/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var te=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/base/common/async","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/platform/log/common/log","vs/base/common/path","vs/base/common/errors","vs/platform/environment/common/environment","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/platform/files/common/files","vs/base/common/types","vs/base/common/arrays","vs/base/common/network","vs/base/common/resources","vs/base/common/buffer","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/platform/storage/common/storage","vs/platform/userDataSync/common/userDataSync","vs/base/common/strings","vs/platform/product/common/productService","vs/base/common/cancellation","vs/base/common/objects","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/uuid","vs/base/common/json","vs/base/common/process","os","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/uriIdentity/common/uriIdentity","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/errorMessage","vs/base/common/map","vs/base/common/extpath","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","child_process","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/codicons","vs/base/common/jsonFormatter","vs/base/common/stream","fs","vs/platform/instantiation/common/descriptors","vs/platform/userDataSync/common/content","vs/base/common/iterator","vs/base/common/jsonEdit","net","vs/base/common/date","vs/base/parts/ipc/node/ipc.cp","vs/platform/files/common/watcher","vs/platform/localizations/common/localizations","vs/platform/native/electron-sandbox/native","vs/base/common/semver/semver","vs/platform/remote/common/tunnel","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/normalization","vs/base/node/powershell","vs/base/parts/ipc/common/ipc.net","electron","vs/base/parts/storage/common/storage","vs/base/node/processes","vs/platform/environment/common/environmentService","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/extensions","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","crypto","vs/platform/files/common/io","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/userConfigurationFileService","vs/platform/log/common/logIpc","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/sharedProcess/common/sharedProcessWorkerService","vs/platform/sign/common/sign","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/userDataSync/common/extensionsStorageSync","vs/platform/userDataSync/common/ignoredExtensions","vs/base/common/assert","vs/base/common/linkedList","vs/base/common/processes","vs/base/common/skipList","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/mime","vs/base/common/uriIpc","vs/base/node/decoder","vs/base/node/macAddress","vs/base/node/id","vs/base/node/extpath","vs/base/node/ports","vs/base/node/ps","vs/base/node/watcher","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/environment/node/shellEnv","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/platform/assignment/common/assignment","vs/platform/environment/node/argv","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/code/electron-browser/sharedProcess/contrib/extensionsCleaner","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/environment/node/argvHelper","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/parcel/parcelWatcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/platform/ipc/electron-sandbox/services","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/code/electron-browser/sharedProcess/contrib/codeCacheCleaner","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/localizations/node/localizations","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/remote/node/sharedProcessTunnelService","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/sharedProcess/electron-browser/sharedProcessWorker","vs/platform/sharedProcess/electron-browser/sharedProcessWorkerService","vs/platform/sign/node/signService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/storage/common/storageIpc","vs/platform/storage/electron-sandbox/storageService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/assignment/common/assignmentService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/requestStore","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/windows/node/windowTracker","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/base/parts/ipc/node/ipc.net","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/tunnelService","string_decoder","util","minimist","assert","graceful-fs","yauzl","yazl","zlib","vs/code/electron-browser/sharedProcess/sharedProcessMain"],ne=function(Q){for(var e=[],L=0,i=Q.length;L<i;L++)e[L]=te[Q[L]];return e};define(te[99],ne([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function L(i,D){if(!i)throw new Error(D?`Assertion failed (${D})`:"Assertion Failed")}e.ok=L}),define(te[47],ne([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function L(k){return k?k.replace(/\$\((.*?)\)/g,(R,E)=>` ${E} `).trim():""}e.getCodiconAriaLabel=L;class i{constructor(R,E,C){this.id=R,this.definition=E,this.description=C,i._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return i._allCodicons}}e.Codicon=i,i._allCodicons=[],i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",i.add.definition),i.gistNew=new i("gist-new",i.add.definition),i.repoCreate=new i("repo-create",i.add.definition),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eba4"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolCustomColor=new i("symbol-customcolor",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.layers=new i("layers",{fontCharacter:"\\ebd2"}),i.layersDot=new i("layers-dot",{fontCharacter:"\\ebd3"}),i.layersActive=new i("layers-active",{fontCharacter:"\\ebd4"}),i.compass=new i("compass",{fontCharacter:"\\ebd5"}),i.compassDot=new i("compass-dot",{fontCharacter:"\\ebd6"}),i.compassActive=new i("compass-active",{fontCharacter:"\\ebd7"}),i.azure=new i("azure",{fontCharacter:"\\ebd8"}),i.issueDraft=new i("issue-draft",{fontCharacter:"\\ebd9"}),i.gitPullRequestClosed=new i("git-pull-request-closed",{fontCharacter:"\\ebda"}),i.gitPullRequestDraft=new i("git-pull-request-draft",{fontCharacter:"\\ebdb"}),i.debugAll=new i("debug-all",{fontCharacter:"\\ebdc"}),i.debugCoverage=new i("debug-coverage",{fontCharacter:"\\ebdd"}),i.runErrors=new i("run-errors",{fontCharacter:"\\ebde"}),i.folderLibrary=new i("folder-library",{fontCharacter:"\\ebdf"}),i.debugContinueSmall=new i("debug-continue-small",{fontCharacter:"\\ebe0"}),i.beakerStop=new i("beaker-stop",{fontCharacter:"\\ebe1"}),i.graphLine=new i("graph-line",{fontCharacter:"\\ebe2"}),i.graphScatter=new i("graph-scatter",{fontCharacter:"\\ebe3"}),i.pieChart=new i("pie-chart",{fontCharacter:"\\ebe4"}),i.bracket=new i("bracket",i.json.definition),i.bracketDot=new i("bracket-dot",{fontCharacter:"\\ebe5"}),i.bracketError=new i("bracket-error",{fontCharacter:"\\ebe6"}),i.lockSmall=new i("lock-small",{fontCharacter:"\\ebe7"}),i.azureDevops=new i("azure-devops",{fontCharacter:"\\ebe8"}),i.verifiedFilled=new i("verified-filled",{fontCharacter:"\\ebe9"}),i.newLine=new i("newline",{fontCharacter:"\\ebea"}),i.layout=new i("layout",{fontCharacter:"\\ebeb"}),i.dialogError=new i("dialog-error",i.error.definition),i.dialogWarning=new i("dialog-warning",i.warning.definition),i.dialogInfo=new i("dialog-info",i.info.definition),i.dialogClose=new i("dialog-close",i.close.definition),i.treeItemExpanded=new i("tree-item-expanded",i.chevronDown.definition),i.treeFilterOnTypeOn=new i("tree-filter-on-type-on",i.listFilter.definition),i.treeFilterOnTypeOff=new i("tree-filter-on-type-off",i.listSelection.definition),i.treeFilterClear=new i("tree-filter-clear",i.close.definition),i.treeItemLoading=new i("tree-item-loading",i.loading.definition),i.menuSelection=new i("menu-selection",i.check.definition),i.menuSubmenu=new i("menu-submenu",i.chevronRight.definition),i.menuBarMore=new i("menubar-more",i.more.definition),i.scrollbarButtonLeft=new i("scrollbar-button-left",i.triangleLeft.definition),i.scrollbarButtonRight=new i("scrollbar-button-right",i.triangleRight.definition),i.scrollbarButtonUp=new i("scrollbar-button-up",i.triangleUp.definition),i.scrollbarButtonDown=new i("scrollbar-button-down",i.triangleDown.definition),i.toolBarMore=new i("toolbar-more",i.more.definition),i.quickInputBack=new i("quick-input-back",i.arrowLeft.definition);function D(k,R){const E=["codicon","codicon-"+k];return R&&E.push("codicon-modifier-"+R),E}e.getClassNamesArray=D;var _;(function(k){k.iconNameSegment="[A-Za-z0-9]+",k.iconNameExpression="[A-Za-z0-9-]+",k.iconModifierExpression="~[A-Za-z]+",k.iconNameCharacter="[A-Za-z0-9~-]";const R=new RegExp(`^(${k.iconNameExpression})(${k.iconModifierExpression})?$`);function E(b){if(b instanceof i)return["codicon","codicon-"+b.id];const d=R.exec(b.id);if(!d)return E(i.error);let[,S,h]=d;const y=["codicon","codicon-"+S];return h&&y.push("codicon-modifier-"+h.substr(1)),y}k.asClassNameArray=E;function C(b){return E(b).join(" ")}k.asClassName=C;function P(b){return"."+E(b).join(".")}k.asCSSSelector=P})(_=e.CSSIcon||(e.CSSIcon={}))}),define(te[66],ne([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const L=Object.prototype.hasOwnProperty;function i(P){const b=[];for(let d in P)L.call(P,d)&&b.push(P[d]);return b}e.values=i;function D(P,b){for(let d in P)if(L.call(P,d)&&b({key:d,value:P[d]},function(){delete P[d]})===!1)return}e.forEach=D;function _(P,b){const d=Object.create(null);for(const S of P){const h=b(S);let y=d[h];y||(y=d[h]=[]),y.push(S)}return d}e.groupBy=_;function k(P){const b=Object.create(null);return P&&P.forEach((d,S)=>{b[S]=d}),b}e.fromMap=k;function R(P,b){const d=[],S=[];for(let h of P)b.has(h)||d.push(h);for(let h of b)P.has(h)||S.push(h);return{removed:d,added:S}}e.diffSets=R;function E(P,b){const d=[],S=[];for(let[h,y]of P)b.has(h)||d.push(y);for(let[h,y]of b)P.has(h)||S.push(y);return{removed:d,added:S}}e.diffMaps=E;class C{constructor(){this.map=new Map}add(b,d){let S=this.map.get(b);S||(S=new Set,this.map.set(b,S)),S.add(d)}delete(b,d){const S=this.map.get(b);!S||(S.delete(d),S.size===0&&this.map.delete(b))}forEach(b,d){const S=this.map.get(b);!S||S.forEach(d)}}e.SetMap=C}),define(te[67],ne([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function L(k){return(R,E,C)=>{let P=null,b=null;if(typeof C.value=="function"?(P="value",b=C.value):typeof C.get=="function"&&(P="get",b=C.get),!b)throw new Error("not supported");C[P]=k(b,E)}}e.createDecorator=L;function i(k,R,E){let C=null,P=null;if(typeof E.value=="function"?(C="value",P=E.value,P.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof E.get=="function"&&(C="get",P=E.get),!P)throw new Error("not supported");const b=`$memoize$${R}`;E[C]=function(...d){return this.hasOwnProperty(b)||Object.defineProperty(this,b,{configurable:!1,enumerable:!1,writable:!1,value:P.apply(this,d)}),this[b]}}e.memoize=i;function D(k,R,E){return L((C,P)=>{const b=`$debounce$${P}`,d=`$debounce$result$${P}`;return function(...S){this[d]||(this[d]=E?E():void 0),clearTimeout(this[b]),R&&(this[d]=R(this[d],...S),S=[this[d]]),this[b]=setTimeout(()=>{C.apply(this,S),this[d]=E?E():void 0},k)}})}e.debounce=D;function _(k,R,E){return L((C,P)=>{const b=`$throttle$timer$${P}`,d=`$throttle$result$${P}`,S=`$throttle$lastRun$${P}`,h=`$throttle$pending$${P}`;return function(...y){if(this[d]||(this[d]=E?E():void 0),(this[S]===null||this[S]===void 0)&&(this[S]=-Number.MAX_VALUE),R&&(this[d]=R(this[d],...y)),this[h])return;const p=this[S]+k;p<=Date.now()?(this[S]=Date.now(),C.apply(this,[this[d]]),this[d]=E?E():void 0):(this[h]=!0,this[b]=setTimeout(()=>{this[h]=!1,this[S]=Date.now(),C.apply(this,[this[d]]),this[d]=E?E():void 0},p-Date.now()))}})}e.throttle=_}),define(te[10],ne([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class L{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(r){setTimeout(()=>{throw r.stack?new Error(r.message+`

`+r.stack):r},0)}}addListener(r){return this.listeners.push(r),()=>{this._removeListener(r)}}emit(r){this.listeners.forEach(a=>{a(r)})}_removeListener(r){this.listeners.splice(this.listeners.indexOf(r),1)}setUnexpectedErrorHandler(r){this.unexpectedErrorHandler=r}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(r){this.unexpectedErrorHandler(r),this.emit(r)}onUnexpectedExternalError(r){this.unexpectedErrorHandler(r)}}e.ErrorHandler=L,e.errorHandler=new L;function i(l){e.errorHandler.setUnexpectedErrorHandler(l)}e.setUnexpectedErrorHandler=i;function D(l){E(l)||e.errorHandler.onUnexpectedError(l)}e.onUnexpectedError=D;function _(l){E(l)||e.errorHandler.onUnexpectedExternalError(l)}e.onUnexpectedExternalError=_;function k(l){if(l instanceof Error){let{name:r,message:a}=l;const n=l.stacktrace||l.stack;return{$isError:!0,name:r,message:a,stack:n}}return l}e.transformErrorForSerialization=k;const R="Canceled";function E(l){return l instanceof Error&&l.name===R&&l.message===R}e.isPromiseCanceledError=E;class C extends Error{constructor(){super(R);this.name=this.message}}e.CancellationError=C;function P(){const l=new Error(R);return l.name=l.message,l}e.canceled=P;function b(l){return l?new Error(`Illegal argument: ${l}`):new Error("Illegal argument")}e.illegalArgument=b;function d(l){return l?new Error(`Illegal state: ${l}`):new Error("Illegal state")}e.illegalState=d;function S(l){return l?new Error(`readonly property '${l} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=S;function h(l){const r=new Error(`${l} has been disposed`);return r.name="DISPOSED",r}e.disposed=h;function y(l){return l?l.message?l.message:l.stack?l.stack.split(`
`)[0]:String(l):"Error"}e.getErrorMessage=y;class p extends Error{constructor(r){super("NotImplemented");r&&(this.message=r)}}e.NotImplementedError=p;class m extends Error{constructor(r){super("NotSupported");r&&(this.message=r)}}e.NotSupportedError=m;class w extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=w;function g(l){const r=l;return r instanceof Error&&Array.isArray(r.actions)}e.isErrorWithActions=g;function c(l,r=Object.create(null)){const a=new Error(l);return r.actions&&(a.actions=r.actions),a}e.createErrorWithActions=c}),define(te[16],ne([0,1,10]),function(Q,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.compareBy=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function i(q,G=0){return q[q.length-(1+G)]}e.tail=i;function D(q){if(q.length===0)throw new Error("Invalid tail call");return[q.slice(0,q.length-1),q[q.length-1]]}e.tail2=D;function _(q,G,Y=(x,K)=>x===K){if(q===G)return!0;if(!q||!G||q.length!==G.length)return!1;for(let x=0,K=q.length;x<K;x++)if(!Y(q[x],G[x]))return!1;return!0}e.equals=_;function k(q,G,Y){let x=0,K=q.length-1;for(;x<=K;){const re=(x+K)/2|0,se=Y(q[re],G);if(se<0)x=re+1;else if(se>0)K=re-1;else return re}return-(x+1)}e.binarySearch=k;function R(q,G){let Y=0,x=q.length;if(x===0)return 0;for(;Y<x;){const K=Math.floor((Y+x)/2);G(q[K])?x=K:Y=K+1}return Y}e.findFirstInSorted=R;function E(q,G,Y){if(q=q|0,q>=G.length)throw new TypeError("invalid index");let x=G[Math.floor(G.length*Math.random())],K=[],re=[],se=[];for(let ce of G){const he=Y(ce,x);he<0?K.push(ce):he>0?re.push(ce):se.push(ce)}return q<K.length?E(q,K,Y):q<K.length+se.length?se[0]:E(q-(K.length+se.length),re,Y)}e.quickSelect=E;function C(q,G){const Y=[];let x;for(const K of q.slice(0).sort(G))!x||G(x[0],K)!==0?(x=[K],Y.push(x)):x.push(K);return Y}e.groupBy=C;function P(q,G,Y){const x=[];function K(ce,he,me){if(he===0&&me.length===0)return;const ve=x[x.length-1];ve&&ve.start+ve.deleteCount===ce?(ve.deleteCount+=he,ve.toInsert.push(...me)):x.push({start:ce,deleteCount:he,toInsert:me})}let re=0,se=0;for(;;){if(re===q.length){K(re,0,G.slice(se));break}if(se===G.length){K(re,q.length-re,[]);break}const ce=q[re],he=G[se],me=Y(ce,he);me===0?(re+=1,se+=1):me<0?(K(re,1,[]),re+=1):me>0&&(K(re,0,[he]),se+=1)}return x}e.sortedDiff=P;function b(q,G,Y){const x=P(q,G,Y),K=[],re=[];for(const se of x)K.push(...q.slice(se.start,se.start+se.deleteCount)),re.push(...se.toInsert);return{removed:K,added:re}}e.delta=b;function d(q,G,Y){if(Y===0)return[];const x=q.slice(0,Y).sort(G);return h(q,G,x,Y,q.length),x}e.top=d;function S(q,G,Y,x,K){return Y===0?Promise.resolve([]):new Promise((re,se)=>{(async()=>{const ce=q.length,he=q.slice(0,Y).sort(G);for(let me=Y,ve=Math.min(Y+x,ce);me<ce;me=ve,ve=Math.min(ve+x,ce)){if(me>Y&&await new Promise(ge=>setTimeout(ge)),K&&K.isCancellationRequested)throw(0,L.canceled)();h(q,G,he,me,ve)}return he})().then(re,se)})}e.topAsync=S;function h(q,G,Y,x,K){for(const re=Y.length;x<K;x++){const se=q[x];if(G(se,Y[re-1])<0){Y.pop();const ce=R(Y,he=>G(se,he)<0);Y.splice(ce,0,se)}}}function y(q){return q.filter(G=>!!G)}e.coalesce=y;function p(q){let G=0;for(let Y=0;Y<q.length;Y++)q[Y]&&(q[G]=q[Y],G+=1);q.length=G}e.coalesceInPlace=p;function m(q,G,Y){q.splice(Y,0,q.splice(G,1)[0])}e.move=m;function w(q){return!Array.isArray(q)||q.length===0}e.isFalsyOrEmpty=w;function g(q){return Array.isArray(q)&&q.length>0}e.isNonEmptyArray=g;function c(q,G=Y=>Y){const Y=new Set;return q.filter(x=>{const K=G(x);return Y.has(K)?!1:(Y.add(K),!0)})}e.distinct=c;function l(q){const G=Object.create(null);return Y=>{const x=q(Y);return G[x]?!1:(G[x]=!0,!0)}}e.uniqueFilter=l;function r(q,G){const Y=a(q,G);if(Y!==-1)return q[Y]}e.findLast=r;function a(q,G){for(let Y=q.length-1;Y>=0;Y--){const x=q[Y];if(G(x))return Y}return-1}e.lastIndex=a;function n(q,G){return q.length>0?q[0]:G}e.firstOrDefault=n;function t(q,G,Y=(x,K)=>x===K){let x=0;for(let K=0,re=Math.min(q.length,G.length);K<re&&Y(q[K],G[K]);K++)x++;return x}e.commonPrefixLength=t;function s(q){return[].concat(...q)}e.flatten=s;function o(q,G){let Y=typeof G=="number"?q:0;typeof G=="number"?Y=q:(Y=0,G=q);const x=[];if(Y<=G)for(let K=Y;K<G;K++)x.push(K);else for(let K=Y;K>G;K--)x.push(K);return x}e.range=o;function u(q,G,Y){return q.reduce((x,K)=>(x[G(K)]=Y?Y(K):K,x),Object.create(null))}e.index=u;function f(q,G){return q.push(G),()=>v(q,G)}e.insert=f;function v(q,G){const Y=q.indexOf(G);if(Y>-1)return q.splice(Y,1),G}e.remove=v;function I(q,G,Y){const x=q.slice(0,G),K=q.slice(G);return x.concat(Y,K)}e.arrayInsert=I;function O(q,G){let Y;if(typeof G=="number"){let x=G;Y=()=>{const K=Math.sin(x++)*179426549;return K-Math.floor(K)}}else Y=Math.random;for(let x=q.length-1;x>0;x-=1){const K=Math.floor(Y()*(x+1)),re=q[x];q[x]=q[K],q[K]=re}}e.shuffle=O;function A(q,G){const Y=q.indexOf(G);Y>-1&&(q.splice(Y,1),q.unshift(G))}e.pushToStart=A;function N(q,G){const Y=q.indexOf(G);Y>-1&&(q.splice(Y,1),q.push(G))}e.pushToEnd=N;function $(q,G){return Array.isArray(q)?q.map(G):G(q)}e.mapArrayOrNot=$;function T(q){return Array.isArray(q)?q:[q]}e.asArray=T;function F(q){return q[Math.floor(Math.random()*q.length)]}e.getRandomElement=F;function M(q,G){for(const Y of q){const x=G(Y);if(x!==void 0)return x}}e.mapFind=M;function U(q,G,Y){const x=ee(q,G),K=q.length,re=Y.length;q.length=K+re;for(let se=K-1;se>=x;se--)q[se+re]=q[se];for(let se=0;se<re;se++)q[se+x]=Y[se]}e.insertInto=U;function B(q,G,Y,x){const K=ee(q,G),re=q.splice(K,Y);return U(q,K,x),re}e.splice=B;function ee(q,G){return G<0?Math.max(G+q.length,0):Math.min(G,q.length)}function H(q,G){return(Y,x)=>G(q(Y),q(x))}e.compareBy=H;const j=(q,G)=>q-G;e.numberComparator=j;function Z(q,G){if(q.length===0)return;let Y=q[0];for(let x=1;x<q.length;x++){const K=q[x];G(K,Y)>0&&(Y=K)}return Y}e.findMaxBy=Z;function W(q,G){if(q.length===0)return;let Y=q[0];for(let x=1;x<q.length;x++){const K=q[x];G(K,Y)>=0&&(Y=K)}return Y}e.findLastMaxBy=W;function z(q,G){return Z(q,(Y,x)=>-G(Y,x))}e.findMinBy=z;class V{constructor(G){this.items=G,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(G){let Y=this.firstIdx;for(;Y<this.items.length&&G(this.items[Y]);)Y++;const x=Y===this.firstIdx?null:this.items.slice(this.firstIdx,Y);return this.firstIdx=Y,x}takeFromEndWhile(G){let Y=this.lastIdx;for(;Y>=0&&G(this.items[Y]);)Y--;const x=Y===this.lastIdx?null:this.items.slice(Y+1,this.lastIdx+1);return this.lastIdx=Y,x}peek(){return this.items[this.firstIdx]}dequeue(){const G=this.items[this.firstIdx];return this.firstIdx++,G}takeCount(G){const Y=this.items.slice(this.firstIdx,this.firstIdx+G);return this.firstIdx+=G,Y}}e.ArrayQueue=V}),define(te[68],ne([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function L(i){const D=this;let _=!1,k;return function(){return _||(_=!0,k=i.apply(D,arguments)),k}}e.once=L}),define(te[53],ne([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var L;(function(i){function D(l){return l&&typeof l=="object"&&typeof l[Symbol.iterator]=="function"}i.is=D;const _=Object.freeze([]);function k(){return _}i.empty=k;function*R(l){yield l}i.single=R;function E(l){return l||_}i.from=E;function C(l){return!l||l[Symbol.iterator]().next().done===!0}i.isEmpty=C;function P(l){return l[Symbol.iterator]().next().value}i.first=P;function b(l,r){for(const a of l)if(r(a))return!0;return!1}i.some=b;function d(l,r){for(const a of l)if(r(a))return a}i.find=d;function*S(l,r){for(const a of l)r(a)&&(yield a)}i.filter=S;function*h(l,r){let a=0;for(const n of l)yield r(n,a++)}i.map=h;function*y(...l){for(const r of l)for(const a of r)yield a}i.concat=y;function*p(l){for(const r of l)for(const a of r)yield a}i.concatNested=p;function m(l,r,a){let n=a;for(const t of l)n=r(n,t);return n}i.reduce=m;function*w(l,r,a=l.length){for(r<0&&(r+=l.length),a<0?a+=l.length:a>l.length&&(a=l.length);r<a;r++)yield l[r]}i.slice=w;function g(l,r=Number.POSITIVE_INFINITY){const a=[];if(r===0)return[a,l];const n=l[Symbol.iterator]();for(let t=0;t<r;t++){const s=n.next();if(s.done)return[a,i.empty()];a.push(s.value)}return[a,{[Symbol.iterator](){return n}}]}i.consume=g;function c(l,r,a=(n,t)=>n===t){const n=l[Symbol.iterator](),t=r[Symbol.iterator]();for(;;){const s=n.next(),o=t.next();if(s.done!==o.done)return!1;if(s.done)return!0;if(!a(s.value,o.value))return!1}}i.equals=c})(L=e.Iterable||(e.Iterable={}))}),define(te[31],ne([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var L;(function(r){r[r.None=0]="None",r[r.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=2]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",r[r.InvalidUnicode=4]="InvalidUnicode",r[r.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",r[r.InvalidCharacter=6]="InvalidCharacter"})(L=e.ScanError||(e.ScanError={}));var i;(function(r){r[r.OpenBraceToken=1]="OpenBraceToken",r[r.CloseBraceToken=2]="CloseBraceToken",r[r.OpenBracketToken=3]="OpenBracketToken",r[r.CloseBracketToken=4]="CloseBracketToken",r[r.CommaToken=5]="CommaToken",r[r.ColonToken=6]="ColonToken",r[r.NullKeyword=7]="NullKeyword",r[r.TrueKeyword=8]="TrueKeyword",r[r.FalseKeyword=9]="FalseKeyword",r[r.StringLiteral=10]="StringLiteral",r[r.NumericLiteral=11]="NumericLiteral",r[r.LineCommentTrivia=12]="LineCommentTrivia",r[r.BlockCommentTrivia=13]="BlockCommentTrivia",r[r.LineBreakTrivia=14]="LineBreakTrivia",r[r.Trivia=15]="Trivia",r[r.Unknown=16]="Unknown",r[r.EOF=17]="EOF"})(i=e.SyntaxKind||(e.SyntaxKind={}));var D;(function(r){r[r.InvalidSymbol=1]="InvalidSymbol",r[r.InvalidNumberFormat=2]="InvalidNumberFormat",r[r.PropertyNameExpected=3]="PropertyNameExpected",r[r.ValueExpected=4]="ValueExpected",r[r.ColonExpected=5]="ColonExpected",r[r.CommaExpected=6]="CommaExpected",r[r.CloseBraceExpected=7]="CloseBraceExpected",r[r.CloseBracketExpected=8]="CloseBracketExpected",r[r.EndOfFileExpected=9]="EndOfFileExpected",r[r.InvalidCommentToken=10]="InvalidCommentToken",r[r.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=12]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",r[r.InvalidUnicode=14]="InvalidUnicode",r[r.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",r[r.InvalidCharacter=16]="InvalidCharacter"})(D=e.ParseErrorCode||(e.ParseErrorCode={}));var _;(function(r){r.DEFAULT={allowTrailingComma:!0}})(_=e.ParseOptions||(e.ParseOptions={}));function k(r,a=!1){let n=0,t=r.length,s="",o=0,u=16,f=0;function v(F){let M=0,U=0;for(;M<F;){const B=r.charCodeAt(n);if(B>=48&&B<=57)U=U*16+B-48;else if(B>=65&&B<=70)U=U*16+B-65+10;else if(B>=97&&B<=102)U=U*16+B-97+10;else break;n++,M++}return M<F&&(U=-1),U}function I(F){n=F,s="",o=0,u=16,f=0}function O(){const F=n;if(r.charCodeAt(n)===48)n++;else for(n++;n<r.length&&C(r.charCodeAt(n));)n++;if(n<r.length&&r.charCodeAt(n)===46)if(n++,n<r.length&&C(r.charCodeAt(n)))for(n++;n<r.length&&C(r.charCodeAt(n));)n++;else return f=3,r.substring(F,n);let M=n;if(n<r.length&&(r.charCodeAt(n)===69||r.charCodeAt(n)===101))if(n++,(n<r.length&&r.charCodeAt(n)===43||r.charCodeAt(n)===45)&&n++,n<r.length&&C(r.charCodeAt(n))){for(n++;n<r.length&&C(r.charCodeAt(n));)n++;M=n}else f=3;return r.substring(F,M)}function A(){let F="",M=n;for(;;){if(n>=t){F+=r.substring(M,n),f=2;break}const U=r.charCodeAt(n);if(U===34){F+=r.substring(M,n),n++;break}if(U===92){if(F+=r.substring(M,n),n++,n>=t){f=2;break}switch(r.charCodeAt(n++)){case 34:F+='"';break;case 92:F+="\\";break;case 47:F+="/";break;case 98:F+="\b";break;case 102:F+="\f";break;case 110:F+=`
`;break;case 114:F+="\r";break;case 116:F+="	";break;case 117:const ee=v(4);ee>=0?F+=String.fromCharCode(ee):f=4;break;default:f=5}M=n;continue}if(U>=0&&U<=31)if(E(U)){F+=r.substring(M,n),f=2;break}else f=6;n++}return F}function N(){if(s="",f=0,o=n,n>=t)return o=t,u=17;let F=r.charCodeAt(n);if(R(F)){do n++,s+=String.fromCharCode(F),F=r.charCodeAt(n);while(R(F));return u=15}if(E(F))return n++,s+=String.fromCharCode(F),F===13&&r.charCodeAt(n)===10&&(n++,s+=`
`),u=14;switch(F){case 123:return n++,u=1;case 125:return n++,u=2;case 91:return n++,u=3;case 93:return n++,u=4;case 58:return n++,u=6;case 44:return n++,u=5;case 34:return n++,s=A(),u=10;case 47:const M=n-1;if(r.charCodeAt(n+1)===47){for(n+=2;n<t&&!E(r.charCodeAt(n));)n++;return s=r.substring(M,n),u=12}if(r.charCodeAt(n+1)===42){n+=2;const U=t-1;let B=!1;for(;n<U;){if(r.charCodeAt(n)===42&&r.charCodeAt(n+1)===47){n+=2,B=!0;break}n++}return B||(n++,f=1),s=r.substring(M,n),u=13}return s+=String.fromCharCode(F),n++,u=16;case 45:if(s+=String.fromCharCode(F),n++,n===t||!C(r.charCodeAt(n)))return u=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=O(),u=11;default:for(;n<t&&$(F);)n++,F=r.charCodeAt(n);if(o!==n){switch(s=r.substring(o,n),s){case"true":return u=8;case"false":return u=9;case"null":return u=7}return u=16}return s+=String.fromCharCode(F),n++,u=16}}function $(F){if(R(F)||E(F))return!1;switch(F){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function T(){let F;do F=N();while(F>=12&&F<=15);return F}return{setPosition:I,getPosition:()=>n,scan:a?T:N,getToken:()=>u,getTokenValue:()=>s,getTokenOffset:()=>o,getTokenLength:()=>n-o,getTokenError:()=>f}}e.createScanner=k;function R(r){return r===32||r===9||r===11||r===12||r===160||r===5760||r>=8192&&r<=8203||r===8239||r===8287||r===12288||r===65279}function E(r){return r===10||r===13||r===8232||r===8233}function C(r){return r>=48&&r<=57}var P;(function(r){r[r.nullCharacter=0]="nullCharacter",r[r.maxAsciiCharacter=127]="maxAsciiCharacter",r[r.lineFeed=10]="lineFeed",r[r.carriageReturn=13]="carriageReturn",r[r.lineSeparator=8232]="lineSeparator",r[r.paragraphSeparator=8233]="paragraphSeparator",r[r.nextLine=133]="nextLine",r[r.space=32]="space",r[r.nonBreakingSpace=160]="nonBreakingSpace",r[r.enQuad=8192]="enQuad",r[r.emQuad=8193]="emQuad",r[r.enSpace=8194]="enSpace",r[r.emSpace=8195]="emSpace",r[r.threePerEmSpace=8196]="threePerEmSpace",r[r.fourPerEmSpace=8197]="fourPerEmSpace",r[r.sixPerEmSpace=8198]="sixPerEmSpace",r[r.figureSpace=8199]="figureSpace",r[r.punctuationSpace=8200]="punctuationSpace",r[r.thinSpace=8201]="thinSpace",r[r.hairSpace=8202]="hairSpace",r[r.zeroWidthSpace=8203]="zeroWidthSpace",r[r.narrowNoBreakSpace=8239]="narrowNoBreakSpace",r[r.ideographicSpace=12288]="ideographicSpace",r[r.mathematicalSpace=8287]="mathematicalSpace",r[r.ogham=5760]="ogham",r[r._=95]="_",r[r.$=36]="$",r[r._0=48]="_0",r[r._1=49]="_1",r[r._2=50]="_2",r[r._3=51]="_3",r[r._4=52]="_4",r[r._5=53]="_5",r[r._6=54]="_6",r[r._7=55]="_7",r[r._8=56]="_8",r[r._9=57]="_9",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.ampersand=38]="ampersand",r[r.asterisk=42]="asterisk",r[r.at=64]="at",r[r.backslash=92]="backslash",r[r.bar=124]="bar",r[r.caret=94]="caret",r[r.closeBrace=125]="closeBrace",r[r.closeBracket=93]="closeBracket",r[r.closeParen=41]="closeParen",r[r.colon=58]="colon",r[r.comma=44]="comma",r[r.dot=46]="dot",r[r.doubleQuote=34]="doubleQuote",r[r.equals=61]="equals",r[r.exclamation=33]="exclamation",r[r.greaterThan=62]="greaterThan",r[r.lessThan=60]="lessThan",r[r.minus=45]="minus",r[r.openBrace=123]="openBrace",r[r.openBracket=91]="openBracket",r[r.openParen=40]="openParen",r[r.percent=37]="percent",r[r.plus=43]="plus",r[r.question=63]="question",r[r.semicolon=59]="semicolon",r[r.singleQuote=39]="singleQuote",r[r.slash=47]="slash",r[r.tilde=126]="tilde",r[r.backspace=8]="backspace",r[r.formFeed=12]="formFeed",r[r.byteOrderMark=65279]="byteOrderMark",r[r.tab=9]="tab",r[r.verticalTab=11]="verticalTab"})(P||(P={}));function b(r,a){const n=[],t=new Object;let s;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let u=!1;function f(v,I,O,A){o.value=v,o.offset=I,o.length=O,o.type=A,o.colonOffset=void 0,s=o}try{g(r,{onObjectBegin:(v,I)=>{if(a<=v)throw t;s=void 0,u=a>v,n.push("")},onObjectProperty:(v,I,O)=>{if(a<I||(f(v,I,O,"property"),n[n.length-1]=v,a<=I+O))throw t},onObjectEnd:(v,I)=>{if(a<=v)throw t;s=void 0,n.pop()},onArrayBegin:(v,I)=>{if(a<=v)throw t;s=void 0,n.push(0)},onArrayEnd:(v,I)=>{if(a<=v)throw t;s=void 0,n.pop()},onLiteralValue:(v,I,O)=>{if(a<I||(f(v,I,O,l(v)),a<=I+O))throw t},onSeparator:(v,I,O)=>{if(a<=I)throw t;if(v===":"&&s&&s.type==="property")s.colonOffset=I,u=!1,s=void 0;else if(v===","){const A=n[n.length-1];typeof A=="number"?n[n.length-1]=A+1:(u=!0,n[n.length-1]=""),s=void 0}}})}catch(v){if(v!==t)throw v}return{path:n,previousNode:s,isAtPropertyKey:u,matches:v=>{let I=0;for(let O=0;I<v.length&&O<n.length;O++)if(v[I]===n[O]||v[I]==="*")I++;else if(v[I]!=="**")return!1;return I===v.length}}}e.getLocation=b;function d(r,a=[],n=_.DEFAULT){let t=null,s=[];const o=[];function u(v){Array.isArray(s)?s.push(v):t!==null&&(s[t]=v)}return g(r,{onObjectBegin:()=>{const v={};u(v),o.push(s),s=v,t=null},onObjectProperty:v=>{t=v},onObjectEnd:()=>{s=o.pop()},onArrayBegin:()=>{const v=[];u(v),o.push(s),s=v,t=null},onArrayEnd:()=>{s=o.pop()},onLiteralValue:u,onError:(v,I,O)=>{a.push({error:v,offset:I,length:O})}},n),s[0]}e.parse=d;function S(r,a=[],n=_.DEFAULT){let t={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(v){t.type==="property"&&(t.length=v-t.offset,t=t.parent)}function o(v){return t.children.push(v),v}g(r,{onObjectBegin:v=>{t=o({type:"object",offset:v,length:-1,parent:t,children:[]})},onObjectProperty:(v,I,O)=>{t=o({type:"property",offset:I,length:-1,parent:t,children:[]}),t.children.push({type:"string",value:v,offset:I,length:O,parent:t})},onObjectEnd:(v,I)=>{t.length=v+I-t.offset,t=t.parent,s(v+I)},onArrayBegin:(v,I)=>{t=o({type:"array",offset:v,length:-1,parent:t,children:[]})},onArrayEnd:(v,I)=>{t.length=v+I-t.offset,t=t.parent,s(v+I)},onLiteralValue:(v,I,O)=>{o({type:l(v),offset:I,length:O,parent:t,value:v}),s(I+O)},onSeparator:(v,I,O)=>{t.type==="property"&&(v===":"?t.colonOffset=I:v===","&&s(I))},onError:(v,I,O)=>{a.push({error:v,offset:I,length:O})}},n);const f=t.children[0];return f&&delete f.parent,f}e.parseTree=S;function h(r,a){if(!r)return;let n=r;for(let t of a)if(typeof t=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let s=!1;for(const o of n.children)if(Array.isArray(o.children)&&o.children[0].value===t){n=o.children[1],s=!0;break}if(!s)return}else{const s=t;if(n.type!=="array"||s<0||!Array.isArray(n.children)||s>=n.children.length)return;n=n.children[s]}return n}e.findNodeAtLocation=h;function y(r){if(!r.parent||!r.parent.children)return[];const a=y(r.parent);if(r.parent.type==="property"){const n=r.parent.children[0].value;a.push(n)}else if(r.parent.type==="array"){const n=r.parent.children.indexOf(r);n!==-1&&a.push(n)}return a}e.getNodePath=y;function p(r){switch(r.type){case"array":return r.children.map(p);case"object":const a=Object.create(null);for(let n of r.children){const t=n.children[1];t&&(a[n.children[0].value]=p(t))}return a;case"null":case"string":case"number":case"boolean":return r.value;default:return}}e.getNodeValue=p;function m(r,a,n=!1){return a>=r.offset&&a<r.offset+r.length||n&&a===r.offset+r.length}e.contains=m;function w(r,a,n=!1){if(m(r,a,n)){const t=r.children;if(Array.isArray(t))for(let s=0;s<t.length&&t[s].offset<=a;s++){const o=w(t[s],a,n);if(o)return o}return r}}e.findNodeAtOffset=w;function g(r,a,n=_.DEFAULT){const t=k(r,!1);function s(V){return V?()=>V(t.getTokenOffset(),t.getTokenLength()):()=>!0}function o(V){return V?q=>V(q,t.getTokenOffset(),t.getTokenLength()):()=>!0}const u=s(a.onObjectBegin),f=o(a.onObjectProperty),v=s(a.onObjectEnd),I=s(a.onArrayBegin),O=s(a.onArrayEnd),A=o(a.onLiteralValue),N=o(a.onSeparator),$=s(a.onComment),T=o(a.onError),F=n&&n.disallowComments,M=n&&n.allowTrailingComma;function U(){for(;;){const V=t.scan();switch(t.getTokenError()){case 4:B(14);break;case 5:B(15);break;case 3:B(13);break;case 1:F||B(11);break;case 2:B(12);break;case 6:B(16);break}switch(V){case 12:case 13:F?B(10):$();break;case 16:B(1);break;case 15:case 14:break;default:return V}}}function B(V,q=[],G=[]){if(T(V),q.length+G.length>0){let Y=t.getToken();for(;Y!==17;){if(q.indexOf(Y)!==-1){U();break}else if(G.indexOf(Y)!==-1)break;Y=U()}}}function ee(V){const q=t.getTokenValue();return V?A(q):f(q),U(),!0}function H(){switch(t.getToken()){case 11:let V=0;try{V=JSON.parse(t.getTokenValue()),typeof V!="number"&&(B(2),V=0)}catch{B(2)}A(V);break;case 7:A(null);break;case 8:A(!0);break;case 9:A(!1);break;default:return!1}return U(),!0}function j(){return t.getToken()!==10?(B(3,[],[2,5]),!1):(ee(!1),t.getToken()===6?(N(":"),U(),z()||B(4,[],[2,5])):B(5,[],[2,5]),!0)}function Z(){u(),U();let V=!1;for(;t.getToken()!==2&&t.getToken()!==17;){if(t.getToken()===5){if(V||B(4,[],[]),N(","),U(),t.getToken()===2&&M)break}else V&&B(6,[],[]);j()||B(4,[],[2,5]),V=!0}return v(),t.getToken()!==2?B(7,[2],[]):U(),!0}function W(){I(),U();let V=!1;for(;t.getToken()!==4&&t.getToken()!==17;){if(t.getToken()===5){if(V||B(4,[],[]),N(","),U(),t.getToken()===4&&M)break}else V&&B(6,[],[]);z()||B(4,[],[4,5]),V=!0}return O(),t.getToken()!==4?B(8,[4],[]):U(),!0}function z(){switch(t.getToken()){case 3:return W();case 1:return Z();case 10:return ee(!0);default:return H()}}return U(),t.getToken()===17?n.allowEmptyContent?!0:(B(4,[],[]),!1):z()?(t.getToken()!==17&&B(9,[],[]),!0):(B(4,[],[]),!1)}e.visit=g;function c(r,a){let n=k(r),t=[],s,o=0,u;do switch(u=n.getPosition(),s=n.scan(),s){case 12:case 13:case 17:o!==u&&t.push(r.substring(o,u)),a!==void 0&&t.push(n.getTokenValue().replace(/[^\r\n]/g,a)),o=n.getPosition();break}while(s!==17);return t.join("")}e.stripComments=c;function l(r){switch(typeof r){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(r){if(Array.isArray(r))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=l}),define(te[48],ne([0,1,31]),function(Q,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function i(C,P,b){let d,S,h,y,p;if(P){for(y=P.offset,p=y+P.length,h=y;h>0&&!E(C,h-1);)h--;let u=p;for(;u<C.length&&!E(C,u);)u++;S=C.substring(h,u),d=k(S,b)}else S=C,d=0,h=0,y=0,p=C.length;const m=R(b,C);let w=!1,g=0,c;b.insertSpaces?c=_(" ",b.tabSize||4):c="	";const l=(0,L.createScanner)(S,!1);let r=!1;function a(){return m+_(c,d+g)}function n(){let u=l.scan();for(w=!1;u===15||u===14;)w=w||u===14,u=l.scan();return r=u===16||l.getTokenError()!==0,u}const t=[];function s(u,f,v){!r&&f<p&&v>y&&C.substring(f,v)!==u&&t.push({offset:f,length:v-f,content:u})}let o=n();if(o!==17){const u=l.getTokenOffset()+h,f=_(c,d);s(f,h,u)}for(;o!==17;){let u=l.getTokenOffset()+l.getTokenLength()+h,f=n(),v="";for(;!w&&(f===12||f===13);){const O=l.getTokenOffset()+h;s(" ",u,O),u=l.getTokenOffset()+l.getTokenLength()+h,v=f===12?a():"",f=n()}if(f===2)o!==1&&(g--,v=a());else if(f===4)o!==3&&(g--,v=a());else{switch(o){case 3:case 1:g++,v=a();break;case 5:case 12:v=a();break;case 13:w?v=a():v=" ";break;case 6:v=" ";break;case 10:if(f===6){v="";break}case 7:case 8:case 9:case 11:case 2:case 4:f===12||f===13?v=" ":f!==5&&f!==17&&(r=!0);break;case 16:r=!0;break}w&&(f===12||f===13)&&(v=a())}const I=l.getTokenOffset()+h;s(v,u,I),o=f}return t}e.format=i;function D(C,P){const b=JSON.stringify(C,void 0,P.insertSpaces?P.tabSize||4:"	");return P.eol!==void 0?b.replace(/\r\n|\r|\n/g,P.eol):b}e.toFormattedString=D;function _(C,P){let b="";for(let d=0;d<P;d++)b+=C;return b}function k(C,P){let b=0,d=0;const S=P.tabSize||4;for(;b<C.length;){const h=C.charAt(b);if(h===" ")d++;else if(h==="	")d+=S;else break;b++}return Math.floor(d/S)}function R(C,P){for(let b=0;b<P.length;b++){const d=P.charAt(b);if(d==="\r")return b+1<P.length&&P.charAt(b+1)===`
`?`\r
`:"\r";if(d===`
`)return`
`}return C&&C.eol||`
`}e.getEOL=R;function E(C,P){return`\r
`.indexOf(C.charAt(P))!==-1}e.isEOL=E}),define(te[54],ne([0,1,31,48]),function(Q,e,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function D(C,P,b){return _(C,P,void 0,b)}e.removeProperty=D;function _(C,P,b,d,S){const h=P.slice(),y=[],p=(0,L.parseTree)(C,y);let m,w;for(;h.length>0&&(w=h.pop(),m=(0,L.findNodeAtLocation)(p,h),m===void 0&&b!==void 0);)typeof w=="string"?b={[w]:b}:b=[b];if(m)if(m.type==="object"&&typeof w=="string"&&Array.isArray(m.children)){const g=(0,L.findNodeAtLocation)(m,[w]);if(g!==void 0)if(b===void 0){if(!g.parent)throw new Error("Malformed AST");const c=m.children.indexOf(g.parent);let l,r=g.parent.offset+g.parent.length;if(c>0){const a=m.children[c-1];l=a.offset+a.length}else l=m.offset+1,m.children.length>1&&(r=m.children[1].offset);return k(C,{offset:l,length:r-l,content:""},d)}else return k(C,{offset:g.offset,length:g.length,content:JSON.stringify(b)},d);else{if(b===void 0)return[];const c=`${JSON.stringify(w)}: ${JSON.stringify(b)}`,l=S?S(m.children.map(a=>a.children[0].value)):m.children.length;let r;if(l>0){const a=m.children[l-1];r={offset:a.offset+a.length,length:0,content:","+c}}else m.children.length===0?r={offset:m.offset+1,length:0,content:c}:r={offset:m.offset+1,length:0,content:c+","};return k(C,r,d)}}else if(m.type==="array"&&typeof w=="number"&&Array.isArray(m.children))if(b!==void 0){const g=`${JSON.stringify(b)}`;let c;if(m.children.length===0||w===0)c={offset:m.offset+1,length:0,content:m.children.length===0?g:g+","};else{const l=w===-1||w>m.children.length?m.children.length:w,r=m.children[l-1];c={offset:r.offset+r.length,length:0,content:","+g}}return k(C,c,d)}else{const g=w,c=m.children[g];let l;if(m.children.length===1)l={offset:m.offset+1,length:m.length-2,content:""};else if(m.children.length-1===g){const r=m.children[g-1],a=r.offset+r.length,n=m.offset+m.length;l={offset:a,length:n-2-a,content:""}}else l={offset:c.offset,length:m.children[g+1].offset-c.offset,content:""};return k(C,l,d)}else throw new Error(`Can not add ${typeof w!="number"?"index":"property"} to parent of type ${m.type}`);else{if(b===void 0)throw new Error("Can not delete in empty document");return k(C,{offset:p?p.offset:0,length:p?p.length:0,content:JSON.stringify(b)},d)}}e.setProperty=_;function k(C,P,b){let d=R(C,P),S=P.offset,h=P.offset+P.content.length;if(P.length===0||P.content.length===0){for(;S>0&&!(0,i.isEOL)(d,S-1);)S--;for(;h<d.length&&!(0,i.isEOL)(d,h);)h++}const y=(0,i.format)(d,{offset:S,length:h-S},b);for(let m=y.length-1;m>=0;m--){const w=y[m];d=R(d,w),S=Math.min(S,w.offset),h=Math.max(h,w.offset+w.length),h+=w.content.length-w.length}const p=C.length-(d.length-h)-S;return[{offset:S,length:p,content:d.substring(S,h)}]}e.withFormatting=k;function R(C,P){return C.substring(0,P.offset)+P.content+C.substring(P.offset+P.length)}e.applyEdit=R;function E(C,P){let b=P.slice(0).sort((S,h)=>{const y=S.offset-h.offset;return y===0?S.length-h.length:y}),d=C.length;for(let S=b.length-1;S>=0;S--){let h=b[S];if(h.offset+h.length<=d)C=R(C,h);else throw new Error("Overlapping edit");d=h.offset}return C}e.applyEdits=E}),define(te[2],ne([0,1,68,53]),function(Q,e,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const D=!1;let _=null;function k(t){_=t}if(e.setDisposableTracker=k,D){const t="__is_disposable_tracked__";k(new class{trackDisposable(s){const o=new Error("Potentially leaked disposable").stack;setTimeout(()=>{s[t]||console.log(o)},3e3)}setParent(s,o){if(s&&s!==w.None)try{s[t]=!0}catch{}}markAsDisposed(s){if(s&&s!==w.None)try{s[t]=!0}catch{}}markAsSingleton(s){}})}function R(t){return _?.trackDisposable(t),t}function E(t){_?.markAsDisposed(t)}function C(t,s){_?.setParent(t,s)}function P(t,s){if(!!_)for(const o of t)_.setParent(o,s)}function b(t){return _?.markAsSingleton(t),t}e.markAsSingleton=b;class d extends Error{constructor(s){super(`Encountered errors while disposing of store. Errors: [${s.join(", ")}]`);this.errors=s}}e.MultiDisposeError=d;function S(t){return typeof t.dispose=="function"&&t.dispose.length===0}e.isDisposable=S;function h(t){if(i.Iterable.is(t)){let s=[];for(const o of t)if(o)try{o.dispose()}catch(u){s.push(u)}if(s.length===1)throw s[0];if(s.length>1)throw new d(s);return Array.isArray(t)?[]:t}else if(t)return t.dispose(),t}e.dispose=h;function y(...t){const s=p(()=>h(t));return P(t,s),s}e.combinedDisposable=y;function p(t){const s=R({dispose:(0,L.once)(()=>{E(s),t()})});return s}e.toDisposable=p;class m{constructor(){this._toDispose=new Set,this._isDisposed=!1,R(this)}dispose(){this._isDisposed||(E(this),this._isDisposed=!0,this.clear())}clear(){try{h(this._toDispose.values())}finally{this._toDispose.clear()}}add(s){if(!s)return s;if(s===this)throw new Error("Cannot register a disposable on itself!");return C(s,this),this._isDisposed?m.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(s),s}}e.DisposableStore=m,m.DISABLE_DISPOSED_WARNING=!1;class w{constructor(){this._store=new m,R(this),C(this._store,this)}dispose(){E(this),this._store.dispose()}_register(s){if(s===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(s)}}e.Disposable=w,w.None=Object.freeze({dispose(){}});class g{constructor(){this._isDisposed=!1,R(this)}get value(){return this._isDisposed?void 0:this._value}set value(s){this._isDisposed||s===this._value||(this._value?.dispose(),s&&C(s,this),this._value=s)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,E(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const s=this._value;return this._value=void 0,s&&C(s,null),s}}e.MutableDisposable=g;class c{constructor(s){this._disposable=s,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=c;class l{constructor(){this.references=new Map}acquire(s,...o){let u=this.references.get(s);u||(u={counter:0,object:this.createReferencedObject(s,...o)},this.references.set(s,u));const{object:f}=u,v=(0,L.once)(()=>{--u.counter==0&&(this.destroyReferencedObject(s,u.object),this.references.delete(s))});return u.counter++,{object:f,dispose:v}}}e.ReferenceCollection=l;class r{constructor(s){this.referenceCollection=s}async acquire(s,...o){const u=this.referenceCollection.acquire(s,...o);try{return{object:await u.object,dispose:()=>u.dispose()}}catch(f){throw u.dispose(),f}}}e.AsyncReferenceCollection=r;class a{constructor(s){this.object=s}dispose(){}}e.ImmortalReference=a;function n(t){const s=new m;try{t(s)}finally{s.dispose()}}e.disposeOnReturn=n}),define(te[100],ne([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class L{constructor(_){this.element=_,this.next=L.Undefined,this.prev=L.Undefined}}L.Undefined=new L(void 0);class i{constructor(){this._first=L.Undefined,this._last=L.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===L.Undefined}clear(){let _=this._first;for(;_!==L.Undefined;){const k=_.next;_.prev=L.Undefined,_.next=L.Undefined,_=k}this._first=L.Undefined,this._last=L.Undefined,this._size=0}unshift(_){return this._insert(_,!1)}push(_){return this._insert(_,!0)}_insert(_,k){const R=new L(_);if(this._first===L.Undefined)this._first=R,this._last=R;else if(k){const C=this._last;this._last=R,R.prev=C,C.next=R}else{const C=this._first;this._first=R,R.next=C,C.prev=R}this._size+=1;let E=!1;return()=>{E||(E=!0,this._remove(R))}}shift(){if(this._first!==L.Undefined){const _=this._first.element;return this._remove(this._first),_}}pop(){if(this._last!==L.Undefined){const _=this._last.element;return this._remove(this._last),_}}_remove(_){if(_.prev!==L.Undefined&&_.next!==L.Undefined){const k=_.prev;k.next=_.next,_.next.prev=k}else _.prev===L.Undefined&&_.next===L.Undefined?(this._first=L.Undefined,this._last=L.Undefined):_.next===L.Undefined?(this._last=this._last.prev,this._last.next=L.Undefined):_.prev===L.Undefined&&(this._first=this._first.next,this._first.prev=L.Undefined);this._size-=1}*[Symbol.iterator](){let _=this._first;for(;_!==L.Undefined;)yield _.element,_=_.next}}e.LinkedList=i}),function(){function Q(D){const _=[];typeof D=="number"&&_.push("code/timeOrigin",D);function k(E){_.push(E,Date.now())}function R(){const E=[];for(let C=0;C<_.length;C+=2)E.push({name:_[C],startTime:_[C+1]});return E}return{mark:k,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Q():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const _=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const k of performance.getEntriesByType("mark"))_.push({name:k.name,startTime:Math.round(D+k.startTime)});return _}};if(typeof process=="object"){const D=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Q(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),Q()}function L(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var i;typeof global=="object"?i=global:typeof self=="object"?i=self:i={},typeof define=="function"?define("vs/base/common/performance",[],function(){return L(i)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=L(i):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),i.perf=L(i))}(),define(te[4],ne([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const L="en";let i=!1,D=!1,_=!1,k=!1,R=!1,E=!1,C=!1,P=!1,b,d=L,S,h;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let y;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?y=e.globals.vscode.process:typeof process!="undefined"&&(y=process);const p=typeof y?.versions?.electron=="string",m=p&&y?.type==="renderer";if(e.isElectronSandboxed=m&&y?.sandboxed,typeof navigator=="object"&&!m)h=navigator.userAgent,i=h.indexOf("Windows")>=0,D=h.indexOf("Macintosh")>=0,P=(h.indexOf("Macintosh")>=0||h.indexOf("iPad")>=0||h.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,_=h.indexOf("Linux")>=0,E=!0,b=navigator.language,d=b;else if(typeof y=="object"){i=y.platform==="win32",D=y.platform==="darwin",_=y.platform==="linux",k=_&&!!y.env.SNAP&&!!y.env.SNAP_REVISION,C=p,b=L,d=L;const s=y.env.VSCODE_NLS_CONFIG;if(s)try{const o=JSON.parse(s),u=o.availableLanguages["*"];b=o.locale,d=u||L,S=o._translationsConfigFile}catch{}R=!0}else console.error("Unable to resolve platform.");var w;(function(s){s[s.Web=0]="Web",s[s.Mac=1]="Mac",s[s.Linux=2]="Linux",s[s.Windows=3]="Windows"})(w=e.Platform||(e.Platform={}));function g(s){switch(s){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=g;let c=0;D?c=1:i?c=3:_&&(c=2),e.isWindows=i,e.isMacintosh=D,e.isLinux=_,e.isLinuxSnap=k,e.isNative=R,e.isElectron=C,e.isWeb=E,e.isIOS=P,e.platform=c,e.userAgent=h,e.language=d;var l;(function(s){function o(){return e.language}s.value=o;function u(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}s.isDefaultVariant=u;function f(){return e.language==="en"}s.isDefault=f})(l=e.Language||(e.Language={})),e.locale=b,e.translationsConfigFile=S,e.setTimeout0=(()=>{if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let s=[];e.globals.addEventListener("message",u=>{if(u.data&&u.data.vscodeScheduleAsyncWork)for(let f=0,v=s.length;f<v;f++){const I=s[f];if(I.id===u.data.vscodeScheduleAsyncWork){s.splice(f,1),I.callback();return}}});let o=0;return u=>{const f=++o;s.push({id:f,callback:u}),e.globals.postMessage({vscodeScheduleAsyncWork:f},"*")}}return s=>setTimeout(s)})();var r;(function(s){s[s.Windows=1]="Windows",s[s.Macintosh=2]="Macintosh",s[s.Linux=3]="Linux"})(r=e.OperatingSystem||(e.OperatingSystem={})),e.OS=D||P?2:i?1:3;let a=!0,n=!1;function t(){if(!n){n=!0;const s=new Uint8Array(2);s[0]=1,s[1]=2,a=new Uint16Array(s.buffer)[0]===(2<<8)+1}return a}e.isLittleEndian=t}),define(te[32],ne([0,1,4]),function(Q,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let i;if(typeof L.globals.vscode!="undefined"&&typeof L.globals.vscode.process!="undefined"){const D=L.globals.vscode.process;i={get platform(){return D.platform},get arch(){return D.arch},get env(){return D.env},cwd(){return D.cwd()}}}else typeof process!="undefined"?i={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:i={get platform(){return L.isWindows?"win32":L.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=i.cwd,e.env=i.env,e.platform=i.platform,e.arch=i.arch}),define(te[9],ne([0,1,32]),function(Q,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const i=65,D=97,_=90,k=122,R=46,E=47,C=92,P=58,b=63;class d extends Error{constructor(c,l,r){let a;typeof l=="string"&&l.indexOf("not ")===0?(a="must not be",l=l.replace(/^not /,"")):a="must be";const n=c.indexOf(".")!==-1?"property":"argument";let t=`The "${c}" ${n} ${a} of type ${l}`;t+=`. Received type ${typeof r}`;super(t);this.code="ERR_INVALID_ARG_TYPE"}}function S(g,c){if(typeof g!="string")throw new d(c,"string",g)}function h(g){return g===E||g===C}function y(g){return g===E}function p(g){return g>=i&&g<=_||g>=D&&g<=k}function m(g,c,l,r){let a="",n=0,t=-1,s=0,o=0;for(let u=0;u<=g.length;++u){if(u<g.length)o=g.charCodeAt(u);else{if(r(o))break;o=E}if(r(o)){if(!(t===u-1||s===1))if(s===2){if(a.length<2||n!==2||a.charCodeAt(a.length-1)!==R||a.charCodeAt(a.length-2)!==R){if(a.length>2){const f=a.lastIndexOf(l);f===-1?(a="",n=0):(a=a.slice(0,f),n=a.length-1-a.lastIndexOf(l)),t=u,s=0;continue}else if(a.length!==0){a="",n=0,t=u,s=0;continue}}c&&(a+=a.length>0?`${l}..`:"..",n=2)}else a.length>0?a+=`${l}${g.slice(t+1,u)}`:a=g.slice(t+1,u),n=u-t-1;t=u,s=0}else o===R&&s!==-1?++s:s=-1}return a}function w(g,c){if(c===null||typeof c!="object")throw new d("pathObject","Object",c);const l=c.dir||c.root,r=c.base||`${c.name||""}${c.ext||""}`;return l?l===c.root?`${l}${r}`:`${l}${g}${r}`:r}e.win32={resolve(...g){let c="",l="",r=!1;for(let a=g.length-1;a>=-1;a--){let n;if(a>=0){if(n=g[a],S(n,"path"),n.length===0)continue}else c.length===0?n=L.cwd():(n=L.env[`=${c}`]||L.cwd(),(n===void 0||n.slice(0,2).toLowerCase()!==c.toLowerCase()&&n.charCodeAt(2)===C)&&(n=`${c}\\`));const t=n.length;let s=0,o="",u=!1;const f=n.charCodeAt(0);if(t===1)h(f)&&(s=1,u=!0);else if(h(f))if(u=!0,h(n.charCodeAt(1))){let v=2,I=v;for(;v<t&&!h(n.charCodeAt(v));)v++;if(v<t&&v!==I){const O=n.slice(I,v);for(I=v;v<t&&h(n.charCodeAt(v));)v++;if(v<t&&v!==I){for(I=v;v<t&&!h(n.charCodeAt(v));)v++;(v===t||v!==I)&&(o=`\\\\${O}\\${n.slice(I,v)}`,s=v)}}}else s=1;else p(f)&&n.charCodeAt(1)===P&&(o=n.slice(0,2),s=2,t>2&&h(n.charCodeAt(2))&&(u=!0,s=3));if(o.length>0)if(c.length>0){if(o.toLowerCase()!==c.toLowerCase())continue}else c=o;if(r){if(c.length>0)break}else if(l=`${n.slice(s)}\\${l}`,r=u,u&&c.length>0)break}return l=m(l,!r,"\\",h),r?`${c}\\${l}`:`${c}${l}`||"."},normalize(g){S(g,"path");const c=g.length;if(c===0)return".";let l=0,r,a=!1;const n=g.charCodeAt(0);if(c===1)return y(n)?"\\":g;if(h(n))if(a=!0,h(g.charCodeAt(1))){let s=2,o=s;for(;s<c&&!h(g.charCodeAt(s));)s++;if(s<c&&s!==o){const u=g.slice(o,s);for(o=s;s<c&&h(g.charCodeAt(s));)s++;if(s<c&&s!==o){for(o=s;s<c&&!h(g.charCodeAt(s));)s++;if(s===c)return`\\\\${u}\\${g.slice(o)}\\`;s!==o&&(r=`\\\\${u}\\${g.slice(o,s)}`,l=s)}}}else l=1;else p(n)&&g.charCodeAt(1)===P&&(r=g.slice(0,2),l=2,c>2&&h(g.charCodeAt(2))&&(a=!0,l=3));let t=l<c?m(g.slice(l),!a,"\\",h):"";return t.length===0&&!a&&(t="."),t.length>0&&h(g.charCodeAt(c-1))&&(t+="\\"),r===void 0?a?`\\${t}`:t:a?`${r}\\${t}`:`${r}${t}`},isAbsolute(g){S(g,"path");const c=g.length;if(c===0)return!1;const l=g.charCodeAt(0);return h(l)||c>2&&p(l)&&g.charCodeAt(1)===P&&h(g.charCodeAt(2))},join(...g){if(g.length===0)return".";let c,l;for(let n=0;n<g.length;++n){const t=g[n];S(t,"path"),t.length>0&&(c===void 0?c=l=t:c+=`\\${t}`)}if(c===void 0)return".";let r=!0,a=0;if(typeof l=="string"&&h(l.charCodeAt(0))){++a;const n=l.length;n>1&&h(l.charCodeAt(1))&&(++a,n>2&&(h(l.charCodeAt(2))?++a:r=!1))}if(r){for(;a<c.length&&h(c.charCodeAt(a));)a++;a>=2&&(c=`\\${c.slice(a)}`)}return e.win32.normalize(c)},relative(g,c){if(S(g,"from"),S(c,"to"),g===c)return"";const l=e.win32.resolve(g),r=e.win32.resolve(c);if(l===r||(g=l.toLowerCase(),c=r.toLowerCase(),g===c))return"";let a=0;for(;a<g.length&&g.charCodeAt(a)===C;)a++;let n=g.length;for(;n-1>a&&g.charCodeAt(n-1)===C;)n--;const t=n-a;let s=0;for(;s<c.length&&c.charCodeAt(s)===C;)s++;let o=c.length;for(;o-1>s&&c.charCodeAt(o-1)===C;)o--;const u=o-s,f=t<u?t:u;let v=-1,I=0;for(;I<f;I++){const A=g.charCodeAt(a+I);if(A!==c.charCodeAt(s+I))break;A===C&&(v=I)}if(I!==f){if(v===-1)return r}else{if(u>f){if(c.charCodeAt(s+I)===C)return r.slice(s+I+1);if(I===2)return r.slice(s+I)}t>f&&(g.charCodeAt(a+I)===C?v=I:I===2&&(v=3)),v===-1&&(v=0)}let O="";for(I=a+v+1;I<=n;++I)(I===n||g.charCodeAt(I)===C)&&(O+=O.length===0?"..":"\\..");return s+=v,O.length>0?`${O}${r.slice(s,o)}`:(r.charCodeAt(s)===C&&++s,r.slice(s,o))},toNamespacedPath(g){if(typeof g!="string")return g;if(g.length===0)return"";const c=e.win32.resolve(g);if(c.length<=2)return g;if(c.charCodeAt(0)===C){if(c.charCodeAt(1)===C){const l=c.charCodeAt(2);if(l!==b&&l!==R)return`\\\\?\\UNC\\${c.slice(2)}`}}else if(p(c.charCodeAt(0))&&c.charCodeAt(1)===P&&c.charCodeAt(2)===C)return`\\\\?\\${c}`;return g},dirname(g){S(g,"path");const c=g.length;if(c===0)return".";let l=-1,r=0;const a=g.charCodeAt(0);if(c===1)return h(a)?g:".";if(h(a)){if(l=r=1,h(g.charCodeAt(1))){let s=2,o=s;for(;s<c&&!h(g.charCodeAt(s));)s++;if(s<c&&s!==o){for(o=s;s<c&&h(g.charCodeAt(s));)s++;if(s<c&&s!==o){for(o=s;s<c&&!h(g.charCodeAt(s));)s++;if(s===c)return g;s!==o&&(l=r=s+1)}}}}else p(a)&&g.charCodeAt(1)===P&&(l=c>2&&h(g.charCodeAt(2))?3:2,r=l);let n=-1,t=!0;for(let s=c-1;s>=r;--s)if(h(g.charCodeAt(s))){if(!t){n=s;break}}else t=!1;if(n===-1){if(l===-1)return".";n=l}return g.slice(0,n)},basename(g,c){c!==void 0&&S(c,"ext"),S(g,"path");let l=0,r=-1,a=!0,n;if(g.length>=2&&p(g.charCodeAt(0))&&g.charCodeAt(1)===P&&(l=2),c!==void 0&&c.length>0&&c.length<=g.length){if(c===g)return"";let t=c.length-1,s=-1;for(n=g.length-1;n>=l;--n){const o=g.charCodeAt(n);if(h(o)){if(!a){l=n+1;break}}else s===-1&&(a=!1,s=n+1),t>=0&&(o===c.charCodeAt(t)?--t==-1&&(r=n):(t=-1,r=s))}return l===r?r=s:r===-1&&(r=g.length),g.slice(l,r)}for(n=g.length-1;n>=l;--n)if(h(g.charCodeAt(n))){if(!a){l=n+1;break}}else r===-1&&(a=!1,r=n+1);return r===-1?"":g.slice(l,r)},extname(g){S(g,"path");let c=0,l=-1,r=0,a=-1,n=!0,t=0;g.length>=2&&g.charCodeAt(1)===P&&p(g.charCodeAt(0))&&(c=r=2);for(let s=g.length-1;s>=c;--s){const o=g.charCodeAt(s);if(h(o)){if(!n){r=s+1;break}continue}a===-1&&(n=!1,a=s+1),o===R?l===-1?l=s:t!==1&&(t=1):l!==-1&&(t=-1)}return l===-1||a===-1||t===0||t===1&&l===a-1&&l===r+1?"":g.slice(l,a)},format:w.bind(null,"\\"),parse(g){S(g,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(g.length===0)return c;const l=g.length;let r=0,a=g.charCodeAt(0);if(l===1)return h(a)?(c.root=c.dir=g,c):(c.base=c.name=g,c);if(h(a)){if(r=1,h(g.charCodeAt(1))){let v=2,I=v;for(;v<l&&!h(g.charCodeAt(v));)v++;if(v<l&&v!==I){for(I=v;v<l&&h(g.charCodeAt(v));)v++;if(v<l&&v!==I){for(I=v;v<l&&!h(g.charCodeAt(v));)v++;v===l?r=v:v!==I&&(r=v+1)}}}}else if(p(a)&&g.charCodeAt(1)===P){if(l<=2)return c.root=c.dir=g,c;if(r=2,h(g.charCodeAt(2))){if(l===3)return c.root=c.dir=g,c;r=3}}r>0&&(c.root=g.slice(0,r));let n=-1,t=r,s=-1,o=!0,u=g.length-1,f=0;for(;u>=r;--u){if(a=g.charCodeAt(u),h(a)){if(!o){t=u+1;break}continue}s===-1&&(o=!1,s=u+1),a===R?n===-1?n=u:f!==1&&(f=1):n!==-1&&(f=-1)}return s!==-1&&(n===-1||f===0||f===1&&n===s-1&&n===t+1?c.base=c.name=g.slice(t,s):(c.name=g.slice(t,n),c.base=g.slice(t,s),c.ext=g.slice(n,s))),t>0&&t!==r?c.dir=g.slice(0,t-1):c.dir=c.root,c},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...g){let c="",l=!1;for(let r=g.length-1;r>=-1&&!l;r--){const a=r>=0?g[r]:L.cwd();S(a,"path"),a.length!==0&&(c=`${a}/${c}`,l=a.charCodeAt(0)===E)}return c=m(c,!l,"/",y),l?`/${c}`:c.length>0?c:"."},normalize(g){if(S(g,"path"),g.length===0)return".";const c=g.charCodeAt(0)===E,l=g.charCodeAt(g.length-1)===E;return g=m(g,!c,"/",y),g.length===0?c?"/":l?"./":".":(l&&(g+="/"),c?`/${g}`:g)},isAbsolute(g){return S(g,"path"),g.length>0&&g.charCodeAt(0)===E},join(...g){if(g.length===0)return".";let c;for(let l=0;l<g.length;++l){const r=g[l];S(r,"path"),r.length>0&&(c===void 0?c=r:c+=`/${r}`)}return c===void 0?".":e.posix.normalize(c)},relative(g,c){if(S(g,"from"),S(c,"to"),g===c||(g=e.posix.resolve(g),c=e.posix.resolve(c),g===c))return"";const l=1,r=g.length,a=r-l,n=1,t=c.length-n,s=a<t?a:t;let o=-1,u=0;for(;u<s;u++){const v=g.charCodeAt(l+u);if(v!==c.charCodeAt(n+u))break;v===E&&(o=u)}if(u===s)if(t>s){if(c.charCodeAt(n+u)===E)return c.slice(n+u+1);if(u===0)return c.slice(n+u)}else a>s&&(g.charCodeAt(l+u)===E?o=u:u===0&&(o=0));let f="";for(u=l+o+1;u<=r;++u)(u===r||g.charCodeAt(u)===E)&&(f+=f.length===0?"..":"/..");return`${f}${c.slice(n+o)}`},toNamespacedPath(g){return g},dirname(g){if(S(g,"path"),g.length===0)return".";const c=g.charCodeAt(0)===E;let l=-1,r=!0;for(let a=g.length-1;a>=1;--a)if(g.charCodeAt(a)===E){if(!r){l=a;break}}else r=!1;return l===-1?c?"/":".":c&&l===1?"//":g.slice(0,l)},basename(g,c){c!==void 0&&S(c,"ext"),S(g,"path");let l=0,r=-1,a=!0,n;if(c!==void 0&&c.length>0&&c.length<=g.length){if(c===g)return"";let t=c.length-1,s=-1;for(n=g.length-1;n>=0;--n){const o=g.charCodeAt(n);if(o===E){if(!a){l=n+1;break}}else s===-1&&(a=!1,s=n+1),t>=0&&(o===c.charCodeAt(t)?--t==-1&&(r=n):(t=-1,r=s))}return l===r?r=s:r===-1&&(r=g.length),g.slice(l,r)}for(n=g.length-1;n>=0;--n)if(g.charCodeAt(n)===E){if(!a){l=n+1;break}}else r===-1&&(a=!1,r=n+1);return r===-1?"":g.slice(l,r)},extname(g){S(g,"path");let c=-1,l=0,r=-1,a=!0,n=0;for(let t=g.length-1;t>=0;--t){const s=g.charCodeAt(t);if(s===E){if(!a){l=t+1;break}continue}r===-1&&(a=!1,r=t+1),s===R?c===-1?c=t:n!==1&&(n=1):c!==-1&&(n=-1)}return c===-1||r===-1||n===0||n===1&&c===r-1&&c===l+1?"":g.slice(c,r)},format:w.bind(null,"/"),parse(g){S(g,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(g.length===0)return c;const l=g.charCodeAt(0)===E;let r;l?(c.root="/",r=1):r=0;let a=-1,n=0,t=-1,s=!0,o=g.length-1,u=0;for(;o>=r;--o){const f=g.charCodeAt(o);if(f===E){if(!s){n=o+1;break}continue}t===-1&&(s=!1,t=o+1),f===R?a===-1?a=o:u!==1&&(u=1):a!==-1&&(u=-1)}if(t!==-1){const f=n===0&&l?1:n;a===-1||u===0||u===1&&a===t-1&&a===n+1?c.base=c.name=g.slice(f,t):(c.name=g.slice(f,a),c.base=g.slice(f,t),c.ext=g.slice(a,t))}return n>0?c.dir=g.slice(0,n-1):l&&(c.dir="/"),c},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=L.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=L.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=L.platform==="win32"?e.win32.join:e.posix.join,e.resolve=L.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=L.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=L.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=L.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=L.platform==="win32"?e.win32.extname:e.posix.extname,e.format=L.platform==="win32"?e.win32.format:e.posix.format,e.parse=L.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=L.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=L.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=L.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(te[101],ne([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var L;(function(_){_[_.stdout=0]="stdout",_[_.stderr=1]="stderr"})(L=e.Source||(e.Source={}));var i;(function(_){_[_.Success=0]="Success",_[_.Unknown=1]="Unknown",_[_.AccessDenied=2]="AccessDenied",_[_.ProcessNotFound=3]="ProcessNotFound"})(i=e.TerminateResponseCode||(e.TerminateResponseCode={}));function D(_,...k){const R=k.reduce((P,b)=>(P[b]=!0,P),{}),E=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(_).filter(P=>!R[P]).forEach(P=>{for(let b=0;b<E.length;b++)if(P.search(E[b])!==-1){delete _[P];break}})}e.sanitizeProcessEnvironment=D}),function(Q,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var L=e();for(var i in L)(typeof exports=="object"?exports:Q)[i]=L[i]}}(typeof self!="undefined"?self:this,function(){return function(Q){var e={};function L(i){if(e[i])return e[i].exports;var D=e[i]={i,l:!1,exports:{}};return Q[i].call(D.exports,D,D.exports,L),D.l=!0,D.exports}return L.m=Q,L.c=e,L.d=function(i,D,_){L.o(i,D)||Object.defineProperty(i,D,{enumerable:!0,get:_})},L.r=function(i){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(i,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(i,"__esModule",{value:!0})},L.t=function(i,D){if(1&D&&(i=L(i)),8&D||4&D&&typeof i=="object"&&i&&i.__esModule)return i;var _=Object.create(null);if(L.r(_),Object.defineProperty(_,"default",{enumerable:!0,value:i}),2&D&&typeof i!="string")for(var k in i)L.d(_,k,function(R){return i[R]}.bind(null,k));return _},L.n=function(i){var D=i&&i.__esModule?function(){return i.default}:function(){return i};return L.d(D,"a",D),D},L.o=function(i,D){return Object.prototype.hasOwnProperty.call(i,D)},L.p="",L(L.s=0)}([function(Q,e,L){(function(i){var D;e=Q.exports=G,D=typeof i=="object"&&i.env&&i.env.NODE_DEBUG&&/\bsemver\b/i.test(i.env.NODE_DEBUG)?function(){var ie=Array.prototype.slice.call(arguments,0);ie.unshift("SEMVER"),console.log.apply(console,ie)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var _=256,k=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],E=e.src=[],C=0,P=C++;E[P]="0|[1-9]\\d*";var b=C++;E[b]="[0-9]+";var d=C++;E[d]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var S=C++;E[S]="("+E[P]+")\\.("+E[P]+")\\.("+E[P]+")";var h=C++;E[h]="("+E[b]+")\\.("+E[b]+")\\.("+E[b]+")";var y=C++;E[y]="(?:"+E[P]+"|"+E[d]+")";var p=C++;E[p]="(?:"+E[b]+"|"+E[d]+")";var m=C++;E[m]="(?:-("+E[y]+"(?:\\."+E[y]+")*))";var w=C++;E[w]="(?:-?("+E[p]+"(?:\\."+E[p]+")*))";var g=C++;E[g]="[0-9A-Za-z-]+";var c=C++;E[c]="(?:\\+("+E[g]+"(?:\\."+E[g]+")*))";var l=C++,r="v?"+E[S]+E[m]+"?"+E[c]+"?";E[l]="^"+r+"$";var a="[v=\\s]*"+E[h]+E[w]+"?"+E[c]+"?",n=C++;E[n]="^"+a+"$";var t=C++;E[t]="((?:<|>)?=?)";var s=C++;E[s]=E[b]+"|x|X|\\*";var o=C++;E[o]=E[P]+"|x|X|\\*";var u=C++;E[u]="[v=\\s]*("+E[o]+")(?:\\.("+E[o]+")(?:\\.("+E[o]+")(?:"+E[m]+")?"+E[c]+"?)?)?";var f=C++;E[f]="[v=\\s]*("+E[s]+")(?:\\.("+E[s]+")(?:\\.("+E[s]+")(?:"+E[w]+")?"+E[c]+"?)?)?";var v=C++;E[v]="^"+E[t]+"\\s*"+E[u]+"$";var I=C++;E[I]="^"+E[t]+"\\s*"+E[f]+"$";var O=C++;E[O]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var A=C++;E[A]="(?:~>?)";var N=C++;E[N]="(\\s*)"+E[A]+"\\s+",R[N]=new RegExp(E[N],"g");var $=C++;E[$]="^"+E[A]+E[u]+"$";var T=C++;E[T]="^"+E[A]+E[f]+"$";var F=C++;E[F]="(?:\\^)";var M=C++;E[M]="(\\s*)"+E[F]+"\\s+",R[M]=new RegExp(E[M],"g");var U=C++;E[U]="^"+E[F]+E[u]+"$";var B=C++;E[B]="^"+E[F]+E[f]+"$";var ee=C++;E[ee]="^"+E[t]+"\\s*("+a+")$|^$";var H=C++;E[H]="^"+E[t]+"\\s*("+r+")$|^$";var j=C++;E[j]="(\\s*)"+E[t]+"\\s*("+a+"|"+E[u]+")",R[j]=new RegExp(E[j],"g");var Z=C++;E[Z]="^\\s*("+E[u]+")\\s+-\\s+("+E[u]+")\\s*$";var W=C++;E[W]="^\\s*("+E[f]+")\\s+-\\s+("+E[f]+")\\s*$";var z=C++;E[z]="(<|>)?=?\\s*\\*";for(var V=0;V<35;V++)D(V,E[V]),R[V]||(R[V]=new RegExp(E[V]));function q(ie,ae){if(ie instanceof G)return ie;if(typeof ie!="string"||ie.length>_||!(ae?R[n]:R[l]).test(ie))return null;try{return new G(ie,ae)}catch{return null}}function G(ie,ae){if(ie instanceof G){if(ie.loose===ae)return ie;ie=ie.version}else if(typeof ie!="string")throw new TypeError("Invalid Version: "+ie);if(ie.length>_)throw new TypeError("version is longer than "+_+" characters");if(!(this instanceof G))return new G(ie,ae);D("SemVer",ie,ae),this.loose=ae;var le=ie.trim().match(ae?R[n]:R[l]);if(!le)throw new TypeError("Invalid Version: "+ie);if(this.raw=ie,this.major=+le[1],this.minor=+le[2],this.patch=+le[3],this.major>k||this.major<0)throw new TypeError("Invalid major version");if(this.minor>k||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>k||this.patch<0)throw new TypeError("Invalid patch version");le[4]?this.prerelease=le[4].split(".").map(function(be){if(/^[0-9]+$/.test(be)){var Ie=+be;if(Ie>=0&&Ie<k)return Ie}return be}):this.prerelease=[],this.build=le[5]?le[5].split("."):[],this.format()}e.parse=q,e.valid=function(ie,ae){var le=q(ie,ae);return le?le.version:null},e.clean=function(ie,ae){var le=q(ie.trim().replace(/^[=v]+/,""),ae);return le?le.version:null},e.SemVer=G,G.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},G.prototype.toString=function(){return this.version},G.prototype.compare=function(ie){return D("SemVer.compare",this.version,this.loose,ie),ie instanceof G||(ie=new G(ie,this.loose)),this.compareMain(ie)||this.comparePre(ie)},G.prototype.compareMain=function(ie){return ie instanceof G||(ie=new G(ie,this.loose)),x(this.major,ie.major)||x(this.minor,ie.minor)||x(this.patch,ie.patch)},G.prototype.comparePre=function(ie){if(ie instanceof G||(ie=new G(ie,this.loose)),this.prerelease.length&&!ie.prerelease.length)return-1;if(!this.prerelease.length&&ie.prerelease.length)return 1;if(!this.prerelease.length&&!ie.prerelease.length)return 0;var ae=0;do{var le=this.prerelease[ae],be=ie.prerelease[ae];if(D("prerelease compare",ae,le,be),le===void 0&&be===void 0)return 0;if(be===void 0)return 1;if(le===void 0)return-1;if(le!==be)return x(le,be)}while(++ae)},G.prototype.inc=function(ie,ae){switch(ie){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ae);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ae);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ae),this.inc("pre",ae);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ae),this.inc("pre",ae);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var le=this.prerelease.length;--le>=0;)typeof this.prerelease[le]=="number"&&(this.prerelease[le]++,le=-2);le===-1&&this.prerelease.push(0)}ae&&(this.prerelease[0]===ae?isNaN(this.prerelease[1])&&(this.prerelease=[ae,0]):this.prerelease=[ae,0]);break;default:throw new Error("invalid increment argument: "+ie)}return this.format(),this.raw=this.version,this},e.inc=function(ie,ae,le,be){typeof le=="string"&&(be=le,le=void 0);try{return new G(ie,le).inc(ae,be).version}catch{return null}},e.diff=function(ie,ae){if(ce(ie,ae))return null;var le=q(ie),be=q(ae);if(le.prerelease.length||be.prerelease.length){for(var Ie in le)if((Ie==="major"||Ie==="minor"||Ie==="patch")&&le[Ie]!==be[Ie])return"pre"+Ie;return"prerelease"}for(var Ie in le)if((Ie==="major"||Ie==="minor"||Ie==="patch")&&le[Ie]!==be[Ie])return Ie},e.compareIdentifiers=x;var Y=/^[0-9]+$/;function x(ie,ae){var le=Y.test(ie),be=Y.test(ae);return le&&be&&(ie=+ie,ae=+ae),le&&!be?-1:be&&!le?1:ie<ae?-1:ie>ae?1:0}function K(ie,ae,le){return new G(ie,le).compare(new G(ae,le))}function re(ie,ae,le){return K(ie,ae,le)>0}function se(ie,ae,le){return K(ie,ae,le)<0}function ce(ie,ae,le){return K(ie,ae,le)===0}function he(ie,ae,le){return K(ie,ae,le)!==0}function me(ie,ae,le){return K(ie,ae,le)>=0}function ve(ie,ae,le){return K(ie,ae,le)<=0}function ge(ie,ae,le,be){var Ie;switch(ae){case"===":typeof ie=="object"&&(ie=ie.version),typeof le=="object"&&(le=le.version),Ie=ie===le;break;case"!==":typeof ie=="object"&&(ie=ie.version),typeof le=="object"&&(le=le.version),Ie=ie!==le;break;case"":case"=":case"==":Ie=ce(ie,le,be);break;case"!=":Ie=he(ie,le,be);break;case">":Ie=re(ie,le,be);break;case">=":Ie=me(ie,le,be);break;case"<":Ie=se(ie,le,be);break;case"<=":Ie=ve(ie,le,be);break;default:throw new TypeError("Invalid operator: "+ae)}return Ie}function we(ie,ae){if(ie instanceof we){if(ie.loose===ae)return ie;ie=ie.value}if(!(this instanceof we))return new we(ie,ae);D("comparator",ie,ae),this.loose=ae,this.parse(ie),this.semver===Re?this.value="":this.value=this.operator+this.semver.version,D("comp",this)}e.rcompareIdentifiers=function(ie,ae){return x(ae,ie)},e.major=function(ie,ae){return new G(ie,ae).major},e.minor=function(ie,ae){return new G(ie,ae).minor},e.patch=function(ie,ae){return new G(ie,ae).patch},e.compare=K,e.compareLoose=function(ie,ae){return K(ie,ae,!0)},e.rcompare=function(ie,ae,le){return K(ae,ie,le)},e.sort=function(ie,ae){return ie.sort(function(le,be){return e.compare(le,be,ae)})},e.rsort=function(ie,ae){return ie.sort(function(le,be){return e.rcompare(le,be,ae)})},e.gt=re,e.lt=se,e.eq=ce,e.neq=he,e.gte=me,e.lte=ve,e.cmp=ge,e.Comparator=we;var Re={};function Ee(ie,ae){if(ie instanceof Ee)return ie.loose===ae?ie:new Ee(ie.raw,ae);if(ie instanceof we)return new Ee(ie.value,ae);if(!(this instanceof Ee))return new Ee(ie,ae);if(this.loose=ae,this.raw=ie,this.set=ie.split(/\s*\|\|\s*/).map(function(le){return this.parseRange(le.trim())},this).filter(function(le){return le.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ie);this.format()}function ke(ie){return!ie||ie.toLowerCase()==="x"||ie==="*"}function Le(ie,ae,le,be,Ie,Me,Te,Ne,Ae,Ue,X,oe,ue){return((ae=ke(le)?"":ke(be)?">="+le+".0.0":ke(Ie)?">="+le+"."+be+".0":">="+ae)+" "+(Ne=ke(Ae)?"":ke(Ue)?"<"+(+Ae+1)+".0.0":ke(X)?"<"+Ae+"."+(+Ue+1)+".0":oe?"<="+Ae+"."+Ue+"."+X+"-"+oe:"<="+Ne)).trim()}function Fe(ie,ae){for(var le=0;le<ie.length;le++)if(!ie[le].test(ae))return!1;if(ae.prerelease.length){for(le=0;le<ie.length;le++)if(D(ie[le].semver),ie[le].semver!==Re&&ie[le].semver.prerelease.length>0){var be=ie[le].semver;if(be.major===ae.major&&be.minor===ae.minor&&be.patch===ae.patch)return!0}return!1}return!0}function $e(ie,ae,le){try{ae=new Ee(ae,le)}catch{return!1}return ae.test(ie)}function ze(ie,ae,le,be){var Ie,Me,Te,Ne,Ae;switch(ie=new G(ie,be),ae=new Ee(ae,be),le){case">":Ie=re,Me=ve,Te=se,Ne=">",Ae=">=";break;case"<":Ie=se,Me=me,Te=re,Ne="<",Ae="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if($e(ie,ae,be))return!1;for(var Ue=0;Ue<ae.set.length;++Ue){var X=ae.set[Ue],oe=null,ue=null;if(X.forEach(function(fe){fe.semver===Re&&(fe=new we(">=0.0.0")),oe=oe||fe,ue=ue||fe,Ie(fe.semver,oe.semver,be)?oe=fe:Te(fe.semver,ue.semver,be)&&(ue=fe)}),oe.operator===Ne||oe.operator===Ae||(!ue.operator||ue.operator===Ne)&&Me(ie,ue.semver)||ue.operator===Ae&&Te(ie,ue.semver))return!1}return!0}we.prototype.parse=function(ie){var ae=this.loose?R[ee]:R[H],le=ie.match(ae);if(!le)throw new TypeError("Invalid comparator: "+ie);this.operator=le[1],this.operator==="="&&(this.operator=""),le[2]?this.semver=new G(le[2],this.loose):this.semver=Re},we.prototype.toString=function(){return this.value},we.prototype.test=function(ie){return D("Comparator.test",ie,this.loose),this.semver===Re||(typeof ie=="string"&&(ie=new G(ie,this.loose)),ge(ie,this.operator,this.semver,this.loose))},we.prototype.intersects=function(ie,ae){if(!(ie instanceof we))throw new TypeError("a Comparator is required");var le;if(this.operator==="")return le=new Ee(ie.value,ae),$e(this.value,le,ae);if(ie.operator==="")return le=new Ee(this.value,ae),$e(ie.semver,le,ae);var be=!(this.operator!==">="&&this.operator!==">"||ie.operator!==">="&&ie.operator!==">"),Ie=!(this.operator!=="<="&&this.operator!=="<"||ie.operator!=="<="&&ie.operator!=="<"),Me=this.semver.version===ie.semver.version,Te=!(this.operator!==">="&&this.operator!=="<="||ie.operator!==">="&&ie.operator!=="<="),Ne=ge(this.semver,"<",ie.semver,ae)&&(this.operator===">="||this.operator===">")&&(ie.operator==="<="||ie.operator==="<"),Ae=ge(this.semver,">",ie.semver,ae)&&(this.operator==="<="||this.operator==="<")&&(ie.operator===">="||ie.operator===">");return be||Ie||Me&&Te||Ne||Ae},e.Range=Ee,Ee.prototype.format=function(){return this.range=this.set.map(function(ie){return ie.join(" ").trim()}).join("||").trim(),this.range},Ee.prototype.toString=function(){return this.range},Ee.prototype.parseRange=function(ie){var ae=this.loose;ie=ie.trim(),D("range",ie,ae);var le=ae?R[W]:R[Z];ie=ie.replace(le,Le),D("hyphen replace",ie),ie=ie.replace(R[j],"$1$2$3"),D("comparator trim",ie,R[j]),ie=(ie=(ie=ie.replace(R[N],"$1~")).replace(R[M],"$1^")).split(/\s+/).join(" ");var be=ae?R[ee]:R[H],Ie=ie.split(" ").map(function(Me){return function(Te,Ne){return D("comp",Te),Te=function(Ae,Ue){return Ae.trim().split(/\s+/).map(function(X){return function(oe,ue){D("caret",oe,ue);var fe=ue?R[B]:R[U];return oe.replace(fe,function(ye,pe,Ce,Pe,De){var _e;return D("caret",oe,ye,pe,Ce,Pe,De),ke(pe)?_e="":ke(Ce)?_e=">="+pe+".0.0 <"+(+pe+1)+".0.0":ke(Pe)?_e=pe==="0"?">="+pe+"."+Ce+".0 <"+pe+"."+(+Ce+1)+".0":">="+pe+"."+Ce+".0 <"+(+pe+1)+".0.0":De?(D("replaceCaret pr",De),De.charAt(0)!=="-"&&(De="-"+De),_e=pe==="0"?Ce==="0"?">="+pe+"."+Ce+"."+Pe+De+" <"+pe+"."+Ce+"."+(+Pe+1):">="+pe+"."+Ce+"."+Pe+De+" <"+pe+"."+(+Ce+1)+".0":">="+pe+"."+Ce+"."+Pe+De+" <"+(+pe+1)+".0.0"):(D("no pr"),_e=pe==="0"?Ce==="0"?">="+pe+"."+Ce+"."+Pe+" <"+pe+"."+Ce+"."+(+Pe+1):">="+pe+"."+Ce+"."+Pe+" <"+pe+"."+(+Ce+1)+".0":">="+pe+"."+Ce+"."+Pe+" <"+(+pe+1)+".0.0"),D("caret return",_e),_e})}(X,Ue)}).join(" ")}(Te,Ne),D("caret",Te),Te=function(Ae,Ue){return Ae.trim().split(/\s+/).map(function(X){return function(oe,ue){var fe=ue?R[T]:R[$];return oe.replace(fe,function(ye,pe,Ce,Pe,De){var _e;return D("tilde",oe,ye,pe,Ce,Pe,De),ke(pe)?_e="":ke(Ce)?_e=">="+pe+".0.0 <"+(+pe+1)+".0.0":ke(Pe)?_e=">="+pe+"."+Ce+".0 <"+pe+"."+(+Ce+1)+".0":De?(D("replaceTilde pr",De),De.charAt(0)!=="-"&&(De="-"+De),_e=">="+pe+"."+Ce+"."+Pe+De+" <"+pe+"."+(+Ce+1)+".0"):_e=">="+pe+"."+Ce+"."+Pe+" <"+pe+"."+(+Ce+1)+".0",D("tilde return",_e),_e})}(X,Ue)}).join(" ")}(Te,Ne),D("tildes",Te),Te=function(Ae,Ue){return D("replaceXRanges",Ae,Ue),Ae.split(/\s+/).map(function(X){return function(oe,ue){oe=oe.trim();var fe=ue?R[I]:R[v];return oe.replace(fe,function(ye,pe,Ce,Pe,De,_e){D("xRange",oe,ye,pe,Ce,Pe,De,_e);var qe=ke(Ce),He=qe||ke(Pe),Ye=He||ke(De);return pe==="="&&Ye&&(pe=""),qe?ye=pe===">"||pe==="<"?"<0.0.0":"*":pe&&Ye?(He&&(Pe=0),Ye&&(De=0),pe===">"?(pe=">=",He?(Ce=+Ce+1,Pe=0,De=0):Ye&&(Pe=+Pe+1,De=0)):pe==="<="&&(pe="<",He?Ce=+Ce+1:Pe=+Pe+1),ye=pe+Ce+"."+Pe+"."+De):He?ye=">="+Ce+".0.0 <"+(+Ce+1)+".0.0":Ye&&(ye=">="+Ce+"."+Pe+".0 <"+Ce+"."+(+Pe+1)+".0"),D("xRange return",ye),ye})}(X,Ue)}).join(" ")}(Te,Ne),D("xrange",Te),Te=function(Ae,Ue){return D("replaceStars",Ae,Ue),Ae.trim().replace(R[z],"")}(Te,Ne),D("stars",Te),Te}(Me,ae)}).join(" ").split(/\s+/);return this.loose&&(Ie=Ie.filter(function(Me){return!!Me.match(be)})),Ie=Ie.map(function(Me){return new we(Me,ae)})},Ee.prototype.intersects=function(ie,ae){if(!(ie instanceof Ee))throw new TypeError("a Range is required");return this.set.some(function(le){return le.every(function(be){return ie.set.some(function(Ie){return Ie.every(function(Me){return be.intersects(Me,ae)})})})})},e.toComparators=function(ie,ae){return new Ee(ie,ae).set.map(function(le){return le.map(function(be){return be.value}).join(" ").trim().split(" ")})},Ee.prototype.test=function(ie){if(!ie)return!1;typeof ie=="string"&&(ie=new G(ie,this.loose));for(var ae=0;ae<this.set.length;ae++)if(Fe(this.set[ae],ie))return!0;return!1},e.satisfies=$e,e.maxSatisfying=function(ie,ae,le){var be=null,Ie=null;try{var Me=new Ee(ae,le)}catch{return null}return ie.forEach(function(Te){Me.test(Te)&&(be&&Ie.compare(Te)!==-1||(Ie=new G(be=Te,le)))}),be},e.minSatisfying=function(ie,ae,le){var be=null,Ie=null;try{var Me=new Ee(ae,le)}catch{return null}return ie.forEach(function(Te){Me.test(Te)&&(be&&Ie.compare(Te)!==1||(Ie=new G(be=Te,le)))}),be},e.validRange=function(ie,ae){try{return new Ee(ie,ae).range||"*"}catch{return null}},e.ltr=function(ie,ae,le){return ze(ie,ae,"<",le)},e.gtr=function(ie,ae,le){return ze(ie,ae,">",le)},e.outside=ze,e.prerelease=function(ie,ae){var le=q(ie,ae);return le&&le.prerelease.length?le.prerelease:null},e.intersects=function(ie,ae,le){return ie=new Ee(ie,le),ae=new Ee(ae,le),ie.intersects(ae)},e.coerce=function(ie){if(ie instanceof G)return ie;if(typeof ie!="string")return null;var ae=ie.match(R[O]);return ae==null?null:q((ae[1]||"0")+"."+(ae[2]||"0")+"."+(ae[3]||"0"))}}).call(this,L(1))},function(Q,e){var L,i,D=Q.exports={};function _(){throw new Error("setTimeout has not been defined")}function k(){throw new Error("clearTimeout has not been defined")}function R(p){if(L===setTimeout)return setTimeout(p,0);if((L===_||!L)&&setTimeout)return L=setTimeout,setTimeout(p,0);try{return L(p,0)}catch{try{return L.call(null,p,0)}catch{return L.call(this,p,0)}}}(function(){try{L=typeof setTimeout=="function"?setTimeout:_}catch{L=_}try{i=typeof clearTimeout=="function"?clearTimeout:k}catch{i=k}})();var E,C=[],P=!1,b=-1;function d(){P&&E&&(P=!1,E.length?C=E.concat(C):b=-1,C.length&&S())}function S(){if(!P){var p=R(d);P=!0;for(var m=C.length;m;){for(E=C,C=[];++b<m;)E&&E[b].run();b=-1,m=C.length}E=null,P=!1,function(w){if(i===clearTimeout)return clearTimeout(w);if((i===k||!i)&&clearTimeout)return i=clearTimeout,clearTimeout(w);try{i(w)}catch{try{return i.call(null,w)}catch{return i.call(this,w)}}}(p)}}function h(p,m){this.fun=p,this.array=m}function y(){}D.nextTick=function(p){var m=new Array(arguments.length-1);if(arguments.length>1)for(var w=1;w<arguments.length;w++)m[w-1]=arguments[w];C.push(new h(p,m)),C.length!==1||P||R(S)},h.prototype.run=function(){this.fun.apply(null,this.array)},D.title="browser",D.browser=!0,D.env={},D.argv=[],D.version="",D.versions={},D.on=y,D.addListener=y,D.once=y,D.off=y,D.removeListener=y,D.removeAllListeners=y,D.emit=y,D.prependListener=y,D.prependOnceListener=y,D.listeners=function(p){return[]},D.binding=function(p){throw new Error("process.binding is not supported")},D.cwd=function(){return"/"},D.chdir=function(p){throw new Error("process.chdir is not supported")},D.umask=function(){return 0}}])}),define(te[102],ne([0,1]),function(Q,e){"use strict";var L;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class i{constructor(R,E,C){this.level=R,this.key=E,this.value=C,this.forward=[]}}const D=void 0;class _{constructor(R,E=2**16){this.comparator=R,this[L]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(E)|0),this._header=new i(this._maxLevel,D,D)}get size(){return this._size}clear(){this._header=new i(this._maxLevel,D,D)}has(R){return Boolean(_._search(this,R,this.comparator))}get(R){return _._search(this,R,this.comparator)?.value}set(R,E){return _._insert(this,R,E,this.comparator)&&(this._size+=1),this}delete(R){const E=_._delete(this,R,this.comparator);return E&&(this._size-=1),E}forEach(R,E){let C=this._header.forward[0];for(;C;)R.call(E,C.value,C.key,this),C=C.forward[0]}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let R=this._header.forward[0];for(;R;)yield[R.key,R.value],R=R.forward[0]}*keys(){let R=this._header.forward[0];for(;R;)yield R.key,R=R.forward[0]}*values(){let R=this._header.forward[0];for(;R;)yield R.value,R=R.forward[0]}toString(){let R="[SkipList]:",E=this._header.forward[0];for(;E;)R+=`node(${E.key}, ${E.value}, lvl:${E.level})`,E=E.forward[0];return R}static _search(R,E,C){let P=R._header;for(let b=R._level-1;b>=0;b--)for(;P.forward[b]&&C(P.forward[b].key,E)<0;)P=P.forward[b];if(P=P.forward[0],P&&C(P.key,E)===0)return P}static _insert(R,E,C,P){let b=[],d=R._header;for(let S=R._level-1;S>=0;S--){for(;d.forward[S]&&P(d.forward[S].key,E)<0;)d=d.forward[S];b[S]=d}if(d=d.forward[0],d&&P(d.key,E)===0)return d.value=C,!1;{let S=_._randomLevel(R);if(S>R._level){for(let h=R._level;h<S;h++)b[h]=R._header;R._level=S}d=new i(S,E,C);for(let h=0;h<S;h++)d.forward[h]=b[h].forward[h],b[h].forward[h]=d;return!0}}static _randomLevel(R,E=.5){let C=1;for(;Math.random()<E&&C<R._maxLevel;)C+=1;return C}static _delete(R,E,C){let P=[],b=R._header;for(let d=R._level-1;d>=0;d--){for(;b.forward[d]&&C(b.forward[d].key,E)<0;)b=b.forward[d];P[d]=b}if(b=b.forward[0],!b||C(b.key,E)!==0)return!1;for(let d=0;d<R._level&&P[d].forward[d]===b;d++)P[d].forward[d]=b.forward[d];for(;R._level>0&&R._header.forward[R._level-1]===D;)R._level-=1;return!0}}e.SkipList=_}),define(te[103],ne([0,1,4]),function(Q,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const i=L.globals.performance&&typeof L.globals.performance.now=="function";class D{constructor(k){this._highResolution=i&&k,this._startTime=this._now(),this._stopTime=-1}static create(k=!0){return new D(k)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?L.globals.performance.now():Date.now()}}e.StopWatch=D}),define(te[3],ne([0,1,10,68,2,100,103]),function(Q,e,L,i,D,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var R;(function(c){c.None=()=>D.Disposable.None;function l(U){return(B,ee=null,H)=>{let j=!1,Z;return Z=U(W=>{if(!j)return Z?Z.dispose():j=!0,B.call(ee,W)},null,H),j&&Z.dispose(),Z}}c.once=l;function r(U,B){return u((ee,H=null,j)=>U(Z=>ee.call(H,B(Z)),null,j))}c.map=r;function a(U,B){return u((ee,H=null,j)=>U(Z=>{B(Z),ee.call(H,Z)},null,j))}c.forEach=a;function n(U,B){return u((ee,H=null,j)=>U(Z=>B(Z)&&ee.call(H,Z),null,j))}c.filter=n;function t(U){return U}c.signal=t;function s(...U){return(B,ee=null,H)=>(0,D.combinedDisposable)(...U.map(j=>j(Z=>B.call(ee,Z),null,H)))}c.any=s;function o(U,B,ee){let H=ee;return r(U,j=>(H=B(H,j),H))}c.reduce=o;function u(U){let B;const ee=new d({onFirstListenerAdd(){B=U(ee.fire,ee)},onLastListenerRemove(){B.dispose()}});return ee.event}function f(U,B,ee=100,H=!1,j){let Z,W,z,V=0;const q=new d({leakWarningThreshold:j,onFirstListenerAdd(){Z=U(G=>{V++,W=B(W,G),H&&!z&&(q.fire(W),W=void 0),clearTimeout(z),z=setTimeout(()=>{const Y=W;W=void 0,z=void 0,(!H||V>1)&&q.fire(Y),V=0},ee)})},onLastListenerRemove(){Z.dispose()}});return q.event}c.debounce=f;function v(U,B=(ee,H)=>ee===H){let ee=!0,H;return n(U,j=>{const Z=ee||!B(j,H);return ee=!1,H=j,Z})}c.latch=v;function I(U,B){return[c.filter(U,B),c.filter(U,ee=>!B(ee))]}c.split=I;function O(U,B=!1,ee=[]){let H=ee.slice(),j=U(z=>{H?H.push(z):W.fire(z)});const Z=()=>{H&&H.forEach(z=>W.fire(z)),H=null},W=new d({onFirstListenerAdd(){j||(j=U(z=>W.fire(z)))},onFirstListenerDidAdd(){H&&(B?setTimeout(Z):Z())},onLastListenerRemove(){j&&j.dispose(),j=null}});return W.event}c.buffer=O;class A{constructor(B){this.event=B}map(B){return new A(r(this.event,B))}forEach(B){return new A(a(this.event,B))}filter(B){return new A(n(this.event,B))}reduce(B,ee){return new A(o(this.event,B,ee))}latch(){return new A(v(this.event))}debounce(B,ee=100,H=!1,j){return new A(f(this.event,B,ee,H,j))}on(B,ee,H){return this.event(B,ee,H)}once(B,ee,H){return l(this.event)(B,ee,H)}}function N(U){return new A(U)}c.chain=N;function $(U,B,ee=H=>H){const H=(...z)=>W.fire(ee(...z)),j=()=>U.on(B,H),Z=()=>U.removeListener(B,H),W=new d({onFirstListenerAdd:j,onLastListenerRemove:Z});return W.event}c.fromNodeEventEmitter=$;function T(U,B,ee=H=>H){const H=(...z)=>W.fire(ee(...z)),j=()=>U.addEventListener(B,H),Z=()=>U.removeEventListener(B,H),W=new d({onFirstListenerAdd:j,onLastListenerRemove:Z});return W.event}c.fromDOMEventEmitter=T;function F(U){return new Promise(B=>l(U)(B))}c.toPromise=F;function M(U,B){return B(void 0),U(ee=>B(ee))}c.runAndSubscribe=M})(R=e.Event||(e.Event={}));class E{constructor(l){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${l}_${E._idPool++}`}start(l){this._stopWatch=new k.StopWatch(!0),this._listenerCount=l}stop(){if(this._stopWatch){const l=this._stopWatch.elapsed();this._elapsedOverall+=l,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${l.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}E._idPool=0;let C=-1;function P(c){const l=C;return C=c,{dispose(){C=l}}}e.setGlobalLeakWarningThreshold=P;class b{constructor(l,r=Math.random().toString(18).slice(2,5)){this.customThreshold=l,this.name=r,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(l){let r=C;if(typeof this.customThreshold=="number"&&(r=this.customThreshold),r<=0||l<r)return;this._stacks||(this._stacks=new Map);const a=new Error().stack.split(`
`).slice(3).join(`
`),n=this._stacks.get(a)||0;if(this._stacks.set(a,n+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=r*.5;let t,s=0;for(const[o,u]of this._stacks)(!t||s<u)&&(t=o,s=u);console.warn(`[${this.name}] potential listener LEAK detected, having ${l} listeners already. MOST frequent listener (${s}):`),console.warn(t)}return()=>{const t=this._stacks.get(a)||0;this._stacks.set(a,t-1)}}}class d{constructor(l){this._disposed=!1,this._options=l,this._leakageMon=C>0?new b(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new E(this._options._profName):void 0}get event(){return this._event||(this._event=(l,r,a)=>{this._listeners||(this._listeners=new _.LinkedList);const n=this._listeners.isEmpty();n&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const t=this._listeners.push(r?[l,r]:l);n&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,l,r);const s=this._leakageMon?.check(this._listeners.size),o=(0,D.toDisposable)(()=>{s&&s(),this._disposed||(t(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return a instanceof D.DisposableStore?a.add(o):Array.isArray(a)&&a.push(o),o}),this._event}fire(l){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new _.LinkedList);for(let r of this._listeners)this._deliveryQueue.push([r,l]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[r,a]=this._deliveryQueue.shift();try{typeof r=="function"?r.call(void 0,a):r[0].call(r[1],a)}catch(n){(0,L.onUnexpectedError)(n)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=d;class S extends d{async fireAsync(l,r,a){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new _.LinkedList);for(const n of this._listeners)this._asyncDeliveryQueue.push([n,l]);for(;this._asyncDeliveryQueue.size>0&&!r.isCancellationRequested;){const[n,t]=this._asyncDeliveryQueue.shift(),s=[],o={...t,token:r,waitUntil:u=>{if(Object.isFrozen(s))throw new Error("waitUntil can NOT be called asynchronous");a&&(u=a(u,typeof n=="function"?n:n[0])),s.push(u)}};try{typeof n=="function"?n.call(void 0,o):n[0].call(n[1],o)}catch(u){(0,L.onUnexpectedError)(u);continue}Object.freeze(s),await Promise.allSettled(s).then(u=>{for(const f of u)f.status==="rejected"&&(0,L.onUnexpectedError)(f.reason)})}}}}e.AsyncEmitter=S;class h extends d{constructor(l){super(l);this._isPaused=0,this._eventQueue=new _.LinkedList,this._mergeFn=l?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const l=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(l))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(l){this._listeners&&(this._isPaused!==0?this._eventQueue.push(l):super.fire(l))}}e.PauseableEmitter=h;class y extends h{constructor(l){super(l);this._delay=l.delay??100}fire(l){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(l)}}e.DebounceEmitter=y;class p extends d{constructor(l){super(l);this._queuedEvents=[],this._mergeFn=l?.merge}fire(l){this._queuedEvents.push(l),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(r=>super.fire(r)),this._queuedEvents=[]})}}e.MicrotaskEmitter=p;class m{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new d({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(l){const r={event:l,listener:null};this.events.push(r),this.hasListeners&&this.hook(r);const a=()=>{this.hasListeners&&this.unhook(r);const n=this.events.indexOf(r);this.events.splice(n,1)};return(0,D.toDisposable)((0,i.once)(a))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(l=>this.hook(l))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(l=>this.unhook(l))}hook(l){l.listener=l.event(r=>this.emitter.fire(r))}unhook(l){l.listener&&l.listener.dispose(),l.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=m;class w{constructor(){this.buffers=[]}wrapEvent(l){return(r,a,n)=>l(t=>{const s=this.buffers[this.buffers.length-1];s?s.push(()=>r.call(a,t)):r.call(a,t)},void 0,n)}bufferEvents(l){const r=[];this.buffers.push(r);const a=l();return this.buffers.pop(),r.forEach(n=>n()),a}}e.EventBufferer=w;class g{constructor(){this.listening=!1,this.inputEvent=R.None,this.inputEventListener=D.Disposable.None,this.emitter=new d({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(l){this.inputEvent=l,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=l(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=g}),define(te[27],ne([0,1,3]),function(Q,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const i=Object.freeze(function(R,E){const C=setTimeout(R.bind(E),0);return{dispose(){clearTimeout(C)}}});var D;(function(R){function E(C){return C===R.None||C===R.Cancelled||C instanceof _?!0:!C||typeof C!="object"?!1:typeof C.isCancellationRequested=="boolean"&&typeof C.onCancellationRequested=="function"}R.isCancellationToken=E,R.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:L.Event.None}),R.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:i})})(D=e.CancellationToken||(e.CancellationToken={}));class _{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?i:(this._emitter||(this._emitter=new L.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class k{constructor(E){this._token=void 0,this._parentListener=void 0,this._parentListener=E&&E.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new _),this._token}cancel(){this._token?this._token instanceof _&&this._token.cancel():this._token=D.Cancelled}dispose(E=!1){E&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof _&&this._token.dispose():this._token=D.None}}e.CancellationTokenSource=k}),define(te[49],ne([0,1,10,2]),function(Q,e,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function D(g){const c=g;return c?[c.on,c.pause,c.resume,c.destroy].every(l=>typeof l=="function"):!1}e.isReadableStream=D;function _(g){const c=g;return c?D(c.stream)&&Array.isArray(c.buffer)&&typeof c.ended=="boolean":!1}e.isReadableBufferedStream=_;function k(g,c){return new R(g,c)}e.newWriteableStream=k;class R{constructor(c,l){this.reducer=c,this.options=l,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(c){if(!this.state.destroyed){if(this.state.flowing)this.emitData(c);else if(this.buffer.data.push(c),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(l=>this.pendingWritePromises.push(l))}}error(c){this.state.destroyed||(this.state.flowing?this.emitError(c):this.buffer.error.push(c))}end(c){this.state.destroyed||(typeof c!="undefined"&&this.write(c),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(c){this.listeners.data.slice(0).forEach(l=>l(c))}emitError(c){this.listeners.error.length===0?(0,L.onUnexpectedError)(c):this.listeners.error.slice(0).forEach(l=>l(c))}emitEnd(){this.listeners.end.slice(0).forEach(c=>c())}on(c,l){if(!this.state.destroyed)switch(c){case"data":this.listeners.data.push(l),this.resume();break;case"end":this.listeners.end.push(l),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(l),this.state.flowing&&this.flowErrors();break}}removeListener(c,l){if(this.state.destroyed)return;let r;switch(c){case"data":r=this.listeners.data;break;case"end":r=this.listeners.end;break;case"error":r=this.listeners.error;break}if(r){const a=r.indexOf(l);a>=0&&r.splice(a,1)}}flowData(){if(this.buffer.data.length>0){const c=this.reducer(this.buffer.data);this.emitData(c),this.buffer.data.length=0;const l=[...this.pendingWritePromises];this.pendingWritePromises.length=0,l.forEach(r=>r())}}flowErrors(){if(this.listeners.error.length>0){for(const c of this.buffer.error)this.emitError(c);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function E(g,c){const l=[];let r;for(;(r=g.read())!==null;)l.push(r);return c(l)}e.consumeReadable=E;function C(g,c,l){const r=[];let a;for(;(a=g.read())!==null&&r.length<l;)r.push(a);return a===null&&r.length>0?c(r):{read:()=>{if(r.length>0)return r.shift();if(typeof a!="undefined"){const n=a;return a=void 0,n}return g.read()}}}e.peekReadable=C;function P(g,c){return new Promise((l,r)=>{const a=[];b(g,{onData:n=>{c&&a.push(n)},onError:n=>{c?r(n):l(void 0)},onEnd:()=>{l(c?c(a):void 0)}})})}e.consumeStream=P;function b(g,c){let l=!1;return g.on("error",r=>{l||c.onError(r)}),g.on("end",()=>{l||c.onEnd()}),g.on("data",r=>{l||c.onData(r)}),(0,i.toDisposable)(()=>l=!0)}e.listenStream=b;function d(g,c){return new Promise((l,r)=>{const a=new i.DisposableStore,n=[],t=u=>{if(n.push(u),n.length>c)return a.dispose(),g.pause(),l({stream:g,buffer:n,ended:!1})},s=u=>r(u),o=()=>l({stream:g,buffer:n,ended:!0});a.add((0,i.toDisposable)(()=>g.removeListener("error",s))),g.on("error",s),a.add((0,i.toDisposable)(()=>g.removeListener("end",o))),g.on("end",o),a.add((0,i.toDisposable)(()=>g.removeListener("data",t))),g.on("data",t)})}e.peekStream=d;function S(g,c){const l=k(c);return l.end(g),l}e.toStream=S;function h(){const g=k(()=>{throw new Error("not supported")});return g.end(),g}e.emptyStream=h;function y(g){let c=!1;return{read:()=>c?null:(c=!0,g)}}e.toReadable=y;function p(g,c,l){const r=k(l);return b(g,{onData:a=>r.write(c.data(a)),onError:a=>r.error(c.error?c.error(a):a),onEnd:()=>r.end()}),r}e.transform=p;function m(g,c,l){let r=!1;return{read:()=>{const a=c.read();return r?a:(r=!0,a!==null?l([g,a]):g)}}}e.prefixedReadable=m;function w(g,c,l){let r=!1;const a=k(l);return b(c,{onData:n=>r?a.write(n):(r=!0,a.write(l([g,n]))),onError:n=>a.error(n),onEnd:()=>{r||(r=!0,a.write(g)),a.end()}}),a}e.prefixedStream=w}),define(te[19],ne([0,1,49]),function(Q,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const i=typeof Buffer!="undefined";let D,_;class k{constructor(t){this.buffer=t,this.byteLength=this.buffer.byteLength}static alloc(t){return i?new k(Buffer.allocUnsafe(t)):new k(new Uint8Array(t))}static wrap(t){return i&&!Buffer.isBuffer(t)&&(t=Buffer.from(t.buffer,t.byteOffset,t.byteLength)),new k(t)}static fromString(t,s){return!(s?.dontUseNodeBuffer||!1)&&i?new k(Buffer.from(t)):(D||(D=new TextEncoder),new k(D.encode(t)))}static fromByteArray(t){const s=k.alloc(t.length);for(let o=0,u=t.length;o<u;o++)s.buffer[o]=t[o];return s}static concat(t,s){if(typeof s=="undefined"){s=0;for(let f=0,v=t.length;f<v;f++)s+=t[f].byteLength}const o=k.alloc(s);let u=0;for(let f=0,v=t.length;f<v;f++){const I=t[f];o.set(I,u),u+=I.byteLength}return o}clone(){const t=k.alloc(this.byteLength);return t.set(this),t}toString(){return i?this.buffer.toString():(_||(_=new TextDecoder),_.decode(this.buffer))}slice(t,s){return new k(this.buffer.subarray(t,s))}set(t,s){if(t instanceof k)this.buffer.set(t.buffer,s);else if(t instanceof Uint8Array)this.buffer.set(t,s);else if(t instanceof ArrayBuffer)this.buffer.set(new Uint8Array(t),s);else if(ArrayBuffer.isView(t))this.buffer.set(new Uint8Array(t.buffer,t.byteOffset,t.byteLength),s);else throw new Error("Unkown argument 'array'")}readUInt32BE(t){return C(this.buffer,t)}writeUInt32BE(t,s){P(this.buffer,t,s)}readUInt32LE(t){return b(this.buffer,t)}writeUInt32LE(t,s){d(this.buffer,t,s)}readUInt8(t){return S(this.buffer,t)}writeUInt8(t,s){h(this.buffer,t,s)}}e.VSBuffer=k;function R(n,t){return n[t+0]<<0>>>0|n[t+1]<<8>>>0}e.readUInt16LE=R;function E(n,t,s){n[s+0]=t&255,t=t>>>8,n[s+1]=t&255}e.writeUInt16LE=E;function C(n,t){return n[t]*2**24+n[t+1]*2**16+n[t+2]*2**8+n[t+3]}e.readUInt32BE=C;function P(n,t,s){n[s+3]=t,t=t>>>8,n[s+2]=t,t=t>>>8,n[s+1]=t,t=t>>>8,n[s]=t}e.writeUInt32BE=P;function b(n,t){return n[t+0]<<0>>>0|n[t+1]<<8>>>0|n[t+2]<<16>>>0|n[t+3]<<24>>>0}e.readUInt32LE=b;function d(n,t,s){n[s+0]=t&255,t=t>>>8,n[s+1]=t&255,t=t>>>8,n[s+2]=t&255,t=t>>>8,n[s+3]=t&255}e.writeUInt32LE=d;function S(n,t){return n[t]}e.readUInt8=S;function h(n,t,s){n[s]=t}e.writeUInt8=h;function y(n){return L.consumeReadable(n,t=>k.concat(t))}e.readableToBuffer=y;function p(n){return L.toReadable(n)}e.bufferToReadable=p;function m(n){return L.consumeStream(n,t=>k.concat(t))}e.streamToBuffer=m;async function w(n){return n.ended?k.concat(n.buffer):k.concat([...n.buffer,await m(n.stream)])}e.bufferedStreamToBuffer=w;function g(n){return L.toStream(n,t=>k.concat(t))}e.bufferToStream=g;function c(n){return L.transform(n,{data:t=>typeof t=="string"?k.fromString(t):k.wrap(t)},t=>k.concat(t))}e.streamToBufferReadableStream=c;function l(n){return L.newWriteableStream(t=>k.concat(t),n)}e.newWriteableBufferStream=l;function r(n,t){return L.prefixedReadable(n,t,s=>k.concat(s))}e.prefixedBufferReadable=r;function a(n,t){return L.prefixedStream(n,t,s=>k.concat(s))}e.prefixedBufferStream=a}),define(te[25],ne([0,1,4]),function(Q,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function i(X){return!X||typeof X!="string"?!0:X.trim().length===0}e.isFalsyOrWhitespace=i;const D=/{(\d+)}/g;function _(X,...oe){return oe.length===0?X:X.replace(D,function(ue,fe){const ye=parseInt(fe,10);return isNaN(ye)||ye<0||ye>=oe.length?ue:oe[ye]})}e.format=_;const k=/{([^}]+)}/g;function R(X,oe){return X.replace(k,(ue,fe)=>oe[fe]??ue)}e.format2=R;function E(X){return X.replace(/[<>&]/g,function(oe){switch(oe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return oe}})}e.escape=E;function C(X){return X.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=C;function P(X,oe){let ue=0;const fe=oe.charCodeAt(0);for(let ye=X.length-1;ye>=0;ye--)X.charCodeAt(ye)===fe&&ue++;return ue}e.count=P;function b(X,oe,ue="\u2026"){return X.length<=oe?X:`${X.substr(0,oe)}${ue}`}e.truncate=b;function d(X,oe=" "){const ue=S(X,oe);return h(ue,oe)}e.trim=d;function S(X,oe){if(!X||!oe)return X;const ue=oe.length;if(ue===0||X.length===0)return X;let fe=0;for(;X.indexOf(oe,fe)===fe;)fe=fe+ue;return X.substring(fe)}e.ltrim=S;function h(X,oe){if(!X||!oe)return X;const ue=oe.length,fe=X.length;if(ue===0||fe===0)return X;let ye=fe,pe=-1;for(;pe=X.lastIndexOf(oe,ye-1),!(pe===-1||pe+ue!==ye);){if(pe===0)return"";ye=pe}return X.substring(0,ye)}e.rtrim=h;function y(X){return X.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=y;function p(X){return X.replace(/\*/g,"")}e.stripWildcards=p;function m(X,oe,ue={}){if(!X)throw new Error("Cannot create regex from empty string");oe||(X=C(X)),ue.wholeWord&&(/\B/.test(X.charAt(0))||(X="\\b"+X),/\B/.test(X.charAt(X.length-1))||(X=X+"\\b"));let fe="";return ue.global&&(fe+="g"),ue.matchCase||(fe+="i"),ue.multiline&&(fe+="m"),ue.unicode&&(fe+="u"),new RegExp(X,fe)}e.createRegExp=m;function w(X){return X.source==="^"||X.source==="^$"||X.source==="$"||X.source==="^\\s*$"?!1:!!(X.exec("")&&X.lastIndex===0)}e.regExpLeadsToEndlessLoop=w;function g(X){return!!X.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=g;function c(X){return(X.global?"g":"")+(X.ignoreCase?"i":"")+(X.multiline?"m":"")+(X.unicode?"u":"")}e.regExpFlags=c;function l(X){return X.split(/\r\n|\r|\n/)}e.splitLines=l;function r(X){for(let oe=0,ue=X.length;oe<ue;oe++){const fe=X.charCodeAt(oe);if(fe!==32&&fe!==9)return oe}return-1}e.firstNonWhitespaceIndex=r;function a(X,oe=0,ue=X.length){for(let fe=oe;fe<ue;fe++){const ye=X.charCodeAt(fe);if(ye!==32&&ye!==9)return X.substring(oe,fe)}return X.substring(oe,ue)}e.getLeadingWhitespace=a;function n(X,oe=X.length-1){for(let ue=oe;ue>=0;ue--){const fe=X.charCodeAt(ue);if(fe!==32&&fe!==9)return ue}return-1}e.lastNonWhitespaceIndex=n;function t(X,oe){return X<oe?-1:X>oe?1:0}e.compare=t;function s(X,oe,ue=0,fe=X.length,ye=0,pe=oe.length){for(;ue<fe&&ye<pe;ue++,ye++){let De=X.charCodeAt(ue),_e=oe.charCodeAt(ye);if(De<_e)return-1;if(De>_e)return 1}const Ce=fe-ue,Pe=pe-ye;return Ce<Pe?-1:Ce>Pe?1:0}e.compareSubstring=s;function o(X,oe){return u(X,oe,0,X.length,0,oe.length)}e.compareIgnoreCase=o;function u(X,oe,ue=0,fe=X.length,ye=0,pe=oe.length){for(;ue<fe&&ye<pe;ue++,ye++){let De=X.charCodeAt(ue),_e=oe.charCodeAt(ye);if(De===_e)continue;if(De>=128||_e>=128)return s(X.toLowerCase(),oe.toLowerCase(),ue,fe,ye,pe);f(De)&&(De-=32),f(_e)&&(_e-=32);const qe=De-_e;if(qe!==0)return qe}const Ce=fe-ue,Pe=pe-ye;return Ce<Pe?-1:Ce>Pe?1:0}e.compareSubstringIgnoreCase=u;function f(X){return X>=97&&X<=122}e.isLowerAsciiLetter=f;function v(X){return X>=65&&X<=90}e.isUpperAsciiLetter=v;function I(X,oe){return X.length===oe.length&&u(X,oe)===0}e.equalsIgnoreCase=I;function O(X,oe){const ue=oe.length;return oe.length>X.length?!1:u(X,oe,0,ue)===0}e.startsWithIgnoreCase=O;function A(X,oe){let ue,fe=Math.min(X.length,oe.length);for(ue=0;ue<fe;ue++)if(X.charCodeAt(ue)!==oe.charCodeAt(ue))return ue;return fe}e.commonPrefixLength=A;function N(X,oe){let ue,fe=Math.min(X.length,oe.length);const ye=X.length-1,pe=oe.length-1;for(ue=0;ue<fe;ue++)if(X.charCodeAt(ye-ue)!==oe.charCodeAt(pe-ue))return ue;return fe}e.commonSuffixLength=N;function $(X){return 55296<=X&&X<=56319}e.isHighSurrogate=$;function T(X){return 56320<=X&&X<=57343}e.isLowSurrogate=T;function F(X,oe){return(X-55296<<10)+(oe-56320)+65536}e.computeCodePoint=F;function M(X,oe,ue){const fe=X.charCodeAt(ue);if($(fe)&&ue+1<oe){const ye=X.charCodeAt(ue+1);if(T(ye))return F(fe,ye)}return fe}e.getNextCodePoint=M;function U(X,oe){const ue=X.charCodeAt(oe-1);if(T(ue)&&oe>1){const fe=X.charCodeAt(oe-2);if($(fe))return F(fe,ue)}return ue}function B(X,oe){const ue=ae.getInstance(),fe=oe,ye=X.length,pe=M(X,ye,oe);oe+=pe>=65536?2:1;let Ce=ue.getGraphemeBreakType(pe);for(;oe<ye;){const Pe=M(X,ye,oe),De=ue.getGraphemeBreakType(Pe);if(ze(Ce,De))break;oe+=Pe>=65536?2:1,Ce=De}return oe-fe}e.nextCharLength=B;function ee(X,oe){const ue=ae.getInstance(),fe=oe,ye=U(X,oe);oe-=ye>=65536?2:1;let pe=ue.getGraphemeBreakType(ye);for(;oe>0;){const Ce=U(X,oe),Pe=ue.getGraphemeBreakType(Ce);if(ze(Pe,pe))break;oe-=Ce>=65536?2:1,pe=Pe}return fe-oe}e.prevCharLength=ee;function H(X,oe){const ue=ae.getInstance(),fe=X.length,ye=oe,pe=M(X,fe,oe),Ce=ue.getGraphemeBreakType(pe);oe+=pe>=65536?2:1;let Pe=Ce;for(;oe<fe;){const _e=M(X,fe,oe),qe=ue.getGraphemeBreakType(_e);if(ze(Pe,qe))break;oe+=_e>=65536?2:1,Pe=qe}const De=oe;for(oe=ye,Pe=Ce;oe>0;){const _e=U(X,oe),qe=ue.getGraphemeBreakType(_e);if(ze(qe,Pe))break;oe-=_e>=65536?2:1,Pe=qe}return[oe,De]}function j(X,oe){return oe>0&&T(X.charCodeAt(oe))?H(X,oe-1):H(X,oe)}e.getCharContainingOffset=j;const Z=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function W(X){return Z.test(X)}e.containsRTL=W;const z=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFF0]|\uD83E[\uDD00-\uDDFF\uDE70-\uDEF6])/;function V(X){return z.test(X)}e.containsEmoji=V;const q=/^[\t\n\r\x20-\x7E]*$/;function G(X){return q.test(X)}e.isBasicASCII=G,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Y(X){return e.UNUSUAL_LINE_TERMINATORS.test(X)}e.containsUnusualLineTerminators=Y;function x(X){for(let oe=0,ue=X.length;oe<ue;oe++)if(K(X.charCodeAt(oe)))return!0;return!1}e.containsFullWidthCharacter=x;function K(X){return X>=11904&&X<=55215||X>=63744&&X<=64255||X>=65281&&X<=65374}e.isFullWidthCharacter=K;function re(X){return X>=127462&&X<=127487||X===8986||X===8987||X===9200||X===9203||X>=9728&&X<=10175||X===11088||X===11093||X>=127744&&X<=128591||X>=128640&&X<=128764||X>=128992&&X<=129008||X>=129280&&X<=129535||X>=129648&&X<=129782}e.isEmojiImprecise=re;function se(X,oe){if(X.length<oe)return X;const ue=/\b/g;let fe=0;for(;ue.test(X)&&!(X.length-ue.lastIndex<oe);)fe=ue.lastIndex,ue.lastIndex+=1;return X.substring(fe).replace(/^\s/,"")}e.lcut=se;const ce=/\x1B\x5B[12]?K/g,he=/\x1b\[\d+m/g,me=/\x1b\[0?m/g;function ve(X){return X&&(X=X.replace(ce,""),X=X.replace(he,""),X=X.replace(me,"")),X}e.removeAnsiEscapeCodes=ve,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ge(X){return!!(X&&X.length>0&&X.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ge;function we(X){return ge(X)?X.substr(1):X}e.stripUTF8BOM=we;function Re(X,oe){if(!X||!oe||X.length<oe.length)return!1;const ue=oe.length,fe=X.toLowerCase();let ye=0,pe=-1;for(;ye<ue;){const Ce=fe.indexOf(oe[ye],pe+1);if(Ce<0)return!1;pe=Ce,ye++}return!0}e.fuzzyContains=Re;function Ee(X,oe=!1){return X?(oe&&(X=X.replace(/\\./g,"")),X.toLowerCase()!==X):!1}e.containsUppercaseCharacter=Ee;function ke(X){return X.charAt(0).toUpperCase()+X.slice(1)}e.uppercaseFirstLetter=ke;function Le(X,oe=1){if(oe===0)return"";let ue=-1;do ue=X.indexOf(`
`,ue+1),oe--;while(oe>0&&ue>=0);return ue===-1?X:(X[ue-1]==="\r"&&ue--,X.substr(0,ue))}e.getNLines=Le;function Fe(X){const oe=90-65+1;return X=X%(2*oe),X<oe?String.fromCharCode(97+X):String.fromCharCode(65+X-oe)}e.singleLetterHash=Fe;function $e(X){return ae.getInstance().getGraphemeBreakType(X)}e.getGraphemeBreakType=$e;function ze(X,oe){return X===0?oe!==5&&oe!==7:X===2&&oe===3?!1:X===4||X===2||X===3||oe===4||oe===2||oe===3?!0:!(X===8&&(oe===8||oe===9||oe===11||oe===12)||(X===11||X===9)&&(oe===9||oe===10)||(X===12||X===10)&&oe===10||oe===5||oe===13||oe===7||X===1||X===13&&oe===14||X===6&&oe===6)}e.breakBetweenGraphemeBreakType=ze;var ie;(function(X){X[X.Other=0]="Other",X[X.Prepend=1]="Prepend",X[X.CR=2]="CR",X[X.LF=3]="LF",X[X.Control=4]="Control",X[X.Extend=5]="Extend",X[X.Regional_Indicator=6]="Regional_Indicator",X[X.SpacingMark=7]="SpacingMark",X[X.L=8]="L",X[X.V=9]="V",X[X.T=10]="T",X[X.LV=11]="LV",X[X.LVT=12]="LVT",X[X.ZWJ=13]="ZWJ",X[X.Extended_Pictographic=14]="Extended_Pictographic"})(ie=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ae{constructor(){this._data=le()}static getInstance(){return ae._INSTANCE||(ae._INSTANCE=new ae),ae._INSTANCE}getGraphemeBreakType(oe){if(oe<32)return oe===10?3:oe===13?2:4;if(oe<127)return 0;const ue=this._data,fe=ue.length/3;let ye=1;for(;ye<=fe;)if(oe<ue[3*ye])ye=2*ye;else if(oe>ue[3*ye+1])ye=2*ye+1;else return ue[3*ye+2];return 0}}ae._INSTANCE=null;function le(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function be(X,oe){if(X===0)return 0;const ue=Ie(X,oe);if(ue!==void 0)return ue;const fe=U(oe,X);return X-=Me(fe),X}e.getLeftDeleteOffset=be;function Ie(X,oe){let ue=U(oe,X);for(X-=Me(ue);Te(ue)||ue===65039||ue===8419;){if(X===0)return;ue=U(oe,X),X-=Me(ue)}if(!!re(ue)){if(X>=0){const fe=U(oe,X);fe===8205&&(X-=Me(fe))}return X}}function Me(X){return X>=65536?2:1}function Te(X){return 127995<=X&&X<=127999}var Ne;(function(X){X[X.zwj=8205]="zwj",X[X.emojiVariantSelector=65039]="emojiVariantSelector",X[X.enclosingKeyCap=8419]="enclosingKeyCap"})(Ne||(Ne={})),e.noBreakWhitespace="\xA0";class Ae{static getData(){return JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,40,10088,40,10098,40,12308,40,64830,40,65341,41,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,124,8739,124,9213,124,65512,124,1633,124,1777,124,66336,124,125127,124,120783,124,120793,124,120803,124,120813,124,120823,124,130033,124,65321,124,8544,124,8464,124,8465,124,119816,124,119868,124,119920,124,120024,124,120128,124,120180,124,120232,124,120284,124,120336,124,120388,124,120440,124,406,124,65356,124,8572,124,8467,124,119845,124,119897,124,119949,124,120001,124,120053,124,120105,124,120157,124,120209,124,120261,124,120313,124,120365,124,120417,124,120469,124,448,124,120496,124,120554,124,120612,124,120670,124,120728,124,11410,124,1030,124,1216,124,1493,124,1503,124,1575,124,126464,124,126592,124,65166,124,65165,124,1994,124,11599,124,5825,124,42226,124,93992,124,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90],"_default":[160,32,8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"cs":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89],"de":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89],"es":[8211,45,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"fr":[65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"it":[160,32,8211,45,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"ko":[8211,45,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"pl":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"pt-BR":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"qps-ploc":[160,32,8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"ru":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,124,1009,112,215,120],"tr":[160,32,8211,45,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"zh-hans":[65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"zh-hant":[8211,45,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89]}')}static getConfusablesForCurrentLocale(){if(!Ae.map){let fe=function(Ce){const Pe=new Map;for(let De=0;De<Ce.length;De+=2)Pe.set(Ce[De],Ce[De+1]);return Pe};const oe=Ae.getData();let ue=L.locale;(!ue||!(ue in oe))&&(ue=L.language),(!ue||!(ue in oe))&&(ue="_default");const ye=fe(oe._common),pe=fe(oe[ue]);for(const[Ce,Pe]of pe)ye.set(Ce,Pe);Ae.map=ye}return Ae.map}static isAmbiguous(oe){return Ae.getConfusablesForCurrentLocale().has(oe)}static getPrimaryConfusable(oe){return Ae.getConfusablesForCurrentLocale().get(oe)}static getPrimaryConfusableCodePoints(){return new Set(Ae.getConfusablesForCurrentLocale().keys())}}e.AmbiguousCharacters=Ae;class Ue{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Ue.getRawData())),this._data}static isInvisibleCharacter(oe){return Ue.getData().has(oe)}static get codePoints(){return Ue.getData()}}e.InvisibleCharacters=Ue,Ue._data=void 0}),define(te[104],ne([0,1,25]),function(Q,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function i(m){return D(m,0)}e.hash=i;function D(m,w){switch(typeof m){case"object":return m===null?_(349,w):Array.isArray(m)?E(m,w):C(m,w);case"string":return R(m,w);case"boolean":return k(m,w);case"number":return _(m,w);case"undefined":return _(937,w);default:return _(617,w)}}e.doHash=D;function _(m,w){return(w<<5)-w+m|0}e.numberHash=_;function k(m,w){return _(m?433:863,w)}function R(m,w){w=_(149417,w);for(let g=0,c=m.length;g<c;g++)w=_(m.charCodeAt(g),w);return w}e.stringHash=R;function E(m,w){return w=_(104579,w),m.reduce((g,c)=>D(c,g),w)}function C(m,w){return w=_(181387,w),Object.keys(m).sort().reduce((g,c)=>(g=R(c,g),D(m[c],g)),w)}class P{constructor(){this._value=0}get value(){return this._value}hash(w){return this._value=D(w,this._value),this._value}}e.Hasher=P;var b;(function(m){m[m.BLOCK_SIZE=64]="BLOCK_SIZE",m[m.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(b||(b={}));function d(m,w,g=32){const c=g-w,l=~((1<<c)-1);return(m<<w|(l&m)>>>c)>>>0}function S(m,w=0,g=m.byteLength,c=0){for(let l=0;l<g;l++)m[w+l]=c}function h(m,w,g="0"){for(;m.length<w;)m=g+m;return m}function y(m,w=32){return m instanceof ArrayBuffer?Array.from(new Uint8Array(m)).map(g=>g.toString(16).padStart(2,"0")).join(""):h((m>>>0).toString(16),w/4)}e.toHexString=y;class p{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(w){const g=w.length;if(g===0)return;const c=this._buff;let l=this._buffLen,r=this._leftoverHighSurrogate,a,n;for(r!==0?(a=r,n=-1,r=0):(a=w.charCodeAt(0),n=0);;){let t=a;if(L.isHighSurrogate(a))if(n+1<g){const s=w.charCodeAt(n+1);L.isLowSurrogate(s)?(n++,t=L.computeCodePoint(a,s)):t=65533}else{r=a;break}else L.isLowSurrogate(a)&&(t=65533);if(l=this._push(c,l,t),n++,n<g)a=w.charCodeAt(n);else break}this._buffLen=l,this._leftoverHighSurrogate=r}_push(w,g,c){return c<128?w[g++]=c:c<2048?(w[g++]=192|(c&1984)>>>6,w[g++]=128|(c&63)>>>0):c<65536?(w[g++]=224|(c&61440)>>>12,w[g++]=128|(c&4032)>>>6,w[g++]=128|(c&63)>>>0):(w[g++]=240|(c&1835008)>>>18,w[g++]=128|(c&258048)>>>12,w[g++]=128|(c&4032)>>>6,w[g++]=128|(c&63)>>>0),g>=64&&(this._step(),g-=64,this._totalLen+=64,w[0]=w[64+0],w[1]=w[64+1],w[2]=w[64+2]),g}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),y(this._h0)+y(this._h1)+y(this._h2)+y(this._h3)+y(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,S(this._buff,this._buffLen),this._buffLen>56&&(this._step(),S(this._buff));const w=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(w/4294967296),!1),this._buffDV.setUint32(60,w%4294967296,!1),this._step()}_step(){const w=p._bigBlock32,g=this._buffDV;for(let u=0;u<64;u+=4)w.setUint32(u,g.getUint32(u,!1),!1);for(let u=64;u<320;u+=4)w.setUint32(u,d(w.getUint32(u-12,!1)^w.getUint32(u-32,!1)^w.getUint32(u-56,!1)^w.getUint32(u-64,!1),1),!1);let c=this._h0,l=this._h1,r=this._h2,a=this._h3,n=this._h4,t,s,o;for(let u=0;u<80;u++)u<20?(t=l&r|~l&a,s=1518500249):u<40?(t=l^r^a,s=1859775393):u<60?(t=l&r|l&a|r&a,s=2400959708):(t=l^r^a,s=3395469782),o=d(c,5)+t+n+s+w.getUint32(u*4,!1)&4294967295,n=a,a=r,r=d(l,30),l=c,c=o;this._h0=this._h0+c&4294967295,this._h1=this._h1+l&4294967295,this._h2=this._h2+r&4294967295,this._h3=this._h3+a&4294967295,this._h4=this._h4+n&4294967295}}e.StringSHA1=p,p._bigBlock32=new DataView(new ArrayBuffer(320))});var bt=this&&this.__classPrivateFieldSet||function(Q,e,L,i,D){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!D:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?D.call(Q,L):D?D.value=L:e.set(Q,L),L},Ve=this&&this.__classPrivateFieldGet||function(Q,e,L,i){if(L==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!i:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return L==="m"?i:L==="a"?i.call(Q):i?i.value:e.get(Q)};define(te[39],ne([0,1,16,25]),function(Q,e,L,i){"use strict";var D,_,k;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function R(n,t,s){let o=n.get(t);return o===void 0&&(o=s,n.set(t,o)),o}e.getOrSet=R;function E(n){const t=[];return n.forEach((s,o)=>{t.push(`${o} => ${s}`)}),`Map(${n.size}) {${t.join(", ")}}`}e.mapToString=E;function C(n){const t=[];return n.forEach(s=>{t.push(s)}),`Set(${n.size}) {${t.join(", ")}}`}e.setToString=C;class P{constructor(){this._value="",this._pos=0}reset(t){return this._value=t,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(t){const s=t.charCodeAt(0),o=this._value.charCodeAt(this._pos);return s-o}value(){return this._value[this._pos]}}e.StringIterator=P;class b{constructor(t=!0){this._caseSensitive=t}reset(t){return this._value=t,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let t=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(t)this._from++;else break;else t=!1;return this}cmp(t){return this._caseSensitive?(0,i.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,i.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=b;class d{constructor(t=!0,s=!0){this._splitOnBackslash=t,this._caseSensitive=s}reset(t){this._from=0,this._to=0,this._value=t,this._valueLen=t.length;for(let s=t.length-1;s>=0;s--,this._valueLen--){const o=this._value.charCodeAt(s);if(!(o===47||this._splitOnBackslash&&o===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let t=!0;for(;this._to<this._valueLen;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(t)this._from++;else break;else t=!1}return this}cmp(t){return this._caseSensitive?(0,i.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,i.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=d;var S;(function(n){n[n.Scheme=1]="Scheme",n[n.Authority=2]="Authority",n[n.Path=3]="Path",n[n.Query=4]="Query",n[n.Fragment=5]="Fragment"})(S||(S={}));class h{constructor(t){this._ignorePathCasing=t,this._states=[],this._stateIdx=0}reset(t){return this._value=t,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new d(!1,!this._ignorePathCasing(t)),this._pathIterator.reset(t.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(t){if(this._states[this._stateIdx]===1)return(0,i.compareIgnoreCase)(t,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,i.compareIgnoreCase)(t,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(t);if(this._states[this._stateIdx]===4)return(0,i.compare)(t,this._value.query);if(this._states[this._stateIdx]===5)return(0,i.compare)(t,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=h;class y{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const t=this.right;return this.right=t.left,t.left=this,this.updateHeight(),t.updateHeight(),t}rotateRight(){const t=this.left;return this.left=t.right,t.right=this,this.updateHeight(),t.updateHeight(),t}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var p;(function(n){n[n.Left=-1]="Left",n[n.Mid=0]="Mid",n[n.Right=1]="Right"})(p||(p={}));class m{constructor(t){this._iter=t}static forUris(t=()=>!1){return new m(new h(t))}static forPaths(){return new m(new d)}static forStrings(){return new m(new P)}static forConfigKeys(){return new m(new b)}clear(){this._root=void 0}fill(t,s){if(s){const o=s.slice(0);(0,L.shuffle)(o);for(let u of o)this.set(u,t)}else{const o=t.slice(0);(0,L.shuffle)(o);for(let u of o)this.set(u[0],u[1])}}set(t,s){const o=this._iter.reset(t);let u;this._root||(this._root=new y,this._root.segment=o.value());const f=[];for(u=this._root;;){const I=o.cmp(u.segment);if(I>0)u.left||(u.left=new y,u.left.segment=o.value()),f.push([-1,u]),u=u.left;else if(I<0)u.right||(u.right=new y,u.right.segment=o.value()),f.push([1,u]),u=u.right;else if(o.hasNext())o.next(),u.mid||(u.mid=new y,u.mid.segment=o.value()),f.push([0,u]),u=u.mid;else break}const v=u.value;u.value=s,u.key=t;for(let I=f.length-1;I>=0;I--){const O=f[I][1];O.updateHeight();const A=O.balanceFactor();if(A<-1||A>1){const N=f[I][0],$=f[I+1][0];if(N===1&&$===1)f[I][1]=O.rotateLeft();else if(N===-1&&$===-1)f[I][1]=O.rotateRight();else if(N===1&&$===-1)O.right=f[I+1][1]=f[I+1][1].rotateRight(),f[I][1]=O.rotateLeft();else if(N===-1&&$===1)O.left=f[I+1][1]=f[I+1][1].rotateLeft(),f[I][1]=O.rotateRight();else throw new Error;if(I>0)switch(f[I-1][0]){case-1:f[I-1][1].left=f[I][1];break;case 1:f[I-1][1].right=f[I][1];break;case 0:f[I-1][1].mid=f[I][1];break}else this._root=f[0][1]}}return v}get(t){return this._getNode(t)?.value}_getNode(t){const s=this._iter.reset(t);let o=this._root;for(;o;){const u=s.cmp(o.segment);if(u>0)o=o.left;else if(u<0)o=o.right;else if(s.hasNext())s.next(),o=o.mid;else break}return o}has(t){const s=this._getNode(t);return!(s?.value===void 0&&s?.mid===void 0)}delete(t){return this._delete(t,!1)}deleteSuperstr(t){return this._delete(t,!0)}_delete(t,s){const o=this._iter.reset(t),u=[];let f=this._root;for(;f;){const v=o.cmp(f.segment);if(v>0)u.push([-1,f]),f=f.left;else if(v<0)u.push([1,f]),f=f.right;else if(o.hasNext())o.next(),u.push([0,f]),f=f.mid;else break}if(!!f){if(s?(f.left=void 0,f.mid=void 0,f.right=void 0,f.height=1):(f.key=void 0,f.value=void 0),!f.mid&&!f.value)if(f.left&&f.right){const v=this._min(f.right),{key:I,value:O,segment:A}=v;this._delete(v.key,!1),f.key=I,f.value=O,f.segment=A}else{const v=f.left??f.right;if(u.length>0){const[I,O]=u[u.length-1];switch(I){case-1:O.left=v;break;case 0:O.mid=v;break;case 1:O.right=v;break}}else this._root=v}for(let v=u.length-1;v>=0;v--){const I=u[v][1];I.updateHeight();const O=I.balanceFactor();if(O>1?(I.right.balanceFactor()>=0||(I.right=I.right.rotateRight()),u[v][1]=I.rotateLeft()):O<-1&&(I.left.balanceFactor()<=0||(I.left=I.left.rotateLeft()),u[v][1]=I.rotateRight()),v>0)switch(u[v-1][0]){case-1:u[v-1][1].left=u[v][1];break;case 1:u[v-1][1].right=u[v][1];break;case 0:u[v-1][1].mid=u[v][1];break}else this._root=u[0][1]}}}_min(t){for(;t.left;)t=t.left;return t}findSubstr(t){const s=this._iter.reset(t);let o=this._root,u;for(;o;){const f=s.cmp(o.segment);if(f>0)o=o.left;else if(f<0)o=o.right;else if(s.hasNext())s.next(),u=o.value||u,o=o.mid;else break}return o&&o.value||u}findSuperstr(t){const s=this._iter.reset(t);let o=this._root;for(;o;){const u=s.cmp(o.segment);if(u>0)o=o.left;else if(u<0)o=o.right;else if(s.hasNext())s.next(),o=o.mid;else return o.mid?this._entries(o.mid):void 0}}forEach(t){for(const[s,o]of this)t(o,s)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(t){!t||(t.left&&(yield*this._entries(t.left)),t.value&&(yield[t.key,t.value]),t.mid&&(yield*this._entries(t.mid)),t.right&&(yield*this._entries(t.right)))}_isBalanced(){const t=s=>{if(!s)return!0;const o=s.balanceFactor();return o<-1||o>1?!1:t(s.left)&&t(s.right)};return t(this._root)}}e.TernarySearchTree=m;class w{constructor(t,s){this.uri=t,this.value=s}}class g{constructor(t,s){this[D]="ResourceMap",t instanceof g?(this.map=new Map(t.map),this.toKey=s??g.defaultToKey):(this.map=new Map,this.toKey=t??g.defaultToKey)}set(t,s){return this.map.set(this.toKey(t),new w(t,s)),this}get(t){return this.map.get(this.toKey(t))?.value}has(t){return this.map.has(this.toKey(t))}get size(){return this.map.size}clear(){this.map.clear()}delete(t){return this.map.delete(this.toKey(t))}forEach(t,s){typeof s!="undefined"&&(t=t.bind(s));for(let[o,u]of this.map)t(u.value,u.uri,this)}*values(){for(let t of this.map.values())yield t.value}*keys(){for(let t of this.map.values())yield t.uri}*entries(){for(let t of this.map.values())yield[t.uri,t.value]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(let[,t]of this.map)yield[t.uri,t.value]}}e.ResourceMap=g,g.defaultToKey=n=>n.toString();var c;(function(n){n[n.None=0]="None",n[n.AsOld=1]="AsOld",n[n.AsNew=2]="AsNew"})(c=e.Touch||(e.Touch={}));class l{constructor(){this[_]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(t){return this._map.has(t)}get(t,s=0){const o=this._map.get(t);if(!!o)return s!==0&&this.touch(o,s),o.value}set(t,s,o=0){let u=this._map.get(t);if(u)u.value=s,o!==0&&this.touch(u,o);else{switch(u={key:t,value:s,next:void 0,previous:void 0},o){case 0:this.addItemLast(u);break;case 1:this.addItemFirst(u);break;case 2:this.addItemLast(u);break;default:this.addItemLast(u);break}this._map.set(t,u),this._size++}return this}delete(t){return!!this.remove(t)}remove(t){const s=this._map.get(t);if(!!s)return this._map.delete(t),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const t=this._head;return this._map.delete(t.key),this.removeItem(t),this._size--,t.value}forEach(t,s){const o=this._state;let u=this._head;for(;u;){if(s?t.bind(s)(u.value,u.key,this):t(u.value,u.key,this),this._state!==o)throw new Error("LinkedMap got modified during iteration.");u=u.next}}keys(){const t=this,s=this._state;let o=this._head;const u={[Symbol.iterator](){return u},next(){if(t._state!==s)throw new Error("LinkedMap got modified during iteration.");if(o){const f={value:o.key,done:!1};return o=o.next,f}else return{value:void 0,done:!0}}};return u}values(){const t=this,s=this._state;let o=this._head;const u={[Symbol.iterator](){return u},next(){if(t._state!==s)throw new Error("LinkedMap got modified during iteration.");if(o){const f={value:o.value,done:!1};return o=o.next,f}else return{value:void 0,done:!0}}};return u}entries(){const t=this,s=this._state;let o=this._head;const u={[Symbol.iterator](){return u},next(){if(t._state!==s)throw new Error("LinkedMap got modified during iteration.");if(o){const f={value:[o.key,o.value],done:!1};return o=o.next,f}else return{value:void 0,done:!0}}};return u}[(_=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(t){if(t>=this.size)return;if(t===0){this.clear();return}let s=this._head,o=this.size;for(;s&&o>t;)this._map.delete(s.key),s=s.next,o--;this._head=s,this._size=o,s&&(s.previous=void 0),this._state++}addItemFirst(t){if(!this._head&&!this._tail)this._tail=t;else if(this._head)t.next=this._head,this._head.previous=t;else throw new Error("Invalid list");this._head=t,this._state++}addItemLast(t){if(!this._head&&!this._tail)this._head=t;else if(this._tail)t.previous=this._tail,this._tail.next=t;else throw new Error("Invalid list");this._tail=t,this._state++}removeItem(t){if(t===this._head&&t===this._tail)this._head=void 0,this._tail=void 0;else if(t===this._head){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this._head=t.next}else if(t===this._tail){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this._tail=t.previous}else{const s=t.next,o=t.previous;if(!s||!o)throw new Error("Invalid list");s.previous=o,o.next=s}t.next=void 0,t.previous=void 0,this._state++}touch(t,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(t===this._head)return;const o=t.next,u=t.previous;t===this._tail?(u.next=void 0,this._tail=u):(o.previous=u,u.next=o),t.previous=void 0,t.next=this._head,this._head.previous=t,this._head=t,this._state++}else if(s===2){if(t===this._tail)return;const o=t.next,u=t.previous;t===this._head?(o.previous=void 0,this._head=o):(o.previous=u,u.next=o),t.next=void 0,t.previous=this._tail,this._tail.next=t,this._tail=t,this._state++}}}toJSON(){const t=[];return this.forEach((s,o)=>{t.push([o,s])}),t}fromJSON(t){this.clear();for(const[s,o]of t)this.set(s,o)}}e.LinkedMap=l;class r extends l{constructor(t,s=1){super();this._limit=t,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(t){this._limit=t,this.checkTrim()}get ratio(){return this._ratio}set ratio(t){this._ratio=Math.min(Math.max(0,t),1),this.checkTrim()}get(t,s=2){return super.get(t,s)}peek(t){return super.get(t,0)}set(t,s){return super.set(t,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=r;class a{constructor(t){k.set(this,void 0),bt(this,k,t,"f")}get size(){return Ve(this,k,"f").size}forEach(t,s){Ve(this,k,"f").forEach(t,s)}get(t){return Ve(this,k,"f").get(t)}has(t){return Ve(this,k,"f").has(t)}entries(){return Ve(this,k,"f").entries()}keys(){return Ve(this,k,"f").keys()}values(){return Ve(this,k,"f").values()}[(k=new WeakMap,Symbol.iterator)](){return Ve(this,k,"f").entries()}}e.ReadonlyMapView=a}),define(te[69],ne([0,1,39]),function(Q,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const i=new L.LRUCache(1e4);function D(C){return E(C,"NFC",i)}e.normalizeNFC=D;const _=new L.LRUCache(1e4);function k(C){return E(C,"NFD",_)}e.normalizeNFD=k;const R=/[^\u0000-\u0080]/;function E(C,P,b){if(!C)return C;const d=b.get(C);if(d)return d;let S;return R.test(C)?S=C.normalize(P):S=C,b.set(C,S),S}e.removeAccents=function(){const C=/[\u0300-\u036f]/g;return function(P){return k(P).replace(C,"")}}()}),define(te[15],ne([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function L(f){return Array.isArray(f)}e.isArray=L;function i(f){return typeof f=="string"}e.isString=i;function D(f){return Array.isArray(f)&&f.every(v=>i(v))}e.isStringArray=D;function _(f){return typeof f=="object"&&f!==null&&!Array.isArray(f)&&!(f instanceof RegExp)&&!(f instanceof Date)}e.isObject=_;function k(f){return typeof f=="number"&&!isNaN(f)}e.isNumber=k;function R(f){return!!f&&typeof f[Symbol.iterator]=="function"}e.isIterable=R;function E(f){return f===!0||f===!1}e.isBoolean=E;function C(f){return typeof f=="undefined"}e.isUndefined=C;function P(f){return!b(f)}e.isDefined=P;function b(f){return C(f)||f===null}e.isUndefinedOrNull=b;function d(f,v){if(!f)throw new Error(v?`Unexpected type, expected '${v}'`:"Unexpected type")}e.assertType=d;function S(f){if(b(f))throw new Error("Assertion Failed: argument is undefined or null");return f}e.assertIsDefined=S;function h(...f){const v=[];for(let I=0;I<f.length;I++){const O=f[I];if(b(O))throw new Error(`Assertion Failed: argument at index ${I} is undefined or null`);v.push(O)}return v}e.assertAllDefined=h;const y=Object.prototype.hasOwnProperty;function p(f){if(!_(f))return!1;for(let v in f)if(y.call(f,v))return!1;return!0}e.isEmptyObject=p;function m(f){return typeof f=="function"}e.isFunction=m;function w(...f){return f.length>0&&f.every(m)}e.areFunctions=w;function g(f,v){const I=Math.min(f.length,v.length);for(let O=0;O<I;O++)c(f[O],v[O])}e.validateConstraints=g;function c(f,v){if(i(v)){if(typeof f!==v)throw new Error(`argument does not match constraint: typeof ${v}`)}else if(m(v)){try{if(f instanceof v)return}catch{}if(!b(f)&&f.constructor===v||v.length===1&&v.call(void 0,f)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=c;function l(f){let v=[],I=Object.getPrototypeOf(f);for(;Object.prototype!==I;)v=v.concat(Object.getOwnPropertyNames(I)),I=Object.getPrototypeOf(I);return v}e.getAllPropertyNames=l;function r(f){const v=[];for(const I of l(f))typeof f[I]=="function"&&v.push(I);return v}e.getAllMethodNames=r;function a(f,v){const I=A=>function(){const N=Array.prototype.slice.call(arguments,0);return v(A,N)};let O={};for(const A of f)O[A]=I(A);return O}e.createProxyObject=a;function n(f){return f===null?void 0:f}e.withNullAsUndefined=n;function t(f){return typeof f=="undefined"?null:f}e.withUndefinedAsNull=t;function s(f){return class{constructor(){return new Proxy({},{get(v,I){if(v[I])return v[I];throw new Error(`Not Implemented: ${f}->${String(I)}`)}})}}}e.NotImplementedProxy=s;function o(f,v="Unreachable"){throw new Error(v)}e.assertNever=o;function u(f){return!!f&&typeof f.then=="function"&&typeof f.catch=="function"}e.isPromise=u}),define(te[40],ne([0,1,9,4,25,15]),function(Q,e,L,i,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function k(n){return n===47||n===92}e.isPathSeparator=k;function R(n){return n.replace(/[\\/]/g,L.posix.sep)}e.toSlashes=R;function E(n){return n.indexOf("/")===-1&&(n=R(n)),/^[a-zA-Z]:(\/|$)/.test(n)&&(n="/"+n),n}e.toPosixPath=E;function C(n,t=L.posix.sep){if(!n)return"";const s=n.length,o=n.charCodeAt(0);if(k(o)){if(k(n.charCodeAt(1))&&!k(n.charCodeAt(2))){let f=3;const v=f;for(;f<s&&!k(n.charCodeAt(f));f++);if(v!==f&&!k(n.charCodeAt(f+1))){for(f+=1;f<s;f++)if(k(n.charCodeAt(f)))return n.slice(0,f+1).replace(/[\\/]/g,t)}}return t}else if(m(o)&&n.charCodeAt(1)===58)return k(n.charCodeAt(2))?n.slice(0,2)+t:n.slice(0,2);let u=n.indexOf("://");if(u!==-1){for(u+=3;u<s;u++)if(k(n.charCodeAt(u)))return n.slice(0,u+1)}return""}e.getRoot=C;function P(n){if(!i.isWindows||!n||n.length<5)return!1;let t=n.charCodeAt(0);if(t!==92||(t=n.charCodeAt(1),t!==92))return!1;let s=2;const o=s;for(;s<n.length&&(t=n.charCodeAt(s),t!==92);s++);return!(o===s||(t=n.charCodeAt(s+1),isNaN(t)||t===92))}e.isUNC=P;const b=/[\\/:\*\?"<>\|]/g,d=/[\\/]/g,S=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function h(n,t=i.isWindows){const s=t?b:d;return!(!n||n.length===0||/^\s+$/.test(n)||(s.lastIndex=0,s.test(n))||t&&S.test(n)||n==="."||n===".."||t&&n[n.length-1]==="."||t&&n.length!==n.trim().length||n.length>255)}e.isValidBasename=h;function y(n,t,s){const o=n===t;return!s||o?o:!n||!t?!1:(0,D.equalsIgnoreCase)(n,t)}e.isEqual=y;function p(n,t,s,o=L.sep){if(n===t)return!0;if(!n||!t||t.length>n.length)return!1;if(s){if(!(0,D.startsWithIgnoreCase)(n,t))return!1;if(t.length===n.length)return!0;let f=t.length;return t.charAt(t.length-1)===o&&f--,n.charAt(f)===o}return t.charAt(t.length-1)!==o&&(t+=o),n.indexOf(t)===0}e.isEqualOrParent=p;function m(n){return n>=65&&n<=90||n>=97&&n<=122}e.isWindowsDriveLetter=m;function w(n,t){return i.isWindows&&n.endsWith(":")&&(n+=L.sep),(0,L.isAbsolute)(n)||(n=(0,L.join)(t,n)),n=(0,L.normalize)(n),i.isWindows?(n=(0,D.rtrim)(n,L.sep),n.endsWith(":")&&(n+=L.sep)):(n=(0,D.rtrim)(n,L.sep),n||(n=L.sep)),n}e.sanitizeFilePath=w;function g(n){const t=(0,L.normalize)(n);return i.isWindows?n.length>3?!1:c(t)&&(n.length===2||t.charCodeAt(2)===92):t===L.posix.sep}e.isRootOrDriveLetter=g;function c(n,t){return(t!==void 0?t:i.isWindows)?m(n.charCodeAt(0))&&n.charCodeAt(1)===58:!1}e.hasDriveLetter=c;function l(n){return c(n)?n[0]:void 0}e.getDriveLetter=l;function r(n,t,s){return t.length>n.length?-1:n===t?0:(s&&(n=n.toLowerCase(),t=t.toLowerCase()),n.indexOf(t))}e.indexOfPath=r;function a(n){const t=n.split(":");let s,o,u;if(t.forEach(f=>{const v=Number(f);(0,_.isNumber)(v)?o===void 0?o=v:u===void 0&&(u=v):s=s?[s,f].join(":"):f}),!s)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:s,line:o!==void 0?o:void 0,column:u!==void 0?u:o!==void 0?1:void 0}}e.parseLineAndColumnAware=a}),define(te[28],ne([0,1,15]),function(Q,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function i(y){if(!y||typeof y!="object"||y instanceof RegExp)return y;const p=Array.isArray(y)?[]:{};return Object.keys(y).forEach(m=>{y[m]&&typeof y[m]=="object"?p[m]=i(y[m]):p[m]=y[m]}),p}e.deepClone=i;function D(y){if(!y||typeof y!="object")return y;const p=[y];for(;p.length>0;){const m=p.shift();Object.freeze(m);for(const w in m)if(_.call(m,w)){const g=m[w];typeof g=="object"&&!Object.isFrozen(g)&&p.push(g)}}return y}e.deepFreeze=D;const _=Object.prototype.hasOwnProperty;function k(y,p){return R(y,p,new Set)}e.cloneAndChange=k;function R(y,p,m){if((0,L.isUndefinedOrNull)(y))return y;const w=p(y);if(typeof w!="undefined")return w;if((0,L.isArray)(y)){const g=[];for(const c of y)g.push(R(c,p,m));return g}if((0,L.isObject)(y)){if(m.has(y))throw new Error("Cannot clone recursive data-structure");m.add(y);const g={};for(let c in y)_.call(y,c)&&(g[c]=R(y[c],p,m));return m.delete(y),g}return y}function E(y,p,m=!0){return(0,L.isObject)(y)?((0,L.isObject)(p)&&Object.keys(p).forEach(w=>{w in y?m&&((0,L.isObject)(y[w])&&(0,L.isObject)(p[w])?E(y[w],p[w],m):y[w]=p[w]):y[w]=p[w]}),y):p}e.mixin=E;function C(y,p){if(y===p)return!0;if(y==null||p===null||p===void 0||typeof y!=typeof p||typeof y!="object"||Array.isArray(y)!==Array.isArray(p))return!1;let m,w;if(Array.isArray(y)){if(y.length!==p.length)return!1;for(m=0;m<y.length;m++)if(!C(y[m],p[m]))return!1}else{const g=[];for(w in y)g.push(w);g.sort();const c=[];for(w in p)c.push(w);if(c.sort(),!C(g,c))return!1;for(m=0;m<g.length;m++)if(!C(y[g[m]],p[g[m]]))return!1}return!0}e.equals=C;function P(y){const p=new Set;return JSON.stringify(y,(m,w)=>{if((0,L.isObject)(w)||Array.isArray(w)){if(p.has(w))return"[Circular]";p.add(w)}return w})}e.safeStringify=P;function b(y,p,m){const w=p(y);return typeof w=="undefined"?m:w}e.getOrDefault=b;function d(y,p){const m=Object.create(null);return!y||!p||Object.keys(p).forEach(g=>{const c=y[g],l=p[g];C(c,l)||(m[g]=l)}),m}e.distinct=d;function S(y,p){const m=p.toLowerCase(),w=Object.keys(y).find(g=>g.toLowerCase()===m);return w?y[w]:y[p]}e.getCaseInsensitive=S;function h(y,p){const m=Object.create(null);for(const[w,g]of Object.entries(y))p(w,g)&&(m[w]=g);return m}e.filter=h}),define(te[7],ne([0,1,9,4]),function(Q,e,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const D=/^\w[\w\d+.-]*$/,_=/^\//,k=/^\/\//;function R(n,t){if(!n.scheme&&t)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${n.authority}", path: "${n.path}", query: "${n.query}", fragment: "${n.fragment}"}`);if(n.scheme&&!D.test(n.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(n.path){if(n.authority){if(!_.test(n.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(k.test(n.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function E(n,t){return!n&&!t?"file":n}function C(n,t){switch(n){case"https":case"http":case"file":t?t[0]!==b&&(t=b+t):t=b;break}return t}const P="",b="/",d=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class S{constructor(t,s,o,u,f,v=!1){typeof t=="object"?(this.scheme=t.scheme||P,this.authority=t.authority||P,this.path=t.path||P,this.query=t.query||P,this.fragment=t.fragment||P):(this.scheme=E(t,v),this.authority=s||P,this.path=C(this.scheme,o||P),this.query=u||P,this.fragment=f||P,R(this,v))}static isUri(t){return t instanceof S?!0:t?typeof t.authority=="string"&&typeof t.fragment=="string"&&typeof t.path=="string"&&typeof t.query=="string"&&typeof t.scheme=="string"&&typeof t.fsPath=="string"&&typeof t.with=="function"&&typeof t.toString=="function":!1}get fsPath(){return g(this,!1)}with(t){if(!t)return this;let{scheme:s,authority:o,path:u,query:f,fragment:v}=t;return s===void 0?s=this.scheme:s===null&&(s=P),o===void 0?o=this.authority:o===null&&(o=P),u===void 0?u=this.path:u===null&&(u=P),f===void 0?f=this.query:f===null&&(f=P),v===void 0?v=this.fragment:v===null&&(v=P),s===this.scheme&&o===this.authority&&u===this.path&&f===this.query&&v===this.fragment?this:new y(s,o,u,f,v)}static parse(t,s=!1){const o=d.exec(t);return o?new y(o[2]||P,a(o[4]||P),a(o[5]||P),a(o[7]||P),a(o[9]||P),s):new y(P,P,P,P,P)}static file(t){let s=P;if(i.isWindows&&(t=t.replace(/\\/g,b)),t[0]===b&&t[1]===b){const o=t.indexOf(b,2);o===-1?(s=t.substring(2),t=b):(s=t.substring(2,o),t=t.substring(o)||b)}return new y("file",s,t,P,P)}static from(t){const s=new y(t.scheme,t.authority,t.path,t.query,t.fragment);return R(s,!0),s}static joinPath(t,...s){if(!t.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let o;return i.isWindows&&t.scheme==="file"?o=S.file(L.win32.join(g(t,!0),...s)).path:o=L.posix.join(t.path,...s),t.with({path:o})}toString(t=!1){return c(this,t)}toJSON(){return this}static revive(t){if(t){if(t instanceof S)return t;{const s=new y(t);return s._formatted=t.external,s._fsPath=t._sep===h?t.fsPath:null,s}}else return t}}e.URI=S;const h=i.isWindows?1:void 0;class y extends S{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=g(this,!1)),this._fsPath}toString(t=!1){return t?c(this,!0):(this._formatted||(this._formatted=c(this,!1)),this._formatted)}toJSON(){const t={$mid:1};return this._fsPath&&(t.fsPath=this._fsPath,t._sep=h),this._formatted&&(t.external=this._formatted),this.path&&(t.path=this.path),this.scheme&&(t.scheme=this.scheme),this.authority&&(t.authority=this.authority),this.query&&(t.query=this.query),this.fragment&&(t.fragment=this.fragment),t}}const p={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function m(n,t){let s,o=-1;for(let u=0;u<n.length;u++){const f=n.charCodeAt(u);if(f>=97&&f<=122||f>=65&&f<=90||f>=48&&f<=57||f===45||f===46||f===95||f===126||t&&f===47)o!==-1&&(s+=encodeURIComponent(n.substring(o,u)),o=-1),s!==void 0&&(s+=n.charAt(u));else{s===void 0&&(s=n.substr(0,u));const v=p[f];v!==void 0?(o!==-1&&(s+=encodeURIComponent(n.substring(o,u)),o=-1),s+=v):o===-1&&(o=u)}}return o!==-1&&(s+=encodeURIComponent(n.substring(o))),s!==void 0?s:n}function w(n){let t;for(let s=0;s<n.length;s++){const o=n.charCodeAt(s);o===35||o===63?(t===void 0&&(t=n.substr(0,s)),t+=p[o]):t!==void 0&&(t+=n[s])}return t!==void 0?t:n}function g(n,t){let s;return n.authority&&n.path.length>1&&n.scheme==="file"?s=`//${n.authority}${n.path}`:n.path.charCodeAt(0)===47&&(n.path.charCodeAt(1)>=65&&n.path.charCodeAt(1)<=90||n.path.charCodeAt(1)>=97&&n.path.charCodeAt(1)<=122)&&n.path.charCodeAt(2)===58?t?s=n.path.substr(1):s=n.path[1].toLowerCase()+n.path.substr(2):s=n.path,i.isWindows&&(s=s.replace(/\//g,"\\")),s}e.uriToFsPath=g;function c(n,t){const s=t?w:m;let o="",{scheme:u,authority:f,path:v,query:I,fragment:O}=n;if(u&&(o+=u,o+=":"),(f||u==="file")&&(o+=b,o+=b),f){let A=f.indexOf("@");if(A!==-1){const N=f.substr(0,A);f=f.substr(A+1),A=N.indexOf(":"),A===-1?o+=s(N,!1):(o+=s(N.substr(0,A),!1),o+=":",o+=s(N.substr(A+1),!1)),o+="@"}f=f.toLowerCase(),A=f.indexOf(":"),A===-1?o+=s(f,!1):(o+=s(f.substr(0,A),!1),o+=f.substr(A))}if(v){if(v.length>=3&&v.charCodeAt(0)===47&&v.charCodeAt(2)===58){const A=v.charCodeAt(1);A>=65&&A<=90&&(v=`/${String.fromCharCode(A+32)}:${v.substr(3)}`)}else if(v.length>=2&&v.charCodeAt(1)===58){const A=v.charCodeAt(0);A>=65&&A<=90&&(v=`${String.fromCharCode(A+32)}:${v.substr(2)}`)}o+=s(v,!0)}return I&&(o+="?",o+=s(I,!1)),O&&(o+="#",o+=t?O:m(O,!1)),o}function l(n){try{return decodeURIComponent(n)}catch{return n.length>3?n.substr(0,3)+l(n.substr(3)):n}}const r=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function a(n){return n.match(r)?n.replace(r,t=>l(t)):n}}),define(te[105],ne([0,1,7]),function(Q,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function i(C){const P=C;return P&&typeof P.type=="string"&&typeof P.severity=="string"}e.isRemoteConsoleLog=i;function D(C){const P=[];let b;try{const d=JSON.parse(C.arguments),S=d[d.length-1];S&&S.__$stack&&(d.pop(),b=S.__$stack),P.push(...d)}catch{P.push("Unable to log remote console arguments",C.arguments)}return{args:P,stack:b}}e.parse=D;function _(C){if(typeof C!="string")return _(D(C).stack);const P=C;if(P){const b=k(P),d=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(b||"");if(d&&d.length===4)return{uri:L.URI.file(d[1]),line:Number(d[2]),column:Number(d[3])}}}e.getFirstFrame=_;function k(C){if(!C)return C;const P=C.indexOf(`
`);return P===-1?C:C.substring(0,P)}function R(C,P){const{args:b,stack:d}=D(C),S=typeof b[0]=="string"&&b.length===1;let h=k(d);h&&(h=`(${h.trim()})`);let y=[];if(typeof b[0]=="string"?h&&S?y=[`%c[${P}] %c${b[0]} %c${h}`,E("blue"),E(""),E("grey")]:y=[`%c[${P}] %c${b[0]}`,E("blue"),E(""),...b.slice(1)]:y=[`%c[${P}]%`,E("blue"),...b],h&&!S&&y.push(h),typeof console[C.severity]!="function")throw new Error("Unknown console method");console[C.severity].apply(console,y)}e.log=R;function E(C){return`color: ${C}`}}),define(te[106],ne([0,1,19,25,7]),function(Q,e,L,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function _(P){return JSON.stringify(P,E)}e.stringify=_;function k(P){let b=JSON.parse(P);return b=C(b),b}e.parse=k;var R;(function(P){P[P.Uri=1]="Uri",P[P.Regexp=2]="Regexp",P[P.ScmResource=3]="ScmResource",P[P.ScmResourceGroup=4]="ScmResourceGroup",P[P.ScmProvider=5]="ScmProvider",P[P.CommentController=6]="CommentController",P[P.CommentThread=7]="CommentThread",P[P.CommentThreadReply=8]="CommentThreadReply",P[P.CommentNode=9]="CommentNode",P[P.CommentThreadNode=10]="CommentThreadNode",P[P.TimelineActionContext=11]="TimelineActionContext",P[P.NotebookCellActionContext=12]="NotebookCellActionContext",P[P.TestItemContext=13]="TestItemContext"})(R=e.MarshalledId||(e.MarshalledId={}));function E(P,b){return b instanceof RegExp?{$mid:2,source:b.source,flags:(0,i.regExpFlags)(b)}:b}function C(P,b=0){if(!P||b>200)return P;if(typeof P=="object"){switch(P.$mid){case 1:return D.URI.revive(P);case 2:return new RegExp(P.source,P.flags)}if(P instanceof L.VSBuffer||P instanceof Uint8Array)return P;if(Array.isArray(P))for(let d=0;d<P.length;++d)P[d]=C(P[d],b+1);else for(const d in P)Object.hasOwnProperty.call(P,d)&&(P[d]=C(P[d],b+1))}return P}e.revive=C}),define(te[17],ne([0,1,4,7]),function(Q,e,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var D;(function(R){R.inMemory="inmemory",R.vscode="vscode",R.internal="private",R.walkThrough="walkThrough",R.walkThroughSnippet="walkThroughSnippet",R.http="http",R.https="https",R.file="file",R.mailto="mailto",R.untitled="untitled",R.data="data",R.command="command",R.vscodeRemote="vscode-remote",R.vscodeRemoteResource="vscode-remote-resource",R.userData="vscode-userdata",R.vscodeCustomEditor="vscode-custom-editor",R.vscodeNotebook="vscode-notebook",R.vscodeNotebookCell="vscode-notebook-cell",R.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",R.vscodeNotebookCellOutput="vscode-notebook-cell-output",R.vscodeInteractive="vscode-interactive",R.vscodeInteractiveInput="vscode-interactive-input",R.vscodeSettings="vscode-settings",R.vscodeWorkspaceTrust="vscode-workspace-trust",R.vscodeTerminal="vscode-terminal",R.webviewPanel="webview-panel",R.vscodeWebview="vscode-webview",R.extension="extension",R.vscodeFileResource="vscode-file",R.tmp="tmp",R.vsls="vsls"})(D=e.Schemas||(e.Schemas={}));class _{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(E){this._preferredWebSchema=E}setDelegate(E){this._delegate=E}set(E,C,P){this._hosts[E]=C,this._ports[E]=P}setConnectionToken(E,C){this._connectionTokens[E]=C}rewrite(E){if(this._delegate)return this._delegate(E);const C=E.authority;let P=this._hosts[C];P&&P.indexOf(":")!==-1&&(P=`[${P}]`);const b=this._ports[C],d=this._connectionTokens[C];let S=`path=${encodeURIComponent(E.path)}`;return typeof d=="string"&&(S+=`&tkn=${encodeURIComponent(d)}`),i.URI.from({scheme:L.isWeb?this._preferredWebSchema:D.vscodeRemoteResource,authority:`${P}:${b}`,path:"/vscode-remote-resource",query:S})}}e.RemoteAuthorities=new _;class k{asBrowserUri(E,C){const P=this.toUri(E,C);return P.scheme===D.vscodeRemote?e.RemoteAuthorities.rewrite(P):P.scheme===D.file&&(L.isNative||typeof L.globals.importScripts=="function"&&L.globals.origin===`${D.vscodeFileResource}://${k.FALLBACK_AUTHORITY}`)?P.with({scheme:D.vscodeFileResource,authority:P.authority||k.FALLBACK_AUTHORITY,query:null,fragment:null}):P}asFileUri(E,C){const P=this.toUri(E,C);return P.scheme===D.vscodeFileResource?P.with({scheme:D.file,authority:P.authority!==k.FALLBACK_AUTHORITY?P.authority:null,query:null,fragment:null}):P}toUri(E,C){return i.URI.isUri(E)?E:i.URI.parse(C.toUrl(E))}}k.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new k}),define(te[18],ne([0,1,40,17,9,4,25,7]),function(Q,e,L,i,D,_,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function E(S){return(0,R.uriToFsPath)(S,!0)}e.originalFSPath=E;class C{constructor(h){this._ignorePathCasing=h}compare(h,y,p=!1){return h===y?0:(0,k.compare)(this.getComparisonKey(h,p),this.getComparisonKey(y,p))}isEqual(h,y,p=!1){return h===y?!0:!h||!y?!1:this.getComparisonKey(h,p)===this.getComparisonKey(y,p)}getComparisonKey(h,y=!1){return h.with({path:this._ignorePathCasing(h)?h.path.toLowerCase():void 0,fragment:y?null:void 0}).toString()}ignorePathCasing(h){return this._ignorePathCasing(h)}isEqualOrParent(h,y,p=!1){if(h.scheme===y.scheme){if(h.scheme===i.Schemas.file)return L.isEqualOrParent(E(h),E(y),this._ignorePathCasing(h))&&h.query===y.query&&(p||h.fragment===y.fragment);if((0,e.isEqualAuthority)(h.authority,y.authority))return L.isEqualOrParent(h.path,y.path,this._ignorePathCasing(h),"/")&&h.query===y.query&&(p||h.fragment===y.fragment)}return!1}joinPath(h,...y){return R.URI.joinPath(h,...y)}basenameOrAuthority(h){return(0,e.basename)(h)||h.authority}basename(h){return D.posix.basename(h.path)}extname(h){return D.posix.extname(h.path)}dirname(h){if(h.path.length===0)return h;let y;return h.scheme===i.Schemas.file?y=R.URI.file(D.dirname(E(h))).path:(y=D.posix.dirname(h.path),h.authority&&y.length&&y.charCodeAt(0)!==47&&(console.error(`dirname("${h.toString})) resulted in a relative path`),y="/")),h.with({path:y})}normalizePath(h){if(!h.path.length)return h;let y;return h.scheme===i.Schemas.file?y=R.URI.file(D.normalize(E(h))).path:y=D.posix.normalize(h.path),h.with({path:y})}relativePath(h,y){if(h.scheme!==y.scheme||!(0,e.isEqualAuthority)(h.authority,y.authority))return;if(h.scheme===i.Schemas.file){const w=D.relative(E(h),E(y));return _.isWindows?L.toSlashes(w):w}let p=h.path||"/",m=y.path||"/";if(this._ignorePathCasing(h)){let w=0;for(const g=Math.min(p.length,m.length);w<g&&!(p.charCodeAt(w)!==m.charCodeAt(w)&&p.charAt(w).toLowerCase()!==m.charAt(w).toLowerCase());w++);p=m.substr(0,w)+p.substr(w)}return D.posix.relative(p,m)}resolvePath(h,y){if(h.scheme===i.Schemas.file){const p=R.URI.file(D.resolve(E(h),y));return h.with({authority:p.authority,path:p.path})}return y=L.toPosixPath(y),h.with({path:D.posix.resolve(h.path,y)})}isAbsolutePath(h){return!!h.path&&h.path[0]==="/"}isEqualAuthority(h,y){return h===y||h!==void 0&&y!==void 0&&(0,k.equalsIgnoreCase)(h,y)}hasTrailingPathSeparator(h,y=D.sep){if(h.scheme===i.Schemas.file){const p=E(h);return p.length>L.getRoot(p).length&&p[p.length-1]===y}else{const p=h.path;return p.length>1&&p.charCodeAt(p.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(h.fsPath)}}removeTrailingPathSeparator(h,y=D.sep){return(0,e.hasTrailingPathSeparator)(h,y)?h.with({path:h.path.substr(0,h.path.length-1)}):h}addTrailingPathSeparator(h,y=D.sep){let p=!1;if(h.scheme===i.Schemas.file){const m=E(h);p=m!==void 0&&m.length===L.getRoot(m).length&&m[m.length-1]===y}else{y="/";const m=h.path;p=m.length===1&&m.charCodeAt(m.length-1)===47}return!p&&!(0,e.hasTrailingPathSeparator)(h,y)?h.with({path:h.path+"/"}):h}}e.ExtUri=C,e.extUri=new C(()=>!1),e.extUriBiasedIgnorePathCase=new C(S=>S.scheme===i.Schemas.file?!_.isLinux:!0),e.extUriIgnorePathCase=new C(S=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function P(S,h){const y=[];for(let p=0;p<S.length;p++){const m=h(S[p]);S.some((w,g)=>g===p?!1:(0,e.isEqualOrParent)(m,h(w)))||y.push(S[p])}return y}e.distinctParents=P;var b;(function(S){S.META_DATA_LABEL="label",S.META_DATA_DESCRIPTION="description",S.META_DATA_SIZE="size",S.META_DATA_MIME="mime";function h(y){const p=new Map;y.path.substring(y.path.indexOf(";")+1,y.path.lastIndexOf(";")).split(";").forEach(g=>{const[c,l]=g.split(":");c&&l&&p.set(c,l)});const w=y.path.substring(0,y.path.indexOf(";"));return w&&p.set(S.META_DATA_MIME,w),p}S.parseMetaData=h})(b=e.DataUri||(e.DataUri={}));function d(S,h,y){if(h){let p=S.path;return p&&p[0]!==D.posix.sep&&(p=D.posix.sep+p),S.with({scheme:y,authority:h,path:p})}return S.with({scheme:y})}e.toLocalResource=d}),define(te[5],ne([0,1,27,10,3,2,18,4]),function(Q,e,L,i,D,_,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function E(W){return!!W&&typeof W.then=="function"}e.isThenable=E;function C(W){const z=new L.CancellationTokenSource,V=W(z.token),q=new Promise((G,Y)=>{const x=z.token.onCancellationRequested(()=>{x.dispose(),z.dispose(),Y((0,i.canceled)())});Promise.resolve(V).then(K=>{x.dispose(),z.dispose(),G(K)},K=>{x.dispose(),z.dispose(),Y(K)})});return new class{cancel(){z.cancel()}then(G,Y){return q.then(G,Y)}catch(G){return this.then(void 0,G)}finally(G){return q.finally(G)}}}e.createCancelablePromise=C;function P(W,z,V){return Promise.race([W,new Promise(q=>z.onCancellationRequested(()=>q(V)))])}e.raceCancellation=P;async function b(W){let z=-1;const V=W.map((G,Y)=>G.then(x=>(z=Y,x))),q=await Promise.race(V);return W.forEach((G,Y)=>{Y!==z&&G.cancel()}),q}e.raceCancellablePromises=b;function d(W,z,V){let q;const G=setTimeout(()=>{q?.(void 0),V?.()},z);return Promise.race([W.finally(()=>clearTimeout(G)),new Promise(Y=>q=Y)])}e.raceTimeout=d;function S(W){return new Promise((z,V)=>{const q=W();E(q)?q.then(z,V):z(q)})}e.asPromise=S;class h{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(z){if(this.activePromise){if(this.queuedPromiseFactory=z,!this.queuedPromise){const V=()=>{this.queuedPromise=null;const q=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,q};this.queuedPromise=new Promise(q=>{this.activePromise.then(V,V).then(q)})}return new Promise((V,q)=>{this.queuedPromise.then(V,q)})}return this.activePromise=z(),new Promise((V,q)=>{this.activePromise.then(G=>{this.activePromise=null,V(G)},G=>{this.activePromise=null,q(G)})})}}e.Throttler=h;class y{constructor(){this.current=Promise.resolve(null)}queue(z){return this.current=this.current.then(()=>z(),()=>z())}}e.Sequencer=y;class p{constructor(){this.promiseMap=new Map}queue(z,V){const G=(this.promiseMap.get(z)??Promise.resolve()).catch(()=>{}).then(V).finally(()=>{this.promiseMap.get(z)===G&&this.promiseMap.delete(z)});return this.promiseMap.set(z,G),G}}e.SequencerByKey=p;class m{constructor(z){this.defaultDelay=z,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(z,V=this.defaultDelay){return this.task=z,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((q,G)=>{this.doResolve=q,this.doReject=G}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const q=this.task;return this.task=null,q()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},V),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,i.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=m;class w{constructor(z){this.delayer=new m(z),this.throttler=new h}trigger(z,V){return this.delayer.trigger(()=>this.throttler.queue(z),V)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=w;class g{constructor(){this._isOpen=!1,this._promise=new Promise((z,V)=>{this._completePromise=z})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=g;class c extends g{constructor(z){super();this._timeout=setTimeout(()=>this.open(),z)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=c;function l(W,z){return z?new Promise((V,q)=>{const G=setTimeout(()=>{Y.dispose(),V()},W),Y=z.onCancellationRequested(()=>{clearTimeout(G),Y.dispose(),q((0,i.canceled)())})}):C(V=>l(W,V))}e.timeout=l;function r(W,z=0){const V=setTimeout(W,z);return(0,_.toDisposable)(()=>clearTimeout(V))}e.disposableTimeout=r;function a(W){const z=[];let V=0;const q=W.length;function G(){return V<q?W[V++]():null}function Y(x){x!=null&&z.push(x);const K=G();return K?K.then(Y):Promise.resolve(z)}return Promise.resolve(null).then(Y)}e.sequence=a;function n(W,z=q=>!!q,V=null){let q=0;const G=W.length,Y=()=>{if(q>=G)return Promise.resolve(V);const x=W[q++];return Promise.resolve(x()).then(re=>z(re)?Promise.resolve(re):Y())};return Y()}e.first=n;function t(W,z=q=>!!q,V=null){if(W.length===0)return Promise.resolve(V);let q=W.length;const G=()=>{q=-1;for(const Y of W)Y.cancel?.()};return new Promise((Y,x)=>{for(const K of W)K.then(re=>{--q>=0&&z(re)?(G(),Y(re)):q===0&&Y(V)}).catch(re=>{--q>=0&&(G(),x(re))})})}e.firstParallel=t;class s{constructor(z){this._size=0,this.maxDegreeOfParalellism=z,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new D.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(z){return this._size++,new Promise((V,q)=>{this.outstandingPromises.push({factory:z,c:V,e:q}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const z=this.outstandingPromises.shift();this.runningPromises++;const V=z.factory();V.then(z.c,z.e),V.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=s;class o extends s{constructor(){super(1)}}e.Queue=o;class u{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const z=new U;return this.drainers.add(z),z.p}isDrained(){for(const[,z]of this.queues)if(z.size>0)return!1;return!0}queueFor(z,V=k.extUri){const q=V.getComparisonKey(z);let G=this.queues.get(q);return G||(G=new o,D.Event.once(G.onFinished)(()=>{G?.dispose(),this.queues.delete(q),this.onDidQueueFinish()}),this.queues.set(q,G)),G}onDidQueueFinish(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const z of this.drainers)z.complete();this.drainers.clear()}dispose(){for(const[,z]of this.queues)z.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=u;class f{constructor(z,V){this._token=-1,typeof z=="function"&&typeof V=="number"&&this.setIfNotSet(z,V)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(z,V){this.cancel(),this._token=setTimeout(()=>{this._token=-1,z()},V)}setIfNotSet(z,V){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,z()},V))}}e.TimeoutTimer=f;class v{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(z,V){this.cancel(),this._token=setInterval(()=>{z()},V)}}e.IntervalTimer=v;class I{constructor(z,V){this.timeoutToken=-1,this.runner=z,this.timeout=V,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(z=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,z)}get delay(){return this.timeout}set delay(z){this.timeout=z}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=I;class O{constructor(z,V){V%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${V}ms is not a multiple of 1000ms.`),this.runner=z,this.timeout=V,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(z=this.timeout){z%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${z}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(z/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=O;class A extends I{constructor(z,V){super(z,V);this.units=[]}work(z){this.units.push(z),this.isScheduled()||this.schedule()}doRun(){const z=this.units;this.units=[],this.runner&&this.runner(z)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=A;class N extends _.Disposable{constructor(z,V,q,G){super();this.maxWorkChunkSize=z,this.maxPendingWork=V,this.throttleDelay=q,this.handler=G,this.pendingWork=[],this.throttler=this._register(new _.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(z){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+z.length>this.maxPendingWork)return!1}else if(this.pending+z.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...z),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new I(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=N,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=W=>{(0,R.setTimeout0)(()=>{if(z)return;const V=Date.now()+3;W(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,V-Date.now())}}))});let z=!1;return{dispose(){z||(z=!0)}}}:e.runWhenIdle=(W,z)=>{const V=requestIdleCallback(W,typeof z=="number"?{timeout:z}:void 0);let q=!1;return{dispose(){q||(q=!0,cancelIdleCallback(V))}}}}();class ${constructor(z){this._didRun=!1,this._executor=()=>{try{this._value=z()}catch(V){this._error=V}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=$;async function T(W,z,V){let q;for(let G=0;G<V;G++)try{return await W()}catch(Y){q=Y,await l(z)}throw q}e.retry=T;class F{hasPending(z){return this._pending?typeof z=="number"?this._pending.taskId===z:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(z,V,q){return this._pending={taskId:z,cancel:()=>q?.(),promise:V},V.then(()=>this.donePending(z),()=>this.donePending(z)),V}donePending(z){this._pending&&z===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const z=this._next;this._next=void 0,z.run().then(z.promiseResolve,z.promiseReject)}}setNext(z){if(this._next)this._next.run=z;else{let V,q;const G=new Promise((Y,x)=>{V=Y,q=x});this._next={run:z,promise:G,promiseResolve:V,promiseReject:q}}return this._next.promise}}e.TaskSequentializer=F;class M{constructor(z,V=()=>Date.now()){this.interval=z,this.nowFn=V,this.lastIncrementTime=0,this.value=0}increment(){const z=this.nowFn();return z-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=z,this.value=0),this.value++,this.value}}e.IntervalCounter=M;class U{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((z,V)=>{this.completeCallback=z,this.errorCallback=V})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(z){return new Promise(V=>{this.completeCallback(z),this.resolved=!0,V()})}error(z){return new Promise(V=>{this.errorCallback(z),this.rejected=!0,V()})}cancel(){new Promise(z=>{this.errorCallback((0,i.canceled)()),this.rejected=!0,z()})}}e.DeferredPromise=U;var B;(function(W){async function z(q){let G;const Y=await Promise.all(q.map(x=>x.then(K=>K,K=>{G||(G=K)})));if(typeof G!="undefined")throw G;return Y}W.settled=z;function V(q){return new Promise(async(G,Y)=>{try{await q(G,Y)}catch(x){Y(x)}})}W.withAsyncBody=V})(B=e.Promises||(e.Promises={}));var ee;(function(W){W[W.Initial=0]="Initial",W[W.DoneOK=1]="DoneOK",W[W.DoneError=2]="DoneError"})(ee||(ee={}));class H{constructor(z){this._state=0,this._results=[],this._error=null,this._onStateChanged=new D.Emitter,queueMicrotask(async()=>{const V={emitOne:q=>this.emitOne(q),emitMany:q=>this.emitMany(q),reject:q=>this.reject(q)};try{await Promise.resolve(z(V)),this.resolve()}catch(q){this.reject(q)}finally{V.emitOne=void 0,V.emitMany=void 0,V.reject=void 0}})}static fromArray(z){return new H(V=>{V.emitMany(z)})}static fromPromise(z){return new H(async V=>{V.emitMany(await z)})}static fromPromises(z){return new H(async V=>{await Promise.all(z.map(async q=>V.emitOne(await q)))})}static merge(z){return new H(async V=>{await Promise.all(z.map(async q=>{for await(const G of q)V.emitOne(G)}))})}[Symbol.asyncIterator](){let z=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(z<this._results.length)return{done:!1,value:this._results[z++]};if(this._state===1)return{done:!0,value:void 0};await D.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(z,V){return new H(async q=>{for await(const G of z)q.emitOne(V(G))})}map(z){return H.map(this,z)}static filter(z,V){return new H(async q=>{for await(const G of z)V(G)&&q.emitOne(G)})}filter(z){return H.filter(this,z)}static coalesce(z){return H.filter(z,V=>!!V)}coalesce(){return H.coalesce(this)}static async toPromise(z){const V=[];for await(const q of z)V.push(q);return V}toPromise(){return H.toPromise(this)}emitOne(z){this._state===0&&(this._results.push(z),this._onStateChanged.fire())}emitMany(z){this._state===0&&(this._results=this._results.concat(z),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(z){this._state===0&&(this._state=2,this._error=z,this._onStateChanged.fire())}}e.AsyncIterableObject=H,H.EMPTY=H.fromArray([]);class j extends H{constructor(z,V){super(V);this._source=z}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=j;function Z(W){const z=new L.CancellationTokenSource,V=W(z.token);return new j(z,async q=>{const G=z.token.onCancellationRequested(()=>{G.dispose(),z.dispose(),q.reject((0,i.canceled)())});try{for await(const Y of V){if(z.token.isCancellationRequested)return;q.emitOne(Y)}G.dispose(),z.dispose()}catch(Y){G.dispose(),z.dispose(),q.reject(Y)}})}e.createCancelableAsyncIterable=Z}),define(te[107],ne([0,1,5,40,39,9,25]),function(Q,e,L,i,D,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function R(){return Object.create(null)}e.getEmptyExpression=R;const E="**",C="/",P="[/\\\\]",b="[^/\\\\]",d=/\//g;function S(j){switch(j){case 0:return"";case 1:return`${b}*?`;default:return`(?:${P}|${b}+${P}|${P}${b}+)*?`}}function h(j,Z){if(!j)return[];const W=[];let z=!1,V=!1,q="";for(const G of j){switch(G){case Z:if(!z&&!V){W.push(q),q="";continue}break;case"{":z=!0;break;case"}":z=!1;break;case"[":V=!0;break;case"]":V=!1;break}q+=G}return q&&W.push(q),W}e.splitGlobAware=h;function y(j){if(!j)return"";let Z="";const W=h(j,C);if(W.every(z=>z===E))Z=".*";else{let z=!1;W.forEach((V,q)=>{if(V===E){z||(Z+=S(2),z=!0);return}let G=!1,Y="",x=!1,K="";for(const re of V){if(re!=="}"&&G){Y+=re;continue}if(x&&(re!=="]"||!K)){let se;re==="-"?se=re:(re==="^"||re==="!")&&!K?se="^":re===C?se="":se=k.escapeRegExpCharacters(re),K+=se;continue}switch(re){case"{":G=!0;continue;case"[":x=!0;continue;case"}":Z+=`(?:${h(Y,",").map(he=>y(he)).join("|")})`,G=!1,Y="";break;case"]":Z+="["+K+"]",x=!1,K="";break;case"?":Z+=b;continue;case"*":Z+=S(1);continue;default:Z+=k.escapeRegExpCharacters(re)}}q<W.length-1&&(W[q+1]!==E||q+2<W.length)&&(Z+=P),z=!1})}return Z}const p=/^\*\*\/\*\.[\w\.-]+$/,m=/^\*\*\/([\w\.-]+)\/?$/,w=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,g=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,l=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,r=new D.LRUCache(1e4),a=function(){return!1},n=function(){return null};function t(j,Z){if(!j)return n;let W;typeof j!="string"?W=j.pattern:W=j,W=W.trim();const z=`${W}_${!!Z.trimForExclusions}`;let V=r.get(z);if(V)return s(V,j);let q;if(p.test(W)){const G=W.substr(4);V=function(Y,x){return typeof Y=="string"&&Y.endsWith(G)?W:null}}else(q=m.exec(o(W,Z)))?V=u(q[1],W):(Z.trimForExclusions?g:w).test(W)?V=f(W,Z):(q=c.exec(o(W,Z)))?V=v(q[1].substr(1),W,!0):(q=l.exec(o(W,Z)))?V=v(q[1],W,!1):V=I(W);return r.set(z,V),s(V,j)}function s(j,Z){return typeof Z=="string"?j:function(W,z){return i.isEqualOrParent(W,Z.base)?j(_.relative(Z.base,W),z):null}}function o(j,Z){return Z.trimForExclusions&&j.endsWith("/**")?j.substr(0,j.length-2):j}function u(j,Z){const W=`/${j}`,z=`\\${j}`,V=function(G,Y){return typeof G!="string"?null:Y?Y===j?Z:null:G===j||G.endsWith(W)||G.endsWith(z)?Z:null},q=[j];return V.basenames=q,V.patterns=[Z],V.allBasenames=q,V}function f(j,Z){const W=H(j.slice(1,-1).split(",").map(Y=>t(Y,Z)).filter(Y=>Y!==n),j),z=W.length;if(!z)return n;if(z===1)return W[0];const V=function(Y,x){for(let K=0,re=W.length;K<re;K++)if(W[K](Y,x))return j;return null},q=W.find(Y=>!!Y.allBasenames);q&&(V.allBasenames=q.allBasenames);const G=W.reduce((Y,x)=>x.allPaths?Y.concat(x.allPaths):Y,[]);return G.length&&(V.allPaths=G),V}function v(j,Z,W){const z=_.sep===_.posix.sep,V=z?j:j.replace(d,_.sep),q=_.sep+V,G=_.posix.sep+j,Y=W?function(x,K){return typeof x=="string"&&(x===V||x.endsWith(q)||!z&&(x===j||x.endsWith(G)))?Z:null}:function(x,K){return typeof x=="string"&&(x===V||!z&&x===j)?Z:null};return Y.allPaths=[(W?"*/":"./")+j],Y}function I(j){try{const Z=new RegExp(`^${y(j)}$`);return function(W){return Z.lastIndex=0,typeof W=="string"&&Z.test(W)?j:null}}catch{return n}}function O(j,Z,W){return!j||typeof Z!="string"?!1:A(j)(Z,void 0,W)}e.match=O;function A(j,Z={}){if(!j)return a;if(typeof j=="string"||F(j)){const W=t(j,Z);if(W===n)return a;const z=function(V,q){return!!W(V,q)};return W.allBasenames&&(z.allBasenames=W.allBasenames),W.allPaths&&(z.allPaths=W.allPaths),z}return B(j,Z)}e.parse=A;function N(j){if(!j)return;let Z;return W=>(Z||(Z=(j()||Promise.resolve([])).then(z=>z?T(z):{})),Z.then(z=>!!z[W]))}e.hasSiblingPromiseFn=N;function $(j){if(!j)return;let Z;return W=>{if(!Z){const z=j();Z=z?T(z):{}}return!!Z[W]}}e.hasSiblingFn=$;function T(j){const Z={};for(const W of j)Z[W]=!0;return Z}function F(j){const Z=j;return Z&&typeof Z.base=="string"&&typeof Z.pattern=="string"}e.isRelativePattern=F;function M(j){return j.allBasenames||[]}e.getBasenameTerms=M;function U(j){return j.allPaths||[]}e.getPathTerms=U;function B(j,Z){const W=H(Object.getOwnPropertyNames(j).map(Y=>ee(Y,j[Y],Z)).filter(Y=>Y!==n)),z=W.length;if(!z)return n;if(!W.some(Y=>!!Y.requiresSiblings)){if(z===1)return W[0];const Y=function(re,se){for(let ce=0,he=W.length;ce<he;ce++){const me=W[ce](re,se);if(me)return me}return null},x=W.find(re=>!!re.allBasenames);x&&(Y.allBasenames=x.allBasenames);const K=W.reduce((re,se)=>se.allPaths?re.concat(se.allPaths):re,[]);return K.length&&(Y.allPaths=K),Y}const V=function(Y,x,K){let re;for(let se=0,ce=W.length;se<ce;se++){const he=W[se];he.requiresSiblings&&K&&(x||(x=_.basename(Y)),re||(re=x.substr(0,x.length-_.extname(Y).length)));const me=he(Y,x,re,K);if(me)return me}return null},q=W.find(Y=>!!Y.allBasenames);q&&(V.allBasenames=q.allBasenames);const G=W.reduce((Y,x)=>x.allPaths?Y.concat(x.allPaths):Y,[]);return G.length&&(V.allPaths=G),V}function ee(j,Z,W){if(Z===!1)return n;const z=t(j,W);if(z===n)return n;if(typeof Z=="boolean")return z;if(Z){const V=Z.when;if(typeof V=="string"){const q=(G,Y,x,K)=>{if(!K||!z(G,Y))return null;const re=V.replace("$(basename)",x),se=K(re);return(0,L.isThenable)(se)?se.then(ce=>ce?j:null):se?j:null};return q.requiresSiblings=!0,q}}return z}function H(j,Z){const W=j.filter(Y=>!!Y.basenames);if(W.length<2)return j;const z=W.reduce((Y,x)=>{const K=x.basenames;return K?Y.concat(K):Y},[]);let V;if(Z){V=[];for(let Y=0,x=z.length;Y<x;Y++)V.push(Z)}else V=W.reduce((Y,x)=>{const K=x.patterns;return K?Y.concat(K):Y},[]);const q=function(Y,x){if(typeof Y!="string")return null;if(!x){let re;for(re=Y.length;re>0;re--){const se=Y.charCodeAt(re-1);if(se===47||se===92)break}x=Y.substr(re)}const K=z.indexOf(x);return K!==-1?V[K]:null};q.basenames=z,q.patterns=V,q.allBasenames=z;const G=j.filter(Y=>!Y.basenames);return G.push(q),G}}),define(te[108],ne([0,1,107,17,9,18,25]),function(Q,e,L,i,D,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var R;(function(t){t.text="text/plain",t.binary="application/octet-stream",t.unknown="application/unknown",t.markdown="text/markdown",t.latex="text/latex"})(R=e.Mimes||(e.Mimes={}));let E=[],C=[],P=[];function b(t,s=!1){const o=d(t);E.push(o),o.userConfigured?P.push(o):C.push(o),s&&!o.userConfigured&&E.forEach(u=>{u.mime===o.mime||u.userConfigured||(o.extension&&u.extension===o.extension&&console.warn(`Overwriting extension <<${o.extension}>> to now point to mime <<${o.mime}>>`),o.filename&&u.filename===o.filename&&console.warn(`Overwriting filename <<${o.filename}>> to now point to mime <<${o.mime}>>`),o.filepattern&&u.filepattern===o.filepattern&&console.warn(`Overwriting filepattern <<${o.filepattern}>> to now point to mime <<${o.mime}>>`),o.firstline&&u.firstline===o.firstline&&console.warn(`Overwriting firstline <<${o.firstline}>> to now point to mime <<${o.mime}>>`))})}e.registerTextMime=b;function d(t){return{id:t.id,mime:t.mime,filename:t.filename,extension:t.extension,filepattern:t.filepattern,firstline:t.firstline,userConfigured:t.userConfigured,filenameLowercase:t.filename?t.filename.toLowerCase():void 0,extensionLowercase:t.extension?t.extension.toLowerCase():void 0,filepatternLowercase:t.filepattern?(0,L.parse)(t.filepattern.toLowerCase()):void 0,filepatternOnPath:t.filepattern?t.filepattern.indexOf(D.posix.sep)>=0:!1}}function S(t){t?(E=E.filter(s=>!s.userConfigured),P=[]):(E=[],C=[],P=[])}e.clearTextMimes=S;function h(t,s){let o;if(t)switch(t.scheme){case i.Schemas.file:o=t.fsPath;break;case i.Schemas.data:o=_.DataUri.parseMetaData(t).get(_.DataUri.META_DATA_LABEL);break;default:o=t.path}if(!o)return[R.unknown];o=o.toLowerCase();const u=(0,D.basename)(o),f=y(o,u,P);if(f)return[f,R.text];const v=y(o,u,C);if(v)return[v,R.text];if(s){const I=p(s);if(I)return[I,R.text]}return[R.unknown]}e.guessMimeTypes=h;function y(t,s,o){let u=null,f=null,v=null;for(let I=o.length-1;I>=0;I--){const O=o[I];if(s===O.filenameLowercase){u=O;break}if(O.filepattern&&(!f||O.filepattern.length>f.filepattern.length)){const A=O.filepatternOnPath?t:s;O.filepatternLowercase?.(A)&&(f=O)}O.extension&&(!v||O.extension.length>v.extension.length)&&s.endsWith(O.extensionLowercase)&&(v=O)}return u?u.mime:f?f.mime:v?v.mime:null}function p(t){if((0,k.startsWithUTF8BOM)(t)&&(t=t.substr(1)),t.length>0)for(let s=E.length-1;s>=0;s--){const o=E[s];if(!o.firstline)continue;const u=t.match(o.firstline);if(u&&u.length>0)return o.mime}return null}function m(t){return t?typeof t=="string"?t===R.binary||t===R.text||t===R.unknown:t.length===1&&m(t[0]):!0}e.isUnspecific=m;const w={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},g={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function c(t){const s=(0,D.extname)(t),o=w[s.toLowerCase()];return o!==void 0?o:l(t)}e.getMediaOrTextMime=c;function l(t){const s=(0,D.extname)(t);return g[s.toLowerCase()]}e.getMediaMime=l;function r(t){for(const s in g)if(g[s]===t)return s}e.getExtensionForMimeType=r;const a=/^(.+)\/(.+?)(;.+)?$/;function n(t,s){const o=a.exec(t);return o?`${o[1].toLowerCase()}/${o[2].toLowerCase()}${o[3]??""}`:s?void 0:t}e.normalizeMimeType=n}),define(te[109],ne([0,1,7]),function(Q,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function i(P){return P.toJSON()}class D{constructor(b){this._uriTransformer=b}transformIncoming(b){const d=this._uriTransformer.transformIncoming(b);return d===b?b:i(L.URI.from(d))}transformOutgoing(b){const d=this._uriTransformer.transformOutgoing(b);return d===b?b:i(L.URI.from(d))}transformOutgoingURI(b){const d=this._uriTransformer.transformOutgoing(b);return d===b?b:L.URI.from(d)}transformOutgoingScheme(b){return this._uriTransformer.transformOutgoingScheme(b)}}e.URITransformer=D,e.DefaultURITransformer=new class{transformIncoming(P){return P}transformOutgoing(P){return P}transformOutgoingURI(P){return P}transformOutgoingScheme(P){return P}};function _(P,b,d){if(!P||d>200)return null;if(typeof P=="object"){if(P instanceof L.URI)return b.transformOutgoing(P);for(let S in P)if(Object.hasOwnProperty.call(P,S)){const h=_(P[S],b,d+1);h!==null&&(P[S]=h)}}return null}function k(P,b){const d=_(P,b,0);return d===null?P:d}e.transformOutgoingURIs=k;function R(P,b,d,S){if(!P||S>200)return null;if(typeof P=="object"){if(P.$mid===1)return d?L.URI.revive(b.transformIncoming(P)):b.transformIncoming(P);for(let h in P)if(Object.hasOwnProperty.call(P,h)){const y=R(P[h],b,d,S+1);y!==null&&(P[h]=y)}}return null}function E(P,b){const d=R(P,b,!1,0);return d===null?P:d}e.transformIncomingURIs=E;function C(P,b){const d=R(P,b,!0,0);return d===null?P:d}e.transformAndReviveIncomingURIs=C}),define(te[30],ne([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const L=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function i(E){return L.test(E)}e.isUUID=i;const D=new Uint8Array(16),_=[];for(let E=0;E<256;E++)_.push(E.toString(16).padStart(2,"0"));let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(E){for(let C=0;C<E.length;C++)E[C]=Math.floor(Math.random()*256);return E};function R(){k(D),D[6]=D[6]&15|64,D[8]=D[8]&63|128;let E=0,C="";return C+=_[D[E++]],C+=_[D[E++]],C+=_[D[E++]],C+=_[D[E++]],C+="-",C+=_[D[E++]],C+=_[D[E++]],C+="-",C+=_[D[E++]],C+=_[D[E++]],C+="-",C+=_[D[E++]],C+=_[D[E++]],C+="-",C+=_[D[E++]],C+=_[D[E++]],C+=_[D[E++]],C+=_[D[E++]],C+=_[D[E++]],C+=_[D[E++]],C}e.generateUuid=R}),define(te[110],ne([0,1,242]),function(Q,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class i{constructor(_="utf8"){this.stringDecoder=new L.StringDecoder(_),this.remaining=null}write(_){const k=[],R=this.remaining?this.remaining+this.stringDecoder.write(_):this.stringDecoder.write(_);if(R.length<1)return k;let E=0,C,P=E;for(;P<R.length;)if(C=R.charCodeAt(P),C===13||C===10){if(k.push(R.substring(E,P)),P++,P<R.length){const b=C;C=R.charCodeAt(P),(b===13&&C===10||b===10&&C===13)&&P++}E=P}else P++;return this.remaining=E<R.length?R.substr(E):null,k}end(){return this.remaining}}e.LineDecoder=i}),define(te[111],ne([0,1,33]),function(Q,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const i=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function D(k){const R=k.replace(/\-/g,":").toLowerCase();return!i.has(R)}function _(){const k=(0,L.networkInterfaces)();for(let R in k){const E=k[R];if(E){for(const{mac:C}of E)if(D(C))return C}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=_}),define(te[112],ne([0,1,33,10,39,30,111]),function(Q,e,L,i,D,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(P){return this._virtualMachineOUIs||(this._virtualMachineOUIs=D.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(P)}value(){if(this._value===void 0){let P=0,b=0;const d=(0,L.networkInterfaces)();for(let S in d){const h=d[S];if(h)for(const{mac:y,internal:p}of h)p||(b+=1,this._isVirtualMachineMacAddress(y.toUpperCase())&&(P+=1))}this._value=b>0?P/b:0}return this._value}};let R;async function E(){return R||(R=(async()=>await C()||_.generateUuid())()),R}e.getMachineId=E;async function C(){try{const P=await new Promise((d,S)=>{Q(["crypto"],d,S)}),b=(0,k.getMac)();return P.createHash("sha256").update(b,"utf8").digest("hex")}catch(P){i.onUnexpectedError(P);return}}}),define(te[20],ne([0,1,50,33,243,5,40,69,9,4,18,7,30]),function(Q,e,L,i,D,_,k,R,E,C,P,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var S;(function(M){M[M.UNLINK=0]="UNLINK",M[M.MOVE=1]="MOVE"})(S=e.RimRafMode||(e.RimRafMode={}));async function h(M,U=S.UNLINK){if((0,k.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");return U===S.UNLINK?p(M):y(M)}async function y(M){try{const U=(0,E.join)((0,i.tmpdir)(),(0,d.generateUuid)());try{await e.Promises.rename(M,U)}catch{return p(M)}p(U).catch(B=>{})}catch(U){if(U.code!=="ENOENT")throw U}}async function p(M){return e.Promises.rmdir(M,{recursive:!0,maxRetries:3})}function m(M){if((0,k.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");L.rmdirSync(M,{recursive:!0})}e.rimrafSync=m;async function w(M,U){return l(await(U?g(M):(0,D.promisify)(L.readdir)(M)))}async function g(M){try{return await(0,D.promisify)(L.readdir)(M,{withFileTypes:!0})}catch(ee){console.warn("[node.js fs] readdir with filetypes failed with error: ",ee)}const U=[],B=await w(M);for(const ee of B){let H=!1,j=!1,Z=!1;try{const W=await e.Promises.lstat((0,E.join)(M,ee));H=W.isFile(),j=W.isDirectory(),Z=W.isSymbolicLink()}catch(W){console.warn("[node.js fs] unexpected error from lstat after readdir: ",W)}U.push({name:ee,isFile:()=>H,isDirectory:()=>j,isSymbolicLink:()=>Z})}return U}function c(M){return l(L.readdirSync(M))}e.readdirSync=c;function l(M){return M.map(U=>typeof U=="string"?C.isMacintosh?(0,R.normalizeNFC)(U):U:(U.name=C.isMacintosh?(0,R.normalizeNFC)(U.name):U.name,U))}async function r(M){const U=await w(M),B=[];for(const ee of U)await n.existsDirectory((0,E.join)(M,ee))&&B.push(ee);return B}function a(M,U=1e3){return new Promise(B=>{let ee=!1;const H=setInterval(()=>{ee||(ee=!0,L.access(M,j=>{ee=!1,j&&(clearInterval(H),B(void 0))}))},U)})}e.whenDeleted=a;var n;(function(M){async function U(H){let j;try{if(j=await e.Promises.lstat(H),!j.isSymbolicLink())return{stat:j}}catch{}try{return{stat:await e.Promises.stat(H),symbolicLink:j?.isSymbolicLink()?{dangling:!1}:void 0}}catch(Z){if(Z.code==="ENOENT"&&j)return{stat:j,symbolicLink:{dangling:!0}};if(C.isWindows&&Z.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(H)),symbolicLink:{dangling:!1}}}catch(W){if(W.code==="ENOENT"&&j)return{stat:j,symbolicLink:{dangling:!0}};throw W}throw Z}}M.stat=U;async function B(H){try{const{stat:j,symbolicLink:Z}=await M.stat(H);return j.isFile()&&Z?.dangling!==!0}catch{}return!1}M.existsFile=B;async function ee(H){try{const{stat:j,symbolicLink:Z}=await M.stat(H);return j.isDirectory()&&Z?.dangling!==!0}catch{}return!1}M.existsDirectory=ee})(n=e.SymlinkSupport||(e.SymlinkSupport={}));const t=new _.ResourceQueue;function s(M,U,B){return t.queueFor(b.URI.file(M),P.extUriBiasedIgnorePathCase).queue(()=>{const ee=v(B);return new Promise((H,j)=>u(M,U,ee,Z=>Z?j(Z):H()))})}let o=!0;function u(M,U,B,ee){if(!o)return L.writeFile(M,U,{mode:B.mode,flag:B.flag},ee);L.open(M,B.flag,B.mode,(H,j)=>{if(H)return ee(H);L.writeFile(j,U,Z=>{if(Z)return L.close(j,()=>ee(Z));L.fdatasync(j,W=>(W&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",W),o=!1),L.close(j,z=>ee(z))))})})}function f(M,U,B){const ee=v(B);if(!o)return L.writeFileSync(M,U,{mode:ee.mode,flag:ee.flag});const H=L.openSync(M,ee.flag,ee.mode);try{L.writeFileSync(H,U);try{L.fdatasyncSync(H)}catch(j){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",j),o=!1}}finally{L.closeSync(H)}}e.writeFileSync=f;function v(M){return M?{mode:typeof M.mode=="number"?M.mode:438,flag:typeof M.flag=="string"?M.flag:"w"}:{mode:438,flag:"w"}}async function I(M,U){if(M===U)return;async function B(ee){try{const H=await e.Promises.lstat(ee);if(H.isDirectory()||H.isSymbolicLink())return;await e.Promises.utimes(ee,H.atime,new Date)}catch{}}try{await e.Promises.rename(M,U),await B(U)}catch(ee){if(M.toLowerCase()!==U.toLowerCase()&&ee.code==="EXDEV"||M.endsWith("."))await O(M,U,{preserveSymlinks:!1}),await h(M,S.MOVE),await B(U);else throw ee}}async function O(M,U,B){return N(M,U,{root:{source:M,target:U},options:B,handledSourcePaths:new Set})}const A=511;async function N(M,U,B){if(B.handledSourcePaths.has(M))return;B.handledSourcePaths.add(M);const{stat:ee,symbolicLink:H}=await n.stat(M);if(H){if(B.options.preserveSymlinks)try{return await F(M,U,B)}catch(j){console.warn("[node.js fs] copy of symlink failed: ",j)}if(H.dangling)return}return ee.isDirectory()?$(M,U,ee.mode&A,B):T(M,U,ee.mode&A)}async function $(M,U,B,ee){await e.Promises.mkdir(U,{recursive:!0,mode:B});const H=await w(M);for(const j of H)await N((0,E.join)(M,j),(0,E.join)(U,j),ee)}async function T(M,U,B){await e.Promises.copyFile(M,U),await e.Promises.chmod(U,B)}async function F(M,U,B){let ee=await e.Promises.readlink(M);(0,k.isEqualOrParent)(ee,B.root.source,!C.isLinux)&&(ee=(0,E.join)(B.root.target,ee.substr(B.root.source.length+1))),await e.Promises.symlink(ee,U)}e.Promises=new class{get access(){return(0,D.promisify)(L.access)}get stat(){return(0,D.promisify)(L.stat)}get lstat(){return(0,D.promisify)(L.lstat)}get utimes(){return(0,D.promisify)(L.utimes)}get read(){return(0,D.promisify)(L.read)}get readFile(){return(0,D.promisify)(L.readFile)}get write(){return(0,D.promisify)(L.write)}get appendFile(){return(0,D.promisify)(L.appendFile)}get fdatasync(){return(0,D.promisify)(L.fdatasync)}get truncate(){return(0,D.promisify)(L.truncate)}get rename(){return(0,D.promisify)(L.rename)}get copyFile(){return(0,D.promisify)(L.copyFile)}get open(){return(0,D.promisify)(L.open)}get close(){return(0,D.promisify)(L.close)}get symlink(){return(0,D.promisify)(L.symlink)}get readlink(){return(0,D.promisify)(L.readlink)}get chmod(){return(0,D.promisify)(L.chmod)}get mkdir(){return(0,D.promisify)(L.mkdir)}get unlink(){return(0,D.promisify)(L.unlink)}get rmdir(){return(0,D.promisify)(L.rmdir)}get realpath(){return(0,D.promisify)(L.realpath)}async exists(M){try{return await e.Promises.access(M),!0}catch{return!1}}get readdir(){return w}get readDirsInDir(){return r}get writeFile(){return s}get rm(){return h}get move(){return I}get copy(){return O}}}),define(te[113],ne([0,1,50,9,25,20]),function(Q,e,L,i,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function k(P){const b=(0,i.dirname)(P);if(P===b)return P;const d=((0,i.basename)(P)||P).toLowerCase();try{const h=(0,_.readdirSync)(b).filter(y=>y.toLowerCase()===d);if(h.length===1){const y=k(b);if(y)return(0,i.join)(y,h[0])}else if(h.length>1){const y=h.indexOf(d);if(y>=0){const p=k(b);if(p)return(0,i.join)(p,h[y])}}}catch{}return null}e.realcaseSync=k;async function R(P){try{return await _.Promises.realpath(P)}catch{const d=C(P);return await _.Promises.access(d,L.constants.R_OK),d}}e.realpath=R;function E(P){try{return L.realpathSync(P)}catch{const d=C(P);return L.accessSync(d,L.constants.R_OK),d}}e.realpathSync=E;function C(P){return(0,D.rtrim)((0,i.normalize)(P),i.sep)}}),define(te[114],ne([0,1,55]),function(Q,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function i(R,E,C,P=1){let b=!1;return new Promise(d=>{const S=setTimeout(()=>{if(!b)return b=!0,d(0)},C);D(R,E,P,h=>{if(!b)return b=!0,clearTimeout(S),d(h)})})}e.findFreePort=i;function D(R,E,C,P){if(E===0)return P(0);const b=new L.Socket;b.once("connect",()=>(k(b),D(R+C,E-1,C,P))),b.once("data",()=>{}),b.once("error",d=>(k(b),d.code!=="ECONNREFUSED"?D(R+C,E-1,C,P):P(R))),b.connect(R,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function _(R,E,C){let P=!1,b,d=1;const S=L.createServer({pauseOnConnect:!0});function h(y,p){P||(P=!0,S.removeAllListeners(),S.close(),b&&clearTimeout(b),p(y))}return new Promise(y=>{b=setTimeout(()=>{h(0,y)},C),S.on("listening",()=>{h(R,y)}),S.on("error",p=>{p&&(p.code==="EADDRINUSE"||p.code==="EACCES")&&d<E?(R++,d++,S.listen(R,"127.0.0.1")):h(0,y)}),S.on("close",()=>{h(0,y)}),S.listen(R,"127.0.0.1")})}e.findFreePortFaster=_;function k(R){try{R.removeAllListeners("connect"),R.removeAllListeners("error"),R.end(),R.destroy(),R.unref()}catch(E){console.error(E)}}}),define(te[70],ne([0,1,33,9,20]),function(Q,e,L,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const _=/^\d+$/,k=/^Microsoft.PowerShell_.*/,R=/^Microsoft.PowerShellPreview_.*/;var E;(function(c){c[c.x64=0]="x64",c[c.x86=1]="x86",c[c.ARM=2]="ARM"})(E||(E={}));let C;switch(process.arch){case"ia32":case"x32":C=1;break;case"arm":case"arm64":C=2;break;default:C=0;break}let P;process.env.PROCESSOR_ARCHITEW6432?P=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?P=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?P=1:P=0;class b{constructor(l,r,a){this.exePath=l,this.displayName=r,this.knownToExist=a}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await D.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function d({useAlternateBitness:c=!1}={}){return c?C===0?process.env["ProgramFiles(x86)"]||null:P===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function S({useAlternateBitness:c=!1,findPreview:l=!1}={}){const r=d({useAlternateBitness:c});if(!r)return null;const a=i.join(r,"PowerShell");if(!await D.SymlinkSupport.existsDirectory(a))return null;let n=-1,t=null;for(const u of await D.Promises.readdir(a)){let f=-1;if(l){const I=u.indexOf("-");if(I<0)continue;const O=u.substring(0,I);if(!_.test(O)||u.substring(I+1)!=="preview")continue;f=parseInt(O,10)}else{if(!_.test(u))continue;f=parseInt(u,10)}if(f<=n)continue;const v=i.join(a,u,"pwsh.exe");!await D.SymlinkSupport.existsFile(v)||(t=v,n=f)}if(!t)return null;const s=r.includes("x86")?" (x86)":"",o=l?" Preview":"";return new b(t,`PowerShell${o}${s}`,!0)}async function h({findPreview:c}={}){if(!process.env.LOCALAPPDATA)return null;const l=i.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await D.SymlinkSupport.existsDirectory(l))return null;const{pwshMsixDirRegex:r,pwshMsixName:a}=c?{pwshMsixDirRegex:R,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:k,pwshMsixName:"PowerShell (Store)"};for(const n of await D.Promises.readdir(l))if(r.test(n)){const t=i.join(l,n,"pwsh.exe");return new b(t,a)}return null}function y(){const c=i.join(L.homedir(),".dotnet","tools","pwsh.exe");return new b(c,".NET Core PowerShell Global Tool")}function p(){const c=i.join(process.env.windir,C===1&&P!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new b(c,"Windows PowerShell",!0)}async function*m(){let c=await S();c&&(yield c),c=await S({useAlternateBitness:!0}),c&&(yield c),c=await h(),c&&(yield c),c=y(),c&&(yield c),c=await S({findPreview:!0}),c&&(yield c),c=await h({findPreview:!0}),c&&(yield c),c=await S({useAlternateBitness:!0,findPreview:!0}),c&&(yield c),c=p(),c&&(yield c)}async function*w(){for await(const c of m())await c.exists()&&(yield c)}e.enumeratePowerShellInstallations=w;async function g(){for await(const c of w())return c;return null}e.getFirstAvailablePowerShellInstallation=g}),define(te[115],ne([0,1,44,17]),function(Q,e,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function D(k){return new Promise((R,E)=>{let C;const P=new Map;function b(S,h,y,p,m){const w=P.get(h);if(S===k||w){const g={name:d(y),cmd:y,pid:S,ppid:h,load:p,mem:m};P.set(S,g),S===k&&(C=g),w&&(w.children||(w.children=[]),w.children.push(g),w.children.length>1&&(w.children=w.children.sort((c,l)=>c.pid-l.pid)))}}function d(S){const h=/--vscode-window-kind=shared-process/,y=/--vscode-window-kind=issue-reporter/,p=/--vscode-window-kind=process-explorer/,m=/--utility-sub-type=network/,w=/--crashes-directory/,g=/\\pipe\\winpty-control/,c=/conhost\.exe/,l=/--type=([a-zA-Z-]+)/;if(w.exec(S))return"electron-crash-reporter";if(g.exec(S))return"winpty-process";if(c.exec(S))return"console-window-host (Windows internal process)";let r=l.exec(S);if(r&&r.length===2)return r[1]==="renderer"?h.exec(S)?"shared-process":y.exec(S)?"issue-reporter":p.exec(S)?"process-explorer":"window":r[1]==="utility"&&m.exec(S)?"utility-network-service":r[1];const a=/[a-zA-Z-]+\.js/g;let n="";do r=a.exec(S),r&&(n+=r+" ");while(r);return n&&S.indexOf("node ")<0&&S.indexOf("node.exe")<0?`electron_node ${n}`:S}if(process.platform==="win32"){const S=h=>h.indexOf("\\\\?\\")===0||h.indexOf("\\??\\")===0?h.substr(4):h.indexOf('"\\\\?\\')===0||h.indexOf('"\\??\\')===0?'"'+h.substr(5):h;new Promise((h,y)=>{Q(["windows-process-tree"],h,y)}).then(h=>{h.getProcessList(k,y=>{h.getProcessCpuUsage(y,p=>{const m=new Map;p.forEach(w=>{const g=S(w.commandLine||"");m.set(w.pid,{name:d(g),cmd:g,pid:w.pid,ppid:w.ppid,load:w.cpu||0,mem:w.memory||0})}),C=m.get(k),C?(m.forEach(w=>{const g=m.get(w.ppid);g&&(g.children||(g.children=[]),g.children.push(w))}),m.forEach(w=>{w.children&&(w.children=w.children.sort((g,c)=>g.pid-c.pid))}),R(C)):E(new Error(`Root process ${k} not found`))})},h.ProcessDataFlag.CommandLine|h.ProcessDataFlag.Memory)})}else{let S=function(){let h=[C];const y=[];for(;h.length;){const m=h.shift();m&&(y.push(m.pid),m.children&&(h=h.concat(m.children)))}let p=JSON.stringify(i.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",Q).fsPath);p+=" "+y.join(" "),(0,L.exec)(p,{},(m,w,g)=>{if(m||g)E(m||new Error(g.toString()));else{const c=w.toString().split(`
`);for(let l=0;l<y.length;l++){const r=P.get(y[l]);r.load=parseFloat(c[l])}if(!C){E(new Error(`Root process ${k} not found`));return}R(C)}})};(0,L.exec)("which ps",{},(h,y,p)=>{if(h||p)if(process.platform!=="linux")E(h||new Error(p.toString()));else{const m=JSON.stringify(i.FileAccess.asFileUri("vs/base/node/ps.sh",Q).fsPath);(0,L.exec)(m,{},(w,g,c)=>{w||c?E(w||new Error(c.toString())):(_(g,b),S())})}else{const m=y.toString().trim(),w="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,L.exec)(`${m} ${w}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(g,c,l)=>{g||l&&!l.includes("screen size is bogus")?E(g||new Error(l.toString())):(_(c,b),process.platform==="linux"?S():C?R(C):E(new Error(`Root process ${k} not found`)))})}})}})}e.listProcesses=D;function _(k,R){const E=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,C=k.toString().split(`
`);for(const P of C){const b=E.exec(P.trim());b&&b.length===6&&R(parseInt(b[1]),parseInt(b[2]),b[5],parseFloat(b[3]),parseFloat(b[4]))}}}),define(te[116],ne([0,1,50,27,40,2,69,9,4,20]),function(Q,e,L,i,D,_,k,R,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function P(h,y,p){return d({path:h,isDirectory:!1},y,p)}e.watchFile=P;function b(h,y,p){return d({path:h,isDirectory:!0},y,p)}e.watchFolder=b,e.CHANGE_BUFFER_DELAY=100;function d(h,y,p){if(E.isMacintosh&&(0,D.isEqualOrParent)(h.path,"/Volumes/"))return p(`Refusing to watch ${h.path} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),_.Disposable.None;const m=(0,R.basename)(h.path),w=new Map;let g=!1,c=[(0,_.toDisposable)(()=>{w.forEach(l=>(0,_.dispose)(l)),w.clear()})];try{const l=(0,L.watch)(h.path);c.push((0,_.toDisposable)(()=>{l.removeAllListeners(),l.close()}));const r=new Set;h.isDirectory&&C.Promises.readdir(h.path).then(a=>a.forEach(n=>r.add(n))),l.on("error",(a,n)=>{g||p(`Failed to watch ${h.path} for changes using fs.watch() (${a}, ${n})`)}),l.on("change",(a,n)=>{if(g)return;let t="";if(n&&(t=n.toString(),E.isMacintosh&&(t=(0,k.normalizeNFC)(t))),!t||a!=="change"&&a!=="rename")return;const s=h.isDirectory?(0,R.join)(h.path,t):h.path;if(h.isDirectory)if(a==="rename"){const o=w.get(s);o&&(0,_.dispose)(o);const u=setTimeout(async()=>{w.delete(s);const f=await C.Promises.exists(s);if(g)return;let v;f?r.has(t)?v="changed":(v="added",r.add(t)):(r.delete(t),v="deleted"),y(v,s)},e.CHANGE_BUFFER_DELAY);w.set(s,(0,_.toDisposable)(()=>clearTimeout(u)))}else{let o;r.has(t)?o="changed":(o="added",r.add(t)),y(o,s)}else if(a==="rename"||t!==m){const o=setTimeout(async()=>{const u=await C.Promises.exists(s);g||(u?(y("changed",s),c=[d(h,y,p)]):y("deleted",s))},e.CHANGE_BUFFER_DELAY);(0,_.dispose)(c),c=[(0,_.toDisposable)(()=>clearTimeout(o))]}else y("changed",s)})}catch(l){C.Promises.exists(h.path).then(r=>{r&&!g&&p(`Failed to watch ${h.path} for changes using fs.watch() (${l.toString()})`)})}return(0,_.toDisposable)(()=>{g=!0,c=(0,_.dispose)(c)})}async function S(h,y,p,m=512){const w=await C.Promises.open(h,"r"),g=Buffer.allocUnsafe(m),c=new i.CancellationTokenSource(p);let l,r=!1;const a=P(h,async n=>{if(n==="changed"){if(r)return;r=!0;try{for(;!c.token.isCancellationRequested;){const{bytesRead:t}=await C.Promises.read(w,g,0,m,null);if(!t||c.token.isCancellationRequested)break;y(g.slice(0,t))}}catch(t){l=new Error(t),c.dispose(!0)}finally{r=!1}}},n=>{l=new Error(n),c.dispose(!0)});return new Promise((n,t)=>{c.token.onCancellationRequested(async()=>{a.dispose(),await C.Promises.close(w),l?t(l):n()})})}e.watchFileContents=S});var de=this&&this.__decorate||function(Q,e,L,i){var D=arguments.length,_=D<3?e:i===null?i=Object.getOwnPropertyDescriptor(e,L):i,k;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")_=Reflect.decorate(Q,e,L,i);else for(var R=Q.length-1;R>=0;R--)(k=Q[R])&&(_=(D<3?k(_):D>3?k(e,L,_):k(e,L))||_);return D>3&&_&&Object.defineProperty(e,L,_),_};define(te[36],ne([0,1,16,5,19,27,67,10,3,2,106,25,15]),function(Q,e,L,i,D,_,k,R,E,C,P,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var S;(function(H){H[H.Promise=100]="Promise",H[H.PromiseCancel=101]="PromiseCancel",H[H.EventListen=102]="EventListen",H[H.EventDispose=103]="EventDispose"})(S=e.RequestType||(e.RequestType={}));function h(H){switch(H){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var y;(function(H){H[H.Initialize=200]="Initialize",H[H.PromiseSuccess=201]="PromiseSuccess",H[H.PromiseError=202]="PromiseError",H[H.PromiseErrorObj=203]="PromiseErrorObj",H[H.EventFire=204]="EventFire"})(y=e.ResponseType||(e.ResponseType={}));function p(H){switch(H){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var m;(function(H){H[H.Uninitialized=0]="Uninitialized",H[H.Idle=1]="Idle"})(m||(m={}));class w{constructor(j){this.buffer=j,this.pos=0}read(j){const Z=this.buffer.slice(this.pos,this.pos+j);return this.pos+=Z.byteLength,Z}}class g{constructor(){this.buffers=[]}get buffer(){return D.VSBuffer.concat(this.buffers)}write(j){this.buffers.push(j)}}var c;(function(H){H[H.Undefined=0]="Undefined",H[H.String=1]="String",H[H.Buffer=2]="Buffer",H[H.VSBuffer=3]="VSBuffer",H[H.Array=4]="Array",H[H.Object=5]="Object"})(c||(c={}));function l(H){const j=D.VSBuffer.alloc(4);return j.writeUInt32BE(H,0),j}function r(H){return H.read(4).readUInt32BE(0)}function a(H){const j=D.VSBuffer.alloc(1);return j.writeUInt8(H,0),j}const n={Undefined:a(c.Undefined),String:a(c.String),Buffer:a(c.Buffer),VSBuffer:a(c.VSBuffer),Array:a(c.Array),Object:a(c.Object)},t=typeof Buffer!="undefined";function s(H,j){if(typeof j=="undefined")H.write(n.Undefined);else if(typeof j=="string"){const Z=D.VSBuffer.fromString(j);H.write(n.String),H.write(l(Z.byteLength)),H.write(Z)}else if(t&&Buffer.isBuffer(j)){const Z=D.VSBuffer.wrap(j);H.write(n.Buffer),H.write(l(Z.byteLength)),H.write(Z)}else if(j instanceof D.VSBuffer)H.write(n.VSBuffer),H.write(l(j.byteLength)),H.write(j);else if(Array.isArray(j)){H.write(n.Array),H.write(l(j.length));for(const Z of j)s(H,Z)}else{const Z=D.VSBuffer.fromString(JSON.stringify(j));H.write(n.Object),H.write(l(Z.byteLength)),H.write(Z)}}function o(H){switch(H.read(1).readUInt8(0)){case c.Undefined:return;case c.String:return H.read(r(H)).toString();case c.Buffer:return H.read(r(H)).buffer;case c.VSBuffer:return H.read(r(H));case c.Array:{const Z=r(H),W=[];for(let z=0;z<Z;z++)W.push(o(H));return W}case c.Object:return JSON.parse(H.read(r(H)).toString())}}class u{constructor(j,Z,W=null,z=1e3){this.protocol=j,this.ctx=Z,this.logger=W,this.timeoutDelay=z,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(V=>this.onRawMessage(V)),this.sendResponse({type:200})}registerChannel(j,Z){this.channels.set(j,Z),setTimeout(()=>this.flushPendingRequests(j),0)}sendResponse(j){switch(j.type){case 200:{const Z=this.send([j.type]);this.logger&&this.logger.logOutgoing(Z,0,1,p(j.type));return}case 201:case 202:case 204:case 203:{const Z=this.send([j.type,j.id],j.data);this.logger&&this.logger.logOutgoing(Z,j.id,1,p(j.type),j.data);return}}}send(j,Z=void 0){const W=new g;return s(W,j),s(W,Z),this.sendBuffer(W.buffer)}sendBuffer(j){try{return this.protocol.send(j),j.byteLength}catch{return 0}}onRawMessage(j){const Z=new w(j),W=o(Z),z=o(Z),V=W[0];switch(V){case 100:return this.logger&&this.logger.logIncoming(j.byteLength,W[1],1,`${h(V)}: ${W[2]}.${W[3]}`,z),this.onPromise({type:V,id:W[1],channelName:W[2],name:W[3],arg:z});case 102:return this.logger&&this.logger.logIncoming(j.byteLength,W[1],1,`${h(V)}: ${W[2]}.${W[3]}`,z),this.onEventListen({type:V,id:W[1],channelName:W[2],name:W[3],arg:z});case 101:return this.logger&&this.logger.logIncoming(j.byteLength,W[1],1,`${h(V)}`),this.disposeActiveRequest({type:V,id:W[1]});case 103:return this.logger&&this.logger.logIncoming(j.byteLength,W[1],1,`${h(V)}`),this.disposeActiveRequest({type:V,id:W[1]})}}onPromise(j){const Z=this.channels.get(j.channelName);if(!Z){this.collectPendingRequest(j);return}const W=new _.CancellationTokenSource;let z;try{z=Z.call(this.ctx,j.name,j.arg,W.token)}catch(G){z=Promise.reject(G)}const V=j.id;z.then(G=>{this.sendResponse({id:V,data:G,type:201}),this.activeRequests.delete(j.id)},G=>{G instanceof Error?this.sendResponse({id:V,data:{message:G.message,name:G.name,stack:G.stack?G.stack.split?G.stack.split(`
`):G.stack:void 0},type:202}):this.sendResponse({id:V,data:G,type:203}),this.activeRequests.delete(j.id)});const q=(0,C.toDisposable)(()=>W.cancel());this.activeRequests.set(j.id,q)}onEventListen(j){const Z=this.channels.get(j.channelName);if(!Z){this.collectPendingRequest(j);return}const W=j.id,V=Z.listen(this.ctx,j.name,j.arg)(q=>this.sendResponse({id:W,data:q,type:204}));this.activeRequests.set(j.id,V)}disposeActiveRequest(j){const Z=this.activeRequests.get(j.id);Z&&(Z.dispose(),this.activeRequests.delete(j.id))}collectPendingRequest(j){let Z=this.pendingRequests.get(j.channelName);Z||(Z=[],this.pendingRequests.set(j.channelName,Z));const W=setTimeout(()=>{console.error(`Unknown channel: ${j.channelName}`),j.type===100&&this.sendResponse({id:j.id,data:{name:"Unknown channel",message:`Channel name '${j.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);Z.push({request:j,timeoutTimer:W})}flushPendingRequests(j){const Z=this.pendingRequests.get(j);if(Z){for(const W of Z)switch(clearTimeout(W.timeoutTimer),W.request.type){case 100:this.onPromise(W.request);break;case 102:this.onEventListen(W.request);break}this.pendingRequests.delete(j)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(j=>j.dispose()),this.activeRequests.clear()}}e.ChannelServer=u;var f;(function(H){H[H.LocalSide=0]="LocalSide",H[H.OtherSide=1]="OtherSide"})(f=e.RequestInitiator||(e.RequestInitiator={}));class v{constructor(j,Z=null){this.protocol=j,this.isDisposed=!1,this.state=m.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new E.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(W=>this.onBuffer(W)),this.logger=Z}getChannel(j){const Z=this;return{call(W,z,V){return Z.isDisposed?Promise.reject(R.canceled()):Z.requestPromise(j,W,z,V)},listen(W,z){return Z.isDisposed?Promise.reject(R.canceled()):Z.requestEvent(j,W,z)}}}requestPromise(j,Z,W,z=_.CancellationToken.None){const V=this.lastRequestId++,G={id:V,type:100,channelName:j,name:Z,arg:W};if(z.isCancellationRequested)return Promise.reject(R.canceled());let Y;return new Promise((K,re)=>{if(z.isCancellationRequested)return re(R.canceled());const se=()=>{const ve=ge=>{switch(ge.type){case 201:this.handlers.delete(V),K(ge.data);break;case 202:this.handlers.delete(V);const we=new Error(ge.data.message);we.stack=ge.data.stack,we.name=ge.data.name,re(we);break;case 203:this.handlers.delete(V),re(ge.data);break}};this.handlers.set(V,ve),this.sendRequest(G)};let ce=null;this.state===m.Idle?se():(ce=(0,i.createCancelablePromise)(ve=>this.whenInitialized()),ce.then(()=>{ce=null,se()}));const he=()=>{ce?(ce.cancel(),ce=null):this.sendRequest({id:V,type:101}),re(R.canceled())},me=z.onCancellationRequested(he);Y=(0,C.combinedDisposable)((0,C.toDisposable)(he),me),this.activeRequests.add(Y)}).finally(()=>{this.activeRequests.delete(Y)})}requestEvent(j,Z,W){const z=this.lastRequestId++,q={id:z,type:102,channelName:j,name:Z,arg:W};let G=null;const Y=new E.Emitter({onFirstListenerAdd:()=>{G=(0,i.createCancelablePromise)(K=>this.whenInitialized()),G.then(()=>{G=null,this.activeRequests.add(Y),this.sendRequest(q)})},onLastListenerRemove:()=>{G?(G.cancel(),G=null):(this.activeRequests.delete(Y),this.sendRequest({id:z,type:103}))}}),x=K=>Y.fire(K.data);return this.handlers.set(z,x),Y.event}sendRequest(j){switch(j.type){case 100:case 102:{const Z=this.send([j.type,j.id,j.channelName,j.name],j.arg);this.logger&&this.logger.logOutgoing(Z,j.id,0,`${h(j.type)}: ${j.channelName}.${j.name}`,j.arg);return}case 101:case 103:{const Z=this.send([j.type,j.id]);this.logger&&this.logger.logOutgoing(Z,j.id,0,h(j.type));return}}}send(j,Z=void 0){const W=new g;return s(W,j),s(W,Z),this.sendBuffer(W.buffer)}sendBuffer(j){try{return this.protocol.send(j),j.byteLength}catch{return 0}}onBuffer(j){const Z=new w(j),W=o(Z),z=o(Z),V=W[0];switch(V){case 200:return this.logger&&this.logger.logIncoming(j.byteLength,0,0,p(V)),this.onResponse({type:W[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(j.byteLength,W[1],0,p(V),z),this.onResponse({type:W[0],id:W[1],data:z})}}onResponse(j){if(j.type===200){this.state=m.Idle,this._onDidInitialize.fire();return}const Z=this.handlers.get(j.id);Z&&Z(j)}get onDidInitializePromise(){return E.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===m.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(j=>j.dispose()),this.activeRequests.clear()}}de([k.memoize],v.prototype,"onDidInitializePromise",null),e.ChannelClient=v;class I{constructor(j){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new E.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new E.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,j(({protocol:Z,onDidClientDisconnect:W})=>{E.Event.once(Z.onMessage)(V=>{const q=new w(V),G=o(q),Y=new u(Z,G),x=new v(Z);this.channels.forEach((re,se)=>Y.registerChannel(se,re));const K={channelServer:Y,channelClient:x,ctx:G};this._connections.add(K),this._onDidAddConnection.fire(K),W(()=>{Y.dispose(),x.dispose(),this._connections.delete(K),this._onDidRemoveConnection.fire(K)})})})}get connections(){const j=[];return this._connections.forEach(Z=>j.push(Z)),j}getChannel(j,Z){const W=this;return{call(z,V,q){let G;if((0,d.isFunction)(Z)){let x=(0,L.getRandomElement)(W.connections.filter(Z));G=x?Promise.resolve(x):E.Event.toPromise(E.Event.filter(W.onDidAddConnection,Z))}else G=Z.routeCall(W,z,V);const Y=G.then(x=>x.channelClient.getChannel(j));return A(Y).call(z,V,q)},listen(z,V){if((0,d.isFunction)(Z))return W.getMulticastEvent(j,Z,z,V);const q=Z.routeEvent(W,z,V).then(G=>G.channelClient.getChannel(j));return A(q).listen(z,V)}}}getMulticastEvent(j,Z,W,z){const V=this;let q=new C.DisposableStore;const G=new E.Emitter({onFirstListenerAdd:()=>{q=new C.DisposableStore;const Y=new E.EventMultiplexer,x=new Map,K=se=>{const he=se.channelClient.getChannel(j).listen(W,z),me=Y.add(he);x.set(se,me)},re=se=>{const ce=x.get(se);!ce||(ce.dispose(),x.delete(se))};V.connections.filter(Z).forEach(K),E.Event.filter(V.onDidAddConnection,Z)(K,void 0,q),V.onDidRemoveConnection(re,void 0,q),Y.event(G.fire,G,q),q.add(Y)},onLastListenerRemove:()=>{q.dispose()}});return G.event}registerChannel(j,Z){this.channels.set(j,Z),this._connections.forEach(W=>{W.channelServer.registerChannel(j,Z)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=I;class O{constructor(j,Z,W=null){const z=new g;s(z,Z),j.send(z.buffer),this.channelClient=new v(j,W),this.channelServer=new u(j,Z,W)}getChannel(j){return this.channelClient.getChannel(j)}registerChannel(j,Z){this.channelServer.registerChannel(j,Z)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=O;function A(H){return{call(j,Z,W){return H.then(z=>z.call(j,Z,W))},listen(j,Z){const W=new E.Relay;return H.then(z=>W.input=z.listen(j,Z)),W.event}}}e.getDelayedChannel=A;function N(H){let j=!1;return{call(Z,W,z){return j?H.call(Z,W,z):(0,i.timeout)(0).then(()=>j=!0).then(()=>H.call(Z,W,z))},listen(Z,W){if(j)return H.listen(Z,W);const z=new E.Relay;return(0,i.timeout)(0).then(()=>j=!0).then(()=>z.input=H.listen(Z,W)),z.event}}}e.getNextTickChannel=N;class ${constructor(j){this.fn=j}routeCall(j){return this.route(j)}routeEvent(j){return this.route(j)}async route(j){for(const Z of j.connections)if(await Promise.resolve(this.fn(Z.ctx)))return Promise.resolve(Z);return await E.Event.toPromise(j.onDidAddConnection),await this.route(j)}}e.StaticRouter=$;var T;(function(H){function j(V,q){const G=V,Y=q&&q.disableMarshalling,x=new Map;for(const K in G)W(K)&&x.set(K,E.Event.buffer(G[K],!0));return new class{listen(K,re,se){const ce=x.get(re);if(ce)return ce;if(z(re)){const he=G[re];if(typeof he=="function")return he.call(G,se)}throw new Error(`Event not found: ${re}`)}call(K,re,se){const ce=G[re];if(typeof ce=="function"){if(!Y&&Array.isArray(se))for(let he=0;he<se.length;he++)se[he]=(0,P.revive)(se[he]);return ce.apply(G,se)}throw new Error(`Method not found: ${re}`)}}}H.fromService=j;function Z(V,q){const G=q&&q.disableMarshalling;return new Proxy({},{get(Y,x){if(typeof x=="string")return q?.properties?.has(x)?q.properties.get(x):z(x)?function(K){return V.listen(x,K)}:W(x)?V.listen(x):async function(...K){let re;q&&!(0,d.isUndefinedOrNull)(q.context)?re=[q.context,...K]:re=K;const se=await V.call(x,re);return G?se:(0,P.revive)(se)};throw new Error(`Property not found: ${String(x)}`)}})}H.toService=Z;function W(V){return V[0]==="o"&&V[1]==="n"&&b.isUpperAsciiLetter(V.charCodeAt(2))}function z(V){return/^onDynamic/.test(V)&&b.isUpperAsciiLetter(V.charCodeAt(9))}})(T=e.ProxyChannel||(e.ProxyChannel={}));const F=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function M(H){if(Array.isArray(H))return H;if(H&&typeof H=="object"&&typeof H.toString=="function"){let j=H.toString();if(j!=="[object Object]")return j}return H}function U(H){return Array.isArray(H)?H.map(M):M(H)}function B(H,j,Z,W,z,V,q){q=U(q);const G=F[z],Y=G[W%G.length];let x=[`%c[${H}]%c[${String(j).padStart(7," ")}]%c[len: ${String(Z).padStart(5," ")}]%c${String(W).padStart(5," ")} - ${V}`,"color: darkgreen","color: grey","color: grey",`color: ${Y}`];/\($/.test(V)?(x=x.concat(q),x.push(")")):x.push(q),console.log.apply(console,x)}e.logWithColors=B;class ee{constructor(j,Z){this._outgoingPrefix=j,this._incomingPrefix=Z,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(j,Z,W,z,V){this._totalOutgoing+=j,B(this._outgoingPrefix,this._totalOutgoing,j,Z,W,z,V)}logIncoming(j,Z,W,z,V){this._totalIncoming+=j,B(this._incomingPrefix,this._totalIncoming,j,Z,W,z,V)}}e.IPCLogger=ee}),define(te[117],ne([0,1,19,3,36]),function(Q,e,L,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class _{constructor(E){this.port=E,this.onMessage=i.Event.fromDOMEventEmitter(this.port,"message",C=>L.VSBuffer.wrap(C.data)),E.start()}send(E){this.port.postMessage(E.buffer)}disconnect(){this.port.close()}}e.Protocol=_;class k extends D.IPCClient{constructor(E,C){const P=new _(E);super(P,C);this.protocol=P}dispose(){this.protocol.disconnect()}}e.Client=k}),define(te[71],ne([0,1,19,3,2,36]),function(Q,e,L,i,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var k;(function(t){t.Created="created",t.Read="read",t.Write="write",t.Open="open",t.Error="error",t.Close="close",t.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",t.NodeEndReceived="nodeEndReceived",t.NodeEndSent="nodeEndSent",t.NodeDrainBegin="nodeDrainBegin",t.NodeDrainEnd="nodeDrainEnd",t.zlibInflateError="zlibInflateError",t.zlibInflateData="zlibInflateData",t.zlibInflateInitialWrite="zlibInflateInitialWrite",t.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",t.zlibInflateWrite="zlibInflateWrite",t.zlibInflateFlushFired="zlibInflateFlushFired",t.zlibDeflateError="zlibDeflateError",t.zlibDeflateData="zlibDeflateData",t.zlibDeflateWrite="zlibDeflateWrite",t.zlibDeflateFlushFired="zlibDeflateFlushFired",t.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",t.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",t.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",t.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",t.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",t.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",t.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",t.ProtocolHeaderRead="protocolHeaderRead",t.ProtocolMessageRead="protocolMessageRead",t.ProtocolHeaderWrite="protocolHeaderWrite",t.ProtocolMessageWrite="protocolMessageWrite",t.ProtocolWrite="protocolWrite"})(k=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var R;(function(t){t.enableDiagnostics=!1,t.records=[];const s=new WeakMap;let o=0;function u(v,I){if(!s.has(v)){const O=String(++o);s.set(v,O)}return s.get(v)}function f(v,I,O,A){if(!t.enableDiagnostics)return;const N=u(v,I);if(A instanceof L.VSBuffer||A instanceof Uint8Array||A instanceof ArrayBuffer||ArrayBuffer.isView(A)){const $=L.VSBuffer.alloc(A.byteLength);$.set(A),t.records.push({timestamp:Date.now(),id:N,label:I,type:O,buff:$})}else t.records.push({timestamp:Date.now(),id:N,label:I,type:O,data:A})}t.traceSocketEvent=f})(R=e.SocketDiagnostics||(e.SocketDiagnostics={}));var E;(function(t){t[t.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",t[t.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(E=e.SocketCloseEventType||(e.SocketCloseEventType={}));let C=null;function P(){return C||(C=L.VSBuffer.alloc(0)),C}class b{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(s){this._chunks.push(s),this._totalLength+=s.byteLength}read(s){return this._read(s,!0)}peek(s){return this._read(s,!1)}_read(s,o){if(s===0)return P();if(s>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===s){const I=this._chunks[0];return o&&(this._chunks.shift(),this._totalLength-=s),I}if(this._chunks[0].byteLength>s){const I=this._chunks[0].slice(0,s);return o&&(this._chunks[0]=this._chunks[0].slice(s),this._totalLength-=s),I}let u=L.VSBuffer.alloc(s),f=0,v=0;for(;s>0;){const I=this._chunks[v];if(I.byteLength>s){const O=I.slice(0,s);u.set(O,f),f+=s,o&&(this._chunks[v]=I.slice(s),this._totalLength-=s),s-=s}else u.set(I,f),f+=I.byteLength,o?(this._chunks.shift(),this._totalLength-=I.byteLength):v++,s-=I.byteLength}return u}}e.ChunkStream=b;var d;(function(t){t[t.None=0]="None",t[t.Regular=1]="Regular",t[t.Control=2]="Control",t[t.Ack=3]="Ack",t[t.Disconnect=5]="Disconnect",t[t.ReplayRequest=6]="ReplayRequest",t[t.Pause=7]="Pause",t[t.Resume=8]="Resume"})(d||(d={}));function S(t){switch(t){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var h;(function(t){t[t.HeaderLength=13]="HeaderLength",t[t.AcknowledgeTime=2e3]="AcknowledgeTime",t[t.TimeoutTime=2e4]="TimeoutTime",t[t.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",t[t.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(h=e.ProtocolConstants||(e.ProtocolConstants={}));class y{constructor(s,o,u,f){this.type=s,this.id=o,this.ack=u,this.data=f,this.writtenTime=0}get size(){return this.data.byteLength}}class p extends D.Disposable{constructor(s){super();this._onMessage=this._register(new i.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=s,this._isDisposed=!1,this._incomingData=new b,this._register(this._socket.onData(o=>this.acceptChunk(o))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(s);this._incomingData.byteLength>=this._state.readLen;){const o=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=o.readUInt32BE(9),this._state.messageType=o.readUInt8(0),this._state.id=o.readUInt32BE(1),this._state.ack=o.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:S(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const u=this._state.messageType,f=this._state.id,v=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",o),this._onMessage.fire(new y(u,f,v,o)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class m{constructor(s){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=s,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(s){if(this._isDisposed)return;s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const o=L.VSBuffer.alloc(13);o.writeUInt8(s.type,0),o.writeUInt32BE(s.id,1),o.writeUInt32BE(s.ack,5),o.writeUInt32BE(s.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:S(s.type),id:s.id,ack:s.ack,messageSize:s.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",s.data),this._writeSoon(o,s.data)}_bufferAdd(s,o){const u=this._totalLength===0;return this._data.push(s,o),this._totalLength+=s.byteLength+o.byteLength,u}_bufferTake(){const s=L.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,s}_writeSoon(s,o){this._bufferAdd(s,o)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const s=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:s.byteLength}),this._socket.write(s)}}class w extends D.Disposable{constructor(s){super();this._onMessage=new i.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new i.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=s,this._socketWriter=this._register(new m(this._socket)),this._socketReader=this._register(new p(this._socket)),this._register(this._socketReader.onMessage(o=>{o.type===1&&this._onMessage.fire(o.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(s){this._socketWriter.write(new y(1,0,0,s))}}e.Protocol=w;class g extends _.IPCClient{constructor(s,o,u=null){super(s,o,u);this.protocol=s}static fromSocket(s,o){return new g(new w(s),o)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const s=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),s.end()}}e.Client=g;class c{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new i.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(s){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(s):this._emitter.fire(s):this._bufferedMessages.push(s)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=c;class l{constructor(s){this.data=s,this.next=null}}class r{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let s=[],o=0,u=this._first;for(;u;)s[o++]=u.data,u=u.next;return s}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(s){const o=new l(s);if(!this._first){this._first=o,this._last=o;return}this._last.next=o,this._last=o}}class a{constructor(){this.lastRuns=[];const s=Date.now();for(let o=0;o<a._HISTORY_LENGTH;o++)this.lastRuns[o]=s-1e3*o;setInterval(()=>{for(let o=a._HISTORY_LENGTH;o>=1;o--)this.lastRuns[o]=this.lastRuns[o-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return a._INSTANCE||(a._INSTANCE=new a),a._INSTANCE}load(){const s=Date.now(),o=(1+a._HISTORY_LENGTH)*1e3;let u=0;for(let f=0;f<a._HISTORY_LENGTH;f++)s-this.lastRuns[f]<=o&&u++;return 1-u/a._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}a._HISTORY_LENGTH=10,a._INSTANCE=null;class n{constructor(s,o=null,u=a.getInstance()){this._onControlMessage=new c,this.onControlMessage=this._onControlMessage.event,this._onMessage=new c,this.onMessage=this._onMessage.event,this._onDidDispose=new c,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new c,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new c,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=u,this._isReconnecting=!1,this._outgoingUnackMsg=new r,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=s,this._socketWriter=new m(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new p(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(f=>this._receiveMessage(f))),this._socketDisposables.push(this._socket.onClose(f=>this._onSocketClose.fire(f))),o&&this._socketReader.acceptChunk(o)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,D.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const s=new y(5,0,0,P());this._socketWriter.write(s),this._socketWriter.flush()}sendPause(){const s=new y(7,0,0,P());this._socketWriter.write(s)}sendResume(){const s=new y(8,0,0,P());this._socketWriter.write(s)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(s,o){this._isReconnecting=!0,this._socketDisposables=(0,D.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=s,this._socketWriter=new m(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new p(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(u=>this._receiveMessage(u))),this._socketDisposables.push(this._socket.onClose(u=>this._onSocketClose.fire(u))),this._socketReader.acceptChunk(o)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const s=new y(3,0,this._incomingAckId,P());this._socketWriter.write(s);const o=this._outgoingUnackMsg.toArray();for(let u=0,f=o.length;u<f;u++)this._socketWriter.write(o[u]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(s){if(s.ack>this._outgoingAckId){this._outgoingAckId=s.ack;do{const o=this._outgoingUnackMsg.peek();if(o&&o.id<=s.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(s.type){case 0:break;case 1:{if(s.id>this._incomingMsgId)if(s.id!==this._incomingMsgId+1){const o=Date.now();o-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=o,this._socketWriter.write(new y(6,0,0,P())))}else this._incomingMsgId=s.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(s.data);break}case 2:{this._onControlMessage.fire(s.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const o=this._outgoingUnackMsg.toArray();for(let u=0,f=o.length;u<f;u++)this._socketWriter.write(o[u]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(s){const o=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const u=new y(1,o,this._incomingAckId,s);this._outgoingUnackMsg.push(u),this._isReconnecting||(this._socketWriter.write(u),this._recvAckCheck())}sendControl(s){const o=new y(2,0,0,s);this._socketWriter.write(o)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const s=Date.now()-this._incomingMsgLastTime;if(s>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-s+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const s=this._outgoingUnackMsg.peek(),o=Date.now()-s.writtenTime,u=Date.now()-this._socketReader.lastReadTime,f=Date.now()-this._lastSocketTimeoutTime;if(o>=2e4&&u>=2e4&&f>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire(void 0);return}const v=Math.max(2e4-o,2e4-u,2e4-f,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},v)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const s=new y(3,0,this._incomingAckId,P());this._socketWriter.write(s)}}e.PersistentProtocol=n}),define(te[118],ne([0,1,72,3,36,117]),function(Q,e,L,i,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class k extends D.IPCServer{static getOnDidClientConnect(){const E=i.Event.fromNodeEventEmitter(L.ipcRenderer,"vscode:createMessageChannel",(C,P)=>P);return i.Event.map(E,C=>{const{port1:P,port2:b}=new MessageChannel,S={protocol:new _.Protocol(P),onDidClientDisconnect:i.Event.fromDOMEventEmitter(P,"close")};return L.ipcRenderer.postMessage("vscode:createMessageChannelResult",C,[b]),S})}constructor(){super(k.getOnDidClientConnect())}}e.Server=k}),define(te[119],ne([0,1,19,10]),function(Q,e,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function D(R,E){R.proxyAuthorization&&(R.headers={...R.headers||{},"Proxy-Authorization":R.proxyAuthorization});const C=new XMLHttpRequest;return new Promise((P,b)=>{C.open(R.type||"GET",R.url||"",!0,R.user,R.password),_(C,R),C.responseType="arraybuffer",C.onerror=d=>b(new Error(C.statusText&&"XHR failed: "+C.statusText||"XHR failed")),C.onload=d=>{P({res:{statusCode:C.status,headers:k(C)},stream:(0,L.bufferToStream)(L.VSBuffer.wrap(new Uint8Array(C.response)))})},C.ontimeout=d=>b(new Error(`XHR timeout: ${R.timeout}ms`)),R.timeout&&(C.timeout=R.timeout),C.send(R.data),E.onCancellationRequested(()=>{C.abort(),b((0,i.canceled)())})})}e.request=D;function _(R,E){if(E.headers){e:for(let C in E.headers){switch(C){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}R.setRequestHeader(C,E.headers[C])}}}function k(R){const E=Object.create(null);for(const C of R.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(C){const P=C.indexOf(":");E[C.substr(0,P).trim().toLowerCase()]=C.substr(P+1).trim()}return E}}),define(te[73],ne([0,1,5,3,2,15]),function(Q,e,L,i,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var k;(function(b){b[b.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(k=e.StorageHint||(e.StorageHint={}));function R(b){const d=b;return d?.changed instanceof Map||d?.deleted instanceof Set}e.isStorageItemsChangeEvent=R;var E;(function(b){b[b.None=0]="None",b[b.Initialized=1]="Initialized",b[b.Closed=2]="Closed"})(E||(E={}));class C extends D.Disposable{constructor(d,S=Object.create(null)){super();this.database=d,this.options=S,this._onDidChangeStorage=this._register(new i.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=E.None,this.cache=new Map,this.flushDelayer=new L.ThrottledDelayer(C.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(d=>this.onDidChangeItemsExternal(d)))}onDidChangeItemsExternal(d){d.changed?.forEach((S,h)=>this.accept(h,S)),d.deleted?.forEach(S=>this.accept(S,void 0))}accept(d,S){if(this.state===E.Closed)return;let h=!1;(0,_.isUndefinedOrNull)(S)?h=this.cache.delete(d):this.cache.get(d)!==S&&(this.cache.set(d,S),h=!0),h&&this._onDidChangeStorage.fire(d)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===E.None&&(this.state=E.Initialized,this.options.hint!==k.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(d,S){const h=this.cache.get(d);return(0,_.isUndefinedOrNull)(h)?S:h}getBoolean(d,S){const h=this.get(d);return(0,_.isUndefinedOrNull)(h)?S:h==="true"}getNumber(d,S){const h=this.get(d);return(0,_.isUndefinedOrNull)(h)?S:parseInt(h,10)}async set(d,S){if(this.state===E.Closed)return;if((0,_.isUndefinedOrNull)(S))return this.delete(d);const h=String(S);if(this.cache.get(d)!==h)return this.cache.set(d,h),this.pendingInserts.set(d,h),this.pendingDeletes.delete(d),this._onDidChangeStorage.fire(d),this.doFlush()}async delete(d){if(!(this.state===E.Closed||!this.cache.delete(d)))return this.pendingDeletes.has(d)||this.pendingDeletes.add(d),this.pendingInserts.delete(d),this._onDidChangeStorage.fire(d),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=E.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const d={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(d).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(d){if(!!this.hasPending)return this.doFlush(d)}async doFlush(d){return this.flushDelayer.trigger(()=>this.flushPending(),d)}async whenFlushed(){if(!!this.hasPending)return new Promise(d=>this.whenFlushedCallbacks.push(d))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=C,C.DEFAULT_FLUSH_DELAY=100;class P{constructor(){this.onDidChangeItemsExternal=i.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(d){d.insert&&d.insert.forEach((S,h)=>this.items.set(h,S)),d.delete&&d.delete.forEach(S=>this.items.delete(S))}async close(){}}e.InMemoryStorageDatabase=P}),define(te[120],ne([12,13]),function(Q,e){return Q.create("vs/base/common/date",e)}),define(te[56],ne([0,1,120]),function(Q,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const i=60,D=i*60,_=D*24,k=_*7,R=_*30,E=_*365;function C(b,d){typeof b!="number"&&(b=b.getTime());const S=Math.round((new Date().getTime()-b)/1e3);if(S<-30)return(0,L.localize)(0,null,C(new Date().getTime()+S*1e3,!1));if(S<30)return(0,L.localize)(1,null);let h;return S<i?(h=S,d?h===1?(0,L.localize)(2,null,h):(0,L.localize)(3,null,h):h===1?(0,L.localize)(4,null,h):(0,L.localize)(5,null,h)):S<D?(h=Math.floor(S/i),d?h===1?(0,L.localize)(6,null,h):(0,L.localize)(7,null,h):h===1?(0,L.localize)(8,null,h):(0,L.localize)(9,null,h)):S<_?(h=Math.floor(S/D),d?h===1?(0,L.localize)(10,null,h):(0,L.localize)(11,null,h):h===1?(0,L.localize)(12,null,h):(0,L.localize)(13,null,h)):S<k?(h=Math.floor(S/_),d?h===1?(0,L.localize)(14,null,h):(0,L.localize)(15,null,h):h===1?(0,L.localize)(16,null,h):(0,L.localize)(17,null,h)):S<R?(h=Math.floor(S/k),d?h===1?(0,L.localize)(18,null,h):(0,L.localize)(19,null,h):h===1?(0,L.localize)(20,null,h):(0,L.localize)(21,null,h)):S<E?(h=Math.floor(S/R),d?h===1?(0,L.localize)(22,null,h):(0,L.localize)(23,null,h):h===1?(0,L.localize)(24,null,h):(0,L.localize)(25,null,h)):(h=Math.floor(S/E),d?h===1?(0,L.localize)(26,null,h):(0,L.localize)(27,null,h):h===1?(0,L.localize)(28,null,h):(0,L.localize)(29,null,h))}e.fromNow=C;function P(b){return b.getFullYear()+"-"+String(b.getMonth()+1).padStart(2,"0")+"-"+String(b.getDate()).padStart(2,"0")+"T"+String(b.getHours()).padStart(2,"0")+":"+String(b.getMinutes()).padStart(2,"0")+":"+String(b.getSeconds()).padStart(2,"0")+"."+(b.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=P}),define(te[121],ne([12,13]),function(Q,e){return Q.create("vs/base/common/errorMessage",e)}),define(te[38],ne([0,1,16,15,121]),function(Q,e,L,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function _(C,P){return P&&(C.stack||C.stacktrace)?D.localize(0,null,R(C),k(C.stack)||k(C.stacktrace)):R(C)}function k(C){return Array.isArray(C)?C.join(`
`):C}function R(C){return typeof C.code=="string"&&typeof C.errno=="number"&&typeof C.syscall=="string"?D.localize(1,null,C.message):C.message||D.localize(2,null)}function E(C=null,P=!1){if(!C)return D.localize(3,null);if(Array.isArray(C)){const b=L.coalesce(C),d=E(b[0],P);return b.length>1?D.localize(4,null,d,b.length):d}if(i.isString(C))return C;if(C.detail){const b=C.detail;if(b.error)return _(b.error,P);if(b.exception)return _(b.exception,P)}return C.stack?_(C,P):C.message?C.message:D.localize(5,null)}e.toErrorMessage=E}),define(te[122],ne([12,13]),function(Q,e){return Q.create("vs/base/node/processes",e)}),define(te[74],ne([0,1,44,40,17,28,9,4,32,101,15,110,20,122]),function(Q,e,L,i,D,_,k,R,E,C,P,b,d,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return C.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return C.TerminateResponseCode}});function h(r){switch(r){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function y(r,a){if(R.isWindows)try{const n={stdio:["pipe","pipe","ignore"]};a&&(n.cwd=a);const t=L.execFile("taskkill",["/T","/F","/PID",r.pid.toString()],n);return new Promise(s=>{t.once("error",o=>{s({success:!1,error:o})}),t.once("exit",(o,u)=>{s(o===0?{success:!0}:{success:!1,code:o!==null?o:1})})})}catch(n){return Promise.resolve({success:!1,error:n,code:n.status?h(n.status):1})}else if(R.isLinux||R.isMacintosh)try{const n=D.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",Q).fsPath;return new Promise(t=>{L.execFile(n,[r.pid.toString()],{encoding:"utf8",shell:!0},(s,o,u)=>{t(s?{success:!1,error:s}:{success:!0})})})}catch(n){return Promise.resolve({success:!1,error:n})}else r.kill("SIGKILL");return Promise.resolve({success:!0})}function p(r){!r||(delete r.DEBUG,R.isMacintosh&&delete r.DYLD_LIBRARY_PATH,R.isLinux&&delete r.LD_PRELOAD)}e.removeDangerousEnvVariables=p;function m(r=E.env){return r.comspec||"cmd.exe"}e.getWindowsShell=m;class w{constructor(a,n,t,s){if(n!==void 0&&t!==void 0&&s!==void 0)this.cmd=a,this.args=n,this.shell=t,this.options=s;else{const o=a;this.cmd=o.command,this.shell=o.isShellCommand,this.args=o.args.slice(0),this.options=o.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const o=Object.create(null);Object.keys(E.env).forEach(u=>{o[u]=E.env[u]}),Object.keys(this.options.env).forEach(u=>{o[u]=this.options.env[u]}),this.options.env=o}}getSanitizedCommand(){let a=this.cmd.toLowerCase();const n=a.lastIndexOf(k.sep);return n!==-1&&(a=a.substring(n+1)),w.WellKnowCommands[a]?a:"other"}start(a){return R.isWindows&&(this.options&&this.options.cwd&&i.isUNC(this.options.cwd)||!this.options&&i.isUNC(E.cwd()))?Promise.reject(new Error(S.localize(0,null))):this.useExec().then(n=>{let t,s;const o=new Promise((u,f)=>{t=u,s=f});if(n){let u=this.cmd;this.args&&(u=u+" "+this.args.join(" ")),this.childProcess=L.exec(u,this.options,(f,v,I)=>{this.childProcess=null;const O=f;O&&O.killed?s({killed:this.terminateRequested,stdout:v.toString(),stderr:I.toString()}):this.handleExec(t,a,f,v,I)})}else{let u=null;const f=v=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(v,t,a,s);const I={terminated:this.terminateRequested};P.isNumber(v)&&(I.cmdCode=v),t(I)};if(this.shell&&R.isWindows){const v=_.deepClone(this.options);v.windowsVerbatimArguments=!0,v.detached=!1;let I=!1,O=!1;const A=[];let N=this.ensureQuotes(this.cmd);A.push(N.value),I=N.quoted,this.args&&this.args.forEach(T=>{N=this.ensureQuotes(T),A.push(N.value),O=O&&N.quoted});const $=["/s","/c"];I?O?$.push('"'+A.join(" ")+'"'):A.length>1?$.push('"'+A[0]+'" '+A.slice(1).join(" ")):$.push('"'+A[0]+'"'):$.push(A.join(" ")),u=L.spawn(m(),$,v)}else this.cmd&&(u=L.spawn(this.cmd,this.args,this.options));u&&(this.childProcess=u,this.childProcessPromise=Promise.resolve(u),this.pidResolve&&(this.pidResolve(P.isNumber(u.pid)?u.pid:-1),this.pidResolve=void 0),u.on("error",v=>{this.childProcess=null,s({terminated:this.terminateRequested,error:v})}),u.pid&&(this.childProcess.on("close",f),this.handleSpawn(u,t,a,s,!0)))}return o})}handleClose(a,n,t,s){}ensureQuotes(a){return w.regexp.test(a)?{value:'"'+a+'"',quoted:!0}:{value:a,quoted:a.length>0&&a[0]==='"'&&a[a.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(a=>a.pid,a=>-1):new Promise(a=>{this.pidResolve=a})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(a=>(this.terminateRequested=!0,y(a,this.options.cwd).then(n=>(n.success&&(this.childProcess=null),n))),a=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(a=>{if(!this.shell||!R.isWindows)return a(!1);const n=L.spawn(m(),["/s","/c"]);n.on("error",t=>a(!0)),n.on("exit",t=>a(!1))})}}e.AbstractProcess=w,w.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},w.regexp=/^[^"].* .*[^"]/;class g extends w{constructor(a,n,t,s){super(a,n,t,s);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(a,n,t,s,o){[s,o].forEach((u,f)=>{const v=new b.LineDecoder;v.write(u).forEach(A=>{n({line:A,source:f===0?0:1})});const O=v.end();O&&n({line:O,source:f===0?0:1})}),a({terminated:this.terminateRequested,error:t})}handleSpawn(a,n,t,s,o){const u=new b.LineDecoder,f=new b.LineDecoder;a.stdout.on("data",v=>{u.write(v).forEach(O=>t({line:O,source:0}))}),a.stderr.on("data",v=>{f.write(v).forEach(O=>t({line:O,source:1}))}),this.stdoutLineDecoder=u,this.stderrLineDecoder=f}handleClose(a,n,t,s){const o=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;o&&t({line:o,source:0});const u=this.stderrLineDecoder?this.stderrLineDecoder.end():null;u&&t({line:u,source:1})}}e.LineProcess=g;function c(r){let a=[],n=!1;const t=function(s){if(n){a.push(s);return}(!r.send(s,u=>{if(u&&console.error(u),n=!1,a.length>0){const f=a.slice(0);a=[],f.forEach(v=>t(v))}})||R.isWindows)&&(n=!0)};return{send:t}}e.createQueuedSender=c;var l;(function(r){async function a(n,t,s){if(k.isAbsolute(n))return n;if(t===void 0&&(t=E.cwd()),k.dirname(n)!=="."||(s===void 0&&P.isString(E.env.PATH)&&(s=E.env.PATH.split(k.delimiter)),s===void 0||s.length===0))return k.join(t,n);async function u(f){if(await d.Promises.exists(f)){let v;try{v=await d.Promises.stat(f)}catch(I){I.message.startsWith("EACCES")&&(v=await d.Promises.lstat(f))}return v?!v.isDirectory():!1}return!1}for(let f of s){let v;if(k.isAbsolute(f)?v=k.join(f,n):v=k.join(t,f,n),await u(v))return v;let I=v+".com";if(await u(I)||(I=v+".exe",await u(I)))return I}return k.join(t,n)}r.findExecutable=a})(l=e.win32||(e.win32={}))}),define(te[123],ne([0,1,33,4,70,74]),function(Q,e,L,i,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function k(S,h){return S===1?i.isWindows?b():_.getWindowsShell(h):C(S,h)}e.getSystemShell=k;function R(S,h){return S===1?i.isWindows?d(h):_.getWindowsShell(h):C(S,h)}e.getSystemShellSync=R;let E=null;function C(S,h){if(i.isLinux&&S===2||i.isMacintosh&&S===3)return"/bin/bash";if(!E){let y;if(i.isWindows)y="/bin/bash";else{if(y=h.SHELL,!y)try{y=(0,L.userInfo)().shell}catch{}y||(y="sh"),y==="/bin/false"&&(y="/bin/bash")}E=y}return E}let P=null;async function b(){return P||(P=(await(0,D.getFirstAvailablePowerShellInstallation)()).exePath),P}function d(S){if(P)return P;const h=i.isWindows&&parseFloat((0,L.release)())>=10,y=S.hasOwnProperty("PROCESSOR_ARCHITEW6432"),p=`${S.windir}\\${y?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return h?p:_.getWindowsShell(S)}}),define(te[57],ne([0,1,44,5,19,27,105,10,3,2,28,74,36]),function(Q,e,L,i,D,_,k,R,E,C,P,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class S extends d.ChannelServer{constructor(p){super({send:m=>{try{process.send&&process.send(m.buffer.toString("base64"))}catch{}},onMessage:E.Event.fromNodeEventEmitter(process,"message",m=>D.VSBuffer.wrap(Buffer.from(m,"base64")))},p);process.once("disconnect",()=>this.dispose())}}e.Server=S;class h{constructor(p,m){this.modulePath=p,this.options=m,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new E.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const w=m&&m.timeout?m.timeout:6e4;this.disposeDelayer=new i.Delayer(w),this.child=null,this._client=null}getChannel(p){const m=this;return{call(w,g,c){return m.requestPromise(p,w,g,c)},listen(w,g){return m.requestEvent(p,w,g)}}}requestPromise(p,m,w,g=_.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(g.isCancellationRequested)return Promise.reject(R.canceled());this.disposeDelayer.cancel();const c=this.getCachedChannel(p),l=(0,i.createCancelablePromise)(n=>c.call(m,w,n)),r=g.onCancellationRequested(()=>l.cancel()),a=(0,C.toDisposable)(()=>l.cancel());return this.activeRequests.add(a),l.finally(()=>{r.dispose(),this.activeRequests.delete(a),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),l}requestEvent(p,m,w){if(!this.disposeDelayer)return E.Event.None;this.disposeDelayer.cancel();let g;const c=new E.Emitter({onFirstListenerAdd:()=>{g=this.getCachedChannel(p).listen(m,w)(c.fire,c),this.activeRequests.add(g)},onLastListenerRemove:()=>{this.activeRequests.delete(g),g.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return c.event}get client(){if(!this._client){const p=this.options&&this.options.args?this.options.args:[],m=Object.create(null);m.env={...(0,P.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(m.env={...m.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(m.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(m.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(m.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),m.execArgv===void 0&&(m.execArgv=process.execArgv.filter(t=>!/^--inspect(-brk)?=/.test(t))),(0,b.removeDangerousEnvVariables)(m.env),this.child=(0,L.fork)(this.modulePath,p,m);const w=new E.Emitter;E.Event.fromNodeEventEmitter(this.child,"message",t=>t)(t=>{if((0,k.isRemoteConsoleLog)(t)){(0,k.log)(t,`IPC Library: ${this.options.serverName}`);return}w.fire(D.VSBuffer.wrap(Buffer.from(t,"base64")))});const c=this.options.useQueue?(0,b.createQueuedSender)(this.child):this.child,l=t=>this.child&&this.child.connected&&c.send(t.buffer.toString("base64")),r=w.event,a={send:l,onMessage:r};this._client=new d.ChannelClient(a);const n=()=>this.disposeClient();process.once("exit",n),this.child.on("error",t=>console.warn('IPC "'+this.options.serverName+'" errored with '+t)),this.child.on("exit",(t,s)=>{process.removeListener("exit",n),this.activeRequests.forEach(o=>(0,C.dispose)(o)),this.activeRequests.clear(),t!==0&&s!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+t+" and signal "+s),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:t,signal:s})})}return this._client}getCachedChannel(p){let m=this.channels.get(p);return m||(m=this.client.getChannel(p),this.channels.set(p,m)),m}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=h}),define(te[124],ne([12,13]),function(Q,e){return Q.create("vs/base/node/zip",e)}),define(te[125],ne([12,13]),function(Q,e){return Q.create("vs/platform/configuration/common/configurationRegistry",e)}),define(te[126],ne([12,13]),function(Q,e){return Q.create("vs/platform/environment/node/argv",e)}),define(te[127],ne([12,13]),function(Q,e){return Q.create("vs/platform/environment/node/argvHelper",e)}),define(te[128],ne([12,13]),function(Q,e){return Q.create("vs/platform/environment/node/shellEnv",e)}),define(te[129],ne([12,13]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(te[130],ne([12,13]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(te[131],ne([12,13]),function(Q,e){return Q.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(te[132],ne([12,13]),function(Q,e){return Q.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(te[133],ne([12,13]),function(Q,e){return Q.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(te[134],ne([12,13]),function(Q,e){return Q.create("vs/platform/extensionManagement/node/extensionsScanner",e)}),define(te[135],ne([12,13]),function(Q,e){return Q.create("vs/platform/extensions/common/extensionValidator",e)}),define(te[136],ne([12,13]),function(Q,e){return Q.create("vs/platform/files/common/fileService",e)}),define(te[137],ne([12,13]),function(Q,e){return Q.create("vs/platform/files/common/files",e)}),define(te[138],ne([12,13]),function(Q,e){return Q.create("vs/platform/files/common/io",e)}),define(te[139],ne([12,13]),function(Q,e){return Q.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(te[140],ne([12,13]),function(Q,e){return Q.create("vs/platform/request/common/request",e)}),define(te[141],ne([12,13]),function(Q,e){return Q.create("vs/platform/telemetry/common/telemetryService",e)}),define(te[142],ne([12,13]),function(Q,e){return Q.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(te[143],ne([12,13]),function(Q,e){return Q.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(te[144],ne([12,13]),function(Q,e){return Q.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(te[145],ne([12,13]),function(Q,e){return Q.create("vs/platform/userDataSync/common/settingsSync",e)}),define(te[146],ne([12,13]),function(Q,e){return Q.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(te[147],ne([12,13]),function(Q,e){return Q.create("vs/platform/userDataSync/common/userDataSync",e)}),define(te[148],ne([12,13]),function(Q,e){return Q.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(te[149],ne([0,1,4]),function(Q,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AssignmentFilterProvider=e.Filters=e.TargetPopulation=e.ASSIGNMENT_REFETCH_INTERVAL=e.ASSIGNMENT_STORAGE_KEY=void 0,e.ASSIGNMENT_STORAGE_KEY="VSCode.ABExp.FeatureData",e.ASSIGNMENT_REFETCH_INTERVAL=0;var i;(function(k){k.Team="team",k.Internal="internal",k.Insiders="insider",k.Public="public"})(i=e.TargetPopulation||(e.TargetPopulation={}));var D;(function(k){k.Market="X-MSEdge-Market",k.CorpNet="X-FD-Corpnet",k.ApplicationVersion="X-VSCode-AppVersion",k.Build="X-VSCode-Build",k.ClientId="X-MSEdge-ClientId",k.ExtensionName="X-VSCode-ExtensionName",k.Language="X-VSCode-Language",k.TargetPopulation="X-VSCode-TargetPopulation"})(D=e.Filters||(e.Filters={}));class _{constructor(R,E,C,P){this.version=R,this.appName=E,this.machineId=C,this.targetPopulation=P}getFilterValue(R){switch(R){case D.ApplicationVersion:return this.version;case D.Build:return this.appName;case D.ClientId:return this.machineId;case D.Language:return L.language;case D.ExtensionName:return"vscode-core";case D.TargetPopulation:return this.targetPopulation;default:return""}}getFilters(){let R=new Map,E=Object.values(D);for(let C of E)R.set(C,this.getFilterValue(C));return R}}e.AssignmentFilterProvider=_}),define(te[75],ne([0,1,56,67,17,9,32,18,7]),function(Q,e,L,i,D,_,k,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class C{constructor(y,p,m){this._args=y,this.paths=p,this.productService=m}get appRoot(){return(0,_.dirname)(D.FileAccess.asFileUri("",Q).fsPath)}get userHome(){return E.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return E.URI.file((0,_.join)(this.userDataPath,"User"))}get tmpDir(){return E.URI.file(this.paths.tmpDir)}get cacheHome(){return E.URI.file(this.userDataPath)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,R.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,R.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const y=(0,L.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,_.join)(this.userDataPath,"logs",y)}return this.args.logsPath}get userDataSyncLogResource(){return E.URI.file((0,_.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,R.joinPath)(E.URI.file((0,_.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return E.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return E.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,R.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,R.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const y=k.env.VSCODE_PORTABLE;return y?E.URI.file((0,_.join)(y,"argv.json")):(0,R.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,R.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return E.URI.file((0,_.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,_.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const y=this.args["builtin-extensions-dir"];return y?(0,_.resolve)(y):(0,_.normalize)((0,_.join)(D.FileAccess.asFileUri("",Q).fsPath,"..","extensions"))}get extensionsDownloadPath(){const y=this.args["extensions-download-dir"];return y?(0,_.resolve)(y):(0,_.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const y=this.args["extensions-dir"];if(y)return(0,_.resolve)(y);const p=k.env.VSCODE_EXTENSIONS;if(p)return p;const m=k.env.VSCODE_PORTABLE;return m?(0,_.join)(m,"extensions"):(0,R.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const y=this.args.extensionDevelopmentPath;if(Array.isArray(y))return y.map(p=>/^[^:/?#]+?:\/\//.test(p)?E.URI.parse(p):E.URI.file((0,_.normalize)(p)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(y=>y==="ui"||y==="workspace"||y==="web"?y:"workspace")}get extensionTestsLocationURI(){const y=this.args.extensionTestsPath;if(y)return/^[^:/?#]+?:\/\//.test(y)?E.URI.parse(y):E.URI.file((0,_.normalize)(y))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const y=this.args["disable-extension"];if(y){if(typeof y=="string")return[y];if(Array.isArray(y)&&y.length>0)return y}return!1}get debugExtensionHost(){return P(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!k.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,R.joinPath)(E.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return E.URI.file((0,_.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}de([i.memoize],C.prototype,"appRoot",null),de([i.memoize],C.prototype,"userHome",null),de([i.memoize],C.prototype,"userDataPath",null),de([i.memoize],C.prototype,"appSettingsHome",null),de([i.memoize],C.prototype,"tmpDir",null),de([i.memoize],C.prototype,"cacheHome",null),de([i.memoize],C.prototype,"userRoamingDataHome",null),de([i.memoize],C.prototype,"settingsResource",null),de([i.memoize],C.prototype,"userDataSyncHome",null),de([i.memoize],C.prototype,"userDataSyncLogResource",null),de([i.memoize],C.prototype,"sync",null),de([i.memoize],C.prototype,"machineSettingsResource",null),de([i.memoize],C.prototype,"globalStorageHome",null),de([i.memoize],C.prototype,"workspaceStorageHome",null),de([i.memoize],C.prototype,"keybindingsResource",null),de([i.memoize],C.prototype,"keyboardLayoutResource",null),de([i.memoize],C.prototype,"argvResource",null),de([i.memoize],C.prototype,"snippetsHome",null),de([i.memoize],C.prototype,"isExtensionDevelopment",null),de([i.memoize],C.prototype,"untitledWorkspacesHome",null),de([i.memoize],C.prototype,"installSourcePath",null),de([i.memoize],C.prototype,"builtinExtensionsPath",null),de([i.memoize],C.prototype,"extensionsPath",null),de([i.memoize],C.prototype,"extensionDevelopmentLocationURI",null),de([i.memoize],C.prototype,"extensionDevelopmentKind",null),de([i.memoize],C.prototype,"extensionTestsLocationURI",null),de([i.memoize],C.prototype,"debugExtensionHost",null),de([i.memoize],C.prototype,"serviceMachineIdResource",null),de([i.memoize],C.prototype,"telemetryLogResource",null),de([i.memoize],C.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=C;function P(h,y){return S(h["inspect-extensions"],h["inspect-brk-extensions"],5870,y,h.debugId,h.extensionEnvironment)}e.parseExtensionHostPort=P;function b(h,y){return S(h["inspect-search"],h["inspect-brk-search"],5876,y,h.extensionEnvironment)}e.parseSearchPort=b;function d(h,y){return S(h["inspect-ptyhost"],h["inspect-brk-ptyhost"],5877,y,h.extensionEnvironment)}e.parsePtyHostPort=d;function S(h,y,p,m,w,g){const l=Number(y||h)||(m?null:p),r=l?Boolean(!!y):!1;let a;if(g)try{a=JSON.parse(g)}catch{}return{port:l,break:r,debugId:w,env:a}}}),define(te[150],ne([0,1,244,4,126]),function(Q,e,L,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const _={o:(0,D.localize)(0,null),e:(0,D.localize)(1,null),t:(0,D.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,D.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,D.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,D.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,D.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,D.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,D.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,D.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,D.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,D.localize)(11,null)},"extensions-dir":{type:"string",deprecates:"extensionHomePath",cat:"e",args:"dir",description:(0,D.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,D.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,D.localize)(14,null)},category:{type:"string",cat:"e",description:(0,D.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:(0,D.localize)(16,null)},"pre-release":{type:"boolean",cat:"e",description:(0,D.localize)(17,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:(0,D.localize)(18,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:(0,D.localize)(19,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,D.localize)(20,null)},verbose:{type:"boolean",cat:"t",description:(0,D.localize)(21,null)},log:{type:"string",cat:"t",args:"level",description:(0,D.localize)(22,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,D.localize)(23,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,D.localize)(24,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:"disableExtensions",cat:"t",description:(0,D.localize)(25,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:(0,D.localize)(26,null)},sync:{type:"string",cat:"t",description:(0,D.localize)(27,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:"debugPluginHost",args:"port",cat:"t",description:(0,D.localize)(28,null)},"inspect-brk-extensions":{type:"string",deprecates:"debugBrkPluginHost",args:"port",cat:"t",description:(0,D.localize)(29,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,D.localize)(30,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,D.localize)(31,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,D.localize)(32,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string"},"inspect-brk-ptyhost":{type:"string"},"inspect-search":{type:"string",deprecates:"debugSearch"},"inspect-brk-search":{type:"string",deprecates:"debugBrkSearch"},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const k={onUnknownOption:()=>{},onMultipleValues:()=>{},onDeprecatedOption:()=>{}};function R(h,y,p=k){const m={},w=[],g=[];for(let a in y){const n=y[a];n.alias&&(m[a]=n.alias),n.type==="string"||n.type==="string[]"?(w.push(a),n.deprecates&&w.push(n.deprecates)):n.type==="boolean"&&(g.push(a),n.deprecates&&g.push(n.deprecates))}const c=L(h,{string:w,boolean:g,alias:m}),l={},r=c;l._=c._.map(a=>String(a)).filter(a=>a.length>0),delete r._;for(let a in y){const n=y[a];n.alias&&delete r[n.alias];let t=r[a];n.deprecates&&r.hasOwnProperty(n.deprecates)&&(t||(t=r[n.deprecates],t&&p.onDeprecatedOption(n.deprecates,a)),delete r[n.deprecates]),typeof t!="undefined"&&(n.type==="string[]"?t&&!Array.isArray(t)&&(t=[t]):n.type==="string"&&Array.isArray(t)&&(t=t.pop(),p.onMultipleValues(a,t)),l[a]=t),delete r[a]}for(let a in r)p.onUnknownOption(a);return l}e.parseArgs=R;function E(h,y){let p="";return y.args&&(Array.isArray(y.args)?p=` <${y.args.join("> <")}>`:p=` <${y.args}>`),y.alias?`-${y.alias} --${h}${p}`:`--${h}${p}`}function C(h,y){let p=0,m=[];for(const l in h){const r=h[l],a=E(l,r);p=Math.max(p,a.length),m.push([a,r.description])}let w=p+2+1;if(y-w<25)return m.reduce((l,r)=>l.concat([`  ${r[0]}`,`      ${r[1]}`]),[]);let g=y-w-1,c=[];for(const l of m){let r=l[0],a=b(l[1],g),n=P(w-r.length-2);c.push("  "+r+n+a[0]);for(let t=1;t<a.length;t++)c.push(P(w)+a[t])}return c}e.formatOptions=C;function P(h){return" ".repeat(h)}function b(h,y){let p=[];for(;h.length;){let m=h.length<y?h.length:h.lastIndexOf(" ",y),w=h.slice(0,m).trim();h=h.slice(m),p.push(w)}return p}function d(h,y,p,m,w){const g=process.stdout.isTTY&&process.stdout.columns||80,c=w?.noInputFiles!==!0?`[${(0,D.localize)(33,null)}...]`:"",l=[`${h} ${p}`];l.push(""),l.push(`${(0,D.localize)(34,null)}: ${y} [${(0,D.localize)(35,null)}]${c}`),l.push(""),w?.noPipe!==!0&&(i.isWindows?l.push((0,D.localize)(36,null,y)):l.push((0,D.localize)(37,null,y)),l.push(""));const r={};for(const a in m){const n=m[a];if(n.description&&n.cat){let t=r[n.cat];t||(r[n.cat]=t={}),t[a]=n}}for(let a in r){const n=a;let t=r[n];t&&(l.push(_[n]),l.push(...C(t,g)),l.push(""))}return l.join(`
`)}e.buildHelpMessage=d;function S(h,y){return`${h||(0,D.localize)(38,null)}
${y||(0,D.localize)(39,null)}
${process.arch}`}e.buildVersionMessage=S}),function(){"use strict";function Q(e,L,i,D){function _(R){const E=k(R),C=[E];return e.isAbsolute(E)||C.unshift(D),e.resolve(...C)}function k(R){const E=process.env.VSCODE_PORTABLE;if(E)return e.join(E,"user-data");let C=process.env.VSCODE_APPDATA;if(C)return e.join(C,i);const P=R["user-data-dir"];if(P)return P;switch(process.platform){case"win32":if(C=process.env.APPDATA,!C){const b=process.env.USERPROFILE;if(typeof b!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");C=e.join(b,"AppData","Roaming")}break;case"darwin":C=e.join(L.homedir(),"Library","Application Support");break;case"linux":C=process.env.XDG_CONFIG_HOME||e.join(L.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(C,i)}return{getUserDataPath:_}}if(typeof define=="function")define(te[151],ne([0,152,33,17,18,32]),function(e,L,i,D,_,k){const R=_.dirname(D.FileAccess.asFileUri("",e)),E=e.__$__nodeRequire(_.joinPath(R,"package.json").fsPath);return Q(L,i,E.name,k.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),L=require("path"),i=require("os");module.exports=Q(L,i,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(te[153],ne([0,1,33,75,151]),function(Q,e,L,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class _ extends i.AbstractNativeEnvironmentService{constructor(R,E){super(R,{homeDir:(0,L.homedir)(),tmpDir:(0,L.tmpdir)(),userDataDir:(0,D.getUserDataPath)(R)},E)}}e.NativeEnvironmentService=_}),define(te[154],ne([0,1,7]),function(Q,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const i=/^([^@:]+@)?([^:]+):/,D=/^([^@:]+@)?([^:]+):(.+)$/,_=/^([^@]+@)?([^:]+)(:\d+)?$/,k=/([^@:.]+\.[^@:.]+)(:\d+)?$/,R=/^\s*url\s*=\s*(.+\S)\s*$/mg,E=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function C(p){const m=p.match(k);return m?m[1]:null}function P(p){if(p.indexOf("://")===-1){const m=p.match(i);return m?C(m[2]):null}try{const m=L.URI.parse(p);if(m.authority)return C(m.authority)}catch{}return null}function b(p,m){const w=new Set;let g;for(;g=R.exec(p);){const l=P(g[1]);l&&w.add(l)}const c=new Set(m);return Array.from(w).map(l=>c.has(l)?l:l.replace(E,"a"))}e.getDomainsOfRemotes=b;function d(p){const m=p.match(_);return m?m[2]:null}function S(p,m,w){return p&&m?(w&&m.endsWith(".git")&&(m=m.substr(0,m.length-4)),m.indexOf("/")===0?`${p}${m}`:`${p}/${m}`):null}function h(p,m){if(p.indexOf("://")===-1){const w=p.match(D);if(w)return S(w[2],w[3],m)}try{const w=L.URI.parse(p);if(w.authority)return S(d(w.authority),w.path,m)}catch{}return null}function y(p,m=!1){const w=[];let g;for(;g=R.exec(p);){const c=h(g[1],m);c&&w.push(c)}return w}e.getRemotes=y}),define(te[155],ne([0,1,28]),function(Q,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;const i=/^%([\w\d.-]+)%$/i;function D(_,k){const R=E=>{if(typeof E!="string")return;const C=i.exec(E);if(!C)return;const P=k[C[1]]??E;return typeof P=="string"?P:typeof P.message=="string"?P.message:E};return(0,L.cloneAndChange)(_,R)}e.localizeManifest=D}),define(te[156],ne([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class L{constructor(_){this.channel=_}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(_,k,R,E){return this.channel.call("promptImportantExtensionsInstallNotification",[_,k,R,E])}promptWorkspaceRecommendations(_){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=L;class i{constructor(_){this.service=_}listen(_,k){throw new Error(`Event not found: ${k}`)}call(_,k,R){switch(k){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(R[0],R[1],R[2],R[3])}throw new Error(`Call not found: ${k}`)}}e.ExtensionRecommendationNotificationServiceChannel=i}),define(te[76],ne([0,1,135]),function(Q,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const i=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,D=/^-(\d{4})(\d{2})(\d{2})$/;function _(d){return d=d.trim(),d==="*"||i.test(d)}e.isValidVersionStr=_;function k(d){if(!_(d))return null;if(d=d.trim(),d==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let S=d.match(i);return S?{hasCaret:S[1]==="^",hasGreaterEquals:S[1]===">=",majorBase:S[2]==="x"?0:parseInt(S[2],10),majorMustEqual:S[2]!=="x",minorBase:S[4]==="x"?0:parseInt(S[4],10),minorMustEqual:S[4]!=="x",patchBase:S[6]==="x"?0:parseInt(S[6],10),patchMustEqual:S[6]!=="x",preRelease:S[8]||null}:null}e.parseVersion=k;function R(d){if(!d)return null;let S=d.majorBase,h=d.majorMustEqual,y=d.minorBase,p=d.minorMustEqual,m=d.patchBase,w=d.patchMustEqual;d.hasCaret&&(S===0||(p=!1),w=!1);let g=0;if(d.preRelease){const c=D.exec(d.preRelease);if(c){const[,l,r,a]=c;g=Date.UTC(Number(l),Number(r)-1,Number(a))}}return{majorBase:S,majorMustEqual:h,minorBase:y,minorMustEqual:p,patchBase:m,patchMustEqual:w,isMinimum:d.hasGreaterEquals,notBefore:g}}e.normalizeVersion=R;function E(d,S,h){let y;typeof d=="string"?y=R(k(d)):y=d;let p;S instanceof Date?p=S.getTime():typeof S=="string"&&(p=new Date(S).getTime());let m;if(typeof h=="string"?m=R(k(h)):m=h,!y||!m)return!1;let w=y.majorBase,g=y.minorBase,c=y.patchBase,l=m.majorBase,r=m.minorBase,a=m.patchBase,n=m.notBefore,t=m.majorMustEqual,s=m.minorMustEqual,o=m.patchMustEqual;return m.isMinimum?w>l?!0:w<l?!1:g>r?!0:g<r||p&&p<n?!1:c>=a:(w===1&&l===0&&(!t||!s||!o)&&(l=1,r=0,a=0,t=!0,s=!1,o=!1),w<l?!1:w>l?!t:g<r?!1:g>r?!s:c<a?!1:c>a?!o:!(p&&p<n))}e.isValidVersion=E;function C(d,S,h,y){return h.isBuiltin||typeof h.main=="undefined"?!0:b(d,S,h.engines.vscode,y)}e.isValidExtensionVersion=C;function P(d,S,h){return d==="*"||b(S,h,d)}e.isEngineValid=P;function b(d,S,h,y=[]){let p=R(k(h));if(!p)return y.push(L.localize(0,null,h)),!1;if(p.majorBase===0){if(!p.majorMustEqual||!p.minorMustEqual)return y.push(L.localize(1,null,h)),!1}else if(!p.majorMustEqual)return y.push(L.localize(2,null,h)),!1;return E(d,S,p)?!0:(y.push(L.localize(3,null,d,h)),!1)}}),define(te[51],ne([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class L{constructor(D,_=[],k=!1){this.ctor=D,this.staticArguments=_,this.supportsDelayedInstantiation=k}}e.SyncDescriptor=L}),define(te[77],ne([0,1,51]),function(Q,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const i=[];function D(k,R,E){R instanceof L.SyncDescriptor||(R=new L.SyncDescriptor(R,[],E)),i.push([k,R])}e.registerSingleton=D;function _(){return i}e.getSingletonServiceDescriptors=_}),define(te[157],ne([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class L{constructor(_){this.incoming=new Map,this.outgoing=new Map,this.data=_}}e.Node=L;class i{constructor(_){this._hashFn=_,this._nodes=new Map}roots(){const _=[];for(let k of this._nodes.values())k.outgoing.size===0&&_.push(k);return _}insertEdge(_,k){const R=this.lookupOrInsertNode(_),E=this.lookupOrInsertNode(k);R.outgoing.set(this._hashFn(k),E),E.incoming.set(this._hashFn(_),R)}removeNode(_){const k=this._hashFn(_);this._nodes.delete(k);for(let R of this._nodes.values())R.outgoing.delete(k),R.incoming.delete(k)}lookupOrInsertNode(_){const k=this._hashFn(_);let R=this._nodes.get(k);return R||(R=new L(_),this._nodes.set(k,R)),R}lookup(_){return this._nodes.get(this._hashFn(_))}isEmpty(){return this._nodes.size===0}toString(){let _=[];for(let[k,R]of this._nodes)_.push(`${k}, (incoming)[${[...R.incoming.keys()].join(", ")}], (outgoing)[${[...R.outgoing.keys()].join(",")}]`);return _.join(`
`)}findCycleSlow(){for(let[_,k]of this._nodes){const R=new Set([_]),E=this._findCycle(k,R);if(E)return E}}_findCycle(_,k){for(let[R,E]of _.outgoing){if(k.has(R))return[...k,R].join(" -> ");k.add(R);const C=this._findCycle(E,k);if(C)return C;k.delete(R)}}}e.Graph=i}),define(te[6],ne([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var L;(function(k){k.serviceIds=new Map,k.DI_TARGET="$di$target",k.DI_DEPENDENCIES="$di$dependencies";function R(E){return E[k.DI_DEPENDENCIES]||[]}k.getServiceDependencies=R})(L=e._util||(e._util={})),e.IInstantiationService=D("instantiationService");function i(k,R,E,C){R[L.DI_TARGET]===R?R[L.DI_DEPENDENCIES].push({id:k,index:E,optional:C}):(R[L.DI_DEPENDENCIES]=[{id:k,index:E,optional:C}],R[L.DI_TARGET]=R)}function D(k){if(L.serviceIds.has(k))return L.serviceIds.get(k);const R=function(E,C,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");i(R,E,P,!1)};return R.toString=()=>k,L.serviceIds.set(k,R),R}e.createDecorator=D;function _(k){return k}e.refineServiceDecorator=_}),define(te[158],ne([0,1,6]),function(Q,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,L.createDecorator)("checksumService")}),define(te[21],ne([0,1,15,7,6]),function(Q,e,L,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,D.createDecorator)("configurationService");function _(p){return p&&typeof p=="object"&&(!p.overrideIdentifier||typeof p.overrideIdentifier=="string")&&(!p.resource||p.resource instanceof i.URI)}e.isConfigurationOverrides=_;function k(p){return p&&typeof p=="object"&&(!p.overrideIdentifiers||L.isArray(p.overrideIdentifiers))&&!p.overrideIdentifier&&(!p.resource||p.resource instanceof i.URI)}e.isConfigurationUpdateOverrides=k;var R;(function(p){p[p.USER=1]="USER",p[p.USER_LOCAL=2]="USER_LOCAL",p[p.USER_REMOTE=3]="USER_REMOTE",p[p.WORKSPACE=4]="WORKSPACE",p[p.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",p[p.DEFAULT=6]="DEFAULT",p[p.MEMORY=7]="MEMORY"})(R=e.ConfigurationTarget||(e.ConfigurationTarget={}));function E(p){switch(p){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=E;function C(p,m){const w=Object.create(null);for(let g in p)P(w,g,p[g],m);return w}e.toValuesTree=C;function P(p,m,w,g){const c=m.split("."),l=c.pop();let r=p;for(let a=0;a<c.length;a++){let n=c[a],t=r[n];switch(typeof t){case"undefined":t=r[n]=Object.create(null);break;case"object":break;default:g(`Ignoring ${m} as ${c.slice(0,a+1).join(".")} is ${JSON.stringify(t)}`);return}r=t}if(typeof r=="object"&&r!==null)try{r[l]=w}catch{g(`Ignoring ${m} as ${c.join(".")} is ${JSON.stringify(r)}`)}else g(`Ignoring ${m} as ${c.join(".")} is ${JSON.stringify(r)}`)}e.addToValueTree=P;function b(p,m){const w=m.split(".");d(p,w)}e.removeFromValueTree=b;function d(p,m){const w=m.shift();if(m.length===0){delete p[w];return}if(Object.keys(p).indexOf(w)!==-1){const g=p[w];typeof g=="object"&&!Array.isArray(g)&&(d(g,m),Object.keys(g).length===0&&delete p[w])}}function S(p,m,w){function g(r,a){let n=r;for(const t of a){if(typeof n!="object"||n===null)return;n=n[t]}return n}const c=m.split("."),l=g(p,c);return typeof l=="undefined"?w:l}e.getConfigurationValue=S;function h(p,m,w){Object.keys(m).forEach(g=>{g!=="__proto__"&&(g in p?L.isObject(p[g])&&L.isObject(m[g])?h(p[g],m[g],w):w&&(p[g]=m[g]):p[g]=m[g])})}e.merge=h;function y(p,m,w){const g=p.inspect(m),c=p.inspect(w);return typeof g.userValue!="undefined"||typeof g.workspaceValue!="undefined"||typeof g.workspaceFolderValue!="undefined"?g.value:typeof c.userValue!="undefined"||typeof c.workspaceValue!="undefined"||typeof c.workspaceFolderValue!="undefined"?c.value:g.defaultValue}e.getMigratedSettingValue=y}),define(te[159],ne([0,1,4,25,6]),function(Q,e,L,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let _=L.userAgent||"";const k=new Map;k.set("false",!1),k.set("true",!0),k.set("isMac",L.isMacintosh),k.set("isLinux",L.isLinux),k.set("isWindows",L.isWindows),k.set("isWeb",L.isWeb),k.set("isMacNative",L.isMacintosh&&!L.isWeb),k.set("isEdge",_.indexOf("Edg/")>=0),k.set("isFirefox",_.indexOf("Firefox")>=0),k.set("isChrome",_.indexOf("Chrome")>=0),k.set("isSafari",_.indexOf("Safari")>=0);const R=Object.prototype.hasOwnProperty;var E;(function($){$[$.False=0]="False",$[$.True=1]="True",$[$.Defined=2]="Defined",$[$.Not=3]="Not",$[$.Equals=4]="Equals",$[$.NotEquals=5]="NotEquals",$[$.And=6]="And",$[$.Regex=7]="Regex",$[$.NotRegex=8]="NotRegex",$[$.Or=9]="Or",$[$.In=10]="In",$[$.NotIn=11]="NotIn",$[$.Greater=12]="Greater",$[$.GreaterEquals=13]="GreaterEquals",$[$.Smaller=14]="Smaller",$[$.SmallerEquals=15]="SmallerEquals"})(E=e.ContextKeyExprType||(e.ContextKeyExprType={}));class C{static false(){return d.INSTANCE}static true(){return S.INSTANCE}static has(T){return h.create(T)}static equals(T,F){return y.create(T,F)}static notEquals(T,F){return w.create(T,F)}static regex(T,F){return t.create(T,F)}static in(T,F){return p.create(T,F)}static not(T){return g.create(T)}static and(...T){return u.create(T,null)}static or(...T){return f.create(T,null,!0)}static greater(T,F){return l.create(T,F)}static greaterEquals(T,F){return r.create(T,F)}static smaller(T,F){return a.create(T,F)}static smallerEquals(T,F){return n.create(T,F)}static deserialize(T,F=!1){if(!!T)return this._deserializeOrExpression(T,F)}static _deserializeOrExpression(T,F){let M=T.split("||");return f.create(M.map(U=>this._deserializeAndExpression(U,F)),null,!0)}static _deserializeAndExpression(T,F){let M=T.split("&&");return u.create(M.map(U=>this._deserializeOne(U,F)),null)}static _deserializeOne(T,F){if(T=T.trim(),T.indexOf("!=")>=0){let M=T.split("!=");return w.create(M[0].trim(),this._deserializeValue(M[1],F))}if(T.indexOf("==")>=0){let M=T.split("==");return y.create(M[0].trim(),this._deserializeValue(M[1],F))}if(T.indexOf("=~")>=0){let M=T.split("=~");return t.create(M[0].trim(),this._deserializeRegexValue(M[1],F))}if(T.indexOf(" in ")>=0){let M=T.split(" in ");return p.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(T)){const M=T.split(">=");return r.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(T)){const M=T.split(">");return l.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(T)){const M=T.split("<=");return n.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(T)){const M=T.split("<");return a.create(M[0].trim(),M[1].trim())}return/^\!\s*/.test(T)?g.create(T.substr(1).trim()):h.create(T)}static _deserializeValue(T,F){if(T=T.trim(),T==="true")return!0;if(T==="false")return!1;let M=/^'([^']*)'$/.exec(T);return M?M[1].trim():T}static _deserializeRegexValue(T,F){if((0,i.isFalsyOrWhitespace)(T)){if(F)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let M=T.indexOf("/"),U=T.lastIndexOf("/");if(M===U||M<0){if(F)throw new Error(`bad regexp-value '${T}', missing /-enclosure`);return console.warn(`bad regexp-value '${T}', missing /-enclosure`),null}let B=T.slice(M+1,U),ee=T[U+1]==="i"?"i":"";try{return new RegExp(B,ee)}catch(H){if(F)throw new Error(`bad regexp-value '${T}', parse error: ${H}`);return console.warn(`bad regexp-value '${T}', parse error: ${H}`),null}}}e.ContextKeyExpr=C;function P($,T){const F=$?$.substituteConstants():void 0,M=T?T.substituteConstants():void 0;return!F&&!M?!0:!F||!M?!1:F.equals(M)}e.expressionsAreEqualWithConstantSubstitution=P;function b($,T){return $.cmp(T)}class d{constructor(){this.type=0}cmp(T){return this.type-T.type}equals(T){return T.type===this.type}substituteConstants(){return this}evaluate(T){return!1}serialize(){return"false"}keys(){return[]}map(T){return this}negate(){return S.INSTANCE}}e.ContextKeyFalseExpr=d,d.INSTANCE=new d;class S{constructor(){this.type=1}cmp(T){return this.type-T.type}equals(T){return T.type===this.type}substituteConstants(){return this}evaluate(T){return!0}serialize(){return"true"}keys(){return[]}map(T){return this}negate(){return d.INSTANCE}}e.ContextKeyTrueExpr=S,S.INSTANCE=new S;class h{constructor(T,F){this.key=T,this.negated=F,this.type=2}static create(T,F=null){const M=k.get(T);return typeof M=="boolean"?M?S.INSTANCE:d.INSTANCE:new h(T,F)}cmp(T){return T.type!==this.type?this.type-T.type:I(this.key,T.key)}equals(T){return T.type===this.type?this.key===T.key:!1}substituteConstants(){const T=k.get(this.key);return typeof T=="boolean"?T?S.INSTANCE:d.INSTANCE:this}evaluate(T){return!!T.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(T){return T.mapDefined(this.key)}negate(){return this.negated||(this.negated=g.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=h;class y{constructor(T,F,M){this.key=T,this.value=F,this.negated=M,this.type=4}static create(T,F,M=null){if(typeof F=="boolean")return F?h.create(T,M):g.create(T,M);const U=k.get(T);return typeof U=="boolean"?F===(U?"true":"false")?S.INSTANCE:d.INSTANCE:new y(T,F,M)}cmp(T){return T.type!==this.type?this.type-T.type:O(this.key,this.value,T.key,T.value)}equals(T){return T.type===this.type?this.key===T.key&&this.value===T.value:!1}substituteConstants(){const T=k.get(this.key);if(typeof T=="boolean"){const F=T?"true":"false";return this.value===F?S.INSTANCE:d.INSTANCE}return this}evaluate(T){return T.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(T){return T.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=w.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=y;class p{constructor(T,F){this.key=T,this.valueKey=F,this.type=10,this.negated=null}static create(T,F){return new p(T,F)}cmp(T){return T.type!==this.type?this.type-T.type:O(this.key,this.valueKey,T.key,T.valueKey)}equals(T){return T.type===this.type?this.key===T.key&&this.valueKey===T.valueKey:!1}substituteConstants(){return this}evaluate(T){const F=T.getValue(this.valueKey),M=T.getValue(this.key);return Array.isArray(F)?F.indexOf(M)>=0:typeof M=="string"&&typeof F=="object"&&F!==null?R.call(F,M):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(T){return T.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=m.create(this)),this.negated}}e.ContextKeyInExpr=p;class m{constructor(T){this._actual=T,this.type=11}static create(T){return new m(T)}cmp(T){return T.type!==this.type?this.type-T.type:this._actual.cmp(T._actual)}equals(T){return T.type===this.type?this._actual.equals(T._actual):!1}substituteConstants(){return this}evaluate(T){return!this._actual.evaluate(T)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(T){return new m(this._actual.map(T))}negate(){return this._actual}}e.ContextKeyNotInExpr=m;class w{constructor(T,F,M){this.key=T,this.value=F,this.negated=M,this.type=5}static create(T,F,M=null){if(typeof F=="boolean")return F?g.create(T,M):h.create(T,M);const U=k.get(T);return typeof U=="boolean"?F===(U?"true":"false")?d.INSTANCE:S.INSTANCE:new w(T,F,M)}cmp(T){return T.type!==this.type?this.type-T.type:O(this.key,this.value,T.key,T.value)}equals(T){return T.type===this.type?this.key===T.key&&this.value===T.value:!1}substituteConstants(){const T=k.get(this.key);if(typeof T=="boolean"){const F=T?"true":"false";return this.value===F?d.INSTANCE:S.INSTANCE}return this}evaluate(T){return T.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(T){return T.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=y.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=w;class g{constructor(T,F){this.key=T,this.negated=F,this.type=3}static create(T,F=null){const M=k.get(T);return typeof M=="boolean"?M?d.INSTANCE:S.INSTANCE:new g(T,F)}cmp(T){return T.type!==this.type?this.type-T.type:I(this.key,T.key)}equals(T){return T.type===this.type?this.key===T.key:!1}substituteConstants(){const T=k.get(this.key);return typeof T=="boolean"?T?d.INSTANCE:S.INSTANCE:this}evaluate(T){return!T.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(T){return T.mapNot(this.key)}negate(){return this.negated||(this.negated=h.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=g;function c($,T){if(typeof $=="string"){const F=parseFloat($);isNaN(F)||($=F)}return typeof $=="string"||typeof $=="number"?T($):d.INSTANCE}class l{constructor(T,F,M){this.key=T,this.value=F,this.negated=M,this.type=12}static create(T,F,M=null){return c(F,U=>new l(T,U,M))}cmp(T){return T.type!==this.type?this.type-T.type:O(this.key,this.value,T.key,T.value)}equals(T){return T.type===this.type?this.key===T.key&&this.value===T.value:!1}substituteConstants(){return this}evaluate(T){return typeof this.value=="string"?!1:parseFloat(T.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(T){return T.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=n.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=l;class r{constructor(T,F,M){this.key=T,this.value=F,this.negated=M,this.type=13}static create(T,F,M=null){return c(F,U=>new r(T,U,M))}cmp(T){return T.type!==this.type?this.type-T.type:O(this.key,this.value,T.key,T.value)}equals(T){return T.type===this.type?this.key===T.key&&this.value===T.value:!1}substituteConstants(){return this}evaluate(T){return typeof this.value=="string"?!1:parseFloat(T.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(T){return T.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=a.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=r;class a{constructor(T,F,M){this.key=T,this.value=F,this.negated=M,this.type=14}static create(T,F,M=null){return c(F,U=>new a(T,U,M))}cmp(T){return T.type!==this.type?this.type-T.type:O(this.key,this.value,T.key,T.value)}equals(T){return T.type===this.type?this.key===T.key&&this.value===T.value:!1}substituteConstants(){return this}evaluate(T){return typeof this.value=="string"?!1:parseFloat(T.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(T){return T.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=r.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=a;class n{constructor(T,F,M){this.key=T,this.value=F,this.negated=M,this.type=15}static create(T,F,M=null){return c(F,U=>new n(T,U,M))}cmp(T){return T.type!==this.type?this.type-T.type:O(this.key,this.value,T.key,T.value)}equals(T){return T.type===this.type?this.key===T.key&&this.value===T.value:!1}substituteConstants(){return this}evaluate(T){return typeof this.value=="string"?!1:parseFloat(T.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(T){return T.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=l.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=n;class t{constructor(T,F){this.key=T,this.regexp=F,this.type=7,this.negated=null}static create(T,F){return new t(T,F)}cmp(T){if(T.type!==this.type)return this.type-T.type;if(this.key<T.key)return-1;if(this.key>T.key)return 1;const F=this.regexp?this.regexp.source:"",M=T.regexp?T.regexp.source:"";return F<M?-1:F>M?1:0}equals(T){if(T.type===this.type){const F=this.regexp?this.regexp.source:"",M=T.regexp?T.regexp.source:"";return this.key===T.key&&F===M}return!1}substituteConstants(){return this}evaluate(T){let F=T.getValue(this.key);return this.regexp?this.regexp.test(F):!1}serialize(){const T=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${T}`}keys(){return[this.key]}map(T){return T.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=s.create(this)),this.negated}}e.ContextKeyRegexExpr=t;class s{constructor(T){this._actual=T,this.type=8}static create(T){return new s(T)}cmp(T){return T.type!==this.type?this.type-T.type:this._actual.cmp(T._actual)}equals(T){return T.type===this.type?this._actual.equals(T._actual):!1}substituteConstants(){return this}evaluate(T){return!this._actual.evaluate(T)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(T){return new s(this._actual.map(T))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=s;function o($){let T=null;for(let F=0,M=$.length;F<M;F++){const U=$[F].substituteConstants();if($[F]!==U&&T===null){T=[];for(let B=0;B<F;B++)T[B]=$[B]}T!==null&&(T[F]=U)}return T===null?$:T}class u{constructor(T,F){this.expr=T,this.negated=F,this.type=6}static create(T,F){return u._normalizeArr(T,F)}cmp(T){if(T.type!==this.type)return this.type-T.type;if(this.expr.length<T.expr.length)return-1;if(this.expr.length>T.expr.length)return 1;for(let F=0,M=this.expr.length;F<M;F++){const U=b(this.expr[F],T.expr[F]);if(U!==0)return U}return 0}equals(T){if(T.type===this.type){if(this.expr.length!==T.expr.length)return!1;for(let F=0,M=this.expr.length;F<M;F++)if(!this.expr[F].equals(T.expr[F]))return!1;return!0}return!1}substituteConstants(){const T=o(this.expr);return T===this.expr?this:u.create(T,this.negated)}evaluate(T){for(let F=0,M=this.expr.length;F<M;F++)if(!this.expr[F].evaluate(T))return!1;return!0}static _normalizeArr(T,F){const M=[];let U=!1;for(const B of T)if(!!B){if(B.type===1){U=!0;continue}if(B.type===0)return d.INSTANCE;if(B.type===6){M.push(...B.expr);continue}M.push(B)}if(M.length===0&&U)return S.INSTANCE;if(M.length!==0){if(M.length===1)return M[0];M.sort(b);for(let B=1;B<M.length;B++)M[B-1].equals(M[B])&&(M.splice(B,1),B--);if(M.length===1)return M[0];for(;M.length>1;){const B=M[M.length-1];if(B.type!==9)break;M.pop();const ee=M.pop(),H=M.length===0,j=f.create(B.expr.map(Z=>u.create([Z,ee],null)),null,H);j&&(M.push(j),M.sort(b))}return M.length===1?M[0]:new u(M,F)}}serialize(){return this.expr.map(T=>T.serialize()).join(" && ")}keys(){const T=[];for(let F of this.expr)T.push(...F.keys());return T}map(T){return new u(this.expr.map(F=>F.map(T)),null)}negate(){if(!this.negated){const T=[];for(let F of this.expr)T.push(F.negate());this.negated=f.create(T,this,!0)}return this.negated}}class f{constructor(T,F){this.expr=T,this.negated=F,this.type=9}static create(T,F,M){return f._normalizeArr(T,F,M)}cmp(T){if(T.type!==this.type)return this.type-T.type;if(this.expr.length<T.expr.length)return-1;if(this.expr.length>T.expr.length)return 1;for(let F=0,M=this.expr.length;F<M;F++){const U=b(this.expr[F],T.expr[F]);if(U!==0)return U}return 0}equals(T){if(T.type===this.type){if(this.expr.length!==T.expr.length)return!1;for(let F=0,M=this.expr.length;F<M;F++)if(!this.expr[F].equals(T.expr[F]))return!1;return!0}return!1}substituteConstants(){const T=o(this.expr);return T===this.expr?this:f.create(T,this.negated,!1)}evaluate(T){for(let F=0,M=this.expr.length;F<M;F++)if(this.expr[F].evaluate(T))return!0;return!1}static _normalizeArr(T,F,M){let U=[],B=!1;if(T){for(let ee=0,H=T.length;ee<H;ee++){const j=T[ee];if(!!j){if(j.type===0){B=!0;continue}if(j.type===1)return S.INSTANCE;if(j.type===9){U=U.concat(j.expr);continue}U.push(j)}}if(U.length===0&&B)return d.INSTANCE;U.sort(b)}if(U.length!==0){if(U.length===1)return U[0];for(let ee=1;ee<U.length;ee++)U[ee-1].equals(U[ee])&&(U.splice(ee,1),ee--);if(U.length===1)return U[0];if(M){for(let ee=0;ee<U.length;ee++)for(let H=ee+1;H<U.length;H++)A(U[ee],U[H])&&(U.splice(H,1),H--);if(U.length===1)return U[0]}return new f(U,F)}}serialize(){return this.expr.map(T=>T.serialize()).join(" || ")}keys(){const T=[];for(let F of this.expr)T.push(...F.keys());return T}map(T){return new f(this.expr.map(F=>F.map(T)),null)}negate(){if(!this.negated){let T=[];for(let F of this.expr)T.push(F.negate());for(;T.length>1;){const F=T.shift(),M=T.shift(),U=[];for(const ee of N(F))for(const H of N(M))U.push(u.create([ee,H],null));const B=T.length===0;T.unshift(f.create(U,null,B))}this.negated=T[0]}return this.negated}}class v extends h{constructor(T,F,M){super(T,null);this._defaultValue=F,typeof M=="object"?v._info.push({...M,key:T}):M!==!0&&v._info.push({key:T,description:M,type:F!=null?typeof F:void 0})}static all(){return v._info.values()}bindTo(T){return T.createKey(this.key,this._defaultValue)}getValue(T){return T.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(T){return y.create(this.key,T)}notEqualsTo(T){return w.create(this.key,T)}}e.RawContextKey=v,v._info=[],e.IContextKeyService=(0,D.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function I($,T){return $<T?-1:$>T?1:0}function O($,T,F,M){return $<F?-1:$>F?1:T<M?-1:T>M?1:0}function A($,T){if(T.type===6&&$.type!==9&&$.type!==6){for(const U of T.expr)if($.equals(U))return!0}const F=$.negate(),M=N(F).concat(N(T));M.sort(b);for(let U=0;U<M.length;U++){const ee=M[U].negate();for(let H=U+1;H<M.length;H++){const j=M[H];if(ee.equals(j))return!0}}return!1}e.implies=A;function N($){return $.type===9?$.expr:[$]}}),define(te[78],ne([0,1,6]),function(Q,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,L.createDecorator)(e.ID);function i(D){return!!D.hostName&&!!D.errorMessage}e.isRemoteDiagnosticError=i}),define(te[79],ne([0,1,6]),function(Q,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,L.createDecorator)("downloadService")}),define(te[11],ne([0,1,6]),function(Q,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,L.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,L.refineServiceDecorator)(e.IEnvironmentService)}),define(te[29],ne([0,1,17,130,6]),function(Q,e,L,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";var _;(function(g){g.WIN32_X64="win32-x64",g.WIN32_IA32="win32-ia32",g.WIN32_ARM64="win32-arm64",g.LINUX_X64="linux-x64",g.LINUX_ARM64="linux-arm64",g.LINUX_ARMHF="linux-armhf",g.ALPINE_X64="alpine-x64",g.ALPINE_ARM64="alpine-arm64",g.DARWIN_X64="darwin-x64",g.DARWIN_ARM64="darwin-arm64",g.WEB="web",g.UNIVERSAL="universal",g.UNKNOWN="unknown",g.UNDEFINED="undefined"})(_=e.TargetPlatform||(e.TargetPlatform={}));function k(g){switch(g){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=k;function R(g){switch(g){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=R;function E(g,c){switch(g){case 3:return c==="x64"?"win32-x64":c==="ia32"?"win32-ia32":c==="arm64"?"win32-arm64":"unknown";case 2:return c==="x64"?"linux-x64":c==="arm64"?"linux-arm64":c==="arm"?"linux-armhf":"unknown";case"alpine":return c==="x64"?"alpine-x64":c==="arm64"?"alpine-arm64":"unknown";case 1:return c==="x64"?"darwin-x64":c==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=E;function C(g,c){return c==="web"&&!g.includes("web")}e.isNotWebExtensionInWebTargetPlatform=C;function P(g,c,l){return C(c,l)?!1:g==="undefined"||g==="universal"?!0:g==="unknown"?!1:g===l?!0:b(l).includes(g)}e.isTargetPlatformCompatible=P;function b(g){switch(g){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=b;function d(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(!g.uuid||typeof g.uuid=="string")}e.isIExtensionIdentifier=d;var S;(function(g){g[g.NoneOrRelevance=0]="NoneOrRelevance",g[g.LastUpdatedDate=1]="LastUpdatedDate",g[g.Title=2]="Title",g[g.PublisherName=3]="PublisherName",g[g.InstallCount=4]="InstallCount",g[g.PublishedDate=10]="PublishedDate",g[g.AverageRating=6]="AverageRating",g[g.WeightedRating=12]="WeightedRating"})(S=e.SortBy||(e.SortBy={}));var h;(function(g){g[g.Default=0]="Default",g[g.Ascending=1]="Ascending",g[g.Descending=2]="Descending"})(h=e.SortOrder||(e.SortOrder={}));var y;(function(g){g.Install="install",g.Uninstall="uninstall"})(y=e.StatisticType||(e.StatisticType={}));var p;(function(g){g[g.None=1]="None",g[g.Install=2]="Install",g[g.Update=3]="Update",g[g.Migrate=4]="Migrate"})(p=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,D.createDecorator)("extensionGalleryService");var m;(function(g){g.Unsupported="Unsupported",g.UnsupportedPreRelease="UnsupportedPreRelease",g.Malicious="Malicious",g.Incompatible="Incompatible",g.IncompatiblePreRelease="IncompatiblePreRelease",g.IncompatibleTargetPlatform="IncompatibleTargetPlatform",g.Invalid="Invalid",g.Download="Download",g.Extract="Extract",g.Delete="Delete",g.Rename="Rename",g.CorruptZip="CorruptZip",g.IncompleteZip="IncompleteZip",g.Internal="Internal"})(m=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class w extends Error{constructor(c,l){super(c);this.code=l,this.name=l}}e.ExtensionManagementError=w,e.IExtensionManagementService=(0,D.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,D.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,D.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=L.FileAccess.asBrowserUri("./media/defaultIcon.png",Q).toString(!0),e.ExtensionsLabel=(0,i.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,i.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,D.createDecorator)("IExtensionManagementCLIService")});var J=this&&this.__param||function(Q,e){return function(L,i){e(L,i,Q)}};define(te[160],ne([0,1,2,29]),function(Q,e,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsCleaner=void 0;let D=class extends L.Disposable{constructor(k){super();k.removeDeprecatedExtensions(),k.migrateUnsupportedExtensions()}};D=de([J(0,i.IExtensionManagementService)],D),e.ExtensionsCleaner=D}),define(te[161],ne([0,1,3,2,28,7,109,29]),function(Q,e,L,i,D,_,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function E(y,p){return _.URI.revive(p?p.transformIncoming(y):y)}function C(y,p){return p?p.transformOutgoingURI(y):y}function P(y,p){p=p||k.DefaultURITransformer;const m=y.manifest;return{...(0,k.transformAndReviveIncomingURIs)({...y,manifest:void 0},p),manifest:m}}function b(y,p){return p?(0,D.cloneAndChange)(y,m=>m instanceof _.URI?p.transformOutgoingURI(m):void 0):y}class d{constructor(p,m){this.service=p,this.getUriTransformer=m,this.onInstallExtension=L.Event.buffer(p.onInstallExtension,!0),this.onDidInstallExtensions=L.Event.buffer(p.onDidInstallExtensions,!0),this.onUninstallExtension=L.Event.buffer(p.onUninstallExtension,!0),this.onDidUninstallExtension=L.Event.buffer(p.onDidUninstallExtension,!0)}listen(p,m){const w=this.getUriTransformer(p);switch(m){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return L.Event.map(this.onDidInstallExtensions,g=>g.map(c=>({...c,local:c.local?b(c.local,w):c.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(p,m,w){const g=this.getUriTransformer(p);switch(m){case"zip":return this.service.zip(P(w[0],g)).then(c=>C(c,g));case"unzip":return this.service.unzip(E(w[0],g));case"install":return this.service.install(E(w[0],g),w[1]);case"getManifest":return this.service.getManifest(E(w[0],g));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(w[0]);case"installFromGallery":return this.service.installFromGallery(w[0],w[1]);case"uninstall":return this.service.uninstall(P(w[0],g),w[1]);case"reinstallFromGallery":return this.service.reinstallFromGallery(P(w[0],g));case"getInstalled":return this.service.getInstalled(w[0]).then(c=>c.map(l=>b(l,g)));case"updateMetadata":return this.service.updateMetadata(P(w[0],g),w[1]).then(c=>b(c,g));case"updateExtensionScope":return this.service.updateExtensionScope(P(w[0],g),w[1]).then(c=>b(c,g));case"getExtensionsControlManifest":return this.service.getExtensionsControlManifest()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=d;class S extends i.Disposable{constructor(p){super();this.channel=p,this._onInstallExtension=this._register(new L.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new L.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new L.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new L.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this._register(this.channel.listen("onInstallExtension")(m=>this._onInstallExtension.fire({identifier:m.identifier,source:this.isUriComponents(m.source)?_.URI.revive(m.source):m.source}))),this._register(this.channel.listen("onDidInstallExtensions")(m=>this._onDidInstallExtensions.fire(m.map(w=>({...w,local:w.local?P(w.local,null):w.local,source:this.isUriComponents(w.source)?_.URI.revive(w.source):w.source}))))),this._register(this.channel.listen("onUninstallExtension")(m=>this._onUninstallExtension.fire(m))),this._register(this.channel.listen("onDidUninstallExtension")(m=>this._onDidUninstallExtension.fire(m)))}isUriComponents(p){return p?typeof p.path=="string"&&typeof p.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(p){const m=await this.getTargetPlatform();return p.allTargetPlatforms.some(w=>(0,R.isTargetPlatformCompatible)(w,p.allTargetPlatforms,m))}zip(p){return Promise.resolve(this.channel.call("zip",[p]).then(m=>_.URI.revive(m)))}unzip(p){return Promise.resolve(this.channel.call("unzip",[p]))}install(p,m){return Promise.resolve(this.channel.call("install",[p,m])).then(w=>P(w,null))}getManifest(p){return Promise.resolve(this.channel.call("getManifest",[p]))}installFromGallery(p,m){return Promise.resolve(this.channel.call("installFromGallery",[p,m])).then(w=>P(w,null))}uninstall(p,m){return Promise.resolve(this.channel.call("uninstall",[p,m]))}reinstallFromGallery(p){return Promise.resolve(this.channel.call("reinstallFromGallery",[p]))}getInstalled(p=null){return Promise.resolve(this.channel.call("getInstalled",[p])).then(m=>m.map(w=>P(w,null)))}updateMetadata(p,m){return Promise.resolve(this.channel.call("updateMetadata",[p,m])).then(w=>P(w,null))}updateExtensionScope(p,m){return Promise.resolve(this.channel.call("updateExtensionScope",[p,m])).then(w=>P(w,null))}getExtensionsControlManifest(){return Promise.resolve(this.channel.call("getExtensionsControlManifest"))}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=S;class h{constructor(p){this.service=p}listen(p,m){throw new Error("Invalid listen")}call(p,m,w){switch(m){case"getConfigBasedTips":return this.service.getConfigBasedTips(_.URI.revive(w[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=h}),define(te[80],ne([0,1,6]),function(Q,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var i;(function(k){k[k.FILE=1]="FILE",k[k.WORKSPACE=2]="WORKSPACE",k[k.EXE=3]="EXE"})(i=e.RecommendationSource||(e.RecommendationSource={}));function D(k){switch(k){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=D;var _;(function(k){k.Ignored="ignored",k.Cancelled="cancelled",k.TooMany="toomany",k.IncompatibleWindow="incompatibleWindow",k.Accepted="reacted"})(_=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,L.createDecorator)("IExtensionRecommendationNotificationService")}),define(te[14],ne([0,1,39,9,25,15,7,137,6]),function(Q,e,L,i,D,_,k,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,E.createDecorator)("fileService");function C(M){return M.create===!0}e.isFileOpenForWriteOptions=C;var P;(function(M){M[M.Unknown=0]="Unknown",M[M.File=1]="File",M[M.Directory=2]="Directory",M[M.SymbolicLink=64]="SymbolicLink"})(P=e.FileType||(e.FileType={}));var b;(function(M){M[M.Readonly=1]="Readonly"})(b=e.FilePermission||(e.FilePermission={}));var d;(function(M){M[M.FileReadWrite=2]="FileReadWrite",M[M.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",M[M.FileReadStream=16]="FileReadStream",M[M.FileFolderCopy=8]="FileFolderCopy",M[M.PathCaseSensitive=1024]="PathCaseSensitive",M[M.Readonly=2048]="Readonly",M[M.Trash=4096]="Trash",M[M.FileWriteUnlock=8192]="FileWriteUnlock"})(d=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function S(M){return!!(M.capabilities&2)}e.hasReadWriteCapability=S;function h(M){return!!(M.capabilities&8)}e.hasFileFolderCopyCapability=h;function y(M){return!!(M.capabilities&4)}e.hasOpenReadWriteCloseCapability=y;function p(M){return!!(M.capabilities&16)}e.hasFileReadStreamCapability=p;var m;(function(M){M.FileExists="EntryExists",M.FileNotFound="EntryNotFound",M.FileNotADirectory="EntryNotADirectory",M.FileIsADirectory="EntryIsADirectory",M.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",M.FileTooLarge="EntryTooLarge",M.FileWriteLocked="EntryWriteLocked",M.NoPermissions="NoPermissions",M.Unavailable="Unavailable",M.Unknown="Unknown"})(m=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class w extends Error{constructor(U,B){super(U);this.code=B}}e.FileSystemProviderError=w;function g(M,U){const B=new w(M.toString(),U);return l(B,U),B}e.createFileSystemProviderError=g;function c(M){return M||g((0,R.localize)(0,null),m.Unknown)}e.ensureFileSystemProviderError=c;function l(M,U){return M.name=U?`${U} (FileSystemError)`:"FileSystemError",M}e.markAsFileSystemProviderError=l;function r(M){if(!M)return m.Unknown;if(M instanceof w)return M.code;const U=/^(.+) \(FileSystemError\)$/.exec(M.name);if(!U)return m.Unknown;switch(U[1]){case m.FileExists:return m.FileExists;case m.FileIsADirectory:return m.FileIsADirectory;case m.FileNotADirectory:return m.FileNotADirectory;case m.FileNotFound:return m.FileNotFound;case m.FileExceedsMemoryLimit:return m.FileExceedsMemoryLimit;case m.FileTooLarge:return m.FileTooLarge;case m.FileWriteLocked:return m.FileWriteLocked;case m.NoPermissions:return m.NoPermissions;case m.Unavailable:return m.Unavailable}return m.Unknown}e.toFileSystemProviderErrorCode=r;function a(M){if(M instanceof f)return M.fileOperationResult;switch(r(M)){case m.FileNotFound:return 1;case m.FileIsADirectory:return 0;case m.FileNotADirectory:return 10;case m.FileWriteLocked:return 5;case m.NoPermissions:return 6;case m.FileExists:return 4;case m.FileExceedsMemoryLimit:return 9;case m.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=a;var n;(function(M){M[M.CREATE=0]="CREATE",M[M.DELETE=1]="DELETE",M[M.MOVE=2]="MOVE",M[M.COPY=3]="COPY"})(n=e.FileOperation||(e.FileOperation={}));class t{constructor(U,B,ee){this.resource=U,this.operation=B,this.target=ee}isOperation(U){return this.operation===U}}e.FileOperationEvent=t;var s;(function(M){M[M.UPDATED=0]="UPDATED",M[M.ADDED=1]="ADDED",M[M.DELETED=2]="DELETED"})(s=e.FileChangeType||(e.FileChangeType={}));class o{constructor(U,B){this.added=void 0,this.updated=void 0,this.deleted=void 0;const ee=new Map;for(const H of U){const j=ee.get(H.type);j?j.push([H.resource,H]):ee.set(H.type,[[H.resource,H]])}for(const[H,j]of ee)switch(H){case 1:this.added=L.TernarySearchTree.forUris(()=>B),this.added.fill(j);break;case 0:this.updated=L.TernarySearchTree.forUris(()=>B),this.updated.fill(j);break;case 2:this.deleted=L.TernarySearchTree.forUris(()=>B),this.deleted.fill(j);break}}contains(U,...B){return this.doContains(U,{includeChildren:!1},...B)}affects(U,...B){return this.doContains(U,{includeChildren:!0},...B)}doContains(U,B,...ee){if(!U)return!1;const H=ee.length>0;return!!((!H||ee.includes(1))&&(this.added?.get(U)||B.includeChildren&&this.added?.findSuperstr(U))||(!H||ee.includes(0))&&(this.updated?.get(U)||B.includeChildren&&this.updated?.findSuperstr(U))||(!H||ee.includes(2))&&(this.deleted?.findSubstr(U)||B.includeChildren&&this.deleted?.findSuperstr(U)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=o;function u(M,U,B){return!M||!U||M===U||U.length>M.length?!1:(U.charAt(U.length-1)!==i.sep&&(U+=i.sep),B?(0,D.startsWithIgnoreCase)(M,U):M.indexOf(U)===0)}e.isParent=u;class f extends Error{constructor(U,B,ee){super(U);this.fileOperationResult=B,this.options=ee}}e.FileOperationError=f;class v extends f{constructor(U,B,ee){super(U,2,ee);this.stat=B}}e.NotModifiedSinceFileOperationError=v;var I;(function(M){M[M.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",M[M.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",M[M.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",M[M.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",M[M.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",M[M.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",M[M.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",M[M.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",M[M.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",M[M.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",M[M.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",M[M.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(I=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var O;(function(M){M[M.FILE=0]="FILE",M[M.FOLDER=1]="FOLDER",M[M.ROOT_FOLDER=2]="ROOT_FOLDER"})(O=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function A(M){if(!(typeof M.size!="number"||typeof M.mtime!="number"))return M.mtime.toString(29)+M.size.toString(31)}e.etag=A;async function N(M,U){if(!U.hasProvider(k.URI.from({scheme:M.scheme})))return new Promise(B=>{const ee=U.onDidChangeFileSystemProviderRegistrations(H=>{H.scheme===M.scheme&&H.added&&(ee.dispose(),B())})})}e.whenProviderRegistered=N,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class ${static formatSize(U){return(0,_.isNumber)(U)||(U=0),U<$.KB?(0,R.localize)(1,null,U.toFixed(0)):U<$.MB?(0,R.localize)(2,null,(U/$.KB).toFixed(2)):U<$.GB?(0,R.localize)(3,null,(U/$.MB).toFixed(2)):U<$.TB?(0,R.localize)(4,null,(U/$.GB).toFixed(2)):(0,R.localize)(5,null,(U/$.TB).toFixed(2))}}e.ByteSize=$,$.KB=1024,$.MB=$.KB*$.KB,$.GB=$.MB*$.KB,$.TB=$.GB*$.KB;var T;(function(M){M[M.IA32=0]="IA32",M[M.OTHER=1]="OTHER"})(T=e.Arch||(e.Arch={}));function F(M){return{maxFileSize:M===0?300*$.MB:16*$.GB,maxHeapSize:M===0?700*$.MB:2*700*$.MB}}e.getPlatformLimits=F}),define(te[162],ne([0,1,81,49,14]),function(Q,e,L,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let _=class{constructor(R){this.fileService=R}async checksum(R){const E=(await this.fileService.readFileStream(R)).value;return new Promise((C,P)=>{const b=(0,L.createHash)("md5");(0,i.listenStream)(E,{onData:d=>b.update(d.buffer),onError:d=>P(d),onEnd:()=>C(b.digest("base64").replace(/=+$/,""))})})}};_=de([J(0,D.IFileService)],_),e.ChecksumService=_}),define(te[163],ne([0,1,245,127,150,14]),function(Q,e,L,i,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function k(d,S){const h={onUnknownOption:p=>{console.warn((0,i.localize)(0,null,p))},onMultipleValues:(p,m)=>{console.warn((0,i.localize)(1,null,p,m))},onDeprecatedOption:(p,m)=>{console.warn((0,i.localize)(2,null,p,m))}},y=(0,D.parseArgs)(d,D.OPTIONS,S?h:void 0);return y.goto&&y._.forEach(p=>L(/^(\w:)?[^:]+(:\d*){0,2}$/.test(p),(0,i.localize)(3,null))),y["max-memory"]&&L(parseInt(y["max-memory"])>=_.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${_.MIN_MAX_MEMORY_SIZE_MB} MB.`),y}function R(d){const S=d.findIndex(h=>!/^-/.test(h));if(S>-1)return[...d.slice(0,S),...d.slice(S+1)]}function E(d){let[,...S]=d;process.env.VSCODE_DEV&&(S=R(S)||[]);const h=!b(process.env);return k(S,h)}e.parseMainProcessArgv=E;function C(d){const[,,...S]=d;return k(S,!0)}e.parseCLIProcessArgv=C;function P(d,...S){const h=d.indexOf("--");return h===-1?d.push(...S):d.splice(h,0,...S),d}e.addArg=P;function b(d){return d.VSCODE_CLI==="1"}e.isLaunchedFromCli=b}),define(te[164],ne([0,1,44,9,128,27,38,10,4,30,123,163,5]),function(Q,e,L,i,D,_,k,R,E,C,P,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const S=1e4;let h;async function y(m,w,g){return w["force-disable-user-env"]?(m.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):E.isWindows?(m.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,b.isLaunchedFromCli)(g)&&!w["force-user-env"]?(m.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,b.isLaunchedFromCli)(g)?m.trace("resolveShellEnv(): running (--force-user-env)"):m.trace("resolveShellEnv(): running (macOS/Linux)"),h||(h=d.Promises.withAsyncBody(async(c,l)=>{const r=new _.CancellationTokenSource,a=setTimeout(()=>{r.dispose(!0),l(new Error((0,D.localize)(0,null)))},S);try{c(await p(m,r.token))}catch(n){!(0,R.isPromiseCanceledError)(n)&&!r.token.isCancellationRequested?l(new Error((0,D.localize)(1,null,(0,k.toErrorMessage)(n)))):c({})}finally{clearTimeout(a),r.dispose()}})),h)}e.getResolvedShellEnv=y;async function p(m,w){const g=process.env.ELECTRON_RUN_AS_NODE;m.trace("getUnixShellEnvironment#runAsNode",g);const c=process.env.ELECTRON_NO_ATTACH_CONSOLE;m.trace("getUnixShellEnvironment#noAttach",c);const l=(0,C.generateUuid)().replace(/-/g,"").substr(0,12),r=new RegExp(l+"(.*)"+l),a={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};m.trace("getUnixShellEnvironment#env",a);const n=await(0,P.getSystemShell)(E.OS,a);return m.trace("getUnixShellEnvironment#shell",n),new Promise((t,s)=>{if(w.isCancellationRequested)return s((0,R.canceled)());const o=(0,i.basename)(n);let u,f;const v=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(o)?(u=`& '${process.execPath}' ${v} -p '''${l}'' + JSON.stringify(process.env) + ''${l}'''`,f=["-Login","-Command"]):(u=`'${process.execPath}' ${v} -p '"${l}" + JSON.stringify(process.env) + "${l}"'`,o==="tcsh"?f=["-ic"]:f=["-ilc"]),m.trace("getUnixShellEnvironment#spawn",JSON.stringify(f),u);const I=(0,L.spawn)(n,[...f,u],{detached:!0,stdio:["ignore","pipe","pipe"],env:a});w.onCancellationRequested(()=>(I.kill(),s((0,R.canceled)()))),I.on("error",N=>{m.error("getUnixShellEnvironment#errorChildProcess",(0,k.toErrorMessage)(N)),s(N)});const O=[];I.stdout.on("data",N=>O.push(N));const A=[];I.stderr.on("data",N=>A.push(N)),I.on("close",(N,$)=>{const T=Buffer.concat(O).toString("utf8");m.trace("getUnixShellEnvironment#raw",T);const F=Buffer.concat(A).toString("utf8");if(F.trim()&&m.trace("getUnixShellEnvironment#stderr",F),N||$)return s(new Error((0,D.localize)(2,null,N,$)));const M=r.exec(T),U=M?M[1]:"{}";try{const B=JSON.parse(U);g?B.ELECTRON_RUN_AS_NODE=g:delete B.ELECTRON_RUN_AS_NODE,c?B.ELECTRON_NO_ATTACH_CONSOLE=c:delete B.ELECTRON_NO_ATTACH_CONSOLE,delete B.XDG_RUNTIME_DIR,m.trace("getUnixShellEnvironment#result",B),t(B)}catch(B){m.error("getUnixShellEnvironment#errorCaught",(0,k.toErrorMessage)(B)),s(B)}})})}}),define(te[82],ne([0,1,19,10,138,14]),function(Q,e,L,i,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function k(P,b,d,S,h,y){let p;try{await R(P,b,d,S,h,y)}catch(m){p=m}finally{p&&h.errorTransformer&&(p=h.errorTransformer(p)),typeof p!="undefined"&&d.error(p),d.end()}}e.readFileIntoStream=k;async function R(P,b,d,S,h,y){E(y);const p=await P.open(b,{create:!1});try{E(y);let m=0,w=0,g=h&&typeof h.length=="number"?h.length:void 0,c=L.VSBuffer.alloc(Math.min(h.bufferSize,typeof g=="number"?g:h.bufferSize)),l=h&&typeof h.position=="number"?h.position:0,r=0;do w=await P.read(p,l,c.buffer,r,c.byteLength-r),l+=w,r+=w,m+=w,typeof g=="number"&&(g-=w),r===c.byteLength&&(await d.write(S(c)),c=L.VSBuffer.alloc(Math.min(h.bufferSize,typeof g=="number"?g:h.bufferSize)),r=0);while(w>0&&(typeof g!="number"||g>0)&&E(y)&&C(m,h));if(r>0){let a=r;typeof g=="number"&&(a=Math.min(r,g)),d.write(S(c.slice(0,a)))}}catch(m){throw(0,_.ensureFileSystemProviderError)(m)}finally{await P.close(p)}}function E(P){if(P.isCancellationRequested)throw(0,i.canceled)();return!0}function C(P,b){if(b?.limits){if(typeof b.limits.memory=="number"&&P>b.limits.memory)throw(0,_.createFileSystemProviderError)((0,D.localize)(0,null),_.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof b.limits.size=="number"&&P>b.limits.size)throw(0,_.createFileSystemProviderError)((0,D.localize)(1,null),_.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(te[58],ne([0,1,2,4,7,14]),function(Q,e,L,i,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.coalesceEvents=e.toFileChanges=e.AbstractRecursiveWatcherClient=void 0;class k extends L.Disposable{constructor(b,d,S){super();this.onFileChanges=b,this.onLogMessage=d,this.verboseLogging=S,this.watcherDisposables=this._register(new L.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const b=new L.DisposableStore;this.watcherDisposables.value=b,this.watcher=this.createWatcher(b),this.watcher.setVerboseLogging(this.verboseLogging),b.add(this.watcher.onDidChangeFile(d=>this.onFileChanges(d))),b.add(this.watcher.onDidLogMessage(d=>this.onLogMessage(d))),b.add(this.watcher.onDidError(d=>this.onError(d)))}onError(b){this.restartCounter<k.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${b}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${b}`)}restart(b){this.restartCounter++,this.init(),this.watch(b)}async watch(b){this.requests=b,await this.watcher?.watch(b)}async setVerboseLogging(b){this.verboseLogging=b,await this.watcher?.setVerboseLogging(b)}error(b){this.onLogMessage({type:"error",message:`[File Watcher (parcel)] ${b}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractRecursiveWatcherClient=k,k.MAX_RESTARTS=5;function R(P){return P.map(b=>({type:b.type,resource:D.URI.file(b.path)}))}e.toFileChanges=R;function E(P){const b=new C;for(const d of P)b.processEvent(d);return b.coalesce()}e.coalesceEvents=E;class C{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(b){return i.isLinux?b.path:b.path.toLowerCase()}processEvent(b){const d=this.mapPathToChange.get(this.toKey(b));let S=!1;if(d){const h=d.type,y=b.type;d.path!==b.path&&b.type===2?S=!0:h===1&&y===2?(this.mapPathToChange.delete(this.toKey(b)),this.coalesced.delete(d)):h===2&&y===1?d.type=0:h===1&&y===0||(d.type=y)}else S=!0;S&&(this.coalesced.add(b),this.mapPathToChange.set(this.toKey(b),b))}coalesce(){const b=[],d=[];return Array.from(this.coalesced).filter(S=>S.type!==2?(b.push(S),!1):!0).sort((S,h)=>S.path.length-h.path.length).filter(S=>d.some(h=>(0,_.isParent)(S.path,h,!i.isLinux))?!1:(d.push(S.path),!0)).concat(b)}}}),define(te[165],ne([0,1,5,2,9,113,20,116,58]),function(Q,e,L,i,D,_,k,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSFileWatcher=void 0;class C extends i.Disposable{constructor(b,d,S,h){super();this.path=b,this.onDidFilesChange=d,this.onLogMessage=S,this.verboseLogging=h,this.fileChangesDelayer=this._register(new L.ThrottledDelayer(R.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(b){this.verboseLogging=b}async startWatching(){try{const{stat:b,symbolicLink:d}=await k.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let S=this.path;if(d)try{S=await(0,_.realpath)(S)}catch(h){if(this.onError(h),d.dangling)return}b.isDirectory()?this._register((0,R.watchFolder)(S,(h,y)=>{this.onFileChange({type:h==="changed"?0:h==="added"?1:2,path:(0,D.join)(this.path,(0,D.basename)(y))})},h=>this.onError(h))):this._register((0,R.watchFile)(S,h=>{this.onFileChange({type:h==="changed"?0:2,path:this.path})},h=>this.onError(h)))}catch(b){b.code!=="ENOENT"&&this.onError(b)}}onFileChange(b){this.fileChangesBuffer.push(b),this.verboseLogging&&this.onVerbose(`${b.type===1?"[ADDED]":b.type===2?"[DELETED]":"[CHANGED]"} ${b.path}`),this.fileChangesDelayer.trigger(async()=>{const d=this.fileChangesBuffer;this.fileChangesBuffer=[];const S=(0,E.coalesceEvents)(d);if(this.verboseLogging)for(const h of S)this.onVerbose(`>> normalized ${h.type===1?"[ADDED]":h.type===2?"[DELETED]":"[CHANGED]"} ${h.path}`);S.length>0&&this.onDidFilesChange(S)})}onError(b){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${b}`})}onVerbose(b){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${b}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.NodeJSFileWatcher=C}),define(te[166],ne([0,1,17,36,57,58]),function(Q,e,L,i,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParcelWatcherClient=void 0;class k extends _.AbstractRecursiveWatcherClient{constructor(E,C,P){super(E,C,P);this.init()}createWatcher(E){const C=E.add(new D.Client(L.FileAccess.asFileUri("bootstrap-fork",Q).fsPath,{serverName:"File Watcher (parcel, node.js)",args:["--type=parcelWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/parcel/parcelWatcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return E.add(C.onDidProcessExit(({code:P,signal:b})=>this.onError(`terminated by itself with code ${P}, signal: ${b}`))),i.ProxyChannel.toService((0,i.getNextTickChannel)(C.getChannel("watcher")))}}e.ParcelWatcherClient=k}),define(te[83],ne([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class L{constructor(...D){this._entries=new Map;for(let[_,k]of D)this.set(_,k)}set(D,_){const k=this._entries.get(D);return this._entries.set(D,_),k}has(D){return this._entries.has(D)}get(D){return this._entries.get(D)}}e.ServiceCollection=L}),define(te[167],ne([0,1,5,10,51,157,6,83]),function(Q,e,L,i,D,_,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const E=!1;class C extends Error{constructor(h){super("cyclic dependency between services");this.message=h.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${h.toString()}`}}class P{constructor(h=new R.ServiceCollection,y=!1,p){this._activeInstantiations=new Set,this._services=h,this._strict=y,this._parent=p,this._services.set(k.IInstantiationService,this)}createChild(h){return new P(h,this._strict,this)}invokeFunction(h,...y){let p=d.traceInvocation(h),m=!1;try{return h({get:g=>{if(m)throw(0,i.illegalState)("service accessor is only valid during the invocation of its target method");const c=this._getOrCreateServiceInstance(g,p);if(!c)throw new Error(`[invokeFunction] unknown service '${g}'`);return c}},...y)}finally{m=!0,p.stop()}}createInstance(h,...y){let p,m;return h instanceof D.SyncDescriptor?(p=d.traceCreation(h.ctor),m=this._createInstance(h.ctor,h.staticArguments.concat(y),p)):(p=d.traceCreation(h),m=this._createInstance(h,y,p)),p.stop(),m}_createInstance(h,y=[],p){let m=k._util.getServiceDependencies(h).sort((c,l)=>c.index-l.index),w=[];for(const c of m){let l=this._getOrCreateServiceInstance(c.id,p);if(!l&&this._strict&&!c.optional)throw new Error(`[createInstance] ${h.name} depends on UNKNOWN service ${c.id}.`);w.push(l)}let g=m.length>0?m[0].index:y.length;if(y.length!==g){console.warn(`[createInstance] First service dependency of ${h.name} at position ${g+1} conflicts with ${y.length} static arguments`);let c=g-y.length;c>0?y=y.concat(new Array(c)):y=y.slice(0,g)}return new h(...[...y,...w])}_setServiceInstance(h,y){if(this._services.get(h)instanceof D.SyncDescriptor)this._services.set(h,y);else if(this._parent)this._parent._setServiceInstance(h,y);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(h){let y=this._services.get(h);return!y&&this._parent?this._parent._getServiceInstanceOrDescriptor(h):y}_getOrCreateServiceInstance(h,y){let p=this._getServiceInstanceOrDescriptor(h);return p instanceof D.SyncDescriptor?this._safeCreateAndCacheServiceInstance(h,p,y.branch(h,!0)):(y.branch(h,!1),p)}_safeCreateAndCacheServiceInstance(h,y,p){if(this._activeInstantiations.has(h))throw new Error(`illegal state - RECURSIVELY instantiating service '${h}'`);this._activeInstantiations.add(h);try{return this._createAndCacheServiceInstance(h,y,p)}finally{this._activeInstantiations.delete(h)}}_createAndCacheServiceInstance(h,y,p){const m=new _.Graph(c=>c.id.toString());let w=0;const g=[{id:h,desc:y,_trace:p}];for(;g.length;){const c=g.pop();if(m.lookupOrInsertNode(c),w++>1e3)throw new C(m);for(let l of k._util.getServiceDependencies(c.desc.ctor)){let r=this._getServiceInstanceOrDescriptor(l.id);if(!r&&!l.optional&&console.warn(`[createInstance] ${h} depends on ${l.id} which is NOT registered.`),r instanceof D.SyncDescriptor){const a={id:l.id,desc:r,_trace:c._trace.branch(l.id,!0)};m.insertEdge(c,a),g.push(a)}}}for(;;){const c=m.roots();if(c.length===0){if(!m.isEmpty())throw new C(m);break}for(const{data:l}of c){if(this._getServiceInstanceOrDescriptor(l.id)instanceof D.SyncDescriptor){const a=this._createServiceInstanceWithOwner(l.id,l.desc.ctor,l.desc.staticArguments,l.desc.supportsDelayedInstantiation,l._trace);this._setServiceInstance(l.id,a)}m.removeNode(l)}}return this._getServiceInstanceOrDescriptor(h)}_createServiceInstanceWithOwner(h,y,p=[],m,w){if(this._services.get(h)instanceof D.SyncDescriptor)return this._createServiceInstance(y,p,m,w);if(this._parent)return this._parent._createServiceInstanceWithOwner(h,y,p,m,w);throw new Error(`illegalState - creating UNKNOWN service instance ${y.name}`)}_createServiceInstance(h,y=[],p,m){if(p){const w=new L.IdleValue(()=>this._createInstance(h,y,m));return new Proxy(Object.create(null),{get(g,c){if(c in g)return g[c];let l=w.value,r=l[c];return typeof r!="function"||(r=r.bind(l),g[c]=r),r},set(g,c,l){return w.value[c]=l,!0}})}else return this._createInstance(h,y,m)}}e.InstantiationService=P;var b;(function(S){S[S.Creation=0]="Creation",S[S.Invocation=1]="Invocation",S[S.Branch=2]="Branch"})(b||(b={}));class d{constructor(h,y){this.type=h,this.name=y,this._start=Date.now(),this._dep=[]}static traceInvocation(h){return E?new d(1,h.name||h.toString().substring(0,42).replace(/\n/g,"")):d._None}static traceCreation(h){return E?new d(0,h.name):d._None}branch(h,y){let p=new d(2,h.toString());return this._dep.push([h,y,p]),p}stop(){let h=Date.now()-this._start;d._totals+=h;let y=!1;function p(w,g){let c=[],l=new Array(w+1).join("	");for(const[r,a,n]of g._dep)if(a&&n){y=!0,c.push(`${l}CREATES -> ${r}`);let t=p(w+1,n);t&&c.push(t)}else c.push(`${l}uses -> ${r}`);return c.join(`
`)}let m=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${p(1,this)}`,`DONE, took ${h.toFixed(2)}ms (grand total ${d._totals.toFixed(2)}ms)`];(h>2||y)&&console.log(m.join(`
`))}}d._None=new class extends d{constructor(){super(-1,null)}stop(){}branch(){return this}},d._totals=0}),define(te[168],ne([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class L{constructor(D,_){this.server=D,this.router=_}getChannel(D){return this.server.getChannel(D,this.router)}registerChannel(D,_){this.server.registerChannel(D,_)}}e.MessagePortMainProcessService=L}),define(te[169],ne([0,1,36,51,77,6]),function(Q,e,L,i,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class k{constructor(S,h,y){const p=y.getChannel(S);return R(h)?new h.channelClientCtor(p):L.ProxyChannel.toService(p,h?.proxyOptions)}}function R(d){return!!d?.channelClientCtor}e.IMainProcessService=(0,_.createDecorator)("mainProcessService");let E=class extends k{constructor(S,h,y){super(S,h,y)}};E=de([J(2,e.IMainProcessService)],E);function C(d,S,h){(0,D.registerSingleton)(d,new i.SyncDescriptor(E,[S,h],h?.supportsDelayedInstantiation))}e.registerMainProcessRemoteService=C,e.ISharedProcessService=(0,_.createDecorator)("sharedProcessService");let P=class extends k{constructor(S,h,y){super(S,h,y)}};P=de([J(2,e.ISharedProcessService)],P);function b(d,S,h){(0,D.registerSingleton)(d,new i.SyncDescriptor(P,[S,h],h?.supportsDelayedInstantiation))}e.registerSharedProcessRemoteService=b}),define(te[59],ne([0,1,6]),function(Q,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidLocalization=e.ILocalizationsService=void 0,e.ILocalizationsService=(0,L.createDecorator)("localizationsService");function i(D){if(typeof D.languageId!="string"||!Array.isArray(D.translations)||D.translations.length===0)return!1;for(const _ of D.translations)if(typeof _.id!="string"||typeof _.path!="string")return!1;return!(D.languageName&&typeof D.languageName!="string"||D.localizedLanguageName&&typeof D.localizedLanguageName!="string")}e.isValidLocalization=i}),define(te[170],ne([0,1,2,59]),function(Q,e,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let D=class extends L.Disposable{constructor(k){super();this.localizationsService=k,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};D=de([J(0,i.ILocalizationsService)],D),e.LocalizationsUpdater=D}),define(te[8],ne([0,1,38,3,2,4,6]),function(Q,e,L,i,D,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,k.createDecorator)("logService"),e.ILoggerService=(0,k.createDecorator)("loggerService");function R(){return new Date().toISOString()}var E;(function(a){a[a.Trace=0]="Trace",a[a.Debug=1]="Debug",a[a.Info=2]="Info",a[a.Warning=3]="Warning",a[a.Error=4]="Error",a[a.Critical=5]="Critical",a[a.Off=6]="Off"})(E=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=E.Info;function C(a,n,t){switch(n){case E.Trace:a.trace(t);break;case E.Debug:a.debug(t);break;case E.Info:a.info(t);break;case E.Warning:a.warn(t);break;case E.Error:a.error(t);break;case E.Critical:a.critical(t);break;default:throw new Error("Invalid log level")}}e.log=C;function P(a){let n="";for(let t=0;t<a.length;t++){let s=a[t];if(typeof s=="object")try{s=JSON.stringify(s)}catch{}n+=(t>0?" ":"")+s}return n}e.format=P;class b extends D.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new i.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(n){this.level!==n&&(this.level=n,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=b;class d extends b{constructor(n){super();this.logAlways=n}checkLogLevel(n){return this.logAlways||this.getLevel()<=n}trace(n,...t){this.checkLogLevel(E.Trace)&&this.log(E.Trace,P([n,...t]))}debug(n,...t){this.checkLogLevel(E.Debug)&&this.log(E.Debug,P([n,...t]))}info(n,...t){this.checkLogLevel(E.Info)&&this.log(E.Info,P([n,...t]))}warn(n,...t){this.checkLogLevel(E.Warning)&&this.log(E.Warning,P([n,...t]))}error(n,...t){if(this.checkLogLevel(E.Error))if(n instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=n.stack,this.log(E.Error,P(s))}else this.log(E.Error,P([n,...t]))}critical(n,...t){this.checkLogLevel(E.Critical)&&this.log(E.Critical,P([n,...t]))}flush(){}}e.AbstractMessageLogger=d;class S extends b{constructor(n=e.DEFAULT_LOG_LEVEL){super();this.setLevel(n),this.useColors=!_.isWindows}trace(n,...t){this.getLevel()<=E.Trace&&(this.useColors?console.log(`[90m[main ${R()}][0m`,n,...t):console.log(`[main ${R()}]`,n,...t))}debug(n,...t){this.getLevel()<=E.Debug&&(this.useColors?console.log(`[90m[main ${R()}][0m`,n,...t):console.log(`[main ${R()}]`,n,...t))}info(n,...t){this.getLevel()<=E.Info&&(this.useColors?console.log(`[90m[main ${R()}][0m`,n,...t):console.log(`[main ${R()}]`,n,...t))}warn(n,...t){this.getLevel()<=E.Warning&&(this.useColors?console.warn(`[93m[main ${R()}][0m`,n,...t):console.warn(`[main ${R()}]`,n,...t))}error(n,...t){this.getLevel()<=E.Error&&(this.useColors?console.error(`[91m[main ${R()}][0m`,n,...t):console.error(`[main ${R()}]`,n,...t))}critical(n,...t){this.getLevel()<=E.Critical&&(this.useColors?console.error(`[90m[main ${R()}][0m`,n,...t):console.error(`[main ${R()}]`,n,...t))}dispose(){}flush(){}}e.ConsoleMainLogger=S;class h extends b{constructor(n=e.DEFAULT_LOG_LEVEL){super();this.setLevel(n)}trace(n,...t){this.getLevel()<=E.Trace&&console.log("%cTRACE","color: #888",n,...t)}debug(n,...t){this.getLevel()<=E.Debug&&console.log("%cDEBUG","background: #eee; color: #888",n,...t)}info(n,...t){this.getLevel()<=E.Info&&console.log("%c INFO","color: #33f",n,...t)}warn(n,...t){this.getLevel()<=E.Warning&&console.log("%c WARN","color: #993",n,...t)}error(n,...t){this.getLevel()<=E.Error&&console.log("%c  ERR","color: #f33",n,...t)}critical(n,...t){this.getLevel()<=E.Critical&&console.log("%cCRITI","background: #f33; color: white",n,...t)}dispose(){}flush(){}}e.ConsoleLogger=h;class y extends b{constructor(n,t=e.DEFAULT_LOG_LEVEL){super();this.adapter=n,this.setLevel(t)}trace(n,...t){this.getLevel()<=E.Trace&&this.adapter.log(E.Trace,[this.extractMessage(n),...t])}debug(n,...t){this.getLevel()<=E.Debug&&this.adapter.log(E.Debug,[this.extractMessage(n),...t])}info(n,...t){this.getLevel()<=E.Info&&this.adapter.log(E.Info,[this.extractMessage(n),...t])}warn(n,...t){this.getLevel()<=E.Warning&&this.adapter.log(E.Warning,[this.extractMessage(n),...t])}error(n,...t){this.getLevel()<=E.Error&&this.adapter.log(E.Error,[this.extractMessage(n),...t])}critical(n,...t){this.getLevel()<=E.Critical&&this.adapter.log(E.Critical,[this.extractMessage(n),...t])}extractMessage(n){return typeof n=="string"?n:(0,L.toErrorMessage)(n,this.getLevel()<=E.Trace)}dispose(){}flush(){}}e.AdapterLogger=y;class p extends b{constructor(n){super();this.logServices=n,n.length&&this.setLevel(n[0].getLevel())}setLevel(n){for(const t of this.logServices)t.setLevel(n);super.setLevel(n)}trace(n,...t){for(const s of this.logServices)s.trace(n,...t)}debug(n,...t){for(const s of this.logServices)s.debug(n,...t)}info(n,...t){for(const s of this.logServices)s.info(n,...t)}warn(n,...t){for(const s of this.logServices)s.warn(n,...t)}error(n,...t){for(const s of this.logServices)s.error(n,...t)}critical(n,...t){for(const s of this.logServices)s.critical(n,...t)}flush(){for(const n of this.logServices)n.flush()}dispose(){for(const n of this.logServices)n.dispose()}}e.MultiplexLogService=p;class m extends D.Disposable{constructor(n){super();this.logger=n,this._register(n)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(n){this.logger.setLevel(n)}getLevel(){return this.logger.getLevel()}trace(n,...t){this.logger.trace(n,...t)}debug(n,...t){this.logger.debug(n,...t)}info(n,...t){this.logger.info(n,...t)}warn(n,...t){this.logger.warn(n,...t)}error(n,...t){this.logger.error(n,...t)}critical(n,...t){this.logger.critical(n,...t)}flush(){this.logger.flush()}}e.LogService=m;class w extends D.Disposable{constructor(n,t){super();this.logLevel=n,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(t(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(o=>o.setLevel(s))}))}getLogger(n){return this.loggers.get(n.toString())}createLogger(n,t){let s=this.loggers.get(n.toString());return s||(s=this.doCreateLogger(n,t?.always?E.Trace:this.logLevel,t),this.loggers.set(n.toString(),s),t?.always||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(n=>n.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=w;class g{constructor(){this.onDidChangeLogLevel=new i.Emitter().event}setLevel(n){}getLevel(){return E.Info}trace(n,...t){}debug(n,...t){}info(n,...t){}warn(n,...t){}error(n,...t){}critical(n,...t){}dispose(){}flush(){}}e.NullLogService=g;function c(a){if(a.verbose)return E.Trace;if(typeof a.logLevel=="string"){const n=l(a.logLevel.toLowerCase());if(n!==void 0)return n}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=c;function l(a){switch(a){case"trace":return E.Trace;case"debug":return E.Debug;case"info":return E.Info;case"warn":return E.Warning;case"error":return E.Error;case"critical":return E.Critical;case"off":return E.Off}}e.parseLogLevel=l;function r(a){switch(a){case E.Trace:return"trace";case E.Debug:return"debug";case E.Info:return"info";case E.Warning:return"warn";case E.Error:return"error";case E.Critical:return"critical";case E.Off:return"off"}}e.LogLevelToString=r}),define(te[171],ne([0,1,5,10,2,9,20,11,8]),function(Q,e,L,i,D,_,k,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let C=class extends D.Disposable{constructor(b,d){super();this.environmentService=b,this.logService=d,this._register(new L.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.trace("[logs cleanup]: Starting to clean up old logs.");try{const b=(0,_.basename)(this.environmentService.logsPath),d=(0,_.dirname)(this.environmentService.logsPath),y=(await k.Promises.readdir(d)).filter(m=>/^\d{8}T\d{6}$/.test(m)).sort().filter(m=>m!==b),p=y.slice(0,Math.max(0,y.length-9));p.length>0&&(this.logService.trace(`[logs cleanup]: Removing log folders '${p.join(", ")}'`),await Promise.all(p.map(m=>k.Promises.rm((0,_.join)(d,m)))))}catch(b){(0,i.onUnexpectedError)(b)}}};C=de([J(0,R.IEnvironmentService),J(1,E.ILogService)],C),e.LogsDataCleaner=C}),define(te[172],ne([0,1,5,10,2,9,20,11,8]),function(Q,e,L,i,D,_,k,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDataCleaner=void 0;let C=class gt extends D.Disposable{constructor(b,d,S){super();this.backupWorkspacesPath=b,this.environmentService=d,this.logService=S,this._register(new L.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.trace("[storage cleanup]: Starting to clean up storage folders.");try{const b=await k.Promises.readFile(this.backupWorkspacesPath,"utf8"),S=JSON.parse(b).emptyWorkspaceInfos.map(y=>y.backupFolder),h=await k.Promises.readdir(this.environmentService.workspaceStorageHome.fsPath);await Promise.all(h.map(async y=>{y.length===gt.NON_EMPTY_WORKSPACE_ID_LENGTH||y===gt.EXTENSION_DEV_EMPTY_WINDOW_ID||S.indexOf(y)>=0||(this.logService.trace(`[storage cleanup]: Deleting workspace storage folder ${y}.`),await k.Promises.rm((0,_.join)(this.environmentService.workspaceStorageHome.fsPath,y)))}))}catch(b){(0,i.onUnexpectedError)(b)}}};C.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4,C.EXTENSION_DEV_EMPTY_WINDOW_ID="ext-dev",C=de([J(1,R.INativeEnvironmentService),J(2,E.ILogService)],C),e.StorageDataCleaner=C}),define(te[84],ne([0,1,5,19,31,54,11,14,6,8]),function(Q,e,L,i,D,_,k,R,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserConfigurationFileService=e.IUserConfigurationFileService=e.UserConfigurationFileServiceId=e.UserConfigurationErrorCode=void 0;var P;(function(d){d.ERROR_INVALID_FILE="ERROR_INVALID_FILE",d.ERROR_FILE_MODIFIED_SINCE="ERROR_FILE_MODIFIED_SINCE"})(P=e.UserConfigurationErrorCode||(e.UserConfigurationErrorCode={})),e.UserConfigurationFileServiceId="IUserConfigurationFileService",e.IUserConfigurationFileService=(0,E.createDecorator)(e.UserConfigurationFileServiceId);let b=class{constructor(S,h,y){this.environmentService=S,this.fileService=h,this.logService=y,this.queue=new L.Queue}async updateSettings(S,h){return this.queue.queue(()=>this.doWrite(S,h))}async doWrite(S,h){this.logService.trace(`${e.UserConfigurationFileServiceId}#write`,this.environmentService.settingsResource.toString(),S);const{value:y,mtime:p,etag:m}=await this.fileService.readFile(this.environmentService.settingsResource,{atomic:!0});let w=y.toString();const g=[];if((0,D.parse)(w,g,{allowTrailingComma:!0,allowEmptyContent:!0}),g.length)throw new Error("ERROR_INVALID_FILE");const c=this.getEdits(S,w,h)[0];if(c){w=w.substring(0,c.offset)+c.content+w.substring(c.offset+c.length);try{await this.fileService.writeFile(this.environmentService.settingsResource,i.VSBuffer.fromString(w),{etag:m,mtime:p})}catch(l){if(l.fileOperationResult===3)throw new Error("ERROR_FILE_MODIFIED_SINCE")}}}async write(S,h){return this.queue.queue(async()=>{await this.fileService.writeFile(this.environmentService.settingsResource,S,h)})}getEdits({value:S,path:h},y,p){return h.length?(0,_.setProperty)(y,h,S,p):[{content:JSON.stringify(S,null,p.insertSpaces&&p.tabSize?" ".repeat(p.tabSize):"	"),length:y.length,offset:0}]}};b=de([J(0,k.IEnvironmentService),J(1,R.IFileService),J(2,C.ILogService)],b),e.UserConfigurationFileService=b}),define(te[173],ne([0,1,44,5,38,3,2,17,9,20,11,8]),function(Q,e,L,i,D,_,k,R,E,C,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let d=class extends k.Disposable{constructor(h,y){super();this.environmentService=h,this.logService=y,this.processesLimiter=new i.Limiter(5)}async postUninstall(h){const y=this.parseScript(h,"uninstall");return y&&(this.logService.info(h.identifier.id,h.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(y.script,"uninstall",y.args,!0,h).then(()=>this.logService.info(h.identifier.id,h.manifest.version,"Finished running post uninstall script"),p=>this.logService.error(h.identifier.id,h.manifest.version,`Failed to run post uninstall script: ${p}`)))),C.Promises.rm(this.getExtensionStoragePath(h)).then(void 0,p=>this.logService.error("Error while removing extension storage path",p))}parseScript(h,y){const p=`vscode:${y}`;if(h.location.scheme===R.Schemas.file&&h.manifest&&h.manifest.scripts&&typeof h.manifest.scripts[p]=="string"){const m=h.manifest.scripts[p].split(" ");return m.length<2||m[0]!=="node"||!m[1]?(this.logService.warn(h.identifier.id,h.manifest.version,`${p} should be a node script`),null):{script:(0,E.join)(h.location.fsPath,m[1]),args:m.slice(2)||[]}}return null}runLifecycleHook(h,y,p,m,w){return new Promise((g,c)=>{const l=this.start(h,y,p,w);let r;const a=n=>{r&&(clearTimeout(r),r=null),n?c(n):g(void 0)};l.on("error",n=>{a((0,D.toErrorMessage)(n)||"Unknown")}),l.on("exit",(n,t)=>{a(n?`post-${y} process exited with code ${n}`:void 0)}),m&&(r=setTimeout(()=>{r=null,l.kill(),c("timed out")},5e3))})}start(h,y,p,m){const w={silent:!0,execArgv:void 0},g=(0,L.fork)(h,[`--type=extension-post-${y}`,...p],w);g.stdout.setEncoding("utf8"),g.stderr.setEncoding("utf8");const c=_.Event.fromNodeEventEmitter(g.stdout,"data"),l=_.Event.fromNodeEventEmitter(g.stderr,"data");c(n=>this.logService.info(m.identifier.id,m.manifest.version,`post-${y}`,n)),l(n=>this.logService.error(m.identifier.id,m.manifest.version,`post-${y}`,n));const r=_.Event.any(_.Event.map(c,n=>({data:`%c${n}`,format:[""]})),_.Event.map(l,n=>({data:`%c${n}`,format:["color: red"]})));return _.Event.debounce(r,(n,t)=>n?{data:n.data+t.data,format:[...n.format,...t.format]}:{data:t.data,format:t.format},100)(n=>{console.group(m.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),g}getExtensionStoragePath(h){return(0,E.join)(this.environmentService.globalStorageHome.fsPath,h.identifier.id.toLowerCase())}};d=de([J(0,P.IEnvironmentService),J(1,b.ILogService)],d),e.ExtensionsLifecycle=d}),define(te[174],ne([0,1,16,5,10,3,2,9,58,8]),function(Q,e,L,i,D,_,k,R,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class P extends k.Disposable{constructor(d){super();this.logService=d,this._onDidChangeFile=this._register(new _.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new _.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new i.ThrottledDelayer(0))}watch(d,S){return S.recursive?this.watchRecursive(d,S):this.watchNonRecursive(d)}watchRecursive(d,S){const h={path:this.toFilePath(d),excludes:S.excludes},y=(0,L.insert)(this.recursiveFoldersToWatch,h);return this.refreshRecursiveWatchers(),(0,k.toDisposable)(()=>{y(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(()=>this.doRefreshRecursiveWatchers()).catch(d=>(0,D.onUnexpectedError)(d))}doRefreshRecursiveWatchers(){return this.recursiveWatcher||(this.recursiveWatcher=this._register(this.createRecursiveWatcher(d=>this._onDidChangeFile.fire((0,E.toFileChanges)(d)),d=>this.onWatcherLogMessage(d),this.logService.getLevel()===C.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher?.setVerboseLogging(this.logService.getLevel()===C.LogLevel.Trace)}))),this.doWatch(this.recursiveWatcher,this.recursiveFoldersToWatch)}doWatch(d,S){return d.watch(S)}watchNonRecursive(d){const S=this.createNonRecursiveWatcher(this.toFilePath(d),y=>this._onDidChangeFile.fire((0,E.toFileChanges)(y)),y=>this.onWatcherLogMessage(y),this.logService.getLevel()===C.LogLevel.Trace),h=this.logService.onDidChangeLogLevel(()=>{S.setVerboseLogging(this.logService.getLevel()===C.LogLevel.Trace)});return(0,k.combinedDisposable)(S,h)}onWatcherLogMessage(d){d.type==="error"&&this._onDidWatchError.fire(d.message),this.logService[d.type](d.message)}toFilePath(d){return(0,R.normalize)(d.fsPath)}}e.AbstractDiskFileSystemProvider=P}),define(te[175],ne([0,1,16,5,19,27,3,53,2,39,17,176,18,49,136,14,82,8]),function(Q,e,L,i,D,_,k,R,E,C,P,b,d,S,h,y,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let w=class Ke extends E.Disposable{constructor(c){super();this.logService=c,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new k.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new k.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new k.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new k.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new k.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new k.Emitter),this.onDidWatchError=this._onDidWatchError.event,this._onDidChangeFilesRaw=this._register(new k.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new i.ThrottledWorker(Ke.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ke.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ke.FILE_EVENTS_THROTTLING.coolDownDelay,l=>this._onDidFilesChange.fire(new y.FileChangesEvent(l,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new i.ThrottledWorker(Ke.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ke.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ke.FILE_EVENTS_THROTTLING.coolDownDelay,l=>this._onDidFilesChange.fire(new y.FileChangesEvent(l,!0)))),this.watchedResources=C.TernarySearchTree.forUris(l=>{const r=this.getProvider(l.scheme);return r?!this.isPathCaseSensitive(r):!1}),this.writeQueue=this._register(new i.ResourceQueue)}registerProvider(c,l){if(this.provider.has(c))throw new Error(`A filesystem provider for the scheme '${c}' is already registered.`);(0,b.mark)(`code/registerFilesystem/${c}`),this.provider.set(c,l),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:c,provider:l});const r=new E.DisposableStore;return r.add(l.onDidChangeFile(a=>this.onDidChangeFile(a,this.isPathCaseSensitive(l)))),r.add(l.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:l,scheme:c}))),typeof l.onDidWatchError=="function"&&r.add(l.onDidWatchError(a=>this._onDidWatchError.fire(new Error(a)))),(0,E.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:c,provider:l}),this.provider.delete(c),(0,E.dispose)(r)})}getProvider(c){return this.provider.get(c)}async activateProvider(c){const l=[];this._onWillActivateFileSystemProvider.fire({scheme:c,join(r){l.push(r)}}),!this.provider.has(c)&&await i.Promises.settled(l)}async canHandleResource(c){return await this.activateProvider(c.scheme),this.hasProvider(c)}hasProvider(c){return this.provider.has(c.scheme)}hasCapability(c,l){const r=this.provider.get(c.scheme);return!!(r&&r.capabilities&l)}listCapabilities(){return R.Iterable.map(this.provider,([c,l])=>({scheme:c,capabilities:l.capabilities}))}async withProvider(c){if(!(0,d.isAbsolutePath)(c))throw new y.FileOperationError((0,h.localize)(0,null,this.resourceForError(c)),8);await this.activateProvider(c.scheme);const l=this.provider.get(c.scheme);if(!l){const r=new Error;throw r.name="ENOPRO",r.message=(0,h.localize)(1,null,c.toString()),r}return l}async withReadProvider(c){const l=await this.withProvider(c);if((0,y.hasOpenReadWriteCloseCapability)(l)||(0,y.hasReadWriteCapability)(l)||(0,y.hasFileReadStreamCapability)(l))return l;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(c){const l=await this.withProvider(c);if((0,y.hasOpenReadWriteCloseCapability)(l)||(0,y.hasReadWriteCapability)(l))return l;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(c,l){try{return await this.doResolveFile(c,l)}catch(r){throw(0,y.toFileSystemProviderErrorCode)(r)===y.FileSystemProviderErrorCode.FileNotFound?new y.FileOperationError((0,h.localize)(2,null,this.resourceForError(c)),1):(0,y.ensureFileSystemProviderError)(r)}}async doResolveFile(c,l){const r=await this.withProvider(c),a=this.isPathCaseSensitive(r),n=l?.resolveTo,t=l?.resolveSingleChildDescendants,s=l?.resolveMetadata,o=await r.stat(c);let u;return this.toFileStat(r,c,o,void 0,!!s,(f,v)=>(u||(u=C.TernarySearchTree.forUris(()=>!a),u.set(c,!0),n&&u.fill(!0,n)),u.get(f.resource)||u.findSuperstr(f.resource.with({query:null,fragment:null}))?!0:f.isDirectory&&t?v===1:!1))}async toFileStat(c,l,r,a,n,t){const{providerExtUri:s}=this.getExtUri(c),o={resource:l,name:s.basename(l),isFile:(r.type&y.FileType.File)!=0,isDirectory:(r.type&y.FileType.Directory)!=0,isSymbolicLink:(r.type&y.FileType.SymbolicLink)!=0,mtime:r.mtime,ctime:r.ctime,size:r.size,readonly:Boolean((r.permissions??0)&y.FilePermission.Readonly)||Boolean(c.capabilities&2048),etag:(0,y.etag)({mtime:r.mtime,size:r.size})};if(o.isDirectory&&t(o,a)){try{const u=await c.readdir(l),f=await i.Promises.settled(u.map(async([v,I])=>{try{const O=s.joinPath(l,v),A=n?await c.stat(O):{type:I};return await this.toFileStat(c,O,A,u.length,n,t)}catch(O){return this.logService.trace(O),null}}));o.children=(0,L.coalesce)(f)}catch(u){this.logService.trace(u),o.children=[]}return o}return o}async resolveAll(c){return i.Promises.settled(c.map(async l=>{try{return{stat:await this.doResolveFile(l.resource,l.options),success:!0}}catch(r){return this.logService.trace(r),{stat:void 0,success:!1}}}))}async exists(c){const l=await this.withProvider(c);try{return!!await l.stat(c)}catch{return!1}}async canCreateFile(c,l){try{await this.doValidateCreateFile(c,l)}catch(r){return r}return!0}async doValidateCreateFile(c,l){if(!l?.overwrite&&await this.exists(c))throw new y.FileOperationError((0,h.localize)(3,null,this.resourceForError(c)),3,l)}async createFile(c,l=D.VSBuffer.fromString(""),r){await this.doValidateCreateFile(c,r);const a=await this.writeFile(c,l);return this._onDidRunOperation.fire(new y.FileOperationEvent(c,0,a)),a}async writeFile(c,l,r){const a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),{providerExtUri:n}=this.getExtUri(a);try{await this.validateWriteFile(a,c,r)||await this.mkdirp(a,n.dirname(c));let s;if((0,y.hasReadWriteCapability)(a)&&!(l instanceof D.VSBuffer))if((0,S.isReadableStream)(l)){const o=await(0,S.peekStream)(l,3);o.ended?s=D.VSBuffer.concat(o.buffer):s=o}else s=(0,S.peekReadable)(l,o=>D.VSBuffer.concat(o),3);else s=l;!(0,y.hasOpenReadWriteCloseCapability)(a)||(0,y.hasReadWriteCapability)(a)&&s instanceof D.VSBuffer?await this.doWriteUnbuffered(a,c,r,s):await this.doWriteBuffered(a,c,r,s instanceof D.VSBuffer?(0,D.bufferToReadable)(s):s)}catch(t){throw new y.FileOperationError((0,h.localize)(4,null,this.resourceForError(c),(0,y.ensureFileSystemProviderError)(t).toString()),(0,y.toFileOperationResult)(t),r)}return this.resolve(c,{resolveMetadata:!0})}async validateWriteFile(c,l,r){if(!!r?.unlock&&!(c.capabilities&8192))throw new Error((0,h.localize)(5,null,this.resourceForError(l)));let n;try{n=await c.stat(l)}catch{return}if((n.type&y.FileType.Directory)!=0)throw new y.FileOperationError((0,h.localize)(6,null,this.resourceForError(l)),0,r);if(this.throwIfFileIsReadonly(l,n),typeof r?.mtime=="number"&&typeof r.etag=="string"&&r.etag!==y.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&r.mtime<n.mtime&&r.etag!==(0,y.etag)({mtime:r.mtime,size:n.size}))throw new y.FileOperationError((0,h.localize)(7,null),3,r);return n}async readFile(c,l,r){const a=await this.withReadProvider(c);return l?.atomic?this.doReadFileAtomic(a,c,l,r):this.doReadFile(a,c,l,r)}async doReadFileAtomic(c,l,r,a){return new Promise((n,t)=>{this.writeQueue.queueFor(l,this.getExtUri(c).providerExtUri).queue(async()=>{try{const s=await this.doReadFile(c,l,r,a);n(s)}catch(s){t(s)}})})}async doReadFile(c,l,r,a){const n=await this.doReadFileStream(c,l,{...r,preferUnbuffered:!0},a);return{...n,value:await(0,D.streamToBuffer)(n.value)}}async readFileStream(c,l,r){const a=await this.withReadProvider(c);return this.doReadFileStream(a,c,l,r)}async doReadFileStream(c,l,r,a){const n=new _.CancellationTokenSource(a),t=this.validateReadFile(l,r).then(o=>o,o=>{throw n.cancel(),o});let s;try{return typeof r?.etag=="string"&&r.etag!==y.ETAG_DISABLED&&await t,!((0,y.hasOpenReadWriteCloseCapability)(c)||(0,y.hasFileReadStreamCapability)(c))||(0,y.hasReadWriteCapability)(c)&&r?.preferUnbuffered?s=this.readFileUnbuffered(c,l,r):(0,y.hasFileReadStreamCapability)(c)?s=this.readFileStreamed(c,l,n.token,r):s=this.readFileBuffered(c,l,n.token,r),{...await t,value:s}}catch(o){s&&await(0,S.consumeStream)(s);const u=(0,h.localize)(8,null,this.resourceForError(l),(0,y.ensureFileSystemProviderError)(o).toString());throw o instanceof y.NotModifiedSinceFileOperationError?new y.NotModifiedSinceFileOperationError(u,o.stat,r):new y.FileOperationError(u,(0,y.toFileOperationResult)(o),r)}}readFileStreamed(c,l,r,a=Object.create(null)){const n=c.readFileStream(l,a,r);return(0,S.transform)(n,{data:t=>t instanceof D.VSBuffer?t:D.VSBuffer.wrap(t),error:t=>new y.FileOperationError((0,h.localize)(9,null,this.resourceForError(l),(0,y.ensureFileSystemProviderError)(t).toString()),(0,y.toFileOperationResult)(t),a)},t=>D.VSBuffer.concat(t))}readFileBuffered(c,l,r,a=Object.create(null)){const n=(0,D.newWriteableBufferStream)();return(0,p.readFileIntoStream)(c,l,n,t=>t,{...a,bufferSize:this.BUFFER_SIZE,errorTransformer:t=>new y.FileOperationError((0,h.localize)(10,null,this.resourceForError(l),(0,y.ensureFileSystemProviderError)(t).toString()),(0,y.toFileOperationResult)(t),a)},r),n}readFileUnbuffered(c,l,r){const a=(0,S.newWriteableStream)(n=>D.VSBuffer.concat(n));return(async()=>{try{let n=await c.readFile(l);typeof r?.position=="number"&&(n=n.slice(r.position)),typeof r?.length=="number"&&(n=n.slice(0,r.length)),this.validateReadFileLimits(l,n.byteLength,r),a.end(D.VSBuffer.wrap(n))}catch(n){a.error(n),a.end()}})(),a}async validateReadFile(c,l){const r=await this.resolve(c,{resolveMetadata:!0});if(r.isDirectory)throw new y.FileOperationError((0,h.localize)(11,null,this.resourceForError(c)),0,l);if(typeof l?.etag=="string"&&l.etag!==y.ETAG_DISABLED&&l.etag===r.etag)throw new y.NotModifiedSinceFileOperationError((0,h.localize)(12,null),r,l);return this.validateReadFileLimits(c,r.size,l),r}validateReadFileLimits(c,l,r){if(r?.limits){let a;if(typeof r.limits.memory=="number"&&l>r.limits.memory&&(a=9),typeof r.limits.size=="number"&&l>r.limits.size&&(a=7),typeof a=="number")throw new y.FileOperationError((0,h.localize)(13,null,this.resourceForError(c)),a)}}async canMove(c,l,r){return this.doCanMoveCopy(c,l,"move",r)}async canCopy(c,l,r){return this.doCanMoveCopy(c,l,"copy",r)}async doCanMoveCopy(c,l,r,a){if(c.toString()!==l.toString())try{const n=r==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c):await this.withReadProvider(c),t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l);await this.doValidateMoveCopy(n,c,t,l,r,a)}catch(n){return n}return!0}async move(c,l,r){const a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),t=await this.doMoveCopy(a,c,n,l,"move",!!r),s=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(c,t==="move"?2:3,s)),s}async copy(c,l,r){const a=await this.withReadProvider(c),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),t=await this.doMoveCopy(a,c,n,l,"copy",!!r),s=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(c,t==="copy"?3:2,s)),s}async doMoveCopy(c,l,r,a,n,t){if(l.toString()===a.toString())return n;const{exists:s,isSameResourceWithDifferentPathCase:o}=await this.doValidateMoveCopy(c,l,r,a,n,t);if(s&&!o&&t&&await this.del(a,{recursive:!0}),await this.mkdirp(r,this.getExtUri(r).providerExtUri.dirname(a)),n==="copy"){if(c===r&&(0,y.hasFileFolderCopyCapability)(c))await c.copy(l,a,{overwrite:t});else{const u=await this.resolve(l);u.isDirectory?await this.doCopyFolder(c,u,r,a):await this.doCopyFile(c,l,r,a)}return n}else return c===r?(await c.rename(l,a,{overwrite:t}),n):(await this.doMoveCopy(c,l,r,a,"copy",t),await this.del(l,{recursive:!0}),"copy")}async doCopyFile(c,l,r,a){if((0,y.hasOpenReadWriteCloseCapability)(c)&&(0,y.hasOpenReadWriteCloseCapability)(r))return this.doPipeBuffered(c,l,r,a);if((0,y.hasOpenReadWriteCloseCapability)(c)&&(0,y.hasReadWriteCapability)(r))return this.doPipeBufferedToUnbuffered(c,l,r,a);if((0,y.hasReadWriteCapability)(c)&&(0,y.hasOpenReadWriteCloseCapability)(r))return this.doPipeUnbufferedToBuffered(c,l,r,a);if((0,y.hasReadWriteCapability)(c)&&(0,y.hasReadWriteCapability)(r))return this.doPipeUnbuffered(c,l,r,a)}async doCopyFolder(c,l,r,a){await r.mkdir(a),Array.isArray(l.children)&&await i.Promises.settled(l.children.map(async n=>{const t=this.getExtUri(r).providerExtUri.joinPath(a,n.name);return n.isDirectory?this.doCopyFolder(c,await this.resolve(n.resource),r,t):this.doCopyFile(c,n.resource,r,t)}))}async doValidateMoveCopy(c,l,r,a,n,t){let s=!1;if(c===r){const{providerExtUri:u,isPathCaseSensitive:f}=this.getExtUri(c);if(f||(s=u.isEqual(l,a)),s&&n==="copy")throw new Error((0,h.localize)(14,null,this.resourceForError(l),this.resourceForError(a)));if(!s&&u.isEqualOrParent(a,l))throw new Error((0,h.localize)(15,null,this.resourceForError(l),this.resourceForError(a)))}const o=await this.exists(a);if(o&&!s){if(!t)throw new y.FileOperationError((0,h.localize)(16,null,this.resourceForError(l),this.resourceForError(a)),4);if(c===r){const{providerExtUri:u}=this.getExtUri(c);if(u.isEqualOrParent(l,a))throw new Error((0,h.localize)(17,null,this.resourceForError(l),this.resourceForError(a)))}}return{exists:o,isSameResourceWithDifferentPathCase:s}}getExtUri(c){const l=this.isPathCaseSensitive(c);return{providerExtUri:l?d.extUri:d.extUriIgnorePathCase,isPathCaseSensitive:l}}isPathCaseSensitive(c){return!!(c.capabilities&1024)}async createFolder(c){const l=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);await this.mkdirp(l,c);const r=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(c,0,r)),r}async mkdirp(c,l){const r=[],{providerExtUri:a}=this.getExtUri(c);for(;!a.isEqual(l,a.dirname(l));)try{if(((await c.stat(l)).type&y.FileType.Directory)==0)throw new Error((0,h.localize)(18,null,this.resourceForError(l)));break}catch(n){if((0,y.toFileSystemProviderErrorCode)(n)!==y.FileSystemProviderErrorCode.FileNotFound)throw n;r.push(a.basename(l)),l=a.dirname(l)}for(let n=r.length-1;n>=0;n--){l=a.joinPath(l,r[n]);try{await c.mkdir(l)}catch(t){if((0,y.toFileSystemProviderErrorCode)(t)!==y.FileSystemProviderErrorCode.FileExists)throw t}}}async canDelete(c,l){try{await this.doValidateDelete(c,l)}catch(r){return r}return!0}async doValidateDelete(c,l){const r=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);if(!!l?.useTrash&&!(r.capabilities&4096))throw new Error((0,h.localize)(19,null,this.resourceForError(c)));let n;try{n=await r.stat(c)}catch{}if(n)this.throwIfFileIsReadonly(c,n);else throw new y.FileOperationError((0,h.localize)(20,null,this.resourceForError(c)),1);if(!!!l?.recursive){const s=await this.resolve(c);if(s.isDirectory&&Array.isArray(s.children)&&s.children.length>0)throw new Error((0,h.localize)(21,null,this.resourceForError(c)))}return r}async del(c,l){const r=await this.doValidateDelete(c,l),a=!!l?.useTrash,n=!!l?.recursive;await r.delete(c,{recursive:n,useTrash:a}),this._onDidRunOperation.fire(new y.FileOperationEvent(c,1))}onDidChangeFile(c,l){this._onDidChangeFilesRaw.fire({changes:c});let r,a;{for(const n of c)this.watchedResources.has(n.resource)?(r||(r=[]),r.push(n)):(a||(a=[]),a.push(n));r&&this._onDidFilesChange.fire(new y.FileChangesEvent(r,!l))}if(a){const n=l?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!n.work(a)&&Ke.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${a.length}, most recent change: ${a[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),n.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${n.pending}, most recent change: ${a[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(c,l={recursive:!1,excludes:[]}){const r=new E.DisposableStore;let a=!1,n=()=>{a=!0};return r.add((0,E.toDisposable)(()=>n())),this.doWatch(c,l).then(t=>{a?(0,E.dispose)(t):n=()=>(0,E.dispose)(t)},t=>this.logService.error(t)),l.recursive||(this.watchedResources.set(c,(this.watchedResources.get(c)??0)+1),r.add((0,E.toDisposable)(()=>{const t=this.watchedResources.get(c);typeof t=="number"&&(t<=1?this.watchedResources.delete(c):this.watchedResources.set(c,t-1))}))),r}async doWatch(c,l){const r=await this.withProvider(c),a=this.toWatchKey(r,c,l);let n=this.activeWatchers.get(a);return n||(n={count:0,disposable:r.watch(c,l)},this.activeWatchers.set(a,n)),n.count+=1,(0,E.toDisposable)(()=>{n&&(n.count--,n.count===0&&((0,E.dispose)(n.disposable),this.activeWatchers.delete(a)))})}toWatchKey(c,l,r){const{providerExtUri:a}=this.getExtUri(c);return[a.getComparisonKey(l),String(r.recursive),r.excludes.join()].join()}dispose(){super.dispose();for(const[,c]of this.activeWatchers)(0,E.dispose)(c.disposable);this.activeWatchers.clear()}async doWriteBuffered(c,l,r,a){return this.writeQueue.queueFor(l,this.getExtUri(c).providerExtUri).queue(async()=>{const n=await c.open(l,{create:!0,unlock:r?.unlock??!1});try{(0,S.isReadableStream)(a)||(0,S.isReadableBufferedStream)(a)?await this.doWriteStreamBufferedQueued(c,n,a):await this.doWriteReadableBufferedQueued(c,n,a)}catch(t){throw(0,y.ensureFileSystemProviderError)(t)}finally{await c.close(n)}})}async doWriteStreamBufferedQueued(c,l,r){let a=0,n;if((0,S.isReadableBufferedStream)(r)){if(r.buffer.length>0){const t=D.VSBuffer.concat(r.buffer);await this.doWriteBuffer(c,l,t,t.byteLength,a,0),a+=t.byteLength}if(r.ended)return;n=r.stream}else n=r;return new Promise((t,s)=>{(0,S.listenStream)(n,{onData:async o=>{n.pause();try{await this.doWriteBuffer(c,l,o,o.byteLength,a,0)}catch(u){return s(u)}a+=o.byteLength,setTimeout(()=>n.resume())},onError:o=>s(o),onEnd:()=>t()})})}async doWriteReadableBufferedQueued(c,l,r){let a=0,n;for(;(n=r.read())!==null;)await this.doWriteBuffer(c,l,n,n.byteLength,a,0),a+=n.byteLength}async doWriteBuffer(c,l,r,a,n,t){let s=0;for(;s<a;)s+=await c.write(l,n+s,r.buffer,t+s,a-s)}async doWriteUnbuffered(c,l,r,a){return this.writeQueue.queueFor(l,this.getExtUri(c).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(c,l,r,a))}async doWriteUnbufferedQueued(c,l,r,a){let n;a instanceof D.VSBuffer?n=a:(0,S.isReadableStream)(a)?n=await(0,D.streamToBuffer)(a):(0,S.isReadableBufferedStream)(a)?n=await(0,D.bufferedStreamToBuffer)(a):n=(0,D.readableToBuffer)(a),await c.writeFile(l,n.buffer,{create:!0,overwrite:!0,unlock:r?.unlock??!1})}async doPipeBuffered(c,l,r,a){return this.writeQueue.queueFor(a,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeBufferedQueued(c,l,r,a))}async doPipeBufferedQueued(c,l,r,a){let n,t;try{n=await c.open(l,{create:!1}),t=await r.open(a,{create:!0,unlock:!1});const s=D.VSBuffer.alloc(this.BUFFER_SIZE);let o=0,u=0,f=0;do f=await c.read(n,o,s.buffer,u,s.byteLength-u),await this.doWriteBuffer(r,t,s,f,o,u),o+=f,u+=f,u===s.byteLength&&(u=0);while(f>0)}catch(s){throw(0,y.ensureFileSystemProviderError)(s)}finally{await i.Promises.settled([typeof n=="number"?c.close(n):Promise.resolve(),typeof t=="number"?r.close(t):Promise.resolve()])}}async doPipeUnbuffered(c,l,r,a){return this.writeQueue.queueFor(a,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(c,l,r,a))}async doPipeUnbufferedQueued(c,l,r,a){return r.writeFile(a,await c.readFile(l),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(c,l,r,a){return this.writeQueue.queueFor(a,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(c,l,r,a))}async doPipeUnbufferedToBufferedQueued(c,l,r,a){const n=await r.open(a,{create:!0,unlock:!1});try{const t=await c.readFile(l);await this.doWriteBuffer(r,n,D.VSBuffer.wrap(t),t.byteLength,0,0)}catch(t){throw(0,y.ensureFileSystemProviderError)(t)}finally{await r.close(n)}}async doPipeBufferedToUnbuffered(c,l,r,a){const n=await(0,D.streamToBuffer)(this.readFileBuffered(c,l,_.CancellationToken.None));await this.doWriteUnbuffered(r,a,void 0,n)}throwIfFileSystemIsReadonly(c,l){if(c.capabilities&2048)throw new y.FileOperationError((0,h.localize)(22,null,this.resourceForError(l)),6);return c}throwIfFileIsReadonly(c,l){if((l.permissions??0)&y.FilePermission.Readonly)throw new y.FileOperationError((0,h.localize)(23,null,this.resourceForError(c)),6)}resourceForError(c){return c.scheme===P.Schemas.file?c.fsPath:c.toString(!0)}};w.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},w=de([J(0,m.ILogService)],w),e.FileService=w}),define(te[177],ne([0,1,50,246,5,19,3,40,9,4,18,49,20,139,14,82,165,166,174,38]),function(Q,e,L,i,D,_,k,R,E,C,P,b,d,S,h,y,p,m,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,i.gracefulify)(L)}catch(l){console.error(`Error enabling graceful-fs: ${(0,g.toErrorMessage)(l)}`)}})();class c extends w.AbstractDiskFileSystemProvider{constructor(r,a){super(r);this.options=a,this.onDidChangeCapabilities=k.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,C.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(r){try{const{stat:a,symbolicLink:n}=await d.SymlinkSupport.stat(this.toFilePath(r));return{type:this.toType(a,n),ctime:a.birthtime.getTime(),mtime:a.mtime.getTime(),size:a.size}}catch(a){throw this.toFileSystemProviderError(a)}}async readdir(r){try{const a=await d.Promises.readdir(this.toFilePath(r),{withFileTypes:!0}),n=[];return await Promise.all(a.map(async t=>{try{let s;t.isSymbolicLink()?s=(await this.stat((0,P.joinPath)(r,t.name))).type:s=this.toType(t),n.push([t.name,s])}catch(s){this.logService.trace(s)}})),n}catch(a){throw this.toFileSystemProviderError(a)}}toType(r,a){let n;return a?.dangling?n=h.FileType.Unknown:r.isFile()?n=h.FileType.File:r.isDirectory()?n=h.FileType.Directory:n=h.FileType.Unknown,a&&(n|=h.FileType.SymbolicLink),n}async readFile(r){try{const a=this.toFilePath(r);return await d.Promises.readFile(a)}catch(a){throw this.toFileSystemProviderError(a)}}readFileStream(r,a,n){const t=(0,b.newWriteableStream)(s=>_.VSBuffer.concat(s.map(o=>_.VSBuffer.wrap(o))).buffer);return(0,y.readFileIntoStream)(this,r,t,s=>s.buffer,{...a,bufferSize:256*1024},n),t}async writeFile(r,a,n){let t;try{const s=this.toFilePath(r);if(!n.create||!n.overwrite){if(await d.Promises.exists(s)){if(!n.overwrite)throw(0,h.createFileSystemProviderError)((0,S.localize)(0,null),h.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,h.createFileSystemProviderError)((0,S.localize)(1,null),h.FileSystemProviderErrorCode.FileNotFound)}t=await this.open(r,{create:!0,unlock:n.unlock}),await this.write(t,0,a,0,a.byteLength)}catch(s){throw await this.toFileSystemProviderWriteError(r,s)}finally{typeof t=="number"&&await this.close(t)}}async open(r,a){try{const n=this.toFilePath(r);if((0,h.isFileOpenForWriteOptions)(a)&&a.unlock)try{const{stat:o}=await d.SymlinkSupport.stat(n);o.mode&128||await d.Promises.chmod(n,o.mode|128)}catch(o){this.logService.trace(o)}let t;if((0,h.isFileOpenForWriteOptions)(a)){if(C.isWindows)try{await d.Promises.truncate(n,0),t="r+"}catch(o){o.code!=="ENOENT"&&this.logService.trace(o)}t||(t="w")}else t="r";const s=await d.Promises.open(n,t);return this.mapHandleToPos.set(s,0),(0,h.isFileOpenForWriteOptions)(a)&&this.writeHandles.set(s,r),s}catch(n){throw(0,h.isFileOpenForWriteOptions)(a)?await this.toFileSystemProviderWriteError(r,n):this.toFileSystemProviderError(n)}}async close(r){try{if(this.mapHandleToPos.delete(r),this.writeHandles.delete(r)&&this.canFlush)try{await d.Promises.fdatasync(r)}catch(a){this.canFlush=!1,this.logService.error(a)}return await d.Promises.close(r)}catch(a){throw this.toFileSystemProviderError(a)}}async read(r,a,n,t,s){const o=this.normalizePos(r,a);let u=null;try{const f=await d.Promises.read(r,n,t,s,o);return typeof f=="number"?u=f:u=f.bytesRead,u}catch(f){throw this.toFileSystemProviderError(f)}finally{this.updatePos(r,o,u)}}normalizePos(r,a){return a===this.mapHandleToPos.get(r)?null:a}updatePos(r,a,n){const t=this.mapHandleToPos.get(r);typeof t=="number"&&(typeof a=="number"||(typeof n=="number"?this.mapHandleToPos.set(r,t+n):this.mapHandleToPos.delete(r)))}async write(r,a,n,t,s){return(0,D.retry)(()=>this.doWrite(r,a,n,t,s),100,3)}async doWrite(r,a,n,t,s){const o=this.normalizePos(r,a);let u=null;try{const f=await d.Promises.write(r,n,t,s,o);return typeof f=="number"?u=f:u=f.bytesWritten,u}catch(f){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(r),f)}finally{this.updatePos(r,o,u)}}async mkdir(r){try{await d.Promises.mkdir(this.toFilePath(r))}catch(a){throw this.toFileSystemProviderError(a)}}async delete(r,a){try{const n=this.toFilePath(r);a.recursive?await d.Promises.rm(n,d.RimRafMode.MOVE):await d.Promises.unlink(n)}catch(n){throw this.toFileSystemProviderError(n)}}async rename(r,a,n){const t=this.toFilePath(r),s=this.toFilePath(a);if(t!==s)try{await this.validateTargetDeleted(r,a,"move",n.overwrite),await d.Promises.move(t,s)}catch(o){throw(o.code==="EINVAL"||o.code==="EBUSY"||o.code==="ENAMETOOLONG")&&(o=new Error((0,S.localize)(2,null,(0,E.basename)(t),(0,E.basename)((0,E.dirname)(s)),o.toString()))),this.toFileSystemProviderError(o)}}async copy(r,a,n){const t=this.toFilePath(r),s=this.toFilePath(a);if(t!==s)try{await this.validateTargetDeleted(r,a,"copy",n.overwrite),await d.Promises.copy(t,s,{preserveSymlinks:!0})}catch(o){throw(o.code==="EINVAL"||o.code==="EBUSY"||o.code==="ENAMETOOLONG")&&(o=new Error((0,S.localize)(3,null,(0,E.basename)(t),(0,E.basename)((0,E.dirname)(s)),o.toString()))),this.toFileSystemProviderError(o)}}async validateTargetDeleted(r,a,n,t){const s=this.toFilePath(r),o=this.toFilePath(a);let u=!1;if(!!(this.capabilities&1024)||(u=(0,R.isEqual)(s,o,!0)),u&&n==="copy")throw(0,h.createFileSystemProviderError)((0,S.localize)(4,null),h.FileSystemProviderErrorCode.FileExists);if(!u&&await d.Promises.exists(o)){if(!t)throw(0,h.createFileSystemProviderError)((0,S.localize)(5,null),h.FileSystemProviderErrorCode.FileExists);await this.delete(a,{recursive:!0,useTrash:!1})}}createRecursiveWatcher(r,a,n){return new m.ParcelWatcherClient(t=>r(t),t=>a(t),n)}doWatch(r,a){const n=this.options?.watcher?.usePolling;if(n===!0)for(const t of a)t.pollingInterval=this.options?.watcher?.pollingInterval??5e3;else if(Array.isArray(n))for(const t of a)n.includes(t.path)&&(t.pollingInterval=this.options?.watcher?.pollingInterval??5e3);return super.doWatch(r,a)}createNonRecursiveWatcher(r,a,n,t){return new p.NodeJSFileWatcher(r,s=>a(s),s=>n(s),t)}toFileSystemProviderError(r){if(r instanceof h.FileSystemProviderError)return r;let a;switch(r.code){case"ENOENT":a=h.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":a=h.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":a=h.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":a=h.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":a=h.FileSystemProviderErrorCode.NoPermissions;break;default:a=h.FileSystemProviderErrorCode.Unknown}return(0,h.createFileSystemProviderError)(r,a)}async toFileSystemProviderWriteError(r,a){let n=this.toFileSystemProviderError(a);if(r&&n.code===h.FileSystemProviderErrorCode.NoPermissions)try{const{stat:t}=await d.SymlinkSupport.stat(this.toFilePath(r));t.mode&128||(n=(0,h.createFileSystemProviderError)(a,h.FileSystemProviderErrorCode.FileWriteLocked))}catch(t){this.logService.trace(t)}return n}}e.DiskFileSystemProvider=c}),define(te[85],ne([0,1,3,7,8]),function(Q,e,L,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class _{constructor(d){this.service=d,this.onDidChangeLogLevel=L.Event.buffer(d.onDidChangeLogLevel,!0)}listen(d,S){switch(S){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${S}`)}async call(d,S,h){switch(S){case"setLevel":return this.service.setLevel(h)}throw new Error(`Call not found: ${S}`)}}e.LogLevelChannel=_;class k{constructor(d){this.channel=d}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(d){k.setLevel(this.channel,d)}static setLevel(d,S){return d.call("setLevel",S)}}e.LogLevelChannelClient=k;class R{constructor(d){this.loggerService=d,this.loggers=new Map}listen(d,S){throw new Error(`Event not found: ${S}`)}async call(d,S,h){switch(S){case"createLogger":this.createLogger(i.URI.revive(h[0]),h[1]);return;case"log":return this.log(i.URI.revive(h[0]),h[1]);case"consoleLog":return this.consoleLog(h[0],h[1])}throw new Error(`Call not found: ${S}`)}createLogger(d,S){this.loggers.set(d.toString(),this.loggerService.createLogger(d,S))}consoleLog(d,S){let h=console.log;switch(d){case D.LogLevel.Error:h=console.error;break;case D.LogLevel.Warning:h=console.warn;break;case D.LogLevel.Info:h=console.info;break}h.call(console,...S)}log(d,S){const h=this.loggers.get(d.toString());if(!h)throw new Error("Create the logger before logging");for(const[y,p]of S)(0,D.log)(h,y,p)}}e.LoggerChannel=R;class E extends D.AbstractLoggerService{constructor(d,S,h){super(d,S);this.channel=h}createConsoleMainLogger(){return new D.AdapterLogger({log:(d,S)=>{this.channel.call("consoleLog",[d,S])}})}doCreateLogger(d,S,h){return new C(this.channel,d,S,h)}}e.LoggerChannelClient=E;class C extends D.AbstractMessageLogger{constructor(d,S,h,y){super(y?.always);this.channel=d,this.file=S,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(h),this.channel.call("createLogger",[S,y]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(d,S){const h=[[d,S]];this.isLoggerCreated?this.doLog(h):this.buffer.push(...h)}doLog(d){this.channel.call("log",[this.file,d])}}class P extends D.LogService{constructor(d,S){super(S);this.parent=d,this._register(d.onDidChangeLogLevel(h=>S.setLevel(h)))}setLevel(d){super.setLevel(d),this.parent.setLevel(d)}}e.FollowerLogService=P}),define(te[60],ne([0,1,6]),function(Q,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,L.createDecorator)("nativeHostService")}),define(te[86],ne([0,1,17,4,32,18]),function(Q,e,L,i,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let k;if(typeof i.globals.vscode!="undefined"&&typeof i.globals.vscode.context!="undefined"){const R=i.globals.vscode.context.configuration();if(R)k=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof Q?.__$__nodeRequire=="function"){const R=(0,_.dirname)(L.FileAccess.asFileUri("",Q));k=Q.__$__nodeRequire((0,_.joinPath)(R,"product.json").fsPath);const E=Q.__$__nodeRequire((0,_.joinPath)(R,"package.json").fsPath);D.env.VSCODE_DEV&&Object.assign(k,{nameShort:`${k.nameShort} Dev`,nameLong:`${k.nameLong} Dev`,dataFolderName:`${k.dataFolderName}-dev`}),Object.assign(k,{version:E.version})}else k={},Object.keys(k).length===0&&Object.assign(k,{version:"1.63.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=k}),define(te[26],ne([0,1,6]),function(Q,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=(0,L.createDecorator)("productService")}),define(te[178],ne([0,1,5,10,2,9,20,8,26]),function(Q,e,L,i,D,_,k,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let C=class extends D.Disposable{constructor(b,d,S){super();this.productService=d,this.logService=S,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,b&&this._register(new L.RunOnceScheduler(()=>{this.cleanUpCodeCaches(b)},30*1e3)).schedule()}async cleanUpCodeCaches(b){this.logService.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const d=Date.now(),S=(0,_.dirname)(b),h=(0,_.basename)(b),y=await k.Promises.readdir(S);await Promise.all(y.map(async p=>{if(p===h)return;const m=(0,_.join)(S,p),w=await k.Promises.stat(m);if(w.isDirectory()&&d-w.mtime.getTime()>this._DataMaxAge)return this.logService.trace(`[code cache cleanup]: Removing code cache folder ${p}.`),k.Promises.rm(m)}))}catch(d){(0,i.onUnexpectedError)(d)}}};C=de([J(1,E.IProductService),J(2,R.ILogService)],C),e.CodeCacheCleaner=C}),define(te[179],ne([0,1,5,10,2,9,20,11,8,26]),function(Q,e,L,i,D,_,k,R,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let P=class extends D.Disposable{constructor(d,S,h){super();this.environmentService=d,this.logService=S,this.productService=h,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new L.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},40*1e3)).schedule()}async cleanUpLanguagePackCache(){this.logService.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const d=Object.create(null),S=JSON.parse(await k.Promises.readFile((0,_.join)(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(let w of Object.keys(S)){const g=S[w];d[`${g.hash}.${w}`]=!0}const h=(0,_.join)(this.environmentService.userDataPath,"clp");if(!await k.Promises.exists(h))return;const p=await k.Promises.readdir(h);for(const w of p){if(d[w]){this.logService.trace(`[language pack cache cleanup]: Skipping folder ${w}. Language pack still in use.`);continue}this.logService.trace(`[language pack cache cleanup]: Removing unused language pack: ${w}`),await k.Promises.rm((0,_.join)(h,w))}const m=Date.now();for(const w of Object.keys(d)){const g=(0,_.join)(h,w),c=await k.Promises.readdir(g);for(const l of c){if(l==="tcf.json")continue;const r=(0,_.join)(g,l),a=await k.Promises.stat(r);a.isDirectory()&&m-a.mtime.getTime()>this._DataMaxAge&&(this.logService.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,_.join)(w,l)}`),await k.Promises.rm(r))}}}catch(d){(0,i.onUnexpectedError)(d)}}};P=de([J(0,R.INativeEnvironmentService),J(1,E.ILogService),J(2,C.IProductService)],P),e.LanguagePackCachedDataCleaner=P}),define(te[37],ne([0,1,99,15]),function(Q,e,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class D{constructor(){this.data=new Map}add(k,R){L.ok(i.isString(k)),L.ok(i.isObject(R)),L.ok(!this.data.has(k),"There is already an extension with this id"),this.data.set(k,R)}knows(k){return this.data.has(k)}as(k){return this.data.get(k)||null}}e.Registry=new D}),define(te[87],ne([0,1,3,37]),function(Q,e,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function D(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class _{constructor(){this._onDidChangeSchema=new L.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(E,C){this.schemasById[D(E)]=C,this._onDidChangeSchema.fire(E)}notifySchemaChanged(E){this._onDidChangeSchema.fire(E)}getSchemaContributions(){return{schemas:this.schemasById}}}const k=new _;i.Registry.add(e.Extensions.JSONContribution,k)}),define(te[41],ne([0,1,16,3,15,125,87,37]),function(Q,e,L,i,D,_,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var E;(function(c){c.Multiline="multilineText",c.Singleline="singlelineText"})(E=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var C;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.MACHINE=2]="MACHINE",c[c.WINDOW=3]="WINDOW",c[c.RESOURCE=4]="RESOURCE",c[c.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",c[c.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(C=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const P=R.Registry.as(k.Extensions.JSONContribution);class b{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new i.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new i.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:_.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(l,r=!0){this.registerConfigurations([l],r)}registerConfigurations(l,r=!0){const a=this.doRegisterConfigurations(l,r);P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a})}deregisterConfigurations(l){const r=this.doDeregisterConfigurations(l);P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}updateConfigurations({add:l,remove:r}){const a=[];a.push(...this.doDeregisterConfigurations(r)),a.push(...this.doRegisterConfigurations(l,!1)),P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,L.distinct)(a)})}registerDefaultConfigurations(l){const r=[],a=[];for(const{overrides:n,source:t}of l)for(const s in n)if(r.push(s),e.OVERRIDE_PROPERTY_REGEX.test(s)){const o={...this.configurationDefaultsOverrides.get(s)?.value||{},...n[s]};this.configurationDefaultsOverrides.set(s,{source:t,value:o});const u={type:"object",default:o,description:_.localize(1,null,s),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:o,source:D.isString(t)?void 0:t};a.push(...h(s)),this.configurationProperties[s]=u,this.defaultLanguageConfigurationOverridesNode.properties[s]=u}else{this.configurationDefaultsOverrides.set(s,{value:n[s],source:t});const o=this.configurationProperties[s];o&&(this.updatePropertyDefaultValue(s,o),this.updateSchema(s,o))}this.registerOverrideIdentifiers(a),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}deregisterDefaultConfigurations(l){const r=[];for(const{overrides:a,source:n}of l)for(const t in a){const s=this.configurationDefaultsOverrides.get(t),o=D.isString(n)?n:n?.id,u=D.isString(s?.source)?s?.source:s?.source?.id;if(o===u)if(r.push(t),this.configurationDefaultsOverrides.delete(t),e.OVERRIDE_PROPERTY_REGEX.test(t))delete this.configurationProperties[t],delete this.defaultLanguageConfigurationOverridesNode.properties[t];else{const f=this.configurationProperties[t];f&&(this.updatePropertyDefaultValue(t,f),this.updateSchema(t,f))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...l){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(l){for(const r of l)this.overrideIdentifiers.add(r);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(l,r){const a=[];return l.forEach(n=>{a.push(...this.validateAndRegisterProperties(n,r,n.extensionInfo,n.restrictedProperties)),this.configurationContributors.push(n),this.registerJSONConfiguration(n)}),a}doDeregisterConfigurations(l){const r=[],a=n=>{if(n.properties)for(const t in n.properties)r.push(t),delete this.configurationProperties[t],this.removeFromSchema(t,n.properties[t]);n.allOf&&n.allOf.forEach(t=>a(t))};for(const n of l){a(n);const t=this.configurationContributors.indexOf(n);t!==-1&&this.configurationContributors.splice(t,1)}return r}validateAndRegisterProperties(l,r=!0,a,n,t=3){t=D.isUndefinedOrNull(l.scope)?t:l.scope;let s=[],o=l.properties;if(o)for(let f in o){if(r&&w(f)){delete o[f];continue}const v=o[f];if(v.source=a,v.defaultDefaultValue=o[f].default,this.updatePropertyDefaultValue(f,v),e.OVERRIDE_PROPERTY_REGEX.test(f)?v.scope=void 0:(v.scope=D.isUndefinedOrNull(v.scope)?t:v.scope,v.restricted=D.isUndefinedOrNull(v.restricted)?!!n?.includes(f):v.restricted),o[f].hasOwnProperty("included")&&!o[f].included){this.excludedConfigurationProperties[f]=o[f],delete o[f];continue}else this.configurationProperties[f]=o[f];!o[f].deprecationMessage&&o[f].markdownDeprecationMessage&&(o[f].deprecationMessage=o[f].markdownDeprecationMessage),s.push(f)}let u=l.allOf;if(u)for(let f of u)s.push(...this.validateAndRegisterProperties(f,r,a,n,t));return s}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(l){const r=a=>{let n=a.properties;if(n)for(const s in n)this.updateSchema(s,n[s]);let t=a.allOf;t&&t.forEach(r)};r(l)}updateSchema(l,r){switch(e.allSettings.properties[l]=r,r.scope){case 1:e.applicationSettings.properties[l]=r;break;case 2:e.machineSettings.properties[l]=r;break;case 6:e.machineOverridableSettings.properties[l]=r;break;case 3:e.windowSettings.properties[l]=r;break;case 4:e.resourceSettings.properties[l]=r;break;case 5:e.resourceSettings.properties[l]=r,this.resourceLanguageSettingsSchema.properties[l]=r;break}}removeFromSchema(l,r){switch(delete e.allSettings.properties[l],r.scope){case 1:delete e.applicationSettings.properties[l];break;case 2:delete e.machineSettings.properties[l];break;case 6:delete e.machineOverridableSettings.properties[l];break;case 3:delete e.windowSettings.properties[l];break;case 4:case 5:delete e.resourceSettings.properties[l],delete this.resourceLanguageSettingsSchema.properties[l];break}}updateOverridePropertyPatternKey(){for(const l of this.overrideIdentifiers.values()){const r=`[${l}]`,a={type:"object",description:_.localize(2,null),errorMessage:_.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(r,a),e.allSettings.properties[r]=a,e.applicationSettings.properties[r]=a,e.machineSettings.properties[r]=a,e.machineOverridableSettings.properties[r]=a,e.windowSettings.properties[r]=a,e.resourceSettings.properties[r]=a}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const l={type:"object",description:_.localize(4,null),errorMessage:_.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(l,r){const a=this.configurationDefaultsOverrides.get(l);let n=a?.value,t=a?.source;D.isUndefined(n)&&(n=r.defaultDefaultValue,t=void 0),D.isUndefined(n)&&(n=p(r.type)),r.default=n,r.defaultValueSource=t}}const d="\\[([^\\]]+)\\]",S=new RegExp(d,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${d})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function h(c){const l=[];if(e.OVERRIDE_PROPERTY_REGEX.test(c)){let r=S.exec(c);for(;r?.length;){const a=r[1].trim();a&&l.push(a),r=S.exec(c)}}return(0,L.distinct)(l)}e.overrideIdentifiersFromKey=h;function y(c){return c.reduce((l,r)=>`${l}[${r}]`,"")}e.keyFromOverrideIdentifiers=y;function p(c){switch(Array.isArray(c)?c[0]:c){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=p;const m=new b;R.Registry.add(e.Extensions.Configuration,m);function w(c){return c.trim()?e.OVERRIDE_PROPERTY_REGEX.test(c)?_.localize(7,null,c):m.getConfigurationProperties()[c]!==void 0?_.localize(8,null,c):null:_.localize(6,null)}e.validateProperty=w;function g(){const c=[],l=m.getConfigurationProperties();for(const r of Object.keys(l))c.push([r,l[r].scope]);return c.push(["launch",4]),c.push(["task",4]),c}e.getScopes=g}),define(te[88],ne([0,1,16,3,31,2,39,28,15,7,21,41,37]),function(Q,e,L,i,D,_,k,R,E,C,P,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class S{constructor(n={},t=[],s=[]){this._contents=n,this._keys=t,this._overrides=s,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(n){return n?(0,P.getConfigurationValue)(this.contents,n):this.contents}getOverrideValue(n,t){const s=this.getContentsForOverrideIdentifer(t);return s?n?(0,P.getConfigurationValue)(s,n):s:void 0}getKeysForOverrideIdentifier(n){const t=[];for(const s of this.overrides)s.identifiers.includes(n)&&t.push(...s.keys);return L.distinct(t)}getAllOverrideIdentifiers(){const n=[];for(const t of this.overrides)n.push(...t.identifiers);return L.distinct(n)}override(n){let t=this.overrideConfigurations.get(n);return t||(t=this.createOverrideConfigurationModel(n),this.overrideConfigurations.set(n,t)),t}merge(...n){const t=R.deepClone(this.contents),s=R.deepClone(this.overrides),o=[...this.keys];for(const u of n){this.mergeContents(t,u.contents);for(const f of u.overrides){const[v]=s.filter(I=>L.equals(I.identifiers,f.identifiers));v?(this.mergeContents(v.contents,f.contents),v.keys.push(...f.keys),v.keys=L.distinct(v.keys)):s.push(R.deepClone(f))}for(const f of u.keys)o.indexOf(f)===-1&&o.push(f)}return new S(t,o,s)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(n){const t=this.getContentsForOverrideIdentifer(n);if(!t||typeof t!="object"||!Object.keys(t).length)return this;let s={};for(const o of L.distinct([...Object.keys(this.contents),...Object.keys(t)])){let u=this.contents[o],f=t[o];f&&(typeof u=="object"&&typeof f=="object"?(u=R.deepClone(u),this.mergeContents(u,f)):u=f),s[o]=u}return new S(s,this.keys,this.overrides)}mergeContents(n,t){for(const s of Object.keys(t)){if(s in n&&E.isObject(n[s])&&E.isObject(t[s])){this.mergeContents(n[s],t[s]);continue}n[s]=R.deepClone(t[s])}}checkAndFreeze(n){return this.isFrozen&&!Object.isFrozen(n)?R.deepFreeze(n):n}getContentsForOverrideIdentifer(n){let t=null,s=null;const o=u=>{u&&(s?this.mergeContents(s,u):s=R.deepClone(u))};for(const u of this.overrides)L.equals(u.identifiers,[n])?t=u.contents:u.identifiers.includes(n)&&o(u.contents);return o(t),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(n,t){this.addKey(n),(0,P.addToValueTree)(this.contents,n,t,s=>{throw new Error(s)})}removeValue(n){this.removeKey(n)&&(0,P.removeFromValueTree)(this.contents,n)}addKey(n){let t=this.keys.length;for(let s=0;s<t;s++)n.indexOf(this.keys[s])===0&&(t=s);this.keys.splice(t,1,n)}removeKey(n){let t=this.keys.indexOf(n);return t!==-1?(this.keys.splice(t,1),!0):!1}}e.ConfigurationModel=S;class h extends S{constructor(n={}){const t=d.Registry.as(b.Extensions.Configuration).getConfigurationProperties(),s=Object.keys(t),o=Object.create(null),u=[];for(const f in t){const v=n[f],I=v!==void 0?v:t[f].default;(0,P.addToValueTree)(o,f,I,O=>console.error(`Conflict in default settings: ${O}`))}for(const f of Object.keys(o))b.OVERRIDE_PROPERTY_REGEX.test(f)&&u.push({identifiers:(0,b.overrideIdentifiersFromKey)(f),keys:Object.keys(o[f]),contents:(0,P.toValuesTree)(o[f],v=>console.error(`Conflict in default settings file: ${v}`))});super(o,s,u)}}e.DefaultConfigurationModel=h;class y{constructor(n){this._name=n,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new S}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(n,t){if(!E.isUndefinedOrNull(n)){const s=this.doParseContent(n);this.parseRaw(s,t)}}reparse(n){this._raw&&this.parseRaw(this._raw,n)}parseRaw(n,t){this._raw=n;const{contents:s,keys:o,overrides:u,restricted:f}=this.doParseRaw(n,t);this._configurationModel=new S(s,o,u),this._restrictedConfigurations=f||[]}doParseContent(n){let t={},s=null,o=[],u=[],f=[];function v(O){Array.isArray(o)?o.push(O):s!==null&&(o[s]=O)}let I={onObjectBegin:()=>{let O={};v(O),u.push(o),o=O,s=null},onObjectProperty:O=>{s=O},onObjectEnd:()=>{o=u.pop()},onArrayBegin:()=>{let O=[];v(O),u.push(o),o=O,s=null},onArrayEnd:()=>{o=u.pop()},onLiteralValue:v,onError:(O,A,N)=>{f.push({error:O,offset:A,length:N})}};if(n)try{D.visit(n,I),t=o[0]||{}}catch(O){console.error(`Error while parsing settings file ${this._name}: ${O}`),this._parseErrors=[O]}return t}doParseRaw(n,t){const s=d.Registry.as(b.Extensions.Configuration).getConfigurationProperties(),o=this.filter(n,s,!0,t);n=o.raw;const u=(0,P.toValuesTree)(n,I=>console.error(`Conflict in settings file ${this._name}: ${I}`)),f=Object.keys(n),v=this.toOverrides(n,I=>console.error(`Conflict in settings file ${this._name}: ${I}`));return{contents:u,keys:f,overrides:v,restricted:o.restricted}}filter(n,t,s,o){if(!o?.scopes&&!o?.skipRestricted)return{raw:n,restricted:[]};const u={},f=[];for(let v in n)if(b.OVERRIDE_PROPERTY_REGEX.test(v)&&s){const I=this.filter(n[v],t,!1,o);u[v]=I.raw,f.push(...I.restricted)}else{const I=t[v],O=I?typeof I.scope!="undefined"?I.scope:3:void 0;I?.restricted&&f.push(v),(O===void 0||o.scopes===void 0||o.scopes.includes(O))&&(o.skipRestricted&&I?.restricted||(u[v]=n[v]))}return{raw:u,restricted:f}}toOverrides(n,t){const s=[];for(const o of Object.keys(n))if(b.OVERRIDE_PROPERTY_REGEX.test(o)){const u={};for(const f in n[o])u[f]=n[o][f];s.push({identifiers:(0,b.overrideIdentifiersFromKey)(o),keys:Object.keys(u),contents:(0,P.toValuesTree)(u,t)})}return s}}e.ConfigurationModelParser=y;class p extends _.Disposable{constructor(n,t,s,o){super();this.userSettingsResource=n,this.scopes=t,this.fileService=o,this._onDidChange=this._register(new i.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new y(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(i.Event.filter(this.fileService.onDidFilesChange,u=>u.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const n=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(n.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new S}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=p;class m{constructor(n,t,s=new S,o=new S,u=new k.ResourceMap,f=new S,v=new k.ResourceMap,I=!0){this._defaultConfiguration=n,this._localUserConfiguration=t,this._remoteUserConfiguration=s,this._workspaceConfiguration=o,this._folderConfigurations=u,this._memoryConfiguration=f,this._memoryConfigurationByResource=v,this._freeze=I,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new k.ResourceMap,this._userConfiguration=null}getValue(n,t,s){return this.getConsolidateConfigurationModel(t,s).getValue(n)}updateValue(n,t,s={}){let o;s.resource?(o=this._memoryConfigurationByResource.get(s.resource),o||(o=new S,this._memoryConfigurationByResource.set(s.resource,o))):o=this._memoryConfiguration,t===void 0?o.removeValue(n):o.setValue(n,t),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(n,t,s){const o=this.getConsolidateConfigurationModel(t,s),u=this.getFolderConfigurationModelForResource(t.resource,s),f=t.resource?this._memoryConfigurationByResource.get(t.resource)||this._memoryConfiguration:this._memoryConfiguration,v=t.overrideIdentifier?this._defaultConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this._defaultConfiguration.freeze().getValue(n),I=t.overrideIdentifier?this.userConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this.userConfiguration.freeze().getValue(n),O=t.overrideIdentifier?this.localUserConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this.localUserConfiguration.freeze().getValue(n),A=t.overrideIdentifier?this.remoteUserConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this.remoteUserConfiguration.freeze().getValue(n),N=s?t.overrideIdentifier?this._workspaceConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this._workspaceConfiguration.freeze().getValue(n):void 0,$=u?t.overrideIdentifier?u.freeze().override(t.overrideIdentifier).getValue(n):u.freeze().getValue(n):void 0,T=t.overrideIdentifier?f.override(t.overrideIdentifier).getValue(n):f.getValue(n),F=o.getValue(n),M=L.distinct(L.flatten(o.overrides.map(U=>U.identifiers))).filter(U=>o.getOverrideValue(n,U)!==void 0);return{defaultValue:v,userValue:I,userLocalValue:O,userRemoteValue:A,workspaceValue:N,workspaceFolderValue:$,memoryValue:T,value:F,default:v!==void 0?{value:this._defaultConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,user:I!==void 0?{value:this.userConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,userLocal:O!==void 0?{value:this.localUserConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,userRemote:A!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,workspace:N!==void 0?{value:this._workspaceConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,workspaceFolder:$!==void 0?{value:u?.freeze().getValue(n),override:t.overrideIdentifier?u?.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,memory:T!==void 0?{value:f.getValue(n),override:t.overrideIdentifier?f.getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,overrideIdentifiers:M.length?M:void 0}}keys(n){const t=this.getFolderConfigurationModelForResource(void 0,n);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:t?t.freeze().keys:[]}}updateDefaultConfiguration(n){this._defaultConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(n){this._localUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(n){this._remoteUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(n){this._workspaceConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(n,t){this._folderConfigurations.set(n,t),this._foldersConsolidatedConfigurations.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this._foldersConsolidatedConfigurations.delete(n)}compareAndUpdateDefaultConfiguration(n,t){const s=[];if(!t){const{added:o,updated:u,removed:f}=l(this._defaultConfiguration,n);t=[...o,...u,...f]}for(const o of t)for(const u of(0,b.overrideIdentifiersFromKey)(o)){const f=this._defaultConfiguration.getKeysForOverrideIdentifier(u),v=n.getKeysForOverrideIdentifier(u),I=[...v.filter(O=>f.indexOf(O)===-1),...f.filter(O=>v.indexOf(O)===-1),...f.filter(O=>!R.equals(this._defaultConfiguration.override(u).getValue(O),n.override(u).getValue(O)))];s.push([u,I])}return this.updateDefaultConfiguration(n),{keys:t,overrides:s}}compareAndUpdateLocalUserConfiguration(n){const{added:t,updated:s,removed:o,overrides:u}=l(this.localUserConfiguration,n),f=[...t,...s,...o];return f.length&&this.updateLocalUserConfiguration(n),{keys:f,overrides:u}}compareAndUpdateRemoteUserConfiguration(n){const{added:t,updated:s,removed:o,overrides:u}=l(this.remoteUserConfiguration,n);let f=[...t,...s,...o];return f.length&&this.updateRemoteUserConfiguration(n),{keys:f,overrides:u}}compareAndUpdateWorkspaceConfiguration(n){const{added:t,updated:s,removed:o,overrides:u}=l(this.workspaceConfiguration,n);let f=[...t,...s,...o];return f.length&&this.updateWorkspaceConfiguration(n),{keys:f,overrides:u}}compareAndUpdateFolderConfiguration(n,t){const s=this.folderConfigurations.get(n),{added:o,updated:u,removed:f,overrides:v}=l(s,t);let I=[...o,...u,...f];return(I.length||!s)&&this.updateFolderConfiguration(n,t),{keys:I,overrides:v}}compareAndDeleteFolderConfiguration(n){const t=this.folderConfigurations.get(n);if(!t)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:s,updated:o,removed:u,overrides:f}=l(t,void 0);return{keys:[...s,...o,...u],overrides:f}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(n,t){let s=this.getConsolidatedConfigurationModelForResource(n,t);return n.overrideIdentifier?s.override(n.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:n},t){let s=this.getWorkspaceConsolidatedConfiguration();if(t&&n){const o=t.getFolder(n);o&&(s=this.getFolderConsolidatedConfiguration(o.uri)||s);const u=this._memoryConfigurationByResource.get(n);u&&(s=s.merge(u))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(n){let t=this._foldersConsolidatedConfigurations.get(n);if(!t){const s=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(n);o?(t=s.merge(o),this._freeze&&(t=t.freeze()),this._foldersConsolidatedConfigurations.set(n,t)):t=s}return t}getFolderConfigurationModelForResource(n,t){if(t&&n){const s=t.getFolder(n);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((n,t)=>{const{contents:s,overrides:o,keys:u}=this._folderConfigurations.get(t);return n.push([t,{contents:s,overrides:o,keys:u}]),n},[])}}allKeys(){const n=new Set;return this._defaultConfiguration.freeze().keys.forEach(t=>n.add(t)),this.userConfiguration.freeze().keys.forEach(t=>n.add(t)),this._workspaceConfiguration.freeze().keys.forEach(t=>n.add(t)),this._folderConfigurations.forEach(t=>t.freeze().keys.forEach(s=>n.add(s))),[...n.values()]}allOverrideIdentifiers(){const n=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>n.add(t)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>n.add(t)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>n.add(t)),this._folderConfigurations.forEach(t=>t.freeze().getAllOverrideIdentifiers().forEach(s=>n.add(s))),[...n.values()]}getAllKeysForOverrideIdentifier(n){const t=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(n).forEach(s=>t.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(s=>t.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(n).forEach(s=>t.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(n).forEach(o=>t.add(o))),[...t.values()]}static parse(n){const t=this.parseConfigurationModel(n.defaults),s=this.parseConfigurationModel(n.user),o=this.parseConfigurationModel(n.workspace),u=n.folders.reduce((f,v)=>(f.set(C.URI.revive(v[0]),this.parseConfigurationModel(v[1])),f),new k.ResourceMap);return new m(t,s,new S,o,u,new S,new k.ResourceMap,!1)}static parseConfigurationModel(n){return new S(n.contents,n.keys,n.overrides).freeze()}}e.Configuration=m;function w(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const n=new Set,t=new Map;for(const o of a)o.keys.forEach(u=>n.add(u)),o.overrides.forEach(([u,f])=>{const v=(0,k.getOrSet)(t,u,new Set);f.forEach(I=>v.add(I))});const s=[];return t.forEach((o,u)=>s.push([u,[...o.values()]])),{keys:[...n.values()],overrides:s}}e.mergeChanges=w;class g{constructor(n,t,s,o){this.change=n,this.previous=t,this.currentConfiguraiton=s,this.currentWorkspace=o,this._previousConfiguration=void 0;const u=new Set;n.keys.forEach(v=>u.add(v)),n.overrides.forEach(([,v])=>v.forEach(I=>u.add(I))),this.affectedKeys=[...u.values()];const f=new S;this.affectedKeys.forEach(v=>f.setValue(v,{})),this.affectedKeysTree=f.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=m.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(n,t){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,n)){if(t){const s=this.previousConfiguration?this.previousConfiguration.getValue(n,t,this.previous?.workspace):void 0,o=this.currentConfiguraiton.getValue(n,t,this.currentWorkspace);return!R.equals(s,o)}return!0}return!1}doesAffectedKeysTreeContains(n,t){let s=(0,P.toValuesTree)({[t]:!0},()=>{}),o;for(;typeof s=="object"&&(o=Object.keys(s)[0]);){if(n=n[o],!n)return!1;s=s[o]}return!0}}e.ConfigurationChangeEvent=g;class c extends g{constructor(n,t,s,o){super({keys:n.allKeys(),overrides:[]},void 0,n,t);this.source=s,this.sourceConfig=o}}e.AllKeysConfigurationChangeEvent=c;function l(a,n){const{added:t,removed:s,updated:o}=r(n,a),u=[],f=a?.getAllOverrideIdentifiers()||[],v=n?.getAllOverrideIdentifiers()||[];if(n){const I=v.filter(O=>!f.includes(O));for(const O of I)u.push([O,n.getKeysForOverrideIdentifier(O)])}if(a){const I=f.filter(O=>!v.includes(O));for(const O of I)u.push([O,a.getKeysForOverrideIdentifier(O)])}if(n&&a){for(const I of f)if(v.includes(I)){const O=r({contents:a.getOverrideValue(void 0,I)||{},keys:a.getKeysForOverrideIdentifier(I)},{contents:n.getOverrideValue(void 0,I)||{},keys:n.getKeysForOverrideIdentifier(I)});u.push([I,[...O.added,...O.removed,...O.updated]])}}return{added:t,removed:s,updated:o,overrides:u}}function r(a,n){const t=a?n?a.keys.filter(u=>n.keys.indexOf(u)===-1):[...a.keys]:[],s=n?a?n.keys.filter(u=>a.keys.indexOf(u)===-1):[...n.keys]:[],o=[];if(a&&n){for(const u of n.keys)if(a.keys.indexOf(u)!==-1){const f=(0,P.getConfigurationValue)(n.contents,u),v=(0,P.getConfigurationValue)(a.contents,u);R.equals(f,v)||o.push(u)}}return{added:t,removed:s,updated:o}}}),define(te[180],ne([0,1,5,3,2,18,21,88,41,37]),function(Q,e,L,i,D,_,k,R,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class P extends D.Disposable{constructor(d,S){super();this.settingsResource=d,this._onDidChangeConfiguration=this._register(new i.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new R.UserSettings(this.settingsResource,void 0,_.extUriBiasedIgnorePathCase,S)),this.configuration=new R.Configuration(new R.DefaultConfigurationModel,new R.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new L.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(C.Registry.as(E.Extensions.Configuration).onDidUpdateConfiguration(({properties:h})=>this.onDidDefaultConfigurationChange(h))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const d=await this.userConfiguration.loadConfiguration();this.configuration=new R.Configuration(new R.DefaultConfigurationModel,d)}getConfigurationData(){return this.configuration.toData()}getValue(d,S){const h=typeof d=="string"?d:void 0,y=(0,k.isConfigurationOverrides)(d)?d:(0,k.isConfigurationOverrides)(S)?S:{};return this.configuration.getValue(h,y,void 0)}updateValue(d,S,h,y){return Promise.reject(new Error("not supported"))}inspect(d){return this.configuration.inspect(d,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const d=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(d)}onDidChangeUserConfiguration(d){const S=this.configuration.toData(),h=this.configuration.compareAndUpdateLocalUserConfiguration(d);this.trigger(h,S,1)}onDidDefaultConfigurationChange(d){const S=this.configuration.toData(),h=this.configuration.compareAndUpdateDefaultConfiguration(new R.DefaultConfigurationModel,d);this.trigger(h,S,6)}trigger(d,S,h){const y=new R.ConfigurationChangeEvent(d,{data:S},this.configuration);y.source=h,y.sourceConfig=this.getTargetConfiguration(h),this._onDidChangeConfiguration.fire(y)}getTargetConfiguration(d){switch(d){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=P}),define(te[181],ne([0,1,6]),function(Q,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,L.createDecorator)("remoteAuthorityResolverService");var i;(function(_){_.Unknown="Unknown",_.NotAvailable="NotAvailable",_.TemporarilyNotAvailable="TemporarilyNotAvailable",_.NoResolverFound="NoResolverFound"})(i=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class D extends Error{constructor(k,R=i.Unknown,E){super(k);this._message=k,this._code=R,this._detail=E,this.isHandled=R===i.NotAvailable&&E===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,D.prototype)}static isTemporarilyNotAvailable(k){return k instanceof D&&k._code===i.TemporarilyNotAvailable}static isNoResolverFound(k){return k instanceof D&&k._code===i.NoResolverFound}static isHandled(k){return k instanceof D&&k.isHandled}}e.RemoteAuthorityResolverError=D}),define(te[182],ne([0,1,5,19,27,10,3,2,30,71,181]),function(Q,e,L,i,D,_,k,R,E,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const b=30*1e3;var d;(function(W){W[W.Management=1]="Management",W[W.ExtensionHost=2]="ExtensionHost",W[W.Tunnel=3]="Tunnel"})(d=e.ConnectionType||(e.ConnectionType={}));function S(W){switch(W){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function h(W){const z=new D.CancellationTokenSource;return setTimeout(()=>z.cancel(),W),z.token}function y(W,z){if(W.isCancellationRequested||z.isCancellationRequested)return D.CancellationToken.Cancelled;const V=new D.CancellationTokenSource;return W.onCancellationRequested(()=>V.cancel()),z.onCancellationRequested(()=>V.cancel()),V.token}class p{constructor(z){this._state="pending",this._disposables=new R.DisposableStore,this.promise=new Promise((V,q)=>{this._resolvePromise=V,this._rejectPromise=q}),z.isCancellationRequested?this._timeout():this._disposables.add(z.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(z){this._state==="pending"?this._disposables.add(z):z.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const z=new Error("Time limit reached");return z.code="ETIMEDOUT",z.syscall="connect",z}resolve(z){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(z))}reject(z){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(z))}}function m(W,z){const V=new p(z);return V.registerDisposable(W.onControlMessage(q=>{const G=JSON.parse(q.toString()),Y=B(G);Y?V.reject(Y):V.resolve(G)})),V.promise}function w(W,z,V,q,G,Y,x){const K=new p(x);return z.connect(V,q,G,Y,(re,se)=>{K.didTimeout?(re&&W.error(re),se?.dispose()):re||!se?K.reject(re):K.resolve(se)}),K.promise}function g(W,z){const V=new p(z);return W.then(q=>{V.didTimeout||V.resolve(q)},q=>{V.didTimeout||V.reject(q)}),V.promise}async function c(W,z,V,q){const G=j(W,z);W.logService.trace(`${G} 1/6. invoking socketFactory.connect().`);let Y;try{Y=await w(W.logService,W.socketFactory,W.host,W.port,`reconnectionToken=${W.reconnectionToken}&reconnection=${W.reconnectionProtocol?"true":"false"}`,`renderer-${S(z)}-${W.reconnectionToken}`,q)}catch(ce){throw W.logService.error(`${G} socketFactory.connect() failed or timed out. Error:`),W.logService.error(ce),ce}W.logService.trace(`${G} 2/6. socketFactory.connect() was successful.`);let x,K;W.reconnectionProtocol?(W.reconnectionProtocol.beginAcceptReconnection(Y,null),x=W.reconnectionProtocol,K=!1):(x=new C.PersistentProtocol(Y,null),K=!0),W.logService.trace(`${G} 3/6. sending AuthRequest control message.`);const re=await g(W.signService.createNewMessage((0,E.generateUuid)()),q),se={type:"auth",auth:W.connectionToken||"00000000000000000000",data:re.data};x.sendControl(i.VSBuffer.fromString(JSON.stringify(se)));try{const ce=await m(x,y(q,h(1e4)));if(ce.type!=="sign"||typeof ce.data!="string"){const ge=new Error("Unexpected handshake message");throw ge.code="VSCODE_CONNECTION_ERROR",ge}if(W.logService.trace(`${G} 4/6. received SignRequest control message.`),!await g(W.signService.validate(re,ce.signedData),q)){const ge=new Error("Refused to connect to unsupported server");throw ge.code="VSCODE_CONNECTION_ERROR",ge}const me=await g(W.signService.sign(ce.data),q),ve={type:"connectionType",commit:W.commit,signedData:me,desiredConnectionType:z};return V&&(ve.args=V),W.logService.trace(`${G} 5/6. sending ConnectionTypeRequest control message.`),x.sendControl(i.VSBuffer.fromString(JSON.stringify(ve))),{protocol:x,ownsProtocol:K}}catch(ce){throw ce&&ce.code==="ETIMEDOUT"&&(W.logService.error(`${G} the handshake timed out. Error:`),W.logService.error(ce)),ce&&ce.code==="VSCODE_CONNECTION_ERROR"&&(W.logService.error(`${G} received error control message when negotiating connection. Error:`),W.logService.error(ce)),K&&U(x),ce}}async function l(W,z,V,q){const G=Date.now(),Y=j(W,z),{protocol:x,ownsProtocol:K}=await c(W,z,V,q),re=new p(q);return re.registerDisposable(x.onControlMessage(se=>{const ce=JSON.parse(se.toString()),he=B(ce);he?(W.logService.error(`${Y} received error control message when negotiating connection. Error:`),W.logService.error(he),K&&U(x),re.reject(he)):(W.reconnectionProtocol&&W.reconnectionProtocol.endAcceptReconnection(),W.logService.trace(`${Y} 6/6. handshake finished, connection is up and running after ${Z(G)}!`),re.resolve({protocol:x,firstMessage:ce}))})),re.promise}async function r(W,z){const{protocol:V}=await l(W,1,void 0,z);return{protocol:V}}async function a(W,z,V){const{protocol:q,firstMessage:G}=await l(W,2,z,V),Y=G&&G.debugPort;return{protocol:q,debugPort:Y}}async function n(W,z,V){const q=Date.now(),G=j(W,3),{protocol:Y}=await c(W,3,z,V);return W.logService.trace(`${G} 6/6. handshake finished, connection is up and running after ${Z(q)}!`),Y}async function t(W,z,V){const{host:q,port:G,connectionToken:Y}=await W.addressProvider.getAddress();return{commit:W.commit,host:q,port:G,connectionToken:Y,reconnectionToken:z,reconnectionProtocol:V,socketFactory:W.socketFactory,signService:W.signService,logService:W.logService}}async function s(W,z,V){try{const q=(0,E.generateUuid)(),G=await t(W,q,null),{protocol:Y}=await r(G,D.CancellationToken.None);return new F(W,z,V,q,Y)}catch(q){throw W.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),W.logService.error(q),T.triggerPermanentFailure(0,0,P.RemoteAuthorityResolverError.isHandled(q)),q}}e.connectRemoteAgentManagement=s;async function o(W,z){try{const V=(0,E.generateUuid)(),q=await t(W,V,null),{protocol:G,debugPort:Y}=await a(q,z,D.CancellationToken.None);return new M(W,z,V,G,Y)}catch(V){throw W.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),W.logService.error(V),T.triggerPermanentFailure(0,0,P.RemoteAuthorityResolverError.isHandled(V)),V}}e.connectRemoteAgentExtensionHost=o;async function u(W,z,V){const q=await t(W,(0,E.generateUuid)(),null);return await n(q,{host:z,port:V},D.CancellationToken.None)}e.connectRemoteAgentTunnel=u;function f(W){return(0,L.createCancelablePromise)(z=>new Promise((V,q)=>{const G=setTimeout(V,W*1e3);z.onCancellationRequested(()=>{clearTimeout(G),V()})}))}var v;(function(W){W[W.ConnectionLost=0]="ConnectionLost",W[W.ReconnectionWait=1]="ReconnectionWait",W[W.ReconnectionRunning=2]="ReconnectionRunning",W[W.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",W[W.ConnectionGain=4]="ConnectionGain"})(v=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class I{constructor(z,V){this.reconnectionToken=z,this.millisSinceLastIncomingData=V,this.type=0}}e.ConnectionLostEvent=I;class O{constructor(z,V,q,G){this.reconnectionToken=z,this.millisSinceLastIncomingData=V,this.durationSeconds=q,this.cancellableTimer=G,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=O;class A{constructor(z,V,q){this.reconnectionToken=z,this.millisSinceLastIncomingData=V,this.attempt=q,this.type=2}}e.ReconnectionRunningEvent=A;class N{constructor(z,V,q){this.reconnectionToken=z,this.millisSinceLastIncomingData=V,this.attempt=q,this.type=4}}e.ConnectionGainEvent=N;class ${constructor(z,V,q,G){this.reconnectionToken=z,this.millisSinceLastIncomingData=V,this.attempt=q,this.handled=G,this.type=3}}e.ReconnectionPermanentFailureEvent=$;class T extends R.Disposable{constructor(z,V,q,G){super();this._connectionType=z,this._onDidStateChange=this._register(new k.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=V,this.reconnectionToken=q,this.protocol=G,this._isReconnecting=!1,this._onDidStateChange.fire(new N(this.reconnectionToken,0,0)),this._register(G.onSocketClose(Y=>{const x=H(this._connectionType,this.reconnectionToken,!0);Y?Y.type===0?(this._options.logService.info(`${x} received socket close event (hadError: ${Y.hadError}).`),Y.error&&this._options.logService.error(Y.error)):(this._options.logService.info(`${x} received socket close event (wasClean: ${Y.wasClean}, code: ${Y.code}, reason: ${Y.reason}).`),Y.event&&this._options.logService.error(Y.event)):this._options.logService.info(`${x} received socket close event.`),this._beginReconnecting()})),this._register(G.onSocketTimeout(()=>{const Y=H(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${Y} received socket timeout event.`),this._beginReconnecting()})),T._instances.push(this),T._permanentFailure&&this._gotoPermanentFailure(T._permanentFailureMillisSinceLastIncomingData,T._permanentFailureAttempt,T._permanentFailureHandled)}static triggerPermanentFailure(z,V,q){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=z,this._permanentFailureAttempt=V,this._permanentFailureHandled=q,this._instances.forEach(G=>G._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(z=>z._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(z=>z._pauseSocketWriting())}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(T._permanentFailure)return;const z=H(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${z} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new I(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const V=[0,5,5,10,10,10,10,10,30];let q=-1;do{q++;const G=q<V.length?V[q]:V[V.length-1];try{if(G>0){const x=f(G);this._onDidStateChange.fire(new O(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),G,x)),this._options.logService.info(`${z} waiting for ${G} seconds before reconnecting...`);try{await x}catch{}}if(T._permanentFailure){this._options.logService.error(`${z} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new A(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),q+1)),this._options.logService.info(`${z} resolving connection...`);const Y=await t(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${z} connecting to ${Y.host}:${Y.port}...`),await this._reconnect(Y,h(b)),this._options.logService.info(`${z} reconnected!`),this._onDidStateChange.fire(new N(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),q+1));break}catch(Y){if(Y.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${z} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(Y),T.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),q+1,!1);break}if(q>360){this._options.logService.error(`${z} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(Y),T.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),q+1,!1);break}if(P.RemoteAuthorityResolverError.isTemporarilyNotAvailable(Y)){this._options.logService.info(`${z} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(Y);continue}if((Y.code==="ETIMEDOUT"||Y.code==="ENETUNREACH"||Y.code==="ECONNREFUSED"||Y.code==="ECONNRESET")&&Y.syscall==="connect"){this._options.logService.info(`${z} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(Y);continue}if((0,_.isPromiseCanceledError)(Y)){this._options.logService.info(`${z} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(Y);continue}if(Y instanceof P.RemoteAuthorityResolverError){this._options.logService.error(`${z} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(Y),T.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),q+1,P.RemoteAuthorityResolverError.isHandled(Y));break}this._options.logService.error(`${z} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(Y),T.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),q+1,!1);break}}while(!T._permanentFailure)}_gotoPermanentFailure(z,V,q){this._onDidStateChange.fire(new $(this.reconnectionToken,z,V,q)),U(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=T,T._permanentFailure=!1,T._permanentFailureMillisSinceLastIncomingData=0,T._permanentFailureAttempt=0,T._permanentFailureHandled=!1,T._instances=[];class F extends T{constructor(z,V,q,G,Y){super(1,z,G,Y);this.client=this._register(new C.Client(Y,{remoteAuthority:V,clientId:q},z.ipcLogger))}async _reconnect(z,V){await r(z,V)}}e.ManagementPersistentConnection=F;class M extends T{constructor(z,V,q,G,Y){super(2,z,q,G);this._startArguments=V,this.debugPort=Y}async _reconnect(z,V){await a(z,this._startArguments,V)}}e.ExtensionHostPersistentConnection=M;function U(W){try{W.acceptDisconnect();const z=W.getSocket();W.dispose(),z.dispose()}catch(z){(0,_.onUnexpectedError)(z)}}function B(W){if(W&&W.type==="error"){const z=new Error(`Connection error: ${W.reason}`);return z.code="VSCODE_CONNECTION_ERROR",z}return null}function ee(W,z){for(;W.length<z;)W+=" ";return W}function H(W,z,V){return`[remote-connection][${ee(S(W),13)}][${z.substr(0,5)}\u2026][${V?"reconnect":"initial"}]`}function j(W,z){return`${H(z,W.reconnectionToken,!!W.reconnectionProtocol)}[${W.host}:${W.port}]`}function Z(W){return`${Date.now()-W} ms`}}),define(te[183],ne([0,1,17]),function(Q,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function i(C){return C.scheme===L.Schemas.vscodeRemote?C.authority:void 0}e.getRemoteAuthority=i;function D(C){if(!C)return;const P=C.indexOf("+");return P<0?C:C.substr(0,P)}e.getRemoteName=D;function _(C){return C.scheme!==L.Schemas.file&&C.scheme!==L.Schemas.vscodeRemote}e.isVirtualResource=_;function k(C){if(C.folders.length)return C.folders.every(P=>_(P.uri))?C.folders[0].uri:void 0;if(C.configuration&&_(C.configuration))return C.configuration}e.getVirtualWorkspaceLocation=k;function R(C){return k(C)?.scheme}e.getVirtualWorkspaceScheme=R;function E(C){return k(C)!==void 0}e.isVirtualWorkspace=E}),define(te[89],ne([0,1,25,6,183]),function(Q,e,L,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function _(d){if(typeof d=="object"&&d!==null&&d.supported!==!0)return d.description}e.getWorkspaceSupportTypeMessage=_;function k(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}e.isIExtensionIdentifier=k,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(d){d[d.System=0]="System",d[d.User=1]="User"})(R=e.ExtensionType||(e.ExtensionType={}));class E{constructor(S){this.value=S,this._lower=S.toLowerCase()}static equals(S,h){if(typeof S=="undefined"||S===null)return typeof h=="undefined"||h===null;if(typeof h=="undefined"||h===null)return!1;if(typeof S=="string"||typeof h=="string"){let y=typeof S=="string"?S:S.value,p=typeof h=="string"?h:h.value;return L.equalsIgnoreCase(y,p)}return S._lower===h._lower}static toKey(S){return typeof S=="string"?S.toLowerCase():S._lower}}e.ExtensionIdentifier=E;function C(d){return d.contributes&&d.contributes.localizations?d.contributes.localizations.length>0:!1}e.isLanguagePackExtension=C;function P(d){return d.contributes&&d.contributes.authentication?d.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=P;function b(d,S){if(S){const h=`onResolveRemoteAuthority:${(0,D.getRemoteName)(S)}`;return d.activationEvents?.indexOf(h)!==-1}return!1}e.isResolverExtension=b,e.IBuiltinExtensionsScannerService=(0,i.createDecorator)("IBuiltinExtensionsScannerService")}),define(te[34],ne([0,1,25,89]),function(Q,e,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function D(h,y){return h.uuid&&y.uuid?h.uuid===y.uuid:h.id===y.id?!0:(0,L.compareIgnoreCase)(h.id,y.id)===0}e.areSameExtensions=D;class _{constructor(y,p){this.version=p,this.id=y.id,this.uuid=y.uuid}key(){return`${this.id}-${this.version}`}equals(y){return y instanceof _?D(this,y)&&this.version===y.version:!1}}e.ExtensionIdentifierWithVersion=_;function k(h,y){return`${h}.${y}`}e.getExtensionId=k;function R(h){return h.toLocaleLowerCase()}e.adoptToGalleryExtensionId=R;function E(h,y){return R(k(h,y))}e.getGalleryExtensionId=E;function C(h,y){const p=[],m=w=>{for(const g of p)if(g.some(c=>D(y(c),y(w))))return g;return null};for(const w of h){const g=m(w);g?g.push(w):p.push([w])}return p}e.groupByExtension=C;function P(h){return{id:h.identifier.id,name:h.manifest.name,galleryId:null,publisherId:h.publisherId,publisherName:h.manifest.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:h.manifest.extensionDependencies&&h.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=P;function b(h){return{id:h.identifier.id,name:h.name,galleryId:h.identifier.uuid,publisherId:h.publisherId,publisherName:h.publisher,publisherDisplayName:h.publisherDisplayName,isPreReleaseVersion:h.properties.isPreReleaseVersion,dependencies:!!(h.properties.dependencies&&h.properties.dependencies.length>0),...h.telemetryData}}e.getGalleryExtensionTelemetryData=b,e.BetterMergeId=new i.ExtensionIdentifier("pprice.better-merge");function d(h){const y=new Set;if(h.malicious)for(const p of h.malicious)y.add(p.id);return y}e.getMaliciousExtensionsSet=d;function S(h,y){const p=[],m=y.manifest.extensionDependencies?.slice(0)??[];for(;m.length;){const w=m.shift();if(w&&p.every(g=>!D(g.identifier,{id:w}))){const g=h.filter(c=>D(c.identifier,{id:w}));g.length===1&&(p.push(g[0]),m.push(...g[0].manifest.extensionDependencies?.slice(0)??[]))}}return p}e.getExtensionDependencies=S}),define(te[184],ne([0,1,5,10,2,4,18,61,7,30,20,11,29,34,14,8]),function(Q,e,L,i,D,_,k,R,E,C,P,b,d,S,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;const p=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let m=class extends D.Disposable{constructor(g,c,l,r){super();this.fileService=c,this.extensionGalleryService=l,this.logService=r,this.extensionsDownloadDir=E.URI.file(g.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(g,c){await this.cleanUpPromise;const l=this.getName(g),r=(0,k.joinPath)(this.extensionsDownloadDir,l);if(!await this.fileService.exists(r)){const a=(0,k.joinPath)(this.extensionsDownloadDir,`.${(0,C.generateUuid)()}`);await this.fileService.exists(a)||await this.extensionGalleryService.download(g,a,c);try{await this.rename(a,r,Date.now()+2*60*1e3)}catch(n){try{await this.fileService.del(a)}catch{}if(n.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",g.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,i.getErrorMessage)(n)}. Deleted the vsix from downloaded location`,a.path),n}}return r}async delete(g){await this.cleanUpPromise,await this.fileService.del(g)}async rename(g,c,l){try{await P.Promises.rename(g.fsPath,c.fsPath)}catch(r){if(_.isWindows&&r&&r.code==="EPERM"&&Date.now()<l)return this.logService.info(`Failed renaming ${g} to ${c} with 'EPERM' error. Trying again...`),this.rename(g,c,l);throw r}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const g=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(g.children){const c=[],l=[];for(const n of g.children){const t=this.parse(n.name);t&&l.push([t,n])}const r=(0,S.groupByExtension)(l,([n])=>n),a=[];for(const n of r)n.sort((t,s)=>R.rcompare(t[0].version,s[0].version)),c.push(...n.slice(1).map(t=>t[1].resource)),a.push(n[0][1]);a.sort((n,t)=>n.mtime-t.mtime),c.push(...a.slice(0,Math.max(0,a.length-this.cache)).map(n=>n.resource)),await L.Promises.settled(c.map(n=>(this.logService.trace("Deleting vsix from cache",n.path),this.fileService.del(n))))}}catch(g){this.logService.error(g)}}getName(g){return this.cache?`${new S.ExtensionIdentifierWithVersion(g.identifier,g.version).key().toLowerCase()}${g.properties.targetPlatform!=="undefined"?`-${g.properties.targetPlatform}`:""}`:(0,C.generateUuid)()}parse(g){const c=p.exec(g);return c&&c[1]&&c[2]?new S.ExtensionIdentifierWithVersion({id:c[1]},c[2]):null}};m=de([J(0,b.INativeEnvironmentService),J(1,h.IFileService),J(2,d.IExtensionGalleryService),J(3,y.ILogService)],m),e.ExtensionsDownloader=m}),define(te[185],ne([0,1,2,9,20,89]),function(Q,e,L,i,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class k extends L.Disposable{constructor(E,C){super();this.environmentService=E,this.extensionsManifestCache=(0,i.join)(this.environmentService.userDataPath,_.MANIFEST_CACHE_FOLDER,_.USER_MANIFEST_CACHE_FILE),this._register(C.onDidInstallExtensions(P=>this.onDidInstallExtensions(P))),this._register(C.onDidUninstallExtension(P=>this.onDidUnInstallExtension(P)))}onDidInstallExtensions(E){E.some(C=>!!C.local)&&this.invalidate()}onDidUnInstallExtension(E){E.error||this.invalidate()}invalidate(){D.Promises.rm(this.extensionsManifestCache,D.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=k}),define(te[186],ne([0,1,81,16,5,2,17,9,20,11,29,34,59,8]),function(Q,e,L,i,D,_,k,R,E,C,P,b,d,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsService=void 0;let h=class extends _.Disposable{constructor(m,w,g){super();this.extensionManagementService=m,this.logService=g,this.cache=this._register(new y(w,g)),this.extensionManagementService.registerParticipant({postInstall:async c=>this.postInstallExtension(c),postUninstall:async c=>this.postUninstallExtension(c)})}async getLanguageIds(){const m=await this.cache.getLanguagePacks(),w=["en",...Object.keys(m)];return(0,i.distinct)(w)}async postInstallExtension(m){m&&m.manifest&&m.manifest.contributes&&m.manifest.contributes.localizations&&m.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",m.identifier.id),await this.update())}async postUninstallExtension(m){const w=await this.cache.getLanguagePacks();Object.keys(w).some(g=>w[g]&&w[g].extensions.some(c=>(0,b.areSameExtensions)(c.extensionIdentifier,m.identifier)))&&(this.logService.info("Removing language packs from the extension",m.identifier.id),await this.update())}async update(){const[m,w]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),g=await this.cache.update(w);return!(0,i.equals)(Object.keys(m),Object.keys(g))}};h=de([J(0,P.IExtensionManagementService),J(1,C.INativeEnvironmentService),J(2,S.ILogService)],h),e.LocalizationsService=h;let y=class extends _.Disposable{constructor(m,w){super();this.logService=w,this.languagePacks={},this.languagePacksFilePath=(0,R.join)(m.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new D.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(m){return this.withLanguagePacks(w=>{Object.keys(w).forEach(g=>delete w[g]),this.createLanguagePacksFromExtensions(w,...m)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(m,...w){for(const g of w)g&&g.manifest&&g.manifest.contributes&&g.manifest.contributes.localizations&&g.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(m,g);Object.keys(m).forEach(g=>this.updateHash(m[g]))}createLanguagePacksFromExtension(m,w){const g=w.identifier,c=w.manifest.contributes&&w.manifest.contributes.localizations?w.manifest.contributes.localizations:[];for(const l of c)if(w.location.scheme===k.Schemas.file&&(0,d.isValidLocalization)(l)){let r=m[l.languageId];r||(r={hash:"",extensions:[],translations:{}},m[l.languageId]=r);let a=r.extensions.filter(n=>(0,b.areSameExtensions)(n.extensionIdentifier,g))[0];a?a.version=w.manifest.version:r.extensions.push({extensionIdentifier:g,version:w.manifest.version});for(const n of l.translations)r.translations[n.id]=(0,R.join)(w.location.fsPath,n.path)}}updateHash(m){if(m){const w=(0,L.createHash)("md5");for(const g of m.extensions)w.update(g.extensionIdentifier.uuid||g.extensionIdentifier.id).update(g.version);m.hash=w.digest("hex")}}withLanguagePacks(m=()=>null){return this.languagePacksFileLimiter.queue(()=>{let w=null;return E.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,g=>g.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(g)).then(g=>{try{return JSON.parse(g)}catch{return{}}}).then(g=>(w=m(g),g)).then(g=>{for(const l of Object.keys(g))g[l]||delete g[l];this.languagePacks=g,this.initializedCache=!0;const c=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",c),E.Promises.writeFile(this.languagePacksFilePath,c)}).then(()=>w,g=>this.logService.error(g))})}};y=de([J(0,C.INativeEnvironmentService),J(1,S.ILogService)],y)}),define(te[187],ne([0,1,6]),function(Q,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,L.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(te[62],ne([0,1,3,4,6,8]),function(Q,e,L,i,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,D.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,D.createDecorator)("sharedTunnelsService");var k;(function(h){h.Http="http",h.Https="https"})(k=e.TunnelProtocol||(e.TunnelProtocol={}));var R;(function(h){h.ConstantPrivate="constantPrivate",h.Private="private",h.Public="public"})(R=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var E;(function(h){h[h.Notify=1]="Notify",h[h.OpenBrowser=2]="OpenBrowser",h[h.OpenPreview=3]="OpenPreview",h[h.Silent=4]="Silent",h[h.Ignore=5]="Ignore",h[h.OpenBrowserOnce=6]="OpenBrowserOnce"})(E=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function C(h){if(h.scheme!=="http"&&h.scheme!=="https")return;const y=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(h.authority);if(!!y)return{address:y[1],port:+y[2]}}e.extractLocalHostUriMetaDataForPortMapping=C,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function P(h){return e.LOCALHOST_ADDRESSES.indexOf(h)>=0}e.isLocalhost=P,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function b(h){return e.ALL_INTERFACES_ADDRESSES.indexOf(h)>=0}e.isAllInterfaces=b;function d(h,y){return y?y!==1&&h<1024:!i.isWindows&&h<1024}e.isPortPrivileged=d;let S=class{constructor(y){this.logService=y,this._onTunnelOpened=new L.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new L.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new L.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(y,p){return this._tunnelProvider=y,y?(this._canElevate=p.elevation,this._privacyOptions=p.privacyOptions,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const y=[],p=Array.from(this._tunnels.values());for(let m of p){const w=Array.from(m.values());for(let g of w){const c=await g.value;c&&y.push(c)}}return y}async dispose(){for(const y of this._tunnels.values()){for(const{value:p}of y.values())await p.then(m=>m?.dispose());y.clear()}this._tunnels.clear()}openTunnel(y,p,m,w,g=!1,c=R.Private,l){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${p}:${m} on local port ${w}.`),!y)return;p||(p="localhost");const r=this.retainOrCreateTunnel(y,p,m,w,g,c,l);return r?r.then(a=>{if(!a){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(p,m);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const n=this.makeTunnel(a);return(a.tunnelRemoteHost!==p||a.tunnelRemotePort!==m)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(n),n}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),r)}makeTunnel(y){return{tunnelRemotePort:y.tunnelRemotePort,tunnelRemoteHost:y.tunnelRemoteHost,tunnelLocalPort:y.tunnelLocalPort,localAddress:y.localAddress,privacy:y.privacy,protocol:y.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${y.tunnelRemoteHost}:${y.tunnelRemotePort} `);const p=this._tunnels.get(y.tunnelRemoteHost);if(p){const m=p.get(y.tunnelRemotePort);m&&(m.refcount--,await this.tryDisposeTunnel(y.tunnelRemoteHost,y.tunnelRemotePort,m))}}}}async tryDisposeTunnel(y,p,m){if(m.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${y}:${p}.`);const w=m.value.then(async g=>{g&&(await g.dispose(!0),this._onTunnelClosed.fire({host:g.tunnelRemoteHost,port:g.tunnelRemotePort}))});return this._tunnels.has(y)&&this._tunnels.get(y).delete(p),w}}async closeTunnel(y,p){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${y}:${p} `);const m=this._tunnels.get(y);if(m&&m.has(p)){const w=m.get(p);w.refcount=0,await this.tryDisposeTunnel(y,p,w)}}addTunnelToMap(y,p,m){this._tunnels.has(y)||this._tunnels.set(y,new Map),this._tunnels.get(y).set(p,{refcount:1,value:m})}async removeEmptyTunnelFromMap(y,p){const m=this._tunnels.get(y);m&&(await m.get(p)||m.delete(p),m.size===0&&this._tunnels.delete(y))}getTunnelFromMap(y,p){let m=[y];P(y)?(m.push(...e.LOCALHOST_ADDRESSES),m.push(...e.ALL_INTERFACES_ADDRESSES)):b(y)&&m.push(...e.ALL_INTERFACES_ADDRESSES);const w=m.map(g=>this._tunnels.get(g));for(const g of w){const c=g?.get(p);if(c)return c}}canTunnel(y){return!!C(y)}createWithProvider(y,p,m,w,g,c,l){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${p}:${m} on local port ${w}.`);const a={elevationRequired:g?d(w===void 0?m:w):!1},n={remoteAddress:{host:p,port:m},localAddressPort:w,privacy:c,public:c!==R.Private,protocol:l},t=y.forwardPort(n,a);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),t&&this.addTunnelToMap(p,m,t),t}};S=de([J(0,_.ILogService)],S),e.AbstractTunnelService=S}),define(te[188],ne([0,1,8,62,2,10,5]),function(Q,e,L,i,D,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class R extends D.Disposable{constructor(){super();this._address=null,this._addressPromise=null}async getAddress(){return this._address?this._address:(this._addressPromise||(this._addressPromise=new k.DeferredPromise),this._addressPromise.p)}setAddress(P){this._address=P,this._addressPromise&&(this._addressPromise.complete(P),this._addressPromise=null)}setTunnel(P){this._register(P)}}let E=class Et extends D.Disposable{constructor(P,b){super();this._tunnelService=P,this._logService=b,this._tunnels=new Map,this._disposedTunnels=new Set}dispose(){super.dispose(),this._tunnels.forEach(P=>P.dispose())}async createTunnel(){return{id:String(++Et._lastId)}}async startTunnel(P,b,d,S,h,y){const p=new R,m=await Promise.resolve(this._tunnelService.openTunnel(P,p,d,S,h,y));if(!m)throw this._logService.info(`[SharedProcessTunnelService] Could not create a tunnel to ${d}:${S} (remote).`),p.dispose(),new Error("Could not create tunnel");if(this._disposedTunnels.has(b))throw this._disposedTunnels.delete(b),p.dispose(),await m.dispose(),(0,_.canceled)();return p.setTunnel(m),this._tunnels.set(b,p),this._logService.info(`[SharedProcessTunnelService] Created tunnel ${b}: ${m.localAddress} (local) to ${d}:${S} (remote).`),{tunnelLocalPort:m.tunnelLocalPort,localAddress:m.localAddress}}async setAddress(P,b){const d=this._tunnels.get(P);!d||d.setAddress(b)}async destroyTunnel(P){const b=this._tunnels.get(P);if(b){this._logService.info(`[SharedProcessTunnelService] Disposing tunnel ${P}.`),this._tunnels.delete(P),await b.dispose();return}this._disposedTunnels.add(P)}};E._lastId=0,E=de([J(0,i.ISharedTunnelsService),J(1,L.ILogService)],E),e.SharedProcessTunnelService=E}),define(te[189],ne([0,1,119,21,8]),function(Q,e,L,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let _=class{constructor(R,E){this.configurationService=R,this.logService=E}request(R,E){return this.logService.trace("RequestService#request",R.url),R.proxyAuthorization||(R.proxyAuthorization=this.configurationService.getValue("http.proxyAuthorization")),(0,L.request)(R,E)}async resolveProxy(R){}};_=de([J(0,i.IConfigurationService),J(1,D.ILogService)],_),e.RequestService=_}),define(te[42],ne([0,1,19,140,41,6,37]),function(Q,e,L,i,D,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,_.createDecorator)("requestService");function R(h){return h.res.statusCode&&h.res.statusCode>=200&&h.res.statusCode<300||h.res.statusCode===1223}e.isSuccess=R;function E(h){return h.res.statusCode===204}async function C(h){if(!R(h))throw new Error("Server returned "+h.res.statusCode);return E(h)?null:(await(0,L.streamToBuffer)(h.stream)).toString()}e.asText=C;async function P(h){if(!R(h))throw new Error("Server returned "+h.res.statusCode);if(E(h))return null;const p=(await(0,L.streamToBuffer)(h.stream)).toString();try{return JSON.parse(p)}catch(m){throw m.message+=`:
`+p,m}}e.asJson=P;function b(h){S(h)}e.updateProxyConfigurationsScope=b;let d;function S(h){const y=k.Registry.as(D.Extensions.Configuration),p=d;d={id:"http",order:15,title:(0,i.localize)(0,null),type:"object",scope:h,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,i.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,i.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,i.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,i.localize)(4,null),(0,i.localize)(5,null),(0,i.localize)(6,null),(0,i.localize)(7,null)],default:"override",description:(0,i.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,i.localize)(9,null),restricted:!0}}},y.updateConfigurations({add:[d],remove:p?[p]:[]})}S(2)}),define(te[190],ne([0,1,27,17,14,42]),function(Q,e,L,i,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let k=class{constructor(E,C){this.requestService=E,this.fileService=C}async download(E,C,P=L.CancellationToken.None){if(E.scheme===i.Schemas.file||E.scheme===i.Schemas.vscodeRemote){await this.fileService.copy(E,C);return}const b={type:"GET",url:E.toString()},d=await this.requestService.request(b,P);if(d.res.statusCode===200)await this.fileService.writeFile(C,d.stream);else{const S=await(0,_.asText)(d);throw new Error(`Expected 200, got back ${d.res.statusCode} instead.

${S}`)}}};k=de([J(0,_.IRequestService),J(1,D.IFileService)],k),e.DownloadService=k}),define(te[191],ne([0,1,16,27,66,2,18,154,14,8,26,42]),function(Q,e,L,i,D,_,k,R,E,C,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let d=class extends _.Disposable{constructor(h,y,p,m){super();this.fileService=h,this.productService=y,this.requestService=p,this.logService=m,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&(0,D.forEach)(this.productService.configBasedExtensionTips,({value:w})=>this.allConfigBasedTips.set(w.configPath,w))}getConfigBasedTips(h){return this.getValidConfigBasedTips(h)}getAllWorkspacesTips(){return this.fetchWorkspacesTips()}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(h){const y=[];for(const[p,m]of this.allConfigBasedTips)if(!(m.configScheme&&m.configScheme!==h.scheme))try{const w=await this.fileService.readFile((0,k.joinPath)(h,p)),g=new Map;(0,D.forEach)(m.recommendations,({key:l,value:r})=>{if((0,L.isNonEmptyArray)(r.remotes))for(const a of r.remotes)g.set(a,{extensionId:l,extensionName:r.name,configName:m.configName,important:!!r.important,isExtensionPack:!!r.isExtensionPack});else y.push({extensionId:l,extensionName:r.name,configName:m.configName,important:!!r.important,isExtensionPack:!!r.isExtensionPack})});const c=(0,R.getDomainsOfRemotes)(w.value.toString(),[...g.keys()]);for(const l of c){const r=g.get(l);r&&y.push(r)}}catch{}return y}async fetchWorkspacesTips(){if(!this.productService.extensionsGallery?.recommendationsUrl)return[];try{const h=await this.requestService.request({type:"GET",url:this.productService.extensionsGallery?.recommendationsUrl},i.CancellationToken.None);if(h.res.statusCode!==200)return[];const y=await(0,b.asJson)(h);return y?y.workspaceRecommendations||[]:[]}catch(h){return this.logService.error(h),[]}}};d=de([J(0,E.IFileService),J(1,P.IProductService),J(2,b.IRequestService),J(3,C.ILogService)],d),e.ExtensionTipsService=d}),define(te[45],ne([0,1,19,30]),function(Q,e,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function D(_,k,R){let E=R&&R.get("storage.serviceMachineId",0)||null;if(E)return E;try{const P=(await k.readFile(_.serviceMachineIdResource)).value.toString();E=(0,i.isUUID)(P)?P:null}catch{E=null}if(!E){E=(0,i.generateUuid)();try{await k.writeFile(_.serviceMachineIdResource,L.VSBuffer.fromString(E))}catch{}}return R&&R.store("storage.serviceMachineId",E,0,1),E}e.getServiceMachineId=D}),define(te[90],ne([0,1,104,6]),function(Q,e,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessWorkerChannelName=e.ISharedProcessWorkerService=e.hash=void 0;function D(_){return(0,L.hash)({moduleId:_.process.moduleId,windowId:_.reply.windowId})}e.hash=D,e.ISharedProcessWorkerService=(0,i.createDecorator)("sharedProcessWorkerService"),e.ipcSharedProcessWorkerChannelName="sharedProcessWorker"}),define(te[192],ne([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerMessages=void 0;var L;(function(i){i.Spawn="vscode:shared-process->shared-process-worker=spawn",i.Terminate="vscode:shared-process->shared-process-worker=terminate",i.SelfTerminated="vscode:shared-process-worker->shared-process=selfTerminated",i.Ready="vscode:shared-process-worker->shared-process=ready",i.Ack="vscode:shared-process-worker->shared-process=ack",i.Trace="vscode:shared-process-worker->shared-process=trace",i.Info="vscode:shared-process-worker->shared-process=info",i.Warn="vscode:shared-process-worker->shared-process=warn",i.Error="vscode:shared-process-worker->shared-process=error"})(L=e.SharedProcessWorkerMessages||(e.SharedProcessWorkerMessages={}))}),define(te[193],ne([0,1,72,152,5,27,3,2,17,4,30,11,8,26,90,192]),function(Q,e,L,i,D,_,k,R,E,C,P,b,d,S,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerService=void 0;let p=class{constructor(g,c,l){this.logService=g,this.productService=c,this.environmentService=l,this.workers=new Map,this.processeDisposables=new Map,this.processResolvers=new Map}async createWorker(g){const c=`window: ${g.reply.windowId}, moduleId: ${g.process.moduleId}`;this.logService.trace(`SharedProcess: createWorker (${c})`);const l=(0,h.hash)(g);this.processeDisposables.has(l)&&(this.logService.warn(`SharedProcess: createWorker found an existing worker that will be terminated (${c})`),this.doDisposeWorker(g));const r=new _.CancellationTokenSource;let a,n,t;this.processeDisposables.set(l,f=>{r.dispose(!0),a?.terminate(g,_.CancellationToken.None),n?.close(),t?.close(),this.processeDisposables.delete(l);const v=this.processResolvers.get(l);v&&(this.processResolvers.delete(l),v({reason:f}))}),a=await this.getOrCreateWebWorker(g);const s=new Promise(f=>{this.processResolvers.set(l,f)});if(r.token.isCancellationRequested)return s;const{port1:o,port2:u}=new MessageChannel;return n=o,t=u,await a.spawn(g,t,r.token),r.token.isCancellationRequested||(this.logService.trace(`SharedProcess: createWorker sending message port back to window (${c})`),L.ipcRenderer.postMessage("vscode:relaySharedProcessWorkerMessageChannel",g,[n])),s}getOrCreateWebWorker(g){let c=this.workers.get(g.process.moduleId);if(!c){this.logService.trace(`SharedProcess: creating new web worker (${g.process.moduleId})`);const l=new m(g.process.type,this.logService,this.productService,this.environmentService);c=l.init(),l.onDidProcessSelfTerminate(({configuration:r,reason:a})=>{this.doDisposeWorker(r,a)}),this.workers.set(g.process.moduleId,c)}return c}async disposeWorker(g){return this.doDisposeWorker(g)}doDisposeWorker(g,c){const l=this.processeDisposables.get((0,h.hash)(g));l&&(this.logService.trace(`SharedProcess: disposeWorker (window: ${g.reply.windowId}, moduleId: ${g.process.moduleId})`),l(c))}};p=de([J(0,d.ILogService),J(1,S.IProductService),J(2,b.INativeEnvironmentService)],p),e.SharedProcessWorkerService=p;class m extends R.Disposable{constructor(g,c,l,r){super();this.type=g,this.logService=c,this.productService=l,this.environmentService=r,this._onDidProcessSelfTerminate=this._register(new k.Emitter),this.onDidProcessSelfTerminate=this._onDidProcessSelfTerminate.event,this.workerReady=this.doInit(),this.mapMessageNonceToPendingMessageResolve=new Map}async init(){return await this.workerReady,this}doInit(){const g=new D.DeferredPromise,c=new Worker("../../../base/worker/workerMain.js",{name:`Shared Process Worker (${this.type})`});return c.onerror=l=>{this.logService.error(`SharedProcess: worker error (${this.type})`,l.message)},c.onmessageerror=l=>{this.logService.error(`SharedProcess: worker message error (${this.type})`,l)},c.onmessage=l=>{const{id:r,message:a,configuration:n,nonce:t}=l.data;switch(r){case y.SharedProcessWorkerMessages.Ready:g.complete(c);break;case y.SharedProcessWorkerMessages.Ack:if(t){const s=this.mapMessageNonceToPendingMessageResolve.get(t);s&&(this.mapMessageNonceToPendingMessageResolve.delete(t),s())}break;case y.SharedProcessWorkerMessages.SelfTerminated:n&&a&&this._onDidProcessSelfTerminate.fire({configuration:n,reason:JSON.parse(a)});break;case y.SharedProcessWorkerMessages.Trace:this.logService.trace(`SharedProcess (worker, ${this.type}):`,a);break;case y.SharedProcessWorkerMessages.Info:a&&this.logService.info(a);break;case y.SharedProcessWorkerMessages.Warn:this.logService.warn(`SharedProcess (worker, ${this.type}):`,a);break;case y.SharedProcessWorkerMessages.Error:this.logService.error(`SharedProcess (worker, ${this.type}):`,a);break;default:this.logService.warn(`SharedProcess: unexpected worker message (${this.type})`,l)}},c.postMessage("vs/platform/sharedProcess/electron-browser/sharedProcessWorkerMain"),g.p}async send(g,c,l){const r=await this.workerReady;if(!c.isCancellationRequested)return new Promise(a=>{const n=(0,P.generateUuid)();this.mapMessageNonceToPendingMessageResolve.set(n,a);const t={...g,nonce:n};l?r.postMessage(t,[l]):r.postMessage(t),c.onCancellationRequested(()=>{this.mapMessageNonceToPendingMessageResolve.delete(n)&&a()})})}spawn(g,c,l){const r={id:y.SharedProcessWorkerMessages.Spawn,configuration:g,environment:this.getSharedProcessWorkerEnvironment()};return this.send(r,l,c)}getSharedProcessWorkerEnvironment(){const g={bootstrapPath:E.FileAccess.asFileUri("bootstrap-fork",Q).fsPath,env:Object.create(null)};if(C.isLinux){const c={companyName:this.productService.crashReporter?.companyName||"Microsoft",productName:this.productService.crashReporter?.productName||this.productService.nameShort,submitURL:"",uploadToServer:!1},l=this.environmentService.args["crash-reporter-id"],r=this.productService.appCenter;if(!this.environmentService.args["crash-reporter-directory"]&&r&&l&&(0,P.isUUID)(l)){const t=r["linux-x64"];c.submitURL=t.concat("&uid=",l,"&iid=",l,"&sid=",l),c.uploadToServer=!0}const n=this.environmentService.args["crash-reporter-directory"]||this.environmentService.userDataPath;g.env.BREAKPAD_DUMP_LOCATION=(0,i.join)(n,this.type),g.env.VSCODE_CRASH_REPORTER_START_OPTIONS=JSON.stringify(c)}return g}terminate(g,c){const l={id:y.SharedProcessWorkerMessages.Terminate,configuration:g};return this.send(l,c)}}}),define(te[91],ne([0,1,6]),function(Q,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,L.createDecorator)(e.SIGN_SERVICE_ID)}),define(te[194],ne([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class L{constructor(){this.validators=new Map}vsda(){return new Promise((D,_)=>Q(["vsda"],D,_))}async createNewMessage(D){try{const _=await this.vsda(),k=new _.validator;if(k){const R=String(L._nextId++);return this.validators.set(R,k),{id:R,data:k.createNewMessage(D)}}}catch{}return{id:"",data:D}}async validate(D,_){if(!D.id)return!0;const k=this.validators.get(D.id);if(!k)return!1;this.validators.delete(D.id);try{return k.validate(_)==="ok"}catch{return!1}}async sign(D){try{const _=await this.vsda(),k=new _.signer;if(k)return k.sign(D)}catch{}return D}}e.SignService=L,L._nextId=1}),define(te[23],ne([0,1,5,3,2,176,15,73,6]),function(Q,e,L,i,D,_,k,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const C="__$__targetStorageMarker";e.IStorageService=(0,E.createDecorator)("storageService");var P;(function(p){p[p.NONE=0]="NONE",p[p.SHUTDOWN=1]="SHUTDOWN"})(P=e.WillSaveStateReason||(e.WillSaveStateReason={}));var b;(function(p){p[p.GLOBAL=0]="GLOBAL",p[p.WORKSPACE=1]="WORKSPACE"})(b=e.StorageScope||(e.StorageScope={}));var d;(function(p){p[p.USER=0]="USER",p[p.MACHINE=1]="MACHINE"})(d=e.StorageTarget||(e.StorageTarget={}));class S extends D.Disposable{constructor(m={flushInterval:S.DEFAULT_FLUSH_INTERVAL}){super();this.options=m,this._onDidChangeValue=this._register(new i.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new i.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new i.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new L.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new D.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,L.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,D.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,_.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,_.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(m,w){w===C?(m===0?this._globalKeyTargets=void 0:m===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:m})):this._onDidChangeValue.fire({scope:m,key:w,target:this.getKeyTargets(m)[w]})}emitWillSaveState(m){this._onWillSaveState.fire({reason:m})}get(m,w,g){return this.getStorage(w)?.get(m,g)}getBoolean(m,w,g){return this.getStorage(w)?.getBoolean(m,g)}getNumber(m,w,g){return this.getStorage(w)?.getNumber(m,g)}store(m,w,g,c){if((0,k.isUndefinedOrNull)(w)){this.remove(m,g);return}this.withPausedEmitters(()=>{this.updateKeyTarget(m,g,c),this.getStorage(g)?.set(m,w)})}remove(m,w){this.withPausedEmitters(()=>{this.updateKeyTarget(m,w,void 0),this.getStorage(w)?.delete(m)})}withPausedEmitters(m){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{m()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(m,w){const g=[],c=this.getKeyTargets(m);for(const l of Object.keys(c))c[l]===w&&g.push(l);return g}updateKeyTarget(m,w,g){const c=this.getKeyTargets(w);typeof g=="number"?c[m]!==g&&(c[m]=g,this.getStorage(w)?.set(C,JSON.stringify(c))):typeof c[m]=="number"&&(delete c[m],this.getStorage(w)?.set(C,JSON.stringify(c)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(m){return m===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(m){const w=this.get(C,m);if(w)try{return JSON.parse(w)}catch{}return Object.create(null)}isNew(m){return this.getBoolean(e.IS_NEW_KEY,m)===!0}async flush(m=P.NONE){this._onWillSaveState.fire({reason:m});const w=this.getStorage(0),g=this.getStorage(1);switch(m){case P.NONE:await L.Promises.settled([w?.whenFlushed()??Promise.resolve(),g?.whenFlushed()??Promise.resolve()]);break;case P.SHUTDOWN:await L.Promises.settled([w?.flush(0)??Promise.resolve(),g?.flush(0)??Promise.resolve()]);break}}async logStorage(){const m=this.getStorage(0)?.items??new Map,w=this.getStorage(1)?.items??new Map;return y(m,w,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=S,S.DEFAULT_FLUSH_INTERVAL=60*1e3;class h extends S{constructor(){super();this.globalStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(m=>this.emitDidChangeValue(1,m))),this._register(this.globalStorage.onDidChangeStorage(m=>this.emitDidChangeValue(0,m)))}getStorage(m){return m===0?this.globalStorage:this.workspaceStorage}getLogDetails(m){return m===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(m){}}e.InMemoryStorageService=h;async function y(p,m,w,g){const c=o=>{try{return JSON.parse(o)}catch{return o}},l=new Map,r=new Map;p.forEach((o,u)=>{l.set(u,o),r.set(u,c(o))});const a=new Map,n=new Map;m.forEach((o,u)=>{a.set(u,o),n.set(u,c(o))}),console.group(`Storage: Global (path: ${w})`);let t=[];l.forEach((o,u)=>{t.push({key:u,value:o})}),console.table(t),console.groupEnd(),console.log(r),console.group(`Storage: Workspace (path: ${g})`);let s=[];a.forEach((o,u)=>{s.push({key:u,value:o})}),console.table(s),console.groupEnd(),console.log(n)}e.logStorage=y}),define(te[195],ne([0,1,3,2,15,29,34,23]),function(Q,e,L,i,D,_,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let E=class extends i.Disposable{constructor(b,d){super();this._onDidChangeEnablement=new L.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new C(b)),this._register(this.storageManger.onDidChange(S=>this._onDidChangeEnablement.fire({extensions:S,source:"storage"}))),this._register(d.onDidInstallExtensions(S=>S.forEach(({local:h,operation:y})=>{h&&y===4&&this._removeFromDisabledExtensions(h.identifier)})))}async enableExtension(b,d){return this._removeFromDisabledExtensions(b)?(this._onDidChangeEnablement.fire({extensions:[b],source:d}),!0):!1}async disableExtension(b,d){return this._addToDisabledExtensions(b)?(this._onDidChangeEnablement.fire({extensions:[b],source:d}),!0):!1}getDisabledExtensions(){return this._getExtensions(_.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(b){let d=this.getDisabledExtensions();return d.every(S=>!(0,k.areSameExtensions)(S,b))?(d.push(b),this._setDisabledExtensions(d),!0):!1}_removeFromDisabledExtensions(b){let d=this.getDisabledExtensions();for(let S=0;S<d.length;S++){const h=d[S];if((0,k.areSameExtensions)(h,b))return d.splice(S,1),this._setDisabledExtensions(d),!0}return!1}_setDisabledExtensions(b){this._setExtensions(_.DISABLED_EXTENSIONS_STORAGE_PATH,b)}_getExtensions(b){return this.storageManger.get(b,0)}_setExtensions(b,d){this.storageManger.set(b,d,0)}};E=de([J(0,R.IStorageService),J(1,_.IExtensionManagementService)],E),e.GlobalExtensionEnablementService=E;class C extends i.Disposable{constructor(b){super();this.storageService=b,this.storage=Object.create(null),this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event,this._register(b.onDidChangeValue(d=>this.onDidStorageChange(d)))}get(b,d){let S;return d===0?((0,D.isUndefinedOrNull)(this.storage[b])&&(this.storage[b]=this._get(b,d)),S=this.storage[b]):S=this._get(b,d),JSON.parse(S)}set(b,d,S){let h=JSON.stringify(d.map(({id:p,uuid:m})=>({id:p,uuid:m})));this._get(b,S)!==h&&(S===0&&(d.length?this.storage[b]=h:delete this.storage[b]),this._set(b,d.length?h:void 0,S))}onDidStorageChange(b){if(b.scope===0&&!(0,D.isUndefinedOrNull)(this.storage[b.key])&&this._get(b.key,b.scope)!==this.storage[b.key]){const S=this.get(b.key,b.scope);delete this.storage[b.key];const h=this.get(b.key,b.scope),y=S.filter(m=>!h.some(w=>(0,k.areSameExtensions)(m,w))),p=h.filter(m=>!S.some(w=>(0,k.areSameExtensions)(w,m)));(y.length||p.length)&&this._onDidChange.fire([...y,...p])}}_get(b,d){return this.storageService.get(b,d,"[]")}_set(b,d,S){d?this.storageService.store(b,d,S,1):this.storageService.remove(b,S)}}e.StorageManager=C}),define(te[196],ne([0,1,3,2]),function(Q,e,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannelClient=void 0;class D extends i.Disposable{constructor(C,P){super();this.channel=C,this.workspace=P}async getItems(){const C={workspace:this.workspace},P=await this.channel.call("getItems",C);return new Map(P)}updateItems(C){const P={workspace:this.workspace};return C.insert&&(P.insert=Array.from(C.insert.entries())),C.delete&&(P.delete=Array.from(C.delete.values())),this.channel.call("updateItems",P)}}class _ extends D{constructor(C){super(C,void 0);this._onDidChangeItemsExternal=this._register(new L.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeGlobalStorage")(C=>this.onDidChangeGlobalStorage(C)))}onDidChangeGlobalStorage(C){(Array.isArray(C.changed)||Array.isArray(C.deleted))&&this._onDidChangeItemsExternal.fire({changed:C.changed?new Map(C.changed):void 0,deleted:C.deleted?new Set(C.deleted):void 0})}async close(){this.dispose()}}class k extends D{constructor(C,P){super(C,P);this.onDidChangeItemsExternal=L.Event.None}async close(){const C={workspace:this.workspace};return this.channel.call("close",C)}}class R extends i.Disposable{constructor(C,P){super();this.channel=C,this.workspace=P,this._globalStorage=void 0,this._workspaceStorage=void 0}get globalStorage(){return this._globalStorage||(this._globalStorage=new _(this.channel)),this._globalStorage}get workspaceStorage(){return!this._workspaceStorage&&this.workspace&&(this._workspaceStorage=new k(this.channel,this.workspace)),this._workspaceStorage}}e.StorageDatabaseChannelClient=R}),define(te[197],ne([0,1,5,2,18,73,23,196]),function(Q,e,L,i,D,_,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class E extends k.AbstractStorageService{constructor(P,b,d){super();this.mainProcessService=b,this.environmentService=d,this.workspaceStorage=void 0,this.workspaceStorageId=void 0,this.workspaceStorageDisposable=this._register(new i.MutableDisposable),this.globalStorage=this.createGlobalStorage(),this.workspaceStorage=this.createWorkspaceStorage(P)}createGlobalStorage(){const P=new R.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),void 0),b=new _.Storage(P.globalStorage);return this._register(b.onDidChangeStorage(d=>this.emitDidChangeValue(0,d))),b}createWorkspaceStorage(P){const b=new R.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),P);if(b.workspaceStorage){const d=new _.Storage(b.workspaceStorage);return this.workspaceStorageDisposable.value=d.onDidChangeStorage(S=>this.emitDidChangeValue(1,S)),this.workspaceStorageId=P?.id,d}else{this.workspaceStorageDisposable.clear(),this.workspaceStorageId=void 0;return}}async doInitialize(){await L.Promises.settled([this.globalStorage.init(),this.workspaceStorage?.init()??Promise.resolve()])}getStorage(P){return P===0?this.globalStorage:this.workspaceStorage}getLogDetails(P){return P===0?this.environmentService.globalStorageHome.fsPath:this.workspaceStorageId?`${(0,D.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}async close(){this.stopFlushWhenIdle(),this.emitWillSaveState(k.WillSaveStateReason.SHUTDOWN),await L.Promises.settled([this.globalStorage.close(),this.workspaceStorage?.close()??Promise.resolve()])}async migrate(P){const b=this.workspaceStorage,d=b?.items??new Map;b&&(await b.close(),b.dispose()),this.workspaceStorage=this.createWorkspaceStorage(P),await this.workspaceStorage.init();for(const[S,h]of d)this.workspaceStorage.set(S,h)}}e.NativeStorageService=E}),define(te[198],ne([0,1,4,32,7,30]),function(Q,e,L,i,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function k(C){if(L.platform===2&&/^penguin(\.|$)/i.test(C))return"chromebook"}async function R(C,P,b,d,S,h,y,p,m,w){const g=Object.create(null);g["common.machineId"]=y,g.sessionID=(0,_.generateUuid)()+Date.now(),g.commitHash=S,g.version=h,g["common.platformVersion"]=(P||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),g["common.platform"]=(0,L.PlatformToString)(L.platform),g["common.nodePlatform"]=i.platform,g["common.nodeArch"]=d,g["common.product"]=w||"desktop";const c=E(p||[]);c&&(g["common.msftInternal"]=c);let l=0;const r=Date.now();Object.defineProperties(g,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-r,enumerable:!0},"common.sequence":{get:()=>l++,enumerable:!0}}),L.isLinuxSnap&&(g["common.snap"]="true");const a=k(b);a&&(g["common.platformDetail"]=a);try{const n=await C.readFile(D.URI.file(m));g["common.source"]=n.value.toString().slice(0,30)}catch{}return g}e.resolveCommonProperties=R;function E(C){const P=i.env.USERDNSDOMAIN;if(!P)return!1;const b=P.toLowerCase();return C.some(d=>b===d)}e.verifyMicrosoftInternalDomain=E}),define(te[22],ne([0,1,6]),function(Q,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,L.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,L.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var i;(function(_){_[_.NONE=0]="NONE",_[_.CRASH=1]="CRASH",_[_.ERROR=2]="ERROR",_[_.USAGE=3]="USAGE"})(i=e.TelemetryLevel||(e.TelemetryLevel={}));var D;(function(_){_.OFF="off",_.CRASH="crash",_.ERROR="error",_.ON="all"})(D=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(te[199],ne([0,1,33,53,5,31,17,9,4,7,112,20,115,78,14,26,22]),function(Q,e,L,i,D,_,k,R,E,C,P,b,d,S,h,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function m(r,a){const n=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}];let t;const s=L.homedir().toLowerCase();switch(process.platform){case"win32":t=[{tag:"gdrive",matcher:A=>/^[a-z]:\\(my drive|shared drives)\\/.test(A)||A.startsWith(s+"\\my drive\\")},{tag:"dropbox",matcher:A=>A.startsWith(s+"\\dropbox")},{tag:"onedrive",matcher:A=>A.startsWith(s+"\\onedrive")},{tag:"box",matcher:A=>A.startsWith(s+"\\box\\")},{tag:"nextcloud",matcher:A=>A.startsWith(s+"\\nextcloud\\")},{tag:"owncloud",matcher:A=>A.startsWith(s+"\\owncloud\\")}];break;case"darwin":t=[{tag:"gdrive",matcher:A=>A.startsWith("/volumes/googledrive/")||A.startsWith(s+"/my drive/")},{tag:"dropbox",matcher:A=>A.startsWith(s+"/dropbox")},{tag:"onedrive",matcher:A=>A.startsWith(s+"/onedrive")||A.startsWith(s+"/library/cloudstorage/onedrive")},{tag:"icloud",matcher:A=>A.startsWith(s+"/library/mobile documents/")},{tag:"box",matcher:A=>A.startsWith(s+"/box/")},{tag:"nextcloud",matcher:A=>A.startsWith(s+"/nextcloud/")},{tag:"owncloud",matcher:A=>A.startsWith(s+"/owncloud/")}];break}const o=new Map,u=new Map,f=2e4;function v(A,N,$,T){for(const M of t){const U=A.toLowerCase();M.matcher(U)&&u.set(M.tag,1)}const F=N.substring(A.length+1);return D.Promises.withAsyncBody(async M=>{let U;try{U=await b.Promises.readdir(N,{withFileTypes:!0})}catch{M();return}if(T.count>=f){T.count+=U.length,T.maxReached=!0,M();return}let B=U.length;if(B===0){M();return}let ee=U;T.count+U.length>f&&(T.maxReached=!0,B=f-T.count,ee=U.slice(0,B)),T.count+=U.length;for(const H of ee)if(H.isDirectory()){if($.includes(H.name)||await v(A,(0,R.join)(N,H.name),$,T),--B==0){M();return}}else{const j=H.name.lastIndexOf(".");if(j>=0){const Z=H.name.substring(j+1);Z&&o.set(Z,(o.get(Z)??0)+1)}for(const Z of n)Z.relativePathPattern?.test(F)!==!1&&Z.filePattern.test(H.name)&&u.set(Z.tag,(u.get(Z.tag)??0)+1);if(--B==0){M();return}}})}const I={count:0,maxReached:!1};await v(r,r,a,I);const O=await c(r);return{configFiles:w(u),fileTypes:w(o),fileCount:I.count,maxFilesReached:I.maxReached,launchConfigFiles:O}}e.collectWorkspaceStats=m;function w(r){return[...i.Iterable.map(r.entries(),([a,n])=>({name:a,count:n}))].sort((a,n)=>n.count-a.count)}function g(){const r={os:`${L.type()} ${L.arch()} ${L.release()}`,memory:`${(L.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(L.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(P.virtualMachineHint.value()*100)}%`},a=L.cpus();return a&&a.length>0&&(r.cpus=`${a[0].model} (${a.length} x ${a[0].speed})`),r}e.getMachineInfo=g;async function c(r){try{const a=new Map,n=(0,R.join)(r,".vscode","launch.json"),t=await b.Promises.readFile(n),s=[],o=(0,_.parse)(t.toString(),s);if(s.length)return console.log(`Unable to parse ${n}`),[];if((0,_.getNodeType)(o)==="object"&&o.configurations)for(const u of o.configurations){const f=u.type;f&&(a.has(f)?a.set(f,a.get(f)+1):a.set(f,1))}return w(a)}catch{return[]}}e.collectLaunchConfigs=c;let l=class{constructor(a,n){this.telemetryService=a,this.productService=n}formatMachineInfo(a){const n=[];return n.push(`OS Version:       ${a.os}`),n.push(`CPUs:             ${a.cpus}`),n.push(`Memory (System):  ${a.memory}`),n.push(`VM:               ${a.vmHint}`),n.join(`
`)}formatEnvironment(a){const n=[];n.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),n.push(`OS Version:       ${L.type()} ${L.arch()} ${L.release()}`);const t=L.cpus();return t&&t.length>0&&n.push(`CPUs:             ${t[0].model} (${t.length} x ${t[0].speed})`),n.push(`Memory (System):  ${(L.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(L.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`),E.isWindows||n.push(`Load (avg):       ${L.loadavg().map(s=>Math.round(s)).join(", ")}`),n.push(`VM:               ${Math.round(P.virtualMachineHint.value()*100)}%`),n.push(`Screen Reader:    ${a.screenReader?"yes":"no"}`),n.push(`Process Argv:     ${a.mainArguments.join(" ")}`),n.push(`GPU Status:       ${this.expandGPUFeatures(a.gpuFeatureStatus)}`),n.join(`
`)}async getPerformanceInfo(a,n){return Promise.all([(0,d.listProcesses)(a.mainPID),this.formatWorkspaceMetadata(a)]).then(async t=>{let[s,o]=t,u=this.formatProcessList(a,s);return n.forEach(f=>{if((0,S.isRemoteDiagnosticError)(f))u+=`
${f.errorMessage}`,o+=`
${f.errorMessage}`;else if(u+=`

Remote: ${f.hostName}`,f.processes&&(u+=`
${this.formatProcessList(a,f.processes)}`),f.workspaceMetadata){o+=`
|  Remote: ${f.hostName}`;for(const v of Object.keys(f.workspaceMetadata)){const I=f.workspaceMetadata[v];let O=`${I.fileCount} files`;I.maxFilesReached&&(O=`more than ${O}`),o+=`|    Folder (${v}): ${O}`,o+=this.formatWorkspaceStats(I)}}}),{processInfo:u,workspaceInfo:o}})}async getSystemInfo(a,n){const{memory:t,vmHint:s,os:o,cpus:u}=g(),f={os:o,memory:t,cpus:u,vmHint:s,processArgs:`${a.mainArguments.join(" ")}`,gpuStatus:a.gpuFeatureStatus,screenReader:`${a.screenReader?"yes":"no"}`,remoteData:n};return E.isWindows||(f.load=`${L.loadavg().map(v=>Math.round(v)).join(", ")}`),E.isLinux&&(f.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(f)}async getDiagnostics(a,n){const t=[];return(0,d.listProcesses)(a.mainPID).then(async s=>(t.push(""),t.push(this.formatEnvironment(a)),t.push(""),t.push(this.formatProcessList(a,s)),a.windows.some(o=>o.folderURIs&&o.folderURIs.length>0&&!o.remoteAuthority)&&(t.push(""),t.push("Workspace Stats: "),t.push(await this.formatWorkspaceMetadata(a))),n.forEach(o=>{if((0,S.isRemoteDiagnosticError)(o))t.push(`
${o.errorMessage}`);else if(t.push(`

`),t.push(`Remote:           ${o.hostName}`),t.push(this.formatMachineInfo(o.machineInfo)),o.processes&&t.push(this.formatProcessList(a,o.processes)),o.workspaceMetadata)for(const u of Object.keys(o.workspaceMetadata)){const f=o.workspaceMetadata[u];let v=`${f.fileCount} files`;f.maxFilesReached&&(v=`more than ${v}`),t.push(`Folder (${u}): ${v}`),t.push(this.formatWorkspaceStats(f))}}),t.push(""),t.push(""),t.join(`
`)))}formatWorkspaceStats(a){const n=[],t=60;let s=0;const o=(I,O)=>{const A=` ${I}(${O})`;s+A.length>t?(n.push(u),u="|                 ",s=u.length):s+=A.length,u+=A};let u="|      File types:";const f=10;let v=a.fileTypes.length>f?f:a.fileTypes.length;for(let I=0;I<v;I++){const O=a.fileTypes[I];o(O.name,O.count)}if(n.push(u),a.configFiles.length>=0&&(u="|      Conf files:",s=0,a.configFiles.forEach(I=>{o(I.name,I.count)}),n.push(u)),a.launchConfigFiles.length>0){let I="|      Launch Configs:";a.launchConfigFiles.forEach(O=>{I+=O.count>1?` ${O.name}(${O.count})`:` ${O.name}`}),n.push(I)}return n.join(`
`)}expandGPUFeatures(a){const n=Math.max(...Object.keys(a).map(t=>t.length));return Object.keys(a).map(t=>`${t}:  ${" ".repeat(n-t.length)}  ${a[t]}`).join(`
                  `)}formatWorkspaceMetadata(a){const n=[],t=[];return a.windows.forEach(s=>{s.folderURIs.length===0||!!s.remoteAuthority||(n.push(`|  Window (${s.title})`),s.folderURIs.forEach(o=>{const u=C.URI.revive(o);if(u.scheme===k.Schemas.file){const f=u.fsPath;t.push(m(f,["node_modules",".git"]).then(v=>{let I=`${v.fileCount} files`;v.maxFilesReached&&(I=`more than ${I}`),n.push(`|    Folder (${(0,R.basename)(f)}): ${I}`),n.push(this.formatWorkspaceStats(v))}).catch(v=>{n.push(`|      Error: Unable to collect workspace stats for folder ${f} (${v.toString()})`)}))}else n.push(`|    Folder (${u.toString()}): Workspace stats not available.`)}))}),Promise.all(t).then(s=>n.join(`
`)).catch(s=>`Unable to collect workspace stats: ${s}`)}formatProcessList(a,n){const t=new Map;a.windows.forEach(o=>t.set(o.pid,o.title));const s=[];return s.push("CPU %	Mem MB	   PID	Process"),n&&this.formatProcessItem(a.mainPID,t,s,n,0),s.join(`
`)}formatProcessItem(a,n,t,s,o){const u=o===0;let f;u?f=s.pid===a?`${this.productService.applicationName} main`:"remote agent":(f=`${"  ".repeat(o)} ${s.name}`,s.name==="window"&&(f=`${f} (${n.get(s.pid)})`));const v=process.platform==="win32"?s.mem:L.totalmem()*(s.mem/100);t.push(`${s.load.toFixed(0).padStart(5," ")}	${(v/h.ByteSize.MB).toFixed(0).padStart(6," ")}	${s.pid.toFixed(0).padStart(6," ")}	${f}`),Array.isArray(s.children)&&s.children.forEach(I=>this.formatProcessItem(a,n,t,I,o+1))}async reportWorkspaceStats(a){for(const{uri:n}of a.folders){const t=C.URI.revive(n);if(t.scheme!==k.Schemas.file)continue;const s=t.fsPath;try{const o=await m(s,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":a.telemetryId,rendererSessionId:a.rendererSessionId}),o.fileTypes.forEach(u=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:a.rendererSessionId,type:u.name,count:u.count})}),o.launchConfigFiles.forEach(u=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:a.rendererSessionId,type:u.name,count:u.count})}),o.configFiles.forEach(u=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:a.rendererSessionId,type:u.name,count:u.count})})}catch{}}}};l=de([J(0,p.ITelemetryService),J(1,y.IProductService)],l),e.DiagnosticsService=l}),define(te[200],ne([0,1,16,5,27,10,3,2,4,15,7,129,29,34,8,26,22]),function(Q,e,L,i,D,_,k,R,E,C,P,b,d,S,h,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=void 0;let m=class extends R.Disposable{constructor(a,n,t,s){super();this.galleryService=a,this.telemetryService=n,this.logService=t,this.productService=s,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new k.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new k.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new k.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new k.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,R.toDisposable)(()=>{this.installingExtensions.forEach(o=>o.cancel()),this.uninstallingExtensions.forEach(o=>o.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(a){const n=await this.getTargetPlatform();return a.allTargetPlatforms.some(t=>(0,d.isTargetPlatformCompatible)(t,a.allTargetPlatforms,n))}async installFromGallery(a,n={}){try{if(!this.galleryService.isEnabled())throw new d.ExtensionManagementError(b.localize(0,null),d.ExtensionManagementErrorCode.Internal);const t=await this.checkAndGetCompatibleVersion(a,!n.installGivenVersion,!!n.installPreReleaseVersion);return await this.installExtension(t.manifest,t.extension,n)}catch(t){throw c(this.telemetryService,"extensionGallery:install",(0,S.getGalleryExtensionTelemetryData)(a),void 0,t),this.logService.error("Failed to install extension.",a.identifier.id),this.logService.error(t),g(t)}}async migrateUnsupportedExtensions(){try{const a=await this.getExtensionsControlManifest();if(!a.unsupportedPreReleaseExtensions)return;const n=await this.getInstalled(1);for(const[t,s]of Object.entries(a.unsupportedPreReleaseExtensions)){const o=n.find(v=>(0,S.areSameExtensions)(v.identifier,{id:t}));if(!o)continue;const u=await this.galleryService.getCompatibleExtension({id:s.id},!0,await this.getTargetPlatform());if(!u){this.logService.info(`Skipping migrating '${o.identifier.id}' extension because, the comaptible target '${s.id}' extension is not found`);continue}const f=await this.galleryService.getManifest(u,D.CancellationToken.None);if(!f){this.logService.info(`Skipping migrating '${o.identifier.id}' extension because, the manifest for '${s.id}' extension is not found`);continue}try{this.logService.info(`Migrating '${o.identifier.id}' extension to '${s.id}' extension...`),await Promise.allSettled([this.uninstall(o),this.installExtension(f,u,{installPreReleaseVersion:!0,isMachineScoped:o.isMachineScoped,operation:4})]),this.logService.info(`Migrated '${o.identifier.id}' extension to '${s.id}' extension.`)}catch(v){this.logService.error(v)}}}catch(a){this.logService.error(a)}}async uninstall(a,n={}){return this.logService.trace("ExtensionManagementService#uninstall",a.identifier.id),this.unininstallExtension(a,n)}async reinstallFromGallery(a){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",a.identifier.id),!this.galleryService.isEnabled())throw new Error(b.localize(1,null));const n=await this.findGalleryExtension(a);if(!n)throw new Error(b.localize(2,null));await this.createUninstallExtensionTask(a,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(n)}getExtensionsControlManifest(){const a=new Date().getTime();return(!this.extensionsControlManifest||a-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=a),this.extensionsControlManifest}registerParticipant(a){this.participants.push(a)}async installExtension(a,n,t){if(!P.URI.isUri(n)){let v=this.installingExtensions.get(new S.ExtensionIdentifierWithVersion(n.identifier,n.version).key());if(v)return this.logService.info("Extensions is already requested to install",n.identifier.id),v.waitUntilTaskIsFinished();t={...t,installOnlyNewlyAddedFromExtensionPack:!0}}const s=[],o=[],u=this.createInstallExtensionTask(a,n,t);P.URI.isUri(n)||this.installingExtensions.set(new S.ExtensionIdentifierWithVersion(u.identifier,a.version).key(),u),this._onInstallExtension.fire({identifier:u.identifier,source:n}),this.logService.info("Installing extension:",u.identifier.id),s.push({task:u,manifest:a});let f=!1;try{if(t.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",u.identifier.id);else try{const I=await this.getAllDepsAndPackExtensionsToInstall(u.identifier,a,!!t.installOnlyNewlyAddedFromExtensionPack,!!t.installPreReleaseVersion);for(const{gallery:O,manifest:A}of I)if(f=f||!!A.extensionDependencies?.some(N=>(0,S.areSameExtensions)({id:N},u.identifier)),this.installingExtensions.has(new S.ExtensionIdentifierWithVersion(O.identifier,O.version).key()))this.logService.info("Extension is already requested to install",O.identifier.id);else{const N=this.createInstallExtensionTask(A,O,{...t,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new S.ExtensionIdentifierWithVersion(N.identifier,A.version).key(),N),this._onInstallExtension.fire({identifier:N.identifier,source:O}),this.logService.info("Installing extension:",N.identifier.id),s.push({task:N,manifest:A})}}catch(I){if(P.URI.isUri(u.source))(0,L.isNonEmptyArray)(a.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",u.identifier.id,I.message),(0,L.isNonEmptyArray)(a.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",u.identifier.id,I.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",u.identifier.id),I}const v=s.reduce((I,{task:O,manifest:A})=>(I.set(O.identifier.id.toLowerCase(),{task:O,manifest:A}),I),new Map);for(;v.size;){let I;const O=[...v.values()].filter(({manifest:A})=>!A.extensionDependencies?.some(N=>v.has(N.toLowerCase())));O.length?I=v.size===1?O:O.filter(({task:A})=>!(A===u&&!f)):(this.logService.info("Found extensions with circular dependencies",O.map(({task:A})=>A.identifier.id)),I=[...v.values()]),await this.joinAllSettled(I.map(async({task:A})=>{const N=new Date().getTime(),$=(0,C.isUndefined)(t.operation)?A.operation:t.operation;try{const T=await A.run();if(await this.joinAllSettled(this.participants.map(F=>F.postInstall(T,A.source,t,D.CancellationToken.None))),!P.URI.isUri(A.source)&&(c(this.telemetryService,$===3?"extensionGallery:update":"extensionGallery:install",(0,S.getGalleryExtensionTelemetryData)(A.source),new Date().getTime()-N,void 0),E.isWeb&&$!==3))try{await this.galleryService.reportStatistic(T.manifest.publisher,T.manifest.name,T.manifest.version,"install")}catch{}o.push({local:T,identifier:A.identifier,operation:$,source:A.source})}catch(T){throw P.URI.isUri(A.source)||c(this.telemetryService,$===3?"extensionGallery:update":"extensionGallery:install",(0,S.getGalleryExtensionTelemetryData)(A.source),new Date().getTime()-N,T),this.logService.error("Error while installing the extension:",A.identifier.id),T}finally{v.delete(A.identifier.id.toLowerCase())}}))}return o.forEach(({identifier:I})=>this.logService.info("Extension installed successfully:",I.id)),this._onDidInstallExtensions.fire(o),o.filter(({identifier:I})=>(0,S.areSameExtensions)(I,u.identifier))[0].local}catch(v){if(s.forEach(({task:I})=>I.cancel()),o.length)try{const I=await Promise.allSettled(o.map(({local:O})=>this.createUninstallExtensionTask(O,{versionOnly:!0}).run()));for(let O=0;O<I.length;O++){const A=I[O],{identifier:N}=o[O];A.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",N.id):this.logService.warn("Rollback: Error while uninstalling extension",N.id,(0,_.getErrorMessage)(A.reason))}}catch(I){this.logService.warn("Error while rolling back extensions",(0,_.getErrorMessage)(I),o.map(({identifier:O})=>O.id))}throw this._onDidInstallExtensions.fire(s.map(({task:I})=>({identifier:I.identifier,operation:2,source:I.source}))),v}finally{for(const{task:v,manifest:I}of s)if(!P.URI.isUri(v.source)){const O=new S.ExtensionIdentifierWithVersion(v.identifier,I.version).key();this.installingExtensions.delete(O)||this.logService.warn("Installation task is not found in the cache",O)}}}async joinAllSettled(a){const n=[],t=[],s=await Promise.allSettled(a);for(const o of s)o.status==="fulfilled"?n.push(o.value):t.push(o.reason);if(t.length)throw w(t);return n}async getAllDepsAndPackExtensionsToInstall(a,n,t,s){if(!this.galleryService.isEnabled())return[];let o=await this.getInstalled();const u=[a,...o.map(I=>I.identifier)],f=[],v=async(I,O)=>{const A=O.extensionDependencies||[],N=[...A];if(O.extensionPack){const $=t?o.find(T=>(0,S.areSameExtensions)(T.identifier,I)):void 0;for(const T of O.extensionPack)$&&$.manifest.extensionPack&&$.manifest.extensionPack.some(F=>(0,S.areSameExtensions)({id:F},{id:T}))||N.every(F=>!(0,S.areSameExtensions)({id:F},{id:T}))&&N.push(T)}if(N.length){const $=[...u,...f.map(F=>F.gallery.identifier)],T=N.filter(F=>$.every(M=>!(0,S.areSameExtensions)(M,{id:F})));if(T.length){const F=await this.galleryService.query({names:T,pageSize:N.length},D.CancellationToken.None);for(const M of F.firstPage){if($.find(ee=>(0,S.areSameExtensions)(ee,M.identifier)))continue;const U=A.some(ee=>(0,S.areSameExtensions)({id:ee},M.identifier));let B;try{B=await this.checkAndGetCompatibleVersion(M,!0,s)}catch(ee){if(ee instanceof d.ExtensionManagementError&&ee.code===d.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!U){this.logService.info("Skipping the packed extension as it cannot be installed",M.identifier.id);continue}else throw ee}f.push({gallery:B.extension,manifest:B.manifest}),await v(B.extension.identifier,O)}}}};return await v(a,n),o=await this.getInstalled(),f.filter(I=>!o.some(O=>(0,S.areSameExtensions)(O.identifier,I.gallery.identifier)))}async checkAndGetCompatibleVersion(a,n,t){const s=await this.getExtensionsControlManifest();if((0,S.getMaliciousExtensionsSet)(s).has(a.identifier.id))throw new d.ExtensionManagementError(b.localize(3,null,a.identifier.id),d.ExtensionManagementErrorCode.Malicious);if(!!s.unsupportedPreReleaseExtensions&&!!s.unsupportedPreReleaseExtensions[a.identifier.id])throw new d.ExtensionManagementError(b.localize(4,null,a.identifier.id,s.unsupportedPreReleaseExtensions[a.identifier.id].displayName),d.ExtensionManagementErrorCode.UnsupportedPreRelease);if(!await this.canInstall(a)){const f=await this.getTargetPlatform();throw new d.ExtensionManagementError(b.localize(5,null,a.identifier.id,this.productService.nameLong,(0,d.TargetPlatformToString)(f)),d.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const o=await this.getCompatibleVersion(a,n,t);if(o){if(t&&a.hasPreReleaseVersion&&!o.properties.isPreReleaseVersion)throw new d.ExtensionManagementError(b.localize(6,null,a.identifier.id,this.productService.nameLong,this.productService.version),d.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw new d.ExtensionManagementError(b.localize(7,null,a.identifier.id,this.productService.nameLong,this.productService.version),d.ExtensionManagementErrorCode.Incompatible);const u=await this.galleryService.getManifest(o,D.CancellationToken.None);if(u===null)throw new d.ExtensionManagementError(`Missing manifest for extension ${a.identifier.id}`,d.ExtensionManagementErrorCode.Invalid);if(u.version!==o.version)throw new d.ExtensionManagementError(`Cannot install '${a.identifier.id}' extension because of version mismatch in Marketplace`,d.ExtensionManagementErrorCode.Invalid);return{extension:o,manifest:u}}async getCompatibleVersion(a,n,t){const s=await this.getTargetPlatform();let o=null;return n&&a.hasPreReleaseVersion&&a.properties.isPreReleaseVersion!==t&&(o=await this.galleryService.getCompatibleExtension(a.identifier,t,s)),!o&&await this.galleryService.isExtensionCompatible(a,t,s)&&(o=a),!o&&n&&(o=await this.galleryService.getCompatibleExtension(a,t,s)),o}async unininstallExtension(a,n){const t=this.uninstallingExtensions.get(a.identifier.id.toLowerCase());if(t)return this.logService.info("Extensions is already requested to uninstall",a.identifier.id),t.waitUntilTaskIsFinished();const s=(v,I)=>{const O=this.createUninstallExtensionTask(v,I);return this.uninstallingExtensions.set(O.extension.identifier.id.toLowerCase(),O),this.logService.info("Uninstalling extension:",v.identifier.id),this._onUninstallExtension.fire(v.identifier),O},o=(v,I)=>{I?this.logService.error("Failed to uninstall extension:",v.identifier.id,I.message):this.logService.info("Successfully uninstalled extension:",v.identifier.id),c(this.telemetryService,"extensionGallery:uninstall",(0,S.getLocalExtensionTelemetryData)(v),void 0,I),this._onDidUninstallExtension.fire({identifier:v.identifier,error:I?.code})},u=[],f=[];try{u.push(s(a,{}));const v=await this.getInstalled(1);if(n.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",a.identifier.id);else{const I=this.getAllPackExtensionsToUninstall(a,v);for(const O of I)this.uninstallingExtensions.has(O.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",O.identifier.id):u.push(s(O,{}))}n.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",a.identifier.id):this.checkForDependents(u.map(I=>I.extension),v,a),await this.joinAllSettled(u.map(async I=>{try{if(await I.run(),await this.joinAllSettled(this.participants.map(O=>O.postUninstall(I.extension,n,D.CancellationToken.None))),I.extension.identifier.uuid)try{await this.galleryService.reportStatistic(I.extension.manifest.publisher,I.extension.manifest.name,I.extension.manifest.version,"uninstall")}catch{}o(I.extension)}catch(O){const A=O instanceof d.ExtensionManagementError?O:new d.ExtensionManagementError((0,_.getErrorMessage)(O),d.ExtensionManagementErrorCode.Internal);throw o(I.extension,A),A}finally{f.push(I)}}))}catch(v){const I=v instanceof d.ExtensionManagementError?v:new d.ExtensionManagementError((0,_.getErrorMessage)(v),d.ExtensionManagementErrorCode.Internal);for(const O of u){try{O.cancel()}catch{}f.includes(O)||o(O.extension,I)}throw I}finally{for(const v of u)this.uninstallingExtensions.delete(v.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",v.extension.identifier.id)}}checkForDependents(a,n,t){for(const s of a){const o=this.getDependents(s,n);if(o.length){const u=o.filter(f=>!a.some(v=>(0,S.areSameExtensions)(v.identifier,f.identifier)));if(u.length)throw new Error(this.getDependentsErrorMessage(s,u,t))}}}getDependentsErrorMessage(a,n,t){return t===a?n.length===1?b.localize(8,null,t.manifest.displayName||t.manifest.name,n[0].manifest.displayName||n[0].manifest.name):n.length===2?b.localize(9,null,t.manifest.displayName||t.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):b.localize(10,null,t.manifest.displayName||t.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):n.length===1?b.localize(11,null,t.manifest.displayName||t.manifest.name,a.manifest.displayName||a.manifest.name,n[0].manifest.displayName||n[0].manifest.name):n.length===2?b.localize(12,null,t.manifest.displayName||t.manifest.name,a.manifest.displayName||a.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):b.localize(13,null,t.manifest.displayName||t.manifest.name,a.manifest.displayName||a.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name)}getAllPackExtensionsToUninstall(a,n,t=[]){if(t.indexOf(a)!==-1)return[];t.push(a);const s=a.manifest.extensionPack?a.manifest.extensionPack:[];if(s.length){const o=n.filter(f=>!f.isBuiltin&&s.some(v=>(0,S.areSameExtensions)({id:v},f.identifier))),u=[];for(const f of o)u.push(...this.getAllPackExtensionsToUninstall(f,n,t));return[...o,...u]}return[]}getDependents(a,n){return n.filter(t=>t.manifest.extensionDependencies&&t.manifest.extensionDependencies.some(s=>(0,S.areSameExtensions)({id:s},a.identifier)))}async findGalleryExtension(a){if(a.identifier.uuid){const n=await this.findGalleryExtensionById(a.identifier.uuid);return n||this.findGalleryExtensionByName(a.identifier.id)}return this.findGalleryExtensionByName(a.identifier.id)}async findGalleryExtensionById(a){return(await this.galleryService.query({ids:[a],pageSize:1},D.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(a){return(await this.galleryService.query({names:[a],pageSize:1},D.CancellationToken.None)).firstPage[0]}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const a=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",a),a}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[]}}}};m=de([J(0,d.IExtensionGalleryService),J(1,p.ITelemetryService),J(2,h.ILogService),J(3,y.IProductService)],m),e.AbstractExtensionManagementService=m;function w(r){const a=Array.isArray(r)?r:[r];return a.length===1?a[0]instanceof Error?a[0]:new Error(a[0]):a.reduce((n,t)=>new Error(`${n.message}${n.message?",":""}${t instanceof Error?t.message:t}`),new Error(""))}e.joinErrors=w;function g(r){if(r instanceof d.ExtensionManagementError)return r;const a=new d.ExtensionManagementError(r.message,d.ExtensionManagementErrorCode.Internal);return a.stack=r.stack,a}function c(r,a,n,t,s){const o=s?s instanceof d.ExtensionManagementError?s.code:d.ExtensionManagementErrorCode.Internal:void 0;r.publicLogError(a,{...n,success:!s,duration:t,errorcode:o})}e.reportTelemetry=c;class l{constructor(){this.barrier=new i.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,i.createCancelablePromise)(a=>this.doRun(a))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,i.createCancelablePromise)(a=>new Promise((n,t)=>{const s=a.onCancellationRequested(()=>{s.dispose(),t((0,_.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=l}),define(te[201],ne([0,1,16,5,66,3,9,4,32,7,131,11,29,191,80,14,8,60,26,42,23,22]),function(Q,e,L,i,D,_,k,R,E,C,P,b,d,S,h,y,p,m,w,g,c,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const r="extensionTips/promptedExecutableTips",a="extensionTips/lastPromptedMediumImpExeTime";let n=class extends S.ExtensionTipsService{constructor(s,o,u,f,v,I,O,A,N,$){super(O,A,N,$);this.environmentService=s,this.telemetryService=o,this.extensionManagementService=u,this.storageService=f,this.nativeHostService=v,this.extensionRecommendationNotificationService=I,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,A.exeBasedExtensionTips&&(0,D.forEach)(A.exeBasedExtensionTips,({key:T,value:F})=>{const M=[],U=[],B=[];(0,D.forEach)(F.recommendations,({key:ee,value:H})=>{H.important?F.important?M.push({extensionId:ee,extensionName:H.name,isExtensionPack:!!H.isExtensionPack}):U.push({extensionId:ee,extensionName:H.name,isExtensionPack:!!H.isExtensionPack}):B.push({extensionId:ee,extensionName:H.name,isExtensionPack:!!H.isExtensionPack})}),M.length&&this.highImportanceExecutableTips.set(T,{exeFriendlyName:F.friendlyName,windowsPath:F.windowsPath,recommendations:M}),U.length&&this.mediumImportanceExecutableTips.set(T,{exeFriendlyName:F.friendlyName,windowsPath:F.windowsPath,recommendations:U}),B.length&&this.allOtherExecutableTips.set(T,{exeFriendlyName:F.friendlyName,windowsPath:F.windowsPath,recommendations:B})}),(0,i.timeout)(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const s=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),o=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...s,...o]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const s=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),o=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),u=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(s,u),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(o,u)}groupImportantTipsByExe(s,o){const u=new Map;s.forEach(A=>u.set(A.extensionId.toLowerCase(),A));const{installed:f,uninstalled:v}=this.groupByInstalled([...u.keys()],o);for(const A of f){const N=u.get(A);N&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:A,exeName:N.exeName})}for(const A of v){const N=u.get(A);N&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:A,exeName:N.exeName})}const I=this.getPromptedExecutableTips(),O=new Map;for(const A of v){const N=u.get(A);if(N&&(!I[N.exeName]||!I[N.exeName].includes(N.extensionId))){let $=O.get(N.exeName);$||($=[],O.set(N.exeName,$)),$.push(N)}}return O}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[s,o]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(o).then(u=>{switch(u){case"reacted":this.addToRecommendedExecutables(o[0].exeName,o);break;case"ignored":this.highImportanceTipsByExe.delete(s);break;case"incompatibleWindow":const f=_.Event.once(_.Event.latch(_.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(f(()=>this.promptHighImportanceExeBasedTip()));break;case"toomany":const v=this._register((0,i.disposableTimeout)(()=>{v.dispose(),this.promptHighImportanceExeBasedTip()},60*60*1e3));break}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const s=this.getLastPromptedMediumExeTime(),o=Date.now()-s,u=7*24*60*60*1e3;if(o<u){const I=this._register((0,i.disposableTimeout)(()=>{I.dispose(),this.promptMediumImportanceExeBasedTip()},u-o));return}const[f,v]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(v).then(I=>{switch(I){case"reacted":this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(f),this.addToRecommendedExecutables(v[0].exeName,v);const O=this._register((0,i.disposableTimeout)(()=>{O.dispose(),this.promptMediumImportanceExeBasedTip()},u));break;case"ignored":this.mediumImportanceTipsByExe.delete(f),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":const A=_.Event.once(_.Event.latch(_.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(A(()=>this.promptMediumImportanceExeBasedTip()));break;case"toomany":const N=this._register((0,i.disposableTimeout)(()=>{N.dispose(),this.promptMediumImportanceExeBasedTip()},60*60*1e3));break}})}promptExeRecommendations(s){const o=s.map(({extensionId:f})=>f.toLowerCase()),u=(0,P.localize)(0,null,s[0].exeFriendlyName);return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification(o,u,`@exe:"${s[0].exeName}"`,3)}getLastPromptedMediumExeTime(){let s=this.storageService.getNumber(a,0);return s||(s=Date.now(),this.updateLastPromptedMediumExeTime(s)),s}updateLastPromptedMediumExeTime(s){this.storageService.store(a,s,0,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(r,0,"{}"))}addToRecommendedExecutables(s,o){const u=this.getPromptedExecutableTips();u[s]=o.map(({extensionId:f})=>f.toLowerCase()),this.storageService.store(r,JSON.stringify(u),0,0)}groupByInstalled(s,o){const u=[],f=[],v=o.reduce((I,O)=>(I.add(O.identifier.id.toLowerCase()),I),new Set);return s.forEach(I=>{v.has(I.toLowerCase())?u.push(I):f.push(I)}),{installed:u,uninstalled:f}}async getValidExecutableBasedExtensionTips(s){const o=[],u=new Map;for(const f of s.keys()){const v=s.get(f);if(!v||!(0,L.isNonEmptyArray)(v.recommendations))continue;const I=[];R.isWindows?v.windowsPath&&I.push(v.windowsPath.replace("%USERPROFILE%",E.env.USERPROFILE).replace("%ProgramFiles(x86)%",E.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",E.env.ProgramFiles).replace("%APPDATA%",E.env.APPDATA).replace("%WINDIR%",E.env.WINDIR)):(I.push((0,k.join)("/usr/local/bin",f)),I.push((0,k.join)("/usr/bin",f)),I.push((0,k.join)(this.environmentService.userHome.fsPath,f)));for(const O of I){let A=u.get(O);if(A===void 0&&(A=await this.fileService.exists(C.URI.file(O)),u.set(O,A)),A)for(const{extensionId:N,extensionName:$,isExtensionPack:T}of v.recommendations)o.push({extensionId:N,extensionName:$,isExtensionPack:T,exeName:f,exeFriendlyName:v.exeFriendlyName,windowsPath:v.windowsPath})}}return o}};n=de([J(0,b.INativeEnvironmentService),J(1,l.ITelemetryService),J(2,d.IExtensionManagementService),J(3,c.IStorageService),J(4,m.INativeHostService),J(5,h.IExtensionRecommendationNotificationService),J(6,y.IFileService),J(7,w.IProductService),J(8,g.IRequestService),J(9,p.ILogService)],n),e.ExtensionTipsService=n}),define(te[92],ne([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class L{constructor(_){this.appenders=_}listen(_,k){throw new Error(`Event not found: ${k}`)}call(_,k,{eventName:R,data:E}){return this.appenders.forEach(C=>C.log(R,E)),Promise.resolve(null)}}e.TelemetryAppenderChannel=L;class i{constructor(_){this.channel=_}log(_,k){return this.channel.call("log",{eventName:_,data:k}).then(void 0,R=>`Failed to log telemetry: ${console.warn(R)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=i}),define(te[43],ne([0,1,28,15,21,22]),function(Q,e,L,i,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class k{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(m,w){return Promise.resolve(void 0)}publicLog2(m,w){return this.publicLog(m,w)}publicLogError(m,w){return Promise.resolve(void 0)}publicLogError2(m,w){return this.publicLogError(m,w)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=k,e.NullTelemetryService=new k;class R{async publicLog(m,w,g){}async publicLogError(m,w,g){}}e.NullEndpointTelemetryService=R,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function E(p,m){return m.onDidChangeConfiguration(w=>{w.source!==6&&p.publicLog2("updateConfiguration",{configurationSource:(0,D.ConfigurationTargetToString)(w.source),configurationKeys:h(w.sourceConfig)})})}e.configurationTelemetry=E;function C(p,m){return!(m.disableTelemetry||!p.enableTelemetry)}e.supportsTelemetry=C;function P(p){const m=p.getValue(_.TELEMETRY_SETTING_ID),w=p.getValue("telemetry.enableCrashReporter");if(p.getValue(_.TELEMETRY_OLD_SETTING_ID)===!1||w===!1)return 0;switch(m??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=P;function b(p){const m=Object.create(null),w=Object.create(null),g=Object.create(null);S(p,g);for(let c in g){c=c.length>150?c.substr(c.length-149):c;const l=g[c];typeof l=="number"?w[c]=l:typeof l=="boolean"?w[c]=l?1:0:typeof l=="string"?(l.length>8192&&console.warn(`Telemetry property: ${c} has been trimmed to 8192, the original length is ${l.length}`),m[c]=l.substring(0,8191)):typeof l!="undefined"&&l!==null&&(m[c]=l)}return{properties:m,measurements:w}}e.validateTelemetryData=b;function d(p){if(!p)return"none";let m="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(g=>{p.indexOf(`${g}+`)===0&&(m=g)}),m}e.cleanRemoteAuthority=d;function S(p,m,w=0,g){if(!!p)for(let c of Object.getOwnPropertyNames(p)){const l=p[c],r=g?g+c:c;Array.isArray(l)?m[r]=(0,L.safeStringify)(l):l instanceof Date?m[r]=l.toISOString():(0,i.isObject)(l)?w<2?S(l,m,w+1,r+"."):m[r]=(0,L.safeStringify)(l):m[r]=l}}function h(p){if(!p)return[];const m=[];return y(m,"",p),m}function y(p,m,w){w&&typeof w=="object"&&!Array.isArray(w)?Object.keys(w).forEach(g=>y(p,m?`${m}.${g}`:g,w[g])):p.push(m)}}),define(te[202],ne([0,1,43,149]),function(Q,e,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AssignmentService=e.BaseAssignmentService=void 0;class D{constructor(){}setSharedProperty(E,C){}postEvent(E,C){}}class _{constructor(E,C,P,b,d){this.getMachineId=E,this.configurationService=C,this.productService=P,this.telemetry=b,this.keyValueStorage=d,this.networkInitialized=!1,P.tasConfig&&this.experimentsEnabled&&(0,L.getTelemetryLevel)(this.configurationService)===3&&(this.tasClient=this.setupTASClient());const S=this.configurationService.getValue("experiments.overrideDelay"),h=typeof S=="number"?S:0;this.overrideInitDelay=new Promise(y=>setTimeout(y,h))}get experimentsEnabled(){return!0}async getTreatment(E){await this.overrideInitDelay;const C=this.configurationService.getValue("experiments.override."+E);if(C!==void 0)return C;if(!this.tasClient||!this.experimentsEnabled)return;let P;const b=await this.tasClient;return this.networkInitialized?P=b.getTreatmentVariable("vscode",E):P=await b.getTreatmentVariableAsync("vscode",E,!0),P=b.getTreatmentVariable("vscode",E),P}async setupTASClient(){const E=this.productService.quality==="stable"?i.TargetPopulation.Public:i.TargetPopulation.Insiders,C=await this.getMachineId(),P=new i.AssignmentFilterProvider(this.productService.version,this.productService.nameLong,C,E),b=this.productService.tasConfig,d=new(await new Promise((S,h)=>{Q(["tas-client-umd"],S,h)})).ExperimentationService({filterProviders:[P],telemetry:this.telemetry,storageKey:i.ASSIGNMENT_STORAGE_KEY,keyValueStorage:this.keyValueStorage,featuresTelemetryPropertyName:b.featuresTelemetryPropertyName,assignmentContextTelemetryPropertyName:b.assignmentContextTelemetryPropertyName,telemetryEventName:b.telemetryEventName,endpoint:b.endpoint,refetchInterval:i.ASSIGNMENT_REFETCH_INTERVAL});return await d.initializePromise,d.initialFetch.then(()=>this.networkInitialized=!0),d}}e.BaseAssignmentService=_;class k extends _{constructor(E,C,P){super(()=>Promise.resolve(E),C,P,new D)}}e.AssignmentService=k}),define(te[203],ne([0,1,16,27,10,28,4,32,15,7,21,11,29,34,76,14,8,26,42,45,23,22,43]),function(Q,e,L,i,D,_,k,R,E,C,P,b,d,S,h,y,p,m,w,g,c,l,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const a=k.isWeb?"web":(0,d.getTargetPlatform)(k.platform,R.arch);var n;(function(x){x[x.None=0]="None",x[x.IncludeVersions=1]="IncludeVersions",x[x.IncludeFiles=2]="IncludeFiles",x[x.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",x[x.IncludeSharedAccounts=8]="IncludeSharedAccounts",x[x.IncludeVersionProperties=16]="IncludeVersionProperties",x[x.ExcludeNonValidated=32]="ExcludeNonValidated",x[x.IncludeInstallationTargets=64]="IncludeInstallationTargets",x[x.IncludeAssetUri=128]="IncludeAssetUri",x[x.IncludeStatistics=256]="IncludeStatistics",x[x.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",x[x.Unpublished=4096]="Unpublished"})(n||(n={}));function t(...x){return String(x.reduce((K,re)=>K|re,0))}var s;(function(x){x[x.Tag=1]="Tag",x[x.ExtensionId=4]="ExtensionId",x[x.Category=5]="Category",x[x.ExtensionName=7]="ExtensionName",x[x.Target=8]="Target",x[x.Featured=9]="Featured",x[x.SearchText=10]="SearchText",x[x.ExcludeWithFlags=12]="ExcludeWithFlags"})(s||(s={}));const o={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},u={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},v={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:n.None,criteria:[],assetTypes:[]};class I{constructor(K=v){this.state=K}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(K,re=this.state.pageSize){return new I({...this.state,pageNumber:K,pageSize:re})}withFilter(K,...re){const se=[...this.state.criteria,...re.length?re.map(ce=>({filterType:K,value:ce})):[{filterType:K}]];return new I({...this.state,criteria:se})}withSortBy(K){return new I({...this.state,sortBy:K})}withSortOrder(K){return new I({...this.state,sortOrder:K})}withFlags(...K){return new I({...this.state,flags:K.reduce((re,se)=>re|se,0)})}withAssetTypes(...K){return new I({...this.state,assetTypes:K})}get raw(){const{criteria:K,pageNumber:re,pageSize:se,sortBy:ce,sortOrder:he,flags:me,assetTypes:ve}=this.state;return{filters:[{criteria:K,pageNumber:re,pageSize:se,sortBy:ce,sortOrder:he}],assetTypes:ve,flags:me}}get searchText(){const K=this.state.criteria.filter(re=>re.filterType===s.SearchText)[0];return K&&K.value?K.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(K=>String(K.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function O(x,K){const re=(x||[]).filter(se=>se.statisticName===K)[0];return re?re.value:0}function A(x){const K="Microsoft.VisualStudio.Code.Translation.";return x.files.filter(se=>se.assetType.indexOf(K)===0).reduce((se,ce)=>{const he=F(x,ce.assetType);return he&&se.push([ce.assetType.substring(K.length),he]),se},[])}function N(x){if(x.properties){const K=x.properties.filter(ce=>ce.key===o.Repository),re=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),se=K.filter(ce=>re.test(ce.value))[0];return se?{uri:se.value,fallbackUri:se.value}:null}return F(x,o.Repository)}function $(x){return{uri:`${x.fallbackAssetUri}/${o.VSIX}?redirect=true${x.targetPlatform?`&targetPlatform=${x.targetPlatform}`:""}`,fallbackUri:`${x.fallbackAssetUri}/${o.VSIX}${x.targetPlatform?`?targetPlatform=${x.targetPlatform}`:""}`}}function T(x){const K=F(x,o.Icon);if(K)return K;const re=d.DefaultIconPath;return{uri:re,fallbackUri:re}}function F(x,K){return x.files.filter(se=>se.assetType===K)[0]?{uri:`${x.assetUri}/${K}${x.targetPlatform?`?targetPlatform=${x.targetPlatform}`:""}`,fallbackUri:`${x.fallbackAssetUri}/${K}${x.targetPlatform?`?targetPlatform=${x.targetPlatform}`:""}`}:null}function M(x,K){const re=x.properties?x.properties.filter(ce=>ce.key===K):[],se=re.length>0&&re[0].value;return se?se.split(",").map(ce=>(0,S.adoptToGalleryExtensionId)(ce)):[]}function U(x){const K=x.properties?x.properties.filter(re=>re.key===u.Engine):[];return K.length>0&&K[0].value||""}function B(x){const K=x.properties?x.properties.filter(re=>re.key===u.PreRelease):[];return K.length>0&&K[0].value==="true"}function ee(x){const K=x.properties?x.properties.filter(se=>se.key===u.LocalizedLanguages):[],re=K.length>0&&K[0].value||"";return re?re.split(","):[]}function H(x){return x.indexOf("preview")!==-1}function j(x){return x.targetPlatform?(0,d.toTargetPlatform)(x.targetPlatform):"undefined"}function Z(x){const K=(0,L.distinct)(x.versions.map(j)),re=!!x.tags?.includes(d.WEB_EXTENSION_TAG),se=K.indexOf("web");return re?se===-1&&K.push("web"):se!==-1&&K.splice(se,1),K}function W(x,K){const re=(0,d.getFallbackTargetPlarforms)(K);for(let se=0;se<x.length;se++){const ce=x[se];if(ce.version===x[se-1]?.version){let he=se;const me=j(ce);if(me===K)for(;he>0&&x[he-1].version===ce.version;)he--;else if(re.includes(me))for(;he>0&&x[he-1].version===ce.version&&j(x[he-1])!==K;)he--;he!==se&&(x.splice(se,1),x.splice(he,0,ce))}}return x}e.sortExtensionVersions=W;function z(x,K,re,se,ce){const he=x.versions[0],me={manifest:F(K,o.Manifest),readme:F(K,o.Details),changelog:F(K,o.Changelog),license:F(K,o.License),repository:N(K),download:$(K),icon:T(K),coreTranslations:A(K)};return{identifier:{id:(0,S.getGalleryExtensionId)(x.publisher.publisherName,x.extensionName),uuid:x.extensionId},name:x.extensionName,version:K.version,displayName:x.displayName,publisherId:x.publisher.publisherId,publisher:x.publisher.publisherName,publisherDisplayName:x.publisher.displayName,publisherDomain:x.publisher.domain?{link:x.publisher.domain,verified:!!x.publisher.isDomainVerified}:void 0,description:x.shortDescription||"",installCount:O(x.statistics,"install"),rating:O(x.statistics,"averagerating"),ratingCount:O(x.statistics,"ratingcount"),categories:x.categories||[],tags:x.tags||[],releaseDate:Date.parse(x.releaseDate),lastUpdated:Date.parse(x.lastUpdated),allTargetPlatforms:re,assets:me,properties:{dependencies:M(K,u.Dependency),extensionPack:M(K,u.ExtensionPack),engine:U(K),localizedLanguages:ee(K),targetPlatform:j(K),isPreReleaseVersion:B(K)},hasPreReleaseVersion:B(he),hasReleaseVersion:se,preview:H(x.flags),telemetryData:ce}}let V=class{constructor(K,re,se,ce,he,me,ve,ge){this.requestService=re,this.logService=se,this.environmentService=ce,this.telemetryService=he,this.fileService=me,this.productService=ve,this.configurationService=ge;const we=ve.extensionsGallery;this.extensionsGalleryUrl=we&&we.serviceUrl,this.extensionsControlUrl=we&&we.controlUrl,this.commonHeadersPromise=Y(ve.version,ve,this.environmentService,this.configurationService,this.fileService,K)}api(K=""){return`${this.extensionsGalleryUrl}${K}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(K,re,se){const ce=(0,E.isBoolean)(re)?re:!1,he=(0,E.isBoolean)(re)?se:re;let me=new I().withFlags(n.IncludeAssetUri,n.IncludeStatistics,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,K.length).withFilter(s.Target,"Microsoft.VisualStudio.Code").withFilter(s.ExtensionName,...K.map(({id:we})=>we.toLowerCase()));K.every(we=>!we.version)&&(me=me.withFlags(n.IncludeAssetUri,n.IncludeStatistics,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties,n.IncludeLatestVersionOnly));const{galleryExtensions:ve}=await this.queryGallery(me,a,i.CancellationToken.None),ge=ve.map(we=>{const Re=(0,S.getGalleryExtensionId)(we.publisher.publisherName,we.extensionName);return{rawGalleryExtension:we,version:K.find(Ee=>(0,S.areSameExtensions)(Ee,{id:Re}))?.version,preRelease:ce}});return this.converToGalleryExtensions(ge,a,()=>{},he)}async getExtensions2(K){const re=[],se=[];for(const ve of K)ve.uuid?se.push(ve.uuid):re.push(ve.id.toLowerCase());let ce=new I().withFlags(n.IncludeAssetUri,n.IncludeStatistics,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties,n.IncludeLatestVersionOnly).withPage(1,K.length).withFilter(s.Target,"Microsoft.VisualStudio.Code");se.length&&(ce=ce.withFilter(s.ExtensionId,...se)),re.length&&(ce=ce.withFilter(s.ExtensionId,...re));const{galleryExtensions:he}=await this.queryGallery(ce,a,i.CancellationToken.None),me=he.map(ve=>{const ge=(0,S.getGalleryExtensionId)(ve.publisher.publisherName,ve.extensionName),we=K.find(Re=>(0,S.areSameExtensions)(Re,{id:ge,uuid:ve.extensionId}));return{rawGalleryExtension:ve,preRelease:!!we?.preRelease}});return this.converToGalleryExtensions(me,a,()=>{},i.CancellationToken.None)}async getCompatibleExtension(K,re,se){const ce=(0,d.isIExtensionIdentifier)(K)?null:K;if(ce){if((0,d.isNotWebExtensionInWebTargetPlatform)(ce.allTargetPlatforms,se))return null;if(await this.isExtensionCompatible(ce,re,se))return ce}const{id:he,uuid:me}=ce?ce.identifier:K;let ve=new I().withFlags(n.IncludeAssetUri,n.IncludeStatistics,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,1).withFilter(s.Target,"Microsoft.VisualStudio.Code");me?ve=ve.withFilter(s.ExtensionId,me):ve=ve.withFilter(s.ExtensionName,he);const{galleryExtensions:ge}=await this.queryGallery(ve,se,i.CancellationToken.None),[we]=ge;if(!we||!we.versions.length)return null;const Re=Z(we);if((0,d.isNotWebExtensionInWebTargetPlatform)(Re,se))return null;for(let Ee of we.versions){if(!U(Ee)){const ke=await this.getEngine(Ee);Ee={...Ee,properties:[...Ee.properties||[],{key:u.Engine,value:ke}]}}if(await this.isRawExtensionVersionCompatible(Ee,re,Re,se)){const ke=we.versions.some(Le=>!B(Le));return z(we,Ee,Re,ke)}}return null}async isExtensionCompatible(K,re,se){if(!(0,d.isTargetPlatformCompatible)(K.properties.targetPlatform,K.allTargetPlatforms,se)||!re&&K.properties.isPreReleaseVersion)return!1;let ce=K.properties.engine;if(!ce){const he=await this.getManifest(K,i.CancellationToken.None);if(!he)throw new Error("Manifest was not found");ce=he.engines.vscode}return(0,h.isEngineValid)(ce,this.productService.version,this.productService.date)}async isRawExtensionVersionCompatible(K,re,se,ce){if(!(0,d.isTargetPlatformCompatible)(j(K),se,ce)||!re&&B(K))return!1;const he=await this.getEngine(K);return(0,h.isEngineValid)(he,this.productService.version,this.productService.date)}async query(K,re){if(!this.isEnabled())throw new Error("No extension gallery service configured.");let se=K.text||"";const ce=(0,_.getOrDefault)(K,Ee=>Ee.pageSize,50);let he=new I().withFlags(n.IncludeLatestVersionOnly,n.IncludeAssetUri,n.IncludeStatistics,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,ce).withFilter(s.Target,"Microsoft.VisualStudio.Code");se?(se=se.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Ee,ke,Le)=>(he=he.withFilter(s.Category,Le||ke),"")),se=se.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Ee,ke,Le)=>(he=he.withFilter(s.Tag,Le||ke),"")),se=se.replace(/\bfeatured(\s+|\b|$)/g,()=>(he=he.withFilter(s.Featured),"")),se=se.trim(),se&&(se=se.length<200?se:se.substring(0,200),he=he.withFilter(s.SearchText,se)),he=he.withSortBy(0)):K.ids?he=he.withFilter(s.ExtensionId,...K.ids):K.names?he=he.withFilter(s.ExtensionName,...K.names):he=he.withSortBy(4),typeof K.sortBy=="number"&&(he=he.withSortBy(K.sortBy)),typeof K.sortOrder=="number"&&(he=he.withSortOrder(K.sortOrder));const{galleryExtensions:me,total:ve}=await this.queryGallery(he,a,re),ge=Ee=>({index:(he.pageNumber-1)*he.pageSize+Ee,querySource:K.source}),we=await this.converToGalleryExtensions(me.map(Ee=>({rawGalleryExtension:Ee,preRelease:!!K.includePreRelease})),a,ge,re),Re=async(Ee,ke)=>{if(ke.isCancellationRequested)throw(0,D.canceled)();const Le=he.withPage(Ee+1),{galleryExtensions:Fe}=await this.queryGallery(Le,a,ke);return await this.converToGalleryExtensions(Fe.map($e=>({rawGalleryExtension:$e,preRelease:!!K.includePreRelease})),a,ge,re)};return{firstPage:we,total:ve,pageSize:he.pageSize,getPage:Re}}async converToGalleryExtensions(K,re,se,ce){const he=(ge,we,Re,Ee)=>{const ke=Z(ge);let Le=ge.versions[0];return Le=ge.versions.find(Fe=>Fe.version===Le.version&&(0,d.isTargetPlatformCompatible)(j(Fe),ke,re))||Le,B(Le)&&!Ee&&(Le=ge.versions.find(Fe=>Fe.version!==Le.version&&!B(Fe))||Le),z(ge,Le,ke,Re,se(we))},me=[],ve=new Map;for(let ge=0;ge<K.length;ge++){const{rawGalleryExtension:we,version:Re,preRelease:Ee}=K[ge],ke=we.versions.some(Le=>!B(Le));if(Re){const Le=we.versions.find(Fe=>Fe.version===Re);Le&&me.push([ge,z(we,Le,Z(we),ke)])}else{const Le=he(we,ge,ke,Ee);Le.properties.isPreReleaseVersion?ve.set(Le.identifier.uuid,{index:ge,preRelease:Ee}):me.push([ge,Le])}}if(ve.size){const ge=new Date().getTime(),we=new I().withFlags(n.IncludeVersions,n.IncludeAssetUri,n.IncludeStatistics,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,ve.size).withFilter(s.Target,"Microsoft.VisualStudio.Code").withFilter(s.ExtensionId,...ve.keys()),{galleryExtensions:Re}=await this.queryGallery(we,re,ce);if(this.telemetryService.publicLog2("galleryService:preReleasesQuery",{duration:new Date().getTime()-ge,count:ve.size}),Re.length!==ve.size)throw new Error("Not all extensions with latest versions are returned");for(const Ee of Re){const ke=Ee.versions.some(ze=>!B(ze)),{index:Le,preRelease:Fe}=ve.get(Ee.extensionId),$e=he(Ee,Le,ke,Fe);me.push([Le,$e])}}return me.sort((ge,we)=>ge[0]-we[0]).map(([,ge])=>ge)}async queryGallery(K,re,se){if(!this.isEnabled())throw new Error("No extension gallery service configured.");K=K.withFlags(K.flags,n.ExcludeNonValidated).withFilter(s.ExcludeWithFlags,t(n.Unpublished));const ce=await this.commonHeadersPromise,he=JSON.stringify(K.raw),me={...ce,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(he.length)},ve=new Date().getTime();let ge,we,Re=0;try{if(ge=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:he,headers:me},se),ge.res.statusCode&&ge.res.statusCode>=400&&ge.res.statusCode<500)return{galleryExtensions:[],total:Re};const Ee=await(0,w.asJson)(ge);if(Ee){const ke=Ee.results[0],Le=ke.extensions;Le.forEach($e=>W($e.versions,re));const Fe=ke.resultMetadata&&ke.resultMetadata.filter($e=>$e.metadataType==="ResultCount")[0];return Re=Fe&&Fe.metadataItems.filter($e=>$e.name==="TotalCount")[0].count||0,{galleryExtensions:Le,total:Re}}return{galleryExtensions:[],total:Re}}catch(Ee){throw we=Ee,Ee}finally{this.telemetryService.publicLog2("galleryService:query",{...K.telemetryData,requestBodySize:String(he.length),duration:new Date().getTime()-ve,success:!!ge&&(0,w.isSuccess)(ge),responseBodySize:ge?.res.headers["Content-Length"],statusCode:ge?String(ge.res.statusCode):void 0,errorCode:we?(0,D.isPromiseCanceledError)(we)?"canceled":(0,D.getErrorMessage)(we).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(Re)})}}async reportStatistic(K,re,se,ce){if(!this.isEnabled())return;const he=k.isWeb?this.api(`/itemName/${K}.${re}/version/${se}/statType/${ce==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${K}/extensions/${re}/${se}/stats?statType=${ce}`),me=k.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ge={...await this.commonHeadersPromise,Accept:me};try{await this.requestService.request({type:"POST",url:he,headers:ge},i.CancellationToken.None)}catch{}}async download(K,re,se){this.logService.trace("ExtensionGalleryService#download",K.identifier.id);const ce=(0,S.getGalleryExtensionTelemetryData)(K),he=new Date().getTime(),me=Re=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...ce,duration:Re}),ve=se===2?"install":se===3?"update":"",ge=ve?{uri:`${K.assets.download.uri}${C.URI.parse(K.assets.download.uri).query?"&":"?"}${ve}=true`,fallbackUri:`${K.assets.download.fallbackUri}${C.URI.parse(K.assets.download.fallbackUri).query?"&":"?"}${ve}=true`}:K.assets.download,we=await this.getAsset(ge);await this.fileService.writeFile(re,we.stream),me(new Date().getTime()-he)}async getReadme(K,re){if(K.assets.readme){const se=await this.getAsset(K.assets.readme,{},re);return await(0,w.asText)(se)||""}return""}async getManifest(K,re){if(K.assets.manifest){const se=await this.getAsset(K.assets.manifest,{},re),ce=await(0,w.asText)(se);return ce?JSON.parse(ce):null}return null}async getManifestFromRawExtensionVersion(K,re){const se=F(K,o.Manifest);if(!se)throw new Error("Manifest was not found");const ce={"Accept-Encoding":"gzip"},he=await this.getAsset(se,{headers:ce});return await(0,w.asJson)(he)}async getCoreTranslation(K,re){const se=K.assets.coreTranslations.filter(ce=>ce[0]===re.toUpperCase())[0];if(se){const ce=await this.getAsset(se[1]),he=await(0,w.asText)(ce);return he?JSON.parse(he):null}return null}async getChangelog(K,re){if(K.assets.changelog){const se=await this.getAsset(K.assets.changelog,{},re);return await(0,w.asText)(se)||""}return""}async getAllCompatibleVersions(K,re,se){let ce=new I().withFlags(n.IncludeVersions,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,1).withFilter(s.Target,"Microsoft.VisualStudio.Code");K.identifier.uuid?ce=ce.withFilter(s.ExtensionId,K.identifier.uuid):ce=ce.withFilter(s.ExtensionName,K.identifier.id);const{galleryExtensions:he}=await this.queryGallery(ce,se,i.CancellationToken.None);if(!he.length)return[];const me=Z(he[0]);if((0,d.isNotWebExtensionInWebTargetPlatform)(me,se))return[];const ve=[];for(const ge of he[0].versions)try{ve[ve.length-1]?.version!==ge.version&&await this.isRawExtensionVersionCompatible(ge,re,me,se)&&ve.push({version:ge.version,date:ge.lastUpdated,isPreReleaseVersion:B(ge)})}catch{}return ve}async getAsset(K,re={},se=i.CancellationToken.None){const ce=await this.commonHeadersPromise,he={type:"GET"},me={...ce,...re.headers||{}};re={...re,...he,headers:me};const ve=K.uri,ge=K.fallbackUri,we={...re,url:ve};try{const Re=await this.requestService.request(we,se);if(Re.res.statusCode===200)return Re;const Ee=await(0,w.asText)(Re);throw new Error(`Expected 200, got back ${Re.res.statusCode} instead.

${Ee}`)}catch(Re){if((0,D.isPromiseCanceledError)(Re))throw Re;const Ee=(0,D.getErrorMessage)(Re);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:ve,message:Ee});const ke={...re,url:ge};return this.requestService.request(ke,se)}}async getEngine(K){let re=U(K);if(!re){const se=await this.getManifestFromRawExtensionVersion(K,i.CancellationToken.None);if(!se)throw new Error("Manifest was not found");re=se.engines.vscode}return re}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[]};const K=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},i.CancellationToken.None);if(K.res.statusCode!==200)throw new Error("Could not get extensions report.");const re=await(0,w.asJson)(K),se=[],ce={};if(re){for(const he of re.malicious)se.push({id:he});if(re.unsupported)for(const he of Object.keys(re.unsupported)){const me=re.unsupported[he];(0,E.isBoolean)(me)||(ce[he.toLowerCase()]=me.preReleaseExtension)}}return{malicious:se,unsupportedPreReleaseExtensions:ce}}};V=de([J(1,w.IRequestService),J(2,p.ILogService),J(3,b.IEnvironmentService),J(4,l.ITelemetryService),J(5,y.IFileService),J(6,m.IProductService),J(7,P.IConfigurationService)],V);let q=class extends V{constructor(K,re,se,ce,he,me,ve,ge){super(K,re,se,ce,he,me,ve,ge)}};q=de([J(0,c.IStorageService),J(1,w.IRequestService),J(2,p.ILogService),J(3,b.IEnvironmentService),J(4,l.ITelemetryService),J(5,y.IFileService),J(6,m.IProductService),J(7,P.IConfigurationService)],q),e.ExtensionGalleryService=q;let G=class extends V{constructor(K,re,se,ce,he,me,ve){super(void 0,K,re,se,ce,he,me,ve)}};G=de([J(0,w.IRequestService),J(1,p.ILogService),J(2,b.IEnvironmentService),J(3,l.ITelemetryService),J(4,y.IFileService),J(5,m.IProductService),J(6,P.IConfigurationService)],G),e.ExtensionGalleryServiceWithNoStorageService=G;async function Y(x,K,re,se,ce,he){const me={"X-Market-Client-Id":`VSCode ${x}`,"User-Agent":`VSCode ${x} (${K.nameShort})`},ve=await(0,g.getServiceMachineId)(re,ce,he);return(0,r.supportsTelemetry)(K,re)&&(0,r.getTelemetryLevel)(se)===3&&(me["X-Market-User-Id"]=ve),me}e.resolveMarketplaceHeaders=Y}),define(te[93],ne([0,1,2,11,8,43]),function(Q,e,L,i,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let k=class extends L.Disposable{constructor(E,C,P=""){super();this.prefix=P;const b=E.getLogger(C.telemetryLogResource);b?this.logger=this._register(b):(this.logger=this._register(E.createLogger(C.telemetryLogResource)),this.logger.info("The below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("==========================================================="))}flush(){return Promise.resolve(void 0)}log(E,C){this.logger.trace(`${this.prefix}telemetry/${E}`,(0,_.validateTelemetryData)(C))}};k=de([J(0,D.ILoggerService),J(1,i.IEnvironmentService)],k),e.TelemetryLogAppender=k}),define(te[94],ne([0,1,2,28,4,25,141,21,41,86,37,22,43]),function(Q,e,L,i,D,_,k,R,E,C,P,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let S=class{constructor(p,m){this._configurationService=m,this._experimentProperties={},this._disposables=new L.DisposableStore,this._cleanupPatterns=[],this._appenders=p.appenders,this._commonProperties=p.commonProperties||Promise.resolve({}),this._piiPaths=p.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!p.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let w of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,_.escapeRegExpCharacters)(w),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._telemetryLevel===3}),this._commonProperties.then(w=>{const g=/^[a-f0-9]+$/i.test(w["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!g})})}setExperimentProperty(p,m){this._experimentProperties[p]=m}_updateTelemetryLevel(){this._telemetryLevel=(0,d.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const p=await this._commonProperties;let m=p.sessionID,w=p["common.machineId"],g=p["common.firstSessionDate"],c=p["common.msftInternal"];return{sessionId:m,machineId:w,firstSessionDate:g,msftInternal:c}}dispose(){this._disposables.dispose()}_log(p,m,w,g){return this.telemetryLevel<m?Promise.resolve(void 0):this._commonProperties.then(c=>{w=(0,i.mixin)(w,c),w=(0,i.mixin)(w,this._experimentProperties),w=(0,i.cloneAndChange)(w,l=>{if(typeof l=="string")return this._cleanupInfo(l,g)}),this._appenders.forEach(l=>l.log(p,w))},c=>{console.error(c)})}publicLog(p,m,w){return this._log(p,3,m,w)}publicLog2(p,m,w){return this.publicLog(p,m,w)}publicLogError(p,m){return this.sendErrorTelemetry?this._log(p,2,m,!0):Promise.resolve(void 0)}publicLogError2(p,m){return this.publicLogError(p,m)}_anonymizeFilePaths(p){let m=p;const w=[];for(let r of this._cleanupPatterns)for(;;){const a=r.exec(p);if(!a)break;w.push([a.index,r.lastIndex])}const g=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,c=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let l=0;for(m="";;){const r=c.exec(p);if(!r)break;!g.test(r[0])&&w.every(([a,n])=>r.index<a||r.index>=n)&&(m+=p.substring(l,r.index)+"<REDACTED: user-file-path>",l=c.lastIndex)}return l<p.length&&(m+=p.substr(l)),m}_removePropertiesWithPossibleUserInfo(p){if(!p)return p;const m=p.toLowerCase(),w=/@[a-zA-Z0-9-.]+/;return/(key|token|sig|signature|password|passwd|pwd)[="':\s]/.test(m)?"<REDACTED: secret>":w.test(m)?"<REDACTED: email>":p}_cleanupInfo(p,m){let w=p;m&&(w=this._anonymizeFilePaths(w));for(let g of this._cleanupPatterns)w=w.replace(g,"");return w=this._removePropertiesWithPossibleUserInfo(w),w}};S.IDLE_START_EVENT_NAME="UserIdleStart",S.IDLE_STOP_EVENT_NAME="UserIdleStop",S=de([J(1,R.IConfigurationService)],S),e.TelemetryService=S;function h(){const y=(0,k.localize)(0,null,C.default.nameLong),p=C.default.privacyStatementUrl?(0,k.localize)(2,null,"https://aka.ms/vscode-telemetry",C.default.privacyStatementUrl):(0,k.localize)(1,null,"https://aka.ms/vscode-telemetry"),m=D.isWeb?"":(0,k.localize)(3,null),w=(0,k.localize)(4,null),g=(0,k.localize)(5,null),c=(0,k.localize)(6,null),l=(0,k.localize)(7,null),r=`
|       | ${w} | ${g} | ${c} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,a=(0,k.localize)(8,null);return`
${y} ${p} ${m}

&nbsp;

${l}
${r}

&nbsp;

${a}
`}P.Registry.as(E.Extensions.Configuration).registerConfiguration({id:b.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,k.localize)(9,null),properties:{[b.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,k.localize)(10,null),(0,k.localize)(11,null),(0,k.localize)(12,null),(0,k.localize)(13,null)],markdownDescription:h(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),P.Registry.as(E.Extensions.Configuration).registerConfiguration({id:b.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,k.localize)(14,null),properties:{[b.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:C.default.privacyStatementUrl?(0,k.localize)(16,null,C.default.nameLong,C.default.privacyStatementUrl):(0,k.localize)(15,null,C.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,k.localize)(17,null,`\`#${b.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(te[204],ne([0,1,10,28,43]),function(Q,e,L,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AppInsightsAppender=void 0;async function _(R,E){const C=await new Promise((b,d)=>{Q(["applicationinsights"],b,d)});let P;return C.defaultClient?(P=new C.TelemetryClient(R),P.channel.setUseDiskRetryCaching(!0)):(C.setup(R).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),P=C.defaultClient),R.indexOf("AIF-")===0&&(P.config.endpointUrl=E?"https://mobile.events.data.microsoft.com/collect/v1":"https://vortex.data.microsoft.com/collect/v1"),P}class k{constructor(E,C,P,b,d){this._eventPrefix=E,this._defaultData=C,this.testCollector=b,this.mirrored=d,this._defaultData||(this._defaultData=Object.create(null)),typeof P=="function"?this._aiClient=P():this._aiClient=P,this._asyncAIClient=null}_withAIClient(E){if(!!this._aiClient){if(typeof this._aiClient!="string"){E(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=_(this._aiClient,this.testCollector??!1)),this._asyncAIClient.then(C=>{E(C)},C=>{(0,L.onUnexpectedError)(C),console.error(C)})}}log(E,C){!this._aiClient||(C=(0,i.mixin)(C,this._defaultData),C=(0,D.validateTelemetryData)(C),this.testCollector&&(C.properties["common.useragent"]=this.mirrored?"mirror-collector++":"collector++"),this._withAIClient(P=>P.trackEvent({name:this._eventPrefix+"/"+E,properties:C.properties,measurements:C.measurements})))}flush(){return this._aiClient?new Promise(E=>{this._withAIClient(C=>{C.flush({callback:()=>{this._aiClient=void 0,E(void 0)}})})}):Promise.resolve(void 0)}}e.AppInsightsAppender=k}),define(te[205],ne([0,1,17,57,21,11,8,22,92,93,94]),function(Q,e,L,i,D,_,k,R,E,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let b=class{constructor(S,h,y,p){this.configurationService=S,this.telemetryService=h,this.loggerService=y,this.environmentService=p,this.customTelemetryServices=new Map}async getCustomTelemetryService(S){if(!this.customTelemetryServices.has(S.id)){const{machineId:h,sessionId:y}=await this.telemetryService.getTelemetryInfo(),p=Object.create(null);p["common.vscodemachineid"]=h,p["common.vscodesessionid"]=y;const m=[S.id,JSON.stringify(p),S.aiKey],g=new i.Client(L.FileAccess.asFileUri("bootstrap-fork",Q).fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:m,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),c=[new E.TelemetryAppenderClient(g),new C.TelemetryLogAppender(this.loggerService,this.environmentService,`[${S.id}] `)];this.customTelemetryServices.set(S.id,new P.TelemetryService({appenders:c,sendErrorTelemetry:S.sendErrorTelemetry},this.configurationService))}return this.customTelemetryServices.get(S.id)}async publicLog(S,h,y){await(await this.getCustomTelemetryService(S)).publicLog(h,y)}async publicLogError(S,h,y){await(await this.getCustomTelemetryService(S)).publicLogError(h,y)}};b=de([J(0,D.IConfigurationService),J(1,R.ITelemetryService),J(2,k.ILoggerService),J(3,_.IEnvironmentService)],b),e.CustomEndpointTelemetryService=b}),define(te[206],ne([0,1,5,27,3,2,8]),function(Q,e,L,i,D,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let R=class extends _.Disposable{constructor(C,P){super();this._logService=P,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new D.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=C===void 0?15e3:C}createRequest(C){return new Promise((P,b)=>{const d=++this._lastRequestId;this._pendingRequests.set(d,P),this._onCreateRequest.fire({requestId:d,...C});const S=new i.CancellationTokenSource;(0,L.timeout)(this._timeout,S.token).then(()=>b(`Request ${d} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(d,[(0,_.toDisposable)(()=>S.cancel())])})}acceptReply(C,P){const b=this._pendingRequests.get(C);b?(this._pendingRequests.delete(C),(0,_.dispose)(this._pendingRequestDisposables.get(C)||[]),this._pendingRequestDisposables.delete(C),b(P)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${C}`)}};R=de([J(1,k.ILogService)],R),e.RequestStore=R}),define(te[95],ne([0,1,6]),function(Q,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.ProcessCapability=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var i;(function(p){p.Shell="terminal.integrated.shell.",p.ShellArgs="terminal.integrated.shellArgs.",p.DefaultProfile="terminal.integrated.defaultProfile.",p.Profiles="terminal.integrated.profiles."})(i=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var D;(function(p){p.ShellLinux="terminal.integrated.shell.linux",p.ShellMacOs="terminal.integrated.shell.osx",p.ShellWindows="terminal.integrated.shell.windows",p.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",p.AutomationShellLinux="terminal.integrated.automationShell.linux",p.AutomationShellMacOs="terminal.integrated.automationShell.osx",p.AutomationShellWindows="terminal.integrated.automationShell.windows",p.AutomationProfileLinux="terminal.integrated.automationProfile.linux",p.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",p.AutomationProfileWindows="terminal.integrated.automationProfile.windows",p.ShellArgsLinux="terminal.integrated.shellArgs.linux",p.ShellArgsMacOs="terminal.integrated.shellArgs.osx",p.ShellArgsWindows="terminal.integrated.shellArgs.windows",p.ProfilesWindows="terminal.integrated.profiles.windows",p.ProfilesMacOs="terminal.integrated.profiles.osx",p.ProfilesLinux="terminal.integrated.profiles.linux",p.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",p.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",p.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",p.UseWslProfiles="terminal.integrated.useWslProfiles",p.TabsEnabled="terminal.integrated.tabs.enabled",p.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",p.TabsHideCondition="terminal.integrated.tabs.hideCondition",p.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",p.TabsShowActions="terminal.integrated.tabs.showActions",p.TabsLocation="terminal.integrated.tabs.location",p.TabsFocusMode="terminal.integrated.tabs.focusMode",p.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",p.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",p.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",p.CopyOnSelection="terminal.integrated.copyOnSelection",p.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",p.FontFamily="terminal.integrated.fontFamily",p.FontSize="terminal.integrated.fontSize",p.LetterSpacing="terminal.integrated.letterSpacing",p.LineHeight="terminal.integrated.lineHeight",p.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",p.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",p.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",p.BellDuration="terminal.integrated.bellDuration",p.FontWeight="terminal.integrated.fontWeight",p.FontWeightBold="terminal.integrated.fontWeightBold",p.CursorBlinking="terminal.integrated.cursorBlinking",p.CursorStyle="terminal.integrated.cursorStyle",p.CursorWidth="terminal.integrated.cursorWidth",p.Scrollback="terminal.integrated.scrollback",p.DetectLocale="terminal.integrated.detectLocale",p.DefaultLocation="terminal.integrated.defaultLocation",p.GpuAcceleration="terminal.integrated.gpuAcceleration",p.TerminalTitleSeparator="terminal.integrated.tabs.separator",p.TerminalTitle="terminal.integrated.tabs.title",p.TerminalDescription="terminal.integrated.tabs.description",p.RightClickBehavior="terminal.integrated.rightClickBehavior",p.Cwd="terminal.integrated.cwd",p.ConfirmOnExit="terminal.integrated.confirmOnExit",p.ConfirmOnKill="terminal.integrated.confirmOnKill",p.EnableBell="terminal.integrated.enableBell",p.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",p.AllowChords="terminal.integrated.allowChords",p.AllowMnemonics="terminal.integrated.allowMnemonics",p.EnvMacOs="terminal.integrated.env.osx",p.EnvLinux="terminal.integrated.env.linux",p.EnvWindows="terminal.integrated.env.windows",p.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",p.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",p.ShowExitAlert="terminal.integrated.showExitAlert",p.SplitCwd="terminal.integrated.splitCwd",p.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",p.WordSeparators="terminal.integrated.wordSeparators",p.EnableFileLinks="terminal.integrated.enableFileLinks",p.UnicodeVersion="terminal.integrated.unicodeVersion",p.ExperimentalLinkProvider="terminal.integrated.experimentalLinkProvider",p.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",p.LocalEchoEnabled="terminal.integrated.localEchoEnabled",p.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",p.LocalEchoStyle="terminal.integrated.localEchoStyle",p.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",p.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",p.CustomGlyphs="terminal.integrated.customGlyphs",p.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",p.InheritEnv="terminal.integrated.inheritEnv",p.ShowLinkHover="terminal.integrated.showLinkHover",p.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",p.AutoReplies="terminal.integrated.autoReplies"})(D=e.TerminalSettingId||(e.TerminalSettingId={}));var _;(function(p){p.CommandPrompt="cmd",p.PowerShell="pwsh",p.Wsl="wsl",p.GitBash="gitbash"})(_=e.WindowsShellType||(e.WindowsShellType={}));var k;(function(p){p[p.Api=0]="Api",p[p.Process=1]="Process",p[p.Sequence=2]="Sequence",p[p.Config=3]="Config"})(k=e.TitleEventSource||(e.TitleEventSource={}));var R;(function(p){p.LocalPty="localPty",p.PtyHost="ptyHost",p.Log="log",p.Heartbeat="heartbeat"})(R=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,L.createDecorator)("ptyService");var E;(function(p){p.Cwd="cwd",p.InitialCwd="initialCwd",p.FixedDimensions="fixedDimensions",p.Title="title",p.ShellType="shellType",p.HasChildProcesses="hasChildProcesses",p.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",p.OverrideDimensions="overrideDimensions"})(E=e.ProcessPropertyType||(e.ProcessPropertyType={}));var C;(function(p){p[p.BeatInterval=5e3]="BeatInterval",p[p.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",p[p.SecondWaitMultiplier=1]="SecondWaitMultiplier",p[p.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(C=e.HeartbeatConstants||(e.HeartbeatConstants={}));var P;(function(p){p[p.Panel=1]="Panel",p[p.Editor=2]="Editor"})(P=e.TerminalLocation||(e.TerminalLocation={}));var b;(function(p){p.TerminalView="view",p.Editor="editor"})(b=e.TerminalLocationString||(e.TerminalLocationString={}));var d;(function(p){p.CwdDetection="cwdDetection"})(d=e.ProcessCapability||(e.ProcessCapability={}));var S;(function(p){p[p.GraceTime=6e4]="GraceTime",p[p.ShortGraceTime=6e3]="ShortGraceTime"})(S=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var h;(function(p){p[p.HighWatermarkChars=1e5]="HighWatermarkChars",p[p.LowWatermarkChars=5e3]="LowWatermarkChars",p[p.CharCountAckSize=5e3]="CharCountAckSize"})(h=e.FlowControlConstants||(e.FlowControlConstants={}));var y;(function(p){p.GitBash="Git Bash",p.Pwsh="PowerShell"})(y=e.ProfileSource||(e.ProfileSource={}))}),define(te[207],ne([0,1,6]),function(Q,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,L.createDecorator)("localPtyService")}),define(te[208],ne([0,1,33,28,9,4,32,15,20]),function(Q,e,L,i,D,_,k,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findExecutable=e.getWindowsBuildNumber=void 0;function C(){const b=/(\d+)\.(\d+)\.(\d+)/g.exec(L.release());let d=0;return b&&b.length===4&&(d=parseInt(b[3])),d}e.getWindowsBuildNumber=C;async function P(b,d,S,h=k.env,y=E.Promises.exists){if(D.isAbsolute(b))return await y(b)?b:void 0;if(d===void 0&&(d=k.cwd()),D.dirname(b)!=="."){const g=D.join(d,b);return await y(g)?g:void 0}const m=(0,i.getCaseInsensitive)(h,"PATH");if(S===void 0&&(0,R.isString)(m)&&(S=m.split(D.delimiter)),S===void 0||S.length===0){const g=D.join(d,b);return await y(g)?g:void 0}for(let g of S){let c;if(D.isAbsolute(g)?c=D.join(g,b):c=D.join(d,g,b),await y(c))return c;if(_.isWindows){let l=c+".com";if(await y(l)||(l=c+".exe",await y(l)))return l}}const w=D.join(d,b);return await y(w)?w:void 0}e.findExecutable=P}),define(te[209],ne([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var L;(function(i){i.DARK="dark",i.LIGHT="light",i.HIGH_CONTRAST="hc"})(L=e.ColorScheme||(e.ColorScheme={}))}),define(te[96],ne([0,1,47,3,2,6,37,209]),function(Q,e,L,i,D,_,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,_.createDecorator)("themeService");var E;(function(p){function m(w){return w&&typeof w=="object"&&typeof w.id=="string"}p.isThemeColor=m})(E=e.ThemeColor||(e.ThemeColor={}));function C(p){return{id:p}}e.themeColorFromId=C;var P;(function(p){function m(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(typeof t.color=="undefined"||E.isThemeColor(t.color))}p.isThemeIcon=m;const w=new RegExp(`^\\$\\((${L.CSSIcon.iconNameExpression}(?:${L.CSSIcon.iconModifierExpression})?)\\)$`);function g(t){const s=w.exec(t);if(!s)return;let[,o]=s;return{id:o}}p.fromString=g;function c(t){return{id:t}}p.fromId=c;function l(t,s){let o=t.id;const u=o.lastIndexOf("~");return u!==-1&&(o=o.substring(0,u)),s&&(o=`${o}~${s}`),{id:o}}p.modify=l;function r(t){const s=t.id.lastIndexOf("~");if(s!==-1)return t.id.substring(s+1)}p.getModifier=r;function a(t,s){return t.id===s.id&&t.color?.id===s.color?.id}p.isEqual=a;function n(t,s){return{id:t.id,color:s?C(s):void 0}}p.asThemeIcon=n,p.asClassNameArray=L.CSSIcon.asClassNameArray,p.asClassName=L.CSSIcon.asClassName,p.asCSSSelector=L.CSSIcon.asCSSSelector})(P=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=L.Codicon.file,e.FolderThemeIcon=L.Codicon.folder;function b(p){switch(p){case R.ColorScheme.DARK:return"vs-dark";case R.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=b,e.Extensions={ThemingContribution:"base.contributions.theming"};class d{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new i.Emitter}onColorThemeChange(m){return this.themingParticipants.push(m),this.onThemingParticipantAddedEmitter.fire(m),(0,D.toDisposable)(()=>{const w=this.themingParticipants.indexOf(m);this.themingParticipants.splice(w,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let S=new d;k.Registry.add(e.Extensions.ThemingContribution,S);function h(p){return S.onColorThemeChange(p)}e.registerThemingParticipant=h;class y extends D.Disposable{constructor(m){super();this.themeService=m,this.theme=m.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(w=>this.onThemeChange(w)))}onThemeChange(m){this.theme=m,this.updateStyles()}updateStyles(){}getColor(m,w){let g=this.theme.getColor(m);return g&&w&&(g=w(g,this.theme)),g?g.toString():null}}e.Themable=y}),define(te[210],ne([0,1,47,7,96]),function(Q,e,L,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function _(b,d){const S=b.map(h=>({name:h.profileName,description:k(h)}));return d&&S.push(...d.map(h=>({name:h.title,description:R(h)}))),{values:S.map(h=>h.name),markdownDescriptions:S.map(h=>h.description)}}e.createProfileSchemaEnums=_;function k(b){let d=`$(${D.ThemeIcon.isThemeIcon(b.icon)?b.icon.id:b.icon?b.icon:L.Codicon.terminal.id}) ${b.profileName}
- path: ${b.path}`;return b.args&&(typeof b.args=="string"?d+=`
- args: "${b.args}"`:d+=`
- args: [${b.args.length===0?"":`'${b.args.join("','")}'`}]`),b.overrideName!==void 0&&(d+=`
- overrideName: ${b.overrideName}`),b.color&&(d+=`
- color: ${b.color}`),b.env&&(d+=`
- env: ${JSON.stringify(b.env)}`),d}function R(b){return`$(${D.ThemeIcon.isThemeIcon(b.icon)?b.icon.id:b.icon?b.icon:L.Codicon.terminal.id}) ${b.title}
- extensionIdenfifier: ${b.extensionIdentifier}`}function E(b,d){if(!b&&!d)return!0;if(typeof b=="string"&&typeof d=="string")return b===d;if(Array.isArray(b)&&Array.isArray(d)){if(b.length!==d.length)return!1;for(let S=0;S<b.length;S++)if(b[S]!==d[S])return!1;return!0}return!1}e.terminalProfileArgsMatch=E;function C(b,d){if(!b&&!d)return!0;if(!b||!d)return!1;if(D.ThemeIcon.isThemeIcon(b)&&D.ThemeIcon.isThemeIcon(d))return b.id===d.id&&b.color===d.color;if(typeof b=="object"&&b&&"light"in b&&"dark"in b&&typeof d=="object"&&d&&"light"in d&&"dark"in d){const S=b,h=d;if((i.URI.isUri(S.light)||P(S.light))&&(i.URI.isUri(S.dark)||P(S.dark))&&(i.URI.isUri(h.light)||P(h.light))&&(i.URI.isUri(h.dark)||P(h.dark)))return S.light.path===h.light.path&&S.dark.path===h.dark.path}if(i.URI.isUri(b)&&i.URI.isUri(d)||P(b)||P(d)){const S=b,h=d;return S.path===h.path&&S.scheme===h.scheme}return!1}e.terminalIconsEqual=C;function P(b){return b?typeof b.path=="string"&&typeof b.scheme=="string":!1}e.isUriComponents=P}),define(te[211],ne([0,1,47,142,41,37,210]),function(Q,e,L,i,D,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=void 0;const R={args:{description:(0,i.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,i.localize)(1,null),type:"boolean"},icon:{description:(0,i.localize)(2,null),type:"string",enum:Array.from(L.Codicon.getAll(),c=>c.id),markdownEnumDescriptions:Array.from(L.Codicon.getAll(),c=>`$(${c.id})`)},color:{description:(0,i.localize)(3,null),type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},env:{markdownDescription:(0,i.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},E={type:"object",required:["path"],properties:{path:{description:(0,i.localize)(5,null),type:["string","array"],items:{type:"string"}},...R}},C={type:"object",required:["path"],properties:{path:{description:(0,i.localize)(6,null),type:["string"],items:{type:"string"}},...R}},P=(0,i.localize)(7,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),b=(0,i.localize)(8,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),d=(0,i.localize)(9,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),S=(0,i.localize)(10,null,"`#terminal.integrated.automationProfile.linux#`"),h=(0,i.localize)(11,null,"`#terminal.integrated.automationProfile.osx#`"),y=(0,i.localize)(12,null,"`#terminal.integrated.automationProfile.windows#`"),p={id:"terminal",order:100,title:(0,i.localize)(13,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,i.localize)(14,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:S},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,i.localize)(15,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:h},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,i.localize)(16,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:y},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,i.localize)(17,null,"#terminal.integrated.automationShell.linux#"),type:["object","null"],default:null,anyOf:[{type:"null"},C],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,description:(0,i.localize)(18,null,"#terminal.integrated.automationShell.osx#"),type:["object","null"],default:null,anyOf:[{type:"null"},C],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,description:(0,i.localize)(19,null,"#terminal.integrated.automationShell.windows#"),type:["object","null"],default:null,anyOf:[{type:"null"},C],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,i.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:P},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,i.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:b},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,i.localize)(22,null),type:["string","null"],default:null,markdownDeprecationMessage:d},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,i.localize)(23,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:P},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,i.localize)(24,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:b},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,i.localize)(25,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,i.localize)(26,null)}},{type:"string",markdownDescription:(0,i.localize)(27,null)}],default:[],markdownDeprecationMessage:d},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,i.localize)(28,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,i.localize)(29,null),enum:["PowerShell","Git Bash"]},...R}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,i.localize)(30,null),type:"string"},id:{description:(0,i.localize)(31,null),type:"string"},title:{description:(0,i.localize)(32,null),type:"string"},...R}},{type:"null"},E]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,i.localize)(33,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,i.localize)(34,null),type:"string"},id:{description:(0,i.localize)(35,null),type:"string"},title:{description:(0,i.localize)(36,null),type:"string"},...R}},{type:"null"},E]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,i.localize)(37,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,i.localize)(38,null),type:"string"},id:{description:(0,i.localize)(39,null),type:"string"},title:{description:(0,i.localize)(40,null),type:"string"},...R}},{type:"null"},E]}},["terminal.integrated.useWslProfiles"]:{description:(0,i.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,i.localize)(42,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,i.localize)(43,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,i.localize)(44,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,i.localize)(45,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function m(){_.Registry.as(D.Extensions.Configuration).registerConfiguration(p),g()}e.registerTerminalPlatformConfiguration=m;let w;function g(c,l){const r=_.Registry.as(D.Extensions.Configuration);let a;c&&(a=(0,k.createProfileSchemaEnums)(c?.profiles,l));const n=w;w={id:"terminal",order:100,title:(0,i.localize)(46,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,i.localize)(47,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:c?.os===3?a?.values:void 0,markdownEnumDescriptions:c?.os===3?a?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,i.localize)(48,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:c?.os===2?a?.values:void 0,markdownEnumDescriptions:c?.os===2?a?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,i.localize)(49,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:c?.os===1?a?.values:void 0,markdownEnumDescriptions:c?.os===1?a?.markdownDescriptions:void 0}}},r.updateConfigurations({add:[w],remove:n?[n]:[]})}e.registerTerminalDefaultProfileConfiguration=g}),define(te[212],ne([0,1,44,47,9,4,20,70,208,96]),function(Q,e,L,i,D,_,k,R,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let P,b=!0;function d(a,n,t,s,o=process.env,u,f,v,I){return u=u||{existsFile:k.SymlinkSupport.existsFile,readFile:k.Promises.readFile},_.isWindows?S(t,u,o,f,s.getValue("terminal.integrated.useWslProfiles")!==!1,a&&typeof a=="object"?{...a}:s.getValue("terminal.integrated.profiles.windows"),typeof n=="string"?n:s.getValue("terminal.integrated.defaultProfile.windows"),I,v):c(u,f,t,a&&typeof a=="object"?{...a}:s.getValue(_.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof n=="string"?n:s.getValue(_.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),I,v,o)}e.detectAvailableProfiles=d;async function S(a,n,t,s,o,u,f,v,I){const O=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),A=`${process.env.windir}\\${O?"Sysnative":"System32"}`;let N=!1;(0,E.getWindowsBuildNumber)()>=16299&&(N=!0),await p(v);const $=new Map;a&&($.set("PowerShell",{source:"PowerShell",icon:i.Codicon.terminalPowershell,isAutoDetected:!0}),$.set("Windows PowerShell",{path:`${A}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:i.Codicon.terminalPowershell,isAutoDetected:!0}),$.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),$.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),$.set("Command Prompt",{path:`${A}\\cmd.exe`,icon:i.Codicon.terminalCmd,isAutoDetected:!0})),l(u,$);const T=await h($.entries(),f,n,t,s,I);if(a||!a&&o)try{const F=await w(`${A}\\${N?"wsl":"bash"}.exe`,f);for(const M of F)(!u||!(M.profileName in u))&&T.push(M)}catch{b&&(s?.info("WSL is not installed, so could not detect WSL profiles"),b=!1)}return T}async function h(a,n,t,s=process.env,o,u){const f=[];for(const[v,I]of a){if(I===null)continue;let O,A,N;if("source"in I){const F=P?.get(I.source);if(!F)continue;O=F.paths,A=I.args||F.args,I.icon?N=y(I.icon):F.icon&&(N=F.icon)}else O=Array.isArray(I.path)?I.path:[I.path],A=_.isWindows||Array.isArray(I.args)?I.args:void 0,N=y(I.icon);const $=await u?.(O)||O.slice(),T=await r(v,n,$,t,s,A,I.env,I.overrideName,I.isAutoDetected,o);T?(T.isAutoDetected=I.isAutoDetected,T.icon=N,T.color=I.color,f.push(T)):o?.trace("profile not validated",v,O)}return f}function y(a){return typeof a=="string"?{id:a}:a}async function p(a){P&&!a||(P=new Map,P.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`,`${process.env.AllUsersProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),P.set("PowerShell",{profileName:"PowerShell",paths:a||await m(),icon:C.ThemeIcon.asThemeIcon(i.Codicon.terminalPowershell)}))}async function m(){const a=[];for await(const n of(0,R.enumeratePowerShellInstallations)())a.push(n.exePath);return a}async function w(a,n){const t=[],s=await new Promise((f,v)=>{L.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(I,O)=>{if(I)return v("Problem occurred when getting wsl distros");f(O)})});if(!s)return[];const o=new RegExp(/[\r?\n]/),u=s.split(o).filter(f=>f.trim().length>0&&f!=="");for(const f of u){if(f===""||f.startsWith("docker-desktop"))continue;const v=`${f} (WSL)`,I={profileName:v,path:a,args:["-d",`${f}`],isDefault:v===n,icon:g(f),isAutoDetected:!0};t.push(I)}return t}function g(a){return a.includes("Ubuntu")?C.ThemeIcon.asThemeIcon(i.Codicon.terminalUbuntu):a.includes("Debian")?C.ThemeIcon.asThemeIcon(i.Codicon.terminalDebian):C.ThemeIcon.asThemeIcon(i.Codicon.terminalLinux)}async function c(a,n,t,s,o,u,f,v){const I=new Map;if(t){const O=(await a.readFile("/etc/shells")).toString(),A=u||O.split(`
`).filter($=>$.trim().indexOf("#")!==0&&$.trim().length>0),N=new Map;for(const $ of A){let T=(0,D.basename)($),F=N.get(T)||0;F++,F>1&&(T=`${T} (${F})`),N.set(T,F),I.set(T,{path:$,isAutoDetected:!0})}}return l(s,I),await h(I.entries(),o,a,v,n,f)}function l(a,n){if(!!a)for(const[t,s]of Object.entries(a))s===null||!("path"in s)&&!("source"in s)?n.delete(t):(s.icon=s.icon||n.get(t)?.icon,n.set(t,s))}async function r(a,n,t,s,o,u,f,v,I,O){if(t.length===0)return Promise.resolve(void 0);const A=t.shift();if(A==="")return r(a,n,t,s,o,u,f,v,I);const N={profileName:a,path:A,args:u,env:f,overrideName:v,isAutoDetected:I,isDefault:a===n};if((0,D.basename)(A)===A){const T=o.PATH?o.PATH.split(D.delimiter):void 0;return await(0,E.findExecutable)(A,void 0,T,void 0,s.existsFile)?N:r(a,n,t,s,o,u)}return await s.existsFile((0,D.normalize)(A))?N:r(a,n,t,s,o,u,f,v,I)}}),define(te[213],ne([0,1,3,2,17,4,36,57,21,11,75,164,8,85,22,206,95,211,212]),function(Q,e,L,i,D,_,k,R,E,C,P,b,d,S,h,y,p,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var g;(function(r){r[r.MaxRestarts=5]="MaxRestarts"})(g||(g={}));let c=0,l=class extends i.Disposable{constructor(a,n,t,s,o){super();this._reconnectConstants=a,this._configurationService=n,this._environmentService=t,this._logService=s,this._telemetryService=o,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new L.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new L.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new L.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new L.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new L.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new L.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessReady=this._register(new L.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new L.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessOrphanQuestion=this._register(new L.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new L.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onDidChangeProperty=this._register(new L.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=this._register(new L.Emitter),this.onProcessExit=this._onProcessExit.event,(0,m.registerTerminalPlatformConfiguration)(),this._shellEnv=this._resolveShellEnv(),this._register((0,i.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new y.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),[this._client,this._proxy]=this._startPtyHost(),this._register(this._configurationService.onDidChangeConfiguration(async u=>{u.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this._refreshIgnoreProcessNames()}))}async initialize(){await this._refreshIgnoreProcessNames()}get _ignoreProcessNames(){return this._configurationService.getValue("terminal.integrated.ignoreProcessNames")}async _refreshIgnoreProcessNames(){return this._proxy.refreshIgnoreProcessNames?.(this._ignoreProcessNames)}async _resolveShellEnv(){if(_.isWindows)return process.env;try{return await(0,b.getResolvedShellEnv)(this._logService,{_:[]},process.env)}catch(a){return this._logService.error("ptyHost was unable to resolve shell environment",a),{}}}_startPtyHost(){const a={serverName:"Pty Host",args:["--type=ptyHost"],env:{VSCODE_LAST_PTY_ID:c,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this._reconnectConstants.scrollback}},n=(0,P.parsePtyHostPort)(this._environmentService.args,this._environmentService.isBuilt);n&&(n.break&&n.port?a.debugBrk=n.port:!n.break&&n.port&&(a.debug=n.port));const t=new R.Client(D.FileAccess.asFileUri("bootstrap-fork",Q).fsPath,a);this._onPtyHostStart.fire(),k.ProxyChannel.toService(t.getChannel(p.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(t.onDidProcessExit(f=>{this._telemetryService.publicLog("ptyHost/exit"),this._onPtyHostExit.fire(f.code),this._isDisposed||(this._restartCount<=g.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${f.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${f.code}, giving up`))}));const o=t.getChannel(p.TerminalIpcChannels.Log);S.LogLevelChannelClient.setLevel(o,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{S.LogLevelChannelClient.setLevel(o,this._logService.getLevel())}));const u=k.ProxyChannel.toService(t.getChannel(p.TerminalIpcChannels.PtyHost));return this._register(u.onProcessData(f=>this._onProcessData.fire(f))),this._register(u.onProcessReady(f=>this._onProcessReady.fire(f))),this._register(u.onProcessExit(f=>this._onProcessExit.fire(f))),this._register(u.onDidChangeProperty(f=>this._onDidChangeProperty.fire(f))),this._register(u.onProcessReplay(f=>this._onProcessReplay.fire(f))),this._register(u.onProcessOrphanQuestion(f=>this._onProcessOrphanQuestion.fire(f))),this._register(u.onDidRequestDetach(f=>this._onDidRequestDetach.fire(f))),[t,u]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(a,n,t,s,o,u,f,v,I,O,A){const N=setTimeout(()=>this._handleUnresponsiveCreateProcess(),p.HeartbeatConstants.CreateProcessTimeout),$=await this._proxy.createProcess(a,n,t,s,o,u,f,v,I,O,A);return clearTimeout(N),c=Math.max(c,$),$}updateTitle(a,n,t){return this._proxy.updateTitle(a,n,t)}updateIcon(a,n,t){return this._proxy.updateIcon(a,n,t)}attachToProcess(a){return this._proxy.attachToProcess(a)}detachFromProcess(a){return this._proxy.detachFromProcess(a)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(a){return this._proxy.start(a)}shutdown(a,n){return this._proxy.shutdown(a,n)}input(a,n){return this._proxy.input(a,n)}processBinary(a,n){return this._proxy.processBinary(a,n)}resize(a,n,t){return this._proxy.resize(a,n,t)}acknowledgeDataEvent(a,n){return this._proxy.acknowledgeDataEvent(a,n)}setUnicodeVersion(a,n){return this._proxy.setUnicodeVersion(a,n)}getInitialCwd(a){return this._proxy.getInitialCwd(a)}getCwd(a){return this._proxy.getCwd(a)}getLatency(a){return this._proxy.getLatency(a)}orphanQuestionReply(a){return this._proxy.orphanQuestionReply(a)}installAutoReply(a,n){return this._proxy.installAutoReply(a,n)}uninstallAllAutoReplies(){return this._proxy.uninstallAllAutoReplies()}uninstallAutoReply(a){return this._proxy.uninstallAutoReply(a)}getDefaultSystemShell(a){return this._proxy.getDefaultSystemShell(a)}async getProfiles(a,n,t,s=!1){const o=await this._shellEnv;return(0,w.detectAvailableProfiles)(n,t,s,this._configurationService,o,void 0,this._logService,this._resolveVariables.bind(this,a))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(a){return this._proxy.getWslPath(a)}setTerminalLayoutInfo(a){return this._proxy.setTerminalLayoutInfo(a)}async getTerminalLayoutInfo(a){return await this._proxy.getTerminalLayoutInfo(a)}async requestDetachInstance(a,n){return this._proxy.requestDetachInstance(a,n)}async acceptDetachInstanceReply(a,n){return this._proxy.acceptDetachInstanceReply(a,n)}async serializeTerminalState(a){return this._proxy.serializeTerminalState(a)}async reviveTerminalProcesses(a,n){return this._proxy.reviveTerminalProcesses(a,n)}async refreshProperty(a,n){return this._proxy.refreshProperty(a,n)}async updateProperty(a,n,t){return this._proxy.updateProperty(a,n,t)}async restartPtyHost(){this._telemetryService.publicLog("ptyHost/restart"),this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll?.(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._telemetryService.publicLog("ptyHost/responsive"),this._isResponsive=!0),this._onPtyHostResponsive.fire()}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.FirstWaitMultiplier+p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._telemetryService.publicLog("ptyHost/unresponsive"),this._isResponsive=!1),this._onPtyHostUnresponsive.fire()}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${p.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._telemetryService.publicLog("ptyHost/responsive"),this._onPtyHostUnresponsive.fire()}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(a,n){return this._resolveVariablesRequestStore.createRequest({workspaceId:a,originalText:n})}async acceptPtyHostResolvedVariables(a,n){this._resolveVariablesRequestStore.acceptReply(a,n)}};l=de([J(1,E.IConfigurationService),J(2,C.IEnvironmentService),J(3,d.ILogService),J(4,h.ITelemetryService)],l),e.PtyHostService=l}),define(te[35],ne([0,1,6]),function(Q,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,L.createDecorator)("IUriIdentityService")}),define(te[214],ne([0,1,3,2,7,11,34,14,8,35]),function(Q,e,L,i,D,_,k,R,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let P=class extends i.Disposable{constructor(d,S,h,y,p){super();this.extensionsManagementService=d,this.logService=y,this.uriIdentityService=p,this._onDidChangeExtensionsByAnotherSource=this._register(new L.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(w=>{this.installedExtensions=w.map(g=>g.identifier),this.startTimestamp=Date.now()}),this._register(d.onInstallExtension(w=>this.onInstallExtension(w))),this._register(d.onDidInstallExtensions(w=>this.onDidInstallExtensions(w))),this._register(d.onDidUninstallExtension(w=>this.onDidUninstallExtension(w)));const m=D.URI.file(h.extensionsPath);this._register(S.watch(m)),this._register(L.Event.filter(S.onDidChangeFilesRaw,w=>w.changes.some(g=>this.doesChangeAffects(g,m)))(()=>this.onDidChange()))}doesChangeAffects(d,S){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(d.resource),S)?this.uriIdentityService.extUri.isEqual(d.resource,this.uriIdentityService.extUri.joinPath(S,".obsolete"))?!0:!(d.type!==1&&d.type!==2||this.uriIdentityService.extUri.basename(d.resource).startsWith(".")):!1}onInstallExtension(d){this.addInstallingExtension(d.identifier)}onDidInstallExtensions(d){for(const S of d)this.removeInstallingExtension(S.identifier),S.local&&this.addInstalledExtension(S.identifier)}onDidUninstallExtension(d){d.error||this.removeInstalledExtension(d.identifier)}addInstallingExtension(d){this.removeInstallingExtension(d),this.installingExtensions.push(d)}removeInstallingExtension(d){this.installingExtensions=this.installingExtensions.filter(S=>!(0,k.areSameExtensions)(S,d))}addInstalledExtension(d){this.installedExtensions&&(this.removeInstalledExtension(d),this.installedExtensions.push(d))}removeInstalledExtension(d){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(S=>!(0,k.areSameExtensions)(S,d)))}async onDidChange(){if(this.installedExtensions){const d=await this.extensionsManagementService.getInstalled(1),S=d.filter(y=>[...this.installingExtensions,...this.installedExtensions].some(p=>(0,k.areSameExtensions)(p,y.identifier))?!1:y.installedTimestamp&&y.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",y.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",y.identifier.id),!1)),h=this.installedExtensions.filter(y=>this.installingExtensions.some(p=>(0,k.areSameExtensions)(p,y))?!1:d.every(p=>!(0,k.areSameExtensions)(p.identifier,y))?(this.logService.info("Detected extension removed from another source",y.id),!0):!1);this.installedExtensions=d.map(y=>y.identifier),(S.length||h.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:S,removed:h})}}};P=de([J(1,R.IFileService),J(2,_.INativeEnvironmentService),J(3,E.ILogService),J(4,C.IUriIdentityService)],P),e.ExtensionsWatcher=P}),define(te[215],ne([0,1,35,77,14,18,102,3,2]),function(Q,e,L,i,D,_,k,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class C{constructor(d){this.uri=d,this.time=C._clock++}touch(){return this.time=C._clock++,this}}C._clock=0;let P=class{constructor(d){this._fileService=d,this._dispooables=new E.DisposableStore,this._limit=2**16;const S=new Map,h=y=>{let p=S.get(y.scheme);return p===void 0&&(p=d.hasProvider(y)&&!this._fileService.hasCapability(y,1024),S.set(y.scheme,p)),p};this._dispooables.add(R.Event.any(d.onDidChangeFileSystemProviderRegistrations,d.onDidChangeFileSystemProviderCapabilities)(y=>{S.delete(y.scheme)})),this.extUri=new _.ExtUri(h),this._canonicalUris=new k.SkipList((y,p)=>this.extUri.compare(y,p,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(d){this._fileService.hasProvider(d)&&(d=(0,_.normalizePath)(d));let S=this._canonicalUris.get(d);return S?S.touch().uri.with({fragment:d.fragment}):(this._canonicalUris.set(d,new C(d)),this._checkTrim(),d)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const d=[...this._canonicalUris.entries()].sort((h,y)=>h[1].touch<y[1].touch?1:h[1].touch>y[1].touch?-1:0);C._clock=0,this._canonicalUris.clear();const S=this._limit*.5;for(let h=0;h<S;h++)this._canonicalUris.set(d[h][0],d[h][1].touch())}};P=de([J(0,D.IFileService)],P),e.UriIdentityService=P,(0,i.registerSingleton)(L.IUriIdentityService,P,!0)}),define(te[52],ne([0,1,54]),function(Q,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function i(k,R,E,C){const P=(0,L.setProperty)(k,R,E,C)[0];return P&&(k=k.substring(0,P.offset)+P.content+k.substring(P.offset+P.length)),k}e.edit=i;function D(k,R,E){let C=E;for(;C>=0;){if(k.charAt(C)===R.charAt(R.length-1)&&R.length===1)return C+1;if(C--,R.length===2&&C>=0&&k.charAt(C)===R.charAt(0))return C+2}return 0}e.getLineStartOffset=D;function _(k,R,E){let C=E;for(;C>=0;)if(k.charAt(C)===R.charAt(R.length-1)&&R.length===1||(C++,R.length===2&&C>=0&&k.charAt(C)===R.charAt(1)))return C;return k.length-1}e.getLineEndOffset=_}),define(te[216],ne([0,1,28,61,15]),function(Q,e,L,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function _(d,S,h,y,p){const m=[],w=[],g=[];if(!S){const A=d.filter(({identifier:N})=>p.every($=>$.toLowerCase()!==N.id.toLowerCase()));return{local:{added:m,removed:w,updated:g},remote:A.length>0?{added:A,updated:[],removed:[],all:A}:null}}d=d.map(P),S=S.map(P),h=h?h.map(P):null;const c=new Map,l=A=>{A.uuid&&c.set(A.id.toLowerCase(),A.uuid)};d.forEach(({identifier:A})=>l(A)),S.forEach(({identifier:A})=>l(A)),h&&h.forEach(({identifier:A})=>l(A));const r=A=>{const N=A.identifier.uuid||c.get(A.identifier.id.toLowerCase());return N?`uuid:${N}`:`id:${A.identifier.id.toLowerCase()}`},a=(A,N)=>(A.set(r(N),N),A),n=d.reduce(a,new Map),t=S.reduce(a,new Map),s=S.reduce((A,N)=>{const $=r(N);N=(0,L.deepClone)(N);const T=n.get($);return T&&(T.installed&&(N.installed=!0),N.version||(N.version=T.version)),a(A,N)},new Map),o=h?h.reduce(a,new Map):null,u=y.reduce(a,new Map),f=p.reduce((A,N)=>{const $=c.get(N.toLowerCase());return A.add($?`uuid:${$}`:`id:${N.toLowerCase()}`)},new Set),v=k(n,t,f);if(v.added.size>0||v.removed.size>0||v.updated.size>0){const A=k(o,n,f),N=k(o,t,f),$=(T,F)=>{const M=n.get(T);if(M){const U=t.get(T),B=F?U:M;return{...B,version:(U.version&&i.gt(U.version,M.version),M.version),state:R(M,U,o?.get(T)),preRelease:(0,D.isUndefined)(B.preRelease)?M.preRelease:B.preRelease}}};for(const T of N.removed.values()){const F=n.get(T);F&&w.push(F.identifier)}for(const T of N.added.values())if(A.added.has(T)){if(v.updated.has(T)){const F=$(T,!0);F&&(g.push(b(F,T)),s.set(T,F))}}else{const F=t.get(T);F.installed&&m.push(b(F,T))}for(const T of N.updated.values()){const F=$(T,!0);F&&(g.push(b(F,T)),s.set(T,F))}for(const T of A.added.values())N.added.has(T)||s.set(T,n.get(T));for(const T of A.updated.values())if(!N.removed.has(T)&&!N.updated.has(T)){const F=$(T,!1);F&&(s.get(T)?.installed&&(F.installed=!0),s.set(T,F))}for(const T of A.removed.values())!u.has(T)&&!N.updated.has(T)&&o?.get(T)?.installed&&s.delete(T)}const I=[],O=k(t,s,new Set,{checkInstalledProperty:!0,checkVersionProperty:!0});return(O.added.size>0||O.updated.size>0||O.removed.size>0)&&s.forEach((A,N)=>I.push(b(A,N))),{local:{added:m,removed:w,updated:g},remote:I.length?{added:[...O.added].map(A=>s.get(A)),updated:[...O.updated].map(A=>s.get(A)),removed:[...O.removed].map(A=>t.get(A)),all:I}:null}}e.merge=_;function k(d,S,h,{checkInstalledProperty:y,checkVersionProperty:p}={checkInstalledProperty:!1,checkVersionProperty:!1}){const m=d?[...d.keys()].filter(r=>!h.has(r)):[],w=[...S.keys()].filter(r=>!h.has(r)),g=w.filter(r=>m.indexOf(r)===-1).reduce((r,a)=>(r.add(a),r),new Set),c=m.filter(r=>w.indexOf(r)===-1).reduce((r,a)=>(r.add(a),r),new Set),l=new Set;for(const r of m){if(c.has(r))continue;const a=d.get(r),n=S.get(r);(!n||a.disabled!==n.disabled||a.preRelease!==n.preRelease||!C(a.state,n.state)||p&&a.version!==n.version||y&&a.installed!==n.installed)&&l.add(r)}return{added:g,removed:c,updated:l}}function R(d,S,h){const y=d.state,p=S.state,m=h?.state;if(!S.version||y&&i.gt(d.version,S.version))return y;if(p&&i.gt(S.version,d.version)||!y)return p;if(!p)return y;const w=(0,L.deepClone)(y),g=m?E(m,p):{added:Object.keys(p).reduce((l,r)=>(l.add(r),l),new Set),removed:new Set,updated:new Set},c=m?E(m,y):{added:Object.keys(y).reduce((l,r)=>(l.add(r),l),new Set),removed:new Set,updated:new Set};for(const l of[...g.added.values(),...g.updated.values()])w[l]=p[l];for(const l of g.removed.values())c.updated.has(l)||delete w[l];return w}function E(d,S){const h=Object.keys(d),y=Object.keys(S),p=y.filter(g=>h.indexOf(g)===-1).reduce((g,c)=>(g.add(c),g),new Set),m=h.filter(g=>y.indexOf(g)===-1).reduce((g,c)=>(g.add(c),g),new Set),w=new Set;for(const g of h){if(m.has(g))continue;const c=d[g],l=S[g];(0,L.equals)(c,l)||w.add(g)}return{added:p,removed:m,updated:w}}function C(d={},S={}){const{added:h,removed:y,updated:p}=E(d,S);return h.size===0&&y.size===0&&p.size===0}function P(d){return{...d,disabled:!!d.disabled,installed:!!d.installed}}function b(d,S){const h={identifier:{id:d.identifier.id,uuid:S.startsWith("uuid:")?S.substring("uuid:".length):void 0},preRelease:!!d.preRelease};return d.version&&(h.version=d.version),d.disabled&&(h.disabled=!0),d.installed&&(h.installed=!0),d.state&&(h.state=d.state),h}}),define(te[97],ne([0,1,16,3,2,34,6,26,23]),function(Q,e,L,i,D,_,k,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsStorageSyncService=e.IExtensionsStorageSyncService=void 0,e.IExtensionsStorageSyncService=(0,k.createDecorator)("IExtensionsStorageSyncService");const C=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let P=class it extends D.Disposable{constructor(d,S){super();this.storageService=d,this.productService=S,this._onDidChangeExtensionsStorage=this._register(new i.Emitter),this.onDidChangeExtensionsStorage=this._onDidChangeExtensionsStorage.event,this.extensionsWithKeysForSync=new Set,this.initialize(),this._register(this.storageService.onDidChangeValue(h=>this.onDidChangeStorageValue(h)))}static toKey(d){return`extensionKeys/${(0,_.adoptToGalleryExtensionId)(d.id)}@${d.version}`}static fromKey(d){const S=C.exec(d);if(S&&S[1])return{id:S[1],version:S[2]}}initialize(){const d=this.storageService.keys(0,1);for(const S of d){const h=it.fromKey(S);h&&this.extensionsWithKeysForSync.add(h.id.toLowerCase())}}onDidChangeStorageValue(d){if(d.scope!==0)return;if(this.extensionsWithKeysForSync.has(d.key.toLowerCase())){this._onDidChangeExtensionsStorage.fire();return}const S=it.fromKey(d.key);if(S){this.extensionsWithKeysForSync.add(S.id.toLowerCase()),this._onDidChangeExtensionsStorage.fire();return}}setKeysForSync(d,S){this.storageService.store(it.toKey(d),JSON.stringify(S),0,1)}getKeysForSync(d){const S=this.productService.extensionSyncedKeys?.[d.id.toLowerCase()],h=this.storageService.get(it.toKey(d),0),y=h?JSON.parse(h):void 0;return y&&S?(0,L.distinct)([...y,...S]):y||S}};P=de([J(0,E.IStorageService),J(1,R.IProductService)],P),e.ExtensionsStorageSyncService=P}),define(te[98],ne([0,1,16,21,6]),function(Q,e,L,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,D.createDecorator)("IIgnoredExtensionsManagementService");let _=class{constructor(R){this.configurationService=R}hasToNeverSyncExtension(R){return this.getConfiguredIgnoredExtensions().includes(R.toLowerCase())}hasToAlwaysSyncExtension(R){return this.getConfiguredIgnoredExtensions().includes(`-${R.toLowerCase()}`)}updateIgnoredExtensions(R,E){let C=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(P=>P.toLowerCase());return C=C.filter(P=>P!==R&&P!==`-${R}`),E&&C.push(R.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",C.length?C:void 0,1)}updateSynchronizedExtensions(R,E){let C=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(P=>P.toLowerCase());return C=C.filter(P=>P!==R&&P!==`-${R}`),E&&C.push(`-${R.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",C.length?C:void 0,1)}getIgnoredExtensions(R){const E=R.filter(d=>d.isMachineScoped).map(d=>d.identifier.id.toLowerCase()),C=this.getConfiguredIgnoredExtensions().map(d=>d.toLowerCase()),P=[],b=[];if(Array.isArray(C))for(const d of C)d.startsWith("-")?b.push(d.substring(1)):P.push(d);return(0,L.distinct)([...E,...P].filter(d=>b.indexOf(d)===-1))}getConfiguredIgnoredExtensions(){let R=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return R!==void 0||(R=this.configurationService.inspect("sync.ignoredExtensions").userValue,R!==void 0)?R:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(E=>E.toLowerCase())}};_=de([J(0,i.IConfigurationService)],_),e.IgnoredExtensionsManagementService=_}),define(te[217],ne([0,1,16,31,28,159,52]),function(Q,e,L,i,D,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function R(c){return(0,i.parse)(c)||[]}e.parseKeybindings=R;async function E(c,l,r,a,n){const t=R(c),s=R(l),o=r?R(r):null,u=[...t,...s,...o||[]].map(U=>U.key),f=await n.resolveUserBindings(u);let v=P(t,s,o,f);if(!v.hasLocalForwarded&&!v.hasRemoteForwarded)return{mergeContent:c,hasChanges:!1,hasConflicts:!1};if(!v.hasLocalForwarded&&v.hasRemoteForwarded)return{mergeContent:l,hasChanges:!0,hasConflicts:!1};if(v.hasLocalForwarded&&!v.hasRemoteForwarded)return{mergeContent:c,hasChanges:!0,hasConflicts:!1};const I=d(t),O=d(s),A=o?d(o):null,N=h(I,O,f),$=A?h(A,I,f):{added:[...I.keys()].reduce((U,B)=>(U.add(B),U),new Set),removed:new Set,updated:new Set},T=A?h(A,O,f):{added:[...O.keys()].reduce((U,B)=>(U.add(B),U),new Set),removed:new Set,updated:new Set},F=C(N,$,T);let M=c;for(const U of F.removed.values())F.conflicts.has(U)||(M=w(M,U,a));for(const U of F.added.values()){if(F.conflicts.has(U))continue;const B=O.get(U);if(B.some(ee=>ee.command!==`-${U}`&&v.conflicts.has(f[ee.key]))){F.conflicts.add(U);continue}M=m(M,B,a)}for(const U of F.updated.values()){if(F.conflicts.has(U))continue;const B=O.get(U);if(B.some(ee=>ee.command!==`-${U}`&&v.conflicts.has(f[ee.key]))){F.conflicts.add(U);continue}M=g(M,U,B,a)}return{mergeContent:M,hasChanges:!0,hasConflicts:F.conflicts.size>0}}e.merge=E;function C(c,l,r){const a=new Set,n=new Set,t=new Set,s=new Set;for(const o of l.removed.values())r.updated.has(o)&&s.add(o);for(const o of r.removed.values())s.has(o)||(l.updated.has(o)?s.add(o):n.add(o));for(const o of l.added.values())s.has(o)||r.added.has(o)&&c.updated.has(o)&&s.add(o);for(const o of r.added.values())s.has(o)||(l.added.has(o)?c.updated.has(o)&&s.add(o):a.add(o));for(const o of l.updated.values())s.has(o)||r.updated.has(o)&&c.updated.has(o)&&s.add(o);for(const o of r.updated.values())s.has(o)||(l.updated.has(o)?c.updated.has(o)&&s.add(o):t.add(o));return{added:a,removed:n,updated:t,conflicts:s}}function P(c,l,r,a){const n=new Set,t=b(c,a),s=b(l,a),o=r?b(r,a):null,u=S(t,s);if(u.added.size===0&&u.removed.size===0&&u.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const f=o?S(o,t):{added:[...t.keys()].reduce(($,T)=>($.add(T),$),new Set),removed:new Set,updated:new Set};if(f.added.size===0&&f.removed.size===0&&f.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:n,removed:n,updated:n,conflicts:n};const v=o?S(o,s):{added:[...s.keys()].reduce(($,T)=>($.add(T),$),new Set),removed:new Set,updated:new Set};if(v.added.size===0&&v.removed.size===0&&v.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const{added:I,removed:O,updated:A,conflicts:N}=C(u,f,v);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:I,removed:O,updated:A,conflicts:N}}function b(c,l){const r=new Map;for(const a of c){const n=l[a.key];let t=r.get(n);t||(t=[],r.set(n,t)),t.push(a)}return r}function d(c){const l=new Map;for(const r of c){const a=r.command[0]==="-"?r.command.substring(1):r.command;let n=l.get(a);n||(n=[],l.set(a,n)),n.push(r)}return l}function S(c,l){const r=[...c.keys()],a=[...l.keys()],n=a.filter(o=>r.indexOf(o)===-1).reduce((o,u)=>(o.add(u),o),new Set),t=r.filter(o=>a.indexOf(o)===-1).reduce((o,u)=>(o.add(u),o),new Set),s=new Set;for(const o of r){if(t.has(o))continue;const u=c.get(o).map(v=>({...v,key:o})),f=l.get(o).map(v=>({...v,key:o}));(0,L.equals)(u,f,(v,I)=>p(v,I))||s.add(o)}return{added:n,removed:t,updated:s}}function h(c,l,r){const a=[...c.keys()],n=[...l.keys()],t=n.filter(u=>a.indexOf(u)===-1).reduce((u,f)=>(u.add(f),u),new Set),s=a.filter(u=>n.indexOf(u)===-1).reduce((u,f)=>(u.add(f),u),new Set),o=new Set;for(const u of a){if(s.has(u))continue;const f=c.get(u).map(I=>({...I,key:r[I.key]})),v=l.get(u).map(I=>({...I,key:r[I.key]}));y(f,v)||o.add(u)}return{added:t,removed:s,updated:o}}function y(c,l){return!(!(0,L.equals)(c.filter(({command:r})=>r[0]!=="-"),l.filter(({command:r})=>r[0]!=="-"),(r,a)=>p(r,a))||!(0,L.equals)(c.filter(({command:r})=>r[0]==="-"),l.filter(({command:r})=>r[0]==="-"),(r,a)=>p(r,a)))}function p(c,l){if(c.command!==l.command||c.key!==l.key)return!1;const r=_.ContextKeyExpr.deserialize(c.when),a=_.ContextKeyExpr.deserialize(l.when);return!(r&&!a||!r&&a||r&&a&&!r.equals(a)||!D.equals(c.args,l.args))}function m(c,l,r){for(const a of l)c=k.edit(c,[-1],a,r);return c}function w(c,l,r){const a=R(c);for(let n=a.length-1;n>=0;n--)(a[n].command===l||a[n].command===`-${l}`)&&(c=k.edit(c,[n],void 0,r));return c}function g(c,l,r,a){const n=R(c),t=n.findIndex(s=>s.command===l||s.command===`-${l}`);for(let s=n.length-1;s>=0;s--)(n[s].command===l||n[s].command===`-${l}`)&&(c=k.edit(c,[s],void 0,a));for(let s=r.length-1;s>=0;s--)c=k.edit(c,[t],r[s],a);return c}}),define(te[218],ne([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function L(_,k,R){const E={},C={},P=new Set;if(!k)return{local:{added:E,updated:C,removed:[...P.values()]},remote:{added:_,updated:{},removed:[]},conflicts:[]};const b=i(_,k);if(b.added.size===0&&b.removed.size===0&&b.updated.size===0)return{local:{added:E,updated:C,removed:[...P.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const d=i(R,_),S=i(R,k),h={},y={},p=new Set,m=new Set;for(const w of d.removed.values())S.updated.has(w)?E[w]=k[w]:p.add(w);for(const w of S.removed.values())m.has(w)||(d.updated.has(w)?m.add(w):P.add(w));for(const w of d.updated.values())m.has(w)||(S.updated.has(w)?b.updated.has(w)&&m.add(w):y[w]=_[w]);for(const w of S.updated.values())m.has(w)||(d.updated.has(w)?b.updated.has(w)&&m.add(w):_[w]!==void 0&&(C[w]=k[w]));for(const w of d.added.values())m.has(w)||(S.added.has(w)?b.updated.has(w)&&m.add(w):h[w]=_[w]);for(const w of S.added.values())m.has(w)||(d.added.has(w)?b.updated.has(w)&&m.add(w):E[w]=k[w]);return{local:{added:E,removed:[...P.values()],updated:C},remote:{added:h,removed:[...p.values()],updated:y},conflicts:[...m.values()]}}e.merge=L;function i(_,k){const R=_?Object.keys(_):[],E=k?Object.keys(k):[],C=E.filter(d=>R.indexOf(d)===-1).reduce((d,S)=>(d.add(S),d),new Set),P=R.filter(d=>E.indexOf(d)===-1).reduce((d,S)=>(d.add(S),d),new Set),b=new Set;for(const d of R){if(P.has(d))continue;const S=_[d],h=k[d];S!==h&&b.add(d)}return{added:C,removed:P,updated:b}}function D(_,k){const{added:R,removed:E,updated:C}=i(_,k);return R.size===0&&E.size===0&&C.size===0}e.areSame=D}),define(te[24],ne([0,1,16,18,15,147,41,29,6,87,37]),function(Q,e,L,i,D,_,k,R,E,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSyncResourceFromLocalPreview=e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataSyncService=e.IUserDataSyncEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function b(){const o=P.Registry.as(k.Extensions.Configuration).getConfigurationProperties();return Object.keys(o).filter(u=>!!o[u].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=b;function d(){const o=P.Registry.as(k.Extensions.Configuration).getConfigurationProperties(),u=Object.keys(o).filter(I=>!!o[I].ignoreSync),f=Object.keys(o).filter(I=>o[I].scope===2||o[I].scope===6),v=b();return(0,L.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...u,...f,...v])}e.getDefaultIgnoredSettings=d,e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync";function S(){const o="vscode://schemas/ignoredSettings",u=P.Registry.as(k.Extensions.Configuration);u.registerConfiguration({id:"settingsSync",order:30,title:(0,_.localize)(0,null),type:"object",properties:{"settingsSync.keybindingsPerPlatform":{type:"boolean",description:(0,_.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,_.localize)(2,null),items:[{type:"string",pattern:R.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,_.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,_.localize)(4,null),default:[],scope:1,$ref:o,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const f=P.Registry.as(C.Extensions.JSONContribution),v=()=>{const I=b(),O=d().filter(T=>T!==e.CONFIGURATION_SYNC_STORE_KEY),A=Object.keys(k.allSettings.properties).filter(T=>O.indexOf(T)===-1),N=O.filter(T=>I.indexOf(T)===-1),$={items:{type:"string",enum:[...A,...N.map(T=>`-${T}`)]}};f.registerSchema(o,$)};return u.onDidUpdateConfiguration(()=>v())}e.registerConfiguration=S;function h(o){return o&&(0,D.isObject)(o)&&(0,D.isString)(o.id)&&(0,D.isArray)(o.scopes)}e.isAuthenticationProvider=h;var y;(function(o){o.Settings="settings",o.Keybindings="keybindings",o.Snippets="snippets",o.Extensions="extensions",o.GlobalState="globalState"})(y=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","extensions","globalState"];function p(o,u,f){return f.joinPath(u.userDataSyncHome,o,`lastSync${o}.json`)}e.getLastSyncResourceUri=p,e.IUserDataSyncStoreManagementService=(0,E.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,E.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,E.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function m(o){const u={};return u[e.HEADER_EXECUTION_ID]=o,u}e.createSyncHeaders=m;var w;(function(o){o.Unauthorized="Unauthorized",o.Conflict="Conflict",o.Gone="Gone",o.PreconditionFailed="PreconditionFailed",o.TooLarge="TooLarge",o.UpgradeRequired="UpgradeRequired",o.PreconditionRequired="PreconditionRequired",o.TooManyRequests="RemoteTooManyRequests",o.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",o.RequestFailed="RequestFailed",o.RequestCanceled="RequestCanceled",o.RequestTimeout="RequestTimeout",o.RequestProtocolNotSupported="RequestProtocolNotSupported",o.RequestPathNotEscaped="RequestPathNotEscaped",o.RequestHeadersNotObject="RequestHeadersNotObject",o.NoRef="NoRef",o.EmptyResponse="EmptyResponse",o.TurnedOff="TurnedOff",o.SessionExpired="SessionExpired",o.ServiceChanged="ServiceChanged",o.DefaultServiceChanged="DefaultServiceChanged",o.LocalTooManyRequests="LocalTooManyRequests",o.LocalPreconditionFailed="LocalPreconditionFailed",o.LocalInvalidContent="LocalInvalidContent",o.LocalError="LocalError",o.IncompatibleLocalContent="IncompatibleLocalContent",o.IncompatibleRemoteContent="IncompatibleRemoteContent",o.UnresolvedConflicts="UnresolvedConflicts",o.Unknown="Unknown"})(w=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class g extends Error{constructor(u,f,v,I){super(u);this.code=f,this.resource=v,this.operationId=I,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=g;class c extends g{constructor(u,f,v,I,O){super(u,v,void 0,O);this.url=f,this.serverCode=I}}e.UserDataSyncStoreError=c;class l extends g{constructor(u,f){super(u,f)}}e.UserDataAutoSyncError=l,function(o){function u(f){if(f instanceof o)return f;const v=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(f.name);if(v&&v[1]){const I=v[2]==="unknown"?void 0:v[2],O=v[3]==="unknown"?void 0:v[3];return new o(f.message,v[1],I,O)}return new o(f.message,"Unknown")}o.toUserDataSyncError=u}(g=e.UserDataSyncError||(e.UserDataSyncError={}));var r;(function(o){o.Uninitialized="uninitialized",o.Idle="idle",o.Syncing="syncing",o.HasConflicts="hasConflicts"})(r=e.SyncStatus||(e.SyncStatus={}));var a;(function(o){o[o.None=0]="None",o[o.Added=1]="Added",o[o.Modified=2]="Modified",o[o.Deleted=3]="Deleted"})(a=e.Change||(e.Change={}));var n;(function(o){o.Preview="preview",o.Conflict="conflict",o.Accepted="accepted"})(n=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function t(o){return`sync.enable.${o}`}e.getEnablementKey=t,e.IUserDataSyncEnablementService=(0,E.createDecorator)("IUserDataSyncEnablementService"),e.IUserDataSyncService=(0,E.createDecorator)("IUserDataSyncService"),e.IUserDataAutoSyncService=(0,E.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,E.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,E.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview";function s(o,u){if(o.scheme!==e.USER_DATA_SYNC_SCHEME)return o=o.with({scheme:u.userDataSyncHome.scheme}),e.ALL_SYNC_RESOURCES.filter(f=>(0,i.isEqualOrParent)(o,(0,i.joinPath)(u.userDataSyncHome,f,e.PREVIEW_DIR_NAME)))[0]}e.getSyncResourceFromLocalPreview=s}),define(te[46],ne([0,1,16,5,19,27,3,31,2,25,15,7,143,21,11,14,8,45,23,22,35,24]),function(Q,e,L,i,D,_,k,R,E,C,P,b,d,S,h,y,p,m,w,g,c,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.isSyncData=void 0;function r(o){return!!(o&&o.version!==void 0&&typeof o.version=="number"&&o.content!==void 0&&typeof o.content=="string"&&(Object.keys(o).length===2||Object.keys(o).length===3&&o.machineId!==void 0&&typeof o.machineId=="string"))}e.isSyncData=r;let a=class extends E.Disposable{constructor(u,f,v,I,O,A,N,$,T,F,M){super();this.resource=u,this.fileService=f,this.environmentService=v,this.userDataSyncStoreService=O,this.userDataSyncBackupStoreService=A,this.userDataSyncEnablementService=N,this.telemetryService=$,this.logService=T,this.configurationService=F,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new k.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new k.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerThrottler=new i.ThrottledDelayer(50),this._onDidChangeLocal=this._register(new k.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.syncResourceLogLabel=(0,C.uppercaseFirstLetter)(this.resource),this.extUri=M.extUri,this.syncFolder=this.extUri.joinPath(v.userDataSyncHome,u),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,l.PREVIEW_DIR_NAME),this.lastSyncResource=(0,l.getLastSyncResourceUri)(u,v,this.extUri),this.currentMachineIdPromise=(0,m.getServiceMachineId)(v,f,I)}get status(){return this._status}get conflicts(){return this._conflicts}triggerLocalChange(){this.localChangeTriggerThrottler.trigger(()=>this.doTriggerLocalChange())}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const u=await this.syncPreviewPromise;this.syncPreviewPromise=null;const f=await this.performSync(u.remoteUserData,u.lastSyncUserData,!0,this.getUserDataSyncConfiguration());this.setStatus(f)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const u=await this.getLastSyncUserData();(u?await this.hasRemoteChanged(u):!0)&&this._onDidChangeLocal.fire()}}setStatus(u){if(this._status!==u){const f=this._status;u==="hasConflicts"&&this.telemetryService.publicLog2("sync/conflictsDetected",{source:this.resource}),f==="hasConflicts"&&u==="idle"&&this.telemetryService.publicLog2("sync/conflictsResolved",{source:this.resource}),this._status=u,this._onDidChangStatus.fire(u)}}async sync(u,f={}){await this._sync(u,!0,this.getUserDataSyncConfiguration(),f)}async preview(u,f,v={}){return this._sync(u,!1,f,v)}async apply(u,f={}){try{this.syncHeaders={...f};const v=await this.doApply(u);return this.setStatus(v),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(u,f,v,I){try{if(this.syncHeaders={...I},this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let O="idle";try{const A=await this.getLastSyncUserData(),N=await this.getLatestRemoteUserData(u,A);return O=await this.performSync(N,A,f,v),O==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):O==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(O)}}finally{this.syncHeaders={}}}async replace(u){const f=await this.resolveContent(u);if(!f)return!1;const v=this.parseSyncData(f);if(!v)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const I=await this.getLastSyncUserData(),O=await this.getLatestRemoteUserData(null,I),A=await this.isRemoteDataFromCurrentMachine(O),N=await this.generateSyncPreview({ref:O.ref,syncData:v},I,A,this.getUserDataSyncConfiguration(),_.CancellationToken.None),$=[];for(const T of N){const F=await this.getAcceptResult(T,T.remoteResource,void 0,_.CancellationToken.None),{remoteChange:M}=await this.getAcceptResult(T,T.previewResource,T.remoteContent,_.CancellationToken.None);$.push([T,{...F,remoteChange:M!==0?M:2}])}await this.applyResult(O,I,$,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async isRemoteDataFromCurrentMachine(u){const f=await this.currentMachineIdPromise;return!!u.syncData?.machineId&&u.syncData.machineId===f}async getLatestRemoteUserData(u,f){if(f){const v=u&&u.latest?u.latest[this.resource]:void 0;if(f.ref===v||v===void 0&&f.syncData===null)return f}return this.getRemoteUserData(f)}async performSync(u,f,v,I){if(u.syncData&&u.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new l.UserDataSyncError((0,d.localize)(0,null,this.resource,this.version,u.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.doSync(u,f,v,I)}catch(O){if(O instanceof l.UserDataSyncError)switch(O.code){case"LocalPreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(u,f,v,I);case"Conflict":case"PreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),u=await this.getRemoteUserData(null),f=await this.getLastSyncUserData(),this.performSync(u,f,v,I)}throw O}}async doSync(u,f,v,I){try{this.syncPreviewPromise||(this.syncPreviewPromise=(0,i.createCancelablePromise)(A=>this.doGenerateSyncResourcePreview(u,f,v,I,A)));const O=await this.syncPreviewPromise;return this.updateConflicts(O.resourcePreviews),O.resourcePreviews.some(({mergeState:A})=>A==="conflict")?"hasConflicts":v?await this.doApply(!1):"syncing"}catch(O){throw this.syncPreviewPromise=null,O}}async merge(u){return await this.updateSyncResourcePreview(u,async f=>{const v=await this.getMergeResult(f,_.CancellationToken.None);await this.fileService.writeFile(f.previewResource,D.VSBuffer.fromString(v?.content||""));const I=v&&!v.hasConflicts?await this.getAcceptResult(f,f.previewResource,void 0,_.CancellationToken.None):void 0;return f.acceptResult=I,f.mergeState=v.hasConflicts?"conflict":I?"accepted":"preview",f.localChange=I?I.localChange:v.localChange,f.remoteChange=I?I.remoteChange:v.remoteChange,f}),this.syncPreviewPromise}async accept(u,f){return await this.updateSyncResourcePreview(u,async v=>{const I=await this.getAcceptResult(v,u,f,_.CancellationToken.None);return v.acceptResult=I,v.mergeState="accepted",v.localChange=I.localChange,v.remoteChange=I.remoteChange,v}),this.syncPreviewPromise}async discard(u){return await this.updateSyncResourcePreview(u,async f=>{const v=await this.getMergeResult(f,_.CancellationToken.None);return await this.fileService.writeFile(f.previewResource,D.VSBuffer.fromString(v.content||"")),f.acceptResult=void 0,f.mergeState="preview",f.localChange=v.localChange,f.remoteChange=v.remoteChange,f}),this.syncPreviewPromise}async updateSyncResourcePreview(u,f){if(!this.syncPreviewPromise)return;let v=await this.syncPreviewPromise;const I=v.resourcePreviews.findIndex(({localResource:O,remoteResource:A,previewResource:N})=>this.extUri.isEqual(O,u)||this.extUri.isEqual(A,u)||this.extUri.isEqual(N,u));I!==-1&&(this.syncPreviewPromise=(0,i.createCancelablePromise)(async O=>{const A=[...v.resourcePreviews];return A[I]=await f(A[I]),{...v,resourcePreviews:A}}),v=await this.syncPreviewPromise,this.updateConflicts(v.resourcePreviews),v.resourcePreviews.some(({mergeState:O})=>O==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(u){if(!this.syncPreviewPromise)return"idle";const f=await this.syncPreviewPromise;return f.resourcePreviews.some(({mergeState:v})=>v==="conflict")?"hasConflicts":f.resourcePreviews.some(({mergeState:v})=>v!=="accepted")?"syncing":(await this.applyResult(f.remoteUserData,f.lastSyncUserData,f.resourcePreviews.map(v=>[v,v.acceptResult]),u),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch{}}updateConflicts(u){const f=u.filter(({mergeState:v})=>v==="conflict");(0,L.equals)(this._conflicts,f,(v,I)=>this.extUri.isEqual(v.previewResource,I.previewResource))||(this._conflicts=f,this._onDidChangeConflicts.fire(f))}async hasPreviouslySynced(){return!!await this.getLastSyncUserData()}async getRemoteSyncResourceHandles(){return(await this.userDataSyncStoreService.getAllRefs(this.resource)).map(({created:f,ref:v})=>({created:f,uri:this.toRemoteBackupResource(v)}))}async getLocalSyncResourceHandles(){return(await this.userDataSyncBackupStoreService.getAllRefs(this.resource)).map(({created:f,ref:v})=>({created:f,uri:this.toLocalBackupResource(v)}))}toRemoteBackupResource(u){return b.URI.from({scheme:l.USER_DATA_SYNC_SCHEME,authority:"remote-backup",path:`/${this.resource}/${u}`})}toLocalBackupResource(u){return b.URI.from({scheme:l.USER_DATA_SYNC_SCHEME,authority:"local-backup",path:`/${this.resource}/${u}`})}async getMachineId({uri:u}){const f=this.extUri.basename(u);if(this.extUri.isEqual(u,this.toRemoteBackupResource(f))){const{content:v}=await this.getUserData(f);if(v)return this.parseSyncData(v)?.machineId}}async resolveContent(u){const f=this.extUri.basename(u);if(this.extUri.isEqual(u,this.toRemoteBackupResource(f))){const{content:v}=await this.getUserData(f);return v}return this.extUri.isEqual(u,this.toLocalBackupResource(f))?this.userDataSyncBackupStoreService.resolveContent(this.resource,f):null}async resolvePreviewContent(u){const f=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(f)for(const v of f.resourcePreviews){if(this.extUri.isEqual(v.acceptedResource,u))return v.acceptResult?v.acceptResult.content:null;if(this.extUri.isEqual(v.remoteResource,u))return v.remoteContent;if(this.extUri.isEqual(v.localResource,u))return v.localContent}return null}async resetLocal(){try{await this.fileService.del(this.lastSyncResource)}catch{}}async doGenerateSyncResourcePreview(u,f,v,I,O){const A=await this.isRemoteDataFromCurrentMachine(u),N=await this.generateSyncPreview(u,f,A,I,O),$=[];for(const T of N){const F=T.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(T.localChange===0&&T.remoteChange===0)$.push({...T,acceptedResource:F,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const M=v?await this.getMergeResult(T,O):void 0;if(O.isCancellationRequested)break;await this.fileService.writeFile(T.previewResource,D.VSBuffer.fromString(M?.content||""));const U=M&&!M.hasConflicts?await this.getAcceptResult(T,T.previewResource,void 0,O):void 0;$.push({...T,acceptResult:U,mergeState:M?.hasConflicts?"conflict":U?"accepted":"preview",localChange:U?U.localChange:M?M.localChange:T.localChange,remoteChange:U?U.remoteChange:M?M.remoteChange:T.remoteChange})}}return{remoteUserData:u,lastSyncUserData:f,resourcePreviews:$,isLastSyncFromCurrentMachine:A}}async getLastSyncUserData(){try{const u=await this.fileService.readFile(this.lastSyncResource),f=JSON.parse(u.value.toString()),v=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=f.version&&v&&f.version!==v,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${f.version} is not compatible with current sync state version ${v}.`),await this.resetLocal(),null;const I=f;if(I.content===null)return{ref:f.ref,syncData:null};const O=JSON.parse(I.content);if(r(O))return{...f,syncData:O,content:void 0}}catch(u){u instanceof y.FileOperationError&&u.fileOperationResult===1||this.logService.error(u)}return null}async updateLastSyncUserData(u,f={}){if(f.ref||f.content||f.version)throw new Error("Cannot have core properties as additional");const v=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource),I={ref:u.ref,content:u.syncData?JSON.stringify(u.syncData):null,version:v,...f};await this.fileService.writeFile(this.lastSyncResource,D.VSBuffer.fromString(JSON.stringify(I)))}async getRemoteUserData(u){const{ref:f,content:v}=await this.getUserData(u);let I=null;return v!==null&&(I=this.parseSyncData(v)),{ref:f,syncData:I}}parseSyncData(u){try{const f=JSON.parse(u);if(r(f))return f}catch(f){this.logService.error(f)}throw new l.UserDataSyncError((0,d.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async getUserData(u){if((0,P.isString)(u)){const f=await this.userDataSyncStoreService.resolveContent(this.resource,u);return{ref:u,content:f}}else{const f=u?{ref:u.ref,content:u.syncData?JSON.stringify(u.syncData):null}:null;return this.userDataSyncStoreService.read(this.resource,f,this.syncHeaders)}}async updateRemoteUserData(u,f){const v=await this.currentMachineIdPromise,I={version:this.version,machineId:v,content:u};return f=await this.userDataSyncStoreService.write(this.resource,JSON.stringify(I),f,this.syncHeaders),{ref:f,syncData:I}}async backupLocal(u){const f={version:this.version,content:u};return this.userDataSyncBackupStoreService.backup(this.resource,JSON.stringify(f))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}getUserDataSyncConfiguration(){return this.configurationService.getValue(l.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};a=de([J(1,y.IFileService),J(2,h.IEnvironmentService),J(3,w.IStorageService),J(4,l.IUserDataSyncStoreService),J(5,l.IUserDataSyncBackupStoreService),J(6,l.IUserDataSyncEnablementService),J(7,g.ITelemetryService),J(8,l.IUserDataSyncLogService),J(9,S.IConfigurationService),J(10,c.IUriIdentityService)],a),e.AbstractSynchroniser=a;let n=class extends a{constructor(u,f,v,I,O,A,N,$,T,F,M,U){super(f,v,I,O,A,N,$,T,F,M,U);this.file=u,this._register(this.fileService.watch(this.extUri.dirname(u))),this._register(this.fileService.onDidFilesChange(B=>this.onFileChanges(B)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch{return null}}async updateLocalFileContent(u,f,v){try{f?await this.writeFileContent(u,f,v):await this.fileService.createFile(this.file,D.VSBuffer.fromString(u),{overwrite:v})}catch(I){throw I instanceof y.FileOperationError&&I.fileOperationResult===1||I instanceof y.FileOperationError&&I.fileOperationResult===3?new l.UserDataSyncError(I.message,"LocalPreconditionFailed"):I}}async writeFileContent(u,f,v){await this.fileService.writeFile(this.file,D.VSBuffer.fromString(u),v?void 0:f)}onFileChanges(u){!u.contains(this.file)||this.triggerLocalChange()}};n=de([J(2,y.IFileService),J(3,h.IEnvironmentService),J(4,w.IStorageService),J(5,l.IUserDataSyncStoreService),J(6,l.IUserDataSyncBackupStoreService),J(7,l.IUserDataSyncEnablementService),J(8,g.ITelemetryService),J(9,l.IUserDataSyncLogService),J(10,S.IConfigurationService),J(11,c.IUriIdentityService)],n),e.AbstractFileSynchroniser=n;let t=class extends n{constructor(u,f,v,I,O,A,N,$,T,F,M,U,B){super(u,f,v,I,O,A,N,$,T,F,U,B);this.userDataSyncUtilService=M,this._formattingOptions=void 0}hasErrors(u){const f=[];return(0,R.parse)(u,f,{allowEmptyContent:!0,allowTrailingComma:!0}),f.length>0}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};t=de([J(2,y.IFileService),J(3,h.IEnvironmentService),J(4,w.IStorageService),J(5,l.IUserDataSyncStoreService),J(6,l.IUserDataSyncBackupStoreService),J(7,l.IUserDataSyncEnablementService),J(8,g.ITelemetryService),J(9,l.IUserDataSyncLogService),J(10,l.IUserDataSyncUtilService),J(11,S.IConfigurationService),J(12,c.IUriIdentityService)],t),e.AbstractJsonFileSynchroniser=t;let s=class{constructor(u,f,v,I,O){this.resource=u,this.environmentService=f,this.logService=v,this.fileService=I,this.extUri=O.extUri,this.lastSyncResource=(0,l.getLastSyncResourceUri)(this.resource,f,this.extUri)}async initialize({ref:u,content:f}){if(!f){this.logService.info("Remote content does not exist.",this.resource);return}const v=this.parseSyncData(f);if(!!v)try{await this.doInitialize({ref:u,syncData:v})}catch(I){this.logService.error(I)}}parseSyncData(u){try{const f=JSON.parse(u);if(r(f))return f}catch(f){this.logService.error(f)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(u,f={}){const v={ref:u.ref,content:u.syncData?JSON.stringify(u.syncData):null,...f};await this.fileService.writeFile(this.lastSyncResource,D.VSBuffer.fromString(JSON.stringify(v)))}};s=de([J(1,h.IEnvironmentService),J(2,p.ILogService),J(3,y.IFileService),J(4,c.IUriIdentityService)],s),e.AbstractInitializer=s}),define(te[219],ne([0,1,5,27,10,3,48,25,7,21,11,29,34,14,8,23,22,35,46,216,97,98,24]),function(Q,e,L,i,D,_,k,R,E,C,P,b,d,S,h,y,p,m,w,g,c,l,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.ExtensionsSynchroniser=e.storeExtensionStorageState=e.getExtensionStorageState=void 0;async function a(u,f){const v=JSON.parse(u.content);if(u.version===1||u.version===2){const I=(await f.getInstalled(0)).filter(O=>O.isBuiltin);for(const O of v)u.version===1&&(O.enabled===!1&&(O.disabled=!0),delete O.enabled),u.version===2&&I.every(A=>!(0,d.areSameExtensions)(A.identifier,O.identifier))&&(O.installed=!0)}return v}function n(u,f,v){const I=v.get((0,d.getExtensionId)(u,f),0)||"{}";return JSON.parse(I)}e.getExtensionStorageState=n;function t(u,f,v,I){I.store((0,d.getExtensionId)(u,f),JSON.stringify(v),0,1)}e.storeExtensionStorageState=t;let s=class mt extends w.AbstractSynchroniser{constructor(f,v,I,O,A,N,$,T,F,M,U,B,ee,H,j){super("extensions",v,f,I,O,A,B,ee,F,U,j);this.storageService=I,this.extensionManagementService=N,this.extensionEnablementService=$,this.ignoredExtensionsManagementService=T,this.extensionGalleryService=M,this.extensionsStorageSyncService=H,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.localResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(_.Event.debounce(_.Event.any(_.Event.filter(this.extensionManagementService.onDidInstallExtensions,Z=>Z.some(({local:W})=>!!W)),_.Event.filter(this.extensionManagementService.onDidUninstallExtension,Z=>!Z.error),this.extensionEnablementService.onDidChangeEnablement,this.extensionsStorageSyncService.onDidChangeExtensionsStorage),()=>{},500)(()=>this.triggerLocalChange()))}async generateSyncPreview(f,v){const I=f.syncData?await a(f.syncData,this.extensionManagementService):null,O=v?.skippedExtensions||[],A=v?.syncData?await a(v.syncData,this.extensionManagementService):null,N=await this.extensionManagementService.getInstalled(void 0,!0),$=this.getLocalExtensions(N),T=this.ignoredExtensionsManagementService.getIgnoredExtensions(N);I?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:F,remote:M}=(0,g.merge)($,I,A,O,T),U={local:F,remote:M,content:this.getPreviewContent($,F.added,F.updated,F.removed),localChange:F.added.length>0||F.removed.length>0||F.updated.length>0?2:0,remoteChange:M!==null?2:0};return[{skippedExtensions:O,localResource:this.localResource,localContent:this.stringify($,!1),localExtensions:$,remoteResource:this.remoteResource,remoteContent:I?this.stringify(I,!1):null,previewResource:this.previewResource,previewResult:U,localChange:U.localChange,remoteChange:U.remoteChange,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(f){const v=f.syncData?await a(f.syncData,this.extensionManagementService):null,I=await this.extensionManagementService.getInstalled(void 0,!0),O=this.getLocalExtensions(I),A=this.ignoredExtensionsManagementService.getIgnoredExtensions(I),{remote:N}=(0,g.merge)(O,v,v,f.skippedExtensions||[],A);return N!==null}getPreviewContent(f,v,I,O){const A=[...v,...I],N=new Set,$=T=>{N.add(T.id.toLowerCase()),T.uuid&&N.add(T.uuid)};A.forEach(({identifier:T})=>$(T)),O.forEach($);for(const T of f)N.has(T.identifier.id.toLowerCase())||T.identifier.uuid&&N.has(T.identifier.uuid)||A.push(T);return this.stringify(A,!1)}async getMergeResult(f,v){return{...f.previewResult,hasConflicts:!1}}async getAcceptResult(f,v,I,O){if(this.extUri.isEqual(v,this.localResource))return this.acceptLocal(f);if(this.extUri.isEqual(v,this.remoteResource))return this.acceptRemote(f);if(this.extUri.isEqual(v,this.previewResource))return f.previewResult;throw new Error(`Invalid Resource: ${v.toString()}`)}async acceptLocal(f){const v=await this.extensionManagementService.getInstalled(),I=this.ignoredExtensionsManagementService.getIgnoredExtensions(v),O=(0,g.merge)(f.localExtensions,null,null,f.skippedExtensions,I),{local:A,remote:N}=O;return{content:f.localContent,local:A,remote:N,localChange:A.added.length>0||A.removed.length>0||A.updated.length>0?2:0,remoteChange:N!==null?2:0}}async acceptRemote(f){const v=await this.extensionManagementService.getInstalled(),I=this.ignoredExtensionsManagementService.getIgnoredExtensions(v),O=f.remoteContent?JSON.parse(f.remoteContent):null;if(O!==null){const A=(0,g.merge)(f.localExtensions,O,f.localExtensions,[],I),{local:N,remote:$}=A;return{content:f.remoteContent,local:N,remote:$,localChange:N.added.length>0||N.removed.length>0||N.updated.length>0?2:0,remoteChange:$!==null?2:0}}else return{content:f.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(f,v,I,O){let{skippedExtensions:A,localExtensions:N}=I[0][0],{local:$,remote:T,localChange:F,remoteChange:M}=I[0][1];if(F===0&&M===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),F!==0&&(await this.backupLocal(JSON.stringify(N)),A=await this.updateLocalExtensions($.added,$.removed,$.updated,A)),T){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const U=JSON.stringify(T.all);f=await this.updateRemoteUserData(U,O?null:f.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${T.added.length?` Added: ${JSON.stringify(T.added.map(B=>B.identifier.id))}.`:""}${T.updated.length?` Updated: ${JSON.stringify(T.updated.map(B=>B.identifier.id))}.`:""}${T.removed.length?` Removed: ${JSON.stringify(T.removed.map(B=>B.identifier.id))}.`:""}`)}v?.ref!==f.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),await this.updateLastSyncUserData(f,{skippedExtensions:A}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${A.length?` Skipped: ${JSON.stringify(A.map(U=>U.identifier.id))}.`:""}`))}async getAssociatedResources({uri:f}){return[{resource:this.extUri.joinPath(f,"extensions.json"),comparableResource:mt.EXTENSIONS_DATA_URI}]}async resolveContent(f){if(this.extUri.isEqual(f,mt.EXTENSIONS_DATA_URI)){const I=await this.extensionManagementService.getInstalled(),O=this.ignoredExtensionsManagementService.getIgnoredExtensions(I),A=this.getLocalExtensions(I).filter(N=>!O.some($=>(0,d.areSameExtensions)({id:$},N.identifier)));return this.stringify(A,!0)}if(this.extUri.isEqual(this.remoteResource,f)||this.extUri.isEqual(this.localResource,f)||this.extUri.isEqual(this.acceptedResource,f)){const I=await this.resolvePreviewContent(f);return I&&this.stringify(JSON.parse(I),!0)}let v=await super.resolveContent(f);if(v)return v;if(v=await super.resolveContent(this.extUri.dirname(f)),v){const I=this.parseSyncData(v);if(I)switch(this.extUri.basename(f)){case"extensions.json":return this.stringify(this.parseExtensions(I),!0)}}return null}stringify(f,v){return f.sort((I,O)=>!I.identifier.uuid&&O.identifier.uuid?-1:I.identifier.uuid&&!O.identifier.uuid?1:(0,R.compare)(I.identifier.id,O.identifier.id)),v?(0,k.toFormattedString)(f,{}):JSON.stringify(f)}async hasLocalData(){try{const f=await this.extensionManagementService.getInstalled();if(this.getLocalExtensions(f).some(I=>I.installed||I.disabled))return!0}catch{}return!1}async updateLocalExtensions(f,v,I,O){const A=[],N=[],$=await this.extensionManagementService.getInstalled();if(v.length){const F=$.filter(({identifier:M,isBuiltin:U})=>!U&&v.some(B=>(0,d.areSameExtensions)(M,B)));await L.Promises.settled(F.map(async M=>{this.logService.trace(`${this.syncResourceLogLabel}: Uninstalling local extension...`,M.identifier.id),await this.extensionManagementService.uninstall(M,{donotIncludePack:!0,donotCheckDependents:!0}),this.logService.info(`${this.syncResourceLogLabel}: Uninstalled local extension.`,M.identifier.id),A.push(M.identifier)}))}(f.length||I.length)&&await L.Promises.settled([...f,...I].map(async F=>{const M=$.find(B=>(0,d.areSameExtensions)(B.identifier,F.identifier));if(M&&M.isBuiltin){F.state&&M.manifest.version===F.version&&this.updateExtensionState(F.state,M.manifest.publisher,M.manifest.name,M.manifest.version),this.extensionEnablementService.getDisabledExtensions().some(ee=>(0,d.areSameExtensions)(ee,F.identifier))!==!!F.disabled&&(F.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,F.identifier.id),await this.extensionEnablementService.disableExtension(F.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,F.identifier.id)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,F.identifier.id),await this.extensionEnablementService.enableExtension(F.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,F.identifier.id))),A.push(F.identifier);return}const U=(await this.extensionGalleryService.getExtensions([F.identifier],!!F.preRelease,i.CancellationToken.None))[0];if(F.state&&(M?M.manifest.version===F.version:!!U)){const B=M?M.manifest.publisher:U.publisher,ee=M?M.manifest.name:U.name;this.updateExtensionState(F.state,B,ee,M?.manifest.version)}if(U)try{this.extensionEnablementService.getDisabledExtensions().some(ee=>(0,d.areSameExtensions)(ee,F.identifier))!==!!F.disabled&&(F.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,F.identifier.id,U.version),await this.extensionEnablementService.disableExtension(U.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,F.identifier.id,U.version)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,F.identifier.id,U.version),await this.extensionEnablementService.enableExtension(U.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,F.identifier.id,U.version))),(!M||M.preRelease!==F.preRelease)&&(await this.extensionManagementService.canInstall(U)?(this.logService.trace(`${this.syncResourceLogLabel}: Installing extension...`,F.identifier.id,U.version),await this.extensionManagementService.installFromGallery(U,{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installPreReleaseVersion:F.preRelease}),this.logService.info(`${this.syncResourceLogLabel}: Installed extension.`,F.identifier.id,U.version),A.push(U.identifier)):(this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because it cannot be installed.`,U.displayName||U.identifier.id),N.push(F)))}catch(B){N.push(F),B instanceof b.ExtensionManagementError&&[b.ExtensionManagementErrorCode.Incompatible,b.ExtensionManagementErrorCode.IncompatiblePreRelease,b.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(B.code)?this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the compatible extension is not found.`,U.displayName||U.identifier.id):(this.logService.error(B),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension`,U.displayName||U.identifier.id))}else N.push(F),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the extension is not found.`,F.identifier.id)}));const T=[];for(const F of O)A.some(M=>(0,d.areSameExtensions)(M,F.identifier))||T.push(F);for(const F of N)T.some(M=>(0,d.areSameExtensions)(M.identifier,F.identifier))||T.push(F);return T}updateExtensionState(f,v,I,O){const A=n(v,I,this.storageService),N=O?this.extensionsStorageSyncService.getKeysForSync({id:(0,d.getGalleryExtensionId)(v,I),version:O}):void 0;N?N.forEach($=>{A[$]=f[$]}):Object.keys(f).forEach($=>A[$]=f[$]),t(v,I,A,this.storageService)}parseExtensions(f){return JSON.parse(f.content)}getLocalExtensions(f){const v=this.extensionEnablementService.getDisabledExtensions();return f.map(({identifier:I,isBuiltin:O,manifest:A,preRelease:N})=>{const $={identifier:I,preRelease:N,version:A.version};v.some(T=>(0,d.areSameExtensions)(T,I))&&($.disabled=!0),O||($.installed=!0);try{const T=this.extensionsStorageSyncService.getKeysForSync({id:I.id,version:A.version});if(T){const F=n(A.publisher,A.name,this.storageService);$.state=Object.keys(F).reduce((M,U)=>(T.includes(U)&&(M[U]=F[U]),M),{})}}catch(T){this.logService.info(`${this.syncResourceLogLabel}: Error while parsing extension state`,(0,D.getErrorMessage)(T))}return $})}};s.EXTENSIONS_DATA_URI=E.URI.from({scheme:r.USER_DATA_SYNC_SCHEME,authority:"extensions",path:"/extensions.json"}),s=de([J(0,P.IEnvironmentService),J(1,S.IFileService),J(2,y.IStorageService),J(3,r.IUserDataSyncStoreService),J(4,r.IUserDataSyncBackupStoreService),J(5,b.IExtensionManagementService),J(6,b.IGlobalExtensionEnablementService),J(7,l.IIgnoredExtensionsManagementService),J(8,r.IUserDataSyncLogService),J(9,b.IExtensionGalleryService),J(10,C.IConfigurationService),J(11,r.IUserDataSyncEnablementService),J(12,p.ITelemetryService),J(13,c.IExtensionsStorageSyncService),J(14,m.IUriIdentityService)],s),e.ExtensionsSynchroniser=s;let o=class extends w.AbstractInitializer{constructor(f,v,I,O,A,N){super("extensions",O,A,I,N);this.extensionManagementService=f,this.ignoredExtensionsManagementService=v}async parseExtensions(f){return f.syncData?await a(f.syncData,this.extensionManagementService):null}generatePreview(f,v){const I=[],O=[],A=[];for(const N of f){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension(N.identifier.id))continue;const $=v.find(T=>(0,d.areSameExtensions)(T.identifier,N.identifier));$?(I.push($),N.disabled&&A.push(N.identifier)):N.installed&&(O.push(N.identifier),N.disabled&&A.push(N.identifier))}return{installedExtensions:I,newExtensions:O,disabledExtensions:A,remoteExtensions:f}}};o=de([J(0,b.IExtensionManagementService),J(1,l.IIgnoredExtensionsManagementService),J(2,S.IFileService),J(3,P.IEnvironmentService),J(4,h.ILogService),J(5,m.IUriIdentityService)],o),e.AbstractExtensionsInitializer=o}),define(te[220],ne([0,1,28,24]),function(Q,e,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function D(R,E,C,P,b){if(!E)return{remote:Object.keys(R).length>0?R:null,local:{added:{},removed:[],updated:{}}};const d=_(R,E);if(d.added.size===0&&d.removed.size===0&&d.updated.size===0)return{remote:null,local:{added:{},removed:[],updated:{}}};const S=C?_(C,E):{added:Object.keys(E).reduce((w,g)=>(w.add(g),w),new Set),removed:new Set,updated:new Set},h=C?_(C,R):{added:Object.keys(R).reduce((w,g)=>(w.add(g),w),new Set),removed:new Set,updated:new Set},y={added:{},removed:[],updated:{}},p=L.deepClone(E),m=!C;for(const w of h.added.values())w!==i.SYNC_SERVICE_URL_TYPE&&m&&S.added.has(w)||(p[w]=R[w]);for(const w of h.updated.values())p[w]=R[w];for(const w of h.removed.values())P.unregistered.includes(w)||delete p[w];for(const w of S.added.values()){const g=E[w];if(P.machine.includes(w)){b.info(`GlobalState: Skipped adding ${w} in local storage because it is declared as machine scoped.`);continue}if(C&&h.added.has(w))continue;const c=R[w];c&&c.value===g.value||w===i.SYNC_SERVICE_URL_TYPE&&m&&h.added.has(w)||(c?y.updated[w]=g:y.added[w]=g)}for(const w of S.updated.values()){const g=E[w];if(P.machine.includes(w)){b.info(`GlobalState: Skipped updating ${w} in local storage because it is declared as machine scoped.`);continue}if(h.updated.has(w)||h.removed.has(w))continue;const c=R[w];c&&c.value===g.value||(y.updated[w]=g)}for(const w of S.removed.values()){if(P.machine.includes(w)){b.trace(`GlobalState: Skipped removing ${w} in local storage because it is declared as machine scoped.`);continue}h.updated.has(w)||h.removed.has(w)||y.removed.push(w)}return{local:y,remote:k(p,E)?null:p}}e.merge=D;function _(R,E){const C=Object.keys(R),P=Object.keys(E),b=P.filter(h=>C.indexOf(h)===-1).reduce((h,y)=>(h.add(y),h),new Set),d=C.filter(h=>P.indexOf(h)===-1).reduce((h,y)=>(h.add(y),h),new Set),S=new Set;for(const h of C){if(d.has(h))continue;const y=R[h],p=E[h];L.equals(y,p)||S.add(h)}return{added:b,removed:d,updated:S}}function k(R,E){const{added:C,removed:P,updated:b}=_(R,E);return C.size===0&&P.size===0&&b.size===0}}),define(te[221],ne([0,1,19,10,3,31,48,4,7,30,21,11,14,8,45,23,22,35,46,52,220,24]),function(Q,e,L,i,D,_,k,R,E,C,P,b,d,S,h,y,p,m,w,g,c,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.GlobalStateSynchroniser=void 0;const r="globalState.argv.",a=["locale"];function n(f,v){const I=f.storage?Object.keys(f.storage).sort():[],O={};return I.forEach(A=>O[A]=f.storage[A]),f.storage=O,v?(0,k.toFormattedString)(f,{}):JSON.stringify(f)}const t=1;let s=class vt extends w.AbstractSynchroniser{constructor(v,I,O,A,N,$,T,F,M,U){super("globalState",v,N,M,I,O,$,T,A,F,U);this.storageService=M,this.version=t,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.localResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(v.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(D.Event.any(D.Event.filter(v.onDidFilesChange,B=>B.contains(this.environmentService.argvResource)),D.Event.filter(M.onDidChangeValue,B=>B.scope===0&&B.target!==void 0?B.target===0:M.keys(0,0).includes(B.key)),this.storageService.onDidChangeTarget)(()=>this.triggerLocalChange()))}async generateSyncPreview(v,I,O){const A=v.syncData?JSON.parse(v.syncData.content):null;I=I===null&&O?v:I;const N=I&&I.syncData?JSON.parse(I.syncData.content):null,$=await this.getLocalGlobalState();A?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const T=this.getStorageKeys(N),{local:F,remote:M}=(0,c.merge)($.storage,A?A.storage:null,N?N.storage:null,T,this.logService),U={content:null,local:F,remote:M,localChange:Object.keys(F.added).length>0||Object.keys(F.updated).length>0||F.removed.length>0?2:0,remoteChange:M!==null?2:0};return[{localResource:this.localResource,localContent:n($,!1),localUserData:$,remoteResource:this.remoteResource,remoteContent:A?n(A,!1):null,previewResource:this.previewResource,previewResult:U,localChange:U.localChange,remoteChange:U.remoteChange,acceptedResource:this.acceptedResource,storageKeys:T}]}async hasRemoteChanged(v){const I=v.syncData?JSON.parse(v.syncData.content):null;if(I===null)return!0;const O=await this.getLocalGlobalState(),A=this.getStorageKeys(I),{remote:N}=(0,c.merge)(O.storage,I.storage,I.storage,A,this.logService);return N!==null}async getMergeResult(v,I){return{...v.previewResult,hasConflicts:!1}}async getAcceptResult(v,I,O,A){if(this.extUri.isEqual(I,this.localResource))return this.acceptLocal(v);if(this.extUri.isEqual(I,this.remoteResource))return this.acceptRemote(v);if(this.extUri.isEqual(I,this.previewResource))return v.previewResult;throw new Error(`Invalid Resource: ${I.toString()}`)}async acceptLocal(v){return{content:v.localContent,local:{added:{},removed:[],updated:{}},remote:v.localUserData.storage,localChange:0,remoteChange:2}}async acceptRemote(v){if(v.remoteContent!==null){const I=JSON.parse(v.remoteContent),{local:O,remote:A}=(0,c.merge)(v.localUserData.storage,I.storage,null,v.storageKeys,this.logService);return{content:v.remoteContent,local:O,remote:A,localChange:Object.keys(O.added).length>0||Object.keys(O.updated).length>0||O.removed.length>0?2:0,remoteChange:A!==null?2:0}}else return{content:v.remoteContent,local:{added:{},removed:[],updated:{}},remote:null,localChange:0,remoteChange:0}}async applyResult(v,I,O,A){let{localUserData:N}=O[0][0],{local:$,remote:T,localChange:F,remoteChange:M}=O[0][1];if(F===0&&M===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),F!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(N)),await this.writeLocalGlobalState($),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),M!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const U=JSON.stringify({storage:T});v=await this.updateRemoteUserData(U,A?null:v.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state`)}I?.ref!==v.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(v),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async getAssociatedResources({uri:v}){return[{resource:this.extUri.joinPath(v,"globalState.json"),comparableResource:vt.GLOBAL_STATE_DATA_URI}]}async resolveContent(v){if(this.extUri.isEqual(v,vt.GLOBAL_STATE_DATA_URI)){const O=await this.getLocalGlobalState();return n(O,!0)}if(this.extUri.isEqual(this.remoteResource,v)||this.extUri.isEqual(this.localResource,v)||this.extUri.isEqual(this.acceptedResource,v)){const O=await this.resolvePreviewContent(v);return O&&n(JSON.parse(O),!0)}let I=await super.resolveContent(v);if(I)return I;if(I=await super.resolveContent(this.extUri.dirname(v)),I){const O=this.parseSyncData(I);if(O)switch(this.extUri.basename(v)){case"globalState.json":return n(JSON.parse(O.content),!0)}}return null}async hasLocalData(){try{const{storage:v}=await this.getLocalGlobalState();if(Object.keys(v).length>1||v[`${r}.locale`]?.value!=="en")return!0}catch{}return!1}async getLocalGlobalState(){const v={},I=await this.getLocalArgvContent(),O=(0,_.parse)(I);for(const A of a)O[A]!==void 0&&(v[`${r}${A}`]={version:1,value:O[A]});for(const A of this.storageService.keys(0,0)){const N=this.storageService.get(A,0);N&&(v[A]={version:1,value:N})}return{storage:v}}async getLocalArgvContent(){try{this.logService.debug("GlobalStateSync#getLocalArgvContent",this.environmentService.argvResource);const v=await this.fileService.readFile(this.environmentService.argvResource);return this.logService.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.environmentService.argvResource),v.value.toString()}catch(v){this.logService.debug((0,i.getErrorMessage)(v))}return"{}"}async writeLocalGlobalState({added:v,removed:I,updated:O}){const A={},N={},$=(F,M)=>{for(const U of F){if(U.startsWith(r)){A[U.substring(r.length)]=M?M[U].value:void 0;continue}if(M){const B=M[U];B.value!==String(this.storageService.get(U,0))&&(N[U]=B.value)}else this.storageService.get(U,0)!==void 0&&(N[U]=void 0)}};if($(Object.keys(v),v),$(Object.keys(O),O),$(I),Object.keys(A).length&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.updateArgv(A),this.logService.info(`${this.syncResourceLogLabel}: Updated locale`)),Object.keys(N).length){this.logService.trace(`${this.syncResourceLogLabel}: Updating global state...`);for(const F of Object.keys(N))this.storageService.store(F,N[F],0,0);this.logService.info(`${this.syncResourceLogLabel}: Updated global state`,Object.keys(N))}}async updateArgv(v){const I=await this.getLocalArgvContent();let O=I;for(const A of Object.keys(v))O=(0,g.edit)(O,[A],v[A],{});I!==O&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,L.VSBuffer.fromString(O)),this.logService.info(`${this.syncResourceLogLabel}: Updated locale.`))}getStorageKeys(v){const I=this.storageService.keys(0,0),O=this.storageService.keys(0,1),A=[...I,...O],N=v?.storage?Object.keys(v.storage).filter($=>!$.startsWith(r)&&!A.includes($)&&this.storageService.get($,0)!==void 0):[];if(!R.isWeb){const $=[...l.ALL_SYNC_RESOURCES.map(T=>(0,l.getEnablementKey)(T)),l.SYNC_SERVICE_URL_TYPE];N.push(...$),O.push(...$)}return{user:I,machine:O,unregistered:N}}};s.GLOBAL_STATE_DATA_URI=E.URI.from({scheme:l.USER_DATA_SYNC_SCHEME,authority:"globalState",path:"/globalState.json"}),s=de([J(0,d.IFileService),J(1,l.IUserDataSyncStoreService),J(2,l.IUserDataSyncBackupStoreService),J(3,l.IUserDataSyncLogService),J(4,b.IEnvironmentService),J(5,l.IUserDataSyncEnablementService),J(6,p.ITelemetryService),J(7,P.IConfigurationService),J(8,y.IStorageService),J(9,m.IUriIdentityService)],s),e.GlobalStateSynchroniser=s;let o=class extends w.AbstractInitializer{constructor(v,I,O,A,N){super("globalState",O,A,I,N);this.storageService=v}async doInitialize(v){const I=v.syncData?JSON.parse(v.syncData.content):null;if(!I){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const O={},A={};for(const N of Object.keys(I.storage))N.startsWith(r)?O[N.substring(r.length)]=I.storage[N].value:this.storageService.get(N,0)===void 0&&(A[N]=I.storage[N].value);if(Object.keys(O).length){let N="{}";try{N=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch{}for(const $ of Object.keys(O))N=(0,g.edit)(N,[$],O[$],{});await this.fileService.writeFile(this.environmentService.argvResource,L.VSBuffer.fromString(N))}if(Object.keys(A).length)for(const N of Object.keys(A))this.storageService.store(N,A[N],0,0)}};o=de([J(0,y.IStorageService),J(1,d.IFileService),J(2,b.IEnvironmentService),J(3,l.IUserDataSyncLogService),J(4,m.IUriIdentityService)],o),e.GlobalStateInitializer=o;let u=class{constructor(v,I,O,A,N){this.userDataSyncStoreClient=v,this.storageService=I,this.environmentService=O,this.fileService=A,this.logService=N}getSyncStoreType(v){return this.parseGlobalState(v)?.storage[l.SYNC_SERVICE_URL_TYPE]?.value}async sync(v){const I=(0,l.createSyncHeaders)((0,C.generateUuid)());try{return await this.doSync(v,I)}catch(O){if(O instanceof l.UserDataSyncError)switch(O.code){case"PreconditionFailed":return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(v,I)}throw O}}async doSync(v,I){const O=await this.userDataSyncStoreClient.read("globalState",null,I),A=this.parseGlobalState(O)||{storage:{}};A.storage[l.SYNC_SERVICE_URL_TYPE]={value:v,version:t};const N=await(0,h.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),$={version:t,machineId:N,content:n(A,!1)};await this.userDataSyncStoreClient.write("globalState",JSON.stringify($),O.ref,I)}parseGlobalState({content:v}){if(!v)return null;const I=JSON.parse(v);if((0,w.isSyncData)(I))return I?JSON.parse(I.content):null;throw new Error("Invalid remote data")}};u=de([J(1,y.IStorageService),J(2,b.IEnvironmentService),J(3,d.IFileService),J(4,S.ILogService)],u),e.UserDataSyncStoreTypeSynchronizer=u}),define(te[222],ne([0,1,16,19,3,31,4,15,144,21,11,14,23,22,35,46,217,24]),function(Q,e,L,i,D,_,k,R,E,C,P,b,d,S,h,y,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function w(l,r,a){try{const n=JSON.parse(l);if(!r)return(0,R.isUndefined)(n.all)?null:n.all;switch(k.OS){case 2:return(0,R.isUndefined)(n.mac)?null:n.mac;case 3:return(0,R.isUndefined)(n.linux)?null:n.linux;case 1:return(0,R.isUndefined)(n.windows)?null:n.windows}}catch(n){return a.error(n),null}}e.getKeybindingsContentFromSyncContent=w;let g=class extends y.AbstractJsonFileSynchroniser{constructor(r,a,n,t,s,o,u,f,v,I,O){super(u.keybindingsResource,"keybindings",o,u,f,r,a,s,I,n,v,t,O);this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.localResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(D.Event.filter(t.onDidChangeConfiguration,A=>A.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(r,a,n,t){const s=r.syncData?w(r.syncData.content,t.keybindingsPerPlatform??this.syncKeybindingsPerPlatform(),this.logService):null;a=a===null&&n?r:a;const o=a?this.getKeybindingsContentFromLastSyncUserData(a):null,u=await this.getLocalFileContent(),f=await this.getFormattingOptions();let v=null,I=!1,O=!1,A=!1;if(s){let $=u?u.value.toString():"[]";if($=$||"[]",this.hasErrors($))throw new m.UserDataSyncError((0,E.localize)(0,null),"LocalInvalidContent",this.resource);if(!o||o!==$||o!==s){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const T=await(0,p.merge)($,s,o,f,this.userDataSyncUtilService);T.hasChanges&&(v=T.mergeContent,A=T.hasConflicts,I=A||T.mergeContent!==$,O=A||T.mergeContent!==s)}}else u&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),v=u.value.toString(),O=!0);const N={content:v,localChange:I?u?2:1:0,remoteChange:O?2:0,hasConflicts:A};return[{fileContent:u,localResource:this.localResource,localContent:u?u.value.toString():null,localChange:N.localChange,remoteResource:this.remoteResource,remoteContent:s,remoteChange:N.remoteChange,previewResource:this.previewResource,previewResult:N,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(r){const a=this.getKeybindingsContentFromLastSyncUserData(r);if(a===null)return!0;const n=await this.getLocalFileContent(),t=n?n.value.toString():"",s=await this.getFormattingOptions(),o=await(0,p.merge)(t||"[]",a,a,s,this.userDataSyncUtilService);return o.hasConflicts||o.mergeContent!==a}async getMergeResult(r,a){return r.previewResult}async getAcceptResult(r,a,n,t){if(this.extUri.isEqual(a,this.localResource))return{content:r.fileContent?r.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(a,this.remoteResource))return{content:r.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(a,this.previewResource))return n===void 0?{content:r.previewResult.content,localChange:r.previewResult.localChange,remoteChange:r.previewResult.remoteChange}:{content:n,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${a.toString()}`)}async applyResult(r,a,n,t){const{fileContent:s}=n[0][0];let{content:o,localChange:u,remoteChange:f}=n[0][1];if(u===0&&f===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),o!==null&&(o=o.trim(),o=o||"[]",this.hasErrors(o)))throw new m.UserDataSyncError((0,E.localize)(1,null),"LocalInvalidContent",this.resource);if(u!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),s&&await this.backupLocal(this.toSyncContent(s.value.toString())),await this.updateLocalFileContent(o||"[]",s,t),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),f!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const v=this.toSyncContent(o||"[]",r.syncData?.content);r=await this.updateRemoteUserData(v,t?null:r.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch{}a?.ref!==r.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(r,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const r=await this.getLocalFileContent();if(r){const a=(0,_.parse)(r.value.toString());if((0,L.isNonEmptyArray)(a))return!0}}catch(r){if(r.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:r}){const a=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(r,"keybindings.json"),comparableResource:a}]}async resolveContent(r){if(this.extUri.isEqual(this.remoteResource,r)||this.extUri.isEqual(this.localResource,r)||this.extUri.isEqual(this.acceptedResource,r))return this.resolvePreviewContent(r);let a=await super.resolveContent(r);if(a)return a;if(a=await super.resolveContent(this.extUri.dirname(r)),a){const n=this.parseSyncData(a);if(n)switch(this.extUri.basename(r)){case"keybindings.json":return w(n.content,this.syncKeybindingsPerPlatform(),this.logService)}}return null}getKeybindingsContentFromLastSyncUserData(r){return!r.syncData||r.platformSpecific!==void 0&&r.platformSpecific!==this.syncKeybindingsPerPlatform()?null:w(r.syncData.content,this.syncKeybindingsPerPlatform(),this.logService)}toSyncContent(r,a){let n={};try{n=JSON.parse(a||"{}")}catch(t){this.logService.error(t)}switch(this.syncKeybindingsPerPlatform()?delete n.all:n.all=r,k.OS){case 2:n.mac=r;break;case 3:n.linux=r;break;case 1:n.windows=r;break}return JSON.stringify(n)}syncKeybindingsPerPlatform(){return!!this.configurationService.getValue("settingsSync.keybindingsPerPlatform")}};g=de([J(0,m.IUserDataSyncStoreService),J(1,m.IUserDataSyncBackupStoreService),J(2,m.IUserDataSyncLogService),J(3,C.IConfigurationService),J(4,m.IUserDataSyncEnablementService),J(5,b.IFileService),J(6,P.IEnvironmentService),J(7,d.IStorageService),J(8,m.IUserDataSyncUtilService),J(9,S.ITelemetryService),J(10,h.IUriIdentityService)],g),e.KeybindingsSynchroniser=g;let c=class extends y.AbstractInitializer{constructor(r,a,n,t){super("keybindings",a,n,r,t)}async doInitialize(r){const a=r.syncData?this.getKeybindingsContentFromSyncContent(r.syncData.content):null;if(!a){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.environmentService.keybindingsResource,i.VSBuffer.fromString(a)),await this.updateLastSyncUserData(r)}async isEmpty(){try{const r=await this.fileService.readFile(this.environmentService.settingsResource),a=(0,_.parse)(r.value.toString());return!(0,L.isNonEmptyArray)(a)}catch(r){return r.fileOperationResult===1}}getKeybindingsContentFromSyncContent(r){try{return w(r,!0,this.logService)}catch(a){return this.logService.error(a),null}}};c=de([J(0,b.IFileService),J(1,P.IEnvironmentService),J(2,m.IUserDataSyncLogService),J(3,h.IUriIdentityService)],c),e.KeybindingsInitializer=c}),define(te[223],ne([0,1,16,31,54,48,28,52,24]),function(Q,e,L,i,D,_,k,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.getIgnoredSettings=void 0;function C(o,u,f){let v=[];f?v=b(f):v=P(u);const I=[],O=[...(0,E.getDisallowedIgnoredSettings)()];if(Array.isArray(v))for(const A of v)A.startsWith("-")?O.push(A.substring(1)):I.push(A);return(0,L.distinct)([...o,...I].filter(A=>O.indexOf(A)===-1))}e.getIgnoredSettings=C;function P(o){let u=o.inspect("settingsSync.ignoredSettings").userValue;return u!==void 0||(u=o.inspect("sync.ignoredSettings").userValue,u!==void 0)?u:o.getValue("settingsSync.ignoredSettings")||[]}function b(o){const u=(0,i.parse)(o);return u?u["settingsSync.ignoredSettings"]||u["sync.ignoredSettings"]||[]:[]}function d(o,u,f,v){if(f.length){const I=s(u),O=(0,i.parse)(u),A=(0,i.parse)(o),N=[];for(const $ of f){const T=O[$],F=A[$];T===void 0?o=R.edit(o,[$],void 0,v):F!==void 0?o=R.edit(o,[$],T,v):N.push(l($,I))}N.sort(($,T)=>$.startOffset-T.startOffset),N.forEach($=>o=m($.setting.key,u,o,v))}return o}e.updateIgnoredSettings=d;function S(o,u,f,v,I,O){const A=d(o,u,v,O),N=f!==A,$=f!==u;if(!N&&!$)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(N&&!$)return{conflictsSettings:[],localContent:null,remoteContent:A,hasConflicts:!1};if($&&!N)return{conflictsSettings:[],localContent:d(u,o,v,O),remoteContent:null,hasConflicts:!1};if(f===null&&y(o)){const x=h(o,u,v)?null:d(u,o,v,O);return{conflictsSettings:[],localContent:x,remoteContent:null,hasConflicts:!1}}let T=o,F=u;const M=(0,i.parse)(o),U=(0,i.parse)(u),B=f?(0,i.parse)(f):null,ee=v.reduce((x,K)=>(x.add(K),x),new Set),H=p(M,U,ee),j=p(B,M,ee),Z=p(B,U,ee),W=new Map,z=new Set,V=x=>{z.add(x);const K=I.filter(({key:re})=>re===x)[0];K?(T=R.edit(T,[x],K.value,O),F=R.edit(F,[x],K.value,O)):W.set(x,{key:x,localValue:M[x],remoteValue:U[x]})};for(const x of j.removed.values())Z.updated.has(x)?V(x):F=R.edit(F,[x],void 0,O);for(const x of Z.removed.values())z.has(x)||(j.updated.has(x)?V(x):T=R.edit(T,[x],void 0,O));for(const x of j.updated.values())z.has(x)||(Z.updated.has(x)?H.updated.has(x)&&V(x):F=R.edit(F,[x],M[x],O));for(const x of Z.updated.values())z.has(x)||(j.updated.has(x)?H.updated.has(x)&&V(x):T=R.edit(T,[x],U[x],O));for(const x of j.added.values())z.has(x)||(Z.added.has(x)?H.updated.has(x)&&V(x):F=m(x,T,F,O));for(const x of Z.added.values())z.has(x)||(j.added.has(x)?H.updated.has(x)&&V(x):T=m(x,F,T,O));const q=W.size>0||!h(T,F,v),G=q||!h(T,o,[]),Y=q||!h(F,u,[]);return{localContent:G?T:null,remoteContent:Y?F:null,conflictsSettings:[...W.values()],hasConflicts:q}}e.merge=S;function h(o,u,f){if(o===u)return!0;const v=(0,i.parse)(o),I=(0,i.parse)(u),O=f.reduce(($,T)=>($.add(T),$),new Set),A=s(o).filter($=>!($.setting&&O.has($.setting.key))),N=s(u).filter($=>!($.setting&&O.has($.setting.key)));if(A.length!==N.length)return!1;for(let $=0;$<A.length;$++){const T=A[$],F=N[$];if(T.setting&&F.setting){if(T.setting.key!==F.setting.key||!k.equals(v[T.setting.key],I[T.setting.key]))return!1}else if(!T.setting&&!F.setting){if(T.value!==F.value)return!1}else return!1}return!0}e.areSame=h;function y(o){return o?s(o).length===0:!0}e.isEmpty=y;function p(o,u,f){const v=o?Object.keys(o).filter($=>!f.has($)):[],I=Object.keys(u).filter($=>!f.has($)),O=I.filter($=>v.indexOf($)===-1).reduce(($,T)=>($.add(T),$),new Set),A=v.filter($=>I.indexOf($)===-1).reduce(($,T)=>($.add(T),$),new Set),N=new Set;if(o)for(const $ of v){if(A.has($))continue;const T=o[$],F=u[$];k.equals(T,F)||N.add($)}return{added:O,removed:A,updated:N}}function m(o,u,f,v){const I=(0,i.parse)(u),O=s(u),A=s(f),N=w(o,O,A);return g(f,o,I[o],N,A,v)}e.addSetting=m;function w(o,u,f){const v=u.findIndex(O=>O.setting?.key===o),I=u[v-1];if(I){if(I.setting){const A=l(I.setting.key,f);if(A)return{index:f.indexOf(A),insertAfter:!0}}else{const A=r(v,u);if(A){const N=l(A.setting.key,f);if(N){const $=a(f.indexOf(N),f),T=n(u,A,u[v]);if($){const F=n(f,N,$),M=t(T,F);return M?{index:f.indexOf(M),insertAfter:!0}:{index:f.indexOf($),insertAfter:!1}}else{const F=n(f,N,f[f.length-1]),M=t(T,F);return M?{index:f.indexOf(M),insertAfter:!0}:{index:f.length-1,insertAfter:!0}}}}}const O=u[v+1];if(O)if(O.setting){const A=l(O.setting.key,f);if(A)return{index:f.indexOf(A),insertAfter:!1}}else{const A=a(v,u);if(A){const N=l(A.setting.key,f);if(N){const $=r(f.indexOf(N),f),T=n(u,u[v],A);if($){const F=n(f,$,N),M=t(T.reverse(),F.reverse());return M?{index:f.indexOf(M),insertAfter:!1}:{index:f.indexOf($),insertAfter:!0}}else{const F=n(f,f[0],N),M=t(T.reverse(),F.reverse());return M?{index:f.indexOf(M),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:f.length-1,insertAfter:!0}}function g(o,u,f,v,I,O){let A;return v.index===-1?A=(0,D.setProperty)(o,[u],f,O):A=c(o,u,f,v,I,O).map(N=>(0,D.withFormatting)(o,N,O)[0]),(0,D.applyEdits)(o,A)}function c(o,u,f,v,I,O){const A=`${JSON.stringify(u)}: ${JSON.stringify(f)}`,N=(0,_.getEOL)(O,o),$=I[v.index];if(v.insertAfter){const T=[];if($.setting)T.push({offset:$.endOffset,length:0,content:","+A});else{const F=a(v.index,I),M=r(v.index,I),U=M?.setting?.commaOffset;M&&U===void 0&&T.push({offset:M.endOffset,length:0,content:","});const B=U!==void 0&&U>$.endOffset;T.push({offset:B?U+1:$.endOffset,length:0,content:F?N+A+",":N+A})}return T}else{if($.setting)return[{offset:$.startOffset,length:0,content:A+","}];const T=(I[v.index-1]&&!I[v.index-1].setting?N:"")+A+(a(v.index,I)?",":"")+N;return[{offset:$.startOffset,length:0,content:T}]}}function l(o,u){return u.filter(f=>f.setting?.key===o)[0]}function r(o,u){for(let f=o-1;f>=0;f--)if(u[f].setting)return u[f]}function a(o,u){for(let f=o+1;f<u.length;f++)if(u[f].setting)return u[f]}function n(o,u,f){const v=o.indexOf(u),I=o.indexOf(f);return o.filter((O,A)=>v<A&&A<I)}function t(o,u){if(o.length&&u.length){let f=0;for(;f<u.length&&f<o.length;f++)if(o[f].value!==u[f].value)return u[f-1];return u[f-1]}}function s(o){const u=[];let f=-1,v,I;const O={onObjectBegin:A=>{f++},onObjectProperty:(A,N,$)=>{f===0&&(v=N,I=A)},onObjectEnd:(A,N)=>{f--,f===0&&u.push({startOffset:v,endOffset:A+N,value:o.substring(v,A+N),setting:{key:I,commaOffset:void 0}})},onArrayBegin:(A,N)=>{f++},onArrayEnd:(A,N)=>{f--,f===0&&u.push({startOffset:v,endOffset:A+N,value:o.substring(v,A+N),setting:{key:I,commaOffset:void 0}})},onLiteralValue:(A,N,$)=>{f===0&&u.push({startOffset:v,endOffset:N+$,value:o.substring(v,N+$),setting:{key:I,commaOffset:void 0}})},onSeparator:(A,N,$)=>{if(f===0&&A===","){let T=u.length-1;for(;T>=0&&!u[T].setting;T--);const F=u[T];F&&u.splice(T,1,{startOffset:F.startOffset,endOffset:F.endOffset,value:F.value,setting:{key:F.setting.key,commaOffset:N}})}},onComment:(A,N)=>{f===0&&u.push({startOffset:A,endOffset:A+N,value:o.substring(A,A+N)})}};return(0,i.visit)(o,O),u}}),define(te[224],ne([0,1,19,3,145,21,88,84,11,29,14,23,22,35,46,52,223,24]),function(Q,e,L,i,D,_,k,R,E,C,P,b,d,S,h,y,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function w(r){return r&&r.settings&&typeof r.settings=="string"&&Object.keys(r).length===1}function g(r){const a=JSON.parse(r);return w(a)?a:{settings:r}}e.parseSettingsSyncContent=g;let c=class extends h.AbstractJsonFileSynchroniser{constructor(a,n,t,s,o,u,f,v,I,O,A,N,$){super(n.settingsResource,"settings",a,n,t,s,o,I,O,u,f,v,$);this.extensionManagementService=A,this.userConfigurationFileService=N,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.localResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async getRemoteUserDataSyncConfiguration(a){const n=await this.getLastSyncUserData(),t=await this.getLatestRemoteUserData(a,n),s=this.getSettingsSyncContent(t),o=new k.ConfigurationModelParser(m.USER_DATA_SYNC_CONFIGURATION_SCOPE);return s?.settings&&o.parse(s.settings),o.configurationModel.getValue(m.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async generateSyncPreview(a,n,t){const s=await this.getLocalFileContent(),o=await this.getFormattingOptions(),u=this.getSettingsSyncContent(a);n=n===null&&t?a:n;const f=n?this.getSettingsSyncContent(n):null,v=await this.getIgnoredSettings();let I=null,O=!1,A=!1,N=!1;if(u){let T=s?s.value.toString().trim():"{}";T=T||"{}",this.validateContent(T),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const F=(0,p.merge)(T,u.settings,f?f.settings:null,v,[],o);I=F.localContent||F.remoteContent,O=F.localContent!==null,A=F.remoteContent!==null,N=F.hasConflicts}else s&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),I=s.value.toString(),A=!0);const $={content:I,localChange:O?2:0,remoteChange:A?2:0,hasConflicts:N};return[{fileContent:s,localResource:this.localResource,localContent:s?s.value.toString():null,localChange:$.localChange,remoteResource:this.remoteResource,remoteContent:u?u.settings:null,remoteChange:$.remoteChange,previewResource:this.previewResource,previewResult:$,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(a){const n=this.getSettingsSyncContent(a);if(n===null)return!0;const t=await this.getLocalFileContent(),s=t?t.value.toString().trim():"",o=await this.getIgnoredSettings(),u=await this.getFormattingOptions();return(0,p.merge)(s||"{}",n.settings,n.settings,o,[],u).remoteContent!==null}async getMergeResult(a,n){const t=await this.getFormattingOptions(),s=await this.getIgnoredSettings();return{...a.previewResult,content:a.previewResult.content?(0,p.updateIgnoredSettings)(a.previewResult.content,"{}",s,t):null}}async getAcceptResult(a,n,t,s){const o=await this.getFormattingOptions(),u=await this.getIgnoredSettings();if(this.extUri.isEqual(n,this.localResource))return{content:a.fileContent?(0,p.updateIgnoredSettings)(a.fileContent.value.toString(),"{}",u,o):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(n,this.remoteResource))return{content:a.remoteContent!==null?(0,p.updateIgnoredSettings)(a.remoteContent,a.fileContent?a.fileContent.value.toString():"{}",u,o):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(n,this.previewResource))return t===void 0?{content:a.previewResult.content,localChange:a.previewResult.localChange,remoteChange:a.previewResult.remoteChange}:{content:t!==null?(0,p.updateIgnoredSettings)(t,a.fileContent?a.fileContent.value.toString():"{}",u,o):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${n.toString()}`)}async applyResult(a,n,t,s){const{fileContent:o}=t[0][0];let{content:u,localChange:f,remoteChange:v}=t[0][1];if(f===0&&v===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),u=u?u.trim():"{}",u=u||"{}",this.validateContent(u),f!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),o&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(o.value.toString()))),await this.updateLocalFileContent(u,o,s),await this.configurationService.reloadConfiguration(2),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),v!==0){const I=await this.getFormattingOptions(),O=this.getSettingsSyncContent(a),A=await this.getIgnoredSettings(u);u=(0,p.updateIgnoredSettings)(u,O?O.settings:"{}",A,I),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),a=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(u)),s?null:a.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch{}n?.ref!==a.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(a),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const a=await this.getLocalFileContent();if(a){const n=await this.getFormattingOptions(),t=(0,y.edit)(a.value.toString(),[m.CONFIGURATION_SYNC_STORE_KEY],void 0,n);return!(0,p.isEmpty)(t)}}catch(a){if(a.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:a}){const n=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(a,"settings.json"),comparableResource:n}]}async resolveContent(a){if(this.extUri.isEqual(this.remoteResource,a)||this.extUri.isEqual(this.localResource,a)||this.extUri.isEqual(this.acceptedResource,a))return this.resolvePreviewContent(a);let n=await super.resolveContent(a);if(n)return n;if(n=await super.resolveContent(this.extUri.dirname(a)),n){const t=this.parseSyncData(n);if(t){const s=this.parseSettingsSyncContent(t.content);if(s)switch(this.extUri.basename(a)){case"settings.json":return s.settings}}}return null}async resolvePreviewContent(a){let n=await super.resolvePreviewContent(a);if(n){const t=await this.getFormattingOptions(),s=await this.getIgnoredSettings();n=(0,p.updateIgnoredSettings)(n,"{}",s,t)}return n}getSettingsSyncContent(a){return a.syncData?this.parseSettingsSyncContent(a.syncData.content):null}parseSettingsSyncContent(a){try{return g(a)}catch(n){this.logService.error(n)}return null}toSettingsSyncContent(a){return{settings:a}}async getIgnoredSettings(a){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const t=i.Event.any(i.Event.filter(this.extensionManagementService.onDidInstallExtensions,s=>s.some(({local:o})=>!!o)),i.Event.filter(this.extensionManagementService.onDidUninstallExtension,s=>!s.error))(()=>{t.dispose(),this._defaultIgnoredSettings=void 0})}const n=await this._defaultIgnoredSettings;return(0,p.getIgnoredSettings)(n,this.configurationService,a)}async writeFileContent(a,n,t){await this.userConfigurationFileService.write(L.VSBuffer.fromString(a),t?void 0:{etag:n.etag,mtime:n.mtime})}validateContent(a){if(this.hasErrors(a))throw new m.UserDataSyncError((0,D.localize)(0,null),"LocalInvalidContent",this.resource)}};c=de([J(0,P.IFileService),J(1,E.IEnvironmentService),J(2,b.IStorageService),J(3,m.IUserDataSyncStoreService),J(4,m.IUserDataSyncBackupStoreService),J(5,m.IUserDataSyncLogService),J(6,m.IUserDataSyncUtilService),J(7,_.IConfigurationService),J(8,m.IUserDataSyncEnablementService),J(9,d.ITelemetryService),J(10,C.IExtensionManagementService),J(11,R.IUserConfigurationFileService),J(12,S.IUriIdentityService)],c),e.SettingsSynchroniser=c;let l=class extends h.AbstractInitializer{constructor(a,n,t,s){super("settings",n,t,a,s)}async doInitialize(a){const n=a.syncData?this.parseSettingsSyncContent(a.syncData.content):null;if(!n){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.environmentService.settingsResource,L.VSBuffer.fromString(n.settings)),await this.updateLastSyncUserData(a)}async isEmpty(){try{const a=await this.fileService.readFile(this.environmentService.settingsResource);return(0,p.isEmpty)(a.value.toString().trim())}catch(a){return a.fileOperationResult===1}}parseSettingsSyncContent(a){try{return g(a)}catch(n){this.logService.error(n)}return null}};l=de([J(0,P.IFileService),J(1,E.IEnvironmentService),J(2,m.IUserDataSyncLogService),J(3,S.IUriIdentityService)],l),e.SettingsInitializer=l}),define(te[225],ne([0,1,19,3,28,21,11,14,23,22,35,46,218,24]),function(Q,e,L,i,D,_,k,R,E,C,P,b,d,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=void 0;let h=class extends b.AbstractSynchroniser{constructor(m,w,g,c,l,r,a,n,t,s){super("snippets",w,m,g,c,l,n,t,r,a,s);this.version=1,this.snippetsFolder=m.snippetsHome,this._register(this.fileService.watch(m.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(i.Event.filter(this.fileService.onDidFilesChange,o=>o.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(m,w,g){const c=await this.getSnippetsFileContents(),l=this.toSnippetsContents(c),r=m.syncData?this.parseSnippets(m.syncData):null;w=w===null&&g?m:w;const a=w&&w.syncData?this.parseSnippets(w.syncData):null;r?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const n=(0,d.merge)(l,r,a);return this.getResourcePreviews(n,c,r||{})}async hasRemoteChanged(m){const w=m.syncData?this.parseSnippets(m.syncData):null;if(w===null)return!0;const g=await this.getSnippetsFileContents(),c=this.toSnippetsContents(g),l=(0,d.merge)(c,w,w);return Object.keys(l.remote.added).length>0||Object.keys(l.remote.updated).length>0||l.remote.removed.length>0||l.conflicts.length>0}async getMergeResult(m,w){return m.previewResult}async getAcceptResult(m,w,g,c){if(this.extUri.isEqualOrParent(w,this.syncPreviewFolder.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:m.fileContent?m.fileContent.value.toString():null,localChange:0,remoteChange:m.fileContent?m.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(w,this.syncPreviewFolder.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:m.remoteContent,localChange:m.remoteContent!==null?m.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(w,this.syncPreviewFolder))return g===void 0?{content:m.previewResult.content,localChange:m.previewResult.localChange,remoteChange:m.previewResult.remoteChange}:{content:g,localChange:g===null?m.fileContent!==null?3:0:2,remoteChange:g===null?m.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${w.toString()}`)}async applyResult(m,w,g,c){const l=g.map(([r,a])=>({...r,acceptResult:a}));l.every(({localChange:r,remoteChange:a})=>r===0&&a===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),l.some(({localChange:r})=>r!==0)&&(await this.updateLocalBackup(l),await this.updateLocalSnippets(l,c)),l.some(({remoteChange:r})=>r!==0)&&(m=await this.updateRemoteSnippets(l,m,c)),w?.ref!==m.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(m),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:r}of l)try{await this.fileService.del(r)}catch{}}getResourcePreviews(m,w,g){const c=new Map;for(const l of Object.keys(m.local.added)){const r={content:m.local.added[l],hasConflicts:!1,localChange:1,remoteChange:0};c.set(l,{fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:g[l],previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of Object.keys(m.local.updated)){const r={content:m.local.updated[l],hasConflicts:!1,localChange:2,remoteChange:0};c.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[l],localContent:w[l].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:g[l],previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of m.local.removed){const r={content:null,hasConflicts:!1,localChange:3,remoteChange:0};c.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[l],localContent:w[l].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of Object.keys(m.remote.added)){const r={content:m.remote.added[l],hasConflicts:!1,localChange:0,remoteChange:1};c.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[l],localContent:w[l].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of Object.keys(m.remote.updated)){const r={content:m.remote.updated[l],hasConflicts:!1,localChange:0,remoteChange:2};c.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[l],localContent:w[l].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:g[l],previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of m.remote.removed){const r={content:null,hasConflicts:!1,localChange:0,remoteChange:3};c.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:g[l],previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of m.conflicts){const r={content:w[l]?w[l].value.toString():null,hasConflicts:!0,localChange:w[l]?2:1,remoteChange:g[l]?2:1};c.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[l]||null,localContent:w[l]?w[l].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:g[l]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of Object.keys(w))if(!c.has(l)){const r={content:w[l]?w[l].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0};c.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[l]||null,localContent:w[l]?w[l].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:g[l]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...c.values()]}async getAssociatedResources({uri:m}){let w=await super.resolveContent(m);if(w){const g=this.parseSyncData(w);if(g){const c=this.parseSnippets(g),l=[];for(const r of Object.keys(c)){const a=this.extUri.joinPath(m,r),n=this.extUri.joinPath(this.snippetsFolder,r),t=await this.fileService.exists(n);l.push({resource:a,comparableResource:t?n:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"})})}return l}}return[]}async resolveContent(m){if(this.extUri.isEqualOrParent(m,this.syncPreviewFolder.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(m,this.syncPreviewFolder.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(m,this.syncPreviewFolder.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})))return this.resolvePreviewContent(m);let w=await super.resolveContent(m);if(w)return w;if(w=await super.resolveContent(this.extUri.dirname(m)),w){const g=this.parseSyncData(w);if(g)return this.parseSnippets(g)[this.extUri.basename(m)]||null}return null}async hasLocalData(){try{const m=await this.getSnippetsFileContents();if(Object.keys(m).length)return!0}catch{}return!1}async updateLocalBackup(m){const w={};for(const g of m)g.fileContent&&(w[this.extUri.basename(g.localResource)]=g.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(w)))}async updateLocalSnippets(m,w){for(const{fileContent:g,acceptResult:c,localResource:l,remoteResource:r,localChange:a}of m)if(a!==0){const n=r?this.extUri.basename(r):this.extUri.basename(l),t=this.extUri.joinPath(this.snippetsFolder,n);a===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(t)),await this.fileService.del(t),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(t))):a===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(t)),await this.fileService.createFile(t,L.VSBuffer.fromString(c.content),{overwrite:w}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(t))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(t)),await this.fileService.writeFile(t,L.VSBuffer.fromString(c.content),w?void 0:g),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(t)))}}async updateRemoteSnippets(m,w,g){const c=w.syncData?this.parseSnippets(w.syncData):{},l=(0,D.deepClone)(c);for(const{acceptResult:r,localResource:a,remoteResource:n,remoteChange:t}of m)if(t!==0){const s=a?this.extUri.basename(a):this.extUri.basename(n);t===3?delete l[s]:l[s]=r.content}return(0,d.areSame)(c,l)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),w=await this.updateRemoteUserData(JSON.stringify(l),g?null:w.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),w}parseSnippets(m){return JSON.parse(m.content)}toSnippetsContents(m){const w={};for(const g of Object.keys(m))w[g]=m[g].value.toString();return w}async getSnippetsFileContents(){const m={};let w;try{w=await this.fileService.resolve(this.snippetsFolder)}catch(g){if(g instanceof R.FileOperationError&&g.fileOperationResult===1)return m;throw g}for(const g of w.children||[]){const c=g.resource,l=this.extUri.extname(c);if(l===".json"||l===".code-snippets"){const r=this.extUri.relativePath(this.snippetsFolder,c),a=await this.fileService.readFile(c);m[r]=a}}return m}};h=de([J(0,k.IEnvironmentService),J(1,R.IFileService),J(2,E.IStorageService),J(3,S.IUserDataSyncStoreService),J(4,S.IUserDataSyncBackupStoreService),J(5,S.IUserDataSyncLogService),J(6,_.IConfigurationService),J(7,S.IUserDataSyncEnablementService),J(8,C.ITelemetryService),J(9,P.IUriIdentityService)],h),e.SnippetsSynchroniser=h;let y=class extends b.AbstractInitializer{constructor(m,w,g,c){super("snippets",w,g,m,c)}async doInitialize(m){const w=m.syncData?JSON.parse(m.syncData.content):null;if(!w){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const c of Object.keys(w)){const l=w[c];if(l){const r=this.extUri.joinPath(this.environmentService.snippetsHome,c);await this.fileService.createFile(r,L.VSBuffer.fromString(l)),this.logService.info("Created snippet",this.extUri.basename(r))}}await this.updateLastSyncUserData(m)}async isEmpty(){try{return!(await this.fileService.resolve(this.environmentService.snippetsHome)).children?.length}catch(m){return m.fileOperationResult===1}}};y=de([J(0,R.IFileService),J(1,k.IEnvironmentService),J(2,S.IUserDataSyncLogService),J(3,P.IUriIdentityService)],y),e.SnippetsInitializer=y}),define(te[63],ne([0,1,3,2,6,24]),function(Q,e,L,i,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,D.createDecorator)("IUserDataSyncAccountService");let k=class extends i.Disposable{constructor(E,C){super();this.userDataSyncStoreService=E,this.logService=C,this._onDidChangeAccount=this._register(new L.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new L.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(E.onTokenFailed(()=>{this.logService.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.wasTokenFailed),this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(E.onTokenSucceed(()=>this.wasTokenFailed=!1))}get account(){return this._account}async updateAccount(E){(E&&this._account?E.token!==this._account.token||E.authenticationProviderId!==this._account.authenticationProviderId:E!==this._account)&&(this._account=E,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(E))}};k=de([J(0,_.IUserDataSyncStoreService),J(1,_.IUserDataSyncLogService)],k),e.UserDataSyncAccountService=k}),define(te[226],ne([0,1,5,19,56,2,18,21,11,14,24]),function(Q,e,L,i,D,_,k,R,E,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let b=class extends _.Disposable{constructor(S,h,y,p){super();this.environmentService=S,this.fileService=h,this.configurationService=y,this.logService=p,P.ALL_SYNC_RESOURCES.forEach(m=>this.cleanUpBackup(m))}async getAllRefs(S){const h=(0,k.joinPath)(this.environmentService.userDataSyncHome,S),y=await this.fileService.resolve(h);return y.children?y.children.filter(m=>m.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(m.name)).sort().reverse().map(m=>({ref:m.name,created:this.getCreationTime(m)})):[]}async resolveContent(S,h){if(!h){const y=await this.getAllRefs(S);y.length&&(h=y[y.length-1].ref)}if(h){const y=(0,k.joinPath)(this.environmentService.userDataSyncHome,S,h);return(await this.fileService.readFile(y)).value.toString()}return null}async backup(S,h){const y=(0,k.joinPath)(this.environmentService.userDataSyncHome,S),p=(0,k.joinPath)(y,`${(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(p,i.VSBuffer.fromString(h))}catch(m){this.logService.error(m)}try{this.cleanUpBackup(S)}catch{}}async cleanUpBackup(S){const h=(0,k.joinPath)(this.environmentService.userDataSyncHome,S);try{try{if(!await this.fileService.exists(h))return}catch{return}const y=await this.fileService.resolve(h);if(y.children){const p=y.children.filter(c=>c.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(c.name)).sort(),m=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let w=p.filter(c=>Date.now()-this.getCreationTime(c)>m);const g=p.length-w.length;g<10&&(w=w.slice(10-g)),await L.Promises.settled(w.map(async c=>{this.logService.info("Deleting from backup",c.resource.path),await this.fileService.del(c.resource)}))}}catch(y){this.logService.error(y)}}getCreationTime(S){return S.ctime||new Date(parseInt(S.name.substring(0,4)),parseInt(S.name.substring(4,6))-1,parseInt(S.name.substring(6,8)),parseInt(S.name.substring(9,11)),parseInt(S.name.substring(11,13)),parseInt(S.name.substring(13,15))).getTime()}};b=de([J(0,E.IEnvironmentService),J(1,C.IFileService),J(2,R.IConfigurationService),J(3,P.IUserDataSyncLogService)],b),e.UserDataSyncBackupStoreService=b}),define(te[227],ne([0,1,3,2,4,11,23,22,24]),function(Q,e,L,i,D,_,k,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncEnablementService=void 0;const C="sync.enable";let P=class extends i.Disposable{constructor(d,S,h,y){super();this.storageService=d,this.telemetryService=S,this.environmentService=h,this.userDataSyncStoreManagementService=y,this._onDidChangeEnablement=new L.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._onDidChangeResourceEnablement=new L.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(d.onDidChangeValue(p=>this.onDidStorageChange(p)))}isEnabled(){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(C,0,!1)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(d){d&&!this.canToggleEnablement()||(this.telemetryService.publicLog2(C,{enabled:d}),this.storageService.store(C,d,0,1))}isResourceEnabled(d){return this.storageService.getBoolean((0,E.getEnablementKey)(d),0,!0)}setResourceEnablement(d,S){if(this.isResourceEnabled(d)!==S){const h=(0,E.getEnablementKey)(d);this.telemetryService.publicLog2(h,{enabled:S}),this.storeResourceEnablement(h,S)}}getResourceSyncStateVersion(d){}storeResourceEnablement(d,S){this.storageService.store(d,S,0,D.isWeb?0:1)}onDidStorageChange(d){if(d.scope!==0)return;if(C===d.key){this._onDidChangeEnablement.fire(this.isEnabled());return}const S=E.ALL_SYNC_RESOURCES.filter(h=>(0,E.getEnablementKey)(h)===d.key)[0];if(S){this._onDidChangeResourceEnablement.fire([S,this.isResourceEnabled(S)]);return}}};P=de([J(0,k.IStorageService),J(1,R.ITelemetryService),J(2,_.IEnvironmentService),J(3,E.IUserDataSyncStoreManagementService)],P),e.UserDataSyncEnablementService=P}),define(te[228],ne([0,1,2,7]),function(Q,e,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class D{constructor(d){this.service=d}listen(d,S){switch(S){case"onError":return this.service.onError}throw new Error(`Event not found: ${S}`)}call(d,S,h){switch(S){case"triggerSync":return this.service.triggerSync(h[0],h[1],h[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(h[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=D;class _{constructor(d){this.service=d}listen(d,S){throw new Error(`Event not found: ${S}`)}call(d,S,h){switch(S){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(h[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(i.URI.revive(h[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=_;class k{constructor(d){this.channel=d}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(d){return this.channel.call("resolveUserKeybindings",[d])}async resolveFormattingOptions(d){return this.channel.call("resolveFormattingOptions",[d])}}e.UserDataSyncUtilServiceClient=k;class R{constructor(d){this.service=d}listen(d,S){switch(S){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${S}`)}async call(d,S,h){switch(S){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(h[0],h[1]);case"setEnablement":return this.service.setEnablement(h[0],h[1])}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=R;class E{constructor(d){this.service=d}listen(d,S){switch(S){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${S}`)}call(d,S,h){switch(S){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(h)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=E;class C{constructor(d){this.service=d}listen(d,S){switch(S){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${S}`)}call(d,S,h){switch(S){case"switch":return this.service.switch(h[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=C;class P extends L.Disposable{constructor(d){super();this.channel=d,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(d){return this.channel.call("switch",[d])}async getPreviousUserDataSyncStore(){const d=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(d)}revive(d){return{url:i.URI.revive(d.url),type:d.type,defaultUrl:i.URI.revive(d.defaultUrl),insidersUrl:i.URI.revive(d.insidersUrl),stableUrl:i.URI.revive(d.stableUrl),canSwitch:d.canSwitch,authenticationProviders:d.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=P}),define(te[229],ne([0,1,11,8]),function(Q,e,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let D=class extends i.AbstractLogger{constructor(k,R){super();this.logger=this._register(k.createLogger(R.userDataSyncLogResource,{name:"settingssync"}))}trace(k,...R){this.logger.trace(k,...R)}debug(k,...R){this.logger.debug(k,...R)}info(k,...R){this.logger.info(k,...R)}warn(k,...R){this.logger.warn(k,...R)}error(k,...R){this.logger.error(k,...R)}critical(k,...R){this.logger.critical(k,...R)}flush(){this.logger.flush()}};D=de([J(0,i.ILoggerService),J(1,L.IEnvironmentService)],D),e.UserDataSyncLogService=D}),define(te[64],ne([0,1,3,2,4,25,148,11,14,6,26,45,23,24]),function(Q,e,L,i,D,_,k,R,E,C,P,b,d,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,C.createDecorator)("IUserDataSyncMachinesService");const h="sync.currentMachineName";let y=class et extends i.Disposable{constructor(m,w,g,c,l,r){super();this.storageService=g,this.userDataSyncStoreService=c,this.logService=l,this.productService=r,this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,b.getServiceMachineId)(m,w,g)}async getMachines(m){const w=await this.currentMachineIdPromise;return(await this.readMachinesData(m)).machines.map(c=>({...c,isCurrent:c.id===w}))}async addCurrentMachine(m){const w=await this.currentMachineIdPromise,g=await this.readMachinesData(m);g.machines.some(({id:c})=>c===w)||(g.machines.push({id:w,name:this.computeCurrentMachineName(g.machines)}),await this.writeMachinesData(g))}async removeCurrentMachine(m){const w=await this.currentMachineIdPromise,g=await this.readMachinesData(m),c=g.machines.filter(({id:l})=>l!==w);c.length!==g.machines.length&&(g.machines=c,await this.writeMachinesData(g))}async renameMachine(m,w,g){const c=await this.currentMachineIdPromise,l=await this.readMachinesData(g),r=l.machines.find(({id:a})=>a===m);r&&(r.name=w,await this.writeMachinesData(l),l.machines.some(({id:a})=>a===c)&&this.storageService.store(h,w,0,1))}async setEnablement(m,w){const g=await this.readMachinesData(),c=g.machines.find(({id:l})=>l===m);c&&(c.disabled=w?void 0:!0,await this.writeMachinesData(g))}computeCurrentMachineName(m){const w=this.storageService.get(h,0);if(w)return w;const g=`${this.productService.nameLong} (${(0,D.PlatformToString)(D.isWeb?0:D.platform)})`,c=new RegExp(`${(0,_.escapeRegExpCharacters)(g)}\\s#(\\d+)`);let l=0;for(const r of m){const a=c.exec(r.name),n=a?parseInt(a[1]):0;l=n>l?n:l}return`${g} #${l+1}`}async readMachinesData(m){this.userData=await this.readUserData(m);const w=this.parse(this.userData);if(w.version!==et.VERSION)throw new Error((0,k.localize)(0,null,this.productService.nameLong));return w}async writeMachinesData(m){const w=JSON.stringify(m),g=await this.userDataSyncStoreService.write(et.RESOURCE,w,this.userData?.ref||null);this.userData={ref:g,content:w},this._onDidChange.fire()}async readUserData(m){if(this.userData){const w=m&&m.latest?m.latest[et.RESOURCE]:void 0;if(this.userData.ref===w)return this.userData;if(w===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.read(et.RESOURCE,this.userData)}parse(m){if(m.content!==null)try{return JSON.parse(m.content)}catch(w){this.logService.error(w)}return{version:et.VERSION,machines:[]}}};y.VERSION=1,y.RESOURCE="machines",y=de([J(0,R.IEnvironmentService),J(1,E.IFileService),J(2,d.IStorageService),J(3,S.IUserDataSyncStoreService),J(4,S.IUserDataSyncLogService),J(5,P.IProductService)],y),e.UserDataSyncMachinesService=y}),define(te[230],ne([0,1,5,56,38,10,3,2,4,18,7,146,26,23,22,24,63,64]),function(Q,e,L,i,D,_,k,R,E,C,P,b,d,S,h,y,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;const w="sync.disableMachineEventually",g="sync.sessionId",c="sync.storeUrl",l="sync.productQuality";let r=class extends R.Disposable{constructor(t,s,o,u,f,v,I,O,A,N){super();this.userDataSyncStoreManagementService=s,this.userDataSyncStoreService=o,this.userDataSyncEnablementService=u,this.userDataSyncService=f,this.logService=v,this.userDataSyncAccountService=I,this.telemetryService=O,this.userDataSyncMachinesService=A,this.storageService=N,this.autoSync=this._register(new R.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this.sources=[],this.syncTriggerDelayer=this._register(new L.Delayer(0)),this.lastSyncUrl=this.syncUrl,this.syncUrl=s.userDataSyncStore?.url,this.previousProductQuality=this.productQuality,this.productQuality=t.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(s.onDidChangeUserDataSyncStore(()=>{(0,C.isEqual)(this.syncUrl,s.userDataSyncStore?.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=s.userDataSyncStore?.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(I.onDidChangeAccount(()=>this.updateAutoSync())),this._register(o.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(k.Event.debounce(f.onDidChangeLocal,($,T)=>$?[...$,T]:[T],1e3)($=>this.triggerSync($,!1,!1))),this._register(k.Event.filter(this.userDataSyncEnablementService.onDidChangeResourceEnablement,([,$])=>$)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}get syncUrl(){const t=this.storageService.get(c,0);return t?P.URI.parse(t):void 0}set syncUrl(t){t?this.storageService.store(c,t.toString(),0,1):this.storageService.remove(c,0)}get productQuality(){return this.storageService.get(l,0)}set productQuality(t){t?this.storageService.store(l,t,0,1):this.storageService.remove(l,0)}updateAutoSync(){const{enabled:t,message:s}=this.isAutoSyncEnabled();t?this.autoSync.value===void 0&&(this.autoSync.value=new a(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(o=>this.onDidFinishSync(o))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(s&&this.logService.info(s),this.autoSync.clear()):s&&this.userDataSyncEnablementService.isEnabled()&&this.logService.info(s))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,i.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(t,s,o){try{this.userDataSyncAccountService.account&&!o&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(g,0),t?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(u){if(s)this.logService.error(u),this.updateEnablement(!1);else throw u}}updateEnablement(t){this.userDataSyncEnablementService.isEnabled()!==t&&(this.userDataSyncEnablementService.setEnablement(t),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(t){if(!t){this.successiveFailures=0;return}const s=y.UserDataSyncError.toUserDataSyncError(t);s instanceof y.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:s.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),s.code==="SessionExpired"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):s.code==="TurnedOff"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):s.code==="LocalTooManyRequests"||s.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):s.code==="UpgradeRequired"||s.code==="Gone"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):s.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${s.resource} content with newer version than of client. Requires client upgrade.`)):s.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${s.resource} content with older version than of client. Requires server reset.`)):s.code==="ServiceChanged"||s.code==="DefaultServiceChanged"?E.isWeb&&s.code==="DefaultServiceChanged"&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(s),this.successiveFailures++),this._onError.fire(s)}async disableMachineEventually(){this.storageService.store(w,!0,0,1),await(0,L.timeout)(1e3*60*10),!!this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(w,0,!1)}stopDisableMachineEventually(){this.storageService.remove(w,0)}async triggerSync(t,s,o){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(s&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...t),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources),this.telemetryService.publicLog2("sync/triggered",{sources:this.sources}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",o)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 1e3}};r=de([J(0,d.IProductService),J(1,y.IUserDataSyncStoreManagementService),J(2,y.IUserDataSyncStoreService),J(3,y.IUserDataSyncEnablementService),J(4,y.IUserDataSyncService),J(5,y.IUserDataSyncLogService),J(6,p.IUserDataSyncAccountService),J(7,h.ITelemetryService),J(8,m.IUserDataSyncMachinesService),J(9,S.IStorageService)],r),e.UserDataAutoSyncService=r;class a extends R.Disposable{constructor(t,s,o,u,f,v,I,O){super();this.lastSyncUrl=t,this.interval=s,this.userDataSyncStoreManagementService=o,this.userDataSyncStoreService=u,this.userDataSyncService=f,this.userDataSyncMachinesService=v,this.logService=I,this.storageService=O,this.intervalHandler=this._register(new R.MutableDisposable),this._onDidStartSync=this._register(new k.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new k.Emitter),this.onDidFinishSync=this._onDidFinishSync.event,this.manifest=null}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,R.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask&&this.syncTask.stop(),this.logService.info("Auto Sync: Stopped")})),this.logService.info("Auto Sync: Started"),this.sync(a.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,L.disposableTimeout)(()=>this.sync(a.INTERVAL_SYNCING,!1),this.interval)}sync(t,s){const o=(0,L.createCancelablePromise)(async u=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(f){if((0,_.isPromiseCanceledError)(f))return}return this.doSync(t,s,u)});return this.syncPromise=o,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){return this.lastSyncUrl!==void 0&&!(0,C.isEqual)(this.lastSyncUrl,this.userDataSyncStoreManagementService.userDataSyncStore?.url)}async hasDefaultServiceChanged(){const t=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),s=this.userDataSyncStoreManagementService.userDataSyncStore;return!!s&&!!t&&(!(0,C.isEqual)(s.defaultUrl,t.defaultUrl)||!(0,C.isEqual)(s.insidersUrl,t.insidersUrl)||!(0,C.isEqual)(s.stableUrl,t.stableUrl))}async doSync(t,s,o){this.logService.info(`Auto Sync: Triggered by ${t}`),this._onDidStartSync.fire();let u;try{if(this.syncTask=await this.userDataSyncService.createSyncTask(this.manifest,s),o.isCancellationRequested)return;if(this.manifest=this.syncTask.manifest,this.manifest===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new y.UserDataAutoSyncError((0,b.localize)(0,null),"DefaultServiceChanged"):new y.UserDataAutoSyncError((0,b.localize)(1,null),"ServiceChanged"):new y.UserDataAutoSyncError((0,b.localize)(2,null),"TurnedOff");const f=this.storageService.get(g,0);if(f&&this.manifest&&f!==this.manifest.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new y.UserDataAutoSyncError((0,b.localize)(3,null),"DefaultServiceChanged"):new y.UserDataAutoSyncError((0,b.localize)(4,null),"ServiceChanged"):new y.UserDataAutoSyncError((0,b.localize)(5,null),"SessionExpired");const v=await this.userDataSyncMachinesService.getMachines(this.manifest||void 0);if(o.isCancellationRequested)return;const I=v.find(O=>O.isCurrent);if(I?.disabled)throw new y.UserDataAutoSyncError((0,b.localize)(6,null),"TurnedOff");if(await this.syncTask.run(),this.manifest===null)try{this.manifest=await this.userDataSyncStoreService.manifest(null)}catch(O){throw new y.UserDataAutoSyncError((0,D.toErrorMessage)(O),O instanceof y.UserDataSyncError?O.code:"Unknown")}if(this.manifest&&this.manifest.session!==f&&this.storageService.store(g,this.manifest.session,0,1),o.isCancellationRequested)return;I||await this.userDataSyncMachinesService.addCurrentMachine(this.manifest||void 0)}catch(f){this.logService.error(f),u=f}this._onDidFinishSync.fire(u)}register(t){return super._register(t)}}a.INTERVAL_SYNCING="Interval"}),define(te[231],ne([0,1,16,5,38,3,2,18,15,30,21,29,6,23,22,219,221,222,224,225,24]),function(Q,e,L,i,D,_,k,R,E,C,P,b,d,S,h,y,p,m,w,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const l="sync.lastSyncTime";let r=class extends k.Disposable{constructor(o,u,f,v,I,O,A,N){super();this.userDataSyncStoreService=o,this.userDataSyncStoreManagementService=u,this.instantiationService=f,this.configurationService=v,this.logService=I,this.telemetryService=O,this.storageService=A,this.userDataSyncEnablementService=N,this._status="uninitialized",this._onDidChangeStatus=this._register(new _.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._onDidChangeLocal=this._register(new _.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new _.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new _.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new _.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new _.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new _.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.synchronizers=this._register(new k.MutableDisposable),this.updateStatus([]),this._lastSyncTime=this.storageService.getNumber(l,0,void 0)}get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}async createSyncTask(o,u){this.checkEnablement();const f=(0,C.generateUuid)();try{const N=(0,c.createSyncHeaders)(f);u&&(N["Cache-Control"]="no-cache"),o=await this.userDataSyncStoreService.manifest(o,N)}catch(N){const $=c.UserDataSyncError.toUserDataSyncError(N);throw this.reportUserDataSyncError($,f),$}let v=!1;const I=this,O=this.getEnabledSynchronizers();let A;return{manifest:o,async run(){if(v)throw new Error("Can run a task only once");return A=(0,i.createCancelablePromise)(N=>I.sync(O,o,f,N)),A.finally(()=>A=void 0)},async stop(){if(A&&A.cancel(),I.status!=="idle")return I.stop(O)}}}async createManualSyncTask(){if(this.checkEnablement(),this.userDataSyncEnablementService.isEnabled())throw new c.UserDataSyncError("Cannot start manual sync when sync is enabled","LocalError");const o=(0,C.generateUuid)(),u=(0,c.createSyncHeaders)(o);let f;try{f=await this.userDataSyncStoreService.manifest(null,u)}catch(I){const O=c.UserDataSyncError.toUserDataSyncError(I);throw this.reportUserDataSyncError(O,o),O}await this.resetLocal();const v=this.getEnabledSynchronizers();return new a(o,f,u,v,()=>this.resetLocal(),this.configurationService,this.logService)}async sync(o,u,f,v){if(v.isCancellationRequested||!o.length)return;const I=new Date().getTime();this._syncErrors=[];try{this.logService.trace("Sync started."),this.status!=="hasConflicts"&&this.setStatus("syncing");const O=(0,c.createSyncHeaders)(f);for(const A of o){if(v.isCancellationRequested||!this.userDataSyncEnablementService.isResourceEnabled(A.resource))return;try{await A.sync(u,O)}catch(N){let $=!1;if(N instanceof c.UserDataSyncError)switch(N.code){case"TooLarge":N=new c.UserDataSyncError(N.message,N.code,A.resource),$=!0;break;case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":$=!0;break}const T=c.UserDataSyncError.toUserDataSyncError(N);if(this.reportUserDataSyncError(T,f),$)throw T;this.logService.error(N),this.logService.error(`${A.resource}: ${(0,D.toErrorMessage)(N)}`),this._syncErrors.push([A.resource,T])}}this.logService.info(`Sync done. Took ${new Date().getTime()-I}ms`),this.updateLastSyncTime()}catch(O){const A=c.UserDataSyncError.toUserDataSyncError(O);throw this.reportUserDataSyncError(A,f),A}finally{this.updateStatus(o),this._onSyncErrors.fire(this._syncErrors)}}async stop(o){if(this.status!=="idle")for(const u of o)try{u.status!=="idle"&&await u.stop()}catch(f){this.logService.error(f)}}async replace(o){this.checkEnablement(),await this.performSynchronizerAction(async u=>{if(await u.replace(o))return!0})}async accept(o,u,f,v){this.checkEnablement(),await this.performSynchronizerAction(async I=>{if(I.resource===o)return await I.accept(u,f),v&&await I.apply(!1,(0,c.createSyncHeaders)((0,C.generateUuid)())),!0})}async resolveContent(o){return this.performSynchronizerAction(async u=>{const f=await u.resolveContent(o);if(f)return f})}async getRemoteSyncResourceHandles(o){return await this.performSynchronizerAction(async f=>{if(f.resource===o)return f.getRemoteSyncResourceHandles()})||[]}async getLocalSyncResourceHandles(o){return await this.performSynchronizerAction(async f=>{if(f.resource===o)return f.getLocalSyncResourceHandles()})||[]}async getAssociatedResources(o,u){return await this.performSynchronizerAction(async v=>{if(v.resource===o)return v.getAssociatedResources(u)})||[]}async getMachineId(o,u){return await this.performSynchronizerAction(async v=>{if(v.resource===o)return await v.getMachineId(u)||null})||void 0}async hasLocalData(){return!!await this.performSynchronizerAction(async u=>{if(u.resource!=="globalState"&&await u.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.performSynchronizerAction(async u=>{if(await u.hasPreviouslySynced())return!0})}async reset(){this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(o){this.logService.error(o)}this._onDidResetRemote.fire()}async resetLocal(){if(this.checkEnablement(),this.storageService.remove(l,0),this.synchronizers.value){for(const o of this.synchronizers.value.enabled)try{await o.resetLocal()}catch(u){this.logService.error(`${o.resource}: ${(0,D.toErrorMessage)(u)}`),this.logService.error(u)}this.synchronizers.value=void 0}this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async performSynchronizerAction(o){const u=new k.DisposableStore;try{const f=this.synchronizers.value||u.add(this.instantiationService.createInstance(n,()=>{},()=>{},()=>{})),v=[...f.enabled,...f.disabled.map(I=>u.add(f.createSynchronizer(I)))];for(const I of v){const O=await o(I);if(!(0,E.isUndefined)(O))return O}return null}finally{u.dispose()}}setStatus(o){const u=this._status;this._status!==o&&(this._status=o,this._onDidChangeStatus.fire(o),u==="hasConflicts"&&this.updateLastSyncTime())}updateStatus(o){this.updateConflicts(o);const u=this.computeStatus(o);this.setStatus(u)}updateConflicts(o){const u=this.computeConflicts(o);(0,L.equals)(this._conflicts,u,([f,v],[I,O])=>f===f&&(0,L.equals)(v,O,(A,N)=>(0,R.isEqual)(A.previewResource,N.previewResource)))||(this._conflicts=this.computeConflicts(o),this._onDidChangeConflicts.fire(u))}computeConflicts(o){return o.filter(u=>u.status==="hasConflicts").map(u=>[u.resource,u.conflicts.map(t)])}computeStatus(o){return this.userDataSyncStoreManagementService.userDataSyncStore?o.some(u=>u.status==="hasConflicts")?"hasConflicts":o.some(u=>u.status==="syncing")?"syncing":"idle":"uninitialized"}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(l,this._lastSyncTime,0,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}reportUserDataSyncError(o,u){this.telemetryService.publicLog2("sync/error",{code:o.code,serverCode:o instanceof c.UserDataSyncStoreError?String(o.serverCode):void 0,url:o instanceof c.UserDataSyncStoreError?o.url:void 0,resource:o.resource,executionId:u,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()})}getEnabledSynchronizers(){return this.synchronizers.value||(this.synchronizers.value=this.instantiationService.createInstance(n,o=>this.updateStatus(o),o=>this.updateConflicts(o),o=>this._onDidChangeLocal.fire(o))),this.synchronizers.value.enabled}checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};r=de([J(0,c.IUserDataSyncStoreService),J(1,c.IUserDataSyncStoreManagementService),J(2,d.IInstantiationService),J(3,P.IConfigurationService),J(4,c.IUserDataSyncLogService),J(5,h.ITelemetryService),J(6,S.IStorageService),J(7,c.IUserDataSyncEnablementService)],r),e.UserDataSyncService=r;class a extends k.Disposable{constructor(o,u,f,v,I,O,A){super();this.id=o,this.manifest=u,this.syncHeaders=f,this.synchronisers=v,this.onStop=I,this.configurationService=O,this.logService=A,this.synchronizingResources=[],this._onSynchronizeResources=this._register(new _.Emitter),this.onSynchronizeResources=this._onSynchronizeResources.event,this.isDisposed=!1}get status(){return this.synchronisers.some(o=>o.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(o=>o.status==="syncing")?"syncing":"idle"}async preview(){try{if(this.isDisposed)throw new Error("Disposed");return this.previewsPromise||(this.previewsPromise=(0,i.createCancelablePromise)(o=>this.getPreviews(o))),this.previews||(this.previews=await this.previewsPromise),this.previews}catch(o){throw this.logService.error(o),o}}async accept(o,u){try{return await this.performAction(o,f=>f.accept(o,u))}catch(f){throw this.logService.error(f),f}}async merge(o){try{return o?await this.performAction(o,u=>u.merge(o)):await this.mergeAll()}catch(u){throw this.logService.error(u),u}}async discard(o){try{return await this.performAction(o,u=>u.discard(o))}catch(u){throw this.logService.error(u),u}}async discardConflicts(){try{if(!this.previews)throw new Error("Missing preview. Create preview and try again.");if(this.synchronizingResources.length)throw new Error("Cannot discard while synchronizing resources");const o=[];for(const[,u]of this.previews)for(const f of u.resourcePreviews)f.mergeState==="conflict"&&o.push(f.previewResource);for(const u of o)await this.discard(u);return this.previews}catch(o){throw this.logService.error(o),o}}async apply(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");const o=[];for(const[u,f]of this.previews){this.synchronizingResources.push([u,f.resourcePreviews.map(O=>O.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const v=this.synchronisers.find(O=>O.resource===u);for(const O of f.resourcePreviews)(O.localChange!==0||O.remoteChange!==0)&&O.mergeState==="preview"&&await v.merge(O.previewResource);const I=await v.apply(!1,this.syncHeaders);I&&o.push(this.toSyncResourcePreview(v.resource,I)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(O=>O[0]===u),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=o,this.previews}catch(o){throw this.logService.error(o),o}}async pull(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[o,u]of this.previews){this.synchronizingResources.push([o,u.resourcePreviews.map(v=>v.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const f=this.synchronisers.find(v=>v.resource===o);for(const v of u.resourcePreviews)await f.accept(v.remoteResource);await f.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(v=>v[0]===o),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(o){throw this.logService.error(o),o}}async push(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[o,u]of this.previews){this.synchronizingResources.push([o,u.resourcePreviews.map(v=>v.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const f=this.synchronisers.find(v=>v.resource===o);for(const v of u.resourcePreviews)await f.accept(v.localResource);await f.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(v=>v[0]===o),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(o){throw this.logService.error(o),o}}async stop(){await this.onStop(),this.reset()}async performAction(o,u){if(!this.previews)throw new Error("Missing preview. Create preview and try again.");const f=this.previews.findIndex(([,F])=>F.resourcePreviews.some(({localResource:M,previewResource:U,remoteResource:B})=>(0,R.isEqual)(o,M)||(0,R.isEqual)(o,U)||(0,R.isEqual)(o,B)));if(f===-1)return this.previews;const[v,I]=this.previews[f],O=I.resourcePreviews.find(({localResource:F,remoteResource:M,previewResource:U})=>(0,R.isEqual)(F,o)||(0,R.isEqual)(M,o)||(0,R.isEqual)(U,o));if(!O)return this.previews;let A=this.synchronizingResources.find(F=>F[0]===v);A||(A=[v,[]],this.synchronizingResources.push(A)),A[1].some(F=>(0,R.isEqual)(F,O.localResource))||(A[1].push(O.localResource),this._onSynchronizeResources.fire(this.synchronizingResources));const N=this.synchronisers.find(F=>F.resource===this.previews[f][0]),$=await u(N);$?this.previews.splice(f,1,this.toSyncResourcePreview(N.resource,$)):this.previews.splice(f,1);const T=this.synchronizingResources.findIndex(F=>F[0]===v);return this.synchronizingResources[T][1].splice(A[1].findIndex(F=>(0,R.isEqual)(F,O.localResource)),1),A[1].length||(this.synchronizingResources.splice(T,1),this._onSynchronizeResources.fire(this.synchronizingResources)),this.previews}async mergeAll(){if(!this.previews)throw new Error("You need to create preview before merging or applying");if(this.synchronizingResources.length)throw new Error("Cannot merge or apply while synchronizing resources");const o=[];for(const[u,f]of this.previews){this.synchronizingResources.push([u,f.resourcePreviews.map(O=>O.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const v=this.synchronisers.find(O=>O.resource===u);let I=f;for(const O of f.resourcePreviews)(O.localChange!==0||O.remoteChange!==0)&&O.mergeState==="preview"&&(I=await v.merge(O.previewResource));I&&o.push(this.toSyncResourcePreview(v.resource,I)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(O=>O[0]===u),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=o,this.previews}async getPreviews(o){const u=[],f=await this.getUserDataSyncConfiguration();for(const v of this.synchronisers){if(o.isCancellationRequested)return[];const I=await v.preview(this.manifest,f,this.syncHeaders);I&&u.push(this.toSyncResourcePreview(v.resource,I))}return u}async getUserDataSyncConfiguration(){const o=this.configurationService.getValue(c.USER_DATA_SYNC_CONFIGURATION_SCOPE),u=await this.synchronisers.find(f=>f instanceof w.SettingsSynchroniser).getRemoteUserDataSyncConfiguration(this.manifest);return{...o,...u}}toSyncResourcePreview(o,u){return[o,{isLastSyncFromCurrentMachine:u.isLastSyncFromCurrentMachine,resourcePreviews:u.resourcePreviews.map(t)}]}reset(){this.previewsPromise&&(this.previewsPromise.cancel(),this.previewsPromise=void 0),this.previews=void 0,this.synchronizingResources=[]}dispose(){this.reset(),this.isDisposed=!0}}let n=class extends k.Disposable{constructor(o,u,f,v,I,O,A){super();this.onDidChangeStatus=o,this.onDidChangeConflicts=u,this.onDidChangeLocal=f,this.userDataSyncEnablementService=v,this.instantiationService=I,this.extensionGalleryService=O,this.logService=A,this._enabled=[],this._register(v.onDidChangeResourceEnablement(([N,$])=>this.onDidChangeResourceEnablement(N,$))),this._register((0,k.toDisposable)(()=>this._enabled.splice(0,this._enabled.length).forEach(([,,N])=>N.dispose())));for(const N of c.ALL_SYNC_RESOURCES)v.isResourceEnabled(N)&&this.registerSynchronizer(N)}get enabled(){return this._enabled.sort((o,u)=>o[1]-u[1]).map(([o])=>o)}get disabled(){return c.ALL_SYNC_RESOURCES.filter(o=>!this.userDataSyncEnablementService.isResourceEnabled(o))}onDidChangeResourceEnablement(o,u){u?this.registerSynchronizer(o):this.deRegisterSynchronizer(o)}registerSynchronizer(o){if(this._enabled.some(([I])=>I.resource===o))return;if(o==="extensions"&&!this.extensionGalleryService.isEnabled()){this.logService.info("Skipping extensions sync because gallery is not configured");return}const u=new k.DisposableStore,f=u.add(this.createSynchronizer(o));u.add(f.onDidChangeStatus(()=>this.onDidChangeStatus(this.enabled))),u.add(f.onDidChangeConflicts(()=>this.onDidChangeConflicts(this.enabled))),u.add(f.onDidChangeLocal(()=>this.onDidChangeLocal(o)));const v=this.getOrder(o);this._enabled.push([f,v,u])}deRegisterSynchronizer(o){const u=this._enabled.findIndex(([f])=>f.resource===o);if(u!==-1){const f=this._enabled.splice(u,1);for(const[v,,I]of f){if(v.status!=="idle"){const O=v.conflicts.length>0;v.stop(),O&&this.onDidChangeConflicts(this.enabled),this.onDidChangeStatus(this.enabled)}I.dispose()}}}createSynchronizer(o){switch(o){case"settings":return this.instantiationService.createInstance(w.SettingsSynchroniser);case"keybindings":return this.instantiationService.createInstance(m.KeybindingsSynchroniser);case"snippets":return this.instantiationService.createInstance(g.SnippetsSynchroniser);case"globalState":return this.instantiationService.createInstance(p.GlobalStateSynchroniser);case"extensions":return this.instantiationService.createInstance(y.ExtensionsSynchroniser)}}getOrder(o){switch(o){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"globalState":return 3;case"extensions":return 4}}};n=de([J(3,c.IUserDataSyncEnablementService),J(4,d.IInstantiationService),J(5,b.IExtensionGalleryService),J(6,c.IUserDataSyncLogService)],n);function t(s){return{localResource:s.localResource,previewResource:s.previewResource,remoteResource:s.remoteResource,acceptedResource:s.acceptedResource,localChange:s.localChange,remoteChange:s.remoteChange,mergeState:s.mergeState}}}),define(te[232],ne([0,1,3,2,15,7,24]),function(Q,e,L,i,D,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;class R{constructor(b,d){this.service=b,this.logService=d,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new L.Emitter}listen(b,d){switch(d){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${d}`)}async call(b,d,S){try{return await this._call(b,d,S)}catch(h){throw this.logService.error(h),h}}async _call(b,d,S){switch(d){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"replace":return this.service.replace(_.URI.revive(S[0]));case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"accept":return this.service.accept(S[0],_.URI.revive(S[1]),S[2],S[3]);case"resolveContent":return this.service.resolveContent(_.URI.revive(S[0]));case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(S[0]);case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(S[0]);case"getAssociatedResources":return this.service.getAssociatedResources(S[0],{created:S[1].created,uri:_.URI.revive(S[1].uri)});case"getMachineId":return this.service.getMachineId(S[0],{created:S[1].created,uri:_.URI.revive(S[1].uri)});case"createManualSyncTask":return this.createManualSyncTask()}if(d.startsWith("manualSync/")){const h=d.substring("manualSync/".length),y=S[0],p=this.getManualSyncTask(y);switch(S=S.slice(1),h){case"preview":return p.preview();case"accept":return p.accept(_.URI.revive(S[0]),S[1]);case"merge":return p.merge(_.URI.revive(S[0]));case"discard":return p.discard(_.URI.revive(S[0]));case"discardConflicts":return p.discardConflicts();case"apply":return p.apply();case"pull":return p.pull();case"push":return p.push();case"stop":return p.stop();case"_getStatus":return p.status;case"dispose":return this.disposeManualSyncTask(p)}}throw new Error("Invalid call")}getManualSyncTask(b){const d=this.manualSyncTasks.get(this.createKey(b));if(!d)throw new Error(`Manual sync taks not found: ${b}`);return d.manualSyncTask}async createManualSyncTask(){const b=new i.DisposableStore,d=b.add(await this.service.createManualSyncTask());return b.add(d.onSynchronizeResources(S=>this.onManualSynchronizeResources.fire({manualSyncTaskId:d.id,data:S}))),this.manualSyncTasks.set(this.createKey(d.id),{manualSyncTask:d,disposables:b}),{id:d.id,manifest:d.manifest,status:d.status}}disposeManualSyncTask(b){b.dispose();const d=this.createKey(b.id);this.manualSyncTasks.get(d)?.disposables.dispose(),this.manualSyncTasks.delete(d)}createKey(b){return`manualSyncTask-${b}`}}e.UserDataSyncChannel=R;class E extends i.Disposable{constructor(b){super();this._status="uninitialized",this._onDidChangeStatus=this._register(new L.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new L.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new L.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new L.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(d,S,h){return b.call(d,S,h).then(null,y=>{throw k.UserDataSyncError.toUserDataSyncError(y)})},listen(d,S){return b.listen(d,S)}},this.channel.call("_getInitialData").then(([d,S,h])=>{this.updateStatus(d),this.updateConflicts(S),h&&this.updateLastSyncTime(h),this._register(this.channel.listen("onDidChangeStatus")(y=>this.updateStatus(y))),this._register(this.channel.listen("onDidChangeLastSyncTime")(y=>this.updateLastSyncTime(y)))}),this._register(this.channel.listen("onDidChangeConflicts")(d=>this.updateConflicts(d))),this._register(this.channel.listen("onSyncErrors")(d=>this._onSyncErrors.fire(d.map(([S,h])=>[S,k.UserDataSyncError.toUserDataSyncError(h)]))))}get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const{id:b,manifest:d,status:S}=await this.channel.call("createManualSyncTask"),h=this,y=new C(b,d,S,{async call(p,m,w){return h.channel.call(`manualSync/${p}`,[b,...(0,D.isArray)(m)?m:[m]],w)},listen(p,m){return L.Event.map(L.Event.filter(h.channel.listen(`manualSync/${p}`,m),w=>!y.isDiposed()&&w.manualSyncTaskId===b),w=>w.data)}});return y}replace(b){return this.channel.call("replace",[b])}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(b,d,S,h){return this.channel.call("accept",[b,d,S,h])}resolveContent(b){return this.channel.call("resolveContent",[b])}async getLocalSyncResourceHandles(b){return(await this.channel.call("getLocalSyncResourceHandles",[b])).map(({created:S,uri:h})=>({created:S,uri:_.URI.revive(h)}))}async getRemoteSyncResourceHandles(b){return(await this.channel.call("getRemoteSyncResourceHandles",[b])).map(({created:S,uri:h})=>({created:S,uri:_.URI.revive(h)}))}async getAssociatedResources(b,d){return(await this.channel.call("getAssociatedResources",[b,d])).map(({resource:h,comparableResource:y})=>({resource:_.URI.revive(h),comparableResource:_.URI.revive(y)}))}async getMachineId(b,d){return this.channel.call("getMachineId",[b,d])}async updateStatus(b){this._status=b,this._onDidChangeStatus.fire(b)}async updateConflicts(b){this._conflicts=b.map(([d,S])=>[d,S.map(h=>({...h,localResource:_.URI.revive(h.localResource),remoteResource:_.URI.revive(h.remoteResource),previewResource:_.URI.revive(h.previewResource)}))]),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(b){this._lastSyncTime!==b&&(this._lastSyncTime=b,this._onDidChangeLastSyncTime.fire(b))}}e.UserDataSyncChannelClient=E;class C extends i.Disposable{constructor(b,d,S,h){super();this.id=b,this.manifest=d,this._disposed=!1,this._status=S;const y=this;this.channel={async call(p,m,w){try{const g=await h.call(p,m,w);return y.isDiposed()||(y._status=await h.call("_getStatus")),g}catch(g){throw k.UserDataSyncError.toUserDataSyncError(g)}},listen(p,m){return h.listen(p,m)}}}get onSynchronizeResources(){return this.channel.listen("onSynchronizeResources")}get status(){return this._status}async preview(){const b=await this.channel.call("preview");return this.deserializePreviews(b)}async accept(b,d){const S=await this.channel.call("accept",[b,d]);return this.deserializePreviews(S)}async merge(b){const d=await this.channel.call("merge",[b]);return this.deserializePreviews(d)}async discard(b){const d=await this.channel.call("discard",[b]);return this.deserializePreviews(d)}async discardConflicts(){const b=await this.channel.call("discardConflicts");return this.deserializePreviews(b)}async apply(){const b=await this.channel.call("apply");return this.deserializePreviews(b)}pull(){return this.channel.call("pull")}push(){return this.channel.call("push")}stop(){return this.channel.call("stop")}isDiposed(){return this._disposed}dispose(){this._disposed=!0,this.channel.call("dispose")}deserializePreviews(b){return b.map(([d,S])=>[d,{isLastSyncFromCurrentMachine:S.isLastSyncFromCurrentMachine,resourcePreviews:S.resourcePreviews.map(h=>({...h,localResource:_.URI.revive(h.localResource),remoteResource:_.URI.revive(h.remoteResource),previewResource:_.URI.revive(h.previewResource),acceptedResource:_.URI.revive(h.acceptedResource)}))}])}}}),define(te[233],ne([0,1,5,27,10,3,2,108,4,18,15,7,30,21,11,14,26,42,45,23,24]),function(Q,e,L,i,D,_,k,R,E,C,P,b,d,S,h,y,p,m,w,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const l="sync.previous.store",r="sync.donot-make-requests-until",a="sync.user-session-id",n="sync.machine-session-id",t=100,s=1e3*60*5;let o=class extends k.Disposable{constructor(A,N,$){super();this.productService=A,this.configurationService=N,this.storageService=$,this._onDidChangeUserDataSyncStore=this._register(new _.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(_.Event.filter($.onDidChangeValue,T=>T.key===c.SYNC_SERVICE_URL_TYPE&&T.scope===0&&this.userDataSyncStoreType!==this.userDataSyncStore?.type)(()=>this.updateUserDataSyncStore()))}get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(c.SYNC_SERVICE_URL_TYPE,0)}set userDataSyncStoreType(A){this.storageService.store(c.SYNC_SERVICE_URL_TYPE,A,0,E.isWeb?0:1)}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[c.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(c.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(A,N){A=E.isWeb&&A?.web?{...A,...A.web}:A;const $={...A||{},...N||{}};if($&&(0,P.isString)($.url)&&(0,P.isObject)($.authenticationProviders)&&Object.keys($.authenticationProviders).every(T=>(0,P.isArray)($.authenticationProviders[T].scopes))){const T=$,F=!!T.canSwitch&&!N?.url,M=T.url===T.insidersUrl?"insiders":"stable",U=(F?this.userDataSyncStoreType:void 0)||M,B=N?.url||(U==="insiders"?T.insidersUrl:U==="stable"?T.stableUrl:T.url);return{url:b.URI.parse(B),type:U,defaultType:M,defaultUrl:b.URI.parse(T.url),stableUrl:b.URI.parse(T.stableUrl),insidersUrl:b.URI.parse(T.insidersUrl),canSwitch:F,authenticationProviders:Object.keys(T.authenticationProviders).reduce((ee,H)=>(ee.push({id:H,scopes:T.authenticationProviders[H].scopes}),ee),[])}}}};o=de([J(0,p.IProductService),J(1,S.IConfigurationService),J(2,g.IStorageService)],o),e.AbstractUserDataSyncStoreManagementService=o;let u=class extends o{constructor(A,N,$){super(A,N,$);const T=this.storageService.get(l,0);T&&(this.previousConfigurationSyncStore=JSON.parse(T));const F=this.productService[c.CONFIGURATION_SYNC_STORE_KEY];F?this.storageService.store(l,JSON.stringify(F),0,1):this.storageService.remove(l,0)}async switch(A){A!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=A,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};u=de([J(0,p.IProductService),J(1,S.IConfigurationService),J(2,g.IStorageService)],u),e.UserDataSyncStoreManagementService=u;let f=class extends k.Disposable{constructor(A,N,$,T,F,M,U){super();this.requestService=$,this.logService=T,this.storageService=U,this._onTokenFailed=this._register(new _.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new _.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new _.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(A),this.commonHeadersPromise=(0,w.getServiceMachineId)(F,M,U).then(B=>{const ee={"X-Client-Name":`${N.applicationName}${E.isWeb?"-web":""}`,"X-Client-Version":N.version};return N.commit&&(ee["X-Client-Commit"]=N.commit),ee}),this.session=new I(t,s,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,k.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}setAuthToken(A,N){this.authToken={token:A,type:N}}updateUserDataSyncStoreUrl(A){this.userDataSyncStoreUrl=A?(0,C.joinPath)(A,"v1"):void 0}initDonotMakeRequestsUntil(){const A=this.storageService.getNumber(r,0);A&&Date.now()<A&&this.setDonotMakeRequestsUntil(new Date(A))}setDonotMakeRequestsUntil(A){this._donotMakeRequestsUntil?.getTime()!==A?.getTime()&&(this._donotMakeRequestsUntil=A,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(r,this._donotMakeRequestsUntil.getTime(),0,1),this.resetDonotMakeRequestsUntilPromise=(0,L.createCancelablePromise)(N=>(0,L.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),N).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,N=>null)):this.storageService.remove(r,0),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllRefs(A){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const N=(0,C.joinPath)(this.userDataSyncStoreUrl,"resource",A),$={},T=await this.request(N.toString(),{type:"GET",headers:$},[],i.CancellationToken.None);return(await(0,m.asJson)(T)||[]).map(({url:M,created:U})=>({ref:(0,C.relativePath)(N,N.with({path:M})),created:U*1e3}))}async resolveContent(A,N){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const $=(0,C.joinPath)(this.userDataSyncStoreUrl,"resource",A,N).toString(),T={};T["Cache-Control"]="no-cache";const F=await this.request($,{type:"GET",headers:T},[],i.CancellationToken.None);return await(0,m.asText)(F)}async delete(A){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const N=(0,C.joinPath)(this.userDataSyncStoreUrl,"resource",A).toString(),$={};await this.request(N,{type:"DELETE",headers:$},[],i.CancellationToken.None)}async read(A,N,$={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const T=(0,C.joinPath)(this.userDataSyncStoreUrl,"resource",A,"latest").toString();$={...$},$["Cache-Control"]="no-cache",N&&($["If-None-Match"]=N.ref);const F=await this.request(T,{type:"GET",headers:$},[304],i.CancellationToken.None);let M=null;if(F.res.statusCode===304&&(M=N),M===null){const U=F.res.headers.etag;if(!U)throw new c.UserDataSyncStoreError("Server did not return the ref",T,"NoRef",F.res.statusCode,F.res.headers[c.HEADER_OPERATION_ID]);const B=await(0,m.asText)(F);if(!B&&F.res.statusCode===304)throw new c.UserDataSyncStoreError("Empty response",T,"EmptyResponse",F.res.statusCode,F.res.headers[c.HEADER_OPERATION_ID]);M={ref:U,content:B}}return M}async write(A,N,$,T={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=(0,C.joinPath)(this.userDataSyncStoreUrl,"resource",A).toString();T={...T},T["Content-Type"]=R.Mimes.text,$&&(T["If-Match"]=$);const M=await this.request(F,{type:"POST",data:N,headers:T},[],i.CancellationToken.None),U=M.res.headers.etag;if(!U)throw new c.UserDataSyncStoreError("Server did not return the ref",F,"NoRef",M.res.statusCode,M.res.headers[c.HEADER_OPERATION_ID]);return U}async manifest(A,N={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const $=(0,C.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();N={...N},N["Content-Type"]="application/json",A&&(N["If-None-Match"]=A.ref);const T=await this.request($,{type:"GET",headers:N},[304],i.CancellationToken.None);let F=null;if(T.res.statusCode===304&&(F=A),!F){const U=T.res.headers.etag;if(!U)throw new c.UserDataSyncStoreError("Server did not return the ref",$,"NoRef",T.res.statusCode,T.res.headers[c.HEADER_OPERATION_ID]);const B=await(0,m.asText)(T);if(!B&&T.res.statusCode===304)throw new c.UserDataSyncStoreError("Empty response",$,"EmptyResponse",T.res.statusCode,T.res.headers[c.HEADER_OPERATION_ID]);B&&(F={...JSON.parse(B),ref:U})}const M=this.storageService.get(a,0);return M&&F&&M!==F.session&&this.clearSession(),F===null&&M&&this.clearSession(),F&&this.storageService.store(a,F.session,0,1),F}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const A=(0,C.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),N={"Content-Type":R.Mimes.text};await this.request(A,{type:"DELETE",headers:N},[],i.CancellationToken.None),this.clearSession()}clearSession(){this.storageService.remove(a,0),this.storageService.remove(n,0)}async request(A,N,$,T){if(!this.authToken)throw new c.UserDataSyncStoreError("No Auth Token Available",A,"Unauthorized",void 0,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new c.UserDataSyncStoreError(`${N.type} request '${A}' failed because of too many requests (429).`,A,"TooManyRequestsAndRetryAfter",void 0,void 0);this.setDonotMakeRequestsUntil(void 0);const F=await this.commonHeadersPromise;N.headers={...N.headers||{},...F,"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`},this.addSessionHeaders(N.headers),this.logService.trace("Sending request to server",{url:A,type:N.type,headers:{...N.headers,authorization:void 0}});let M;try{M=await this.session.request(A,N,T)}catch(H){if(!(H instanceof c.UserDataSyncStoreError)){let j="RequestFailed";const Z=(0,D.getErrorMessage)(H).toLowerCase();Z.includes("xhr timeout")?j="RequestTimeout":Z.includes("protocol")&&Z.includes("not supported")?j="RequestProtocolNotSupported":Z.includes("request path contains unescaped characters")?j="RequestPathNotEscaped":Z.includes("headers must be an object")?j="RequestHeadersNotObject":(0,D.isPromiseCanceledError)(H)&&(j="RequestCanceled"),H=new c.UserDataSyncStoreError(`Connection refused for the request '${A}'.`,A,j,void 0,void 0)}throw this.logService.info("Request failed",A),H}const U=M.res.headers[c.HEADER_OPERATION_ID],B={url:A,status:M.res.statusCode,"execution-id":N.headers[c.HEADER_EXECUTION_ID],"operation-id":U},ee=(0,m.isSuccess)(M)||M.res.statusCode&&$.indexOf(M.res.statusCode)!==-1;if(ee?this.logService.trace("Request succeeded",B):this.logService.info("Request failed",B),M.res.statusCode===401)throw this.authToken=void 0,this._onTokenFailed.fire(),new c.UserDataSyncStoreError(`Request '${A}' failed because of Unauthorized (401).`,A,"Unauthorized",M.res.statusCode,U);if(this._onTokenSucceed.fire(),M.res.statusCode===409)throw new c.UserDataSyncStoreError(`${N.type} request '${A}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,A,"Conflict",M.res.statusCode,U);if(M.res.statusCode===410)throw new c.UserDataSyncStoreError(`${N.type} request '${A}' failed because the requested resource is not longer available (410).`,A,"Gone",M.res.statusCode,U);if(M.res.statusCode===412)throw new c.UserDataSyncStoreError(`${N.type} request '${A}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,A,"PreconditionFailed",M.res.statusCode,U);if(M.res.statusCode===413)throw new c.UserDataSyncStoreError(`${N.type} request '${A}' failed because of too large payload (413).`,A,"TooLarge",M.res.statusCode,U);if(M.res.statusCode===426)throw new c.UserDataSyncStoreError(`${N.type} request '${A}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,A,"UpgradeRequired",M.res.statusCode,U);if(M.res.statusCode===429){const H=M.res.headers["retry-after"];throw H?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(H)*1e3)),new c.UserDataSyncStoreError(`${N.type} request '${A}' failed because of too many requests (429).`,A,"TooManyRequestsAndRetryAfter",M.res.statusCode,U)):new c.UserDataSyncStoreError(`${N.type} request '${A}' failed because of too many requests (429).`,A,"RemoteTooManyRequests",M.res.statusCode,U)}if(!ee)throw new c.UserDataSyncStoreError("Server returned "+M.res.statusCode,A,"Unknown",M.res.statusCode,U);return M}addSessionHeaders(A){let N=this.storageService.get(n,0);N===void 0&&(N=(0,d.generateUuid)(),this.storageService.store(n,N,0,1)),A["X-Machine-Session-Id"]=N;const $=this.storageService.get(a,0);$!==void 0&&(A["X-User-Session-Id"]=$)}};f=de([J(1,p.IProductService),J(2,m.IRequestService),J(3,c.IUserDataSyncLogService),J(4,h.IEnvironmentService),J(5,y.IFileService),J(6,g.IStorageService)],f),e.UserDataSyncStoreClient=f;let v=class extends f{constructor(A,N,$,T,F,M,U){super(A.userDataSyncStore?.url,N,$,T,F,M,U);this._register(A.onDidChangeUserDataSyncStore(()=>this.updateUserDataSyncStoreUrl(A.userDataSyncStore?.url)))}};v=de([J(0,c.IUserDataSyncStoreManagementService),J(1,p.IProductService),J(2,m.IRequestService),J(3,c.IUserDataSyncLogService),J(4,h.IEnvironmentService),J(5,y.IFileService),J(6,g.IStorageService)],v),e.UserDataSyncStoreService=v;class I{constructor(A,N,$,T){this.limit=A,this.interval=N,this.requestService=$,this.logService=T,this.requests=[],this.startTime=void 0}request(A,N,$){if(this.isExpired()&&this.reset(),N.url=A,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new c.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,A,"LocalTooManyRequests",void 0,void 0);return this.startTime=this.startTime||new Date,this.requests.push(A),this.requestService.request(N,$)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=I}),define(te[234],ne([0,1,3,60,26,23,22,230,24,63,64]),function(Q,e,L,i,D,_,k,R,E,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let b=class extends R.UserDataAutoSyncService{constructor(S,h,y,p,m,w,g,c,l,r,a){super(S,h,y,p,m,g,c,l,r,a);this._register(L.Event.debounce(L.Event.any(L.Event.map(w.onDidFocusWindow,()=>"windowFocus"),L.Event.map(w.onDidOpenWindow,()=>"windowOpen")),(n,t)=>n?[...n,t]:[t],1e3)(n=>this.triggerSync(n,!0,!1)))}};b=de([J(0,D.IProductService),J(1,E.IUserDataSyncStoreManagementService),J(2,E.IUserDataSyncStoreService),J(3,E.IUserDataSyncEnablementService),J(4,E.IUserDataSyncService),J(5,i.INativeHostService),J(6,E.IUserDataSyncLogService),J(7,C.IUserDataSyncAccountService),J(8,k.ITelemetryService),J(9,P.IUserDataSyncMachinesService),J(10,_.IStorageService)],b),e.UserDataAutoSyncService=b}),define(te[235],ne([0,1,5,3,2]),function(Q,e,L,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class _ extends D.Disposable{constructor({onDidOpenWindow:R,onDidFocusWindow:E,getActiveWindowId:C}){super();this.disposables=this._register(new D.DisposableStore),i.Event.latch(i.Event.any(R,E))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,L.createCancelablePromise)(()=>C()),(async()=>{try{const b=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:b}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(R){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=R}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=_}),define(te[65],ne([0,1,50,5,9,15,20,124,247,248]),function(Q,e,L,i,D,_,k,R,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class P extends Error{constructor(r,a){let n=a.message;switch(r){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n);this.type=r,this.cause=a}}e.ExtractError=P;function b(l){const r=l.externalFileAttributes>>16||33188;return[448,56,7].map(a=>r&a).reduce((a,n)=>a+n,r&61440)}function d(l){if(l instanceof P)return l;let r;return/end of central directory record signature not found/.test(l.message)&&(r="CorruptZip"),new P(r,l)}function S(l,r,a,n,t,s){const o=D.dirname(r),u=D.join(n,o);if(!u.startsWith(n))return Promise.reject(new Error(R.localize(0,null,r)));const f=D.join(n,r);let v;return s.onCancellationRequested(()=>{v&&v.destroy()}),Promise.resolve(k.Promises.mkdir(u,{recursive:!0})).then(()=>new Promise((I,O)=>{if(!s.isCancellationRequested)try{v=(0,L.createWriteStream)(f,{mode:a}),v.once("close",()=>I()),v.once("error",O),l.once("error",O),l.pipe(v)}catch(A){O(A)}}))}function h(l,r,a,n){let t=(0,i.createCancelablePromise)(()=>Promise.resolve()),s=0;return n.onCancellationRequested(()=>{t.cancel(),l.close()}),new Promise((o,u)=>{const f=new i.Sequencer,v=I=>{I.isCancellationRequested||(s++,l.readEntry())};l.once("error",u),l.once("close",()=>t.then(()=>{n.isCancellationRequested||l.entryCount===s?o():u(new P("Incomplete",new Error(R.localize(1,null,s,l.entryCount))))},u)),l.readEntry(),l.on("entry",I=>{if(n.isCancellationRequested)return;if(!a.sourcePathRegex.test(I.fileName)){v(n);return}const O=I.fileName.replace(a.sourcePathRegex,"");if(/\/$/.test(O)){const $=D.join(r,O);t=(0,i.createCancelablePromise)(T=>k.Promises.mkdir($,{recursive:!0}).then(()=>v(T)).then(void 0,u));return}const A=p(l,I),N=b(I);t=(0,i.createCancelablePromise)($=>f.queue(()=>A.then(T=>S(T,O,N,r,a,$).then(()=>v($)))).then(null,u))})})}function y(l,r=!1){return new Promise((a,n)=>{(0,E.open)(l,r?{lazyEntries:!0}:void 0,(t,s)=>{t?n(d(t)):a((0,_.assertIsDefined)(s))})})}function p(l,r){return new Promise((a,n)=>{l.openReadStream(r,(t,s)=>{t?n(d(t)):a((0,_.assertIsDefined)(s))})})}function m(l,r){return new Promise((a,n)=>{const t=new C.ZipFile;r.forEach(o=>{o.contents?t.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&t.addFile(o.localPath,o.path)}),t.end();const s=(0,L.createWriteStream)(l);t.outputStream.pipe(s),t.outputStream.once("error",n),s.once("error",n),s.once("finish",()=>a(l))})}e.zip=m;function w(l,r,a={},n){const t=new RegExp(a.sourcePath?`^${a.sourcePath}`:"");let s=y(l,!0);return a.overwrite&&(s=s.then(o=>k.Promises.rm(r).then(()=>o))),s.then(o=>h(o,r,{sourcePathRegex:t},n))}e.extract=w;function g(l,r){return y(l).then(a=>new Promise((n,t)=>{a.on("entry",s=>{s.fileName===r&&p(a,s).then(o=>n(o),o=>t(o))}),a.once("close",()=>t(new Error(R.localize(2,null,r))))}))}function c(l,r){return g(l,r).then(a=>new Promise((n,t)=>{const s=[];a.once("error",t),a.on("data",o=>s.push(o)),a.on("end",()=>n(Buffer.concat(s)))}))}e.buffer=c}),define(te[236],ne([0,1,65,133]),function(Q,e,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function D(_){return(0,L.buffer)(_,"extension/package.json").then(k=>{try{return JSON.parse(k.toString("utf8"))}catch{throw new Error((0,i.localize)(0,null))}})}e.getManifest=D}),define(te[237],ne([0,1,16,5,10,2,17,9,4,18,61,7,30,20,65,134,11,29,34,155,14,8,26]),function(Q,e,L,i,D,_,k,R,E,C,P,b,d,S,h,y,p,m,w,g,c,l,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScanner=void 0;let a=class extends _.Disposable{constructor(t,s,o,u,f){super();this.beforeRemovingExtension=t,this.fileService=s,this.logService=o,this.environmentService=u,this.productService=f,this._devSystemExtensionsPath=null,this.systemExtensionsPath=u.builtinExtensionsPath,this.extensionsPath=u.extensionsPath,this.uninstalledPath=R.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new i.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(t){const s=[];(t===null||t===0)&&s.push(this.scanSystemExtensions().then(null,o=>Promise.reject(new m.ExtensionManagementError(this.joinErrors(o).message,m.ExtensionManagementErrorCode.Internal)))),(t===null||t===1)&&s.push(this.scanUserExtensions(!0).then(null,o=>Promise.reject(new m.ExtensionManagementError(this.joinErrors(o).message,m.ExtensionManagementErrorCode.Internal))));try{const o=await Promise.all(s);return(0,L.flatten)(o)}catch(o){throw this.joinErrors(o)}}async scanUserExtensions(t){this.logService.trace("Started scanning user extensions");let[s,o]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return o=o.filter(u=>!s[new w.ExtensionIdentifierWithVersion(u.identifier,u.manifest.version).key()]),t&&(o=(0,w.groupByExtension)(o,f=>f.identifier).map(f=>f.sort((v,I)=>P.rcompare(v.manifest.version,I.manifest.version))[0])),this.logService.trace("Scanned user extensions:",o.length),o}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(t,s,o,u){const f=t.key(),v=R.join(this.extensionsPath,`.${(0,d.generateUuid)()}`),I=R.join(this.extensionsPath,f);try{await S.Promises.rm(I)}catch{try{await S.Promises.rm(I)}catch{}throw new m.ExtensionManagementError((0,y.localize)(0,null,I,t.id),m.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(t,s,v,u);let O=await this.scanExtension(b.URI.file(v),1);if(!O)throw new Error((0,y.localize)(1,null,v));await this.storeMetadata(O,{...o,installedTimestamp:Date.now()});try{await this.rename(t,v,I,Date.now()+2*60*1e3),this.logService.info("Renamed to",I)}catch(A){try{await S.Promises.rm(v)}catch{}if(A.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",t.id);else throw this.logService.info(`Rename failed because of ${(0,D.getErrorMessage)(A)}. Deleted from extracted location`,v),A}try{O=await this.scanExtension(b.URI.file(I),1)}catch{}if(O)return O;throw new Error((0,y.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(t,s){return this.setMetadata(t,s),await this.storeMetadata(t,{...s,installedTimestamp:t.installedTimestamp}),t}async storeMetadata(t,s){s.isMachineScoped=s.isMachineScoped||void 0,s.isBuiltin=s.isBuiltin||void 0,s.installedTimestamp=s.installedTimestamp||void 0;const o=R.join(t.location.fsPath,"package.json"),u=await S.Promises.readFile(o,"utf8"),{manifest:f}=await this.parseManifest(u);return f.__metadata=s,await S.Promises.writeFile(o,JSON.stringify(f,null,"	")),t}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...t){const s=t.map(o=>new w.ExtensionIdentifierWithVersion(o.identifier,o.manifest.version));await this.withUninstalledExtensions(o=>{s.forEach(u=>o[u.key()]=!0)})}async setInstalled(t){await this.withUninstalledExtensions(u=>delete u[t.key()]);const o=(await this.scanExtensions(1)).find(u=>new w.ExtensionIdentifierWithVersion(u.identifier,u.manifest.version).equals(t))||null;return o?(await this.storeMetadata(o,{installedTimestamp:Date.now()}),this.scanExtension(o.location,1)):null}async withUninstalledExtensions(t){return this.uninstalledFileLimiter.queue(async()=>{let s;try{s=await S.Promises.readFile(this.uninstalledPath,"utf8")}catch(u){if(u.code!=="ENOENT")throw u}let o={};if(s)try{o=JSON.parse(s)}catch{}return t&&(t(o),Object.keys(o).length?await S.Promises.writeFile(this.uninstalledPath,JSON.stringify(o)):await S.Promises.rm(this.uninstalledPath)),o})}async removeExtension(t,s){this.logService.trace(`Deleting ${s} extension from disk`,t.identifier.id,t.location.fsPath),await S.Promises.rm(t.location.fsPath),this.logService.info("Deleted from disk",t.identifier.id,t.location.fsPath)}async removeUninstalledExtension(t){await this.removeExtension(t,"uninstalled"),await this.withUninstalledExtensions(s=>delete s[new w.ExtensionIdentifierWithVersion(t.identifier,t.manifest.version).key()])}async extractAtLocation(t,s,o,u){this.logService.trace(`Started extracting the extension from ${s} to ${o}`);try{await S.Promises.rm(o)}catch(f){throw new m.ExtensionManagementError(this.joinErrors(f).message,m.ExtensionManagementErrorCode.Delete)}try{await(0,h.extract)(s,o,{sourcePath:"extension",overwrite:!0},u),this.logService.info(`Extracted extension to ${o}:`,t.id)}catch(f){try{await S.Promises.rm(o)}catch{}let v=m.ExtensionManagementErrorCode.Extract;throw f instanceof h.ExtractError&&(f.type==="CorruptZip"?v=m.ExtensionManagementErrorCode.CorruptZip:f.type==="Incomplete"&&(v=m.ExtensionManagementErrorCode.IncompleteZip)),new m.ExtensionManagementError(f.message,v)}}async rename(t,s,o,u){try{await S.Promises.rename(s,o)}catch(f){if(E.isWindows&&f&&f.code==="EPERM"&&Date.now()<u)return this.logService.info(`Failed renaming ${s} to ${o} with 'EPERM' error. Trying again...`,t.id),this.rename(t,s,o,u);throw new m.ExtensionManagementError(f.message||(0,y.localize)(3,null,s,o),f.code||m.ExtensionManagementErrorCode.Rename)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const t=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return t;const s=this.scanDevSystemExtensions(),[o,u]=await Promise.all([t,s]);return[...o,...u]}async scanExtensionsInDir(t,s){const o=new i.Limiter(10),u=await this.fileService.resolve(b.URI.file(t));return u.children?(await Promise.all(u.children.filter(v=>v.isDirectory).map(v=>o.queue(async()=>s===1&&(0,C.basename)(v.resource).indexOf(".")===0?null:this.scanExtension(v.resource,s))))).filter(v=>v&&v.identifier):[]}async scanExtension(t,s){try{const o=await this.fileService.resolve(t);if(o.children){const{manifest:u,metadata:f}=await this.readManifest(t.fsPath),v=o.children.find(({name:N})=>/^readme(\.txt|\.md|)$/i.test(N))?.resource,I=o.children.find(({name:N})=>/^changelog(\.txt|\.md|)$/i.test(N))?.resource,O={id:(0,w.getGalleryExtensionId)(u.publisher,u.name)},A={type:s,identifier:O,manifest:u,location:t,readmeUrl:v,changelogUrl:I,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:s===0};return this.setMetadata(A,f),A}}catch(o){s!==0&&this.logService.trace(o)}return null}async scanDefaultSystemExtensions(){const t=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",t.length),t}async scanDevSystemExtensions(){const t=this.getDevSystemExtensionsList();if(t.length){const s=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",s.length),s.filter(o=>t.some(u=>(0,w.areSameExtensions)(o.identifier,{id:u})))}else return[]}setMetadata(t,s){t.publisherDisplayName=s?.publisherDisplayName||null,t.publisherId=s?.publisherId||null,t.identifier.uuid=s?.id,t.isMachineScoped=!!s?.isMachineScoped,t.isPreReleaseVersion=!!s?.isPreReleaseVersion,t.preRelease=!!s?.preRelease,t.isBuiltin=t.type===0||!!s?.isBuiltin,t.installedTimestamp=s?.installedTimestamp}async removeUninstalledExtensions(){const t=await this.getUninstalledExtensions(),s=await this.scanAllUserExtensions(),o=new Set;for(const v of s)t[new w.ExtensionIdentifierWithVersion(v.identifier,v.manifest.version).key()]||o.add(v.identifier.id.toLowerCase());const u=(0,w.groupByExtension)(s,v=>v.identifier);await i.Promises.settled(u.map(async v=>{const I=v.sort((O,A)=>P.rcompare(O.manifest.version,A.manifest.version))[0];o.has(I.identifier.id.toLowerCase())||await this.beforeRemovingExtension(I)}));const f=s.filter(v=>t[new w.ExtensionIdentifierWithVersion(v.identifier,v.manifest.version).key()]);await i.Promises.settled(f.map(v=>this.removeUninstalledExtension(v)))}async removeOutdatedExtensions(){const t=await this.scanAllUserExtensions(),s=[],o=(0,w.groupByExtension)(t,u=>u.identifier);s.push(...(0,L.flatten)(o.map(u=>u.sort((f,v)=>P.rcompare(f.manifest.version,v.manifest.version)).slice(1)))),await i.Promises.settled(s.map(u=>this.removeExtension(u,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(t=>t.name)}joinErrors(t){const s=Array.isArray(t)?t:[t];return s.length===1?s[0]instanceof Error?s[0]:new Error(s[0]):s.reduce((o,u)=>new Error(`${o.message}${o.message?",":""}${u instanceof Error?u.message:u}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=R.normalize(R.join(k.FileAccess.asFileUri("",Q).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(t){const s=[S.Promises.readFile(R.join(t,"package.json"),"utf8").then(v=>this.parseManifest(v)),S.Promises.readFile(R.join(t,"package.nls.json"),"utf8").then(void 0,v=>v.code!=="ENOENT"?Promise.reject(v):"{}").then(v=>JSON.parse(v))],[{manifest:o,metadata:u},f]=await Promise.all(s);return{manifest:(0,g.localizeManifest)(o,f),metadata:u}}parseManifest(t){return new Promise((s,o)=>{try{const u=JSON.parse(t),f=u.__metadata||null;s({manifest:u,metadata:f})}catch{o(new Error((0,y.localize)(4,null)))}})}};a=de([J(1,c.IFileService),J(2,l.ILogService),J(3,p.INativeEnvironmentService),J(4,r.IProductService)],a),e.ExtensionsScanner=a}),define(te[238],ne([0,1,38,10,17,9,4,32,18,61,7,30,20,65,132,79,11,200,29,34,184,173,236,185,237,214,76,14,6,8,26,22,35]),function(Q,e,L,i,D,_,k,R,E,C,P,b,d,S,h,y,p,m,w,g,c,l,r,a,n,t,s,o,u,f,v,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=void 0;let A=class extends m.AbstractExtensionManagementService{constructor(U,B,ee,H,j,Z,W,z,V){super(U,B,ee,z);this.environmentService=H,this.downloadService=j,this.fileService=W;const q=this._register(Z.createInstance(l.ExtensionsLifecycle));this.extensionsScanner=this._register(Z.createInstance(n.ExtensionsScanner,Y=>q.postUninstall(Y))),this.manifestCache=this._register(new a.ExtensionsManifestCache(H,this)),this.extensionsDownloader=this._register(Z.createInstance(c.ExtensionsDownloader));const G=this._register(new t.ExtensionsWatcher(this,W,H,ee,V));this._register(G.onDidChangeExtensionsByAnotherSource(({added:Y,removed:x})=>{Y.length&&this._onDidInstallExtensions.fire(Y.map(K=>({identifier:K.identifier,operation:1,local:K}))),x.forEach(K=>this._onDidUninstallExtension.fire({identifier:K}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(async()=>{const U=await this.isAlpineLinux(),B=(0,w.getTargetPlatform)(U?"alpine":k.platform,R.arch);return this.logService.debug("ExtensionManagementService#TargetPlatform:",B),B})()),this._targetPlatformPromise}async isAlpineLinux(){if(!k.isLinux)return!1;let U;try{U=(await this.fileService.readFile(P.URI.file("/etc/os-release"))).value.toString()}catch{try{U=(await this.fileService.readFile(P.URI.file("/usr/lib/os-release"))).value.toString()}catch(ee){this.logService.debug("Error while getting the os-release file.",(0,i.getErrorMessage)(ee))}}return!!U&&(U.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async zip(U){this.logService.trace("ExtensionManagementService#zip",U.identifier.id);const B=await this.collectFiles(U),ee=await(0,S.zip)((0,E.joinPath)(this.environmentService.tmpDir,(0,b.generateUuid)()).fsPath,B);return P.URI.file(ee)}async unzip(U){return this.logService.trace("ExtensionManagementService#unzip",U.toString()),(await this.install(U)).identifier}async getManifest(U){const B=await this.downloadVsix(U),ee=_.resolve(B.fsPath);return(0,r.getManifest)(ee)}getInstalled(U=null){return this.extensionsScanner.scanExtensions(U)}async install(U,B={}){this.logService.trace("ExtensionManagementService#install",U.toString());const ee=await this.downloadVsix(U),H=await(0,r.getManifest)(_.resolve(ee.fsPath));if(H.engines&&H.engines.vscode&&!(0,s.isEngineValid)(H.engines.vscode,this.productService.version,this.productService.date))throw new Error(h.localize(0,null,(0,g.getGalleryExtensionId)(H.publisher,H.name),this.productService.version));return this.installExtension(H,ee,B)}async updateMetadata(U,B){this.logService.trace("ExtensionManagementService#updateMetadata",U.identifier.id);const ee={...U.manifest.__metadata||{},...B};return B.isPreReleaseVersion&&(ee.preRelease=!0),U=await this.extensionsScanner.saveMetadataForLocalExtension(U,ee),this.manifestCache.invalidate(),U}async updateExtensionScope(U,B){return this.logService.trace("ExtensionManagementService#updateExtensionScope",U.identifier.id),U=await this.extensionsScanner.saveMetadataForLocalExtension(U,{...U.manifest.__metadata||{},isMachineScoped:B}),this.manifestCache.invalidate(),U}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(U){if(U.scheme===D.Schemas.file)return U;const B=(0,E.joinPath)(this.environmentService.tmpDir,(0,b.generateUuid)());return await this.downloadService.download(U,B),B}createInstallExtensionTask(U,B,ee){return P.URI.isUri(B)?new T(U,B,ee,this.galleryService,this.extensionsScanner,this.logService):new $(B,ee,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(U,B){return new F(U,B,this.extensionsScanner)}async collectFiles(U){const B=async H=>{let j=await d.Promises.readdir(H);j=j.map(z=>_.join(H,z));const Z=await Promise.all(j.map(z=>d.Promises.stat(z)));let W=Promise.resolve([]);return Z.forEach((z,V)=>{const q=j[V];z.isFile()&&(W=W.then(G=>[...G,q])),z.isDirectory()&&(W=W.then(G=>B(q).then(Y=>[...G,...Y])))}),W};return(await B(U.location.fsPath)).map(H=>({path:`extension/${_.relative(U.location.fsPath,H)}`,localPath:H}))}};A=de([J(0,w.IExtensionGalleryService),J(1,I.ITelemetryService),J(2,f.ILogService),J(3,p.INativeEnvironmentService),J(4,y.IDownloadService),J(5,u.IInstantiationService),J(6,o.IFileService),J(7,v.IProductService),J(8,O.IUriIdentityService)],A),e.ExtensionManagementService=A;class N extends m.AbstractExtensionTask{constructor(U,B,ee,H){super();this.identifier=U,this.source=B,this.extensionsScanner=ee,this.logService=H,this._operation=2}get operation(){return this._operation}async installExtension(U,B){try{const ee=await this.unsetUninstalledAndGetLocal(U.identifierWithVersion);if(ee)return U.metadata?this.extensionsScanner.saveMetadataForLocalExtension(ee,{...ee.manifest.__metadata||{},...U.metadata}):ee}catch{throw k.isMacintosh?new w.ExtensionManagementError(h.localize(1,null),w.ExtensionManagementErrorCode.Internal):new w.ExtensionManagementError(h.localize(2,null),w.ExtensionManagementErrorCode.Internal)}return this.extract(U,B)}async unsetUninstalledAndGetLocal(U){if(!await this.isUninstalled(U))return null;this.logService.trace("Removing the extension from uninstalled list:",U.id);const ee=await this.extensionsScanner.setInstalled(U);return this.logService.info("Removed the extension from uninstalled list:",U.id),ee}async isUninstalled(U){return!!(await this.extensionsScanner.getUninstalledExtensions())[U.key()]}async extract({zipPath:U,identifierWithVersion:B,metadata:ee},H){let j=await this.extensionsScanner.extractUserExtension(B,U,ee,H);return this.logService.info("Extracting completed.",B.id),j}}class $ extends N{constructor(U,B,ee,H,j){super(U.identifier,U,H,j);this.gallery=U,this.options=B,this.extensionsDownloader=ee}async doRun(U){const ee=(await this.extensionsScanner.scanExtensions(null)).find(j=>(0,g.areSameExtensions)(j.identifier,this.gallery.identifier));ee&&(this._operation=3);const H=await this.downloadInstallableExtension(this.gallery,this._operation);H.metadata.isMachineScoped=this.options.isMachineScoped||ee?.isMachineScoped,H.metadata.isBuiltin=this.options.isBuiltin||ee?.isBuiltin,H.metadata.isPreReleaseVersion=this.gallery.properties.isPreReleaseVersion,H.metadata.preRelease=this.gallery.hasPreReleaseVersion?this.gallery.properties.isPreReleaseVersion:ee?.preRelease;try{const j=await this.installExtension(H,U);return ee&&C.neq(ee.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(ee),j}catch(j){throw await this.deleteDownloadedVSIX(H.zipPath),j}}async deleteDownloadedVSIX(U){try{await this.extensionsDownloader.delete(P.URI.file(U))}catch(B){this.logService.warn("Error while deleting the downloaded vsix",U.toString(),(0,i.getErrorMessage)(B))}}async downloadInstallableExtension(U,B){const ee={id:U.identifier.uuid,publisherId:U.publisherId,publisherDisplayName:U.publisherDisplayName};let H;try{this.logService.trace("Started downloading extension:",U.identifier.id),H=(await this.extensionsDownloader.downloadExtension(U,B)).fsPath,this.logService.info("Downloaded extension:",U.identifier.id,H)}catch(j){throw new w.ExtensionManagementError((0,m.joinErrors)(j).message,w.ExtensionManagementErrorCode.Download)}try{const j=await(0,r.getManifest)(H);return{zipPath:H,identifierWithVersion:new g.ExtensionIdentifierWithVersion(U.identifier,j.version),metadata:ee}}catch(j){throw await this.deleteDownloadedVSIX(H),new w.ExtensionManagementError((0,m.joinErrors)(j).message,w.ExtensionManagementErrorCode.Invalid)}}}class T extends N{constructor(U,B,ee,H,j,Z){super({id:(0,g.getGalleryExtensionId)(U.publisher,U.name)},B,j,Z);this.manifest=U,this.location=B,this.options=ee,this.galleryService=H}async doRun(U){const B=new g.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),H=(await this.extensionsScanner.scanExtensions(1)).find(Z=>(0,g.areSameExtensions)(this.identifier,Z.identifier)),j=await this.getMetadata(this.identifier.id,this.manifest.version,U);if(j.isMachineScoped=this.options.isMachineScoped||H?.isMachineScoped,j.isBuiltin=this.options.isBuiltin||H?.isBuiltin,H)if(this._operation=3,B.equals(new g.ExtensionIdentifierWithVersion(H.identifier,H.manifest.version)))try{await this.extensionsScanner.removeExtension(H,"existing")}catch{throw new Error(h.localize(3,null,this.manifest.displayName||this.manifest.name))}else C.gt(H.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(H);else{const Z=await this.unsetUninstalledAndGetLocal(B);if(Z)try{await this.extensionsScanner.removeExtension(Z,"existing")}catch{throw new Error(h.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:_.resolve(this.location.fsPath),identifierWithVersion:B,metadata:j},U)}async getMetadata(U,B,ee){try{let[H]=await this.galleryService.getExtensions([{id:U,version:B}],ee);if(H||([H]=await this.galleryService.getExtensions([{id:U}],ee)),H)return{id:H.identifier.uuid,publisherDisplayName:H.publisherDisplayName,publisherId:H.publisherId,isPreReleaseVersion:H.properties.isPreReleaseVersion,preRelease:H.properties.isPreReleaseVersion}}catch{}return{}}}class F extends m.AbstractExtensionTask{constructor(U,B,ee){super();this.extension=U,this.options=B,this.extensionsScanner=ee}async doRun(U){const B=[],ee=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const H=new g.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);B.push(...ee.filter(j=>H.equals(new g.ExtensionIdentifierWithVersion(j.identifier,j.manifest.version))))}else B.push(...ee.filter(H=>(0,g.areSameExtensions)(H.identifier,this.extension.identifier)));if(!B.length)throw new Error(h.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...B),this.options.remove)for(const H of B)try{U.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(H)}catch(j){throw new Error(h.localize(6,null,(0,L.toErrorMessage)(j)))}}}}),define(te[239],ne([0,1,81,55,33,19,10,3,2,9,4,30,36,71,249]),function(Q,e,L,i,D,_,k,R,E,C,P,b,d,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class y{constructor(I,O=""){this.debugLabel=O,this.socket=I,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=A=>{if(this.traceSocketEvent("error",{code:A?.code,message:A?.message}),A){if(A.code==="EPIPE")return;(0,k.onUnexpectedError)(A)}},this.socket.on("error",this._errorListener)}traceSocketEvent(I,O){S.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,I,O)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(I){const O=A=>{this.traceSocketEvent("read",A),I(_.VSBuffer.wrap(A))};return this.socket.on("data",O),{dispose:()=>this.socket.off("data",O)}}onClose(I){const O=A=>{this.traceSocketEvent("close",{hadError:A}),I({type:0,hadError:A,error:void 0})};return this.socket.on("close",O),{dispose:()=>this.socket.off("close",O)}}onEnd(I){const O=()=>{this.traceSocketEvent("nodeEndReceived"),I()};return this.socket.on("end",O),{dispose:()=>this.socket.off("end",O)}}write(I){if(!this.socket.destroyed)try{this.traceSocketEvent("write",I),this.socket.write(I.buffer,O=>{if(O){if(O.code==="EPIPE")return;(0,k.onUnexpectedError)(O)}})}catch(O){if(O.code==="EPIPE")return;(0,k.onUnexpectedError)(O)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((I,O)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),I();return}const A=()=>{this.socket.off("close",A),this.socket.off("end",A),this.socket.off("error",A),this.socket.off("timeout",A),this.socket.off("drain",A),this.traceSocketEvent("nodeDrainEnd"),I()};this.socket.on("close",A),this.socket.on("end",A),this.socket.on("error",A),this.socket.on("timeout",A),this.socket.on("drain",A)})}}e.NodeSocket=y;var p;(function(v){v[v.MinHeaderByteSize=2]="MinHeaderByteSize"})(p||(p={}));var m;(function(v){v[v.PeekHeader=1]="PeekHeader",v[v.ReadHeader=2]="ReadHeader",v[v.ReadBody=3]="ReadBody",v[v.Fin=4]="Fin"})(m||(m={}));class w extends E.Disposable{constructor(I,O,A,N){super();this._onData=this._register(new R.Emitter),this._onClose=this._register(new R.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=I,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:O,inflateBytesLength:A?.byteLength||0,recordInflateBytes:N}),this._flowManager=this._register(new g(this,O,A,N,this._onData,($,T)=>this._write($,T))),this._register(this._flowManager.onError($=>{console.error($),(0,k.onUnexpectedError)($),this._onClose.fire({type:0,hadError:!0,error:$})})),this._incomingData=new S.ChunkStream,this._register(this.socket.onData($=>this._acceptChunk($))),this._register(this.socket.onClose($=>this._onClose.fire($)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(I,O){this.socket.traceSocketEvent(I,O)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(I){return this._onData.event(I)}onClose(I){return this._onClose.event(I)}onEnd(I){return this.socket.onEnd(I)}write(I){this._flowManager.writeMessage(I)}_write(I,O){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",I);let A=2;I.byteLength<126?A+=0:I.byteLength<2**16?A+=2:A+=8;const N=_.VSBuffer.alloc(A);if(O?N.writeUInt8(194,0):N.writeUInt8(130,0),I.byteLength<126)N.writeUInt8(I.byteLength,1);else if(I.byteLength<2**16){N.writeUInt8(126,1);let $=1;N.writeUInt8(I.byteLength>>>8&255,++$),N.writeUInt8(I.byteLength>>>0&255,++$)}else{N.writeUInt8(127,1);let $=1;N.writeUInt8(0,++$),N.writeUInt8(0,++$),N.writeUInt8(0,++$),N.writeUInt8(0,++$),N.writeUInt8(I.byteLength>>>24&255,++$),N.writeUInt8(I.byteLength>>>16&255,++$),N.writeUInt8(I.byteLength>>>8&255,++$),N.writeUInt8(I.byteLength>>>0&255,++$)}this.socket.write(_.VSBuffer.concat([N,I]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(I){if(I.byteLength!==0){for(this._incomingData.acceptChunk(I);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const O=this._incomingData.peek(this._state.readLen),A=O.readUInt8(0),N=(A&128)>>>7,$=(A&64)>>>6,T=O.readUInt8(1),F=(T&128)>>>7,M=T&127;this._state.state=2,this._state.readLen=2+(F?4:0)+(M===126?2:0)+(M===127?8:0),this._state.fin=N,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean($)),this._state.firstFrameOfMessage=Boolean(N),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const O=this._incomingData.read(this._state.readLen),A=O.readUInt8(1),N=(A&128)>>>7;let $=A&127,T=1;$===126?$=O.readUInt8(++T)*2**8+O.readUInt8(++T):$===127&&($=O.readUInt8(++T)*0+O.readUInt8(++T)*0+O.readUInt8(++T)*0+O.readUInt8(++T)*0+O.readUInt8(++T)*2**24+O.readUInt8(++T)*2**16+O.readUInt8(++T)*2**8+O.readUInt8(++T));let F=0;N&&(F=O.readUInt8(++T)*2**24+O.readUInt8(++T)*2**16+O.readUInt8(++T)*2**8+O.readUInt8(++T)),this._state.state=3,this._state.readLen=$,this._state.mask=F,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const O=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",O),r(O,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",O),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(O,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await R.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=w;class g extends E.Disposable{constructor(I,O,A,N,$,T){super();this._tracer=I,this._onData=$,this._writeFn=T,this._onError=this._register(new R.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new R.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,O?(this._zlibInflateStream=this._register(new c(this._tracer,N,A,{windowBits:15})),this._zlibDeflateStream=this._register(new l(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(F=>this._onError.fire(F))),this._register(this._zlibDeflateStream.onError(F=>this._onError.fire(F)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:_.VSBuffer.alloc(0)}writeMessage(I){this._writeQueue.push(I),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const I=this._writeQueue.shift();if(this._zlibDeflateStream){const O=await this._deflateMessage(this._zlibDeflateStream,I);this._writeFn(O,!0)}else this._writeFn(I,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(I,O){return new Promise((A,N)=>{I.write(O),I.flush($=>A($))})}acceptFrame(I,O,A){this._readQueue.push({data:I,isCompressed:O,isLastFrameOfMessage:A}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const I=this._readQueue.shift();if(this._zlibInflateStream&&I.isCompressed){const O=await this._inflateFrame(this._zlibInflateStream,I.data,I.isLastFrameOfMessage);this._onData.fire(O)}else this._onData.fire(I.data)}this._isProcessingReadQueue=!1}}_inflateFrame(I,O,A){return new Promise((N,$)=>{I.write(O),A&&I.write(_.VSBuffer.fromByteArray([0,0,255,255])),I.flush(T=>N(T))})}}class c extends E.Disposable{constructor(I,O,A,N){super();this._tracer=I,this._recordInflateBytes=O,this._onError=this._register(new R.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=h.createInflateRaw(N),this._zlibInflate.on("error",$=>{this._tracer.traceSocketEvent("zlibInflateError",{message:$?.message,code:$?.code}),this._onError.fire($)}),this._zlibInflate.on("data",$=>{this._tracer.traceSocketEvent("zlibInflateData",$),this._pendingInflateData.push(_.VSBuffer.wrap($))}),A&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",A.buffer),this._zlibInflate.write(A.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?_.VSBuffer.concat(this._recordedInflateBytes):_.VSBuffer.alloc(0)}write(I){this._recordInflateBytes&&this._recordedInflateBytes.push(I.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",I),this._zlibInflate.write(I.buffer)}flush(I){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const O=_.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,I(O)})}}class l extends E.Disposable{constructor(I,O){super();this._tracer=I,this._onError=this._register(new R.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=h.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",A=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:A?.message,code:A?.code}),this._onError.fire(A)}),this._zlibDeflate.on("data",A=>{this._tracer.traceSocketEvent("zlibDeflateData",A),this._pendingDeflateData.push(_.VSBuffer.wrap(A))})}write(I){this._tracer.traceSocketEvent("zlibDeflateWrite",I.buffer),this._zlibDeflate.write(I.buffer)}flush(I){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let O=_.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,O=O.slice(0,O.byteLength-4),I(O)})}}function r(v,I){if(I===0)return;let O=v.byteLength>>>2;for(let M=0;M<O;M++){const U=v.readUInt32BE(M*4);v.writeUInt32BE(U^I,M*4)}let A=O*4,N=v.byteLength-A;const $=I>>>24&255,T=I>>>16&255,F=I>>>8&255;N>=1&&v.writeUInt8(v.readUInt8(A)^$,A),N>=2&&v.writeUInt8(v.readUInt8(A+1)^T,A+1),N>=3&&v.writeUInt8(v.readUInt8(A+2)^F,A+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const a={[2]:107,[1]:103};function n(){const v=(0,b.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${v}-sock`;let I;return e.XDG_RUNTIME_DIR?I=(0,C.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${v}.sock`):I=(0,C.join)((0,D.tmpdir)(),`vscode-ipc-${v}.sock`),s(I),I}e.createRandomIPCHandle=n;function t(v,I,O){const A=(0,L.createHash)("md5").update(v).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${A}-${O}-${I}-sock`;let N;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?N=(0,C.join)(e.XDG_RUNTIME_DIR,`vscode-${A.substr(0,8)}-${O}-${I}.sock`):N=(0,C.join)(v,`${O}-${I}.sock`),s(N),N}e.createStaticIPCHandle=t;function s(v){const I=a[P.platform];typeof I=="number"&&v.length>=I&&console.warn(`WARNING: IPC handle "${v}" is longer than ${I} chars, try a shorter --user-data-dir`)}class o extends d.IPCServer{constructor(I){super(o.toClientConnectionEvent(I));this.server=I}static toClientConnectionEvent(I){const O=R.Event.fromNodeEventEmitter(I,"connection");return R.Event.map(O,A=>({protocol:new S.Protocol(new y(A,"ipc-server-connection")),onDidClientDisconnect:R.Event.once(R.Event.fromNodeEventEmitter(A,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=o;function u(v){return new Promise((I,O)=>{const A=(0,i.createServer)();A.on("error",O),A.listen(v,()=>{A.removeListener("error",O),I(new o(A))})})}e.serve=u;function f(v,I){return new Promise((O,A)=>{const N=(0,i.createConnection)(v,()=>{N.removeListener("error",A),O(S.Client.fromSocket(new y(N,`ipc-client${I}`),I))});N.once("error",A)})}e.connect=f}),define(te[240],ne([0,1,55,239]),function(Q,e,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(D,_,k,R,E){const C=b=>E(b,void 0),P=L.createConnection({host:D,port:_},()=>{P.removeListener("error",C);const b=Buffer.alloc(16);for(let y=0;y<16;y++)b[y]=Math.round(Math.random()*256);const d=b.toString("base64"),S=[`GET ws://${/:/.test(D)?`[${D}]`:D}:${_}/?${k}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${d}`];P.write(S.join(`\r
`)+`\r
\r
`);const h=y=>{y.toString().indexOf(`\r
\r
`)>=0&&(P.off("data",h),E(void 0,new i.NodeSocket(P,R)))};P.on("data",h)});P.setNoDelay(!0),P.once("error",C)}}}),define(te[241],ne([0,1,55,114,240,5,2,21,8,26,182,62,91]),function(Q,e,L,i,D,_,k,R,E,C,P,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function S(w,g,c,l,r){let a;for(let n=3;n&&(a&&a.dispose(),a=await new h(w,g,c,l,r).waitForReady(),!(r&&i.BROWSER_RESTRICTED_PORTS[r]||!i.BROWSER_RESTRICTED_PORTS[a.tunnelLocalPort]));n--);return a}class h extends k.Disposable{constructor(g,c,l,r,a){super();this.defaultTunnelHost=c,this.suggestedLocalPort=a,this.privacy=b.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=g,this._server=L.createServer(),this._barrier=new _.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=n=>this._onConnection(n),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=r,this.tunnelRemoteHost=l}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(c=>{c()})}async waitForReady(){let g=await(0,i.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),c=null;return this._server.listen(g,this.defaultTunnelHost),await this._barrier.wait(),c=this._server.address(),c||(g=0,this._server.listen(g,this.defaultTunnelHost),await this._barrier.wait(),c=this._server.address()),this.tunnelLocalPort=c.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${c.port}`,this}async _onConnection(g){g.pause();const c=(0,b.isLocalhost)(this.tunnelRemoteHost)||(0,b.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,l=await(0,P.connectRemoteAgentTunnel)(this._options,c,this.tunnelRemotePort),r=l.getSocket().socket,a=l.readEntireBuffer();l.dispose(),a.byteLength>0&&g.write(a.buffer),g.on("end",()=>{this._socketsDispose.delete(g.localAddress),r.end()}),g.on("close",()=>r.end()),g.on("error",()=>{this._socketsDispose.delete(g.localAddress),r.destroy()}),r.on("end",()=>g.end()),r.on("close",()=>g.end()),r.on("error",()=>{g.destroy()}),g.pipe(r),r.pipe(g),this._socketsDispose.set(g.localAddress,()=>{g.end(),r.end()})}}let y=class extends b.AbstractTunnelService{constructor(g,c,l,r,a){super(c);this.socketFactory=g,this.signService=l,this.productService=r,this.configurationService=a}get defaultTunnelHost(){const g=this.configurationService.getValue("remote.localPortHost");return!g||g==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(g,c,l,r,a,n,t){const s=this.getTunnelFromMap(c,l);if(s)return++s.refcount,s.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,c,l,r,a,n,t);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${c}:${l} on local port ${r}.`);const o={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:g,signService:this.signService,logService:this.logService,ipcLogger:null},u=S(o,this.defaultTunnelHost,c,l,r);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(c,l,u),u}}};y=de([J(1,E.ILogService),J(2,d.ISignService),J(3,C.IProductService),J(4,R.IConfigurationService)],y),e.BaseTunnelService=y;let p=class extends y{constructor(g,c,l,r){super(D.nodeSocketFactory,g,c,l,r)}};p=de([J(0,E.ILogService),J(1,d.ISignService),J(2,C.IProductService),J(3,R.IConfigurationService)],p),e.TunnelService=p;let m=class extends k.Disposable{constructor(g,c,l,r){super();this.logService=g,this.productService=c,this.signService=l,this.configurationService=r,this._tunnelServices=new Map}async openTunnel(g,c,l,r,a,n,t,s){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${l}:${r} on local port ${a}.`),!this._tunnelServices.has(g)){const o=new p(this.logService,this.signService,this.productService,this.configurationService);this._register(o),this._tunnelServices.set(g,o),o.onTunnelClosed(async()=>{(await o.tunnels).length===0&&(o.dispose(),this._tunnelServices.delete(g))})}return this._tunnelServices.get(g).openTunnel(c,l,r,a,n,t,s)}};m=de([J(0,E.ILogService),J(1,C.IProductService),J(2,d.ISignService),J(3,R.IConfigurationService)],m),e.SharedTunnelsService=m}),define(te[250],ne([0,1,72,33,38,10,2,17,18,7,36,118,178,160,179,170,171,172,158,162,21,180,78,199,79,190,11,153,195,203,29,161,201,238,80,156,14,175,177,51,6,167,83,168,169,59,186,8,85,60,86,26,189,42,23,197,198,22,92,93,94,43,204,205,95,207,213,97,98,24,63,226,228,229,64,227,231,232,233,234,235,91,194,62,241,187,188,90,193,84,202,35,215]),function(Q,e,L,i,D,_,k,R,E,C,P,b,d,S,h,y,p,m,w,g,c,l,r,a,n,t,s,o,u,f,v,I,O,A,N,$,T,F,M,U,B,ee,H,j,Z,W,z,V,q,G,Y,x,K,re,se,ce,he,me,ve,ge,we,Re,Ee,ke,Le,Fe,$e,ze,ie,ae,le,be,Ie,Me,Te,Ne,Ae,Ue,X,oe,ue,fe,ye,pe,Ce,Pe,De,_e,qe,He,Ye,Ct,It){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Pt extends k.Disposable{constructor(Se){super();this.configuration=Se,this.server=this._register(new b.Server),this.sharedProcessWorkerService=void 0,this.registerListeners()}registerListeners(){const Se=()=>this.dispose();process.once("exit",Se),L.ipcRenderer.once("vscode:electron-main->shared-process=exit",Se);const Oe="vscode:electron-main->shared-process=disposeWorker",je=(Ge,We)=>this.onDisposeWorker(We);L.ipcRenderer.on(Oe,je),this._register((0,k.toDisposable)(()=>L.ipcRenderer.removeListener(Oe,je)))}onDisposeWorker(Se){this.sharedProcessWorkerService?.disposeWorker(Se)}async open(){const Se=await this.initServices();(0,ae.registerConfiguration)(),Se.invokeFunction(Oe=>{const je=Oe.get(V.ILogService);je.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Oe),this.registerErrorHandler(je)}),this._register((0,k.combinedDisposable)(Se.createInstance(d.CodeCacheCleaner,this.configuration.codeCachePath),Se.createInstance(h.LanguagePackCachedDataCleaner),Se.createInstance(m.StorageDataCleaner,this.configuration.backupWorkspacesPath),Se.createInstance(p.LogsDataCleaner),Se.createInstance(y.LocalizationsUpdater),Se.createInstance(S.ExtensionsCleaner)))}async initServices(){const Se=new H.ServiceCollection,Oe={_serviceBrand:void 0,...Y.default};Se.set(x.IProductService,Oe);const je=new P.StaticRouter(Be=>Be==="main"),Ge=new j.MessagePortMainProcessService(this.server,je);Se.set(Z.IMainProcessService,Ge);const We=new o.NativeEnvironmentService(this.configuration.args,Oe);Se.set(s.INativeEnvironmentService,We);const rt=new q.LogLevelChannelClient(this.server.getChannel("logLevel",je)),Qe=new q.LoggerChannelClient(this.configuration.logLevel,rt.onDidChangeLogLevel,Ge.getChannel("logger"));Se.set(V.ILoggerService,Qe);const at=this._register(new V.MultiplexLogService([this._register(new V.ConsoleLogger(this.configuration.logLevel)),this._register(Qe.createLogger((0,E.joinPath)(C.URI.file(We.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),Je=this._register(new q.FollowerLogService(rt,at));Se.set(V.ILogService,Je),this.sharedProcessWorkerService=new qe.SharedProcessWorkerService(Je,Oe,We),Se.set(_e.ISharedProcessWorkerService,this.sharedProcessWorkerService);const Xe=this._register(new F.FileService(Je));Se.set(T.IFileService,Xe);const ct=this._register(new M.DiskFileSystemProvider(Je));Xe.registerProvider(R.Schemas.file,ct);const xe=this._register(new l.ConfigurationService(We.settingsResource,Xe));Se.set(c.IConfigurationService,xe);const tt=new ce.NativeStorageService(void 0,Ge,We);Se.set(se.IStorageService,tt),this._register((0,k.toDisposable)(()=>tt.flush())),await Promise.all([xe.initialize(),tt.initialize()]),Se.set(He.IUserConfigurationFileService,P.ProxyChannel.toService(Ge.getChannel(He.UserConfigurationFileServiceId))),Se.set(Ct.IUriIdentityService,new It.UriIdentityService(Xe)),Se.set(re.IRequestService,new U.SyncDescriptor(K.RequestService)),Se.set(w.IChecksumService,new U.SyncDescriptor(g.ChecksumService));const st=P.ProxyChannel.toService(Ge.getChannel("nativeHost"),{context:this.configuration.windowId});Se.set(G.INativeHostService,st),Se.set(n.IDownloadService,new U.SyncDescriptor(t.DownloadService));const lt=this._register(new ue.ActiveWindowManager(st)),ut=new P.StaticRouter(Be=>lt.getActiveClientId().then(dt=>Be===dt));Se.set(N.IExtensionRecommendationNotificationService,new $.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",ut)));const ht=new Ye.AssignmentService(this.configuration.machineId,xe,Oe);let nt;const Ze=[];if((0,Re.supportsTelemetry)(Oe,We)){const Be=new ge.TelemetryLogAppender(Qe,We);Ze.push(Be);const{appRoot:dt,extensionsPath:kt,installSourcePath:Tt}=We;if(Oe.aiConfig&&Oe.aiConfig.asimovKey){const ot=await ht.getTreatment("telemetryMigration")??!1,ft=Oe.quality!=="stable";if(ft&&ot){const wt=new Ee.AppInsightsAppender("monacoworkbench",null,Oe.aiConfig.asimovKey,ot,!0);this._register((0,k.toDisposable)(()=>wt.flush())),Ze.push(wt)}const yt=new Ee.AppInsightsAppender("monacoworkbench",null,Oe.aiConfig.asimovKey,ft?!1:ot,ot&&ft);this._register((0,k.toDisposable)(()=>yt.flush())),Ze.push(yt)}nt=new we.TelemetryService({appenders:Ze,commonProperties:(0,he.resolveCommonProperties)(Xe,(0,i.release)(),(0,i.hostname)(),process.arch,Oe.commit,Oe.version,this.configuration.machineId,Oe.msftInternalDomains,Tt),sendErrorTelemetry:!0,piiPaths:[dt,kt]},xe)}else{nt=Re.NullTelemetryService;const Be=Re.NullAppender;Ze.push(Be)}this.server.registerChannel("telemetryAppender",new ve.TelemetryAppenderChannel(Ze)),Se.set(me.ITelemetryService,nt);const Dt=new ke.CustomEndpointTelemetryService(xe,nt,Qe,We);Se.set(me.ICustomEndpointTelemetryService,Dt),Se.set(v.IExtensionManagementService,new U.SyncDescriptor(A.ExtensionManagementService)),Se.set(v.IExtensionGalleryService,new U.SyncDescriptor(f.ExtensionGalleryService)),Se.set(v.IExtensionTipsService,new U.SyncDescriptor(O.ExtensionTipsService)),Se.set(W.ILocalizationsService,new U.SyncDescriptor(z.LocalizationsService)),Se.set(r.IDiagnosticsService,new U.SyncDescriptor(a.DiagnosticsService)),Se.set(le.IUserDataSyncAccountService,new U.SyncDescriptor(le.UserDataSyncAccountService)),Se.set(ae.IUserDataSyncLogService,new U.SyncDescriptor(Me.UserDataSyncLogService)),Se.set(ae.IUserDataSyncUtilService,new Ie.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",Be=>Be.ctx!=="main"))),Se.set(v.IGlobalExtensionEnablementService,new U.SyncDescriptor(u.GlobalExtensionEnablementService)),Se.set(ie.IIgnoredExtensionsManagementService,new U.SyncDescriptor(ie.IgnoredExtensionsManagementService)),Se.set(ze.IExtensionsStorageSyncService,new U.SyncDescriptor(ze.ExtensionsStorageSyncService)),Se.set(ae.IUserDataSyncStoreManagementService,new U.SyncDescriptor(X.UserDataSyncStoreManagementService)),Se.set(ae.IUserDataSyncStoreService,new U.SyncDescriptor(X.UserDataSyncStoreService)),Se.set(Te.IUserDataSyncMachinesService,new U.SyncDescriptor(Te.UserDataSyncMachinesService)),Se.set(ae.IUserDataSyncBackupStoreService,new U.SyncDescriptor(be.UserDataSyncBackupStoreService)),Se.set(ae.IUserDataSyncEnablementService,new U.SyncDescriptor(Ne.UserDataSyncEnablementService)),Se.set(ae.IUserDataSyncService,new U.SyncDescriptor(Ae.UserDataSyncService));const St=new $e.PtyHostService({graceTime:6e4,shortGraceTime:6e3,scrollback:xe.getValue("terminal.integrated.persistentSessionScrollback")??100},xe,We,Je,nt);return await St.initialize(),Se.set(Fe.ILocalPtyService,this._register(St)),Se.set(fe.ISignService,new U.SyncDescriptor(ye.SignService)),Se.set(pe.ISharedTunnelsService,new U.SyncDescriptor(Ce.SharedTunnelsService)),Se.set(Pe.ISharedProcessTunnelService,new U.SyncDescriptor(De.SharedProcessTunnelService)),new ee.InstantiationService(Se)}initChannels(Se){const Oe=new I.ExtensionManagementChannel(Se.get(v.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Oe);const je=P.ProxyChannel.fromService(Se.get(W.ILocalizationsService));this.server.registerChannel("localizations",je);const Ge=P.ProxyChannel.fromService(Se.get(r.IDiagnosticsService));this.server.registerChannel("diagnostics",Ge);const We=new I.ExtensionTipsChannel(Se.get(v.IExtensionTipsService));this.server.registerChannel("extensionTipsService",We);const rt=P.ProxyChannel.fromService(Se.get(w.IChecksumService));this.server.registerChannel("checksum",rt);const Qe=new Ie.UserDataSyncMachinesServiceChannel(Se.get(Te.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",Qe);const at=P.ProxyChannel.fromService(Se.get(me.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",at);const Je=new Ie.UserDataSyncAccountServiceChannel(Se.get(le.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",Je);const Xe=new Ie.UserDataSyncStoreManagementServiceChannel(Se.get(ae.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",Xe);const ct=new Ue.UserDataSyncChannel(Se.get(ae.IUserDataSyncService),Se.get(V.ILogService));this.server.registerChannel("userDataSync",ct);const xe=this._register(Se.get(B.IInstantiationService).createInstance(oe.UserDataAutoSyncService)),tt=new Ie.UserDataAutoSyncChannel(xe);this.server.registerChannel("userDataAutoSync",tt);const st=Se.get(Fe.ILocalPtyService),lt=P.ProxyChannel.fromService(st);this.server.registerChannel(Le.TerminalIpcChannels.LocalPty,lt);const ut=P.ProxyChannel.fromService(Se.get(Pe.ISharedProcessTunnelService));this.server.registerChannel(Pe.ipcSharedProcessTunnelChannelName,ut);const ht=P.ProxyChannel.fromService(Se.get(_e.ISharedProcessWorkerService));this.server.registerChannel(_e.ipcSharedProcessWorkerChannelName,ht)}registerErrorHandler(Se){window.addEventListener("unhandledrejection",Oe=>{(0,_.onUnexpectedError)(Oe.reason),Oe.preventDefault()}),(0,_.setUnexpectedErrorHandler)(Oe=>{const je=(0,D.toErrorMessage)(Oe,!0);!je||Se.error(`[uncaught exception in sharedProcess]: ${je}`)})}}async function Rt(pt){const Se=new Pt(pt);L.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await Se.open(),L.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=Rt})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/745ef8b8264e12b2a704f6b2b60a2ce2cabfcda3/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
