/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Z=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/path","vs/base/common/async","vs/base/common/network","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","electron","vs/base/common/resources","vs/base/common/errors","vs/base/common/buffer","vs/platform/files/common/files","vs/platform/configuration/common/configuration","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/node/pfs","vs/platform/product/common/productService","vs/base/common/cancellation","vs/platform/environment/electron-main/environmentMainService","vs/base/common/strings","os","fs","vs/platform/telemetry/common/telemetry","vs/platform/workspaces/common/workspaces","vs/base/common/arrays","vs/base/common/uuid","vs/base/common/extpath","vs/base/common/labels","vs/base/common/process","vs/platform/windows/electron-main/windows","vs/base/parts/ipc/common/ipc","vs/platform/state/electron-main/state","vs/base/common/json","vs/base/common/map","vs/platform/registry/common/platform","vs/platform/update/common/update","vs/base/common/functional","child_process","vs/base/common/errorMessage","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/base/common/objects","vs/platform/environment/common/environment","vs/platform/request/common/request","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/native/electron-main/nativeHostMainService","vs/platform/backup/electron-main/backup","vs/platform/environment/node/argvHelper","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/configuration/common/configurationRegistry","vs/base/parts/ipc/node/ipc.net","vs/base/common/keybindings","vs/base/common/stream","crypto","net","vs/platform/files/common/watcher","vs/base/common/performance","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/theme/electron-main/themeMainService","vs/platform/windows/common/windows","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/iterator","vs/base/common/normalization","vs/base/node/id","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/sign/common/sign","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/jsonEdit","vs/base/common/keyCodes","vs/base/common/processes","vs/base/common/hash","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/externalTerminal/common/externalTerminal","vs/platform/environment/node/shellEnv","vs/platform/files/common/io","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/bufferLog","vs/platform/log/node/spdlogLog","vs/platform/remote/common/tunnel","vs/platform/storage/common/storage","vs/platform/url/common/url","vs/platform/storage/electron-main/storageMainService","vs/platform/windows/electron-main/windowsFinder","vs/platform/workspaces/electron-main/workspaces","vs/platform/launch/electron-main/launchMainService","vs/base/common/assert","vs/base/common/codicons","vs/base/common/jsonFormatter","vs/base/common/keybindingParser","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/console","vs/base/common/marshalling","vs/base/common/uriIpc","vs/base/common/worker/simpleWorker","vs/base/node/crypto","vs/base/node/decoder","vs/base/node/macAddress","util","vs/base/node/ports","vs/base/node/powershell","vs/base/node/watcher","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/storage/node/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/keybindingLabels","vs/base/common/keybindingLabels","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/environment/node/shellEnv","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderIpc","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/windows/electron-main/window","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/node/backup","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/driver/common/driverIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/extensions/common/extensionValidator","vs/platform/files/node/diskFileSystemProviderIpc","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/node/watcher/parcel/parcelWatcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/keybinding/common/baseResolvedKeybinding","vs/platform/keybinding/common/resolvedKeybindingItem","vs/platform/keybinding/common/usLayoutResolvedKeybinding","vs/platform/lifecycle/common/lifecycle","vs/platform/configuration/common/userConfigurationFileService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/electron-main/diskFileSystemProviderIpc","vs/platform/log/common/fileLog","vs/platform/log/common/logIpc","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryService","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/workspace/common/workspace","vs/platform/storage/electron-main/storageIpc","vs/platform/storage/electron-main/storageMain","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/extensions/electron-main/workerMainProcessExtensionHostStarter","zlib","vs/platform/driver/node/driver","vs/platform/backup/electron-main/backupMainService","vs/platform/driver/electron-main/driver","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/tunnelService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/state/electron-main/stateMainService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/code/electron-main/auth","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/window","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","string_decoder","minimist","path","assert","graceful-fs","worker_threads","vs/code/electron-main/main"],x=function(j){for(var e=[],p=0,r=j.length;p<r;p++)e[p]=Z[j[p]];return e};define(Z[103],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function p(r,D){if(!r)throw new Error(D?`Assertion failed (${D})`:"Assertion Failed")}e.ok=p}),define(Z[104],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function p(P){return P?P.replace(/\$\((.*?)\)/g,(I,d)=>` ${d} `).trim():""}e.getCodiconAriaLabel=p;class r{constructor(I,d,f){this.id=I,this.definition=d,this.description=f,r._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return r._allCodicons}}e.Codicon=r,r._allCodicons=[],r.add=new r("add",{fontCharacter:"\\ea60"}),r.plus=new r("plus",r.add.definition),r.gistNew=new r("gist-new",r.add.definition),r.repoCreate=new r("repo-create",r.add.definition),r.lightbulb=new r("lightbulb",{fontCharacter:"\\ea61"}),r.lightBulb=new r("light-bulb",{fontCharacter:"\\ea61"}),r.repo=new r("repo",{fontCharacter:"\\ea62"}),r.repoDelete=new r("repo-delete",{fontCharacter:"\\ea62"}),r.gistFork=new r("gist-fork",{fontCharacter:"\\ea63"}),r.repoForked=new r("repo-forked",{fontCharacter:"\\ea63"}),r.gitPullRequest=new r("git-pull-request",{fontCharacter:"\\ea64"}),r.gitPullRequestAbandoned=new r("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),r.recordKeys=new r("record-keys",{fontCharacter:"\\ea65"}),r.keyboard=new r("keyboard",{fontCharacter:"\\ea65"}),r.tag=new r("tag",{fontCharacter:"\\ea66"}),r.tagAdd=new r("tag-add",{fontCharacter:"\\ea66"}),r.tagRemove=new r("tag-remove",{fontCharacter:"\\ea66"}),r.person=new r("person",{fontCharacter:"\\ea67"}),r.personFollow=new r("person-follow",{fontCharacter:"\\ea67"}),r.personOutline=new r("person-outline",{fontCharacter:"\\ea67"}),r.personFilled=new r("person-filled",{fontCharacter:"\\ea67"}),r.gitBranch=new r("git-branch",{fontCharacter:"\\ea68"}),r.gitBranchCreate=new r("git-branch-create",{fontCharacter:"\\ea68"}),r.gitBranchDelete=new r("git-branch-delete",{fontCharacter:"\\ea68"}),r.sourceControl=new r("source-control",{fontCharacter:"\\ea68"}),r.mirror=new r("mirror",{fontCharacter:"\\ea69"}),r.mirrorPublic=new r("mirror-public",{fontCharacter:"\\ea69"}),r.star=new r("star",{fontCharacter:"\\ea6a"}),r.starAdd=new r("star-add",{fontCharacter:"\\ea6a"}),r.starDelete=new r("star-delete",{fontCharacter:"\\ea6a"}),r.starEmpty=new r("star-empty",{fontCharacter:"\\ea6a"}),r.comment=new r("comment",{fontCharacter:"\\ea6b"}),r.commentAdd=new r("comment-add",{fontCharacter:"\\ea6b"}),r.alert=new r("alert",{fontCharacter:"\\ea6c"}),r.warning=new r("warning",{fontCharacter:"\\ea6c"}),r.search=new r("search",{fontCharacter:"\\ea6d"}),r.searchSave=new r("search-save",{fontCharacter:"\\ea6d"}),r.logOut=new r("log-out",{fontCharacter:"\\ea6e"}),r.signOut=new r("sign-out",{fontCharacter:"\\ea6e"}),r.logIn=new r("log-in",{fontCharacter:"\\ea6f"}),r.signIn=new r("sign-in",{fontCharacter:"\\ea6f"}),r.eye=new r("eye",{fontCharacter:"\\ea70"}),r.eyeUnwatch=new r("eye-unwatch",{fontCharacter:"\\ea70"}),r.eyeWatch=new r("eye-watch",{fontCharacter:"\\ea70"}),r.circleFilled=new r("circle-filled",{fontCharacter:"\\ea71"}),r.primitiveDot=new r("primitive-dot",{fontCharacter:"\\ea71"}),r.closeDirty=new r("close-dirty",{fontCharacter:"\\ea71"}),r.debugBreakpoint=new r("debug-breakpoint",{fontCharacter:"\\ea71"}),r.debugBreakpointDisabled=new r("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),r.debugHint=new r("debug-hint",{fontCharacter:"\\ea71"}),r.primitiveSquare=new r("primitive-square",{fontCharacter:"\\ea72"}),r.edit=new r("edit",{fontCharacter:"\\ea73"}),r.pencil=new r("pencil",{fontCharacter:"\\ea73"}),r.info=new r("info",{fontCharacter:"\\ea74"}),r.issueOpened=new r("issue-opened",{fontCharacter:"\\ea74"}),r.gistPrivate=new r("gist-private",{fontCharacter:"\\ea75"}),r.gitForkPrivate=new r("git-fork-private",{fontCharacter:"\\ea75"}),r.lock=new r("lock",{fontCharacter:"\\ea75"}),r.mirrorPrivate=new r("mirror-private",{fontCharacter:"\\ea75"}),r.close=new r("close",{fontCharacter:"\\ea76"}),r.removeClose=new r("remove-close",{fontCharacter:"\\ea76"}),r.x=new r("x",{fontCharacter:"\\ea76"}),r.repoSync=new r("repo-sync",{fontCharacter:"\\ea77"}),r.sync=new r("sync",{fontCharacter:"\\ea77"}),r.clone=new r("clone",{fontCharacter:"\\ea78"}),r.desktopDownload=new r("desktop-download",{fontCharacter:"\\ea78"}),r.beaker=new r("beaker",{fontCharacter:"\\ea79"}),r.microscope=new r("microscope",{fontCharacter:"\\ea79"}),r.vm=new r("vm",{fontCharacter:"\\ea7a"}),r.deviceDesktop=new r("device-desktop",{fontCharacter:"\\ea7a"}),r.file=new r("file",{fontCharacter:"\\ea7b"}),r.fileText=new r("file-text",{fontCharacter:"\\ea7b"}),r.more=new r("more",{fontCharacter:"\\ea7c"}),r.ellipsis=new r("ellipsis",{fontCharacter:"\\ea7c"}),r.kebabHorizontal=new r("kebab-horizontal",{fontCharacter:"\\ea7c"}),r.mailReply=new r("mail-reply",{fontCharacter:"\\ea7d"}),r.reply=new r("reply",{fontCharacter:"\\ea7d"}),r.organization=new r("organization",{fontCharacter:"\\ea7e"}),r.organizationFilled=new r("organization-filled",{fontCharacter:"\\ea7e"}),r.organizationOutline=new r("organization-outline",{fontCharacter:"\\ea7e"}),r.newFile=new r("new-file",{fontCharacter:"\\ea7f"}),r.fileAdd=new r("file-add",{fontCharacter:"\\ea7f"}),r.newFolder=new r("new-folder",{fontCharacter:"\\ea80"}),r.fileDirectoryCreate=new r("file-directory-create",{fontCharacter:"\\ea80"}),r.trash=new r("trash",{fontCharacter:"\\ea81"}),r.trashcan=new r("trashcan",{fontCharacter:"\\ea81"}),r.history=new r("history",{fontCharacter:"\\ea82"}),r.clock=new r("clock",{fontCharacter:"\\ea82"}),r.folder=new r("folder",{fontCharacter:"\\ea83"}),r.fileDirectory=new r("file-directory",{fontCharacter:"\\ea83"}),r.symbolFolder=new r("symbol-folder",{fontCharacter:"\\ea83"}),r.logoGithub=new r("logo-github",{fontCharacter:"\\ea84"}),r.markGithub=new r("mark-github",{fontCharacter:"\\ea84"}),r.github=new r("github",{fontCharacter:"\\ea84"}),r.terminal=new r("terminal",{fontCharacter:"\\ea85"}),r.console=new r("console",{fontCharacter:"\\ea85"}),r.repl=new r("repl",{fontCharacter:"\\ea85"}),r.zap=new r("zap",{fontCharacter:"\\ea86"}),r.symbolEvent=new r("symbol-event",{fontCharacter:"\\ea86"}),r.error=new r("error",{fontCharacter:"\\ea87"}),r.stop=new r("stop",{fontCharacter:"\\ea87"}),r.variable=new r("variable",{fontCharacter:"\\ea88"}),r.symbolVariable=new r("symbol-variable",{fontCharacter:"\\ea88"}),r.array=new r("array",{fontCharacter:"\\ea8a"}),r.symbolArray=new r("symbol-array",{fontCharacter:"\\ea8a"}),r.symbolModule=new r("symbol-module",{fontCharacter:"\\ea8b"}),r.symbolPackage=new r("symbol-package",{fontCharacter:"\\ea8b"}),r.symbolNamespace=new r("symbol-namespace",{fontCharacter:"\\ea8b"}),r.symbolObject=new r("symbol-object",{fontCharacter:"\\ea8b"}),r.symbolMethod=new r("symbol-method",{fontCharacter:"\\ea8c"}),r.symbolFunction=new r("symbol-function",{fontCharacter:"\\ea8c"}),r.symbolConstructor=new r("symbol-constructor",{fontCharacter:"\\ea8c"}),r.symbolBoolean=new r("symbol-boolean",{fontCharacter:"\\ea8f"}),r.symbolNull=new r("symbol-null",{fontCharacter:"\\ea8f"}),r.symbolNumeric=new r("symbol-numeric",{fontCharacter:"\\ea90"}),r.symbolNumber=new r("symbol-number",{fontCharacter:"\\ea90"}),r.symbolStructure=new r("symbol-structure",{fontCharacter:"\\ea91"}),r.symbolStruct=new r("symbol-struct",{fontCharacter:"\\ea91"}),r.symbolParameter=new r("symbol-parameter",{fontCharacter:"\\ea92"}),r.symbolTypeParameter=new r("symbol-type-parameter",{fontCharacter:"\\ea92"}),r.symbolKey=new r("symbol-key",{fontCharacter:"\\ea93"}),r.symbolText=new r("symbol-text",{fontCharacter:"\\ea93"}),r.symbolReference=new r("symbol-reference",{fontCharacter:"\\ea94"}),r.goToFile=new r("go-to-file",{fontCharacter:"\\ea94"}),r.symbolEnum=new r("symbol-enum",{fontCharacter:"\\ea95"}),r.symbolValue=new r("symbol-value",{fontCharacter:"\\ea95"}),r.symbolRuler=new r("symbol-ruler",{fontCharacter:"\\ea96"}),r.symbolUnit=new r("symbol-unit",{fontCharacter:"\\ea96"}),r.activateBreakpoints=new r("activate-breakpoints",{fontCharacter:"\\ea97"}),r.archive=new r("archive",{fontCharacter:"\\ea98"}),r.arrowBoth=new r("arrow-both",{fontCharacter:"\\ea99"}),r.arrowDown=new r("arrow-down",{fontCharacter:"\\ea9a"}),r.arrowLeft=new r("arrow-left",{fontCharacter:"\\ea9b"}),r.arrowRight=new r("arrow-right",{fontCharacter:"\\ea9c"}),r.arrowSmallDown=new r("arrow-small-down",{fontCharacter:"\\ea9d"}),r.arrowSmallLeft=new r("arrow-small-left",{fontCharacter:"\\ea9e"}),r.arrowSmallRight=new r("arrow-small-right",{fontCharacter:"\\ea9f"}),r.arrowSmallUp=new r("arrow-small-up",{fontCharacter:"\\eaa0"}),r.arrowUp=new r("arrow-up",{fontCharacter:"\\eaa1"}),r.bell=new r("bell",{fontCharacter:"\\eaa2"}),r.bold=new r("bold",{fontCharacter:"\\eaa3"}),r.book=new r("book",{fontCharacter:"\\eaa4"}),r.bookmark=new r("bookmark",{fontCharacter:"\\eaa5"}),r.debugBreakpointConditionalUnverified=new r("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),r.debugBreakpointConditional=new r("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),r.debugBreakpointConditionalDisabled=new r("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),r.debugBreakpointDataUnverified=new r("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),r.debugBreakpointData=new r("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),r.debugBreakpointDataDisabled=new r("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),r.debugBreakpointLogUnverified=new r("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),r.debugBreakpointLog=new r("debug-breakpoint-log",{fontCharacter:"\\eaab"}),r.debugBreakpointLogDisabled=new r("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),r.briefcase=new r("briefcase",{fontCharacter:"\\eaac"}),r.broadcast=new r("broadcast",{fontCharacter:"\\eaad"}),r.browser=new r("browser",{fontCharacter:"\\eaae"}),r.bug=new r("bug",{fontCharacter:"\\eaaf"}),r.calendar=new r("calendar",{fontCharacter:"\\eab0"}),r.caseSensitive=new r("case-sensitive",{fontCharacter:"\\eab1"}),r.check=new r("check",{fontCharacter:"\\eab2"}),r.checklist=new r("checklist",{fontCharacter:"\\eab3"}),r.chevronDown=new r("chevron-down",{fontCharacter:"\\eab4"}),r.dropDownButton=new r("drop-down-button",r.chevronDown.definition),r.chevronLeft=new r("chevron-left",{fontCharacter:"\\eab5"}),r.chevronRight=new r("chevron-right",{fontCharacter:"\\eab6"}),r.chevronUp=new r("chevron-up",{fontCharacter:"\\eab7"}),r.chromeClose=new r("chrome-close",{fontCharacter:"\\eab8"}),r.chromeMaximize=new r("chrome-maximize",{fontCharacter:"\\eab9"}),r.chromeMinimize=new r("chrome-minimize",{fontCharacter:"\\eaba"}),r.chromeRestore=new r("chrome-restore",{fontCharacter:"\\eabb"}),r.circleOutline=new r("circle-outline",{fontCharacter:"\\eabc"}),r.debugBreakpointUnverified=new r("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),r.circleSlash=new r("circle-slash",{fontCharacter:"\\eabd"}),r.circuitBoard=new r("circuit-board",{fontCharacter:"\\eabe"}),r.clearAll=new r("clear-all",{fontCharacter:"\\eabf"}),r.clippy=new r("clippy",{fontCharacter:"\\eac0"}),r.closeAll=new r("close-all",{fontCharacter:"\\eac1"}),r.cloudDownload=new r("cloud-download",{fontCharacter:"\\eac2"}),r.cloudUpload=new r("cloud-upload",{fontCharacter:"\\eac3"}),r.code=new r("code",{fontCharacter:"\\eac4"}),r.collapseAll=new r("collapse-all",{fontCharacter:"\\eac5"}),r.colorMode=new r("color-mode",{fontCharacter:"\\eac6"}),r.commentDiscussion=new r("comment-discussion",{fontCharacter:"\\eac7"}),r.compareChanges=new r("compare-changes",{fontCharacter:"\\eafd"}),r.creditCard=new r("credit-card",{fontCharacter:"\\eac9"}),r.dash=new r("dash",{fontCharacter:"\\eacc"}),r.dashboard=new r("dashboard",{fontCharacter:"\\eacd"}),r.database=new r("database",{fontCharacter:"\\eace"}),r.debugContinue=new r("debug-continue",{fontCharacter:"\\eacf"}),r.debugDisconnect=new r("debug-disconnect",{fontCharacter:"\\ead0"}),r.debugPause=new r("debug-pause",{fontCharacter:"\\ead1"}),r.debugRestart=new r("debug-restart",{fontCharacter:"\\ead2"}),r.debugStart=new r("debug-start",{fontCharacter:"\\ead3"}),r.debugStepInto=new r("debug-step-into",{fontCharacter:"\\ead4"}),r.debugStepOut=new r("debug-step-out",{fontCharacter:"\\ead5"}),r.debugStepOver=new r("debug-step-over",{fontCharacter:"\\ead6"}),r.debugStop=new r("debug-stop",{fontCharacter:"\\ead7"}),r.debug=new r("debug",{fontCharacter:"\\ead8"}),r.deviceCameraVideo=new r("device-camera-video",{fontCharacter:"\\ead9"}),r.deviceCamera=new r("device-camera",{fontCharacter:"\\eada"}),r.deviceMobile=new r("device-mobile",{fontCharacter:"\\eadb"}),r.diffAdded=new r("diff-added",{fontCharacter:"\\eadc"}),r.diffIgnored=new r("diff-ignored",{fontCharacter:"\\eadd"}),r.diffModified=new r("diff-modified",{fontCharacter:"\\eade"}),r.diffRemoved=new r("diff-removed",{fontCharacter:"\\eadf"}),r.diffRenamed=new r("diff-renamed",{fontCharacter:"\\eae0"}),r.diff=new r("diff",{fontCharacter:"\\eae1"}),r.discard=new r("discard",{fontCharacter:"\\eae2"}),r.editorLayout=new r("editor-layout",{fontCharacter:"\\eae3"}),r.emptyWindow=new r("empty-window",{fontCharacter:"\\eae4"}),r.exclude=new r("exclude",{fontCharacter:"\\eae5"}),r.extensions=new r("extensions",{fontCharacter:"\\eae6"}),r.eyeClosed=new r("eye-closed",{fontCharacter:"\\eae7"}),r.fileBinary=new r("file-binary",{fontCharacter:"\\eae8"}),r.fileCode=new r("file-code",{fontCharacter:"\\eae9"}),r.fileMedia=new r("file-media",{fontCharacter:"\\eaea"}),r.filePdf=new r("file-pdf",{fontCharacter:"\\eaeb"}),r.fileSubmodule=new r("file-submodule",{fontCharacter:"\\eaec"}),r.fileSymlinkDirectory=new r("file-symlink-directory",{fontCharacter:"\\eaed"}),r.fileSymlinkFile=new r("file-symlink-file",{fontCharacter:"\\eaee"}),r.fileZip=new r("file-zip",{fontCharacter:"\\eaef"}),r.files=new r("files",{fontCharacter:"\\eaf0"}),r.filter=new r("filter",{fontCharacter:"\\eaf1"}),r.flame=new r("flame",{fontCharacter:"\\eaf2"}),r.foldDown=new r("fold-down",{fontCharacter:"\\eaf3"}),r.foldUp=new r("fold-up",{fontCharacter:"\\eaf4"}),r.fold=new r("fold",{fontCharacter:"\\eaf5"}),r.folderActive=new r("folder-active",{fontCharacter:"\\eaf6"}),r.folderOpened=new r("folder-opened",{fontCharacter:"\\eaf7"}),r.gear=new r("gear",{fontCharacter:"\\eaf8"}),r.gift=new r("gift",{fontCharacter:"\\eaf9"}),r.gistSecret=new r("gist-secret",{fontCharacter:"\\eafa"}),r.gist=new r("gist",{fontCharacter:"\\eafb"}),r.gitCommit=new r("git-commit",{fontCharacter:"\\eafc"}),r.gitCompare=new r("git-compare",{fontCharacter:"\\eafd"}),r.gitMerge=new r("git-merge",{fontCharacter:"\\eafe"}),r.githubAction=new r("github-action",{fontCharacter:"\\eaff"}),r.githubAlt=new r("github-alt",{fontCharacter:"\\eb00"}),r.globe=new r("globe",{fontCharacter:"\\eb01"}),r.grabber=new r("grabber",{fontCharacter:"\\eb02"}),r.graph=new r("graph",{fontCharacter:"\\eb03"}),r.gripper=new r("gripper",{fontCharacter:"\\eb04"}),r.heart=new r("heart",{fontCharacter:"\\eb05"}),r.home=new r("home",{fontCharacter:"\\eb06"}),r.horizontalRule=new r("horizontal-rule",{fontCharacter:"\\eb07"}),r.hubot=new r("hubot",{fontCharacter:"\\eb08"}),r.inbox=new r("inbox",{fontCharacter:"\\eb09"}),r.issueClosed=new r("issue-closed",{fontCharacter:"\\eba4"}),r.issueReopened=new r("issue-reopened",{fontCharacter:"\\eb0b"}),r.issues=new r("issues",{fontCharacter:"\\eb0c"}),r.italic=new r("italic",{fontCharacter:"\\eb0d"}),r.jersey=new r("jersey",{fontCharacter:"\\eb0e"}),r.json=new r("json",{fontCharacter:"\\eb0f"}),r.kebabVertical=new r("kebab-vertical",{fontCharacter:"\\eb10"}),r.key=new r("key",{fontCharacter:"\\eb11"}),r.law=new r("law",{fontCharacter:"\\eb12"}),r.lightbulbAutofix=new r("lightbulb-autofix",{fontCharacter:"\\eb13"}),r.linkExternal=new r("link-external",{fontCharacter:"\\eb14"}),r.link=new r("link",{fontCharacter:"\\eb15"}),r.listOrdered=new r("list-ordered",{fontCharacter:"\\eb16"}),r.listUnordered=new r("list-unordered",{fontCharacter:"\\eb17"}),r.liveShare=new r("live-share",{fontCharacter:"\\eb18"}),r.loading=new r("loading",{fontCharacter:"\\eb19"}),r.location=new r("location",{fontCharacter:"\\eb1a"}),r.mailRead=new r("mail-read",{fontCharacter:"\\eb1b"}),r.mail=new r("mail",{fontCharacter:"\\eb1c"}),r.markdown=new r("markdown",{fontCharacter:"\\eb1d"}),r.megaphone=new r("megaphone",{fontCharacter:"\\eb1e"}),r.mention=new r("mention",{fontCharacter:"\\eb1f"}),r.milestone=new r("milestone",{fontCharacter:"\\eb20"}),r.mortarBoard=new r("mortar-board",{fontCharacter:"\\eb21"}),r.move=new r("move",{fontCharacter:"\\eb22"}),r.multipleWindows=new r("multiple-windows",{fontCharacter:"\\eb23"}),r.mute=new r("mute",{fontCharacter:"\\eb24"}),r.noNewline=new r("no-newline",{fontCharacter:"\\eb25"}),r.note=new r("note",{fontCharacter:"\\eb26"}),r.octoface=new r("octoface",{fontCharacter:"\\eb27"}),r.openPreview=new r("open-preview",{fontCharacter:"\\eb28"}),r.package_=new r("package",{fontCharacter:"\\eb29"}),r.paintcan=new r("paintcan",{fontCharacter:"\\eb2a"}),r.pin=new r("pin",{fontCharacter:"\\eb2b"}),r.play=new r("play",{fontCharacter:"\\eb2c"}),r.run=new r("run",{fontCharacter:"\\eb2c"}),r.plug=new r("plug",{fontCharacter:"\\eb2d"}),r.preserveCase=new r("preserve-case",{fontCharacter:"\\eb2e"}),r.preview=new r("preview",{fontCharacter:"\\eb2f"}),r.project=new r("project",{fontCharacter:"\\eb30"}),r.pulse=new r("pulse",{fontCharacter:"\\eb31"}),r.question=new r("question",{fontCharacter:"\\eb32"}),r.quote=new r("quote",{fontCharacter:"\\eb33"}),r.radioTower=new r("radio-tower",{fontCharacter:"\\eb34"}),r.reactions=new r("reactions",{fontCharacter:"\\eb35"}),r.references=new r("references",{fontCharacter:"\\eb36"}),r.refresh=new r("refresh",{fontCharacter:"\\eb37"}),r.regex=new r("regex",{fontCharacter:"\\eb38"}),r.remoteExplorer=new r("remote-explorer",{fontCharacter:"\\eb39"}),r.remote=new r("remote",{fontCharacter:"\\eb3a"}),r.remove=new r("remove",{fontCharacter:"\\eb3b"}),r.replaceAll=new r("replace-all",{fontCharacter:"\\eb3c"}),r.replace=new r("replace",{fontCharacter:"\\eb3d"}),r.repoClone=new r("repo-clone",{fontCharacter:"\\eb3e"}),r.repoForcePush=new r("repo-force-push",{fontCharacter:"\\eb3f"}),r.repoPull=new r("repo-pull",{fontCharacter:"\\eb40"}),r.repoPush=new r("repo-push",{fontCharacter:"\\eb41"}),r.report=new r("report",{fontCharacter:"\\eb42"}),r.requestChanges=new r("request-changes",{fontCharacter:"\\eb43"}),r.rocket=new r("rocket",{fontCharacter:"\\eb44"}),r.rootFolderOpened=new r("root-folder-opened",{fontCharacter:"\\eb45"}),r.rootFolder=new r("root-folder",{fontCharacter:"\\eb46"}),r.rss=new r("rss",{fontCharacter:"\\eb47"}),r.ruby=new r("ruby",{fontCharacter:"\\eb48"}),r.saveAll=new r("save-all",{fontCharacter:"\\eb49"}),r.saveAs=new r("save-as",{fontCharacter:"\\eb4a"}),r.save=new r("save",{fontCharacter:"\\eb4b"}),r.screenFull=new r("screen-full",{fontCharacter:"\\eb4c"}),r.screenNormal=new r("screen-normal",{fontCharacter:"\\eb4d"}),r.searchStop=new r("search-stop",{fontCharacter:"\\eb4e"}),r.server=new r("server",{fontCharacter:"\\eb50"}),r.settingsGear=new r("settings-gear",{fontCharacter:"\\eb51"}),r.settings=new r("settings",{fontCharacter:"\\eb52"}),r.shield=new r("shield",{fontCharacter:"\\eb53"}),r.smiley=new r("smiley",{fontCharacter:"\\eb54"}),r.sortPrecedence=new r("sort-precedence",{fontCharacter:"\\eb55"}),r.splitHorizontal=new r("split-horizontal",{fontCharacter:"\\eb56"}),r.splitVertical=new r("split-vertical",{fontCharacter:"\\eb57"}),r.squirrel=new r("squirrel",{fontCharacter:"\\eb58"}),r.starFull=new r("star-full",{fontCharacter:"\\eb59"}),r.starHalf=new r("star-half",{fontCharacter:"\\eb5a"}),r.symbolClass=new r("symbol-class",{fontCharacter:"\\eb5b"}),r.symbolColor=new r("symbol-color",{fontCharacter:"\\eb5c"}),r.symbolCustomColor=new r("symbol-customcolor",{fontCharacter:"\\eb5c"}),r.symbolConstant=new r("symbol-constant",{fontCharacter:"\\eb5d"}),r.symbolEnumMember=new r("symbol-enum-member",{fontCharacter:"\\eb5e"}),r.symbolField=new r("symbol-field",{fontCharacter:"\\eb5f"}),r.symbolFile=new r("symbol-file",{fontCharacter:"\\eb60"}),r.symbolInterface=new r("symbol-interface",{fontCharacter:"\\eb61"}),r.symbolKeyword=new r("symbol-keyword",{fontCharacter:"\\eb62"}),r.symbolMisc=new r("symbol-misc",{fontCharacter:"\\eb63"}),r.symbolOperator=new r("symbol-operator",{fontCharacter:"\\eb64"}),r.symbolProperty=new r("symbol-property",{fontCharacter:"\\eb65"}),r.wrench=new r("wrench",{fontCharacter:"\\eb65"}),r.wrenchSubaction=new r("wrench-subaction",{fontCharacter:"\\eb65"}),r.symbolSnippet=new r("symbol-snippet",{fontCharacter:"\\eb66"}),r.tasklist=new r("tasklist",{fontCharacter:"\\eb67"}),r.telescope=new r("telescope",{fontCharacter:"\\eb68"}),r.textSize=new r("text-size",{fontCharacter:"\\eb69"}),r.threeBars=new r("three-bars",{fontCharacter:"\\eb6a"}),r.thumbsdown=new r("thumbsdown",{fontCharacter:"\\eb6b"}),r.thumbsup=new r("thumbsup",{fontCharacter:"\\eb6c"}),r.tools=new r("tools",{fontCharacter:"\\eb6d"}),r.triangleDown=new r("triangle-down",{fontCharacter:"\\eb6e"}),r.triangleLeft=new r("triangle-left",{fontCharacter:"\\eb6f"}),r.triangleRight=new r("triangle-right",{fontCharacter:"\\eb70"}),r.triangleUp=new r("triangle-up",{fontCharacter:"\\eb71"}),r.twitter=new r("twitter",{fontCharacter:"\\eb72"}),r.unfold=new r("unfold",{fontCharacter:"\\eb73"}),r.unlock=new r("unlock",{fontCharacter:"\\eb74"}),r.unmute=new r("unmute",{fontCharacter:"\\eb75"}),r.unverified=new r("unverified",{fontCharacter:"\\eb76"}),r.verified=new r("verified",{fontCharacter:"\\eb77"}),r.versions=new r("versions",{fontCharacter:"\\eb78"}),r.vmActive=new r("vm-active",{fontCharacter:"\\eb79"}),r.vmOutline=new r("vm-outline",{fontCharacter:"\\eb7a"}),r.vmRunning=new r("vm-running",{fontCharacter:"\\eb7b"}),r.watch=new r("watch",{fontCharacter:"\\eb7c"}),r.whitespace=new r("whitespace",{fontCharacter:"\\eb7d"}),r.wholeWord=new r("whole-word",{fontCharacter:"\\eb7e"}),r.window=new r("window",{fontCharacter:"\\eb7f"}),r.wordWrap=new r("word-wrap",{fontCharacter:"\\eb80"}),r.zoomIn=new r("zoom-in",{fontCharacter:"\\eb81"}),r.zoomOut=new r("zoom-out",{fontCharacter:"\\eb82"}),r.listFilter=new r("list-filter",{fontCharacter:"\\eb83"}),r.listFlat=new r("list-flat",{fontCharacter:"\\eb84"}),r.listSelection=new r("list-selection",{fontCharacter:"\\eb85"}),r.selection=new r("selection",{fontCharacter:"\\eb85"}),r.listTree=new r("list-tree",{fontCharacter:"\\eb86"}),r.debugBreakpointFunctionUnverified=new r("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),r.debugBreakpointFunction=new r("debug-breakpoint-function",{fontCharacter:"\\eb88"}),r.debugBreakpointFunctionDisabled=new r("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),r.debugStackframeActive=new r("debug-stackframe-active",{fontCharacter:"\\eb89"}),r.debugStackframeDot=new r("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),r.debugStackframe=new r("debug-stackframe",{fontCharacter:"\\eb8b"}),r.debugStackframeFocused=new r("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),r.debugBreakpointUnsupported=new r("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),r.symbolString=new r("symbol-string",{fontCharacter:"\\eb8d"}),r.debugReverseContinue=new r("debug-reverse-continue",{fontCharacter:"\\eb8e"}),r.debugStepBack=new r("debug-step-back",{fontCharacter:"\\eb8f"}),r.debugRestartFrame=new r("debug-restart-frame",{fontCharacter:"\\eb90"}),r.callIncoming=new r("call-incoming",{fontCharacter:"\\eb92"}),r.callOutgoing=new r("call-outgoing",{fontCharacter:"\\eb93"}),r.menu=new r("menu",{fontCharacter:"\\eb94"}),r.expandAll=new r("expand-all",{fontCharacter:"\\eb95"}),r.feedback=new r("feedback",{fontCharacter:"\\eb96"}),r.groupByRefType=new r("group-by-ref-type",{fontCharacter:"\\eb97"}),r.ungroupByRefType=new r("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),r.account=new r("account",{fontCharacter:"\\eb99"}),r.bellDot=new r("bell-dot",{fontCharacter:"\\eb9a"}),r.debugConsole=new r("debug-console",{fontCharacter:"\\eb9b"}),r.library=new r("library",{fontCharacter:"\\eb9c"}),r.output=new r("output",{fontCharacter:"\\eb9d"}),r.runAll=new r("run-all",{fontCharacter:"\\eb9e"}),r.syncIgnored=new r("sync-ignored",{fontCharacter:"\\eb9f"}),r.pinned=new r("pinned",{fontCharacter:"\\eba0"}),r.githubInverted=new r("github-inverted",{fontCharacter:"\\eba1"}),r.debugAlt=new r("debug-alt",{fontCharacter:"\\eb91"}),r.serverProcess=new r("server-process",{fontCharacter:"\\eba2"}),r.serverEnvironment=new r("server-environment",{fontCharacter:"\\eba3"}),r.pass=new r("pass",{fontCharacter:"\\eba4"}),r.stopCircle=new r("stop-circle",{fontCharacter:"\\eba5"}),r.playCircle=new r("play-circle",{fontCharacter:"\\eba6"}),r.record=new r("record",{fontCharacter:"\\eba7"}),r.debugAltSmall=new r("debug-alt-small",{fontCharacter:"\\eba8"}),r.vmConnect=new r("vm-connect",{fontCharacter:"\\eba9"}),r.cloud=new r("cloud",{fontCharacter:"\\ebaa"}),r.merge=new r("merge",{fontCharacter:"\\ebab"}),r.exportIcon=new r("export",{fontCharacter:"\\ebac"}),r.graphLeft=new r("graph-left",{fontCharacter:"\\ebad"}),r.magnet=new r("magnet",{fontCharacter:"\\ebae"}),r.notebook=new r("notebook",{fontCharacter:"\\ebaf"}),r.redo=new r("redo",{fontCharacter:"\\ebb0"}),r.checkAll=new r("check-all",{fontCharacter:"\\ebb1"}),r.pinnedDirty=new r("pinned-dirty",{fontCharacter:"\\ebb2"}),r.passFilled=new r("pass-filled",{fontCharacter:"\\ebb3"}),r.circleLargeFilled=new r("circle-large-filled",{fontCharacter:"\\ebb4"}),r.circleLargeOutline=new r("circle-large-outline",{fontCharacter:"\\ebb5"}),r.combine=new r("combine",{fontCharacter:"\\ebb6"}),r.gather=new r("gather",{fontCharacter:"\\ebb6"}),r.table=new r("table",{fontCharacter:"\\ebb7"}),r.variableGroup=new r("variable-group",{fontCharacter:"\\ebb8"}),r.typeHierarchy=new r("type-hierarchy",{fontCharacter:"\\ebb9"}),r.typeHierarchySub=new r("type-hierarchy-sub",{fontCharacter:"\\ebba"}),r.typeHierarchySuper=new r("type-hierarchy-super",{fontCharacter:"\\ebbb"}),r.gitPullRequestCreate=new r("git-pull-request-create",{fontCharacter:"\\ebbc"}),r.runAbove=new r("run-above",{fontCharacter:"\\ebbd"}),r.runBelow=new r("run-below",{fontCharacter:"\\ebbe"}),r.notebookTemplate=new r("notebook-template",{fontCharacter:"\\ebbf"}),r.debugRerun=new r("debug-rerun",{fontCharacter:"\\ebc0"}),r.workspaceTrusted=new r("workspace-trusted",{fontCharacter:"\\ebc1"}),r.workspaceUntrusted=new r("workspace-untrusted",{fontCharacter:"\\ebc2"}),r.workspaceUnspecified=new r("workspace-unspecified",{fontCharacter:"\\ebc3"}),r.terminalCmd=new r("terminal-cmd",{fontCharacter:"\\ebc4"}),r.terminalDebian=new r("terminal-debian",{fontCharacter:"\\ebc5"}),r.terminalLinux=new r("terminal-linux",{fontCharacter:"\\ebc6"}),r.terminalPowershell=new r("terminal-powershell",{fontCharacter:"\\ebc7"}),r.terminalTmux=new r("terminal-tmux",{fontCharacter:"\\ebc8"}),r.terminalUbuntu=new r("terminal-ubuntu",{fontCharacter:"\\ebc9"}),r.terminalBash=new r("terminal-bash",{fontCharacter:"\\ebca"}),r.arrowSwap=new r("arrow-swap",{fontCharacter:"\\ebcb"}),r.copy=new r("copy",{fontCharacter:"\\ebcc"}),r.personAdd=new r("person-add",{fontCharacter:"\\ebcd"}),r.filterFilled=new r("filter-filled",{fontCharacter:"\\ebce"}),r.wand=new r("wand",{fontCharacter:"\\ebcf"}),r.debugLineByLine=new r("debug-line-by-line",{fontCharacter:"\\ebd0"}),r.inspect=new r("inspect",{fontCharacter:"\\ebd1"}),r.layers=new r("layers",{fontCharacter:"\\ebd2"}),r.layersDot=new r("layers-dot",{fontCharacter:"\\ebd3"}),r.layersActive=new r("layers-active",{fontCharacter:"\\ebd4"}),r.compass=new r("compass",{fontCharacter:"\\ebd5"}),r.compassDot=new r("compass-dot",{fontCharacter:"\\ebd6"}),r.compassActive=new r("compass-active",{fontCharacter:"\\ebd7"}),r.azure=new r("azure",{fontCharacter:"\\ebd8"}),r.issueDraft=new r("issue-draft",{fontCharacter:"\\ebd9"}),r.gitPullRequestClosed=new r("git-pull-request-closed",{fontCharacter:"\\ebda"}),r.gitPullRequestDraft=new r("git-pull-request-draft",{fontCharacter:"\\ebdb"}),r.debugAll=new r("debug-all",{fontCharacter:"\\ebdc"}),r.debugCoverage=new r("debug-coverage",{fontCharacter:"\\ebdd"}),r.runErrors=new r("run-errors",{fontCharacter:"\\ebde"}),r.folderLibrary=new r("folder-library",{fontCharacter:"\\ebdf"}),r.debugContinueSmall=new r("debug-continue-small",{fontCharacter:"\\ebe0"}),r.beakerStop=new r("beaker-stop",{fontCharacter:"\\ebe1"}),r.graphLine=new r("graph-line",{fontCharacter:"\\ebe2"}),r.graphScatter=new r("graph-scatter",{fontCharacter:"\\ebe3"}),r.pieChart=new r("pie-chart",{fontCharacter:"\\ebe4"}),r.bracket=new r("bracket",r.json.definition),r.bracketDot=new r("bracket-dot",{fontCharacter:"\\ebe5"}),r.bracketError=new r("bracket-error",{fontCharacter:"\\ebe6"}),r.lockSmall=new r("lock-small",{fontCharacter:"\\ebe7"}),r.azureDevops=new r("azure-devops",{fontCharacter:"\\ebe8"}),r.verifiedFilled=new r("verified-filled",{fontCharacter:"\\ebe9"}),r.newLine=new r("newline",{fontCharacter:"\\ebea"}),r.layout=new r("layout",{fontCharacter:"\\ebeb"}),r.dialogError=new r("dialog-error",r.error.definition),r.dialogWarning=new r("dialog-warning",r.warning.definition),r.dialogInfo=new r("dialog-info",r.info.definition),r.dialogClose=new r("dialog-close",r.close.definition),r.treeItemExpanded=new r("tree-item-expanded",r.chevronDown.definition),r.treeFilterOnTypeOn=new r("tree-filter-on-type-on",r.listFilter.definition),r.treeFilterOnTypeOff=new r("tree-filter-on-type-off",r.listSelection.definition),r.treeFilterClear=new r("tree-filter-clear",r.close.definition),r.treeItemLoading=new r("tree-item-loading",r.loading.definition),r.menuSelection=new r("menu-selection",r.check.definition),r.menuSubmenu=new r("menu-submenu",r.chevronRight.definition),r.menuBarMore=new r("menubar-more",r.more.definition),r.scrollbarButtonLeft=new r("scrollbar-button-left",r.triangleLeft.definition),r.scrollbarButtonRight=new r("scrollbar-button-right",r.triangleRight.definition),r.scrollbarButtonUp=new r("scrollbar-button-up",r.triangleUp.definition),r.scrollbarButtonDown=new r("scrollbar-button-down",r.triangleDown.definition),r.toolBarMore=new r("toolbar-more",r.more.definition),r.quickInputBack=new r("quick-input-back",r.arrowLeft.definition);function D(P,I){const d=["codicon","codicon-"+P];return I&&d.push("codicon-modifier-"+I),d}e.getClassNamesArray=D;var C;(function(P){P.iconNameSegment="[A-Za-z0-9]+",P.iconNameExpression="[A-Za-z0-9-]+",P.iconModifierExpression="~[A-Za-z]+",P.iconNameCharacter="[A-Za-z0-9~-]";const I=new RegExp(`^(${P.iconNameExpression})(${P.iconModifierExpression})?$`);function d(b){if(b instanceof r)return["codicon","codicon-"+b.id];const m=I.exec(b.id);if(!m)return d(r.error);let[,S,t]=m;const g=["codicon","codicon-"+S];return t&&g.push("codicon-modifier-"+t.substr(1)),g}P.asClassNameArray=d;function f(b){return d(b).join(" ")}P.asClassName=f;function y(b){return"."+d(b).join(".")}P.asCSSSelector=y})(C=e.CSSIcon||(e.CSSIcon={}))}),define(Z[46],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function p(P){return(I,d,f)=>{let y=null,b=null;if(typeof f.value=="function"?(y="value",b=f.value):typeof f.get=="function"&&(y="get",b=f.get),!b)throw new Error("not supported");f[y]=P(b,d)}}e.createDecorator=p;function r(P,I,d){let f=null,y=null;if(typeof d.value=="function"?(f="value",y=d.value,y.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof d.get=="function"&&(f="get",y=d.get),!y)throw new Error("not supported");const b=`$memoize$${I}`;d[f]=function(...m){return this.hasOwnProperty(b)||Object.defineProperty(this,b,{configurable:!1,enumerable:!1,writable:!1,value:y.apply(this,m)}),this[b]}}e.memoize=r;function D(P,I,d){return p((f,y)=>{const b=`$debounce$${y}`,m=`$debounce$result$${y}`;return function(...S){this[m]||(this[m]=d?d():void 0),clearTimeout(this[b]),I&&(this[m]=I(this[m],...S),S=[this[m]]),this[b]=setTimeout(()=>{f.apply(this,S),this[m]=d?d():void 0},P)}})}e.debounce=D;function C(P,I,d){return p((f,y)=>{const b=`$throttle$timer$${y}`,m=`$throttle$result$${y}`,S=`$throttle$lastRun$${y}`,t=`$throttle$pending$${y}`;return function(...g){if(this[m]||(this[m]=d?d():void 0),(this[S]===null||this[S]===void 0)&&(this[S]=-Number.MAX_VALUE),I&&(this[m]=I(this[m],...g)),this[t])return;const E=this[S]+P;E<=Date.now()?(this[S]=Date.now(),f.apply(this,[this[m]]),this[m]=d?d():void 0):(this[t]=!0,this[b]=setTimeout(()=>{this[t]=!1,this[S]=Date.now(),f.apply(this,[this[m]]),this[m]=d?d():void 0},E-Date.now()))}})}e.throttle=C}),define(Z[16],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class p{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(s){setTimeout(()=>{throw s.stack?new Error(s.message+`

`+s.stack):s},0)}}addListener(s){return this.listeners.push(s),()=>{this._removeListener(s)}}emit(s){this.listeners.forEach(l=>{l(s)})}_removeListener(s){this.listeners.splice(this.listeners.indexOf(s),1)}setUnexpectedErrorHandler(s){this.unexpectedErrorHandler=s}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(s){this.unexpectedErrorHandler(s),this.emit(s)}onUnexpectedExternalError(s){this.unexpectedErrorHandler(s)}}e.ErrorHandler=p,e.errorHandler=new p;function r(u){e.errorHandler.setUnexpectedErrorHandler(u)}e.setUnexpectedErrorHandler=r;function D(u){d(u)||e.errorHandler.onUnexpectedError(u)}e.onUnexpectedError=D;function C(u){d(u)||e.errorHandler.onUnexpectedExternalError(u)}e.onUnexpectedExternalError=C;function P(u){if(u instanceof Error){let{name:s,message:l}=u;const n=u.stacktrace||u.stack;return{$isError:!0,name:s,message:l,stack:n}}return u}e.transformErrorForSerialization=P;const I="Canceled";function d(u){return u instanceof Error&&u.name===I&&u.message===I}e.isPromiseCanceledError=d;class f extends Error{constructor(){super(I);this.name=this.message}}e.CancellationError=f;function y(){const u=new Error(I);return u.name=u.message,u}e.canceled=y;function b(u){return u?new Error(`Illegal argument: ${u}`):new Error("Illegal argument")}e.illegalArgument=b;function m(u){return u?new Error(`Illegal state: ${u}`):new Error("Illegal state")}e.illegalState=m;function S(u){return u?new Error(`readonly property '${u} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=S;function t(u){const s=new Error(`${u} has been disposed`);return s.name="DISPOSED",s}e.disposed=t;function g(u){return u?u.message?u.message:u.stack?u.stack.split(`
`)[0]:String(u):"Error"}e.getErrorMessage=g;class E extends Error{constructor(s){super("NotImplemented");s&&(this.message=s)}}e.NotImplementedError=E;class v extends Error{constructor(s){super("NotSupported");s&&(this.message=s)}}e.NotSupportedError=v;class k extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=k;function c(u){const s=u;return s instanceof Error&&Array.isArray(s.actions)}e.isErrorWithActions=c;function a(u,s=Object.create(null)){const l=new Error(u);return s.actions&&(l.actions=s.actions),l}e.createErrorWithActions=a}),define(Z[30],x([0,1,16]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.compareBy=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function r(F,N=0){return F[F.length-(1+N)]}e.tail=r;function D(F){if(F.length===0)throw new Error("Invalid tail call");return[F.slice(0,F.length-1),F[F.length-1]]}e.tail2=D;function C(F,N,V=(U,z)=>U===z){if(F===N)return!0;if(!F||!N||F.length!==N.length)return!1;for(let U=0,z=F.length;U<z;U++)if(!V(F[U],N[U]))return!1;return!0}e.equals=C;function P(F,N,V){let U=0,z=F.length-1;for(;U<=z;){const ee=(U+z)/2|0,re=V(F[ee],N);if(re<0)U=ee+1;else if(re>0)z=ee-1;else return ee}return-(U+1)}e.binarySearch=P;function I(F,N){let V=0,U=F.length;if(U===0)return 0;for(;V<U;){const z=Math.floor((V+U)/2);N(F[z])?U=z:V=z+1}return V}e.findFirstInSorted=I;function d(F,N,V){if(F=F|0,F>=N.length)throw new TypeError("invalid index");let U=N[Math.floor(N.length*Math.random())],z=[],ee=[],re=[];for(let se of N){const J=V(se,U);J<0?z.push(se):J>0?ee.push(se):re.push(se)}return F<z.length?d(F,z,V):F<z.length+re.length?re[0]:d(F-(z.length+re.length),ee,V)}e.quickSelect=d;function f(F,N){const V=[];let U;for(const z of F.slice(0).sort(N))!U||N(U[0],z)!==0?(U=[z],V.push(U)):U.push(z);return V}e.groupBy=f;function y(F,N,V){const U=[];function z(se,J,ce){if(J===0&&ce.length===0)return;const le=U[U.length-1];le&&le.start+le.deleteCount===se?(le.deleteCount+=J,le.toInsert.push(...ce)):U.push({start:se,deleteCount:J,toInsert:ce})}let ee=0,re=0;for(;;){if(ee===F.length){z(ee,0,N.slice(re));break}if(re===N.length){z(ee,F.length-ee,[]);break}const se=F[ee],J=N[re],ce=V(se,J);ce===0?(ee+=1,re+=1):ce<0?(z(ee,1,[]),ee+=1):ce>0&&(z(ee,0,[J]),re+=1)}return U}e.sortedDiff=y;function b(F,N,V){const U=y(F,N,V),z=[],ee=[];for(const re of U)z.push(...F.slice(re.start,re.start+re.deleteCount)),ee.push(...re.toInsert);return{removed:z,added:ee}}e.delta=b;function m(F,N,V){if(V===0)return[];const U=F.slice(0,V).sort(N);return t(F,N,U,V,F.length),U}e.top=m;function S(F,N,V,U,z){return V===0?Promise.resolve([]):new Promise((ee,re)=>{(async()=>{const se=F.length,J=F.slice(0,V).sort(N);for(let ce=V,le=Math.min(V+U,se);ce<se;ce=le,le=Math.min(le+U,se)){if(ce>V&&await new Promise(ue=>setTimeout(ue)),z&&z.isCancellationRequested)throw(0,p.canceled)();t(F,N,J,ce,le)}return J})().then(ee,re)})}e.topAsync=S;function t(F,N,V,U,z){for(const ee=V.length;U<z;U++){const re=F[U];if(N(re,V[ee-1])<0){V.pop();const se=I(V,J=>N(re,J)<0);V.splice(se,0,re)}}}function g(F){return F.filter(N=>!!N)}e.coalesce=g;function E(F){let N=0;for(let V=0;V<F.length;V++)F[V]&&(F[N]=F[V],N+=1);F.length=N}e.coalesceInPlace=E;function v(F,N,V){F.splice(V,0,F.splice(N,1)[0])}e.move=v;function k(F){return!Array.isArray(F)||F.length===0}e.isFalsyOrEmpty=k;function c(F){return Array.isArray(F)&&F.length>0}e.isNonEmptyArray=c;function a(F,N=V=>V){const V=new Set;return F.filter(U=>{const z=N(U);return V.has(z)?!1:(V.add(z),!0)})}e.distinct=a;function u(F){const N=Object.create(null);return V=>{const U=F(V);return N[U]?!1:(N[U]=!0,!0)}}e.uniqueFilter=u;function s(F,N){const V=l(F,N);if(V!==-1)return F[V]}e.findLast=s;function l(F,N){for(let V=F.length-1;V>=0;V--){const U=F[V];if(N(U))return V}return-1}e.lastIndex=l;function n(F,N){return F.length>0?F[0]:N}e.firstOrDefault=n;function i(F,N,V=(U,z)=>U===z){let U=0;for(let z=0,ee=Math.min(F.length,N.length);z<ee&&V(F[z],N[z]);z++)U++;return U}e.commonPrefixLength=i;function o(F){return[].concat(...F)}e.flatten=o;function h(F,N){let V=typeof N=="number"?F:0;typeof N=="number"?V=F:(V=0,N=F);const U=[];if(V<=N)for(let z=V;z<N;z++)U.push(z);else for(let z=V;z>N;z--)U.push(z);return U}e.range=h;function w(F,N,V){return F.reduce((U,z)=>(U[N(z)]=V?V(z):z,U),Object.create(null))}e.index=w;function M(F,N){return F.push(N),()=>A(F,N)}e.insert=M;function A(F,N){const V=F.indexOf(N);if(V>-1)return F.splice(V,1),N}e.remove=A;function R(F,N,V){const U=F.slice(0,N),z=F.slice(N);return U.concat(V,z)}e.arrayInsert=R;function T(F,N){let V;if(typeof N=="number"){let U=N;V=()=>{const z=Math.sin(U++)*179426549;return z-Math.floor(z)}}else V=Math.random;for(let U=F.length-1;U>0;U-=1){const z=Math.floor(V()*(U+1)),ee=F[U];F[U]=F[z],F[z]=ee}}e.shuffle=T;function _(F,N){const V=F.indexOf(N);V>-1&&(F.splice(V,1),F.unshift(N))}e.pushToStart=_;function Q(F,N){const V=F.indexOf(N);V>-1&&(F.splice(V,1),F.push(N))}e.pushToEnd=Q;function ne(F,N){return Array.isArray(F)?F.map(N):N(F)}e.mapArrayOrNot=ne;function oe(F){return Array.isArray(F)?F:[F]}e.asArray=oe;function X(F){return F[Math.floor(Math.random()*F.length)]}e.getRandomElement=X;function O(F,N){for(const V of F){const U=N(V);if(U!==void 0)return U}}e.mapFind=O;function H(F,N,V){const U=Y(F,N),z=F.length,ee=V.length;F.length=z+ee;for(let re=z-1;re>=U;re--)F[re+ee]=F[re];for(let re=0;re<ee;re++)F[re+U]=V[re]}e.insertInto=H;function q(F,N,V,U){const z=Y(F,N),ee=F.splice(z,V);return H(F,z,U),ee}e.splice=q;function Y(F,N){return N<0?Math.max(N+F.length,0):Math.min(N,F.length)}function $(F,N){return(V,U)=>N(F(V),F(U))}e.compareBy=$;const K=(F,N)=>F-N;e.numberComparator=K;function te(F,N){if(F.length===0)return;let V=F[0];for(let U=1;U<F.length;U++){const z=F[U];N(z,V)>0&&(V=z)}return V}e.findMaxBy=te;function B(F,N){if(F.length===0)return;let V=F[0];for(let U=1;U<F.length;U++){const z=F[U];N(z,V)>=0&&(V=z)}return V}e.findLastMaxBy=B;function L(F,N){return te(F,(V,U)=>-N(V,U))}e.findMinBy=L;class W{constructor(N){this.items=N,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(N){let V=this.firstIdx;for(;V<this.items.length&&N(this.items[V]);)V++;const U=V===this.firstIdx?null:this.items.slice(this.firstIdx,V);return this.firstIdx=V,U}takeFromEndWhile(N){let V=this.lastIdx;for(;V>=0&&N(this.items[V]);)V--;const U=V===this.lastIdx?null:this.items.slice(V+1,this.lastIdx+1);return this.lastIdx=V,U}peek(){return this.items[this.firstIdx]}dequeue(){const N=this.items[this.firstIdx];return this.firstIdx++,N}takeCount(N){const V=this.items.slice(this.firstIdx,this.firstIdx+N);return this.firstIdx+=N,V}}e.ArrayQueue=W}),define(Z[42],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function p(r){const D=this;let C=!1,P;return function(){return C||(C=!0,P=r.apply(D,arguments)),P}}e.once=p}),define(Z[69],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var p;(function(r){function D(u){return u&&typeof u=="object"&&typeof u[Symbol.iterator]=="function"}r.is=D;const C=Object.freeze([]);function P(){return C}r.empty=P;function*I(u){yield u}r.single=I;function d(u){return u||C}r.from=d;function f(u){return!u||u[Symbol.iterator]().next().done===!0}r.isEmpty=f;function y(u){return u[Symbol.iterator]().next().value}r.first=y;function b(u,s){for(const l of u)if(s(l))return!0;return!1}r.some=b;function m(u,s){for(const l of u)if(s(l))return l}r.find=m;function*S(u,s){for(const l of u)s(l)&&(yield l)}r.filter=S;function*t(u,s){let l=0;for(const n of u)yield s(n,l++)}r.map=t;function*g(...u){for(const s of u)for(const l of s)yield l}r.concat=g;function*E(u){for(const s of u)for(const l of s)yield l}r.concatNested=E;function v(u,s,l){let n=l;for(const i of u)n=s(n,i);return n}r.reduce=v;function*k(u,s,l=u.length){for(s<0&&(s+=u.length),l<0?l+=u.length:l>u.length&&(l=u.length);s<l;s++)yield u[s]}r.slice=k;function c(u,s=Number.POSITIVE_INFINITY){const l=[];if(s===0)return[l,u];const n=u[Symbol.iterator]();for(let i=0;i<s;i++){const o=n.next();if(o.done)return[l,r.empty()];l.push(o.value)}return[l,{[Symbol.iterator](){return n}}]}r.consume=c;function a(u,s,l=(n,i)=>n===i){const n=u[Symbol.iterator](),i=s[Symbol.iterator]();for(;;){const o=n.next(),h=i.next();if(o.done!==h.done)return!1;if(o.done)return!0;if(!l(o.value,h.value))return!1}}r.equals=a})(p=e.Iterable||(e.Iterable={}))}),define(Z[38],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var p;(function(s){s[s.None=0]="None",s[s.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=2]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",s[s.InvalidUnicode=4]="InvalidUnicode",s[s.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",s[s.InvalidCharacter=6]="InvalidCharacter"})(p=e.ScanError||(e.ScanError={}));var r;(function(s){s[s.OpenBraceToken=1]="OpenBraceToken",s[s.CloseBraceToken=2]="CloseBraceToken",s[s.OpenBracketToken=3]="OpenBracketToken",s[s.CloseBracketToken=4]="CloseBracketToken",s[s.CommaToken=5]="CommaToken",s[s.ColonToken=6]="ColonToken",s[s.NullKeyword=7]="NullKeyword",s[s.TrueKeyword=8]="TrueKeyword",s[s.FalseKeyword=9]="FalseKeyword",s[s.StringLiteral=10]="StringLiteral",s[s.NumericLiteral=11]="NumericLiteral",s[s.LineCommentTrivia=12]="LineCommentTrivia",s[s.BlockCommentTrivia=13]="BlockCommentTrivia",s[s.LineBreakTrivia=14]="LineBreakTrivia",s[s.Trivia=15]="Trivia",s[s.Unknown=16]="Unknown",s[s.EOF=17]="EOF"})(r=e.SyntaxKind||(e.SyntaxKind={}));var D;(function(s){s[s.InvalidSymbol=1]="InvalidSymbol",s[s.InvalidNumberFormat=2]="InvalidNumberFormat",s[s.PropertyNameExpected=3]="PropertyNameExpected",s[s.ValueExpected=4]="ValueExpected",s[s.ColonExpected=5]="ColonExpected",s[s.CommaExpected=6]="CommaExpected",s[s.CloseBraceExpected=7]="CloseBraceExpected",s[s.CloseBracketExpected=8]="CloseBracketExpected",s[s.EndOfFileExpected=9]="EndOfFileExpected",s[s.InvalidCommentToken=10]="InvalidCommentToken",s[s.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=12]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",s[s.InvalidUnicode=14]="InvalidUnicode",s[s.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",s[s.InvalidCharacter=16]="InvalidCharacter"})(D=e.ParseErrorCode||(e.ParseErrorCode={}));var C;(function(s){s.DEFAULT={allowTrailingComma:!0}})(C=e.ParseOptions||(e.ParseOptions={}));function P(s,l=!1){let n=0,i=s.length,o="",h=0,w=16,M=0;function A(X){let O=0,H=0;for(;O<X;){const q=s.charCodeAt(n);if(q>=48&&q<=57)H=H*16+q-48;else if(q>=65&&q<=70)H=H*16+q-65+10;else if(q>=97&&q<=102)H=H*16+q-97+10;else break;n++,O++}return O<X&&(H=-1),H}function R(X){n=X,o="",h=0,w=16,M=0}function T(){const X=n;if(s.charCodeAt(n)===48)n++;else for(n++;n<s.length&&f(s.charCodeAt(n));)n++;if(n<s.length&&s.charCodeAt(n)===46)if(n++,n<s.length&&f(s.charCodeAt(n)))for(n++;n<s.length&&f(s.charCodeAt(n));)n++;else return M=3,s.substring(X,n);let O=n;if(n<s.length&&(s.charCodeAt(n)===69||s.charCodeAt(n)===101))if(n++,(n<s.length&&s.charCodeAt(n)===43||s.charCodeAt(n)===45)&&n++,n<s.length&&f(s.charCodeAt(n))){for(n++;n<s.length&&f(s.charCodeAt(n));)n++;O=n}else M=3;return s.substring(X,O)}function _(){let X="",O=n;for(;;){if(n>=i){X+=s.substring(O,n),M=2;break}const H=s.charCodeAt(n);if(H===34){X+=s.substring(O,n),n++;break}if(H===92){if(X+=s.substring(O,n),n++,n>=i){M=2;break}switch(s.charCodeAt(n++)){case 34:X+='"';break;case 92:X+="\\";break;case 47:X+="/";break;case 98:X+="\b";break;case 102:X+="\f";break;case 110:X+=`
`;break;case 114:X+="\r";break;case 116:X+="	";break;case 117:const Y=A(4);Y>=0?X+=String.fromCharCode(Y):M=4;break;default:M=5}O=n;continue}if(H>=0&&H<=31)if(d(H)){X+=s.substring(O,n),M=2;break}else M=6;n++}return X}function Q(){if(o="",M=0,h=n,n>=i)return h=i,w=17;let X=s.charCodeAt(n);if(I(X)){do n++,o+=String.fromCharCode(X),X=s.charCodeAt(n);while(I(X));return w=15}if(d(X))return n++,o+=String.fromCharCode(X),X===13&&s.charCodeAt(n)===10&&(n++,o+=`
`),w=14;switch(X){case 123:return n++,w=1;case 125:return n++,w=2;case 91:return n++,w=3;case 93:return n++,w=4;case 58:return n++,w=6;case 44:return n++,w=5;case 34:return n++,o=_(),w=10;case 47:const O=n-1;if(s.charCodeAt(n+1)===47){for(n+=2;n<i&&!d(s.charCodeAt(n));)n++;return o=s.substring(O,n),w=12}if(s.charCodeAt(n+1)===42){n+=2;const H=i-1;let q=!1;for(;n<H;){if(s.charCodeAt(n)===42&&s.charCodeAt(n+1)===47){n+=2,q=!0;break}n++}return q||(n++,M=1),o=s.substring(O,n),w=13}return o+=String.fromCharCode(X),n++,w=16;case 45:if(o+=String.fromCharCode(X),n++,n===i||!f(s.charCodeAt(n)))return w=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=T(),w=11;default:for(;n<i&&ne(X);)n++,X=s.charCodeAt(n);if(h!==n){switch(o=s.substring(h,n),o){case"true":return w=8;case"false":return w=9;case"null":return w=7}return w=16}return o+=String.fromCharCode(X),n++,w=16}}function ne(X){if(I(X)||d(X))return!1;switch(X){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function oe(){let X;do X=Q();while(X>=12&&X<=15);return X}return{setPosition:R,getPosition:()=>n,scan:l?oe:Q,getToken:()=>w,getTokenValue:()=>o,getTokenOffset:()=>h,getTokenLength:()=>n-h,getTokenError:()=>M}}e.createScanner=P;function I(s){return s===32||s===9||s===11||s===12||s===160||s===5760||s>=8192&&s<=8203||s===8239||s===8287||s===12288||s===65279}function d(s){return s===10||s===13||s===8232||s===8233}function f(s){return s>=48&&s<=57}var y;(function(s){s[s.nullCharacter=0]="nullCharacter",s[s.maxAsciiCharacter=127]="maxAsciiCharacter",s[s.lineFeed=10]="lineFeed",s[s.carriageReturn=13]="carriageReturn",s[s.lineSeparator=8232]="lineSeparator",s[s.paragraphSeparator=8233]="paragraphSeparator",s[s.nextLine=133]="nextLine",s[s.space=32]="space",s[s.nonBreakingSpace=160]="nonBreakingSpace",s[s.enQuad=8192]="enQuad",s[s.emQuad=8193]="emQuad",s[s.enSpace=8194]="enSpace",s[s.emSpace=8195]="emSpace",s[s.threePerEmSpace=8196]="threePerEmSpace",s[s.fourPerEmSpace=8197]="fourPerEmSpace",s[s.sixPerEmSpace=8198]="sixPerEmSpace",s[s.figureSpace=8199]="figureSpace",s[s.punctuationSpace=8200]="punctuationSpace",s[s.thinSpace=8201]="thinSpace",s[s.hairSpace=8202]="hairSpace",s[s.zeroWidthSpace=8203]="zeroWidthSpace",s[s.narrowNoBreakSpace=8239]="narrowNoBreakSpace",s[s.ideographicSpace=12288]="ideographicSpace",s[s.mathematicalSpace=8287]="mathematicalSpace",s[s.ogham=5760]="ogham",s[s._=95]="_",s[s.$=36]="$",s[s._0=48]="_0",s[s._1=49]="_1",s[s._2=50]="_2",s[s._3=51]="_3",s[s._4=52]="_4",s[s._5=53]="_5",s[s._6=54]="_6",s[s._7=55]="_7",s[s._8=56]="_8",s[s._9=57]="_9",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.ampersand=38]="ampersand",s[s.asterisk=42]="asterisk",s[s.at=64]="at",s[s.backslash=92]="backslash",s[s.bar=124]="bar",s[s.caret=94]="caret",s[s.closeBrace=125]="closeBrace",s[s.closeBracket=93]="closeBracket",s[s.closeParen=41]="closeParen",s[s.colon=58]="colon",s[s.comma=44]="comma",s[s.dot=46]="dot",s[s.doubleQuote=34]="doubleQuote",s[s.equals=61]="equals",s[s.exclamation=33]="exclamation",s[s.greaterThan=62]="greaterThan",s[s.lessThan=60]="lessThan",s[s.minus=45]="minus",s[s.openBrace=123]="openBrace",s[s.openBracket=91]="openBracket",s[s.openParen=40]="openParen",s[s.percent=37]="percent",s[s.plus=43]="plus",s[s.question=63]="question",s[s.semicolon=59]="semicolon",s[s.singleQuote=39]="singleQuote",s[s.slash=47]="slash",s[s.tilde=126]="tilde",s[s.backspace=8]="backspace",s[s.formFeed=12]="formFeed",s[s.byteOrderMark=65279]="byteOrderMark",s[s.tab=9]="tab",s[s.verticalTab=11]="verticalTab"})(y||(y={}));function b(s,l){const n=[],i=new Object;let o;const h={value:{},offset:0,length:0,type:"object",parent:void 0};let w=!1;function M(A,R,T,_){h.value=A,h.offset=R,h.length=T,h.type=_,h.colonOffset=void 0,o=h}try{c(s,{onObjectBegin:(A,R)=>{if(l<=A)throw i;o=void 0,w=l>A,n.push("")},onObjectProperty:(A,R,T)=>{if(l<R||(M(A,R,T,"property"),n[n.length-1]=A,l<=R+T))throw i},onObjectEnd:(A,R)=>{if(l<=A)throw i;o=void 0,n.pop()},onArrayBegin:(A,R)=>{if(l<=A)throw i;o=void 0,n.push(0)},onArrayEnd:(A,R)=>{if(l<=A)throw i;o=void 0,n.pop()},onLiteralValue:(A,R,T)=>{if(l<R||(M(A,R,T,u(A)),l<=R+T))throw i},onSeparator:(A,R,T)=>{if(l<=R)throw i;if(A===":"&&o&&o.type==="property")o.colonOffset=R,w=!1,o=void 0;else if(A===","){const _=n[n.length-1];typeof _=="number"?n[n.length-1]=_+1:(w=!0,n[n.length-1]=""),o=void 0}}})}catch(A){if(A!==i)throw A}return{path:n,previousNode:o,isAtPropertyKey:w,matches:A=>{let R=0;for(let T=0;R<A.length&&T<n.length;T++)if(A[R]===n[T]||A[R]==="*")R++;else if(A[R]!=="**")return!1;return R===A.length}}}e.getLocation=b;function m(s,l=[],n=C.DEFAULT){let i=null,o=[];const h=[];function w(A){Array.isArray(o)?o.push(A):i!==null&&(o[i]=A)}return c(s,{onObjectBegin:()=>{const A={};w(A),h.push(o),o=A,i=null},onObjectProperty:A=>{i=A},onObjectEnd:()=>{o=h.pop()},onArrayBegin:()=>{const A=[];w(A),h.push(o),o=A,i=null},onArrayEnd:()=>{o=h.pop()},onLiteralValue:w,onError:(A,R,T)=>{l.push({error:A,offset:R,length:T})}},n),o[0]}e.parse=m;function S(s,l=[],n=C.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(A){i.type==="property"&&(i.length=A-i.offset,i=i.parent)}function h(A){return i.children.push(A),A}c(s,{onObjectBegin:A=>{i=h({type:"object",offset:A,length:-1,parent:i,children:[]})},onObjectProperty:(A,R,T)=>{i=h({type:"property",offset:R,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:A,offset:R,length:T,parent:i})},onObjectEnd:(A,R)=>{i.length=A+R-i.offset,i=i.parent,o(A+R)},onArrayBegin:(A,R)=>{i=h({type:"array",offset:A,length:-1,parent:i,children:[]})},onArrayEnd:(A,R)=>{i.length=A+R-i.offset,i=i.parent,o(A+R)},onLiteralValue:(A,R,T)=>{h({type:u(A),offset:R,length:T,parent:i,value:A}),o(R+T)},onSeparator:(A,R,T)=>{i.type==="property"&&(A===":"?i.colonOffset=R:A===","&&o(R))},onError:(A,R,T)=>{l.push({error:A,offset:R,length:T})}},n);const M=i.children[0];return M&&delete M.parent,M}e.parseTree=S;function t(s,l){if(!s)return;let n=s;for(let i of l)if(typeof i=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let o=!1;for(const h of n.children)if(Array.isArray(h.children)&&h.children[0].value===i){n=h.children[1],o=!0;break}if(!o)return}else{const o=i;if(n.type!=="array"||o<0||!Array.isArray(n.children)||o>=n.children.length)return;n=n.children[o]}return n}e.findNodeAtLocation=t;function g(s){if(!s.parent||!s.parent.children)return[];const l=g(s.parent);if(s.parent.type==="property"){const n=s.parent.children[0].value;l.push(n)}else if(s.parent.type==="array"){const n=s.parent.children.indexOf(s);n!==-1&&l.push(n)}return l}e.getNodePath=g;function E(s){switch(s.type){case"array":return s.children.map(E);case"object":const l=Object.create(null);for(let n of s.children){const i=n.children[1];i&&(l[n.children[0].value]=E(i))}return l;case"null":case"string":case"number":case"boolean":return s.value;default:return}}e.getNodeValue=E;function v(s,l,n=!1){return l>=s.offset&&l<s.offset+s.length||n&&l===s.offset+s.length}e.contains=v;function k(s,l,n=!1){if(v(s,l,n)){const i=s.children;if(Array.isArray(i))for(let o=0;o<i.length&&i[o].offset<=l;o++){const h=k(i[o],l,n);if(h)return h}return s}}e.findNodeAtOffset=k;function c(s,l,n=C.DEFAULT){const i=P(s,!1);function o(W){return W?()=>W(i.getTokenOffset(),i.getTokenLength()):()=>!0}function h(W){return W?F=>W(F,i.getTokenOffset(),i.getTokenLength()):()=>!0}const w=o(l.onObjectBegin),M=h(l.onObjectProperty),A=o(l.onObjectEnd),R=o(l.onArrayBegin),T=o(l.onArrayEnd),_=h(l.onLiteralValue),Q=h(l.onSeparator),ne=o(l.onComment),oe=h(l.onError),X=n&&n.disallowComments,O=n&&n.allowTrailingComma;function H(){for(;;){const W=i.scan();switch(i.getTokenError()){case 4:q(14);break;case 5:q(15);break;case 3:q(13);break;case 1:X||q(11);break;case 2:q(12);break;case 6:q(16);break}switch(W){case 12:case 13:X?q(10):ne();break;case 16:q(1);break;case 15:case 14:break;default:return W}}}function q(W,F=[],N=[]){if(oe(W),F.length+N.length>0){let V=i.getToken();for(;V!==17;){if(F.indexOf(V)!==-1){H();break}else if(N.indexOf(V)!==-1)break;V=H()}}}function Y(W){const F=i.getTokenValue();return W?_(F):M(F),H(),!0}function $(){switch(i.getToken()){case 11:let W=0;try{W=JSON.parse(i.getTokenValue()),typeof W!="number"&&(q(2),W=0)}catch{q(2)}_(W);break;case 7:_(null);break;case 8:_(!0);break;case 9:_(!1);break;default:return!1}return H(),!0}function K(){return i.getToken()!==10?(q(3,[],[2,5]),!1):(Y(!1),i.getToken()===6?(Q(":"),H(),L()||q(4,[],[2,5])):q(5,[],[2,5]),!0)}function te(){w(),H();let W=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(W||q(4,[],[]),Q(","),H(),i.getToken()===2&&O)break}else W&&q(6,[],[]);K()||q(4,[],[2,5]),W=!0}return A(),i.getToken()!==2?q(7,[2],[]):H(),!0}function B(){R(),H();let W=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(W||q(4,[],[]),Q(","),H(),i.getToken()===4&&O)break}else W&&q(6,[],[]);L()||q(4,[],[4,5]),W=!0}return T(),i.getToken()!==4?q(8,[4],[]):H(),!0}function L(){switch(i.getToken()){case 3:return B();case 1:return te();case 10:return Y(!0);default:return $()}}return H(),i.getToken()===17?n.allowEmptyContent?!0:(q(4,[],[]),!1):L()?(i.getToken()!==17&&q(9,[],[]),!0):(q(4,[],[]),!1)}e.visit=c;function a(s,l){let n=P(s),i=[],o,h=0,w;do switch(w=n.getPosition(),o=n.scan(),o){case 12:case 13:case 17:h!==w&&i.push(s.substring(h,w)),l!==void 0&&i.push(n.getTokenValue().replace(/[^\r\n]/g,l)),h=n.getPosition();break}while(o!==17);return i.join("")}e.stripComments=a;function u(s){switch(typeof s){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(s){if(Array.isArray(s))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=u}),define(Z[105],x([0,1,38]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function r(f,y,b){let m,S,t,g,E;if(y){for(g=y.offset,E=g+y.length,t=g;t>0&&!d(f,t-1);)t--;let w=E;for(;w<f.length&&!d(f,w);)w++;S=f.substring(t,w),m=P(S,b)}else S=f,m=0,t=0,g=0,E=f.length;const v=I(b,f);let k=!1,c=0,a;b.insertSpaces?a=C(" ",b.tabSize||4):a="	";const u=(0,p.createScanner)(S,!1);let s=!1;function l(){return v+C(a,m+c)}function n(){let w=u.scan();for(k=!1;w===15||w===14;)k=k||w===14,w=u.scan();return s=w===16||u.getTokenError()!==0,w}const i=[];function o(w,M,A){!s&&M<E&&A>g&&f.substring(M,A)!==w&&i.push({offset:M,length:A-M,content:w})}let h=n();if(h!==17){const w=u.getTokenOffset()+t,M=C(a,m);o(M,t,w)}for(;h!==17;){let w=u.getTokenOffset()+u.getTokenLength()+t,M=n(),A="";for(;!k&&(M===12||M===13);){const T=u.getTokenOffset()+t;o(" ",w,T),w=u.getTokenOffset()+u.getTokenLength()+t,A=M===12?l():"",M=n()}if(M===2)h!==1&&(c--,A=l());else if(M===4)h!==3&&(c--,A=l());else{switch(h){case 3:case 1:c++,A=l();break;case 5:case 12:A=l();break;case 13:k?A=l():A=" ";break;case 6:A=" ";break;case 10:if(M===6){A="";break}case 7:case 8:case 9:case 11:case 2:case 4:M===12||M===13?A=" ":M!==5&&M!==17&&(s=!0);break;case 16:s=!0;break}k&&(M===12||M===13)&&(A=l())}const R=u.getTokenOffset()+t;o(A,w,R),h=M}return i}e.format=r;function D(f,y){const b=JSON.stringify(f,void 0,y.insertSpaces?y.tabSize||4:"	");return y.eol!==void 0?b.replace(/\r\n|\r|\n/g,y.eol):b}e.toFormattedString=D;function C(f,y){let b="";for(let m=0;m<y;m++)b+=f;return b}function P(f,y){let b=0,m=0;const S=y.tabSize||4;for(;b<f.length;){const t=f.charAt(b);if(t===" ")m++;else if(t==="	")m+=S;else break;b++}return Math.floor(m/S)}function I(f,y){for(let b=0;b<y.length;b++){const m=y.charAt(b);if(m==="\r")return b+1<y.length&&y.charAt(b+1)===`
`?`\r
`:"\r";if(m===`
`)return`
`}return f&&f.eol||`
`}e.getEOL=I;function d(f,y){return`\r
`.indexOf(f.charAt(y))!==-1}e.isEOL=d}),define(Z[78],x([0,1,38,105]),function(j,e,p,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function D(f,y,b){return C(f,y,void 0,b)}e.removeProperty=D;function C(f,y,b,m,S){const t=y.slice(),g=[],E=(0,p.parseTree)(f,g);let v,k;for(;t.length>0&&(k=t.pop(),v=(0,p.findNodeAtLocation)(E,t),v===void 0&&b!==void 0);)typeof k=="string"?b={[k]:b}:b=[b];if(v)if(v.type==="object"&&typeof k=="string"&&Array.isArray(v.children)){const c=(0,p.findNodeAtLocation)(v,[k]);if(c!==void 0)if(b===void 0){if(!c.parent)throw new Error("Malformed AST");const a=v.children.indexOf(c.parent);let u,s=c.parent.offset+c.parent.length;if(a>0){const l=v.children[a-1];u=l.offset+l.length}else u=v.offset+1,v.children.length>1&&(s=v.children[1].offset);return P(f,{offset:u,length:s-u,content:""},m)}else return P(f,{offset:c.offset,length:c.length,content:JSON.stringify(b)},m);else{if(b===void 0)return[];const a=`${JSON.stringify(k)}: ${JSON.stringify(b)}`,u=S?S(v.children.map(l=>l.children[0].value)):v.children.length;let s;if(u>0){const l=v.children[u-1];s={offset:l.offset+l.length,length:0,content:","+a}}else v.children.length===0?s={offset:v.offset+1,length:0,content:a}:s={offset:v.offset+1,length:0,content:a+","};return P(f,s,m)}}else if(v.type==="array"&&typeof k=="number"&&Array.isArray(v.children))if(b!==void 0){const c=`${JSON.stringify(b)}`;let a;if(v.children.length===0||k===0)a={offset:v.offset+1,length:0,content:v.children.length===0?c:c+","};else{const u=k===-1||k>v.children.length?v.children.length:k,s=v.children[u-1];a={offset:s.offset+s.length,length:0,content:","+c}}return P(f,a,m)}else{const c=k,a=v.children[c];let u;if(v.children.length===1)u={offset:v.offset+1,length:v.length-2,content:""};else if(v.children.length-1===c){const s=v.children[c-1],l=s.offset+s.length,n=v.offset+v.length;u={offset:l,length:n-2-l,content:""}}else u={offset:a.offset,length:v.children[c+1].offset-a.offset,content:""};return P(f,u,m)}else throw new Error(`Can not add ${typeof k!="number"?"index":"property"} to parent of type ${v.type}`);else{if(b===void 0)throw new Error("Can not delete in empty document");return P(f,{offset:E?E.offset:0,length:E?E.length:0,content:JSON.stringify(b)},m)}}e.setProperty=C;function P(f,y,b){let m=I(f,y),S=y.offset,t=y.offset+y.content.length;if(y.length===0||y.content.length===0){for(;S>0&&!(0,r.isEOL)(m,S-1);)S--;for(;t<m.length&&!(0,r.isEOL)(m,t);)t++}const g=(0,r.format)(m,{offset:S,length:t-S},b);for(let v=g.length-1;v>=0;v--){const k=g[v];m=I(m,k),S=Math.min(S,k.offset),t=Math.max(t,k.offset+k.length),t+=k.content.length-k.length}const E=f.length-(m.length-t)-S;return[{offset:S,length:E,content:m.substring(S,t)}]}e.withFormatting=P;function I(f,y){return f.substring(0,y.offset)+y.content+f.substring(y.offset+y.length)}e.applyEdit=I;function d(f,y){let b=y.slice(0).sort((S,t)=>{const g=S.offset-t.offset;return g===0?S.length-t.length:g}),m=f.length;for(let S=b.length-1;S>=0;S--){let t=b[S];if(t.offset+t.length<=m)f=I(f,t);else throw new Error("Overlapping edit");m=t.offset}return f}e.applyEdits=d}),define(Z[79],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyChord=e.KeyMod=e.KeyCodeUtils=e.IMMUTABLE_KEY_CODE_TO_CODE=e.IMMUTABLE_CODE_TO_KEY_CODE=e.ScanCodeUtils=e.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=e.EVENT_KEY_CODE_MAP=e.ScanCode=e.KeyCode=void 0;var p;(function(t){t[t.DependsOnKbLayout=-1]="DependsOnKbLayout",t[t.Unknown=0]="Unknown",t[t.Backspace=1]="Backspace",t[t.Tab=2]="Tab",t[t.Enter=3]="Enter",t[t.Shift=4]="Shift",t[t.Ctrl=5]="Ctrl",t[t.Alt=6]="Alt",t[t.PauseBreak=7]="PauseBreak",t[t.CapsLock=8]="CapsLock",t[t.Escape=9]="Escape",t[t.Space=10]="Space",t[t.PageUp=11]="PageUp",t[t.PageDown=12]="PageDown",t[t.End=13]="End",t[t.Home=14]="Home",t[t.LeftArrow=15]="LeftArrow",t[t.UpArrow=16]="UpArrow",t[t.RightArrow=17]="RightArrow",t[t.DownArrow=18]="DownArrow",t[t.Insert=19]="Insert",t[t.Delete=20]="Delete",t[t.Digit0=21]="Digit0",t[t.Digit1=22]="Digit1",t[t.Digit2=23]="Digit2",t[t.Digit3=24]="Digit3",t[t.Digit4=25]="Digit4",t[t.Digit5=26]="Digit5",t[t.Digit6=27]="Digit6",t[t.Digit7=28]="Digit7",t[t.Digit8=29]="Digit8",t[t.Digit9=30]="Digit9",t[t.KeyA=31]="KeyA",t[t.KeyB=32]="KeyB",t[t.KeyC=33]="KeyC",t[t.KeyD=34]="KeyD",t[t.KeyE=35]="KeyE",t[t.KeyF=36]="KeyF",t[t.KeyG=37]="KeyG",t[t.KeyH=38]="KeyH",t[t.KeyI=39]="KeyI",t[t.KeyJ=40]="KeyJ",t[t.KeyK=41]="KeyK",t[t.KeyL=42]="KeyL",t[t.KeyM=43]="KeyM",t[t.KeyN=44]="KeyN",t[t.KeyO=45]="KeyO",t[t.KeyP=46]="KeyP",t[t.KeyQ=47]="KeyQ",t[t.KeyR=48]="KeyR",t[t.KeyS=49]="KeyS",t[t.KeyT=50]="KeyT",t[t.KeyU=51]="KeyU",t[t.KeyV=52]="KeyV",t[t.KeyW=53]="KeyW",t[t.KeyX=54]="KeyX",t[t.KeyY=55]="KeyY",t[t.KeyZ=56]="KeyZ",t[t.Meta=57]="Meta",t[t.ContextMenu=58]="ContextMenu",t[t.F1=59]="F1",t[t.F2=60]="F2",t[t.F3=61]="F3",t[t.F4=62]="F4",t[t.F5=63]="F5",t[t.F6=64]="F6",t[t.F7=65]="F7",t[t.F8=66]="F8",t[t.F9=67]="F9",t[t.F10=68]="F10",t[t.F11=69]="F11",t[t.F12=70]="F12",t[t.F13=71]="F13",t[t.F14=72]="F14",t[t.F15=73]="F15",t[t.F16=74]="F16",t[t.F17=75]="F17",t[t.F18=76]="F18",t[t.F19=77]="F19",t[t.NumLock=78]="NumLock",t[t.ScrollLock=79]="ScrollLock",t[t.Semicolon=80]="Semicolon",t[t.Equal=81]="Equal",t[t.Comma=82]="Comma",t[t.Minus=83]="Minus",t[t.Period=84]="Period",t[t.Slash=85]="Slash",t[t.Backquote=86]="Backquote",t[t.BracketLeft=87]="BracketLeft",t[t.Backslash=88]="Backslash",t[t.BracketRight=89]="BracketRight",t[t.Quote=90]="Quote",t[t.OEM_8=91]="OEM_8",t[t.IntlBackslash=92]="IntlBackslash",t[t.Numpad0=93]="Numpad0",t[t.Numpad1=94]="Numpad1",t[t.Numpad2=95]="Numpad2",t[t.Numpad3=96]="Numpad3",t[t.Numpad4=97]="Numpad4",t[t.Numpad5=98]="Numpad5",t[t.Numpad6=99]="Numpad6",t[t.Numpad7=100]="Numpad7",t[t.Numpad8=101]="Numpad8",t[t.Numpad9=102]="Numpad9",t[t.NumpadMultiply=103]="NumpadMultiply",t[t.NumpadAdd=104]="NumpadAdd",t[t.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",t[t.NumpadSubtract=106]="NumpadSubtract",t[t.NumpadDecimal=107]="NumpadDecimal",t[t.NumpadDivide=108]="NumpadDivide",t[t.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",t[t.ABNT_C1=110]="ABNT_C1",t[t.ABNT_C2=111]="ABNT_C2",t[t.AudioVolumeMute=112]="AudioVolumeMute",t[t.AudioVolumeUp=113]="AudioVolumeUp",t[t.AudioVolumeDown=114]="AudioVolumeDown",t[t.BrowserSearch=115]="BrowserSearch",t[t.BrowserHome=116]="BrowserHome",t[t.BrowserBack=117]="BrowserBack",t[t.BrowserForward=118]="BrowserForward",t[t.MediaTrackNext=119]="MediaTrackNext",t[t.MediaTrackPrevious=120]="MediaTrackPrevious",t[t.MediaStop=121]="MediaStop",t[t.MediaPlayPause=122]="MediaPlayPause",t[t.LaunchMediaPlayer=123]="LaunchMediaPlayer",t[t.LaunchMail=124]="LaunchMail",t[t.LaunchApp2=125]="LaunchApp2",t[t.MAX_VALUE=126]="MAX_VALUE"})(p=e.KeyCode||(e.KeyCode={}));var r;(function(t){t[t.DependsOnKbLayout=-1]="DependsOnKbLayout",t[t.None=0]="None",t[t.Hyper=1]="Hyper",t[t.Super=2]="Super",t[t.Fn=3]="Fn",t[t.FnLock=4]="FnLock",t[t.Suspend=5]="Suspend",t[t.Resume=6]="Resume",t[t.Turbo=7]="Turbo",t[t.Sleep=8]="Sleep",t[t.WakeUp=9]="WakeUp",t[t.KeyA=10]="KeyA",t[t.KeyB=11]="KeyB",t[t.KeyC=12]="KeyC",t[t.KeyD=13]="KeyD",t[t.KeyE=14]="KeyE",t[t.KeyF=15]="KeyF",t[t.KeyG=16]="KeyG",t[t.KeyH=17]="KeyH",t[t.KeyI=18]="KeyI",t[t.KeyJ=19]="KeyJ",t[t.KeyK=20]="KeyK",t[t.KeyL=21]="KeyL",t[t.KeyM=22]="KeyM",t[t.KeyN=23]="KeyN",t[t.KeyO=24]="KeyO",t[t.KeyP=25]="KeyP",t[t.KeyQ=26]="KeyQ",t[t.KeyR=27]="KeyR",t[t.KeyS=28]="KeyS",t[t.KeyT=29]="KeyT",t[t.KeyU=30]="KeyU",t[t.KeyV=31]="KeyV",t[t.KeyW=32]="KeyW",t[t.KeyX=33]="KeyX",t[t.KeyY=34]="KeyY",t[t.KeyZ=35]="KeyZ",t[t.Digit1=36]="Digit1",t[t.Digit2=37]="Digit2",t[t.Digit3=38]="Digit3",t[t.Digit4=39]="Digit4",t[t.Digit5=40]="Digit5",t[t.Digit6=41]="Digit6",t[t.Digit7=42]="Digit7",t[t.Digit8=43]="Digit8",t[t.Digit9=44]="Digit9",t[t.Digit0=45]="Digit0",t[t.Enter=46]="Enter",t[t.Escape=47]="Escape",t[t.Backspace=48]="Backspace",t[t.Tab=49]="Tab",t[t.Space=50]="Space",t[t.Minus=51]="Minus",t[t.Equal=52]="Equal",t[t.BracketLeft=53]="BracketLeft",t[t.BracketRight=54]="BracketRight",t[t.Backslash=55]="Backslash",t[t.IntlHash=56]="IntlHash",t[t.Semicolon=57]="Semicolon",t[t.Quote=58]="Quote",t[t.Backquote=59]="Backquote",t[t.Comma=60]="Comma",t[t.Period=61]="Period",t[t.Slash=62]="Slash",t[t.CapsLock=63]="CapsLock",t[t.F1=64]="F1",t[t.F2=65]="F2",t[t.F3=66]="F3",t[t.F4=67]="F4",t[t.F5=68]="F5",t[t.F6=69]="F6",t[t.F7=70]="F7",t[t.F8=71]="F8",t[t.F9=72]="F9",t[t.F10=73]="F10",t[t.F11=74]="F11",t[t.F12=75]="F12",t[t.PrintScreen=76]="PrintScreen",t[t.ScrollLock=77]="ScrollLock",t[t.Pause=78]="Pause",t[t.Insert=79]="Insert",t[t.Home=80]="Home",t[t.PageUp=81]="PageUp",t[t.Delete=82]="Delete",t[t.End=83]="End",t[t.PageDown=84]="PageDown",t[t.ArrowRight=85]="ArrowRight",t[t.ArrowLeft=86]="ArrowLeft",t[t.ArrowDown=87]="ArrowDown",t[t.ArrowUp=88]="ArrowUp",t[t.NumLock=89]="NumLock",t[t.NumpadDivide=90]="NumpadDivide",t[t.NumpadMultiply=91]="NumpadMultiply",t[t.NumpadSubtract=92]="NumpadSubtract",t[t.NumpadAdd=93]="NumpadAdd",t[t.NumpadEnter=94]="NumpadEnter",t[t.Numpad1=95]="Numpad1",t[t.Numpad2=96]="Numpad2",t[t.Numpad3=97]="Numpad3",t[t.Numpad4=98]="Numpad4",t[t.Numpad5=99]="Numpad5",t[t.Numpad6=100]="Numpad6",t[t.Numpad7=101]="Numpad7",t[t.Numpad8=102]="Numpad8",t[t.Numpad9=103]="Numpad9",t[t.Numpad0=104]="Numpad0",t[t.NumpadDecimal=105]="NumpadDecimal",t[t.IntlBackslash=106]="IntlBackslash",t[t.ContextMenu=107]="ContextMenu",t[t.Power=108]="Power",t[t.NumpadEqual=109]="NumpadEqual",t[t.F13=110]="F13",t[t.F14=111]="F14",t[t.F15=112]="F15",t[t.F16=113]="F16",t[t.F17=114]="F17",t[t.F18=115]="F18",t[t.F19=116]="F19",t[t.F20=117]="F20",t[t.F21=118]="F21",t[t.F22=119]="F22",t[t.F23=120]="F23",t[t.F24=121]="F24",t[t.Open=122]="Open",t[t.Help=123]="Help",t[t.Select=124]="Select",t[t.Again=125]="Again",t[t.Undo=126]="Undo",t[t.Cut=127]="Cut",t[t.Copy=128]="Copy",t[t.Paste=129]="Paste",t[t.Find=130]="Find",t[t.AudioVolumeMute=131]="AudioVolumeMute",t[t.AudioVolumeUp=132]="AudioVolumeUp",t[t.AudioVolumeDown=133]="AudioVolumeDown",t[t.NumpadComma=134]="NumpadComma",t[t.IntlRo=135]="IntlRo",t[t.KanaMode=136]="KanaMode",t[t.IntlYen=137]="IntlYen",t[t.Convert=138]="Convert",t[t.NonConvert=139]="NonConvert",t[t.Lang1=140]="Lang1",t[t.Lang2=141]="Lang2",t[t.Lang3=142]="Lang3",t[t.Lang4=143]="Lang4",t[t.Lang5=144]="Lang5",t[t.Abort=145]="Abort",t[t.Props=146]="Props",t[t.NumpadParenLeft=147]="NumpadParenLeft",t[t.NumpadParenRight=148]="NumpadParenRight",t[t.NumpadBackspace=149]="NumpadBackspace",t[t.NumpadMemoryStore=150]="NumpadMemoryStore",t[t.NumpadMemoryRecall=151]="NumpadMemoryRecall",t[t.NumpadMemoryClear=152]="NumpadMemoryClear",t[t.NumpadMemoryAdd=153]="NumpadMemoryAdd",t[t.NumpadMemorySubtract=154]="NumpadMemorySubtract",t[t.NumpadClear=155]="NumpadClear",t[t.NumpadClearEntry=156]="NumpadClearEntry",t[t.ControlLeft=157]="ControlLeft",t[t.ShiftLeft=158]="ShiftLeft",t[t.AltLeft=159]="AltLeft",t[t.MetaLeft=160]="MetaLeft",t[t.ControlRight=161]="ControlRight",t[t.ShiftRight=162]="ShiftRight",t[t.AltRight=163]="AltRight",t[t.MetaRight=164]="MetaRight",t[t.BrightnessUp=165]="BrightnessUp",t[t.BrightnessDown=166]="BrightnessDown",t[t.MediaPlay=167]="MediaPlay",t[t.MediaRecord=168]="MediaRecord",t[t.MediaFastForward=169]="MediaFastForward",t[t.MediaRewind=170]="MediaRewind",t[t.MediaTrackNext=171]="MediaTrackNext",t[t.MediaTrackPrevious=172]="MediaTrackPrevious",t[t.MediaStop=173]="MediaStop",t[t.Eject=174]="Eject",t[t.MediaPlayPause=175]="MediaPlayPause",t[t.MediaSelect=176]="MediaSelect",t[t.LaunchMail=177]="LaunchMail",t[t.LaunchApp2=178]="LaunchApp2",t[t.LaunchApp1=179]="LaunchApp1",t[t.SelectTask=180]="SelectTask",t[t.LaunchScreenSaver=181]="LaunchScreenSaver",t[t.BrowserSearch=182]="BrowserSearch",t[t.BrowserHome=183]="BrowserHome",t[t.BrowserBack=184]="BrowserBack",t[t.BrowserForward=185]="BrowserForward",t[t.BrowserStop=186]="BrowserStop",t[t.BrowserRefresh=187]="BrowserRefresh",t[t.BrowserFavorites=188]="BrowserFavorites",t[t.ZoomToggle=189]="ZoomToggle",t[t.MailReply=190]="MailReply",t[t.MailForward=191]="MailForward",t[t.MailSend=192]="MailSend",t[t.MAX_VALUE=193]="MAX_VALUE"})(r=e.ScanCode||(e.ScanCode={}));class D{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(g,E){this._keyCodeToStr[g]=E,this._strToKeyCode[E.toLowerCase()]=g}keyCodeToStr(g){return this._keyCodeToStr[g]}strToKeyCode(g){return this._strToKeyCode[g.toLowerCase()]||0}}const C=new D,P=new D,I=new D;e.EVENT_KEY_CODE_MAP=new Array(230),e.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const d=[],f=Object.create(null),y=Object.create(null);e.ScanCodeUtils={lowerCaseToEnum:t=>y[t]||0,toEnum:t=>f[t]||0,toString:t=>d[t]||"None"},e.IMMUTABLE_CODE_TO_KEY_CODE=[],e.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let t=0;t<=193;t++)e.IMMUTABLE_CODE_TO_KEY_CODE[t]=-1;for(let t=0;t<=126;t++)e.IMMUTABLE_KEY_CODE_TO_CODE[t]=-1;(function(){const t="",g=[[0,1,0,"None",0,"unknown",0,"VK_UNKNOWN",t,t],[0,1,1,"Hyper",0,t,0,t,t,t],[0,1,2,"Super",0,t,0,t,t,t],[0,1,3,"Fn",0,t,0,t,t,t],[0,1,4,"FnLock",0,t,0,t,t,t],[0,1,5,"Suspend",0,t,0,t,t,t],[0,1,6,"Resume",0,t,0,t,t,t],[0,1,7,"Turbo",0,t,0,t,t,t],[0,1,8,"Sleep",0,t,0,"VK_SLEEP",t,t],[0,1,9,"WakeUp",0,t,0,t,t,t],[31,0,10,"KeyA",31,"A",65,"VK_A",t,t],[32,0,11,"KeyB",32,"B",66,"VK_B",t,t],[33,0,12,"KeyC",33,"C",67,"VK_C",t,t],[34,0,13,"KeyD",34,"D",68,"VK_D",t,t],[35,0,14,"KeyE",35,"E",69,"VK_E",t,t],[36,0,15,"KeyF",36,"F",70,"VK_F",t,t],[37,0,16,"KeyG",37,"G",71,"VK_G",t,t],[38,0,17,"KeyH",38,"H",72,"VK_H",t,t],[39,0,18,"KeyI",39,"I",73,"VK_I",t,t],[40,0,19,"KeyJ",40,"J",74,"VK_J",t,t],[41,0,20,"KeyK",41,"K",75,"VK_K",t,t],[42,0,21,"KeyL",42,"L",76,"VK_L",t,t],[43,0,22,"KeyM",43,"M",77,"VK_M",t,t],[44,0,23,"KeyN",44,"N",78,"VK_N",t,t],[45,0,24,"KeyO",45,"O",79,"VK_O",t,t],[46,0,25,"KeyP",46,"P",80,"VK_P",t,t],[47,0,26,"KeyQ",47,"Q",81,"VK_Q",t,t],[48,0,27,"KeyR",48,"R",82,"VK_R",t,t],[49,0,28,"KeyS",49,"S",83,"VK_S",t,t],[50,0,29,"KeyT",50,"T",84,"VK_T",t,t],[51,0,30,"KeyU",51,"U",85,"VK_U",t,t],[52,0,31,"KeyV",52,"V",86,"VK_V",t,t],[53,0,32,"KeyW",53,"W",87,"VK_W",t,t],[54,0,33,"KeyX",54,"X",88,"VK_X",t,t],[55,0,34,"KeyY",55,"Y",89,"VK_Y",t,t],[56,0,35,"KeyZ",56,"Z",90,"VK_Z",t,t],[22,0,36,"Digit1",22,"1",49,"VK_1",t,t],[23,0,37,"Digit2",23,"2",50,"VK_2",t,t],[24,0,38,"Digit3",24,"3",51,"VK_3",t,t],[25,0,39,"Digit4",25,"4",52,"VK_4",t,t],[26,0,40,"Digit5",26,"5",53,"VK_5",t,t],[27,0,41,"Digit6",27,"6",54,"VK_6",t,t],[28,0,42,"Digit7",28,"7",55,"VK_7",t,t],[29,0,43,"Digit8",29,"8",56,"VK_8",t,t],[30,0,44,"Digit9",30,"9",57,"VK_9",t,t],[21,0,45,"Digit0",21,"0",48,"VK_0",t,t],[3,1,46,"Enter",3,"Enter",13,"VK_RETURN",t,t],[9,1,47,"Escape",9,"Escape",27,"VK_ESCAPE",t,t],[1,1,48,"Backspace",1,"Backspace",8,"VK_BACK",t,t],[2,1,49,"Tab",2,"Tab",9,"VK_TAB",t,t],[10,1,50,"Space",10,"Space",32,"VK_SPACE",t,t],[83,0,51,"Minus",83,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[81,0,52,"Equal",81,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[87,0,53,"BracketLeft",87,"[",219,"VK_OEM_4","[","OEM_4"],[89,0,54,"BracketRight",89,"]",221,"VK_OEM_6","]","OEM_6"],[88,0,55,"Backslash",88,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,0,56,"IntlHash",0,t,0,t,t,t],[80,0,57,"Semicolon",80,";",186,"VK_OEM_1",";","OEM_1"],[90,0,58,"Quote",90,"'",222,"VK_OEM_7","'","OEM_7"],[86,0,59,"Backquote",86,"`",192,"VK_OEM_3","`","OEM_3"],[82,0,60,"Comma",82,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[84,0,61,"Period",84,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[85,0,62,"Slash",85,"/",191,"VK_OEM_2","/","OEM_2"],[8,1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",t,t],[59,1,64,"F1",59,"F1",112,"VK_F1",t,t],[60,1,65,"F2",60,"F2",113,"VK_F2",t,t],[61,1,66,"F3",61,"F3",114,"VK_F3",t,t],[62,1,67,"F4",62,"F4",115,"VK_F4",t,t],[63,1,68,"F5",63,"F5",116,"VK_F5",t,t],[64,1,69,"F6",64,"F6",117,"VK_F6",t,t],[65,1,70,"F7",65,"F7",118,"VK_F7",t,t],[66,1,71,"F8",66,"F8",119,"VK_F8",t,t],[67,1,72,"F9",67,"F9",120,"VK_F9",t,t],[68,1,73,"F10",68,"F10",121,"VK_F10",t,t],[69,1,74,"F11",69,"F11",122,"VK_F11",t,t],[70,1,75,"F12",70,"F12",123,"VK_F12",t,t],[0,1,76,"PrintScreen",0,t,0,t,t,t],[79,1,77,"ScrollLock",79,"ScrollLock",145,"VK_SCROLL",t,t],[7,1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",t,t],[19,1,79,"Insert",19,"Insert",45,"VK_INSERT",t,t],[14,1,80,"Home",14,"Home",36,"VK_HOME",t,t],[11,1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",t,t],[20,1,82,"Delete",20,"Delete",46,"VK_DELETE",t,t],[13,1,83,"End",13,"End",35,"VK_END",t,t],[12,1,84,"PageDown",12,"PageDown",34,"VK_NEXT",t,t],[17,1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",t],[15,1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",t],[18,1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",t],[16,1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",t],[78,1,89,"NumLock",78,"NumLock",144,"VK_NUMLOCK",t,t],[108,1,90,"NumpadDivide",108,"NumPad_Divide",111,"VK_DIVIDE",t,t],[103,1,91,"NumpadMultiply",103,"NumPad_Multiply",106,"VK_MULTIPLY",t,t],[106,1,92,"NumpadSubtract",106,"NumPad_Subtract",109,"VK_SUBTRACT",t,t],[104,1,93,"NumpadAdd",104,"NumPad_Add",107,"VK_ADD",t,t],[3,1,94,"NumpadEnter",3,t,0,t,t,t],[94,1,95,"Numpad1",94,"NumPad1",97,"VK_NUMPAD1",t,t],[95,1,96,"Numpad2",95,"NumPad2",98,"VK_NUMPAD2",t,t],[96,1,97,"Numpad3",96,"NumPad3",99,"VK_NUMPAD3",t,t],[97,1,98,"Numpad4",97,"NumPad4",100,"VK_NUMPAD4",t,t],[98,1,99,"Numpad5",98,"NumPad5",101,"VK_NUMPAD5",t,t],[99,1,100,"Numpad6",99,"NumPad6",102,"VK_NUMPAD6",t,t],[100,1,101,"Numpad7",100,"NumPad7",103,"VK_NUMPAD7",t,t],[101,1,102,"Numpad8",101,"NumPad8",104,"VK_NUMPAD8",t,t],[102,1,103,"Numpad9",102,"NumPad9",105,"VK_NUMPAD9",t,t],[93,1,104,"Numpad0",93,"NumPad0",96,"VK_NUMPAD0",t,t],[107,1,105,"NumpadDecimal",107,"NumPad_Decimal",110,"VK_DECIMAL",t,t],[92,0,106,"IntlBackslash",92,"OEM_102",226,"VK_OEM_102",t,t],[58,1,107,"ContextMenu",58,"ContextMenu",93,t,t,t],[0,1,108,"Power",0,t,0,t,t,t],[0,1,109,"NumpadEqual",0,t,0,t,t,t],[71,1,110,"F13",71,"F13",124,"VK_F13",t,t],[72,1,111,"F14",72,"F14",125,"VK_F14",t,t],[73,1,112,"F15",73,"F15",126,"VK_F15",t,t],[74,1,113,"F16",74,"F16",127,"VK_F16",t,t],[75,1,114,"F17",75,"F17",128,"VK_F17",t,t],[76,1,115,"F18",76,"F18",129,"VK_F18",t,t],[77,1,116,"F19",77,"F19",130,"VK_F19",t,t],[0,1,117,"F20",0,t,0,"VK_F20",t,t],[0,1,118,"F21",0,t,0,"VK_F21",t,t],[0,1,119,"F22",0,t,0,"VK_F22",t,t],[0,1,120,"F23",0,t,0,"VK_F23",t,t],[0,1,121,"F24",0,t,0,"VK_F24",t,t],[0,1,122,"Open",0,t,0,t,t,t],[0,1,123,"Help",0,t,0,t,t,t],[0,1,124,"Select",0,t,0,t,t,t],[0,1,125,"Again",0,t,0,t,t,t],[0,1,126,"Undo",0,t,0,t,t,t],[0,1,127,"Cut",0,t,0,t,t,t],[0,1,128,"Copy",0,t,0,t,t,t],[0,1,129,"Paste",0,t,0,t,t,t],[0,1,130,"Find",0,t,0,t,t,t],[0,1,131,"AudioVolumeMute",112,"AudioVolumeMute",173,"VK_VOLUME_MUTE",t,t],[0,1,132,"AudioVolumeUp",113,"AudioVolumeUp",175,"VK_VOLUME_UP",t,t],[0,1,133,"AudioVolumeDown",114,"AudioVolumeDown",174,"VK_VOLUME_DOWN",t,t],[105,1,134,"NumpadComma",105,"NumPad_Separator",108,"VK_SEPARATOR",t,t],[110,0,135,"IntlRo",110,"ABNT_C1",193,"VK_ABNT_C1",t,t],[0,1,136,"KanaMode",0,t,0,t,t,t],[0,0,137,"IntlYen",0,t,0,t,t,t],[0,1,138,"Convert",0,t,0,t,t,t],[0,1,139,"NonConvert",0,t,0,t,t,t],[0,1,140,"Lang1",0,t,0,t,t,t],[0,1,141,"Lang2",0,t,0,t,t,t],[0,1,142,"Lang3",0,t,0,t,t,t],[0,1,143,"Lang4",0,t,0,t,t,t],[0,1,144,"Lang5",0,t,0,t,t,t],[0,1,145,"Abort",0,t,0,t,t,t],[0,1,146,"Props",0,t,0,t,t,t],[0,1,147,"NumpadParenLeft",0,t,0,t,t,t],[0,1,148,"NumpadParenRight",0,t,0,t,t,t],[0,1,149,"NumpadBackspace",0,t,0,t,t,t],[0,1,150,"NumpadMemoryStore",0,t,0,t,t,t],[0,1,151,"NumpadMemoryRecall",0,t,0,t,t,t],[0,1,152,"NumpadMemoryClear",0,t,0,t,t,t],[0,1,153,"NumpadMemoryAdd",0,t,0,t,t,t],[0,1,154,"NumpadMemorySubtract",0,t,0,t,t,t],[0,1,155,"NumpadClear",0,t,0,t,t,t],[0,1,156,"NumpadClearEntry",0,t,0,t,t,t],[5,1,0,t,5,"Ctrl",17,"VK_CONTROL",t,t],[4,1,0,t,4,"Shift",16,"VK_SHIFT",t,t],[6,1,0,t,6,"Alt",18,"VK_MENU",t,t],[57,1,0,t,57,"Meta",0,"VK_COMMAND",t,t],[5,1,157,"ControlLeft",5,t,0,"VK_LCONTROL",t,t],[4,1,158,"ShiftLeft",4,t,0,"VK_LSHIFT",t,t],[6,1,159,"AltLeft",6,t,0,"VK_LMENU",t,t],[57,1,160,"MetaLeft",57,t,0,"VK_LWIN",t,t],[5,1,161,"ControlRight",5,t,0,"VK_RCONTROL",t,t],[4,1,162,"ShiftRight",4,t,0,"VK_RSHIFT",t,t],[6,1,163,"AltRight",6,t,0,"VK_RMENU",t,t],[57,1,164,"MetaRight",57,t,0,"VK_RWIN",t,t],[0,1,165,"BrightnessUp",0,t,0,t,t,t],[0,1,166,"BrightnessDown",0,t,0,t,t,t],[0,1,167,"MediaPlay",0,t,0,t,t,t],[0,1,168,"MediaRecord",0,t,0,t,t,t],[0,1,169,"MediaFastForward",0,t,0,t,t,t],[0,1,170,"MediaRewind",0,t,0,t,t,t],[114,1,171,"MediaTrackNext",119,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",t,t],[115,1,172,"MediaTrackPrevious",120,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",t,t],[116,1,173,"MediaStop",121,"MediaStop",178,"VK_MEDIA_STOP",t,t],[0,1,174,"Eject",0,t,0,t,t,t],[117,1,175,"MediaPlayPause",122,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",t,t],[0,1,176,"MediaSelect",123,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",t,t],[0,1,177,"LaunchMail",124,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",t,t],[0,1,178,"LaunchApp2",125,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",t,t],[0,1,179,"LaunchApp1",0,t,0,"VK_MEDIA_LAUNCH_APP1",t,t],[0,1,180,"SelectTask",0,t,0,t,t,t],[0,1,181,"LaunchScreenSaver",0,t,0,t,t,t],[0,1,182,"BrowserSearch",115,"BrowserSearch",170,"VK_BROWSER_SEARCH",t,t],[0,1,183,"BrowserHome",116,"BrowserHome",172,"VK_BROWSER_HOME",t,t],[112,1,184,"BrowserBack",117,"BrowserBack",166,"VK_BROWSER_BACK",t,t],[113,1,185,"BrowserForward",118,"BrowserForward",167,"VK_BROWSER_FORWARD",t,t],[0,1,186,"BrowserStop",0,t,0,"VK_BROWSER_STOP",t,t],[0,1,187,"BrowserRefresh",0,t,0,"VK_BROWSER_REFRESH",t,t],[0,1,188,"BrowserFavorites",0,t,0,"VK_BROWSER_FAVORITES",t,t],[0,1,189,"ZoomToggle",0,t,0,t,t,t],[0,1,190,"MailReply",0,t,0,t,t,t],[0,1,191,"MailForward",0,t,0,t,t,t],[0,1,192,"MailSend",0,t,0,t,t,t],[109,1,0,t,109,"KeyInComposition",229,t,t,t],[111,1,0,t,111,"ABNT_C2",194,"VK_ABNT_C2",t,t],[91,1,0,t,91,"OEM_8",223,"VK_OEM_8",t,t],[0,1,0,t,0,t,0,"VK_CLEAR",t,t],[0,1,0,t,0,t,0,"VK_KANA",t,t],[0,1,0,t,0,t,0,"VK_HANGUL",t,t],[0,1,0,t,0,t,0,"VK_JUNJA",t,t],[0,1,0,t,0,t,0,"VK_FINAL",t,t],[0,1,0,t,0,t,0,"VK_HANJA",t,t],[0,1,0,t,0,t,0,"VK_KANJI",t,t],[0,1,0,t,0,t,0,"VK_CONVERT",t,t],[0,1,0,t,0,t,0,"VK_NONCONVERT",t,t],[0,1,0,t,0,t,0,"VK_ACCEPT",t,t],[0,1,0,t,0,t,0,"VK_MODECHANGE",t,t],[0,1,0,t,0,t,0,"VK_SELECT",t,t],[0,1,0,t,0,t,0,"VK_PRINT",t,t],[0,1,0,t,0,t,0,"VK_EXECUTE",t,t],[0,1,0,t,0,t,0,"VK_SNAPSHOT",t,t],[0,1,0,t,0,t,0,"VK_HELP",t,t],[0,1,0,t,0,t,0,"VK_APPS",t,t],[0,1,0,t,0,t,0,"VK_PROCESSKEY",t,t],[0,1,0,t,0,t,0,"VK_PACKET",t,t],[0,1,0,t,0,t,0,"VK_DBE_SBCSCHAR",t,t],[0,1,0,t,0,t,0,"VK_DBE_DBCSCHAR",t,t],[0,1,0,t,0,t,0,"VK_ATTN",t,t],[0,1,0,t,0,t,0,"VK_CRSEL",t,t],[0,1,0,t,0,t,0,"VK_EXSEL",t,t],[0,1,0,t,0,t,0,"VK_EREOF",t,t],[0,1,0,t,0,t,0,"VK_PLAY",t,t],[0,1,0,t,0,t,0,"VK_ZOOM",t,t],[0,1,0,t,0,t,0,"VK_NONAME",t,t],[0,1,0,t,0,t,0,"VK_PA1",t,t],[0,1,0,t,0,t,0,"VK_OEM_CLEAR",t,t]];let E=[],v=[];for(const k of g){const[c,a,u,s,l,n,i,o,h,w]=k;if(v[u]||(v[u]=!0,d[u]=s,f[s]=u,y[s.toLowerCase()]=u,a&&(e.IMMUTABLE_CODE_TO_KEY_CODE[u]=l,l!==0&&l!==3&&l!==5&&l!==4&&l!==6&&l!==57&&(e.IMMUTABLE_KEY_CODE_TO_CODE[l]=u))),!E[l]){if(E[l]=!0,!n)throw new Error(`String representation missing for key code ${l} around scan code ${s}`);C.define(l,n),P.define(l,h||n),I.define(l,w||h||n)}i&&(e.EVENT_KEY_CODE_MAP[i]=l),o&&(e.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[o]=l)}e.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var b;(function(t){function g(u){return C.keyCodeToStr(u)}t.toString=g;function E(u){return C.strToKeyCode(u)}t.fromString=E;function v(u){return P.keyCodeToStr(u)}t.toUserSettingsUS=v;function k(u){return I.keyCodeToStr(u)}t.toUserSettingsGeneral=k;function c(u){return P.strToKeyCode(u)||I.strToKeyCode(u)}t.fromUserSettings=c;function a(u){if(u>=93&&u<=108)return null;switch(u){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return C.keyCodeToStr(u)}t.toElectronAccelerator=a})(b=e.KeyCodeUtils||(e.KeyCodeUtils={}));var m;(function(t){t[t.CtrlCmd=2048]="CtrlCmd",t[t.Shift=1024]="Shift",t[t.Alt=512]="Alt",t[t.WinCtrl=256]="WinCtrl"})(m=e.KeyMod||(e.KeyMod={}));function S(t,g){const E=(g&65535)<<16>>>0;return(t|E)>>>0}e.KeyChord=S}),define(Z[58],x([0,1,16]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedKeybinding=e.ResolvedKeybindingPart=e.ScanCodeBinding=e.ChordKeybinding=e.SimpleKeybinding=e.createSimpleKeybinding=e.createKeybinding=void 0;var r;(function(b){b[b.CtrlCmd=2048]="CtrlCmd",b[b.Shift=1024]="Shift",b[b.Alt=512]="Alt",b[b.WinCtrl=256]="WinCtrl",b[b.KeyCode=255]="KeyCode"})(r||(r={}));function D(b,m){if(b===0)return null;const S=(b&65535)>>>0,t=(b&4294901760)>>>16;return t!==0?new I([C(S,m),C(t,m)]):new I([C(S,m)])}e.createKeybinding=D;function C(b,m){const S=!!(b&2048),t=!!(b&256),g=m===2?t:S,E=!!(b&1024),v=!!(b&512),k=m===2?S:t,c=b&255;return new P(g,E,v,k,c)}e.createSimpleKeybinding=C;class P{constructor(m,S,t,g,E){this.ctrlKey=m,this.shiftKey=S,this.altKey=t,this.metaKey=g,this.keyCode=E}equals(m){return this.ctrlKey===m.ctrlKey&&this.shiftKey===m.shiftKey&&this.altKey===m.altKey&&this.metaKey===m.metaKey&&this.keyCode===m.keyCode}getHashCode(){const m=this.ctrlKey?"1":"0",S=this.shiftKey?"1":"0",t=this.altKey?"1":"0",g=this.metaKey?"1":"0";return`${m}${S}${t}${g}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toChord(){return new I([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}e.SimpleKeybinding=P;class I{constructor(m){if(m.length===0)throw(0,p.illegalArgument)("parts");this.parts=m}getHashCode(){let m="";for(let S=0,t=this.parts.length;S<t;S++)S!==0&&(m+=";"),m+=this.parts[S].getHashCode();return m}equals(m){if(m===null||this.parts.length!==m.parts.length)return!1;for(let S=0;S<this.parts.length;S++)if(!this.parts[S].equals(m.parts[S]))return!1;return!0}}e.ChordKeybinding=I;class d{constructor(m,S,t,g,E){this.ctrlKey=m,this.shiftKey=S,this.altKey=t,this.metaKey=g,this.scanCode=E}equals(m){return this.ctrlKey===m.ctrlKey&&this.shiftKey===m.shiftKey&&this.altKey===m.altKey&&this.metaKey===m.metaKey&&this.scanCode===m.scanCode}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}e.ScanCodeBinding=d;class f{constructor(m,S,t,g,E,v){this.ctrlKey=m,this.shiftKey=S,this.altKey=t,this.metaKey=g,this.keyLabel=E,this.keyAriaLabel=v}}e.ResolvedKeybindingPart=f;class y{}e.ResolvedKeybinding=y}),define(Z[106],x([0,1,79,58]),function(j,e,p,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingParser=void 0;class D{static _readModifiers(P){P=P.toLowerCase().trim();let I=!1,d=!1,f=!1,y=!1,b;do b=!1,/^ctrl(\+|\-)/.test(P)&&(I=!0,P=P.substr("ctrl-".length),b=!0),/^shift(\+|\-)/.test(P)&&(d=!0,P=P.substr("shift-".length),b=!0),/^alt(\+|\-)/.test(P)&&(f=!0,P=P.substr("alt-".length),b=!0),/^meta(\+|\-)/.test(P)&&(y=!0,P=P.substr("meta-".length),b=!0),/^win(\+|\-)/.test(P)&&(y=!0,P=P.substr("win-".length),b=!0),/^cmd(\+|\-)/.test(P)&&(y=!0,P=P.substr("cmd-".length),b=!0);while(b);let m;const S=P.indexOf(" ");return S>0?(m=P.substring(0,S),P=P.substring(S)):(m=P,P=""),{remains:P,ctrl:I,shift:d,alt:f,meta:y,key:m}}static parseSimpleKeybinding(P){const I=this._readModifiers(P),d=p.KeyCodeUtils.fromUserSettings(I.key);return[new r.SimpleKeybinding(I.ctrl,I.shift,I.alt,I.meta,d),I.remains]}static parseKeybinding(P,I){if(!P)return null;const d=[];let f;do[f,P]=this.parseSimpleKeybinding(P),d.push(f);while(P.length>0);return new r.ChordKeybinding(d)}static parseSimpleUserBinding(P){const I=this._readModifiers(P),d=I.key.match(/^\[([^\]]+)\]$/);if(d){const y=d[1],b=p.ScanCodeUtils.lowerCaseToEnum(y);return[new r.ScanCodeBinding(I.ctrl,I.shift,I.alt,I.meta,b),I.remains]}const f=p.KeyCodeUtils.fromUserSettings(I.key);return[new r.SimpleKeybinding(I.ctrl,I.shift,I.alt,I.meta,f),I.remains]}static parseUserBinding(P){if(!P)return[];const I=[];let d;for(;P.length>0;)[d,P]=this.parseSimpleUserBinding(P),I.push(d);return I}}e.KeybindingParser=D}),define(Z[2],x([0,1,42,69]),function(j,e,p,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const D=!1;let C=null;function P(i){C=i}if(e.setDisposableTracker=P,D){const i="__is_disposable_tracked__";P(new class{trackDisposable(o){const h=new Error("Potentially leaked disposable").stack;setTimeout(()=>{o[i]||console.log(h)},3e3)}setParent(o,h){if(o&&o!==k.None)try{o[i]=!0}catch{}}markAsDisposed(o){if(o&&o!==k.None)try{o[i]=!0}catch{}}markAsSingleton(o){}})}function I(i){return C?.trackDisposable(i),i}function d(i){C?.markAsDisposed(i)}function f(i,o){C?.setParent(i,o)}function y(i,o){if(!!C)for(const h of i)C.setParent(h,o)}function b(i){return C?.markAsSingleton(i),i}e.markAsSingleton=b;class m extends Error{constructor(o){super(`Encountered errors while disposing of store. Errors: [${o.join(", ")}]`);this.errors=o}}e.MultiDisposeError=m;function S(i){return typeof i.dispose=="function"&&i.dispose.length===0}e.isDisposable=S;function t(i){if(r.Iterable.is(i)){let o=[];for(const h of i)if(h)try{h.dispose()}catch(w){o.push(w)}if(o.length===1)throw o[0];if(o.length>1)throw new m(o);return Array.isArray(i)?[]:i}else if(i)return i.dispose(),i}e.dispose=t;function g(...i){const o=E(()=>t(i));return y(i,o),o}e.combinedDisposable=g;function E(i){const o=I({dispose:(0,p.once)(()=>{d(o),i()})});return o}e.toDisposable=E;class v{constructor(){this._toDispose=new Set,this._isDisposed=!1,I(this)}dispose(){this._isDisposed||(d(this),this._isDisposed=!0,this.clear())}clear(){try{t(this._toDispose.values())}finally{this._toDispose.clear()}}add(o){if(!o)return o;if(o===this)throw new Error("Cannot register a disposable on itself!");return f(o,this),this._isDisposed?v.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(o),o}}e.DisposableStore=v,v.DISABLE_DISPOSED_WARNING=!1;class k{constructor(){this._store=new v,I(this),f(this._store,this)}dispose(){d(this),this._store.dispose()}_register(o){if(o===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(o)}}e.Disposable=k,k.None=Object.freeze({dispose(){}});class c{constructor(){this._isDisposed=!1,I(this)}get value(){return this._isDisposed?void 0:this._value}set value(o){this._isDisposed||o===this._value||(this._value?.dispose(),o&&f(o,this),this._value=o)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,d(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const o=this._value;return this._value=void 0,o&&f(o,null),o}}e.MutableDisposable=c;class a{constructor(o){this._disposable=o,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=a;class u{constructor(){this.references=new Map}acquire(o,...h){let w=this.references.get(o);w||(w={counter:0,object:this.createReferencedObject(o,...h)},this.references.set(o,w));const{object:M}=w,A=(0,p.once)(()=>{--w.counter==0&&(this.destroyReferencedObject(o,w.object),this.references.delete(o))});return w.counter++,{object:M,dispose:A}}}e.ReferenceCollection=u;class s{constructor(o){this.referenceCollection=o}async acquire(o,...h){const w=this.referenceCollection.acquire(o,...h);try{return{object:await w.object,dispose:()=>w.dispose()}}catch(M){throw w.dispose(),M}}}e.AsyncReferenceCollection=s;class l{constructor(o){this.object=o}dispose(){}}e.ImmortalReference=l;function n(i){const o=new v;try{i(o)}finally{o.dispose()}}e.disposeOnReturn=n}),define(Z[107],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class p{constructor(C){this.element=C,this.next=p.Undefined,this.prev=p.Undefined}}p.Undefined=new p(void 0);class r{constructor(){this._first=p.Undefined,this._last=p.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===p.Undefined}clear(){let C=this._first;for(;C!==p.Undefined;){const P=C.next;C.prev=p.Undefined,C.next=p.Undefined,C=P}this._first=p.Undefined,this._last=p.Undefined,this._size=0}unshift(C){return this._insert(C,!1)}push(C){return this._insert(C,!0)}_insert(C,P){const I=new p(C);if(this._first===p.Undefined)this._first=I,this._last=I;else if(P){const f=this._last;this._last=I,I.prev=f,f.next=I}else{const f=this._first;this._first=I,I.next=f,f.prev=I}this._size+=1;let d=!1;return()=>{d||(d=!0,this._remove(I))}}shift(){if(this._first!==p.Undefined){const C=this._first.element;return this._remove(this._first),C}}pop(){if(this._last!==p.Undefined){const C=this._last.element;return this._remove(this._last),C}}_remove(C){if(C.prev!==p.Undefined&&C.next!==p.Undefined){const P=C.prev;P.next=C.next,C.next.prev=P}else C.prev===p.Undefined&&C.next===p.Undefined?(this._first=p.Undefined,this._last=p.Undefined):C.next===p.Undefined?(this._last=this._last.prev,this._last.next=p.Undefined):C.prev===p.Undefined&&(this._first=this._first.next,this._first.prev=p.Undefined);this._size-=1}*[Symbol.iterator](){let C=this._first;for(;C!==p.Undefined;)yield C.element,C=C.next}}e.LinkedList=r}),function(){function j(D){const C=[];typeof D=="number"&&C.push("code/timeOrigin",D);function P(d){C.push(d,Date.now())}function I(){const d=[];for(let f=0;f<C.length;f+=2)d.push({name:C[f],startTime:C[f+1]});return d}return{mark:P,getMarks:I}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?j():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const C=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const P of performance.getEntriesByType("mark"))C.push({name:P.name,startTime:Math.round(D+P.startTime)});return C}};if(typeof process=="object"){const D=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return j(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),j()}function p(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var r;typeof global=="object"?r=global:typeof self=="object"?r=self:r={},typeof define=="function"?define("vs/base/common/performance",[],function(){return p(r)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=p(r):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),r.perf=p(r))}(),define(Z[3],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const p="en";let r=!1,D=!1,C=!1,P=!1,I=!1,d=!1,f=!1,y=!1,b,m=p,S,t;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let g;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?g=e.globals.vscode.process:typeof process!="undefined"&&(g=process);const E=typeof g?.versions?.electron=="string",v=E&&g?.type==="renderer";if(e.isElectronSandboxed=v&&g?.sandboxed,typeof navigator=="object"&&!v)t=navigator.userAgent,r=t.indexOf("Windows")>=0,D=t.indexOf("Macintosh")>=0,y=(t.indexOf("Macintosh")>=0||t.indexOf("iPad")>=0||t.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,C=t.indexOf("Linux")>=0,d=!0,b=navigator.language,m=b;else if(typeof g=="object"){r=g.platform==="win32",D=g.platform==="darwin",C=g.platform==="linux",P=C&&!!g.env.SNAP&&!!g.env.SNAP_REVISION,f=E,b=p,m=p;const o=g.env.VSCODE_NLS_CONFIG;if(o)try{const h=JSON.parse(o),w=h.availableLanguages["*"];b=h.locale,m=w||p,S=h._translationsConfigFile}catch{}I=!0}else console.error("Unable to resolve platform.");var k;(function(o){o[o.Web=0]="Web",o[o.Mac=1]="Mac",o[o.Linux=2]="Linux",o[o.Windows=3]="Windows"})(k=e.Platform||(e.Platform={}));function c(o){switch(o){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=c;let a=0;D?a=1:r?a=3:C&&(a=2),e.isWindows=r,e.isMacintosh=D,e.isLinux=C,e.isLinuxSnap=P,e.isNative=I,e.isElectron=f,e.isWeb=d,e.isIOS=y,e.platform=a,e.userAgent=t,e.language=m;var u;(function(o){function h(){return e.language}o.value=h;function w(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}o.isDefaultVariant=w;function M(){return e.language==="en"}o.isDefault=M})(u=e.Language||(e.Language={})),e.locale=b,e.translationsConfigFile=S,e.setTimeout0=(()=>{if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let o=[];e.globals.addEventListener("message",w=>{if(w.data&&w.data.vscodeScheduleAsyncWork)for(let M=0,A=o.length;M<A;M++){const R=o[M];if(R.id===w.data.vscodeScheduleAsyncWork){o.splice(M,1),R.callback();return}}});let h=0;return w=>{const M=++h;o.push({id:M,callback:w}),e.globals.postMessage({vscodeScheduleAsyncWork:M},"*")}}return o=>setTimeout(o)})();var s;(function(o){o[o.Windows=1]="Windows",o[o.Macintosh=2]="Macintosh",o[o.Linux=3]="Linux"})(s=e.OperatingSystem||(e.OperatingSystem={})),e.OS=D||y?2:r?1:3;let l=!0,n=!1;function i(){if(!n){n=!0;const o=new Uint8Array(2);o[0]=1,o[1]=2,l=new Uint16Array(o.buffer)[0]===(2<<8)+1}return l}e.isLittleEndian=i}),define(Z[34],x([0,1,3]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let r;if(typeof p.globals.vscode!="undefined"&&typeof p.globals.vscode.process!="undefined"){const D=p.globals.vscode.process;r={get platform(){return D.platform},get arch(){return D.arch},get env(){return D.env},cwd(){return D.cwd()}}}else typeof process!="undefined"?r={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:r={get platform(){return p.isWindows?"win32":p.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=r.cwd,e.env=r.env,e.platform=r.platform,e.arch=r.arch}),define(Z[8],x([0,1,34]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const r=65,D=97,C=90,P=122,I=46,d=47,f=92,y=58,b=63;class m extends Error{constructor(a,u,s){let l;typeof u=="string"&&u.indexOf("not ")===0?(l="must not be",u=u.replace(/^not /,"")):l="must be";const n=a.indexOf(".")!==-1?"property":"argument";let i=`The "${a}" ${n} ${l} of type ${u}`;i+=`. Received type ${typeof s}`;super(i);this.code="ERR_INVALID_ARG_TYPE"}}function S(c,a){if(typeof c!="string")throw new m(a,"string",c)}function t(c){return c===d||c===f}function g(c){return c===d}function E(c){return c>=r&&c<=C||c>=D&&c<=P}function v(c,a,u,s){let l="",n=0,i=-1,o=0,h=0;for(let w=0;w<=c.length;++w){if(w<c.length)h=c.charCodeAt(w);else{if(s(h))break;h=d}if(s(h)){if(!(i===w-1||o===1))if(o===2){if(l.length<2||n!==2||l.charCodeAt(l.length-1)!==I||l.charCodeAt(l.length-2)!==I){if(l.length>2){const M=l.lastIndexOf(u);M===-1?(l="",n=0):(l=l.slice(0,M),n=l.length-1-l.lastIndexOf(u)),i=w,o=0;continue}else if(l.length!==0){l="",n=0,i=w,o=0;continue}}a&&(l+=l.length>0?`${u}..`:"..",n=2)}else l.length>0?l+=`${u}${c.slice(i+1,w)}`:l=c.slice(i+1,w),n=w-i-1;i=w,o=0}else h===I&&o!==-1?++o:o=-1}return l}function k(c,a){if(a===null||typeof a!="object")throw new m("pathObject","Object",a);const u=a.dir||a.root,s=a.base||`${a.name||""}${a.ext||""}`;return u?u===a.root?`${u}${s}`:`${u}${c}${s}`:s}e.win32={resolve(...c){let a="",u="",s=!1;for(let l=c.length-1;l>=-1;l--){let n;if(l>=0){if(n=c[l],S(n,"path"),n.length===0)continue}else a.length===0?n=p.cwd():(n=p.env[`=${a}`]||p.cwd(),(n===void 0||n.slice(0,2).toLowerCase()!==a.toLowerCase()&&n.charCodeAt(2)===f)&&(n=`${a}\\`));const i=n.length;let o=0,h="",w=!1;const M=n.charCodeAt(0);if(i===1)t(M)&&(o=1,w=!0);else if(t(M))if(w=!0,t(n.charCodeAt(1))){let A=2,R=A;for(;A<i&&!t(n.charCodeAt(A));)A++;if(A<i&&A!==R){const T=n.slice(R,A);for(R=A;A<i&&t(n.charCodeAt(A));)A++;if(A<i&&A!==R){for(R=A;A<i&&!t(n.charCodeAt(A));)A++;(A===i||A!==R)&&(h=`\\\\${T}\\${n.slice(R,A)}`,o=A)}}}else o=1;else E(M)&&n.charCodeAt(1)===y&&(h=n.slice(0,2),o=2,i>2&&t(n.charCodeAt(2))&&(w=!0,o=3));if(h.length>0)if(a.length>0){if(h.toLowerCase()!==a.toLowerCase())continue}else a=h;if(s){if(a.length>0)break}else if(u=`${n.slice(o)}\\${u}`,s=w,w&&a.length>0)break}return u=v(u,!s,"\\",t),s?`${a}\\${u}`:`${a}${u}`||"."},normalize(c){S(c,"path");const a=c.length;if(a===0)return".";let u=0,s,l=!1;const n=c.charCodeAt(0);if(a===1)return g(n)?"\\":c;if(t(n))if(l=!0,t(c.charCodeAt(1))){let o=2,h=o;for(;o<a&&!t(c.charCodeAt(o));)o++;if(o<a&&o!==h){const w=c.slice(h,o);for(h=o;o<a&&t(c.charCodeAt(o));)o++;if(o<a&&o!==h){for(h=o;o<a&&!t(c.charCodeAt(o));)o++;if(o===a)return`\\\\${w}\\${c.slice(h)}\\`;o!==h&&(s=`\\\\${w}\\${c.slice(h,o)}`,u=o)}}}else u=1;else E(n)&&c.charCodeAt(1)===y&&(s=c.slice(0,2),u=2,a>2&&t(c.charCodeAt(2))&&(l=!0,u=3));let i=u<a?v(c.slice(u),!l,"\\",t):"";return i.length===0&&!l&&(i="."),i.length>0&&t(c.charCodeAt(a-1))&&(i+="\\"),s===void 0?l?`\\${i}`:i:l?`${s}\\${i}`:`${s}${i}`},isAbsolute(c){S(c,"path");const a=c.length;if(a===0)return!1;const u=c.charCodeAt(0);return t(u)||a>2&&E(u)&&c.charCodeAt(1)===y&&t(c.charCodeAt(2))},join(...c){if(c.length===0)return".";let a,u;for(let n=0;n<c.length;++n){const i=c[n];S(i,"path"),i.length>0&&(a===void 0?a=u=i:a+=`\\${i}`)}if(a===void 0)return".";let s=!0,l=0;if(typeof u=="string"&&t(u.charCodeAt(0))){++l;const n=u.length;n>1&&t(u.charCodeAt(1))&&(++l,n>2&&(t(u.charCodeAt(2))?++l:s=!1))}if(s){for(;l<a.length&&t(a.charCodeAt(l));)l++;l>=2&&(a=`\\${a.slice(l)}`)}return e.win32.normalize(a)},relative(c,a){if(S(c,"from"),S(a,"to"),c===a)return"";const u=e.win32.resolve(c),s=e.win32.resolve(a);if(u===s||(c=u.toLowerCase(),a=s.toLowerCase(),c===a))return"";let l=0;for(;l<c.length&&c.charCodeAt(l)===f;)l++;let n=c.length;for(;n-1>l&&c.charCodeAt(n-1)===f;)n--;const i=n-l;let o=0;for(;o<a.length&&a.charCodeAt(o)===f;)o++;let h=a.length;for(;h-1>o&&a.charCodeAt(h-1)===f;)h--;const w=h-o,M=i<w?i:w;let A=-1,R=0;for(;R<M;R++){const _=c.charCodeAt(l+R);if(_!==a.charCodeAt(o+R))break;_===f&&(A=R)}if(R!==M){if(A===-1)return s}else{if(w>M){if(a.charCodeAt(o+R)===f)return s.slice(o+R+1);if(R===2)return s.slice(o+R)}i>M&&(c.charCodeAt(l+R)===f?A=R:R===2&&(A=3)),A===-1&&(A=0)}let T="";for(R=l+A+1;R<=n;++R)(R===n||c.charCodeAt(R)===f)&&(T+=T.length===0?"..":"\\..");return o+=A,T.length>0?`${T}${s.slice(o,h)}`:(s.charCodeAt(o)===f&&++o,s.slice(o,h))},toNamespacedPath(c){if(typeof c!="string")return c;if(c.length===0)return"";const a=e.win32.resolve(c);if(a.length<=2)return c;if(a.charCodeAt(0)===f){if(a.charCodeAt(1)===f){const u=a.charCodeAt(2);if(u!==b&&u!==I)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(E(a.charCodeAt(0))&&a.charCodeAt(1)===y&&a.charCodeAt(2)===f)return`\\\\?\\${a}`;return c},dirname(c){S(c,"path");const a=c.length;if(a===0)return".";let u=-1,s=0;const l=c.charCodeAt(0);if(a===1)return t(l)?c:".";if(t(l)){if(u=s=1,t(c.charCodeAt(1))){let o=2,h=o;for(;o<a&&!t(c.charCodeAt(o));)o++;if(o<a&&o!==h){for(h=o;o<a&&t(c.charCodeAt(o));)o++;if(o<a&&o!==h){for(h=o;o<a&&!t(c.charCodeAt(o));)o++;if(o===a)return c;o!==h&&(u=s=o+1)}}}}else E(l)&&c.charCodeAt(1)===y&&(u=a>2&&t(c.charCodeAt(2))?3:2,s=u);let n=-1,i=!0;for(let o=a-1;o>=s;--o)if(t(c.charCodeAt(o))){if(!i){n=o;break}}else i=!1;if(n===-1){if(u===-1)return".";n=u}return c.slice(0,n)},basename(c,a){a!==void 0&&S(a,"ext"),S(c,"path");let u=0,s=-1,l=!0,n;if(c.length>=2&&E(c.charCodeAt(0))&&c.charCodeAt(1)===y&&(u=2),a!==void 0&&a.length>0&&a.length<=c.length){if(a===c)return"";let i=a.length-1,o=-1;for(n=c.length-1;n>=u;--n){const h=c.charCodeAt(n);if(t(h)){if(!l){u=n+1;break}}else o===-1&&(l=!1,o=n+1),i>=0&&(h===a.charCodeAt(i)?--i==-1&&(s=n):(i=-1,s=o))}return u===s?s=o:s===-1&&(s=c.length),c.slice(u,s)}for(n=c.length-1;n>=u;--n)if(t(c.charCodeAt(n))){if(!l){u=n+1;break}}else s===-1&&(l=!1,s=n+1);return s===-1?"":c.slice(u,s)},extname(c){S(c,"path");let a=0,u=-1,s=0,l=-1,n=!0,i=0;c.length>=2&&c.charCodeAt(1)===y&&E(c.charCodeAt(0))&&(a=s=2);for(let o=c.length-1;o>=a;--o){const h=c.charCodeAt(o);if(t(h)){if(!n){s=o+1;break}continue}l===-1&&(n=!1,l=o+1),h===I?u===-1?u=o:i!==1&&(i=1):u!==-1&&(i=-1)}return u===-1||l===-1||i===0||i===1&&u===l-1&&u===s+1?"":c.slice(u,l)},format:k.bind(null,"\\"),parse(c){S(c,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(c.length===0)return a;const u=c.length;let s=0,l=c.charCodeAt(0);if(u===1)return t(l)?(a.root=a.dir=c,a):(a.base=a.name=c,a);if(t(l)){if(s=1,t(c.charCodeAt(1))){let A=2,R=A;for(;A<u&&!t(c.charCodeAt(A));)A++;if(A<u&&A!==R){for(R=A;A<u&&t(c.charCodeAt(A));)A++;if(A<u&&A!==R){for(R=A;A<u&&!t(c.charCodeAt(A));)A++;A===u?s=A:A!==R&&(s=A+1)}}}}else if(E(l)&&c.charCodeAt(1)===y){if(u<=2)return a.root=a.dir=c,a;if(s=2,t(c.charCodeAt(2))){if(u===3)return a.root=a.dir=c,a;s=3}}s>0&&(a.root=c.slice(0,s));let n=-1,i=s,o=-1,h=!0,w=c.length-1,M=0;for(;w>=s;--w){if(l=c.charCodeAt(w),t(l)){if(!h){i=w+1;break}continue}o===-1&&(h=!1,o=w+1),l===I?n===-1?n=w:M!==1&&(M=1):n!==-1&&(M=-1)}return o!==-1&&(n===-1||M===0||M===1&&n===o-1&&n===i+1?a.base=a.name=c.slice(i,o):(a.name=c.slice(i,n),a.base=c.slice(i,o),a.ext=c.slice(n,o))),i>0&&i!==s?a.dir=c.slice(0,i-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...c){let a="",u=!1;for(let s=c.length-1;s>=-1&&!u;s--){const l=s>=0?c[s]:p.cwd();S(l,"path"),l.length!==0&&(a=`${l}/${a}`,u=l.charCodeAt(0)===d)}return a=v(a,!u,"/",g),u?`/${a}`:a.length>0?a:"."},normalize(c){if(S(c,"path"),c.length===0)return".";const a=c.charCodeAt(0)===d,u=c.charCodeAt(c.length-1)===d;return c=v(c,!a,"/",g),c.length===0?a?"/":u?"./":".":(u&&(c+="/"),a?`/${c}`:c)},isAbsolute(c){return S(c,"path"),c.length>0&&c.charCodeAt(0)===d},join(...c){if(c.length===0)return".";let a;for(let u=0;u<c.length;++u){const s=c[u];S(s,"path"),s.length>0&&(a===void 0?a=s:a+=`/${s}`)}return a===void 0?".":e.posix.normalize(a)},relative(c,a){if(S(c,"from"),S(a,"to"),c===a||(c=e.posix.resolve(c),a=e.posix.resolve(a),c===a))return"";const u=1,s=c.length,l=s-u,n=1,i=a.length-n,o=l<i?l:i;let h=-1,w=0;for(;w<o;w++){const A=c.charCodeAt(u+w);if(A!==a.charCodeAt(n+w))break;A===d&&(h=w)}if(w===o)if(i>o){if(a.charCodeAt(n+w)===d)return a.slice(n+w+1);if(w===0)return a.slice(n+w)}else l>o&&(c.charCodeAt(u+w)===d?h=w:w===0&&(h=0));let M="";for(w=u+h+1;w<=s;++w)(w===s||c.charCodeAt(w)===d)&&(M+=M.length===0?"..":"/..");return`${M}${a.slice(n+h)}`},toNamespacedPath(c){return c},dirname(c){if(S(c,"path"),c.length===0)return".";const a=c.charCodeAt(0)===d;let u=-1,s=!0;for(let l=c.length-1;l>=1;--l)if(c.charCodeAt(l)===d){if(!s){u=l;break}}else s=!1;return u===-1?a?"/":".":a&&u===1?"//":c.slice(0,u)},basename(c,a){a!==void 0&&S(a,"ext"),S(c,"path");let u=0,s=-1,l=!0,n;if(a!==void 0&&a.length>0&&a.length<=c.length){if(a===c)return"";let i=a.length-1,o=-1;for(n=c.length-1;n>=0;--n){const h=c.charCodeAt(n);if(h===d){if(!l){u=n+1;break}}else o===-1&&(l=!1,o=n+1),i>=0&&(h===a.charCodeAt(i)?--i==-1&&(s=n):(i=-1,s=o))}return u===s?s=o:s===-1&&(s=c.length),c.slice(u,s)}for(n=c.length-1;n>=0;--n)if(c.charCodeAt(n)===d){if(!l){u=n+1;break}}else s===-1&&(l=!1,s=n+1);return s===-1?"":c.slice(u,s)},extname(c){S(c,"path");let a=-1,u=0,s=-1,l=!0,n=0;for(let i=c.length-1;i>=0;--i){const o=c.charCodeAt(i);if(o===d){if(!l){u=i+1;break}continue}s===-1&&(l=!1,s=i+1),o===I?a===-1?a=i:n!==1&&(n=1):a!==-1&&(n=-1)}return a===-1||s===-1||n===0||n===1&&a===s-1&&a===u+1?"":c.slice(a,s)},format:k.bind(null,"/"),parse(c){S(c,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(c.length===0)return a;const u=c.charCodeAt(0)===d;let s;u?(a.root="/",s=1):s=0;let l=-1,n=0,i=-1,o=!0,h=c.length-1,w=0;for(;h>=s;--h){const M=c.charCodeAt(h);if(M===d){if(!o){n=h+1;break}continue}i===-1&&(o=!1,i=h+1),M===I?l===-1?l=h:w!==1&&(w=1):l!==-1&&(w=-1)}if(i!==-1){const M=n===0&&u?1:n;l===-1||w===0||w===1&&l===i-1&&l===n+1?a.base=a.name=c.slice(M,i):(a.name=c.slice(M,l),a.base=c.slice(M,i),a.ext=c.slice(l,i))}return n>0?a.dir=c.slice(0,n-1):u&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=p.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=p.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=p.platform==="win32"?e.win32.join:e.posix.join,e.resolve=p.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=p.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=p.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=p.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=p.platform==="win32"?e.win32.extname:e.posix.extname,e.format=p.platform==="win32"?e.win32.format:e.posix.format,e.parse=p.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=p.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=p.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=p.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(Z[80],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var p;(function(C){C[C.stdout=0]="stdout",C[C.stderr=1]="stderr"})(p=e.Source||(e.Source={}));var r;(function(C){C[C.Success=0]="Success",C[C.Unknown=1]="Unknown",C[C.AccessDenied=2]="AccessDenied",C[C.ProcessNotFound=3]="ProcessNotFound"})(r=e.TerminateResponseCode||(e.TerminateResponseCode={}));function D(C,...P){const I=P.reduce((y,b)=>(y[b]=!0,y),{}),d=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(C).filter(y=>!I[y]).forEach(y=>{for(let b=0;b<d.length;b++)if(y.search(d[b])!==-1){delete C[y];break}})}e.sanitizeProcessEnvironment=D}),define(Z[108],x([0,1,3]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const r=p.globals.performance&&typeof p.globals.performance.now=="function";class D{constructor(P){this._highResolution=r&&P,this._startTime=this._now(),this._stopTime=-1}static create(P=!0){return new D(P)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?p.globals.performance.now():Date.now()}}e.StopWatch=D}),define(Z[4],x([0,1,16,42,2,107,108]),function(j,e,p,r,D,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var I;(function(a){a.None=()=>D.Disposable.None;function u(H){return(q,Y=null,$)=>{let K=!1,te;return te=H(B=>{if(!K)return te?te.dispose():K=!0,q.call(Y,B)},null,$),K&&te.dispose(),te}}a.once=u;function s(H,q){return w((Y,$=null,K)=>H(te=>Y.call($,q(te)),null,K))}a.map=s;function l(H,q){return w((Y,$=null,K)=>H(te=>{q(te),Y.call($,te)},null,K))}a.forEach=l;function n(H,q){return w((Y,$=null,K)=>H(te=>q(te)&&Y.call($,te),null,K))}a.filter=n;function i(H){return H}a.signal=i;function o(...H){return(q,Y=null,$)=>(0,D.combinedDisposable)(...H.map(K=>K(te=>q.call(Y,te),null,$)))}a.any=o;function h(H,q,Y){let $=Y;return s(H,K=>($=q($,K),$))}a.reduce=h;function w(H){let q;const Y=new m({onFirstListenerAdd(){q=H(Y.fire,Y)},onLastListenerRemove(){q.dispose()}});return Y.event}function M(H,q,Y=100,$=!1,K){let te,B,L,W=0;const F=new m({leakWarningThreshold:K,onFirstListenerAdd(){te=H(N=>{W++,B=q(B,N),$&&!L&&(F.fire(B),B=void 0),clearTimeout(L),L=setTimeout(()=>{const V=B;B=void 0,L=void 0,(!$||W>1)&&F.fire(V),W=0},Y)})},onLastListenerRemove(){te.dispose()}});return F.event}a.debounce=M;function A(H,q=(Y,$)=>Y===$){let Y=!0,$;return n(H,K=>{const te=Y||!q(K,$);return Y=!1,$=K,te})}a.latch=A;function R(H,q){return[a.filter(H,q),a.filter(H,Y=>!q(Y))]}a.split=R;function T(H,q=!1,Y=[]){let $=Y.slice(),K=H(L=>{$?$.push(L):B.fire(L)});const te=()=>{$&&$.forEach(L=>B.fire(L)),$=null},B=new m({onFirstListenerAdd(){K||(K=H(L=>B.fire(L)))},onFirstListenerDidAdd(){$&&(q?setTimeout(te):te())},onLastListenerRemove(){K&&K.dispose(),K=null}});return B.event}a.buffer=T;class _{constructor(q){this.event=q}map(q){return new _(s(this.event,q))}forEach(q){return new _(l(this.event,q))}filter(q){return new _(n(this.event,q))}reduce(q,Y){return new _(h(this.event,q,Y))}latch(){return new _(A(this.event))}debounce(q,Y=100,$=!1,K){return new _(M(this.event,q,Y,$,K))}on(q,Y,$){return this.event(q,Y,$)}once(q,Y,$){return u(this.event)(q,Y,$)}}function Q(H){return new _(H)}a.chain=Q;function ne(H,q,Y=$=>$){const $=(...L)=>B.fire(Y(...L)),K=()=>H.on(q,$),te=()=>H.removeListener(q,$),B=new m({onFirstListenerAdd:K,onLastListenerRemove:te});return B.event}a.fromNodeEventEmitter=ne;function oe(H,q,Y=$=>$){const $=(...L)=>B.fire(Y(...L)),K=()=>H.addEventListener(q,$),te=()=>H.removeEventListener(q,$),B=new m({onFirstListenerAdd:K,onLastListenerRemove:te});return B.event}a.fromDOMEventEmitter=oe;function X(H){return new Promise(q=>u(H)(q))}a.toPromise=X;function O(H,q){return q(void 0),H(Y=>q(Y))}a.runAndSubscribe=O})(I=e.Event||(e.Event={}));class d{constructor(u){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${u}_${d._idPool++}`}start(u){this._stopWatch=new P.StopWatch(!0),this._listenerCount=u}stop(){if(this._stopWatch){const u=this._stopWatch.elapsed();this._elapsedOverall+=u,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${u.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}d._idPool=0;let f=-1;function y(a){const u=f;return f=a,{dispose(){f=u}}}e.setGlobalLeakWarningThreshold=y;class b{constructor(u,s=Math.random().toString(18).slice(2,5)){this.customThreshold=u,this.name=s,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(u){let s=f;if(typeof this.customThreshold=="number"&&(s=this.customThreshold),s<=0||u<s)return;this._stacks||(this._stacks=new Map);const l=new Error().stack.split(`
`).slice(3).join(`
`),n=this._stacks.get(l)||0;if(this._stacks.set(l,n+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=s*.5;let i,o=0;for(const[h,w]of this._stacks)(!i||o<w)&&(i=h,o=w);console.warn(`[${this.name}] potential listener LEAK detected, having ${u} listeners already. MOST frequent listener (${o}):`),console.warn(i)}return()=>{const i=this._stacks.get(l)||0;this._stacks.set(l,i-1)}}}class m{constructor(u){this._disposed=!1,this._options=u,this._leakageMon=f>0?new b(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new d(this._options._profName):void 0}get event(){return this._event||(this._event=(u,s,l)=>{this._listeners||(this._listeners=new C.LinkedList);const n=this._listeners.isEmpty();n&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const i=this._listeners.push(s?[u,s]:u);n&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,u,s);const o=this._leakageMon?.check(this._listeners.size),h=(0,D.toDisposable)(()=>{o&&o(),this._disposed||(i(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return l instanceof D.DisposableStore?l.add(h):Array.isArray(l)&&l.push(h),h}),this._event}fire(u){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new C.LinkedList);for(let s of this._listeners)this._deliveryQueue.push([s,u]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[s,l]=this._deliveryQueue.shift();try{typeof s=="function"?s.call(void 0,l):s[0].call(s[1],l)}catch(n){(0,p.onUnexpectedError)(n)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=m;class S extends m{async fireAsync(u,s,l){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new C.LinkedList);for(const n of this._listeners)this._asyncDeliveryQueue.push([n,u]);for(;this._asyncDeliveryQueue.size>0&&!s.isCancellationRequested;){const[n,i]=this._asyncDeliveryQueue.shift(),o=[],h={...i,token:s,waitUntil:w=>{if(Object.isFrozen(o))throw new Error("waitUntil can NOT be called asynchronous");l&&(w=l(w,typeof n=="function"?n:n[0])),o.push(w)}};try{typeof n=="function"?n.call(void 0,h):n[0].call(n[1],h)}catch(w){(0,p.onUnexpectedError)(w);continue}Object.freeze(o),await Promise.allSettled(o).then(w=>{for(const M of w)M.status==="rejected"&&(0,p.onUnexpectedError)(M.reason)})}}}}e.AsyncEmitter=S;class t extends m{constructor(u){super(u);this._isPaused=0,this._eventQueue=new C.LinkedList,this._mergeFn=u?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const u=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(u))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(u){this._listeners&&(this._isPaused!==0?this._eventQueue.push(u):super.fire(u))}}e.PauseableEmitter=t;class g extends t{constructor(u){super(u);this._delay=u.delay??100}fire(u){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(u)}}e.DebounceEmitter=g;class E extends m{constructor(u){super(u);this._queuedEvents=[],this._mergeFn=u?.merge}fire(u){this._queuedEvents.push(u),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(s=>super.fire(s)),this._queuedEvents=[]})}}e.MicrotaskEmitter=E;class v{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new m({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(u){const s={event:u,listener:null};this.events.push(s),this.hasListeners&&this.hook(s);const l=()=>{this.hasListeners&&this.unhook(s);const n=this.events.indexOf(s);this.events.splice(n,1)};return(0,D.toDisposable)((0,r.once)(l))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(u=>this.hook(u))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(u=>this.unhook(u))}hook(u){u.listener=u.event(s=>this.emitter.fire(s))}unhook(u){u.listener&&u.listener.dispose(),u.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=v;class k{constructor(){this.buffers=[]}wrapEvent(u){return(s,l,n)=>u(i=>{const o=this.buffers[this.buffers.length-1];o?o.push(()=>s.call(l,i)):s.call(l,i)},void 0,n)}bufferEvents(u){const s=[];this.buffers.push(s);const l=u();return this.buffers.pop(),s.forEach(n=>n()),l}}e.EventBufferer=k;class c{constructor(){this.listening=!1,this.inputEvent=I.None,this.inputEventListener=D.Disposable.None,this.emitter=new m({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(u){this.inputEvent=u,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=u(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=c}),define(Z[23],x([0,1,4]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const r=Object.freeze(function(I,d){const f=setTimeout(I.bind(d),0);return{dispose(){clearTimeout(f)}}});var D;(function(I){function d(f){return f===I.None||f===I.Cancelled||f instanceof C?!0:!f||typeof f!="object"?!1:typeof f.isCancellationRequested=="boolean"&&typeof f.onCancellationRequested=="function"}I.isCancellationToken=d,I.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:p.Event.None}),I.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:r})})(D=e.CancellationToken||(e.CancellationToken={}));class C{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?r:(this._emitter||(this._emitter=new p.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class P{constructor(d){this._token=void 0,this._parentListener=void 0,this._parentListener=d&&d.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new C),this._token}cancel(){this._token?this._token instanceof C&&this._token.cancel():this._token=D.Cancelled}dispose(d=!1){d&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof C&&this._token.dispose():this._token=D.None}}e.CancellationTokenSource=P}),define(Z[59],x([0,1,16,2]),function(j,e,p,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function D(c){const a=c;return a?[a.on,a.pause,a.resume,a.destroy].every(u=>typeof u=="function"):!1}e.isReadableStream=D;function C(c){const a=c;return a?D(a.stream)&&Array.isArray(a.buffer)&&typeof a.ended=="boolean":!1}e.isReadableBufferedStream=C;function P(c,a){return new I(c,a)}e.newWriteableStream=P;class I{constructor(a,u){this.reducer=a,this.options=u,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(a){if(!this.state.destroyed){if(this.state.flowing)this.emitData(a);else if(this.buffer.data.push(a),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(u=>this.pendingWritePromises.push(u))}}error(a){this.state.destroyed||(this.state.flowing?this.emitError(a):this.buffer.error.push(a))}end(a){this.state.destroyed||(typeof a!="undefined"&&this.write(a),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(a){this.listeners.data.slice(0).forEach(u=>u(a))}emitError(a){this.listeners.error.length===0?(0,p.onUnexpectedError)(a):this.listeners.error.slice(0).forEach(u=>u(a))}emitEnd(){this.listeners.end.slice(0).forEach(a=>a())}on(a,u){if(!this.state.destroyed)switch(a){case"data":this.listeners.data.push(u),this.resume();break;case"end":this.listeners.end.push(u),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(u),this.state.flowing&&this.flowErrors();break}}removeListener(a,u){if(this.state.destroyed)return;let s;switch(a){case"data":s=this.listeners.data;break;case"end":s=this.listeners.end;break;case"error":s=this.listeners.error;break}if(s){const l=s.indexOf(u);l>=0&&s.splice(l,1)}}flowData(){if(this.buffer.data.length>0){const a=this.reducer(this.buffer.data);this.emitData(a),this.buffer.data.length=0;const u=[...this.pendingWritePromises];this.pendingWritePromises.length=0,u.forEach(s=>s())}}flowErrors(){if(this.listeners.error.length>0){for(const a of this.buffer.error)this.emitError(a);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function d(c,a){const u=[];let s;for(;(s=c.read())!==null;)u.push(s);return a(u)}e.consumeReadable=d;function f(c,a,u){const s=[];let l;for(;(l=c.read())!==null&&s.length<u;)s.push(l);return l===null&&s.length>0?a(s):{read:()=>{if(s.length>0)return s.shift();if(typeof l!="undefined"){const n=l;return l=void 0,n}return c.read()}}}e.peekReadable=f;function y(c,a){return new Promise((u,s)=>{const l=[];b(c,{onData:n=>{a&&l.push(n)},onError:n=>{a?s(n):u(void 0)},onEnd:()=>{u(a?a(l):void 0)}})})}e.consumeStream=y;function b(c,a){let u=!1;return c.on("error",s=>{u||a.onError(s)}),c.on("end",()=>{u||a.onEnd()}),c.on("data",s=>{u||a.onData(s)}),(0,r.toDisposable)(()=>u=!0)}e.listenStream=b;function m(c,a){return new Promise((u,s)=>{const l=new r.DisposableStore,n=[],i=w=>{if(n.push(w),n.length>a)return l.dispose(),c.pause(),u({stream:c,buffer:n,ended:!1})},o=w=>s(w),h=()=>u({stream:c,buffer:n,ended:!0});l.add((0,r.toDisposable)(()=>c.removeListener("error",o))),c.on("error",o),l.add((0,r.toDisposable)(()=>c.removeListener("end",h))),c.on("end",h),l.add((0,r.toDisposable)(()=>c.removeListener("data",i))),c.on("data",i)})}e.peekStream=m;function S(c,a){const u=P(a);return u.end(c),u}e.toStream=S;function t(){const c=P(()=>{throw new Error("not supported")});return c.end(),c}e.emptyStream=t;function g(c){let a=!1;return{read:()=>a?null:(a=!0,c)}}e.toReadable=g;function E(c,a,u){const s=P(u);return b(c,{onData:l=>s.write(a.data(l)),onError:l=>s.error(a.error?a.error(l):l),onEnd:()=>s.end()}),s}e.transform=E;function v(c,a,u){let s=!1;return{read:()=>{const l=a.read();return s?l:(s=!0,l!==null?u([c,l]):c)}}}e.prefixedReadable=v;function k(c,a,u){let s=!1;const l=P(u);return b(a,{onData:n=>s?l.write(n):(s=!0,l.write(u([c,n]))),onError:n=>l.error(n),onEnd:()=>{s||(s=!0,l.write(c)),l.end()}}),l}e.prefixedStream=k}),define(Z[17],x([0,1,59]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const r=typeof Buffer!="undefined";let D,C;class P{constructor(i){this.buffer=i,this.byteLength=this.buffer.byteLength}static alloc(i){return r?new P(Buffer.allocUnsafe(i)):new P(new Uint8Array(i))}static wrap(i){return r&&!Buffer.isBuffer(i)&&(i=Buffer.from(i.buffer,i.byteOffset,i.byteLength)),new P(i)}static fromString(i,o){return!(o?.dontUseNodeBuffer||!1)&&r?new P(Buffer.from(i)):(D||(D=new TextEncoder),new P(D.encode(i)))}static fromByteArray(i){const o=P.alloc(i.length);for(let h=0,w=i.length;h<w;h++)o.buffer[h]=i[h];return o}static concat(i,o){if(typeof o=="undefined"){o=0;for(let M=0,A=i.length;M<A;M++)o+=i[M].byteLength}const h=P.alloc(o);let w=0;for(let M=0,A=i.length;M<A;M++){const R=i[M];h.set(R,w),w+=R.byteLength}return h}clone(){const i=P.alloc(this.byteLength);return i.set(this),i}toString(){return r?this.buffer.toString():(C||(C=new TextDecoder),C.decode(this.buffer))}slice(i,o){return new P(this.buffer.subarray(i,o))}set(i,o){if(i instanceof P)this.buffer.set(i.buffer,o);else if(i instanceof Uint8Array)this.buffer.set(i,o);else if(i instanceof ArrayBuffer)this.buffer.set(new Uint8Array(i),o);else if(ArrayBuffer.isView(i))this.buffer.set(new Uint8Array(i.buffer,i.byteOffset,i.byteLength),o);else throw new Error("Unkown argument 'array'")}readUInt32BE(i){return f(this.buffer,i)}writeUInt32BE(i,o){y(this.buffer,i,o)}readUInt32LE(i){return b(this.buffer,i)}writeUInt32LE(i,o){m(this.buffer,i,o)}readUInt8(i){return S(this.buffer,i)}writeUInt8(i,o){t(this.buffer,i,o)}}e.VSBuffer=P;function I(n,i){return n[i+0]<<0>>>0|n[i+1]<<8>>>0}e.readUInt16LE=I;function d(n,i,o){n[o+0]=i&255,i=i>>>8,n[o+1]=i&255}e.writeUInt16LE=d;function f(n,i){return n[i]*2**24+n[i+1]*2**16+n[i+2]*2**8+n[i+3]}e.readUInt32BE=f;function y(n,i,o){n[o+3]=i,i=i>>>8,n[o+2]=i,i=i>>>8,n[o+1]=i,i=i>>>8,n[o]=i}e.writeUInt32BE=y;function b(n,i){return n[i+0]<<0>>>0|n[i+1]<<8>>>0|n[i+2]<<16>>>0|n[i+3]<<24>>>0}e.readUInt32LE=b;function m(n,i,o){n[o+0]=i&255,i=i>>>8,n[o+1]=i&255,i=i>>>8,n[o+2]=i&255,i=i>>>8,n[o+3]=i&255}e.writeUInt32LE=m;function S(n,i){return n[i]}e.readUInt8=S;function t(n,i,o){n[o]=i}e.writeUInt8=t;function g(n){return p.consumeReadable(n,i=>P.concat(i))}e.readableToBuffer=g;function E(n){return p.toReadable(n)}e.bufferToReadable=E;function v(n){return p.consumeStream(n,i=>P.concat(i))}e.streamToBuffer=v;async function k(n){return n.ended?P.concat(n.buffer):P.concat([...n.buffer,await v(n.stream)])}e.bufferedStreamToBuffer=k;function c(n){return p.toStream(n,i=>P.concat(i))}e.bufferToStream=c;function a(n){return p.transform(n,{data:i=>typeof i=="string"?P.fromString(i):P.wrap(i)},i=>P.concat(i))}e.streamToBufferReadableStream=a;function u(n){return p.newWriteableStream(i=>P.concat(i),n)}e.newWriteableBufferStream=u;function s(n,i){return p.prefixedReadable(n,i,o=>P.concat(o))}e.prefixedBufferReadable=s;function l(n,i){return p.prefixedStream(n,i,o=>P.concat(o))}e.prefixedBufferStream=l}),define(Z[25],x([0,1,3]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function r(G){return!G||typeof G!="string"?!0:G.trim().length===0}e.isFalsyOrWhitespace=r;const D=/{(\d+)}/g;function C(G,...ae){return ae.length===0?G:G.replace(D,function(he,ve){const Ie=parseInt(ve,10);return isNaN(Ie)||Ie<0||Ie>=ae.length?he:ae[Ie]})}e.format=C;const P=/{([^}]+)}/g;function I(G,ae){return G.replace(P,(he,ve)=>ae[ve]??he)}e.format2=I;function d(G){return G.replace(/[<>&]/g,function(ae){switch(ae){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ae}})}e.escape=d;function f(G){return G.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=f;function y(G,ae){let he=0;const ve=ae.charCodeAt(0);for(let Ie=G.length-1;Ie>=0;Ie--)G.charCodeAt(Ie)===ve&&he++;return he}e.count=y;function b(G,ae,he="\u2026"){return G.length<=ae?G:`${G.substr(0,ae)}${he}`}e.truncate=b;function m(G,ae=" "){const he=S(G,ae);return t(he,ae)}e.trim=m;function S(G,ae){if(!G||!ae)return G;const he=ae.length;if(he===0||G.length===0)return G;let ve=0;for(;G.indexOf(ae,ve)===ve;)ve=ve+he;return G.substring(ve)}e.ltrim=S;function t(G,ae){if(!G||!ae)return G;const he=ae.length,ve=G.length;if(he===0||ve===0)return G;let Ie=ve,Ce=-1;for(;Ce=G.lastIndexOf(ae,Ie-1),!(Ce===-1||Ce+he!==Ie);){if(Ce===0)return"";Ie=Ce}return G.substring(0,Ie)}e.rtrim=t;function g(G){return G.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=g;function E(G){return G.replace(/\*/g,"")}e.stripWildcards=E;function v(G,ae,he={}){if(!G)throw new Error("Cannot create regex from empty string");ae||(G=f(G)),he.wholeWord&&(/\B/.test(G.charAt(0))||(G="\\b"+G),/\B/.test(G.charAt(G.length-1))||(G=G+"\\b"));let ve="";return he.global&&(ve+="g"),he.matchCase||(ve+="i"),he.multiline&&(ve+="m"),he.unicode&&(ve+="u"),new RegExp(G,ve)}e.createRegExp=v;function k(G){return G.source==="^"||G.source==="^$"||G.source==="$"||G.source==="^\\s*$"?!1:!!(G.exec("")&&G.lastIndex===0)}e.regExpLeadsToEndlessLoop=k;function c(G){return!!G.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=c;function a(G){return(G.global?"g":"")+(G.ignoreCase?"i":"")+(G.multiline?"m":"")+(G.unicode?"u":"")}e.regExpFlags=a;function u(G){return G.split(/\r\n|\r|\n/)}e.splitLines=u;function s(G){for(let ae=0,he=G.length;ae<he;ae++){const ve=G.charCodeAt(ae);if(ve!==32&&ve!==9)return ae}return-1}e.firstNonWhitespaceIndex=s;function l(G,ae=0,he=G.length){for(let ve=ae;ve<he;ve++){const Ie=G.charCodeAt(ve);if(Ie!==32&&Ie!==9)return G.substring(ae,ve)}return G.substring(ae,he)}e.getLeadingWhitespace=l;function n(G,ae=G.length-1){for(let he=ae;he>=0;he--){const ve=G.charCodeAt(he);if(ve!==32&&ve!==9)return he}return-1}e.lastNonWhitespaceIndex=n;function i(G,ae){return G<ae?-1:G>ae?1:0}e.compare=i;function o(G,ae,he=0,ve=G.length,Ie=0,Ce=ae.length){for(;he<ve&&Ie<Ce;he++,Ie++){let Oe=G.charCodeAt(he),Ne=ae.charCodeAt(Ie);if(Oe<Ne)return-1;if(Oe>Ne)return 1}const Te=ve-he,We=Ce-Ie;return Te<We?-1:Te>We?1:0}e.compareSubstring=o;function h(G,ae){return w(G,ae,0,G.length,0,ae.length)}e.compareIgnoreCase=h;function w(G,ae,he=0,ve=G.length,Ie=0,Ce=ae.length){for(;he<ve&&Ie<Ce;he++,Ie++){let Oe=G.charCodeAt(he),Ne=ae.charCodeAt(Ie);if(Oe===Ne)continue;if(Oe>=128||Ne>=128)return o(G.toLowerCase(),ae.toLowerCase(),he,ve,Ie,Ce);M(Oe)&&(Oe-=32),M(Ne)&&(Ne-=32);const je=Oe-Ne;if(je!==0)return je}const Te=ve-he,We=Ce-Ie;return Te<We?-1:Te>We?1:0}e.compareSubstringIgnoreCase=w;function M(G){return G>=97&&G<=122}e.isLowerAsciiLetter=M;function A(G){return G>=65&&G<=90}e.isUpperAsciiLetter=A;function R(G,ae){return G.length===ae.length&&w(G,ae)===0}e.equalsIgnoreCase=R;function T(G,ae){const he=ae.length;return ae.length>G.length?!1:w(G,ae,0,he)===0}e.startsWithIgnoreCase=T;function _(G,ae){let he,ve=Math.min(G.length,ae.length);for(he=0;he<ve;he++)if(G.charCodeAt(he)!==ae.charCodeAt(he))return he;return ve}e.commonPrefixLength=_;function Q(G,ae){let he,ve=Math.min(G.length,ae.length);const Ie=G.length-1,Ce=ae.length-1;for(he=0;he<ve;he++)if(G.charCodeAt(Ie-he)!==ae.charCodeAt(Ce-he))return he;return ve}e.commonSuffixLength=Q;function ne(G){return 55296<=G&&G<=56319}e.isHighSurrogate=ne;function oe(G){return 56320<=G&&G<=57343}e.isLowSurrogate=oe;function X(G,ae){return(G-55296<<10)+(ae-56320)+65536}e.computeCodePoint=X;function O(G,ae,he){const ve=G.charCodeAt(he);if(ne(ve)&&he+1<ae){const Ie=G.charCodeAt(he+1);if(oe(Ie))return X(ve,Ie)}return ve}e.getNextCodePoint=O;function H(G,ae){const he=G.charCodeAt(ae-1);if(oe(he)&&ae>1){const ve=G.charCodeAt(ae-2);if(ne(ve))return X(ve,he)}return he}function q(G,ae){const he=ze.getInstance(),ve=ae,Ie=G.length,Ce=O(G,Ie,ae);ae+=Ce>=65536?2:1;let Te=he.getGraphemeBreakType(Ce);for(;ae<Ie;){const We=O(G,Ie,ae),Oe=he.getGraphemeBreakType(We);if(Fe(Te,Oe))break;ae+=We>=65536?2:1,Te=Oe}return ae-ve}e.nextCharLength=q;function Y(G,ae){const he=ze.getInstance(),ve=ae,Ie=H(G,ae);ae-=Ie>=65536?2:1;let Ce=he.getGraphemeBreakType(Ie);for(;ae>0;){const Te=H(G,ae),We=he.getGraphemeBreakType(Te);if(Fe(We,Ce))break;ae-=Te>=65536?2:1,Ce=We}return ve-ae}e.prevCharLength=Y;function $(G,ae){const he=ze.getInstance(),ve=G.length,Ie=ae,Ce=O(G,ve,ae),Te=he.getGraphemeBreakType(Ce);ae+=Ce>=65536?2:1;let We=Te;for(;ae<ve;){const Ne=O(G,ve,ae),je=he.getGraphemeBreakType(Ne);if(Fe(We,je))break;ae+=Ne>=65536?2:1,We=je}const Oe=ae;for(ae=Ie,We=Te;ae>0;){const Ne=H(G,ae),je=he.getGraphemeBreakType(Ne);if(Fe(je,We))break;ae-=Ne>=65536?2:1,We=je}return[ae,Oe]}function K(G,ae){return ae>0&&oe(G.charCodeAt(ae))?$(G,ae-1):$(G,ae)}e.getCharContainingOffset=K;const te=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function B(G){return te.test(G)}e.containsRTL=B;const L=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFF0]|\uD83E[\uDD00-\uDDFF\uDE70-\uDEF6])/;function W(G){return L.test(G)}e.containsEmoji=W;const F=/^[\t\n\r\x20-\x7E]*$/;function N(G){return F.test(G)}e.isBasicASCII=N,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function V(G){return e.UNUSUAL_LINE_TERMINATORS.test(G)}e.containsUnusualLineTerminators=V;function U(G){for(let ae=0,he=G.length;ae<he;ae++)if(z(G.charCodeAt(ae)))return!0;return!1}e.containsFullWidthCharacter=U;function z(G){return G>=11904&&G<=55215||G>=63744&&G<=64255||G>=65281&&G<=65374}e.isFullWidthCharacter=z;function ee(G){return G>=127462&&G<=127487||G===8986||G===8987||G===9200||G===9203||G>=9728&&G<=10175||G===11088||G===11093||G>=127744&&G<=128591||G>=128640&&G<=128764||G>=128992&&G<=129008||G>=129280&&G<=129535||G>=129648&&G<=129782}e.isEmojiImprecise=ee;function re(G,ae){if(G.length<ae)return G;const he=/\b/g;let ve=0;for(;he.test(G)&&!(G.length-he.lastIndex<ae);)ve=he.lastIndex,he.lastIndex+=1;return G.substring(ve).replace(/^\s/,"")}e.lcut=re;const se=/\x1B\x5B[12]?K/g,J=/\x1b\[\d+m/g,ce=/\x1b\[0?m/g;function le(G){return G&&(G=G.replace(se,""),G=G.replace(J,""),G=G.replace(ce,"")),G}e.removeAnsiEscapeCodes=le,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ue(G){return!!(G&&G.length>0&&G.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ue;function me(G){return ue(G)?G.substr(1):G}e.stripUTF8BOM=me;function Ee(G,ae){if(!G||!ae||G.length<ae.length)return!1;const he=ae.length,ve=G.toLowerCase();let Ie=0,Ce=-1;for(;Ie<he;){const Te=ve.indexOf(ae[Ie],Ce+1);if(Te<0)return!1;Ce=Te,Ie++}return!0}e.fuzzyContains=Ee;function de(G,ae=!1){return G?(ae&&(G=G.replace(/\\./g,"")),G.toLowerCase()!==G):!1}e.containsUppercaseCharacter=de;function ge(G){return G.charAt(0).toUpperCase()+G.slice(1)}e.uppercaseFirstLetter=ge;function pe(G,ae=1){if(ae===0)return"";let he=-1;do he=G.indexOf(`
`,he+1),ae--;while(ae>0&&he>=0);return he===-1?G:(G[he-1]==="\r"&&he--,G.substr(0,he))}e.getNLines=pe;function ke(G){const ae=90-65+1;return G=G%(2*ae),G<ae?String.fromCharCode(97+G):String.fromCharCode(65+G-ae)}e.singleLetterHash=ke;function Re(G){return ze.getInstance().getGraphemeBreakType(G)}e.getGraphemeBreakType=Re;function Fe(G,ae){return G===0?ae!==5&&ae!==7:G===2&&ae===3?!1:G===4||G===2||G===3||ae===4||ae===2||ae===3?!0:!(G===8&&(ae===8||ae===9||ae===11||ae===12)||(G===11||G===9)&&(ae===9||ae===10)||(G===12||G===10)&&ae===10||ae===5||ae===13||ae===7||G===1||G===13&&ae===14||G===6&&ae===6)}e.breakBetweenGraphemeBreakType=Fe;var $e;(function(G){G[G.Other=0]="Other",G[G.Prepend=1]="Prepend",G[G.CR=2]="CR",G[G.LF=3]="LF",G[G.Control=4]="Control",G[G.Extend=5]="Extend",G[G.Regional_Indicator=6]="Regional_Indicator",G[G.SpacingMark=7]="SpacingMark",G[G.L=8]="L",G[G.V=9]="V",G[G.T=10]="T",G[G.LV=11]="LV",G[G.LVT=12]="LVT",G[G.ZWJ=13]="ZWJ",G[G.Extended_Pictographic=14]="Extended_Pictographic"})($e=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ze{constructor(){this._data=Qe()}static getInstance(){return ze._INSTANCE||(ze._INSTANCE=new ze),ze._INSTANCE}getGraphemeBreakType(ae){if(ae<32)return ae===10?3:ae===13?2:4;if(ae<127)return 0;const he=this._data,ve=he.length/3;let Ie=1;for(;Ie<=ve;)if(ae<he[3*Ie])Ie=2*Ie;else if(ae>he[3*Ie+1])Ie=2*Ie+1;else return he[3*Ie+2];return 0}}ze._INSTANCE=null;function Qe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ge(G,ae){if(G===0)return 0;const he=gt(G,ae);if(he!==void 0)return he;const ve=H(ae,G);return G-=Je(ve),G}e.getLeftDeleteOffset=Ge;function gt(G,ae){let he=H(ae,G);for(G-=Je(he);at(he)||he===65039||he===8419;){if(G===0)return;he=H(ae,G),G-=Je(he)}if(!!ee(he)){if(G>=0){const ve=H(ae,G);ve===8205&&(G-=Je(ve))}return G}}function Je(G){return G>=65536?2:1}function at(G){return 127995<=G&&G<=127999}var ct;(function(G){G[G.zwj=8205]="zwj",G[G.emojiVariantSelector=65039]="emojiVariantSelector",G[G.enclosingKeyCap=8419]="enclosingKeyCap"})(ct||(ct={})),e.noBreakWhitespace="\xA0";class Ve{static getData(){return JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,40,10088,40,10098,40,12308,40,64830,40,65341,41,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,124,8739,124,9213,124,65512,124,1633,124,1777,124,66336,124,125127,124,120783,124,120793,124,120803,124,120813,124,120823,124,130033,124,65321,124,8544,124,8464,124,8465,124,119816,124,119868,124,119920,124,120024,124,120128,124,120180,124,120232,124,120284,124,120336,124,120388,124,120440,124,406,124,65356,124,8572,124,8467,124,119845,124,119897,124,119949,124,120001,124,120053,124,120105,124,120157,124,120209,124,120261,124,120313,124,120365,124,120417,124,120469,124,448,124,120496,124,120554,124,120612,124,120670,124,120728,124,11410,124,1030,124,1216,124,1493,124,1503,124,1575,124,126464,124,126592,124,65166,124,65165,124,1994,124,11599,124,5825,124,42226,124,93992,124,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90],"_default":[160,32,8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"cs":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89],"de":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89],"es":[8211,45,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"fr":[65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"it":[160,32,8211,45,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"ko":[8211,45,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"pl":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"pt-BR":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"qps-ploc":[160,32,8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"ru":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,124,1009,112,215,120],"tr":[160,32,8211,45,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"zh-hans":[65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"zh-hant":[8211,45,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89]}')}static getConfusablesForCurrentLocale(){if(!Ve.map){let ve=function(Te){const We=new Map;for(let Oe=0;Oe<Te.length;Oe+=2)We.set(Te[Oe],Te[Oe+1]);return We};const ae=Ve.getData();let he=p.locale;(!he||!(he in ae))&&(he=p.language),(!he||!(he in ae))&&(he="_default");const Ie=ve(ae._common),Ce=ve(ae[he]);for(const[Te,We]of Ce)Ie.set(Te,We);Ve.map=Ie}return Ve.map}static isAmbiguous(ae){return Ve.getConfusablesForCurrentLocale().has(ae)}static getPrimaryConfusable(ae){return Ve.getConfusablesForCurrentLocale().get(ae)}static getPrimaryConfusableCodePoints(){return new Set(Ve.getConfusablesForCurrentLocale().keys())}}e.AmbiguousCharacters=Ve;class He{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(He.getRawData())),this._data}static isInvisibleCharacter(ae){return He.getData().has(ae)}static get codePoints(){return He.getData()}}e.InvisibleCharacters=He,He._data=void 0}),define(Z[81],x([0,1,25]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function r(v){return D(v,0)}e.hash=r;function D(v,k){switch(typeof v){case"object":return v===null?C(349,k):Array.isArray(v)?d(v,k):f(v,k);case"string":return I(v,k);case"boolean":return P(v,k);case"number":return C(v,k);case"undefined":return C(937,k);default:return C(617,k)}}e.doHash=D;function C(v,k){return(k<<5)-k+v|0}e.numberHash=C;function P(v,k){return C(v?433:863,k)}function I(v,k){k=C(149417,k);for(let c=0,a=v.length;c<a;c++)k=C(v.charCodeAt(c),k);return k}e.stringHash=I;function d(v,k){return k=C(104579,k),v.reduce((c,a)=>D(a,c),k)}function f(v,k){return k=C(181387,k),Object.keys(v).sort().reduce((c,a)=>(c=I(a,c),D(v[a],c)),k)}class y{constructor(){this._value=0}get value(){return this._value}hash(k){return this._value=D(k,this._value),this._value}}e.Hasher=y;var b;(function(v){v[v.BLOCK_SIZE=64]="BLOCK_SIZE",v[v.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(b||(b={}));function m(v,k,c=32){const a=c-k,u=~((1<<a)-1);return(v<<k|(u&v)>>>a)>>>0}function S(v,k=0,c=v.byteLength,a=0){for(let u=0;u<c;u++)v[k+u]=a}function t(v,k,c="0"){for(;v.length<k;)v=c+v;return v}function g(v,k=32){return v instanceof ArrayBuffer?Array.from(new Uint8Array(v)).map(c=>c.toString(16).padStart(2,"0")).join(""):t((v>>>0).toString(16),k/4)}e.toHexString=g;class E{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(k){const c=k.length;if(c===0)return;const a=this._buff;let u=this._buffLen,s=this._leftoverHighSurrogate,l,n;for(s!==0?(l=s,n=-1,s=0):(l=k.charCodeAt(0),n=0);;){let i=l;if(p.isHighSurrogate(l))if(n+1<c){const o=k.charCodeAt(n+1);p.isLowSurrogate(o)?(n++,i=p.computeCodePoint(l,o)):i=65533}else{s=l;break}else p.isLowSurrogate(l)&&(i=65533);if(u=this._push(a,u,i),n++,n<c)l=k.charCodeAt(n);else break}this._buffLen=u,this._leftoverHighSurrogate=s}_push(k,c,a){return a<128?k[c++]=a:a<2048?(k[c++]=192|(a&1984)>>>6,k[c++]=128|(a&63)>>>0):a<65536?(k[c++]=224|(a&61440)>>>12,k[c++]=128|(a&4032)>>>6,k[c++]=128|(a&63)>>>0):(k[c++]=240|(a&1835008)>>>18,k[c++]=128|(a&258048)>>>12,k[c++]=128|(a&4032)>>>6,k[c++]=128|(a&63)>>>0),c>=64&&(this._step(),c-=64,this._totalLen+=64,k[0]=k[64+0],k[1]=k[64+1],k[2]=k[64+2]),c}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),g(this._h0)+g(this._h1)+g(this._h2)+g(this._h3)+g(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,S(this._buff,this._buffLen),this._buffLen>56&&(this._step(),S(this._buff));const k=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(k/4294967296),!1),this._buffDV.setUint32(60,k%4294967296,!1),this._step()}_step(){const k=E._bigBlock32,c=this._buffDV;for(let w=0;w<64;w+=4)k.setUint32(w,c.getUint32(w,!1),!1);for(let w=64;w<320;w+=4)k.setUint32(w,m(k.getUint32(w-12,!1)^k.getUint32(w-32,!1)^k.getUint32(w-56,!1)^k.getUint32(w-64,!1),1),!1);let a=this._h0,u=this._h1,s=this._h2,l=this._h3,n=this._h4,i,o,h;for(let w=0;w<80;w++)w<20?(i=u&s|~u&l,o=1518500249):w<40?(i=u^s^l,o=1859775393):w<60?(i=u&s|u&l|s&l,o=2400959708):(i=u^s^l,o=3395469782),h=m(a,5)+i+n+o+k.getUint32(w*4,!1)&4294967295,n=l,l=s,s=m(u,30),u=a,a=h;this._h0=this._h0+a&4294967295,this._h1=this._h1+u&4294967295,this._h2=this._h2+s&4294967295,this._h3=this._h3+l&4294967295,this._h4=this._h4+n&4294967295}}e.StringSHA1=E,E._bigBlock32=new DataView(new ArrayBuffer(320))});var kt=this&&this.__classPrivateFieldSet||function(j,e,p,r,D){if(r==="m")throw new TypeError("Private method is not writable");if(r==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?j!==e||!D:!e.has(j))throw new TypeError("Cannot write private member to an object whose class did not declare it");return r==="a"?D.call(j,p):D?D.value=p:e.set(j,p),p},Ke=this&&this.__classPrivateFieldGet||function(j,e,p,r){if(p==="a"&&!r)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?j!==e||!r:!e.has(j))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?r:p==="a"?r.call(j):r?r.value:e.get(j)};define(Z[39],x([0,1,30,25]),function(j,e,p,r){"use strict";var D,C,P;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function I(n,i,o){let h=n.get(i);return h===void 0&&(h=o,n.set(i,h)),h}e.getOrSet=I;function d(n){const i=[];return n.forEach((o,h)=>{i.push(`${h} => ${o}`)}),`Map(${n.size}) {${i.join(", ")}}`}e.mapToString=d;function f(n){const i=[];return n.forEach(o=>{i.push(o)}),`Set(${n.size}) {${i.join(", ")}}`}e.setToString=f;class y{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const o=i.charCodeAt(0),h=this._value.charCodeAt(this._pos);return o-h}value(){return this._value[this._pos]}}e.StringIterator=y;class b{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?(0,r.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,r.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=b;class m{constructor(i=!0,o=!0){this._splitOnBackslash=i,this._caseSensitive=o}reset(i){this._from=0,this._to=0,this._value=i,this._valueLen=i.length;for(let o=i.length-1;o>=0;o--,this._valueLen--){const h=this._value.charCodeAt(o);if(!(h===47||this._splitOnBackslash&&h===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let i=!0;for(;this._to<this._valueLen;this._to++){const o=this._value.charCodeAt(this._to);if(o===47||this._splitOnBackslash&&o===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?(0,r.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,r.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=m;var S;(function(n){n[n.Scheme=1]="Scheme",n[n.Authority=2]="Authority",n[n.Path=3]="Path",n[n.Query=4]="Query",n[n.Fragment=5]="Fragment"})(S||(S={}));class t{constructor(i){this._ignorePathCasing=i,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new m(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return(0,r.compareIgnoreCase)(i,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,r.compareIgnoreCase)(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return(0,r.compare)(i,this._value.query);if(this._states[this._stateIdx]===5)return(0,r.compare)(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=t;class g{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const i=this.right;return this.right=i.left,i.left=this,this.updateHeight(),i.updateHeight(),i}rotateRight(){const i=this.left;return this.left=i.right,i.right=this,this.updateHeight(),i.updateHeight(),i}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var E;(function(n){n[n.Left=-1]="Left",n[n.Mid=0]="Mid",n[n.Right=1]="Right"})(E||(E={}));class v{constructor(i){this._iter=i}static forUris(i=()=>!1){return new v(new t(i))}static forPaths(){return new v(new m)}static forStrings(){return new v(new y)}static forConfigKeys(){return new v(new b)}clear(){this._root=void 0}fill(i,o){if(o){const h=o.slice(0);(0,p.shuffle)(h);for(let w of h)this.set(w,i)}else{const h=i.slice(0);(0,p.shuffle)(h);for(let w of h)this.set(w[0],w[1])}}set(i,o){const h=this._iter.reset(i);let w;this._root||(this._root=new g,this._root.segment=h.value());const M=[];for(w=this._root;;){const R=h.cmp(w.segment);if(R>0)w.left||(w.left=new g,w.left.segment=h.value()),M.push([-1,w]),w=w.left;else if(R<0)w.right||(w.right=new g,w.right.segment=h.value()),M.push([1,w]),w=w.right;else if(h.hasNext())h.next(),w.mid||(w.mid=new g,w.mid.segment=h.value()),M.push([0,w]),w=w.mid;else break}const A=w.value;w.value=o,w.key=i;for(let R=M.length-1;R>=0;R--){const T=M[R][1];T.updateHeight();const _=T.balanceFactor();if(_<-1||_>1){const Q=M[R][0],ne=M[R+1][0];if(Q===1&&ne===1)M[R][1]=T.rotateLeft();else if(Q===-1&&ne===-1)M[R][1]=T.rotateRight();else if(Q===1&&ne===-1)T.right=M[R+1][1]=M[R+1][1].rotateRight(),M[R][1]=T.rotateLeft();else if(Q===-1&&ne===1)T.left=M[R+1][1]=M[R+1][1].rotateLeft(),M[R][1]=T.rotateRight();else throw new Error;if(R>0)switch(M[R-1][0]){case-1:M[R-1][1].left=M[R][1];break;case 1:M[R-1][1].right=M[R][1];break;case 0:M[R-1][1].mid=M[R][1];break}else this._root=M[0][1]}}return A}get(i){return this._getNode(i)?.value}_getNode(i){const o=this._iter.reset(i);let h=this._root;for(;h;){const w=o.cmp(h.segment);if(w>0)h=h.left;else if(w<0)h=h.right;else if(o.hasNext())o.next(),h=h.mid;else break}return h}has(i){const o=this._getNode(i);return!(o?.value===void 0&&o?.mid===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,o){const h=this._iter.reset(i),w=[];let M=this._root;for(;M;){const A=h.cmp(M.segment);if(A>0)w.push([-1,M]),M=M.left;else if(A<0)w.push([1,M]),M=M.right;else if(h.hasNext())h.next(),w.push([0,M]),M=M.mid;else break}if(!!M){if(o?(M.left=void 0,M.mid=void 0,M.right=void 0,M.height=1):(M.key=void 0,M.value=void 0),!M.mid&&!M.value)if(M.left&&M.right){const A=this._min(M.right),{key:R,value:T,segment:_}=A;this._delete(A.key,!1),M.key=R,M.value=T,M.segment=_}else{const A=M.left??M.right;if(w.length>0){const[R,T]=w[w.length-1];switch(R){case-1:T.left=A;break;case 0:T.mid=A;break;case 1:T.right=A;break}}else this._root=A}for(let A=w.length-1;A>=0;A--){const R=w[A][1];R.updateHeight();const T=R.balanceFactor();if(T>1?(R.right.balanceFactor()>=0||(R.right=R.right.rotateRight()),w[A][1]=R.rotateLeft()):T<-1&&(R.left.balanceFactor()<=0||(R.left=R.left.rotateLeft()),w[A][1]=R.rotateRight()),A>0)switch(w[A-1][0]){case-1:w[A-1][1].left=w[A][1];break;case 1:w[A-1][1].right=w[A][1];break;case 0:w[A-1][1].mid=w[A][1];break}else this._root=w[0][1]}}}_min(i){for(;i.left;)i=i.left;return i}findSubstr(i){const o=this._iter.reset(i);let h=this._root,w;for(;h;){const M=o.cmp(h.segment);if(M>0)h=h.left;else if(M<0)h=h.right;else if(o.hasNext())o.next(),w=h.value||w,h=h.mid;else break}return h&&h.value||w}findSuperstr(i){const o=this._iter.reset(i);let h=this._root;for(;h;){const w=o.cmp(h.segment);if(w>0)h=h.left;else if(w<0)h=h.right;else if(o.hasNext())o.next(),h=h.mid;else return h.mid?this._entries(h.mid):void 0}}forEach(i){for(const[o,h]of this)i(h,o)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(i){!i||(i.left&&(yield*this._entries(i.left)),i.value&&(yield[i.key,i.value]),i.mid&&(yield*this._entries(i.mid)),i.right&&(yield*this._entries(i.right)))}_isBalanced(){const i=o=>{if(!o)return!0;const h=o.balanceFactor();return h<-1||h>1?!1:i(o.left)&&i(o.right)};return i(this._root)}}e.TernarySearchTree=v;class k{constructor(i,o){this.uri=i,this.value=o}}class c{constructor(i,o){this[D]="ResourceMap",i instanceof c?(this.map=new Map(i.map),this.toKey=o??c.defaultToKey):(this.map=new Map,this.toKey=i??c.defaultToKey)}set(i,o){return this.map.set(this.toKey(i),new k(i,o)),this}get(i){return this.map.get(this.toKey(i))?.value}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,o){typeof o!="undefined"&&(i=i.bind(o));for(let[h,w]of this.map)i(w.value,w.uri,this)}*values(){for(let i of this.map.values())yield i.value}*keys(){for(let i of this.map.values())yield i.uri}*entries(){for(let i of this.map.values())yield[i.uri,i.value]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(let[,i]of this.map)yield[i.uri,i.value]}}e.ResourceMap=c,c.defaultToKey=n=>n.toString();var a;(function(n){n[n.None=0]="None",n[n.AsOld=1]="AsOld",n[n.AsNew=2]="AsNew"})(a=e.Touch||(e.Touch={}));class u{constructor(){this[C]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(i){return this._map.has(i)}get(i,o=0){const h=this._map.get(i);if(!!h)return o!==0&&this.touch(h,o),h.value}set(i,o,h=0){let w=this._map.get(i);if(w)w.value=o,h!==0&&this.touch(w,h);else{switch(w={key:i,value:o,next:void 0,previous:void 0},h){case 0:this.addItemLast(w);break;case 1:this.addItemFirst(w);break;case 2:this.addItemLast(w);break;default:this.addItemLast(w);break}this._map.set(i,w),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const o=this._map.get(i);if(!!o)return this._map.delete(i),this.removeItem(o),this._size--,o.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}forEach(i,o){const h=this._state;let w=this._head;for(;w;){if(o?i.bind(o)(w.value,w.key,this):i(w.value,w.key,this),this._state!==h)throw new Error("LinkedMap got modified during iteration.");w=w.next}}keys(){const i=this,o=this._state;let h=this._head;const w={[Symbol.iterator](){return w},next(){if(i._state!==o)throw new Error("LinkedMap got modified during iteration.");if(h){const M={value:h.key,done:!1};return h=h.next,M}else return{value:void 0,done:!0}}};return w}values(){const i=this,o=this._state;let h=this._head;const w={[Symbol.iterator](){return w},next(){if(i._state!==o)throw new Error("LinkedMap got modified during iteration.");if(h){const M={value:h.value,done:!1};return h=h.next,M}else return{value:void 0,done:!0}}};return w}entries(){const i=this,o=this._state;let h=this._head;const w={[Symbol.iterator](){return w},next(){if(i._state!==o)throw new Error("LinkedMap got modified during iteration.");if(h){const M={value:[h.key,h.value],done:!1};return h=h.next,M}else return{value:void 0,done:!0}}};return w}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(i>=this.size)return;if(i===0){this.clear();return}let o=this._head,h=this.size;for(;o&&h>i;)this._map.delete(o.key),o=o.next,h--;this._head=o,this._size=h,o&&(o.previous=void 0),this._state++}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const o=i.next,h=i.previous;if(!o||!h)throw new Error("Invalid list");o.previous=h,h.next=o}i.next=void 0,i.previous=void 0,this._state++}touch(i,o){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(i===this._head)return;const h=i.next,w=i.previous;i===this._tail?(w.next=void 0,this._tail=w):(h.previous=w,w.next=h),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(o===2){if(i===this._tail)return;const h=i.next,w=i.previous;i===this._head?(h.previous=void 0,this._head=h):(h.previous=w,w.next=h),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((o,h)=>{i.push([h,o])}),i}fromJSON(i){this.clear();for(const[o,h]of i)this.set(o,h)}}e.LinkedMap=u;class s extends u{constructor(i,o=1){super();this._limit=i,this._ratio=Math.min(Math.max(0,o),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,o=2){return super.get(i,o)}peek(i){return super.get(i,0)}set(i,o){return super.set(i,o,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=s;class l{constructor(i){P.set(this,void 0),kt(this,P,i,"f")}get size(){return Ke(this,P,"f").size}forEach(i,o){Ke(this,P,"f").forEach(i,o)}get(i){return Ke(this,P,"f").get(i)}has(i){return Ke(this,P,"f").has(i)}entries(){return Ke(this,P,"f").entries()}keys(){return Ke(this,P,"f").keys()}values(){return Ke(this,P,"f").values()}[(P=new WeakMap,Symbol.iterator)](){return Ke(this,P,"f").entries()}}e.ReadonlyMapView=l}),define(Z[70],x([0,1,39]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const r=new p.LRUCache(1e4);function D(f){return d(f,"NFC",r)}e.normalizeNFC=D;const C=new p.LRUCache(1e4);function P(f){return d(f,"NFD",C)}e.normalizeNFD=P;const I=/[^\u0000-\u0080]/;function d(f,y,b){if(!f)return f;const m=b.get(f);if(m)return m;let S;return I.test(f)?S=f.normalize(y):S=f,b.set(f,S),S}e.removeAccents=function(){const f=/[\u0300-\u036f]/g;return function(y){return P(y).replace(f,"")}}()}),define(Z[13],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function p(M){return Array.isArray(M)}e.isArray=p;function r(M){return typeof M=="string"}e.isString=r;function D(M){return Array.isArray(M)&&M.every(A=>r(A))}e.isStringArray=D;function C(M){return typeof M=="object"&&M!==null&&!Array.isArray(M)&&!(M instanceof RegExp)&&!(M instanceof Date)}e.isObject=C;function P(M){return typeof M=="number"&&!isNaN(M)}e.isNumber=P;function I(M){return!!M&&typeof M[Symbol.iterator]=="function"}e.isIterable=I;function d(M){return M===!0||M===!1}e.isBoolean=d;function f(M){return typeof M=="undefined"}e.isUndefined=f;function y(M){return!b(M)}e.isDefined=y;function b(M){return f(M)||M===null}e.isUndefinedOrNull=b;function m(M,A){if(!M)throw new Error(A?`Unexpected type, expected '${A}'`:"Unexpected type")}e.assertType=m;function S(M){if(b(M))throw new Error("Assertion Failed: argument is undefined or null");return M}e.assertIsDefined=S;function t(...M){const A=[];for(let R=0;R<M.length;R++){const T=M[R];if(b(T))throw new Error(`Assertion Failed: argument at index ${R} is undefined or null`);A.push(T)}return A}e.assertAllDefined=t;const g=Object.prototype.hasOwnProperty;function E(M){if(!C(M))return!1;for(let A in M)if(g.call(M,A))return!1;return!0}e.isEmptyObject=E;function v(M){return typeof M=="function"}e.isFunction=v;function k(...M){return M.length>0&&M.every(v)}e.areFunctions=k;function c(M,A){const R=Math.min(M.length,A.length);for(let T=0;T<R;T++)a(M[T],A[T])}e.validateConstraints=c;function a(M,A){if(r(A)){if(typeof M!==A)throw new Error(`argument does not match constraint: typeof ${A}`)}else if(v(A)){try{if(M instanceof A)return}catch{}if(!b(M)&&M.constructor===A||A.length===1&&A.call(void 0,M)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=a;function u(M){let A=[],R=Object.getPrototypeOf(M);for(;Object.prototype!==R;)A=A.concat(Object.getOwnPropertyNames(R)),R=Object.getPrototypeOf(R);return A}e.getAllPropertyNames=u;function s(M){const A=[];for(const R of u(M))typeof M[R]=="function"&&A.push(R);return A}e.getAllMethodNames=s;function l(M,A){const R=_=>function(){const Q=Array.prototype.slice.call(arguments,0);return A(_,Q)};let T={};for(const _ of M)T[_]=R(_);return T}e.createProxyObject=l;function n(M){return M===null?void 0:M}e.withNullAsUndefined=n;function i(M){return typeof M=="undefined"?null:M}e.withUndefinedAsNull=i;function o(M){return class{constructor(){return new Proxy({},{get(A,R){if(A[R])return A[R];throw new Error(`Not Implemented: ${M}->${String(R)}`)}})}}}e.NotImplementedProxy=o;function h(M,A="Unreachable"){throw new Error(A)}e.assertNever=h;function w(M){return!!M&&typeof M.then=="function"&&typeof M.catch=="function"}e.isPromise=w}),define(Z[32],x([0,1,8,3,25,13]),function(j,e,p,r,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function P(n){return n===47||n===92}e.isPathSeparator=P;function I(n){return n.replace(/[\\/]/g,p.posix.sep)}e.toSlashes=I;function d(n){return n.indexOf("/")===-1&&(n=I(n)),/^[a-zA-Z]:(\/|$)/.test(n)&&(n="/"+n),n}e.toPosixPath=d;function f(n,i=p.posix.sep){if(!n)return"";const o=n.length,h=n.charCodeAt(0);if(P(h)){if(P(n.charCodeAt(1))&&!P(n.charCodeAt(2))){let M=3;const A=M;for(;M<o&&!P(n.charCodeAt(M));M++);if(A!==M&&!P(n.charCodeAt(M+1))){for(M+=1;M<o;M++)if(P(n.charCodeAt(M)))return n.slice(0,M+1).replace(/[\\/]/g,i)}}return i}else if(v(h)&&n.charCodeAt(1)===58)return P(n.charCodeAt(2))?n.slice(0,2)+i:n.slice(0,2);let w=n.indexOf("://");if(w!==-1){for(w+=3;w<o;w++)if(P(n.charCodeAt(w)))return n.slice(0,w+1)}return""}e.getRoot=f;function y(n){if(!r.isWindows||!n||n.length<5)return!1;let i=n.charCodeAt(0);if(i!==92||(i=n.charCodeAt(1),i!==92))return!1;let o=2;const h=o;for(;o<n.length&&(i=n.charCodeAt(o),i!==92);o++);return!(h===o||(i=n.charCodeAt(o+1),isNaN(i)||i===92))}e.isUNC=y;const b=/[\\/:\*\?"<>\|]/g,m=/[\\/]/g,S=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function t(n,i=r.isWindows){const o=i?b:m;return!(!n||n.length===0||/^\s+$/.test(n)||(o.lastIndex=0,o.test(n))||i&&S.test(n)||n==="."||n===".."||i&&n[n.length-1]==="."||i&&n.length!==n.trim().length||n.length>255)}e.isValidBasename=t;function g(n,i,o){const h=n===i;return!o||h?h:!n||!i?!1:(0,D.equalsIgnoreCase)(n,i)}e.isEqual=g;function E(n,i,o,h=p.sep){if(n===i)return!0;if(!n||!i||i.length>n.length)return!1;if(o){if(!(0,D.startsWithIgnoreCase)(n,i))return!1;if(i.length===n.length)return!0;let M=i.length;return i.charAt(i.length-1)===h&&M--,n.charAt(M)===h}return i.charAt(i.length-1)!==h&&(i+=h),n.indexOf(i)===0}e.isEqualOrParent=E;function v(n){return n>=65&&n<=90||n>=97&&n<=122}e.isWindowsDriveLetter=v;function k(n,i){return r.isWindows&&n.endsWith(":")&&(n+=p.sep),(0,p.isAbsolute)(n)||(n=(0,p.join)(i,n)),n=(0,p.normalize)(n),r.isWindows?(n=(0,D.rtrim)(n,p.sep),n.endsWith(":")&&(n+=p.sep)):(n=(0,D.rtrim)(n,p.sep),n||(n=p.sep)),n}e.sanitizeFilePath=k;function c(n){const i=(0,p.normalize)(n);return r.isWindows?n.length>3?!1:a(i)&&(n.length===2||i.charCodeAt(2)===92):i===p.posix.sep}e.isRootOrDriveLetter=c;function a(n,i){return(i!==void 0?i:r.isWindows)?v(n.charCodeAt(0))&&n.charCodeAt(1)===58:!1}e.hasDriveLetter=a;function u(n){return a(n)?n[0]:void 0}e.getDriveLetter=u;function s(n,i,o){return i.length>n.length?-1:n===i?0:(o&&(n=n.toLowerCase(),i=i.toLowerCase()),n.indexOf(i))}e.indexOfPath=s;function l(n){const i=n.split(":");let o,h,w;if(i.forEach(M=>{const A=Number(M);(0,C.isNumber)(A)?h===void 0?h=A:w===void 0&&(w=A):o=o?[o,M].join(":"):M}),!o)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:o,line:h!==void 0?h:void 0,column:w!==void 0?w:h!==void 0?1:void 0}}e.parseLineAndColumnAware=l}),define(Z[47],x([0,1,13]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function r(g){if(!g||typeof g!="object"||g instanceof RegExp)return g;const E=Array.isArray(g)?[]:{};return Object.keys(g).forEach(v=>{g[v]&&typeof g[v]=="object"?E[v]=r(g[v]):E[v]=g[v]}),E}e.deepClone=r;function D(g){if(!g||typeof g!="object")return g;const E=[g];for(;E.length>0;){const v=E.shift();Object.freeze(v);for(const k in v)if(C.call(v,k)){const c=v[k];typeof c=="object"&&!Object.isFrozen(c)&&E.push(c)}}return g}e.deepFreeze=D;const C=Object.prototype.hasOwnProperty;function P(g,E){return I(g,E,new Set)}e.cloneAndChange=P;function I(g,E,v){if((0,p.isUndefinedOrNull)(g))return g;const k=E(g);if(typeof k!="undefined")return k;if((0,p.isArray)(g)){const c=[];for(const a of g)c.push(I(a,E,v));return c}if((0,p.isObject)(g)){if(v.has(g))throw new Error("Cannot clone recursive data-structure");v.add(g);const c={};for(let a in g)C.call(g,a)&&(c[a]=I(g[a],E,v));return v.delete(g),c}return g}function d(g,E,v=!0){return(0,p.isObject)(g)?((0,p.isObject)(E)&&Object.keys(E).forEach(k=>{k in g?v&&((0,p.isObject)(g[k])&&(0,p.isObject)(E[k])?d(g[k],E[k],v):g[k]=E[k]):g[k]=E[k]}),g):E}e.mixin=d;function f(g,E){if(g===E)return!0;if(g==null||E===null||E===void 0||typeof g!=typeof E||typeof g!="object"||Array.isArray(g)!==Array.isArray(E))return!1;let v,k;if(Array.isArray(g)){if(g.length!==E.length)return!1;for(v=0;v<g.length;v++)if(!f(g[v],E[v]))return!1}else{const c=[];for(k in g)c.push(k);c.sort();const a=[];for(k in E)a.push(k);if(a.sort(),!f(c,a))return!1;for(v=0;v<c.length;v++)if(!f(g[c[v]],E[c[v]]))return!1}return!0}e.equals=f;function y(g){const E=new Set;return JSON.stringify(g,(v,k)=>{if((0,p.isObject)(k)||Array.isArray(k)){if(E.has(k))return"[Circular]";E.add(k)}return k})}e.safeStringify=y;function b(g,E,v){const k=E(g);return typeof k=="undefined"?v:k}e.getOrDefault=b;function m(g,E){const v=Object.create(null);return!g||!E||Object.keys(E).forEach(c=>{const a=g[c],u=E[c];f(a,u)||(v[c]=u)}),v}e.distinct=m;function S(g,E){const v=E.toLowerCase(),k=Object.keys(g).find(c=>c.toLowerCase()===v);return k?g[k]:g[E]}e.getCaseInsensitive=S;function t(g,E){const v=Object.create(null);for(const[k,c]of Object.entries(g))E(k,c)&&(v[k]=c);return v}e.filter=t}),define(Z[7],x([0,1,8,3]),function(j,e,p,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const D=/^\w[\w\d+.-]*$/,C=/^\//,P=/^\/\//;function I(n,i){if(!n.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${n.authority}", path: "${n.path}", query: "${n.query}", fragment: "${n.fragment}"}`);if(n.scheme&&!D.test(n.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(n.path){if(n.authority){if(!C.test(n.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(P.test(n.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function d(n,i){return!n&&!i?"file":n}function f(n,i){switch(n){case"https":case"http":case"file":i?i[0]!==b&&(i=b+i):i=b;break}return i}const y="",b="/",m=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class S{constructor(i,o,h,w,M,A=!1){typeof i=="object"?(this.scheme=i.scheme||y,this.authority=i.authority||y,this.path=i.path||y,this.query=i.query||y,this.fragment=i.fragment||y):(this.scheme=d(i,A),this.authority=o||y,this.path=f(this.scheme,h||y),this.query=w||y,this.fragment=M||y,I(this,A))}static isUri(i){return i instanceof S?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}get fsPath(){return c(this,!1)}with(i){if(!i)return this;let{scheme:o,authority:h,path:w,query:M,fragment:A}=i;return o===void 0?o=this.scheme:o===null&&(o=y),h===void 0?h=this.authority:h===null&&(h=y),w===void 0?w=this.path:w===null&&(w=y),M===void 0?M=this.query:M===null&&(M=y),A===void 0?A=this.fragment:A===null&&(A=y),o===this.scheme&&h===this.authority&&w===this.path&&M===this.query&&A===this.fragment?this:new g(o,h,w,M,A)}static parse(i,o=!1){const h=m.exec(i);return h?new g(h[2]||y,l(h[4]||y),l(h[5]||y),l(h[7]||y),l(h[9]||y),o):new g(y,y,y,y,y)}static file(i){let o=y;if(r.isWindows&&(i=i.replace(/\\/g,b)),i[0]===b&&i[1]===b){const h=i.indexOf(b,2);h===-1?(o=i.substring(2),i=b):(o=i.substring(2,h),i=i.substring(h)||b)}return new g("file",o,i,y,y)}static from(i){const o=new g(i.scheme,i.authority,i.path,i.query,i.fragment);return I(o,!0),o}static joinPath(i,...o){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let h;return r.isWindows&&i.scheme==="file"?h=S.file(p.win32.join(c(i,!0),...o)).path:h=p.posix.join(i.path,...o),i.with({path:h})}toString(i=!1){return a(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof S)return i;{const o=new g(i);return o._formatted=i.external,o._fsPath=i._sep===t?i.fsPath:null,o}}else return i}}e.URI=S;const t=r.isWindows?1:void 0;class g extends S{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=c(this,!1)),this._fsPath}toString(i=!1){return i?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=t),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const E={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function v(n,i){let o,h=-1;for(let w=0;w<n.length;w++){const M=n.charCodeAt(w);if(M>=97&&M<=122||M>=65&&M<=90||M>=48&&M<=57||M===45||M===46||M===95||M===126||i&&M===47)h!==-1&&(o+=encodeURIComponent(n.substring(h,w)),h=-1),o!==void 0&&(o+=n.charAt(w));else{o===void 0&&(o=n.substr(0,w));const A=E[M];A!==void 0?(h!==-1&&(o+=encodeURIComponent(n.substring(h,w)),h=-1),o+=A):h===-1&&(h=w)}}return h!==-1&&(o+=encodeURIComponent(n.substring(h))),o!==void 0?o:n}function k(n){let i;for(let o=0;o<n.length;o++){const h=n.charCodeAt(o);h===35||h===63?(i===void 0&&(i=n.substr(0,o)),i+=E[h]):i!==void 0&&(i+=n[o])}return i!==void 0?i:n}function c(n,i){let o;return n.authority&&n.path.length>1&&n.scheme==="file"?o=`//${n.authority}${n.path}`:n.path.charCodeAt(0)===47&&(n.path.charCodeAt(1)>=65&&n.path.charCodeAt(1)<=90||n.path.charCodeAt(1)>=97&&n.path.charCodeAt(1)<=122)&&n.path.charCodeAt(2)===58?i?o=n.path.substr(1):o=n.path[1].toLowerCase()+n.path.substr(2):o=n.path,r.isWindows&&(o=o.replace(/\//g,"\\")),o}e.uriToFsPath=c;function a(n,i){const o=i?k:v;let h="",{scheme:w,authority:M,path:A,query:R,fragment:T}=n;if(w&&(h+=w,h+=":"),(M||w==="file")&&(h+=b,h+=b),M){let _=M.indexOf("@");if(_!==-1){const Q=M.substr(0,_);M=M.substr(_+1),_=Q.indexOf(":"),_===-1?h+=o(Q,!1):(h+=o(Q.substr(0,_),!1),h+=":",h+=o(Q.substr(_+1),!1)),h+="@"}M=M.toLowerCase(),_=M.indexOf(":"),_===-1?h+=o(M,!1):(h+=o(M.substr(0,_),!1),h+=M.substr(_))}if(A){if(A.length>=3&&A.charCodeAt(0)===47&&A.charCodeAt(2)===58){const _=A.charCodeAt(1);_>=65&&_<=90&&(A=`/${String.fromCharCode(_+32)}:${A.substr(3)}`)}else if(A.length>=2&&A.charCodeAt(1)===58){const _=A.charCodeAt(0);_>=65&&_<=90&&(A=`${String.fromCharCode(_+32)}:${A.substr(2)}`)}h+=o(A,!0)}return R&&(h+="?",h+=o(R,!1)),T&&(h+="#",h+=i?T:v(T,!1)),h}function u(n){try{return decodeURIComponent(n)}catch{return n.length>3?n.substr(0,3)+u(n.substr(3)):n}}const s=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function l(n){return n.match(s)?n.replace(s,i=>u(i)):n}}),define(Z[109],x([0,1,7]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function r(f){const y=f;return y&&typeof y.type=="string"&&typeof y.severity=="string"}e.isRemoteConsoleLog=r;function D(f){const y=[];let b;try{const m=JSON.parse(f.arguments),S=m[m.length-1];S&&S.__$stack&&(m.pop(),b=S.__$stack),y.push(...m)}catch{y.push("Unable to log remote console arguments",f.arguments)}return{args:y,stack:b}}e.parse=D;function C(f){if(typeof f!="string")return C(D(f).stack);const y=f;if(y){const b=P(y),m=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(b||"");if(m&&m.length===4)return{uri:p.URI.file(m[1]),line:Number(m[2]),column:Number(m[3])}}}e.getFirstFrame=C;function P(f){if(!f)return f;const y=f.indexOf(`
`);return y===-1?f:f.substring(0,y)}function I(f,y){const{args:b,stack:m}=D(f),S=typeof b[0]=="string"&&b.length===1;let t=P(m);t&&(t=`(${t.trim()})`);let g=[];if(typeof b[0]=="string"?t&&S?g=[`%c[${y}] %c${b[0]} %c${t}`,d("blue"),d(""),d("grey")]:g=[`%c[${y}] %c${b[0]}`,d("blue"),d(""),...b.slice(1)]:g=[`%c[${y}]%`,d("blue"),...b],t&&!S&&g.push(t),typeof console[f.severity]!="function")throw new Error("Unknown console method");console[f.severity].apply(console,g)}e.log=I;function d(f){return`color: ${f}`}}),define(Z[110],x([0,1,17,25,7]),function(j,e,p,r,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function C(y){return JSON.stringify(y,d)}e.stringify=C;function P(y){let b=JSON.parse(y);return b=f(b),b}e.parse=P;var I;(function(y){y[y.Uri=1]="Uri",y[y.Regexp=2]="Regexp",y[y.ScmResource=3]="ScmResource",y[y.ScmResourceGroup=4]="ScmResourceGroup",y[y.ScmProvider=5]="ScmProvider",y[y.CommentController=6]="CommentController",y[y.CommentThread=7]="CommentThread",y[y.CommentThreadReply=8]="CommentThreadReply",y[y.CommentNode=9]="CommentNode",y[y.CommentThreadNode=10]="CommentThreadNode",y[y.TimelineActionContext=11]="TimelineActionContext",y[y.NotebookCellActionContext=12]="NotebookCellActionContext",y[y.TestItemContext=13]="TestItemContext"})(I=e.MarshalledId||(e.MarshalledId={}));function d(y,b){return b instanceof RegExp?{$mid:2,source:b.source,flags:(0,r.regExpFlags)(b)}:b}function f(y,b=0){if(!y||b>200)return y;if(typeof y=="object"){switch(y.$mid){case 1:return D.URI.revive(y);case 2:return new RegExp(y.source,y.flags)}if(y instanceof p.VSBuffer||y instanceof Uint8Array)return y;if(Array.isArray(y))for(let m=0;m<y.length;++m)y[m]=f(y[m],b+1);else for(const m in y)Object.hasOwnProperty.call(y,m)&&(y[m]=f(y[m],b+1))}return y}e.revive=f}),define(Z[10],x([0,1,3,7]),function(j,e,p,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var D;(function(I){I.inMemory="inmemory",I.vscode="vscode",I.internal="private",I.walkThrough="walkThrough",I.walkThroughSnippet="walkThroughSnippet",I.http="http",I.https="https",I.file="file",I.mailto="mailto",I.untitled="untitled",I.data="data",I.command="command",I.vscodeRemote="vscode-remote",I.vscodeRemoteResource="vscode-remote-resource",I.userData="vscode-userdata",I.vscodeCustomEditor="vscode-custom-editor",I.vscodeNotebook="vscode-notebook",I.vscodeNotebookCell="vscode-notebook-cell",I.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",I.vscodeNotebookCellOutput="vscode-notebook-cell-output",I.vscodeInteractive="vscode-interactive",I.vscodeInteractiveInput="vscode-interactive-input",I.vscodeSettings="vscode-settings",I.vscodeWorkspaceTrust="vscode-workspace-trust",I.vscodeTerminal="vscode-terminal",I.webviewPanel="webview-panel",I.vscodeWebview="vscode-webview",I.extension="extension",I.vscodeFileResource="vscode-file",I.tmp="tmp",I.vsls="vsls"})(D=e.Schemas||(e.Schemas={}));class C{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(d){this._preferredWebSchema=d}setDelegate(d){this._delegate=d}set(d,f,y){this._hosts[d]=f,this._ports[d]=y}setConnectionToken(d,f){this._connectionTokens[d]=f}rewrite(d){if(this._delegate)return this._delegate(d);const f=d.authority;let y=this._hosts[f];y&&y.indexOf(":")!==-1&&(y=`[${y}]`);const b=this._ports[f],m=this._connectionTokens[f];let S=`path=${encodeURIComponent(d.path)}`;return typeof m=="string"&&(S+=`&tkn=${encodeURIComponent(m)}`),r.URI.from({scheme:p.isWeb?this._preferredWebSchema:D.vscodeRemoteResource,authority:`${y}:${b}`,path:"/vscode-remote-resource",query:S})}}e.RemoteAuthorities=new C;class P{asBrowserUri(d,f){const y=this.toUri(d,f);return y.scheme===D.vscodeRemote?e.RemoteAuthorities.rewrite(y):y.scheme===D.file&&(p.isNative||typeof p.globals.importScripts=="function"&&p.globals.origin===`${D.vscodeFileResource}://${P.FALLBACK_AUTHORITY}`)?y.with({scheme:D.vscodeFileResource,authority:y.authority||P.FALLBACK_AUTHORITY,query:null,fragment:null}):y}asFileUri(d,f){const y=this.toUri(d,f);return y.scheme===D.vscodeFileResource?y.with({scheme:D.file,authority:y.authority!==P.FALLBACK_AUTHORITY?y.authority:null,query:null,fragment:null}):y}toUri(d,f){return r.URI.isUri(d)?d:r.URI.parse(f.toUrl(d))}}P.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new P}),define(Z[15],x([0,1,32,10,8,3,25,7]),function(j,e,p,r,D,C,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function d(S){return(0,I.uriToFsPath)(S,!0)}e.originalFSPath=d;class f{constructor(t){this._ignorePathCasing=t}compare(t,g,E=!1){return t===g?0:(0,P.compare)(this.getComparisonKey(t,E),this.getComparisonKey(g,E))}isEqual(t,g,E=!1){return t===g?!0:!t||!g?!1:this.getComparisonKey(t,E)===this.getComparisonKey(g,E)}getComparisonKey(t,g=!1){return t.with({path:this._ignorePathCasing(t)?t.path.toLowerCase():void 0,fragment:g?null:void 0}).toString()}ignorePathCasing(t){return this._ignorePathCasing(t)}isEqualOrParent(t,g,E=!1){if(t.scheme===g.scheme){if(t.scheme===r.Schemas.file)return p.isEqualOrParent(d(t),d(g),this._ignorePathCasing(t))&&t.query===g.query&&(E||t.fragment===g.fragment);if((0,e.isEqualAuthority)(t.authority,g.authority))return p.isEqualOrParent(t.path,g.path,this._ignorePathCasing(t),"/")&&t.query===g.query&&(E||t.fragment===g.fragment)}return!1}joinPath(t,...g){return I.URI.joinPath(t,...g)}basenameOrAuthority(t){return(0,e.basename)(t)||t.authority}basename(t){return D.posix.basename(t.path)}extname(t){return D.posix.extname(t.path)}dirname(t){if(t.path.length===0)return t;let g;return t.scheme===r.Schemas.file?g=I.URI.file(D.dirname(d(t))).path:(g=D.posix.dirname(t.path),t.authority&&g.length&&g.charCodeAt(0)!==47&&(console.error(`dirname("${t.toString})) resulted in a relative path`),g="/")),t.with({path:g})}normalizePath(t){if(!t.path.length)return t;let g;return t.scheme===r.Schemas.file?g=I.URI.file(D.normalize(d(t))).path:g=D.posix.normalize(t.path),t.with({path:g})}relativePath(t,g){if(t.scheme!==g.scheme||!(0,e.isEqualAuthority)(t.authority,g.authority))return;if(t.scheme===r.Schemas.file){const k=D.relative(d(t),d(g));return C.isWindows?p.toSlashes(k):k}let E=t.path||"/",v=g.path||"/";if(this._ignorePathCasing(t)){let k=0;for(const c=Math.min(E.length,v.length);k<c&&!(E.charCodeAt(k)!==v.charCodeAt(k)&&E.charAt(k).toLowerCase()!==v.charAt(k).toLowerCase());k++);E=v.substr(0,k)+E.substr(k)}return D.posix.relative(E,v)}resolvePath(t,g){if(t.scheme===r.Schemas.file){const E=I.URI.file(D.resolve(d(t),g));return t.with({authority:E.authority,path:E.path})}return g=p.toPosixPath(g),t.with({path:D.posix.resolve(t.path,g)})}isAbsolutePath(t){return!!t.path&&t.path[0]==="/"}isEqualAuthority(t,g){return t===g||t!==void 0&&g!==void 0&&(0,P.equalsIgnoreCase)(t,g)}hasTrailingPathSeparator(t,g=D.sep){if(t.scheme===r.Schemas.file){const E=d(t);return E.length>p.getRoot(E).length&&E[E.length-1]===g}else{const E=t.path;return E.length>1&&E.charCodeAt(E.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(t.fsPath)}}removeTrailingPathSeparator(t,g=D.sep){return(0,e.hasTrailingPathSeparator)(t,g)?t.with({path:t.path.substr(0,t.path.length-1)}):t}addTrailingPathSeparator(t,g=D.sep){let E=!1;if(t.scheme===r.Schemas.file){const v=d(t);E=v!==void 0&&v.length===p.getRoot(v).length&&v[v.length-1]===g}else{g="/";const v=t.path;E=v.length===1&&v.charCodeAt(v.length-1)===47}return!E&&!(0,e.hasTrailingPathSeparator)(t,g)?t.with({path:t.path+"/"}):t}}e.ExtUri=f,e.extUri=new f(()=>!1),e.extUriBiasedIgnorePathCase=new f(S=>S.scheme===r.Schemas.file?!C.isLinux:!0),e.extUriIgnorePathCase=new f(S=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function y(S,t){const g=[];for(let E=0;E<S.length;E++){const v=t(S[E]);S.some((k,c)=>c===E?!1:(0,e.isEqualOrParent)(v,t(k)))||g.push(S[E])}return g}e.distinctParents=y;var b;(function(S){S.META_DATA_LABEL="label",S.META_DATA_DESCRIPTION="description",S.META_DATA_SIZE="size",S.META_DATA_MIME="mime";function t(g){const E=new Map;g.path.substring(g.path.indexOf(";")+1,g.path.lastIndexOf(";")).split(";").forEach(c=>{const[a,u]=c.split(":");a&&u&&E.set(a,u)});const k=g.path.substring(0,g.path.indexOf(";"));return k&&E.set(S.META_DATA_MIME,k),E}S.parseMetaData=t})(b=e.DataUri||(e.DataUri={}));function m(S,t,g){if(t){let E=S.path;return E&&E[0]!==D.posix.sep&&(E=D.posix.sep+E),S.with({scheme:g,authority:t,path:E})}return S.with({scheme:g})}e.toLocalResource=m}),define(Z[9],x([0,1,23,16,4,2,15,3]),function(j,e,p,r,D,C,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function d(B){return!!B&&typeof B.then=="function"}e.isThenable=d;function f(B){const L=new p.CancellationTokenSource,W=B(L.token),F=new Promise((N,V)=>{const U=L.token.onCancellationRequested(()=>{U.dispose(),L.dispose(),V((0,r.canceled)())});Promise.resolve(W).then(z=>{U.dispose(),L.dispose(),N(z)},z=>{U.dispose(),L.dispose(),V(z)})});return new class{cancel(){L.cancel()}then(N,V){return F.then(N,V)}catch(N){return this.then(void 0,N)}finally(N){return F.finally(N)}}}e.createCancelablePromise=f;function y(B,L,W){return Promise.race([B,new Promise(F=>L.onCancellationRequested(()=>F(W)))])}e.raceCancellation=y;async function b(B){let L=-1;const W=B.map((N,V)=>N.then(U=>(L=V,U))),F=await Promise.race(W);return B.forEach((N,V)=>{V!==L&&N.cancel()}),F}e.raceCancellablePromises=b;function m(B,L,W){let F;const N=setTimeout(()=>{F?.(void 0),W?.()},L);return Promise.race([B.finally(()=>clearTimeout(N)),new Promise(V=>F=V)])}e.raceTimeout=m;function S(B){return new Promise((L,W)=>{const F=B();d(F)?F.then(L,W):L(F)})}e.asPromise=S;class t{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(L){if(this.activePromise){if(this.queuedPromiseFactory=L,!this.queuedPromise){const W=()=>{this.queuedPromise=null;const F=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,F};this.queuedPromise=new Promise(F=>{this.activePromise.then(W,W).then(F)})}return new Promise((W,F)=>{this.queuedPromise.then(W,F)})}return this.activePromise=L(),new Promise((W,F)=>{this.activePromise.then(N=>{this.activePromise=null,W(N)},N=>{this.activePromise=null,F(N)})})}}e.Throttler=t;class g{constructor(){this.current=Promise.resolve(null)}queue(L){return this.current=this.current.then(()=>L(),()=>L())}}e.Sequencer=g;class E{constructor(){this.promiseMap=new Map}queue(L,W){const N=(this.promiseMap.get(L)??Promise.resolve()).catch(()=>{}).then(W).finally(()=>{this.promiseMap.get(L)===N&&this.promiseMap.delete(L)});return this.promiseMap.set(L,N),N}}e.SequencerByKey=E;class v{constructor(L){this.defaultDelay=L,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(L,W=this.defaultDelay){return this.task=L,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((F,N)=>{this.doResolve=F,this.doReject=N}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const F=this.task;return this.task=null,F()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},W),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,r.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=v;class k{constructor(L){this.delayer=new v(L),this.throttler=new t}trigger(L,W){return this.delayer.trigger(()=>this.throttler.queue(L),W)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=k;class c{constructor(){this._isOpen=!1,this._promise=new Promise((L,W)=>{this._completePromise=L})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=c;class a extends c{constructor(L){super();this._timeout=setTimeout(()=>this.open(),L)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=a;function u(B,L){return L?new Promise((W,F)=>{const N=setTimeout(()=>{V.dispose(),W()},B),V=L.onCancellationRequested(()=>{clearTimeout(N),V.dispose(),F((0,r.canceled)())})}):f(W=>u(B,W))}e.timeout=u;function s(B,L=0){const W=setTimeout(B,L);return(0,C.toDisposable)(()=>clearTimeout(W))}e.disposableTimeout=s;function l(B){const L=[];let W=0;const F=B.length;function N(){return W<F?B[W++]():null}function V(U){U!=null&&L.push(U);const z=N();return z?z.then(V):Promise.resolve(L)}return Promise.resolve(null).then(V)}e.sequence=l;function n(B,L=F=>!!F,W=null){let F=0;const N=B.length,V=()=>{if(F>=N)return Promise.resolve(W);const U=B[F++];return Promise.resolve(U()).then(ee=>L(ee)?Promise.resolve(ee):V())};return V()}e.first=n;function i(B,L=F=>!!F,W=null){if(B.length===0)return Promise.resolve(W);let F=B.length;const N=()=>{F=-1;for(const V of B)V.cancel?.()};return new Promise((V,U)=>{for(const z of B)z.then(ee=>{--F>=0&&L(ee)?(N(),V(ee)):F===0&&V(W)}).catch(ee=>{--F>=0&&(N(),U(ee))})})}e.firstParallel=i;class o{constructor(L){this._size=0,this.maxDegreeOfParalellism=L,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new D.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(L){return this._size++,new Promise((W,F)=>{this.outstandingPromises.push({factory:L,c:W,e:F}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const L=this.outstandingPromises.shift();this.runningPromises++;const W=L.factory();W.then(L.c,L.e),W.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=o;class h extends o{constructor(){super(1)}}e.Queue=h;class w{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const L=new H;return this.drainers.add(L),L.p}isDrained(){for(const[,L]of this.queues)if(L.size>0)return!1;return!0}queueFor(L,W=P.extUri){const F=W.getComparisonKey(L);let N=this.queues.get(F);return N||(N=new h,D.Event.once(N.onFinished)(()=>{N?.dispose(),this.queues.delete(F),this.onDidQueueFinish()}),this.queues.set(F,N)),N}onDidQueueFinish(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const L of this.drainers)L.complete();this.drainers.clear()}dispose(){for(const[,L]of this.queues)L.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=w;class M{constructor(L,W){this._token=-1,typeof L=="function"&&typeof W=="number"&&this.setIfNotSet(L,W)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(L,W){this.cancel(),this._token=setTimeout(()=>{this._token=-1,L()},W)}setIfNotSet(L,W){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,L()},W))}}e.TimeoutTimer=M;class A{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(L,W){this.cancel(),this._token=setInterval(()=>{L()},W)}}e.IntervalTimer=A;class R{constructor(L,W){this.timeoutToken=-1,this.runner=L,this.timeout=W,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(L=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,L)}get delay(){return this.timeout}set delay(L){this.timeout=L}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=R;class T{constructor(L,W){W%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${W}ms is not a multiple of 1000ms.`),this.runner=L,this.timeout=W,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(L=this.timeout){L%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${L}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(L/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=T;class _ extends R{constructor(L,W){super(L,W);this.units=[]}work(L){this.units.push(L),this.isScheduled()||this.schedule()}doRun(){const L=this.units;this.units=[],this.runner&&this.runner(L)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=_;class Q extends C.Disposable{constructor(L,W,F,N){super();this.maxWorkChunkSize=L,this.maxPendingWork=W,this.throttleDelay=F,this.handler=N,this.pendingWork=[],this.throttler=this._register(new C.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(L){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+L.length>this.maxPendingWork)return!1}else if(this.pending+L.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...L),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new R(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=Q,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=B=>{(0,I.setTimeout0)(()=>{if(L)return;const W=Date.now()+3;B(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,W-Date.now())}}))});let L=!1;return{dispose(){L||(L=!0)}}}:e.runWhenIdle=(B,L)=>{const W=requestIdleCallback(B,typeof L=="number"?{timeout:L}:void 0);let F=!1;return{dispose(){F||(F=!0,cancelIdleCallback(W))}}}}();class ne{constructor(L){this._didRun=!1,this._executor=()=>{try{this._value=L()}catch(W){this._error=W}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=ne;async function oe(B,L,W){let F;for(let N=0;N<W;N++)try{return await B()}catch(V){F=V,await u(L)}throw F}e.retry=oe;class X{hasPending(L){return this._pending?typeof L=="number"?this._pending.taskId===L:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(L,W,F){return this._pending={taskId:L,cancel:()=>F?.(),promise:W},W.then(()=>this.donePending(L),()=>this.donePending(L)),W}donePending(L){this._pending&&L===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const L=this._next;this._next=void 0,L.run().then(L.promiseResolve,L.promiseReject)}}setNext(L){if(this._next)this._next.run=L;else{let W,F;const N=new Promise((V,U)=>{W=V,F=U});this._next={run:L,promise:N,promiseResolve:W,promiseReject:F}}return this._next.promise}}e.TaskSequentializer=X;class O{constructor(L,W=()=>Date.now()){this.interval=L,this.nowFn=W,this.lastIncrementTime=0,this.value=0}increment(){const L=this.nowFn();return L-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=L,this.value=0),this.value++,this.value}}e.IntervalCounter=O;class H{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((L,W)=>{this.completeCallback=L,this.errorCallback=W})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(L){return new Promise(W=>{this.completeCallback(L),this.resolved=!0,W()})}error(L){return new Promise(W=>{this.errorCallback(L),this.rejected=!0,W()})}cancel(){new Promise(L=>{this.errorCallback((0,r.canceled)()),this.rejected=!0,L()})}}e.DeferredPromise=H;var q;(function(B){async function L(F){let N;const V=await Promise.all(F.map(U=>U.then(z=>z,z=>{N||(N=z)})));if(typeof N!="undefined")throw N;return V}B.settled=L;function W(F){return new Promise(async(N,V)=>{try{await F(N,V)}catch(U){V(U)}})}B.withAsyncBody=W})(q=e.Promises||(e.Promises={}));var Y;(function(B){B[B.Initial=0]="Initial",B[B.DoneOK=1]="DoneOK",B[B.DoneError=2]="DoneError"})(Y||(Y={}));class ${constructor(L){this._state=0,this._results=[],this._error=null,this._onStateChanged=new D.Emitter,queueMicrotask(async()=>{const W={emitOne:F=>this.emitOne(F),emitMany:F=>this.emitMany(F),reject:F=>this.reject(F)};try{await Promise.resolve(L(W)),this.resolve()}catch(F){this.reject(F)}finally{W.emitOne=void 0,W.emitMany=void 0,W.reject=void 0}})}static fromArray(L){return new $(W=>{W.emitMany(L)})}static fromPromise(L){return new $(async W=>{W.emitMany(await L)})}static fromPromises(L){return new $(async W=>{await Promise.all(L.map(async F=>W.emitOne(await F)))})}static merge(L){return new $(async W=>{await Promise.all(L.map(async F=>{for await(const N of F)W.emitOne(N)}))})}[Symbol.asyncIterator](){let L=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(L<this._results.length)return{done:!1,value:this._results[L++]};if(this._state===1)return{done:!0,value:void 0};await D.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(L,W){return new $(async F=>{for await(const N of L)F.emitOne(W(N))})}map(L){return $.map(this,L)}static filter(L,W){return new $(async F=>{for await(const N of L)W(N)&&F.emitOne(N)})}filter(L){return $.filter(this,L)}static coalesce(L){return $.filter(L,W=>!!W)}coalesce(){return $.coalesce(this)}static async toPromise(L){const W=[];for await(const F of L)W.push(F);return W}toPromise(){return $.toPromise(this)}emitOne(L){this._state===0&&(this._results.push(L),this._onStateChanged.fire())}emitMany(L){this._state===0&&(this._results=this._results.concat(L),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(L){this._state===0&&(this._state=2,this._error=L,this._onStateChanged.fire())}}e.AsyncIterableObject=$,$.EMPTY=$.fromArray([]);class K extends ${constructor(L,W){super(W);this._source=L}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=K;function te(B){const L=new p.CancellationTokenSource,W=B(L.token);return new K(L,async F=>{const N=L.token.onCancellationRequested(()=>{N.dispose(),L.dispose(),F.reject((0,r.canceled)())});try{for await(const V of W){if(L.token.isCancellationRequested)return;F.emitOne(V)}N.dispose(),L.dispose()}catch(V){N.dispose(),L.dispose(),F.reject(V)}})}e.createCancelableAsyncIterable=te}),define(Z[33],x([0,1,32,10,8,3,15,25,7]),function(j,e,p,r,D,C,P,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function f(i,o,h){if(typeof i=="string"&&(i=d.URI.file(i)),h){const M=h.getWorkspaceFolder(i);if(M){const A=h.getWorkspace().folders.length>1;let R;if((0,P.isEqual)(M.uri,i)?R="":R=(0,P.relativePath)(M.uri,i),A){const T=M.name?M.name:(0,P.basename)(M.uri);R=R?T+" \u2022 "+R:T}return R}}if(i.scheme!==r.Schemas.file&&i.scheme!==r.Schemas.untitled)return i.with({query:null,fragment:null}).toString(!0);if((0,p.hasDriveLetter)(i.fsPath))return(0,D.normalize)(b(i.fsPath));let w=(0,D.normalize)(i.fsPath);return!C.isWindows&&o?.userHome&&(w=S(w,o.userHome.fsPath)),w}e.getPathLabel=f;function y(i){if(!i)return;typeof i=="string"&&(i=d.URI.file(i));const o=(0,P.basename)(i)||(i.scheme===r.Schemas.file?i.fsPath:i.path);return C.isWindows&&(0,p.isRootOrDriveLetter)(o)?b(o):o}e.getBaseLabel=y;function b(i,o){return(0,p.hasDriveLetter)(i,o)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=b;let m=Object.create(null);function S(i,o){if(C.isWindows||!i||!o)return i;let h=m.original===o?m.normalized:void 0;return h||(h=`${(0,I.rtrim)(o,D.posix.sep)}${D.posix.sep}`,m={original:o,normalized:h}),(C.isLinux?i.startsWith(h):(0,I.startsWithIgnoreCase)(i,h))&&(i=`~/${i.substr(h.length)}`),i}e.tildify=S;function t(i,o){return i.replace(/^~($|\/|\\)/,`${o}$1`)}e.untildify=t;const g="\u2026",E="\\\\",v="~";function k(i,o=D.sep){const h=new Array(i.length);let w=!1;for(let M=0;M<i.length;M++){let A=i[M];if(A===""){h[M]=`.${o}`;continue}if(!A){h[M]=A;continue}w=!0;let R="";A.indexOf(E)===0?(R=A.substr(0,A.indexOf(E)+E.length),A=A.substr(A.indexOf(E)+E.length)):A.indexOf(o)===0?(R=A.substr(0,A.indexOf(o)+o.length),A=A.substr(A.indexOf(o)+o.length)):A.indexOf(v)===0&&(R=A.substr(0,A.indexOf(v)+v.length),A=A.substr(A.indexOf(v)+v.length));const T=A.split(o);for(let _=1;w&&_<=T.length;_++)for(let Q=T.length-_;w&&Q>=0;Q--){w=!1;let ne=T.slice(Q,Q+_).join(o);for(let oe=0;!w&&oe<i.length;oe++)if(oe!==M&&i[oe]&&i[oe].indexOf(ne)>-1){const X=Q+_===T.length,O=Q>0&&i[oe].indexOf(o)>-1?o+ne:ne,H=i[oe].endsWith(O);w=!X||H}if(!w){let oe="";(T[0].endsWith(":")||R!=="")&&(Q===1&&(Q=0,_++,ne=T[0]+o+ne),Q>0&&(oe=T[0]+o),oe=R+oe),Q>0&&(oe=oe+g+o),oe=oe+ne,Q+_<T.length&&(oe=oe+o+g),h[M]=oe}}w&&(h[M]=A)}return h}e.shorten=k;var c;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(c||(c={}));function a(i,o=Object.create(null)){const h=[];let w=!1,M="";for(const A of i)if(A==="$"||w&&A==="{")M&&h.push({value:M,type:c.TEXT}),M="",w=!0;else if(A==="}"&&w){const R=o[M];if(typeof R=="string")R.length&&h.push({value:R,type:c.VARIABLE});else if(R){const T=h[h.length-1];(!T||T.type!==c.SEPARATOR)&&h.push({value:R.label,type:c.SEPARATOR})}M="",w=!1}else M+=A;return M&&!w&&h.push({value:M,type:c.TEXT}),h.filter((A,R)=>{if(A.type===c.SEPARATOR){const T=h[R-1],_=h[R+1];return[T,_].every(Q=>Q&&(Q.type===c.VARIABLE||Q.type===c.TEXT)&&Q.value.length>0)}return!0}).map(A=>A.value).join("")}e.template=a;function u(i,o){return C.isMacintosh||o?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,C.isMacintosh?"&":"&&"):i.replace(/&&|&/g,h=>h==="&"?"&&":"&")}e.mnemonicMenuLabel=u;function s(i,o){return C.isMacintosh||o?i.replace(/\(&&\w\)|&&/g,""):C.isWindows?i.replace(/&&|&/g,h=>h==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=s;function l(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=l;function n(i){const o=i.indexOf("/")!==-1?D.posix:D.win32,h=o.basename(i),w=o.dirname(i);return h.length?{name:h,parentPath:w}:{name:w,parentPath:""}}e.splitName=n}),define(Z[111],x([0,1,7]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function r(y){return y.toJSON()}class D{constructor(b){this._uriTransformer=b}transformIncoming(b){const m=this._uriTransformer.transformIncoming(b);return m===b?b:r(p.URI.from(m))}transformOutgoing(b){const m=this._uriTransformer.transformOutgoing(b);return m===b?b:r(p.URI.from(m))}transformOutgoingURI(b){const m=this._uriTransformer.transformOutgoing(b);return m===b?b:p.URI.from(m)}transformOutgoingScheme(b){return this._uriTransformer.transformOutgoingScheme(b)}}e.URITransformer=D,e.DefaultURITransformer=new class{transformIncoming(y){return y}transformOutgoing(y){return y}transformOutgoingURI(y){return y}transformOutgoingScheme(y){return y}};function C(y,b,m){if(!y||m>200)return null;if(typeof y=="object"){if(y instanceof p.URI)return b.transformOutgoing(y);for(let S in y)if(Object.hasOwnProperty.call(y,S)){const t=C(y[S],b,m+1);t!==null&&(y[S]=t)}}return null}function P(y,b){const m=C(y,b,0);return m===null?y:m}e.transformOutgoingURIs=P;function I(y,b,m,S){if(!y||S>200)return null;if(typeof y=="object"){if(y.$mid===1)return m?p.URI.revive(b.transformIncoming(y)):b.transformIncoming(y);for(let t in y)if(Object.hasOwnProperty.call(y,t)){const g=I(y[t],b,m,S+1);g!==null&&(y[t]=g)}}return null}function d(y,b){const m=I(y,b,!1,0);return m===null?y:m}e.transformIncomingURIs=d;function f(y,b){const m=I(y,b,!0,0);return m===null?y:m}e.transformAndReviveIncomingURIs=f}),define(Z[31],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const p=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function r(d){return p.test(d)}e.isUUID=r;const D=new Uint8Array(16),C=[];for(let d=0;d<256;d++)C.push(d.toString(16).padStart(2,"0"));let P;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?P=crypto.getRandomValues.bind(crypto):P=function(d){for(let f=0;f<d.length;f++)d[f]=Math.floor(Math.random()*256);return d};function I(){P(D),D[6]=D[6]&15|64,D[8]=D[8]&63|128;let d=0,f="";return f+=C[D[d++]],f+=C[D[d++]],f+=C[D[d++]],f+=C[D[d++]],f+="-",f+=C[D[d++]],f+=C[D[d++]],f+="-",f+=C[D[d++]],f+=C[D[d++]],f+="-",f+=C[D[d++]],f+=C[D[d++]],f+="-",f+=C[D[d++]],f+=C[D[d++]],f+=C[D[d++]],f+=C[D[d++]],f+=C[D[d++]],f+=C[D[d++]],f}e.generateUuid=I}),define(Z[112],x([0,1,16,4,2,3,13,25]),function(j,e,p,r,D,C,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=e.SimpleWorkerServer=e.SimpleWorkerClient=e.logOnceWebWorkerWarning=void 0;const d="$initialize";let f=!1;function y(n){!C.isWeb||(f||(f=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(n.message))}e.logOnceWebWorkerWarning=y;var b;(function(n){n[n.Request=0]="Request",n[n.Reply=1]="Reply",n[n.SubscribeEvent=2]="SubscribeEvent",n[n.Event=3]="Event",n[n.UnsubscribeEvent=4]="UnsubscribeEvent"})(b||(b={}));class m{constructor(i,o,h,w){this.vsWorker=i,this.req=o,this.method=h,this.args=w,this.type=0}}class S{constructor(i,o,h,w){this.vsWorker=i,this.seq=o,this.res=h,this.err=w,this.type=1}}class t{constructor(i,o,h,w){this.vsWorker=i,this.req=o,this.eventName=h,this.arg=w,this.type=2}}class g{constructor(i,o,h){this.vsWorker=i,this.req=o,this.event=h,this.type=3}}class E{constructor(i,o){this.vsWorker=i,this.req=o,this.type=4}}class v{constructor(i){this._workerId=-1,this._handler=i,this._lastSentReq=0,this._pendingReplies=Object.create(null),this._pendingEmitters=new Map,this._pendingEvents=new Map}setWorkerId(i){this._workerId=i}sendMessage(i,o){const h=String(++this._lastSentReq);return new Promise((w,M)=>{this._pendingReplies[h]={resolve:w,reject:M},this._send(new m(this._workerId,h,i,o))})}listen(i,o){let h=null;const w=new r.Emitter({onFirstListenerAdd:()=>{h=String(++this._lastSentReq),this._pendingEmitters.set(h,w),this._send(new t(this._workerId,h,i,o))},onLastListenerRemove:()=>{this._pendingEmitters.delete(h),this._send(new E(this._workerId,h)),h=null}});return w.event}handleMessage(i){!i||!i.vsWorker||this._workerId!==-1&&i.vsWorker!==this._workerId||this._handleMessage(i)}_handleMessage(i){switch(i.type){case 1:return this._handleReplyMessage(i);case 0:return this._handleRequestMessage(i);case 2:return this._handleSubscribeEventMessage(i);case 3:return this._handleEventMessage(i);case 4:return this._handleUnsubscribeEventMessage(i)}}_handleReplyMessage(i){if(!this._pendingReplies[i.seq]){console.warn("Got reply to unknown seq");return}let o=this._pendingReplies[i.seq];if(delete this._pendingReplies[i.seq],i.err){let h=i.err;i.err.$isError&&(h=new Error,h.name=i.err.name,h.message=i.err.message,h.stack=i.err.stack),o.reject(h);return}o.resolve(i.res)}_handleRequestMessage(i){let o=i.req;this._handler.handleMessage(i.method,i.args).then(w=>{this._send(new S(this._workerId,o,w,void 0))},w=>{w.detail instanceof Error&&(w.detail=(0,p.transformErrorForSerialization)(w.detail)),this._send(new S(this._workerId,o,void 0,(0,p.transformErrorForSerialization)(w)))})}_handleSubscribeEventMessage(i){const o=i.req,h=this._handler.handleEvent(i.eventName,i.arg)(w=>{this._send(new g(this._workerId,o,w))});this._pendingEvents.set(o,h)}_handleEventMessage(i){if(!this._pendingEmitters.has(i.req)){console.warn("Got event for unknown req");return}this._pendingEmitters.get(i.req).fire(i.event)}_handleUnsubscribeEventMessage(i){if(!this._pendingEvents.has(i.req)){console.warn("Got unsubscribe for unknown req");return}this._pendingEvents.get(i.req).dispose(),this._pendingEvents.delete(i.req)}_send(i){let o=[];if(i.type===0)for(let h=0;h<i.args.length;h++)i.args[h]instanceof ArrayBuffer&&o.push(i.args[h]);else i.type===1&&i.res instanceof ArrayBuffer&&o.push(i.res);this._handler.sendMessage(i,o)}}class k extends D.Disposable{constructor(i,o,h){super();let w=null;this._worker=this._register(i.create("vs/base/common/worker/simpleWorker",_=>{this._protocol.handleMessage(_)},_=>{w&&w(_)})),this._protocol=new v({sendMessage:(_,Q)=>{this._worker.postMessage(_,Q)},handleMessage:(_,Q)=>{if(typeof h[_]!="function")return Promise.reject(new Error("Missing method "+_+" on main thread host."));try{return Promise.resolve(h[_].apply(h,Q))}catch(ne){return Promise.reject(ne)}},handleEvent:(_,Q)=>{if(a(_)){const ne=h[_].call(h,Q);if(typeof ne!="function")throw new Error(`Missing dynamic event ${_} on main thread host.`);return ne}if(c(_)){const ne=h[_];if(typeof ne!="function")throw new Error(`Missing event ${_} on main thread host.`);return ne}throw new Error(`Malformed event name ${_}`)}}),this._protocol.setWorkerId(this._worker.getId());let M=null;typeof C.globals.require!="undefined"&&typeof C.globals.require.getConfig=="function"?M=C.globals.require.getConfig():typeof C.globals.requirejs!="undefined"&&(M=C.globals.requirejs.s.contexts._.config);const A=P.getAllMethodNames(h);this._onModuleLoaded=this._protocol.sendMessage(d,[this._worker.getId(),JSON.parse(JSON.stringify(M)),o,A]);const R=(_,Q)=>this._request(_,Q),T=(_,Q)=>this._protocol.listen(_,Q);this._lazyProxy=new Promise((_,Q)=>{w=Q,this._onModuleLoaded.then(ne=>{_(u(ne,R,T))},ne=>{Q(ne),this._onError("Worker failed to load "+o,ne)})})}getProxyObject(){return this._lazyProxy}_request(i,o){return new Promise((h,w)=>{this._onModuleLoaded.then(()=>{this._protocol.sendMessage(i,o).then(h,w)},w)})}_onError(i,o){console.error(i),console.info(o)}}e.SimpleWorkerClient=k;function c(n){return n[0]==="o"&&n[1]==="n"&&I.isUpperAsciiLetter(n.charCodeAt(2))}function a(n){return/^onDynamic/.test(n)&&I.isUpperAsciiLetter(n.charCodeAt(9))}function u(n,i,o){const h=A=>function(){const R=Array.prototype.slice.call(arguments,0);return i(A,R)},w=A=>function(R){return o(A,R)};let M={};for(const A of n){if(a(A)){M[A]=w(A);continue}if(c(A)){M[A]=o(A,void 0);continue}M[A]=h(A)}return M}class s{constructor(i,o){this._requestHandlerFactory=o,this._requestHandler=null,this._protocol=new v({sendMessage:(h,w)=>{i(h,w)},handleMessage:(h,w)=>this._handleMessage(h,w),handleEvent:(h,w)=>this._handleEvent(h,w)})}onmessage(i){this._protocol.handleMessage(i)}_handleMessage(i,o){if(i===d)return this.initialize(o[0],o[1],o[2],o[3]);if(!this._requestHandler||typeof this._requestHandler[i]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+i));try{return Promise.resolve(this._requestHandler[i].apply(this._requestHandler,o))}catch(h){return Promise.reject(h)}}_handleEvent(i,o){if(!this._requestHandler)throw new Error("Missing requestHandler");if(a(i)){const h=this._requestHandler[i].call(this._requestHandler,o);if(typeof h!="function")throw new Error(`Missing dynamic event ${i} on request handler.`);return h}if(c(i)){const h=this._requestHandler[i];if(typeof h!="function")throw new Error(`Missing event ${i} on request handler.`);return h}throw new Error(`Malformed event name ${i}`)}initialize(i,o,h,w){this._protocol.setWorkerId(i);const R=u(w,(T,_)=>this._protocol.sendMessage(T,_),(T,_)=>this._protocol.listen(T,_));return this._requestHandlerFactory?(this._requestHandler=this._requestHandlerFactory(R),Promise.resolve(P.getAllMethodNames(this._requestHandler))):(o&&(typeof o.baseUrl!="undefined"&&delete o.baseUrl,typeof o.paths!="undefined"&&typeof o.paths.vs!="undefined"&&delete o.paths.vs,typeof o.trustedTypesPolicy!==void 0&&delete o.trustedTypesPolicy,o.catchError=!0,C.globals.require.config(o)),new Promise((T,_)=>{(C.globals.require||j)([h],ne=>{if(this._requestHandler=ne.create(R),!this._requestHandler){_(new Error("No RequestHandler!"));return}T(P.getAllMethodNames(this._requestHandler))},_)}))}}e.SimpleWorkerServer=s;function l(n){return new s(n,null)}e.create=l}),define(Z[113],x([0,1,60,27,42]),function(j,e,p,r,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function C(P,I){if(await new Promise((y,b)=>{const m=r.createReadStream(P),S=p.createHash("sha1");m.pipe(S);const t=(0,D.once)((g,E)=>{m.removeAllListeners(),S.removeAllListeners(),g?b(g):y(E)});m.once("error",t),m.once("end",t),S.once("error",t),S.once("data",g=>t(void 0,g.toString("hex")))})!==I)throw new Error("Hash mismatch")}e.checksum=C}),define(Z[114],x([0,1,245]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class r{constructor(C="utf8"){this.stringDecoder=new p.StringDecoder(C),this.remaining=null}write(C){const P=[],I=this.remaining?this.remaining+this.stringDecoder.write(C):this.stringDecoder.write(C);if(I.length<1)return P;let d=0,f,y=d;for(;y<I.length;)if(f=I.charCodeAt(y),f===13||f===10){if(P.push(I.substring(d,y)),y++,y<I.length){const b=f;f=I.charCodeAt(y),(b===13&&f===10||b===10&&f===13)&&y++}d=y}else y++;return this.remaining=d<I.length?I.substr(d):null,P}end(){return this.remaining}}e.LineDecoder=r}),define(Z[115],x([0,1,26]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const r=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function D(P){const I=P.replace(/\-/g,":").toLowerCase();return!r.has(I)}function C(){const P=(0,p.networkInterfaces)();for(let I in P){const d=P[I];if(d){for(const{mac:f}of d)if(D(f))return f}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=C}),define(Z[71],x([0,1,26,16,39,31,115]),function(j,e,p,r,D,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(y){return this._virtualMachineOUIs||(this._virtualMachineOUIs=D.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(y)}value(){if(this._value===void 0){let y=0,b=0;const m=(0,p.networkInterfaces)();for(let S in m){const t=m[S];if(t)for(const{mac:g,internal:E}of t)E||(b+=1,this._isVirtualMachineMacAddress(g.toUpperCase())&&(y+=1))}this._value=b>0?y/b:0}return this._value}};let I;async function d(){return I||(I=(async()=>await f()||C.generateUuid())()),I}e.getMachineId=d;async function f(){try{const y=await new Promise((m,S)=>{j(["crypto"],m,S)}),b=(0,P.getMac)();return y.createHash("sha256").update(b,"utf8").digest("hex")}catch(y){r.onUnexpectedError(y);return}}}),define(Z[21],x([0,1,27,26,116,9,32,70,8,3,15,7,31]),function(j,e,p,r,D,C,P,I,d,f,y,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var S;(function(O){O[O.UNLINK=0]="UNLINK",O[O.MOVE=1]="MOVE"})(S=e.RimRafMode||(e.RimRafMode={}));async function t(O,H=S.UNLINK){if((0,P.isRootOrDriveLetter)(O))throw new Error("rimraf - will refuse to recursively delete root");return H===S.UNLINK?E(O):g(O)}async function g(O){try{const H=(0,d.join)((0,r.tmpdir)(),(0,m.generateUuid)());try{await e.Promises.rename(O,H)}catch{return E(O)}E(H).catch(q=>{})}catch(H){if(H.code!=="ENOENT")throw H}}async function E(O){return e.Promises.rmdir(O,{recursive:!0,maxRetries:3})}function v(O){if((0,P.isRootOrDriveLetter)(O))throw new Error("rimraf - will refuse to recursively delete root");p.rmdirSync(O,{recursive:!0})}e.rimrafSync=v;async function k(O,H){return u(await(H?c(O):(0,D.promisify)(p.readdir)(O)))}async function c(O){try{return await(0,D.promisify)(p.readdir)(O,{withFileTypes:!0})}catch(Y){console.warn("[node.js fs] readdir with filetypes failed with error: ",Y)}const H=[],q=await k(O);for(const Y of q){let $=!1,K=!1,te=!1;try{const B=await e.Promises.lstat((0,d.join)(O,Y));$=B.isFile(),K=B.isDirectory(),te=B.isSymbolicLink()}catch(B){console.warn("[node.js fs] unexpected error from lstat after readdir: ",B)}H.push({name:Y,isFile:()=>$,isDirectory:()=>K,isSymbolicLink:()=>te})}return H}function a(O){return u(p.readdirSync(O))}e.readdirSync=a;function u(O){return O.map(H=>typeof H=="string"?f.isMacintosh?(0,I.normalizeNFC)(H):H:(H.name=f.isMacintosh?(0,I.normalizeNFC)(H.name):H.name,H))}async function s(O){const H=await k(O),q=[];for(const Y of H)await n.existsDirectory((0,d.join)(O,Y))&&q.push(Y);return q}function l(O,H=1e3){return new Promise(q=>{let Y=!1;const $=setInterval(()=>{Y||(Y=!0,p.access(O,K=>{Y=!1,K&&(clearInterval($),q(void 0))}))},H)})}e.whenDeleted=l;var n;(function(O){async function H($){let K;try{if(K=await e.Promises.lstat($),!K.isSymbolicLink())return{stat:K}}catch{}try{return{stat:await e.Promises.stat($),symbolicLink:K?.isSymbolicLink()?{dangling:!1}:void 0}}catch(te){if(te.code==="ENOENT"&&K)return{stat:K,symbolicLink:{dangling:!0}};if(f.isWindows&&te.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink($)),symbolicLink:{dangling:!1}}}catch(B){if(B.code==="ENOENT"&&K)return{stat:K,symbolicLink:{dangling:!0}};throw B}throw te}}O.stat=H;async function q($){try{const{stat:K,symbolicLink:te}=await O.stat($);return K.isFile()&&te?.dangling!==!0}catch{}return!1}O.existsFile=q;async function Y($){try{const{stat:K,symbolicLink:te}=await O.stat($);return K.isDirectory()&&te?.dangling!==!0}catch{}return!1}O.existsDirectory=Y})(n=e.SymlinkSupport||(e.SymlinkSupport={}));const i=new C.ResourceQueue;function o(O,H,q){return i.queueFor(b.URI.file(O),y.extUriBiasedIgnorePathCase).queue(()=>{const Y=A(q);return new Promise(($,K)=>w(O,H,Y,te=>te?K(te):$()))})}let h=!0;function w(O,H,q,Y){if(!h)return p.writeFile(O,H,{mode:q.mode,flag:q.flag},Y);p.open(O,q.flag,q.mode,($,K)=>{if($)return Y($);p.writeFile(K,H,te=>{if(te)return p.close(K,()=>Y(te));p.fdatasync(K,B=>(B&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",B),h=!1),p.close(K,L=>Y(L))))})})}function M(O,H,q){const Y=A(q);if(!h)return p.writeFileSync(O,H,{mode:Y.mode,flag:Y.flag});const $=p.openSync(O,Y.flag,Y.mode);try{p.writeFileSync($,H);try{p.fdatasyncSync($)}catch(K){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",K),h=!1}}finally{p.closeSync($)}}e.writeFileSync=M;function A(O){return O?{mode:typeof O.mode=="number"?O.mode:438,flag:typeof O.flag=="string"?O.flag:"w"}:{mode:438,flag:"w"}}async function R(O,H){if(O===H)return;async function q(Y){try{const $=await e.Promises.lstat(Y);if($.isDirectory()||$.isSymbolicLink())return;await e.Promises.utimes(Y,$.atime,new Date)}catch{}}try{await e.Promises.rename(O,H),await q(H)}catch(Y){if(O.toLowerCase()!==H.toLowerCase()&&Y.code==="EXDEV"||O.endsWith("."))await T(O,H,{preserveSymlinks:!1}),await t(O,S.MOVE),await q(H);else throw Y}}async function T(O,H,q){return Q(O,H,{root:{source:O,target:H},options:q,handledSourcePaths:new Set})}const _=511;async function Q(O,H,q){if(q.handledSourcePaths.has(O))return;q.handledSourcePaths.add(O);const{stat:Y,symbolicLink:$}=await n.stat(O);if($){if(q.options.preserveSymlinks)try{return await X(O,H,q)}catch(K){console.warn("[node.js fs] copy of symlink failed: ",K)}if($.dangling)return}return Y.isDirectory()?ne(O,H,Y.mode&_,q):oe(O,H,Y.mode&_)}async function ne(O,H,q,Y){await e.Promises.mkdir(H,{recursive:!0,mode:q});const $=await k(O);for(const K of $)await Q((0,d.join)(O,K),(0,d.join)(H,K),Y)}async function oe(O,H,q){await e.Promises.copyFile(O,H),await e.Promises.chmod(H,q)}async function X(O,H,q){let Y=await e.Promises.readlink(O);(0,P.isEqualOrParent)(Y,q.root.source,!f.isLinux)&&(Y=(0,d.join)(q.root.target,Y.substr(q.root.source.length+1))),await e.Promises.symlink(Y,H)}e.Promises=new class{get access(){return(0,D.promisify)(p.access)}get stat(){return(0,D.promisify)(p.stat)}get lstat(){return(0,D.promisify)(p.lstat)}get utimes(){return(0,D.promisify)(p.utimes)}get read(){return(0,D.promisify)(p.read)}get readFile(){return(0,D.promisify)(p.readFile)}get write(){return(0,D.promisify)(p.write)}get appendFile(){return(0,D.promisify)(p.appendFile)}get fdatasync(){return(0,D.promisify)(p.fdatasync)}get truncate(){return(0,D.promisify)(p.truncate)}get rename(){return(0,D.promisify)(p.rename)}get copyFile(){return(0,D.promisify)(p.copyFile)}get open(){return(0,D.promisify)(p.open)}get close(){return(0,D.promisify)(p.close)}get symlink(){return(0,D.promisify)(p.symlink)}get readlink(){return(0,D.promisify)(p.readlink)}get chmod(){return(0,D.promisify)(p.chmod)}get mkdir(){return(0,D.promisify)(p.mkdir)}get unlink(){return(0,D.promisify)(p.unlink)}get rmdir(){return(0,D.promisify)(p.rmdir)}get realpath(){return(0,D.promisify)(p.realpath)}async exists(O){try{return await e.Promises.access(O),!0}catch{return!1}}get readdir(){return k}get readDirsInDir(){return s}get writeFile(){return o}get rm(){return t}get move(){return R}get copy(){return T}}}),define(Z[82],x([0,1,27,8,25,21]),function(j,e,p,r,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function P(y){const b=(0,r.dirname)(y);if(y===b)return y;const m=((0,r.basename)(y)||y).toLowerCase();try{const t=(0,C.readdirSync)(b).filter(g=>g.toLowerCase()===m);if(t.length===1){const g=P(b);if(g)return(0,r.join)(g,t[0])}else if(t.length>1){const g=t.indexOf(m);if(g>=0){const E=P(b);if(E)return(0,r.join)(E,t[g])}}}catch{}return null}e.realcaseSync=P;async function I(y){try{return await C.Promises.realpath(y)}catch{const m=f(y);return await C.Promises.access(m,p.constants.R_OK),m}}e.realpath=I;function d(y){try{return p.realpathSync(y)}catch{const m=f(y);return p.accessSync(m,p.constants.R_OK),m}}e.realpathSync=d;function f(y){return(0,D.rtrim)((0,r.normalize)(y),r.sep)}}),define(Z[117],x([0,1,61]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function r(I,d,f,y=1){let b=!1;return new Promise(m=>{const S=setTimeout(()=>{if(!b)return b=!0,m(0)},f);D(I,d,y,t=>{if(!b)return b=!0,clearTimeout(S),m(t)})})}e.findFreePort=r;function D(I,d,f,y){if(d===0)return y(0);const b=new p.Socket;b.once("connect",()=>(P(b),D(I+f,d-1,f,y))),b.once("data",()=>{}),b.once("error",m=>(P(b),m.code!=="ECONNREFUSED"?D(I+f,d-1,f,y):y(I))),b.connect(I,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function C(I,d,f){let y=!1,b,m=1;const S=p.createServer({pauseOnConnect:!0});function t(g,E){y||(y=!0,S.removeAllListeners(),S.close(),b&&clearTimeout(b),E(g))}return new Promise(g=>{b=setTimeout(()=>{t(0,g)},f),S.on("listening",()=>{t(I,g)}),S.on("error",E=>{E&&(E.code==="EADDRINUSE"||E.code==="EACCES")&&m<d?(I++,m++,S.listen(I,"127.0.0.1")):t(0,g)}),S.on("close",()=>{t(0,g)}),S.listen(I,"127.0.0.1")})}e.findFreePortFaster=C;function P(I){try{I.removeAllListeners("connect"),I.removeAllListeners("error"),I.end(),I.destroy(),I.unref()}catch(d){console.error(d)}}}),define(Z[118],x([0,1,26,8,21]),function(j,e,p,r,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const C=/^\d+$/,P=/^Microsoft.PowerShell_.*/,I=/^Microsoft.PowerShellPreview_.*/;var d;(function(a){a[a.x64=0]="x64",a[a.x86=1]="x86",a[a.ARM=2]="ARM"})(d||(d={}));let f;switch(process.arch){case"ia32":case"x32":f=1;break;case"arm":case"arm64":f=2;break;default:f=0;break}let y;process.env.PROCESSOR_ARCHITEW6432?y=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?y=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?y=1:y=0;class b{constructor(u,s,l){this.exePath=u,this.displayName=s,this.knownToExist=l}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await D.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function m({useAlternateBitness:a=!1}={}){return a?f===0?process.env["ProgramFiles(x86)"]||null:y===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function S({useAlternateBitness:a=!1,findPreview:u=!1}={}){const s=m({useAlternateBitness:a});if(!s)return null;const l=r.join(s,"PowerShell");if(!await D.SymlinkSupport.existsDirectory(l))return null;let n=-1,i=null;for(const w of await D.Promises.readdir(l)){let M=-1;if(u){const R=w.indexOf("-");if(R<0)continue;const T=w.substring(0,R);if(!C.test(T)||w.substring(R+1)!=="preview")continue;M=parseInt(T,10)}else{if(!C.test(w))continue;M=parseInt(w,10)}if(M<=n)continue;const A=r.join(l,w,"pwsh.exe");!await D.SymlinkSupport.existsFile(A)||(i=A,n=M)}if(!i)return null;const o=s.includes("x86")?" (x86)":"",h=u?" Preview":"";return new b(i,`PowerShell${h}${o}`,!0)}async function t({findPreview:a}={}){if(!process.env.LOCALAPPDATA)return null;const u=r.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await D.SymlinkSupport.existsDirectory(u))return null;const{pwshMsixDirRegex:s,pwshMsixName:l}=a?{pwshMsixDirRegex:I,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:P,pwshMsixName:"PowerShell (Store)"};for(const n of await D.Promises.readdir(u))if(s.test(n)){const i=r.join(u,n,"pwsh.exe");return new b(i,l)}return null}function g(){const a=r.join(p.homedir(),".dotnet","tools","pwsh.exe");return new b(a,".NET Core PowerShell Global Tool")}function E(){const a=r.join(process.env.windir,f===1&&y!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new b(a,"Windows PowerShell",!0)}async function*v(){let a=await S();a&&(yield a),a=await S({useAlternateBitness:!0}),a&&(yield a),a=await t(),a&&(yield a),a=g(),a&&(yield a),a=await S({findPreview:!0}),a&&(yield a),a=await t({findPreview:!0}),a&&(yield a),a=await S({useAlternateBitness:!0,findPreview:!0}),a&&(yield a),a=E(),a&&(yield a)}async function*k(){for await(const a of v())await a.exists()&&(yield a)}e.enumeratePowerShellInstallations=k;async function c(){for await(const a of k())return a;return null}e.getFirstAvailablePowerShellInstallation=c}),define(Z[83],x([0,1,43,10]),function(j,e,p,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function D(P){return new Promise((I,d)=>{let f;const y=new Map;function b(S,t,g,E,v){const k=y.get(t);if(S===P||k){const c={name:m(g),cmd:g,pid:S,ppid:t,load:E,mem:v};y.set(S,c),S===P&&(f=c),k&&(k.children||(k.children=[]),k.children.push(c),k.children.length>1&&(k.children=k.children.sort((a,u)=>a.pid-u.pid)))}}function m(S){const t=/--vscode-window-kind=shared-process/,g=/--vscode-window-kind=issue-reporter/,E=/--vscode-window-kind=process-explorer/,v=/--utility-sub-type=network/,k=/--crashes-directory/,c=/\\pipe\\winpty-control/,a=/conhost\.exe/,u=/--type=([a-zA-Z-]+)/;if(k.exec(S))return"electron-crash-reporter";if(c.exec(S))return"winpty-process";if(a.exec(S))return"console-window-host (Windows internal process)";let s=u.exec(S);if(s&&s.length===2)return s[1]==="renderer"?t.exec(S)?"shared-process":g.exec(S)?"issue-reporter":E.exec(S)?"process-explorer":"window":s[1]==="utility"&&v.exec(S)?"utility-network-service":s[1];const l=/[a-zA-Z-]+\.js/g;let n="";do s=l.exec(S),s&&(n+=s+" ");while(s);return n&&S.indexOf("node ")<0&&S.indexOf("node.exe")<0?`electron_node ${n}`:S}if(process.platform==="win32"){const S=t=>t.indexOf("\\\\?\\")===0||t.indexOf("\\??\\")===0?t.substr(4):t.indexOf('"\\\\?\\')===0||t.indexOf('"\\??\\')===0?'"'+t.substr(5):t;new Promise((t,g)=>{j(["windows-process-tree"],t,g)}).then(t=>{t.getProcessList(P,g=>{t.getProcessCpuUsage(g,E=>{const v=new Map;E.forEach(k=>{const c=S(k.commandLine||"");v.set(k.pid,{name:m(c),cmd:c,pid:k.pid,ppid:k.ppid,load:k.cpu||0,mem:k.memory||0})}),f=v.get(P),f?(v.forEach(k=>{const c=v.get(k.ppid);c&&(c.children||(c.children=[]),c.children.push(k))}),v.forEach(k=>{k.children&&(k.children=k.children.sort((c,a)=>c.pid-a.pid))}),I(f)):d(new Error(`Root process ${P} not found`))})},t.ProcessDataFlag.CommandLine|t.ProcessDataFlag.Memory)})}else{let S=function(){let t=[f];const g=[];for(;t.length;){const v=t.shift();v&&(g.push(v.pid),v.children&&(t=t.concat(v.children)))}let E=JSON.stringify(r.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",j).fsPath);E+=" "+g.join(" "),(0,p.exec)(E,{},(v,k,c)=>{if(v||c)d(v||new Error(c.toString()));else{const a=k.toString().split(`
`);for(let u=0;u<g.length;u++){const s=y.get(g[u]);s.load=parseFloat(a[u])}if(!f){d(new Error(`Root process ${P} not found`));return}I(f)}})};(0,p.exec)("which ps",{},(t,g,E)=>{if(t||E)if(process.platform!=="linux")d(t||new Error(E.toString()));else{const v=JSON.stringify(r.FileAccess.asFileUri("vs/base/node/ps.sh",j).fsPath);(0,p.exec)(v,{},(k,c,a)=>{k||a?d(k||new Error(a.toString())):(C(c,b),S())})}else{const v=g.toString().trim(),k="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,p.exec)(`${v} ${k}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(c,a,u)=>{c||u&&!u.includes("screen size is bogus")?d(c||new Error(u.toString())):(C(a,b),process.platform==="linux"?S():f?I(f):d(new Error(`Root process ${P} not found`)))})}})}})}e.listProcesses=D;function C(P,I){const d=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,f=P.toString().split(`
`);for(const y of f){const b=d.exec(y.trim());b&&b.length===6&&I(parseInt(b[1]),parseInt(b[2]),b[5],parseFloat(b[3]),parseFloat(b[4]))}}}),define(Z[119],x([0,1,27,23,32,2,70,8,3,21]),function(j,e,p,r,D,C,P,I,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function y(t,g,E){return m({path:t,isDirectory:!1},g,E)}e.watchFile=y;function b(t,g,E){return m({path:t,isDirectory:!0},g,E)}e.watchFolder=b,e.CHANGE_BUFFER_DELAY=100;function m(t,g,E){if(d.isMacintosh&&(0,D.isEqualOrParent)(t.path,"/Volumes/"))return E(`Refusing to watch ${t.path} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),C.Disposable.None;const v=(0,I.basename)(t.path),k=new Map;let c=!1,a=[(0,C.toDisposable)(()=>{k.forEach(u=>(0,C.dispose)(u)),k.clear()})];try{const u=(0,p.watch)(t.path);a.push((0,C.toDisposable)(()=>{u.removeAllListeners(),u.close()}));const s=new Set;t.isDirectory&&f.Promises.readdir(t.path).then(l=>l.forEach(n=>s.add(n))),u.on("error",(l,n)=>{c||E(`Failed to watch ${t.path} for changes using fs.watch() (${l}, ${n})`)}),u.on("change",(l,n)=>{if(c)return;let i="";if(n&&(i=n.toString(),d.isMacintosh&&(i=(0,P.normalizeNFC)(i))),!i||l!=="change"&&l!=="rename")return;const o=t.isDirectory?(0,I.join)(t.path,i):t.path;if(t.isDirectory)if(l==="rename"){const h=k.get(o);h&&(0,C.dispose)(h);const w=setTimeout(async()=>{k.delete(o);const M=await f.Promises.exists(o);if(c)return;let A;M?s.has(i)?A="changed":(A="added",s.add(i)):(s.delete(i),A="deleted"),g(A,o)},e.CHANGE_BUFFER_DELAY);k.set(o,(0,C.toDisposable)(()=>clearTimeout(w)))}else{let h;s.has(i)?h="changed":(h="added",s.add(i)),g(h,o)}else if(l==="rename"||i!==v){const h=setTimeout(async()=>{const w=await f.Promises.exists(o);c||(w?(g("changed",o),a=[m(t,g,E)]):g("deleted",o))},e.CHANGE_BUFFER_DELAY);(0,C.dispose)(a),a=[(0,C.toDisposable)(()=>clearTimeout(h))]}else g("changed",o)})}catch(u){f.Promises.exists(t.path).then(s=>{s&&!c&&E(`Failed to watch ${t.path} for changes using fs.watch() (${u.toString()})`)})}return(0,C.toDisposable)(()=>{c=!0,a=(0,C.dispose)(a)})}async function S(t,g,E,v=512){const k=await f.Promises.open(t,"r"),c=Buffer.allocUnsafe(v),a=new r.CancellationTokenSource(E);let u,s=!1;const l=y(t,async n=>{if(n==="changed"){if(s)return;s=!0;try{for(;!a.token.isCancellationRequested;){const{bytesRead:i}=await f.Promises.read(k,c,0,v,null);if(!i||a.token.isCancellationRequested)break;g(c.slice(0,i))}}catch(i){u=new Error(i),a.dispose(!0)}finally{s=!1}}},n=>{u=new Error(n),a.dispose(!0)});return new Promise((n,i)=>{a.token.onCancellationRequested(async()=>{l.dispose(),await f.Promises.close(k),u?i(u):n()})})}e.watchFileContents=S}),define(Z[120],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(Z[121],x([0,1,14,13,120]),function(j,e,p,r,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function C(){p.ipcMain.on(D.CONTEXT_MENU_CHANNEL,(I,d,f,y,b)=>{const m=P(I,y,f);m.popup({window:(0,r.withNullAsUndefined)(p.BrowserWindow.fromWebContents(I.sender)),x:b?b.x:void 0,y:b?b.y:void 0,positioningItem:b?b.positioningItem:void 0,callback:()=>{m&&I.sender.send(D.CONTEXT_MENU_CLOSE_CHANNEL,d)}})})}e.registerContextMenuListener=C;function P(I,d,f){const y=new p.Menu;return f.forEach(b=>{let m;b.type==="separator"?m=new p.MenuItem({type:b.type}):Array.isArray(b.submenu)?m=new p.MenuItem({submenu:P(I,d,b.submenu),label:b.label}):m=new p.MenuItem({label:b.label,type:b.type,accelerator:b.accelerator,checked:b.checked,enabled:b.enabled,visible:b.visible,click:(S,t,g)=>I.sender.send(d,b.id,g)}),y.append(m)}),y}});var fe=this&&this.__decorate||function(j,e,p,r){var D=arguments.length,C=D<3?e:r===null?r=Object.getOwnPropertyDescriptor(e,p):r,P;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")C=Reflect.decorate(j,e,p,r);else for(var I=j.length-1;I>=0;I--)(P=j[I])&&(C=(D<3?P(C):D>3?P(e,p,C):P(e,p))||C);return D>3&&C&&Object.defineProperty(e,p,C),C};define(Z[36],x([0,1,30,9,17,23,46,16,4,2,110,25,13]),function(j,e,p,r,D,C,P,I,d,f,y,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var S;(function($){$[$.Promise=100]="Promise",$[$.PromiseCancel=101]="PromiseCancel",$[$.EventListen=102]="EventListen",$[$.EventDispose=103]="EventDispose"})(S=e.RequestType||(e.RequestType={}));function t($){switch($){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var g;(function($){$[$.Initialize=200]="Initialize",$[$.PromiseSuccess=201]="PromiseSuccess",$[$.PromiseError=202]="PromiseError",$[$.PromiseErrorObj=203]="PromiseErrorObj",$[$.EventFire=204]="EventFire"})(g=e.ResponseType||(e.ResponseType={}));function E($){switch($){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var v;(function($){$[$.Uninitialized=0]="Uninitialized",$[$.Idle=1]="Idle"})(v||(v={}));class k{constructor(K){this.buffer=K,this.pos=0}read(K){const te=this.buffer.slice(this.pos,this.pos+K);return this.pos+=te.byteLength,te}}class c{constructor(){this.buffers=[]}get buffer(){return D.VSBuffer.concat(this.buffers)}write(K){this.buffers.push(K)}}var a;(function($){$[$.Undefined=0]="Undefined",$[$.String=1]="String",$[$.Buffer=2]="Buffer",$[$.VSBuffer=3]="VSBuffer",$[$.Array=4]="Array",$[$.Object=5]="Object"})(a||(a={}));function u($){const K=D.VSBuffer.alloc(4);return K.writeUInt32BE($,0),K}function s($){return $.read(4).readUInt32BE(0)}function l($){const K=D.VSBuffer.alloc(1);return K.writeUInt8($,0),K}const n={Undefined:l(a.Undefined),String:l(a.String),Buffer:l(a.Buffer),VSBuffer:l(a.VSBuffer),Array:l(a.Array),Object:l(a.Object)},i=typeof Buffer!="undefined";function o($,K){if(typeof K=="undefined")$.write(n.Undefined);else if(typeof K=="string"){const te=D.VSBuffer.fromString(K);$.write(n.String),$.write(u(te.byteLength)),$.write(te)}else if(i&&Buffer.isBuffer(K)){const te=D.VSBuffer.wrap(K);$.write(n.Buffer),$.write(u(te.byteLength)),$.write(te)}else if(K instanceof D.VSBuffer)$.write(n.VSBuffer),$.write(u(K.byteLength)),$.write(K);else if(Array.isArray(K)){$.write(n.Array),$.write(u(K.length));for(const te of K)o($,te)}else{const te=D.VSBuffer.fromString(JSON.stringify(K));$.write(n.Object),$.write(u(te.byteLength)),$.write(te)}}function h($){switch($.read(1).readUInt8(0)){case a.Undefined:return;case a.String:return $.read(s($)).toString();case a.Buffer:return $.read(s($)).buffer;case a.VSBuffer:return $.read(s($));case a.Array:{const te=s($),B=[];for(let L=0;L<te;L++)B.push(h($));return B}case a.Object:return JSON.parse($.read(s($)).toString())}}class w{constructor(K,te,B=null,L=1e3){this.protocol=K,this.ctx=te,this.logger=B,this.timeoutDelay=L,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(W=>this.onRawMessage(W)),this.sendResponse({type:200})}registerChannel(K,te){this.channels.set(K,te),setTimeout(()=>this.flushPendingRequests(K),0)}sendResponse(K){switch(K.type){case 200:{const te=this.send([K.type]);this.logger&&this.logger.logOutgoing(te,0,1,E(K.type));return}case 201:case 202:case 204:case 203:{const te=this.send([K.type,K.id],K.data);this.logger&&this.logger.logOutgoing(te,K.id,1,E(K.type),K.data);return}}}send(K,te=void 0){const B=new c;return o(B,K),o(B,te),this.sendBuffer(B.buffer)}sendBuffer(K){try{return this.protocol.send(K),K.byteLength}catch{return 0}}onRawMessage(K){const te=new k(K),B=h(te),L=h(te),W=B[0];switch(W){case 100:return this.logger&&this.logger.logIncoming(K.byteLength,B[1],1,`${t(W)}: ${B[2]}.${B[3]}`,L),this.onPromise({type:W,id:B[1],channelName:B[2],name:B[3],arg:L});case 102:return this.logger&&this.logger.logIncoming(K.byteLength,B[1],1,`${t(W)}: ${B[2]}.${B[3]}`,L),this.onEventListen({type:W,id:B[1],channelName:B[2],name:B[3],arg:L});case 101:return this.logger&&this.logger.logIncoming(K.byteLength,B[1],1,`${t(W)}`),this.disposeActiveRequest({type:W,id:B[1]});case 103:return this.logger&&this.logger.logIncoming(K.byteLength,B[1],1,`${t(W)}`),this.disposeActiveRequest({type:W,id:B[1]})}}onPromise(K){const te=this.channels.get(K.channelName);if(!te){this.collectPendingRequest(K);return}const B=new C.CancellationTokenSource;let L;try{L=te.call(this.ctx,K.name,K.arg,B.token)}catch(N){L=Promise.reject(N)}const W=K.id;L.then(N=>{this.sendResponse({id:W,data:N,type:201}),this.activeRequests.delete(K.id)},N=>{N instanceof Error?this.sendResponse({id:W,data:{message:N.message,name:N.name,stack:N.stack?N.stack.split?N.stack.split(`
`):N.stack:void 0},type:202}):this.sendResponse({id:W,data:N,type:203}),this.activeRequests.delete(K.id)});const F=(0,f.toDisposable)(()=>B.cancel());this.activeRequests.set(K.id,F)}onEventListen(K){const te=this.channels.get(K.channelName);if(!te){this.collectPendingRequest(K);return}const B=K.id,W=te.listen(this.ctx,K.name,K.arg)(F=>this.sendResponse({id:B,data:F,type:204}));this.activeRequests.set(K.id,W)}disposeActiveRequest(K){const te=this.activeRequests.get(K.id);te&&(te.dispose(),this.activeRequests.delete(K.id))}collectPendingRequest(K){let te=this.pendingRequests.get(K.channelName);te||(te=[],this.pendingRequests.set(K.channelName,te));const B=setTimeout(()=>{console.error(`Unknown channel: ${K.channelName}`),K.type===100&&this.sendResponse({id:K.id,data:{name:"Unknown channel",message:`Channel name '${K.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);te.push({request:K,timeoutTimer:B})}flushPendingRequests(K){const te=this.pendingRequests.get(K);if(te){for(const B of te)switch(clearTimeout(B.timeoutTimer),B.request.type){case 100:this.onPromise(B.request);break;case 102:this.onEventListen(B.request);break}this.pendingRequests.delete(K)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(K=>K.dispose()),this.activeRequests.clear()}}e.ChannelServer=w;var M;(function($){$[$.LocalSide=0]="LocalSide",$[$.OtherSide=1]="OtherSide"})(M=e.RequestInitiator||(e.RequestInitiator={}));class A{constructor(K,te=null){this.protocol=K,this.isDisposed=!1,this.state=v.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new d.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(B=>this.onBuffer(B)),this.logger=te}getChannel(K){const te=this;return{call(B,L,W){return te.isDisposed?Promise.reject(I.canceled()):te.requestPromise(K,B,L,W)},listen(B,L){return te.isDisposed?Promise.reject(I.canceled()):te.requestEvent(K,B,L)}}}requestPromise(K,te,B,L=C.CancellationToken.None){const W=this.lastRequestId++,N={id:W,type:100,channelName:K,name:te,arg:B};if(L.isCancellationRequested)return Promise.reject(I.canceled());let V;return new Promise((z,ee)=>{if(L.isCancellationRequested)return ee(I.canceled());const re=()=>{const le=ue=>{switch(ue.type){case 201:this.handlers.delete(W),z(ue.data);break;case 202:this.handlers.delete(W);const me=new Error(ue.data.message);me.stack=ue.data.stack,me.name=ue.data.name,ee(me);break;case 203:this.handlers.delete(W),ee(ue.data);break}};this.handlers.set(W,le),this.sendRequest(N)};let se=null;this.state===v.Idle?re():(se=(0,r.createCancelablePromise)(le=>this.whenInitialized()),se.then(()=>{se=null,re()}));const J=()=>{se?(se.cancel(),se=null):this.sendRequest({id:W,type:101}),ee(I.canceled())},ce=L.onCancellationRequested(J);V=(0,f.combinedDisposable)((0,f.toDisposable)(J),ce),this.activeRequests.add(V)}).finally(()=>{this.activeRequests.delete(V)})}requestEvent(K,te,B){const L=this.lastRequestId++,F={id:L,type:102,channelName:K,name:te,arg:B};let N=null;const V=new d.Emitter({onFirstListenerAdd:()=>{N=(0,r.createCancelablePromise)(z=>this.whenInitialized()),N.then(()=>{N=null,this.activeRequests.add(V),this.sendRequest(F)})},onLastListenerRemove:()=>{N?(N.cancel(),N=null):(this.activeRequests.delete(V),this.sendRequest({id:L,type:103}))}}),U=z=>V.fire(z.data);return this.handlers.set(L,U),V.event}sendRequest(K){switch(K.type){case 100:case 102:{const te=this.send([K.type,K.id,K.channelName,K.name],K.arg);this.logger&&this.logger.logOutgoing(te,K.id,0,`${t(K.type)}: ${K.channelName}.${K.name}`,K.arg);return}case 101:case 103:{const te=this.send([K.type,K.id]);this.logger&&this.logger.logOutgoing(te,K.id,0,t(K.type));return}}}send(K,te=void 0){const B=new c;return o(B,K),o(B,te),this.sendBuffer(B.buffer)}sendBuffer(K){try{return this.protocol.send(K),K.byteLength}catch{return 0}}onBuffer(K){const te=new k(K),B=h(te),L=h(te),W=B[0];switch(W){case 200:return this.logger&&this.logger.logIncoming(K.byteLength,0,0,E(W)),this.onResponse({type:B[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(K.byteLength,B[1],0,E(W),L),this.onResponse({type:B[0],id:B[1],data:L})}}onResponse(K){if(K.type===200){this.state=v.Idle,this._onDidInitialize.fire();return}const te=this.handlers.get(K.id);te&&te(K)}get onDidInitializePromise(){return d.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===v.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(K=>K.dispose()),this.activeRequests.clear()}}fe([P.memoize],A.prototype,"onDidInitializePromise",null),e.ChannelClient=A;class R{constructor(K){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new d.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new d.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,K(({protocol:te,onDidClientDisconnect:B})=>{d.Event.once(te.onMessage)(W=>{const F=new k(W),N=h(F),V=new w(te,N),U=new A(te);this.channels.forEach((ee,re)=>V.registerChannel(re,ee));const z={channelServer:V,channelClient:U,ctx:N};this._connections.add(z),this._onDidAddConnection.fire(z),B(()=>{V.dispose(),U.dispose(),this._connections.delete(z),this._onDidRemoveConnection.fire(z)})})})}get connections(){const K=[];return this._connections.forEach(te=>K.push(te)),K}getChannel(K,te){const B=this;return{call(L,W,F){let N;if((0,m.isFunction)(te)){let U=(0,p.getRandomElement)(B.connections.filter(te));N=U?Promise.resolve(U):d.Event.toPromise(d.Event.filter(B.onDidAddConnection,te))}else N=te.routeCall(B,L,W);const V=N.then(U=>U.channelClient.getChannel(K));return _(V).call(L,W,F)},listen(L,W){if((0,m.isFunction)(te))return B.getMulticastEvent(K,te,L,W);const F=te.routeEvent(B,L,W).then(N=>N.channelClient.getChannel(K));return _(F).listen(L,W)}}}getMulticastEvent(K,te,B,L){const W=this;let F=new f.DisposableStore;const N=new d.Emitter({onFirstListenerAdd:()=>{F=new f.DisposableStore;const V=new d.EventMultiplexer,U=new Map,z=re=>{const J=re.channelClient.getChannel(K).listen(B,L),ce=V.add(J);U.set(re,ce)},ee=re=>{const se=U.get(re);!se||(se.dispose(),U.delete(re))};W.connections.filter(te).forEach(z),d.Event.filter(W.onDidAddConnection,te)(z,void 0,F),W.onDidRemoveConnection(ee,void 0,F),V.event(N.fire,N,F),F.add(V)},onLastListenerRemove:()=>{F.dispose()}});return N.event}registerChannel(K,te){this.channels.set(K,te),this._connections.forEach(B=>{B.channelServer.registerChannel(K,te)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=R;class T{constructor(K,te,B=null){const L=new c;o(L,te),K.send(L.buffer),this.channelClient=new A(K,B),this.channelServer=new w(K,te,B)}getChannel(K){return this.channelClient.getChannel(K)}registerChannel(K,te){this.channelServer.registerChannel(K,te)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=T;function _($){return{call(K,te,B){return $.then(L=>L.call(K,te,B))},listen(K,te){const B=new d.Relay;return $.then(L=>B.input=L.listen(K,te)),B.event}}}e.getDelayedChannel=_;function Q($){let K=!1;return{call(te,B,L){return K?$.call(te,B,L):(0,r.timeout)(0).then(()=>K=!0).then(()=>$.call(te,B,L))},listen(te,B){if(K)return $.listen(te,B);const L=new d.Relay;return(0,r.timeout)(0).then(()=>K=!0).then(()=>L.input=$.listen(te,B)),L.event}}}e.getNextTickChannel=Q;class ne{constructor(K){this.fn=K}routeCall(K){return this.route(K)}routeEvent(K){return this.route(K)}async route(K){for(const te of K.connections)if(await Promise.resolve(this.fn(te.ctx)))return Promise.resolve(te);return await d.Event.toPromise(K.onDidAddConnection),await this.route(K)}}e.StaticRouter=ne;var oe;(function($){function K(W,F){const N=W,V=F&&F.disableMarshalling,U=new Map;for(const z in N)B(z)&&U.set(z,d.Event.buffer(N[z],!0));return new class{listen(z,ee,re){const se=U.get(ee);if(se)return se;if(L(ee)){const J=N[ee];if(typeof J=="function")return J.call(N,re)}throw new Error(`Event not found: ${ee}`)}call(z,ee,re){const se=N[ee];if(typeof se=="function"){if(!V&&Array.isArray(re))for(let J=0;J<re.length;J++)re[J]=(0,y.revive)(re[J]);return se.apply(N,re)}throw new Error(`Method not found: ${ee}`)}}}$.fromService=K;function te(W,F){const N=F&&F.disableMarshalling;return new Proxy({},{get(V,U){if(typeof U=="string")return F?.properties?.has(U)?F.properties.get(U):L(U)?function(z){return W.listen(U,z)}:B(U)?W.listen(U):async function(...z){let ee;F&&!(0,m.isUndefinedOrNull)(F.context)?ee=[F.context,...z]:ee=z;const re=await W.call(U,ee);return N?re:(0,y.revive)(re)};throw new Error(`Property not found: ${String(U)}`)}})}$.toService=te;function B(W){return W[0]==="o"&&W[1]==="n"&&b.isUpperAsciiLetter(W.charCodeAt(2))}function L(W){return/^onDynamic/.test(W)&&b.isUpperAsciiLetter(W.charCodeAt(9))}})(oe=e.ProxyChannel||(e.ProxyChannel={}));const X=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function O($){if(Array.isArray($))return $;if($&&typeof $=="object"&&typeof $.toString=="function"){let K=$.toString();if(K!=="[object Object]")return K}return $}function H($){return Array.isArray($)?$.map(O):O($)}function q($,K,te,B,L,W,F){F=H(F);const N=X[L],V=N[B%N.length];let U=[`%c[${$}]%c[${String(K).padStart(7," ")}]%c[len: ${String(te).padStart(5," ")}]%c${String(B).padStart(5," ")} - ${W}`,"color: darkgreen","color: grey","color: grey",`color: ${V}`];/\($/.test(W)?(U=U.concat(F),U.push(")")):U.push(F),console.log.apply(console,U)}e.logWithColors=q;class Y{constructor(K,te){this._outgoingPrefix=K,this._incomingPrefix=te,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(K,te,B,L,W){this._totalOutgoing+=K,q(this._outgoingPrefix,this._totalOutgoing,K,te,B,L,W)}logIncoming(K,te,B,L,W){this._totalIncoming+=K,q(this._incomingPrefix,this._totalIncoming,K,te,B,L,W)}}e.IPCLogger=Y}),define(Z[122],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class p{constructor(D,C){this.sender=D,this.onMessage=C}send(D){try{this.sender.send("vscode:message",D.buffer)}catch{}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=p}),define(Z[123],x([0,1,17,4,36]),function(j,e,p,r,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class C{constructor(d){this.port=d,this.onMessage=r.Event.fromDOMEventEmitter(this.port,"message",f=>p.VSBuffer.wrap(f.data)),d.start()}send(d){this.port.postMessage(d.buffer)}disconnect(){this.port.close()}}e.Protocol=C;class P extends D.IPCClient{constructor(d,f){const y=new C(d);super(y,f);this.protocol=y}dispose(){this.protocol.disconnect()}}e.Client=P}),define(Z[84],x([0,1,17,4,2,36]),function(j,e,p,r,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var P;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(P=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var I;(function(i){i.enableDiagnostics=!1,i.records=[];const o=new WeakMap;let h=0;function w(A,R){if(!o.has(A)){const T=String(++h);o.set(A,T)}return o.get(A)}function M(A,R,T,_){if(!i.enableDiagnostics)return;const Q=w(A,R);if(_ instanceof p.VSBuffer||_ instanceof Uint8Array||_ instanceof ArrayBuffer||ArrayBuffer.isView(_)){const ne=p.VSBuffer.alloc(_.byteLength);ne.set(_),i.records.push({timestamp:Date.now(),id:Q,label:R,type:T,buff:ne})}else i.records.push({timestamp:Date.now(),id:Q,label:R,type:T,data:_})}i.traceSocketEvent=M})(I=e.SocketDiagnostics||(e.SocketDiagnostics={}));var d;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(d=e.SocketCloseEventType||(e.SocketCloseEventType={}));let f=null;function y(){return f||(f=p.VSBuffer.alloc(0)),f}class b{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(o){this._chunks.push(o),this._totalLength+=o.byteLength}read(o){return this._read(o,!0)}peek(o){return this._read(o,!1)}_read(o,h){if(o===0)return y();if(o>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===o){const R=this._chunks[0];return h&&(this._chunks.shift(),this._totalLength-=o),R}if(this._chunks[0].byteLength>o){const R=this._chunks[0].slice(0,o);return h&&(this._chunks[0]=this._chunks[0].slice(o),this._totalLength-=o),R}let w=p.VSBuffer.alloc(o),M=0,A=0;for(;o>0;){const R=this._chunks[A];if(R.byteLength>o){const T=R.slice(0,o);w.set(T,M),M+=o,h&&(this._chunks[A]=R.slice(o),this._totalLength-=o),o-=o}else w.set(R,M),M+=R.byteLength,h?(this._chunks.shift(),this._totalLength-=R.byteLength):A++,o-=R.byteLength}return w}}e.ChunkStream=b;var m;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume"})(m||(m={}));function S(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var t;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(t=e.ProtocolConstants||(e.ProtocolConstants={}));class g{constructor(o,h,w,M){this.type=o,this.id=h,this.ack=w,this.data=M,this.writtenTime=0}get size(){return this.data.byteLength}}class E extends D.Disposable{constructor(o){super();this._onMessage=this._register(new r.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=o,this._isDisposed=!1,this._incomingData=new b,this._register(this._socket.onData(h=>this.acceptChunk(h))),this.lastReadTime=Date.now()}acceptChunk(o){if(!(!o||o.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(o);this._incomingData.byteLength>=this._state.readLen;){const h=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=h.readUInt32BE(9),this._state.messageType=h.readUInt8(0),this._state.id=h.readUInt32BE(1),this._state.ack=h.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:S(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const w=this._state.messageType,M=this._state.id,A=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",h),this._onMessage.fire(new g(w,M,A,h)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class v{constructor(o){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=o,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(o){if(this._isDisposed)return;o.writtenTime=Date.now(),this.lastWriteTime=Date.now();const h=p.VSBuffer.alloc(13);h.writeUInt8(o.type,0),h.writeUInt32BE(o.id,1),h.writeUInt32BE(o.ack,5),h.writeUInt32BE(o.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:S(o.type),id:o.id,ack:o.ack,messageSize:o.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",o.data),this._writeSoon(h,o.data)}_bufferAdd(o,h){const w=this._totalLength===0;return this._data.push(o,h),this._totalLength+=o.byteLength+h.byteLength,w}_bufferTake(){const o=p.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,o}_writeSoon(o,h){this._bufferAdd(o,h)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const o=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:o.byteLength}),this._socket.write(o)}}class k extends D.Disposable{constructor(o){super();this._onMessage=new r.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new r.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=o,this._socketWriter=this._register(new v(this._socket)),this._socketReader=this._register(new E(this._socket)),this._register(this._socketReader.onMessage(h=>{h.type===1&&this._onMessage.fire(h.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(o){this._socketWriter.write(new g(1,0,0,o))}}e.Protocol=k;class c extends C.IPCClient{constructor(o,h,w=null){super(o,h,w);this.protocol=o}static fromSocket(o,h){return new c(new k(o),h)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const o=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),o.end()}}e.Client=c;class a{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new r.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(o){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(o):this._emitter.fire(o):this._bufferedMessages.push(o)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=a;class u{constructor(o){this.data=o,this.next=null}}class s{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let o=[],h=0,w=this._first;for(;w;)o[h++]=w.data,w=w.next;return o}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(o){const h=new u(o);if(!this._first){this._first=h,this._last=h;return}this._last.next=h,this._last=h}}class l{constructor(){this.lastRuns=[];const o=Date.now();for(let h=0;h<l._HISTORY_LENGTH;h++)this.lastRuns[h]=o-1e3*h;setInterval(()=>{for(let h=l._HISTORY_LENGTH;h>=1;h--)this.lastRuns[h]=this.lastRuns[h-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return l._INSTANCE||(l._INSTANCE=new l),l._INSTANCE}load(){const o=Date.now(),h=(1+l._HISTORY_LENGTH)*1e3;let w=0;for(let M=0;M<l._HISTORY_LENGTH;M++)o-this.lastRuns[M]<=h&&w++;return 1-w/l._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}l._HISTORY_LENGTH=10,l._INSTANCE=null;class n{constructor(o,h=null,w=l.getInstance()){this._onControlMessage=new a,this.onControlMessage=this._onControlMessage.event,this._onMessage=new a,this.onMessage=this._onMessage.event,this._onDidDispose=new a,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new a,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new a,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=w,this._isReconnecting=!1,this._outgoingUnackMsg=new s,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=o,this._socketWriter=new v(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new E(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(M=>this._receiveMessage(M))),this._socketDisposables.push(this._socket.onClose(M=>this._onSocketClose.fire(M))),h&&this._socketReader.acceptChunk(h)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,D.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const o=new g(5,0,0,y());this._socketWriter.write(o),this._socketWriter.flush()}sendPause(){const o=new g(7,0,0,y());this._socketWriter.write(o)}sendResume(){const o=new g(8,0,0,y());this._socketWriter.write(o)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(o,h){this._isReconnecting=!0,this._socketDisposables=(0,D.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=o,this._socketWriter=new v(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new E(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(w=>this._receiveMessage(w))),this._socketDisposables.push(this._socket.onClose(w=>this._onSocketClose.fire(w))),this._socketReader.acceptChunk(h)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const o=new g(3,0,this._incomingAckId,y());this._socketWriter.write(o);const h=this._outgoingUnackMsg.toArray();for(let w=0,M=h.length;w<M;w++)this._socketWriter.write(h[w]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(o){if(o.ack>this._outgoingAckId){this._outgoingAckId=o.ack;do{const h=this._outgoingUnackMsg.peek();if(h&&h.id<=o.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(o.type){case 0:break;case 1:{if(o.id>this._incomingMsgId)if(o.id!==this._incomingMsgId+1){const h=Date.now();h-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=h,this._socketWriter.write(new g(6,0,0,y())))}else this._incomingMsgId=o.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(o.data);break}case 2:{this._onControlMessage.fire(o.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const h=this._outgoingUnackMsg.toArray();for(let w=0,M=h.length;w<M;w++)this._socketWriter.write(h[w]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(o){const h=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const w=new g(1,h,this._incomingAckId,o);this._outgoingUnackMsg.push(w),this._isReconnecting||(this._socketWriter.write(w),this._recvAckCheck())}sendControl(o){const h=new g(2,0,0,o);this._socketWriter.write(h)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const o=Date.now()-this._incomingMsgLastTime;if(o>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-o+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const o=this._outgoingUnackMsg.peek(),h=Date.now()-o.writtenTime,w=Date.now()-this._socketReader.lastReadTime,M=Date.now()-this._lastSocketTimeoutTime;if(h>=2e4&&w>=2e4&&M>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire(void 0);return}const A=Math.max(2e4-h,2e4-w,2e4-M,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},A)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const o=new g(3,0,this._incomingAckId,y());this._socketWriter.write(o)}}e.PersistentProtocol=n}),define(Z[124],x([0,1,14,17,4,2,36,122]),function(j,e,p,r,D,C,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function d(y,b){const m=D.Event.fromNodeEventEmitter(p.ipcMain,b,(t,g)=>({event:t,message:g})),S=D.Event.filter(m,({event:t})=>t.sender.id===y);return D.Event.map(S,({message:t})=>t&&r.VSBuffer.wrap(t))}class f extends P.IPCServer{constructor(){super(f.getOnDidClientConnect())}static getOnDidClientConnect(){const b=D.Event.fromNodeEventEmitter(p.ipcMain,"vscode:hello",({sender:m})=>m);return D.Event.map(b,m=>{const S=m.id,t=f.Clients.get(S);t&&t.dispose();const g=new D.Emitter;f.Clients.set(S,(0,C.toDisposable)(()=>g.fire()));const E=d(S,"vscode:message"),v=D.Event.any(D.Event.signal(d(S,"vscode:disconnect")),g.event);return{protocol:new I.Protocol(m,E),onDidClientDisconnect:v}})}}e.Server=f,f.Clients=new Map}),define(Z[85],x([0,1,14,4,31,123]),function(j,e,p,r,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class P extends C.Client{constructor(f,y){super({addEventListener:(b,m)=>f.addListener(b,m),removeEventListener:(b,m)=>f.removeListener(b,m),postMessage:b=>f.postMessage(b),start:()=>f.start(),close:()=>f.close()},y)}}e.Client=P;async function I(d){if(d.isDestroyed()||d.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const f=(0,D.generateUuid)();d.webContents.send("vscode:createMessageChannel",f);const y=r.Event.fromNodeEventEmitter(p.ipcMain,"vscode:createMessageChannelResult",(m,S)=>({nonce:S,port:m.ports[0]})),{port:b}=await r.Event.toPromise(r.Event.once(r.Event.filter(y,m=>m.nonce===f)));return b}e.connect=I}),define(Z[86],x([0,1,9,4,2,13]),function(j,e,p,r,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var P;(function(b){b[b.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(P=e.StorageHint||(e.StorageHint={}));function I(b){const m=b;return m?.changed instanceof Map||m?.deleted instanceof Set}e.isStorageItemsChangeEvent=I;var d;(function(b){b[b.None=0]="None",b[b.Initialized=1]="Initialized",b[b.Closed=2]="Closed"})(d||(d={}));class f extends D.Disposable{constructor(m,S=Object.create(null)){super();this.database=m,this.options=S,this._onDidChangeStorage=this._register(new r.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=d.None,this.cache=new Map,this.flushDelayer=new p.ThrottledDelayer(f.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(m=>this.onDidChangeItemsExternal(m)))}onDidChangeItemsExternal(m){m.changed?.forEach((S,t)=>this.accept(t,S)),m.deleted?.forEach(S=>this.accept(S,void 0))}accept(m,S){if(this.state===d.Closed)return;let t=!1;(0,C.isUndefinedOrNull)(S)?t=this.cache.delete(m):this.cache.get(m)!==S&&(this.cache.set(m,S),t=!0),t&&this._onDidChangeStorage.fire(m)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===d.None&&(this.state=d.Initialized,this.options.hint!==P.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(m,S){const t=this.cache.get(m);return(0,C.isUndefinedOrNull)(t)?S:t}getBoolean(m,S){const t=this.get(m);return(0,C.isUndefinedOrNull)(t)?S:t==="true"}getNumber(m,S){const t=this.get(m);return(0,C.isUndefinedOrNull)(t)?S:parseInt(t,10)}async set(m,S){if(this.state===d.Closed)return;if((0,C.isUndefinedOrNull)(S))return this.delete(m);const t=String(S);if(this.cache.get(m)!==t)return this.cache.set(m,t),this.pendingInserts.set(m,t),this.pendingDeletes.delete(m),this._onDidChangeStorage.fire(m),this.doFlush()}async delete(m){if(!(this.state===d.Closed||!this.cache.delete(m)))return this.pendingDeletes.has(m)||this.pendingDeletes.add(m),this.pendingInserts.delete(m),this._onDidChangeStorage.fire(m),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=d.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const m={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(m).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(m){if(!!this.hasPending)return this.doFlush(m)}async doFlush(m){return this.flushDelayer.trigger(()=>this.flushPending(),m)}async whenFlushed(){if(!!this.hasPending)return new Promise(m=>this.whenFlushedCallbacks.push(m))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=f,f.DEFAULT_FLUSH_DELAY=100;class y{constructor(){this.onDidChangeItemsExternal=r.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(m){m.insert&&m.insert.forEach((S,t)=>this.items.set(t,S)),m.delete&&m.delete.forEach(S=>this.items.delete(S))}async close(){}}e.InMemoryStorageDatabase=y}),define(Z[125],x([0,1,9,4,39,8,21]),function(j,e,p,r,D,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class I{constructor(y,b=Object.create(null)){this.path=y,this.options=b,this.name=(0,C.basename)(this.path),this.logger=new d(this.options.logging),this.whenConnected=this.connect(this.path)}get onDidChangeItemsExternal(){return r.Event.None}async getItems(){const y=await this.whenConnected,b=new Map;return(await this.all(y,"SELECT * FROM ItemTable")).forEach(S=>b.set(S.key,S.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${b.size} rows`),b}async updateItems(y){const b=await this.whenConnected;return this.doUpdateItems(b,y)}doUpdateItems(y,b){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${b.insert?(0,D.mapToString)(b.insert):"0"}), delete(${b.delete?(0,D.setToString)(b.delete):"0"})`),this.transaction(y,()=>{const m=b.insert,S=b.delete;if(m&&m.size>0){const t=[];t.push([]);let g=0;m.forEach((E,v)=>{let k=t[g];k.length>I.MAX_HOST_PARAMETERS&&(g++,k=[],t.push(k)),k.push(v,E)}),t.forEach(E=>{this.prepare(y,`INSERT INTO ItemTable VALUES ${new Array(E.length/2).fill("(?,?)").join(",")}`,v=>v.run(E),()=>{const v=[];let k=0;return m.forEach((c,a)=>{v.push(a),k+=c.length}),`Keys: ${v.join(", ")} Length: ${k}`})})}if(S&&S.size){const t=[];t.push([]);let g=0;S.forEach(E=>{let v=t[g];v.length>I.MAX_HOST_PARAMETERS&&(g++,v=[],t.push(v)),v.push(E)}),t.forEach(E=>{this.prepare(y,`DELETE FROM ItemTable WHERE key IN (${new Array(E.length).fill("?").join(",")})`,v=>v.run(E),()=>{const v=[];return S.forEach(k=>{v.push(k)}),`Keys: ${v.join(", ")}`})})}})}async close(y){this.logger.trace(`[storage ${this.name}] close()`);const b=await this.whenConnected;return this.doClose(b,y)}doClose(y,b){return new Promise((m,S)=>{y.db.close(t=>(t&&this.handleSQLiteError(y,`[storage ${this.name}] close(): ${t}`),this.path===I.IN_MEMORY_PATH?m():!y.isErroneous&&!y.isInMemory?this.backup().then(m,g=>(this.logger.error(`[storage ${this.name}] backup(): ${g}`),m())):typeof b=="function"?P.Promises.unlink(this.path).then(()=>this.doConnect(this.path).then(g=>{const E=()=>this.doClose(g,void 0);return this.doUpdateItems(g,{insert:b()}).then(()=>E(),v=>(E(),Promise.reject(v)))})).then(m,S):S(t||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const y=this.toBackupPath(this.path);return P.Promises.copy(this.path,y,{preserveSymlinks:!1})}toBackupPath(y){return`${y}.backup`}async checkIntegrity(y){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${y})`);const b=await this.whenConnected,m=await this.get(b,y?"PRAGMA integrity_check":"PRAGMA quick_check"),S=y?m.integrity_check:m.quick_check;return b.isErroneous?`${S} (last error: ${b.lastError})`:b.isInMemory?`${S} (in-memory!)`:S}async connect(y,b=!0){this.logger.trace(`[storage ${this.name}] open(${y}, retryOnBusy: ${b})`);try{return await this.doConnect(y)}catch(m){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${m}`),m.code==="SQLITE_BUSY"&&b)return await(0,p.timeout)(I.BUSY_OPEN_TIMEOUT),this.connect(y,!1);try{await P.Promises.unlink(y);try{await P.Promises.rename(this.toBackupPath(y),y)}catch{}return await this.doConnect(y)}catch(S){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${S}`),this.doConnect(I.IN_MEMORY_PATH)}}}handleSQLiteError(y,b){y.isErroneous=!0,y.lastError=b,this.logger.error(b)}doConnect(y){return new Promise((b,m)=>{new Promise((S,t)=>{j(["@vscode/sqlite3"],S,t)}).then(S=>{const t={db:new(this.logger.isTracing?S.verbose().Database:S.Database)(y,g=>g?t.db?t.db.close(()=>m(g)):m(g):this.exec(t,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>b(t),E=>t.db.close(()=>m(E)))),isInMemory:y===I.IN_MEMORY_PATH};t.db.on("error",g=>this.handleSQLiteError(t,`[storage ${this.name}] Error (event): ${g}`)),this.logger.isTracing&&t.db.on("trace",g=>this.logger.trace(`[storage ${this.name}] Trace (event): ${g}`))},m)})}exec(y,b){return new Promise((m,S)=>{y.db.exec(b,t=>t?(this.handleSQLiteError(y,`[storage ${this.name}] exec(): ${t}`),S(t)):m())})}get(y,b){return new Promise((m,S)=>{y.db.get(b,(t,g)=>t?(this.handleSQLiteError(y,`[storage ${this.name}] get(): ${t}`),S(t)):m(g))})}all(y,b){return new Promise((m,S)=>{y.db.all(b,(t,g)=>t?(this.handleSQLiteError(y,`[storage ${this.name}] all(): ${t}`),S(t)):m(g))})}transaction(y,b){return new Promise((m,S)=>{y.db.serialize(()=>{y.db.run("BEGIN TRANSACTION"),b(),y.db.run("END TRANSACTION",t=>t?(this.handleSQLiteError(y,`[storage ${this.name}] transaction(): ${t}`),S(t)):m())})})}prepare(y,b,m,S){const t=y.db.prepare(b),g=E=>{this.handleSQLiteError(y,`[storage ${this.name}] prepare(): ${E} (${b}). Details: ${S()}`)};t.on("error",g),m(t),t.finalize(E=>{E&&g(E),t.removeListener("error",g)})}}e.SQLiteStorageDatabase=I,I.IN_MEMORY_PATH=":memory:",I.BUSY_OPEN_TIMEOUT=2e3,I.MAX_HOST_PARAMETERS=256;class d{constructor(y){y&&typeof y.logTrace=="function"&&process.env[d.VSCODE_TRACE_STORAGE]&&(this.logTrace=y.logTrace),y&&typeof y.logError=="function"&&(this.logError=y.logError)}get isTracing(){return!!this.logTrace}trace(y){this.logTrace&&this.logTrace(y)}error(y){this.logError&&this.logError(y)}}d.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(Z[126],x([12,11]),function(j,e){return j.create("vs/base/common/date",e)}),define(Z[127],x([0,1,126]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const r=60,D=r*60,C=D*24,P=C*7,I=C*30,d=C*365;function f(b,m){typeof b!="number"&&(b=b.getTime());const S=Math.round((new Date().getTime()-b)/1e3);if(S<-30)return(0,p.localize)(0,null,f(new Date().getTime()+S*1e3,!1));if(S<30)return(0,p.localize)(1,null);let t;return S<r?(t=S,m?t===1?(0,p.localize)(2,null,t):(0,p.localize)(3,null,t):t===1?(0,p.localize)(4,null,t):(0,p.localize)(5,null,t)):S<D?(t=Math.floor(S/r),m?t===1?(0,p.localize)(6,null,t):(0,p.localize)(7,null,t):t===1?(0,p.localize)(8,null,t):(0,p.localize)(9,null,t)):S<C?(t=Math.floor(S/D),m?t===1?(0,p.localize)(10,null,t):(0,p.localize)(11,null,t):t===1?(0,p.localize)(12,null,t):(0,p.localize)(13,null,t)):S<P?(t=Math.floor(S/C),m?t===1?(0,p.localize)(14,null,t):(0,p.localize)(15,null,t):t===1?(0,p.localize)(16,null,t):(0,p.localize)(17,null,t)):S<I?(t=Math.floor(S/P),m?t===1?(0,p.localize)(18,null,t):(0,p.localize)(19,null,t):t===1?(0,p.localize)(20,null,t):(0,p.localize)(21,null,t)):S<d?(t=Math.floor(S/I),m?t===1?(0,p.localize)(22,null,t):(0,p.localize)(23,null,t):t===1?(0,p.localize)(24,null,t):(0,p.localize)(25,null,t)):(t=Math.floor(S/d),m?t===1?(0,p.localize)(26,null,t):(0,p.localize)(27,null,t):t===1?(0,p.localize)(28,null,t):(0,p.localize)(29,null,t))}e.fromNow=f;function y(b){return b.getFullYear()+"-"+String(b.getMonth()+1).padStart(2,"0")+"-"+String(b.getDate()).padStart(2,"0")+"T"+String(b.getHours()).padStart(2,"0")+":"+String(b.getMinutes()).padStart(2,"0")+":"+String(b.getSeconds()).padStart(2,"0")+"."+(b.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=y}),define(Z[128],x([12,11]),function(j,e){return j.create("vs/base/common/errorMessage",e)}),define(Z[44],x([0,1,30,13,128]),function(j,e,p,r,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function C(f,y){return y&&(f.stack||f.stacktrace)?D.localize(0,null,I(f),P(f.stack)||P(f.stacktrace)):I(f)}function P(f){return Array.isArray(f)?f.join(`
`):f}function I(f){return typeof f.code=="string"&&typeof f.errno=="number"&&typeof f.syscall=="string"?D.localize(1,null,f.message):f.message||D.localize(2,null)}function d(f=null,y=!1){if(!f)return D.localize(3,null);if(Array.isArray(f)){const b=p.coalesce(f),m=d(b[0],y);return b.length>1?D.localize(4,null,m,b.length):m}if(r.isString(f))return f;if(f.detail){const b=f.detail;if(b.error)return C(b.error,y);if(b.exception)return C(b.exception,y)}return f.stack?C(f,y):f.message?f.message:D.localize(5,null)}e.toErrorMessage=d}),define(Z[129],x([12,11]),function(j,e){return j.create("vs/base/common/keybindingLabels",e)}),define(Z[130],x([0,1,129]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserSettingsLabelProvider=e.ElectronAcceleratorLabelProvider=e.AriaLabelProvider=e.UILabelProvider=e.ModifierLabelProvider=void 0;class r{constructor(P,I,d=I){this.modifierLabels=[null],this.modifierLabels[2]=P,this.modifierLabels[1]=I,this.modifierLabels[3]=d}toLabel(P,I,d){if(I.length===0)return null;const f=[];for(let y=0,b=I.length;y<b;y++){const m=I[y],S=d(m);if(S===null)return null;f[y]=D(m,S,this.modifierLabels[P])}return f.join(" ")}}e.ModifierLabelProvider=r,e.UILabelProvider=new r({ctrlKey:"\u2303",shiftKey:"\u21E7",altKey:"\u2325",metaKey:"\u2318",separator:""},{ctrlKey:p.localize(0,null),shiftKey:p.localize(1,null),altKey:p.localize(2,null),metaKey:p.localize(3,null),separator:"+"},{ctrlKey:p.localize(4,null),shiftKey:p.localize(5,null),altKey:p.localize(6,null),metaKey:p.localize(7,null),separator:"+"}),e.AriaLabelProvider=new r({ctrlKey:p.localize(8,null),shiftKey:p.localize(9,null),altKey:p.localize(10,null),metaKey:p.localize(11,null),separator:"+"},{ctrlKey:p.localize(12,null),shiftKey:p.localize(13,null),altKey:p.localize(14,null),metaKey:p.localize(15,null),separator:"+"},{ctrlKey:p.localize(16,null),shiftKey:p.localize(17,null),altKey:p.localize(18,null),metaKey:p.localize(19,null),separator:"+"}),e.ElectronAcceleratorLabelProvider=new r({ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Cmd",separator:"+"},{ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Super",separator:"+"}),e.UserSettingsLabelProvider=new r({ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"cmd",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"win",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"meta",separator:"+"});function D(C,P,I){if(P===null)return"";const d=[];return C.ctrlKey&&d.push(I.ctrlKey),C.shiftKey&&d.push(I.shiftKey),C.altKey&&d.push(I.altKey),C.metaKey&&d.push(I.metaKey),P!==""&&d.push(P),d.join(I.separator)}}),define(Z[131],x([12,11]),function(j,e){return j.create("vs/base/node/processes",e)}),define(Z[72],x([0,1,43,32,10,47,8,3,34,80,13,114,21,131]),function(j,e,p,r,D,C,P,I,d,f,y,b,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return f.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return f.TerminateResponseCode}});function t(s){switch(s){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function g(s,l){if(I.isWindows)try{const n={stdio:["pipe","pipe","ignore"]};l&&(n.cwd=l);const i=p.execFile("taskkill",["/T","/F","/PID",s.pid.toString()],n);return new Promise(o=>{i.once("error",h=>{o({success:!1,error:h})}),i.once("exit",(h,w)=>{o(h===0?{success:!0}:{success:!1,code:h!==null?h:1})})})}catch(n){return Promise.resolve({success:!1,error:n,code:n.status?t(n.status):1})}else if(I.isLinux||I.isMacintosh)try{const n=D.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",j).fsPath;return new Promise(i=>{p.execFile(n,[s.pid.toString()],{encoding:"utf8",shell:!0},(o,h,w)=>{i(o?{success:!1,error:o}:{success:!0})})})}catch(n){return Promise.resolve({success:!1,error:n})}else s.kill("SIGKILL");return Promise.resolve({success:!0})}function E(s){!s||(delete s.DEBUG,I.isMacintosh&&delete s.DYLD_LIBRARY_PATH,I.isLinux&&delete s.LD_PRELOAD)}e.removeDangerousEnvVariables=E;function v(s=d.env){return s.comspec||"cmd.exe"}e.getWindowsShell=v;class k{constructor(l,n,i,o){if(n!==void 0&&i!==void 0&&o!==void 0)this.cmd=l,this.args=n,this.shell=i,this.options=o;else{const h=l;this.cmd=h.command,this.shell=h.isShellCommand,this.args=h.args.slice(0),this.options=h.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const h=Object.create(null);Object.keys(d.env).forEach(w=>{h[w]=d.env[w]}),Object.keys(this.options.env).forEach(w=>{h[w]=this.options.env[w]}),this.options.env=h}}getSanitizedCommand(){let l=this.cmd.toLowerCase();const n=l.lastIndexOf(P.sep);return n!==-1&&(l=l.substring(n+1)),k.WellKnowCommands[l]?l:"other"}start(l){return I.isWindows&&(this.options&&this.options.cwd&&r.isUNC(this.options.cwd)||!this.options&&r.isUNC(d.cwd()))?Promise.reject(new Error(S.localize(0,null))):this.useExec().then(n=>{let i,o;const h=new Promise((w,M)=>{i=w,o=M});if(n){let w=this.cmd;this.args&&(w=w+" "+this.args.join(" ")),this.childProcess=p.exec(w,this.options,(M,A,R)=>{this.childProcess=null;const T=M;T&&T.killed?o({killed:this.terminateRequested,stdout:A.toString(),stderr:R.toString()}):this.handleExec(i,l,M,A,R)})}else{let w=null;const M=A=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(A,i,l,o);const R={terminated:this.terminateRequested};y.isNumber(A)&&(R.cmdCode=A),i(R)};if(this.shell&&I.isWindows){const A=C.deepClone(this.options);A.windowsVerbatimArguments=!0,A.detached=!1;let R=!1,T=!1;const _=[];let Q=this.ensureQuotes(this.cmd);_.push(Q.value),R=Q.quoted,this.args&&this.args.forEach(oe=>{Q=this.ensureQuotes(oe),_.push(Q.value),T=T&&Q.quoted});const ne=["/s","/c"];R?T?ne.push('"'+_.join(" ")+'"'):_.length>1?ne.push('"'+_[0]+'" '+_.slice(1).join(" ")):ne.push('"'+_[0]+'"'):ne.push(_.join(" ")),w=p.spawn(v(),ne,A)}else this.cmd&&(w=p.spawn(this.cmd,this.args,this.options));w&&(this.childProcess=w,this.childProcessPromise=Promise.resolve(w),this.pidResolve&&(this.pidResolve(y.isNumber(w.pid)?w.pid:-1),this.pidResolve=void 0),w.on("error",A=>{this.childProcess=null,o({terminated:this.terminateRequested,error:A})}),w.pid&&(this.childProcess.on("close",M),this.handleSpawn(w,i,l,o,!0)))}return h})}handleClose(l,n,i,o){}ensureQuotes(l){return k.regexp.test(l)?{value:'"'+l+'"',quoted:!0}:{value:l,quoted:l.length>0&&l[0]==='"'&&l[l.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(l=>l.pid,l=>-1):new Promise(l=>{this.pidResolve=l})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(l=>(this.terminateRequested=!0,g(l,this.options.cwd).then(n=>(n.success&&(this.childProcess=null),n))),l=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(l=>{if(!this.shell||!I.isWindows)return l(!1);const n=p.spawn(v(),["/s","/c"]);n.on("error",i=>l(!0)),n.on("exit",i=>l(!1))})}}e.AbstractProcess=k,k.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},k.regexp=/^[^"].* .*[^"]/;class c extends k{constructor(l,n,i,o){super(l,n,i,o);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(l,n,i,o,h){[o,h].forEach((w,M)=>{const A=new b.LineDecoder;A.write(w).forEach(_=>{n({line:_,source:M===0?0:1})});const T=A.end();T&&n({line:T,source:M===0?0:1})}),l({terminated:this.terminateRequested,error:i})}handleSpawn(l,n,i,o,h){const w=new b.LineDecoder,M=new b.LineDecoder;l.stdout.on("data",A=>{w.write(A).forEach(T=>i({line:T,source:0}))}),l.stderr.on("data",A=>{M.write(A).forEach(T=>i({line:T,source:1}))}),this.stdoutLineDecoder=w,this.stderrLineDecoder=M}handleClose(l,n,i,o){const h=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;h&&i({line:h,source:0});const w=this.stderrLineDecoder?this.stderrLineDecoder.end():null;w&&i({line:w,source:1})}}e.LineProcess=c;function a(s){let l=[],n=!1;const i=function(o){if(n){l.push(o);return}(!s.send(o,w=>{if(w&&console.error(w),n=!1,l.length>0){const M=l.slice(0);l=[],M.forEach(A=>i(A))}})||I.isWindows)&&(n=!0)};return{send:i}}e.createQueuedSender=a;var u;(function(s){async function l(n,i,o){if(P.isAbsolute(n))return n;if(i===void 0&&(i=d.cwd()),P.dirname(n)!=="."||(o===void 0&&y.isString(d.env.PATH)&&(o=d.env.PATH.split(P.delimiter)),o===void 0||o.length===0))return P.join(i,n);async function w(M){if(await m.Promises.exists(M)){let A;try{A=await m.Promises.stat(M)}catch(R){R.message.startsWith("EACCES")&&(A=await m.Promises.lstat(M))}return A?!A.isDirectory():!1}return!1}for(let M of o){let A;if(P.isAbsolute(M)?A=P.join(M,n):A=P.join(i,M,n),await w(A))return A;let R=A+".com";if(await w(R)||(R=A+".exe",await w(R)))return R}return P.join(i,n)}s.findExecutable=l})(u=e.win32||(e.win32={}))}),define(Z[132],x([0,1,26,3,118,72]),function(j,e,p,r,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function P(S,t){return S===1?r.isWindows?b():C.getWindowsShell(t):f(S,t)}e.getSystemShell=P;function I(S,t){return S===1?r.isWindows?m(t):C.getWindowsShell(t):f(S,t)}e.getSystemShellSync=I;let d=null;function f(S,t){if(r.isLinux&&S===2||r.isMacintosh&&S===3)return"/bin/bash";if(!d){let g;if(r.isWindows)g="/bin/bash";else{if(g=t.SHELL,!g)try{g=(0,p.userInfo)().shell}catch{}g||(g="sh"),g==="/bin/false"&&(g="/bin/bash")}d=g}return d}let y=null;async function b(){return y||(y=(await(0,D.getFirstAvailablePowerShellInstallation)()).exePath),y}function m(S){if(y)return y;const t=r.isWindows&&parseFloat((0,p.release)())>=10,g=S.hasOwnProperty("PROCESSOR_ARCHITEW6432"),E=`${S.windir}\\${g?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return t?E:C.getWindowsShell(S)}}),define(Z[133],x([0,1,43,9,17,23,109,16,4,2,47,72,36]),function(j,e,p,r,D,C,P,I,d,f,y,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class S extends m.ChannelServer{constructor(E){super({send:v=>{try{process.send&&process.send(v.buffer.toString("base64"))}catch{}},onMessage:d.Event.fromNodeEventEmitter(process,"message",v=>D.VSBuffer.wrap(Buffer.from(v,"base64")))},E);process.once("disconnect",()=>this.dispose())}}e.Server=S;class t{constructor(E,v){this.modulePath=E,this.options=v,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new d.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const k=v&&v.timeout?v.timeout:6e4;this.disposeDelayer=new r.Delayer(k),this.child=null,this._client=null}getChannel(E){const v=this;return{call(k,c,a){return v.requestPromise(E,k,c,a)},listen(k,c){return v.requestEvent(E,k,c)}}}requestPromise(E,v,k,c=C.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(c.isCancellationRequested)return Promise.reject(I.canceled());this.disposeDelayer.cancel();const a=this.getCachedChannel(E),u=(0,r.createCancelablePromise)(n=>a.call(v,k,n)),s=c.onCancellationRequested(()=>u.cancel()),l=(0,f.toDisposable)(()=>u.cancel());return this.activeRequests.add(l),u.finally(()=>{s.dispose(),this.activeRequests.delete(l),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),u}requestEvent(E,v,k){if(!this.disposeDelayer)return d.Event.None;this.disposeDelayer.cancel();let c;const a=new d.Emitter({onFirstListenerAdd:()=>{c=this.getCachedChannel(E).listen(v,k)(a.fire,a),this.activeRequests.add(c)},onLastListenerRemove:()=>{this.activeRequests.delete(c),c.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return a.event}get client(){if(!this._client){const E=this.options&&this.options.args?this.options.args:[],v=Object.create(null);v.env={...(0,y.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(v.env={...v.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(v.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(v.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(v.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),v.execArgv===void 0&&(v.execArgv=process.execArgv.filter(i=>!/^--inspect(-brk)?=/.test(i))),(0,b.removeDangerousEnvVariables)(v.env),this.child=(0,p.fork)(this.modulePath,E,v);const k=new d.Emitter;d.Event.fromNodeEventEmitter(this.child,"message",i=>i)(i=>{if((0,P.isRemoteConsoleLog)(i)){(0,P.log)(i,`IPC Library: ${this.options.serverName}`);return}k.fire(D.VSBuffer.wrap(Buffer.from(i,"base64")))});const a=this.options.useQueue?(0,b.createQueuedSender)(this.child):this.child,u=i=>this.child&&this.child.connected&&a.send(i.buffer.toString("base64")),s=k.event,l={send:u,onMessage:s};this._client=new m.ChannelClient(l);const n=()=>this.disposeClient();process.once("exit",n),this.child.on("error",i=>console.warn('IPC "'+this.options.serverName+'" errored with '+i)),this.child.on("exit",(i,o)=>{process.removeListener("exit",n),this.activeRequests.forEach(h=>(0,f.dispose)(h)),this.activeRequests.clear(),i!==0&&o!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+i+" and signal "+o),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:i,signal:o})})}return this._client}getCachedChannel(E){let v=this.channels.get(E);return v||(v=this.client.getChannel(E),this.channels.set(E,v)),v}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=t}),define(Z[134],x([12,11]),function(j,e){return j.create("vs/code/electron-main/app",e)}),define(Z[135],x([12,11]),function(j,e){return j.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Z[136],x([12,11]),function(j,e){return j.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(Z[137],x([12,11]),function(j,e){return j.create("vs/platform/environment/node/argv",e)}),define(Z[138],x([12,11]),function(j,e){return j.create("vs/platform/environment/node/argvHelper",e)}),define(Z[139],x([12,11]),function(j,e){return j.create("vs/platform/environment/node/shellEnv",e)}),define(Z[140],x([12,11]),function(j,e){return j.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Z[141],x([12,11]),function(j,e){return j.create("vs/platform/extensions/common/extensionValidator",e)}),define(Z[142],x([12,11]),function(j,e){return j.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Z[143],x([12,11]),function(j,e){return j.create("vs/platform/files/common/fileService",e)}),define(Z[144],x([12,11]),function(j,e){return j.create("vs/platform/files/common/files",e)}),define(Z[145],x([12,11]),function(j,e){return j.create("vs/platform/files/common/io",e)}),define(Z[146],x([12,11]),function(j,e){return j.create("vs/platform/files/electron-main/diskFileSystemProviderIpc",e)}),define(Z[147],x([12,11]),function(j,e){return j.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Z[148],x([12,11]),function(j,e){return j.create("vs/platform/issue/electron-main/issueMainService",e)}),define(Z[149],x([12,11]),function(j,e){return j.create("vs/platform/menubar/electron-main/menubar",e)}),define(Z[150],x([12,11]),function(j,e){return j.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(Z[151],x([12,11]),function(j,e){return j.create("vs/platform/request/common/request",e)}),define(Z[152],x([12,11]),function(j,e){return j.create("vs/platform/telemetry/common/telemetryService",e)}),define(Z[153],x([12,11]),function(j,e){return j.create("vs/platform/update/common/update.config.contribution",e)}),define(Z[154],x([12,11]),function(j,e){return j.create("vs/platform/windows/electron-main/window",e)}),define(Z[155],x([12,11]),function(j,e){return j.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(Z[156],x([12,11]),function(j,e){return j.create("vs/platform/workspaces/common/workspaces",e)}),define(Z[157],x([12,11]),function(j,e){return j.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(Z[158],x([12,11]),function(j,e){return j.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(Z[159],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEmptyWindowBackupInfo=void 0;function p(r){return typeof r?.backupFolder=="string"}e.isEmptyWindowBackupInfo=p}),define(Z[160],x([0,1,4,2]),function(j,e,p,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class D{constructor(){this._onCloseEmitter=new p.Emitter,this._onReloadEmitter=new p.Emitter,this._onTerminateEmitter=new p.Emitter,this._onAttachEmitter=new p.Emitter}call(I,d,f){switch(d){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:f[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:f[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:f[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:f[0],port:f[1],subId:f[2]}))}throw new Error("Method not implemented.")}listen(I,d,f){switch(d){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=D,D.ChannelName="extensionhostdebugservice";class C extends r.Disposable{constructor(I){super();this.channel=I}reload(I){this.channel.call("reload",[I])}get onReload(){return this.channel.listen("reload")}close(I){this.channel.call("close",[I])}get onClose(){return this.channel.listen("close")}attachSession(I,d,f){this.channel.call("attach",[I,d,f])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(I,d){this.channel.call("terminate",[I,d])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(I,d){return this.channel.call("openExtensionDevelopmentHostWindow",[I,d])}}e.ExtensionHostDebugChannelClient=C}),define(Z[161],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowDriverRegistryChannelClient=e.WindowDriverChannelClient=e.WindowDriverChannel=void 0;class p{constructor(P){this.driver=P}listen(P,I){throw new Error(`No event found: ${I}`)}call(P,I,d){switch(I){case"click":return this.driver.click(d[0],d[1],d[2]);case"doubleClick":return this.driver.doubleClick(d);case"setValue":return this.driver.setValue(d[0],d[1]);case"getTitle":return this.driver.getTitle();case"isActiveElement":return this.driver.isActiveElement(d);case"getElements":return this.driver.getElements(d[0],d[1]);case"getElementXY":return this.driver.getElementXY(d[0],d[1],d[2]);case"typeInEditor":return this.driver.typeInEditor(d[0],d[1]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(d);case"writeInTerminal":return this.driver.writeInTerminal(d[0],d[1]);case"getLocaleInfo":return this.driver.getLocaleInfo();case"getLocalizedStrings":return this.driver.getLocalizedStrings()}throw new Error(`Call not found: ${I}`)}}e.WindowDriverChannel=p;class r{constructor(P){this.channel=P}click(P,I,d){return this.channel.call("click",[P,I,d])}doubleClick(P){return this.channel.call("doubleClick",P)}setValue(P,I){return this.channel.call("setValue",[P,I])}getTitle(){return this.channel.call("getTitle")}isActiveElement(P){return this.channel.call("isActiveElement",P)}getElements(P,I){return this.channel.call("getElements",[P,I])}getElementXY(P,I,d){return this.channel.call("getElementXY",[P,I,d])}typeInEditor(P,I){return this.channel.call("typeInEditor",[P,I])}getTerminalBuffer(P){return this.channel.call("getTerminalBuffer",P)}writeInTerminal(P,I){return this.channel.call("writeInTerminal",[P,I])}getLocaleInfo(){return this.channel.call("getLocaleInfo")}getLocalizedStrings(){return this.channel.call("getLocalizedStrings")}}e.WindowDriverChannelClient=r;class D{constructor(P){this.channel=P}registerWindowDriver(P){return this.channel.call("registerWindowDriver",P)}reloadWindowDriver(P){return this.channel.call("reloadWindowDriver",P)}}e.WindowDriverRegistryChannelClient=D}),define(Z[162],x([0,1,127,46,10,8,34,15,7]),function(j,e,p,r,D,C,P,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class f{constructor(g,E,v){this._args=g,this.paths=E,this.productService=v}get appRoot(){return(0,C.dirname)(D.FileAccess.asFileUri("",j).fsPath)}get userHome(){return d.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return d.URI.file((0,C.join)(this.userDataPath,"User"))}get tmpDir(){return d.URI.file(this.paths.tmpDir)}get cacheHome(){return d.URI.file(this.userDataPath)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,I.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,I.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const g=(0,p.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,C.join)(this.userDataPath,"logs",g)}return this.args.logsPath}get userDataSyncLogResource(){return d.URI.file((0,C.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,I.joinPath)(d.URI.file((0,C.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return d.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return d.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,I.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,I.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const g=P.env.VSCODE_PORTABLE;return g?d.URI.file((0,C.join)(g,"argv.json")):(0,I.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,I.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return d.URI.file((0,C.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,C.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const g=this.args["builtin-extensions-dir"];return g?(0,C.resolve)(g):(0,C.normalize)((0,C.join)(D.FileAccess.asFileUri("",j).fsPath,"..","extensions"))}get extensionsDownloadPath(){const g=this.args["extensions-download-dir"];return g?(0,C.resolve)(g):(0,C.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const g=this.args["extensions-dir"];if(g)return(0,C.resolve)(g);const E=P.env.VSCODE_EXTENSIONS;if(E)return E;const v=P.env.VSCODE_PORTABLE;return v?(0,C.join)(v,"extensions"):(0,I.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const g=this.args.extensionDevelopmentPath;if(Array.isArray(g))return g.map(E=>/^[^:/?#]+?:\/\//.test(E)?d.URI.parse(E):d.URI.file((0,C.normalize)(E)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(g=>g==="ui"||g==="workspace"||g==="web"?g:"workspace")}get extensionTestsLocationURI(){const g=this.args.extensionTestsPath;if(g)return/^[^:/?#]+?:\/\//.test(g)?d.URI.parse(g):d.URI.file((0,C.normalize)(g))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const g=this.args["disable-extension"];if(g){if(typeof g=="string")return[g];if(Array.isArray(g)&&g.length>0)return g}return!1}get debugExtensionHost(){return y(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!P.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,I.joinPath)(d.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return d.URI.file((0,C.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}fe([r.memoize],f.prototype,"appRoot",null),fe([r.memoize],f.prototype,"userHome",null),fe([r.memoize],f.prototype,"userDataPath",null),fe([r.memoize],f.prototype,"appSettingsHome",null),fe([r.memoize],f.prototype,"tmpDir",null),fe([r.memoize],f.prototype,"cacheHome",null),fe([r.memoize],f.prototype,"userRoamingDataHome",null),fe([r.memoize],f.prototype,"settingsResource",null),fe([r.memoize],f.prototype,"userDataSyncHome",null),fe([r.memoize],f.prototype,"userDataSyncLogResource",null),fe([r.memoize],f.prototype,"sync",null),fe([r.memoize],f.prototype,"machineSettingsResource",null),fe([r.memoize],f.prototype,"globalStorageHome",null),fe([r.memoize],f.prototype,"workspaceStorageHome",null),fe([r.memoize],f.prototype,"keybindingsResource",null),fe([r.memoize],f.prototype,"keyboardLayoutResource",null),fe([r.memoize],f.prototype,"argvResource",null),fe([r.memoize],f.prototype,"snippetsHome",null),fe([r.memoize],f.prototype,"isExtensionDevelopment",null),fe([r.memoize],f.prototype,"untitledWorkspacesHome",null),fe([r.memoize],f.prototype,"installSourcePath",null),fe([r.memoize],f.prototype,"builtinExtensionsPath",null),fe([r.memoize],f.prototype,"extensionsPath",null),fe([r.memoize],f.prototype,"extensionDevelopmentLocationURI",null),fe([r.memoize],f.prototype,"extensionDevelopmentKind",null),fe([r.memoize],f.prototype,"extensionTestsLocationURI",null),fe([r.memoize],f.prototype,"debugExtensionHost",null),fe([r.memoize],f.prototype,"serviceMachineIdResource",null),fe([r.memoize],f.prototype,"telemetryLogResource",null),fe([r.memoize],f.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=f;function y(t,g){return S(t["inspect-extensions"],t["inspect-brk-extensions"],5870,g,t.debugId,t.extensionEnvironment)}e.parseExtensionHostPort=y;function b(t,g){return S(t["inspect-search"],t["inspect-brk-search"],5876,g,t.extensionEnvironment)}e.parseSearchPort=b;function m(t,g){return S(t["inspect-ptyhost"],t["inspect-brk-ptyhost"],5877,g,t.extensionEnvironment)}e.parsePtyHostPort=m;function S(t,g,E,v,k,c){const u=Number(g||t)||(v?null:E),s=u?Boolean(!!g):!1;let l;if(c)try{l=JSON.parse(c)}catch{}return{port:u,break:s,debugId:k,env:l}}}),define(Z[87],x([0,1,246,3,137]),function(j,e,p,r,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const C={o:(0,D.localize)(0,null),e:(0,D.localize)(1,null),t:(0,D.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,D.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,D.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,D.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,D.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,D.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,D.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,D.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,D.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,D.localize)(11,null)},"extensions-dir":{type:"string",deprecates:"extensionHomePath",cat:"e",args:"dir",description:(0,D.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,D.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,D.localize)(14,null)},category:{type:"string",cat:"e",description:(0,D.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:(0,D.localize)(16,null)},"pre-release":{type:"boolean",cat:"e",description:(0,D.localize)(17,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:(0,D.localize)(18,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:(0,D.localize)(19,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,D.localize)(20,null)},verbose:{type:"boolean",cat:"t",description:(0,D.localize)(21,null)},log:{type:"string",cat:"t",args:"level",description:(0,D.localize)(22,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,D.localize)(23,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,D.localize)(24,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:"disableExtensions",cat:"t",description:(0,D.localize)(25,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:(0,D.localize)(26,null)},sync:{type:"string",cat:"t",description:(0,D.localize)(27,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:"debugPluginHost",args:"port",cat:"t",description:(0,D.localize)(28,null)},"inspect-brk-extensions":{type:"string",deprecates:"debugBrkPluginHost",args:"port",cat:"t",description:(0,D.localize)(29,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,D.localize)(30,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,D.localize)(31,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,D.localize)(32,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string"},"inspect-brk-ptyhost":{type:"string"},"inspect-search":{type:"string",deprecates:"debugSearch"},"inspect-brk-search":{type:"string",deprecates:"debugBrkSearch"},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const P={onUnknownOption:()=>{},onMultipleValues:()=>{},onDeprecatedOption:()=>{}};function I(t,g,E=P){const v={},k=[],c=[];for(let l in g){const n=g[l];n.alias&&(v[l]=n.alias),n.type==="string"||n.type==="string[]"?(k.push(l),n.deprecates&&k.push(n.deprecates)):n.type==="boolean"&&(c.push(l),n.deprecates&&c.push(n.deprecates))}const a=p(t,{string:k,boolean:c,alias:v}),u={},s=a;u._=a._.map(l=>String(l)).filter(l=>l.length>0),delete s._;for(let l in g){const n=g[l];n.alias&&delete s[n.alias];let i=s[l];n.deprecates&&s.hasOwnProperty(n.deprecates)&&(i||(i=s[n.deprecates],i&&E.onDeprecatedOption(n.deprecates,l)),delete s[n.deprecates]),typeof i!="undefined"&&(n.type==="string[]"?i&&!Array.isArray(i)&&(i=[i]):n.type==="string"&&Array.isArray(i)&&(i=i.pop(),E.onMultipleValues(l,i)),u[l]=i),delete s[l]}for(let l in s)E.onUnknownOption(l);return u}e.parseArgs=I;function d(t,g){let E="";return g.args&&(Array.isArray(g.args)?E=` <${g.args.join("> <")}>`:E=` <${g.args}>`),g.alias?`-${g.alias} --${t}${E}`:`--${t}${E}`}function f(t,g){let E=0,v=[];for(const u in t){const s=t[u],l=d(u,s);E=Math.max(E,l.length),v.push([l,s.description])}let k=E+2+1;if(g-k<25)return v.reduce((u,s)=>u.concat([`  ${s[0]}`,`      ${s[1]}`]),[]);let c=g-k-1,a=[];for(const u of v){let s=u[0],l=b(u[1],c),n=y(k-s.length-2);a.push("  "+s+n+l[0]);for(let i=1;i<l.length;i++)a.push(y(k)+l[i])}return a}e.formatOptions=f;function y(t){return" ".repeat(t)}function b(t,g){let E=[];for(;t.length;){let v=t.length<g?t.length:t.lastIndexOf(" ",g),k=t.slice(0,v).trim();t=t.slice(v),E.push(k)}return E}function m(t,g,E,v,k){const c=process.stdout.isTTY&&process.stdout.columns||80,a=k?.noInputFiles!==!0?`[${(0,D.localize)(33,null)}...]`:"",u=[`${t} ${E}`];u.push(""),u.push(`${(0,D.localize)(34,null)}: ${g} [${(0,D.localize)(35,null)}]${a}`),u.push(""),k?.noPipe!==!0&&(r.isWindows?u.push((0,D.localize)(36,null,g)):u.push((0,D.localize)(37,null,g)),u.push(""));const s={};for(const l in v){const n=v[l];if(n.description&&n.cat){let i=s[n.cat];i||(s[n.cat]=i={}),i[l]=n}}for(let l in s){const n=l;let i=s[n];i&&(u.push(C[n]),u.push(...f(i,c)),u.push(""))}return u.join(`
`)}e.buildHelpMessage=m;function S(t,g){return`${t||(0,D.localize)(38,null)}
${g||(0,D.localize)(39,null)}
${process.arch}`}e.buildVersionMessage=S}),define(Z[163],x([0,1,61,160,87]),function(j,e,p,r,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class C extends r.ExtensionHostDebugBroadcastChannel{constructor(I){super();this.windowsMainService=I}call(I,d,f){return d==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(f[0],f[1]):super.call(I,d,f)}async openExtensionDevelopmentHostWindow(I,d){const f=(0,D.parseArgs)(I,D.OPTIONS);f.debugRenderer=d;const y=f.extensionDevelopmentPath;if(!y)return{success:!1};const[b]=this.windowsMainService.openExtensionDevelopmentHostWindow(y,{context:5,cli:f});if(!d)return{success:!0};const m=b.win;if(!m)return{success:!0};const S=m.webContents.debugger;let t=S.isAttached()?1/0:0;const g=(0,p.createServer)(E=>{t++==0&&S.attach();let v=!1;const k=u=>{v||E.write(JSON.stringify(u)+"\0")},c=(u,s,l,n)=>k({method:s,params:l,sessionId:n});m.on("close",()=>{S.removeListener("message",c),E.end(),v=!0}),S.addListener("message",c);let a=Buffer.alloc(0);E.on("data",u=>{a=Buffer.concat([a,u]);for(let s=a.indexOf(0);s!==-1;s=a.indexOf(0)){let l;try{const n=a.slice(0,s).toString("utf8");a=a.slice(s+1),l=JSON.parse(n)}catch(n){console.error("error reading cdp line",n)}S.sendCommand(l.method,l.params,l.sessionId).then(n=>k({id:l.id,sessionId:l.sessionId,result:n})).catch(n=>k({id:l.id,sessionId:l.sessionId,error:{code:0,message:n.message}}))}}),E.on("error",u=>{console.error("error on cdp pipe:",u)}),E.on("close",()=>{v=!0,--t==0&&S.detach()})});return await new Promise(E=>g.listen(0,E)),m.on("close",()=>g.close()),{rendererDebugPort:g.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=C}),function(){"use strict";function j(e,p,r,D){function C(I){const d=P(I),f=[d];return e.isAbsolute(d)||f.unshift(D),e.resolve(...f)}function P(I){const d=process.env.VSCODE_PORTABLE;if(d)return e.join(d,"user-data");let f=process.env.VSCODE_APPDATA;if(f)return e.join(f,r);const y=I["user-data-dir"];if(y)return y;switch(process.platform){case"win32":if(f=process.env.APPDATA,!f){const b=process.env.USERPROFILE;if(typeof b!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");f=e.join(b,"AppData","Roaming")}break;case"darwin":f=e.join(p.homedir(),"Library","Application Support");break;case"linux":f=process.env.XDG_CONFIG_HOME||e.join(p.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(f,r)}return{getUserDataPath:C}}if(typeof define=="function")define(Z[164],x([0,247,26,10,15,34]),function(e,p,r,D,C,P){const I=C.dirname(D.FileAccess.asFileUri("",e)),d=e.__$__nodeRequire(C.joinPath(I,"package.json").fsPath);return j(p,r,d.name,P.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),p=require("path"),r=require("os");module.exports=j(p,r,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Z[165],x([0,1,26,162,164]),function(j,e,p,r,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class C extends r.AbstractNativeEnvironmentService{constructor(I,d){super(I,{homeDir:(0,p.homedir)(),tmpDir:(0,p.tmpdir)(),userDataDir:(0,D.getUserDataPath)(I)},d)}}e.NativeEnvironmentService=C}),define(Z[166],x([0,1,27,26,8]),function(j,e,p,r,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFile=void 0;function C(P){const I=(0,D.join)((0,r.tmpdir)(),Math.random().toString(36).replace(/[^a-z]+/g,"").substr(0,10));try{return p.writeFileSync(I,""),P&&console.log(`Marker file for --wait created: ${I}`),I}catch(d){P&&console.error(`Failed to create marker file for --wait: ${d}`);return}}e.createWaitMarkerFile=C}),define(Z[167],x([0,1,141]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const r=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,D=/^-(\d{4})(\d{2})(\d{2})$/;function C(m){return m=m.trim(),m==="*"||r.test(m)}e.isValidVersionStr=C;function P(m){if(!C(m))return null;if(m=m.trim(),m==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let S=m.match(r);return S?{hasCaret:S[1]==="^",hasGreaterEquals:S[1]===">=",majorBase:S[2]==="x"?0:parseInt(S[2],10),majorMustEqual:S[2]!=="x",minorBase:S[4]==="x"?0:parseInt(S[4],10),minorMustEqual:S[4]!=="x",patchBase:S[6]==="x"?0:parseInt(S[6],10),patchMustEqual:S[6]!=="x",preRelease:S[8]||null}:null}e.parseVersion=P;function I(m){if(!m)return null;let S=m.majorBase,t=m.majorMustEqual,g=m.minorBase,E=m.minorMustEqual,v=m.patchBase,k=m.patchMustEqual;m.hasCaret&&(S===0||(E=!1),k=!1);let c=0;if(m.preRelease){const a=D.exec(m.preRelease);if(a){const[,u,s,l]=a;c=Date.UTC(Number(u),Number(s)-1,Number(l))}}return{majorBase:S,majorMustEqual:t,minorBase:g,minorMustEqual:E,patchBase:v,patchMustEqual:k,isMinimum:m.hasGreaterEquals,notBefore:c}}e.normalizeVersion=I;function d(m,S,t){let g;typeof m=="string"?g=I(P(m)):g=m;let E;S instanceof Date?E=S.getTime():typeof S=="string"&&(E=new Date(S).getTime());let v;if(typeof t=="string"?v=I(P(t)):v=t,!g||!v)return!1;let k=g.majorBase,c=g.minorBase,a=g.patchBase,u=v.majorBase,s=v.minorBase,l=v.patchBase,n=v.notBefore,i=v.majorMustEqual,o=v.minorMustEqual,h=v.patchMustEqual;return v.isMinimum?k>u?!0:k<u?!1:c>s?!0:c<s||E&&E<n?!1:a>=l:(k===1&&u===0&&(!i||!o||!h)&&(u=1,s=0,l=0,i=!0,o=!1,h=!1),k<u?!1:k>u?!i:c<s?!1:c>s?!o:a<l?!1:a>l?!h:!(E&&E<n))}e.isValidVersion=d;function f(m,S,t,g){return t.isBuiltin||typeof t.main=="undefined"?!0:b(m,S,t.engines.vscode,g)}e.isValidExtensionVersion=f;function y(m,S,t){return m==="*"||b(S,t,m)}e.isEngineValid=y;function b(m,S,t,g=[]){let E=I(P(t));if(!E)return g.push(p.localize(0,null,t)),!1;if(E.majorBase===0){if(!E.majorMustEqual||!E.minorMustEqual)return g.push(p.localize(1,null,t)),!1}else if(!E.majorMustEqual)return g.push(p.localize(2,null,t)),!1;return d(m,S,E)?!0:(g.push(p.localize(3,null,m,t)),!1)}}),define(Z[168],x([0,1,4,2,17,59,23]),function(j,e,p,r,D,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProviderChannel=void 0;class I extends r.Disposable{constructor(f,y){super();this.provider=f,this.logService=y,this.sessionToWatcher=new Map,this.watchRequests=new Map}call(f,y,b){const m=this.getUriTransformer(f);switch(y){case"stat":return this.stat(m,b[0]);case"readdir":return this.readdir(m,b[0]);case"open":return this.open(m,b[0],b[1]);case"close":return this.close(b[0]);case"read":return this.read(b[0],b[1],b[2]);case"readFile":return this.readFile(m,b[0]);case"write":return this.write(b[0],b[1],b[2],b[3],b[4]);case"writeFile":return this.writeFile(m,b[0],b[1],b[2]);case"rename":return this.rename(m,b[0],b[1],b[2]);case"copy":return this.copy(m,b[0],b[1],b[2]);case"mkdir":return this.mkdir(m,b[0]);case"delete":return this.delete(m,b[0],b[1]);case"watch":return this.watch(m,b[0],b[1],b[2],b[3]);case"unwatch":return this.unwatch(b[0],b[1])}throw new Error(`IPC Command ${y} not found`)}listen(f,y,b){const m=this.getUriTransformer(f);switch(y){case"fileChange":return this.onFileChange(m,b[0]);case"readFileStream":return this.onReadFileStream(m,b[0],b[1])}throw new Error(`Unknown event ${y}`)}stat(f,y){const b=this.transformIncoming(f,y,!0);return this.provider.stat(b)}readdir(f,y){const b=this.transformIncoming(f,y);return this.provider.readdir(b)}async readFile(f,y){const b=this.transformIncoming(f,y,!0),m=await this.provider.readFile(b);return D.VSBuffer.wrap(m)}onReadFileStream(f,y,b){const m=this.transformIncoming(f,y,!0),S=new P.CancellationTokenSource,t=new p.Emitter({onLastListenerRemove:()=>{S.cancel()}}),g=this.provider.readFileStream(m,b,S.token);return(0,C.listenStream)(g,{onData:E=>t.fire(D.VSBuffer.wrap(E)),onError:E=>t.fire(E),onEnd:()=>{t.fire("end"),t.dispose(),S.dispose()}}),t.event}writeFile(f,y,b,m){const S=this.transformIncoming(f,y);return this.provider.writeFile(S,b.buffer,m)}open(f,y,b){const m=this.transformIncoming(f,y,!0);return this.provider.open(m,b)}close(f){return this.provider.close(f)}async read(f,y,b){const m=D.VSBuffer.alloc(b),S=0,t=await this.provider.read(f,y,m.buffer,S,b);return[m,t]}write(f,y,b,m,S){return this.provider.write(f,y,b.buffer,m,S)}mkdir(f,y){const b=this.transformIncoming(f,y);return this.provider.mkdir(b)}delete(f,y,b){const m=this.transformIncoming(f,y);return this.provider.delete(m,b)}rename(f,y,b,m){const S=this.transformIncoming(f,y),t=this.transformIncoming(f,b);return this.provider.rename(S,t,m)}copy(f,y,b,m){const S=this.transformIncoming(f,y),t=this.transformIncoming(f,b);return this.provider.copy(S,t,m)}onFileChange(f,y){const b=new p.Emitter({onFirstListenerAdd:()=>{this.sessionToWatcher.set(y,this.createSessionFileWatcher(f,b))},onLastListenerRemove:()=>{(0,r.dispose)(this.sessionToWatcher.get(y)),this.sessionToWatcher.delete(y)}});return b.event}async watch(f,y,b,m,S){const t=this.sessionToWatcher.get(y);if(t){const g=this.transformIncoming(f,m),E=t.watch(b,g,S);this.watchRequests.set(y+b,E)}}async unwatch(f,y){const b=f+y,m=this.watchRequests.get(b);m&&((0,r.dispose)(m),this.watchRequests.delete(b))}dispose(){super.dispose(),this.watchRequests.forEach(f=>(0,r.dispose)(f)),this.watchRequests.clear(),this.sessionToWatcher.forEach(f=>(0,r.dispose)(f)),this.sessionToWatcher.clear()}}e.AbstractDiskFileSystemProviderChannel=I}),define(Z[73],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class p{constructor(D,C=[],P=!1){this.ctor=D,this.staticArguments=C,this.supportsDelayedInstantiation=P}}e.SyncDescriptor=p}),define(Z[169],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class p{constructor(C){this.incoming=new Map,this.outgoing=new Map,this.data=C}}e.Node=p;class r{constructor(C){this._hashFn=C,this._nodes=new Map}roots(){const C=[];for(let P of this._nodes.values())P.outgoing.size===0&&C.push(P);return C}insertEdge(C,P){const I=this.lookupOrInsertNode(C),d=this.lookupOrInsertNode(P);I.outgoing.set(this._hashFn(P),d),d.incoming.set(this._hashFn(C),I)}removeNode(C){const P=this._hashFn(C);this._nodes.delete(P);for(let I of this._nodes.values())I.outgoing.delete(P),I.incoming.delete(P)}lookupOrInsertNode(C){const P=this._hashFn(C);let I=this._nodes.get(P);return I||(I=new p(C),this._nodes.set(P,I)),I}lookup(C){return this._nodes.get(this._hashFn(C))}isEmpty(){return this._nodes.size===0}toString(){let C=[];for(let[P,I]of this._nodes)C.push(`${P}, (incoming)[${[...I.incoming.keys()].join(", ")}], (outgoing)[${[...I.outgoing.keys()].join(",")}]`);return C.join(`
`)}findCycleSlow(){for(let[C,P]of this._nodes){const I=new Set([C]),d=this._findCycle(P,I);if(d)return d}}_findCycle(C,P){for(let[I,d]of C.outgoing){if(P.has(I))return[...P,I].join(" -> ");P.add(I);const f=this._findCycle(d,P);if(f)return f;P.delete(I)}}}e.Graph=r}),define(Z[5],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var p;(function(P){P.serviceIds=new Map,P.DI_TARGET="$di$target",P.DI_DEPENDENCIES="$di$dependencies";function I(d){return d[P.DI_DEPENDENCIES]||[]}P.getServiceDependencies=I})(p=e._util||(e._util={})),e.IInstantiationService=D("instantiationService");function r(P,I,d,f){I[p.DI_TARGET]===I?I[p.DI_DEPENDENCIES].push({id:P,index:d,optional:f}):(I[p.DI_DEPENDENCIES]=[{id:P,index:d,optional:f}],I[p.DI_TARGET]=I)}function D(P){if(p.serviceIds.has(P))return p.serviceIds.get(P);const I=function(d,f,y){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");r(I,d,y,!1)};return I.toString=()=>P,p.serviceIds.set(P,I),I}e.createDecorator=D;function C(P){return P}e.refineServiceDecorator=C}),define(Z[52],x([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBackupMainService=void 0,e.IBackupMainService=(0,p.createDecorator)("backupMainService")}),define(Z[19],x([0,1,13,7,5]),function(j,e,p,r,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,D.createDecorator)("configurationService");function C(E){return E&&typeof E=="object"&&(!E.overrideIdentifier||typeof E.overrideIdentifier=="string")&&(!E.resource||E.resource instanceof r.URI)}e.isConfigurationOverrides=C;function P(E){return E&&typeof E=="object"&&(!E.overrideIdentifiers||p.isArray(E.overrideIdentifiers))&&!E.overrideIdentifier&&(!E.resource||E.resource instanceof r.URI)}e.isConfigurationUpdateOverrides=P;var I;(function(E){E[E.USER=1]="USER",E[E.USER_LOCAL=2]="USER_LOCAL",E[E.USER_REMOTE=3]="USER_REMOTE",E[E.WORKSPACE=4]="WORKSPACE",E[E.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",E[E.DEFAULT=6]="DEFAULT",E[E.MEMORY=7]="MEMORY"})(I=e.ConfigurationTarget||(e.ConfigurationTarget={}));function d(E){switch(E){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=d;function f(E,v){const k=Object.create(null);for(let c in E)y(k,c,E[c],v);return k}e.toValuesTree=f;function y(E,v,k,c){const a=v.split("."),u=a.pop();let s=E;for(let l=0;l<a.length;l++){let n=a[l],i=s[n];switch(typeof i){case"undefined":i=s[n]=Object.create(null);break;case"object":break;default:c(`Ignoring ${v} as ${a.slice(0,l+1).join(".")} is ${JSON.stringify(i)}`);return}s=i}if(typeof s=="object"&&s!==null)try{s[u]=k}catch{c(`Ignoring ${v} as ${a.join(".")} is ${JSON.stringify(s)}`)}else c(`Ignoring ${v} as ${a.join(".")} is ${JSON.stringify(s)}`)}e.addToValueTree=y;function b(E,v){const k=v.split(".");m(E,k)}e.removeFromValueTree=b;function m(E,v){const k=v.shift();if(v.length===0){delete E[k];return}if(Object.keys(E).indexOf(k)!==-1){const c=E[k];typeof c=="object"&&!Array.isArray(c)&&(m(c,v),Object.keys(c).length===0&&delete E[k])}}function S(E,v,k){function c(s,l){let n=s;for(const i of l){if(typeof n!="object"||n===null)return;n=n[i]}return n}const a=v.split("."),u=c(E,a);return typeof u=="undefined"?k:u}e.getConfigurationValue=S;function t(E,v,k){Object.keys(v).forEach(c=>{c!=="__proto__"&&(c in E?p.isObject(E[c])&&p.isObject(v[c])?t(E[c],v[c],k):k&&(E[c]=v[c]):E[c]=v[c])})}e.merge=t;function g(E,v,k){const c=E.inspect(v),a=E.inspect(k);return typeof c.userValue!="undefined"||typeof c.workspaceValue!="undefined"||typeof c.workspaceFolderValue!="undefined"?c.value:typeof a.userValue!="undefined"||typeof a.workspaceValue!="undefined"||typeof a.workspaceFolderValue!="undefined"?a.value:c.defaultValue}e.getMigratedSettingValue=g}),define(Z[74],x([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,p.createDecorator)(e.ID);function r(D){return!!D.hostName&&!!D.errorMessage}e.isRemoteDiagnosticError=r}),define(Z[88],x([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,p.createDecorator)("encryptionMainService");class r{constructor(C){this.machineId=C}encryption(){return new Promise((C,P)=>j(["vscode-encrypt"],C,P))}async encrypt(C){try{return(await this.encryption()).encrypt(this.machineId,C)}catch{return C}}async decrypt(C){try{return(await this.encryption()).decrypt(this.machineId,C)}catch{return C}}}e.EncryptionMainService=r}),define(Z[48],x([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,p.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,p.refineServiceDecorator)(e.IEnvironmentService)}),define(Z[170],x([0,1,10,140,5]),function(j,e,p,r,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";var C;(function(c){c.WIN32_X64="win32-x64",c.WIN32_IA32="win32-ia32",c.WIN32_ARM64="win32-arm64",c.LINUX_X64="linux-x64",c.LINUX_ARM64="linux-arm64",c.LINUX_ARMHF="linux-armhf",c.ALPINE_X64="alpine-x64",c.ALPINE_ARM64="alpine-arm64",c.DARWIN_X64="darwin-x64",c.DARWIN_ARM64="darwin-arm64",c.WEB="web",c.UNIVERSAL="universal",c.UNKNOWN="unknown",c.UNDEFINED="undefined"})(C=e.TargetPlatform||(e.TargetPlatform={}));function P(c){switch(c){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=P;function I(c){switch(c){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=I;function d(c,a){switch(c){case 3:return a==="x64"?"win32-x64":a==="ia32"?"win32-ia32":a==="arm64"?"win32-arm64":"unknown";case 2:return a==="x64"?"linux-x64":a==="arm64"?"linux-arm64":a==="arm"?"linux-armhf":"unknown";case"alpine":return a==="x64"?"alpine-x64":a==="arm64"?"alpine-arm64":"unknown";case 1:return a==="x64"?"darwin-x64":a==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=d;function f(c,a){return a==="web"&&!c.includes("web")}e.isNotWebExtensionInWebTargetPlatform=f;function y(c,a,u){return f(a,u)?!1:c==="undefined"||c==="universal"?!0:c==="unknown"?!1:c===u?!0:b(u).includes(c)}e.isTargetPlatformCompatible=y;function b(c){switch(c){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=b;function m(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(!c.uuid||typeof c.uuid=="string")}e.isIExtensionIdentifier=m;var S;(function(c){c[c.NoneOrRelevance=0]="NoneOrRelevance",c[c.LastUpdatedDate=1]="LastUpdatedDate",c[c.Title=2]="Title",c[c.PublisherName=3]="PublisherName",c[c.InstallCount=4]="InstallCount",c[c.PublishedDate=10]="PublishedDate",c[c.AverageRating=6]="AverageRating",c[c.WeightedRating=12]="WeightedRating"})(S=e.SortBy||(e.SortBy={}));var t;(function(c){c[c.Default=0]="Default",c[c.Ascending=1]="Ascending",c[c.Descending=2]="Descending"})(t=e.SortOrder||(e.SortOrder={}));var g;(function(c){c.Install="install",c.Uninstall="uninstall"})(g=e.StatisticType||(e.StatisticType={}));var E;(function(c){c[c.None=1]="None",c[c.Install=2]="Install",c[c.Update=3]="Update",c[c.Migrate=4]="Migrate"})(E=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,D.createDecorator)("extensionGalleryService");var v;(function(c){c.Unsupported="Unsupported",c.UnsupportedPreRelease="UnsupportedPreRelease",c.Malicious="Malicious",c.Incompatible="Incompatible",c.IncompatiblePreRelease="IncompatiblePreRelease",c.IncompatibleTargetPlatform="IncompatibleTargetPlatform",c.Invalid="Invalid",c.Download="Download",c.Extract="Extract",c.Delete="Delete",c.Rename="Rename",c.CorruptZip="CorruptZip",c.IncompleteZip="IncompleteZip",c.Internal="Internal"})(v=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class k extends Error{constructor(a,u){super(a);this.code=u,this.name=u}}e.ExtensionManagementError=k,e.IExtensionManagementService=(0,D.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,D.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,D.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=p.FileAccess.asBrowserUri("./media/defaultIcon.png",j).toString(!0),e.ExtensionsLabel=(0,r.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,r.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,D.createDecorator)("IExtensionManagementCLIService")}),define(Z[171],x([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,p.createDecorator)("extensionUrlTrustService")}),define(Z[172],x([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,p.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(Z[89],x([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,p.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,p.createDecorator)("externalTerminal")}),define(Z[173],x([0,1,43,10,8,3,80,21,72,142,89]),function(j,e,p,r,D,C,P,I,d,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const b=f.localize(0,null);class m{async getDefaultTerminalForPlatforms(){return{windows:S.getDefaultTerminalWindows(),linux:await g.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class S extends m{openTerminal(a,u){return this.spawnTerminal(p,a,d.getWindowsShell(),u)}spawnTerminal(a,u,s,l){const n=u.windowsExec||S.getDefaultTerminalWindows();l&&l[1]===":"&&(l=l[0].toUpperCase()+l.substr(1));const i=D.basename(n).toLowerCase();if(i==="cmder"||i==="cmder.exe")return a.spawn(n,l?[l]:void 0),Promise.resolve(void 0);const o=["/c","start","/wait"];return n.indexOf(" ")>=0&&o.push('""'),o.push(n),(i==="wt"||i==="wt.exe")&&o.push("-d ."),new Promise((h,w)=>{const M=E(process),A=a.spawn(s,o,{cwd:l,env:M});A.on("error",w),A.on("exit",()=>h())})}runInTerminal(a,u,s,l,n){const i="windowsExec"in n&&n.windowsExec?n.windowsExec:S.getDefaultTerminalWindows();return new Promise((o,h)=>{const w=`"${u} - ${b}"`,M=`""${s.join('" "')}" & pause"`,A=["/c","start",w,"/wait",i,"/c",M],R=Object.assign({},E(process),l);Object.keys(R).filter(Q=>R[Q]===null).forEach(Q=>delete R[Q]);const T={cwd:u,env:R,windowsVerbatimArguments:!0};p.spawn(S.CMD,A,T).on("error",Q=>{h(v(Q))}),o(void 0)})}static getDefaultTerminalWindows(){if(!S._DEFAULT_TERMINAL_WINDOWS){const a=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");S._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${a?"Sysnative":"System32"}\\cmd.exe`}return S._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=S,S.CMD="cmd.exe";class t extends m{openTerminal(a,u){return this.spawnTerminal(p,a,u)}runInTerminal(a,u,s,l,n){const i=n.osxExec||y.DEFAULT_TERMINAL_OSX;return new Promise((o,h)=>{if(i===y.DEFAULT_TERMINAL_OSX||i==="iTerm.app"){const w=i===y.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",A=[r.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${w}.scpt`,j).fsPath,"-t",a||b,"-w",u];for(let _ of s)A.push("-a"),A.push(_);if(l){const _=Object.assign({},E(process),l);for(let Q in _){const ne=_[Q];ne===null?(A.push("-u"),A.push(Q)):(A.push("-e"),A.push(`${Q}=${ne}`))}}let R="";const T=p.spawn(t.OSASCRIPT,A);T.on("error",_=>{h(v(_))}),T.stderr.on("data",_=>{R+=_.toString()}),T.on("exit",_=>{if(_===0)o(void 0);else if(R){const Q=R.split(`
`,1);h(new Error(Q[0]))}else h(new Error(f.localize(1,null,w,_)))})}else h(new Error(f.localize(2,null,i)))})}spawnTerminal(a,u,s){const l=u.osxExec||y.DEFAULT_TERMINAL_OSX;return new Promise((n,i)=>{const o=["-a",l];s&&o.push(s);const h=E(process),w=a.spawn("/usr/bin/open",o,{cwd:s,env:h});w.on("error",i),w.on("exit",()=>n())})}}e.MacExternalTerminalService=t,t.OSASCRIPT="/usr/bin/osascript";class g extends m{openTerminal(a,u){return this.spawnTerminal(p,a,u)}runInTerminal(a,u,s,l,n){const i=n.linuxExec?Promise.resolve(n.linuxExec):g.getDefaultTerminalLinuxReady();return new Promise((o,h)=>{let w=[];i.then(M=>{M.indexOf("gnome-terminal")>=0?w.push("-x"):w.push("-e"),w.push("bash"),w.push("-c");const A=`${k(s)}; echo; read -p "${g.WAIT_MESSAGE}" -n1;`;w.push(`''${A}''`);const R=Object.assign({},E(process),l);Object.keys(R).filter(ne=>R[ne]===null).forEach(ne=>delete R[ne]);const T={cwd:u,env:R};let _="";const Q=p.spawn(M,w,T);Q.on("error",ne=>{h(v(ne))}),Q.stderr.on("data",ne=>{_+=ne.toString()}),Q.on("exit",ne=>{if(ne===0)o(void 0);else if(_){const oe=_.split(`
`,1);h(new Error(oe[0]))}else h(new Error(f.localize(4,null,M,ne)))})})})}static async getDefaultTerminalLinuxReady(){if(!g._DEFAULT_TERMINAL_LINUX_READY)if(!C.isLinux)g._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const a=await I.Promises.exists("/etc/debian_version");g._DEFAULT_TERMINAL_LINUX_READY=new Promise(u=>{a?u("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?u("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?u("konsole"):process.env.COLORTERM?u(process.env.COLORTERM):process.env.TERM?u(process.env.TERM):u("xterm")})}return g._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(a,u,s){const l=u.linuxExec?Promise.resolve(u.linuxExec):g.getDefaultTerminalLinuxReady();return new Promise((n,i)=>{l.then(o=>{const h=E(process),w=a.spawn(o,[],{cwd:s,env:h});w.on("error",i),w.on("exit",()=>n())})})}}e.LinuxExternalTerminalService=g,g.WAIT_MESSAGE=f.localize(3,null);function E(c){const a={...c.env};return(0,P.sanitizeProcessEnvironment)(a),a}function v(c){return"errno"in c&&c.errno==="ENOENT"&&"path"in c&&typeof c.path=="string"?new Error(f.localize(5,null,c.path)):c}function k(c){let a="";for(let u of c)u.indexOf(" ")>=0?a+='"'+u+'"':a+=u,a+=" ";return a}}),define(Z[18],x([0,1,39,8,25,13,7,144,5]),function(j,e,p,r,D,C,P,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,d.createDecorator)("fileService");function f(O){return O.create===!0}e.isFileOpenForWriteOptions=f;var y;(function(O){O[O.Unknown=0]="Unknown",O[O.File=1]="File",O[O.Directory=2]="Directory",O[O.SymbolicLink=64]="SymbolicLink"})(y=e.FileType||(e.FileType={}));var b;(function(O){O[O.Readonly=1]="Readonly"})(b=e.FilePermission||(e.FilePermission={}));var m;(function(O){O[O.FileReadWrite=2]="FileReadWrite",O[O.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",O[O.FileReadStream=16]="FileReadStream",O[O.FileFolderCopy=8]="FileFolderCopy",O[O.PathCaseSensitive=1024]="PathCaseSensitive",O[O.Readonly=2048]="Readonly",O[O.Trash=4096]="Trash",O[O.FileWriteUnlock=8192]="FileWriteUnlock"})(m=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function S(O){return!!(O.capabilities&2)}e.hasReadWriteCapability=S;function t(O){return!!(O.capabilities&8)}e.hasFileFolderCopyCapability=t;function g(O){return!!(O.capabilities&4)}e.hasOpenReadWriteCloseCapability=g;function E(O){return!!(O.capabilities&16)}e.hasFileReadStreamCapability=E;var v;(function(O){O.FileExists="EntryExists",O.FileNotFound="EntryNotFound",O.FileNotADirectory="EntryNotADirectory",O.FileIsADirectory="EntryIsADirectory",O.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",O.FileTooLarge="EntryTooLarge",O.FileWriteLocked="EntryWriteLocked",O.NoPermissions="NoPermissions",O.Unavailable="Unavailable",O.Unknown="Unknown"})(v=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class k extends Error{constructor(H,q){super(H);this.code=q}}e.FileSystemProviderError=k;function c(O,H){const q=new k(O.toString(),H);return u(q,H),q}e.createFileSystemProviderError=c;function a(O){return O||c((0,I.localize)(0,null),v.Unknown)}e.ensureFileSystemProviderError=a;function u(O,H){return O.name=H?`${H} (FileSystemError)`:"FileSystemError",O}e.markAsFileSystemProviderError=u;function s(O){if(!O)return v.Unknown;if(O instanceof k)return O.code;const H=/^(.+) \(FileSystemError\)$/.exec(O.name);if(!H)return v.Unknown;switch(H[1]){case v.FileExists:return v.FileExists;case v.FileIsADirectory:return v.FileIsADirectory;case v.FileNotADirectory:return v.FileNotADirectory;case v.FileNotFound:return v.FileNotFound;case v.FileExceedsMemoryLimit:return v.FileExceedsMemoryLimit;case v.FileTooLarge:return v.FileTooLarge;case v.FileWriteLocked:return v.FileWriteLocked;case v.NoPermissions:return v.NoPermissions;case v.Unavailable:return v.Unavailable}return v.Unknown}e.toFileSystemProviderErrorCode=s;function l(O){if(O instanceof M)return O.fileOperationResult;switch(s(O)){case v.FileNotFound:return 1;case v.FileIsADirectory:return 0;case v.FileNotADirectory:return 10;case v.FileWriteLocked:return 5;case v.NoPermissions:return 6;case v.FileExists:return 4;case v.FileExceedsMemoryLimit:return 9;case v.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=l;var n;(function(O){O[O.CREATE=0]="CREATE",O[O.DELETE=1]="DELETE",O[O.MOVE=2]="MOVE",O[O.COPY=3]="COPY"})(n=e.FileOperation||(e.FileOperation={}));class i{constructor(H,q,Y){this.resource=H,this.operation=q,this.target=Y}isOperation(H){return this.operation===H}}e.FileOperationEvent=i;var o;(function(O){O[O.UPDATED=0]="UPDATED",O[O.ADDED=1]="ADDED",O[O.DELETED=2]="DELETED"})(o=e.FileChangeType||(e.FileChangeType={}));class h{constructor(H,q){this.added=void 0,this.updated=void 0,this.deleted=void 0;const Y=new Map;for(const $ of H){const K=Y.get($.type);K?K.push([$.resource,$]):Y.set($.type,[[$.resource,$]])}for(const[$,K]of Y)switch($){case 1:this.added=p.TernarySearchTree.forUris(()=>q),this.added.fill(K);break;case 0:this.updated=p.TernarySearchTree.forUris(()=>q),this.updated.fill(K);break;case 2:this.deleted=p.TernarySearchTree.forUris(()=>q),this.deleted.fill(K);break}}contains(H,...q){return this.doContains(H,{includeChildren:!1},...q)}affects(H,...q){return this.doContains(H,{includeChildren:!0},...q)}doContains(H,q,...Y){if(!H)return!1;const $=Y.length>0;return!!((!$||Y.includes(1))&&(this.added?.get(H)||q.includeChildren&&this.added?.findSuperstr(H))||(!$||Y.includes(0))&&(this.updated?.get(H)||q.includeChildren&&this.updated?.findSuperstr(H))||(!$||Y.includes(2))&&(this.deleted?.findSubstr(H)||q.includeChildren&&this.deleted?.findSuperstr(H)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=h;function w(O,H,q){return!O||!H||O===H||H.length>O.length?!1:(H.charAt(H.length-1)!==r.sep&&(H+=r.sep),q?(0,D.startsWithIgnoreCase)(O,H):O.indexOf(H)===0)}e.isParent=w;class M extends Error{constructor(H,q,Y){super(H);this.fileOperationResult=q,this.options=Y}}e.FileOperationError=M;class A extends M{constructor(H,q,Y){super(H,2,Y);this.stat=q}}e.NotModifiedSinceFileOperationError=A;var R;(function(O){O[O.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",O[O.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",O[O.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",O[O.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",O[O.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",O[O.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",O[O.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",O[O.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",O[O.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",O[O.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",O[O.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",O[O.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(R=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var T;(function(O){O[O.FILE=0]="FILE",O[O.FOLDER=1]="FOLDER",O[O.ROOT_FOLDER=2]="ROOT_FOLDER"})(T=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function _(O){if(!(typeof O.size!="number"||typeof O.mtime!="number"))return O.mtime.toString(29)+O.size.toString(31)}e.etag=_;async function Q(O,H){if(!H.hasProvider(P.URI.from({scheme:O.scheme})))return new Promise(q=>{const Y=H.onDidChangeFileSystemProviderRegistrations($=>{$.scheme===O.scheme&&$.added&&(Y.dispose(),q())})})}e.whenProviderRegistered=Q,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class ne{static formatSize(H){return(0,C.isNumber)(H)||(H=0),H<ne.KB?(0,I.localize)(1,null,H.toFixed(0)):H<ne.MB?(0,I.localize)(2,null,(H/ne.KB).toFixed(2)):H<ne.GB?(0,I.localize)(3,null,(H/ne.MB).toFixed(2)):H<ne.TB?(0,I.localize)(4,null,(H/ne.GB).toFixed(2)):(0,I.localize)(5,null,(H/ne.TB).toFixed(2))}}e.ByteSize=ne,ne.KB=1024,ne.MB=ne.KB*ne.KB,ne.GB=ne.MB*ne.KB,ne.TB=ne.GB*ne.KB;var oe;(function(O){O[O.IA32=0]="IA32",O[O.OTHER=1]="OTHER"})(oe=e.Arch||(e.Arch={}));function X(O){return{maxFileSize:O===0?300*ne.MB:16*ne.GB,maxHeapSize:O===0?700*ne.MB:2*700*ne.MB}}e.getPlatformLimits=X}),define(Z[53],x([0,1,248,138,87,18]),function(j,e,p,r,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function P(m,S){const t={onUnknownOption:E=>{console.warn((0,r.localize)(0,null,E))},onMultipleValues:(E,v)=>{console.warn((0,r.localize)(1,null,E,v))},onDeprecatedOption:(E,v)=>{console.warn((0,r.localize)(2,null,E,v))}},g=(0,D.parseArgs)(m,D.OPTIONS,S?t:void 0);return g.goto&&g._.forEach(E=>p(/^(\w:)?[^:]+(:\d*){0,2}$/.test(E),(0,r.localize)(3,null))),g["max-memory"]&&p(parseInt(g["max-memory"])>=C.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${C.MIN_MAX_MEMORY_SIZE_MB} MB.`),g}function I(m){const S=m.findIndex(t=>!/^-/.test(t));if(S>-1)return[...m.slice(0,S),...m.slice(S+1)]}function d(m){let[,...S]=m;process.env.VSCODE_DEV&&(S=I(S)||[]);const t=!b(process.env);return P(S,t)}e.parseMainProcessArgv=d;function f(m){const[,,...S]=m;return P(S,!0)}e.parseCLIProcessArgv=f;function y(m,...S){const t=m.indexOf("--");return t===-1?m.push(...S):m.splice(t,0,...S),m}e.addArg=y;function b(m){return m.VSCODE_CLI==="1"}e.isLaunchedFromCli=b}),define(Z[90],x([0,1,43,8,139,23,44,16,3,31,132,53,9]),function(j,e,p,r,D,C,P,I,d,f,y,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const S=1e4;let t;async function g(v,k,c){return k["force-disable-user-env"]?(v.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):d.isWindows?(v.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,b.isLaunchedFromCli)(c)&&!k["force-user-env"]?(v.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,b.isLaunchedFromCli)(c)?v.trace("resolveShellEnv(): running (--force-user-env)"):v.trace("resolveShellEnv(): running (macOS/Linux)"),t||(t=m.Promises.withAsyncBody(async(a,u)=>{const s=new C.CancellationTokenSource,l=setTimeout(()=>{s.dispose(!0),u(new Error((0,D.localize)(0,null)))},S);try{a(await E(v,s.token))}catch(n){!(0,I.isPromiseCanceledError)(n)&&!s.token.isCancellationRequested?u(new Error((0,D.localize)(1,null,(0,P.toErrorMessage)(n)))):a({})}finally{clearTimeout(l),s.dispose()}})),t)}e.getResolvedShellEnv=g;async function E(v,k){const c=process.env.ELECTRON_RUN_AS_NODE;v.trace("getUnixShellEnvironment#runAsNode",c);const a=process.env.ELECTRON_NO_ATTACH_CONSOLE;v.trace("getUnixShellEnvironment#noAttach",a);const u=(0,f.generateUuid)().replace(/-/g,"").substr(0,12),s=new RegExp(u+"(.*)"+u),l={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};v.trace("getUnixShellEnvironment#env",l);const n=await(0,y.getSystemShell)(d.OS,l);return v.trace("getUnixShellEnvironment#shell",n),new Promise((i,o)=>{if(k.isCancellationRequested)return o((0,I.canceled)());const h=(0,r.basename)(n);let w,M;const A=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(h)?(w=`& '${process.execPath}' ${A} -p '''${u}'' + JSON.stringify(process.env) + ''${u}'''`,M=["-Login","-Command"]):(w=`'${process.execPath}' ${A} -p '"${u}" + JSON.stringify(process.env) + "${u}"'`,h==="tcsh"?M=["-ic"]:M=["-ilc"]),v.trace("getUnixShellEnvironment#spawn",JSON.stringify(M),w);const R=(0,p.spawn)(n,[...M,w],{detached:!0,stdio:["ignore","pipe","pipe"],env:l});k.onCancellationRequested(()=>(R.kill(),o((0,I.canceled)()))),R.on("error",Q=>{v.error("getUnixShellEnvironment#errorChildProcess",(0,P.toErrorMessage)(Q)),o(Q)});const T=[];R.stdout.on("data",Q=>T.push(Q));const _=[];R.stderr.on("data",Q=>_.push(Q)),R.on("close",(Q,ne)=>{const oe=Buffer.concat(T).toString("utf8");v.trace("getUnixShellEnvironment#raw",oe);const X=Buffer.concat(_).toString("utf8");if(X.trim()&&v.trace("getUnixShellEnvironment#stderr",X),Q||ne)return o(new Error((0,D.localize)(2,null,Q,ne)));const O=s.exec(oe),H=O?O[1]:"{}";try{const q=JSON.parse(H);c?q.ELECTRON_RUN_AS_NODE=c:delete q.ELECTRON_RUN_AS_NODE,a?q.ELECTRON_NO_ATTACH_CONSOLE=a:delete q.ELECTRON_NO_ATTACH_CONSOLE,delete q.XDG_RUNTIME_DIR,v.trace("getUnixShellEnvironment#result",q),i(q)}catch(q){v.error("getUnixShellEnvironment#errorCaught",(0,P.toErrorMessage)(q)),o(q)}})})}}),define(Z[91],x([0,1,17,16,145,18]),function(j,e,p,r,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function P(y,b,m,S,t,g){let E;try{await I(y,b,m,S,t,g)}catch(v){E=v}finally{E&&t.errorTransformer&&(E=t.errorTransformer(E)),typeof E!="undefined"&&m.error(E),m.end()}}e.readFileIntoStream=P;async function I(y,b,m,S,t,g){d(g);const E=await y.open(b,{create:!1});try{d(g);let v=0,k=0,c=t&&typeof t.length=="number"?t.length:void 0,a=p.VSBuffer.alloc(Math.min(t.bufferSize,typeof c=="number"?c:t.bufferSize)),u=t&&typeof t.position=="number"?t.position:0,s=0;do k=await y.read(E,u,a.buffer,s,a.byteLength-s),u+=k,s+=k,v+=k,typeof c=="number"&&(c-=k),s===a.byteLength&&(await m.write(S(a)),a=p.VSBuffer.alloc(Math.min(t.bufferSize,typeof c=="number"?c:t.bufferSize)),s=0);while(k>0&&(typeof c!="number"||c>0)&&d(g)&&f(v,t));if(s>0){let l=s;typeof c=="number"&&(l=Math.min(s,c)),m.write(S(a.slice(0,l)))}}catch(v){throw(0,C.ensureFileSystemProviderError)(v)}finally{await y.close(E)}}function d(y){if(y.isCancellationRequested)throw(0,r.canceled)();return!0}function f(y,b){if(b?.limits){if(typeof b.limits.memory=="number"&&y>b.limits.memory)throw(0,C.createFileSystemProviderError)((0,D.localize)(0,null),C.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof b.limits.size=="number"&&y>b.limits.size)throw(0,C.createFileSystemProviderError)((0,D.localize)(1,null),C.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Z[62],x([0,1,2,3,7,18]),function(j,e,p,r,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.coalesceEvents=e.toFileChanges=e.AbstractRecursiveWatcherClient=void 0;class P extends p.Disposable{constructor(b,m,S){super();this.onFileChanges=b,this.onLogMessage=m,this.verboseLogging=S,this.watcherDisposables=this._register(new p.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const b=new p.DisposableStore;this.watcherDisposables.value=b,this.watcher=this.createWatcher(b),this.watcher.setVerboseLogging(this.verboseLogging),b.add(this.watcher.onDidChangeFile(m=>this.onFileChanges(m))),b.add(this.watcher.onDidLogMessage(m=>this.onLogMessage(m))),b.add(this.watcher.onDidError(m=>this.onError(m)))}onError(b){this.restartCounter<P.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${b}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${b}`)}restart(b){this.restartCounter++,this.init(),this.watch(b)}async watch(b){this.requests=b,await this.watcher?.watch(b)}async setVerboseLogging(b){this.verboseLogging=b,await this.watcher?.setVerboseLogging(b)}error(b){this.onLogMessage({type:"error",message:`[File Watcher (parcel)] ${b}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractRecursiveWatcherClient=P,P.MAX_RESTARTS=5;function I(y){return y.map(b=>({type:b.type,resource:D.URI.file(b.path)}))}e.toFileChanges=I;function d(y){const b=new f;for(const m of y)b.processEvent(m);return b.coalesce()}e.coalesceEvents=d;class f{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(b){return r.isLinux?b.path:b.path.toLowerCase()}processEvent(b){const m=this.mapPathToChange.get(this.toKey(b));let S=!1;if(m){const t=m.type,g=b.type;m.path!==b.path&&b.type===2?S=!0:t===1&&g===2?(this.mapPathToChange.delete(this.toKey(b)),this.coalesced.delete(m)):t===2&&g===1?m.type=0:t===1&&g===0||(m.type=g)}else S=!0;S&&(this.coalesced.add(b),this.mapPathToChange.set(this.toKey(b),b))}coalesce(){const b=[],m=[];return Array.from(this.coalesced).filter(S=>S.type!==2?(b.push(S),!1):!0).sort((S,t)=>S.path.length-t.path.length).filter(S=>m.some(t=>(0,C.isParent)(S.path,t,!r.isLinux))?!1:(m.push(S.path),!0)).concat(b)}}}),define(Z[92],x([0,1,9,2,8,82,21,119,62]),function(j,e,p,r,D,C,P,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSFileWatcher=void 0;class f extends r.Disposable{constructor(b,m,S,t){super();this.path=b,this.onDidFilesChange=m,this.onLogMessage=S,this.verboseLogging=t,this.fileChangesDelayer=this._register(new p.ThrottledDelayer(I.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(b){this.verboseLogging=b}async startWatching(){try{const{stat:b,symbolicLink:m}=await P.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let S=this.path;if(m)try{S=await(0,C.realpath)(S)}catch(t){if(this.onError(t),m.dangling)return}b.isDirectory()?this._register((0,I.watchFolder)(S,(t,g)=>{this.onFileChange({type:t==="changed"?0:t==="added"?1:2,path:(0,D.join)(this.path,(0,D.basename)(g))})},t=>this.onError(t))):this._register((0,I.watchFile)(S,t=>{this.onFileChange({type:t==="changed"?0:2,path:this.path})},t=>this.onError(t)))}catch(b){b.code!=="ENOENT"&&this.onError(b)}}onFileChange(b){this.fileChangesBuffer.push(b),this.verboseLogging&&this.onVerbose(`${b.type===1?"[ADDED]":b.type===2?"[DELETED]":"[CHANGED]"} ${b.path}`),this.fileChangesDelayer.trigger(async()=>{const m=this.fileChangesBuffer;this.fileChangesBuffer=[];const S=(0,d.coalesceEvents)(m);if(this.verboseLogging)for(const t of S)this.onVerbose(`>> normalized ${t.type===1?"[ADDED]":t.type===2?"[DELETED]":"[CHANGED]"} ${t.path}`);S.length>0&&this.onDidFilesChange(S)})}onError(b){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${b}`})}onVerbose(b){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${b}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.NodeJSFileWatcher=f}),define(Z[174],x([0,1,10,36,133,62]),function(j,e,p,r,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParcelWatcherClient=void 0;class P extends C.AbstractRecursiveWatcherClient{constructor(d,f,y){super(d,f,y);this.init()}createWatcher(d){const f=d.add(new D.Client(p.FileAccess.asFileUri("bootstrap-fork",j).fsPath,{serverName:"File Watcher (parcel, node.js)",args:["--type=parcelWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/parcel/parcelWatcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return d.add(f.onDidProcessExit(({code:y,signal:b})=>this.onError(`terminated by itself with code ${y}, signal: ${b}`))),r.ProxyChannel.toService((0,r.getNextTickChannel)(f.getChannel("watcher")))}}e.ParcelWatcherClient=P}),define(Z[75],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class p{constructor(...D){this._entries=new Map;for(let[C,P]of D)this.set(C,P)}set(D,C){const P=this._entries.get(D);return this._entries.set(D,C),P}has(D){return this._entries.has(D)}get(D){return this._entries.get(D)}}e.ServiceCollection=p}),define(Z[175],x([0,1,9,16,73,169,5,75]),function(j,e,p,r,D,C,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const d=!1;class f extends Error{constructor(t){super("cyclic dependency between services");this.message=t.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${t.toString()}`}}class y{constructor(t=new I.ServiceCollection,g=!1,E){this._activeInstantiations=new Set,this._services=t,this._strict=g,this._parent=E,this._services.set(P.IInstantiationService,this)}createChild(t){return new y(t,this._strict,this)}invokeFunction(t,...g){let E=m.traceInvocation(t),v=!1;try{return t({get:c=>{if(v)throw(0,r.illegalState)("service accessor is only valid during the invocation of its target method");const a=this._getOrCreateServiceInstance(c,E);if(!a)throw new Error(`[invokeFunction] unknown service '${c}'`);return a}},...g)}finally{v=!0,E.stop()}}createInstance(t,...g){let E,v;return t instanceof D.SyncDescriptor?(E=m.traceCreation(t.ctor),v=this._createInstance(t.ctor,t.staticArguments.concat(g),E)):(E=m.traceCreation(t),v=this._createInstance(t,g,E)),E.stop(),v}_createInstance(t,g=[],E){let v=P._util.getServiceDependencies(t).sort((a,u)=>a.index-u.index),k=[];for(const a of v){let u=this._getOrCreateServiceInstance(a.id,E);if(!u&&this._strict&&!a.optional)throw new Error(`[createInstance] ${t.name} depends on UNKNOWN service ${a.id}.`);k.push(u)}let c=v.length>0?v[0].index:g.length;if(g.length!==c){console.warn(`[createInstance] First service dependency of ${t.name} at position ${c+1} conflicts with ${g.length} static arguments`);let a=c-g.length;a>0?g=g.concat(new Array(a)):g=g.slice(0,c)}return new t(...[...g,...k])}_setServiceInstance(t,g){if(this._services.get(t)instanceof D.SyncDescriptor)this._services.set(t,g);else if(this._parent)this._parent._setServiceInstance(t,g);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(t){let g=this._services.get(t);return!g&&this._parent?this._parent._getServiceInstanceOrDescriptor(t):g}_getOrCreateServiceInstance(t,g){let E=this._getServiceInstanceOrDescriptor(t);return E instanceof D.SyncDescriptor?this._safeCreateAndCacheServiceInstance(t,E,g.branch(t,!0)):(g.branch(t,!1),E)}_safeCreateAndCacheServiceInstance(t,g,E){if(this._activeInstantiations.has(t))throw new Error(`illegal state - RECURSIVELY instantiating service '${t}'`);this._activeInstantiations.add(t);try{return this._createAndCacheServiceInstance(t,g,E)}finally{this._activeInstantiations.delete(t)}}_createAndCacheServiceInstance(t,g,E){const v=new C.Graph(a=>a.id.toString());let k=0;const c=[{id:t,desc:g,_trace:E}];for(;c.length;){const a=c.pop();if(v.lookupOrInsertNode(a),k++>1e3)throw new f(v);for(let u of P._util.getServiceDependencies(a.desc.ctor)){let s=this._getServiceInstanceOrDescriptor(u.id);if(!s&&!u.optional&&console.warn(`[createInstance] ${t} depends on ${u.id} which is NOT registered.`),s instanceof D.SyncDescriptor){const l={id:u.id,desc:s,_trace:a._trace.branch(u.id,!0)};v.insertEdge(a,l),c.push(l)}}}for(;;){const a=v.roots();if(a.length===0){if(!v.isEmpty())throw new f(v);break}for(const{data:u}of a){if(this._getServiceInstanceOrDescriptor(u.id)instanceof D.SyncDescriptor){const l=this._createServiceInstanceWithOwner(u.id,u.desc.ctor,u.desc.staticArguments,u.desc.supportsDelayedInstantiation,u._trace);this._setServiceInstance(u.id,l)}v.removeNode(u)}}return this._getServiceInstanceOrDescriptor(t)}_createServiceInstanceWithOwner(t,g,E=[],v,k){if(this._services.get(t)instanceof D.SyncDescriptor)return this._createServiceInstance(g,E,v,k);if(this._parent)return this._parent._createServiceInstanceWithOwner(t,g,E,v,k);throw new Error(`illegalState - creating UNKNOWN service instance ${g.name}`)}_createServiceInstance(t,g=[],E,v){if(E){const k=new p.IdleValue(()=>this._createInstance(t,g,v));return new Proxy(Object.create(null),{get(c,a){if(a in c)return c[a];let u=k.value,s=u[a];return typeof s!="function"||(s=s.bind(u),c[a]=s),s},set(c,a,u){return k.value[a]=u,!0}})}else return this._createInstance(t,g,v)}}e.InstantiationService=y;var b;(function(S){S[S.Creation=0]="Creation",S[S.Invocation=1]="Invocation",S[S.Branch=2]="Branch"})(b||(b={}));class m{constructor(t,g){this.type=t,this.name=g,this._start=Date.now(),this._dep=[]}static traceInvocation(t){return d?new m(1,t.name||t.toString().substring(0,42).replace(/\n/g,"")):m._None}static traceCreation(t){return d?new m(0,t.name):m._None}branch(t,g){let E=new m(2,t.toString());return this._dep.push([t,g,E]),E}stop(){let t=Date.now()-this._start;m._totals+=t;let g=!1;function E(k,c){let a=[],u=new Array(k+1).join("	");for(const[s,l,n]of c._dep)if(l&&n){g=!0,a.push(`${u}CREATES -> ${s}`);let i=E(k+1,n);i&&a.push(i)}else a.push(`${u}uses -> ${s}`);return a.join(`
`)}let v=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${E(1,this)}`,`DONE, took ${t.toFixed(2)}ms (grand total ${m._totals.toFixed(2)}ms)`];(t>2||g)&&console.log(v.join(`
`))}}m._None=new class extends m{constructor(){super(-1,null)}stop(){}branch(){return this}},m._totals=0}),define(Z[176],x([0,1,16,130,58]),function(j,e,p,r,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseResolvedKeybinding=void 0;class C extends D.ResolvedKeybinding{constructor(I,d){super();if(d.length===0)throw(0,p.illegalArgument)("parts");this._os=I,this._parts=d}getLabel(){return r.UILabelProvider.toLabel(this._os,this._parts,I=>this._getLabel(I))}getAriaLabel(){return r.AriaLabelProvider.toLabel(this._os,this._parts,I=>this._getAriaLabel(I))}getElectronAccelerator(){return this._parts.length>1||this._parts[0].isDuplicateModifierCase()?null:r.ElectronAcceleratorLabelProvider.toLabel(this._os,this._parts,I=>this._getElectronAccelerator(I))}getUserSettingsLabel(){return r.UserSettingsLabelProvider.toLabel(this._os,this._parts,I=>this._getUserSettingsLabel(I))}isWYSIWYG(){return this._parts.every(I=>this._isWYSIWYG(I))}isChord(){return this._parts.length>1}getParts(){return this._parts.map(I=>this._getPart(I))}_getPart(I){return new D.ResolvedKeybindingPart(I.ctrlKey,I.shiftKey,I.altKey,I.metaKey,this._getLabel(I),this._getAriaLabel(I))}getDispatchParts(){return this._parts.map(I=>this._getDispatchPart(I))}getSingleModifierDispatchParts(){return this._parts.map(I=>this._getSingleModifierDispatchPart(I))}}e.BaseResolvedKeybinding=C}),define(Z[177],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeElementsAfterNulls=e.ResolvedKeybindingItem=void 0;class p{constructor(C,P,I,d,f,y,b){this._resolvedKeybindingItemBrand=void 0,this.resolvedKeybinding=C,this.keypressParts=C?r(C.getDispatchParts()):[],C&&this.keypressParts.length===0&&(this.keypressParts=r(C.getSingleModifierDispatchParts())),this.bubble=P?P.charCodeAt(0)===94:!1,this.command=this.bubble?P.substr(1):P,this.commandArgs=I,this.when=d,this.isDefault=f,this.extensionId=y,this.isBuiltinExtension=b}}e.ResolvedKeybindingItem=p;function r(D){let C=[];for(let P=0,I=D.length;P<I;P++){const d=D[P];if(!d)return C;C.push(d)}return C}e.removeElementsAfterNulls=r}),define(Z[178],x([0,1,79,58,176,177]),function(j,e,p,r,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USLayoutResolvedKeybinding=void 0;class P extends D.BaseResolvedKeybinding{constructor(d,f){super(f,d.parts)}_keyCodeToUILabel(d){if(this._os===2)switch(d){case 15:return"\u2190";case 16:return"\u2191";case 17:return"\u2192";case 18:return"\u2193"}return p.KeyCodeUtils.toString(d)}_getLabel(d){return d.isDuplicateModifierCase()?"":this._keyCodeToUILabel(d.keyCode)}_getAriaLabel(d){return d.isDuplicateModifierCase()?"":p.KeyCodeUtils.toString(d.keyCode)}_getElectronAccelerator(d){return p.KeyCodeUtils.toElectronAccelerator(d.keyCode)}_getUserSettingsLabel(d){if(d.isDuplicateModifierCase())return"";const f=p.KeyCodeUtils.toUserSettingsUS(d.keyCode);return f&&f.toLowerCase()}_isWYSIWYG(){return!0}_getDispatchPart(d){return P.getDispatchStr(d)}static getDispatchStr(d){if(d.isModifierKey())return null;let f="";return d.ctrlKey&&(f+="ctrl+"),d.shiftKey&&(f+="shift+"),d.altKey&&(f+="alt+"),d.metaKey&&(f+="meta+"),f+=p.KeyCodeUtils.toString(d.keyCode),f}_getSingleModifierDispatchPart(d){return d.keyCode===5&&!d.shiftKey&&!d.altKey&&!d.metaKey?"ctrl":d.keyCode===4&&!d.ctrlKey&&!d.altKey&&!d.metaKey?"shift":d.keyCode===6&&!d.ctrlKey&&!d.shiftKey&&!d.metaKey?"alt":d.keyCode===57&&!d.ctrlKey&&!d.shiftKey&&!d.altKey?"meta":null}static _scanCodeToKeyCode(d){const f=p.IMMUTABLE_CODE_TO_KEY_CODE[d];if(f!==-1)return f;switch(d){case 10:return 31;case 11:return 32;case 12:return 33;case 13:return 34;case 14:return 35;case 15:return 36;case 16:return 37;case 17:return 38;case 18:return 39;case 19:return 40;case 20:return 41;case 21:return 42;case 22:return 43;case 23:return 44;case 24:return 45;case 25:return 46;case 26:return 47;case 27:return 48;case 28:return 49;case 29:return 50;case 30:return 51;case 31:return 52;case 32:return 53;case 33:return 54;case 34:return 55;case 35:return 56;case 36:return 22;case 37:return 23;case 38:return 24;case 39:return 25;case 40:return 26;case 41:return 27;case 42:return 28;case 43:return 29;case 44:return 30;case 45:return 21;case 51:return 83;case 52:return 81;case 53:return 87;case 54:return 89;case 55:return 88;case 56:return 0;case 57:return 80;case 58:return 90;case 59:return 86;case 60:return 82;case 61:return 84;case 62:return 85;case 106:return 92}return 0}static _resolveSimpleUserBinding(d){if(!d)return null;if(d instanceof r.SimpleKeybinding)return d;const f=this._scanCodeToKeyCode(d.scanCode);return f===0?null:new r.SimpleKeybinding(d.ctrlKey,d.shiftKey,d.altKey,d.metaKey,f)}static resolveUserBinding(d,f){const y=(0,C.removeElementsAfterNulls)(d.map(b=>this._resolveSimpleUserBinding(b)));return y.length>0?[new P(new r.ChordKeybinding(y),f)]:[]}}e.USLayoutResolvedKeybinding=P}),define(Z[179],x([0,1,9]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.handleVetos=void 0;function r(D,C){if(D.length===0)return Promise.resolve(!1);const P=[];let I=!1;for(let d of D){if(d===!0)return Promise.resolve(!0);(0,p.isThenable)(d)&&P.push(d.then(f=>{f&&(I=!0)},f=>{C(f),I=!0}))}return p.Promises.settled(P).then(()=>I)}e.handleVetos=r}),define(Z[6],x([0,1,44,4,2,3,5]),function(j,e,p,r,D,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,P.createDecorator)("logService"),e.ILoggerService=(0,P.createDecorator)("loggerService");function I(){return new Date().toISOString()}var d;(function(l){l[l.Trace=0]="Trace",l[l.Debug=1]="Debug",l[l.Info=2]="Info",l[l.Warning=3]="Warning",l[l.Error=4]="Error",l[l.Critical=5]="Critical",l[l.Off=6]="Off"})(d=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=d.Info;function f(l,n,i){switch(n){case d.Trace:l.trace(i);break;case d.Debug:l.debug(i);break;case d.Info:l.info(i);break;case d.Warning:l.warn(i);break;case d.Error:l.error(i);break;case d.Critical:l.critical(i);break;default:throw new Error("Invalid log level")}}e.log=f;function y(l){let n="";for(let i=0;i<l.length;i++){let o=l[i];if(typeof o=="object")try{o=JSON.stringify(o)}catch{}n+=(i>0?" ":"")+o}return n}e.format=y;class b extends D.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new r.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(n){this.level!==n&&(this.level=n,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=b;class m extends b{constructor(n){super();this.logAlways=n}checkLogLevel(n){return this.logAlways||this.getLevel()<=n}trace(n,...i){this.checkLogLevel(d.Trace)&&this.log(d.Trace,y([n,...i]))}debug(n,...i){this.checkLogLevel(d.Debug)&&this.log(d.Debug,y([n,...i]))}info(n,...i){this.checkLogLevel(d.Info)&&this.log(d.Info,y([n,...i]))}warn(n,...i){this.checkLogLevel(d.Warning)&&this.log(d.Warning,y([n,...i]))}error(n,...i){if(this.checkLogLevel(d.Error))if(n instanceof Error){const o=Array.prototype.slice.call(arguments);o[0]=n.stack,this.log(d.Error,y(o))}else this.log(d.Error,y([n,...i]))}critical(n,...i){this.checkLogLevel(d.Critical)&&this.log(d.Critical,y([n,...i]))}flush(){}}e.AbstractMessageLogger=m;class S extends b{constructor(n=e.DEFAULT_LOG_LEVEL){super();this.setLevel(n),this.useColors=!C.isWindows}trace(n,...i){this.getLevel()<=d.Trace&&(this.useColors?console.log(`[90m[main ${I()}][0m`,n,...i):console.log(`[main ${I()}]`,n,...i))}debug(n,...i){this.getLevel()<=d.Debug&&(this.useColors?console.log(`[90m[main ${I()}][0m`,n,...i):console.log(`[main ${I()}]`,n,...i))}info(n,...i){this.getLevel()<=d.Info&&(this.useColors?console.log(`[90m[main ${I()}][0m`,n,...i):console.log(`[main ${I()}]`,n,...i))}warn(n,...i){this.getLevel()<=d.Warning&&(this.useColors?console.warn(`[93m[main ${I()}][0m`,n,...i):console.warn(`[main ${I()}]`,n,...i))}error(n,...i){this.getLevel()<=d.Error&&(this.useColors?console.error(`[91m[main ${I()}][0m`,n,...i):console.error(`[main ${I()}]`,n,...i))}critical(n,...i){this.getLevel()<=d.Critical&&(this.useColors?console.error(`[90m[main ${I()}][0m`,n,...i):console.error(`[main ${I()}]`,n,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=S;class t extends b{constructor(n=e.DEFAULT_LOG_LEVEL){super();this.setLevel(n)}trace(n,...i){this.getLevel()<=d.Trace&&console.log("%cTRACE","color: #888",n,...i)}debug(n,...i){this.getLevel()<=d.Debug&&console.log("%cDEBUG","background: #eee; color: #888",n,...i)}info(n,...i){this.getLevel()<=d.Info&&console.log("%c INFO","color: #33f",n,...i)}warn(n,...i){this.getLevel()<=d.Warning&&console.log("%c WARN","color: #993",n,...i)}error(n,...i){this.getLevel()<=d.Error&&console.log("%c  ERR","color: #f33",n,...i)}critical(n,...i){this.getLevel()<=d.Critical&&console.log("%cCRITI","background: #f33; color: white",n,...i)}dispose(){}flush(){}}e.ConsoleLogger=t;class g extends b{constructor(n,i=e.DEFAULT_LOG_LEVEL){super();this.adapter=n,this.setLevel(i)}trace(n,...i){this.getLevel()<=d.Trace&&this.adapter.log(d.Trace,[this.extractMessage(n),...i])}debug(n,...i){this.getLevel()<=d.Debug&&this.adapter.log(d.Debug,[this.extractMessage(n),...i])}info(n,...i){this.getLevel()<=d.Info&&this.adapter.log(d.Info,[this.extractMessage(n),...i])}warn(n,...i){this.getLevel()<=d.Warning&&this.adapter.log(d.Warning,[this.extractMessage(n),...i])}error(n,...i){this.getLevel()<=d.Error&&this.adapter.log(d.Error,[this.extractMessage(n),...i])}critical(n,...i){this.getLevel()<=d.Critical&&this.adapter.log(d.Critical,[this.extractMessage(n),...i])}extractMessage(n){return typeof n=="string"?n:(0,p.toErrorMessage)(n,this.getLevel()<=d.Trace)}dispose(){}flush(){}}e.AdapterLogger=g;class E extends b{constructor(n){super();this.logServices=n,n.length&&this.setLevel(n[0].getLevel())}setLevel(n){for(const i of this.logServices)i.setLevel(n);super.setLevel(n)}trace(n,...i){for(const o of this.logServices)o.trace(n,...i)}debug(n,...i){for(const o of this.logServices)o.debug(n,...i)}info(n,...i){for(const o of this.logServices)o.info(n,...i)}warn(n,...i){for(const o of this.logServices)o.warn(n,...i)}error(n,...i){for(const o of this.logServices)o.error(n,...i)}critical(n,...i){for(const o of this.logServices)o.critical(n,...i)}flush(){for(const n of this.logServices)n.flush()}dispose(){for(const n of this.logServices)n.dispose()}}e.MultiplexLogService=E;class v extends D.Disposable{constructor(n){super();this.logger=n,this._register(n)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(n){this.logger.setLevel(n)}getLevel(){return this.logger.getLevel()}trace(n,...i){this.logger.trace(n,...i)}debug(n,...i){this.logger.debug(n,...i)}info(n,...i){this.logger.info(n,...i)}warn(n,...i){this.logger.warn(n,...i)}error(n,...i){this.logger.error(n,...i)}critical(n,...i){this.logger.critical(n,...i)}flush(){this.logger.flush()}}e.LogService=v;class k extends D.Disposable{constructor(n,i){super();this.logLevel=n,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(o=>{this.logLevel=o,this.logLevelChangeableLoggers.forEach(h=>h.setLevel(o))}))}getLogger(n){return this.loggers.get(n.toString())}createLogger(n,i){let o=this.loggers.get(n.toString());return o||(o=this.doCreateLogger(n,i?.always?d.Trace:this.logLevel,i),this.loggers.set(n.toString(),o),i?.always||this.logLevelChangeableLoggers.push(o)),o}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(n=>n.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=k;class c{constructor(){this.onDidChangeLogLevel=new r.Emitter().event}setLevel(n){}getLevel(){return d.Info}trace(n,...i){}debug(n,...i){}info(n,...i){}warn(n,...i){}error(n,...i){}critical(n,...i){}dispose(){}flush(){}}e.NullLogService=c;function a(l){if(l.verbose)return d.Trace;if(typeof l.logLevel=="string"){const n=u(l.logLevel.toLowerCase());if(n!==void 0)return n}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=a;function u(l){switch(l){case"trace":return d.Trace;case"debug":return d.Debug;case"info":return d.Info;case"warn":return d.Warning;case"error":return d.Error;case"critical":return d.Critical;case"off":return d.Off}}e.parseLogLevel=u;function s(l){switch(l){case d.Trace:return"trace";case d.Debug:return"debug";case d.Info:return"info";case d.Warning:return"warn";case d.Error:return"error";case d.Critical:return"critical";case d.Off:return"off"}}e.LogLevelToString=s});var ie=this&&this.__param||function(j,e){return function(p,r){e(p,r,j)}};define(Z[180],x([0,1,9,17,38,78,48,18,5,6]),function(j,e,p,r,D,C,P,I,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserConfigurationFileService=e.IUserConfigurationFileService=e.UserConfigurationFileServiceId=e.UserConfigurationErrorCode=void 0;var y;(function(m){m.ERROR_INVALID_FILE="ERROR_INVALID_FILE",m.ERROR_FILE_MODIFIED_SINCE="ERROR_FILE_MODIFIED_SINCE"})(y=e.UserConfigurationErrorCode||(e.UserConfigurationErrorCode={})),e.UserConfigurationFileServiceId="IUserConfigurationFileService",e.IUserConfigurationFileService=(0,d.createDecorator)(e.UserConfigurationFileServiceId);let b=class{constructor(S,t,g){this.environmentService=S,this.fileService=t,this.logService=g,this.queue=new p.Queue}async updateSettings(S,t){return this.queue.queue(()=>this.doWrite(S,t))}async doWrite(S,t){this.logService.trace(`${e.UserConfigurationFileServiceId}#write`,this.environmentService.settingsResource.toString(),S);const{value:g,mtime:E,etag:v}=await this.fileService.readFile(this.environmentService.settingsResource,{atomic:!0});let k=g.toString();const c=[];if((0,D.parse)(k,c,{allowTrailingComma:!0,allowEmptyContent:!0}),c.length)throw new Error("ERROR_INVALID_FILE");const a=this.getEdits(S,k,t)[0];if(a){k=k.substring(0,a.offset)+a.content+k.substring(a.offset+a.length);try{await this.fileService.writeFile(this.environmentService.settingsResource,r.VSBuffer.fromString(k),{etag:v,mtime:E})}catch(u){if(u.fileOperationResult===3)throw new Error("ERROR_FILE_MODIFIED_SINCE")}}}async write(S,t){return this.queue.queue(async()=>{await this.fileService.writeFile(this.environmentService.settingsResource,S,t)})}getEdits({value:S,path:t},g,E){return t.length?(0,C.setProperty)(g,t,S,E):[{content:JSON.stringify(S,null,E.insertSpaces&&E.tabSize?" ".repeat(E.tabSize):"	"),length:g.length,offset:0}]}};b=fe([ie(0,P.IEnvironmentService),ie(1,I.IFileService),ie(2,f.ILogService)],b),e.UserConfigurationFileService=b}),define(Z[181],x([0,1,30,9,16,4,2,8,62,6]),function(j,e,p,r,D,C,P,I,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class y extends P.Disposable{constructor(m){super();this.logService=m,this._onDidChangeFile=this._register(new C.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new C.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new r.ThrottledDelayer(0))}watch(m,S){return S.recursive?this.watchRecursive(m,S):this.watchNonRecursive(m)}watchRecursive(m,S){const t={path:this.toFilePath(m),excludes:S.excludes},g=(0,p.insert)(this.recursiveFoldersToWatch,t);return this.refreshRecursiveWatchers(),(0,P.toDisposable)(()=>{g(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(()=>this.doRefreshRecursiveWatchers()).catch(m=>(0,D.onUnexpectedError)(m))}doRefreshRecursiveWatchers(){return this.recursiveWatcher||(this.recursiveWatcher=this._register(this.createRecursiveWatcher(m=>this._onDidChangeFile.fire((0,d.toFileChanges)(m)),m=>this.onWatcherLogMessage(m),this.logService.getLevel()===f.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher?.setVerboseLogging(this.logService.getLevel()===f.LogLevel.Trace)}))),this.doWatch(this.recursiveWatcher,this.recursiveFoldersToWatch)}doWatch(m,S){return m.watch(S)}watchNonRecursive(m){const S=this.createNonRecursiveWatcher(this.toFilePath(m),g=>this._onDidChangeFile.fire((0,d.toFileChanges)(g)),g=>this.onWatcherLogMessage(g),this.logService.getLevel()===f.LogLevel.Trace),t=this.logService.onDidChangeLogLevel(()=>{S.setVerboseLogging(this.logService.getLevel()===f.LogLevel.Trace)});return(0,P.combinedDisposable)(S,t)}onWatcherLogMessage(m){m.type==="error"&&this._onDidWatchError.fire(m.message),this.logService[m.type](m.message)}toFilePath(m){return(0,I.normalize)(m.fsPath)}}e.AbstractDiskFileSystemProvider=y}),define(Z[182],x([0,1,30,9,17,23,4,69,2,39,10,63,15,59,143,18,91,6]),function(j,e,p,r,D,C,P,I,d,f,y,b,m,S,t,g,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let k=class Ye extends d.Disposable{constructor(a){super();this.logService=a,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new P.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new P.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new P.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new P.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new P.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new P.Emitter),this.onDidWatchError=this._onDidWatchError.event,this._onDidChangeFilesRaw=this._register(new P.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new r.ThrottledWorker(Ye.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ye.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ye.FILE_EVENTS_THROTTLING.coolDownDelay,u=>this._onDidFilesChange.fire(new g.FileChangesEvent(u,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new r.ThrottledWorker(Ye.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ye.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ye.FILE_EVENTS_THROTTLING.coolDownDelay,u=>this._onDidFilesChange.fire(new g.FileChangesEvent(u,!0)))),this.watchedResources=f.TernarySearchTree.forUris(u=>{const s=this.getProvider(u.scheme);return s?!this.isPathCaseSensitive(s):!1}),this.writeQueue=this._register(new r.ResourceQueue)}registerProvider(a,u){if(this.provider.has(a))throw new Error(`A filesystem provider for the scheme '${a}' is already registered.`);(0,b.mark)(`code/registerFilesystem/${a}`),this.provider.set(a,u),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:a,provider:u});const s=new d.DisposableStore;return s.add(u.onDidChangeFile(l=>this.onDidChangeFile(l,this.isPathCaseSensitive(u)))),s.add(u.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:u,scheme:a}))),typeof u.onDidWatchError=="function"&&s.add(u.onDidWatchError(l=>this._onDidWatchError.fire(new Error(l)))),(0,d.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:a,provider:u}),this.provider.delete(a),(0,d.dispose)(s)})}getProvider(a){return this.provider.get(a)}async activateProvider(a){const u=[];this._onWillActivateFileSystemProvider.fire({scheme:a,join(s){u.push(s)}}),!this.provider.has(a)&&await r.Promises.settled(u)}async canHandleResource(a){return await this.activateProvider(a.scheme),this.hasProvider(a)}hasProvider(a){return this.provider.has(a.scheme)}hasCapability(a,u){const s=this.provider.get(a.scheme);return!!(s&&s.capabilities&u)}listCapabilities(){return I.Iterable.map(this.provider,([a,u])=>({scheme:a,capabilities:u.capabilities}))}async withProvider(a){if(!(0,m.isAbsolutePath)(a))throw new g.FileOperationError((0,t.localize)(0,null,this.resourceForError(a)),8);await this.activateProvider(a.scheme);const u=this.provider.get(a.scheme);if(!u){const s=new Error;throw s.name="ENOPRO",s.message=(0,t.localize)(1,null,a.toString()),s}return u}async withReadProvider(a){const u=await this.withProvider(a);if((0,g.hasOpenReadWriteCloseCapability)(u)||(0,g.hasReadWriteCapability)(u)||(0,g.hasFileReadStreamCapability)(u))return u;throw new Error(`Filesystem provider for scheme '${a.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(a){const u=await this.withProvider(a);if((0,g.hasOpenReadWriteCloseCapability)(u)||(0,g.hasReadWriteCapability)(u))return u;throw new Error(`Filesystem provider for scheme '${a.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(a,u){try{return await this.doResolveFile(a,u)}catch(s){throw(0,g.toFileSystemProviderErrorCode)(s)===g.FileSystemProviderErrorCode.FileNotFound?new g.FileOperationError((0,t.localize)(2,null,this.resourceForError(a)),1):(0,g.ensureFileSystemProviderError)(s)}}async doResolveFile(a,u){const s=await this.withProvider(a),l=this.isPathCaseSensitive(s),n=u?.resolveTo,i=u?.resolveSingleChildDescendants,o=u?.resolveMetadata,h=await s.stat(a);let w;return this.toFileStat(s,a,h,void 0,!!o,(M,A)=>(w||(w=f.TernarySearchTree.forUris(()=>!l),w.set(a,!0),n&&w.fill(!0,n)),w.get(M.resource)||w.findSuperstr(M.resource.with({query:null,fragment:null}))?!0:M.isDirectory&&i?A===1:!1))}async toFileStat(a,u,s,l,n,i){const{providerExtUri:o}=this.getExtUri(a),h={resource:u,name:o.basename(u),isFile:(s.type&g.FileType.File)!=0,isDirectory:(s.type&g.FileType.Directory)!=0,isSymbolicLink:(s.type&g.FileType.SymbolicLink)!=0,mtime:s.mtime,ctime:s.ctime,size:s.size,readonly:Boolean((s.permissions??0)&g.FilePermission.Readonly)||Boolean(a.capabilities&2048),etag:(0,g.etag)({mtime:s.mtime,size:s.size})};if(h.isDirectory&&i(h,l)){try{const w=await a.readdir(u),M=await r.Promises.settled(w.map(async([A,R])=>{try{const T=o.joinPath(u,A),_=n?await a.stat(T):{type:R};return await this.toFileStat(a,T,_,w.length,n,i)}catch(T){return this.logService.trace(T),null}}));h.children=(0,p.coalesce)(M)}catch(w){this.logService.trace(w),h.children=[]}return h}return h}async resolveAll(a){return r.Promises.settled(a.map(async u=>{try{return{stat:await this.doResolveFile(u.resource,u.options),success:!0}}catch(s){return this.logService.trace(s),{stat:void 0,success:!1}}}))}async exists(a){const u=await this.withProvider(a);try{return!!await u.stat(a)}catch{return!1}}async canCreateFile(a,u){try{await this.doValidateCreateFile(a,u)}catch(s){return s}return!0}async doValidateCreateFile(a,u){if(!u?.overwrite&&await this.exists(a))throw new g.FileOperationError((0,t.localize)(3,null,this.resourceForError(a)),3,u)}async createFile(a,u=D.VSBuffer.fromString(""),s){await this.doValidateCreateFile(a,s);const l=await this.writeFile(a,u);return this._onDidRunOperation.fire(new g.FileOperationEvent(a,0,l)),l}async writeFile(a,u,s){const l=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),{providerExtUri:n}=this.getExtUri(l);try{await this.validateWriteFile(l,a,s)||await this.mkdirp(l,n.dirname(a));let o;if((0,g.hasReadWriteCapability)(l)&&!(u instanceof D.VSBuffer))if((0,S.isReadableStream)(u)){const h=await(0,S.peekStream)(u,3);h.ended?o=D.VSBuffer.concat(h.buffer):o=h}else o=(0,S.peekReadable)(u,h=>D.VSBuffer.concat(h),3);else o=u;!(0,g.hasOpenReadWriteCloseCapability)(l)||(0,g.hasReadWriteCapability)(l)&&o instanceof D.VSBuffer?await this.doWriteUnbuffered(l,a,s,o):await this.doWriteBuffered(l,a,s,o instanceof D.VSBuffer?(0,D.bufferToReadable)(o):o)}catch(i){throw new g.FileOperationError((0,t.localize)(4,null,this.resourceForError(a),(0,g.ensureFileSystemProviderError)(i).toString()),(0,g.toFileOperationResult)(i),s)}return this.resolve(a,{resolveMetadata:!0})}async validateWriteFile(a,u,s){if(!!s?.unlock&&!(a.capabilities&8192))throw new Error((0,t.localize)(5,null,this.resourceForError(u)));let n;try{n=await a.stat(u)}catch{return}if((n.type&g.FileType.Directory)!=0)throw new g.FileOperationError((0,t.localize)(6,null,this.resourceForError(u)),0,s);if(this.throwIfFileIsReadonly(u,n),typeof s?.mtime=="number"&&typeof s.etag=="string"&&s.etag!==g.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&s.mtime<n.mtime&&s.etag!==(0,g.etag)({mtime:s.mtime,size:n.size}))throw new g.FileOperationError((0,t.localize)(7,null),3,s);return n}async readFile(a,u,s){const l=await this.withReadProvider(a);return u?.atomic?this.doReadFileAtomic(l,a,u,s):this.doReadFile(l,a,u,s)}async doReadFileAtomic(a,u,s,l){return new Promise((n,i)=>{this.writeQueue.queueFor(u,this.getExtUri(a).providerExtUri).queue(async()=>{try{const o=await this.doReadFile(a,u,s,l);n(o)}catch(o){i(o)}})})}async doReadFile(a,u,s,l){const n=await this.doReadFileStream(a,u,{...s,preferUnbuffered:!0},l);return{...n,value:await(0,D.streamToBuffer)(n.value)}}async readFileStream(a,u,s){const l=await this.withReadProvider(a);return this.doReadFileStream(l,a,u,s)}async doReadFileStream(a,u,s,l){const n=new C.CancellationTokenSource(l),i=this.validateReadFile(u,s).then(h=>h,h=>{throw n.cancel(),h});let o;try{return typeof s?.etag=="string"&&s.etag!==g.ETAG_DISABLED&&await i,!((0,g.hasOpenReadWriteCloseCapability)(a)||(0,g.hasFileReadStreamCapability)(a))||(0,g.hasReadWriteCapability)(a)&&s?.preferUnbuffered?o=this.readFileUnbuffered(a,u,s):(0,g.hasFileReadStreamCapability)(a)?o=this.readFileStreamed(a,u,n.token,s):o=this.readFileBuffered(a,u,n.token,s),{...await i,value:o}}catch(h){o&&await(0,S.consumeStream)(o);const w=(0,t.localize)(8,null,this.resourceForError(u),(0,g.ensureFileSystemProviderError)(h).toString());throw h instanceof g.NotModifiedSinceFileOperationError?new g.NotModifiedSinceFileOperationError(w,h.stat,s):new g.FileOperationError(w,(0,g.toFileOperationResult)(h),s)}}readFileStreamed(a,u,s,l=Object.create(null)){const n=a.readFileStream(u,l,s);return(0,S.transform)(n,{data:i=>i instanceof D.VSBuffer?i:D.VSBuffer.wrap(i),error:i=>new g.FileOperationError((0,t.localize)(9,null,this.resourceForError(u),(0,g.ensureFileSystemProviderError)(i).toString()),(0,g.toFileOperationResult)(i),l)},i=>D.VSBuffer.concat(i))}readFileBuffered(a,u,s,l=Object.create(null)){const n=(0,D.newWriteableBufferStream)();return(0,E.readFileIntoStream)(a,u,n,i=>i,{...l,bufferSize:this.BUFFER_SIZE,errorTransformer:i=>new g.FileOperationError((0,t.localize)(10,null,this.resourceForError(u),(0,g.ensureFileSystemProviderError)(i).toString()),(0,g.toFileOperationResult)(i),l)},s),n}readFileUnbuffered(a,u,s){const l=(0,S.newWriteableStream)(n=>D.VSBuffer.concat(n));return(async()=>{try{let n=await a.readFile(u);typeof s?.position=="number"&&(n=n.slice(s.position)),typeof s?.length=="number"&&(n=n.slice(0,s.length)),this.validateReadFileLimits(u,n.byteLength,s),l.end(D.VSBuffer.wrap(n))}catch(n){l.error(n),l.end()}})(),l}async validateReadFile(a,u){const s=await this.resolve(a,{resolveMetadata:!0});if(s.isDirectory)throw new g.FileOperationError((0,t.localize)(11,null,this.resourceForError(a)),0,u);if(typeof u?.etag=="string"&&u.etag!==g.ETAG_DISABLED&&u.etag===s.etag)throw new g.NotModifiedSinceFileOperationError((0,t.localize)(12,null),s,u);return this.validateReadFileLimits(a,s.size,u),s}validateReadFileLimits(a,u,s){if(s?.limits){let l;if(typeof s.limits.memory=="number"&&u>s.limits.memory&&(l=9),typeof s.limits.size=="number"&&u>s.limits.size&&(l=7),typeof l=="number")throw new g.FileOperationError((0,t.localize)(13,null,this.resourceForError(a)),l)}}async canMove(a,u,s){return this.doCanMoveCopy(a,u,"move",s)}async canCopy(a,u,s){return this.doCanMoveCopy(a,u,"copy",s)}async doCanMoveCopy(a,u,s,l){if(a.toString()!==u.toString())try{const n=s==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a):await this.withReadProvider(a),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u);await this.doValidateMoveCopy(n,a,i,u,s,l)}catch(n){return n}return!0}async move(a,u,s){const l=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u),i=await this.doMoveCopy(l,a,n,u,"move",!!s),o=await this.resolve(u,{resolveMetadata:!0});return this._onDidRunOperation.fire(new g.FileOperationEvent(a,i==="move"?2:3,o)),o}async copy(a,u,s){const l=await this.withReadProvider(a),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u),i=await this.doMoveCopy(l,a,n,u,"copy",!!s),o=await this.resolve(u,{resolveMetadata:!0});return this._onDidRunOperation.fire(new g.FileOperationEvent(a,i==="copy"?3:2,o)),o}async doMoveCopy(a,u,s,l,n,i){if(u.toString()===l.toString())return n;const{exists:o,isSameResourceWithDifferentPathCase:h}=await this.doValidateMoveCopy(a,u,s,l,n,i);if(o&&!h&&i&&await this.del(l,{recursive:!0}),await this.mkdirp(s,this.getExtUri(s).providerExtUri.dirname(l)),n==="copy"){if(a===s&&(0,g.hasFileFolderCopyCapability)(a))await a.copy(u,l,{overwrite:i});else{const w=await this.resolve(u);w.isDirectory?await this.doCopyFolder(a,w,s,l):await this.doCopyFile(a,u,s,l)}return n}else return a===s?(await a.rename(u,l,{overwrite:i}),n):(await this.doMoveCopy(a,u,s,l,"copy",i),await this.del(u,{recursive:!0}),"copy")}async doCopyFile(a,u,s,l){if((0,g.hasOpenReadWriteCloseCapability)(a)&&(0,g.hasOpenReadWriteCloseCapability)(s))return this.doPipeBuffered(a,u,s,l);if((0,g.hasOpenReadWriteCloseCapability)(a)&&(0,g.hasReadWriteCapability)(s))return this.doPipeBufferedToUnbuffered(a,u,s,l);if((0,g.hasReadWriteCapability)(a)&&(0,g.hasOpenReadWriteCloseCapability)(s))return this.doPipeUnbufferedToBuffered(a,u,s,l);if((0,g.hasReadWriteCapability)(a)&&(0,g.hasReadWriteCapability)(s))return this.doPipeUnbuffered(a,u,s,l)}async doCopyFolder(a,u,s,l){await s.mkdir(l),Array.isArray(u.children)&&await r.Promises.settled(u.children.map(async n=>{const i=this.getExtUri(s).providerExtUri.joinPath(l,n.name);return n.isDirectory?this.doCopyFolder(a,await this.resolve(n.resource),s,i):this.doCopyFile(a,n.resource,s,i)}))}async doValidateMoveCopy(a,u,s,l,n,i){let o=!1;if(a===s){const{providerExtUri:w,isPathCaseSensitive:M}=this.getExtUri(a);if(M||(o=w.isEqual(u,l)),o&&n==="copy")throw new Error((0,t.localize)(14,null,this.resourceForError(u),this.resourceForError(l)));if(!o&&w.isEqualOrParent(l,u))throw new Error((0,t.localize)(15,null,this.resourceForError(u),this.resourceForError(l)))}const h=await this.exists(l);if(h&&!o){if(!i)throw new g.FileOperationError((0,t.localize)(16,null,this.resourceForError(u),this.resourceForError(l)),4);if(a===s){const{providerExtUri:w}=this.getExtUri(a);if(w.isEqualOrParent(u,l))throw new Error((0,t.localize)(17,null,this.resourceForError(u),this.resourceForError(l)))}}return{exists:h,isSameResourceWithDifferentPathCase:o}}getExtUri(a){const u=this.isPathCaseSensitive(a);return{providerExtUri:u?m.extUri:m.extUriIgnorePathCase,isPathCaseSensitive:u}}isPathCaseSensitive(a){return!!(a.capabilities&1024)}async createFolder(a){const u=this.throwIfFileSystemIsReadonly(await this.withProvider(a),a);await this.mkdirp(u,a);const s=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new g.FileOperationEvent(a,0,s)),s}async mkdirp(a,u){const s=[],{providerExtUri:l}=this.getExtUri(a);for(;!l.isEqual(u,l.dirname(u));)try{if(((await a.stat(u)).type&g.FileType.Directory)==0)throw new Error((0,t.localize)(18,null,this.resourceForError(u)));break}catch(n){if((0,g.toFileSystemProviderErrorCode)(n)!==g.FileSystemProviderErrorCode.FileNotFound)throw n;s.push(l.basename(u)),u=l.dirname(u)}for(let n=s.length-1;n>=0;n--){u=l.joinPath(u,s[n]);try{await a.mkdir(u)}catch(i){if((0,g.toFileSystemProviderErrorCode)(i)!==g.FileSystemProviderErrorCode.FileExists)throw i}}}async canDelete(a,u){try{await this.doValidateDelete(a,u)}catch(s){return s}return!0}async doValidateDelete(a,u){const s=this.throwIfFileSystemIsReadonly(await this.withProvider(a),a);if(!!u?.useTrash&&!(s.capabilities&4096))throw new Error((0,t.localize)(19,null,this.resourceForError(a)));let n;try{n=await s.stat(a)}catch{}if(n)this.throwIfFileIsReadonly(a,n);else throw new g.FileOperationError((0,t.localize)(20,null,this.resourceForError(a)),1);if(!!!u?.recursive){const o=await this.resolve(a);if(o.isDirectory&&Array.isArray(o.children)&&o.children.length>0)throw new Error((0,t.localize)(21,null,this.resourceForError(a)))}return s}async del(a,u){const s=await this.doValidateDelete(a,u),l=!!u?.useTrash,n=!!u?.recursive;await s.delete(a,{recursive:n,useTrash:l}),this._onDidRunOperation.fire(new g.FileOperationEvent(a,1))}onDidChangeFile(a,u){this._onDidChangeFilesRaw.fire({changes:a});let s,l;{for(const n of a)this.watchedResources.has(n.resource)?(s||(s=[]),s.push(n)):(l||(l=[]),l.push(n));s&&this._onDidFilesChange.fire(new g.FileChangesEvent(s,!u))}if(l){const n=u?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!n.work(l)&&Ye.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${l.length}, most recent change: ${l[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),n.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${n.pending}, most recent change: ${l[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(a,u={recursive:!1,excludes:[]}){const s=new d.DisposableStore;let l=!1,n=()=>{l=!0};return s.add((0,d.toDisposable)(()=>n())),this.doWatch(a,u).then(i=>{l?(0,d.dispose)(i):n=()=>(0,d.dispose)(i)},i=>this.logService.error(i)),u.recursive||(this.watchedResources.set(a,(this.watchedResources.get(a)??0)+1),s.add((0,d.toDisposable)(()=>{const i=this.watchedResources.get(a);typeof i=="number"&&(i<=1?this.watchedResources.delete(a):this.watchedResources.set(a,i-1))}))),s}async doWatch(a,u){const s=await this.withProvider(a),l=this.toWatchKey(s,a,u);let n=this.activeWatchers.get(l);return n||(n={count:0,disposable:s.watch(a,u)},this.activeWatchers.set(l,n)),n.count+=1,(0,d.toDisposable)(()=>{n&&(n.count--,n.count===0&&((0,d.dispose)(n.disposable),this.activeWatchers.delete(l)))})}toWatchKey(a,u,s){const{providerExtUri:l}=this.getExtUri(a);return[l.getComparisonKey(u),String(s.recursive),s.excludes.join()].join()}dispose(){super.dispose();for(const[,a]of this.activeWatchers)(0,d.dispose)(a.disposable);this.activeWatchers.clear()}async doWriteBuffered(a,u,s,l){return this.writeQueue.queueFor(u,this.getExtUri(a).providerExtUri).queue(async()=>{const n=await a.open(u,{create:!0,unlock:s?.unlock??!1});try{(0,S.isReadableStream)(l)||(0,S.isReadableBufferedStream)(l)?await this.doWriteStreamBufferedQueued(a,n,l):await this.doWriteReadableBufferedQueued(a,n,l)}catch(i){throw(0,g.ensureFileSystemProviderError)(i)}finally{await a.close(n)}})}async doWriteStreamBufferedQueued(a,u,s){let l=0,n;if((0,S.isReadableBufferedStream)(s)){if(s.buffer.length>0){const i=D.VSBuffer.concat(s.buffer);await this.doWriteBuffer(a,u,i,i.byteLength,l,0),l+=i.byteLength}if(s.ended)return;n=s.stream}else n=s;return new Promise((i,o)=>{(0,S.listenStream)(n,{onData:async h=>{n.pause();try{await this.doWriteBuffer(a,u,h,h.byteLength,l,0)}catch(w){return o(w)}l+=h.byteLength,setTimeout(()=>n.resume())},onError:h=>o(h),onEnd:()=>i()})})}async doWriteReadableBufferedQueued(a,u,s){let l=0,n;for(;(n=s.read())!==null;)await this.doWriteBuffer(a,u,n,n.byteLength,l,0),l+=n.byteLength}async doWriteBuffer(a,u,s,l,n,i){let o=0;for(;o<l;)o+=await a.write(u,n+o,s.buffer,i+o,l-o)}async doWriteUnbuffered(a,u,s,l){return this.writeQueue.queueFor(u,this.getExtUri(a).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(a,u,s,l))}async doWriteUnbufferedQueued(a,u,s,l){let n;l instanceof D.VSBuffer?n=l:(0,S.isReadableStream)(l)?n=await(0,D.streamToBuffer)(l):(0,S.isReadableBufferedStream)(l)?n=await(0,D.bufferedStreamToBuffer)(l):n=(0,D.readableToBuffer)(l),await a.writeFile(u,n.buffer,{create:!0,overwrite:!0,unlock:s?.unlock??!1})}async doPipeBuffered(a,u,s,l){return this.writeQueue.queueFor(l,this.getExtUri(s).providerExtUri).queue(()=>this.doPipeBufferedQueued(a,u,s,l))}async doPipeBufferedQueued(a,u,s,l){let n,i;try{n=await a.open(u,{create:!1}),i=await s.open(l,{create:!0,unlock:!1});const o=D.VSBuffer.alloc(this.BUFFER_SIZE);let h=0,w=0,M=0;do M=await a.read(n,h,o.buffer,w,o.byteLength-w),await this.doWriteBuffer(s,i,o,M,h,w),h+=M,w+=M,w===o.byteLength&&(w=0);while(M>0)}catch(o){throw(0,g.ensureFileSystemProviderError)(o)}finally{await r.Promises.settled([typeof n=="number"?a.close(n):Promise.resolve(),typeof i=="number"?s.close(i):Promise.resolve()])}}async doPipeUnbuffered(a,u,s,l){return this.writeQueue.queueFor(l,this.getExtUri(s).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(a,u,s,l))}async doPipeUnbufferedQueued(a,u,s,l){return s.writeFile(l,await a.readFile(u),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(a,u,s,l){return this.writeQueue.queueFor(l,this.getExtUri(s).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(a,u,s,l))}async doPipeUnbufferedToBufferedQueued(a,u,s,l){const n=await s.open(l,{create:!0,unlock:!1});try{const i=await a.readFile(u);await this.doWriteBuffer(s,n,D.VSBuffer.wrap(i),i.byteLength,0,0)}catch(i){throw(0,g.ensureFileSystemProviderError)(i)}finally{await s.close(n)}}async doPipeBufferedToUnbuffered(a,u,s,l){const n=await(0,D.streamToBuffer)(this.readFileBuffered(a,u,C.CancellationToken.None));await this.doWriteUnbuffered(s,l,void 0,n)}throwIfFileSystemIsReadonly(a,u){if(a.capabilities&2048)throw new g.FileOperationError((0,t.localize)(22,null,this.resourceForError(u)),6);return a}throwIfFileIsReadonly(a,u){if((u.permissions??0)&g.FilePermission.Readonly)throw new g.FileOperationError((0,t.localize)(23,null,this.resourceForError(a)),6)}resourceForError(a){return a.scheme===y.Schemas.file?a.fsPath:a.toString(!0)}};k.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},k=fe([ie(0,v.ILogService)],k),e.FileService=k}),define(Z[183],x([0,1,14,146,3,7,18,92,8,2,62,6,168,111]),function(j,e,p,r,D,C,P,I,d,f,y,b,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderChannel=void 0;class t extends m.AbstractDiskFileSystemProviderChannel{constructor(v,k){super(v,k)}getUriTransformer(v){return S.DefaultURITransformer}transformIncoming(v,k){return C.URI.revive(k)}async delete(v,k,c){if(!c.useTrash)return super.delete(v,k,c);const a=this.transformIncoming(v,k),u=(0,d.normalize)(a.fsPath);try{await p.shell.trashItem(u)}catch{throw(0,P.createFileSystemProviderError)(D.isWindows?(0,r.localize)(0,null,(0,d.basename)(u)):(0,r.localize)(1,null,(0,d.basename)(u)),P.FileSystemProviderErrorCode.Unknown)}}createSessionFileWatcher(v,k){return new g(k,this.logService)}}e.DiskFileSystemProviderChannel=t;class g extends f.Disposable{constructor(v,k){super();this.sessionEmitter=v,this.logService=k,this.watcherRequests=new Map}watch(v,k,c){if(c.recursive)throw(0,P.createFileSystemProviderError)("Recursive watcher is not supported from main process",P.FileSystemProviderErrorCode.Unavailable);const a=new f.DisposableStore;this.watcherRequests.set(v,a),a.add((0,f.toDisposable)(()=>this.watcherRequests.delete(v)));const u=a.add(new I.NodeJSFileWatcher((0,d.normalize)(k.fsPath),s=>this.sessionEmitter.fire((0,y.toFileChanges)(s)),s=>this.onWatcherLogMessage(s),this.logService.getLevel()===b.LogLevel.Trace));return a.add(this.logService.onDidChangeLogLevel(()=>{u.setVerboseLogging(this.logService.getLevel()===b.LogLevel.Trace)})),a}onWatcherLogMessage(v){v.type==="error"&&this.sessionEmitter.fire(v.message),this.logService[v.type](v.message)}dispose(){super.dispose(),this.watcherRequests.forEach(v=>(0,f.dispose)(v)),this.watcherRequests.clear()}}}),define(Z[93],x([0,1,27,249,9,17,4,32,8,3,15,59,21,147,18,91,92,174,181,44]),function(j,e,p,r,D,C,P,I,d,f,y,b,m,S,t,g,E,v,k,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,r.gracefulify)(p)}catch(u){console.error(`Error enabling graceful-fs: ${(0,c.toErrorMessage)(u)}`)}})();class a extends k.AbstractDiskFileSystemProvider{constructor(s,l){super(s);this.options=l,this.onDidChangeCapabilities=P.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,f.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(s){try{const{stat:l,symbolicLink:n}=await m.SymlinkSupport.stat(this.toFilePath(s));return{type:this.toType(l,n),ctime:l.birthtime.getTime(),mtime:l.mtime.getTime(),size:l.size}}catch(l){throw this.toFileSystemProviderError(l)}}async readdir(s){try{const l=await m.Promises.readdir(this.toFilePath(s),{withFileTypes:!0}),n=[];return await Promise.all(l.map(async i=>{try{let o;i.isSymbolicLink()?o=(await this.stat((0,y.joinPath)(s,i.name))).type:o=this.toType(i),n.push([i.name,o])}catch(o){this.logService.trace(o)}})),n}catch(l){throw this.toFileSystemProviderError(l)}}toType(s,l){let n;return l?.dangling?n=t.FileType.Unknown:s.isFile()?n=t.FileType.File:s.isDirectory()?n=t.FileType.Directory:n=t.FileType.Unknown,l&&(n|=t.FileType.SymbolicLink),n}async readFile(s){try{const l=this.toFilePath(s);return await m.Promises.readFile(l)}catch(l){throw this.toFileSystemProviderError(l)}}readFileStream(s,l,n){const i=(0,b.newWriteableStream)(o=>C.VSBuffer.concat(o.map(h=>C.VSBuffer.wrap(h))).buffer);return(0,g.readFileIntoStream)(this,s,i,o=>o.buffer,{...l,bufferSize:256*1024},n),i}async writeFile(s,l,n){let i;try{const o=this.toFilePath(s);if(!n.create||!n.overwrite){if(await m.Promises.exists(o)){if(!n.overwrite)throw(0,t.createFileSystemProviderError)((0,S.localize)(0,null),t.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,t.createFileSystemProviderError)((0,S.localize)(1,null),t.FileSystemProviderErrorCode.FileNotFound)}i=await this.open(s,{create:!0,unlock:n.unlock}),await this.write(i,0,l,0,l.byteLength)}catch(o){throw await this.toFileSystemProviderWriteError(s,o)}finally{typeof i=="number"&&await this.close(i)}}async open(s,l){try{const n=this.toFilePath(s);if((0,t.isFileOpenForWriteOptions)(l)&&l.unlock)try{const{stat:h}=await m.SymlinkSupport.stat(n);h.mode&128||await m.Promises.chmod(n,h.mode|128)}catch(h){this.logService.trace(h)}let i;if((0,t.isFileOpenForWriteOptions)(l)){if(f.isWindows)try{await m.Promises.truncate(n,0),i="r+"}catch(h){h.code!=="ENOENT"&&this.logService.trace(h)}i||(i="w")}else i="r";const o=await m.Promises.open(n,i);return this.mapHandleToPos.set(o,0),(0,t.isFileOpenForWriteOptions)(l)&&this.writeHandles.set(o,s),o}catch(n){throw(0,t.isFileOpenForWriteOptions)(l)?await this.toFileSystemProviderWriteError(s,n):this.toFileSystemProviderError(n)}}async close(s){try{if(this.mapHandleToPos.delete(s),this.writeHandles.delete(s)&&this.canFlush)try{await m.Promises.fdatasync(s)}catch(l){this.canFlush=!1,this.logService.error(l)}return await m.Promises.close(s)}catch(l){throw this.toFileSystemProviderError(l)}}async read(s,l,n,i,o){const h=this.normalizePos(s,l);let w=null;try{const M=await m.Promises.read(s,n,i,o,h);return typeof M=="number"?w=M:w=M.bytesRead,w}catch(M){throw this.toFileSystemProviderError(M)}finally{this.updatePos(s,h,w)}}normalizePos(s,l){return l===this.mapHandleToPos.get(s)?null:l}updatePos(s,l,n){const i=this.mapHandleToPos.get(s);typeof i=="number"&&(typeof l=="number"||(typeof n=="number"?this.mapHandleToPos.set(s,i+n):this.mapHandleToPos.delete(s)))}async write(s,l,n,i,o){return(0,D.retry)(()=>this.doWrite(s,l,n,i,o),100,3)}async doWrite(s,l,n,i,o){const h=this.normalizePos(s,l);let w=null;try{const M=await m.Promises.write(s,n,i,o,h);return typeof M=="number"?w=M:w=M.bytesWritten,w}catch(M){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(s),M)}finally{this.updatePos(s,h,w)}}async mkdir(s){try{await m.Promises.mkdir(this.toFilePath(s))}catch(l){throw this.toFileSystemProviderError(l)}}async delete(s,l){try{const n=this.toFilePath(s);l.recursive?await m.Promises.rm(n,m.RimRafMode.MOVE):await m.Promises.unlink(n)}catch(n){throw this.toFileSystemProviderError(n)}}async rename(s,l,n){const i=this.toFilePath(s),o=this.toFilePath(l);if(i!==o)try{await this.validateTargetDeleted(s,l,"move",n.overwrite),await m.Promises.move(i,o)}catch(h){throw(h.code==="EINVAL"||h.code==="EBUSY"||h.code==="ENAMETOOLONG")&&(h=new Error((0,S.localize)(2,null,(0,d.basename)(i),(0,d.basename)((0,d.dirname)(o)),h.toString()))),this.toFileSystemProviderError(h)}}async copy(s,l,n){const i=this.toFilePath(s),o=this.toFilePath(l);if(i!==o)try{await this.validateTargetDeleted(s,l,"copy",n.overwrite),await m.Promises.copy(i,o,{preserveSymlinks:!0})}catch(h){throw(h.code==="EINVAL"||h.code==="EBUSY"||h.code==="ENAMETOOLONG")&&(h=new Error((0,S.localize)(3,null,(0,d.basename)(i),(0,d.basename)((0,d.dirname)(o)),h.toString()))),this.toFileSystemProviderError(h)}}async validateTargetDeleted(s,l,n,i){const o=this.toFilePath(s),h=this.toFilePath(l);let w=!1;if(!!(this.capabilities&1024)||(w=(0,I.isEqual)(o,h,!0)),w&&n==="copy")throw(0,t.createFileSystemProviderError)((0,S.localize)(4,null),t.FileSystemProviderErrorCode.FileExists);if(!w&&await m.Promises.exists(h)){if(!i)throw(0,t.createFileSystemProviderError)((0,S.localize)(5,null),t.FileSystemProviderErrorCode.FileExists);await this.delete(l,{recursive:!0,useTrash:!1})}}createRecursiveWatcher(s,l,n){return new v.ParcelWatcherClient(i=>s(i),i=>l(i),n)}doWatch(s,l){const n=this.options?.watcher?.usePolling;if(n===!0)for(const i of l)i.pollingInterval=this.options?.watcher?.pollingInterval??5e3;else if(Array.isArray(n))for(const i of l)n.includes(i.path)&&(i.pollingInterval=this.options?.watcher?.pollingInterval??5e3);return super.doWatch(s,l)}createNonRecursiveWatcher(s,l,n,i){return new E.NodeJSFileWatcher(s,o=>l(o),o=>n(o),i)}toFileSystemProviderError(s){if(s instanceof t.FileSystemProviderError)return s;let l;switch(s.code){case"ENOENT":l=t.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":l=t.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":l=t.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":l=t.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":l=t.FileSystemProviderErrorCode.NoPermissions;break;default:l=t.FileSystemProviderErrorCode.Unknown}return(0,t.createFileSystemProviderError)(s,l)}async toFileSystemProviderWriteError(s,l){let n=this.toFileSystemProviderError(l);if(s&&n.code===t.FileSystemProviderErrorCode.NoPermissions)try{const{stat:i}=await m.SymlinkSupport.stat(this.toFilePath(s));i.mode&128||(n=(0,t.createFileSystemProviderError)(l,t.FileSystemProviderErrorCode.FileWriteLocked))}catch(i){this.logService.trace(i)}return n}}e.DiskFileSystemProvider=a}),define(Z[94],x([0,1,6]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function r(C,P){switch(P){case p.LogLevel.Trace:return C.trace;case p.LogLevel.Debug:return C.debug;case p.LogLevel.Info:return C.info;case p.LogLevel.Warning:return C.warn;case p.LogLevel.Error:return C.error;case p.LogLevel.Critical:return C.critical;default:throw new Error("Invalid log level")}}class D extends p.AbstractLogger{constructor(P=p.DEFAULT_LOG_LEVEL){super();this.buffer=[],this._logger=void 0,this.setLevel(P),this._register(this.onDidChangeLogLevel(I=>{this._logger&&this._logger.setLevel(I)}))}set logger(P){this._logger=P;for(const{level:I,args:d}of this.buffer)r(P,I).apply(P,d);this.buffer=[]}_log(P,...I){this._logger?r(this._logger,P).apply(this._logger,I):this.getLevel()<=P&&this.buffer.push({level:P,args:I})}trace(P,...I){this._log(p.LogLevel.Trace,P,...I)}debug(P,...I){this._log(p.LogLevel.Debug,P,...I)}info(P,...I){this._log(p.LogLevel.Info,P,...I)}warn(P,...I){this._log(p.LogLevel.Warning,P,...I)}error(P,...I){this._log(p.LogLevel.Error,P,...I)}critical(P,...I){this._log(p.LogLevel.Critical,P,...I)}dispose(){this._logger&&this._logger.dispose()}flush(){this._logger&&this._logger.flush()}}e.BufferLogService=D}),define(Z[184],x([0,1,9,17,15,18,5,94,6]),function(j,e,p,r,D,C,P,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileLoggerService=e.FileLogger=void 0;const f=5*C.ByteSize.MB;let y=class extends d.AbstractLogger{constructor(S,t,g,E,v){super();this.name=S,this.resource=t,this.donotUseFormatters=E,this.fileService=v,this.backupIndex=1,this.setLevel(g),this.queue=this._register(new p.Queue),this.initializePromise=this.initialize()}trace(){this.getLevel()<=d.LogLevel.Trace&&this._log(d.LogLevel.Trace,(0,d.format)(arguments))}debug(){this.getLevel()<=d.LogLevel.Debug&&this._log(d.LogLevel.Debug,(0,d.format)(arguments))}info(){this.getLevel()<=d.LogLevel.Info&&this._log(d.LogLevel.Info,(0,d.format)(arguments))}warn(){this.getLevel()<=d.LogLevel.Warning&&this._log(d.LogLevel.Warning,(0,d.format)(arguments))}error(){if(this.getLevel()<=d.LogLevel.Error){const S=arguments[0];if(S instanceof Error){const t=Array.prototype.slice.call(arguments);t[0]=S.stack,this._log(d.LogLevel.Error,(0,d.format)(t))}else this._log(d.LogLevel.Error,(0,d.format)(arguments))}}critical(){this.getLevel()<=d.LogLevel.Critical&&this._log(d.LogLevel.Critical,(0,d.format)(arguments))}flush(){}async initialize(){try{await this.fileService.createFile(this.resource)}catch(S){if(S.fileOperationResult!==3)throw S}}_log(S,t){this.queue.queue(async()=>{await this.initializePromise;let g=await this.loadContent();g.length>f&&(await this.fileService.writeFile(this.getBackupResource(),r.VSBuffer.fromString(g)),g=""),this.donotUseFormatters?g+=t:g+=`[${this.getCurrentTimestamp()}] [${this.name}] [${this.stringifyLogLevel(S)}] ${t}
`,await this.fileService.writeFile(this.resource,r.VSBuffer.fromString(g))})}getCurrentTimestamp(){const S=E=>E<10?`0${E}`:E,t=E=>E<10?`00${E}`:E<100?`0${E}`:E,g=new Date;return`${g.getFullYear()}-${S(g.getMonth()+1)}-${S(g.getDate())} ${S(g.getHours())}:${S(g.getMinutes())}:${S(g.getSeconds())}.${t(g.getMilliseconds())}`}getBackupResource(){return this.backupIndex=this.backupIndex>5?1:this.backupIndex,(0,D.joinPath)((0,D.dirname)(this.resource),`${(0,D.basename)(this.resource)}_${this.backupIndex++}`)}async loadContent(){try{return(await this.fileService.readFile(this.resource)).value.toString()}catch{return""}}stringifyLogLevel(S){switch(S){case d.LogLevel.Critical:return"critical";case d.LogLevel.Debug:return"debug";case d.LogLevel.Error:return"error";case d.LogLevel.Info:return"info";case d.LogLevel.Trace:return"trace";case d.LogLevel.Warning:return"warning"}return""}};y=fe([ie(4,C.IFileService)],y),e.FileLogger=y;let b=class extends d.AbstractLoggerService{constructor(S,t,g){super(S.getLevel(),S.onDidChangeLogLevel);this.instantiationService=t,this.fileService=g}doCreateLogger(S,t,g){const E=new I.BufferLogService(t);return(0,C.whenProviderRegistered)(S,this.fileService).then(()=>E.logger=this.instantiationService.createInstance(y,g?.name||(0,D.basename)(S),S,E.getLevel(),!!g?.donotUseFormatters)),E}};b=fe([ie(0,d.ILogService),ie(1,P.IInstantiationService),ie(2,C.IFileService)],b),e.FileLoggerService=b}),define(Z[185],x([0,1,4,7,6]),function(j,e,p,r,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class C{constructor(m){this.service=m,this.onDidChangeLogLevel=p.Event.buffer(m.onDidChangeLogLevel,!0)}listen(m,S){switch(S){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${S}`)}async call(m,S,t){switch(S){case"setLevel":return this.service.setLevel(t)}throw new Error(`Call not found: ${S}`)}}e.LogLevelChannel=C;class P{constructor(m){this.channel=m}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(m){P.setLevel(this.channel,m)}static setLevel(m,S){return m.call("setLevel",S)}}e.LogLevelChannelClient=P;class I{constructor(m){this.loggerService=m,this.loggers=new Map}listen(m,S){throw new Error(`Event not found: ${S}`)}async call(m,S,t){switch(S){case"createLogger":this.createLogger(r.URI.revive(t[0]),t[1]);return;case"log":return this.log(r.URI.revive(t[0]),t[1]);case"consoleLog":return this.consoleLog(t[0],t[1])}throw new Error(`Call not found: ${S}`)}createLogger(m,S){this.loggers.set(m.toString(),this.loggerService.createLogger(m,S))}consoleLog(m,S){let t=console.log;switch(m){case D.LogLevel.Error:t=console.error;break;case D.LogLevel.Warning:t=console.warn;break;case D.LogLevel.Info:t=console.info;break}t.call(console,...S)}log(m,S){const t=this.loggers.get(m.toString());if(!t)throw new Error("Create the logger before logging");for(const[g,E]of S)(0,D.log)(t,g,E)}}e.LoggerChannel=I;class d extends D.AbstractLoggerService{constructor(m,S,t){super(m,S);this.channel=t}createConsoleMainLogger(){return new D.AdapterLogger({log:(m,S)=>{this.channel.call("consoleLog",[m,S])}})}doCreateLogger(m,S,t){return new f(this.channel,m,S,t)}}e.LoggerChannelClient=d;class f extends D.AbstractMessageLogger{constructor(m,S,t,g){super(g?.always);this.channel=m,this.file=S,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(t),this.channel.call("createLogger",[S,g]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(m,S){const t=[[m,S]];this.isLoggerCreated?this.doLog(t):this.buffer.push(...t)}doLog(m){this.channel.call("log",[this.file,m])}}class y extends D.LogService{constructor(m,S){super(S);this.parent=m,this._register(m.onDidChangeLogLevel(t=>S.setLevel(t)))}setLevel(m){super.setLevel(m),this.parent.setLevel(m)}}e.FollowerLogService=y}),define(Z[95],x([0,1,18,6]),function(j,e,p,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function D(I,d,f,y,b){try{const m=await new Promise((t,g)=>{j(["spdlog"],t,g)});m.setFlushOn(r.LogLevel.Trace);const S=await m.createAsyncRotatingLogger(I,d,f,y);return b&&S.clearFormatters(),S}catch(m){console.error(m)}return null}function C(I,d,f){switch(d){case r.LogLevel.Trace:I.trace(f);break;case r.LogLevel.Debug:I.debug(f);break;case r.LogLevel.Info:I.info(f);break;case r.LogLevel.Warning:I.warn(f);break;case r.LogLevel.Error:I.error(f);break;case r.LogLevel.Critical:I.critical(f);break;default:throw new Error("Invalid log level")}}class P extends r.AbstractMessageLogger{constructor(d,f,y,b,m){super();this.buffer=[],this.setLevel(m),this._loggerCreationPromise=this._createSpdLogLogger(d,f,y,b),this._register(this.onDidChangeLogLevel(S=>{this._logger&&this._logger.setLevel(S)}))}async _createSpdLogLogger(d,f,y,b){const m=y?6:1,S=30/m*p.ByteSize.MB,t=await D(d,f,S,m,b);if(t){this._logger=t,this._logger.setLevel(this.getLevel());for(const{level:g,message:E}of this.buffer)C(this._logger,g,E);this.buffer=[]}}log(d,f){this._logger?C(this._logger,d,f):this.getLevel()<=d&&this.buffer.push({level:d,message:f})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=P}),define(Z[186],x([0,1,10,15,31,18,184,6,95]),function(j,e,p,r,D,C,P,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let f=class extends I.AbstractLoggerService{constructor(b,m){super(b.getLevel(),b.onDidChangeLogLevel);this.fileService=m}doCreateLogger(b,m,S){return b.scheme===p.Schemas.file?new d.SpdLogLogger(S?.name||(0,D.generateUuid)(),b.fsPath,!S?.donotRotate,!!S?.donotUseFormatters,m):new P.FileLogger(S?.name??(0,r.basename)(b),b,m,!!S?.donotUseFormatters,this.fileService)}};f=fe([ie(0,I.ILogService),ie(1,C.IFileService)],f),e.LoggerService=f}),define(Z[187],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function p(P){return P.submenu!==void 0}e.isMenubarMenuItemSubmenu=p;function r(P){return P.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=r;function D(P){return P.uri!==void 0}e.isMenubarMenuItemRecentAction=D;function C(P){return!p(P)&&!r(P)&&!D(P)}e.isMenubarMenuItemAction=C}),define(Z[54],x([0,1,10,3,34,15]),function(j,e,p,r,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let P;if(typeof r.globals.vscode!="undefined"&&typeof r.globals.vscode.context!="undefined"){const I=r.globals.vscode.context.configuration();if(I)P=I.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof j?.__$__nodeRequire=="function"){const I=(0,C.dirname)(p.FileAccess.asFileUri("",j));P=j.__$__nodeRequire((0,C.joinPath)(I,"product.json").fsPath);const d=j.__$__nodeRequire((0,C.joinPath)(I,"package.json").fsPath);D.env.VSCODE_DEV&&Object.assign(P,{nameShort:`${P.nameShort} Dev`,nameLong:`${P.nameLong} Dev`,dataFolderName:`${P.dataFolderName}-dev`}),Object.assign(P,{version:d.version})}else P={},Object.keys(P).length===0&&Object.assign(P,{version:"1.63.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=P}),define(Z[22],x([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=(0,p.createDecorator)("productService")}),define(Z[188],x([0,1,60,6,22]),function(j,e,p,r,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let C=class{constructor(I,d){this.productService=I,this.logService=d,this.trustedExtensionUrlPublicKeys=new Map}async isExtensionUrlTrusted(I,d){if(!this.productService.trustedExtensionUrlPublicKeys)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const f=/^(.*)#([^#]+)$/.exec(d);if(!f)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",d),!1;const[,y,b]=f;let m=this.trustedExtensionUrlPublicKeys.get(I);if(!m){if(m=this.productService.trustedExtensionUrlPublicKeys[I],!m||m.length===0)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",I),!1;this.trustedExtensionUrlPublicKeys.set(I,[...m])}const S=Buffer.from(decodeURIComponent(b),"base64");if(S.length<=6)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",d),!1;const t=S.slice(0,6),g=S.readUIntBE(0,6),E=Date.now()-g;if(E<0||E>36e5)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",d),!1;const v=S.slice(6),k=p.createVerify("SHA256");k.write(t),k.write(Buffer.from(y)),k.end();for(let c=0;c<m.length;c++){let a=m[c];if(a!==null){if(typeof a=="string")try{a=p.createPublicKey({key:Buffer.from(a,"base64"),format:"der",type:"spki"}),m[c]=a}catch(u){this.logService.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${c+1} for ${I}:`,u),m[c]=null;continue}if(k.verify(a,v))return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",d),!0}}return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",d),!1}};C=fe([ie(0,D.IProductService),ie(1,r.ILogService)],C),e.ExtensionUrlTrustService=C}),define(Z[55],x([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,p.createDecorator)("protocolMainService")}),define(Z[189],x([0,1,14,2,39,10,3,15,7,31,48,6]),function(j,e,p,r,D,C,P,I,d,f,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let m=class extends r.Disposable{constructor(t,g){super();this.logService=g,this.validRoots=D.TernarySearchTree.forUris(()=>!P.isLinux),this.validExtensions=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp"]),this.addValidFileRoot(d.URI.file(t.appRoot)),this.addValidFileRoot(d.URI.file(t.extensionsPath)),this.addValidFileRoot(t.globalStorageHome),this.addValidFileRoot(t.workspaceStorageHome),this.handleProtocols()}handleProtocols(){const{defaultSession:t}=p.session;t.protocol.registerFileProtocol(C.Schemas.vscodeFileResource,(g,E)=>this.handleResourceRequest(g,E)),t.protocol.interceptFileProtocol(C.Schemas.file,(g,E)=>this.handleFileRequest(g,E)),this._register((0,r.toDisposable)(()=>{t.protocol.unregisterProtocol(C.Schemas.vscodeFileResource),t.protocol.uninterceptProtocol(C.Schemas.file)}))}addValidFileRoot(t){return this.validRoots.get(t)?r.Disposable.None:(this.validRoots.set(t,!0),(0,r.toDisposable)(()=>this.validRoots.delete(t)))}handleFileRequest(t,g){const E=d.URI.parse(t.url);return this.logService.error(`Refused to load resource ${E.fsPath} from ${C.Schemas.file}: protocol (original URL: ${t.url})`),g({error:-3})}handleResourceRequest(t,g){const E=d.URI.parse(t.url),v=C.FileAccess.asFileUri(E);return this.validRoots.findSubstr(v)?g({path:v.fsPath}):this.validExtensions.has((0,I.extname)(v))?g({path:v.fsPath}):(this.logService.error(`${C.Schemas.vscodeFileResource}: Refused to load resource ${v.fsPath} from ${C.Schemas.vscodeFileResource}: protocol (original URL: ${t.url})`),g({error:-3}))}createIPCObjectUrl(){let t;const g=d.URI.from({scheme:"vscode",path:(0,f.generateUuid)()}),E=g.toString(),v=async()=>t;return p.ipcMain.handle(E,v),this.logService.trace(`IPC Object URL: Registered new channel ${E}.`),{resource:g,update:k=>t=k,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${E}.`),p.ipcMain.removeHandler(E)}}}};m=fe([ie(0,y.INativeEnvironmentService),ie(1,b.ILogService)],m),e.ProtocolMainService=m}),define(Z[40],x([0,1,103,13]),function(j,e,p,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class D{constructor(){this.data=new Map}add(P,I){p.ok(r.isString(P)),p.ok(r.isObject(I)),p.ok(!this.data.has(P),"There is already an extension with this id"),this.data.set(P,I)}knows(P){return this.data.has(P)}as(P){return this.data.get(P)||null}}e.Registry=new D}),define(Z[190],x([0,1,4,40]),function(j,e,p,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function D(I){return I.length>0&&I.charAt(I.length-1)==="#"?I.substring(0,I.length-1):I}class C{constructor(){this._onDidChangeSchema=new p.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(d,f){this.schemasById[D(d)]=f,this._onDidChangeSchema.fire(d)}notifySchemaChanged(d){this._onDidChangeSchema.fire(d)}getSchemaContributions(){return{schemas:this.schemasById}}}const P=new C;r.Registry.add(e.Extensions.JSONContribution,P)}),define(Z[56],x([0,1,30,4,13,135,190,40]),function(j,e,p,r,D,C,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var d;(function(a){a.Multiline="multilineText",a.Singleline="singlelineText"})(d=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var f;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.MACHINE=2]="MACHINE",a[a.WINDOW=3]="WINDOW",a[a.RESOURCE=4]="RESOURCE",a[a.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",a[a.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(f=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const y=I.Registry.as(P.Extensions.JSONContribution);class b{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new r.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new r.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:C.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(u,s=!0){this.registerConfigurations([u],s)}registerConfigurations(u,s=!0){const l=this.doRegisterConfigurations(u,s);y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:l})}deregisterConfigurations(u){const s=this.doDeregisterConfigurations(u);y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s})}updateConfigurations({add:u,remove:s}){const l=[];l.push(...this.doDeregisterConfigurations(s)),l.push(...this.doRegisterConfigurations(u,!1)),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,p.distinct)(l)})}registerDefaultConfigurations(u){const s=[],l=[];for(const{overrides:n,source:i}of u)for(const o in n)if(s.push(o),e.OVERRIDE_PROPERTY_REGEX.test(o)){const h={...this.configurationDefaultsOverrides.get(o)?.value||{},...n[o]};this.configurationDefaultsOverrides.set(o,{source:i,value:h});const w={type:"object",default:h,description:C.localize(1,null,o),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:h,source:D.isString(i)?void 0:i};l.push(...t(o)),this.configurationProperties[o]=w,this.defaultLanguageConfigurationOverridesNode.properties[o]=w}else{this.configurationDefaultsOverrides.set(o,{value:n[o],source:i});const h=this.configurationProperties[o];h&&(this.updatePropertyDefaultValue(o,h),this.updateSchema(o,h))}this.registerOverrideIdentifiers(l),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s,defaultsOverrides:!0})}deregisterDefaultConfigurations(u){const s=[];for(const{overrides:l,source:n}of u)for(const i in l){const o=this.configurationDefaultsOverrides.get(i),h=D.isString(n)?n:n?.id,w=D.isString(o?.source)?o?.source:o?.source?.id;if(h===w)if(s.push(i),this.configurationDefaultsOverrides.delete(i),e.OVERRIDE_PROPERTY_REGEX.test(i))delete this.configurationProperties[i],delete this.defaultLanguageConfigurationOverridesNode.properties[i];else{const M=this.configurationProperties[i];M&&(this.updatePropertyDefaultValue(i,M),this.updateSchema(i,M))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...u){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(u){for(const s of u)this.overrideIdentifiers.add(s);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(u,s){const l=[];return u.forEach(n=>{l.push(...this.validateAndRegisterProperties(n,s,n.extensionInfo,n.restrictedProperties)),this.configurationContributors.push(n),this.registerJSONConfiguration(n)}),l}doDeregisterConfigurations(u){const s=[],l=n=>{if(n.properties)for(const i in n.properties)s.push(i),delete this.configurationProperties[i],this.removeFromSchema(i,n.properties[i]);n.allOf&&n.allOf.forEach(i=>l(i))};for(const n of u){l(n);const i=this.configurationContributors.indexOf(n);i!==-1&&this.configurationContributors.splice(i,1)}return s}validateAndRegisterProperties(u,s=!0,l,n,i=3){i=D.isUndefinedOrNull(u.scope)?i:u.scope;let o=[],h=u.properties;if(h)for(let M in h){if(s&&k(M)){delete h[M];continue}const A=h[M];if(A.source=l,A.defaultDefaultValue=h[M].default,this.updatePropertyDefaultValue(M,A),e.OVERRIDE_PROPERTY_REGEX.test(M)?A.scope=void 0:(A.scope=D.isUndefinedOrNull(A.scope)?i:A.scope,A.restricted=D.isUndefinedOrNull(A.restricted)?!!n?.includes(M):A.restricted),h[M].hasOwnProperty("included")&&!h[M].included){this.excludedConfigurationProperties[M]=h[M],delete h[M];continue}else this.configurationProperties[M]=h[M];!h[M].deprecationMessage&&h[M].markdownDeprecationMessage&&(h[M].deprecationMessage=h[M].markdownDeprecationMessage),o.push(M)}let w=u.allOf;if(w)for(let M of w)o.push(...this.validateAndRegisterProperties(M,s,l,n,i));return o}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(u){const s=l=>{let n=l.properties;if(n)for(const o in n)this.updateSchema(o,n[o]);let i=l.allOf;i&&i.forEach(s)};s(u)}updateSchema(u,s){switch(e.allSettings.properties[u]=s,s.scope){case 1:e.applicationSettings.properties[u]=s;break;case 2:e.machineSettings.properties[u]=s;break;case 6:e.machineOverridableSettings.properties[u]=s;break;case 3:e.windowSettings.properties[u]=s;break;case 4:e.resourceSettings.properties[u]=s;break;case 5:e.resourceSettings.properties[u]=s,this.resourceLanguageSettingsSchema.properties[u]=s;break}}removeFromSchema(u,s){switch(delete e.allSettings.properties[u],s.scope){case 1:delete e.applicationSettings.properties[u];break;case 2:delete e.machineSettings.properties[u];break;case 6:delete e.machineOverridableSettings.properties[u];break;case 3:delete e.windowSettings.properties[u];break;case 4:case 5:delete e.resourceSettings.properties[u],delete this.resourceLanguageSettingsSchema.properties[u];break}}updateOverridePropertyPatternKey(){for(const u of this.overrideIdentifiers.values()){const s=`[${u}]`,l={type:"object",description:C.localize(2,null),errorMessage:C.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(s,l),e.allSettings.properties[s]=l,e.applicationSettings.properties[s]=l,e.machineSettings.properties[s]=l,e.machineOverridableSettings.properties[s]=l,e.windowSettings.properties[s]=l,e.resourceSettings.properties[s]=l}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const u={type:"object",description:C.localize(4,null),errorMessage:C.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=u,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=u,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=u,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=u,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=u,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=u,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(u,s){const l=this.configurationDefaultsOverrides.get(u);let n=l?.value,i=l?.source;D.isUndefined(n)&&(n=s.defaultDefaultValue,i=void 0),D.isUndefined(n)&&(n=E(s.type)),s.default=n,s.defaultValueSource=i}}const m="\\[([^\\]]+)\\]",S=new RegExp(m,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${m})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function t(a){const u=[];if(e.OVERRIDE_PROPERTY_REGEX.test(a)){let s=S.exec(a);for(;s?.length;){const l=s[1].trim();l&&u.push(l),s=S.exec(a)}}return(0,p.distinct)(u)}e.overrideIdentifiersFromKey=t;function g(a){return a.reduce((u,s)=>`${u}[${s}]`,"")}e.keyFromOverrideIdentifiers=g;function E(a){switch(Array.isArray(a)?a[0]:a){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=E;const v=new b;I.Registry.add(e.Extensions.Configuration,v);function k(a){return a.trim()?e.OVERRIDE_PROPERTY_REGEX.test(a)?C.localize(7,null,a):v.getConfigurationProperties()[a]!==void 0?C.localize(8,null,a):null:C.localize(6,null)}e.validateProperty=k;function c(){const a=[],u=v.getConfigurationProperties();for(const s of Object.keys(u))a.push([s,u[s].scope]);return a.push(["launch",4]),a.push(["task",4]),a}e.getScopes=c}),define(Z[191],x([0,1,30,4,38,2,39,47,13,7,19,56,40]),function(j,e,p,r,D,C,P,I,d,f,y,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class S{constructor(n={},i=[],o=[]){this._contents=n,this._keys=i,this._overrides=o,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(n){return n?(0,y.getConfigurationValue)(this.contents,n):this.contents}getOverrideValue(n,i){const o=this.getContentsForOverrideIdentifer(i);return o?n?(0,y.getConfigurationValue)(o,n):o:void 0}getKeysForOverrideIdentifier(n){const i=[];for(const o of this.overrides)o.identifiers.includes(n)&&i.push(...o.keys);return p.distinct(i)}getAllOverrideIdentifiers(){const n=[];for(const i of this.overrides)n.push(...i.identifiers);return p.distinct(n)}override(n){let i=this.overrideConfigurations.get(n);return i||(i=this.createOverrideConfigurationModel(n),this.overrideConfigurations.set(n,i)),i}merge(...n){const i=I.deepClone(this.contents),o=I.deepClone(this.overrides),h=[...this.keys];for(const w of n){this.mergeContents(i,w.contents);for(const M of w.overrides){const[A]=o.filter(R=>p.equals(R.identifiers,M.identifiers));A?(this.mergeContents(A.contents,M.contents),A.keys.push(...M.keys),A.keys=p.distinct(A.keys)):o.push(I.deepClone(M))}for(const M of w.keys)h.indexOf(M)===-1&&h.push(M)}return new S(i,h,o)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(n){const i=this.getContentsForOverrideIdentifer(n);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let o={};for(const h of p.distinct([...Object.keys(this.contents),...Object.keys(i)])){let w=this.contents[h],M=i[h];M&&(typeof w=="object"&&typeof M=="object"?(w=I.deepClone(w),this.mergeContents(w,M)):w=M),o[h]=w}return new S(o,this.keys,this.overrides)}mergeContents(n,i){for(const o of Object.keys(i)){if(o in n&&d.isObject(n[o])&&d.isObject(i[o])){this.mergeContents(n[o],i[o]);continue}n[o]=I.deepClone(i[o])}}checkAndFreeze(n){return this.isFrozen&&!Object.isFrozen(n)?I.deepFreeze(n):n}getContentsForOverrideIdentifer(n){let i=null,o=null;const h=w=>{w&&(o?this.mergeContents(o,w):o=I.deepClone(w))};for(const w of this.overrides)p.equals(w.identifiers,[n])?i=w.contents:w.identifiers.includes(n)&&h(w.contents);return h(i),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(n,i){this.addKey(n),(0,y.addToValueTree)(this.contents,n,i,o=>{throw new Error(o)})}removeValue(n){this.removeKey(n)&&(0,y.removeFromValueTree)(this.contents,n)}addKey(n){let i=this.keys.length;for(let o=0;o<i;o++)n.indexOf(this.keys[o])===0&&(i=o);this.keys.splice(i,1,n)}removeKey(n){let i=this.keys.indexOf(n);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=S;class t extends S{constructor(n={}){const i=m.Registry.as(b.Extensions.Configuration).getConfigurationProperties(),o=Object.keys(i),h=Object.create(null),w=[];for(const M in i){const A=n[M],R=A!==void 0?A:i[M].default;(0,y.addToValueTree)(h,M,R,T=>console.error(`Conflict in default settings: ${T}`))}for(const M of Object.keys(h))b.OVERRIDE_PROPERTY_REGEX.test(M)&&w.push({identifiers:(0,b.overrideIdentifiersFromKey)(M),keys:Object.keys(h[M]),contents:(0,y.toValuesTree)(h[M],A=>console.error(`Conflict in default settings file: ${A}`))});super(h,o,w)}}e.DefaultConfigurationModel=t;class g{constructor(n){this._name=n,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new S}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(n,i){if(!d.isUndefinedOrNull(n)){const o=this.doParseContent(n);this.parseRaw(o,i)}}reparse(n){this._raw&&this.parseRaw(this._raw,n)}parseRaw(n,i){this._raw=n;const{contents:o,keys:h,overrides:w,restricted:M}=this.doParseRaw(n,i);this._configurationModel=new S(o,h,w),this._restrictedConfigurations=M||[]}doParseContent(n){let i={},o=null,h=[],w=[],M=[];function A(T){Array.isArray(h)?h.push(T):o!==null&&(h[o]=T)}let R={onObjectBegin:()=>{let T={};A(T),w.push(h),h=T,o=null},onObjectProperty:T=>{o=T},onObjectEnd:()=>{h=w.pop()},onArrayBegin:()=>{let T=[];A(T),w.push(h),h=T,o=null},onArrayEnd:()=>{h=w.pop()},onLiteralValue:A,onError:(T,_,Q)=>{M.push({error:T,offset:_,length:Q})}};if(n)try{D.visit(n,R),i=h[0]||{}}catch(T){console.error(`Error while parsing settings file ${this._name}: ${T}`),this._parseErrors=[T]}return i}doParseRaw(n,i){const o=m.Registry.as(b.Extensions.Configuration).getConfigurationProperties(),h=this.filter(n,o,!0,i);n=h.raw;const w=(0,y.toValuesTree)(n,R=>console.error(`Conflict in settings file ${this._name}: ${R}`)),M=Object.keys(n),A=this.toOverrides(n,R=>console.error(`Conflict in settings file ${this._name}: ${R}`));return{contents:w,keys:M,overrides:A,restricted:h.restricted}}filter(n,i,o,h){if(!h?.scopes&&!h?.skipRestricted)return{raw:n,restricted:[]};const w={},M=[];for(let A in n)if(b.OVERRIDE_PROPERTY_REGEX.test(A)&&o){const R=this.filter(n[A],i,!1,h);w[A]=R.raw,M.push(...R.restricted)}else{const R=i[A],T=R?typeof R.scope!="undefined"?R.scope:3:void 0;R?.restricted&&M.push(A),(T===void 0||h.scopes===void 0||h.scopes.includes(T))&&(h.skipRestricted&&R?.restricted||(w[A]=n[A]))}return{raw:w,restricted:M}}toOverrides(n,i){const o=[];for(const h of Object.keys(n))if(b.OVERRIDE_PROPERTY_REGEX.test(h)){const w={};for(const M in n[h])w[M]=n[h][M];o.push({identifiers:(0,b.overrideIdentifiersFromKey)(h),keys:Object.keys(w),contents:(0,y.toValuesTree)(w,i)})}return o}}e.ConfigurationModelParser=g;class E extends C.Disposable{constructor(n,i,o,h){super();this.userSettingsResource=n,this.scopes=i,this.fileService=h,this._onDidChange=this._register(new r.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new g(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(o.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(r.Event.filter(this.fileService.onDidFilesChange,w=>w.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const n=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(n.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new S}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=E;class v{constructor(n,i,o=new S,h=new S,w=new P.ResourceMap,M=new S,A=new P.ResourceMap,R=!0){this._defaultConfiguration=n,this._localUserConfiguration=i,this._remoteUserConfiguration=o,this._workspaceConfiguration=h,this._folderConfigurations=w,this._memoryConfiguration=M,this._memoryConfigurationByResource=A,this._freeze=R,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new P.ResourceMap,this._userConfiguration=null}getValue(n,i,o){return this.getConsolidateConfigurationModel(i,o).getValue(n)}updateValue(n,i,o={}){let h;o.resource?(h=this._memoryConfigurationByResource.get(o.resource),h||(h=new S,this._memoryConfigurationByResource.set(o.resource,h))):h=this._memoryConfiguration,i===void 0?h.removeValue(n):h.setValue(n,i),o.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(n,i,o){const h=this.getConsolidateConfigurationModel(i,o),w=this.getFolderConfigurationModelForResource(i.resource,o),M=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,A=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(n):this._defaultConfiguration.freeze().getValue(n),R=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(n):this.userConfiguration.freeze().getValue(n),T=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(n):this.localUserConfiguration.freeze().getValue(n),_=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(n):this.remoteUserConfiguration.freeze().getValue(n),Q=o?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(n):this._workspaceConfiguration.freeze().getValue(n):void 0,ne=w?i.overrideIdentifier?w.freeze().override(i.overrideIdentifier).getValue(n):w.freeze().getValue(n):void 0,oe=i.overrideIdentifier?M.override(i.overrideIdentifier).getValue(n):M.getValue(n),X=h.getValue(n),O=p.distinct(p.flatten(h.overrides.map(H=>H.identifiers))).filter(H=>h.getOverrideValue(n,H)!==void 0);return{defaultValue:A,userValue:R,userLocalValue:T,userRemoteValue:_,workspaceValue:Q,workspaceFolderValue:ne,memoryValue:oe,value:X,default:A!==void 0?{value:this._defaultConfiguration.freeze().getValue(n),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(n,i.overrideIdentifier):void 0}:void 0,user:R!==void 0?{value:this.userConfiguration.freeze().getValue(n),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(n,i.overrideIdentifier):void 0}:void 0,userLocal:T!==void 0?{value:this.localUserConfiguration.freeze().getValue(n),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(n,i.overrideIdentifier):void 0}:void 0,userRemote:_!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(n),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(n,i.overrideIdentifier):void 0}:void 0,workspace:Q!==void 0?{value:this._workspaceConfiguration.freeze().getValue(n),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(n,i.overrideIdentifier):void 0}:void 0,workspaceFolder:ne!==void 0?{value:w?.freeze().getValue(n),override:i.overrideIdentifier?w?.freeze().getOverrideValue(n,i.overrideIdentifier):void 0}:void 0,memory:oe!==void 0?{value:M.getValue(n),override:i.overrideIdentifier?M.getOverrideValue(n,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:O.length?O:void 0}}keys(n){const i=this.getFolderConfigurationModelForResource(void 0,n);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(n){this._defaultConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(n){this._localUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(n){this._remoteUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(n){this._workspaceConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(n,i){this._folderConfigurations.set(n,i),this._foldersConsolidatedConfigurations.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this._foldersConsolidatedConfigurations.delete(n)}compareAndUpdateDefaultConfiguration(n,i){const o=[];if(!i){const{added:h,updated:w,removed:M}=u(this._defaultConfiguration,n);i=[...h,...w,...M]}for(const h of i)for(const w of(0,b.overrideIdentifiersFromKey)(h)){const M=this._defaultConfiguration.getKeysForOverrideIdentifier(w),A=n.getKeysForOverrideIdentifier(w),R=[...A.filter(T=>M.indexOf(T)===-1),...M.filter(T=>A.indexOf(T)===-1),...M.filter(T=>!I.equals(this._defaultConfiguration.override(w).getValue(T),n.override(w).getValue(T)))];o.push([w,R])}return this.updateDefaultConfiguration(n),{keys:i,overrides:o}}compareAndUpdateLocalUserConfiguration(n){const{added:i,updated:o,removed:h,overrides:w}=u(this.localUserConfiguration,n),M=[...i,...o,...h];return M.length&&this.updateLocalUserConfiguration(n),{keys:M,overrides:w}}compareAndUpdateRemoteUserConfiguration(n){const{added:i,updated:o,removed:h,overrides:w}=u(this.remoteUserConfiguration,n);let M=[...i,...o,...h];return M.length&&this.updateRemoteUserConfiguration(n),{keys:M,overrides:w}}compareAndUpdateWorkspaceConfiguration(n){const{added:i,updated:o,removed:h,overrides:w}=u(this.workspaceConfiguration,n);let M=[...i,...o,...h];return M.length&&this.updateWorkspaceConfiguration(n),{keys:M,overrides:w}}compareAndUpdateFolderConfiguration(n,i){const o=this.folderConfigurations.get(n),{added:h,updated:w,removed:M,overrides:A}=u(o,i);let R=[...h,...w,...M];return(R.length||!o)&&this.updateFolderConfiguration(n,i),{keys:R,overrides:A}}compareAndDeleteFolderConfiguration(n){const i=this.folderConfigurations.get(n);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:o,updated:h,removed:w,overrides:M}=u(i,void 0);return{keys:[...o,...h,...w],overrides:M}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(n,i){let o=this.getConsolidatedConfigurationModelForResource(n,i);return n.overrideIdentifier?o.override(n.overrideIdentifier):o}getConsolidatedConfigurationModelForResource({resource:n},i){let o=this.getWorkspaceConsolidatedConfiguration();if(i&&n){const h=i.getFolder(n);h&&(o=this.getFolderConsolidatedConfiguration(h.uri)||o);const w=this._memoryConfigurationByResource.get(n);w&&(o=o.merge(w))}return o}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(n){let i=this._foldersConsolidatedConfigurations.get(n);if(!i){const o=this.getWorkspaceConsolidatedConfiguration(),h=this._folderConfigurations.get(n);h?(i=o.merge(h),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(n,i)):i=o}return i}getFolderConfigurationModelForResource(n,i){if(i&&n){const o=i.getFolder(n);if(o)return this._folderConfigurations.get(o.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((n,i)=>{const{contents:o,overrides:h,keys:w}=this._folderConfigurations.get(i);return n.push([i,{contents:o,overrides:h,keys:w}]),n},[])}}allKeys(){const n=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>n.add(i)),this.userConfiguration.freeze().keys.forEach(i=>n.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>n.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(o=>n.add(o))),[...n.values()]}allOverrideIdentifiers(){const n=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>n.add(i)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>n.add(i)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>n.add(i)),this._folderConfigurations.forEach(i=>i.freeze().getAllOverrideIdentifiers().forEach(o=>n.add(o))),[...n.values()]}getAllKeysForOverrideIdentifier(n){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(n).forEach(o=>i.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(o=>i.add(o)),this._workspaceConfiguration.getKeysForOverrideIdentifier(n).forEach(o=>i.add(o)),this._folderConfigurations.forEach(o=>o.getKeysForOverrideIdentifier(n).forEach(h=>i.add(h))),[...i.values()]}static parse(n){const i=this.parseConfigurationModel(n.defaults),o=this.parseConfigurationModel(n.user),h=this.parseConfigurationModel(n.workspace),w=n.folders.reduce((M,A)=>(M.set(f.URI.revive(A[0]),this.parseConfigurationModel(A[1])),M),new P.ResourceMap);return new v(i,o,new S,h,w,new S,new P.ResourceMap,!1)}static parseConfigurationModel(n){return new S(n.contents,n.keys,n.overrides).freeze()}}e.Configuration=v;function k(...l){if(l.length===0)return{keys:[],overrides:[]};if(l.length===1)return l[0];const n=new Set,i=new Map;for(const h of l)h.keys.forEach(w=>n.add(w)),h.overrides.forEach(([w,M])=>{const A=(0,P.getOrSet)(i,w,new Set);M.forEach(R=>A.add(R))});const o=[];return i.forEach((h,w)=>o.push([w,[...h.values()]])),{keys:[...n.values()],overrides:o}}e.mergeChanges=k;class c{constructor(n,i,o,h){this.change=n,this.previous=i,this.currentConfiguraiton=o,this.currentWorkspace=h,this._previousConfiguration=void 0;const w=new Set;n.keys.forEach(A=>w.add(A)),n.overrides.forEach(([,A])=>A.forEach(R=>w.add(R))),this.affectedKeys=[...w.values()];const M=new S;this.affectedKeys.forEach(A=>M.setValue(A,{})),this.affectedKeysTree=M.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=v.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(n,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,n)){if(i){const o=this.previousConfiguration?this.previousConfiguration.getValue(n,i,this.previous?.workspace):void 0,h=this.currentConfiguraiton.getValue(n,i,this.currentWorkspace);return!I.equals(o,h)}return!0}return!1}doesAffectedKeysTreeContains(n,i){let o=(0,y.toValuesTree)({[i]:!0},()=>{}),h;for(;typeof o=="object"&&(h=Object.keys(o)[0]);){if(n=n[h],!n)return!1;o=o[h]}return!0}}e.ConfigurationChangeEvent=c;class a extends c{constructor(n,i,o,h){super({keys:n.allKeys(),overrides:[]},void 0,n,i);this.source=o,this.sourceConfig=h}}e.AllKeysConfigurationChangeEvent=a;function u(l,n){const{added:i,removed:o,updated:h}=s(n,l),w=[],M=l?.getAllOverrideIdentifiers()||[],A=n?.getAllOverrideIdentifiers()||[];if(n){const R=A.filter(T=>!M.includes(T));for(const T of R)w.push([T,n.getKeysForOverrideIdentifier(T)])}if(l){const R=M.filter(T=>!A.includes(T));for(const T of R)w.push([T,l.getKeysForOverrideIdentifier(T)])}if(n&&l){for(const R of M)if(A.includes(R)){const T=s({contents:l.getOverrideValue(void 0,R)||{},keys:l.getKeysForOverrideIdentifier(R)},{contents:n.getOverrideValue(void 0,R)||{},keys:n.getKeysForOverrideIdentifier(R)});w.push([R,[...T.added,...T.removed,...T.updated]])}}return{added:i,removed:o,updated:h,overrides:w}}function s(l,n){const i=l?n?l.keys.filter(w=>n.keys.indexOf(w)===-1):[...l.keys]:[],o=n?l?n.keys.filter(w=>l.keys.indexOf(w)===-1):[...n.keys]:[],h=[];if(l&&n){for(const w of n.keys)if(l.keys.indexOf(w)!==-1){const M=(0,y.getConfigurationValue)(n.contents,w),A=(0,y.getConfigurationValue)(l.contents,w);I.equals(M,A)||h.push(w)}}return{added:i,removed:o,updated:h}}}),define(Z[192],x([0,1,9,4,2,15,19,191,56,40]),function(j,e,p,r,D,C,P,I,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class y extends D.Disposable{constructor(m,S){super();this.settingsResource=m,this._onDidChangeConfiguration=this._register(new r.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new I.UserSettings(this.settingsResource,void 0,C.extUriBiasedIgnorePathCase,S)),this.configuration=new I.Configuration(new I.DefaultConfigurationModel,new I.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new p.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(f.Registry.as(d.Extensions.Configuration).onDidUpdateConfiguration(({properties:t})=>this.onDidDefaultConfigurationChange(t))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const m=await this.userConfiguration.loadConfiguration();this.configuration=new I.Configuration(new I.DefaultConfigurationModel,m)}getConfigurationData(){return this.configuration.toData()}getValue(m,S){const t=typeof m=="string"?m:void 0,g=(0,P.isConfigurationOverrides)(m)?m:(0,P.isConfigurationOverrides)(S)?S:{};return this.configuration.getValue(t,g,void 0)}updateValue(m,S,t,g){return Promise.reject(new Error("not supported"))}inspect(m){return this.configuration.inspect(m,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const m=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(m)}onDidChangeUserConfiguration(m){const S=this.configuration.toData(),t=this.configuration.compareAndUpdateLocalUserConfiguration(m);this.trigger(t,S,1)}onDidDefaultConfigurationChange(m){const S=this.configuration.toData(),t=this.configuration.compareAndUpdateDefaultConfiguration(new I.DefaultConfigurationModel,m);this.trigger(t,S,6)}trigger(m,S,t){const g=new I.ConfigurationChangeEvent(m,{data:S},this.configuration);g.source=t,g.sourceConfig=this.getTargetConfiguration(t),this._onDidChangeConfiguration.fire(g)}getTargetConfiguration(m){switch(m){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=y}),define(Z[193],x([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,p.createDecorator)("remoteAuthorityResolverService");var r;(function(C){C.Unknown="Unknown",C.NotAvailable="NotAvailable",C.TemporarilyNotAvailable="TemporarilyNotAvailable",C.NoResolverFound="NoResolverFound"})(r=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class D extends Error{constructor(P,I=r.Unknown,d){super(P);this._message=P,this._code=I,this._detail=d,this.isHandled=I===r.NotAvailable&&d===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,D.prototype)}static isTemporarilyNotAvailable(P){return P instanceof D&&P._code===r.TemporarilyNotAvailable}static isNoResolverFound(P){return P instanceof D&&P._code===r.NoResolverFound}static isHandled(P){return P instanceof D&&P.isHandled}}e.RemoteAuthorityResolverError=D}),define(Z[194],x([0,1,9,17,23,16,4,2,31,84,193]),function(j,e,p,r,D,C,P,I,d,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const b=30*1e3;var m;(function(B){B[B.Management=1]="Management",B[B.ExtensionHost=2]="ExtensionHost",B[B.Tunnel=3]="Tunnel"})(m=e.ConnectionType||(e.ConnectionType={}));function S(B){switch(B){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function t(B){const L=new D.CancellationTokenSource;return setTimeout(()=>L.cancel(),B),L.token}function g(B,L){if(B.isCancellationRequested||L.isCancellationRequested)return D.CancellationToken.Cancelled;const W=new D.CancellationTokenSource;return B.onCancellationRequested(()=>W.cancel()),L.onCancellationRequested(()=>W.cancel()),W.token}class E{constructor(L){this._state="pending",this._disposables=new I.DisposableStore,this.promise=new Promise((W,F)=>{this._resolvePromise=W,this._rejectPromise=F}),L.isCancellationRequested?this._timeout():this._disposables.add(L.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(L){this._state==="pending"?this._disposables.add(L):L.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const L=new Error("Time limit reached");return L.code="ETIMEDOUT",L.syscall="connect",L}resolve(L){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(L))}reject(L){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(L))}}function v(B,L){const W=new E(L);return W.registerDisposable(B.onControlMessage(F=>{const N=JSON.parse(F.toString()),V=q(N);V?W.reject(V):W.resolve(N)})),W.promise}function k(B,L,W,F,N,V,U){const z=new E(U);return L.connect(W,F,N,V,(ee,re)=>{z.didTimeout?(ee&&B.error(ee),re?.dispose()):ee||!re?z.reject(ee):z.resolve(re)}),z.promise}function c(B,L){const W=new E(L);return B.then(F=>{W.didTimeout||W.resolve(F)},F=>{W.didTimeout||W.reject(F)}),W.promise}async function a(B,L,W,F){const N=K(B,L);B.logService.trace(`${N} 1/6. invoking socketFactory.connect().`);let V;try{V=await k(B.logService,B.socketFactory,B.host,B.port,`reconnectionToken=${B.reconnectionToken}&reconnection=${B.reconnectionProtocol?"true":"false"}`,`renderer-${S(L)}-${B.reconnectionToken}`,F)}catch(se){throw B.logService.error(`${N} socketFactory.connect() failed or timed out. Error:`),B.logService.error(se),se}B.logService.trace(`${N} 2/6. socketFactory.connect() was successful.`);let U,z;B.reconnectionProtocol?(B.reconnectionProtocol.beginAcceptReconnection(V,null),U=B.reconnectionProtocol,z=!1):(U=new f.PersistentProtocol(V,null),z=!0),B.logService.trace(`${N} 3/6. sending AuthRequest control message.`);const ee=await c(B.signService.createNewMessage((0,d.generateUuid)()),F),re={type:"auth",auth:B.connectionToken||"00000000000000000000",data:ee.data};U.sendControl(r.VSBuffer.fromString(JSON.stringify(re)));try{const se=await v(U,g(F,t(1e4)));if(se.type!=="sign"||typeof se.data!="string"){const ue=new Error("Unexpected handshake message");throw ue.code="VSCODE_CONNECTION_ERROR",ue}if(B.logService.trace(`${N} 4/6. received SignRequest control message.`),!await c(B.signService.validate(ee,se.signedData),F)){const ue=new Error("Refused to connect to unsupported server");throw ue.code="VSCODE_CONNECTION_ERROR",ue}const ce=await c(B.signService.sign(se.data),F),le={type:"connectionType",commit:B.commit,signedData:ce,desiredConnectionType:L};return W&&(le.args=W),B.logService.trace(`${N} 5/6. sending ConnectionTypeRequest control message.`),U.sendControl(r.VSBuffer.fromString(JSON.stringify(le))),{protocol:U,ownsProtocol:z}}catch(se){throw se&&se.code==="ETIMEDOUT"&&(B.logService.error(`${N} the handshake timed out. Error:`),B.logService.error(se)),se&&se.code==="VSCODE_CONNECTION_ERROR"&&(B.logService.error(`${N} received error control message when negotiating connection. Error:`),B.logService.error(se)),z&&H(U),se}}async function u(B,L,W,F){const N=Date.now(),V=K(B,L),{protocol:U,ownsProtocol:z}=await a(B,L,W,F),ee=new E(F);return ee.registerDisposable(U.onControlMessage(re=>{const se=JSON.parse(re.toString()),J=q(se);J?(B.logService.error(`${V} received error control message when negotiating connection. Error:`),B.logService.error(J),z&&H(U),ee.reject(J)):(B.reconnectionProtocol&&B.reconnectionProtocol.endAcceptReconnection(),B.logService.trace(`${V} 6/6. handshake finished, connection is up and running after ${te(N)}!`),ee.resolve({protocol:U,firstMessage:se}))})),ee.promise}async function s(B,L){const{protocol:W}=await u(B,1,void 0,L);return{protocol:W}}async function l(B,L,W){const{protocol:F,firstMessage:N}=await u(B,2,L,W),V=N&&N.debugPort;return{protocol:F,debugPort:V}}async function n(B,L,W){const F=Date.now(),N=K(B,3),{protocol:V}=await a(B,3,L,W);return B.logService.trace(`${N} 6/6. handshake finished, connection is up and running after ${te(F)}!`),V}async function i(B,L,W){const{host:F,port:N,connectionToken:V}=await B.addressProvider.getAddress();return{commit:B.commit,host:F,port:N,connectionToken:V,reconnectionToken:L,reconnectionProtocol:W,socketFactory:B.socketFactory,signService:B.signService,logService:B.logService}}async function o(B,L,W){try{const F=(0,d.generateUuid)(),N=await i(B,F,null),{protocol:V}=await s(N,D.CancellationToken.None);return new X(B,L,W,F,V)}catch(F){throw B.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),B.logService.error(F),oe.triggerPermanentFailure(0,0,y.RemoteAuthorityResolverError.isHandled(F)),F}}e.connectRemoteAgentManagement=o;async function h(B,L){try{const W=(0,d.generateUuid)(),F=await i(B,W,null),{protocol:N,debugPort:V}=await l(F,L,D.CancellationToken.None);return new O(B,L,W,N,V)}catch(W){throw B.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),B.logService.error(W),oe.triggerPermanentFailure(0,0,y.RemoteAuthorityResolverError.isHandled(W)),W}}e.connectRemoteAgentExtensionHost=h;async function w(B,L,W){const F=await i(B,(0,d.generateUuid)(),null);return await n(F,{host:L,port:W},D.CancellationToken.None)}e.connectRemoteAgentTunnel=w;function M(B){return(0,p.createCancelablePromise)(L=>new Promise((W,F)=>{const N=setTimeout(W,B*1e3);L.onCancellationRequested(()=>{clearTimeout(N),W()})}))}var A;(function(B){B[B.ConnectionLost=0]="ConnectionLost",B[B.ReconnectionWait=1]="ReconnectionWait",B[B.ReconnectionRunning=2]="ReconnectionRunning",B[B.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",B[B.ConnectionGain=4]="ConnectionGain"})(A=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class R{constructor(L,W){this.reconnectionToken=L,this.millisSinceLastIncomingData=W,this.type=0}}e.ConnectionLostEvent=R;class T{constructor(L,W,F,N){this.reconnectionToken=L,this.millisSinceLastIncomingData=W,this.durationSeconds=F,this.cancellableTimer=N,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=T;class _{constructor(L,W,F){this.reconnectionToken=L,this.millisSinceLastIncomingData=W,this.attempt=F,this.type=2}}e.ReconnectionRunningEvent=_;class Q{constructor(L,W,F){this.reconnectionToken=L,this.millisSinceLastIncomingData=W,this.attempt=F,this.type=4}}e.ConnectionGainEvent=Q;class ne{constructor(L,W,F,N){this.reconnectionToken=L,this.millisSinceLastIncomingData=W,this.attempt=F,this.handled=N,this.type=3}}e.ReconnectionPermanentFailureEvent=ne;class oe extends I.Disposable{constructor(L,W,F,N){super();this._connectionType=L,this._onDidStateChange=this._register(new P.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=W,this.reconnectionToken=F,this.protocol=N,this._isReconnecting=!1,this._onDidStateChange.fire(new Q(this.reconnectionToken,0,0)),this._register(N.onSocketClose(V=>{const U=$(this._connectionType,this.reconnectionToken,!0);V?V.type===0?(this._options.logService.info(`${U} received socket close event (hadError: ${V.hadError}).`),V.error&&this._options.logService.error(V.error)):(this._options.logService.info(`${U} received socket close event (wasClean: ${V.wasClean}, code: ${V.code}, reason: ${V.reason}).`),V.event&&this._options.logService.error(V.event)):this._options.logService.info(`${U} received socket close event.`),this._beginReconnecting()})),this._register(N.onSocketTimeout(()=>{const V=$(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${V} received socket timeout event.`),this._beginReconnecting()})),oe._instances.push(this),oe._permanentFailure&&this._gotoPermanentFailure(oe._permanentFailureMillisSinceLastIncomingData,oe._permanentFailureAttempt,oe._permanentFailureHandled)}static triggerPermanentFailure(L,W,F){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=L,this._permanentFailureAttempt=W,this._permanentFailureHandled=F,this._instances.forEach(N=>N._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(L=>L._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(L=>L._pauseSocketWriting())}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(oe._permanentFailure)return;const L=$(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${L} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new R(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const W=[0,5,5,10,10,10,10,10,30];let F=-1;do{F++;const N=F<W.length?W[F]:W[W.length-1];try{if(N>0){const U=M(N);this._onDidStateChange.fire(new T(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),N,U)),this._options.logService.info(`${L} waiting for ${N} seconds before reconnecting...`);try{await U}catch{}}if(oe._permanentFailure){this._options.logService.error(`${L} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new _(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),F+1)),this._options.logService.info(`${L} resolving connection...`);const V=await i(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${L} connecting to ${V.host}:${V.port}...`),await this._reconnect(V,t(b)),this._options.logService.info(`${L} reconnected!`),this._onDidStateChange.fire(new Q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),F+1));break}catch(V){if(V.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${L} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(V),oe.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),F+1,!1);break}if(F>360){this._options.logService.error(`${L} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(V),oe.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),F+1,!1);break}if(y.RemoteAuthorityResolverError.isTemporarilyNotAvailable(V)){this._options.logService.info(`${L} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(V);continue}if((V.code==="ETIMEDOUT"||V.code==="ENETUNREACH"||V.code==="ECONNREFUSED"||V.code==="ECONNRESET")&&V.syscall==="connect"){this._options.logService.info(`${L} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(V);continue}if((0,C.isPromiseCanceledError)(V)){this._options.logService.info(`${L} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(V);continue}if(V instanceof y.RemoteAuthorityResolverError){this._options.logService.error(`${L} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(V),oe.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),F+1,y.RemoteAuthorityResolverError.isHandled(V));break}this._options.logService.error(`${L} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(V),oe.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),F+1,!1);break}}while(!oe._permanentFailure)}_gotoPermanentFailure(L,W,F){this._onDidStateChange.fire(new ne(this.reconnectionToken,L,W,F)),H(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=oe,oe._permanentFailure=!1,oe._permanentFailureMillisSinceLastIncomingData=0,oe._permanentFailureAttempt=0,oe._permanentFailureHandled=!1,oe._instances=[];class X extends oe{constructor(L,W,F,N,V){super(1,L,N,V);this.client=this._register(new f.Client(V,{remoteAuthority:W,clientId:F},L.ipcLogger))}async _reconnect(L,W){await s(L,W)}}e.ManagementPersistentConnection=X;class O extends oe{constructor(L,W,F,N,V){super(2,L,F,N);this._startArguments=W,this.debugPort=V}async _reconnect(L,W){await l(L,this._startArguments,W)}}e.ExtensionHostPersistentConnection=O;function H(B){try{B.acceptDisconnect();const L=B.getSocket();B.dispose(),L.dispose()}catch(L){(0,C.onUnexpectedError)(L)}}function q(B){if(B&&B.type==="error"){const L=new Error(`Connection error: ${B.reason}`);return L.code="VSCODE_CONNECTION_ERROR",L}return null}function Y(B,L){for(;B.length<L;)B+=" ";return B}function $(B,L,W){return`[remote-connection][${Y(S(B),13)}][${L.substr(0,5)}\u2026][${W?"reconnect":"initial"}]`}function K(B,L){return`${$(L,B.reconnectionToken,!!B.reconnectionProtocol)}[${B.host}:${B.port}]`}function te(B){return`${Date.now()-B} ms`}}),define(Z[64],x([0,1,10]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function r(f){return f.scheme===p.Schemas.vscodeRemote?f.authority:void 0}e.getRemoteAuthority=r;function D(f){if(!f)return;const y=f.indexOf("+");return y<0?f:f.substr(0,y)}e.getRemoteName=D;function C(f){return f.scheme!==p.Schemas.file&&f.scheme!==p.Schemas.vscodeRemote}e.isVirtualResource=C;function P(f){if(f.folders.length)return f.folders.every(y=>C(y.uri))?f.folders[0].uri:void 0;if(f.configuration&&C(f.configuration))return f.configuration}e.getVirtualWorkspaceLocation=P;function I(f){return P(f)?.scheme}e.getVirtualWorkspaceScheme=I;function d(f){return P(f)!==void 0}e.isVirtualWorkspace=d}),define(Z[195],x([0,1,25,5,64]),function(j,e,p,r,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function C(m){if(typeof m=="object"&&m!==null&&m.supported!==!0)return m.description}e.getWorkspaceSupportTypeMessage=C;function P(m){return m&&typeof m=="object"&&typeof m.id=="string"&&(!m.uuid||typeof m.uuid=="string")}e.isIExtensionIdentifier=P,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var I;(function(m){m[m.System=0]="System",m[m.User=1]="User"})(I=e.ExtensionType||(e.ExtensionType={}));class d{constructor(S){this.value=S,this._lower=S.toLowerCase()}static equals(S,t){if(typeof S=="undefined"||S===null)return typeof t=="undefined"||t===null;if(typeof t=="undefined"||t===null)return!1;if(typeof S=="string"||typeof t=="string"){let g=typeof S=="string"?S:S.value,E=typeof t=="string"?t:t.value;return p.equalsIgnoreCase(g,E)}return S._lower===t._lower}static toKey(S){return typeof S=="string"?S.toLowerCase():S._lower}}e.ExtensionIdentifier=d;function f(m){return m.contributes&&m.contributes.localizations?m.contributes.localizations.length>0:!1}e.isLanguagePackExtension=f;function y(m){return m.contributes&&m.contributes.authentication?m.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=y;function b(m,S){if(S){const t=`onResolveRemoteAuthority:${(0,D.getRemoteName)(S)}`;return m.activationEvents?.indexOf(t)!==-1}return!1}e.isResolverExtension=b,e.IBuiltinExtensionsScannerService=(0,r.createDecorator)("IBuiltinExtensionsScannerService")}),define(Z[196],x([0,1,25,195]),function(j,e,p,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function D(t,g){return t.uuid&&g.uuid?t.uuid===g.uuid:t.id===g.id?!0:(0,p.compareIgnoreCase)(t.id,g.id)===0}e.areSameExtensions=D;class C{constructor(g,E){this.version=E,this.id=g.id,this.uuid=g.uuid}key(){return`${this.id}-${this.version}`}equals(g){return g instanceof C?D(this,g)&&this.version===g.version:!1}}e.ExtensionIdentifierWithVersion=C;function P(t,g){return`${t}.${g}`}e.getExtensionId=P;function I(t){return t.toLocaleLowerCase()}e.adoptToGalleryExtensionId=I;function d(t,g){return I(P(t,g))}e.getGalleryExtensionId=d;function f(t,g){const E=[],v=k=>{for(const c of E)if(c.some(a=>D(g(a),g(k))))return c;return null};for(const k of t){const c=v(k);c?c.push(k):E.push([k])}return E}e.groupByExtension=f;function y(t){return{id:t.identifier.id,name:t.manifest.name,galleryId:null,publisherId:t.publisherId,publisherName:t.manifest.publisher,publisherDisplayName:t.publisherDisplayName,dependencies:t.manifest.extensionDependencies&&t.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=y;function b(t){return{id:t.identifier.id,name:t.name,galleryId:t.identifier.uuid,publisherId:t.publisherId,publisherName:t.publisher,publisherDisplayName:t.publisherDisplayName,isPreReleaseVersion:t.properties.isPreReleaseVersion,dependencies:!!(t.properties.dependencies&&t.properties.dependencies.length>0),...t.telemetryData}}e.getGalleryExtensionTelemetryData=b,e.BetterMergeId=new r.ExtensionIdentifier("pprice.better-merge");function m(t){const g=new Set;if(t.malicious)for(const E of t.malicious)g.add(E.id);return g}e.getMaliciousExtensionsSet=m;function S(t,g){const E=[],v=g.manifest.extensionDependencies?.slice(0)??[];for(;v.length;){const k=v.shift();if(k&&E.every(c=>!D(c.identifier,{id:k}))){const c=t.filter(a=>D(a.identifier,{id:k}));c.length===1&&(E.push(c[0]),v.push(...c[0].manifest.extensionDependencies?.slice(0)??[]))}}return E}e.getExtensionDependencies=S}),define(Z[96],x([0,1,4,3,5,6]),function(j,e,p,r,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,D.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,D.createDecorator)("sharedTunnelsService");var P;(function(t){t.Http="http",t.Https="https"})(P=e.TunnelProtocol||(e.TunnelProtocol={}));var I;(function(t){t.ConstantPrivate="constantPrivate",t.Private="private",t.Public="public"})(I=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var d;(function(t){t[t.Notify=1]="Notify",t[t.OpenBrowser=2]="OpenBrowser",t[t.OpenPreview=3]="OpenPreview",t[t.Silent=4]="Silent",t[t.Ignore=5]="Ignore",t[t.OpenBrowserOnce=6]="OpenBrowserOnce"})(d=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function f(t){if(t.scheme!=="http"&&t.scheme!=="https")return;const g=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(t.authority);if(!!g)return{address:g[1],port:+g[2]}}e.extractLocalHostUriMetaDataForPortMapping=f,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function y(t){return e.LOCALHOST_ADDRESSES.indexOf(t)>=0}e.isLocalhost=y,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function b(t){return e.ALL_INTERFACES_ADDRESSES.indexOf(t)>=0}e.isAllInterfaces=b;function m(t,g){return g?g!==1&&t<1024:!r.isWindows&&t<1024}e.isPortPrivileged=m;let S=class{constructor(g){this.logService=g,this._onTunnelOpened=new p.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new p.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new p.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(g,E){return this._tunnelProvider=g,g?(this._canElevate=E.elevation,this._privacyOptions=E.privacyOptions,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const g=[],E=Array.from(this._tunnels.values());for(let v of E){const k=Array.from(v.values());for(let c of k){const a=await c.value;a&&g.push(a)}}return g}async dispose(){for(const g of this._tunnels.values()){for(const{value:E}of g.values())await E.then(v=>v?.dispose());g.clear()}this._tunnels.clear()}openTunnel(g,E,v,k,c=!1,a=I.Private,u){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${E}:${v} on local port ${k}.`),!g)return;E||(E="localhost");const s=this.retainOrCreateTunnel(g,E,v,k,c,a,u);return s?s.then(l=>{if(!l){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(E,v);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const n=this.makeTunnel(l);return(l.tunnelRemoteHost!==E||l.tunnelRemotePort!==v)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(n),n}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),s)}makeTunnel(g){return{tunnelRemotePort:g.tunnelRemotePort,tunnelRemoteHost:g.tunnelRemoteHost,tunnelLocalPort:g.tunnelLocalPort,localAddress:g.localAddress,privacy:g.privacy,protocol:g.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${g.tunnelRemoteHost}:${g.tunnelRemotePort} `);const E=this._tunnels.get(g.tunnelRemoteHost);if(E){const v=E.get(g.tunnelRemotePort);v&&(v.refcount--,await this.tryDisposeTunnel(g.tunnelRemoteHost,g.tunnelRemotePort,v))}}}}async tryDisposeTunnel(g,E,v){if(v.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${g}:${E}.`);const k=v.value.then(async c=>{c&&(await c.dispose(!0),this._onTunnelClosed.fire({host:c.tunnelRemoteHost,port:c.tunnelRemotePort}))});return this._tunnels.has(g)&&this._tunnels.get(g).delete(E),k}}async closeTunnel(g,E){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${g}:${E} `);const v=this._tunnels.get(g);if(v&&v.has(E)){const k=v.get(E);k.refcount=0,await this.tryDisposeTunnel(g,E,k)}}addTunnelToMap(g,E,v){this._tunnels.has(g)||this._tunnels.set(g,new Map),this._tunnels.get(g).set(E,{refcount:1,value:v})}async removeEmptyTunnelFromMap(g,E){const v=this._tunnels.get(g);v&&(await v.get(E)||v.delete(E),v.size===0&&this._tunnels.delete(g))}getTunnelFromMap(g,E){let v=[g];y(g)?(v.push(...e.LOCALHOST_ADDRESSES),v.push(...e.ALL_INTERFACES_ADDRESSES)):b(g)&&v.push(...e.ALL_INTERFACES_ADDRESSES);const k=v.map(c=>this._tunnels.get(c));for(const c of k){const a=c?.get(E);if(a)return a}}canTunnel(g){return!!f(g)}createWithProvider(g,E,v,k,c,a,u){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${E}:${v} on local port ${k}.`);const l={elevationRequired:c?m(k===void 0?v:k):!1},n={remoteAddress:{host:E,port:v},localAddressPort:k,privacy:a,public:a!==I.Private,protocol:u},i=g.forwardPort(n,l);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),i&&this.addTunnelToMap(E,v,i),i}};S=fe([ie(0,C.ILogService)],S),e.AbstractTunnelService=S}),define(Z[49],x([0,1,17,151,56,5,40]),function(j,e,p,r,D,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,C.createDecorator)("requestService");function I(t){return t.res.statusCode&&t.res.statusCode>=200&&t.res.statusCode<300||t.res.statusCode===1223}e.isSuccess=I;function d(t){return t.res.statusCode===204}async function f(t){if(!I(t))throw new Error("Server returned "+t.res.statusCode);return d(t)?null:(await(0,p.streamToBuffer)(t.stream)).toString()}e.asText=f;async function y(t){if(!I(t))throw new Error("Server returned "+t.res.statusCode);if(d(t))return null;const E=(await(0,p.streamToBuffer)(t.stream)).toString();try{return JSON.parse(E)}catch(v){throw v.message+=`:
`+E,v}}e.asJson=y;function b(t){S(t)}e.updateProxyConfigurationsScope=b;let m;function S(t){const g=P.Registry.as(D.Extensions.Configuration),E=m;m={id:"http",order:15,title:(0,r.localize)(0,null),type:"object",scope:t,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,r.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,r.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,r.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,r.localize)(4,null),(0,r.localize)(5,null),(0,r.localize)(6,null),(0,r.localize)(7,null)],default:"override",description:(0,r.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,r.localize)(9,null),restricted:!0}}},g.updateConfigurations({add:[m],remove:E?[E]:[]})}S(2)}),define(Z[197],x([0,1,198,13]),function(j,e,p,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function D(P,I){return P.protocol==="http:"?I.HTTP_PROXY||I.http_proxy||null:P.protocol==="https:"&&(I.HTTPS_PROXY||I.https_proxy||I.HTTP_PROXY||I.http_proxy)||null}async function C(P,I,d={}){const f=(0,p.parse)(P),y=d.proxyUrl||D(f,I);if(!y)return null;const b=(0,p.parse)(y);if(!/^https?:$/.test(b.protocol||""))return null;const m={host:b.hostname||"",port:b.port||(b.protocol==="https"?"443":"80"),auth:b.auth,rejectUnauthorized:(0,r.isBoolean)(d.strictSSL)?d.strictSSL:!0};return f.protocol==="http:"?new(await new Promise((S,t)=>{j(["http-proxy-agent"],S,t)}))(m):new(await new Promise((S,t)=>{j(["https-proxy-agent"],S,t)}))(m)}e.getProxyAgent=C}),define(Z[199],x([0,1,17,31]),function(j,e,p,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function D(C,P,I){let d=I&&I.get("storage.serviceMachineId",0)||null;if(d)return d;try{const y=(await P.readFile(C.serviceMachineIdResource)).value.toString();d=(0,r.isUUID)(y)?y:null}catch{d=null}if(!d){d=(0,r.generateUuid)();try{await P.writeFile(C.serviceMachineIdResource,p.VSBuffer.fromString(d))}catch{}}return I&&I.store("storage.serviceMachineId",d,0,1),d}e.getServiceMachineId=D}),define(Z[76],x([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,p.createDecorator)(e.SIGN_SERVICE_ID)}),define(Z[200],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class p{constructor(){this.validators=new Map}vsda(){return new Promise((D,C)=>j(["vsda"],D,C))}async createNewMessage(D){try{const C=await this.vsda(),P=new C.validator;if(P){const I=String(p._nextId++);return this.validators.set(I,P),{id:I,data:P.createNewMessage(D)}}}catch{}return{id:"",data:D}}async validate(D,C){if(!D.id)return!0;const P=this.validators.get(D.id);if(!P)return!1;this.validators.delete(D.id);try{return P.validate(C)==="ok"}catch{return!1}}async sign(D){try{const C=await this.vsda(),P=new C.signer;if(P)return P.sign(D)}catch{}return D}}e.SignService=p,p._nextId=1}),define(Z[37],x([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateMainService=void 0,e.IStateMainService=(0,p.createDecorator)("stateMainService")}),define(Z[20],x([0,1,14,9,4,2,3,34,13,5,179,6,37]),function(j,e,p,r,D,C,P,I,d,f,y,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,f.createDecorator)("lifecycleMainService");var S;(function(g){g[g.Starting=1]="Starting",g[g.Ready=2]="Ready",g[g.AfterWindowOpen=3]="AfterWindowOpen"})(S=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let t=class dt extends C.Disposable{constructor(E,v){super();this.logService=E,this.stateMainService=v,this._onBeforeShutdown=this._register(new D.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new D.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new D.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new D.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._onBeforeUnloadWindow=this._register(new D.Emitter),this.onBeforeUnloadWindow=this._onBeforeUnloadWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.phaseWhen=new Map,this.resolveRestarted(),this.when(2).then(()=>this.registerListeners())}get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}resolveRestarted(){this._wasRestarted=!!this.stateMainService.getItem(dt.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateMainService.removeItem(dt.QUIT_AND_RESTART_KEY)}registerListeners(){const E=()=>{this._quitRequested||(this.logService.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.logService.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),P.isMacintosh&&this.windowCounter===0&&this.fireOnWillShutdown())};p.app.addListener("before-quit",E);const v=()=>{this.logService.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!P.isMacintosh)&&p.app.quit()};p.app.addListener("window-all-closed",v),p.app.once("will-quit",k=>{this.logService.trace("Lifecycle#app.on(will-quit)"),k.preventDefault(),this.fireOnWillShutdown().finally(()=>{this.resolvePendingQuitPromise(!1),p.app.removeListener("before-quit",E),p.app.removeListener("window-all-closed",v),p.app.quit()})})}fireOnWillShutdown(){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;this.logService.trace("Lifecycle#onWillShutdown.fire()");const E=[];return this._onWillShutdown.fire({join(v){E.push(v)}}),this.pendingWillShutdownPromise=(async()=>{try{await r.Promises.settled(E)}catch(v){this.logService.error(v)}try{await this.stateMainService.close()}catch(v){this.logService.error(v)}})(),this.pendingWillShutdownPromise}set phase(E){if(E<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase===E)return;this.logService.trace(`lifecycle (main): phase changed (value: ${E})`),this._phase=E;const v=this.phaseWhen.get(this._phase);v&&(v.open(),this.phaseWhen.delete(this._phase))}async when(E){if(E<=this._phase)return;let v=this.phaseWhen.get(E);v||(v=new r.Barrier,this.phaseWhen.set(E,v)),await v.wait()}registerWindow(E){const v=new C.DisposableStore;this.windowCounter++,v.add(E.onWillLoad(c=>this._onWillLoadWindow.fire({window:E,workspace:c.workspace,reason:c.reason})));const k=(0,d.assertIsDefined)(E.win);k.on("close",c=>{const a=E.id;if(this.windowToCloseRequest.has(a)){this.windowToCloseRequest.delete(a);return}this.logService.trace(`Lifecycle#window.on('close') - window ID ${E.id}`),c.preventDefault(),this.unload(E,1).then(u=>{if(u){this.windowToCloseRequest.delete(a);return}this.windowToCloseRequest.add(a),this.logService.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${a}`),this._onBeforeCloseWindow.fire(E),E.close()})}),k.on("closed",()=>{this.logService.trace(`Lifecycle#window.on('closed') - window ID ${E.id}`),this.windowCounter--,v.dispose(),this.windowCounter===0&&(!P.isMacintosh||this._quitRequested)&&this.fireOnWillShutdown()})}async reload(E,v){await this.unload(E,3)||E.reload(v)}async unload(E,v){if(!E.isReady)return!1;this.logService.trace(`Lifecycle#unload() - window ID ${E.id}`);const k=this._quitRequested?2:v;let c=await this.onBeforeUnloadWindowInRenderer(E,k);return c?(this.logService.trace(`Lifecycle#unload() - veto in renderer (window ID ${E.id})`),this.handleWindowUnloadVeto(c)):(c=await this.onBeforeUnloadWindowInMain(E,k),c?(this.logService.trace(`Lifecycle#unload() - veto in main (window ID ${E.id})`),this.handleWindowUnloadVeto(c)):(this.logService.trace(`Lifecycle#unload() - no veto (window ID ${E.id})`),await this.onWillUnloadWindowInRenderer(E,k),!1))}handleWindowUnloadVeto(E){return E?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(E){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(E),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(E,v){return new Promise(k=>{const c=this.oneTimeListenerTokenGenerator++,a=`vscode:ok${c}`,u=`vscode:cancel${c}`;p.ipcMain.once(a,()=>{k(!1)}),p.ipcMain.once(u,()=>{k(!0)}),E.send("vscode:onBeforeUnload",{okChannel:a,cancelChannel:u,reason:v})})}onBeforeUnloadWindowInMain(E,v){const k=[];return this._onBeforeUnloadWindow.fire({reason:v,window:E,veto(c){k.push(c)}}),(0,y.handleVetos)(k,c=>this.logService.error(c))}onWillUnloadWindowInRenderer(E,v){return new Promise(k=>{const a=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;p.ipcMain.once(a,()=>k()),E.send("vscode:onWillUnload",{replyChannel:a,reason:v})})}quit(E){return this.pendingQuitPromise?this.pendingQuitPromise:(this.logService.trace(`Lifecycle#quit() - will restart: ${E}`),E&&this.stateMainService.setItem(dt.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(v=>{this.pendingQuitPromiseResolve=v,this.logService.trace("Lifecycle#quit() - calling app.quit()"),p.app.quit()}),this.pendingQuitPromise)}async relaunch(E){this.logService.trace("Lifecycle#relaunch()");const v=process.argv.slice(1);if(E?.addArgs&&v.push(...E.addArgs),E?.removeArgs)for(const a of E.removeArgs){const u=v.indexOf(a);u>=0&&v.splice(u,1)}const k=()=>{try{if(P.isWindows){const a=(0,I.cwd)();a!==process.cwd()&&process.chdir(a)}}catch(a){this.logService.error(a)}this.logService.trace("Lifecycle#relaunch() - calling app.relaunch()"),p.app.relaunch({args:v})};p.app.once("quit",k),await this.quit(!0)&&p.app.removeListener("quit",k)}async kill(E){this.logService.trace("Lifecycle#kill()"),await this.fireOnWillShutdown(),await Promise.race([(0,r.timeout)(1e3),(async()=>{for(const v of p.BrowserWindow.getAllWindows())if(v&&!v.isDestroyed()){let k;v.webContents&&!v.webContents.isDestroyed()?k=new Promise(c=>v.once("closed",c)):k=Promise.resolve(),v.destroy(),await k}})()]),p.app.exit(E)}};t.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart",t=fe([ie(0,b.ILogService),ie(1,m.IStateMainService)],t),e.LifecycleMainService=t}),define(Z[201],x([0,1,4,2,5,20]),function(j,e,p,r,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,D.createDecorator)("keyboardLayoutMainService");let P=class extends r.Disposable{constructor(f){super();this._onDidChangeKeyboardLayout=this._register(new p.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,f.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const f=await new Promise((y,b)=>{j(["native-keymap"],y,b)});this._keyboardLayoutData=I(f),f.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=I(f),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};P=fe([ie(0,C.ILifecycleMainService)],P),e.KeyboardLayoutMainService=P;function I(d){const f=d.getKeyMap(),y=d.getCurrentKeyboardLayout();return{keyboardMapping:f,keyboardLayoutInfo:y}}}),define(Z[97],x([0,1,9,4,2,63,13,86,5]),function(j,e,p,r,D,C,P,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const f="__$__targetStorageMarker";e.IStorageService=(0,d.createDecorator)("storageService");var y;(function(E){E[E.NONE=0]="NONE",E[E.SHUTDOWN=1]="SHUTDOWN"})(y=e.WillSaveStateReason||(e.WillSaveStateReason={}));var b;(function(E){E[E.GLOBAL=0]="GLOBAL",E[E.WORKSPACE=1]="WORKSPACE"})(b=e.StorageScope||(e.StorageScope={}));var m;(function(E){E[E.USER=0]="USER",E[E.MACHINE=1]="MACHINE"})(m=e.StorageTarget||(e.StorageTarget={}));class S extends D.Disposable{constructor(v={flushInterval:S.DEFAULT_FLUSH_INTERVAL}){super();this.options=v,this._onDidChangeValue=this._register(new r.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new r.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new r.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new p.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new D.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,p.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,D.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,C.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,C.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(v,k){k===f?(v===0?this._globalKeyTargets=void 0:v===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:v})):this._onDidChangeValue.fire({scope:v,key:k,target:this.getKeyTargets(v)[k]})}emitWillSaveState(v){this._onWillSaveState.fire({reason:v})}get(v,k,c){return this.getStorage(k)?.get(v,c)}getBoolean(v,k,c){return this.getStorage(k)?.getBoolean(v,c)}getNumber(v,k,c){return this.getStorage(k)?.getNumber(v,c)}store(v,k,c,a){if((0,P.isUndefinedOrNull)(k)){this.remove(v,c);return}this.withPausedEmitters(()=>{this.updateKeyTarget(v,c,a),this.getStorage(c)?.set(v,k)})}remove(v,k){this.withPausedEmitters(()=>{this.updateKeyTarget(v,k,void 0),this.getStorage(k)?.delete(v)})}withPausedEmitters(v){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{v()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(v,k){const c=[],a=this.getKeyTargets(v);for(const u of Object.keys(a))a[u]===k&&c.push(u);return c}updateKeyTarget(v,k,c){const a=this.getKeyTargets(k);typeof c=="number"?a[v]!==c&&(a[v]=c,this.getStorage(k)?.set(f,JSON.stringify(a))):typeof a[v]=="number"&&(delete a[v],this.getStorage(k)?.set(f,JSON.stringify(a)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(v){return v===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(v){const k=this.get(f,v);if(k)try{return JSON.parse(k)}catch{}return Object.create(null)}isNew(v){return this.getBoolean(e.IS_NEW_KEY,v)===!0}async flush(v=y.NONE){this._onWillSaveState.fire({reason:v});const k=this.getStorage(0),c=this.getStorage(1);switch(v){case y.NONE:await p.Promises.settled([k?.whenFlushed()??Promise.resolve(),c?.whenFlushed()??Promise.resolve()]);break;case y.SHUTDOWN:await p.Promises.settled([k?.flush(0)??Promise.resolve(),c?.flush(0)??Promise.resolve()]);break}}async logStorage(){const v=this.getStorage(0)?.items??new Map,k=this.getStorage(1)?.items??new Map;return g(v,k,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=S,S.DEFAULT_FLUSH_INTERVAL=60*1e3;class t extends S{constructor(){super();this.globalStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(v=>this.emitDidChangeValue(1,v))),this._register(this.globalStorage.onDidChangeStorage(v=>this.emitDidChangeValue(0,v)))}getStorage(v){return v===0?this.globalStorage:this.workspaceStorage}getLogDetails(v){return v===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(v){}}e.InMemoryStorageService=t;async function g(E,v,k,c){const a=h=>{try{return JSON.parse(h)}catch{return h}},u=new Map,s=new Map;E.forEach((h,w)=>{u.set(w,h),s.set(w,a(h))});const l=new Map,n=new Map;v.forEach((h,w)=>{l.set(w,h),n.set(w,a(h))}),console.group(`Storage: Global (path: ${k})`);let i=[];u.forEach((h,w)=>{i.push({key:w,value:h})}),console.table(i),console.groupEnd(),console.log(s),console.group(`Storage: Workspace (path: ${c})`);let o=[];l.forEach((h,w)=>{o.push({key:w,value:h})}),console.table(o),console.groupEnd(),console.log(n)}e.logStorage=g}),define(Z[202],x([0,1,3,34,7,31]),function(j,e,p,r,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function P(f){if(p.platform===2&&/^penguin(\.|$)/i.test(f))return"chromebook"}async function I(f,y,b,m,S,t,g,E,v,k){const c=Object.create(null);c["common.machineId"]=g,c.sessionID=(0,C.generateUuid)()+Date.now(),c.commitHash=S,c.version=t,c["common.platformVersion"]=(y||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),c["common.platform"]=(0,p.PlatformToString)(p.platform),c["common.nodePlatform"]=r.platform,c["common.nodeArch"]=m,c["common.product"]=k||"desktop";const a=d(E||[]);a&&(c["common.msftInternal"]=a);let u=0;const s=Date.now();Object.defineProperties(c,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-s,enumerable:!0},"common.sequence":{get:()=>u++,enumerable:!0}}),p.isLinuxSnap&&(c["common.snap"]="true");const l=P(b);l&&(c["common.platformDetail"]=l);try{const n=await f.readFile(D.URI.file(v));c["common.source"]=n.value.toString().slice(0,30)}catch{}return c}e.resolveCommonProperties=I;function d(f){const y=r.env.USERDNSDOMAIN;if(!y)return!1;const b=y.toLowerCase();return f.some(m=>b===m)}e.verifyMicrosoftInternalDomain=d}),define(Z[28],x([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,p.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,p.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var r;(function(C){C[C.NONE=0]="NONE",C[C.CRASH=1]="CRASH",C[C.ERROR=2]="ERROR",C[C.USAGE=3]="USAGE"})(r=e.TelemetryLevel||(e.TelemetryLevel={}));var D;(function(C){C.OFF="off",C.CRASH="crash",C.ERROR="error",C.ON="all"})(D=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Z[203],x([0,1,26,69,9,38,10,8,3,7,71,21,83,74,18,22,28]),function(j,e,p,r,D,C,P,I,d,f,y,b,m,S,t,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function v(s,l){const n=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}];let i;const o=p.homedir().toLowerCase();switch(process.platform){case"win32":i=[{tag:"gdrive",matcher:_=>/^[a-z]:\\(my drive|shared drives)\\/.test(_)||_.startsWith(o+"\\my drive\\")},{tag:"dropbox",matcher:_=>_.startsWith(o+"\\dropbox")},{tag:"onedrive",matcher:_=>_.startsWith(o+"\\onedrive")},{tag:"box",matcher:_=>_.startsWith(o+"\\box\\")},{tag:"nextcloud",matcher:_=>_.startsWith(o+"\\nextcloud\\")},{tag:"owncloud",matcher:_=>_.startsWith(o+"\\owncloud\\")}];break;case"darwin":i=[{tag:"gdrive",matcher:_=>_.startsWith("/volumes/googledrive/")||_.startsWith(o+"/my drive/")},{tag:"dropbox",matcher:_=>_.startsWith(o+"/dropbox")},{tag:"onedrive",matcher:_=>_.startsWith(o+"/onedrive")||_.startsWith(o+"/library/cloudstorage/onedrive")},{tag:"icloud",matcher:_=>_.startsWith(o+"/library/mobile documents/")},{tag:"box",matcher:_=>_.startsWith(o+"/box/")},{tag:"nextcloud",matcher:_=>_.startsWith(o+"/nextcloud/")},{tag:"owncloud",matcher:_=>_.startsWith(o+"/owncloud/")}];break}const h=new Map,w=new Map,M=2e4;function A(_,Q,ne,oe){for(const O of i){const H=_.toLowerCase();O.matcher(H)&&w.set(O.tag,1)}const X=Q.substring(_.length+1);return D.Promises.withAsyncBody(async O=>{let H;try{H=await b.Promises.readdir(Q,{withFileTypes:!0})}catch{O();return}if(oe.count>=M){oe.count+=H.length,oe.maxReached=!0,O();return}let q=H.length;if(q===0){O();return}let Y=H;oe.count+H.length>M&&(oe.maxReached=!0,q=M-oe.count,Y=H.slice(0,q)),oe.count+=H.length;for(const $ of Y)if($.isDirectory()){if(ne.includes($.name)||await A(_,(0,I.join)(Q,$.name),ne,oe),--q==0){O();return}}else{const K=$.name.lastIndexOf(".");if(K>=0){const te=$.name.substring(K+1);te&&h.set(te,(h.get(te)??0)+1)}for(const te of n)te.relativePathPattern?.test(X)!==!1&&te.filePattern.test($.name)&&w.set(te.tag,(w.get(te.tag)??0)+1);if(--q==0){O();return}}})}const R={count:0,maxReached:!1};await A(s,s,l,R);const T=await a(s);return{configFiles:k(w),fileTypes:k(h),fileCount:R.count,maxFilesReached:R.maxReached,launchConfigFiles:T}}e.collectWorkspaceStats=v;function k(s){return[...r.Iterable.map(s.entries(),([l,n])=>({name:l,count:n}))].sort((l,n)=>n.count-l.count)}function c(){const s={os:`${p.type()} ${p.arch()} ${p.release()}`,memory:`${(p.totalmem()/t.ByteSize.GB).toFixed(2)}GB (${(p.freemem()/t.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(y.virtualMachineHint.value()*100)}%`},l=p.cpus();return l&&l.length>0&&(s.cpus=`${l[0].model} (${l.length} x ${l[0].speed})`),s}e.getMachineInfo=c;async function a(s){try{const l=new Map,n=(0,I.join)(s,".vscode","launch.json"),i=await b.Promises.readFile(n),o=[],h=(0,C.parse)(i.toString(),o);if(o.length)return console.log(`Unable to parse ${n}`),[];if((0,C.getNodeType)(h)==="object"&&h.configurations)for(const w of h.configurations){const M=w.type;M&&(l.has(M)?l.set(M,l.get(M)+1):l.set(M,1))}return k(l)}catch{return[]}}e.collectLaunchConfigs=a;let u=class{constructor(l,n){this.telemetryService=l,this.productService=n}formatMachineInfo(l){const n=[];return n.push(`OS Version:       ${l.os}`),n.push(`CPUs:             ${l.cpus}`),n.push(`Memory (System):  ${l.memory}`),n.push(`VM:               ${l.vmHint}`),n.join(`
`)}formatEnvironment(l){const n=[];n.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),n.push(`OS Version:       ${p.type()} ${p.arch()} ${p.release()}`);const i=p.cpus();return i&&i.length>0&&n.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),n.push(`Memory (System):  ${(p.totalmem()/t.ByteSize.GB).toFixed(2)}GB (${(p.freemem()/t.ByteSize.GB).toFixed(2)}GB free)`),d.isWindows||n.push(`Load (avg):       ${p.loadavg().map(o=>Math.round(o)).join(", ")}`),n.push(`VM:               ${Math.round(y.virtualMachineHint.value()*100)}%`),n.push(`Screen Reader:    ${l.screenReader?"yes":"no"}`),n.push(`Process Argv:     ${l.mainArguments.join(" ")}`),n.push(`GPU Status:       ${this.expandGPUFeatures(l.gpuFeatureStatus)}`),n.join(`
`)}async getPerformanceInfo(l,n){return Promise.all([(0,m.listProcesses)(l.mainPID),this.formatWorkspaceMetadata(l)]).then(async i=>{let[o,h]=i,w=this.formatProcessList(l,o);return n.forEach(M=>{if((0,S.isRemoteDiagnosticError)(M))w+=`
${M.errorMessage}`,h+=`
${M.errorMessage}`;else if(w+=`

Remote: ${M.hostName}`,M.processes&&(w+=`
${this.formatProcessList(l,M.processes)}`),M.workspaceMetadata){h+=`
|  Remote: ${M.hostName}`;for(const A of Object.keys(M.workspaceMetadata)){const R=M.workspaceMetadata[A];let T=`${R.fileCount} files`;R.maxFilesReached&&(T=`more than ${T}`),h+=`|    Folder (${A}): ${T}`,h+=this.formatWorkspaceStats(R)}}}),{processInfo:w,workspaceInfo:h}})}async getSystemInfo(l,n){const{memory:i,vmHint:o,os:h,cpus:w}=c(),M={os:h,memory:i,cpus:w,vmHint:o,processArgs:`${l.mainArguments.join(" ")}`,gpuStatus:l.gpuFeatureStatus,screenReader:`${l.screenReader?"yes":"no"}`,remoteData:n};return d.isWindows||(M.load=`${p.loadavg().map(A=>Math.round(A)).join(", ")}`),d.isLinux&&(M.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(M)}async getDiagnostics(l,n){const i=[];return(0,m.listProcesses)(l.mainPID).then(async o=>(i.push(""),i.push(this.formatEnvironment(l)),i.push(""),i.push(this.formatProcessList(l,o)),l.windows.some(h=>h.folderURIs&&h.folderURIs.length>0&&!h.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.formatWorkspaceMetadata(l))),n.forEach(h=>{if((0,S.isRemoteDiagnosticError)(h))i.push(`
${h.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${h.hostName}`),i.push(this.formatMachineInfo(h.machineInfo)),h.processes&&i.push(this.formatProcessList(l,h.processes)),h.workspaceMetadata)for(const w of Object.keys(h.workspaceMetadata)){const M=h.workspaceMetadata[w];let A=`${M.fileCount} files`;M.maxFilesReached&&(A=`more than ${A}`),i.push(`Folder (${w}): ${A}`),i.push(this.formatWorkspaceStats(M))}}),i.push(""),i.push(""),i.join(`
`)))}formatWorkspaceStats(l){const n=[],i=60;let o=0;const h=(R,T)=>{const _=` ${R}(${T})`;o+_.length>i?(n.push(w),w="|                 ",o=w.length):o+=_.length,w+=_};let w="|      File types:";const M=10;let A=l.fileTypes.length>M?M:l.fileTypes.length;for(let R=0;R<A;R++){const T=l.fileTypes[R];h(T.name,T.count)}if(n.push(w),l.configFiles.length>=0&&(w="|      Conf files:",o=0,l.configFiles.forEach(R=>{h(R.name,R.count)}),n.push(w)),l.launchConfigFiles.length>0){let R="|      Launch Configs:";l.launchConfigFiles.forEach(T=>{R+=T.count>1?` ${T.name}(${T.count})`:` ${T.name}`}),n.push(R)}return n.join(`
`)}expandGPUFeatures(l){const n=Math.max(...Object.keys(l).map(i=>i.length));return Object.keys(l).map(i=>`${i}:  ${" ".repeat(n-i.length)}  ${l[i]}`).join(`
                  `)}formatWorkspaceMetadata(l){const n=[],i=[];return l.windows.forEach(o=>{o.folderURIs.length===0||!!o.remoteAuthority||(n.push(`|  Window (${o.title})`),o.folderURIs.forEach(h=>{const w=f.URI.revive(h);if(w.scheme===P.Schemas.file){const M=w.fsPath;i.push(v(M,["node_modules",".git"]).then(A=>{let R=`${A.fileCount} files`;A.maxFilesReached&&(R=`more than ${R}`),n.push(`|    Folder (${(0,I.basename)(M)}): ${R}`),n.push(this.formatWorkspaceStats(A))}).catch(A=>{n.push(`|      Error: Unable to collect workspace stats for folder ${M} (${A.toString()})`)}))}else n.push(`|    Folder (${w.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(o=>n.join(`
`)).catch(o=>`Unable to collect workspace stats: ${o}`)}formatProcessList(l,n){const i=new Map;l.windows.forEach(h=>i.set(h.pid,h.title));const o=[];return o.push("CPU %	Mem MB	   PID	Process"),n&&this.formatProcessItem(l.mainPID,i,o,n,0),o.join(`
`)}formatProcessItem(l,n,i,o,h){const w=h===0;let M;w?M=o.pid===l?`${this.productService.applicationName} main`:"remote agent":(M=`${"  ".repeat(h)} ${o.name}`,o.name==="window"&&(M=`${M} (${n.get(o.pid)})`));const A=process.platform==="win32"?o.mem:p.totalmem()*(o.mem/100);i.push(`${o.load.toFixed(0).padStart(5," ")}	${(A/t.ByteSize.MB).toFixed(0).padStart(6," ")}	${o.pid.toFixed(0).padStart(6," ")}	${M}`),Array.isArray(o.children)&&o.children.forEach(R=>this.formatProcessItem(l,n,i,R,h+1))}async reportWorkspaceStats(l){for(const{uri:n}of l.folders){const i=f.URI.revive(n);if(i.scheme!==P.Schemas.file)continue;const o=i.fsPath;try{const h=await v(o,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":l.telemetryId,rendererSessionId:l.rendererSessionId}),h.fileTypes.forEach(w=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:l.rendererSessionId,type:w.name,count:w.count})}),h.launchConfigFiles.forEach(w=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:l.rendererSessionId,type:w.name,count:w.count})}),h.configFiles.forEach(w=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:l.rendererSessionId,type:w.name,count:w.count})})}catch{}}}};u=fe([ie(0,E.ITelemetryService),ie(1,g.IProductService)],u),e.DiagnosticsService=u}),define(Z[204],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class p{constructor(C){this.appenders=C}listen(C,P){throw new Error(`Event not found: ${P}`)}call(C,P,{eventName:I,data:d}){return this.appenders.forEach(f=>f.log(I,d)),Promise.resolve(null)}}e.TelemetryAppenderChannel=p;class r{constructor(C){this.channel=C}log(C,P){return this.channel.call("log",{eventName:C,data:P}).then(void 0,I=>`Failed to log telemetry: ${console.warn(I)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=r}),define(Z[65],x([0,1,47,13,19,28]),function(j,e,p,r,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class P{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(v,k){return Promise.resolve(void 0)}publicLog2(v,k){return this.publicLog(v,k)}publicLogError(v,k){return Promise.resolve(void 0)}publicLogError2(v,k){return this.publicLogError(v,k)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=P,e.NullTelemetryService=new P;class I{async publicLog(v,k,c){}async publicLogError(v,k,c){}}e.NullEndpointTelemetryService=I,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function d(E,v){return v.onDidChangeConfiguration(k=>{k.source!==6&&E.publicLog2("updateConfiguration",{configurationSource:(0,D.ConfigurationTargetToString)(k.source),configurationKeys:t(k.sourceConfig)})})}e.configurationTelemetry=d;function f(E,v){return!(v.disableTelemetry||!E.enableTelemetry)}e.supportsTelemetry=f;function y(E){const v=E.getValue(C.TELEMETRY_SETTING_ID),k=E.getValue("telemetry.enableCrashReporter");if(E.getValue(C.TELEMETRY_OLD_SETTING_ID)===!1||k===!1)return 0;switch(v??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=y;function b(E){const v=Object.create(null),k=Object.create(null),c=Object.create(null);S(E,c);for(let a in c){a=a.length>150?a.substr(a.length-149):a;const u=c[a];typeof u=="number"?k[a]=u:typeof u=="boolean"?k[a]=u?1:0:typeof u=="string"?(u.length>8192&&console.warn(`Telemetry property: ${a} has been trimmed to 8192, the original length is ${u.length}`),v[a]=u.substring(0,8191)):typeof u!="undefined"&&u!==null&&(v[a]=u)}return{properties:v,measurements:k}}e.validateTelemetryData=b;function m(E){if(!E)return"none";let v="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(c=>{E.indexOf(`${c}+`)===0&&(v=c)}),v}e.cleanRemoteAuthority=m;function S(E,v,k=0,c){if(!!E)for(let a of Object.getOwnPropertyNames(E)){const u=E[a],s=c?c+a:a;Array.isArray(u)?v[s]=(0,p.safeStringify)(u):u instanceof Date?v[s]=u.toISOString():(0,r.isObject)(u)?k<2?S(u,v,k+1,s+"."):v[s]=(0,p.safeStringify)(u):v[s]=u}}function t(E){if(!E)return[];const v=[];return g(v,"",E),v}function g(E,v,k){k&&typeof k=="object"&&!Array.isArray(k)?Object.keys(k).forEach(c=>g(E,v?`${v}.${c}`:c,k[c])):E.push(v)}}),define(Z[205],x([0,1,30,23,16,47,3,34,13,7,19,48,170,196,167,18,6,22,49,199,97,28,65]),function(j,e,p,r,D,C,P,I,d,f,y,b,m,S,t,g,E,v,k,c,a,u,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const l=P.isWeb?"web":(0,m.getTargetPlatform)(P.platform,I.arch);var n;(function(U){U[U.None=0]="None",U[U.IncludeVersions=1]="IncludeVersions",U[U.IncludeFiles=2]="IncludeFiles",U[U.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",U[U.IncludeSharedAccounts=8]="IncludeSharedAccounts",U[U.IncludeVersionProperties=16]="IncludeVersionProperties",U[U.ExcludeNonValidated=32]="ExcludeNonValidated",U[U.IncludeInstallationTargets=64]="IncludeInstallationTargets",U[U.IncludeAssetUri=128]="IncludeAssetUri",U[U.IncludeStatistics=256]="IncludeStatistics",U[U.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",U[U.Unpublished=4096]="Unpublished"})(n||(n={}));function i(...U){return String(U.reduce((z,ee)=>z|ee,0))}var o;(function(U){U[U.Tag=1]="Tag",U[U.ExtensionId=4]="ExtensionId",U[U.Category=5]="Category",U[U.ExtensionName=7]="ExtensionName",U[U.Target=8]="Target",U[U.Featured=9]="Featured",U[U.SearchText=10]="SearchText",U[U.ExcludeWithFlags=12]="ExcludeWithFlags"})(o||(o={}));const h={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},w={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},A={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:n.None,criteria:[],assetTypes:[]};class R{constructor(z=A){this.state=z}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(z,ee=this.state.pageSize){return new R({...this.state,pageNumber:z,pageSize:ee})}withFilter(z,...ee){const re=[...this.state.criteria,...ee.length?ee.map(se=>({filterType:z,value:se})):[{filterType:z}]];return new R({...this.state,criteria:re})}withSortBy(z){return new R({...this.state,sortBy:z})}withSortOrder(z){return new R({...this.state,sortOrder:z})}withFlags(...z){return new R({...this.state,flags:z.reduce((ee,re)=>ee|re,0)})}withAssetTypes(...z){return new R({...this.state,assetTypes:z})}get raw(){const{criteria:z,pageNumber:ee,pageSize:re,sortBy:se,sortOrder:J,flags:ce,assetTypes:le}=this.state;return{filters:[{criteria:z,pageNumber:ee,pageSize:re,sortBy:se,sortOrder:J}],assetTypes:le,flags:ce}}get searchText(){const z=this.state.criteria.filter(ee=>ee.filterType===o.SearchText)[0];return z&&z.value?z.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(z=>String(z.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function T(U,z){const ee=(U||[]).filter(re=>re.statisticName===z)[0];return ee?ee.value:0}function _(U){const z="Microsoft.VisualStudio.Code.Translation.";return U.files.filter(re=>re.assetType.indexOf(z)===0).reduce((re,se)=>{const J=X(U,se.assetType);return J&&re.push([se.assetType.substring(z.length),J]),re},[])}function Q(U){if(U.properties){const z=U.properties.filter(se=>se.key===h.Repository),ee=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),re=z.filter(se=>ee.test(se.value))[0];return re?{uri:re.value,fallbackUri:re.value}:null}return X(U,h.Repository)}function ne(U){return{uri:`${U.fallbackAssetUri}/${h.VSIX}?redirect=true${U.targetPlatform?`&targetPlatform=${U.targetPlatform}`:""}`,fallbackUri:`${U.fallbackAssetUri}/${h.VSIX}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`}}function oe(U){const z=X(U,h.Icon);if(z)return z;const ee=m.DefaultIconPath;return{uri:ee,fallbackUri:ee}}function X(U,z){return U.files.filter(re=>re.assetType===z)[0]?{uri:`${U.assetUri}/${z}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`,fallbackUri:`${U.fallbackAssetUri}/${z}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`}:null}function O(U,z){const ee=U.properties?U.properties.filter(se=>se.key===z):[],re=ee.length>0&&ee[0].value;return re?re.split(",").map(se=>(0,S.adoptToGalleryExtensionId)(se)):[]}function H(U){const z=U.properties?U.properties.filter(ee=>ee.key===w.Engine):[];return z.length>0&&z[0].value||""}function q(U){const z=U.properties?U.properties.filter(ee=>ee.key===w.PreRelease):[];return z.length>0&&z[0].value==="true"}function Y(U){const z=U.properties?U.properties.filter(re=>re.key===w.LocalizedLanguages):[],ee=z.length>0&&z[0].value||"";return ee?ee.split(","):[]}function $(U){return U.indexOf("preview")!==-1}function K(U){return U.targetPlatform?(0,m.toTargetPlatform)(U.targetPlatform):"undefined"}function te(U){const z=(0,p.distinct)(U.versions.map(K)),ee=!!U.tags?.includes(m.WEB_EXTENSION_TAG),re=z.indexOf("web");return ee?re===-1&&z.push("web"):re!==-1&&z.splice(re,1),z}function B(U,z){const ee=(0,m.getFallbackTargetPlarforms)(z);for(let re=0;re<U.length;re++){const se=U[re];if(se.version===U[re-1]?.version){let J=re;const ce=K(se);if(ce===z)for(;J>0&&U[J-1].version===se.version;)J--;else if(ee.includes(ce))for(;J>0&&U[J-1].version===se.version&&K(U[J-1])!==z;)J--;J!==re&&(U.splice(re,1),U.splice(J,0,se))}}return U}e.sortExtensionVersions=B;function L(U,z,ee,re,se){const J=U.versions[0],ce={manifest:X(z,h.Manifest),readme:X(z,h.Details),changelog:X(z,h.Changelog),license:X(z,h.License),repository:Q(z),download:ne(z),icon:oe(z),coreTranslations:_(z)};return{identifier:{id:(0,S.getGalleryExtensionId)(U.publisher.publisherName,U.extensionName),uuid:U.extensionId},name:U.extensionName,version:z.version,displayName:U.displayName,publisherId:U.publisher.publisherId,publisher:U.publisher.publisherName,publisherDisplayName:U.publisher.displayName,publisherDomain:U.publisher.domain?{link:U.publisher.domain,verified:!!U.publisher.isDomainVerified}:void 0,description:U.shortDescription||"",installCount:T(U.statistics,"install"),rating:T(U.statistics,"averagerating"),ratingCount:T(U.statistics,"ratingcount"),categories:U.categories||[],tags:U.tags||[],releaseDate:Date.parse(U.releaseDate),lastUpdated:Date.parse(U.lastUpdated),allTargetPlatforms:ee,assets:ce,properties:{dependencies:O(z,w.Dependency),extensionPack:O(z,w.ExtensionPack),engine:H(z),localizedLanguages:Y(z),targetPlatform:K(z),isPreReleaseVersion:q(z)},hasPreReleaseVersion:q(J),hasReleaseVersion:re,preview:$(U.flags),telemetryData:se}}let W=class{constructor(z,ee,re,se,J,ce,le,ue){this.requestService=ee,this.logService=re,this.environmentService=se,this.telemetryService=J,this.fileService=ce,this.productService=le,this.configurationService=ue;const me=le.extensionsGallery;this.extensionsGalleryUrl=me&&me.serviceUrl,this.extensionsControlUrl=me&&me.controlUrl,this.commonHeadersPromise=V(le.version,le,this.environmentService,this.configurationService,this.fileService,z)}api(z=""){return`${this.extensionsGalleryUrl}${z}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(z,ee,re){const se=(0,d.isBoolean)(ee)?ee:!1,J=(0,d.isBoolean)(ee)?re:ee;let ce=new R().withFlags(n.IncludeAssetUri,n.IncludeStatistics,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,z.length).withFilter(o.Target,"Microsoft.VisualStudio.Code").withFilter(o.ExtensionName,...z.map(({id:me})=>me.toLowerCase()));z.every(me=>!me.version)&&(ce=ce.withFlags(n.IncludeAssetUri,n.IncludeStatistics,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties,n.IncludeLatestVersionOnly));const{galleryExtensions:le}=await this.queryGallery(ce,l,r.CancellationToken.None),ue=le.map(me=>{const Ee=(0,S.getGalleryExtensionId)(me.publisher.publisherName,me.extensionName);return{rawGalleryExtension:me,version:z.find(de=>(0,S.areSameExtensions)(de,{id:Ee}))?.version,preRelease:se}});return this.converToGalleryExtensions(ue,l,()=>{},J)}async getExtensions2(z){const ee=[],re=[];for(const le of z)le.uuid?re.push(le.uuid):ee.push(le.id.toLowerCase());let se=new R().withFlags(n.IncludeAssetUri,n.IncludeStatistics,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties,n.IncludeLatestVersionOnly).withPage(1,z.length).withFilter(o.Target,"Microsoft.VisualStudio.Code");re.length&&(se=se.withFilter(o.ExtensionId,...re)),ee.length&&(se=se.withFilter(o.ExtensionId,...ee));const{galleryExtensions:J}=await this.queryGallery(se,l,r.CancellationToken.None),ce=J.map(le=>{const ue=(0,S.getGalleryExtensionId)(le.publisher.publisherName,le.extensionName),me=z.find(Ee=>(0,S.areSameExtensions)(Ee,{id:ue,uuid:le.extensionId}));return{rawGalleryExtension:le,preRelease:!!me?.preRelease}});return this.converToGalleryExtensions(ce,l,()=>{},r.CancellationToken.None)}async getCompatibleExtension(z,ee,re){const se=(0,m.isIExtensionIdentifier)(z)?null:z;if(se){if((0,m.isNotWebExtensionInWebTargetPlatform)(se.allTargetPlatforms,re))return null;if(await this.isExtensionCompatible(se,ee,re))return se}const{id:J,uuid:ce}=se?se.identifier:z;let le=new R().withFlags(n.IncludeAssetUri,n.IncludeStatistics,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,1).withFilter(o.Target,"Microsoft.VisualStudio.Code");ce?le=le.withFilter(o.ExtensionId,ce):le=le.withFilter(o.ExtensionName,J);const{galleryExtensions:ue}=await this.queryGallery(le,re,r.CancellationToken.None),[me]=ue;if(!me||!me.versions.length)return null;const Ee=te(me);if((0,m.isNotWebExtensionInWebTargetPlatform)(Ee,re))return null;for(let de of me.versions){if(!H(de)){const ge=await this.getEngine(de);de={...de,properties:[...de.properties||[],{key:w.Engine,value:ge}]}}if(await this.isRawExtensionVersionCompatible(de,ee,Ee,re)){const ge=me.versions.some(pe=>!q(pe));return L(me,de,Ee,ge)}}return null}async isExtensionCompatible(z,ee,re){if(!(0,m.isTargetPlatformCompatible)(z.properties.targetPlatform,z.allTargetPlatforms,re)||!ee&&z.properties.isPreReleaseVersion)return!1;let se=z.properties.engine;if(!se){const J=await this.getManifest(z,r.CancellationToken.None);if(!J)throw new Error("Manifest was not found");se=J.engines.vscode}return(0,t.isEngineValid)(se,this.productService.version,this.productService.date)}async isRawExtensionVersionCompatible(z,ee,re,se){if(!(0,m.isTargetPlatformCompatible)(K(z),re,se)||!ee&&q(z))return!1;const J=await this.getEngine(z);return(0,t.isEngineValid)(J,this.productService.version,this.productService.date)}async query(z,ee){if(!this.isEnabled())throw new Error("No extension gallery service configured.");let re=z.text||"";const se=(0,C.getOrDefault)(z,de=>de.pageSize,50);let J=new R().withFlags(n.IncludeLatestVersionOnly,n.IncludeAssetUri,n.IncludeStatistics,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,se).withFilter(o.Target,"Microsoft.VisualStudio.Code");re?(re=re.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(de,ge,pe)=>(J=J.withFilter(o.Category,pe||ge),"")),re=re.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(de,ge,pe)=>(J=J.withFilter(o.Tag,pe||ge),"")),re=re.replace(/\bfeatured(\s+|\b|$)/g,()=>(J=J.withFilter(o.Featured),"")),re=re.trim(),re&&(re=re.length<200?re:re.substring(0,200),J=J.withFilter(o.SearchText,re)),J=J.withSortBy(0)):z.ids?J=J.withFilter(o.ExtensionId,...z.ids):z.names?J=J.withFilter(o.ExtensionName,...z.names):J=J.withSortBy(4),typeof z.sortBy=="number"&&(J=J.withSortBy(z.sortBy)),typeof z.sortOrder=="number"&&(J=J.withSortOrder(z.sortOrder));const{galleryExtensions:ce,total:le}=await this.queryGallery(J,l,ee),ue=de=>({index:(J.pageNumber-1)*J.pageSize+de,querySource:z.source}),me=await this.converToGalleryExtensions(ce.map(de=>({rawGalleryExtension:de,preRelease:!!z.includePreRelease})),l,ue,ee),Ee=async(de,ge)=>{if(ge.isCancellationRequested)throw(0,D.canceled)();const pe=J.withPage(de+1),{galleryExtensions:ke}=await this.queryGallery(pe,l,ge);return await this.converToGalleryExtensions(ke.map(Re=>({rawGalleryExtension:Re,preRelease:!!z.includePreRelease})),l,ue,ee)};return{firstPage:me,total:le,pageSize:J.pageSize,getPage:Ee}}async converToGalleryExtensions(z,ee,re,se){const J=(ue,me,Ee,de)=>{const ge=te(ue);let pe=ue.versions[0];return pe=ue.versions.find(ke=>ke.version===pe.version&&(0,m.isTargetPlatformCompatible)(K(ke),ge,ee))||pe,q(pe)&&!de&&(pe=ue.versions.find(ke=>ke.version!==pe.version&&!q(ke))||pe),L(ue,pe,ge,Ee,re(me))},ce=[],le=new Map;for(let ue=0;ue<z.length;ue++){const{rawGalleryExtension:me,version:Ee,preRelease:de}=z[ue],ge=me.versions.some(pe=>!q(pe));if(Ee){const pe=me.versions.find(ke=>ke.version===Ee);pe&&ce.push([ue,L(me,pe,te(me),ge)])}else{const pe=J(me,ue,ge,de);pe.properties.isPreReleaseVersion?le.set(pe.identifier.uuid,{index:ue,preRelease:de}):ce.push([ue,pe])}}if(le.size){const ue=new Date().getTime(),me=new R().withFlags(n.IncludeVersions,n.IncludeAssetUri,n.IncludeStatistics,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,le.size).withFilter(o.Target,"Microsoft.VisualStudio.Code").withFilter(o.ExtensionId,...le.keys()),{galleryExtensions:Ee}=await this.queryGallery(me,ee,se);if(this.telemetryService.publicLog2("galleryService:preReleasesQuery",{duration:new Date().getTime()-ue,count:le.size}),Ee.length!==le.size)throw new Error("Not all extensions with latest versions are returned");for(const de of Ee){const ge=de.versions.some(Fe=>!q(Fe)),{index:pe,preRelease:ke}=le.get(de.extensionId),Re=J(de,pe,ge,ke);ce.push([pe,Re])}}return ce.sort((ue,me)=>ue[0]-me[0]).map(([,ue])=>ue)}async queryGallery(z,ee,re){if(!this.isEnabled())throw new Error("No extension gallery service configured.");z=z.withFlags(z.flags,n.ExcludeNonValidated).withFilter(o.ExcludeWithFlags,i(n.Unpublished));const se=await this.commonHeadersPromise,J=JSON.stringify(z.raw),ce={...se,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(J.length)},le=new Date().getTime();let ue,me,Ee=0;try{if(ue=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:J,headers:ce},re),ue.res.statusCode&&ue.res.statusCode>=400&&ue.res.statusCode<500)return{galleryExtensions:[],total:Ee};const de=await(0,k.asJson)(ue);if(de){const ge=de.results[0],pe=ge.extensions;pe.forEach(Re=>B(Re.versions,ee));const ke=ge.resultMetadata&&ge.resultMetadata.filter(Re=>Re.metadataType==="ResultCount")[0];return Ee=ke&&ke.metadataItems.filter(Re=>Re.name==="TotalCount")[0].count||0,{galleryExtensions:pe,total:Ee}}return{galleryExtensions:[],total:Ee}}catch(de){throw me=de,de}finally{this.telemetryService.publicLog2("galleryService:query",{...z.telemetryData,requestBodySize:String(J.length),duration:new Date().getTime()-le,success:!!ue&&(0,k.isSuccess)(ue),responseBodySize:ue?.res.headers["Content-Length"],statusCode:ue?String(ue.res.statusCode):void 0,errorCode:me?(0,D.isPromiseCanceledError)(me)?"canceled":(0,D.getErrorMessage)(me).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(Ee)})}}async reportStatistic(z,ee,re,se){if(!this.isEnabled())return;const J=P.isWeb?this.api(`/itemName/${z}.${ee}/version/${re}/statType/${se==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${z}/extensions/${ee}/${re}/stats?statType=${se}`),ce=P.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ue={...await this.commonHeadersPromise,Accept:ce};try{await this.requestService.request({type:"POST",url:J,headers:ue},r.CancellationToken.None)}catch{}}async download(z,ee,re){this.logService.trace("ExtensionGalleryService#download",z.identifier.id);const se=(0,S.getGalleryExtensionTelemetryData)(z),J=new Date().getTime(),ce=Ee=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...se,duration:Ee}),le=re===2?"install":re===3?"update":"",ue=le?{uri:`${z.assets.download.uri}${f.URI.parse(z.assets.download.uri).query?"&":"?"}${le}=true`,fallbackUri:`${z.assets.download.fallbackUri}${f.URI.parse(z.assets.download.fallbackUri).query?"&":"?"}${le}=true`}:z.assets.download,me=await this.getAsset(ue);await this.fileService.writeFile(ee,me.stream),ce(new Date().getTime()-J)}async getReadme(z,ee){if(z.assets.readme){const re=await this.getAsset(z.assets.readme,{},ee);return await(0,k.asText)(re)||""}return""}async getManifest(z,ee){if(z.assets.manifest){const re=await this.getAsset(z.assets.manifest,{},ee),se=await(0,k.asText)(re);return se?JSON.parse(se):null}return null}async getManifestFromRawExtensionVersion(z,ee){const re=X(z,h.Manifest);if(!re)throw new Error("Manifest was not found");const se={"Accept-Encoding":"gzip"},J=await this.getAsset(re,{headers:se});return await(0,k.asJson)(J)}async getCoreTranslation(z,ee){const re=z.assets.coreTranslations.filter(se=>se[0]===ee.toUpperCase())[0];if(re){const se=await this.getAsset(re[1]),J=await(0,k.asText)(se);return J?JSON.parse(J):null}return null}async getChangelog(z,ee){if(z.assets.changelog){const re=await this.getAsset(z.assets.changelog,{},ee);return await(0,k.asText)(re)||""}return""}async getAllCompatibleVersions(z,ee,re){let se=new R().withFlags(n.IncludeVersions,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,1).withFilter(o.Target,"Microsoft.VisualStudio.Code");z.identifier.uuid?se=se.withFilter(o.ExtensionId,z.identifier.uuid):se=se.withFilter(o.ExtensionName,z.identifier.id);const{galleryExtensions:J}=await this.queryGallery(se,re,r.CancellationToken.None);if(!J.length)return[];const ce=te(J[0]);if((0,m.isNotWebExtensionInWebTargetPlatform)(ce,re))return[];const le=[];for(const ue of J[0].versions)try{le[le.length-1]?.version!==ue.version&&await this.isRawExtensionVersionCompatible(ue,ee,ce,re)&&le.push({version:ue.version,date:ue.lastUpdated,isPreReleaseVersion:q(ue)})}catch{}return le}async getAsset(z,ee={},re=r.CancellationToken.None){const se=await this.commonHeadersPromise,J={type:"GET"},ce={...se,...ee.headers||{}};ee={...ee,...J,headers:ce};const le=z.uri,ue=z.fallbackUri,me={...ee,url:le};try{const Ee=await this.requestService.request(me,re);if(Ee.res.statusCode===200)return Ee;const de=await(0,k.asText)(Ee);throw new Error(`Expected 200, got back ${Ee.res.statusCode} instead.

${de}`)}catch(Ee){if((0,D.isPromiseCanceledError)(Ee))throw Ee;const de=(0,D.getErrorMessage)(Ee);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:le,message:de});const ge={...ee,url:ue};return this.requestService.request(ge,re)}}async getEngine(z){let ee=H(z);if(!ee){const re=await this.getManifestFromRawExtensionVersion(z,r.CancellationToken.None);if(!re)throw new Error("Manifest was not found");ee=re.engines.vscode}return ee}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[]};const z=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},r.CancellationToken.None);if(z.res.statusCode!==200)throw new Error("Could not get extensions report.");const ee=await(0,k.asJson)(z),re=[],se={};if(ee){for(const J of ee.malicious)re.push({id:J});if(ee.unsupported)for(const J of Object.keys(ee.unsupported)){const ce=ee.unsupported[J];(0,d.isBoolean)(ce)||(se[J.toLowerCase()]=ce.preReleaseExtension)}}return{malicious:re,unsupportedPreReleaseExtensions:se}}};W=fe([ie(1,k.IRequestService),ie(2,E.ILogService),ie(3,b.IEnvironmentService),ie(4,u.ITelemetryService),ie(5,g.IFileService),ie(6,v.IProductService),ie(7,y.IConfigurationService)],W);let F=class extends W{constructor(z,ee,re,se,J,ce,le,ue){super(z,ee,re,se,J,ce,le,ue)}};F=fe([ie(0,a.IStorageService),ie(1,k.IRequestService),ie(2,E.ILogService),ie(3,b.IEnvironmentService),ie(4,u.ITelemetryService),ie(5,g.IFileService),ie(6,v.IProductService),ie(7,y.IConfigurationService)],F),e.ExtensionGalleryService=F;let N=class extends W{constructor(z,ee,re,se,J,ce,le){super(void 0,z,ee,re,se,J,ce,le)}};N=fe([ie(0,k.IRequestService),ie(1,E.ILogService),ie(2,b.IEnvironmentService),ie(3,u.ITelemetryService),ie(4,g.IFileService),ie(5,v.IProductService),ie(6,y.IConfigurationService)],N),e.ExtensionGalleryServiceWithNoStorageService=N;async function V(U,z,ee,re,se,J){const ce={"X-Market-Client-Id":`VSCode ${U}`,"User-Agent":`VSCode ${U} (${z.nameShort})`},le=await(0,c.getServiceMachineId)(ee,se,J);return(0,s.supportsTelemetry)(z,ee)&&(0,s.getTelemetryLevel)(re)===3&&(ce["X-Market-User-Id"]=le),ce}e.resolveMarketplaceHeaders=V}),define(Z[206],x([0,1,2,47,3,25,152,19,56,54,40,28,65]),function(j,e,p,r,D,C,P,I,d,f,y,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let S=class{constructor(E,v){this._configurationService=v,this._experimentProperties={},this._disposables=new p.DisposableStore,this._cleanupPatterns=[],this._appenders=E.appenders,this._commonProperties=E.commonProperties||Promise.resolve({}),this._piiPaths=E.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!E.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let k of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,C.escapeRegExpCharacters)(k),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._telemetryLevel===3}),this._commonProperties.then(k=>{const c=/^[a-f0-9]+$/i.test(k["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!c})})}setExperimentProperty(E,v){this._experimentProperties[E]=v}_updateTelemetryLevel(){this._telemetryLevel=(0,m.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const E=await this._commonProperties;let v=E.sessionID,k=E["common.machineId"],c=E["common.firstSessionDate"],a=E["common.msftInternal"];return{sessionId:v,machineId:k,firstSessionDate:c,msftInternal:a}}dispose(){this._disposables.dispose()}_log(E,v,k,c){return this.telemetryLevel<v?Promise.resolve(void 0):this._commonProperties.then(a=>{k=(0,r.mixin)(k,a),k=(0,r.mixin)(k,this._experimentProperties),k=(0,r.cloneAndChange)(k,u=>{if(typeof u=="string")return this._cleanupInfo(u,c)}),this._appenders.forEach(u=>u.log(E,k))},a=>{console.error(a)})}publicLog(E,v,k){return this._log(E,3,v,k)}publicLog2(E,v,k){return this.publicLog(E,v,k)}publicLogError(E,v){return this.sendErrorTelemetry?this._log(E,2,v,!0):Promise.resolve(void 0)}publicLogError2(E,v){return this.publicLogError(E,v)}_anonymizeFilePaths(E){let v=E;const k=[];for(let s of this._cleanupPatterns)for(;;){const l=s.exec(E);if(!l)break;k.push([l.index,s.lastIndex])}const c=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,a=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let u=0;for(v="";;){const s=a.exec(E);if(!s)break;!c.test(s[0])&&k.every(([l,n])=>s.index<l||s.index>=n)&&(v+=E.substring(u,s.index)+"<REDACTED: user-file-path>",u=a.lastIndex)}return u<E.length&&(v+=E.substr(u)),v}_removePropertiesWithPossibleUserInfo(E){if(!E)return E;const v=E.toLowerCase(),k=/@[a-zA-Z0-9-.]+/;return/(key|token|sig|signature|password|passwd|pwd)[="':\s]/.test(v)?"<REDACTED: secret>":k.test(v)?"<REDACTED: email>":E}_cleanupInfo(E,v){let k=E;v&&(k=this._anonymizeFilePaths(k));for(let c of this._cleanupPatterns)k=k.replace(c,"");return k=this._removePropertiesWithPossibleUserInfo(k),k}};S.IDLE_START_EVENT_NAME="UserIdleStart",S.IDLE_STOP_EVENT_NAME="UserIdleStop",S=fe([ie(1,I.IConfigurationService)],S),e.TelemetryService=S;function t(){const g=(0,P.localize)(0,null,f.default.nameLong),E=f.default.privacyStatementUrl?(0,P.localize)(2,null,"https://aka.ms/vscode-telemetry",f.default.privacyStatementUrl):(0,P.localize)(1,null,"https://aka.ms/vscode-telemetry"),v=D.isWeb?"":(0,P.localize)(3,null),k=(0,P.localize)(4,null),c=(0,P.localize)(5,null),a=(0,P.localize)(6,null),u=(0,P.localize)(7,null),s=`
|       | ${k} | ${c} | ${a} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,l=(0,P.localize)(8,null);return`
${g} ${E} ${v}

&nbsp;

${u}
${s}

&nbsp;

${l}
`}y.Registry.as(d.Extensions.Configuration).registerConfiguration({id:b.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,P.localize)(9,null),properties:{[b.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,P.localize)(10,null),(0,P.localize)(11,null),(0,P.localize)(12,null),(0,P.localize)(13,null)],markdownDescription:t(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),y.Registry.as(d.Extensions.Configuration).registerConfiguration({id:b.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,P.localize)(14,null),properties:{[b.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:f.default.privacyStatementUrl?(0,P.localize)(16,null,f.default.nameLong,f.default.privacyStatementUrl):(0,P.localize)(15,null,f.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,P.localize)(17,null,`\`#${b.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Z[207],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var p;(function(r){r.DARK="dark",r.LIGHT="light",r.HIGH_CONTRAST="hc"})(p=e.ColorScheme||(e.ColorScheme={}))}),define(Z[208],x([0,1,104,4,2,5,40,207]),function(j,e,p,r,D,C,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,C.createDecorator)("themeService");var d;(function(E){function v(k){return k&&typeof k=="object"&&typeof k.id=="string"}E.isThemeColor=v})(d=e.ThemeColor||(e.ThemeColor={}));function f(E){return{id:E}}e.themeColorFromId=f;var y;(function(E){function v(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color=="undefined"||d.isThemeColor(i.color))}E.isThemeIcon=v;const k=new RegExp(`^\\$\\((${p.CSSIcon.iconNameExpression}(?:${p.CSSIcon.iconModifierExpression})?)\\)$`);function c(i){const o=k.exec(i);if(!o)return;let[,h]=o;return{id:h}}E.fromString=c;function a(i){return{id:i}}E.fromId=a;function u(i,o){let h=i.id;const w=h.lastIndexOf("~");return w!==-1&&(h=h.substring(0,w)),o&&(h=`${h}~${o}`),{id:h}}E.modify=u;function s(i){const o=i.id.lastIndexOf("~");if(o!==-1)return i.id.substring(o+1)}E.getModifier=s;function l(i,o){return i.id===o.id&&i.color?.id===o.color?.id}E.isEqual=l;function n(i,o){return{id:i.id,color:o?f(o):void 0}}E.asThemeIcon=n,E.asClassNameArray=p.CSSIcon.asClassNameArray,E.asClassName=p.CSSIcon.asClassName,E.asCSSSelector=p.CSSIcon.asCSSSelector})(y=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=p.Codicon.file,e.FolderThemeIcon=p.Codicon.folder;function b(E){switch(E){case I.ColorScheme.DARK:return"vs-dark";case I.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=b,e.Extensions={ThemingContribution:"base.contributions.theming"};class m{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new r.Emitter}onColorThemeChange(v){return this.themingParticipants.push(v),this.onThemingParticipantAddedEmitter.fire(v),(0,D.toDisposable)(()=>{const k=this.themingParticipants.indexOf(v);this.themingParticipants.splice(k,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let S=new m;P.Registry.add(e.Extensions.ThemingContribution,S);function t(E){return S.onColorThemeChange(E)}e.registerThemingParticipant=t;class g extends D.Disposable{constructor(v){super();this.themeService=v,this.theme=v.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(k=>this.onThemeChange(k)))}onThemeChange(v){this.theme=v,this.updateStyles()}updateStyles(){}getColor(v,k){let c=this.theme.getColor(v);return c&&k&&(c=k(c,this.theme)),c?c.toString():null}}e.Themable=g}),define(Z[66],x([0,1,14,3,5,37]),function(j,e,p,r,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const P="#FFFFFF",I="#1E1E1E",d="#000000",f="theme",y="themeBackground",b="windowSplash";e.IThemeMainService=(0,D.createDecorator)("themeMainService");let m=class{constructor(t){this.stateMainService=t}getBackgroundColor(){if((r.isWindows||r.isMacintosh)&&p.nativeTheme.shouldUseInvertedColorScheme)return d;let t=this.stateMainService.getItem(y,null);if(!t){let g;(r.isWindows||r.isMacintosh)&&p.nativeTheme.shouldUseInvertedColorScheme?g="hc-black":g=this.stateMainService.getItem(f,"vs-dark").split(" ")[0],t=g==="hc-black"?d:g==="vs"?P:I}return r.isMacintosh&&t.toUpperCase()===I&&(t="#171717"),t}saveWindowSplash(t,g){this.stateMainService.setItems([{key:f,data:g.baseTheme},{key:y,data:g.colorInfo.background},{key:b,data:g}]),typeof t=="number"&&this.updateBackgroundColor(t,g)}updateBackgroundColor(t,g){for(const E of p.BrowserWindow.getAllWindows())if(E.id===t){E.setBackgroundColor(g.colorInfo.background);break}}getWindowSplash(){return this.stateMainService.getItem(b)}};m=fe([ie(0,C.IStateMainService)],m),e.ThemeMainService=m}),define(Z[41],x([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var r;(function(C){C.Uninitialized="uninitialized",C.Idle="idle",C.CheckingForUpdates="checking for updates",C.AvailableForDownload="available for download",C.Downloading="downloading",C.Downloaded="downloaded",C.Updating="updating",C.Ready="ready"})(r=e.StateType||(e.StateType={}));var D;(function(C){C[C.Setup=0]="Setup",C[C.Archive=1]="Archive",C[C.Snap=2]="Snap"})(D=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(C,P)=>({type:"idle",updateType:C,error:P}),CheckingForUpdates:C=>({type:"checking for updates",explicit:C}),AvailableForDownload:C=>({type:"available for download",update:C}),Downloading:C=>({type:"downloading",update:C}),Downloaded:C=>({type:"downloaded",update:C}),Updating:C=>({type:"updating",update:C}),Ready:C=>({type:"ready",update:C})},e.IUpdateService=(0,p.createDecorator)("updateService")}),define(Z[209],x([0,1,3,153,56,40]),function(j,e,p,r,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),C.Registry.as(D.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,r.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,r.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,r.localize)(2,null),(0,r.localize)(3,null),(0,r.localize)(4,null),(0,r.localize)(5,null)]},"update.channel":{type:"string",default:"default",scope:1,description:(0,r.localize)(6,null),deprecationMessage:(0,r.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,r.localize)(8,null),description:(0,r.localize)(9,null),included:p.isWindows&&!p.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,r.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(Z[210],x([0,1,4,41]),function(j,e,p,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class D{constructor(I){this.service=I}listen(I,d){switch(d){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${d}`)}call(I,d,f){switch(d){case"checkForUpdates":return this.service.checkForUpdates(f);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion()}throw new Error(`Call not found: ${d}`)}}e.UpdateChannel=D;class C{constructor(I){this.channel=I,this._onStateChange=new p.Emitter,this.onStateChange=this._onStateChange.event,this._state=r.State.Uninitialized,this.channel.listen("onStateChange")(d=>this.state=d),this.channel.call("_getInitialState").then(d=>this.state=d)}get state(){return this._state}set state(I){this._state=I,this._onStateChange.fire(I)}checkForUpdates(I){return this.channel.call("checkForUpdates",I)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}}e.UpdateChannelClient=C}),define(Z[98],x([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,p.createDecorator)("urlService")}),define(Z[211],x([0,1,7]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class r{constructor(I){this.handler=I}listen(I,d){throw new Error(`Event not found: ${d}`)}call(I,d,f){switch(d){case"handleURL":return this.handler.handleURL(p.URI.revive(f[0]),f[1])}throw new Error(`Call not found: ${d}`)}}e.URLHandlerChannel=r;class D{constructor(I){this.channel=I}handleURL(I,d){return this.channel.call("handleURL",[I.toJSON(),d])}}e.URLHandlerChannelClient=D;class C{constructor(I){this.next=I}async routeCall(I,d,f,y){if(d!=="handleURL")throw new Error(`Call not found: ${d}`);if(f){const b=p.URI.revive(f);if(b&&b.query){const m=/\bwindowId=(\d+)/.exec(b.query);if(m){const S=m[1],t=new RegExp(`window:${S}`),g=I.connections.find(E=>t.test(E.ctx));if(g)return g}}}return this.next.routeCall(I,d,f,y)}routeEvent(I,d){throw new Error(`Event not found: ${d}`)}}e.URLHandlerRouter=C}),define(Z[212],x([0,1,9,2,7,22]),function(j,e,p,r,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class P extends r.Disposable{constructor(){super(...arguments);this.handlers=new Set}open(f,y){const b=[...this.handlers.values()];return(0,p.first)(b.map(m=>()=>m.handleURL(f,y)),void 0,!1).then(m=>m||!1)}registerHandler(f){return this.handlers.add(f),(0,r.toDisposable)(()=>this.handlers.delete(f))}}e.AbstractURLService=P;let I=class extends P{constructor(f){super();this.productService=f}create(f){let{authority:y,path:b,query:m,fragment:S}=f||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return y&&b&&b.indexOf("/")!==0&&(b=`/${b}`),D.URI.from({scheme:this.productService.urlProtocol,authority:y,path:b,query:m,fragment:S})}};I=fe([ie(0,C.IProductService)],I),e.NativeURLService=I}),define(Z[213],x([0,1,14,9,4,2,3,7]),function(j,e,p,r,D,C,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function d(y){try{return I.URI.parse(y)}catch{return null}}class f{constructor(b,m,S,t,g){if(this.urlService=m,this.uris=[],this.retryCount=0,this.flushDisposable=C.Disposable.None,this.disposables=new C.DisposableStore,this.uris=b,P.isWindows){const k=t.isBuilt?[]:[`"${t.appRoot}"`];k.push("--open-url","--"),p.app.setAsDefaultProtocolClient(g.urlProtocol,process.execPath,k)}const E=D.Event.map(D.Event.fromNodeEventEmitter(p.app,"open-url",(k,c)=>({event:k,url:c})),({event:k,url:c})=>(k.preventDefault(),c));this.disposables.add(E(k=>{const c=d(k);!c||this.urlService.open(c,{originalUrl:k})})),S.getWindows().filter(k=>k.isReady).length>0?this.flush():D.Event.once(S.onDidSignalReadyWindow)(this.flush,this,this.disposables)}async flush(){if(this.retryCount++>10)return;const b=[];for(const m of this.uris)await this.urlService.open(m.uri,{originalUrl:m.url})||b.push(m);b.length!==0&&(this.uris=b,this.flushDisposable=(0,r.disposableTimeout)(()=>this.flush(),500))}dispose(){this.disposables.dispose(),this.flushDisposable.dispose()}}e.ElectronURLListener=f}),define(Z[214],x([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,p.createDecorator)("webviewManagerService")}),define(Z[215],x([0,1,14,2,10,7]),function(j,e,p,r,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class P extends r.Disposable{constructor(){super();const d=this.handleWebviewRequest.bind(this);p.protocol.registerFileProtocol(D.Schemas.vscodeWebview,d)}handleWebviewRequest(d,f){try{const y=C.URI.parse(d.url),b=P.validWebviewFilePaths.get(y.path);if(typeof b=="string"){const m=`vs/workbench/contrib/webview/browser/pre/${b}`,S=D.FileAccess.asFileUri(m,j);return f(decodeURIComponent(S.fsPath))}else return f({error:-10})}catch{}return f({error:-2})}}e.WebviewProtocolProvider=P,P.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/main.js","main.js"],["/service-worker.js","service-worker.js"]])}),define(Z[67],x([0,1,3]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function r(f){return!!f.workspaceUri}e.isWorkspaceToOpen=r;function D(f){return!!f.folderUri}e.isFolderToOpen=D;function C(f){return!!f.fileUri}e.isFileToOpen=C;function P(f){const y=I(f),b=f.getValue("window.menuBarVisibility");return b==="default"||y==="native"&&b==="compact"||p.isMacintosh&&p.isNative?"classic":b}e.getMenuBarVisibility=P;function I(f){if(p.isWeb)return"custom";const y=f.getValue("window");if(y){if(p.isMacintosh&&y.nativeTabs===!0||p.isMacintosh&&y.nativeFullScreen===!1)return"native";const S=f.getValue("workbench.colorCustomizations");if(S?.["window.activeBorder"]||S?.["window.inactiveBorder"])return"custom";const t=y.titleBarStyle;if(t==="native"||t==="custom")return t}return p.isLinux?"native":"custom"}e.getTitleBarStyle=I;function d(f=0){return Math.pow(1.2,f)}e.zoomLevelToZoomFactor=d}),define(Z[35],x([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWindowsMainService=e.WindowError=e.WindowMode=e.defaultWindowState=e.OpenContext=e.UnloadReason=e.LoadReason=void 0;var r;(function(f){f[f.INITIAL=1]="INITIAL",f[f.LOAD=2]="LOAD",f[f.RELOAD=3]="RELOAD"})(r=e.LoadReason||(e.LoadReason={}));var D;(function(f){f[f.CLOSE=1]="CLOSE",f[f.QUIT=2]="QUIT",f[f.RELOAD=3]="RELOAD",f[f.LOAD=4]="LOAD"})(D=e.UnloadReason||(e.UnloadReason={}));var C;(function(f){f[f.CLI=0]="CLI",f[f.DOCK=1]="DOCK",f[f.MENU=2]="MENU",f[f.DIALOG=3]="DIALOG",f[f.DESKTOP=4]="DESKTOP",f[f.API=5]="API"})(C=e.OpenContext||(e.OpenContext={}));const P=function(f=1){return{width:1024,height:768,mode:f}};e.defaultWindowState=P;var I;(function(f){f[f.Maximized=0]="Maximized",f[f.Normal=1]="Normal",f[f.Minimized=2]="Minimized",f[f.Fullscreen=3]="Fullscreen"})(I=e.WindowMode||(e.WindowMode={}));var d;(function(f){f[f.UNRESPONSIVE=1]="UNRESPONSIVE",f[f.CRASHED=2]="CRASHED",f[f.LOAD=3]="LOAD"})(d=e.WindowError||(e.WindowError={})),e.IWindowsMainService=(0,p.createDecorator)("windowsMainService")}),define(Z[216],x([0,1,14,4,2,215,35]),function(j,e,p,r,D,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let I=class extends D.Disposable{constructor(f){super();this.windowsMainService=f,this._onFoundInFrame=this._register(new r.Emitter),this.onFoundInFrame=this._onFoundInFrame.event,this._register(new C.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(f,y){let b;if(typeof f.windowId=="number"){const{windowId:m}=f,S=this.windowsMainService.getWindowById(m);if(!S?.win)throw new Error(`Invalid windowId: ${m}`);b=S.win.webContents}else{const{webContentsId:m}=f;if(b=p.webContents.fromId(m),!b)throw new Error(`Invalid webContentsId: ${m}`)}b.isDestroyed()||b.setIgnoreMenuShortcuts(y)}async findInFrame(f,y,b,m){const S=this.getFrameByName(f,y),t=S;if(typeof t.findInFrame=="function"){t.findInFrame(b,{findNext:m.findNext,forward:m.forward});const g=(E,v)=>{v.finalUpdate&&(this._onFoundInFrame.fire(v),S.removeListener("found-in-frame",g))};S.on("found-in-frame",g)}}async stopFindInFrame(f,y,b){const S=this.getFrameByName(f,y);typeof S.stopFindInFrame=="function"&&S.stopFindInFrame(b.keepSelection?"keepSelection":"clearSelection")}getFrameByName(f,y){const b=this.windowsMainService.getWindowById(f.windowId);if(!b?.win)throw new Error(`Invalid windowId: ${f}`);const m=b.win.webContents.mainFrame.framesInSubtree.find(S=>S.name===y);if(!m)throw new Error(`Unknown frame: ${y}`);return m}};I=fe([ie(0,P.IWindowsMainService)],I),e.WebviewMainService=I}),define(Z[217],x([0,1,9,4,2]),function(j,e,p,r,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class C extends D.Disposable{constructor({onDidOpenWindow:I,onDidFocusWindow:d,getActiveWindowId:f}){super();this.disposables=this._register(new D.DisposableStore),r.Event.latch(r.Event.any(I,d))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,p.createCancelablePromise)(()=>f()),(async()=>{try{const b=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:b}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(I){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=I}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=C}),define(Z[218],x([0,1,39,15,7,5]),function(j,e,p,r,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,C.createDecorator)("contextService");var P;(function(m){m[m.EMPTY=1]="EMPTY",m[m.FOLDER=2]="FOLDER",m[m.WORKSPACE=3]="WORKSPACE"})(P=e.WorkbenchState||(e.WorkbenchState={}));function I(m){const S=m;return!!(S&&typeof S=="object"&&typeof S.id=="string"&&Array.isArray(S.folders))}e.isWorkspace=I;function d(m){const S=m;return!!(S&&typeof S=="object"&&D.URI.isUri(S.uri)&&typeof S.name=="string"&&typeof S.toResource=="function")}e.isWorkspaceFolder=d;class f{constructor(S,t,g,E,v){this._id=S,this._transient=g,this._configuration=E,this._ignorePathCasing=v,this._foldersMap=p.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=t}update(S){this._id=S.id,this._configuration=S.configuration,this._transient=S.transient,this._ignorePathCasing=S._ignorePathCasing,this.folders=S.folders}get folders(){return this._folders}set folders(S){this._folders=S,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(S){this._configuration=S}getFolder(S){return S&&this._foldersMap.findSubstr(S.with({scheme:S.scheme,authority:S.authority,path:S.path}))||null}updateFoldersMap(){this._foldersMap=p.TernarySearchTree.forUris(this._ignorePathCasing);for(const S of this.folders)this._foldersMap.set(S.uri,S)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=f;class y{constructor(S,t){this.raw=t,this.uri=S.uri,this.index=S.index,this.name=S.name}toResource(S){return(0,r.joinPath)(this.uri,S)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=y;function b(m){return new y({uri:m,index:0,name:(0,r.basenameOrAuthority)(m)},{uri:m.toString()})}e.toWorkspaceFolder=b}),define(Z[29],x([0,1,32,38,78,33,10,8,3,15,7,156,5,64,218]),function(j,e,p,r,D,C,P,I,d,f,y,b,m,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isWorkspaceBackupInfo=e.isFolderBackupInfo=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const g=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,b.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function E(q){return(typeof q=="string"?(0,I.extname)(q):(0,f.extname)(q))===g}e.hasWorkspaceFileExtension=E,e.IWorkspacesService=(0,m.createDecorator)("workspacesService");function v(q){return q.hasOwnProperty("workspace")}e.isRecentWorkspace=v;function k(q){return q.hasOwnProperty("folderUri")}e.isRecentFolder=k;function c(q){return q.hasOwnProperty("fileUri")}e.isRecentFile=c;function a(q){return q&&q.hasOwnProperty("folderUri")}e.isFolderBackupInfo=a;function u(q){return q&&q.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=u;function s(q){const Y=q;return typeof Y?.id=="string"&&y.URI.isUri(Y.uri)}e.isSingleFolderWorkspaceIdentifier=s;function l(q){if(q.configuration)return{id:q.id,configPath:q.configuration};if(q.folders.length===1)return{id:q.id,uri:q.folders[0].uri}}e.toWorkspaceIdentifier=l;function n(q){const Y=q;return typeof Y?.id=="string"&&y.URI.isUri(Y.configPath)}e.isWorkspaceIdentifier=n;function i(q){const Y=q;if(Y?.uri)return{id:Y.id,uri:y.URI.revive(Y.uri)};const $=q;if($?.configPath)return{id:$.id,configPath:y.URI.revive($.configPath)};if(q?.id)return{id:q.id}}e.reviveIdentifier=i;function o(q,Y){return f.extUriBiasedIgnorePathCase.isEqualOrParent(q,Y.untitledWorkspacesHome)}e.isUntitledWorkspace=o;function h(q){return w(q)||M(q)}e.isStoredWorkspaceFolder=h;function w(q){const Y=q;return typeof Y?.path=="string"&&(!Y.name||typeof Y.name=="string")}e.isRawFileWorkspaceFolder=w;function M(q){const Y=q;return typeof Y?.uri=="string"&&(!Y.name||typeof Y.name=="string")}e.isRawUriWorkspaceFolder=M;function A(q,Y,$,K,te=!d.isWindows,B){if(q.scheme!==K.scheme)return{name:$,uri:q.toString(!0)};let L=Y?void 0:B.relativePath(K,q);if(L!==void 0)L.length===0?L=".":d.isWindows&&q.scheme===P.Schemas.file&&!te&&(L=L.replace(/\//g,"\\"));else if(q.scheme===P.Schemas.file)L=q.fsPath,d.isWindows&&(L=(0,C.normalizeDriveLetter)(L),te&&(L=(0,p.toSlashes)(L)));else{if(!B.isEqualAuthority(q.authority,K.authority))return{name:$,uri:q.toString(!0)};L=q.path}return{name:$,path:L}}e.getStoredWorkspaceFolder=A;function R(q,Y,$){let K=[],te=new Set;const B=$.dirname(Y);for(let L of q){let W;if(w(L))L.path&&(W=$.resolvePath(B,L.path));else if(M(L))try{W=y.URI.parse(L.uri),W.path[0]!=="/"&&(W=W.with({path:"/"+W.path}))}catch(F){console.warn(F)}if(W){let F=$.getComparisonKey(W);if(!te.has(F)){te.add(F);const N=L.name||$.basenameOrAuthority(W);K.push(new t.WorkspaceFolder({uri:W,name:N,index:K.length},L))}}}return K}e.toWorkspaceFolders=R;function T(q,Y,$,K,te){let B=_(Y,q);const L=te.dirname(Y),W=te.dirname(K),F=[],N=Q(B.folders);for(const ee of B.folders){const re=w(ee)?te.resolvePath(L,ee.path):y.URI.parse(ee.uri);let se;$?se=!1:se=!w(ee)||(0,I.isAbsolute)(ee.path),F.push(A(re,se,ee.name,W,N,te))}const V={insertSpaces:!1,tabSize:4,eol:d.isLinux||d.isMacintosh?`
`:`\r
`},U=D.setProperty(q,["folders"],F,V);let z=D.applyEdits(q,U);return(0,f.isEqualAuthority)(B.remoteAuthority,(0,S.getRemoteAuthority)(K))&&(z=D.applyEdits(z,D.removeProperty(z,["remoteAuthority"],V))),z}e.rewriteWorkspaceFileForNewLocation=T;function _(q,Y){let $=r.parse(Y);if($&&Array.isArray($.folders))$.folders=$.folders.filter(K=>h(K));else throw new Error(`${q} looks like an invalid workspace file.`);return $}function Q(q){return d.isWindows?q.some(Y=>w(Y)&&Y.path.indexOf("/")>=0):!0}e.useSlashForPath=Q;function ne(q){return q.workspace&&typeof q.workspace=="object"&&typeof q.workspace.id=="string"&&typeof q.workspace.configPath=="string"}function oe(q){return typeof q.folderUri=="string"}function X(q){return typeof q.fileUri=="string"}function O(q,Y){const $={workspaces:[],files:[]};if(q){const K=function(B,L){for(let W=0;W<B.length;W++)try{L(B[W],W)}catch(F){Y.warn(`Error restoring recent entry ${JSON.stringify(B[W])}: ${F.toString()}. Skip entry.`)}},te=q;if(Array.isArray(te.entries))K(te.entries,B=>{const L=B.label,W=B.remoteAuthority;ne(B)?$.workspaces.push({label:L,remoteAuthority:W,workspace:{id:B.workspace.id,configPath:y.URI.parse(B.workspace.configPath)}}):oe(B)?$.workspaces.push({label:L,remoteAuthority:W,folderUri:y.URI.parse(B.folderUri)}):X(B)&&$.files.push({label:L,remoteAuthority:W,fileUri:y.URI.parse(B.fileUri)})});else{const B=q;Array.isArray(B.workspaces3)&&K(B.workspaces3,(L,W)=>{const F=Array.isArray(B.workspaceLabels)&&B.workspaceLabels[W]||void 0;typeof L=="object"&&typeof L.id=="string"&&typeof L.configURIPath=="string"?$.workspaces.push({label:F,workspace:{id:L.id,configPath:y.URI.parse(L.configURIPath)}}):typeof L=="string"&&$.workspaces.push({label:F,folderUri:y.URI.parse(L)})}),Array.isArray(B.files2)&&K(B.files2,(L,W)=>{const F=Array.isArray(B.fileLabels)&&B.fileLabels[W]||void 0;typeof L=="string"&&$.files.push({label:F,fileUri:y.URI.parse(L)})})}}return $}e.restoreRecentlyOpened=O;function H(q){const Y={entries:[]};for(const $ of q.workspaces)k($)?Y.entries.push({folderUri:$.folderUri.toString(),label:$.label,remoteAuthority:$.remoteAuthority}):Y.entries.push({workspace:{id:$.workspace.id,configPath:$.workspace.configPath.toString()},label:$.label,remoteAuthority:$.remoteAuthority});for(const $ of q.files)Y.entries.push({fileUri:$.fileUri.toString(),label:$.label,remoteAuthority:$.remoteAuthority});return Y}e.toStoreData=H}),define(Z[50],x([0,1,14,9,81,33,2,70,8,3,13,21,136,5,6,37,29]),function(j,e,p,r,D,C,P,I,d,f,y,b,m,S,t,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,S.createDecorator)("dialogMainService");let v=class vt{constructor(c,a){this.stateMainService=c,this.logService=a,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new r.Queue}pickFileFolder(c,a){return this.doPick({...c,pickFolders:!0,pickFiles:!0,title:(0,m.localize)(0,null)},a)}pickFolder(c,a){return this.doPick({...c,pickFolders:!0,title:(0,m.localize)(1,null)},a)}pickFile(c,a){return this.doPick({...c,pickFiles:!0,title:(0,m.localize)(2,null)},a)}pickWorkspace(c,a){const u=(0,m.localize)(3,null),s=(0,C.mnemonicButtonLabel)((0,m.localize)(4,null)),l=E.WORKSPACE_FILTER;return this.doPick({...c,pickFiles:!0,title:u,filters:l,buttonLabel:s},a)}async doPick(c,a){const u={title:c.title,buttonLabel:c.buttonLabel,filters:c.filters};u.defaultPath=c.defaultPath||this.stateMainService.getItem(vt.workingDirPickerStorageKey),(typeof c.pickFiles=="boolean"||typeof c.pickFolders=="boolean")&&(u.properties=void 0,c.pickFiles&&c.pickFolders&&(u.properties=["multiSelections","openDirectory","openFile","createDirectory"])),u.properties||(u.properties=["multiSelections",c.pickFolders?"openDirectory":"openFile","createDirectory"]),f.isMacintosh&&u.properties.push("treatPackageAsDirectory");const s=a||p.BrowserWindow.getFocusedWindow(),l=await this.showOpenDialog(u,(0,y.withNullAsUndefined)(s));if(l&&l.filePaths&&l.filePaths.length>0)return this.stateMainService.setItem(vt.workingDirPickerStorageKey,(0,d.dirname)(l.filePaths[0])),l.filePaths}getWindowDialogQueue(c){if(c){let a=this.windowDialogQueues.get(c.id);return a||(a=new r.Queue,this.windowDialogQueues.set(c.id,a)),a}else return this.noWindowDialogueQueue}showMessageBox(c,a){return this.getWindowDialogQueue(a).queue(async()=>a?p.dialog.showMessageBox(a,c):p.dialog.showMessageBox(c))}async showSaveDialog(c,a){const u=this.acquireFileDialogLock(c,a);if(!u)return this.logService.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.getWindowDialogQueue(a).queue(async()=>{let s;return a?s=await p.dialog.showSaveDialog(a,c):s=await p.dialog.showSaveDialog(c),s.filePath=this.normalizePath(s.filePath),s})}finally{(0,P.dispose)(u)}}normalizePath(c){return c&&f.isMacintosh&&(c=(0,I.normalizeNFC)(c)),c}normalizePaths(c){return c.map(a=>this.normalizePath(a))}async showOpenDialog(c,a){c.defaultPath&&(await b.Promises.exists(c.defaultPath)||(c.defaultPath=void 0));const u=this.acquireFileDialogLock(c,a);if(!u)return this.logService.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.getWindowDialogQueue(a).queue(async()=>{let s;return a?s=await p.dialog.showOpenDialog(a,c):s=await p.dialog.showOpenDialog(c),s.filePaths=this.normalizePaths(s.filePaths),s})}finally{(0,P.dispose)(u)}}acquireFileDialogLock(c,a){if(!a)return P.Disposable.None;let u=this.windowFileDialogLocks.get(a.id);u||(u=new Set,this.windowFileDialogLocks.set(a.id,u));const s=(0,D.hash)(c);if(!u.has(s))return u.add(s),(0,P.toDisposable)(()=>{u?.delete(s),u?.size===0&&this.windowFileDialogLocks.delete(a.id)})}};v.workingDirPickerStorageKey="pickerWorkingDir",v=fe([ie(0,g.IStateMainService),ie(1,t.ILogService)],v),e.DialogMainService=v}),define(Z[219],x([0,1,4,2,29]),function(j,e,p,r,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class C extends r.Disposable{constructor(I,d){super();this.logService=I,this.storageMainService=d,this._onDidChangeGlobalStorage=this._register(new p.Emitter),this.onDidChangeGlobalStorage=this._onDidChangeGlobalStorage.event,this.registerGlobalStorageListeners()}registerGlobalStorageListeners(){this._register(p.Event.debounce(this.storageMainService.globalStorage.onDidChangeStorage,(I,d)=>(I?I.push(d):I=[d],I),C.STORAGE_CHANGE_DEBOUNCE_TIME)(I=>{I.length&&this._onDidChangeGlobalStorage.fire(this.serializeGlobalStorageEvents(I))}))}serializeGlobalStorageEvents(I){const d=new Map,f=new Set;return I.forEach(y=>{const b=this.storageMainService.globalStorage.get(y.key);typeof b=="string"?d.set(y.key,b):f.add(y.key)}),{changed:Array.from(d.entries()),deleted:Array.from(f.values())}}listen(I,d){switch(d){case"onDidChangeGlobalStorage":return this.onDidChangeGlobalStorage}throw new Error(`Event not found: ${d}`)}async call(I,d,f){const y=(0,D.reviveIdentifier)(f.workspace),b=await this.withStorageInitialized(y);switch(d){case"getItems":return Array.from(b.items.entries());case"updateItems":{const m=f;if(m.insert)for(const[S,t]of m.insert)b.set(S,t);m.delete&&m.delete.forEach(S=>b.delete(S));break}case"close":{if(y)return b.close();break}default:throw new Error(`Call not found: ${d}`)}}async withStorageInitialized(I){const d=I?this.storageMainService.workspaceStorage(I):this.storageMainService.globalStorage;try{await d.init()}catch(f){this.logService.error(`StorageIPC#init: Unable to init ${I?"workspace":"global"} storage due to ${f}`)}return d}}e.StorageDatabaseChannel=C,C.STORAGE_CHANGE_DEBOUNCE_TIME=100}),define(Z[220],x([0,1,9,4,2,8,21,86,125,6,97,28,29]),function(j,e,p,r,D,C,P,I,d,f,y,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspaceStorageMain=e.GlobalStorageMain=void 0;class S extends D.Disposable{constructor(v){super();this.logService=v,this._onDidChangeStorage=this._register(new r.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new r.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this.storage=new I.Storage(new I.InMemoryStorageDatabase),this.initializePromise=void 0,this.whenInitPromise=new p.DeferredPromise,this.whenInit=this.whenInitPromise.p}init(){return this.initializePromise||(this.initializePromise=(async()=>{try{const v=await this.doCreate();this.storage.dispose(),this.storage=v,this._register(v.onDidChangeStorage(c=>this._onDidChangeStorage.fire({key:c}))),await this.doInit(v);const k=v.getBoolean(y.IS_NEW_KEY);k===void 0?v.set(y.IS_NEW_KEY,!0):k&&v.set(y.IS_NEW_KEY,!1)}catch(v){this.logService.error(`StorageMain#initialize(): Unable to init storage due to ${v}`)}finally{this.whenInitPromise.complete()}})()),this.initializePromise}createLoggingOptions(){return{logTrace:this.logService.getLevel()===f.LogLevel.Trace?v=>this.logService.trace(v):void 0,logError:v=>this.logService.error(v)}}doInit(v){return v.init()}get items(){return this.storage.items}get(v,k){return this.storage.get(v,k)}set(v,k){return this.storage.set(v,k)}delete(v){return this.storage.delete(v)}async close(){this.initializePromise&&await this.initializePromise,await this.storage.close(),this._onDidCloseStorage.fire()}}class t extends S{constructor(v,k,c){super(k);this.options=v,this.environmentService=c}async doCreate(){let v;return this.options.useInMemoryStorage?v=d.SQLiteStorageDatabase.IN_MEMORY_PATH:v=(0,C.join)(this.environmentService.globalStorageHome.fsPath,t.STORAGE_NAME),new I.Storage(new d.SQLiteStorageDatabase(v,{logging:this.createLoggingOptions()}))}async doInit(v){await super.doInit(v),this.updateTelemetryState(v)}updateTelemetryState(v){v.get(b.firstSessionDateStorageKey,void 0)===void 0&&v.set(b.firstSessionDateStorageKey,new Date().toUTCString());const c=v.get(b.currentSessionDateStorageKey,void 0),a=new Date().toUTCString();v.set(b.lastSessionDateStorageKey,typeof c=="undefined"?null:c),v.set(b.currentSessionDateStorageKey,a)}}e.GlobalStorageMain=t,t.STORAGE_NAME="state.vscdb";class g extends S{constructor(v,k,c,a){super(c);this.workspace=v,this.options=k,this.environmentService=a}async doCreate(){const{storageFilePath:v,wasCreated:k}=await this.prepareWorkspaceStorageFolder();return new I.Storage(new d.SQLiteStorageDatabase(v,{logging:this.createLoggingOptions()}),{hint:k?I.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:d.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const v=(0,C.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id),k=(0,C.join)(v,g.WORKSPACE_STORAGE_NAME);return await P.Promises.exists(v)?{storageFilePath:k,wasCreated:!1}:(await P.Promises.mkdir(v,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(v),{storageFilePath:k,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(v){let k;if((0,m.isSingleFolderWorkspaceIdentifier)(this.workspace)?k={folder:this.workspace.uri.toString()}:(0,m.isWorkspaceIdentifier)(this.workspace)&&(k={workspace:this.workspace.configPath.toString()}),k)try{const c=(0,C.join)(v,g.WORKSPACE_META_NAME);await P.Promises.exists(c)||await P.Promises.writeFile(c,JSON.stringify(k,void 0,2))}catch(c){this.logService.error(`StorageMain#ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${c}`)}}}e.WorkspaceStorageMain=g,g.WORKSPACE_STORAGE_NAME="state.vscdb",g.WORKSPACE_META_NAME="workspace.json"}),define(Z[99],x([0,1,42,2,48,5,20,6,220]),function(j,e,p,r,D,C,P,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,C.createDecorator)("storageMainService");let f=class extends r.Disposable{constructor(b,m,S){super();this.logService=b,this.environmentService=m,this.lifecycleMainService=S,this.globalStorage=this.createGlobalStorage(),this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>{await this.lifecycleMainService.when(3),this.globalStorage.init()})(),this._register(this.lifecycleMainService.onWillLoadWindow(async b=>{b.workspace&&this.workspaceStorage(b.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(b=>{b.join(this.globalStorage.close());for(const[,m]of this.mapWorkspaceToStorage)b.join(m.close())}))}createGlobalStorage(){if(this.globalStorage)return this.globalStorage;this.logService.trace("StorageMainService: creating global storage");const b=new d.GlobalStorageMain(this.getStorageOptions(),this.logService,this.environmentService);return(0,p.once)(b.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed global storage")}),b}createWorkspaceStorage(b){return new d.WorkspaceStorageMain(b,this.getStorageOptions(),this.logService,this.environmentService)}workspaceStorage(b){let m=this.mapWorkspaceToStorage.get(b.id);return m||(this.logService.trace(`StorageMainService: creating workspace storage (${b.id})`),m=this.createWorkspaceStorage(b),this.mapWorkspaceToStorage.set(b.id,m),(0,p.once)(m.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${b.id})`),this.mapWorkspaceToStorage.delete(b.id)})),m}};f=fe([ie(0,I.ILogService),ie(1,D.IEnvironmentService),ie(2,P.ILifecycleMainService)],f),e.StorageMainService=f}),define(Z[100],x([0,1,15,7,29]),function(j,e,p,r,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;function C(d,f,y){for(const m of d){const S=m.openedWorkspace;if((0,D.isWorkspaceIdentifier)(S)){const t=y(S);if(t){if(t.folders.some(g=>p.extUriBiasedIgnorePathCase.isEqualOrParent(f,g.uri)))return m}else if(p.extUriBiasedIgnorePathCase.isEqualOrParent(f,S.configPath))return m}}const b=d.filter(m=>(0,D.isSingleFolderWorkspaceIdentifier)(m.openedWorkspace)&&p.extUriBiasedIgnorePathCase.isEqualOrParent(f,m.openedWorkspace.uri));if(b.length)return b.sort((m,S)=>-(m.openedWorkspace.uri.path.length-S.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=C;function P(d,f){for(const y of d)if((0,D.isWorkspaceIdentifier)(y.openedWorkspace)&&p.extUriBiasedIgnorePathCase.isEqual(y.openedWorkspace.configPath,f)||(0,D.isSingleFolderWorkspaceIdentifier)(y.openedWorkspace)&&p.extUriBiasedIgnorePathCase.isEqual(y.openedWorkspace.uri,f))return y}e.findWindowOnWorkspaceOrFolder=P;function I(d,f){const y=b=>f.some(m=>p.extUriBiasedIgnorePathCase.isEqual(r.URI.file(m),r.URI.file(b)));for(const b of d)if(b.config?.extensionDevelopmentPath?.some(m=>y(m)))return b}e.findWindowOnExtensionDevelopmentPath=I}),define(Z[221],x([0,1,14,2,3,15,7,19,20,6,37,35,29]),function(j,e,p,r,D,C,P,I,d,f,y,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let S=class St extends r.Disposable{constructor(c,a,u,s,l){super();this.windowsMainService=c,this.stateMainService=a,this.lifecycleMainService=u,this.logService=s,this.configurationService=l,this._state=t(this.stateMainService.getItem(St.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}get state(){return this._state}registerListeners(){p.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(c=>this.onBeforeCloseWindow(c)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(c=>{c.newCount-c.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(c=>this.onBeforeCloseWindow(c))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const c={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!c.lastActiveWindow){let s=this.windowsMainService.getLastActiveWindow();(!s||s.isExtensionDevelopmentHost)&&(s=this.windowsMainService.getWindows().find(l=>!l.isExtensionDevelopmentHost)),s&&(c.lastActiveWindow=this.toWindowState(s))}const a=this.windowsMainService.getWindows().find(s=>s.isExtensionDevelopmentHost&&!s.isExtensionTestHost);a&&(c.lastPluginDevelopmentHostWindow=this.toWindowState(a)),this.windowsMainService.getWindowCount()>1&&(c.openedWindows=this.windowsMainService.getWindows().filter(s=>!s.isExtensionDevelopmentHost).map(s=>this.toWindowState(s)));const u=E(c);this.stateMainService.setItem(St.windowsStateStorageKey,u),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",u)}onBeforeCloseWindow(c){if(this.lifecycleMainService.quitRequested)return;const a=this.toWindowState(c);c.isExtensionDevelopmentHost&&!c.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=a:!c.isExtensionDevelopmentHost&&c.openedWorkspace&&this._state.openedWindows.forEach(u=>{const s=(0,m.isWorkspaceIdentifier)(c.openedWorkspace)&&u.workspace?.id===c.openedWorkspace.id,l=(0,m.isSingleFolderWorkspaceIdentifier)(c.openedWorkspace)&&u.folderUri&&C.extUriBiasedIgnorePathCase.isEqual(u.folderUri,c.openedWorkspace.uri);(s||l)&&(u.uiState=a.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=a)}toWindowState(c){return{workspace:(0,m.isWorkspaceIdentifier)(c.openedWorkspace)?c.openedWorkspace:void 0,folderUri:(0,m.isSingleFolderWorkspaceIdentifier)(c.openedWorkspace)?c.openedWorkspace.uri:void 0,backupPath:c.backupPath,remoteAuthority:c.remoteAuthority,uiState:c.serializeWindowState()}}getNewWindowState(c){const a=this.doGetNewWindowState(c),u=this.configurationService.getValue("window");let s;return a.hasDefaultState?s=!!(u?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(u.newWindowDimensions)>=0):(s=!!(this.lifecycleMainService.wasRestarted||u?.restoreFullscreen),s&&D.isMacintosh&&this.windowsMainService.getWindows().some(l=>l.isFullScreen)&&(s=!1)),a.mode===3&&!s&&(a.mode=1),a}doGetNewWindowState(c){const a=this.windowsMainService.getLastActiveWindow();if(!c.extensionTestsPath){if(!!c.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const o=c.workspace;if((0,m.isWorkspaceIdentifier)(o)){const w=this.state.openedWindows.filter(M=>M.workspace&&M.workspace.id===o.id).map(M=>M.uiState);if(w.length)return w[0]}if((0,m.isSingleFolderWorkspaceIdentifier)(o)){const w=this.state.openedWindows.filter(M=>M.folderUri&&C.extUriBiasedIgnorePathCase.isEqual(M.folderUri,o.uri)).map(M=>M.uiState);if(w.length)return w[0]}else if(c.backupPath){const w=this.state.openedWindows.filter(M=>M.backupPath===c.backupPath).map(M=>M.uiState);if(w.length)return w[0]}const h=this.lastClosedState||this.state.lastActiveWindow;if(!a&&h)return h.uiState}let u;const s=p.screen.getAllDisplays();if(s.length===1)u=s[0];else{if(D.isMacintosh){const o=p.screen.getCursorScreenPoint();u=p.screen.getDisplayNearestPoint(o)}!u&&a&&(u=p.screen.getDisplayMatching(a.getBounds())),u||(u=p.screen.getPrimaryDisplay()||s[0])}let l=(0,b.defaultWindowState)();l.x=Math.round(u.bounds.x+u.bounds.width/2-l.width/2),l.y=Math.round(u.bounds.y+u.bounds.height/2-l.height/2);const n=this.configurationService.getValue("window");let i=!0;if(n?.newWindowDimensions){if(n.newWindowDimensions==="maximized")l.mode=0,i=!1;else if(n.newWindowDimensions==="fullscreen")l.mode=3,i=!1;else if((n.newWindowDimensions==="inherit"||n.newWindowDimensions==="offset")&&a){const o=a.serializeWindowState();o.mode===3?l.mode=3:l=o,i=l.mode!==3&&n.newWindowDimensions==="offset"}}return i&&(l=this.ensureNoOverlap(l)),l.hasDefaultState=!0,l}ensureNoOverlap(c){if(this.windowsMainService.getWindows().length===0)return c;c.x=typeof c.x=="number"?c.x:0,c.y=typeof c.y=="number"?c.y:0;const a=this.windowsMainService.getWindows().map(u=>u.getBounds());for(;a.some(u=>u.x===c.x||u.y===c.y);)c.x+=30,c.y+=30;return c}};S.windowsStateStorageKey="windowsState",S=fe([ie(0,b.IWindowsMainService),ie(1,y.IStateMainService),ie(2,d.ILifecycleMainService),ie(3,f.ILogService),ie(4,I.IConfigurationService)],S),e.WindowsStateHandler=S;function t(k){const c={openedWindows:[]},a=k||{openedWindows:[]};return a.lastActiveWindow&&(c.lastActiveWindow=g(a.lastActiveWindow)),a.lastPluginDevelopmentHostWindow&&(c.lastPluginDevelopmentHostWindow=g(a.lastPluginDevelopmentHostWindow)),Array.isArray(a.openedWindows)&&(c.openedWindows=a.openedWindows.map(u=>g(u))),c}e.restoreWindowsState=t;function g(k){const c={uiState:k.uiState};return k.backupPath&&(c.backupPath=k.backupPath),k.remoteAuthority&&(c.remoteAuthority=k.remoteAuthority),k.folder&&(c.folderUri=P.URI.parse(k.folder)),k.workspaceIdentifier&&(c.workspace={id:k.workspaceIdentifier.id,configPath:P.URI.parse(k.workspaceIdentifier.configURIPath)}),c}function E(k){return{lastActiveWindow:k.lastActiveWindow&&v(k.lastActiveWindow),lastPluginDevelopmentHostWindow:k.lastPluginDevelopmentHostWindow&&v(k.lastPluginDevelopmentHostWindow),openedWindows:k.openedWindows.map(c=>v(c))}}e.getWindowsStateStoreData=E;function v(k){return{workspaceIdentifier:k.workspace&&{id:k.workspace.id,configURIPath:k.workspace.configPath.toString()},folder:k.folderUri&&k.folderUri.toString(),backupPath:k.backupPath,remoteAuthority:k.remoteAuthority,uiState:k.uiState}}}),define(Z[101],x([0,1,60,27,10,3,15]),function(j,e,p,r,D,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=void 0;function I(f){function y(){let b=f.scheme===D.Schemas.file?(0,P.originalFSPath)(f):f.toString();return C.isLinux||(b=b.toLowerCase()),(0,p.createHash)("md5").update(b).digest("hex")}return{id:y(),configPath:f}}e.getWorkspaceIdentifier=I;function d(f,y){function b(){if(f.scheme!==D.Schemas.file)return(0,p.createHash)("md5").update(f.toString()).digest("hex");if(!y)try{y=(0,r.statSync)(f.fsPath)}catch{return}let S;return C.isLinux?S=y.ino:C.isMacintosh?S=y.birthtime.getTime():C.isWindows&&(typeof y.birthtimeMs=="number"?S=Math.floor(y.birthtimeMs):S=y.birthtime.getTime()),(0,p.createHash)("md5").update(f.fsPath).update(S?String(S):"").digest("hex")}const m=b();if(typeof m=="string")return{id:m,uri:f}}e.getSingleFolderWorkspaceIdentifier=d}),define(Z[222],x([0,1,16,10,6,250,112,20]),function(j,e,p,r,D,C,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerMainProcessExtensionHostStarter=void 0;class d{constructor(m,S){this._worker=new C.Worker(r.FileAccess.asFileUri("vs/platform/extensions/node/extensionHostStarterWorkerMain.js",j).fsPath),this._worker.on("message",m),this._worker.on("error",S)}getId(){return 1}postMessage(m,S){this._worker.postMessage(m,S)}dispose(){this._worker.terminate()}}let f=class{constructor(m){this._logService=m}async logInfo(m){this._logService.info(m)}};f=fe([ie(0,D.ILogService)],f);let y=class{constructor(m,S){this._logService=m,this._shutdown=!1,this._proxy=null;const t={create:(g,E,v)=>{const k=new d(E,v);return k.postMessage(g,[]),k}};this._worker=new P.SimpleWorkerClient(t,"vs/platform/extensions/node/extensionHostStarterWorker",new f(this._logService)),this._initialize(),S.onWillShutdown(g=>{this._shutdown=!0,this._proxy&&g.join(this._proxy.waitForAllExit(6e3))})}dispose(){}async _initialize(){this._proxy=await this._worker.getProxyObject(),this._logService.info("ExtensionHostStarterWorker created")}onDynamicStdout(m){return this._proxy.onDynamicStdout(m)}onDynamicStderr(m){return this._proxy.onDynamicStderr(m)}onDynamicMessage(m){return this._proxy.onDynamicMessage(m)}onDynamicError(m){return this._proxy.onDynamicError(m)}onDynamicExit(m){return this._proxy.onDynamicExit(m)}async createExtensionHost(){const m=await this._worker.getProxyObject();if(this._shutdown)throw(0,p.canceled)();return m.createExtensionHost()}async start(m,S){const t=await this._worker.getProxyObject();if(this._shutdown)throw(0,p.canceled)();return t.start(m,S)}async enableInspectPort(m){const S=await this._worker.getProxyObject();if(this._shutdown)throw(0,p.canceled)();return S.enableInspectPort(m)}async kill(m){const S=await this._worker.getProxyObject();if(this._shutdown)throw(0,p.canceled)();return S.kill(m)}};y=fe([ie(0,D.ILogService),ie(1,I.ILifecycleMainService)],y),e.WorkerMainProcessExtensionHostStarter=y}),define(Z[57],x([0,1,60,61,26,17,16,4,2,8,3,31,36,84,223]),function(j,e,p,r,D,C,P,I,d,f,y,b,m,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class g{constructor(R,T=""){this.debugLabel=T,this.socket=R,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=_=>{if(this.traceSocketEvent("error",{code:_?.code,message:_?.message}),_){if(_.code==="EPIPE")return;(0,P.onUnexpectedError)(_)}},this.socket.on("error",this._errorListener)}traceSocketEvent(R,T){S.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,R,T)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(R){const T=_=>{this.traceSocketEvent("read",_),R(C.VSBuffer.wrap(_))};return this.socket.on("data",T),{dispose:()=>this.socket.off("data",T)}}onClose(R){const T=_=>{this.traceSocketEvent("close",{hadError:_}),R({type:0,hadError:_,error:void 0})};return this.socket.on("close",T),{dispose:()=>this.socket.off("close",T)}}onEnd(R){const T=()=>{this.traceSocketEvent("nodeEndReceived"),R()};return this.socket.on("end",T),{dispose:()=>this.socket.off("end",T)}}write(R){if(!this.socket.destroyed)try{this.traceSocketEvent("write",R),this.socket.write(R.buffer,T=>{if(T){if(T.code==="EPIPE")return;(0,P.onUnexpectedError)(T)}})}catch(T){if(T.code==="EPIPE")return;(0,P.onUnexpectedError)(T)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((R,T)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),R();return}const _=()=>{this.socket.off("close",_),this.socket.off("end",_),this.socket.off("error",_),this.socket.off("timeout",_),this.socket.off("drain",_),this.traceSocketEvent("nodeDrainEnd"),R()};this.socket.on("close",_),this.socket.on("end",_),this.socket.on("error",_),this.socket.on("timeout",_),this.socket.on("drain",_)})}}e.NodeSocket=g;var E;(function(A){A[A.MinHeaderByteSize=2]="MinHeaderByteSize"})(E||(E={}));var v;(function(A){A[A.PeekHeader=1]="PeekHeader",A[A.ReadHeader=2]="ReadHeader",A[A.ReadBody=3]="ReadBody",A[A.Fin=4]="Fin"})(v||(v={}));class k extends d.Disposable{constructor(R,T,_,Q){super();this._onData=this._register(new I.Emitter),this._onClose=this._register(new I.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=R,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:T,inflateBytesLength:_?.byteLength||0,recordInflateBytes:Q}),this._flowManager=this._register(new c(this,T,_,Q,this._onData,(ne,oe)=>this._write(ne,oe))),this._register(this._flowManager.onError(ne=>{console.error(ne),(0,P.onUnexpectedError)(ne),this._onClose.fire({type:0,hadError:!0,error:ne})})),this._incomingData=new S.ChunkStream,this._register(this.socket.onData(ne=>this._acceptChunk(ne))),this._register(this.socket.onClose(ne=>this._onClose.fire(ne)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(R,T){this.socket.traceSocketEvent(R,T)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(R){return this._onData.event(R)}onClose(R){return this._onClose.event(R)}onEnd(R){return this.socket.onEnd(R)}write(R){this._flowManager.writeMessage(R)}_write(R,T){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",R);let _=2;R.byteLength<126?_+=0:R.byteLength<2**16?_+=2:_+=8;const Q=C.VSBuffer.alloc(_);if(T?Q.writeUInt8(194,0):Q.writeUInt8(130,0),R.byteLength<126)Q.writeUInt8(R.byteLength,1);else if(R.byteLength<2**16){Q.writeUInt8(126,1);let ne=1;Q.writeUInt8(R.byteLength>>>8&255,++ne),Q.writeUInt8(R.byteLength>>>0&255,++ne)}else{Q.writeUInt8(127,1);let ne=1;Q.writeUInt8(0,++ne),Q.writeUInt8(0,++ne),Q.writeUInt8(0,++ne),Q.writeUInt8(0,++ne),Q.writeUInt8(R.byteLength>>>24&255,++ne),Q.writeUInt8(R.byteLength>>>16&255,++ne),Q.writeUInt8(R.byteLength>>>8&255,++ne),Q.writeUInt8(R.byteLength>>>0&255,++ne)}this.socket.write(C.VSBuffer.concat([Q,R]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(R){if(R.byteLength!==0){for(this._incomingData.acceptChunk(R);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const T=this._incomingData.peek(this._state.readLen),_=T.readUInt8(0),Q=(_&128)>>>7,ne=(_&64)>>>6,oe=T.readUInt8(1),X=(oe&128)>>>7,O=oe&127;this._state.state=2,this._state.readLen=2+(X?4:0)+(O===126?2:0)+(O===127?8:0),this._state.fin=Q,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(ne)),this._state.firstFrameOfMessage=Boolean(Q),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const T=this._incomingData.read(this._state.readLen),_=T.readUInt8(1),Q=(_&128)>>>7;let ne=_&127,oe=1;ne===126?ne=T.readUInt8(++oe)*2**8+T.readUInt8(++oe):ne===127&&(ne=T.readUInt8(++oe)*0+T.readUInt8(++oe)*0+T.readUInt8(++oe)*0+T.readUInt8(++oe)*0+T.readUInt8(++oe)*2**24+T.readUInt8(++oe)*2**16+T.readUInt8(++oe)*2**8+T.readUInt8(++oe));let X=0;Q&&(X=T.readUInt8(++oe)*2**24+T.readUInt8(++oe)*2**16+T.readUInt8(++oe)*2**8+T.readUInt8(++oe)),this._state.state=3,this._state.readLen=ne,this._state.mask=X,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const T=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",T),s(T,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",T),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(T,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await I.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=k;class c extends d.Disposable{constructor(R,T,_,Q,ne,oe){super();this._tracer=R,this._onData=ne,this._writeFn=oe,this._onError=this._register(new I.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new I.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,T?(this._zlibInflateStream=this._register(new a(this._tracer,Q,_,{windowBits:15})),this._zlibDeflateStream=this._register(new u(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(X=>this._onError.fire(X))),this._register(this._zlibDeflateStream.onError(X=>this._onError.fire(X)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:C.VSBuffer.alloc(0)}writeMessage(R){this._writeQueue.push(R),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const R=this._writeQueue.shift();if(this._zlibDeflateStream){const T=await this._deflateMessage(this._zlibDeflateStream,R);this._writeFn(T,!0)}else this._writeFn(R,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(R,T){return new Promise((_,Q)=>{R.write(T),R.flush(ne=>_(ne))})}acceptFrame(R,T,_){this._readQueue.push({data:R,isCompressed:T,isLastFrameOfMessage:_}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const R=this._readQueue.shift();if(this._zlibInflateStream&&R.isCompressed){const T=await this._inflateFrame(this._zlibInflateStream,R.data,R.isLastFrameOfMessage);this._onData.fire(T)}else this._onData.fire(R.data)}this._isProcessingReadQueue=!1}}_inflateFrame(R,T,_){return new Promise((Q,ne)=>{R.write(T),_&&R.write(C.VSBuffer.fromByteArray([0,0,255,255])),R.flush(oe=>Q(oe))})}}class a extends d.Disposable{constructor(R,T,_,Q){super();this._tracer=R,this._recordInflateBytes=T,this._onError=this._register(new I.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=t.createInflateRaw(Q),this._zlibInflate.on("error",ne=>{this._tracer.traceSocketEvent("zlibInflateError",{message:ne?.message,code:ne?.code}),this._onError.fire(ne)}),this._zlibInflate.on("data",ne=>{this._tracer.traceSocketEvent("zlibInflateData",ne),this._pendingInflateData.push(C.VSBuffer.wrap(ne))}),_&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",_.buffer),this._zlibInflate.write(_.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?C.VSBuffer.concat(this._recordedInflateBytes):C.VSBuffer.alloc(0)}write(R){this._recordInflateBytes&&this._recordedInflateBytes.push(R.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",R),this._zlibInflate.write(R.buffer)}flush(R){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const T=C.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,R(T)})}}class u extends d.Disposable{constructor(R,T){super();this._tracer=R,this._onError=this._register(new I.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=t.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",_=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:_?.message,code:_?.code}),this._onError.fire(_)}),this._zlibDeflate.on("data",_=>{this._tracer.traceSocketEvent("zlibDeflateData",_),this._pendingDeflateData.push(C.VSBuffer.wrap(_))})}write(R){this._tracer.traceSocketEvent("zlibDeflateWrite",R.buffer),this._zlibDeflate.write(R.buffer)}flush(R){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let T=C.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,T=T.slice(0,T.byteLength-4),R(T)})}}function s(A,R){if(R===0)return;let T=A.byteLength>>>2;for(let O=0;O<T;O++){const H=A.readUInt32BE(O*4);A.writeUInt32BE(H^R,O*4)}let _=T*4,Q=A.byteLength-_;const ne=R>>>24&255,oe=R>>>16&255,X=R>>>8&255;Q>=1&&A.writeUInt8(A.readUInt8(_)^ne,_),Q>=2&&A.writeUInt8(A.readUInt8(_+1)^oe,_+1),Q>=3&&A.writeUInt8(A.readUInt8(_+2)^X,_+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const l={[2]:107,[1]:103};function n(){const A=(0,b.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${A}-sock`;let R;return e.XDG_RUNTIME_DIR?R=(0,f.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${A}.sock`):R=(0,f.join)((0,D.tmpdir)(),`vscode-ipc-${A}.sock`),o(R),R}e.createRandomIPCHandle=n;function i(A,R,T){const _=(0,p.createHash)("md5").update(A).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${_}-${T}-${R}-sock`;let Q;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?Q=(0,f.join)(e.XDG_RUNTIME_DIR,`vscode-${_.substr(0,8)}-${T}-${R}.sock`):Q=(0,f.join)(A,`${T}-${R}.sock`),o(Q),Q}e.createStaticIPCHandle=i;function o(A){const R=l[y.platform];typeof R=="number"&&A.length>=R&&console.warn(`WARNING: IPC handle "${A}" is longer than ${R} chars, try a shorter --user-data-dir`)}class h extends m.IPCServer{constructor(R){super(h.toClientConnectionEvent(R));this.server=R}static toClientConnectionEvent(R){const T=I.Event.fromNodeEventEmitter(R,"connection");return I.Event.map(T,_=>({protocol:new S.Protocol(new g(_,"ipc-server-connection")),onDidClientDisconnect:I.Event.once(I.Event.fromNodeEventEmitter(_,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=h;function w(A){return new Promise((R,T)=>{const _=(0,r.createServer)();_.on("error",T),_.listen(A,()=>{_.removeListener("error",T),R(new h(_))})})}e.serve=w;function M(A,R){return new Promise((T,_)=>{const Q=(0,r.createConnection)(A,()=>{Q.removeListener("error",_),T(S.Client.fromSocket(new g(Q,`ipc-client${R}`),R))});Q.once("error",_)})}e.connect=M}),define(Z[224],x([0,1,57]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.WindowDriverRegistryChannel=e.DriverChannelClient=e.DriverChannel=void 0;class r{constructor(d){this.driver=d}listen(d,f){throw new Error("No event found")}call(d,f,y){switch(f){case"getWindowIds":return this.driver.getWindowIds();case"capturePage":return this.driver.capturePage(y);case"startTracing":return this.driver.startTracing(y[0],y[1]);case"stopTracing":return this.driver.stopTracing(y[0],y[1],y[2]);case"reloadWindow":return this.driver.reloadWindow(y);case"exitApplication":return this.driver.exitApplication();case"dispatchKeybinding":return this.driver.dispatchKeybinding(y[0],y[1]);case"click":return this.driver.click(y[0],y[1],y[2],y[3]);case"doubleClick":return this.driver.doubleClick(y[0],y[1]);case"setValue":return this.driver.setValue(y[0],y[1],y[2]);case"getTitle":return this.driver.getTitle(y[0]);case"isActiveElement":return this.driver.isActiveElement(y[0],y[1]);case"getElements":return this.driver.getElements(y[0],y[1],y[2]);case"getElementXY":return this.driver.getElementXY(y[0],y[1],y[2]);case"typeInEditor":return this.driver.typeInEditor(y[0],y[1],y[2]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(y[0],y[1]);case"writeInTerminal":return this.driver.writeInTerminal(y[0],y[1],y[2]);case"getLocaleInfo":return this.driver.getLocaleInfo(y);case"getLocalizedStrings":return this.driver.getLocalizedStrings(y)}throw new Error(`Call not found: ${f}`)}}e.DriverChannel=r;class D{constructor(d){this.channel=d}getWindowIds(){return this.channel.call("getWindowIds")}capturePage(d){return this.channel.call("capturePage",d)}startTracing(d,f){return this.channel.call("startTracing",[d,f])}stopTracing(d,f,y){return this.channel.call("stopTracing",[d,f,y])}reloadWindow(d){return this.channel.call("reloadWindow",d)}exitApplication(){return this.channel.call("exitApplication")}dispatchKeybinding(d,f){return this.channel.call("dispatchKeybinding",[d,f])}click(d,f,y,b){return this.channel.call("click",[d,f,y,b])}doubleClick(d,f){return this.channel.call("doubleClick",[d,f])}setValue(d,f,y){return this.channel.call("setValue",[d,f,y])}getTitle(d){return this.channel.call("getTitle",[d])}isActiveElement(d,f){return this.channel.call("isActiveElement",[d,f])}getElements(d,f,y){return this.channel.call("getElements",[d,f,y])}getElementXY(d,f,y,b){return this.channel.call("getElementXY",[d,f,y,b])}typeInEditor(d,f,y){return this.channel.call("typeInEditor",[d,f,y])}getTerminalBuffer(d,f){return this.channel.call("getTerminalBuffer",[d,f])}writeInTerminal(d,f,y){return this.channel.call("writeInTerminal",[d,f,y])}getLocaleInfo(d){return this.channel.call("getLocaleInfo",d)}getLocalizedStrings(d){return this.channel.call("getLocalizedStrings",d)}}e.DriverChannelClient=D;class C{constructor(d){this.registry=d}listen(d,f){throw new Error(`Event not found: ${f}`)}call(d,f,y){switch(f){case"registerWindowDriver":return this.registry.registerWindowDriver(y);case"reloadWindowDriver":return this.registry.reloadWindowDriver(y)}throw new Error(`Call not found: ${f}`)}}e.WindowDriverRegistryChannel=C;async function P(I){const d=await(0,p.connect)(I,"driverClient"),f=d.getChannel("driver"),y=new D(f);return{client:d,driver:y}}e.connect=P}),define(Z[24],x([0,1,46,8,57,48,165,5]),function(j,e,p,r,D,C,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,I.refineServiceDecorator)(C.IEnvironmentService);class d extends P.NativeEnvironmentService{get cachedLanguagesPath(){return(0,r.join)(this.userDataPath,"clp")}get backupHome(){return(0,r.join)(this.userDataPath,"Backups")}get backupWorkspacesPath(){return(0,r.join)(this.backupHome,"workspaces.json")}get mainIPCHandle(){return(0,D.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get mainLockfile(){return(0,r.join)(this.userDataPath,"code.lock")}get sandbox(){return!!this.args.__sandbox}get driverVerbose(){return!!this.args["driver-verbose"]}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}}fe([p.memoize],d.prototype,"cachedLanguagesPath",null),fe([p.memoize],d.prototype,"backupHome",null),fe([p.memoize],d.prototype,"backupWorkspacesPath",null),fe([p.memoize],d.prototype,"mainIPCHandle",null),fe([p.memoize],d.prototype,"mainLockfile",null),fe([p.memoize],d.prototype,"sandbox",null),fe([p.memoize],d.prototype,"driverVerbose",null),fe([p.memoize],d.prototype,"disableUpdates",null),fe([p.memoize],d.prototype,"disableKeytar",null),fe([p.memoize],d.prototype,"codeCachePath",null),fe([p.memoize],d.prototype,"useCodeCache",null),e.EnvironmentMainService=d}),define(Z[225],x([0,1,60,27,32,10,8,3,15,7,21,159,19,24,18,6,29]),function(j,e,p,r,D,C,P,I,d,f,y,b,m,S,t,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let v=class{constructor(c,a,u){this.configurationService=a,this.logService=u,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=d.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(s,l)=>(0,D.isEqual)(s,l,!I.isLinux)},this.backupHome=c.backupHome,this.workspacesJsonPath=c.backupWorkspacesPath}async initialize(){let c;try{c=JSON.parse(await y.Promises.readFile(this.workspacesJsonPath,"utf8"))}catch{c=Object.create(null)}this.emptyWindows=await this.validateEmptyWorkspaces(c.emptyWorkspaceInfos);let a=[];try{Array.isArray(c.rootURIWorkspaces)&&(a=c.rootURIWorkspaces.map(s=>({workspace:{id:s.id,configPath:f.URI.parse(s.configURIPath)},remoteAuthority:s.remoteAuthority})))}catch{}this.workspaces=await this.validateWorkspaces(a);let u=[];try{Array.isArray(c.folderWorkspaceInfos)?u=c.folderWorkspaceInfos.map(s=>({folderUri:f.URI.parse(s.folderUri),remoteAuthority:s.remoteAuthority})):Array.isArray(c.folderURIWorkspaces)&&(u=c.folderURIWorkspaces.map(s=>({folderUri:f.URI.parse(s),remoteAuthority:void 0})))}catch{}this.folders=await this.validateFolders(u),await this.save()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackupPaths(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==t.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===t.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){return this.configurationService.getValue()?.files?.hotExit||t.HotExitConfiguration.ON_EXIT}getEmptyWindowBackupPaths(){return this.emptyWindows.slice(0)}registerWorkspaceBackupSync(c,a){this.workspaces.some(s=>c.workspace.id===s.workspace.id)||(this.workspaces.push(c),this.saveSync());const u=this.getBackupPath(c.workspace.id);return a&&this.moveBackupFolderSync(u,a),u}moveBackupFolderSync(c,a){if(r.existsSync(c)&&this.convertToEmptyWindowBackupSync(c),r.existsSync(a))try{r.renameSync(a,c)}catch(u){this.logService.error(`Backup: Could not move backup folder to new location: ${u.toString()}`)}}unregisterWorkspaceBackupSync(c){const a=c.id,u=this.workspaces.findIndex(s=>s.workspace.id===a);u!==-1&&(this.workspaces.splice(u,1),this.saveSync())}registerFolderBackupSync(c){return this.folders.some(a=>this.backupUriComparer.isEqual(c.folderUri,a.folderUri))||(this.folders.push(c),this.saveSync()),this.getBackupPath(this.getFolderHash(c))}unregisterFolderBackupSync(c){const a=this.folders.findIndex(u=>this.backupUriComparer.isEqual(c,u.folderUri));a!==-1&&(this.folders.splice(a,1),this.saveSync())}registerEmptyWindowBackupSync(c,a){const u=c||this.getRandomEmptyWindowId();return this.emptyWindows.some(s=>!!s.backupFolder&&this.backupPathComparer.isEqual(s.backupFolder,u))||(this.emptyWindows.push({backupFolder:u,remoteAuthority:a}),this.saveSync()),this.getBackupPath(u)}unregisterEmptyWindowBackupSync(c){const a=this.emptyWindows.findIndex(u=>!!u.backupFolder&&this.backupPathComparer.isEqual(u.backupFolder,c));a!==-1&&(this.emptyWindows.splice(a,1),this.saveSync())}getBackupPath(c){return(0,P.join)(this.backupHome,c)}async validateWorkspaces(c){if(!Array.isArray(c))return[];const a=new Set,u=[];for(let s of c){const l=s.workspace;if(!(0,E.isWorkspaceIdentifier)(l))return[];if(!a.has(l.id)){a.add(l.id);const n=this.getBackupPath(l.id);await this.doHasBackups(n)?l.configPath.scheme!==C.Schemas.file||await y.Promises.exists(l.configPath.fsPath)?u.push(s):await this.convertToEmptyWindowBackup(n):await this.deleteStaleBackup(n)}}return u}async validateFolders(c){if(!Array.isArray(c))return[];const a=[],u=new Set;for(let s of c){const l=s.folderUri,n=this.backupUriComparer.getComparisonKey(l);if(!u.has(n)){u.add(n);const i=this.getBackupPath(this.getFolderHash(s));await this.doHasBackups(i)?l.scheme!==C.Schemas.file||await y.Promises.exists(l.fsPath)?a.push(s):await this.convertToEmptyWindowBackup(i):await this.deleteStaleBackup(i)}}return a}async validateEmptyWorkspaces(c){if(!Array.isArray(c))return[];const a=[],u=new Set;for(let s of c){const l=s.backupFolder;if(typeof l!="string")return[];if(!u.has(l)){u.add(l);const n=this.getBackupPath(l);await this.doHasBackups(n)?a.push(s):await this.deleteStaleBackup(n)}}return a}async deleteStaleBackup(c){try{await y.Promises.exists(c)&&await y.Promises.rm(c,y.RimRafMode.MOVE)}catch(a){this.logService.error(`Backup: Could not delete stale backup: ${a.toString()}`)}}async convertToEmptyWindowBackup(c){let a=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(s=>!!s.backupFolder&&this.backupPathComparer.isEqual(s.backupFolder,a));)a=this.getRandomEmptyWindowId();const u=this.getBackupPath(a);try{await y.Promises.rename(c,u)}catch(s){return this.logService.error(`Backup: Could not rename backup folder: ${s.toString()}`),!1}return this.emptyWindows.push({backupFolder:a}),!0}convertToEmptyWindowBackupSync(c){let a=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(s=>!!s.backupFolder&&this.backupPathComparer.isEqual(s.backupFolder,a));)a=this.getRandomEmptyWindowId();const u=this.getBackupPath(a);try{r.renameSync(c,u)}catch(s){return this.logService.error(`Backup: Could not rename backup folder: ${s.toString()}`),!1}return this.emptyWindows.push({backupFolder:a}),!0}async getDirtyWorkspaces(){const c=[];for(const a of this.workspaces)await this.hasBackups(a)&&c.push(a);for(const a of this.folders)await this.hasBackups(a)&&c.push(a);return c}hasBackups(c){let a;return(0,b.isEmptyWindowBackupInfo)(c)?a=c.backupFolder:(0,E.isFolderBackupInfo)(c)?a=this.getBackupPath(this.getFolderHash(c)):a=this.getBackupPath(c.workspace.id),this.doHasBackups(a)}async doHasBackups(c){try{const a=await y.Promises.readdir(c);for(const u of a)try{if((await y.Promises.readdir((0,P.join)(c,u))).length>0)return!0}catch{}}catch{}return!1}saveSync(){try{(0,y.writeFileSync)(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(c){this.logService.error(`Backup: Could not save workspaces.json: ${c.toString()}`)}}async save(){try{await y.Promises.writeFile(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(c){this.logService.error(`Backup: Could not save workspaces.json: ${c.toString()}`)}}serializeBackups(){return{rootURIWorkspaces:this.workspaces.map(c=>({id:c.workspace.id,configURIPath:c.workspace.configPath.toString(),remoteAuthority:c.remoteAuthority})),folderWorkspaceInfos:this.folders.map(c=>({folderUri:c.folderUri.toString(),remoteAuthority:c.remoteAuthority})),emptyWorkspaceInfos:this.emptyWindows}}getRandomEmptyWindowId(){return(Date.now()+Math.round(Math.random()*1e3)).toString()}getFolderHash(c){const a=c.folderUri;let u;return a.scheme===C.Schemas.file?u=I.isLinux?a.fsPath:a.fsPath.toLowerCase():u=a.toString().toLowerCase(),(0,p.createHash)("md5").update(u).digest("hex")}};v=fe([ie(0,S.IEnvironmentMainService),ie(1,m.IConfigurationService),ie(2,g.ILogService)],v),e.BackupMainService=v}),define(Z[226],x([0,1,9,4,106,58,2,3,36,57,161,224,24,178,20,35,18,7,8,17]),function(j,e,p,r,D,C,P,I,d,f,y,b,m,S,t,g,E,v,k,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serve=e.Driver=void 0;function a(l){return l<21}let u=class{constructor(n,i,o,h,w,M){this.windowServer=n,this.options=i,this.windowsMainService=o,this.lifecycleMainService=h,this.fileService=w,this.environmentMainService=M,this.registeredWindowIds=new Set,this.reloadingWindowIds=new Set,this.onDidReloadingChange=new r.Emitter}async registerWindowDriver(n){return this.registeredWindowIds.add(n),this.reloadingWindowIds.delete(n),this.onDidReloadingChange.fire(),this.options}async reloadWindowDriver(n){this.reloadingWindowIds.add(n)}async getWindowIds(){return this.windowsMainService.getWindows().map(n=>n.id).filter(n=>this.registeredWindowIds.has(n)&&!this.reloadingWindowIds.has(n))}async capturePage(n){await this.whenUnfrozen(n);const i=this.windowsMainService.getWindowById(n);if(!i?.win)throw new Error("Invalid window");return(await i.win.webContents.capturePage()).toPNG().toString("base64")}async startTracing(n,i){}async stopTracing(n,i,o){if(!o)return;const h=await this.capturePage(n),w=Buffer.from(h,"base64");await this.fileService.writeFile(v.URI.file((0,k.join)(this.environmentMainService.logsPath,`${i}.png`)),c.VSBuffer.wrap(w))}async reloadWindow(n){await this.whenUnfrozen(n);const i=this.windowsMainService.getWindowById(n);if(!i)throw new Error("Invalid window");this.reloadingWindowIds.add(n),this.lifecycleMainService.reload(i)}exitApplication(){return this.lifecycleMainService.quit()}async dispatchKeybinding(n,i){await this.whenUnfrozen(n);const o=D.KeybindingParser.parseUserBinding(i);for(let h of o)await this._dispatchKeybinding(n,h)}async _dispatchKeybinding(n,i){if(i instanceof C.ScanCodeBinding)throw new Error("ScanCodeBindings not supported");const o=this.windowsMainService.getWindowById(n);if(!o?.win)throw new Error("Invalid window");const h=o.win.webContents,w=new C.SimpleKeybinding(!1,!1,!1,!1,i.keyCode),A=new S.USLayoutResolvedKeybinding(w.toChord(),I.OS).getElectronAccelerator(),R=[];i.ctrlKey&&R.push("ctrl"),i.metaKey&&R.push("meta"),i.shiftKey&&R.push("shift"),i.altKey&&R.push("alt"),h.sendInputEvent({type:"keyDown",keyCode:A,modifiers:R}),a(i.keyCode)||h.sendInputEvent({type:"char",keyCode:A,modifiers:R}),h.sendInputEvent({type:"keyUp",keyCode:A,modifiers:R}),await(0,p.timeout)(100)}async click(n,i,o,h){await(await this.getWindowDriver(n)).click(i,o,h)}async doubleClick(n,i){await(await this.getWindowDriver(n)).doubleClick(i)}async setValue(n,i,o){await(await this.getWindowDriver(n)).setValue(i,o)}async getTitle(n){return await(await this.getWindowDriver(n)).getTitle()}async isActiveElement(n,i){return await(await this.getWindowDriver(n)).isActiveElement(i)}async getElements(n,i,o){return await(await this.getWindowDriver(n)).getElements(i,o)}async getElementXY(n,i,o,h){return await(await this.getWindowDriver(n)).getElementXY(i,o,h)}async typeInEditor(n,i,o){await(await this.getWindowDriver(n)).typeInEditor(i,o)}async getTerminalBuffer(n,i){return await(await this.getWindowDriver(n)).getTerminalBuffer(i)}async writeInTerminal(n,i,o){await(await this.getWindowDriver(n)).writeInTerminal(i,o)}async getLocaleInfo(n){return await(await this.getWindowDriver(n)).getLocaleInfo()}async getLocalizedStrings(n){return await(await this.getWindowDriver(n)).getLocalizedStrings()}async getWindowDriver(n){await this.whenUnfrozen(n);const i=`window:${n}`,o=new d.StaticRouter(w=>w===i),h=this.windowServer.getChannel("windowDriver",o);return new y.WindowDriverChannelClient(h)}async whenUnfrozen(n){for(;this.reloadingWindowIds.has(n);)await r.Event.toPromise(this.onDidReloadingChange.event)}};u=fe([ie(2,g.IWindowsMainService),ie(3,t.ILifecycleMainService),ie(4,E.IFileService),ie(5,m.IEnvironmentMainService)],u),e.Driver=u;async function s(l,n,i,o){const h=i.driverVerbose,w=o.createInstance(u,l,{verbose:h}),M=new b.WindowDriverRegistryChannel(w);l.registerChannel("windowDriverRegistry",M);const A=await(0,f.serve)(n),R=new b.DriverChannel(w);return A.registerChannel("driver",R),(0,P.combinedDisposable)(A,l)}e.serve=s}),define(Z[227],x([0,1,61,57]),function(j,e,p,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(D,C,P,I,d){const f=b=>d(b,void 0),y=p.createConnection({host:D,port:C},()=>{y.removeListener("error",f);const b=Buffer.alloc(16);for(let g=0;g<16;g++)b[g]=Math.round(Math.random()*256);const m=b.toString("base64"),S=[`GET ws://${/:/.test(D)?`[${D}]`:D}:${C}/?${P}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${m}`];y.write(S.join(`\r
`)+`\r
\r
`);const t=g=>{g.toString().indexOf(`\r
\r
`)>=0&&(y.off("data",t),d(void 0,new r.NodeSocket(y,I)))};y.on("data",t)});y.setNoDelay(!0),y.once("error",f)}}}),define(Z[228],x([0,1,61,117,227,9,2,19,6,22,194,96,76]),function(j,e,p,r,D,C,P,I,d,f,y,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function S(k,c,a,u,s){let l;for(let n=3;n&&(l&&l.dispose(),l=await new t(k,c,a,u,s).waitForReady(),!(s&&r.BROWSER_RESTRICTED_PORTS[s]||!r.BROWSER_RESTRICTED_PORTS[l.tunnelLocalPort]));n--);return l}class t extends P.Disposable{constructor(c,a,u,s,l){super();this.defaultTunnelHost=a,this.suggestedLocalPort=l,this.privacy=b.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=c,this._server=p.createServer(),this._barrier=new C.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=n=>this._onConnection(n),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=s,this.tunnelRemoteHost=u}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(a=>{a()})}async waitForReady(){let c=await(0,r.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),a=null;return this._server.listen(c,this.defaultTunnelHost),await this._barrier.wait(),a=this._server.address(),a||(c=0,this._server.listen(c,this.defaultTunnelHost),await this._barrier.wait(),a=this._server.address()),this.tunnelLocalPort=a.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${a.port}`,this}async _onConnection(c){c.pause();const a=(0,b.isLocalhost)(this.tunnelRemoteHost)||(0,b.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,u=await(0,y.connectRemoteAgentTunnel)(this._options,a,this.tunnelRemotePort),s=u.getSocket().socket,l=u.readEntireBuffer();u.dispose(),l.byteLength>0&&c.write(l.buffer),c.on("end",()=>{this._socketsDispose.delete(c.localAddress),s.end()}),c.on("close",()=>s.end()),c.on("error",()=>{this._socketsDispose.delete(c.localAddress),s.destroy()}),s.on("end",()=>c.end()),s.on("close",()=>c.end()),s.on("error",()=>{c.destroy()}),c.pipe(s),s.pipe(c),this._socketsDispose.set(c.localAddress,()=>{c.end(),s.end()})}}let g=class extends b.AbstractTunnelService{constructor(c,a,u,s,l){super(a);this.socketFactory=c,this.signService=u,this.productService=s,this.configurationService=l}get defaultTunnelHost(){const c=this.configurationService.getValue("remote.localPortHost");return!c||c==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(c,a,u,s,l,n,i){const o=this.getTunnelFromMap(a,u);if(o)return++o.refcount,o.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,a,u,s,l,n,i);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${a}:${u} on local port ${s}.`);const h={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:c,signService:this.signService,logService:this.logService,ipcLogger:null},w=S(h,this.defaultTunnelHost,a,u,s);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(a,u,w),w}}};g=fe([ie(1,d.ILogService),ie(2,m.ISignService),ie(3,f.IProductService),ie(4,I.IConfigurationService)],g),e.BaseTunnelService=g;let E=class extends g{constructor(c,a,u,s){super(D.nodeSocketFactory,c,a,u,s)}};E=fe([ie(0,d.ILogService),ie(1,m.ISignService),ie(2,f.IProductService),ie(3,I.IConfigurationService)],E),e.TunnelService=E;let v=class extends P.Disposable{constructor(c,a,u,s){super();this.logService=c,this.productService=a,this.signService=u,this.configurationService=s,this._tunnelServices=new Map}async openTunnel(c,a,u,s,l,n,i,o){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${u}:${s} on local port ${l}.`),!this._tunnelServices.has(c)){const h=new E(this.logService,this.signService,this.productService,this.configurationService);this._register(h),this._tunnelServices.set(c,h),h.onTunnelClosed(async()=>{(await h.tunnels).length===0&&(h.dispose(),this._tunnelServices.delete(c))})}return this._tunnelServices.get(c).openTunnel(a,u,s,l,n,i,o)}};v=fe([ie(0,d.ILogService),ie(1,f.IProductService),ie(2,m.ISignService),ie(3,I.IConfigurationService)],v),e.SharedTunnelsService=v}),define(Z[229],x([0,1,198,9,17,16,2,13,19,48,90,6,197,223]),function(j,e,p,r,D,C,P,I,d,f,y,b,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let t=class extends P.Disposable{constructor(E,v,k){super();this.environmentService=v,this.logService=k,this.configure(E.getValue()),this._register(E.onDidChangeConfiguration(()=>this.configure(E.getValue()),this))}configure(E){this.proxyUrl=E.http&&E.http.proxy,this.strictSSL=!!(E.http&&E.http.proxyStrictSSL),this.authorization=E.http&&E.http.proxyAuthorization}async request(E,v){this.logService.trace("RequestService#request",E.url);const{proxyUrl:k,strictSSL:c}=this;let a;try{a=await(0,y.getResolvedShellEnv)(this.logService,this.environmentService.args,process.env)}catch(l){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("RequestService#request resolving shell environment failed",l))}const u={...process.env,...a},s=E.agent?E.agent:await(0,m.getProxyAgent)(E.url||"",u,{proxyUrl:k,strictSSL:c});return E.agent=s,E.strictSSL=c,this.authorization&&(E.headers={...E.headers||{},"Proxy-Authorization":this.authorization}),this._request(E,v)}async getNodeRequest(E){return((0,p.parse)(E.url).protocol==="https:"?await new Promise((c,a)=>{j(["https"],c,a)}):await new Promise((c,a)=>{j(["http"],c,a)})).request}_request(E,v){return r.Promises.withAsyncBody(async(k,c)=>{let a;const u=(0,p.parse)(E.url),s=E.getRawRequest?E.getRawRequest(E):await this.getNodeRequest(E),l={hostname:u.hostname,port:u.port?parseInt(u.port):u.protocol==="https:"?443:80,protocol:u.protocol,path:u.path,method:E.type||"GET",headers:E.headers,agent:E.agent,rejectUnauthorized:(0,I.isBoolean)(E.strictSSL)?E.strictSSL:!0};E.user&&E.password&&(l.auth=E.user+":"+E.password),a=s(l,n=>{const i=(0,I.isNumber)(E.followRedirects)?E.followRedirects:3;if(n.statusCode&&n.statusCode>=300&&n.statusCode<400&&i>0&&n.headers.location)this._request({...E,url:n.headers.location,followRedirects:i-1},v).then(k,c);else{let o=n;n.headers["content-encoding"]==="gzip"&&(o=n.pipe((0,S.createGunzip)())),k({res:n,stream:(0,D.streamToBufferReadableStream)(o)})}}),a.on("error",c),E.timeout&&a.setTimeout(E.timeout),E.data&&typeof E.data=="string"&&a.write(E.data),a.end(),v.onCancellationRequested(()=>{a.abort(),c((0,C.canceled)())})})}async resolveProxy(E){}};t=fe([ie(0,d.IConfigurationService),ie(1,f.INativeEnvironmentService),ie(2,b.ILogService)],t),e.RequestService=t}),define(Z[230],x([0,1,14,229]),function(j,e,p,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function D(P){return p.net.request}class C extends r.RequestService{request(I,d){return super.request({...I||{},getRawRequest:D},d)}}e.RequestMainService=C}),define(Z[231],x([0,1,14,9,4,2,10,13,85,24,20,6,54,55,66,44]),function(j,e,p,r,D,C,P,I,d,f,y,b,m,S,t,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let E=class extends C.Disposable{constructor(k,c,a,u,s,l,n){super();this.machineId=k,this.userEnv=c,this.environmentMainService=a,this.lifecycleMainService=u,this.logService=s,this.themeMainService=l,this.protocolMainService=n,this.firstWindowConnectionBarrier=new r.Barrier,this.window=void 0,this.windowCloseListener=void 0,this._onDidError=this._register(new D.Emitter),this.onDidError=D.Event.buffer(this._onDidError.event),this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){p.ipcMain.on("vscode:createSharedProcessMessageChannel",(k,c)=>this.onWindowConnection(k,c)),p.ipcMain.on("vscode:relaySharedProcessWorkerMessageChannel",(k,c)=>this.onWorkerConnection(k,c)),this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown()))}async onWindowConnection(k,c){this.logService.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const a=await this.connect();if(k.sender.isDestroyed())return a.close();k.sender.postMessage("vscode:createSharedProcessMessageChannelResult",c,[a])}onWorkerConnection(k,c){this.logService.trace("SharedProcess: onWorkerConnection",c);const a=new C.DisposableStore,u=l=>{!this.isAlive()||(this.logService.trace(`SharedProcess: disposing worker (reason: '${l}')`,c),a.dispose(),this.send("vscode:electron-main->shared-process=disposeWorker",c))},s=p.BrowserWindow.fromId(c.reply.windowId);if(!s||s.isDestroyed()||s.webContents.isDestroyed()||!c.reply.channel){u("unavailable");return}a.add(D.Event.filter(this.lifecycleMainService.onWillLoadWindow,l=>l.window.win===s)(()=>u("load"))),a.add(D.Event.fromNodeEventEmitter(s,"closed")(()=>u("closed"))),s.webContents.postMessage(c.reply.channel,c.reply.nonce,k.ports)}onWillShutdown(){const k=this.window;!k||(this.send("vscode:electron-main->shared-process=exit"),this.windowCloseListener&&(k.removeListener("close",this.windowCloseListener),this.windowCloseListener=void 0),setTimeout(()=>{try{k.close()}catch{}this.window=void 0},0))}send(k,...c){if(!this.isAlive()){this.logService.warn(`Sending IPC message to channel '${k}' for shared process window that is destroyed`);return}try{this.window?.webContents.send(k,...c)}catch(a){this.logService.warn(`Error sending IPC message to channel '${k}' of shared process: ${(0,g.toErrorMessage)(a)}`)}}whenReady(){return this._whenReady||(this._whenReady=new Promise(k=>p.ipcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.logService.trace("SharedProcess: Overall ready"),k()}))),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.createWindow(),this.registerWindowListeners(),await new Promise(k=>p.ipcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.logService.trace("SharedProcess: IPC ready"),k()}))})()),this._whenIpcReady}createWindow(){const k=this._register(this.protocolMainService.createIPCObjectUrl());this.window=new p.BrowserWindow({show:!1,backgroundColor:this.themeMainService.getBackgroundColor(),webPreferences:{preload:P.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",j).fsPath,additionalArguments:[`--vscode-window-config=${k.resource.toString()}`,"--vscode-window-kind=shared-process"],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",nodeIntegration:!0,nodeIntegrationInWorker:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,images:!1,webgl:!1}}),k.update({machineId:this.machineId,windowId:this.window.id,appRoot:this.environmentMainService.appRoot,codeCachePath:this.environmentMainService.codeCachePath,backupWorkspacesPath:this.environmentMainService.backupWorkspacesPath,userEnv:this.userEnv,args:this.environmentMainService.args,logLevel:this.logService.getLevel(),product:m.default}),this.window.loadURL(P.FileAccess.asBrowserUri("vs/code/electron-browser/sharedProcess/sharedProcess.html",j).toString(!0))}registerWindowListeners(){!this.window||(this.windowCloseListener=k=>{this.logService.trace("SharedProcess#close prevented"),k.preventDefault(),this.window?.isVisible()&&this.window.hide()},this.window.on("close",this.windowCloseListener),this.window.webContents.on("render-process-gone",(k,c)=>this._onDidError.fire({type:2,details:c})),this.window.on("unresponsive",()=>this._onDidError.fire({type:1})),this.window.webContents.on("did-fail-load",(k,c,a)=>this._onDidError.fire({type:3,details:{reason:a,exitCode:c}})))}async connect(){await this.whenIpcReady;const k=(0,I.assertIsDefined)(this.window);return(0,d.connect)(k)}async toggle(){await this.whenIpcReady,!!this.window&&(this.window.isVisible()?(this.window.webContents.closeDevTools(),this.window.hide()):(this.window.show(),this.window.webContents.openDevTools()))}isVisible(){return this.window?.isVisible()??!1}isAlive(){const k=this.window;return k?!k.isDestroyed()&&!k.webContents.isDestroyed():!1}};E=fe([ie(2,f.IEnvironmentMainService),ie(3,y.ILifecycleMainService),ie(4,b.ILogService),ie(5,t.IThemeMainService),ie(6,S.IProtocolMainService)],E),e.SharedProcess=E}),define(Z[232],x([0,1,9,17,8,13,7,24,18,6]),function(j,e,p,r,D,C,P,I,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateMainService=e.FileStorage=void 0;class y{constructor(S,t,g){this.storagePath=S,this.logService=t,this.fileService=g,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=new p.ThrottledDelayer(100),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(S){S.fileOperationResult!==1&&this.logService.error(S)}}getItem(S,t){const g=this.storage[S];return(0,C.isUndefinedOrNull)(g)?t:g}setItem(S,t){this.setItems([{key:S,data:t}])}setItems(S){let t=!1;for(const{key:g,data:E}of S)this.storage[g]!==E&&((0,C.isUndefinedOrNull)(E)?(0,C.isUndefined)(this.storage[g])||(this.storage[g]=void 0,t=!0):(this.storage[g]=E,t=!0));t&&this.save()}removeItem(S){(0,C.isUndefined)(this.storage[S])||(this.storage[S]=void 0,this.save())}async save(S){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave(),S)}async doSave(){if(!this.initializing)return;await this.initializing;const S=JSON.stringify(this.storage,null,4);if(S!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,r.VSBuffer.fromString(S)),this.lastSavedStorageContents=S}catch(t){this.logService.error(t)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=y;let b=class It{constructor(S,t,g){this.fileStorage=new y(P.URI.file((0,D.join)(S.userDataPath,It.STATE_FILE)),t,g)}async init(){return this.fileStorage.init()}getItem(S,t){return this.fileStorage.getItem(S,t)}setItem(S,t){this.fileStorage.setItem(S,t)}setItems(S){this.fileStorage.setItems(S)}removeItem(S){this.fileStorage.removeItem(S)}close(){return this.fileStorage.close()}};b.STATE_FILE="storage.json",b=fe([ie(0,I.IEnvironmentMainService),ie(1,f.ILogService),ie(2,d.IFileService)],b),e.StateMainService=b}),define(Z[77],x([0,1,9,23,4,19,24,20,6,22,49,41]),function(j,e,p,r,D,C,P,I,d,f,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function m(t,g,E){return`${E.updateUrl}/api/update/${t}/${g}/${E.commit}`}e.createUpdateURL=m;let S=class{constructor(g,E,v,k,c,a){this.lifecycleMainService=g,this.configurationService=E,this.environmentMainService=v,this.requestService=k,this.logService=c,this.productService=a,this._state=b.State.Uninitialized,this._onStateChange=new D.Emitter,this.onStateChange=this._onStateChange.event}get state(){return this._state}setState(g){this.logService.info("update#setState",g.type),this._state=g,this._onStateChange.fire(g)}initialize(){if(!this.environmentMainService.isBuilt)return;if(this.environmentMainService.disableUpdates){this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const g=this.getUpdateMode(),E=this.getProductQuality(g);if(!E){this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(E),!this.url){this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(b.State.Idle(this.getUpdateType())),g==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}g==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,v=>this.logService.error(v))}getUpdateMode(){return(0,C.getMigratedSettingValue)(this.configurationService,"update.mode","update.channel")}getProductQuality(g){return g==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(g=60*60*1e3){return(0,p.timeout)(g).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(g){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(g)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(g){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(g=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${g}`),!g&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}async isLatestVersion(){if(this.url){if(this.getUpdateMode()==="none")return!1}else return;return(await this.requestService.request({url:this.url},r.CancellationToken.None)).res.statusCode===204}getUpdateType(){return 1}doQuitAndInstall(){}};S=fe([ie(0,I.ILifecycleMainService),ie(1,C.IConfigurationService),ie(2,P.IEnvironmentMainService),ie(3,y.IRequestService),ie(4,d.ILogService),ie(5,f.IProductService)],S),e.AbstractUpdateService=S}),define(Z[233],x([0,1,14,46,4,2,19,24,20,6,22,49,28,41,77]),function(j,e,p,r,D,C,P,I,d,f,y,b,m,S,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let g=class extends t.AbstractUpdateService{constructor(v,k,c,a,u,s,l){super(v,k,a,u,s,l);this.telemetryService=c,this.disposables=new C.DisposableStore}get onRawError(){return D.Event.fromNodeEventEmitter(p.autoUpdater,"error",(v,k)=>k)}get onRawUpdateNotAvailable(){return D.Event.fromNodeEventEmitter(p.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return D.Event.fromNodeEventEmitter(p.autoUpdater,"update-available",(v,k,c)=>({url:k,version:c,productVersion:c}))}get onRawUpdateDownloaded(){return D.Event.fromNodeEventEmitter(p.autoUpdater,"update-downloaded",(v,k,c,a)=>({releaseNotes:k,version:c,productVersion:c,date:a}))}initialize(){super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(v){this.logService.error("UpdateService error:",v);const c=(this.state.type==="checking for updates"?this.state.explicit:!0)?v:void 0;this.setState(S.State.Idle(1,c))}buildUpdateFeedUrl(v){let k;this.productService.darwinUniversalAssetId?k=this.productService.darwinUniversalAssetId:k=process.arch==="x64"?"darwin":"darwin-arm64";const c=(0,t.createUpdateURL)(k,v,this.productService);try{p.autoUpdater.setFeedURL({url:c})}catch(a){this.logService.error("Failed to set update feed URL",a);return}return c}doCheckForUpdates(v){this.setState(S.State.CheckingForUpdates(v)),p.autoUpdater.checkForUpdates()}onUpdateAvailable(v){this.state.type==="checking for updates"&&this.setState(S.State.Downloading(v))}onUpdateDownloaded(v){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:v.version}),this.setState(S.State.Ready(v)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(S.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),p.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};fe([r.memoize],g.prototype,"onRawError",null),fe([r.memoize],g.prototype,"onRawUpdateNotAvailable",null),fe([r.memoize],g.prototype,"onRawUpdateAvailable",null),fe([r.memoize],g.prototype,"onRawUpdateDownloaded",null),g=fe([ie(0,d.ILifecycleMainService),ie(1,P.IConfigurationService),ie(2,m.ITelemetryService),ie(3,I.IEnvironmentMainService),ie(4,b.IRequestService),ie(5,f.ILogService),ie(6,y.IProductService)],g),e.DarwinUpdateService=g}),define(Z[234],x([0,1,43,27,9,4,8,24,20,6,28,41]),function(j,e,p,r,D,C,P,I,d,f,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let m=class{constructor(g,E,v){if(this.lifecycleMainService=g,this.logService=v,this._state=b.State.Uninitialized,this._onStateChange=new C.Emitter,this.onStateChange=this._onStateChange.event,E.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(b.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,k=>this.logService.error(k))}get state(){return this._state}setState(g){this.logService.info("update#setState",g.type),this._state=g,this._onStateChange.fire(g)}scheduleCheckForUpdates(g=60*60*1e3){return(0,D.timeout)(g).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(g){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(g)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(g){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(g=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${g}`),!g&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}};m=fe([ie(0,d.ILifecycleMainService),ie(1,I.IEnvironmentMainService),ie(2,f.ILogService)],m);let S=class extends m{constructor(g,E,v,k,c,a){super(v,k,c);this.snap=g,this.snapRevision=E,this.telemetryService=a;const u=(0,r.watch)(P.dirname(this.snap)),s=C.Event.fromNodeEventEmitter(u,"change",(o,h)=>h),l=C.Event.filter(s,o=>o==="current"),i=C.Event.debounce(l,(o,h)=>h,2e3)(()=>this.checkForUpdates(!1));v.onWillShutdown(()=>{i.dispose(),u.close()})}doCheckForUpdates(){this.setState(b.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(g=>{g?this.setState(b.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(b.State.Idle(2)))},g=>{this.logService.error(g),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(b.State.Idle(2,g.message||g))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,p.spawn)("sleep 3 && "+P.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const g=await new Promise((v,k)=>(0,r.realpath)(`${P.dirname(this.snap)}/current`,(c,a)=>c?k(c):v(a))),E=P.basename(g);return this.snapRevision!==E}isLatestVersion(){return this.isUpdateAvailable().then(void 0,g=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};S=fe([ie(2,d.ILifecycleMainService),ie(3,I.IEnvironmentMainService),ie(4,f.ILogService),ie(5,y.ITelemetryService)],S),e.SnapUpdateService=S}),define(Z[45],x([0,1,14,27,4,38,33,2,10,8,3,15,13,21,158,52,50,24,5,6,22,100,29,101]),function(j,e,p,r,D,C,P,I,d,f,y,b,m,S,t,g,E,v,k,c,a,u,s,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,k.createDecorator)("workspacesManagementMainService");let n=class extends I.Disposable{constructor(o,h,w,M,A){super();this.environmentMainService=o,this.logService=h,this.backupMainService=w,this.dialogMainService=M,this.productService=A,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this._onDidDeleteUntitledWorkspace=this._register(new D.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new D.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event}resolveLocalWorkspaceSync(o){return this.doResolveLocalWorkspace(o,h=>(0,r.readFileSync)(h,"utf8"))}resolveLocalWorkspace(o){return this.doResolveLocalWorkspace(o,h=>S.Promises.readFile(h,"utf8"))}doResolveLocalWorkspace(o,h){if(!!this.isWorkspacePath(o)&&o.scheme===d.Schemas.file)try{const w=h(o.fsPath);return w instanceof Promise?w.then(M=>this.doResolveWorkspace(o,M),M=>{}):this.doResolveWorkspace(o,w)}catch{return}}isWorkspacePath(o){return(0,s.isUntitledWorkspace)(o,this.environmentMainService)||(0,s.hasWorkspaceFileExtension)(o)}doResolveWorkspace(o,h){try{const w=this.doParseStoredWorkspace(o,h),M=(0,l.getWorkspaceIdentifier)(o);return{id:M.id,configPath:M.configPath,folders:(0,s.toWorkspaceFolders)(w.folders,M.configPath,b.extUriBiasedIgnorePathCase),remoteAuthority:w.remoteAuthority,transient:w.transient}}catch(w){this.logService.warn(w.toString())}}doParseStoredWorkspace(o,h){const w=(0,C.parse)(h);if(w&&Array.isArray(w.folders))w.folders=w.folders.filter(M=>(0,s.isStoredWorkspaceFolder)(M));else throw new Error(`${o.toString(!0)} looks like an invalid workspace file.`);return w}async createUntitledWorkspace(o,h){const{workspace:w,storedWorkspace:M}=this.newUntitledWorkspace(o,h),A=w.configPath.fsPath;return await S.Promises.mkdir((0,f.dirname)(A),{recursive:!0}),await S.Promises.writeFile(A,JSON.stringify(M,null,"	")),w}createUntitledWorkspaceSync(o,h){const{workspace:w,storedWorkspace:M}=this.newUntitledWorkspace(o,h),A=w.configPath.fsPath;return(0,r.mkdirSync)((0,f.dirname)(A),{recursive:!0}),(0,S.writeFileSync)(A,JSON.stringify(M,null,"	")),w}newUntitledWorkspace(o=[],h){const w=(Date.now()+Math.round(Math.random()*1e3)).toString(),M=(0,b.joinPath)(this.untitledWorkspacesHome,w),A=(0,b.joinPath)(M,s.UNTITLED_WORKSPACE_NAME),R=[];for(const T of o)R.push((0,s.getStoredWorkspaceFolder)(T.uri,!0,T.name,M,!y.isWindows,b.extUriBiasedIgnorePathCase));return{workspace:(0,l.getWorkspaceIdentifier)(A),storedWorkspace:{folders:R,remoteAuthority:h}}}async getWorkspaceIdentifier(o){return(0,l.getWorkspaceIdentifier)(o)}isUntitledWorkspace(o){return(0,s.isUntitledWorkspace)(o.configPath,this.environmentMainService)}deleteUntitledWorkspaceSync(o){!this.isUntitledWorkspace(o)||(this.doDeleteUntitledWorkspaceSync(o),this._onDidDeleteUntitledWorkspace.fire(o))}async deleteUntitledWorkspace(o){this.deleteUntitledWorkspaceSync(o)}doDeleteUntitledWorkspaceSync(o){const h=(0,b.originalFSPath)(o.configPath);try{(0,S.rimrafSync)((0,f.dirname)(h));const w=(0,f.join)(this.environmentMainService.workspaceStorageHome.fsPath,o.id);(0,r.existsSync)(w)&&(0,S.writeFileSync)((0,f.join)(w,"obsolete"),"")}catch(w){this.logService.warn(`Unable to delete untitled workspace ${h} (${w}).`)}}getUntitledWorkspacesSync(){const o=[];try{const h=(0,S.readdirSync)(this.untitledWorkspacesHome.fsPath).map(w=>(0,b.joinPath)(this.untitledWorkspacesHome,w,s.UNTITLED_WORKSPACE_NAME));for(const w of h){const M=(0,l.getWorkspaceIdentifier)(w),A=this.resolveLocalWorkspaceSync(w);A?o.push({workspace:M,remoteAuthority:A.remoteAuthority}):this.doDeleteUntitledWorkspaceSync(M)}}catch(h){h.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${h}).`)}return o}async enterWorkspace(o,h,w){if(!o||!o.win||!o.isReady||!await this.isValidTargetWorkspacePath(o,h,w))return;const A=this.doEnterWorkspace(o,(0,l.getWorkspaceIdentifier)(w));if(!!A)return this._onDidEnterWorkspace.fire({window:o,workspace:A.workspace}),A}async isValidTargetWorkspacePath(o,h,w){if(!w)return!0;if((0,s.isWorkspaceIdentifier)(o.openedWorkspace)&&b.extUriBiasedIgnorePathCase.isEqual(o.openedWorkspace.configPath,w))return!1;if((0,u.findWindowOnWorkspaceOrFolder)(h,w)){const M={title:this.productService.nameLong,type:"info",buttons:[(0,P.mnemonicButtonLabel)((0,t.localize)(0,null))],message:(0,t.localize)(1,null,(0,b.basename)(w)),detail:(0,t.localize)(2,null),noLink:!0,defaultId:0};return await this.dialogMainService.showMessageBox(M,(0,m.withNullAsUndefined)(p.BrowserWindow.getFocusedWindow())),!1}return!0}doEnterWorkspace(o,h){if(!o.config)return;o.focus();let w;return o.config.extensionDevelopmentPath||(w=this.backupMainService.registerWorkspaceBackupSync({workspace:h,remoteAuthority:o.remoteAuthority},o.config.backupPath)),(0,s.isWorkspaceIdentifier)(o.openedWorkspace)&&this.isUntitledWorkspace(o.openedWorkspace)&&this.deleteUntitledWorkspaceSync(o.openedWorkspace),o.config.workspace=h,o.config.backupPath=w,{workspace:h,backupPath:w}}};n=fe([ie(0,v.IEnvironmentMainService),ie(1,c.ILogService),ie(2,g.IBackupMainService),ie(3,E.IDialogMainService),ie(4,a.IProductService)],n),e.WorkspacesManagementMainService=n}),define(Z[102],x([0,1,14,30,23,3,13,7,21,19,53,5,6,98,35,29,45]),function(j,e,p,r,D,C,P,I,d,f,y,b,m,S,t,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,b.createDecorator)(e.ID);let v=class{constructor(c,a,u,s,l){this.logService=c,this.windowsMainService=a,this.urlService=u,this.workspacesManagementMainService=s,this.configurationService=l}async start(c,a){this.logService.trace("Received data from other instance: ",c,a),C.isMacintosh&&p.app.focus({steal:!0});const u=this.parseOpenUrl(c);if(u.length){let s=Promise.resolve();this.windowsMainService.getWindowCount()===0&&(s=this.windowsMainService.openEmptyWindow({context:4})[0].ready()),s.then(()=>{for(const{uri:l,url:n}of u)this.urlService.open(l,{originalUrl:n})})}else return this.startOpenWindow(c,a)}parseOpenUrl(c){return c["open-url"]&&c._urls&&c._urls.length>0?(0,r.coalesce)(c._urls.map(a=>{try{return{uri:I.URI.parse(a),url:a}}catch{return null}})):[]}async startOpenWindow(c,a){const u=(0,y.isLaunchedFromCli)(a)?0:4;let s=[];const l=c.wait&&c.waitMarkerFilePath?I.URI.file(c.waitMarkerFilePath):void 0,n=c.remote||void 0,i={context:u,cli:c,userEnv:a,waitMarkerFileURI:l,remoteAuthority:n};if(c.extensionDevelopmentPath)this.windowsMainService.openExtensionDevelopmentHostWindow(c.extensionDevelopmentPath,i);else if(!c._.length&&!c["folder-uri"]&&!c["file-uri"]){let o=!1;if(c["new-window"]||c["unity-launch"])o=!0;else if(c["reuse-window"])o=!1;else switch(this.configurationService.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":o=!0;break;case"off":o=!1;break;default:o=!C.isMacintosh}if(o)s=this.windowsMainService.open({...i,forceNewWindow:!0,forceEmpty:!0});else{const h=this.windowsMainService.getLastActiveWindow();h?(this.windowsMainService.openExistingWindow(h,i),s=[h]):s=this.windowsMainService.open({...i,forceEmpty:!0})}}else s=this.windowsMainService.open({...i,forceNewWindow:c["new-window"],preferNewWindow:!c["reuse-window"]&&!c.wait,forceReuseWindow:c["reuse-window"],diffMode:c.diff,addMode:c.add,noRecentEntry:!!c["skip-add-to-recently-opened"],gotoLineMode:c.goto});if(l&&s.length===1&&s[0])return Promise.race([s[0].whenClosedOrLoaded,(0,d.whenDeleted)(l.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}async getMainProcessInfo(){this.logService.trace("Received request for main process info from other instance.");const c=[];return p.BrowserWindow.getAllWindows().forEach(a=>{const u=this.windowsMainService.getWindowById(a.id);u?c.push(this.codeWindowToInfo(u)):c.push(this.browserWindowToInfo(a))}),{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:c,screenReader:!!p.app.accessibilitySupportEnabled,gpuFeatureStatus:p.app.getGPUFeatureStatus()}}async getRemoteDiagnostics(c){const a=this.windowsMainService.getWindows();return(await Promise.all(a.map(s=>new Promise(l=>{const n=s.remoteAuthority;if(n){const i=`vscode:getDiagnosticInfoResponse${s.id}`,o={includeProcesses:c.includeProcesses,folders:c.includeWorkspaceMetadata?this.getFolderURIs(s):void 0};s.sendWhenReady("vscode:getDiagnosticInfo",D.CancellationToken.None,{replyChannel:i,args:o}),p.ipcMain.once(i,(h,w)=>{w||l({hostName:n,errorMessage:`Unable to resolve connection to '${n}'.`}),l(w)}),setTimeout(()=>{l({hostName:n,errorMessage:`Fetching remote diagnostics for '${n}' timed out.`})},5e3)}else l(void 0)})))).filter(s=>!!s)}getFolderURIs(c){const a=[],u=c.openedWorkspace;if((0,g.isSingleFolderWorkspaceIdentifier)(u))a.push(u.uri);else if((0,g.isWorkspaceIdentifier)(u)){const s=this.workspacesManagementMainService.resolveLocalWorkspaceSync(u.configPath);s&&s.folders.forEach(n=>{a.push(n.uri)})}return a}codeWindowToInfo(c){const a=this.getFolderURIs(c),u=(0,P.assertIsDefined)(c.win);return this.browserWindowToInfo(u,a,c.remoteAuthority)}browserWindowToInfo(c,a=[],u){return{pid:c.webContents.getOSProcessId(),title:c.getTitle(),folderURIs:a,remoteAuthority:u}}};v=fe([ie(0,m.ILogService),ie(1,t.IWindowsMainService),ie(2,S.IURLService),ie(3,E.IWorkspacesManagementMainService),ie(4,f.IConfigurationService)],v),e.LaunchMainService=v}),define(Z[51],x([0,1,43,14,26,116,46,4,33,2,10,8,3,7,82,71,21,150,50,24,5,20,6,22,28,66,35,29,45]),function(j,e,p,r,D,C,P,I,d,f,y,b,m,S,t,g,E,v,k,c,a,u,s,l,n,i,o,h,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,a.createDecorator)("nativeHostMainService");let M=class ft extends f.Disposable{constructor(R,T,_,Q,ne,oe,X,O,H,q){super();this.sharedProcess=R,this.windowsMainService=T,this.dialogMainService=_,this.lifecycleMainService=Q,this.environmentMainService=ne,this.telemetryService=oe,this.logService=X,this.productService=O,this.themeMainService=H,this.workspacesManagementMainService=q,this.onDidOpenWindow=I.Event.map(this.windowsMainService.onDidOpenWindow,Y=>Y.id),this.onDidMaximizeWindow=I.Event.filter(I.Event.fromNodeEventEmitter(r.app,"browser-window-maximize",(Y,$)=>$.id),Y=>!!this.windowsMainService.getWindowById(Y)),this.onDidUnmaximizeWindow=I.Event.filter(I.Event.fromNodeEventEmitter(r.app,"browser-window-unmaximize",(Y,$)=>$.id),Y=>!!this.windowsMainService.getWindowById(Y)),this.onDidBlurWindow=I.Event.filter(I.Event.fromNodeEventEmitter(r.app,"browser-window-blur",(Y,$)=>$.id),Y=>!!this.windowsMainService.getWindowById(Y)),this.onDidFocusWindow=I.Event.any(I.Event.map(I.Event.filter(I.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),Y=>!!Y),Y=>Y.id),I.Event.filter(I.Event.fromNodeEventEmitter(r.app,"browser-window-focus",(Y,$)=>$.id),Y=>!!this.windowsMainService.getWindowById(Y))),this.onDidResumeOS=I.Event.fromNodeEventEmitter(r.powerMonitor,"resume"),this._onDidChangeColorScheme=this._register(new I.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,this._onDidChangePassword=this._register(new I.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=I.Event.debounce(I.Event.any(I.Event.filter(I.Event.fromNodeEventEmitter(r.screen,"display-metrics-changed",(Y,$,K)=>K),Y=>!(Array.isArray(Y)&&Y.length===1&&Y[0]==="workArea")),I.Event.fromNodeEventEmitter(r.screen,"display-added"),I.Event.fromNodeEventEmitter(r.screen,"display-removed")),()=>{},100),this.registerListeners()}registerListeners(){r.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire(this.osColorScheme)})}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map(T=>({id:T.id,workspace:T.openedWorkspace,title:T.win?.getTitle()??"",filename:T.getRepresentedFilename(),dirty:T.isDocumentEdited()}))}async getWindowCount(R){return this.windowsMainService.getWindowCount()}async getActiveWindowId(R){const T=r.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(T)return T.id}openWindow(R,T,_){return Array.isArray(T)?this.doOpenWindow(R,T,_):this.doOpenEmptyWindow(R,T)}async doOpenWindow(R,T,_=Object.create(null)){T.length>0&&this.windowsMainService.open({context:5,contextWindowId:R,urisToOpen:T,cli:this.environmentMainService.args,forceNewWindow:_.forceNewWindow,forceReuseWindow:_.forceReuseWindow,preferNewWindow:_.preferNewWindow,diffMode:_.diffMode,addMode:_.addMode,gotoLineMode:_.gotoLineMode,noRecentEntry:_.noRecentEntry,waitMarkerFileURI:_.waitMarkerFileURI,remoteAuthority:_.remoteAuthority||void 0})}async doOpenEmptyWindow(R,T){this.windowsMainService.openEmptyWindow({context:5,contextWindowId:R},T)}async toggleFullScreen(R){const T=this.windowById(R);T&&T.toggleFullScreen()}async handleTitleDoubleClick(R){const T=this.windowById(R);T&&T.handleTitleDoubleClick()}async isMaximized(R){const T=this.windowById(R);return T?.win?T.win.isMaximized():!1}async maximizeWindow(R){const T=this.windowById(R);T?.win&&T.win.maximize()}async unmaximizeWindow(R){const T=this.windowById(R);T?.win&&T.win.unmaximize()}async minimizeWindow(R){const T=this.windowById(R);T?.win&&T.win.minimize()}async focusWindow(R,T){T&&typeof T.windowId=="number"&&(R=T.windowId);const _=this.windowById(R);_&&_.focus({force:T?.force??!1})}async setMinimumSize(R,T,_){const Q=this.windowById(R);if(Q?.win){const[ne,oe]=Q.win.getSize(),[X,O]=Q.win.getMinimumSize(),[H,q]=[T??X,_??O],[Y,$]=[Math.max(ne,H),Math.max(oe,q)];(X!==H||O!==q)&&Q.win.setMinimumSize(H,q),(ne!==Y||oe!==$)&&Q.win.setSize(Y,$)}}async saveWindowSplash(R,T){this.themeMainService.saveWindowSplash(R,T)}async installShellCommand(R){const{source:T,target:_}=await this.getShellCommandLink();try{const{symbolicLink:Q}=await E.SymlinkSupport.stat(T);if(Q&&!Q.dangling){const ne=await(0,t.realpath)(T);if(_===ne)return}await E.Promises.unlink(T)}catch(Q){if(Q.code!=="ENOENT")throw Q}try{await E.Promises.symlink(_,T)}catch(Q){if(Q.code!=="EACCES"&&Q.code!=="ENOENT")throw Q;const{response:ne}=await this.showMessageBox(R,{title:this.productService.nameLong,type:"info",message:(0,v.localize)(0,null,this.productService.nameShort),buttons:[(0,d.mnemonicButtonLabel)((0,v.localize)(1,null)),(0,d.mnemonicButtonLabel)((0,v.localize)(2,null))],noLink:!0,defaultId:0,cancelId:1});if(ne===0)try{const oe=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${_}' '${T}'\\" with administrator privileges"`;await(0,C.promisify)(p.exec)(oe)}catch{throw new Error((0,v.localize)(3,null,T))}}}async uninstallShellCommand(R){const{source:T}=await this.getShellCommandLink();try{await E.Promises.unlink(T)}catch(_){switch(_.code){case"EACCES":const{response:Q}=await this.showMessageBox(R,{title:this.productService.nameLong,type:"info",message:(0,v.localize)(4,null,this.productService.nameShort),buttons:[(0,d.mnemonicButtonLabel)((0,v.localize)(5,null)),(0,d.mnemonicButtonLabel)((0,v.localize)(6,null))],noLink:!0,defaultId:0,cancelId:1});if(Q===0)try{const ne=`osascript -e "do shell script \\"rm '${T}'\\" with administrator privileges"`;await(0,C.promisify)(p.exec)(ne)}catch{throw new Error((0,v.localize)(7,null,T))}break;case"ENOENT":break;default:throw _}}}async getShellCommandLink(){const R=(0,b.resolve)(this.environmentMainService.appRoot,"bin","code"),T=`/usr/local/bin/${this.productService.applicationName}`;if(!await E.Promises.exists(R))throw new Error((0,v.localize)(8,null,R));return{source:T,target:R}}async showMessageBox(R,T){return this.dialogMainService.showMessageBox(T,this.toBrowserWindow(R))}async showSaveDialog(R,T){return this.dialogMainService.showSaveDialog(T,this.toBrowserWindow(R))}async showOpenDialog(R,T){return this.dialogMainService.showOpenDialog(T,this.toBrowserWindow(R))}toBrowserWindow(R){const T=this.windowById(R);if(T?.win)return T.win}async pickFileFolderAndOpen(R,T){const _=await this.dialogMainService.pickFileFolder(T);_&&(this.sendPickerTelemetry(_,T.telemetryEventName||"openFileFolder",T.telemetryExtraData),this.doOpenPicked(await Promise.all(_.map(async Q=>await E.SymlinkSupport.existsDirectory(Q)?{folderUri:S.URI.file(Q)}:{fileUri:S.URI.file(Q)})),T,R))}async pickFolderAndOpen(R,T){const _=await this.dialogMainService.pickFolder(T);_&&(this.sendPickerTelemetry(_,T.telemetryEventName||"openFolder",T.telemetryExtraData),this.doOpenPicked(_.map(Q=>({folderUri:S.URI.file(Q)})),T,R))}async pickFileAndOpen(R,T){const _=await this.dialogMainService.pickFile(T);_&&(this.sendPickerTelemetry(_,T.telemetryEventName||"openFile",T.telemetryExtraData),this.doOpenPicked(_.map(Q=>({fileUri:S.URI.file(Q)})),T,R))}async pickWorkspaceAndOpen(R,T){const _=await this.dialogMainService.pickWorkspace(T);_&&(this.sendPickerTelemetry(_,T.telemetryEventName||"openWorkspace",T.telemetryExtraData),this.doOpenPicked(_.map(Q=>({workspaceUri:S.URI.file(Q)})),T,R))}doOpenPicked(R,T,_){this.windowsMainService.open({context:3,contextWindowId:_,cli:this.environmentMainService.args,urisToOpen:R,forceNewWindow:T.forceNewWindow})}sendPickerTelemetry(R,T,_){const Q=R?R.length:0;this.telemetryService.publicLog(T,{..._,outcome:Q?"success":"canceled",numberOfPaths:Q})}async showItemInFolder(R,T){r.shell.showItemInFolder(T)}async setRepresentedFilename(R,T){const _=this.windowById(R);_&&_.setRepresentedFilename(T)}async setDocumentEdited(R,T){const _=this.windowById(R);_&&_.setDocumentEdited(T)}async openExternal(R,T){return m.isLinuxSnap?this.safeSnapOpenExternal(T):r.shell.openExternal(T),!0}safeSnapOpenExternal(R){const T=process.env.GDK_PIXBUF_MODULE_FILE,_=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,r.shell.openExternal(R),process.env.GDK_PIXBUF_MODULE_FILE=T,process.env.GDK_PIXBUF_MODULEDIR=_}moveItemToTrash(R,T){return r.shell.trashItem(T)}async isAdmin(){let R;return m.isWindows?R=(await new Promise((T,_)=>{j(["native-is-elevated"],T,_)}))():R=process.getuid()===0,R}async writeElevated(R,T,_,Q){const ne=await new Promise((oe,X)=>{j(["@vscode/sudo-prompt"],oe,X)});return new Promise((oe,X)=>{const O=[`"${this.cliPath}"`];Q?.unlock&&O.push("--file-chmod"),O.push("--file-write",`"${T.fsPath}"`,`"${_.fsPath}"`);const H={name:this.productService.nameLong.replace("-",""),icns:m.isMacintosh&&this.environmentMainService.isBuilt?(0,b.join)((0,b.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};ne.exec(O.join(" "),H,(q,Y,$)=>{Y&&this.logService.trace(`[sudo-prompt] received stdout: ${Y}`),$&&this.logService.trace(`[sudo-prompt] received stderr: ${$}`),q?X(q):oe(void 0)})})}get cliPath(){return m.isWindows?this.environmentMainService.isBuilt?(0,b.join)((0,b.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,b.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):m.isLinux?this.environmentMainService.isBuilt?(0,b.join)((0,b.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,b.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,b.join)(this.environmentMainService.appRoot,"bin","code"):(0,b.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,D.totalmem)(),freemem:(0,D.freemem)(),loadavg:(0,D.loadavg)()}}async getOSProperties(){return{arch:(0,D.arch)(),platform:(0,D.platform)(),release:(0,D.release)(),type:(0,D.type)(),cpus:(0,D.cpus)()}}async getOSVirtualMachineHint(){return g.virtualMachineHint.value()}get osColorScheme(){return{highContrast:r.nativeTheme.shouldUseInvertedColorScheme||r.nativeTheme.shouldUseHighContrastColors,dark:r.nativeTheme.shouldUseDarkColors}}async getOSColorScheme(){return this.osColorScheme}async killProcess(R,T,_){process.kill(T,_)}async readClipboardText(R,T){return r.clipboard.readText(T)}async writeClipboardText(R,T,_){return r.clipboard.writeText(T,_)}async readClipboardFindText(R){return r.clipboard.readFindText()}async writeClipboardFindText(R,T){return r.clipboard.writeFindText(T)}async writeClipboardBuffer(R,T,_,Q){return r.clipboard.writeBuffer(T,Buffer.from(_),Q)}async readClipboardBuffer(R,T){return r.clipboard.readBuffer(T)}async hasClipboard(R,T,_){return r.clipboard.has(T,_)}async newWindowTab(){this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){r.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){r.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){r.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){r.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){r.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(R,T){const _=this.windowById(R);_&&_.updateTouchBar(T)}async notifyReady(R){const T=this.windowById(R);T&&T.setReady()}async relaunch(R,T){return this.lifecycleMainService.relaunch(T)}async reload(R,T){const _=this.windowById(R);if(_){if((0,h.isWorkspaceIdentifier)(_.openedWorkspace)){const Q=_.openedWorkspace.configPath;if(Q.scheme===y.Schemas.file&&(await this.workspacesManagementMainService.resolveLocalWorkspace(Q))?.transient)return this.openWindow(_.id,{forceReuseWindow:!0})}return this.lifecycleMainService.reload(_,T?.disableExtensions!==void 0?{_:[],"disable-extensions":T.disableExtensions}:void 0)}}async closeWindow(R){this.closeWindowById(R,R)}async closeWindowById(R,T){const _=this.windowById(T);if(_?.win)return _.win.close()}async quit(R){const T=this.windowsMainService.getLastActiveWindow();T?.isExtensionDevelopmentHost&&this.windowsMainService.getWindowCount()>1&&T.win?T.win.close():this.lifecycleMainService.quit()}async exit(R,T){await this.lifecycleMainService.kill(T)}async resolveProxy(R,T){const Q=this.windowById(R)?.win?.webContents?.session;if(Q)return Q.resolveProxy(T)}async openDevTools(R,T){const _=this.windowById(R);_?.win&&_.win.webContents.openDevTools(T)}async toggleDevTools(R){const T=this.windowById(R);T?.win&&T.win.webContents.toggleDevTools()}async sendInputEvent(R,T){const _=this.windowById(R);_?.win&&(T.type==="mouseDown"||T.type==="mouseUp")&&_.win.webContents.sendInputEvent(T)}async toggleSharedProcessWindow(){return this.sharedProcess.toggle()}async windowsGetStringRegKey(R,T,_,Q){if(!m.isWindows)return;const ne=await new Promise((oe,X)=>{j(["vscode-windows-registry"],oe,X)});try{return ne.GetStringRegKey(T,_,Q)}catch{return}}async getPassword(R,T,_){const Q=await this.withKeytar(),ne=await Q.getPassword(T,_);if(ne)try{let{content:oe,hasNextChunk:X}=JSON.parse(ne);if(!oe||!X)return ne;let O=1;for(;X;){const H=await Q.getPassword(T,`${_}-${O}`),q=JSON.parse(H);oe+=q.content,X=q.hasNextChunk,O++}return oe}catch{return ne}return ne}async setPassword(R,T,_,Q){const ne=await this.withKeytar(),oe=3,X=async(O,H,q)=>{let Y=0,$;for(;Y<oe;)try{await ne.setPassword(O,H,q);return}catch(K){$=K,this.logService.warn("Error attempting to set a password: ",K),Y++,await new Promise(te=>setTimeout(te,200))}throw $};if(m.isWindows&&Q.length>ft.MAX_PASSWORD_LENGTH){let O=0,H=0,q=!0;for(;q;){const Y=Q.substring(O,O+ft.PASSWORD_CHUNK_SIZE);O+=ft.PASSWORD_CHUNK_SIZE,q=Q.length-O>0;const $={content:Y,hasNextChunk:q};await X(T,H?`${_}-${H}`:_,JSON.stringify($)),H++}}else await X(T,_,Q);this._onDidChangePassword.fire({service:T,account:_})}async deletePassword(R,T,_){const ne=await(await this.withKeytar()).deletePassword(T,_);return ne&&this._onDidChangePassword.fire({service:T,account:_}),ne}async findPassword(R,T){return(await this.withKeytar()).findPassword(T)}async findCredentials(R,T){return(await this.withKeytar()).findCredentials(T)}async withKeytar(){if(this.environmentMainService.disableKeytar)throw new Error("keytar has been disabled via --disable-keytar option");return await new Promise((R,T)=>{j(["keytar"],R,T)})}windowById(R){if(typeof R=="number")return this.windowsMainService.getWindowById(R)}};M.MAX_PASSWORD_LENGTH=2500,M.PASSWORD_CHUNK_SIZE=M.MAX_PASSWORD_LENGTH-100,fe([P.memoize],M.prototype,"cliPath",null),M=fe([ie(1,o.IWindowsMainService),ie(2,k.IDialogMainService),ie(3,u.ILifecycleMainService),ie(4,c.IEnvironmentMainService),ie(5,n.ITelemetryService),ie(6,s.ILogService),ie(7,l.IProductService),ie(8,i.IThemeMainService),ie(9,w.IWorkspacesManagementMainService)],M),e.NativeHostMainService=M}),define(Z[235],x([0,1,14,23,4,81,2,31,88,6,51,22,35]),function(j,e,p,r,D,C,P,I,d,f,y,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var S;(function(g){g[g.Initial=1]="Initial",g[g.StoredCredentialsUsed=2]="StoredCredentialsUsed",g[g.LoginDialogShown=3]="LoginDialogShown"})(S||(S={}));let t=class extends P.Disposable{constructor(E,v,k,c,a){super();this.logService=E,this.windowsMainService=v,this.nativeHostMainService=k,this.encryptionMainService=c,this.productService=a,this.PROXY_CREDENTIALS_SERVICE_KEY=`${this.productService.urlProtocol}.proxy-credentials`,this.pendingProxyResolve=void 0,this.state=S.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const E=D.Event.fromNodeEventEmitter(p.app,"login",(v,k,c,a,u)=>({event:v,webContents:k,req:c,authInfo:a,callback:u}));this._register(E(this.onLogin,this))}async onLogin({event:E,authInfo:v,req:k,callback:c}){if(!v.isProxy)return;if(!this.pendingProxyResolve&&this.state===S.LoginDialogShown&&k.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}E.preventDefault();let a;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),a=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(v);try{a=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}c(a?.username,a?.password)}async resolveProxyCredentials(E){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const v=await this.doResolveProxyCredentials(E);if(v)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),v;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(E){this.logService.trace("auth#doResolveProxyCredentials - enter",E);const v=String((0,C.hash)({scheme:E.scheme,host:E.host,port:E.port}));let k,c;try{const l=await this.nativeHostMainService.getPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,v);if(l){const n=JSON.parse(await this.encryptionMainService.decrypt(l));k=n.username,c=n.password}}catch(l){this.logService.error(l)}if(this.state!==S.StoredCredentialsUsed&&typeof k=="string"&&typeof c=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=S.StoredCredentialsUsed,{username:k,password:c};const a=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!a){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${a.id} to handle proxy login`);const u={authInfo:E,username:this.sessionCredentials?.username??k,password:this.sessionCredentials?.password??c,replyChannel:`vscode:proxyAuthResponse:${(0,I.generateUuid)()}`};a.sendWhenReady("vscode:openProxyAuthenticationDialog",r.CancellationToken.None,u),this.state=S.LoginDialogShown;const s=await new Promise(l=>{const n=async(i,o,h)=>{if(o===u.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${a.id}`),a.win?.webContents.off("ipc-message",n),h){const w={username:h.username,password:h.password};try{if(h.remember){const M=await this.encryptionMainService.encrypt(JSON.stringify(w));await this.nativeHostMainService.setPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,v,M)}else await this.nativeHostMainService.deletePassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,v)}catch(M){this.logService.error(M)}l({username:w.username,password:w.password})}else l(void 0)};a.win?.webContents.on("ipc-message",n)});return this.sessionCredentials=s,s}};t=fe([ie(0,f.ILogService),ie(1,m.IWindowsMainService),ie(2,y.INativeHostMainService),ie(3,d.IEncryptionMainService),ie(4,b.IProductService)],t),e.ProxyAuthHandler=t}),define(Z[236],x([0,1,14,26,33,2,10,3,83,148,74,50,24,5,102,6,51,54,22,55,67]),function(j,e,p,r,D,C,P,I,d,f,y,b,m,S,t,g,E,v,k,c,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,S.createDecorator)("issueMainService");let u=class Pt{constructor(l,n,i,o,h,w,M,A,R){this.userEnv=l,this.environmentMainService=n,this.launchMainService=i,this.logService=o,this.diagnosticsService=h,this.dialogMainService=w,this.nativeHostMainService=M,this.protocolMainService=A,this.productService=R,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){p.ipcMain.on("vscode:issueSystemInfoRequest",async l=>{const[n,i]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),o=await this.diagnosticsService.getSystemInfo(n,i);this.safeSend(l,"vscode:issueSystemInfoResponse",o)}),p.ipcMain.on("vscode:listProcesses",async l=>{const n=[];try{const i=await this.launchMainService.getMainProcessId();n.push({name:(0,f.localize)(0,null),rootProcess:await(0,d.listProcesses)(i)}),(await this.launchMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(h=>{(0,y.isRemoteDiagnosticError)(h)?n.push({name:h.hostName,rootProcess:h}):h.processes&&n.push({name:h.hostName,rootProcess:h.processes})})}catch(i){this.logService.error(`Listing processes failed: ${i}`)}this.safeSend(l,"vscode:listProcessesResponse",n)}),p.ipcMain.on("vscode:issueReporterClipboard",async l=>{const n={title:this.productService.nameLong,message:(0,f.localize)(1,null),type:"warning",buttons:[(0,D.mnemonicButtonLabel)((0,f.localize)(2,null)),(0,D.mnemonicButtonLabel)((0,f.localize)(3,null))],defaultId:0,cancelId:1,noLink:!0};if(this.issueReporterWindow){const i=await this.dialogMainService.showMessageBox(n,this.issueReporterWindow);this.safeSend(l,"vscode:issueReporterClipboardResponse",i.response===0)}}),p.ipcMain.on("vscode:issuePerformanceInfoRequest",async l=>{const n=await this.getPerformanceInfo();this.safeSend(l,"vscode:issuePerformanceInfoResponse",n)}),p.ipcMain.on("vscode:issueReporterConfirmClose",async()=>{const l={title:this.productService.nameLong,message:(0,f.localize)(4,null),type:"warning",buttons:[(0,D.mnemonicButtonLabel)((0,f.localize)(5,null)),(0,D.mnemonicButtonLabel)((0,f.localize)(6,null))],defaultId:0,cancelId:1,noLink:!0};this.issueReporterWindow&&(await this.dialogMainService.showMessageBox(l,this.issueReporterWindow)).response===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}),p.ipcMain.on("vscode:workbenchCommand",(l,n)=>{const{id:i,from:o,args:h}=n;let w;switch(o){case"issueReporter":w=this.issueReporterParentWindow;break;case"processExplorer":w=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${o}`)}w&&w.webContents.send("vscode:runAction",{id:i,from:o,args:h})}),p.ipcMain.on("vscode:openExternal",(l,n)=>{this.nativeHostMainService.openExternal(void 0,n)}),p.ipcMain.on("vscode:closeIssueReporter",l=>{this.issueReporterWindow&&this.issueReporterWindow.close()}),p.ipcMain.on("vscode:closeProcessExplorer",l=>{this.processExplorerWindow&&this.processExplorerWindow.close()}),p.ipcMain.on("vscode:windowsInfoRequest",async l=>{const n=await this.launchMainService.getMainProcessInfo();this.safeSend(l,"vscode:windowsInfoResponse",n.windows)})}safeSend(l,n,...i){l.sender.isDestroyed()||l.sender.send(n,...i)}async openReporter(l){if(!this.issueReporterWindow&&(this.issueReporterParentWindow=p.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const n=new C.DisposableStore,i=n.add(this.protocolMainService.createIPCObjectUrl()),o=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(o,i,{backgroundColor:l.styles.backgroundColor,title:(0,f.localize)(7,null),zoomLevel:l.zoomLevel,alwaysOnTop:!1},"issue-reporter"),i.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:l,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:(0,r.type)(),arch:(0,r.arch)(),release:(0,r.release)()},product:v.default}),this.issueReporterWindow.loadURL(P.FileAccess.asBrowserUri("vs/code/electron-sandbox/issue/issueReporter.html",j).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,n.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,n.dispose())})}this.issueReporterWindow&&this.focusWindow(this.issueReporterWindow)}async openProcessExplorer(l){if(!this.processExplorerWindow&&(this.processExplorerParentWindow=p.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const n=new C.DisposableStore,i=n.add(this.protocolMainService.createIPCObjectUrl()),o=this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(o,i,{backgroundColor:l.styles.backgroundColor,title:(0,f.localize)(8,null),zoomLevel:l.zoomLevel,alwaysOnTop:!0},"process-explorer"),i.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:l,product:v.default}),this.processExplorerWindow.loadURL(P.FileAccess.asBrowserUri("vs/code/electron-sandbox/processExplorer/processExplorer.html",j).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,n.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,n.dispose())})}this.processExplorerWindow&&this.focusWindow(this.processExplorerWindow)}focusWindow(l){l.isMinimized()&&l.restore(),l.focus()}createBrowserWindow(l,n,i,o){const h=new p.BrowserWindow({fullscreen:!1,skipTaskbar:!0,resizable:!0,width:l.width,height:l.height,minWidth:300,minHeight:200,x:l.x,y:l.y,title:i.title,backgroundColor:i.backgroundColor||Pt.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:P.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",j).fsPath,additionalArguments:[`--vscode-window-config=${n.resource.toString()}`,`--vscode-window-kind=${o}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,a.zoomLevelToZoomFactor)(i.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:i.alwaysOnTop});return h.setMenuBarVisibility(!1),h}async getSystemStatus(){const[l,n]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(l,n)}getWindowPosition(l,n,i){let o;const h=p.screen.getAllDisplays();if(h.length===1)o=h[0];else{if(I.isMacintosh){const A=p.screen.getCursorScreenPoint();o=p.screen.getDisplayNearestPoint(A)}!o&&l&&(o=p.screen.getDisplayMatching(l.getBounds())),o||(o=p.screen.getPrimaryDisplay()||h[0])}const w={width:n,height:i},M=o.bounds;return w.x=M.x+M.width/2-w.width/2,w.y=M.y+M.height/2-w.height/2,M.width>0&&M.height>0&&(w.x<M.x&&(w.x=M.x),w.y<M.y&&(w.y=M.y),w.x>M.x+M.width&&(w.x=M.x),w.y>M.y+M.height&&(w.y=M.y),w.width>M.width&&(w.width=M.width),w.height>M.height&&(w.height=M.height)),w}async getPerformanceInfo(){try{const[l,n]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(l,n)}catch(l){throw this.logService.warn("issueService#getPerformanceInfo ",l.message),l}}};u.DEFAULT_BACKGROUND_COLOR="#1E1E1E",u=fe([ie(1,m.IEnvironmentMainService),ie(2,t.ILaunchMainService),ie(3,g.ILogService),ie(4,y.IDiagnosticsService),ie(5,b.IDialogMainService),ie(6,E.INativeHostMainService),ie(7,c.IProtocolMainService),ie(8,k.IProductService)],u),e.IssueMainService=u}),define(Z[237],x([0,1,23,19,24,20,6,51,22,49,28,41,77]),function(j,e,p,r,D,C,P,I,d,f,y,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let S=class extends m.AbstractUpdateService{constructor(g,E,v,k,c,a,u,s){super(g,E,k,c,a,s);this.telemetryService=v,this.nativeHostMainService=u}buildUpdateFeedUrl(g){return(0,m.createUpdateURL)(`linux-${process.arch}`,g,this.productService)}doCheckForUpdates(g){!this.url||(this.setState(b.State.CheckingForUpdates(g)),this.requestService.request({url:this.url},p.CancellationToken.None).then(f.asJson).then(E=>{!E||!E.url||!E.version||!E.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!g}),this.setState(b.State.Idle(1))):this.setState(b.State.AvailableForDownload(E))}).then(void 0,E=>{this.logService.error(E),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!g});const v=g?E.message||E:void 0;this.setState(b.State.Idle(1,v))}))}async doDownloadUpdate(g){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):g.update.url&&this.nativeHostMainService.openExternal(void 0,g.update.url),this.setState(b.State.Idle(1))}};S=fe([ie(0,C.ILifecycleMainService),ie(1,r.IConfigurationService),ie(2,y.ITelemetryService),ie(3,D.IEnvironmentMainService),ie(4,f.IRequestService),ie(5,P.ILogService),ie(6,I.INativeHostMainService),ie(7,d.IProductService)],S),e.LinuxUpdateService=S}),define(Z[238],x([0,1,43,27,26,9,23,46,8,7,113,21,19,24,18,20,6,51,22,49,28,41,77]),function(j,e,p,r,D,C,P,I,d,f,y,b,m,S,t,g,E,v,k,c,a,u,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function l(h,w=1e3){for(;!h();)await(0,C.timeout)(w)}let n;function i(){return typeof n=="undefined"&&(n=r.existsSync(d.join(d.dirname(process.execPath),"unins000.exe"))?0:1),n}let o=class extends s.AbstractUpdateService{constructor(w,M,A,R,T,_,Q,ne,oe){super(w,M,R,T,_,oe);this.telemetryService=A,this.fileService=Q,this.nativeHostMainService=ne}get cachePath(){const w=d.join((0,D.tmpdir)(),`vscode-update-${this.productService.target}-${process.arch}`);return b.Promises.mkdir(w,{recursive:!0}).then(()=>w)}initialize(){super.initialize(),i()===0&&this.telemetryService.publicLog("update:win32SetupTarget",{target:this.productService.target})}buildUpdateFeedUrl(w){let M="win32";return process.arch!=="ia32"&&(M+=`-${process.arch}`),i()===1?M+="-archive":this.productService.target==="user"&&(M+="-user"),(0,s.createUpdateURL)(M,w,this.productService)}doCheckForUpdates(w){!this.url||(this.setState(u.State.CheckingForUpdates(w)),this.requestService.request({url:this.url},P.CancellationToken.None).then(c.asJson).then(M=>{const A=i();return!M||!M.url||!M.version||!M.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!w}),this.setState(u.State.Idle(A)),Promise.resolve(null)):A===1?(this.setState(u.State.AvailableForDownload(M)),Promise.resolve(null)):(this.setState(u.State.Downloading(M)),this.cleanup(M.version).then(()=>this.getUpdatePackagePath(M.version).then(R=>b.Promises.exists(R).then(T=>{if(T)return Promise.resolve(R);const _=M.url,Q=M.hash,ne=`${R}.tmp`;return this.requestService.request({url:_},P.CancellationToken.None).then(oe=>this.fileService.writeFile(f.URI.file(ne),oe.stream)).then(Q?()=>(0,y.checksum)(ne,M.hash):()=>{}).then(()=>b.Promises.rename(ne,R)).then(()=>R)})).then(R=>{const T=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:R},T&&M.supportsFastUpdate?this.productService.target==="user"?this.doApplyUpdate():this.setState(u.State.Downloaded(M)):this.setState(u.State.Ready(M))})))}).then(void 0,M=>{this.logService.error(M),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!w});const A=w?M.message||M:void 0;this.setState(u.State.Idle(i(),A))}))}async doDownloadUpdate(w){w.update.url&&this.nativeHostMainService.openExternal(void 0,w.update.url),this.setState(u.State.Idle(i()))}async getUpdatePackagePath(w){const M=await this.cachePath;return d.join(M,`CodeSetup-${this.productService.quality}-${w}.exe`)}async cleanup(w=null){const M=w?_=>!new RegExp(`${this.productService.quality}-${w}\\.exe$`).test(_):()=>!0,A=await this.cachePath,T=(await b.Promises.readdir(A)).filter(M).map(async _=>{try{await b.Promises.unlink(d.join(A,_))}catch{}});await Promise.all(T)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const w=this.state.update;this.setState(u.State.Updating(w));const M=await this.cachePath;this.availableUpdate.updateFilePath=d.join(M,`CodeSetup-${this.productService.quality}-${w.version}.flag`),await b.Promises.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,p.spawn)(this.availableUpdate.packagePath,["/verysilent",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(u.State.Idle(i()))});const R=`${this.productService.win32MutexName}-ready`,T=await new Promise((_,Q)=>{j(["windows-mutex"],_,Q)});l(()=>T.isActive(R)).then(()=>this.setState(u.State.Ready(w)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.availableUpdate.updateFilePath?r.unlinkSync(this.availableUpdate.updateFilePath):(0,p.spawn)(this.availableUpdate.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return i()}};fe([I.memoize],o.prototype,"cachePath",null),o=fe([ie(0,g.ILifecycleMainService),ie(1,m.IConfigurationService),ie(2,a.ITelemetryService),ie(3,S.IEnvironmentMainService),ie(4,c.IRequestService),ie(5,E.ILogService),ie(6,t.IFileService),ie(7,v.INativeHostMainService),ie(8,k.IProductService)],o),e.Win32UpdateService=o}),define(Z[239],x([0,1,14,9,23,44,4,33,2,10,8,63,3,7,154,52,19,50,24,53,205,18,20,6,22,55,99,28,208,66,67,35,29,45]),function(j,e,p,r,D,C,P,I,d,f,y,b,m,S,t,g,E,v,k,c,a,u,s,l,n,i,o,h,w,M,A,R,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var Q;(function(oe){oe[oe.NONE=0]="NONE",oe[oe.LOADING=1]="LOADING",oe[oe.NAVIGATING=2]="NAVIGATING",oe[oe.READY=3]="READY"})(Q||(Q={}));let ne=class extends d.Disposable{constructor(X,O,H,q,Y,$,K,te,B,L,W,F,N,V,U){super();this.logService=O,this.environmentMainService=H,this.fileService=q,this.storageMainService=Y,this.configurationService=$,this.themeMainService=K,this.workspacesManagementMainService=te,this.backupMainService=B,this.telemetryService=L,this.dialogMainService=W,this.lifecycleMainService=F,this.productService=N,this.protocolMainService=V,this.windowsMainService=U,this._onWillLoad=this._register(new P.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new P.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidClose=this._register(new P.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new P.Emitter),this.onDidDestroy=this._onDidDestroy.event,this._lastFocusTime=-1,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.wasLoaded=!1,this.readyState=0;{const[z,ee]=this.restoreWindowState(X.state);this.windowState=z,this.logService.trace("window#ctor: using window state",z);const re=this.windowState.mode===0||this.windowState.mode===3,se=this.configurationService.getValue("window"),J={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:A.WindowMinimumSize.WIDTH,minHeight:A.WindowMinimumSize.HEIGHT,show:!re,title:this.productService.nameLong,webPreferences:{preload:f.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",j).fsPath,additionalArguments:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,A.zoomLevelToZoomFactor)(se?.zoomLevel),...this.environmentMainService.sandbox?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1}}};m.isLinux?J.icon=(0,y.join)(this.environmentMainService.appRoot,"resources/linux/code.png"):m.isWindows&&!this.environmentMainService.isBuilt&&(J.icon=(0,y.join)(this.environmentMainService.appRoot,"resources/win32/code_150x150.png")),m.isMacintosh&&!this.useNativeFullScreen()&&(J.fullscreenable=!1),m.isMacintosh&&(J.acceptFirstMouse=!0,se?.clickThroughInactive===!1&&(J.acceptFirstMouse=!1));const ce=m.isMacintosh&&se?.nativeTabs===!0;ce&&(J.tabbingIdentifier=this.productService.nameShort);const le=(0,A.getTitleBarStyle)(this.configurationService)==="custom";if(le&&(J.titleBarStyle="hidden",this.hiddenTitleBarStyle=!0,m.isMacintosh||(J.frame=!1)),(0,b.mark)("code/willCreateCodeBrowserWindow"),this._win=new p.BrowserWindow(J),(0,b.mark)("code/didCreateCodeBrowserWindow"),this._id=this._win.id,this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),m.isMacintosh&&le&&this._win.setSheetOffset(22),m.isMacintosh&&ee&&(!ce||p.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(ue=>typeof ue=="number")){const ue=this.windowState;this._win.setBounds({width:ue.width,height:ue.height,x:ue.x,y:ue.y})}re&&((0,b.mark)("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.isVisible()||this._win.show(),(0,b.mark)("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.onConfigurationUpdated(),this.createTouchBar(),this.registerListeners()}get id(){return this._id}get win(){return this._win}get lastFocusTime(){return this._lastFocusTime}get backupPath(){return this.currentConfig?.backupPath}get openedWorkspace(){return this.currentConfig?.workspace}get remoteAuthority(){return this.currentConfig?.remoteAuthority}get config(){return this.currentConfig}get hasHiddenTitleBarStyle(){return!!this.hiddenTitleBarStyle}get isExtensionDevelopmentHost(){return!!this.currentConfig?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.currentConfig?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.currentConfig?.debugId}setRepresentedFilename(X){m.isMacintosh?this._win.setRepresentedFilename(X):this.representedFilename=X}getRepresentedFilename(){return m.isMacintosh?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited(X){m.isMacintosh&&this._win.setDocumentEdited(X),this.documentEdited=X}isDocumentEdited(){return m.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(X){m.isMacintosh&&X?.force&&p.app.focus({steal:!0}),!!this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}setReady(){for(this.readyState=3;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(X=>{if(this.isReady)return X(this);this.whenReadyCallbacks.push(X)})}get isReady(){return this.readyState===3}get whenClosedOrLoaded(){return new Promise(X=>{function O(){H.dispose(),q.dispose(),X()}const H=this.onDidClose(()=>O()),q=this.onWillLoad(()=>O())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",(Y,$)=>this.onWindowError(2,$)),this._win.webContents.on("did-fail-load",(Y,$,K)=>this.onWindowError(3,{reason:K,exitCode:$})),this._win.webContents.on("will-prevent-unload",Y=>{Y.preventDefault()}),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()});const X=new Set([f.Schemas.file,f.Schemas.vscodeFileResource,f.Schemas.vscodeRemoteResource,"devtools"]),O=Y=>{for(let $=Y;$;$=$.parent)if($.url.startsWith(`${f.Schemas.vscodeWebview}://`))return!0;return!1},H=Y=>Y.resourceType==="xhr"||O(Y.frame);this._win.webContents.session.webRequest.onBeforeRequest((Y,$)=>{const K=S.URI.parse(Y.url);return K.path.endsWith(".svg")&&!X.has(K.scheme)?$({cancel:!H(Y)}):$({cancel:!1})}),this._win.webContents.session.webRequest.onHeadersReceived((Y,$)=>{const K=Y.responseHeaders,te=K["content-type"]||K["Content-Type"];if(te&&Array.isArray(te)){const B=S.URI.parse(Y.url);if(B.path.endsWith(".svg")&&X.has(B.scheme))return K["Content-Type"]=["image/svg+xml"],$({cancel:!1,responseHeaders:K});if(!B.path.includes(f.Schemas.vscodeRemoteResource)&&te.some(L=>L.toLowerCase().includes("image/svg")))return $({cancel:!H(Y)})}return $({cancel:!1})}),this._win.webContents.on("did-finish-load",()=>{this.readyState=1,this.pendingLoadConfig&&(this.currentConfig=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),this._win.on("maximize",Y=>{this.currentConfig&&(this.currentConfig.maximized=!0),p.app.emit("browser-window-maximize",Y,this._win)}),this._win.on("unmaximize",Y=>{this.currentConfig&&(this.currentConfig.maximized=!1),p.app.emit("browser-window-unmaximize",Y,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",D.CancellationToken.None)}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",D.CancellationToken.None)}),this._register(this.configurationService.onDidChangeConfiguration(()=>this.onConfigurationUpdated())),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(Y=>this.onDidDeleteUntitledWorkspace(Y)));const q=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:q},async(Y,$)=>{const K=await this.getMarketplaceHeaders();$({cancel:!1,requestHeaders:Object.assign(Y.requestHeaders,K)})})}getMarketplaceHeaders(){return this.marketplaceHeadersPromise||(this.marketplaceHeadersPromise=(0,a.resolveMarketplaceHeaders)(this.productService.version,this.productService,this.environmentMainService,this.configurationService,this.fileService,{get:X=>this.storageMainService.globalStorage.get(X),store:(X,O)=>this.storageMainService.globalStorage.set(X,O)})),this.marketplaceHeadersPromise}async onWindowError(X,O){switch(X){case 2:this.logService.error(`CodeWindow: renderer process crashed (reason: ${O?.reason||"<unknown>"}, code: ${O?.exitCode||"<unknown>"})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load (reason: ${O?.reason||"<unknown>"}, code: ${O?.exitCode||"<unknown>"})`);break}switch(this.telemetryService.publicLog2("windowerror",{type:X,reason:O?.reason,code:O?.exitCode}),X){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(this.environmentMainService.driverHandle){this.destroyWindow(!1);return}if(X===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const H=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,I.mnemonicButtonLabel)((0,t.localize)(0,null)),(0,I.mnemonicButtonLabel)((0,t.localize)(1,null)),(0,I.mnemonicButtonLabel)((0,t.localize)(2,null))],message:(0,t.localize)(3,null),detail:(0,t.localize)(4,null),noLink:!0,defaultId:0,cancelId:1},this._win);if(H.response!==1){const q=H.response===0;this.destroyWindow(q)}}else if(X===2){let H;O?H=(0,t.localize)(6,null,O.reason,O.exitCode??"<unknown>"):H=(0,t.localize)(5,null);const Y=(await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,I.mnemonicButtonLabel)((0,t.localize)(7,null)),(0,I.mnemonicButtonLabel)((0,t.localize)(8,null))],message:H,detail:(0,t.localize)(9,null),noLink:!0,defaultId:0},this._win)).response===0;this.destroyWindow(Y)}break}}destroyWindow(X){if(this._onDidDestroy.fire(),this._win?.destroy(),X&&this.config){let O,H;(0,T.isSingleFolderWorkspaceIdentifier)(this.openedWorkspace)?O={folderUri:this.openedWorkspace.uri}:(0,T.isWorkspaceIdentifier)(this.openedWorkspace)?O={workspaceUri:this.openedWorkspace.configPath}:H=!0;const[q]=this.windowsMainService.open({context:5,userEnv:this.config.userEnv,cli:{...this.environmentMainService.args,_:[]},urisToOpen:O?[O]:void 0,forceEmpty:H,forceNewWindow:!0,remoteAuthority:this.remoteAuthority});q.focus()}}onDidDeleteUntitledWorkspace(X){this.openedWorkspace?.id===X.id&&this.currentConfig&&(this.currentConfig.workspace=void 0)}onConfigurationUpdated(){const X=this.getMenuBarVisibility();X!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=X,this.setMenuBarVisibility(X));let O=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;O?.endsWith("/")&&(O=O.substr(0,O.length-1));const H=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((O||"").indexOf("@")===-1&&(O!==this.currentHttpProxy||H!==this.currentNoProxy)){this.currentHttpProxy=O,this.currentNoProxy=H;const q=O||"",Y=H?`${H},<local>`:"<local>";this.logService.trace(`Setting proxy to '${q}', bypassing '${Y}'`),this._win.webContents.session.setProxy({proxyRules:q,proxyBypassRules:Y,pacScript:""})}}addTabbedWindow(X){m.isMacintosh&&X.win&&this._win.addTabbedWindow(X.win)}load(X,O=Object.create(null)){this.isDocumentEdited()&&(!O.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),O.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(X,O),this.readyState===0?this.currentConfig=X:(this.pendingLoadConfig=X,this.readyState=2),this._win.loadURL(f.FileAccess.asBrowserUri(this.environmentMainService.sandbox?"vs/code/electron-sandbox/workbench/workbench.html":"vs/code/electron-browser/workbench/workbench.html",j).toString(!0));const H=this.wasLoaded;this.wasLoaded=!0,!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&this._register(new r.RunOnceScheduler(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)).schedule(),this._onWillLoad.fire({workspace:X.workspace,reason:O.isReload?3:H?2:1})}updateConfiguration(X,O){const H=(this.currentConfig??this.pendingLoadConfig)?.userEnv;if(H){const q=(0,c.isLaunchedFromCli)(H)&&!(0,c.isLaunchedFromCli)(X.userEnv),Y=this.isExtensionDevelopmentHost;(q||Y)&&(X.userEnv={...H,...X.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(X.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),O.disableExtensions!==void 0&&(X["disable-extensions"]=O.disableExtensions),X.fullscreen=this.isFullScreen,X.maximized=this._win.isMaximized(),X.partsSplash=this.themeMainService.getWindowSplash(),(0,b.mark)("code/willOpenNewWindow"),X.perfMarks=(0,b.getMarks)(),this.configObjectUrl.update(X)}async reload(X){const O=Object.assign({},this.currentConfig);O.workspace=await this.validateWorkspaceBeforeReload(O),delete O.filesToOpenOrCreate,delete O.filesToDiff,delete O.filesToWait,this.isExtensionDevelopmentHost&&X&&(O.verbose=X.verbose,O.debugId=X.debugId,O.extensionEnvironment=X.extensionEnvironment,O["inspect-extensions"]=X["inspect-extensions"],O["inspect-brk-extensions"]=X["inspect-brk-extensions"],O["extensions-dir"]=X["extensions-dir"]),O.isInitialStartup=!1,this.load(O,{isReload:!0,disableExtensions:X?.["disable-extensions"]})}async validateWorkspaceBeforeReload(X){if((0,T.isWorkspaceIdentifier)(X.workspace)){const O=X.workspace.configPath;if(O.scheme===f.Schemas.file&&!await this.fileService.exists(O))return}else if((0,T.isSingleFolderWorkspaceIdentifier)(X.workspace)){const O=X.workspace.uri;if(O.scheme===f.Schemas.file&&!await this.fileService.exists(O))return}return X.workspace}serializeWindowState(){if(!this._win)return(0,R.defaultWindowState)();if(this.isFullScreen){let H;try{H=p.screen.getDisplayMatching(this.getBounds())}catch{}const q=(0,R.defaultWindowState)();return{mode:3,display:H?H.id:void 0,width:this.windowState.width||q.width,height:this.windowState.height||q.height,x:this.windowState.x||0,y:this.windowState.y||0}}const X=Object.create(null);let O;if(!m.isMacintosh&&this._win.isMaximized()?O=0:O=1,O===0?X.mode=0:X.mode=1,O===1||O===0){let H;O===1?H=this.getBounds():H=this._win.getNormalBounds(),X.x=H.x,X.y=H.y,X.width=H.width,X.height=H.height}return X}restoreWindowState(X){(0,b.mark)("code/willRestoreCodeWindowState");let O=!1;if(X)try{const H=p.screen.getAllDisplays();O=H.length>1,X=this.validateWindowState(X,H)}catch(H){this.logService.warn(`Unexpected error validating window state: ${H}
${H.stack}`)}return(0,b.mark)("code/didRestoreCodeWindowState"),[X||(0,R.defaultWindowState)(),O]}validateWindowState(X,O){if(this.logService.trace(`window#validateWindowState: validating window state on ${O.length} display(s)`,X),typeof X.x!="number"||typeof X.y!="number"||typeof X.width!="number"||typeof X.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(X.width<=0||X.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if(O.length===1){const Y=this.getWorkingArea(O[0]);if(Y){let $=function(){!X||typeof X.x!="number"||typeof X.y!="number"||!Y||(X.x<Y.x&&(X.x=Y.x),X.y<Y.y&&(X.y=Y.y))};this.logService.trace("window#validateWindowState: 1 monitor working area",Y),$(),X.width>Y.width&&(X.width=Y.width),X.height>Y.height&&(X.height=Y.height),X.x>Y.x+Y.width-128&&(X.x=Y.x+Y.width-X.width),X.y>Y.y+Y.height-128&&(X.y=Y.y+Y.height-X.height),$()}return X}if(X.display&&X.mode===3){const Y=O.find($=>$.id===X.display);if(Y&&typeof Y.bounds?.x=="number"&&typeof Y.bounds?.y=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const $=(0,R.defaultWindowState)(3);return $.x=Y.bounds.x,$.y=Y.bounds.y,$}}let H,q;try{H=p.screen.getDisplayMatching({x:X.x,y:X.y,width:X.width,height:X.height}),q=this.getWorkingArea(H)}catch{}if(H&&q&&X.x+X.width>q.x&&X.y+X.height>q.y&&X.x<q.x+q.width&&X.y<q.y+q.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",q),X}getWorkingArea(X){if(X.workArea.width>0&&X.workArea.height>0)return X.workArea;if(X.bounds.width>0&&X.bounds.height>0)return X.bounds}getBounds(){const[X,O]=this._win.getPosition(),[H,q]=this._win.getSize();return{x:X,y:O,width:H,height:q}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(X){this.useNativeFullScreen()?this.setNativeFullScreen(X):this.setSimpleFullScreen(X),this.sendWhenReady(X?"vscode:enterFullScreen":"vscode:leaveFullScreen",D.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen(X){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this._win.setFullScreen(X)}setSimpleFullScreen(X){this._win.isFullScreen()&&this._win.setFullScreen(!1),this._win.setSimpleFullScreen(X),this._win.webContents.focus()}useNativeFullScreen(){const X=this.configurationService.getValue("window");return!X||typeof X.nativeFullScreen!="boolean"||X.nativeTabs?!0:X.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let X=(0,A.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(X)<0&&(X="classic"),X}setMenuBarVisibility(X,O=!0){m.isMacintosh||(X==="toggle"&&O&&this.send("vscode:showInfoMessage",(0,t.localize)(10,null)),X==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(X)}):this.doSetMenuBarVisibility(X))}doSetMenuBarVisibility(X){const O=this.isFullScreen;switch(X){case"classic":this._win.setMenuBarVisibility(!O),this._win.autoHideMenuBar=O;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(m.isMacintosh)switch(p.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win&&this._win.close()}sendWhenReady(X,O,...H){this.isReady?this.send(X,...H):this.ready().then(()=>{O.isCancellationRequested||this.send(X,...H)})}send(X,...O){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel '${X}' for window that is destroyed`);return}try{this._win.webContents.send(X,...O)}catch(H){this.logService.warn(`Error sending IPC message to channel '${X}' of window ${this._id}: ${(0,C.toErrorMessage)(H)}`)}}}updateTouchBar(X){!m.isMacintosh||this.touchBarGroups.forEach((O,H)=>{const q=X[H];O.segments=this.createTouchBarGroupSegments(q)})}createTouchBar(){if(!!m.isMacintosh){for(let X=0;X<10;X++){const O=this.createTouchBarGroup();this.touchBarGroups.push(O)}this._win.setTouchBar(new p.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(X=[]){const O=this.createTouchBarGroupSegments(X),H=new p.TouchBar.TouchBarSegmentedControl({segments:O,mode:"buttons",segmentStyle:"automatic",change:q=>{this.sendWhenReady("vscode:runAction",D.CancellationToken.None,{id:H.segments[q].id,from:"touchbar"})}});return H}createTouchBarGroupSegments(X=[]){return X.map(H=>{let q;H.icon&&!w.ThemeIcon.isThemeIcon(H.icon)&&H.icon?.dark?.scheme===f.Schemas.file&&(q=p.nativeImage.createFromPath(S.URI.revive(H.icon.dark).fsPath),q.isEmpty()&&(q=void 0));let Y;return typeof H.title=="string"?Y=H.title:Y=H.title.value,{id:H.id,label:q?void 0:Y,icon:q}})}dispose(){super.dispose(),this._win=null}};ne=fe([ie(1,l.ILogService),ie(2,k.IEnvironmentMainService),ie(3,u.IFileService),ie(4,o.IStorageMainService),ie(5,E.IConfigurationService),ie(6,M.IThemeMainService),ie(7,_.IWorkspacesManagementMainService),ie(8,g.IBackupMainService),ie(9,h.ITelemetryService),ie(10,v.IDialogMainService),ie(11,s.ILifecycleMainService),ie(12,n.IProductService),ie(13,i.IProtocolMainService),ie(14,R.IWindowsMainService)],ne),e.CodeWindow=ne}),define(Z[68],x([0,1,14,30,9,4,33,2,10,3,15,7,21,157,5,20,6,37,29,45]),function(j,e,p,r,D,C,P,I,d,f,y,b,m,S,t,g,E,v,k,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,t.createDecorator)("workspacesHistoryMainService");let a=class qe extends I.Disposable{constructor(s,l,n,i){super();this.stateMainService=s,this.logService=l,this.workspacesManagementMainService=n,this.lifecycleMainService=i,this._onDidChangeRecentlyOpened=this._register(new C.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new D.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(3).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(s=>this.addRecentlyOpened([{workspace:s.workspace,remoteAuthority:s.window.remoteAuthority}])))}handleWindowsJumpList(){!f.isWindows||(this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}addRecentlyOpened(s){const l=[],n=[];for(let i of s)if((0,k.isRecentWorkspace)(i))!this.workspacesManagementMainService.isUntitledWorkspace(i.workspace)&&this.indexOfWorkspace(l,i.workspace)===-1&&l.push(i);else if((0,k.isRecentFolder)(i))this.indexOfFolder(l,i.folderUri)===-1&&l.push(i);else{const o=this.indexOfFile(n,i.fileUri)>=0,h=i.fileUri.scheme===d.Schemas.file&&qe.COMMON_FILES_FILTER.indexOf((0,y.basename)(i.fileUri))>=0;!o&&!h&&(n.push(i),f.isWindows&&i.fileUri.scheme===d.Schemas.file&&p.app.addRecentDocument(i.fileUri.fsPath))}this.addEntriesFromStorage(l,n),l.length>qe.MAX_TOTAL_RECENT_ENTRIES&&(l.length=qe.MAX_TOTAL_RECENT_ENTRIES),n.length>qe.MAX_TOTAL_RECENT_ENTRIES&&(n.length=qe.MAX_TOTAL_RECENT_ENTRIES),this.saveRecentlyOpened({workspaces:l,files:n}),this._onDidChangeRecentlyOpened.fire(),f.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}removeRecentlyOpened(s){const l=h=>{const w=this.location(h);for(const M of s)if(y.extUriBiasedIgnorePathCase.isEqual(M,w))return!1;return!0},n=this.getRecentlyOpened(),i=n.workspaces.filter(l),o=n.files.filter(l);(i.length!==n.workspaces.length||o.length!==n.files.length)&&(this.saveRecentlyOpened({files:o,workspaces:i}),this._onDidChangeRecentlyOpened.fire(),f.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async updateMacOSRecentDocuments(){if(!f.isMacintosh)return;p.app.clearRecentDocuments();const s=this.getRecentlyOpened(),l=[];let n=0;for(let o=0;o<s.workspaces.length&&n<qe.MAX_MACOS_DOCK_RECENT_WORKSPACES;o++){const h=this.location(s.workspaces[o]);if(h.scheme===d.Schemas.file){const w=(0,y.originalFSPath)(h);await m.Promises.exists(w)&&(l.push(w),n++)}}const i=[];for(let o=0;o<s.files.length&&n<qe.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;o++){const h=this.location(s.files[o]);if(h.scheme===d.Schemas.file){const w=(0,y.originalFSPath)(h);if(qe.COMMON_FILES_FILTER.includes((0,y.basename)(h))||l.includes(w))continue;await m.Promises.exists(w)&&(i.push(w),n++)}}i.reverse().forEach(o=>p.app.addRecentDocument(o)),l.reverse().forEach(o=>p.app.addRecentDocument(o))}clearRecentlyOpened(){this.saveRecentlyOpened({workspaces:[],files:[]}),p.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}getRecentlyOpened(s){const l=[],n=[];if(s){const o=s.config?.workspace;(0,k.isWorkspaceIdentifier)(o)&&!this.workspacesManagementMainService.isUntitledWorkspace(o)?l.push({workspace:o,remoteAuthority:s.remoteAuthority}):(0,k.isSingleFolderWorkspaceIdentifier)(o)&&l.push({folderUri:o.uri,remoteAuthority:s.remoteAuthority})}const i=s?.config?.filesToOpenOrCreate;if(i)for(let o of i){const h=o.fileUri;h&&this.indexOfFile(n,h)===-1&&n.push({fileUri:h})}return this.addEntriesFromStorage(l,n),{workspaces:l,files:n}}addEntriesFromStorage(s,l){let n=this.getRecentlyOpenedFromStorage();for(let i of n.workspaces){let o=(0,k.isRecentFolder)(i)?this.indexOfFolder(s,i.folderUri):this.indexOfWorkspace(s,i.workspace);o>=0?s[o].label=s[o].label||i.label:s.push(i)}for(let i of n.files){let o=this.indexOfFile(l,i.fileUri);o>=0?l[o].label=l[o].label||i.label:l.push(i)}}getRecentlyOpenedFromStorage(){const s=this.stateMainService.getItem(qe.recentlyOpenedStorageKey);return(0,k.restoreRecentlyOpened)(s,this.logService)}saveRecentlyOpened(s){const l=(0,k.toStoreData)(s);this.stateMainService.setItem(qe.recentlyOpenedStorageKey,l)}updateWindowsJumpList(){if(!f.isWindows)return;const s=[];if(s.push({type:"tasks",items:[{type:"task",title:(0,S.localize)(0,null),description:(0,S.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),this.getRecentlyOpened().workspaces.length>0){let l=[];for(let o of p.app.getJumpListSettings().removedItems){const h=o.args;if(h){const w=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(h);w&&l.push(b.URI.parse(w[2]))}}this.removeRecentlyOpened(l);let n=!1;const i=(0,r.coalesce)(this.getRecentlyOpened().workspaces.slice(0,qe.MAX_WINDOWS_JUMP_LIST_ENTRIES).map(o=>{const h=(0,k.isRecentWorkspace)(o)?o.workspace:o.folderUri,{title:w,description:M}=this.getWindowsJumpListLabel(h,o.label);let A;return b.URI.isUri(h)?A=`--folder-uri "${h.toString()}"`:(n=!0,A=`--file-uri "${h.configPath.toString()}"`),{type:"task",title:w.substr(0,255),description:M.substr(0,255),program:process.execPath,args:A,iconPath:"explorer.exe",iconIndex:0}}));i.length>0&&s.push({type:"custom",name:n?(0,S.localize)(2,null):(0,S.localize)(3,null),items:i})}s.push({type:"recent"});try{p.app.setJumpList(s)}catch(l){this.logService.warn("updateWindowsJumpList#setJumpList",l)}}getWindowsJumpListLabel(s,l){if(l)return{title:(0,P.splitName)(l).name,description:l};if(b.URI.isUri(s))return{title:(0,y.basename)(s),description:this.renderJumpListPathDescription(s)};if(this.workspacesManagementMainService.isUntitledWorkspace(s))return{title:(0,S.localize)(4,null),description:""};let n=(0,y.basename)(s.configPath);return n.endsWith(k.WORKSPACE_EXTENSION)&&(n=n.substr(0,n.length-k.WORKSPACE_EXTENSION.length-1)),{title:(0,S.localize)(5,null,n),description:this.renderJumpListPathDescription(s.configPath)}}renderJumpListPathDescription(s){return s.scheme==="file"?(0,P.normalizeDriveLetter)(s.fsPath):s.toString()}location(s){return(0,k.isRecentFolder)(s)?s.folderUri:(0,k.isRecentFile)(s)?s.fileUri:s.workspace.configPath}indexOfWorkspace(s,l){return s.findIndex(n=>(0,k.isRecentWorkspace)(n)&&n.workspace.id===l.id)}indexOfFolder(s,l){return s.findIndex(n=>(0,k.isRecentFolder)(n)&&y.extUriBiasedIgnorePathCase.isEqual(n.folderUri,l))}indexOfFile(s,l){return s.findIndex(n=>y.extUriBiasedIgnorePathCase.isEqual(n.fileUri,l))}};a.MAX_TOTAL_RECENT_ENTRIES=500,a.MAX_MACOS_DOCK_RECENT_WORKSPACES=7,a.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10,a.MAX_WINDOWS_JUMP_LIST_ENTRIES=7,a.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"],a.recentlyOpenedStorageKey="openedPathsList",a=fe([ie(0,v.IStateMainService),ie(1,E.ILogService),ie(2,c.IWorkspacesManagementMainService),ie(3,g.ILifecycleMainService)],a),e.WorkspacesHistoryMainService=a}),define(Z[240],x([0,1,14,9,23,33,3,7,149,19,24,20,6,187,51,22,37,28,41,67,35,68]),function(j,e,p,r,D,C,P,I,d,f,y,b,m,S,t,g,E,v,k,c,a,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const s="menu";let l=class yt{constructor(o,h,w,M,A,R,T,_,Q,ne,oe){this.updateService=o,this.configurationService=h,this.windowsMainService=w,this.environmentMainService=M,this.telemetryService=A,this.workspacesHistoryMainService=R,this.stateMainService=T,this.lifecycleMainService=_,this.logService=Q,this.nativeHostMainService=ne,this.productService=oe,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new r.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new r.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(P.isMacintosh||(0,c.getTitleBarStyle)(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const o=this.stateMainService.getItem(yt.lastKnownMenubarStorageKey);o&&(o.menus&&(this.menubarMenus=o.menus),o.keybindings&&(this.keybindings=o.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(R,T,_)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:T?.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(R,T,_)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:T?.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(R,T,_)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(_),telemetryExtraData:{from:s}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(R,T,_)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(_),telemetryExtraData:{from:s}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const o=this.productService.twitterUrl;o&&(this.fallbackMenuHandlers["workbench.action.openTwitterUrl"]=()=>this.openUrl(o,"openTwitterUrl"));const h=this.productService.requestFeatureUrl;h&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(h,"openUserVoiceUrl"));const w=this.productService.reportIssueUrl;w&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(w,"openReportIssues"));const M=this.productService.licenseUrl;M&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(P.language){const R=M.indexOf("?")>0?"&":"?";this.openUrl(`${M}${R}lang=${P.language}`,"openLicenseUrl")}else this.openUrl(M,"openLicenseUrl")});const A=this.productService.privacyStatementUrl;A&&M&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{this.openUrl(A,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(o=>this.onDidChangeWindowsCount(o)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){let o=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof o!="boolean"?!0:o}get currentEnableNativeTabs(){if(!P.isMacintosh)return!1;let o=this.configurationService.getValue("window.nativeTabs");return typeof o!="boolean"?!1:o}updateMenu(o,h){this.menubarMenus=o.menus,this.keybindings=o.keybindings,this.stateMainService.setItem(yt.lastKnownMenubarStorageKey,o),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(o){!P.isMacintosh||(o.oldCount===0&&o.newCount>0||o.oldCount>0&&o.newCount===0)&&(this.closedLastWindow=o.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){!P.isMacintosh||(this.noActiveWindow=!p.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const o=p.Menu.getApplicationMenu();if(o&&this.oldMenus.push(o),Object.keys(this.menubarMenus).length===0){p.Menu.setApplicationMenu(P.isMacintosh?new p.Menu:null);return}const h=new p.Menu;let w;if(P.isMacintosh){const A=new p.Menu;w=new p.MenuItem({label:this.productService.nameShort,submenu:A}),this.setMacApplicationMenu(A),h.append(w)}if(P.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const A=new p.Menu;A.append(new p.MenuItem({label:this.mnemonicLabel(d.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),p.app.dock.setMenu(A)}if(this.shouldDrawMenu("File")){const A=new p.Menu,R=new p.MenuItem({label:this.mnemonicLabel(d.localize(1,null)),submenu:A});this.setMenuById(A,"File"),h.append(R)}if(this.shouldDrawMenu("Edit")){const A=new p.Menu,R=new p.MenuItem({label:this.mnemonicLabel(d.localize(2,null)),submenu:A});this.setMenuById(A,"Edit"),h.append(R)}if(this.shouldDrawMenu("Selection")){const A=new p.Menu,R=new p.MenuItem({label:this.mnemonicLabel(d.localize(3,null)),submenu:A});this.setMenuById(A,"Selection"),h.append(R)}if(this.shouldDrawMenu("View")){const A=new p.Menu,R=new p.MenuItem({label:this.mnemonicLabel(d.localize(4,null)),submenu:A});this.setMenuById(A,"View"),h.append(R)}if(this.shouldDrawMenu("Go")){const A=new p.Menu,R=new p.MenuItem({label:this.mnemonicLabel(d.localize(5,null)),submenu:A});this.setMenuById(A,"Go"),h.append(R)}if(this.shouldDrawMenu("Run")){const A=new p.Menu,R=new p.MenuItem({label:this.mnemonicLabel(d.localize(6,null)),submenu:A});this.setMenuById(A,"Run"),h.append(R)}if(this.shouldDrawMenu("Terminal")){const A=new p.Menu,R=new p.MenuItem({label:this.mnemonicLabel(d.localize(7,null)),submenu:A});this.setMenuById(A,"Terminal"),h.append(R)}let M;if(this.shouldDrawMenu("Window")){const A=new p.Menu;M=new p.MenuItem({label:this.mnemonicLabel(d.localize(8,null)),submenu:A,role:"window"}),this.setMacWindowMenu(A)}if(M&&h.append(M),this.shouldDrawMenu("Help")){const A=new p.Menu,R=new p.MenuItem({label:this.mnemonicLabel(d.localize(9,null)),submenu:A,role:"help"});this.setMenuById(A,"Help"),h.append(R)}h.items&&h.items.length>0?p.Menu.setApplicationMenu(h):p.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(o){const h=this.createMenuItem(d.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),w=this.getUpdateMenuItems();let M;if(this.shouldDrawMenu("Preferences")){const X=new p.Menu;this.setMenuById(X,"Preferences"),M=new p.MenuItem({label:this.mnemonicLabel(d.localize(11,null)),submenu:X})}const A=new p.Menu,R=new p.MenuItem({label:d.localize(12,null),role:"services",submenu:A}),T=new p.MenuItem({label:d.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),_=new p.MenuItem({label:d.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),Q=new p.MenuItem({label:d.localize(15,null),role:"unhide"}),ne=new p.MenuItem(this.likeAction("workbench.action.quit",{label:d.localize(16,null,this.productService.nameLong),click:()=>{const X=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||!!p.BrowserWindow.getFocusedWindow()||X?.isMinimized())&&this.nativeHostMainService.quit(void 0)}})),oe=[h];oe.push(...w),M&&oe.push(n(),M),oe.push(n(),R,n(),T,_,Q,n(),ne),oe.forEach(X=>o.append(X))}shouldDrawMenu(o){if(!P.isMacintosh&&(0,c.getTitleBarStyle)(this.configurationService)==="custom")return!1;switch(o){case"File":case"Help":if(P.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[o];case"Window":if(P.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[o]}}setMenu(o,h){h.forEach(w=>{if((0,S.isMenubarMenuItemSeparator)(w))o.append(n());else if((0,S.isMenubarMenuItemSubmenu)(w)){const M=new p.Menu,A=new p.MenuItem({label:this.mnemonicLabel(w.label),submenu:M});this.setMenu(M,w.submenu.items),o.append(A)}else(0,S.isMenubarMenuItemRecentAction)(w)?o.append(this.createOpenRecentMenuItem(w)):(0,S.isMenubarMenuItemAction)(w)&&(w.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(o),P.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[w.id]?o.append(new p.MenuItem(this.likeAction(w.id,{label:this.mnemonicLabel(w.label),click:this.fallbackMenuHandlers[w.id]}))):o.append(this.createMenuItem(w.label,w.id,!1,w.checked)):o.append(this.createMenuItem(w.label,w.id,w.enabled!==!1,!!w.checked)):o.append(this.createMenuItem(w.label,w.id,w.enabled!==!1,!!w.checked)))})}setMenuById(o,h){this.menubarMenus&&this.menubarMenus[h]&&this.setMenu(o,this.menubarMenus[h].items)}insertCheckForUpdatesItems(o){const h=this.getUpdateMenuItems();h.length&&(h.forEach(w=>o.append(w)),o.append(n()))}createOpenRecentMenuItem(o){const h=I.URI.revive(o.uri),w=o.id,M=w==="openRecentFile"?{fileUri:h}:w==="openRecentWorkspace"?{workspaceUri:h}:{folderUri:h};return new p.MenuItem(this.likeAction(w,{label:o.label,click:(A,R,T)=>{const _=this.isOptionClick(T);this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[M],forceNewWindow:_,gotoLineMode:!1,remoteAuthority:o.remoteAuthority}).length>0||this.workspacesHistoryMainService.removeRecentlyOpened([h])}},!1))}isOptionClick(o){return!!(o&&(!P.isMacintosh&&(o.ctrlKey||o.shiftKey)||P.isMacintosh&&(o.metaKey||o.altKey)))}createRoleMenuItem(o,h,w){const M={label:this.mnemonicLabel(o),role:w,enabled:!0};return new p.MenuItem(this.withKeybinding(h,M))}setMacWindowMenu(o){const h=new p.MenuItem({label:d.localize(17,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),w=new p.MenuItem({label:d.localize(18,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),M=new p.MenuItem({label:d.localize(19,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),A=this.createMenuItem(d.localize(20,null),"workbench.action.switchWindow"),R=[];this.currentEnableNativeTabs&&(R.push(n()),R.push(this.createMenuItem(d.localize(21,null),"workbench.action.newWindowTab")),R.push(this.createRoleMenuItem(d.localize(22,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),R.push(this.createRoleMenuItem(d.localize(23,null),"workbench.action.showNextWindowTab","selectNextTab")),R.push(this.createRoleMenuItem(d.localize(24,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),R.push(this.createRoleMenuItem(d.localize(25,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[h,w,n(),A,...R,n(),M].forEach(T=>o.append(T))}getUpdateMenuItems(){switch(this.updateService.state.type){case"uninitialized":return[];case"idle":return[new p.MenuItem({label:this.mnemonicLabel(d.localize(26,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case"checking for updates":return[new p.MenuItem({label:d.localize(27,null),enabled:!1})];case"available for download":return[new p.MenuItem({label:this.mnemonicLabel(d.localize(28,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new p.MenuItem({label:d.localize(29,null),enabled:!1})];case"downloaded":return[new p.MenuItem({label:this.mnemonicLabel(d.localize(30,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new p.MenuItem({label:d.localize(31,null),enabled:!1})];case"ready":return[new p.MenuItem({label:this.mnemonicLabel(d.localize(32,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})]}}createMenuItem(o,h,w,M){const A=this.mnemonicLabel(o),R=typeof h=="function"?h:(oe,X,O)=>{const H=oe?oe.userSettingsLabel:null;let q=h;Array.isArray(h)&&(q=this.isOptionClick(O)?h[1]:h[0]),H&&O.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:H}):this.runActionInRenderer({type:"commandId",commandId:q})},T=typeof w=="boolean"?w:this.windowsMainService.getWindowCount()>0,_=typeof M=="boolean"?M:!1,Q={label:A,click:R,enabled:T};_&&(Q.type="checkbox",Q.checked=_);let ne;return typeof h=="string"?ne=h:Array.isArray(h)&&(ne=h[0]),P.isMacintosh&&(ne==="editor.action.clipboardCutAction"?Q.role="cut":ne==="editor.action.clipboardCopyAction"?Q.role="copy":ne==="editor.action.clipboardPasteAction"&&(Q.role="paste"),ne==="undo"?Q.click=this.makeContextAwareClickHandler(R,{inDevTools:oe=>oe.undo(),inNoWindow:()=>p.Menu.sendActionToFirstResponder("undo:")}):ne==="redo"?Q.click=this.makeContextAwareClickHandler(R,{inDevTools:oe=>oe.redo(),inNoWindow:()=>p.Menu.sendActionToFirstResponder("redo:")}):ne==="editor.action.selectAll"&&(Q.click=this.makeContextAwareClickHandler(R,{inDevTools:oe=>oe.selectAll(),inNoWindow:()=>p.Menu.sendActionToFirstResponder("selectAll:")}))),new p.MenuItem(this.withKeybinding(ne,Q))}makeContextAwareClickHandler(o,h){return(w,M,A)=>{const R=p.BrowserWindow.getFocusedWindow();if(!R)return h.inNoWindow();if(R.webContents.isDevToolsFocused()&&R.webContents.devToolsWebContents)return h.inDevTools(R.webContents.devToolsWebContents);o(w,M||R,A)}}runActionInRenderer(o){let h=p.BrowserWindow.getFocusedWindow();if(!h){const M=this.windowsMainService.getLastActiveWindow();M?.isMinimized()&&(h=M.win)}const w=h?this.windowsMainService.getWindowById(h.id):void 0;if(w){if(this.logService.trace("menubar#runActionInRenderer",o),P.isMacintosh&&!this.environmentMainService.isBuilt&&!w.isReady&&(o.type==="commandId"&&o.commandId==="workbench.action.toggleDevTools"||o.type!=="commandId"&&o.userSettingsLabel==="alt+cmd+i"))return;if(o.type==="commandId"){const M={id:o.commandId,from:"menu"};w.sendWhenReady("vscode:runAction",D.CancellationToken.None,M)}else{const M={userSettingsLabel:o.userSettingsLabel};w.sendWhenReady("vscode:runKeybinding",D.CancellationToken.None,M)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",o)}withKeybinding(o,h){const w=typeof o=="string"?this.keybindings[o]:void 0;if(w?.label){if(w.isNative!==!1)h.accelerator=w.label,h.userSettingsLabel=w.userSettingsLabel;else if(typeof h.label=="string"){const M=h.label.indexOf("[");M>=0?h.label=`${h.label.substr(0,M)} [${w.label}]`:h.label=`${h.label} [${w.label}]`}}else h.accelerator=void 0;return h}likeAction(o,h,w=!h.accelerator){w&&(h=this.withKeybinding(o,h));const M=h.click;return h.click=(A,R,T)=>{this.reportMenuActionTelemetry(o),M&&M(A,R,T)},h}openUrl(o,h){this.nativeHostMainService.openExternal(void 0,o),this.reportMenuActionTelemetry(h)}reportMenuActionTelemetry(o){this.telemetryService.publicLog2("workbenchActionExecuted",{id:o,from:s})}mnemonicLabel(o){return(0,C.mnemonicMenuLabel)(o,!this.currentEnableMenuBarMnemonics)}};l.lastKnownMenubarStorageKey="lastKnownMenubarData",l=fe([ie(0,k.IUpdateService),ie(1,f.IConfigurationService),ie(2,a.IWindowsMainService),ie(3,y.IEnvironmentMainService),ie(4,v.ITelemetryService),ie(5,u.IWorkspacesHistoryMainService),ie(6,E.IStateMainService),ie(7,b.ILifecycleMainService),ie(8,m.ILogService),ie(9,t.INativeHostMainService),ie(10,g.IProductService)],l),e.Menubar=l;function n(){return new p.MenuItem({type:"separator"})}}),define(Z[241],x([0,1,5,20,6,240]),function(j,e,p,r,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,p.createDecorator)("menubarMainService");let P=class{constructor(d,f,y){this.instantiationService=d,this.lifecycleMainService=f,this.logService=y,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(C.Menubar)}async updateMenubar(d,f){this.logService.trace("menubarService#updateMenubar",d),(await this.menubar).updateMenu(f,d)}};P=fe([ie(0,p.IInstantiationService),ie(1,r.ILifecycleMainService),ie(2,D.ILogService)],P),e.MenubarMainService=P}),define(Z[242],x([0,1,14,27,26,30,23,4,32,42,33,2,10,8,63,3,34,15,13,7,155,52,19,50,24,18,5,20,6,54,22,55,64,37,67,239,100,221,29,101,68,45]),function(j,e,p,r,D,C,P,I,d,f,y,b,m,S,t,g,E,v,k,c,a,u,s,l,n,i,o,h,w,M,A,R,T,_,Q,ne,oe,X,O,H,q,Y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function $(B){return(0,O.isWorkspaceIdentifier)(B?.workspace)}function K(B){return(0,O.isSingleFolderWorkspaceIdentifier)(B?.workspace)}let te=class it extends b.Disposable{constructor(L,W,F,N,V,U,z,ee,re,se,J,ce,le,ue,me){super();this.machineId=L,this.initialUserEnv=W,this.logService=F,this.stateMainService=N,this.environmentMainService=V,this.lifecycleMainService=U,this.backupMainService=z,this.configurationService=ee,this.workspacesHistoryMainService=re,this.workspacesManagementMainService=se,this.instantiationService=J,this.dialogMainService=ce,this.fileService=le,this.productService=ue,this.protocolMainService=me,this._onDidOpenWindow=this._register(new I.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new I.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new I.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new I.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this.windowsStateHandler=this._register(new X.WindowsStateHandler(this,this.stateMainService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(L=>this._onDidSignalReadyWindow.fire(L.window))),this._register(this.onDidSignalReadyWindow(L=>{if(L.config?.extensionDevelopmentPath||L.config?.extensionTestsPath){const W=new b.DisposableStore;if(W.add(I.Event.any(L.onDidClose,L.onDidDestroy)(()=>W.dispose())),L.config.extensionDevelopmentPath)for(const F of L.config.extensionDevelopmentPath)W.add(this.protocolMainService.addValidFileRoot(c.URI.file(F)));L.config.extensionTestsPath&&W.add(this.protocolMainService.addValidFileRoot(c.URI.file(L.config.extensionTestsPath)))}}))}openEmptyWindow(L,W){let F=this.environmentMainService.args;const N=W?.remoteAuthority||void 0,V=!0,U=W?.forceReuseWindow,z=!U;return this.open({...L,cli:F,forceEmpty:V,forceNewWindow:z,forceReuseWindow:U,remoteAuthority:N})}openExistingWindow(L,W){L.focus(),this.handleWaitMarkerFile(W,[L])}open(L){this.logService.trace("windowsManager#open"),L.addMode&&(L.initialStartup||!this.getLastActiveWindow())&&(L.addMode=!1);const W=[],F=[],N=[],V=[],U=[];let z,ee=0;const re=this.getPathsToOpen(L);this.logService.trace("windowsManager#open pathsToOpen",re);for(const le of re)K(le)?L.addMode?W.push(le):F.push(le):$(le)?N.push(le):le.fileUri?(z||(z={filesToOpenOrCreate:[],filesToDiff:[],remoteAuthority:le.remoteAuthority}),z.filesToOpenOrCreate.push(le)):le.backupPath?U.push({backupFolder:(0,S.basename)(le.backupPath),remoteAuthority:le.remoteAuthority}):ee++;L.diffMode&&z&&z.filesToOpenOrCreate.length>=2&&(z.filesToDiff=z.filesToOpenOrCreate.slice(0,2),z.filesToOpenOrCreate=[]),z&&L.waitMarkerFileURI&&(z.filesToWait={paths:[...z.filesToDiff,...z.filesToOpenOrCreate],waitMarkerFileUri:L.waitMarkerFileURI}),L.initialStartup?(V.push(...this.workspacesManagementMainService.getUntitledWorkspacesSync()),N.push(...V),U.push(...this.backupMainService.getEmptyWindowBackupPaths())):U.length=0;const{windows:se,filesOpenedInWindow:J}=this.doOpen(L,N,F,U,ee,z,W);if(this.logService.trace(`windowsManager#open used window count ${se.length} (workspacesToOpen: ${N.length}, foldersToOpen: ${F.length}, emptyToRestore: ${U.length}, emptyToOpen: ${ee})`),se.length>1)if(J)J.focus();else{const le=this.windowsStateHandler.state.lastActiveWindow&&!L.forceEmpty&&!L.cli._.length&&!L.cli["file-uri"]&&!L.cli["folder-uri"]&&!(L.urisToOpen&&L.urisToOpen.length);let ue=!0,me=!0;if(le){const Ee=se.filter(de=>this.windowsStateHandler.state.lastActiveWindow&&de.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);Ee.length&&(Ee[0].focus(),ue=!1,me=!1)}if(ue)for(let Ee=se.length-1;Ee>=0;Ee--){const de=se[Ee];if(!(de.openedWorkspace&&V.some(ge=>de.openedWorkspace&&ge.workspace.id===de.openedWorkspace.id)||de.backupPath&&U.some(ge=>de.backupPath&&ge.backupFolder===(0,S.basename)(de.backupPath)))){de.focus(),me=!1;break}}me&&se[se.length-1].focus()}const ce=z&&z.filesToDiff.length>0;if(!se.some(le=>le.isExtensionDevelopmentHost)&&!ce&&!L.noRecentEntry){const le=[];for(const ue of re)$(ue)&&!ue.transient?le.push({label:ue.label,workspace:ue.workspace,remoteAuthority:ue.remoteAuthority}):K(ue)?le.push({label:ue.label,folderUri:ue.workspace.uri,remoteAuthority:ue.remoteAuthority}):ue.fileUri&&le.push({label:ue.label,fileUri:ue.fileUri,remoteAuthority:ue.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(le)}return this.handleWaitMarkerFile(L,se),se}handleWaitMarkerFile(L,W){const F=L.waitMarkerFileURI;L.context===0&&F&&W.length===1&&W[0]&&(async()=>{await W[0].whenClosedOrLoaded;try{await this.fileService.del(F)}catch{}})()}doOpen(L,W,F,N,V,U,z){const ee=[];let re;function se(de,ge){ee.push(de),ge&&(re=de,U=void 0)}let{openFolderInNewWindow:J,openFilesInNewWindow:ce}=this.shouldOpenNewWindow(L);if(!L.initialStartup&&z.length>0){const de=z[0].remoteAuthority,ge=this.getLastActiveWindowForAuthority(de);ge&&se(this.doAddFoldersToExistingWindow(ge,z.map(pe=>pe.workspace.uri)))}const le=F.length+W.length+N.length;if(U&&le===0){const de=U.filesToOpenOrCreate[0]||U.filesToDiff[0],ge=this.getWindows().filter(ke=>U&&(0,v.isEqualAuthority)(ke.remoteAuthority,U.remoteAuthority));let pe;de?.fileUri&&!ce&&((L.context===4||L.context===0||L.context===1)&&(pe=(0,oe.findWindowOnFile)(ge,de.fileUri,ke=>ke.configPath.scheme===m.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspaceSync(ke.configPath):void 0)),pe||(pe=this.doGetLastActiveWindow(ge))),pe?(0,O.isWorkspaceIdentifier)(pe.openedWorkspace)?W.push({workspace:pe.openedWorkspace,remoteAuthority:pe.remoteAuthority}):(0,O.isSingleFolderWorkspaceIdentifier)(pe.openedWorkspace)?F.push({workspace:pe.openedWorkspace,remoteAuthority:pe.remoteAuthority}):se(this.doOpenFilesInExistingWindow(L,pe,U),!0):se(this.openInBrowserWindow({userEnv:L.userEnv,cli:L.cli,initialStartup:L.initialStartup,filesToOpen:U,forceNewWindow:!0,remoteAuthority:U.remoteAuthority,forceNewTabbedWindow:L.forceNewTabbedWindow}),!0)}const ue=(0,C.distinct)(W,de=>de.workspace.id);if(ue.length>0){const de=(0,C.coalesce)(ue.map(ge=>(0,oe.findWindowOnWorkspaceOrFolder)(this.getWindows(),ge.workspace.configPath)));if(de.length>0){const ge=de[0],pe=(0,v.isEqualAuthority)(U?.remoteAuthority,ge.remoteAuthority)?U:void 0;se(this.doOpenFilesInExistingWindow(L,ge,pe),!!pe),J=!0}ue.forEach(ge=>{if(de.some(Re=>Re.openedWorkspace&&Re.openedWorkspace.id===ge.workspace.id))return;const pe=ge.remoteAuthority,ke=(0,v.isEqualAuthority)(U?.remoteAuthority,pe)?U:void 0;se(this.doOpenFolderOrWorkspace(L,ge,J,ke),!!ke),J=!0})}const me=(0,C.distinct)(F,de=>v.extUriBiasedIgnorePathCase.getComparisonKey(de.workspace.uri));if(me.length>0){const de=(0,C.coalesce)(me.map(ge=>(0,oe.findWindowOnWorkspaceOrFolder)(this.getWindows(),ge.workspace.uri)));if(de.length>0){const ge=de[0],pe=(0,v.isEqualAuthority)(U?.remoteAuthority,ge.remoteAuthority)?U:void 0;se(this.doOpenFilesInExistingWindow(L,ge,pe),!!pe),J=!0}me.forEach(ge=>{if(de.some(Re=>(0,O.isSingleFolderWorkspaceIdentifier)(Re.openedWorkspace)&&v.extUriBiasedIgnorePathCase.isEqual(Re.openedWorkspace.uri,ge.workspace.uri)))return;const pe=ge.remoteAuthority,ke=(0,v.isEqualAuthority)(U?.remoteAuthority,pe)?U:void 0;se(this.doOpenFolderOrWorkspace(L,ge,J,ke),!!ke),J=!0})}const Ee=(0,C.distinct)(N,de=>de.backupFolder);if(Ee.length>0&&Ee.forEach(de=>{const ge=de.remoteAuthority,pe=(0,v.isEqualAuthority)(U?.remoteAuthority,ge)?U:void 0;se(this.doOpenEmpty(L,!0,ge,pe,de),!!pe),J=!0}),ee.length===0||U){U&&!V&&V++;const de=U?U.remoteAuthority:L.remoteAuthority;for(let ge=0;ge<V;ge++)se(this.doOpenEmpty(L,J,de,U),!!U),J=!0}return{windows:(0,C.distinct)(ee),filesOpenedInWindow:re}}doOpenFilesInExistingWindow(L,W,F){this.logService.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:F}),W.focus();const N={filesToOpenOrCreate:F?.filesToOpenOrCreate,filesToDiff:F?.filesToDiff,filesToWait:F?.filesToWait,termProgram:L?.userEnv?.TERM_PROGRAM};return W.sendWhenReady("vscode:openFiles",P.CancellationToken.None,N),W}doAddFoldersToExistingWindow(L,W){this.logService.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:W}),L.focus();const F={foldersToAdd:W};return L.sendWhenReady("vscode:addFolders",P.CancellationToken.None,F),L}doOpenEmpty(L,W,F,N,V){this.logService.trace("windowsManager#doOpenEmpty",{restore:!!V,remoteAuthority:F,filesToOpen:N,forceNewWindow:W});let U;return!W&&typeof L.contextWindowId=="number"&&(U=this.getWindowById(L.contextWindowId)),this.openInBrowserWindow({userEnv:L.userEnv,cli:L.cli,initialStartup:L.initialStartup,remoteAuthority:F,forceNewWindow:W,forceNewTabbedWindow:L.forceNewTabbedWindow,filesToOpen:N,windowToUse:U,emptyWindowBackupInfo:V})}doOpenFolderOrWorkspace(L,W,F,N,V){return this.logService.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:W,filesToOpen:N}),!F&&!V&&typeof L.contextWindowId=="number"&&(V=this.getWindowById(L.contextWindowId)),this.openInBrowserWindow({workspace:W.workspace,userEnv:L.userEnv,cli:L.cli,initialStartup:L.initialStartup,remoteAuthority:W.remoteAuthority,forceNewWindow:F,forceNewTabbedWindow:L.forceNewTabbedWindow,filesToOpen:N,windowToUse:V})}getPathsToOpen(L){let W,F=!1,N=!1;if(L.urisToOpen&&L.urisToOpen.length>0?(W=this.doExtractPathsFromAPI(L),F=!0):L.forceEmpty?W=[Object.create(null)]:L.cli._.length||L.cli["folder-uri"]||L.cli["file-uri"]?(W=this.doExtractPathsFromCLI(L.cli),W.length===0&&W.push(Object.create(null)),F=!0):(W=this.doGetPathsFromLastSession(),W.length===0&&W.push(Object.create(null)),N=!0),!L.addMode&&F){const V=W.filter(U=>K(U));if(V.length>1){const U=V[0].remoteAuthority;if(V.every(z=>(0,v.isEqualAuthority)(z.remoteAuthority,U))){const z=this.workspacesManagementMainService.createUntitledWorkspaceSync(V.map(ee=>({uri:ee.workspace.uri})));W.push({workspace:z,remoteAuthority:U}),W=W.filter(ee=>!K(ee))}}}return L.initialStartup&&!N&&this.configurationService.getValue("window")?.restoreWindows==="preserve"&&W.unshift(...this.doGetPathsFromLastSession().filter(V=>$(V)||K(V)||V.backupPath)),W}doExtractPathsFromAPI(L){const W=[],F={gotoLineMode:L.gotoLineMode,remoteAuthority:L.remoteAuthority};for(const N of(0,C.coalesce)(L.urisToOpen||[])){const V=this.resolveOpenable(N,F);if(V)V.label=N.label,W.push(V);else{const U=this.resourceFromOpenable(N),z={title:this.productService.nameLong,type:"info",buttons:[(0,y.mnemonicButtonLabel)((0,a.localize)(0,null))],defaultId:0,message:U.scheme===m.Schemas.file?(0,a.localize)(1,null):(0,a.localize)(2,null),detail:U.scheme===m.Schemas.file?(0,a.localize)(3,null,(0,y.getPathLabel)(U.fsPath,this.environmentMainService)):(0,a.localize)(4,null,U.toString()),noLink:!0};this.dialogMainService.showMessageBox(z,(0,k.withNullAsUndefined)(p.BrowserWindow.getFocusedWindow()))}}return W}doExtractPathsFromCLI(L){const W=[],F={ignoreFileNotFound:!0,gotoLineMode:L.goto,remoteAuthority:L.remote||void 0,forceOpenWorkspaceAsFile:!1},N=L["folder-uri"];if(N)for(const z of N){const ee=this.cliArgToUri(z);if(ee){const re=this.resolveOpenable({folderUri:ee},F);re&&W.push(re)}}const V=L["file-uri"];if(V)for(const z of V){const ee=this.cliArgToUri(z);if(ee){const re=this.resolveOpenable((0,O.hasWorkspaceFileExtension)(z)?{workspaceUri:ee}:{fileUri:ee},F);re&&W.push(re)}}const U=L._;for(const z of U){const ee=F.remoteAuthority?this.doResolvePathRemote(z,F):this.doResolveFilePath(z,F);ee&&W.push(ee)}return W}cliArgToUri(L){try{const W=c.URI.parse(L);if(!W.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${L}`);return}return W}catch(W){this.logService.error(`Invalid URI input string: ${L}, ${W.message}`)}}doGetPathsFromLastSession(){const L=this.getRestoreWindowsSetting();switch(L){case"none":return[];case"one":case"all":case"preserve":case"folders":const W=[];L!=="one"&&W.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&W.push(this.windowsStateHandler.state.lastActiveWindow);const F=[];for(const N of W)if(N.workspace){const V=this.resolveOpenable({workspaceUri:N.workspace.configPath},{remoteAuthority:N.remoteAuthority,rejectTransientWorkspaces:!0});$(V)&&F.push(V)}else if(N.folderUri){const V=this.resolveOpenable({folderUri:N.folderUri},{remoteAuthority:N.remoteAuthority});K(V)&&F.push(V)}else L!=="folders"&&N.backupPath&&F.push({backupPath:N.backupPath,remoteAuthority:N.remoteAuthority});return F}}getRestoreWindowsSetting(){let L;return this.lifecycleMainService.wasRestarted?L="all":(L=this.configurationService.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(L)||(L="all")),L}resolveOpenable(L,W=Object.create(null)){let F=this.resourceFromOpenable(L);return F.scheme===m.Schemas.file?((0,Q.isFileToOpen)(L)&&(W={...W,forceOpenWorkspaceAsFile:!0}),this.doResolveFilePath(F.fsPath,W)):this.doResolveRemoteOpenable(L,W)}doResolveRemoteOpenable(L,W){let F=this.resourceFromOpenable(L);const N=(0,T.getRemoteAuthority)(F)||W.remoteAuthority;if(F=(0,v.removeTrailingPathSeparator)((0,v.normalizePath)(F)),(0,Q.isFileToOpen)(L)){if(W.gotoLineMode){const{path:V,line:U,column:z}=(0,d.parseLineAndColumnAware)(F.path);return{fileUri:F.with({path:V}),selection:U?{startLineNumber:U,startColumn:z||1}:void 0,remoteAuthority:N}}return{fileUri:F,remoteAuthority:N}}else if((0,Q.isWorkspaceToOpen)(L))return{workspace:(0,H.getWorkspaceIdentifier)(F),remoteAuthority:N};return{workspace:(0,H.getSingleFolderWorkspaceIdentifier)(F),remoteAuthority:N}}resourceFromOpenable(L){return(0,Q.isWorkspaceToOpen)(L)?L.workspaceUri:(0,Q.isFolderToOpen)(L)?L.folderUri:L.fileUri}doResolveFilePath(L,W){let F,N;W.gotoLineMode&&({path:L,line:F,column:N}=(0,d.parseLineAndColumnAware)(L)),L=(0,d.sanitizeFilePath)((0,S.normalize)(L),(0,E.cwd)());try{const V=(0,r.statSync)(L);if(V.isFile()){if(!W.forceOpenWorkspaceAsFile){const U=this.workspacesManagementMainService.resolveLocalWorkspaceSync(c.URI.file(L));if(U)return U.transient&&W.rejectTransientWorkspaces?void 0:{workspace:{id:U.id,configPath:U.configPath},type:i.FileType.File,exists:!0,remoteAuthority:U.remoteAuthority,transient:U.transient}}return{fileUri:c.URI.file(L),type:i.FileType.File,exists:!0,selection:F?{startLineNumber:F,startColumn:N||1}:void 0}}else{if(V.isDirectory())return{workspace:(0,H.getSingleFolderWorkspaceIdentifier)(c.URI.file(L),V),type:i.FileType.Directory,exists:!0};if(!g.isWindows&&L==="/dev/null")return{fileUri:c.URI.file(L),type:i.FileType.File,exists:!0}}}catch{const U=c.URI.file(L);if(this.workspacesHistoryMainService.removeRecentlyOpened([U]),W.ignoreFileNotFound)return{fileUri:U,type:i.FileType.File,exists:!1}}}doResolvePathRemote(L,W){const F=L.charCodeAt(0),N=W.remoteAuthority;let V,U;W.gotoLineMode&&({path:L,line:V,column:U}=(0,d.parseLineAndColumnAware)(L)),F!==47&&((0,d.isWindowsDriveLetter)(F)&&L.charCodeAt(L.charCodeAt(1))===58&&(L=(0,d.toSlashes)(L)),L=`/${L}`);const z=c.URI.from({scheme:m.Schemas.vscodeRemote,authority:N,path:L});if(L.charCodeAt(L.length-1)!==47){if((0,O.hasWorkspaceFileExtension)(L))return W.forceOpenWorkspaceAsFile?{fileUri:z,selection:V?{startLineNumber:V,startColumn:U||1}:void 0,remoteAuthority:W.remoteAuthority}:{workspace:(0,H.getWorkspaceIdentifier)(z),remoteAuthority:N};if(W.gotoLineMode||S.posix.basename(L).indexOf(".")!==-1)return{fileUri:z,selection:V?{startLineNumber:V,startColumn:U||1}:void 0,remoteAuthority:N}}return{workspace:(0,H.getSingleFolderWorkspaceIdentifier)(z),remoteAuthority:N}}shouldOpenNewWindow(L){const W=this.configurationService.getValue("window"),F=W?.openFoldersInNewWindow||"default",N=W?.openFilesInNewWindow||"off";let V=(L.preferNewWindow||L.forceNewWindow)&&!L.forceReuseWindow;!L.forceNewWindow&&!L.forceReuseWindow&&(F==="on"||F==="off")&&(V=F==="on");let U=!1;return L.forceNewWindow||L.forceReuseWindow?U=!!L.forceNewWindow&&!L.forceReuseWindow:(g.isMacintosh?L.context===1&&(U=!0):L.context!==3&&L.context!==2&&!(L.userEnv&&L.userEnv.TERM_PROGRAM==="vscode")&&(U=!0),!L.cli.extensionDevelopmentPath&&(N==="on"||N==="off")&&(U=N==="on")),{openFolderInNewWindow:!!V,openFilesInNewWindow:U}}openExtensionDevelopmentHostWindow(L,W){const F=(0,oe.findWindowOnExtensionDevelopmentPath)(this.getWindows(),L);if(F)return this.lifecycleMainService.reload(F,W.cli),F.focus(),[F];let N=W.cli["folder-uri"]||[],V=W.cli["file-uri"]||[],U=W.cli._;if(!U.length&&!N.length&&!V.length&&!W.cli.extensionTestsPath){const se=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,J=se&&(se.workspace||se.folderUri);J&&(c.URI.isUri(J)?J.scheme===m.Schemas.file?U=[J.fsPath]:N=[J.toString()]:J.configPath.scheme===m.Schemas.file?U=[(0,v.originalFSPath)(J.configPath)]:V=[J.configPath.toString()])}let z=W.remoteAuthority;for(const se of L)if(se.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const J=c.URI.parse(se),ce=(0,T.getRemoteAuthority)(J);ce&&(z?(0,v.isEqualAuthority)(ce,z)||this.logService.error("more than one extension development path authority"):z=ce)}U=U.filter(se=>{const J=c.URI.file(se);return(0,oe.findWindowOnWorkspaceOrFolder)(this.getWindows(),J)?!1:(0,v.isEqualAuthority)((0,T.getRemoteAuthority)(J),z)}),N=N.filter(se=>{const J=this.cliArgToUri(se);return J&&!!(0,oe.findWindowOnWorkspaceOrFolder)(this.getWindows(),J)?!1:J?(0,v.isEqualAuthority)((0,T.getRemoteAuthority)(J),z):!1}),V=V.filter(se=>{const J=this.cliArgToUri(se);return J&&!!(0,oe.findWindowOnWorkspaceOrFolder)(this.getWindows(),J)?!1:J?(0,v.isEqualAuthority)((0,T.getRemoteAuthority)(J),z):!1}),W.cli._=U,W.cli["folder-uri"]=N,W.cli["file-uri"]=V;const ee=!U.length&&!N.length&&!V.length,re={context:W.context,cli:W.cli,forceNewWindow:!0,forceEmpty:ee,userEnv:W.userEnv,noRecentEntry:!0,waitMarkerFileURI:W.waitMarkerFileURI,remoteAuthority:z};return this.open(re)}openInBrowserWindow(L){const W=this.configurationService.getValue("window"),F={...this.environmentMainService.args,...L.cli,machineId:this.machineId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,codeCachePath:this.environmentMainService.codeCachePath,backupPath:L.emptyWindowBackupInfo?(0,S.join)(this.environmentMainService.backupHome,L.emptyWindowBackupInfo.backupFolder):void 0,homeDir:this.environmentMainService.userHome.fsPath,tmpDir:this.environmentMainService.tmpDir.fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:L.remoteAuthority,workspace:L.workspace,userEnv:{...this.initialUserEnv,...L.userEnv},filesToOpenOrCreate:L.filesToOpen?.filesToOpenOrCreate,filesToDiff:L.filesToOpen?.filesToDiff,filesToWait:L.filesToOpen?.filesToWait,logLevel:this.logService.getLevel(),logsPath:this.environmentMainService.logsPath,product:M.default,isInitialStartup:L.initialStartup,perfMarks:(0,t.getMarks)(),os:{release:(0,D.release)(),hostname:(0,D.hostname)()},zoomLevel:typeof W?.zoomLevel=="number"?W.zoomLevel:void 0,autoDetectHighContrast:W?.autoDetectHighContrast??!0,accessibilitySupport:p.app.accessibilitySupportEnabled,colorScheme:{dark:p.nativeTheme.shouldUseDarkColors,highContrast:p.nativeTheme.shouldUseInvertedColorScheme||p.nativeTheme.shouldUseHighContrastColors}};let N;if(!L.forceNewWindow&&!L.forceNewTabbedWindow&&(N=L.windowToUse||this.getLastActiveWindow(),N&&N.focus()),N){const V=N.config;!F.extensionDevelopmentPath&&V&&!!V.extensionDevelopmentPath&&(F.extensionDevelopmentPath=V.extensionDevelopmentPath,F.verbose=V.verbose,F["inspect-brk-extensions"]=V["inspect-brk-extensions"],F.debugId=V.debugId,F.extensionEnvironment=V.extensionEnvironment,F["inspect-extensions"]=V["inspect-extensions"],F["extensions-dir"]=V["extensions-dir"])}else{const V=this.windowsStateHandler.getNewWindowState(F);(0,t.mark)("code/willCreateCodeWindow");const U=N=this.instantiationService.createInstance(ne.CodeWindow,{state:V,extensionDevelopmentPath:F.extensionDevelopmentPath,isExtensionTestHost:!!F.extensionTestsPath});if((0,t.mark)("code/didCreateCodeWindow"),L.forceNewTabbedWindow){const ee=this.getLastActiveWindow();ee&&ee.addTabbedWindow(U)}it.WINDOWS.push(U),this._onDidOpenWindow.fire(U),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,f.once)(U.onDidSignalReady)(()=>this._onDidSignalReadyWindow.fire(U)),(0,f.once)(U.onDidClose)(()=>this.onWindowClosed(U)),(0,f.once)(U.onDidDestroy)(()=>this._onDidDestroyWindow.fire(U));const z=(0,k.assertIsDefined)(U.win?.webContents);z.removeAllListeners("devtools-reload-page"),z.on("devtools-reload-page",()=>this.lifecycleMainService.reload(U)),this.lifecycleMainService.registerWindow(U)}return F.windowId=N.id,N.isReady?this.lifecycleMainService.unload(N,4).then(V=>{V||this.doOpenInBrowserWindow(N,F,L)}):this.doOpenInBrowserWindow(N,F,L),N}doOpenInBrowserWindow(L,W,F){if(!W.extensionDevelopmentPath)if((0,O.isWorkspaceIdentifier)(W.workspace))W.backupPath=this.backupMainService.registerWorkspaceBackupSync({workspace:W.workspace,remoteAuthority:W.remoteAuthority});else if((0,O.isSingleFolderWorkspaceIdentifier)(W.workspace))W.backupPath=this.backupMainService.registerFolderBackupSync({folderUri:W.workspace.uri,remoteAuthority:W.remoteAuthority});else{const N=F.emptyWindowBackupInfo&&F.emptyWindowBackupInfo.backupFolder;W.backupPath=this.backupMainService.registerEmptyWindowBackupSync(N,W.remoteAuthority)}L.load(W)}onWindowClosed(L){const W=it.WINDOWS.indexOf(L);it.WINDOWS.splice(W,1),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const L=p.BrowserWindow.getFocusedWindow();if(L)return this.getWindowById(L.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(L){return this.doGetLastActiveWindow(this.getWindows().filter(W=>(0,v.isEqualAuthority)(W.remoteAuthority,L)))}doGetLastActiveWindow(L){const W=Math.max.apply(Math,L.map(F=>F.lastFocusTime));return L.find(F=>F.lastFocusTime===W)}sendToFocused(L,...W){const F=this.getFocusedWindow()||this.getLastActiveWindow();F&&F.sendWhenReady(L,P.CancellationToken.None,...W)}sendToAll(L,W,F){for(const N of this.getWindows())F&&F.indexOf(N.id)>=0||N.sendWhenReady(L,P.CancellationToken.None,W)}getWindows(){return it.WINDOWS}getWindowCount(){return it.WINDOWS.length}getWindowById(L){const W=this.getWindows().filter(F=>F.id===L);return(0,C.firstOrDefault)(W)}getWindowByWebContents(L){const W=p.BrowserWindow.fromWebContents(L);if(!!W)return this.getWindowById(W.id)}};te.WINDOWS=[],te=fe([ie(2,w.ILogService),ie(3,_.IStateMainService),ie(4,n.IEnvironmentMainService),ie(5,h.ILifecycleMainService),ie(6,u.IBackupMainService),ie(7,s.IConfigurationService),ie(8,q.IWorkspacesHistoryMainService),ie(9,Y.IWorkspacesManagementMainService),ie(10,o.IInstantiationService),ie(11,l.IDialogMainService),ie(12,i.IFileService),ie(13,A.IProductService),ie(14,R.IProtocolMainService)],te),e.WindowsMainService=te}),define(Z[243],x([0,1,52,35,68,45]),function(j,e,p,r,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let P=class{constructor(d,f,y,b){this.workspacesManagementMainService=d,this.windowsMainService=f,this.workspacesHistoryMainService=y,this.backupMainService=b,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(d,f){const y=this.windowsMainService.getWindowById(d);if(y)return this.workspacesManagementMainService.enterWorkspace(y,this.windowsMainService.getWindows(),f)}createUntitledWorkspace(d,f,y){return this.workspacesManagementMainService.createUntitledWorkspace(f,y)}deleteUntitledWorkspace(d,f){return this.workspacesManagementMainService.deleteUntitledWorkspace(f)}getWorkspaceIdentifier(d,f){return this.workspacesManagementMainService.getWorkspaceIdentifier(f)}async getRecentlyOpened(d){return this.workspacesHistoryMainService.getRecentlyOpened(this.windowsMainService.getWindowById(d))}async addRecentlyOpened(d,f){return this.workspacesHistoryMainService.addRecentlyOpened(f)}async removeRecentlyOpened(d,f){return this.workspacesHistoryMainService.removeRecentlyOpened(f)}async clearRecentlyOpened(d){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};P=fe([ie(0,C.IWorkspacesManagementMainService),ie(1,r.IWindowsMainService),ie(2,D.IWorkspacesHistoryMainService),ie(3,p.IBackupMainService)],P),e.WorkspacesMainService=P}),define(Z[244],x([0,1,14,27,26,17,44,16,32,42,38,33,2,10,8,3,15,13,7,31,71,121,36,124,85,235,134,52,225,19,180,163,74,50,226,88,24,53,90,171,188,172,222,89,173,18,183,93,73,5,75,236,201,102,20,6,185,241,51,22,64,231,76,37,219,99,202,28,204,206,65,41,210,233,237,234,238,98,211,212,213,214,216,35,242,217,29,68,243,45]),function(j,e,p,r,D,C,P,I,d,f,y,b,m,S,t,g,E,v,k,c,a,u,s,l,n,i,o,h,w,M,A,R,T,_,Q,ne,oe,X,O,H,q,Y,$,K,te,B,L,W,F,N,V,U,z,ee,re,se,J,ce,le,ue,me,Ee,de,ge,pe,ke,Re,Fe,$e,ze,Qe,Ge,gt,Je,at,ct,Ve,He,G,ae,he,ve,Ie,Ce,Te,We,Oe,Ne,je,bt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let mt=class extends m.Disposable{constructor(we,ye,be,Se,Pe,De,Me,Le,Ae,Xe){super();this.mainProcessNodeIpcServer=we,this.userEnv=ye,this.mainInstantiationService=be,this.logService=Se,this.environmentMainService=Pe,this.lifecycleMainService=De,this.configurationService=Me,this.stateMainService=Le,this.fileService=Ae,this.productService=Xe,this.configureSession(),this.registerListeners()}configureSession(){const we=Se=>Se?.startsWith(`${S.Schemas.vscodeWebview}://`),ye=new Set(["clipboard-read","clipboard-sanitized-write"]);p.session.defaultSession.setPermissionRequestHandler((Se,Pe,De,Me)=>we(Me.requestingUrl)?De(ye.has(Pe)):De(!1)),p.session.defaultSession.setPermissionCheckHandler((Se,Pe,De,Me)=>we(Me.requestingUrl)?ye.has(Pe):!1);const be=p.session.defaultSession;typeof be.setCodeCachePath=="function"&&this.environmentMainService.codeCachePath&&be.setCodeCachePath((0,t.join)(this.environmentMainService.codeCachePath,"chrome"))}registerListeners(){(0,I.setUnexpectedErrorHandler)(be=>this.onUnexpectedError(be)),process.on("uncaughtException",be=>(0,I.onUnexpectedError)(be)),process.on("unhandledRejection",be=>(0,I.onUnexpectedError)(be)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),(0,u.registerContextMenuListener)(),p.app.on("accessibility-support-changed",(be,Se)=>{this.windowsMainService?.sendToAll("vscode:accessibilitySupportChanged",Se)}),p.app.on("activate",(be,Se)=>{this.logService.trace("app#activate"),Se||this.windowsMainService?.openEmptyWindow({context:1})}),p.app.on("web-contents-created",(be,Se)=>{Se.on("will-navigate",Pe=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),Pe.preventDefault()}),Se.setWindowOpenHandler(({url:Pe})=>(this.nativeHostMainService?.openExternal(void 0,Pe),{action:"deny"}))});let we=[],ye;p.app.on("open-file",(be,Se)=>{this.logService.trace("app#open-file: ",Se),be.preventDefault(),we.push(this.getWindowOpenableFromPathSync(Se)),ye!==void 0&&(clearTimeout(ye),ye=void 0),ye=setTimeout(()=>{this.windowsMainService?.open({context:1,cli:this.environmentMainService.args,urisToOpen:we,gotoLineMode:!1,preferNewWindow:!0}),we=[],ye=void 0},100)}),p.app.on("new-window-for-tab",()=>{this.windowsMainService?.openEmptyWindow({context:4})}),p.ipcMain.handle("vscode:fetchShellEnv",be=>{const Se=this.windowsMainService?.getWindowByWebContents(be.sender);let Pe,De;return Se?.config?(Pe=Se.config,De={...process.env,...Se.config.userEnv}):(Pe=this.environmentMainService.args,De=process.env),this.resolveShellEnvironment(Pe,De,!1)}),p.ipcMain.handle("vscode:writeNlsFile",(be,Se,Pe)=>{const De=this.validateNlsPath([Se]);if(!De||typeof Pe!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(De,C.VSBuffer.fromString(Pe))}),p.ipcMain.handle("vscode:readNlsFile",async(be,...Se)=>{const Pe=this.validateNlsPath(Se);if(!Pe)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(Pe)).value.toString()}),p.ipcMain.on("vscode:toggleDevTools",be=>be.sender.toggleDevTools()),p.ipcMain.on("vscode:openDevTools",be=>be.sender.openDevTools()),p.ipcMain.on("vscode:reloadWindow",be=>be.sender.reload())}validateNlsPath(we){let ye;for(const be of we)typeof be=="string"&&(typeof ye!="string"?ye=be:ye=(0,t.join)(ye,be));if(!(typeof ye!="string"||!(0,t.isAbsolute)(ye)||!(0,d.isEqualOrParent)(ye,this.environmentMainService.cachedLanguagesPath,!g.isLinux)))return k.URI.file(ye)}onUnexpectedError(we){if(we){const ye={message:`[uncaught exception in main]: ${we.message}`,stack:we.stack};this.windowsMainService?.sendToFocused("vscode:reportError",JSON.stringify(ye))}this.logService.error(`[uncaught exception in main]: ${we}`),we.stack&&this.logService.error(we.stack)}async startup(){this.logService.debug("Starting VS Code"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);const we=this.productService.win32AppUserModelId;g.isWindows&&we&&p.app.setAppUserModelId(we);try{g.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!p.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&p.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Ae){this.logService.error(Ae)}const ye=new l.Server;this.logService.trace("Resolving machine identifier...");const be=await this.resolveMachineId();this.logService.trace(`Resolved machine identifier: ${be}`);const{sharedProcess:Se,sharedProcessReady:Pe,sharedProcessClient:De}=this.setupSharedProcess(be),Me=await this.initServices(be,Se,Pe);if(this.environmentMainService.driverHandle){const Ae=await(0,Q.serve)(ye,this.environmentMainService.driverHandle,this.environmentMainService,Me);this.logService.info("Driver started at:",this.environmentMainService.driverHandle),this._register(Ae)}this._register(Me.createInstance(i.ProxyAuthHandler)),Me.invokeFunction(Ae=>this.initChannels(Ae,ye,De));const Le=Me.invokeFunction(Ae=>this.openFirstWindow(Ae,ye));Me.invokeFunction(Ae=>this.afterWindowOpen(Ae,Se)),this.environmentMainService.args.trace&&Me.invokeFunction(Ae=>this.stopTracingEventually(Ae,Le))}async resolveMachineId(){let we=this.stateMainService.getItem(Fe.machineIdKey);return(!we||g.isMacintosh&&we==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(we=await(0,a.getMachineId)(),this.stateMainService.setItem(Fe.machineIdKey,we)),we}setupSharedProcess(we){const ye=this._register(this.mainInstantiationService.createInstance(Ee.SharedProcess,we,this.userEnv)),be=(async()=>{this.logService.trace("Main->SharedProcess#connect");const Pe=await ye.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new n.Client(Pe,"main")})(),Se=(async()=>(await ye.whenReady(),be))();return{sharedProcess:ye,sharedProcessReady:Se,sharedProcessClient:be}}async initServices(we,ye,be){const Se=new V.ServiceCollection;switch(process.platform){case"win32":Se.set(Ge.IUpdateService,new F.SyncDescriptor(Ve.Win32UpdateService));break;case"linux":g.isLinuxSnap?Se.set(Ge.IUpdateService,new F.SyncDescriptor(ct.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):Se.set(Ge.IUpdateService,new F.SyncDescriptor(at.LinuxUpdateService));break;case"darwin":Se.set(Ge.IUpdateService,new F.SyncDescriptor(Je.DarwinUpdateService));break}Se.set(Ce.IWindowsMainService,new F.SyncDescriptor(Te.WindowsMainService,[we,this.userEnv])),Se.set(_.IDialogMainService,new F.SyncDescriptor(_.DialogMainService)),Se.set(ee.ILaunchMainService,new F.SyncDescriptor(ee.LaunchMainService)),Se.set(T.IDiagnosticsService,s.ProxyChannel.toService((0,s.getDelayedChannel)(be.then(De=>De.getChannel("diagnostics"))))),Se.set(U.IIssueMainService,new F.SyncDescriptor(U.IssueMainService,[this.userEnv])),Se.set(ne.IEncryptionMainService,new F.SyncDescriptor(ne.EncryptionMainService,[we])),Se.set(z.IKeyboardLayoutMainService,new F.SyncDescriptor(z.KeyboardLayoutMainService)),Se.set(le.INativeHostMainService,new F.SyncDescriptor(le.NativeHostMainService,[ye])),Se.set(ve.IWebviewManagerService,new F.SyncDescriptor(Ie.WebviewMainService)),Se.set(Oe.IWorkspacesService,new F.SyncDescriptor(je.WorkspacesMainService)),Se.set(bt.IWorkspacesManagementMainService,new F.SyncDescriptor(bt.WorkspacesManagementMainService)),Se.set(Ne.IWorkspacesHistoryMainService,new F.SyncDescriptor(Ne.WorkspacesHistoryMainService)),Se.set(ce.IMenubarMainService,new F.SyncDescriptor(ce.MenubarMainService)),Se.set(H.IExtensionUrlTrustService,new F.SyncDescriptor(q.ExtensionUrlTrustService)),Se.set(Y.IExtensionHostStarter,new F.SyncDescriptor($.WorkerMainProcessExtensionHostStarter)),Se.set(ke.IStorageMainService,new F.SyncDescriptor(ke.StorageMainService)),g.isWindows?Se.set(K.IExternalTerminalMainService,new F.SyncDescriptor(te.WindowsExternalTerminalService)):g.isMacintosh?Se.set(K.IExternalTerminalMainService,new F.SyncDescriptor(te.MacExternalTerminalService)):g.isLinux&&Se.set(K.IExternalTerminalMainService,new F.SyncDescriptor(te.LinuxExternalTerminalService));const Pe=new w.BackupMainService(this.environmentMainService,this.configurationService,this.logService);if(Se.set(h.IBackupMainService,Pe),Se.set(He.IURLService,new F.SyncDescriptor(ae.NativeURLService)),(0,Qe.supportsTelemetry)(this.productService,this.environmentMainService)){const De=(0,s.getDelayedChannel)(be.then(Ze=>Ze.getChannel("telemetryAppender"))),Me=new $e.TelemetryAppenderClient(De),Le=(0,Re.resolveCommonProperties)(this.fileService,(0,D.release)(),(0,D.hostname)(),process.arch,this.productService.commit,this.productService.version,we,this.productService.msftInternalDomains,this.environmentMainService.installSourcePath),Ae=[this.environmentMainService.appRoot,this.environmentMainService.extensionsPath],Xe={appenders:[Me],commonProperties:Le,piiPaths:Ae,sendErrorTelemetry:!0};Se.set(Fe.ITelemetryService,new F.SyncDescriptor(ze.TelemetryService,[Xe]))}else Se.set(Fe.ITelemetryService,Qe.NullTelemetryService);return await Pe.initialize(),this.mainInstantiationService.createChild(Se)}initChannels(we,ye,be){const Se=s.ProxyChannel.fromService(we.get(ee.ILaunchMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",Se);const Pe=this.fileService.getProvider(S.Schemas.file);(0,v.assertType)(Pe instanceof W.DiskFileSystemProvider);const De=new L.DiskFileSystemProviderChannel(Pe,this.logService);ye.registerChannel("localFilesystem",De);const Me=new A.UserConfigurationFileService(this.environmentMainService,this.fileService,this.logService);ye.registerChannel(A.UserConfigurationFileServiceId,s.ProxyChannel.fromService(Me)),be.then(Be=>Be.registerChannel(A.UserConfigurationFileServiceId,s.ProxyChannel.fromService(Me)));const Le=new gt.UpdateChannel(we.get(Ge.IUpdateService));ye.registerChannel("update",Le);const Ae=s.ProxyChannel.fromService(we.get(U.IIssueMainService));ye.registerChannel("issue",Ae);const Xe=s.ProxyChannel.fromService(we.get(ne.IEncryptionMainService));ye.registerChannel("encryption",Xe);const Ze=s.ProxyChannel.fromService(we.get(de.ISignService));ye.registerChannel("sign",Ze);const nt=s.ProxyChannel.fromService(we.get(z.IKeyboardLayoutMainService));ye.registerChannel("keyboardLayout",nt),this.nativeHostMainService=we.get(le.INativeHostMainService);const xe=s.ProxyChannel.fromService(this.nativeHostMainService);ye.registerChannel("nativeHost",xe),be.then(Be=>Be.registerChannel("nativeHost",xe));const wt=s.ProxyChannel.fromService(we.get(Oe.IWorkspacesService));ye.registerChannel("workspaces",wt);const Ue=s.ProxyChannel.fromService(we.get(ce.IMenubarMainService));ye.registerChannel("menubar",Ue);const lt=s.ProxyChannel.fromService(we.get(He.IURLService));ye.registerChannel("url",lt);const rt=s.ProxyChannel.fromService(we.get(H.IExtensionUrlTrustService));ye.registerChannel("extensionUrlTrust",rt);const st=s.ProxyChannel.fromService(we.get(ve.IWebviewManagerService));ye.registerChannel("webview",st);const ot=this._register(new pe.StorageDatabaseChannel(this.logService,we.get(ke.IStorageMainService)));ye.registerChannel("storage",ot),be.then(Be=>Be.registerChannel("storage",ot));const ut=s.ProxyChannel.fromService(we.get(K.IExternalTerminalMainService));ye.registerChannel("externalTerminal",ut);const et=new J.LogLevelChannel(we.get(se.ILogService));ye.registerChannel("logLevel",et),be.then(Be=>Be.registerChannel("logLevel",et));const tt=new J.LoggerChannel(we.get(se.ILoggerService));ye.registerChannel("logger",tt),be.then(Be=>Be.registerChannel("logger",tt));const ht=new R.ElectronExtensionHostDebugBroadcastChannel(we.get(Ce.IWindowsMainService));ye.registerChannel("extensionhostdebugservice",ht);const _e=s.ProxyChannel.fromService(we.get(Y.IExtensionHostStarter));ye.registerChannel(Y.ipcExtensionHostStarterChannelName,_e)}openFirstWindow(we,ye){const be=this.windowsMainService=we.get(Ce.IWindowsMainService),Se=we.get(He.IURLService),Pe=we.get(le.INativeHostMainService);this.lifecycleMainService.phase=2;const De=[],Me=[...this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[],...global.getOpenUrls()||[]].map(_e=>{try{return{uri:k.URI.parse(_e),url:_e}}catch{return}}).filter(_e=>{if(!_e||this.shouldBlockURI(_e.uri))return!1;const Be=this.getWindowOpenableFromProtocolLink(_e.uri);return Be?(De.push(Be),!1):!0}),Le=this,Ae=this.environmentMainService,Xe=this.productService;Se.registerHandler({async handleURL(_e,Be){if(_e.scheme===Xe.urlProtocol&&_e.path==="workspace"&&(_e=_e.with({authority:"file",path:k.URI.parse(_e.query).path,query:""})),Le.shouldBlockURI(_e))return!0;const Et=Le.getWindowOpenableFromProtocolLink(_e);if(Et){const[pt]=be.open({context:5,cli:{...Ae.args},urisToOpen:[Et],gotoLineMode:!0});return pt.focus(),!0}if(g.isMacintosh&&be.getWindowCount()===0){const[pt]=be.open({context:5,cli:{...Ae.args},forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,me.getRemoteAuthority)(_e)});return await pt.ready(),Se.open(_e,Be)}return!1}});const Ze=this._register(new We.ActiveWindowManager({onDidOpenWindow:Pe.onDidOpenWindow,onDidFocusWindow:Pe.onDidFocusWindow,getActiveWindowId:()=>Pe.getActiveWindowId(-1)})),nt=new s.StaticRouter(_e=>Ze.getActiveClientId().then(Be=>_e===Be)),xe=new G.URLHandlerRouter(nt),wt=ye.getChannel("urlHandler",xe);Se.registerHandler(new G.URLHandlerChannelClient(wt)),this._register(new he.ElectronURLListener(Me,Se,be,this.environmentMainService,this.productService));const Ue=this.environmentMainService.args,lt=global.macOpenFiles,rt=(0,X.isLaunchedFromCli)(process.env)?0:4,st=Ue._.length,ot=!!Ue["folder-uri"],ut=!!Ue["file-uri"],et=Ue["skip-add-to-recently-opened"]===!0,tt=Ue.wait&&Ue.waitMarkerFilePath?k.URI.file(Ue.waitMarkerFilePath):void 0,ht=Ue.remote||void 0;return De.length>0?be.open({context:rt,cli:Ue,urisToOpen:De,gotoLineMode:!0,initialStartup:!0}):Ue["new-window"]&&!st&&!ot&&!ut?be.open({context:rt,cli:Ue,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:et,waitMarkerFileURI:tt,initialStartup:!0,remoteAuthority:ht}):lt.length&&!st&&!ot&&!ut?be.open({context:1,cli:Ue,urisToOpen:lt.map(_e=>this.getWindowOpenableFromPathSync(_e)),noRecentEntry:et,waitMarkerFileURI:tt,initialStartup:!0}):be.open({context:rt,cli:Ue,forceNewWindow:Ue["new-window"]||!st&&Ue["unity-launch"],diffMode:Ue.diff,noRecentEntry:et,waitMarkerFileURI:tt,gotoLineMode:Ue.goto,initialStartup:!0,remoteAuthority:ht})}shouldBlockURI(we){return!!(we.authority===S.Schemas.file&&g.isWindows&&p.dialog.showMessageBoxSync({title:this.productService.nameLong,type:"question",buttons:[(0,b.mnemonicButtonLabel)((0,o.localize)(0,null)),(0,b.mnemonicButtonLabel)((0,o.localize)(1,null))],defaultId:0,cancelId:1,message:(0,o.localize)(2,null,(0,b.getPathLabel)(we.fsPath,this.environmentMainService),this.productService.nameShort),detail:(0,o.localize)(3,null),noLink:!0})===1)}getWindowOpenableFromProtocolLink(we){if(!!we.path){if(we.authority===S.Schemas.file){const ye=k.URI.file(we.fsPath);return(0,Oe.hasWorkspaceFileExtension)(ye)?{workspaceUri:ye}:{fileUri:ye}}else if(we.authority===S.Schemas.vscodeRemote){const ye=we.path.indexOf(t.posix.sep,1);if(ye!==-1){const be=we.path.substring(1,ye),Se=we.path.substring(ye),Pe=k.URI.from({scheme:S.Schemas.vscodeRemote,authority:be,path:Se,query:we.query,fragment:we.fragment});return(0,Oe.hasWorkspaceFileExtension)(Se)?{workspaceUri:Pe}:/:[\d]+$/.test(Se)?{fileUri:Pe}:{folderUri:Pe}}}}}getWindowOpenableFromPathSync(we){try{if((0,r.statSync)(we).isDirectory())return{folderUri:k.URI.file(we)};if((0,Oe.hasWorkspaceFileExtension)(we))return{workspaceUri:k.URI.file(we)}}catch{}return{fileUri:k.URI.file(we)}}async afterWindowOpen(we,ye){this.lifecycleMainService.phase=3;let be=!1;(0,f.once)(this.lifecycleMainService.onWillShutdown)(()=>be=!0);const Se=we.get(Fe.ITelemetryService);this._register(ye.onDidError(({type:Me,details:Le})=>{let Ae;switch(Me){case 1:Ae="SharedProcess: detected unresponsive window";break;case 2:Ae=`SharedProcess: crashed (detail: ${Le?.reason??"<unknown>"}, code: ${Le?.exitCode??"<unknown>"})`;break;case 3:Ae=`SharedProcess: failed to load (detail: ${Le?.reason??"<unknown>"}, code: ${Le?.exitCode??"<unknown>"})`;break}(0,I.onUnexpectedError)(new Error(Ae)),Se.publicLog2("sharedprocesserror",{type:Me,reason:Le?.reason,code:Le?.exitCode,visible:ye.isVisible(),shuttingdown:be})}));const Pe=this.productService.win32MutexName;if(g.isWindows&&Pe)try{const Me=j.__$__nodeRequire("windows-mutex").Mutex,Le=new Me(Pe);(0,f.once)(this.lifecycleMainService.onWillShutdown)(()=>Le.release())}catch(Me){this.logService.error(Me)}p.protocol.registerHttpProtocol(S.Schemas.vscodeRemoteResource,(Me,Le)=>{Le({url:Me.url.replace(/^vscode-remote-resource:/,"http:"),method:Me.method})});const De=we.get(Ge.IUpdateService);(De instanceof Ve.Win32UpdateService||De instanceof at.LinuxUpdateService||De instanceof Je.DarwinUpdateService)&&De.initialize(),this.resolveShellEnvironment(this.environmentMainService.args,process.env,!0);try{const Le=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString();if(JSON.parse((0,y.stripComments)(Le))["enable-crash-reporter"]===void 0){const Ze=(0,Qe.getTelemetryLevel)(this.configurationService)>=1,nt=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Ze},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,c.generateUuid)()}"`,"}"],xe=Le.substring(0,Le.length-2).concat(`,
`,nt.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,C.VSBuffer.fromString(xe))}}catch(Me){this.logService.error(Me)}}async resolveShellEnvironment(we,ye,be){try{return await(0,O.getResolvedShellEnv)(this.logService,we,ye)}catch(Se){const Pe=(0,P.toErrorMessage)(Se);be?this.windowsMainService?.sendToFocused("vscode:showResolveShellEnvError",Pe):this.logService.error(Pe)}return{}}stopTracingEventually(we,ye){this.logService.info("Tracing: waiting for windows to get ready...");const be=we.get(_.IDialogMainService);let Se=!1;const Pe=async Me=>{if(Se)return;Se=!0;const Le=await p.contentTracing.stopRecording((0,E.joinPath)(this.environmentMainService.userHome,`${this.productService.applicationName}-${Math.random().toString(16).slice(-4)}.trace.txt`).fsPath);Me?this.logService.info(`Tracing: data recorded (after 30s timeout) to ${Le}`):be.showMessageBox({title:this.productService.nameLong,type:"info",message:(0,o.localize)(4,null),detail:(0,o.localize)(5,null,Le),buttons:[(0,b.mnemonicButtonLabel)((0,o.localize)(6,null))],defaultId:0,noLink:!0},(0,v.withNullAsUndefined)(p.BrowserWindow.getFocusedWindow()))},De=setTimeout(()=>Pe(!0),3e4);Promise.all(ye.map(Me=>Me.ready())).then(()=>{clearTimeout(De),Pe(!1)})}};mt=fe([ie(2,N.IInstantiationService),ie(3,se.ILogService),ie(4,oe.IEnvironmentMainService),ie(5,re.ILifecycleMainService),ie(6,M.IConfigurationService),ie(7,ge.IStateMainService),ie(8,B.IFileService),ie(9,ue.IProductService)],mt),e.CodeApplication=mt}),define(Z[251],x([0,1,14,27,30,9,44,16,32,42,33,10,8,63,3,34,25,21,36,57,244,11,19,192,203,24,53,166,18,182,93,73,175,75,20,94,6,186,95,54,22,55,189,96,228,49,230,76,200,37,232,65,66,209]),function(j,e,p,r,D,C,P,I,d,f,y,b,m,S,t,g,E,v,k,c,a,u,s,l,n,i,o,h,w,M,A,R,T,_,Q,ne,oe,X,O,H,q,Y,$,K,te,B,L,W,F,N,V,U,z){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class ee{main(){try{this.startup()}catch(J){console.error(J.message),p.app.exit(1)}}async startup(){(0,I.setUnexpectedErrorHandler)(ge=>console.error(ge));const[J,ce,le,ue,me,Ee,de]=this.createServices();try{try{await this.initServices(le,ue,me)}catch(ge){throw this.handleStartupDataDirError(le,de.nameLong,ge),ge}await J.invokeFunction(async ge=>{const pe=ge.get(oe.ILogService),ke=ge.get(Q.ILifecycleMainService),Re=ge.get(w.IFileService),Fe=await this.claimInstance(pe,le,ke,J,de,!0);return v.Promises.writeFile(le.mainLockfile,String(process.pid)).catch($e=>{pe.warn(`Error writing main lockfile: ${$e.stack}`)}),Ee.logger=new O.SpdLogLogger("main",(0,m.join)(le.logsPath,"main.log"),!0,!1,Ee.getLevel()),(0,f.once)(ke.onWillShutdown)($e=>{Re.dispose(),ue.dispose(),$e.join(v.Promises.unlink(le.mainLockfile).catch(()=>{}))}),J.createInstance(a.CodeApplication,Fe,ce).startup()})}catch(ge){J.invokeFunction(this.quit,ge)}}createServices(){const J=new _.ServiceCollection,ce={_serviceBrand:void 0,...H.default};J.set(q.IProductService,ce);const le=new i.EnvironmentMainService(this.resolveArgs(),ce),ue=this.patchEnvironment(le);J.set(i.IEnvironmentMainService,le);const me=new ne.BufferLogService,Ee=new oe.MultiplexLogService([new oe.ConsoleMainLogger((0,oe.getLogLevel)(le)),me]);process.once("exit",()=>Ee.dispose()),J.set(oe.ILogService,Ee);const de=new M.FileService(Ee);J.set(w.IFileService,de);const ge=new A.DiskFileSystemProvider(Ee);de.registerProvider(b.Schemas.file,ge),J.set(oe.ILoggerService,new X.LoggerService(Ee,de));const pe=new l.ConfigurationService(le.settingsResource,de);J.set(s.IConfigurationService,pe),J.set(Q.ILifecycleMainService,new R.SyncDescriptor(Q.LifecycleMainService));const ke=new V.StateMainService(le,Ee,de);return J.set(N.IStateMainService,ke),J.set(B.IRequestService,new R.SyncDescriptor(L.RequestMainService)),J.set(z.IThemeMainService,new R.SyncDescriptor(z.ThemeMainService)),J.set(W.ISignService,new R.SyncDescriptor(F.SignService)),J.set(K.ITunnelService,new R.SyncDescriptor(te.TunnelService)),J.set(Y.IProtocolMainService,new R.SyncDescriptor($.ProtocolMainService)),[new T.InstantiationService(J,!0),ue,le,pe,ke,me,ce]}patchEnvironment(J){const ce={VSCODE_IPC_HOOK:J.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(le=>{const ue=process.env[le];typeof ue=="string"&&(ce[le]=ue)}),Object.assign(process.env,ce),ce}initServices(J,ce,le){return C.Promises.settled([Promise.all([J.extensionsPath,J.codeCachePath,J.logsPath,J.globalStorageHome.fsPath,J.workspaceStorageHome.fsPath,J.backupHome].map(ue=>ue?v.Promises.mkdir(ue,{recursive:!0}):void 0)),ce.initialize(),le.init()])}async claimInstance(J,ce,le,ue,me,Ee){let de;try{(0,S.mark)("code/willStartMainServer"),de=await(0,c.serve)(ce.mainIPCHandle),(0,S.mark)("code/didStartMainServer"),(0,f.once)(le.onWillShutdown)(()=>de.dispose())}catch(ge){if(ge.code!=="EADDRINUSE")throw this.handleStartupDataDirError(ce,me.nameLong,ge),ge;let pe;try{pe=await(0,c.connect)(ce.mainIPCHandle,"main")}catch(Fe){if(!Ee||t.isWindows||Fe.code!=="ECONNREFUSED")throw Fe.code==="EPERM"&&this.showStartupWarningDialog((0,u.localize)(0,null,me.nameShort),(0,u.localize)(1,null),me.nameLong),Fe;try{(0,r.unlinkSync)(ce.mainIPCHandle)}catch($e){throw J.warn("Could not delete obsolete instance handle",$e),$e}return this.claimInstance(J,ce,le,ue,me,!1)}if(ce.extensionTestsLocationURI&&!ce.debugExtensionHost.break){const Fe="Running extension tests from the command line is currently only supported if no other instance of Code is running.";throw J.error(Fe),pe.dispose(),new Error(Fe)}let ke;!ce.args.wait&&!ce.args.status&&(ke=setTimeout(()=>{this.showStartupWarningDialog((0,u.localize)(2,null,me.nameShort),(0,u.localize)(3,null),me.nameLong)},1e4));const Re=k.ProxyChannel.toService(pe.getChannel("launch"),{disableMarshalling:!0});if(ce.args.status)return ue.invokeFunction(async()=>{const Fe=new n.DiagnosticsService(U.NullTelemetryService,me),$e=await Re.getMainProcessInfo(),ze=await Re.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Qe=await Fe.getDiagnostics($e,ze);throw console.log(Qe),new I.ExpectedError});throw t.isWindows&&await this.windowsAllowSetForegroundWindow(Re,J),J.trace("Sending env to running instance..."),await Re.start(ce.args,process.env),pe.dispose(),ke&&clearTimeout(ke),new I.ExpectedError("Sent env to running instance. Terminating...")}if(ce.args.status)throw J.warn("Warning: The --status argument can only be used if Code is already running. Please run it again after Code has started."),new I.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),de}handleStartupDataDirError(J,ce,le){if(le.code==="EACCES"||le.code==="EPERM"){const ue=(0,D.coalesce)([J.userDataPath,J.extensionsPath,c.XDG_RUNTIME_DIR]).map(me=>(0,y.getPathLabel)(me,J));this.showStartupWarningDialog((0,u.localize)(4,null),(0,u.localize)(5,null,(0,P.toErrorMessage)(le),ue.join(`
`)),ce)}}showStartupWarningDialog(J,ce,le){p.dialog.showMessageBoxSync({title:le,type:"warning",buttons:[(0,y.mnemonicButtonLabel)((0,u.localize)(6,null))],message:J,detail:ce,defaultId:0,noLink:!0})}async windowsAllowSetForegroundWindow(J,ce){if(t.isWindows){const le=await J.getMainProcessId();ce.trace("Sending some foreground love to the running instance:",le);try{(await new Promise((ue,me)=>{j(["windows-foreground-love"],ue,me)})).allowSetForegroundWindow(le)}catch(ue){ce.error(ue)}}}quit(J,ce){const le=J.get(oe.ILogService),ue=J.get(Q.ILifecycleMainService);let me=0;ce&&(ce.isExpected?ce.message&&le.trace(ce.message):(me=1,ce.stack?le.error(ce.stack):le.error(`Startup error: ${ce.toString()}`))),ue.kill(me)}resolveArgs(){const J=this.validatePaths((0,o.parseMainProcessArgv)(process.argv));if(J.wait&&!J.waitMarkerFilePath){const ce=(0,h.createWaitMarkerFile)(J.verbose);ce&&((0,o.addArg)(process.argv,"--waitMarkerFilePath",ce),J.waitMarkerFilePath=ce)}return J}validatePaths(J){if(J["open-url"]&&(J._urls=J._,J._=[]),!J.remote){const ce=this.doValidatePaths(J._,J.goto);J._=ce}return J}doValidatePaths(J,ce){const le=(0,g.cwd)(),ue=J.map(de=>{let ge=String(de),pe;ce&&(pe=(0,d.parseLineAndColumnAware)(ge),ge=pe.path),ge&&(ge=this.preparePath(le,ge));const ke=(0,d.sanitizeFilePath)(ge,le),Re=(0,m.basename)(ke);return Re&&!(0,d.isValidBasename)(Re)?null:ce&&pe?(pe.path=ke,this.toPath(pe)):ke}),me=t.isWindows||t.isMacintosh,Ee=(0,D.distinct)(ue,de=>de&&me?de.toLowerCase():de||"");return(0,D.coalesce)(Ee)}preparePath(J,ce){return t.isWindows&&(ce=(0,E.rtrim)(ce,'"')),ce=(0,E.trim)((0,E.trim)(ce," "),"	"),t.isWindows&&(ce=(0,m.resolve)(J,ce),ce=(0,E.rtrim)(ce,".")),ce}toPath(J){const ce=[J.path];return typeof J.line=="number"&&ce.push(String(J.line)),typeof J.column=="number"&&ce.push(String(J.column)),ce.join(":")}}new ee().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/745ef8b8264e12b2a704f6b2b60a2ce2cabfcda3/core/vs/code/electron-main/main.js.map
