/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ve=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/path","vs/base/common/network","vs/platform/log/common/log","vs/base/common/platform","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/base/common/errors","vs/base/common/arrays","vs/workbench/api/common/extHostTypeConverters","vs/base/common/async","vs/nls","vs/nls!vs/workbench/services/extensions/node/extensionHostProcess","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/base/common/map","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/platform/extensions/common/extensions","vs/base/node/pfs","vs/workbench/services/extensions/common/extensions","vs/base/common/extpath","vs/base/common/glob","vs/base/common/uuid","vs/workbench/services/search/common/search","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","child_process","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostExtensionService","vs/base/common/process","vs/editor/common/core/range","vs/platform/files/common/files","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/severity","vs/editor/common/core/position","vs/base/common/errorMessage","vs/platform/registry/common/platform","vs/workbench/api/common/extHostTunnelService","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDebugService","vs/base/common/assert","vs/base/common/decorators","vs/base/common/json","vs/base/common/marshalling","fs","vs/platform/contextkey/common/contextkey","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostSearch","vs/base/common/codicons","vs/base/common/collections","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/iterator","vs/base/common/numbers","vs/base/common/normalization","vs/base/common/labels","os","vs/editor/common/modes/languageSelector","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/instantiation/common/serviceCollection","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/api/common/shared/webview","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/linkedList","vs/base/common/processes","vs/base/common/stream","vs/base/common/filters","vs/base/common/htmlContent","vs/base/common/uint","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/mime","vs/base/common/uriIpc","string_decoder","vs/base/node/extpath","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/base/node/processes","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/descriptors","vs/platform/configuration/common/configuration","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/tunnel","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testCollection","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/iconLabels","vs/base/node/decoder","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/api/node/extHostTunnelService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/output/common/output","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/textfile/common/encoding","vs/workbench/services/extensions/node/proxyResolver","http","vs/workbench/services/search/node/ripgrepFileSearch","vscode-ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","vs/workbench/services/extensions/node/extensionHostProcessSetup","util","vs/base/common/marked/marked","https","tls","vscode-proxy-agent","events","vscode-regexpp","crypto","zlib","minimist","vs/workbench/services/extensions/node/extensionHostProcess"],we=function(J){for(var e=[],m=0,i=J.length;m<i;m++)e[m]=ve[J[m]];return e};define(ve[56],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function m(i,y){if(!i)throw new Error(y?`Assertion failed (${y})`:"Assertion Failed")}e.ok=m}),define(ve[73],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function m(P){return P?P.replace(/\$\((.*?)\)/g,(D,_)=>` ${_} `).trim():""}e.getCodiconAriaLabel=m;class i{constructor(D,_,I){this.id=D,this.definition=_,this.description=I,i._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return i._allCodicons}}e.Codicon=i,i._allCodicons=[],i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",i.add.definition),i.gistNew=new i("gist-new",i.add.definition),i.repoCreate=new i("repo-create",i.add.definition),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eba4"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolCustomColor=new i("symbol-customcolor",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.layers=new i("layers",{fontCharacter:"\\ebd2"}),i.layersDot=new i("layers-dot",{fontCharacter:"\\ebd3"}),i.layersActive=new i("layers-active",{fontCharacter:"\\ebd4"}),i.compass=new i("compass",{fontCharacter:"\\ebd5"}),i.compassDot=new i("compass-dot",{fontCharacter:"\\ebd6"}),i.compassActive=new i("compass-active",{fontCharacter:"\\ebd7"}),i.azure=new i("azure",{fontCharacter:"\\ebd8"}),i.issueDraft=new i("issue-draft",{fontCharacter:"\\ebd9"}),i.gitPullRequestClosed=new i("git-pull-request-closed",{fontCharacter:"\\ebda"}),i.gitPullRequestDraft=new i("git-pull-request-draft",{fontCharacter:"\\ebdb"}),i.debugAll=new i("debug-all",{fontCharacter:"\\ebdc"}),i.debugCoverage=new i("debug-coverage",{fontCharacter:"\\ebdd"}),i.runErrors=new i("run-errors",{fontCharacter:"\\ebde"}),i.folderLibrary=new i("folder-library",{fontCharacter:"\\ebdf"}),i.debugContinueSmall=new i("debug-continue-small",{fontCharacter:"\\ebe0"}),i.beakerStop=new i("beaker-stop",{fontCharacter:"\\ebe1"}),i.graphLine=new i("graph-line",{fontCharacter:"\\ebe2"}),i.graphScatter=new i("graph-scatter",{fontCharacter:"\\ebe3"}),i.pieChart=new i("pie-chart",{fontCharacter:"\\ebe4"}),i.bracket=new i("bracket",i.json.definition),i.bracketDot=new i("bracket-dot",{fontCharacter:"\\ebe5"}),i.bracketError=new i("bracket-error",{fontCharacter:"\\ebe6"}),i.lockSmall=new i("lock-small",{fontCharacter:"\\ebe7"}),i.azureDevops=new i("azure-devops",{fontCharacter:"\\ebe8"}),i.verifiedFilled=new i("verified-filled",{fontCharacter:"\\ebe9"}),i.newLine=new i("newline",{fontCharacter:"\\ebea"}),i.layout=new i("layout",{fontCharacter:"\\ebeb"}),i.dialogError=new i("dialog-error",i.error.definition),i.dialogWarning=new i("dialog-warning",i.warning.definition),i.dialogInfo=new i("dialog-info",i.info.definition),i.dialogClose=new i("dialog-close",i.close.definition),i.treeItemExpanded=new i("tree-item-expanded",i.chevronDown.definition),i.treeFilterOnTypeOn=new i("tree-filter-on-type-on",i.listFilter.definition),i.treeFilterOnTypeOff=new i("tree-filter-on-type-off",i.listSelection.definition),i.treeFilterClear=new i("tree-filter-clear",i.close.definition),i.treeItemLoading=new i("tree-item-loading",i.loading.definition),i.menuSelection=new i("menu-selection",i.check.definition),i.menuSubmenu=new i("menu-submenu",i.chevronRight.definition),i.menuBarMore=new i("menubar-more",i.more.definition),i.scrollbarButtonLeft=new i("scrollbar-button-left",i.triangleLeft.definition),i.scrollbarButtonRight=new i("scrollbar-button-right",i.triangleRight.definition),i.scrollbarButtonUp=new i("scrollbar-button-up",i.triangleUp.definition),i.scrollbarButtonDown=new i("scrollbar-button-down",i.triangleDown.definition),i.toolBarMore=new i("toolbar-more",i.more.definition),i.quickInputBack=new i("quick-input-back",i.arrowLeft.definition);function y(P,D){const _=["codicon","codicon-"+P];return D&&_.push("codicon-modifier-"+D),_}e.getClassNamesArray=y;var C;(function(P){P.iconNameSegment="[A-Za-z0-9]+",P.iconNameExpression="[A-Za-z0-9-]+",P.iconModifierExpression="~[A-Za-z]+",P.iconNameCharacter="[A-Za-z0-9~-]";const D=new RegExp(`^(${P.iconNameExpression})(${P.iconModifierExpression})?$`);function _(A){if(A instanceof i)return["codicon","codicon-"+A.id];const c=D.exec(A.id);if(!c)return _(i.error);let[,E,h]=c;const p=["codicon","codicon-"+E];return h&&p.push("codicon-modifier-"+h.substr(1)),p}P.asClassNameArray=_;function I(A){return _(A).join(" ")}P.asClassName=I;function L(A){return"."+_(A).join(".")}P.asCSSSelector=L})(C=e.CSSIcon||(e.CSSIcon={}))}),define(ve[74],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const m=Object.prototype.hasOwnProperty;function i(L){const A=[];for(let c in L)m.call(L,c)&&A.push(L[c]);return A}e.values=i;function y(L,A){for(let c in L)if(m.call(L,c)&&A({key:c,value:L[c]},function(){delete L[c]})===!1)return}e.forEach=y;function C(L,A){const c=Object.create(null);for(const E of L){const h=A(E);let p=c[h];p||(p=c[h]=[]),p.push(E)}return c}e.groupBy=C;function P(L){const A=Object.create(null);return L&&L.forEach((c,E)=>{A[E]=c}),A}e.fromMap=P;function D(L,A){const c=[],E=[];for(let h of L)A.has(h)||c.push(h);for(let h of A)L.has(h)||E.push(h);return{removed:c,added:E}}e.diffSets=D;function _(L,A){const c=[],E=[];for(let[h,p]of L)A.has(h)||c.push(p);for(let[h,p]of A)L.has(h)||E.push(p);return{removed:c,added:E}}e.diffMaps=_;class I{constructor(){this.map=new Map}add(A,c){let E=this.map.get(A);E||(E=new Set,this.map.set(A,E)),E.add(c)}delete(A,c){const E=this.map.get(A);!E||(E.delete(c),E.size===0&&this.map.delete(A))}forEach(A,c){const E=this.map.get(A);!E||E.forEach(c)}}e.SetMap=I}),define(ve[57],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function m(P){return(D,_,I)=>{let L=null,A=null;if(typeof I.value=="function"?(L="value",A=I.value):typeof I.get=="function"&&(L="get",A=I.get),!A)throw new Error("not supported");I[L]=P(A,_)}}e.createDecorator=m;function i(P,D,_){let I=null,L=null;if(typeof _.value=="function"?(I="value",L=_.value,L.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof _.get=="function"&&(I="get",L=_.get),!L)throw new Error("not supported");const A=`$memoize$${D}`;_[I]=function(...c){return this.hasOwnProperty(A)||Object.defineProperty(this,A,{configurable:!1,enumerable:!1,writable:!1,value:L.apply(this,c)}),this[A]}}e.memoize=i;function y(P,D,_){return m((I,L)=>{const A=`$debounce$${L}`,c=`$debounce$result$${L}`;return function(...E){this[c]||(this[c]=_?_():void 0),clearTimeout(this[A]),D&&(this[c]=D(this[c],...E),E=[this[c]]),this[A]=setTimeout(()=>{I.apply(this,E),this[c]=_?_():void 0},P)}})}e.debounce=y;function C(P,D,_){return m((I,L)=>{const A=`$throttle$timer$${L}`,c=`$throttle$result$${L}`,E=`$throttle$lastRun$${L}`,h=`$throttle$pending$${L}`;return function(...p){if(this[c]||(this[c]=_?_():void 0),(this[E]===null||this[E]===void 0)&&(this[E]=-Number.MAX_VALUE),D&&(this[c]=D(this[c],...p)),this[h])return;const v=this[E]+P;v<=Date.now()?(this[E]=Date.now(),I.apply(this,[this[c]]),this[c]=_?_():void 0):(this[h]=!0,this[A]=setTimeout(()=>{this[h]=!1,this[E]=Date.now(),I.apply(this,[this[c]]),this[c]=_?_():void 0},v-Date.now()))}})}e.throttle=C}),define(ve[15],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class m{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(l){setTimeout(()=>{throw l.stack?new Error(l.message+`

`+l.stack):l},0)}}addListener(l){return this.listeners.push(l),()=>{this._removeListener(l)}}emit(l){this.listeners.forEach(S=>{S(l)})}_removeListener(l){this.listeners.splice(this.listeners.indexOf(l),1)}setUnexpectedErrorHandler(l){this.unexpectedErrorHandler=l}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(l){this.unexpectedErrorHandler(l),this.emit(l)}onUnexpectedExternalError(l){this.unexpectedErrorHandler(l)}}e.ErrorHandler=m,e.errorHandler=new m;function i(g){e.errorHandler.setUnexpectedErrorHandler(g)}e.setUnexpectedErrorHandler=i;function y(g){_(g)||e.errorHandler.onUnexpectedError(g)}e.onUnexpectedError=y;function C(g){_(g)||e.errorHandler.onUnexpectedExternalError(g)}e.onUnexpectedExternalError=C;function P(g){if(g instanceof Error){let{name:l,message:S}=g;const n=g.stacktrace||g.stack;return{$isError:!0,name:l,message:S,stack:n}}return g}e.transformErrorForSerialization=P;const D="Canceled";function _(g){return g instanceof Error&&g.name===D&&g.message===D}e.isPromiseCanceledError=_;class I extends Error{constructor(){super(D);this.name=this.message}}e.CancellationError=I;function L(){const g=new Error(D);return g.name=g.message,g}e.canceled=L;function A(g){return g?new Error(`Illegal argument: ${g}`):new Error("Illegal argument")}e.illegalArgument=A;function c(g){return g?new Error(`Illegal state: ${g}`):new Error("Illegal state")}e.illegalState=c;function E(g){return g?new Error(`readonly property '${g} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=E;function h(g){const l=new Error(`${g} has been disposed`);return l.name="DISPOSED",l}e.disposed=h;function p(g){return g?g.message?g.message:g.stack?g.stack.split(`
`)[0]:String(g):"Error"}e.getErrorMessage=p;class v extends Error{constructor(l){super("NotImplemented");l&&(this.message=l)}}e.NotImplementedError=v;class T extends Error{constructor(l){super("NotSupported");l&&(this.message=l)}}e.NotSupportedError=T;class b extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=b;function o(g){const l=g;return l instanceof Error&&Array.isArray(l.actions)}e.isErrorWithActions=o;function s(g,l=Object.create(null)){const S=new Error(g);return l.actions&&(S.actions=l.actions),S}e.createErrorWithActions=s}),define(ve[16],we([0,1,15]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.compareBy=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function i(Y,fe=0){return Y[Y.length-(1+fe)]}e.tail=i;function y(Y){if(Y.length===0)throw new Error("Invalid tail call");return[Y.slice(0,Y.length-1),Y[Y.length-1]]}e.tail2=y;function C(Y,fe,me=(_e,Ie)=>_e===Ie){if(Y===fe)return!0;if(!Y||!fe||Y.length!==fe.length)return!1;for(let _e=0,Ie=Y.length;_e<Ie;_e++)if(!me(Y[_e],fe[_e]))return!1;return!0}e.equals=C;function P(Y,fe,me){let _e=0,Ie=Y.length-1;for(;_e<=Ie;){const Oe=(_e+Ie)/2|0,We=me(Y[Oe],fe);if(We<0)_e=Oe+1;else if(We>0)Ie=Oe-1;else return Oe}return-(_e+1)}e.binarySearch=P;function D(Y,fe){let me=0,_e=Y.length;if(_e===0)return 0;for(;me<_e;){const Ie=Math.floor((me+_e)/2);fe(Y[Ie])?_e=Ie:me=Ie+1}return me}e.findFirstInSorted=D;function _(Y,fe,me){if(Y=Y|0,Y>=fe.length)throw new TypeError("invalid index");let _e=fe[Math.floor(fe.length*Math.random())],Ie=[],Oe=[],We=[];for(let j of fe){const Z=me(j,_e);Z<0?Ie.push(j):Z>0?Oe.push(j):We.push(j)}return Y<Ie.length?_(Y,Ie,me):Y<Ie.length+We.length?We[0]:_(Y-(Ie.length+We.length),Oe,me)}e.quickSelect=_;function I(Y,fe){const me=[];let _e;for(const Ie of Y.slice(0).sort(fe))!_e||fe(_e[0],Ie)!==0?(_e=[Ie],me.push(_e)):_e.push(Ie);return me}e.groupBy=I;function L(Y,fe,me){const _e=[];function Ie(j,Z,re){if(Z===0&&re.length===0)return;const ue=_e[_e.length-1];ue&&ue.start+ue.deleteCount===j?(ue.deleteCount+=Z,ue.toInsert.push(...re)):_e.push({start:j,deleteCount:Z,toInsert:re})}let Oe=0,We=0;for(;;){if(Oe===Y.length){Ie(Oe,0,fe.slice(We));break}if(We===fe.length){Ie(Oe,Y.length-Oe,[]);break}const j=Y[Oe],Z=fe[We],re=me(j,Z);re===0?(Oe+=1,We+=1):re<0?(Ie(Oe,1,[]),Oe+=1):re>0&&(Ie(Oe,0,[Z]),We+=1)}return _e}e.sortedDiff=L;function A(Y,fe,me){const _e=L(Y,fe,me),Ie=[],Oe=[];for(const We of _e)Ie.push(...Y.slice(We.start,We.start+We.deleteCount)),Oe.push(...We.toInsert);return{removed:Ie,added:Oe}}e.delta=A;function c(Y,fe,me){if(me===0)return[];const _e=Y.slice(0,me).sort(fe);return h(Y,fe,_e,me,Y.length),_e}e.top=c;function E(Y,fe,me,_e,Ie){return me===0?Promise.resolve([]):new Promise((Oe,We)=>{(async()=>{const j=Y.length,Z=Y.slice(0,me).sort(fe);for(let re=me,ue=Math.min(me+_e,j);re<j;re=ue,ue=Math.min(ue+_e,j)){if(re>me&&await new Promise(te=>setTimeout(te)),Ie&&Ie.isCancellationRequested)throw(0,m.canceled)();h(Y,fe,Z,re,ue)}return Z})().then(Oe,We)})}e.topAsync=E;function h(Y,fe,me,_e,Ie){for(const Oe=me.length;_e<Ie;_e++){const We=Y[_e];if(fe(We,me[Oe-1])<0){me.pop();const j=D(me,Z=>fe(We,Z)<0);me.splice(j,0,We)}}}function p(Y){return Y.filter(fe=>!!fe)}e.coalesce=p;function v(Y){let fe=0;for(let me=0;me<Y.length;me++)Y[me]&&(Y[fe]=Y[me],fe+=1);Y.length=fe}e.coalesceInPlace=v;function T(Y,fe,me){Y.splice(me,0,Y.splice(fe,1)[0])}e.move=T;function b(Y){return!Array.isArray(Y)||Y.length===0}e.isFalsyOrEmpty=b;function o(Y){return Array.isArray(Y)&&Y.length>0}e.isNonEmptyArray=o;function s(Y,fe=me=>me){const me=new Set;return Y.filter(_e=>{const Ie=fe(_e);return me.has(Ie)?!1:(me.add(Ie),!0)})}e.distinct=s;function g(Y){const fe=Object.create(null);return me=>{const _e=Y(me);return fe[_e]?!1:(fe[_e]=!0,!0)}}e.uniqueFilter=g;function l(Y,fe){const me=S(Y,fe);if(me!==-1)return Y[me]}e.findLast=l;function S(Y,fe){for(let me=Y.length-1;me>=0;me--){const _e=Y[me];if(fe(_e))return me}return-1}e.lastIndex=S;function n(Y,fe){return Y.length>0?Y[0]:fe}e.firstOrDefault=n;function t(Y,fe,me=(_e,Ie)=>_e===Ie){let _e=0;for(let Ie=0,Oe=Math.min(Y.length,fe.length);Ie<Oe&&me(Y[Ie],fe[Ie]);Ie++)_e++;return _e}e.commonPrefixLength=t;function r(Y){return[].concat(...Y)}e.flatten=r;function u(Y,fe){let me=typeof fe=="number"?Y:0;typeof fe=="number"?me=Y:(me=0,fe=Y);const _e=[];if(me<=fe)for(let Ie=me;Ie<fe;Ie++)_e.push(Ie);else for(let Ie=me;Ie>fe;Ie--)_e.push(Ie);return _e}e.range=u;function a(Y,fe,me){return Y.reduce((_e,Ie)=>(_e[fe(Ie)]=me?me(Ie):Ie,_e),Object.create(null))}e.index=a;function f(Y,fe){return Y.push(fe),()=>w(Y,fe)}e.insert=f;function w(Y,fe){const me=Y.indexOf(fe);if(me>-1)return Y.splice(me,1),fe}e.remove=w;function d(Y,fe,me){const _e=Y.slice(0,fe),Ie=Y.slice(fe);return _e.concat(me,Ie)}e.arrayInsert=d;function k(Y,fe){let me;if(typeof fe=="number"){let _e=fe;me=()=>{const Ie=Math.sin(_e++)*179426549;return Ie-Math.floor(Ie)}}else me=Math.random;for(let _e=Y.length-1;_e>0;_e-=1){const Ie=Math.floor(me()*(_e+1)),Oe=Y[_e];Y[_e]=Y[Ie],Y[Ie]=Oe}}e.shuffle=k;function R(Y,fe){const me=Y.indexOf(fe);me>-1&&(Y.splice(me,1),Y.unshift(fe))}e.pushToStart=R;function N(Y,fe){const me=Y.indexOf(fe);me>-1&&(Y.splice(me,1),Y.push(fe))}e.pushToEnd=N;function x(Y,fe){return Array.isArray(Y)?Y.map(fe):fe(Y)}e.mapArrayOrNot=x;function F(Y){return Array.isArray(Y)?Y:[Y]}e.asArray=F;function B(Y){return Y[Math.floor(Math.random()*Y.length)]}e.getRandomElement=B;function O(Y,fe){for(const me of Y){const _e=fe(me);if(_e!==void 0)return _e}}e.mapFind=O;function H(Y,fe,me){const _e=W(Y,fe),Ie=Y.length,Oe=me.length;Y.length=Ie+Oe;for(let We=Ie-1;We>=_e;We--)Y[We+Oe]=Y[We];for(let We=0;We<Oe;We++)Y[We+_e]=me[We]}e.insertInto=H;function M(Y,fe,me,_e){const Ie=W(Y,fe),Oe=Y.splice(Ie,me);return H(Y,Ie,_e),Oe}e.splice=M;function W(Y,fe){return fe<0?Math.max(fe+Y.length,0):Math.min(fe,Y.length)}function z(Y,fe){return(me,_e)=>fe(Y(me),Y(_e))}e.compareBy=z;const U=(Y,fe)=>Y-fe;e.numberComparator=U;function V(Y,fe){if(Y.length===0)return;let me=Y[0];for(let _e=1;_e<Y.length;_e++){const Ie=Y[_e];fe(Ie,me)>0&&(me=Ie)}return me}e.findMaxBy=V;function K(Y,fe){if(Y.length===0)return;let me=Y[0];for(let _e=1;_e<Y.length;_e++){const Ie=Y[_e];fe(Ie,me)>=0&&(me=Ie)}return me}e.findLastMaxBy=K;function G(Y,fe){return V(Y,(me,_e)=>-fe(me,_e))}e.findMinBy=G;class Q{constructor(fe){this.items=fe,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(fe){let me=this.firstIdx;for(;me<this.items.length&&fe(this.items[me]);)me++;const _e=me===this.firstIdx?null:this.items.slice(this.firstIdx,me);return this.firstIdx=me,_e}takeFromEndWhile(fe){let me=this.lastIdx;for(;me>=0&&fe(this.items[me]);)me--;const _e=me===this.lastIdx?null:this.items.slice(me+1,this.lastIdx+1);return this.lastIdx=me,_e}peek(){return this.items[this.firstIdx]}dequeue(){const fe=this.items[this.firstIdx];return this.firstIdx++,fe}takeCount(fe){const me=this.items.slice(this.firstIdx,this.firstIdx+fe);return this.firstIdx+=fe,me}}e.ArrayQueue=Q}),define(ve[75],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function m(i){const y=this;let C=!1,P;return function(){return C||(C=!0,P=i.apply(y,arguments)),P}}e.once=m}),define(ve[76],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class m{constructor(y){this._prefix=y,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=m,e.defaultGenerator=new m("id#")}),define(ve[77],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var m;(function(i){function y(g){return g&&typeof g=="object"&&typeof g[Symbol.iterator]=="function"}i.is=y;const C=Object.freeze([]);function P(){return C}i.empty=P;function*D(g){yield g}i.single=D;function _(g){return g||C}i.from=_;function I(g){return!g||g[Symbol.iterator]().next().done===!0}i.isEmpty=I;function L(g){return g[Symbol.iterator]().next().value}i.first=L;function A(g,l){for(const S of g)if(l(S))return!0;return!1}i.some=A;function c(g,l){for(const S of g)if(l(S))return S}i.find=c;function*E(g,l){for(const S of g)l(S)&&(yield S)}i.filter=E;function*h(g,l){let S=0;for(const n of g)yield l(n,S++)}i.map=h;function*p(...g){for(const l of g)for(const S of l)yield S}i.concat=p;function*v(g){for(const l of g)for(const S of l)yield S}i.concatNested=v;function T(g,l,S){let n=S;for(const t of g)n=l(n,t);return n}i.reduce=T;function*b(g,l,S=g.length){for(l<0&&(l+=g.length),S<0?S+=g.length:S>g.length&&(S=g.length);l<S;l++)yield g[l]}i.slice=b;function o(g,l=Number.POSITIVE_INFINITY){const S=[];if(l===0)return[S,g];const n=g[Symbol.iterator]();for(let t=0;t<l;t++){const r=n.next();if(r.done)return[S,i.empty()];S.push(r.value)}return[S,{[Symbol.iterator](){return n}}]}i.consume=o;function s(g,l,S=(n,t)=>n===t){const n=g[Symbol.iterator](),t=l[Symbol.iterator]();for(;;){const r=n.next(),u=t.next();if(r.done!==u.done)return!1;if(r.done)return!0;if(!S(r.value,u.value))return!1}}i.equals=s})(m=e.Iterable||(e.Iterable={}))}),define(ve[58],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var m;(function(l){l[l.None=0]="None",l[l.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",l[l.UnexpectedEndOfString=2]="UnexpectedEndOfString",l[l.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",l[l.InvalidUnicode=4]="InvalidUnicode",l[l.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",l[l.InvalidCharacter=6]="InvalidCharacter"})(m=e.ScanError||(e.ScanError={}));var i;(function(l){l[l.OpenBraceToken=1]="OpenBraceToken",l[l.CloseBraceToken=2]="CloseBraceToken",l[l.OpenBracketToken=3]="OpenBracketToken",l[l.CloseBracketToken=4]="CloseBracketToken",l[l.CommaToken=5]="CommaToken",l[l.ColonToken=6]="ColonToken",l[l.NullKeyword=7]="NullKeyword",l[l.TrueKeyword=8]="TrueKeyword",l[l.FalseKeyword=9]="FalseKeyword",l[l.StringLiteral=10]="StringLiteral",l[l.NumericLiteral=11]="NumericLiteral",l[l.LineCommentTrivia=12]="LineCommentTrivia",l[l.BlockCommentTrivia=13]="BlockCommentTrivia",l[l.LineBreakTrivia=14]="LineBreakTrivia",l[l.Trivia=15]="Trivia",l[l.Unknown=16]="Unknown",l[l.EOF=17]="EOF"})(i=e.SyntaxKind||(e.SyntaxKind={}));var y;(function(l){l[l.InvalidSymbol=1]="InvalidSymbol",l[l.InvalidNumberFormat=2]="InvalidNumberFormat",l[l.PropertyNameExpected=3]="PropertyNameExpected",l[l.ValueExpected=4]="ValueExpected",l[l.ColonExpected=5]="ColonExpected",l[l.CommaExpected=6]="CommaExpected",l[l.CloseBraceExpected=7]="CloseBraceExpected",l[l.CloseBracketExpected=8]="CloseBracketExpected",l[l.EndOfFileExpected=9]="EndOfFileExpected",l[l.InvalidCommentToken=10]="InvalidCommentToken",l[l.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",l[l.UnexpectedEndOfString=12]="UnexpectedEndOfString",l[l.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",l[l.InvalidUnicode=14]="InvalidUnicode",l[l.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",l[l.InvalidCharacter=16]="InvalidCharacter"})(y=e.ParseErrorCode||(e.ParseErrorCode={}));var C;(function(l){l.DEFAULT={allowTrailingComma:!0}})(C=e.ParseOptions||(e.ParseOptions={}));function P(l,S=!1){let n=0,t=l.length,r="",u=0,a=16,f=0;function w(B){let O=0,H=0;for(;O<B;){const M=l.charCodeAt(n);if(M>=48&&M<=57)H=H*16+M-48;else if(M>=65&&M<=70)H=H*16+M-65+10;else if(M>=97&&M<=102)H=H*16+M-97+10;else break;n++,O++}return O<B&&(H=-1),H}function d(B){n=B,r="",u=0,a=16,f=0}function k(){const B=n;if(l.charCodeAt(n)===48)n++;else for(n++;n<l.length&&I(l.charCodeAt(n));)n++;if(n<l.length&&l.charCodeAt(n)===46)if(n++,n<l.length&&I(l.charCodeAt(n)))for(n++;n<l.length&&I(l.charCodeAt(n));)n++;else return f=3,l.substring(B,n);let O=n;if(n<l.length&&(l.charCodeAt(n)===69||l.charCodeAt(n)===101))if(n++,(n<l.length&&l.charCodeAt(n)===43||l.charCodeAt(n)===45)&&n++,n<l.length&&I(l.charCodeAt(n))){for(n++;n<l.length&&I(l.charCodeAt(n));)n++;O=n}else f=3;return l.substring(B,O)}function R(){let B="",O=n;for(;;){if(n>=t){B+=l.substring(O,n),f=2;break}const H=l.charCodeAt(n);if(H===34){B+=l.substring(O,n),n++;break}if(H===92){if(B+=l.substring(O,n),n++,n>=t){f=2;break}switch(l.charCodeAt(n++)){case 34:B+='"';break;case 92:B+="\\";break;case 47:B+="/";break;case 98:B+="\b";break;case 102:B+="\f";break;case 110:B+=`
`;break;case 114:B+="\r";break;case 116:B+="	";break;case 117:const W=w(4);W>=0?B+=String.fromCharCode(W):f=4;break;default:f=5}O=n;continue}if(H>=0&&H<=31)if(_(H)){B+=l.substring(O,n),f=2;break}else f=6;n++}return B}function N(){if(r="",f=0,u=n,n>=t)return u=t,a=17;let B=l.charCodeAt(n);if(D(B)){do n++,r+=String.fromCharCode(B),B=l.charCodeAt(n);while(D(B));return a=15}if(_(B))return n++,r+=String.fromCharCode(B),B===13&&l.charCodeAt(n)===10&&(n++,r+=`
`),a=14;switch(B){case 123:return n++,a=1;case 125:return n++,a=2;case 91:return n++,a=3;case 93:return n++,a=4;case 58:return n++,a=6;case 44:return n++,a=5;case 34:return n++,r=R(),a=10;case 47:const O=n-1;if(l.charCodeAt(n+1)===47){for(n+=2;n<t&&!_(l.charCodeAt(n));)n++;return r=l.substring(O,n),a=12}if(l.charCodeAt(n+1)===42){n+=2;const H=t-1;let M=!1;for(;n<H;){if(l.charCodeAt(n)===42&&l.charCodeAt(n+1)===47){n+=2,M=!0;break}n++}return M||(n++,f=1),r=l.substring(O,n),a=13}return r+=String.fromCharCode(B),n++,a=16;case 45:if(r+=String.fromCharCode(B),n++,n===t||!I(l.charCodeAt(n)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=k(),a=11;default:for(;n<t&&x(B);)n++,B=l.charCodeAt(n);if(u!==n){switch(r=l.substring(u,n),r){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return r+=String.fromCharCode(B),n++,a=16}}function x(B){if(D(B)||_(B))return!1;switch(B){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function F(){let B;do B=N();while(B>=12&&B<=15);return B}return{setPosition:d,getPosition:()=>n,scan:S?F:N,getToken:()=>a,getTokenValue:()=>r,getTokenOffset:()=>u,getTokenLength:()=>n-u,getTokenError:()=>f}}e.createScanner=P;function D(l){return l===32||l===9||l===11||l===12||l===160||l===5760||l>=8192&&l<=8203||l===8239||l===8287||l===12288||l===65279}function _(l){return l===10||l===13||l===8232||l===8233}function I(l){return l>=48&&l<=57}var L;(function(l){l[l.nullCharacter=0]="nullCharacter",l[l.maxAsciiCharacter=127]="maxAsciiCharacter",l[l.lineFeed=10]="lineFeed",l[l.carriageReturn=13]="carriageReturn",l[l.lineSeparator=8232]="lineSeparator",l[l.paragraphSeparator=8233]="paragraphSeparator",l[l.nextLine=133]="nextLine",l[l.space=32]="space",l[l.nonBreakingSpace=160]="nonBreakingSpace",l[l.enQuad=8192]="enQuad",l[l.emQuad=8193]="emQuad",l[l.enSpace=8194]="enSpace",l[l.emSpace=8195]="emSpace",l[l.threePerEmSpace=8196]="threePerEmSpace",l[l.fourPerEmSpace=8197]="fourPerEmSpace",l[l.sixPerEmSpace=8198]="sixPerEmSpace",l[l.figureSpace=8199]="figureSpace",l[l.punctuationSpace=8200]="punctuationSpace",l[l.thinSpace=8201]="thinSpace",l[l.hairSpace=8202]="hairSpace",l[l.zeroWidthSpace=8203]="zeroWidthSpace",l[l.narrowNoBreakSpace=8239]="narrowNoBreakSpace",l[l.ideographicSpace=12288]="ideographicSpace",l[l.mathematicalSpace=8287]="mathematicalSpace",l[l.ogham=5760]="ogham",l[l._=95]="_",l[l.$=36]="$",l[l._0=48]="_0",l[l._1=49]="_1",l[l._2=50]="_2",l[l._3=51]="_3",l[l._4=52]="_4",l[l._5=53]="_5",l[l._6=54]="_6",l[l._7=55]="_7",l[l._8=56]="_8",l[l._9=57]="_9",l[l.a=97]="a",l[l.b=98]="b",l[l.c=99]="c",l[l.d=100]="d",l[l.e=101]="e",l[l.f=102]="f",l[l.g=103]="g",l[l.h=104]="h",l[l.i=105]="i",l[l.j=106]="j",l[l.k=107]="k",l[l.l=108]="l",l[l.m=109]="m",l[l.n=110]="n",l[l.o=111]="o",l[l.p=112]="p",l[l.q=113]="q",l[l.r=114]="r",l[l.s=115]="s",l[l.t=116]="t",l[l.u=117]="u",l[l.v=118]="v",l[l.w=119]="w",l[l.x=120]="x",l[l.y=121]="y",l[l.z=122]="z",l[l.A=65]="A",l[l.B=66]="B",l[l.C=67]="C",l[l.D=68]="D",l[l.E=69]="E",l[l.F=70]="F",l[l.G=71]="G",l[l.H=72]="H",l[l.I=73]="I",l[l.J=74]="J",l[l.K=75]="K",l[l.L=76]="L",l[l.M=77]="M",l[l.N=78]="N",l[l.O=79]="O",l[l.P=80]="P",l[l.Q=81]="Q",l[l.R=82]="R",l[l.S=83]="S",l[l.T=84]="T",l[l.U=85]="U",l[l.V=86]="V",l[l.W=87]="W",l[l.X=88]="X",l[l.Y=89]="Y",l[l.Z=90]="Z",l[l.ampersand=38]="ampersand",l[l.asterisk=42]="asterisk",l[l.at=64]="at",l[l.backslash=92]="backslash",l[l.bar=124]="bar",l[l.caret=94]="caret",l[l.closeBrace=125]="closeBrace",l[l.closeBracket=93]="closeBracket",l[l.closeParen=41]="closeParen",l[l.colon=58]="colon",l[l.comma=44]="comma",l[l.dot=46]="dot",l[l.doubleQuote=34]="doubleQuote",l[l.equals=61]="equals",l[l.exclamation=33]="exclamation",l[l.greaterThan=62]="greaterThan",l[l.lessThan=60]="lessThan",l[l.minus=45]="minus",l[l.openBrace=123]="openBrace",l[l.openBracket=91]="openBracket",l[l.openParen=40]="openParen",l[l.percent=37]="percent",l[l.plus=43]="plus",l[l.question=63]="question",l[l.semicolon=59]="semicolon",l[l.singleQuote=39]="singleQuote",l[l.slash=47]="slash",l[l.tilde=126]="tilde",l[l.backspace=8]="backspace",l[l.formFeed=12]="formFeed",l[l.byteOrderMark=65279]="byteOrderMark",l[l.tab=9]="tab",l[l.verticalTab=11]="verticalTab"})(L||(L={}));function A(l,S){const n=[],t=new Object;let r;const u={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function f(w,d,k,R){u.value=w,u.offset=d,u.length=k,u.type=R,u.colonOffset=void 0,r=u}try{o(l,{onObjectBegin:(w,d)=>{if(S<=w)throw t;r=void 0,a=S>w,n.push("")},onObjectProperty:(w,d,k)=>{if(S<d||(f(w,d,k,"property"),n[n.length-1]=w,S<=d+k))throw t},onObjectEnd:(w,d)=>{if(S<=w)throw t;r=void 0,n.pop()},onArrayBegin:(w,d)=>{if(S<=w)throw t;r=void 0,n.push(0)},onArrayEnd:(w,d)=>{if(S<=w)throw t;r=void 0,n.pop()},onLiteralValue:(w,d,k)=>{if(S<d||(f(w,d,k,g(w)),S<=d+k))throw t},onSeparator:(w,d,k)=>{if(S<=d)throw t;if(w===":"&&r&&r.type==="property")r.colonOffset=d,a=!1,r=void 0;else if(w===","){const R=n[n.length-1];typeof R=="number"?n[n.length-1]=R+1:(a=!0,n[n.length-1]=""),r=void 0}}})}catch(w){if(w!==t)throw w}return{path:n,previousNode:r,isAtPropertyKey:a,matches:w=>{let d=0;for(let k=0;d<w.length&&k<n.length;k++)if(w[d]===n[k]||w[d]==="*")d++;else if(w[d]!=="**")return!1;return d===w.length}}}e.getLocation=A;function c(l,S=[],n=C.DEFAULT){let t=null,r=[];const u=[];function a(w){Array.isArray(r)?r.push(w):t!==null&&(r[t]=w)}return o(l,{onObjectBegin:()=>{const w={};a(w),u.push(r),r=w,t=null},onObjectProperty:w=>{t=w},onObjectEnd:()=>{r=u.pop()},onArrayBegin:()=>{const w=[];a(w),u.push(r),r=w,t=null},onArrayEnd:()=>{r=u.pop()},onLiteralValue:a,onError:(w,d,k)=>{S.push({error:w,offset:d,length:k})}},n),r[0]}e.parse=c;function E(l,S=[],n=C.DEFAULT){let t={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(w){t.type==="property"&&(t.length=w-t.offset,t=t.parent)}function u(w){return t.children.push(w),w}o(l,{onObjectBegin:w=>{t=u({type:"object",offset:w,length:-1,parent:t,children:[]})},onObjectProperty:(w,d,k)=>{t=u({type:"property",offset:d,length:-1,parent:t,children:[]}),t.children.push({type:"string",value:w,offset:d,length:k,parent:t})},onObjectEnd:(w,d)=>{t.length=w+d-t.offset,t=t.parent,r(w+d)},onArrayBegin:(w,d)=>{t=u({type:"array",offset:w,length:-1,parent:t,children:[]})},onArrayEnd:(w,d)=>{t.length=w+d-t.offset,t=t.parent,r(w+d)},onLiteralValue:(w,d,k)=>{u({type:g(w),offset:d,length:k,parent:t,value:w}),r(d+k)},onSeparator:(w,d,k)=>{t.type==="property"&&(w===":"?t.colonOffset=d:w===","&&r(d))},onError:(w,d,k)=>{S.push({error:w,offset:d,length:k})}},n);const f=t.children[0];return f&&delete f.parent,f}e.parseTree=E;function h(l,S){if(!l)return;let n=l;for(let t of S)if(typeof t=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let r=!1;for(const u of n.children)if(Array.isArray(u.children)&&u.children[0].value===t){n=u.children[1],r=!0;break}if(!r)return}else{const r=t;if(n.type!=="array"||r<0||!Array.isArray(n.children)||r>=n.children.length)return;n=n.children[r]}return n}e.findNodeAtLocation=h;function p(l){if(!l.parent||!l.parent.children)return[];const S=p(l.parent);if(l.parent.type==="property"){const n=l.parent.children[0].value;S.push(n)}else if(l.parent.type==="array"){const n=l.parent.children.indexOf(l);n!==-1&&S.push(n)}return S}e.getNodePath=p;function v(l){switch(l.type){case"array":return l.children.map(v);case"object":const S=Object.create(null);for(let n of l.children){const t=n.children[1];t&&(S[n.children[0].value]=v(t))}return S;case"null":case"string":case"number":case"boolean":return l.value;default:return}}e.getNodeValue=v;function T(l,S,n=!1){return S>=l.offset&&S<l.offset+l.length||n&&S===l.offset+l.length}e.contains=T;function b(l,S,n=!1){if(T(l,S,n)){const t=l.children;if(Array.isArray(t))for(let r=0;r<t.length&&t[r].offset<=S;r++){const u=b(t[r],S,n);if(u)return u}return l}}e.findNodeAtOffset=b;function o(l,S,n=C.DEFAULT){const t=P(l,!1);function r(Q){return Q?()=>Q(t.getTokenOffset(),t.getTokenLength()):()=>!0}function u(Q){return Q?Y=>Q(Y,t.getTokenOffset(),t.getTokenLength()):()=>!0}const a=r(S.onObjectBegin),f=u(S.onObjectProperty),w=r(S.onObjectEnd),d=r(S.onArrayBegin),k=r(S.onArrayEnd),R=u(S.onLiteralValue),N=u(S.onSeparator),x=r(S.onComment),F=u(S.onError),B=n&&n.disallowComments,O=n&&n.allowTrailingComma;function H(){for(;;){const Q=t.scan();switch(t.getTokenError()){case 4:M(14);break;case 5:M(15);break;case 3:M(13);break;case 1:B||M(11);break;case 2:M(12);break;case 6:M(16);break}switch(Q){case 12:case 13:B?M(10):x();break;case 16:M(1);break;case 15:case 14:break;default:return Q}}}function M(Q,Y=[],fe=[]){if(F(Q),Y.length+fe.length>0){let me=t.getToken();for(;me!==17;){if(Y.indexOf(me)!==-1){H();break}else if(fe.indexOf(me)!==-1)break;me=H()}}}function W(Q){const Y=t.getTokenValue();return Q?R(Y):f(Y),H(),!0}function z(){switch(t.getToken()){case 11:let Q=0;try{Q=JSON.parse(t.getTokenValue()),typeof Q!="number"&&(M(2),Q=0)}catch{M(2)}R(Q);break;case 7:R(null);break;case 8:R(!0);break;case 9:R(!1);break;default:return!1}return H(),!0}function U(){return t.getToken()!==10?(M(3,[],[2,5]),!1):(W(!1),t.getToken()===6?(N(":"),H(),G()||M(4,[],[2,5])):M(5,[],[2,5]),!0)}function V(){a(),H();let Q=!1;for(;t.getToken()!==2&&t.getToken()!==17;){if(t.getToken()===5){if(Q||M(4,[],[]),N(","),H(),t.getToken()===2&&O)break}else Q&&M(6,[],[]);U()||M(4,[],[2,5]),Q=!0}return w(),t.getToken()!==2?M(7,[2],[]):H(),!0}function K(){d(),H();let Q=!1;for(;t.getToken()!==4&&t.getToken()!==17;){if(t.getToken()===5){if(Q||M(4,[],[]),N(","),H(),t.getToken()===4&&O)break}else Q&&M(6,[],[]);G()||M(4,[],[4,5]),Q=!0}return k(),t.getToken()!==4?M(8,[4],[]):H(),!0}function G(){switch(t.getToken()){case 3:return K();case 1:return V();case 10:return W(!0);default:return z()}}return H(),t.getToken()===17?n.allowEmptyContent?!0:(M(4,[],[]),!1):G()?(t.getToken()!==17&&M(9,[],[]),!0):(M(4,[],[]),!1)}e.visit=o;function s(l,S){let n=P(l),t=[],r,u=0,a;do switch(a=n.getPosition(),r=n.scan(),r){case 12:case 13:case 17:u!==a&&t.push(l.substring(u,a)),S!==void 0&&t.push(n.getTokenValue().replace(/[^\r\n]/g,S)),u=n.getPosition();break}while(r!==17);return t.join("")}e.stripComments=s;function g(l){switch(typeof l){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(l){if(Array.isArray(l))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=g}),define(ve[138],we([0,1,58]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function i(I,L,A){let c,E,h,p,v;if(L){for(p=L.offset,v=p+L.length,h=p;h>0&&!_(I,h-1);)h--;let a=v;for(;a<I.length&&!_(I,a);)a++;E=I.substring(h,a),c=P(E,A)}else E=I,c=0,h=0,p=0,v=I.length;const T=D(A,I);let b=!1,o=0,s;A.insertSpaces?s=C(" ",A.tabSize||4):s="	";const g=(0,m.createScanner)(E,!1);let l=!1;function S(){return T+C(s,c+o)}function n(){let a=g.scan();for(b=!1;a===15||a===14;)b=b||a===14,a=g.scan();return l=a===16||g.getTokenError()!==0,a}const t=[];function r(a,f,w){!l&&f<v&&w>p&&I.substring(f,w)!==a&&t.push({offset:f,length:w-f,content:a})}let u=n();if(u!==17){const a=g.getTokenOffset()+h,f=C(s,c);r(f,h,a)}for(;u!==17;){let a=g.getTokenOffset()+g.getTokenLength()+h,f=n(),w="";for(;!b&&(f===12||f===13);){const k=g.getTokenOffset()+h;r(" ",a,k),a=g.getTokenOffset()+g.getTokenLength()+h,w=f===12?S():"",f=n()}if(f===2)u!==1&&(o--,w=S());else if(f===4)u!==3&&(o--,w=S());else{switch(u){case 3:case 1:o++,w=S();break;case 5:case 12:w=S();break;case 13:b?w=S():w=" ";break;case 6:w=" ";break;case 10:if(f===6){w="";break}case 7:case 8:case 9:case 11:case 2:case 4:f===12||f===13?w=" ":f!==5&&f!==17&&(l=!0);break;case 16:l=!0;break}b&&(f===12||f===13)&&(w=S())}const d=g.getTokenOffset()+h;r(w,a,d),u=f}return t}e.format=i;function y(I,L){const A=JSON.stringify(I,void 0,L.insertSpaces?L.tabSize||4:"	");return L.eol!==void 0?A.replace(/\r\n|\r|\n/g,L.eol):A}e.toFormattedString=y;function C(I,L){let A="";for(let c=0;c<L;c++)A+=I;return A}function P(I,L){let A=0,c=0;const E=L.tabSize||4;for(;A<I.length;){const h=I.charAt(A);if(h===" ")c++;else if(h==="	")c+=E;else break;A++}return Math.floor(c/E)}function D(I,L){for(let A=0;A<L.length;A++){const c=L.charAt(A);if(c==="\r")return A+1<L.length&&L.charAt(A+1)===`
`?`\r
`:"\r";if(c===`
`)return`
`}return I&&I.eol||`
`}e.getEOL=D;function _(I,L){return`\r
`.indexOf(I.charAt(L))!==-1}e.isEOL=_}),define(ve[139],we([0,1,58,138]),function(J,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function y(I,L,A){return C(I,L,void 0,A)}e.removeProperty=y;function C(I,L,A,c,E){const h=L.slice(),p=[],v=(0,m.parseTree)(I,p);let T,b;for(;h.length>0&&(b=h.pop(),T=(0,m.findNodeAtLocation)(v,h),T===void 0&&A!==void 0);)typeof b=="string"?A={[b]:A}:A=[A];if(T)if(T.type==="object"&&typeof b=="string"&&Array.isArray(T.children)){const o=(0,m.findNodeAtLocation)(T,[b]);if(o!==void 0)if(A===void 0){if(!o.parent)throw new Error("Malformed AST");const s=T.children.indexOf(o.parent);let g,l=o.parent.offset+o.parent.length;if(s>0){const S=T.children[s-1];g=S.offset+S.length}else g=T.offset+1,T.children.length>1&&(l=T.children[1].offset);return P(I,{offset:g,length:l-g,content:""},c)}else return P(I,{offset:o.offset,length:o.length,content:JSON.stringify(A)},c);else{if(A===void 0)return[];const s=`${JSON.stringify(b)}: ${JSON.stringify(A)}`,g=E?E(T.children.map(S=>S.children[0].value)):T.children.length;let l;if(g>0){const S=T.children[g-1];l={offset:S.offset+S.length,length:0,content:","+s}}else T.children.length===0?l={offset:T.offset+1,length:0,content:s}:l={offset:T.offset+1,length:0,content:s+","};return P(I,l,c)}}else if(T.type==="array"&&typeof b=="number"&&Array.isArray(T.children))if(A!==void 0){const o=`${JSON.stringify(A)}`;let s;if(T.children.length===0||b===0)s={offset:T.offset+1,length:0,content:T.children.length===0?o:o+","};else{const g=b===-1||b>T.children.length?T.children.length:b,l=T.children[g-1];s={offset:l.offset+l.length,length:0,content:","+o}}return P(I,s,c)}else{const o=b,s=T.children[o];let g;if(T.children.length===1)g={offset:T.offset+1,length:T.length-2,content:""};else if(T.children.length-1===o){const l=T.children[o-1],S=l.offset+l.length,n=T.offset+T.length;g={offset:S,length:n-2-S,content:""}}else g={offset:s.offset,length:T.children[o+1].offset-s.offset,content:""};return P(I,g,c)}else throw new Error(`Can not add ${typeof b!="number"?"index":"property"} to parent of type ${T.type}`);else{if(A===void 0)throw new Error("Can not delete in empty document");return P(I,{offset:v?v.offset:0,length:v?v.length:0,content:JSON.stringify(A)},c)}}e.setProperty=C;function P(I,L,A){let c=D(I,L),E=L.offset,h=L.offset+L.content.length;if(L.length===0||L.content.length===0){for(;E>0&&!(0,i.isEOL)(c,E-1);)E--;for(;h<c.length&&!(0,i.isEOL)(c,h);)h++}const p=(0,i.format)(c,{offset:E,length:h-E},A);for(let T=p.length-1;T>=0;T--){const b=p[T];c=D(c,b),E=Math.min(E,b.offset),h=Math.max(h,b.offset+b.length),h+=b.content.length-b.length}const v=I.length-(c.length-h)-E;return[{offset:E,length:v,content:c.substring(E,h)}]}e.withFormatting=P;function D(I,L){return I.substring(0,L.offset)+L.content+I.substring(L.offset+L.length)}e.applyEdit=D;function _(I,L){let A=L.slice(0).sort((E,h)=>{const p=E.offset-h.offset;return p===0?E.length-h.length:p}),c=I.length;for(let E=A.length-1;E>=0;E--){let h=A[E];if(h.offset+h.length<=c)I=D(I,h);else throw new Error("Overlapping edit");c=h.offset}return I}e.applyEdits=_}),define(ve[140],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class m{constructor(y){this.executor=y,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(y){this._error=y}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(y){return new m(()=>y(this.getValue()))}}e.Lazy=m}),define(ve[6],we([0,1,75,77]),function(J,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const y=!1;let C=null;function P(t){C=t}if(e.setDisposableTracker=P,y){const t="__is_disposable_tracked__";P(new class{trackDisposable(r){const u=new Error("Potentially leaked disposable").stack;setTimeout(()=>{r[t]||console.log(u)},3e3)}setParent(r,u){if(r&&r!==b.None)try{r[t]=!0}catch{}}markAsDisposed(r){if(r&&r!==b.None)try{r[t]=!0}catch{}}markAsSingleton(r){}})}function D(t){return C?.trackDisposable(t),t}function _(t){C?.markAsDisposed(t)}function I(t,r){C?.setParent(t,r)}function L(t,r){if(!!C)for(const u of t)C.setParent(u,r)}function A(t){return C?.markAsSingleton(t),t}e.markAsSingleton=A;class c extends Error{constructor(r){super(`Encountered errors while disposing of store. Errors: [${r.join(", ")}]`);this.errors=r}}e.MultiDisposeError=c;function E(t){return typeof t.dispose=="function"&&t.dispose.length===0}e.isDisposable=E;function h(t){if(i.Iterable.is(t)){let r=[];for(const u of t)if(u)try{u.dispose()}catch(a){r.push(a)}if(r.length===1)throw r[0];if(r.length>1)throw new c(r);return Array.isArray(t)?[]:t}else if(t)return t.dispose(),t}e.dispose=h;function p(...t){const r=v(()=>h(t));return L(t,r),r}e.combinedDisposable=p;function v(t){const r=D({dispose:(0,m.once)(()=>{_(r),t()})});return r}e.toDisposable=v;class T{constructor(){this._toDispose=new Set,this._isDisposed=!1,D(this)}dispose(){this._isDisposed||(_(this),this._isDisposed=!0,this.clear())}clear(){try{h(this._toDispose.values())}finally{this._toDispose.clear()}}add(r){if(!r)return r;if(r===this)throw new Error("Cannot register a disposable on itself!");return I(r,this),this._isDisposed?T.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(r),r}}e.DisposableStore=T,T.DISABLE_DISPOSED_WARNING=!1;class b{constructor(){this._store=new T,D(this),I(this._store,this)}dispose(){_(this),this._store.dispose()}_register(r){if(r===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(r)}}e.Disposable=b,b.None=Object.freeze({dispose(){}});class o{constructor(){this._isDisposed=!1,D(this)}get value(){return this._isDisposed?void 0:this._value}set value(r){this._isDisposed||r===this._value||(this._value?.dispose(),r&&I(r,this),this._value=r)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,_(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const r=this._value;return this._value=void 0,r&&I(r,null),r}}e.MutableDisposable=o;class s{constructor(r){this._disposable=r,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=s;class g{constructor(){this.references=new Map}acquire(r,...u){let a=this.references.get(r);a||(a={counter:0,object:this.createReferencedObject(r,...u)},this.references.set(r,a));const{object:f}=a,w=(0,m.once)(()=>{--a.counter==0&&(this.destroyReferencedObject(r,a.object),this.references.delete(r))});return a.counter++,{object:f,dispose:w}}}e.ReferenceCollection=g;class l{constructor(r){this.referenceCollection=r}async acquire(r,...u){const a=this.referenceCollection.acquire(r,...u);try{return{object:await a.object,dispose:()=>a.dispose()}}catch(f){throw a.dispose(),f}}}e.AsyncReferenceCollection=l;class S{constructor(r){this.object=r}dispose(){}}e.ImmortalReference=S;function n(t){const r=new T;try{t(r)}finally{r.dispose()}}e.disposeOnReturn=n}),define(ve[93],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class m{constructor(C){this.element=C,this.next=m.Undefined,this.prev=m.Undefined}}m.Undefined=new m(void 0);class i{constructor(){this._first=m.Undefined,this._last=m.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===m.Undefined}clear(){let C=this._first;for(;C!==m.Undefined;){const P=C.next;C.prev=m.Undefined,C.next=m.Undefined,C=P}this._first=m.Undefined,this._last=m.Undefined,this._size=0}unshift(C){return this._insert(C,!1)}push(C){return this._insert(C,!0)}_insert(C,P){const D=new m(C);if(this._first===m.Undefined)this._first=D,this._last=D;else if(P){const I=this._last;this._last=D,D.prev=I,I.next=D}else{const I=this._first;this._first=D,D.next=I,I.prev=D}this._size+=1;let _=!1;return()=>{_||(_=!0,this._remove(D))}}shift(){if(this._first!==m.Undefined){const C=this._first.element;return this._remove(this._first),C}}pop(){if(this._last!==m.Undefined){const C=this._last.element;return this._remove(this._last),C}}_remove(C){if(C.prev!==m.Undefined&&C.next!==m.Undefined){const P=C.prev;P.next=C.next,C.next.prev=P}else C.prev===m.Undefined&&C.next===m.Undefined?(this._first=m.Undefined,this._last=m.Undefined):C.next===m.Undefined?(this._last=this._last.prev,this._last.next=m.Undefined):C.prev===m.Undefined&&(this._first=this._first.next,this._first.prev=m.Undefined);this._size-=1}*[Symbol.iterator](){let C=this._first;for(;C!==m.Undefined;)yield C.element,C=C.next}}e.LinkedList=i}),function(J,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(J=typeof globalThis!="undefined"?globalThis:J||self,J.marked=e())}(this,function(){"use strict";function J(Ae,Pe){for(var ye=0;ye<Pe.length;ye++){var ce=Pe[ye];ce.enumerable=ce.enumerable||!1,ce.configurable=!0,"value"in ce&&(ce.writable=!0),Object.defineProperty(Ae,ce.key,ce)}}function e(Ae,Pe,ye){return Pe&&J(Ae.prototype,Pe),ye&&J(Ae,ye),Ae}function m(Ae,Pe){if(!!Ae){if(typeof Ae=="string")return i(Ae,Pe);var ye=Object.prototype.toString.call(Ae).slice(8,-1);if(ye==="Object"&&Ae.constructor&&(ye=Ae.constructor.name),ye==="Map"||ye==="Set")return Array.from(Ae);if(ye==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ye))return i(Ae,Pe)}}function i(Ae,Pe){(Pe==null||Pe>Ae.length)&&(Pe=Ae.length);for(var ye=0,ce=new Array(Pe);ye<Pe;ye++)ce[ye]=Ae[ye];return ce}function y(Ae,Pe){var ye=typeof Symbol!="undefined"&&Ae[Symbol.iterator]||Ae["@@iterator"];if(ye)return(ye=ye.call(Ae)).next.bind(ye);if(Array.isArray(Ae)||(ye=m(Ae))||Pe&&Ae&&typeof Ae.length=="number"){ye&&(Ae=ye);var ce=0;return function(){return ce>=Ae.length?{done:!0}:{done:!1,value:Ae[ce++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}var C={exports:{}};function P(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function D(Ae){C.exports.defaults=Ae}C.exports={defaults:P(),getDefaults:P,changeDefaults:D};var _=/[&<>"']/,I=/[&<>"']/g,L=/[<>"']|&(?!#?\w+;)/,A=/[<>"']|&(?!#?\w+;)/g,c={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},E=function(Pe){return c[Pe]};function h(Ae,Pe){if(Pe){if(_.test(Ae))return Ae.replace(I,E)}else if(L.test(Ae))return Ae.replace(A,E);return Ae}var p=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function v(Ae){return Ae.replace(p,function(Pe,ye){return ye=ye.toLowerCase(),ye==="colon"?":":ye.charAt(0)==="#"?ye.charAt(1)==="x"?String.fromCharCode(parseInt(ye.substring(2),16)):String.fromCharCode(+ye.substring(1)):""})}var T=/(^|[^\[])\^/g;function b(Ae,Pe){Ae=Ae.source||Ae,Pe=Pe||"";var ye={replace:function(de,be){return be=be.source||be,be=be.replace(T,"$1"),Ae=Ae.replace(de,be),ye},getRegex:function(){return new RegExp(Ae,Pe)}};return ye}var o=/[^\w:]/g,s=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function g(Ae,Pe,ye){if(Ae){var ce;try{ce=decodeURIComponent(v(ye)).replace(o,"").toLowerCase()}catch{return null}if(ce.indexOf("javascript:")===0||ce.indexOf("vbscript:")===0||ce.indexOf("data:")===0)return null}Pe&&!s.test(ye)&&(ye=r(Pe,ye));try{ye=encodeURI(ye).replace(/%25/g,"%")}catch{return null}return ye}var l={},S=/^[^:]+:\/*[^/]*$/,n=/^([^:]+:)[\s\S]*$/,t=/^([^:]+:\/*[^/]*)[\s\S]*$/;function r(Ae,Pe){l[" "+Ae]||(S.test(Ae)?l[" "+Ae]=Ae+"/":l[" "+Ae]=w(Ae,"/",!0)),Ae=l[" "+Ae];var ye=Ae.indexOf(":")===-1;return Pe.substring(0,2)==="//"?ye?Pe:Ae.replace(n,"$1")+Pe:Pe.charAt(0)==="/"?ye?Pe:Ae.replace(t,"$1")+Pe:Ae+Pe}var u={exec:function(){}};function a(Ae){for(var Pe=1,ye,ce;Pe<arguments.length;Pe++){ye=arguments[Pe];for(ce in ye)Object.prototype.hasOwnProperty.call(ye,ce)&&(Ae[ce]=ye[ce])}return Ae}function f(Ae,Pe){var ye=Ae.replace(/\|/g,function(be,Ce,Me){for(var Ke=!1,He=Ce;--He>=0&&Me[He]==="\\";)Ke=!Ke;return Ke?"|":" |"}),ce=ye.split(/ \|/),de=0;if(ce[0].trim()||ce.shift(),ce[ce.length-1].trim()||ce.pop(),ce.length>Pe)ce.splice(Pe);else for(;ce.length<Pe;)ce.push("");for(;de<ce.length;de++)ce[de]=ce[de].trim().replace(/\\\|/g,"|");return ce}function w(Ae,Pe,ye){var ce=Ae.length;if(ce===0)return"";for(var de=0;de<ce;){var be=Ae.charAt(ce-de-1);if(be===Pe&&!ye)de++;else if(be!==Pe&&ye)de++;else break}return Ae.substr(0,ce-de)}function d(Ae,Pe){if(Ae.indexOf(Pe[1])===-1)return-1;for(var ye=Ae.length,ce=0,de=0;de<ye;de++)if(Ae[de]==="\\")de++;else if(Ae[de]===Pe[0])ce++;else if(Ae[de]===Pe[1]&&(ce--,ce<0))return de;return-1}function k(Ae){Ae&&Ae.sanitize&&!Ae.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function R(Ae,Pe){if(Pe<1)return"";for(var ye="";Pe>1;)Pe&1&&(ye+=Ae),Pe>>=1,Ae+=Ae;return ye+Ae}var N={escape:h,unescape:v,edit:b,cleanUrl:g,resolveUrl:r,noopTest:u,merge:a,splitCells:f,rtrim:w,findClosingBracket:d,checkSanitizeDeprecation:k,repeatString:R},x=C.exports.defaults,F=N.rtrim,B=N.splitCells,O=N.escape,H=N.findClosingBracket;function M(Ae,Pe,ye,ce){var de=Pe.href,be=Pe.title?O(Pe.title):null,Ce=Ae[1].replace(/\\([\[\]])/g,"$1");if(Ae[0].charAt(0)!=="!"){ce.state.inLink=!0;var Me={type:"link",raw:ye,href:de,title:be,text:Ce,tokens:ce.inlineTokens(Ce,[])};return ce.state.inLink=!1,Me}else return{type:"image",raw:ye,href:de,title:be,text:O(Ce)}}function W(Ae,Pe){var ye=Ae.match(/^(\s+)(?:```)/);if(ye===null)return Pe;var ce=ye[1];return Pe.split(`
`).map(function(de){var be=de.match(/^\s+/);if(be===null)return de;var Ce=be[0];return Ce.length>=ce.length?de.slice(ce.length):de}).join(`
`)}var z=function(){function Ae(ye){this.options=ye||x}var Pe=Ae.prototype;return Pe.space=function(ce){var de=this.rules.block.newline.exec(ce);if(de)return de[0].length>1?{type:"space",raw:de[0]}:{raw:`
`}},Pe.code=function(ce){var de=this.rules.block.code.exec(ce);if(de){var be=de[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:de[0],codeBlockStyle:"indented",text:this.options.pedantic?be:F(be,`
`)}}},Pe.fences=function(ce){var de=this.rules.block.fences.exec(ce);if(de){var be=de[0],Ce=W(be,de[3]||"");return{type:"code",raw:be,lang:de[2]?de[2].trim():de[2],text:Ce}}},Pe.heading=function(ce){var de=this.rules.block.heading.exec(ce);if(de){var be=de[2].trim();if(/#$/.test(be)){var Ce=F(be,"#");(this.options.pedantic||!Ce||/ $/.test(Ce))&&(be=Ce.trim())}var Me={type:"heading",raw:de[0],depth:de[1].length,text:be,tokens:[]};return this.lexer.inline(Me.text,Me.tokens),Me}},Pe.hr=function(ce){var de=this.rules.block.hr.exec(ce);if(de)return{type:"hr",raw:de[0]}},Pe.blockquote=function(ce){var de=this.rules.block.blockquote.exec(ce);if(de){var be=de[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:de[0],tokens:this.lexer.blockTokens(be,[]),text:be}}},Pe.list=function(ce){var de=this.rules.block.list.exec(ce);if(de){var be,Ce,Me,Ke,He,Qe,st,at,he,De,le=de[1].trim(),X=le.length>1,ke={type:"list",raw:"",ordered:X,start:X?+le.slice(0,-1):"",loose:!1,items:[]};le=X?"\\d{1,9}\\"+le.slice(-1):"\\"+le,this.options.pedantic&&(le=X?le:"[*+-]");for(var Le=new RegExp("^( {0,3}"+le+")((?: [^\\n]*| *)(?:\\n[^\\n]*)*(?:\\n|$))");ce&&!(this.rules.block.hr.test(ce)||!(de=Le.exec(ce)));){he=de[2].split(`
`),this.options.pedantic?(Ke=2,De=he[0].trimLeft()):(Ke=de[2].search(/[^ ]/),Ke=de[1].length+(Ke>4?1:Ke),De=he[0].slice(Ke-de[1].length)),Qe=!1,be=de[0],!he[0]&&/^ *$/.test(he[1])&&(be=de[1]+he.slice(0,2).join(`
`)+`
`,ke.loose=!0,he=[]);var Ze=new RegExp("^ {0,"+Math.min(3,Ke-1)+"}(?:[*+-]|\\d{1,9}[.)])");for(He=1;He<he.length;He++){if(at=he[He],this.options.pedantic&&(at=at.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),Ze.test(at)){be=de[1]+he.slice(0,He).join(`
`)+`
`;break}if(!Qe){at.trim()||(Qe=!0),at.search(/[^ ]/)>=Ke?De+=`
`+at.slice(Ke):De+=`
`+at;continue}if(at.search(/[^ ]/)>=Ke||!at.trim()){De+=`
`+at.slice(Ke);continue}else{be=de[1]+he.slice(0,He).join(`
`)+`
`;break}}ke.loose||(st?ke.loose=!0:/\n *\n *$/.test(be)&&(st=!0)),this.options.gfm&&(Ce=/^\[[ xX]\] /.exec(De),Ce&&(Me=Ce[0]!=="[ ] ",De=De.replace(/^\[[ xX]\] +/,""))),ke.items.push({type:"list_item",raw:be,task:!!Ce,checked:Me,loose:!1,text:De}),ke.raw+=be,ce=ce.slice(be.length)}ke.items[ke.items.length-1].raw=be.trimRight(),ke.items[ke.items.length-1].text=De.trimRight(),ke.raw=ke.raw.trimRight();var qe=ke.items.length;for(He=0;He<qe;He++)this.lexer.state.top=!1,ke.items[He].tokens=this.lexer.blockTokens(ke.items[He].text,[]),ke.items[He].tokens.some(function(dt){return dt.type==="space"})&&(ke.loose=!0,ke.items[He].loose=!0);return ke}},Pe.html=function(ce){var de=this.rules.block.html.exec(ce);if(de){var be={type:"html",raw:de[0],pre:!this.options.sanitizer&&(de[1]==="pre"||de[1]==="script"||de[1]==="style"),text:de[0]};return this.options.sanitize&&(be.type="paragraph",be.text=this.options.sanitizer?this.options.sanitizer(de[0]):O(de[0]),be.tokens=[],this.lexer.inline(be.text,be.tokens)),be}},Pe.def=function(ce){var de=this.rules.block.def.exec(ce);if(de){de[3]&&(de[3]=de[3].substring(1,de[3].length-1));var be=de[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:be,raw:de[0],href:de[2],title:de[3]}}},Pe.table=function(ce){var de=this.rules.block.table.exec(ce);if(de){var be={type:"table",header:B(de[1]).map(function(st){return{text:st}}),align:de[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:de[3]?de[3].replace(/\n$/,"").split(`
`):[]};if(be.header.length===be.align.length){be.raw=de[0];var Ce=be.align.length,Me,Ke,He,Qe;for(Me=0;Me<Ce;Me++)/^ *-+: *$/.test(be.align[Me])?be.align[Me]="right":/^ *:-+: *$/.test(be.align[Me])?be.align[Me]="center":/^ *:-+ *$/.test(be.align[Me])?be.align[Me]="left":be.align[Me]=null;for(Ce=be.rows.length,Me=0;Me<Ce;Me++)be.rows[Me]=B(be.rows[Me],be.header.length).map(function(st){return{text:st}});for(Ce=be.header.length,Ke=0;Ke<Ce;Ke++)be.header[Ke].tokens=[],this.lexer.inlineTokens(be.header[Ke].text,be.header[Ke].tokens);for(Ce=be.rows.length,Ke=0;Ke<Ce;Ke++)for(Qe=be.rows[Ke],He=0;He<Qe.length;He++)Qe[He].tokens=[],this.lexer.inlineTokens(Qe[He].text,Qe[He].tokens);return be}}},Pe.lheading=function(ce){var de=this.rules.block.lheading.exec(ce);if(de){var be={type:"heading",raw:de[0],depth:de[2].charAt(0)==="="?1:2,text:de[1],tokens:[]};return this.lexer.inline(be.text,be.tokens),be}},Pe.paragraph=function(ce){var de=this.rules.block.paragraph.exec(ce);if(de){var be={type:"paragraph",raw:de[0],text:de[1].charAt(de[1].length-1)===`
`?de[1].slice(0,-1):de[1],tokens:[]};return this.lexer.inline(be.text,be.tokens),be}},Pe.text=function(ce){var de=this.rules.block.text.exec(ce);if(de){var be={type:"text",raw:de[0],text:de[0],tokens:[]};return this.lexer.inline(be.text,be.tokens),be}},Pe.escape=function(ce){var de=this.rules.inline.escape.exec(ce);if(de)return{type:"escape",raw:de[0],text:O(de[1])}},Pe.tag=function(ce){var de=this.rules.inline.tag.exec(ce);if(de)return!this.lexer.state.inLink&&/^<a /i.test(de[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(de[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(de[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(de[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:de[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(de[0]):O(de[0]):de[0]}},Pe.link=function(ce){var de=this.rules.inline.link.exec(ce);if(de){var be=de[2].trim();if(!this.options.pedantic&&/^</.test(be)){if(!/>$/.test(be))return;var Ce=F(be.slice(0,-1),"\\");if((be.length-Ce.length)%2==0)return}else{var Me=H(de[2],"()");if(Me>-1){var Ke=de[0].indexOf("!")===0?5:4,He=Ke+de[1].length+Me;de[2]=de[2].substring(0,Me),de[0]=de[0].substring(0,He).trim(),de[3]=""}}var Qe=de[2],st="";if(this.options.pedantic){var at=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Qe);at&&(Qe=at[1],st=at[3])}else st=de[3]?de[3].slice(1,-1):"";return Qe=Qe.trim(),/^</.test(Qe)&&(this.options.pedantic&&!/>$/.test(be)?Qe=Qe.slice(1):Qe=Qe.slice(1,-1)),M(de,{href:Qe&&Qe.replace(this.rules.inline._escapes,"$1"),title:st&&st.replace(this.rules.inline._escapes,"$1")},de[0],this.lexer)}},Pe.reflink=function(ce,de){var be;if((be=this.rules.inline.reflink.exec(ce))||(be=this.rules.inline.nolink.exec(ce))){var Ce=(be[2]||be[1]).replace(/\s+/g," ");if(Ce=de[Ce.toLowerCase()],!Ce||!Ce.href){var Me=be[0].charAt(0);return{type:"text",raw:Me,text:Me}}return M(be,Ce,be[0],this.lexer)}},Pe.emStrong=function(ce,de,be){be===void 0&&(be="");var Ce=this.rules.inline.emStrong.lDelim.exec(ce);if(!!Ce&&!(Ce[3]&&be.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Me=Ce[1]||Ce[2]||"";if(!Me||Me&&(be===""||this.rules.inline.punctuation.exec(be))){var Ke=Ce[0].length-1,He,Qe,st=Ke,at=0,he=Ce[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(he.lastIndex=0,de=de.slice(-1*ce.length+Ke);(Ce=he.exec(de))!=null;)if(He=Ce[1]||Ce[2]||Ce[3]||Ce[4]||Ce[5]||Ce[6],!!He){if(Qe=He.length,Ce[3]||Ce[4]){st+=Qe;continue}else if((Ce[5]||Ce[6])&&Ke%3&&!((Ke+Qe)%3)){at+=Qe;continue}if(st-=Qe,!(st>0)){if(Qe=Math.min(Qe,Qe+st+at),Math.min(Ke,Qe)%2){var De=ce.slice(1,Ke+Ce.index+Qe);return{type:"em",raw:ce.slice(0,Ke+Ce.index+Qe+1),text:De,tokens:this.lexer.inlineTokens(De,[])}}var le=ce.slice(2,Ke+Ce.index+Qe-1);return{type:"strong",raw:ce.slice(0,Ke+Ce.index+Qe+1),text:le,tokens:this.lexer.inlineTokens(le,[])}}}}}},Pe.codespan=function(ce){var de=this.rules.inline.code.exec(ce);if(de){var be=de[2].replace(/\n/g," "),Ce=/[^ ]/.test(be),Me=/^ /.test(be)&&/ $/.test(be);return Ce&&Me&&(be=be.substring(1,be.length-1)),be=O(be,!0),{type:"codespan",raw:de[0],text:be}}},Pe.br=function(ce){var de=this.rules.inline.br.exec(ce);if(de)return{type:"br",raw:de[0]}},Pe.del=function(ce){var de=this.rules.inline.del.exec(ce);if(de)return{type:"del",raw:de[0],text:de[2],tokens:this.lexer.inlineTokens(de[2],[])}},Pe.autolink=function(ce,de){var be=this.rules.inline.autolink.exec(ce);if(be){var Ce,Me;return be[2]==="@"?(Ce=O(this.options.mangle?de(be[1]):be[1]),Me="mailto:"+Ce):(Ce=O(be[1]),Me=Ce),{type:"link",raw:be[0],text:Ce,href:Me,tokens:[{type:"text",raw:Ce,text:Ce}]}}},Pe.url=function(ce,de){var be;if(be=this.rules.inline.url.exec(ce)){var Ce,Me;if(be[2]==="@")Ce=O(this.options.mangle?de(be[0]):be[0]),Me="mailto:"+Ce;else{var Ke;do Ke=be[0],be[0]=this.rules.inline._backpedal.exec(be[0])[0];while(Ke!==be[0]);Ce=O(be[0]),be[1]==="www."?Me="http://"+Ce:Me=Ce}return{type:"link",raw:be[0],text:Ce,href:Me,tokens:[{type:"text",raw:Ce,text:Ce}]}}},Pe.inlineText=function(ce,de){var be=this.rules.inline.text.exec(ce);if(be){var Ce;return this.lexer.state.inRawBlock?Ce=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(be[0]):O(be[0]):be[0]:Ce=O(this.options.smartypants?de(be[0]):be[0]),{type:"text",raw:be[0],text:Ce}}},Ae}(),U=N.noopTest,V=N.edit,K=N.merge,G={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,table:U,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};G._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,G._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,G.def=V(G.def).replace("label",G._label).replace("title",G._title).getRegex(),G.bullet=/(?:[*+-]|\d{1,9}[.)])/,G.listItemStart=V(/^( *)(bull) */).replace("bull",G.bullet).getRegex(),G.list=V(G.list).replace(/bull/g,G.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+G.def.source+")").getRegex(),G._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",G._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,G.html=V(G.html,"i").replace("comment",G._comment).replace("tag",G._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),G.paragraph=V(G._paragraph).replace("hr",G.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",G._tag).getRegex(),G.blockquote=V(G.blockquote).replace("paragraph",G.paragraph).getRegex(),G.normal=K({},G),G.gfm=K({},G.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)\\|?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),G.gfm.table=V(G.gfm.table).replace("hr",G.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",G._tag).getRegex(),G.pedantic=K({},G.normal,{html:V(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",G._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:U,paragraph:V(G.normal._paragraph).replace("hr",G.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",G.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var Q={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:U,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_*]*?\*[^_*]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^_*]*?\_[^_*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:U,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};Q._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",Q.punctuation=V(Q.punctuation).replace(/punctuation/g,Q._punctuation).getRegex(),Q.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,Q.escapedEmSt=/\\\*|\\_/g,Q._comment=V(G._comment).replace("(?:-->|$)","-->").getRegex(),Q.emStrong.lDelim=V(Q.emStrong.lDelim).replace(/punct/g,Q._punctuation).getRegex(),Q.emStrong.rDelimAst=V(Q.emStrong.rDelimAst,"g").replace(/punct/g,Q._punctuation).getRegex(),Q.emStrong.rDelimUnd=V(Q.emStrong.rDelimUnd,"g").replace(/punct/g,Q._punctuation).getRegex(),Q._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,Q._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,Q._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,Q.autolink=V(Q.autolink).replace("scheme",Q._scheme).replace("email",Q._email).getRegex(),Q._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,Q.tag=V(Q.tag).replace("comment",Q._comment).replace("attribute",Q._attribute).getRegex(),Q._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,Q._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,Q._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,Q.link=V(Q.link).replace("label",Q._label).replace("href",Q._href).replace("title",Q._title).getRegex(),Q.reflink=V(Q.reflink).replace("label",Q._label).getRegex(),Q.reflinkSearch=V(Q.reflinkSearch,"g").replace("reflink",Q.reflink).replace("nolink",Q.nolink).getRegex(),Q.normal=K({},Q),Q.pedantic=K({},Q.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:V(/^!?\[(label)\]\((.*?)\)/).replace("label",Q._label).getRegex(),reflink:V(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",Q._label).getRegex()}),Q.gfm=K({},Q.normal,{escape:V(Q.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),Q.gfm.url=V(Q.gfm.url,"i").replace("email",Q.gfm._extended_email).getRegex(),Q.breaks=K({},Q.gfm,{br:V(Q.br).replace("{2,}","*").getRegex(),text:V(Q.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var Y={block:G,inline:Q},fe=z,me=C.exports.defaults,_e=Y.block,Ie=Y.inline,Oe=N.repeatString;function We(Ae){return Ae.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function j(Ae){var Pe="",ye,ce,de=Ae.length;for(ye=0;ye<de;ye++)ce=Ae.charCodeAt(ye),Math.random()>.5&&(ce="x"+ce.toString(16)),Pe+="&#"+ce+";";return Pe}var Z=function(){function Ae(ye){this.tokens=[],this.tokens.links=Object.create(null),this.options=ye||me,this.options.tokenizer=this.options.tokenizer||new fe,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ce={block:_e.normal,inline:Ie.normal};this.options.pedantic?(ce.block=_e.pedantic,ce.inline=Ie.pedantic):this.options.gfm&&(ce.block=_e.gfm,this.options.breaks?ce.inline=Ie.breaks:ce.inline=Ie.gfm),this.tokenizer.rules=ce}Ae.lex=function(ce,de){var be=new Ae(de);return be.lex(ce)},Ae.lexInline=function(ce,de){var be=new Ae(de);return be.inlineTokens(ce)};var Pe=Ae.prototype;return Pe.lex=function(ce){ce=ce.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(ce,this.tokens);for(var de;de=this.inlineQueue.shift();)this.inlineTokens(de.src,de.tokens);return this.tokens},Pe.blockTokens=function(ce,de){var be=this;de===void 0&&(de=[]),this.options.pedantic&&(ce=ce.replace(/^ +$/gm,""));for(var Ce,Me,Ke,He;ce;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(st){return(Ce=st.call({lexer:be},ce,de))?(ce=ce.substring(Ce.raw.length),de.push(Ce),!0):!1}))){if(Ce=this.tokenizer.space(ce)){ce=ce.substring(Ce.raw.length),Ce.type&&de.push(Ce);continue}if(Ce=this.tokenizer.code(ce)){ce=ce.substring(Ce.raw.length),Me=de[de.length-1],Me&&(Me.type==="paragraph"||Me.type==="text")?(Me.raw+=`
`+Ce.raw,Me.text+=`
`+Ce.text,this.inlineQueue[this.inlineQueue.length-1].src=Me.text):de.push(Ce);continue}if(Ce=this.tokenizer.fences(ce)){ce=ce.substring(Ce.raw.length),de.push(Ce);continue}if(Ce=this.tokenizer.heading(ce)){ce=ce.substring(Ce.raw.length),de.push(Ce);continue}if(Ce=this.tokenizer.hr(ce)){ce=ce.substring(Ce.raw.length),de.push(Ce);continue}if(Ce=this.tokenizer.blockquote(ce)){ce=ce.substring(Ce.raw.length),de.push(Ce);continue}if(Ce=this.tokenizer.list(ce)){ce=ce.substring(Ce.raw.length),de.push(Ce);continue}if(Ce=this.tokenizer.html(ce)){ce=ce.substring(Ce.raw.length),de.push(Ce);continue}if(Ce=this.tokenizer.def(ce)){ce=ce.substring(Ce.raw.length),Me=de[de.length-1],Me&&(Me.type==="paragraph"||Me.type==="text")?(Me.raw+=`
`+Ce.raw,Me.text+=`
`+Ce.raw,this.inlineQueue[this.inlineQueue.length-1].src=Me.text):this.tokens.links[Ce.tag]||(this.tokens.links[Ce.tag]={href:Ce.href,title:Ce.title});continue}if(Ce=this.tokenizer.table(ce)){ce=ce.substring(Ce.raw.length),de.push(Ce);continue}if(Ce=this.tokenizer.lheading(ce)){ce=ce.substring(Ce.raw.length),de.push(Ce);continue}if(Ke=ce,this.options.extensions&&this.options.extensions.startBlock&&function(){var st=1/0,at=ce.slice(1),he=void 0;be.options.extensions.startBlock.forEach(function(De){he=De.call({lexer:this},at),typeof he=="number"&&he>=0&&(st=Math.min(st,he))}),st<1/0&&st>=0&&(Ke=ce.substring(0,st+1))}(),this.state.top&&(Ce=this.tokenizer.paragraph(Ke))){Me=de[de.length-1],He&&Me.type==="paragraph"?(Me.raw+=`
`+Ce.raw,Me.text+=`
`+Ce.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Me.text):de.push(Ce),He=Ke.length!==ce.length,ce=ce.substring(Ce.raw.length);continue}if(Ce=this.tokenizer.text(ce)){ce=ce.substring(Ce.raw.length),Me=de[de.length-1],Me&&Me.type==="text"?(Me.raw+=`
`+Ce.raw,Me.text+=`
`+Ce.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Me.text):de.push(Ce);continue}if(ce){var Qe="Infinite loop on byte: "+ce.charCodeAt(0);if(this.options.silent){console.error(Qe);break}else throw new Error(Qe)}}return this.state.top=!0,de},Pe.inline=function(ce,de){this.inlineQueue.push({src:ce,tokens:de})},Pe.inlineTokens=function(ce,de){var be=this;de===void 0&&(de=[]);var Ce,Me,Ke,He=ce,Qe,st,at;if(this.tokens.links){var he=Object.keys(this.tokens.links);if(he.length>0)for(;(Qe=this.tokenizer.rules.inline.reflinkSearch.exec(He))!=null;)he.includes(Qe[0].slice(Qe[0].lastIndexOf("[")+1,-1))&&(He=He.slice(0,Qe.index)+"["+Oe("a",Qe[0].length-2)+"]"+He.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Qe=this.tokenizer.rules.inline.blockSkip.exec(He))!=null;)He=He.slice(0,Qe.index)+"["+Oe("a",Qe[0].length-2)+"]"+He.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Qe=this.tokenizer.rules.inline.escapedEmSt.exec(He))!=null;)He=He.slice(0,Qe.index)+"++"+He.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ce;)if(st||(at=""),st=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(le){return(Ce=le.call({lexer:be},ce,de))?(ce=ce.substring(Ce.raw.length),de.push(Ce),!0):!1}))){if(Ce=this.tokenizer.escape(ce)){ce=ce.substring(Ce.raw.length),de.push(Ce);continue}if(Ce=this.tokenizer.tag(ce)){ce=ce.substring(Ce.raw.length),Me=de[de.length-1],Me&&Ce.type==="text"&&Me.type==="text"?(Me.raw+=Ce.raw,Me.text+=Ce.text):de.push(Ce);continue}if(Ce=this.tokenizer.link(ce)){ce=ce.substring(Ce.raw.length),de.push(Ce);continue}if(Ce=this.tokenizer.reflink(ce,this.tokens.links)){ce=ce.substring(Ce.raw.length),Me=de[de.length-1],Me&&Ce.type==="text"&&Me.type==="text"?(Me.raw+=Ce.raw,Me.text+=Ce.text):de.push(Ce);continue}if(Ce=this.tokenizer.emStrong(ce,He,at)){ce=ce.substring(Ce.raw.length),de.push(Ce);continue}if(Ce=this.tokenizer.codespan(ce)){ce=ce.substring(Ce.raw.length),de.push(Ce);continue}if(Ce=this.tokenizer.br(ce)){ce=ce.substring(Ce.raw.length),de.push(Ce);continue}if(Ce=this.tokenizer.del(ce)){ce=ce.substring(Ce.raw.length),de.push(Ce);continue}if(Ce=this.tokenizer.autolink(ce,j)){ce=ce.substring(Ce.raw.length),de.push(Ce);continue}if(!this.state.inLink&&(Ce=this.tokenizer.url(ce,j))){ce=ce.substring(Ce.raw.length),de.push(Ce);continue}if(Ke=ce,this.options.extensions&&this.options.extensions.startInline&&function(){var le=1/0,X=ce.slice(1),ke=void 0;be.options.extensions.startInline.forEach(function(Le){ke=Le.call({lexer:this},X),typeof ke=="number"&&ke>=0&&(le=Math.min(le,ke))}),le<1/0&&le>=0&&(Ke=ce.substring(0,le+1))}(),Ce=this.tokenizer.inlineText(Ke,We)){ce=ce.substring(Ce.raw.length),Ce.raw.slice(-1)!=="_"&&(at=Ce.raw.slice(-1)),st=!0,Me=de[de.length-1],Me&&Me.type==="text"?(Me.raw+=Ce.raw,Me.text+=Ce.text):de.push(Ce);continue}if(ce){var De="Infinite loop on byte: "+ce.charCodeAt(0);if(this.options.silent){console.error(De);break}else throw new Error(De)}}return de},e(Ae,null,[{key:"rules",get:function(){return{block:_e,inline:Ie}}}]),Ae}(),re=C.exports.defaults,ue=N.cleanUrl,te=N.escape,oe=function(){function Ae(ye){this.options=ye||re}var Pe=Ae.prototype;return Pe.code=function(ce,de,be){var Ce=(de||"").match(/\S*/)[0];if(this.options.highlight){var Me=this.options.highlight(ce,Ce);Me!=null&&Me!==ce&&(be=!0,ce=Me)}return ce=ce.replace(/\n$/,"")+`
`,Ce?'<pre><code class="'+this.options.langPrefix+te(Ce,!0)+'">'+(be?ce:te(ce,!0))+`</code></pre>
`:"<pre><code>"+(be?ce:te(ce,!0))+`</code></pre>
`},Pe.blockquote=function(ce){return`<blockquote>
`+ce+`</blockquote>
`},Pe.html=function(ce){return ce},Pe.heading=function(ce,de,be,Ce){return this.options.headerIds?"<h"+de+' id="'+this.options.headerPrefix+Ce.slug(be)+'">'+ce+"</h"+de+`>
`:"<h"+de+">"+ce+"</h"+de+`>
`},Pe.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Pe.list=function(ce,de,be){var Ce=de?"ol":"ul",Me=de&&be!==1?' start="'+be+'"':"";return"<"+Ce+Me+`>
`+ce+"</"+Ce+`>
`},Pe.listitem=function(ce){return"<li>"+ce+`</li>
`},Pe.checkbox=function(ce){return"<input "+(ce?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Pe.paragraph=function(ce){return"<p>"+ce+`</p>
`},Pe.table=function(ce,de){return de&&(de="<tbody>"+de+"</tbody>"),`<table>
<thead>
`+ce+`</thead>
`+de+`</table>
`},Pe.tablerow=function(ce){return`<tr>
`+ce+`</tr>
`},Pe.tablecell=function(ce,de){var be=de.header?"th":"td",Ce=de.align?"<"+be+' align="'+de.align+'">':"<"+be+">";return Ce+ce+"</"+be+`>
`},Pe.strong=function(ce){return"<strong>"+ce+"</strong>"},Pe.em=function(ce){return"<em>"+ce+"</em>"},Pe.codespan=function(ce){return"<code>"+ce+"</code>"},Pe.br=function(){return this.options.xhtml?"<br/>":"<br>"},Pe.del=function(ce){return"<del>"+ce+"</del>"},Pe.link=function(ce,de,be){if(ce=ue(this.options.sanitize,this.options.baseUrl,ce),ce===null)return be;var Ce='<a href="'+te(ce)+'"';return de&&(Ce+=' title="'+de+'"'),Ce+=">"+be+"</a>",Ce},Pe.image=function(ce,de,be){if(ce=ue(this.options.sanitize,this.options.baseUrl,ce),ce===null)return be;var Ce='<img src="'+ce+'" alt="'+be+'"';return de&&(Ce+=' title="'+de+'"'),Ce+=this.options.xhtml?"/>":">",Ce},Pe.text=function(ce){return ce},Ae}(),Ee=function(){function Ae(){}var Pe=Ae.prototype;return Pe.strong=function(ce){return ce},Pe.em=function(ce){return ce},Pe.codespan=function(ce){return ce},Pe.del=function(ce){return ce},Pe.html=function(ce){return ce},Pe.text=function(ce){return ce},Pe.link=function(ce,de,be){return""+be},Pe.image=function(ce,de,be){return""+be},Pe.br=function(){return""},Ae}(),Ne=function(){function Ae(){this.seen={}}var Pe=Ae.prototype;return Pe.serialize=function(ce){return ce.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Pe.getNextSafeSlug=function(ce,de){var be=ce,Ce=0;if(this.seen.hasOwnProperty(be)){Ce=this.seen[ce];do Ce++,be=ce+"-"+Ce;while(this.seen.hasOwnProperty(be))}return de||(this.seen[ce]=Ce,this.seen[be]=0),be},Pe.slug=function(ce,de){de===void 0&&(de={});var be=this.serialize(ce);return this.getNextSafeSlug(be,de.dryrun)},Ae}(),Ve=oe,Ge=Ee,Je=Ne,tt=C.exports.defaults,ot=N.unescape,et=function(){function Ae(ye){this.options=ye||tt,this.options.renderer=this.options.renderer||new Ve,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Ge,this.slugger=new Je}Ae.parse=function(ce,de){var be=new Ae(de);return be.parse(ce)},Ae.parseInline=function(ce,de){var be=new Ae(de);return be.parseInline(ce)};var Pe=Ae.prototype;return Pe.parse=function(ce,de){de===void 0&&(de=!0);var be="",Ce,Me,Ke,He,Qe,st,at,he,De,le,X,ke,Le,Ze,qe,dt,wt,yt,bt,ft=ce.length;for(Ce=0;Ce<ft;Ce++){if(le=ce[Ce],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[le.type]&&(bt=this.options.extensions.renderers[le.type].call({parser:this},le),bt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(le.type))){be+=bt||"";continue}switch(le.type){case"space":continue;case"hr":{be+=this.renderer.hr();continue}case"heading":{be+=this.renderer.heading(this.parseInline(le.tokens),le.depth,ot(this.parseInline(le.tokens,this.textRenderer)),this.slugger);continue}case"code":{be+=this.renderer.code(le.text,le.lang,le.escaped);continue}case"table":{for(he="",at="",He=le.header.length,Me=0;Me<He;Me++)at+=this.renderer.tablecell(this.parseInline(le.header[Me].tokens),{header:!0,align:le.align[Me]});for(he+=this.renderer.tablerow(at),De="",He=le.rows.length,Me=0;Me<He;Me++){for(st=le.rows[Me],at="",Qe=st.length,Ke=0;Ke<Qe;Ke++)at+=this.renderer.tablecell(this.parseInline(st[Ke].tokens),{header:!1,align:le.align[Ke]});De+=this.renderer.tablerow(at)}be+=this.renderer.table(he,De);continue}case"blockquote":{De=this.parse(le.tokens),be+=this.renderer.blockquote(De);continue}case"list":{for(X=le.ordered,ke=le.start,Le=le.loose,He=le.items.length,De="",Me=0;Me<He;Me++)qe=le.items[Me],dt=qe.checked,wt=qe.task,Ze="",qe.task&&(yt=this.renderer.checkbox(dt),Le?qe.tokens.length>0&&qe.tokens[0].type==="paragraph"?(qe.tokens[0].text=yt+" "+qe.tokens[0].text,qe.tokens[0].tokens&&qe.tokens[0].tokens.length>0&&qe.tokens[0].tokens[0].type==="text"&&(qe.tokens[0].tokens[0].text=yt+" "+qe.tokens[0].tokens[0].text)):qe.tokens.unshift({type:"text",text:yt}):Ze+=yt),Ze+=this.parse(qe.tokens,Le),De+=this.renderer.listitem(Ze,wt,dt);be+=this.renderer.list(De,X,ke);continue}case"html":{be+=this.renderer.html(le.text);continue}case"paragraph":{be+=this.renderer.paragraph(this.parseInline(le.tokens));continue}case"text":{for(De=le.tokens?this.parseInline(le.tokens):le.text;Ce+1<ft&&ce[Ce+1].type==="text";)le=ce[++Ce],De+=`
`+(le.tokens?this.parseInline(le.tokens):le.text);be+=de?this.renderer.paragraph(De):De;continue}default:{var vt='Token with "'+le.type+'" type was not found.';if(this.options.silent){console.error(vt);return}else throw new Error(vt)}}}return be},Pe.parseInline=function(ce,de){de=de||this.renderer;var be="",Ce,Me,Ke,He=ce.length;for(Ce=0;Ce<He;Ce++){if(Me=ce[Ce],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Me.type]&&(Ke=this.options.extensions.renderers[Me.type].call({parser:this},Me),Ke!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Me.type))){be+=Ke||"";continue}switch(Me.type){case"escape":{be+=de.text(Me.text);break}case"html":{be+=de.html(Me.text);break}case"link":{be+=de.link(Me.href,Me.title,this.parseInline(Me.tokens,de));break}case"image":{be+=de.image(Me.href,Me.title,Me.text);break}case"strong":{be+=de.strong(this.parseInline(Me.tokens,de));break}case"em":{be+=de.em(this.parseInline(Me.tokens,de));break}case"codespan":{be+=de.codespan(Me.text);break}case"br":{be+=de.br();break}case"del":{be+=de.del(this.parseInline(Me.tokens,de));break}case"text":{be+=de.text(Me.text);break}default:{var Qe='Token with "'+Me.type+'" type was not found.';if(this.options.silent){console.error(Qe);return}else throw new Error(Qe)}}}return be},Ae}(),it=Z,lt=et,pt=z,Pt=oe,xe=Ee,Rt=Ne,ee=N.merge,ne=N.checkSanitizeDeprecation,pe=N.escape,ie=C.exports.getDefaults,Se=C.exports.changeDefaults,Fe=C.exports.defaults;function Ue(Ae,Pe,ye){if(typeof Ae=="undefined"||Ae===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Ae!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Ae)+", string expected");if(typeof Pe=="function"&&(ye=Pe,Pe=null),Pe=ee({},Ue.defaults,Pe||{}),ne(Pe),ye){var ce=Pe.highlight,de;try{de=it.lex(Ae,Pe)}catch(Ke){return ye(Ke)}var be=function(He){var Qe;if(!He)try{Pe.walkTokens&&Ue.walkTokens(de,Pe.walkTokens),Qe=lt.parse(de,Pe)}catch(st){He=st}return Pe.highlight=ce,He?ye(He):ye(null,Qe)};if(!ce||ce.length<3||(delete Pe.highlight,!de.length))return be();var Ce=0;Ue.walkTokens(de,function(Ke){Ke.type==="code"&&(Ce++,setTimeout(function(){ce(Ke.text,Ke.lang,function(He,Qe){if(He)return be(He);Qe!=null&&Qe!==Ke.text&&(Ke.text=Qe,Ke.escaped=!0),Ce--,Ce===0&&be()})},0))}),Ce===0&&be();return}try{var Me=it.lex(Ae,Pe);return Pe.walkTokens&&Ue.walkTokens(Me,Pe.walkTokens),lt.parse(Me,Pe)}catch(Ke){if(Ke.message+=`
Please report this to https://github.com/markedjs/marked.`,Pe.silent)return"<p>An error occurred:</p><pre>"+pe(Ke.message+"",!0)+"</pre>";throw Ke}}Ue.options=Ue.setOptions=function(Ae){return ee(Ue.defaults,Ae),Se(Ue.defaults),Ue},Ue.getDefaults=ie,Ue.defaults=Fe,Ue.use=function(){for(var Ae=this,Pe=arguments.length,ye=new Array(Pe),ce=0;ce<Pe;ce++)ye[ce]=arguments[ce];var de=ee.apply(void 0,[{}].concat(ye)),be=Ue.defaults.extensions||{renderers:{},childTokens:{}},Ce;ye.forEach(function(Me){if(Me.extensions&&(Ce=!0,Me.extensions.forEach(function(He){if(!He.name)throw new Error("extension name required");if(He.renderer){var Qe=be.renderers?be.renderers[He.name]:null;Qe?be.renderers[He.name]=function(){for(var st=arguments.length,at=new Array(st),he=0;he<st;he++)at[he]=arguments[he];var De=He.renderer.apply(this,at);return De===!1&&(De=Qe.apply(this,at)),De}:be.renderers[He.name]=He.renderer}if(He.tokenizer){if(!He.level||He.level!=="block"&&He.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");be[He.level]?be[He.level].unshift(He.tokenizer):be[He.level]=[He.tokenizer],He.start&&(He.level==="block"?be.startBlock?be.startBlock.push(He.start):be.startBlock=[He.start]:He.level==="inline"&&(be.startInline?be.startInline.push(He.start):be.startInline=[He.start]))}He.childTokens&&(be.childTokens[He.name]=He.childTokens)})),Me.renderer&&function(){var He=Ue.defaults.renderer||new Pt,Qe=function(he){var De=He[he];He[he]=function(){for(var le=arguments.length,X=new Array(le),ke=0;ke<le;ke++)X[ke]=arguments[ke];var Le=Me.renderer[he].apply(He,X);return Le===!1&&(Le=De.apply(He,X)),Le}};for(var st in Me.renderer)Qe(st);de.renderer=He}(),Me.tokenizer&&function(){var He=Ue.defaults.tokenizer||new pt,Qe=function(he){var De=He[he];He[he]=function(){for(var le=arguments.length,X=new Array(le),ke=0;ke<le;ke++)X[ke]=arguments[ke];var Le=Me.tokenizer[he].apply(He,X);return Le===!1&&(Le=De.apply(He,X)),Le}};for(var st in Me.tokenizer)Qe(st);de.tokenizer=He}(),Me.walkTokens){var Ke=Ue.defaults.walkTokens;de.walkTokens=function(He){Me.walkTokens.call(Ae,He),Ke&&Ke(He)}}Ce&&(de.extensions=be),Ue.setOptions(de)})},Ue.walkTokens=function(Ae,Pe){for(var ye=function(){var Ce=de.value;switch(Pe(Ce),Ce.type){case"table":{for(var Me=y(Ce.header),Ke;!(Ke=Me()).done;){var He=Ke.value;Ue.walkTokens(He.tokens,Pe)}for(var Qe=y(Ce.rows),st;!(st=Qe()).done;)for(var at=st.value,he=y(at),De;!(De=he()).done;){var le=De.value;Ue.walkTokens(le.tokens,Pe)}break}case"list":{Ue.walkTokens(Ce.items,Pe);break}default:Ue.defaults.extensions&&Ue.defaults.extensions.childTokens&&Ue.defaults.extensions.childTokens[Ce.type]?Ue.defaults.extensions.childTokens[Ce.type].forEach(function(X){Ue.walkTokens(Ce[X],Pe)}):Ce.tokens&&Ue.walkTokens(Ce.tokens,Pe)}},ce=y(Ae),de;!(de=ce()).done;)ye()},Ue.parseInline=function(Ae,Pe){if(typeof Ae=="undefined"||Ae===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Ae!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Ae)+", string expected");Pe=ee({},Ue.defaults,Pe||{}),ne(Pe);try{var ye=it.lexInline(Ae,Pe);return Pe.walkTokens&&Ue.walkTokens(ye,Pe.walkTokens),lt.parseInline(ye,Pe)}catch(ce){if(ce.message+=`
Please report this to https://github.com/markedjs/marked.`,Pe.silent)return"<p>An error occurred:</p><pre>"+pe(ce.message+"",!0)+"</pre>";throw ce}},Ue.Parser=lt,Ue.parser=lt.parse,Ue.Renderer=Pt,Ue.TextRenderer=xe,Ue.Lexer=it,Ue.lexer=it.lex,Ue.Tokenizer=pt,Ue.Slugger=Rt,Ue.parse=Ue;var Xe=Ue;return Xe}),define(ve[78],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function m(P,D,_){return Math.min(Math.max(P,D),_)}e.clamp=m;function i(P,D){return(D+P%D)%D}e.rot=i;class y{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=y;class C{constructor(){this._n=1,this._val=0}update(D){return this._val=this._val+(D-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=C}),function(){function J(y){const C=[];typeof y=="number"&&C.push("code/timeOrigin",y);function P(_){C.push(_,Date.now())}function D(){const _=[];for(let I=0;I<C.length;I+=2)_.push({name:C[I],startTime:C[I+1]});return _}return{mark:P,getMarks:D}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(y){performance.mark(y)},getMarks(){let y=performance.timeOrigin;typeof y!="number"&&(y=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const C=[{name:"code/timeOrigin",startTime:Math.round(y)}];for(const P of performance.getEntriesByType("mark"))C.push({name:P.name,startTime:Math.round(y+P.startTime)});return C}};if(typeof process=="object"){const y=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(y)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function m(y){return y.MonacoPerformanceMarks||(y.MonacoPerformanceMarks=e()),y.MonacoPerformanceMarks}var i;typeof global=="object"?i=global:typeof self=="object"?i=self:i={},typeof define=="function"?define("vs/base/common/performance",[],function(){return m(i)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=m(i):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),i.perf=m(i))}(),define(ve[12],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const m="en";let i=!1,y=!1,C=!1,P=!1,D=!1,_=!1,I=!1,L=!1,A,c=m,E,h;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let p;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?p=e.globals.vscode.process:typeof process!="undefined"&&(p=process);const v=typeof p?.versions?.electron=="string",T=v&&p?.type==="renderer";if(e.isElectronSandboxed=T&&p?.sandboxed,typeof navigator=="object"&&!T)h=navigator.userAgent,i=h.indexOf("Windows")>=0,y=h.indexOf("Macintosh")>=0,L=(h.indexOf("Macintosh")>=0||h.indexOf("iPad")>=0||h.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,C=h.indexOf("Linux")>=0,_=!0,A=navigator.language,c=A;else if(typeof p=="object"){i=p.platform==="win32",y=p.platform==="darwin",C=p.platform==="linux",P=C&&!!p.env.SNAP&&!!p.env.SNAP_REVISION,I=v,A=m,c=m;const r=p.env.VSCODE_NLS_CONFIG;if(r)try{const u=JSON.parse(r),a=u.availableLanguages["*"];A=u.locale,c=a||m,E=u._translationsConfigFile}catch{}D=!0}else console.error("Unable to resolve platform.");var b;(function(r){r[r.Web=0]="Web",r[r.Mac=1]="Mac",r[r.Linux=2]="Linux",r[r.Windows=3]="Windows"})(b=e.Platform||(e.Platform={}));function o(r){switch(r){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=o;let s=0;y?s=1:i?s=3:C&&(s=2),e.isWindows=i,e.isMacintosh=y,e.isLinux=C,e.isLinuxSnap=P,e.isNative=D,e.isElectron=I,e.isWeb=_,e.isIOS=L,e.platform=s,e.userAgent=h,e.language=c;var g;(function(r){function u(){return e.language}r.value=u;function a(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}r.isDefaultVariant=a;function f(){return e.language==="en"}r.isDefault=f})(g=e.Language||(e.Language={})),e.locale=A,e.translationsConfigFile=E,e.setTimeout0=(()=>{if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let r=[];e.globals.addEventListener("message",a=>{if(a.data&&a.data.vscodeScheduleAsyncWork)for(let f=0,w=r.length;f<w;f++){const d=r[f];if(d.id===a.data.vscodeScheduleAsyncWork){r.splice(f,1),d.callback();return}}});let u=0;return a=>{const f=++u;r.push({id:f,callback:a}),e.globals.postMessage({vscodeScheduleAsyncWork:f},"*")}}return r=>setTimeout(r)})();var l;(function(r){r[r.Windows=1]="Windows",r[r.Macintosh=2]="Macintosh",r[r.Linux=3]="Linux"})(l=e.OperatingSystem||(e.OperatingSystem={})),e.OS=y||L?2:i?1:3;let S=!0,n=!1;function t(){if(!n){n=!0;const r=new Uint8Array(2);r[0]=1,r[1]=2,S=new Uint16Array(r.buffer)[0]===(2<<8)+1}return S}e.isLittleEndian=t}),define(ve[40],we([0,1,12]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let i;if(typeof m.globals.vscode!="undefined"&&typeof m.globals.vscode.process!="undefined"){const y=m.globals.vscode.process;i={get platform(){return y.platform},get arch(){return y.arch},get env(){return y.env},cwd(){return y.cwd()}}}else typeof process!="undefined"?i={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:i={get platform(){return m.isWindows?"win32":m.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=i.cwd,e.env=i.env,e.platform=i.platform,e.arch=i.arch}),define(ve[9],we([0,1,40]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const i=65,y=97,C=90,P=122,D=46,_=47,I=92,L=58,A=63;class c extends Error{constructor(s,g,l){let S;typeof g=="string"&&g.indexOf("not ")===0?(S="must not be",g=g.replace(/^not /,"")):S="must be";const n=s.indexOf(".")!==-1?"property":"argument";let t=`The "${s}" ${n} ${S} of type ${g}`;t+=`. Received type ${typeof l}`;super(t);this.code="ERR_INVALID_ARG_TYPE"}}function E(o,s){if(typeof o!="string")throw new c(s,"string",o)}function h(o){return o===_||o===I}function p(o){return o===_}function v(o){return o>=i&&o<=C||o>=y&&o<=P}function T(o,s,g,l){let S="",n=0,t=-1,r=0,u=0;for(let a=0;a<=o.length;++a){if(a<o.length)u=o.charCodeAt(a);else{if(l(u))break;u=_}if(l(u)){if(!(t===a-1||r===1))if(r===2){if(S.length<2||n!==2||S.charCodeAt(S.length-1)!==D||S.charCodeAt(S.length-2)!==D){if(S.length>2){const f=S.lastIndexOf(g);f===-1?(S="",n=0):(S=S.slice(0,f),n=S.length-1-S.lastIndexOf(g)),t=a,r=0;continue}else if(S.length!==0){S="",n=0,t=a,r=0;continue}}s&&(S+=S.length>0?`${g}..`:"..",n=2)}else S.length>0?S+=`${g}${o.slice(t+1,a)}`:S=o.slice(t+1,a),n=a-t-1;t=a,r=0}else u===D&&r!==-1?++r:r=-1}return S}function b(o,s){if(s===null||typeof s!="object")throw new c("pathObject","Object",s);const g=s.dir||s.root,l=s.base||`${s.name||""}${s.ext||""}`;return g?g===s.root?`${g}${l}`:`${g}${o}${l}`:l}e.win32={resolve(...o){let s="",g="",l=!1;for(let S=o.length-1;S>=-1;S--){let n;if(S>=0){if(n=o[S],E(n,"path"),n.length===0)continue}else s.length===0?n=m.cwd():(n=m.env[`=${s}`]||m.cwd(),(n===void 0||n.slice(0,2).toLowerCase()!==s.toLowerCase()&&n.charCodeAt(2)===I)&&(n=`${s}\\`));const t=n.length;let r=0,u="",a=!1;const f=n.charCodeAt(0);if(t===1)h(f)&&(r=1,a=!0);else if(h(f))if(a=!0,h(n.charCodeAt(1))){let w=2,d=w;for(;w<t&&!h(n.charCodeAt(w));)w++;if(w<t&&w!==d){const k=n.slice(d,w);for(d=w;w<t&&h(n.charCodeAt(w));)w++;if(w<t&&w!==d){for(d=w;w<t&&!h(n.charCodeAt(w));)w++;(w===t||w!==d)&&(u=`\\\\${k}\\${n.slice(d,w)}`,r=w)}}}else r=1;else v(f)&&n.charCodeAt(1)===L&&(u=n.slice(0,2),r=2,t>2&&h(n.charCodeAt(2))&&(a=!0,r=3));if(u.length>0)if(s.length>0){if(u.toLowerCase()!==s.toLowerCase())continue}else s=u;if(l){if(s.length>0)break}else if(g=`${n.slice(r)}\\${g}`,l=a,a&&s.length>0)break}return g=T(g,!l,"\\",h),l?`${s}\\${g}`:`${s}${g}`||"."},normalize(o){E(o,"path");const s=o.length;if(s===0)return".";let g=0,l,S=!1;const n=o.charCodeAt(0);if(s===1)return p(n)?"\\":o;if(h(n))if(S=!0,h(o.charCodeAt(1))){let r=2,u=r;for(;r<s&&!h(o.charCodeAt(r));)r++;if(r<s&&r!==u){const a=o.slice(u,r);for(u=r;r<s&&h(o.charCodeAt(r));)r++;if(r<s&&r!==u){for(u=r;r<s&&!h(o.charCodeAt(r));)r++;if(r===s)return`\\\\${a}\\${o.slice(u)}\\`;r!==u&&(l=`\\\\${a}\\${o.slice(u,r)}`,g=r)}}}else g=1;else v(n)&&o.charCodeAt(1)===L&&(l=o.slice(0,2),g=2,s>2&&h(o.charCodeAt(2))&&(S=!0,g=3));let t=g<s?T(o.slice(g),!S,"\\",h):"";return t.length===0&&!S&&(t="."),t.length>0&&h(o.charCodeAt(s-1))&&(t+="\\"),l===void 0?S?`\\${t}`:t:S?`${l}\\${t}`:`${l}${t}`},isAbsolute(o){E(o,"path");const s=o.length;if(s===0)return!1;const g=o.charCodeAt(0);return h(g)||s>2&&v(g)&&o.charCodeAt(1)===L&&h(o.charCodeAt(2))},join(...o){if(o.length===0)return".";let s,g;for(let n=0;n<o.length;++n){const t=o[n];E(t,"path"),t.length>0&&(s===void 0?s=g=t:s+=`\\${t}`)}if(s===void 0)return".";let l=!0,S=0;if(typeof g=="string"&&h(g.charCodeAt(0))){++S;const n=g.length;n>1&&h(g.charCodeAt(1))&&(++S,n>2&&(h(g.charCodeAt(2))?++S:l=!1))}if(l){for(;S<s.length&&h(s.charCodeAt(S));)S++;S>=2&&(s=`\\${s.slice(S)}`)}return e.win32.normalize(s)},relative(o,s){if(E(o,"from"),E(s,"to"),o===s)return"";const g=e.win32.resolve(o),l=e.win32.resolve(s);if(g===l||(o=g.toLowerCase(),s=l.toLowerCase(),o===s))return"";let S=0;for(;S<o.length&&o.charCodeAt(S)===I;)S++;let n=o.length;for(;n-1>S&&o.charCodeAt(n-1)===I;)n--;const t=n-S;let r=0;for(;r<s.length&&s.charCodeAt(r)===I;)r++;let u=s.length;for(;u-1>r&&s.charCodeAt(u-1)===I;)u--;const a=u-r,f=t<a?t:a;let w=-1,d=0;for(;d<f;d++){const R=o.charCodeAt(S+d);if(R!==s.charCodeAt(r+d))break;R===I&&(w=d)}if(d!==f){if(w===-1)return l}else{if(a>f){if(s.charCodeAt(r+d)===I)return l.slice(r+d+1);if(d===2)return l.slice(r+d)}t>f&&(o.charCodeAt(S+d)===I?w=d:d===2&&(w=3)),w===-1&&(w=0)}let k="";for(d=S+w+1;d<=n;++d)(d===n||o.charCodeAt(d)===I)&&(k+=k.length===0?"..":"\\..");return r+=w,k.length>0?`${k}${l.slice(r,u)}`:(l.charCodeAt(r)===I&&++r,l.slice(r,u))},toNamespacedPath(o){if(typeof o!="string")return o;if(o.length===0)return"";const s=e.win32.resolve(o);if(s.length<=2)return o;if(s.charCodeAt(0)===I){if(s.charCodeAt(1)===I){const g=s.charCodeAt(2);if(g!==A&&g!==D)return`\\\\?\\UNC\\${s.slice(2)}`}}else if(v(s.charCodeAt(0))&&s.charCodeAt(1)===L&&s.charCodeAt(2)===I)return`\\\\?\\${s}`;return o},dirname(o){E(o,"path");const s=o.length;if(s===0)return".";let g=-1,l=0;const S=o.charCodeAt(0);if(s===1)return h(S)?o:".";if(h(S)){if(g=l=1,h(o.charCodeAt(1))){let r=2,u=r;for(;r<s&&!h(o.charCodeAt(r));)r++;if(r<s&&r!==u){for(u=r;r<s&&h(o.charCodeAt(r));)r++;if(r<s&&r!==u){for(u=r;r<s&&!h(o.charCodeAt(r));)r++;if(r===s)return o;r!==u&&(g=l=r+1)}}}}else v(S)&&o.charCodeAt(1)===L&&(g=s>2&&h(o.charCodeAt(2))?3:2,l=g);let n=-1,t=!0;for(let r=s-1;r>=l;--r)if(h(o.charCodeAt(r))){if(!t){n=r;break}}else t=!1;if(n===-1){if(g===-1)return".";n=g}return o.slice(0,n)},basename(o,s){s!==void 0&&E(s,"ext"),E(o,"path");let g=0,l=-1,S=!0,n;if(o.length>=2&&v(o.charCodeAt(0))&&o.charCodeAt(1)===L&&(g=2),s!==void 0&&s.length>0&&s.length<=o.length){if(s===o)return"";let t=s.length-1,r=-1;for(n=o.length-1;n>=g;--n){const u=o.charCodeAt(n);if(h(u)){if(!S){g=n+1;break}}else r===-1&&(S=!1,r=n+1),t>=0&&(u===s.charCodeAt(t)?--t==-1&&(l=n):(t=-1,l=r))}return g===l?l=r:l===-1&&(l=o.length),o.slice(g,l)}for(n=o.length-1;n>=g;--n)if(h(o.charCodeAt(n))){if(!S){g=n+1;break}}else l===-1&&(S=!1,l=n+1);return l===-1?"":o.slice(g,l)},extname(o){E(o,"path");let s=0,g=-1,l=0,S=-1,n=!0,t=0;o.length>=2&&o.charCodeAt(1)===L&&v(o.charCodeAt(0))&&(s=l=2);for(let r=o.length-1;r>=s;--r){const u=o.charCodeAt(r);if(h(u)){if(!n){l=r+1;break}continue}S===-1&&(n=!1,S=r+1),u===D?g===-1?g=r:t!==1&&(t=1):g!==-1&&(t=-1)}return g===-1||S===-1||t===0||t===1&&g===S-1&&g===l+1?"":o.slice(g,S)},format:b.bind(null,"\\"),parse(o){E(o,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(o.length===0)return s;const g=o.length;let l=0,S=o.charCodeAt(0);if(g===1)return h(S)?(s.root=s.dir=o,s):(s.base=s.name=o,s);if(h(S)){if(l=1,h(o.charCodeAt(1))){let w=2,d=w;for(;w<g&&!h(o.charCodeAt(w));)w++;if(w<g&&w!==d){for(d=w;w<g&&h(o.charCodeAt(w));)w++;if(w<g&&w!==d){for(d=w;w<g&&!h(o.charCodeAt(w));)w++;w===g?l=w:w!==d&&(l=w+1)}}}}else if(v(S)&&o.charCodeAt(1)===L){if(g<=2)return s.root=s.dir=o,s;if(l=2,h(o.charCodeAt(2))){if(g===3)return s.root=s.dir=o,s;l=3}}l>0&&(s.root=o.slice(0,l));let n=-1,t=l,r=-1,u=!0,a=o.length-1,f=0;for(;a>=l;--a){if(S=o.charCodeAt(a),h(S)){if(!u){t=a+1;break}continue}r===-1&&(u=!1,r=a+1),S===D?n===-1?n=a:f!==1&&(f=1):n!==-1&&(f=-1)}return r!==-1&&(n===-1||f===0||f===1&&n===r-1&&n===t+1?s.base=s.name=o.slice(t,r):(s.name=o.slice(t,n),s.base=o.slice(t,r),s.ext=o.slice(n,r))),t>0&&t!==l?s.dir=o.slice(0,t-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...o){let s="",g=!1;for(let l=o.length-1;l>=-1&&!g;l--){const S=l>=0?o[l]:m.cwd();E(S,"path"),S.length!==0&&(s=`${S}/${s}`,g=S.charCodeAt(0)===_)}return s=T(s,!g,"/",p),g?`/${s}`:s.length>0?s:"."},normalize(o){if(E(o,"path"),o.length===0)return".";const s=o.charCodeAt(0)===_,g=o.charCodeAt(o.length-1)===_;return o=T(o,!s,"/",p),o.length===0?s?"/":g?"./":".":(g&&(o+="/"),s?`/${o}`:o)},isAbsolute(o){return E(o,"path"),o.length>0&&o.charCodeAt(0)===_},join(...o){if(o.length===0)return".";let s;for(let g=0;g<o.length;++g){const l=o[g];E(l,"path"),l.length>0&&(s===void 0?s=l:s+=`/${l}`)}return s===void 0?".":e.posix.normalize(s)},relative(o,s){if(E(o,"from"),E(s,"to"),o===s||(o=e.posix.resolve(o),s=e.posix.resolve(s),o===s))return"";const g=1,l=o.length,S=l-g,n=1,t=s.length-n,r=S<t?S:t;let u=-1,a=0;for(;a<r;a++){const w=o.charCodeAt(g+a);if(w!==s.charCodeAt(n+a))break;w===_&&(u=a)}if(a===r)if(t>r){if(s.charCodeAt(n+a)===_)return s.slice(n+a+1);if(a===0)return s.slice(n+a)}else S>r&&(o.charCodeAt(g+a)===_?u=a:a===0&&(u=0));let f="";for(a=g+u+1;a<=l;++a)(a===l||o.charCodeAt(a)===_)&&(f+=f.length===0?"..":"/..");return`${f}${s.slice(n+u)}`},toNamespacedPath(o){return o},dirname(o){if(E(o,"path"),o.length===0)return".";const s=o.charCodeAt(0)===_;let g=-1,l=!0;for(let S=o.length-1;S>=1;--S)if(o.charCodeAt(S)===_){if(!l){g=S;break}}else l=!1;return g===-1?s?"/":".":s&&g===1?"//":o.slice(0,g)},basename(o,s){s!==void 0&&E(s,"ext"),E(o,"path");let g=0,l=-1,S=!0,n;if(s!==void 0&&s.length>0&&s.length<=o.length){if(s===o)return"";let t=s.length-1,r=-1;for(n=o.length-1;n>=0;--n){const u=o.charCodeAt(n);if(u===_){if(!S){g=n+1;break}}else r===-1&&(S=!1,r=n+1),t>=0&&(u===s.charCodeAt(t)?--t==-1&&(l=n):(t=-1,l=r))}return g===l?l=r:l===-1&&(l=o.length),o.slice(g,l)}for(n=o.length-1;n>=0;--n)if(o.charCodeAt(n)===_){if(!S){g=n+1;break}}else l===-1&&(S=!1,l=n+1);return l===-1?"":o.slice(g,l)},extname(o){E(o,"path");let s=-1,g=0,l=-1,S=!0,n=0;for(let t=o.length-1;t>=0;--t){const r=o.charCodeAt(t);if(r===_){if(!S){g=t+1;break}continue}l===-1&&(S=!1,l=t+1),r===D?s===-1?s=t:n!==1&&(n=1):s!==-1&&(n=-1)}return s===-1||l===-1||n===0||n===1&&s===l-1&&s===g+1?"":o.slice(s,l)},format:b.bind(null,"/"),parse(o){E(o,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(o.length===0)return s;const g=o.charCodeAt(0)===_;let l;g?(s.root="/",l=1):l=0;let S=-1,n=0,t=-1,r=!0,u=o.length-1,a=0;for(;u>=l;--u){const f=o.charCodeAt(u);if(f===_){if(!r){n=u+1;break}continue}t===-1&&(r=!1,t=u+1),f===D?S===-1?S=u:a!==1&&(a=1):S!==-1&&(a=-1)}if(t!==-1){const f=n===0&&g?1:n;S===-1||a===0||a===1&&S===t-1&&S===n+1?s.base=s.name=o.slice(f,t):(s.name=o.slice(f,S),s.base=o.slice(f,t),s.ext=o.slice(S,t))}return n>0?s.dir=o.slice(0,n-1):g&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=m.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=m.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=m.platform==="win32"?e.win32.join:e.posix.join,e.resolve=m.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=m.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=m.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=m.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=m.platform==="win32"?e.win32.extname:e.posix.extname,e.format=m.platform==="win32"?e.win32.format:e.posix.format,e.parse=m.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=m.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=m.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=m.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(ve[94],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var m;(function(C){C[C.stdout=0]="stdout",C[C.stderr=1]="stderr"})(m=e.Source||(e.Source={}));var i;(function(C){C[C.Success=0]="Success",C[C.Unknown=1]="Unknown",C[C.AccessDenied=2]="AccessDenied",C[C.ProcessNotFound=3]="ProcessNotFound"})(i=e.TerminateResponseCode||(e.TerminateResponseCode={}));function y(C,...P){const D=P.reduce((L,A)=>(L[A]=!0,L),{}),_=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(C).filter(L=>!D[L]).forEach(L=>{for(let A=0;A<_.length;A++)if(L.search(_[A])!==-1){delete C[L];break}})}e.sanitizeProcessEnvironment=y}),define(ve[46],we([0,1,12]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const i=m.globals.performance&&typeof m.globals.performance.now=="function";class y{constructor(P){this._highResolution=i&&P,this._startTime=this._now(),this._stopTime=-1}static create(P=!0){return new y(P)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?m.globals.performance.now():Date.now()}}e.StopWatch=y}),define(ve[3],we([0,1,15,75,6,93,46]),function(J,e,m,i,y,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var D;(function(s){s.None=()=>y.Disposable.None;function g(H){return(M,W=null,z)=>{let U=!1,V;return V=H(K=>{if(!U)return V?V.dispose():U=!0,M.call(W,K)},null,z),U&&V.dispose(),V}}s.once=g;function l(H,M){return a((W,z=null,U)=>H(V=>W.call(z,M(V)),null,U))}s.map=l;function S(H,M){return a((W,z=null,U)=>H(V=>{M(V),W.call(z,V)},null,U))}s.forEach=S;function n(H,M){return a((W,z=null,U)=>H(V=>M(V)&&W.call(z,V),null,U))}s.filter=n;function t(H){return H}s.signal=t;function r(...H){return(M,W=null,z)=>(0,y.combinedDisposable)(...H.map(U=>U(V=>M.call(W,V),null,z)))}s.any=r;function u(H,M,W){let z=W;return l(H,U=>(z=M(z,U),z))}s.reduce=u;function a(H){let M;const W=new c({onFirstListenerAdd(){M=H(W.fire,W)},onLastListenerRemove(){M.dispose()}});return W.event}function f(H,M,W=100,z=!1,U){let V,K,G,Q=0;const Y=new c({leakWarningThreshold:U,onFirstListenerAdd(){V=H(fe=>{Q++,K=M(K,fe),z&&!G&&(Y.fire(K),K=void 0),clearTimeout(G),G=setTimeout(()=>{const me=K;K=void 0,G=void 0,(!z||Q>1)&&Y.fire(me),Q=0},W)})},onLastListenerRemove(){V.dispose()}});return Y.event}s.debounce=f;function w(H,M=(W,z)=>W===z){let W=!0,z;return n(H,U=>{const V=W||!M(U,z);return W=!1,z=U,V})}s.latch=w;function d(H,M){return[s.filter(H,M),s.filter(H,W=>!M(W))]}s.split=d;function k(H,M=!1,W=[]){let z=W.slice(),U=H(G=>{z?z.push(G):K.fire(G)});const V=()=>{z&&z.forEach(G=>K.fire(G)),z=null},K=new c({onFirstListenerAdd(){U||(U=H(G=>K.fire(G)))},onFirstListenerDidAdd(){z&&(M?setTimeout(V):V())},onLastListenerRemove(){U&&U.dispose(),U=null}});return K.event}s.buffer=k;class R{constructor(M){this.event=M}map(M){return new R(l(this.event,M))}forEach(M){return new R(S(this.event,M))}filter(M){return new R(n(this.event,M))}reduce(M,W){return new R(u(this.event,M,W))}latch(){return new R(w(this.event))}debounce(M,W=100,z=!1,U){return new R(f(this.event,M,W,z,U))}on(M,W,z){return this.event(M,W,z)}once(M,W,z){return g(this.event)(M,W,z)}}function N(H){return new R(H)}s.chain=N;function x(H,M,W=z=>z){const z=(...G)=>K.fire(W(...G)),U=()=>H.on(M,z),V=()=>H.removeListener(M,z),K=new c({onFirstListenerAdd:U,onLastListenerRemove:V});return K.event}s.fromNodeEventEmitter=x;function F(H,M,W=z=>z){const z=(...G)=>K.fire(W(...G)),U=()=>H.addEventListener(M,z),V=()=>H.removeEventListener(M,z),K=new c({onFirstListenerAdd:U,onLastListenerRemove:V});return K.event}s.fromDOMEventEmitter=F;function B(H){return new Promise(M=>g(H)(M))}s.toPromise=B;function O(H,M){return M(void 0),H(W=>M(W))}s.runAndSubscribe=O})(D=e.Event||(e.Event={}));class _{constructor(g){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${g}_${_._idPool++}`}start(g){this._stopWatch=new P.StopWatch(!0),this._listenerCount=g}stop(){if(this._stopWatch){const g=this._stopWatch.elapsed();this._elapsedOverall+=g,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${g.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}_._idPool=0;let I=-1;function L(s){const g=I;return I=s,{dispose(){I=g}}}e.setGlobalLeakWarningThreshold=L;class A{constructor(g,l=Math.random().toString(18).slice(2,5)){this.customThreshold=g,this.name=l,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(g){let l=I;if(typeof this.customThreshold=="number"&&(l=this.customThreshold),l<=0||g<l)return;this._stacks||(this._stacks=new Map);const S=new Error().stack.split(`
`).slice(3).join(`
`),n=this._stacks.get(S)||0;if(this._stacks.set(S,n+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=l*.5;let t,r=0;for(const[u,a]of this._stacks)(!t||r<a)&&(t=u,r=a);console.warn(`[${this.name}] potential listener LEAK detected, having ${g} listeners already. MOST frequent listener (${r}):`),console.warn(t)}return()=>{const t=this._stacks.get(S)||0;this._stacks.set(S,t-1)}}}class c{constructor(g){this._disposed=!1,this._options=g,this._leakageMon=I>0?new A(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new _(this._options._profName):void 0}get event(){return this._event||(this._event=(g,l,S)=>{this._listeners||(this._listeners=new C.LinkedList);const n=this._listeners.isEmpty();n&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const t=this._listeners.push(l?[g,l]:g);n&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,g,l);const r=this._leakageMon?.check(this._listeners.size),u=(0,y.toDisposable)(()=>{r&&r(),this._disposed||(t(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return S instanceof y.DisposableStore?S.add(u):Array.isArray(S)&&S.push(u),u}),this._event}fire(g){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new C.LinkedList);for(let l of this._listeners)this._deliveryQueue.push([l,g]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[l,S]=this._deliveryQueue.shift();try{typeof l=="function"?l.call(void 0,S):l[0].call(l[1],S)}catch(n){(0,m.onUnexpectedError)(n)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=c;class E extends c{async fireAsync(g,l,S){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new C.LinkedList);for(const n of this._listeners)this._asyncDeliveryQueue.push([n,g]);for(;this._asyncDeliveryQueue.size>0&&!l.isCancellationRequested;){const[n,t]=this._asyncDeliveryQueue.shift(),r=[],u={...t,token:l,waitUntil:a=>{if(Object.isFrozen(r))throw new Error("waitUntil can NOT be called asynchronous");S&&(a=S(a,typeof n=="function"?n:n[0])),r.push(a)}};try{typeof n=="function"?n.call(void 0,u):n[0].call(n[1],u)}catch(a){(0,m.onUnexpectedError)(a);continue}Object.freeze(r),await Promise.allSettled(r).then(a=>{for(const f of a)f.status==="rejected"&&(0,m.onUnexpectedError)(f.reason)})}}}}e.AsyncEmitter=E;class h extends c{constructor(g){super(g);this._isPaused=0,this._eventQueue=new C.LinkedList,this._mergeFn=g?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const g=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(g))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(g){this._listeners&&(this._isPaused!==0?this._eventQueue.push(g):super.fire(g))}}e.PauseableEmitter=h;class p extends h{constructor(g){super(g);this._delay=g.delay??100}fire(g){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(g)}}e.DebounceEmitter=p;class v extends c{constructor(g){super(g);this._queuedEvents=[],this._mergeFn=g?.merge}fire(g){this._queuedEvents.push(g),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(l=>super.fire(l)),this._queuedEvents=[]})}}e.MicrotaskEmitter=v;class T{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new c({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(g){const l={event:g,listener:null};this.events.push(l),this.hasListeners&&this.hook(l);const S=()=>{this.hasListeners&&this.unhook(l);const n=this.events.indexOf(l);this.events.splice(n,1)};return(0,y.toDisposable)((0,i.once)(S))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(g=>this.hook(g))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(g=>this.unhook(g))}hook(g){g.listener=g.event(l=>this.emitter.fire(l))}unhook(g){g.listener&&g.listener.dispose(),g.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=T;class b{constructor(){this.buffers=[]}wrapEvent(g){return(l,S,n)=>g(t=>{const r=this.buffers[this.buffers.length-1];r?r.push(()=>l.call(S,t)):l.call(S,t)},void 0,n)}bufferEvents(g){const l=[];this.buffers.push(l);const S=g();return this.buffers.pop(),l.forEach(n=>n()),S}}e.EventBufferer=b;class o{constructor(){this.listening=!1,this.inputEvent=D.None,this.inputEventListener=y.Disposable.None,this.emitter=new c({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(g){this.inputEvent=g,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=g(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=o}),define(ve[21],we([0,1,3]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const i=Object.freeze(function(D,_){const I=setTimeout(D.bind(_),0);return{dispose(){clearTimeout(I)}}});var y;(function(D){function _(I){return I===D.None||I===D.Cancelled||I instanceof C?!0:!I||typeof I!="object"?!1:typeof I.isCancellationRequested=="boolean"&&typeof I.onCancellationRequested=="function"}D.isCancellationToken=_,D.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:m.Event.None}),D.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:i})})(y=e.CancellationToken||(e.CancellationToken={}));class C{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?i:(this._emitter||(this._emitter=new m.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class P{constructor(_){this._token=void 0,this._parentListener=void 0,this._parentListener=_&&_.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new C),this._token}cancel(){this._token?this._token instanceof C&&this._token.cancel():this._token=y.Cancelled}dispose(_=!1){_&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof C&&this._token.dispose():this._token=y.None}}e.CancellationTokenSource=P}),define(ve[95],we([0,1,15,6]),function(J,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function y(o){const s=o;return s?[s.on,s.pause,s.resume,s.destroy].every(g=>typeof g=="function"):!1}e.isReadableStream=y;function C(o){const s=o;return s?y(s.stream)&&Array.isArray(s.buffer)&&typeof s.ended=="boolean":!1}e.isReadableBufferedStream=C;function P(o,s){return new D(o,s)}e.newWriteableStream=P;class D{constructor(s,g){this.reducer=s,this.options=g,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(s){if(!this.state.destroyed){if(this.state.flowing)this.emitData(s);else if(this.buffer.data.push(s),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(g=>this.pendingWritePromises.push(g))}}error(s){this.state.destroyed||(this.state.flowing?this.emitError(s):this.buffer.error.push(s))}end(s){this.state.destroyed||(typeof s!="undefined"&&this.write(s),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(s){this.listeners.data.slice(0).forEach(g=>g(s))}emitError(s){this.listeners.error.length===0?(0,m.onUnexpectedError)(s):this.listeners.error.slice(0).forEach(g=>g(s))}emitEnd(){this.listeners.end.slice(0).forEach(s=>s())}on(s,g){if(!this.state.destroyed)switch(s){case"data":this.listeners.data.push(g),this.resume();break;case"end":this.listeners.end.push(g),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(g),this.state.flowing&&this.flowErrors();break}}removeListener(s,g){if(this.state.destroyed)return;let l;switch(s){case"data":l=this.listeners.data;break;case"end":l=this.listeners.end;break;case"error":l=this.listeners.error;break}if(l){const S=l.indexOf(g);S>=0&&l.splice(S,1)}}flowData(){if(this.buffer.data.length>0){const s=this.reducer(this.buffer.data);this.emitData(s),this.buffer.data.length=0;const g=[...this.pendingWritePromises];this.pendingWritePromises.length=0,g.forEach(l=>l())}}flowErrors(){if(this.listeners.error.length>0){for(const s of this.buffer.error)this.emitError(s);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function _(o,s){const g=[];let l;for(;(l=o.read())!==null;)g.push(l);return s(g)}e.consumeReadable=_;function I(o,s,g){const l=[];let S;for(;(S=o.read())!==null&&l.length<g;)l.push(S);return S===null&&l.length>0?s(l):{read:()=>{if(l.length>0)return l.shift();if(typeof S!="undefined"){const n=S;return S=void 0,n}return o.read()}}}e.peekReadable=I;function L(o,s){return new Promise((g,l)=>{const S=[];A(o,{onData:n=>{s&&S.push(n)},onError:n=>{s?l(n):g(void 0)},onEnd:()=>{g(s?s(S):void 0)}})})}e.consumeStream=L;function A(o,s){let g=!1;return o.on("error",l=>{g||s.onError(l)}),o.on("end",()=>{g||s.onEnd()}),o.on("data",l=>{g||s.onData(l)}),(0,i.toDisposable)(()=>g=!0)}e.listenStream=A;function c(o,s){return new Promise((g,l)=>{const S=new i.DisposableStore,n=[],t=a=>{if(n.push(a),n.length>s)return S.dispose(),o.pause(),g({stream:o,buffer:n,ended:!1})},r=a=>l(a),u=()=>g({stream:o,buffer:n,ended:!0});S.add((0,i.toDisposable)(()=>o.removeListener("error",r))),o.on("error",r),S.add((0,i.toDisposable)(()=>o.removeListener("end",u))),o.on("end",u),S.add((0,i.toDisposable)(()=>o.removeListener("data",t))),o.on("data",t)})}e.peekStream=c;function E(o,s){const g=P(s);return g.end(o),g}e.toStream=E;function h(){const o=P(()=>{throw new Error("not supported")});return o.end(),o}e.emptyStream=h;function p(o){let s=!1;return{read:()=>s?null:(s=!0,o)}}e.toReadable=p;function v(o,s,g){const l=P(g);return A(o,{onData:S=>l.write(s.data(S)),onError:S=>l.error(s.error?s.error(S):S),onEnd:()=>l.end()}),l}e.transform=v;function T(o,s,g){let l=!1;return{read:()=>{const S=s.read();return l?S:(l=!0,S!==null?g([o,S]):o)}}}e.prefixedReadable=T;function b(o,s,g){let l=!1;const S=P(g);return A(s,{onData:n=>l?S.write(n):(l=!0,S.write(g([o,n]))),onError:n=>S.error(n),onEnd:()=>{l||(l=!0,S.write(o)),S.end()}}),S}e.prefixedStream=b}),define(ve[22],we([0,1,95]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const i=typeof Buffer!="undefined";let y,C;class P{constructor(t){this.buffer=t,this.byteLength=this.buffer.byteLength}static alloc(t){return i?new P(Buffer.allocUnsafe(t)):new P(new Uint8Array(t))}static wrap(t){return i&&!Buffer.isBuffer(t)&&(t=Buffer.from(t.buffer,t.byteOffset,t.byteLength)),new P(t)}static fromString(t,r){return!(r?.dontUseNodeBuffer||!1)&&i?new P(Buffer.from(t)):(y||(y=new TextEncoder),new P(y.encode(t)))}static fromByteArray(t){const r=P.alloc(t.length);for(let u=0,a=t.length;u<a;u++)r.buffer[u]=t[u];return r}static concat(t,r){if(typeof r=="undefined"){r=0;for(let f=0,w=t.length;f<w;f++)r+=t[f].byteLength}const u=P.alloc(r);let a=0;for(let f=0,w=t.length;f<w;f++){const d=t[f];u.set(d,a),a+=d.byteLength}return u}clone(){const t=P.alloc(this.byteLength);return t.set(this),t}toString(){return i?this.buffer.toString():(C||(C=new TextDecoder),C.decode(this.buffer))}slice(t,r){return new P(this.buffer.subarray(t,r))}set(t,r){if(t instanceof P)this.buffer.set(t.buffer,r);else if(t instanceof Uint8Array)this.buffer.set(t,r);else if(t instanceof ArrayBuffer)this.buffer.set(new Uint8Array(t),r);else if(ArrayBuffer.isView(t))this.buffer.set(new Uint8Array(t.buffer,t.byteOffset,t.byteLength),r);else throw new Error("Unkown argument 'array'")}readUInt32BE(t){return I(this.buffer,t)}writeUInt32BE(t,r){L(this.buffer,t,r)}readUInt32LE(t){return A(this.buffer,t)}writeUInt32LE(t,r){c(this.buffer,t,r)}readUInt8(t){return E(this.buffer,t)}writeUInt8(t,r){h(this.buffer,t,r)}}e.VSBuffer=P;function D(n,t){return n[t+0]<<0>>>0|n[t+1]<<8>>>0}e.readUInt16LE=D;function _(n,t,r){n[r+0]=t&255,t=t>>>8,n[r+1]=t&255}e.writeUInt16LE=_;function I(n,t){return n[t]*2**24+n[t+1]*2**16+n[t+2]*2**8+n[t+3]}e.readUInt32BE=I;function L(n,t,r){n[r+3]=t,t=t>>>8,n[r+2]=t,t=t>>>8,n[r+1]=t,t=t>>>8,n[r]=t}e.writeUInt32BE=L;function A(n,t){return n[t+0]<<0>>>0|n[t+1]<<8>>>0|n[t+2]<<16>>>0|n[t+3]<<24>>>0}e.readUInt32LE=A;function c(n,t,r){n[r+0]=t&255,t=t>>>8,n[r+1]=t&255,t=t>>>8,n[r+2]=t&255,t=t>>>8,n[r+3]=t&255}e.writeUInt32LE=c;function E(n,t){return n[t]}e.readUInt8=E;function h(n,t,r){n[r]=t}e.writeUInt8=h;function p(n){return m.consumeReadable(n,t=>P.concat(t))}e.readableToBuffer=p;function v(n){return m.toReadable(n)}e.bufferToReadable=v;function T(n){return m.consumeStream(n,t=>P.concat(t))}e.streamToBuffer=T;async function b(n){return n.ended?P.concat(n.buffer):P.concat([...n.buffer,await T(n.stream)])}e.bufferedStreamToBuffer=b;function o(n){return m.toStream(n,t=>P.concat(t))}e.bufferToStream=o;function s(n){return m.transform(n,{data:t=>typeof t=="string"?P.fromString(t):P.wrap(t)},t=>P.concat(t))}e.streamToBufferReadableStream=s;function g(n){return m.newWriteableStream(t=>P.concat(t),n)}e.newWriteableBufferStream=g;function l(n,t){return m.prefixedReadable(n,t,r=>P.concat(r))}e.prefixedBufferReadable=l;function S(n,t){return m.prefixedStream(n,t,r=>P.concat(r))}e.prefixedBufferStream=S}),define(ve[8],we([0,1,12]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function i(ie){return!ie||typeof ie!="string"?!0:ie.trim().length===0}e.isFalsyOrWhitespace=i;const y=/{(\d+)}/g;function C(ie,...Se){return Se.length===0?ie:ie.replace(y,function(Fe,Ue){const Xe=parseInt(Ue,10);return isNaN(Xe)||Xe<0||Xe>=Se.length?Fe:Se[Xe]})}e.format=C;const P=/{([^}]+)}/g;function D(ie,Se){return ie.replace(P,(Fe,Ue)=>Se[Ue]??Fe)}e.format2=D;function _(ie){return ie.replace(/[<>&]/g,function(Se){switch(Se){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Se}})}e.escape=_;function I(ie){return ie.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=I;function L(ie,Se){let Fe=0;const Ue=Se.charCodeAt(0);for(let Xe=ie.length-1;Xe>=0;Xe--)ie.charCodeAt(Xe)===Ue&&Fe++;return Fe}e.count=L;function A(ie,Se,Fe="\u2026"){return ie.length<=Se?ie:`${ie.substr(0,Se)}${Fe}`}e.truncate=A;function c(ie,Se=" "){const Fe=E(ie,Se);return h(Fe,Se)}e.trim=c;function E(ie,Se){if(!ie||!Se)return ie;const Fe=Se.length;if(Fe===0||ie.length===0)return ie;let Ue=0;for(;ie.indexOf(Se,Ue)===Ue;)Ue=Ue+Fe;return ie.substring(Ue)}e.ltrim=E;function h(ie,Se){if(!ie||!Se)return ie;const Fe=Se.length,Ue=ie.length;if(Fe===0||Ue===0)return ie;let Xe=Ue,Ae=-1;for(;Ae=ie.lastIndexOf(Se,Xe-1),!(Ae===-1||Ae+Fe!==Xe);){if(Ae===0)return"";Xe=Ae}return ie.substring(0,Xe)}e.rtrim=h;function p(ie){return ie.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=p;function v(ie){return ie.replace(/\*/g,"")}e.stripWildcards=v;function T(ie,Se,Fe={}){if(!ie)throw new Error("Cannot create regex from empty string");Se||(ie=I(ie)),Fe.wholeWord&&(/\B/.test(ie.charAt(0))||(ie="\\b"+ie),/\B/.test(ie.charAt(ie.length-1))||(ie=ie+"\\b"));let Ue="";return Fe.global&&(Ue+="g"),Fe.matchCase||(Ue+="i"),Fe.multiline&&(Ue+="m"),Fe.unicode&&(Ue+="u"),new RegExp(ie,Ue)}e.createRegExp=T;function b(ie){return ie.source==="^"||ie.source==="^$"||ie.source==="$"||ie.source==="^\\s*$"?!1:!!(ie.exec("")&&ie.lastIndex===0)}e.regExpLeadsToEndlessLoop=b;function o(ie){return!!ie.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=o;function s(ie){return(ie.global?"g":"")+(ie.ignoreCase?"i":"")+(ie.multiline?"m":"")+(ie.unicode?"u":"")}e.regExpFlags=s;function g(ie){return ie.split(/\r\n|\r|\n/)}e.splitLines=g;function l(ie){for(let Se=0,Fe=ie.length;Se<Fe;Se++){const Ue=ie.charCodeAt(Se);if(Ue!==32&&Ue!==9)return Se}return-1}e.firstNonWhitespaceIndex=l;function S(ie,Se=0,Fe=ie.length){for(let Ue=Se;Ue<Fe;Ue++){const Xe=ie.charCodeAt(Ue);if(Xe!==32&&Xe!==9)return ie.substring(Se,Ue)}return ie.substring(Se,Fe)}e.getLeadingWhitespace=S;function n(ie,Se=ie.length-1){for(let Fe=Se;Fe>=0;Fe--){const Ue=ie.charCodeAt(Fe);if(Ue!==32&&Ue!==9)return Fe}return-1}e.lastNonWhitespaceIndex=n;function t(ie,Se){return ie<Se?-1:ie>Se?1:0}e.compare=t;function r(ie,Se,Fe=0,Ue=ie.length,Xe=0,Ae=Se.length){for(;Fe<Ue&&Xe<Ae;Fe++,Xe++){let ce=ie.charCodeAt(Fe),de=Se.charCodeAt(Xe);if(ce<de)return-1;if(ce>de)return 1}const Pe=Ue-Fe,ye=Ae-Xe;return Pe<ye?-1:Pe>ye?1:0}e.compareSubstring=r;function u(ie,Se){return a(ie,Se,0,ie.length,0,Se.length)}e.compareIgnoreCase=u;function a(ie,Se,Fe=0,Ue=ie.length,Xe=0,Ae=Se.length){for(;Fe<Ue&&Xe<Ae;Fe++,Xe++){let ce=ie.charCodeAt(Fe),de=Se.charCodeAt(Xe);if(ce===de)continue;if(ce>=128||de>=128)return r(ie.toLowerCase(),Se.toLowerCase(),Fe,Ue,Xe,Ae);f(ce)&&(ce-=32),f(de)&&(de-=32);const be=ce-de;if(be!==0)return be}const Pe=Ue-Fe,ye=Ae-Xe;return Pe<ye?-1:Pe>ye?1:0}e.compareSubstringIgnoreCase=a;function f(ie){return ie>=97&&ie<=122}e.isLowerAsciiLetter=f;function w(ie){return ie>=65&&ie<=90}e.isUpperAsciiLetter=w;function d(ie,Se){return ie.length===Se.length&&a(ie,Se)===0}e.equalsIgnoreCase=d;function k(ie,Se){const Fe=Se.length;return Se.length>ie.length?!1:a(ie,Se,0,Fe)===0}e.startsWithIgnoreCase=k;function R(ie,Se){let Fe,Ue=Math.min(ie.length,Se.length);for(Fe=0;Fe<Ue;Fe++)if(ie.charCodeAt(Fe)!==Se.charCodeAt(Fe))return Fe;return Ue}e.commonPrefixLength=R;function N(ie,Se){let Fe,Ue=Math.min(ie.length,Se.length);const Xe=ie.length-1,Ae=Se.length-1;for(Fe=0;Fe<Ue;Fe++)if(ie.charCodeAt(Xe-Fe)!==Se.charCodeAt(Ae-Fe))return Fe;return Ue}e.commonSuffixLength=N;function x(ie){return 55296<=ie&&ie<=56319}e.isHighSurrogate=x;function F(ie){return 56320<=ie&&ie<=57343}e.isLowSurrogate=F;function B(ie,Se){return(ie-55296<<10)+(Se-56320)+65536}e.computeCodePoint=B;function O(ie,Se,Fe){const Ue=ie.charCodeAt(Fe);if(x(Ue)&&Fe+1<Se){const Xe=ie.charCodeAt(Fe+1);if(F(Xe))return B(Ue,Xe)}return Ue}e.getNextCodePoint=O;function H(ie,Se){const Fe=ie.charCodeAt(Se-1);if(F(Fe)&&Se>1){const Ue=ie.charCodeAt(Se-2);if(x(Ue))return B(Ue,Fe)}return Fe}function M(ie,Se){const Fe=it.getInstance(),Ue=Se,Xe=ie.length,Ae=O(ie,Xe,Se);Se+=Ae>=65536?2:1;let Pe=Fe.getGraphemeBreakType(Ae);for(;Se<Xe;){const ye=O(ie,Xe,Se),ce=Fe.getGraphemeBreakType(ye);if(ot(Pe,ce))break;Se+=ye>=65536?2:1,Pe=ce}return Se-Ue}e.nextCharLength=M;function W(ie,Se){const Fe=it.getInstance(),Ue=Se,Xe=H(ie,Se);Se-=Xe>=65536?2:1;let Ae=Fe.getGraphemeBreakType(Xe);for(;Se>0;){const Pe=H(ie,Se),ye=Fe.getGraphemeBreakType(Pe);if(ot(ye,Ae))break;Se-=Pe>=65536?2:1,Ae=ye}return Ue-Se}e.prevCharLength=W;function z(ie,Se){const Fe=it.getInstance(),Ue=ie.length,Xe=Se,Ae=O(ie,Ue,Se),Pe=Fe.getGraphemeBreakType(Ae);Se+=Ae>=65536?2:1;let ye=Pe;for(;Se<Ue;){const de=O(ie,Ue,Se),be=Fe.getGraphemeBreakType(de);if(ot(ye,be))break;Se+=de>=65536?2:1,ye=be}const ce=Se;for(Se=Xe,ye=Pe;Se>0;){const de=H(ie,Se),be=Fe.getGraphemeBreakType(de);if(ot(be,ye))break;Se-=de>=65536?2:1,ye=be}return[Se,ce]}function U(ie,Se){return Se>0&&F(ie.charCodeAt(Se))?z(ie,Se-1):z(ie,Se)}e.getCharContainingOffset=U;const V=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function K(ie){return V.test(ie)}e.containsRTL=K;const G=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFF0]|\uD83E[\uDD00-\uDDFF\uDE70-\uDEF6])/;function Q(ie){return G.test(ie)}e.containsEmoji=Q;const Y=/^[\t\n\r\x20-\x7E]*$/;function fe(ie){return Y.test(ie)}e.isBasicASCII=fe,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function me(ie){return e.UNUSUAL_LINE_TERMINATORS.test(ie)}e.containsUnusualLineTerminators=me;function _e(ie){for(let Se=0,Fe=ie.length;Se<Fe;Se++)if(Ie(ie.charCodeAt(Se)))return!0;return!1}e.containsFullWidthCharacter=_e;function Ie(ie){return ie>=11904&&ie<=55215||ie>=63744&&ie<=64255||ie>=65281&&ie<=65374}e.isFullWidthCharacter=Ie;function Oe(ie){return ie>=127462&&ie<=127487||ie===8986||ie===8987||ie===9200||ie===9203||ie>=9728&&ie<=10175||ie===11088||ie===11093||ie>=127744&&ie<=128591||ie>=128640&&ie<=128764||ie>=128992&&ie<=129008||ie>=129280&&ie<=129535||ie>=129648&&ie<=129782}e.isEmojiImprecise=Oe;function We(ie,Se){if(ie.length<Se)return ie;const Fe=/\b/g;let Ue=0;for(;Fe.test(ie)&&!(ie.length-Fe.lastIndex<Se);)Ue=Fe.lastIndex,Fe.lastIndex+=1;return ie.substring(Ue).replace(/^\s/,"")}e.lcut=We;const j=/\x1B\x5B[12]?K/g,Z=/\x1b\[\d+m/g,re=/\x1b\[0?m/g;function ue(ie){return ie&&(ie=ie.replace(j,""),ie=ie.replace(Z,""),ie=ie.replace(re,"")),ie}e.removeAnsiEscapeCodes=ue,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function te(ie){return!!(ie&&ie.length>0&&ie.charCodeAt(0)===65279)}e.startsWithUTF8BOM=te;function oe(ie){return te(ie)?ie.substr(1):ie}e.stripUTF8BOM=oe;function Ee(ie,Se){if(!ie||!Se||ie.length<Se.length)return!1;const Fe=Se.length,Ue=ie.toLowerCase();let Xe=0,Ae=-1;for(;Xe<Fe;){const Pe=Ue.indexOf(Se[Xe],Ae+1);if(Pe<0)return!1;Ae=Pe,Xe++}return!0}e.fuzzyContains=Ee;function Ne(ie,Se=!1){return ie?(Se&&(ie=ie.replace(/\\./g,"")),ie.toLowerCase()!==ie):!1}e.containsUppercaseCharacter=Ne;function Ve(ie){return ie.charAt(0).toUpperCase()+ie.slice(1)}e.uppercaseFirstLetter=Ve;function Ge(ie,Se=1){if(Se===0)return"";let Fe=-1;do Fe=ie.indexOf(`
`,Fe+1),Se--;while(Se>0&&Fe>=0);return Fe===-1?ie:(ie[Fe-1]==="\r"&&Fe--,ie.substr(0,Fe))}e.getNLines=Ge;function Je(ie){const Se=90-65+1;return ie=ie%(2*Se),ie<Se?String.fromCharCode(97+ie):String.fromCharCode(65+ie-Se)}e.singleLetterHash=Je;function tt(ie){return it.getInstance().getGraphemeBreakType(ie)}e.getGraphemeBreakType=tt;function ot(ie,Se){return ie===0?Se!==5&&Se!==7:ie===2&&Se===3?!1:ie===4||ie===2||ie===3||Se===4||Se===2||Se===3?!0:!(ie===8&&(Se===8||Se===9||Se===11||Se===12)||(ie===11||ie===9)&&(Se===9||Se===10)||(ie===12||ie===10)&&Se===10||Se===5||Se===13||Se===7||ie===1||ie===13&&Se===14||ie===6&&Se===6)}e.breakBetweenGraphemeBreakType=ot;var et;(function(ie){ie[ie.Other=0]="Other",ie[ie.Prepend=1]="Prepend",ie[ie.CR=2]="CR",ie[ie.LF=3]="LF",ie[ie.Control=4]="Control",ie[ie.Extend=5]="Extend",ie[ie.Regional_Indicator=6]="Regional_Indicator",ie[ie.SpacingMark=7]="SpacingMark",ie[ie.L=8]="L",ie[ie.V=9]="V",ie[ie.T=10]="T",ie[ie.LV=11]="LV",ie[ie.LVT=12]="LVT",ie[ie.ZWJ=13]="ZWJ",ie[ie.Extended_Pictographic=14]="Extended_Pictographic"})(et=e.GraphemeBreakType||(e.GraphemeBreakType={}));class it{constructor(){this._data=lt()}static getInstance(){return it._INSTANCE||(it._INSTANCE=new it),it._INSTANCE}getGraphemeBreakType(Se){if(Se<32)return Se===10?3:Se===13?2:4;if(Se<127)return 0;const Fe=this._data,Ue=Fe.length/3;let Xe=1;for(;Xe<=Ue;)if(Se<Fe[3*Xe])Xe=2*Xe;else if(Se>Fe[3*Xe+1])Xe=2*Xe+1;else return Fe[3*Xe+2];return 0}}it._INSTANCE=null;function lt(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function pt(ie,Se){if(ie===0)return 0;const Fe=Pt(ie,Se);if(Fe!==void 0)return Fe;const Ue=H(Se,ie);return ie-=xe(Ue),ie}e.getLeftDeleteOffset=pt;function Pt(ie,Se){let Fe=H(Se,ie);for(ie-=xe(Fe);Rt(Fe)||Fe===65039||Fe===8419;){if(ie===0)return;Fe=H(Se,ie),ie-=xe(Fe)}if(!!Oe(Fe)){if(ie>=0){const Ue=H(Se,ie);Ue===8205&&(ie-=xe(Ue))}return ie}}function xe(ie){return ie>=65536?2:1}function Rt(ie){return 127995<=ie&&ie<=127999}var ee;(function(ie){ie[ie.zwj=8205]="zwj",ie[ie.emojiVariantSelector=65039]="emojiVariantSelector",ie[ie.enclosingKeyCap=8419]="enclosingKeyCap"})(ee||(ee={})),e.noBreakWhitespace="\xA0";class ne{static getData(){return JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,40,10088,40,10098,40,12308,40,64830,40,65341,41,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,124,8739,124,9213,124,65512,124,1633,124,1777,124,66336,124,125127,124,120783,124,120793,124,120803,124,120813,124,120823,124,130033,124,65321,124,8544,124,8464,124,8465,124,119816,124,119868,124,119920,124,120024,124,120128,124,120180,124,120232,124,120284,124,120336,124,120388,124,120440,124,406,124,65356,124,8572,124,8467,124,119845,124,119897,124,119949,124,120001,124,120053,124,120105,124,120157,124,120209,124,120261,124,120313,124,120365,124,120417,124,120469,124,448,124,120496,124,120554,124,120612,124,120670,124,120728,124,11410,124,1030,124,1216,124,1493,124,1503,124,1575,124,126464,124,126592,124,65166,124,65165,124,1994,124,11599,124,5825,124,42226,124,93992,124,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90],"_default":[160,32,8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"cs":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89],"de":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89],"es":[8211,45,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"fr":[65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"it":[160,32,8211,45,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"ko":[8211,45,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"pl":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"pt-BR":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"qps-ploc":[160,32,8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"ru":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,124,1009,112,215,120],"tr":[160,32,8211,45,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"zh-hans":[65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"zh-hant":[8211,45,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89]}')}static getConfusablesForCurrentLocale(){if(!ne.map){let Ue=function(Pe){const ye=new Map;for(let ce=0;ce<Pe.length;ce+=2)ye.set(Pe[ce],Pe[ce+1]);return ye};const Se=ne.getData();let Fe=m.locale;(!Fe||!(Fe in Se))&&(Fe=m.language),(!Fe||!(Fe in Se))&&(Fe="_default");const Xe=Ue(Se._common),Ae=Ue(Se[Fe]);for(const[Pe,ye]of Ae)Xe.set(Pe,ye);ne.map=Xe}return ne.map}static isAmbiguous(Se){return ne.getConfusablesForCurrentLocale().has(Se)}static getPrimaryConfusable(Se){return ne.getConfusablesForCurrentLocale().get(Se)}static getPrimaryConfusableCodePoints(){return new Set(ne.getConfusablesForCurrentLocale().keys())}}e.AmbiguousCharacters=ne;class pe{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(pe.getRawData())),this._data}static isInvisibleCharacter(Se){return pe.getData().has(Se)}static get codePoints(){return pe.getData()}}e.InvisibleCharacters=pe,pe._data=void 0}),define(ve[47],we([0,1,8]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function i(T){return y(T,0)}e.hash=i;function y(T,b){switch(typeof T){case"object":return T===null?C(349,b):Array.isArray(T)?_(T,b):I(T,b);case"string":return D(T,b);case"boolean":return P(T,b);case"number":return C(T,b);case"undefined":return C(937,b);default:return C(617,b)}}e.doHash=y;function C(T,b){return(b<<5)-b+T|0}e.numberHash=C;function P(T,b){return C(T?433:863,b)}function D(T,b){b=C(149417,b);for(let o=0,s=T.length;o<s;o++)b=C(T.charCodeAt(o),b);return b}e.stringHash=D;function _(T,b){return b=C(104579,b),T.reduce((o,s)=>y(s,o),b)}function I(T,b){return b=C(181387,b),Object.keys(T).sort().reduce((o,s)=>(o=D(s,o),y(T[s],o)),b)}class L{constructor(){this._value=0}get value(){return this._value}hash(b){return this._value=y(b,this._value),this._value}}e.Hasher=L;var A;(function(T){T[T.BLOCK_SIZE=64]="BLOCK_SIZE",T[T.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(A||(A={}));function c(T,b,o=32){const s=o-b,g=~((1<<s)-1);return(T<<b|(g&T)>>>s)>>>0}function E(T,b=0,o=T.byteLength,s=0){for(let g=0;g<o;g++)T[b+g]=s}function h(T,b,o="0"){for(;T.length<b;)T=o+T;return T}function p(T,b=32){return T instanceof ArrayBuffer?Array.from(new Uint8Array(T)).map(o=>o.toString(16).padStart(2,"0")).join(""):h((T>>>0).toString(16),b/4)}e.toHexString=p;class v{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(b){const o=b.length;if(o===0)return;const s=this._buff;let g=this._buffLen,l=this._leftoverHighSurrogate,S,n;for(l!==0?(S=l,n=-1,l=0):(S=b.charCodeAt(0),n=0);;){let t=S;if(m.isHighSurrogate(S))if(n+1<o){const r=b.charCodeAt(n+1);m.isLowSurrogate(r)?(n++,t=m.computeCodePoint(S,r)):t=65533}else{l=S;break}else m.isLowSurrogate(S)&&(t=65533);if(g=this._push(s,g,t),n++,n<o)S=b.charCodeAt(n);else break}this._buffLen=g,this._leftoverHighSurrogate=l}_push(b,o,s){return s<128?b[o++]=s:s<2048?(b[o++]=192|(s&1984)>>>6,b[o++]=128|(s&63)>>>0):s<65536?(b[o++]=224|(s&61440)>>>12,b[o++]=128|(s&4032)>>>6,b[o++]=128|(s&63)>>>0):(b[o++]=240|(s&1835008)>>>18,b[o++]=128|(s&258048)>>>12,b[o++]=128|(s&4032)>>>6,b[o++]=128|(s&63)>>>0),o>=64&&(this._step(),o-=64,this._totalLen+=64,b[0]=b[64+0],b[1]=b[64+1],b[2]=b[64+2]),o}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),p(this._h0)+p(this._h1)+p(this._h2)+p(this._h3)+p(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,E(this._buff,this._buffLen),this._buffLen>56&&(this._step(),E(this._buff));const b=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(b/4294967296),!1),this._buffDV.setUint32(60,b%4294967296,!1),this._step()}_step(){const b=v._bigBlock32,o=this._buffDV;for(let a=0;a<64;a+=4)b.setUint32(a,o.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)b.setUint32(a,c(b.getUint32(a-12,!1)^b.getUint32(a-32,!1)^b.getUint32(a-56,!1)^b.getUint32(a-64,!1),1),!1);let s=this._h0,g=this._h1,l=this._h2,S=this._h3,n=this._h4,t,r,u;for(let a=0;a<80;a++)a<20?(t=g&l|~g&S,r=1518500249):a<40?(t=g^l^S,r=1859775393):a<60?(t=g&l|g&S|l&S,r=2400959708):(t=g^l^S,r=3395469782),u=c(s,5)+t+n+r+b.getUint32(a*4,!1)&4294967295,n=S,S=l,l=c(g,30),g=s,s=u;this._h0=this._h0+s&4294967295,this._h1=this._h1+g&4294967295,this._h2=this._h2+l&4294967295,this._h3=this._h3+S&4294967295,this._h4=this._h4+n&4294967295}}e.StringSHA1=v,v._bigBlock32=new DataView(new ArrayBuffer(320))});var nt=this&&this.__classPrivateFieldSet||function(J,e,m,i,y){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!y:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?y.call(J,m):y?y.value=m:e.set(J,m),m},Be=this&&this.__classPrivateFieldGet||function(J,e,m,i){if(m==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!i:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?i:m==="a"?i.call(J):i?i.value:e.get(J)};define(ve[24],we([0,1,16,8]),function(J,e,m,i){"use strict";var y,C,P;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function D(n,t,r){let u=n.get(t);return u===void 0&&(u=r,n.set(t,u)),u}e.getOrSet=D;function _(n){const t=[];return n.forEach((r,u)=>{t.push(`${u} => ${r}`)}),`Map(${n.size}) {${t.join(", ")}}`}e.mapToString=_;function I(n){const t=[];return n.forEach(r=>{t.push(r)}),`Set(${n.size}) {${t.join(", ")}}`}e.setToString=I;class L{constructor(){this._value="",this._pos=0}reset(t){return this._value=t,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(t){const r=t.charCodeAt(0),u=this._value.charCodeAt(this._pos);return r-u}value(){return this._value[this._pos]}}e.StringIterator=L;class A{constructor(t=!0){this._caseSensitive=t}reset(t){return this._value=t,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let t=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(t)this._from++;else break;else t=!1;return this}cmp(t){return this._caseSensitive?(0,i.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,i.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=A;class c{constructor(t=!0,r=!0){this._splitOnBackslash=t,this._caseSensitive=r}reset(t){this._from=0,this._to=0,this._value=t,this._valueLen=t.length;for(let r=t.length-1;r>=0;r--,this._valueLen--){const u=this._value.charCodeAt(r);if(!(u===47||this._splitOnBackslash&&u===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let t=!0;for(;this._to<this._valueLen;this._to++){const r=this._value.charCodeAt(this._to);if(r===47||this._splitOnBackslash&&r===92)if(t)this._from++;else break;else t=!1}return this}cmp(t){return this._caseSensitive?(0,i.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,i.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=c;var E;(function(n){n[n.Scheme=1]="Scheme",n[n.Authority=2]="Authority",n[n.Path=3]="Path",n[n.Query=4]="Query",n[n.Fragment=5]="Fragment"})(E||(E={}));class h{constructor(t){this._ignorePathCasing=t,this._states=[],this._stateIdx=0}reset(t){return this._value=t,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new c(!1,!this._ignorePathCasing(t)),this._pathIterator.reset(t.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(t){if(this._states[this._stateIdx]===1)return(0,i.compareIgnoreCase)(t,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,i.compareIgnoreCase)(t,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(t);if(this._states[this._stateIdx]===4)return(0,i.compare)(t,this._value.query);if(this._states[this._stateIdx]===5)return(0,i.compare)(t,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=h;class p{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const t=this.right;return this.right=t.left,t.left=this,this.updateHeight(),t.updateHeight(),t}rotateRight(){const t=this.left;return this.left=t.right,t.right=this,this.updateHeight(),t.updateHeight(),t}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var v;(function(n){n[n.Left=-1]="Left",n[n.Mid=0]="Mid",n[n.Right=1]="Right"})(v||(v={}));class T{constructor(t){this._iter=t}static forUris(t=()=>!1){return new T(new h(t))}static forPaths(){return new T(new c)}static forStrings(){return new T(new L)}static forConfigKeys(){return new T(new A)}clear(){this._root=void 0}fill(t,r){if(r){const u=r.slice(0);(0,m.shuffle)(u);for(let a of u)this.set(a,t)}else{const u=t.slice(0);(0,m.shuffle)(u);for(let a of u)this.set(a[0],a[1])}}set(t,r){const u=this._iter.reset(t);let a;this._root||(this._root=new p,this._root.segment=u.value());const f=[];for(a=this._root;;){const d=u.cmp(a.segment);if(d>0)a.left||(a.left=new p,a.left.segment=u.value()),f.push([-1,a]),a=a.left;else if(d<0)a.right||(a.right=new p,a.right.segment=u.value()),f.push([1,a]),a=a.right;else if(u.hasNext())u.next(),a.mid||(a.mid=new p,a.mid.segment=u.value()),f.push([0,a]),a=a.mid;else break}const w=a.value;a.value=r,a.key=t;for(let d=f.length-1;d>=0;d--){const k=f[d][1];k.updateHeight();const R=k.balanceFactor();if(R<-1||R>1){const N=f[d][0],x=f[d+1][0];if(N===1&&x===1)f[d][1]=k.rotateLeft();else if(N===-1&&x===-1)f[d][1]=k.rotateRight();else if(N===1&&x===-1)k.right=f[d+1][1]=f[d+1][1].rotateRight(),f[d][1]=k.rotateLeft();else if(N===-1&&x===1)k.left=f[d+1][1]=f[d+1][1].rotateLeft(),f[d][1]=k.rotateRight();else throw new Error;if(d>0)switch(f[d-1][0]){case-1:f[d-1][1].left=f[d][1];break;case 1:f[d-1][1].right=f[d][1];break;case 0:f[d-1][1].mid=f[d][1];break}else this._root=f[0][1]}}return w}get(t){return this._getNode(t)?.value}_getNode(t){const r=this._iter.reset(t);let u=this._root;for(;u;){const a=r.cmp(u.segment);if(a>0)u=u.left;else if(a<0)u=u.right;else if(r.hasNext())r.next(),u=u.mid;else break}return u}has(t){const r=this._getNode(t);return!(r?.value===void 0&&r?.mid===void 0)}delete(t){return this._delete(t,!1)}deleteSuperstr(t){return this._delete(t,!0)}_delete(t,r){const u=this._iter.reset(t),a=[];let f=this._root;for(;f;){const w=u.cmp(f.segment);if(w>0)a.push([-1,f]),f=f.left;else if(w<0)a.push([1,f]),f=f.right;else if(u.hasNext())u.next(),a.push([0,f]),f=f.mid;else break}if(!!f){if(r?(f.left=void 0,f.mid=void 0,f.right=void 0,f.height=1):(f.key=void 0,f.value=void 0),!f.mid&&!f.value)if(f.left&&f.right){const w=this._min(f.right),{key:d,value:k,segment:R}=w;this._delete(w.key,!1),f.key=d,f.value=k,f.segment=R}else{const w=f.left??f.right;if(a.length>0){const[d,k]=a[a.length-1];switch(d){case-1:k.left=w;break;case 0:k.mid=w;break;case 1:k.right=w;break}}else this._root=w}for(let w=a.length-1;w>=0;w--){const d=a[w][1];d.updateHeight();const k=d.balanceFactor();if(k>1?(d.right.balanceFactor()>=0||(d.right=d.right.rotateRight()),a[w][1]=d.rotateLeft()):k<-1&&(d.left.balanceFactor()<=0||(d.left=d.left.rotateLeft()),a[w][1]=d.rotateRight()),w>0)switch(a[w-1][0]){case-1:a[w-1][1].left=a[w][1];break;case 1:a[w-1][1].right=a[w][1];break;case 0:a[w-1][1].mid=a[w][1];break}else this._root=a[0][1]}}}_min(t){for(;t.left;)t=t.left;return t}findSubstr(t){const r=this._iter.reset(t);let u=this._root,a;for(;u;){const f=r.cmp(u.segment);if(f>0)u=u.left;else if(f<0)u=u.right;else if(r.hasNext())r.next(),a=u.value||a,u=u.mid;else break}return u&&u.value||a}findSuperstr(t){const r=this._iter.reset(t);let u=this._root;for(;u;){const a=r.cmp(u.segment);if(a>0)u=u.left;else if(a<0)u=u.right;else if(r.hasNext())r.next(),u=u.mid;else return u.mid?this._entries(u.mid):void 0}}forEach(t){for(const[r,u]of this)t(u,r)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(t){!t||(t.left&&(yield*this._entries(t.left)),t.value&&(yield[t.key,t.value]),t.mid&&(yield*this._entries(t.mid)),t.right&&(yield*this._entries(t.right)))}_isBalanced(){const t=r=>{if(!r)return!0;const u=r.balanceFactor();return u<-1||u>1?!1:t(r.left)&&t(r.right)};return t(this._root)}}e.TernarySearchTree=T;class b{constructor(t,r){this.uri=t,this.value=r}}class o{constructor(t,r){this[y]="ResourceMap",t instanceof o?(this.map=new Map(t.map),this.toKey=r??o.defaultToKey):(this.map=new Map,this.toKey=t??o.defaultToKey)}set(t,r){return this.map.set(this.toKey(t),new b(t,r)),this}get(t){return this.map.get(this.toKey(t))?.value}has(t){return this.map.has(this.toKey(t))}get size(){return this.map.size}clear(){this.map.clear()}delete(t){return this.map.delete(this.toKey(t))}forEach(t,r){typeof r!="undefined"&&(t=t.bind(r));for(let[u,a]of this.map)t(a.value,a.uri,this)}*values(){for(let t of this.map.values())yield t.value}*keys(){for(let t of this.map.values())yield t.uri}*entries(){for(let t of this.map.values())yield[t.uri,t.value]}*[(y=Symbol.toStringTag,Symbol.iterator)](){for(let[,t]of this.map)yield[t.uri,t.value]}}e.ResourceMap=o,o.defaultToKey=n=>n.toString();var s;(function(n){n[n.None=0]="None",n[n.AsOld=1]="AsOld",n[n.AsNew=2]="AsNew"})(s=e.Touch||(e.Touch={}));class g{constructor(){this[C]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(t){return this._map.has(t)}get(t,r=0){const u=this._map.get(t);if(!!u)return r!==0&&this.touch(u,r),u.value}set(t,r,u=0){let a=this._map.get(t);if(a)a.value=r,u!==0&&this.touch(a,u);else{switch(a={key:t,value:r,next:void 0,previous:void 0},u){case 0:this.addItemLast(a);break;case 1:this.addItemFirst(a);break;case 2:this.addItemLast(a);break;default:this.addItemLast(a);break}this._map.set(t,a),this._size++}return this}delete(t){return!!this.remove(t)}remove(t){const r=this._map.get(t);if(!!r)return this._map.delete(t),this.removeItem(r),this._size--,r.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const t=this._head;return this._map.delete(t.key),this.removeItem(t),this._size--,t.value}forEach(t,r){const u=this._state;let a=this._head;for(;a;){if(r?t.bind(r)(a.value,a.key,this):t(a.value,a.key,this),this._state!==u)throw new Error("LinkedMap got modified during iteration.");a=a.next}}keys(){const t=this,r=this._state;let u=this._head;const a={[Symbol.iterator](){return a},next(){if(t._state!==r)throw new Error("LinkedMap got modified during iteration.");if(u){const f={value:u.key,done:!1};return u=u.next,f}else return{value:void 0,done:!0}}};return a}values(){const t=this,r=this._state;let u=this._head;const a={[Symbol.iterator](){return a},next(){if(t._state!==r)throw new Error("LinkedMap got modified during iteration.");if(u){const f={value:u.value,done:!1};return u=u.next,f}else return{value:void 0,done:!0}}};return a}entries(){const t=this,r=this._state;let u=this._head;const a={[Symbol.iterator](){return a},next(){if(t._state!==r)throw new Error("LinkedMap got modified during iteration.");if(u){const f={value:[u.key,u.value],done:!1};return u=u.next,f}else return{value:void 0,done:!0}}};return a}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(t){if(t>=this.size)return;if(t===0){this.clear();return}let r=this._head,u=this.size;for(;r&&u>t;)this._map.delete(r.key),r=r.next,u--;this._head=r,this._size=u,r&&(r.previous=void 0),this._state++}addItemFirst(t){if(!this._head&&!this._tail)this._tail=t;else if(this._head)t.next=this._head,this._head.previous=t;else throw new Error("Invalid list");this._head=t,this._state++}addItemLast(t){if(!this._head&&!this._tail)this._head=t;else if(this._tail)t.previous=this._tail,this._tail.next=t;else throw new Error("Invalid list");this._tail=t,this._state++}removeItem(t){if(t===this._head&&t===this._tail)this._head=void 0,this._tail=void 0;else if(t===this._head){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this._head=t.next}else if(t===this._tail){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this._tail=t.previous}else{const r=t.next,u=t.previous;if(!r||!u)throw new Error("Invalid list");r.previous=u,u.next=r}t.next=void 0,t.previous=void 0,this._state++}touch(t,r){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(r!==1&&r!==2)){if(r===1){if(t===this._head)return;const u=t.next,a=t.previous;t===this._tail?(a.next=void 0,this._tail=a):(u.previous=a,a.next=u),t.previous=void 0,t.next=this._head,this._head.previous=t,this._head=t,this._state++}else if(r===2){if(t===this._tail)return;const u=t.next,a=t.previous;t===this._head?(u.previous=void 0,this._head=u):(u.previous=a,a.next=u),t.next=void 0,t.previous=this._tail,this._tail.next=t,this._tail=t,this._state++}}}toJSON(){const t=[];return this.forEach((r,u)=>{t.push([u,r])}),t}fromJSON(t){this.clear();for(const[r,u]of t)this.set(r,u)}}e.LinkedMap=g;class l extends g{constructor(t,r=1){super();this._limit=t,this._ratio=Math.min(Math.max(0,r),1)}get limit(){return this._limit}set limit(t){this._limit=t,this.checkTrim()}get ratio(){return this._ratio}set ratio(t){this._ratio=Math.min(Math.max(0,t),1),this.checkTrim()}get(t,r=2){return super.get(t,r)}peek(t){return super.get(t,0)}set(t,r){return super.set(t,r,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=l;class S{constructor(t){P.set(this,void 0),nt(this,P,t,"f")}get size(){return Be(this,P,"f").size}forEach(t,r){Be(this,P,"f").forEach(t,r)}get(t){return Be(this,P,"f").get(t)}has(t){return Be(this,P,"f").has(t)}entries(){return Be(this,P,"f").entries()}keys(){return Be(this,P,"f").keys()}values(){return Be(this,P,"f").values()}[(P=new WeakMap,Symbol.iterator)](){return Be(this,P,"f").entries()}}e.ReadonlyMapView=S}),define(ve[96],we([0,1,24,8]),function(J,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function y(...te){return function(oe,Ee){for(let Ne=0,Ve=te.length;Ne<Ve;Ne++){const Ge=te[Ne](oe,Ee);if(Ge)return Ge}return null}}e.or=y,e.matchesStrictPrefix=C.bind(void 0,!1),e.matchesPrefix=C.bind(void 0,!0);function C(te,oe,Ee){if(!Ee||Ee.length<oe.length)return null;let Ne;return te?Ne=i.startsWithIgnoreCase(Ee,oe):Ne=Ee.indexOf(oe)===0,Ne?oe.length>0?[{start:0,end:oe.length}]:[]:null}function P(te,oe){const Ee=oe.toLowerCase().indexOf(te.toLowerCase());return Ee===-1?null:[{start:Ee,end:Ee+te.length}]}e.matchesContiguousSubString=P;function D(te,oe){return _(te.toLowerCase(),oe.toLowerCase(),0,0)}e.matchesSubString=D;function _(te,oe,Ee,Ne){if(Ee===te.length)return[];if(Ne===oe.length)return null;if(te[Ee]===oe[Ne]){let Ve=null;return(Ve=_(te,oe,Ee+1,Ne+1))?T({start:Ne,end:Ne+1},Ve):null}return _(te,oe,Ee,Ne+1)}function I(te){return 97<=te&&te<=122}function L(te){return 65<=te&&te<=90}e.isUpper=L;function A(te){return 48<=te&&te<=57}function c(te){return te===32||te===9||te===10||te===13}const E=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(te=>E.add(te.charCodeAt(0)));function h(te){return c(te)||E.has(te)}function p(te,oe){return te===oe||h(te)&&h(oe)}function v(te){return I(te)||L(te)||A(te)}function T(te,oe){return oe.length===0?oe=[te]:te.end===oe[0].start?oe[0].start=te.start:oe.unshift(te),oe}function b(te,oe){for(let Ee=oe;Ee<te.length;Ee++){const Ne=te.charCodeAt(Ee);if(L(Ne)||A(Ne)||Ee>0&&!v(te.charCodeAt(Ee-1)))return Ee}return te.length}function o(te,oe,Ee,Ne){if(Ee===te.length)return[];if(Ne===oe.length)return null;if(te[Ee]!==oe[Ne].toLowerCase())return null;{let Ve=null,Ge=Ne+1;for(Ve=o(te,oe,Ee+1,Ne+1);!Ve&&(Ge=b(oe,Ge))<oe.length;)Ve=o(te,oe,Ee+1,Ge),Ge++;return Ve===null?null:T({start:Ne,end:Ne+1},Ve)}}function s(te){let oe=0,Ee=0,Ne=0,Ve=0,Ge=0;for(let it=0;it<te.length;it++)Ge=te.charCodeAt(it),L(Ge)&&oe++,I(Ge)&&Ee++,v(Ge)&&Ne++,A(Ge)&&Ve++;const Je=oe/te.length,tt=Ee/te.length,ot=Ne/te.length,et=Ve/te.length;return{upperPercent:Je,lowerPercent:tt,alphaPercent:ot,numericPercent:et}}function g(te){const{upperPercent:oe,lowerPercent:Ee}=te;return Ee===0&&oe>.6}function l(te){const{upperPercent:oe,lowerPercent:Ee,alphaPercent:Ne,numericPercent:Ve}=te;return Ee>.2&&oe<.8&&Ne>.6&&Ve<.2}function S(te){let oe=0,Ee=0,Ne=0,Ve=0;for(let Ge=0;Ge<te.length;Ge++)Ne=te.charCodeAt(Ge),L(Ne)&&oe++,I(Ne)&&Ee++,c(Ne)&&Ve++;return(oe===0||Ee===0)&&Ve===0?te.length<=30:oe<=5}function n(te,oe){if(!oe||(oe=oe.trim(),oe.length===0)||!S(te)||oe.length>60)return null;const Ee=s(oe);if(!l(Ee)){if(!g(Ee))return null;oe=oe.toLowerCase()}let Ne=null,Ve=0;for(te=te.toLowerCase();Ve<oe.length&&(Ne=o(te,oe,0,Ve))===null;)Ve=b(oe,Ve+1);return Ne}e.matchesCamelCase=n;function t(te,oe,Ee=!1){if(!oe||oe.length===0)return null;let Ne=null,Ve=0;for(te=te.toLowerCase(),oe=oe.toLowerCase();Ve<oe.length&&(Ne=r(te,oe,0,Ve,Ee))===null;)Ve=u(oe,Ve+1);return Ne}e.matchesWords=t;function r(te,oe,Ee,Ne,Ve){if(Ee===te.length)return[];if(Ne===oe.length)return null;if(p(te.charCodeAt(Ee),oe.charCodeAt(Ne))){let Ge=null,Je=Ne+1;if(Ge=r(te,oe,Ee+1,Ne+1,Ve),!Ve)for(;!Ge&&(Je=u(oe,Je))<oe.length;)Ge=r(te,oe,Ee+1,Je,Ve),Je++;return Ge===null?null:T({start:Ne,end:Ne+1},Ge)}else return null}function u(te,oe){for(let Ee=oe;Ee<te.length;Ee++)if(h(te.charCodeAt(Ee))||Ee>0&&h(te.charCodeAt(Ee-1)))return Ee;return te.length}const a=y(e.matchesPrefix,n,P),f=y(e.matchesPrefix,n,D),w=new m.LRUCache(1e4);function d(te,oe,Ee=!1){if(typeof te!="string"||typeof oe!="string")return null;let Ne=w.get(te);Ne||(Ne=new RegExp(i.convertSimple2RegExpPattern(te),"i"),w.set(te,Ne));const Ve=Ne.exec(oe);return Ve?[{start:Ve.index,end:Ve.index+Ve[0].length}]:Ee?f(te,oe):a(te,oe)}e.matchesFuzzy=d;function k(te,oe){const Ee=Ie(te,te.toLowerCase(),0,oe,oe.toLowerCase(),0,!0);return Ee?N(Ee):null}e.matchesFuzzy2=k;function R(te,oe,Ee,Ne,Ve,Ge){const Je=Math.min(13,te.length);for(;Ee<Je;Ee++){const tt=Ie(te,oe,Ee,Ne,Ve,Ge,!1);if(tt)return tt}return[0,Ge]}e.anyScore=R;function N(te){if(typeof te=="undefined")return[];const oe=[],Ee=te[1];for(let Ne=te.length-1;Ne>1;Ne--){const Ve=te[Ne]+Ee,Ge=oe[oe.length-1];Ge&&Ge.end===Ve?Ge.end=Ve+1:oe.push({start:Ve,end:Ve+1})}return oe}e.createMatches=N;const x=128;function F(){const te=[],oe=[];for(let Ee=0;Ee<=x;Ee++)oe[Ee]=0;for(let Ee=0;Ee<=x;Ee++)te.push(oe.slice(0));return te}function B(te){const oe=[];for(let Ee=0;Ee<=te;Ee++)oe[Ee]=0;return oe}const O=B(2*x),H=B(2*x),M=F(),W=F(),z=F(),U=!1;function V(te,oe,Ee,Ne,Ve){function Ge(tt,ot,et=" "){for(;tt.length<ot;)tt=et+tt;return tt}let Je=` |   |${Ne.split("").map(tt=>Ge(tt,3)).join("|")}
`;for(let tt=0;tt<=Ee;tt++)tt===0?Je+=" |":Je+=`${oe[tt-1]}|`,Je+=te[tt].slice(0,Ve+1).map(ot=>Ge(ot.toString(),3)).join("|")+`
`;return Je}function K(te,oe,Ee,Ne){te=te.substr(oe),Ee=Ee.substr(Ne),console.log(V(W,te,te.length,Ee,Ee.length)),console.log(V(z,te,te.length,Ee,Ee.length)),console.log(V(M,te,te.length,Ee,Ee.length))}function G(te,oe){if(oe<0||oe>=te.length)return!1;const Ee=te.codePointAt(oe);switch(Ee){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!i.isEmojiImprecise(Ee)}}function Q(te,oe){if(oe<0||oe>=te.length)return!1;switch(te.charCodeAt(oe)){case 32:case 9:return!0;default:return!1}}function Y(te,oe,Ee){return oe[te]!==Ee[te]}function fe(te,oe,Ee,Ne,Ve,Ge,Je=!1){for(;oe<Ee&&Ve<Ge;)te[oe]===Ne[Ve]&&(Je&&(O[oe]=Ve),oe+=1),Ve+=1;return oe===Ee}e.isPatternInWord=fe;var me;(function(te){te[te.Diag=1]="Diag",te[te.Left=2]="Left",te[te.LeftLeft=3]="LeftLeft"})(me||(me={}));var _e;(function(te){te.Default=[-100,0];function oe(Ee){return!Ee||Ee.length===2&&Ee[0]===-100&&Ee[1]===0}te.isDefault=oe})(_e=e.FuzzyScore||(e.FuzzyScore={}));function Ie(te,oe,Ee,Ne,Ve,Ge,Je){const tt=te.length>x?x:te.length,ot=Ne.length>x?x:Ne.length;if(Ee>=tt||Ge>=ot||tt-Ee>ot-Ge||!fe(oe,Ee,tt,Ve,Ge,ot,!0))return;Oe(tt,ot,Ee,Ge,oe,Ve);let et=1,it=1,lt=Ee,pt=Ge;const Pt=[!1];for(et=1,lt=Ee;lt<tt;et++,lt++){const pe=O[lt],ie=H[lt],Se=lt+1<tt?H[lt+1]:ot;for(it=pe-Ge+1,pt=pe;pt<Se;it++,pt++){let Fe=Number.MIN_SAFE_INTEGER,Ue=!1;pt<=ie&&(Fe=We(te,oe,lt,Ee,Ne,Ve,pt,ot,Ge,M[et-1][it-1]===0,Pt));let Xe=0;Fe!==Number.MAX_SAFE_INTEGER&&(Ue=!0,Xe=Fe+W[et-1][it-1]);const Ae=pt>pe,Pe=Ae?W[et][it-1]+(M[et][it-1]>0?-5:0):0,ye=pt>pe+1&&M[et][it-1]>0,ce=ye?W[et][it-2]+(M[et][it-2]>0?-5:0):0;if(ye&&(!Ae||ce>=Pe)&&(!Ue||ce>=Xe))W[et][it]=ce,z[et][it]=3,M[et][it]=0;else if(Ae&&(!Ue||Pe>=Xe))W[et][it]=Pe,z[et][it]=2,M[et][it]=0;else if(Ue)W[et][it]=Xe,z[et][it]=1,M[et][it]=M[et-1][it-1]+1;else throw new Error("not possible")}}if(U&&K(te,Ee,Ne,Ge),!Pt[0]&&!Je)return;et--,it--;const xe=[W[et][it],Ge];let Rt=0,ee=0;for(;et>=1;){let pe=it;do{const ie=z[et][pe];if(ie===3)pe=pe-2;else if(ie===2)pe=pe-1;else break}while(pe>=1);Rt>1&&oe[Ee+et-1]===Ve[Ge+it-1]&&!Y(pe+Ge-1,Ne,Ve)&&Rt+1>M[et][pe]&&(pe=it),pe===it?Rt++:Rt=1,ee||(ee=pe),et--,it=pe-1,xe.push(it)}ot===tt&&(xe[0]+=2);const ne=ee-tt;return xe[0]-=ne,xe}e.fuzzyScore=Ie;function Oe(te,oe,Ee,Ne,Ve,Ge){let Je=te-1,tt=oe-1;for(;Je>=Ee&&tt>=Ne;)Ve[Je]===Ge[tt]&&(H[Je]=tt,Je--),tt--}function We(te,oe,Ee,Ne,Ve,Ge,Je,tt,ot,et,it){if(oe[Ee]!==Ge[Je])return Number.MIN_SAFE_INTEGER;let lt=1,pt=!1;return Je===Ee-Ne?lt=te[Ee]===Ve[Je]?7:5:Y(Je,Ve,Ge)&&(Je===0||!Y(Je-1,Ve,Ge))?(lt=te[Ee]===Ve[Je]?7:5,pt=!0):G(Ge,Je)&&(Je===0||!G(Ge,Je-1))?lt=5:(G(Ge,Je-1)||Q(Ge,Je-1))&&(lt=5,pt=!0),lt>1&&Ee===Ne&&(it[0]=!0),pt||(pt=Y(Je,Ve,Ge)||G(Ge,Je-1)||Q(Ge,Je-1)),Ee===Ne?Je>ot&&(lt-=pt?3:5):et?lt+=pt?2:0:lt+=pt?0:1,Je+1===tt&&(lt-=pt?3:5),lt}function j(te,oe,Ee,Ne,Ve,Ge,Je){return re(te,oe,Ee,Ne,Ve,Ge,!0,Je)}e.fuzzyScoreGracefulAggressive=j;function Z(te,oe,Ee,Ne,Ve,Ge,Je){return re(te,oe,Ee,Ne,Ve,Ge,!1,Je)}e.fuzzyScoreGraceful=Z;function re(te,oe,Ee,Ne,Ve,Ge,Je,tt){let ot=Ie(te,oe,Ee,Ne,Ve,Ge,tt);if(ot&&!Je)return ot;if(te.length>=3){const et=Math.min(7,te.length-1);for(let it=Ee+1;it<et;it++){const lt=ue(te,it);if(lt){const pt=Ie(lt,lt.toLowerCase(),Ee,Ne,Ve,Ge,tt);pt&&(pt[0]-=3,(!ot||pt[0]>ot[0])&&(ot=pt))}}}return ot}function ue(te,oe){if(oe+1>=te.length)return;const Ee=te[oe],Ne=te[oe+1];if(Ee!==Ne)return te.slice(0,oe)+Ne+Ee+te.slice(oe+2)}}),define(ve[141],we([0,1,73,96,8]),function(J,e,m,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const C=new RegExp(`\\$\\(${m.CSSIcon.iconNameExpression}(?:${m.CSSIcon.iconModifierExpression})?\\)`,"g"),P=new RegExp(m.CSSIcon.iconNameCharacter),D=new RegExp(`(\\\\)?${C.source}`,"g");function _(v){return v.replace(D,(T,b)=>b?T:`\\${T}`)}e.escapeIcons=_;const I=new RegExp(`\\\\${C.source}`,"g");function L(v){return v.replace(I,T=>`\\${T}`)}e.markdownEscapeEscapedIcons=L;const A=new RegExp(`(\\s)?(\\\\)?${C.source}(\\s)?`,"g");function c(v){return v.indexOf(e.iconStartMarker)===-1?v:v.replace(A,(T,b,o,s)=>o?T:b||s||"")}e.stripIcons=c;function E(v){const T=v.indexOf(e.iconStartMarker);return T===-1?{text:v}:h(v,T)}e.parseLabelWithIcons=E;function h(v,T){const b=[];let o="";function s(a){if(a){o+=a;for(const f of a)b.push(S)}}let g=-1,l="",S=0,n,t,r=T;const u=v.length;for(s(v.substr(0,T));r<u;)n=v[r],t=v[r+1],n===e.iconStartMarker[0]&&t===e.iconStartMarker[1]?(g=r,s(l),l=e.iconStartMarker,r++):n===")"&&g!==-1?(S+=r-g+1,g=-1,l=""):g!==-1?P.test(n)?l+=n:(s(l),g=-1,l=""):s(n),r++;return s(l),{text:o,iconOffsets:b}}function p(v,T,b=!1){const{text:o,iconOffsets:s}=T;if(!s||s.length===0)return(0,i.matchesFuzzy)(v,o,b);const g=(0,y.ltrim)(o," "),l=o.length-g.length,S=(0,i.matchesFuzzy)(v,g,b);if(S)for(const n of S){const t=s[n.start+l]+l;n.start+=t,n.end+=t}return S}e.matchesFuzzyIconAware=p}),define(ve[97],we([0,1,15,141]),function(J,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var y;(function(c){c[c.Paragraph=0]="Paragraph",c[c.Break=1]="Break"})(y=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class C{constructor(E="",h=!1){if(this.value=E,typeof this.value!="string")throw(0,m.illegalArgument)("value");typeof h=="boolean"?(this.isTrusted=h,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=h.isTrusted??void 0,this.supportThemeIcons=h.supportThemeIcons??!1,this.supportHtml=h.supportHtml??!1)}appendText(E,h=0){return this.value+=I(this.supportThemeIcons?(0,i.escapeIcons)(E):E).replace(/([ \t]+)/g,(p,v)=>"&nbsp;".repeat(v.length)).replace(/\>/gm,"\\>").replace(/\n/g,h===1?`\\
`:`

`),this}appendMarkdown(E){return this.value+=E,this}appendCodeblock(E,h){return this.value+="\n```",this.value+=E,this.value+=`
`,this.value+=h,this.value+="\n```\n",this}}e.MarkdownString=C;function P(c){return D(c)?!c.value:Array.isArray(c)?c.every(P):!0}e.isEmptyMarkdownString=P;function D(c){return c instanceof C?!0:c&&typeof c=="object"?typeof c.value=="string"&&(typeof c.isTrusted=="boolean"||c.isTrusted===void 0)&&(typeof c.supportThemeIcons=="boolean"||c.supportThemeIcons===void 0):!1}e.isMarkdownString=D;function _(c,E){return c===E?!0:!c||!E?!1:c.value===E.value&&c.isTrusted===E.isTrusted&&c.supportThemeIcons===E.supportThemeIcons}e.markdownStringEqual=_;function I(c){return c.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=I;function L(c){return c&&c.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=L;function A(c){const E=[],h=c.split("|").map(v=>v.trim());c=h[0];const p=h[1];if(p){const v=/height=(\d+)/.exec(p),T=/width=(\d+)/.exec(p),b=v?v[1]:"",o=T?T[1]:"",s=isFinite(parseInt(o)),g=isFinite(parseInt(b));s&&E.push(`width="${o}"`),g&&E.push(`height="${b}"`)}return{href:c,dimensions:E}}e.parseHrefAndDimensions=A}),define(ve[79],we([0,1,24]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const i=new m.LRUCache(1e4);function y(I){return _(I,"NFC",i)}e.normalizeNFC=y;const C=new m.LRUCache(1e4);function P(I){return _(I,"NFD",C)}e.normalizeNFD=P;const D=/[^\u0000-\u0080]/;function _(I,L,A){if(!I)return I;const c=A.get(I);if(c)return c;let E;return D.test(I)?E=I.normalize(L):E=I,A.set(I,E),E}e.removeAccents=function(){const I=/[\u0300-\u036f]/g;return function(L){return P(L).replace(I,"")}}()}),define(ve[48],we([0,1,8]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var i;(function(y){y[y.Ignore=0]="Ignore",y[y.Info=1]="Info",y[y.Warning=2]="Warning",y[y.Error=3]="Error"})(i||(i={})),function(y){const C="error",P="warning",D="warn",_="info",I="ignore";function L(c){return c?m.equalsIgnoreCase(C,c)?y.Error:m.equalsIgnoreCase(P,c)||m.equalsIgnoreCase(D,c)?y.Warning:m.equalsIgnoreCase(_,c)?y.Info:y.Ignore:y.Ignore}y.fromValue=L;function A(c){switch(c){case y.Error:return C;case y.Warning:return P;case y.Info:return _;default:return I}}y.toString=A}(i||(i={})),e.default=i}),define(ve[13],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function m(f){return Array.isArray(f)}e.isArray=m;function i(f){return typeof f=="string"}e.isString=i;function y(f){return Array.isArray(f)&&f.every(w=>i(w))}e.isStringArray=y;function C(f){return typeof f=="object"&&f!==null&&!Array.isArray(f)&&!(f instanceof RegExp)&&!(f instanceof Date)}e.isObject=C;function P(f){return typeof f=="number"&&!isNaN(f)}e.isNumber=P;function D(f){return!!f&&typeof f[Symbol.iterator]=="function"}e.isIterable=D;function _(f){return f===!0||f===!1}e.isBoolean=_;function I(f){return typeof f=="undefined"}e.isUndefined=I;function L(f){return!A(f)}e.isDefined=L;function A(f){return I(f)||f===null}e.isUndefinedOrNull=A;function c(f,w){if(!f)throw new Error(w?`Unexpected type, expected '${w}'`:"Unexpected type")}e.assertType=c;function E(f){if(A(f))throw new Error("Assertion Failed: argument is undefined or null");return f}e.assertIsDefined=E;function h(...f){const w=[];for(let d=0;d<f.length;d++){const k=f[d];if(A(k))throw new Error(`Assertion Failed: argument at index ${d} is undefined or null`);w.push(k)}return w}e.assertAllDefined=h;const p=Object.prototype.hasOwnProperty;function v(f){if(!C(f))return!1;for(let w in f)if(p.call(f,w))return!1;return!0}e.isEmptyObject=v;function T(f){return typeof f=="function"}e.isFunction=T;function b(...f){return f.length>0&&f.every(T)}e.areFunctions=b;function o(f,w){const d=Math.min(f.length,w.length);for(let k=0;k<d;k++)s(f[k],w[k])}e.validateConstraints=o;function s(f,w){if(i(w)){if(typeof f!==w)throw new Error(`argument does not match constraint: typeof ${w}`)}else if(T(w)){try{if(f instanceof w)return}catch{}if(!A(f)&&f.constructor===w||w.length===1&&w.call(void 0,f)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=s;function g(f){let w=[],d=Object.getPrototypeOf(f);for(;Object.prototype!==d;)w=w.concat(Object.getOwnPropertyNames(d)),d=Object.getPrototypeOf(d);return w}e.getAllPropertyNames=g;function l(f){const w=[];for(const d of g(f))typeof f[d]=="function"&&w.push(d);return w}e.getAllMethodNames=l;function S(f,w){const d=R=>function(){const N=Array.prototype.slice.call(arguments,0);return w(R,N)};let k={};for(const R of f)k[R]=d(R);return k}e.createProxyObject=S;function n(f){return f===null?void 0:f}e.withNullAsUndefined=n;function t(f){return typeof f=="undefined"?null:f}e.withUndefinedAsNull=t;function r(f){return class{constructor(){return new Proxy({},{get(w,d){if(w[d])return w[d];throw new Error(`Not Implemented: ${f}->${String(d)}`)}})}}}e.NotImplementedProxy=r;function u(f,w="Unreachable"){throw new Error(w)}e.assertNever=u;function a(f){return!!f&&typeof f.then=="function"&&typeof f.catch=="function"}e.isPromise=a}),define(ve[30],we([0,1,9,12,8,13]),function(J,e,m,i,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function P(n){return n===47||n===92}e.isPathSeparator=P;function D(n){return n.replace(/[\\/]/g,m.posix.sep)}e.toSlashes=D;function _(n){return n.indexOf("/")===-1&&(n=D(n)),/^[a-zA-Z]:(\/|$)/.test(n)&&(n="/"+n),n}e.toPosixPath=_;function I(n,t=m.posix.sep){if(!n)return"";const r=n.length,u=n.charCodeAt(0);if(P(u)){if(P(n.charCodeAt(1))&&!P(n.charCodeAt(2))){let f=3;const w=f;for(;f<r&&!P(n.charCodeAt(f));f++);if(w!==f&&!P(n.charCodeAt(f+1))){for(f+=1;f<r;f++)if(P(n.charCodeAt(f)))return n.slice(0,f+1).replace(/[\\/]/g,t)}}return t}else if(T(u)&&n.charCodeAt(1)===58)return P(n.charCodeAt(2))?n.slice(0,2)+t:n.slice(0,2);let a=n.indexOf("://");if(a!==-1){for(a+=3;a<r;a++)if(P(n.charCodeAt(a)))return n.slice(0,a+1)}return""}e.getRoot=I;function L(n){if(!i.isWindows||!n||n.length<5)return!1;let t=n.charCodeAt(0);if(t!==92||(t=n.charCodeAt(1),t!==92))return!1;let r=2;const u=r;for(;r<n.length&&(t=n.charCodeAt(r),t!==92);r++);return!(u===r||(t=n.charCodeAt(r+1),isNaN(t)||t===92))}e.isUNC=L;const A=/[\\/:\*\?"<>\|]/g,c=/[\\/]/g,E=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function h(n,t=i.isWindows){const r=t?A:c;return!(!n||n.length===0||/^\s+$/.test(n)||(r.lastIndex=0,r.test(n))||t&&E.test(n)||n==="."||n===".."||t&&n[n.length-1]==="."||t&&n.length!==n.trim().length||n.length>255)}e.isValidBasename=h;function p(n,t,r){const u=n===t;return!r||u?u:!n||!t?!1:(0,y.equalsIgnoreCase)(n,t)}e.isEqual=p;function v(n,t,r,u=m.sep){if(n===t)return!0;if(!n||!t||t.length>n.length)return!1;if(r){if(!(0,y.startsWithIgnoreCase)(n,t))return!1;if(t.length===n.length)return!0;let f=t.length;return t.charAt(t.length-1)===u&&f--,n.charAt(f)===u}return t.charAt(t.length-1)!==u&&(t+=u),n.indexOf(t)===0}e.isEqualOrParent=v;function T(n){return n>=65&&n<=90||n>=97&&n<=122}e.isWindowsDriveLetter=T;function b(n,t){return i.isWindows&&n.endsWith(":")&&(n+=m.sep),(0,m.isAbsolute)(n)||(n=(0,m.join)(t,n)),n=(0,m.normalize)(n),i.isWindows?(n=(0,y.rtrim)(n,m.sep),n.endsWith(":")&&(n+=m.sep)):(n=(0,y.rtrim)(n,m.sep),n||(n=m.sep)),n}e.sanitizeFilePath=b;function o(n){const t=(0,m.normalize)(n);return i.isWindows?n.length>3?!1:s(t)&&(n.length===2||t.charCodeAt(2)===92):t===m.posix.sep}e.isRootOrDriveLetter=o;function s(n,t){return(t!==void 0?t:i.isWindows)?T(n.charCodeAt(0))&&n.charCodeAt(1)===58:!1}e.hasDriveLetter=s;function g(n){return s(n)?n[0]:void 0}e.getDriveLetter=g;function l(n,t,r){return t.length>n.length?-1:n===t?0:(r&&(n=n.toLowerCase(),t=t.toLowerCase()),n.indexOf(t))}e.indexOfPath=l;function S(n){const t=n.split(":");let r,u,a;if(t.forEach(f=>{const w=Number(f);(0,C.isNumber)(w)?u===void 0?u=w:a===void 0&&(a=w):r=r?[r,f].join(":"):f}),!r)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:r,line:u!==void 0?u:void 0,column:a!==void 0?a:u!==void 0?1:void 0}}e.parseLineAndColumnAware=S}),define(ve[25],we([0,1,13]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function i(p){if(!p||typeof p!="object"||p instanceof RegExp)return p;const v=Array.isArray(p)?[]:{};return Object.keys(p).forEach(T=>{p[T]&&typeof p[T]=="object"?v[T]=i(p[T]):v[T]=p[T]}),v}e.deepClone=i;function y(p){if(!p||typeof p!="object")return p;const v=[p];for(;v.length>0;){const T=v.shift();Object.freeze(T);for(const b in T)if(C.call(T,b)){const o=T[b];typeof o=="object"&&!Object.isFrozen(o)&&v.push(o)}}return p}e.deepFreeze=y;const C=Object.prototype.hasOwnProperty;function P(p,v){return D(p,v,new Set)}e.cloneAndChange=P;function D(p,v,T){if((0,m.isUndefinedOrNull)(p))return p;const b=v(p);if(typeof b!="undefined")return b;if((0,m.isArray)(p)){const o=[];for(const s of p)o.push(D(s,v,T));return o}if((0,m.isObject)(p)){if(T.has(p))throw new Error("Cannot clone recursive data-structure");T.add(p);const o={};for(let s in p)C.call(p,s)&&(o[s]=D(p[s],v,T));return T.delete(p),o}return p}function _(p,v,T=!0){return(0,m.isObject)(p)?((0,m.isObject)(v)&&Object.keys(v).forEach(b=>{b in p?T&&((0,m.isObject)(p[b])&&(0,m.isObject)(v[b])?_(p[b],v[b],T):p[b]=v[b]):p[b]=v[b]}),p):v}e.mixin=_;function I(p,v){if(p===v)return!0;if(p==null||v===null||v===void 0||typeof p!=typeof v||typeof p!="object"||Array.isArray(p)!==Array.isArray(v))return!1;let T,b;if(Array.isArray(p)){if(p.length!==v.length)return!1;for(T=0;T<p.length;T++)if(!I(p[T],v[T]))return!1}else{const o=[];for(b in p)o.push(b);o.sort();const s=[];for(b in v)s.push(b);if(s.sort(),!I(o,s))return!1;for(T=0;T<o.length;T++)if(!I(p[o[T]],v[o[T]]))return!1}return!0}e.equals=I;function L(p){const v=new Set;return JSON.stringify(p,(T,b)=>{if((0,m.isObject)(b)||Array.isArray(b)){if(v.has(b))return"[Circular]";v.add(b)}return b})}e.safeStringify=L;function A(p,v,T){const b=v(p);return typeof b=="undefined"?T:b}e.getOrDefault=A;function c(p,v){const T=Object.create(null);return!p||!v||Object.keys(v).forEach(o=>{const s=p[o],g=v[o];I(s,g)||(T[o]=g)}),T}e.distinct=c;function E(p,v){const T=v.toLowerCase(),b=Object.keys(p).find(o=>o.toLowerCase()===T);return b?p[b]:p[v]}e.getCaseInsensitive=E;function h(p,v){const T=Object.create(null);for(const[b,o]of Object.entries(p))v(b,o)&&(T[b]=o);return T}e.filter=h}),define(ve[98],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var m;(function(C){C[C.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",C[C.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",C[C.MAX_UINT_8=255]="MAX_UINT_8",C[C.MAX_UINT_16=65535]="MAX_UINT_16",C[C.MAX_UINT_32=4294967295]="MAX_UINT_32",C[C.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(m=e.Constants||(e.Constants={}));function i(C){return C<0?0:C>255?255:C|0}e.toUint8=i;function y(C){return C<0?0:C>4294967295?4294967295:C|0}e.toUint32=y}),define(ve[2],we([0,1,9,12]),function(J,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const y=/^\w[\w\d+.-]*$/,C=/^\//,P=/^\/\//;function D(n,t){if(!n.scheme&&t)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${n.authority}", path: "${n.path}", query: "${n.query}", fragment: "${n.fragment}"}`);if(n.scheme&&!y.test(n.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(n.path){if(n.authority){if(!C.test(n.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(P.test(n.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function _(n,t){return!n&&!t?"file":n}function I(n,t){switch(n){case"https":case"http":case"file":t?t[0]!==A&&(t=A+t):t=A;break}return t}const L="",A="/",c=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class E{constructor(t,r,u,a,f,w=!1){typeof t=="object"?(this.scheme=t.scheme||L,this.authority=t.authority||L,this.path=t.path||L,this.query=t.query||L,this.fragment=t.fragment||L):(this.scheme=_(t,w),this.authority=r||L,this.path=I(this.scheme,u||L),this.query=a||L,this.fragment=f||L,D(this,w))}static isUri(t){return t instanceof E?!0:t?typeof t.authority=="string"&&typeof t.fragment=="string"&&typeof t.path=="string"&&typeof t.query=="string"&&typeof t.scheme=="string"&&typeof t.fsPath=="string"&&typeof t.with=="function"&&typeof t.toString=="function":!1}get fsPath(){return o(this,!1)}with(t){if(!t)return this;let{scheme:r,authority:u,path:a,query:f,fragment:w}=t;return r===void 0?r=this.scheme:r===null&&(r=L),u===void 0?u=this.authority:u===null&&(u=L),a===void 0?a=this.path:a===null&&(a=L),f===void 0?f=this.query:f===null&&(f=L),w===void 0?w=this.fragment:w===null&&(w=L),r===this.scheme&&u===this.authority&&a===this.path&&f===this.query&&w===this.fragment?this:new p(r,u,a,f,w)}static parse(t,r=!1){const u=c.exec(t);return u?new p(u[2]||L,S(u[4]||L),S(u[5]||L),S(u[7]||L),S(u[9]||L),r):new p(L,L,L,L,L)}static file(t){let r=L;if(i.isWindows&&(t=t.replace(/\\/g,A)),t[0]===A&&t[1]===A){const u=t.indexOf(A,2);u===-1?(r=t.substring(2),t=A):(r=t.substring(2,u),t=t.substring(u)||A)}return new p("file",r,t,L,L)}static from(t){const r=new p(t.scheme,t.authority,t.path,t.query,t.fragment);return D(r,!0),r}static joinPath(t,...r){if(!t.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let u;return i.isWindows&&t.scheme==="file"?u=E.file(m.win32.join(o(t,!0),...r)).path:u=m.posix.join(t.path,...r),t.with({path:u})}toString(t=!1){return s(this,t)}toJSON(){return this}static revive(t){if(t){if(t instanceof E)return t;{const r=new p(t);return r._formatted=t.external,r._fsPath=t._sep===h?t.fsPath:null,r}}else return t}}e.URI=E;const h=i.isWindows?1:void 0;class p extends E{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=o(this,!1)),this._fsPath}toString(t=!1){return t?s(this,!0):(this._formatted||(this._formatted=s(this,!1)),this._formatted)}toJSON(){const t={$mid:1};return this._fsPath&&(t.fsPath=this._fsPath,t._sep=h),this._formatted&&(t.external=this._formatted),this.path&&(t.path=this.path),this.scheme&&(t.scheme=this.scheme),this.authority&&(t.authority=this.authority),this.query&&(t.query=this.query),this.fragment&&(t.fragment=this.fragment),t}}const v={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function T(n,t){let r,u=-1;for(let a=0;a<n.length;a++){const f=n.charCodeAt(a);if(f>=97&&f<=122||f>=65&&f<=90||f>=48&&f<=57||f===45||f===46||f===95||f===126||t&&f===47)u!==-1&&(r+=encodeURIComponent(n.substring(u,a)),u=-1),r!==void 0&&(r+=n.charAt(a));else{r===void 0&&(r=n.substr(0,a));const w=v[f];w!==void 0?(u!==-1&&(r+=encodeURIComponent(n.substring(u,a)),u=-1),r+=w):u===-1&&(u=a)}}return u!==-1&&(r+=encodeURIComponent(n.substring(u))),r!==void 0?r:n}function b(n){let t;for(let r=0;r<n.length;r++){const u=n.charCodeAt(r);u===35||u===63?(t===void 0&&(t=n.substr(0,r)),t+=v[u]):t!==void 0&&(t+=n[r])}return t!==void 0?t:n}function o(n,t){let r;return n.authority&&n.path.length>1&&n.scheme==="file"?r=`//${n.authority}${n.path}`:n.path.charCodeAt(0)===47&&(n.path.charCodeAt(1)>=65&&n.path.charCodeAt(1)<=90||n.path.charCodeAt(1)>=97&&n.path.charCodeAt(1)<=122)&&n.path.charCodeAt(2)===58?t?r=n.path.substr(1):r=n.path[1].toLowerCase()+n.path.substr(2):r=n.path,i.isWindows&&(r=r.replace(/\//g,"\\")),r}e.uriToFsPath=o;function s(n,t){const r=t?b:T;let u="",{scheme:a,authority:f,path:w,query:d,fragment:k}=n;if(a&&(u+=a,u+=":"),(f||a==="file")&&(u+=A,u+=A),f){let R=f.indexOf("@");if(R!==-1){const N=f.substr(0,R);f=f.substr(R+1),R=N.indexOf(":"),R===-1?u+=r(N,!1):(u+=r(N.substr(0,R),!1),u+=":",u+=r(N.substr(R+1),!1)),u+="@"}f=f.toLowerCase(),R=f.indexOf(":"),R===-1?u+=r(f,!1):(u+=r(f.substr(0,R),!1),u+=f.substr(R))}if(w){if(w.length>=3&&w.charCodeAt(0)===47&&w.charCodeAt(2)===58){const R=w.charCodeAt(1);R>=65&&R<=90&&(w=`/${String.fromCharCode(R+32)}:${w.substr(3)}`)}else if(w.length>=2&&w.charCodeAt(1)===58){const R=w.charCodeAt(0);R>=65&&R<=90&&(w=`${String.fromCharCode(R+32)}:${w.substr(2)}`)}u+=r(w,!0)}return d&&(u+="?",u+=r(d,!1)),k&&(u+="#",u+=t?k:T(k,!1)),u}function g(n){try{return decodeURIComponent(n)}catch{return n.length>3?n.substr(0,3)+g(n.substr(3)):n}}const l=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function S(n){return n.match(l)?n.replace(l,t=>g(t)):n}}),define(ve[59],we([0,1,22,8,2]),function(J,e,m,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function C(L){return JSON.stringify(L,_)}e.stringify=C;function P(L){let A=JSON.parse(L);return A=I(A),A}e.parse=P;var D;(function(L){L[L.Uri=1]="Uri",L[L.Regexp=2]="Regexp",L[L.ScmResource=3]="ScmResource",L[L.ScmResourceGroup=4]="ScmResourceGroup",L[L.ScmProvider=5]="ScmProvider",L[L.CommentController=6]="CommentController",L[L.CommentThread=7]="CommentThread",L[L.CommentThreadReply=8]="CommentThreadReply",L[L.CommentNode=9]="CommentNode",L[L.CommentThreadNode=10]="CommentThreadNode",L[L.TimelineActionContext=11]="TimelineActionContext",L[L.NotebookCellActionContext=12]="NotebookCellActionContext",L[L.TestItemContext=13]="TestItemContext"})(D=e.MarshalledId||(e.MarshalledId={}));function _(L,A){return A instanceof RegExp?{$mid:2,source:A.source,flags:(0,i.regExpFlags)(A)}:A}function I(L,A=0){if(!L||A>200)return L;if(typeof L=="object"){switch(L.$mid){case 1:return y.URI.revive(L);case 2:return new RegExp(L.source,L.flags)}if(L instanceof m.VSBuffer||L instanceof Uint8Array)return L;if(Array.isArray(L))for(let c=0;c<L.length;++c)L[c]=I(L[c],A+1);else for(const c in L)Object.hasOwnProperty.call(L,c)&&(L[c]=I(L[c],A+1))}return L}e.revive=I}),define(ve[10],we([0,1,12,2]),function(J,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var y;(function(D){D.inMemory="inmemory",D.vscode="vscode",D.internal="private",D.walkThrough="walkThrough",D.walkThroughSnippet="walkThroughSnippet",D.http="http",D.https="https",D.file="file",D.mailto="mailto",D.untitled="untitled",D.data="data",D.command="command",D.vscodeRemote="vscode-remote",D.vscodeRemoteResource="vscode-remote-resource",D.userData="vscode-userdata",D.vscodeCustomEditor="vscode-custom-editor",D.vscodeNotebook="vscode-notebook",D.vscodeNotebookCell="vscode-notebook-cell",D.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",D.vscodeNotebookCellOutput="vscode-notebook-cell-output",D.vscodeInteractive="vscode-interactive",D.vscodeInteractiveInput="vscode-interactive-input",D.vscodeSettings="vscode-settings",D.vscodeWorkspaceTrust="vscode-workspace-trust",D.vscodeTerminal="vscode-terminal",D.webviewPanel="webview-panel",D.vscodeWebview="vscode-webview",D.extension="extension",D.vscodeFileResource="vscode-file",D.tmp="tmp",D.vsls="vsls"})(y=e.Schemas||(e.Schemas={}));class C{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(_){this._preferredWebSchema=_}setDelegate(_){this._delegate=_}set(_,I,L){this._hosts[_]=I,this._ports[_]=L}setConnectionToken(_,I){this._connectionTokens[_]=I}rewrite(_){if(this._delegate)return this._delegate(_);const I=_.authority;let L=this._hosts[I];L&&L.indexOf(":")!==-1&&(L=`[${L}]`);const A=this._ports[I],c=this._connectionTokens[I];let E=`path=${encodeURIComponent(_.path)}`;return typeof c=="string"&&(E+=`&tkn=${encodeURIComponent(c)}`),i.URI.from({scheme:m.isWeb?this._preferredWebSchema:y.vscodeRemoteResource,authority:`${L}:${A}`,path:"/vscode-remote-resource",query:E})}}e.RemoteAuthorities=new C;class P{asBrowserUri(_,I){const L=this.toUri(_,I);return L.scheme===y.vscodeRemote?e.RemoteAuthorities.rewrite(L):L.scheme===y.file&&(m.isNative||typeof m.globals.importScripts=="function"&&m.globals.origin===`${y.vscodeFileResource}://${P.FALLBACK_AUTHORITY}`)?L.with({scheme:y.vscodeFileResource,authority:L.authority||P.FALLBACK_AUTHORITY,query:null,fragment:null}):L}asFileUri(_,I){const L=this.toUri(_,I);return L.scheme===y.vscodeFileResource?L.with({scheme:y.file,authority:L.authority!==P.FALLBACK_AUTHORITY?L.authority:null,query:null,fragment:null}):L}toUri(_,I){return i.URI.isUri(_)?_:i.URI.parse(I.toUrl(_))}}P.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new P}),define(ve[23],we([0,1,30,10,9,12,8,2]),function(J,e,m,i,y,C,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function _(E){return(0,D.uriToFsPath)(E,!0)}e.originalFSPath=_;class I{constructor(h){this._ignorePathCasing=h}compare(h,p,v=!1){return h===p?0:(0,P.compare)(this.getComparisonKey(h,v),this.getComparisonKey(p,v))}isEqual(h,p,v=!1){return h===p?!0:!h||!p?!1:this.getComparisonKey(h,v)===this.getComparisonKey(p,v)}getComparisonKey(h,p=!1){return h.with({path:this._ignorePathCasing(h)?h.path.toLowerCase():void 0,fragment:p?null:void 0}).toString()}ignorePathCasing(h){return this._ignorePathCasing(h)}isEqualOrParent(h,p,v=!1){if(h.scheme===p.scheme){if(h.scheme===i.Schemas.file)return m.isEqualOrParent(_(h),_(p),this._ignorePathCasing(h))&&h.query===p.query&&(v||h.fragment===p.fragment);if((0,e.isEqualAuthority)(h.authority,p.authority))return m.isEqualOrParent(h.path,p.path,this._ignorePathCasing(h),"/")&&h.query===p.query&&(v||h.fragment===p.fragment)}return!1}joinPath(h,...p){return D.URI.joinPath(h,...p)}basenameOrAuthority(h){return(0,e.basename)(h)||h.authority}basename(h){return y.posix.basename(h.path)}extname(h){return y.posix.extname(h.path)}dirname(h){if(h.path.length===0)return h;let p;return h.scheme===i.Schemas.file?p=D.URI.file(y.dirname(_(h))).path:(p=y.posix.dirname(h.path),h.authority&&p.length&&p.charCodeAt(0)!==47&&(console.error(`dirname("${h.toString})) resulted in a relative path`),p="/")),h.with({path:p})}normalizePath(h){if(!h.path.length)return h;let p;return h.scheme===i.Schemas.file?p=D.URI.file(y.normalize(_(h))).path:p=y.posix.normalize(h.path),h.with({path:p})}relativePath(h,p){if(h.scheme!==p.scheme||!(0,e.isEqualAuthority)(h.authority,p.authority))return;if(h.scheme===i.Schemas.file){const b=y.relative(_(h),_(p));return C.isWindows?m.toSlashes(b):b}let v=h.path||"/",T=p.path||"/";if(this._ignorePathCasing(h)){let b=0;for(const o=Math.min(v.length,T.length);b<o&&!(v.charCodeAt(b)!==T.charCodeAt(b)&&v.charAt(b).toLowerCase()!==T.charAt(b).toLowerCase());b++);v=T.substr(0,b)+v.substr(b)}return y.posix.relative(v,T)}resolvePath(h,p){if(h.scheme===i.Schemas.file){const v=D.URI.file(y.resolve(_(h),p));return h.with({authority:v.authority,path:v.path})}return p=m.toPosixPath(p),h.with({path:y.posix.resolve(h.path,p)})}isAbsolutePath(h){return!!h.path&&h.path[0]==="/"}isEqualAuthority(h,p){return h===p||h!==void 0&&p!==void 0&&(0,P.equalsIgnoreCase)(h,p)}hasTrailingPathSeparator(h,p=y.sep){if(h.scheme===i.Schemas.file){const v=_(h);return v.length>m.getRoot(v).length&&v[v.length-1]===p}else{const v=h.path;return v.length>1&&v.charCodeAt(v.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(h.fsPath)}}removeTrailingPathSeparator(h,p=y.sep){return(0,e.hasTrailingPathSeparator)(h,p)?h.with({path:h.path.substr(0,h.path.length-1)}):h}addTrailingPathSeparator(h,p=y.sep){let v=!1;if(h.scheme===i.Schemas.file){const T=_(h);v=T!==void 0&&T.length===m.getRoot(T).length&&T[T.length-1]===p}else{p="/";const T=h.path;v=T.length===1&&T.charCodeAt(T.length-1)===47}return!v&&!(0,e.hasTrailingPathSeparator)(h,p)?h.with({path:h.path+"/"}):h}}e.ExtUri=I,e.extUri=new I(()=>!1),e.extUriBiasedIgnorePathCase=new I(E=>E.scheme===i.Schemas.file?!C.isLinux:!0),e.extUriIgnorePathCase=new I(E=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function L(E,h){const p=[];for(let v=0;v<E.length;v++){const T=h(E[v]);E.some((b,o)=>o===v?!1:(0,e.isEqualOrParent)(T,h(b)))||p.push(E[v])}return p}e.distinctParents=L;var A;(function(E){E.META_DATA_LABEL="label",E.META_DATA_DESCRIPTION="description",E.META_DATA_SIZE="size",E.META_DATA_MIME="mime";function h(p){const v=new Map;p.path.substring(p.path.indexOf(";")+1,p.path.lastIndexOf(";")).split(";").forEach(o=>{const[s,g]=o.split(":");s&&g&&v.set(s,g)});const b=p.path.substring(0,p.path.indexOf(";"));return b&&v.set(E.META_DATA_MIME,b),v}E.parseMetaData=h})(A=e.DataUri||(e.DataUri={}));function c(E,h,p){if(h){let v=E.path;return v&&v[0]!==y.posix.sep&&(v=y.posix.sep+v),E.with({scheme:p,authority:h,path:v})}return E.with({scheme:p})}e.toLocalResource=c}),define(ve[18],we([0,1,21,15,3,6,23,12]),function(J,e,m,i,y,C,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function _(K){return!!K&&typeof K.then=="function"}e.isThenable=_;function I(K){const G=new m.CancellationTokenSource,Q=K(G.token),Y=new Promise((fe,me)=>{const _e=G.token.onCancellationRequested(()=>{_e.dispose(),G.dispose(),me((0,i.canceled)())});Promise.resolve(Q).then(Ie=>{_e.dispose(),G.dispose(),fe(Ie)},Ie=>{_e.dispose(),G.dispose(),me(Ie)})});return new class{cancel(){G.cancel()}then(fe,me){return Y.then(fe,me)}catch(fe){return this.then(void 0,fe)}finally(fe){return Y.finally(fe)}}}e.createCancelablePromise=I;function L(K,G,Q){return Promise.race([K,new Promise(Y=>G.onCancellationRequested(()=>Y(Q)))])}e.raceCancellation=L;async function A(K){let G=-1;const Q=K.map((fe,me)=>fe.then(_e=>(G=me,_e))),Y=await Promise.race(Q);return K.forEach((fe,me)=>{me!==G&&fe.cancel()}),Y}e.raceCancellablePromises=A;function c(K,G,Q){let Y;const fe=setTimeout(()=>{Y?.(void 0),Q?.()},G);return Promise.race([K.finally(()=>clearTimeout(fe)),new Promise(me=>Y=me)])}e.raceTimeout=c;function E(K){return new Promise((G,Q)=>{const Y=K();_(Y)?Y.then(G,Q):G(Y)})}e.asPromise=E;class h{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(G){if(this.activePromise){if(this.queuedPromiseFactory=G,!this.queuedPromise){const Q=()=>{this.queuedPromise=null;const Y=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,Y};this.queuedPromise=new Promise(Y=>{this.activePromise.then(Q,Q).then(Y)})}return new Promise((Q,Y)=>{this.queuedPromise.then(Q,Y)})}return this.activePromise=G(),new Promise((Q,Y)=>{this.activePromise.then(fe=>{this.activePromise=null,Q(fe)},fe=>{this.activePromise=null,Y(fe)})})}}e.Throttler=h;class p{constructor(){this.current=Promise.resolve(null)}queue(G){return this.current=this.current.then(()=>G(),()=>G())}}e.Sequencer=p;class v{constructor(){this.promiseMap=new Map}queue(G,Q){const fe=(this.promiseMap.get(G)??Promise.resolve()).catch(()=>{}).then(Q).finally(()=>{this.promiseMap.get(G)===fe&&this.promiseMap.delete(G)});return this.promiseMap.set(G,fe),fe}}e.SequencerByKey=v;class T{constructor(G){this.defaultDelay=G,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(G,Q=this.defaultDelay){return this.task=G,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((Y,fe)=>{this.doResolve=Y,this.doReject=fe}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const Y=this.task;return this.task=null,Y()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},Q),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,i.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=T;class b{constructor(G){this.delayer=new T(G),this.throttler=new h}trigger(G,Q){return this.delayer.trigger(()=>this.throttler.queue(G),Q)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=b;class o{constructor(){this._isOpen=!1,this._promise=new Promise((G,Q)=>{this._completePromise=G})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=o;class s extends o{constructor(G){super();this._timeout=setTimeout(()=>this.open(),G)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=s;function g(K,G){return G?new Promise((Q,Y)=>{const fe=setTimeout(()=>{me.dispose(),Q()},K),me=G.onCancellationRequested(()=>{clearTimeout(fe),me.dispose(),Y((0,i.canceled)())})}):I(Q=>g(K,Q))}e.timeout=g;function l(K,G=0){const Q=setTimeout(K,G);return(0,C.toDisposable)(()=>clearTimeout(Q))}e.disposableTimeout=l;function S(K){const G=[];let Q=0;const Y=K.length;function fe(){return Q<Y?K[Q++]():null}function me(_e){_e!=null&&G.push(_e);const Ie=fe();return Ie?Ie.then(me):Promise.resolve(G)}return Promise.resolve(null).then(me)}e.sequence=S;function n(K,G=Y=>!!Y,Q=null){let Y=0;const fe=K.length,me=()=>{if(Y>=fe)return Promise.resolve(Q);const _e=K[Y++];return Promise.resolve(_e()).then(Oe=>G(Oe)?Promise.resolve(Oe):me())};return me()}e.first=n;function t(K,G=Y=>!!Y,Q=null){if(K.length===0)return Promise.resolve(Q);let Y=K.length;const fe=()=>{Y=-1;for(const me of K)me.cancel?.()};return new Promise((me,_e)=>{for(const Ie of K)Ie.then(Oe=>{--Y>=0&&G(Oe)?(fe(),me(Oe)):Y===0&&me(Q)}).catch(Oe=>{--Y>=0&&(fe(),_e(Oe))})})}e.firstParallel=t;class r{constructor(G){this._size=0,this.maxDegreeOfParalellism=G,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new y.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(G){return this._size++,new Promise((Q,Y)=>{this.outstandingPromises.push({factory:G,c:Q,e:Y}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const G=this.outstandingPromises.shift();this.runningPromises++;const Q=G.factory();Q.then(G.c,G.e),Q.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=r;class u extends r{constructor(){super(1)}}e.Queue=u;class a{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const G=new H;return this.drainers.add(G),G.p}isDrained(){for(const[,G]of this.queues)if(G.size>0)return!1;return!0}queueFor(G,Q=P.extUri){const Y=Q.getComparisonKey(G);let fe=this.queues.get(Y);return fe||(fe=new u,y.Event.once(fe.onFinished)(()=>{fe?.dispose(),this.queues.delete(Y),this.onDidQueueFinish()}),this.queues.set(Y,fe)),fe}onDidQueueFinish(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const G of this.drainers)G.complete();this.drainers.clear()}dispose(){for(const[,G]of this.queues)G.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=a;class f{constructor(G,Q){this._token=-1,typeof G=="function"&&typeof Q=="number"&&this.setIfNotSet(G,Q)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(G,Q){this.cancel(),this._token=setTimeout(()=>{this._token=-1,G()},Q)}setIfNotSet(G,Q){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,G()},Q))}}e.TimeoutTimer=f;class w{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(G,Q){this.cancel(),this._token=setInterval(()=>{G()},Q)}}e.IntervalTimer=w;class d{constructor(G,Q){this.timeoutToken=-1,this.runner=G,this.timeout=Q,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(G=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,G)}get delay(){return this.timeout}set delay(G){this.timeout=G}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=d;class k{constructor(G,Q){Q%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Q}ms is not a multiple of 1000ms.`),this.runner=G,this.timeout=Q,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(G=this.timeout){G%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${G}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(G/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=k;class R extends d{constructor(G,Q){super(G,Q);this.units=[]}work(G){this.units.push(G),this.isScheduled()||this.schedule()}doRun(){const G=this.units;this.units=[],this.runner&&this.runner(G)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=R;class N extends C.Disposable{constructor(G,Q,Y,fe){super();this.maxWorkChunkSize=G,this.maxPendingWork=Q,this.throttleDelay=Y,this.handler=fe,this.pendingWork=[],this.throttler=this._register(new C.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(G){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+G.length>this.maxPendingWork)return!1}else if(this.pending+G.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...G),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new d(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=N,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=K=>{(0,D.setTimeout0)(()=>{if(G)return;const Q=Date.now()+3;K(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,Q-Date.now())}}))});let G=!1;return{dispose(){G||(G=!0)}}}:e.runWhenIdle=(K,G)=>{const Q=requestIdleCallback(K,typeof G=="number"?{timeout:G}:void 0);let Y=!1;return{dispose(){Y||(Y=!0,cancelIdleCallback(Q))}}}}();class x{constructor(G){this._didRun=!1,this._executor=()=>{try{this._value=G()}catch(Q){this._error=Q}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=x;async function F(K,G,Q){let Y;for(let fe=0;fe<Q;fe++)try{return await K()}catch(me){Y=me,await g(G)}throw Y}e.retry=F;class B{hasPending(G){return this._pending?typeof G=="number"?this._pending.taskId===G:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(G,Q,Y){return this._pending={taskId:G,cancel:()=>Y?.(),promise:Q},Q.then(()=>this.donePending(G),()=>this.donePending(G)),Q}donePending(G){this._pending&&G===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const G=this._next;this._next=void 0,G.run().then(G.promiseResolve,G.promiseReject)}}setNext(G){if(this._next)this._next.run=G;else{let Q,Y;const fe=new Promise((me,_e)=>{Q=me,Y=_e});this._next={run:G,promise:fe,promiseResolve:Q,promiseReject:Y}}return this._next.promise}}e.TaskSequentializer=B;class O{constructor(G,Q=()=>Date.now()){this.interval=G,this.nowFn=Q,this.lastIncrementTime=0,this.value=0}increment(){const G=this.nowFn();return G-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=G,this.value=0),this.value++,this.value}}e.IntervalCounter=O;class H{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((G,Q)=>{this.completeCallback=G,this.errorCallback=Q})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(G){return new Promise(Q=>{this.completeCallback(G),this.resolved=!0,Q()})}error(G){return new Promise(Q=>{this.errorCallback(G),this.rejected=!0,Q()})}cancel(){new Promise(G=>{this.errorCallback((0,i.canceled)()),this.rejected=!0,G()})}}e.DeferredPromise=H;var M;(function(K){async function G(Y){let fe;const me=await Promise.all(Y.map(_e=>_e.then(Ie=>Ie,Ie=>{fe||(fe=Ie)})));if(typeof fe!="undefined")throw fe;return me}K.settled=G;function Q(Y){return new Promise(async(fe,me)=>{try{await Y(fe,me)}catch(_e){me(_e)}})}K.withAsyncBody=Q})(M=e.Promises||(e.Promises={}));var W;(function(K){K[K.Initial=0]="Initial",K[K.DoneOK=1]="DoneOK",K[K.DoneError=2]="DoneError"})(W||(W={}));class z{constructor(G){this._state=0,this._results=[],this._error=null,this._onStateChanged=new y.Emitter,queueMicrotask(async()=>{const Q={emitOne:Y=>this.emitOne(Y),emitMany:Y=>this.emitMany(Y),reject:Y=>this.reject(Y)};try{await Promise.resolve(G(Q)),this.resolve()}catch(Y){this.reject(Y)}finally{Q.emitOne=void 0,Q.emitMany=void 0,Q.reject=void 0}})}static fromArray(G){return new z(Q=>{Q.emitMany(G)})}static fromPromise(G){return new z(async Q=>{Q.emitMany(await G)})}static fromPromises(G){return new z(async Q=>{await Promise.all(G.map(async Y=>Q.emitOne(await Y)))})}static merge(G){return new z(async Q=>{await Promise.all(G.map(async Y=>{for await(const fe of Y)Q.emitOne(fe)}))})}[Symbol.asyncIterator](){let G=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(G<this._results.length)return{done:!1,value:this._results[G++]};if(this._state===1)return{done:!0,value:void 0};await y.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(G,Q){return new z(async Y=>{for await(const fe of G)Y.emitOne(Q(fe))})}map(G){return z.map(this,G)}static filter(G,Q){return new z(async Y=>{for await(const fe of G)Q(fe)&&Y.emitOne(fe)})}filter(G){return z.filter(this,G)}static coalesce(G){return z.filter(G,Q=>!!Q)}coalesce(){return z.coalesce(this)}static async toPromise(G){const Q=[];for await(const Y of G)Q.push(Y);return Q}toPromise(){return z.toPromise(this)}emitOne(G){this._state===0&&(this._results.push(G),this._onStateChanged.fire())}emitMany(G){this._state===0&&(this._results=this._results.concat(G),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(G){this._state===0&&(this._state=2,this._error=G,this._onStateChanged.fire())}}e.AsyncIterableObject=z,z.EMPTY=z.fromArray([]);class U extends z{constructor(G,Q){super(Q);this._source=G}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=U;function V(K){const G=new m.CancellationTokenSource,Q=K(G.token);return new U(G,async Y=>{const fe=G.token.onCancellationRequested(()=>{fe.dispose(),G.dispose(),Y.reject((0,i.canceled)())});try{for await(const me of Q){if(G.token.isCancellationRequested)return;Y.emitOne(me)}fe.dispose(),G.dispose()}catch(me){fe.dispose(),G.dispose(),Y.reject(me)}})}e.createCancelableAsyncIterable=V}),define(ve[99],we([0,1,18,9]),function(J,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const y=new m.IdleValue(()=>{const w=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:w,collatorIsNumeric:w.resolvedOptions().numeric}}),C=new m.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),P=new m.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function D(w,d,k=!1){const R=w||"",N=d||"",x=y.value.collator.compare(R,N);return y.value.collatorIsNumeric&&x===0&&R!==N?R<N?-1:1:x}e.compareFileNames=D;function _(w,d){const k=C.value.collator;return w=w||"",d=d||"",g(k,w,d)}e.compareFileNamesDefault=_;function I(w,d){const k=C.value.collator;return w=w||"",d=d||"",t(w,d)||g(k,w,d)}e.compareFileNamesUpper=I;function L(w,d){const k=C.value.collator;return w=w||"",d=d||"",n(w,d)||g(k,w,d)}e.compareFileNamesLower=L;function A(w,d){return w=w||"",d=d||"",w===d?0:w<d?-1:1}e.compareFileNamesUnicode=A;function c(w,d,k=!1){k||(w=w&&w.toLowerCase(),d=d&&d.toLowerCase());const[R,N]=o(w),[x,F]=o(d);return R!==x?R<x?-1:1:N===F?0:N<F?-1:1}e.noIntlCompareFileNames=c;function E(w,d){const[k,R]=o(w),[N,x]=o(d);let F=y.value.collator.compare(R,x);if(F===0){if(y.value.collatorIsNumeric&&R!==x)return R<x?-1:1;if(F=y.value.collator.compare(k,N),y.value.collatorIsNumeric&&F===0&&k!==N)return k<N?-1:1}return F}e.compareFileExtensions=E;function h(w,d){w=w||"",d=d||"";const k=s(w),R=s(d),N=C.value.collator,x=P.value.collator;return g(x,k,R)||g(N,w,d)}e.compareFileExtensionsDefault=h;function p(w,d){w=w||"",d=d||"";const k=s(w),R=s(d),N=C.value.collator,x=P.value.collator;return g(x,k,R)||t(w,d)||g(N,w,d)}e.compareFileExtensionsUpper=p;function v(w,d){w=w||"",d=d||"";const k=s(w),R=s(d),N=C.value.collator,x=P.value.collator;return g(x,k,R)||n(w,d)||g(N,w,d)}e.compareFileExtensionsLower=v;function T(w,d){w=w||"",d=d||"";const k=s(w).toLowerCase(),R=s(d).toLowerCase();return k!==R?k<R?-1:1:w!==d?w<d?-1:1:0}e.compareFileExtensionsUnicode=T;const b=/^(.*?)(\.([^.]*))?$/;function o(w,d=!1){const k=w?b.exec(w):[];let R=[k&&k[1]||"",k&&k[3]||""];return d&&(!R[0]&&R[1]||R[0]&&R[0].charAt(0)===".")&&(R=[R[0]+"."+R[1],""]),R}function s(w){const d=w?b.exec(w):[];return d&&d[1]&&d[1].charAt(0)!=="."&&d[3]||""}function g(w,d,k){let R=w.compare(d,k);return R!==0?R:d.length!==k.length?d.length<k.length?-1:1:0}function l(w){const d=w.charAt(0);return d.toLocaleUpperCase()!==d}function S(w){const d=w.charAt(0);return d.toLocaleLowerCase()!==d}function n(w,d){return l(w)&&S(d)?-1:S(w)&&l(d)?1:0}function t(w,d){return S(w)&&l(d)?-1:l(w)&&S(d)?1:0}function r(w,d,k=!1){return k||(w=w&&w.toLowerCase(),d=d&&d.toLowerCase()),w===d?0:w<d?-1:1}function u(w,d,k=!1){const R=w.split(i.sep),N=d.split(i.sep),x=R.length-1,F=N.length-1;let B,O;for(let H=0;;H++){if(B=x===H,O=F===H,B&&O)return D(R[H],N[H],k);if(B)return-1;if(O)return 1;const M=r(R[H],N[H],k);if(M!==0)return M}}e.comparePaths=u;function a(w,d,k){const R=w.toLowerCase(),N=d.toLowerCase(),x=f(w,d,k);if(x)return x;const F=R.endsWith(k),B=N.endsWith(k);if(F!==B)return F?-1:1;const O=D(R,N);return O!==0?O:R.localeCompare(N)}e.compareAnything=a;function f(w,d,k){const R=w.toLowerCase(),N=d.toLowerCase(),x=R.startsWith(k),F=N.startsWith(k);if(x!==F)return x?-1:1;if(x&&F){if(R.length<N.length)return-1;if(R.length>N.length)return 1}return 0}e.compareByPrefix=f}),define(ve[100],we([0,1,99,96,47,9,12,8]),function(J,e,m,i,y,C,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const _=0,I=[_,[]];function L(M,W,z,U){if(!M||!W)return I;const V=M.length,K=W.length;if(V<K)return I;const G=M.toLowerCase();return A(W,z,K,M,G,V,U)}e.scoreFuzzy=L;function A(M,W,z,U,V,K,G){const Q=[],Y=[];for(let Ie=0;Ie<z;Ie++){const Oe=Ie*K,We=Oe-K,j=Ie>0,Z=M[Ie],re=W[Ie];for(let ue=0;ue<K;ue++){const te=ue>0,oe=Oe+ue,Ee=oe-1,Ne=We+ue-1,Ve=te?Q[Ee]:0,Ge=j&&te?Q[Ne]:0,Je=j&&te?Y[Ne]:0;let tt;!Ge&&j?tt=0:tt=c(Z,re,U,V,ue,Je),tt&&Ge+tt>=Ve&&(G||j||V.startsWith(W,ue))?(Y[oe]=Je+1,Q[oe]=Ge+tt):(Y[oe]=_,Q[oe]=Ve)}}const fe=[];let me=z-1,_e=K-1;for(;me>=0&&_e>=0;){const Ie=me*K+_e;Y[Ie]===_||(fe.push(_e),me--),_e--}return[Q[z*K-1],fe.reverse()]}function c(M,W,z,U,V,K){let G=0;if(!E(W,U[V]))return G;if(G+=1,K>0&&(G+=K*5),M===z[V]&&(G+=1),V===0)G+=8;else{const Q=h(z.charCodeAt(V-1));Q?G+=Q:(0,i.isUpper)(z.charCodeAt(V))&&K===0&&(G+=2)}return G}function E(M,W){return M===W?!0:M==="/"||M==="\\"?W==="/"||W==="\\":!1}function h(M){switch(M){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const p=[void 0,[]];function v(M,W,z=0,U=0){const V=W;return V.values&&V.values.length>1?T(M,V.values,z,U):b(M,W,z,U)}e.scoreFuzzy2=v;function T(M,W,z,U){let V=0;const K=[];for(const G of W){const[Q,Y]=b(M,G,z,U);if(typeof Q!="number")return p;V+=Q,K.push(...Y)}return[V,f(K)]}function b(M,W,z,U){const V=(0,i.fuzzyScore)(W.original,W.originalLowercase,z,M,M.toLowerCase(),U,!0);return V?[V[0],(0,i.createMatches)(V)]:p}const o=Object.freeze({score:0}),s=1<<18,g=1<<17,l=1<<16;function S(M,W,z,U){const V=U.values?U.values:[U];return(0,y.hash)({[U.normalized]:{values:V.map(G=>({value:G.normalized,expectContiguousMatch:G.expectContiguousMatch})),label:M,description:W,allowNonContiguousMatches:z}})}function n(M,W,z,U,V){if(!M||!W.normalized)return o;const K=U.getItemLabel(M);if(!K)return o;const G=U.getItemDescription(M),Q=S(K,G,z,W),Y=V[Q];if(Y)return Y;const fe=t(K,G,U.getItemPath(M),W,z);return V[Q]=fe,fe}e.scoreItemFuzzy=n;function t(M,W,z,U,V){const K=!z||!U.containsPathSeparator;return z&&(P.isLinux?U.pathNormalized===z:(0,D.equalsIgnoreCase)(U.pathNormalized,z))?{score:s,labelMatch:[{start:0,end:M.length}],descriptionMatch:W?[{start:0,end:W.length}]:void 0}:U.values&&U.values.length>1?r(M,W,z,U.values,K,V):u(M,W,z,U,K,V)}function r(M,W,z,U,V,K){let G=0;const Q=[],Y=[];for(const fe of U){const{score:me,labelMatch:_e,descriptionMatch:Ie}=u(M,W,z,fe,V,K);if(me===_)return o;G+=me,_e&&Q.push(..._e),Ie&&Y.push(...Ie)}return{score:G,labelMatch:f(Q),descriptionMatch:f(Y)}}function u(M,W,z,U,V,K){if(V||!W){const[G,Q]=L(M,U.normalized,U.normalizedLowercase,K&&!U.expectContiguousMatch);if(G){const Y=(0,i.matchesPrefix)(U.normalized,M);let fe;return Y?(fe=g,fe+=Math.round(U.normalized.length/M.length*100)):fe=l,{score:fe+G,labelMatch:Y||a(Q)}}}if(W){let G=W;z&&(G=`${W}${C.sep}`);const Q=G.length,Y=`${G}${M}`,[fe,me]=L(Y,U.normalized,U.normalizedLowercase,K&&!U.expectContiguousMatch);if(fe){const _e=a(me),Ie=[],Oe=[];return _e.forEach(We=>{We.start<Q&&We.end>Q?(Ie.push({start:0,end:We.end-Q}),Oe.push({start:We.start,end:Q})):We.start>=Q?Ie.push({start:We.start-Q,end:We.end-Q}):Oe.push(We)}),{score:fe,labelMatch:Ie,descriptionMatch:Oe}}}return o}function a(M){const W=[];if(!M)return W;let z;for(const U of M)z&&z.end===U?z.end+=1:(z={start:U,end:U+1},W.push(z));return W}function f(M){const W=M.sort((V,K)=>V.start-K.start),z=[];let U;for(const V of W)!U||!w(U,V)?(U=V,z.push(V)):(U.start=Math.min(U.start,V.start),U.end=Math.max(U.end,V.end));return z}function w(M,W){return!(M.end<W.start||W.end<M.start)}function d(M,W,z,U,V,K){const G=n(M,z,U,V,K),Q=n(W,z,U,V,K),Y=G.score,fe=Q.score;if((Y===s||fe===s)&&Y!==fe)return Y===s?-1:1;if(Y>l||fe>l){if(Y!==fe)return Y>fe?-1:1;if(Y<g&&fe<g){const Z=R(G.labelMatch,Q.labelMatch);if(Z!==0)return Z}const We=V.getItemLabel(M)||"",j=V.getItemLabel(W)||"";if(We.length!==j.length)return We.length-j.length}if(Y!==fe)return Y>fe?-1:1;const me=Array.isArray(G.labelMatch)&&G.labelMatch.length>0,_e=Array.isArray(Q.labelMatch)&&Q.labelMatch.length>0;if(me&&!_e)return-1;if(_e&&!me)return 1;const Ie=k(M,G,V),Oe=k(W,Q,V);return Ie&&Oe&&Ie!==Oe?Oe>Ie?-1:1:N(M,W,z,V)}e.compareItemsByFuzzyScore=d;function k(M,W,z){let U=-1,V=-1;if(W.descriptionMatch&&W.descriptionMatch.length?U=W.descriptionMatch[0].start:W.labelMatch&&W.labelMatch.length&&(U=W.labelMatch[0].start),W.labelMatch&&W.labelMatch.length){if(V=W.labelMatch[W.labelMatch.length-1].end,W.descriptionMatch&&W.descriptionMatch.length){const K=z.getItemDescription(M);K&&(V+=K.length)}}else W.descriptionMatch&&W.descriptionMatch.length&&(V=W.descriptionMatch[W.descriptionMatch.length-1].end);return V-U}function R(M,W){if(!M&&!W||(!M||!M.length)&&(!W||!W.length))return 0;if(!W||!W.length)return-1;if(!M||!M.length)return 1;const z=M[0].start,V=M[M.length-1].end-z,K=W[0].start,Q=W[W.length-1].end-K;return V===Q?0:Q<V?1:-1}function N(M,W,z,U){const V=U.getItemLabel(M)||"",K=U.getItemLabel(W)||"",G=U.getItemDescription(M),Q=U.getItemDescription(W),Y=V.length+(G?G.length:0),fe=K.length+(Q?Q.length:0);if(Y!==fe)return Y-fe;const me=U.getItemPath(M),_e=U.getItemPath(W);return me&&_e&&me.length!==_e.length?me.length-_e.length:V!==K?(0,m.compareAnything)(V,K,z.normalized):G&&Q&&G!==Q?(0,m.compareAnything)(G,Q,z.normalized):me&&_e&&me!==_e?(0,m.compareAnything)(me,_e,z.normalized):0}function x(M){return M.startsWith('"')&&M.endsWith('"')}const F=" ";function B(M){typeof M!="string"&&(M="");const W=M.toLowerCase(),{pathNormalized:z,normalized:U,normalizedLowercase:V}=O(M),K=z.indexOf(C.sep)>=0,G=x(M);let Q;const Y=M.split(F);if(Y.length>1)for(const fe of Y){const me=x(fe),{pathNormalized:_e,normalized:Ie,normalizedLowercase:Oe}=O(fe);Ie&&(Q||(Q=[]),Q.push({original:fe,originalLowercase:fe.toLowerCase(),pathNormalized:_e,normalized:Ie,normalizedLowercase:Oe,expectContiguousMatch:me}))}return{original:M,originalLowercase:W,pathNormalized:z,normalized:U,normalizedLowercase:V,values:Q,containsPathSeparator:K,expectContiguousMatch:G}}e.prepareQuery=B;function O(M){let W;P.isWindows?W=M.replace(/\//g,C.sep):W=M.replace(/\\/g,C.sep);const z=(0,D.stripWildcards)(W).replace(/\s|"/g,"");return{pathNormalized:W,normalized:z,normalizedLowercase:z.toLowerCase()}}function H(M){return Array.isArray(M)?B(M.map(W=>W.original).join(F)):B(M.original)}e.pieceToQuery=H}),define(ve[31],we([0,1,18,30,24,9,8]),function(J,e,m,i,y,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function D(){return Object.create(null)}e.getEmptyExpression=D;const _="**",I="/",L="[/\\\\]",A="[^/\\\\]",c=/\//g;function E(U){switch(U){case 0:return"";case 1:return`${A}*?`;default:return`(?:${L}|${A}+${L}|${L}${A}+)*?`}}function h(U,V){if(!U)return[];const K=[];let G=!1,Q=!1,Y="";for(const fe of U){switch(fe){case V:if(!G&&!Q){K.push(Y),Y="";continue}break;case"{":G=!0;break;case"}":G=!1;break;case"[":Q=!0;break;case"]":Q=!1;break}Y+=fe}return Y&&K.push(Y),K}e.splitGlobAware=h;function p(U){if(!U)return"";let V="";const K=h(U,I);if(K.every(G=>G===_))V=".*";else{let G=!1;K.forEach((Q,Y)=>{if(Q===_){G||(V+=E(2),G=!0);return}let fe=!1,me="",_e=!1,Ie="";for(const Oe of Q){if(Oe!=="}"&&fe){me+=Oe;continue}if(_e&&(Oe!=="]"||!Ie)){let We;Oe==="-"?We=Oe:(Oe==="^"||Oe==="!")&&!Ie?We="^":Oe===I?We="":We=P.escapeRegExpCharacters(Oe),Ie+=We;continue}switch(Oe){case"{":fe=!0;continue;case"[":_e=!0;continue;case"}":V+=`(?:${h(me,",").map(Z=>p(Z)).join("|")})`,fe=!1,me="";break;case"]":V+="["+Ie+"]",_e=!1,Ie="";break;case"?":V+=A;continue;case"*":V+=E(1);continue;default:V+=P.escapeRegExpCharacters(Oe)}}Y<K.length-1&&(K[Y+1]!==_||Y+2<K.length)&&(V+=L),G=!1})}return V}const v=/^\*\*\/\*\.[\w\.-]+$/,T=/^\*\*\/([\w\.-]+)\/?$/,b=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,o=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,s=/^\*\*((\/[\w\.-]+)+)\/?$/,g=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,l=new y.LRUCache(1e4),S=function(){return!1},n=function(){return null};function t(U,V){if(!U)return n;let K;typeof U!="string"?K=U.pattern:K=U,K=K.trim();const G=`${K}_${!!V.trimForExclusions}`;let Q=l.get(G);if(Q)return r(Q,U);let Y;if(v.test(K)){const fe=K.substr(4);Q=function(me,_e){return typeof me=="string"&&me.endsWith(fe)?K:null}}else(Y=T.exec(u(K,V)))?Q=a(Y[1],K):(V.trimForExclusions?o:b).test(K)?Q=f(K,V):(Y=s.exec(u(K,V)))?Q=w(Y[1].substr(1),K,!0):(Y=g.exec(u(K,V)))?Q=w(Y[1],K,!1):Q=d(K);return l.set(G,Q),r(Q,U)}function r(U,V){return typeof V=="string"?U:function(K,G){return i.isEqualOrParent(K,V.base)?U(C.relative(V.base,K),G):null}}function u(U,V){return V.trimForExclusions&&U.endsWith("/**")?U.substr(0,U.length-2):U}function a(U,V){const K=`/${U}`,G=`\\${U}`,Q=function(fe,me){return typeof fe!="string"?null:me?me===U?V:null:fe===U||fe.endsWith(K)||fe.endsWith(G)?V:null},Y=[U];return Q.basenames=Y,Q.patterns=[V],Q.allBasenames=Y,Q}function f(U,V){const K=z(U.slice(1,-1).split(",").map(me=>t(me,V)).filter(me=>me!==n),U),G=K.length;if(!G)return n;if(G===1)return K[0];const Q=function(me,_e){for(let Ie=0,Oe=K.length;Ie<Oe;Ie++)if(K[Ie](me,_e))return U;return null},Y=K.find(me=>!!me.allBasenames);Y&&(Q.allBasenames=Y.allBasenames);const fe=K.reduce((me,_e)=>_e.allPaths?me.concat(_e.allPaths):me,[]);return fe.length&&(Q.allPaths=fe),Q}function w(U,V,K){const G=C.sep===C.posix.sep,Q=G?U:U.replace(c,C.sep),Y=C.sep+Q,fe=C.posix.sep+U,me=K?function(_e,Ie){return typeof _e=="string"&&(_e===Q||_e.endsWith(Y)||!G&&(_e===U||_e.endsWith(fe)))?V:null}:function(_e,Ie){return typeof _e=="string"&&(_e===Q||!G&&_e===U)?V:null};return me.allPaths=[(K?"*/":"./")+U],me}function d(U){try{const V=new RegExp(`^${p(U)}$`);return function(K){return V.lastIndex=0,typeof K=="string"&&V.test(K)?U:null}}catch{return n}}function k(U,V,K){return!U||typeof V!="string"?!1:R(U)(V,void 0,K)}e.match=k;function R(U,V={}){if(!U)return S;if(typeof U=="string"||B(U)){const K=t(U,V);if(K===n)return S;const G=function(Q,Y){return!!K(Q,Y)};return K.allBasenames&&(G.allBasenames=K.allBasenames),K.allPaths&&(G.allPaths=K.allPaths),G}return M(U,V)}e.parse=R;function N(U){if(!U)return;let V;return K=>(V||(V=(U()||Promise.resolve([])).then(G=>G?F(G):{})),V.then(G=>!!G[K]))}e.hasSiblingPromiseFn=N;function x(U){if(!U)return;let V;return K=>{if(!V){const G=U();V=G?F(G):{}}return!!V[K]}}e.hasSiblingFn=x;function F(U){const V={};for(const K of U)V[K]=!0;return V}function B(U){const V=U;return V&&typeof V.base=="string"&&typeof V.pattern=="string"}e.isRelativePattern=B;function O(U){return U.allBasenames||[]}e.getBasenameTerms=O;function H(U){return U.allPaths||[]}e.getPathTerms=H;function M(U,V){const K=z(Object.getOwnPropertyNames(U).map(me=>W(me,U[me],V)).filter(me=>me!==n)),G=K.length;if(!G)return n;if(!K.some(me=>!!me.requiresSiblings)){if(G===1)return K[0];const me=function(Oe,We){for(let j=0,Z=K.length;j<Z;j++){const re=K[j](Oe,We);if(re)return re}return null},_e=K.find(Oe=>!!Oe.allBasenames);_e&&(me.allBasenames=_e.allBasenames);const Ie=K.reduce((Oe,We)=>We.allPaths?Oe.concat(We.allPaths):Oe,[]);return Ie.length&&(me.allPaths=Ie),me}const Q=function(me,_e,Ie){let Oe;for(let We=0,j=K.length;We<j;We++){const Z=K[We];Z.requiresSiblings&&Ie&&(_e||(_e=C.basename(me)),Oe||(Oe=_e.substr(0,_e.length-C.extname(me).length)));const re=Z(me,_e,Oe,Ie);if(re)return re}return null},Y=K.find(me=>!!me.allBasenames);Y&&(Q.allBasenames=Y.allBasenames);const fe=K.reduce((me,_e)=>_e.allPaths?me.concat(_e.allPaths):me,[]);return fe.length&&(Q.allPaths=fe),Q}function W(U,V,K){if(V===!1)return n;const G=t(U,K);if(G===n)return n;if(typeof V=="boolean")return G;if(V){const Q=V.when;if(typeof Q=="string"){const Y=(fe,me,_e,Ie)=>{if(!Ie||!G(fe,me))return null;const Oe=Q.replace("$(basename)",_e),We=Ie(Oe);return(0,m.isThenable)(We)?We.then(j=>j?U:null):We?U:null};return Y.requiresSiblings=!0,Y}}return G}function z(U,V){const K=U.filter(me=>!!me.basenames);if(K.length<2)return U;const G=K.reduce((me,_e)=>{const Ie=_e.basenames;return Ie?me.concat(Ie):me},[]);let Q;if(V){Q=[];for(let me=0,_e=G.length;me<_e;me++)Q.push(V)}else Q=K.reduce((me,_e)=>{const Ie=_e.patterns;return Ie?me.concat(Ie):me},[]);const Y=function(me,_e){if(typeof me!="string")return null;if(!_e){let Oe;for(Oe=me.length;Oe>0;Oe--){const We=me.charCodeAt(Oe-1);if(We===47||We===92)break}_e=me.substr(Oe)}const Ie=G.indexOf(_e);return Ie!==-1?Q[Ie]:null};Y.basenames=G,Y.patterns=Q,Y.allBasenames=G;const fe=U.filter(me=>!me.basenames);return fe.push(Y),fe}}),define(ve[80],we([0,1,30,10,9,12,23,8,2]),function(J,e,m,i,y,C,P,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function I(t,r,u){if(typeof t=="string"&&(t=_.URI.file(t)),u){const f=u.getWorkspaceFolder(t);if(f){const w=u.getWorkspace().folders.length>1;let d;if((0,P.isEqual)(f.uri,t)?d="":d=(0,P.relativePath)(f.uri,t),w){const k=f.name?f.name:(0,P.basename)(f.uri);d=d?k+" \u2022 "+d:k}return d}}if(t.scheme!==i.Schemas.file&&t.scheme!==i.Schemas.untitled)return t.with({query:null,fragment:null}).toString(!0);if((0,m.hasDriveLetter)(t.fsPath))return(0,y.normalize)(A(t.fsPath));let a=(0,y.normalize)(t.fsPath);return!C.isWindows&&r?.userHome&&(a=E(a,r.userHome.fsPath)),a}e.getPathLabel=I;function L(t){if(!t)return;typeof t=="string"&&(t=_.URI.file(t));const r=(0,P.basename)(t)||(t.scheme===i.Schemas.file?t.fsPath:t.path);return C.isWindows&&(0,m.isRootOrDriveLetter)(r)?A(r):r}e.getBaseLabel=L;function A(t,r){return(0,m.hasDriveLetter)(t,r)?t.charAt(0).toUpperCase()+t.slice(1):t}e.normalizeDriveLetter=A;let c=Object.create(null);function E(t,r){if(C.isWindows||!t||!r)return t;let u=c.original===r?c.normalized:void 0;return u||(u=`${(0,D.rtrim)(r,y.posix.sep)}${y.posix.sep}`,c={original:r,normalized:u}),(C.isLinux?t.startsWith(u):(0,D.startsWithIgnoreCase)(t,u))&&(t=`~/${t.substr(u.length)}`),t}e.tildify=E;function h(t,r){return t.replace(/^~($|\/|\\)/,`${r}$1`)}e.untildify=h;const p="\u2026",v="\\\\",T="~";function b(t,r=y.sep){const u=new Array(t.length);let a=!1;for(let f=0;f<t.length;f++){let w=t[f];if(w===""){u[f]=`.${r}`;continue}if(!w){u[f]=w;continue}a=!0;let d="";w.indexOf(v)===0?(d=w.substr(0,w.indexOf(v)+v.length),w=w.substr(w.indexOf(v)+v.length)):w.indexOf(r)===0?(d=w.substr(0,w.indexOf(r)+r.length),w=w.substr(w.indexOf(r)+r.length)):w.indexOf(T)===0&&(d=w.substr(0,w.indexOf(T)+T.length),w=w.substr(w.indexOf(T)+T.length));const k=w.split(r);for(let R=1;a&&R<=k.length;R++)for(let N=k.length-R;a&&N>=0;N--){a=!1;let x=k.slice(N,N+R).join(r);for(let F=0;!a&&F<t.length;F++)if(F!==f&&t[F]&&t[F].indexOf(x)>-1){const B=N+R===k.length,O=N>0&&t[F].indexOf(r)>-1?r+x:x,H=t[F].endsWith(O);a=!B||H}if(!a){let F="";(k[0].endsWith(":")||d!=="")&&(N===1&&(N=0,R++,x=k[0]+r+x),N>0&&(F=k[0]+r),F=d+F),N>0&&(F=F+p+r),F=F+x,N+R<k.length&&(F=F+r+p),u[f]=F}}a&&(u[f]=w)}return u}e.shorten=b;var o;(function(t){t[t.TEXT=0]="TEXT",t[t.VARIABLE=1]="VARIABLE",t[t.SEPARATOR=2]="SEPARATOR"})(o||(o={}));function s(t,r=Object.create(null)){const u=[];let a=!1,f="";for(const w of t)if(w==="$"||a&&w==="{")f&&u.push({value:f,type:o.TEXT}),f="",a=!0;else if(w==="}"&&a){const d=r[f];if(typeof d=="string")d.length&&u.push({value:d,type:o.VARIABLE});else if(d){const k=u[u.length-1];(!k||k.type!==o.SEPARATOR)&&u.push({value:d.label,type:o.SEPARATOR})}f="",a=!1}else f+=w;return f&&!a&&u.push({value:f,type:o.TEXT}),u.filter((w,d)=>{if(w.type===o.SEPARATOR){const k=u[d-1],R=u[d+1];return[k,R].every(N=>N&&(N.type===o.VARIABLE||N.type===o.TEXT)&&N.value.length>0)}return!0}).map(w=>w.value).join("")}e.template=s;function g(t,r){return C.isMacintosh||r?t.replace(/\(&&\w\)|&&/g,"").replace(/&/g,C.isMacintosh?"&":"&&"):t.replace(/&&|&/g,u=>u==="&"?"&&":"&")}e.mnemonicMenuLabel=g;function l(t,r){return C.isMacintosh||r?t.replace(/\(&&\w\)|&&/g,""):C.isWindows?t.replace(/&&|&/g,u=>u==="&"?"&&":"&"):t.replace(/&&/g,"_")}e.mnemonicButtonLabel=l;function S(t){return t.replace(/&/g,"&&")}e.unmnemonicLabel=S;function n(t){const r=t.indexOf("/")!==-1?y.posix:y.win32,u=r.basename(t),a=r.dirname(t);return u.length?{name:u,parentPath:a}:{name:a,parentPath:""}}e.splitName=n}),define(ve[101],we([0,1,31,10,9,23,8]),function(J,e,m,i,y,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var D;(function(t){t.text="text/plain",t.binary="application/octet-stream",t.unknown="application/unknown",t.markdown="text/markdown",t.latex="text/latex"})(D=e.Mimes||(e.Mimes={}));let _=[],I=[],L=[];function A(t,r=!1){const u=c(t);_.push(u),u.userConfigured?L.push(u):I.push(u),r&&!u.userConfigured&&_.forEach(a=>{a.mime===u.mime||a.userConfigured||(u.extension&&a.extension===u.extension&&console.warn(`Overwriting extension <<${u.extension}>> to now point to mime <<${u.mime}>>`),u.filename&&a.filename===u.filename&&console.warn(`Overwriting filename <<${u.filename}>> to now point to mime <<${u.mime}>>`),u.filepattern&&a.filepattern===u.filepattern&&console.warn(`Overwriting filepattern <<${u.filepattern}>> to now point to mime <<${u.mime}>>`),u.firstline&&a.firstline===u.firstline&&console.warn(`Overwriting firstline <<${u.firstline}>> to now point to mime <<${u.mime}>>`))})}e.registerTextMime=A;function c(t){return{id:t.id,mime:t.mime,filename:t.filename,extension:t.extension,filepattern:t.filepattern,firstline:t.firstline,userConfigured:t.userConfigured,filenameLowercase:t.filename?t.filename.toLowerCase():void 0,extensionLowercase:t.extension?t.extension.toLowerCase():void 0,filepatternLowercase:t.filepattern?(0,m.parse)(t.filepattern.toLowerCase()):void 0,filepatternOnPath:t.filepattern?t.filepattern.indexOf(y.posix.sep)>=0:!1}}function E(t){t?(_=_.filter(r=>!r.userConfigured),L=[]):(_=[],I=[],L=[])}e.clearTextMimes=E;function h(t,r){let u;if(t)switch(t.scheme){case i.Schemas.file:u=t.fsPath;break;case i.Schemas.data:u=C.DataUri.parseMetaData(t).get(C.DataUri.META_DATA_LABEL);break;default:u=t.path}if(!u)return[D.unknown];u=u.toLowerCase();const a=(0,y.basename)(u),f=p(u,a,L);if(f)return[f,D.text];const w=p(u,a,I);if(w)return[w,D.text];if(r){const d=v(r);if(d)return[d,D.text]}return[D.unknown]}e.guessMimeTypes=h;function p(t,r,u){let a=null,f=null,w=null;for(let d=u.length-1;d>=0;d--){const k=u[d];if(r===k.filenameLowercase){a=k;break}if(k.filepattern&&(!f||k.filepattern.length>f.filepattern.length)){const R=k.filepatternOnPath?t:r;k.filepatternLowercase?.(R)&&(f=k)}k.extension&&(!w||k.extension.length>w.extension.length)&&r.endsWith(k.extensionLowercase)&&(w=k)}return a?a.mime:f?f.mime:w?w.mime:null}function v(t){if((0,P.startsWithUTF8BOM)(t)&&(t=t.substr(1)),t.length>0)for(let r=_.length-1;r>=0;r--){const u=_[r];if(!u.firstline)continue;const a=t.match(u.firstline);if(a&&a.length>0)return u.mime}return null}function T(t){return t?typeof t=="string"?t===D.binary||t===D.text||t===D.unknown:t.length===1&&T(t[0]):!0}e.isUnspecific=T;const b={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},o={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function s(t){const r=(0,y.extname)(t),u=b[r.toLowerCase()];return u!==void 0?u:g(t)}e.getMediaOrTextMime=s;function g(t){const r=(0,y.extname)(t);return o[r.toLowerCase()]}e.getMediaMime=g;function l(t){for(const r in o)if(o[r]===t)return r}e.getExtensionForMimeType=l;const S=/^(.+)\/(.+?)(;.+)?$/;function n(t,r){const u=S.exec(t);return u?`${u[1].toLowerCase()}/${u[2].toLowerCase()}${u[3]??""}`:r?void 0:t}e.normalizeMimeType=n}),define(ve[102],we([0,1,2]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function i(L){return L.toJSON()}class y{constructor(A){this._uriTransformer=A}transformIncoming(A){const c=this._uriTransformer.transformIncoming(A);return c===A?A:i(m.URI.from(c))}transformOutgoing(A){const c=this._uriTransformer.transformOutgoing(A);return c===A?A:i(m.URI.from(c))}transformOutgoingURI(A){const c=this._uriTransformer.transformOutgoing(A);return c===A?A:m.URI.from(c)}transformOutgoingScheme(A){return this._uriTransformer.transformOutgoingScheme(A)}}e.URITransformer=y,e.DefaultURITransformer=new class{transformIncoming(L){return L}transformOutgoing(L){return L}transformOutgoingURI(L){return L}transformOutgoingScheme(L){return L}};function C(L,A,c){if(!L||c>200)return null;if(typeof L=="object"){if(L instanceof m.URI)return A.transformOutgoing(L);for(let E in L)if(Object.hasOwnProperty.call(L,E)){const h=C(L[E],A,c+1);h!==null&&(L[E]=h)}}return null}function P(L,A){const c=C(L,A,0);return c===null?L:c}e.transformOutgoingURIs=P;function D(L,A,c,E){if(!L||E>200)return null;if(typeof L=="object"){if(L.$mid===1)return c?m.URI.revive(A.transformIncoming(L)):A.transformIncoming(L);for(let h in L)if(Object.hasOwnProperty.call(L,h)){const p=D(L[h],A,c,E+1);p!==null&&(L[h]=p)}}return null}function _(L,A){const c=D(L,A,!1,0);return c===null?L:c}e.transformIncomingURIs=_;function I(L,A){const c=D(L,A,!0,0);return c===null?L:c}e.transformAndReviveIncomingURIs=I}),define(ve[32],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const m=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function i(_){return m.test(_)}e.isUUID=i;const y=new Uint8Array(16),C=[];for(let _=0;_<256;_++)C.push(_.toString(16).padStart(2,"0"));let P;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?P=crypto.getRandomValues.bind(crypto):P=function(_){for(let I=0;I<_.length;I++)_[I]=Math.floor(Math.random()*256);return _};function D(){P(y),y[6]=y[6]&15|64,y[8]=y[8]&63|128;let _=0,I="";return I+=C[y[_++]],I+=C[y[_++]],I+=C[y[_++]],I+=C[y[_++]],I+="-",I+=C[y[_++]],I+=C[y[_++]],I+="-",I+=C[y[_++]],I+=C[y[_++]],I+="-",I+=C[y[_++]],I+=C[y[_++]],I+="-",I+=C[y[_++]],I+=C[y[_++]],I+=C[y[_++]],I+=C[y[_++]],I+=C[y[_++]],I+=C[y[_++]],I}e.generateUuid=D}),define(ve[142],we([0,1,103]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class i{constructor(C="utf8"){this.stringDecoder=new m.StringDecoder(C),this.remaining=null}write(C){const P=[],D=this.remaining?this.remaining+this.stringDecoder.write(C):this.stringDecoder.write(C);if(D.length<1)return P;let _=0,I,L=_;for(;L<D.length;)if(I=D.charCodeAt(L),I===13||I===10){if(P.push(D.substring(_,L)),L++,L<D.length){const A=I;I=D.charCodeAt(L),(A===13&&I===10||A===10&&I===13)&&L++}_=L}else L++;return this.remaining=_<D.length?D.substr(_):null,P}end(){return this.remaining}}e.LineDecoder=i}),define(ve[28],we([0,1,60,81,289,18,30,79,9,12,23,2,32]),function(J,e,m,i,y,C,P,D,_,I,L,A,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var E;(function(O){O[O.UNLINK=0]="UNLINK",O[O.MOVE=1]="MOVE"})(E=e.RimRafMode||(e.RimRafMode={}));async function h(O,H=E.UNLINK){if((0,P.isRootOrDriveLetter)(O))throw new Error("rimraf - will refuse to recursively delete root");return H===E.UNLINK?v(O):p(O)}async function p(O){try{const H=(0,_.join)((0,i.tmpdir)(),(0,c.generateUuid)());try{await e.Promises.rename(O,H)}catch{return v(O)}v(H).catch(M=>{})}catch(H){if(H.code!=="ENOENT")throw H}}async function v(O){return e.Promises.rmdir(O,{recursive:!0,maxRetries:3})}function T(O){if((0,P.isRootOrDriveLetter)(O))throw new Error("rimraf - will refuse to recursively delete root");m.rmdirSync(O,{recursive:!0})}e.rimrafSync=T;async function b(O,H){return g(await(H?o(O):(0,y.promisify)(m.readdir)(O)))}async function o(O){try{return await(0,y.promisify)(m.readdir)(O,{withFileTypes:!0})}catch(W){console.warn("[node.js fs] readdir with filetypes failed with error: ",W)}const H=[],M=await b(O);for(const W of M){let z=!1,U=!1,V=!1;try{const K=await e.Promises.lstat((0,_.join)(O,W));z=K.isFile(),U=K.isDirectory(),V=K.isSymbolicLink()}catch(K){console.warn("[node.js fs] unexpected error from lstat after readdir: ",K)}H.push({name:W,isFile:()=>z,isDirectory:()=>U,isSymbolicLink:()=>V})}return H}function s(O){return g(m.readdirSync(O))}e.readdirSync=s;function g(O){return O.map(H=>typeof H=="string"?I.isMacintosh?(0,D.normalizeNFC)(H):H:(H.name=I.isMacintosh?(0,D.normalizeNFC)(H.name):H.name,H))}async function l(O){const H=await b(O),M=[];for(const W of H)await n.existsDirectory((0,_.join)(O,W))&&M.push(W);return M}function S(O,H=1e3){return new Promise(M=>{let W=!1;const z=setInterval(()=>{W||(W=!0,m.access(O,U=>{W=!1,U&&(clearInterval(z),M(void 0))}))},H)})}e.whenDeleted=S;var n;(function(O){async function H(z){let U;try{if(U=await e.Promises.lstat(z),!U.isSymbolicLink())return{stat:U}}catch{}try{return{stat:await e.Promises.stat(z),symbolicLink:U?.isSymbolicLink()?{dangling:!1}:void 0}}catch(V){if(V.code==="ENOENT"&&U)return{stat:U,symbolicLink:{dangling:!0}};if(I.isWindows&&V.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(z)),symbolicLink:{dangling:!1}}}catch(K){if(K.code==="ENOENT"&&U)return{stat:U,symbolicLink:{dangling:!0}};throw K}throw V}}O.stat=H;async function M(z){try{const{stat:U,symbolicLink:V}=await O.stat(z);return U.isFile()&&V?.dangling!==!0}catch{}return!1}O.existsFile=M;async function W(z){try{const{stat:U,symbolicLink:V}=await O.stat(z);return U.isDirectory()&&V?.dangling!==!0}catch{}return!1}O.existsDirectory=W})(n=e.SymlinkSupport||(e.SymlinkSupport={}));const t=new C.ResourceQueue;function r(O,H,M){return t.queueFor(A.URI.file(O),L.extUriBiasedIgnorePathCase).queue(()=>{const W=w(M);return new Promise((z,U)=>a(O,H,W,V=>V?U(V):z()))})}let u=!0;function a(O,H,M,W){if(!u)return m.writeFile(O,H,{mode:M.mode,flag:M.flag},W);m.open(O,M.flag,M.mode,(z,U)=>{if(z)return W(z);m.writeFile(U,H,V=>{if(V)return m.close(U,()=>W(V));m.fdatasync(U,K=>(K&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",K),u=!1),m.close(U,G=>W(G))))})})}function f(O,H,M){const W=w(M);if(!u)return m.writeFileSync(O,H,{mode:W.mode,flag:W.flag});const z=m.openSync(O,W.flag,W.mode);try{m.writeFileSync(z,H);try{m.fdatasyncSync(z)}catch(U){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",U),u=!1}}finally{m.closeSync(z)}}e.writeFileSync=f;function w(O){return O?{mode:typeof O.mode=="number"?O.mode:438,flag:typeof O.flag=="string"?O.flag:"w"}:{mode:438,flag:"w"}}async function d(O,H){if(O===H)return;async function M(W){try{const z=await e.Promises.lstat(W);if(z.isDirectory()||z.isSymbolicLink())return;await e.Promises.utimes(W,z.atime,new Date)}catch{}}try{await e.Promises.rename(O,H),await M(H)}catch(W){if(O.toLowerCase()!==H.toLowerCase()&&W.code==="EXDEV"||O.endsWith("."))await k(O,H,{preserveSymlinks:!1}),await h(O,E.MOVE),await M(H);else throw W}}async function k(O,H,M){return N(O,H,{root:{source:O,target:H},options:M,handledSourcePaths:new Set})}const R=511;async function N(O,H,M){if(M.handledSourcePaths.has(O))return;M.handledSourcePaths.add(O);const{stat:W,symbolicLink:z}=await n.stat(O);if(z){if(M.options.preserveSymlinks)try{return await B(O,H,M)}catch(U){console.warn("[node.js fs] copy of symlink failed: ",U)}if(z.dangling)return}return W.isDirectory()?x(O,H,W.mode&R,M):F(O,H,W.mode&R)}async function x(O,H,M,W){await e.Promises.mkdir(H,{recursive:!0,mode:M});const z=await b(O);for(const U of z)await N((0,_.join)(O,U),(0,_.join)(H,U),W)}async function F(O,H,M){await e.Promises.copyFile(O,H),await e.Promises.chmod(H,M)}async function B(O,H,M){let W=await e.Promises.readlink(O);(0,P.isEqualOrParent)(W,M.root.source,!I.isLinux)&&(W=(0,_.join)(M.root.target,W.substr(M.root.source.length+1))),await e.Promises.symlink(W,H)}e.Promises=new class{get access(){return(0,y.promisify)(m.access)}get stat(){return(0,y.promisify)(m.stat)}get lstat(){return(0,y.promisify)(m.lstat)}get utimes(){return(0,y.promisify)(m.utimes)}get read(){return(0,y.promisify)(m.read)}get readFile(){return(0,y.promisify)(m.readFile)}get write(){return(0,y.promisify)(m.write)}get appendFile(){return(0,y.promisify)(m.appendFile)}get fdatasync(){return(0,y.promisify)(m.fdatasync)}get truncate(){return(0,y.promisify)(m.truncate)}get rename(){return(0,y.promisify)(m.rename)}get copyFile(){return(0,y.promisify)(m.copyFile)}get open(){return(0,y.promisify)(m.open)}get close(){return(0,y.promisify)(m.close)}get symlink(){return(0,y.promisify)(m.symlink)}get readlink(){return(0,y.promisify)(m.readlink)}get chmod(){return(0,y.promisify)(m.chmod)}get mkdir(){return(0,y.promisify)(m.mkdir)}get unlink(){return(0,y.promisify)(m.unlink)}get rmdir(){return(0,y.promisify)(m.rmdir)}get realpath(){return(0,y.promisify)(m.realpath)}async exists(O){try{return await e.Promises.access(O),!0}catch{return!1}}get readdir(){return b}get readDirsInDir(){return l}get writeFile(){return r}get rm(){return h}get move(){return d}get copy(){return k}}}),define(ve[104],we([0,1,60,9,8,28]),function(J,e,m,i,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function P(L){const A=(0,i.dirname)(L);if(L===A)return L;const c=((0,i.basename)(L)||L).toLowerCase();try{const h=(0,C.readdirSync)(A).filter(p=>p.toLowerCase()===c);if(h.length===1){const p=P(A);if(p)return(0,i.join)(p,h[0])}else if(h.length>1){const p=h.indexOf(c);if(p>=0){const v=P(A);if(v)return(0,i.join)(v,h[p])}}}catch{}return null}e.realcaseSync=P;async function D(L){try{return await C.Promises.realpath(L)}catch{const c=I(L);return await C.Promises.access(c,m.constants.R_OK),c}}e.realpath=D;function _(L){try{return m.realpathSync(L)}catch{const c=I(L);return m.accessSync(c,m.constants.R_OK),c}}e.realpathSync=_;function I(L){return(0,y.rtrim)((0,i.normalize)(L),i.sep)}});var je=this&&this.__decorate||function(J,e,m,i){var y=arguments.length,C=y<3?e:i===null?i=Object.getOwnPropertyDescriptor(e,m):i,P;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")C=Reflect.decorate(J,e,m,i);else for(var D=J.length-1;D>=0;D--)(P=J[D])&&(C=(y<3?P(C):y>3?P(e,m,C):P(e,m))||C);return y>3&&C&&Object.defineProperty(e,m,C),C};define(ve[105],we([0,1,16,18,22,21,57,15,3,6,59,8,13]),function(J,e,m,i,y,C,P,D,_,I,L,A,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var E;(function(z){z[z.Promise=100]="Promise",z[z.PromiseCancel=101]="PromiseCancel",z[z.EventListen=102]="EventListen",z[z.EventDispose=103]="EventDispose"})(E=e.RequestType||(e.RequestType={}));function h(z){switch(z){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var p;(function(z){z[z.Initialize=200]="Initialize",z[z.PromiseSuccess=201]="PromiseSuccess",z[z.PromiseError=202]="PromiseError",z[z.PromiseErrorObj=203]="PromiseErrorObj",z[z.EventFire=204]="EventFire"})(p=e.ResponseType||(e.ResponseType={}));function v(z){switch(z){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var T;(function(z){z[z.Uninitialized=0]="Uninitialized",z[z.Idle=1]="Idle"})(T||(T={}));class b{constructor(U){this.buffer=U,this.pos=0}read(U){const V=this.buffer.slice(this.pos,this.pos+U);return this.pos+=V.byteLength,V}}class o{constructor(){this.buffers=[]}get buffer(){return y.VSBuffer.concat(this.buffers)}write(U){this.buffers.push(U)}}var s;(function(z){z[z.Undefined=0]="Undefined",z[z.String=1]="String",z[z.Buffer=2]="Buffer",z[z.VSBuffer=3]="VSBuffer",z[z.Array=4]="Array",z[z.Object=5]="Object"})(s||(s={}));function g(z){const U=y.VSBuffer.alloc(4);return U.writeUInt32BE(z,0),U}function l(z){return z.read(4).readUInt32BE(0)}function S(z){const U=y.VSBuffer.alloc(1);return U.writeUInt8(z,0),U}const n={Undefined:S(s.Undefined),String:S(s.String),Buffer:S(s.Buffer),VSBuffer:S(s.VSBuffer),Array:S(s.Array),Object:S(s.Object)},t=typeof Buffer!="undefined";function r(z,U){if(typeof U=="undefined")z.write(n.Undefined);else if(typeof U=="string"){const V=y.VSBuffer.fromString(U);z.write(n.String),z.write(g(V.byteLength)),z.write(V)}else if(t&&Buffer.isBuffer(U)){const V=y.VSBuffer.wrap(U);z.write(n.Buffer),z.write(g(V.byteLength)),z.write(V)}else if(U instanceof y.VSBuffer)z.write(n.VSBuffer),z.write(g(U.byteLength)),z.write(U);else if(Array.isArray(U)){z.write(n.Array),z.write(g(U.length));for(const V of U)r(z,V)}else{const V=y.VSBuffer.fromString(JSON.stringify(U));z.write(n.Object),z.write(g(V.byteLength)),z.write(V)}}function u(z){switch(z.read(1).readUInt8(0)){case s.Undefined:return;case s.String:return z.read(l(z)).toString();case s.Buffer:return z.read(l(z)).buffer;case s.VSBuffer:return z.read(l(z));case s.Array:{const V=l(z),K=[];for(let G=0;G<V;G++)K.push(u(z));return K}case s.Object:return JSON.parse(z.read(l(z)).toString())}}class a{constructor(U,V,K=null,G=1e3){this.protocol=U,this.ctx=V,this.logger=K,this.timeoutDelay=G,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(Q=>this.onRawMessage(Q)),this.sendResponse({type:200})}registerChannel(U,V){this.channels.set(U,V),setTimeout(()=>this.flushPendingRequests(U),0)}sendResponse(U){switch(U.type){case 200:{const V=this.send([U.type]);this.logger&&this.logger.logOutgoing(V,0,1,v(U.type));return}case 201:case 202:case 204:case 203:{const V=this.send([U.type,U.id],U.data);this.logger&&this.logger.logOutgoing(V,U.id,1,v(U.type),U.data);return}}}send(U,V=void 0){const K=new o;return r(K,U),r(K,V),this.sendBuffer(K.buffer)}sendBuffer(U){try{return this.protocol.send(U),U.byteLength}catch{return 0}}onRawMessage(U){const V=new b(U),K=u(V),G=u(V),Q=K[0];switch(Q){case 100:return this.logger&&this.logger.logIncoming(U.byteLength,K[1],1,`${h(Q)}: ${K[2]}.${K[3]}`,G),this.onPromise({type:Q,id:K[1],channelName:K[2],name:K[3],arg:G});case 102:return this.logger&&this.logger.logIncoming(U.byteLength,K[1],1,`${h(Q)}: ${K[2]}.${K[3]}`,G),this.onEventListen({type:Q,id:K[1],channelName:K[2],name:K[3],arg:G});case 101:return this.logger&&this.logger.logIncoming(U.byteLength,K[1],1,`${h(Q)}`),this.disposeActiveRequest({type:Q,id:K[1]});case 103:return this.logger&&this.logger.logIncoming(U.byteLength,K[1],1,`${h(Q)}`),this.disposeActiveRequest({type:Q,id:K[1]})}}onPromise(U){const V=this.channels.get(U.channelName);if(!V){this.collectPendingRequest(U);return}const K=new C.CancellationTokenSource;let G;try{G=V.call(this.ctx,U.name,U.arg,K.token)}catch(fe){G=Promise.reject(fe)}const Q=U.id;G.then(fe=>{this.sendResponse({id:Q,data:fe,type:201}),this.activeRequests.delete(U.id)},fe=>{fe instanceof Error?this.sendResponse({id:Q,data:{message:fe.message,name:fe.name,stack:fe.stack?fe.stack.split?fe.stack.split(`
`):fe.stack:void 0},type:202}):this.sendResponse({id:Q,data:fe,type:203}),this.activeRequests.delete(U.id)});const Y=(0,I.toDisposable)(()=>K.cancel());this.activeRequests.set(U.id,Y)}onEventListen(U){const V=this.channels.get(U.channelName);if(!V){this.collectPendingRequest(U);return}const K=U.id,Q=V.listen(this.ctx,U.name,U.arg)(Y=>this.sendResponse({id:K,data:Y,type:204}));this.activeRequests.set(U.id,Q)}disposeActiveRequest(U){const V=this.activeRequests.get(U.id);V&&(V.dispose(),this.activeRequests.delete(U.id))}collectPendingRequest(U){let V=this.pendingRequests.get(U.channelName);V||(V=[],this.pendingRequests.set(U.channelName,V));const K=setTimeout(()=>{console.error(`Unknown channel: ${U.channelName}`),U.type===100&&this.sendResponse({id:U.id,data:{name:"Unknown channel",message:`Channel name '${U.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);V.push({request:U,timeoutTimer:K})}flushPendingRequests(U){const V=this.pendingRequests.get(U);if(V){for(const K of V)switch(clearTimeout(K.timeoutTimer),K.request.type){case 100:this.onPromise(K.request);break;case 102:this.onEventListen(K.request);break}this.pendingRequests.delete(U)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(U=>U.dispose()),this.activeRequests.clear()}}e.ChannelServer=a;var f;(function(z){z[z.LocalSide=0]="LocalSide",z[z.OtherSide=1]="OtherSide"})(f=e.RequestInitiator||(e.RequestInitiator={}));class w{constructor(U,V=null){this.protocol=U,this.isDisposed=!1,this.state=T.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new _.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(K=>this.onBuffer(K)),this.logger=V}getChannel(U){const V=this;return{call(K,G,Q){return V.isDisposed?Promise.reject(D.canceled()):V.requestPromise(U,K,G,Q)},listen(K,G){return V.isDisposed?Promise.reject(D.canceled()):V.requestEvent(U,K,G)}}}requestPromise(U,V,K,G=C.CancellationToken.None){const Q=this.lastRequestId++,fe={id:Q,type:100,channelName:U,name:V,arg:K};if(G.isCancellationRequested)return Promise.reject(D.canceled());let me;return new Promise((Ie,Oe)=>{if(G.isCancellationRequested)return Oe(D.canceled());const We=()=>{const ue=te=>{switch(te.type){case 201:this.handlers.delete(Q),Ie(te.data);break;case 202:this.handlers.delete(Q);const oe=new Error(te.data.message);oe.stack=te.data.stack,oe.name=te.data.name,Oe(oe);break;case 203:this.handlers.delete(Q),Oe(te.data);break}};this.handlers.set(Q,ue),this.sendRequest(fe)};let j=null;this.state===T.Idle?We():(j=(0,i.createCancelablePromise)(ue=>this.whenInitialized()),j.then(()=>{j=null,We()}));const Z=()=>{j?(j.cancel(),j=null):this.sendRequest({id:Q,type:101}),Oe(D.canceled())},re=G.onCancellationRequested(Z);me=(0,I.combinedDisposable)((0,I.toDisposable)(Z),re),this.activeRequests.add(me)}).finally(()=>{this.activeRequests.delete(me)})}requestEvent(U,V,K){const G=this.lastRequestId++,Y={id:G,type:102,channelName:U,name:V,arg:K};let fe=null;const me=new _.Emitter({onFirstListenerAdd:()=>{fe=(0,i.createCancelablePromise)(Ie=>this.whenInitialized()),fe.then(()=>{fe=null,this.activeRequests.add(me),this.sendRequest(Y)})},onLastListenerRemove:()=>{fe?(fe.cancel(),fe=null):(this.activeRequests.delete(me),this.sendRequest({id:G,type:103}))}}),_e=Ie=>me.fire(Ie.data);return this.handlers.set(G,_e),me.event}sendRequest(U){switch(U.type){case 100:case 102:{const V=this.send([U.type,U.id,U.channelName,U.name],U.arg);this.logger&&this.logger.logOutgoing(V,U.id,0,`${h(U.type)}: ${U.channelName}.${U.name}`,U.arg);return}case 101:case 103:{const V=this.send([U.type,U.id]);this.logger&&this.logger.logOutgoing(V,U.id,0,h(U.type));return}}}send(U,V=void 0){const K=new o;return r(K,U),r(K,V),this.sendBuffer(K.buffer)}sendBuffer(U){try{return this.protocol.send(U),U.byteLength}catch{return 0}}onBuffer(U){const V=new b(U),K=u(V),G=u(V),Q=K[0];switch(Q){case 200:return this.logger&&this.logger.logIncoming(U.byteLength,0,0,v(Q)),this.onResponse({type:K[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(U.byteLength,K[1],0,v(Q),G),this.onResponse({type:K[0],id:K[1],data:G})}}onResponse(U){if(U.type===200){this.state=T.Idle,this._onDidInitialize.fire();return}const V=this.handlers.get(U.id);V&&V(U)}get onDidInitializePromise(){return _.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===T.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(U=>U.dispose()),this.activeRequests.clear()}}je([P.memoize],w.prototype,"onDidInitializePromise",null),e.ChannelClient=w;class d{constructor(U){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new _.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new _.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,U(({protocol:V,onDidClientDisconnect:K})=>{_.Event.once(V.onMessage)(Q=>{const Y=new b(Q),fe=u(Y),me=new a(V,fe),_e=new w(V);this.channels.forEach((Oe,We)=>me.registerChannel(We,Oe));const Ie={channelServer:me,channelClient:_e,ctx:fe};this._connections.add(Ie),this._onDidAddConnection.fire(Ie),K(()=>{me.dispose(),_e.dispose(),this._connections.delete(Ie),this._onDidRemoveConnection.fire(Ie)})})})}get connections(){const U=[];return this._connections.forEach(V=>U.push(V)),U}getChannel(U,V){const K=this;return{call(G,Q,Y){let fe;if((0,c.isFunction)(V)){let _e=(0,m.getRandomElement)(K.connections.filter(V));fe=_e?Promise.resolve(_e):_.Event.toPromise(_.Event.filter(K.onDidAddConnection,V))}else fe=V.routeCall(K,G,Q);const me=fe.then(_e=>_e.channelClient.getChannel(U));return R(me).call(G,Q,Y)},listen(G,Q){if((0,c.isFunction)(V))return K.getMulticastEvent(U,V,G,Q);const Y=V.routeEvent(K,G,Q).then(fe=>fe.channelClient.getChannel(U));return R(Y).listen(G,Q)}}}getMulticastEvent(U,V,K,G){const Q=this;let Y=new I.DisposableStore;const fe=new _.Emitter({onFirstListenerAdd:()=>{Y=new I.DisposableStore;const me=new _.EventMultiplexer,_e=new Map,Ie=We=>{const Z=We.channelClient.getChannel(U).listen(K,G),re=me.add(Z);_e.set(We,re)},Oe=We=>{const j=_e.get(We);!j||(j.dispose(),_e.delete(We))};Q.connections.filter(V).forEach(Ie),_.Event.filter(Q.onDidAddConnection,V)(Ie,void 0,Y),Q.onDidRemoveConnection(Oe,void 0,Y),me.event(fe.fire,fe,Y),Y.add(me)},onLastListenerRemove:()=>{Y.dispose()}});return fe.event}registerChannel(U,V){this.channels.set(U,V),this._connections.forEach(K=>{K.channelServer.registerChannel(U,V)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=d;class k{constructor(U,V,K=null){const G=new o;r(G,V),U.send(G.buffer),this.channelClient=new w(U,K),this.channelServer=new a(U,V,K)}getChannel(U){return this.channelClient.getChannel(U)}registerChannel(U,V){this.channelServer.registerChannel(U,V)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=k;function R(z){return{call(U,V,K){return z.then(G=>G.call(U,V,K))},listen(U,V){const K=new _.Relay;return z.then(G=>K.input=G.listen(U,V)),K.event}}}e.getDelayedChannel=R;function N(z){let U=!1;return{call(V,K,G){return U?z.call(V,K,G):(0,i.timeout)(0).then(()=>U=!0).then(()=>z.call(V,K,G))},listen(V,K){if(U)return z.listen(V,K);const G=new _.Relay;return(0,i.timeout)(0).then(()=>U=!0).then(()=>G.input=z.listen(V,K)),G.event}}}e.getNextTickChannel=N;class x{constructor(U){this.fn=U}routeCall(U){return this.route(U)}routeEvent(U){return this.route(U)}async route(U){for(const V of U.connections)if(await Promise.resolve(this.fn(V.ctx)))return Promise.resolve(V);return await _.Event.toPromise(U.onDidAddConnection),await this.route(U)}}e.StaticRouter=x;var F;(function(z){function U(Q,Y){const fe=Q,me=Y&&Y.disableMarshalling,_e=new Map;for(const Ie in fe)K(Ie)&&_e.set(Ie,_.Event.buffer(fe[Ie],!0));return new class{listen(Ie,Oe,We){const j=_e.get(Oe);if(j)return j;if(G(Oe)){const Z=fe[Oe];if(typeof Z=="function")return Z.call(fe,We)}throw new Error(`Event not found: ${Oe}`)}call(Ie,Oe,We){const j=fe[Oe];if(typeof j=="function"){if(!me&&Array.isArray(We))for(let Z=0;Z<We.length;Z++)We[Z]=(0,L.revive)(We[Z]);return j.apply(fe,We)}throw new Error(`Method not found: ${Oe}`)}}}z.fromService=U;function V(Q,Y){const fe=Y&&Y.disableMarshalling;return new Proxy({},{get(me,_e){if(typeof _e=="string")return Y?.properties?.has(_e)?Y.properties.get(_e):G(_e)?function(Ie){return Q.listen(_e,Ie)}:K(_e)?Q.listen(_e):async function(...Ie){let Oe;Y&&!(0,c.isUndefinedOrNull)(Y.context)?Oe=[Y.context,...Ie]:Oe=Ie;const We=await Q.call(_e,Oe);return fe?We:(0,L.revive)(We)};throw new Error(`Property not found: ${String(_e)}`)}})}z.toService=V;function K(Q){return Q[0]==="o"&&Q[1]==="n"&&A.isUpperAsciiLetter(Q.charCodeAt(2))}function G(Q){return/^onDynamic/.test(Q)&&A.isUpperAsciiLetter(Q.charCodeAt(9))}})(F=e.ProxyChannel||(e.ProxyChannel={}));const B=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function O(z){if(Array.isArray(z))return z;if(z&&typeof z=="object"&&typeof z.toString=="function"){let U=z.toString();if(U!=="[object Object]")return U}return z}function H(z){return Array.isArray(z)?z.map(O):O(z)}function M(z,U,V,K,G,Q,Y){Y=H(Y);const fe=B[G],me=fe[K%fe.length];let _e=[`%c[${z}]%c[${String(U).padStart(7," ")}]%c[len: ${String(V).padStart(5," ")}]%c${String(K).padStart(5," ")} - ${Q}`,"color: darkgreen","color: grey","color: grey",`color: ${me}`];/\($/.test(Q)?(_e=_e.concat(Y),_e.push(")")):_e.push(Y),console.log.apply(console,_e)}e.logWithColors=M;class W{constructor(U,V){this._outgoingPrefix=U,this._incomingPrefix=V,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(U,V,K,G,Q){this._totalOutgoing+=U,M(this._outgoingPrefix,this._totalOutgoing,U,V,K,G,Q)}logIncoming(U,V,K,G,Q){this._totalIncoming+=U,M(this._incomingPrefix,this._totalIncoming,U,V,K,G,Q)}}e.IPCLogger=W}),define(ve[106],we([0,1,22,3,6,105]),function(J,e,m,i,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var P;(function(t){t.Created="created",t.Read="read",t.Write="write",t.Open="open",t.Error="error",t.Close="close",t.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",t.NodeEndReceived="nodeEndReceived",t.NodeEndSent="nodeEndSent",t.NodeDrainBegin="nodeDrainBegin",t.NodeDrainEnd="nodeDrainEnd",t.zlibInflateError="zlibInflateError",t.zlibInflateData="zlibInflateData",t.zlibInflateInitialWrite="zlibInflateInitialWrite",t.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",t.zlibInflateWrite="zlibInflateWrite",t.zlibInflateFlushFired="zlibInflateFlushFired",t.zlibDeflateError="zlibDeflateError",t.zlibDeflateData="zlibDeflateData",t.zlibDeflateWrite="zlibDeflateWrite",t.zlibDeflateFlushFired="zlibDeflateFlushFired",t.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",t.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",t.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",t.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",t.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",t.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",t.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",t.ProtocolHeaderRead="protocolHeaderRead",t.ProtocolMessageRead="protocolMessageRead",t.ProtocolHeaderWrite="protocolHeaderWrite",t.ProtocolMessageWrite="protocolMessageWrite",t.ProtocolWrite="protocolWrite"})(P=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var D;(function(t){t.enableDiagnostics=!1,t.records=[];const r=new WeakMap;let u=0;function a(w,d){if(!r.has(w)){const k=String(++u);r.set(w,k)}return r.get(w)}function f(w,d,k,R){if(!t.enableDiagnostics)return;const N=a(w,d);if(R instanceof m.VSBuffer||R instanceof Uint8Array||R instanceof ArrayBuffer||ArrayBuffer.isView(R)){const x=m.VSBuffer.alloc(R.byteLength);x.set(R),t.records.push({timestamp:Date.now(),id:N,label:d,type:k,buff:x})}else t.records.push({timestamp:Date.now(),id:N,label:d,type:k,data:R})}t.traceSocketEvent=f})(D=e.SocketDiagnostics||(e.SocketDiagnostics={}));var _;(function(t){t[t.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",t[t.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(_=e.SocketCloseEventType||(e.SocketCloseEventType={}));let I=null;function L(){return I||(I=m.VSBuffer.alloc(0)),I}class A{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(r){this._chunks.push(r),this._totalLength+=r.byteLength}read(r){return this._read(r,!0)}peek(r){return this._read(r,!1)}_read(r,u){if(r===0)return L();if(r>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===r){const d=this._chunks[0];return u&&(this._chunks.shift(),this._totalLength-=r),d}if(this._chunks[0].byteLength>r){const d=this._chunks[0].slice(0,r);return u&&(this._chunks[0]=this._chunks[0].slice(r),this._totalLength-=r),d}let a=m.VSBuffer.alloc(r),f=0,w=0;for(;r>0;){const d=this._chunks[w];if(d.byteLength>r){const k=d.slice(0,r);a.set(k,f),f+=r,u&&(this._chunks[w]=d.slice(r),this._totalLength-=r),r-=r}else a.set(d,f),f+=d.byteLength,u?(this._chunks.shift(),this._totalLength-=d.byteLength):w++,r-=d.byteLength}return a}}e.ChunkStream=A;var c;(function(t){t[t.None=0]="None",t[t.Regular=1]="Regular",t[t.Control=2]="Control",t[t.Ack=3]="Ack",t[t.Disconnect=5]="Disconnect",t[t.ReplayRequest=6]="ReplayRequest",t[t.Pause=7]="Pause",t[t.Resume=8]="Resume"})(c||(c={}));function E(t){switch(t){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var h;(function(t){t[t.HeaderLength=13]="HeaderLength",t[t.AcknowledgeTime=2e3]="AcknowledgeTime",t[t.TimeoutTime=2e4]="TimeoutTime",t[t.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",t[t.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(h=e.ProtocolConstants||(e.ProtocolConstants={}));class p{constructor(r,u,a,f){this.type=r,this.id=u,this.ack=a,this.data=f,this.writtenTime=0}get size(){return this.data.byteLength}}class v extends y.Disposable{constructor(r){super();this._onMessage=this._register(new i.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=r,this._isDisposed=!1,this._incomingData=new A,this._register(this._socket.onData(u=>this.acceptChunk(u))),this.lastReadTime=Date.now()}acceptChunk(r){if(!(!r||r.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(r);this._incomingData.byteLength>=this._state.readLen;){const u=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=u.readUInt32BE(9),this._state.messageType=u.readUInt8(0),this._state.id=u.readUInt32BE(1),this._state.ack=u.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:E(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const a=this._state.messageType,f=this._state.id,w=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",u),this._onMessage.fire(new p(a,f,w,u)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class T{constructor(r){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=r,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(r){if(this._isDisposed)return;r.writtenTime=Date.now(),this.lastWriteTime=Date.now();const u=m.VSBuffer.alloc(13);u.writeUInt8(r.type,0),u.writeUInt32BE(r.id,1),u.writeUInt32BE(r.ack,5),u.writeUInt32BE(r.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:E(r.type),id:r.id,ack:r.ack,messageSize:r.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",r.data),this._writeSoon(u,r.data)}_bufferAdd(r,u){const a=this._totalLength===0;return this._data.push(r,u),this._totalLength+=r.byteLength+u.byteLength,a}_bufferTake(){const r=m.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,r}_writeSoon(r,u){this._bufferAdd(r,u)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const r=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:r.byteLength}),this._socket.write(r)}}class b extends y.Disposable{constructor(r){super();this._onMessage=new i.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new i.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=r,this._socketWriter=this._register(new T(this._socket)),this._socketReader=this._register(new v(this._socket)),this._register(this._socketReader.onMessage(u=>{u.type===1&&this._onMessage.fire(u.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(r){this._socketWriter.write(new p(1,0,0,r))}}e.Protocol=b;class o extends C.IPCClient{constructor(r,u,a=null){super(r,u,a);this.protocol=r}static fromSocket(r,u){return new o(new b(r),u)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const r=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),r.end()}}e.Client=o;class s{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new i.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(r){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(r):this._emitter.fire(r):this._bufferedMessages.push(r)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=s;class g{constructor(r){this.data=r,this.next=null}}class l{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let r=[],u=0,a=this._first;for(;a;)r[u++]=a.data,a=a.next;return r}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(r){const u=new g(r);if(!this._first){this._first=u,this._last=u;return}this._last.next=u,this._last=u}}class S{constructor(){this.lastRuns=[];const r=Date.now();for(let u=0;u<S._HISTORY_LENGTH;u++)this.lastRuns[u]=r-1e3*u;setInterval(()=>{for(let u=S._HISTORY_LENGTH;u>=1;u--)this.lastRuns[u]=this.lastRuns[u-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return S._INSTANCE||(S._INSTANCE=new S),S._INSTANCE}load(){const r=Date.now(),u=(1+S._HISTORY_LENGTH)*1e3;let a=0;for(let f=0;f<S._HISTORY_LENGTH;f++)r-this.lastRuns[f]<=u&&a++;return 1-a/S._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}S._HISTORY_LENGTH=10,S._INSTANCE=null;class n{constructor(r,u=null,a=S.getInstance()){this._onControlMessage=new s,this.onControlMessage=this._onControlMessage.event,this._onMessage=new s,this.onMessage=this._onMessage.event,this._onDidDispose=new s,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new s,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new s,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=a,this._isReconnecting=!1,this._outgoingUnackMsg=new l,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=r,this._socketWriter=new T(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new v(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(f=>this._receiveMessage(f))),this._socketDisposables.push(this._socket.onClose(f=>this._onSocketClose.fire(f))),u&&this._socketReader.acceptChunk(u)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,y.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const r=new p(5,0,0,L());this._socketWriter.write(r),this._socketWriter.flush()}sendPause(){const r=new p(7,0,0,L());this._socketWriter.write(r)}sendResume(){const r=new p(8,0,0,L());this._socketWriter.write(r)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(r,u){this._isReconnecting=!0,this._socketDisposables=(0,y.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=r,this._socketWriter=new T(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new v(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(a=>this._receiveMessage(a))),this._socketDisposables.push(this._socket.onClose(a=>this._onSocketClose.fire(a))),this._socketReader.acceptChunk(u)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const r=new p(3,0,this._incomingAckId,L());this._socketWriter.write(r);const u=this._outgoingUnackMsg.toArray();for(let a=0,f=u.length;a<f;a++)this._socketWriter.write(u[a]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(r){if(r.ack>this._outgoingAckId){this._outgoingAckId=r.ack;do{const u=this._outgoingUnackMsg.peek();if(u&&u.id<=r.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(r.type){case 0:break;case 1:{if(r.id>this._incomingMsgId)if(r.id!==this._incomingMsgId+1){const u=Date.now();u-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=u,this._socketWriter.write(new p(6,0,0,L())))}else this._incomingMsgId=r.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(r.data);break}case 2:{this._onControlMessage.fire(r.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const u=this._outgoingUnackMsg.toArray();for(let a=0,f=u.length;a<f;a++)this._socketWriter.write(u[a]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(r){const u=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const a=new p(1,u,this._incomingAckId,r);this._outgoingUnackMsg.push(a),this._isReconnecting||(this._socketWriter.write(a),this._recvAckCheck())}sendControl(r){const u=new p(2,0,0,r);this._socketWriter.write(u)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const r=Date.now()-this._incomingMsgLastTime;if(r>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-r+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const r=this._outgoingUnackMsg.peek(),u=Date.now()-r.writtenTime,a=Date.now()-this._socketReader.lastReadTime,f=Date.now()-this._lastSocketTimeoutTime;if(u>=2e4&&a>=2e4&&f>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire(void 0);return}const w=Math.max(2e4-u,2e4-a,2e4-f,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},w)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const r=new p(3,0,this._incomingAckId,L());this._socketWriter.write(r)}}e.PersistentProtocol=n}),define(ve[107],we([0,1,98]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class i{constructor(D){let _=(0,m.toUint8)(D);this._defaultValue=_,this._asciiMap=i._createAsciiMap(_),this._map=new Map}static _createAsciiMap(D){let _=new Uint8Array(256);for(let I=0;I<256;I++)_[I]=D;return _}set(D,_){let I=(0,m.toUint8)(_);D>=0&&D<256?this._asciiMap[D]=I:this._map.set(D,I)}get(D){return D>=0&&D<256?this._asciiMap[D]:this._map.get(D)||this._defaultValue}}e.CharacterClassifier=i;var y;(function(P){P[P.False=0]="False",P[P.True=1]="True"})(y||(y={}));class C{constructor(){this._actual=new i(0)}add(D){this._actual.set(D,1)}has(D){return this._actual.get(D)===1}}e.CharacterSet=C}),define(ve[143],we([0,1,107]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var i;(function(P){P[P.Regular=0]="Regular",P[P.Whitespace=1]="Whitespace",P[P.WordSeparator=2]="WordSeparator"})(i=e.WordCharacterClass||(e.WordCharacterClass={}));class y extends m.CharacterClassifier{constructor(D){super(0);for(let _=0,I=D.length;_<I;_++)this.set(D.charCodeAt(_),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=y;function C(P){let D={};return _=>(D.hasOwnProperty(_)||(D[_]=P(_)),D[_])}e.getMapForWordSeparators=C(P=>new y(P))}),define(ve[49],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class m{constructor(y,C){this.lineNumber=y,this.column=C}with(y=this.lineNumber,C=this.column){return y===this.lineNumber&&C===this.column?this:new m(y,C)}delta(y=0,C=0){return this.with(this.lineNumber+y,this.column+C)}equals(y){return m.equals(this,y)}static equals(y,C){return!y&&!C?!0:!!y&&!!C&&y.lineNumber===C.lineNumber&&y.column===C.column}isBefore(y){return m.isBefore(this,y)}static isBefore(y,C){return y.lineNumber<C.lineNumber?!0:C.lineNumber<y.lineNumber?!1:y.column<C.column}isBeforeOrEqual(y){return m.isBeforeOrEqual(this,y)}static isBeforeOrEqual(y,C){return y.lineNumber<C.lineNumber?!0:C.lineNumber<y.lineNumber?!1:y.column<=C.column}static compare(y,C){let P=y.lineNumber|0,D=C.lineNumber|0;if(P===D){let _=y.column|0,I=C.column|0;return _-I}return P-D}clone(){return new m(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(y){return new m(y.lineNumber,y.column)}static isIPosition(y){return y&&typeof y.lineNumber=="number"&&typeof y.column=="number"}}e.Position=m}),define(ve[41],we([0,1,49]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class i{constructor(C,P,D,_){C>D||C===D&&P>_?(this.startLineNumber=D,this.startColumn=_,this.endLineNumber=C,this.endColumn=P):(this.startLineNumber=C,this.startColumn=P,this.endLineNumber=D,this.endColumn=_)}isEmpty(){return i.isEmpty(this)}static isEmpty(C){return C.startLineNumber===C.endLineNumber&&C.startColumn===C.endColumn}containsPosition(C){return i.containsPosition(this,C)}static containsPosition(C,P){return!(P.lineNumber<C.startLineNumber||P.lineNumber>C.endLineNumber||P.lineNumber===C.startLineNumber&&P.column<C.startColumn||P.lineNumber===C.endLineNumber&&P.column>C.endColumn)}static strictContainsPosition(C,P){return!(P.lineNumber<C.startLineNumber||P.lineNumber>C.endLineNumber||P.lineNumber===C.startLineNumber&&P.column<=C.startColumn||P.lineNumber===C.endLineNumber&&P.column>=C.endColumn)}containsRange(C){return i.containsRange(this,C)}static containsRange(C,P){return!(P.startLineNumber<C.startLineNumber||P.endLineNumber<C.startLineNumber||P.startLineNumber>C.endLineNumber||P.endLineNumber>C.endLineNumber||P.startLineNumber===C.startLineNumber&&P.startColumn<C.startColumn||P.endLineNumber===C.endLineNumber&&P.endColumn>C.endColumn)}strictContainsRange(C){return i.strictContainsRange(this,C)}static strictContainsRange(C,P){return!(P.startLineNumber<C.startLineNumber||P.endLineNumber<C.startLineNumber||P.startLineNumber>C.endLineNumber||P.endLineNumber>C.endLineNumber||P.startLineNumber===C.startLineNumber&&P.startColumn<=C.startColumn||P.endLineNumber===C.endLineNumber&&P.endColumn>=C.endColumn)}plusRange(C){return i.plusRange(this,C)}static plusRange(C,P){let D,_,I,L;return P.startLineNumber<C.startLineNumber?(D=P.startLineNumber,_=P.startColumn):P.startLineNumber===C.startLineNumber?(D=P.startLineNumber,_=Math.min(P.startColumn,C.startColumn)):(D=C.startLineNumber,_=C.startColumn),P.endLineNumber>C.endLineNumber?(I=P.endLineNumber,L=P.endColumn):P.endLineNumber===C.endLineNumber?(I=P.endLineNumber,L=Math.max(P.endColumn,C.endColumn)):(I=C.endLineNumber,L=C.endColumn),new i(D,_,I,L)}intersectRanges(C){return i.intersectRanges(this,C)}static intersectRanges(C,P){let D=C.startLineNumber,_=C.startColumn,I=C.endLineNumber,L=C.endColumn,A=P.startLineNumber,c=P.startColumn,E=P.endLineNumber,h=P.endColumn;return D<A?(D=A,_=c):D===A&&(_=Math.max(_,c)),I>E?(I=E,L=h):I===E&&(L=Math.min(L,h)),D>I||D===I&&_>L?null:new i(D,_,I,L)}equalsRange(C){return i.equalsRange(this,C)}static equalsRange(C,P){return!!C&&!!P&&C.startLineNumber===P.startLineNumber&&C.startColumn===P.startColumn&&C.endLineNumber===P.endLineNumber&&C.endColumn===P.endColumn}getEndPosition(){return i.getEndPosition(this)}static getEndPosition(C){return new m.Position(C.endLineNumber,C.endColumn)}getStartPosition(){return i.getStartPosition(this)}static getStartPosition(C){return new m.Position(C.startLineNumber,C.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(C,P){return new i(this.startLineNumber,this.startColumn,C,P)}setStartPosition(C,P){return new i(C,P,this.endLineNumber,this.endColumn)}collapseToStart(){return i.collapseToStart(this)}static collapseToStart(C){return new i(C.startLineNumber,C.startColumn,C.startLineNumber,C.startColumn)}static fromPositions(C,P=C){return new i(C.lineNumber,C.column,P.lineNumber,P.column)}static lift(C){return C?new i(C.startLineNumber,C.startColumn,C.endLineNumber,C.endColumn):null}static isIRange(C){return C&&typeof C.startLineNumber=="number"&&typeof C.startColumn=="number"&&typeof C.endLineNumber=="number"&&typeof C.endColumn=="number"}static areIntersectingOrTouching(C,P){return!(C.endLineNumber<P.startLineNumber||C.endLineNumber===P.startLineNumber&&C.endColumn<P.startColumn||P.endLineNumber<C.startLineNumber||P.endLineNumber===C.startLineNumber&&P.endColumn<C.startColumn)}static areIntersecting(C,P){return!(C.endLineNumber<P.startLineNumber||C.endLineNumber===P.startLineNumber&&C.endColumn<=P.startColumn||P.endLineNumber<C.startLineNumber||P.endLineNumber===C.startLineNumber&&P.endColumn<=C.startColumn)}static compareRangesUsingStarts(C,P){if(C&&P){const I=C.startLineNumber|0,L=P.startLineNumber|0;if(I===L){const A=C.startColumn|0,c=P.startColumn|0;if(A===c){const E=C.endLineNumber|0,h=P.endLineNumber|0;if(E===h){const p=C.endColumn|0,v=P.endColumn|0;return p-v}return E-h}return A-c}return I-L}return(C?1:0)-(P?1:0)}static compareRangesUsingEnds(C,P){return C.endLineNumber===P.endLineNumber?C.endColumn===P.endColumn?C.startLineNumber===P.startLineNumber?C.startColumn-P.startColumn:C.startLineNumber-P.startLineNumber:C.endColumn-P.endColumn:C.endLineNumber-P.endLineNumber}static spansMultipleLines(C){return C.endLineNumber>C.startLineNumber}}e.Range=i}),define(ve[144],we([0,1,49,41]),function(J,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var y;(function(P){P[P.LTR=0]="LTR",P[P.RTL=1]="RTL"})(y=e.SelectionDirection||(e.SelectionDirection={}));class C extends i.Range{constructor(D,_,I,L){super(D,_,I,L);this.selectionStartLineNumber=D,this.selectionStartColumn=_,this.positionLineNumber=I,this.positionColumn=L}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(D){return C.selectionsEqual(this,D)}static selectionsEqual(D,_){return D.selectionStartLineNumber===_.selectionStartLineNumber&&D.selectionStartColumn===_.selectionStartColumn&&D.positionLineNumber===_.positionLineNumber&&D.positionColumn===_.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(D,_){return this.getDirection()===0?new C(this.startLineNumber,this.startColumn,D,_):new C(D,_,this.startLineNumber,this.startColumn)}getPosition(){return new m.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new m.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(D,_){return this.getDirection()===0?new C(D,_,this.endLineNumber,this.endColumn):new C(this.endLineNumber,this.endColumn,D,_)}static fromPositions(D,_=D){return new C(D.lineNumber,D.column,_.lineNumber,_.column)}static fromRange(D,_){return _===0?new C(D.startLineNumber,D.startColumn,D.endLineNumber,D.endColumn):new C(D.endLineNumber,D.endColumn,D.startLineNumber,D.startColumn)}static liftSelection(D){return new C(D.selectionStartLineNumber,D.selectionStartColumn,D.positionLineNumber,D.positionColumn)}static selectionsArrEqual(D,_){if(D&&!_||!D&&_)return!1;if(!D&&!_)return!0;if(D.length!==_.length)return!1;for(let I=0,L=D.length;I<L;I++)if(!this.selectionsEqual(D[I],_[I]))return!1;return!0}static isISelection(D){return D&&typeof D.selectionStartLineNumber=="number"&&typeof D.selectionStartColumn=="number"&&typeof D.positionLineNumber=="number"&&typeof D.positionColumn=="number"}static createWithDirection(D,_,I,L,A){return A===0?new C(D,_,I,L):new C(I,L,D,_)}}e.Selection=C}),define(ve[108],we([0,1,25]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var i;(function(p){p[p.Left=1]="Left",p[p.Center=2]="Center",p[p.Right=4]="Right",p[p.Full=7]="Full"})(i=e.OverviewRulerLane||(e.OverviewRulerLane={}));var y;(function(p){p[p.Inline=1]="Inline",p[p.Gutter=2]="Gutter"})(y=e.MinimapPosition||(e.MinimapPosition={}));var C;(function(p){p[p.TextDefined=0]="TextDefined",p[p.LF=1]="LF",p[p.CRLF=2]="CRLF"})(C=e.EndOfLinePreference||(e.EndOfLinePreference={}));var P;(function(p){p[p.LF=1]="LF",p[p.CRLF=2]="CRLF"})(P=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var D;(function(p){p[p.LF=0]="LF",p[p.CRLF=1]="CRLF"})(D=e.EndOfLineSequence||(e.EndOfLineSequence={}));class _{constructor(v){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,v.tabSize|0),this.indentSize=v.tabSize|0,this.insertSpaces=Boolean(v.insertSpaces),this.defaultEOL=v.defaultEOL|0,this.trimAutoWhitespace=Boolean(v.trimAutoWhitespace),this.bracketPairColorizationOptions=v.bracketPairColorizationOptions}equals(v){return this.tabSize===v.tabSize&&this.indentSize===v.indentSize&&this.insertSpaces===v.insertSpaces&&this.defaultEOL===v.defaultEOL&&this.trimAutoWhitespace===v.trimAutoWhitespace&&(0,m.equals)(this.bracketPairColorizationOptions,v.bracketPairColorizationOptions)}createChangeEvent(v){return{tabSize:this.tabSize!==v.tabSize,indentSize:this.indentSize!==v.indentSize,insertSpaces:this.insertSpaces!==v.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==v.trimAutoWhitespace}}}e.TextModelResolvedOptions=_;class I{constructor(v,T){this._findMatchBrand=void 0,this.range=v,this.matches=T}}e.FindMatch=I;var L;(function(p){p[p.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",p[p.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",p[p.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",p[p.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(L=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var A;(function(p){p[p.Left=0]="Left",p[p.Right=1]="Right",p[p.None=2]="None"})(A=e.PositionAffinity||(e.PositionAffinity={}));var c;(function(p){p[p.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(c=e.ModelConstants||(e.ModelConstants={}));class E{constructor(v,T,b,o,s,g){this.identifier=v,this.range=T,this.text=b,this.forceMoveMarkers=o,this.isAutoWhitespaceEdit=s,this._isTracked=g}}e.ValidAnnotatedEditOperation=E;class h{constructor(v,T,b){this.reverseEdits=v,this.changes=T,this.trimAutoWhitespaceLineNumbers=b}}e.ApplyEditsResult=h}),define(ve[145],we([0,1,8,143,49,41,108]),function(J,e,m,i,y,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const D=999;class _{constructor(o,s,g,l){this.searchString=o,this.isRegex=s,this.matchCase=g,this.wordSeparators=l}parseSearchRequest(){if(this.searchString==="")return null;let o;this.isRegex?o=I(this.searchString):o=this.searchString.indexOf(`
`)>=0;let s=null;try{s=m.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:o,global:!0,unicode:!0})}catch{return null}if(!s)return null;let g=!this.isRegex&&!o;return g&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(g=this.matchCase),new L(s,this.wordSeparators?(0,i.getMapForWordSeparators)(this.wordSeparators):null,g?this.searchString:null)}}e.SearchParams=_;function I(b){if(!b||b.length===0)return!1;for(let o=0,s=b.length;o<s;o++)if(b.charCodeAt(o)===92){if(o++,o>=s)break;const l=b.charCodeAt(o);if(l===110||l===114||l===87)return!0}return!1}e.isMultilineRegexSource=I;class L{constructor(o,s,g){this.regex=o,this.wordSeparators=s,this.simpleSearch=g}}e.SearchData=L;function A(b,o,s){if(!s)return new P.FindMatch(b,null);let g=[];for(let l=0,S=o.length;l<S;l++)g[l]=o[l];return new P.FindMatch(b,g)}e.createFindMatch=A;class c{constructor(o){let s=[],g=0;for(let l=0,S=o.length;l<S;l++)o.charCodeAt(l)===10&&(s[g++]=l);this._lineFeedsOffsets=s}findLineFeedCountBeforeOffset(o){const s=this._lineFeedsOffsets;let g=0,l=s.length-1;if(l===-1||o<=s[0])return 0;for(;g<l;){const S=g+((l-g)/2>>0);s[S]>=o?l=S-1:s[S+1]>=o?(g=S,l=S):g=S+1}return g+1}}class E{static findMatches(o,s,g,l,S){const n=s.parseSearchRequest();return n?n.regex.multiline?this._doFindMatchesMultiline(o,g,new T(n.wordSeparators,n.regex),l,S):this._doFindMatchesLineByLine(o,g,n,l,S):[]}static _getMultilineMatchRange(o,s,g,l,S,n){let t,r=0;l?(r=l.findLineFeedCountBeforeOffset(S),t=s+S+r):t=s+S;let u;if(l){let d=l.findLineFeedCountBeforeOffset(S+n.length)-r;u=t+n.length+d}else u=t+n.length;const a=o.getPositionAt(t),f=o.getPositionAt(u);return new C.Range(a.lineNumber,a.column,f.lineNumber,f.column)}static _doFindMatchesMultiline(o,s,g,l,S){const n=o.getOffsetAt(s.getStartPosition()),t=o.getValueInRange(s,1),r=o.getEOL()===`\r
`?new c(t):null,u=[];let a=0,f;for(g.reset(0);f=g.next(t);)if(u[a++]=A(this._getMultilineMatchRange(o,n,t,r,f.index,f[0]),f,l),a>=S)return u;return u}static _doFindMatchesLineByLine(o,s,g,l,S){const n=[];let t=0;if(s.startLineNumber===s.endLineNumber){const u=o.getLineContent(s.startLineNumber).substring(s.startColumn-1,s.endColumn-1);return t=this._findMatchesInLine(g,u,s.startLineNumber,s.startColumn-1,t,n,l,S),n}const r=o.getLineContent(s.startLineNumber).substring(s.startColumn-1);t=this._findMatchesInLine(g,r,s.startLineNumber,s.startColumn-1,t,n,l,S);for(let u=s.startLineNumber+1;u<s.endLineNumber&&t<S;u++)t=this._findMatchesInLine(g,o.getLineContent(u),u,0,t,n,l,S);if(t<S){const u=o.getLineContent(s.endLineNumber).substring(0,s.endColumn-1);t=this._findMatchesInLine(g,u,s.endLineNumber,0,t,n,l,S)}return n}static _findMatchesInLine(o,s,g,l,S,n,t,r){const u=o.wordSeparators;if(!t&&o.simpleSearch){const w=o.simpleSearch,d=w.length,k=s.length;let R=-d;for(;(R=s.indexOf(w,R+d))!==-1;)if((!u||v(u,s,k,R,d))&&(n[S++]=new P.FindMatch(new C.Range(g,R+1+l,g,R+1+d+l),null),S>=r))return S;return S}const a=new T(o.wordSeparators,o.regex);let f;a.reset(0);do if(f=a.next(s),f&&(n[S++]=A(new C.Range(g,f.index+1+l,g,f.index+1+f[0].length+l),f,t),S>=r))return S;while(f);return S}static findNextMatch(o,s,g,l){const S=s.parseSearchRequest();if(!S)return null;const n=new T(S.wordSeparators,S.regex);return S.regex.multiline?this._doFindNextMatchMultiline(o,g,n,l):this._doFindNextMatchLineByLine(o,g,n,l)}static _doFindNextMatchMultiline(o,s,g,l){const S=new y.Position(s.lineNumber,1),n=o.getOffsetAt(S),t=o.getLineCount(),r=o.getValueInRange(new C.Range(S.lineNumber,S.column,t,o.getLineMaxColumn(t)),1),u=o.getEOL()===`\r
`?new c(r):null;g.reset(s.column-1);let a=g.next(r);return a?A(this._getMultilineMatchRange(o,n,r,u,a.index,a[0]),a,l):s.lineNumber!==1||s.column!==1?this._doFindNextMatchMultiline(o,new y.Position(1,1),g,l):null}static _doFindNextMatchLineByLine(o,s,g,l){const S=o.getLineCount(),n=s.lineNumber,t=o.getLineContent(n),r=this._findFirstMatchInLine(g,t,n,s.column,l);if(r)return r;for(let u=1;u<=S;u++){const a=(n+u-1)%S,f=o.getLineContent(a+1),w=this._findFirstMatchInLine(g,f,a+1,1,l);if(w)return w}return null}static _findFirstMatchInLine(o,s,g,l,S){o.reset(l-1);const n=o.next(s);return n?A(new C.Range(g,n.index+1,g,n.index+1+n[0].length),n,S):null}static findPreviousMatch(o,s,g,l){const S=s.parseSearchRequest();if(!S)return null;const n=new T(S.wordSeparators,S.regex);return S.regex.multiline?this._doFindPreviousMatchMultiline(o,g,n,l):this._doFindPreviousMatchLineByLine(o,g,n,l)}static _doFindPreviousMatchMultiline(o,s,g,l){const S=this._doFindMatchesMultiline(o,new C.Range(1,1,s.lineNumber,s.column),g,l,10*D);if(S.length>0)return S[S.length-1];const n=o.getLineCount();return s.lineNumber!==n||s.column!==o.getLineMaxColumn(n)?this._doFindPreviousMatchMultiline(o,new y.Position(n,o.getLineMaxColumn(n)),g,l):null}static _doFindPreviousMatchLineByLine(o,s,g,l){const S=o.getLineCount(),n=s.lineNumber,t=o.getLineContent(n).substring(0,s.column-1),r=this._findLastMatchInLine(g,t,n,l);if(r)return r;for(let u=1;u<=S;u++){const a=(S+n-u-1)%S,f=o.getLineContent(a+1),w=this._findLastMatchInLine(g,f,a+1,l);if(w)return w}return null}static _findLastMatchInLine(o,s,g,l){let S=null,n;for(o.reset(0);n=o.next(s);)S=A(new C.Range(g,n.index+1,g,n.index+1+n[0].length),n,l);return S}}e.TextModelSearch=E;function h(b,o,s,g,l){if(g===0)return!0;const S=o.charCodeAt(g-1);if(b.get(S)!==0||S===13||S===10)return!0;if(l>0){const n=o.charCodeAt(g);if(b.get(n)!==0)return!0}return!1}function p(b,o,s,g,l){if(g+l===s)return!0;const S=o.charCodeAt(g+l);if(b.get(S)!==0||S===13||S===10)return!0;if(l>0){const n=o.charCodeAt(g+l-1);if(b.get(n)!==0)return!0}return!1}function v(b,o,s,g,l){return h(b,o,s,g,l)&&p(b,o,s,g,l)}e.isValidMatch=v;class T{constructor(o,s){this._wordSeparators=o,this._searchRegex=s,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(o){this._searchRegex.lastIndex=o,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(o){const s=o.length;let g;do{if(this._prevMatchStartIndex+this._prevMatchLength===s||(g=this._searchRegex.exec(o),!g))return null;const l=g.index,S=g[0].length;if(l===this._prevMatchStartIndex&&S===this._prevMatchLength){if(S===0){m.getNextCodePoint(o,s,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=l,this._prevMatchLength=S,!this._wordSeparators||v(this._wordSeparators,o,s,l,S))return g}while(g);return null}}e.Searcher=T}),define(ve[109],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function m(D=""){let _="(-?\\d*\\.\\d\\w*)|([^";for(const I of e.USUAL_WORD_SEPARATORS)D.indexOf(I)>=0||(_+="\\"+I);return _+="\\s]+)",new RegExp(_,"g")}e.DEFAULT_WORD_REGEXP=m();function i(D){let _=e.DEFAULT_WORD_REGEXP;if(D&&D instanceof RegExp)if(D.global)_=D;else{let I="g";D.ignoreCase&&(I+="i"),D.multiline&&(I+="m"),D.unicode&&(I+="u"),_=new RegExp(D.source,I)}return _.lastIndex=0,_}e.ensureValidWordDefinition=i;const y={maxLen:1e3,windowSize:15,timeBudget:150};function C(D,_,I,L,A=y){if(I.length>A.maxLen){let v=D-A.maxLen/2;return v<0?v=0:L+=v,I=I.substring(v,D+A.maxLen/2),C(D,_,I,L,A)}const c=Date.now(),E=D-1-L;let h=-1,p=null;for(let v=1;!(Date.now()-c>=A.timeBudget);v++){const T=E-A.windowSize*v;_.lastIndex=Math.max(0,T);const b=P(_,I,E,h);if(!b&&p||(p=b,T<=0))break;h=T}if(p){let v={word:p[0],startColumn:L+1+p.index,endColumn:L+1+p.index+p[0].length};return _.lastIndex=0,v}return null}e.getWordAtText=C;function P(D,_,I,L){let A;for(;A=D.exec(_);){const c=A.index||0;if(c<=I&&D.lastIndex>=I)return A;if(L>0&&c>L)return null}return null}}),define(ve[146],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var m;(function(P){P[P.None=0]="None",P[P.Indent=1]="Indent",P[P.IndentOutdent=2]="IndentOutdent",P[P.Outdent=3]="Outdent"})(m=e.IndentAction||(e.IndentAction={}));class i{constructor(D){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=D.open,this.close=D.close,this._standardTokenMask=0,Array.isArray(D.notIn))for(let _=0,I=D.notIn.length;_<I;_++)switch(D.notIn[_]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(D){return(this._standardTokenMask&D)==0}shouldAutoClose(D,_){if(D.getTokenCount()===0)return!0;const I=D.findTokenIndexAtOffset(_-2),L=D.getStandardTokenType(I);return this.isOK(L)}_findNeutralCharacterInRange(D,_){for(let I=D;I<=_;I++){const L=String.fromCharCode(I);if(!this.open.includes(L)&&!this.close.includes(L))return L}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=i;class y{constructor(D){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const _ of D)C(this.autoClosingPairsOpenByStart,_.open.charAt(0),_),C(this.autoClosingPairsOpenByEnd,_.open.charAt(_.open.length-1),_),C(this.autoClosingPairsCloseByStart,_.close.charAt(0),_),C(this.autoClosingPairsCloseByEnd,_.close.charAt(_.close.length-1),_),_.close.length===1&&_.open.length===1&&C(this.autoClosingPairsCloseSingleChar,_.close,_)}}e.AutoClosingPairs=y;function C(P,D,_){P.has(D)?P.get(D).push(_):P.set(D,[_])}}),define(ve[82],we([0,1,31,9]),function(J,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function y(C,P,D,_){if(Array.isArray(C)){let I=0;for(const L of C){const A=y(L,P,D,_);if(A===10)return A;A>I&&(I=A)}return I}else{if(typeof C=="string")return _?C==="*"?5:C===D?10:0:0;if(C){const{language:I,pattern:L,scheme:A,hasAccessToAllModels:c}=C;if(!_&&!c)return 0;let E=0;if(A)if(A===P.scheme)E=10;else if(A==="*")E=5;else return 0;if(I)if(I===D)E=10;else if(I==="*")E=Math.max(E,5);else return 0;if(L){let h;if(typeof L=="string"?h=L:h={...L,base:(0,i.normalize)(L.base)},h===P.fsPath||(0,m.match)(h,P.fsPath))E=10;else return 0}return E}else return 0}}e.score=y}),define(ve[147],we([0,1,107]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var i;(function(E){E[E.Invalid=0]="Invalid",E[E.Start=1]="Start",E[E.H=2]="H",E[E.HT=3]="HT",E[E.HTT=4]="HTT",E[E.HTTP=5]="HTTP",E[E.F=6]="F",E[E.FI=7]="FI",E[E.FIL=8]="FIL",E[E.BeforeColon=9]="BeforeColon",E[E.AfterColon=10]="AfterColon",E[E.AlmostThere=11]="AlmostThere",E[E.End=12]="End",E[E.Accept=13]="Accept",E[E.LastKnownState=14]="LastKnownState"})(i=e.State||(e.State={}));class y{constructor(h,p,v){const T=new Uint8Array(h*p);for(let b=0,o=h*p;b<o;b++)T[b]=v;this._data=T,this.rows=h,this.cols=p}get(h,p){return this._data[h*this.cols+p]}set(h,p,v){this._data[h*this.cols+p]=v}}e.Uint8Matrix=y;class C{constructor(h){let p=0,v=0;for(let b=0,o=h.length;b<o;b++){let[s,g,l]=h[b];g>p&&(p=g),s>v&&(v=s),l>v&&(v=l)}p++,v++;let T=new y(v,p,0);for(let b=0,o=h.length;b<o;b++){let[s,g,l]=h[b];T.set(s,g,l)}this._states=T,this._maxCharCode=p}nextState(h,p){return p<0||p>=this._maxCharCode?0:this._states.get(h,p)}}e.StateMachine=C;let P=null;function D(){return P===null&&(P=new C([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),P}var _;(function(E){E[E.None=0]="None",E[E.ForceTermination=1]="ForceTermination",E[E.CannotEndIn=2]="CannotEndIn"})(_||(_={}));let I=null;function L(){if(I===null){I=new m.CharacterClassifier(0);const E=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let p=0;p<E.length;p++)I.set(E.charCodeAt(p),1);const h=".,;";for(let p=0;p<h.length;p++)I.set(h.charCodeAt(p),2)}return I}class A{static _createLink(h,p,v,T,b){let o=b-1;do{const s=p.charCodeAt(o);if(h.get(s)!==2)break;o--}while(o>T);if(T>0){const s=p.charCodeAt(T-1),g=p.charCodeAt(o);(s===40&&g===41||s===91&&g===93||s===123&&g===125)&&o--}return{range:{startLineNumber:v,startColumn:T+1,endLineNumber:v,endColumn:o+2},url:p.substring(T,o+1)}}static computeLinks(h,p=D()){const v=L();let T=[];for(let b=1,o=h.getLineCount();b<=o;b++){const s=h.getLineContent(b),g=s.length;let l=0,S=0,n=0,t=1,r=!1,u=!1,a=!1,f=!1;for(;l<g;){let w=!1;const d=s.charCodeAt(l);if(t===13){let k;switch(d){case 40:r=!0,k=0;break;case 41:k=r?0:1;break;case 91:a=!0,u=!0,k=0;break;case 93:a=!1,k=u?0:1;break;case 123:f=!0,k=0;break;case 125:k=f?0:1;break;case 39:k=n===34||n===96?0:1;break;case 34:k=n===39||n===96?0:1;break;case 96:k=n===39||n===34?0:1;break;case 42:k=n===42?1:0;break;case 124:k=n===124?1:0;break;case 32:k=a?0:1;break;default:k=v.get(d)}k===1&&(T.push(A._createLink(v,s,b,S,l)),w=!0)}else if(t===12){let k;d===91?(u=!0,k=0):k=v.get(d),k===1?w=!0:t=13}else t=p.nextState(t,d),t===0&&(w=!0);w&&(t=1,r=!1,u=!1,f=!1,S=l+1,n=d),l++}t===13&&T.push(A._createLink(v,s,b,S,g))}return T}}e.LinkComputer=A;function c(E){return!E||typeof E.getLineCount!="function"||typeof E.getLineContent!="function"?[]:A.computeLinks(E)}e.computeLinks=c}),define(ve[148],we([0,1,3,6]),function(J,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class y{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new m.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(P){this._onDidChange.fire({changedLanguages:P,changedColorMap:!1})}register(P,D){return this._map.set(P,D),this.fire([P]),(0,i.toDisposable)(()=>{this._map.get(P)===D&&(this._map.delete(P),this.fire([P]))})}registerPromise(P,D){let _=null,I=!1;return this._promises.set(P,D.then(L=>{this._promises.delete(P),!(I||!L)&&(_=this.register(P,L))})),(0,i.toDisposable)(()=>{I=!0,_&&_.dispose()})}getPromise(P){const D=this.get(P);if(D)return Promise.resolve(D);const _=this._promises.get(P);return _?_.then(I=>this.get(P)):null}get(P){return this._map.get(P)||null}setColorMap(P){this._colorMap=P,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=y}),define(ve[110],we([0,1,22,12]),function(J,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var y;(function(A){A[A.Full=1]="Full",A[A.Delta=2]="Delta"})(y||(y={}));function C(A){for(let c=0,E=A.length;c<E;c+=4){const h=A[c+0],p=A[c+1],v=A[c+2],T=A[c+3];A[c+0]=T,A[c+1]=v,A[c+2]=p,A[c+3]=h}}function P(A){const c=new Uint8Array(A.buffer,A.byteOffset,A.length*4);return i.isLittleEndian()||C(c),m.VSBuffer.wrap(c)}function D(A){const c=A.buffer;if(i.isLittleEndian()||C(c),c.byteOffset%4==0)return new Uint32Array(c.buffer,c.byteOffset,c.length/4);{const E=new Uint8Array(c.byteLength);return E.set(c),new Uint32Array(E.buffer,E.byteOffset,E.length/4)}}function _(A){const c=new Uint32Array(I(A));let E=0;if(c[E++]=A.id,A.type==="full")c[E++]=1,c[E++]=A.data.length,c.set(A.data,E),E+=A.data.length;else{c[E++]=2,c[E++]=A.deltas.length;for(const h of A.deltas)c[E++]=h.start,c[E++]=h.deleteCount,h.data?(c[E++]=h.data.length,c.set(h.data,E),E+=h.data.length):c[E++]=0}return P(c)}e.encodeSemanticTokensDto=_;function I(A){let c=0;if(c+=1+1,A.type==="full")c+=1+A.data.length;else{c+=1,c+=(1+1+1)*A.deltas.length;for(const E of A.deltas)E.data&&(c+=E.data.length)}return c}function L(A){const c=D(A);let E=0;const h=c[E++];if(c[E++]===1){const b=c[E++],o=c.subarray(E,E+b);return E+=b,{id:h,type:"full",data:o}}const v=c[E++];let T=[];for(let b=0;b<v;b++){const o=c[E++],s=c[E++],g=c[E++];let l;g>0&&(l=c.subarray(E,E+g),E+=g),T[b]={start:o,deleteCount:s,data:l}}return{id:h,type:"delta",deltas:T}}e.decodeSemanticTokensDto=L}),define(ve[111],we([0,1,16,98]),function(J,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class y{constructor(_){this.values=_,this.prefixSum=new Uint32Array(_.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(_,I){_=(0,i.toUint32)(_);const L=this.values,A=this.prefixSum,c=I.length;return c===0?!1:(this.values=new Uint32Array(L.length+c),this.values.set(L.subarray(0,_),0),this.values.set(L.subarray(_),_+c),this.values.set(I,_),_-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=_-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(A.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(_,I){return _=(0,i.toUint32)(_),I=(0,i.toUint32)(I),this.values[_]===I?!1:(this.values[_]=I,_-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=_-1),!0)}removeValues(_,I){_=(0,i.toUint32)(_),I=(0,i.toUint32)(I);const L=this.values,A=this.prefixSum;if(_>=L.length)return!1;let c=L.length-_;return I>=c&&(I=c),I===0?!1:(this.values=new Uint32Array(L.length-I),this.values.set(L.subarray(0,_),0),this.values.set(L.subarray(_+I),_),this.prefixSum=new Uint32Array(this.values.length),_-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=_-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(A.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(_){return _<0?0:(_=(0,i.toUint32)(_),this._getPrefixSum(_))}_getPrefixSum(_){if(_<=this.prefixSumValidIndex[0])return this.prefixSum[_];let I=this.prefixSumValidIndex[0]+1;I===0&&(this.prefixSum[0]=this.values[0],I++),_>=this.values.length&&(_=this.values.length-1);for(let L=I;L<=_;L++)this.prefixSum[L]=this.prefixSum[L-1]+this.values[L];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],_),this.prefixSum[_]}getIndexOf(_){_=Math.floor(_),this.getTotalSum();let I=0,L=this.values.length-1,A=0,c=0,E=0;for(;I<=L;)if(A=I+(L-I)/2|0,c=this.prefixSum[A],E=c-this.values[A],_<E)L=A-1;else if(_>=c)I=A+1;else break;return new P(A,_-E)}}e.PrefixSumComputer=y;class C{constructor(_){this._values=_,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(_){return this._ensureValid(),_===0?0:this._prefixSum[_-1]}getIndexOf(_){this._ensureValid();const I=this._indexBySum[_],L=I>0?this._prefixSum[I-1]:0;return new P(I,_-L)}removeValues(_,I){this._values.splice(_,I),this._invalidate(_)}insertValues(_,I){this._values=(0,m.arrayInsert)(this._values,_,I),this._invalidate(_)}_invalidate(_){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,_-1)}_ensureValid(){if(!this._isValid){for(let _=this._validEndIndex+1,I=this._values.length;_<I;_++){const L=this._values[_],A=_>0?this._prefixSum[_-1]:0;this._prefixSum[_]=A+L;for(let c=0;c<L;c++)this._indexBySum[A+c]=_}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(_,I){this._values[_]!==I&&(this._values[_]=I,this._invalidate(_))}}e.ConstantTimePrefixSumComputer=C;class P{constructor(_,I){this.index=_,this.remainder=I,this._prefixSumIndexOfResultBrand=void 0,this.index=_,this.remainder=I}}e.PrefixSumIndexOfResult=P}),define(ve[149],we([0,1,8,49,111]),function(J,e,m,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class C{constructor(D,_,I,L){this._uri=D,this._lines=_,this._eol=I,this._versionId=L,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(D){D.eol&&D.eol!==this._eol&&(this._eol=D.eol,this._lineStarts=null);const _=D.changes;for(const I of _)this._acceptDeleteRange(I.range),this._acceptInsertText(new i.Position(I.range.startLineNumber,I.range.startColumn),I.text);this._versionId=D.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const D=this._eol.length,_=this._lines.length,I=new Uint32Array(_);for(let L=0;L<_;L++)I[L]=this._lines[L].length+D;this._lineStarts=new y.PrefixSumComputer(I)}}_setLineText(D,_){this._lines[D]=_,this._lineStarts&&this._lineStarts.setValue(D,this._lines[D].length+this._eol.length)}_acceptDeleteRange(D){if(D.startLineNumber===D.endLineNumber){if(D.startColumn===D.endColumn)return;this._setLineText(D.startLineNumber-1,this._lines[D.startLineNumber-1].substring(0,D.startColumn-1)+this._lines[D.startLineNumber-1].substring(D.endColumn-1));return}this._setLineText(D.startLineNumber-1,this._lines[D.startLineNumber-1].substring(0,D.startColumn-1)+this._lines[D.endLineNumber-1].substring(D.endColumn-1)),this._lines.splice(D.startLineNumber,D.endLineNumber-D.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(D.startLineNumber,D.endLineNumber-D.startLineNumber)}_acceptInsertText(D,_){if(_.length===0)return;let I=(0,m.splitLines)(_);if(I.length===1){this._setLineText(D.lineNumber-1,this._lines[D.lineNumber-1].substring(0,D.column-1)+I[0]+this._lines[D.lineNumber-1].substring(D.column-1));return}I[I.length-1]+=this._lines[D.lineNumber-1].substring(D.column-1),this._setLineText(D.lineNumber-1,this._lines[D.lineNumber-1].substring(0,D.column-1)+I[0]);let L=new Uint32Array(I.length-1);for(let A=1;A<I.length;A++)this._lines.splice(D.lineNumber+A-1,0,I[A]),L[A-1]=I[A].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(D.lineNumber,L)}}e.MirrorTextModel=C}),define(ve[150],we([19,20]),function(J,e){return J.create("vs/base/common/date",e)}),define(ve[151],we([0,1,150]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const i=60,y=i*60,C=y*24,P=C*7,D=C*30,_=C*365;function I(A,c){typeof A!="number"&&(A=A.getTime());const E=Math.round((new Date().getTime()-A)/1e3);if(E<-30)return(0,m.localize)(0,null,I(new Date().getTime()+E*1e3,!1));if(E<30)return(0,m.localize)(1,null);let h;return E<i?(h=E,c?h===1?(0,m.localize)(2,null,h):(0,m.localize)(3,null,h):h===1?(0,m.localize)(4,null,h):(0,m.localize)(5,null,h)):E<y?(h=Math.floor(E/i),c?h===1?(0,m.localize)(6,null,h):(0,m.localize)(7,null,h):h===1?(0,m.localize)(8,null,h):(0,m.localize)(9,null,h)):E<C?(h=Math.floor(E/y),c?h===1?(0,m.localize)(10,null,h):(0,m.localize)(11,null,h):h===1?(0,m.localize)(12,null,h):(0,m.localize)(13,null,h)):E<P?(h=Math.floor(E/C),c?h===1?(0,m.localize)(14,null,h):(0,m.localize)(15,null,h):h===1?(0,m.localize)(16,null,h):(0,m.localize)(17,null,h)):E<D?(h=Math.floor(E/P),c?h===1?(0,m.localize)(18,null,h):(0,m.localize)(19,null,h):h===1?(0,m.localize)(20,null,h):(0,m.localize)(21,null,h)):E<_?(h=Math.floor(E/D),c?h===1?(0,m.localize)(22,null,h):(0,m.localize)(23,null,h):h===1?(0,m.localize)(24,null,h):(0,m.localize)(25,null,h)):(h=Math.floor(E/_),c?h===1?(0,m.localize)(26,null,h):(0,m.localize)(27,null,h):h===1?(0,m.localize)(28,null,h):(0,m.localize)(29,null,h))}e.fromNow=I;function L(A){return A.getFullYear()+"-"+String(A.getMonth()+1).padStart(2,"0")+"-"+String(A.getDate()).padStart(2,"0")+"T"+String(A.getHours()).padStart(2,"0")+":"+String(A.getMinutes()).padStart(2,"0")+":"+String(A.getSeconds()).padStart(2,"0")+"."+(A.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=L}),define(ve[152],we([19,20]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(ve[50],we([0,1,16,13,152]),function(J,e,m,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function C(I,L){return L&&(I.stack||I.stacktrace)?y.localize(0,null,D(I),P(I.stack)||P(I.stacktrace)):D(I)}function P(I){return Array.isArray(I)?I.join(`
`):I}function D(I){return typeof I.code=="string"&&typeof I.errno=="number"&&typeof I.syscall=="string"?y.localize(1,null,I.message):I.message||y.localize(2,null)}function _(I=null,L=!1){if(!I)return y.localize(3,null);if(Array.isArray(I)){const A=m.coalesce(I),c=_(A[0],L);return A.length>1?y.localize(4,null,c,A.length):c}if(i.isString(I))return I;if(I.detail){const A=I.detail;if(A.error)return C(A.error,L);if(A.exception)return C(A.exception,L)}return I.stack?C(I,L):I.message?I.message:y.localize(5,null)}e.toErrorMessage=_}),define(ve[153],we([19,20]),function(J,e){return J.create("vs/base/node/processes",e)}),define(ve[112],we([0,1,37,30,10,25,9,12,40,94,13,142,28,153]),function(J,e,m,i,y,C,P,D,_,I,L,A,c,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return I.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return I.TerminateResponseCode}});function h(l){switch(l){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function p(l,S){if(D.isWindows)try{const n={stdio:["pipe","pipe","ignore"]};S&&(n.cwd=S);const t=m.execFile("taskkill",["/T","/F","/PID",l.pid.toString()],n);return new Promise(r=>{t.once("error",u=>{r({success:!1,error:u})}),t.once("exit",(u,a)=>{r(u===0?{success:!0}:{success:!1,code:u!==null?u:1})})})}catch(n){return Promise.resolve({success:!1,error:n,code:n.status?h(n.status):1})}else if(D.isLinux||D.isMacintosh)try{const n=y.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",J).fsPath;return new Promise(t=>{m.execFile(n,[l.pid.toString()],{encoding:"utf8",shell:!0},(r,u,a)=>{t(r?{success:!1,error:r}:{success:!0})})})}catch(n){return Promise.resolve({success:!1,error:n})}else l.kill("SIGKILL");return Promise.resolve({success:!0})}function v(l){!l||(delete l.DEBUG,D.isMacintosh&&delete l.DYLD_LIBRARY_PATH,D.isLinux&&delete l.LD_PRELOAD)}e.removeDangerousEnvVariables=v;function T(l=_.env){return l.comspec||"cmd.exe"}e.getWindowsShell=T;class b{constructor(S,n,t,r){if(n!==void 0&&t!==void 0&&r!==void 0)this.cmd=S,this.args=n,this.shell=t,this.options=r;else{const u=S;this.cmd=u.command,this.shell=u.isShellCommand,this.args=u.args.slice(0),this.options=u.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const u=Object.create(null);Object.keys(_.env).forEach(a=>{u[a]=_.env[a]}),Object.keys(this.options.env).forEach(a=>{u[a]=this.options.env[a]}),this.options.env=u}}getSanitizedCommand(){let S=this.cmd.toLowerCase();const n=S.lastIndexOf(P.sep);return n!==-1&&(S=S.substring(n+1)),b.WellKnowCommands[S]?S:"other"}start(S){return D.isWindows&&(this.options&&this.options.cwd&&i.isUNC(this.options.cwd)||!this.options&&i.isUNC(_.cwd()))?Promise.reject(new Error(E.localize(0,null))):this.useExec().then(n=>{let t,r;const u=new Promise((a,f)=>{t=a,r=f});if(n){let a=this.cmd;this.args&&(a=a+" "+this.args.join(" ")),this.childProcess=m.exec(a,this.options,(f,w,d)=>{this.childProcess=null;const k=f;k&&k.killed?r({killed:this.terminateRequested,stdout:w.toString(),stderr:d.toString()}):this.handleExec(t,S,f,w,d)})}else{let a=null;const f=w=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(w,t,S,r);const d={terminated:this.terminateRequested};L.isNumber(w)&&(d.cmdCode=w),t(d)};if(this.shell&&D.isWindows){const w=C.deepClone(this.options);w.windowsVerbatimArguments=!0,w.detached=!1;let d=!1,k=!1;const R=[];let N=this.ensureQuotes(this.cmd);R.push(N.value),d=N.quoted,this.args&&this.args.forEach(F=>{N=this.ensureQuotes(F),R.push(N.value),k=k&&N.quoted});const x=["/s","/c"];d?k?x.push('"'+R.join(" ")+'"'):R.length>1?x.push('"'+R[0]+'" '+R.slice(1).join(" ")):x.push('"'+R[0]+'"'):x.push(R.join(" ")),a=m.spawn(T(),x,w)}else this.cmd&&(a=m.spawn(this.cmd,this.args,this.options));a&&(this.childProcess=a,this.childProcessPromise=Promise.resolve(a),this.pidResolve&&(this.pidResolve(L.isNumber(a.pid)?a.pid:-1),this.pidResolve=void 0),a.on("error",w=>{this.childProcess=null,r({terminated:this.terminateRequested,error:w})}),a.pid&&(this.childProcess.on("close",f),this.handleSpawn(a,t,S,r,!0)))}return u})}handleClose(S,n,t,r){}ensureQuotes(S){return b.regexp.test(S)?{value:'"'+S+'"',quoted:!0}:{value:S,quoted:S.length>0&&S[0]==='"'&&S[S.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(S=>S.pid,S=>-1):new Promise(S=>{this.pidResolve=S})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(S=>(this.terminateRequested=!0,p(S,this.options.cwd).then(n=>(n.success&&(this.childProcess=null),n))),S=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(S=>{if(!this.shell||!D.isWindows)return S(!1);const n=m.spawn(T(),["/s","/c"]);n.on("error",t=>S(!0)),n.on("exit",t=>S(!1))})}}e.AbstractProcess=b,b.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},b.regexp=/^[^"].* .*[^"]/;class o extends b{constructor(S,n,t,r){super(S,n,t,r);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(S,n,t,r,u){[r,u].forEach((a,f)=>{const w=new A.LineDecoder;w.write(a).forEach(R=>{n({line:R,source:f===0?0:1})});const k=w.end();k&&n({line:k,source:f===0?0:1})}),S({terminated:this.terminateRequested,error:t})}handleSpawn(S,n,t,r,u){const a=new A.LineDecoder,f=new A.LineDecoder;S.stdout.on("data",w=>{a.write(w).forEach(k=>t({line:k,source:0}))}),S.stderr.on("data",w=>{f.write(w).forEach(k=>t({line:k,source:1}))}),this.stdoutLineDecoder=a,this.stderrLineDecoder=f}handleClose(S,n,t,r){const u=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;u&&t({line:u,source:0});const a=this.stderrLineDecoder?this.stderrLineDecoder.end():null;a&&t({line:a,source:1})}}e.LineProcess=o;function s(l){let S=[],n=!1;const t=function(r){if(n){S.push(r);return}(!l.send(r,a=>{if(a&&console.error(a),n=!1,S.length>0){const f=S.slice(0);S=[],f.forEach(w=>t(w))}})||D.isWindows)&&(n=!0)};return{send:t}}e.createQueuedSender=s;var g;(function(l){async function S(n,t,r){if(P.isAbsolute(n))return n;if(t===void 0&&(t=_.cwd()),P.dirname(n)!=="."||(r===void 0&&L.isString(_.env.PATH)&&(r=_.env.PATH.split(P.delimiter)),r===void 0||r.length===0))return P.join(t,n);async function a(f){if(await c.Promises.exists(f)){let w;try{w=await c.Promises.stat(f)}catch(d){d.message.startsWith("EACCES")&&(w=await c.Promises.lstat(f))}return w?!w.isDirectory():!1}return!1}for(let f of r){let w;if(P.isAbsolute(f)?w=P.join(f,n):w=P.join(t,f,n),await a(w))return w;let d=w+".com";if(await a(d)||(d=w+".exe",await a(d)))return d}return P.join(t,n)}l.findExecutable=S})(g=e.win32||(e.win32={}))}),define(ve[154],we([19,20]),function(J,e){return J.create("vs/editor/common/config/editorOptions",e)}),define(ve[113],we([0,1,154,12,109,16,25]),function(J,e,m,i,y,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var D;(function(ee){ee[ee.None=0]="None",ee[ee.Keep=1]="Keep",ee[ee.Brackets=2]="Brackets",ee[ee.Advanced=3]="Advanced",ee[ee.Full=4]="Full"})(D=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class _{constructor(ne){this._values=ne}hasChanged(ne){return this._values[ne]}}e.ConfigurationChangedEvent=_;class I{constructor(){this._values=[]}_read(ne){return this._values[ne]}get(ne){return this._values[ne]}_write(ne,pe){this._values[ne]=pe}}e.ValidatedEditorOptions=I;class L{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=L;class A{constructor(ne,pe,ie,Se){this.id=ne,this.name=pe,this.defaultValue=ie,this.schema=Se}applyUpdate(ne,pe){return E(ne,pe)}compute(ne,pe,ie){return ie}}class c{constructor(ne,pe){this.newValue=ne,this.didChange=pe}}e.ApplyUpdateResult=c;function E(ee,ne){if(typeof ee!="object"||typeof ne!="object"||!ee||!ne)return new c(ne,ee!==ne);if(Array.isArray(ee)||Array.isArray(ne)){const ie=Array.isArray(ee)&&Array.isArray(ne)&&C.equals(ee,ne);return new c(ne,ie)}let pe=!1;for(let ie in ne)if(ne.hasOwnProperty(ie)){const Se=E(ee[ie],ne[ie]);Se.didChange&&(ee[ie]=Se.newValue,pe=!0)}return new c(ee,pe)}class h{constructor(ne){this.schema=void 0,this.id=ne,this.name="_never_",this.defaultValue=void 0}applyUpdate(ne,pe){return E(ne,pe)}validate(ne){return this.defaultValue}}class p{constructor(ne,pe,ie,Se){this.id=ne,this.name=pe,this.defaultValue=ie,this.schema=Se}applyUpdate(ne,pe){return E(ne,pe)}validate(ne){return typeof ne=="undefined"?this.defaultValue:ne}compute(ne,pe,ie){return ie}}function v(ee,ne){return typeof ee=="undefined"?ne:ee==="false"?!1:Boolean(ee)}e.boolean=v;class T extends p{constructor(ne,pe,ie,Se=void 0){typeof Se!="undefined"&&(Se.type="boolean",Se.default=ie);super(ne,pe,ie,Se)}validate(ne){return v(ne,this.defaultValue)}}function b(ee,ne,pe,ie){if(typeof ee=="undefined")return ne;let Se=parseInt(ee,10);return isNaN(Se)?ne:(Se=Math.max(pe,Se),Se=Math.min(ie,Se),Se|0)}e.clampedInt=b;class o extends p{constructor(ne,pe,ie,Se,Fe,Ue=void 0){typeof Ue!="undefined"&&(Ue.type="integer",Ue.default=ie,Ue.minimum=Se,Ue.maximum=Fe);super(ne,pe,ie,Ue);this.minimum=Se,this.maximum=Fe}static clampedInt(ne,pe,ie,Se){return b(ne,pe,ie,Se)}validate(ne){return o.clampedInt(ne,this.defaultValue,this.minimum,this.maximum)}}class s extends p{constructor(ne,pe,ie,Se,Fe){typeof Fe!="undefined"&&(Fe.type="number",Fe.default=ie);super(ne,pe,ie,Fe);this.validationFn=Se}static clamp(ne,pe,ie){return ne<pe?pe:ne>ie?ie:ne}static float(ne,pe){if(typeof ne=="number")return ne;if(typeof ne=="undefined")return pe;const ie=parseFloat(ne);return isNaN(ie)?pe:ie}validate(ne){return this.validationFn(s.float(ne,this.defaultValue))}}class g extends p{static string(ne,pe){return typeof ne!="string"?pe:ne}constructor(ne,pe,ie,Se=void 0){typeof Se!="undefined"&&(Se.type="string",Se.default=ie);super(ne,pe,ie,Se)}validate(ne){return g.string(ne,this.defaultValue)}}function l(ee,ne,pe){return typeof ee!="string"||pe.indexOf(ee)===-1?ne:ee}e.stringSet=l;class S extends p{constructor(ne,pe,ie,Se,Fe=void 0){typeof Fe!="undefined"&&(Fe.type="string",Fe.enum=Se,Fe.default=ie);super(ne,pe,ie,Fe);this._allowedValues=Se}validate(ne){return l(ne,this.defaultValue,this._allowedValues)}}class n extends A{constructor(ne,pe,ie,Se,Fe,Ue,Xe=void 0){typeof Xe!="undefined"&&(Xe.type="string",Xe.enum=Fe,Xe.default=Se);super(ne,pe,ie,Xe);this._allowedValues=Fe,this._convert=Ue}validate(ne){return typeof ne!="string"?this.defaultValue:this._allowedValues.indexOf(ne)===-1?this.defaultValue:this._convert(ne)}}function t(ee){switch(ee){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class r extends A{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[m.localize(0,null),m.localize(1,null),m.localize(2,null)],default:"auto",description:m.localize(3,null)})}validate(ne){switch(ne){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ne,pe,ie){return ie===0?ne.accessibilitySupport:ie}}class u extends A{constructor(){const ne={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",ne,{"editor.comments.insertSpace":{type:"boolean",default:ne.insertSpace,description:m.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ne.ignoreEmptyLines,description:m.localize(5,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const pe=ne;return{insertSpace:v(pe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:v(pe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var a;(function(ee){ee[ee.Hidden=0]="Hidden",ee[ee.Blink=1]="Blink",ee[ee.Smooth=2]="Smooth",ee[ee.Phase=3]="Phase",ee[ee.Expand=4]="Expand",ee[ee.Solid=5]="Solid"})(a=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function f(ee){switch(ee){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var w;(function(ee){ee[ee.Line=1]="Line",ee[ee.Block=2]="Block",ee[ee.Underline=3]="Underline",ee[ee.LineThin=4]="LineThin",ee[ee.BlockOutline=5]="BlockOutline",ee[ee.UnderlineThin=6]="UnderlineThin"})(w=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function d(ee){switch(ee){case w.Line:return"line";case w.Block:return"block";case w.Underline:return"underline";case w.LineThin:return"line-thin";case w.BlockOutline:return"block-outline";case w.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=d;function k(ee){switch(ee){case"line":return w.Line;case"block":return w.Block;case"underline":return w.Underline;case"line-thin":return w.LineThin;case"block-outline":return w.BlockOutline;case"underline-thin":return w.UnderlineThin}}class R extends h{constructor(){super(127)}compute(ne,pe,ie){const Se=["monaco-editor"];return pe.get(33)&&Se.push(pe.get(33)),ne.extraEditorClassName&&Se.push(ne.extraEditorClassName),pe.get(65)==="default"?Se.push("mouse-default"):pe.get(65)==="copy"&&Se.push("mouse-copy"),pe.get(99)&&Se.push("showUnused"),pe.get(125)&&Se.push("showDeprecated"),Se.join(" ")}}class N extends T{constructor(){super(32,"emptySelectionClipboard",!0,{description:m.localize(6,null)})}compute(ne,pe,ie){return ie&&ne.emptySelectionClipboard}}class x extends A{constructor(){const ne={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(35,"find",ne,{"editor.find.cursorMoveOnType":{type:"boolean",default:ne.cursorMoveOnType,description:m.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:ne.seedSearchStringFromSelection,enumDescriptions:[m.localize(8,null),m.localize(9,null),m.localize(10,null)],description:m.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ne.autoFindInSelection,enumDescriptions:[m.localize(12,null),m.localize(13,null),m.localize(14,null)],description:m.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ne.globalFindClipboard,description:m.localize(16,null),included:i.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ne.addExtraSpaceOnTop,description:m.localize(17,null)},"editor.find.loop":{type:"boolean",default:ne.loop,description:m.localize(18,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const pe=ne;return{cursorMoveOnType:v(pe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof ne.seedSearchStringFromSelection=="boolean"?ne.seedSearchStringFromSelection?"always":"never":l(pe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof ne.autoFindInSelection=="boolean"?ne.autoFindInSelection?"always":"never":l(pe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:v(pe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:v(pe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:v(pe.loop,this.defaultValue.loop)}}}class F extends A{constructor(){super(44,"fontLigatures",F.OFF,{anyOf:[{type:"boolean",description:m.localize(19,null)},{type:"string",description:m.localize(20,null)}],description:m.localize(21,null),default:!1})}validate(ne){return typeof ne=="undefined"?this.defaultValue:typeof ne=="string"?ne==="false"?F.OFF:ne==="true"?F.ON:ne:Boolean(ne)?F.ON:F.OFF}}e.EditorFontLigatures=F,F.OFF='"liga" off, "calt" off',F.ON='"liga" on, "calt" on';class B extends h{constructor(){super(43)}compute(ne,pe,ie){return ne.fontInfo}}class O extends p{constructor(){super(45,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:m.localize(22,null)})}validate(ne){let pe=s.float(ne,this.defaultValue);return pe===0?e.EDITOR_FONT_DEFAULTS.fontSize:s.clamp(pe,6,100)}compute(ne,pe,ie){return ne.fontInfo.fontSize}}class H extends A{constructor(){super(46,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:H.MINIMUM_VALUE,maximum:H.MAXIMUM_VALUE,errorMessage:m.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:H.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:m.localize(24,null)})}validate(ne){return ne==="normal"||ne==="bold"?ne:String(o.clampedInt(ne,e.EDITOR_FONT_DEFAULTS.fontWeight,H.MINIMUM_VALUE,H.MAXIMUM_VALUE))}}H.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],H.MINIMUM_VALUE=1,H.MAXIMUM_VALUE=1e3;class M extends A{constructor(){const ne={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},pe={type:"string",enum:["peek","gotoAndPeek","goto"],default:ne.multiple,enumDescriptions:[m.localize(25,null),m.localize(26,null),m.localize(27,null)]},ie=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(50,"gotoLocation",ne,{"editor.gotoLocation.multiple":{deprecationMessage:m.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:m.localize(29,null),...pe},"editor.gotoLocation.multipleTypeDefinitions":{description:m.localize(30,null),...pe},"editor.gotoLocation.multipleDeclarations":{description:m.localize(31,null),...pe},"editor.gotoLocation.multipleImplementations":{description:m.localize(32,null),...pe},"editor.gotoLocation.multipleReferences":{description:m.localize(33,null),...pe},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ne.alternativeDefinitionCommand,enum:ie,description:m.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ne.alternativeTypeDefinitionCommand,enum:ie,description:m.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ne.alternativeDeclarationCommand,enum:ie,description:m.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ne.alternativeImplementationCommand,enum:ie,description:m.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ne.alternativeReferenceCommand,enum:ie,description:m.localize(38,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const pe=ne;return{multiple:l(pe.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:pe.multipleDefinitions??l(pe.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:pe.multipleTypeDefinitions??l(pe.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:pe.multipleDeclarations??l(pe.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:pe.multipleImplementations??l(pe.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:pe.multipleReferences??l(pe.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:g.string(pe.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:g.string(pe.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:g.string(pe.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:g.string(pe.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:g.string(pe.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class W extends A{constructor(){const ne={enabled:!0,delay:300,sticky:!0,above:!0};super(52,"hover",ne,{"editor.hover.enabled":{type:"boolean",default:ne.enabled,description:m.localize(39,null)},"editor.hover.delay":{type:"number",default:ne.delay,description:m.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:ne.sticky,description:m.localize(41,null)},"editor.hover.above":{type:"boolean",default:ne.above,description:m.localize(42,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const pe=ne;return{enabled:v(pe.enabled,this.defaultValue.enabled),delay:o.clampedInt(pe.delay,this.defaultValue.delay,0,1e4),sticky:v(pe.sticky,this.defaultValue.sticky),above:v(pe.above,this.defaultValue.above)}}}var z;(function(ee){ee[ee.None=0]="None",ee[ee.Text=1]="Text",ee[ee.Blocks=2]="Blocks"})(z=e.RenderMinimap||(e.RenderMinimap={}));class U extends h{constructor(){super(130)}compute(ne,pe,ie){return U.computeLayout(pe,{memory:ne.memory,outerWidth:ne.outerWidth,outerHeight:ne.outerHeight,isDominatedByLongLines:ne.isDominatedByLongLines,lineHeight:ne.fontInfo.lineHeight,viewLineCount:ne.viewLineCount,lineNumbersDigitCount:ne.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ne.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ne.fontInfo.maxDigitWidth,pixelRatio:ne.pixelRatio})}static computeContainedMinimapLineCount(ne){const pe=ne.height/ne.lineHeight,ie=ne.scrollBeyondLastLine?pe-1:0,Se=(ne.viewLineCount+ie)/(ne.pixelRatio*ne.height),Fe=Math.floor(ne.viewLineCount/Se);return{typicalViewportLineCount:pe,extraLinesBeyondLastLine:ie,desiredRatio:Se,minimapLineCount:Fe}}static _computeMinimapLayout(ne,pe){const ie=ne.outerWidth,Se=ne.outerHeight,Fe=ne.pixelRatio;if(!ne.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Fe*Se),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Se};const Ue=pe.stableMinimapLayoutInput,Xe=Ue&&ne.outerHeight===Ue.outerHeight&&ne.lineHeight===Ue.lineHeight&&ne.typicalHalfwidthCharacterWidth===Ue.typicalHalfwidthCharacterWidth&&ne.pixelRatio===Ue.pixelRatio&&ne.scrollBeyondLastLine===Ue.scrollBeyondLastLine&&ne.minimap.enabled===Ue.minimap.enabled&&ne.minimap.side===Ue.minimap.side&&ne.minimap.size===Ue.minimap.size&&ne.minimap.showSlider===Ue.minimap.showSlider&&ne.minimap.renderCharacters===Ue.minimap.renderCharacters&&ne.minimap.maxColumn===Ue.minimap.maxColumn&&ne.minimap.scale===Ue.minimap.scale&&ne.verticalScrollbarWidth===Ue.verticalScrollbarWidth&&ne.isViewportWrapping===Ue.isViewportWrapping,Ae=ne.lineHeight,Pe=ne.typicalHalfwidthCharacterWidth,ye=ne.scrollBeyondLastLine,ce=ne.minimap.renderCharacters;let de=Fe>=2?Math.round(ne.minimap.scale*2):ne.minimap.scale;const be=ne.minimap.maxColumn,Ce=ne.minimap.size,Me=ne.minimap.side,Ke=ne.verticalScrollbarWidth,He=ne.viewLineCount,Qe=ne.remainingWidth,st=ne.isViewportWrapping,at=ce?2:3;let he=Math.floor(Fe*Se);const De=he/Fe;let le=!1,X=!1,ke=at*de,Le=de/Fe,Ze=1;if(Ce==="fill"||Ce==="fit"){const{typicalViewportLineCount:vt,extraLinesBeyondLastLine:_t,desiredRatio:Ot,minimapLineCount:It}=U.computeContainedMinimapLineCount({viewLineCount:He,scrollBeyondLastLine:ye,height:Se,lineHeight:Ae,pixelRatio:Fe});if(He/It>1)le=!0,X=!0,de=1,ke=1,Le=de/Fe;else{let Lt=!1,St=de+1;if(Ce==="fit"){const Mt=Math.ceil((He+_t)*ke);st&&Xe&&Qe<=pe.stableFitRemainingWidth?(Lt=!0,St=pe.stableFitMaxMinimapScale):Lt=Mt>he}if(Ce==="fill"||Lt){le=!0;const Mt=de;ke=Math.min(Ae*Fe,Math.max(1,Math.floor(1/Ot))),st&&Xe&&Qe<=pe.stableFitRemainingWidth&&(St=pe.stableFitMaxMinimapScale),de=Math.min(St,Math.max(1,Math.floor(ke/at))),de>Mt&&(Ze=Math.min(2,de/Mt)),Le=de/Fe/Ze,he=Math.ceil(Math.max(vt,He+_t)*ke),st?(pe.stableMinimapLayoutInput=ne,pe.stableFitRemainingWidth=Qe,pe.stableFitMaxMinimapScale=de):(pe.stableMinimapLayoutInput=null,pe.stableFitRemainingWidth=0)}}}const qe=Math.floor(be*Le),dt=Math.min(qe,Math.max(0,Math.floor((Qe-Ke-2)*Le/(Pe+Le)))+e.MINIMAP_GUTTER_WIDTH);let wt=Math.floor(Fe*dt);const yt=wt/Fe;wt=Math.floor(wt*Ze);const bt=ce?1:2,ft=Me==="left"?0:ie-dt-Ke;return{renderMinimap:bt,minimapLeft:ft,minimapWidth:dt,minimapHeightIsEditorHeight:le,minimapIsSampling:X,minimapScale:de,minimapLineHeight:ke,minimapCanvasInnerWidth:wt,minimapCanvasInnerHeight:he,minimapCanvasOuterWidth:yt,minimapCanvasOuterHeight:De}}static computeLayout(ne,pe){const ie=pe.outerWidth|0,Se=pe.outerHeight|0,Fe=pe.lineHeight|0,Ue=pe.lineNumbersDigitCount|0,Xe=pe.typicalHalfwidthCharacterWidth,Ae=pe.maxDigitWidth,Pe=pe.pixelRatio,ye=pe.viewLineCount,ce=ne.get(122),de=ce==="inherit"?ne.get(121):ce,be=de==="inherit"?ne.get(117):de,Ce=ne.get(120),Me=ne.get(2),Ke=pe.isDominatedByLongLines,He=ne.get(49),Qe=ne.get(59).renderType!==0,st=ne.get(60),at=ne.get(93),he=ne.get(64),De=ne.get(91),le=De.verticalScrollbarSize,X=De.verticalHasArrows,ke=De.arrowSize,Le=De.horizontalScrollbarSize,Ze=ne.get(57),qe=ne.get(37);let dt;if(typeof Ze=="string"&&/^\d+(\.\d+)?ch$/.test(Ze)){const Wt=parseFloat(Ze.substr(0,Ze.length-2));dt=o.clampedInt(Wt*Xe,0,0,1e3)}else dt=o.clampedInt(Ze,0,0,1e3);qe&&(dt+=16);let wt=0;if(Qe){const Wt=Math.max(Ue,st);wt=Math.round(Wt*Ae)}let yt=0;He&&(yt=Fe);let bt=0,ft=bt+yt,vt=ft+wt,_t=vt+dt;const Ot=ie-yt-wt-dt;let It=!1,Tt=!1,Lt=-1;Me!==2&&(de==="inherit"&&Ke?(It=!0,Tt=!0):be==="on"||be==="bounded"?Tt=!0:be==="wordWrapColumn"&&(Lt=Ce));const St=U._computeMinimapLayout({outerWidth:ie,outerHeight:Se,lineHeight:Fe,typicalHalfwidthCharacterWidth:Xe,pixelRatio:Pe,scrollBeyondLastLine:at,minimap:he,verticalScrollbarWidth:le,viewLineCount:ye,remainingWidth:Ot,isViewportWrapping:Tt},pe.memory||new L);St.renderMinimap!==0&&St.minimapLeft===0&&(bt+=St.minimapWidth,ft+=St.minimapWidth,vt+=St.minimapWidth,_t+=St.minimapWidth);const Mt=Ot-St.minimapWidth,Nt=Math.max(1,Math.floor((Mt-le-2)/Xe)),Et=X?ke:0;return Tt&&(Lt=Math.max(1,Nt),be==="bounded"&&(Lt=Math.min(Lt,Ce))),{width:ie,height:Se,glyphMarginLeft:bt,glyphMarginWidth:yt,lineNumbersLeft:ft,lineNumbersWidth:wt,decorationsLeft:vt,decorationsWidth:dt,contentLeft:_t,contentWidth:Mt,minimap:St,viewportColumn:Nt,isWordWrapMinified:It,isViewportWrapping:Tt,wrappingColumn:Lt,verticalScrollbarWidth:le,horizontalScrollbarHeight:Le,overviewRuler:{top:Et,width:le,height:Se-2*Et,right:0}}}}e.EditorLayoutInfoComputer=U;class V extends A{constructor(){const ne={enabled:!0};super(56,"lightbulb",ne,{"editor.lightbulb.enabled":{type:"boolean",default:ne.enabled,description:m.localize(43,null)}})}validate(ne){return!ne||typeof ne!="object"?this.defaultValue:{enabled:v(ne.enabled,this.defaultValue.enabled)}}}class K extends A{constructor(){const ne={enabled:!0,fontSize:0,fontFamily:""};super(126,"inlayHints",ne,{"editor.inlayHints.enabled":{type:"boolean",default:ne.enabled,description:m.localize(44,null)},"editor.inlayHints.fontSize":{type:"number",default:ne.fontSize,markdownDescription:m.localize(45,null)},"editor.inlayHints.fontFamily":{type:"string",default:ne.fontFamily,markdownDescription:m.localize(46,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const pe=ne;return{enabled:v(pe.enabled,this.defaultValue.enabled),fontSize:o.clampedInt(pe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:g.string(pe.fontFamily,this.defaultValue.fontFamily)}}}class G extends s{constructor(){super(58,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,ne=>s.clamp(ne,0,150),{markdownDescription:m.localize(47,null)})}compute(ne,pe,ie){return ne.fontInfo.lineHeight}}class Q extends A{constructor(){const ne={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(64,"minimap",ne,{"editor.minimap.enabled":{type:"boolean",default:ne.enabled,description:m.localize(48,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[m.localize(49,null),m.localize(50,null),m.localize(51,null)],default:ne.size,description:m.localize(52,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ne.side,description:m.localize(53,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ne.showSlider,description:m.localize(54,null)},"editor.minimap.scale":{type:"number",default:ne.scale,minimum:1,maximum:3,enum:[1,2,3],description:m.localize(55,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ne.renderCharacters,description:m.localize(56,null)},"editor.minimap.maxColumn":{type:"number",default:ne.maxColumn,description:m.localize(57,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const pe=ne;return{enabled:v(pe.enabled,this.defaultValue.enabled),size:l(pe.size,this.defaultValue.size,["proportional","fill","fit"]),side:l(pe.side,this.defaultValue.side,["right","left"]),showSlider:l(pe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:v(pe.renderCharacters,this.defaultValue.renderCharacters),scale:o.clampedInt(pe.scale,1,1,3),maxColumn:o.clampedInt(pe.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Y(ee){return ee==="ctrlCmd"?i.isMacintosh?"metaKey":"ctrlKey":"altKey"}class fe extends A{constructor(){super(74,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(58,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(59,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const pe=ne;return{top:o.clampedInt(pe.top,0,0,1e3),bottom:o.clampedInt(pe.bottom,0,0,1e3)}}}class me extends A{constructor(){const ne={enabled:!0,cycle:!1};super(75,"parameterHints",ne,{"editor.parameterHints.enabled":{type:"boolean",default:ne.enabled,description:m.localize(60,null)},"editor.parameterHints.cycle":{type:"boolean",default:ne.cycle,description:m.localize(61,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const pe=ne;return{enabled:v(pe.enabled,this.defaultValue.enabled),cycle:v(pe.cycle,this.defaultValue.cycle)}}}class _e extends h{constructor(){super(128)}compute(ne,pe,ie){return ne.pixelRatio}}class Ie extends A{constructor(){const ne={other:!0,comments:!1,strings:!1};super(78,"quickSuggestions",ne,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:ne.strings,description:m.localize(62,null)},comments:{type:"boolean",default:ne.comments,description:m.localize(63,null)},other:{type:"boolean",default:ne.other,description:m.localize(64,null)}}}],default:ne,description:m.localize(65,null)});this.defaultValue=ne}validate(ne){if(typeof ne=="boolean")return ne;if(ne&&typeof ne=="object"){const pe=ne,ie={other:v(pe.other,this.defaultValue.other),comments:v(pe.comments,this.defaultValue.comments),strings:v(pe.strings,this.defaultValue.strings)};return ie.other&&ie.comments&&ie.strings?!0:!ie.other&&!ie.comments&&!ie.strings?!1:ie}return this.defaultValue}}var Oe;(function(ee){ee[ee.Off=0]="Off",ee[ee.On=1]="On",ee[ee.Relative=2]="Relative",ee[ee.Interval=3]="Interval",ee[ee.Custom=4]="Custom"})(Oe=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class We extends A{constructor(){super(59,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[m.localize(66,null),m.localize(67,null),m.localize(68,null),m.localize(69,null)],default:"on",description:m.localize(70,null)})}validate(ne){let pe=this.defaultValue.renderType,ie=this.defaultValue.renderFn;return typeof ne!="undefined"&&(typeof ne=="function"?(pe=4,ie=ne):ne==="interval"?pe=3:ne==="relative"?pe=2:ne==="on"?pe=1:pe=0),{renderType:pe,renderFn:ie}}}function j(ee){const ne=ee.get(86);return ne==="editable"?ee.get(80):ne!=="on"}e.filterValidationDecorations=j;class Z extends A{constructor(){const ne=[],pe={type:"number",description:m.localize(71,null)};super(90,"rulers",ne,{type:"array",items:{anyOf:[pe,{type:["object"],properties:{column:pe,color:{type:"string",description:m.localize(72,null),format:"color-hex"}}}]},default:ne,description:m.localize(73,null)})}validate(ne){if(Array.isArray(ne)){let pe=[];for(let ie of ne)if(typeof ie=="number")pe.push({column:o.clampedInt(ie,0,0,1e4),color:null});else if(ie&&typeof ie=="object"){const Se=ie;pe.push({column:o.clampedInt(Se.column,0,0,1e4),color:Se.color})}return pe.sort((ie,Se)=>ie.column-Se.column),pe}return this.defaultValue}}function re(ee,ne){if(typeof ee!="string")return ne;switch(ee){case"hidden":return 2;case"visible":return 3;default:return 1}}class ue extends A{constructor(){const ne={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(91,"scrollbar",ne,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(74,null),m.localize(75,null),m.localize(76,null)],default:"auto",description:m.localize(77,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(78,null),m.localize(79,null),m.localize(80,null)],default:"auto",description:m.localize(81,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:ne.verticalScrollbarSize,description:m.localize(82,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:ne.horizontalScrollbarSize,description:m.localize(83,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:ne.scrollByPage,description:m.localize(84,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const pe=ne,ie=o.clampedInt(pe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Se=o.clampedInt(pe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:o.clampedInt(pe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:re(pe.vertical,this.defaultValue.vertical),horizontal:re(pe.horizontal,this.defaultValue.horizontal),useShadows:v(pe.useShadows,this.defaultValue.useShadows),verticalHasArrows:v(pe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:v(pe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:v(pe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:v(pe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:ie,horizontalSliderSize:o.clampedInt(pe.horizontalSliderSize,ie,0,1e3),verticalScrollbarSize:Se,verticalSliderSize:o.clampedInt(pe.verticalSliderSize,Se,0,1e3),scrollByPage:v(pe.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments"};class te extends A{constructor(){const ne={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,allowedCharacters:{}};super(112,"unicodeHighlight",ne,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ne.nonBasicASCII,description:m.localize(85,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:ne.invisibleCharacters,description:m.localize(86,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:ne.ambiguousCharacters,description:m.localize(87,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ne.includeComments,description:m.localize(88,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:ne.allowedCharacters,description:m.localize(89,null),additionalProperties:{type:"boolean"}}})}applyUpdate(ne,pe){let ie=!1;pe.allowedCharacters&&(P.equals(ne.allowedCharacters,pe.allowedCharacters)||(ne={...ne,allowedCharacters:pe.allowedCharacters},ie=!0));const Se=super.applyUpdate(ne,pe);return ie?new c(Se.newValue,!0):Se}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const pe=ne;return{nonBasicASCII:Ve(pe.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:v(pe.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:v(pe.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Ve(pe.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateAllowedCharacters(ne.allowedCharacters,this.defaultValue.allowedCharacters)}}validateAllowedCharacters(ne,pe){if(typeof ne!="object"||!ne)return pe;const ie={};for(const[Se,Fe]of Object.entries(ne))Fe===!0&&(ie[Se]=!0);return ie}}class oe extends A{constructor(){const ne={enabled:!0,mode:"subwordSmart"};super(54,"inlineSuggest",ne,{"editor.inlineSuggest.enabled":{type:"boolean",default:ne.enabled,description:m.localize(90,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const pe=ne;return{enabled:v(pe.enabled,this.defaultValue.enabled),mode:l(pe.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class Ee extends A{constructor(){const ne={enabled:e.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled};super(12,"bracketPairColorization",ne,{"editor.bracketPairColorization.enabled":{type:"boolean",default:ne.enabled,description:m.localize(91,null)}})}validate(ne){return!ne||typeof ne!="object"?this.defaultValue:{enabled:v(ne.enabled,this.defaultValue.enabled)}}}class Ne extends A{constructor(){const ne={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",ne,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[m.localize(92,null),m.localize(93,null),m.localize(94,null)],default:ne.bracketPairs,description:m.localize(95,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[m.localize(96,null),m.localize(97,null),m.localize(98,null)],default:ne.bracketPairsHorizontal,description:m.localize(99,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:ne.highlightActiveBracketPair,description:m.localize(100,null)},"editor.guides.indentation":{type:"boolean",default:ne.indentation,description:m.localize(101,null)},"editor.guides.highlightActiveIndentation":{type:"boolean",default:ne.highlightActiveIndentation,description:m.localize(102,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const pe=ne;return{bracketPairs:Ve(pe.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Ve(pe.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:v(pe.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:v(pe.indentation,this.defaultValue.indentation),highlightActiveIndentation:v(pe.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation)}}}function Ve(ee,ne,pe){const ie=pe.indexOf(ee);return ie===-1?ne:pe[ie]}class Ge extends A{constructor(){const ne={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(105,"suggest",ne,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[m.localize(103,null),m.localize(104,null)],default:ne.insertMode,description:m.localize(105,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ne.filterGraceful,description:m.localize(106,null)},"editor.suggest.localityBonus":{type:"boolean",default:ne.localityBonus,description:m.localize(107,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ne.shareSuggestSelections,markdownDescription:m.localize(108,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ne.snippetsPreventQuickSuggestions,description:m.localize(109,null)},"editor.suggest.showIcons":{type:"boolean",default:ne.showIcons,description:m.localize(110,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ne.showStatusBar,description:m.localize(111,null)},"editor.suggest.preview":{type:"boolean",default:ne.preview,description:m.localize(112,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ne.showInlineDetails,description:m.localize(113,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:m.localize(114,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:m.localize(115,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:m.localize(116,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:m.localize(117,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:m.localize(118,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:m.localize(119,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:m.localize(120,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:m.localize(121,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:m.localize(122,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:m.localize(123,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:m.localize(124,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:m.localize(125,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:m.localize(126,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:m.localize(127,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:m.localize(128,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:m.localize(129,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:m.localize(130,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:m.localize(131,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:m.localize(132,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:m.localize(133,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:m.localize(134,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:m.localize(135,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:m.localize(136,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:m.localize(137,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:m.localize(138,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:m.localize(139,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:m.localize(140,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:m.localize(141,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:m.localize(142,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:m.localize(143,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:m.localize(144,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const pe=ne;return{insertMode:l(pe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:v(pe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:v(pe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:v(pe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:v(pe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:v(pe.showIcons,this.defaultValue.showIcons),showStatusBar:v(pe.showStatusBar,this.defaultValue.showStatusBar),preview:v(pe.preview,this.defaultValue.preview),previewMode:l(pe.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:v(pe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:v(pe.showMethods,this.defaultValue.showMethods),showFunctions:v(pe.showFunctions,this.defaultValue.showFunctions),showConstructors:v(pe.showConstructors,this.defaultValue.showConstructors),showDeprecated:v(pe.showDeprecated,this.defaultValue.showDeprecated),showFields:v(pe.showFields,this.defaultValue.showFields),showVariables:v(pe.showVariables,this.defaultValue.showVariables),showClasses:v(pe.showClasses,this.defaultValue.showClasses),showStructs:v(pe.showStructs,this.defaultValue.showStructs),showInterfaces:v(pe.showInterfaces,this.defaultValue.showInterfaces),showModules:v(pe.showModules,this.defaultValue.showModules),showProperties:v(pe.showProperties,this.defaultValue.showProperties),showEvents:v(pe.showEvents,this.defaultValue.showEvents),showOperators:v(pe.showOperators,this.defaultValue.showOperators),showUnits:v(pe.showUnits,this.defaultValue.showUnits),showValues:v(pe.showValues,this.defaultValue.showValues),showConstants:v(pe.showConstants,this.defaultValue.showConstants),showEnums:v(pe.showEnums,this.defaultValue.showEnums),showEnumMembers:v(pe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:v(pe.showKeywords,this.defaultValue.showKeywords),showWords:v(pe.showWords,this.defaultValue.showWords),showColors:v(pe.showColors,this.defaultValue.showColors),showFiles:v(pe.showFiles,this.defaultValue.showFiles),showReferences:v(pe.showReferences,this.defaultValue.showReferences),showFolders:v(pe.showFolders,this.defaultValue.showFolders),showTypeParameters:v(pe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:v(pe.showSnippets,this.defaultValue.showSnippets),showUsers:v(pe.showUsers,this.defaultValue.showUsers),showIssues:v(pe.showIssues,this.defaultValue.showIssues)}}}class Je extends A{constructor(){super(101,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:m.localize(145,null),default:!0,type:"boolean"}})}validate(ne){return!ne||typeof ne!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:v(ne.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class tt extends h{constructor(){super(129)}compute(ne,pe,ie){return pe.get(80)?!0:ne.tabFocusMode}}var ot;(function(ee){ee[ee.None=0]="None",ee[ee.Same=1]="Same",ee[ee.Indent=2]="Indent",ee[ee.DeepIndent=3]="DeepIndent"})(ot=e.WrappingIndent||(e.WrappingIndent={}));function et(ee){switch(ee){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class it extends h{constructor(){super(131)}compute(ne,pe,ie){const Se=pe.get(130);return{isDominatedByLongLines:ne.isDominatedByLongLines,isWordWrapMinified:Se.isWordWrapMinified,isViewportWrapping:Se.isViewportWrapping,wrappingColumn:Se.wrappingColumn}}}const lt="Consolas, 'Courier New', monospace",pt="Menlo, Monaco, 'Courier New', monospace",Pt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:i.isMacintosh?pt:i.isLinux?Pt:lt,fontWeight:"normal",fontSize:i.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!1}},e.editorOptionsRegistry=[];function xe(ee){return e.editorOptionsRegistry[ee.id]=ee,ee}var Rt;(function(ee){ee[ee.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ee[ee.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ee[ee.accessibilitySupport=2]="accessibilitySupport",ee[ee.accessibilityPageSize=3]="accessibilityPageSize",ee[ee.ariaLabel=4]="ariaLabel",ee[ee.autoClosingBrackets=5]="autoClosingBrackets",ee[ee.autoClosingDelete=6]="autoClosingDelete",ee[ee.autoClosingOvertype=7]="autoClosingOvertype",ee[ee.autoClosingQuotes=8]="autoClosingQuotes",ee[ee.autoIndent=9]="autoIndent",ee[ee.automaticLayout=10]="automaticLayout",ee[ee.autoSurround=11]="autoSurround",ee[ee.bracketPairColorization=12]="bracketPairColorization",ee[ee.guides=13]="guides",ee[ee.codeLens=14]="codeLens",ee[ee.codeLensFontFamily=15]="codeLensFontFamily",ee[ee.codeLensFontSize=16]="codeLensFontSize",ee[ee.colorDecorators=17]="colorDecorators",ee[ee.columnSelection=18]="columnSelection",ee[ee.comments=19]="comments",ee[ee.contextmenu=20]="contextmenu",ee[ee.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",ee[ee.cursorBlinking=22]="cursorBlinking",ee[ee.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",ee[ee.cursorStyle=24]="cursorStyle",ee[ee.cursorSurroundingLines=25]="cursorSurroundingLines",ee[ee.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",ee[ee.cursorWidth=27]="cursorWidth",ee[ee.disableLayerHinting=28]="disableLayerHinting",ee[ee.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",ee[ee.domReadOnly=30]="domReadOnly",ee[ee.dragAndDrop=31]="dragAndDrop",ee[ee.emptySelectionClipboard=32]="emptySelectionClipboard",ee[ee.extraEditorClassName=33]="extraEditorClassName",ee[ee.fastScrollSensitivity=34]="fastScrollSensitivity",ee[ee.find=35]="find",ee[ee.fixedOverflowWidgets=36]="fixedOverflowWidgets",ee[ee.folding=37]="folding",ee[ee.foldingStrategy=38]="foldingStrategy",ee[ee.foldingHighlight=39]="foldingHighlight",ee[ee.foldingImportsByDefault=40]="foldingImportsByDefault",ee[ee.unfoldOnClickAfterEndOfLine=41]="unfoldOnClickAfterEndOfLine",ee[ee.fontFamily=42]="fontFamily",ee[ee.fontInfo=43]="fontInfo",ee[ee.fontLigatures=44]="fontLigatures",ee[ee.fontSize=45]="fontSize",ee[ee.fontWeight=46]="fontWeight",ee[ee.formatOnPaste=47]="formatOnPaste",ee[ee.formatOnType=48]="formatOnType",ee[ee.glyphMargin=49]="glyphMargin",ee[ee.gotoLocation=50]="gotoLocation",ee[ee.hideCursorInOverviewRuler=51]="hideCursorInOverviewRuler",ee[ee.hover=52]="hover",ee[ee.inDiffEditor=53]="inDiffEditor",ee[ee.inlineSuggest=54]="inlineSuggest",ee[ee.letterSpacing=55]="letterSpacing",ee[ee.lightbulb=56]="lightbulb",ee[ee.lineDecorationsWidth=57]="lineDecorationsWidth",ee[ee.lineHeight=58]="lineHeight",ee[ee.lineNumbers=59]="lineNumbers",ee[ee.lineNumbersMinChars=60]="lineNumbersMinChars",ee[ee.linkedEditing=61]="linkedEditing",ee[ee.links=62]="links",ee[ee.matchBrackets=63]="matchBrackets",ee[ee.minimap=64]="minimap",ee[ee.mouseStyle=65]="mouseStyle",ee[ee.mouseWheelScrollSensitivity=66]="mouseWheelScrollSensitivity",ee[ee.mouseWheelZoom=67]="mouseWheelZoom",ee[ee.multiCursorMergeOverlapping=68]="multiCursorMergeOverlapping",ee[ee.multiCursorModifier=69]="multiCursorModifier",ee[ee.multiCursorPaste=70]="multiCursorPaste",ee[ee.occurrencesHighlight=71]="occurrencesHighlight",ee[ee.overviewRulerBorder=72]="overviewRulerBorder",ee[ee.overviewRulerLanes=73]="overviewRulerLanes",ee[ee.padding=74]="padding",ee[ee.parameterHints=75]="parameterHints",ee[ee.peekWidgetDefaultFocus=76]="peekWidgetDefaultFocus",ee[ee.definitionLinkOpensInPeek=77]="definitionLinkOpensInPeek",ee[ee.quickSuggestions=78]="quickSuggestions",ee[ee.quickSuggestionsDelay=79]="quickSuggestionsDelay",ee[ee.readOnly=80]="readOnly",ee[ee.renameOnType=81]="renameOnType",ee[ee.renderControlCharacters=82]="renderControlCharacters",ee[ee.renderFinalNewline=83]="renderFinalNewline",ee[ee.renderLineHighlight=84]="renderLineHighlight",ee[ee.renderLineHighlightOnlyWhenFocus=85]="renderLineHighlightOnlyWhenFocus",ee[ee.renderValidationDecorations=86]="renderValidationDecorations",ee[ee.renderWhitespace=87]="renderWhitespace",ee[ee.revealHorizontalRightPadding=88]="revealHorizontalRightPadding",ee[ee.roundedSelection=89]="roundedSelection",ee[ee.rulers=90]="rulers",ee[ee.scrollbar=91]="scrollbar",ee[ee.scrollBeyondLastColumn=92]="scrollBeyondLastColumn",ee[ee.scrollBeyondLastLine=93]="scrollBeyondLastLine",ee[ee.scrollPredominantAxis=94]="scrollPredominantAxis",ee[ee.selectionClipboard=95]="selectionClipboard",ee[ee.selectionHighlight=96]="selectionHighlight",ee[ee.selectOnLineNumbers=97]="selectOnLineNumbers",ee[ee.showFoldingControls=98]="showFoldingControls",ee[ee.showUnused=99]="showUnused",ee[ee.snippetSuggestions=100]="snippetSuggestions",ee[ee.smartSelect=101]="smartSelect",ee[ee.smoothScrolling=102]="smoothScrolling",ee[ee.stickyTabStops=103]="stickyTabStops",ee[ee.stopRenderingLineAfter=104]="stopRenderingLineAfter",ee[ee.suggest=105]="suggest",ee[ee.suggestFontSize=106]="suggestFontSize",ee[ee.suggestLineHeight=107]="suggestLineHeight",ee[ee.suggestOnTriggerCharacters=108]="suggestOnTriggerCharacters",ee[ee.suggestSelection=109]="suggestSelection",ee[ee.tabCompletion=110]="tabCompletion",ee[ee.tabIndex=111]="tabIndex",ee[ee.unicodeHighlighting=112]="unicodeHighlighting",ee[ee.unusualLineTerminators=113]="unusualLineTerminators",ee[ee.useShadowDOM=114]="useShadowDOM",ee[ee.useTabStops=115]="useTabStops",ee[ee.wordSeparators=116]="wordSeparators",ee[ee.wordWrap=117]="wordWrap",ee[ee.wordWrapBreakAfterCharacters=118]="wordWrapBreakAfterCharacters",ee[ee.wordWrapBreakBeforeCharacters=119]="wordWrapBreakBeforeCharacters",ee[ee.wordWrapColumn=120]="wordWrapColumn",ee[ee.wordWrapOverride1=121]="wordWrapOverride1",ee[ee.wordWrapOverride2=122]="wordWrapOverride2",ee[ee.wrappingIndent=123]="wrappingIndent",ee[ee.wrappingStrategy=124]="wrappingStrategy",ee[ee.showDeprecated=125]="showDeprecated",ee[ee.inlayHints=126]="inlayHints",ee[ee.editorClassName=127]="editorClassName",ee[ee.pixelRatio=128]="pixelRatio",ee[ee.tabFocusMode=129]="tabFocusMode",ee[ee.layoutInfo=130]="layoutInfo",ee[ee.wrappingInfo=131]="wrappingInfo"})(Rt=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:xe(new T(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:m.localize(146,null)})),acceptSuggestionOnEnter:xe(new S(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",m.localize(147,null),""],markdownDescription:m.localize(148,null)})),accessibilitySupport:xe(new r),accessibilityPageSize:xe(new o(3,"accessibilityPageSize",10,1,1073741824,{description:m.localize(149,null)})),ariaLabel:xe(new g(4,"ariaLabel",m.localize(150,null))),autoClosingBrackets:xe(new S(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(151,null),m.localize(152,null),""],description:m.localize(153,null)})),autoClosingDelete:xe(new S(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",m.localize(154,null),""],description:m.localize(155,null)})),autoClosingOvertype:xe(new S(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",m.localize(156,null),""],description:m.localize(157,null)})),autoClosingQuotes:xe(new S(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(158,null),m.localize(159,null),""],description:m.localize(160,null)})),autoIndent:xe(new n(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],t,{enumDescriptions:[m.localize(161,null),m.localize(162,null),m.localize(163,null),m.localize(164,null),m.localize(165,null)],description:m.localize(166,null)})),automaticLayout:xe(new T(10,"automaticLayout",!1)),autoSurround:xe(new S(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[m.localize(167,null),m.localize(168,null),m.localize(169,null),""],description:m.localize(170,null)})),bracketPairColorization:xe(new Ee),bracketPairGuides:xe(new Ne),stickyTabStops:xe(new T(103,"stickyTabStops",!1,{description:m.localize(171,null)})),codeLens:xe(new T(14,"codeLens",!0,{description:m.localize(172,null)})),codeLensFontFamily:xe(new g(15,"codeLensFontFamily","",{description:m.localize(173,null)})),codeLensFontSize:xe(new o(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:m.localize(174,null)})),colorDecorators:xe(new T(17,"colorDecorators",!0,{description:m.localize(175,null)})),columnSelection:xe(new T(18,"columnSelection",!1,{description:m.localize(176,null)})),comments:xe(new u),contextmenu:xe(new T(20,"contextmenu",!0)),copyWithSyntaxHighlighting:xe(new T(21,"copyWithSyntaxHighlighting",!0,{description:m.localize(177,null)})),cursorBlinking:xe(new n(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],f,{description:m.localize(178,null)})),cursorSmoothCaretAnimation:xe(new T(23,"cursorSmoothCaretAnimation",!1,{description:m.localize(179,null)})),cursorStyle:xe(new n(24,"cursorStyle",w.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],k,{description:m.localize(180,null)})),cursorSurroundingLines:xe(new o(25,"cursorSurroundingLines",0,0,1073741824,{description:m.localize(181,null)})),cursorSurroundingLinesStyle:xe(new S(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[m.localize(182,null),m.localize(183,null)],description:m.localize(184,null)})),cursorWidth:xe(new o(27,"cursorWidth",0,0,1073741824,{markdownDescription:m.localize(185,null)})),disableLayerHinting:xe(new T(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:xe(new T(29,"disableMonospaceOptimizations",!1)),domReadOnly:xe(new T(30,"domReadOnly",!1)),dragAndDrop:xe(new T(31,"dragAndDrop",!0,{description:m.localize(186,null)})),emptySelectionClipboard:xe(new N),extraEditorClassName:xe(new g(33,"extraEditorClassName","")),fastScrollSensitivity:xe(new s(34,"fastScrollSensitivity",5,ee=>ee<=0?5:ee,{markdownDescription:m.localize(187,null)})),find:xe(new x),fixedOverflowWidgets:xe(new T(36,"fixedOverflowWidgets",!1)),folding:xe(new T(37,"folding",!0,{description:m.localize(188,null)})),foldingStrategy:xe(new S(38,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[m.localize(189,null),m.localize(190,null)],description:m.localize(191,null)})),foldingHighlight:xe(new T(39,"foldingHighlight",!0,{description:m.localize(192,null)})),foldingImportsByDefault:xe(new T(40,"foldingImportsByDefault",!1,{description:m.localize(193,null)})),unfoldOnClickAfterEndOfLine:xe(new T(41,"unfoldOnClickAfterEndOfLine",!1,{description:m.localize(194,null)})),fontFamily:xe(new g(42,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:m.localize(195,null)})),fontInfo:xe(new B),fontLigatures2:xe(new F),fontSize:xe(new O),fontWeight:xe(new H),formatOnPaste:xe(new T(47,"formatOnPaste",!1,{description:m.localize(196,null)})),formatOnType:xe(new T(48,"formatOnType",!1,{description:m.localize(197,null)})),glyphMargin:xe(new T(49,"glyphMargin",!0,{description:m.localize(198,null)})),gotoLocation:xe(new M),hideCursorInOverviewRuler:xe(new T(51,"hideCursorInOverviewRuler",!1,{description:m.localize(199,null)})),hover:xe(new W),inDiffEditor:xe(new T(53,"inDiffEditor",!1)),letterSpacing:xe(new s(55,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ee=>s.clamp(ee,-5,20),{description:m.localize(200,null)})),lightbulb:xe(new V),lineDecorationsWidth:xe(new p(57,"lineDecorationsWidth",10)),lineHeight:xe(new G),lineNumbers:xe(new We),lineNumbersMinChars:xe(new o(60,"lineNumbersMinChars",5,1,300)),linkedEditing:xe(new T(61,"linkedEditing",!1,{description:m.localize(201,null)})),links:xe(new T(62,"links",!0,{description:m.localize(202,null)})),matchBrackets:xe(new S(63,"matchBrackets","always",["always","near","never"],{description:m.localize(203,null)})),minimap:xe(new Q),mouseStyle:xe(new S(65,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:xe(new s(66,"mouseWheelScrollSensitivity",1,ee=>ee===0?1:ee,{markdownDescription:m.localize(204,null)})),mouseWheelZoom:xe(new T(67,"mouseWheelZoom",!1,{markdownDescription:m.localize(205,null)})),multiCursorMergeOverlapping:xe(new T(68,"multiCursorMergeOverlapping",!0,{description:m.localize(206,null)})),multiCursorModifier:xe(new n(69,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Y,{markdownEnumDescriptions:[m.localize(207,null),m.localize(208,null)],markdownDescription:m.localize(209,null)})),multiCursorPaste:xe(new S(70,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[m.localize(210,null),m.localize(211,null)],markdownDescription:m.localize(212,null)})),occurrencesHighlight:xe(new T(71,"occurrencesHighlight",!0,{description:m.localize(213,null)})),overviewRulerBorder:xe(new T(72,"overviewRulerBorder",!0,{description:m.localize(214,null)})),overviewRulerLanes:xe(new o(73,"overviewRulerLanes",3,0,3)),padding:xe(new fe),parameterHints:xe(new me),peekWidgetDefaultFocus:xe(new S(76,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[m.localize(215,null),m.localize(216,null)],description:m.localize(217,null)})),definitionLinkOpensInPeek:xe(new T(77,"definitionLinkOpensInPeek",!1,{description:m.localize(218,null)})),quickSuggestions:xe(new Ie),quickSuggestionsDelay:xe(new o(79,"quickSuggestionsDelay",10,0,1073741824,{description:m.localize(219,null)})),readOnly:xe(new T(80,"readOnly",!1)),renameOnType:xe(new T(81,"renameOnType",!1,{description:m.localize(220,null),markdownDeprecationMessage:m.localize(221,null)})),renderControlCharacters:xe(new T(82,"renderControlCharacters",!0,{description:m.localize(222,null),restricted:!0})),renderFinalNewline:xe(new T(83,"renderFinalNewline",!0,{description:m.localize(223,null)})),renderLineHighlight:xe(new S(84,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",m.localize(224,null)],description:m.localize(225,null)})),renderLineHighlightOnlyWhenFocus:xe(new T(85,"renderLineHighlightOnlyWhenFocus",!1,{description:m.localize(226,null)})),renderValidationDecorations:xe(new S(86,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:xe(new S(87,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",m.localize(227,null),m.localize(228,null),m.localize(229,null),""],description:m.localize(230,null)})),revealHorizontalRightPadding:xe(new o(88,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:xe(new T(89,"roundedSelection",!0,{description:m.localize(231,null)})),rulers:xe(new Z),scrollbar:xe(new ue),scrollBeyondLastColumn:xe(new o(92,"scrollBeyondLastColumn",5,0,1073741824,{description:m.localize(232,null)})),scrollBeyondLastLine:xe(new T(93,"scrollBeyondLastLine",!0,{description:m.localize(233,null)})),scrollPredominantAxis:xe(new T(94,"scrollPredominantAxis",!0,{description:m.localize(234,null)})),selectionClipboard:xe(new T(95,"selectionClipboard",!0,{description:m.localize(235,null),included:i.isLinux})),selectionHighlight:xe(new T(96,"selectionHighlight",!0,{description:m.localize(236,null)})),selectOnLineNumbers:xe(new T(97,"selectOnLineNumbers",!0)),showFoldingControls:xe(new S(98,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[m.localize(237,null),m.localize(238,null)],description:m.localize(239,null)})),showUnused:xe(new T(99,"showUnused",!0,{description:m.localize(240,null)})),showDeprecated:xe(new T(125,"showDeprecated",!0,{description:m.localize(241,null)})),inlayHints:xe(new K),snippetSuggestions:xe(new S(100,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[m.localize(242,null),m.localize(243,null),m.localize(244,null),m.localize(245,null)],description:m.localize(246,null)})),smartSelect:xe(new Je),smoothScrolling:xe(new T(102,"smoothScrolling",!1,{description:m.localize(247,null)})),stopRenderingLineAfter:xe(new o(104,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:xe(new Ge),inlineSuggest:xe(new oe),suggestFontSize:xe(new o(106,"suggestFontSize",0,0,1e3,{markdownDescription:m.localize(248,null)})),suggestLineHeight:xe(new o(107,"suggestLineHeight",0,0,1e3,{markdownDescription:m.localize(249,null)})),suggestOnTriggerCharacters:xe(new T(108,"suggestOnTriggerCharacters",!0,{description:m.localize(250,null)})),suggestSelection:xe(new S(109,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[m.localize(251,null),m.localize(252,null),m.localize(253,null)],description:m.localize(254,null)})),tabCompletion:xe(new S(110,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[m.localize(255,null),m.localize(256,null),m.localize(257,null)],description:m.localize(258,null)})),tabIndex:xe(new o(111,"tabIndex",0,-1,1073741824)),unicodeHighlight:xe(new te),unusualLineTerminators:xe(new S(113,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[m.localize(259,null),m.localize(260,null),m.localize(261,null)],description:m.localize(262,null)})),useShadowDOM:xe(new T(114,"useShadowDOM",!0)),useTabStops:xe(new T(115,"useTabStops",!0,{description:m.localize(263,null)})),wordSeparators:xe(new g(116,"wordSeparators",y.USUAL_WORD_SEPARATORS,{description:m.localize(264,null)})),wordWrap:xe(new S(117,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[m.localize(265,null),m.localize(266,null),m.localize(267,null),m.localize(268,null)],description:m.localize(269,null)})),wordWrapBreakAfterCharacters:xe(new g(118,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:xe(new g(119,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:xe(new o(120,"wordWrapColumn",80,1,1073741824,{markdownDescription:m.localize(270,null)})),wordWrapOverride1:xe(new S(121,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:xe(new S(122,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:xe(new n(123,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],et,{enumDescriptions:[m.localize(271,null),m.localize(272,null),m.localize(273,null),m.localize(274,null)],description:m.localize(275,null)})),wrappingStrategy:xe(new S(124,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[m.localize(276,null),m.localize(277,null)],description:m.localize(278,null)})),editorClassName:xe(new R),pixelRatio:xe(new _e),tabFocusMode:xe(new tt),layoutInfo:xe(new U),wrappingInfo:xe(new it)}}),define(ve[155],we([19,20]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ve[156],we([19,20]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ve[157],we([19,20]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(ve[158],we([19,20]),function(J,e){return J.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ve[159],we([19,20]),function(J,e){return J.create("vs/platform/files/common/files",e)}),define(ve[160],we([19,20]),function(J,e){return J.create("vs/platform/markers/common/markers",e)}),define(ve[161],we([19,20]),function(J,e){return J.create("vs/platform/workspaces/common/workspaces",e)}),define(ve[162],we([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ve[163],we([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ve[164],we([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostProgress",e)}),define(ve[165],we([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ve[166],we([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ve[167],we([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ve[168],we([19,20]),function(J,e){return J.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ve[169],we([19,20]),function(J,e){return J.create("vs/workbench/api/node/extHostDebugService",e)}),define(ve[170],we([19,20]),function(J,e){return J.create("vs/workbench/api/node/extHostTunnelService",e)}),define(ve[171],we([19,20]),function(J,e){return J.create("vs/workbench/common/editor",e)}),define(ve[172],we([19,20]),function(J,e){return J.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ve[173],we([19,20]),function(J,e){return J.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(ve[174],we([19,20]),function(J,e){return J.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(ve[175],we([19,20]),function(J,e){return J.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(ve[176],we([19,20]),function(J,e){return J.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ve[177],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var m;(function(P){P[P.ACTIVATE=1]="ACTIVATE",P[P.RESTORE=2]="RESTORE",P[P.PRESERVE=3]="PRESERVE"})(m=e.EditorActivation||(e.EditorActivation={}));var i;(function(P){P[P.PICK=0]="PICK",P[P.DISABLED=1]="DISABLED",P[P.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(i=e.EditorResolution||(e.EditorResolution={}));var y;(function(P){P[P.API=0]="API",P[P.USER=1]="USER"})(y=e.EditorOpenContext||(e.EditorOpenContext={}));var C;(function(P){P[P.Center=0]="Center",P[P.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",P[P.NearTop=2]="NearTop",P[P.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(C=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(ve[178],we([0,1,157]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const i=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,y=/^-(\d{4})(\d{2})(\d{2})$/;function C(c){return c=c.trim(),c==="*"||i.test(c)}e.isValidVersionStr=C;function P(c){if(!C(c))return null;if(c=c.trim(),c==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let E=c.match(i);return E?{hasCaret:E[1]==="^",hasGreaterEquals:E[1]===">=",majorBase:E[2]==="x"?0:parseInt(E[2],10),majorMustEqual:E[2]!=="x",minorBase:E[4]==="x"?0:parseInt(E[4],10),minorMustEqual:E[4]!=="x",patchBase:E[6]==="x"?0:parseInt(E[6],10),patchMustEqual:E[6]!=="x",preRelease:E[8]||null}:null}e.parseVersion=P;function D(c){if(!c)return null;let E=c.majorBase,h=c.majorMustEqual,p=c.minorBase,v=c.minorMustEqual,T=c.patchBase,b=c.patchMustEqual;c.hasCaret&&(E===0||(v=!1),b=!1);let o=0;if(c.preRelease){const s=y.exec(c.preRelease);if(s){const[,g,l,S]=s;o=Date.UTC(Number(g),Number(l)-1,Number(S))}}return{majorBase:E,majorMustEqual:h,minorBase:p,minorMustEqual:v,patchBase:T,patchMustEqual:b,isMinimum:c.hasGreaterEquals,notBefore:o}}e.normalizeVersion=D;function _(c,E,h){let p;typeof c=="string"?p=D(P(c)):p=c;let v;E instanceof Date?v=E.getTime():typeof E=="string"&&(v=new Date(E).getTime());let T;if(typeof h=="string"?T=D(P(h)):T=h,!p||!T)return!1;let b=p.majorBase,o=p.minorBase,s=p.patchBase,g=T.majorBase,l=T.minorBase,S=T.patchBase,n=T.notBefore,t=T.majorMustEqual,r=T.minorMustEqual,u=T.patchMustEqual;return T.isMinimum?b>g?!0:b<g?!1:o>l?!0:o<l||v&&v<n?!1:s>=S:(b===1&&g===0&&(!t||!r||!u)&&(g=1,l=0,S=0,t=!0,r=!1,u=!1),b<g?!1:b>g?!t:o<l?!1:o>l?!r:s<S?!1:s>S?!u:!(v&&v<n))}e.isValidVersion=_;function I(c,E,h,p){return h.isBuiltin||typeof h.main=="undefined"?!0:A(c,E,h.engines.vscode,p)}e.isValidExtensionVersion=I;function L(c,E,h){return c==="*"||A(E,h,c)}e.isEngineValid=L;function A(c,E,h,p=[]){let v=D(P(h));if(!v)return p.push(m.localize(0,null,h)),!1;if(v.majorBase===0){if(!v.majorMustEqual||!v.minorMustEqual)return p.push(m.localize(1,null,h)),!1}else if(!v.majorMustEqual)return p.push(m.localize(2,null,h)),!1;return _(c,E,v)?!0:(p.push(m.localize(3,null,c,h)),!1)}}),define(ve[114],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class m{constructor(y,C=[],P=!1){this.ctor=y,this.staticArguments=C,this.supportsDelayedInstantiation=P}}e.SyncDescriptor=m}),define(ve[83],we([0,1,114]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const i=[];function y(P,D,_){D instanceof m.SyncDescriptor||(D=new m.SyncDescriptor(D,[],_)),i.push([P,D])}e.registerSingleton=y;function C(){return i}e.getSingletonServiceDescriptors=C}),define(ve[179],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class m{constructor(C){this.incoming=new Map,this.outgoing=new Map,this.data=C}}e.Node=m;class i{constructor(C){this._hashFn=C,this._nodes=new Map}roots(){const C=[];for(let P of this._nodes.values())P.outgoing.size===0&&C.push(P);return C}insertEdge(C,P){const D=this.lookupOrInsertNode(C),_=this.lookupOrInsertNode(P);D.outgoing.set(this._hashFn(P),_),_.incoming.set(this._hashFn(C),D)}removeNode(C){const P=this._hashFn(C);this._nodes.delete(P);for(let D of this._nodes.values())D.outgoing.delete(P),D.incoming.delete(P)}lookupOrInsertNode(C){const P=this._hashFn(C);let D=this._nodes.get(P);return D||(D=new m(C),this._nodes.set(P,D)),D}lookup(C){return this._nodes.get(this._hashFn(C))}isEmpty(){return this._nodes.size===0}toString(){let C=[];for(let[P,D]of this._nodes)C.push(`${P}, (incoming)[${[...D.incoming.keys()].join(", ")}], (outgoing)[${[...D.outgoing.keys()].join(",")}]`);return C.join(`
`)}findCycleSlow(){for(let[C,P]of this._nodes){const D=new Set([C]),_=this._findCycle(P,D);if(_)return _}}_findCycle(C,P){for(let[D,_]of C.outgoing){if(P.has(D))return[...P,D].join(" -> ");P.add(D);const I=this._findCycle(_,P);if(I)return I;P.delete(D)}}}e.Graph=i}),define(ve[4],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var m;(function(P){P.serviceIds=new Map,P.DI_TARGET="$di$target",P.DI_DEPENDENCIES="$di$dependencies";function D(_){return _[P.DI_DEPENDENCIES]||[]}P.getServiceDependencies=D})(m=e._util||(e._util={})),e.IInstantiationService=y("instantiationService");function i(P,D,_,I){D[m.DI_TARGET]===D?D[m.DI_DEPENDENCIES].push({id:P,index:_,optional:I}):(D[m.DI_DEPENDENCIES]=[{id:P,index:_,optional:I}],D[m.DI_TARGET]=D)}function y(P){if(m.serviceIds.has(P))return m.serviceIds.get(P);const D=function(_,I,L){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");i(D,_,L,!1)};return D.toString=()=>P,m.serviceIds.set(P,D),D}e.createDecorator=y;function C(P){return P}e.refineServiceDecorator=C}),define(ve[180],we([0,1,4]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,m.createDecorator)("modelService");function i(y){return!y.isTooLargeForSyncing()&&!y.isForSimpleWidget}e.shouldSynchronizeModel=i}),define(ve[181],we([0,1,3,47,6,24,78,82,180]),function(J,e,m,i,y,C,P,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function I(p){return typeof p=="string"?!1:Array.isArray(p)?p.every(I):!!p.exclusive}class L{constructor(){this._clock=0,this._entries=[],this._onDidChange=new m.Emitter}get onDidChange(){return this._onDidChange.event}register(v,T){let b={selector:v,provider:T,_score:-1,_time:this._clock++};return this._entries.push(b),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,y.toDisposable)(()=>{if(b){let o=this._entries.indexOf(b);o>=0&&(this._entries.splice(o,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),b=void 0)}})}has(v){return this.all(v).length>0}all(v){if(!v)return[];this._updateScores(v);const T=[];for(let b of this._entries)b._score>0&&T.push(b.provider);return T}ordered(v){const T=[];return this._orderedForEach(v,b=>T.push(b.provider)),T}orderedGroups(v){const T=[];let b,o;return this._orderedForEach(v,s=>{b&&o===s._score?b.push(s.provider):(o=s._score,b=[s.provider],T.push(b))}),T}_orderedForEach(v,T){if(!!v){this._updateScores(v);for(const b of this._entries)b._score>0&&T(b)}}_updateScores(v){let T={uri:v.uri.toString(),language:v.getLanguageId()};if(!(this._lastCandidate&&this._lastCandidate.language===T.language&&this._lastCandidate.uri===T.uri)){this._lastCandidate=T;for(let b of this._entries)if(b._score=(0,D.score)(b.selector,v.uri,v.getLanguageId(),(0,_.shouldSynchronizeModel)(v)),I(b.selector)&&b._score>0){for(let o of this._entries)o._score=0;b._score=1e3;break}this._entries.sort(L._compareByScoreAndTime)}}static _compareByScoreAndTime(v,T){return v._score<T._score?1:v._score>T._score?-1:v._time<T._time?1:v._time>T._time?-1:0}}e.LanguageFeatureRegistry=L;const A=new WeakMap;let c=0;function E(p){let v=A.get(p);return v===void 0&&(v=++c,A.set(p,v)),v}class h{constructor(v,T,b=Number.MAX_SAFE_INTEGER){this._registry=v,this.min=T,this.max=b,this._cache=new C.LRUCache(50,.7)}_key(v){return v.id+this._registry.all(v).reduce((T,b)=>(0,i.doHash)(E(b),T),0)}_clamp(v){return v===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(v*1.3)))}get(v){const T=this._key(v),b=this._cache.get(T);return this._clamp(b?.value)}update(v,T){const b=this._key(v);let o=this._cache.get(b);return o||(o=new P.MovingAverage,this._cache.set(b,o)),o.update(T),this.get(v)}}e.LanguageFeatureRequestDelays=h}),define(ve[84],we([0,1,2,41,181,148,73]),function(J,e,m,i,y,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var D;(function(d){d[d.Null=0]="Null",d[d.PlainText=1]="PlainText"})(D=e.LanguageId||(e.LanguageId={}));var _;(function(d){d[d.NotSet=-1]="NotSet",d[d.None=0]="None",d[d.Italic=1]="Italic",d[d.Bold=2]="Bold",d[d.Underline=4]="Underline"})(_=e.FontStyle||(e.FontStyle={}));var I;(function(d){d[d.None=0]="None",d[d.DefaultForeground=1]="DefaultForeground",d[d.DefaultBackground=2]="DefaultBackground"})(I=e.ColorId||(e.ColorId={}));var L;(function(d){d[d.Other=0]="Other",d[d.Comment=1]="Comment",d[d.String=2]="String",d[d.RegEx=4]="RegEx"})(L=e.StandardTokenType||(e.StandardTokenType={}));var A;(function(d){d[d.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",d[d.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",d[d.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",d[d.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",d[d.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",d[d.ITALIC_MASK=2048]="ITALIC_MASK",d[d.BOLD_MASK=4096]="BOLD_MASK",d[d.UNDERLINE_MASK=8192]="UNDERLINE_MASK",d[d.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",d[d.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",d[d.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",d[d.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",d[d.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",d[d.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",d[d.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",d[d.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",d[d.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",d[d.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(A=e.MetadataConsts||(e.MetadataConsts={}));class c{static getLanguageId(k){return(k&255)>>>0}static getTokenType(k){return(k&1792)>>>8}static getFontStyle(k){return(k&14336)>>>11}static getForeground(k){return(k&8372224)>>>14}static getBackground(k){return(k&4286578688)>>>23}static getClassNameFromMetadata(k){let R=this.getForeground(k),N="mtk"+R,x=this.getFontStyle(k);return x&1&&(N+=" mtki"),x&2&&(N+=" mtkb"),x&4&&(N+=" mtku"),N}static getInlineStyleFromMetadata(k,R){const N=this.getForeground(k),x=this.getFontStyle(k);let F=`color: ${R[N]};`;return x&1&&(F+="font-style: italic;"),x&2&&(F+="font-weight: bold;"),x&4&&(F+="text-decoration: underline;"),F}}e.TokenMetadata=c;var E;(function(d){d[d.Method=0]="Method",d[d.Function=1]="Function",d[d.Constructor=2]="Constructor",d[d.Field=3]="Field",d[d.Variable=4]="Variable",d[d.Class=5]="Class",d[d.Struct=6]="Struct",d[d.Interface=7]="Interface",d[d.Module=8]="Module",d[d.Property=9]="Property",d[d.Event=10]="Event",d[d.Operator=11]="Operator",d[d.Unit=12]="Unit",d[d.Value=13]="Value",d[d.Constant=14]="Constant",d[d.Enum=15]="Enum",d[d.EnumMember=16]="EnumMember",d[d.Keyword=17]="Keyword",d[d.Text=18]="Text",d[d.Color=19]="Color",d[d.File=20]="File",d[d.Reference=21]="Reference",d[d.Customcolor=22]="Customcolor",d[d.Folder=23]="Folder",d[d.TypeParameter=24]="TypeParameter",d[d.User=25]="User",d[d.Issue=26]="Issue",d[d.Snippet=27]="Snippet"})(E=e.CompletionItemKind||(e.CompletionItemKind={}));var h;(function(d){const k=new Map;k.set(0,P.Codicon.symbolMethod),k.set(1,P.Codicon.symbolFunction),k.set(2,P.Codicon.symbolConstructor),k.set(3,P.Codicon.symbolField),k.set(4,P.Codicon.symbolVariable),k.set(5,P.Codicon.symbolClass),k.set(6,P.Codicon.symbolStruct),k.set(7,P.Codicon.symbolInterface),k.set(8,P.Codicon.symbolModule),k.set(9,P.Codicon.symbolProperty),k.set(10,P.Codicon.symbolEvent),k.set(11,P.Codicon.symbolOperator),k.set(12,P.Codicon.symbolUnit),k.set(13,P.Codicon.symbolValue),k.set(15,P.Codicon.symbolEnum),k.set(14,P.Codicon.symbolConstant),k.set(15,P.Codicon.symbolEnum),k.set(16,P.Codicon.symbolEnumMember),k.set(17,P.Codicon.symbolKeyword),k.set(27,P.Codicon.symbolSnippet),k.set(18,P.Codicon.symbolText),k.set(19,P.Codicon.symbolColor),k.set(20,P.Codicon.symbolFile),k.set(21,P.Codicon.symbolReference),k.set(22,P.Codicon.symbolCustomColor),k.set(23,P.Codicon.symbolFolder),k.set(24,P.Codicon.symbolTypeParameter),k.set(25,P.Codicon.account),k.set(26,P.Codicon.issues);function R(F){let B=k.get(F);return B||(console.info("No codicon found for CompletionItemKind "+F),B=P.Codicon.symbolProperty),B}d.toIcon=R;const N=new Map;N.set("method",0),N.set("function",1),N.set("constructor",2),N.set("field",3),N.set("variable",4),N.set("class",5),N.set("struct",6),N.set("interface",7),N.set("module",8),N.set("property",9),N.set("event",10),N.set("operator",11),N.set("unit",12),N.set("value",13),N.set("constant",14),N.set("enum",15),N.set("enum-member",16),N.set("enumMember",16),N.set("keyword",17),N.set("snippet",27),N.set("text",18),N.set("color",19),N.set("file",20),N.set("reference",21),N.set("customcolor",22),N.set("folder",23),N.set("type-parameter",24),N.set("typeParameter",24),N.set("account",25),N.set("issue",26);function x(F,B){let O=N.get(F);return typeof O=="undefined"&&!B&&(O=9),O}d.fromString=x})(h=e.CompletionItemKinds||(e.CompletionItemKinds={}));var p;(function(d){d[d.Deprecated=1]="Deprecated"})(p=e.CompletionItemTag||(e.CompletionItemTag={}));var v;(function(d){d[d.KeepWhitespace=1]="KeepWhitespace",d[d.InsertAsSnippet=4]="InsertAsSnippet"})(v=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var T;(function(d){d[d.Invoke=0]="Invoke",d[d.TriggerCharacter=1]="TriggerCharacter",d[d.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(T=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var b;(function(d){d[d.Automatic=0]="Automatic",d[d.Explicit=1]="Explicit"})(b=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var o;(function(d){d[d.Invoke=1]="Invoke",d[d.Auto=2]="Auto"})(o=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var s;(function(d){d[d.Invoke=1]="Invoke",d[d.TriggerCharacter=2]="TriggerCharacter",d[d.ContentChange=3]="ContentChange"})(s=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var g;(function(d){d[d.Text=0]="Text",d[d.Read=1]="Read",d[d.Write=2]="Write"})(g=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function l(d){return d&&m.URI.isUri(d.uri)&&i.Range.isIRange(d.range)&&(i.Range.isIRange(d.originSelectionRange)||i.Range.isIRange(d.targetSelectionRange))}e.isLocationLink=l;var S;(function(d){d[d.File=0]="File",d[d.Module=1]="Module",d[d.Namespace=2]="Namespace",d[d.Package=3]="Package",d[d.Class=4]="Class",d[d.Method=5]="Method",d[d.Property=6]="Property",d[d.Field=7]="Field",d[d.Constructor=8]="Constructor",d[d.Enum=9]="Enum",d[d.Interface=10]="Interface",d[d.Function=11]="Function",d[d.Variable=12]="Variable",d[d.Constant=13]="Constant",d[d.String=14]="String",d[d.Number=15]="Number",d[d.Boolean=16]="Boolean",d[d.Array=17]="Array",d[d.Object=18]="Object",d[d.Key=19]="Key",d[d.Null=20]="Null",d[d.EnumMember=21]="EnumMember",d[d.Struct=22]="Struct",d[d.Event=23]="Event",d[d.Operator=24]="Operator",d[d.TypeParameter=25]="TypeParameter"})(S=e.SymbolKind||(e.SymbolKind={}));var n;(function(d){d[d.Deprecated=1]="Deprecated"})(n=e.SymbolTag||(e.SymbolTag={}));var t;(function(d){const k=new Map;k.set(0,P.Codicon.symbolFile),k.set(1,P.Codicon.symbolModule),k.set(2,P.Codicon.symbolNamespace),k.set(3,P.Codicon.symbolPackage),k.set(4,P.Codicon.symbolClass),k.set(5,P.Codicon.symbolMethod),k.set(6,P.Codicon.symbolProperty),k.set(7,P.Codicon.symbolField),k.set(8,P.Codicon.symbolConstructor),k.set(9,P.Codicon.symbolEnum),k.set(10,P.Codicon.symbolInterface),k.set(11,P.Codicon.symbolFunction),k.set(12,P.Codicon.symbolVariable),k.set(13,P.Codicon.symbolConstant),k.set(14,P.Codicon.symbolString),k.set(15,P.Codicon.symbolNumber),k.set(16,P.Codicon.symbolBoolean),k.set(17,P.Codicon.symbolArray),k.set(18,P.Codicon.symbolObject),k.set(19,P.Codicon.symbolKey),k.set(20,P.Codicon.symbolNull),k.set(21,P.Codicon.symbolEnumMember),k.set(22,P.Codicon.symbolStruct),k.set(23,P.Codicon.symbolEvent),k.set(24,P.Codicon.symbolOperator),k.set(25,P.Codicon.symbolTypeParameter);function R(N){let x=k.get(N);return x||(console.info("No codicon found for SymbolKind "+N),x=P.Codicon.symbolProperty),x}d.toIcon=R})(t=e.SymbolKinds||(e.SymbolKinds={}));class r{constructor(k){this.value=k}}e.FoldingRangeKind=r,r.Comment=new r("comment"),r.Imports=new r("imports"),r.Region=new r("region");var u;(function(d){d[d.Collapsed=0]="Collapsed",d[d.Expanded=1]="Expanded"})(u=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var a;(function(d){d[d.Editing=0]="Editing",d[d.Preview=1]="Preview"})(a=e.CommentMode||(e.CommentMode={}));var f;(function(d){d[d.Other=0]="Other",d[d.Type=1]="Type",d[d.Parameter=2]="Parameter"})(f=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new y.LanguageFeatureRegistry,e.RenameProviderRegistry=new y.LanguageFeatureRegistry,e.CompletionProviderRegistry=new y.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new y.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new y.LanguageFeatureRegistry,e.HoverProviderRegistry=new y.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new y.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new y.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new y.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new y.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new y.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new y.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new y.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new y.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new y.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new y.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new y.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new y.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new y.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new y.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new y.LanguageFeatureRegistry,e.LinkProviderRegistry=new y.LanguageFeatureRegistry,e.ColorProviderRegistry=new y.LanguageFeatureRegistry,e.SelectionRangeRegistry=new y.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new y.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new y.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new y.LanguageFeatureRegistry,e.TokenizationRegistry=new C.TokenizationRegistryImpl;var w;(function(d){d[d.None=0]="None",d[d.Option=1]="Option",d[d.Default=2]="Default",d[d.Preferred=3]="Preferred"})(w=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(ve[115],we([0,1,13,2,4]),function(J,e,m,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,y.createDecorator)("configurationService");function C(v){return v&&typeof v=="object"&&(!v.overrideIdentifier||typeof v.overrideIdentifier=="string")&&(!v.resource||v.resource instanceof i.URI)}e.isConfigurationOverrides=C;function P(v){return v&&typeof v=="object"&&(!v.overrideIdentifiers||m.isArray(v.overrideIdentifiers))&&!v.overrideIdentifier&&(!v.resource||v.resource instanceof i.URI)}e.isConfigurationUpdateOverrides=P;var D;(function(v){v[v.USER=1]="USER",v[v.USER_LOCAL=2]="USER_LOCAL",v[v.USER_REMOTE=3]="USER_REMOTE",v[v.WORKSPACE=4]="WORKSPACE",v[v.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",v[v.DEFAULT=6]="DEFAULT",v[v.MEMORY=7]="MEMORY"})(D=e.ConfigurationTarget||(e.ConfigurationTarget={}));function _(v){switch(v){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=_;function I(v,T){const b=Object.create(null);for(let o in v)L(b,o,v[o],T);return b}e.toValuesTree=I;function L(v,T,b,o){const s=T.split("."),g=s.pop();let l=v;for(let S=0;S<s.length;S++){let n=s[S],t=l[n];switch(typeof t){case"undefined":t=l[n]=Object.create(null);break;case"object":break;default:o(`Ignoring ${T} as ${s.slice(0,S+1).join(".")} is ${JSON.stringify(t)}`);return}l=t}if(typeof l=="object"&&l!==null)try{l[g]=b}catch{o(`Ignoring ${T} as ${s.join(".")} is ${JSON.stringify(l)}`)}else o(`Ignoring ${T} as ${s.join(".")} is ${JSON.stringify(l)}`)}e.addToValueTree=L;function A(v,T){const b=T.split(".");c(v,b)}e.removeFromValueTree=A;function c(v,T){const b=T.shift();if(T.length===0){delete v[b];return}if(Object.keys(v).indexOf(b)!==-1){const o=v[b];typeof o=="object"&&!Array.isArray(o)&&(c(o,T),Object.keys(o).length===0&&delete v[b])}}function E(v,T,b){function o(l,S){let n=l;for(const t of S){if(typeof n!="object"||n===null)return;n=n[t]}return n}const s=T.split("."),g=o(v,s);return typeof g=="undefined"?b:g}e.getConfigurationValue=E;function h(v,T,b){Object.keys(T).forEach(o=>{o!=="__proto__"&&(o in v?m.isObject(v[o])&&m.isObject(T[o])?h(v[o],T[o],b):b&&(v[o]=T[o]):v[o]=T[o])})}e.merge=h;function p(v,T,b){const o=v.inspect(T),s=v.inspect(b);return typeof o.userValue!="undefined"||typeof o.workspaceValue!="undefined"||typeof o.workspaceFolderValue!="undefined"?o.value:typeof s.userValue!="undefined"||typeof s.workspaceValue!="undefined"||typeof s.workspaceFolderValue!="undefined"?s.value:o.defaultValue}e.getMigratedSettingValue=p}),define(ve[61],we([0,1,12,8,4]),function(J,e,m,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let C=m.userAgent||"";const P=new Map;P.set("false",!1),P.set("true",!0),P.set("isMac",m.isMacintosh),P.set("isLinux",m.isLinux),P.set("isWindows",m.isWindows),P.set("isWeb",m.isWeb),P.set("isMacNative",m.isMacintosh&&!m.isWeb),P.set("isEdge",C.indexOf("Edg/")>=0),P.set("isFirefox",C.indexOf("Firefox")>=0),P.set("isChrome",C.indexOf("Chrome")>=0),P.set("isSafari",C.indexOf("Safari")>=0);const D=Object.prototype.hasOwnProperty;var _;(function(x){x[x.False=0]="False",x[x.True=1]="True",x[x.Defined=2]="Defined",x[x.Not=3]="Not",x[x.Equals=4]="Equals",x[x.NotEquals=5]="NotEquals",x[x.And=6]="And",x[x.Regex=7]="Regex",x[x.NotRegex=8]="NotRegex",x[x.Or=9]="Or",x[x.In=10]="In",x[x.NotIn=11]="NotIn",x[x.Greater=12]="Greater",x[x.GreaterEquals=13]="GreaterEquals",x[x.Smaller=14]="Smaller",x[x.SmallerEquals=15]="SmallerEquals"})(_=e.ContextKeyExprType||(e.ContextKeyExprType={}));class I{static false(){return c.INSTANCE}static true(){return E.INSTANCE}static has(F){return h.create(F)}static equals(F,B){return p.create(F,B)}static notEquals(F,B){return b.create(F,B)}static regex(F,B){return t.create(F,B)}static in(F,B){return v.create(F,B)}static not(F){return o.create(F)}static and(...F){return a.create(F,null)}static or(...F){return f.create(F,null,!0)}static greater(F,B){return g.create(F,B)}static greaterEquals(F,B){return l.create(F,B)}static smaller(F,B){return S.create(F,B)}static smallerEquals(F,B){return n.create(F,B)}static deserialize(F,B=!1){if(!!F)return this._deserializeOrExpression(F,B)}static _deserializeOrExpression(F,B){let O=F.split("||");return f.create(O.map(H=>this._deserializeAndExpression(H,B)),null,!0)}static _deserializeAndExpression(F,B){let O=F.split("&&");return a.create(O.map(H=>this._deserializeOne(H,B)),null)}static _deserializeOne(F,B){if(F=F.trim(),F.indexOf("!=")>=0){let O=F.split("!=");return b.create(O[0].trim(),this._deserializeValue(O[1],B))}if(F.indexOf("==")>=0){let O=F.split("==");return p.create(O[0].trim(),this._deserializeValue(O[1],B))}if(F.indexOf("=~")>=0){let O=F.split("=~");return t.create(O[0].trim(),this._deserializeRegexValue(O[1],B))}if(F.indexOf(" in ")>=0){let O=F.split(" in ");return v.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(F)){const O=F.split(">=");return l.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(F)){const O=F.split(">");return g.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(F)){const O=F.split("<=");return n.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(F)){const O=F.split("<");return S.create(O[0].trim(),O[1].trim())}return/^\!\s*/.test(F)?o.create(F.substr(1).trim()):h.create(F)}static _deserializeValue(F,B){if(F=F.trim(),F==="true")return!0;if(F==="false")return!1;let O=/^'([^']*)'$/.exec(F);return O?O[1].trim():F}static _deserializeRegexValue(F,B){if((0,i.isFalsyOrWhitespace)(F)){if(B)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let O=F.indexOf("/"),H=F.lastIndexOf("/");if(O===H||O<0){if(B)throw new Error(`bad regexp-value '${F}', missing /-enclosure`);return console.warn(`bad regexp-value '${F}', missing /-enclosure`),null}let M=F.slice(O+1,H),W=F[H+1]==="i"?"i":"";try{return new RegExp(M,W)}catch(z){if(B)throw new Error(`bad regexp-value '${F}', parse error: ${z}`);return console.warn(`bad regexp-value '${F}', parse error: ${z}`),null}}}e.ContextKeyExpr=I;function L(x,F){const B=x?x.substituteConstants():void 0,O=F?F.substituteConstants():void 0;return!B&&!O?!0:!B||!O?!1:B.equals(O)}e.expressionsAreEqualWithConstantSubstitution=L;function A(x,F){return x.cmp(F)}class c{constructor(){this.type=0}cmp(F){return this.type-F.type}equals(F){return F.type===this.type}substituteConstants(){return this}evaluate(F){return!1}serialize(){return"false"}keys(){return[]}map(F){return this}negate(){return E.INSTANCE}}e.ContextKeyFalseExpr=c,c.INSTANCE=new c;class E{constructor(){this.type=1}cmp(F){return this.type-F.type}equals(F){return F.type===this.type}substituteConstants(){return this}evaluate(F){return!0}serialize(){return"true"}keys(){return[]}map(F){return this}negate(){return c.INSTANCE}}e.ContextKeyTrueExpr=E,E.INSTANCE=new E;class h{constructor(F,B){this.key=F,this.negated=B,this.type=2}static create(F,B=null){const O=P.get(F);return typeof O=="boolean"?O?E.INSTANCE:c.INSTANCE:new h(F,B)}cmp(F){return F.type!==this.type?this.type-F.type:d(this.key,F.key)}equals(F){return F.type===this.type?this.key===F.key:!1}substituteConstants(){const F=P.get(this.key);return typeof F=="boolean"?F?E.INSTANCE:c.INSTANCE:this}evaluate(F){return!!F.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(F){return F.mapDefined(this.key)}negate(){return this.negated||(this.negated=o.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=h;class p{constructor(F,B,O){this.key=F,this.value=B,this.negated=O,this.type=4}static create(F,B,O=null){if(typeof B=="boolean")return B?h.create(F,O):o.create(F,O);const H=P.get(F);return typeof H=="boolean"?B===(H?"true":"false")?E.INSTANCE:c.INSTANCE:new p(F,B,O)}cmp(F){return F.type!==this.type?this.type-F.type:k(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){const F=P.get(this.key);if(typeof F=="boolean"){const B=F?"true":"false";return this.value===B?E.INSTANCE:c.INSTANCE}return this}evaluate(F){return F.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(F){return F.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=b.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=p;class v{constructor(F,B){this.key=F,this.valueKey=B,this.type=10,this.negated=null}static create(F,B){return new v(F,B)}cmp(F){return F.type!==this.type?this.type-F.type:k(this.key,this.valueKey,F.key,F.valueKey)}equals(F){return F.type===this.type?this.key===F.key&&this.valueKey===F.valueKey:!1}substituteConstants(){return this}evaluate(F){const B=F.getValue(this.valueKey),O=F.getValue(this.key);return Array.isArray(B)?B.indexOf(O)>=0:typeof O=="string"&&typeof B=="object"&&B!==null?D.call(B,O):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(F){return F.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=T.create(this)),this.negated}}e.ContextKeyInExpr=v;class T{constructor(F){this._actual=F,this.type=11}static create(F){return new T(F)}cmp(F){return F.type!==this.type?this.type-F.type:this._actual.cmp(F._actual)}equals(F){return F.type===this.type?this._actual.equals(F._actual):!1}substituteConstants(){return this}evaluate(F){return!this._actual.evaluate(F)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(F){return new T(this._actual.map(F))}negate(){return this._actual}}e.ContextKeyNotInExpr=T;class b{constructor(F,B,O){this.key=F,this.value=B,this.negated=O,this.type=5}static create(F,B,O=null){if(typeof B=="boolean")return B?o.create(F,O):h.create(F,O);const H=P.get(F);return typeof H=="boolean"?B===(H?"true":"false")?c.INSTANCE:E.INSTANCE:new b(F,B,O)}cmp(F){return F.type!==this.type?this.type-F.type:k(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){const F=P.get(this.key);if(typeof F=="boolean"){const B=F?"true":"false";return this.value===B?c.INSTANCE:E.INSTANCE}return this}evaluate(F){return F.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(F){return F.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=p.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=b;class o{constructor(F,B){this.key=F,this.negated=B,this.type=3}static create(F,B=null){const O=P.get(F);return typeof O=="boolean"?O?c.INSTANCE:E.INSTANCE:new o(F,B)}cmp(F){return F.type!==this.type?this.type-F.type:d(this.key,F.key)}equals(F){return F.type===this.type?this.key===F.key:!1}substituteConstants(){const F=P.get(this.key);return typeof F=="boolean"?F?c.INSTANCE:E.INSTANCE:this}evaluate(F){return!F.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(F){return F.mapNot(this.key)}negate(){return this.negated||(this.negated=h.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=o;function s(x,F){if(typeof x=="string"){const B=parseFloat(x);isNaN(B)||(x=B)}return typeof x=="string"||typeof x=="number"?F(x):c.INSTANCE}class g{constructor(F,B,O){this.key=F,this.value=B,this.negated=O,this.type=12}static create(F,B,O=null){return s(B,H=>new g(F,H,O))}cmp(F){return F.type!==this.type?this.type-F.type:k(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){return this}evaluate(F){return typeof this.value=="string"?!1:parseFloat(F.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(F){return F.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=n.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=g;class l{constructor(F,B,O){this.key=F,this.value=B,this.negated=O,this.type=13}static create(F,B,O=null){return s(B,H=>new l(F,H,O))}cmp(F){return F.type!==this.type?this.type-F.type:k(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){return this}evaluate(F){return typeof this.value=="string"?!1:parseFloat(F.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(F){return F.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=S.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=l;class S{constructor(F,B,O){this.key=F,this.value=B,this.negated=O,this.type=14}static create(F,B,O=null){return s(B,H=>new S(F,H,O))}cmp(F){return F.type!==this.type?this.type-F.type:k(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){return this}evaluate(F){return typeof this.value=="string"?!1:parseFloat(F.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(F){return F.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=l.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=S;class n{constructor(F,B,O){this.key=F,this.value=B,this.negated=O,this.type=15}static create(F,B,O=null){return s(B,H=>new n(F,H,O))}cmp(F){return F.type!==this.type?this.type-F.type:k(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){return this}evaluate(F){return typeof this.value=="string"?!1:parseFloat(F.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(F){return F.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=g.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=n;class t{constructor(F,B){this.key=F,this.regexp=B,this.type=7,this.negated=null}static create(F,B){return new t(F,B)}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.key<F.key)return-1;if(this.key>F.key)return 1;const B=this.regexp?this.regexp.source:"",O=F.regexp?F.regexp.source:"";return B<O?-1:B>O?1:0}equals(F){if(F.type===this.type){const B=this.regexp?this.regexp.source:"",O=F.regexp?F.regexp.source:"";return this.key===F.key&&B===O}return!1}substituteConstants(){return this}evaluate(F){let B=F.getValue(this.key);return this.regexp?this.regexp.test(B):!1}serialize(){const F=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${F}`}keys(){return[this.key]}map(F){return F.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=r.create(this)),this.negated}}e.ContextKeyRegexExpr=t;class r{constructor(F){this._actual=F,this.type=8}static create(F){return new r(F)}cmp(F){return F.type!==this.type?this.type-F.type:this._actual.cmp(F._actual)}equals(F){return F.type===this.type?this._actual.equals(F._actual):!1}substituteConstants(){return this}evaluate(F){return!this._actual.evaluate(F)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(F){return new r(this._actual.map(F))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=r;function u(x){let F=null;for(let B=0,O=x.length;B<O;B++){const H=x[B].substituteConstants();if(x[B]!==H&&F===null){F=[];for(let M=0;M<B;M++)F[M]=x[M]}F!==null&&(F[B]=H)}return F===null?x:F}class a{constructor(F,B){this.expr=F,this.negated=B,this.type=6}static create(F,B){return a._normalizeArr(F,B)}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.expr.length<F.expr.length)return-1;if(this.expr.length>F.expr.length)return 1;for(let B=0,O=this.expr.length;B<O;B++){const H=A(this.expr[B],F.expr[B]);if(H!==0)return H}return 0}equals(F){if(F.type===this.type){if(this.expr.length!==F.expr.length)return!1;for(let B=0,O=this.expr.length;B<O;B++)if(!this.expr[B].equals(F.expr[B]))return!1;return!0}return!1}substituteConstants(){const F=u(this.expr);return F===this.expr?this:a.create(F,this.negated)}evaluate(F){for(let B=0,O=this.expr.length;B<O;B++)if(!this.expr[B].evaluate(F))return!1;return!0}static _normalizeArr(F,B){const O=[];let H=!1;for(const M of F)if(!!M){if(M.type===1){H=!0;continue}if(M.type===0)return c.INSTANCE;if(M.type===6){O.push(...M.expr);continue}O.push(M)}if(O.length===0&&H)return E.INSTANCE;if(O.length!==0){if(O.length===1)return O[0];O.sort(A);for(let M=1;M<O.length;M++)O[M-1].equals(O[M])&&(O.splice(M,1),M--);if(O.length===1)return O[0];for(;O.length>1;){const M=O[O.length-1];if(M.type!==9)break;O.pop();const W=O.pop(),z=O.length===0,U=f.create(M.expr.map(V=>a.create([V,W],null)),null,z);U&&(O.push(U),O.sort(A))}return O.length===1?O[0]:new a(O,B)}}serialize(){return this.expr.map(F=>F.serialize()).join(" && ")}keys(){const F=[];for(let B of this.expr)F.push(...B.keys());return F}map(F){return new a(this.expr.map(B=>B.map(F)),null)}negate(){if(!this.negated){const F=[];for(let B of this.expr)F.push(B.negate());this.negated=f.create(F,this,!0)}return this.negated}}class f{constructor(F,B){this.expr=F,this.negated=B,this.type=9}static create(F,B,O){return f._normalizeArr(F,B,O)}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.expr.length<F.expr.length)return-1;if(this.expr.length>F.expr.length)return 1;for(let B=0,O=this.expr.length;B<O;B++){const H=A(this.expr[B],F.expr[B]);if(H!==0)return H}return 0}equals(F){if(F.type===this.type){if(this.expr.length!==F.expr.length)return!1;for(let B=0,O=this.expr.length;B<O;B++)if(!this.expr[B].equals(F.expr[B]))return!1;return!0}return!1}substituteConstants(){const F=u(this.expr);return F===this.expr?this:f.create(F,this.negated,!1)}evaluate(F){for(let B=0,O=this.expr.length;B<O;B++)if(this.expr[B].evaluate(F))return!0;return!1}static _normalizeArr(F,B,O){let H=[],M=!1;if(F){for(let W=0,z=F.length;W<z;W++){const U=F[W];if(!!U){if(U.type===0){M=!0;continue}if(U.type===1)return E.INSTANCE;if(U.type===9){H=H.concat(U.expr);continue}H.push(U)}}if(H.length===0&&M)return c.INSTANCE;H.sort(A)}if(H.length!==0){if(H.length===1)return H[0];for(let W=1;W<H.length;W++)H[W-1].equals(H[W])&&(H.splice(W,1),W--);if(H.length===1)return H[0];if(O){for(let W=0;W<H.length;W++)for(let z=W+1;z<H.length;z++)R(H[W],H[z])&&(H.splice(z,1),z--);if(H.length===1)return H[0]}return new f(H,B)}}serialize(){return this.expr.map(F=>F.serialize()).join(" || ")}keys(){const F=[];for(let B of this.expr)F.push(...B.keys());return F}map(F){return new f(this.expr.map(B=>B.map(F)),null)}negate(){if(!this.negated){let F=[];for(let B of this.expr)F.push(B.negate());for(;F.length>1;){const B=F.shift(),O=F.shift(),H=[];for(const W of N(B))for(const z of N(O))H.push(a.create([W,z],null));const M=F.length===0;F.unshift(f.create(H,null,M))}this.negated=F[0]}return this.negated}}class w extends h{constructor(F,B,O){super(F,null);this._defaultValue=B,typeof O=="object"?w._info.push({...O,key:F}):O!==!0&&w._info.push({key:F,description:O,type:B!=null?typeof B:void 0})}static all(){return w._info.values()}bindTo(F){return F.createKey(this.key,this._defaultValue)}getValue(F){return F.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(F){return p.create(this.key,F)}notEqualsTo(F){return b.create(this.key,F)}}e.RawContextKey=w,w._info=[],e.IContextKeyService=(0,y.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function d(x,F){return x<F?-1:x>F?1:0}function k(x,F,B,O){return x<B?-1:x>B?1:F<O?-1:F>O?1:0}function R(x,F){if(F.type===6&&x.type!==9&&x.type!==6){for(const H of F.expr)if(x.equals(H))return!0}const B=x.negate(),O=N(B).concat(N(F));O.sort(A);for(let H=0;H<O.length;H++){const W=O[H].negate();for(let z=H+1;z<O.length;z++){const U=O[z];if(W.equals(U))return!0}}return!1}e.implies=R;function N(x){return x.type===9?x.expr:[x]}}),define(ve[182],we([0,1,4]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,m.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,m.refineServiceDecorator)(e.IEnvironmentService)}),define(ve[183],we([0,1,10,156,4]),function(J,e,m,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";var C;(function(o){o.WIN32_X64="win32-x64",o.WIN32_IA32="win32-ia32",o.WIN32_ARM64="win32-arm64",o.LINUX_X64="linux-x64",o.LINUX_ARM64="linux-arm64",o.LINUX_ARMHF="linux-armhf",o.ALPINE_X64="alpine-x64",o.ALPINE_ARM64="alpine-arm64",o.DARWIN_X64="darwin-x64",o.DARWIN_ARM64="darwin-arm64",o.WEB="web",o.UNIVERSAL="universal",o.UNKNOWN="unknown",o.UNDEFINED="undefined"})(C=e.TargetPlatform||(e.TargetPlatform={}));function P(o){switch(o){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=P;function D(o){switch(o){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=D;function _(o,s){switch(o){case 3:return s==="x64"?"win32-x64":s==="ia32"?"win32-ia32":s==="arm64"?"win32-arm64":"unknown";case 2:return s==="x64"?"linux-x64":s==="arm64"?"linux-arm64":s==="arm"?"linux-armhf":"unknown";case"alpine":return s==="x64"?"alpine-x64":s==="arm64"?"alpine-arm64":"unknown";case 1:return s==="x64"?"darwin-x64":s==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=_;function I(o,s){return s==="web"&&!o.includes("web")}e.isNotWebExtensionInWebTargetPlatform=I;function L(o,s,g){return I(s,g)?!1:o==="undefined"||o==="universal"?!0:o==="unknown"?!1:o===g?!0:A(g).includes(o)}e.isTargetPlatformCompatible=L;function A(o){switch(o){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=A;function c(o){return o&&typeof o=="object"&&typeof o.id=="string"&&(!o.uuid||typeof o.uuid=="string")}e.isIExtensionIdentifier=c;var E;(function(o){o[o.NoneOrRelevance=0]="NoneOrRelevance",o[o.LastUpdatedDate=1]="LastUpdatedDate",o[o.Title=2]="Title",o[o.PublisherName=3]="PublisherName",o[o.InstallCount=4]="InstallCount",o[o.PublishedDate=10]="PublishedDate",o[o.AverageRating=6]="AverageRating",o[o.WeightedRating=12]="WeightedRating"})(E=e.SortBy||(e.SortBy={}));var h;(function(o){o[o.Default=0]="Default",o[o.Ascending=1]="Ascending",o[o.Descending=2]="Descending"})(h=e.SortOrder||(e.SortOrder={}));var p;(function(o){o.Install="install",o.Uninstall="uninstall"})(p=e.StatisticType||(e.StatisticType={}));var v;(function(o){o[o.None=1]="None",o[o.Install=2]="Install",o[o.Update=3]="Update",o[o.Migrate=4]="Migrate"})(v=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,y.createDecorator)("extensionGalleryService");var T;(function(o){o.Unsupported="Unsupported",o.UnsupportedPreRelease="UnsupportedPreRelease",o.Malicious="Malicious",o.Incompatible="Incompatible",o.IncompatiblePreRelease="IncompatiblePreRelease",o.IncompatibleTargetPlatform="IncompatibleTargetPlatform",o.Invalid="Invalid",o.Download="Download",o.Extract="Extract",o.Delete="Delete",o.Rename="Rename",o.CorruptZip="CorruptZip",o.IncompleteZip="IncompleteZip",o.Internal="Internal"})(T=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class b extends Error{constructor(s,g){super(s);this.code=g,this.name=g}}e.ExtensionManagementError=b,e.IExtensionManagementService=(0,y.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,y.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,y.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=m.FileAccess.asBrowserUri("./media/defaultIcon.png",J).toString(!0),e.ExtensionsLabel=(0,i.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,i.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,y.createDecorator)("IExtensionManagementCLIService")}),define(ve[184],we([0,1,4]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,m.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,m.createDecorator)("externalTerminal")}),define(ve[185],we([0,1,37,10,9,12,94,28,112,158,184]),function(J,e,m,i,y,C,P,D,_,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const A=I.localize(0,null);class c{async getDefaultTerminalForPlatforms(){return{windows:E.getDefaultTerminalWindows(),linux:await p.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class E extends c{openTerminal(s,g){return this.spawnTerminal(m,s,_.getWindowsShell(),g)}spawnTerminal(s,g,l,S){const n=g.windowsExec||E.getDefaultTerminalWindows();S&&S[1]===":"&&(S=S[0].toUpperCase()+S.substr(1));const t=y.basename(n).toLowerCase();if(t==="cmder"||t==="cmder.exe")return s.spawn(n,S?[S]:void 0),Promise.resolve(void 0);const r=["/c","start","/wait"];return n.indexOf(" ")>=0&&r.push('""'),r.push(n),(t==="wt"||t==="wt.exe")&&r.push("-d ."),new Promise((u,a)=>{const f=v(process),w=s.spawn(l,r,{cwd:S,env:f});w.on("error",a),w.on("exit",()=>u())})}runInTerminal(s,g,l,S,n){const t="windowsExec"in n&&n.windowsExec?n.windowsExec:E.getDefaultTerminalWindows();return new Promise((r,u)=>{const a=`"${g} - ${A}"`,f=`""${l.join('" "')}" & pause"`,w=["/c","start",a,"/wait",t,"/c",f],d=Object.assign({},v(process),S);Object.keys(d).filter(N=>d[N]===null).forEach(N=>delete d[N]);const k={cwd:g,env:d,windowsVerbatimArguments:!0};m.spawn(E.CMD,w,k).on("error",N=>{u(T(N))}),r(void 0)})}static getDefaultTerminalWindows(){if(!E._DEFAULT_TERMINAL_WINDOWS){const s=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");E._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${s?"Sysnative":"System32"}\\cmd.exe`}return E._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=E,E.CMD="cmd.exe";class h extends c{openTerminal(s,g){return this.spawnTerminal(m,s,g)}runInTerminal(s,g,l,S,n){const t=n.osxExec||L.DEFAULT_TERMINAL_OSX;return new Promise((r,u)=>{if(t===L.DEFAULT_TERMINAL_OSX||t==="iTerm.app"){const a=t===L.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",w=[i.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${a}.scpt`,J).fsPath,"-t",s||A,"-w",g];for(let R of l)w.push("-a"),w.push(R);if(S){const R=Object.assign({},v(process),S);for(let N in R){const x=R[N];x===null?(w.push("-u"),w.push(N)):(w.push("-e"),w.push(`${N}=${x}`))}}let d="";const k=m.spawn(h.OSASCRIPT,w);k.on("error",R=>{u(T(R))}),k.stderr.on("data",R=>{d+=R.toString()}),k.on("exit",R=>{if(R===0)r(void 0);else if(d){const N=d.split(`
`,1);u(new Error(N[0]))}else u(new Error(I.localize(1,null,a,R)))})}else u(new Error(I.localize(2,null,t)))})}spawnTerminal(s,g,l){const S=g.osxExec||L.DEFAULT_TERMINAL_OSX;return new Promise((n,t)=>{const r=["-a",S];l&&r.push(l);const u=v(process),a=s.spawn("/usr/bin/open",r,{cwd:l,env:u});a.on("error",t),a.on("exit",()=>n())})}}e.MacExternalTerminalService=h,h.OSASCRIPT="/usr/bin/osascript";class p extends c{openTerminal(s,g){return this.spawnTerminal(m,s,g)}runInTerminal(s,g,l,S,n){const t=n.linuxExec?Promise.resolve(n.linuxExec):p.getDefaultTerminalLinuxReady();return new Promise((r,u)=>{let a=[];t.then(f=>{f.indexOf("gnome-terminal")>=0?a.push("-x"):a.push("-e"),a.push("bash"),a.push("-c");const w=`${b(l)}; echo; read -p "${p.WAIT_MESSAGE}" -n1;`;a.push(`''${w}''`);const d=Object.assign({},v(process),S);Object.keys(d).filter(x=>d[x]===null).forEach(x=>delete d[x]);const k={cwd:g,env:d};let R="";const N=m.spawn(f,a,k);N.on("error",x=>{u(T(x))}),N.stderr.on("data",x=>{R+=x.toString()}),N.on("exit",x=>{if(x===0)r(void 0);else if(R){const F=R.split(`
`,1);u(new Error(F[0]))}else u(new Error(I.localize(4,null,f,x)))})})})}static async getDefaultTerminalLinuxReady(){if(!p._DEFAULT_TERMINAL_LINUX_READY)if(!C.isLinux)p._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const s=await D.Promises.exists("/etc/debian_version");p._DEFAULT_TERMINAL_LINUX_READY=new Promise(g=>{s?g("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?g("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?g("konsole"):process.env.COLORTERM?g(process.env.COLORTERM):process.env.TERM?g(process.env.TERM):g("xterm")})}return p._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(s,g,l){const S=g.linuxExec?Promise.resolve(g.linuxExec):p.getDefaultTerminalLinuxReady();return new Promise((n,t)=>{S.then(r=>{const u=v(process),a=s.spawn(r,[],{cwd:l,env:u});a.on("error",t),a.on("exit",()=>n())})})}}e.LinuxExternalTerminalService=p,p.WAIT_MESSAGE=I.localize(3,null);function v(o){const s={...o.env};return(0,P.sanitizeProcessEnvironment)(s),s}function T(o){return"errno"in o&&o.errno==="ENOENT"&&"path"in o&&typeof o.path=="string"?new Error(I.localize(5,null,o.path)):o}function b(o){let s="";for(let g of o)g.indexOf(" ")>=0?s+='"'+g+'"':s+=g,s+=" ";return s}}),define(ve[42],we([0,1,24,9,8,13,2,159,4]),function(J,e,m,i,y,C,P,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,_.createDecorator)("fileService");function I(O){return O.create===!0}e.isFileOpenForWriteOptions=I;var L;(function(O){O[O.Unknown=0]="Unknown",O[O.File=1]="File",O[O.Directory=2]="Directory",O[O.SymbolicLink=64]="SymbolicLink"})(L=e.FileType||(e.FileType={}));var A;(function(O){O[O.Readonly=1]="Readonly"})(A=e.FilePermission||(e.FilePermission={}));var c;(function(O){O[O.FileReadWrite=2]="FileReadWrite",O[O.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",O[O.FileReadStream=16]="FileReadStream",O[O.FileFolderCopy=8]="FileFolderCopy",O[O.PathCaseSensitive=1024]="PathCaseSensitive",O[O.Readonly=2048]="Readonly",O[O.Trash=4096]="Trash",O[O.FileWriteUnlock=8192]="FileWriteUnlock"})(c=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function E(O){return!!(O.capabilities&2)}e.hasReadWriteCapability=E;function h(O){return!!(O.capabilities&8)}e.hasFileFolderCopyCapability=h;function p(O){return!!(O.capabilities&4)}e.hasOpenReadWriteCloseCapability=p;function v(O){return!!(O.capabilities&16)}e.hasFileReadStreamCapability=v;var T;(function(O){O.FileExists="EntryExists",O.FileNotFound="EntryNotFound",O.FileNotADirectory="EntryNotADirectory",O.FileIsADirectory="EntryIsADirectory",O.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",O.FileTooLarge="EntryTooLarge",O.FileWriteLocked="EntryWriteLocked",O.NoPermissions="NoPermissions",O.Unavailable="Unavailable",O.Unknown="Unknown"})(T=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class b extends Error{constructor(H,M){super(H);this.code=M}}e.FileSystemProviderError=b;function o(O,H){const M=new b(O.toString(),H);return g(M,H),M}e.createFileSystemProviderError=o;function s(O){return O||o((0,D.localize)(0,null),T.Unknown)}e.ensureFileSystemProviderError=s;function g(O,H){return O.name=H?`${H} (FileSystemError)`:"FileSystemError",O}e.markAsFileSystemProviderError=g;function l(O){if(!O)return T.Unknown;if(O instanceof b)return O.code;const H=/^(.+) \(FileSystemError\)$/.exec(O.name);if(!H)return T.Unknown;switch(H[1]){case T.FileExists:return T.FileExists;case T.FileIsADirectory:return T.FileIsADirectory;case T.FileNotADirectory:return T.FileNotADirectory;case T.FileNotFound:return T.FileNotFound;case T.FileExceedsMemoryLimit:return T.FileExceedsMemoryLimit;case T.FileTooLarge:return T.FileTooLarge;case T.FileWriteLocked:return T.FileWriteLocked;case T.NoPermissions:return T.NoPermissions;case T.Unavailable:return T.Unavailable}return T.Unknown}e.toFileSystemProviderErrorCode=l;function S(O){if(O instanceof f)return O.fileOperationResult;switch(l(O)){case T.FileNotFound:return 1;case T.FileIsADirectory:return 0;case T.FileNotADirectory:return 10;case T.FileWriteLocked:return 5;case T.NoPermissions:return 6;case T.FileExists:return 4;case T.FileExceedsMemoryLimit:return 9;case T.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=S;var n;(function(O){O[O.CREATE=0]="CREATE",O[O.DELETE=1]="DELETE",O[O.MOVE=2]="MOVE",O[O.COPY=3]="COPY"})(n=e.FileOperation||(e.FileOperation={}));class t{constructor(H,M,W){this.resource=H,this.operation=M,this.target=W}isOperation(H){return this.operation===H}}e.FileOperationEvent=t;var r;(function(O){O[O.UPDATED=0]="UPDATED",O[O.ADDED=1]="ADDED",O[O.DELETED=2]="DELETED"})(r=e.FileChangeType||(e.FileChangeType={}));class u{constructor(H,M){this.added=void 0,this.updated=void 0,this.deleted=void 0;const W=new Map;for(const z of H){const U=W.get(z.type);U?U.push([z.resource,z]):W.set(z.type,[[z.resource,z]])}for(const[z,U]of W)switch(z){case 1:this.added=m.TernarySearchTree.forUris(()=>M),this.added.fill(U);break;case 0:this.updated=m.TernarySearchTree.forUris(()=>M),this.updated.fill(U);break;case 2:this.deleted=m.TernarySearchTree.forUris(()=>M),this.deleted.fill(U);break}}contains(H,...M){return this.doContains(H,{includeChildren:!1},...M)}affects(H,...M){return this.doContains(H,{includeChildren:!0},...M)}doContains(H,M,...W){if(!H)return!1;const z=W.length>0;return!!((!z||W.includes(1))&&(this.added?.get(H)||M.includeChildren&&this.added?.findSuperstr(H))||(!z||W.includes(0))&&(this.updated?.get(H)||M.includeChildren&&this.updated?.findSuperstr(H))||(!z||W.includes(2))&&(this.deleted?.findSubstr(H)||M.includeChildren&&this.deleted?.findSuperstr(H)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=u;function a(O,H,M){return!O||!H||O===H||H.length>O.length?!1:(H.charAt(H.length-1)!==i.sep&&(H+=i.sep),M?(0,y.startsWithIgnoreCase)(O,H):O.indexOf(H)===0)}e.isParent=a;class f extends Error{constructor(H,M,W){super(H);this.fileOperationResult=M,this.options=W}}e.FileOperationError=f;class w extends f{constructor(H,M,W){super(H,2,W);this.stat=M}}e.NotModifiedSinceFileOperationError=w;var d;(function(O){O[O.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",O[O.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",O[O.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",O[O.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",O[O.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",O[O.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",O[O.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",O[O.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",O[O.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",O[O.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",O[O.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",O[O.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(d=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var k;(function(O){O[O.FILE=0]="FILE",O[O.FOLDER=1]="FOLDER",O[O.ROOT_FOLDER=2]="ROOT_FOLDER"})(k=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function R(O){if(!(typeof O.size!="number"||typeof O.mtime!="number"))return O.mtime.toString(29)+O.size.toString(31)}e.etag=R;async function N(O,H){if(!H.hasProvider(P.URI.from({scheme:O.scheme})))return new Promise(M=>{const W=H.onDidChangeFileSystemProviderRegistrations(z=>{z.scheme===O.scheme&&z.added&&(W.dispose(),M())})})}e.whenProviderRegistered=N,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class x{static formatSize(H){return(0,C.isNumber)(H)||(H=0),H<x.KB?(0,D.localize)(1,null,H.toFixed(0)):H<x.MB?(0,D.localize)(2,null,(H/x.KB).toFixed(2)):H<x.GB?(0,D.localize)(3,null,(H/x.MB).toFixed(2)):H<x.TB?(0,D.localize)(4,null,(H/x.GB).toFixed(2)):(0,D.localize)(5,null,(H/x.TB).toFixed(2))}}e.ByteSize=x,x.KB=1024,x.MB=x.KB*x.KB,x.GB=x.MB*x.KB,x.TB=x.GB*x.KB;var F;(function(O){O[O.IA32=0]="IA32",O[O.OTHER=1]="OTHER"})(F=e.Arch||(e.Arch={}));function B(O){return{maxFileSize:O===0?300*x.MB:16*x.GB,maxHeapSize:O===0?700*x.MB:2*700*x.MB}}e.getPlatformLimits=B}),define(ve[85],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class m{constructor(...y){this._entries=new Map;for(let[C,P]of y)this.set(C,P)}set(y,C){const P=this._entries.get(y);return this._entries.set(y,C),P}has(y){return this._entries.has(y)}get(y){return this._entries.get(y)}}e.ServiceCollection=m}),define(ve[186],we([0,1,18,15,114,179,4,85]),function(J,e,m,i,y,C,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const _=!1;class I extends Error{constructor(h){super("cyclic dependency between services");this.message=h.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${h.toString()}`}}class L{constructor(h=new D.ServiceCollection,p=!1,v){this._activeInstantiations=new Set,this._services=h,this._strict=p,this._parent=v,this._services.set(P.IInstantiationService,this)}createChild(h){return new L(h,this._strict,this)}invokeFunction(h,...p){let v=c.traceInvocation(h),T=!1;try{return h({get:o=>{if(T)throw(0,i.illegalState)("service accessor is only valid during the invocation of its target method");const s=this._getOrCreateServiceInstance(o,v);if(!s)throw new Error(`[invokeFunction] unknown service '${o}'`);return s}},...p)}finally{T=!0,v.stop()}}createInstance(h,...p){let v,T;return h instanceof y.SyncDescriptor?(v=c.traceCreation(h.ctor),T=this._createInstance(h.ctor,h.staticArguments.concat(p),v)):(v=c.traceCreation(h),T=this._createInstance(h,p,v)),v.stop(),T}_createInstance(h,p=[],v){let T=P._util.getServiceDependencies(h).sort((s,g)=>s.index-g.index),b=[];for(const s of T){let g=this._getOrCreateServiceInstance(s.id,v);if(!g&&this._strict&&!s.optional)throw new Error(`[createInstance] ${h.name} depends on UNKNOWN service ${s.id}.`);b.push(g)}let o=T.length>0?T[0].index:p.length;if(p.length!==o){console.warn(`[createInstance] First service dependency of ${h.name} at position ${o+1} conflicts with ${p.length} static arguments`);let s=o-p.length;s>0?p=p.concat(new Array(s)):p=p.slice(0,o)}return new h(...[...p,...b])}_setServiceInstance(h,p){if(this._services.get(h)instanceof y.SyncDescriptor)this._services.set(h,p);else if(this._parent)this._parent._setServiceInstance(h,p);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(h){let p=this._services.get(h);return!p&&this._parent?this._parent._getServiceInstanceOrDescriptor(h):p}_getOrCreateServiceInstance(h,p){let v=this._getServiceInstanceOrDescriptor(h);return v instanceof y.SyncDescriptor?this._safeCreateAndCacheServiceInstance(h,v,p.branch(h,!0)):(p.branch(h,!1),v)}_safeCreateAndCacheServiceInstance(h,p,v){if(this._activeInstantiations.has(h))throw new Error(`illegal state - RECURSIVELY instantiating service '${h}'`);this._activeInstantiations.add(h);try{return this._createAndCacheServiceInstance(h,p,v)}finally{this._activeInstantiations.delete(h)}}_createAndCacheServiceInstance(h,p,v){const T=new C.Graph(s=>s.id.toString());let b=0;const o=[{id:h,desc:p,_trace:v}];for(;o.length;){const s=o.pop();if(T.lookupOrInsertNode(s),b++>1e3)throw new I(T);for(let g of P._util.getServiceDependencies(s.desc.ctor)){let l=this._getServiceInstanceOrDescriptor(g.id);if(!l&&!g.optional&&console.warn(`[createInstance] ${h} depends on ${g.id} which is NOT registered.`),l instanceof y.SyncDescriptor){const S={id:g.id,desc:l,_trace:s._trace.branch(g.id,!0)};T.insertEdge(s,S),o.push(S)}}}for(;;){const s=T.roots();if(s.length===0){if(!T.isEmpty())throw new I(T);break}for(const{data:g}of s){if(this._getServiceInstanceOrDescriptor(g.id)instanceof y.SyncDescriptor){const S=this._createServiceInstanceWithOwner(g.id,g.desc.ctor,g.desc.staticArguments,g.desc.supportsDelayedInstantiation,g._trace);this._setServiceInstance(g.id,S)}T.removeNode(g)}}return this._getServiceInstanceOrDescriptor(h)}_createServiceInstanceWithOwner(h,p,v=[],T,b){if(this._services.get(h)instanceof y.SyncDescriptor)return this._createServiceInstance(p,v,T,b);if(this._parent)return this._parent._createServiceInstanceWithOwner(h,p,v,T,b);throw new Error(`illegalState - creating UNKNOWN service instance ${p.name}`)}_createServiceInstance(h,p=[],v,T){if(v){const b=new m.IdleValue(()=>this._createInstance(h,p,T));return new Proxy(Object.create(null),{get(o,s){if(s in o)return o[s];let g=b.value,l=g[s];return typeof l!="function"||(l=l.bind(g),o[s]=l),l},set(o,s,g){return b.value[s]=g,!0}})}else return this._createInstance(h,p,T)}}e.InstantiationService=L;var A;(function(E){E[E.Creation=0]="Creation",E[E.Invocation=1]="Invocation",E[E.Branch=2]="Branch"})(A||(A={}));class c{constructor(h,p){this.type=h,this.name=p,this._start=Date.now(),this._dep=[]}static traceInvocation(h){return _?new c(1,h.name||h.toString().substring(0,42).replace(/\n/g,"")):c._None}static traceCreation(h){return _?new c(0,h.name):c._None}branch(h,p){let v=new c(2,h.toString());return this._dep.push([h,p,v]),v}stop(){let h=Date.now()-this._start;c._totals+=h;let p=!1;function v(b,o){let s=[],g=new Array(b+1).join("	");for(const[l,S,n]of o._dep)if(S&&n){p=!0,s.push(`${g}CREATES -> ${l}`);let t=v(b+1,n);t&&s.push(t)}else s.push(`${g}uses -> ${l}`);return s.join(`
`)}let T=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${v(1,this)}`,`DONE, took ${h.toFixed(2)}ms (grand total ${c._totals.toFixed(2)}ms)`];(h>2||p)&&console.log(T.join(`
`))}}c._None=new class extends c{constructor(){super(-1,null)}stop(){}branch(){return this}},c._totals=0}),define(ve[11],we([0,1,50,3,6,12,4]),function(J,e,m,i,y,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,P.createDecorator)("logService"),e.ILoggerService=(0,P.createDecorator)("loggerService");function D(){return new Date().toISOString()}var _;(function(S){S[S.Trace=0]="Trace",S[S.Debug=1]="Debug",S[S.Info=2]="Info",S[S.Warning=3]="Warning",S[S.Error=4]="Error",S[S.Critical=5]="Critical",S[S.Off=6]="Off"})(_=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=_.Info;function I(S,n,t){switch(n){case _.Trace:S.trace(t);break;case _.Debug:S.debug(t);break;case _.Info:S.info(t);break;case _.Warning:S.warn(t);break;case _.Error:S.error(t);break;case _.Critical:S.critical(t);break;default:throw new Error("Invalid log level")}}e.log=I;function L(S){let n="";for(let t=0;t<S.length;t++){let r=S[t];if(typeof r=="object")try{r=JSON.stringify(r)}catch{}n+=(t>0?" ":"")+r}return n}e.format=L;class A extends y.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new i.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(n){this.level!==n&&(this.level=n,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=A;class c extends A{constructor(n){super();this.logAlways=n}checkLogLevel(n){return this.logAlways||this.getLevel()<=n}trace(n,...t){this.checkLogLevel(_.Trace)&&this.log(_.Trace,L([n,...t]))}debug(n,...t){this.checkLogLevel(_.Debug)&&this.log(_.Debug,L([n,...t]))}info(n,...t){this.checkLogLevel(_.Info)&&this.log(_.Info,L([n,...t]))}warn(n,...t){this.checkLogLevel(_.Warning)&&this.log(_.Warning,L([n,...t]))}error(n,...t){if(this.checkLogLevel(_.Error))if(n instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=n.stack,this.log(_.Error,L(r))}else this.log(_.Error,L([n,...t]))}critical(n,...t){this.checkLogLevel(_.Critical)&&this.log(_.Critical,L([n,...t]))}flush(){}}e.AbstractMessageLogger=c;class E extends A{constructor(n=e.DEFAULT_LOG_LEVEL){super();this.setLevel(n),this.useColors=!C.isWindows}trace(n,...t){this.getLevel()<=_.Trace&&(this.useColors?console.log(`[90m[main ${D()}][0m`,n,...t):console.log(`[main ${D()}]`,n,...t))}debug(n,...t){this.getLevel()<=_.Debug&&(this.useColors?console.log(`[90m[main ${D()}][0m`,n,...t):console.log(`[main ${D()}]`,n,...t))}info(n,...t){this.getLevel()<=_.Info&&(this.useColors?console.log(`[90m[main ${D()}][0m`,n,...t):console.log(`[main ${D()}]`,n,...t))}warn(n,...t){this.getLevel()<=_.Warning&&(this.useColors?console.warn(`[93m[main ${D()}][0m`,n,...t):console.warn(`[main ${D()}]`,n,...t))}error(n,...t){this.getLevel()<=_.Error&&(this.useColors?console.error(`[91m[main ${D()}][0m`,n,...t):console.error(`[main ${D()}]`,n,...t))}critical(n,...t){this.getLevel()<=_.Critical&&(this.useColors?console.error(`[90m[main ${D()}][0m`,n,...t):console.error(`[main ${D()}]`,n,...t))}dispose(){}flush(){}}e.ConsoleMainLogger=E;class h extends A{constructor(n=e.DEFAULT_LOG_LEVEL){super();this.setLevel(n)}trace(n,...t){this.getLevel()<=_.Trace&&console.log("%cTRACE","color: #888",n,...t)}debug(n,...t){this.getLevel()<=_.Debug&&console.log("%cDEBUG","background: #eee; color: #888",n,...t)}info(n,...t){this.getLevel()<=_.Info&&console.log("%c INFO","color: #33f",n,...t)}warn(n,...t){this.getLevel()<=_.Warning&&console.log("%c WARN","color: #993",n,...t)}error(n,...t){this.getLevel()<=_.Error&&console.log("%c  ERR","color: #f33",n,...t)}critical(n,...t){this.getLevel()<=_.Critical&&console.log("%cCRITI","background: #f33; color: white",n,...t)}dispose(){}flush(){}}e.ConsoleLogger=h;class p extends A{constructor(n,t=e.DEFAULT_LOG_LEVEL){super();this.adapter=n,this.setLevel(t)}trace(n,...t){this.getLevel()<=_.Trace&&this.adapter.log(_.Trace,[this.extractMessage(n),...t])}debug(n,...t){this.getLevel()<=_.Debug&&this.adapter.log(_.Debug,[this.extractMessage(n),...t])}info(n,...t){this.getLevel()<=_.Info&&this.adapter.log(_.Info,[this.extractMessage(n),...t])}warn(n,...t){this.getLevel()<=_.Warning&&this.adapter.log(_.Warning,[this.extractMessage(n),...t])}error(n,...t){this.getLevel()<=_.Error&&this.adapter.log(_.Error,[this.extractMessage(n),...t])}critical(n,...t){this.getLevel()<=_.Critical&&this.adapter.log(_.Critical,[this.extractMessage(n),...t])}extractMessage(n){return typeof n=="string"?n:(0,m.toErrorMessage)(n,this.getLevel()<=_.Trace)}dispose(){}flush(){}}e.AdapterLogger=p;class v extends A{constructor(n){super();this.logServices=n,n.length&&this.setLevel(n[0].getLevel())}setLevel(n){for(const t of this.logServices)t.setLevel(n);super.setLevel(n)}trace(n,...t){for(const r of this.logServices)r.trace(n,...t)}debug(n,...t){for(const r of this.logServices)r.debug(n,...t)}info(n,...t){for(const r of this.logServices)r.info(n,...t)}warn(n,...t){for(const r of this.logServices)r.warn(n,...t)}error(n,...t){for(const r of this.logServices)r.error(n,...t)}critical(n,...t){for(const r of this.logServices)r.critical(n,...t)}flush(){for(const n of this.logServices)n.flush()}dispose(){for(const n of this.logServices)n.dispose()}}e.MultiplexLogService=v;class T extends y.Disposable{constructor(n){super();this.logger=n,this._register(n)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(n){this.logger.setLevel(n)}getLevel(){return this.logger.getLevel()}trace(n,...t){this.logger.trace(n,...t)}debug(n,...t){this.logger.debug(n,...t)}info(n,...t){this.logger.info(n,...t)}warn(n,...t){this.logger.warn(n,...t)}error(n,...t){this.logger.error(n,...t)}critical(n,...t){this.logger.critical(n,...t)}flush(){this.logger.flush()}}e.LogService=T;class b extends y.Disposable{constructor(n,t){super();this.logLevel=n,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(t(r=>{this.logLevel=r,this.logLevelChangeableLoggers.forEach(u=>u.setLevel(r))}))}getLogger(n){return this.loggers.get(n.toString())}createLogger(n,t){let r=this.loggers.get(n.toString());return r||(r=this.doCreateLogger(n,t?.always?_.Trace:this.logLevel,t),this.loggers.set(n.toString(),r),t?.always||this.logLevelChangeableLoggers.push(r)),r}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(n=>n.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=b;class o{constructor(){this.onDidChangeLogLevel=new i.Emitter().event}setLevel(n){}getLevel(){return _.Info}trace(n,...t){}debug(n,...t){}info(n,...t){}warn(n,...t){}error(n,...t){}critical(n,...t){}dispose(){}flush(){}}e.NullLogService=o;function s(S){if(S.verbose)return _.Trace;if(typeof S.logLevel=="string"){const n=g(S.logLevel.toLowerCase());if(n!==void 0)return n}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=s;function g(S){switch(S){case"trace":return _.Trace;case"debug":return _.Debug;case"info":return _.Info;case"warn":return _.Warning;case"error":return _.Error;case"critical":return _.Critical;case"off":return _.Off}}e.parseLogLevel=g;function l(S){switch(S){case _.Trace:return"trace";case _.Debug:return"debug";case _.Info:return"info";case _.Warning:return"warn";case _.Error:return"error";case _.Critical:return"critical";case _.Off:return"off"}}e.LogLevelToString=l}),define(ve[187],we([0,1,42,11]),function(J,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function y(D,_,I,L,A){try{const c=await new Promise((h,p)=>{J(["spdlog"],h,p)});c.setFlushOn(i.LogLevel.Trace);const E=await c.createAsyncRotatingLogger(D,_,I,L);return A&&E.clearFormatters(),E}catch(c){console.error(c)}return null}function C(D,_,I){switch(_){case i.LogLevel.Trace:D.trace(I);break;case i.LogLevel.Debug:D.debug(I);break;case i.LogLevel.Info:D.info(I);break;case i.LogLevel.Warning:D.warn(I);break;case i.LogLevel.Error:D.error(I);break;case i.LogLevel.Critical:D.critical(I);break;default:throw new Error("Invalid log level")}}class P extends i.AbstractMessageLogger{constructor(_,I,L,A,c){super();this.buffer=[],this.setLevel(c),this._loggerCreationPromise=this._createSpdLogLogger(_,I,L,A),this._register(this.onDidChangeLogLevel(E=>{this._logger&&this._logger.setLevel(E)}))}async _createSpdLogLogger(_,I,L,A){const c=L?6:1,E=30/c*m.ByteSize.MB,h=await y(_,I,E,c,A);if(h){this._logger=h,this._logger.setLevel(this.getLevel());for(const{level:p,message:v}of this.buffer)C(this._logger,p,v);this.buffer=[]}}log(_,I){this._logger?C(this._logger,_,I):this.getLevel()<=_&&this.buffer.push({level:_,message:I})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=P}),define(ve[116],we([0,1,48,160,4]),function(J,e,m,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var C;(function(_){_[_.Unnecessary=1]="Unnecessary",_[_.Deprecated=2]="Deprecated"})(C=e.MarkerTag||(e.MarkerTag={}));var P;(function(_){_[_.Hint=1]="Hint",_[_.Info=2]="Info",_[_.Warning=4]="Warning",_[_.Error=8]="Error"})(P=e.MarkerSeverity||(e.MarkerSeverity={})),function(_){function I(h,p){return p-h}_.compare=I;const L=Object.create(null);L[_.Error]=(0,i.localize)(0,null),L[_.Warning]=(0,i.localize)(1,null),L[_.Info]=(0,i.localize)(2,null);function A(h){return L[h]||""}_.toString=A;function c(h){switch(h){case m.default.Error:return _.Error;case m.default.Warning:return _.Warning;case m.default.Info:return _.Info;case m.default.Ignore:return _.Hint}}_.fromSeverity=c;function E(h){switch(h){case _.Error:return m.default.Error;case _.Warning:return m.default.Warning;case _.Info:return m.default.Info;case _.Hint:return m.default.Ignore}}_.toSeverity=E}(P=e.MarkerSeverity||(e.MarkerSeverity={}));var D;(function(_){const I="";function L(c){return A(c,!0)}_.makeKey=L;function A(c,E){let h=[I];return c.source?h.push(c.source.replace("\xA6","\\\xA6")):h.push(I),c.code?typeof c.code=="string"?h.push(c.code.replace("\xA6","\\\xA6")):h.push(c.code.value.replace("\xA6","\\\xA6")):h.push(I),c.severity!==void 0&&c.severity!==null?h.push(P.toString(c.severity)):h.push(I),c.message&&E?h.push(c.message.replace("\xA6","\\\xA6")):h.push(I),c.startLineNumber!==void 0&&c.startLineNumber!==null?h.push(c.startLineNumber.toString()):h.push(I),c.startColumn!==void 0&&c.startColumn!==null?h.push(c.startColumn.toString()):h.push(I),c.endLineNumber!==void 0&&c.endLineNumber!==null?h.push(c.endLineNumber.toString()):h.push(I),c.endColumn!==void 0&&c.endColumn!==null?h.push(c.endColumn.toString()):h.push(I),h.push(I),h.join("\xA6")}_.makeKeyOptionalMessage=A})(D=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,y.createDecorator)("markerService")}),define(ve[188],we([0,1,3,48,4]),function(J,e,m,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=i.default,e.INotificationService=(0,y.createDecorator)("notificationService");var C;(function(I){I[I.WORKSPACE=0]="WORKSPACE",I[I.GLOBAL=1]="GLOBAL"})(C=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var P;(function(I){I[I.OFF=0]="OFF",I[I.SILENT=1]="SILENT",I[I.ERROR=2]="ERROR"})(P=e.NotificationsFilter||(e.NotificationsFilter={}));class D{constructor(){this.progress=new _,this.onDidClose=m.Event.None,this.onDidChangeVisibility=m.Event.None}updateSeverity(L){}updateMessage(L){}updateActions(L){}close(){}}e.NoOpNotification=D;class _{infinite(){}done(){}total(L){}worked(L){}}e.NoOpProgress=_}),define(ve[189],we([0,1,6,8,2,4]),function(J,e,m,i,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,C.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return m.Disposable.None},registerValidator(){return m.Disposable.None},registerExternalUriResolver(){return m.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return m.Disposable.None},async open(){return!1},async resolveExternalUri(_){return{resolved:_,dispose(){}}}});function P(_,I){return y.URI.isUri(_)?(0,i.equalsIgnoreCase)(_.scheme,I):(0,i.startsWithIgnoreCase)(_,I+":")}e.matchesScheme=P;function D(_,...I){return I.some(L=>P(_,L))}e.matchesSomeScheme=D}),define(ve[190],we([0,1,10,12,40,23]),function(J,e,m,i,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let P;if(typeof i.globals.vscode!="undefined"&&typeof i.globals.vscode.context!="undefined"){const D=i.globals.vscode.context.configuration();if(D)P=D.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof J?.__$__nodeRequire=="function"){const D=(0,C.dirname)(m.FileAccess.asFileUri("",J));P=J.__$__nodeRequire((0,C.joinPath)(D,"product.json").fsPath);const _=J.__$__nodeRequire((0,C.joinPath)(D,"package.json").fsPath);y.env.VSCODE_DEV&&Object.assign(P,{nameShort:`${P.nameShort} Dev`,nameLong:`${P.nameLong} Dev`,dataFolderName:`${P.dataFolderName}-dev`}),Object.assign(P,{version:_.version})}else P={},Object.keys(P).length===0&&Object.assign(P,{version:"1.63.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=P});var ze=this&&this.__param||function(J,e){return function(m,i){e(m,i,J)}};define(ve[117],we([0,1,18,21,6,4]),function(J,e,m,i,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,C.createDecorator)("progressService");var P;(function(L){L[L.Explorer=1]="Explorer",L[L.Scm=3]="Scm",L[L.Extensions=5]="Extensions",L[L.Window=10]="Window",L[L.Notification=15]="Notification",L[L.Dialog=20]="Dialog"})(P=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class D{constructor(A){this.callback=A}get value(){return this._value}report(A){this._value=A,this.callback(this._value)}}e.Progress=D,D.None=Object.freeze({report(){}});let _=class extends y.Disposable{constructor(A,c){super();this.deferred=new m.DeferredPromise,c.withProgress(A,E=>(this.reporter=E,this.lastStep&&E.report(this.lastStep),this.deferred.p)),this._register((0,y.toDisposable)(()=>this.deferred.complete()))}report(A){this.reporter?this.reporter.report(A):this.lastStep=A}};_=je([ze(1,e.IProgressService)],_),e.UnmanagedProgress=_;class I extends y.Disposable{constructor(A){super();this.progressIndicator=A,this.currentOperationId=0,this.currentOperationDisposables=this._register(new y.DisposableStore)}start(A){this.stop();const c=++this.currentOperationId,E=new i.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{c===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},A),this.currentOperationDisposables.add((0,y.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,y.toDisposable)(()=>E.cancel())),this.currentOperationDisposables.add((0,y.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:c,token:E.token,stop:()=>this.doStop(c),isCurrent:()=>this.currentOperationId===c}}stop(){this.doStop(this.currentOperationId)}doStop(A){this.currentOperationId===A&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=I,e.IEditorProgressService=(0,C.createDecorator)("editorProgressService")}),define(ve[51],we([0,1,56,13]),function(J,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class y{constructor(){this.data=new Map}add(P,D){m.ok(i.isString(P)),m.ok(i.isObject(D)),m.ok(!this.data.has(P),"There is already an extension with this id"),this.data.set(P,D)}knows(P){return this.data.has(P)}as(P){return this.data.get(P)||null}}e.Registry=new y}),define(ve[191],we([0,1,3,51]),function(J,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function y(D){return D.length>0&&D.charAt(D.length-1)==="#"?D.substring(0,D.length-1):D}class C{constructor(){this._onDidChangeSchema=new m.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(_,I){this.schemasById[y(_)]=I,this._onDidChangeSchema.fire(_)}notifySchemaChanged(_){this._onDidChangeSchema.fire(_)}getSchemaContributions(){return{schemas:this.schemasById}}}const P=new C;i.Registry.add(e.Extensions.JSONContribution,P)}),define(ve[118],we([0,1,16,3,13,155,191,51]),function(J,e,m,i,y,C,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var _;(function(s){s.Multiline="multilineText",s.Singleline="singlelineText"})(_=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var I;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.MACHINE=2]="MACHINE",s[s.WINDOW=3]="WINDOW",s[s.RESOURCE=4]="RESOURCE",s[s.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",s[s.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(I=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const L=D.Registry.as(P.Extensions.JSONContribution);class A{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new i.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new i.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:C.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},L.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(g,l=!0){this.registerConfigurations([g],l)}registerConfigurations(g,l=!0){const S=this.doRegisterConfigurations(g,l);L.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:S})}deregisterConfigurations(g){const l=this.doDeregisterConfigurations(g);L.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:l})}updateConfigurations({add:g,remove:l}){const S=[];S.push(...this.doDeregisterConfigurations(l)),S.push(...this.doRegisterConfigurations(g,!1)),L.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,m.distinct)(S)})}registerDefaultConfigurations(g){const l=[],S=[];for(const{overrides:n,source:t}of g)for(const r in n)if(l.push(r),e.OVERRIDE_PROPERTY_REGEX.test(r)){const u={...this.configurationDefaultsOverrides.get(r)?.value||{},...n[r]};this.configurationDefaultsOverrides.set(r,{source:t,value:u});const a={type:"object",default:u,description:C.localize(1,null,r),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:u,source:y.isString(t)?void 0:t};S.push(...h(r)),this.configurationProperties[r]=a,this.defaultLanguageConfigurationOverridesNode.properties[r]=a}else{this.configurationDefaultsOverrides.set(r,{value:n[r],source:t});const u=this.configurationProperties[r];u&&(this.updatePropertyDefaultValue(r,u),this.updateSchema(r,u))}this.registerOverrideIdentifiers(S),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:l,defaultsOverrides:!0})}deregisterDefaultConfigurations(g){const l=[];for(const{overrides:S,source:n}of g)for(const t in S){const r=this.configurationDefaultsOverrides.get(t),u=y.isString(n)?n:n?.id,a=y.isString(r?.source)?r?.source:r?.source?.id;if(u===a)if(l.push(t),this.configurationDefaultsOverrides.delete(t),e.OVERRIDE_PROPERTY_REGEX.test(t))delete this.configurationProperties[t],delete this.defaultLanguageConfigurationOverridesNode.properties[t];else{const f=this.configurationProperties[t];f&&(this.updatePropertyDefaultValue(t,f),this.updateSchema(t,f))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:l,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...g){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(g){for(const l of g)this.overrideIdentifiers.add(l);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(g,l){const S=[];return g.forEach(n=>{S.push(...this.validateAndRegisterProperties(n,l,n.extensionInfo,n.restrictedProperties)),this.configurationContributors.push(n),this.registerJSONConfiguration(n)}),S}doDeregisterConfigurations(g){const l=[],S=n=>{if(n.properties)for(const t in n.properties)l.push(t),delete this.configurationProperties[t],this.removeFromSchema(t,n.properties[t]);n.allOf&&n.allOf.forEach(t=>S(t))};for(const n of g){S(n);const t=this.configurationContributors.indexOf(n);t!==-1&&this.configurationContributors.splice(t,1)}return l}validateAndRegisterProperties(g,l=!0,S,n,t=3){t=y.isUndefinedOrNull(g.scope)?t:g.scope;let r=[],u=g.properties;if(u)for(let f in u){if(l&&b(f)){delete u[f];continue}const w=u[f];if(w.source=S,w.defaultDefaultValue=u[f].default,this.updatePropertyDefaultValue(f,w),e.OVERRIDE_PROPERTY_REGEX.test(f)?w.scope=void 0:(w.scope=y.isUndefinedOrNull(w.scope)?t:w.scope,w.restricted=y.isUndefinedOrNull(w.restricted)?!!n?.includes(f):w.restricted),u[f].hasOwnProperty("included")&&!u[f].included){this.excludedConfigurationProperties[f]=u[f],delete u[f];continue}else this.configurationProperties[f]=u[f];!u[f].deprecationMessage&&u[f].markdownDeprecationMessage&&(u[f].deprecationMessage=u[f].markdownDeprecationMessage),r.push(f)}let a=g.allOf;if(a)for(let f of a)r.push(...this.validateAndRegisterProperties(f,l,S,n,t));return r}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(g){const l=S=>{let n=S.properties;if(n)for(const r in n)this.updateSchema(r,n[r]);let t=S.allOf;t&&t.forEach(l)};l(g)}updateSchema(g,l){switch(e.allSettings.properties[g]=l,l.scope){case 1:e.applicationSettings.properties[g]=l;break;case 2:e.machineSettings.properties[g]=l;break;case 6:e.machineOverridableSettings.properties[g]=l;break;case 3:e.windowSettings.properties[g]=l;break;case 4:e.resourceSettings.properties[g]=l;break;case 5:e.resourceSettings.properties[g]=l,this.resourceLanguageSettingsSchema.properties[g]=l;break}}removeFromSchema(g,l){switch(delete e.allSettings.properties[g],l.scope){case 1:delete e.applicationSettings.properties[g];break;case 2:delete e.machineSettings.properties[g];break;case 6:delete e.machineOverridableSettings.properties[g];break;case 3:delete e.windowSettings.properties[g];break;case 4:case 5:delete e.resourceSettings.properties[g],delete this.resourceLanguageSettingsSchema.properties[g];break}}updateOverridePropertyPatternKey(){for(const g of this.overrideIdentifiers.values()){const l=`[${g}]`,S={type:"object",description:C.localize(2,null),errorMessage:C.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(l,S),e.allSettings.properties[l]=S,e.applicationSettings.properties[l]=S,e.machineSettings.properties[l]=S,e.machineOverridableSettings.properties[l]=S,e.windowSettings.properties[l]=S,e.resourceSettings.properties[l]=S}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const g={type:"object",description:C.localize(4,null),errorMessage:C.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=g,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=g,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=g,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=g,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=g,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=g,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(g,l){const S=this.configurationDefaultsOverrides.get(g);let n=S?.value,t=S?.source;y.isUndefined(n)&&(n=l.defaultDefaultValue,t=void 0),y.isUndefined(n)&&(n=v(l.type)),l.default=n,l.defaultValueSource=t}}const c="\\[([^\\]]+)\\]",E=new RegExp(c,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${c})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function h(s){const g=[];if(e.OVERRIDE_PROPERTY_REGEX.test(s)){let l=E.exec(s);for(;l?.length;){const S=l[1].trim();S&&g.push(S),l=E.exec(s)}}return(0,m.distinct)(g)}e.overrideIdentifiersFromKey=h;function p(s){return s.reduce((g,l)=>`${g}[${l}]`,"")}e.keyFromOverrideIdentifiers=p;function v(s){switch(Array.isArray(s)?s[0]:s){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=v;const T=new A;D.Registry.add(e.Extensions.Configuration,T);function b(s){return s.trim()?e.OVERRIDE_PROPERTY_REGEX.test(s)?C.localize(7,null,s):T.getConfigurationProperties()[s]!==void 0?C.localize(8,null,s):null:C.localize(6,null)}e.validateProperty=b;function o(){const s=[],g=T.getConfigurationProperties();for(const l of Object.keys(g))s.push([l,g[l].scope]);return s.push(["launch",4]),s.push(["task",4]),s}e.getScopes=o}),define(ve[192],we([0,1,16,3,58,6,24,25,13,2,115,118,51]),function(J,e,m,i,y,C,P,D,_,I,L,A,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class E{constructor(n={},t=[],r=[]){this._contents=n,this._keys=t,this._overrides=r,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(n){return n?(0,L.getConfigurationValue)(this.contents,n):this.contents}getOverrideValue(n,t){const r=this.getContentsForOverrideIdentifer(t);return r?n?(0,L.getConfigurationValue)(r,n):r:void 0}getKeysForOverrideIdentifier(n){const t=[];for(const r of this.overrides)r.identifiers.includes(n)&&t.push(...r.keys);return m.distinct(t)}getAllOverrideIdentifiers(){const n=[];for(const t of this.overrides)n.push(...t.identifiers);return m.distinct(n)}override(n){let t=this.overrideConfigurations.get(n);return t||(t=this.createOverrideConfigurationModel(n),this.overrideConfigurations.set(n,t)),t}merge(...n){const t=D.deepClone(this.contents),r=D.deepClone(this.overrides),u=[...this.keys];for(const a of n){this.mergeContents(t,a.contents);for(const f of a.overrides){const[w]=r.filter(d=>m.equals(d.identifiers,f.identifiers));w?(this.mergeContents(w.contents,f.contents),w.keys.push(...f.keys),w.keys=m.distinct(w.keys)):r.push(D.deepClone(f))}for(const f of a.keys)u.indexOf(f)===-1&&u.push(f)}return new E(t,u,r)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(n){const t=this.getContentsForOverrideIdentifer(n);if(!t||typeof t!="object"||!Object.keys(t).length)return this;let r={};for(const u of m.distinct([...Object.keys(this.contents),...Object.keys(t)])){let a=this.contents[u],f=t[u];f&&(typeof a=="object"&&typeof f=="object"?(a=D.deepClone(a),this.mergeContents(a,f)):a=f),r[u]=a}return new E(r,this.keys,this.overrides)}mergeContents(n,t){for(const r of Object.keys(t)){if(r in n&&_.isObject(n[r])&&_.isObject(t[r])){this.mergeContents(n[r],t[r]);continue}n[r]=D.deepClone(t[r])}}checkAndFreeze(n){return this.isFrozen&&!Object.isFrozen(n)?D.deepFreeze(n):n}getContentsForOverrideIdentifer(n){let t=null,r=null;const u=a=>{a&&(r?this.mergeContents(r,a):r=D.deepClone(a))};for(const a of this.overrides)m.equals(a.identifiers,[n])?t=a.contents:a.identifiers.includes(n)&&u(a.contents);return u(t),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(n,t){this.addKey(n),(0,L.addToValueTree)(this.contents,n,t,r=>{throw new Error(r)})}removeValue(n){this.removeKey(n)&&(0,L.removeFromValueTree)(this.contents,n)}addKey(n){let t=this.keys.length;for(let r=0;r<t;r++)n.indexOf(this.keys[r])===0&&(t=r);this.keys.splice(t,1,n)}removeKey(n){let t=this.keys.indexOf(n);return t!==-1?(this.keys.splice(t,1),!0):!1}}e.ConfigurationModel=E;class h extends E{constructor(n={}){const t=c.Registry.as(A.Extensions.Configuration).getConfigurationProperties(),r=Object.keys(t),u=Object.create(null),a=[];for(const f in t){const w=n[f],d=w!==void 0?w:t[f].default;(0,L.addToValueTree)(u,f,d,k=>console.error(`Conflict in default settings: ${k}`))}for(const f of Object.keys(u))A.OVERRIDE_PROPERTY_REGEX.test(f)&&a.push({identifiers:(0,A.overrideIdentifiersFromKey)(f),keys:Object.keys(u[f]),contents:(0,L.toValuesTree)(u[f],w=>console.error(`Conflict in default settings file: ${w}`))});super(u,r,a)}}e.DefaultConfigurationModel=h;class p{constructor(n){this._name=n,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new E}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(n,t){if(!_.isUndefinedOrNull(n)){const r=this.doParseContent(n);this.parseRaw(r,t)}}reparse(n){this._raw&&this.parseRaw(this._raw,n)}parseRaw(n,t){this._raw=n;const{contents:r,keys:u,overrides:a,restricted:f}=this.doParseRaw(n,t);this._configurationModel=new E(r,u,a),this._restrictedConfigurations=f||[]}doParseContent(n){let t={},r=null,u=[],a=[],f=[];function w(k){Array.isArray(u)?u.push(k):r!==null&&(u[r]=k)}let d={onObjectBegin:()=>{let k={};w(k),a.push(u),u=k,r=null},onObjectProperty:k=>{r=k},onObjectEnd:()=>{u=a.pop()},onArrayBegin:()=>{let k=[];w(k),a.push(u),u=k,r=null},onArrayEnd:()=>{u=a.pop()},onLiteralValue:w,onError:(k,R,N)=>{f.push({error:k,offset:R,length:N})}};if(n)try{y.visit(n,d),t=u[0]||{}}catch(k){console.error(`Error while parsing settings file ${this._name}: ${k}`),this._parseErrors=[k]}return t}doParseRaw(n,t){const r=c.Registry.as(A.Extensions.Configuration).getConfigurationProperties(),u=this.filter(n,r,!0,t);n=u.raw;const a=(0,L.toValuesTree)(n,d=>console.error(`Conflict in settings file ${this._name}: ${d}`)),f=Object.keys(n),w=this.toOverrides(n,d=>console.error(`Conflict in settings file ${this._name}: ${d}`));return{contents:a,keys:f,overrides:w,restricted:u.restricted}}filter(n,t,r,u){if(!u?.scopes&&!u?.skipRestricted)return{raw:n,restricted:[]};const a={},f=[];for(let w in n)if(A.OVERRIDE_PROPERTY_REGEX.test(w)&&r){const d=this.filter(n[w],t,!1,u);a[w]=d.raw,f.push(...d.restricted)}else{const d=t[w],k=d?typeof d.scope!="undefined"?d.scope:3:void 0;d?.restricted&&f.push(w),(k===void 0||u.scopes===void 0||u.scopes.includes(k))&&(u.skipRestricted&&d?.restricted||(a[w]=n[w]))}return{raw:a,restricted:f}}toOverrides(n,t){const r=[];for(const u of Object.keys(n))if(A.OVERRIDE_PROPERTY_REGEX.test(u)){const a={};for(const f in n[u])a[f]=n[u][f];r.push({identifiers:(0,A.overrideIdentifiersFromKey)(u),keys:Object.keys(a),contents:(0,L.toValuesTree)(a,t)})}return r}}e.ConfigurationModelParser=p;class v extends C.Disposable{constructor(n,t,r,u){super();this.userSettingsResource=n,this.scopes=t,this.fileService=u,this._onDidChange=this._register(new i.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new p(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(i.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const n=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(n.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new E}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=v;class T{constructor(n,t,r=new E,u=new E,a=new P.ResourceMap,f=new E,w=new P.ResourceMap,d=!0){this._defaultConfiguration=n,this._localUserConfiguration=t,this._remoteUserConfiguration=r,this._workspaceConfiguration=u,this._folderConfigurations=a,this._memoryConfiguration=f,this._memoryConfigurationByResource=w,this._freeze=d,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new P.ResourceMap,this._userConfiguration=null}getValue(n,t,r){return this.getConsolidateConfigurationModel(t,r).getValue(n)}updateValue(n,t,r={}){let u;r.resource?(u=this._memoryConfigurationByResource.get(r.resource),u||(u=new E,this._memoryConfigurationByResource.set(r.resource,u))):u=this._memoryConfiguration,t===void 0?u.removeValue(n):u.setValue(n,t),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(n,t,r){const u=this.getConsolidateConfigurationModel(t,r),a=this.getFolderConfigurationModelForResource(t.resource,r),f=t.resource?this._memoryConfigurationByResource.get(t.resource)||this._memoryConfiguration:this._memoryConfiguration,w=t.overrideIdentifier?this._defaultConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this._defaultConfiguration.freeze().getValue(n),d=t.overrideIdentifier?this.userConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this.userConfiguration.freeze().getValue(n),k=t.overrideIdentifier?this.localUserConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this.localUserConfiguration.freeze().getValue(n),R=t.overrideIdentifier?this.remoteUserConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this.remoteUserConfiguration.freeze().getValue(n),N=r?t.overrideIdentifier?this._workspaceConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this._workspaceConfiguration.freeze().getValue(n):void 0,x=a?t.overrideIdentifier?a.freeze().override(t.overrideIdentifier).getValue(n):a.freeze().getValue(n):void 0,F=t.overrideIdentifier?f.override(t.overrideIdentifier).getValue(n):f.getValue(n),B=u.getValue(n),O=m.distinct(m.flatten(u.overrides.map(H=>H.identifiers))).filter(H=>u.getOverrideValue(n,H)!==void 0);return{defaultValue:w,userValue:d,userLocalValue:k,userRemoteValue:R,workspaceValue:N,workspaceFolderValue:x,memoryValue:F,value:B,default:w!==void 0?{value:this._defaultConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,user:d!==void 0?{value:this.userConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,userLocal:k!==void 0?{value:this.localUserConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,userRemote:R!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,workspace:N!==void 0?{value:this._workspaceConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,workspaceFolder:x!==void 0?{value:a?.freeze().getValue(n),override:t.overrideIdentifier?a?.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,memory:F!==void 0?{value:f.getValue(n),override:t.overrideIdentifier?f.getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,overrideIdentifiers:O.length?O:void 0}}keys(n){const t=this.getFolderConfigurationModelForResource(void 0,n);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:t?t.freeze().keys:[]}}updateDefaultConfiguration(n){this._defaultConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(n){this._localUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(n){this._remoteUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(n){this._workspaceConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(n,t){this._folderConfigurations.set(n,t),this._foldersConsolidatedConfigurations.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this._foldersConsolidatedConfigurations.delete(n)}compareAndUpdateDefaultConfiguration(n,t){const r=[];if(!t){const{added:u,updated:a,removed:f}=g(this._defaultConfiguration,n);t=[...u,...a,...f]}for(const u of t)for(const a of(0,A.overrideIdentifiersFromKey)(u)){const f=this._defaultConfiguration.getKeysForOverrideIdentifier(a),w=n.getKeysForOverrideIdentifier(a),d=[...w.filter(k=>f.indexOf(k)===-1),...f.filter(k=>w.indexOf(k)===-1),...f.filter(k=>!D.equals(this._defaultConfiguration.override(a).getValue(k),n.override(a).getValue(k)))];r.push([a,d])}return this.updateDefaultConfiguration(n),{keys:t,overrides:r}}compareAndUpdateLocalUserConfiguration(n){const{added:t,updated:r,removed:u,overrides:a}=g(this.localUserConfiguration,n),f=[...t,...r,...u];return f.length&&this.updateLocalUserConfiguration(n),{keys:f,overrides:a}}compareAndUpdateRemoteUserConfiguration(n){const{added:t,updated:r,removed:u,overrides:a}=g(this.remoteUserConfiguration,n);let f=[...t,...r,...u];return f.length&&this.updateRemoteUserConfiguration(n),{keys:f,overrides:a}}compareAndUpdateWorkspaceConfiguration(n){const{added:t,updated:r,removed:u,overrides:a}=g(this.workspaceConfiguration,n);let f=[...t,...r,...u];return f.length&&this.updateWorkspaceConfiguration(n),{keys:f,overrides:a}}compareAndUpdateFolderConfiguration(n,t){const r=this.folderConfigurations.get(n),{added:u,updated:a,removed:f,overrides:w}=g(r,t);let d=[...u,...a,...f];return(d.length||!r)&&this.updateFolderConfiguration(n,t),{keys:d,overrides:w}}compareAndDeleteFolderConfiguration(n){const t=this.folderConfigurations.get(n);if(!t)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:r,updated:u,removed:a,overrides:f}=g(t,void 0);return{keys:[...r,...u,...a],overrides:f}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(n,t){let r=this.getConsolidatedConfigurationModelForResource(n,t);return n.overrideIdentifier?r.override(n.overrideIdentifier):r}getConsolidatedConfigurationModelForResource({resource:n},t){let r=this.getWorkspaceConsolidatedConfiguration();if(t&&n){const u=t.getFolder(n);u&&(r=this.getFolderConsolidatedConfiguration(u.uri)||r);const a=this._memoryConfigurationByResource.get(n);a&&(r=r.merge(a))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(n){let t=this._foldersConsolidatedConfigurations.get(n);if(!t){const r=this.getWorkspaceConsolidatedConfiguration(),u=this._folderConfigurations.get(n);u?(t=r.merge(u),this._freeze&&(t=t.freeze()),this._foldersConsolidatedConfigurations.set(n,t)):t=r}return t}getFolderConfigurationModelForResource(n,t){if(t&&n){const r=t.getFolder(n);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((n,t)=>{const{contents:r,overrides:u,keys:a}=this._folderConfigurations.get(t);return n.push([t,{contents:r,overrides:u,keys:a}]),n},[])}}allKeys(){const n=new Set;return this._defaultConfiguration.freeze().keys.forEach(t=>n.add(t)),this.userConfiguration.freeze().keys.forEach(t=>n.add(t)),this._workspaceConfiguration.freeze().keys.forEach(t=>n.add(t)),this._folderConfigurations.forEach(t=>t.freeze().keys.forEach(r=>n.add(r))),[...n.values()]}allOverrideIdentifiers(){const n=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>n.add(t)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>n.add(t)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>n.add(t)),this._folderConfigurations.forEach(t=>t.freeze().getAllOverrideIdentifiers().forEach(r=>n.add(r))),[...n.values()]}getAllKeysForOverrideIdentifier(n){const t=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(n).forEach(r=>t.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(r=>t.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(n).forEach(r=>t.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(n).forEach(u=>t.add(u))),[...t.values()]}static parse(n){const t=this.parseConfigurationModel(n.defaults),r=this.parseConfigurationModel(n.user),u=this.parseConfigurationModel(n.workspace),a=n.folders.reduce((f,w)=>(f.set(I.URI.revive(w[0]),this.parseConfigurationModel(w[1])),f),new P.ResourceMap);return new T(t,r,new E,u,a,new E,new P.ResourceMap,!1)}static parseConfigurationModel(n){return new E(n.contents,n.keys,n.overrides).freeze()}}e.Configuration=T;function b(...S){if(S.length===0)return{keys:[],overrides:[]};if(S.length===1)return S[0];const n=new Set,t=new Map;for(const u of S)u.keys.forEach(a=>n.add(a)),u.overrides.forEach(([a,f])=>{const w=(0,P.getOrSet)(t,a,new Set);f.forEach(d=>w.add(d))});const r=[];return t.forEach((u,a)=>r.push([a,[...u.values()]])),{keys:[...n.values()],overrides:r}}e.mergeChanges=b;class o{constructor(n,t,r,u){this.change=n,this.previous=t,this.currentConfiguraiton=r,this.currentWorkspace=u,this._previousConfiguration=void 0;const a=new Set;n.keys.forEach(w=>a.add(w)),n.overrides.forEach(([,w])=>w.forEach(d=>a.add(d))),this.affectedKeys=[...a.values()];const f=new E;this.affectedKeys.forEach(w=>f.setValue(w,{})),this.affectedKeysTree=f.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=T.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(n,t){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,n)){if(t){const r=this.previousConfiguration?this.previousConfiguration.getValue(n,t,this.previous?.workspace):void 0,u=this.currentConfiguraiton.getValue(n,t,this.currentWorkspace);return!D.equals(r,u)}return!0}return!1}doesAffectedKeysTreeContains(n,t){let r=(0,L.toValuesTree)({[t]:!0},()=>{}),u;for(;typeof r=="object"&&(u=Object.keys(r)[0]);){if(n=n[u],!n)return!1;r=r[u]}return!0}}e.ConfigurationChangeEvent=o;class s extends o{constructor(n,t,r,u){super({keys:n.allKeys(),overrides:[]},void 0,n,t);this.source=r,this.sourceConfig=u}}e.AllKeysConfigurationChangeEvent=s;function g(S,n){const{added:t,removed:r,updated:u}=l(n,S),a=[],f=S?.getAllOverrideIdentifiers()||[],w=n?.getAllOverrideIdentifiers()||[];if(n){const d=w.filter(k=>!f.includes(k));for(const k of d)a.push([k,n.getKeysForOverrideIdentifier(k)])}if(S){const d=f.filter(k=>!w.includes(k));for(const k of d)a.push([k,S.getKeysForOverrideIdentifier(k)])}if(n&&S){for(const d of f)if(w.includes(d)){const k=l({contents:S.getOverrideValue(void 0,d)||{},keys:S.getKeysForOverrideIdentifier(d)},{contents:n.getOverrideValue(void 0,d)||{},keys:n.getKeysForOverrideIdentifier(d)});a.push([d,[...k.added,...k.removed,...k.updated]])}}return{added:t,removed:r,updated:u,overrides:a}}function l(S,n){const t=S?n?S.keys.filter(a=>n.keys.indexOf(a)===-1):[...S.keys]:[],r=n?S?n.keys.filter(a=>S.keys.indexOf(a)===-1):[...n.keys]:[],u=[];if(S&&n){for(const a of n.keys)if(S.keys.indexOf(a)!==-1){const f=(0,L.getConfigurationValue)(n.contents,a),w=(0,L.getConfigurationValue)(S.contents,a);D.equals(f,w)||u.push(a)}}return{added:t,removed:r,updated:u}}}),define(ve[119],we([0,1,4]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,m.createDecorator)("remoteAuthorityResolverService");var i;(function(C){C.Unknown="Unknown",C.NotAvailable="NotAvailable",C.TemporarilyNotAvailable="TemporarilyNotAvailable",C.NoResolverFound="NoResolverFound"})(i=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class y extends Error{constructor(P,D=i.Unknown,_){super(P);this._message=P,this._code=D,this._detail=_,this.isHandled=D===i.NotAvailable&&_===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,y.prototype)}static isTemporarilyNotAvailable(P){return P instanceof y&&P._code===i.TemporarilyNotAvailable}static isNoResolverFound(P){return P instanceof y&&P._code===i.NoResolverFound}static isHandled(P){return P instanceof y&&P.isHandled}}e.RemoteAuthorityResolverError=y}),define(ve[62],we([0,1,10]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function i(I){return I.scheme===m.Schemas.vscodeRemote?I.authority:void 0}e.getRemoteAuthority=i;function y(I){if(!I)return;const L=I.indexOf("+");return L<0?I:I.substr(0,L)}e.getRemoteName=y;function C(I){return I.scheme!==m.Schemas.file&&I.scheme!==m.Schemas.vscodeRemote}e.isVirtualResource=C;function P(I){if(I.folders.length)return I.folders.every(L=>C(L.uri))?I.folders[0].uri:void 0;if(I.configuration&&C(I.configuration))return I.configuration}e.getVirtualWorkspaceLocation=P;function D(I){return P(I)?.scheme}e.getVirtualWorkspaceScheme=D;function _(I){return P(I)!==void 0}e.isVirtualWorkspace=_}),define(ve[27],we([0,1,8,4,62]),function(J,e,m,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function C(c){if(typeof c=="object"&&c!==null&&c.supported!==!0)return c.description}e.getWorkspaceSupportTypeMessage=C;function P(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(!c.uuid||typeof c.uuid=="string")}e.isIExtensionIdentifier=P,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var D;(function(c){c[c.System=0]="System",c[c.User=1]="User"})(D=e.ExtensionType||(e.ExtensionType={}));class _{constructor(E){this.value=E,this._lower=E.toLowerCase()}static equals(E,h){if(typeof E=="undefined"||E===null)return typeof h=="undefined"||h===null;if(typeof h=="undefined"||h===null)return!1;if(typeof E=="string"||typeof h=="string"){let p=typeof E=="string"?E:E.value,v=typeof h=="string"?h:h.value;return m.equalsIgnoreCase(p,v)}return E._lower===h._lower}static toKey(E){return typeof E=="string"?E.toLowerCase():E._lower}}e.ExtensionIdentifier=_;function I(c){return c.contributes&&c.contributes.localizations?c.contributes.localizations.length>0:!1}e.isLanguagePackExtension=I;function L(c){return c.contributes&&c.contributes.authentication?c.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=L;function A(c,E){if(E){const h=`onResolveRemoteAuthority:${(0,y.getRemoteName)(E)}`;return c.activationEvents?.indexOf(h)!==-1}return!1}e.isResolverExtension=A,e.IBuiltinExtensionsScannerService=(0,i.createDecorator)("IBuiltinExtensionsScannerService")}),define(ve[193],we([0,1,8,27]),function(J,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function y(h,p){return h.uuid&&p.uuid?h.uuid===p.uuid:h.id===p.id?!0:(0,m.compareIgnoreCase)(h.id,p.id)===0}e.areSameExtensions=y;class C{constructor(p,v){this.version=v,this.id=p.id,this.uuid=p.uuid}key(){return`${this.id}-${this.version}`}equals(p){return p instanceof C?y(this,p)&&this.version===p.version:!1}}e.ExtensionIdentifierWithVersion=C;function P(h,p){return`${h}.${p}`}e.getExtensionId=P;function D(h){return h.toLocaleLowerCase()}e.adoptToGalleryExtensionId=D;function _(h,p){return D(P(h,p))}e.getGalleryExtensionId=_;function I(h,p){const v=[],T=b=>{for(const o of v)if(o.some(s=>y(p(s),p(b))))return o;return null};for(const b of h){const o=T(b);o?o.push(b):v.push([b])}return v}e.groupByExtension=I;function L(h){return{id:h.identifier.id,name:h.manifest.name,galleryId:null,publisherId:h.publisherId,publisherName:h.manifest.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:h.manifest.extensionDependencies&&h.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=L;function A(h){return{id:h.identifier.id,name:h.name,galleryId:h.identifier.uuid,publisherId:h.publisherId,publisherName:h.publisher,publisherDisplayName:h.publisherDisplayName,isPreReleaseVersion:h.properties.isPreReleaseVersion,dependencies:!!(h.properties.dependencies&&h.properties.dependencies.length>0),...h.telemetryData}}e.getGalleryExtensionTelemetryData=A,e.BetterMergeId=new i.ExtensionIdentifier("pprice.better-merge");function c(h){const p=new Set;if(h.malicious)for(const v of h.malicious)p.add(v.id);return p}e.getMaliciousExtensionsSet=c;function E(h,p){const v=[],T=p.manifest.extensionDependencies?.slice(0)??[];for(;T.length;){const b=T.shift();if(b&&v.every(o=>!y(o.identifier,{id:b}))){const o=h.filter(s=>y(s.identifier,{id:b}));o.length===1&&(v.push(o[0]),T.push(...o[0].manifest.extensionDependencies?.slice(0)??[]))}}return v}e.getExtensionDependencies=E}),define(ve[120],we([0,1,3,12,4,11]),function(J,e,m,i,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,y.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,y.createDecorator)("sharedTunnelsService");var P;(function(h){h.Http="http",h.Https="https"})(P=e.TunnelProtocol||(e.TunnelProtocol={}));var D;(function(h){h.ConstantPrivate="constantPrivate",h.Private="private",h.Public="public"})(D=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var _;(function(h){h[h.Notify=1]="Notify",h[h.OpenBrowser=2]="OpenBrowser",h[h.OpenPreview=3]="OpenPreview",h[h.Silent=4]="Silent",h[h.Ignore=5]="Ignore",h[h.OpenBrowserOnce=6]="OpenBrowserOnce"})(_=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function I(h){if(h.scheme!=="http"&&h.scheme!=="https")return;const p=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(h.authority);if(!!p)return{address:p[1],port:+p[2]}}e.extractLocalHostUriMetaDataForPortMapping=I,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function L(h){return e.LOCALHOST_ADDRESSES.indexOf(h)>=0}e.isLocalhost=L,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function A(h){return e.ALL_INTERFACES_ADDRESSES.indexOf(h)>=0}e.isAllInterfaces=A;function c(h,p){return p?p!==1&&h<1024:!i.isWindows&&h<1024}e.isPortPrivileged=c;let E=class{constructor(p){this.logService=p,this._onTunnelOpened=new m.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new m.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new m.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(p,v){return this._tunnelProvider=p,p?(this._canElevate=v.elevation,this._privacyOptions=v.privacyOptions,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const p=[],v=Array.from(this._tunnels.values());for(let T of v){const b=Array.from(T.values());for(let o of b){const s=await o.value;s&&p.push(s)}}return p}async dispose(){for(const p of this._tunnels.values()){for(const{value:v}of p.values())await v.then(T=>T?.dispose());p.clear()}this._tunnels.clear()}openTunnel(p,v,T,b,o=!1,s=D.Private,g){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${v}:${T} on local port ${b}.`),!p)return;v||(v="localhost");const l=this.retainOrCreateTunnel(p,v,T,b,o,s,g);return l?l.then(S=>{if(!S){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(v,T);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const n=this.makeTunnel(S);return(S.tunnelRemoteHost!==v||S.tunnelRemotePort!==T)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(n),n}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),l)}makeTunnel(p){return{tunnelRemotePort:p.tunnelRemotePort,tunnelRemoteHost:p.tunnelRemoteHost,tunnelLocalPort:p.tunnelLocalPort,localAddress:p.localAddress,privacy:p.privacy,protocol:p.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${p.tunnelRemoteHost}:${p.tunnelRemotePort} `);const v=this._tunnels.get(p.tunnelRemoteHost);if(v){const T=v.get(p.tunnelRemotePort);T&&(T.refcount--,await this.tryDisposeTunnel(p.tunnelRemoteHost,p.tunnelRemotePort,T))}}}}async tryDisposeTunnel(p,v,T){if(T.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${p}:${v}.`);const b=T.value.then(async o=>{o&&(await o.dispose(!0),this._onTunnelClosed.fire({host:o.tunnelRemoteHost,port:o.tunnelRemotePort}))});return this._tunnels.has(p)&&this._tunnels.get(p).delete(v),b}}async closeTunnel(p,v){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${p}:${v} `);const T=this._tunnels.get(p);if(T&&T.has(v)){const b=T.get(v);b.refcount=0,await this.tryDisposeTunnel(p,v,b)}}addTunnelToMap(p,v,T){this._tunnels.has(p)||this._tunnels.set(p,new Map),this._tunnels.get(p).set(v,{refcount:1,value:T})}async removeEmptyTunnelFromMap(p,v){const T=this._tunnels.get(p);T&&(await T.get(v)||T.delete(v),T.size===0&&this._tunnels.delete(p))}getTunnelFromMap(p,v){let T=[p];L(p)?(T.push(...e.LOCALHOST_ADDRESSES),T.push(...e.ALL_INTERFACES_ADDRESSES)):A(p)&&T.push(...e.ALL_INTERFACES_ADDRESSES);const b=T.map(o=>this._tunnels.get(o));for(const o of b){const s=o?.get(v);if(s)return s}}canTunnel(p){return!!I(p)}createWithProvider(p,v,T,b,o,s,g){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${v}:${T} on local port ${b}.`);const S={elevationRequired:o?c(b===void 0?T:b):!1},n={remoteAddress:{host:v,port:T},localAddressPort:b,privacy:s,public:s!==D.Private,protocol:g},t=p.forwardPort(n,S);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),t&&this.addTunnelToMap(v,T,t),t}};E=je([ze(0,C.ILogService)],E),e.AbstractTunnelService=E}),define(ve[194],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class m{constructor(){this.validators=new Map}vsda(){return new Promise((y,C)=>J(["vsda"],y,C))}async createNewMessage(y){try{const C=await this.vsda(),P=new C.validator;if(P){const D=String(m._nextId++);return this.validators.set(D,P),{id:D,data:P.createNewMessage(y)}}}catch{}return{id:"",data:y}}async validate(y,C){if(!y.id)return!0;const P=this.validators.get(y.id);if(!P)return!1;this.validators.delete(y.id);try{return P.validate(C)==="ok"}catch{return!1}}async sign(y){try{const C=await this.vsda(),P=new C.signer;if(P)return P.sign(y)}catch{}return y}}e.SignService=m,m._nextId=1}),define(ve[195],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class m{constructor(y){this._callback=y,this._terminalBufferMap=new Map}dispose(){for(const y of this._terminalBufferMap.values())y.dispose()}startBuffering(y,C,P=5){let D;return D=C(_=>{const I=typeof _=="string"?_:_.data;let L=this._terminalBufferMap.get(y);if(L){L.data.push(I);return}const A=setTimeout(()=>this.flushBuffer(y),P);L={data:[I],timeoutId:A,dispose:()=>{clearTimeout(A),this.flushBuffer(y),D.dispose()}},this._terminalBufferMap.set(y,L)}),D}stopBuffering(y){const C=this._terminalBufferMap.get(y);C&&C.dispose()}flushBuffer(y){const C=this._terminalBufferMap.get(y);C&&(this._terminalBufferMap.delete(y),this._callback(y,C.data.join("")))}}e.TerminalDataBufferer=m}),define(ve[196],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var m;(function(i){i.DARK="dark",i.LIGHT="light",i.HIGH_CONTRAST="hc"})(m=e.ColorScheme||(e.ColorScheme={}))}),define(ve[86],we([0,1,73,3,6,4,51,196]),function(J,e,m,i,y,C,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,C.createDecorator)("themeService");var _;(function(v){function T(b){return b&&typeof b=="object"&&typeof b.id=="string"}v.isThemeColor=T})(_=e.ThemeColor||(e.ThemeColor={}));function I(v){return{id:v}}e.themeColorFromId=I;var L;(function(v){function T(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(typeof t.color=="undefined"||_.isThemeColor(t.color))}v.isThemeIcon=T;const b=new RegExp(`^\\$\\((${m.CSSIcon.iconNameExpression}(?:${m.CSSIcon.iconModifierExpression})?)\\)$`);function o(t){const r=b.exec(t);if(!r)return;let[,u]=r;return{id:u}}v.fromString=o;function s(t){return{id:t}}v.fromId=s;function g(t,r){let u=t.id;const a=u.lastIndexOf("~");return a!==-1&&(u=u.substring(0,a)),r&&(u=`${u}~${r}`),{id:u}}v.modify=g;function l(t){const r=t.id.lastIndexOf("~");if(r!==-1)return t.id.substring(r+1)}v.getModifier=l;function S(t,r){return t.id===r.id&&t.color?.id===r.color?.id}v.isEqual=S;function n(t,r){return{id:t.id,color:r?I(r):void 0}}v.asThemeIcon=n,v.asClassNameArray=m.CSSIcon.asClassNameArray,v.asClassName=m.CSSIcon.asClassName,v.asCSSSelector=m.CSSIcon.asCSSSelector})(L=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=m.Codicon.file,e.FolderThemeIcon=m.Codicon.folder;function A(v){switch(v){case D.ColorScheme.DARK:return"vs-dark";case D.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=A,e.Extensions={ThemingContribution:"base.contributions.theming"};class c{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new i.Emitter}onColorThemeChange(T){return this.themingParticipants.push(T),this.onThemingParticipantAddedEmitter.fire(T),(0,y.toDisposable)(()=>{const b=this.themingParticipants.indexOf(T);this.themingParticipants.splice(b,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let E=new c;P.Registry.add(e.Extensions.ThemingContribution,E);function h(v){return E.onColorThemeChange(v)}e.registerThemingParticipant=h;class p extends y.Disposable{constructor(T){super();this.themeService=T,this.theme=T.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(b=>this.onThemeChange(b)))}onThemeChange(T){this.theme=T,this.updateStyles()}updateStyles(){}getColor(T,b){let o=this.theme.getColor(T);return o&&b&&(o=b(o,this.theme)),o?o.toString():null}}e.Themable=p}),define(ve[43],we([0,1,24,23,2,4]),function(J,e,m,i,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,C.createDecorator)("contextService");var P;(function(c){c[c.EMPTY=1]="EMPTY",c[c.FOLDER=2]="FOLDER",c[c.WORKSPACE=3]="WORKSPACE"})(P=e.WorkbenchState||(e.WorkbenchState={}));function D(c){const E=c;return!!(E&&typeof E=="object"&&typeof E.id=="string"&&Array.isArray(E.folders))}e.isWorkspace=D;function _(c){const E=c;return!!(E&&typeof E=="object"&&y.URI.isUri(E.uri)&&typeof E.name=="string"&&typeof E.toResource=="function")}e.isWorkspaceFolder=_;class I{constructor(E,h,p,v,T){this._id=E,this._transient=p,this._configuration=v,this._ignorePathCasing=T,this._foldersMap=m.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=h}update(E){this._id=E.id,this._configuration=E.configuration,this._transient=E.transient,this._ignorePathCasing=E._ignorePathCasing,this.folders=E.folders}get folders(){return this._folders}set folders(E){this._folders=E,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(E){this._configuration=E}getFolder(E){return E&&this._foldersMap.findSubstr(E.with({scheme:E.scheme,authority:E.authority,path:E.path}))||null}updateFoldersMap(){this._foldersMap=m.TernarySearchTree.forUris(this._ignorePathCasing);for(const E of this.folders)this._foldersMap.set(E.uri,E)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=I;class L{constructor(E,h){this.raw=h,this.uri=E.uri,this.index=E.index,this.name=E.name}toResource(E){return(0,i.joinPath)(this.uri,E)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=L;function A(c){return new L({uri:c,index:0,name:(0,i.basenameOrAuthority)(c)},{uri:c.toString()})}e.toWorkspaceFolder=A}),define(ve[197],we([0,1,30,58,139,80,10,9,12,23,2,161,4,62,43]),function(J,e,m,i,y,C,P,D,_,I,L,A,c,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isWorkspaceBackupInfo=e.isFolderBackupInfo=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const p=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,A.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function v(M){return(typeof M=="string"?(0,D.extname)(M):(0,I.extname)(M))===p}e.hasWorkspaceFileExtension=v,e.IWorkspacesService=(0,c.createDecorator)("workspacesService");function T(M){return M.hasOwnProperty("workspace")}e.isRecentWorkspace=T;function b(M){return M.hasOwnProperty("folderUri")}e.isRecentFolder=b;function o(M){return M.hasOwnProperty("fileUri")}e.isRecentFile=o;function s(M){return M&&M.hasOwnProperty("folderUri")}e.isFolderBackupInfo=s;function g(M){return M&&M.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=g;function l(M){const W=M;return typeof W?.id=="string"&&L.URI.isUri(W.uri)}e.isSingleFolderWorkspaceIdentifier=l;function S(M){if(M.configuration)return{id:M.id,configPath:M.configuration};if(M.folders.length===1)return{id:M.id,uri:M.folders[0].uri}}e.toWorkspaceIdentifier=S;function n(M){const W=M;return typeof W?.id=="string"&&L.URI.isUri(W.configPath)}e.isWorkspaceIdentifier=n;function t(M){const W=M;if(W?.uri)return{id:W.id,uri:L.URI.revive(W.uri)};const z=M;if(z?.configPath)return{id:z.id,configPath:L.URI.revive(z.configPath)};if(M?.id)return{id:M.id}}e.reviveIdentifier=t;function r(M,W){return I.extUriBiasedIgnorePathCase.isEqualOrParent(M,W.untitledWorkspacesHome)}e.isUntitledWorkspace=r;function u(M){return a(M)||f(M)}e.isStoredWorkspaceFolder=u;function a(M){const W=M;return typeof W?.path=="string"&&(!W.name||typeof W.name=="string")}e.isRawFileWorkspaceFolder=a;function f(M){const W=M;return typeof W?.uri=="string"&&(!W.name||typeof W.name=="string")}e.isRawUriWorkspaceFolder=f;function w(M,W,z,U,V=!_.isWindows,K){if(M.scheme!==U.scheme)return{name:z,uri:M.toString(!0)};let G=W?void 0:K.relativePath(U,M);if(G!==void 0)G.length===0?G=".":_.isWindows&&M.scheme===P.Schemas.file&&!V&&(G=G.replace(/\//g,"\\"));else if(M.scheme===P.Schemas.file)G=M.fsPath,_.isWindows&&(G=(0,C.normalizeDriveLetter)(G),V&&(G=(0,m.toSlashes)(G)));else{if(!K.isEqualAuthority(M.authority,U.authority))return{name:z,uri:M.toString(!0)};G=M.path}return{name:z,path:G}}e.getStoredWorkspaceFolder=w;function d(M,W,z){let U=[],V=new Set;const K=z.dirname(W);for(let G of M){let Q;if(a(G))G.path&&(Q=z.resolvePath(K,G.path));else if(f(G))try{Q=L.URI.parse(G.uri),Q.path[0]!=="/"&&(Q=Q.with({path:"/"+Q.path}))}catch(Y){console.warn(Y)}if(Q){let Y=z.getComparisonKey(Q);if(!V.has(Y)){V.add(Y);const fe=G.name||z.basenameOrAuthority(Q);U.push(new h.WorkspaceFolder({uri:Q,name:fe,index:U.length},G))}}}return U}e.toWorkspaceFolders=d;function k(M,W,z,U,V){let K=R(W,M);const G=V.dirname(W),Q=V.dirname(U),Y=[],fe=N(K.folders);for(const Oe of K.folders){const We=a(Oe)?V.resolvePath(G,Oe.path):L.URI.parse(Oe.uri);let j;z?j=!1:j=!a(Oe)||(0,D.isAbsolute)(Oe.path),Y.push(w(We,j,Oe.name,Q,fe,V))}const me={insertSpaces:!1,tabSize:4,eol:_.isLinux||_.isMacintosh?`
`:`\r
`},_e=y.setProperty(M,["folders"],Y,me);let Ie=y.applyEdits(M,_e);return(0,I.isEqualAuthority)(K.remoteAuthority,(0,E.getRemoteAuthority)(U))&&(Ie=y.applyEdits(Ie,y.removeProperty(Ie,["remoteAuthority"],me))),Ie}e.rewriteWorkspaceFileForNewLocation=k;function R(M,W){let z=i.parse(W);if(z&&Array.isArray(z.folders))z.folders=z.folders.filter(U=>u(U));else throw new Error(`${M} looks like an invalid workspace file.`);return z}function N(M){return _.isWindows?M.some(W=>a(W)&&W.path.indexOf("/")>=0):!0}e.useSlashForPath=N;function x(M){return M.workspace&&typeof M.workspace=="object"&&typeof M.workspace.id=="string"&&typeof M.workspace.configPath=="string"}function F(M){return typeof M.folderUri=="string"}function B(M){return typeof M.fileUri=="string"}function O(M,W){const z={workspaces:[],files:[]};if(M){const U=function(K,G){for(let Q=0;Q<K.length;Q++)try{G(K[Q],Q)}catch(Y){W.warn(`Error restoring recent entry ${JSON.stringify(K[Q])}: ${Y.toString()}. Skip entry.`)}},V=M;if(Array.isArray(V.entries))U(V.entries,K=>{const G=K.label,Q=K.remoteAuthority;x(K)?z.workspaces.push({label:G,remoteAuthority:Q,workspace:{id:K.workspace.id,configPath:L.URI.parse(K.workspace.configPath)}}):F(K)?z.workspaces.push({label:G,remoteAuthority:Q,folderUri:L.URI.parse(K.folderUri)}):B(K)&&z.files.push({label:G,remoteAuthority:Q,fileUri:L.URI.parse(K.fileUri)})});else{const K=M;Array.isArray(K.workspaces3)&&U(K.workspaces3,(G,Q)=>{const Y=Array.isArray(K.workspaceLabels)&&K.workspaceLabels[Q]||void 0;typeof G=="object"&&typeof G.id=="string"&&typeof G.configURIPath=="string"?z.workspaces.push({label:Y,workspace:{id:G.id,configPath:L.URI.parse(G.configURIPath)}}):typeof G=="string"&&z.workspaces.push({label:Y,folderUri:L.URI.parse(G)})}),Array.isArray(K.files2)&&U(K.files2,(G,Q)=>{const Y=Array.isArray(K.fileLabels)&&K.fileLabels[Q]||void 0;typeof G=="string"&&z.files.push({label:Y,fileUri:L.URI.parse(G)})})}}return z}e.restoreRecentlyOpened=O;function H(M){const W={entries:[]};for(const z of M.workspaces)b(z)?W.entries.push({folderUri:z.folderUri.toString(),label:z.label,remoteAuthority:z.remoteAuthority}):W.entries.push({workspace:{id:z.workspace.id,configPath:z.workspace.configPath.toString()},label:z.label,remoteAuthority:z.remoteAuthority});for(const z of M.files)W.entries.push({fileUri:z.fileUri.toString(),label:z.label,remoteAuthority:z.remoteAuthority});return W}e.toStoreData=H}),define(ve[87],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class m{constructor(y){this.id=y,this._data=new Map,this._idPool=1}add(y){const C=this._idPool++;return this._data.set(C,y),this.logDebugInfo(),C}get(y,C){return this._data.has(y)?this._data.get(y)[C]:void 0}delete(y){this._data.delete(y),this.logDebugInfo()}logDebugInfo(){!m.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=m,m.enableDebugLogging=!1}),define(ve[44],we([0,1,10,23,4]),function(J,e,m,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class C{constructor(){this._systemSchemes=new Set(Object.keys(m.Schemas)),this._providerInfo=new Map,this.extUri=new i.ExtUri(D=>{const _=this._providerInfo.get(D.scheme);return!(_===void 0||_&1024)})}$acceptProviderInfos(D,_){_===null?this._providerInfo.delete(D.scheme):this._providerInfo.set(D.scheme,_)}isFreeScheme(D){return!this._providerInfo.has(D)&&!this._systemSchemes.has(D)}getCapabilities(D){return this._providerInfo.get(D)}}e.ExtHostFileSystemInfo=C,e.IExtHostFileSystemInfo=(0,y.createDecorator)("IExtHostFileSystemInfo")}),define(ve[26],we([0,1,4]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,m.createDecorator)("IExtHostInitDataService")}),define(ve[198],we([0,1,18]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class i{constructor(P,D,_){this._deferredPromises=new Map,this._id=P,this._shared=D,this._storage=_,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(I=>(this._value=I,this)),this._storageListener=this._storage.onDidChangeStorage(I=>{I.shared===this._shared&&I.key===this._id&&(this._value=I.value)}),this._scheduler=new m.RunOnceScheduler(()=>{const I=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const L of I.values())L.complete()}catch(L){for(const A of I.values())A.error(L)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,P])=>P!==void 0).map(([P])=>P)}get whenReady(){return this._init}get(P,D){let _=this._value[P];return typeof _=="undefined"&&(_=D),_}update(P,D){this._value[P]=D;let _=this._deferredPromises.get(P);if(_!==void 0)return _.p;const I=new m.DeferredPromise;return this._deferredPromises.set(P,I),this._scheduler.isScheduled()||this._scheduler.schedule(),I.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=i;class y extends i{constructor(P,D){super(P.identifier.value,!0,D);this._extension=P}setKeysForSync(P){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},P)}}e.ExtensionGlobalMemento=y}),define(ve[199],we([0,1,3,2,11]),function(J,e,m,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let C=class{constructor(D,_){this._logService=D,this._notebooksAndEditors=_,this._onDidChangeNotebookDocumentMetadata=new m.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new m.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(D,_,I){this._notebooksAndEditors.getNotebookDocument(i.URI.revive(D)).acceptModelChanged(_.value,I)}$acceptDirtyStateChanged(D,_){this._notebooksAndEditors.getNotebookDocument(i.URI.revive(D)).acceptDirty(_)}$acceptModelSaved(D){const _=this._notebooksAndEditors.getNotebookDocument(i.URI.revive(D));this._onDidSaveNotebookDocument.fire(_.apiNotebook)}$acceptDocumentPropertiesChanged(D,_){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",D.path,_);const I=this._notebooksAndEditors.getNotebookDocument(i.URI.revive(D));I.acceptDocumentPropertiesChanged(_),_.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:I.apiNotebook})}};C=je([ze(0,y.ILogService)],C),e.ExtHostNotebookDocuments=C}),define(ve[14],we([0,1,4]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,m.createDecorator)("IExtHostRpcService");class i{constructor(C){this.getProxy=C.getProxy.bind(C),this.set=C.set.bind(C),this.assertRegistered=C.assertRegistered.bind(C),this.drain=C.drain.bind(C)}}e.ExtHostRpcService=i});var nt=this&&this.__classPrivateFieldSet||function(J,e,m,i,y){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!y:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?y.call(J,m):y?y.value=m:e.set(J,m),m},Be=this&&this.__classPrivateFieldGet||function(J,e,m,i){if(m==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!i:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?i:m==="a"?i.call(J):i?i.value:e.get(J)};define(ve[200],we([0,1,27,3]),function(J,e,m,i){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class C{constructor(D,_){y.set(this,void 0),this._onDidChange=new i.Emitter,this.onDidChange=this._onDidChange.event,this._id=m.ExtensionIdentifier.toKey(D.identifier),nt(this,y,_,"f"),Be(this,y,"f").onDidChangePassword(I=>{I.extensionId===this._id&&this._onDidChange.fire({key:I.key})})}get(D){return Be(this,y,"f").get(this._id,D)}store(D,_){return Be(this,y,"f").store(this._id,D,_)}delete(D){return Be(this,y,"f").delete(this._id,D)}}e.ExtensionSecrets=C,y=new WeakMap}),define(ve[121],we([0,1,4,3]),function(J,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class y{constructor(){this._onDidChangeTelemetryEnabled=new i.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(P){this._enabled=P}$onDidChangeTelemetryEnabled(P){this._enabled=P,this._onDidChangeTelemetryEnabled.fire(P)}}e.ExtHostTelemetry=y,e.IExtHostTelemetry=(0,m.createDecorator)("IExtHostTelemetry")}),define(ve[63],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var m;(function(b){b[b.Upsert=0]="Upsert",b[b.RemoveChild=1]="RemoveChild",b[b.Invalidated=2]="Invalidated",b[b.SetProp=3]="SetProp",b[b.Bulk=4]="Bulk"})(m=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const i=new WeakMap,y=(b,o)=>{const s={controllerId:o};return i.set(b,s),s};e.createPrivateApiFor=y;const C=b=>i.get(b);e.getPrivateApiFor=C;const P=(b,o,s,g)=>{let l=s;return{enumerable:!0,configurable:!1,get(){return l},set(S){if(!g(l,S)){const n=l;l=S,b.listener?.({op:3,key:o,value:S,previous:n})}}}},D=(b,o)=>b===o,_={range:(b,o)=>b===o?!0:!b||!o?!1:b.isEqual(o),label:D,description:D,busy:D,error:D,canResolveChildren:D,tags:(b,o)=>!(b.length!==o.length||b.some(s=>!o.find(g=>s.id===g.id)))},I=Object.keys(_),L=(b,o)=>({range:P(b,"range",void 0,_.range),label:P(b,"label",o,_.label),description:P(b,"description",void 0,_.description),canResolveChildren:P(b,"canResolveChildren",!1,_.canResolveChildren),busy:P(b,"busy",!1,_.busy),error:P(b,"error",void 0,_.error),tags:P(b,"tags",[],_.tags)}),A=(b,o)=>{const s=new Map;for(const g of I)_[g](b[g],o[g])||s.set(g,o[g]);return s};e.diffTestItems=A;class c extends Error{constructor(o){super(`Attempted to insert a duplicate test item ID ${o}`)}}e.DuplicateTestItemError=c;class E extends Error{constructor(o){super(`TestItem with ID "${o}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=E;class h extends Error{constructor(o,s,g){super(`TestItem with ID "${o}" is from controller "${s}" and cannot be added as a child of an item from controller "${g}".`)}}e.MixedTestItemController=h;const p=b=>{const o=(0,e.getPrivateApiFor)(b);let s=new Map;return{get size(){return s.size},forEach(g,l){for(const S of s.values())g.call(l,S,this)},replace(g){const l=new Map,S=new Set(s.keys()),n={op:4,ops:[]};for(const t of g){if(!(t instanceof v))throw new E(t.id);const r=(0,e.getPrivateApiFor)(t).controllerId;if(r!==o.controllerId)throw new h(t.id,r,o.controllerId);if(l.has(t.id))throw new c(t.id);l.set(t.id,t),S.delete(t.id),n.ops.push({op:0,item:t})}for(const t of S.keys())n.ops.push({op:1,id:t});o.listener?.(n),s=l},add(g){if(!(g instanceof v))throw new E(g.id);s.set(g.id,g),o.listener?.({op:0,item:g})},delete(g){s.delete(g)&&o.listener?.({op:1,id:g})},get(g){return s.get(g)},toJSON(){return Array.from(s.values())},[Symbol.iterator](){return s.values()}}};class v{constructor(o,s,g,l){if(s.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(s)} symbol`);const S=(0,e.createPrivateApiFor)(this,o);Object.defineProperties(this,{id:{value:s,enumerable:!0,writable:!1},uri:{value:l,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return S.parent instanceof T?void 0:S.parent}},children:{value:p(this),enumerable:!0,writable:!1},...L(S,g)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=v;class T extends v{constructor(o,s){super(o,o,s,void 0)}}e.TestItemRootImpl=T}),define(ve[52],we([0,1,4,120,3,14]),function(J,e,m,i,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var P;(function(_){function I(A){return{remoteAddress:A.remoteAddress,localAddress:A.localAddress,public:!!A.public,privacy:A.privacy??(A.public?i.TunnelPrivacyId.Public:i.TunnelPrivacyId.Private),protocol:A.protocol}}_.fromApiTunnel=I;function L(A){return{remoteAddress:{host:A.tunnelRemoteHost,port:A.tunnelRemotePort},localAddress:A.localAddress,public:A.privacy!==i.TunnelPrivacyId.ConstantPrivate&&A.privacy!==i.TunnelPrivacyId.ConstantPrivate,privacy:A.privacy,protocol:A.protocol}}_.fromServiceTunnel=L})(P=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,m.createDecorator)("IExtHostTunnelService");let D=class{constructor(I){this.onDidChangeTunnels=new y.Emitter().event}async $applyCandidateFilter(I){return I}async openTunnel(I,L){}async getTunnels(){return[]}async setTunnelExtensionFunctions(I){return{dispose:()=>{}}}registerPortsAttributesProvider(I,L){return{dispose:()=>{}}}async $providePortAttributes(I,L,A,c,E){return[]}async $forwardPort(I,L){}async $closeTunnel(I){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};D=je([ze(0,C.IExtHostRpcService)],D),e.ExtHostTunnelService=D});var nt=this&&this.__classPrivateFieldSet||function(J,e,m,i,y){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!y:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?y.call(J,m):y?y.value=m:e.set(J,m),m},Be=this&&this.__classPrivateFieldGet||function(J,e,m,i){if(m==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!i:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?i:m==="a"?i.call(J):i?i.value:e.get(J)};define(ve[7],we([0,1,16,15,97,24,101,8,13,2,32,42,119]),function(J,e,m,i,y,C,P,D,_,I,L,A,c){"use strict";var E,h,p,v,T,b,o,s,g,l,S,n,t,r,u,a,f,w,d,k;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeDataTransfer=e.TreeDataTransferItem=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function R(q){function $(){return Reflect.construct(q,arguments,this.constructor)}return Object.defineProperty($,"name",Object.getOwnPropertyDescriptor(q,"name")),Object.setPrototypeOf($,q),Object.setPrototypeOf($.prototype,q.prototype),$}let N=T=class{constructor($){E.set(this,void 0),nt(this,E,$,"f")}static from(...$){let ae=$;return new T(function(){if(ae){for(const Te of ae)Te&&typeof Te.dispose=="function"&&Te.dispose();ae=void 0}})}dispose(){typeof Be(this,E,"f")=="function"&&(Be(this,E,"f").call(this),nt(this,E,void 0,"f"))}};E=new WeakMap,N=T=je([R],N),e.Disposable=N;let x=b=class{constructor($,ae){if($<0)throw(0,i.illegalArgument)("line must be non-negative");if(ae<0)throw(0,i.illegalArgument)("character must be non-negative");this._line=$,this._character=ae}static Min(...$){if($.length===0)throw new TypeError;let ae=$[0];for(let Te=1;Te<$.length;Te++){const Ye=$[Te];Ye.isBefore(ae)&&(ae=Ye)}return ae}static Max(...$){if($.length===0)throw new TypeError;let ae=$[0];for(let Te=1;Te<$.length;Te++){const Ye=$[Te];Ye.isAfter(ae)&&(ae=Ye)}return ae}static isPosition($){if(!$)return!1;if($ instanceof b)return!0;let{line:ae,character:Te}=$;return typeof ae=="number"&&typeof Te=="number"}get line(){return this._line}get character(){return this._character}isBefore($){return this._line<$._line?!0:$._line<this._line?!1:this._character<$._character}isBeforeOrEqual($){return this._line<$._line?!0:$._line<this._line?!1:this._character<=$._character}isAfter($){return!this.isBeforeOrEqual($)}isAfterOrEqual($){return!this.isBefore($)}isEqual($){return this._line===$._line&&this._character===$._character}compareTo($){return this._line<$._line?-1:this._line>$.line?1:this._character<$._character?-1:this._character>$._character?1:0}translate($,ae=0){if($===null||ae===null)throw(0,i.illegalArgument)();let Te;return typeof $=="undefined"?Te=0:typeof $=="number"?Te=$:(Te=typeof $.lineDelta=="number"?$.lineDelta:0,ae=typeof $.characterDelta=="number"?$.characterDelta:0),Te===0&&ae===0?this:new b(this.line+Te,this.character+ae)}with($,ae=this.character){if($===null||ae===null)throw(0,i.illegalArgument)();let Te;return typeof $=="undefined"?Te=this.line:typeof $=="number"?Te=$:(Te=typeof $.line=="number"?$.line:this.line,ae=typeof $.character=="number"?$.character:this.character),Te===this.line&&ae===this.character?this:new b(Te,ae)}toJSON(){return{line:this.line,character:this.character}}};x=b=je([R],x),e.Position=x;let F=o=class{constructor($,ae,Te,Ye){let rt,ct;if(typeof $=="number"&&typeof ae=="number"&&typeof Te=="number"&&typeof Ye=="number"?(rt=new x($,ae),ct=new x(Te,Ye)):$ instanceof x&&ae instanceof x&&(rt=$,ct=ae),!rt||!ct)throw new Error("Invalid arguments");rt.isBefore(ct)?(this._start=rt,this._end=ct):(this._start=ct,this._end=rt)}static isRange($){return $ instanceof o?!0:$?x.isPosition($.start)&&x.isPosition($.end):!1}get start(){return this._start}get end(){return this._end}contains($){return $ instanceof o?this.contains($._start)&&this.contains($._end):$ instanceof x?!($.isBefore(this._start)||this._end.isBefore($)):!1}isEqual($){return this._start.isEqual($._start)&&this._end.isEqual($._end)}intersection($){const ae=x.Max($.start,this._start),Te=x.Min($.end,this._end);if(!ae.isAfter(Te))return new o(ae,Te)}union($){if(this.contains($))return this;if($.contains(this))return $;const ae=x.Min($.start,this._start),Te=x.Max($.end,this.end);return new o(ae,Te)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with($,ae=this.end){if($===null||ae===null)throw(0,i.illegalArgument)();let Te;return $?x.isPosition($)?Te=$:(Te=$.start||this.start,ae=$.end||this.end):Te=this.start,Te.isEqual(this._start)&&ae.isEqual(this.end)?this:new o(Te,ae)}toJSON(){return[this.start,this.end]}};F=o=je([R],F),e.Range=F;let B=s=class extends F{constructor($,ae,Te,Ye){let rt,ct;if(typeof $=="number"&&typeof ae=="number"&&typeof Te=="number"&&typeof Ye=="number"?(rt=new x($,ae),ct=new x(Te,Ye)):$ instanceof x&&ae instanceof x&&(rt=$,ct=ae),!rt||!ct)throw new Error("Invalid arguments");super(rt,ct);this._anchor=rt,this._active=ct}static isSelection($){return $ instanceof s?!0:$?F.isRange($)&&x.isPosition($.anchor)&&x.isPosition($.active)&&typeof $.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};B=s=je([R],B),e.Selection=B;class O{constructor($,ae,Te){if(typeof $!="string"||$.length===0)throw(0,i.illegalArgument)("host");if(typeof ae!="number"||ae===0||Math.round(ae)!==ae)throw(0,i.illegalArgument)("port");if(typeof Te!="undefined"&&(typeof Te!="string"||Te.length===0||!/^[0-9A-Za-z\-]+$/.test(Te)))throw(0,i.illegalArgument)("connectionToken");this.host=$,this.port=Math.round(ae),this.connectionToken=Te}}e.ResolvedAuthority=O;class H extends Error{constructor($,ae=c.RemoteAuthorityResolverErrorCode.Unknown,Te){super($);this._message=$,this._code=ae,this._detail=Te,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,H.prototype)}static NotAvailable($,ae){return new H($,c.RemoteAuthorityResolverErrorCode.NotAvailable,ae)}static TemporarilyNotAvailable($){return new H($,c.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=H;var M;(function(q){q[q.LF=1]="LF",q[q.CRLF=2]="CRLF"})(M=e.EndOfLine||(e.EndOfLine={}));var W;(function(q){q[q.Replace=1]="Replace",q[q.Append=2]="Append",q[q.Prepend=3]="Prepend"})(W=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let z=g=class{constructor($,ae){this._range=$,this._newText=ae}static isTextEdit($){return $ instanceof g?!0:$?F.isRange($)&&typeof $.newText=="string":!1}static replace($,ae){return new g($,ae)}static insert($,ae){return g.replace(new F($,$),ae)}static delete($){return g.replace($,"")}static setEndOfLine($){const ae=new g(new F(new x(0,0),new x(0,0)),"");return ae.newEol=$,ae}get range(){return this._range}set range($){if($&&!F.isRange($))throw(0,i.illegalArgument)("range");this._range=$}get newText(){return this._newText||""}set newText($){if($&&typeof $!="string")throw(0,i.illegalArgument)("newText");this._newText=$}get newEol(){return this._newEol}set newEol($){if($&&typeof $!="number")throw(0,i.illegalArgument)("newEol");this._newEol=$}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};z=g=je([R],z),e.TextEdit=z;var U;(function(q){q[q.File=1]="File",q[q.Text=2]="Text",q[q.Cell=3]="Cell",q[q.CellReplace=5]="CellReplace"})(U=e.FileEditType||(e.FileEditType={}));let V=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile($,ae,Te,Ye){this._edits.push({_type:1,from:$,to:ae,options:Te,metadata:Ye})}createFile($,ae,Te){this._edits.push({_type:1,from:void 0,to:$,options:ae,metadata:Te})}deleteFile($,ae,Te){this._edits.push({_type:1,from:$,to:void 0,options:ae,metadata:Te})}replaceNotebookMetadata($,ae,Te){this._edits.push({_type:3,metadata:Te,uri:$,edit:{editType:5,metadata:ae},notebookMetadata:ae})}replaceNotebookCells($,ae,Te,Ye,rt){let ct,ht,kt=[],Ft;if($e.isNotebookRange(ae)&&Bt.isNotebookCellDataArray(Te)&&!Bt.isNotebookCellDataArray(Ye)?(ct=ae.start,ht=ae.end,kt=Te,Ft=Ye):typeof ae=="number"&&typeof Te=="number"&&Bt.isNotebookCellDataArray(Ye)&&(ct=ae,ht=Te,kt=Ye,Ft=rt),ct===void 0||ht===void 0)throw new Error("Invalid arguments");(ct!==ht||kt.length>0)&&this._edits.push({_type:5,uri:$,index:ct,count:ht-ct,cells:kt,metadata:Ft})}replaceNotebookCellMetadata($,ae,Te,Ye){this._edits.push({_type:3,metadata:Ye,uri:$,edit:{editType:8,index:ae,metadata:Te}})}replace($,ae,Te,Ye){this._edits.push({_type:2,uri:$,edit:new z(ae,Te),metadata:Ye})}insert($,ae,Te,Ye){this.replace($,new F(ae,ae),Te,Ye)}delete($,ae,Te){this.replace($,ae,"",Te)}has($){return this._edits.some(ae=>ae._type===2&&ae.uri.toString()===$.toString())}set($,ae){if(ae)for(const Te of ae)Te&&this._edits.push({_type:2,uri:$,edit:Te});else{for(let Te=0;Te<this._edits.length;Te++){const Ye=this._edits[Te];Ye._type===2&&Ye.uri.toString()===$.toString()&&(this._edits[Te]=void 0)}(0,m.coalesceInPlace)(this._edits)}}get($){const ae=[];for(let Te of this._edits)Te._type===2&&Te.uri.toString()===$.toString()&&ae.push(Te.edit);return ae}entries(){const $=new C.ResourceMap;for(let ae of this._edits)if(ae._type===2){let Te=$.get(ae.uri);Te||(Te=[ae.uri,[]],$.set(ae.uri,Te)),Te[1].push(ae.edit)}return[...$.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};V=je([R],V),e.WorkspaceEdit=V;let K=l=class{constructor($){this._tabstop=1,this.value=$||""}static isSnippetString($){return $ instanceof l?!0:$?typeof $.value=="string":!1}static _escape($){return $.replace(/\$|}|\\/g,"\\$&")}appendText($){return this.value+=l._escape($),this}appendTabstop($=this._tabstop++){return this.value+="$",this.value+=$,this}appendPlaceholder($,ae=this._tabstop++){if(typeof $=="function"){const Te=new l;Te._tabstop=this._tabstop,$(Te),this._tabstop=Te._tabstop,$=Te.value}else $=l._escape($);return this.value+="${",this.value+=ae,this.value+=":",this.value+=$,this.value+="}",this}appendChoice($,ae=this._tabstop++){const Te=$.map(Ye=>Ye.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ae,this.value+="|",this.value+=Te,this.value+="|}",this}appendVariable($,ae){if(typeof ae=="function"){const Te=new l;Te._tabstop=this._tabstop,ae(Te),this._tabstop=Te._tabstop,ae=Te.value}else typeof ae=="string"&&(ae=ae.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=$,ae&&(this.value+=":",this.value+=ae),this.value+="}",this}};K=l=je([R],K),e.SnippetString=K;var G;(function(q){q[q.Unnecessary=1]="Unnecessary",q[q.Deprecated=2]="Deprecated"})(G=e.DiagnosticTag||(e.DiagnosticTag={}));var Q;(function(q){q[q.Hint=3]="Hint",q[q.Information=2]="Information",q[q.Warning=1]="Warning",q[q.Error=0]="Error"})(Q=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let Y=S=class{constructor($,ae){if(this.uri=$,ae)if(ae instanceof F)this.range=ae;else if(ae instanceof x)this.range=new F(ae,ae);else throw new Error("Illegal argument")}static isLocation($){return $ instanceof S?!0:$?F.isRange($.range)&&I.URI.isUri($.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};Y=S=je([R],Y),e.Location=Y;let fe=class{constructor($,ae){this.location=$,this.message=ae}static is($){return $?typeof $.message=="string"&&$.location&&F.isRange($.location.range)&&I.URI.isUri($.location.uri):!1}static isEqual($,ae){return $===ae?!0:!$||!ae?!1:$.message===ae.message&&$.location.range.isEqual(ae.location.range)&&$.location.uri.toString()===ae.location.uri.toString()}};fe=je([R],fe),e.DiagnosticRelatedInformation=fe;let me=class{constructor($,ae,Te=Q.Error){if(!F.isRange($))throw new TypeError("range must be set");if(!ae)throw new TypeError("message must be set");this.range=$,this.message=ae,this.severity=Te}toJSON(){return{severity:Q[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual($,ae){return $===ae?!0:!$||!ae?!1:$.message===ae.message&&$.severity===ae.severity&&$.code===ae.code&&$.severity===ae.severity&&$.source===ae.source&&$.range.isEqual(ae.range)&&(0,m.equals)($.tags,ae.tags)&&(0,m.equals)($.relatedInformation,ae.relatedInformation,fe.isEqual)}};me=je([R],me),e.Diagnostic=me;let _e=class{constructor($,ae){if(!$)throw new Error("Illegal argument, contents must be defined");Array.isArray($)?this.contents=$:this.contents=[$],this.range=ae}};_e=je([R],_e),e.Hover=_e;var Ie;(function(q){q[q.Text=0]="Text",q[q.Read=1]="Read",q[q.Write=2]="Write"})(Ie=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Oe=class{constructor($,ae=Ie.Text){this.range=$,this.kind=ae}toJSON(){return{range:this.range,kind:Ie[this.kind]}}};Oe=je([R],Oe),e.DocumentHighlight=Oe;var We;(function(q){q[q.File=0]="File",q[q.Module=1]="Module",q[q.Namespace=2]="Namespace",q[q.Package=3]="Package",q[q.Class=4]="Class",q[q.Method=5]="Method",q[q.Property=6]="Property",q[q.Field=7]="Field",q[q.Constructor=8]="Constructor",q[q.Enum=9]="Enum",q[q.Interface=10]="Interface",q[q.Function=11]="Function",q[q.Variable=12]="Variable",q[q.Constant=13]="Constant",q[q.String=14]="String",q[q.Number=15]="Number",q[q.Boolean=16]="Boolean",q[q.Array=17]="Array",q[q.Object=18]="Object",q[q.Key=19]="Key",q[q.Null=20]="Null",q[q.EnumMember=21]="EnumMember",q[q.Struct=22]="Struct",q[q.Event=23]="Event",q[q.Operator=24]="Operator",q[q.TypeParameter=25]="TypeParameter"})(We=e.SymbolKind||(e.SymbolKind={}));var j;(function(q){q[q.Deprecated=1]="Deprecated"})(j=e.SymbolTag||(e.SymbolTag={}));let Z=n=class{constructor($,ae,Te,Ye,rt){this.name=$,this.kind=ae,this.containerName=rt,typeof Te=="string"&&(this.containerName=Te),Ye instanceof Y?this.location=Ye:Te instanceof F&&(this.location=new Y(Ye,Te)),n.validate(this)}static validate($){if(!$.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:We[this.kind],location:this.location,containerName:this.containerName}}};Z=n=je([R],Z),e.SymbolInformation=Z;let re=t=class{constructor($,ae,Te,Ye,rt){this.name=$,this.detail=ae,this.kind=Te,this.range=Ye,this.selectionRange=rt,this.children=[],t.validate(this)}static validate($){if(!$.name)throw new Error("name must not be falsy");if(!$.range.contains($.selectionRange))throw new Error("selectionRange must be contained in fullRange");$.children&&$.children.forEach(t.validate)}};re=t=je([R],re),e.DocumentSymbol=re;var ue;(function(q){q[q.Invoke=1]="Invoke",q[q.Automatic=2]="Automatic"})(ue=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let te=class{constructor($,ae){this.title=$,this.kind=ae}};te=je([R],te),e.CodeAction=te;let oe=r=class{constructor($){this.value=$}append($){return new r(this.value?this.value+r.sep+$:$)}intersects($){return this.contains($)||$.contains(this)}contains($){return this.value===$.value||$.value.startsWith(this.value+r.sep)}};oe.sep=".",oe=r=je([R],oe),e.CodeActionKind=oe,oe.Empty=new oe(""),oe.QuickFix=oe.Empty.append("quickfix"),oe.Refactor=oe.Empty.append("refactor"),oe.RefactorExtract=oe.Refactor.append("extract"),oe.RefactorInline=oe.Refactor.append("inline"),oe.RefactorRewrite=oe.Refactor.append("rewrite"),oe.Source=oe.Empty.append("source"),oe.SourceOrganizeImports=oe.Source.append("organizeImports"),oe.SourceFixAll=oe.Source.append("fixAll");let Ee=class{constructor($,ae){if(this.range=$,this.parent=ae,ae&&!ae.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};Ee=je([R],Ee),e.SelectionRange=Ee;class Ne{constructor($,ae,Te,Ye,rt,ct){this.kind=$,this.name=ae,this.detail=Te,this.uri=Ye,this.range=rt,this.selectionRange=ct}}e.CallHierarchyItem=Ne;class Ve{constructor($,ae){this.fromRanges=ae,this.from=$}}e.CallHierarchyIncomingCall=Ve;class Ge{constructor($,ae){this.fromRanges=ae,this.to=$}}e.CallHierarchyOutgoingCall=Ge;var Je;(function(q){q[q.Information=0]="Information",q[q.Warning=1]="Warning",q[q.Error=2]="Error"})(Je=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let tt=class{constructor($,ae){this.range=$,this.command=ae}get isResolved(){return!!this.command}};tt=je([R],tt),e.CodeLens=tt;let ot=u=class{constructor($,ae=!1){h.set(this,void 0),nt(this,h,new y.MarkdownString($,{supportThemeIcons:ae}),"f")}static isMarkdownString($){return $ instanceof u?!0:$&&$.appendCodeblock&&$.appendMarkdown&&$.appendText&&$.value!==void 0}get value(){return Be(this,h,"f").value}set value($){Be(this,h,"f").value=$}get isTrusted(){return Be(this,h,"f").isTrusted}set isTrusted($){Be(this,h,"f").isTrusted=$}get supportThemeIcons(){return Be(this,h,"f").supportThemeIcons}set supportThemeIcons($){Be(this,h,"f").supportThemeIcons=$}get supportHtml(){return Be(this,h,"f").supportHtml}set supportHtml($){Be(this,h,"f").supportHtml=$}appendText($){return Be(this,h,"f").appendText($),this}appendMarkdown($){return Be(this,h,"f").appendMarkdown($),this}appendCodeblock($,ae){return Be(this,h,"f").appendCodeblock(ae??"",$),this}};h=new WeakMap,ot=u=je([R],ot),e.MarkdownString=ot;let et=class{constructor($,ae){this.label=$,this.documentation=ae}};et=je([R],et),e.ParameterInformation=et;let it=class{constructor($,ae){this.label=$,this.documentation=ae,this.parameters=[]}};it=je([R],it),e.SignatureInformation=it;let lt=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};lt=je([R],lt),e.SignatureHelp=lt;var pt;(function(q){q[q.Invoke=1]="Invoke",q[q.TriggerCharacter=2]="TriggerCharacter",q[q.ContentChange=3]="ContentChange"})(pt=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Pt;(function(q){q[q.Other=0]="Other",q[q.Type=1]="Type",q[q.Parameter=2]="Parameter"})(Pt=e.InlayHintKind||(e.InlayHintKind={}));let xe=class{constructor($,ae,Te){this.text=$,this.position=ae,this.kind=Te}};xe=je([R],xe),e.InlayHint=xe;var Rt;(function(q){q[q.Invoke=0]="Invoke",q[q.TriggerCharacter=1]="TriggerCharacter",q[q.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Rt=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var ee;(function(q){q[q.Text=0]="Text",q[q.Method=1]="Method",q[q.Function=2]="Function",q[q.Constructor=3]="Constructor",q[q.Field=4]="Field",q[q.Variable=5]="Variable",q[q.Class=6]="Class",q[q.Interface=7]="Interface",q[q.Module=8]="Module",q[q.Property=9]="Property",q[q.Unit=10]="Unit",q[q.Value=11]="Value",q[q.Enum=12]="Enum",q[q.Keyword=13]="Keyword",q[q.Snippet=14]="Snippet",q[q.Color=15]="Color",q[q.File=16]="File",q[q.Reference=17]="Reference",q[q.Folder=18]="Folder",q[q.EnumMember=19]="EnumMember",q[q.Constant=20]="Constant",q[q.Struct=21]="Struct",q[q.Event=22]="Event",q[q.Operator=23]="Operator",q[q.TypeParameter=24]="TypeParameter",q[q.User=25]="User",q[q.Issue=26]="Issue"})(ee=e.CompletionItemKind||(e.CompletionItemKind={}));var ne;(function(q){q[q.Deprecated=1]="Deprecated"})(ne=e.CompletionItemTag||(e.CompletionItemTag={}));let pe=class{constructor($,ae){this.label=$,this.kind=ae}toJSON(){return{label:this.label,kind:this.kind&&ee[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};pe=je([R],pe),e.CompletionItem=pe;let ie=class{constructor($=[],ae=!1){this.items=$,this.isIncomplete=ae}};ie=je([R],ie),e.CompletionList=ie;let Se=class{constructor($,ae,Te){this.text=$,this.range=ae,this.command=Te}};Se=je([R],Se),e.InlineSuggestion=Se;let Fe=class{constructor($){this.items=$}};Fe=je([R],Fe),e.InlineSuggestions=Fe;var Ue;(function(q){q[q.Active=-1]="Active",q[q.Beside=-2]="Beside",q[q.One=1]="One",q[q.Two=2]="Two",q[q.Three=3]="Three",q[q.Four=4]="Four",q[q.Five=5]="Five",q[q.Six=6]="Six",q[q.Seven=7]="Seven",q[q.Eight=8]="Eight",q[q.Nine=9]="Nine"})(Ue=e.ViewColumn||(e.ViewColumn={}));var Xe;(function(q){q[q.Left=1]="Left",q[q.Right=2]="Right"})(Xe=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Ae;(function(q){q[q.Off=0]="Off",q[q.On=1]="On",q[q.Relative=2]="Relative"})(Ae=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Pe;(function(q){q[q.Manual=1]="Manual",q[q.AfterDelay=2]="AfterDelay",q[q.FocusOut=3]="FocusOut"})(Pe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var ye;(function(q){q[q.Default=0]="Default",q[q.InCenter=1]="InCenter",q[q.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",q[q.AtTop=3]="AtTop"})(ye=e.TextEditorRevealType||(e.TextEditorRevealType={}));var ce;(function(q){q[q.Keyboard=1]="Keyboard",q[q.Mouse=2]="Mouse",q[q.Command=3]="Command"})(ce=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var de;(function(q){q[q.Undo=1]="Undo",q[q.Redo=2]="Redo"})(de=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var be;(function(q){q[q.OpenOpen=0]="OpenOpen",q[q.ClosedClosed=1]="ClosedClosed",q[q.OpenClosed=2]="OpenClosed",q[q.ClosedOpen=3]="ClosedOpen"})(be=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(q){function $(ae){switch(ae){case"keyboard":return q.Keyboard;case"mouse":return q.Mouse;case"api":return q.Command}}q.fromValue=$}(ce=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Ce=class{constructor($,ae){if(ae&&!I.URI.isUri(ae))throw(0,i.illegalArgument)("target");if(!F.isRange($)||$.isEmpty)throw(0,i.illegalArgument)("range");this.range=$,this.target=ae}};Ce=je([R],Ce),e.DocumentLink=Ce;let Me=class{constructor($,ae,Te,Ye){this.red=$,this.green=ae,this.blue=Te,this.alpha=Ye}};Me=je([R],Me),e.Color=Me;let Ke=class{constructor($,ae){if(ae&&!(ae instanceof Me))throw(0,i.illegalArgument)("color");if(!F.isRange($)||$.isEmpty)throw(0,i.illegalArgument)("range");this.range=$,this.color=ae}};Ke=je([R],Ke),e.ColorInformation=Ke;let He=class{constructor($){if(!$||typeof $!="string")throw(0,i.illegalArgument)("label");this.label=$}};He=je([R],He),e.ColorPresentation=He;var Qe;(function(q){q[q.RGB=0]="RGB",q[q.HEX=1]="HEX",q[q.HSL=2]="HSL"})(Qe=e.ColorFormat||(e.ColorFormat={}));var st;(function(q){q[q.Error=0]="Error",q[q.Warning=1]="Warning",q[q.Information=2]="Information"})(st=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class at{constructor($,ae,Te){if(this.startIndex=$,this.length=ae,this.tooltip=Te,typeof $!="number"||$<0)throw(0,i.illegalArgument)("startIndex");if(typeof ae!="number"||ae<1)throw(0,i.illegalArgument)("length");if(Te!==void 0&&typeof Te!="string")throw(0,i.illegalArgument)("tooltip")}}e.TerminalLink=at;var he;(function(q){q[q.Panel=1]="Panel",q[q.Editor=2]="Editor"})(he=e.TerminalLocation||(e.TerminalLocation={}));class De{constructor($){this.options=$,typeof $!="object"&&(0,i.illegalArgument)("options")}}e.TerminalProfile=De;var le;(function(q){q[q.Always=1]="Always",q[q.Silent=2]="Silent",q[q.Never=3]="Never"})(le=e.TaskRevealKind||(e.TaskRevealKind={}));var X;(function(q){q[q.Shared=1]="Shared",q[q.Dedicated=2]="Dedicated",q[q.New=3]="New"})(X=e.TaskPanelKind||(e.TaskPanelKind={}));let ke=a=class{constructor($,ae){if(this.label=ae,typeof $!="string"||typeof ae!="string")throw(0,i.illegalArgument)("name");this._id=$}static from($){switch($){case"clean":return a.Clean;case"build":return a.Build;case"rebuild":return a.Rebuild;case"test":return a.Test;default:return}}get id(){return this._id}};ke.Clean=new a("clean","Clean"),ke.Build=new a("build","Build"),ke.Rebuild=new a("rebuild","Rebuild"),ke.Test=new a("test","Test"),ke=a=je([R],ke),e.TaskGroup=ke;function Le(q){let $="";for(let ae=0;ae<q.length;ae++)$+=q[ae].replace(/,/g,",,")+",";return $}let Ze=class{constructor($,ae,Te){if(typeof $!="string")throw(0,i.illegalArgument)("process");this._args=[],this._process=$,ae!==void 0&&(Array.isArray(ae)?(this._args=ae,this._options=Te):this._options=ae)}get process(){return this._process}set process($){if(typeof $!="string")throw(0,i.illegalArgument)("process");this._process=$}get args(){return this._args}set args($){Array.isArray($)||($=[]),this._args=$}get options(){return this._options}set options($){this._options=$}computeId(){const $=[];if($.push("process"),this._process!==void 0&&$.push(this._process),this._args&&this._args.length>0)for(let ae of this._args)$.push(ae);return Le($)}};Ze=je([R],Ze),e.ProcessExecution=Ze;let qe=class{constructor($,ae,Te){if(this._args=[],Array.isArray(ae)){if(!$)throw(0,i.illegalArgument)("command can't be undefined or null");if(typeof $!="string"&&typeof $.value!="string")throw(0,i.illegalArgument)("command");this._command=$,this._args=ae,this._options=Te}else{if(typeof $!="string")throw(0,i.illegalArgument)("commandLine");this._commandLine=$,this._options=ae}}get commandLine(){return this._commandLine}set commandLine($){if(typeof $!="string")throw(0,i.illegalArgument)("commandLine");this._commandLine=$}get command(){return this._command?this._command:""}set command($){if(typeof $!="string"&&typeof $.value!="string")throw(0,i.illegalArgument)("command");this._command=$}get args(){return this._args}set args($){this._args=$||[]}get options(){return this._options}set options($){this._options=$}computeId(){const $=[];if($.push("shell"),this._commandLine!==void 0&&$.push(this._commandLine),this._command!==void 0&&$.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let ae of this._args)$.push(typeof ae=="string"?ae:ae.value);return Le($)}};qe=je([R],qe),e.ShellExecution=qe;var dt;(function(q){q[q.Escape=1]="Escape",q[q.Strong=2]="Strong",q[q.Weak=3]="Weak"})(dt=e.ShellQuoting||(e.ShellQuoting={}));var wt;(function(q){q[q.Global=1]="Global",q[q.Workspace=2]="Workspace"})(wt=e.TaskScope||(e.TaskScope={}));class yt{constructor($){this._callback=$}computeId(){return"customExecution"+(0,L.generateUuid)()}set callback($){this._callback=$}get callback(){return this._callback}}e.CustomExecution=yt;let bt=f=class{constructor($,ae,Te,Ye,rt,ct){this.__deprecated=!1,this._definition=this.definition=$;let ht;typeof ae=="string"?(this._name=this.name=ae,this._source=this.source=Te,this.execution=Ye,ht=rt,this.__deprecated=!0):ae===wt.Global||ae===wt.Workspace?(this.target=ae,this._name=this.name=Te,this._source=this.source=Ye,this.execution=rt,ht=ct):(this.target=ae,this._name=this.name=Te,this._source=this.source=Ye,this.execution=rt,ht=ct),typeof ht=="string"?(this._problemMatchers=[ht],this._hasDefinedMatchers=!0):Array.isArray(ht)?(this._problemMatchers=ht,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id($){this.__id=$}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Ze?this._definition={type:f.ProcessType,id:this._execution.computeId()}:this._execution instanceof qe?this._definition={type:f.ShellType,id:this._execution.computeId()}:this._execution instanceof yt?this._definition={type:f.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:f.EmptyType,id:(0,L.generateUuid)()}}get definition(){return this._definition}set definition($){if($==null)throw(0,i.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=$}get scope(){return this._scope}set target($){this.clear(),this._scope=$}get name(){return this._name}set name($){if(typeof $!="string")throw(0,i.illegalArgument)("name");this.clear(),this._name=$}get execution(){return this._execution}set execution($){$===null&&($=void 0),this.clear(),this._execution=$;const ae=this._definition.type;(f.EmptyType===ae||f.ProcessType===ae||f.ShellType===ae||f.ExtensionCallbackType===ae)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers($){if(Array.isArray($))this.clear(),this._problemMatchers=$,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground($){$!==!0&&$!==!1&&($=!1),this.clear(),this._isBackground=$}get source(){return this._source}set source($){if(typeof $!="string"||$.length===0)throw(0,i.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=$}get group(){return this._group}set group($){$===null&&($=void 0),this.clear(),this._group=$}get detail(){return this._detail}set detail($){$===null&&($=void 0),this._detail=$}get presentationOptions(){return this._presentationOptions}set presentationOptions($){$==null&&($=Object.create(null)),this.clear(),this._presentationOptions=$}get runOptions(){return this._runOptions}set runOptions($){$==null&&($=Object.create(null)),this.clear(),this._runOptions=$}};bt.ExtensionCallbackType="customExecution",bt.ProcessType="process",bt.ShellType="shell",bt.EmptyType="$empty",bt=f=je([R],bt),e.Task=bt;var ft;(function(q){q[q.SourceControl=1]="SourceControl",q[q.Window=10]="Window",q[q.Notification=15]="Notification"})(ft=e.ProgressLocation||(e.ProgressLocation={}));let vt=class{constructor($,ae=_t.None){this.collapsibleState=ae,I.URI.isUri($)?this.resourceUri=$:this.label=$}};vt=je([R],vt),e.TreeItem=vt;var _t;(function(q){q[q.None=0]="None",q[q.Collapsed=1]="Collapsed",q[q.Expanded=2]="Expanded"})(_t=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let Ot=class{constructor($){this._value=$}async asString(){return JSON.stringify(this._value)}};Ot=je([R],Ot),e.TreeDataTransferItem=Ot;let It=class{constructor(){this._items=new Map}get($){return this._items.get($)}set($,ae){this._items.set($,ae)}forEach($){this._items.forEach($)}};It=je([R],It),e.TreeDataTransfer=It;let Tt=class{constructor($,ae){this.id=$,this.color=ae}};Tt=je([R],Tt),e.ThemeIcon=Tt,Tt.File=new Tt("file"),Tt.Folder=new Tt("folder");let Lt=class{constructor($){this.id=$}};Lt=je([R],Lt),e.ThemeColor=Lt;var St;(function(q){q[q.Global=1]="Global",q[q.Workspace=2]="Workspace",q[q.WorkspaceFolder=3]="WorkspaceFolder"})(St=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Mt=class{constructor($,ae){if(typeof $!="string"&&(!$||!I.URI.isUri($)&&!I.URI.isUri($.uri)))throw(0,i.illegalArgument)("base");if(typeof ae!="string")throw(0,i.illegalArgument)("pattern");typeof $=="string"?(this.baseFolder=I.URI.file($),this.base=$):I.URI.isUri($)?(this.baseFolder=$,this.base=$.fsPath):(this.baseFolder=$.uri,this.base=$.uri.fsPath),this.pattern=ae}};Mt=je([R],Mt),e.RelativePattern=Mt;let Nt=class{constructor($,ae,Te,Ye){this.enabled=typeof $=="boolean"?$:!0,typeof ae=="string"&&(this.condition=ae),typeof Te=="string"&&(this.hitCondition=Te),typeof Ye=="string"&&(this.logMessage=Ye)}get id(){return this._id||(this._id=(0,L.generateUuid)()),this._id}};Nt=je([R],Nt),e.Breakpoint=Nt;let Et=class extends Nt{constructor($,ae,Te,Ye,rt){super(ae,Te,Ye,rt);if($===null)throw(0,i.illegalArgument)("location");this.location=$}};Et=je([R],Et),e.SourceBreakpoint=Et;let Wt=class extends Nt{constructor($,ae,Te,Ye,rt){super(ae,Te,Ye,rt);this.functionName=$}};Wt=je([R],Wt),e.FunctionBreakpoint=Wt;let jt=class extends Nt{constructor($,ae,Te,Ye,rt,ct,ht){super(Ye,rt,ct,ht);if(!ae)throw(0,i.illegalArgument)("dataId");this.label=$,this.dataId=ae,this.canPersist=Te}};jt=je([R],jt),e.DataBreakpoint=jt;let si=class{constructor($,ae,Te){this.command=$,this.args=ae||[],this.options=Te}};si=je([R],si),e.DebugAdapterExecutable=si;let oi=class{constructor($,ae){this.port=$,this.host=ae}};oi=je([R],oi),e.DebugAdapterServer=oi;let At=class{constructor($){this.path=$}};At=je([R],At),e.DebugAdapterNamedPipeServer=At;let Xt=class{constructor($){this.implementation=$}};Xt=je([R],Xt),e.DebugAdapterInlineImplementation=Xt;let ai=class{constructor($,ae){this.range=$,this.expression=ae}};ai=je([R],ai),e.EvaluatableExpression=ai;var Yt;(function(q){q[q.Automatic=0]="Automatic",q[q.Explicit=1]="Explicit"})(Yt=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Vt=class{constructor($,ae){this.range=$,this.text=ae}};Vt=je([R],Vt),e.InlineValueText=Vt;let gt=class{constructor($,ae,Te=!0){this.range=$,this.variableName=ae,this.caseSensitiveLookup=Te}};gt=je([R],gt),e.InlineValueVariableLookup=gt;let li=class{constructor($,ae){this.range=$,this.expression=ae}};li=je([R],li),e.InlineValueEvaluatableExpression=li;let Ut=class{constructor($,ae){this.frameId=$,this.stoppedLocation=ae}};Ut=je([R],Ut),e.InlineValueContext=Ut;var qt;(function(q){q[q.Changed=1]="Changed",q[q.Created=2]="Created",q[q.Deleted=3]="Deleted"})(qt=e.FileChangeType||(e.FileChangeType={}));let Jt=w=class extends Error{constructor($,ae=A.FileSystemProviderErrorCode.Unknown,Te){super(I.URI.isUri($)?$.toString(!0):$);this.code=Te?.name??"Unknown",(0,A.markAsFileSystemProviderError)(this,ae),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,w.prototype),typeof Error.captureStackTrace=="function"&&typeof Te=="function"&&Error.captureStackTrace(this,Te)}static FileExists($){return new w($,A.FileSystemProviderErrorCode.FileExists,w.FileExists)}static FileNotFound($){return new w($,A.FileSystemProviderErrorCode.FileNotFound,w.FileNotFound)}static FileNotADirectory($){return new w($,A.FileSystemProviderErrorCode.FileNotADirectory,w.FileNotADirectory)}static FileIsADirectory($){return new w($,A.FileSystemProviderErrorCode.FileIsADirectory,w.FileIsADirectory)}static NoPermissions($){return new w($,A.FileSystemProviderErrorCode.NoPermissions,w.NoPermissions)}static Unavailable($){return new w($,A.FileSystemProviderErrorCode.Unavailable,w.Unavailable)}};Jt=w=je([R],Jt),e.FileSystemError=Jt;let ci=class{constructor($,ae,Te){this.start=$,this.end=ae,this.kind=Te}};ci=je([R],ci),e.FoldingRange=ci;var fi;(function(q){q[q.Comment=1]="Comment",q[q.Imports=2]="Imports",q[q.Region=3]="Region"})(fi=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Ei;(function(q){q[q.Collapsed=0]="Collapsed",q[q.Expanded=1]="Expanded"})(Ei=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var mi;(function(q){q[q.Editing=0]="Editing",q[q.Preview=1]="Preview"})(mi=e.CommentMode||(e.CommentMode={}));class Zt{constructor($,ae=[]){this.tokenTypes=$,this.tokenModifiers=ae}}e.SemanticTokensLegend=Zt;function Si(q){return typeof q=="undefined"||(0,_.isStringArray)(q)}class Gt{constructor($){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,$){this._hasLegend=!0;for(let ae=0,Te=$.tokenTypes.length;ae<Te;ae++)this._tokenTypeStrToInt.set($.tokenTypes[ae],ae);for(let ae=0,Te=$.tokenModifiers.length;ae<Te;ae++)this._tokenModifierStrToInt.set($.tokenModifiers[ae],ae)}}push($,ae,Te,Ye,rt){if(typeof $=="number"&&typeof ae=="number"&&typeof Te=="number"&&typeof Ye=="number"&&(typeof rt=="number"||typeof rt=="undefined"))return typeof rt=="undefined"&&(rt=0),this._pushEncoded($,ae,Te,Ye,rt);if(F.isRange($)&&typeof ae=="string"&&Si(Te))return this._push($,ae,Te);throw(0,i.illegalArgument)()}_push($,ae,Te){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if($.start.line!==$.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ae))throw new Error("`tokenType` is not in the provided legend");const Ye=$.start.line,rt=$.start.character,ct=$.end.character-$.start.character,ht=this._tokenTypeStrToInt.get(ae);let kt=0;if(Te)for(const Ft of Te){if(!this._tokenModifierStrToInt.has(Ft))throw new Error("`tokenModifier` is not in the provided legend");const xt=this._tokenModifierStrToInt.get(Ft);kt|=1<<xt>>>0}this._pushEncoded(Ye,rt,ct,ht,kt)}_pushEncoded($,ae,Te,Ye,rt){if(this._dataIsSortedAndDeltaEncoded&&($<this._prevLine||$===this._prevLine&&ae<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const kt=this._data.length/5|0;let Ft=0,xt=0;for(let $t=0;$t<kt;$t++){let Ht=this._data[5*$t],di=this._data[5*$t+1];Ht===0?(Ht=Ft,di+=xt):Ht+=Ft,this._data[5*$t]=Ht,this._data[5*$t+1]=di,Ft=Ht,xt=di}}let ct=$,ht=ae;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(ct-=this._prevLine,ct===0&&(ht-=this._prevChar)),this._data[this._dataLen++]=ct,this._data[this._dataLen++]=ht,this._data[this._dataLen++]=Te,this._data[this._dataLen++]=Ye,this._data[this._dataLen++]=rt,this._prevLine=$,this._prevChar=ae}static _sortAndDeltaEncode($){let ae=[];const Te=$.length/5|0;for(let ht=0;ht<Te;ht++)ae[ht]=ht;ae.sort((ht,kt)=>{const Ft=$[5*ht],xt=$[5*kt];if(Ft===xt){const $t=$[5*ht+1],Ht=$[5*kt+1];return $t-Ht}return Ft-xt});const Ye=new Uint32Array($.length);let rt=0,ct=0;for(let ht=0;ht<Te;ht++){const kt=5*ae[ht],Ft=$[kt+0],xt=$[kt+1],$t=$[kt+2],Ht=$[kt+3],di=$[kt+4],$i=Ft-rt,Xi=$i===0?xt-ct:xt,hi=5*ht;Ye[hi+0]=$i,Ye[hi+1]=Xi,Ye[hi+2]=$t,Ye[hi+3]=Ht,Ye[hi+4]=di,rt=Ft,ct=xt}return Ye}build($){return this._dataIsSortedAndDeltaEncoded?new Kt(new Uint32Array(this._data),$):new Kt(Gt._sortAndDeltaEncode(this._data),$)}}e.SemanticTokensBuilder=Gt;class Kt{constructor($,ae){this.resultId=ae,this.data=$}}e.SemanticTokens=Kt;class _i{constructor($,ae,Te){this.start=$,this.deleteCount=ae,this.data=Te}}e.SemanticTokensEdit=_i;class Ci{constructor($,ae){this.resultId=ae,this.edits=$}}e.SemanticTokensEdits=Ci;var Qt;(function(q){q[q.Separate=0]="Separate",q[q.MergeWithParent=1]="MergeWithParent"})(Qt=e.DebugConsoleMode||(e.DebugConsoleMode={}));var yi;(function(q){q[q.Initial=1]="Initial",q[q.Dynamic=2]="Dynamic"})(yi=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let ei=class{constructor(){}};ei.Back={iconPath:new Tt("arrow-left")},ei=je([R],ei),e.QuickInputButtons=ei;var Di;(function(q){q[q.Default=1]="Default",q[q.Separator=2]="Separator"})(Di=e.QuickPickItemKind||(e.QuickPickItemKind={}));var ki;(function(q){q[q.UI=1]="UI",q[q.Workspace=2]="Workspace"})(ki=e.ExtensionKind||(e.ExtensionKind={}));class ui{constructor($,ae,Te){this.badge=$,this.tooltip=ae,this.color=Te}static validate($){if($.badge){let ae=(0,D.nextCharLength)($.badge,0);if(ae<$.badge.length&&(ae+=(0,D.nextCharLength)($.badge,ae)),$.badge.length>ae)throw new Error("The 'badge'-property must be undefined or a short character")}if(!$.color&&!$.badge&&!$.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=ui;let ti=class{constructor($){this.kind=$}};ti=je([R],ti),e.ColorTheme=ti;var gi;(function(q){q[q.Light=1]="Light",q[q.Dark=2]="Dark",q[q.HighContrast=3]="HighContrast"})(gi=e.ColorThemeKind||(e.ColorThemeKind={}));class $e{constructor($,ae){if($<0)throw(0,i.illegalArgument)("start must be positive");if(ae<0)throw(0,i.illegalArgument)("end must be positive");$<=ae?(this._start=$,this._end=ae):(this._start=ae,this._end=$)}static isNotebookRange($){return $ instanceof $e?!0:$?typeof $.start=="number"&&typeof $.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with($){let ae=this._start,Te=this._end;return $.start!==void 0&&(ae=$.start),$.end!==void 0&&(Te=$.end),ae===this._start&&Te===this._end?this:new $e(ae,Te)}}e.NotebookRange=$e;class Bt{constructor($,ae,Te,Ye,rt,ct,ht){this.kind=$,this.value=ae,this.languageId=Te,this.mime=Ye,this.outputs=rt??[],this.metadata=ct,this.executionSummary=ht,Bt.validate(this)}static validate($){if(typeof $.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof $.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof $.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray($){return Array.isArray($)&&$.every(ae=>Bt.isNotebookCellData(ae))}static isNotebookCellData($){return!0}}e.NotebookCellData=Bt;class pi{constructor($){this.cells=$}}e.NotebookData=pi;class mt{constructor($,ae){this.data=$,this.mime=ae;const Te=(0,P.normalizeMimeType)(ae,!0);if(!Te)throw new Error(`INVALID mime type: ${ae}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Te}static isNotebookCellOutputItem($){return $ instanceof mt?!0:$?typeof $.mime=="string"&&$.data instanceof Uint8Array:!1}static error($){const ae={name:$.name,message:$.message,stack:$.stack};return mt.json(ae,"application/vnd.code.notebook.error")}static stdout($){return mt.text($,"application/vnd.code.notebook.stdout")}static stderr($){return mt.text($,"application/vnd.code.notebook.stderr")}static bytes($,ae="application/octet-stream"){return new mt($,ae)}static text($,ae=P.Mimes.text){const Te=Be(mt,p,"f",v).encode(String($));return new mt(Te,ae)}static json($,ae="application/json"){const Te=JSON.stringify($,void 0,"	");return mt.text(Te,ae)}}e.NotebookCellOutputItem=mt,p=mt,v={value:new TextEncoder};class ii{constructor($,ae,Te){this.items=ii.ensureUniqueMimeTypes($,!0),typeof ae=="string"?(this.id=ae,this.metadata=Te):(this.id=(0,L.generateUuid)(),this.metadata=ae??Te)}static isNotebookCellOutput($){return $ instanceof ii?!0:!$||typeof $!="object"?!1:typeof $.id=="string"&&(0,_.isArray)($.items)}static ensureUniqueMimeTypes($,ae=!1){const Te=new Set,Ye=new Set;for(let rt=0;rt<$.length;rt++){const ct=$[rt],ht=(0,P.normalizeMimeType)(ct.mime);if(!Te.has(ht)){Te.add(ht);continue}Ye.add(rt),ae&&console.warn(`DUPLICATED mime type '${ct.mime}' will be dropped`)}return Ye.size===0?$:$.filter((rt,ct)=>!Ye.has(ct))}}e.NotebookCellOutput=ii;var Ii;(function(q){q[q.Markup=1]="Markup",q[q.Code=2]="Code"})(Ii=e.NotebookCellKind||(e.NotebookCellKind={}));var vi;(function(q){q[q.Idle=1]="Idle",q[q.Pending=2]="Pending",q[q.Executing=3]="Executing"})(vi=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var wi;(function(q){q[q.Left=1]="Left",q[q.Right=2]="Right"})(wi=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Pi;(function(q){q[q.Default=0]="Default",q[q.InCenter=1]="InCenter",q[q.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",q[q.AtTop=3]="AtTop"})(Pi=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Ti{constructor($,ae){this.text=$,this.alignment=ae}}e.NotebookCellStatusBarItem=Ti;var Ai;(function(q){q[q.Default=1]="Default",q[q.Preferred=2]="Preferred"})(Ai=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Ri{constructor($,ae=[]){this.uri=$,this.provides=(0,m.asArray)(ae)}}e.NotebookRendererScript=Ri;let ni=class{constructor($,ae){this.label=$,this.timestamp=ae}};ni=je([R],ni),e.TimelineItem=ni;var Li;(function(q){q[q.Production=1]="Production",q[q.Development=2]="Development",q[q.Test=3]="Test"})(Li=e.ExtensionMode||(e.ExtensionMode={}));var Fi;(function(q){q[q.Node=1]="Node",q[q.Webworker=2]="Webworker"})(Fi=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Mi;(function(q){q[q.Other=0]="Other",q[q.Comment=1]="Comment",q[q.String=2]="String",q[q.RegEx=4]="RegEx"})(Mi=e.StandardTokenType||(e.StandardTokenType={}));class Oi{constructor($,ae){this.ranges=$,this.wordPattern=ae}}e.LinkedEditingRanges=Oi;class Ni{constructor($,ae){this._port=$,this._autoForwardAction=ae}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Ni;var se;(function(q){q[q.Queued=1]="Queued",q[q.Running=2]="Running",q[q.Passed=3]="Passed",q[q.Failed=4]="Failed",q[q.Skipped=5]="Skipped",q[q.Errored=6]="Errored"})(se=e.TestResultState||(e.TestResultState={}));var ge;(function(q){q[q.Run=1]="Run",q[q.Debug=2]="Debug",q[q.Coverage=3]="Coverage"})(ge=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Re=class{constructor($=void 0,ae=void 0,Te=void 0){this.include=$,this.exclude=ae,this.profile=Te}};Re=je([R],Re),e.TestRunRequest=Re;let ut=d=class{constructor($){this.message=$}static diff($,ae,Te){const Ye=new d($);return Ye.expectedOutput=ae,Ye.actualOutput=Te,Ye}};ut=d=je([R],ut),e.TestMessage=ut;let Ct=class{constructor($){this.id=$}};Ct=je([R],Ct),e.TestTag=Ct;let Dt=class{constructor($,ae){this.covered=$,this.total=ae}};Dt=je([R],Dt),e.CoveredCount=Dt;let Ui=k=class{constructor($,ae,Te,Ye){this.uri=$,this.statementCoverage=ae,this.branchCoverage=Te,this.functionCoverage=Ye}static fromDetails($,ae){const Te=new Dt(0,0),Ye=new Dt(0,0),rt=new Dt(0,0);for(const ht of ae)if("branches"in ht){Te.total+=1,Te.covered+=ht.executionCount>0?1:0;for(const kt of ht.branches)Ye.total+=1,Ye.covered+=kt.executionCount>0?1:0}else rt.total+=1,rt.covered+=ht.executionCount>0?1:0;const ct=new k($,Te,Ye.total>0?Ye:void 0,rt.total>0?rt:void 0);return ct.detailedCoverage=ae,ct}};Ui=k=je([R],Ui),e.FileCoverage=Ui;let Bi=class{constructor($,ae,Te=[]){this.executionCount=$,this.location=ae,this.branches=Te}};Bi=je([R],Bi),e.StatementCoverage=Bi;let xi=class{constructor($,ae){this.executionCount=$,this.location=ae}};xi=je([R],xi),e.BranchCoverage=xi;let Wi=class{constructor($,ae){this.executionCount=$,this.location=ae}};Wi=je([R],Wi),e.FunctionCoverage=Wi;var qi;(function(q){q[q.None=0]="None",q[q.Option=1]="Option",q[q.Default=2]="Default",q[q.Preferred=3]="Preferred"})(qi=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Gi;(function(q){q[q.Untrusted=0]="Untrusted",q[q.Trusted=1]="Trusted",q[q.Unspecified=2]="Unspecified"})(Gi=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Ki;(function(q){q[q.Notify=1]="Notify",q[q.OpenBrowser=2]="OpenBrowser",q[q.OpenPreview=3]="OpenPreview",q[q.Silent=4]="Silent",q[q.Ignore=5]="Ignore",q[q.OpenBrowserOnce=6]="OpenBrowserOnce"})(Ki=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class Qi{constructor($,ae,Te,Ye,rt,ct){this.kind=$,this.name=ae,this.detail=Te,this.uri=Ye,this.range=rt,this.selectionRange=ct}}e.TypeHierarchyItem=Qi}),define(ve[122],we([0,1,56,10,8,149,109,7,16]),function(J,e,m,i,y,C,P,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const I=new Map;function L(h,p){p?I.set(h,p):I.delete(h)}e.setWordDefinitionFor=L;function A(h){return I.get(h)}e.getWordDefinitionFor=A;class c extends C.MirrorTextModel{constructor(p,v,T,b,o,s,g,l){super(v,T,b,o);this._proxy=p,this._languageId=s,this._isDirty=g,this._notebook=l,this._isDisposed=!1}dispose(){(0,m.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(p){return(0,_.equals)(this._lines,p)}get document(){if(!this._document){const p=this;this._document={get uri(){return p._uri},get fileName(){return p._uri.fsPath},get isUntitled(){return p._uri.scheme===i.Schemas.untitled},get languageId(){return p._languageId},get version(){return p._versionId},get isClosed(){return p._isDisposed},get isDirty(){return p._isDirty},get notebook(){return p._notebook},save(){return p._save()},getText(v){return v?p._getTextInRange(v):p.getText()},get eol(){return p._eol===`
`?D.EndOfLine.LF:D.EndOfLine.CRLF},get lineCount(){return p._lines.length},lineAt(v){return p._lineAt(v)},offsetAt(v){return p._offsetAt(v)},positionAt(v){return p._positionAt(v)},validateRange(v){return p._validateRange(v)},validatePosition(v){return p._validatePosition(v)},getWordRangeAtPosition(v,T){return p._getWordRangeAtPosition(v,T)}}}return Object.freeze(this._document)}_acceptLanguageId(p){(0,m.ok)(!this._isDisposed),this._languageId=p}_acceptIsDirty(p){(0,m.ok)(!this._isDisposed),this._isDirty=p}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(p){const v=this._validateRange(p);if(v.isEmpty)return"";if(v.isSingleLine)return this._lines[v.start.line].substring(v.start.character,v.end.character);const T=this._eol,b=v.start.line,o=v.end.line,s=[];s.push(this._lines[b].substring(v.start.character));for(let g=b+1;g<o;g++)s.push(this._lines[g]);return s.push(this._lines[o].substring(0,v.end.character)),s.join(T)}_lineAt(p){let v;if(p instanceof D.Position?v=p.line:typeof p=="number"&&(v=p),typeof v!="number"||v<0||v>=this._lines.length||Math.floor(v)!==v)throw new Error("Illegal value for `line`");return new E(v,this._lines[v],v===this._lines.length-1)}_offsetAt(p){return p=this._validatePosition(p),this._ensureLineStarts(),this._lineStarts.getPrefixSum(p.line-1)+p.character}_positionAt(p){p=Math.floor(p),p=Math.max(0,p),this._ensureLineStarts();const v=this._lineStarts.getIndexOf(p),T=this._lines[v.index].length;return new D.Position(v.index,Math.min(v.remainder,T))}_validateRange(p){if(!(p instanceof D.Range))throw new Error("Invalid argument");const v=this._validatePosition(p.start),T=this._validatePosition(p.end);return v===p.start&&T===p.end?p:new D.Range(v.line,v.character,T.line,T.character)}_validatePosition(p){if(!(p instanceof D.Position))throw new Error("Invalid argument");if(this._lines.length===0)return p.with(0,0);let{line:v,character:T}=p,b=!1;if(v<0)v=0,T=0,b=!0;else if(v>=this._lines.length)v=this._lines.length-1,T=this._lines[v].length,b=!0;else{const o=this._lines[v].length;T<0?(T=0,b=!0):T>o&&(T=o,b=!0)}return b?new D.Position(v,T):p}_getWordRangeAtPosition(p,v){const T=this._validatePosition(p);if(!v)v=A(this._languageId);else if((0,y.regExpLeadsToEndlessLoop)(v))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${v.source}' because it matches the empty string.`);const b=(0,P.getWordAtText)(T.character+1,(0,P.ensureValidWordDefinition)(v),this._lines[T.line],0);if(b)return new D.Range(T.line,b.startColumn-1,T.line,b.endColumn-1)}}e.ExtHostDocumentData=c;class E{constructor(p,v,T){this._line=p,this._text=v,this._isLastLine=T}get lineNumber(){return this._line}get text(){return this._text}get range(){return new D.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new D.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=E}),define(ve[201],we([0,1,7,3,111,6,82,24,2,32]),function(J,e,m,i,y,C,P,D,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class L{constructor(c,E,h,p){this._notebook=h,this._selector=p,this._disposables=new C.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new i.Emitter,this.onDidChange=this._onDidChange.event,this.uri=_.URI.from({scheme:"vscode-concat-doc",path:(0,I.generateUuid)()}),this._init(),this._disposables.add(E.onDidChangeDocument(T=>{const b=this._cellUris.get(T.document.uri);b!==void 0&&(this._cellLengths.setValue(b,this._cells[b].document.getText().length+1),this._cellLines.setValue(b,this._cells[b].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const v=T=>{T===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(c.onDidChangeNotebookCells(T=>v(T.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new D.ResourceMap;const c=[],E=[];for(const h of this._notebook.getCells())h.kind===m.NotebookCellKind.Code&&(!this._selector||(0,P.score)(this._selector,h.document.uri,h.document.languageId,!0))&&(this._cellUris.set(h.document.uri,this._cells.length),this._cells.push(h),c.push(h.document.getText().length+1),E.push(h.document.lineCount));this._cellLengths=new y.PrefixSumComputer(new Uint32Array(c)),this._cellLines=new y.PrefixSumComputer(new Uint32Array(E))}get version(){return this._versionId}getText(c){if(!c){let b="";for(const o of this._cells)b+=o.document.getText()+`
`;return b=b.slice(0,-1),b}if(c.isEmpty)return"";const E=this.locationAt(c.start),h=this.locationAt(c.end),p=this._cellUris.get(E.uri),v=this._cellUris.get(h.uri);if(p===void 0||v===void 0)return"";if(p===v)return this._cells[p].document.getText(new m.Range(E.range.start,h.range.end));const T=[this._cells[p].document.getText(new m.Range(E.range.start,new m.Position(this._cells[p].document.lineCount,0)))];for(let b=p+1;b<v;b++)T.push(this._cells[b].document.getText());return T.push(this._cells[v].document.getText(new m.Range(new m.Position(0,0),h.range.end))),T.join(`
`)}offsetAt(c){const E=this._cellLines.getIndexOf(c.line),h=this._cellLengths.getPrefixSum(E.index-1),p=this._cells[E.index].document.offsetAt(c.with(E.remainder));return h+p}positionAt(c){if(typeof c=="number"){const h=this._cellLengths.getIndexOf(c),p=this._cellLines.getPrefixSum(h.index-1);return this._cells[h.index].document.positionAt(h.remainder).translate(p)}const E=this._cellUris.get(c.uri);if(E!==void 0){const h=this._cellLines.getPrefixSum(E-1);return new m.Position(h+c.range.start.line,c.range.start.character)}return new m.Position(0,0)}locationAt(c){m.Range.isRange(c)||(c=new m.Range(c,c));const E=this._cellLines.getIndexOf(c.start.line);let h=E;c.isEmpty||(h=this._cellLines.getIndexOf(c.end.line));const p=new m.Position(E.remainder,c.start.character),v=new m.Position(h.remainder,c.end.character),T=new m.Range(p,v),b=this._cells[E.index];return new m.Location(b.document.uri,b.document.validateRange(T))}contains(c){return this._cellUris.has(c)}validateRange(c){const E=this.validatePosition(c.start),h=this.validatePosition(c.end);return c.with(E,h)}validatePosition(c){const E=this._cellLines.getIndexOf(c.line),h=new m.Position(E.remainder,c.character),p=this._cells[E.index].document.validatePosition(h),v=this._cellLines.getPrefixSum(E.index-1);return new m.Position(v+p.line,p.character)}}e.ExtHostNotebookConcatDocument=L}),define(ve[202],we([0,1,7,14,3]),function(J,e,m,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let C=class{constructor(D){this._actual=new m.ColorTheme(m.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new y.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(D){let _=D==="light"?m.ColorThemeKind.Light:D==="dark"?m.ColorThemeKind.Dark:m.ColorThemeKind.HighContrast;this._actual=new m.ColorTheme(_),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};C=je([ze(0,i.IExtHostRpcService)],C),e.ExtHostTheming=C}),define(ve[64],we([0,1,4]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,m.createDecorator)("IURITransformerService");class i{constructor(C){C?(this.transformIncoming=C.transformIncoming.bind(C),this.transformOutgoing=C.transformOutgoing.bind(C),this.transformOutgoingURI=C.transformOutgoingURI.bind(C),this.transformOutgoingScheme=C.transformOutgoingScheme.bind(C)):(this.transformIncoming=P=>P,this.transformOutgoing=P=>P,this.transformOutgoingURI=P=>P,this.transformOutgoingScheme=P=>P)}}e.URITransformerService=i}),define(ve[203],we([0,1,22]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class i{constructor(){this.buffers=[]}add(_){let I=this.buffers.indexOf(_);return I<0&&(I=this.buffers.length,this.buffers.push(_)),I}}function y(D,_){if(_.serializeBuffersForPostMessage){const I=new i,L=(E,h)=>{if(h instanceof ArrayBuffer){const p=I.add(h);return{$$vscode_array_buffer_reference$$:!0,index:p}}else if(ArrayBuffer.isView(h)){const p=C(h);if(p){const v=I.add(h.buffer);return{$$vscode_array_buffer_reference$$:!0,index:v,view:{type:p,byteLength:h.byteLength,byteOffset:h.byteOffset}}}}return h},A=JSON.stringify(D,L),c=I.buffers.map(E=>{const h=new Uint8Array(E);return m.VSBuffer.wrap(h)});return{message:A,buffers:c}}else return{message:JSON.stringify(D),buffers:[]}}e.serializeWebviewMessage=y;function C(D){switch(D.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function P(D,_){const I=_.map(c=>{const E=new ArrayBuffer(c.byteLength);return new Uint8Array(E).set(c.buffer),E}),L=_.length?(c,E)=>{if(typeof E=="object"&&E.$$vscode_array_buffer_reference$$){const h=E,{index:p}=h,v=I[p];if(h.view)switch(h.view.type){case 1:return new Int8Array(v,h.view.byteOffset,h.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(v,h.view.byteOffset,h.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(v,h.view.byteOffset,h.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(v,h.view.byteOffset,h.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(v,h.view.byteOffset,h.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(v,h.view.byteOffset,h.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(v,h.view.byteOffset,h.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(v,h.view.byteOffset,h.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(v,h.view.byteOffset,h.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(v,h.view.byteOffset,h.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(v,h.view.byteOffset,h.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return v}return E}:void 0;return{message:JSON.parse(D,L),arrayBuffers:I}}e.deserializeWebviewMessage=P}),define(ve[204],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var m;(function(i){function y(P){const D=new Map;return P.types.forEach((_,I)=>{D.set(_,{asString:async()=>P.items[I].asString})}),D}i.toITreeDataTransfer=y;async function C(P){const D={types:[],items:[]},_=Array.from(P.entries());for(const I of _)D.types.push(I[0]),D.items.push({asString:await I[1].asString()});return D}i.toTreeDataTransferDTO=C})(m=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(ve[88],we([0,1,10,2]),function(J,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function y(D,_){return D.scheme===m.Schemas.http||D.scheme===m.Schemas.https?D:(_&&_.authority&&_.isRemote&&D.scheme===m.Schemas.file&&(D=i.URI.from({scheme:m.Schemas.vscodeRemote,authority:_.authority,path:D.path})),i.URI.from({scheme:m.Schemas.https,authority:`${D.scheme}+${C(D.authority)}.${e.webviewRootResourceAuthority}`,path:D.path,fragment:D.fragment,query:D.query}))}e.asWebviewUri=y;function C(D){return D.replace(/./g,_=>{const I=_.charCodeAt(0);return I>=97&&I<=122||I>=65&&I<=90||I>=48&&I<=57?_:"-"+I.toString(16).padStart(4,"0")})}function P(D){return D.replace(/-([0-9a-f]{4})/g,(_,I)=>String.fromCharCode(parseInt(I,16)))}e.decodeAuthority=P}),define(ve[205],we([0,1,3,6,88]),function(J,e,m,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class C{constructor(D,_,I){this._proxy=D,this._editors=_,this._initData=I,this._handlePool=0,this._disposables=new i.DisposableStore,this._insets=new Map,this._disposables.add(_.onDidChangeVisibleTextEditors(()=>{const L=_.getVisibleTextEditors();for(const A of this._insets.values())L.indexOf(A.editor)<0&&A.inset.dispose()}))}dispose(){this._insets.forEach(D=>D.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(D,_,I,L,A){let c;for(const o of this._editors.getVisibleTextEditors(!0))if(o.value===D){c=o;break}if(!c)throw new Error("not a visible editor");const E=this,h=this._handlePool++,p=new m.Emitter,v=new m.Emitter,T=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(o){return(0,y.asWebviewUri)(o,E._initData.remote)}get cspSource(){return y.webviewGenericCspSource}set options(o){this._options=o,E._proxy.$setOptions(h,o)}get options(){return this._options}set html(o){this._html=o,E._proxy.$setHtml(h,o)}get html(){return this._html}get onDidReceiveMessage(){return p.event}postMessage(o){return E._proxy.$postMessage(h,o)}},b=new class{constructor(){this.editor=D,this.line=_,this.height=I,this.webview=T,this.onDidDispose=v.event}dispose(){E._insets.has(h)&&(E._insets.delete(h),E._proxy.$disposeEditorInset(h),v.fire(),v.dispose(),p.dispose())}};return this._proxy.$createEditorInset(h,c.id,c.value.document.uri,_+1,I,L||{},A.identifier,A.extensionLocation),this._insets.set(h,{editor:D,inset:b,onDidReceiveMessage:p}),b}$onDidDispose(D){const _=this._insets.get(D);_&&_.inset.dispose()}$onDidReceiveMessage(D,_){const I=this._insets.get(D);I&&I.onDidReceiveMessage.fire(_)}}e.ExtHostEditorInsets=C}),define(ve[206],we([0,1,171,13,2,6,4,61,51,42,16,10]),function(J,e,m,i,y,C,P,D,_,I,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLockedContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.SideBySideEditorActiveContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanSplitInGroupContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,m.localize)(0,null),providerDisplayName:(0,m.localize)(1,null)},e.ActiveEditorDirtyContext=new D.RawContextKey("activeEditorIsDirty",!1,(0,m.localize)(2,null)),e.ActiveEditorPinnedContext=new D.RawContextKey("activeEditorIsNotPreview",!1,(0,m.localize)(3,null)),e.ActiveEditorStickyContext=new D.RawContextKey("activeEditorIsPinned",!1,(0,m.localize)(4,null)),e.ActiveEditorReadonlyContext=new D.RawContextKey("activeEditorIsReadonly",!1,(0,m.localize)(5,null)),e.ActiveEditorCanRevertContext=new D.RawContextKey("activeEditorCanRevert",!1,(0,m.localize)(6,null)),e.ActiveEditorCanSplitInGroupContext=new D.RawContextKey("activeEditorCanSplitInGroup",!0),e.ActiveEditorContext=new D.RawContextKey("activeEditor",null,{type:"string",description:(0,m.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new D.RawContextKey("activeEditorAvailableEditorIds","",(0,m.localize)(8,null)),e.TextCompareEditorVisibleContext=new D.RawContextKey("textCompareEditorVisible",!1,(0,m.localize)(9,null)),e.TextCompareEditorActiveContext=new D.RawContextKey("textCompareEditorActive",!1,(0,m.localize)(10,null)),e.SideBySideEditorActiveContext=new D.RawContextKey("sideBySideEditorActive",!1,(0,m.localize)(11,null)),e.EditorGroupEditorsCountContext=new D.RawContextKey("groupEditorsCount",0,(0,m.localize)(12,null)),e.ActiveEditorGroupEmptyContext=new D.RawContextKey("activeEditorGroupEmpty",!1,(0,m.localize)(13,null)),e.ActiveEditorGroupIndexContext=new D.RawContextKey("activeEditorGroupIndex",0,(0,m.localize)(14,null)),e.ActiveEditorGroupLastContext=new D.RawContextKey("activeEditorGroupLast",!1,(0,m.localize)(15,null)),e.ActiveEditorGroupLockedContext=new D.RawContextKey("activeEditorGroupLocked",!1,(0,m.localize)(16,null)),e.MultipleEditorGroupsContext=new D.RawContextKey("multipleEditorGroups",!1,(0,m.localize)(17,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new D.RawContextKey("editorIsOpen",!1,(0,m.localize)(18,null)),e.InEditorZenModeContext=new D.RawContextKey("inZenMode",!1,(0,m.localize)(19,null)),e.IsCenteredLayoutContext=new D.RawContextKey("isCenteredLayout",!1,(0,m.localize)(20,null)),e.SplitEditorsVertically=new D.RawContextKey("splitEditorsVertically",!1,(0,m.localize)(21,null)),e.EditorAreaVisibleContext=new D.RawContextKey("editorAreaVisible",!0,(0,m.localize)(22,null)),e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function c(F,B,O){for(const H of O.visibleEditorPanes)if(H.group.id===B&&F.matches(H.input))return H.getViewState()}e.findViewStateForEditor=c;function E(F){if(g(F))return!1;const B=F;return y.URI.isUri(B?.resource)}e.isResourceEditorInput=E;function h(F){if(g(F))return!1;const B=F;return B?.original!==void 0&&B.modified!==void 0}e.isResourceDiffEditorInput=h;function p(F){if(g(F)||h(F))return!1;const B=F;return B?.primary!==void 0&&B.secondary!==void 0}e.isResourceSideBySideEditorInput=p;function v(F){if(g(F))return!1;const B=F;return B?B.resource===void 0||B.resource.scheme===A.Schemas.untitled||B.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=v;var T;(function(F){F[F.SHORT=0]="SHORT",F[F.MEDIUM=1]="MEDIUM",F[F.LONG=2]="LONG"})(T=e.Verbosity||(e.Verbosity={}));var b;(function(F){F[F.EXPLICIT=1]="EXPLICIT",F[F.AUTO=2]="AUTO",F[F.FOCUS_CHANGE=3]="FOCUS_CHANGE",F[F.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(b=e.SaveReason||(e.SaveReason={}));var o;(function(F){F[F.None=0]="None",F[F.Readonly=2]="Readonly",F[F.Untitled=4]="Untitled",F[F.Singleton=8]="Singleton",F[F.RequiresTrust=16]="RequiresTrust",F[F.CanSplitInGroup=32]="CanSplitInGroup",F[F.ForceDescription=64]="ForceDescription"})(o=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class s extends C.Disposable{}e.AbstractEditorInput=s;function g(F){return F instanceof s}e.isEditorInput=g;function l(F){const B=F;return y.URI.isUri(B?.preferredResource)}function S(F){const B=F;return g(B?.primary)&&g(B?.secondary)}e.isSideBySideEditorInput=S;function n(F){const B=F;return g(B?.modified)&&g(B?.original)}e.isDiffEditorInput=n;function t(F){return g(F?.editor)}e.isEditorInputWithOptions=t;function r(F){const B=F;return t(F)&&B?.group!==void 0}e.isEditorInputWithOptionsAndGroup=r;function u(F){const B=F;return typeof B?.groupId=="number"&&g(B.editor)}e.isEditorIdentifier=u;var a;(function(F){F[F.UNKNOWN=0]="UNKNOWN",F[F.REPLACE=1]="REPLACE",F[F.MOVE=2]="MOVE",F[F.UNPIN=3]="UNPIN"})(a=e.EditorCloseContext||(e.EditorCloseContext={}));var f;(function(F){F[F.GROUP_ACTIVE=0]="GROUP_ACTIVE",F[F.GROUP_INDEX=1]="GROUP_INDEX",F[F.GROUP_LOCKED=2]="GROUP_LOCKED",F[F.EDITOR_OPEN=3]="EDITOR_OPEN",F[F.EDITOR_CLOSE=4]="EDITOR_CLOSE",F[F.EDITOR_MOVE=5]="EDITOR_MOVE",F[F.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",F[F.EDITOR_LABEL=7]="EDITOR_LABEL",F[F.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",F[F.EDITOR_PIN=9]="EDITOR_PIN",F[F.EDITOR_STICKY=10]="EDITOR_STICKY",F[F.EDITOR_DIRTY=11]="EDITOR_DIRTY",F[F.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(f=e.GroupChangeKind||(e.GroupChangeKind={}));var w;(function(F){F[F.PRIMARY=1]="PRIMARY",F[F.SECONDARY=2]="SECONDARY",F[F.BOTH=3]="BOTH",F[F.ANY=4]="ANY"})(w=e.SideBySideEditor||(e.SideBySideEditor={}));class d{getOriginalUri(B,O){if(!B)return;if(O?.supportSideBySide){const{primary:M,secondary:W}=this.getSideEditors(B);if(M&&W){if(O?.supportSideBySide===w.BOTH)return{primary:this.getOriginalUri(M,{filterByScheme:O.filterByScheme}),secondary:this.getOriginalUri(W,{filterByScheme:O.filterByScheme})};if(O?.supportSideBySide===w.ANY)return this.getOriginalUri(M,{filterByScheme:O.filterByScheme})??this.getOriginalUri(W,{filterByScheme:O.filterByScheme});B=O.supportSideBySide===w.PRIMARY?M:W}}if(h(B)||p(B))return;const H=l(B)?B.preferredResource:B.resource;return!H||!O||!O.filterByScheme?H:this.filterUri(H,O.filterByScheme)}getSideEditors(B){return S(B)||p(B)?{primary:B.primary,secondary:B.secondary}:n(B)||h(B)?{primary:B.modified,secondary:B.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(B,O){if(!B)return;if(O?.supportSideBySide){const{primary:M,secondary:W}=this.getSideEditors(B);if(M&&W){if(O?.supportSideBySide===w.BOTH)return{primary:this.getCanonicalUri(M,{filterByScheme:O.filterByScheme}),secondary:this.getCanonicalUri(W,{filterByScheme:O.filterByScheme})};if(O?.supportSideBySide===w.ANY)return this.getCanonicalUri(M,{filterByScheme:O.filterByScheme})??this.getCanonicalUri(W,{filterByScheme:O.filterByScheme});B=O.supportSideBySide===w.PRIMARY?M:W}}if(h(B)||p(B))return;const H=B.resource;return!H||!O||!O.filterByScheme?H:this.filterUri(H,O.filterByScheme)}filterUri(B,O){if(Array.isArray(O)){if(O.some(H=>B.scheme===H))return B}else if(O===B.scheme)return B}}e.EditorResourceAccessor=new d;var k;(function(F){F[F.LEFT=0]="LEFT",F[F.RIGHT=1]="RIGHT"})(k=e.CloseDirection||(e.CloseDirection={}));class R{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(B){const O=this.instantiationService=B.get(P.IInstantiationService);for(const[H,M]of this.editorSerializerConstructors)this.createEditorSerializer(H,M,O);this.editorSerializerConstructors.clear()}createEditorSerializer(B,O,H){const M=H.createInstance(O);this.editorSerializerInstances.set(B,M)}registerFileEditorFactory(B){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=B}getFileEditorFactory(){return(0,i.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(B,O){if(this.editorSerializerConstructors.has(B)||this.editorSerializerInstances.has(B))throw new Error(`A editor serializer with type ID '${B}' was already registered.`);return this.instantiationService?this.createEditorSerializer(B,O,this.instantiationService):this.editorSerializerConstructors.set(B,O),(0,C.toDisposable)(()=>{this.editorSerializerConstructors.delete(B),this.editorSerializerInstances.delete(B)})}getEditorSerializer(B){return this.editorSerializerInstances.get(typeof B=="string"?B:B.typeId)}}_.Registry.add(e.EditorExtensions.EditorFactory,new R);async function N(F,B){if(!F||!F.length)return[];const O=await Promise.all(F.map(async H=>{const M=y.URI.revive(H.fileUri);if(!M||!await B.canHandleResource(M))return;let z=H.exists,U=H.type;if(typeof z!="boolean"||typeof U!="number")try{U=(await B.resolve(M)).isDirectory?I.FileType.Directory:I.FileType.Unknown,z=!0}catch{z=!1}if(!z&&H.openOnlyIfExists||U===I.FileType.Directory)return;const V={selection:z?H.selection:void 0,pinned:!0,override:H.editorOverrideId};let K;return z?K={resource:M,options:V}:K={resource:M,options:V,forceUntitled:!0},K}));return(0,L.coalesce)(O)}e.pathsToEditors=N;var x;(function(F){F[F.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",F[F.SEQUENTIAL=1]="SEQUENTIAL"})(x=e.EditorsOrder||(e.EditorsOrder={}))}),define(ve[123],we([0,1,3,18,172]),function(J,e,m,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class C{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new m.Emitter,this._onExit=new m.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(D){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=D}onEvent(D){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=D}onRequest(D){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=D}sendResponse(D){D.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${D.command}`)):this.internalSend("response",D)}sendRequest(D,_,I,L){const A={command:D};if(_&&Object.keys(_).length>0&&(A.arguments=_),this.internalSend("request",A),typeof L=="number"){const c=setTimeout(()=>{clearTimeout(c);const E=this.pendingRequests.get(A.seq);if(E){this.pendingRequests.delete(A.seq);const h={type:"response",seq:0,request_seq:A.seq,success:!1,command:D,message:(0,y.localize)(0,null,L,D)};E(h)}},L)}return I&&this.pendingRequests.set(A.seq,I),A.seq}acceptMessage(D){this.messageCallback?this.messageCallback(D):(this.queue.push(D),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(D,_){return D.type!=="event"||_.type!=="event"}async processQueue(){let D;for(;this.queue.length;){if((!D||this.needsTaskBoundaryBetween(this.queue[0],D))&&await(0,i.timeout)(0),D=this.queue.shift(),!D)return;switch(D.type){case"event":this.eventCallback&&this.eventCallback(D);break;case"request":this.requestCallback&&this.requestCallback(D);break;case"response":const _=D,I=this.pendingRequests.get(_.request_seq);I&&(this.pendingRequests.delete(_.request_seq),I(_));break}}}internalSend(D,_){_.type=D,_.seq=this.sequence++,this.sendMessage(_)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const D=new Map;this.pendingRequests.forEach((_,I)=>D.set(I,_)),await(0,i.timeout)(500),D.forEach((_,I)=>{_({type:"response",seq:0,request_seq:I,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(I)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=C}),define(ve[207],we([0,1,8,2,9,25,10]),function(J,e,m,i,y,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const D=/{([^}]+)}/g;function _(n,t,r){return n.replace(D,function(u,a){return t&&a.length>0&&a[0]!=="_"?u:r&&r.hasOwnProperty(a)?r[a]:u})}e.formatPII=_;function I(n){const t={};for(const r of Object.keys(n))r.startsWith("!")||(t[r]=n[r]);return t}e.filterExceptionsFromTelemetry=I;function L(n){return n.configuration.request==="attach"&&!A(n)&&(!n.parentSession||L(n.parentSession))}e.isSessionAttach=L;function A(n){let t=n.configuration.type;if(!!t)return t==="vslsShare"&&(t=n.configuration.adapterProxy.configuration.type),(0,m.equalsIgnoreCase)(t,"extensionhost")||(0,m.equalsIgnoreCase)(t,"pwa-extensionhost")?n:n.parentSession?A(n.parentSession):void 0}e.getExtensionHostDebugSession=A;function c(n){return n.type&&(n.label||n.program||n.runtime)}e.isDebuggerMainContribution=c;function E(n,t,r){let u,a=0,f=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,w=null;for(;w=f.exec(n);){let d=w.index+1,k=d+w[0].length;if(d<=t&&k>=r){u=w[0],a=d;break}}if(u){let d=/\w+/g,k=null;for(;(k=d.exec(u))&&!(k.index+1+a+k[0].length>=r););k&&(u=u.substring(0,d.lastIndex))}return u?{start:a,end:a+u.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=E;const h=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function p(n){return!!(n&&n.match(h))}e.isUri=p;function v(n){if(typeof n.path=="string"&&!(typeof n.sourceReference=="number"&&n.sourceReference>0)){if(p(n.path))return i.URI.parse(n.path);if((0,y.isAbsolute)(n.path))return i.URI.file(n.path)}return n.path}function T(n){if(typeof n.path=="object"){const t=i.URI.revive(n.path);if(t)return t.scheme===P.Schemas.file?t.fsPath:t.toString()}return n.path}function b(n,t){const r=t?v:T,u=(0,C.deepClone)(n);return s(u,(a,f)=>{a&&f&&(f.path=r(f))}),u}e.convertToDAPaths=b;function o(n,t){const r=t?v:T,u=(0,C.deepClone)(n);return s(u,(a,f)=>{!a&&f&&(f.path=r(f))}),u}e.convertToVSCPaths=o;function s(n,t){switch(n.type){case"event":const r=n;switch(r.event){case"output":t(!1,r.body.source);break;case"loadedSource":t(!1,r.body.source);break;case"breakpoint":t(!1,r.body.breakpoint.source);break;default:break}break;case"request":const u=n;switch(u.command){case"setBreakpoints":t(!0,u.arguments.source);break;case"breakpointLocations":t(!0,u.arguments.source);break;case"source":t(!0,u.arguments.source);break;case"gotoTargets":t(!0,u.arguments.source);break;case"launchVSCode":u.arguments.args.forEach(f=>t(!1,f));break;default:break}break;case"response":const a=n;if(a.success&&a.body)switch(a.command){case"stackTrace":a.body.stackFrames.forEach(f=>t(!1,f.source));break;case"loadedSources":a.body.sources.forEach(f=>t(!1,f));break;case"scopes":a.body.scopes.forEach(f=>t(!1,f.source));break;case"setFunctionBreakpoints":a.body.breakpoints.forEach(f=>t(!1,f.source));break;case"setBreakpoints":a.body.breakpoints.forEach(f=>t(!1,f.source));break;default:break}break}}function g(n){return n.filter(t=>!t.presentation?.hidden).sort((t,r)=>t.presentation?r.presentation?t.presentation.group?r.presentation.group?t.presentation.group!==r.presentation.group?t.presentation.group.localeCompare(r.presentation.group):l(t.presentation.order,r.presentation.order):-1:r.presentation.group?1:l(t.presentation.order,r.presentation.order):-1:r.presentation?1:0)}e.getVisibleAndSorted=g;function l(n,t){return typeof n!="number"?typeof t!="number"?0:1:typeof t!="number"?-1:n-t}async function S(n,t){const r=n.getValue("debug.saveBeforeStart",{overrideIdentifier:t.activeTextEditorMode});if(r!=="none"&&(await t.saveAll(),r==="allEditorsInActiveGroup")){const u=t.activeEditorPane;u&&await t.save({editor:u.input,groupId:u.group.id})}await n.reloadConfiguration()}e.saveAllBeforeDebugStart=S}),define(ve[208],we([0,1,28,37,173,124,9,8,25,12,183,123]),function(J,e,m,i,y,C,P,D,_,I,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class c extends A.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(b,o){this.outputStream=o,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,b.on("data",s=>this.handleData(s))}sendMessage(b){if(this.outputStream){const o=JSON.stringify(b);this.outputStream.write(`Content-Length: ${Buffer.byteLength(o,"utf8")}${c.TWO_CRLF}${o}`,"utf8")}}handleData(b){for(this.rawData=Buffer.concat([this.rawData,b]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const o=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,o.length>0)try{this.acceptMessage(JSON.parse(o))}catch(s){this._onError.fire(new Error((s.message||s)+`
`+o))}continue}}else{const o=this.rawData.indexOf(c.TWO_CRLF);if(o!==-1){const g=this.rawData.toString("utf8",0,o).split(c.HEADER_LINESEPARATOR);for(const l of g){const S=l.split(c.HEADER_FIELDSEPARATOR);S[0]==="Content-Length"&&(this.contentLength=Number(S[1]))}this.rawData=this.rawData.slice(o+c.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=c,c.TWO_CRLF=`\r
\r
`,c.HEADER_LINESEPARATOR=/\r?\n/,c.HEADER_FIELDSEPARATOR=/: */;class E extends c{startSession(){return new Promise((b,o)=>{let s=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),b(),s=!0}),this.socket.on("close",()=>{s?this._onError.fire(new Error("connection closed")):o(new Error("connection closed"))}),this.socket.on("error",g=>{s?this._onError.fire(g):o(g)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=E;class h extends E{constructor(b){super();this.adapterServer=b}createConnection(b){return C.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",b)}}e.SocketDebugAdapter=h;class p extends E{constructor(b){super();this.adapterServer=b}createConnection(b){return C.createConnection(this.adapterServer.path,b)}}e.NamedPipeDebugAdapter=p;class v extends c{constructor(b,o,s){super();this.adapterExecutable=b,this.debugType=o,this.outputService=s}async startSession(){const b=this.adapterExecutable.command,o=this.adapterExecutable.args,s=this.adapterExecutable.options||{};try{if(b)if(P.isAbsolute(b)){if(!await m.Promises.exists(b))throw new Error(y.localize(0,null,b))}else b.indexOf("/")<0&&b.indexOf("\\")<0;else throw new Error(y.localize(1,null,this.debugType));let g=process.env;if(s.env&&Object.keys(s.env).length>0&&(g=_.mixin(_.deepClone(process.env),s.env)),b==="node")if(Array.isArray(o)&&o.length>0){const S=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,n={env:g,execArgv:S?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};s.cwd&&(n.cwd=s.cwd);const t=i.fork(o[0],o.slice(1),n);if(!t.pid)throw new Error(y.localize(2,null,o[0]));this.serverProcess=t}else throw new Error(y.localize(3,null));else{const S={env:g};s.cwd&&(S.cwd=s.cwd),this.serverProcess=i.spawn(b,o,S)}this.serverProcess.on("error",S=>{this._onError.fire(S)}),this.serverProcess.on("exit",(S,n)=>{this._onExit.fire(S)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",S=>{this._onError.fire(S)}),this.serverProcess.stdin.on("error",S=>{this._onError.fire(S)});const l=this.outputService;if(l){const S=n=>n.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",n=>{const t=l.getChannel(L.ExtensionsChannelId);t&&t.append(S(n))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(g){this._onError.fire(g)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),I.isWindows?new Promise((b,o)=>{const s=i.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(g,l,S){if(g)return o(g)});s.on("exit",b),s.on("error",o)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(b,o){if(!b)return;const s=Object.create(null);b.runtime&&(b.runtime.indexOf("./")===0?s.runtime=P.join(o,b.runtime):s.runtime=b.runtime),b.runtimeArgs&&(s.runtimeArgs=b.runtimeArgs),b.program&&(P.isAbsolute(b.program)?s.program=b.program:s.program=P.join(o,b.program)),b.args&&(s.args=b.args);const g=b;return g.win&&(s.win=v.extract(g.win,o)),g.winx86&&(s.winx86=v.extract(g.winx86,o)),g.windows&&(s.windows=v.extract(g.windows,o)),g.osx&&(s.osx=v.extract(g.osx,o)),g.linux&&(s.linux=v.extract(g.linux,o)),s}static platformAdapterExecutable(b,o){let s=Object.create(null);o=o.toLowerCase();for(const r of b)if(r.contributes){const u=r.contributes.debuggers;u&&u.length>0&&u.filter(a=>typeof a.type=="string"&&D.equalsIgnoreCase(a.type,o)).forEach(a=>{const f=v.extract(a,r.extensionLocation.fsPath);s=_.mixin(s,f,r.isBuiltin)})}let g;I.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?g=s.winx86||s.win||s.windows:I.isWindows?g=s.win||s.windows:I.isMacintosh?g=s.osx:I.isLinux&&(g=s.linux),g=g||s;let l=g.program||s.program;const S=g.args||s.args;let n=g.runtime||s.runtime;const t=g.runtimeArgs||s.runtimeArgs;if(n)return{type:"executable",command:n,args:(t||[]).concat(typeof l=="string"?[l]:[]).concat(S||[])};if(l)return{type:"executable",command:l,args:S||[]}}}e.ExecutableDebugAdapter=v}),define(ve[209],we([0,1,37,12,30,185]),function(J,e,m,i,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=e.runInExternalTerminal=void 0;function P(c,E){return new Promise((h,p)=>{let v="";const T=m.spawn(c,E);T.pid&&T.stdout.on("data",b=>{v+=b.toString()}),T.on("error",b=>{p(b)}),T.on("close",b=>{h(v)})})}let D;function _(c,E){if(!D)if(i.isWindows)D=new C.WindowsExternalTerminalService;else if(i.isMacintosh)D=new C.MacExternalTerminalService;else if(i.isLinux)D=new C.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const h=E.getConfiguration("terminal");return D.runInTerminal(c.title,c.cwd,c.args,c.env||{},h.external||{})}e.runInExternalTerminal=_;async function I(c){if(c)if(i.isWindows){const E=await new Promise((h,p)=>{J(["windows-process-tree"],h,p)});return new Promise(h=>{E.getProcessTree(c,p=>{h(p.children.length>0)})})}else return P("/usr/bin/pgrep",["-lP",String(c)]).then(E=>{const h=E.trim();return!(h.length===0||h.indexOf(" tmux")>=0)},E=>!0);return Promise.resolve(!0)}e.hasChildProcesses=I;var L;(function(c){c[c.cmd=0]="cmd",c[c.powershell=1]="powershell",c[c.bash=2]="bash"})(L||(L={}));function A(c,E,h,p){c=c.trim().toLowerCase();let v;c.indexOf("powershell")>=0||c.indexOf("pwsh")>=0?v=1:c.indexOf("cmd.exe")>=0?v=0:c.indexOf("bash")>=0?v=2:i.isWindows?v=0:v=2;let T,b=" ";switch(v){case 1:if(T=s=>(s=s.replace(/\'/g,"''"),s.length>0&&s.charAt(s.length-1)==="\\"?`'${s}\\'`:`'${s}'`),h){const s=(0,y.getDriveLetter)(h);s&&(b+=`${s}:; `),b+=`cd ${T(h)}; `}if(p)for(let s in p){const g=p[s];g===null?b+=`Remove-Item env:${s}; `:b+=`\${env:${s}}='${g}'; `}if(E.length>0){const s=T(E.shift());b+=s[0]==="'"?`& ${s} `:`${s} `;for(let g of E)b+=`${T(g)} `}break;case 0:if(T=s=>(s=s.replace(/\"/g,'""'),s.indexOf(" ")>=0||s.indexOf('"')>=0||s.length===0?`"${s}"`:s),h){const s=(0,y.getDriveLetter)(h);s&&(b+=`${s}: && `),b+=`cd ${T(h)} && `}if(p){b+='cmd /C "';for(let s in p){let g=p[s];g===null?b+=`set "${s}=" && `:(g=g.replace(/[\^\&\|\<\>]/g,l=>`^${l}`),b+=`set "${s}=${g}" && `)}}for(let s of E)b+=`${T(s)} `;p&&(b+='"');break;case 2:T=s=>(s=s.replace(/(["'\\\$])/g,"\\$1"),s.indexOf(" ")>=0||s.indexOf(";")>=0||s.length===0?`"${s}"`:s);const o=s=>/[^\w@%\/+=,.:^-]/.test(s)?`'${s.replace(/'/g,"'\\''")}'`:s;if(h&&(b+=`cd ${T(h)} ; `),p){b+="/usr/bin/env";for(let s in p){const g=p[s];g===null?b+=` -u ${o(s)}`:b+=` ${o(`${s}=${g}`)}`}b+=" "}for(let s of E)b+=`${T(s)} `;break}return b}e.prepareCommand=A}),define(ve[125],we([0,1,31,77,101,10,9,12,61]),function(J,e,m,i,y,C,P,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var I;(function(d){d[d.Markup=1]="Markup",d[d.Code=2]="Code"})(I=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",y.Mimes.latex,y.Mimes.markdown,"image/png","image/jpeg",y.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[y.Mimes.latex,y.Mimes.markdown,"application/json",y.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var L;(function(d){d[d.Running=1]="Running",d[d.Idle=2]="Idle"})(L=e.NotebookRunState||(e.NotebookRunState={}));var A;(function(d){d[d.Pending=2]="Pending",d[d.Executing=3]="Executing"})(A=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var c;(function(d){d[d.WithHardKernelDependency=0]="WithHardKernelDependency",d[d.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",d[d.Pure=2]="Pure",d[d.Never=3]="Never"})(c=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var E;(function(d){d.Always="always",d.Never="never",d.Optional="optional"})(E=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var h;(function(d){d[d.ModelChange=1]="ModelChange",d[d.Move=2]="Move",d[d.ChangeLanguage=5]="ChangeLanguage",d[d.Initialize=6]="Initialize",d[d.ChangeCellMetadata=7]="ChangeCellMetadata",d[d.Output=8]="Output",d[d.OutputItem=9]="OutputItem",d[d.ChangeCellContent=10]="ChangeCellContent",d[d.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",d[d.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",d[d.ChangeCellMime=13]="ChangeCellMime",d[d.Unknown=100]="Unknown"})(h=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var p;(function(d){d[d.Handle=0]="Handle",d[d.Index=1]="Index"})(p=e.SelectionStateType||(e.SelectionStateType={}));var v;(function(d){d[d.Replace=1]="Replace",d[d.Output=2]="Output",d[d.Metadata=3]="Metadata",d[d.CellLanguage=4]="CellLanguage",d[d.DocumentMetadata=5]="DocumentMetadata",d[d.Move=6]="Move",d[d.OutputItems=7]="OutputItems",d[d.PartialMetadata=8]="PartialMetadata",d[d.PartialInternalMetadata=9]="PartialInternalMetadata"})(v=e.CellEditType||(e.CellEditType={}));var T;(function(d){d.scheme=C.Schemas.vscodeNotebookCell;const k=/^ch(\d{7,})/;function R(H,M){return H.with({scheme:d.scheme,fragment:`ch${M.toString().padStart(7,"0")}${H.scheme!==C.Schemas.file?H.scheme:""}`})}d.generate=R;function N(H){if(H.scheme!==d.scheme)return;const M=k.exec(H.fragment);return M?{handle:Number(M[1]),notebook:H.with({scheme:H.fragment.substr(M[0].length)||C.Schemas.file,fragment:null})}:void 0}d.parse=N;function x(H,M,W){return H.with({scheme:C.Schemas.vscodeNotebookCellOutput,fragment:`ch${M.toString().padStart(7,"0")},${W??""},${H.scheme!==C.Schemas.file?H.scheme:""}`})}d.generateCellOutputUri=x;function F(H){if(H.scheme!==C.Schemas.vscodeNotebookCellOutput)return;const M=/^ch(\d{7,})\,([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(H.fragment);if(!M)return;const W=Number(M[1]),z=M[2]&&M[2]!==""?M[2]:void 0,U=M[3];return{handle:W,outputId:z,notebook:H.with({scheme:U||C.Schemas.file,fragment:null})}}d.parseCellOutputUri=F;function B(H,M,W){return H.with({scheme:W,fragment:`ch${M.toString().padStart(7,"0")}${H.scheme!==C.Schemas.file?H.scheme:""}`})}d.generateCellUri=B;function O(H,M){if(H.scheme!==M)return;const W=k.exec(H.fragment);return W?{handle:Number(W[1]),notebook:H.with({scheme:H.fragment.substr(W[0].length)||C.Schemas.file,fragment:null})}:void 0}d.parseCellUri=O})(T=e.CellUri||(e.CellUri={}));const b=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[y.Mimes.latex,{alwaysSecure:!0,supportedByCore:!0}],[y.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function o(d){return b.get(d)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=o;function s(d){return b.get(d)?.supportedByCore??!1}e.mimeTypeSupportedByCore=s;function g(d){return b.get(d)?.mergeable??!1}e.mimeTypeIsMergeable=g;const l=d=>D.isWindows?d.replace(/\//g,"\\"):d;class S{constructor(k=[],R=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=R,this.order=[...new Set(k)].map(N=>({pattern:N,matches:m.parse(l(N))}))}sort(k){const R=new Map(i.Iterable.map(k,x=>[x,l(x)]));let N=[];for(const{matches:x}of this.order)for(const[F,B]of R)if(x(B)){N.push(F),R.delete(F);break}return R.size&&(N=N.concat([...R.keys()].sort((x,F)=>this.defaultOrder.indexOf(x)-this.defaultOrder.indexOf(F)))),N}prioritize(k,R){const N=this.findIndex(k);if(N===-1){this.order.unshift({pattern:k,matches:m.parse(l(k))});return}const x=new Set(R.map(B=>this.findIndex(B,N)));x.delete(-1);const F=Array.from(x).sort();this.order.splice(N+1,0,...F.map(B=>this.order[B]));for(let B=F.length-1;B>=0;B--)this.order.splice(F[B],1)}toArray(){return this.order.map(k=>k.pattern)}findIndex(k,R=this.order.length){const N=l(k);for(let x=0;x<R;x++)if(this.order[x].matches(N))return x;return-1}}e.MimeTypeDisplayOrder=S;function n(d,k,R,N=(x,F)=>x===F){const x=[];function F(H,M,W){if(M===0&&W.length===0)return;const z=x[x.length-1];z&&z.start+z.deleteCount===H?(z.deleteCount+=M,z.toInsert.push(...W)):x.push({start:H,deleteCount:M,toInsert:W})}let B=0,O=0;for(;;){if(B===d.length){F(B,0,k.slice(O));break}if(O===k.length){F(B,d.length-B,[]);break}const H=d[B],M=k[O];if(N(H,M)){B+=1,O+=1;continue}R(M)?(F(B,1,[]),B+=1):(F(B,0,[M]),O+=1)}return x}e.diff=n,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new _.RawContextKey("notebookEditorCursorAtBoundary","none");var t;(function(d){d.default="default",d.option="option"})(t=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function r(d){const k=d;return!!((typeof k.include=="string"||m.isRelativePattern(k.include))&&(typeof k.exclude=="string"||m.isRelativePattern(k.exclude)))}e.isDocumentExcludePattern=r;function u(d,k,R){if(Array.isArray(d.viewType)&&d.viewType.indexOf(k)>=0||d.viewType===k)return!0;if(d.filenamePattern){let N=r(d.filenamePattern)?d.filenamePattern.include:d.filenamePattern,x=r(d.filenamePattern)?d.filenamePattern.exclude:void 0;if(m.match(N,(0,P.basename)(R.fsPath).toLowerCase()))return!(x&&m.match(x,(0,P.basename)(R.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=u;class a{constructor(k){this.textModel=k}getElements(){const k=new Int32Array(this.textModel.cells.length);for(let R=0;R<this.textModel.cells.length;R++)k[R]=this.textModel.cells[R].getHashValue();return k}}e.CellSequence=a,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize"};var f;(function(d){d[d.Left=1]="Left",d[d.Right=2]="Right"})(f=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class w{static create(k){return`${w._prefix}${k}`}static parse(k){if(k.startsWith(w._prefix))return k.substr(w._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=w,w._prefix="notebook/"}),define(ve[210],we([0,1,4]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var i;(function(y){y[y.Output=1]="Output",y[y.OutputItems=2]="OutputItems",y[y.ExecutionState=3]="ExecutionState",y[y.Complete=4]="Complete"})(i=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,m.createDecorator)("INotebookExecutionService")}),define(ve[211],we([0,1,4,61]),function(J,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new i.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new i.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new i.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,m.createDecorator)(e.OUTPUT_SERVICE_ID);var y;(function(C){C[C.Append=1]="Append",C[C.Replace=2]="Replace",C[C.Clear=3]="Clear"})(y=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={}))}),define(ve[212],we([0,1,175,4,61]),function(J,e,m,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new y.RawContextKey("customExecutionSupported",!0,m.localize(0,null)),e.ShellExecutionSupportedContext=new y.RawContextKey("shellExecutionSupported",!1,m.localize(1,null)),e.ProcessExecutionSupportedContext=new y.RawContextKey("processExecutionSupported",!1,m.localize(2,null)),e.ITaskService=(0,i.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(ve[213],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function m(y){return[...y.entries()]}e.serializeEnvironmentVariableCollection=m;function i(y){return new Map(y)}e.deserializeEnvironmentVariableCollection=i}),define(ve[126],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.TestMessageType=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var m;(function(A){A[A.Unset=0]="Unset",A[A.Queued=1]="Queued",A[A.Running=2]="Running",A[A.Passed=3]="Passed",A[A.Failed=4]="Failed",A[A.Skipped=5]="Skipped",A[A.Errored=6]="Errored"})(m=e.TestResultState||(e.TestResultState={}));var i;(function(A){A[A.Run=2]="Run",A[A.Debug=4]="Debug",A[A.Coverage=8]="Coverage",A[A.HasNonDefaultProfile=16]="HasNonDefaultProfile",A[A.HasConfigurable=32]="HasConfigurable"})(i=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var y;(function(A){A[A.Error=0]="Error",A[A.Info=1]="Info"})(y=e.TestMessageType||(e.TestMessageType={}));var C;(function(A){A[A.NotExpandable=0]="NotExpandable",A[A.Expandable=1]="Expandable",A[A.BusyExpanding=2]="BusyExpanding",A[A.Expanded=3]="Expanded"})(C=e.TestItemExpandState||(e.TestItemExpandState={}));const P=(A,c)=>{c.expand!==void 0&&(A.expand=c.expand),c.item!==void 0&&(A.item=A.item?Object.assign(A.item,c.item):c.item)};e.applyTestItemUpdate=P;var D;(function(A){A[A.Function=0]="Function",A[A.Statement=1]="Statement"})(D=e.DetailType||(e.DetailType={}));var _;(function(A){A[A.Add=0]="Add",A[A.Update=1]="Update",A[A.Remove=2]="Remove",A[A.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",A[A.Retire=4]="Retire",A[A.AddTag=5]="AddTag",A[A.RemoveTag=6]="RemoveTag"})(_=e.TestDiffOpType||(e.TestDiffOpType={}));class I{add(c){}update(c){}remove(c,E){}complete(){}}e.IncrementalChangeCollector=I;class L{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(c){const E=this.createChangeCollector();for(const h of c)switch(h[0]){case 0:{const p=h[1];if(p.parent){if(this.items.has(p.parent)){const v=this.items.get(p.parent);v.children.add(p.item.extId);const T=this.createItem(p,v);this.items.set(p.item.extId,T),E.add(T)}}else{const v=this.createItem(p);this.roots.add(v),this.items.set(p.item.extId,v),E.add(v)}p.expand===2&&this.busyControllerCount++;break}case 1:{const p=h[1],v=this.items.get(p.extId);if(!v)break;p.expand!==void 0&&(v.expand===2&&this.busyControllerCount--,p.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(v,p),E.update(v);break}case 2:{const p=this.items.get(h[1]);if(!p)break;p.parent?this.items.get(p.parent).children.delete(p.item.extId):this.roots.delete(p);const v=[[h[1]]];for(;v.length;)for(const T of v.pop()){const b=this.items.get(T);b&&(v.push(b.children),this.items.delete(T),E.remove(b,b!==p),b.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(h[1]);break;case 3:this.updatePendingRoots(h[1]);break;case 5:this._tags.set(h[1].id,h[1]);break;case 6:this._tags.delete(h[1]);break}E.complete()}retireTest(c){}updatePendingRoots(c){this.pendingRootCount+=c}createChangeCollector(){return new I}}e.AbstractIncrementalTestCollection=L}),define(ve[89],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var m;(function(C){C.Delimiter="\0"})(m=e.TestIdPathParts||(e.TestIdPathParts={}));var i;(function(C){C[C.IsSame=0]="IsSame",C[C.Disconnected=1]="Disconnected",C[C.IsChild=2]="IsChild",C[C.IsParent=3]="IsParent"})(i=e.TestPosition||(e.TestPosition={}));class y{constructor(P,D=P.length){if(this.path=P,this.viewEnd=D,P.length===0||D<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(P,D,_=P.parent){if(P.id===D)return new y([D]);let I=[P.id];for(let L=_;L&&L.id!==D;L=L.parent)I.push(L.id);return I.push(D),new y(I.reverse())}static isRoot(P){return!P.includes("\0")}static fromString(P){return new y(P.split("\0"))}static join(P,D){return new y([...P.path,D])}static joinToString(P,D){return P.toString()+"\0"+D}static compare(P,D){return P===D?0:D.startsWith(P+"\0")?2:P.startsWith(D+"\0")?3:1}get parentId(){return this.viewEnd>1?new y(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let P=1;P<=this.viewEnd;P++)yield new y(this.path,P)}compare(P){if(typeof P=="string")return y.compare(this.toString(),P);for(let D=0;D<P.viewEnd&&D<this.viewEnd;D++)if(P.path[D]!==this.path[D])return 1;return P.viewEnd>this.viewEnd?2:P.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let P=1;P<this.viewEnd;P++)this.stringifed+="\0",this.stringifed+=this.path[P]}return this.stringifed}}e.TestId=y}),define(ve[214],we([0,1,9,40,13,25,12,80,176]),function(J,e,m,i,y,C,P,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class I{constructor(A,c,E){this._contributedVariables=new Map,this._context=A,this._labelService=c,E&&(this._envVariablesPromise=E.then(h=>this.prepareEnv(h)))}prepareEnv(A){if(P.isWindows){const c=Object.create(null);return Object.keys(A).forEach(E=>{c[E.toLowerCase()]=A[E]}),c}return A}resolveWithEnvironment(A,c,E){return this.recursiveResolve(this.prepareEnv(A),c?c.uri:void 0,E)}async resolveAsync(A,c){return this.recursiveResolve(await this._envVariablesPromise,A?A.uri:void 0,c)}async resolveAnyBase(A,c,E,h){const p=C.deepClone(c);return P.isWindows&&p.windows?Object.keys(p.windows).forEach(v=>p[v]=p.windows[v]):P.isMacintosh&&p.osx?Object.keys(p.osx).forEach(v=>p[v]=p.osx[v]):P.isLinux&&p.linux&&Object.keys(p.linux).forEach(v=>p[v]=p.linux[v]),delete p.windows,delete p.osx,delete p.linux,this.recursiveResolve(await this._envVariablesPromise,A?A.uri:void 0,p,E,h)}async resolveAnyAsync(A,c,E){return this.resolveAnyBase(A,c,E)}async resolveAnyMap(A,c,E){const h=new Map;return{newConfig:await this.resolveAnyBase(A,c,E,h),resolvedVariables:h}}resolveWithInteractionReplace(A,c,E,h){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(A,c,E,h){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(A,c){if(this._contributedVariables.has(A))throw new Error("Variable "+A+" is contributed twice.");this._contributedVariables.set(A,c)}recursiveResolve(A,c,E,h,p){if(y.isString(E))return this.resolveString(A,c,E,h,p);if(y.isArray(E))return E.map(v=>this.recursiveResolve(A,c,v,h,p));if(y.isObject(E)){let v=Object.create(null);return Object.keys(E).forEach(T=>{const b=this.resolveString(A,c,T,h,p);v[b]=this.recursiveResolve(A,c,E[T],h,p)}),v}return E}resolveString(A,c,E,h,p){return E.replace(I.VARIABLE_REGEXP,(T,b)=>{if(b.includes(I.VARIABLE_LHS))return T;let o=this.evaluateSingleVariable(A,T,b,c,h);return p&&p.set(b,o),o!==T&&y.isString(o)&&o.match(I.VARIABLE_REGEXP)&&(o=this.resolveString(A,c,o,h,p)),o})}fsPath(A){return this._labelService?this._labelService.getUriLabel(A,{noPrefix:!0}):A.fsPath}evaluateSingleVariable(A,c,E,h,p){let v;const T=E.split(":");T.length>1&&(E=T[0],v=T[1]);const b=()=>{const g=this._context.getFilePath();if(g)return g;throw new Error((0,_.localize)(0,null,c))},o=()=>{const g=b();if(this._context.getWorkspaceFolderPathForFile){const l=this._context.getWorkspaceFolderPathForFile();if(l)return l}throw new Error((0,_.localize)(1,null,c,m.basename(g)))},s=()=>{if(v){const g=this._context.getFolderUri(v);if(g)return g;throw new Error((0,_.localize)(2,null,c,v))}if(h)return h;throw this._context.getWorkspaceFolderCount()>1?new Error((0,_.localize)(3,null,c)):new Error((0,_.localize)(4,null,c))};switch(E){case"env":if(v){if(A){const g=A[P.isWindows?v.toLowerCase():v];if(y.isString(g))return g}return""}throw new Error((0,_.localize)(5,null,c));case"config":if(v){const g=this._context.getConfigurationValue(h,v);if(y.isUndefinedOrNull(g))throw new Error((0,_.localize)(6,null,c,v));if(y.isObject(g))throw new Error((0,_.localize)(7,null,c,v));return g}throw new Error((0,_.localize)(8,null,c));case"command":return this.resolveFromMap(c,v,p,"command");case"input":return this.resolveFromMap(c,v,p,"input");default:switch(E){case"workspaceRoot":case"workspaceFolder":return(0,D.normalizeDriveLetter)(this.fsPath(s()));case"cwd":return h||v?(0,D.normalizeDriveLetter)(this.fsPath(s())):i.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return m.basename(this.fsPath(s()));case"lineNumber":const g=this._context.getLineNumber();if(g)return g;throw new Error((0,_.localize)(9,null,c));case"selectedText":const l=this._context.getSelectedText();if(l)return l;throw new Error((0,_.localize)(10,null,c));case"file":return b();case"fileWorkspaceFolder":return o();case"relativeFile":return h||v?m.relative(this.fsPath(s()),b()):b();case"relativeFileDirname":const S=m.dirname(b());if(h||v){const u=m.relative(this.fsPath(s()),S);return u.length===0?".":u}return S;case"fileDirname":return m.dirname(b());case"fileExtname":return m.extname(b());case"fileBasename":return m.basename(b());case"fileBasenameNoExtension":const n=m.basename(b());return n.slice(0,n.length-m.extname(n).length);case"fileDirnameBasename":return m.basename(m.dirname(b()));case"execPath":const t=this._context.getExecPath();return t||c;case"execInstallFolder":const r=this._context.getAppRoot();return r||c;case"pathSeparator":return m.sep;default:try{const u=v?`${E}:${v}`:E;return this.resolveFromMap(c,u,p,void 0)}catch{return c}}}}resolveFromMap(A,c,E,h){if(c&&E){const p=h===void 0?E[c]:E[h+":"+c];if(typeof p=="string")return p;throw new Error((0,_.localize)(11,null,A))}return A}}e.AbstractVariableResolverService=I,I.VARIABLE_LHS="${",I.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(ve[127],we([0,1,4,206]),function(J,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,m.createDecorator)("editorGroupsService");var y;(function(h){h[h.UP=0]="UP",h[h.DOWN=1]="DOWN",h[h.LEFT=2]="LEFT",h[h.RIGHT=3]="RIGHT"})(y=e.GroupDirection||(e.GroupDirection={}));var C;(function(h){h[h.HORIZONTAL=0]="HORIZONTAL",h[h.VERTICAL=1]="VERTICAL"})(C=e.GroupOrientation||(e.GroupOrientation={}));var P;(function(h){h[h.FIRST=0]="FIRST",h[h.LAST=1]="LAST",h[h.NEXT=2]="NEXT",h[h.PREVIOUS=3]="PREVIOUS"})(P=e.GroupLocation||(e.GroupLocation={}));var D;(function(h){h[h.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",h[h.EVEN=1]="EVEN",h[h.TOGGLE=2]="TOGGLE"})(D=e.GroupsArrangement||(e.GroupsArrangement={}));var _;(function(h){h[h.COPY_EDITORS=0]="COPY_EDITORS",h[h.MOVE_EDITORS=1]="MOVE_EDITORS"})(_=e.MergeGroupMode||(e.MergeGroupMode={}));function I(h){const p=h;return(0,i.isEditorInput)(p?.editor)&&(0,i.isEditorInput)(p?.replacement)}e.isEditorReplacement=I;var L;(function(h){h[h.CREATION_TIME=0]="CREATION_TIME",h[h.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",h[h.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(L=e.GroupsOrder||(e.GroupsOrder={}));var A;(function(h){h[h.NEW_EDITOR=1]="NEW_EDITOR",h[h.MOVE_EDITOR=2]="MOVE_EDITOR",h[h.COPY_EDITOR=3]="COPY_EDITOR"})(A=e.OpenEditorContext||(e.OpenEditorContext={}));function c(h){const p=h;return!!p&&typeof p.id=="number"&&Array.isArray(p.editors)}e.isEditorGroup=c;function E(h){return h.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=E}),define(ve[215],we([0,1,4,127]),function(J,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,m.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function y(C){const P=C;return typeof C=="number"||(0,i.isEditorGroup)(P)}e.isPreferredGroup=y}),define(ve[17],we([0,1,16,22,97,290,59,25,13,2,41,84,177,116,63,125,89,215,7]),function(J,e,m,i,y,C,P,D,_,I,L,A,c,E,h,p,v,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var o;(function(he){function De(X){const{selectionStartLineNumber:ke,selectionStartColumn:Le,positionLineNumber:Ze,positionColumn:qe}=X,dt=new b.Position(ke-1,Le-1),wt=new b.Position(Ze-1,qe-1);return new b.Selection(dt,wt)}he.to=De;function le(X){const{anchor:ke,active:Le}=X;return{selectionStartLineNumber:ke.line+1,selectionStartColumn:ke.character+1,positionLineNumber:Le.line+1,positionColumn:Le.character+1}}he.from=le})(o=e.Selection||(e.Selection={}));var s;(function(he){function De(X){if(!X)return;const{start:ke,end:Le}=X;return{startLineNumber:ke.line+1,startColumn:ke.character+1,endLineNumber:Le.line+1,endColumn:Le.character+1}}he.from=De;function le(X){if(!X)return;const{startLineNumber:ke,startColumn:Le,endLineNumber:Ze,endColumn:qe}=X;return new b.Range(ke-1,Le-1,Ze-1,qe-1)}he.to=le})(s=e.Range||(e.Range={}));var g;(function(he){function De(le){switch(le){case 1:return b.StandardTokenType.Comment;case 0:return b.StandardTokenType.Other;case 4:return b.StandardTokenType.RegEx;case 2:return b.StandardTokenType.String}}he.to=De})(g=e.TokenType||(e.TokenType={}));var l;(function(he){function De(X){return new b.Position(X.lineNumber-1,X.column-1)}he.to=De;function le(X){return{lineNumber:X.line+1,column:X.character+1}}he.from=le})(l=e.Position||(e.Position={}));var S;(function(he){function De(ke,Le){return(0,m.coalesce)((0,m.asArray)(ke).map(Ze=>le(Ze,Le)))}he.from=De;function le(ke,Le){if(typeof ke=="string")return{$serialized:!0,language:ke};if(ke)return{$serialized:!0,language:ke.language,scheme:X(ke.scheme,Le),pattern:typeof ke.pattern=="undefined"?void 0:ee.from(ke.pattern),exclusive:ke.exclusive}}function X(ke,Le){return Le&&typeof ke=="string"?Le.transformOutgoingScheme(ke):ke}})(S=e.DocumentSelector||(e.DocumentSelector={}));var n;(function(he){function De(X){switch(X){case b.DiagnosticTag.Unnecessary:return 1;case b.DiagnosticTag.Deprecated:return 2}}he.from=De;function le(X){switch(X){case 1:return b.DiagnosticTag.Unnecessary;case 2:return b.DiagnosticTag.Deprecated;default:return}}he.to=le})(n=e.DiagnosticTag||(e.DiagnosticTag={}));var t;(function(he){function De(X){let ke;return X.code&&((0,_.isString)(X.code)||(0,_.isNumber)(X.code)?ke=String(X.code):ke={value:String(X.code.value),target:X.code.target}),{...s.from(X.range),message:X.message,source:X.source,code:ke,severity:u.from(X.severity),relatedInformation:X.relatedInformation&&X.relatedInformation.map(r.from),tags:Array.isArray(X.tags)?(0,m.coalesce)(X.tags.map(n.from)):void 0}}he.from=De;function le(X){const ke=new b.Diagnostic(s.to(X),X.message,u.to(X.severity));return ke.source=X.source,ke.code=(0,_.isString)(X.code)?X.code:X.code?.value,ke.relatedInformation=X.relatedInformation&&X.relatedInformation.map(r.to),ke.tags=X.tags&&(0,m.coalesce)(X.tags.map(n.to)),ke}he.to=le})(t=e.Diagnostic||(e.Diagnostic={}));var r;(function(he){function De(X){return{...s.from(X.location.range),message:X.message,resource:X.location.uri}}he.from=De;function le(X){return new b.DiagnosticRelatedInformation(new b.Location(X.resource,s.to(X)),X.message)}he.to=le})(r=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var u;(function(he){function De(X){switch(X){case b.DiagnosticSeverity.Error:return E.MarkerSeverity.Error;case b.DiagnosticSeverity.Warning:return E.MarkerSeverity.Warning;case b.DiagnosticSeverity.Information:return E.MarkerSeverity.Info;case b.DiagnosticSeverity.Hint:return E.MarkerSeverity.Hint}return E.MarkerSeverity.Error}he.from=De;function le(X){switch(X){case E.MarkerSeverity.Info:return b.DiagnosticSeverity.Information;case E.MarkerSeverity.Warning:return b.DiagnosticSeverity.Warning;case E.MarkerSeverity.Error:return b.DiagnosticSeverity.Error;case E.MarkerSeverity.Hint:return b.DiagnosticSeverity.Hint;default:return b.DiagnosticSeverity.Error}}he.to=le})(u=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var a;(function(he){function De(X){return typeof X=="number"&&X>=b.ViewColumn.One?X-1:X===b.ViewColumn.Beside?T.SIDE_GROUP:T.ACTIVE_GROUP}he.from=De;function le(X){if(typeof X=="number"&&X>=0)return X+1;throw new Error("invalid 'EditorGroupColumn'")}he.to=le})(a=e.ViewColumn||(e.ViewColumn={}));function f(he){return typeof he.range!="undefined"}function w(he){return he.length===0?!0:!!f(he[0])}e.isDecorationOptionsArr=w;var d;(function(he){function De(qe){return qe.map(he.from)}he.fromMany=De;function le(qe){return qe&&typeof qe=="object"&&typeof qe.language=="string"&&typeof qe.value=="string"}function X(qe){let dt;if(le(qe)){const{language:ft,value:vt}=qe;dt={value:"```"+ft+`
`+vt+"\n```\n"}}else b.MarkdownString.isMarkdownString(qe)?dt={value:qe.value,isTrusted:qe.isTrusted,supportThemeIcons:qe.supportThemeIcons,supportHtml:qe.supportHtml}:typeof qe=="string"?dt={value:qe}:dt={value:""};const wt=Object.create(null);dt.uris=wt;const yt=ft=>{try{let vt=I.URI.parse(ft,!0);vt=vt.with({query:ke(vt.query,wt)}),wt[ft]=vt}catch{}return""},bt=new C.Renderer;return bt.link=yt,bt.image=ft=>yt(y.parseHrefAndDimensions(ft).href),C(dt.value,{renderer:bt}),dt}he.from=X;function ke(qe,dt){if(!qe)return qe;let wt;try{wt=(0,P.parse)(qe)}catch{}if(!wt)return qe;let yt=!1;return wt=(0,D.cloneAndChange)(wt,bt=>{if(I.URI.isUri(bt)){const ft=`__uri_${Math.random().toString(16).slice(2,8)}`;return dt[ft]=bt,yt=!0,ft}else return}),yt?JSON.stringify(wt):qe}function Le(qe){const dt=new b.MarkdownString(qe.value,qe.supportThemeIcons);return dt.isTrusted=qe.isTrusted,dt.supportHtml=qe.supportHtml,dt}he.to=Le;function Ze(qe){if(!!qe)return typeof qe=="string"?qe:he.from(qe)}he.fromStrict=Ze})(d=e.MarkdownString||(e.MarkdownString={}));function k(he){return w(he)?he.map(De=>({range:s.from(De.range),hoverMessage:Array.isArray(De.hoverMessage)?d.fromMany(De.hoverMessage):De.hoverMessage?d.from(De.hoverMessage):void 0,renderOptions:De.renderOptions})):he.map(De=>({range:s.from(De)}))}e.fromRangeOrRangeWithMessage=k;function R(he){return typeof he=="undefined"?he:typeof he=="string"?I.URI.file(he):he}e.pathOrURIToURI=R;var N;(function(he){function De(le){return typeof le=="undefined"?le:{contentText:le.contentText,contentIconPath:le.contentIconPath?R(le.contentIconPath):void 0,border:le.border,borderColor:le.borderColor,fontStyle:le.fontStyle,fontWeight:le.fontWeight,textDecoration:le.textDecoration,color:le.color,backgroundColor:le.backgroundColor,margin:le.margin,width:le.width,height:le.height}}he.from=De})(N=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var x;(function(he){function De(le){return typeof le=="undefined"?le:{backgroundColor:le.backgroundColor,outline:le.outline,outlineColor:le.outlineColor,outlineStyle:le.outlineStyle,outlineWidth:le.outlineWidth,border:le.border,borderColor:le.borderColor,borderRadius:le.borderRadius,borderSpacing:le.borderSpacing,borderStyle:le.borderStyle,borderWidth:le.borderWidth,fontStyle:le.fontStyle,fontWeight:le.fontWeight,textDecoration:le.textDecoration,cursor:le.cursor,color:le.color,opacity:le.opacity,letterSpacing:le.letterSpacing,gutterIconPath:le.gutterIconPath?R(le.gutterIconPath):void 0,gutterIconSize:le.gutterIconSize,overviewRulerColor:le.overviewRulerColor,before:le.before?N.from(le.before):void 0,after:le.after?N.from(le.after):void 0}}he.from=De})(x=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var F;(function(he){function De(le){if(typeof le=="undefined")return le;switch(le){case b.DecorationRangeBehavior.OpenOpen:return 0;case b.DecorationRangeBehavior.ClosedClosed:return 1;case b.DecorationRangeBehavior.OpenClosed:return 2;case b.DecorationRangeBehavior.ClosedOpen:return 3}}he.from=De})(F=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var B;(function(he){function De(le){return{isWholeLine:le.isWholeLine,rangeBehavior:le.rangeBehavior?F.from(le.rangeBehavior):void 0,overviewRulerLane:le.overviewRulerLane,light:le.light?x.from(le.light):void 0,dark:le.dark?x.from(le.dark):void 0,backgroundColor:le.backgroundColor,outline:le.outline,outlineColor:le.outlineColor,outlineStyle:le.outlineStyle,outlineWidth:le.outlineWidth,border:le.border,borderColor:le.borderColor,borderRadius:le.borderRadius,borderSpacing:le.borderSpacing,borderStyle:le.borderStyle,borderWidth:le.borderWidth,fontStyle:le.fontStyle,fontWeight:le.fontWeight,textDecoration:le.textDecoration,cursor:le.cursor,color:le.color,opacity:le.opacity,letterSpacing:le.letterSpacing,gutterIconPath:le.gutterIconPath?R(le.gutterIconPath):void 0,gutterIconSize:le.gutterIconSize,overviewRulerColor:le.overviewRulerColor,before:le.before?N.from(le.before):void 0,after:le.after?N.from(le.after):void 0}}he.from=De})(B=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var O;(function(he){function De(X){return{text:X.newText,eol:X.newEol&&lt.from(X.newEol),range:s.from(X.range)}}he.from=De;function le(X){const ke=new b.TextEdit(s.to(X.range),X.text);return ke.newEol=typeof X.eol=="undefined"?void 0:lt.to(X.eol),ke}he.to=le})(O=e.TextEdit||(e.TextEdit={}));var H;(function(he){function De(X,ke,Le){const Ze={edits:[]};if(X instanceof b.WorkspaceEdit)for(let qe of X._allEntries())if(qe._type===1)Ze.edits.push({_type:1,oldUri:qe.from,newUri:qe.to,options:qe.options,metadata:qe.metadata});else if(qe._type===2){const dt=ke?.getDocument(qe.uri);Ze.edits.push({_type:2,resource:qe.uri,edit:O.from(qe.edit),modelVersionId:dt?.version,metadata:qe.metadata})}else qe._type===3?Ze.edits.push({_type:3,metadata:qe.metadata,resource:qe.uri,edit:qe.edit,notebookMetadata:qe.notebookMetadata,notebookVersionId:Le?.getNotebookDocument(qe.uri,!0)?.apiNotebook.version}):qe._type===5&&Ze.edits.push({_type:3,metadata:qe.metadata,resource:qe.uri,notebookVersionId:Le?.getNotebookDocument(qe.uri,!0)?.apiNotebook.version,edit:{editType:1,index:qe.index,count:qe.count,cells:qe.cells.map(Ue.from)}});return Ze}he.from=De;function le(X){const ke=new b.WorkspaceEdit;for(const Le of X.edits)Le.edit?ke.replace(I.URI.revive(Le.resource),s.to(Le.edit.range),Le.edit.text):ke.renameFile(I.URI.revive(Le.oldUri),I.URI.revive(Le.newUri),Le.options);return ke}he.to=le})(H=e.WorkspaceEdit||(e.WorkspaceEdit={}));var M;(function(he){const De=Object.create(null);De[b.SymbolKind.File]=0,De[b.SymbolKind.Module]=1,De[b.SymbolKind.Namespace]=2,De[b.SymbolKind.Package]=3,De[b.SymbolKind.Class]=4,De[b.SymbolKind.Method]=5,De[b.SymbolKind.Property]=6,De[b.SymbolKind.Field]=7,De[b.SymbolKind.Constructor]=8,De[b.SymbolKind.Enum]=9,De[b.SymbolKind.Interface]=10,De[b.SymbolKind.Function]=11,De[b.SymbolKind.Variable]=12,De[b.SymbolKind.Constant]=13,De[b.SymbolKind.String]=14,De[b.SymbolKind.Number]=15,De[b.SymbolKind.Boolean]=16,De[b.SymbolKind.Array]=17,De[b.SymbolKind.Object]=18,De[b.SymbolKind.Key]=19,De[b.SymbolKind.Null]=20,De[b.SymbolKind.EnumMember]=21,De[b.SymbolKind.Struct]=22,De[b.SymbolKind.Event]=23,De[b.SymbolKind.Operator]=24,De[b.SymbolKind.TypeParameter]=25;function le(ke){return typeof De[ke]=="number"?De[ke]:6}he.from=le;function X(ke){for(const Le in De)if(De[Le]===ke)return Number(Le);return b.SymbolKind.Property}he.to=X})(M=e.SymbolKind||(e.SymbolKind={}));var W;(function(he){function De(X){switch(X){case b.SymbolTag.Deprecated:return 1}}he.from=De;function le(X){switch(X){case 1:return b.SymbolTag.Deprecated}}he.to=le})(W=e.SymbolTag||(e.SymbolTag={}));var z;(function(he){function De(X){return{name:X.name,kind:M.from(X.kind),tags:X.tags&&X.tags.map(W.from),containerName:X.containerName,location:Q.from(X.location)}}he.from=De;function le(X){const ke=new b.SymbolInformation(X.name,M.to(X.kind),X.containerName,Q.to(X.location));return ke.tags=X.tags&&X.tags.map(W.to),ke}he.to=le})(z=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var U;(function(he){function De(X){const ke={name:X.name||"!!MISSING: name!!",detail:X.detail,range:s.from(X.range),selectionRange:s.from(X.selectionRange),kind:M.from(X.kind),tags:X.tags?.map(W.from)??[]};return X.children&&(ke.children=X.children.map(De)),ke}he.from=De;function le(X){const ke=new b.DocumentSymbol(X.name,X.detail,M.to(X.kind),s.to(X.range),s.to(X.selectionRange));return(0,m.isNonEmptyArray)(X.tags)&&(ke.tags=X.tags.map(W.to)),X.children&&(ke.children=X.children.map(le)),ke}he.to=le})(U=e.DocumentSymbol||(e.DocumentSymbol={}));var V;(function(he){function De(X){const ke=new b.CallHierarchyItem(M.to(X.kind),X.name,X.detail||"",I.URI.revive(X.uri),s.to(X.range),s.to(X.selectionRange));return ke._sessionId=X._sessionId,ke._itemId=X._itemId,ke}he.to=De;function le(X,ke,Le){if(ke=ke??X._sessionId,Le=Le??X._itemId,ke===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:ke,_itemId:Le,name:X.name,detail:X.detail,kind:M.from(X.kind),uri:X.uri,range:s.from(X.range),selectionRange:s.from(X.selectionRange),tags:X.tags?.map(W.from)}}he.from=le})(V=e.CallHierarchyItem||(e.CallHierarchyItem={}));var K;(function(he){function De(le){return new b.CallHierarchyIncomingCall(V.to(le.from),le.fromRanges.map(X=>s.to(X)))}he.to=De})(K=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var G;(function(he){function De(le){return new b.CallHierarchyOutgoingCall(V.to(le.to),le.fromRanges.map(X=>s.to(X)))}he.to=De})(G=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var Q;(function(he){function De(X){return{range:X.range&&s.from(X.range),uri:X.uri}}he.from=De;function le(X){return new b.Location(I.URI.revive(X.uri),s.to(X.range))}he.to=le})(Q=e.location||(e.location={}));var Y;(function(he){function De(X){const ke=X,Le=X;return{originSelectionRange:ke.originSelectionRange?s.from(ke.originSelectionRange):void 0,uri:ke.targetUri?ke.targetUri:Le.uri,range:s.from(ke.targetRange?ke.targetRange:Le.range),targetSelectionRange:ke.targetSelectionRange?s.from(ke.targetSelectionRange):void 0}}he.from=De;function le(X){return{targetUri:I.URI.revive(X.uri),targetRange:s.to(X.range),targetSelectionRange:X.targetSelectionRange?s.to(X.targetSelectionRange):void 0,originSelectionRange:X.originSelectionRange?s.to(X.originSelectionRange):void 0}}he.to=le})(Y=e.DefinitionLink||(e.DefinitionLink={}));var fe;(function(he){function De(X){return{range:s.from(X.range),contents:d.fromMany(X.contents)}}he.from=De;function le(X){return new b.Hover(X.contents.map(d.to),s.to(X.range))}he.to=le})(fe=e.Hover||(e.Hover={}));var me;(function(he){function De(X){return{range:s.from(X.range),expression:X.expression}}he.from=De;function le(X){return new b.EvaluatableExpression(s.to(X.range),X.expression)}he.to=le})(me=e.EvaluatableExpression||(e.EvaluatableExpression={}));var _e;(function(he){function De(X){if(X instanceof b.InlineValueText)return{type:"text",range:s.from(X.range),text:X.text};if(X instanceof b.InlineValueVariableLookup)return{type:"variable",range:s.from(X.range),variableName:X.variableName,caseSensitiveLookup:X.caseSensitiveLookup};if(X instanceof b.InlineValueEvaluatableExpression)return{type:"expression",range:s.from(X.range),expression:X.expression};throw new Error("Unknown 'InlineValue' type")}he.from=De;function le(X){switch(X.type){case"text":return{range:s.to(X.range),text:X.text};case"variable":return{range:s.to(X.range),variableName:X.variableName,caseSensitiveLookup:X.caseSensitiveLookup};case"expression":return{range:s.to(X.range),expression:X.expression}}}he.to=le})(_e=e.InlineValue||(e.InlineValue={}));var Ie;(function(he){function De(X){return{frameId:X.frameId,stoppedLocation:s.from(X.stoppedLocation)}}he.from=De;function le(X){return new b.InlineValueContext(X.frameId,s.to(X.stoppedLocation))}he.to=le})(Ie=e.InlineValueContext||(e.InlineValueContext={}));var Oe;(function(he){function De(X){return{range:s.from(X.range),kind:X.kind}}he.from=De;function le(X){return new b.DocumentHighlight(s.to(X.range),X.kind)}he.to=le})(Oe=e.DocumentHighlight||(e.DocumentHighlight={}));var We;(function(he){function De(le){switch(le){case 1:return b.CompletionTriggerKind.TriggerCharacter;case 2:return b.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return b.CompletionTriggerKind.Invoke}}he.to=De})(We=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var j;(function(he){function De(le){return{triggerKind:We.to(le.triggerKind),triggerCharacter:le.triggerCharacter}}he.to=De})(j=e.CompletionContext||(e.CompletionContext={}));var Z;(function(he){function De(X){switch(X){case b.CompletionItemTag.Deprecated:return 1}}he.from=De;function le(X){switch(X){case 1:return b.CompletionItemTag.Deprecated}}he.to=le})(Z=e.CompletionItemTag||(e.CompletionItemTag={}));var re;(function(he){const De=new Map([[b.CompletionItemKind.Method,0],[b.CompletionItemKind.Function,1],[b.CompletionItemKind.Constructor,2],[b.CompletionItemKind.Field,3],[b.CompletionItemKind.Variable,4],[b.CompletionItemKind.Class,5],[b.CompletionItemKind.Interface,7],[b.CompletionItemKind.Struct,6],[b.CompletionItemKind.Module,8],[b.CompletionItemKind.Property,9],[b.CompletionItemKind.Unit,12],[b.CompletionItemKind.Value,13],[b.CompletionItemKind.Constant,14],[b.CompletionItemKind.Enum,15],[b.CompletionItemKind.EnumMember,16],[b.CompletionItemKind.Keyword,17],[b.CompletionItemKind.Snippet,27],[b.CompletionItemKind.Text,18],[b.CompletionItemKind.Color,19],[b.CompletionItemKind.File,20],[b.CompletionItemKind.Reference,21],[b.CompletionItemKind.Folder,23],[b.CompletionItemKind.Event,10],[b.CompletionItemKind.Operator,11],[b.CompletionItemKind.TypeParameter,24],[b.CompletionItemKind.Issue,26],[b.CompletionItemKind.User,25]]);function le(Le){return De.get(Le)??9}he.from=le;const X=new Map([[0,b.CompletionItemKind.Method],[1,b.CompletionItemKind.Function],[2,b.CompletionItemKind.Constructor],[3,b.CompletionItemKind.Field],[4,b.CompletionItemKind.Variable],[5,b.CompletionItemKind.Class],[7,b.CompletionItemKind.Interface],[6,b.CompletionItemKind.Struct],[8,b.CompletionItemKind.Module],[9,b.CompletionItemKind.Property],[12,b.CompletionItemKind.Unit],[13,b.CompletionItemKind.Value],[14,b.CompletionItemKind.Constant],[15,b.CompletionItemKind.Enum],[16,b.CompletionItemKind.EnumMember],[17,b.CompletionItemKind.Keyword],[27,b.CompletionItemKind.Snippet],[18,b.CompletionItemKind.Text],[19,b.CompletionItemKind.Color],[20,b.CompletionItemKind.File],[21,b.CompletionItemKind.Reference],[23,b.CompletionItemKind.Folder],[10,b.CompletionItemKind.Event],[11,b.CompletionItemKind.Operator],[24,b.CompletionItemKind.TypeParameter],[25,b.CompletionItemKind.User],[26,b.CompletionItemKind.Issue]]);function ke(Le){return X.get(Le)??b.CompletionItemKind.Property}he.to=ke})(re=e.CompletionItemKind||(e.CompletionItemKind={}));var ue;(function(he){function De(le,X){const ke=new b.CompletionItem(le.label);return ke.insertText=le.insertText,ke.kind=re.to(le.kind),ke.tags=le.tags?.map(Z.to),ke.detail=le.detail,ke.documentation=y.isMarkdownString(le.documentation)?d.to(le.documentation):le.documentation,ke.sortText=le.sortText,ke.filterText=le.filterText,ke.preselect=le.preselect,ke.commitCharacters=le.commitCharacters,L.Range.isIRange(le.range)?ke.range=s.to(le.range):typeof le.range=="object"&&(ke.range={inserting:s.to(le.range.insert),replacing:s.to(le.range.replace)}),ke.keepWhitespace=typeof le.insertTextRules=="undefined"?!1:Boolean(le.insertTextRules&1),typeof le.insertTextRules!="undefined"&&le.insertTextRules&4?ke.insertText=new b.SnippetString(le.insertText):(ke.insertText=le.insertText,ke.textEdit=ke.range instanceof b.Range?new b.TextEdit(ke.range,ke.insertText):void 0),le.additionalTextEdits&&le.additionalTextEdits.length>0&&(ke.additionalTextEdits=le.additionalTextEdits.map(Le=>O.to(Le))),ke.command=X&&le.command?X.fromInternal(le.command):void 0,ke}he.to=De})(ue=e.CompletionItem||(e.CompletionItem={}));var te;(function(he){function De(X){return{label:X.label,documentation:X.documentation?d.fromStrict(X.documentation):void 0}}he.from=De;function le(X){return{label:X.label,documentation:y.isMarkdownString(X.documentation)?d.to(X.documentation):X.documentation}}he.to=le})(te=e.ParameterInformation||(e.ParameterInformation={}));var oe;(function(he){function De(X){return{label:X.label,documentation:X.documentation?d.fromStrict(X.documentation):void 0,parameters:Array.isArray(X.parameters)?X.parameters.map(te.from):[],activeParameter:X.activeParameter}}he.from=De;function le(X){return{label:X.label,documentation:y.isMarkdownString(X.documentation)?d.to(X.documentation):X.documentation,parameters:Array.isArray(X.parameters)?X.parameters.map(te.to):[],activeParameter:X.activeParameter}}he.to=le})(oe=e.SignatureInformation||(e.SignatureInformation={}));var Ee;(function(he){function De(X){return{activeSignature:X.activeSignature,activeParameter:X.activeParameter,signatures:Array.isArray(X.signatures)?X.signatures.map(oe.from):[]}}he.from=De;function le(X){return{activeSignature:X.activeSignature,activeParameter:X.activeParameter,signatures:Array.isArray(X.signatures)?X.signatures.map(oe.to):[]}}he.to=le})(Ee=e.SignatureHelp||(e.SignatureHelp={}));var Ne;(function(he){function De(X){return{text:X.text,position:l.from(X.position),kind:Ve.from(X.kind??b.InlayHintKind.Other),whitespaceBefore:X.whitespaceBefore,whitespaceAfter:X.whitespaceAfter}}he.from=De;function le(X){const ke=new b.InlayHint(X.text,l.to(X.position),Ve.to(X.kind));return ke.whitespaceAfter=X.whitespaceAfter,ke.whitespaceBefore=X.whitespaceBefore,ke}he.to=le})(Ne=e.InlayHint||(e.InlayHint={}));var Ve;(function(he){function De(X){return X}he.from=De;function le(X){return X}he.to=le})(Ve=e.InlayHintKind||(e.InlayHintKind={}));var Ge;(function(he){function De(X){return{range:s.from(X.range),url:X.target,tooltip:X.tooltip}}he.from=De;function le(X){let ke;if(X.url)try{ke=typeof X.url=="string"?I.URI.parse(X.url,!0):I.URI.revive(X.url)}catch{}return new b.DocumentLink(s.to(X.range),ke)}he.to=le})(Ge=e.DocumentLink||(e.DocumentLink={}));var Je;(function(he){function De(X){const ke=new b.ColorPresentation(X.label);return X.textEdit&&(ke.textEdit=O.to(X.textEdit)),X.additionalTextEdits&&(ke.additionalTextEdits=X.additionalTextEdits.map(Le=>O.to(Le))),ke}he.to=De;function le(X){return{label:X.label,textEdit:X.textEdit?O.from(X.textEdit):void 0,additionalTextEdits:X.additionalTextEdits?X.additionalTextEdits.map(ke=>O.from(ke)):void 0}}he.from=le})(Je=e.ColorPresentation||(e.ColorPresentation={}));var tt;(function(he){function De(X){return new b.Color(X[0],X[1],X[2],X[3])}he.to=De;function le(X){return[X.red,X.green,X.blue,X.alpha]}he.from=le})(tt=e.Color||(e.Color={}));var ot;(function(he){function De(X){return{range:s.from(X.range)}}he.from=De;function le(X){return new b.SelectionRange(s.to(X.range))}he.to=le})(ot=e.SelectionRange||(e.SelectionRange={}));var et;(function(he){function De(le){switch(le){case 2:return b.TextDocumentSaveReason.AfterDelay;case 1:return b.TextDocumentSaveReason.Manual;case 3:case 4:return b.TextDocumentSaveReason.FocusOut}}he.to=De})(et=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var it;(function(he){function De(X){switch(X){case b.TextEditorLineNumbersStyle.Off:return 0;case b.TextEditorLineNumbersStyle.Relative:return 2;case b.TextEditorLineNumbersStyle.On:default:return 1}}he.from=De;function le(X){switch(X){case 0:return b.TextEditorLineNumbersStyle.Off;case 2:return b.TextEditorLineNumbersStyle.Relative;case 1:default:return b.TextEditorLineNumbersStyle.On}}he.to=le})(it=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var lt;(function(he){function De(X){if(X===b.EndOfLine.CRLF)return 1;if(X===b.EndOfLine.LF)return 0}he.from=De;function le(X){if(X===1)return b.EndOfLine.CRLF;if(X===0)return b.EndOfLine.LF}he.to=le})(lt=e.EndOfLine||(e.EndOfLine={}));var pt;(function(he){function De(le){if(typeof le=="object")return le.viewId;switch(le){case b.ProgressLocation.SourceControl:return 3;case b.ProgressLocation.Window:return 10;case b.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}he.from=De})(pt=e.ProgressLocation||(e.ProgressLocation={}));var Pt;(function(he){function De(le){const X={start:le.start+1,end:le.end+1};return le.kind&&(X.kind=xe.from(le.kind)),X}he.from=De})(Pt=e.FoldingRange||(e.FoldingRange={}));var xe;(function(he){function De(le){if(le)switch(le){case b.FoldingRangeKind.Comment:return A.FoldingRangeKind.Comment;case b.FoldingRangeKind.Imports:return A.FoldingRangeKind.Imports;case b.FoldingRangeKind.Region:return A.FoldingRangeKind.Region}}he.from=De})(xe=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Rt;(function(he){function De(le){if(le)return{pinned:typeof le.preview=="boolean"?!le.preview:void 0,inactive:le.background,preserveFocus:le.preserveFocus,selection:typeof le.selection=="object"?s.from(le.selection):void 0,override:typeof le.override=="boolean"?c.EditorResolution.DISABLED:void 0}}he.from=De})(Rt=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var ee;(function(he){function De(X){return X instanceof b.RelativePattern||typeof X=="string"?X:le(X)?new b.RelativePattern(X.base,X.pattern):X}he.from=De;function le(X){const ke=X;return ke&&typeof ke.base=="string"&&typeof ke.pattern=="string"}})(ee=e.GlobPattern||(e.GlobPattern={}));var ne;(function(he){function De(le){if(le){if(Array.isArray(le))return le.map(De);if(typeof le=="string")return le;{const X=le;return{language:X.language,scheme:X.scheme,pattern:typeof X.pattern=="undefined"?void 0:ee.from(X.pattern),exclusive:X.exclusive}}}else return}he.from=De})(ne=e.LanguageSelector||(e.LanguageSelector={}));var pe;(function(he){function De(X){return{start:X.start,end:X.end}}he.from=De;function le(X){return new b.NotebookRange(X.start,X.end)}he.to=le})(pe=e.NotebookRange||(e.NotebookRange={}));var ie;(function(he){function De(X){return{timing:typeof X.runStartTime=="number"&&typeof X.runEndTime=="number"?{startTime:X.runStartTime,endTime:X.runEndTime}:void 0,executionOrder:X.executionOrder,success:X.lastRunSuccess}}he.to=De;function le(X){return{lastRunSuccess:X.success,runStartTime:X.timing?.startTime,runEndTime:X.timing?.endTime,executionOrder:X.executionOrder}}he.from=le})(ie=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Se;(function(he){function De(X){switch(X){case b.NotebookCellKind.Markup:return p.CellKind.Markup;case b.NotebookCellKind.Code:default:return p.CellKind.Code}}he.from=De;function le(X){switch(X){case p.CellKind.Markup:return b.NotebookCellKind.Markup;case p.CellKind.Code:default:return b.NotebookCellKind.Code}}he.to=le})(Se=e.NotebookCellKind||(e.NotebookCellKind={}));var Fe;(function(he){function De(X){const ke={metadata:X.metadata??Object.create(null),cells:[]};for(let Le of X.cells)b.NotebookCellData.validate(Le),ke.cells.push(Ue.from(Le));return ke}he.from=De;function le(X){const ke=new b.NotebookData(X.cells.map(Ue.to));return(0,_.isEmptyObject)(X.metadata)||(ke.metadata=X.metadata),ke}he.to=le})(Fe=e.NotebookData||(e.NotebookData={}));var Ue;(function(he){function De(X){return{cellKind:Se.from(X.kind),language:X.languageId,mime:X.mime,source:X.value,metadata:X.metadata,internalMetadata:ie.from(X.executionSummary??{}),outputs:X.outputs?X.outputs.map(Ae.from):[]}}he.from=De;function le(X){return new b.NotebookCellData(Se.to(X.cellKind),X.source,X.language,X.mime,X.outputs?X.outputs.map(Ae.to):void 0,X.metadata,X.internalMetadata?ie.to(X.internalMetadata):void 0)}he.to=le})(Ue=e.NotebookCellData||(e.NotebookCellData={}));var Xe;(function(he){function De(X){return{mime:X.mime,valueBytes:i.VSBuffer.wrap(X.data)}}he.from=De;function le(X){return new b.NotebookCellOutputItem(X.valueBytes.buffer,X.mime)}he.to=le})(Xe=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Ae;(function(he){function De(X){return{outputId:X.id,items:X.items.map(Xe.from),metadata:X.metadata}}he.from=De;function le(X){const ke=X.items.map(Xe.to);return new b.NotebookCellOutput(ke,X.outputId,X.metadata)}he.to=le})(Ae=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Pe;(function(he){function De(Le){if(Le!=null){if(Le instanceof b.RelativePattern||typeof Le=="string")return Le;if(ke(Le))return new b.RelativePattern(Le.base,Le.pattern);if(X(Le))return{include:ee.from(Le.include)||void 0,exclude:ee.from(Le.exclude)||void 0}}}he.from=De;function le(Le){return typeof Le=="string"?Le:ke(Le)?{base:Le.base,pattern:Le.pattern}:{include:Le.include,exclude:Le.exclude}}he.to=le;function X(Le){const Ze=Le,qe=ee.from(Ze.include);if(!(qe&&qe instanceof b.RelativePattern||typeof qe=="string"))return!1;const dt=ee.from(Ze.exclude);return!!(dt&&dt instanceof b.RelativePattern||typeof dt=="string")}function ke(Le){const Ze=Le;return Ze&&typeof Ze.base=="string"&&typeof Ze.pattern=="string"}})(Pe=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var ye;(function(he){function De(le){return{backgroundColor:le.backgroundColor,borderColor:le.borderColor,top:le.top?N.from(le.top):void 0}}he.from=De})(ye=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var ce;(function(he){function De(le,X,ke){const Le=typeof le.command=="string"?{title:"",command:le.command}:le.command;return{alignment:le.alignment===b.NotebookCellStatusBarAlignment.Left?1:2,command:X.toInternal(Le,ke),text:le.text,tooltip:le.tooltip,accessibilityInformation:le.accessibilityInformation,priority:le.priority}}he.from=De})(ce=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var de;(function(he){function De(le){return{transientOutputs:le?.transientOutputs??!1,transientCellMetadata:le?.transientCellMetadata??{},transientDocumentMetadata:le?.transientDocumentMetadata??{}}}he.from=De})(de=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var be;(function(he){function De(X){return{uri:X.uri,provides:X.provides}}he.from=De;function le(X){return new b.NotebookRendererScript(I.URI.revive(X.uri),X.provides)}he.to=le})(be=e.NotebookRendererScript||(e.NotebookRendererScript={}));var Ce;(function(he){function De(X){return{message:d.fromStrict(X.message)||"",type:0,expected:X.expectedOutput,actual:X.actualOutput,location:X.location?Q.from(X.location):void 0}}he.from=De;function le(X){const ke=new b.TestMessage(typeof X.message=="string"?X.message:d.to(X.message));return ke.actualOutput=X.actual,ke.expectedOutput=X.expected,ke.location=X.location?Q.to(X.location):void 0,ke}he.to=le})(Ce=e.TestMessage||(e.TestMessage={}));var Me;(function(he){let De;(function(le){le.Delimiter="\0"})(De||(De={})),he.namespace=(le,X)=>le+"\0"+X,he.denamespace=le=>{const X=le.indexOf("\0");return{ctrlId:le.slice(0,X),tagId:le.slice(X+1)}}})(Me=e.TestTag||(e.TestTag={}));var Ke;(function(he){function De(Le){const Ze=(0,h.getPrivateApiFor)(Le).controllerId;return{extId:v.TestId.fromExtHostTestItem(Le,Ze).toString(),label:Le.label,uri:Le.uri,tags:Le.tags.map(qe=>Me.namespace(Ze,qe.id)),range:s.from(Le.range)||null,description:Le.description||null,error:Le.error&&d.fromStrict(Le.error)||null}}he.from=De;function le(Le){return{parent:void 0,error:void 0,id:v.TestId.fromString(Le.extId).localId,label:Le.label,uri:I.URI.revive(Le.uri),tags:(Le.tags||[]).map(Ze=>{const{tagId:qe}=Me.denamespace(Ze);return new b.TestTag(qe)}),range:s.to(Le.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Le.description||void 0}}he.toPlain=le;function X(Le){const Ze=v.TestId.fromString(Le.extId),qe=new h.TestItemImpl(Ze.controllerId,Ze.localId,Le.label,I.URI.revive(Le.uri));return qe.range=s.to(Le.range||void 0),qe.description=Le.description||void 0,qe}function ke(Le){let Ze;for(const qe of Le.tests){const dt=X(qe.item);(0,h.getPrivateApiFor)(dt).parent=Ze,Ze=dt}return Ze}he.toItemFromContext=ke})(Ke=e.TestItem||(e.TestItem={})),function(he){function De(X){return{id:X.id}}he.from=De;function le(X){return new b.TestTag(X.id)}he.to=le}(Me=e.TestTag||(e.TestTag={}));var He;(function(he){const De=(X,ke)=>{const Le={...Ke.toPlain(X.item),parent:void 0,taskStates:X.tasks.map(Ze=>({state:Ze.state,duration:Ze.duration,messages:Ze.messages.filter(qe=>qe.type===0).map(Ce.to)})),children:X.children.map(Ze=>ke.get(Ze)).filter(_.isDefined).map(Ze=>De(Ze,ke))};for(const Ze of Le.children)Ze.parent=Le;return Le};function le(X){const ke=[],Le=new Map;for(const Ze of X.items)Le.set(Ze.item.extId,Ze),X.request.targets.some(qe=>qe.controllerId===Ze.controllerId&&qe.testIds.includes(Ze.item.extId))&&ke.push(Ze);return{completedAt:X.completedAt,results:ke.map(Ze=>De(Ze,Le))}}he.to=le})(He=e.TestResults||(e.TestResults={}));var Qe;(function(he){function De(Le){return{covered:Le.covered,total:Le.covered}}function le(Le){return"line"in Le?l.from(Le):s.from(Le)}function X(Le){return"branches"in Le?{count:Le.executionCount,location:le(Le.location),type:1,branches:Le.branches.length?Le.branches.map(Ze=>({count:Ze.executionCount,location:Ze.location&&le(Ze.location)})):void 0}:{type:0,count:Le.executionCount,location:le(Le.location)}}he.fromDetailed=X;function ke(Le){return{uri:Le.uri,statement:De(Le.statementCoverage),branch:Le.branchCoverage&&De(Le.branchCoverage),function:Le.functionCoverage&&De(Le.functionCoverage),details:Le.detailedCoverage?.map(X)}}he.fromFile=ke})(Qe=e.TestCoverage||(e.TestCoverage={}));var st;(function(he){function De(le){switch(le){case 1:return b.CodeActionTriggerKind.Invoke;case 2:return b.CodeActionTriggerKind.Automatic}}he.to=De})(st=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var at;(function(he){function De(X){const ke=new b.TypeHierarchyItem(M.to(X.kind),X.name,X.detail||"",I.URI.revive(X.uri),s.to(X.range),s.to(X.selectionRange));return ke._sessionId=X._sessionId,ke._itemId=X._itemId,ke}he.to=De;function le(X,ke,Le){if(ke=ke??X._sessionId,Le=Le??X._itemId,ke===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:ke,_itemId:Le,kind:M.from(X.kind),name:X.name,detail:X.detail??"",uri:X.uri,range:s.from(X.range),selectionRange:s.from(X.selectionRange),tags:X.tags?.map(W.from)}}he.from=le})(at=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(ve[216],we([0,1,2,15,7,17,93]),function(J,e,m,i,y,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class D{constructor(I,L,A,c={timeout:1500,errors:3}){this._logService=I,this._documents=L,this._mainThreadBulkEdits=A,this._thresholds=c,this._callbacks=new P.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(I){return(L,A,c)=>{const h={dispose:this._callbacks.push([L,A,I])};return Array.isArray(c)&&c.push(h),h}}async $participateInSave(I,L){const A=m.URI.revive(I);let c=!1;const E=setTimeout(()=>c=!0,this._thresholds.timeout),h=[];try{for(let p of[...this._callbacks]){if(c)break;const v=this._documents.getDocument(A),T=await this._deliverEventAsyncAndBlameBadListeners(p,{document:v,reason:C.TextDocumentSaveReason.to(L)});h.push(T)}}finally{clearTimeout(E)}return h}_deliverEventAsyncAndBlameBadListeners([I,L,A],c){const E=this._badListeners.get(I);return typeof E=="number"&&E>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(A,I,L,c).then(()=>!0,h=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${A.identifier.value}' threw ERROR`),this._logService.error(h),!(h instanceof Error)||h.message!=="concurrent_edits"){const p=this._badListeners.get(I);this._badListeners.set(I,p?p+1:1),typeof p=="number"&&p>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${A.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(I,L,A,c){const E=[],h=Date.now(),{document:p,reason:v}=c,{version:T}=p,b=Object.freeze({document:p,reason:v,waitUntil(o){if(Object.isFrozen(E))throw(0,i.illegalState)("waitUntil can not be called async");E.push(Promise.resolve(o))}});try{L.apply(A,[b])}catch(o){return Promise.reject(o)}return Object.freeze(E),new Promise((o,s)=>{const g=setTimeout(()=>s(new Error("timeout")),this._thresholds.timeout);return Promise.all(E).then(l=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' finished after ${Date.now()-h}ms`),clearTimeout(g),o(l)}).catch(l=>{clearTimeout(g),s(l)})}).then(o=>{const s={edits:[]};for(const g of o)if(Array.isArray(g)&&g.every(l=>l instanceof y.TextEdit))for(const{newText:l,newEol:S,range:n}of g)s.edits.push({_type:2,resource:p.uri,edit:{range:n&&C.Range.from(n),text:l,eol:S&&C.EndOfLine.from(S)}});if(s.edits.length!==0)return T===p.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(s):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=D}),define(ve[217],we([0,1,3,31,2,17,7]),function(J,e,m,i,y,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class D{constructor(L,A,c,E,h){this._onDidCreate=new m.Emitter,this._onDidChange=new m.Emitter,this._onDidDelete=new m.Emitter,this._config=0,c&&(this._config+=1),E&&(this._config+=2),h&&(this._config+=4);const p=(0,i.parse)(A),v=L(T=>{if(!c)for(let b of T.created){const o=y.URI.revive(b);p(o.fsPath)&&this._onDidCreate.fire(o)}if(!E)for(let b of T.changed){const o=y.URI.revive(b);p(o.fsPath)&&this._onDidChange.fire(o)}if(!h)for(let b of T.deleted){const o=y.URI.revive(b);p(o.fsPath)&&this._onDidDelete.fire(o)}});this._disposable=P.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,v)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class _{constructor(L,A,c){this._logService=A,this._extHostDocumentsAndEditors=c,this._onFileSystemEvent=new m.Emitter,this._onDidRenameFile=new m.Emitter,this._onDidCreateFile=new m.Emitter,this._onDidDeleteFile=new m.Emitter,this._onWillRenameFile=new m.AsyncEmitter,this._onWillCreateFile=new m.AsyncEmitter,this._onWillDeleteFile=new m.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(L,A,c,E){return new D(this._onFileSystemEvent.event,L,A,c,E)}$onFileEvent(L){this._onFileSystemEvent.fire(L)}$onDidRunFileOperation(L,A){switch(L){case 2:this._onDidRenameFile.fire(Object.freeze({files:A.map(c=>({oldUri:y.URI.revive(c.source),newUri:y.URI.revive(c.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:A.map(c=>y.URI.revive(c.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:A.map(c=>y.URI.revive(c.target))}));break;default:}}getOnWillRenameFileEvent(L){return this._createWillExecuteEvent(L,this._onWillRenameFile)}getOnWillCreateFileEvent(L){return this._createWillExecuteEvent(L,this._onWillCreateFile)}getOnWillDeleteFileEvent(L){return this._createWillExecuteEvent(L,this._onWillDeleteFile)}_createWillExecuteEvent(L,A){return(c,E,h)=>{const p=function(T){c.call(E,T)};return p.extension=L,A.event(p,void 0,h)}}async $onWillRunFileOperation(L,A,c,E){switch(L){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:A.map(h=>({oldUri:y.URI.revive(h.source),newUri:y.URI.revive(h.target)}))},c,E);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:A.map(h=>y.URI.revive(h.target))},c,E);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:A.map(h=>y.URI.revive(h.target))},c,E)}}async _fireWillEvent(L,A,c,E){const h=new Set,p=[];if(await L.fireAsync(A,E,async(T,b)=>{const o=Date.now(),s=await Promise.resolve(T);s instanceof P.WorkspaceEdit&&(p.push(s),h.add(b.extension.displayName??b.extension.identifier.value)),Date.now()-o>c&&this._logService.warn("SLOW file-participant",b.extension.identifier)}),E.isCancellationRequested||p.length===0)return;const v={edits:[]};for(let T of p){let{edits:b}=C.WorkspaceEdit.from(T,this._extHostDocumentsAndEditors);v.edits=v.edits.concat(b)}return{edit:v,extensionNames:Array.from(h)}}}e.ExtHostFileSystemEventService=_}),define(ve[218],we([0,1,10,25,2,17,7,125]),function(J,e,m,i,y,C,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class _{constructor(c,E,h,p){this.start=c,this.deletedCount=E,this.deletedItems=h,this.items=p}static asApiEvents(c){return c.map(E=>({start:E.start,deletedCount:E.deletedCount,deletedItems:E.deletedItems,items:E.items.map(h=>h.apiCell)}))}}class I{constructor(c,E,h){this.notebook=c,this._extHostDocument=E,this._cellData=h,this.handle=h.handle,this.uri=y.URI.revive(h.uri),this.cellKind=h.cellKind,this._outputs=h.outputs.map(C.NotebookCellOutput.to),this._internalMetadata=h.internalMetadata??{},this._metadata=Object.freeze(h.metadata??{}),this._previousResult=Object.freeze(C.NotebookCellExecutionSummary.to(h.internalMetadata??{}))}static asModelAddData(c,E){return{EOL:E.eol,lines:E.source,languageId:E.language,uri:E.uri,isDirty:!1,versionId:1,notebook:c}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const c=this,E=this._extHostDocument.getDocument(this.uri);if(!E)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return c.notebook.getCellIndex(c)},notebook:c.notebook.apiNotebook,kind:C.NotebookCellKind.to(this._cellData.cellKind),document:E.document,get mime(){return c._mime},set mime(h){c._mime=h},get outputs(){return c._outputs.slice(0)},get metadata(){return c._metadata},get executionSummary(){return c._previousResult}})}return this._apiCell}setOutputs(c){this._outputs=c.map(C.NotebookCellOutput.to)}setOutputItems(c,E,h){const p=h.map(C.NotebookCellOutputItem.to),v=this._outputs.find(T=>T.id===c);v&&(E||(v.items.length=0),v.items.push(...p))}setMetadata(c){this._metadata=Object.freeze(c)}setInternalMetadata(c){this._internalMetadata=c,this._previousResult=Object.freeze(C.NotebookCellExecutionSummary.to(c))}setMime(c){}}e.ExtHostCell=I;class L{constructor(c,E,h,p,v,T){this._proxy=c,this._textDocumentsAndEditors=E,this._textDocuments=h,this._emitter=p,this.uri=v,this.handle=L._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=T.viewType,this._metadata=Object.freeze(T.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,T.cells]],!0),this._versionId=T.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const c=this;this._notebook={get uri(){return c.uri},get version(){return c._versionId},get notebookType(){return c._notebookType},get isDirty(){return c._isDirty},get isUntitled(){return c.uri.scheme===m.Schemas.untitled},get isClosed(){return c._disposed},get metadata(){return c._metadata},get cellCount(){return c._cells.length},cellAt(E){return E=c._validateIndex(E),c._cells[E].apiCell},getCells(E){return(E?c._getCells(E):c._cells).map(p=>p.apiCell)},save(){return c._save()}}}return this._notebook}updateBackup(c){this._backup?.delete(),this._backup=c}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(c){c.metadata&&(this._metadata=Object.freeze({...this._metadata,...c.metadata}))}acceptDirty(c){this._isDirty=c}acceptModelChanged(c,E){this._versionId=c.versionId,this._isDirty=E;for(const h of c.rawEvents)h.kind===D.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(h.changes,!1):h.kind===D.NotebookCellsChangeType.Move?this._moveCell(h.index,h.newIdx):h.kind===D.NotebookCellsChangeType.Output?this._setCellOutputs(h.index,h.outputs):h.kind===D.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(h.index,h.outputId,h.append,h.outputItems):h.kind===D.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(h.index,h.language):h.kind===D.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(h.index,h.mime):h.kind===D.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(h.index,h.metadata):h.kind===D.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(h.index,h.internalMetadata)}_validateIndex(c){return c=c|0,c<0?0:c>=this._cells.length?this._cells.length-1:c}_validateRange(c){let E=c.start|0,h=c.end|0;return E<0&&(E=0),h>this._cells.length&&(h=this._cells.length),c.with({start:E,end:h})}_getCells(c){c=this._validateRange(c);const E=[];for(let h=c.start;h<c.end;h++)E.push(this._cells[h]);return E}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(c,E){if(this._disposed)return;const h=[],p=[],v=[];c.reverse().forEach(T=>{const o=T[2].map(l=>{const S=new I(this,this._textDocumentsAndEditors,l);return E||p.push(I.asModelAddData(this.apiNotebook,l)),S}),s=new _(T[0],T[1],[],o),g=this._cells.splice(T[0],T[1],...o);for(const l of g)v.push(l.uri),s.deletedItems.push(l.apiCell);h.push(s)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:p,removedDocuments:v}),E||this._emitter.emitModelChange((0,i.deepFreeze)({document:this.apiNotebook,changes:_.asApiEvents(h)}))}_moveCell(c,E){const h=this._cells.splice(c,1);this._cells.splice(E,0,...h);const p=[new _(c,1,h.map(v=>v.apiCell),[]),new _(E,0,[],h)];this._emitter.emitModelChange((0,i.deepFreeze)({document:this.apiNotebook,changes:_.asApiEvents(p)}))}_setCellOutputs(c,E){const h=this._cells[c];h.setOutputs(E),this._emitter.emitCellOutputsChange((0,i.deepFreeze)({document:this.apiNotebook,cells:[h.apiCell]}))}_setCellOutputItems(c,E,h,p){const v=this._cells[c];v.setOutputItems(E,h,p),this._emitter.emitCellOutputsChange((0,i.deepFreeze)({document:this.apiNotebook,cells:[v.apiCell]}))}_changeCellLanguage(c,E){const h=this._cells[c];h.apiCell.document.languageId!==E&&this._textDocuments.$acceptModelModeChanged(h.uri,E)}_changeCellMime(c,E){const h=this._cells[c];h.apiCell.mime=E}_changeCellMetadata(c,E){const h=this._cells[c],p=h.apiCell.metadata;h.setMetadata(E);const v=h.apiCell.metadata;(0,i.equals)(p,v)||this._emitter.emitCellMetadataChange((0,i.deepFreeze)({document:this.apiNotebook,cell:h.apiCell}))}_changeCellInternalMetadata(c,E){const h=this._cells[c],p=h.internalMetadata;if(h.setInternalMetadata(E),p.runState!==E.runState){const v=E.runState??P.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,i.deepFreeze)({document:this.apiNotebook,cell:h.apiCell,state:v}))}}getCellFromApiCell(c){return this._cells.find(E=>E.apiCell===c)}getCellFromIndex(c){return this._cells[c]}getCell(c){return this._cells.find(E=>E.handle===c)}getCellIndex(c){return this._cells.indexOf(c)}}e.ExtHostNotebookDocument=L,L._handlePool=0}),define(ve[128],we([0,1,7,17,15]),function(J,e,m,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class C{constructor(_){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=_}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(_){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:_})}replaceCellMetadata(_,I){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:_,metadata:I})}replaceCells(_,I,L){this._throwIfFinalized(),!(_===I&&L.length===0)&&this._collectedEdits.push({editType:1,index:_,count:I-_,cells:L.map(i.NotebookCellData.from)})}}class P{constructor(_,I,L,A,c,E){this.id=_,this._proxy=I,this.notebookData=L,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=c,this._visibleRanges=A,this._viewColumn=E}get apiEditor(){if(!this._editor){const _=this;this._editor={get document(){return _.notebookData.apiNotebook},get selections(){return _._selections},set selections(I){if(!Array.isArray(I)||!I.every(m.NotebookRange.isNotebookRange))throw(0,y.illegalArgument)("selections");_._selections=I,_._trySetSelections(I)},get visibleRanges(){return _._visibleRanges},revealRange(I,L){_._proxy.$tryRevealRange(_.id,i.NotebookRange.from(I),L??m.NotebookEditorRevealType.Default)},get viewColumn(){return _._viewColumn},edit(I){const L=new C(this.document.version);return I(L),_._applyEdit(L.finalize())},setDecorations(I,L){return _.setDecorations(I,L)}},P.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(_){this._visible=_}_acceptVisibleRanges(_){this._visibleRanges=_}_acceptSelections(_){this._selections=_}_trySetSelections(_){this._proxy.$trySetSelections(this.id,_.map(i.NotebookRange.from))}_acceptViewColumn(_){this._viewColumn=_}_applyEdit(_){if(_.cellEdits.length===0)return Promise.resolve(!0);const I=[];let L=-1;for(let A=0;A<_.cellEdits.length;A++){if(L<0){I.push(_.cellEdits[A]),L++;continue}const E=I[L],h=_.cellEdits[A];if(E.editType===1&&h.editType===1&&E.index===h.index){E.cells.push(..._.cellEdits[A].cells),E.count+=_.cellEdits[A].count;continue}I.push(_.cellEdits[A]),L++}return this._proxy.$tryApplyEdits(this.id,_.documentVersionId,I)}setDecorations(_,I){if(!(I.isEmpty&&!this._hasDecorationsForKey.has(_.key)))return I.isEmpty?this._hasDecorationsForKey.delete(_.key):this._hasDecorationsForKey.add(_.key),this._proxy.$trySetDecorations(this.id,i.NotebookRange.from(I),_.key)}}e.ExtHostNotebookEditor=P,P.apiEditorsToExtHost=new WeakMap}),define(ve[219],we([0,1,17,117,164,21,57,15]),function(J,e,m,i,y,C,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class _{constructor(c){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=c}async withProgress(c,E,h){const p=this._handles++,{title:v,location:T,cancellable:b}=E,o={label:(0,y.localize)(0,null,c.displayName||c.name),id:c.identifier.value};return this._proxy.$startProgress(p,{location:m.ProgressLocation.from(T),title:v,source:o,cancellable:b},c).catch(D.onUnexpectedExternalError),this._withProgress(p,h,!!b)}_withProgress(c,E,h){let p;h&&(p=new C.CancellationTokenSource,this._mapHandleToCancellationSource.set(c,p));const v=b=>{this._proxy.$progressEnd(b),this._mapHandleToCancellationSource.delete(b),p&&p.dispose()};let T;try{T=E(new L(this._proxy,c),h&&p?p.token:C.CancellationToken.None)}catch(b){throw v(c),b}return T.then(b=>v(c),b=>v(c)),T}$acceptProgressCanceled(c){const E=this._mapHandleToCancellationSource.get(c);E&&(E.cancel(),this._mapHandleToCancellationSource.delete(c))}}e.ExtHostProgress=_;function I(A,c){return A.message=c.message,typeof c.increment=="number"&&(typeof A.increment=="number"?A.increment+=c.increment:A.increment=c.increment),A}class L extends i.Progress{constructor(c,E){super(h=>this.throttledReport(h));this._proxy=c,this._handle=E}throttledReport(c){this._proxy.$progressReport(this._handle,c)}}je([(0,P.throttle)(100,(A,c)=>I(A,c),()=>Object.create(null))],L.prototype,"throttledReport",null)}),define(ve[129],we([0,1,56,15,76,17,7]),function(J,e,m,i,y,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class D{constructor(c,E,h){const p=D._Keys.nextId();c.$registerTextEditorDecorationType(E.identifier,p,C.DecorationRenderOptions.from(h)),this.value=Object.freeze({key:p,dispose(){c.$removeTextEditorDecorationType(p)}})}}e.TextEditorDecorationType=D,D._Keys=new y.IdGenerator("TextEditorDecorationType");class _{constructor(c,E){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=c,this._documentVersionId=c.version,this._undoStopBefore=E.undoStopBefore,this._undoStopAfter=E.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(c,E){this._throwIfFinalized();let h=null;if(c instanceof P.Position)h=new P.Range(c,c);else if(c instanceof P.Range)h=c;else throw new Error("Unrecognized location");this._pushEdit(h,E,!1)}insert(c,E){this._throwIfFinalized(),this._pushEdit(new P.Range(c,c),E,!0)}delete(c){this._throwIfFinalized();let E=null;if(c instanceof P.Range)E=c;else throw new Error("Unrecognized location");this._pushEdit(E,null,!0)}_pushEdit(c,E,h){const p=this._document.validateRange(c);this._collectedEdits.push({range:p,text:E,forceMoveMarkers:h})}setEndOfLine(c){if(this._throwIfFinalized(),c!==P.EndOfLine.LF&&c!==P.EndOfLine.CRLF)throw(0,i.illegalArgument)("endOfLine");this._setEndOfLine=c}}e.TextEditorEdit=_;class I{constructor(c,E,h,p){this._proxy=c,this._id=E,this._accept(h),this._logService=p;const v=this;this.value={get tabSize(){return v._tabSize},set tabSize(T){v._setTabSize(T)},get insertSpaces(){return v._insertSpaces},set insertSpaces(T){v._setInsertSpaces(T)},get cursorStyle(){return v._cursorStyle},set cursorStyle(T){v._setCursorStyle(T)},get lineNumbers(){return v._lineNumbers},set lineNumbers(T){v._setLineNumbers(T)}}}_accept(c){this._tabSize=c.tabSize,this._insertSpaces=c.insertSpaces,this._cursorStyle=c.cursorStyle,this._lineNumbers=C.TextEditorLineNumbersStyle.to(c.lineNumbers)}_validateTabSize(c){if(c==="auto")return"auto";if(typeof c=="number"){const E=Math.floor(c);return E>0?E:null}if(typeof c=="string"){const E=parseInt(c,10);return isNaN(E)?null:E>0?E:null}return null}_setTabSize(c){const E=this._validateTabSize(c);if(E!==null){if(typeof E=="number"){if(this._tabSize===E)return;this._tabSize=E}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:E}))}}_validateInsertSpaces(c){return c==="auto"?"auto":c==="false"?!1:Boolean(c)}_setInsertSpaces(c){const E=this._validateInsertSpaces(c);if(typeof E=="boolean"){if(this._insertSpaces===E)return;this._insertSpaces=E}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:E}))}_setCursorStyle(c){this._cursorStyle!==c&&(this._cursorStyle=c,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:c})))}_setLineNumbers(c){this._lineNumbers!==c&&(this._lineNumbers=c,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:C.TextEditorLineNumbersStyle.from(c)})))}assign(c){const E={};let h=!1;if(typeof c.tabSize!="undefined"){const p=this._validateTabSize(c.tabSize);p==="auto"?(h=!0,E.tabSize=p):typeof p=="number"&&this._tabSize!==p&&(this._tabSize=p,h=!0,E.tabSize=p)}if(typeof c.insertSpaces!="undefined"){const p=this._validateInsertSpaces(c.insertSpaces);p==="auto"?(h=!0,E.insertSpaces=p):this._insertSpaces!==p&&(this._insertSpaces=p,h=!0,E.insertSpaces=p)}typeof c.cursorStyle!="undefined"&&this._cursorStyle!==c.cursorStyle&&(this._cursorStyle=c.cursorStyle,h=!0,E.cursorStyle=c.cursorStyle),typeof c.lineNumbers!="undefined"&&this._lineNumbers!==c.lineNumbers&&(this._lineNumbers=c.lineNumbers,h=!0,E.lineNumbers=C.TextEditorLineNumbersStyle.from(c.lineNumbers)),h&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,E))}_warnOnError(c,E){E.catch(h=>{this._logService.warn(`ExtHostTextEditorOptions '${c}' failed:'`),this._logService.warn(h)})}}e.ExtHostTextEditorOptions=I;class L{constructor(c,E,h,p,v,T,b,o){this.id=c,this._proxy=E,this._logService=h,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=v,this._options=new I(this._proxy,this.id,T,h),this._visibleRanges=b,this._viewColumn=o;const s=this;this.value=Object.freeze({get document(){return p.getValue()},set document(g){throw(0,i.readonly)("document")},get selection(){return s._selections&&s._selections[0]},set selection(g){if(!(g instanceof P.Selection))throw(0,i.illegalArgument)("selection");s._selections=[g],s._trySetSelection()},get selections(){return s._selections},set selections(g){if(!Array.isArray(g)||g.some(l=>!(l instanceof P.Selection)))throw(0,i.illegalArgument)("selections");s._selections=g,s._trySetSelection()},get visibleRanges(){return s._visibleRanges},set visibleRanges(g){throw(0,i.readonly)("visibleRanges")},get options(){return s._options.value},set options(g){s._disposed||s._options.assign(g)},get viewColumn(){return s._viewColumn},set viewColumn(g){throw(0,i.readonly)("viewColumn")},edit(g,l={undoStopBefore:!0,undoStopAfter:!0}){if(s._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const S=new _(p.getValue(),l);return g(S),s._applyEdit(S)},insertSnippet(g,l,S={undoStopBefore:!0,undoStopAfter:!0}){if(s._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let n;if(!l||Array.isArray(l)&&l.length===0)n=s._selections.map(t=>C.Range.from(t));else if(l instanceof P.Position){const{lineNumber:t,column:r}=C.Position.from(l);n=[{startLineNumber:t,startColumn:r,endLineNumber:t,endColumn:r}]}else if(l instanceof P.Range)n=[C.Range.from(l)];else{n=[];for(const t of l)if(t instanceof P.Range)n.push(C.Range.from(t));else{const{lineNumber:r,column:u}=C.Position.from(t);n.push({startLineNumber:r,startColumn:u,endLineNumber:r,endColumn:u})}}return E.$tryInsertSnippet(c,g.value,n,S)},setDecorations(g,l){const S=l.length===0;S&&!s._hasDecorationsForKey.has(g.key)||(S?s._hasDecorationsForKey.delete(g.key):s._hasDecorationsForKey.add(g.key),s._runOnProxy(()=>{if(C.isDecorationOptionsArr(l))return E.$trySetDecorations(c,g.key,C.fromRangeOrRangeWithMessage(l));{const n=new Array(4*l.length);for(let t=0,r=l.length;t<r;t++){const u=l[t];n[4*t]=u.start.line+1,n[4*t+1]=u.start.character+1,n[4*t+2]=u.end.line+1,n[4*t+3]=u.end.character+1}return E.$trySetDecorationsFast(c,g.key,n)}}))},revealRange(g,l){s._runOnProxy(()=>E.$tryRevealRange(c,C.Range.from(g),l||P.TextEditorRevealType.Default))},show(g){E.$tryShowEditor(c,C.ViewColumn.from(g))},hide(){E.$tryHideEditor(c)}})}dispose(){(0,m.ok)(!this._disposed),this._disposed=!0}_acceptOptions(c){(0,m.ok)(!this._disposed),this._options._accept(c)}_acceptVisibleRanges(c){(0,m.ok)(!this._disposed),this._visibleRanges=c}_acceptViewColumn(c){(0,m.ok)(!this._disposed),this._viewColumn=c}_acceptSelections(c){(0,m.ok)(!this._disposed),this._selections=c}async _trySetSelection(){const c=this._selections.map(C.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,c)),this.value}_applyEdit(c){const E=c.finalize();if(E.edits.length===0&&!E.setEndOfLine)return Promise.resolve(!0);const h=E.edits.map(v=>v.range);h.sort((v,T)=>v.end.line===T.end.line?v.end.character===T.end.character?v.start.line===T.start.line?v.start.character-T.start.character:v.start.line-T.start.line:v.end.character-T.end.character:v.end.line-T.end.line);for(let v=0,T=h.length-1;v<T;v++){const b=h[v].end;if(h[v+1].start.isBefore(b))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const p=E.edits.map(v=>({range:C.Range.from(v.range),text:v.text,forceMoveMarkers:v.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,E.documentVersionId,p,{setEndOfLine:typeof E.setEndOfLine=="number"?C.EndOfLine.from(E.setEndOfLine):void 0,undoStopBefore:E.undoStopBefore,undoStopAfter:E.undoStopAfter})}_runOnProxy(c){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):c().then(()=>this,E=>(E instanceof Error&&E.name==="DISPOSED"||this._logService.warn(E),null))}}e.ExtHostTextEditor=L}),define(ve[220],we([0,1,167,23,2,3,6,18,7,13,16,17,21,204]),function(J,e,m,i,y,C,P,D,_,I,L,A,c,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function h(T,b){if((0,I.isString)(T))return{label:T};if(T&&typeof T=="object"&&typeof T.label=="string"){let o;return Array.isArray(T.highlights)&&(o=T.highlights.filter(s=>s.length===2&&typeof s[0]=="number"&&typeof s[1]=="number"),o=o.length?o:void 0),{label:T.label,highlights:o}}}class p{constructor(b,o,s){this._proxy=b,this.commands=o,this.logService=s,this.treeViews=new Map;function g(l){return l&&l.$treeViewId&&l.$treeItemHandle}o.registerArgumentProcessor({processArgument:l=>g(l)?this.convertArgument(l):Array.isArray(l)&&l.length>0?l.map(S=>g(S)?this.convertArgument(S):S):l})}registerTreeDataProvider(b,o,s){const g=this.createTreeView(b,{treeDataProvider:o},s);return{dispose:()=>g.dispose()}}createTreeView(b,o,s){if(!o||!o.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const g=o.dragAndDropController?.supportedMimeTypes,l=this._proxy.$registerTreeViewDataProvider(b,{showCollapseAll:!!o.showCollapseAll,canSelectMany:!!o.canSelectMany,dragAndDropMimeTypes:g}),S=this.createExtHostTreeView(b,o,s);return{get onDidCollapseElement(){return S.onDidCollapseElement},get onDidExpandElement(){return S.onDidExpandElement},get selection(){return S.selectedElements},get onDidChangeSelection(){return S.onDidChangeSelection},get visible(){return S.visible},get onDidChangeVisibility(){return S.onDidChangeVisibility},get message(){return S.message},set message(n){S.message=n},get title(){return S.title},set title(n){S.title=n},get description(){return S.description},set description(n){S.description=n},reveal:(n,t)=>S.reveal(n,t),dispose:async()=>{await l,this.treeViews.delete(b),S.dispose()}}}$getChildren(b,o){const s=this.treeViews.get(b);return s?s.getChildren(o):Promise.reject(new Error((0,m.localize)(0,null,b)))}async $onDrop(b,o,s,g,l){const S=this.treeViews.get(b);if(!S)return Promise.reject(new Error((0,m.localize)(1,null,b)));const n=E.TreeDataTransferConverter.toITreeDataTransfer(o);if(g===b&&l){const t=await S.onWillDrop(l);t&&t.forEach((r,u)=>{r&&n.set(u,r)})}return S.onDrop(n,s)}async $hasResolve(b){const o=this.treeViews.get(b);if(!o)throw new Error((0,m.localize)(2,null,b));return o.hasResolve}$resolve(b,o,s){const g=this.treeViews.get(b);if(!g)throw new Error((0,m.localize)(3,null,b));return g.resolveTreeItem(o,s)}$setExpanded(b,o,s){const g=this.treeViews.get(b);if(!g)throw new Error((0,m.localize)(4,null,b));g.setExpanded(o,s)}$setSelection(b,o){const s=this.treeViews.get(b);if(!s)throw new Error((0,m.localize)(5,null,b));s.setSelection(o)}$setVisible(b,o){const s=this.treeViews.get(b);if(!s)throw new Error((0,m.localize)(6,null,b));s.setVisible(o)}createExtHostTreeView(b,o,s){const g=new v(b,o,this._proxy,this.commands.converter,this.logService,s);return this.treeViews.set(b,g),g}convertArgument(b){const o=this.treeViews.get(b.$treeViewId);return o?o.getExtensionElement(b.$treeItemHandle):null}}e.ExtHostTreeViews=p;class v extends P.Disposable{constructor(b,o,s,g,l,S){super();if(this.viewId=b,this.proxy=s,this.commands=g,this.logService=l,this.extension=S,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new C.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new C.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new C.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new C.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new C.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new c.CancellationTokenSource,S.contributes&&S.contributes.views)for(const r in S.contributes.views)for(const u of S.contributes.views[r])u.id===b&&(this._title=u.name);this.dataProvider=o.treeDataProvider,this.dndController=o.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(r=>this._onDidChangeData.fire({message:!1,element:r}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(r=>this._onDidChangeData.fire({message:!1,element:r})));let n,t;this._register(C.Event.debounce(this._onDidChangeData.event,(r,u)=>(r||(r={message:!1,elements:[]}),u.element!==!1&&(n||(n=new Promise(a=>t=a),this.refreshPromise=this.refreshPromise.then(()=>n)),Array.isArray(u.element)?r.elements.push(...u.element):r.elements.push(u.element)),u.message&&(r.message=!0),r),200,!0)(({message:r,elements:u})=>{u.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const a=t;return n=null,this.refresh(u).then(()=>a())})),r&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(b=>this.getExtensionElement(b)).filter(b=>!(0,I.isUndefinedOrNull)(b))}async getChildren(b){const o=b?this.getExtensionElement(b):void 0;if(b&&!o)return this.logService.error(`No tree item with id '${b}' found.`),Promise.resolve([]);let s=this.getChildrenNodes(b);return s||(s=await this.fetchChildrenNodes(o)),s?s.map(g=>g.item):void 0}getExtensionElement(b){return this.elements.get(b)}reveal(b,o){o=o||{select:!0,focus:!1};const s=(0,I.isUndefinedOrNull)(o.select)?!0:o.select,g=(0,I.isUndefinedOrNull)(o.focus)?!1:o.focus,l=(0,I.isUndefinedOrNull)(o.expand)?!1:o.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):b?this.refreshPromise.then(()=>this.resolveUnknownParentChain(b)).then(S=>this.resolveTreeNode(b,S[S.length-1]).then(n=>this.proxy.$reveal(this.viewId,{item:n.item,parentChain:S.map(t=>t.item)},{select:s,focus:g,expand:l})),S=>this.logService.error(S)):this.proxy.$reveal(this.viewId,void 0,{select:s,focus:g,expand:l})}get message(){return this._message}set message(b){this._message=b,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(b){this._title=b,this.proxy.$setTitle(this.viewId,b,this._description)}get description(){return this._description}set description(b){this._description=b,this.proxy.$setTitle(this.viewId,this._title,b)}setExpanded(b,o){const s=this.getExtensionElement(b);s&&(o?this._onDidExpandElement.fire(Object.freeze({element:s})):this._onDidCollapseElement.fire(Object.freeze({element:s})))}setSelection(b){(0,L.equals)(this._selectedHandles,b)||(this._selectedHandles=b,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(b){b!==this._visible&&(this._visible=b,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async onWillDrop(b){const o=[];for(const s of b){const g=this.getExtensionElement(s);g&&o.push(g)}if(!(!this.dndController?.onWillDrop||o.length===0))return this.dndController.onWillDrop(o)}async onDrop(b,o){const s=this.getExtensionElement(o);if(!!s)return(0,D.asPromise)(()=>this.dndController?.onDrop(b,s))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(b,o){if(!this.dataProvider.resolveTreeItem)return;const s=this.elements.get(b);if(s){const g=this.nodes.get(s);if(g){const l=await this.dataProvider.resolveTreeItem(g.extensionItem,s,o)??g.extensionItem;return g.item.tooltip=this.getTooltip(l.tooltip),g.item.command=this.getCommand(g.disposableStore,l.command),g.item}}}resolveUnknownParentChain(b){return this.resolveParent(b).then(o=>o?this.resolveUnknownParentChain(o).then(s=>this.resolveTreeNode(o,s[s.length-1]).then(g=>(s.push(g),s))):Promise.resolve([]))}resolveParent(b){const o=this.nodes.get(b);return o?Promise.resolve(o.parent?this.elements.get(o.parent.item.handle):void 0):(0,D.asPromise)(()=>this.dataProvider.getParent(b))}resolveTreeNode(b,o){const s=this.nodes.get(b);return s?Promise.resolve(s):(0,D.asPromise)(()=>this.dataProvider.getTreeItem(b)).then(g=>this.createHandle(b,g,o,!0)).then(g=>this.getChildren(o?o.item.handle:void 0).then(()=>{const l=this.getExtensionElement(g);if(l){const S=this.nodes.get(l);if(S)return Promise.resolve(S)}throw new Error(`Cannot resolve tree item for element ${g}`)}))}getChildrenNodes(b){if(b){let o;if(typeof b=="string"){const s=this.getExtensionElement(b);o=s?this.nodes.get(s):void 0}else o=b;return o&&o.children||void 0}return this.roots}async fetchChildrenNodes(b){this.clearChildren(b);const o=new c.CancellationTokenSource(this._refreshCancellationSource.token);try{const s=b?this.nodes.get(b):void 0,g=await this.dataProvider.getChildren(b);if(o.token.isCancellationRequested)return;const l=await Promise.all((0,L.coalesce)(g||[]).map(async S=>{const n=await this.dataProvider.getTreeItem(S);return n&&!o.token.isCancellationRequested?this.createAndRegisterTreeNode(S,n,s):null}));return o.token.isCancellationRequested?void 0:(0,L.coalesce)(l)}finally{o.dispose()}}refresh(b){if(b.some(s=>!s))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new c.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const s=this.getHandlesToRefresh(b);if(s.length)return this.refreshHandles(s)}return Promise.resolve(void 0)}getHandlesToRefresh(b){const o=new Set,s=b.map(l=>this.nodes.get(l));for(const l of s)if(l&&!o.has(l.item.handle)){let S=l;for(;S&&S.parent&&s.findIndex(n=>S&&S.parent&&n&&n.item.handle===S.parent.item.handle)===-1;){const n=this.elements.get(S.parent.item.handle);S=n?this.nodes.get(n):void 0}S&&!S.parent&&o.add(l.item.handle)}const g=[];return o.forEach(l=>{const S=this.elements.get(l);if(S){const n=this.nodes.get(S);n&&(!n.parent||!o.has(n.parent.item.handle))&&g.push(l)}}),g}refreshHandles(b){const o={};return Promise.all(b.map(s=>this.refreshNode(s).then(g=>{g&&(o[s]=g.item)}))).then(()=>Object.keys(o).length?this.proxy.$refresh(this.viewId,o):void 0)}refreshNode(b){const o=this.getExtensionElement(b);if(o){const s=this.nodes.get(o);if(s)return this.clearChildren(o),(0,D.asPromise)(()=>this.dataProvider.getTreeItem(o)).then(g=>{if(g){const l=this.createTreeNode(o,g,s.parent);return this.updateNodeCache(o,l,s,s.parent),s.dispose(),l}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(b,o,s){const g=this.createTreeNode(b,o,s);if(o.id&&this.elements.has(g.item.handle))throw new Error((0,m.localize)(7,null,o.id));return this.addNodeToCache(b,g),this.addNodeToParentCache(g,s),g}getTooltip(b){return _.MarkdownString.isMarkdownString(b)?A.MarkdownString.from(b):b}getCommand(b,o){return o?this.commands.toInternal(o,b):void 0}createTreeNode(b,o,s){const g=new P.DisposableStore,l=this.createHandle(b,o,s),S=this.getLightIconPath(o);return{item:{handle:l,parentHandle:s?s.item.handle:void 0,label:h(o.label,this.extension),description:o.description,resourceUri:o.resourceUri,tooltip:this.getTooltip(o.tooltip),command:this.getCommand(g,o.command),contextValue:o.contextValue,icon:S,iconDark:this.getDarkIconPath(o)||S,themeIcon:this.getThemeIcon(o),collapsibleState:(0,I.isUndefinedOrNull)(o.collapsibleState)?_.TreeItemCollapsibleState.None:o.collapsibleState,accessibilityInformation:o.accessibilityInformation},extensionItem:o,parent:s,children:void 0,disposableStore:g,dispose(){g.dispose()}}}getThemeIcon(b){return b.iconPath instanceof _.ThemeIcon?b.iconPath:void 0}createHandle(b,{id:o,label:s,resourceUri:g},l,S){if(o)return`${v.ID_HANDLE_PREFIX}/${o}`;const n=h(s,this.extension),t=l?l.item.handle:v.LABEL_HANDLE_PREFIX;let r=n?n.label:g?(0,i.basename)(g):"";r=r.indexOf("/")!==-1?r.replace("/","//"):r;const u=this.nodes.has(b)?this.nodes.get(b).item.handle:void 0,a=this.getChildrenNodes(l)||[];let f,w=0;do{if(f=`${t}/${w}:${r}`,S||!this.elements.has(f)||u===f)break;w++}while(w<=a.length);return f}getLightIconPath(b){if(b.iconPath&&!(b.iconPath instanceof _.ThemeIcon))return typeof b.iconPath=="string"||y.URI.isUri(b.iconPath)?this.getIconPath(b.iconPath):this.getIconPath(b.iconPath.light)}getDarkIconPath(b){if(b.iconPath&&!(b.iconPath instanceof _.ThemeIcon)&&b.iconPath.dark)return this.getIconPath(b.iconPath.dark)}getIconPath(b){return y.URI.isUri(b)?b:y.URI.file(b)}addNodeToCache(b,o){this.elements.set(o.item.handle,b),this.nodes.set(b,o)}updateNodeCache(b,o,s,g){this.elements.delete(o.item.handle),this.nodes.delete(b),o.item.handle!==s.item.handle&&this.elements.delete(s.item.handle),this.addNodeToCache(b,o);const l=this.getChildrenNodes(g)||[],S=l.filter(n=>n.item.handle===s.item.handle)[0];S&&l.splice(l.indexOf(S),1,o)}addNodeToParentCache(b,o){o?(o.children||(o.children=[]),o.children.push(b)):(this.roots||(this.roots=[]),this.roots.push(b))}clearChildren(b){if(b){const o=this.nodes.get(b);if(o){if(o.children)for(const s of o.children){const g=this.elements.get(s.item.handle);g&&this.clear(g)}o.children=void 0}}else this.clearAll()}clear(b){const o=this.nodes.get(b);if(o){if(o.children)for(const s of o.children){const g=this.elements.get(s.item.handle);g&&this.clear(g)}this.nodes.delete(b),this.elements.delete(o.item.handle),o.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(b=>b.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}v.LABEL_HANDLE_PREFIX="0",v.ID_HANDLE_PREFIX="1"}),define(ve[221],we([0,1,18,3,6,13,63,17,126,89]),function(J,e,m,i,y,C,P,D,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class L extends y.Disposable{constructor(c){super();this.controllerId=c,this.debounceSendDiff=this._register(new m.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new i.Emitter),this.root=new P.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(c){this._resolveHandler=c;for(const E of this.tree.values())this.updateExpandability(E)}collectDiff(){const c=this.diff;return this.diff=[],c}pushDiff(c){const E=this.diff[this.diff.length-1];if(E&&c[0]===1){if(E[0]===1&&E[1].extId===c[1].extId){(0,_.applyTestItemUpdate)(E[1],c[1]);return}if(E[0]===0&&E[1].item.extId===c[1].extId){(0,_.applyTestItemUpdate)(E[1],c[1]);return}}this.diff.push(c),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(c,E){const h=this.tree.get(c);if(!!h){if((h.expandLevels===void 0||E>h.expandLevels)&&(h.expandLevels=E),h.expand===1){const p=this.resolveChildren(h);return p.isOpen()?this.expandChildren(h,E-1):p.wait().then(()=>this.expandChildren(h,E-1))}else if(h.expand===3)return h.resolveBarrier?.isOpen()===!1?h.resolveBarrier.wait().then(()=>this.expandChildren(h,E-1)):this.expandChildren(h,E-1)}}dispose(){for(const c of this.tree.values())(0,P.getPrivateApiFor)(c.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(c,E){switch(E.op){case 2:this.pushDiff([4,c.fullId.toString()]);break;case 1:this.removeItem(I.TestId.joinToString(c.fullId,E.id));break;case 0:this.upsertItem(E.item,c);break;case 4:for(const b of E.ops)this.onTestItemEvent(c,b);break;case 3:const{key:h,value:p,previous:v}=E,T=c.fullId.toString();switch(h){case"canResolveChildren":this.updateExpandability(c);break;case"tags":this.diffTagRefs(p,v,T);break;case"range":this.pushDiff([1,{extId:T,item:{range:D.Range.from(p)}}]);break;case"error":this.pushDiff([1,{extId:T,item:{error:D.MarkdownString.fromStrict(p)||null}}]);break;default:this.pushDiff([1,{extId:T,item:{[h]:p??null}}]);break}break;default:(0,C.assertNever)(E)}}upsertItem(c,E){if(!(c instanceof P.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${c.id} did not`);const h=I.TestId.fromExtHostTestItem(c,this.root.id,E?.actual),p=(0,P.getPrivateApiFor)(c);p.parent&&p.parent!==E?.actual&&p.parent.children.delete(c.id);let v=this.tree.get(h.toString());if(!v){v={fullId:h,actual:c,parent:E?h.parentId:null,expandLevels:E?.expandLevels?E.expandLevels-1:void 0,expand:0},c.tags.forEach(this.incrementTagRefs,this),this.tree.set(v.fullId.toString(),v),this.setItemParent(c,E),this.pushDiff([0,{parent:v.parent&&v.parent.toString(),controllerId:this.controllerId,expand:v.expand,item:D.TestItem.from(c)}]),this.connectItemAndChildren(c,v,E);return}if(v.actual===c){this.connectItem(c,v,E);return}const T=v.actual.children,b=v.actual,o=(0,P.diffTestItems)(b,c);(0,P.getPrivateApiFor)(b).listener=void 0,v.actual=c,v.expand=0;for(const[s,g]of o)this.onTestItemEvent(v,{op:3,key:s,value:g,previous:b[s]});this.connectItemAndChildren(c,v,E);for(const s of T)c.children.get(s.id)||this.removeItem(I.TestId.joinToString(h,s.id))}diffTagRefs(c,E,h){const p=new Set(E.map(v=>v.id));for(const v of c)p.delete(v.id)||this.incrementTagRefs(v);this.pushDiff([1,{extId:h,item:{tags:c.map(v=>D.TestTag.namespace(this.controllerId,v.id))}}]),p.forEach(this.decrementTagRefs,this)}incrementTagRefs(c){const E=this.tags.get(c.id);E?E.refCount++:(this.tags.set(c.id,{refCount:1}),this.pushDiff([5,{id:D.TestTag.namespace(this.controllerId,c.id),ctrlLabel:this.root.label}]))}decrementTagRefs(c){const E=this.tags.get(c);E&&!--E.refCount&&(this.tags.delete(c),this.pushDiff([6,D.TestTag.namespace(this.controllerId,c)]))}setItemParent(c,E){(0,P.getPrivateApiFor)(c).parent=E&&E.actual!==this.root?E.actual:void 0}connectItem(c,E,h){this.setItemParent(c,h);const p=(0,P.getPrivateApiFor)(c);p.parent=h?.actual,p.listener=v=>this.onTestItemEvent(E,v),this.updateExpandability(E)}connectItemAndChildren(c,E,h){this.connectItem(c,E,h);for(const p of c.children)this.upsertItem(p,E)}updateExpandability(c){let E;this._resolveHandler?c.resolveBarrier?E=c.resolveBarrier.isOpen()?3:2:E=c.actual.canResolveChildren?1:0:E=0,E!==c.expand&&(c.expand=E,this.pushDiff([1,{extId:c.fullId.toString(),expand:E}]),E===1&&c.expandLevels!==void 0&&this.resolveChildren(c))}expandChildren(c,E){if(E<0)return;const h=[];for(const p of c.actual.children){const v=this.expand(I.TestId.joinToString(c.fullId,p.id),E);(0,m.isThenable)(v)&&h.push(v)}if(h.length)return Promise.all(h).then(()=>{})}resolveChildren(c){if(c.resolveBarrier)return c.resolveBarrier;if(!this._resolveHandler){const v=new m.Barrier;return v.open(),v}c.expand=2,this.pushExpandStateUpdate(c);const E=c.resolveBarrier=new m.Barrier,h=v=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),c.actual!==this.root&&(c.actual.error=v.stack||v.message||String(v))};let p;try{p=this._resolveHandler(c.actual===this.root?void 0:c.actual)}catch(v){h(v)}return(0,m.isThenable)(p)?p.catch(h).then(()=>{E.open(),this.updateExpandability(c)}):(E.open(),this.updateExpandability(c)),c.resolveBarrier}pushExpandStateUpdate(c){this.pushDiff([1,{extId:c.fullId.toString(),expand:c.expand}])}removeItem(c){const E=this.tree.get(c);if(!E)throw new Error("attempting to remove non-existent child");this.pushDiff([2,c]);const h=[E];for(;h.length;){const p=h.pop();if(!!p){(0,P.getPrivateApiFor)(p.actual).listener=void 0;for(const v of p.actual.tags)this.decrementTagRefs(v.id);this.tree.delete(p.fullId.toString());for(const v of p.actual.children)h.push(this.tree.get(I.TestId.joinToString(p.fullId,v.id)))}}}flushDiff(){const c=this.collectDiff();c.length&&this.diffOpEmitter.fire(c)}}e.SingleUseTestCollection=L}),define(ve[222],we([0,1,4,182]),function(J,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,m.refineServiceDecorator)(i.IEnvironmentService)}),define(ve[223],we([0,1,27,3,9]),function(J,e,m,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class C{constructor(L){this.removedDueToLooping=L}}e.DeltaExtensionsResult=C;class P{constructor(L){this._onDidChange=new i.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=L,this._initialize()}_initialize(){this._extensionDescriptions.sort(_),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const L of this._extensionDescriptions){if(this._extensionsMap.has(m.ExtensionIdentifier.toKey(L.identifier))){console.error("Extension `"+L.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(m.ExtensionIdentifier.toKey(L.identifier),L),this._extensionsArr.push(L),Array.isArray(L.activationEvents))for(let A of L.activationEvents)A==="onUri"&&(A=`onUri:${m.ExtensionIdentifier.toKey(L.identifier)}`),this._activationMap.has(A)||this._activationMap.set(A,[]),this._activationMap.get(A).push(L)}}keepOnly(L){const A=new Set;L.forEach(c=>A.add(m.ExtensionIdentifier.toKey(c))),this._extensionDescriptions=this._extensionDescriptions.filter(c=>A.has(m.ExtensionIdentifier.toKey(c.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(L,A){L.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(L));const c=P._findLoopingExtensions(this._extensionDescriptions);if(A=A.concat(c.map(E=>E.identifier)),A.length>0){const E=new Set;A.forEach(h=>E.add(m.ExtensionIdentifier.toKey(h))),this._extensionDescriptions=this._extensionDescriptions.filter(h=>!E.has(m.ExtensionIdentifier.toKey(h.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new C(c)}static _findLoopingExtensions(L){const A=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(v){this._nodesSet.has(v)||(this._nodesSet.add(v),this._nodesArr.push(v))}addArc(v,T){this.addNode(v),this.addNode(T),this._arcs.has(v)?this._arcs.get(v).push(T):this._arcs.set(v,[T])}getArcs(v){return this._arcs.has(v)?this._arcs.get(v):[]}hasOnlyGoodArcs(v,T){const b=A.getArcs(v);for(let o=0;o<b.length;o++)if(!T.has(b[o]))return!1;return!0}getNodes(){return this._nodesArr}};let c=new Map;for(let v of L){const T=m.ExtensionIdentifier.toKey(v.identifier);if(c.set(T,v),v.extensionDependencies)for(let b of v.extensionDependencies){const o=m.ExtensionIdentifier.toKey(b);A.addArc(T,o)}}let E=new Set;A.getNodes().filter(v=>A.getArcs(v).length===0).forEach(v=>E.add(v));let h=A.getNodes().filter(v=>!E.has(v)),p;do{p=!1;for(let v=0;v<h.length;v++){const T=h[v];A.hasOnlyGoodArcs(T,E)&&(h.splice(v,1),v--,E.add(T),p=!0)}}while(p);return h.map(v=>c.get(v))}containsActivationEvent(L){return this._activationMap.has(L)}containsExtension(L){return this._extensionsMap.has(m.ExtensionIdentifier.toKey(L))}getExtensionDescriptionsForActivationEvent(L){const A=this._activationMap.get(L);return A?A.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(L){const A=this._extensionsMap.get(m.ExtensionIdentifier.toKey(L));return A||void 0}}e.ExtensionDescriptionRegistry=P;var D;(function(I){I[I.Builtin=0]="Builtin",I[I.User=1]="User",I[I.Dev=2]="Dev"})(D||(D={}));function _(I,L){const A=I.isBuiltin?0:I.isUnderDevelopment?2:1,c=L.isBuiltin?0:L.isUnderDevelopment?2:1;if(A!==c)return A-c;const E=y.posix.basename(I.extensionLocation.path),h=y.posix.basename(L.extensionLocation.path);return E<h?-1:E>h?1:0}}),define(ve[224],we([0,1,22]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var i;(function(D){D[D.VersionMismatch=55]="VersionMismatch",D[D.UnexpectedError=81]="UnexpectedError"})(i=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var y;(function(D){D[D.Initialized=0]="Initialized",D[D.Ready=1]="Ready",D[D.Terminate=2]="Terminate"})(y=e.MessageType||(e.MessageType={}));function C(D){const _=m.VSBuffer.alloc(1);switch(D){case 0:_.writeUInt8(1,0);break;case 1:_.writeUInt8(2,0);break;case 2:_.writeUInt8(3,0);break}return _}e.createMessageOfType=C;function P(D,_){if(D.byteLength!==1)return!1;switch(D.readUInt8(0)){case 1:return _===0;case 2:return _===1;case 3:return _===2;default:return!1}}e.isMessageOfType=P}),define(ve[29],we([0,1,3,2,4,27,193]),function(J,e,m,i,y,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.extensionRunningLocationToString=e.ExtensionRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new C.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:i.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,y.createDecorator)("extensionService");var D;(function(s){s[s.None=0]="None",s[s.LocalProcess=1]="LocalProcess",s[s.LocalWebWorker=2]="LocalWebWorker",s[s.Remote=3]="Remote"})(D=e.ExtensionRunningLocation||(e.ExtensionRunningLocation={}));function _(s){switch(s){case 0:return"None";case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionRunningLocationToString=_;class I{constructor(g){this.dependency=g}}e.MissingExtensionDependency=I;var L;(function(s){s[s.LocalProcess=0]="LocalProcess",s[s.LocalWebWorker=1]="LocalWebWorker",s[s.Remote=2]="Remote"})(L=e.ExtensionHostKind||(e.ExtensionHostKind={}));function A(s){switch(s){case 0:return"LocalProcess";case 1:return"LocalWebWorker";case 2:return"Remote"}}e.extensionHostKindToString=A;function c(s,g){return s.enabledApiProposals?s.enabledApiProposals.includes(g):!1}e.isProposedApiEnabled=c;function E(s,g){if(!c(s,g))throw new Error(`Extension '${s.identifier.value}' CANNOT use API proposal: ${g}.
Its package.json#enabledApiProposals-property declares: ${s.enabledApiProposals?.join(", ")??"[]"} but NOT ${g}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${s.identifier.value}`)}e.checkProposedApiEnabled=E;class h{constructor(g,l,S,n){this.codeLoadingTime=g,this.activateCallTime=l,this.activateResolvedTime=S,this.activationReason=n}}e.ActivationTimes=h;class p{constructor(g,l){this.description=g,this.value=l}}e.ExtensionPointContribution=p,e.ExtensionHostLogFileName="exthost";var v;(function(s){s[s.Normal=0]="Normal",s[s.Immediate=1]="Immediate"})(v=e.ActivationKind||(e.ActivationKind={}));function T(s){return{type:s.isBuiltin?0:1,isBuiltin:s.isBuiltin||s.isUserBuiltin,identifier:{id:(0,P.getGalleryExtensionId)(s.publisher,s.name),uuid:s.uuid},manifest:s,location:s.extensionLocation}}e.toExtension=T;function b(s,g){return{identifier:new C.ExtensionIdentifier(s.identifier.id),isBuiltin:s.type===0,isUserBuiltin:s.type===1&&s.isBuiltin,isUnderDevelopment:!!g,extensionLocation:s.location,...s.manifest,uuid:s.identifier.uuid}}e.toExtensionDescription=b;class o{constructor(){this.onDidRegisterExtensions=m.Event.None,this.onDidChangeExtensionsStatus=m.Event.None,this.onDidChangeExtensions=m.Event.None,this.onWillActivateByEvent=m.Event.None,this.onDidChangeResponsiveChange=m.Event.None}activateByEvent(g){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(g){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(g){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(g){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(g,l){return Promise.resolve()}_onWillActivateExtension(g){}_onDidActivateExtension(g,l,S,n,t){}_onDidActivateExtensionError(g,l){}_onExtensionRuntimeError(g,l){}_onExtensionHostExit(g){}}e.NullExtensionService=o}),define(ve[225],we([0,1,15,27,29,11]),function(J,e,m,i,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const P=Promise.resolve(void 0);class D{constructor(p,v,T,b){this.startup=p,this.codeLoadingTime=v,this.activateCallTime=T,this.activateResolvedTime=b}}e.ExtensionActivationTimes=D,D.NONE=new D(!1,-1,-1,-1);class _{constructor(p){this._startup=p,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(p,v){return p===-1||v===-1?-1:v-p}build(){return new D(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=_;class I{constructor(p,v,T,b,o,s){this.activationFailed=p,this.activationFailedError=v,this.activationTimes=T,this.module=b,this.exports=o,this.subscriptions=s}}e.ActivatedExtension=I;class L extends I{constructor(p){super(!1,null,p,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=L;class A extends I{constructor(){super(!1,null,D.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=A;class c extends I{constructor(p){super(!0,p,D.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=c;let E=class{constructor(p,v,T,b,o){this._logService=o,this._isDisposed=!1,this._registry=p,this._resolvedExtensionsSet=new Set,v.forEach(s=>this._resolvedExtensionsSet.add(i.ExtensionIdentifier.toKey(s))),this._hostExtensionsMap=new Map,T.forEach(s=>this._hostExtensionsMap.set(i.ExtensionIdentifier.toKey(s),s)),this._host=b,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){this._isDisposed=!0}isActivated(p){const v=i.ExtensionIdentifier.toKey(p);return this._activatedExtensions.has(v)}getActivatedExtension(p){const v=i.ExtensionIdentifier.toKey(p),T=this._activatedExtensions.get(v);if(!T)throw new Error("Extension `"+p.value+"` is not known or not activated");return T}activateByEvent(p,v){if(this._alreadyActivatedEvents[p])return P;const T=this._registry.getExtensionDescriptionsForActivationEvent(p);return this._activateExtensions(T.map(b=>({id:b.identifier,reason:{startup:v,extensionId:b.identifier,activationEvent:p}}))).then(()=>{this._alreadyActivatedEvents[p]=!0})}activateById(p,v){const T=this._registry.getExtensionDescription(p);if(!T)throw new Error("Extension `"+p+"` is not known");return this._activateExtensions([{id:T.identifier,reason:v}])}_handleActivateRequest(p,v,T){if(this._hostExtensionsMap.has(i.ExtensionIdentifier.toKey(p.id))){v[i.ExtensionIdentifier.toKey(p.id)]=p;return}const b=this._registry.getExtensionDescription(p.id);if(!b){const g=new Error(`Cannot activate unknown extension '${p.id.value}'`);this._host.onExtensionActivationError(p.id,g,new y.MissingExtensionDependency(p.id.value)),this._activatedExtensions.set(i.ExtensionIdentifier.toKey(p.id),new c(g));return}const o=typeof b.extensionDependencies=="undefined"?[]:b.extensionDependencies;let s=!0;for(let g=0,l=o.length;g<l;g++){const S=o[g];if(this._resolvedExtensionsSet.has(i.ExtensionIdentifier.toKey(S)))continue;const n=this._activatedExtensions.get(i.ExtensionIdentifier.toKey(S));if(n&&!n.activationFailed)continue;if(n&&n.activationFailed){const a=b.displayName||b.identifier.value,f=this._registry.getExtensionDescription(S),w=f&&f.displayName||S,d=new Error(`Cannot activate the '${a}' extension because its dependency '${w}' failed to activate`);d.detail=n.activationFailedError,this._host.onExtensionActivationError(b.identifier,d,null),this._activatedExtensions.set(i.ExtensionIdentifier.toKey(b.identifier),new c(d));return}if(this._hostExtensionsMap.has(i.ExtensionIdentifier.toKey(S))){s=!1,v[i.ExtensionIdentifier.toKey(S)]={id:this._hostExtensionsMap.get(i.ExtensionIdentifier.toKey(S)),reason:p.reason};continue}const t=this._registry.getExtensionDescription(S);if(t){if(!t.main&&!t.browser)continue;s=!1,v[i.ExtensionIdentifier.toKey(S)]={id:t.identifier,reason:p.reason};continue}const r=b.displayName||b.identifier.value,u=new Error(`Cannot activate the '${r}' extension because it depends on unknown extension '${S}'`);this._host.onExtensionActivationError(b.identifier,u,new y.MissingExtensionDependency(S)),this._activatedExtensions.set(i.ExtensionIdentifier.toKey(b.identifier),new c(u));return}s?v[i.ExtensionIdentifier.toKey(b.identifier)]=p:T.push(p)}_activateExtensions(p){if(p.length===0||(p=p.filter(o=>!this._activatedExtensions.has(i.ExtensionIdentifier.toKey(o.id))),p.length===0))return Promise.resolve(void 0);const v=Object.create(null),T=[];for(let o=0,s=p.length;o<s;o++)this._handleActivateRequest(p[o],v,T);for(let o=0,s=T.length;o<s;o++){const g=i.ExtensionIdentifier.toKey(T[o].id);v[g]&&delete v[g]}const b=Object.keys(v).map(o=>v[o]);return T.length===0?Promise.all(b.map(o=>this._activateExtension(o.id,o.reason))).then(o=>{}):this._activateExtensions(b).then(o=>this._activateExtensions(T))}_activateExtension(p,v){const T=i.ExtensionIdentifier.toKey(p);if(this._activatedExtensions.has(T))return Promise.resolve(void 0);const b=this._activatingExtensions.get(T);if(b)return b;const o=this._host.actualActivateExtension(p,v).then(void 0,s=>{const g=new Error;return s&&s.name&&(g.name=s.name),s&&s.message?g.message=`Activating extension '${p.value}' failed: ${s.message}.`:g.message=`Activating extension '${p.value}' failed: ${s}.`,s&&s.stack&&(g.stack=s.stack),this._isDisposed&&m.isPromiseCanceledError(s)?new c(s):(this._host.onExtensionActivationError(p,g,null),this._logService.error(`Activating extension ${p.value} failed due to an error:`),this._logService.error(s),new c(s))}).then(s=>{this._activatedExtensions.set(T,s),this._activatingExtensions.delete(T)});return this._activatingExtensions.set(T,o),o}};E=je([ze(4,C.ILogService)],E),e.ExtensionsActivator=E}),define(ve[226],we([0,1,11,26,29]),function(J,e,m,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let C=class extends m.LogService{constructor(D,_){super(D.createLogger(_.logFile,{name:y.ExtensionHostLogFileName}))}};C=je([ze(0,m.ILoggerService),ze(1,i.IExtHostInitDataService)],C),e.ExtHostLogService=C}),define(ve[227],we([0,1,15]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class i{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((C,P)=>{this._actualOk=C,this._actualErr=P,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(C){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=C,this._actual&&this._actualOk(C))}resolveErr(C){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=C,this._actual?this._actualErr(C):(0,m.onUnexpectedError)(C))}then(C,P){return this._ensureActual().then(C,P)}catch(C){return this._ensureActual().then(void 0,C)}finally(C){return this._ensureActual().finally(C)}}e.LazyPromise=i}),define(ve[53],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class m{constructor(I,L){this._proxyIdentifierBrand=void 0,this.isMain=I,this.sid=L,this.nid=++m.count}}e.ProxyIdentifier=m,m.count=0;const i=[];function y(_){const I=new m(!0,_);return i[I.nid]=I,I}e.createMainContextProxyIdentifier=y;function C(_){const I=new m(!1,_);return i[I.nid]=I,I}e.createExtHostContextProxyIdentifier=C;function P(_){return i[_].sid}e.getStringIdentifierForProxy=P;class D{constructor(I){this.value=I}}e.SerializableObjectWithBuffers=D}),define(ve[5],we([0,1,59,2,53]),function(J,e,m,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var C;(function(o){o[o.Desktop=1]="Desktop",o[o.Web=2]="Web"})(C=e.UIKind||(e.UIKind={}));var P;(function(o){o[o.Default=0]="Default",o[o.InCenter=1]="InCenter",o[o.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",o[o.AtTop=3]="AtTop"})(P=e.TextEditorRevealType||(e.TextEditorRevealType={}));var D;(function(o){o[o.Editable=0]="Editable",o[o.SupportsHotExit=1]="SupportsHotExit"})(D=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var _;(function(o){o[o.Int8Array=1]="Int8Array",o[o.Uint8Array=2]="Uint8Array",o[o.Uint8ClampedArray=3]="Uint8ClampedArray",o[o.Int16Array=4]="Int16Array",o[o.Uint16Array=5]="Uint16Array",o[o.Int32Array=6]="Int32Array",o[o.Uint32Array=7]="Uint32Array",o[o.Float32Array=8]="Float32Array",o[o.Float64Array=9]="Float64Array",o[o.BigInt64Array=10]="BigInt64Array",o[o.BigUint64Array=11]="BigUint64Array"})(_=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var I;(function(o){o[o.Text=1]="Text",o[o.Error=2]="Error",o[o.Rich=3]="Rich"})(I=e.CellOutputKind||(e.CellOutputKind={}));var L;(function(o){o[o.Default=0]="Default",o[o.InCenter=1]="InCenter",o[o.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",o[o.AtTop=3]="AtTop"})(L=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var A;(function(o){o[o.None=0]="None",o[o.Process=1]="Process",o[o.Output=2]="Output"})(A=e.CandidatePortSource||(e.CandidatePortSource={}));var c;(function(o){o.name="$ident";function s(l,S){return Object.defineProperty(l,o.name,{value:S,enumerable:!0}),l}o.mixin=s;function g(l){return l[o.name]}o.of=g})(c=e.ObjectIdentifier||(e.ObjectIdentifier={}));class E{static mixin(s){return s._id=E._n++,s}}e.IdObject=E,E._n=0;var h;(function(o){o.label="a",o.kind="b",o.detail="c",o.documentation="d",o.sortText="e",o.filterText="f",o.preselect="g",o.insertText="h",o.insertTextRules="i",o.range="j",o.commitCharacters="k",o.additionalTextEdits="l",o.command="m",o.kindModifier="n"})(h=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var p;(function(o){o.defaultRanges="a",o.completions="b",o.isIncomplete="c",o.duration="d"})(p=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var v;(function(o){o[o.File=1]="File",o[o.Text=2]="Text",o[o.Cell=3]="Cell"})(v=e.WorkspaceEditType||(e.WorkspaceEditType={}));function T(o){if(o&&o.edits)for(const s of o.edits)typeof s.resource=="object"?s.resource=i.URI.revive(s.resource):(s.newUri=i.URI.revive(s.newUri),s.oldUri=i.URI.revive(s.oldUri)),s.metadata&&s.metadata.iconPath&&(s.metadata=(0,m.revive)(s.metadata));return o}e.reviveWorkspaceEditDto=T;var b;(function(o){o[o.Workspace=0]="Workspace",o[o.TextDocument=1]="TextDocument"})(b=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,y.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,y.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,y.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,y.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,y.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,y.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,y.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,y.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,y.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,y.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,y.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,y.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,y.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,y.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,y.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,y.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,y.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,y.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,y.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,y.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,y.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,y.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,y.createMainContextProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,y.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,y.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,y.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,y.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,y.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,y.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,y.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,y.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,y.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,y.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,y.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,y.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,y.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,y.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,y.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,y.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,y.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,y.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,y.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,y.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,y.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,y.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,y.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,y.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,y.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,y.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,y.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,y.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,y.createMainContextProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,y.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,y.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,y.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,y.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,y.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,y.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,y.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,y.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,y.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,y.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,y.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,y.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,y.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,y.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,y.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,y.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,y.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,y.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,y.createExtHostContextProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,y.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,y.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,y.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,y.createExtHostContextProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,y.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,y.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,y.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,y.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,y.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,y.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,y.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,y.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,y.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,y.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,y.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,y.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,y.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,y.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,y.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,y.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,y.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,y.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,y.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,y.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,y.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,y.createMainContextProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,y.createMainContextProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,y.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,y.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,y.createMainContextProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,y.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,y.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,y.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,y.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,y.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,y.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(ve[90],we([0,1,5,3,4]),function(J,e,m,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class C{constructor(D){this._onDidChangePassword=new i.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=D.getProxy(m.MainContext.MainThreadSecretState)}async $onDidChangePassword(D){this._onDidChangePassword.fire(D)}get(D,_){return this._proxy.$getPassword(D,_)}store(D,_,I){return this._proxy.$setPassword(D,_,I)}delete(D,_){return this._proxy.$deletePassword(D,_)}}e.ExtHostSecretState=C,e.IExtHostSecretState=(0,y.createDecorator)("IExtHostSecretState")}),define(ve[65],we([0,1,4,11,5,14]),function(J,e,m,i,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,m.createDecorator)("IExtHostApiDeprecationService");let P=class{constructor(_,I){this._extHostLogService=I,this._reportedUsages=new Set,this._telemetryShape=_.getProxy(y.MainContext.MainThreadTelemetry)}report(_,I,L){const A=this.getUsageKey(_,I);this._reportedUsages.has(A)||(this._reportedUsages.add(A),I.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${_}' is deprecated. ${L}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:I.identifier.value,apiId:_}))}getUsageKey(_,I){return`${_}-${I.identifier.value}`}};P=je([ze(0,C.IExtHostRpcService),ze(1,i.ILogService)],P),e.ExtHostApiDeprecationService=P,e.NullApiDeprecationService=Object.freeze(new class{report(D,_,I){}})}),define(ve[228],we([0,1,3,5,7,27]),function(J,e,m,i,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class P{constructor(_){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new m.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=_.getProxy(i.MainContext.MainThreadAuthentication)}$setProviders(_){return this._providers=_,Promise.resolve()}async getSession(_,I,L,A={}){const c=C.ExtensionIdentifier.toKey(_.identifier),E=this._inFlightRequests.get(c)||[],h=[...L].sort().join(" ");let p=E.find(v=>v.scopes===h);if(p)return p.result;{const v=this._getSession(_,c,I,L,A);p={scopes:h,result:v},E.push(p),this._inFlightRequests.set(c,E);try{await v}finally{const T=E.findIndex(b=>b.scopes===h);T>-1&&(E.splice(T),this._inFlightRequests.set(c,E))}return v}}async _getSession(_,I,L,A,c={}){await this._proxy.$ensureProvider(L);const E=_.displayName||_.name;return this._proxy.$getSession(L,A,I,E,c)}async removeSession(_,I){const L=this._authenticationProviders.get(_);return L?L.provider.removeSession(I):this._proxy.$removeSession(_,I)}registerAuthenticationProvider(_,I,L,A){if(this._authenticationProviders.get(_))throw new Error(`An authentication provider with id '${_}' is already registered.`);this._authenticationProviders.set(_,{label:I,provider:L,options:A??{supportsMultipleAccounts:!1}}),this._providers.find(E=>E.id===_)||this._providers.push({id:_,label:I});const c=L.onDidChangeSessions(E=>{this._proxy.$sendDidChangeSessions(_,{added:E.added??[],changed:E.changed??[],removed:E.removed??[]})});return this._proxy.$registerAuthenticationProvider(_,I,A?.supportsMultipleAccounts??!1),new y.Disposable(()=>{c.dispose(),this._authenticationProviders.delete(_);const E=this._providers.findIndex(h=>h.id===_);E>-1&&this._providers.splice(E),this._proxy.$unregisterAuthenticationProvider(_)})}$createSession(_,I){const L=this._authenticationProviders.get(_);if(L)return Promise.resolve(L.provider.createSession(I));throw new Error(`Unable to find authentication provider with handle: ${_}`)}$removeSession(_,I){const L=this._authenticationProviders.get(_);if(L)return Promise.resolve(L.provider.removeSession(I));throw new Error(`Unable to find authentication provider with handle: ${_}`)}$getSessions(_,I){const L=this._authenticationProviders.get(_);if(L)return Promise.resolve(L.provider.getSessions(I));throw new Error(`Unable to find authentication provider with handle: ${_}`)}$onDidChangeAuthenticationSessions(_,I){return this._onDidChangeSessions.fire({provider:{id:_,label:I}}),Promise.resolve()}}e.ExtHostAuthentication=P}),define(ve[229],we([0,1,5,14,17]),function(J,e,m,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let C=class{constructor(D,_){this._extHostDocumentsAndEditors=_,this._proxy=D.getProxy(m.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(D){const _=y.WorkspaceEdit.from(D,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(_)}};C=je([ze(0,i.IExtHostRpcService)],C),e.ExtHostBulkEdits=C}),define(ve[230],we([0,1,5]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class i{constructor(C){const P=C.getProxy(m.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return P.$readText()},writeText(D){return P.$writeText(D)}})}}e.ExtHostClipboard=i}),define(ve[38],we([0,1,13,7,17,25,5,16,11,59,41,49,2,6,4,14,63,22,53,50]),function(J,e,m,i,y,C,P,D,_,I,L,A,c,E,h,p,v,T,b,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let s=class{constructor(r,u){this._commands=new Map,this._apiCommands=new Map,this._proxy=r.getProxy(P.MainContext.MainThreadCommands),this._logService=u,this.converter=new g(this,a=>{const f=this._apiCommands.get(a);return f?.result===S.Void?f:void 0},u),this._argumentProcessors=[{processArgument(a){return(0,I.revive)(a)}},{processArgument(a){return(0,C.cloneAndChange)(a,function(f){if(L.Range.isIRange(f))return y.Range.to(f);if(A.Position.isIPosition(f))return y.Position.to(f);if(L.Range.isIRange(f.range)&&c.URI.isUri(f.uri))return y.location.to(f);if(f instanceof T.VSBuffer)return f.buffer.buffer;if(!Array.isArray(f))return f})}}]}registerArgumentProcessor(r){this._argumentProcessors.push(r)}registerApiCommand(r){const u=this.registerCommand(!1,r.id,async(...a)=>{const f=r.args.map((d,k)=>{if(!d.validate(a[k]))throw new Error(`Invalid argument '${d.name}' when running '${r.id}', received: ${a[k]}`);return d.convert(a[k])}),w=await this.executeCommand(r.internalId,...f);return r.result.convert(w,a,this.converter)},void 0,{description:r.description,args:r.args,returns:r.result.description});return this._apiCommands.set(r.id,r),new i.Disposable(()=>{u.dispose(),this._apiCommands.delete(r.id)})}registerCommand(r,u,a,f,w,d){if(this._logService.trace("ExtHostCommands#registerCommand",u),!u.trim().length)throw new Error("invalid id");if(this._commands.has(u))throw new Error(`command '${u}' already exists`);return this._commands.set(u,{callback:a,thisArg:f,description:w,extension:d}),r&&this._proxy.$registerCommand(u),new i.Disposable(()=>{this._commands.delete(u)&&r&&this._proxy.$unregisterCommand(u)})}executeCommand(r,...u){return this._logService.trace("ExtHostCommands#executeCommand",r),this._doExecuteCommand(r,u,!0)}async _doExecuteCommand(r,u,a){if(this._commands.has(r))return this._executeContributedCommand(r,u,!1);{let f=!1;const w=(0,C.cloneAndChange)(u,function(d){if(d instanceof i.Position)return y.Position.from(d);if(d instanceof i.Range)return y.Range.from(d);if(d instanceof i.Location)return y.location.from(d);if(i.NotebookRange.isNotebookRange(d))return y.NotebookRange.from(d);if(d instanceof ArrayBuffer)return f=!0,T.VSBuffer.wrap(new Uint8Array(d));if(d instanceof Uint8Array)return f=!0,T.VSBuffer.wrap(d);if(!Array.isArray(d))return d});try{const d=await this._proxy.$executeCommand(r,f?new b.SerializableObjectWithBuffers(w):w,a);return(0,I.revive)(d)}catch(d){if(d instanceof Error&&d.message==="$executeCommand:retry")return this._doExecuteCommand(r,u,!1);throw d}}}async _executeContributedCommand(r,u,a){const f=this._commands.get(r);if(!f)throw new Error("Unknown command");let{callback:w,thisArg:d,description:k}=f;if(k)for(let R=0;R<k.args.length;R++)try{(0,m.validateConstraint)(u[R],k.args[R].constraint)}catch{throw new Error(`Running the contributed command: '${r}' failed. Illegal argument '${k.args[R].name}' - ${k.args[R].description}`)}try{return await w.apply(d,u)}catch(R){if(r===this.converter.delegatingCommandId){const N=this.converter.getActualCommand(...u);N&&(r=N.command)}throw this._logService.error(R,r,f.extension?.identifier),a?new class extends Error{constructor(){super((0,o.toErrorMessage)(R));this.id=r,this.source=f.extension?.displayName??f.extension?.name}}:R}}$executeContributedCommand(r,...u){return this._logService.trace("ExtHostCommands#$executeContributedCommand",r),this._commands.has(r)?(u=u.map(a=>this._argumentProcessors.reduce((f,w)=>w.processArgument(f),a)),this._executeContributedCommand(r,u,!0)):Promise.reject(new Error(`Contributed command '${r}' does not exist.`))}getCommands(r=!1){return this._logService.trace("ExtHostCommands#getCommands",r),this._proxy.$getCommands().then(u=>(r&&(u=u.filter(a=>a[0]!=="_")),u))}$getContributedCommandHandlerDescriptions(){const r=Object.create(null);for(let[u,a]of this._commands){let{description:f}=a;f&&(r[u]=f)}return Promise.resolve(r)}};s=je([ze(0,p.IExtHostRpcService),ze(1,_.ILogService)],s),e.ExtHostCommands=s,e.IExtHostCommands=(0,h.createDecorator)("IExtHostCommands");class g{constructor(r,u,a){this._commands=r,this._lookupApiCommand=u,this._logService=a,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(r,u){if(!r)return;const a={$ident:void 0,id:r.command,title:r.title,tooltip:r.tooltip};if(!r.command)return a;const f=this._lookupApiCommand(r.command);if(f)a.id=f.internalId,a.arguments=f.args.map((w,d)=>w.convert(r.arguments&&r.arguments[d]));else if((0,D.isNonEmptyArray)(r.arguments)){const w=++this._cachIdPool;this._cache.set(w,r),u.add((0,E.toDisposable)(()=>{this._cache.delete(w),this._logService.trace("CommandsConverter#DISPOSE",w)})),a.$ident=w,a.id=this.delegatingCommandId,a.arguments=[w],this._logService.trace("CommandsConverter#CREATE",r.command,w)}return a}fromInternal(r){const u=P.ObjectIdentifier.of(r);return typeof u=="number"?this._cache.get(u):{command:r.id,title:r.title,arguments:r.arguments}}getActualCommand(...r){return this._cache.get(r[0])}_executeConvertedCommand(...r){const u=this.getActualCommand(...r);return this._logService.trace("CommandsConverter#EXECUTE",r[0],u?u.command:"MISSING"),u?this._commands.executeCommand(u.command,...u.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=g;class l{constructor(r,u,a,f){this.name=r,this.description=u,this.validate=a,this.convert=f}optional(){return new l(this.name,`(optional) ${this.description}`,r=>r==null||this.validate(r),r=>r===void 0?void 0:r===null?null:this.convert(r))}with(r,u){return new l(r??this.name,u??this.description,this.validate,this.convert)}}e.ApiCommandArgument=l,l.Uri=new l("uri","Uri of a text document",t=>c.URI.isUri(t),t=>t),l.Position=new l("position","A position in a text document",t=>i.Position.isPosition(t),y.Position.from),l.Range=new l("range","A range in a text document",t=>i.Range.isRange(t),y.Range.from),l.Selection=new l("selection","A selection in a text document",t=>i.Selection.isSelection(t),y.Selection.from),l.Number=new l("number","",t=>typeof t=="number",t=>t),l.String=new l("string","",t=>typeof t=="string",t=>t),l.CallHierarchyItem=new l("item","A call hierarchy item",t=>t instanceof i.CallHierarchyItem,y.CallHierarchyItem.from),l.TypeHierarchyItem=new l("item","A type hierarchy item",t=>t instanceof i.TypeHierarchyItem,y.TypeHierarchyItem.from),l.TestItem=new l("testItem","A VS Code TestItem",t=>t instanceof v.TestItemImpl,y.TestItem.from);class S{constructor(r,u){this.description=r,this.convert=u}}e.ApiCommandResult=S,S.Void=new S("no result",t=>t);class n{constructor(r,u,a,f,w){this.id=r,this.internalId=u,this.description=a,this.args=f,this.result=w}}e.ApiCommand=n}),define(ve[231],we([0,1,17,7,84,38,16,110]),function(J,e,m,i,y,C,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const _=[new C.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",L(m.DocumentHighlight.to))),new C.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(c,E)=>{if((0,P.isFalsyOrEmpty)(c))return;class h extends i.SymbolInformation{static to(v){const T=new h(v.name,m.SymbolKind.to(v.kind),v.containerName||"",new i.Location(E[0],m.Range.to(v.range)));return T.detail=v.detail,T.range=T.location.range,T.selectionRange=m.Range.to(v.selectionRange),T.children=v.children?v.children.map(h.to):[],T}}return c.map(h.to)})),new C.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("options","Formatting options",c=>!0,c=>c)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",L(m.TextEdit.to))),new C.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range,new C.ApiCommandArgument("options","Formatting options",c=>!0,c=>c)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",L(m.TextEdit.to))),new C.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,new C.ApiCommandArgument("ch","Trigger character",c=>typeof c=="string",c=>c),new C.ApiCommandArgument("options","Formatting options",c=>!0,c=>c)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",L(m.TextEdit.to))),new C.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",A)),new C.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",A)),new C.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",A)),new C.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",A)),new C.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location-instances.",L(m.location.to))),new C.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Hover-instances.",L(m.Hover.to))),new C.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("position","A position in a text document",c=>Array.isArray(c)&&c.every(E=>i.Position.isPosition(E)),c=>c.map(m.Position.from))],new C.ApiCommandResult("A promise that resolves to an array of ranges.",c=>c.map(E=>{let h;for(const p of E.reverse())h=new i.SelectionRange(m.Range.to(p),h);return h}))),new C.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[C.ApiCommandArgument.String.with("query","Search string")],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",c=>c.map(m.WorkspaceSymbol.to))),new C.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A CallHierarchyItem or undefined",c=>c.map(m.CallHierarchyItem.to))),new C.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A CallHierarchyItem or undefined",c=>c.map(m.CallHierarchyIncomingCall.to))),new C.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A CallHierarchyItem or undefined",c=>c.map(m.CallHierarchyOutgoingCall.to))),new C.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to a range and placeholder text.",c=>{if(!!c)return{range:m.Range.to(c.range),placeholder:c.text}})),new C.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("newName","The new symbol name")],new C.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",c=>{if(!!c){if(c.rejectReason)throw new Error(c.rejectReason);return m.WorkspaceEdit.to(c)}})),new C.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new C.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",c=>c.map(m.DocumentLink.to))),new C.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",c=>{if(!!c)return new i.SemanticTokensLegend(c.tokenTypes,c.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",c=>{if(!c)return;const E=(0,D.decodeSemanticTokensDto)(c);if(E.type==="full")return new i.SemanticTokens(E.data,void 0)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range.optional()],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",c=>{if(!!c)return new i.SemanticTokensLegend(c.tokenTypes,c.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",c=>{if(!c)return;const E=(0,D.decodeSemanticTokensDto)(c);if(E.type==="full")return new i.SemanticTokens(E.data,void 0)})),new C.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new C.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(c,E,h)=>{if(!c)return new i.CompletionList([]);const p=c.suggestions.map(v=>m.CompletionItem.to(v,h));return new i.CompletionList(p,c.incomplete)})),new C.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new C.ApiCommandResult("A promise that resolves to SignatureHelp.",c=>{if(c)return m.SignatureHelp.to(c)})),new C.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new C.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(c,E,h)=>L(p=>new i.CodeLens(m.Range.to(p.range),p.command&&h.fromInternal(p.command)))(c))),new C.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",c=>i.Range.isRange(c),c=>i.Selection.isSelection(c)?m.Selection.from(c):m.Range.from(c)),C.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new C.ApiCommandResult("A promise that resolves to an array of Command-instances.",(c,E,h)=>L(p=>{if(p._isSynthetic){if(!p.command)throw new Error("Synthetic code actions must have a command");return h.fromInternal(p.command)}else{const v=new i.CodeAction(p.title,p.kind?new i.CodeActionKind(p.kind):void 0);return p.edit&&(v.edit=m.WorkspaceEdit.to(p.edit)),p.command&&(v.command=h.fromInternal(p.command)),v.isPreferred=p.isPreferred,v}})(c))),new C.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",c=>c?c.map(E=>new i.ColorInformation(m.Range.to(E.range),m.Color.to(E.color))):[])),new C.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new C.ApiCommandArgument("color","The color to show and insert",c=>c instanceof i.Color,m.Color.from),new C.ApiCommandArgument("context","Context object with uri and range",c=>!0,c=>({uri:c.uri,range:m.Range.from(c.range)}))],new C.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",c=>c?c.map(m.ColorPresentation.to):[])),new C.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of Inlay objects",c=>c.map(m.InlayHint.to))),new C.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new C.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",L(c=>({viewType:c.viewType,displayName:c.displayName,options:{transientOutputs:c.options.transientOutputs,transientCellMetadata:c.options.transientCellMetadata,transientDocumentMetadata:c.options.transientDocumentMetadata},filenamePattern:c.filenamePattern.map(E=>m.NotebookExclusiveDocumentPattern.to(E))})))),new C.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of InlineValue objects",c=>c.map(m.InlineValue.to))),new C.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="number"||typeof c=="object",c=>c&&(typeof c=="number"?[c,void 0]:[m.ViewColumn.from(c.viewColumn),m.TextEditorOpenOptions.from(c)])).optional(),C.ApiCommandArgument.String.with("label","").optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[C.ApiCommandArgument.Uri.with("resource","Resource to open"),C.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="number"||typeof c=="object",c=>c&&(typeof c=="number"?[c,void 0]:[m.ViewColumn.from(c.viewColumn),m.TextEditorOpenOptions.from(c)])).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[C.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),C.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),C.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="object",c=>c&&[m.ViewColumn.from(c.viewColumn),m.TextEditorOpenOptions.from(c)]).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A TypeHierarchyItem or undefined",c=>c.map(m.TypeHierarchyItem.to))),new C.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[C.ApiCommandArgument.TypeHierarchyItem],new C.ApiCommandResult("A TypeHierarchyItem or undefined",c=>c.map(m.TypeHierarchyItem.to))),new C.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[C.ApiCommandArgument.TypeHierarchyItem],new C.ApiCommandResult("A TypeHierarchyItem or undefined",c=>c.map(m.TypeHierarchyItem.to))),new C.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[C.ApiCommandArgument.TestItem],C.ApiCommandResult.Void)];class I{static register(E){_.forEach(E.registerApiCommand,E)}}e.ExtHostApiCommands=I;function L(c){return E=>{if(Array.isArray(E))return E.map(c)}}function A(c){if(!Array.isArray(c))return;const E=[];for(const h of c)y.isLocationLink(h)?E.push(m.DefinitionLink.to(h)):E.push(m.location.to(h));return E}}),define(ve[232],we([0,1,18,57,3,6,2,84,27,17,7,5]),function(J,e,m,i,y,C,P,D,_,I,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function c(E,h,p){const v=E.getProxy(A.MainContext.MainThreadComments);class T{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,h.registerArgumentProcessor({processArgument:t=>{if(t&&t.$mid===6){const r=this._commentControllers.get(t.handle);return r||t}else if(t&&t.$mid===7){const r=this._commentControllers.get(t.commentControlHandle);if(!r)return t;const u=r.getCommentThread(t.commentThreadHandle);return u||t}else if(t&&t.$mid===8){const r=this._commentControllers.get(t.thread.commentControlHandle);if(!r)return t;const u=r.getCommentThread(t.thread.commentThreadHandle);return u?{thread:u,text:t.text}:t}else if(t&&t.$mid===9){const r=this._commentControllers.get(t.thread.commentControlHandle);if(!r)return t;const u=r.getCommentThread(t.thread.commentThreadHandle);if(!u)return t;let a=t.commentUniqueId,f=u.getCommentByUniqueId(a);return f||t}else if(t&&t.$mid===10){const r=this._commentControllers.get(t.thread.commentControlHandle);if(!r)return t;const u=r.getCommentThread(t.thread.commentThreadHandle);if(!u)return t;let a=t.text,f=t.commentUniqueId,w=u.getCommentByUniqueId(f);return w?(w.body=a,w):t}return t}})}createCommentController(t,r,u){const a=T.handlePool++,f=new o(t,a,r,u);this._commentControllers.set(f.handle,f);const w=this._commentControllersByExtension.get(_.ExtensionIdentifier.toKey(t.identifier))||[];return w.push(f),this._commentControllersByExtension.set(_.ExtensionIdentifier.toKey(t.identifier),w),f.value}$createCommentThreadTemplate(t,r,u){const a=this._commentControllers.get(t);!a||a.$createCommentThreadTemplate(r,u)}async $updateCommentThreadTemplate(t,r,u){const a=this._commentControllers.get(t);!a||a.$updateCommentThreadTemplate(r,u)}$deleteCommentThread(t,r){const u=this._commentControllers.get(t);u&&u.$deleteCommentThread(r)}$provideCommentingRanges(t,r,u){const a=this._commentControllers.get(t);if(!a||!a.commentingRangeProvider)return Promise.resolve(void 0);const f=p.getDocument(P.URI.revive(r));return(0,m.asPromise)(()=>a.commentingRangeProvider.provideCommentingRanges(f,u)).then(w=>w?w.map(d=>I.Range.from(d)):void 0)}$toggleReaction(t,r,u,a,f){const w=this._commentControllers.get(t);return!w||!w.reactionHandler?Promise.resolve(void 0):(0,m.asPromise)(()=>{const d=w.getCommentThread(r);if(d){const k=d.getCommentByUniqueId(a.uniqueIdInThread);if(w!==void 0&&k&&w.reactionHandler)return w.reactionHandler(k,l(f))}return Promise.resolve(void 0)})}dispose(){}}T.handlePool=0;class b{constructor(t,r,u,a,f,w,d){this._commentControllerHandle=r,this._id=u,this._uri=a,this._range=f,this._comments=w,this.handle=b._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new y.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new C.MutableDisposable,this._acceptInputDisposables.value=new C.DisposableStore,this._id===void 0&&(this._id=`${t}.${this.handle}`),v.$createCommentThread(r,this.handle,this._id,this._uri,I.Range.from(this._range),d),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=w,this._localDisposables.push({dispose:()=>{v.$deleteCommentThread(r,this.handle)}});const k=this;this.value={get uri(){return k.uri},get range(){return k.range},set range(R){k.range=R},get comments(){return k.comments},set comments(R){k.comments=R},get collapsibleState(){return k.collapsibleState},set collapsibleState(R){k.collapsibleState=R},get canReply(){return k.canReply},set canReply(R){k.canReply=R},get contextValue(){return k.contextValue},set contextValue(R){k.contextValue=R},get label(){return k.label},set label(R){k.label=R},dispose:()=>{k.dispose()}}}set threadId(t){this._id=t}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(t){t.isEqual(this._range)||(this._range=t,this.modifications.range=t,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(t){this._canReply!==t&&(this._canReply=t,this.modifications.canReply=t,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(t){this._label=t,this.modifications.label=t,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(t){this._contextValue=t,this.modifications.contextValue=t,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(t){this._comments=t,this.modifications.comments=t,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(t){this._collapseState=t,this.modifications.collapsibleState=t,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new C.DisposableStore);const t=u=>Object.prototype.hasOwnProperty.call(this.modifications,u),r={};t("range")&&(r.range=I.Range.from(this._range)),t("label")&&(r.label=this.label),t("contextValue")&&(r.contextValue=this.contextValue??null),t("comments")&&(r.comments=this._comments.map(u=>s(this,u,this._commentsMap))),t("collapsibleState")&&(r.collapseState=S(this._collapseState)),t("canReply")&&(r.canReply=this.canReply),this.modifications={},v.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,r)}getCommentByUniqueId(t){for(let r of this._commentsMap){let u=r[0],a=r[1];if(t===a)return u}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(t=>t.dispose())}}b._handlePool=0,je([(0,i.debounce)(100)],b.prototype,"eventuallyUpdateCommentThread",null);class o{constructor(t,r,u,a){this._extension=t,this._handle=r,this._id=u,this._label=a,this._threads=new Map,v.$registerCommentController(this.handle,u,a);const f=this;this.value=Object.freeze({id:f.id,label:f.label,get options(){return f.options},set options(w){f.options=w},get commentingRangeProvider(){return f.commentingRangeProvider},set commentingRangeProvider(w){f.commentingRangeProvider=w},get reactionHandler(){return f.reactionHandler},set reactionHandler(w){f.reactionHandler=w},createCommentThread(w,d,k){return f.createCommentThread(w,d,k).value},dispose:()=>{f.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{v.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(t){this._commentingRangeProvider=t,v.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(t){this._reactionHandler=t,v.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!t})}get options(){return this._options}set options(t){this._options=t,v.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(t,r,u,a){if(typeof t=="string"){const f=new b(this.id,this.handle,t,r,u,a,this._extension.identifier);return this._threads.set(f.handle,f),f}else{const f=new b(this.id,this.handle,void 0,t,r,u,this._extension.identifier);return this._threads.set(f.handle,f),f}}$createCommentThreadTemplate(t,r){const u=new b(this.id,this.handle,void 0,P.URI.revive(t),I.Range.to(r),[],this._extension.identifier);return u.collapsibleState=D.CommentThreadCollapsibleState.Expanded,this._threads.set(u.handle,u),u}$updateCommentThreadTemplate(t,r){let u=this._threads.get(t);u&&(u.range=I.Range.to(r))}$deleteCommentThread(t){let r=this._threads.get(t);r&&r.dispose(),this._threads.delete(t)}getCommentThread(t){return this._threads.get(t)}dispose(){this._threads.forEach(t=>{t.dispose()}),this._localDisposables.forEach(t=>t.dispose())}}function s(n,t,r){let u=r.get(t);u||(u=++n.commentHandle,r.set(t,u));const a=t.author&&t.author.iconPath?t.author.iconPath.toString():void 0;return{mode:t.mode,contextValue:t.contextValue,uniqueIdInThread:u,body:I.MarkdownString.from(t.body),userName:t.author.name,userIconPath:a,label:t.label,commentReactions:t.reactions?t.reactions.map(f=>g(f)):void 0}}function g(n){return{label:n.label,iconPath:n.iconPath?I.pathOrURIToURI(n.iconPath):void 0,count:n.count,hasReacted:n.authorHasReacted}}function l(n){return{label:n.label||"",count:n.count||0,iconPath:n.iconPath?P.URI.revive(n.iconPath):"",authorHasReacted:n.hasReacted||!1}}function S(n){if(n!==void 0)switch(n){case L.CommentThreadCollapsibleState.Expanded:return D.CommentThreadCollapsibleState.Expanded;case L.CommentThreadCollapsibleState.Collapsed:return D.CommentThreadCollapsibleState.Collapsed}return D.CommentThreadCollapsibleState.Collapsed}return new T}e.createExtHostComments=c}),define(ve[130],we([0,1,2,5,7,4,14,11,16,8,9]),function(J,e,m,i,y,C,P,D,_,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let A=class bi{constructor(E,h){this._logService=h,this._provider=new Map,this._proxy=E.getProxy(i.MainContext.MainThreadDecorations)}registerFileDecorationProvider(E,h){const p=bi._handlePool++;this._provider.set(p,{provider:E,extensionId:h}),this._proxy.$registerDecorationProvider(p,h.value);const v=E.onDidChangeFileDecorations&&E.onDidChangeFileDecorations(T=>{if(!T){this._proxy.$onDidChange(p,null);return}let b=(0,_.asArray)(T);if(b.length<=bi._maxEventSize){this._proxy.$onDidChange(p,b);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",h.value,b.length);const o=b.map(l=>({uri:l,rank:(0,I.count)(l.path,"/")})),s=(0,_.groupBy)(o,(l,S)=>l.rank-S.rank||(0,I.compare)(l.uri.path,S.uri.path));let g=[];e:for(let l of s){let S;for(let n of l){let t=(0,L.dirname)(n.uri.path);if(S!==t&&(S=t,g.push(n.uri)>=bi._maxEventSize))break e}}this._proxy.$onDidChange(p,g)});return new y.Disposable(()=>{v?.dispose(),this._proxy.$unregisterDecorationProvider(p),this._provider.delete(p)})}async $provideDecorations(E,h,p){if(!this._provider.has(E))return Object.create(null);const v=Object.create(null),{provider:T,extensionId:b}=this._provider.get(E);return await Promise.all(h.map(async o=>{try{const{uri:s,id:g}=o,l=await Promise.resolve(T.provideFileDecoration(m.URI.revive(s),p));if(!l)return;try{y.FileDecoration.validate(l),v[g]=[l.propagate,l.tooltip,l.badge,l.color]}catch(S){this._logService.warn(`INVALID decoration from extension '${b.value}': ${S}`)}}catch(s){this._logService.error(s)}})),v}};A._handlePool=0,A._maxEventSize=250,A=je([ze(0,P.IExtHostRpcService),ze(1,D.ILogService)],A),e.ExtHostDecorations=A,e.IExtHostDecorations=(0,C.createDecorator)("IExtHostDecorations")});var nt=this&&this.__classPrivateFieldSet||function(J,e,m,i,y){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!y:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?y.call(J,m):y?y.value=m:e.set(J,m),m},Be=this&&this.__classPrivateFieldGet||function(J,e,m,i){if(m==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!i:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?i:m==="a"?i.call(J):i?i.value:e.get(J)};define(ve[233],we([0,1,162,116,2,5,7,17,3,11,24,44]),function(J,e,m,i,y,C,P,D,_,I,L,A){"use strict";var c,E,h;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class p{constructor(b,o,s,g,l,S){this._name=b,this._owner=o,this._maxDiagnosticsPerFile=s,c.set(this,void 0),E.set(this,void 0),h.set(this,void 0),this._isDisposed=!1,nt(this,h,new L.ResourceMap(n=>g.getComparisonKey(n)),"f"),nt(this,c,l,"f"),nt(this,E,S,"f")}dispose(){this._isDisposed||(Be(this,E,"f").fire([...Be(this,h,"f").keys()]),Be(this,c,"f")&&Be(this,c,"f").$clear(this._owner),Be(this,h,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(b,o){if(!b){this.clear();return}this._checkDisposed();let s=[];if(y.URI.isUri(b)){if(!o){this.delete(b);return}Be(this,h,"f").set(b,o.slice()),s=[b]}else if(Array.isArray(b)){s=[];let l;b=[...b].sort(p._compareIndexedTuplesByUri);for(const S of b){const[n,t]=S;if((!l||n.toString()!==l.toString())&&(l&&Be(this,h,"f").get(l).length===0&&Be(this,h,"f").delete(l),l=n,s.push(n),Be(this,h,"f").set(n,[])),t){const r=Be(this,h,"f").get(n);r&&r.push(...t)}else{const r=Be(this,h,"f").get(n);r&&(r.length=0)}}}if(Be(this,E,"f").fire(s),!Be(this,c,"f"))return;const g=[];for(let l of s){let S=[];const n=Be(this,h,"f").get(l);if(n)if(n.length>this._maxDiagnosticsPerFile){S=[];const t=[P.DiagnosticSeverity.Error,P.DiagnosticSeverity.Warning,P.DiagnosticSeverity.Information,P.DiagnosticSeverity.Hint];e:for(let r=0;r<4;r++)for(let u of n)if(u.severity===t[r]&&S.push(D.Diagnostic.from(u))===this._maxDiagnosticsPerFile)break e;S.push({severity:i.MarkerSeverity.Info,message:(0,m.localize)(0,null,n.length-this._maxDiagnosticsPerFile),startLineNumber:S[S.length-1].startLineNumber,startColumn:S[S.length-1].startColumn,endLineNumber:S[S.length-1].endLineNumber,endColumn:S[S.length-1].endColumn})}else S=n.map(t=>D.Diagnostic.from(t));g.push([l,S])}Be(this,c,"f").$changeMany(this._owner,g)}delete(b){this._checkDisposed(),Be(this,E,"f").fire([b]),Be(this,h,"f").delete(b),Be(this,c,"f")&&Be(this,c,"f").$changeMany(this._owner,[[b,void 0]])}clear(){this._checkDisposed(),Be(this,E,"f").fire([...Be(this,h,"f").keys()]),Be(this,h,"f").clear(),Be(this,c,"f")&&Be(this,c,"f").$clear(this._owner)}forEach(b,o){this._checkDisposed();for(let s of Be(this,h,"f").keys())b.apply(o,[s,this.get(s),this])}get(b){this._checkDisposed();const o=Be(this,h,"f").get(b);return Array.isArray(o)?Object.freeze(o.slice(0)):[]}has(b){return this._checkDisposed(),Array.isArray(Be(this,h,"f").get(b))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(b,o){return b[0].toString()<o[0].toString()?-1:b[0].toString()>o[0].toString()?1:0}}e.DiagnosticCollection=p,c=new WeakMap,E=new WeakMap,h=new WeakMap;let v=class ri{constructor(b,o,s){this._logService=o,this._fileSystemInfoService=s,this._collections=new Map,this._onDidChangeDiagnostics=new _.DebounceEmitter({merge:g=>g.flat(),delay:50}),this.onDidChangeDiagnostics=_.Event.map(this._onDidChangeDiagnostics.event,ri._mapper),this._proxy=b.getProxy(C.MainContext.MainThreadDiagnostics)}static _mapper(b){const o=new L.ResourceMap;for(const s of b)o.set(s,s);return{uris:Object.freeze(Array.from(o.values()))}}createDiagnosticCollection(b,o){const{_collections:s,_proxy:g,_onDidChangeDiagnostics:l,_logService:S,_fileSystemInfoService:n}=this,t=new class{$changeMany(a,f){g.$changeMany(a,f),S.trace("[DiagnosticCollection] change many (extension, owner, uris)",b.value,a,f.length===0?"CLEARING":f)}$clear(a){g.$clear(a),S.trace("[DiagnosticCollection] remove all (extension, owner)",b.value,a)}dispose(){g.dispose()}};let r;if(!o)o="_generated_diagnostic_collection_name_#"+ri._idPool++,r=o;else if(!s.has(o))r=o;else{this._logService.warn(`DiagnosticCollection with name '${o}' does already exist.`);do r=o+ri._idPool++;while(s.has(r))}return new class extends p{constructor(){super(o,r,ri._maxDiagnosticsPerFile,n.extUri,t,l);s.set(r,this)}dispose(){super.dispose(),s.delete(r)}}}getDiagnostics(b){if(b)return this._getDiagnostics(b);{const o=new Map,s=[];for(const g of this._collections.values())g.forEach((l,S)=>{let n=o.get(l.toString());typeof n=="undefined"&&(n=s.length,o.set(l.toString(),n),s.push([l,[]])),s[n][1]=s[n][1].concat(...S)});return s}}_getDiagnostics(b){let o=[];for(let s of this._collections.values())s.has(b)&&(o=o.concat(s.get(b)));return o}$acceptMarkersChange(b){if(!this._mirrorCollection){const o="_generated_mirror",s=new p(o,o,ri._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(o,s),this._mirrorCollection=s}for(const[o,s]of b)this._mirrorCollection.set(y.URI.revive(o),s.map(D.Diagnostic.to))}};v._idPool=0,v._maxDiagnosticsPerFile=1e3,v=je([ze(1,I.ILogService),ze(2,A.IExtHostFileSystemInfo)],v),e.ExtHostDiagnostics=v}),define(ve[234],we([0,1,2,5]),function(J,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class y{constructor(P){this._proxy=P.getProxy(i.MainContext.MainThreadDialogs)}showOpenDialog(P){return this._proxy.$showOpenDialog(P).then(D=>D?D.map(_=>m.URI.revive(_)):void 0)}showSaveDialog(P){return this._proxy.$showSaveDialog(P).then(D=>D?m.URI.revive(D):void 0)}}e.ExtHostDialogs=y}),define(ve[235],we([0,1,15,2,7,5,10,21,8]),function(J,e,m,i,y,C,P,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class I{constructor(A,c,E){this._documentsAndEditors=c,this._logService=E,this._documentContentProviders=new Map,this._proxy=A.getProxy(C.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(A,c){if(Object.keys(P.Schemas).indexOf(A)>=0)throw new Error(`scheme '${A}' already registered`);const E=I._handlePool++;this._documentContentProviders.set(E,c),this._proxy.$registerTextContentProvider(E,A);let h;return typeof c.onDidChange=="function"&&(h=c.onDidChange(p=>{if(p.scheme!==A){this._logService.warn(`Provider for scheme '${A}' is firing event for schema '${p.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(p)&&this.$provideTextDocumentContent(E,p).then(v=>{if(!v&&typeof v!="string")return;const T=this._documentsAndEditors.getDocument(p);if(!T)return;const b=(0,_.splitLines)(v);if(!T.equalLines(b))return this._proxy.$onVirtualDocumentChange(p,v)},m.onUnexpectedError)})),new y.Disposable(()=>{this._documentContentProviders.delete(E)&&this._proxy.$unregisterTextContentProvider(E),h&&(h.dispose(),h=void 0)})}$provideTextDocumentContent(A,c){const E=this._documentContentProviders.get(A);return E?Promise.resolve(E.provideTextDocumentContent(i.URI.revive(c),D.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${c.scheme}`))}}e.ExtHostDocumentContentProvider=I,I._handlePool=0}),define(ve[236],we([0,1,3,6,2,5,122,17,13,25,7]),function(J,e,m,i,y,C,P,D,_,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class A{constructor(E,h){this._onDidAddDocument=new m.Emitter,this._onDidRemoveDocument=new m.Emitter,this._onDidChangeDocument=new m.Emitter,this._onDidSaveDocument=new m.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new i.DisposableStore,this._documentLoader=new Map,this._proxy=E.getProxy(C.MainContext.MainThreadDocuments),this._documentsAndEditors=h,this._documentsAndEditors.onDidRemoveDocuments(p=>{for(const v of p)this._onDidRemoveDocument.fire(v.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(p=>{for(const v of p)this._onDidAddDocument.fire(v.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(E){if(!E)return;const h=this._documentsAndEditors.getDocument(E);if(h)return h}getDocument(E){const h=this.getDocumentData(E);if(!h?.document)throw new Error(`Unable to retrieve document from URI '${E}'`);return h.document}ensureDocumentData(E){const h=this._documentsAndEditors.getDocument(E);if(h)return Promise.resolve(h);let p=this._documentLoader.get(E.toString());return p||(p=this._proxy.$tryOpenDocument(E).then(v=>{this._documentLoader.delete(E.toString());const T=y.URI.revive(v);return(0,_.assertIsDefined)(this._documentsAndEditors.getDocument(T))},v=>(this._documentLoader.delete(E.toString()),Promise.reject(v))),this._documentLoader.set(E.toString(),p)),p}createDocumentData(E){return this._proxy.$tryCreateDocument(E).then(h=>y.URI.revive(h))}$acceptModelModeChanged(E,h){const p=y.URI.revive(E),v=this._documentsAndEditors.getDocument(p);if(!v)throw new Error("unknown document");this._onDidRemoveDocument.fire(v.document),v._acceptLanguageId(h),this._onDidAddDocument.fire(v.document)}$acceptModelSaved(E){const h=y.URI.revive(E),p=this._documentsAndEditors.getDocument(h);if(!p)throw new Error("unknown document");this.$acceptDirtyStateChanged(E,!1),this._onDidSaveDocument.fire(p.document)}$acceptDirtyStateChanged(E,h){const p=y.URI.revive(E),v=this._documentsAndEditors.getDocument(p);if(!v)throw new Error("unknown document");v._acceptIsDirty(h),this._onDidChangeDocument.fire({document:v.document,contentChanges:[],reason:void 0})}$acceptModelChanged(E,h,p){const v=y.URI.revive(E),T=this._documentsAndEditors.getDocument(v);if(!T)throw new Error("unknown document");T._acceptIsDirty(p),T.onEvents(h);let b;h.isUndoing?b=L.TextDocumentChangeReason.Undo:h.isRedoing&&(b=L.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,I.deepFreeze)({document:T.document,contentChanges:h.changes.map(o=>({range:D.Range.to(o.range),rangeOffset:o.rangeOffset,rangeLength:o.rangeLength,text:o.text})),reason:b}))}setWordDefinitionFor(E,h){(0,P.setWordDefinitionFor)(E,h)}}e.ExtHostDocuments=A}),define(ve[45],we([0,1,56,3,6,2,4,5,122,14,129,17,11,24,10,77,140]),function(J,e,m,i,y,C,P,D,_,I,L,A,c,E,h,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class T{constructor(s){this.value=s,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let b=class{constructor(s,g){this._extHostRpc=s,this._logService=g,this._activeEditorId=null,this._editors=new Map,this._documents=new E.ResourceMap,this._onDidAddDocuments=new i.Emitter,this._onDidRemoveDocuments=new i.Emitter,this._onDidChangeVisibleTextEditors=new i.Emitter,this._onDidChangeActiveTextEditor=new i.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(s){this.acceptDocumentsAndEditorsDelta(s)}acceptDocumentsAndEditorsDelta(s){const g=[],l=[],S=[];if(s.removedDocuments)for(const n of s.removedDocuments){const t=C.URI.revive(n),r=this._documents.get(t);r?.unref()&&(this._documents.delete(t),g.push(r.value))}if(s.addedDocuments)for(const n of s.addedDocuments){const t=C.URI.revive(n.uri);let r=this._documents.get(t);if(r&&t.scheme!==h.Schemas.vscodeNotebookCell&&t.scheme!==h.Schemas.vscodeInteractiveInput)throw new Error(`document '${t} already exists!'`);r||(r=new T(new _.ExtHostDocumentData(this._extHostRpc.getProxy(D.MainContext.MainThreadDocuments),t,n.lines,n.EOL,n.versionId,n.languageId,n.isDirty,n.notebook)),this._documents.set(t,r),l.push(r.value)),r.ref()}if(s.removedEditors)for(const n of s.removedEditors){const t=this._editors.get(n);this._editors.delete(n),t&&S.push(t)}if(s.addedEditors)for(const n of s.addedEditors){const t=C.URI.revive(n.documentUri);m.ok(this._documents.has(t),`document '${t}' does not exist`),m.ok(!this._editors.has(n.id),`editor '${n.id}' already exists!`);const r=this._documents.get(t).value,u=new L.ExtHostTextEditor(n.id,this._extHostRpc.getProxy(D.MainContext.MainThreadTextEditors),this._logService,new v.Lazy(()=>r.document),n.selections.map(A.Selection.to),n.options,n.visibleRanges.map(a=>A.Range.to(a)),typeof n.editorPosition=="number"?A.ViewColumn.to(n.editorPosition):void 0);this._editors.set(n.id,u)}s.newActiveEditor!==void 0&&(m.ok(s.newActiveEditor===null||this._editors.has(s.newActiveEditor),`active editor '${s.newActiveEditor}' does not exist`),this._activeEditorId=s.newActiveEditor),(0,y.dispose)(g),(0,y.dispose)(S),s.removedDocuments&&this._onDidRemoveDocuments.fire(g),s.addedDocuments&&this._onDidAddDocuments.fire(l),(s.removedEditors||s.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(n=>n.value)),s.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(s){return this._documents.get(s)?.value}allDocuments(){return p.Iterable.map(this._documents.values(),s=>s.value)}getEditor(s){return this._editors.get(s)}activeEditor(s){if(!this._activeEditorId)return;const g=this._editors.get(this._activeEditorId);return s?g:g?.value}allEditors(){return[...this._editors.values()]}};b=je([ze(0,I.IExtHostRpcService),ze(1,c.ILogService)],b),e.ExtHostDocumentsAndEditors=b,e.IExtHostDocumentsAndEditors=(0,P.createDecorator)("IExtHostDocumentsAndEditors")}),define(ve[54],we([0,1,17,5,2,3,4,14,18]),function(J,e,m,i,y,C,P,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,P.createDecorator)("IExtHostEditorTabs");let I=class{constructor(A){this._onDidChangeTabs=new C.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._onDidChangeActiveTab=new C.Emitter,this.onDidChangeActiveTab=this._onDidChangeActiveTab.event,this._tabs=[],this._proxy=A.getProxy(i.MainContext.MainThreadEditorTabs)}get tabs(){return this._tabs}get activeTab(){return this._activeTab}$acceptEditorTabs(A){let c=-1;this._tabs=A.map((h,p)=>(h.isActive&&(c=p),Object.freeze({label:h.label,viewColumn:m.ViewColumn.to(h.viewColumn),index:p,resource:y.URI.revive(h.resource),additionalResourcesAndViewIds:h.additionalResourcesAndViewIds.map(({resource:v,viewId:T})=>({resource:y.URI.revive(v),viewId:T})),viewId:h.editorId,isActive:h.isActive,move:async(v,T)=>{this._proxy.$moveTab(h,v,m.ViewColumn.from(T)),await(0,_.raceTimeout)(C.Event.toPromise(this._onDidChangeTabs.event),1e3)},close:async()=>{await this._proxy.$closeTab(h),await(0,_.raceTimeout)(C.Event.toPromise(this._onDidChangeTabs.event),1e3)}}))),this._tabs=this._tabs.sort((h,p)=>h.viewColumn===p.viewColumn?h.index-p.index:h.viewColumn-p.viewColumn);const E=this._activeTab;this._activeTab=c===-1?void 0:this._tabs[c],this._activeTab!==E&&this._onDidChangeActiveTab.fire(this._activeTab),this._onDidChangeTabs.fire(this._tabs)}};I=je([ze(0,D.IExtHostRpcService)],I),e.ExtHostEditorTabs=I}),define(ve[237],we([0,1,2,5,6,7,17,147,8,22,29]),function(J,e,m,i,y,C,P,D,_,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class A{constructor(){this._schemes=[]}add(h){this._stateMachine=void 0,this._schemes.push(h)}delete(h){const p=this._schemes.indexOf(h);p>=0&&(this._schemes.splice(p,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const h=this._schemes.sort(),p=[];let v,T,b=14,o=14;for(const s of h){let g=v?(0,_.commonPrefixLength)(v,s):0;for(g===0?T=1:T=o;g<s.length;g++)g+1===s.length?(b=o,o=9):o+=1,p.push([T,s.toUpperCase().charCodeAt(g),o]),p.push([T,s.toLowerCase().charCodeAt(g),o]),T=o;v=s,o=b}p.push([9,58,10]),p.push([10,47,12]),this._stateMachine=new D.StateMachine(p)}}provideDocumentLinks(h){this._initStateMachine();const p=[],v=D.LinkComputer.computeLinks({getLineContent(T){return h.lineAt(T-1).text},getLineCount(){return h.lineCount}},this._stateMachine);for(const T of v){const b=P.DocumentLink.to(T);b.target&&p.push(b)}return p}}class c{constructor(h,p){this._extHostLanguageFeatures=p,this._linkProvider=new A,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=h.getProxy(i.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(h,p,v,T={}){if(this._registeredSchemes.has(p))throw new Error(`a provider for the scheme '${p}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const b=this._handlePool++;this._linkProvider.add(p),this._registeredSchemes.add(p),this._fsProvider.set(b,v);let o=2;T.isCaseSensitive&&(o+=1024),T.isReadonly&&(o+=2048),typeof v.copy=="function"&&(o+=8),typeof v.open=="function"&&typeof v.close=="function"&&typeof v.read=="function"&&typeof v.write=="function"&&((0,L.checkProposedApiEnabled)(h,"fsChunks"),o+=4),this._proxy.$registerFileSystemProvider(b,p,o).catch(g=>{console.error(`FAILED to register filesystem provider of ${h.identifier.value}-extension for the scheme ${p}`),console.error(g)});const s=v.onDidChangeFile(g=>{const l=[];for(const S of g){let{uri:n,type:t}=S;if(n.scheme!==p)continue;let r;switch(t){case C.FileChangeType.Changed:r=0;break;case C.FileChangeType.Created:r=1;break;case C.FileChangeType.Deleted:r=2;break;default:throw new Error("Unknown FileChangeType")}l.push({resource:n,type:r})}this._proxy.$onFileSystemChange(b,l)});return(0,y.toDisposable)(()=>{s.dispose(),this._linkProvider.delete(p),this._registeredSchemes.delete(p),this._fsProvider.delete(b),this._proxy.$unregisterProvider(b)})}static _asIStat(h){const{type:p,ctime:v,mtime:T,size:b,permissions:o}=h;return{type:p,ctime:v,mtime:T,size:b,permissions:o}}$stat(h,p){return Promise.resolve(this._getFsProvider(h).stat(m.URI.revive(p))).then(v=>c._asIStat(v))}$readdir(h,p){return Promise.resolve(this._getFsProvider(h).readDirectory(m.URI.revive(p)))}$readFile(h,p){return Promise.resolve(this._getFsProvider(h).readFile(m.URI.revive(p))).then(v=>I.VSBuffer.wrap(v))}$writeFile(h,p,v,T){return Promise.resolve(this._getFsProvider(h).writeFile(m.URI.revive(p),v.buffer,T))}$delete(h,p,v){return Promise.resolve(this._getFsProvider(h).delete(m.URI.revive(p),v))}$rename(h,p,v,T){return Promise.resolve(this._getFsProvider(h).rename(m.URI.revive(p),m.URI.revive(v),T))}$copy(h,p,v,T){const b=this._getFsProvider(h);if(!b.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(b.copy(m.URI.revive(p),m.URI.revive(v),T))}$mkdir(h,p){return Promise.resolve(this._getFsProvider(h).createDirectory(m.URI.revive(p)))}$watch(h,p,v,T){const b=this._getFsProvider(h).watch(m.URI.revive(v),T);this._watches.set(p,b)}$unwatch(h,p){const v=this._watches.get(p);v&&(v.dispose(),this._watches.delete(p))}$open(h,p,v){const T=this._getFsProvider(h);if(!T.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(T.open(m.URI.revive(p),v))}$close(h,p){const v=this._getFsProvider(h);if(!v.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(v.close(p))}$read(h,p,v,T){const b=this._getFsProvider(h);if(!b.read)throw new Error('FileSystemProvider does not implement "read"');const o=I.VSBuffer.alloc(T);return Promise.resolve(b.read(p,v,o.buffer,0,T)).then(s=>o.slice(0,s))}$write(h,p,v,T){const b=this._getFsProvider(h);if(!b.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(b.write(p,v,T.buffer,0,T.byteLength))}_getFsProvider(h){const p=this._fsProvider.get(h);if(!p){const v=new Error;throw v.name="ENOPRO",v.message="no provider",v}return p}}e.ExtHostFileSystem=c}),define(ve[66],we([0,1,5,42,7,22,4,14,44,6]),function(J,e,m,i,y,C,P,D,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let L=class zt{constructor(c,E){this._fileSystemProvider=new Map,this._proxy=c.getProxy(m.MainContext.MainThreadFileSystem);const h=this;this.value=Object.freeze({async stat(p){try{const v=h._fileSystemProvider.get(p.scheme);if(!v)return await h._proxy.$stat(p);await h._proxy.$ensureActivation(p.scheme);const T=await v.stat(p);return{type:T.type,ctime:T.ctime,mtime:T.mtime,size:T.size,permissions:T.permissions}}catch(v){zt._handleError(v)}},async readDirectory(p){try{const v=h._fileSystemProvider.get(p.scheme);return v?(await h._proxy.$ensureActivation(p.scheme),(await v.readDirectory(p)).slice()):await h._proxy.$readdir(p)}catch(v){return zt._handleError(v)}},async createDirectory(p){try{return await h._proxy.$mkdir(p)}catch(v){return zt._handleError(v)}},async readFile(p){try{const v=h._fileSystemProvider.get(p.scheme);return v?(await h._proxy.$ensureActivation(p.scheme),(await v.readFile(p)).slice()):(await h._proxy.$readFile(p)).buffer}catch(v){return zt._handleError(v)}},async writeFile(p,v){try{return await h._proxy.$writeFile(p,C.VSBuffer.wrap(v))}catch(T){return zt._handleError(T)}},async delete(p,v){try{const T=h._fileSystemProvider.get(p.scheme);return T?(await h._proxy.$ensureActivation(p.scheme),await T.delete(p,{recursive:!1,...v})):await h._proxy.$delete(p,{recursive:!1,useTrash:!1,...v})}catch(T){return zt._handleError(T)}},async rename(p,v,T){try{return await h._proxy.$rename(p,v,{overwrite:!1,...T})}catch(b){return zt._handleError(b)}},async copy(p,v,T){try{return await h._proxy.$copy(p,v,{overwrite:!1,...T})}catch(b){return zt._handleError(b)}},isWritableFileSystem(p){const v=E.getCapabilities(p);if(typeof v=="number")return!(v&2048)}})}static _handleError(c){if(c instanceof y.FileSystemError)throw c;if(!(c instanceof Error))throw new y.FileSystemError(String(c));if(c.name==="ENOPRO")throw y.FileSystemError.Unavailable(c.message);switch(c.name){case i.FileSystemProviderErrorCode.FileExists:throw y.FileSystemError.FileExists(c.message);case i.FileSystemProviderErrorCode.FileNotFound:throw y.FileSystemError.FileNotFound(c.message);case i.FileSystemProviderErrorCode.FileNotADirectory:throw y.FileSystemError.FileNotADirectory(c.message);case i.FileSystemProviderErrorCode.FileIsADirectory:throw y.FileSystemError.FileIsADirectory(c.message);case i.FileSystemProviderErrorCode.NoPermissions:throw y.FileSystemError.NoPermissions(c.message);case i.FileSystemProviderErrorCode.Unavailable:throw y.FileSystemError.Unavailable(c.message);default:throw new y.FileSystemError(c.message,c.name)}}addFileSystemProvider(c,E){return this._fileSystemProvider.set(c,E),(0,I.toDisposable)(()=>this._fileSystemProvider.delete(c))}};L=je([ze(0,D.IExtHostRpcService),ze(1,_.IExtHostFileSystemInfo)],L),e.ExtHostConsumerFileSystem=L,e.IExtHostConsumerFileSystem=(0,P.createDecorator)("IExtHostConsumerFileSystem")}),define(ve[238],we([0,1,2,38]),function(J,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class y{constructor(P,D,_,I){this._extHostNotebooks=D,this._textDocumentsAndEditors=_,this._commands=I;const L=new i.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new i.ApiCommandArgument("showOptions","Show Options",A=>!0,A=>A),new i.ApiCommandArgument("resource","Interactive resource Uri",A=>!0,A=>A),new i.ApiCommandArgument("controllerId","Notebook controller Id",A=>!0,A=>A),new i.ApiCommandArgument("title","Interactive editor title",A=>!0,A=>A)],new i.ApiCommandResult("Notebook and input URI",A=>{if(A.notebookEditorId!==void 0){const c=this._extHostNotebooks.getEditorById(A.notebookEditorId);return{notebookUri:m.URI.revive(A.notebookUri),inputUri:m.URI.revive(A.inputUri),notebookEditor:c.apiEditor}}return{notebookUri:m.URI.revive(A.notebookUri),inputUri:m.URI.revive(A.inputUri)}}));this._commands.registerApiCommand(L)}$willAddInteractiveDocument(P,D,_,I){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:D,lines:[""],languageId:_,uri:P,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(m.URI.revive(I))?.apiNotebook}]})}$willRemoveInteractiveDocument(P,D){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[P]})}}e.ExtHostInteractive=y}),define(ve[239],we([0,1,6,5]),function(J,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class y{constructor(P){this._handlePool=0,this._proxy=P.getProxy(i.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(P){const D=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(D,P),(0,m.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(D)})}}e.ExtHostLabelService=y}),define(ve[240],we([0,1,2,25,17,7,5,8,41,16,13,144,6,110,76,87,46,15,3]),function(J,e,m,i,y,C,P,D,_,I,L,A,c,E,h,p,v,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class o{constructor(j,Z){this._documents=j,this._provider=Z}async provideDocumentSymbols(j,Z){const re=this._documents.getDocument(j),ue=await this._provider.provideDocumentSymbols(re,Z);if(!(0,I.isFalsyOrEmpty)(ue))return ue[0]instanceof C.DocumentSymbol?ue.map(y.DocumentSymbol.from):o._asDocumentSymbolTree(ue)}static _asDocumentSymbolTree(j){j=j.slice(0).sort((ue,te)=>{let oe=ue.location.range.start.compareTo(te.location.range.start);return oe===0&&(oe=te.location.range.end.compareTo(ue.location.range.end)),oe});const Z=[],re=[];for(const ue of j){const te={name:ue.name||"!!MISSING: name!!",kind:y.SymbolKind.from(ue.kind),tags:ue.tags?.map(y.SymbolTag.from)||[],detail:"",containerName:ue.containerName,range:y.Range.from(ue.location.range),selectionRange:y.Range.from(ue.location.range),children:[]};for(;;){if(re.length===0){re.push(te),Z.push(te);break}const oe=re[re.length-1];if(_.Range.containsRange(oe.range,te.range)&&!_.Range.equalsRange(oe.range,te.range)){oe.children&&oe.children.push(te),re.push(te);break}re.pop()}}return Z}}class s{constructor(j,Z,re){this._documents=j,this._commands=Z,this._provider=re,this._cache=new p.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(j,Z){const re=this._documents.getDocument(j),ue=await this._provider.provideCodeLenses(re,Z);if(!ue||Z.isCancellationRequested)return;const te=this._cache.add(ue),oe=new c.DisposableStore;this._disposables.set(te,oe);const Ee={cacheId:te,lenses:[]};for(let Ne=0;Ne<ue.length;Ne++)Ee.lenses.push({cacheId:[te,Ne],range:y.Range.from(ue[Ne].range),command:this._commands.toInternal(ue[Ne].command,oe)});return Ee}async resolveCodeLens(j,Z){const re=j.cacheId&&this._cache.get(...j.cacheId);if(!re)return;let ue;if(typeof this._provider.resolveCodeLens!="function"||re.isResolved?ue=re:ue=await this._provider.resolveCodeLens(re,Z),ue||(ue=re),Z.isCancellationRequested)return;const te=j.cacheId&&this._disposables.get(j.cacheId[0]);if(!!te)return j.command=this._commands.toInternal(ue.command??s._badCmd,te),j}releaseCodeLenses(j){this._disposables.get(j)?.dispose(),this._disposables.delete(j),this._cache.delete(j)}}s._badCmd={command:"missing",title:"!!MISSING: command!!"};function g(We){return Array.isArray(We)?We.map(y.DefinitionLink.from):We?[y.DefinitionLink.from(We)]:[]}class l{constructor(j,Z){this._documents=j,this._provider=Z}async provideDefinition(j,Z,re){const ue=this._documents.getDocument(j),te=y.Position.to(Z),oe=await this._provider.provideDefinition(ue,te,re);return g(oe)}}class S{constructor(j,Z){this._documents=j,this._provider=Z}async provideDeclaration(j,Z,re){const ue=this._documents.getDocument(j),te=y.Position.to(Z),oe=await this._provider.provideDeclaration(ue,te,re);return g(oe)}}class n{constructor(j,Z){this._documents=j,this._provider=Z}async provideImplementation(j,Z,re){const ue=this._documents.getDocument(j),te=y.Position.to(Z),oe=await this._provider.provideImplementation(ue,te,re);return g(oe)}}class t{constructor(j,Z){this._documents=j,this._provider=Z}async provideTypeDefinition(j,Z,re){const ue=this._documents.getDocument(j),te=y.Position.to(Z),oe=await this._provider.provideTypeDefinition(ue,te,re);return g(oe)}}class r{constructor(j,Z){this._documents=j,this._provider=Z}async provideHover(j,Z,re){const ue=this._documents.getDocument(j),te=y.Position.to(Z),oe=await this._provider.provideHover(ue,te,re);if(!(!oe||(0,I.isFalsyOrEmpty)(oe.contents)))return oe.range||(oe.range=ue.getWordRangeAtPosition(te)),oe.range||(oe.range=new C.Range(te,te)),y.Hover.from(oe)}}class u{constructor(j,Z){this._documents=j,this._provider=Z}async provideEvaluatableExpression(j,Z,re){const ue=this._documents.getDocument(j),te=y.Position.to(Z),oe=await this._provider.provideEvaluatableExpression(ue,te,re);if(oe)return y.EvaluatableExpression.from(oe)}}class a{constructor(j,Z){this._documents=j,this._provider=Z}async provideInlineValues(j,Z,re,ue){const te=this._documents.getDocument(j),oe=await this._provider.provideInlineValues(te,y.Range.to(Z),y.InlineValueContext.to(re),ue);if(Array.isArray(oe))return oe.map(Ee=>y.InlineValue.from(Ee))}}class f{constructor(j,Z){this._documents=j,this._provider=Z}async provideDocumentHighlights(j,Z,re){const ue=this._documents.getDocument(j),te=y.Position.to(Z),oe=await this._provider.provideDocumentHighlights(ue,te,re);if(Array.isArray(oe))return oe.map(y.DocumentHighlight.from)}}class w{constructor(j,Z){this._documents=j,this._provider=Z}async provideLinkedEditingRanges(j,Z,re){const ue=this._documents.getDocument(j),te=y.Position.to(Z),oe=await this._provider.provideLinkedEditingRanges(ue,te,re);if(oe&&Array.isArray(oe.ranges))return{ranges:(0,I.coalesce)(oe.ranges.map(y.Range.from)),wordPattern:oe.wordPattern}}}class d{constructor(j,Z){this._documents=j,this._provider=Z}async provideReferences(j,Z,re,ue){const te=this._documents.getDocument(j),oe=y.Position.to(Z),Ee=await this._provider.provideReferences(te,oe,re,ue);if(Array.isArray(Ee))return Ee.map(y.location.from)}}class k{constructor(j,Z,re,ue,te,oe,Ee){this._documents=j,this._commands=Z,this._diagnostics=re,this._provider=ue,this._logService=te,this._extension=oe,this._apiDeprecation=Ee,this._cache=new p.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(j,Z,re,ue){const te=this._documents.getDocument(j),oe=A.Selection.isISelection(Z)?y.Selection.to(Z):y.Range.to(Z),Ee=[];for(const ot of this._diagnostics.getDiagnostics(j))if(oe.intersection(ot.range)&&Ee.push(ot)>k._maxCodeActionsPerFile)break;const Ne={diagnostics:Ee,only:re.only?new C.CodeActionKind(re.only):void 0,triggerKind:y.CodeActionTriggerKind.to(re.trigger)},Ve=await this._provider.provideCodeActions(te,oe,Ne,ue);if(!(0,I.isNonEmptyArray)(Ve)||ue.isCancellationRequested)return;const Ge=this._cache.add(Ve),Je=new c.DisposableStore;this._disposables.set(Ge,Je);const tt=[];for(let ot=0;ot<Ve.length;ot++){const et=Ve[ot];!et||(k._isCommand(et)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),tt.push({_isSynthetic:!0,title:et.title,command:this._commands.toInternal(et,Je)})):(Ne.only&&(et.kind?Ne.only.contains(et.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ne.only.value} 'requested but returned code action is of kind '${et.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ne.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),tt.push({cacheId:[Ge,ot],title:et.title,command:et.command&&this._commands.toInternal(et.command,Je),diagnostics:et.diagnostics&&et.diagnostics.map(y.Diagnostic.from),edit:et.edit&&y.WorkspaceEdit.from(et.edit),kind:et.kind&&et.kind.value,isPreferred:et.isPreferred,disabled:et.disabled?.reason})))}return{cacheId:Ge,actions:tt}}async resolveCodeAction(j,Z){const[re,ue]=j,te=this._cache.get(re,ue);if(!te||k._isCommand(te)||!this._provider.resolveCodeAction)return;const oe=await this._provider.resolveCodeAction(te,Z)??te;return oe?.edit?y.WorkspaceEdit.from(oe.edit):void 0}releaseCodeActions(j){this._disposables.get(j)?.dispose(),this._disposables.delete(j),this._cache.delete(j)}static _isCommand(j){return typeof j.command=="string"&&typeof j.title=="string"}}k._maxCodeActionsPerFile=1e3;class R{constructor(j,Z){this._documents=j,this._provider=Z}async provideDocumentFormattingEdits(j,Z,re){const ue=this._documents.getDocument(j),te=await this._provider.provideDocumentFormattingEdits(ue,Z,re);if(Array.isArray(te))return te.map(y.TextEdit.from)}}class N{constructor(j,Z){this._documents=j,this._provider=Z}async provideDocumentRangeFormattingEdits(j,Z,re,ue){const te=this._documents.getDocument(j),oe=y.Range.to(Z),Ee=await this._provider.provideDocumentRangeFormattingEdits(te,oe,re,ue);if(Array.isArray(Ee))return Ee.map(y.TextEdit.from)}}class x{constructor(j,Z){this._documents=j,this._provider=Z,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(j,Z,re,ue,te){const oe=this._documents.getDocument(j),Ee=y.Position.to(Z),Ne=await this._provider.provideOnTypeFormattingEdits(oe,Ee,re,ue,te);if(Array.isArray(Ne))return Ne.map(y.TextEdit.from)}}class F{constructor(j,Z){this._provider=j,this._logService=Z,this._symbolCache=new Map,this._resultCache=new Map}async provideWorkspaceSymbols(j,Z){const re=P.IdObject.mixin({symbols:[]}),ue=await this._provider.provideWorkspaceSymbols(j,Z);if((0,I.isNonEmptyArray)(ue))for(const te of ue){if(!te)continue;if(!te.name){this._logService.warn("INVALID SymbolInformation, lacks name",te);continue}const oe=P.IdObject.mixin(y.WorkspaceSymbol.from(te));this._symbolCache.set(oe._id,te),re.symbols.push(oe)}return re.symbols.length>0&&this._resultCache.set(re._id,[re.symbols[0]._id,re.symbols[re.symbols.length-1]._id]),re}async resolveWorkspaceSymbol(j,Z){if(typeof this._provider.resolveWorkspaceSymbol!="function")return j;const re=this._symbolCache.get(j._id);if(re){const ue=await this._provider.resolveWorkspaceSymbol(re,Z);return ue&&(0,i.mixin)(j,y.WorkspaceSymbol.from(ue),!0)}}releaseWorkspaceSymbols(j){const Z=this._resultCache.get(j);if(Z){for(let[re,ue]=Z;re<=ue;re++)this._symbolCache.delete(re);this._resultCache.delete(j)}}}class B{constructor(j,Z,re){this._documents=j,this._provider=Z,this._logService=re}static supportsResolving(j){return typeof j.prepareRename=="function"}async provideRenameEdits(j,Z,re,ue){const te=this._documents.getDocument(j),oe=y.Position.to(Z);try{const Ee=await this._provider.provideRenameEdits(te,oe,re,ue);return Ee?y.WorkspaceEdit.from(Ee):void 0}catch(Ee){const Ne=B._asMessage(Ee);return Ne?{rejectReason:Ne,edits:void 0}:Promise.reject(Ee)}}async resolveRenameLocation(j,Z,re){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const ue=this._documents.getDocument(j),te=y.Position.to(Z);try{const oe=await this._provider.prepareRename(ue,te,re);let Ee,Ne;if(C.Range.isRange(oe)?(Ee=oe,Ne=ue.getText(oe)):(0,L.isObject)(oe)&&(Ee=oe.range,Ne=oe.placeholder),!Ee||!Ne)return;if(Ee.start.line>te.line||Ee.end.line<te.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:y.Range.from(Ee),text:Ne}}catch(oe){const Ee=B._asMessage(oe);return Ee?{rejectReason:Ee,range:void 0,text:void 0}:Promise.reject(oe)}}static _asMessage(j){return typeof j=="string"?j:j instanceof Error&&typeof j.message=="string"?j.message:void 0}}class O{constructor(j,Z){this.resultId=j,this.tokens=Z}}class H{constructor(j,Z){this._documents=j,this._provider=Z,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(j,Z,re){const ue=this._documents.getDocument(j),te=Z!==0?this._previousResults.get(Z):null;let oe=typeof te?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(ue,te.resultId,re):await this._provider.provideDocumentSemanticTokens(ue,re);return te&&this._previousResults.delete(Z),oe?(oe=H._fixProvidedSemanticTokens(oe),this._send(H._convertToEdits(te,oe),oe)):null}async releaseDocumentSemanticColoring(j){this._previousResults.delete(j)}static _fixProvidedSemanticTokens(j){return H._isSemanticTokens(j)?H._isCorrectSemanticTokens(j)?j:new C.SemanticTokens(new Uint32Array(j.data),j.resultId):H._isSemanticTokensEdits(j)?H._isCorrectSemanticTokensEdits(j)?j:new C.SemanticTokensEdits(j.edits.map(Z=>new C.SemanticTokensEdit(Z.start,Z.deleteCount,Z.data?new Uint32Array(Z.data):Z.data)),j.resultId):j}static _isSemanticTokens(j){return j&&!!j.data}static _isCorrectSemanticTokens(j){return j.data instanceof Uint32Array}static _isSemanticTokensEdits(j){return j&&Array.isArray(j.edits)}static _isCorrectSemanticTokensEdits(j){for(const Z of j.edits)if(!(Z.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(j,Z){if(!H._isSemanticTokens(Z)||!j||!j.tokens)return Z;const re=j.tokens,ue=re.length,te=Z.data,oe=te.length;let Ee=0;const Ne=Math.min(ue,oe);for(;Ee<Ne&&re[Ee]===te[Ee];)Ee++;if(Ee===ue&&Ee===oe)return new C.SemanticTokensEdits([],Z.resultId);let Ve=0;const Ge=Ne-Ee;for(;Ve<Ge&&re[ue-Ve-1]===te[oe-Ve-1];)Ve++;return new C.SemanticTokensEdits([{start:Ee,deleteCount:ue-Ee-Ve,data:te.subarray(Ee,oe-Ve)}],Z.resultId)}_send(j,Z){if(H._isSemanticTokens(j)){const re=this._nextResultId++;return this._previousResults.set(re,new O(j.resultId,j.data)),(0,E.encodeSemanticTokensDto)({id:re,type:"full",data:j.data})}if(H._isSemanticTokensEdits(j)){const re=this._nextResultId++;return H._isSemanticTokens(Z)?this._previousResults.set(re,new O(Z.resultId,Z.data)):this._previousResults.set(re,new O(j.resultId)),(0,E.encodeSemanticTokensDto)({id:re,type:"delta",deltas:(j.edits||[]).map(ue=>({start:ue.start,deleteCount:ue.deleteCount,data:ue.data}))})}return null}}e.DocumentSemanticTokensAdapter=H;class M{constructor(j,Z){this._documents=j,this._provider=Z}async provideDocumentRangeSemanticTokens(j,Z,re){const ue=this._documents.getDocument(j),te=await this._provider.provideDocumentRangeSemanticTokens(ue,y.Range.to(Z),re);return te?this._send(te):null}_send(j){return(0,E.encodeSemanticTokensDto)({id:0,type:"full",data:j.data})}}e.DocumentRangeSemanticTokensAdapter=M;class W{constructor(j,Z,re,ue,te){this._documents=j,this._commands=Z,this._provider=re,this._apiDeprecation=ue,this._extension=te,this._cache=new p.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(j){return typeof j.resolveCompletionItem=="function"}async provideCompletionItems(j,Z,re,ue){const te=this._documents.getDocument(j),oe=y.Position.to(Z),Ee=te.getWordRangeAtPosition(oe)||new C.Range(oe,oe),Ne=Ee.with({end:oe}),Ve=new v.StopWatch(!0),Ge=await this._provider.provideCompletionItems(te,oe,ue,y.CompletionContext.to(re));if(!Ge||ue.isCancellationRequested)return;const Je=Array.isArray(Ge)?new C.CompletionList(Ge):Ge,tt=W.supportsResolving(this._provider)?this._cache.add(Je.items):this._cache.add([]),ot=new c.DisposableStore;this._disposables.set(tt,ot);const et=[],it={x:tt,b:et,a:{replace:y.Range.from(Ee),insert:y.Range.from(Ne)},c:Je.isIncomplete||void 0,d:Ve.elapsed()};for(let lt=0;lt<Je.items.length;lt++){const pt=Je.items[lt],Pt=this._convertCompletionItem(pt,[tt,lt],Ne,Ee);et.push(Pt)}return it}async resolveCompletionItem(j,Z){if(typeof this._provider.resolveCompletionItem!="function")return;const re=this._cache.get(...j);if(!re)return;const ue=await this._provider.resolveCompletionItem(re,Z);if(!!ue)return this._convertCompletionItem(ue,j)}releaseCompletionItems(j){this._disposables.get(j)?.dispose(),this._disposables.delete(j),this._cache.delete(j)}_convertCompletionItem(j,Z,re,ue){const te=this._disposables.get(Z[0]);if(!te)throw Error("DisposableStore is missing...");const oe={x:Z,a:j.label,b:j.kind!==void 0?y.CompletionItemKind.from(j.kind):void 0,n:j.tags&&j.tags.map(y.CompletionItemTag.from),c:j.detail,d:typeof j.documentation=="undefined"?void 0:y.MarkdownString.fromStrict(j.documentation),e:j.sortText!==j.label?j.sortText:void 0,f:j.filterText!==j.label?j.filterText:void 0,g:j.preselect||void 0,i:j.keepWhitespace?1:0,k:j.commitCharacters,l:j.additionalTextEdits&&j.additionalTextEdits.map(y.TextEdit.from),m:this._commands.toInternal(j.command,te)};j.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),oe.h=j.textEdit.newText):typeof j.insertText=="string"?oe.h=j.insertText:j.insertText instanceof C.SnippetString&&(oe.h=j.insertText.value,oe.i|=4);let Ee;return j.textEdit?Ee=j.textEdit.range:j.range&&(Ee=j.range),C.Range.isRange(Ee)?oe.j=y.Range.from(Ee):Ee&&(!re?.isEqual(Ee.inserting)||!ue?.isEqual(Ee.replacing))&&(oe.j={insert:y.Range.from(Ee.inserting),replace:y.Range.from(Ee.replacing)}),oe}}class z{constructor(j,Z,re){this._documents=j,this._provider=Z,this._commands=re,this._cache=new p.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(j,Z,re,ue){const te=this._documents.getDocument(j),oe=y.Position.to(Z),Ee=await this._provider.provideInlineCompletionItems(te,oe,{selectedCompletionInfo:re.selectedSuggestionInfo?{range:y.Range.to(re.selectedSuggestionInfo.range),text:re.selectedSuggestionInfo.text,isSnippetText:re.selectedSuggestionInfo.isSnippetText,completionKind:y.CompletionItemKind.to(re.selectedSuggestionInfo.completionKind)}:void 0,triggerKind:re.triggerKind},ue);if(!Ee||ue.isCancellationRequested)return;const Ne=(0,L.isArray)(Ee)?{items:Ee}:Ee,Ve=this._cache.add(Ne.items);let Ge;return{pid:Ve,items:Ne.items.map((Je,tt)=>{let ot;return Je.command&&(Ge||(Ge=new c.DisposableStore,this._disposables.set(Ve,Ge)),ot=this._commands.toInternal(Je.command,Ge)),{text:Je.text,range:Je.range?y.Range.from(Je.range):void 0,command:ot,idx:tt}})}}disposeCompletions(j){this._cache.delete(j);const Z=this._disposables.get(j);Z&&Z.clear(),this._disposables.delete(j)}handleDidShowCompletionItem(j,Z){const re=this._cache.get(j,Z);re&&U.get(this._provider).fireOnDidShowCompletionItem({completionItem:re})}}class U{constructor(){this._onDidShowCompletionItemEmitter=new b.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(j){let Z=U.map.get(j);return Z||(Z=new U,U.map.set(j,Z)),Z}fireOnDidShowCompletionItem(j){this._onDidShowCompletionItemEmitter.fire(j)}}e.InlineCompletionController=U,U.map=new WeakMap;class V{constructor(j,Z){this._documents=j,this._provider=Z,this._cache=new p.Cache("SignatureHelp")}async provideSignatureHelp(j,Z,re,ue){const te=this._documents.getDocument(j),oe=y.Position.to(Z),Ee=this.reviveContext(re),Ne=await this._provider.provideSignatureHelp(te,oe,ue,Ee);if(Ne){const Ve=this._cache.add([Ne]);return{...y.SignatureHelp.from(Ne),id:Ve}}}reviveContext(j){let Z;if(j.activeSignatureHelp){const re=y.SignatureHelp.to(j.activeSignatureHelp),ue=this._cache.get(j.activeSignatureHelp.id,0);ue?(Z=ue,Z.activeSignature=re.activeSignature,Z.activeParameter=re.activeParameter):Z=re}return{...j,activeSignatureHelp:Z}}releaseSignatureHelp(j){this._cache.delete(j)}}class K{constructor(j,Z){this._documents=j,this._provider=Z}async provideInlayHints(j,Z,re){const ue=this._documents.getDocument(j),te=await this._provider.provideInlayHints(ue,y.Range.to(Z),re);return te?{hints:te.map(y.InlayHint.from)}:void 0}}class G{constructor(j,Z){this._documents=j,this._provider=Z,this._cache=new p.Cache("DocumentLink")}async provideLinks(j,Z){const re=this._documents.getDocument(j),ue=await this._provider.provideDocumentLinks(re,Z);if(!(!Array.isArray(ue)||ue.length===0)&&!Z.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:ue.filter(G._validateLink).map(y.DocumentLink.from)};{const te=this._cache.add(ue),oe={links:[],id:te};for(let Ee=0;Ee<ue.length;Ee++){if(!G._validateLink(ue[Ee]))continue;const Ne=y.DocumentLink.from(ue[Ee]);Ne.cacheId=[te,Ee],oe.links.push(Ne)}return oe}}}static _validateLink(j){return j.target&&j.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(j,Z){if(typeof this._provider.resolveDocumentLink!="function")return;const re=this._cache.get(...j);if(!re)return;const ue=await this._provider.resolveDocumentLink(re,Z);if(!(!ue||!G._validateLink(ue)))return y.DocumentLink.from(ue)}releaseLinks(j){this._cache.delete(j)}}class Q{constructor(j,Z){this._documents=j,this._provider=Z}async provideColors(j,Z){const re=this._documents.getDocument(j),ue=await this._provider.provideDocumentColors(re,Z);return Array.isArray(ue)?ue.map(oe=>({color:y.Color.from(oe.color),range:y.Range.from(oe.range)})):[]}async provideColorPresentations(j,Z,re){const ue=this._documents.getDocument(j),te=y.Range.to(Z.range),oe=y.Color.to(Z.color),Ee=await this._provider.provideColorPresentations(oe,{document:ue,range:te},re);if(!!Array.isArray(Ee))return Ee.map(y.ColorPresentation.from)}}class Y{constructor(j,Z){this._documents=j,this._provider=Z}async provideFoldingRanges(j,Z,re){const ue=this._documents.getDocument(j),te=await this._provider.provideFoldingRanges(ue,Z,re);if(!!Array.isArray(te))return te.map(y.FoldingRange.from)}}class fe{constructor(j,Z,re){this._documents=j,this._provider=Z,this._logService=re}async provideSelectionRanges(j,Z,re){const ue=this._documents.getDocument(j),te=Z.map(y.Position.to),oe=await this._provider.provideSelectionRanges(ue,te,re);if(!(0,I.isNonEmptyArray)(oe))return[];if(oe.length!==te.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const Ee=[];for(let Ne=0;Ne<te.length;Ne++){const Ve=[];Ee.push(Ve);let Ge=te[Ne],Je=oe[Ne];for(;;){if(!Je.range.contains(Ge))throw new Error("INVALID selection range, must contain the previous range");if(Ve.push(y.SelectionRange.from(Je)),!Je.parent)break;Ge=Je.range,Je=Je.parent}}return Ee}}class me{constructor(j,Z){this._documents=j,this._provider=Z,this._idPool=new h.IdGenerator(""),this._cache=new Map}async prepareSession(j,Z,re){const ue=this._documents.getDocument(j),te=y.Position.to(Z),oe=await this._provider.prepareCallHierarchy(ue,te,re);if(!oe)return;const Ee=this._idPool.nextId();return this._cache.set(Ee,new Map),Array.isArray(oe)?oe.map(Ne=>this._cacheAndConvertItem(Ee,Ne)):[this._cacheAndConvertItem(Ee,oe)]}async provideCallsTo(j,Z,re){const ue=this._itemFromCache(j,Z);if(!ue)throw new Error("missing call hierarchy item");const te=await this._provider.provideCallHierarchyIncomingCalls(ue,re);if(!!te)return te.map(oe=>({from:this._cacheAndConvertItem(j,oe.from),fromRanges:oe.fromRanges.map(Ee=>y.Range.from(Ee))}))}async provideCallsFrom(j,Z,re){const ue=this._itemFromCache(j,Z);if(!ue)throw new Error("missing call hierarchy item");const te=await this._provider.provideCallHierarchyOutgoingCalls(ue,re);if(!!te)return te.map(oe=>({to:this._cacheAndConvertItem(j,oe.to),fromRanges:oe.fromRanges.map(Ee=>y.Range.from(Ee))}))}releaseSession(j){this._cache.delete(j)}_cacheAndConvertItem(j,Z){const re=this._cache.get(j),ue=y.CallHierarchyItem.from(Z,j,re.size.toString(36));return re.set(ue._itemId,Z),ue}_itemFromCache(j,Z){return this._cache.get(j)?.get(Z)}}class _e{constructor(j,Z){this._documents=j,this._provider=Z,this._idPool=new h.IdGenerator(""),this._cache=new Map}async prepareSession(j,Z,re){const ue=this._documents.getDocument(j),te=y.Position.to(Z),oe=await this._provider.prepareTypeHierarchy(ue,te,re);if(!oe)return;const Ee=this._idPool.nextId();return this._cache.set(Ee,new Map),Array.isArray(oe)?oe.map(Ne=>this._cacheAndConvertItem(Ee,Ne)):[this._cacheAndConvertItem(Ee,oe)]}async provideSupertypes(j,Z,re){const ue=this._itemFromCache(j,Z);if(!ue)throw new Error("missing type hierarchy item");const te=await this._provider.provideTypeHierarchySupertypes(ue,re);if(!!te)return te.map(oe=>this._cacheAndConvertItem(j,oe))}async provideSubtypes(j,Z,re){const ue=this._itemFromCache(j,Z);if(!ue)throw new Error("missing type hierarchy item");const te=await this._provider.provideTypeHierarchySubtypes(ue,re);if(!!te)return te.map(oe=>this._cacheAndConvertItem(j,oe))}releaseSession(j){this._cache.delete(j)}_cacheAndConvertItem(j,Z){const re=this._cache.get(j),ue=y.TypeHierarchyItem.from(Z,j,re.size.toString(36));return re.set(ue._itemId,Z),ue}_itemFromCache(j,Z){return this._cache.get(j)?.get(Z)}}class Ie{constructor(j,Z){this.adapter=j,this.extension=Z}}class Oe{constructor(j,Z,re,ue,te,oe,Ee){this._adapter=new Map,this._uriTransformer=Z,this._proxy=j.getProxy(P.MainContext.MainThreadLanguageFeatures),this._documents=re,this._commands=ue,this._diagnostics=te,this._logService=oe,this._apiDeprecation=Ee}_transformDocumentSelector(j){return y.DocumentSelector.from(j,this._uriTransformer)}_createDisposable(j){return new C.Disposable(()=>{this._adapter.delete(j),this._proxy.$unregister(j)})}_nextHandle(){return Oe._handlePool++}_withAdapter(j,Z,re,ue,te=!1){const oe=this._adapter.get(j);if(!oe)return Promise.resolve(ue);if(oe.adapter instanceof Z){let Ee;oe.extension&&(Ee=Date.now(),this._logService.trace(`[${oe.extension.identifier.value}] INVOKE provider '${Z.name}'`));const Ne=re(oe.adapter,oe.extension),Ve=oe.extension;return Ve&&Promise.resolve(Ne).then(()=>this._logService.trace(`[${Ve.identifier.value}] provider DONE after ${Date.now()-Ee}ms`),Ge=>{te&&Ge instanceof T.CancellationError||(this._logService.error(`[${Ve.identifier.value}] provider FAILED`),this._logService.error(Ge))}),Ne}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(j,Z){const re=this._nextHandle();return this._adapter.set(re,new Ie(j,Z)),re}static _extLabel(j){return j.displayName||j.name}registerDocumentSymbolProvider(j,Z,re,ue){const te=this._addNewAdapter(new o(this._documents,re),j),oe=ue&&ue.label||Oe._extLabel(j);return this._proxy.$registerDocumentSymbolProvider(te,this._transformDocumentSelector(Z),oe),this._createDisposable(te)}$provideDocumentSymbols(j,Z,re){return this._withAdapter(j,o,ue=>ue.provideDocumentSymbols(m.URI.revive(Z),re),void 0)}registerCodeLensProvider(j,Z,re){const ue=this._nextHandle(),te=typeof re.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(ue,new Ie(new s(this._documents,this._commands.converter,re),j)),this._proxy.$registerCodeLensSupport(ue,this._transformDocumentSelector(Z),te);let oe=this._createDisposable(ue);if(te!==void 0){const Ee=re.onDidChangeCodeLenses(Ne=>this._proxy.$emitCodeLensEvent(te));oe=C.Disposable.from(oe,Ee)}return oe}$provideCodeLenses(j,Z,re){return this._withAdapter(j,s,ue=>ue.provideCodeLenses(m.URI.revive(Z),re),void 0)}$resolveCodeLens(j,Z,re){return this._withAdapter(j,s,ue=>ue.resolveCodeLens(Z,re),void 0)}$releaseCodeLenses(j,Z){this._withAdapter(j,s,re=>Promise.resolve(re.releaseCodeLenses(Z)),void 0)}registerDefinitionProvider(j,Z,re){const ue=this._addNewAdapter(new l(this._documents,re),j);return this._proxy.$registerDefinitionSupport(ue,this._transformDocumentSelector(Z)),this._createDisposable(ue)}$provideDefinition(j,Z,re,ue){return this._withAdapter(j,l,te=>te.provideDefinition(m.URI.revive(Z),re,ue),[])}registerDeclarationProvider(j,Z,re){const ue=this._addNewAdapter(new S(this._documents,re),j);return this._proxy.$registerDeclarationSupport(ue,this._transformDocumentSelector(Z)),this._createDisposable(ue)}$provideDeclaration(j,Z,re,ue){return this._withAdapter(j,S,te=>te.provideDeclaration(m.URI.revive(Z),re,ue),[])}registerImplementationProvider(j,Z,re){const ue=this._addNewAdapter(new n(this._documents,re),j);return this._proxy.$registerImplementationSupport(ue,this._transformDocumentSelector(Z)),this._createDisposable(ue)}$provideImplementation(j,Z,re,ue){return this._withAdapter(j,n,te=>te.provideImplementation(m.URI.revive(Z),re,ue),[])}registerTypeDefinitionProvider(j,Z,re){const ue=this._addNewAdapter(new t(this._documents,re),j);return this._proxy.$registerTypeDefinitionSupport(ue,this._transformDocumentSelector(Z)),this._createDisposable(ue)}$provideTypeDefinition(j,Z,re,ue){return this._withAdapter(j,t,te=>te.provideTypeDefinition(m.URI.revive(Z),re,ue),[])}registerHoverProvider(j,Z,re,ue){const te=this._addNewAdapter(new r(this._documents,re),j);return this._proxy.$registerHoverProvider(te,this._transformDocumentSelector(Z)),this._createDisposable(te)}$provideHover(j,Z,re,ue){return this._withAdapter(j,r,te=>te.provideHover(m.URI.revive(Z),re,ue),void 0)}registerEvaluatableExpressionProvider(j,Z,re,ue){const te=this._addNewAdapter(new u(this._documents,re),j);return this._proxy.$registerEvaluatableExpressionProvider(te,this._transformDocumentSelector(Z)),this._createDisposable(te)}$provideEvaluatableExpression(j,Z,re,ue){return this._withAdapter(j,u,te=>te.provideEvaluatableExpression(m.URI.revive(Z),re,ue),void 0)}registerInlineValuesProvider(j,Z,re,ue){const te=typeof re.onDidChangeInlineValues=="function"?this._nextHandle():void 0,oe=this._addNewAdapter(new a(this._documents,re),j);this._proxy.$registerInlineValuesProvider(oe,this._transformDocumentSelector(Z),te);let Ee=this._createDisposable(oe);if(te!==void 0){const Ne=re.onDidChangeInlineValues(Ve=>this._proxy.$emitInlineValuesEvent(te));Ee=C.Disposable.from(Ee,Ne)}return Ee}$provideInlineValues(j,Z,re,ue,te){return this._withAdapter(j,a,oe=>oe.provideInlineValues(m.URI.revive(Z),re,ue,te),void 0)}registerDocumentHighlightProvider(j,Z,re){const ue=this._addNewAdapter(new f(this._documents,re),j);return this._proxy.$registerDocumentHighlightProvider(ue,this._transformDocumentSelector(Z)),this._createDisposable(ue)}$provideDocumentHighlights(j,Z,re,ue){return this._withAdapter(j,f,te=>te.provideDocumentHighlights(m.URI.revive(Z),re,ue),void 0)}registerLinkedEditingRangeProvider(j,Z,re){const ue=this._addNewAdapter(new w(this._documents,re),j);return this._proxy.$registerLinkedEditingRangeProvider(ue,this._transformDocumentSelector(Z)),this._createDisposable(ue)}$provideLinkedEditingRanges(j,Z,re,ue){return this._withAdapter(j,w,async te=>{const oe=await te.provideLinkedEditingRanges(m.URI.revive(Z),re,ue);if(oe)return{ranges:oe.ranges,wordPattern:oe.wordPattern?Oe._serializeRegExp(oe.wordPattern):void 0}},void 0)}registerReferenceProvider(j,Z,re){const ue=this._addNewAdapter(new d(this._documents,re),j);return this._proxy.$registerReferenceSupport(ue,this._transformDocumentSelector(Z)),this._createDisposable(ue)}$provideReferences(j,Z,re,ue,te){return this._withAdapter(j,d,oe=>oe.provideReferences(m.URI.revive(Z),re,ue,te),void 0)}registerCodeActionProvider(j,Z,re,ue){const te=new c.DisposableStore,oe=this._addNewAdapter(new k(this._documents,this._commands.converter,this._diagnostics,re,this._logService,j,this._apiDeprecation),j);return this._proxy.$registerQuickFixSupport(oe,this._transformDocumentSelector(Z),{providedKinds:ue?.providedCodeActionKinds?.map(Ee=>Ee.value),documentation:ue?.documentation?.map(Ee=>({kind:Ee.kind.value,command:this._commands.converter.toInternal(Ee.command,te)}))},Oe._extLabel(j),Boolean(re.resolveCodeAction)),te.add(this._createDisposable(oe)),te}$provideCodeActions(j,Z,re,ue,te){return this._withAdapter(j,k,oe=>oe.provideCodeActions(m.URI.revive(Z),re,ue,te),void 0)}$resolveCodeAction(j,Z,re){return this._withAdapter(j,k,ue=>ue.resolveCodeAction(Z,re),void 0)}$releaseCodeActions(j,Z){this._withAdapter(j,k,re=>Promise.resolve(re.releaseCodeActions(Z)),void 0)}registerDocumentFormattingEditProvider(j,Z,re){const ue=this._addNewAdapter(new R(this._documents,re),j);return this._proxy.$registerDocumentFormattingSupport(ue,this._transformDocumentSelector(Z),j.identifier,j.displayName||j.name),this._createDisposable(ue)}$provideDocumentFormattingEdits(j,Z,re,ue){return this._withAdapter(j,R,te=>te.provideDocumentFormattingEdits(m.URI.revive(Z),re,ue),void 0)}registerDocumentRangeFormattingEditProvider(j,Z,re){const ue=this._addNewAdapter(new N(this._documents,re),j);return this._proxy.$registerRangeFormattingSupport(ue,this._transformDocumentSelector(Z),j.identifier,j.displayName||j.name),this._createDisposable(ue)}$provideDocumentRangeFormattingEdits(j,Z,re,ue,te){return this._withAdapter(j,N,oe=>oe.provideDocumentRangeFormattingEdits(m.URI.revive(Z),re,ue,te),void 0)}registerOnTypeFormattingEditProvider(j,Z,re,ue){const te=this._addNewAdapter(new x(this._documents,re),j);return this._proxy.$registerOnTypeFormattingSupport(te,this._transformDocumentSelector(Z),ue,j.identifier),this._createDisposable(te)}$provideOnTypeFormattingEdits(j,Z,re,ue,te,oe){return this._withAdapter(j,x,Ee=>Ee.provideOnTypeFormattingEdits(m.URI.revive(Z),re,ue,te,oe),void 0)}registerWorkspaceSymbolProvider(j,Z){const re=this._addNewAdapter(new F(Z,this._logService),j);return this._proxy.$registerNavigateTypeSupport(re,typeof Z.resolveWorkspaceSymbol=="function"),this._createDisposable(re)}$provideWorkspaceSymbols(j,Z,re){return this._withAdapter(j,F,ue=>ue.provideWorkspaceSymbols(Z,re),{symbols:[]})}$resolveWorkspaceSymbol(j,Z,re){return this._withAdapter(j,F,ue=>ue.resolveWorkspaceSymbol(Z,re),void 0)}$releaseWorkspaceSymbols(j,Z){this._withAdapter(j,F,re=>re.releaseWorkspaceSymbols(Z),void 0)}registerRenameProvider(j,Z,re){const ue=this._addNewAdapter(new B(this._documents,re,this._logService),j);return this._proxy.$registerRenameSupport(ue,this._transformDocumentSelector(Z),B.supportsResolving(re)),this._createDisposable(ue)}$provideRenameEdits(j,Z,re,ue,te){return this._withAdapter(j,B,oe=>oe.provideRenameEdits(m.URI.revive(Z),re,ue,te),void 0)}$resolveRenameLocation(j,Z,re,ue){return this._withAdapter(j,B,te=>te.resolveRenameLocation(m.URI.revive(Z),re,ue),void 0)}registerDocumentSemanticTokensProvider(j,Z,re,ue){const te=this._nextHandle(),oe=typeof re.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(te,new Ie(new H(this._documents,re),j)),this._proxy.$registerDocumentSemanticTokensProvider(te,this._transformDocumentSelector(Z),ue,oe);let Ee=this._createDisposable(te);if(oe){const Ne=re.onDidChangeSemanticTokens(Ve=>this._proxy.$emitDocumentSemanticTokensEvent(oe));Ee=C.Disposable.from(Ee,Ne)}return Ee}$provideDocumentSemanticTokens(j,Z,re,ue){return this._withAdapter(j,H,te=>te.provideDocumentSemanticTokens(m.URI.revive(Z),re,ue),null,!0)}$releaseDocumentSemanticTokens(j,Z){this._withAdapter(j,H,re=>re.releaseDocumentSemanticColoring(Z),void 0)}registerDocumentRangeSemanticTokensProvider(j,Z,re,ue){const te=this._addNewAdapter(new M(this._documents,re),j);return this._proxy.$registerDocumentRangeSemanticTokensProvider(te,this._transformDocumentSelector(Z),ue),this._createDisposable(te)}$provideDocumentRangeSemanticTokens(j,Z,re,ue){return this._withAdapter(j,M,te=>te.provideDocumentRangeSemanticTokens(m.URI.revive(Z),re,ue),null,!0)}registerCompletionItemProvider(j,Z,re,ue){const te=this._addNewAdapter(new W(this._documents,this._commands.converter,re,this._apiDeprecation,j),j);return this._proxy.$registerSuggestSupport(te,this._transformDocumentSelector(Z),ue,W.supportsResolving(re),`${j.identifier.value}(${ue.join("")})`),this._createDisposable(te)}$provideCompletionItems(j,Z,re,ue,te){return this._withAdapter(j,W,oe=>oe.provideCompletionItems(m.URI.revive(Z),re,ue,te),void 0)}$resolveCompletionItem(j,Z,re){return this._withAdapter(j,W,ue=>ue.resolveCompletionItem(Z,re),void 0)}$releaseCompletionItems(j,Z){this._withAdapter(j,W,re=>re.releaseCompletionItems(Z),void 0)}registerInlineCompletionsProvider(j,Z,re){const ue=this._addNewAdapter(new z(this._documents,re,this._commands.converter),j);return this._proxy.$registerInlineCompletionsSupport(ue,this._transformDocumentSelector(Z)),this._createDisposable(ue)}$provideInlineCompletions(j,Z,re,ue,te){return this._withAdapter(j,z,oe=>oe.provideInlineCompletions(m.URI.revive(Z),re,ue,te),void 0)}$handleInlineCompletionDidShow(j,Z,re){this._withAdapter(j,z,async ue=>{ue.handleDidShowCompletionItem(Z,re)},void 0)}$freeInlineCompletionsList(j,Z){this._withAdapter(j,z,async re=>{re.disposeCompletions(Z)},void 0)}registerSignatureHelpProvider(j,Z,re,ue){const te=Array.isArray(ue)?{triggerCharacters:ue,retriggerCharacters:[]}:ue,oe=this._addNewAdapter(new V(this._documents,re),j);return this._proxy.$registerSignatureHelpProvider(oe,this._transformDocumentSelector(Z),te),this._createDisposable(oe)}$provideSignatureHelp(j,Z,re,ue,te){return this._withAdapter(j,V,oe=>oe.provideSignatureHelp(m.URI.revive(Z),re,ue,te),void 0)}$releaseSignatureHelp(j,Z){this._withAdapter(j,V,re=>re.releaseSignatureHelp(Z),void 0)}registerInlayHintsProvider(j,Z,re){const ue=typeof re.onDidChangeInlayHints=="function"?this._nextHandle():void 0,te=this._addNewAdapter(new K(this._documents,re),j);this._proxy.$registerInlayHintsProvider(te,this._transformDocumentSelector(Z),ue);let oe=this._createDisposable(te);if(ue!==void 0){const Ee=re.onDidChangeInlayHints(Ne=>this._proxy.$emitInlayHintsEvent(ue));oe=C.Disposable.from(oe,Ee)}return oe}$provideInlayHints(j,Z,re,ue){return this._withAdapter(j,K,te=>te.provideInlayHints(m.URI.revive(Z),re,ue),void 0)}registerDocumentLinkProvider(j,Z,re){const ue=this._addNewAdapter(new G(this._documents,re),j);return this._proxy.$registerDocumentLinkProvider(ue,this._transformDocumentSelector(Z),typeof re.resolveDocumentLink=="function"),this._createDisposable(ue)}$provideDocumentLinks(j,Z,re){return this._withAdapter(j,G,ue=>ue.provideLinks(m.URI.revive(Z),re),void 0)}$resolveDocumentLink(j,Z,re){return this._withAdapter(j,G,ue=>ue.resolveLink(Z,re),void 0)}$releaseDocumentLinks(j,Z){this._withAdapter(j,G,re=>re.releaseLinks(Z),void 0)}registerColorProvider(j,Z,re){const ue=this._addNewAdapter(new Q(this._documents,re),j);return this._proxy.$registerDocumentColorProvider(ue,this._transformDocumentSelector(Z)),this._createDisposable(ue)}$provideDocumentColors(j,Z,re){return this._withAdapter(j,Q,ue=>ue.provideColors(m.URI.revive(Z),re),[])}$provideColorPresentations(j,Z,re,ue){return this._withAdapter(j,Q,te=>te.provideColorPresentations(m.URI.revive(Z),re,ue),void 0)}registerFoldingRangeProvider(j,Z,re){const ue=this._nextHandle(),te=typeof re.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(ue,new Ie(new Y(this._documents,re),j)),this._proxy.$registerFoldingRangeProvider(ue,this._transformDocumentSelector(Z),te);let oe=this._createDisposable(ue);if(te!==void 0){const Ee=re.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(te));oe=C.Disposable.from(oe,Ee)}return oe}$provideFoldingRanges(j,Z,re,ue){return this._withAdapter(j,Y,te=>te.provideFoldingRanges(m.URI.revive(Z),re,ue),void 0)}registerSelectionRangeProvider(j,Z,re){const ue=this._addNewAdapter(new fe(this._documents,re,this._logService),j);return this._proxy.$registerSelectionRangeProvider(ue,this._transformDocumentSelector(Z)),this._createDisposable(ue)}$provideSelectionRanges(j,Z,re,ue){return this._withAdapter(j,fe,te=>te.provideSelectionRanges(m.URI.revive(Z),re,ue),[])}registerCallHierarchyProvider(j,Z,re){const ue=this._addNewAdapter(new me(this._documents,re),j);return this._proxy.$registerCallHierarchyProvider(ue,this._transformDocumentSelector(Z)),this._createDisposable(ue)}$prepareCallHierarchy(j,Z,re,ue){return this._withAdapter(j,me,te=>Promise.resolve(te.prepareSession(m.URI.revive(Z),re,ue)),void 0)}$provideCallHierarchyIncomingCalls(j,Z,re,ue){return this._withAdapter(j,me,te=>te.provideCallsTo(Z,re,ue),void 0)}$provideCallHierarchyOutgoingCalls(j,Z,re,ue){return this._withAdapter(j,me,te=>te.provideCallsFrom(Z,re,ue),void 0)}$releaseCallHierarchy(j,Z){this._withAdapter(j,me,re=>Promise.resolve(re.releaseSession(Z)),void 0)}registerTypeHierarchyProvider(j,Z,re){const ue=this._addNewAdapter(new _e(this._documents,re),j);return this._proxy.$registerTypeHierarchyProvider(ue,this._transformDocumentSelector(Z)),this._createDisposable(ue)}$prepareTypeHierarchy(j,Z,re,ue){return this._withAdapter(j,_e,te=>Promise.resolve(te.prepareSession(m.URI.revive(Z),re,ue)),void 0)}$provideTypeHierarchySupertypes(j,Z,re,ue){return this._withAdapter(j,_e,te=>te.provideSupertypes(Z,re,ue),void 0)}$provideTypeHierarchySubtypes(j,Z,re,ue){return this._withAdapter(j,_e,te=>te.provideSubtypes(Z,re,ue),void 0)}$releaseTypeHierarchy(j,Z){this._withAdapter(j,_e,re=>Promise.resolve(re.releaseSession(Z)),void 0)}static _serializeRegExp(j){return{pattern:j.source,flags:(0,D.regExpFlags)(j)}}static _serializeIndentationRule(j){return{decreaseIndentPattern:Oe._serializeRegExp(j.decreaseIndentPattern),increaseIndentPattern:Oe._serializeRegExp(j.increaseIndentPattern),indentNextLinePattern:j.indentNextLinePattern?Oe._serializeRegExp(j.indentNextLinePattern):void 0,unIndentedLinePattern:j.unIndentedLinePattern?Oe._serializeRegExp(j.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(j){return{beforeText:Oe._serializeRegExp(j.beforeText),afterText:j.afterText?Oe._serializeRegExp(j.afterText):void 0,previousLineText:j.previousLineText?Oe._serializeRegExp(j.previousLineText):void 0,action:j.action}}static _serializeOnEnterRules(j){return j.map(Oe._serializeOnEnterRule)}setLanguageConfiguration(j,Z,re){let{wordPattern:ue}=re;if(ue&&(0,D.regExpLeadsToEndlessLoop)(ue))throw new Error(`Invalid language configuration: wordPattern '${ue}' is not allowed to match the empty string.`);ue?this._documents.setWordDefinitionFor(Z,ue):this._documents.setWordDefinitionFor(Z,void 0),re.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",j,"Do not use."),re.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",j,"Do not use.");const te=this._nextHandle(),oe={comments:re.comments,brackets:re.brackets,wordPattern:re.wordPattern?Oe._serializeRegExp(re.wordPattern):void 0,indentationRules:re.indentationRules?Oe._serializeIndentationRule(re.indentationRules):void 0,onEnterRules:re.onEnterRules?Oe._serializeOnEnterRules(re.onEnterRules):void 0,__electricCharacterSupport:re.__electricCharacterSupport,__characterPairSupport:re.__characterPairSupport};return this._proxy.$setLanguageConfiguration(te,Z,oe),this._createDisposable(te)}$setWordDefinitions(j){for(const Z of j)this._documents.setWordDefinitionFor(Z.languageId,new RegExp(Z.regexSource,Z.regexFlags))}}e.ExtHostLanguageFeatures=Oe,Oe._handlePool=0}),define(ve[241],we([0,1,5,17,7,48,18,6]),function(J,e,m,i,y,C,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class _{constructor(L,A,c,E){this._documents=A,this._commands=c,this._uriTransformer=E,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=L.getProxy(m.MainContext.MainThreadLanguages)}$acceptLanguageIds(L){this._languageIds=L}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(L,A){await this._proxy.$changeLanguage(L,A);const c=this._documents.getDocumentData(L);if(!c)throw new Error(`document '${L.toString}' NOT found`);return c.document}async tokenAtPosition(L,A){const c=L.version,E=i.Position.from(A),h=await this._proxy.$tokensAtPosition(L.uri,E),p={type:y.StandardTokenType.Other,range:L.getWordRangeAtPosition(A)??new y.Range(A.line,A.character,A.line,A.character)};if(!h)return p;const v={range:i.Range.to(h.range),type:i.TokenType.to(h.type)};return!v.range.contains(A)||c!==L.version?p:v}createLanguageStatusItem(L,A,c){const E=this._handlePool++,h=this._proxy,p=this._ids,v=`${L.identifier.value}/${A}`;if(p.has(v))throw new Error(`LanguageStatusItem with id '${A}' ALREADY exists`);p.add(v);const T={selector:c,id:A,name:L.displayName??L.name,severity:y.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let b,o=new D.DisposableStore;const s=()=>{b?.dispose(),b=(0,P.disposableTimeout)(()=>{o.clear(),this._proxy.$setLanguageStatus(E,{id:v,name:T.name??L.displayName??L.name,source:L.displayName??L.name,selector:i.DocumentSelector.from(T.selector,this._uriTransformer),label:T.text,detail:T.detail??"",severity:T.severity===y.LanguageStatusSeverity.Error?C.default.Error:T.severity===y.LanguageStatusSeverity.Warning?C.default.Warning:C.default.Info,command:T.command&&this._commands.toInternal(T.command,o),accessibilityInfo:T.accessibilityInformation,busy:T.busy})},0)},g={dispose(){o.dispose(),b?.dispose(),h.$removeLanguageStatus(E),p.delete(v)},get id(){return T.id},get name(){return T.name},set name(l){T.name=l,s()},get selector(){return T.selector},set selector(l){T.selector=l,s()},get text(){return T.text},set text(l){T.text=l,s()},get detail(){return T.detail},set detail(l){T.detail=l,s()},get severity(){return T.severity},set severity(l){T.severity=l,s()},get accessibilityInformation(){return T.accessibilityInformation},set accessibilityInformation(l){T.accessibilityInformation=l,s()},get command(){return T.command},set command(l){T.command=l,s()},get busy(){return T.busy},set busy(l){T.busy=l,s()}};return s(),g}}e.ExtHostLanguages=_}),define(ve[131],we([0,1,11,5,26,14,3]),function(J,e,m,i,y,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let D=class extends m.AbstractLoggerService{constructor(L,A){const c=new P.Emitter;super(A.logLevel,c.event);this._proxy=L.getProxy(i.MainContext.MainThreadLogger),this._onDidChangeLogLevel=this._register(c)}$setLevel(L){this._onDidChangeLogLevel.fire(L)}doCreateLogger(L,A,c){return new _(this._proxy,L,A,c)}};D=je([ze(0,C.IExtHostRpcService),ze(1,y.IExtHostInitDataService)],D),e.ExtHostLoggerService=D;class _ extends m.AbstractMessageLogger{constructor(L,A,c,E){super(E?.always);this.proxy=L,this.file=A,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(c),this.proxy.$createLogger(A,E).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(L,A){const c=[[L,A]];this.isLoggerCreated?this.doLog(c):this.buffer.push(...c)}doLog(L){this.proxy.$log(this.file,L)}}}),define(ve[242],we([0,1,5,11,29]),function(J,e,m,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function C(D){return D&&D.title}let P=class{constructor(_,I){this._logService=I,this._proxy=_.getProxy(m.MainContext.MainThreadMessageService)}showMessage(_,I,L,A,c){const E={extension:_};let h;typeof A=="string"||C(A)?h=[A,...c]:(E.modal=A?.modal,E.useCustom=A?.useCustom,E.detail=A?.detail,h=c),E.useCustom&&(0,y.checkProposedApiEnabled)(_,"resolvers");const p=[];for(let v=0;v<h.length;v++){const T=h[v];if(typeof T=="string")p.push({title:T,handle:v,isCloseAffordance:!1});else if(typeof T=="object"){let{title:b,isCloseAffordance:o}=T;p.push({title:b,isCloseAffordance:!!o,handle:v})}else this._logService.warn("Invalid message item:",T)}return this._proxy.$showMessage(I,L,E,p).then(v=>{if(typeof v=="number")return h[v]})}};P=je([ze(1,i.ILogService)],P),e.ExtHostMessageService=P}),define(ve[243],we([0,1,22,3,47,6,24,8,13,2,87,5,17,7,53,218,128]),function(J,e,m,i,y,C,P,D,_,I,L,A,c,E,h,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class T{constructor(o,s,g,l,S){this._textDocumentsAndEditors=g,this._textDocuments=l,this._extensionStoragePaths=S,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new P.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new i.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new i.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new i.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new i.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new i.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new i.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new i.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new i.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new L.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=o.getProxy(A.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=o.getProxy(A.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=o.getProxy(A.MainContext.MainThreadNotebookEditors),this._commandsConverter=s.converter,s.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===12){const t=n.notebookEditor?.notebookUri,r=n.cell.handle,a=this._documents.get(t)?.getCell(r);if(a)return a.apiCell}return n}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(o=>o.apiEditor)}getEditorById(o){const s=this._editors.get(o);if(!s)throw new Error(`unknown text editor: ${o}. known editors: ${[...this._editors.keys()]} `);return s}getIdByEditor(o){for(const[s,g]of this._editors)if(g.apiEditor===o)return s}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(o,s){const g=this._documents.get(o);if(!g&&!s)throw new Error(`NO notebook document for '${o}'`);return g}_getProviderData(o){const s=this._notebookContentProviders.get(o);if(!s)throw new Error(`NO provider for '${o}'`);return s}registerNotebookContentProvider(o,s,g,l,S){if((0,D.isFalsyOrWhitespace)(s))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(s))throw new Error(`Notebook provider for '${s}' already registered`);this._notebookContentProviders.set(s,{extension:o,provider:g});let n;return g.onDidChangeNotebookContentOptions&&(n=g.onDidChangeNotebookContentOptions(()=>{const t=c.NotebookDocumentContentOptions.from(g.options);this._notebookProxy.$updateNotebookProviderOptions(s,t)})),this._notebookProxy.$registerNotebookProvider({id:o.identifier,location:o.extensionLocation},s,c.NotebookDocumentContentOptions.from(l),T._convertNotebookRegistrationData(o,S)),new E.Disposable(()=>{n?.dispose(),this._notebookContentProviders.delete(s),this._notebookProxy.$unregisterNotebookProvider(s)})}static _convertNotebookRegistrationData(o,s){if(!s)return;const g=s.filenamePattern.map(l=>c.NotebookExclusiveDocumentPattern.from(l)).filter(l=>l!==void 0);if(s.filenamePattern&&!g){console.warn(`Notebook content provider view options file name pattern is invalid ${s.filenamePattern}`);return}return{extension:o.identifier,providerDisplayName:o.displayName||o.name,displayName:s.displayName,filenamePattern:g,exclusive:s.exclusive||!1}}registerNotebookCellStatusBarItemProvider(o,s,g){const l=T._notebookStatusBarItemProviderHandlePool++,S=typeof g.onDidChangeCellStatusBarItems=="function"?T._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(l,g),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(l,S,s);let n;return S!==void 0&&(n=g.onDidChangeCellStatusBarItems(t=>this._notebookProxy.$emitCellStatusBarEvent(S))),new E.Disposable(()=>{this._notebookStatusBarItemProviders.delete(l),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(l,S),n&&n.dispose()})}async createNotebookDocument(o){const s=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:o.viewType,content:o.content&&c.NotebookData.from(o.content)});return I.URI.revive(s)}async openNotebookDocument(o){const s=this._documents.get(o);if(s)return s.apiNotebook;const g=await this._notebookDocumentsProxy.$tryOpenNotebook(o),l=this._documents.get(I.URI.revive(g));return(0,_.assertIsDefined)(l?.apiNotebook)}async showNotebookDocument(o,s){I.URI.isUri(o)&&(o=await this.openNotebookDocument(o));let g;typeof s=="object"?g={position:c.ViewColumn.from(s.viewColumn),preserveFocus:s.preserveFocus,selections:s.selections&&s.selections.map(c.NotebookRange.from),pinned:typeof s.preview=="boolean"?!s.preview:void 0}:g={preserveFocus:!1};const l=await this._notebookEditorsProxy.$tryShowNotebookDocument(o.uri,o.notebookType,g),S=l&&this._editors.get(l)?.apiEditor;if(S)return S;throw l?new Error(`Could NOT open editor for "${o.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${o.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(o,s,g,l){const S=this._notebookStatusBarItemProviders.get(o),n=I.URI.revive(s),t=this._documents.get(n);if(!t||!S)return;const r=t.getCellFromIndex(g);if(!r)return;const u=await S.provideCellStatusBarItems(r.apiCell,l);if(!u)return;const a=new C.DisposableStore,f=this._statusBarCache.add([a]),d=(Array.isArray(u)?u:[u]).map(k=>c.NotebookStatusBarItem.from(k,this._commandsConverter,a));return{cacheId:f,items:d}}$releaseNotebookCellStatusBarItems(o){this._statusBarCache.delete(o)}registerNotebookSerializer(o,s,g,l,S){if((0,D.isFalsyOrWhitespace)(s))throw new Error("viewType cannot be empty or just whitespace");const n=this._handlePool++;return this._notebookSerializer.set(n,g),this._notebookProxy.$registerNotebookSerializer(n,{id:o.identifier,location:o.extensionLocation},s,c.NotebookDocumentContentOptions.from(l),T._convertNotebookRegistrationData(o,S)),(0,C.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(n)})}async $dataToNotebook(o,s,g){const l=this._notebookSerializer.get(o);if(!l)throw new Error("NO serializer found");const S=await l.deserializeNotebook(s.buffer,g);return new h.SerializableObjectWithBuffers(c.NotebookData.from(S))}async $notebookToData(o,s,g){const l=this._notebookSerializer.get(o);if(!l)throw new Error("NO serializer found");const S=await l.serializeNotebook(c.NotebookData.to(s.value),g);return m.VSBuffer.wrap(S)}async $openNotebook(o,s,g,l,S){const{provider:n}=this._getProviderData(o),t=await n.openNotebook(I.URI.revive(s),{backupId:g,untitledDocumentData:l?.buffer},S);return new h.SerializableObjectWithBuffers({metadata:t.metadata??Object.create(null),cells:t.cells.map(c.NotebookCellData.from)})}async $saveNotebook(o,s,g){const l=this.getNotebookDocument(I.URI.revive(s)),{provider:S}=this._getProviderData(o);return await S.saveNotebook(l.apiNotebook,g),!0}async $saveNotebookAs(o,s,g,l){const S=this.getNotebookDocument(I.URI.revive(s)),{provider:n}=this._getProviderData(o);return await n.saveNotebookAs(I.URI.revive(g),S.apiNotebook,l),!0}async $backupNotebook(o,s,g){const l=this.getNotebookDocument(I.URI.revive(s)),S=this._getProviderData(o),n=this._extensionStoragePaths.workspaceValue(S.extension)??this._extensionStoragePaths.globalValue(S.extension),t=String((0,y.hash)([l.uri.toString(),this._backupIdPool++])),r=I.URI.joinPath(n,t),u=await S.provider.backupNotebook(l.apiNotebook,{destination:r},g);return l.updateBackup(u),u.id}_createExtHostEditor(o,s,g){if(this._editors.has(s))throw new Error(`editor with id ALREADY EXSIST: ${s}`);const l=new v.ExtHostNotebookEditor(s,this._notebookEditorsProxy,o,g.visibleRanges.map(c.NotebookRange.to),g.selections.map(c.NotebookRange.to),typeof g.viewColumn=="number"?c.ViewColumn.to(g.viewColumn):void 0);this._editors.set(s,l)}$acceptDocumentAndEditorsDelta(o){if(o.value.removedDocuments)for(const g of o.value.removedDocuments){const l=I.URI.revive(g),S=this._documents.get(l);S&&(S.dispose(),this._documents.delete(l),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:S.apiNotebook.getCells().map(n=>n.document.uri)}),this._onDidCloseNotebookDocument.fire(S.apiNotebook));for(const n of this._editors.values())n.notebookData.uri.toString()===l.toString()&&this._editors.delete(n.id)}if(o.value.addedDocuments){const g=[];for(const l of o.value.addedDocuments){const S=I.URI.revive(l.uri);if(this._documents.has(S))throw new Error(`adding EXISTING notebook ${S} `);const n=this,t=new p.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(r){n._onDidChangeNotebookCells.fire(r)},emitCellOutputsChange(r){n._onDidChangeCellOutputs.fire(r)},emitCellMetadataChange(r){n._onDidChangeCellMetadata.fire(r)},emitCellExecutionStateChange(r){n._onDidChangeCellExecutionState.fire(r)}},S,l);g.push(...l.cells.map(r=>p.ExtHostCell.asModelAddData(t.apiNotebook,r))),this._documents.get(S)?.dispose(),this._documents.set(S,t),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:g}),this._onDidOpenNotebookDocument.fire(t.apiNotebook)}}if(o.value.addedEditors)for(const g of o.value.addedEditors){if(this._editors.has(g.id))return;const l=I.URI.revive(g.documentUri),S=this._documents.get(l);S&&this._createExtHostEditor(S,g.id,g)}const s=[];if(o.value.removedEditors)for(const g of o.value.removedEditors){const l=this._editors.get(g);l&&(this._editors.delete(g),this._activeNotebookEditor?.id===l.id&&(this._activeNotebookEditor=void 0),s.push(l))}if(o.value.visibleEditors){this._visibleNotebookEditors=o.value.visibleEditors.map(l=>this._editors.get(l)).filter(l=>!!l);const g=new Set;this._visibleNotebookEditors.forEach(l=>g.add(l.id));for(const l of this._editors.values()){const S=g.has(l.id);l._acceptVisibility(S)}this._visibleNotebookEditors=[...this._editors.values()].map(l=>l).filter(l=>l.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}o.value.newActiveEditor===null?this._activeNotebookEditor=void 0:o.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(o.value.newActiveEditor)),o.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=T,T._notebookStatusBarItemProviderHandlePool=0}),define(ve[244],we([0,1,3,76,11,5,14,17]),function(J,e,m,i,y,C,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class _{constructor(A,c){const E=_._Keys.nextId();A.$registerNotebookEditorDecorationType(E,D.NotebookDecorationRenderOptions.from(c)),this.value={key:E,dispose(){A.$removeNotebookEditorDecorationType(E)}}}}_._Keys=new i.IdGenerator("NotebookEditorDecorationType");let I=class{constructor(A,c,E){this._logService=A,this._extHostRpc=c,this._notebooksAndEditors=E,this._onDidChangeNotebookEditorSelection=new m.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new m.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(A){return new _(this._extHostRpc.getProxy(C.MainContext.MainThreadNotebookEditors),A).value}$acceptEditorPropertiesChanged(A,c){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",A,c);const E=this._notebooksAndEditors.getEditorById(A);c.visibleRanges&&E._acceptVisibleRanges(c.visibleRanges.ranges.map(D.NotebookRange.to)),c.selections&&E._acceptSelections(c.selections.selections.map(D.NotebookRange.to)),c.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:E.apiEditor,visibleRanges:E.apiEditor.visibleRanges}),c.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:E.apiEditor,selections:E.apiEditor.selections}))}$acceptEditorViewColumns(A){for(const c in A)this._notebooksAndEditors.getEditorById(c)._acceptViewColumn(D.ViewColumn.to(A[c]))}};I=je([ze(0,y.ILogService),ze(1,P.IExtHostRpcService)],I),e.ExtHostNotebookEditors=I}),define(ve[245],we([0,1,16,18,21,3,6,24,2,27,11,5,38,17,7,88,210,29,53]),function(J,e,m,i,y,C,P,D,_,I,L,A,c,E,h,p,v,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let o=class{constructor(n,t,r,u,a){this._initData=t,this._extHostNotebook=r,this._commands=u,this._logService=a,this._activeExecutions=new D.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=n.getProxy(A.MainContext.MainThreadNotebookKernels);const f=new c.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new c.ApiCommandArgument("options","Select kernel options",w=>!0,w=>{if(w&&"notebookEditor"in w&&"id"in w){const d=this._extHostNotebook.getIdByEditor(w.notebookEditor);return{id:w.id,extension:w.extension,notebookEditorId:d}}else if(w&&"notebookEditor"in w){const d=this._extHostNotebook.getIdByEditor(w.notebookEditor);if(d===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${w.notebookEditor.document.uri.toString()}`);return{notebookEditorId:d}}return w})],c.ApiCommandResult.Void);this._commands.registerApiCommand(f)}createNotebookController(n,t,r,u,a,f){for(let V of this._kernelData.values())if(V.controller.id===t&&I.ExtensionIdentifier.equals(n.identifier,V.extensionId))throw new Error(`notebook controller with id '${t}' ALREADY exist`);const w=this._handlePool++,d=this;this._logService.trace(`NotebookController[${w}], CREATED by ${n.identifier.value}, ${t}`);const k=()=>console.warn(`NO execute handler from notebook controller '${B.id}' of extension: '${n.identifier}'`);let R=!1;const N=new P.DisposableStore,x=new C.Emitter,F=new C.Emitter,B={id:`${n.identifier.value}/${t}`,notebookType:r,extensionId:n.identifier,extensionLocation:n.extensionLocation,label:u||n.identifier.value,preloads:f?f.map(E.NotebookRendererScript.from):[]};let O=a??k,H;this._proxy.$addKernel(w,B).catch(V=>{console.log(V),R=!0});let M=0;const W=()=>{if(R)return;const V=++M;Promise.resolve().then(()=>{V===M&&this._proxy.$updateKernel(w,B)})},z=new D.ResourceMap,U={get id(){return t},get notebookType(){return B.notebookType},onDidChangeSelectedNotebooks:x.event,get label(){return B.label},set label(V){B.label=V??n.displayName??n.name,W()},get detail(){return B.detail??""},set detail(V){B.detail=V,W()},get description(){return B.description??""},set description(V){B.description=V,W()},get kind(){return(0,T.checkProposedApiEnabled)(n,"notebookControllerKind"),B.kind??""},set kind(V){(0,T.checkProposedApiEnabled)(n,"notebookControllerKind"),B.kind=V,W()},get supportedLanguages(){return B.supportedLanguages},set supportedLanguages(V){B.supportedLanguages=V,W()},get supportsExecutionOrder(){return B.supportsExecutionOrder??!1},set supportsExecutionOrder(V){B.supportsExecutionOrder=V,W()},get rendererScripts(){return B.preloads?B.preloads.map(E.NotebookRendererScript.to):[]},get executeHandler(){return O},set executeHandler(V){O=V??k},get interruptHandler(){return H},set interruptHandler(V){H=V,B.supportsInterrupt=Boolean(V),W()},createNotebookCellExecution(V){if(R)throw new Error("notebook controller is DISPOSED");if(!z.has(V.notebook.uri))throw d._logService.trace(`NotebookController[${w}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(z.keys()).map(K=>K.toString())),new Error(`notebook controller is NOT associated to notebook: ${V.notebook.uri.toString()}`);return d._createNotebookCellExecution(V)},dispose:()=>{R||(this._logService.trace(`NotebookController[${w}], DISPOSED`),R=!0,this._kernelData.delete(w),N.dispose(),x.dispose(),F.dispose(),this._proxy.$removeKernel(w))},updateNotebookAffinity(V,K){d._proxy.$updateNotebookPriority(w,V.uri,K)},onDidReceiveMessage:F.event,postMessage(V,K){return(0,T.checkProposedApiEnabled)(n,"notebookMessaging"),d._proxy.$postMessage(w,K&&d._extHostNotebook.getIdByEditor(K),V)},asWebviewUri(V){return(0,T.checkProposedApiEnabled)(n,"notebookMessaging"),(0,p.asWebviewUri)(V,d._initData.remote)}};return this._kernelData.set(w,{extensionId:n.identifier,controller:U,onDidReceiveMessage:F,onDidChangeSelection:x,associatedNotebooks:z}),U}$acceptNotebookAssociation(n,t,r){const u=this._kernelData.get(n);if(u){const a=this._extHostNotebook.getNotebookDocument(_.URI.revive(t));r?u.associatedNotebooks.set(a.uri,!0):u.associatedNotebooks.delete(a.uri),this._logService.trace(`NotebookController[${n}] ASSOCIATE notebook`,a.uri.toString(),r),u.onDidChangeSelection.fire({selected:r,notebook:a.apiNotebook})}}async $executeCells(n,t,r){const u=this._kernelData.get(n);if(!u)return;const a=this._extHostNotebook.getNotebookDocument(_.URI.revive(t)),f=[];for(let w of r){const d=a.getCell(w);d&&f.push(d.apiCell)}try{this._logService.trace(`NotebookController[${n}] EXECUTE cells`,a.uri.toString(),f.length),await u.controller.executeHandler.call(u.controller,f,a.apiNotebook,u.controller)}catch(w){this._logService.error(`NotebookController[${n}] execute cells FAILED`,w),console.error(w)}}async $cancelCells(n,t,r){const u=this._kernelData.get(n);if(!u)return;const a=this._extHostNotebook.getNotebookDocument(_.URI.revive(t));if(u.controller.interruptHandler)await u.controller.interruptHandler.call(u.controller,a.apiNotebook);else for(let f of r){const w=a.getCell(f);w&&this._activeExecutions.get(w.uri)?.cancel()}}$acceptKernelMessageFromRenderer(n,t,r){const u=this._kernelData.get(n);if(!u)return;const a=this._extHostNotebook.getEditorById(t);u.onDidReceiveMessage.fire(Object.freeze({editor:a.apiEditor,message:r}))}_createNotebookCellExecution(n){if(n.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const r=this._extHostNotebook.getNotebookDocument(n.notebook.uri).getCellFromApiCell(n);if(!r)throw new Error("invalid cell");if(this._activeExecutions.has(r.uri))throw new Error(`duplicate execution for ${r.uri}`);const u=new g(r.notebook,r,this._proxy);this._activeExecutions.set(r.uri,u);const a=u.onDidChangeState(()=>{u.state===s.Resolved&&(u.dispose(),a.dispose(),this._activeExecutions.delete(r.uri))});return u.asApiObject()}};o=je([ze(4,L.ILogService)],o),e.ExtHostNotebookKernels=o;var s;(function(S){S[S.Init=0]="Init",S[S.Started=1]="Started",S[S.Resolved=2]="Resolved"})(s||(s={}));class g extends P.Disposable{constructor(n,t,r){super();this._document=n,this._cell=t,this._proxy=r,this._handle=g.HANDLE++,this._onDidChangeState=new C.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=s.Init,this._tokenSource=this._register(new y.CancellationTokenSource),this._collector=new l(10,u=>this.update(u)),this._executionOrder=t.internalMetadata.executionOrder,this._proxy.$addExecution(this._handle,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(n){await this._collector.addItem(n)}async update(n){const t=Array.isArray(n)?n:[n];return this._proxy.$updateExecutions(new b.SerializableObjectWithBuffers(t))}verifyStateForOutput(){if(this._state===s.Init)throw new Error("Must call start before modifying cell output");if(this._state===s.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(n){let t=this._cell;if(n&&(t=this._document.getCellFromApiCell(n)),!t)throw new Error("INVALID cell");return t.handle}validateAndConvertOutputs(n){return n.map(t=>{const r=h.NotebookCellOutput.ensureUniqueMimeTypes(t.items,!0);return r===t.items?E.NotebookCellOutput.from(t):E.NotebookCellOutput.from({items:r,id:t.id,metadata:t.metadata})})}async updateOutputs(n,t,r){const u=this.cellIndexToHandle(t),a=this.validateAndConvertOutputs((0,m.asArray)(n));return this.updateSoon({editType:v.CellExecutionUpdateType.Output,executionHandle:this._handle,cellHandle:u,append:r,outputs:a})}async updateOutputItems(n,t,r){return n=h.NotebookCellOutput.ensureUniqueMimeTypes((0,m.asArray)(n),!0),this.updateSoon({editType:v.CellExecutionUpdateType.OutputItems,executionHandle:this._handle,items:n.map(E.NotebookCellOutputItem.from),outputId:t.id,append:r})}asApiObject(){const n=this;return Object.freeze({get token(){return n._tokenSource.token},get cell(){return n._cell.apiCell},get executionOrder(){return n._executionOrder},set executionOrder(r){n._executionOrder=r,n.update([{editType:v.CellExecutionUpdateType.ExecutionState,executionHandle:n._handle,executionOrder:n._executionOrder}])},start(r){if(n._state===s.Resolved||n._state===s.Started)throw new Error("Cannot call start again");n._state=s.Started,n._onDidChangeState.fire(),n.update({editType:v.CellExecutionUpdateType.ExecutionState,executionHandle:n._handle,runStartTime:r})},end(r,u){if(n._state===s.Resolved)throw new Error("Cannot call resolve twice");n._state=s.Resolved,n._onDidChangeState.fire(),n.updateSoon({editType:v.CellExecutionUpdateType.Complete,executionHandle:n._handle,runEndTime:u,lastRunSuccess:r}),n._collector.flush(),n._proxy.$removeExecution(n._handle)},clearOutput(r){return n.verifyStateForOutput(),n.updateOutputs([],r,!1)},appendOutput(r,u){return n.verifyStateForOutput(),n.updateOutputs(r,u,!0)},replaceOutput(r,u){return n.verifyStateForOutput(),n.updateOutputs(r,u,!1)},appendOutputItems(r,u){return n.verifyStateForOutput(),n.updateOutputItems(r,u,!0)},replaceOutputItems(r,u){return n.verifyStateForOutput(),n.updateOutputItems(r,u,!1)}})}}g.HANDLE=0;class l{constructor(n,t){this.delay=n,this.callback=t,this.batch=[],this.startedTimer=Date.now()}addItem(n){return this.batch.push(n),this.currentDeferred||(this.currentDeferred=new i.DeferredPromise,this.startedTimer=Date.now(),(0,i.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const n=this.currentDeferred;this.currentDeferred=void 0;const t=this.batch;return this.batch=[],this.callback(t).finally(()=>n.complete())}}}),define(ve[246],we([0,1,3,5,128,29]),function(J,e,m,i,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class P{constructor(_,I){this._extHostNotebook=I,this._rendererMessageEmitters=new Map,this.proxy=_.getProxy(i.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(_,I,L){const A=this._extHostNotebook.getEditorById(_);this._rendererMessageEmitters.get(I)?.fire({editor:A.apiEditor,message:L})}createRendererMessaging(_,I){if(!_.contributes?.notebookRenderer?.some(E=>E.id===I))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${I})`);const L=(0,C.isProposedApiEnabled)(_,"notebookEditor"),A=new WeakMap;return{onDidReceiveMessage:(E,h,p)=>{const v=L?E:T=>{const b={};A.set(b,T.editor),E({editor:b,message:T.message})};return this.getOrCreateEmitterFor(I).event(v,h,p)},postMessage:(E,h)=>{y.ExtHostNotebookEditor.apiEditorsToExtHost.has(E)&&([E,h]=[h,E]);const p=L?h:A.get(h),v=p&&y.ExtHostNotebookEditor.apiEditorsToExtHost.get(p);return this.proxy.$postMessage(v?.id,I,E)}}}getOrCreateEmitterFor(_){let I=this._rendererMessageEmitters.get(_);return I||(I=new m.Emitter({onLastListenerRemove:()=>{I?.dispose(),this._rendererMessageEmitters.delete(_)}}),this._rendererMessageEmitters.set(_,I),I)}}e.ExtHostNotebookRenderers=P}),define(ve[132],we([0,1,5,6,4,14,11,211,66,26,44,151,22]),function(J,e,m,i,y,C,P,D,_,I,L,A,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.ExtHostOutputChannel=void 0;class E extends i.Disposable{constructor(v,T,b,o){super();this.id=v,this.name=T,this.logger=b,this.proxy=o,this.offset=0,this.visible=!1,this._disposed=!1}get disposed(){return this._disposed}appendLine(v){this.append(v+`
`)}append(v){this.write(v),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,D.OutputChannelUpdateMode.Append))}clear(){const v=this.offset;this.logger.flush(),this.proxy.$update(this.id,D.OutputChannelUpdateMode.Clear,v)}replace(v){const T=this.offset;this.write(v),this.proxy.$update(this.id,D.OutputChannelUpdateMode.Replace,T),this.visible&&this.logger.flush()}show(v,T){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof v=="boolean"?v:T))}hide(){this.proxy.$close(this.id)}write(v){this.offset+=c.VSBuffer.fromString(v).byteLength,this.logger.info(v)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}e.ExtHostOutputChannel=E;let h=class{constructor(v,T,b,o,s){this.extHostFileSystem=b,this.extHostFileSystemInfo=o,this.loggerService=s,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=v.getProxy(m.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(T.logsLocation,`output_logging_${(0,A.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(v){this.visibleChannelId=v;for(const[T,b]of this.channels)b.visible=T===this.visibleChannelId}createOutputChannel(v,T){if(v=v.trim(),!v)throw new Error("illegal argument `name`. must not be falsy");const b=this.doCreateOutputChannel(v,T);return b.then(o=>{this.channels.set(o.id,o),o.visible=o.id===this.visibleChannelId}),this.createExtHostOutputChannel(v,b)}async doCreateOutputChannel(v,T){const b=await this.createOutputDirectory(),o=this.extHostFileSystemInfo.extUri.joinPath(b,`${this.namePool++}-${v.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),s=this.loggerService.createLogger(o,{always:!0,donotRotate:!0,donotUseFormatters:!0}),g=await this.proxy.$register(v,!1,o,T.identifier.value);return new E(g,v,s,this.proxy)}createOutputDirectory(){return this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation)),this.outputDirectoryPromise}createExtHostOutputChannel(v,T){let b=!1;const o=()=>{if(b)throw new Error("Channel has been closed")};return{get name(){return v},append(s){o(),T.then(g=>g.append(s))},appendLine(s){o(),T.then(g=>g.appendLine(s))},clear(){o(),T.then(s=>s.clear())},replace(s){o(),T.then(g=>g.replace(s))},show(s,g){o(),T.then(l=>l.show(s,g))},hide(){o(),T.then(s=>s.hide())},dispose(){b=!0,T.then(s=>s.dispose())}}}};h=je([ze(0,C.IExtHostRpcService),ze(1,I.IExtHostInitDataService),ze(2,_.IExtHostConsumerFileSystem),ze(3,L.IExtHostFileSystemInfo),ze(4,P.ILoggerService)],h),e.ExtHostOutputService=h,e.IExtHostOutputService=(0,y.createDecorator)("IExtHostOutputService")}),define(ve[247],we([0,1,18,21,3,6,5,2,7,15,16,48,86,29]),function(J,e,m,i,y,C,P,D,_,I,L,A,c,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function h(p,v,T){const b=p.getProxy(P.MainContext.MainThreadQuickOpen);class o{constructor(a,f){this._sessions=new Map,this._instances=0,this._workspace=a,this._commands=f}showQuickPick(a,f,w=i.CancellationToken.None){this._onDidSelectItem=void 0;const d=Promise.resolve(a),k=++this._instances,R=b.$show(k,{title:f?.title,placeHolder:f?.placeHolder,matchOnDescription:f?.matchOnDescription,matchOnDetail:f?.matchOnDetail,ignoreFocusLost:f?.ignoreFocusOut,canPickMany:f?.canPickMany},w),N={},x=R.then(()=>N);return Promise.race([x,d]).then(F=>{if(F!==N)return d.then(B=>{const O=[];for(let H=0;H<B.length;H++){const M=B[H];typeof M=="string"?O.push({label:M,handle:H}):M.kind===_.QuickPickItemKind.Separator?O.push({type:"separator",label:M.label}):O.push({label:M.label,description:M.description,detail:M.detail,picked:M.picked,alwaysShow:M.alwaysShow,handle:H})}return f&&typeof f.onDidSelectItem=="function"&&(this._onDidSelectItem=H=>{f.onDidSelectItem(B[H])}),b.$setItems(k,O),R.then(H=>{if(typeof H=="number")return B[H];if(Array.isArray(H))return H.map(M=>B[M])})})}).then(void 0,F=>{if(!(0,I.isPromiseCanceledError)(F))return b.$setError(k,F),Promise.reject(F)})}$onItemSelected(a){this._onDidSelectItem&&this._onDidSelectItem(a)}showInput(a,f=i.CancellationToken.None){return this._validateInput=a?a.validateInput:void 0,b.$input(a,typeof this._validateInput=="function",f).then(void 0,w=>{if(!(0,I.isPromiseCanceledError)(w))return Promise.reject(w)})}$validateInput(a){return this._validateInput?(0,m.asPromise)(()=>this._validateInput(a)):Promise.resolve(void 0)}async showWorkspaceFolderPick(a,f=i.CancellationToken.None){const w=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[a]);if(!w)return;const d=await this._workspace.getWorkspaceFolders2();if(!!d)return d.find(k=>k.uri.toString()===w.uri.toString())}createQuickPick(a){const f=new t(a,()=>this._sessions.delete(f._id));return this._sessions.set(f._id,f),f}createInputBox(a){const f=new r(a,()=>this._sessions.delete(f._id));return this._sessions.set(f._id,f),f}$onDidChangeValue(a,f){const w=this._sessions.get(a);w&&w._fireDidChangeValue(f)}$onDidAccept(a){const f=this._sessions.get(a);f&&f._fireDidAccept()}$onDidChangeActive(a,f){const w=this._sessions.get(a);w instanceof t&&w._fireDidChangeActive(f)}$onDidChangeSelection(a,f){const w=this._sessions.get(a);w instanceof t&&w._fireDidChangeSelection(f)}$onDidTriggerButton(a,f){const w=this._sessions.get(a);w&&w._fireDidTriggerButton(f)}$onDidTriggerItemButton(a,f,w){const d=this._sessions.get(a);d instanceof t&&d._fireDidTriggerItemButton(f,w)}$onDidHide(a){const f=this._sessions.get(a);f&&f._fireDidHide()}}class s{constructor(a,f){this._extensionId=a,this._onDidDispose=f,this._id=t._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new y.Emitter,this._onDidChangeValueEmitter=new y.Emitter,this._onDidTriggerButtonEmitter=new y.Emitter,this._onDidHideEmitter=new y.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(a){this._title=a,this.update({title:a})}get step(){return this._steps}set step(a){this._steps=a,this.update({step:a})}get totalSteps(){return this._totalSteps}set totalSteps(a){this._totalSteps=a,this.update({totalSteps:a})}get enabled(){return this._enabled}set enabled(a){this._enabled=a,this.update({enabled:a})}get busy(){return this._busy}set busy(a){this._busy=a,this.update({busy:a})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(a){this._ignoreFocusOut=a,this.update({ignoreFocusOut:a})}get value(){return this._value}set value(a){this._value=a,this.update({value:a})}get placeholder(){return this._placeholder}set placeholder(a){this._placeholder=a,this.update({placeholder:a})}get buttons(){return this._buttons}set buttons(a){this._buttons=a.slice(),this._handlesToButtons.clear(),a.forEach((f,w)=>{const d=f===_.QuickInputButtons.Back?-1:w;this._handlesToButtons.set(d,f)}),this.update({buttons:a.map((f,w)=>({...n(f),tooltip:f.tooltip,handle:f===_.QuickInputButtons.Back?-1:w}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(a){this._value=a,this._onDidChangeValueEmitter.fire(a)}_fireDidTriggerButton(a){const f=this._handlesToButtons.get(a);f&&this._onDidTriggerButtonEmitter.fire(f)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,C.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),b.$dispose(this._id))}update(a){if(!this._disposed){for(const f of Object.keys(a)){const w=a[f];this._pendingUpdate[f]=w===void 0?null:w}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){b.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}s._nextId=1;function g(u){if(u instanceof _.ThemeIcon)return{id:u.id};const a=S(u),f=l(u);return{dark:typeof a=="string"?D.URI.file(a):a,light:typeof f=="string"?D.URI.file(f):f}}function l(u){return typeof u=="object"&&"light"in u?u.light:u}function S(u){return typeof u=="object"&&"dark"in u?u.dark:u}function n(u){const a=g(u.iconPath);let f,w;return"id"in a?w=c.ThemeIcon.asClassName(a):f=a,{iconPath:f,iconClass:w}}class t extends s{constructor(a,f){super(a.identifier,f);this.extension=a,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new y.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new y.Emitter,this._onDidTriggerItemButtonEmitter=new y.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(a){a.some(w=>w.kind!==void 0)&&(0,E.checkProposedApiEnabled)(this.extension,"quickPickSeparators"),this._items=a.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),a.forEach((w,d)=>{this._handlesToItems.set(d,w),this._itemsToHandles.set(w,d)});const f=[];for(let w=0;w<a.length;w++){const d=a[w];d.kind===_.QuickPickItemKind.Separator?f.push({type:"separator",label:d.label}):f.push({handle:w,label:d.label,description:d.description,detail:d.detail,picked:d.picked,alwaysShow:d.alwaysShow,buttons:d.buttons?.map((k,R)=>({...n(k),tooltip:k.tooltip,handle:R}))})}this.update({items:f})}get canSelectMany(){return this._canSelectMany}set canSelectMany(a){this._canSelectMany=a,this.update({canSelectMany:a})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(a){this._matchOnDescription=a,this.update({matchOnDescription:a})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(a){this._matchOnDetail=a,this.update({matchOnDetail:a})}get sortByLabel(){return this._sortByLabel}set sortByLabel(a){this._sortByLabel=a,this.update({sortByLabel:a})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(a){this._keepScrollPosition=a,this.update({keepScrollPosition:a})}get activeItems(){return this._activeItems}set activeItems(a){this._activeItems=a.filter(f=>this._itemsToHandles.has(f)),this.update({activeItems:this._activeItems.map(f=>this._itemsToHandles.get(f))})}get selectedItems(){return this._selectedItems}set selectedItems(a){this._selectedItems=a.filter(f=>this._itemsToHandles.has(f)),this.update({selectedItems:this._selectedItems.map(f=>this._itemsToHandles.get(f))})}_fireDidChangeActive(a){const f=(0,L.coalesce)(a.map(w=>this._handlesToItems.get(w)));this._activeItems=f,this._onDidChangeActiveEmitter.fire(f)}_fireDidChangeSelection(a){const f=(0,L.coalesce)(a.map(w=>this._handlesToItems.get(w)));this._selectedItems=f,this._onDidChangeSelectionEmitter.fire(f)}_fireDidTriggerItemButton(a,f){const w=this._handlesToItems.get(a);if(!w||!w.buttons||!w.buttons.length)return;const d=w.buttons[f];d&&this._onDidTriggerItemButtonEmitter.fire({button:d,item:w})}}class r extends s{constructor(a,f){super(a,f);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(a){this._password=a,this.update({password:a})}get prompt(){return this._prompt}set prompt(a){this._prompt=a,this.update({prompt:a})}get validationMessage(){return this._validationMessage}set validationMessage(a){this._validationMessage=a,this.update({validationMessage:a,severity:a?A.default.Error:A.default.Ignore})}}return new o(v,T)}e.createExtHostQuickOpen=h}),define(ve[248],we([0,1,2,3,57,6,18,5,16,99,11,27,86,17,29]),function(J,e,m,i,y,C,P,D,_,I,L,A,c,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function p(u){if(u)return typeof u.iconPath=="string"?m.URI.file(u.iconPath):m.URI.isUri(u.iconPath)||c.ThemeIcon.isThemeIcon(u.iconPath)?u.iconPath:void 0}function v(u,a){if(!u.iconPath&&!a.iconPath)return 0;if(u.iconPath){if(!a.iconPath)return 1}else return-1;const f=typeof u.iconPath=="string"?u.iconPath:m.URI.isUri(u.iconPath)?u.iconPath.fsPath:u.iconPath.id,w=typeof a.iconPath=="string"?a.iconPath:m.URI.isUri(a.iconPath)?a.iconPath.fsPath:a.iconPath.id;return(0,I.comparePaths)(f,w)}function T(u,a){let f=0;if(u.strikeThrough!==a.strikeThrough)return u.strikeThrough?1:-1;if(u.faded!==a.faded)return u.faded?1:-1;if(u.tooltip!==a.tooltip)return(u.tooltip||"").localeCompare(a.tooltip||"");if(f=v(u,a),f!==0)return f;if(u.light&&a.light)f=v(u.light,a.light);else{if(u.light)return 1;if(a.light)return-1}if(f!==0)return f;if(u.dark&&a.dark)f=v(u.dark,a.dark);else{if(u.dark)return 1;if(a.dark)return-1}return f}function b(u,a){if(u.command!==a.command)return u.command<a.command?-1:1;if(u.title!==a.title)return u.title<a.title?-1:1;if(u.tooltip!==a.tooltip){if(u.tooltip!==void 0&&a.tooltip!==void 0)return u.tooltip<a.tooltip?-1:1;if(u.tooltip!==void 0)return 1;if(a.tooltip!==void 0)return-1}if(u.arguments===a.arguments)return 0;if(u.arguments)if(a.arguments){if(u.arguments.length!==a.arguments.length)return u.arguments.length-a.arguments.length}else return 1;else return-1;for(let f=0;f<u.arguments.length;f++){const w=u.arguments[f],d=a.arguments[f];if(w!==d)return w<d?-1:1}return 0}function o(u,a){let f=(0,I.comparePaths)(u.resourceUri.fsPath,a.resourceUri.fsPath,!0);if(f!==0)return f;if(u.command&&a.command)f=b(u.command,a.command);else{if(u.command)return 1;if(a.command)return-1}if(f!==0)return f;if(u.decorations&&a.decorations)f=T(u.decorations,a.decorations);else{if(u.decorations)return 1;if(a.decorations)return-1}return f}function s(u,a){for(let f=0;f<u.length;f++)if(u[f]!==a[f])return!1;return!0}function g(u,a){return u.command===a.command&&u.title===a.title&&u.tooltip===a.tooltip&&(u.arguments&&a.arguments?s(u.arguments,a.arguments):u.arguments===a.arguments)}function l(u,a){return(0,_.equals)(u,a,g)}class S{constructor(a,f,w){this._extension=a,this._proxy=f,this._sourceControlHandle=w,this._value="",this._onDidChange=new i.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(a){a=a??"",this._proxy.$setInputBoxValue(this._sourceControlHandle,a),this.updateValue(a)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(a){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,a),this._placeholder=a}get validateInput(){return(0,h.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(a){if((0,h.checkProposedApiEnabled)(this._extension,"scmValidation"),a&&typeof a!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=a,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!a)}get visible(){return this._visible}set visible(a){a=!!a,this._visible!==a&&(this._visible=a,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,a))}showValidationMessage(a,f){(0,h.checkProposedApiEnabled)(this._extension,"scmValidation"),this._proxy.$showValidationMessage(this._sourceControlHandle,a,f)}$onInputBoxValueChange(a){this.updateValue(a)}updateValue(a){this._value=a,this._onDidChange.fire(a)}}e.ExtHostSCMInputBox=S;class n{constructor(a,f,w,d,k){this._proxy=a,this._commands=f,this._sourceControlHandle=w,this._id=d,this._label=k,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new i.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new i.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=n._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(a){this._label=a,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,a)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(a){this._hideWhenEmpty=a,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(a){this._resourceStates=[...a],this._onDidUpdateResourceStates.fire()}getResourceState(a){return this._resourceStatesMap.get(a)}$executeResourceCommand(a,f){const w=this._resourceStatesCommandsMap.get(a);return w?(0,P.asPromise)(()=>this._commands.executeCommand(w.command,...w.arguments||[],f)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const a=[...this._resourceStates].sort(o),w=(0,_.sortedDiff)(this._resourceSnapshot,a,o).map(R=>{const N=R.toInsert.map(x=>{const F=this._resourceHandlePool++;this._resourceStatesMap.set(F,x);const B=x.resourceUri;let O;if(x.command)if(x.command.command==="vscode.open"||x.command.command==="vscode.diff"){const Y=new C.DisposableStore;O=this._commands.converter.toInternal(x.command,Y),this._resourceStatesDisposablesMap.set(F,Y)}else this._resourceStatesCommandsMap.set(F,x.command);const H=p(x.decorations),M=x.decorations&&p(x.decorations.light)||H,W=x.decorations&&p(x.decorations.dark)||H,z=[M,W],U=x.decorations&&x.decorations.tooltip||"",V=x.decorations&&!!x.decorations.strikeThrough,K=x.decorations&&!!x.decorations.faded,G=x.contextValue||"";return{rawResource:[F,B,z,U,V,K,G,O],handle:F}});return{start:R.start,deleteCount:R.deleteCount,toInsert:N}}),d=w.map(({start:R,deleteCount:N,toInsert:x})=>[R,N,x.map(F=>F.rawResource)]),k=w.reverse();for(const{start:R,deleteCount:N,toInsert:x}of k){const F=x.map(O=>O.handle),B=this._handlesSnapshot.splice(R,N,...F);for(const O of B)this._resourceStatesMap.delete(O),this._resourceStatesCommandsMap.delete(O),this._resourceStatesDisposablesMap.get(O)?.dispose(),this._resourceStatesDisposablesMap.delete(O)}return this._resourceSnapshot=a,d}dispose(){this._disposed=!0,this._onDidDispose.fire()}}n._handlePool=0;class t{constructor(a,f,w,d,k,R){this._extension=a,this._proxy=f,this._commands=w,this._id=d,this._label=k,this._rootUri=R,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new C.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new C.MutableDisposable,this._statusBarDisposables=new C.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new i.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=t._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new S(a,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,d,k,R)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(a){this._count!==a&&(this._count=a,this._proxy.$updateSourceControl(this.handle,{count:a}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(a){this._quickDiffProvider=a,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!a})}get commitTemplate(){return this._commitTemplate}set commitTemplate(a){a!==this._commitTemplate&&(this._commitTemplate=a,this._proxy.$updateSourceControl(this.handle,{commitTemplate:a}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(a){this._acceptInputDisposables.value=new C.DisposableStore,this._acceptInputCommand=a;const f=this._commands.converter.toInternal(a,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:f})}get actionButton(){return(0,h.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(a){(0,h.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new C.DisposableStore,this._actionButton=a;const f=a!==void 0?this._commands.converter.toInternal(this._actionButton,this._actionButtonDisposables.value):void 0;this._proxy.$updateSourceControl(this.handle,{actionButton:f??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(a){if(this._statusBarCommands&&a&&l(this._statusBarCommands,a))return;this._statusBarDisposables.value=new C.DisposableStore,this._statusBarCommands=a;const f=(a||[]).map(w=>this._commands.converter.toInternal(w,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:f})}get selected(){return this._selected}createResourceGroup(a,f){const w=new n(this._proxy,this._commands,this.handle,a,f),d=i.Event.once(w.onDidDispose)(()=>this.createdResourceGroups.delete(w));return this.createdResourceGroups.set(w,d),this.eventuallyAddResourceGroups(),w}eventuallyAddResourceGroups(){const a=[],f=[];for(const[w,d]of this.createdResourceGroups){d.dispose();const k=w.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(w),this.eventuallyUpdateResourceStates()});i.Event.once(w.onDidDispose)(()=>{this.updatedResourceGroups.delete(w),k.dispose(),this._groups.delete(w.handle),this._proxy.$unregisterGroup(this.handle,w.handle)}),a.push([w.handle,w.id,w.label,w.features]);const R=w._takeResourceStateSnapshot();R.length>0&&f.push([w.handle,R]),this._groups.set(w.handle,w)}this._proxy.$registerGroups(this.handle,a,f),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const a=[];this.updatedResourceGroups.forEach(f=>{const w=f._takeResourceStateSnapshot();w.length!==0&&a.push([f.handle,w])}),a.length>0&&this._proxy.$spliceResourceStates(this.handle,a),this.updatedResourceGroups.clear()}getResourceGroup(a){return this._groups.get(a)}setSelectionState(a){this._selected=a,this._onDidChangeSelection.fire(a)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(a=>a.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}t._handlePool=0,je([(0,y.debounce)(100)],t.prototype,"eventuallyAddResourceGroups",null),je([(0,y.debounce)(100)],t.prototype,"eventuallyUpdateResourceStates",null);let r=class Hi{constructor(a,f,w){this._commands=f,this.logService=w,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new i.Emitter,this._proxy=a.getProxy(D.MainContext.MainThreadSCM),this._telemetry=a.getProxy(D.MainContext.MainThreadTelemetry),f.registerArgumentProcessor({processArgument:d=>{if(d&&d.$mid===3){const k=this._sourceControls.get(d.sourceControlHandle);if(!k)return d;const R=k.getResourceGroup(d.groupHandle);return R?R.getResourceState(d.handle):d}else if(d&&d.$mid===4){const k=this._sourceControls.get(d.sourceControlHandle);return k?k.getResourceGroup(d.groupHandle):d}else if(d&&d.$mid===5){const k=this._sourceControls.get(d.handle);return k||d}return d}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(a,f,w,d){this.logService.trace("ExtHostSCM#createSourceControl",a.identifier.value,f,w,d),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:a.identifier.value});const k=Hi._handlePool++,R=new t(a,this._proxy,this._commands,f,w,d);this._sourceControls.set(k,R);const N=this._sourceControlsByExtension.get(A.ExtensionIdentifier.toKey(a.identifier))||[];return N.push(R),this._sourceControlsByExtension.set(A.ExtensionIdentifier.toKey(a.identifier),N),R}getLastInputBox(a){this.logService.trace("ExtHostSCM#getLastInputBox",a.identifier.value);const f=this._sourceControlsByExtension.get(A.ExtensionIdentifier.toKey(a.identifier)),w=f&&f[f.length-1];return w&&w.inputBox}$provideOriginalResource(a,f,w){const d=m.URI.revive(f);this.logService.trace("ExtHostSCM#$provideOriginalResource",a,d.toString());const k=this._sourceControls.get(a);return!k||!k.quickDiffProvider||!k.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,P.asPromise)(()=>k.quickDiffProvider.provideOriginalResource(d,w)).then(R=>R||null)}$onInputBoxValueChange(a,f){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",a);const w=this._sourceControls.get(a);return w&&w.inputBox.$onInputBoxValueChange(f),Promise.resolve(void 0)}$executeResourceCommand(a,f,w,d){this.logService.trace("ExtHostSCM#$executeResourceCommand",a,f,w);const k=this._sourceControls.get(a);if(!k)return Promise.resolve(void 0);const R=k.getResourceGroup(f);return R?R.$executeResourceCommand(w,d):Promise.resolve(void 0)}$validateInput(a,f,w){this.logService.trace("ExtHostSCM#$validateInput",a);const d=this._sourceControls.get(a);return!d||!d.inputBox.validateInput?Promise.resolve(void 0):(0,P.asPromise)(()=>d.inputBox.validateInput(f,w)).then(k=>{if(!k)return Promise.resolve(void 0);const R=E.MarkdownString.fromStrict(k.message);return R?Promise.resolve([R,k.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(a){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",a),a!==void 0&&this._sourceControls.get(a)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=a,Promise.resolve(void 0)}};r._handlePool=0,r=je([ze(2,L.ILogService)],r),e.ExtHostSCM=r});var nt=this&&this.__classPrivateFieldSet||function(J,e,m,i,y){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!y:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?y.call(J,m):y?y.value=m:e.set(J,m),m},Be=this&&this.__classPrivateFieldGet||function(J,e,m,i){if(m==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!i:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?i:m==="a"?i.call(J):i?i.value:e.get(J)};define(ve[249],we([0,1,7,5,165,6,17,13]),function(J,e,m,i,y,C,P,D){"use strict";var _,I;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class L{constructor(h,p,v,T,b=m.StatusBarAlignment.Left,o){_.set(this,void 0),I.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new C.DisposableStore,nt(this,_,h,"f"),nt(this,I,p,"f"),this._entryId=L.ID_GEN++,this._extension=v,this._id=T,this._alignment=b,this._priority=this.validatePriority(o)}validatePriority(h){if(!!(0,D.isNumber)(h))return h===Number.POSITIVE_INFINITY?Number.MAX_VALUE:h===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:h}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(h){this._text=h,this.update()}set name(h){this._name=h,this.update()}set tooltip(h){this._tooltip=h,this.update()}set color(h){this._color=h,this.update()}set backgroundColor(h){h&&!L.ALLOWED_BACKGROUND_COLORS.has(h.id)&&(h=void 0),this._backgroundColor=h,this.update()}set command(h){this._command?.fromApi!==h&&(this._internalCommandRegistration.clear(),typeof h=="string"?this._command={fromApi:h,internal:Be(this,I,"f").toInternal({title:"",command:h},this._internalCommandRegistration)}:h?this._command={fromApi:h,internal:Be(this,I,"f").toInternal(h,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(h){this._accessibilityInformation=h,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Be(this,_,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let h;this._extension?this._id?h=`${this._extension.identifier.value}.${this._id}`:h=this._extension.identifier.value:h=this._id;let p;this._name?p=this._name:p=(0,y.localize)(0,null,this._extension.displayName||this._extension.name);let v=this._color;this._backgroundColor&&(v=L.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const T=this._tooltip?P.MarkdownString.fromStrict(this._tooltip):void 0;Be(this,_,"f").$setEntry(this._entryId,h,p,this._text,T,this._command?.internal,v,this._backgroundColor,this._alignment===m.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=L,_=new WeakMap,I=new WeakMap,L.ID_GEN=0,L.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new m.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new m.ThemeColor("statusBarItem.warningForeground")]]);class A{constructor(h){this._messages=[],this._item=h.createStatusBarEntry(void 0,"status.extensionMessage",m.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,y.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(h){const p={message:h};return this._messages.unshift(p),this._update(),new m.Disposable(()=>{const v=this._messages.indexOf(p);v>=0&&(this._messages.splice(v,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class c{constructor(h,p){this._proxy=h.getProxy(i.MainContext.MainThreadStatusBar),this._commands=p,this._statusMessage=new A(this)}createStatusBarEntry(h,p,v,T){return new L(this._proxy,this._commands,h,p,v,T)}setStatusBarMessage(h,p){const v=this._statusMessage.setMessage(h);let T;return typeof p=="number"?T=setTimeout(()=>v.dispose(),p):typeof p!="undefined"&&p.then(()=>v.dispose(),()=>v.dispose()),new m.Disposable(()=>{v.dispose(),clearTimeout(T)})}}e.ExtHostStatusBar=c}),define(ve[91],we([0,1,5,3,4]),function(J,e,m,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class C{constructor(D){this._onDidChangeStorage=new i.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=D.getProxy(m.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(D,_){this._proxy.$registerExtensionStorageKeysToSync(D,_)}getValue(D,_,I){return this._proxy.$getValue(D,_).then(L=>L||I)}setValue(D,_,I){return this._proxy.$setValue(D,_,I)}$acceptValue(D,_,I){this._onDidChangeStorage.fire({shared:D,key:_,value:I})}}e.ExtHostStorage=C,e.IExtHostStorage=(0,y.createDecorator)("IExtHostStorage")}),define(ve[67],we([0,1,4,26,11,66,2]),function(J,e,m,i,y,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,m.createDecorator)("IExtensionStoragePaths");let D=class{constructor(I,L,A){this._logService=L,this._extHostFileSystem=A,this._workspace=I.workspace??void 0,this._environment=I.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(c=>this._value=c)}async _getWorkspaceStorageURI(I){return P.URI.joinPath(this._environment.workspaceStorageHome,I)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const I=this._workspace.id,L=await this._getWorkspaceStorageURI(I);try{return await this._extHostFileSystem.value.stat(L),this._logService.trace("[ExtHostStorage] storage dir already exists",L),L}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",L),await this._extHostFileSystem.value.createDirectory(L),await this._extHostFileSystem.value.writeFile(P.URI.joinPath(L,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:P.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),L}catch(A){this._logService.error("[ExtHostStorage]",A);return}}workspaceValue(I){if(this._value)return P.URI.joinPath(this._value,I.identifier.value)}globalValue(I){return P.URI.joinPath(this._environment.globalStorageHome,I.identifier.value.toLowerCase())}onWillDeactivateAll(){}};D=je([ze(0,i.IExtHostInitDataService),ze(1,y.ILogService),ze(2,C.IExtHostConsumerFileSystem)],D),e.ExtensionStoragePaths=D}),define(ve[34],we([0,1,3,5,4,2,14,6,7,166,15,213,21,32,195,86,13,18]),function(J,e,m,i,y,C,P,D,_,I,L,A,c,E,h,p,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,y.createDecorator)("IExtHostTerminalService");class b{constructor(u,a,f,w){this._proxy=u,this._id=a,this._creationOptions=f,this._name=w,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(k=>this._pidPromiseComplete=k);const d=this;this.value={get name(){return d._name||""},get processId(){return d._pidPromise},get creationOptions(){return d._creationOptions},get exitStatus(){return d._exitStatus},get state(){return d._state},sendText(k,R=!0){d._checkDisposed(),d._proxy.$sendText(d._id,k,R)},show(k){d._checkDisposed(),d._proxy.$show(d._id,k)},hide(){d._checkDisposed(),d._proxy.$hide(d._id)},dispose(){d._disposed||(d._disposed=!0,d._proxy.$dispose(d._id))},get dimensions(){if(!(d._cols===void 0||d._rows===void 0))return{columns:d._cols,rows:d._rows}}}}async create(u,a){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:u.name,shellPath:(0,v.withNullAsUndefined)(u.shellPath),shellArgs:(0,v.withNullAsUndefined)(u.shellArgs),cwd:(0,v.withNullAsUndefined)(u.cwd),env:(0,v.withNullAsUndefined)(u.env),icon:(0,v.withNullAsUndefined)(n(u.iconPath)),color:p.ThemeColor.isThemeColor(u.color)?u.color.id:void 0,initialText:(0,v.withNullAsUndefined)(u.message),strictEnv:(0,v.withNullAsUndefined)(u.strictEnv),hideFromUser:(0,v.withNullAsUndefined)(u.hideFromUser),isFeatureTerminal:(0,v.withNullAsUndefined)(a?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,v.withNullAsUndefined)(a?.useShellEnvironment),location:a?.location||this._serializeParentTerminal(u.location,a?.resolvedExtHostIdentifier),disablePersistence:(0,v.withNullAsUndefined)(u.disablePersistence)})}async createExtensionTerminal(u,a,f,w){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:f,color:p.ThemeColor.isThemeColor(w)?w.id:void 0,location:this._serializeParentTerminal(u,a),disablePersistence:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(u,a){return typeof u=="object"?"parentTerminal"in u&&u.parentTerminal&&a?{parentTerminal:a}:"viewColumn"in u?{viewColumn:u.viewColumn,preserveFocus:u.preserveFocus}:void 0:u}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(u){this._name=u}setExitCode(u){this._exitStatus=Object.freeze({code:u})}setDimensions(u,a){return u===this._cols&&a===this._rows||u===0||a===0?!1:(this._cols=u,this._rows=a,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(u){this._pidPromiseComplete?(this._pidPromiseComplete(u),this._pidPromiseComplete=void 0):this._pidPromise.then(a=>{a!==u&&(this._pidPromise=Promise.resolve(u))})}}e.ExtHostTerminal=b;class o{constructor(u){this._pty=u,this.id=0,this.shouldPersist=!1,this._capabilities=[],this._onProcessData=new m.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new m.Emitter,this._onDidChangeProperty=new m.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new m.Emitter,this.onProcessExit=this._onProcessExit.event}get capabilities(){return this._capabilities}get onProcessReady(){return this._onProcessReady.event}refreshProperty(u){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${u}`)}updateProperty(u,a){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${u}, value: ${a}`)}async start(){}shutdown(){this._pty.close()}input(u){this._pty.handleInput?.(u)}resize(u,a){this._pty.setDimensions?.({columns:u,rows:a})}async processBinary(u){}acknowledgeDataEvent(u){}async setUnicodeVersion(u){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(u){this._pty.onDidWrite(a=>this._onProcessData.fire(a)),this._pty.onDidClose?.((a=void 0)=>{this._onProcessExit.fire(a===void 0?void 0:a)}),this._pty.onDidOverrideDimensions?.(a=>{a&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:a.columns,rows:a.rows}})}),this._pty.onDidChangeName?.(a=>{this._onDidChangeProperty.fire({type:"title",value:a})}),this._pty.open(u||void 0),u&&this._pty.setDimensions?.(u),this._onProcessReady.fire({pid:-1,cwd:"",capabilities:this._capabilities})}}e.ExtHostPseudoterminal=o;let s=1,g=class extends D.Disposable{constructor(u,a){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new m.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new m.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new m.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new m.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new m.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=a.getProxy(i.MainContext.MainThreadTerminalService),this._bufferer=new h.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new m.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(u),this._register({dispose:()=>{for(const[f,w]of this._terminalProcesses)w.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(u=>u.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(u){return(u?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(u){return(u?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(u,a){const f=new b(this._proxy,(0,E.generateUuid)(),u,u.name),w=new o(u.pty);return f.createExtensionTerminal(u.location,this._serializeParentTerminal(u,a).resolvedExtHostIdentifier,n(u.iconPath),t(u.color)).then(d=>{const k=this._setupExtHostProcessListeners(d,w);this._terminalProcessDisposables[d]=k}),this._terminals.push(f),f.value}_serializeParentTerminal(u,a){if(a=a||{},u.location&&typeof u.location=="object"&&"parentTerminal"in u.location){const f=u.location.parentTerminal;if(f){const w=this._terminals.find(d=>d.value===f);w&&(a.resolvedExtHostIdentifier=w._id)}}else u.location&&typeof u.location!="object"?a.location=u.location:a.location&&typeof a.location=="object"&&"splitActiveTerminal"in a.location&&(a.location={splitActiveTerminal:!0});return a}attachPtyToTerminal(u,a){if(!this._getTerminalById(u))throw new Error(`Cannot resolve terminal with id ${u} for virtual process`);const w=new o(a),d=this._setupExtHostProcessListeners(u,w);this._terminalProcessDisposables[u]=d}async $acceptActiveTerminalChanged(u){const a=this._activeTerminal;if(u===null){this._activeTerminal=void 0,a!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const f=this._getTerminalById(u);f&&(this._activeTerminal=f,a!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(u,a){const f=this._getTerminalById(u);f&&this._onDidWriteTerminalData.fire({terminal:f.value,data:a})}async $acceptTerminalDimensions(u,a,f){const w=this._getTerminalById(u);w&&w.setDimensions(a,f)&&this._onDidChangeTerminalDimensions.fire({terminal:w.value,dimensions:w.value.dimensions})}async $acceptTerminalMaximumDimensions(u,a,f){this._terminalProcesses.get(u)?.resize(a,f)}async $acceptTerminalTitleChange(u,a){const f=this._getTerminalById(u);f&&(f.name=a)}async $acceptTerminalClosed(u,a){const f=this._getTerminalObjectIndexById(this._terminals,u);if(f!==null){const w=this._terminals.splice(f,1)[0];w.setExitCode(a),this._onDidCloseTerminal.fire(w.value)}}$acceptTerminalOpened(u,a,f,w){if(a){const R=this._getTerminalObjectIndexById(this._terminals,a);if(R!==null){this._terminals[R]._id=u,this._onDidOpenTerminal.fire(this.terminals[R]),this._terminals[R].isOpen=!0;return}}const d={name:w.name,shellPath:w.executable,shellArgs:w.args,cwd:typeof w.cwd=="string"?w.cwd:C.URI.revive(w.cwd),env:w.env,hideFromUser:w.hideFromUser},k=new b(this._proxy,u,d,f);this._terminals.push(k),this._onDidOpenTerminal.fire(k.value),k.isOpen=!0}async $acceptTerminalProcessId(u,a){const f=this._getTerminalById(u);f&&f._setProcessId(a)}async $startExtensionTerminal(u,a){const f=this._getTerminalById(u);if(!f)return{message:(0,I.localize)(0,null,u)};f.isOpen||await new Promise(d=>{const k=this.onDidOpenTerminal(async R=>{R===f.value&&(k.dispose(),d())})});const w=this._terminalProcesses.get(u);w?w.startSendingEvents(a):this._extensionTerminalAwaitingStart[u]={initialDimensions:a}}_setupExtHostProcessListeners(u,a){const f=new D.DisposableStore;f.add(a.onProcessReady(d=>this._proxy.$sendProcessReady(u,d.pid,d.cwd))),f.add(a.onDidChangeProperty(d=>this._proxy.$sendProcessProperty(u,d))),this._bufferer.startBuffering(u,a.onProcessData),f.add(a.onProcessExit(d=>this._onProcessExit(u,d))),this._terminalProcesses.set(u,a);const w=this._extensionTerminalAwaitingStart[u];return w&&a instanceof o&&(a.startSendingEvents(w.initialDimensions),delete this._extensionTerminalAwaitingStart[u]),f}$acceptProcessAckDataEvent(u,a){this._terminalProcesses.get(u)?.acknowledgeDataEvent(a)}$acceptProcessInput(u,a){this._terminalProcesses.get(u)?.input(a)}$acceptTerminalInteraction(u){const a=this._getTerminalById(u);a?.setInteractedWith()&&this._onDidChangeTerminalState.fire(a.value)}$acceptProcessResize(u,a,f){try{this._terminalProcesses.get(u)?.resize(a,f)}catch(w){if(w.code!=="EPIPE"&&w.code!=="ERR_IPC_CHANNEL_CLOSED")throw w}}$acceptProcessShutdown(u,a){this._terminalProcesses.get(u)?.shutdown(a)}$acceptProcessRequestInitialCwd(u){this._terminalProcesses.get(u)?.getInitialCwd().then(a=>this._proxy.$sendProcessProperty(u,{type:"initialCwd",value:a}))}$acceptProcessRequestCwd(u){this._terminalProcesses.get(u)?.getCwd().then(a=>this._proxy.$sendProcessProperty(u,{type:"cwd",value:a}))}$acceptProcessRequestLatency(u){return u}registerLinkProvider(u){return this._linkProviders.add(u),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new _.Disposable(()=>{this._linkProviders.delete(u),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(u,a,f){if(this._profileProviders.has(a))throw new Error(`Terminal profile provider "${a}" already registered`);return this._profileProviders.set(a,f),this._proxy.$registerProfileProvider(a,u.identifier.value),new _.Disposable(()=>{this._profileProviders.delete(a),this._proxy.$unregisterProfileProvider(a)})}async $createContributedProfileTerminal(u,a){const f=new c.CancellationTokenSource().token;let w=await this._profileProviders.get(u)?.provideTerminalProfile(f);if(!f.isCancellationRequested){if(w&&!("options"in w)&&(w={options:w}),!w||!("options"in w))throw new Error(`No terminal profile options provided for id "${u}"`);if("pty"in w.options){this.createExtensionTerminal(w.options,a);return}this.createTerminalFromOptions(w.options,a)}}async $provideLinks(u,a){const f=this._getTerminalById(u);if(!f)return[];this._terminalLinkCache.delete(u);const w=this._terminalLinkCancellationSource.get(u);w&&w.dispose(!0);const d=new c.CancellationTokenSource;this._terminalLinkCancellationSource.set(u,d);const k=[],R={terminal:f.value,line:a},N=[];for(const B of this._linkProviders)N.push(T.Promises.withAsyncBody(async O=>{d.token.onCancellationRequested(()=>O({provider:B,links:[]}));const H=await B.provideTerminalLinks(R,d.token)||[];d.token.isCancellationRequested||O({provider:B,links:H})}));const x=await Promise.all(N);if(d.token.isCancellationRequested)return[];const F=new Map;for(const B of x)B&&B.links.length>0&&k.push(...B.links.map(O=>{const H={id:s++,startIndex:O.startIndex,length:O.length,label:O.tooltip};return F.set(H.id,{provider:B.provider,link:O}),H}));return this._terminalLinkCache.set(u,F),k}$activateLink(u,a){const f=this._terminalLinkCache.get(u)?.get(a);!f||f.provider.handleTerminalLink(f.link)}_onProcessExit(u,a){this._bufferer.stopBuffering(u),this._terminalProcesses.delete(u),delete this._extensionTerminalAwaitingStart[u];const f=this._terminalProcessDisposables[u];f&&(f.dispose(),delete this._terminalProcessDisposables[u]),this._proxy.$sendProcessExit(u,a)}_getTerminalById(u){return this._getTerminalObjectById(this._terminals,u)}_getTerminalObjectById(u,a){const f=this._getTerminalObjectIndexById(u,a);return f!==null?u[f]:null}_getTerminalObjectIndexById(u,a){let f=null;return u.some((w,d)=>w._id===a?(f=d,!0):!1),f}getEnvironmentVariableCollection(u){let a=this._environmentVariableCollections.get(u.identifier.value);return a||(a=new l,this._setEnvironmentVariableCollection(u.identifier.value,a)),a}_syncEnvironmentVariableCollection(u,a){const f=(0,A.serializeEnvironmentVariableCollection)(a.map);this._proxy.$setEnvironmentVariableCollection(u,a.persistent,f.length===0?void 0:f)}$initEnvironmentVariableCollections(u){u.forEach(a=>{const f=a[0],w=new l(a[1]);this._setEnvironmentVariableCollection(f,w)})}$acceptDefaultProfile(u,a){this._defaultProfile=u,this._defaultAutomationProfile=a}_setEnvironmentVariableCollection(u,a){this._environmentVariableCollections.set(u,a),a.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(u,a)})}};g=je([ze(1,P.IExtHostRpcService)],g),e.BaseExtHostTerminalService=g;class l{constructor(u){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new m.Emitter,this.map=new Map(u)}get persistent(){return this._persistent}set persistent(u){this._persistent=u,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(u,a){this._setIfDiffers(u,{value:a,type:_.EnvironmentVariableMutatorType.Replace})}append(u,a){this._setIfDiffers(u,{value:a,type:_.EnvironmentVariableMutatorType.Append})}prepend(u,a){this._setIfDiffers(u,{value:a,type:_.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(u,a){const f=this.map.get(u);(!f||f.value!==a.value||f.type!==a.type)&&(this.map.set(u,a),this._onDidChangeCollection.fire())}get(u){return this.map.get(u)}forEach(u,a){this.map.forEach((f,w)=>u.call(a,w,f,this))}delete(u){this.map.delete(u),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=l;let S=class extends g{constructor(u){super(!1,u)}createTerminal(u,a,f){throw new L.NotSupportedError}createTerminalFromOptions(u,a){throw new L.NotSupportedError}};S=je([ze(0,P.IExtHostRpcService)],S),e.WorkerExtHostTerminalService=S;function n(r){if(!(!r||typeof r=="string"))return"id"in r?{id:r.id,color:r.color}:r}function t(r){return p.ThemeColor.isThemeColor(r)?r:void 0}});var nt=this&&this.__classPrivateFieldSet||function(J,e,m,i,y){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!y:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?y.call(J,m):y?y.value=m:e.set(J,m),m},Be=this&&this.__classPrivateFieldGet||function(J,e,m,i){if(m==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!i:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?i:m==="a"?i.call(J):i?i.value:e.get(J)};define(ve[250],we([0,1,16,22,21,3,75,47,6,25,13,32,5,14,63,17,7,221,126,89]),function(J,e,m,i,y,C,P,D,_,I,L,A,c,E,h,p,v,T,b,o){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let g=class{constructor(R,N){this.resultsChangedEmitter=new C.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=R.getProxy(c.MainContext.MainThreadTesting),this.observer=new f(this.proxy),this.runTracker=new S(this.proxy),N.registerArgumentProcessor({processArgument:x=>x?.$mid===13?p.TestItem.toItemFromContext(x):x})}createTestController(R,N){if(this.controllers.has(R))throw new Error(`Attempt to insert a duplicate controller with ID "${R}"`);const x=new _.DisposableStore,F=x.add(new T.SingleUseTestCollection(R));F.root.label=N;const B=new Map,O=this.proxy,H={items:F.root.children,get label(){return N},set label(W){N=W,F.root.label=W,O.$updateControllerLabel(R,N)},get id(){return R},createRunProfile:(W,z,U,V,K)=>{let G=(0,D.hash)(W);for(;B.has(G);)G++;const Q=new w(this.proxy,R,G,W,z,U,V,K);return B.set(G,Q),Q},createTestItem(W,z,U){return new h.TestItemImpl(R,W,z,U)},createTestRun:(W,z,U=!0)=>this.runTracker.createTestRun(R,F,W,z,U),set resolveHandler(W){F.resolveHandler=W},get resolveHandler(){return F.resolveHandler},dispose:()=>{x.dispose()}};H.createRunConfiguration=H.createRunProfile,O.$registerTestController(R,N),x.add((0,_.toDisposable)(()=>O.$unregisterTestController(R)));const M={controller:H,collection:F,profiles:B};return this.controllers.set(R,M),x.add((0,_.toDisposable)(()=>this.controllers.delete(R))),x.add(F.onDidGenerateDiff(W=>O.$publishDiff(R,W))),H}createTestObserver(){return this.observer.checkout()}async runTests(R,N=y.CancellationToken.None){const x=n(R);if(!x)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const F=this.controllers.get(x.controllerId);if(!F)throw new Error("Controller not found");await this.proxy.$runTests({targets:[{testIds:R.include?.map(B=>B.id)??[F.collection.root.id],profileGroup:d[x.kind],profileId:x.profileId,controllerId:x.controllerId}],exclude:R.exclude?.map(B=>B.id)},N)}$provideFileCoverage(R,N,x){return(0,m.mapFind)(this.runTracker.trackers,B=>B.id===R?B.getCoverage(N):void 0)?.provideFileCoverage(x)??Promise.resolve([])}$resolveFileCoverage(R,N,x,F){return(0,m.mapFind)(this.runTracker.trackers,O=>O.id===R?O.getCoverage(N):void 0)?.resolveFileCoverage(x,F)??Promise.resolve([])}$configureRunProfile(R,N){this.controllers.get(R)?.profiles.get(N)?.configureHandler?.()}$publishTestResults(R){this.results=Object.freeze(R.map(N=>(0,I.deepFreeze)(p.TestResults.to(N))).concat(this.results).sort((N,x)=>x.completedAt-N.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(R,N){const x=this.controllers.get(o.TestId.fromString(R).controllerId)?.collection;x&&(await x.expand(R,N<0?1/0:N),x.flushDiff())}$acceptDiff(R){this.observer.applyDiff(R)}async $runControllerTests(R,N){const x=this.controllers.get(R.controllerId);if(!x)return;const{collection:F,profiles:B}=x,O=B.get(R.profileId);if(!O)return;const H=R.testIds.map(U=>F.tree.get(U)).filter(L.isDefined),M=R.excludeExtIds.map(U=>x.collection.tree.get(U)).filter(L.isDefined).filter(U=>H.some(V=>V.fullId.compare(U.fullId)===2));if(!H.length)return;const W=new v.TestRunRequest(H.some(U=>U.actual instanceof h.TestItemRootImpl)?void 0:H.map(U=>U.actual),M.map(U=>U.actual),O),z=this.runTracker.prepareForMainThreadTestRun(W,t.fromInternal(R,x.collection),N);try{await O.runHandler(W,N)}finally{z.isRunning&&!N.isCancellationRequested&&await C.Event.toPromise(z.onEnd),z.dispose()}}$cancelExtensionTestRun(R){R===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(R)}};g=je([ze(0,E.IExtHostRpcService)],g),e.ExtHostTesting=g;class l extends _.Disposable{constructor(R,N,x){super();this.dto=R,this.proxy=N,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new C.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new y.CancellationTokenSource(x)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:F}of this.tasks.values())F.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(R){return this.tasks.get(R)?.coverage}createRun(R){const N=this.dto.id,x=this.dto.controllerId,F=(0,A.generateUuid)(),B=new r(this.proxy,N,F),O=z=>(U,...V)=>{if(M){console.warn(`Setting the state of test "${U.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(U)||(this.ensureTestIsKnown(U),z(U,...V))},H=(z,U)=>{const V=U instanceof Array?U.map(p.TestMessage.from):[p.TestMessage.from(U)];if(z.uri&&z.range){const K={range:p.Range.from(z.range),uri:z.uri};for(const G of V)G.location=G.location||K}this.proxy.$appendTestMessagesInRun(N,F,o.TestId.fromExtHostTestItem(z,x).toString(),V)};let M=!1;const W={isPersisted:this.dto.isPersisted,token:this.cts.token,name:R,get coverageProvider(){return B.coverageProvider},set coverageProvider(z){B.coverageProvider=z},enqueued:O(z=>{this.proxy.$updateTestStateInRun(N,F,o.TestId.fromExtHostTestItem(z,x).toString(),1)}),skipped:O(z=>{this.proxy.$updateTestStateInRun(N,F,o.TestId.fromExtHostTestItem(z,x).toString(),5)}),started:O(z=>{this.proxy.$updateTestStateInRun(N,F,o.TestId.fromExtHostTestItem(z,x).toString(),2)}),errored:O((z,U,V)=>{H(z,U),this.proxy.$updateTestStateInRun(N,F,o.TestId.fromExtHostTestItem(z,x).toString(),6,V)}),failed:O((z,U,V)=>{H(z,U),this.proxy.$updateTestStateInRun(N,F,o.TestId.fromExtHostTestItem(z,x).toString(),4,V)}),passed:O((z,U)=>{this.proxy.$updateTestStateInRun(N,F,o.TestId.fromExtHostTestItem(z,this.dto.controllerId).toString(),3,U)}),appendOutput:(z,U,V)=>{M||(V&&(this.dto.isIncluded(V)?this.ensureTestIsKnown(V):V=void 0),this.proxy.$appendOutputToRun(N,F,i.VSBuffer.fromString(z),U&&p.location.from(U),V&&o.TestId.fromExtHostTestItem(V,x).toString()))},end:()=>{M||(M=!0,this.proxy.$finishedTestRunTask(N,F),this.tasks.delete(F),this.isRunning||this.dispose())}};return this.tasks.set(F,{run:W,coverage:B}),this.proxy.$startedTestRunTask(N,{id:F,name:R,running:!0}),W}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(R){if(!(R instanceof h.TestItemImpl))throw new h.InvalidTestItemError(R.id);if(this.sharedTestIds.has(o.TestId.fromExtHostTestItem(R,this.dto.controllerId).toString()))return;const N=[],x=this.dto.colllection.root;for(;;){const F=p.TestItem.from(R);if(N.unshift(F),this.sharedTestIds.has(F.extId)||(this.sharedTestIds.add(F.extId),R===x))break;R=R.parent||x}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,N)}}class S{constructor(R){this.proxy=R,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(R,N,x){return this.getTracker(R,N,x)}cancelRunById(R){for(const N of this.tracked.values())if(N.id===R){N.dispose();return}}cancelAllRuns(){for(const R of this.tracked.values())R.dispose()}createTestRun(R,N,x,F,B){const O=this.tracked.get(x);if(O)return O.createRun(F);const H=t.fromPublic(R,N,x,B),M=n(x);this.proxy.$startedExtensionTestRun({controllerId:R,profile:M&&{group:d[M.kind],id:M.profileId},exclude:x.exclude?.map(z=>z.id)??[],id:H.id,include:x.include?.map(z=>z.id)??[N.root.id],persist:B});const W=this.getTracker(x,H);return W.onEnd(()=>this.proxy.$finishedExtensionTestRun(H.id)),W.createRun(F)}getTracker(R,N,x){const F=new l(N,this.proxy,x);return this.tracked.set(R,F),F.onEnd(()=>this.tracked.delete(R)),F}}e.TestRunCoordinator=S;const n=k=>{if(!!k.profile){if(!(k.profile instanceof w))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return k.profile}};class t{constructor(R,N,x,F,B,O){this.controllerId=R,this.id=N,this.isPersisted=B,this.colllection=O,this.includePrefix=x.map(H=>H+"\0"),this.excludePrefix=F.map(H=>H+"\0")}static fromPublic(R,N,x,F){return new t(R,(0,A.generateUuid)(),x.include?.map(B=>o.TestId.fromExtHostTestItem(B,R).toString())??[R],x.exclude?.map(B=>o.TestId.fromExtHostTestItem(B,R).toString())??[],F,N)}static fromInternal(R,N){return new t(R.controllerId,R.runId,R.testIds,R.excludeExtIds,!0,N)}isIncluded(R){const N=o.TestId.fromExtHostTestItem(R,this.controllerId).toString()+"\0";for(const x of this.excludePrefix)if(N===x||N.startsWith(x))return!1;for(const x of this.includePrefix)if(N===x||N.startsWith(x))return!0;return!1}}e.TestRunDto=t;class r{constructor(R,N,x){this.proxy=R,this.runId=N,this.taskId=x}set coverageProvider(R){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!R||(this._coverageProvider=R,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(R){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(R))());try{return(await this.fileCoverage)?.map(p.TestCoverage.fromFile)??[]}catch(N){throw this.fileCoverage=void 0,N}}async resolveFileCoverage(R,N){const x=await this.fileCoverage;let F=x?.[R];return!this._coverageProvider||!x||!F?[]:(F.detailedCoverage||(F=x[R]=await this._coverageProvider.resolveFileCoverage?.(F,N)??F),F.detailedCoverage?.map(p.TestCoverage.fromDetailed)??[])}}class u extends b.IncrementalChangeCollector{constructor(R){super();this.emitter=R,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(R){this.added.add(R)}update(R){Object.assign(R.revived,p.TestItem.toPlain(R.item)),this.added.has(R)||this.updated.add(R)}remove(R){if(this.added.has(R)){this.added.delete(R);return}if(this.updated.delete(R),R.parent&&this.alreadyRemoved.has(R.parent)){this.alreadyRemoved.add(R.item.extId);return}this.removed.add(R)}getChangeEvent(){const{added:R,updated:N,removed:x}=this;return{get added(){return[...R].map(F=>F.revived)},get updated(){return[...N].map(F=>F.revived)},get removed(){return[...x].map(F=>F.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class a extends b.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new C.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(R){return this.items.get(R)}getMirroredTestDataByReference(R){return this.items.get(R.id)}createItem(R,N){return{...R,revived:p.TestItem.toPlain(R.item),depth:N?N.depth+1:0,children:new Set}}createChangeCollector(){return new u(this.changeEmitter)}}e.MirroredTestCollection=a;class f{constructor(R){this.proxy=R}checkout(){this.current||(this.current=this.createObserverData());const R=this.current;return R.observers++,{onDidChangeTest:R.tests.onDidChangeTests,get tests(){return[...R.tests.rootTests].map(N=>N.revived)},dispose:(0,P.once)(()=>{--R.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(R){return this.current?.tests.getMirroredTestDataByReference(R)}applyDiff(R){this.current?.tests.apply(R)}createObserverData(){const R=new a;return this.proxy.$subscribeToDiffs(),{observers:0,tests:R}}}class w{constructor(R,N,x,F,B,O,H=!1,M=void 0){this.controllerId=N,this.profileId=x,this._label=F,this.kind=B,this.runHandler=O,this._isDefault=H,this._tag=M,s.set(this,void 0),nt(this,s,R,"f");const W=d[B];if(typeof W!="number")throw new Error(`Unknown TestRunProfile.group ${B}`);Be(this,s,"f").$publishTestRunProfile({profileId:x,controllerId:N,tag:M?p.TestTag.namespace(this.controllerId,M.id):null,label:F,group:W,isDefault:H,hasConfigurationHandler:!1})}get label(){return this._label}set label(R){R!==this._label&&(this._label=R,Be(this,s,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:R}))}get isDefault(){return this._isDefault}set isDefault(R){R!==this._isDefault&&(this._isDefault=R,Be(this,s,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:R}))}get tag(){return this._tag}set tag(R){R?.id!==this._tag?.id&&(this._tag=R,Be(this,s,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:R?p.TestTag.namespace(this.controllerId,R.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(R){R!==this._configureHandler&&(this._configureHandler=R,Be(this,s,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!R}))}dispose(){Be(this,s,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=w,s=new WeakMap;const d={[v.TestRunProfileKind.Coverage]:8,[v.TestRunProfileKind.Debug]:4,[v.TestRunProfileKind.Run]:2}}),define(ve[251],we([0,1,3,16,5,129,17,7]),function(J,e,m,i,y,C,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class _{constructor(L,A){this._extHostDocumentsAndEditors=A,this._onDidChangeTextEditorSelection=new m.Emitter,this._onDidChangeTextEditorOptions=new m.Emitter,this._onDidChangeTextEditorVisibleRanges=new m.Emitter,this._onDidChangeTextEditorViewColumn=new m.Emitter,this._onDidChangeActiveTextEditor=new m.Emitter,this._onDidChangeVisibleTextEditors=new m.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=L.getProxy(y.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(c=>this._onDidChangeVisibleTextEditors.fire(c)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(c=>this._onDidChangeActiveTextEditor.fire(c))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(L){const A=this._extHostDocumentsAndEditors.allEditors();return L?A:A.map(c=>c.value)}async showTextDocument(L,A,c){let E;typeof A=="number"?E={position:P.ViewColumn.from(A),preserveFocus:c}:typeof A=="object"?E={position:P.ViewColumn.from(A.viewColumn),preserveFocus:A.preserveFocus,selection:typeof A.selection=="object"?P.Range.from(A.selection):void 0,pinned:typeof A.preview=="boolean"?!A.preview:void 0}:E={preserveFocus:!1};const h=await this._proxy.$tryShowTextDocument(L.uri,E),p=h&&this._extHostDocumentsAndEditors.getEditor(h);if(p)return p.value;throw h?new Error(`Could NOT open editor for "${L.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${L.uri.toString()}".`)}createTextEditorDecorationType(L,A){return new C.TextEditorDecorationType(this._proxy,L,A).value}$acceptEditorPropertiesChanged(L,A){const c=this._extHostDocumentsAndEditors.getEditor(L);if(!c)throw new Error("unknown text editor");if(A.options&&c._acceptOptions(A.options),A.selections){const E=A.selections.selections.map(P.Selection.to);c._acceptSelections(E)}if(A.visibleRanges){const E=i.coalesce(A.visibleRanges.map(P.Range.to));c._acceptVisibleRanges(E)}if(A.options&&this._onDidChangeTextEditorOptions.fire({textEditor:c.value,options:{...A.options,lineNumbers:P.TextEditorLineNumbersStyle.to(A.options.lineNumbers)}}),A.selections){const E=D.TextEditorSelectionChangeKind.fromValue(A.selections.source),h=A.selections.selections.map(P.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:c.value,selections:h,kind:E})}if(A.visibleRanges){const E=i.coalesce(A.visibleRanges.map(P.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:c.value,visibleRanges:E})}}$acceptEditorPositionData(L){for(const A in L){const c=this._extHostDocumentsAndEditors.getEditor(A);if(!c)throw new Error("Unknown text editor");const E=P.ViewColumn.to(L[A]);c.value.viewColumn!==E&&(c._acceptViewColumn(E),this._onDidChangeTextEditorViewColumn.fire({textEditor:c.value,viewColumn:E}))}}getDiffInformation(L){return Promise.resolve(this._proxy.$getDiffInformation(L))}}e.ExtHostEditors=_}),define(ve[252],we([0,1,2,4,5,6,7]),function(J,e,m,i,y,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,i.createDecorator)("IExtHostTimeline");class D{constructor(L,A){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=L.getProxy(y.MainContext.MainThreadTimeline),A.registerArgumentProcessor({processArgument:c=>{if(c&&c.$mid===11){const E=c.uri===void 0?void 0:m.URI.revive(c.uri);return this._itemsBySourceAndUriMap.get(c.source)?.get(_(E))?.get(c.handle)}return c}})}async $getTimeline(L,A,c,E,h){return this._providers.get(L)?.provideTimeline(m.URI.revive(A),c,E,h)}registerTimelineProvider(L,A,c,E){const h=new C.DisposableStore,p=this.convertTimelineItem(A.id,E,h).bind(this);let v;A.onDidChange&&(v=A.onDidChange(b=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...b,id:A.id}),this));const T=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...A,scheme:L,onDidChange:void 0,async provideTimeline(b,o,s,g){g?.resetCache&&(h.clear(),T.get(A.id)?.clear());const l=await A.provideTimeline(b,o,s);if(l==null)return;const S=p(b,g);return{...l,source:A.id,items:l.items.map(S)}},dispose(){for(const b of T.values())b.get(A.id)?.clear();v?.dispose(),h.dispose()}})}convertTimelineItem(L,A,c){return(E,h)=>{let p;if(h?.cacheResults){let v=this._itemsBySourceAndUriMap.get(L);v===void 0&&(v=new Map,this._itemsBySourceAndUriMap.set(L,v));const T=_(E);p=v.get(T),p===void 0&&(p=new Map,v.set(T,p))}return v=>{const{iconPath:T,...b}=v,o=`${L}|${v.id??v.timestamp}`;p?.set(o,v);let s,g,l;return v.iconPath&&(T instanceof P.ThemeIcon?l={id:T.id,color:T.color}:m.URI.isUri(T)?(s=T,g=T):{light:s,dark:g}=T),{...b,id:b.id??void 0,handle:o,source:L,command:v.command?A.toInternal(v.command,c):void 0,icon:s,iconDark:g,themeIcon:l,accessibilityInformation:v.accessibilityInformation}}}}registerTimelineProviderCore(L){if(this._providers.get(L.id))throw new Error(`Timeline Provider ${L.id} already exists.`);return this._proxy.$registerTimelineProvider({id:L.id,label:L.label,scheme:L.scheme}),this._providers.set(L.id,L),(0,C.toDisposable)(()=>{for(const c of this._itemsBySourceAndUriMap.values())c.get(L.id)?.clear();this._providers.delete(L.id),this._proxy.$unregisterTimelineProvider(L.id),L.dispose()})}}e.ExtHostTimeline=D;function _(I){return I?.toString()}}),define(ve[253],we([0,1,6,10,2,5]),function(J,e,m,i,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class P{constructor(_){this._openers=new Map,this._proxy=_.getProxy(C.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(_,I,L,A){if(this._openers.has(I))throw new Error(`Opener with id '${I}' already registered`);const c=A.schemes.find(E=>!P.supportedSchemes.has(E));if(c)throw new Error(`Scheme '${c}' is not supported. Only http and https are currently supported.`);return this._openers.set(I,L),this._proxy.$registerUriOpener(I,A.schemes,_,A.label),(0,m.toDisposable)(()=>{this._openers.delete(I),this._proxy.$unregisterUriOpener(I)})}async $canOpenUri(_,I,L){const A=this._openers.get(_);if(!A)throw new Error(`Unknown opener with id: ${_}`);const c=y.URI.revive(I);return A.canOpenExternalUri(c,L)}async $openUri(_,I,L){const A=this._openers.get(_);if(!A)throw new Error(`Unknown opener id: '${_}'`);return A.openExternalUri(y.URI.revive(I.resolvedUri),{sourceUri:y.URI.revive(I.sourceUri)},L)}}e.ExtHostUriOpeners=P,P.supportedSchemes=new Set([i.Schemas.http,i.Schemas.https])}),define(ve[254],we([0,1,5,2,6,15,27]),function(J,e,m,i,y,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class D{constructor(I){this.handles=new Set,this.handlers=new Map,this._proxy=I.getProxy(m.MainContext.MainThreadUrls)}registerUriHandler(I,L){if(this.handles.has(P.ExtensionIdentifier.toKey(I)))throw new Error(`Protocol handler already registered for extension ${I}`);const A=D.HandlePool++;return this.handles.add(P.ExtensionIdentifier.toKey(I)),this.handlers.set(A,L),this._proxy.$registerUriHandler(A,I),(0,y.toDisposable)(()=>{this.handles.delete(P.ExtensionIdentifier.toKey(I)),this.handlers.delete(A),this._proxy.$unregisterUriHandler(A)})}$handleExternalUri(I,L){const A=this.handlers.get(I);if(!A)return Promise.resolve(void 0);try{A.handleUri(i.URI.revive(L))}catch(c){(0,C.onUnexpectedError)(c)}return Promise.resolve(void 0)}async createAppUri(I){return i.URI.revive(await this._proxy.$createAppUri(I))}}e.ExtHostUrls=D,D.HandlePool=0});var nt=this&&this.__classPrivateFieldSet||function(J,e,m,i,y){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!y:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?y.call(J,m):y?y.value=m:e.set(J,m),m},Be=this&&this.__classPrivateFieldGet||function(J,e,m,i){if(m==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!i:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?i:m==="a"?i.call(J):i?i.value:e.get(J)};define(ve[68],we([0,1,3,10,2,178,203,88,5]),function(J,e,m,i,y,C,P,D,_){"use strict";var I,L,A,c,E,h,p,v,T,b,o,s;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class g{constructor(f,w,d,k,R,N,x){I.set(this,void 0),L.set(this,void 0),A.set(this,void 0),c.set(this,void 0),E.set(this,void 0),h.set(this,void 0),p.set(this,""),v.set(this,void 0),T.set(this,!1),b.set(this,!1),o.set(this,!1),this._onMessageEmitter=new m.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,s.set(this,new m.Emitter),this._onDidDispose=Be(this,s,"f").event,nt(this,I,f,"f"),nt(this,L,w,"f"),nt(this,v,d,"f"),nt(this,c,k,"f"),nt(this,E,R,"f"),nt(this,h,N,"f"),nt(this,o,l(N),"f"),nt(this,A,x,"f")}dispose(){nt(this,T,!0,"f"),Be(this,s,"f").fire(),Be(this,s,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(f){return nt(this,b,!0,"f"),(0,D.asWebviewUri)(f,Be(this,c,"f").remote)}get cspSource(){const f=Be(this,h,"f").extensionLocation;if(f.scheme===i.Schemas.https||f.scheme===i.Schemas.http){let w=f.toString();return w.endsWith("/")||(w+="/"),w+" "+D.webviewGenericCspSource}return D.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Be(this,p,"f")}set html(f){this.assertNotDisposed(),Be(this,p,"f")!==f&&(nt(this,p,f,"f"),!Be(this,b,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(f)&&(nt(this,b,!0,"f"),Be(this,A,"f").report("Webview vscode-resource: uris",Be(this,h,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Be(this,L,"f").$setHtml(Be(this,I,"f"),f))}get options(){return this.assertNotDisposed(),Be(this,v,"f")}set options(f){this.assertNotDisposed(),Be(this,L,"f").$setOptions(Be(this,I,"f"),t(Be(this,h,"f"),Be(this,E,"f"),f)),nt(this,v,f,"f")}async postMessage(f){if(Be(this,T,"f"))return!1;const w=(0,P.serializeWebviewMessage)(f,{serializeBuffersForPostMessage:Be(this,o,"f")});return Be(this,L,"f").$postMessage(Be(this,I,"f"),w.message,...w.buffers)}assertNotDisposed(){if(Be(this,T,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=g,I=new WeakMap,L=new WeakMap,A=new WeakMap,c=new WeakMap,E=new WeakMap,h=new WeakMap,p=new WeakMap,v=new WeakMap,T=new WeakMap,b=new WeakMap,o=new WeakMap,s=new WeakMap;function l(a){try{const f=(0,C.normalizeVersion)((0,C.parseVersion)(a.engines.vscode));return!!f&&f.majorBase>=1&&f.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=l;class S{constructor(f,w,d,k,R){this.initData=w,this.workspace=d,this._logService=k,this._deprecationService=R,this._webviews=new Map,this._webviewProxy=f.getProxy(_.MainContext.MainThreadWebviews)}$onMessage(f,w,d){const k=this.getWebview(f);if(k){const{message:R}=(0,P.deserializeWebviewMessage)(w,d.value);k._onMessageEmitter.fire(R)}}$onMissingCsp(f,w){this._logService.warn(`${w} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(f,w,d){const k=new g(f,this._webviewProxy,r(w),this.initData,this.workspace,d,this._deprecationService);return this._webviews.set(f,k),k._onDidDispose(()=>{this._webviews.delete(f)}),k}deleteWebview(f){this._webviews.delete(f)}getWebview(f){return this._webviews.get(f)}}e.ExtHostWebviews=S;function n(a){return{id:a.identifier,location:a.extensionLocation}}e.toExtensionData=n;function t(a,f,w){return{enableCommandUris:w.enableCommandUris,enableScripts:w.enableScripts,enableForms:w.enableForms,portMapping:w.portMapping,localResourceRoots:w.localResourceRoots||u(a,f)}}e.serializeWebviewOptions=t;function r(a){return{enableCommandUris:a.enableCommandUris,enableScripts:a.enableScripts,enableForms:a.enableForms,portMapping:a.portMapping,localResourceRoots:a.localResourceRoots?.map(f=>y.URI.from(f))}}e.reviveOptions=r;function u(a,f){return[...(f?.getWorkspaceFolders()||[]).map(w=>w.uri),a.extensionLocation]}}),define(ve[255],we([0,1,21,47,6,10,23,2,17,68,87,5,7]),function(J,e,m,i,y,C,P,D,_,I,L,A,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class E{constructor(l,S){this.document=l,this._storagePath=S,this._backupCounter=1,this._edits=new L.Cache("custom documents")}addEdit(l){return this._edits.add([l])}async undo(l,S){await this.getEdit(l).undo(),S||this.disposeBackup()}async redo(l,S){await this.getEdit(l).redo(),S||this.disposeBackup()}disposeEdits(l){for(const S of l)this._edits.delete(S)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const l=s(this.document.uri)+this._backupCounter++;return(0,P.joinPath)(this._storagePath,l)}updateBackup(l){this._backup?.delete(),this._backup=l}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(l){const S=this._edits.get(l,0);if(!S)throw new Error("No edit found");return S}}class h{constructor(){this._documents=new Map}get(l,S){return this._documents.get(this.key(l,S))}add(l,S,n){const t=this.key(l,S.uri);if(this._documents.has(t))throw new Error(`Document already exists for viewType:${l} resource:${S.uri}`);const r=new E(S,n);return this._documents.set(t,r),r}delete(l,S){const n=this.key(l,S.uri);this._documents.delete(n)}key(l,S){return`${l}@@@${S}`}}var p;(function(g){g[g.Text=0]="Text",g[g.Custom=1]="Custom"})(p||(p={}));class v{constructor(){this._providers=new Map}addTextProvider(l,S,n){return this.add(0,l,S,n)}addCustomProvider(l,S,n){return this.add(1,l,S,n)}get(l){return this._providers.get(l)}add(l,S,n,t){if(this._providers.has(S))throw new Error(`Provider for viewType:${S} already registered`);return this._providers.set(S,{type:l,extension:n,provider:t}),new c.Disposable(()=>this._providers.delete(S))}}class T{constructor(l,S,n,t,r){this._extHostDocuments=S,this._extensionStoragePaths=n,this._extHostWebview=t,this._extHostWebviewPanels=r,this._editorProviders=new v,this._documents=new h,this._proxy=l.getProxy(A.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(l,S,n,t){const r=new y.DisposableStore;return b(n)?(r.add(this._editorProviders.addTextProvider(S,l,n)),this._proxy.$registerTextEditorProvider((0,I.toExtensionData)(l),S,t.webviewOptions||{},{supportsMove:!!n.moveCustomTextEditor},(0,I.shouldSerializeBuffersForPostMessage)(l))):(r.add(this._editorProviders.addCustomProvider(S,l,n)),this.supportEditing(n)&&r.add(n.onDidChangeCustomDocument(u=>{const a=this.getCustomDocumentEntry(S,u.document.uri);if(o(u)){const f=a.addEdit(u);this._proxy.$onDidEdit(u.document.uri,S,f,u.label)}else this._proxy.$onContentChange(u.document.uri,S)})),this._proxy.$registerCustomEditorProvider((0,I.toExtensionData)(l),S,t.webviewOptions||{},!!t.supportsMultipleEditorsPerDocument,(0,I.shouldSerializeBuffersForPostMessage)(l))),c.Disposable.from(r,new c.Disposable(()=>{this._proxy.$unregisterEditorProvider(S)}))}async $createCustomDocument(l,S,n,t,r){const u=this._editorProviders.get(S);if(!u)throw new Error(`No provider found for '${S}'`);if(u.type!==1)throw new Error(`Invalid provide type for '${S}'`);const a=D.URI.revive(l),f=await u.provider.openCustomDocument(a,{backupId:n,untitledDocumentData:t?.buffer},r);let w;return this.supportEditing(u.provider)&&this._extensionStoragePaths&&(w=this._extensionStoragePaths.workspaceValue(u.extension)??this._extensionStoragePaths.globalValue(u.extension)),this._documents.add(S,f,w),{editable:this.supportEditing(u.provider)}}async $disposeCustomDocument(l,S){const n=this._editorProviders.get(S);if(!n)throw new Error(`No provider found for '${S}'`);if(n.type!==1)throw new Error(`Invalid provider type for '${S}'`);const t=D.URI.revive(l),{document:r}=this.getCustomDocumentEntry(S,t);this._documents.delete(S,r),r.dispose()}async $resolveWebviewEditor(l,S,n,t,r,u){const a=this._editorProviders.get(n);if(!a)throw new Error(`No provider found for '${n}'`);const f=_.ViewColumn.to(r),w=this._extHostWebview.createNewWebview(S,t.webviewOptions,a.extension),d=this._extHostWebviewPanels.createNewWebviewPanel(S,n,t.title,f,t.panelOptions,w),k=D.URI.revive(l);switch(a.type){case 1:{const{document:R}=this.getCustomDocumentEntry(n,k);return a.provider.resolveCustomEditor(R,d,u)}case 0:{const R=this._extHostDocuments.getDocument(k);return a.provider.resolveCustomTextEditor(R,d,u)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(l,S,n){this.getCustomDocumentEntry(S,l).disposeEdits(n)}async $onMoveCustomEditor(l,S,n){const t=this._editorProviders.get(n);if(!t)throw new Error(`No provider found for '${n}'`);if(!t.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${n}'`);const r=this._extHostWebviewPanels.getWebviewPanel(l);if(!r)throw new Error("No webview found");const u=D.URI.revive(S),a=this._extHostDocuments.getDocument(u);await t.provider.moveCustomTextEditor(a,r,m.CancellationToken.None)}async $undo(l,S,n,t){return this.getCustomDocumentEntry(S,l).undo(n,t)}async $redo(l,S,n,t){return this.getCustomDocumentEntry(S,l).redo(n,t)}async $revert(l,S,n){const t=this.getCustomDocumentEntry(S,l);await this.getCustomEditorProvider(S).revertCustomDocument(t.document,n),t.disposeBackup()}async $onSave(l,S,n){const t=this.getCustomDocumentEntry(S,l);await this.getCustomEditorProvider(S).saveCustomDocument(t.document,n),t.disposeBackup()}async $onSaveAs(l,S,n,t){const r=this.getCustomDocumentEntry(S,l);return this.getCustomEditorProvider(S).saveCustomDocumentAs(r.document,D.URI.revive(n),t)}async $backup(l,S,n){const t=this.getCustomDocumentEntry(S,l),u=await this.getCustomEditorProvider(S).backupCustomDocument(t.document,{destination:t.getNewBackupUri()},n);return t.updateBackup(u),u.id}getCustomDocumentEntry(l,S){const n=this._documents.get(l,D.URI.revive(S));if(!n)throw new Error("No custom document found");return n}getCustomEditorProvider(l){const n=this._editorProviders.get(l)?.provider;if(!n||!this.supportEditing(n))throw new Error("Custom document is not editable");return n}supportEditing(l){return!!l.onDidChangeCustomDocument}}e.ExtHostCustomEditors=T;function b(g){return typeof g.resolveCustomTextEditor=="function"}function o(g){return typeof g.undo=="function"&&typeof g.redo=="function"}function s(g){const l=g.scheme===C.Schemas.file||g.scheme===C.Schemas.untitled?g.fsPath:g.toString();return(0,i.hash)(l)+""}});var nt=this&&this.__classPrivateFieldSet||function(J,e,m,i,y){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!y:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?y.call(J,m):y?y.value=m:e.set(J,m),m},Be=this&&this.__classPrivateFieldGet||function(J,e,m,i){if(m==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!i:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?i:m==="a"?i.call(J):i?i.value:e.get(J)};define(ve[256],we([0,1,3,6,2,32,17,68,5,7]),function(J,e,m,i,y,C,P,D,_,I){"use strict";var L,A,c,E,h,p,v,T,b,o,s,g,l;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class S extends i.Disposable{constructor(u,a,f,w,d,k,R){super();L.set(this,void 0),A.set(this,void 0),c.set(this,void 0),E.set(this,void 0),h.set(this,void 0),p.set(this,void 0),v.set(this,void 0),T.set(this,void 0),b.set(this,!0),o.set(this,!0),s.set(this,!1),g.set(this,this._register(new m.Emitter)),this.onDidDispose=Be(this,g,"f").event,l.set(this,this._register(new m.Emitter)),this.onDidChangeViewState=Be(this,l,"f").event,nt(this,L,u,"f"),nt(this,A,a,"f"),nt(this,c,f,"f"),nt(this,h,k,"f"),nt(this,T,d,"f"),nt(this,p,w,"f"),nt(this,E,R,"f")}dispose(){Be(this,s,"f")||(nt(this,s,!0,"f"),Be(this,g,"f").fire(),Be(this,A,"f").$disposeWebview(Be(this,L,"f")),Be(this,E,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Be(this,E,"f")}get viewType(){return this.assertNotDisposed(),Be(this,c,"f")}get title(){return this.assertNotDisposed(),Be(this,p,"f")}set title(u){this.assertNotDisposed(),Be(this,p,"f")!==u&&(nt(this,p,u,"f"),Be(this,A,"f").$setTitle(Be(this,L,"f"),u))}get iconPath(){return this.assertNotDisposed(),Be(this,v,"f")}set iconPath(u){this.assertNotDisposed(),Be(this,v,"f")!==u&&(nt(this,v,u,"f"),Be(this,A,"f").$setIconPath(Be(this,L,"f"),y.URI.isUri(u)?{light:u,dark:u}:u))}get options(){return Be(this,h,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Be(this,T,"f")=="number"&&Be(this,T,"f")<0))return Be(this,T,"f")}get active(){return this.assertNotDisposed(),Be(this,o,"f")}get visible(){return this.assertNotDisposed(),Be(this,b,"f")}_updateViewState(u){Be(this,s,"f")||(this.active!==u.active||this.visible!==u.visible||this.viewColumn!==u.viewColumn)&&(nt(this,o,u.active,"f"),nt(this,b,u.visible,"f"),nt(this,T,u.viewColumn,"f"),Be(this,l,"f").fire({webviewPanel:this}))}reveal(u,a){this.assertNotDisposed(),Be(this,A,"f").$reveal(Be(this,L,"f"),{viewColumn:u?P.ViewColumn.from(u):void 0,preserveFocus:!!a})}assertNotDisposed(){if(Be(this,s,"f"))throw new Error("Webview is disposed")}}L=new WeakMap,A=new WeakMap,c=new WeakMap,E=new WeakMap,h=new WeakMap,p=new WeakMap,v=new WeakMap,T=new WeakMap,b=new WeakMap,o=new WeakMap,s=new WeakMap,g=new WeakMap,l=new WeakMap;class n{constructor(u,a,f){this.webviews=a,this.workspace=f,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=u.getProxy(_.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,C.generateUuid)()}createWebviewPanel(u,a,f,w,d={}){const k=typeof w=="object"?w.viewColumn:w,R={viewColumn:P.ViewColumn.from(k),preserveFocus:typeof w=="object"&&!!w.preserveFocus},N=(0,D.shouldSerializeBuffersForPostMessage)(u),x=n.newHandle();this._proxy.$createWebviewPanel((0,D.toExtensionData)(u),x,a,{title:f,panelOptions:t(d),webviewOptions:(0,D.serializeWebviewOptions)(u,this.workspace,d),serializeBuffersForPostMessage:N},R);const F=this.webviews.createNewWebview(x,d,u);return this.createNewWebviewPanel(x,a,f,k,d,F)}$onDidChangeWebviewPanelViewStates(u){const a=Object.keys(u);a.sort((f,w)=>{const d=u[f],k=u[w];return d.active?1:k.active?-1:+d.visible-+k.visible});for(const f of a){const w=this.getWebviewPanel(f);if(!w)continue;const d=u[f];w._updateViewState({active:d.active,visible:d.visible,viewColumn:P.ViewColumn.to(d.position)})}}async $onDidDisposeWebviewPanel(u){this.getWebviewPanel(u)?.dispose(),this._webviewPanels.delete(u),this.webviews.deleteWebview(u)}registerWebviewPanelSerializer(u,a,f){if(this._serializers.has(a))throw new Error(`Serializer for '${a}' already registered`);return this._serializers.set(a,{serializer:f,extension:u}),this._proxy.$registerSerializer(a,{serializeBuffersForPostMessage:(0,D.shouldSerializeBuffersForPostMessage)(u)}),new I.Disposable(()=>{this._serializers.delete(a),this._proxy.$unregisterSerializer(a)})}async $deserializeWebviewPanel(u,a,f,w){const d=this._serializers.get(a);if(!d)throw new Error(`No serializer found for '${a}'`);const{serializer:k,extension:R}=d,N=this.webviews.createNewWebview(u,f.webviewOptions,R),x=this.createNewWebviewPanel(u,a,f.title,w,f.panelOptions,N);await k.deserializeWebviewPanel(x,f.state)}createNewWebviewPanel(u,a,f,w,d,k){const R=new S(u,this._proxy,a,f,w,d,k);return this._webviewPanels.set(u,R),R}getWebviewPanel(u){return this._webviewPanels.get(u)}}e.ExtHostWebviewPanels=n;function t(r){return{enableFindWidget:r.enableFindWidget,retainContextWhenHidden:r.retainContextWhenHidden}}});var nt=this&&this.__classPrivateFieldSet||function(J,e,m,i,y){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!y:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?y.call(J,m):y?y.value=m:e.set(J,m),m},Be=this&&this.__classPrivateFieldGet||function(J,e,m,i){if(m==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!i:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?i:m==="a"?i.call(J):i?i.value:e.get(J)};define(ve[257],we([0,1,3,6,68,5,7]),function(J,e,m,i,y,C,P){"use strict";var D,_,I,L,A,c,E,h,p,v;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class T extends i.Disposable{constructor(s,g,l,S,n,t){super();D.set(this,void 0),_.set(this,void 0),I.set(this,void 0),L.set(this,void 0),A.set(this,!1),c.set(this,void 0),E.set(this,void 0),h.set(this,void 0),p.set(this,this._register(new m.Emitter)),this.onDidChangeVisibility=Be(this,p,"f").event,v.set(this,this._register(new m.Emitter)),this.onDidDispose=Be(this,v,"f").event,nt(this,I,l,"f"),nt(this,E,S,"f"),nt(this,D,s,"f"),nt(this,_,g,"f"),nt(this,L,n,"f"),nt(this,c,t,"f")}dispose(){Be(this,A,"f")||(nt(this,A,!0,"f"),Be(this,v,"f").fire(),Be(this,L,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Be(this,E,"f")}set title(s){this.assertNotDisposed(),Be(this,E,"f")!==s&&(nt(this,E,s,"f"),Be(this,_,"f").$setWebviewViewTitle(Be(this,D,"f"),s))}get description(){return this.assertNotDisposed(),Be(this,h,"f")}set description(s){this.assertNotDisposed(),Be(this,h,"f")!==s&&(nt(this,h,s,"f"),Be(this,_,"f").$setWebviewViewDescription(Be(this,D,"f"),s))}get visible(){return Be(this,c,"f")}get webview(){return Be(this,L,"f")}get viewType(){return Be(this,I,"f")}_setVisible(s){s===Be(this,c,"f")||Be(this,A,"f")||(nt(this,c,s,"f"),Be(this,p,"f").fire())}show(s){this.assertNotDisposed(),Be(this,_,"f").$show(Be(this,D,"f"),!!s)}assertNotDisposed(){if(Be(this,A,"f"))throw new Error("Webview is disposed")}}D=new WeakMap,_=new WeakMap,I=new WeakMap,L=new WeakMap,A=new WeakMap,c=new WeakMap,E=new WeakMap,h=new WeakMap,p=new WeakMap,v=new WeakMap;class b{constructor(s,g){this._extHostWebview=g,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=s.getProxy(C.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(s,g,l,S){if(this._viewProviders.has(g))throw new Error(`View provider for '${g}' already registered`);return this._viewProviders.set(g,{provider:l,extension:s}),this._proxy.$registerWebviewViewProvider((0,y.toExtensionData)(s),g,{retainContextWhenHidden:S?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new P.Disposable(()=>{this._viewProviders.delete(g),this._proxy.$unregisterWebviewViewProvider(g)})}async $resolveWebviewView(s,g,l,S,n){const t=this._viewProviders.get(g);if(!t)throw new Error(`No view provider found for '${g}'`);const{provider:r,extension:u}=t,a=this._extHostWebview.createNewWebview(s,{},u),f=new T(s,this._proxy,g,l,a,!0);this._webviewViews.set(s,f),await r.resolveWebviewView(f,{state:S},n)}async $onDidChangeWebviewViewVisibility(s,g){this.getWebviewView(s)._setVisible(g)}async $disposeWebviewView(s){const g=this.getWebviewView(s);this._webviewViews.delete(s),g.dispose(),this._extHostWebview.deleteWebview(s)}getWebviewView(s){const g=this._webviewViews.get(s);if(!g)throw new Error("No webview found");return g}}e.ExtHostWebviewViews=b}),define(ve[133],we([0,1,3,5,2,10,8,4,14]),function(J,e,m,i,y,C,P,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let I=class zi{constructor(A){this._onDidChangeWindowState=new m.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=zi.InitialState,this._proxy=A.getProxy(i.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(c=>this.$onDidChangeWindowFocus(c))}get state(){return this._state}$onDidChangeWindowFocus(A){A!==this._state.focused&&(this._state={...this._state,focused:A},this._onDidChangeWindowState.fire(this._state))}openUri(A,c){let E;if(typeof A=="string"){E=A;try{A=y.URI.parse(A)}catch{return Promise.reject(`Invalid uri - '${A}'`)}}return(0,P.isFalsyOrWhitespace)(A.scheme)?Promise.reject("Invalid scheme - cannot be empty"):A.scheme===C.Schemas.command?Promise.reject(`Invalid scheme '${A.scheme}'`):this._proxy.$openUri(A,E,c)}async asExternalUri(A,c){if((0,P.isFalsyOrWhitespace)(A.scheme))return Promise.reject("Invalid scheme - cannot be empty");const E=await this._proxy.$asExternalUri(A,c);return y.URI.from(E)}};I.InitialState={focused:!0},I=je([ze(0,_.IExtHostRpcService)],I),e.ExtHostWindow=I,e.IExtHostWindow=(0,D.createDecorator)("IExtHostWindow")}),define(ve[258],we([0,1,9,81,32,38,6,5,2,14]),function(J,e,m,i,y,C,P,D,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let L=class extends P.Disposable{constructor(c,E){super();const h=c.getProxy(D.MainContext.MainThreadDownloadService);E.registerCommand(!1,"_workbench.downloadResource",async p=>{const v=_.URI.file((0,m.join)((0,i.tmpdir)(),(0,y.generateUuid)()));return await h.$download(p,v),v})}};L=je([ze(0,I.IExtHostRpcService),ze(1,C.IExtHostCommands)],L),e.ExtHostDownloadService=L}),define(ve[259],we([0,1,131,10,187,32]),function(J,e,m,i,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class P extends m.ExtHostLoggerService{doCreateLogger(_,I,L){return _.scheme===i.Schemas.file?new y.SpdLogLogger(L?.name||(0,C.generateUuid)(),_.fsPath,!L?.donotRotate,!!L?.donotUseFormatters,I):super.doCreateLogger(_,I,L)}}e.ExtHostLoggerService=P}),define(ve[260],we([0,1,60,9,2,67,6,10,18,28]),function(J,e,m,i,y,C,P,D,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class L extends C.ExtensionStoragePaths{constructor(){super(...arguments);this._workspaceStorageLock=null}async _getWorkspaceStorageURI(l){const S=await super._getWorkspaceStorageURI(l);if(S.scheme!==D.Schemas.file)return S;if(this._environment.skipWorkspaceStorageLock)return this._logService.info(`Skipping acquiring lock for ${S.fsPath}.`),S;const n=S.fsPath;let t=0;do{let r;t===0?r=n:r=/[/\\]$/.test(n)?`${n.substr(0,n.length-1)}-${t}`:`${n}-${t}`,await A(r);const u=i.join(r,"vscode.lock"),a=await p(this._logService,u,!1);if(a)return this._workspaceStorageLock=a,process.on("exit",()=>{a.dispose()}),y.URI.file(r);t++}while(t<10);return S}onWillDeactivateAll(){this._workspaceStorageLock&&this._workspaceStorageLock.setWillRelease(6e3)}}e.ExtensionStoragePaths=L;async function A(g){try{await I.Promises.stat(g);return}catch{}try{await I.Promises.mkdir(g,{recursive:!0})}catch{}}const c=1e3,E=10*60*1e3;class h extends P.Disposable{constructor(l,S){super();this.logService=l,this.filename=S,this._timer=this._register(new _.IntervalTimer),this._timer.cancelAndSet(async()=>{const n=await v(l,S);(!n||n.pid!==process.pid)&&(l.info(`Lock '${S}': The lock was lost unexpectedly.`),this._timer.cancel());try{await I.Promises.utimes(S,new Date,new Date)}catch(t){l.error(t),l.info(`Lock '${S}': Could not update mtime.`)}},c)}dispose(){super.dispose();try{m.unlinkSync(this.filename)}catch{}}async setWillRelease(l){this.logService.info(`Lock '${this.filename}': Marking the lockfile as scheduled to be released in ${l} ms.`);try{const S={pid:process.pid,willReleaseAt:Date.now()+l};await I.Promises.writeFile(this.filename,JSON.stringify(S),{flag:"w"})}catch(S){this.logService.error(S)}}}async function p(g,l,S){try{const t={pid:process.pid,willReleaseAt:0};await I.Promises.writeFile(l,JSON.stringify(t),{flag:"wx"})}catch(t){g.error(t)}const n=await v(g,l);return!n||n.pid!==process.pid?S?(g.info(`Lock '${l}': Could not acquire lock, giving up.`),null):(g.info(`Lock '${l}': Could not acquire lock, checking if the file is stale.`),o(g,l)):(g.info(`Lock '${l}': Lock acquired.`),new h(g,l))}async function v(g,l){let S;try{S=await I.Promises.readFile(l)}catch(n){return g.error(n),null}try{return JSON.parse(String(S))}catch(n){return g.error(n),null}}async function T(g,l){let S;try{S=await I.Promises.stat(l)}catch(n){return g.error(n),0}return S.mtime.getTime()}function b(g){try{return process.kill(g,0),!0}catch{return!1}}async function o(g,l){const S=await v(g,l);if(!S)return g.info(`Lock '${l}': Could not read pid of lock holder.`),s(g,l);if(S.willReleaseAt){let a=S.willReleaseAt-Date.now();if(a<5e3){for(a>0?g.info(`Lock '${l}': The lockfile is scheduled to be released in ${a} ms.`):g.info(`Lock '${l}': The lockfile is scheduled to have been released.`);a>0;){if(await(0,_.timeout)(Math.min(100,a)),await T(g,l)===0)return s(g,l);a=S.willReleaseAt-Date.now()}return s(g,l)}}if(!b(S.pid))return g.info(`Lock '${l}': The pid ${S.pid} appears to be gone.`),s(g,l);const n=await T(g,l),t=Date.now()-n;if(t<=E)return g.info(`Lock '${l}': The lock does not look stale, elapsed: ${t} ms, giving up.`),null;g.info(`Lock '${l}': The lock looks stale, waiting for 2s.`),await(0,_.timeout)(2e3);const r=await T(g,l),u=Date.now()-r;return u<=E?(g.info(`Lock '${l}': The lock does not look stale, elapsed: ${u} ms, giving up.`),null):(g.info(`Lock '${l}': The lock looks stale even after waiting for 2s.`),s(g,l))}async function s(g,l){g.info(`Lock '${l}': Deleting a stale lock.`);try{await I.Promises.unlink(l)}catch{}return p(g,l,!0)}}),define(ve[261],we([0,1,32,14,34]),function(J,e,m,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let C=class extends y.BaseExtHostTerminalService{constructor(D){super(!0,D)}createTerminal(D,_,I){return this.createTerminalFromOptions({name:D,shellPath:_,shellArgs:I})}createTerminalFromOptions(D,_){const I=new y.ExtHostTerminal(this._proxy,(0,m.generateUuid)(),D,D.name);return this._terminals.push(I),I.create(D,this._serializeParentTerminal(D,_)),I.value}};C=je([ze(0,i.IExtHostRpcService)],C),e.ExtHostTerminalService=C}),define(ve[262],we([0,1,5,14,170,6,26,2,37,23,28,7,12,52,3,120,78,11]),function(J,e,m,i,y,C,P,D,_,I,L,A,c,E,h,p,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class b{constructor(f,w,d){this.remoteAddress=f,this.localAddress=w,this._dispose=d,this._onDispose=new h.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}function o(a){const f=a.trim().split(`
`),w=[];return f.forEach(k=>{const R=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(k);R&&R.length>=3&&w.push({pid:parseInt(R[1],10),socket:parseInt(R[2],10)})}),w.reduce((k,R)=>(k[R.socket]=R,k),{})}e.getSockets=o;function s(...a){const f=[].concat(...a.map(l));return[...new Map(f.filter(w=>w.st==="0A").map(w=>{const d=w.local_address.split(":");return{socket:parseInt(w.inode,10),ip:g(d[0]),port:parseInt(d[1],16)}}).map(w=>[w.ip+":"+w.port,w])).values()]}e.loadListeningPorts=s;function g(a){let f="";if(a.length===8)for(let w=a.length-2;w>=0;w-=2)f+=parseInt(a.substr(w,2),16),w!==0&&(f+=".");else for(let w=a.length-4;w>=0;w-=4)f+=parseInt(a.substr(w,4),16).toString(16),w!==0&&(f+=":");return f}e.parseIpAddress=g;function l(a){const f=a.trim().split(`
`),w=f.shift().trim().split(/\s+/).filter(k=>k!=="rx_queue"&&k!=="tm->when");return f.map(k=>k.trim().split(/\s+/).reduce((R,N,x)=>(R[w[x]||x]=N,R),{}))}e.loadConnectionTable=l;function S(a){return!!a.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||a.indexOf("out/vs/server/main.js")!==-1||a.indexOf("_productName=VSCode")!==-1}function n(a){const f=a.trim().split(`
`),w=[];return f.forEach(d=>{const k=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(d);k&&k.length>=4&&w.push({pid:parseInt(k[1],10),ppid:parseInt(k[2]),cmd:k[3]})}),w}e.getRootProcesses=n;async function t(a,f,w){const d=w.reduce((R,N)=>(R[N.pid]=N,R),{}),k=[];return a.forEach(({socket:R,ip:N,port:x})=>{const F=f[R]?f[R].pid:void 0,B=F?d[F]?.cmd:void 0;F&&B&&!S(B)&&k.push({host:N,port:x,detail:B,pid:F})}),k}e.findPorts=t;function r(a,f,w){const d=new Map,k=n(f);for(const R of a){const N=w.get(R.port);if(N){d.set(R.port,N);continue}const x=k.find(F=>F.cmd.includes(`${R.port}`));if(x){let F=x,B;do B=k.find(O=>O.ppid===F.pid),B&&(F=B);while(B);d.set(R.port,{host:R.ip,port:R.port,pid:F.pid,detail:F.cmd,ppid:F.ppid})}else d.set(R.port,{host:R.ip,port:R.port,ppid:Number.MAX_VALUE})}return d}e.tryFindRootPorts=r;let u=class extends C.Disposable{constructor(f,w,d){super();this.logService=d,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new h.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=f.getProxy(m.MainContext.MainThreadTunnelService),c.isLinux&&w.remote.isRemote&&w.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(f,w){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${f.identifier.value} called openTunnel API for ${w.remoteAddress.host}:${w.remoteAddress.port}.`);const d=await this._proxy.$openTunnel(w,f.displayName);if(d){const k=new b(d.remoteAddress,d.localAddress,()=>this._proxy.$closeTunnel(d.remoteAddress));return this._register(k),k}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(f){return Math.max(f*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(f,w){const d=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(d,{selector:f,provider:w}),this._proxy.$registerPortsAttributesProvider(f,d),new A.Disposable(()=>{this._portAttributesProviders.delete(d),this._proxy.$unregisterPortsAttributesProvider(d)})}async $providePortAttributes(f,w,d,k,R){const N=[];for(const F of f){const B=this._portAttributesProviders.get(F);if(!B)return[];N.push(...await Promise.all(w.map(async O=>B.provider.providePortAttributes(O,d,k,R))))}const x=N.filter(F=>!!F);return x.length>0?x.map(F=>({autoForwardAction:F.autoForwardAction,port:F.port})):[]}async $registerCandidateFinder(f){if(f&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=f;let w=new v.MovingAverage,d;for(;this._candidateFindingEnabled;){const k=new Date().getTime(),R=(await this.findCandidatePorts()).filter(x=>(0,p.isLocalhost)(x.host)||(0,p.isAllInterfaces)(x.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${R.map(x=>x.port).join(", ")}`);const N=new Date().getTime()-k;w.update(N),(!d||JSON.stringify(d)!==JSON.stringify(R))&&(d=R,await this._proxy.$onFoundNewCandidates(d)),await new Promise(x=>setTimeout(()=>x(),this.calculateDelay(w.value)))}}async setTunnelExtensionFunctions(f){if(f){if(f.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(f.candidatePortSource),f.showCandidatePort&&(this._showCandidatePort=f.showCandidatePort,this._proxy.$setCandidateFilter()),f.tunnelFactory){this._forwardPortProvider=f.tunnelFactory;let w=f.tunnelFeatures?.privacyOptions??[];f.tunnelFeatures?.public&&w.length===0&&(w=[{id:"private",label:y.localize(0,null),themeIcon:"lock"},{id:"public",label:y.localize(1,null),themeIcon:"eye"}]),this._proxy.$setTunnelProvider({elevation:!!f.tunnelFeatures?.elevation,public:!!f.tunnelFeatures?.public,privacyOptions:w})}}else this._forwardPortProvider=void 0;return(0,C.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(f,w){if(this._extensionTunnels.has(f.host)){const d=this._extensionTunnels.get(f.host);d.has(f.port)&&(w&&d.get(f.port).disposeListener.dispose(),await d.get(f.port).tunnel.dispose(),d.delete(f.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(f,w){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const d=this._forwardPortProvider(f,w);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),d!==void 0){const k=await d;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(f.remoteAddress.host)||this._extensionTunnels.set(f.remoteAddress.host,new Map);const R=this._register(k.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(k.remoteAddress))));return this._extensionTunnels.get(f.remoteAddress.host).set(f.remoteAddress.port,{tunnel:k,disposeListener:R}),E.TunnelDto.fromApiTunnel(k)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(f){const w=await Promise.all(f.map(k=>this._showCandidatePort(k.host,k.port,k.detail??""))),d=f.filter((k,R)=>w[R]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${f.map(k=>k.port).join(", ")} to ${d.map(k=>k.port).join(", ")}`),d}async findCandidatePorts(){let f="",w="";try{f=await L.Promises.readFile("/proc/net/tcp","utf8"),w=await L.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const d=s(f,w),k=await new Promise(M=>{(0,_.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(W,z,U)=>{M(z)})}),R=o(k),N=await L.Promises.readdir("/proc"),x=[];for(let M of N)try{const W=Number(M),z=I.joinPath(D.URI.file("/proc"),M);if((await L.Promises.stat(z.fsPath)).isDirectory()&&!isNaN(W)){const V=await L.Promises.readlink(I.joinPath(z,"cwd").fsPath),K=await L.Promises.readFile(I.joinPath(z,"cmdline").fsPath,"utf8");x.push({pid:W,cwd:V,cmd:K})}}catch{}const F=[],B=d.filter(M=>{const W=R[M.socket];return W||F.push(M),W}),O=t(B,R,x);let H;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${F.length}`),F.length>0){const M=await new Promise(W=>{(0,_.exec)("ps -F -A -l | grep root",(z,U,V)=>{W(U)})});this._foundRootPorts=r(F,M,this._foundRootPorts),H=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${H.join(", ")}`)}return O.then(M=>H?M.concat(H):M)}};u=je([ze(0,i.IExtHostRpcService),ze(1,P.IExtHostInitDataService),ze(2,T.ILogService)],u),e.ExtHostTunnelService=u}),define(ve[263],we([0,1,18,22,21,15,3,6,102,227,53]),function(J,e,m,i,y,C,P,D,_,I,L){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function c(d,k){try{return JSON.stringify(d,k)}catch{return"null"}}const E="$$ref$$",h={[E]:-1};class p{constructor(k,R){this.jsonString=k,this.referencedBuffers=R}}function v(d,k=null,R=!1){const N=[];return{jsonString:(R?c:JSON.stringify)(d,(F,B)=>{if(typeof B=="undefined")return h;if(typeof B=="object"){if(B instanceof i.VSBuffer){const O=N.push(B)-1;return{[E]:O}}if(k)return k(F,B)}return B}),referencedBuffers:N}}e.stringifyJsonWithBufferRefs=v;function T(d,k,R){return JSON.parse(d,(N,x)=>{if(x){const F=x[E];if(typeof F=="number")return k[F];if(R&&x.$mid===1)return R.transformIncoming(x)}return x})}e.parseJsonAndRestoreBufferRefs=T;function b(d,k){return JSON.stringify(d,k)}function o(d){return d?(k,R)=>R&&R.$mid===1?d.transformOutgoing(R):R:null}var s;(function(d){d[d.LocalSide=0]="LocalSide",d[d.OtherSide=1]="OtherSide"})(s=e.RequestInitiator||(e.RequestInitiator={}));var g;(function(d){d[d.Responsive=0]="Responsive",d[d.Unresponsive=1]="Unresponsive"})(g=e.ResponsiveState||(e.ResponsiveState={}));const l=()=>{},S=Symbol.for("rpcProtocol"),n=Symbol.for("rpcProxy");class t extends D.Disposable{constructor(k,R=null,N=null){super();this[A]=!0,this._onDidChangeResponsiveState=this._register(new P.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=k,this._logger=R,this._uriTransformer=N,this._uriReplacer=o(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let x=0,F=L.ProxyIdentifier.count;x<F;x++)this._locals[x]=null,this._proxies[x]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new m.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(x=>this._receiveOneMessage(x))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(k=>{this._pendingRPCReplies[k].resolveErr(C.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(k){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+t.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(k){this._unresponsiveTime=Date.now()+t.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(k){this._responsiveState!==k&&(this._responsiveState=k,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(k){return this._uriTransformer?(0,_.transformIncomingURIs)(k,this._uriTransformer):k}getProxy(k){const{nid:R,sid:N}=k;return this._proxies[R]||(this._proxies[R]=this._createProxy(R,N)),this._proxies[R]}_createProxy(k,R){let N={get:(x,F)=>(typeof F=="string"&&!x[F]&&F.charCodeAt(0)===36&&(x[F]=(...B)=>this._remoteCall(k,F,B)),F===n?R:x[F])};return new Proxy(Object.create(null),N)}set(k,R){return this._locals[k.nid]=R,R}assertRegistered(k){for(let R=0,N=k.length;R<N;R++){const x=k[R];if(!this._locals[x.nid])throw new Error(`Missing actor ${x.sid} (isMain: ${x.isMain})`)}}_receiveOneMessage(k){if(this._isDisposed)return;const R=k.byteLength,N=r.read(k,0),x=N.readUInt8(),F=N.readUInt32();switch(x){case 1:case 2:{let{rpcId:B,method:O,args:H}=a.deserializeRequestJSONArgs(N);this._uriTransformer&&(H=(0,_.transformIncomingURIs)(H,this._uriTransformer)),this._receiveRequest(R,F,B,O,H,x===2);break}case 3:case 4:{let{rpcId:B,method:O,args:H}=a.deserializeRequestMixedArgs(N);this._uriTransformer&&(H=(0,_.transformIncomingURIs)(H,this._uriTransformer)),this._receiveRequest(R,F,B,O,H,x===4);break}case 5:{this._logger&&this._logger.logIncoming(R,F,0,"ack"),this._onDidReceiveAcknowledge(F);break}case 6:{this._receiveCancel(R,F);break}case 7:{this._receiveReply(R,F,void 0);break}case 9:{let B=a.deserializeReplyOKJSON(N);this._uriTransformer&&(B=(0,_.transformIncomingURIs)(B,this._uriTransformer)),this._receiveReply(R,F,B);break}case 10:{const B=a.deserializeReplyOKJSONWithBuffers(N,this._uriTransformer);this._receiveReply(R,F,B);break}case 8:{let B=a.deserializeReplyOKVSBuffer(N);this._receiveReply(R,F,B);break}case 11:{let B=a.deserializeReplyErrError(N);this._uriTransformer&&(B=(0,_.transformIncomingURIs)(B,this._uriTransformer)),this._receiveReplyErr(R,F,B);break}case 12:{this._receiveReplyErr(R,F,void 0);break}default:console.error("received unexpected message"),console.error(k)}}_receiveRequest(k,R,N,x,F,B){this._logger&&this._logger.logIncoming(k,R,1,`receiveRequest ${(0,L.getStringIdentifierForProxy)(N)}.${x}(`,F);const O=String(R);let H,M;if(B){const z=new y.CancellationTokenSource;F.push(z.token),H=this._invokeHandler(N,x,F),M=()=>z.cancel()}else H=this._invokeHandler(N,x,F),M=l;this._cancelInvokedHandlers[O]=M;const W=a.serializeAcknowledged(R);this._logger&&this._logger.logOutgoing(W.byteLength,R,1,"ack"),this._protocol.send(W),H.then(z=>{delete this._cancelInvokedHandlers[O];const U=a.serializeReplyOK(R,z,this._uriReplacer);this._logger&&this._logger.logOutgoing(U.byteLength,R,1,"reply:",z),this._protocol.send(U)},z=>{delete this._cancelInvokedHandlers[O];const U=a.serializeReplyErr(R,z);this._logger&&this._logger.logOutgoing(U.byteLength,R,1,"replyErr:",z),this._protocol.send(U)})}_receiveCancel(k,R){this._logger&&this._logger.logIncoming(k,R,1,"receiveCancel");const N=String(R);this._cancelInvokedHandlers[N]&&this._cancelInvokedHandlers[N]()}_receiveReply(k,R,N){this._logger&&this._logger.logIncoming(k,R,0,"receiveReply:",N);const x=String(R);if(!this._pendingRPCReplies.hasOwnProperty(x))return;const F=this._pendingRPCReplies[x];delete this._pendingRPCReplies[x],F.resolveOk(N)}_receiveReplyErr(k,R,N){this._logger&&this._logger.logIncoming(k,R,0,"receiveReplyErr:",N);const x=String(R);if(!this._pendingRPCReplies.hasOwnProperty(x))return;const F=this._pendingRPCReplies[x];delete this._pendingRPCReplies[x];let B;N&&(N.$isError?(B=new Error,B.name=N.name,B.message=N.message,B.stack=N.stack):B=N),F.resolveErr(B)}_invokeHandler(k,R,N){try{return Promise.resolve(this._doInvokeHandler(k,R,N))}catch(x){return Promise.reject(x)}}_doInvokeHandler(k,R,N){const x=this._locals[k];if(!x)throw new Error("Unknown actor "+(0,L.getStringIdentifierForProxy)(k));let F=x[R];if(typeof F!="function")throw new Error("Unknown method "+R+" on actor "+(0,L.getStringIdentifierForProxy)(k));return F.apply(x,N)}_remoteCall(k,R,N){if(this._isDisposed)return Promise.reject(C.canceled());let x=null;if(N.length>0&&y.CancellationToken.isCancellationToken(N[N.length-1])&&(x=N.pop()),x&&x.isCancellationRequested)return Promise.reject(C.canceled());const F=a.serializeRequestArguments(N,this._uriReplacer),B=++this._lastMessageId,O=String(B),H=new I.LazyPromise;x&&x.onCancellationRequested(()=>{const W=a.serializeCancel(B);this._logger&&this._logger.logOutgoing(W.byteLength,B,0,"cancel"),this._protocol.send(a.serializeCancel(B))}),this._pendingRPCReplies[O]=H,this._onWillSendRequest(B);const M=a.serializeRequest(B,k,R,F,!!x);return this._logger&&this._logger.logOutgoing(M.byteLength,B,0,`request: ${(0,L.getStringIdentifierForProxy)(k)}.${R}(`,N),this._protocol.send(M),H}}e.RPCProtocol=t,A=S,t.UNRESPONSIVE_TIME=3*1e3;class r{constructor(k,R){this._buff=k,this._offset=R}static alloc(k,R,N){let x=new r(i.VSBuffer.alloc(N+1+4),0);return x.writeUInt8(k),x.writeUInt32(R),x}static read(k,R){return new r(k,R)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(k){this._buff.writeUInt8(k,this._offset),this._offset+=1}readUInt8(){const k=this._buff.readUInt8(this._offset);return this._offset+=1,k}writeUInt32(k){this._buff.writeUInt32BE(k,this._offset),this._offset+=4}readUInt32(){const k=this._buff.readUInt32BE(this._offset);return this._offset+=4,k}static sizeShortString(k){return 1+k.byteLength}writeShortString(k){this._buff.writeUInt8(k.byteLength,this._offset),this._offset+=1,this._buff.set(k,this._offset),this._offset+=k.byteLength}readShortString(){const k=this._buff.readUInt8(this._offset);this._offset+=1;const N=this._buff.slice(this._offset,this._offset+k).toString();return this._offset+=k,N}static sizeLongString(k){return 4+k.byteLength}writeLongString(k){this._buff.writeUInt32BE(k.byteLength,this._offset),this._offset+=4,this._buff.set(k,this._offset),this._offset+=k.byteLength}readLongString(){const k=this._buff.readUInt32BE(this._offset);this._offset+=4;const N=this._buff.slice(this._offset,this._offset+k).toString();return this._offset+=k,N}writeBuffer(k){this._buff.writeUInt32BE(k.byteLength,this._offset),this._offset+=4,this._buff.set(k,this._offset),this._offset+=k.byteLength}static sizeVSBuffer(k){return 4+k.byteLength}writeVSBuffer(k){this._buff.writeUInt32BE(k.byteLength,this._offset),this._offset+=4,this._buff.set(k,this._offset),this._offset+=k.byteLength}readVSBuffer(){const k=this._buff.readUInt32BE(this._offset);this._offset+=4;const R=this._buff.slice(this._offset,this._offset+k);return this._offset+=k,R}static sizeMixedArray(k){let R=0;R+=1;for(let N=0,x=k.length;N<x;N++){const F=k[N];switch(R+=1,F.type){case 1:R+=this.sizeLongString(F.value);break;case 2:R+=this.sizeVSBuffer(F.value);break;case 3:R+=this.sizeUInt32,R+=this.sizeLongString(F.value);for(let B=0;B<F.buffers.length;++B)R+=this.sizeVSBuffer(F.buffers[B]);break;case 4:break}}return R}writeMixedArray(k){this._buff.writeUInt8(k.length,this._offset),this._offset+=1;for(let R=0,N=k.length;R<N;R++){const x=k[R];switch(x.type){case 1:this.writeUInt8(1),this.writeLongString(x.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(x.value);break;case 3:this.writeUInt8(3),this.writeUInt32(x.buffers.length),this.writeLongString(x.value);for(let F=0;F<x.buffers.length;++F)this.writeBuffer(x.buffers[F]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const k=this._buff.readUInt8(this._offset);this._offset+=1;let R=new Array(k);for(let N=0;N<k;N++)switch(this.readUInt8()){case 1:R[N]=this.readLongString();break;case 2:R[N]=this.readVSBuffer();break;case 3:const F=this.readUInt32(),B=this.readLongString(),O=[];for(let H=0;H<F;++H)O.push(this.readVSBuffer());R[N]=new L.SerializableObjectWithBuffers(T(B,O,null));break;case 4:R[N]=void 0;break}return R}}r.sizeUInt32=4;var u;(function(d){d[d.Simple=0]="Simple",d[d.Mixed=1]="Mixed"})(u||(u={}));class a{static _useMixedArgSerialization(k){for(let R=0,N=k.length;R<N;R++)if(k[R]instanceof i.VSBuffer||k[R]instanceof L.SerializableObjectWithBuffers||typeof k[R]=="undefined")return!0;return!1}static serializeRequestArguments(k,R){if(this._useMixedArgSerialization(k)){const N=[];for(let x=0,F=k.length;x<F;x++){const B=k[x];if(B instanceof i.VSBuffer)N[x]={type:2,value:B};else if(typeof B=="undefined")N[x]={type:4};else if(B instanceof L.SerializableObjectWithBuffers){const{jsonString:O,referencedBuffers:H}=v(B.value,R);N[x]={type:3,value:i.VSBuffer.fromString(O),buffers:H}}else N[x]={type:1,value:i.VSBuffer.fromString(b(B,R))}}return{type:1,args:N}}return{type:0,args:b(k,R)}}static serializeRequest(k,R,N,x,F){switch(x.type){case 0:return this._requestJSONArgs(k,R,N,x.args,F);case 1:return this._requestMixedArgs(k,R,N,x.args,F)}}static _requestJSONArgs(k,R,N,x,F){const B=i.VSBuffer.fromString(N),O=i.VSBuffer.fromString(x);let H=0;H+=r.sizeUInt8(),H+=r.sizeShortString(B),H+=r.sizeLongString(O);let M=r.alloc(F?2:1,k,H);return M.writeUInt8(R),M.writeShortString(B),M.writeLongString(O),M.buffer}static deserializeRequestJSONArgs(k){const R=k.readUInt8(),N=k.readShortString(),x=k.readLongString();return{rpcId:R,method:N,args:JSON.parse(x)}}static _requestMixedArgs(k,R,N,x,F){const B=i.VSBuffer.fromString(N);let O=0;O+=r.sizeUInt8(),O+=r.sizeShortString(B),O+=r.sizeMixedArray(x);let H=r.alloc(F?4:3,k,O);return H.writeUInt8(R),H.writeShortString(B),H.writeMixedArray(x),H.buffer}static deserializeRequestMixedArgs(k){const R=k.readUInt8(),N=k.readShortString(),x=k.readMixedArray(),F=new Array(x.length);for(let B=0,O=x.length;B<O;B++){const H=x[B];typeof H=="string"?F[B]=JSON.parse(H):F[B]=H}return{rpcId:R,method:N,args:F}}static serializeAcknowledged(k){return r.alloc(5,k,0).buffer}static serializeCancel(k){return r.alloc(6,k,0).buffer}static serializeReplyOK(k,R,N){if(typeof R=="undefined")return this._serializeReplyOKEmpty(k);if(R instanceof i.VSBuffer)return this._serializeReplyOKVSBuffer(k,R);if(R instanceof L.SerializableObjectWithBuffers){const{jsonString:x,referencedBuffers:F}=v(R.value,N,!0);return this._serializeReplyOKJSONWithBuffers(k,x,F)}else return this._serializeReplyOKJSON(k,c(R,N))}static _serializeReplyOKEmpty(k){return r.alloc(7,k,0).buffer}static _serializeReplyOKVSBuffer(k,R){let N=0;N+=r.sizeVSBuffer(R);let x=r.alloc(8,k,N);return x.writeVSBuffer(R),x.buffer}static deserializeReplyOKVSBuffer(k){return k.readVSBuffer()}static _serializeReplyOKJSON(k,R){const N=i.VSBuffer.fromString(R);let x=0;x+=r.sizeLongString(N);let F=r.alloc(9,k,x);return F.writeLongString(N),F.buffer}static _serializeReplyOKJSONWithBuffers(k,R,N){const x=i.VSBuffer.fromString(R);let F=0;F+=r.sizeUInt32,F+=r.sizeLongString(x);for(const O of N)F+=r.sizeVSBuffer(O);let B=r.alloc(10,k,F);B.writeUInt32(N.length),B.writeLongString(x);for(const O of N)B.writeBuffer(O);return B.buffer}static deserializeReplyOKJSON(k){const R=k.readLongString();return JSON.parse(R)}static deserializeReplyOKJSONWithBuffers(k,R){const N=k.readUInt32(),x=k.readLongString(),F=[];for(let B=0;B<N;++B)F.push(k.readVSBuffer());return new L.SerializableObjectWithBuffers(T(x,F,R))}static serializeReplyErr(k,R){return R?this._serializeReplyErrEror(k,R):this._serializeReplyErrEmpty(k)}static _serializeReplyErrEror(k,R){const N=i.VSBuffer.fromString(c(C.transformErrorForSerialization(R),null));let x=0;x+=r.sizeLongString(N);let F=r.alloc(11,k,x);return F.writeLongString(N),F.buffer}static deserializeReplyErrError(k){const R=k.readLongString();return JSON.parse(R)}static _serializeReplyErrEmpty(k){return r.alloc(12,k,0).buffer}}var f;(function(d){d[d.RequestJSONArgs=1]="RequestJSONArgs",d[d.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",d[d.RequestMixedArgs=3]="RequestMixedArgs",d[d.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",d[d.Acknowledged=5]="Acknowledged",d[d.Cancel=6]="Cancel",d[d.ReplyOKEmpty=7]="ReplyOKEmpty",d[d.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",d[d.ReplyOKJSON=9]="ReplyOKJSON",d[d.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",d[d.ReplyErrError=11]="ReplyErrError",d[d.ReplyErrEmpty=12]="ReplyErrEmpty"})(f||(f={}));var w;(function(d){d[d.String=1]="String",d[d.VSBuffer=2]="VSBuffer",d[d.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",d[d.Undefined=4]="Undefined"})(w||(w={}))}),define(ve[264],we([0,1,4]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,m.createDecorator)("remoteAgentService")}),define(ve[265],we([0,1,10,9,12,2,4,62,43,222,264]),function(J,e,m,i,y,C,P,D,_,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,P.createDecorator)("pathService");let A=class Vi{constructor(E,h,p,v){this.localUserHome=E,this.remoteAgentService=h,this.environmentService=p,this.contextService=v,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||y.OS)(),this.resolveUserHome=(async()=>{const T=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=T?.userHome||E})()}get defaultUriScheme(){return Vi.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(E,h){if(E.remoteAuthority)return m.Schemas.vscodeRemote;const p=(0,D.getVirtualWorkspaceScheme)(h.getWorkspace());if(p)return p;const v=h.getWorkspace().folders[0];if(v)return v.uri.scheme;const T=h.getWorkspace().configuration;return T?T.scheme:m.Schemas.file}async userHome(E){return E?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(E=>E===1?i.win32:i.posix)}async fileURI(E){let h="";if(await this.resolveOS===1&&(E=E.replace(/\\/g,"/")),E[0]==="/"&&E[1]==="/"){const v=E.indexOf("/",2);v===-1?(h=E.substring(2),E="/"):(h=E.substring(2,v),E=E.substring(v)||"/")}return C.URI.from({scheme:m.Schemas.file,authority:h,path:E,query:"",fragment:""})}};A=je([ze(1,L.IRemoteAgentService),ze(2,I.IWorkbenchEnvironmentService),ze(3,_.IWorkspaceContextService)],A),e.AbstractPathService=A}),define(ve[69],we([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class m{constructor(P,D){this.line=P,this.character=D}isBefore(P){return!1}isBeforeOrEqual(P){return!1}isAfter(P){return!1}isAfterOrEqual(P){return!1}isEqual(P){return!1}compareTo(P){return 0}translate(P,D){return new m(0,0)}with(P){return new m(0,0)}}e.Position=m;class i{constructor(P,D,_,I){this.isEmpty=!1,this.isSingleLine=!1,this.start=new m(P,D),this.end=new m(_,I)}contains(P){return!1}isEqual(P){return!1}intersection(P){}union(P){return new i(0,0,0,0)}with(P){return new i(0,0,0,0)}}e.Range=i;var y;(function(C){C[C.Information=1]="Information",C[C.Warning=2]="Warning"})(y=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(ve[33],we([0,1,16,31,25,30,8,4,9,15,69,13]),function(J,e,m,i,y,C,P,D,_,I,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return L.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const c="\u27EA ",E=" characters skipped \u27EB",h=(c.length+E.length+5)*2;e.ISearchService=(0,D.createDecorator)("searchService");var p;(function(W){W[W.file=0]="file",W[W.text=1]="text"})(p=e.SearchProviderType||(e.SearchProviderType={}));var v;(function(W){W[W.File=1]="File",W[W.Text=2]="Text"})(v=e.QueryType||(e.QueryType={}));function T(W){return!!W.preview}e.resultIsMatch=T;function b(W){return!!W.resource}e.isFileMatch=b;function o(W){return!!W.message}e.isProgressMessage=o;var s;(function(W){W[W.Normal=0]="Normal",W[W.NewSearchStarted=1]="NewSearchStarted"})(s=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class g{constructor(z){this.resource=z,this.results=[]}}e.FileMatch=g;class l{constructor(z,U,V){this.ranges=U;const K=Array.isArray(U)?U:[U];if(V&&V.matchLines===1&&S(K)){z=(0,P.getNLines)(z,V.matchLines);let G="",Q=0,Y=0;const fe=Math.floor(V.charsPerLine/5),me=[];for(const _e of K){const Ie=Math.max(_e.startColumn-fe,0),Oe=_e.startColumn+V.charsPerLine;if(Ie>Y+fe+h){const We=c+(Ie-Y)+E;G+=We+z.slice(Ie,Oe),Q+=Ie-(Y+We.length)}else G+=z.slice(Y,Oe);me.push(new t(0,_e.startColumn-Q,_e.endColumn-Q)),Y=Oe}this.preview={text:G,matches:Array.isArray(this.ranges)?me:me[0]}}else{const G=Array.isArray(U)?U[0].startLineNumber:U.startLineNumber;this.preview={text:z,matches:(0,m.mapArrayOrNot)(U,Q=>new n(Q.startLineNumber-G,Q.startColumn,Q.endLineNumber-G,Q.endColumn))}}}}e.TextSearchMatch=l;function S(W){const z=W[0].startLineNumber;for(const U of W)if(U.startLineNumber!==z||U.endLineNumber!==z)return!1;return!0}class n{constructor(z,U,V,K){this.startLineNumber=z,this.startColumn=U,this.endLineNumber=V,this.endColumn=K}}e.SearchRange=n;class t extends n{constructor(z,U,V){super(z,U,z,V)}}e.OneLineRange=t;var r;(function(W){W.Default="default",W.FileNames="fileNames",W.Type="type",W.Modified="modified",W.CountDescending="countDescending",W.CountAscending="countAscending"})(r=e.SearchSortOrder||(e.SearchSortOrder={}));function u(W,z=!0){const U=W&&W.files&&W.files.exclude,V=z&&W&&W.search&&W.search.exclude;if(!U&&!V)return;if(!U||!V)return U||V;let K=Object.create(null);return K=y.mixin(K,y.deepClone(U)),K=y.mixin(K,y.deepClone(V),!0),K}e.getExcludes=u;function a(W,z){return W.excludePattern&&i.match(W.excludePattern,z)?!1:W.includePattern||W.usingSearchPaths?W.includePattern&&i.match(W.includePattern,z)?!0:W.usingSearchPaths?!!W.folderQueries&&W.folderQueries.some(U=>{const V=U.folder.fsPath;if(C.isEqualOrParent(z,V)){const K=_.relative(V,z);return!U.includePattern||!!i.match(U.includePattern,K)}else return!1}):!1:!0}e.pathIncludedInQuery=a;var f;(function(W){W[W.unknownEncoding=1]="unknownEncoding",W[W.regexParseError=2]="regexParseError",W[W.globParseError=3]="globParseError",W[W.invalidLiteral=4]="invalidLiteral",W[W.rgProcessError=5]="rgProcessError",W[W.other=6]="other",W[W.canceled=7]="canceled"})(f=e.SearchErrorCode||(e.SearchErrorCode={}));class w extends Error{constructor(z,U){super(z);this.code=U}}e.SearchError=w;function d(W){const z=W.message;if((0,I.isPromiseCanceledError)(W))return new w(z,f.canceled);try{const U=JSON.parse(z);return new w(U.message,U.code)}catch{return new w(z,f.other)}}e.deserializeSearchError=d;function k(W){const z={message:W.message,code:W.code};return new Error(JSON.stringify(z))}e.serializeSearchError=k;function R(W){return W.type==="error"?!0:W.type==="success"}e.isSerializedSearchComplete=R;function N(W){return W.type==="success"}e.isSerializedSearchSuccess=N;function x(W){return!!W.path}e.isSerializedFileMatch=x;function F(W,z){const U=W.searchPath?W.searchPath:W.relativePath;return(0,P.fuzzyContains)(U,z)}e.isFilePatternMatch=F;class B{constructor(z){this.path=z,this.results=[]}addMatch(z){this.results.push(z)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=B;function O(W,z){const U={...W||{},...z||{}};return Object.keys(U).filter(V=>{const K=U[V];return typeof K=="boolean"&&K})}e.resolvePatternsForProvider=O;class H{constructor(z,U){this._parsedIncludeExpression=null,this._excludeExpression={...z.excludePattern||{},...U.excludePattern||{}},this._parsedExcludeExpression=i.parse(this._excludeExpression);let V=z.includePattern;U.includePattern&&(V?V={...V,...U.includePattern}:V=U.includePattern),V&&(this._parsedIncludeExpression=i.parse(V))}matchesExcludesSync(z,U,V){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(z,U,V))}includedInQuerySync(z,U,V){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(z,U,V)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(z,U,V))}includedInQuery(z,U,V){const K=this._parsedExcludeExpression(z,U,V),G=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(z,U,V):!0;return(0,A.isPromise)(K)?K.then(Q=>Q?!1:G()):G()}hasSiblingExcludeClauses(){return M(this._excludeExpression)}}e.QueryGlobTester=H;function M(W){for(const z in W)if(typeof W[z]!="boolean")return!0;return!1}}),define(ve[35],we([0,1,16,18,21,3,24,10,78,23,8,13,2,168,4,11,188,43,44,26,14,7,33,5]),function(J,e,m,i,y,C,P,D,_,I,L,A,c,E,h,p,v,T,b,o,s,g,l,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function n(k,R,N){return new I.ExtUri(x=>a(x,N)).isEqual(k,R)}function t(k,R,N){return n(k.uri,R.uri,N)?0:(0,L.compare)(k.uri.toString(),R.uri.toString())}function r(k,R,N){return k.index!==R.index?k.index<R.index?-1:1:n(k.uri,R.uri,N)?(0,L.compare)(k.name,R.name):(0,L.compare)(k.uri.toString(),R.uri.toString())}function u(k,R,N,x){const F=k.slice(0).sort((O,H)=>N(O,H,x)),B=R.slice(0).sort((O,H)=>N(O,H,x));return(0,m.delta)(F,B,(O,H)=>N(O,H,x))}function a(k,R){const N=R.getCapabilities(k.scheme);return!(N&&N&1024)}class f extends T.Workspace{constructor(R,N,x,F,B,O,H){super(R,x.map(M=>new T.WorkspaceFolder(M)),F,B,H);this._name=N,this._isUntitled=O,this._workspaceFolders=[],this._structure=P.TernarySearchTree.forUris(H),x.forEach(M=>{this._workspaceFolders.push(M),this._structure.set(M.uri,M)})}static toExtHostWorkspace(R,N,x,F){if(!R)return{workspace:null,added:[],removed:[]};const{id:B,name:O,folders:H,configuration:M,transient:W,isUntitled:z}=R,U=[],V=N;N?H.forEach((Y,fe)=>{const me=c.URI.revive(Y.uri),_e=f._findFolder(x||N,me,F);_e?(_e.name=Y.name,_e.index=Y.index,U.push(_e)):U.push({uri:me,name:Y.name,index:fe})}):U.push(...H.map(({uri:Y,name:fe,index:me})=>({uri:c.URI.revive(Y),name:fe,index:me}))),U.sort((Y,fe)=>Y.index<fe.index?-1:1);const K=new f(B,O,U,!!W,M?c.URI.revive(M):null,!!z,Y=>a(Y,F)),{added:G,removed:Q}=u(V?V.workspaceFolders:[],K.workspaceFolders,t,F);return{workspace:K,added:G,removed:Q}}static _findFolder(R,N,x){for(let F=0;F<R.folders.length;F++){const B=R.workspaceFolders[F];if(n(B.uri,N,x))return B}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(R,N){return N&&this._structure.get(R)&&(R=(0,I.dirname)(R)),this._structure.findSubstr(R)}resolveWorkspaceFolder(R){return this._structure.get(R)}}let w=class{constructor(R,N,x,F){this._onDidChangeWorkspace=new C.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new C.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=F,this._extHostFileSystemInfo=x,this._requestIdProvider=new _.Counter,this._barrier=new i.Barrier,this._proxy=R.getProxy(S.MainContext.MainThreadWorkspace),this._messageService=R.getProxy(S.MainContext.MainThreadMessageService);const B=N.workspace;this._confirmedWorkspace=B?new f(B.id,B.name,[],!!B.transient,B.configuration?c.URI.revive(B.configuration):null,!!B.isUntitled,O=>a(O,x)):void 0}$initializeWorkspace(R,N){this._trusted=N,this.$acceptWorkspaceData(R),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?c.URI.from({scheme:D.Schemas.untitled,path:(0,I.basename)((0,I.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(R,N,x,...F){const B=[];if(Array.isArray(F)&&F.forEach(z=>{c.URI.isUri(z.uri)&&!B.some(U=>n(U.uri,z.uri,this._extHostFileSystemInfo))&&B.push({uri:z.uri,name:z.name||(0,I.basenameOrAuthority)(z.uri)})}),this._unconfirmedWorkspace||[N,x].some(z=>typeof z!="number"||z<0)||x===0&&B.length===0)return!1;const O=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(N+x>O.length)return!1;const H=O.slice(0);H.splice(N,x,...B.map(z=>({uri:z.uri,name:z.name||(0,I.basenameOrAuthority)(z.uri),index:void 0})));for(let z=0;z<H.length;z++){const U=H[z];if(H.some((V,K)=>K!==z&&n(U.uri,V.uri,this._extHostFileSystemInfo)))return!1}H.forEach((z,U)=>z.index=U);const{added:M,removed:W}=u(O,H,r,this._extHostFileSystemInfo);if(M.length===0&&W.length===0)return!1;if(this._proxy){const z=R.displayName||R.name;this._proxy.$updateWorkspaceFolders(z,N,x,B).then(void 0,U=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(v.Severity.Error,(0,E.localize)(0,null,z,U.toString()),{extension:R},[])})}return this.trySetWorkspaceFolders(H),!0}getWorkspaceFolder(R,N){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(R,N)}async getWorkspaceFolder2(R,N){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(R,N)}async resolveWorkspaceFolder(R){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(R)}getPath(){if(!this._actualWorkspace)return;const{folders:R}=this._actualWorkspace;if(R.length!==0)return R[0].uri.fsPath}getRelativePath(R,N){let x,F="";if(typeof R=="string"?(x=c.URI.file(R),F=R):typeof R!="undefined"&&(x=R,F=R.fsPath),!x)return F;const B=this.getWorkspaceFolder(x,!0);if(!B)return F;typeof N=="undefined"&&this._actualWorkspace&&(N=this._actualWorkspace.folders.length>1);let O=(0,I.relativePath)(B.uri,x);return N&&B.name&&(O=`${B.name}/${O}`),O}trySetWorkspaceFolders(R){this._actualWorkspace&&(this._unconfirmedWorkspace=f.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:R,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(R){const{workspace:N,added:x,removed:F}=f.toExtHostWorkspace(R,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=N||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:x,removed:F}))}findFiles(R,N,x,F,B=y.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${F.value}, entryPoint: findFiles`);let O;if(N===null?O=!1:N&&(typeof N=="string"?O=N:O=N.pattern),B&&B.isCancellationRequested)return Promise.resolve([]);const{includePattern:H,folder:M}=d(R);return this._proxy.$startFileSearch((0,A.withUndefinedAsNull)(H),(0,A.withUndefinedAsNull)(M),(0,A.withUndefinedAsNull)(O),(0,A.withUndefinedAsNull)(x),B).then(W=>Array.isArray(W)?W.map(z=>c.URI.revive(z)):[])}async findTextInFiles(R,N,x,F,B=y.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${F.value}, entryPoint: findTextInFiles`);const O=this._requestIdProvider.getNext(),H=typeof N.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:N.previewOptions,{includePattern:M,folder:W}=d(N.include),z=typeof N.exclude=="string"?N.exclude:N.exclude?N.exclude.pattern:void 0,U={ignoreSymlinks:typeof N.followSymlinks=="boolean"?!N.followSymlinks:void 0,disregardIgnoreFiles:typeof N.useIgnoreFiles=="boolean"?!N.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof N.useGlobalIgnoreFiles=="boolean"?!N.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof N.useDefaultExcludes=="boolean"?!N.useDefaultExcludes:!0,fileEncoding:N.encoding,maxResults:N.maxResults,previewOptions:H,afterContext:N.afterContext,beforeContext:N.beforeContext,includePattern:M,excludePattern:z},V=!1;if(this._activeSearchCallbacks[O]=K=>{if(V)return;const G=c.URI.revive(K.resource);K.results.forEach(Q=>{(0,l.resultIsMatch)(Q)?x({uri:G,preview:{text:Q.preview.text,matches:(0,m.mapArrayOrNot)(Q.preview.matches,Y=>new g.Range(Y.startLineNumber,Y.startColumn,Y.endLineNumber,Y.endColumn))},ranges:(0,m.mapArrayOrNot)(Q.ranges,Y=>new g.Range(Y.startLineNumber,Y.startColumn,Y.endLineNumber,Y.endColumn))}):x({uri:G,text:Q.text,lineNumber:Q.lineNumber})})},B.isCancellationRequested)return{};try{const K=await this._proxy.$startTextSearch(R,(0,A.withUndefinedAsNull)(W),U,O,B);return delete this._activeSearchCallbacks[O],K||{}}catch(K){throw delete this._activeSearchCallbacks[O],K}}$handleTextSearchResult(R,N){this._activeSearchCallbacks[N]&&this._activeSearchCallbacks[N](R)}saveAll(R){return this._proxy.$saveAll(R)}resolveProxy(R){return this._proxy.$resolveProxy(R)}get trusted(){return this._trusted}requestWorkspaceTrust(R){return this._proxy.$requestWorkspaceTrust(R)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};w=je([ze(0,s.IExtHostRpcService),ze(1,o.IExtHostInitDataService),ze(2,b.IExtHostFileSystemInfo),ze(3,p.ILogService)],w),e.ExtHostWorkspace=w,e.IExtHostWorkspace=(0,h.createDecorator)("IExtHostWorkspace");function d(k){let R,N;return k&&(typeof k=="string"?R=k:(R=k.pattern,N=k.baseFolder||c.URI.file(k.base))),{includePattern:R,folder:N}}}),define(ve[36],we([0,1,25,3,35,5,7,192,118,13,18,4,14,11,2]),function(J,e,m,i,y,C,P,D,_,I,L,A,c,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function p(S,n){if(n){const t=n.split(".");let r=S;for(let u=0;r&&u<t.length;u++)r=r[t[u]];return r}}function v(S){return S instanceof h.URI}function T(S){return S&&S.uri instanceof h.URI&&S.languageId&&typeof S.languageId=="string"}function b(S){return S&&!S.uri&&S.languageId&&typeof S.languageId=="string"}function o(S){return S&&S.uri instanceof h.URI&&(!S.name||typeof S.name=="string")&&(!S.index||typeof S.index=="number")}function s(S){if(v(S))return{resource:S};if(T(S))return{resource:S.uri,overrideIdentifier:S.languageId};if(b(S))return{overrideIdentifier:S.languageId};if(o(S))return{resource:S.uri};if(S===null)return{resource:null}}let g=class{constructor(n,t,r){this._proxy=n.getProxy(C.MainContext.MainThreadConfiguration),this._extHostWorkspace=t,this._logService=r,this._barrier=new L.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(n=>this._actual)}$initializeConfiguration(n){this._actual=new l(this._proxy,this._extHostWorkspace,n,this._logService),this._barrier.open()}$acceptConfigurationChanged(n,t){this.getConfigProvider().then(r=>r.$acceptConfigurationChanged(n,t))}};g=je([ze(0,c.IExtHostRpcService),ze(1,y.IExtHostWorkspace),ze(2,E.ILogService)],g),e.ExtHostConfiguration=g;class l{constructor(n,t,r,u){this._onDidChangeConfiguration=new i.Emitter,this._proxy=n,this._logService=u,this._extHostWorkspace=t,this._configuration=D.Configuration.parse(r),this._configurationScopes=this._toMap(r.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(n,t){const r={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=D.Configuration.parse(n),this._configurationScopes=this._toMap(n.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(t,r))}getConfiguration(n,t,r){const u=s(t)||{},a=this._toReadonlyValue(n?p(this._configuration.getValue(void 0,u,this._extHostWorkspace.workspace),n):this._configuration.getValue(void 0,u,this._extHostWorkspace.workspace));n&&this._validateConfigurationAccess(n,u,r?.identifier);function f(d){if(d==null)return null;if(typeof d=="boolean")return d?1:4;switch(d){case P.ConfigurationTarget.Global:return 1;case P.ConfigurationTarget.Workspace:return 4;case P.ConfigurationTarget.WorkspaceFolder:return 5}}const w={has(d){return typeof p(a,d)!="undefined"},get:(d,k)=>{this._validateConfigurationAccess(n?`${n}.${d}`:d,u,r?.identifier);let R=p(a,d);if(typeof R=="undefined")R=k;else{let N;const x=(F,B)=>{let O;const H=()=>{N=N||(0,m.deepClone)(a),O=O||p(N,B)};return(0,I.isObject)(F)?new Proxy(F,{get:(M,W)=>{if(typeof W=="string"&&W.toLowerCase()==="tojson")return H(),()=>O;if(N)return O=O||p(N,B),O[W];const z=M[W];return typeof W=="string"?x(z,`${B}.${W}`):z},set:(M,W,z)=>(H(),O&&(O[W]=z),!0),deleteProperty:(M,W)=>(H(),O&&delete O[W],!0),defineProperty:(M,W,z)=>(H(),O&&Object.defineProperty(O,W,z),!0)}):F};R=x(R,d)}return R},update:(d,k,R,N)=>{d=n?`${n}.${d}`:d;const x=f(R);return k!==void 0?this._proxy.$updateConfigurationOption(x,d,k,u,N):this._proxy.$removeConfigurationOption(x,d,u,N)},inspect:d=>{d=n?`${n}.${d}`:d;const k=(0,m.deepClone)(this._configuration.inspect(d,u,this._extHostWorkspace.workspace));if(k)return{key:d,defaultValue:k.default?.value,globalValue:k.user?.value,workspaceValue:k.workspace?.value,workspaceFolderValue:k.workspaceFolder?.value,defaultLanguageValue:k.default?.override,globalLanguageValue:k.user?.override,workspaceLanguageValue:k.workspace?.override,workspaceFolderLanguageValue:k.workspaceFolder?.override,languageIds:k.overrideIdentifiers}}};return typeof a=="object"&&(0,m.mixin)(w,a,!1),Object.freeze(w)}_toReadonlyValue(n){const t=r=>(0,I.isObject)(r)?new Proxy(r,{get:(u,a)=>t(u[a]),set:(u,a,f)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(a)}' of object`)},deleteProperty:(u,a)=>{throw new Error(`TypeError: Cannot delete read only property '${String(a)}' of object`)},defineProperty:(u,a)=>{throw new Error(`TypeError: Cannot define property '${String(a)}' for a readonly object`)},setPrototypeOf:u=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):r;return t(n)}_validateConfigurationAccess(n,t,r){const u=_.OVERRIDE_PROPERTY_REGEX.test(n)?4:this._configurationScopes.get(n),a=r?`[${r.value}] `:"";if(u===4){typeof t?.resource=="undefined"&&this._logService.warn(`${a}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${n}', provide the URI of a resource or 'null' for any resource.`);return}if(u===3){t?.resource&&this._logService.warn(`${a}Accessing a window scoped configuration for a resource is not expected. To associate '${n}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(n,t){const r=new D.ConfigurationChangeEvent(n,t,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(u,a)=>r.affectsConfiguration(u,s(a))})}_toMap(n){return n.reduce((t,r)=>(t.set(r[0],r[1]),t),new Map)}}e.ExtHostConfigProvider=l,e.IExtHostConfiguration=(0,A.createDecorator)("IExtHostConfiguration")});var nt=this&&this.__classPrivateFieldSet||function(J,e,m,i,y){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!y:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?y.call(J,m):y?y.value=m:e.set(J,m),m},Be=this&&this.__classPrivateFieldGet||function(J,e,m,i){if(m==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!i:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?i:m==="a"?i.call(J):i?i.value:e.get(J)};define(ve[70],we([0,1,2,18,3,5,7,35,45,36,21,34,14,26,4,10,12,11,65,212,15]),function(J,e,m,i,y,C,P,D,_,I,L,A,c,E,h,p,v,T,b,o,s){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var l;(function(B){function O(M){if(M!=null)return M}B.from=O;function H(M){if(M!=null)return M}B.to=H})(l=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var S;(function(B){function O(M){if(M!=null)return M}B.from=O;function H(M){if(M!=null)return M}B.to=H})(S=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var n;(function(B){function O(M){if(M!=null)return M}B.from=O;function H(M){if(M!=null)return M}B.to=H})(n=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var t;(function(B){function O(W){if(W){const z=W;return z&&!!z.process}else return!1}B.is=O;function H(W){if(W==null)return;const z={process:W.process,args:W.args};return W.options&&(z.options=n.from(W.options)),z}B.from=H;function M(W){if(W!=null)return new P.ProcessExecution(W.process,W.args,W.options)}B.to=M})(t=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var r;(function(B){function O(M){if(M!=null)return M}B.from=O;function H(M){if(M!=null)return M}B.to=H})(r=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var u;(function(B){function O(W){if(W){const z=W;return z&&(!!z.commandLine||!!z.command)}else return!1}B.is=O;function H(W){if(W==null)return;const z={};return W.commandLine!==void 0?z.commandLine=W.commandLine:(z.command=W.command,z.args=W.args),W.options&&(z.options=r.from(W.options)),z}B.from=H;function M(W){if(!(W==null||W.command===void 0&&W.commandLine===void 0))return W.commandLine?new P.ShellExecution(W.commandLine,W.options):new P.ShellExecution(W.command,W.args?W.args:[],W.options)}B.to=M})(u=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var a;(function(B){function O(W){if(W){let z=W;return z&&z.customExecution==="customExecution"}else return!1}B.is=O;function H(W){return{customExecution:"customExecution"}}B.from=H;function M(W,z){return z.get(W)}B.to=M})(a=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var f;(function(B){function O(H,M){let W;return H.scope!==void 0&&typeof H.scope!="number"?W=H.scope.uri:H.scope!==void 0&&typeof H.scope=="number"&&(H.scope===P.TaskScope.Workspace&&M&&M.workspaceFile?W=M.workspaceFile:W=o.USER_TASKS_GROUP_KEY),{id:H._id,workspaceFolder:W}}B.from=O})(f=e.TaskHandleDTO||(e.TaskHandleDTO={}));var w;(function(B){function O(H){if(H!=null)return{_id:H.id,isDefault:H.isDefault}}B.from=O})(w=e.TaskGroupDTO||(e.TaskGroupDTO={}));var d;(function(B){function O(W,z){if(W==null)return[];const U=[];for(let V of W){const K=H(V,z);K&&U.push(K)}return U}B.fromMany=O;function H(W,z){if(W==null)return;let U;W.execution instanceof P.ProcessExecution?U=t.from(W.execution):W.execution instanceof P.ShellExecution?U=u.from(W.execution):W.execution&&W.execution instanceof P.CustomExecution&&(U=a.from(W.execution));const V=l.from(W.definition);let K;return W.scope?typeof W.scope=="number"?K=W.scope:K=W.scope.uri:K=P.TaskScope.Workspace,!V||!K?void 0:{_id:W._id,definition:V,name:W.name,source:{extensionId:z.identifier.value,label:W.source,scope:K},execution:U,isBackground:W.isBackground,group:w.from(W.group),presentationOptions:S.from(W.presentationOptions),problemMatchers:W.problemMatchers,hasDefinedMatchers:W.hasDefinedMatchers,runOptions:W.runOptions?W.runOptions:{reevaluateOnRerun:!0},detail:W.detail}}B.from=H;async function M(W,z,U){if(W==null)return;let V;t.is(W.execution)?V=t.to(W.execution):u.is(W.execution)?V=u.to(W.execution):a.is(W.execution)&&(V=a.to(W._id,U));const K=l.to(W.definition);let G;if(W.source&&(W.source.scope!==void 0?typeof W.source.scope=="number"?G=W.source.scope:G=await z.resolveWorkspaceFolder(m.URI.revive(W.source.scope)):G=P.TaskScope.Workspace),!K||!G)return;const Q=new P.Task(K,G,W.name,W.source.label,V,W.problemMatchers);return W.isBackground!==void 0&&(Q.isBackground=W.isBackground),W.group!==void 0&&(Q.group=P.TaskGroup.from(W.group._id),Q.group&&W.group.isDefault&&(Q.group=new P.TaskGroup(Q.group.id,Q.group.label),W.group.isDefault&&(Q.group.isDefault=W.group.isDefault))),W.presentationOptions&&(Q.presentationOptions=S.to(W.presentationOptions)),W._id&&(Q._id=W._id),W.detail&&(Q.detail=W.detail),Q}B.to=M})(d=e.TaskDTO||(e.TaskDTO={}));var k;(function(B){function O(M){return M}B.from=O;function H(M){if(!!M)return Object.assign(Object.create(null),M)}B.to=H})(k=e.TaskFilterDTO||(e.TaskFilterDTO={}));class R{constructor(O,H,M){this._id=H,this._task=M,g.set(this,void 0),nt(this,g,O,"f")}get task(){return this._task}terminate(){Be(this,g,"f").terminateTask(this)}fireDidStartProcess(O){}fireDidEndProcess(O){}}g=new WeakMap;var N;(function(B){function O(H){return{id:H._id,task:void 0}}B.from=O})(N=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let x=class{constructor(O,H,M,W,z,U,V,K){this._onDidExecuteTask=new y.Emitter,this._onDidTerminateTask=new y.Emitter,this._onDidTaskProcessStarted=new y.Emitter,this._onDidTaskProcessEnded=new y.Emitter,this._proxy=O.getProxy(C.MainContext.MainThreadTask),this._workspaceProvider=M,this._editorService=W,this._configurationService=z,this._terminalService=U,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=V,this._deprecationService=K,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(O,H,M){if(!M)return new P.Disposable(()=>{});const W=this.nextHandle();return this._handlers.set(W,{type:H,provider:M,extension:O}),this._proxy.$registerTaskProvider(W,H),new P.Disposable(()=>{this._handlers.delete(W),this._proxy.$unregisterTaskProvider(W)})}registerTaskSystem(O,H){this._proxy.$registerTaskSystem(O,H)}fetchTasks(O){return this._proxy.$fetchTasks(k.from(O)).then(async H=>{const M=[];for(let W of H){const z=await d.to(W,this._workspaceProvider,this._providedCustomExecutions2);z&&M.push(z)}return M})}get taskExecutions(){const O=[];return this._taskExecutions.forEach(H=>O.push(H)),O}terminateTask(O){if(!(O instanceof R))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(O._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(O,H,M){const W=this._providedCustomExecutions2.get(O.id);W&&(this._activeCustomExecutions2.set(O.id,W),this._terminalService.attachPtyToTerminal(H,await W.callback(M))),this._lastStartedTask=O.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(O)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(O){const H=await this.getTaskExecution(O);this._taskExecutionPromises.delete(O.id),this._taskExecutions.delete(O.id),this.customExecutionComplete(O),this._onDidTerminateTask.fire({execution:H})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(O){const H=await this.getTaskExecution(O.id);this._onDidTaskProcessStarted.fire({execution:H,processId:O.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(O){const H=await this.getTaskExecution(O.id);this._onDidTaskProcessEnded.fire({execution:H,exitCode:O.exitCode})}$provideTasks(O,H){const M=this._handlers.get(O);if(!M)return Promise.reject(new Error("no handler found"));const W=[],z=(0,i.asPromise)(()=>M.provider.provideTasks(L.CancellationToken.None)).then(U=>this.provideTasksInternal(H,W,M,U));return new Promise(U=>{z.then(V=>{Promise.all(W).then(()=>{U(V)})})})}async $resolveTask(O,H){const M=this._handlers.get(O);if(!M)return Promise.reject(new Error("no handler found"));if(H.definition.type!==M.type)throw new Error(`Unexpected: Task of type [${H.definition.type}] cannot be resolved by provider of type [${M.type}].`);const W=await d.to(H,this._workspaceProvider,this._providedCustomExecutions2);if(!W)throw new Error("Unexpected: Task cannot be resolved.");const z=await M.provider.resolveTask(W,L.CancellationToken.None);if(!z)return;this.checkDeprecation(z,M);const U=d.from(z,M.extension);if(!U)throw new Error("Unexpected: Task cannot be resolved.");if(z.definition!==W.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return a.is(U.execution)&&await this.addCustomExecution(U,z,!0),await this.resolveTaskInternal(U)}nextHandle(){return this._handleCounter++}async addCustomExecution(O,H,M){const W=await this._proxy.$createTaskId(O);!M&&!this._providedCustomExecutions2.has(W)&&(this._notProvidedCustomExecutions.add(W),this._activeCustomExecutions2.set(W,H.execution)),this._providedCustomExecutions2.set(W,H.execution)}async getTaskExecution(O,H){if(typeof O=="string"){const z=this._taskExecutionPromises.get(O);if(!z)throw new Error("Unexpected: The specified task is missing an execution");return z}let M=this._taskExecutionPromises.get(O.id);if(M)return M;const W=new Promise((z,U)=>{function V(K,G,Q){Q?z(new R(K,G.id,Q)):U("Unexpected: Task does not exist.")}H?V(this,O,H):d.to(O.task,this._workspaceProvider,this._providedCustomExecutions2).then(K=>V(this,O,K))});return this._taskExecutionPromises.set(O.id,W),W.then(z=>(this._taskExecutions.set(O.id,z),z),z=>Promise.reject(z))}checkDeprecation(O,H){O._deprecated&&this._deprecationService.report("Task.constructor",H.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(O){this._activeCustomExecutions2.get(O.id)&&this._activeCustomExecutions2.delete(O.id),this._notProvidedCustomExecutions.has(O.id)&&this._lastStartedTask!==O.id&&(this._providedCustomExecutions2.delete(O.id),this._notProvidedCustomExecutions.delete(O.id));let M=this._notProvidedCustomExecutions.values(),W=M.next();for(;!W.done;)!this._activeCustomExecutions2.has(W.value)&&this._lastStartedTask!==W.value&&(this._providedCustomExecutions2.delete(W.value),this._notProvidedCustomExecutions.delete(W.value)),W=M.next()}};x=je([ze(0,c.IExtHostRpcService),ze(1,E.IExtHostInitDataService),ze(2,D.IExtHostWorkspace),ze(3,_.IExtHostDocumentsAndEditors),ze(4,I.IExtHostConfiguration),ze(5,A.IExtHostTerminalService),ze(6,T.ILogService),ze(7,b.IExtHostApiDeprecationService)],x),e.ExtHostTaskBase=x;let F=class extends x{constructor(O,H,M,W,z,U,V,K){super(O,H,M,W,z,U,V,K);this.registerTaskSystem(p.Schemas.vscodeRemote,{scheme:p.Schemas.vscodeRemote,authority:"",platform:v.PlatformToString(0)})}async executeTask(O,H){if(!H.execution)throw new Error("Tasks to execute must include an execution");const M=d.from(H,O);if(M===void 0)throw new Error("Task is not valid");if(a.is(M.execution))await this.addCustomExecution(M,H,!1);else throw new s.NotSupportedError;const W=await this.getTaskExecution(await this._proxy.$getTaskExecution(M),H);return this._proxy.$executeTask(M).catch(z=>{throw new Error(z)}),W}provideTasksInternal(O,H,M,W){const z=[];if(W)for(let U of W){this.checkDeprecation(U,M),(!U.definition||!O[U.definition.type])&&this._logService.warn(`The task [${U.source}, ${U.name}] uses an undefined task type. The task will be ignored in the future.`);const V=d.from(U,M.extension);V&&a.is(V.execution)?(z.push(V),H.push(this.addCustomExecution(V,U,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:z,extension:M.extension}}async resolveTaskInternal(O){if(a.is(O.execution))return O;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(O,H){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(O,H,M){}};F=je([ze(0,c.IExtHostRpcService),ze(1,E.IExtHostInitDataService),ze(2,D.IExtHostWorkspace),ze(3,_.IExtHostDocumentsAndEditors),ze(4,I.IExtHostConfiguration),ze(5,A.IExtHostTerminalService),ze(6,T.ILogService),ze(7,b.IExtHostApiDeprecationService)],F),e.WorkerExtHostTask=F,e.IExtHostTask=(0,h.createDecorator)("IExtHostTask")}),define(ve[266],we([0,1,16,74,31,80,24,10,9,23,8,13,2,145,174,115,43,127,265,33]),function(J,e,m,i,y,C,P,D,_,I,L,A,c,E,h,p,v,T,b,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let s=class{constructor(f,w,d,k){this.configurationService=f,this.workspaceContextService=w,this.editorGroupsService=d,this.pathService=k}text(f,w,d={}){f=this.getContentPattern(f,d);const k=this.configurationService.getValue(),R=w&&w.some(x=>!this.configurationService.getValue({resource:x}).search.useRipgrep);return{...this.commonQuery(w?.map(v.toWorkspaceFolder),d),type:2,contentPattern:f,previewOptions:d.previewOptions,maxFileSize:d.maxFileSize,usePCRE2:k.search.usePCRE2||R||!1,beforeContext:d.beforeContext,afterContext:d.afterContext,userDisabledExcludesAndIgnoreFiles:d.disregardExcludeSettings&&d.disregardIgnoreFiles}}getContentPattern(f,w){const d=this.configurationService.getValue();f.isRegExp&&(f.pattern=f.pattern.replace(/\r?\n/g,"\\n"));const k={...f,wordSeparators:d.editor.wordSeparators};return this.isCaseSensitive(f,w)&&(k.isCaseSensitive=!0),this.isMultiline(f)&&(k.isMultiline=!0),k}file(f,w={}){return{...this.commonQuery(f,w),type:1,filePattern:w.filePattern?w.filePattern.trim():w.filePattern,exists:w.exists,sortByScore:w.sortByScore,cacheKey:w.cacheKey}}handleIncludeExclude(f,w){return f?(f=Array.isArray(f)?f.map(t):t(f),w?this.parseSearchPaths(f):{pattern:l(...Array.isArray(f)?f:[f])}):{}}commonQuery(f=[],w={}){const d=this.handleIncludeExclude(w.includePattern,w.expandPatterns),k=this.handleIncludeExclude(w.excludePattern,w.expandPatterns),R=f.length>1,N=(d.searchPaths&&d.searchPaths.length?d.searchPaths.map(B=>this.getFolderQueryForSearchPath(B,w,k)):f.map(B=>this.getFolderQueryForRoot(B,w,k,R))).filter(B=>!!B),x={_reason:w._reason,folderQueries:N,usingSearchPaths:!!(d.searchPaths&&d.searchPaths.length),extraFileResources:w.extraFileResources,excludePattern:k.pattern,includePattern:d.pattern,onlyOpenEditors:w.onlyOpenEditors,maxResults:w.maxResults};if(w.onlyOpenEditors){const O=m.coalesce(m.flatten(this.editorGroupsService.groups.map(M=>M.editors.map(W=>W.resource)))).filter(M=>(0,o.pathIncludedInQuery)(x,M.fsPath)),H=this.commonQueryFromFileList(O);return{...x,...H}}const F=w.extraFileResources&&w.extraFileResources.filter(B=>(0,o.pathIncludedInQuery)(x,B.fsPath));return x.extraFileResources=F&&F.length?F:void 0,x}commonQueryFromFileList(f){const w=[],d=new P.ResourceMap,k={};let R=!1;return f.forEach(N=>{if(N.scheme===D.Schemas.walkThrough)return;if((0,I.isAbsolutePath)(N)){const F=this.workspaceContextService.getWorkspaceFolder(N)?.uri??N.with({path:_.dirname(N.fsPath)});let B=d.get(F);B||(R=!0,B={folder:F,includePattern:{}},w.push(B),d.set(F,B));const O=_.relative(F.fsPath,N.fsPath);(0,A.assertIsDefined)(B.includePattern)[O.replace(/\\/g,"/")]=!0}else N.fsPath&&(R=!0,k[N.fsPath]=!0)}),{folderQueries:w,includePattern:k,usingSearchPaths:!0,excludePattern:R?void 0:{"**/*":!0}}}isCaseSensitive(f,w){if(w.isSmartCase){if(f.isRegExp){if(L.containsUppercaseCharacter(f.pattern,!0))return!0}else if(L.containsUppercaseCharacter(f.pattern))return!0}return!!f.isCaseSensitive}isMultiline(f){return f.isMultiline||f.isRegExp&&(0,E.isMultilineRegexSource)(f.pattern)||f.pattern.indexOf(`
`)>=0?!0:!!f.isMultiline}parseSearchPaths(f){const w=H=>_.isAbsolute(H)||/^\.\.?([\/\\]|$)/.test(H),k=(Array.isArray(f)?f:S(f)).map(H=>{const M=this.pathService.resolvedUserHome;return M?(0,C.untildify)(H,M.scheme===D.Schemas.file?M.fsPath:M.path):H}),R=i.groupBy(k,H=>w(H)?"searchPaths":"exprSegments"),N=(R.exprSegments||[]).map(H=>L.rtrim(H,"/")).map(H=>L.rtrim(H,"\\")).map(H=>(H[0]==="."&&(H="*"+H),n(H))),x={},F=this.expandSearchPathPatterns(R.searchPaths||[]);F&&F.length&&(x.searchPaths=F);const B=m.flatten(N),O=l(...B);return O&&(x.pattern=O),x}getExcludesForFolder(f,w){return w.disregardExcludeSettings?void 0:(0,o.getExcludes)(f,!w.disregardSearchExcludeSettings)}expandSearchPathPatterns(f){if(!f||!f.length)return[];const w=m.flatten(f.map(k=>{let{pathPortion:R,globPortion:N}=g(k);N&&(N=r(N));const x=this.expandOneSearchPath(R);return m.flatten(x.map(F=>this.resolveOneSearchPathPattern(F,N)))})),d=new Map;return w.forEach(k=>{const R=k.searchPath.toString(),N=d.get(R);N?k.pattern&&(N.pattern=N.pattern||{},N.pattern[k.pattern]=!0):d.set(R,{searchPath:k.searchPath,pattern:k.pattern?l(k.pattern):void 0})}),Array.from(d.values())}expandOneSearchPath(f){if(_.isAbsolute(f)){const w=this.workspaceContextService.getWorkspace().folders;return w[0]&&w[0].uri.scheme!==D.Schemas.file?[{searchPath:w[0].uri.with({path:f})}]:[{searchPath:c.URI.file(_.normalize(f))}]}if(this.workspaceContextService.getWorkbenchState()===2){const w=this.workspaceContextService.getWorkspace().folders[0].uri;if(f=t(f),f.startsWith("../")||f===".."){const k=_.posix.resolve(w.path,f);return[{searchPath:w.with({path:k})}]}const d=r(f);return[{searchPath:w,pattern:d}]}else{if(f==="./"||f===".\\")return[];{const w=f.replace(/^\.[\/\\]/,""),k=this.workspaceContextService.getWorkspace().folders.map(R=>{const N=w.match(new RegExp(`^${L.escapeRegExpCharacters(R.name)}(?:/(.*)|$)`));return N?{match:N,folder:R}:null}).filter(A.isDefined);if(k.length)return k.map(R=>{const N=R.match[1];return{searchPath:R.folder.uri,pattern:N&&r(N)}});{const R=f.match(/\.[\/\\](.+)[\/\\]?/),N=R?R[1]:f,x=h.localize(0,null,N);throw new Error(x)}}}}resolveOneSearchPathPattern(f,w){const d=f.pattern&&w?`${f.pattern}/${w}`:f.pattern||w,k=[{searchPath:f.searchPath,pattern:d}];return d&&!d.endsWith("**")&&k.push({searchPath:f.searchPath,pattern:d+"/**"}),k}getFolderQueryForSearchPath(f,w,d){const k=this.getFolderQueryForRoot((0,v.toWorkspaceFolder)(f.searchPath),w,d,!1);return k?{...k,includePattern:f.pattern}:null}getFolderQueryForRoot(f,w,d,k){let R;const N=c.URI.isUri(f)?f:f.uri;if(d.searchPaths){const H=d.searchPaths.filter(M=>(0,I.isEqual)(M.searchPath,N))[0];if(H&&!H.pattern)return null;H&&(R=H.pattern)}const x=this.configurationService.getValue({resource:N}),B={...this.getExcludesForFolder(x,w)||{},...R||{}},O=c.URI.isUri(f)?(0,I.basename)(f):f.name;return{folder:N,folderName:k?O:void 0,excludePattern:Object.keys(B).length>0?B:void 0,fileEncoding:x.files&&x.files.encoding,disregardIgnoreFiles:typeof w.disregardIgnoreFiles=="boolean"?w.disregardIgnoreFiles:!x.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof w.disregardGlobalIgnoreFiles=="boolean"?w.disregardGlobalIgnoreFiles:!x.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof w.ignoreSymlinks=="boolean"?w.ignoreSymlinks:!x.search.followSymlinks}}};s=je([ze(0,p.IConfigurationService),ze(1,v.IWorkspaceContextService),ze(2,T.IEditorGroupsService),ze(3,b.IPathService)],s),e.QueryBuilder=s;function g(a){const f=a.match(/[\*\{\}\(\)\[\]\?]/);if(f){const w=f.index,d=a.substr(0,w).match(/[/|\\][^/\\]*$/);if(d){let k=a.substr(0,d.index);return k.match(/[/\\]/)||(k+="/"),{pathPortion:k,globPortion:a.substr((d.index||0)+1)}}}return{pathPortion:a}}function l(...a){return a.length?a.reduce((f,w)=>(f[w]=!0,f),Object.create(null)):void 0}function S(a){return y.splitGlobAware(a,",").map(f=>f.trim()).filter(f=>!!f.length)}function n(a){return[`**/${a}/**`,`**/${a}`].map(w=>w.replace(/\*\*\/\*\*/g,"**"))}function t(a){return a.replace(/\\/g,"/")}function r(a){return t(a).replace(/^\.\//,"").replace(/\/+$/g,"")}function u(a,f){a=m.distinct(a,k=>k.toString());const w=[],d=f.getWorkspace();return a&&a.forEach(k=>{let R;if(f.getWorkbenchState()===2)R=(0,I.relativePath)(d.folders[0].uri,k),R&&R!=="."&&(R="./"+R);else{const N=f.getWorkspaceFolder(k);if(N){const x=N.name;if(d.folders.filter(B=>B.name===x).length===1){const B=(0,I.relativePath)(N.uri,k);B===""?R=`./${N.name}`:R=`./${N.name}/${B}`}else R=k.fsPath}}R&&w.push(R)}),w}e.resolveResourcesForSearchIncludes=u}),define(ve[267],we([0,1,23,2,21,15,4,266,33,43]),function(J,e,m,i,y,C,P,D,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const L=7e3;function A(p,v){const T=v.activationEvents;if(!T)return Promise.resolve(void 0);const b=[],o=[];for(const t of T)if(/^workspaceContains:/.test(t)){const r=t.substr("workspaceContains:".length);r.indexOf("*")>=0||r.indexOf("?")>=0||p.forceUsingSearch?o.push(r):b.push(r)}if(b.length===0&&o.length===0)return Promise.resolve(void 0);let s;const g=new Promise((t,r)=>{s=t}),l=t=>s({activationEvent:t}),S=Promise.all(b.map(t=>c(p,t,l))).then(()=>{}),n=E(p,v.identifier,o,l);return Promise.all([S,n]).then(()=>{s(void 0)}),g}e.checkActivateWorkspaceContainsExtension=A;async function c(p,v,T){for(const b of p.folders)if(await p.exists(m.joinPath(i.URI.revive(b),v))){T(`workspaceContains:${v}`);return}}async function E(p,v,T,b){if(T.length===0)return Promise.resolve(void 0);const o=new y.CancellationTokenSource,s=p.checkExists(p.folders,T,o.token),g=setTimeout(async()=>{o.cancel(),p.logService.info(`Not activating extension '${v.value}': Timed out while searching for 'workspaceContains' pattern ${T.join(",")}`)},L);let l=!1;try{l=await s}catch(S){C.isPromiseCanceledError(S)||C.onUnexpectedError(S)}o.dispose(),clearTimeout(g),l&&b(`workspaceContains:${T.join(",")}`)}function h(p,v,T,b){const o=p.get(P.IInstantiationService),s=p.get(_.ISearchService),l=o.createInstance(D.QueryBuilder).file(v.map(S=>(0,I.toWorkspaceFolder)(i.URI.revive(S))),{_reason:"checkExists",includePattern:T,exists:!0});return s.fileSearch(l,b).then(S=>!!S.limitHit,S=>C.isPromiseCanceledError(S)?!1:Promise.reject(S))}e.checkGlobFileExists=h});var nt=this&&this.__classPrivateFieldSet||function(J,e,m,i,y){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!y:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?y.call(J,m):y?y.value=m:e.set(J,m),m},Be=this&&this.__classPrivateFieldGet||function(J,e,m,i){if(m==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!i:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?i:m==="a"?i.call(J):i?i.value:e.get(J)};define(ve[39],we([0,1,163,9,71,23,18,6,24,2,11,5,36,225,91,35,29,223,15,27,22,198,7,119,4,26,67,14,85,52,34,3,267,90,200,10]),function(J,e,m,i,y,C,P,D,_,I,L,A,c,E,h,p,v,T,b,o,s,g,l,S,n,t,r,u,a,f,w,d,k,R,N,x){"use strict";var F,B,O;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,n.createDecorator)("IHostUtils");let H=class ji extends D.Disposable{constructor(U,V,K,G,Q,Y,fe,me,_e,Ie){super();this._onDidChangeRemoteConnectionData=this._register(new d.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=V,this._extHostContext=K,this._initData=fe,this._extHostWorkspace=G,this._extHostConfiguration=Q,this._logService=Y,this._extHostTunnelService=_e,this._extHostTerminalService=Ie,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(A.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(A.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(A.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new P.Barrier,this._readyToStartExtensionHost=new P.Barrier,this._readyToRunExtensions=new P.Barrier,this._eagerExtensionsActivated=new P.Barrier,this._registry=new T.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new h.ExtHostStorage(this._extHostContext),this._secretState=new R.ExtHostSecretState(this._extHostContext),this._storagePath=me,this._instaService=U.createChild(new a.ServiceCollection([h.IExtHostStorage,this._storage],[R.IExtHostSecretState,this._secretState]));const Oe=new Set;this._initData.hostExtensions.forEach(We=>Oe.add(o.ExtensionIdentifier.toKey(We))),this._activator=this._register(new E.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(We,j,Z)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(We,b.transformErrorForSerialization(j),Z)},actualActivateExtension:async(We,j)=>{if(Oe.has(o.ExtensionIdentifier.toKey(We)))return await this._mainThreadExtensionsProxy.$activateExtension(We,j),new E.HostExtension;const Z=this._registry.getExtensionDescription(We);return this._activateExtension(Z,j)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),y.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(U){b.onUnexpectedError(U)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let U=[];try{U=this._registry.getAllExtensionDescriptions().map(Q=>Q.identifier).filter(Q=>this.isActivated(Q)).map(Q=>this._deactivate(Q))}catch{}await Promise.all(U)}isActivated(U){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(U):!1}_activateByEvent(U,V){return this._activator.activateByEvent(U,V)}_activateById(U,V){return this._activator.activateById(U,V)}activateByIdWithErrors(U,V){return this._activateById(U,V).then(()=>{const K=this._activator.getActivatedExtension(U);if(K.activationFailed)return Promise.reject(K.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(U=>this._registry)}getExtensionExports(U){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(U).exports:null}async _realPathExtensionUri(U){if(U.scheme!==x.Schemas.file)return U;const V=await this._hostUtils.realpath(U.fsPath);return I.URI.file(V)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=(async()=>{const U=_.TernarySearchTree.forUris(V=>C.extUriBiasedIgnorePathCase.ignorePathCasing(V));for(const V of this._registry.getAllExtensionDescriptions())if(this._getEntryPoint(V)){const K=await this._realPathExtensionUri(V.extensionLocation);U.set(K,V)}return U})()),this._extensionPathIndex}_deactivate(U){let V=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(U))return V;const K=this._activator.getActivatedExtension(U);if(!K)return V;try{typeof K.module.deactivate=="function"&&(V=Promise.resolve(K.module.deactivate()).then(void 0,G=>(this._logService.error(G),Promise.resolve(void 0))))}catch(G){this._logService.error(G)}try{(0,D.dispose)(K.subscriptions)}catch(G){this._logService.error(G)}return V}async _activateExtension(U,V){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(U.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(U.identifier),this._doActivateExtension(U,V).then(K=>{const G=K.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(U.identifier,G.codeLoadingTime,G.activateCallTime,G.activateResolvedTime,V),this._logExtensionActivationTimes(U,V,"success",G),K},K=>{throw this._logExtensionActivationTimes(U,V,"failure"),K})}_logExtensionActivationTimes(U,V,K,G){const Q=M(U,V);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...Q,...G||{},outcome:K})}_doActivateExtension(U,V){const K=M(U,V);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",K);const G=this._getEntryPoint(U);if(!G)return Promise.resolve(new E.EmptyExtension(E.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${U.identifier.value}, startup: ${V.startup}, activationEvent: '${V.activationEvent}'${U.identifier.value!==V.extensionId.value?`, root cause: ${V.extensionId.value}`:""}`),this._logService.flush();const Q=new E.ExtensionActivationTimesBuilder(V.startup);return Promise.all([this._loadCommonJSModule(U.identifier,(0,C.joinPath)(U.extensionLocation,G),Q),this._loadExtensionContext(U)]).then(Y=>(y.mark(`code/extHost/willActivateExtension/${U.identifier.value}`),ji._callActivate(this._logService,U.identifier,Y[0],Y[1],Q))).then(Y=>(y.mark(`code/extHost/didActivateExtension/${U.identifier.value}`),Y))}_loadExtensionContext(U){const V=new g.ExtensionGlobalMemento(U,this._storage),K=new g.ExtensionMemento(U.identifier.value,!1,this._storage),G=new N.ExtensionSecrets(U,this._secretState),Q=U.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?l.ExtensionMode.Test:l.ExtensionMode.Development:l.ExtensionMode.Production,Y=this._initData.remote.isRemote?l.ExtensionKind.Workspace:l.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${U.identifier.value}`),Promise.all([V.whenReady,K.whenReady,this._storagePath.whenReady]).then(()=>{const fe=this;let me;return Object.freeze({globalState:V,workspaceState:K,secrets:G,subscriptions:[],get extensionUri(){return U.extensionLocation},get extensionPath(){return U.extensionLocation.fsPath},asAbsolutePath(_e){return i.join(U.extensionLocation.fsPath,_e)},get storagePath(){return fe._storagePath.workspaceValue(U)?.fsPath},get globalStoragePath(){return fe._storagePath.globalValue(U).fsPath},get logPath(){return i.join(fe._initData.logsLocation.fsPath,U.identifier.value)},get logUri(){return I.URI.joinPath(fe._initData.logsLocation,U.identifier.value)},get storageUri(){return fe._storagePath.workspaceValue(U)},get globalStorageUri(){return fe._storagePath.globalValue(U)},get extensionMode(){return Q},get extension(){return me===void 0&&(me=new W(fe,U.identifier,U,Y)),me},get extensionRuntime(){return(0,v.checkProposedApiEnabled)(U,"extensionRuntime"),fe.extensionRuntime},get environmentVariableCollection(){return fe._extHostTerminalService.getEnvironmentVariableCollection(U)}})})}static _callActivate(U,V,K,G,Q){return K=K||{activate:void 0,deactivate:void 0},this._callActivateOptional(U,V,K,G,Q).then(Y=>new E.ActivatedExtension(!1,null,Q.build(),K,Y,G.subscriptions))}static _callActivateOptional(U,V,K,G,Q){if(typeof K.activate=="function")try{Q.activateCallStart(),U.trace(`ExtensionService#_callActivateOptional ${V.value}`);const Y=typeof global=="object"?global:self,fe=K.activate.apply(Y,[G]);return Q.activateCallStop(),Q.activateResolveStart(),Promise.resolve(fe).then(me=>(Q.activateResolveStop(),me))}catch(Y){return Promise.reject(Y)}else return Promise.resolve(K)}_activateOneStartupFinished(U,V){this._activateById(U.identifier,{startup:!1,extensionId:U.identifier,activationEvent:V}).then(void 0,K=>{this._logService.error(K)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(y.getMarks());for(const U of this._registry.getAllExtensionDescriptions())if(U.activationEvents)for(const V of U.activationEvents)V==="onStartupFinished"&&this._activateOneStartupFinished(U,V)}_handleEagerExtensions(){const U=this._activateByEvent("*",!0).then(void 0,Q=>{this._logService.error(Q)});this._register(this._extHostWorkspace.onDidChangeWorkspace(Q=>this._handleWorkspaceContainsEagerExtensions(Q.added)));const V=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],K=this._handleWorkspaceContainsEagerExtensions(V),G=Promise.all([U,K]).then(()=>{});return Promise.race([G,(0,P.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),G}_handleWorkspaceContainsEagerExtensions(U){return U.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(V=>this._handleWorkspaceContainsEagerExtension(U,V))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(U,V){if(this.isActivated(V.identifier))return;const K=!this._initData.remote.isRemote&&!!this._initData.remote.authority,G={logService:this._logService,folders:U.map(Y=>Y.uri),forceUsingSearch:K,exists:Y=>this._hostUtils.exists(Y.fsPath),checkExists:(Y,fe,me)=>this._mainThreadWorkspaceProxy.$checkExists(Y,fe,me)},Q=await(0,k.checkActivateWorkspaceContainsExtension)(G,V);if(!!Q)return this._activateById(V.identifier,{startup:!0,extensionId:V.identifier,activationEvent:Q.activationEvent}).then(void 0,Y=>this._logService.error(Y))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(U){throw console.error(U),U}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:U,extensionTestsLocationURI:V}=this._initData.environment;if(!U||!V)throw new Error(m.localize(0,null));const K=await this._loadCommonJSModule(null,V,new E.ExtensionActivationTimesBuilder(!1));if(!K||typeof K.run!="function")throw new Error(m.localize(1,null,V.toString()));return new Promise((G,Q)=>{const Y=(_e,Ie)=>{_e?Q(_e):G(typeof Ie=="number"&&Ie>0?1:0)},fe=(0,C.originalFSPath)(V),me=K.run(fe,Y);me&&me.then&&me.then(()=>{G(0)}).catch(_e=>{Q(_e.toString())})})}async $extensionTestsExit(U){this._logService.info(`Extension host terminating: test runner requested exit with code ${U}`),this._hostUtils.pid&&this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${U}`),this._logService.flush(),this._hostUtils.exit(U)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(U,V){return this._resolvers[U]=V,(0,D.toDisposable)(()=>{delete this._resolvers[U]})}async _activateAndGetResolver(U){const V=U.indexOf("+");if(V===-1)throw new Error("Not an authority that can be resolved!");const K=U.substr(0,V);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${K}`,!1),{authorityPrefix:K,resolver:this._resolvers[K]}}async $resolveAuthority(U,V){const{authorityPrefix:K,resolver:G}=await this._activateAndGetResolver(U);if(!G)return{type:"error",error:{code:S.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${K}.`,detail:void 0}};try{this._register(await this._extHostTunnelService.setTunnelExtensionFunctions(G)),y.mark(`code/extHost/willResolveAuthority/${K}`);const Q=await G.resolve(U,{resolveAttempt:V});y.mark(`code/extHost/didResolveAuthorityOK/${K}`);const Y={authority:U,host:Q.host,port:Q.port,connectionToken:Q.connectionToken},fe={extensionHostEnv:Q.extensionHostEnv,isTrusted:Q.isTrusted,authenticationSession:Q.authenticationSessionForInitializingExtensions?{id:Q.authenticationSessionForInitializingExtensions.id,providerId:Q.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:Y,options:fe,tunnelInformation:{environmentTunnels:Q.environmentTunnels}}}}catch(Q){if(y.mark(`code/extHost/didResolveAuthorityError/${K}`),Q instanceof l.RemoteAuthorityResolverError)return{type:"error",error:{code:Q._code,message:Q._message,detail:Q._detail}};throw Q}}async $getCanonicalURI(U,V){const{authorityPrefix:K,resolver:G}=await this._activateAndGetResolver(U);if(!G)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${K}`);const Q=I.URI.revive(V);if(typeof G.getCanonicalURI=="undefined")return Q;const Y=await(0,P.asPromise)(()=>G.getCanonicalURI(Q));return Y||Q}$startExtensionHost(U){return this._registry.keepOnly(U),this._startExtensionHost()}$activateByEvent(U,V){return V===1?this._activateByEvent(U,!1):this._readyToRunExtensions.wait().then(K=>this._activateByEvent(U,!1))}async $activate(U,V){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(U)?(await this._activateById(U,V),!0):!1}async $deltaExtensions(U,V){U.forEach(G=>G.extensionLocation=I.URI.revive(G.extensionLocation));const K=await this.getExtensionPathIndex();return await Promise.all(V.map(async G=>{const Q=this._registry.getExtensionDescription(G);Q&&K.delete(await this._realPathExtensionUri(Q.extensionLocation))})),await Promise.all(U.map(async G=>{const Q=await this._realPathExtensionUri(G.extensionLocation);K.set(Q,G)})),this._registry.deltaExtensions(U,V),Promise.resolve(void 0)}async $test_latency(U){return U}async $test_up(U){return U.byteLength}async $test_down(U){let V=s.VSBuffer.alloc(U),K=Math.random()%256;for(let G=0;G<U;G++)V.writeUInt8(K,G);return V}async $updateRemoteConnectionData(U){this._remoteConnectionData=U,this._onDidChangeRemoteConnectionData.fire()}};H=je([ze(0,n.IInstantiationService),ze(1,e.IHostUtils),ze(2,u.IExtHostRpcService),ze(3,p.IExtHostWorkspace),ze(4,c.IExtHostConfiguration),ze(5,L.ILogService),ze(6,t.IExtHostInitDataService),ze(7,r.IExtensionStoragePaths),ze(8,f.IExtHostTunnelService),ze(9,w.IExtHostTerminalService)],H),e.AbstractExtHostExtensionService=H;function M(z,U){return{id:z.identifier.value,name:z.name,extensionVersion:z.version,publisherDisplayName:z.publisher,activationEvents:z.activationEvents?z.activationEvents.join(","):null,isBuiltin:z.isBuiltin,reason:U.activationEvent,reasonId:U.extensionId.value}}e.IExtHostExtensionService=(0,n.createDecorator)("IExtHostExtensionService");class W{constructor(U,V,K,G){F.set(this,void 0),B.set(this,void 0),O.set(this,void 0),nt(this,F,U,"f"),nt(this,B,V,"f"),nt(this,O,K.identifier,"f"),this.id=K.identifier.value,this.extensionUri=K.extensionLocation,this.extensionPath=i.normalize((0,C.originalFSPath)(K.extensionLocation)),this.packageJSON=K,this.extensionKind=G}get isActive(){return Be(this,F,"f").isActivated(Be(this,O,"f"))}get exports(){if(this.packageJSON.api!=="none")return Be(this,F,"f").getExtensionExports(Be(this,O,"f"))}activate(){return Be(this,F,"f").activateByIdWithErrors(Be(this,O,"f"),{startup:!1,extensionId:Be(this,B,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=W,F=new WeakMap,B=new WeakMap,O=new WeakMap}),define(ve[55],we([0,1,9,2,3,18,5,7,123,35,39,45,214,36,207,14,4,13,40,54]),function(J,e,m,i,y,C,P,D,_,I,L,A,c,E,h,p,v,T,b,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,v.createDecorator)("IExtHostDebugService");let s=class{constructor(a,f,w,d,k,R){this._workspaceService=f,this._extensionService=w,this._editorsService=d,this._configurationService=k,this._editorTabs=R,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new y.Emitter,this._onDidTerminateDebugSession=new y.Emitter,this._onDidChangeActiveDebugSession=new y.Emitter,this._onDidReceiveDebugSessionCustomEvent=new y.Emitter,this._debugServiceProxy=a.getProxy(P.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new y.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new l(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(N=>{N.onDidChange(x=>{this.registerAllDebugTypes(N)}),this.registerAllDebugTypes(N)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(a,f){const w=a;if(typeof w.sourceReference=="number"&&w.sourceReference>0){let d=`debug:${encodeURIComponent(w.path||"")}`,k="?";return f&&(d+=`${k}session=${encodeURIComponent(f.id)}`,k="&"),d+=`${k}ref=${w.sourceReference}`,i.URI.parse(d)}else{if(w.path)return i.URI.file(w.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(a){const f=[];for(const w of a.getAllExtensionDescriptions())if(w.contributes){const d=w.contributes.debuggers;if(d&&d.length>0)for(const k of d)(0,h.isDebuggerMainContribution)(k)&&f.push(k.type)}this._debugServiceProxy.$registerDebugTypes(f)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const a=[];return this._breakpoints.forEach(f=>a.push(f)),a}addBreakpoints(a){this.startBreakpoints();const f=a.filter(k=>{const R=k.id;return this._breakpoints.has(R)?!1:(this._breakpoints.set(R,k),!0)});this.fireBreakpointChanges(f,[],[]);const w=[],d=new Map;for(const k of f)if(k instanceof D.SourceBreakpoint){let R=d.get(k.location.uri.toString());R||(R={type:"sourceMulti",uri:k.location.uri,lines:[]},d.set(k.location.uri.toString(),R),w.push(R)),R.lines.push({id:k.id,enabled:k.enabled,condition:k.condition,hitCondition:k.hitCondition,logMessage:k.logMessage,line:k.location.range.start.line,character:k.location.range.start.character})}else k instanceof D.FunctionBreakpoint&&w.push({type:"function",id:k.id,enabled:k.enabled,hitCondition:k.hitCondition,logMessage:k.logMessage,condition:k.condition,functionName:k.functionName});return this._debugServiceProxy.$registerBreakpoints(w)}removeBreakpoints(a){this.startBreakpoints();const f=a.filter(R=>this._breakpoints.delete(R.id));this.fireBreakpointChanges([],f,[]);const w=f.filter(R=>R instanceof D.SourceBreakpoint).map(R=>R.id),d=f.filter(R=>R instanceof D.FunctionBreakpoint).map(R=>R.id),k=f.filter(R=>R instanceof D.DataBreakpoint).map(R=>R.id);return this._debugServiceProxy.$unregisterBreakpoints(w,d,k)}startDebugging(a,f,w){return this._debugServiceProxy.$startDebugging(a?a.uri:void 0,f,{parentSessionID:w.parentSession?w.parentSession.id:void 0,lifecycleManagedByParent:w.lifecycleManagedByParent,repl:w.consoleMode===D.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:w.noDebug,compact:w.compact,debugUI:w.debugUI,suppressSaveBeforeStart:w.suppressSaveBeforeStart})}stopDebugging(a){return this._debugServiceProxy.$stopDebugging(a?a.id:void 0)}registerDebugConfigurationProvider(a,f,w){if(!f)return new D.Disposable(()=>{});const d=this._configProviderHandleCounter++;return this._configProviders.push({type:a,handle:d,provider:f}),this._debugServiceProxy.$registerDebugConfigurationProvider(a,w,!!f.provideDebugConfigurations,!!f.resolveDebugConfiguration,!!f.resolveDebugConfigurationWithSubstitutedVariables,d),new D.Disposable(()=>{this._configProviders=this._configProviders.filter(k=>k.provider!==f),this._debugServiceProxy.$unregisterDebugConfigurationProvider(d)})}registerDebugAdapterDescriptorFactory(a,f,w){if(!w)return new D.Disposable(()=>{});if(!this.definesDebugType(a,f))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${f}' debugger.`);if(this.getAdapterDescriptorFactoryByType(f))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const d=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:f,handle:d,factory:w}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(f,d),new D.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(k=>k.factory!==w),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(d)})}registerDebugAdapterTrackerFactory(a,f){if(!f)return new D.Disposable(()=>{});const w=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:a,handle:w,factory:f}),new D.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(d=>d.factory!==f)})}async $runInTerminal(a,f){return Promise.resolve(void 0)}async $substituteVariables(a,f){if(!this._variableResolver){const[k,R]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(k||[],this._editorsService,R)}let w;const d=await this.getFolder(a);return d&&(w={uri:d.uri,name:d.name,index:d.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(w,f)}createDebugAdapter(a,f){if(a.type==="implementation")return new t(a.implementation)}createSignService(){}async $startDASession(a,f){const w=this,d=await this.getSession(f);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(d.type),d).then(k=>{if(!k)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${d.type}' (extension might have failed to activate)`);const R=this.convertToDto(k),N=this.createDebugAdapter(R,d);if(!N)throw new Error(`Couldn't create a debug adapter for type '${d.type}'.`);const x=N;return this._debugAdapters.set(a,x),this.getDebugAdapterTrackers(d).then(F=>(F&&this._debugAdaptersTrackers.set(a,F),x.onMessage(async B=>{if(B.type==="request"&&B.command==="handshake"){const O=B,H={type:"response",seq:0,command:O.command,request_seq:O.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const M=await this._signService.sign(O.arguments.value);H.body={signature:M},x.sendResponse(H)}else throw new Error("no signer")}catch(M){H.success=!1,H.message=M.message,x.sendResponse(H)}}else F&&F.onDidSendMessage&&F.onDidSendMessage(B),B=(0,h.convertToVSCPaths)(B,!0),w._debugServiceProxy.$acceptDAMessage(a,B)}),x.onError(B=>{F&&F.onError&&F.onError(B),this._debugServiceProxy.$acceptDAError(a,B.name,B.message,B.stack)}),x.onExit(B=>{F&&F.onExit&&F.onExit((0,T.withNullAsUndefined)(B),void 0),this._debugServiceProxy.$acceptDAExit(a,(0,T.withNullAsUndefined)(B),void 0)}),F&&F.onWillStartSession&&F.onWillStartSession(),x.startSession()))})}$sendDAMessage(a,f){f=(0,h.convertToDAPaths)(f,!1);const w=this._debugAdaptersTrackers.get(a);w&&w.onWillReceiveMessage&&w.onWillReceiveMessage(f);const d=this._debugAdapters.get(a);d&&d.sendMessage(f)}$stopDASession(a){const f=this._debugAdaptersTrackers.get(a);this._debugAdaptersTrackers.delete(a),f&&f.onWillStopSession&&f.onWillStopSession();const w=this._debugAdapters.get(a);return this._debugAdapters.delete(a),w?w.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(a){const f=[],w=[],d=[];if(a.added)for(const k of a.added){const R=k.id;if(R&&!this._breakpoints.has(R)){let N;if(k.type==="function")N=new D.FunctionBreakpoint(k.functionName,k.enabled,k.condition,k.hitCondition,k.logMessage);else if(k.type==="data")N=new D.DataBreakpoint(k.label,k.dataId,k.canPersist,k.enabled,k.hitCondition,k.condition,k.logMessage);else{const x=i.URI.revive(k.uri);N=new D.SourceBreakpoint(new D.Location(x,new D.Position(k.line,k.character)),k.enabled,k.condition,k.hitCondition,k.logMessage)}N._id=R,this._breakpoints.set(R,N),f.push(N)}}if(a.removed)for(const k of a.removed){const R=this._breakpoints.get(k);R&&(this._breakpoints.delete(k),w.push(R))}if(a.changed){for(const k of a.changed)if(k.id){const R=this._breakpoints.get(k.id);if(R){if(R instanceof D.FunctionBreakpoint&&k.type==="function"){const N=R;N.enabled=k.enabled,N.condition=k.condition,N.hitCondition=k.hitCondition,N.logMessage=k.logMessage,N.functionName=k.functionName}else if(R instanceof D.SourceBreakpoint&&k.type==="source"){const N=R;N.enabled=k.enabled,N.condition=k.condition,N.hitCondition=k.hitCondition,N.logMessage=k.logMessage,N.location=new D.Location(i.URI.revive(k.uri),new D.Position(k.line,k.character))}d.push(R)}}}this.fireBreakpointChanges(f,w,d)}$provideDebugConfigurations(a,f,w){return(0,C.asPromise)(async()=>{const d=this.getConfigProviderByHandle(a);if(!d)throw new Error("no DebugConfigurationProvider found");if(!d.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const k=await this.getFolder(f);return d.provideDebugConfigurations(k,w)}).then(d=>{if(!d)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return d})}$resolveDebugConfiguration(a,f,w,d){return(0,C.asPromise)(async()=>{const k=this.getConfigProviderByHandle(a);if(!k)throw new Error("no DebugConfigurationProvider found");if(!k.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const R=await this.getFolder(f);return k.resolveDebugConfiguration(R,w,d)})}$resolveDebugConfigurationWithSubstitutedVariables(a,f,w,d){return(0,C.asPromise)(async()=>{const k=this.getConfigProviderByHandle(a);if(!k)throw new Error("no DebugConfigurationProvider found");if(!k.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const R=await this.getFolder(f);return k.resolveDebugConfigurationWithSubstitutedVariables(R,w,d)})}async $provideDebugAdapter(a,f){const w=this.getAdapterDescriptorFactoryByHandle(a);if(!w)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const d=await this.getSession(f);return this.getAdapterDescriptor(w,d).then(k=>{if(!k)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${d.type}'`);return this.convertToDto(k)})}async $acceptDebugSessionStarted(a){const f=await this.getSession(a);this._onDidStartDebugSession.fire(f)}async $acceptDebugSessionTerminated(a){const f=await this.getSession(a);f&&(this._onDidTerminateDebugSession.fire(f),this._debugSessions.delete(f.id))}async $acceptDebugSessionActiveChanged(a){this._activeDebugSession=a?await this.getSession(a):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(a,f){const w=await this.getSession(a);w&&w._acceptNameChanged(f)}async $acceptDebugSessionCustomEvent(a,f){const d={session:await this.getSession(a),event:f.event,body:f.body};this._onDidReceiveDebugSessionCustomEvent.fire(d)}convertToDto(a){if(a instanceof D.DebugAdapterExecutable)return{type:"executable",command:a.command,args:a.args,options:a.options};if(a instanceof D.DebugAdapterServer)return{type:"server",port:a.port,host:a.host};if(a instanceof D.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:a.path};if(a instanceof D.DebugAdapterInlineImplementation)return{type:"implementation",implementation:a.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(a){const f=this._adapterFactories.filter(w=>w.type===a);if(f.length>0)return f[0].factory}getAdapterDescriptorFactoryByHandle(a){const f=this._adapterFactories.filter(w=>w.handle===a);if(f.length>0)return f[0].factory}getConfigProviderByHandle(a){const f=this._configProviders.filter(w=>w.handle===a);if(f.length>0)return f[0].provider}definesDebugType(a,f){if(a.contributes){const w=a.contributes.debuggers;if(w&&w.length>0){for(const d of w)if(d.label&&d.type&&d.type===f)return!0}}return!1}getDebugAdapterTrackers(a){const w=a.configuration.type,d=this._trackerFactories.filter(k=>k.type===w||k.type==="*").map(k=>(0,C.asPromise)(()=>k.factory.createDebugAdapterTracker(a)).then(R=>R,R=>null));return Promise.race([Promise.all(d).then(k=>{const R=k.filter(N=>!!N);if(R.length>0)return new n(R)}),new Promise((k,R)=>{const N=setTimeout(()=>{clearTimeout(N),R(new Error("timeout"))},1e3)})]).catch(k=>{})}async getAdapterDescriptor(a,f){const w=f.configuration.debugServer;if(typeof w=="number")return Promise.resolve(new D.DebugAdapterServer(w));if(a){const k=await this._extensionService.getExtensionRegistry();return(0,C.asPromise)(()=>a.createDebugAdapterDescriptor(f,this.daExecutableFromPackage(f,k))).then(R=>{if(R)return R})}const d=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(f,d))}daExecutableFromPackage(a,f){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(a,f,w){(a.length>0||f.length>0||w.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:a,removed:f,changed:w}))}async getSession(a){if(a)if(typeof a=="string"){const f=this._debugSessions.get(a);if(f)return f}else{let f=this._debugSessions.get(a.id);if(!f){const w=await this.getFolder(a.folderUri),d=a.parent?this._debugSessions.get(a.parent):void 0;f=new g(this._debugServiceProxy,a.id,a.type,a.name,w,a.configuration,d),this._debugSessions.set(f.id,f),this._debugServiceProxy.$sessionCached(f.id)}return f}throw new Error("cannot find session")}getFolder(a){if(a){const f=i.URI.revive(a);return this._workspaceService.resolveWorkspaceFolder(f)}return Promise.resolve(void 0)}};s=je([ze(0,p.IExtHostRpcService),ze(1,I.IExtHostWorkspace),ze(2,L.IExtHostExtensionService),ze(3,A.IExtHostDocumentsAndEditors),ze(4,E.IExtHostConfiguration),ze(5,o.IExtHostEditorTabs)],s),e.ExtHostDebugServiceBase=s;class g{constructor(a,f,w,d,k,R,N){this._debugServiceProxy=a,this._id=f,this._type=w,this._name=d,this._workspaceFolder=k,this._configuration=R,this._parentSession=N}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(a){this._name=a,this._debugServiceProxy.$setDebugSessionName(this._id,a)}get parentSession(){return this._parentSession}_acceptNameChanged(a){this._name=a}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(a,f){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,a,f)}getDebugProtocolBreakpoint(a){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,a.id)}}e.ExtHostDebugSession=g;class l{constructor(a){this.value=Object.freeze({append(f){a.$appendDebugConsole(f)},appendLine(f){this.append(f+`
`)}})}}e.ExtHostDebugConsole=l;class S extends c.AbstractVariableResolverService{constructor(a,f,w,d,k){function R(){if(f){const N=f.activeEditor();if(N)return N.document.uri;const x=d.tabs.filter(F=>F.isActive);if(x.length>0){const F=x[0].resource;return F&&(F.primary||F.secondary)?F.primary??F.secondary:x[0].resource}}}super({getFolderUri:N=>{const x=a.filter(F=>F.name===N);if(x&&x.length>0)return x[0].uri},getWorkspaceFolderCount:()=>a.length,getConfigurationValue:(N,x)=>w.getConfiguration(void 0,N).get(x),getAppRoot:()=>b.cwd(),getExecPath:()=>b.env.VSCODE_EXEC_PATH,getFilePath:()=>{const N=R();if(N)return m.normalize(N.fsPath)},getWorkspaceFolderPathForFile:()=>{if(k){const N=R();if(N){const x=k.getWorkspaceFolder(N);if(x)return m.normalize(x.uri.fsPath)}}},getSelectedText:()=>{if(f){const N=f.activeEditor();if(N&&!N.selection.isEmpty)return N.document.getText(N.selection)}},getLineNumber:()=>{if(f){const N=f.activeEditor();if(N)return String(N.selection.end.line+1)}}},void 0,Promise.resolve(b.env))}}e.ExtHostVariableResolverService=S;class n{constructor(a){this.trackers=a}onWillStartSession(){this.trackers.forEach(a=>a.onWillStartSession?a.onWillStartSession():void 0)}onWillReceiveMessage(a){this.trackers.forEach(f=>f.onWillReceiveMessage?f.onWillReceiveMessage(a):void 0)}onDidSendMessage(a){this.trackers.forEach(f=>f.onDidSendMessage?f.onDidSendMessage(a):void 0)}onWillStopSession(){this.trackers.forEach(a=>a.onWillStopSession?a.onWillStopSession():void 0)}onError(a){this.trackers.forEach(f=>f.onError?f.onError(a):void 0)}onExit(a,f){this.trackers.forEach(w=>w.onExit?w.onExit(a,f):void 0)}}class t extends _.AbstractDebugAdapter{constructor(a){super();this.implementation=a,a.onDidSendMessage(f=>{this.acceptMessage(f)})}startSession(){return Promise.resolve(void 0)}sendMessage(a){this.implementation.handleMessage(a)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let r=class extends s{constructor(a,f,w,d,k,R){super(a,f,w,d,k,R)}createVariableResolver(a,f,w){return new S(a,f,w,this._editorTabs)}};r=je([ze(0,p.IExtHostRpcService),ze(1,I.IExtHostWorkspace),ze(2,L.IExtHostExtensionService),ze(3,A.IExtHostDocumentsAndEditors),ze(4,E.IExtHostConfiguration),ze(5,o.IExtHostEditorTabs)],r),e.WorkerExtHostDebugService=r}),define(ve[268],we([0,1,71,2,5,36,29,27,14,26,4,39,40,11]),function(J,e,m,i,y,C,P,D,_,I,L,A,c,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let h=class{constructor(o,s,g,l,S,n,t){this._apiFactory=o,this._extensionRegistry=s,this._instaService=g,this._extHostConfiguration=l,this._extHostExtensionService=S,this._initData=n,this._logService=t,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),m.mark("code/extHost/willWaitForConfig");const o=await this._extHostConfiguration.getConfigProvider();m.mark("code/extHost/didWaitForConfig");const s=await this._extHostExtensionService.getExtensionPathIndex();this.register(new p(this._apiFactory,s,this._extensionRegistry,o,this._logService)),this.register(this._instaService.createInstance(v,s)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(T,s,this._initData.environment.appUriScheme))}register(o){if(Array.isArray(o.nodeModuleName))for(let s of o.nodeModuleName)this._factories.set(s,o);else this._factories.set(o.nodeModuleName,o);typeof o.alternativeModuleName=="function"&&this._alternatives.push(s=>o.alternativeModuleName(s))}};h=je([ze(2,L.IInstantiationService),ze(3,C.IExtHostConfiguration),ze(4,A.IExtHostExtensionService),ze(5,I.IExtHostInitDataService),ze(6,E.ILogService)],h),e.RequireInterceptor=h;class p{constructor(o,s,g,l,S){this._apiFactory=o,this._extensionPaths=s,this._extensionRegistry=g,this._configProvider=l,this._logService=S,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(o,s){const g=this._extensionPaths.findSubstr(s);if(g){let l=this._extApiImpl.get(D.ExtensionIdentifier.toKey(g.identifier));return l||(l=this._apiFactory(g,this._extensionRegistry,this._configProvider),this._extApiImpl.set(D.ExtensionIdentifier.toKey(g.identifier),l)),l}if(!this._defaultApiImpl){let l="";this._extensionPaths.forEach((S,n)=>l+=`	${n} -> ${S.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${s}. These are the extension path mappings: 
${l}`),this._defaultApiImpl=this._apiFactory(P.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let v=class{constructor(o,s,g){this._extensionPaths=o,this.nodeModuleName="keytar",this._mainThreadTelemetry=s.getProxy(y.MainContext.MainThreadTelemetry);const{environment:l}=g,S=s.getProxy(y.MainContext.MainThreadKeytar);if(l.appRoot){let n=l.appRoot.fsPath;c.platform==="win32"&&(n=n.replace(/\\/g,"/")),n[n.length-1]==="/"&&(n=n.substr(0,n.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${n}/node_modules.asar/keytar`),this.alternativeNames.add(`${n}/node_modules/keytar`)}this._impl={getPassword:(n,t)=>S.$getPassword(n,t),setPassword:(n,t,r)=>S.$setPassword(n,t,r),deletePassword:(n,t)=>S.$deletePassword(n,t),findPassword:n=>S.$findPassword(n),findCredentials(n){return S.$findCredentials(n)}}}load(o,s){const g=this._extensionPaths.findSubstr(s);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:g?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(o){const s=o.length;if(s<=7||!this.alternativeNames)return;const g=s-7;if((o.charAt(g)==="/"||o.charAt(g)==="\\")&&o.endsWith("keytar")&&(o=o.replace(/\\/g,"/"),this.alternativeNames.has(o)))return"keytar"}};v=je([ze(1,_.IExtHostRpcService),ze(2,I.IExtHostInitDataService)],v);let T=class{constructor(o,s,g){this._extensionPaths=o,this._appUriScheme=s,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=g.getProxy(y.MainContext.MainThreadTelemetry);const l=g.getProxy(y.MainContext.MainThreadWindow);this._impl=(S,n)=>{const t=i.URI.parse(S);return n?this.callOriginal(S,n):t.scheme==="http"||t.scheme==="https"?l.$openUri(t,S,{allowTunneling:!0}):t.scheme==="mailto"||t.scheme===this._appUriScheme?l.$openUri(t,S,{}):this.callOriginal(S,n)}}load(o,s,g){const l=this._extensionPaths.findSubstr(s);return l&&(this._extensionId=l.identifier.value,this.sendShimmingTelemetry()),this._original=g(o),this._impl}callOriginal(o,s){return this.sendNoForwardTelemetry(),this._original(o,s)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};T=je([ze(2,_.IExtHostRpcService)],T)}),define(ve[269],we([0,1,169,12,7,208,35,39,45,36,34,14,55,194,18,209,54]),function(J,e,m,i,y,C,P,D,_,I,L,A,c,E,h,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let T=class extends c.ExtHostDebugServiceBase{constructor(s,g,l,S,n,t,r){super(s,g,l,S,n,r);this._terminalService=t,this._integratedTerminalInstances=new b}createDebugAdapter(s,g){switch(s.type){case"server":return new C.SocketDebugAdapter(s);case"pipeServer":return new C.NamedPipeDebugAdapter(s);case"executable":return new C.ExecutableDebugAdapter(s,g.type)}return super.createDebugAdapter(s,g)}daExecutableFromPackage(s,g){const l=C.ExecutableDebugAdapter.platformAdapterExecutable(g.getAllExtensionDescriptions(),s.type);if(l)return new y.DebugAdapterExecutable(l.command,l.args,l.options)}createSignService(){return new E.SignService}async $runInTerminal(s,g){if(s.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(R=>{this._integratedTerminalInstances.onTerminalClosed(R)}));const l=await this._configurationService.getConfigProvider(),S=this._terminalService.getDefaultShell(!0),n=this._terminalService.getDefaultShellArgs(!0),t=s.title||m.localize(0,null),r=JSON.stringify({shell:S,shellArgs:n});let u=await this._integratedTerminalInstances.checkout(r,t),a,f=!1;if(u)a=s.cwd;else{const R={shellPath:S,shellArgs:n,cwd:s.cwd,name:t,iconPath:new y.ThemeIcon("debug")};f=!0,u=this._terminalService.createTerminalFromOptions(R,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(u,r)}u.show(!0);const w=await u.processId;f?await new Promise(R=>setTimeout(R,1e3)):l.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(S.indexOf("powershell")>=0||S.indexOf("pwsh")>=0||S.indexOf("cmd.exe")>=0?u.sendText("cls"):S.indexOf("bash")>=0?u.sendText("clear"):i.isWindows?u.sendText("cls"):u.sendText("clear"));const d=(0,p.prepareCommand)(S,s.args,a,s.env);u.sendText(d);const k=this.onDidTerminateDebugSession(R=>{R.id===g&&(this._integratedTerminalInstances.free(u),k.dispose())});return w}else if(s.kind==="external")return(0,p.runInExternalTerminal)(s,await this._configurationService.getConfigProvider());return super.$runInTerminal(s,g)}createVariableResolver(s,g,l){return new c.ExtHostVariableResolverService(s,g,l,this._editorTabs,this._workspaceService)}};T=je([ze(0,A.IExtHostRpcService),ze(1,P.IExtHostWorkspace),ze(2,D.IExtHostExtensionService),ze(3,_.IExtHostDocumentsAndEditors),ze(4,I.IExtHostConfiguration),ze(5,L.IExtHostTerminalService),ze(6,v.IExtHostEditorTabs)],T),e.ExtHostDebugService=T;class b{constructor(){this._terminalInstances=new Map}async checkout(s,g){const S=[...this._terminalInstances.entries()].map(([n,t])=>(0,h.createCancelablePromise)(async r=>{if(n.name!==g||t.lastUsedAt!==-1&&await(0,p.hasChildProcesses)(await n.processId))return null;const u=Date.now();return t.lastUsedAt+b.minUseDelay>u||r.isCancellationRequested||t.config!==s?null:(t.lastUsedAt=u,n)}));return await(0,h.firstParallel)(S,n=>!!n)}insert(s,g){this._terminalInstances.set(s,{lastUsedAt:Date.now(),config:g})}free(s){const g=this._terminalInstances.get(s);g&&(g.lastUsedAt=-1)}onTerminalClosed(s){this._terminalInstances.delete(s)}}b.minUseDelay=1e3}),define(ve[270],we([0,1,9,2,112,35,55,45,36,43,34,14,26,70,10,11,65,54,23,81]),function(J,e,m,i,y,C,P,D,_,I,L,A,c,E,h,p,v,T,b,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let s=class extends E.ExtHostTaskBase{constructor(l,S,n,t,r,u,a,f,w){super(l,S,n,t,r,u,a,f);this.workspaceService=n,this.editorTabs=w,S.remote.isRemote&&S.remote.authority?this.registerTaskSystem(h.Schemas.vscodeRemote,{scheme:h.Schemas.vscodeRemote,authority:S.remote.authority,platform:process.platform}):this.registerTaskSystem(h.Schemas.file,{scheme:h.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(l,S){const n=S;if(!S.execution&&n._id===void 0)throw new Error("Tasks to execute must include an execution");if(n._id!==void 0){const t=E.TaskHandleDTO.from(n,this.workspaceService),r=await this._proxy.$getTaskExecution(t);if(r.task===void 0)throw new Error("Task from execution DTO is undefined");const u=await this.getTaskExecution(r,S);return this._proxy.$executeTask(t).catch(()=>{}),u}else{const t=E.TaskDTO.from(S,l);if(t===void 0)return Promise.reject(new Error("Task is not valid"));E.CustomExecutionDTO.is(t.execution)&&await this.addCustomExecution(t,S,!1);const r=await this.getTaskExecution(await this._proxy.$getTaskExecution(t),S);return this._proxy.$executeTask(t).catch(()=>{}),r}}provideTasksInternal(l,S,n,t){const r=[];if(t)for(let u of t){this.checkDeprecation(u,n),(!u.definition||!l[u.definition.type])&&this._logService.warn(`The task [${u.source}, ${u.name}] uses an undefined task type. The task will be ignored in the future.`);const a=E.TaskDTO.from(u,n.extension);a&&(r.push(a),E.CustomExecutionDTO.is(a.execution)&&S.push(this.addCustomExecution(a,u,!0)))}return{tasks:r,extension:n.extension}}async resolveTaskInternal(l){return l}async getVariableResolver(l){if(this._variableResolver===void 0){const S=await this._configurationService.getConfigProvider();this._variableResolver=new P.ExtHostVariableResolverService(l,this._editorService,S,this.editorTabs,this.workspaceService)}return this._variableResolver}async getAFolder(l){let S=l&&l.length>0?l[0]:void 0;if(!S){const n=i.URI.file((0,o.homedir)());S=new I.WorkspaceFolder({uri:n,name:b.basename(n),index:0})}return{uri:S.uri,name:S.name,index:S.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(l,S){const n=i.URI.revive(l),t={process:void 0,variables:Object.create(null)},r=await this._workspaceProvider.resolveWorkspaceFolder(n),u=await this._workspaceProvider.getWorkspaceFolders2()??[],a=await this.getVariableResolver(u),f=r?{uri:r.uri,name:r.name,index:r.index,toResource:()=>{throw new Error("Not implemented")}}:await this.getAFolder(u);for(let w of S.variables)t.variables[w]=await a.resolveAsync(f,w);if(S.process!==void 0){let w;if(S.process.path!==void 0){w=S.process.path.split(m.delimiter);for(let d=0;d<w.length;d++)w[d]=await a.resolveAsync(f,w[d])}t.process=await y.win32.findExecutable(await a.resolveAsync(f,S.process.name),S.process.cwd!==void 0?await a.resolveAsync(f,S.process.cwd):void 0,w)}return t}async $jsonTasksSupported(){return!0}async $findExecutable(l,S,n){return y.win32.findExecutable(l,S,n)}};s=je([ze(0,A.IExtHostRpcService),ze(1,c.IExtHostInitDataService),ze(2,C.IExtHostWorkspace),ze(3,D.IExtHostDocumentsAndEditors),ze(4,_.IExtHostConfiguration),ze(5,L.IExtHostTerminalService),ze(6,p.ILogService),ze(7,v.IExtHostApiDeprecationService),ze(8,T.IExtHostEditorTabs)],s),e.ExtHostTask=s}),define(ve[271],we([0,1,18,15,71,6,2,5,263,11,83,85,26,186,14,64,39,34]),function(J,e,m,i,y,C,P,D,_,I,L,A,c,E,h,p,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class b{constructor(s,g,l,S){this._disposables=new C.DisposableStore,this._isTerminating=!1,this._hostUtils=l,this._rpcProtocol=new _.RPCProtocol(s,null,S),g=b._transform(g,this._rpcProtocol);const n=new A.ServiceCollection(...(0,L.getSingletonServiceDescriptors)());n.set(c.IExtHostInitDataService,{_serviceBrand:void 0,...g}),n.set(h.IExtHostRpcService,new h.ExtHostRpcService(this._rpcProtocol)),n.set(p.IURITransformerService,new p.URITransformerService(S)),n.set(v.IHostUtils,l);const t=new E.InstantiationService(n,!0);this._disposables.add(t.invokeFunction(f=>f.get(T.IExtHostTerminalService))),this._disposables.add(t.invokeFunction(f=>f.get(v.IExtHostExtensionService))),this._logService=t.invokeFunction(f=>f.get(I.ILogService)),y.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",g),this._extensionService=t.invokeFunction(f=>f.get(v.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const r=new WeakMap;this._extensionService.getExtensionPathIndex().then(f=>{Error.prepareStackTrace=(w,d)=>{let k="",R,N;for(const x of d)k+=`
	at ${x.toString()}`,N=x.getFileName(),!R&&N&&(R=f.findSubstr(P.URI.file(N)));return r.set(w,R),`${w.name||"Error"}: ${w.message||""}${k}`}});const u=this._rpcProtocol.getProxy(D.MainContext.MainThreadExtensionService),a=this._rpcProtocol.getProxy(D.MainContext.MainThreadErrors);i.setUnexpectedErrorHandler(f=>{const w=i.transformErrorForSerialization(f),d=r.get(f);d?u.$onExtensionRuntimeError(d.identifier,w):a.$onUnexpectedError(w)})}terminate(s){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${s}`),this._logService.flush(),this._disposables.dispose(),i.setUnexpectedErrorHandler(l=>{this._logService.error(l)}),this._rpcProtocol.dispose();const g=this._extensionService.deactivateAll();Promise.race([(0,m.timeout)(5e3),g]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code 0`):this._logService.info("Extension host exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})}static _transform(s,g){s.extensions.forEach(S=>S.extensionLocation=P.URI.revive(g.transformIncomingURIs(S.extensionLocation))),s.environment.appRoot=P.URI.revive(g.transformIncomingURIs(s.environment.appRoot));const l=s.environment.extensionDevelopmentLocationURI;return l&&(s.environment.extensionDevelopmentLocationURI=l.map(S=>P.URI.revive(g.transformIncomingURIs(S)))),s.environment.extensionTestsLocationURI=P.URI.revive(g.transformIncomingURIs(s.environment.extensionTestsLocationURI)),s.environment.globalStorageHome=P.URI.revive(g.transformIncomingURIs(s.environment.globalStorageHome)),s.environment.workspaceStorageHome=P.URI.revive(g.transformIncomingURIs(s.environment.workspaceStorageHome)),s.logsLocation=P.URI.revive(g.transformIncomingURIs(s.logsLocation)),s.logFile=P.URI.revive(g.transformIncomingURIs(s.logFile)),s.workspace=g.transformIncomingURIs(s.workspace),s}}e.ExtensionHostMain=b}),define(ve[272],we([0,1,9,21,50,31,23,46,33]),function(J,e,m,i,y,C,P,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class I{constructor(c,E,h){this.config=c,this.provider=E,this.sessionToken=h,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=c.filePattern,this.includePattern=c.includePattern&&C.parse(c.includePattern),this.maxResults=c.maxResults||void 0,this.exists=c.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=c.excludePattern&&C.parse(c.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(c=>c.cancel()),this.activeCancellationTokens=new Set}search(c){const E=this.config.folderQueries||[];return new Promise((h,p)=>{const v=T=>{this.resultCount++,c(T)};if(this.isCanceled)return h({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(T=>{const b=T.toString(),o=m.basename(b);this.globalExcludePattern&&this.globalExcludePattern(b,o)||this.matchFile(v,{base:T,basename:o})}),Promise.all(E.map(T=>this.searchInFolder(T,v))).then(T=>{h({limitHit:this.isLimitHit,stats:T[0]||void 0})},T=>{p(new Error((0,y.toErrorMessage)(T)))})})}async searchInFolder(c,E){const h=new i.CancellationTokenSource,p=this.getSearchOptionsForFolder(c),v=this.initDirectoryTree(),T=new _.QueryGlobTester(this.config,c),b=!T.hasSiblingExcludeClauses();let o;try{this.activeCancellationTokens.add(h),o=D.StopWatch.create();const s=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},p,h.token),g=o.elapsed(),l=D.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(s&&s.forEach(S=>{const n=m.posix.relative(c.folder.path,S.path);if(b){const t=m.basename(S.path);this.matchFile(E,{base:c.folder,relativePath:n,basename:t});return}this.addDirectoryEntries(v,c.folder,n,E)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(v,T,E),{providerTime:g,postProcessTime:l.elapsed()})}finally{h.dispose(),this.activeCancellationTokens.delete(h)}}getSearchOptionsForFolder(c){const E=(0,_.resolvePatternsForProvider)(this.config.includePattern,c.includePattern),h=(0,_.resolvePatternsForProvider)(this.config.excludePattern,c.excludePattern);return{folder:c.folder,excludes:h,includes:E,useIgnoreFiles:!c.disregardIgnoreFiles,useGlobalIgnoreFiles:!c.disregardGlobalIgnoreFiles,followSymlinks:!c.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const c={rootEntries:[],pathToEntries:Object.create(null)};return c.pathToEntries["."]=c.rootEntries,c}addDirectoryEntries({pathToEntries:c},E,h,p){if(h===this.filePattern){const T=m.basename(this.filePattern);this.matchFile(p,{base:E,relativePath:this.filePattern,basename:T})}function v(T){const b=m.basename(T),o=m.dirname(T);let s=c[o];s||(s=c[o]=[],v(o)),s.push({base:E,relativePath:T,basename:b})}v(h)}matchDirectoryTree({rootEntries:c,pathToEntries:E},h,p){const v=this,T=this.filePattern;function b(o){const s=C.hasSiblingFn(()=>o.map(g=>g.basename));for(let g=0,l=o.length;g<l;g++){const S=o[g],{relativePath:n,basename:t}=S;if(h.matchesExcludesSync(n,t,T!==t?s:void 0))continue;const r=E[n];if(r)b(r);else{if(n===T)continue;v.matchFile(p,S)}if(v.isLimitHit)break}}b(c)}matchFile(c,E){(!this.includePattern||E.relativePath&&this.includePattern(E.relativePath,E.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||c(E))}}class L{constructor(){this.sessions=new Map}fileSearch(c,E,h,p){const v=this.getSessionTokenSource(c.cacheKey),T=new I(c,E,v&&v.token);let b=0;const o=s=>{b+=s.length,h(s.map(g=>this.rawMatchToSearchItem(g)))};return this.doSearch(T,L.BATCH_SIZE,o,p).then(s=>({limitHit:s.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:b,detailStats:s.stats}}))}clearCache(c){const E=this.getSessionTokenSource(c);E&&E.cancel()}getSessionTokenSource(c){if(!!c)return this.sessions.has(c)||this.sessions.set(c,new i.CancellationTokenSource),this.sessions.get(c)}rawMatchToSearchItem(c){return c.relativePath?{resource:P.joinPath(c.base,c.relativePath)}:{resource:c.base}}doSearch(c,E,h,p){p.onCancellationRequested(()=>{c.cancel()});const v=b=>{b&&(T.push(b),E>0&&T.length>=E&&(h(T),T=[]))};let T=[];return c.search(v).then(b=>(T.length&&h(T),b),b=>(T.length&&h(T),Promise.reject(b)))}}e.FileSearchManager=L,L.BATCH_SIZE=512}),define(ve[134],we([0,1,16,21,50,31,10,9,23,13,2,33]),function(J,e,m,i,y,C,P,D,_,I,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class c{constructor(o,s,g,l){this.query=o,this.provider=s,this.fileUtils=g,this.processType=l,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(o,s){const g=this.query.folderQueries||[],l=new i.CancellationTokenSource;return s.onCancellationRequested(()=>l.cancel()),new Promise((S,n)=>{this.collector=new h(o);let t=!1;const r=(u,a)=>{if(!t&&!this.isLimitHit){const f=this.resultSize(u);v(u)&&typeof this.query.maxResults=="number"&&this.resultCount+f>this.query.maxResults&&(this.isLimitHit=!0,t=!0,l.cancel(),u=this.trimResultToSize(u,this.query.maxResults-this.resultCount));const w=this.resultSize(u);this.resultCount+=w,(w>0||!v(u))&&this.collector.add(u,a)}};Promise.all(g.map((u,a)=>this.searchInFolder(u,f=>r(f,a),l.token))).then(u=>{l.dispose(),this.collector.flush();const a=u.some(f=>!!f&&!!f.limitHit);S({limitHit:this.isLimitHit||a,messages:(0,m.flatten)(u.map(f=>f?.message?(0,I.isArray)(f.message)?f.message:[f.message]:[])),stats:{type:this.processType}})},u=>{l.dispose();const a=(0,y.toErrorMessage)(u);n(new Error(a))})})}resultSize(o){return v(o)?Array.isArray(o.ranges)?o.ranges.length:1:0}trimResultToSize(o,s){const g=Array.isArray(o.ranges)?o.ranges:[o.ranges],l=Array.isArray(o.preview.matches)?o.preview.matches:[o.preview.matches];return{ranges:g.slice(0,s),preview:{matches:l.slice(0,s),text:o.preview.text},uri:o.uri}}async searchInFolder(o,s,g){const l=new A.QueryGlobTester(this.query,o),S=[],n={report:u=>{if(!this.validateProviderResult(u))return;const a=o.folder.scheme===P.Schemas.file?C.hasSiblingPromiseFn(()=>this.fileUtils.readdir(_.dirname(u.uri))):void 0,f=_.relativePath(o.folder,u.uri);if(f){const w=l.includedInQuery(f,D.basename(f),a);(0,I.isPromise)(w)?S.push(w.then(d=>{d&&s(u)})):w&&s(u)}}},t=this.getSearchOptionsForFolder(o),r=await this.provider.provideTextSearchResults(E(this.query.contentPattern),t,n,g);return S.length&&await Promise.all(S),r}validateProviderResult(o){if(v(o)){if(Array.isArray(o.ranges)){if(!Array.isArray(o.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(o.preview.matches.length!==o.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(o.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(o){const s=(0,A.resolvePatternsForProvider)(this.query.includePattern,o.includePattern),g=(0,A.resolvePatternsForProvider)(this.query.excludePattern,o.excludePattern),l={folder:L.URI.from(o.folder),excludes:g,includes:s,useIgnoreFiles:!o.disregardIgnoreFiles,useGlobalIgnoreFiles:!o.disregardGlobalIgnoreFiles,followSymlinks:!o.ignoreSymlinks,encoding:o.fileEncoding&&this.fileUtils.toCanonicalName(o.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return l.usePCRE2=this.query.usePCRE2,l}}e.TextSearchManager=c;function E(b){return{isCaseSensitive:b.isCaseSensitive||!1,isRegExp:b.isRegExp||!1,isWordMatch:b.isWordMatch||!1,isMultiline:b.isMultiline||!1,pattern:b.pattern}}class h{constructor(o){this._onResult=o,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new T(512,s=>this.sendItems(s))}add(o,s){this._currentFileMatch&&(this._currentFolderIdx!==s||!_.isEqual(this._currentUri,o.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=s,this._currentFileMatch={resource:o.uri,results:[]}),this._currentFileMatch.results.push(p(o))}pushToCollector(){const o=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,o)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(o){this._onResult(o)}}e.TextSearchResultsCollector=h;function p(b){return v(b)?{preview:{matches:(0,m.mapArrayOrNot)(b.preview.matches,o=>({startLineNumber:o.start.line,startColumn:o.start.character,endLineNumber:o.end.line,endColumn:o.end.character})),text:b.preview.text},ranges:(0,m.mapArrayOrNot)(b.ranges,o=>({startLineNumber:o.start.line,startColumn:o.start.character,endLineNumber:o.end.line,endColumn:o.end.character}))}:{text:b.text,lineNumber:b.lineNumber}}function v(b){return!!b.preview}e.extensionResultIsMatch=v;class T{constructor(o,s){this.maxBatchSize=o,this.cb=s,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(o,s){!o||this.addItemToBatch(o,s)}addItems(o,s){!o||this.addItemsToBatch(o,s)}addItemToBatch(o,s){this.batch.push(o),this.batchSize+=s,this.onUpdate()}addItemsToBatch(o,s){this.batch=this.batch.concat(o),this.batchSize+=s,this.onUpdate()}onUpdate(){this.totalNumberCompleted<T.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},T.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=T,T.TIMEOUT=4e3,T.START_BATCH_AFTER_COUNT=50}),define(ve[72],we([0,1,6,5,4,272,14,64,11,2,134]),function(J,e,m,i,y,C,P,D,_,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,y.createDecorator)("IExtHostSearch");let A=class{constructor(p,v,T){this.extHostRpc=p,this._uriTransformer=v,this._logService=T,this._proxy=this.extHostRpc.getProxy(i.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new C.FileSearchManager}_transformScheme(p){return this._uriTransformer.transformOutgoingScheme(p)}registerTextSearchProvider(p,v){if(this._textSearchUsedSchemes.has(p))throw new Error(`a text search provider for the scheme '${p}' is already registered`);this._textSearchUsedSchemes.add(p);const T=this._handlePool++;return this._textSearchProvider.set(T,v),this._proxy.$registerTextSearchProvider(T,this._transformScheme(p)),(0,m.toDisposable)(()=>{this._textSearchUsedSchemes.delete(p),this._textSearchProvider.delete(T),this._proxy.$unregisterProvider(T)})}registerFileSearchProvider(p,v){if(this._fileSearchUsedSchemes.has(p))throw new Error(`a file search provider for the scheme '${p}' is already registered`);this._fileSearchUsedSchemes.add(p);const T=this._handlePool++;return this._fileSearchProvider.set(T,v),this._proxy.$registerFileSearchProvider(T,this._transformScheme(p)),(0,m.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(p),this._fileSearchProvider.delete(T),this._proxy.$unregisterProvider(T)})}$provideFileSearchResults(p,v,T,b){const o=c(T),s=this._fileSearchProvider.get(p);if(s)return this._fileSearchManager.fileSearch(o,s,g=>{this._proxy.$handleFileMatch(p,v,g.map(l=>l.resource))},b);throw new Error("unknown provider: "+p)}$clearCache(p){return this._fileSearchManager.clearCache(p),Promise.resolve(void 0)}$provideTextSearchResults(p,v,T,b){const o=this._textSearchProvider.get(p);if(!o||!o.provideTextSearchResults)throw new Error(`Unknown provider ${p}`);const s=c(T);return this.createTextSearchManager(s,o).search(l=>this._proxy.$handleTextMatch(p,v,l),b)}$enableExtensionHostSearch(){}createTextSearchManager(p,v){return new L.TextSearchManager(p,v,{readdir:T=>Promise.resolve([]),toCanonicalName:T=>T},"textSearchProvider")}};A=je([ze(0,P.IExtHostRpcService),ze(1,D.IURITransformerService),ze(2,_.ILogService)],A),e.ExtHostSearch=A;function c(h){return{...h,folderQueries:h.folderQueries&&h.folderQueries.map(E),extraFileResources:h.extraFileResources&&h.extraFileResources.map(p=>I.URI.revive(p))}}e.reviveQuery=c;function E(h){return{...h,folder:I.URI.revive(h.folder)}}}),define(ve[273],we([0,1,21,15,3,48,2,113,108,146,82,42,5,231,230,38,232,36,233,234,235,216,236,45,39,237,217,240,241,242,132,219,247,248,249,91,34,251,220,17,7,254,68,133,35,74,205,239,62,130,70,55,72,11,64,14,26,243,202,52,65,228,252,201,67,66,257,255,256,229,44,250,253,90,54,121,245,69,246,10,189,244,199,238,6,29]),function(J,e,m,i,y,C,P,D,_,I,L,A,c,E,h,p,v,T,b,o,s,g,l,S,n,t,r,u,a,f,w,d,k,R,N,x,F,B,O,H,M,W,z,U,V,K,G,Q,Y,fe,me,_e,Ie,Oe,We,j,Z,re,ue,te,oe,Ee,Ne,Ve,Ge,Je,tt,ot,et,it,lt,pt,Pt,xe,Rt,ee,ne,pe,ie,Se,Fe,Ue,Xe,Ae,Pe,ye){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function ce(de){const be=de.get(Z.IExtHostInitDataService),Ce=de.get(lt.IExtHostFileSystemInfo),Me=de.get(Je.IExtHostConsumerFileSystem),Ke=de.get(n.IExtHostExtensionService),He=de.get(V.IExtHostWorkspace),Qe=de.get(ee.IExtHostTelemetry),st=de.get(T.IExtHostConfiguration),at=de.get(We.IURITransformerService),he=de.get(j.IExtHostRpcService),De=de.get(x.IExtHostStorage),le=de.get(Ge.IExtensionStoragePaths),X=de.get(Oe.ILoggerService),ke=de.get(Oe.ILogService),Le=de.get(te.IExtHostTunnelService),Ze=de.get(oe.IExtHostApiDeprecationService),qe=de.get(U.IExtHostWindow),dt=de.get(xe.IExtHostSecretState),wt=de.get(Rt.IExtHostEditorTabs);he.set(c.ExtHostContext.ExtHostFileSystemInfo,Ce),he.set(c.ExtHostContext.ExtHostLogLevelServiceShape,X),he.set(c.ExtHostContext.ExtHostWorkspace,He),he.set(c.ExtHostContext.ExtHostConfiguration,st),he.set(c.ExtHostContext.ExtHostExtensionService,Ke),he.set(c.ExtHostContext.ExtHostStorage,De),he.set(c.ExtHostContext.ExtHostTunnelService,Le),he.set(c.ExtHostContext.ExtHostWindow,qe),he.set(c.ExtHostContext.ExtHostSecretState,dt),he.set(c.ExtHostContext.ExtHostTelemetry,Qe),he.set(c.ExtHostContext.ExtHostEditorTabs,wt);const yt=he.set(c.ExtHostContext.ExtHostDecorations,de.get(fe.IExtHostDecorations)),bt=he.set(c.ExtHostContext.ExtHostDocumentsAndEditors,de.get(S.IExtHostDocumentsAndEditors)),ft=he.set(c.ExtHostContext.ExtHostCommands,de.get(p.IExtHostCommands)),vt=he.set(c.ExtHostContext.ExtHostTerminalService,de.get(F.IExtHostTerminalService)),_t=he.set(c.ExtHostContext.ExtHostDebugService,de.get(_e.IExtHostDebugService)),Ot=he.set(c.ExtHostContext.ExtHostSearch,de.get(Ie.IExtHostSearch)),It=he.set(c.ExtHostContext.ExtHostTask,de.get(me.IExtHostTask)),Tt=he.set(c.ExtHostContext.ExtHostOutputService,de.get(w.IExtHostOutputService)),Lt=he.set(c.ExtHostContext.ExtHostUrls,new W.ExtHostUrls(he)),St=he.set(c.ExtHostContext.ExtHostDocuments,new l.ExtHostDocuments(he,bt)),Mt=he.set(c.ExtHostContext.ExtHostDocumentContentProviders,new s.ExtHostDocumentContentProvider(he,bt,ke)),Nt=he.set(c.ExtHostContext.ExtHostDocumentSaveParticipant,new g.ExtHostDocumentSaveParticipant(ke,St,he.getProxy(c.MainContext.MainThreadBulkEdits))),Et=he.set(c.ExtHostContext.ExtHostNotebook,new re.ExtHostNotebookController(he,ft,bt,St,le)),Wt=he.set(c.ExtHostContext.ExtHostNotebookDocuments,new Xe.ExtHostNotebookDocuments(ke,Et)),jt=he.set(c.ExtHostContext.ExtHostNotebookEditors,new Ue.ExtHostNotebookEditors(ke,he,Et)),si=he.set(c.ExtHostContext.ExtHostNotebookKernels,new ne.ExtHostNotebookKernels(he,be,Et,ft,ke)),oi=he.set(c.ExtHostContext.ExtHostNotebookRenderers,new ie.ExtHostNotebookRenderers(he,Et)),At=he.set(c.ExtHostContext.ExtHostEditors,new B.ExtHostEditors(he,bt)),Xt=he.set(c.ExtHostContext.ExtHostTreeViews,new O.ExtHostTreeViews(he.getProxy(c.MainContext.MainThreadTreeViews),ft,ke)),ai=he.set(c.ExtHostContext.ExtHostEditorInsets,new G.ExtHostEditorInsets(he.getProxy(c.MainContext.MainThreadEditorInsets),At,be)),Yt=he.set(c.ExtHostContext.ExtHostDiagnostics,new b.ExtHostDiagnostics(he,ke,Ce)),Vt=he.set(c.ExtHostContext.ExtHostLanguages,new a.ExtHostLanguages(he,St,ft.converter,at)),gt=he.set(c.ExtHostContext.ExtHostLanguageFeatures,new u.ExtHostLanguageFeatures(he,at,St,ft,Yt,ke,Ze)),li=he.set(c.ExtHostContext.ExtHostFileSystem,new t.ExtHostFileSystem(he,gt)),Ut=he.set(c.ExtHostContext.ExtHostFileSystemEventService,new r.ExtHostFileSystemEventService(he,ke,bt)),qt=he.set(c.ExtHostContext.ExtHostQuickOpen,(0,k.createExtHostQuickOpen)(he,He,ft)),Jt=he.set(c.ExtHostContext.ExtHostSCM,new R.ExtHostSCM(he,ft,ke)),ci=he.set(c.ExtHostContext.ExtHostComments,(0,v.createExtHostComments)(he,ft,St)),fi=he.set(c.ExtHostContext.ExtHostProgress,new d.ExtHostProgress(he.getProxy(c.MainContext.MainThreadProgress))),Ei=he.set(c.ExtHostContext.ExtHosLabelService,new Q.ExtHostLabelService(he)),mi=he.set(c.ExtHostContext.ExtHostTheming,new ue.ExtHostTheming(he)),Zt=he.set(c.ExtHostContext.ExtHostAuthentication,new Ee.ExtHostAuthentication(he)),Si=he.set(c.ExtHostContext.ExtHostTimeline,new Ne.ExtHostTimeline(he,ft)),Gt=he.set(c.ExtHostContext.ExtHostWebviews,new z.ExtHostWebviews(he,{remote:be.remote},He,ke,Ze)),Kt=he.set(c.ExtHostContext.ExtHostWebviewPanels,new et.ExtHostWebviewPanels(he,Gt,He)),_i=he.set(c.ExtHostContext.ExtHostCustomEditors,new ot.ExtHostCustomEditors(he,St,le,Gt,Kt)),Ci=he.set(c.ExtHostContext.ExtHostWebviewViews,new tt.ExtHostWebviewViews(he,Gt)),Qt=he.set(c.ExtHostContext.ExtHostTesting,new pt.ExtHostTesting(he,ft)),yi=he.set(c.ExtHostContext.ExtHostUriOpeners,new Pt.ExtHostUriOpeners(he));he.set(c.ExtHostContext.ExtHostInteractive,new Ae.ExtHostInteractive(he,Et,bt,ft));const ei=(0,K.values)(c.ExtHostContext);he.assertRegistered(ei);const Di=new it.ExtHostBulkEdits(he,bt),ki=new h.ExtHostClipboard(he),ui=new f.ExtHostMessageService(he,ke),ti=new o.ExtHostDialogs(he),gi=new N.ExtHostStatusBar(he,ft.converter);return E.ExtHostApiCommands.register(ft),function($e,Bt,pi){const mt=function(){let se=!$e.isUnderDevelopment;function ge(){se||(ke.info(`Extension '${$e.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),se=!0)}return function Re(ut){if(Array.isArray(ut))ut.forEach(Re);else if(typeof ut=="string")ge();else{const Ct=ut;typeof Ct.scheme=="undefined"&&ge(),typeof Ct.exclusive=="boolean"&&(0,ye.checkProposedApiEnabled)($e,"documentFiltersExclusive")}return ut}}(),ii={getSession(se,ge,Re){return Zt.getSession($e,se,ge,Re)},async hasSession(se,ge){return(0,ye.checkProposedApiEnabled)($e,"authSession"),!!await Zt.getSession($e,se,ge,{silent:!0})},get onDidChangeSessions(){return Zt.onDidChangeSessions},registerAuthenticationProvider(se,ge,Re,ut){return Zt.registerAuthenticationProvider(se,ge,Re,ut)}},Ii={registerCommand(se,ge,Re){return ft.registerCommand(!0,se,ge,Re,void 0,$e)},registerTextEditorCommand(se,ge,Re){return ft.registerCommand(!0,se,(...ut)=>{const Ct=At.getActiveTextEditor();if(!Ct){ke.warn("Cannot execute "+se+" because there is no active text editor.");return}return Ct.edit(Dt=>{ge.apply(Re,[Ct,Dt,...ut])}).then(Dt=>{Dt||ke.warn("Edits from command "+se+" were not applied.")},Dt=>{ke.warn("An error occurred while running command "+se,Dt)})},void 0,void 0,$e)},registerDiffInformationCommand:(se,ge,Re)=>((0,ye.checkProposedApiEnabled)($e,"diffCommand"),ft.registerCommand(!0,se,async(...ut)=>{const Ct=bt.activeEditor(!0);if(!Ct){ke.warn("Cannot execute "+se+" because there is no active text editor.");return}const Dt=await At.getDiffInformation(Ct.id);ge.apply(Re,[Dt,...ut])},void 0,void 0,$e)),executeCommand(se,...ge){return ft.executeCommand(se,...ge)},getCommands(se=!1){return ft.getCommands(se)}},vi={get machineId(){return be.telemetryInfo.machineId},get sessionId(){return be.telemetryInfo.sessionId},get language(){return be.environment.appLanguage},get appName(){return be.environment.appName},get appRoot(){return be.environment.appRoot?.fsPath??""},get appHost(){return be.environment.appHost},get uriScheme(){return be.environment.appUriScheme},get clipboard(){return ki.value},get shell(){return vt.getDefaultShell(!1)},get isTelemetryEnabled(){return Qe.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return Qe.onDidChangeTelemetryEnabled},get isNewAppInstall(){const se=Date.now()-new Date(be.telemetryInfo.firstSessionDate).getTime();return isNaN(se)?!1:se<1e3*60*60*24},openExternal(se,ge){return qe.openUri(se,{allowTunneling:!!be.remote.authority,allowContributedOpeners:ge?.allowContributedOpeners})},async asExternalUri(se){if(se.scheme===be.environment.appUriScheme)return Lt.createAppUri(se);try{return await qe.asExternalUri(se,{allowTunneling:!!be.remote.authority})}catch(ge){if((0,Fe.matchesScheme)(se,Se.Schemas.http)||(0,Fe.matchesScheme)(se,Se.Schemas.https))return se;throw ge}},get remoteName(){return(0,Y.getRemoteName)(be.remote.authority)},get remoteAuthority(){return(0,ye.checkProposedApiEnabled)($e,"resolvers"),be.remote.authority},get uiKind(){return be.uiKind}};be.environment.extensionTestsLocationURI||Object.freeze(vi);const wi=be.remote.isRemote?M.ExtensionKind.Workspace:M.ExtensionKind.UI,Pi={createTestController(se,ge){return Qt.createTestController(se,ge)},createTestObserver(){return(0,ye.checkProposedApiEnabled)($e,"testObserver"),Qt.createTestObserver()},runTests(se){return(0,ye.checkProposedApiEnabled)($e,"testObserver"),Qt.runTests(se)},get onDidChangeTestResults(){return(0,ye.checkProposedApiEnabled)($e,"testObserver"),Qt.onResultsChanged},get testResults(){return(0,ye.checkProposedApiEnabled)($e,"testObserver"),Qt.results}},Ti={getExtension(se){const ge=Bt.getExtensionDescription(se);if(ge)return new n.Extension(Ke,$e.identifier,ge,wi)},get all(){return Bt.getAllExtensionDescriptions().map(se=>new n.Extension(Ke,$e.identifier,se,wi))},get onDidChange(){return Bt.onDidChange}},Ai={createDiagnosticCollection(se){return Yt.createDiagnosticCollection($e.identifier,se)},get onDidChangeDiagnostics(){return Yt.onDidChangeDiagnostics},getDiagnostics:se=>Yt.getDiagnostics(se),getLanguages(){return Vt.getLanguages()},setTextDocumentLanguage(se,ge){return Vt.changeLanguage(se.uri,ge)},match(se,ge){return(0,L.score)(H.LanguageSelector.from(se),ge.uri,ge.languageId,!0)},registerCodeActionsProvider(se,ge,Re){return gt.registerCodeActionProvider($e,mt(se),ge,Re)},registerCodeLensProvider(se,ge){return gt.registerCodeLensProvider($e,mt(se),ge)},registerDefinitionProvider(se,ge){return gt.registerDefinitionProvider($e,mt(se),ge)},registerDeclarationProvider(se,ge){return gt.registerDeclarationProvider($e,mt(se),ge)},registerImplementationProvider(se,ge){return gt.registerImplementationProvider($e,mt(se),ge)},registerTypeDefinitionProvider(se,ge){return gt.registerTypeDefinitionProvider($e,mt(se),ge)},registerHoverProvider(se,ge){return gt.registerHoverProvider($e,mt(se),ge,$e.identifier)},registerEvaluatableExpressionProvider(se,ge){return gt.registerEvaluatableExpressionProvider($e,mt(se),ge,$e.identifier)},registerInlineValuesProvider(se,ge){return gt.registerInlineValuesProvider($e,mt(se),ge,$e.identifier)},registerDocumentHighlightProvider(se,ge){return gt.registerDocumentHighlightProvider($e,mt(se),ge)},registerLinkedEditingRangeProvider(se,ge){return gt.registerLinkedEditingRangeProvider($e,mt(se),ge)},registerReferenceProvider(se,ge){return gt.registerReferenceProvider($e,mt(se),ge)},registerRenameProvider(se,ge){return gt.registerRenameProvider($e,mt(se),ge)},registerDocumentSymbolProvider(se,ge,Re){return gt.registerDocumentSymbolProvider($e,mt(se),ge,Re)},registerWorkspaceSymbolProvider(se){return gt.registerWorkspaceSymbolProvider($e,se)},registerDocumentFormattingEditProvider(se,ge){return gt.registerDocumentFormattingEditProvider($e,mt(se),ge)},registerDocumentRangeFormattingEditProvider(se,ge){return gt.registerDocumentRangeFormattingEditProvider($e,mt(se),ge)},registerOnTypeFormattingEditProvider(se,ge,Re,...ut){return gt.registerOnTypeFormattingEditProvider($e,mt(se),ge,[Re].concat(ut))},registerDocumentSemanticTokensProvider(se,ge,Re){return gt.registerDocumentSemanticTokensProvider($e,mt(se),ge,Re)},registerDocumentRangeSemanticTokensProvider(se,ge,Re){return gt.registerDocumentRangeSemanticTokensProvider($e,mt(se),ge,Re)},registerSignatureHelpProvider(se,ge,Re,...ut){return typeof Re=="object"?gt.registerSignatureHelpProvider($e,mt(se),ge,Re):gt.registerSignatureHelpProvider($e,mt(se),ge,typeof Re=="undefined"?[]:[Re,...ut])},registerCompletionItemProvider(se,ge,...Re){return gt.registerCompletionItemProvider($e,mt(se),ge,Re)},registerInlineCompletionItemProvider(se,ge){return(0,ye.checkProposedApiEnabled)($e,"inlineCompletions"),gt.registerInlineCompletionsProvider($e,mt(se),ge)},registerDocumentLinkProvider(se,ge){return gt.registerDocumentLinkProvider($e,mt(se),ge)},registerColorProvider(se,ge){return gt.registerColorProvider($e,mt(se),ge)},registerFoldingRangeProvider(se,ge){return gt.registerFoldingRangeProvider($e,mt(se),ge)},registerSelectionRangeProvider(se,ge){return gt.registerSelectionRangeProvider($e,se,ge)},registerCallHierarchyProvider(se,ge){return gt.registerCallHierarchyProvider($e,se,ge)},registerTypeHierarchyProvider(se,ge){return gt.registerTypeHierarchyProvider($e,se,ge)},setLanguageConfiguration:(se,ge)=>gt.setLanguageConfiguration($e,se,ge),getTokenInformationAtPosition(se,ge){return(0,ye.checkProposedApiEnabled)($e,"tokenInformation"),Vt.tokenAtPosition(se,ge)},registerInlayHintsProvider(se,ge){return(0,ye.checkProposedApiEnabled)($e,"inlayHints"),gt.registerInlayHintsProvider($e,se,ge)},createLanguageStatusItem(se,ge){return(0,ye.checkProposedApiEnabled)($e,"languageStatus"),Vt.createLanguageStatusItem($e,se,ge)}},Ri={get activeTextEditor(){return At.getActiveTextEditor()},get visibleTextEditors(){return At.getVisibleTextEditors()},get activeTerminal(){return vt.activeTerminal},get terminals(){return vt.terminals},async showTextDocument(se,ge,Re){const ut=await(P.URI.isUri(se)?Promise.resolve(ni.openTextDocument(se)):Promise.resolve(se));return At.showTextDocument(ut,ge,Re)},createTextEditorDecorationType(se){return At.createTextEditorDecorationType($e,se)},onDidChangeActiveTextEditor(se,ge,Re){return At.onDidChangeActiveTextEditor(se,ge,Re)},onDidChangeVisibleTextEditors(se,ge,Re){return At.onDidChangeVisibleTextEditors(se,ge,Re)},onDidChangeTextEditorSelection(se,ge,Re){return At.onDidChangeTextEditorSelection(se,ge,Re)},onDidChangeTextEditorOptions(se,ge,Re){return At.onDidChangeTextEditorOptions(se,ge,Re)},onDidChangeTextEditorVisibleRanges(se,ge,Re){return At.onDidChangeTextEditorVisibleRanges(se,ge,Re)},onDidChangeTextEditorViewColumn(se,ge,Re){return At.onDidChangeTextEditorViewColumn(se,ge,Re)},onDidCloseTerminal(se,ge,Re){return vt.onDidCloseTerminal(se,ge,Re)},onDidOpenTerminal(se,ge,Re){return vt.onDidOpenTerminal(se,ge,Re)},onDidChangeActiveTerminal(se,ge,Re){return vt.onDidChangeActiveTerminal(se,ge,Re)},onDidChangeTerminalDimensions(se,ge,Re){return(0,ye.checkProposedApiEnabled)($e,"terminalDimensions"),vt.onDidChangeTerminalDimensions(se,ge,Re)},onDidChangeTerminalState(se,ge,Re){return vt.onDidChangeTerminalState(se,ge,Re)},onDidWriteTerminalData(se,ge,Re){return(0,ye.checkProposedApiEnabled)($e,"terminalDataWriteEvent"),vt.onDidWriteTerminalData(se,ge,Re)},get state(){return qe.state},onDidChangeWindowState(se,ge,Re){return qe.onDidChangeWindowState(se,ge,Re)},showInformationMessage(se,...ge){return ui.showMessage($e,C.default.Info,se,ge[0],ge.slice(1))},showWarningMessage(se,...ge){return ui.showMessage($e,C.default.Warning,se,ge[0],ge.slice(1))},showErrorMessage(se,...ge){return ui.showMessage($e,C.default.Error,se,ge[0],ge.slice(1))},showQuickPick(se,ge,Re){return Array.isArray(se)&&se.some(ut=>ut.kind!==void 0)&&(0,ye.checkProposedApiEnabled)($e,"quickPickSeparators"),qt.showQuickPick(se,ge,Re)},showWorkspaceFolderPick(se){return qt.showWorkspaceFolderPick(se)},showInputBox(se,ge){return qt.showInput(se,ge)},showOpenDialog(se){return ti.showOpenDialog(se)},showSaveDialog(se){return ti.showSaveDialog(se)},createStatusBarItem(se,ge,Re){let ut,Ct,Dt;return typeof se=="string"?(ut=se,Ct=ge,Dt=Re):(Ct=se,Dt=ge),gi.createStatusBarEntry($e,ut,Ct,Dt)},setStatusBarMessage(se,ge){return gi.setStatusBarMessage(se,ge)},withScmProgress(se){return Ze.report("window.withScmProgress",$e,"Use 'withProgress' instead."),fi.withProgress($e,{location:M.ProgressLocation.SourceControl},(ge,Re)=>se({report(ut){}}))},withProgress(se,ge){return fi.withProgress($e,se,ge)},createOutputChannel(se){return Tt.createOutputChannel(se,$e)},createWebviewPanel(se,ge,Re,ut){return Kt.createWebviewPanel($e,se,ge,Re,ut)},createWebviewTextEditorInset(se,ge,Re,ut){return(0,ye.checkProposedApiEnabled)($e,"editorInsets"),ai.createWebviewEditorInset(se,ge,Re,ut,$e)},createTerminal(se,ge,Re){return typeof se=="object"?"pty"in se?vt.createExtensionTerminal(se):vt.createTerminalFromOptions(se):vt.createTerminal(se,ge,Re)},registerTerminalLinkProvider(se){return vt.registerLinkProvider(se)},registerTerminalProfileProvider(se,ge){return vt.registerProfileProvider($e,se,ge)},registerTreeDataProvider(se,ge){return Xt.registerTreeDataProvider(se,ge,$e)},createTreeView(se,ge){return Xt.createTreeView(se,ge,$e)},registerWebviewPanelSerializer:(se,ge)=>Kt.registerWebviewPanelSerializer($e,se,ge),registerCustomEditorProvider:(se,ge,Re={})=>_i.registerCustomEditorProvider($e,se,ge,Re),registerFileDecorationProvider(se){return yt.registerFileDecorationProvider(se,$e.identifier)},registerUriHandler(se){return Lt.registerUriHandler($e.identifier,se)},createQuickPick(){return qt.createQuickPick($e)},createInputBox(){return qt.createInputBox($e.identifier)},get activeColorTheme(){return mi.activeColorTheme},onDidChangeActiveColorTheme(se,ge,Re){return mi.onDidChangeActiveColorTheme(se,ge,Re)},registerWebviewViewProvider(se,ge,Re){return Ci.registerWebviewViewProvider($e,se,ge,Re?.webviewOptions)},get activeNotebookEditor(){return(0,ye.checkProposedApiEnabled)($e,"notebookEditor"),Et.activeNotebookEditor},onDidChangeActiveNotebookEditor(se,ge,Re){return(0,ye.checkProposedApiEnabled)($e,"notebookEditor"),Et.onDidChangeActiveNotebookEditor(se,ge,Re)},get visibleNotebookEditors(){return(0,ye.checkProposedApiEnabled)($e,"notebookEditor"),Et.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,ye.checkProposedApiEnabled)($e,"notebookEditor"),Et.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(se,ge,Re){return(0,ye.checkProposedApiEnabled)($e,"notebookEditor"),jt.onDidChangeNotebookEditorSelection(se,ge,Re)},onDidChangeNotebookEditorVisibleRanges(se,ge,Re){return(0,ye.checkProposedApiEnabled)($e,"notebookEditor"),jt.onDidChangeNotebookEditorVisibleRanges(se,ge,Re)},showNotebookDocument(se,ge){return(0,ye.checkProposedApiEnabled)($e,"notebookEditor"),Et.showNotebookDocument(se,ge)},registerExternalUriOpener(se,ge,Re){return(0,ye.checkProposedApiEnabled)($e,"externalUriOpener"),yi.registerExternalUriOpener($e.identifier,se,ge,Re)},get tabs(){return(0,ye.checkProposedApiEnabled)($e,"tabs"),wt.tabs},get activeTab(){return(0,ye.checkProposedApiEnabled)($e,"tabs"),wt.activeTab},get onDidChangeTabs(){return(0,ye.checkProposedApiEnabled)($e,"tabs"),wt.onDidChangeTabs},get onDidChangeActiveTab(){return(0,ye.checkProposedApiEnabled)($e,"tabs"),wt.onDidChangeActiveTab},getInlineCompletionItemController(se){return(0,ye.checkProposedApiEnabled)($e,"inlineCompletions"),u.InlineCompletionController.get(se)}},ni={get rootPath(){return Ze.report("workspace.rootPath",$e,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),He.getPath()},set rootPath(se){throw i.readonly()},getWorkspaceFolder(se){return He.getWorkspaceFolder(se)},get workspaceFolders(){return He.getWorkspaceFolders()},get name(){return He.name},set name(se){throw i.readonly()},get workspaceFile(){return He.workspaceFile},set workspaceFile(se){throw i.readonly()},updateWorkspaceFolders:(se,ge,...Re)=>He.updateWorkspaceFolders($e,se,ge||0,...Re),onDidChangeWorkspaceFolders:function(se,ge,Re){return He.onDidChangeWorkspace(se,ge,Re)},asRelativePath:(se,ge)=>He.getRelativePath(se,ge),findFiles:(se,ge,Re,ut)=>He.findFiles(H.GlobPattern.from(se),H.GlobPattern.from(ge),Re,$e.identifier,ut),findTextInFiles:(se,ge,Re,ut)=>{(0,ye.checkProposedApiEnabled)($e,"findTextInFiles");let Ct,Dt;return typeof ge=="object"?(Ct=ge,Dt=Re):(Ct={},Dt=ge,ut=Re),He.findTextInFiles(se,Ct||{},Dt,$e.identifier,ut)},saveAll:se=>He.saveAll(se),applyEdit(se){return Di.applyWorkspaceEdit(se)},createFileSystemWatcher:(se,ge,Re,ut)=>Ut.createFileSystemWatcher(H.GlobPattern.from(se),ge,Re,ut),get textDocuments(){return St.getAllDocumentData().map(se=>se.document)},set textDocuments(se){throw i.readonly()},openTextDocument(se){let ge;const Re=se;if(typeof se=="string")ge=Promise.resolve(P.URI.file(se));else if(P.URI.isUri(se))ge=Promise.resolve(se);else if(!Re||typeof Re=="object")ge=St.createDocumentData(Re);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ge.then(ut=>St.ensureDocumentData(ut).then(Ct=>Ct.document))},onDidOpenTextDocument:(se,ge,Re)=>St.onDidAddDocument(se,ge,Re),onDidCloseTextDocument:(se,ge,Re)=>St.onDidRemoveDocument(se,ge,Re),onDidChangeTextDocument:(se,ge,Re)=>St.onDidChangeDocument(se,ge,Re),onDidSaveTextDocument:(se,ge,Re)=>St.onDidSaveDocument(se,ge,Re),onWillSaveTextDocument:(se,ge,Re)=>Nt.getOnWillSaveTextDocumentEvent($e)(se,ge,Re),get notebookDocuments(){return Et.notebookDocuments.map(se=>se.apiNotebook)},async openNotebookDocument(se,ge){let Re;if(P.URI.isUri(se))Re=se,await Et.openNotebookDocument(se);else if(typeof se=="string")Re=P.URI.revive(await Et.createNotebookDocument({viewType:se,content:ge}));else throw new Error("Invalid arguments");return Et.getNotebookDocument(Re).apiNotebook},get onDidOpenNotebookDocument(){return Et.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return Et.onDidCloseNotebookDocument},registerNotebookSerializer(se,ge,Re,ut){return Et.registerNotebookSerializer($e,se,ge,Re,(0,ye.isProposedApiEnabled)($e,"notebookLiveShare")?ut:void 0)},registerNotebookContentProvider:(se,ge,Re,ut)=>((0,ye.checkProposedApiEnabled)($e,"notebookContentProvider"),Et.registerNotebookContentProvider($e,se,ge,Re,(0,ye.isProposedApiEnabled)($e,"notebookLiveShare")?ut:void 0)),onDidChangeConfiguration:(se,ge,Re)=>pi.onDidChangeConfiguration(se,ge,Re),getConfiguration(se,ge){return ge=arguments.length===1?void 0:ge,pi.getConfiguration(se,ge,$e)},registerTextDocumentContentProvider(se,ge){return Mt.registerTextDocumentContentProvider(se,ge)},registerTaskProvider:(se,ge)=>(Ze.report("window.registerTaskProvider",$e,"Use the corresponding function on the 'tasks' namespace instead"),It.registerTaskProvider($e,se,ge)),registerFileSystemProvider(se,ge,Re){return(0,Pe.combinedDisposable)(li.registerFileSystemProvider($e,se,ge,Re),Me.addFileSystemProvider(se,ge))},get fs(){return Me.value},registerFileSearchProvider:(se,ge)=>((0,ye.checkProposedApiEnabled)($e,"fileSearchProvider"),Ot.registerFileSearchProvider(se,ge)),registerTextSearchProvider:(se,ge)=>((0,ye.checkProposedApiEnabled)($e,"textSearchProvider"),Ot.registerTextSearchProvider(se,ge)),registerRemoteAuthorityResolver:(se,ge)=>((0,ye.checkProposedApiEnabled)($e,"resolvers"),Ke.registerRemoteAuthorityResolver(se,ge)),registerResourceLabelFormatter:se=>((0,ye.checkProposedApiEnabled)($e,"resolvers"),Ei.$registerResourceLabelFormatter(se)),onDidCreateFiles:(se,ge,Re)=>Ut.onDidCreateFile(se,ge,Re),onDidDeleteFiles:(se,ge,Re)=>Ut.onDidDeleteFile(se,ge,Re),onDidRenameFiles:(se,ge,Re)=>Ut.onDidRenameFile(se,ge,Re),onWillCreateFiles:(se,ge,Re)=>Ut.getOnWillCreateFileEvent($e)(se,ge,Re),onWillDeleteFiles:(se,ge,Re)=>Ut.getOnWillDeleteFileEvent($e)(se,ge,Re),onWillRenameFiles:(se,ge,Re)=>Ut.getOnWillRenameFileEvent($e)(se,ge,Re),openTunnel:se=>((0,ye.checkProposedApiEnabled)($e,"resolvers"),Le.openTunnel($e,se).then(ge=>{if(!ge)throw new Error("cannot open tunnel");return ge})),get tunnels(){return(0,ye.checkProposedApiEnabled)($e,"resolvers"),Le.getTunnels()},onDidChangeTunnels:(se,ge,Re)=>((0,ye.checkProposedApiEnabled)($e,"resolvers"),Le.onDidChangeTunnels(se,ge,Re)),registerPortAttributesProvider:(se,ge)=>((0,ye.checkProposedApiEnabled)($e,"portsAttributes"),Le.registerPortsAttributesProvider(se,ge)),registerTimelineProvider:(se,ge)=>((0,ye.checkProposedApiEnabled)($e,"timeline"),Si.registerTimelineProvider(se,ge,$e.identifier,ft.converter)),get isTrusted(){return He.trusted},requestWorkspaceTrust:se=>((0,ye.checkProposedApiEnabled)($e,"workspaceTrust"),He.requestWorkspaceTrust(se)),onDidGrantWorkspaceTrust:(se,ge,Re)=>He.onDidGrantWorkspaceTrust(se,ge,Re)},Li={get inputBox(){return Ze.report("scm.inputBox",$e,"Use 'SourceControl.inputBox' instead"),Jt.getLastInputBox($e)},createSourceControl(se,ge,Re){return Jt.createSourceControl($e,se,ge,Re)}},Fi={createCommentController(se,ge){return ci.createCommentController($e,se,ge)}},Mi={get activeDebugSession(){return _t.activeDebugSession},get activeDebugConsole(){return _t.activeDebugConsole},get breakpoints(){return _t.breakpoints},onDidStartDebugSession(se,ge,Re){return _t.onDidStartDebugSession(se,ge,Re)},onDidTerminateDebugSession(se,ge,Re){return _t.onDidTerminateDebugSession(se,ge,Re)},onDidChangeActiveDebugSession(se,ge,Re){return _t.onDidChangeActiveDebugSession(se,ge,Re)},onDidReceiveDebugSessionCustomEvent(se,ge,Re){return _t.onDidReceiveDebugSessionCustomEvent(se,ge,Re)},onDidChangeBreakpoints(se,ge,Re){return _t.onDidChangeBreakpoints(se,ge,Re)},registerDebugConfigurationProvider(se,ge,Re){return _t.registerDebugConfigurationProvider(se,ge,Re||M.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(se,ge){return _t.registerDebugAdapterDescriptorFactory($e,se,ge)},registerDebugAdapterTrackerFactory(se,ge){return _t.registerDebugAdapterTrackerFactory(se,ge)},startDebugging(se,ge,Re){return!Re||typeof Re=="object"&&"configuration"in Re?_t.startDebugging(se,ge,{parentSession:Re}):_t.startDebugging(se,ge,Re||{})},stopDebugging(se){return _t.stopDebugging(se)},addBreakpoints(se){return _t.addBreakpoints(se)},removeBreakpoints(se){return _t.removeBreakpoints(se)},asDebugSourceUri(se,ge){return _t.asDebugSourceUri(se,ge)}},Oi={registerTaskProvider:(se,ge)=>It.registerTaskProvider($e,se,ge),fetchTasks:se=>It.fetchTasks(se),executeTask:se=>It.executeTask($e,se),get taskExecutions(){return It.taskExecutions},onDidStartTask:(se,ge,Re)=>It.onDidStartTask(se,ge,Re),onDidEndTask:(se,ge,Re)=>It.onDidEndTask(se,ge,Re),onDidStartTaskProcess:(se,ge,Re)=>It.onDidStartTaskProcess(se,ge,Re),onDidEndTaskProcess:(se,ge,Re)=>It.onDidEndTaskProcess(se,ge,Re)},Ni={createNotebookController(se,ge,Re,ut,Ct){return si.createNotebookController($e,se,ge,Re,ut,(0,ye.isProposedApiEnabled)($e,"notebookMessaging")?Ct:void 0)},registerNotebookCellStatusBarItemProvider:(se,ge)=>Et.registerNotebookCellStatusBarItemProvider($e,se,ge),get onDidSaveNotebookDocument(){return(0,ye.checkProposedApiEnabled)($e,"notebookEditor"),Wt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(se){return(0,ye.checkProposedApiEnabled)($e,"notebookEditorDecorationType"),jt.createNotebookEditorDecorationType(se)},createRendererMessaging(se){return oi.createRendererMessaging($e,se)},onDidChangeNotebookDocumentMetadata(se,ge,Re){return(0,ye.checkProposedApiEnabled)($e,"notebookEditor"),Wt.onDidChangeNotebookDocumentMetadata(se,ge,Re)},onDidChangeNotebookCells(se,ge,Re){return(0,ye.checkProposedApiEnabled)($e,"notebookEditor"),Et.onDidChangeNotebookCells(se,ge,Re)},onDidChangeNotebookCellExecutionState(se,ge,Re){return(0,ye.checkProposedApiEnabled)($e,"notebookCellExecutionState"),Et.onDidChangeNotebookCellExecutionState(se,ge,Re)},onDidChangeCellOutputs(se,ge,Re){return(0,ye.checkProposedApiEnabled)($e,"notebookEditor"),Et.onDidChangeCellOutputs(se,ge,Re)},onDidChangeCellMetadata(se,ge,Re){return(0,ye.checkProposedApiEnabled)($e,"notebookEditor"),Et.onDidChangeCellMetadata(se,ge,Re)},createConcatTextDocument(se,ge){return(0,ye.checkProposedApiEnabled)($e,"notebookConcatTextDocument"),new Ve.ExtHostNotebookConcatDocument(Et,St,se,ge)}};return{version:be.version,authentication:ii,commands:Ii,comments:Fi,debug:Mi,env:vi,extensions:Ti,languages:Ai,notebooks:Ni,scm:Li,tasks:Oi,tests:Pi,window:Ri,workspace:ni,Breakpoint:M.Breakpoint,CallHierarchyIncomingCall:M.CallHierarchyIncomingCall,CallHierarchyItem:M.CallHierarchyItem,CallHierarchyOutgoingCall:M.CallHierarchyOutgoingCall,CancellationError:i.CancellationError,CancellationTokenSource:m.CancellationTokenSource,CandidatePortSource:c.CandidatePortSource,CodeAction:M.CodeAction,CodeActionKind:M.CodeActionKind,CodeActionTriggerKind:M.CodeActionTriggerKind,CodeLens:M.CodeLens,Color:M.Color,ColorInformation:M.ColorInformation,ColorPresentation:M.ColorPresentation,ColorThemeKind:M.ColorThemeKind,CommentMode:M.CommentMode,CommentThreadCollapsibleState:M.CommentThreadCollapsibleState,CompletionItem:M.CompletionItem,CompletionItemKind:M.CompletionItemKind,CompletionItemTag:M.CompletionItemTag,CompletionList:M.CompletionList,CompletionTriggerKind:M.CompletionTriggerKind,ConfigurationTarget:M.ConfigurationTarget,CustomExecution:M.CustomExecution,DebugAdapterExecutable:M.DebugAdapterExecutable,DebugAdapterInlineImplementation:M.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:M.DebugAdapterNamedPipeServer,DebugAdapterServer:M.DebugAdapterServer,DebugConfigurationProviderTriggerKind:M.DebugConfigurationProviderTriggerKind,DebugConsoleMode:M.DebugConsoleMode,DecorationRangeBehavior:M.DecorationRangeBehavior,Diagnostic:M.Diagnostic,DiagnosticRelatedInformation:M.DiagnosticRelatedInformation,DiagnosticSeverity:M.DiagnosticSeverity,DiagnosticTag:M.DiagnosticTag,Disposable:M.Disposable,DocumentHighlight:M.DocumentHighlight,DocumentHighlightKind:M.DocumentHighlightKind,DocumentLink:M.DocumentLink,DocumentSymbol:M.DocumentSymbol,EndOfLine:M.EndOfLine,EnvironmentVariableMutatorType:M.EnvironmentVariableMutatorType,EvaluatableExpression:M.EvaluatableExpression,InlineValueText:M.InlineValueText,InlineValueVariableLookup:M.InlineValueVariableLookup,InlineValueEvaluatableExpression:M.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:M.InlineCompletionTriggerKind,EventEmitter:y.Emitter,ExtensionKind:M.ExtensionKind,ExtensionMode:M.ExtensionMode,ExternalUriOpenerPriority:M.ExternalUriOpenerPriority,FileChangeType:M.FileChangeType,FileDecoration:M.FileDecoration,FileSystemError:M.FileSystemError,FileType:A.FileType,FilePermission:A.FilePermission,FoldingRange:M.FoldingRange,FoldingRangeKind:M.FoldingRangeKind,FunctionBreakpoint:M.FunctionBreakpoint,InlineCompletionItem:M.InlineSuggestion,InlineCompletionList:M.InlineSuggestions,Hover:M.Hover,IndentAction:I.IndentAction,Location:M.Location,MarkdownString:M.MarkdownString,OverviewRulerLane:_.OverviewRulerLane,ParameterInformation:M.ParameterInformation,PortAutoForwardAction:M.PortAutoForwardAction,Position:M.Position,ProcessExecution:M.ProcessExecution,ProgressLocation:M.ProgressLocation,QuickInputButtons:M.QuickInputButtons,Range:M.Range,RelativePattern:M.RelativePattern,Selection:M.Selection,SelectionRange:M.SelectionRange,SemanticTokens:M.SemanticTokens,SemanticTokensBuilder:M.SemanticTokensBuilder,SemanticTokensEdit:M.SemanticTokensEdit,SemanticTokensEdits:M.SemanticTokensEdits,SemanticTokensLegend:M.SemanticTokensLegend,ShellExecution:M.ShellExecution,ShellQuoting:M.ShellQuoting,SignatureHelp:M.SignatureHelp,SignatureHelpTriggerKind:M.SignatureHelpTriggerKind,SignatureInformation:M.SignatureInformation,SnippetString:M.SnippetString,SourceBreakpoint:M.SourceBreakpoint,StandardTokenType:M.StandardTokenType,StatusBarAlignment:M.StatusBarAlignment,SymbolInformation:M.SymbolInformation,SymbolKind:M.SymbolKind,SymbolTag:M.SymbolTag,Task:M.Task,TaskGroup:M.TaskGroup,TaskPanelKind:M.TaskPanelKind,TaskRevealKind:M.TaskRevealKind,TaskScope:M.TaskScope,TerminalLink:M.TerminalLink,TerminalLocation:M.TerminalLocation,TerminalProfile:M.TerminalProfile,TextDocumentSaveReason:M.TextDocumentSaveReason,TextEdit:M.TextEdit,TextEditorCursorStyle:D.TextEditorCursorStyle,TextEditorLineNumbersStyle:M.TextEditorLineNumbersStyle,TextEditorRevealType:M.TextEditorRevealType,TextEditorSelectionChangeKind:M.TextEditorSelectionChangeKind,TextDocumentChangeReason:M.TextDocumentChangeReason,ThemeColor:M.ThemeColor,ThemeIcon:M.ThemeIcon,TreeItem:M.TreeItem,TreeItemCollapsibleState:M.TreeItemCollapsibleState,TypeHierarchyItem:M.TypeHierarchyItem,UIKind:c.UIKind,Uri:P.URI,ViewColumn:M.ViewColumn,WorkspaceEdit:M.WorkspaceEdit,InlayHint:M.InlayHint,InlayHintKind:M.InlayHintKind,RemoteAuthorityResolverError:M.RemoteAuthorityResolverError,ResolvedAuthority:M.ResolvedAuthority,SourceControlInputBoxValidationType:M.SourceControlInputBoxValidationType,ExtensionRuntime:M.ExtensionRuntime,TimelineItem:M.TimelineItem,NotebookRange:M.NotebookRange,NotebookCellKind:M.NotebookCellKind,NotebookCellExecutionState:M.NotebookCellExecutionState,NotebookCellData:M.NotebookCellData,NotebookData:M.NotebookData,NotebookRendererScript:M.NotebookRendererScript,NotebookCellStatusBarAlignment:M.NotebookCellStatusBarAlignment,NotebookEditorRevealType:M.NotebookEditorRevealType,NotebookCellOutput:M.NotebookCellOutput,NotebookCellOutputItem:M.NotebookCellOutputItem,NotebookCellStatusBarItem:M.NotebookCellStatusBarItem,NotebookControllerAffinity:M.NotebookControllerAffinity,PortAttributes:M.PortAttributes,LinkedEditingRanges:M.LinkedEditingRanges,TestResultState:M.TestResultState,TestRunRequest:M.TestRunRequest,TestMessage:M.TestMessage,TestTag:M.TestTag,TestRunProfileKind:M.TestRunProfileKind,TextSearchCompleteMessageType:pe.TextSearchCompleteMessageType,TreeDataTransfer:M.TreeDataTransfer,TreeDataTransferItem:M.TreeDataTransferItem,CoveredCount:M.CoveredCount,FileCoverage:M.FileCoverage,StatementCoverage:M.StatementCoverage,BranchCoverage:M.BranchCoverage,FunctionCoverage:M.FunctionCoverage,WorkspaceTrustState:M.WorkspaceTrustState,LanguageStatusSeverity:M.LanguageStatusSeverity,QuickPickItemKind:M.QuickPickItemKind}}}e.createApiFactoryAndRegisterActors=ce}),define(ve[274],we([0,1,83,132,35,130,36,38,45,34,70,55,72,91,52,65,133,66,44,90,121,54,131,11,226]),function(J,e,m,i,y,C,P,D,_,I,L,A,c,E,h,p,v,T,b,o,s,g,l,S,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,m.registerSingleton)(S.ILoggerService,l.ExtHostLoggerService),(0,m.registerSingleton)(S.ILogService,n.ExtHostLogService),(0,m.registerSingleton)(p.IExtHostApiDeprecationService,p.ExtHostApiDeprecationService),(0,m.registerSingleton)(D.IExtHostCommands,D.ExtHostCommands),(0,m.registerSingleton)(P.IExtHostConfiguration,P.ExtHostConfiguration),(0,m.registerSingleton)(T.IExtHostConsumerFileSystem,T.ExtHostConsumerFileSystem),(0,m.registerSingleton)(A.IExtHostDebugService,A.WorkerExtHostDebugService),(0,m.registerSingleton)(C.IExtHostDecorations,C.ExtHostDecorations),(0,m.registerSingleton)(_.IExtHostDocumentsAndEditors,_.ExtHostDocumentsAndEditors),(0,m.registerSingleton)(b.IExtHostFileSystemInfo,b.ExtHostFileSystemInfo),(0,m.registerSingleton)(i.IExtHostOutputService,i.ExtHostOutputService),(0,m.registerSingleton)(c.IExtHostSearch,c.ExtHostSearch),(0,m.registerSingleton)(E.IExtHostStorage,E.ExtHostStorage),(0,m.registerSingleton)(L.IExtHostTask,L.WorkerExtHostTask),(0,m.registerSingleton)(I.IExtHostTerminalService,I.WorkerExtHostTerminalService),(0,m.registerSingleton)(h.IExtHostTunnelService,h.ExtHostTunnelService),(0,m.registerSingleton)(v.IExtHostWindow,v.ExtHostWindow),(0,m.registerSingleton)(y.IExtHostWorkspace,y.ExtHostWorkspace),(0,m.registerSingleton)(o.IExtHostSecretState,o.ExtHostSecretState),(0,m.registerSingleton)(s.IExtHostTelemetry,s.ExtHostTelemetry),(0,m.registerSingleton)(g.IExtHostEditorTabs,g.ExtHostEditorTabs)}),define(ve[92],we([0,1,16,11,33,69]),function(J,e,m,i,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function P(A){return A.startsWith("**")||A.startsWith("/")?A:`/${A}`}e.anchorGlob=P;function D(A,c,E,h){const p=(0,m.mapArrayOrNot)(E,_),v=new y.TextSearchMatch(c,p,h),T=v.preview.matches;return{ranges:(0,m.mapArrayOrNot)(p,I),uri:A,preview:{text:v.preview.text,matches:(0,m.mapArrayOrNot)(T,I)}}}e.createTextSearchResult=D;function _(A){return new y.SearchRange(A.start.line,A.start.character,A.end.line,A.end.character)}function I(A){return new C.Range(A.startLineNumber,A.startColumn,A.endLineNumber,A.endColumn)}let L=class{constructor(c,E){this.prefix=c,this.logService=E}appendLine(c){this.logService.debug(`${this.prefix}#search`,c)}};L=je([ze(1,i.ILogService)],L),e.OutputChannel=L}),define(ve[275],we([0,1,95,22]),function(J,e,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.DecodeStreamError=e.DecodeStreamErrorKind=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function y(n){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(t=>t===n)}e.isUTFEncoding=y,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const C=512,P=512,D=512*8,_=512*128;var I;(function(n){n[n.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(I=e.DecodeStreamErrorKind||(e.DecodeStreamErrorKind={}));class L extends Error{constructor(t,r){super(t);this.decodeStreamErrorKind=r}}e.DecodeStreamError=L;class A{constructor(t){this.iconvLiteDecoder=t}static async create(t){let r;if(t!==e.UTF8)r=(await new Promise((a,f)=>{J(["iconv-lite-umd"],a,f)})).getDecoder(p(t));else{const u=new TextDecoder;r={write(a){return u.decode(a,{stream:!0})},end(){return u.decode()}}}return new A(r)}write(t){return this.iconvLiteDecoder.write(t)}end(){return this.iconvLiteDecoder.end()}}function c(n,t){const r=t.minBytesRequiredForDetection??t.guessEncoding?D:P;return new Promise((u,a)=>{const f=(0,m.newWriteableStream)(x=>x.join("")),w=[];let d=0,k,R;const N=async()=>{try{const x=await S({buffer:i.VSBuffer.concat(w),bytesRead:d},t.guessEncoding);if(x.seemsBinary&&t.acceptTextOnly)throw new L("Stream is binary but only text is accepted for decoding",1);x.encoding=await t.overwriteEncoding(x.encoding),k=await A.create(x.encoding);const F=k.write(i.VSBuffer.concat(w).buffer);f.write(F),w.length=0,d=0,u({stream:f,detected:x})}catch(x){R?.dispose(),f.destroy(),a(x)}};R=(0,m.listenStream)(n,{onData:async x=>{k?f.write(k.write(x.buffer)):(w.push(x),d+=x.byteLength,d>=r&&(n.pause(),await N(),setTimeout(()=>n.resume())))},onError:x=>f.error(x),onEnd:async()=>{k||await N(),f.end(k?.end())}})})}e.toDecodeStream=c;async function E(n,t,r){const a=(await new Promise((d,k)=>{J(["iconv-lite-umd"],d,k)})).getEncoder(p(t),r);let f=!1,w=!1;return{read(){if(w)return null;const d=n.read();if(typeof d!="string"){if(w=!0,!f&&r?.addBOM)switch(t){case e.UTF8:case e.UTF8_with_bom:return i.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return i.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return i.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const k=a.end();return k&&k.length>0?(f=!0,i.VSBuffer.wrap(k)):null}return f=!0,i.VSBuffer.wrap(a.write(d))}}}e.toEncodeReadable=E;async function h(n){return(await new Promise((r,u)=>{J(["iconv-lite-umd"],r,u)})).encodingExists(p(n))}e.encodingExists=h;function p(n){return n===e.UTF8_with_bom||n===null?e.UTF8:n}e.toNodeEncoding=p;function v(n,t){if(!n||t<e.UTF16be_BOM.length)return null;const r=n.readUInt8(0),u=n.readUInt8(1);if(r===e.UTF16be_BOM[0]&&u===e.UTF16be_BOM[1])return e.UTF16be;if(r===e.UTF16le_BOM[0]&&u===e.UTF16le_BOM[1])return e.UTF16le;if(t<e.UTF8_BOM.length)return null;const a=n.readUInt8(2);return r===e.UTF8_BOM[0]&&u===e.UTF8_BOM[1]&&a===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=v;const T=["ascii","utf-16","utf-32"];async function b(n){const t=await new Promise((w,d)=>{J(["jschardet"],w,d)}),r=n.slice(0,_),u=g(r.buffer),a=t.detect(u);if(!a||!a.encoding)return null;const f=a.encoding.toLowerCase();return 0<=T.indexOf(f)?null:s(a.encoding)}const o={ibm866:"cp866",big5:"cp950"};function s(n){const t=n.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return o[t]||t}function g(n){let t="";for(let r=0;r<n.length;r++)t+=String.fromCharCode(n[r]);return t}function l(n){switch(n){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:const t=n.match(/windows(\d+)/);return t?"windows-"+t[1]:n}}e.toCanonicalName=l;function S({buffer:n,bytesRead:t},r){let u=v(n,t),a=!1;if(u!==e.UTF16be&&u!==e.UTF16le&&n){let f=!0,w=!0,d=!1;for(let k=0;k<t&&k<C;k++){const R=k%2==1,N=n.readUInt8(k)===0;if(N&&(d=!0),f&&(R&&!N||!R&&N)&&(f=!1),w&&(R&&N||!R&&!N)&&(w=!1),N&&!f&&!w)break}d&&(f?u=e.UTF16le:w?u=e.UTF16be:a=!0)}return r&&!a&&!u&&n?b(n.slice(0,t)).then(f=>({seemsBinary:!1,encoding:f})):{seemsBinary:a,encoding:u}}e.detectEncodingFromBuffer=S,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(ve[135],we([0,1,275,28,134]),function(J,e,m,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class C extends y.TextSearchManager{constructor(D,_,I=i,L="searchProcess"){super(D,_,{readdir:A=>I.Promises.readdir(A.fsPath),toCanonicalName:A=>(0,m.toCanonicalName)(A)},L)}}e.NativeTextSearchManager=C}),define(ve[276],we([0,1,277,291,292,2,293]),function(J,e,m,i,y,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function D(A,c,E,h,p,v){const T=v.environment.useHostProxy,b=typeof T=="boolean"?T:!v.remote.isRemote,o=(0,P.createProxyResolver)({resolveProxy:g=>A.resolveProxy(g),getHttpProxySetting:()=>c.getConfiguration("http").get("proxy"),log:(g,l,...S)=>{switch(g){case P.LogLevel.Trace:h.trace(l,...S);break;case P.LogLevel.Debug:h.debug(l,...S);break;case P.LogLevel.Info:h.info(l,...S);break;case P.LogLevel.Warning:h.warn(l,...S);break;case P.LogLevel.Error:h.error(l,...S);break;case P.LogLevel.Critical:h.critical(l,...S);break;case P.LogLevel.Off:break;default:n(g,l,S);break}function n(t,r,...u){h.error("Unknown log level",t),h.error(r,...u)}},getLogLevel:()=>h.getLevel(),proxyResolveTelemetry:g=>{p.$publicLog2("resolveProxy",g)},useHostProxy:b,env:process.env}),s=_(c,o);return L(E,s)}e.connectProxyResolver=D;function _(A,c){const E={config:A.getConfiguration("http").get("proxySupport")||"off"};A.onDidChangeConfiguration(p=>{E.config=A.getConfiguration("http").get("proxySupport")||"off"});const h={config:!!A.getConfiguration("http").get("systemCertificates")};return A.onDidChangeConfiguration(p=>{h.config=!!A.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},m,(0,P.createHttpPatch)(m,c,{config:"off"},h,!0)),on:Object.assign({},m,(0,P.createHttpPatch)(m,c,{config:"on"},h,!0)),override:Object.assign({},m,(0,P.createHttpPatch)(m,c,{config:"override"},h,!0)),onRequest:Object.assign({},m,(0,P.createHttpPatch)(m,c,E,h,!0)),default:Object.assign(m,(0,P.createHttpPatch)(m,c,E,h,!1))},https:{off:Object.assign({},i,(0,P.createHttpPatch)(i,c,{config:"off"},h,!0)),on:Object.assign({},i,(0,P.createHttpPatch)(i,c,{config:"on"},h,!0)),override:Object.assign({},i,(0,P.createHttpPatch)(i,c,{config:"override"},h,!0)),onRequest:Object.assign({},i,(0,P.createHttpPatch)(i,c,E,h,!0)),default:Object.assign(i,(0,P.createHttpPatch)(i,c,E,h,!1))},tls:Object.assign(y,(0,P.createTlsPatch)(y))}}const I=new Map;function L(A,c){return A.getExtensionPathIndex().then(E=>{const h=J.__$__nodeRequire("module"),p=h._load;h._load=function(T,b,o){if(T==="tls")return c.tls;if(T!=="http"&&T!=="https")return p.apply(this,arguments);const s=c[T],g=E.findSubstr(C.URI.file(b.filename));let l=I.get(g);if(l||I.set(g,l={}),!l[T]){let S=s.default;l[T]={...S}}return l[T]}})}}),define(ve[278],we([0,1,37,9,79,30,12,8,92,279]),function(J,e,m,i,y,C,P,D,_,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const L=I.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function A(o,s,g,l){const S=c(o,s,g,l),n=s.folder.fsPath;return{cmd:m.spawn(L,S.args,{cwd:n}),rgDiskPath:L,siblingClauses:S.siblingClauses,rgArgs:S,cwd:n}}e.spawnRipgrepCmd=A;function c(o,s,g,l){const S=["--files","--hidden","--case-sensitive"];h([s],g,!1).forEach(t=>{const r=(0,_.anchorGlob)(t);if(S.push("-g",r),P.isMacintosh){const u=(0,y.normalizeNFD)(r);u!==r&&S.push("-g",u)}});const n=E([s],l,void 0,!1);return n.globArgs.forEach(t=>{const r=`!${(0,_.anchorGlob)(t)}`;if(S.push("-g",r),P.isMacintosh){const u=(0,y.normalizeNFD)(r);u!==r&&S.push("-g",u)}}),s.disregardIgnoreFiles!==!1?S.push("--no-ignore"):S.push("--no-ignore-parent"),s.ignoreSymlinks||S.push("--follow"),o.exists&&S.push("--quiet"),S.push("--no-config"),s.disregardGlobalIgnoreFiles&&S.push("--no-ignore-global"),{args:S,siblingClauses:n.siblingClauses}}function E(o,s,g,l=!0){const S=[];let n={};return o.forEach(t=>{const r=Object.assign({},t.excludePattern||{},s||{}),u=p(r,l?t.folder.fsPath:void 0,g);S.push(...u.globArgs),u.siblingClauses&&(n=Object.assign(n,u.siblingClauses))}),{globArgs:S,siblingClauses:n}}e.foldersToRgExcludeGlobs=E;function h(o,s,g=!0){const l=[];return o.forEach(S=>{const n=Object.assign({},s||{},S.includePattern||{}),t=p(n,g?S.folder.fsPath:void 0);l.push(...t.globArgs)}),l}e.foldersToIncludeGlobs=h;function p(o,s,g){const l=[],S={};return Object.keys(o).forEach(n=>{if(g&&g.has(n)||!n)return;const t=o[n];n=T(s?v(s,n):n),n.startsWith("\\\\")?n="\\\\"+n.substr(2).replace(/\\/g,"/"):n=n.replace(/\\/g,"/"),typeof t=="boolean"&&t?(n.startsWith("\\\\")&&(n+="**"),l.push(b(n))):t&&t.when&&(S[n]=t)}),{globArgs:l,siblingClauses:S}}function v(o,s){return i.isAbsolute(s)?s:i.join(o,s)}e.getAbsoluteGlob=v;function T(o){return o=D.rtrim(o,"\\"),D.rtrim(o,"/")}function b(o){return C.getRoot(o).toLowerCase()==="c:/"?o.replace(/^c:[/\\]/i,"/"):o}e.fixDriveC=b}),define(ve[280],we([0,1,37,60,9,103,16,50,31,79,30,12,46,8,13,28,33,278,100]),function(J,e,m,i,y,C,P,D,_,I,L,A,c,E,h,p,v,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const o=new Set;process.on("exit",()=>{o.forEach(n=>n())});class s{constructor(t){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=t,this.filePattern=t.filePattern||"",this.includePattern=t.includePattern&&_.parse(t.includePattern),this.maxResults=t.maxResults||null,this.exists=!!t.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,b.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=t.excludePattern&&_.parse(t.excludePattern),this.folderExcludePatterns=new Map,t.folderQueries.forEach(r=>{const u=Object.assign({},r.excludePattern||{},this.config.excludePattern||{}),a=r.folder.fsPath;t.folderQueries.map(f=>f.folder.fsPath).filter(f=>f!==a).forEach(f=>{(0,L.isEqualOrParent)(f,a)&&(u[y.relative(a,f)]=!0)}),this.folderExcludePatterns.set(a,new l(u,a))})}cancel(){this.isCanceled=!0,o.forEach(t=>t())}walk(t,r,u,a,f){if(this.fileWalkSW=c.StopWatch.create(!1),this.isCanceled)return f(null,this.isLimitHit);r.forEach(w=>{const d=y.basename(w.fsPath);this.globalExcludePattern&&this.globalExcludePattern(w.fsPath,d)||this.matchFile(u,{relativePath:w.fsPath,searchPath:void 0})}),this.cmdSW=c.StopWatch.create(!1),this.parallel(t,(w,d)=>{this.call(this.cmdTraversal,this,w,u,a,k=>{if(k){const R=(0,D.toErrorMessage)(k);console.error(R),this.errors.push(R),d(k,void 0)}else d(null,void 0)})},(w,d)=>{this.fileWalkSW.stop();const k=w?P.coalesce(w)[0]:null;f(k,this.isLimitHit)})}parallel(t,r,u){const a=new Array(t.length),f=new Array(t.length);let w=!1,d=0;if(t.length===0)return u(null,[]);t.forEach((k,R)=>{r(k,(N,x)=>{if(N?(w=!0,a[R]=null,f[R]=N):(a[R]=x,f[R]=null),++d===t.length)return u(w?f:null,a)})})}call(t,r,...u){try{t.apply(r,u)}catch(a){u[u.length-1](a)}}cmdTraversal(t,r,u,a){const f=t.folder.fsPath,w=A.isMacintosh;let d;const k=()=>d&&d.kill();o.add(k);let R=M=>{o.delete(k),R=()=>{},a(M)},N="";const x=this.initDirectoryTree();let F;const B=(0,T.spawnRipgrepCmd)(this.config,t,this.config.includePattern,this.folderExcludePatterns.get(t.folder.fsPath).expression);d=B.cmd,F=!Object.keys(B.siblingClauses).length;const O=B.rgArgs.args.map(M=>M.match(/^-/)?M:`'${M}'`).join(" ");let H=`${B.rgDiskPath} ${O}
 - cwd: ${B.cwd}`;B.rgArgs.siblingClauses&&(H+=`
 - Sibling clauses: ${JSON.stringify(B.rgArgs.siblingClauses)}`),u({message:H}),this.cmdResultCount=0,this.collectStdout(d,"utf8",u,(M,W,z)=>{if(M){R(M);return}if(this.isLimitHit){R();return}const V=(N+(w?I.normalizeNFC(W||""):W)).split(`
`);if(z){const K=V.length;V[K-1]=V[K-1].trim(),V[K-1]||V.pop()}else N=V.pop()||"";if(V.length&&V[0].indexOf(`
`)!==-1){R(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=V.length,F){for(const K of V)if(this.matchFile(r,{base:f,relativePath:K,searchPath:this.getSearchPath(t,K)}),this.isLimitHit){k();break}(z||this.isLimitHit)&&R();return}this.addDirectoryEntries(t,x,f,V,r),z&&(this.matchDirectoryTree(x,f,r),R())})}spawnFindCmd(t){const r=this.folderExcludePatterns.get(t.folder.fsPath),u=r.getBasenameTerms(),a=r.getPathTerms(),f=["-L","."];if(u.length||a.length){f.push("-not","(","(");for(const w of u)f.push("-name",w),f.push("-o");for(const w of a)f.push("-path",w),f.push("-o");f.pop(),f.push(")","-prune",")")}return f.push("-type","f"),m.spawn("find",f,{cwd:t.folder.fsPath})}readStdout(t,r,u){let a="";this.collectStdout(t,r,()=>{},(f,w,d)=>{if(f){u(f);return}a+=w,d&&u(null,a)})}collectStdout(t,r,u,a){let f=(k,R,N)=>{(k||N)&&(f=()=>{},this.cmdSW&&this.cmdSW.stop()),a(k,R,N)},w=!1;t.stdout?(this.forwardData(t.stdout,r,f),t.stdout.once("data",()=>w=!0)):u({message:"stdout is null"});let d;t.stderr?d=this.collectData(t.stderr):u({message:"stderr is null"}),t.on("error",k=>{f(k)}),t.on("close",k=>{let R;!w&&(R=this.decodeData(d,r))&&S(R)?f(new Error(`command failed with error code ${k}: ${this.decodeData(d,r)}`)):(this.exists&&k===0&&(this.isLimitHit=!0),f(null,"",!0))})}forwardData(t,r,u){const a=new C.StringDecoder(r);return t.on("data",f=>{u(null,a.write(f))}),a}collectData(t){const r=[];return t.on("data",u=>{r.push(u)}),r}decodeData(t,r){const u=new C.StringDecoder(r);return t.map(a=>u.write(a)).join("")}initDirectoryTree(){const t={rootEntries:[],pathToEntries:Object.create(null)};return t.pathToEntries["."]=t.rootEntries,t}addDirectoryEntries(t,{pathToEntries:r},u,a,f){a.indexOf(this.filePattern)!==-1&&this.matchFile(f,{base:u,relativePath:this.filePattern,searchPath:this.getSearchPath(t,this.filePattern)});const w=d=>{const k=y.basename(d),R=y.dirname(d);let N=r[R];N||(N=r[R]=[],w(R)),N.push({base:u,relativePath:d,basename:k,searchPath:this.getSearchPath(t,d)})};a.forEach(w)}matchDirectoryTree({rootEntries:t,pathToEntries:r},u,a){const f=this,w=this.folderExcludePatterns.get(u),d=this.filePattern;function k(R){f.directoriesWalked++;const N=_.hasSiblingFn(()=>R.map(x=>x.basename));for(let x=0,F=R.length;x<F;x++){const B=R[x],{relativePath:O,basename:H}=B;if(w.test(O,H,d!==H?N:void 0))continue;const M=r[O];if(M)k(M);else{if(f.filesWalked++,O===d)continue;f.matchFile(a,B)}if(f.isLimitHit)break}}k(t)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(t,r,u,a,f){const w=t.folder,d=_.hasSiblingFn(()=>u);this.parallel(u,(k,R)=>{if(this.isCanceled||this.isLimitHit)return R(null);const N=r?[r,k].join(y.sep):k;if(this.folderExcludePatterns.get(t.folder.fsPath).test(N,k,this.config.filePattern!==k?d:void 0))return R(null);const x=[w.fsPath,N].join(y.sep);i.lstat(x,(F,B)=>{if(F||this.isCanceled||this.isLimitHit)return R(null);this.statLinkIfNeeded(x,B,(O,H)=>O||this.isCanceled||this.isLimitHit?R(null):H.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(x,B,(M,W)=>M||this.isCanceled||this.isLimitHit||(W=W||"",this.walkedPaths[W])?R(null):(this.walkedPaths[W]=!0,p.Promises.readdir(x).then(z=>{if(this.isCanceled||this.isLimitHit)return R(null);this.doWalk(t,N,z,a,U=>R(U||null))},z=>{R(null)})))):(this.filesWalked++,N===this.filePattern||this.maxFilesize&&h.isNumber(H.size)&&H.size>this.maxFilesize||this.matchFile(a,{base:w.fsPath,relativePath:N,searchPath:this.getSearchPath(t,N)}),R(null,void 0)))})},k=>{const R=k&&P.coalesce(k);return f(R&&R.length>0?R[0]:void 0)})}matchFile(t,r){this.isFileMatch(r)&&(!this.includePattern||this.includePattern(r.relativePath,y.basename(r.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||t(r))}isFileMatch(t){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,v.isFilePatternMatch)(t,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(t,r,u){return r.isSymbolicLink()?i.stat(t,u):u(null,r)}realPathIfNeeded(t,r,u){return r.isSymbolicLink()?i.realpath(t,(a,f)=>a?u(a):u(null,f)):u(null,t)}getSearchPath(t,r){return t.folderName?y.join(t.folderName,r):r}}e.FileWalker=s;class g{constructor(t){this.folderQueries=t.folderQueries,this.extraFiles=t.extraFileResources||[],this.walker=new s(t)}search(t,r,u){this.walker.walk(this.folderQueries,this.extraFiles,t,r,(a,f)=>{u(a,{limitHit:f,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=g;class l{constructor(t,r){this.expression=t,this.root=r,this.init(t)}init(t){let r,u;Object.keys(t).filter(a=>t[a]).forEach(a=>{y.isAbsolute(a)?(r=r||_.getEmptyExpression(),r[a]=t[a]):(u=u||_.getEmptyExpression(),u[a]=t[a])}),this.absoluteParsedExpr=r&&_.parse(r,{trimForExclusions:!0}),this.relativeParsedExpr=u&&_.parse(u,{trimForExclusions:!0})}test(t,r,u){return this.relativeParsedExpr&&this.relativeParsedExpr(t,r,u)||this.absoluteParsedExpr&&this.absoluteParsedExpr(y.join(this.root,t),r,u)}getBasenameTerms(){const t=[];return this.absoluteParsedExpr&&t.push(..._.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&t.push(..._.getBasenameTerms(this.relativeParsedExpr)),t}getPathTerms(){const t=[];return this.absoluteParsedExpr&&t.push(..._.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&t.push(..._.getPathTerms(this.relativeParsedExpr)),t}}function S(n){const t=n.trim().split(`
`),r=t[0].trim();if(r.startsWith("Error parsing regex"))return r;if(r.startsWith("regex parse error"))return E.uppercaseFirstLetter(t[t.length-1].trim());if(r.startsWith("error parsing glob")||r.startsWith("unsupported encoding"))return r.charAt(0).toUpperCase()+r.substr(1);if(r==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(r.startsWith("Literal "))return r}e.rgErrorMsgForDisplay=S}),define(ve[136],we([0,1,37,294,103,16,74,31,9,8,2,33,69,295,279,92]),function(J,e,m,i,y,C,P,D,_,I,L,A,c,E,h,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const v=h.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class T{constructor(w){this.outputChannel=w}provideTextSearchResults(w,d,k,R){return this.outputChannel.appendLine(`provideTextSearchResults ${w.pattern}, ${JSON.stringify({...d,folder:d.folder.toString()})}`),new Promise((N,x)=>{R.onCancellationRequested(()=>U());const F=S(w,d),B=d.folder.fsPath,O=F.map(Y=>Y.match(/^-/)?Y:`'${Y}'`).join(" ");this.outputChannel.appendLine(`${v} ${O}
 - cwd: ${B}`);let H=m.spawn(v,F,{cwd:B});H.on("error",Y=>{console.error(Y),this.outputChannel.appendLine("Error: "+(Y&&Y.message)),x((0,A.serializeSearchError)(new A.SearchError(Y&&Y.message,A.SearchErrorCode.rgProcessError)))});let M=!1;const W=new s(d.maxResults,B,d.previewOptions);W.on("result",Y=>{M=!0,K="",k.report(Y)});let z=!1;const U=()=>{z=!0,H&&H.kill(),W&&W.cancel()};let V=!1;W.on("hitLimit",()=>{V=!0,U()});let K="";H.stdout.on("data",Y=>{W.handleData(Y),M||(K+=Y)});let G=!1;H.stdout.once("data",()=>G=!0);let Q="";H.stderr.on("data",Y=>{const fe=Y.toString();this.outputChannel.appendLine(fe),Q+=fe}),H.on("close",()=>{if(this.outputChannel.appendLine(G?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(M?"Got result from parser":"No result from parser"),K&&this.outputChannel.appendLine(`Got data without result: ${K}`),this.outputChannel.appendLine(""),z)N({limitHit:V});else{W.flush(),H=null;let Y;Q&&!G&&(Y=b(Q))?x((0,A.serializeSearchError)(new A.SearchError(Y.message,Y.code))):N({limitHit:V})}})})}}e.RipgrepTextSearchEngine=T;function b(f){const w=f.split(`
`),d=w[0].trim();if(w.some(R=>R.startsWith("regex parse error")))return new A.SearchError(o(w),A.SearchErrorCode.regexParseError);const k=d.match(/grep config error: unknown encoding: (.*)/);if(k)return new A.SearchError(`Unknown encoding: ${k[1]}`,A.SearchErrorCode.unknownEncoding);if(d.startsWith("error parsing glob"))return new A.SearchError(d.charAt(0).toUpperCase()+d.substr(1),A.SearchErrorCode.globParseError);if(d.startsWith("the literal"))return new A.SearchError(d.charAt(0).toUpperCase()+d.substr(1),A.SearchErrorCode.invalidLiteral);if(d.startsWith("PCRE2: error compiling pattern"))return new A.SearchError(d,A.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=b;function o(f){const w=["Regex parse error"],d=f.filter(k=>k.startsWith("PCRE2:"));if(d.length>=1){const k=d[0].replace("PCRE2:","");if(k.indexOf(":")!==-1&&k.split(":").length>=2){const R=k.split(":")[1];w.push(":"+R)}}return w.join("")}e.buildRegexParseError=o;class s extends i.EventEmitter{constructor(w,d,k){super();this.maxResults=w,this.rootFolder=d,this.previewOptions=k,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new y.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(w,d){return super.on(w,d),this}handleData(w){if(this.isDone)return;const d=typeof w=="string"?w:this.stringDecoder.write(w);this.handleDecodedData(d)}handleDecodedData(w){let d=w.indexOf(`
`);const k=this.remainder+w;if(d>=0)d+=this.remainder.length;else{this.remainder=k;return}let R=0;for(;d>=0;)this.handleLine(k.substring(R,d).trim()),R=d+1,d=k.indexOf(`
`,R);this.remainder=k.substring(R)}handleLine(w){if(this.isDone||!w)return;let d;try{d=JSON.parse(w)}catch{throw new Error(`malformed line from rg: ${w}`)}if(d.type==="match"){const k=g(d.data.path),R=L.URI.file(_.join(this.rootFolder,k)),N=this.createTextSearchMatch(d.data,R);this.onResult(N),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(d.type==="context"){const k=g(d.data.path),R=L.URI.file(_.join(this.rootFolder,k));this.createTextSearchContext(d.data,R).forEach(x=>this.onResult(x))}}createTextSearchMatch(w,d){const k=w.line_number-1,R=g(w.lines),N=Buffer.from(R);let x=0,F=0,B=k;w.submatches.length===0&&w.submatches.push(R.length?{start:0,end:1,match:{text:R[0]}}:{start:0,end:0,match:{text:""}});const O=(0,C.coalesce)(w.submatches.map((H,M)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const W=g(H.match),z=N.slice(x,H.start).toString().length,U=F+z,V=l(W),K=B,G=V.numLines+K,Q=V.numLines>0?V.lastLineLength:V.lastLineLength+U;return x=H.end,F=Q,B=G,new c.Range(K,U,G,Q)}));return(0,p.createTextSearchResult)(d,R,O,this.previewOptions)}createTextSearchContext(w,d){const k=g(w.lines),R=w.line_number;return k.replace(/\r?\n$/,"").split(`
`).map((N,x)=>({text:N,uri:d,lineNumber:R+x}))}onResult(w){this.emit("result",w)}}e.RipgrepParser=s;function g(f){return f.bytes?Buffer.from(f.bytes,"base64").toString():f.text}function l(f){const w=/\n/g;let d=0,k=-1,R;for(;R=w.exec(f);)d++,k=R.index;const N=k>=0?f.length-k-1:f.length;return{numLines:d,lastLineLength:N}}function S(f,w){const d=["--hidden"];d.push(f.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:k,otherIncludes:R}=(0,P.groupBy)(w.includes,x=>x.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(R&&R.length){const x=new Set;R.forEach(F=>{x.add(F)}),d.push("-g","!*"),x.forEach(F=>{n(F).map(p.anchorGlob).forEach(B=>{d.push("-g",B)})})}k&&k.length&&k.forEach(x=>{d.push("-g",x)}),w.excludes.map(p.anchorGlob).forEach(x=>d.push("-g",`!${x}`)),w.maxFileSize&&d.push("--max-filesize",w.maxFileSize+""),w.useIgnoreFiles?d.push("--no-ignore-parent"):d.push("--no-ignore"),w.followSymlinks&&d.push("--follow"),w.encoding&&w.encoding!=="utf8"&&d.push("--encoding",w.encoding),f.pattern==="--"&&(f.isRegExp=!0,f.pattern="\\-\\-"),f.isMultiline&&!f.isRegExp&&(f.pattern=(0,I.escapeRegExpCharacters)(f.pattern),f.isRegExp=!0),w.usePCRE2&&d.push("--pcre2"),d.push("--crlf"),f.isRegExp&&(f.pattern=t(f.pattern),d.push("--auto-hybrid-regex"));let N;if(f.isWordMatch){const F=(0,I.createRegExp)(f.pattern,!!f.isRegExp,{wholeWord:f.isWordMatch}).source.replace(/\\\//g,"/");d.push("--regexp",F)}else if(f.isRegExp){let x=u(f.pattern);x=a(x),d.push("--regexp",x)}else N=f.pattern,d.push("--fixed-strings");return d.push("--no-config"),w.useGlobalIgnoreFiles||d.push("--no-ignore-global"),d.push("--json"),f.isMultiline&&d.push("--multiline"),w.beforeContext&&d.push("--before-context",w.beforeContext+""),w.afterContext&&d.push("--after-context",w.afterContext+""),d.push("--"),N&&d.push(N),d.push("."),d}function n(f){const w=(0,D.splitGlobAware)(f,"/");return w.map((d,k)=>w.slice(0,k+1).join("/"))}e.spreadGlobComponents=n;function t(f){const w=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;f.match(w);)f=f.replace(w,"$1\\x{$2}");const d=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;f.match(d);)f=f.replace(d,"$1\\x{$2}");return f}e.unicodeEscapesToPCRE2=t;const r=f=>f.type==="Assertion"&&f.kind==="lookbehind";function u(f){let w;try{w=new E.RegExpParser().parsePattern(f)}catch{return f}let d="",k=0;const R=(F,B,O)=>{d+=f.slice(k,F)+O,k=B},N=[];return new E.RegExpVisitor({onCharacterEnter(F){if(F.raw!=="\\n")return;const B=N[0];if(!B)R(F.start,F.end,"\\r?\\n");else if(!N.some(r))if(B.type==="CharacterClass")if(B.negate){const O=f.slice(B.start+2,F.start)+f.slice(F.end,B.end-1);if(B.parent?.type==="Quantifier"){const H=B.parent;R(H.start,H.end,(O?`[^${O}]`:".")+(H.greedy?"+":"*"))}else R(B.start,B.end,"(?!\\r?\\n"+(O?`|[${O}]`:"")+")")}else{const O=f.slice(B.start+1,F.start)+f.slice(F.end,B.end-1);R(B.start,B.end,O===""?"\\r?\\n":`(?:[${O}]|\\r?\\n)`)}else B.type==="Quantifier"&&R(F.start,F.end,"(?:\\r?\\n)")},onQuantifierEnter(F){N.unshift(F)},onQuantifierLeave(){N.shift()},onCharacterClassRangeEnter(F){N.unshift(F)},onCharacterClassRangeLeave(){N.shift()},onCharacterClassEnter(F){N.unshift(F)},onCharacterClassLeave(){N.shift()},onAssertionEnter(F){r(F)&&N.push(F)},onAssertionLeave(F){N[0]===F&&N.shift()}}).visit(w),d+=f.slice(k),d}e.fixRegexNewline=u;function a(f){return f.replace(/\n/g,"\\r?\\n")}e.fixNewline=a}),define(ve[281],we([0,1,21,136,117,10]),function(J,e,m,i,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class P{constructor(I){this.outputChannel=I,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(I,L,A,c){const E=new i.RipgrepTextSearchEngine(this.outputChannel);if(L.folder.scheme===C.Schemas.userData){const h={...L,folder:L.folder.with({scheme:C.Schemas.file})},p=new y.Progress(v=>A.report({...v,uri:v.uri.with({scheme:L.folder.scheme})}));return this.withToken(c,v=>E.provideTextSearchResults(I,h,p,v))}else return this.withToken(c,h=>E.provideTextSearchResults(I,L,A,h))}async withToken(I,L){const A=D(I);this.inProgress.add(A);const c=await L(A.token);return this.inProgress.delete(A),c}dispose(){this.inProgress.forEach(I=>I.cancel())}}e.RipgrepSearchProvider=P;function D(_){const I=new m.CancellationTokenSource;return _.onCancellationRequested(()=>I.cancel()),I}}),define(ve[282],we([0,1,28,136,135]),function(J,e,m,i,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class C{constructor(_){this.query=_}search(_,I,L){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const A={appendLine(E){L({message:E})}},c=new y.NativeTextSearchManager(this.query,new i.RipgrepTextSearchEngine(A),m);return new Promise((E,h)=>c.search(p=>{I(p.map(P))},_).then(p=>E({limitHit:p.limitHit,type:"success",stats:p.stats}),h))}}e.TextSearchEngineAdapter=C;function P(D){return{path:D.resource&&D.resource.fsPath,results:D.results,numMatches:(D.results||[]).reduce((_,I)=>{if(I.ranges){const L=I;return _+(Array.isArray(L.ranges)?L.ranges.length:1)}else return _+1},0)}}}),define(ve[283],we([0,1,16,18,15,3,100,9,46,2,42,33,280,282]),function(J,e,m,i,y,C,P,D,_,I,L,A,c,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0;class h{constructor(s="searchProcess"){this.processType=s,this.caches=Object.create(null)}fileSearch(s){let g;const l=T(s),S=new C.Emitter({onFirstListenerDidAdd:()=>{g=(0,i.createCancelablePromise)(n=>this.doFileSearchWithEngine(c.Engine,l,t=>S.fire(t),n)),g.then(n=>S.fire(n),n=>S.fire({type:"error",error:{message:n.message,stack:n.stack}}))},onLastListenerRemove:()=>{g.cancel()}});return S.event}textSearch(s){let g;const l=T(s),S=new C.Emitter({onFirstListenerDidAdd:()=>{g=(0,i.createCancelablePromise)(n=>this.ripgrepTextSearch(l,t=>S.fire(t),n)),g.then(n=>S.fire(n),n=>S.fire({type:"error",error:{message:n.message,stack:n.stack}}))},onLastListenerRemove:()=>{g.cancel()}});return S.event}ripgrepTextSearch(s,g,l){return s.maxFileSize=(0,L.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new E.TextSearchEngineAdapter(s).search(l,g,g)}doFileSearch(s,g,l){return this.doFileSearchWithEngine(c.Engine,s,g,l)}doFileSearchWithEngine(s,g,l,S,n=h.BATCH_SIZE){let t=0;const r=a=>{Array.isArray(a)?(t+=a.length,l(a.map(f=>this.rawMatchToSearchItem(f)))):a.relativePath?(t++,l(this.rawMatchToSearchItem(a))):l(a)};if(g.sortByScore){let a=this.trySortedSearchFromCache(g,r,S);if(!a){const f=g.maxResults?Object.assign({},g,{maxResults:null}):g,w=new s(f);a=this.doSortedSearch(w,g,l,r,S)}return new Promise((f,w)=>{a.then(([d,k])=>{const R=k.map(N=>this.rawMatchToSearchItem(N));this.sendProgress(R,l,n),f(d)},w)})}const u=new s(g);return this.doSearch(u,r,n,S).then(a=>({limitHit:a.limitHit,type:"success",stats:{detailStats:a.stats,type:this.processType,fromCache:!1,resultCount:t,sortingTime:void 0}}))}rawMatchToSearchItem(s){return{path:s.base?(0,D.join)(s.base,s.relativePath):s.relativePath}}doSortedSearch(s,g,l,S,n){const t=new C.Emitter;let r=(0,i.createCancelablePromise)(a=>{let f=[];const w=d=>{Array.isArray(d)?f=d:(S(d),t.fire(d))};return this.doSearch(s,w,-1,a).then(d=>[d,f])}),u;if(g.cacheKey){u=this.getOrCreateCache(g.cacheKey);const a={promise:r,event:t.event,resolved:!1};u.resultsToSearchCache[g.filePattern||""]=a,r.then(()=>{a.resolved=!0},f=>{delete u.resultsToSearchCache[g.filePattern||""]}),r=this.preventCancellation(r)}return r.then(([a,f])=>{const w=u?u.scorerCache:Object.create(null),d=(typeof g.maxResults!="number"||g.maxResults>0)&&_.StopWatch.create(!1);return this.sortResults(g,f,w,n).then(k=>{const R=d?d.elapsed():-1;return[{type:"success",stats:{detailStats:a.stats,sortingTime:R,fromCache:!1,type:this.processType,workspaceFolderCount:g.folderQueries.length,resultCount:k.length},messages:a.messages,limitHit:a.limitHit||typeof g.maxResults=="number"&&f.length>g.maxResults},k]})})}getOrCreateCache(s){const g=this.caches[s];return g||(this.caches[s]=new p)}trySortedSearchFromCache(s,g,l){const S=s.cacheKey&&this.caches[s.cacheKey];if(!S)return;const n=this.getResultsFromCache(S,s.filePattern||"",g,l);if(n)return n.then(([t,r,u])=>{const a=_.StopWatch.create(!1);return this.sortResults(s,r,S.scorerCache,l).then(f=>{const w=a.elapsed(),d={fromCache:!0,detailStats:u,type:this.processType,resultCount:r.length,sortingTime:w};return[{type:"success",limitHit:t.limitHit||typeof s.maxResults=="number"&&r.length>s.maxResults,stats:d},f]})})}sortResults(s,g,l,S){const n=(0,P.prepareQuery)(s.filePattern||""),t=(u,a)=>(0,P.compareItemsByFuzzyScore)(u,a,n,!0,v,l),r=typeof s.maxResults=="number"?s.maxResults:Number.MAX_VALUE;return m.topAsync(g,t,r,1e4,S)}sendProgress(s,g,l){if(l&&l>0)for(let S=0;S<s.length;S+=l)g(s.slice(S,S+l));else g(s)}getResultsFromCache(s,g,l,S){const n=_.StopWatch.create(!1),t=g.indexOf(D.sep)>=0;let r;for(const w in s.resultsToSearchCache)if(g.startsWith(w)){if(t&&w.indexOf(D.sep)<0&&w!=="")continue;const d=s.resultsToSearchCache[w];r={promise:this.preventCancellation(d.promise),event:d.event,resolved:d.resolved};break}if(!r)return null;const u=n.elapsed(),a=_.StopWatch.create(!1),f=r.event(l);return S&&S.onCancellationRequested(()=>{f.dispose()}),r.promise.then(([w,d])=>{if(S&&S.isCancellationRequested)throw(0,y.canceled)();const k=[],R=(0,P.prepareQuery)(g).normalizedLowercase;for(const N of d)!(0,A.isFilePatternMatch)(N,R)||k.push(N);return[w,k,{cacheWasResolved:r.resolved,cacheLookupTime:u,cacheFilterTime:a.elapsed(),cacheEntryCount:d.length}]})}doSearch(s,g,l,S){return new Promise((n,t)=>{let r=[];S&&S.onCancellationRequested(()=>s.cancel()),s.search(u=>{u&&(l?(r.push(u),l>0&&r.length>=l&&(g(r),r=[])):g(u))},u=>{g(u)},(u,a)=>{r.length&&g(r),u?t(u):n(a)})})}clearCache(s){return delete this.caches[s],Promise.resolve(void 0)}preventCancellation(s){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(g,l){return s.then(g,l)}catch(g){return this.then(void 0,g)}finally(g){return s.finally(g)}}}}e.SearchService=h,h.BATCH_SIZE=512;class p{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const v=new class{getItemLabel(o){return(0,D.basename)(o.relativePath)}getItemDescription(o){return(0,D.dirname)(o.relativePath)}getItemPath(o){return o.relativePath}};function T(o){return{...o,folderQueries:o.folderQueries&&o.folderQueries.map(b),extraFileResources:o.extraFileResources&&o.extraFileResources.map(s=>I.URI.revive(s))}}function b(o){return{...o,folder:I.URI.revive(o.folder)}}}),define(ve[284],we([0,1,6,10,2,28,11,26,14,72,64,33,283,281,92,135]),function(J,e,m,i,y,C,P,D,_,I,L,A,c,E,h,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let v=class extends I.ExtHostSearch{constructor(b,o,s,g){super(b,s,g);this._pfs=C,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null,this._registeredEHSearchProvider=!1;const l=new h.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(i.Schemas.userData,new E.RipgrepSearchProvider(l)),o.remote.isRemote&&o.remote.authority&&this._registerEHSearchProviders()}$enableExtensionHostSearch(){this._registerEHSearchProviders()}_registerEHSearchProviders(){if(this._registeredEHSearchProvider)return;this._registeredEHSearchProvider=!0;const b=new h.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(i.Schemas.file,new E.RipgrepSearchProvider(b)),this.registerInternalFileSearchProvider(i.Schemas.file,new c.SearchService("fileSearchProvider"))}registerInternalFileSearchProvider(b,o){const s=this._handlePool++;return this._internalFileSearchProvider=o,this._internalFileSearchHandle=s,this._proxy.$registerFileSearchProvider(s,this._transformScheme(b)),(0,m.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(s)})}$provideFileSearchResults(b,o,s,g){const l=(0,I.reviveQuery)(s);return b===this._internalFileSearchHandle?this.doInternalFileSearch(b,o,l,g):super.$provideFileSearchResults(b,o,s,g)}doInternalFileSearch(b,o,s,g){const l=S=>{if((0,A.isSerializedFileMatch)(S)&&(S=[S]),Array.isArray(S)){this._proxy.$handleFileMatch(b,o,S.map(n=>y.URI.file(n.path)));return}S.message&&this._logService.debug("ExtHostSearch",S.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(s,l,g)}$clearCache(b){return this._internalFileSearchProvider&&this._internalFileSearchProvider.clearCache(b),super.$clearCache(b)}createTextSearchManager(b,o){return new p.NativeTextSearchManager(b,o,void 0,"textSearchProvider")}};v=je([ze(0,_.IExtHostRpcService),ze(1,D.IExtHostInitDataService),ze(2,L.IURITransformerService),ze(3,P.ILogService)],v),e.NativeExtHostSearch=v}),define(ve[137],we([0,1,296,124,81,22,15,3,6,9,12,32,105,106,297]),function(J,e,m,i,y,C,P,D,_,I,L,A,c,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class p{constructor(d,k=""){this.debugLabel=k,this.socket=d,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=R=>{if(this.traceSocketEvent("error",{code:R?.code,message:R?.message}),R){if(R.code==="EPIPE")return;(0,P.onUnexpectedError)(R)}},this.socket.on("error",this._errorListener)}traceSocketEvent(d,k){E.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,d,k)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(d){const k=R=>{this.traceSocketEvent("read",R),d(C.VSBuffer.wrap(R))};return this.socket.on("data",k),{dispose:()=>this.socket.off("data",k)}}onClose(d){const k=R=>{this.traceSocketEvent("close",{hadError:R}),d({type:0,hadError:R,error:void 0})};return this.socket.on("close",k),{dispose:()=>this.socket.off("close",k)}}onEnd(d){const k=()=>{this.traceSocketEvent("nodeEndReceived"),d()};return this.socket.on("end",k),{dispose:()=>this.socket.off("end",k)}}write(d){if(!this.socket.destroyed)try{this.traceSocketEvent("write",d),this.socket.write(d.buffer,k=>{if(k){if(k.code==="EPIPE")return;(0,P.onUnexpectedError)(k)}})}catch(k){if(k.code==="EPIPE")return;(0,P.onUnexpectedError)(k)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((d,k)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),d();return}const R=()=>{this.socket.off("close",R),this.socket.off("end",R),this.socket.off("error",R),this.socket.off("timeout",R),this.socket.off("drain",R),this.traceSocketEvent("nodeDrainEnd"),d()};this.socket.on("close",R),this.socket.on("end",R),this.socket.on("error",R),this.socket.on("timeout",R),this.socket.on("drain",R)})}}e.NodeSocket=p;var v;(function(w){w[w.MinHeaderByteSize=2]="MinHeaderByteSize"})(v||(v={}));var T;(function(w){w[w.PeekHeader=1]="PeekHeader",w[w.ReadHeader=2]="ReadHeader",w[w.ReadBody=3]="ReadBody",w[w.Fin=4]="Fin"})(T||(T={}));class b extends _.Disposable{constructor(d,k,R,N){super();this._onData=this._register(new D.Emitter),this._onClose=this._register(new D.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=d,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:k,inflateBytesLength:R?.byteLength||0,recordInflateBytes:N}),this._flowManager=this._register(new o(this,k,R,N,this._onData,(x,F)=>this._write(x,F))),this._register(this._flowManager.onError(x=>{console.error(x),(0,P.onUnexpectedError)(x),this._onClose.fire({type:0,hadError:!0,error:x})})),this._incomingData=new E.ChunkStream,this._register(this.socket.onData(x=>this._acceptChunk(x))),this._register(this.socket.onClose(x=>this._onClose.fire(x)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(d,k){this.socket.traceSocketEvent(d,k)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(d){return this._onData.event(d)}onClose(d){return this._onClose.event(d)}onEnd(d){return this.socket.onEnd(d)}write(d){this._flowManager.writeMessage(d)}_write(d,k){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",d);let R=2;d.byteLength<126?R+=0:d.byteLength<2**16?R+=2:R+=8;const N=C.VSBuffer.alloc(R);if(k?N.writeUInt8(194,0):N.writeUInt8(130,0),d.byteLength<126)N.writeUInt8(d.byteLength,1);else if(d.byteLength<2**16){N.writeUInt8(126,1);let x=1;N.writeUInt8(d.byteLength>>>8&255,++x),N.writeUInt8(d.byteLength>>>0&255,++x)}else{N.writeUInt8(127,1);let x=1;N.writeUInt8(0,++x),N.writeUInt8(0,++x),N.writeUInt8(0,++x),N.writeUInt8(0,++x),N.writeUInt8(d.byteLength>>>24&255,++x),N.writeUInt8(d.byteLength>>>16&255,++x),N.writeUInt8(d.byteLength>>>8&255,++x),N.writeUInt8(d.byteLength>>>0&255,++x)}this.socket.write(C.VSBuffer.concat([N,d]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(d){if(d.byteLength!==0){for(this._incomingData.acceptChunk(d);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const k=this._incomingData.peek(this._state.readLen),R=k.readUInt8(0),N=(R&128)>>>7,x=(R&64)>>>6,F=k.readUInt8(1),B=(F&128)>>>7,O=F&127;this._state.state=2,this._state.readLen=2+(B?4:0)+(O===126?2:0)+(O===127?8:0),this._state.fin=N,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(x)),this._state.firstFrameOfMessage=Boolean(N),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const k=this._incomingData.read(this._state.readLen),R=k.readUInt8(1),N=(R&128)>>>7;let x=R&127,F=1;x===126?x=k.readUInt8(++F)*2**8+k.readUInt8(++F):x===127&&(x=k.readUInt8(++F)*0+k.readUInt8(++F)*0+k.readUInt8(++F)*0+k.readUInt8(++F)*0+k.readUInt8(++F)*2**24+k.readUInt8(++F)*2**16+k.readUInt8(++F)*2**8+k.readUInt8(++F));let B=0;N&&(B=k.readUInt8(++F)*2**24+k.readUInt8(++F)*2**16+k.readUInt8(++F)*2**8+k.readUInt8(++F)),this._state.state=3,this._state.readLen=x,this._state.mask=B,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const k=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",k),l(k,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",k),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(k,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await D.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=b;class o extends _.Disposable{constructor(d,k,R,N,x,F){super();this._tracer=d,this._onData=x,this._writeFn=F,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new D.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,k?(this._zlibInflateStream=this._register(new s(this._tracer,N,R,{windowBits:15})),this._zlibDeflateStream=this._register(new g(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(B=>this._onError.fire(B))),this._register(this._zlibDeflateStream.onError(B=>this._onError.fire(B)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:C.VSBuffer.alloc(0)}writeMessage(d){this._writeQueue.push(d),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const d=this._writeQueue.shift();if(this._zlibDeflateStream){const k=await this._deflateMessage(this._zlibDeflateStream,d);this._writeFn(k,!0)}else this._writeFn(d,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(d,k){return new Promise((R,N)=>{d.write(k),d.flush(x=>R(x))})}acceptFrame(d,k,R){this._readQueue.push({data:d,isCompressed:k,isLastFrameOfMessage:R}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const d=this._readQueue.shift();if(this._zlibInflateStream&&d.isCompressed){const k=await this._inflateFrame(this._zlibInflateStream,d.data,d.isLastFrameOfMessage);this._onData.fire(k)}else this._onData.fire(d.data)}this._isProcessingReadQueue=!1}}_inflateFrame(d,k,R){return new Promise((N,x)=>{d.write(k),R&&d.write(C.VSBuffer.fromByteArray([0,0,255,255])),d.flush(F=>N(F))})}}class s extends _.Disposable{constructor(d,k,R,N){super();this._tracer=d,this._recordInflateBytes=k,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=h.createInflateRaw(N),this._zlibInflate.on("error",x=>{this._tracer.traceSocketEvent("zlibInflateError",{message:x?.message,code:x?.code}),this._onError.fire(x)}),this._zlibInflate.on("data",x=>{this._tracer.traceSocketEvent("zlibInflateData",x),this._pendingInflateData.push(C.VSBuffer.wrap(x))}),R&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",R.buffer),this._zlibInflate.write(R.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?C.VSBuffer.concat(this._recordedInflateBytes):C.VSBuffer.alloc(0)}write(d){this._recordInflateBytes&&this._recordedInflateBytes.push(d.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",d),this._zlibInflate.write(d.buffer)}flush(d){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const k=C.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,d(k)})}}class g extends _.Disposable{constructor(d,k){super();this._tracer=d,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=h.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",R=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:R?.message,code:R?.code}),this._onError.fire(R)}),this._zlibDeflate.on("data",R=>{this._tracer.traceSocketEvent("zlibDeflateData",R),this._pendingDeflateData.push(C.VSBuffer.wrap(R))})}write(d){this._tracer.traceSocketEvent("zlibDeflateWrite",d.buffer),this._zlibDeflate.write(d.buffer)}flush(d){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let k=C.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,k=k.slice(0,k.byteLength-4),d(k)})}}function l(w,d){if(d===0)return;let k=w.byteLength>>>2;for(let O=0;O<k;O++){const H=w.readUInt32BE(O*4);w.writeUInt32BE(H^d,O*4)}let R=k*4,N=w.byteLength-R;const x=d>>>24&255,F=d>>>16&255,B=d>>>8&255;N>=1&&w.writeUInt8(w.readUInt8(R)^x,R),N>=2&&w.writeUInt8(w.readUInt8(R+1)^F,R+1),N>=3&&w.writeUInt8(w.readUInt8(R+2)^B,R+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const S={[2]:107,[1]:103};function n(){const w=(0,A.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${w}-sock`;let d;return e.XDG_RUNTIME_DIR?d=(0,I.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${w}.sock`):d=(0,I.join)((0,y.tmpdir)(),`vscode-ipc-${w}.sock`),r(d),d}e.createRandomIPCHandle=n;function t(w,d,k){const R=(0,m.createHash)("md5").update(w).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${R}-${k}-${d}-sock`;let N;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?N=(0,I.join)(e.XDG_RUNTIME_DIR,`vscode-${R.substr(0,8)}-${k}-${d}.sock`):N=(0,I.join)(w,`${k}-${d}.sock`),r(N),N}e.createStaticIPCHandle=t;function r(w){const d=S[L.platform];typeof d=="number"&&w.length>=d&&console.warn(`WARNING: IPC handle "${w}" is longer than ${d} chars, try a shorter --user-data-dir`)}class u extends c.IPCServer{constructor(d){super(u.toClientConnectionEvent(d));this.server=d}static toClientConnectionEvent(d){const k=D.Event.fromNodeEventEmitter(d,"connection");return D.Event.map(k,R=>({protocol:new E.Protocol(new p(R,"ipc-server-connection")),onDidClientDisconnect:D.Event.once(D.Event.fromNodeEventEmitter(R,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=u;function a(w){return new Promise((d,k)=>{const R=(0,i.createServer)();R.on("error",k),R.listen(w,()=>{R.removeListener("error",k),d(new u(R))})})}e.serve=a;function f(w,d){return new Promise((k,R)=>{const N=(0,i.createConnection)(w,()=>{N.removeListener("error",R),k(E.Client.fromSocket(new p(N,`ipc-client${d}`),d))});N.once("error",R)})}e.connect=f}),define(ve[285],we([0,1,137,277,60,38,2,197,11]),function(J,e,m,i,y,C,P,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class I{constructor(c,E,h){this._commands=c,this.logService=E,this._ipcHandlePath=h,this._server=i.createServer((p,v)=>this.onRequest(p,v)),this.setup().catch(p=>(E.error(p),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",c=>this.logService.error(c))}catch{this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(c,E){const h=[];c.setEncoding("utf8"),c.on("data",p=>h.push(p)),c.on("end",()=>{const p=JSON.parse(h.join(""));switch(p.type){case"open":this.open(p,E);break;case"openExternal":this.openExternal(p,E);break;case"status":this.getStatus(p,E);break;case"extensionManagement":this.manageExtensions(p,E).catch(this.logService.error);break;default:E.writeHead(404),E.write(`Unknown message type: ${p.type}`,v=>{v&&this.logService.error(v)}),E.end();break}})}open(c,E){const{fileURIs:h,folderURIs:p,forceNewWindow:v,diffMode:T,addMode:b,forceReuseWindow:o,gotoLineMode:s,waitMarkerFilePath:g,remoteAuthority:l}=c,S=[];if(Array.isArray(p))for(const u of p)try{S.push({folderUri:P.URI.parse(u)})}catch{}if(Array.isArray(h))for(const u of h)try{(0,D.hasWorkspaceFileExtension)(u)?S.push({workspaceUri:P.URI.parse(u)}):S.push({fileUri:P.URI.parse(u)})}catch{}const n=g?P.URI.file(g):void 0,r={forceNewWindow:v,diffMode:T,addMode:b,gotoLineMode:s,forceReuseWindow:o,preferNewWindow:!o&&!n&&!b,waitMarkerFileURI:n,remoteAuthority:l};this._commands.executeCommand("_remoteCLI.windowOpen",S,r),E.writeHead(200),E.end()}async openExternal(c,E){for(const h of c.uris){const p=P.URI.parse(h),v=p.scheme==="file"?p:h;await this._commands.executeCommand("_remoteCLI.openExternal",v)}E.writeHead(200),E.end()}async manageExtensions(c,E){try{const h=T=>T?.map(b=>/\.vsix$/i.test(b)?P.URI.parse(b):b),p={list:c.list,install:h(c.install),uninstall:h(c.uninstall),force:c.force},v=await this._commands.executeCommand("_remoteCLI.manageExtensions",p);E.writeHead(200),E.write(v)}catch(h){E.writeHead(500),E.write(String(h),p=>{p&&this.logService.error(p)})}E.end()}async getStatus(c,E){try{const h=await this._commands.executeCommand("_remoteCLI.getSystemStatus");E.writeHead(200),E.write(h),E.end()}catch(h){E.writeHead(500),E.write(String(h),p=>{p&&this.logService.error(p)}),E.end()}}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&y.existsSync(this._ipcHandlePath)&&y.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=I;let L=class extends I{constructor(c,E){super(c,E,(0,m.createRandomIPCHandle)())}};L=je([ze(0,C.IExtHostCommands),ze(1,_.ILogService)],L),e.CLIServer=L}),define(ve[286],we([0,1,71,273,268,5,276,39,258,2,10,7,285,104]),function(J,e,m,i,y,C,P,D,_,I,L,A,c,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class h extends y.RequireInterceptor{_installInterceptor(){const T=this,b=J.__$__nodeRequire("module"),o=b._load;b._load=function(g,l,S){for(let n of T._alternatives){let t=n(g);if(t){g=t;break}}return T._factories.has(g)?T._factories.get(g).load(g,I.URI.file((0,E.realpathSync)(l.filename)),n=>o.apply(this,[n,l,S])):o.apply(this,arguments)}}}class p extends D.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=A.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){const T=this._instaService.invokeFunction(i.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(_.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const l=this._instaService.createInstance(c.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=l.ipcHandlePath}await this._instaService.createInstance(h,T,this._registry).install(),m.mark("code/extHost/didInitAPI");const o=await this._extHostConfiguration.getConfigProvider();await(0,P.connectProxyResolver)(this._extHostWorkspace,o,this,this._logService,this._mainThreadTelemetryProxy,this._initData),m.mark("code/extHost/didInitProxyResolver");const s=process.send,g=this._extHostContext.getProxy(C.MainContext.MainThreadConsole);process.send=(...l)=>l.length===0||!l[0]||l[0].type!=="__$console"?s.apply(process,l):(g.$logExtensionHostMessage(l[0]),!1)}_getEntryPoint(T){return T.main}_loadCommonJSModule(T,b,o){if(b.scheme!==L.Schemas.file)throw new Error(`Cannot load URI: '${b}', must be of file-scheme`);let s=null;o.codeLoadingStart(),this._logService.trace(`ExtensionService#loadCommonJSModule ${b.toString(!0)}`),this._logService.flush();try{T&&m.mark(`code/extHost/willLoadExtensionCode/${T.value}`),s=J.__$__nodeRequire(b.fsPath)}catch(g){return Promise.reject(g)}finally{T&&m.mark(`code/extHost/didLoadExtensionCode/${T.value}`),o.codeLoadingStop()}return Promise.resolve(s)}async $setRemoteEnvironment(T){if(!!this._initData.remote.isRemote)for(const b in T){const o=T[b];o===null?delete process.env[b]:process.env[b]=o}}}e.ExtHostExtensionService=p}),define(ve[287],we([0,1,83,261,270,269,284,286,262,55,39,72,70,34,52,67,260,259,11]),function(J,e,m,i,y,C,P,D,_,I,L,A,c,E,h,p,v,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,m.registerSingleton)(L.IExtHostExtensionService,D.ExtHostExtensionService),(0,m.registerSingleton)(b.ILoggerService,T.ExtHostLoggerService),(0,m.registerSingleton)(p.IExtensionStoragePaths,v.ExtensionStoragePaths),(0,m.registerSingleton)(I.IExtHostDebugService,C.ExtHostDebugService),(0,m.registerSingleton)(A.IExtHostSearch,P.NativeExtHostSearch),(0,m.registerSingleton)(c.IExtHostTask,y.ExtHostTask),(0,m.registerSingleton)(E.IExtHostTerminalService,i.ExtHostTerminalService),(0,m.registerSingleton)(h.IExtHostTunnelService,_.ExtHostTunnelService)}),define(ve[288],we([0,1,124,298,71,15,106,137,190,224,271,22,102,28,104,18,113,274,287]),function(J,e,m,i,y,C,P,D,_,I,L,A,c,E,h,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let r=0;r<process.execArgv.length;r++)process.execArgv[r]==="--inspect-port=0"&&(process.execArgv.splice(r,1),r--)}();const T=i(process.argv.slice(2),{string:["uriTransformerPath","useHostProxy"],boolean:["skipWorkspaceStorageLock"]});(function(){const t=J.__$__nodeRequire("module"),r=t._load;t._load=function(u){if(u==="natives")throw new Error('Either the extension or a NPM dependency is using the "natives" node module which is unsupported as it can cause a crash of the extension host. Click [here](https://go.microsoft.com/fwlink/?linkid=871887) to find out more');return r.apply(this,arguments)}})();const b=process.exit.bind(process);function o(t){process.exit=function(r){if(t)b(r);else{const u=new Error("An extension called process.exit() and this was prevented.");console.warn(u.stack)}},process.crash=function(){const r=new Error("An extension called process.crash() and this was prevented.");console.warn(r.stack)}}let s=function(t){b()};function g(){if(process.env.VSCODE_EXTHOST_WILL_SEND_SOCKET)return new Promise((t,r)=>{let u=null,a=setTimeout(()=>{s("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4);const f=108e5,w=3e5,d=new p.ProcessTimeRunOnceScheduler(()=>s("renderer disconnected for too long (1)"),f),k=new p.ProcessTimeRunOnceScheduler(()=>s("renderer disconnected for too long (2)"),w);process.on("message",(N,x)=>{if(N&&N.type==="VSCODE_EXTHOST_IPC_SOCKET"){x.setNoDelay(!0);const F=A.VSBuffer.wrap(Buffer.from(N.initialDataChunk,"base64"));let B;if(N.skipWebSocketFrames)B=new D.NodeSocket(x,"extHost-socket");else{const O=A.VSBuffer.wrap(Buffer.from(N.inflateBytes,"base64"));B=new D.WebSocketNodeSocket(new D.NodeSocket(x,"extHost-socket"),N.permessageDeflate,O,!1)}u?(d.cancel(),k.cancel(),u.beginAcceptReconnection(B,F),u.endAcceptReconnection(),u.sendResume()):(clearTimeout(a),u=new P.PersistentProtocol(B,F),u.sendResume(),u.onDidDispose(()=>s("renderer disconnected")),t(u),u.onSocketClose(()=>{d.schedule()}))}if(N&&N.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(k.isScheduled())return;d.isScheduled()&&k.schedule()}});const R={type:"VSCODE_EXTHOST_IPC_READY"};process.send&&process.send(R)});{const t=process.env.VSCODE_IPC_HOOK_EXTHOST;return new Promise((r,u)=>{const a=m.createConnection(t,()=>{a.removeListener("error",u),r(new P.PersistentProtocol(new D.NodeSocket(a,"extHost-renderer")))});a.once("error",u),a.on("close",()=>{s("renderer closed the socket")})})}}async function l(){const t=await g();return new class{constructor(){this._onMessage=new P.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,t.onMessage(r=>{(0,I.isMessageOfType)(r,2)?(this._terminating=!0,s("received terminate message from renderer")):this._onMessage.fire(r)})}send(r){this._terminating||t.send(r)}drain(){return t.drain()}}}function S(t){return new Promise(r=>{const u=t.onMessage(a=>{u.dispose();const f=JSON.parse(a.toString()),w=f.commit,d=_.default.commit;w&&d&&w!==d&&b(55);let k=0;setInterval(function(){try{process.kill(f.parentPid,0),k=0}catch(N){N&&N.code==="EPERM"?(k++,k>=3&&s(`parent process ${f.parentPid} does not exist anymore (3 x EPERM): ${N.message} (code: ${N.code}) (errno: ${N.errno})`)):s(`parent process ${f.parentPid} does not exist anymore: ${N.message} (code: ${N.code}) (errno: ${N.errno})`)}},1e3);let R;try{R=J.__$__nodeRequire("native-watchdog"),R.start(f.parentPid)}catch(N){(0,C.onUnexpectedError)(N)}t.send((0,I.createMessageOfType)(0)),r({protocol:t,initData:f})});t.send((0,I.createMessageOfType)(1))})}async function n(){const t=[];process.on("unhandledRejection",(k,R)=>{t.push(R),setTimeout(()=>{const N=t.indexOf(R);N>=0&&R.catch(x=>{t.splice(N,1),(0,C.isPromiseCanceledError)(x)||(console.warn(`rejected promise not handled within 1 second: ${x}`),x&&x.stack&&console.warn(`stack trace: ${x.stack}`),k&&(0,C.onUnexpectedError)(k))})},1e3)}),process.on("rejectionHandled",k=>{const R=t.indexOf(k);R>=0&&t.splice(R,1)}),process.on("uncaughtException",function(k){(0,C.onUnexpectedError)(k)}),y.mark("code/extHost/willConnectToRenderer");const r=await l();y.mark("code/extHost/didConnectToRenderer");const u=await S(r);y.mark("code/extHost/didWaitForInitData");const{initData:a}=u;o(!!a.environment.extensionTestsLocationURI),a.environment.useHostProxy=T.useHostProxy!==void 0?T.useHostProxy!=="false":void 0,a.environment.skipWorkspaceStorageLock=(0,v.boolean)(T.skipWorkspaceStorageLock,!1);const f=new class{constructor(){this.pid=process.pid}exit(R){b(R)}exists(R){return E.Promises.exists(R)}realpath(R){return(0,h.realpath)(R)}};let w=null;if(a.remote.authority&&T.uriTransformerPath)try{const R=J.__$__nodeRequire(T.uriTransformerPath)(a.remote.authority);w=new c.URITransformer(R)}catch(k){console.error(k)}const d=new L.ExtensionHostMain(u.protocol,a,f,w);s=k=>d.terminate(k)}e.startExtensionHostProcess=n}),define(ve[299],we([0,1,288]),function(J,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,m.startExtensionHostProcess)().catch(i=>console.log(i))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/745ef8b8264e12b2a704f6b2b60a2ce2cabfcda3/core/vs/workbench/services/extensions/node/extensionHostProcess.js.map
