/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ee=["require","exports","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/base/common/strings","vs/base/common/network","vs/base/common/types","vs/platform/log/common/log","vs/workbench/api/common/extHostRpcService","vs/base/common/async","vs/base/common/errors","vs/base/common/arrays","vs/base/common/path","vs/nls","vs/nls!vs/workbench/services/extensions/worker/extensionHostWorker","vs/base/common/cancellation","vs/base/common/map","vs/base/common/buffer","vs/base/common/platform","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/base/common/objects","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/glob","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/severity","vs/base/common/uuid","vs/platform/registry/common/platform","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/extpath","vs/base/common/errorMessage","vs/platform/contextkey/common/contextkey","vs/platform/files/common/files","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostWebview","vs/base/common/codicons","vs/base/common/decorators","vs/base/common/idGenerator","vs/base/common/marshalling","vs/editor/common/modes/languageSelector","vs/platform/instantiation/common/extensions","vs/base/common/hash","vs/editor/common/modes","vs/editor/common/core/range","vs/platform/instantiation/common/serviceCollection","vs/platform/remote/common/remoteHosts","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/shared/webview","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/collections","vs/base/common/numbers","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/mime","vs/editor/common/services/semanticTokensDto","vs/platform/instantiation/common/descriptors","vs/platform/configuration/common/configuration","vs/platform/markers/common/markers","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testCollection","vs/base/common/process","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/lazy","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/tokenizationRegistry","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/model/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/remote/common/tunnel","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/base/common/iterator","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/output/common/output","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/base/common/stopwatch","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/editor/common/model/mirrorTextModel","vs/editor/common/viewModel/prefixSumComputer","vs/base/common/marked/marked","vs/base/common/linkedList","vs/editor/common/core/position","vs/editor/common/modes/linkComputer","vs/editor/common/core/selection","vs/base/common/functional","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/services/extensions/worker/extensionHostWorker"],ye=function(re){for(var e=[],a=0,t=re.length;a<t;a++)e[a]=Ee[re[a]];return e};define(Ee[41],ye([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function a(t,w){if(!t)throw new Error(w?`Assertion failed (${w})`:"Assertion Failed")}e.ok=a}),define(Ee[51],ye([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function a(k){return k?k.replace(/\$\((.*?)\)/g,(I,S)=>` ${S} `).trim():""}e.getCodiconAriaLabel=a;class t{constructor(I,S,R){this.id=I,this.definition=S,this.description=R,t._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t._allCodicons}}e.Codicon=t,t._allCodicons=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",{fontCharacter:"\\ea71"}),t.closeDirty=new t("close-dirty",{fontCharacter:"\\ea71"}),t.debugBreakpoint=new t("debug-breakpoint",{fontCharacter:"\\ea71"}),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),t.debugHint=new t("debug-hint",{fontCharacter:"\\ea71"}),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circleOutline=new t("circle-outline",{fontCharacter:"\\eabc"}),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.debugStackframeDot=new t("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLargeOutline=new t("circle-large-outline",{fontCharacter:"\\ebb5"}),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function w(k,I){const S=["codicon","codicon-"+k];return I&&S.push("codicon-modifier-"+I),S}e.getClassNamesArray=w;var T;(function(k){k.iconNameSegment="[A-Za-z0-9]+",k.iconNameExpression="[A-Za-z0-9-]+",k.iconModifierExpression="~[A-Za-z]+",k.iconNameCharacter="[A-Za-z0-9~-]";const I=new RegExp(`^(${k.iconNameExpression})(${k.iconModifierExpression})?$`);function S(_){if(_ instanceof t)return["codicon","codicon-"+_.id];const n=I.exec(_.id);if(!n)return S(t.error);let[,f,o]=n;const m=["codicon","codicon-"+f];return o&&m.push("codicon-modifier-"+o.substr(1)),m}k.asClassNameArray=S;function R(_){return S(_).join(" ")}k.asClassName=R;function F(_){return"."+S(_).join(".")}k.asCSSSelector=F})(T=e.CSSIcon||(e.CSSIcon={}))}),define(Ee[74],ye([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const a=Object.prototype.hasOwnProperty;function t(F){const _=[];for(let n in F)a.call(F,n)&&_.push(F[n]);return _}e.values=t;function w(F,_){for(let n in F)if(a.call(F,n)&&_({key:n,value:F[n]},function(){delete F[n]})===!1)return}e.forEach=w;function T(F,_){const n=Object.create(null);for(const f of F){const o=_(f);let m=n[o];m||(m=n[o]=[]),m.push(f)}return n}e.groupBy=T;function k(F){const _=Object.create(null);return F&&F.forEach((n,f)=>{_[f]=n}),_}e.fromMap=k;function I(F,_){const n=[],f=[];for(let o of F)_.has(o)||n.push(o);for(let o of _)F.has(o)||f.push(o);return{removed:n,added:f}}e.diffSets=I;function S(F,_){const n=[],f=[];for(let[o,m]of F)_.has(o)||n.push(m);for(let[o,m]of _)F.has(o)||f.push(m);return{removed:n,added:f}}e.diffMaps=S;class R{constructor(){this.map=new Map}add(_,n){let f=this.map.get(_);f||(f=new Set,this.map.set(_,f)),f.add(n)}delete(_,n){const f=this.map.get(_);!f||(f.delete(n),f.size===0&&this.map.delete(_))}forEach(_,n){const f=this.map.get(_);!f||f.forEach(n)}}e.SetMap=R}),define(Ee[52],ye([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function a(k){return(I,S,R)=>{let F=null,_=null;if(typeof R.value=="function"?(F="value",_=R.value):typeof R.get=="function"&&(F="get",_=R.get),!_)throw new Error("not supported");R[F]=k(_,S)}}e.createDecorator=a;function t(k,I,S){let R=null,F=null;if(typeof S.value=="function"?(R="value",F=S.value,F.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(R="get",F=S.get),!F)throw new Error("not supported");const _=`$memoize$${I}`;S[R]=function(...n){return this.hasOwnProperty(_)||Object.defineProperty(this,_,{configurable:!1,enumerable:!1,writable:!1,value:F.apply(this,n)}),this[_]}}e.memoize=t;function w(k,I,S){return a((R,F)=>{const _=`$debounce$${F}`,n=`$debounce$result$${F}`;return function(...f){this[n]||(this[n]=S?S():void 0),clearTimeout(this[_]),I&&(this[n]=I(this[n],...f),f=[this[n]]),this[_]=setTimeout(()=>{R.apply(this,f),this[n]=S?S():void 0},k)}})}e.debounce=w;function T(k,I,S){return a((R,F)=>{const _=`$throttle$timer$${F}`,n=`$throttle$result$${F}`,f=`$throttle$lastRun$${F}`,o=`$throttle$pending$${F}`;return function(...m){if(this[n]||(this[n]=S?S():void 0),(this[f]===null||this[f]===void 0)&&(this[f]=-Number.MAX_VALUE),I&&(this[n]=I(this[n],...m)),this[o])return;const c=this[f]+k;c<=Date.now()?(this[f]=Date.now(),R.apply(this,[this[n]]),this[n]=S?S():void 0):(this[o]=!0,this[_]=setTimeout(()=>{this[o]=!1,this[f]=Date.now(),R.apply(this,[this[n]]),this[n]=S?S():void 0},c-Date.now()))}})}e.throttle=T}),define(Ee[53],ye([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class a{constructor(w){this._prefix=w,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=a,e.defaultGenerator=new a("id#")}),define(Ee[100],ye([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var a;(function(l){l[l.None=0]="None",l[l.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",l[l.UnexpectedEndOfString=2]="UnexpectedEndOfString",l[l.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",l[l.InvalidUnicode=4]="InvalidUnicode",l[l.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",l[l.InvalidCharacter=6]="InvalidCharacter"})(a=e.ScanError||(e.ScanError={}));var t;(function(l){l[l.OpenBraceToken=1]="OpenBraceToken",l[l.CloseBraceToken=2]="CloseBraceToken",l[l.OpenBracketToken=3]="OpenBracketToken",l[l.CloseBracketToken=4]="CloseBracketToken",l[l.CommaToken=5]="CommaToken",l[l.ColonToken=6]="ColonToken",l[l.NullKeyword=7]="NullKeyword",l[l.TrueKeyword=8]="TrueKeyword",l[l.FalseKeyword=9]="FalseKeyword",l[l.StringLiteral=10]="StringLiteral",l[l.NumericLiteral=11]="NumericLiteral",l[l.LineCommentTrivia=12]="LineCommentTrivia",l[l.BlockCommentTrivia=13]="BlockCommentTrivia",l[l.LineBreakTrivia=14]="LineBreakTrivia",l[l.Trivia=15]="Trivia",l[l.Unknown=16]="Unknown",l[l.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var w;(function(l){l[l.InvalidSymbol=1]="InvalidSymbol",l[l.InvalidNumberFormat=2]="InvalidNumberFormat",l[l.PropertyNameExpected=3]="PropertyNameExpected",l[l.ValueExpected=4]="ValueExpected",l[l.ColonExpected=5]="ColonExpected",l[l.CommaExpected=6]="CommaExpected",l[l.CloseBraceExpected=7]="CloseBraceExpected",l[l.CloseBracketExpected=8]="CloseBracketExpected",l[l.EndOfFileExpected=9]="EndOfFileExpected",l[l.InvalidCommentToken=10]="InvalidCommentToken",l[l.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",l[l.UnexpectedEndOfString=12]="UnexpectedEndOfString",l[l.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",l[l.InvalidUnicode=14]="InvalidUnicode",l[l.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",l[l.InvalidCharacter=16]="InvalidCharacter"})(w=e.ParseErrorCode||(e.ParseErrorCode={}));var T;(function(l){l.DEFAULT={allowTrailingComma:!0}})(T=e.ParseOptions||(e.ParseOptions={}));function k(l,M=!1){let r=0,i=l.length,p="",d=0,s=16,v=0;function y(N){let L=0,z=0;for(;L<N;){const H=l.charCodeAt(r);if(H>=48&&H<=57)z=z*16+H-48;else if(H>=65&&H<=70)z=z*16+H-65+10;else if(H>=97&&H<=102)z=z*16+H-97+10;else break;r++,L++}return L<N&&(z=-1),z}function u(N){r=N,p="",d=0,s=16,v=0}function D(){const N=r;if(l.charCodeAt(r)===48)r++;else for(r++;r<l.length&&R(l.charCodeAt(r));)r++;if(r<l.length&&l.charCodeAt(r)===46)if(r++,r<l.length&&R(l.charCodeAt(r)))for(r++;r<l.length&&R(l.charCodeAt(r));)r++;else return v=3,l.substring(N,r);let L=r;if(r<l.length&&(l.charCodeAt(r)===69||l.charCodeAt(r)===101))if(r++,(r<l.length&&l.charCodeAt(r)===43||l.charCodeAt(r)===45)&&r++,r<l.length&&R(l.charCodeAt(r))){for(r++;r<l.length&&R(l.charCodeAt(r));)r++;L=r}else v=3;return l.substring(N,L)}function A(){let N="",L=r;for(;;){if(r>=i){N+=l.substring(L,r),v=2;break}const z=l.charCodeAt(r);if(z===34){N+=l.substring(L,r),r++;break}if(z===92){if(N+=l.substring(L,r),r++,r>=i){v=2;break}switch(l.charCodeAt(r++)){case 34:N+='"';break;case 92:N+="\\";break;case 47:N+="/";break;case 98:N+="\b";break;case 102:N+="\f";break;case 110:N+=`
`;break;case 114:N+="\r";break;case 116:N+="	";break;case 117:const j=y(4);j>=0?N+=String.fromCharCode(j):v=4;break;default:v=5}L=r;continue}if(z>=0&&z<=31)if(S(z)){N+=l.substring(L,r),v=2;break}else v=6;r++}return N}function U(){if(p="",v=0,d=r,r>=i)return d=i,s=17;let N=l.charCodeAt(r);if(I(N)){do r++,p+=String.fromCharCode(N),N=l.charCodeAt(r);while(I(N));return s=15}if(S(N))return r++,p+=String.fromCharCode(N),N===13&&l.charCodeAt(r)===10&&(r++,p+=`
`),s=14;switch(N){case 123:return r++,s=1;case 125:return r++,s=2;case 91:return r++,s=3;case 93:return r++,s=4;case 58:return r++,s=6;case 44:return r++,s=5;case 34:return r++,p=A(),s=10;case 47:const L=r-1;if(l.charCodeAt(r+1)===47){for(r+=2;r<i&&!S(l.charCodeAt(r));)r++;return p=l.substring(L,r),s=12}if(l.charCodeAt(r+1)===42){r+=2;const z=i-1;let H=!1;for(;r<z;){if(l.charCodeAt(r)===42&&l.charCodeAt(r+1)===47){r+=2,H=!0;break}r++}return H||(r++,v=1),p=l.substring(L,r),s=13}return p+=String.fromCharCode(N),r++,s=16;case 45:if(p+=String.fromCharCode(N),r++,r===i||!R(l.charCodeAt(r)))return s=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return p+=D(),s=11;default:for(;r<i&&B(N);)r++,N=l.charCodeAt(r);if(d!==r){switch(p=l.substring(d,r),p){case"true":return s=8;case"false":return s=9;case"null":return s=7}return s=16}return p+=String.fromCharCode(N),r++,s=16}}function B(N){if(I(N)||S(N))return!1;switch(N){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function E(){let N;do N=U();while(N>=12&&N<=15);return N}return{setPosition:u,getPosition:()=>r,scan:M?E:U,getToken:()=>s,getTokenValue:()=>p,getTokenOffset:()=>d,getTokenLength:()=>r-d,getTokenError:()=>v}}e.createScanner=k;function I(l){return l===32||l===9||l===11||l===12||l===160||l===5760||l>=8192&&l<=8203||l===8239||l===8287||l===12288||l===65279}function S(l){return l===10||l===13||l===8232||l===8233}function R(l){return l>=48&&l<=57}var F;(function(l){l[l.nullCharacter=0]="nullCharacter",l[l.maxAsciiCharacter=127]="maxAsciiCharacter",l[l.lineFeed=10]="lineFeed",l[l.carriageReturn=13]="carriageReturn",l[l.lineSeparator=8232]="lineSeparator",l[l.paragraphSeparator=8233]="paragraphSeparator",l[l.nextLine=133]="nextLine",l[l.space=32]="space",l[l.nonBreakingSpace=160]="nonBreakingSpace",l[l.enQuad=8192]="enQuad",l[l.emQuad=8193]="emQuad",l[l.enSpace=8194]="enSpace",l[l.emSpace=8195]="emSpace",l[l.threePerEmSpace=8196]="threePerEmSpace",l[l.fourPerEmSpace=8197]="fourPerEmSpace",l[l.sixPerEmSpace=8198]="sixPerEmSpace",l[l.figureSpace=8199]="figureSpace",l[l.punctuationSpace=8200]="punctuationSpace",l[l.thinSpace=8201]="thinSpace",l[l.hairSpace=8202]="hairSpace",l[l.zeroWidthSpace=8203]="zeroWidthSpace",l[l.narrowNoBreakSpace=8239]="narrowNoBreakSpace",l[l.ideographicSpace=12288]="ideographicSpace",l[l.mathematicalSpace=8287]="mathematicalSpace",l[l.ogham=5760]="ogham",l[l._=95]="_",l[l.$=36]="$",l[l._0=48]="_0",l[l._1=49]="_1",l[l._2=50]="_2",l[l._3=51]="_3",l[l._4=52]="_4",l[l._5=53]="_5",l[l._6=54]="_6",l[l._7=55]="_7",l[l._8=56]="_8",l[l._9=57]="_9",l[l.a=97]="a",l[l.b=98]="b",l[l.c=99]="c",l[l.d=100]="d",l[l.e=101]="e",l[l.f=102]="f",l[l.g=103]="g",l[l.h=104]="h",l[l.i=105]="i",l[l.j=106]="j",l[l.k=107]="k",l[l.l=108]="l",l[l.m=109]="m",l[l.n=110]="n",l[l.o=111]="o",l[l.p=112]="p",l[l.q=113]="q",l[l.r=114]="r",l[l.s=115]="s",l[l.t=116]="t",l[l.u=117]="u",l[l.v=118]="v",l[l.w=119]="w",l[l.x=120]="x",l[l.y=121]="y",l[l.z=122]="z",l[l.A=65]="A",l[l.B=66]="B",l[l.C=67]="C",l[l.D=68]="D",l[l.E=69]="E",l[l.F=70]="F",l[l.G=71]="G",l[l.H=72]="H",l[l.I=73]="I",l[l.J=74]="J",l[l.K=75]="K",l[l.L=76]="L",l[l.M=77]="M",l[l.N=78]="N",l[l.O=79]="O",l[l.P=80]="P",l[l.Q=81]="Q",l[l.R=82]="R",l[l.S=83]="S",l[l.T=84]="T",l[l.U=85]="U",l[l.V=86]="V",l[l.W=87]="W",l[l.X=88]="X",l[l.Y=89]="Y",l[l.Z=90]="Z",l[l.ampersand=38]="ampersand",l[l.asterisk=42]="asterisk",l[l.at=64]="at",l[l.backslash=92]="backslash",l[l.bar=124]="bar",l[l.caret=94]="caret",l[l.closeBrace=125]="closeBrace",l[l.closeBracket=93]="closeBracket",l[l.closeParen=41]="closeParen",l[l.colon=58]="colon",l[l.comma=44]="comma",l[l.dot=46]="dot",l[l.doubleQuote=34]="doubleQuote",l[l.equals=61]="equals",l[l.exclamation=33]="exclamation",l[l.greaterThan=62]="greaterThan",l[l.lessThan=60]="lessThan",l[l.minus=45]="minus",l[l.openBrace=123]="openBrace",l[l.openBracket=91]="openBracket",l[l.openParen=40]="openParen",l[l.percent=37]="percent",l[l.plus=43]="plus",l[l.question=63]="question",l[l.semicolon=59]="semicolon",l[l.singleQuote=39]="singleQuote",l[l.slash=47]="slash",l[l.tilde=126]="tilde",l[l.backspace=8]="backspace",l[l.formFeed=12]="formFeed",l[l.byteOrderMark=65279]="byteOrderMark",l[l.tab=9]="tab",l[l.verticalTab=11]="verticalTab"})(F||(F={}));function _(l,M){const r=[],i=new Object;let p;const d={value:{},offset:0,length:0,type:"object",parent:void 0};let s=!1;function v(y,u,D,A){d.value=y,d.offset=u,d.length=D,d.type=A,d.colonOffset=void 0,p=d}try{h(l,{onObjectBegin:(y,u)=>{if(M<=y)throw i;p=void 0,s=M>y,r.push("")},onObjectProperty:(y,u,D)=>{if(M<u||(v(y,u,D,"property"),r[r.length-1]=y,M<=u+D))throw i},onObjectEnd:(y,u)=>{if(M<=y)throw i;p=void 0,r.pop()},onArrayBegin:(y,u)=>{if(M<=y)throw i;p=void 0,r.push(0)},onArrayEnd:(y,u)=>{if(M<=y)throw i;p=void 0,r.pop()},onLiteralValue:(y,u,D)=>{if(M<u||(v(y,u,D,P(y)),M<=u+D))throw i},onSeparator:(y,u,D)=>{if(M<=u)throw i;if(y===":"&&p&&p.type==="property")p.colonOffset=u,s=!1,p=void 0;else if(y===","){const A=r[r.length-1];typeof A=="number"?r[r.length-1]=A+1:(s=!0,r[r.length-1]=""),p=void 0}}})}catch(y){if(y!==i)throw y}return{path:r,previousNode:p,isAtPropertyKey:s,matches:y=>{let u=0;for(let D=0;u<y.length&&D<r.length;D++)if(y[u]===r[D]||y[u]==="*")u++;else if(y[u]!=="**")return!1;return u===y.length}}}e.getLocation=_;function n(l,M=[],r=T.DEFAULT){let i=null,p=[];const d=[];function s(y){Array.isArray(p)?p.push(y):i!==null&&(p[i]=y)}return h(l,{onObjectBegin:()=>{const y={};s(y),d.push(p),p=y,i=null},onObjectProperty:y=>{i=y},onObjectEnd:()=>{p=d.pop()},onArrayBegin:()=>{const y=[];s(y),d.push(p),p=y,i=null},onArrayEnd:()=>{p=d.pop()},onLiteralValue:s,onError:(y,u,D)=>{M.push({error:y,offset:u,length:D})}},r),p[0]}e.parse=n;function f(l,M=[],r=T.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function p(y){i.type==="property"&&(i.length=y-i.offset,i=i.parent)}function d(y){return i.children.push(y),y}h(l,{onObjectBegin:y=>{i=d({type:"object",offset:y,length:-1,parent:i,children:[]})},onObjectProperty:(y,u,D)=>{i=d({type:"property",offset:u,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:y,offset:u,length:D,parent:i})},onObjectEnd:(y,u)=>{i.length=y+u-i.offset,i=i.parent,p(y+u)},onArrayBegin:(y,u)=>{i=d({type:"array",offset:y,length:-1,parent:i,children:[]})},onArrayEnd:(y,u)=>{i.length=y+u-i.offset,i=i.parent,p(y+u)},onLiteralValue:(y,u,D)=>{d({type:P(y),offset:u,length:D,parent:i,value:y}),p(u+D)},onSeparator:(y,u,D)=>{i.type==="property"&&(y===":"?i.colonOffset=u:y===","&&p(u))},onError:(y,u,D)=>{M.push({error:y,offset:u,length:D})}},r);const v=i.children[0];return v&&delete v.parent,v}e.parseTree=f;function o(l,M){if(!l)return;let r=l;for(let i of M)if(typeof i=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let p=!1;for(const d of r.children)if(Array.isArray(d.children)&&d.children[0].value===i){r=d.children[1],p=!0;break}if(!p)return}else{const p=i;if(r.type!=="array"||p<0||!Array.isArray(r.children)||p>=r.children.length)return;r=r.children[p]}return r}e.findNodeAtLocation=o;function m(l){if(!l.parent||!l.parent.children)return[];const M=m(l.parent);if(l.parent.type==="property"){const r=l.parent.children[0].value;M.push(r)}else if(l.parent.type==="array"){const r=l.parent.children.indexOf(l);r!==-1&&M.push(r)}return M}e.getNodePath=m;function c(l){switch(l.type){case"array":return l.children.map(c);case"object":const M=Object.create(null);for(let r of l.children){const i=r.children[1];i&&(M[r.children[0].value]=c(i))}return M;case"null":case"string":case"number":case"boolean":return l.value;default:return}}e.getNodeValue=c;function C(l,M,r=!1){return M>=l.offset&&M<l.offset+l.length||r&&M===l.offset+l.length}e.contains=C;function b(l,M,r=!1){if(C(l,M,r)){const i=l.children;if(Array.isArray(i))for(let p=0;p<i.length&&i[p].offset<=M;p++){const d=b(i[p],M,r);if(d)return d}return l}}e.findNodeAtOffset=b;function h(l,M,r=T.DEFAULT){const i=k(l,!1);function p(ie){return ie?()=>ie(i.getTokenOffset(),i.getTokenLength()):()=>!0}function d(ie){return ie?we=>ie(we,i.getTokenOffset(),i.getTokenLength()):()=>!0}const s=p(M.onObjectBegin),v=d(M.onObjectProperty),y=p(M.onObjectEnd),u=p(M.onArrayBegin),D=p(M.onArrayEnd),A=d(M.onLiteralValue),U=d(M.onSeparator),B=p(M.onComment),E=d(M.onError),N=r&&r.disallowComments,L=r&&r.allowTrailingComma;function z(){for(;;){const ie=i.scan();switch(i.getTokenError()){case 4:H(14);break;case 5:H(15);break;case 3:H(13);break;case 1:N||H(11);break;case 2:H(12);break;case 6:H(16);break}switch(ie){case 12:case 13:N?H(10):B();break;case 16:H(1);break;case 15:case 14:break;default:return ie}}}function H(ie,we=[],Me=[]){if(E(ie),we.length+Me.length>0){let Re=i.getToken();for(;Re!==17;){if(we.indexOf(Re)!==-1){z();break}else if(Me.indexOf(Re)!==-1)break;Re=z()}}}function j(ie){const we=i.getTokenValue();return ie?A(we):v(we),z(),!0}function ue(){switch(i.getToken()){case 11:let ie=0;try{ie=JSON.parse(i.getTokenValue()),typeof ie!="number"&&(H(2),ie=0)}catch{H(2)}A(ie);break;case 7:A(null);break;case 8:A(!0);break;case 9:A(!1);break;default:return!1}return z(),!0}function G(){return i.getToken()!==10?(H(3,[],[2,5]),!1):(j(!1),i.getToken()===6?(U(":"),z(),Y()||H(4,[],[2,5])):H(5,[],[2,5]),!0)}function le(){s(),z();let ie=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(ie||H(4,[],[]),U(","),z(),i.getToken()===2&&L)break}else ie&&H(6,[],[]);G()||H(4,[],[2,5]),ie=!0}return y(),i.getToken()!==2?H(7,[2],[]):z(),!0}function ce(){u(),z();let ie=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(ie||H(4,[],[]),U(","),z(),i.getToken()===4&&L)break}else ie&&H(6,[],[]);Y()||H(4,[],[4,5]),ie=!0}return D(),i.getToken()!==4?H(8,[4],[]):z(),!0}function Y(){switch(i.getToken()){case 3:return ce();case 1:return le();case 10:return j(!0);default:return ue()}}return z(),i.getToken()===17?r.allowEmptyContent?!0:(H(4,[],[]),!1):Y()?(i.getToken()!==17&&H(9,[],[]),!0):(H(4,[],[]),!1)}e.visit=h;function g(l,M){let r=k(l),i=[],p,d=0,s;do switch(s=r.getPosition(),p=r.scan(),p){case 12:case 13:case 17:d!==s&&i.push(l.substring(d,s)),M!==void 0&&i.push(r.getTokenValue().replace(/[^\r\n]/g,M)),d=r.getPosition();break}while(p!==17);return i.join("")}e.stripComments=g;function P(l){switch(typeof l){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(l){if(Array.isArray(l))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=P}),define(Ee[101],ye([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class a{constructor(w){this.executor=w,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(w){this._error=w}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(w){return new a(()=>w(this.getValue()))}}e.Lazy=a}),function(re,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(re=typeof globalThis!="undefined"?globalThis:re||self,re.marked=e())}(this,function(){"use strict";function re(Ie,Ce){for(var ve=0;ve<Ce.length;ve++){var oe=Ce[ve];oe.enumerable=oe.enumerable||!1,oe.configurable=!0,"value"in oe&&(oe.writable=!0),Object.defineProperty(Ie,oe.key,oe)}}function e(Ie,Ce,ve){return Ce&&re(Ie.prototype,Ce),ve&&re(Ie,ve),Ie}function a(Ie,Ce){if(!!Ie){if(typeof Ie=="string")return t(Ie,Ce);var ve=Object.prototype.toString.call(Ie).slice(8,-1);if(ve==="Object"&&Ie.constructor&&(ve=Ie.constructor.name),ve==="Map"||ve==="Set")return Array.from(Ie);if(ve==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ve))return t(Ie,Ce)}}function t(Ie,Ce){(Ce==null||Ce>Ie.length)&&(Ce=Ie.length);for(var ve=0,oe=new Array(Ce);ve<Ce;ve++)oe[ve]=Ie[ve];return oe}function w(Ie,Ce){var ve=typeof Symbol!="undefined"&&Ie[Symbol.iterator]||Ie["@@iterator"];if(ve)return(ve=ve.call(Ie)).next.bind(ve);if(Array.isArray(Ie)||(ve=a(Ie))||Ce&&Ie&&typeof Ie.length=="number"){ve&&(Ie=ve);var oe=0;return function(){return oe>=Ie.length?{done:!0}:{done:!1,value:Ie[oe++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}var T={exports:{}};function k(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function I(Ie){T.exports.defaults=Ie}T.exports={defaults:k(),getDefaults:k,changeDefaults:I};var S=/[&<>"']/,R=/[&<>"']/g,F=/[<>"']|&(?!#?\w+;)/,_=/[<>"']|&(?!#?\w+;)/g,n={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},f=function(Ce){return n[Ce]};function o(Ie,Ce){if(Ce){if(S.test(Ie))return Ie.replace(R,f)}else if(F.test(Ie))return Ie.replace(_,f);return Ie}var m=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function c(Ie){return Ie.replace(m,function(Ce,ve){return ve=ve.toLowerCase(),ve==="colon"?":":ve.charAt(0)==="#"?ve.charAt(1)==="x"?String.fromCharCode(parseInt(ve.substring(2),16)):String.fromCharCode(+ve.substring(1)):""})}var C=/(^|[^\[])\^/g;function b(Ie,Ce){Ie=Ie.source||Ie,Ce=Ce||"";var ve={replace:function(se,fe){return fe=fe.source||fe,fe=fe.replace(C,"$1"),Ie=Ie.replace(se,fe),ve},getRegex:function(){return new RegExp(Ie,Ce)}};return ve}var h=/[^\w:]/g,g=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function P(Ie,Ce,ve){if(Ie){var oe;try{oe=decodeURIComponent(c(ve)).replace(h,"").toLowerCase()}catch{return null}if(oe.indexOf("javascript:")===0||oe.indexOf("vbscript:")===0||oe.indexOf("data:")===0)return null}Ce&&!g.test(ve)&&(ve=p(Ce,ve));try{ve=encodeURI(ve).replace(/%25/g,"%")}catch{return null}return ve}var l={},M=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,i=/^([^:]+:\/*[^/]*)[\s\S]*$/;function p(Ie,Ce){l[" "+Ie]||(M.test(Ie)?l[" "+Ie]=Ie+"/":l[" "+Ie]=y(Ie,"/",!0)),Ie=l[" "+Ie];var ve=Ie.indexOf(":")===-1;return Ce.substring(0,2)==="//"?ve?Ce:Ie.replace(r,"$1")+Ce:Ce.charAt(0)==="/"?ve?Ce:Ie.replace(i,"$1")+Ce:Ie+Ce}var d={exec:function(){}};function s(Ie){for(var Ce=1,ve,oe;Ce<arguments.length;Ce++){ve=arguments[Ce];for(oe in ve)Object.prototype.hasOwnProperty.call(ve,oe)&&(Ie[oe]=ve[oe])}return Ie}function v(Ie,Ce){var ve=Ie.replace(/\|/g,function(fe,ge,ke){for(var ze=!1,Oe=ge;--Oe>=0&&ke[Oe]==="\\";)ze=!ze;return ze?"|":" |"}),oe=ve.split(/ \|/),se=0;if(oe[0].trim()||oe.shift(),oe[oe.length-1].trim()||oe.pop(),oe.length>Ce)oe.splice(Ce);else for(;oe.length<Ce;)oe.push("");for(;se<oe.length;se++)oe[se]=oe[se].trim().replace(/\\\|/g,"|");return oe}function y(Ie,Ce,ve){var oe=Ie.length;if(oe===0)return"";for(var se=0;se<oe;){var fe=Ie.charAt(oe-se-1);if(fe===Ce&&!ve)se++;else if(fe!==Ce&&ve)se++;else break}return Ie.substr(0,oe-se)}function u(Ie,Ce){if(Ie.indexOf(Ce[1])===-1)return-1;for(var ve=Ie.length,oe=0,se=0;se<ve;se++)if(Ie[se]==="\\")se++;else if(Ie[se]===Ce[0])oe++;else if(Ie[se]===Ce[1]&&(oe--,oe<0))return se;return-1}function D(Ie){Ie&&Ie.sanitize&&!Ie.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function A(Ie,Ce){if(Ce<1)return"";for(var ve="";Ce>1;)Ce&1&&(ve+=Ie),Ce>>=1,Ie+=Ie;return ve+Ie}var U={escape:o,unescape:c,edit:b,cleanUrl:P,resolveUrl:p,noopTest:d,merge:s,splitCells:v,rtrim:y,findClosingBracket:u,checkSanitizeDeprecation:D,repeatString:A},B=T.exports.defaults,E=U.rtrim,N=U.splitCells,L=U.escape,z=U.findClosingBracket;function H(Ie,Ce,ve,oe){var se=Ce.href,fe=Ce.title?L(Ce.title):null,ge=Ie[1].replace(/\\([\[\]])/g,"$1");if(Ie[0].charAt(0)!=="!"){oe.state.inLink=!0;var ke={type:"link",raw:ve,href:se,title:fe,text:ge,tokens:oe.inlineTokens(ge,[])};return oe.state.inLink=!1,ke}else return{type:"image",raw:ve,href:se,title:fe,text:L(ge)}}function j(Ie,Ce){var ve=Ie.match(/^(\s+)(?:```)/);if(ve===null)return Ce;var oe=ve[1];return Ce.split(`
`).map(function(se){var fe=se.match(/^\s+/);if(fe===null)return se;var ge=fe[0];return ge.length>=oe.length?se.slice(oe.length):se}).join(`
`)}var ue=function(){function Ie(ve){this.options=ve||B}var Ce=Ie.prototype;return Ce.space=function(oe){var se=this.rules.block.newline.exec(oe);if(se)return se[0].length>1?{type:"space",raw:se[0]}:{raw:`
`}},Ce.code=function(oe){var se=this.rules.block.code.exec(oe);if(se){var fe=se[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:se[0],codeBlockStyle:"indented",text:this.options.pedantic?fe:E(fe,`
`)}}},Ce.fences=function(oe){var se=this.rules.block.fences.exec(oe);if(se){var fe=se[0],ge=j(fe,se[3]||"");return{type:"code",raw:fe,lang:se[2]?se[2].trim():se[2],text:ge}}},Ce.heading=function(oe){var se=this.rules.block.heading.exec(oe);if(se){var fe=se[2].trim();if(/#$/.test(fe)){var ge=E(fe,"#");(this.options.pedantic||!ge||/ $/.test(ge))&&(fe=ge.trim())}var ke={type:"heading",raw:se[0],depth:se[1].length,text:fe,tokens:[]};return this.lexer.inline(ke.text,ke.tokens),ke}},Ce.hr=function(oe){var se=this.rules.block.hr.exec(oe);if(se)return{type:"hr",raw:se[0]}},Ce.blockquote=function(oe){var se=this.rules.block.blockquote.exec(oe);if(se){var fe=se[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:se[0],tokens:this.lexer.blockTokens(fe,[]),text:fe}}},Ce.list=function(oe){var se=this.rules.block.list.exec(oe);if(se){var fe,ge,ke,ze,Oe,Ve,it,rt,ne,pe,ee=se[1].trim(),W=ee.length>1,be={type:"list",raw:"",ordered:W,start:W?+ee.slice(0,-1):"",loose:!1,items:[]};ee=W?"\\d{1,9}\\"+ee.slice(-1):"\\"+ee,this.options.pedantic&&(ee=W?ee:"[*+-]");for(var De=new RegExp("^( {0,3}"+ee+")((?: [^\\n]*| *)(?:\\n[^\\n]*)*(?:\\n|$))");oe&&!(this.rules.block.hr.test(oe)||!(se=De.exec(oe)));){ne=se[2].split(`
`),this.options.pedantic?(ze=2,pe=ne[0].trimLeft()):(ze=se[2].search(/[^ ]/),ze=se[1].length+(ze>4?1:ze),pe=ne[0].slice(ze-se[1].length)),Ve=!1,fe=se[0],!ne[0]&&/^ *$/.test(ne[1])&&(fe=se[1]+ne.slice(0,2).join(`
`)+`
`,be.loose=!0,ne=[]);var qe=new RegExp("^ {0,"+Math.min(3,ze-1)+"}(?:[*+-]|\\d{1,9}[.)])");for(Oe=1;Oe<ne.length;Oe++){if(rt=ne[Oe],this.options.pedantic&&(rt=rt.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),qe.test(rt)){fe=se[1]+ne.slice(0,Oe).join(`
`)+`
`;break}if(!Ve){rt.trim()||(Ve=!0),rt.search(/[^ ]/)>=ze?pe+=`
`+rt.slice(ze):pe+=`
`+rt;continue}if(rt.search(/[^ ]/)>=ze||!rt.trim()){pe+=`
`+rt.slice(ze);continue}else{fe=se[1]+ne.slice(0,Oe).join(`
`)+`
`;break}}be.loose||(it?be.loose=!0:/\n *\n *$/.test(fe)&&(it=!0)),this.options.gfm&&(ge=/^\[[ xX]\] /.exec(pe),ge&&(ke=ge[0]!=="[ ] ",pe=pe.replace(/^\[[ xX]\] +/,""))),be.items.push({type:"list_item",raw:fe,task:!!ge,checked:ke,loose:!1,text:pe}),be.raw+=fe,oe=oe.slice(fe.length)}be.items[be.items.length-1].raw=fe.trimRight(),be.items[be.items.length-1].text=pe.trimRight(),be.raw=be.raw.trimRight();var xe=be.items.length;for(Oe=0;Oe<xe;Oe++)this.lexer.state.top=!1,be.items[Oe].tokens=this.lexer.blockTokens(be.items[Oe].text,[]),be.items[Oe].tokens.some(function(ut){return ut.type==="space"})&&(be.loose=!0,be.items[Oe].loose=!0);return be}},Ce.html=function(oe){var se=this.rules.block.html.exec(oe);if(se){var fe={type:"html",raw:se[0],pre:!this.options.sanitizer&&(se[1]==="pre"||se[1]==="script"||se[1]==="style"),text:se[0]};return this.options.sanitize&&(fe.type="paragraph",fe.text=this.options.sanitizer?this.options.sanitizer(se[0]):L(se[0]),fe.tokens=[],this.lexer.inline(fe.text,fe.tokens)),fe}},Ce.def=function(oe){var se=this.rules.block.def.exec(oe);if(se){se[3]&&(se[3]=se[3].substring(1,se[3].length-1));var fe=se[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:fe,raw:se[0],href:se[2],title:se[3]}}},Ce.table=function(oe){var se=this.rules.block.table.exec(oe);if(se){var fe={type:"table",header:N(se[1]).map(function(it){return{text:it}}),align:se[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:se[3]?se[3].replace(/\n$/,"").split(`
`):[]};if(fe.header.length===fe.align.length){fe.raw=se[0];var ge=fe.align.length,ke,ze,Oe,Ve;for(ke=0;ke<ge;ke++)/^ *-+: *$/.test(fe.align[ke])?fe.align[ke]="right":/^ *:-+: *$/.test(fe.align[ke])?fe.align[ke]="center":/^ *:-+ *$/.test(fe.align[ke])?fe.align[ke]="left":fe.align[ke]=null;for(ge=fe.rows.length,ke=0;ke<ge;ke++)fe.rows[ke]=N(fe.rows[ke],fe.header.length).map(function(it){return{text:it}});for(ge=fe.header.length,ze=0;ze<ge;ze++)fe.header[ze].tokens=[],this.lexer.inlineTokens(fe.header[ze].text,fe.header[ze].tokens);for(ge=fe.rows.length,ze=0;ze<ge;ze++)for(Ve=fe.rows[ze],Oe=0;Oe<Ve.length;Oe++)Ve[Oe].tokens=[],this.lexer.inlineTokens(Ve[Oe].text,Ve[Oe].tokens);return fe}}},Ce.lheading=function(oe){var se=this.rules.block.lheading.exec(oe);if(se){var fe={type:"heading",raw:se[0],depth:se[2].charAt(0)==="="?1:2,text:se[1],tokens:[]};return this.lexer.inline(fe.text,fe.tokens),fe}},Ce.paragraph=function(oe){var se=this.rules.block.paragraph.exec(oe);if(se){var fe={type:"paragraph",raw:se[0],text:se[1].charAt(se[1].length-1)===`
`?se[1].slice(0,-1):se[1],tokens:[]};return this.lexer.inline(fe.text,fe.tokens),fe}},Ce.text=function(oe){var se=this.rules.block.text.exec(oe);if(se){var fe={type:"text",raw:se[0],text:se[0],tokens:[]};return this.lexer.inline(fe.text,fe.tokens),fe}},Ce.escape=function(oe){var se=this.rules.inline.escape.exec(oe);if(se)return{type:"escape",raw:se[0],text:L(se[1])}},Ce.tag=function(oe){var se=this.rules.inline.tag.exec(oe);if(se)return!this.lexer.state.inLink&&/^<a /i.test(se[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(se[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(se[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(se[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:se[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(se[0]):L(se[0]):se[0]}},Ce.link=function(oe){var se=this.rules.inline.link.exec(oe);if(se){var fe=se[2].trim();if(!this.options.pedantic&&/^</.test(fe)){if(!/>$/.test(fe))return;var ge=E(fe.slice(0,-1),"\\");if((fe.length-ge.length)%2==0)return}else{var ke=z(se[2],"()");if(ke>-1){var ze=se[0].indexOf("!")===0?5:4,Oe=ze+se[1].length+ke;se[2]=se[2].substring(0,ke),se[0]=se[0].substring(0,Oe).trim(),se[3]=""}}var Ve=se[2],it="";if(this.options.pedantic){var rt=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ve);rt&&(Ve=rt[1],it=rt[3])}else it=se[3]?se[3].slice(1,-1):"";return Ve=Ve.trim(),/^</.test(Ve)&&(this.options.pedantic&&!/>$/.test(fe)?Ve=Ve.slice(1):Ve=Ve.slice(1,-1)),H(se,{href:Ve&&Ve.replace(this.rules.inline._escapes,"$1"),title:it&&it.replace(this.rules.inline._escapes,"$1")},se[0],this.lexer)}},Ce.reflink=function(oe,se){var fe;if((fe=this.rules.inline.reflink.exec(oe))||(fe=this.rules.inline.nolink.exec(oe))){var ge=(fe[2]||fe[1]).replace(/\s+/g," ");if(ge=se[ge.toLowerCase()],!ge||!ge.href){var ke=fe[0].charAt(0);return{type:"text",raw:ke,text:ke}}return H(fe,ge,fe[0],this.lexer)}},Ce.emStrong=function(oe,se,fe){fe===void 0&&(fe="");var ge=this.rules.inline.emStrong.lDelim.exec(oe);if(!!ge&&!(ge[3]&&fe.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var ke=ge[1]||ge[2]||"";if(!ke||ke&&(fe===""||this.rules.inline.punctuation.exec(fe))){var ze=ge[0].length-1,Oe,Ve,it=ze,rt=0,ne=ge[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ne.lastIndex=0,se=se.slice(-1*oe.length+ze);(ge=ne.exec(se))!=null;)if(Oe=ge[1]||ge[2]||ge[3]||ge[4]||ge[5]||ge[6],!!Oe){if(Ve=Oe.length,ge[3]||ge[4]){it+=Ve;continue}else if((ge[5]||ge[6])&&ze%3&&!((ze+Ve)%3)){rt+=Ve;continue}if(it-=Ve,!(it>0)){if(Ve=Math.min(Ve,Ve+it+rt),Math.min(ze,Ve)%2){var pe=oe.slice(1,ze+ge.index+Ve);return{type:"em",raw:oe.slice(0,ze+ge.index+Ve+1),text:pe,tokens:this.lexer.inlineTokens(pe,[])}}var ee=oe.slice(2,ze+ge.index+Ve-1);return{type:"strong",raw:oe.slice(0,ze+ge.index+Ve+1),text:ee,tokens:this.lexer.inlineTokens(ee,[])}}}}}},Ce.codespan=function(oe){var se=this.rules.inline.code.exec(oe);if(se){var fe=se[2].replace(/\n/g," "),ge=/[^ ]/.test(fe),ke=/^ /.test(fe)&&/ $/.test(fe);return ge&&ke&&(fe=fe.substring(1,fe.length-1)),fe=L(fe,!0),{type:"codespan",raw:se[0],text:fe}}},Ce.br=function(oe){var se=this.rules.inline.br.exec(oe);if(se)return{type:"br",raw:se[0]}},Ce.del=function(oe){var se=this.rules.inline.del.exec(oe);if(se)return{type:"del",raw:se[0],text:se[2],tokens:this.lexer.inlineTokens(se[2],[])}},Ce.autolink=function(oe,se){var fe=this.rules.inline.autolink.exec(oe);if(fe){var ge,ke;return fe[2]==="@"?(ge=L(this.options.mangle?se(fe[1]):fe[1]),ke="mailto:"+ge):(ge=L(fe[1]),ke=ge),{type:"link",raw:fe[0],text:ge,href:ke,tokens:[{type:"text",raw:ge,text:ge}]}}},Ce.url=function(oe,se){var fe;if(fe=this.rules.inline.url.exec(oe)){var ge,ke;if(fe[2]==="@")ge=L(this.options.mangle?se(fe[0]):fe[0]),ke="mailto:"+ge;else{var ze;do ze=fe[0],fe[0]=this.rules.inline._backpedal.exec(fe[0])[0];while(ze!==fe[0]);ge=L(fe[0]),fe[1]==="www."?ke="http://"+ge:ke=ge}return{type:"link",raw:fe[0],text:ge,href:ke,tokens:[{type:"text",raw:ge,text:ge}]}}},Ce.inlineText=function(oe,se){var fe=this.rules.inline.text.exec(oe);if(fe){var ge;return this.lexer.state.inRawBlock?ge=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(fe[0]):L(fe[0]):fe[0]:ge=L(this.options.smartypants?se(fe[0]):fe[0]),{type:"text",raw:fe[0],text:ge}}},Ie}(),G=U.noopTest,le=U.edit,ce=U.merge,Y={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,table:G,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};Y._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,Y._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,Y.def=le(Y.def).replace("label",Y._label).replace("title",Y._title).getRegex(),Y.bullet=/(?:[*+-]|\d{1,9}[.)])/,Y.listItemStart=le(/^( *)(bull) */).replace("bull",Y.bullet).getRegex(),Y.list=le(Y.list).replace(/bull/g,Y.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+Y.def.source+")").getRegex(),Y._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",Y._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,Y.html=le(Y.html,"i").replace("comment",Y._comment).replace("tag",Y._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),Y.paragraph=le(Y._paragraph).replace("hr",Y.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",Y._tag).getRegex(),Y.blockquote=le(Y.blockquote).replace("paragraph",Y.paragraph).getRegex(),Y.normal=ce({},Y),Y.gfm=ce({},Y.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)\\|?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),Y.gfm.table=le(Y.gfm.table).replace("hr",Y.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",Y._tag).getRegex(),Y.pedantic=ce({},Y.normal,{html:le(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",Y._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:G,paragraph:le(Y.normal._paragraph).replace("hr",Y.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",Y.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var ie={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:G,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_*]*?\*[^_*]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^_*]*?\_[^_*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:G,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};ie._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",ie.punctuation=le(ie.punctuation).replace(/punctuation/g,ie._punctuation).getRegex(),ie.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,ie.escapedEmSt=/\\\*|\\_/g,ie._comment=le(Y._comment).replace("(?:-->|$)","-->").getRegex(),ie.emStrong.lDelim=le(ie.emStrong.lDelim).replace(/punct/g,ie._punctuation).getRegex(),ie.emStrong.rDelimAst=le(ie.emStrong.rDelimAst,"g").replace(/punct/g,ie._punctuation).getRegex(),ie.emStrong.rDelimUnd=le(ie.emStrong.rDelimUnd,"g").replace(/punct/g,ie._punctuation).getRegex(),ie._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,ie._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,ie._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,ie.autolink=le(ie.autolink).replace("scheme",ie._scheme).replace("email",ie._email).getRegex(),ie._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,ie.tag=le(ie.tag).replace("comment",ie._comment).replace("attribute",ie._attribute).getRegex(),ie._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,ie._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,ie._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,ie.link=le(ie.link).replace("label",ie._label).replace("href",ie._href).replace("title",ie._title).getRegex(),ie.reflink=le(ie.reflink).replace("label",ie._label).getRegex(),ie.reflinkSearch=le(ie.reflinkSearch,"g").replace("reflink",ie.reflink).replace("nolink",ie.nolink).getRegex(),ie.normal=ce({},ie),ie.pedantic=ce({},ie.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:le(/^!?\[(label)\]\((.*?)\)/).replace("label",ie._label).getRegex(),reflink:le(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",ie._label).getRegex()}),ie.gfm=ce({},ie.normal,{escape:le(ie.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),ie.gfm.url=le(ie.gfm.url,"i").replace("email",ie.gfm._extended_email).getRegex(),ie.breaks=ce({},ie.gfm,{br:le(ie.br).replace("{2,}","*").getRegex(),text:le(ie.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var we={block:Y,inline:ie},Me=ue,Re=T.exports.defaults,Be=we.block,Qe=we.inline,Ke=U.repeatString;function Xe(Ie){return Ie.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function $(Ie){var Ce="",ve,oe,se=Ie.length;for(ve=0;ve<se;ve++)oe=Ie.charCodeAt(ve),Math.random()>.5&&(oe="x"+oe.toString(16)),Ce+="&#"+oe+";";return Ce}var K=function(){function Ie(ve){this.tokens=[],this.tokens.links=Object.create(null),this.options=ve||Re,this.options.tokenizer=this.options.tokenizer||new Me,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var oe={block:Be.normal,inline:Qe.normal};this.options.pedantic?(oe.block=Be.pedantic,oe.inline=Qe.pedantic):this.options.gfm&&(oe.block=Be.gfm,this.options.breaks?oe.inline=Qe.breaks:oe.inline=Qe.gfm),this.tokenizer.rules=oe}Ie.lex=function(oe,se){var fe=new Ie(se);return fe.lex(oe)},Ie.lexInline=function(oe,se){var fe=new Ie(se);return fe.inlineTokens(oe)};var Ce=Ie.prototype;return Ce.lex=function(oe){oe=oe.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(oe,this.tokens);for(var se;se=this.inlineQueue.shift();)this.inlineTokens(se.src,se.tokens);return this.tokens},Ce.blockTokens=function(oe,se){var fe=this;se===void 0&&(se=[]),this.options.pedantic&&(oe=oe.replace(/^ +$/gm,""));for(var ge,ke,ze,Oe;oe;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(it){return(ge=it.call({lexer:fe},oe,se))?(oe=oe.substring(ge.raw.length),se.push(ge),!0):!1}))){if(ge=this.tokenizer.space(oe)){oe=oe.substring(ge.raw.length),ge.type&&se.push(ge);continue}if(ge=this.tokenizer.code(oe)){oe=oe.substring(ge.raw.length),ke=se[se.length-1],ke&&(ke.type==="paragraph"||ke.type==="text")?(ke.raw+=`
`+ge.raw,ke.text+=`
`+ge.text,this.inlineQueue[this.inlineQueue.length-1].src=ke.text):se.push(ge);continue}if(ge=this.tokenizer.fences(oe)){oe=oe.substring(ge.raw.length),se.push(ge);continue}if(ge=this.tokenizer.heading(oe)){oe=oe.substring(ge.raw.length),se.push(ge);continue}if(ge=this.tokenizer.hr(oe)){oe=oe.substring(ge.raw.length),se.push(ge);continue}if(ge=this.tokenizer.blockquote(oe)){oe=oe.substring(ge.raw.length),se.push(ge);continue}if(ge=this.tokenizer.list(oe)){oe=oe.substring(ge.raw.length),se.push(ge);continue}if(ge=this.tokenizer.html(oe)){oe=oe.substring(ge.raw.length),se.push(ge);continue}if(ge=this.tokenizer.def(oe)){oe=oe.substring(ge.raw.length),ke=se[se.length-1],ke&&(ke.type==="paragraph"||ke.type==="text")?(ke.raw+=`
`+ge.raw,ke.text+=`
`+ge.raw,this.inlineQueue[this.inlineQueue.length-1].src=ke.text):this.tokens.links[ge.tag]||(this.tokens.links[ge.tag]={href:ge.href,title:ge.title});continue}if(ge=this.tokenizer.table(oe)){oe=oe.substring(ge.raw.length),se.push(ge);continue}if(ge=this.tokenizer.lheading(oe)){oe=oe.substring(ge.raw.length),se.push(ge);continue}if(ze=oe,this.options.extensions&&this.options.extensions.startBlock&&function(){var it=1/0,rt=oe.slice(1),ne=void 0;fe.options.extensions.startBlock.forEach(function(pe){ne=pe.call({lexer:this},rt),typeof ne=="number"&&ne>=0&&(it=Math.min(it,ne))}),it<1/0&&it>=0&&(ze=oe.substring(0,it+1))}(),this.state.top&&(ge=this.tokenizer.paragraph(ze))){ke=se[se.length-1],Oe&&ke.type==="paragraph"?(ke.raw+=`
`+ge.raw,ke.text+=`
`+ge.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=ke.text):se.push(ge),Oe=ze.length!==oe.length,oe=oe.substring(ge.raw.length);continue}if(ge=this.tokenizer.text(oe)){oe=oe.substring(ge.raw.length),ke=se[se.length-1],ke&&ke.type==="text"?(ke.raw+=`
`+ge.raw,ke.text+=`
`+ge.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=ke.text):se.push(ge);continue}if(oe){var Ve="Infinite loop on byte: "+oe.charCodeAt(0);if(this.options.silent){console.error(Ve);break}else throw new Error(Ve)}}return this.state.top=!0,se},Ce.inline=function(oe,se){this.inlineQueue.push({src:oe,tokens:se})},Ce.inlineTokens=function(oe,se){var fe=this;se===void 0&&(se=[]);var ge,ke,ze,Oe=oe,Ve,it,rt;if(this.tokens.links){var ne=Object.keys(this.tokens.links);if(ne.length>0)for(;(Ve=this.tokenizer.rules.inline.reflinkSearch.exec(Oe))!=null;)ne.includes(Ve[0].slice(Ve[0].lastIndexOf("[")+1,-1))&&(Oe=Oe.slice(0,Ve.index)+"["+Ke("a",Ve[0].length-2)+"]"+Oe.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ve=this.tokenizer.rules.inline.blockSkip.exec(Oe))!=null;)Oe=Oe.slice(0,Ve.index)+"["+Ke("a",Ve[0].length-2)+"]"+Oe.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ve=this.tokenizer.rules.inline.escapedEmSt.exec(Oe))!=null;)Oe=Oe.slice(0,Ve.index)+"++"+Oe.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;oe;)if(it||(rt=""),it=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ee){return(ge=ee.call({lexer:fe},oe,se))?(oe=oe.substring(ge.raw.length),se.push(ge),!0):!1}))){if(ge=this.tokenizer.escape(oe)){oe=oe.substring(ge.raw.length),se.push(ge);continue}if(ge=this.tokenizer.tag(oe)){oe=oe.substring(ge.raw.length),ke=se[se.length-1],ke&&ge.type==="text"&&ke.type==="text"?(ke.raw+=ge.raw,ke.text+=ge.text):se.push(ge);continue}if(ge=this.tokenizer.link(oe)){oe=oe.substring(ge.raw.length),se.push(ge);continue}if(ge=this.tokenizer.reflink(oe,this.tokens.links)){oe=oe.substring(ge.raw.length),ke=se[se.length-1],ke&&ge.type==="text"&&ke.type==="text"?(ke.raw+=ge.raw,ke.text+=ge.text):se.push(ge);continue}if(ge=this.tokenizer.emStrong(oe,Oe,rt)){oe=oe.substring(ge.raw.length),se.push(ge);continue}if(ge=this.tokenizer.codespan(oe)){oe=oe.substring(ge.raw.length),se.push(ge);continue}if(ge=this.tokenizer.br(oe)){oe=oe.substring(ge.raw.length),se.push(ge);continue}if(ge=this.tokenizer.del(oe)){oe=oe.substring(ge.raw.length),se.push(ge);continue}if(ge=this.tokenizer.autolink(oe,$)){oe=oe.substring(ge.raw.length),se.push(ge);continue}if(!this.state.inLink&&(ge=this.tokenizer.url(oe,$))){oe=oe.substring(ge.raw.length),se.push(ge);continue}if(ze=oe,this.options.extensions&&this.options.extensions.startInline&&function(){var ee=1/0,W=oe.slice(1),be=void 0;fe.options.extensions.startInline.forEach(function(De){be=De.call({lexer:this},W),typeof be=="number"&&be>=0&&(ee=Math.min(ee,be))}),ee<1/0&&ee>=0&&(ze=oe.substring(0,ee+1))}(),ge=this.tokenizer.inlineText(ze,Xe)){oe=oe.substring(ge.raw.length),ge.raw.slice(-1)!=="_"&&(rt=ge.raw.slice(-1)),it=!0,ke=se[se.length-1],ke&&ke.type==="text"?(ke.raw+=ge.raw,ke.text+=ge.text):se.push(ge);continue}if(oe){var pe="Infinite loop on byte: "+oe.charCodeAt(0);if(this.options.silent){console.error(pe);break}else throw new Error(pe)}}return se},e(Ie,null,[{key:"rules",get:function(){return{block:Be,inline:Qe}}}]),Ie}(),J=T.exports.defaults,ae=U.cleanUrl,q=U.escape,te=function(){function Ie(ve){this.options=ve||J}var Ce=Ie.prototype;return Ce.code=function(oe,se,fe){var ge=(se||"").match(/\S*/)[0];if(this.options.highlight){var ke=this.options.highlight(oe,ge);ke!=null&&ke!==oe&&(fe=!0,oe=ke)}return oe=oe.replace(/\n$/,"")+`
`,ge?'<pre><code class="'+this.options.langPrefix+q(ge,!0)+'">'+(fe?oe:q(oe,!0))+`</code></pre>
`:"<pre><code>"+(fe?oe:q(oe,!0))+`</code></pre>
`},Ce.blockquote=function(oe){return`<blockquote>
`+oe+`</blockquote>
`},Ce.html=function(oe){return oe},Ce.heading=function(oe,se,fe,ge){return this.options.headerIds?"<h"+se+' id="'+this.options.headerPrefix+ge.slug(fe)+'">'+oe+"</h"+se+`>
`:"<h"+se+">"+oe+"</h"+se+`>
`},Ce.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Ce.list=function(oe,se,fe){var ge=se?"ol":"ul",ke=se&&fe!==1?' start="'+fe+'"':"";return"<"+ge+ke+`>
`+oe+"</"+ge+`>
`},Ce.listitem=function(oe){return"<li>"+oe+`</li>
`},Ce.checkbox=function(oe){return"<input "+(oe?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Ce.paragraph=function(oe){return"<p>"+oe+`</p>
`},Ce.table=function(oe,se){return se&&(se="<tbody>"+se+"</tbody>"),`<table>
<thead>
`+oe+`</thead>
`+se+`</table>
`},Ce.tablerow=function(oe){return`<tr>
`+oe+`</tr>
`},Ce.tablecell=function(oe,se){var fe=se.header?"th":"td",ge=se.align?"<"+fe+' align="'+se.align+'">':"<"+fe+">";return ge+oe+"</"+fe+`>
`},Ce.strong=function(oe){return"<strong>"+oe+"</strong>"},Ce.em=function(oe){return"<em>"+oe+"</em>"},Ce.codespan=function(oe){return"<code>"+oe+"</code>"},Ce.br=function(){return this.options.xhtml?"<br/>":"<br>"},Ce.del=function(oe){return"<del>"+oe+"</del>"},Ce.link=function(oe,se,fe){if(oe=ae(this.options.sanitize,this.options.baseUrl,oe),oe===null)return fe;var ge='<a href="'+q(oe)+'"';return se&&(ge+=' title="'+se+'"'),ge+=">"+fe+"</a>",ge},Ce.image=function(oe,se,fe){if(oe=ae(this.options.sanitize,this.options.baseUrl,oe),oe===null)return fe;var ge='<img src="'+oe+'" alt="'+fe+'"';return se&&(ge+=' title="'+se+'"'),ge+=this.options.xhtml?"/>":">",ge},Ce.text=function(oe){return oe},Ie}(),me=function(){function Ie(){}var Ce=Ie.prototype;return Ce.strong=function(oe){return oe},Ce.em=function(oe){return oe},Ce.codespan=function(oe){return oe},Ce.del=function(oe){return oe},Ce.html=function(oe){return oe},Ce.text=function(oe){return oe},Ce.link=function(oe,se,fe){return""+fe},Ce.image=function(oe,se,fe){return""+fe},Ce.br=function(){return""},Ie}(),Pe=function(){function Ie(){this.seen={}}var Ce=Ie.prototype;return Ce.serialize=function(oe){return oe.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Ce.getNextSafeSlug=function(oe,se){var fe=oe,ge=0;if(this.seen.hasOwnProperty(fe)){ge=this.seen[oe];do ge++,fe=oe+"-"+ge;while(this.seen.hasOwnProperty(fe))}return se||(this.seen[oe]=ge,this.seen[fe]=0),fe},Ce.slug=function(oe,se){se===void 0&&(se={});var fe=this.serialize(oe);return this.getNextSafeSlug(fe,se.dryrun)},Ie}(),Ne=te,He=me,Ye=Pe,et=T.exports.defaults,st=U.unescape,Je=function(){function Ie(ve){this.options=ve||et,this.options.renderer=this.options.renderer||new Ne,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new He,this.slugger=new Ye}Ie.parse=function(oe,se){var fe=new Ie(se);return fe.parse(oe)},Ie.parseInline=function(oe,se){var fe=new Ie(se);return fe.parseInline(oe)};var Ce=Ie.prototype;return Ce.parse=function(oe,se){se===void 0&&(se=!0);var fe="",ge,ke,ze,Oe,Ve,it,rt,ne,pe,ee,W,be,De,qe,xe,ut,vt,St,bt,ht=oe.length;for(ge=0;ge<ht;ge++){if(ee=oe[ge],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ee.type]&&(bt=this.options.extensions.renderers[ee.type].call({parser:this},ee),bt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ee.type))){fe+=bt||"";continue}switch(ee.type){case"space":continue;case"hr":{fe+=this.renderer.hr();continue}case"heading":{fe+=this.renderer.heading(this.parseInline(ee.tokens),ee.depth,st(this.parseInline(ee.tokens,this.textRenderer)),this.slugger);continue}case"code":{fe+=this.renderer.code(ee.text,ee.lang,ee.escaped);continue}case"table":{for(ne="",rt="",Oe=ee.header.length,ke=0;ke<Oe;ke++)rt+=this.renderer.tablecell(this.parseInline(ee.header[ke].tokens),{header:!0,align:ee.align[ke]});for(ne+=this.renderer.tablerow(rt),pe="",Oe=ee.rows.length,ke=0;ke<Oe;ke++){for(it=ee.rows[ke],rt="",Ve=it.length,ze=0;ze<Ve;ze++)rt+=this.renderer.tablecell(this.parseInline(it[ze].tokens),{header:!1,align:ee.align[ze]});pe+=this.renderer.tablerow(rt)}fe+=this.renderer.table(ne,pe);continue}case"blockquote":{pe=this.parse(ee.tokens),fe+=this.renderer.blockquote(pe);continue}case"list":{for(W=ee.ordered,be=ee.start,De=ee.loose,Oe=ee.items.length,pe="",ke=0;ke<Oe;ke++)xe=ee.items[ke],ut=xe.checked,vt=xe.task,qe="",xe.task&&(St=this.renderer.checkbox(ut),De?xe.tokens.length>0&&xe.tokens[0].type==="paragraph"?(xe.tokens[0].text=St+" "+xe.tokens[0].text,xe.tokens[0].tokens&&xe.tokens[0].tokens.length>0&&xe.tokens[0].tokens[0].type==="text"&&(xe.tokens[0].tokens[0].text=St+" "+xe.tokens[0].tokens[0].text)):xe.tokens.unshift({type:"text",text:St}):qe+=St),qe+=this.parse(xe.tokens,De),pe+=this.renderer.listitem(qe,vt,ut);fe+=this.renderer.list(pe,W,be);continue}case"html":{fe+=this.renderer.html(ee.text);continue}case"paragraph":{fe+=this.renderer.paragraph(this.parseInline(ee.tokens));continue}case"text":{for(pe=ee.tokens?this.parseInline(ee.tokens):ee.text;ge+1<ht&&oe[ge+1].type==="text";)ee=oe[++ge],pe+=`
`+(ee.tokens?this.parseInline(ee.tokens):ee.text);fe+=se?this.renderer.paragraph(pe):pe;continue}default:{var gt='Token with "'+ee.type+'" type was not found.';if(this.options.silent){console.error(gt);return}else throw new Error(gt)}}}return fe},Ce.parseInline=function(oe,se){se=se||this.renderer;var fe="",ge,ke,ze,Oe=oe.length;for(ge=0;ge<Oe;ge++){if(ke=oe[ge],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ke.type]&&(ze=this.options.extensions.renderers[ke.type].call({parser:this},ke),ze!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(ke.type))){fe+=ze||"";continue}switch(ke.type){case"escape":{fe+=se.text(ke.text);break}case"html":{fe+=se.html(ke.text);break}case"link":{fe+=se.link(ke.href,ke.title,this.parseInline(ke.tokens,se));break}case"image":{fe+=se.image(ke.href,ke.title,ke.text);break}case"strong":{fe+=se.strong(this.parseInline(ke.tokens,se));break}case"em":{fe+=se.em(this.parseInline(ke.tokens,se));break}case"codespan":{fe+=se.codespan(ke.text);break}case"br":{fe+=se.br();break}case"del":{fe+=se.del(this.parseInline(ke.tokens,se));break}case"text":{fe+=se.text(ke.text);break}default:{var Ve='Token with "'+ke.type+'" type was not found.';if(this.options.silent){console.error(Ve);return}else throw new Error(Ve)}}}return fe},Ie}(),nt=K,lt=Je,pt=ue,Ft=te,Fe=me,Mt=Pe,V=U.merge,Q=U.checkSanitizeDeprecation,he=U.escape,Le=T.exports.getDefaults,We=T.exports.changeDefaults,ot=T.exports.defaults;function Ge(Ie,Ce,ve){if(typeof Ie=="undefined"||Ie===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Ie!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Ie)+", string expected");if(typeof Ce=="function"&&(ve=Ce,Ce=null),Ce=V({},Ge.defaults,Ce||{}),Q(Ce),ve){var oe=Ce.highlight,se;try{se=nt.lex(Ie,Ce)}catch(ze){return ve(ze)}var fe=function(Oe){var Ve;if(!Oe)try{Ce.walkTokens&&Ge.walkTokens(se,Ce.walkTokens),Ve=lt.parse(se,Ce)}catch(it){Oe=it}return Ce.highlight=oe,Oe?ve(Oe):ve(null,Ve)};if(!oe||oe.length<3||(delete Ce.highlight,!se.length))return fe();var ge=0;Ge.walkTokens(se,function(ze){ze.type==="code"&&(ge++,setTimeout(function(){oe(ze.text,ze.lang,function(Oe,Ve){if(Oe)return fe(Oe);Ve!=null&&Ve!==ze.text&&(ze.text=Ve,ze.escaped=!0),ge--,ge===0&&fe()})},0))}),ge===0&&fe();return}try{var ke=nt.lex(Ie,Ce);return Ce.walkTokens&&Ge.walkTokens(ke,Ce.walkTokens),lt.parse(ke,Ce)}catch(ze){if(ze.message+=`
Please report this to https://github.com/markedjs/marked.`,Ce.silent)return"<p>An error occurred:</p><pre>"+he(ze.message+"",!0)+"</pre>";throw ze}}Ge.options=Ge.setOptions=function(Ie){return V(Ge.defaults,Ie),We(Ge.defaults),Ge},Ge.getDefaults=Le,Ge.defaults=ot,Ge.use=function(){for(var Ie=this,Ce=arguments.length,ve=new Array(Ce),oe=0;oe<Ce;oe++)ve[oe]=arguments[oe];var se=V.apply(void 0,[{}].concat(ve)),fe=Ge.defaults.extensions||{renderers:{},childTokens:{}},ge;ve.forEach(function(ke){if(ke.extensions&&(ge=!0,ke.extensions.forEach(function(Oe){if(!Oe.name)throw new Error("extension name required");if(Oe.renderer){var Ve=fe.renderers?fe.renderers[Oe.name]:null;Ve?fe.renderers[Oe.name]=function(){for(var it=arguments.length,rt=new Array(it),ne=0;ne<it;ne++)rt[ne]=arguments[ne];var pe=Oe.renderer.apply(this,rt);return pe===!1&&(pe=Ve.apply(this,rt)),pe}:fe.renderers[Oe.name]=Oe.renderer}if(Oe.tokenizer){if(!Oe.level||Oe.level!=="block"&&Oe.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");fe[Oe.level]?fe[Oe.level].unshift(Oe.tokenizer):fe[Oe.level]=[Oe.tokenizer],Oe.start&&(Oe.level==="block"?fe.startBlock?fe.startBlock.push(Oe.start):fe.startBlock=[Oe.start]:Oe.level==="inline"&&(fe.startInline?fe.startInline.push(Oe.start):fe.startInline=[Oe.start]))}Oe.childTokens&&(fe.childTokens[Oe.name]=Oe.childTokens)})),ke.renderer&&function(){var Oe=Ge.defaults.renderer||new Ft,Ve=function(ne){var pe=Oe[ne];Oe[ne]=function(){for(var ee=arguments.length,W=new Array(ee),be=0;be<ee;be++)W[be]=arguments[be];var De=ke.renderer[ne].apply(Oe,W);return De===!1&&(De=pe.apply(Oe,W)),De}};for(var it in ke.renderer)Ve(it);se.renderer=Oe}(),ke.tokenizer&&function(){var Oe=Ge.defaults.tokenizer||new pt,Ve=function(ne){var pe=Oe[ne];Oe[ne]=function(){for(var ee=arguments.length,W=new Array(ee),be=0;be<ee;be++)W[be]=arguments[be];var De=ke.tokenizer[ne].apply(Oe,W);return De===!1&&(De=pe.apply(Oe,W)),De}};for(var it in ke.tokenizer)Ve(it);se.tokenizer=Oe}(),ke.walkTokens){var ze=Ge.defaults.walkTokens;se.walkTokens=function(Oe){ke.walkTokens.call(Ie,Oe),ze&&ze(Oe)}}ge&&(se.extensions=fe),Ge.setOptions(se)})},Ge.walkTokens=function(Ie,Ce){for(var ve=function(){var ge=se.value;switch(Ce(ge),ge.type){case"table":{for(var ke=w(ge.header),ze;!(ze=ke()).done;){var Oe=ze.value;Ge.walkTokens(Oe.tokens,Ce)}for(var Ve=w(ge.rows),it;!(it=Ve()).done;)for(var rt=it.value,ne=w(rt),pe;!(pe=ne()).done;){var ee=pe.value;Ge.walkTokens(ee.tokens,Ce)}break}case"list":{Ge.walkTokens(ge.items,Ce);break}default:Ge.defaults.extensions&&Ge.defaults.extensions.childTokens&&Ge.defaults.extensions.childTokens[ge.type]?Ge.defaults.extensions.childTokens[ge.type].forEach(function(W){Ge.walkTokens(ge[W],Ce)}):ge.tokens&&Ge.walkTokens(ge.tokens,Ce)}},oe=w(Ie),se;!(se=oe()).done;)ve()},Ge.parseInline=function(Ie,Ce){if(typeof Ie=="undefined"||Ie===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Ie!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Ie)+", string expected");Ce=V({},Ge.defaults,Ce||{}),Q(Ce);try{var ve=nt.lexInline(Ie,Ce);return Ce.walkTokens&&Ge.walkTokens(ve,Ce.walkTokens),lt.parseInline(ve,Ce)}catch(oe){if(oe.message+=`
Please report this to https://github.com/markedjs/marked.`,Ce.silent)return"<p>An error occurred:</p><pre>"+he(oe.message+"",!0)+"</pre>";throw oe}},Ge.Parser=lt,Ge.parser=lt.parse,Ge.Renderer=Ft,Ge.TextRenderer=Fe,Ge.Lexer=nt,Ge.lexer=nt.lex,Ge.Tokenizer=pt,Ge.Slugger=Mt,Ge.parse=Ge;var yt=Ge;return yt}),define(Ee[75],ye([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function a(k,I,S){return Math.min(Math.max(k,I),S)}e.clamp=a;function t(k,I){return(I+k%I)%I}e.rot=t;class w{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=w;class T{constructor(){this._n=1,this._val=0}update(I){return this._val=this._val+(I-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=T}),function(){function re(w){const T=[];typeof w=="number"&&T.push("code/timeOrigin",w);function k(S){T.push(S,Date.now())}function I(){const S=[];for(let R=0;R<T.length;R+=2)S.push({name:T[R],startTime:T[R+1]});return S}return{mark:k,getMarks:I}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?re():{mark(w){performance.mark(w)},getMarks(){let w=performance.timeOrigin;typeof w!="number"&&(w=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const T=[{name:"code/timeOrigin",startTime:Math.round(w)}];for(const k of performance.getEntriesByType("mark"))T.push({name:k.name,startTime:Math.round(w+k.startTime)});return T}};if(typeof process=="object"){const w=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return re(w)}else return console.trace("perf-util loaded in UNKNOWN environment"),re()}function a(w){return w.MonacoPerformanceMarks||(w.MonacoPerformanceMarks=e()),w.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return a(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=a(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=a(t))}(),define(Ee[102],ye([0,1,15,6]),function(re,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function w(h){const g=h;return g?[g.on,g.pause,g.resume,g.destroy].every(P=>typeof P=="function"):!1}e.isReadableStream=w;function T(h){const g=h;return g?w(g.stream)&&Array.isArray(g.buffer)&&typeof g.ended=="boolean":!1}e.isReadableBufferedStream=T;function k(h,g){return new I(h,g)}e.newWriteableStream=k;class I{constructor(g,P){this.reducer=g,this.options=P,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(g){if(!this.state.destroyed){if(this.state.flowing)this.emitData(g);else if(this.buffer.data.push(g),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(P=>this.pendingWritePromises.push(P))}}error(g){this.state.destroyed||(this.state.flowing?this.emitError(g):this.buffer.error.push(g))}end(g){this.state.destroyed||(typeof g!="undefined"&&this.write(g),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(g){this.listeners.data.slice(0).forEach(P=>P(g))}emitError(g){this.listeners.error.length===0?(0,a.onUnexpectedError)(g):this.listeners.error.slice(0).forEach(P=>P(g))}emitEnd(){this.listeners.end.slice(0).forEach(g=>g())}on(g,P){if(!this.state.destroyed)switch(g){case"data":this.listeners.data.push(P),this.resume();break;case"end":this.listeners.end.push(P),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(P),this.state.flowing&&this.flowErrors();break}}removeListener(g,P){if(this.state.destroyed)return;let l;switch(g){case"data":l=this.listeners.data;break;case"end":l=this.listeners.end;break;case"error":l=this.listeners.error;break}if(l){const M=l.indexOf(P);M>=0&&l.splice(M,1)}}flowData(){if(this.buffer.data.length>0){const g=this.reducer(this.buffer.data);this.emitData(g),this.buffer.data.length=0;const P=[...this.pendingWritePromises];this.pendingWritePromises.length=0,P.forEach(l=>l())}}flowErrors(){if(this.listeners.error.length>0){for(const g of this.buffer.error)this.emitError(g);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function S(h,g){const P=[];let l;for(;(l=h.read())!==null;)P.push(l);return g(P)}e.consumeReadable=S;function R(h,g,P){const l=[];let M;for(;(M=h.read())!==null&&l.length<P;)l.push(M);return M===null&&l.length>0?g(l):{read:()=>{if(l.length>0)return l.shift();if(typeof M!="undefined"){const r=M;return M=void 0,r}return h.read()}}}e.peekReadable=R;function F(h,g){return new Promise((P,l)=>{const M=[];_(h,{onData:r=>{g&&M.push(r)},onError:r=>{g?l(r):P(void 0)},onEnd:()=>{P(g?g(M):void 0)}})})}e.consumeStream=F;function _(h,g){let P=!1;return h.on("error",l=>{P||g.onError(l)}),h.on("end",()=>{P||g.onEnd()}),h.on("data",l=>{P||g.onData(l)}),(0,t.toDisposable)(()=>P=!0)}e.listenStream=_;function n(h,g){return new Promise((P,l)=>{const M=new t.DisposableStore,r=[],i=s=>{if(r.push(s),r.length>g)return M.dispose(),h.pause(),P({stream:h,buffer:r,ended:!1})},p=s=>l(s),d=()=>P({stream:h,buffer:r,ended:!0});M.add((0,t.toDisposable)(()=>h.removeListener("error",p))),h.on("error",p),M.add((0,t.toDisposable)(()=>h.removeListener("end",d))),h.on("end",d),M.add((0,t.toDisposable)(()=>h.removeListener("data",i))),h.on("data",i)})}e.peekStream=n;function f(h,g){const P=k(g);return P.end(h),P}e.toStream=f;function o(){const h=k(()=>{throw new Error("not supported")});return h.end(),h}e.emptyStream=o;function m(h){let g=!1;return{read:()=>g?null:(g=!0,h)}}e.toReadable=m;function c(h,g,P){const l=k(P);return _(h,{onData:M=>l.write(g.data(M)),onError:M=>l.error(g.error?g.error(M):M),onEnd:()=>l.end()}),l}e.transform=c;function C(h,g,P){let l=!1;return{read:()=>{const M=g.read();return l?M:(l=!0,M!==null?P([h,M]):h)}}}e.prefixedReadable=C;function b(h,g,P){let l=!1;const M=k(P);return _(g,{onData:r=>l?M.write(r):(l=!0,M.write(P([h,r]))),onError:r=>M.error(r),onEnd:()=>{l||(l=!0,M.write(h)),M.end()}}),M}e.prefixedStream=b}),define(Ee[22],ye([0,1,102]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer!="undefined";let w,T;class k{constructor(i){this.buffer=i,this.byteLength=this.buffer.byteLength}static alloc(i){return t?new k(Buffer.allocUnsafe(i)):new k(new Uint8Array(i))}static wrap(i){return t&&!Buffer.isBuffer(i)&&(i=Buffer.from(i.buffer,i.byteOffset,i.byteLength)),new k(i)}static fromString(i,p){return!(p?.dontUseNodeBuffer||!1)&&t?new k(Buffer.from(i)):(w||(w=new TextEncoder),new k(w.encode(i)))}static fromByteArray(i){const p=k.alloc(i.length);for(let d=0,s=i.length;d<s;d++)p.buffer[d]=i[d];return p}static concat(i,p){if(typeof p=="undefined"){p=0;for(let v=0,y=i.length;v<y;v++)p+=i[v].byteLength}const d=k.alloc(p);let s=0;for(let v=0,y=i.length;v<y;v++){const u=i[v];d.set(u,s),s+=u.byteLength}return d}clone(){const i=k.alloc(this.byteLength);return i.set(this),i}toString(){return t?this.buffer.toString():(T||(T=new TextDecoder),T.decode(this.buffer))}slice(i,p){return new k(this.buffer.subarray(i,p))}set(i,p){if(i instanceof k)this.buffer.set(i.buffer,p);else if(i instanceof Uint8Array)this.buffer.set(i,p);else if(i instanceof ArrayBuffer)this.buffer.set(new Uint8Array(i),p);else if(ArrayBuffer.isView(i))this.buffer.set(new Uint8Array(i.buffer,i.byteOffset,i.byteLength),p);else throw new Error("Unkown argument 'array'")}readUInt32BE(i){return R(this.buffer,i)}writeUInt32BE(i,p){F(this.buffer,i,p)}readUInt32LE(i){return _(this.buffer,i)}writeUInt32LE(i,p){n(this.buffer,i,p)}readUInt8(i){return f(this.buffer,i)}writeUInt8(i,p){o(this.buffer,i,p)}}e.VSBuffer=k;function I(r,i){return r[i+0]<<0>>>0|r[i+1]<<8>>>0}e.readUInt16LE=I;function S(r,i,p){r[p+0]=i&255,i=i>>>8,r[p+1]=i&255}e.writeUInt16LE=S;function R(r,i){return r[i]*2**24+r[i+1]*2**16+r[i+2]*2**8+r[i+3]}e.readUInt32BE=R;function F(r,i,p){r[p+3]=i,i=i>>>8,r[p+2]=i,i=i>>>8,r[p+1]=i,i=i>>>8,r[p]=i}e.writeUInt32BE=F;function _(r,i){return r[i+0]<<0>>>0|r[i+1]<<8>>>0|r[i+2]<<16>>>0|r[i+3]<<24>>>0}e.readUInt32LE=_;function n(r,i,p){r[p+0]=i&255,i=i>>>8,r[p+1]=i&255,i=i>>>8,r[p+2]=i&255,i=i>>>8,r[p+3]=i&255}e.writeUInt32LE=n;function f(r,i){return r[i]}e.readUInt8=f;function o(r,i,p){r[p]=i}e.writeUInt8=o;function m(r){return a.consumeReadable(r,i=>k.concat(i))}e.readableToBuffer=m;function c(r){return a.toReadable(r)}e.bufferToReadable=c;function C(r){return a.consumeStream(r,i=>k.concat(i))}e.streamToBuffer=C;async function b(r){return r.ended?k.concat(r.buffer):k.concat([...r.buffer,await C(r.stream)])}e.bufferedStreamToBuffer=b;function h(r){return a.toStream(r,i=>k.concat(i))}e.bufferToStream=h;function g(r){return a.transform(r,{data:i=>typeof i=="string"?k.fromString(i):k.wrap(i)},i=>k.concat(i))}e.streamToBufferReadableStream=g;function P(r){return a.newWriteableStream(i=>k.concat(i),r)}e.newWriteableBufferStream=P;function l(r,i){return a.prefixedReadable(r,i,p=>k.concat(p))}e.prefixedBufferReadable=l;function M(r,i){return a.prefixedStream(r,i,p=>k.concat(p))}e.prefixedBufferStream=M});var Ze=this&&this.__classPrivateFieldSet||function(re,e,a,t,w){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!w:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?w.call(re,a):w?w.value=a:e.set(re,a),a},Te=this&&this.__classPrivateFieldGet||function(re,e,a,t){if(a==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!t:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?t:a==="a"?t.call(re):t?t.value:e.get(re)};define(Ee[21],ye([0,1,16,9]),function(re,e,a,t){"use strict";var w,T,k;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function I(r,i,p){let d=r.get(i);return d===void 0&&(d=p,r.set(i,d)),d}e.getOrSet=I;function S(r){const i=[];return r.forEach((p,d)=>{i.push(`${d} => ${p}`)}),`Map(${r.size}) {${i.join(", ")}}`}e.mapToString=S;function R(r){const i=[];return r.forEach(p=>{i.push(p)}),`Set(${r.size}) {${i.join(", ")}}`}e.setToString=R;class F{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const p=i.charCodeAt(0),d=this._value.charCodeAt(this._pos);return p-d}value(){return this._value[this._pos]}}e.StringIterator=F;class _{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?(0,t.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=_;class n{constructor(i=!0,p=!0){this._splitOnBackslash=i,this._caseSensitive=p}reset(i){this._from=0,this._to=0,this._value=i,this._valueLen=i.length;for(let p=i.length-1;p>=0;p--,this._valueLen--){const d=this._value.charCodeAt(p);if(!(d===47||this._splitOnBackslash&&d===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let i=!0;for(;this._to<this._valueLen;this._to++){const p=this._value.charCodeAt(this._to);if(p===47||this._splitOnBackslash&&p===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?(0,t.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=n;var f;(function(r){r[r.Scheme=1]="Scheme",r[r.Authority=2]="Authority",r[r.Path=3]="Path",r[r.Query=4]="Query",r[r.Fragment=5]="Fragment"})(f||(f={}));class o{constructor(i){this._ignorePathCasing=i,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new n(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return(0,t.compareIgnoreCase)(i,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,t.compareIgnoreCase)(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return(0,t.compare)(i,this._value.query);if(this._states[this._stateIdx]===5)return(0,t.compare)(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=o;class m{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const i=this.right;return this.right=i.left,i.left=this,this.updateHeight(),i.updateHeight(),i}rotateRight(){const i=this.left;return this.left=i.right,i.right=this,this.updateHeight(),i.updateHeight(),i}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var c;(function(r){r[r.Left=-1]="Left",r[r.Mid=0]="Mid",r[r.Right=1]="Right"})(c||(c={}));class C{constructor(i){this._iter=i}static forUris(i=()=>!1){return new C(new o(i))}static forPaths(){return new C(new n)}static forStrings(){return new C(new F)}static forConfigKeys(){return new C(new _)}clear(){this._root=void 0}fill(i,p){if(p){const d=p.slice(0);(0,a.shuffle)(d);for(let s of d)this.set(s,i)}else{const d=i.slice(0);(0,a.shuffle)(d);for(let s of d)this.set(s[0],s[1])}}set(i,p){const d=this._iter.reset(i);let s;this._root||(this._root=new m,this._root.segment=d.value());const v=[];for(s=this._root;;){const u=d.cmp(s.segment);if(u>0)s.left||(s.left=new m,s.left.segment=d.value()),v.push([-1,s]),s=s.left;else if(u<0)s.right||(s.right=new m,s.right.segment=d.value()),v.push([1,s]),s=s.right;else if(d.hasNext())d.next(),s.mid||(s.mid=new m,s.mid.segment=d.value()),v.push([0,s]),s=s.mid;else break}const y=s.value;s.value=p,s.key=i;for(let u=v.length-1;u>=0;u--){const D=v[u][1];D.updateHeight();const A=D.balanceFactor();if(A<-1||A>1){const U=v[u][0],B=v[u+1][0];if(U===1&&B===1)v[u][1]=D.rotateLeft();else if(U===-1&&B===-1)v[u][1]=D.rotateRight();else if(U===1&&B===-1)D.right=v[u+1][1]=v[u+1][1].rotateRight(),v[u][1]=D.rotateLeft();else if(U===-1&&B===1)D.left=v[u+1][1]=v[u+1][1].rotateLeft(),v[u][1]=D.rotateRight();else throw new Error;if(u>0)switch(v[u-1][0]){case-1:v[u-1][1].left=v[u][1];break;case 1:v[u-1][1].right=v[u][1];break;case 0:v[u-1][1].mid=v[u][1];break}else this._root=v[0][1]}}return y}get(i){return this._getNode(i)?.value}_getNode(i){const p=this._iter.reset(i);let d=this._root;for(;d;){const s=p.cmp(d.segment);if(s>0)d=d.left;else if(s<0)d=d.right;else if(p.hasNext())p.next(),d=d.mid;else break}return d}has(i){const p=this._getNode(i);return!(p?.value===void 0&&p?.mid===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,p){const d=this._iter.reset(i),s=[];let v=this._root;for(;v;){const y=d.cmp(v.segment);if(y>0)s.push([-1,v]),v=v.left;else if(y<0)s.push([1,v]),v=v.right;else if(d.hasNext())d.next(),s.push([0,v]),v=v.mid;else break}if(!!v){if(p?(v.left=void 0,v.mid=void 0,v.right=void 0,v.height=1):(v.key=void 0,v.value=void 0),!v.mid&&!v.value)if(v.left&&v.right){const y=this._min(v.right),{key:u,value:D,segment:A}=y;this._delete(y.key,!1),v.key=u,v.value=D,v.segment=A}else{const y=v.left??v.right;if(s.length>0){const[u,D]=s[s.length-1];switch(u){case-1:D.left=y;break;case 0:D.mid=y;break;case 1:D.right=y;break}}else this._root=y}for(let y=s.length-1;y>=0;y--){const u=s[y][1];u.updateHeight();const D=u.balanceFactor();if(D>1?(u.right.balanceFactor()>=0||(u.right=u.right.rotateRight()),s[y][1]=u.rotateLeft()):D<-1&&(u.left.balanceFactor()<=0||(u.left=u.left.rotateLeft()),s[y][1]=u.rotateRight()),y>0)switch(s[y-1][0]){case-1:s[y-1][1].left=s[y][1];break;case 1:s[y-1][1].right=s[y][1];break;case 0:s[y-1][1].mid=s[y][1];break}else this._root=s[0][1]}}}_min(i){for(;i.left;)i=i.left;return i}findSubstr(i){const p=this._iter.reset(i);let d=this._root,s;for(;d;){const v=p.cmp(d.segment);if(v>0)d=d.left;else if(v<0)d=d.right;else if(p.hasNext())p.next(),s=d.value||s,d=d.mid;else break}return d&&d.value||s}findSuperstr(i){const p=this._iter.reset(i);let d=this._root;for(;d;){const s=p.cmp(d.segment);if(s>0)d=d.left;else if(s<0)d=d.right;else if(p.hasNext())p.next(),d=d.mid;else return d.mid?this._entries(d.mid):void 0}}forEach(i){for(const[p,d]of this)i(d,p)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(i){!i||(i.left&&(yield*this._entries(i.left)),i.value&&(yield[i.key,i.value]),i.mid&&(yield*this._entries(i.mid)),i.right&&(yield*this._entries(i.right)))}_isBalanced(){const i=p=>{if(!p)return!0;const d=p.balanceFactor();return d<-1||d>1?!1:i(p.left)&&i(p.right)};return i(this._root)}}e.TernarySearchTree=C;class b{constructor(i,p){this.uri=i,this.value=p}}class h{constructor(i,p){this[w]="ResourceMap",i instanceof h?(this.map=new Map(i.map),this.toKey=p??h.defaultToKey):(this.map=new Map,this.toKey=i??h.defaultToKey)}set(i,p){return this.map.set(this.toKey(i),new b(i,p)),this}get(i){return this.map.get(this.toKey(i))?.value}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,p){typeof p!="undefined"&&(i=i.bind(p));for(let[d,s]of this.map)i(s.value,s.uri,this)}*values(){for(let i of this.map.values())yield i.value}*keys(){for(let i of this.map.values())yield i.uri}*entries(){for(let i of this.map.values())yield[i.uri,i.value]}*[(w=Symbol.toStringTag,Symbol.iterator)](){for(let[,i]of this.map)yield[i.uri,i.value]}}e.ResourceMap=h,h.defaultToKey=r=>r.toString();var g;(function(r){r[r.None=0]="None",r[r.AsOld=1]="AsOld",r[r.AsNew=2]="AsNew"})(g=e.Touch||(e.Touch={}));class P{constructor(){this[T]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(i){return this._map.has(i)}get(i,p=0){const d=this._map.get(i);if(!!d)return p!==0&&this.touch(d,p),d.value}set(i,p,d=0){let s=this._map.get(i);if(s)s.value=p,d!==0&&this.touch(s,d);else{switch(s={key:i,value:p,next:void 0,previous:void 0},d){case 0:this.addItemLast(s);break;case 1:this.addItemFirst(s);break;case 2:this.addItemLast(s);break;default:this.addItemLast(s);break}this._map.set(i,s),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const p=this._map.get(i);if(!!p)return this._map.delete(i),this.removeItem(p),this._size--,p.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}forEach(i,p){const d=this._state;let s=this._head;for(;s;){if(p?i.bind(p)(s.value,s.key,this):i(s.value,s.key,this),this._state!==d)throw new Error("LinkedMap got modified during iteration.");s=s.next}}keys(){const i=this,p=this._state;let d=this._head;const s={[Symbol.iterator](){return s},next(){if(i._state!==p)throw new Error("LinkedMap got modified during iteration.");if(d){const v={value:d.key,done:!1};return d=d.next,v}else return{value:void 0,done:!0}}};return s}values(){const i=this,p=this._state;let d=this._head;const s={[Symbol.iterator](){return s},next(){if(i._state!==p)throw new Error("LinkedMap got modified during iteration.");if(d){const v={value:d.value,done:!1};return d=d.next,v}else return{value:void 0,done:!0}}};return s}entries(){const i=this,p=this._state;let d=this._head;const s={[Symbol.iterator](){return s},next(){if(i._state!==p)throw new Error("LinkedMap got modified during iteration.");if(d){const v={value:[d.key,d.value],done:!1};return d=d.next,v}else return{value:void 0,done:!0}}};return s}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(i>=this.size)return;if(i===0){this.clear();return}let p=this._head,d=this.size;for(;p&&d>i;)this._map.delete(p.key),p=p.next,d--;this._head=p,this._size=d,p&&(p.previous=void 0),this._state++}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const p=i.next,d=i.previous;if(!p||!d)throw new Error("Invalid list");p.previous=d,d.next=p}i.next=void 0,i.previous=void 0,this._state++}touch(i,p){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(p!==1&&p!==2)){if(p===1){if(i===this._head)return;const d=i.next,s=i.previous;i===this._tail?(s.next=void 0,this._tail=s):(d.previous=s,s.next=d),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(p===2){if(i===this._tail)return;const d=i.next,s=i.previous;i===this._head?(d.previous=void 0,this._head=d):(d.previous=s,s.next=d),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((p,d)=>{i.push([d,p])}),i}fromJSON(i){this.clear();for(const[p,d]of i)this.set(p,d)}}e.LinkedMap=P;class l extends P{constructor(i,p=1){super();this._limit=i,this._ratio=Math.min(Math.max(0,p),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,p=2){return super.get(i,p)}peek(i){return super.get(i,0)}set(i,p){return super.set(i,p,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=l;class M{constructor(i){k.set(this,void 0),Ze(this,k,i,"f")}get size(){return Te(this,k,"f").size}forEach(i,p){Te(this,k,"f").forEach(i,p)}get(i){return Te(this,k,"f").get(i)}has(i){return Te(this,k,"f").has(i)}entries(){return Te(this,k,"f").entries()}keys(){return Te(this,k,"f").keys()}values(){return Te(this,k,"f").values()}[(k=new WeakMap,Symbol.iterator)](){return Te(this,k,"f").entries()}}e.ReadonlyMapView=M}),define(Ee[103],ye([0,1,21,9]),function(re,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function w(...q){return function(te,me){for(let Pe=0,Ne=q.length;Pe<Ne;Pe++){const He=q[Pe](te,me);if(He)return He}return null}}e.or=w,e.matchesStrictPrefix=T.bind(void 0,!1),e.matchesPrefix=T.bind(void 0,!0);function T(q,te,me){if(!me||me.length<te.length)return null;let Pe;return q?Pe=t.startsWithIgnoreCase(me,te):Pe=me.indexOf(te)===0,Pe?te.length>0?[{start:0,end:te.length}]:[]:null}function k(q,te){const me=te.toLowerCase().indexOf(q.toLowerCase());return me===-1?null:[{start:me,end:me+q.length}]}e.matchesContiguousSubString=k;function I(q,te){return S(q.toLowerCase(),te.toLowerCase(),0,0)}e.matchesSubString=I;function S(q,te,me,Pe){if(me===q.length)return[];if(Pe===te.length)return null;if(q[me]===te[Pe]){let Ne=null;return(Ne=S(q,te,me+1,Pe+1))?C({start:Pe,end:Pe+1},Ne):null}return S(q,te,me,Pe+1)}function R(q){return 97<=q&&q<=122}function F(q){return 65<=q&&q<=90}e.isUpper=F;function _(q){return 48<=q&&q<=57}function n(q){return q===32||q===9||q===10||q===13}const f=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(q=>f.add(q.charCodeAt(0)));function o(q){return n(q)||f.has(q)}function m(q,te){return q===te||o(q)&&o(te)}function c(q){return R(q)||F(q)||_(q)}function C(q,te){return te.length===0?te=[q]:q.end===te[0].start?te[0].start=q.start:te.unshift(q),te}function b(q,te){for(let me=te;me<q.length;me++){const Pe=q.charCodeAt(me);if(F(Pe)||_(Pe)||me>0&&!c(q.charCodeAt(me-1)))return me}return q.length}function h(q,te,me,Pe){if(me===q.length)return[];if(Pe===te.length)return null;if(q[me]!==te[Pe].toLowerCase())return null;{let Ne=null,He=Pe+1;for(Ne=h(q,te,me+1,Pe+1);!Ne&&(He=b(te,He))<te.length;)Ne=h(q,te,me+1,He),He++;return Ne===null?null:C({start:Pe,end:Pe+1},Ne)}}function g(q){let te=0,me=0,Pe=0,Ne=0,He=0;for(let nt=0;nt<q.length;nt++)He=q.charCodeAt(nt),F(He)&&te++,R(He)&&me++,c(He)&&Pe++,_(He)&&Ne++;const Ye=te/q.length,et=me/q.length,st=Pe/q.length,Je=Ne/q.length;return{upperPercent:Ye,lowerPercent:et,alphaPercent:st,numericPercent:Je}}function P(q){const{upperPercent:te,lowerPercent:me}=q;return me===0&&te>.6}function l(q){const{upperPercent:te,lowerPercent:me,alphaPercent:Pe,numericPercent:Ne}=q;return me>.2&&te<.8&&Pe>.6&&Ne<.2}function M(q){let te=0,me=0,Pe=0,Ne=0;for(let He=0;He<q.length;He++)Pe=q.charCodeAt(He),F(Pe)&&te++,R(Pe)&&me++,n(Pe)&&Ne++;return(te===0||me===0)&&Ne===0?q.length<=30:te<=5}function r(q,te){if(!te||(te=te.trim(),te.length===0)||!M(q)||te.length>60)return null;const me=g(te);if(!l(me)){if(!P(me))return null;te=te.toLowerCase()}let Pe=null,Ne=0;for(q=q.toLowerCase();Ne<te.length&&(Pe=h(q,te,0,Ne))===null;)Ne=b(te,Ne+1);return Pe}e.matchesCamelCase=r;function i(q,te,me=!1){if(!te||te.length===0)return null;let Pe=null,Ne=0;for(q=q.toLowerCase(),te=te.toLowerCase();Ne<te.length&&(Pe=p(q,te,0,Ne,me))===null;)Ne=d(te,Ne+1);return Pe}e.matchesWords=i;function p(q,te,me,Pe,Ne){if(me===q.length)return[];if(Pe===te.length)return null;if(m(q.charCodeAt(me),te.charCodeAt(Pe))){let He=null,Ye=Pe+1;if(He=p(q,te,me+1,Pe+1,Ne),!Ne)for(;!He&&(Ye=d(te,Ye))<te.length;)He=p(q,te,me+1,Ye,Ne),Ye++;return He===null?null:C({start:Pe,end:Pe+1},He)}else return null}function d(q,te){for(let me=te;me<q.length;me++)if(o(q.charCodeAt(me))||me>0&&o(q.charCodeAt(me-1)))return me;return q.length}const s=w(e.matchesPrefix,r,k),v=w(e.matchesPrefix,r,I),y=new a.LRUCache(1e4);function u(q,te,me=!1){if(typeof q!="string"||typeof te!="string")return null;let Pe=y.get(q);Pe||(Pe=new RegExp(t.convertSimple2RegExpPattern(q),"i"),y.set(q,Pe));const Ne=Pe.exec(te);return Ne?[{start:Ne.index,end:Ne.index+Ne[0].length}]:me?v(q,te):s(q,te)}e.matchesFuzzy=u;function D(q,te){const me=Qe(q,q.toLowerCase(),0,te,te.toLowerCase(),0,!0);return me?U(me):null}e.matchesFuzzy2=D;function A(q,te,me,Pe,Ne,He){const Ye=Math.min(13,q.length);for(;me<Ye;me++){const et=Qe(q,te,me,Pe,Ne,He,!1);if(et)return et}return[0,He]}e.anyScore=A;function U(q){if(typeof q=="undefined")return[];const te=[],me=q[1];for(let Pe=q.length-1;Pe>1;Pe--){const Ne=q[Pe]+me,He=te[te.length-1];He&&He.end===Ne?He.end=Ne+1:te.push({start:Ne,end:Ne+1})}return te}e.createMatches=U;const B=128;function E(){const q=[],te=[];for(let me=0;me<=B;me++)te[me]=0;for(let me=0;me<=B;me++)q.push(te.slice(0));return q}function N(q){const te=[];for(let me=0;me<=q;me++)te[me]=0;return te}const L=N(2*B),z=N(2*B),H=E(),j=E(),ue=E(),G=!1;function le(q,te,me,Pe,Ne){function He(et,st,Je=" "){for(;et.length<st;)et=Je+et;return et}let Ye=` |   |${Pe.split("").map(et=>He(et,3)).join("|")}
`;for(let et=0;et<=me;et++)et===0?Ye+=" |":Ye+=`${te[et-1]}|`,Ye+=q[et].slice(0,Ne+1).map(st=>He(st.toString(),3)).join("|")+`
`;return Ye}function ce(q,te,me,Pe){q=q.substr(te),me=me.substr(Pe),console.log(le(j,q,q.length,me,me.length)),console.log(le(ue,q,q.length,me,me.length)),console.log(le(H,q,q.length,me,me.length))}function Y(q,te){if(te<0||te>=q.length)return!1;const me=q.codePointAt(te);switch(me){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!t.isEmojiImprecise(me)}}function ie(q,te){if(te<0||te>=q.length)return!1;switch(q.charCodeAt(te)){case 32:case 9:return!0;default:return!1}}function we(q,te,me){return te[q]!==me[q]}function Me(q,te,me,Pe,Ne,He,Ye=!1){for(;te<me&&Ne<He;)q[te]===Pe[Ne]&&(Ye&&(L[te]=Ne),te+=1),Ne+=1;return te===me}e.isPatternInWord=Me;var Re;(function(q){q[q.Diag=1]="Diag",q[q.Left=2]="Left",q[q.LeftLeft=3]="LeftLeft"})(Re||(Re={}));var Be;(function(q){q.Default=[-100,0];function te(me){return!me||me.length===2&&me[0]===-100&&me[1]===0}q.isDefault=te})(Be=e.FuzzyScore||(e.FuzzyScore={}));function Qe(q,te,me,Pe,Ne,He,Ye){const et=q.length>B?B:q.length,st=Pe.length>B?B:Pe.length;if(me>=et||He>=st||et-me>st-He||!Me(te,me,et,Ne,He,st,!0))return;Ke(et,st,me,He,te,Ne);let Je=1,nt=1,lt=me,pt=He;const Ft=[!1];for(Je=1,lt=me;lt<et;Je++,lt++){const he=L[lt],Le=z[lt],We=lt+1<et?z[lt+1]:st;for(nt=he-He+1,pt=he;pt<We;nt++,pt++){let ot=Number.MIN_SAFE_INTEGER,Ge=!1;pt<=Le&&(ot=Xe(q,te,lt,me,Pe,Ne,pt,st,He,H[Je-1][nt-1]===0,Ft));let yt=0;ot!==Number.MAX_SAFE_INTEGER&&(Ge=!0,yt=ot+j[Je-1][nt-1]);const Ie=pt>he,Ce=Ie?j[Je][nt-1]+(H[Je][nt-1]>0?-5:0):0,ve=pt>he+1&&H[Je][nt-1]>0,oe=ve?j[Je][nt-2]+(H[Je][nt-2]>0?-5:0):0;if(ve&&(!Ie||oe>=Ce)&&(!Ge||oe>=yt))j[Je][nt]=oe,ue[Je][nt]=3,H[Je][nt]=0;else if(Ie&&(!Ge||Ce>=yt))j[Je][nt]=Ce,ue[Je][nt]=2,H[Je][nt]=0;else if(Ge)j[Je][nt]=yt,ue[Je][nt]=1,H[Je][nt]=H[Je-1][nt-1]+1;else throw new Error("not possible")}}if(G&&ce(q,me,Pe,He),!Ft[0]&&!Ye)return;Je--,nt--;const Fe=[j[Je][nt],He];let Mt=0,V=0;for(;Je>=1;){let he=nt;do{const Le=ue[Je][he];if(Le===3)he=he-2;else if(Le===2)he=he-1;else break}while(he>=1);Mt>1&&te[me+Je-1]===Ne[He+nt-1]&&!we(he+He-1,Pe,Ne)&&Mt+1>H[Je][he]&&(he=nt),he===nt?Mt++:Mt=1,V||(V=he),Je--,nt=he-1,Fe.push(nt)}st===et&&(Fe[0]+=2);const Q=V-et;return Fe[0]-=Q,Fe}e.fuzzyScore=Qe;function Ke(q,te,me,Pe,Ne,He){let Ye=q-1,et=te-1;for(;Ye>=me&&et>=Pe;)Ne[Ye]===He[et]&&(z[Ye]=et,Ye--),et--}function Xe(q,te,me,Pe,Ne,He,Ye,et,st,Je,nt){if(te[me]!==He[Ye])return Number.MIN_SAFE_INTEGER;let lt=1,pt=!1;return Ye===me-Pe?lt=q[me]===Ne[Ye]?7:5:we(Ye,Ne,He)&&(Ye===0||!we(Ye-1,Ne,He))?(lt=q[me]===Ne[Ye]?7:5,pt=!0):Y(He,Ye)&&(Ye===0||!Y(He,Ye-1))?lt=5:(Y(He,Ye-1)||ie(He,Ye-1))&&(lt=5,pt=!0),lt>1&&me===Pe&&(nt[0]=!0),pt||(pt=we(Ye,Ne,He)||Y(He,Ye-1)||ie(He,Ye-1)),me===Pe?Ye>st&&(lt-=pt?3:5):Je?lt+=pt?2:0:lt+=pt?0:1,Ye+1===et&&(lt-=pt?3:5),lt}function $(q,te,me,Pe,Ne,He,Ye){return J(q,te,me,Pe,Ne,He,!0,Ye)}e.fuzzyScoreGracefulAggressive=$;function K(q,te,me,Pe,Ne,He,Ye){return J(q,te,me,Pe,Ne,He,!1,Ye)}e.fuzzyScoreGraceful=K;function J(q,te,me,Pe,Ne,He,Ye,et){let st=Qe(q,te,me,Pe,Ne,He,et);if(st&&!Ye)return st;if(q.length>=3){const Je=Math.min(7,q.length-1);for(let nt=me+1;nt<Je;nt++){const lt=ae(q,nt);if(lt){const pt=Qe(lt,lt.toLowerCase(),me,Pe,Ne,He,et);pt&&(pt[0]-=3,(!st||pt[0]>st[0])&&(st=pt))}}}return st}function ae(q,te){if(te+1>=q.length)return;const me=q[te],Pe=q[te+1];if(me!==Pe)return q.slice(0,te)+Pe+me+q.slice(te+2)}}),define(Ee[104],ye([0,1,51,103,9]),function(re,e,a,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const T=new RegExp(`\\$\\(${a.CSSIcon.iconNameExpression}(?:${a.CSSIcon.iconModifierExpression})?\\)`,"g"),k=new RegExp(a.CSSIcon.iconNameCharacter),I=new RegExp(`(\\\\)?${T.source}`,"g");function S(c){return c.replace(I,(C,b)=>b?C:`\\${C}`)}e.escapeIcons=S;const R=new RegExp(`\\\\${T.source}`,"g");function F(c){return c.replace(R,C=>`\\${C}`)}e.markdownEscapeEscapedIcons=F;const _=new RegExp(`(\\s)?(\\\\)?${T.source}(\\s)?`,"g");function n(c){return c.indexOf(e.iconStartMarker)===-1?c:c.replace(_,(C,b,h,g)=>h?C:b||g||"")}e.stripIcons=n;function f(c){const C=c.indexOf(e.iconStartMarker);return C===-1?{text:c}:o(c,C)}e.parseLabelWithIcons=f;function o(c,C){const b=[];let h="";function g(s){if(s){h+=s;for(const v of s)b.push(M)}}let P=-1,l="",M=0,r,i,p=C;const d=c.length;for(g(c.substr(0,C));p<d;)r=c[p],i=c[p+1],r===e.iconStartMarker[0]&&i===e.iconStartMarker[1]?(P=p,g(l),l=e.iconStartMarker,p++):r===")"&&P!==-1?(M+=p-P+1,P=-1,l=""):P!==-1?k.test(r)?l+=r:(g(l),P=-1,l=""):g(r),p++;return g(l),{text:h,iconOffsets:b}}function m(c,C,b=!1){const{text:h,iconOffsets:g}=C;if(!g||g.length===0)return(0,t.matchesFuzzy)(c,h,b);const P=(0,w.ltrim)(h," "),l=h.length-P.length,M=(0,t.matchesFuzzy)(c,P,b);if(M)for(const r of M){const i=g[r.start+l]+l;r.start+=i,r.end+=i}return M}e.matchesFuzzyIconAware=m}),define(Ee[76],ye([0,1,15,104]),function(re,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var w;(function(n){n[n.Paragraph=0]="Paragraph",n[n.Break=1]="Break"})(w=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class T{constructor(f="",o=!1){if(this.value=f,typeof this.value!="string")throw(0,a.illegalArgument)("value");typeof o=="boolean"?(this.isTrusted=o,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=o.isTrusted??void 0,this.supportThemeIcons=o.supportThemeIcons??!1,this.supportHtml=o.supportHtml??!1)}appendText(f,o=0){return this.value+=R(this.supportThemeIcons?(0,t.escapeIcons)(f):f).replace(/([ \t]+)/g,(m,c)=>"&nbsp;".repeat(c.length)).replace(/\>/gm,"\\>").replace(/\n/g,o===1?`\\
`:`

`),this}appendMarkdown(f){return this.value+=f,this}appendCodeblock(f,o){return this.value+="\n```",this.value+=f,this.value+=`
`,this.value+=o,this.value+="\n```\n",this}}e.MarkdownString=T;function k(n){return I(n)?!n.value:Array.isArray(n)?n.every(k):!0}e.isEmptyMarkdownString=k;function I(n){return n instanceof T?!0:n&&typeof n=="object"?typeof n.value=="string"&&(typeof n.isTrusted=="boolean"||n.isTrusted===void 0)&&(typeof n.supportThemeIcons=="boolean"||n.supportThemeIcons===void 0):!1}e.isMarkdownString=I;function S(n,f){return n===f?!0:!n||!f?!1:n.value===f.value&&n.isTrusted===f.isTrusted&&n.supportThemeIcons===f.supportThemeIcons}e.markdownStringEqual=S;function R(n){return n.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=R;function F(n){return n&&n.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=F;function _(n){const f=[],o=n.split("|").map(c=>c.trim());n=o[0];const m=o[1];if(m){const c=/height=(\d+)/.exec(m),C=/width=(\d+)/.exec(m),b=c?c[1]:"",h=C?C[1]:"",g=isFinite(parseInt(h)),P=isFinite(parseInt(b));g&&f.push(`width="${h}"`),P&&f.push(`height="${b}"`)}return{href:n,dimensions:f}}e.parseHrefAndDimensions=_}),define(Ee[34],ye([0,1,9]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(w){w[w.Ignore=0]="Ignore",w[w.Info=1]="Info",w[w.Warning=2]="Warning",w[w.Error=3]="Error"})(t||(t={})),function(w){const T="error",k="warning",I="warn",S="info",R="ignore";function F(n){return n?a.equalsIgnoreCase(T,n)?w.Error:a.equalsIgnoreCase(k,n)||a.equalsIgnoreCase(I,n)?w.Warning:a.equalsIgnoreCase(S,n)?w.Info:w.Ignore:w.Ignore}w.fromValue=F;function _(n){switch(n){case w.Error:return T;case w.Warning:return k;case w.Info:return S;default:return R}}w.toString=_}(t||(t={})),e.default=t}),define(Ee[42],ye([0,1,17,23,9,11]),function(re,e,a,t,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function k(r){return r===47||r===92}e.isPathSeparator=k;function I(r){return r.replace(/[\\/]/g,a.posix.sep)}e.toSlashes=I;function S(r){return r.indexOf("/")===-1&&(r=I(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=S;function R(r,i=a.posix.sep){if(!r)return"";const p=r.length,d=r.charCodeAt(0);if(k(d)){if(k(r.charCodeAt(1))&&!k(r.charCodeAt(2))){let v=3;const y=v;for(;v<p&&!k(r.charCodeAt(v));v++);if(y!==v&&!k(r.charCodeAt(v+1))){for(v+=1;v<p;v++)if(k(r.charCodeAt(v)))return r.slice(0,v+1).replace(/[\\/]/g,i)}}return i}else if(C(d)&&r.charCodeAt(1)===58)return k(r.charCodeAt(2))?r.slice(0,2)+i:r.slice(0,2);let s=r.indexOf("://");if(s!==-1){for(s+=3;s<p;s++)if(k(r.charCodeAt(s)))return r.slice(0,s+1)}return""}e.getRoot=R;function F(r){if(!t.isWindows||!r||r.length<5)return!1;let i=r.charCodeAt(0);if(i!==92||(i=r.charCodeAt(1),i!==92))return!1;let p=2;const d=p;for(;p<r.length&&(i=r.charCodeAt(p),i!==92);p++);return!(d===p||(i=r.charCodeAt(p+1),isNaN(i)||i===92))}e.isUNC=F;const _=/[\\/:\*\?"<>\|]/g,n=/[\\/]/g,f=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function o(r,i=t.isWindows){const p=i?_:n;return!(!r||r.length===0||/^\s+$/.test(r)||(p.lastIndex=0,p.test(r))||i&&f.test(r)||r==="."||r===".."||i&&r[r.length-1]==="."||i&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=o;function m(r,i,p){const d=r===i;return!p||d?d:!r||!i?!1:(0,w.equalsIgnoreCase)(r,i)}e.isEqual=m;function c(r,i,p,d=a.sep){if(r===i)return!0;if(!r||!i||i.length>r.length)return!1;if(p){if(!(0,w.startsWithIgnoreCase)(r,i))return!1;if(i.length===r.length)return!0;let v=i.length;return i.charAt(i.length-1)===d&&v--,r.charAt(v)===d}return i.charAt(i.length-1)!==d&&(i+=d),r.indexOf(i)===0}e.isEqualOrParent=c;function C(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=C;function b(r,i){return t.isWindows&&r.endsWith(":")&&(r+=a.sep),(0,a.isAbsolute)(r)||(r=(0,a.join)(i,r)),r=(0,a.normalize)(r),t.isWindows?(r=(0,w.rtrim)(r,a.sep),r.endsWith(":")&&(r+=a.sep)):(r=(0,w.rtrim)(r,a.sep),r||(r=a.sep)),r}e.sanitizeFilePath=b;function h(r){const i=(0,a.normalize)(r);return t.isWindows?r.length>3?!1:g(i)&&(r.length===2||i.charCodeAt(2)===92):i===a.posix.sep}e.isRootOrDriveLetter=h;function g(r,i){return(i!==void 0?i:t.isWindows)?C(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=g;function P(r){return g(r)?r[0]:void 0}e.getDriveLetter=P;function l(r,i,p){return i.length>r.length?-1:r===i?0:(p&&(r=r.toLowerCase(),i=i.toLowerCase()),r.indexOf(i))}e.indexOfPath=l;function M(r){const i=r.split(":");let p,d,s;if(i.forEach(v=>{const y=Number(v);(0,T.isNumber)(y)?d===void 0?d=y:s===void 0&&(s=y):p=p?[p,v].join(":"):v}),!p)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:p,line:d!==void 0?d:void 0,column:s!==void 0?s:d!==void 0?1:void 0}}e.parseLineAndColumnAware=M}),define(Ee[54],ye([0,1,22,9,2]),function(re,e,a,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function T(F){return JSON.stringify(F,S)}e.stringify=T;function k(F){let _=JSON.parse(F);return _=R(_),_}e.parse=k;var I;(function(F){F[F.Uri=1]="Uri",F[F.Regexp=2]="Regexp",F[F.ScmResource=3]="ScmResource",F[F.ScmResourceGroup=4]="ScmResourceGroup",F[F.ScmProvider=5]="ScmProvider",F[F.CommentController=6]="CommentController",F[F.CommentThread=7]="CommentThread",F[F.CommentThreadReply=8]="CommentThreadReply",F[F.CommentNode=9]="CommentNode",F[F.CommentThreadNode=10]="CommentThreadNode",F[F.TimelineActionContext=11]="TimelineActionContext",F[F.NotebookCellActionContext=12]="NotebookCellActionContext",F[F.TestItemContext=13]="TestItemContext"})(I=e.MarshalledId||(e.MarshalledId={}));function S(F,_){return _ instanceof RegExp?{$mid:2,source:_.source,flags:(0,t.regExpFlags)(_)}:_}function R(F,_=0){if(!F||_>200)return F;if(typeof F=="object"){switch(F.$mid){case 1:return w.URI.revive(F);case 2:return new RegExp(F.source,F.flags)}if(F instanceof a.VSBuffer||F instanceof Uint8Array)return F;if(Array.isArray(F))for(let n=0;n<F.length;++n)F[n]=R(F[n],_+1);else for(const n in F)Object.hasOwnProperty.call(F,n)&&(F[n]=R(F[n],_+1))}return F}e.revive=R}),define(Ee[10],ye([0,1,23,2]),function(re,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var w;(function(I){I.inMemory="inmemory",I.vscode="vscode",I.internal="private",I.walkThrough="walkThrough",I.walkThroughSnippet="walkThroughSnippet",I.http="http",I.https="https",I.file="file",I.mailto="mailto",I.untitled="untitled",I.data="data",I.command="command",I.vscodeRemote="vscode-remote",I.vscodeRemoteResource="vscode-remote-resource",I.userData="vscode-userdata",I.vscodeCustomEditor="vscode-custom-editor",I.vscodeNotebook="vscode-notebook",I.vscodeNotebookCell="vscode-notebook-cell",I.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",I.vscodeNotebookCellOutput="vscode-notebook-cell-output",I.vscodeInteractive="vscode-interactive",I.vscodeInteractiveInput="vscode-interactive-input",I.vscodeSettings="vscode-settings",I.vscodeWorkspaceTrust="vscode-workspace-trust",I.vscodeTerminal="vscode-terminal",I.webviewPanel="webview-panel",I.vscodeWebview="vscode-webview",I.extension="extension",I.vscodeFileResource="vscode-file",I.tmp="tmp",I.vsls="vsls"})(w=e.Schemas||(e.Schemas={}));class T{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(S){this._preferredWebSchema=S}setDelegate(S){this._delegate=S}set(S,R,F){this._hosts[S]=R,this._ports[S]=F}setConnectionToken(S,R){this._connectionTokens[S]=R}rewrite(S){if(this._delegate)return this._delegate(S);const R=S.authority;let F=this._hosts[R];F&&F.indexOf(":")!==-1&&(F=`[${F}]`);const _=this._ports[R],n=this._connectionTokens[R];let f=`path=${encodeURIComponent(S.path)}`;return typeof n=="string"&&(f+=`&tkn=${encodeURIComponent(n)}`),t.URI.from({scheme:a.isWeb?this._preferredWebSchema:w.vscodeRemoteResource,authority:`${F}:${_}`,path:"/vscode-remote-resource",query:f})}}e.RemoteAuthorities=new T;class k{asBrowserUri(S,R){const F=this.toUri(S,R);return F.scheme===w.vscodeRemote?e.RemoteAuthorities.rewrite(F):F.scheme===w.file&&(a.isNative||typeof a.globals.importScripts=="function"&&a.globals.origin===`${w.vscodeFileResource}://${k.FALLBACK_AUTHORITY}`)?F.with({scheme:w.vscodeFileResource,authority:F.authority||k.FALLBACK_AUTHORITY,query:null,fragment:null}):F}asFileUri(S,R){const F=this.toUri(S,R);return F.scheme===w.vscodeFileResource?F.with({scheme:w.file,authority:F.authority!==k.FALLBACK_AUTHORITY?F.authority:null,query:null,fragment:null}):F}toUri(S,R){return t.URI.isUri(S)?S:t.URI.parse(R.toUrl(S))}}k.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new k}),define(Ee[24],ye([0,1,42,10,17,23,9,2]),function(re,e,a,t,w,T,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function S(f){return(0,I.uriToFsPath)(f,!0)}e.originalFSPath=S;class R{constructor(o){this._ignorePathCasing=o}compare(o,m,c=!1){return o===m?0:(0,k.compare)(this.getComparisonKey(o,c),this.getComparisonKey(m,c))}isEqual(o,m,c=!1){return o===m?!0:!o||!m?!1:this.getComparisonKey(o,c)===this.getComparisonKey(m,c)}getComparisonKey(o,m=!1){return o.with({path:this._ignorePathCasing(o)?o.path.toLowerCase():void 0,fragment:m?null:void 0}).toString()}ignorePathCasing(o){return this._ignorePathCasing(o)}isEqualOrParent(o,m,c=!1){if(o.scheme===m.scheme){if(o.scheme===t.Schemas.file)return a.isEqualOrParent(S(o),S(m),this._ignorePathCasing(o))&&o.query===m.query&&(c||o.fragment===m.fragment);if((0,e.isEqualAuthority)(o.authority,m.authority))return a.isEqualOrParent(o.path,m.path,this._ignorePathCasing(o),"/")&&o.query===m.query&&(c||o.fragment===m.fragment)}return!1}joinPath(o,...m){return I.URI.joinPath(o,...m)}basenameOrAuthority(o){return(0,e.basename)(o)||o.authority}basename(o){return w.posix.basename(o.path)}extname(o){return w.posix.extname(o.path)}dirname(o){if(o.path.length===0)return o;let m;return o.scheme===t.Schemas.file?m=I.URI.file(w.dirname(S(o))).path:(m=w.posix.dirname(o.path),o.authority&&m.length&&m.charCodeAt(0)!==47&&(console.error(`dirname("${o.toString})) resulted in a relative path`),m="/")),o.with({path:m})}normalizePath(o){if(!o.path.length)return o;let m;return o.scheme===t.Schemas.file?m=I.URI.file(w.normalize(S(o))).path:m=w.posix.normalize(o.path),o.with({path:m})}relativePath(o,m){if(o.scheme!==m.scheme||!(0,e.isEqualAuthority)(o.authority,m.authority))return;if(o.scheme===t.Schemas.file){const b=w.relative(S(o),S(m));return T.isWindows?a.toSlashes(b):b}let c=o.path||"/",C=m.path||"/";if(this._ignorePathCasing(o)){let b=0;for(const h=Math.min(c.length,C.length);b<h&&!(c.charCodeAt(b)!==C.charCodeAt(b)&&c.charAt(b).toLowerCase()!==C.charAt(b).toLowerCase());b++);c=C.substr(0,b)+c.substr(b)}return w.posix.relative(c,C)}resolvePath(o,m){if(o.scheme===t.Schemas.file){const c=I.URI.file(w.resolve(S(o),m));return o.with({authority:c.authority,path:c.path})}return m=a.toPosixPath(m),o.with({path:w.posix.resolve(o.path,m)})}isAbsolutePath(o){return!!o.path&&o.path[0]==="/"}isEqualAuthority(o,m){return o===m||o!==void 0&&m!==void 0&&(0,k.equalsIgnoreCase)(o,m)}hasTrailingPathSeparator(o,m=w.sep){if(o.scheme===t.Schemas.file){const c=S(o);return c.length>a.getRoot(c).length&&c[c.length-1]===m}else{const c=o.path;return c.length>1&&c.charCodeAt(c.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(o.fsPath)}}removeTrailingPathSeparator(o,m=w.sep){return(0,e.hasTrailingPathSeparator)(o,m)?o.with({path:o.path.substr(0,o.path.length-1)}):o}addTrailingPathSeparator(o,m=w.sep){let c=!1;if(o.scheme===t.Schemas.file){const C=S(o);c=C!==void 0&&C.length===a.getRoot(C).length&&C[C.length-1]===m}else{m="/";const C=o.path;c=C.length===1&&C.charCodeAt(C.length-1)===47}return!c&&!(0,e.hasTrailingPathSeparator)(o,m)?o.with({path:o.path+"/"}):o}}e.ExtUri=R,e.extUri=new R(()=>!1),e.extUriBiasedIgnorePathCase=new R(f=>f.scheme===t.Schemas.file?!T.isLinux:!0),e.extUriIgnorePathCase=new R(f=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function F(f,o){const m=[];for(let c=0;c<f.length;c++){const C=o(f[c]);f.some((b,h)=>h===c?!1:(0,e.isEqualOrParent)(C,o(b)))||m.push(f[c])}return m}e.distinctParents=F;var _;(function(f){f.META_DATA_LABEL="label",f.META_DATA_DESCRIPTION="description",f.META_DATA_SIZE="size",f.META_DATA_MIME="mime";function o(m){const c=new Map;m.path.substring(m.path.indexOf(";")+1,m.path.lastIndexOf(";")).split(";").forEach(h=>{const[g,P]=h.split(":");g&&P&&c.set(g,P)});const b=m.path.substring(0,m.path.indexOf(";"));return b&&c.set(f.META_DATA_MIME,b),c}f.parseMetaData=o})(_=e.DataUri||(e.DataUri={}));function n(f,o,m){if(o){let c=f.path;return c&&c[0]!==w.posix.sep&&(c=w.posix.sep+c),f.with({scheme:m,authority:o,path:c})}return f.with({scheme:m})}e.toLocalResource=n}),define(Ee[14],ye([0,1,20,15,4,6,24,23]),function(re,e,a,t,w,T,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function S(ce){return!!ce&&typeof ce.then=="function"}e.isThenable=S;function R(ce){const Y=new a.CancellationTokenSource,ie=ce(Y.token),we=new Promise((Me,Re)=>{const Be=Y.token.onCancellationRequested(()=>{Be.dispose(),Y.dispose(),Re((0,t.canceled)())});Promise.resolve(ie).then(Qe=>{Be.dispose(),Y.dispose(),Me(Qe)},Qe=>{Be.dispose(),Y.dispose(),Re(Qe)})});return new class{cancel(){Y.cancel()}then(Me,Re){return we.then(Me,Re)}catch(Me){return this.then(void 0,Me)}finally(Me){return we.finally(Me)}}}e.createCancelablePromise=R;function F(ce,Y,ie){return Promise.race([ce,new Promise(we=>Y.onCancellationRequested(()=>we(ie)))])}e.raceCancellation=F;async function _(ce){let Y=-1;const ie=ce.map((Me,Re)=>Me.then(Be=>(Y=Re,Be))),we=await Promise.race(ie);return ce.forEach((Me,Re)=>{Re!==Y&&Me.cancel()}),we}e.raceCancellablePromises=_;function n(ce,Y,ie){let we;const Me=setTimeout(()=>{we?.(void 0),ie?.()},Y);return Promise.race([ce.finally(()=>clearTimeout(Me)),new Promise(Re=>we=Re)])}e.raceTimeout=n;function f(ce){return new Promise((Y,ie)=>{const we=ce();S(we)?we.then(Y,ie):Y(we)})}e.asPromise=f;class o{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(Y){if(this.activePromise){if(this.queuedPromiseFactory=Y,!this.queuedPromise){const ie=()=>{this.queuedPromise=null;const we=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,we};this.queuedPromise=new Promise(we=>{this.activePromise.then(ie,ie).then(we)})}return new Promise((ie,we)=>{this.queuedPromise.then(ie,we)})}return this.activePromise=Y(),new Promise((ie,we)=>{this.activePromise.then(Me=>{this.activePromise=null,ie(Me)},Me=>{this.activePromise=null,we(Me)})})}}e.Throttler=o;class m{constructor(){this.current=Promise.resolve(null)}queue(Y){return this.current=this.current.then(()=>Y(),()=>Y())}}e.Sequencer=m;class c{constructor(){this.promiseMap=new Map}queue(Y,ie){const Me=(this.promiseMap.get(Y)??Promise.resolve()).catch(()=>{}).then(ie).finally(()=>{this.promiseMap.get(Y)===Me&&this.promiseMap.delete(Y)});return this.promiseMap.set(Y,Me),Me}}e.SequencerByKey=c;class C{constructor(Y){this.defaultDelay=Y,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(Y,ie=this.defaultDelay){return this.task=Y,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((we,Me)=>{this.doResolve=we,this.doReject=Me}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const we=this.task;return this.task=null,we()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},ie),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,t.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=C;class b{constructor(Y){this.delayer=new C(Y),this.throttler=new o}trigger(Y,ie){return this.delayer.trigger(()=>this.throttler.queue(Y),ie)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=b;class h{constructor(){this._isOpen=!1,this._promise=new Promise((Y,ie)=>{this._completePromise=Y})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=h;class g extends h{constructor(Y){super();this._timeout=setTimeout(()=>this.open(),Y)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=g;function P(ce,Y){return Y?new Promise((ie,we)=>{const Me=setTimeout(()=>{Re.dispose(),ie()},ce),Re=Y.onCancellationRequested(()=>{clearTimeout(Me),Re.dispose(),we((0,t.canceled)())})}):R(ie=>P(ce,ie))}e.timeout=P;function l(ce,Y=0){const ie=setTimeout(ce,Y);return(0,T.toDisposable)(()=>clearTimeout(ie))}e.disposableTimeout=l;function M(ce){const Y=[];let ie=0;const we=ce.length;function Me(){return ie<we?ce[ie++]():null}function Re(Be){Be!=null&&Y.push(Be);const Qe=Me();return Qe?Qe.then(Re):Promise.resolve(Y)}return Promise.resolve(null).then(Re)}e.sequence=M;function r(ce,Y=we=>!!we,ie=null){let we=0;const Me=ce.length,Re=()=>{if(we>=Me)return Promise.resolve(ie);const Be=ce[we++];return Promise.resolve(Be()).then(Ke=>Y(Ke)?Promise.resolve(Ke):Re())};return Re()}e.first=r;function i(ce,Y=we=>!!we,ie=null){if(ce.length===0)return Promise.resolve(ie);let we=ce.length;const Me=()=>{we=-1;for(const Re of ce)Re.cancel?.()};return new Promise((Re,Be)=>{for(const Qe of ce)Qe.then(Ke=>{--we>=0&&Y(Ke)?(Me(),Re(Ke)):we===0&&Re(ie)}).catch(Ke=>{--we>=0&&(Me(),Be(Ke))})})}e.firstParallel=i;class p{constructor(Y){this._size=0,this.maxDegreeOfParalellism=Y,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new w.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(Y){return this._size++,new Promise((ie,we)=>{this.outstandingPromises.push({factory:Y,c:ie,e:we}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const Y=this.outstandingPromises.shift();this.runningPromises++;const ie=Y.factory();ie.then(Y.c,Y.e),ie.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=p;class d extends p{constructor(){super(1)}}e.Queue=d;class s{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const Y=new z;return this.drainers.add(Y),Y.p}isDrained(){for(const[,Y]of this.queues)if(Y.size>0)return!1;return!0}queueFor(Y,ie=k.extUri){const we=ie.getComparisonKey(Y);let Me=this.queues.get(we);return Me||(Me=new d,w.Event.once(Me.onFinished)(()=>{Me?.dispose(),this.queues.delete(we),this.onDidQueueFinish()}),this.queues.set(we,Me)),Me}onDidQueueFinish(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const Y of this.drainers)Y.complete();this.drainers.clear()}dispose(){for(const[,Y]of this.queues)Y.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=s;class v{constructor(Y,ie){this._token=-1,typeof Y=="function"&&typeof ie=="number"&&this.setIfNotSet(Y,ie)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(Y,ie){this.cancel(),this._token=setTimeout(()=>{this._token=-1,Y()},ie)}setIfNotSet(Y,ie){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,Y()},ie))}}e.TimeoutTimer=v;class y{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(Y,ie){this.cancel(),this._token=setInterval(()=>{Y()},ie)}}e.IntervalTimer=y;class u{constructor(Y,ie){this.timeoutToken=-1,this.runner=Y,this.timeout=ie,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(Y=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,Y)}get delay(){return this.timeout}set delay(Y){this.timeout=Y}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=u;class D{constructor(Y,ie){ie%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ie}ms is not a multiple of 1000ms.`),this.runner=Y,this.timeout=ie,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(Y=this.timeout){Y%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Y}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(Y/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=D;class A extends u{constructor(Y,ie){super(Y,ie);this.units=[]}work(Y){this.units.push(Y),this.isScheduled()||this.schedule()}doRun(){const Y=this.units;this.units=[],this.runner&&this.runner(Y)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=A;class U extends T.Disposable{constructor(Y,ie,we,Me){super();this.maxWorkChunkSize=Y,this.maxPendingWork=ie,this.throttleDelay=we,this.handler=Me,this.pendingWork=[],this.throttler=this._register(new T.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(Y){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+Y.length>this.maxPendingWork)return!1}else if(this.pending+Y.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...Y),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new u(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=U,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=ce=>{(0,I.setTimeout0)(()=>{if(Y)return;const ie=Date.now()+3;ce(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ie-Date.now())}}))});let Y=!1;return{dispose(){Y||(Y=!0)}}}:e.runWhenIdle=(ce,Y)=>{const ie=requestIdleCallback(ce,typeof Y=="number"?{timeout:Y}:void 0);let we=!1;return{dispose(){we||(we=!0,cancelIdleCallback(ie))}}}}();class B{constructor(Y){this._didRun=!1,this._executor=()=>{try{this._value=Y()}catch(ie){this._error=ie}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=B;async function E(ce,Y,ie){let we;for(let Me=0;Me<ie;Me++)try{return await ce()}catch(Re){we=Re,await P(Y)}throw we}e.retry=E;class N{hasPending(Y){return this._pending?typeof Y=="number"?this._pending.taskId===Y:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(Y,ie,we){return this._pending={taskId:Y,cancel:()=>we?.(),promise:ie},ie.then(()=>this.donePending(Y),()=>this.donePending(Y)),ie}donePending(Y){this._pending&&Y===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const Y=this._next;this._next=void 0,Y.run().then(Y.promiseResolve,Y.promiseReject)}}setNext(Y){if(this._next)this._next.run=Y;else{let ie,we;const Me=new Promise((Re,Be)=>{ie=Re,we=Be});this._next={run:Y,promise:Me,promiseResolve:ie,promiseReject:we}}return this._next.promise}}e.TaskSequentializer=N;class L{constructor(Y,ie=()=>Date.now()){this.interval=Y,this.nowFn=ie,this.lastIncrementTime=0,this.value=0}increment(){const Y=this.nowFn();return Y-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=Y,this.value=0),this.value++,this.value}}e.IntervalCounter=L;class z{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((Y,ie)=>{this.completeCallback=Y,this.errorCallback=ie})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(Y){return new Promise(ie=>{this.completeCallback(Y),this.resolved=!0,ie()})}error(Y){return new Promise(ie=>{this.errorCallback(Y),this.rejected=!0,ie()})}cancel(){new Promise(Y=>{this.errorCallback((0,t.canceled)()),this.rejected=!0,Y()})}}e.DeferredPromise=z;var H;(function(ce){async function Y(we){let Me;const Re=await Promise.all(we.map(Be=>Be.then(Qe=>Qe,Qe=>{Me||(Me=Qe)})));if(typeof Me!="undefined")throw Me;return Re}ce.settled=Y;function ie(we){return new Promise(async(Me,Re)=>{try{await we(Me,Re)}catch(Be){Re(Be)}})}ce.withAsyncBody=ie})(H=e.Promises||(e.Promises={}));var j;(function(ce){ce[ce.Initial=0]="Initial",ce[ce.DoneOK=1]="DoneOK",ce[ce.DoneError=2]="DoneError"})(j||(j={}));class ue{constructor(Y){this._state=0,this._results=[],this._error=null,this._onStateChanged=new w.Emitter,queueMicrotask(async()=>{const ie={emitOne:we=>this.emitOne(we),emitMany:we=>this.emitMany(we),reject:we=>this.reject(we)};try{await Promise.resolve(Y(ie)),this.resolve()}catch(we){this.reject(we)}finally{ie.emitOne=void 0,ie.emitMany=void 0,ie.reject=void 0}})}static fromArray(Y){return new ue(ie=>{ie.emitMany(Y)})}static fromPromise(Y){return new ue(async ie=>{ie.emitMany(await Y)})}static fromPromises(Y){return new ue(async ie=>{await Promise.all(Y.map(async we=>ie.emitOne(await we)))})}static merge(Y){return new ue(async ie=>{await Promise.all(Y.map(async we=>{for await(const Me of we)ie.emitOne(Me)}))})}[Symbol.asyncIterator](){let Y=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(Y<this._results.length)return{done:!1,value:this._results[Y++]};if(this._state===1)return{done:!0,value:void 0};await w.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(Y,ie){return new ue(async we=>{for await(const Me of Y)we.emitOne(ie(Me))})}map(Y){return ue.map(this,Y)}static filter(Y,ie){return new ue(async we=>{for await(const Me of Y)ie(Me)&&we.emitOne(Me)})}filter(Y){return ue.filter(this,Y)}static coalesce(Y){return ue.filter(Y,ie=>!!ie)}coalesce(){return ue.coalesce(this)}static async toPromise(Y){const ie=[];for await(const we of Y)ie.push(we);return ie}toPromise(){return ue.toPromise(this)}emitOne(Y){this._state===0&&(this._results.push(Y),this._onStateChanged.fire())}emitMany(Y){this._state===0&&(this._results=this._results.concat(Y),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(Y){this._state===0&&(this._state=2,this._error=Y,this._onStateChanged.fire())}}e.AsyncIterableObject=ue,ue.EMPTY=ue.fromArray([]);class G extends ue{constructor(Y,ie){super(ie);this._source=Y}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=G;function le(ce){const Y=new a.CancellationTokenSource,ie=ce(Y.token);return new G(Y,async we=>{const Me=Y.token.onCancellationRequested(()=>{Me.dispose(),Y.dispose(),we.reject((0,t.canceled)())});try{for await(const Re of ie){if(Y.token.isCancellationRequested)return;we.emitOne(Re)}Me.dispose(),Y.dispose()}catch(Re){Me.dispose(),Y.dispose(),we.reject(Re)}})}e.createCancelableAsyncIterable=le}),define(Ee[105],ye([0,1,14,17]),function(re,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const w=new a.IdleValue(()=>{const y=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:y,collatorIsNumeric:y.resolvedOptions().numeric}}),T=new a.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),k=new a.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function I(y,u,D=!1){const A=y||"",U=u||"",B=w.value.collator.compare(A,U);return w.value.collatorIsNumeric&&B===0&&A!==U?A<U?-1:1:B}e.compareFileNames=I;function S(y,u){const D=T.value.collator;return y=y||"",u=u||"",P(D,y,u)}e.compareFileNamesDefault=S;function R(y,u){const D=T.value.collator;return y=y||"",u=u||"",i(y,u)||P(D,y,u)}e.compareFileNamesUpper=R;function F(y,u){const D=T.value.collator;return y=y||"",u=u||"",r(y,u)||P(D,y,u)}e.compareFileNamesLower=F;function _(y,u){return y=y||"",u=u||"",y===u?0:y<u?-1:1}e.compareFileNamesUnicode=_;function n(y,u,D=!1){D||(y=y&&y.toLowerCase(),u=u&&u.toLowerCase());const[A,U]=h(y),[B,E]=h(u);return A!==B?A<B?-1:1:U===E?0:U<E?-1:1}e.noIntlCompareFileNames=n;function f(y,u){const[D,A]=h(y),[U,B]=h(u);let E=w.value.collator.compare(A,B);if(E===0){if(w.value.collatorIsNumeric&&A!==B)return A<B?-1:1;if(E=w.value.collator.compare(D,U),w.value.collatorIsNumeric&&E===0&&D!==U)return D<U?-1:1}return E}e.compareFileExtensions=f;function o(y,u){y=y||"",u=u||"";const D=g(y),A=g(u),U=T.value.collator,B=k.value.collator;return P(B,D,A)||P(U,y,u)}e.compareFileExtensionsDefault=o;function m(y,u){y=y||"",u=u||"";const D=g(y),A=g(u),U=T.value.collator,B=k.value.collator;return P(B,D,A)||i(y,u)||P(U,y,u)}e.compareFileExtensionsUpper=m;function c(y,u){y=y||"",u=u||"";const D=g(y),A=g(u),U=T.value.collator,B=k.value.collator;return P(B,D,A)||r(y,u)||P(U,y,u)}e.compareFileExtensionsLower=c;function C(y,u){y=y||"",u=u||"";const D=g(y).toLowerCase(),A=g(u).toLowerCase();return D!==A?D<A?-1:1:y!==u?y<u?-1:1:0}e.compareFileExtensionsUnicode=C;const b=/^(.*?)(\.([^.]*))?$/;function h(y,u=!1){const D=y?b.exec(y):[];let A=[D&&D[1]||"",D&&D[3]||""];return u&&(!A[0]&&A[1]||A[0]&&A[0].charAt(0)===".")&&(A=[A[0]+"."+A[1],""]),A}function g(y){const u=y?b.exec(y):[];return u&&u[1]&&u[1].charAt(0)!=="."&&u[3]||""}function P(y,u,D){let A=y.compare(u,D);return A!==0?A:u.length!==D.length?u.length<D.length?-1:1:0}function l(y){const u=y.charAt(0);return u.toLocaleUpperCase()!==u}function M(y){const u=y.charAt(0);return u.toLocaleLowerCase()!==u}function r(y,u){return l(y)&&M(u)?-1:M(y)&&l(u)?1:0}function i(y,u){return M(y)&&l(u)?-1:l(y)&&M(u)?1:0}function p(y,u,D=!1){return D||(y=y&&y.toLowerCase(),u=u&&u.toLowerCase()),y===u?0:y<u?-1:1}function d(y,u,D=!1){const A=y.split(t.sep),U=u.split(t.sep),B=A.length-1,E=U.length-1;let N,L;for(let z=0;;z++){if(N=B===z,L=E===z,N&&L)return I(A[z],U[z],D);if(N)return-1;if(L)return 1;const H=p(A[z],U[z],D);if(H!==0)return H}}e.comparePaths=d;function s(y,u,D){const A=y.toLowerCase(),U=u.toLowerCase(),B=v(y,u,D);if(B)return B;const E=A.endsWith(D),N=U.endsWith(D);if(E!==N)return E?-1:1;const L=I(A,U);return L!==0?L:A.localeCompare(U)}e.compareAnything=s;function v(y,u,D){const A=y.toLowerCase(),U=u.toLowerCase(),B=A.startsWith(D),E=U.startsWith(D);if(B!==E)return B?-1:1;if(B&&E){if(A.length<U.length)return-1;if(A.length>U.length)return 1}return 0}e.compareByPrefix=v}),define(Ee[29],ye([0,1,14,42,21,17,9]),function(re,e,a,t,w,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function I(){return Object.create(null)}e.getEmptyExpression=I;const S="**",R="/",F="[/\\\\]",_="[^/\\\\]",n=/\//g;function f(G){switch(G){case 0:return"";case 1:return`${_}*?`;default:return`(?:${F}|${_}+${F}|${F}${_}+)*?`}}function o(G,le){if(!G)return[];const ce=[];let Y=!1,ie=!1,we="";for(const Me of G){switch(Me){case le:if(!Y&&!ie){ce.push(we),we="";continue}break;case"{":Y=!0;break;case"}":Y=!1;break;case"[":ie=!0;break;case"]":ie=!1;break}we+=Me}return we&&ce.push(we),ce}e.splitGlobAware=o;function m(G){if(!G)return"";let le="";const ce=o(G,R);if(ce.every(Y=>Y===S))le=".*";else{let Y=!1;ce.forEach((ie,we)=>{if(ie===S){Y||(le+=f(2),Y=!0);return}let Me=!1,Re="",Be=!1,Qe="";for(const Ke of ie){if(Ke!=="}"&&Me){Re+=Ke;continue}if(Be&&(Ke!=="]"||!Qe)){let Xe;Ke==="-"?Xe=Ke:(Ke==="^"||Ke==="!")&&!Qe?Xe="^":Ke===R?Xe="":Xe=k.escapeRegExpCharacters(Ke),Qe+=Xe;continue}switch(Ke){case"{":Me=!0;continue;case"[":Be=!0;continue;case"}":le+=`(?:${o(Re,",").map(K=>m(K)).join("|")})`,Me=!1,Re="";break;case"]":le+="["+Qe+"]",Be=!1,Qe="";break;case"?":le+=_;continue;case"*":le+=f(1);continue;default:le+=k.escapeRegExpCharacters(Ke)}}we<ce.length-1&&(ce[we+1]!==S||we+2<ce.length)&&(le+=F),Y=!1})}return le}const c=/^\*\*\/\*\.[\w\.-]+$/,C=/^\*\*\/([\w\.-]+)\/?$/,b=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,h=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,g=/^\*\*((\/[\w\.-]+)+)\/?$/,P=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,l=new w.LRUCache(1e4),M=function(){return!1},r=function(){return null};function i(G,le){if(!G)return r;let ce;typeof G!="string"?ce=G.pattern:ce=G,ce=ce.trim();const Y=`${ce}_${!!le.trimForExclusions}`;let ie=l.get(Y);if(ie)return p(ie,G);let we;if(c.test(ce)){const Me=ce.substr(4);ie=function(Re,Be){return typeof Re=="string"&&Re.endsWith(Me)?ce:null}}else(we=C.exec(d(ce,le)))?ie=s(we[1],ce):(le.trimForExclusions?h:b).test(ce)?ie=v(ce,le):(we=g.exec(d(ce,le)))?ie=y(we[1].substr(1),ce,!0):(we=P.exec(d(ce,le)))?ie=y(we[1],ce,!1):ie=u(ce);return l.set(Y,ie),p(ie,G)}function p(G,le){return typeof le=="string"?G:function(ce,Y){return t.isEqualOrParent(ce,le.base)?G(T.relative(le.base,ce),Y):null}}function d(G,le){return le.trimForExclusions&&G.endsWith("/**")?G.substr(0,G.length-2):G}function s(G,le){const ce=`/${G}`,Y=`\\${G}`,ie=function(Me,Re){return typeof Me!="string"?null:Re?Re===G?le:null:Me===G||Me.endsWith(ce)||Me.endsWith(Y)?le:null},we=[G];return ie.basenames=we,ie.patterns=[le],ie.allBasenames=we,ie}function v(G,le){const ce=ue(G.slice(1,-1).split(",").map(Re=>i(Re,le)).filter(Re=>Re!==r),G),Y=ce.length;if(!Y)return r;if(Y===1)return ce[0];const ie=function(Re,Be){for(let Qe=0,Ke=ce.length;Qe<Ke;Qe++)if(ce[Qe](Re,Be))return G;return null},we=ce.find(Re=>!!Re.allBasenames);we&&(ie.allBasenames=we.allBasenames);const Me=ce.reduce((Re,Be)=>Be.allPaths?Re.concat(Be.allPaths):Re,[]);return Me.length&&(ie.allPaths=Me),ie}function y(G,le,ce){const Y=T.sep===T.posix.sep,ie=Y?G:G.replace(n,T.sep),we=T.sep+ie,Me=T.posix.sep+G,Re=ce?function(Be,Qe){return typeof Be=="string"&&(Be===ie||Be.endsWith(we)||!Y&&(Be===G||Be.endsWith(Me)))?le:null}:function(Be,Qe){return typeof Be=="string"&&(Be===ie||!Y&&Be===G)?le:null};return Re.allPaths=[(ce?"*/":"./")+G],Re}function u(G){try{const le=new RegExp(`^${m(G)}$`);return function(ce){return le.lastIndex=0,typeof ce=="string"&&le.test(ce)?G:null}}catch{return r}}function D(G,le,ce){return!G||typeof le!="string"?!1:A(G)(le,void 0,ce)}e.match=D;function A(G,le={}){if(!G)return M;if(typeof G=="string"||N(G)){const ce=i(G,le);if(ce===r)return M;const Y=function(ie,we){return!!ce(ie,we)};return ce.allBasenames&&(Y.allBasenames=ce.allBasenames),ce.allPaths&&(Y.allPaths=ce.allPaths),Y}return H(G,le)}e.parse=A;function U(G){if(!G)return;let le;return ce=>(le||(le=(G()||Promise.resolve([])).then(Y=>Y?E(Y):{})),le.then(Y=>!!Y[ce]))}e.hasSiblingPromiseFn=U;function B(G){if(!G)return;let le;return ce=>{if(!le){const Y=G();le=Y?E(Y):{}}return!!le[ce]}}e.hasSiblingFn=B;function E(G){const le={};for(const ce of G)le[ce]=!0;return le}function N(G){const le=G;return le&&typeof le.base=="string"&&typeof le.pattern=="string"}e.isRelativePattern=N;function L(G){return G.allBasenames||[]}e.getBasenameTerms=L;function z(G){return G.allPaths||[]}e.getPathTerms=z;function H(G,le){const ce=ue(Object.getOwnPropertyNames(G).map(Re=>j(Re,G[Re],le)).filter(Re=>Re!==r)),Y=ce.length;if(!Y)return r;if(!ce.some(Re=>!!Re.requiresSiblings)){if(Y===1)return ce[0];const Re=function(Ke,Xe){for(let $=0,K=ce.length;$<K;$++){const J=ce[$](Ke,Xe);if(J)return J}return null},Be=ce.find(Ke=>!!Ke.allBasenames);Be&&(Re.allBasenames=Be.allBasenames);const Qe=ce.reduce((Ke,Xe)=>Xe.allPaths?Ke.concat(Xe.allPaths):Ke,[]);return Qe.length&&(Re.allPaths=Qe),Re}const ie=function(Re,Be,Qe){let Ke;for(let Xe=0,$=ce.length;Xe<$;Xe++){const K=ce[Xe];K.requiresSiblings&&Qe&&(Be||(Be=T.basename(Re)),Ke||(Ke=Be.substr(0,Be.length-T.extname(Re).length)));const J=K(Re,Be,Ke,Qe);if(J)return J}return null},we=ce.find(Re=>!!Re.allBasenames);we&&(ie.allBasenames=we.allBasenames);const Me=ce.reduce((Re,Be)=>Be.allPaths?Re.concat(Be.allPaths):Re,[]);return Me.length&&(ie.allPaths=Me),ie}function j(G,le,ce){if(le===!1)return r;const Y=i(G,ce);if(Y===r)return r;if(typeof le=="boolean")return Y;if(le){const ie=le.when;if(typeof ie=="string"){const we=(Me,Re,Be,Qe)=>{if(!Qe||!Y(Me,Re))return null;const Ke=ie.replace("$(basename)",Be),Xe=Qe(Ke);return(0,a.isThenable)(Xe)?Xe.then($=>$?G:null):Xe?G:null};return we.requiresSiblings=!0,we}}return Y}function ue(G,le){const ce=G.filter(Re=>!!Re.basenames);if(ce.length<2)return G;const Y=ce.reduce((Re,Be)=>{const Qe=Be.basenames;return Qe?Re.concat(Qe):Re},[]);let ie;if(le){ie=[];for(let Re=0,Be=Y.length;Re<Be;Re++)ie.push(le)}else ie=ce.reduce((Re,Be)=>{const Qe=Be.patterns;return Qe?Re.concat(Qe):Re},[]);const we=function(Re,Be){if(typeof Re!="string")return null;if(!Be){let Ke;for(Ke=Re.length;Ke>0;Ke--){const Xe=Re.charCodeAt(Ke-1);if(Xe===47||Xe===92)break}Be=Re.substr(Ke)}const Qe=Y.indexOf(Be);return Qe!==-1?ie[Qe]:null};we.basenames=Y,we.patterns=ie,we.allBasenames=Y;const Me=G.filter(Re=>!Re.basenames);return Me.push(we),Me}}),define(Ee[77],ye([0,1,42,10,17,23,24,9,2]),function(re,e,a,t,w,T,k,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function R(i,p,d){if(typeof i=="string"&&(i=S.URI.file(i)),d){const v=d.getWorkspaceFolder(i);if(v){const y=d.getWorkspace().folders.length>1;let u;if((0,k.isEqual)(v.uri,i)?u="":u=(0,k.relativePath)(v.uri,i),y){const D=v.name?v.name:(0,k.basename)(v.uri);u=u?D+" \u2022 "+u:D}return u}}if(i.scheme!==t.Schemas.file&&i.scheme!==t.Schemas.untitled)return i.with({query:null,fragment:null}).toString(!0);if((0,a.hasDriveLetter)(i.fsPath))return(0,w.normalize)(_(i.fsPath));let s=(0,w.normalize)(i.fsPath);return!T.isWindows&&p?.userHome&&(s=f(s,p.userHome.fsPath)),s}e.getPathLabel=R;function F(i){if(!i)return;typeof i=="string"&&(i=S.URI.file(i));const p=(0,k.basename)(i)||(i.scheme===t.Schemas.file?i.fsPath:i.path);return T.isWindows&&(0,a.isRootOrDriveLetter)(p)?_(p):p}e.getBaseLabel=F;function _(i,p){return(0,a.hasDriveLetter)(i,p)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=_;let n=Object.create(null);function f(i,p){if(T.isWindows||!i||!p)return i;let d=n.original===p?n.normalized:void 0;return d||(d=`${(0,I.rtrim)(p,w.posix.sep)}${w.posix.sep}`,n={original:p,normalized:d}),(T.isLinux?i.startsWith(d):(0,I.startsWithIgnoreCase)(i,d))&&(i=`~/${i.substr(d.length)}`),i}e.tildify=f;function o(i,p){return i.replace(/^~($|\/|\\)/,`${p}$1`)}e.untildify=o;const m="\u2026",c="\\\\",C="~";function b(i,p=w.sep){const d=new Array(i.length);let s=!1;for(let v=0;v<i.length;v++){let y=i[v];if(y===""){d[v]=`.${p}`;continue}if(!y){d[v]=y;continue}s=!0;let u="";y.indexOf(c)===0?(u=y.substr(0,y.indexOf(c)+c.length),y=y.substr(y.indexOf(c)+c.length)):y.indexOf(p)===0?(u=y.substr(0,y.indexOf(p)+p.length),y=y.substr(y.indexOf(p)+p.length)):y.indexOf(C)===0&&(u=y.substr(0,y.indexOf(C)+C.length),y=y.substr(y.indexOf(C)+C.length));const D=y.split(p);for(let A=1;s&&A<=D.length;A++)for(let U=D.length-A;s&&U>=0;U--){s=!1;let B=D.slice(U,U+A).join(p);for(let E=0;!s&&E<i.length;E++)if(E!==v&&i[E]&&i[E].indexOf(B)>-1){const N=U+A===D.length,L=U>0&&i[E].indexOf(p)>-1?p+B:B,z=i[E].endsWith(L);s=!N||z}if(!s){let E="";(D[0].endsWith(":")||u!=="")&&(U===1&&(U=0,A++,B=D[0]+p+B),U>0&&(E=D[0]+p),E=u+E),U>0&&(E=E+m+p),E=E+B,U+A<D.length&&(E=E+p+m),d[v]=E}}s&&(d[v]=y)}return d}e.shorten=b;var h;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(h||(h={}));function g(i,p=Object.create(null)){const d=[];let s=!1,v="";for(const y of i)if(y==="$"||s&&y==="{")v&&d.push({value:v,type:h.TEXT}),v="",s=!0;else if(y==="}"&&s){const u=p[v];if(typeof u=="string")u.length&&d.push({value:u,type:h.VARIABLE});else if(u){const D=d[d.length-1];(!D||D.type!==h.SEPARATOR)&&d.push({value:u.label,type:h.SEPARATOR})}v="",s=!1}else v+=y;return v&&!s&&d.push({value:v,type:h.TEXT}),d.filter((y,u)=>{if(y.type===h.SEPARATOR){const D=d[u-1],A=d[u+1];return[D,A].every(U=>U&&(U.type===h.VARIABLE||U.type===h.TEXT)&&U.value.length>0)}return!0}).map(y=>y.value).join("")}e.template=g;function P(i,p){return T.isMacintosh||p?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,T.isMacintosh?"&":"&&"):i.replace(/&&|&/g,d=>d==="&"?"&&":"&")}e.mnemonicMenuLabel=P;function l(i,p){return T.isMacintosh||p?i.replace(/\(&&\w\)|&&/g,""):T.isWindows?i.replace(/&&|&/g,d=>d==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=l;function M(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=M;function r(i){const p=i.indexOf("/")!==-1?w.posix:w.win32,d=p.basename(i),s=p.dirname(i);return d.length?{name:d,parentPath:s}:{name:s,parentPath:""}}e.splitName=r}),define(Ee[78],ye([0,1,29,10,17,24,9]),function(re,e,a,t,w,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var I;(function(i){i.text="text/plain",i.binary="application/octet-stream",i.unknown="application/unknown",i.markdown="text/markdown",i.latex="text/latex"})(I=e.Mimes||(e.Mimes={}));let S=[],R=[],F=[];function _(i,p=!1){const d=n(i);S.push(d),d.userConfigured?F.push(d):R.push(d),p&&!d.userConfigured&&S.forEach(s=>{s.mime===d.mime||s.userConfigured||(d.extension&&s.extension===d.extension&&console.warn(`Overwriting extension <<${d.extension}>> to now point to mime <<${d.mime}>>`),d.filename&&s.filename===d.filename&&console.warn(`Overwriting filename <<${d.filename}>> to now point to mime <<${d.mime}>>`),d.filepattern&&s.filepattern===d.filepattern&&console.warn(`Overwriting filepattern <<${d.filepattern}>> to now point to mime <<${d.mime}>>`),d.firstline&&s.firstline===d.firstline&&console.warn(`Overwriting firstline <<${d.firstline}>> to now point to mime <<${d.mime}>>`))})}e.registerTextMime=_;function n(i){return{id:i.id,mime:i.mime,filename:i.filename,extension:i.extension,filepattern:i.filepattern,firstline:i.firstline,userConfigured:i.userConfigured,filenameLowercase:i.filename?i.filename.toLowerCase():void 0,extensionLowercase:i.extension?i.extension.toLowerCase():void 0,filepatternLowercase:i.filepattern?(0,a.parse)(i.filepattern.toLowerCase()):void 0,filepatternOnPath:i.filepattern?i.filepattern.indexOf(w.posix.sep)>=0:!1}}function f(i){i?(S=S.filter(p=>!p.userConfigured),F=[]):(S=[],R=[],F=[])}e.clearTextMimes=f;function o(i,p){let d;if(i)switch(i.scheme){case t.Schemas.file:d=i.fsPath;break;case t.Schemas.data:d=T.DataUri.parseMetaData(i).get(T.DataUri.META_DATA_LABEL);break;default:d=i.path}if(!d)return[I.unknown];d=d.toLowerCase();const s=(0,w.basename)(d),v=m(d,s,F);if(v)return[v,I.text];const y=m(d,s,R);if(y)return[y,I.text];if(p){const u=c(p);if(u)return[u,I.text]}return[I.unknown]}e.guessMimeTypes=o;function m(i,p,d){let s=null,v=null,y=null;for(let u=d.length-1;u>=0;u--){const D=d[u];if(p===D.filenameLowercase){s=D;break}if(D.filepattern&&(!v||D.filepattern.length>v.filepattern.length)){const A=D.filepatternOnPath?i:p;D.filepatternLowercase?.(A)&&(v=D)}D.extension&&(!y||D.extension.length>y.extension.length)&&p.endsWith(D.extensionLowercase)&&(y=D)}return s?s.mime:v?v.mime:y?y.mime:null}function c(i){if((0,k.startsWithUTF8BOM)(i)&&(i=i.substr(1)),i.length>0)for(let p=S.length-1;p>=0;p--){const d=S[p];if(!d.firstline)continue;const s=i.match(d.firstline);if(s&&s.length>0)return d.mime}return null}function C(i){return i?typeof i=="string"?i===I.binary||i===I.text||i===I.unknown:i.length===1&&C(i[0]):!0}e.isUnspecific=C;const b={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},h={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function g(i){const p=(0,w.extname)(i),d=b[p.toLowerCase()];return d!==void 0?d:P(i)}e.getMediaOrTextMime=g;function P(i){const p=(0,w.extname)(i);return h[p.toLowerCase()]}e.getMediaMime=P;function l(i){for(const p in h)if(h[p]===i)return p}e.getExtensionForMimeType=l;const M=/^(.+)\/(.+?)(;.+)?$/;function r(i,p){const d=M.exec(i);return d?`${d[1].toLowerCase()}/${d[2].toLowerCase()}${d[3]??""}`:p?void 0:i}e.normalizeMimeType=r}),define(Ee[106],ye([0,1,2]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(F){return F.toJSON()}class w{constructor(_){this._uriTransformer=_}transformIncoming(_){const n=this._uriTransformer.transformIncoming(_);return n===_?_:t(a.URI.from(n))}transformOutgoing(_){const n=this._uriTransformer.transformOutgoing(_);return n===_?_:t(a.URI.from(n))}transformOutgoingURI(_){const n=this._uriTransformer.transformOutgoing(_);return n===_?_:a.URI.from(n)}transformOutgoingScheme(_){return this._uriTransformer.transformOutgoingScheme(_)}}e.URITransformer=w,e.DefaultURITransformer=new class{transformIncoming(F){return F}transformOutgoing(F){return F}transformOutgoingURI(F){return F}transformOutgoingScheme(F){return F}};function T(F,_,n){if(!F||n>200)return null;if(typeof F=="object"){if(F instanceof a.URI)return _.transformOutgoing(F);for(let f in F)if(Object.hasOwnProperty.call(F,f)){const o=T(F[f],_,n+1);o!==null&&(F[f]=o)}}return null}function k(F,_){const n=T(F,_,0);return n===null?F:n}e.transformOutgoingURIs=k;function I(F,_,n,f){if(!F||f>200)return null;if(typeof F=="object"){if(F.$mid===1)return n?a.URI.revive(_.transformIncoming(F)):_.transformIncoming(F);for(let o in F)if(Object.hasOwnProperty.call(F,o)){const m=I(F[o],_,n,f+1);m!==null&&(F[o]=m)}}return null}function S(F,_){const n=I(F,_,!1,0);return n===null?F:n}e.transformIncomingURIs=S;function R(F,_){const n=I(F,_,!0,0);return n===null?F:n}e.transformAndReviveIncomingURIs=R}),define(Ee[35],ye([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const a=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(S){return a.test(S)}e.isUUID=t;const w=new Uint8Array(16),T=[];for(let S=0;S<256;S++)T.push(S.toString(16).padStart(2,"0"));let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(S){for(let R=0;R<S.length;R++)S[R]=Math.floor(Math.random()*256);return S};function I(){k(w),w[6]=w[6]&15|64,w[8]=w[8]&63|128;let S=0,R="";return R+=T[w[S++]],R+=T[w[S++]],R+=T[w[S++]],R+=T[w[S++]],R+="-",R+=T[w[S++]],R+=T[w[S++]],R+="-",R+=T[w[S++]],R+=T[w[S++]],R+="-",R+=T[w[S++]],R+=T[w[S++]],R+="-",R+=T[w[S++]],R+=T[w[S++]],R+=T[w[S++]],R+=T[w[S++]],R+=T[w[S++]],R+=T[w[S++]],R}e.generateUuid=I}),define(Ee[107],ye([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var a;(function(k){k[k.None=0]="None",k[k.Indent=1]="Indent",k[k.IndentOutdent=2]="IndentOutdent",k[k.Outdent=3]="Outdent"})(a=e.IndentAction||(e.IndentAction={}));class t{constructor(I){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=I.open,this.close=I.close,this._standardTokenMask=0,Array.isArray(I.notIn))for(let S=0,R=I.notIn.length;S<R;S++)switch(I.notIn[S]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(I){return(this._standardTokenMask&I)==0}shouldAutoClose(I,S){if(I.getTokenCount()===0)return!0;const R=I.findTokenIndexAtOffset(S-2),F=I.getStandardTokenType(R);return this.isOK(F)}_findNeutralCharacterInRange(I,S){for(let R=I;R<=S;R++){const F=String.fromCharCode(R);if(!this.open.includes(F)&&!this.close.includes(F))return F}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=t;class w{constructor(I){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const S of I)T(this.autoClosingPairsOpenByStart,S.open.charAt(0),S),T(this.autoClosingPairsOpenByEnd,S.open.charAt(S.open.length-1),S),T(this.autoClosingPairsCloseByStart,S.close.charAt(0),S),T(this.autoClosingPairsCloseByEnd,S.close.charAt(S.close.length-1),S),S.close.length===1&&S.open.length===1&&T(this.autoClosingPairsCloseSingleChar,S.close,S)}}e.AutoClosingPairs=w;function T(k,I,S){k.has(I)?k.get(I).push(S):k.set(I,[S])}}),define(Ee[55],ye([0,1,29,17]),function(re,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function w(T,k,I,S){if(Array.isArray(T)){let R=0;for(const F of T){const _=w(F,k,I,S);if(_===10)return _;_>R&&(R=_)}return R}else{if(typeof T=="string")return S?T==="*"?5:T===I?10:0:0;if(T){const{language:R,pattern:F,scheme:_,hasAccessToAllModels:n}=T;if(!S&&!n)return 0;let f=0;if(_)if(_===k.scheme)f=10;else if(_==="*")f=5;else return 0;if(R)if(R===I)f=10;else if(R==="*")f=Math.max(f,5);else return 0;if(F){let o;if(typeof F=="string"?o=F:o={...F,base:(0,t.normalize)(F.base)},o===k.fsPath||(0,a.match)(o,k.fsPath))f=10;else return 0}return f}else return 0}}e.score=w}),define(Ee[108],ye([0,1,4,6]),function(re,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class w{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new a.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(k){this._onDidChange.fire({changedLanguages:k,changedColorMap:!1})}register(k,I){return this._map.set(k,I),this.fire([k]),(0,t.toDisposable)(()=>{this._map.get(k)===I&&(this._map.delete(k),this.fire([k]))})}registerPromise(k,I){let S=null,R=!1;return this._promises.set(k,I.then(F=>{this._promises.delete(k),!(R||!F)&&(S=this.register(k,F))})),(0,t.toDisposable)(()=>{R=!0,S&&S.dispose()})}getPromise(k){const I=this.get(k);if(I)return Promise.resolve(I);const S=this._promises.get(k);return S?S.then(R=>this.get(k)):null}get(k){return this._map.get(k)||null}setColorMap(k){this._colorMap=k,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=w}),define(Ee[79],ye([0,1,22,23]),function(re,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var w;(function(_){_[_.Full=1]="Full",_[_.Delta=2]="Delta"})(w||(w={}));function T(_){for(let n=0,f=_.length;n<f;n+=4){const o=_[n+0],m=_[n+1],c=_[n+2],C=_[n+3];_[n+0]=C,_[n+1]=c,_[n+2]=m,_[n+3]=o}}function k(_){const n=new Uint8Array(_.buffer,_.byteOffset,_.length*4);return t.isLittleEndian()||T(n),a.VSBuffer.wrap(n)}function I(_){const n=_.buffer;if(t.isLittleEndian()||T(n),n.byteOffset%4==0)return new Uint32Array(n.buffer,n.byteOffset,n.length/4);{const f=new Uint8Array(n.byteLength);return f.set(n),new Uint32Array(f.buffer,f.byteOffset,f.length/4)}}function S(_){const n=new Uint32Array(R(_));let f=0;if(n[f++]=_.id,_.type==="full")n[f++]=1,n[f++]=_.data.length,n.set(_.data,f),f+=_.data.length;else{n[f++]=2,n[f++]=_.deltas.length;for(const o of _.deltas)n[f++]=o.start,n[f++]=o.deleteCount,o.data?(n[f++]=o.data.length,n.set(o.data,f),f+=o.data.length):n[f++]=0}return k(n)}e.encodeSemanticTokensDto=S;function R(_){let n=0;if(n+=1+1,_.type==="full")n+=1+_.data.length;else{n+=1,n+=(1+1+1)*_.deltas.length;for(const f of _.deltas)f.data&&(n+=f.data.length)}return n}function F(_){const n=I(_);let f=0;const o=n[f++];if(n[f++]===1){const b=n[f++],h=n.subarray(f,f+b);return f+=b,{id:o,type:"full",data:h}}const c=n[f++];let C=[];for(let b=0;b<c;b++){const h=n[f++],g=n[f++],P=n[f++];let l;P>0&&(l=n.subarray(f,f+P),f+=P),C[b]={start:h,deleteCount:g,data:l}}return{id:o,type:"delta",deltas:C}}e.decodeSemanticTokensDto=F}),define(Ee[109],ye([18,19]),function(re,e){return re.create("vs/base/common/date",e)}),define(Ee[110],ye([0,1,109]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,w=t*60,T=w*24,k=T*7,I=T*30,S=T*365;function R(_,n){typeof _!="number"&&(_=_.getTime());const f=Math.round((new Date().getTime()-_)/1e3);if(f<-30)return(0,a.localize)(0,null,R(new Date().getTime()+f*1e3,!1));if(f<30)return(0,a.localize)(1,null);let o;return f<t?(o=f,n?o===1?(0,a.localize)(2,null,o):(0,a.localize)(3,null,o):o===1?(0,a.localize)(4,null,o):(0,a.localize)(5,null,o)):f<w?(o=Math.floor(f/t),n?o===1?(0,a.localize)(6,null,o):(0,a.localize)(7,null,o):o===1?(0,a.localize)(8,null,o):(0,a.localize)(9,null,o)):f<T?(o=Math.floor(f/w),n?o===1?(0,a.localize)(10,null,o):(0,a.localize)(11,null,o):o===1?(0,a.localize)(12,null,o):(0,a.localize)(13,null,o)):f<k?(o=Math.floor(f/T),n?o===1?(0,a.localize)(14,null,o):(0,a.localize)(15,null,o):o===1?(0,a.localize)(16,null,o):(0,a.localize)(17,null,o)):f<I?(o=Math.floor(f/k),n?o===1?(0,a.localize)(18,null,o):(0,a.localize)(19,null,o):o===1?(0,a.localize)(20,null,o):(0,a.localize)(21,null,o)):f<S?(o=Math.floor(f/I),n?o===1?(0,a.localize)(22,null,o):(0,a.localize)(23,null,o):o===1?(0,a.localize)(24,null,o):(0,a.localize)(25,null,o)):(o=Math.floor(f/S),n?o===1?(0,a.localize)(26,null,o):(0,a.localize)(27,null,o):o===1?(0,a.localize)(28,null,o):(0,a.localize)(29,null,o))}e.fromNow=R;function F(_){return _.getFullYear()+"-"+String(_.getMonth()+1).padStart(2,"0")+"-"+String(_.getDate()).padStart(2,"0")+"T"+String(_.getHours()).padStart(2,"0")+":"+String(_.getMinutes()).padStart(2,"0")+":"+String(_.getSeconds()).padStart(2,"0")+"."+(_.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=F}),define(Ee[111],ye([18,19]),function(re,e){return re.create("vs/base/common/errorMessage",e)}),define(Ee[43],ye([0,1,16,11,111]),function(re,e,a,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function T(R,F){return F&&(R.stack||R.stacktrace)?w.localize(0,null,I(R),k(R.stack)||k(R.stacktrace)):I(R)}function k(R){return Array.isArray(R)?R.join(`
`):R}function I(R){return typeof R.code=="string"&&typeof R.errno=="number"&&typeof R.syscall=="string"?w.localize(1,null,R.message):R.message||w.localize(2,null)}function S(R=null,F=!1){if(!R)return w.localize(3,null);if(Array.isArray(R)){const _=a.coalesce(R),n=S(_[0],F);return _.length>1?w.localize(4,null,n,_.length):n}if(t.isString(R))return R;if(R.detail){const _=R.detail;if(_.error)return T(_.error,F);if(_.exception)return T(_.exception,F)}return R.stack?T(R,F):R.message?R.message:w.localize(5,null)}e.toErrorMessage=S}),define(Ee[112],ye([18,19]),function(re,e){return re.create("vs/editor/common/config/editorOptions",e)}),define(Ee[113],ye([0,1,112,23,114,16,26]),function(re,e,a,t,w,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var I;(function(V){V[V.None=0]="None",V[V.Keep=1]="Keep",V[V.Brackets=2]="Brackets",V[V.Advanced=3]="Advanced",V[V.Full=4]="Full"})(I=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class S{constructor(Q){this._values=Q}hasChanged(Q){return this._values[Q]}}e.ConfigurationChangedEvent=S;class R{constructor(){this._values=[]}_read(Q){return this._values[Q]}get(Q){return this._values[Q]}_write(Q,he){this._values[Q]=he}}e.ValidatedEditorOptions=R;class F{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=F;class _{constructor(Q,he,Le,We){this.id=Q,this.name=he,this.defaultValue=Le,this.schema=We}applyUpdate(Q,he){return f(Q,he)}compute(Q,he,Le){return Le}}class n{constructor(Q,he){this.newValue=Q,this.didChange=he}}e.ApplyUpdateResult=n;function f(V,Q){if(typeof V!="object"||typeof Q!="object"||!V||!Q)return new n(Q,V!==Q);if(Array.isArray(V)||Array.isArray(Q)){const Le=Array.isArray(V)&&Array.isArray(Q)&&T.equals(V,Q);return new n(Q,Le)}let he=!1;for(let Le in Q)if(Q.hasOwnProperty(Le)){const We=f(V[Le],Q[Le]);We.didChange&&(V[Le]=We.newValue,he=!0)}return new n(V,he)}class o{constructor(Q){this.schema=void 0,this.id=Q,this.name="_never_",this.defaultValue=void 0}applyUpdate(Q,he){return f(Q,he)}validate(Q){return this.defaultValue}}class m{constructor(Q,he,Le,We){this.id=Q,this.name=he,this.defaultValue=Le,this.schema=We}applyUpdate(Q,he){return f(Q,he)}validate(Q){return typeof Q=="undefined"?this.defaultValue:Q}compute(Q,he,Le){return Le}}function c(V,Q){return typeof V=="undefined"?Q:V==="false"?!1:Boolean(V)}e.boolean=c;class C extends m{constructor(Q,he,Le,We=void 0){typeof We!="undefined"&&(We.type="boolean",We.default=Le);super(Q,he,Le,We)}validate(Q){return c(Q,this.defaultValue)}}function b(V,Q,he,Le){if(typeof V=="undefined")return Q;let We=parseInt(V,10);return isNaN(We)?Q:(We=Math.max(he,We),We=Math.min(Le,We),We|0)}e.clampedInt=b;class h extends m{constructor(Q,he,Le,We,ot,Ge=void 0){typeof Ge!="undefined"&&(Ge.type="integer",Ge.default=Le,Ge.minimum=We,Ge.maximum=ot);super(Q,he,Le,Ge);this.minimum=We,this.maximum=ot}static clampedInt(Q,he,Le,We){return b(Q,he,Le,We)}validate(Q){return h.clampedInt(Q,this.defaultValue,this.minimum,this.maximum)}}class g extends m{constructor(Q,he,Le,We,ot){typeof ot!="undefined"&&(ot.type="number",ot.default=Le);super(Q,he,Le,ot);this.validationFn=We}static clamp(Q,he,Le){return Q<he?he:Q>Le?Le:Q}static float(Q,he){if(typeof Q=="number")return Q;if(typeof Q=="undefined")return he;const Le=parseFloat(Q);return isNaN(Le)?he:Le}validate(Q){return this.validationFn(g.float(Q,this.defaultValue))}}class P extends m{static string(Q,he){return typeof Q!="string"?he:Q}constructor(Q,he,Le,We=void 0){typeof We!="undefined"&&(We.type="string",We.default=Le);super(Q,he,Le,We)}validate(Q){return P.string(Q,this.defaultValue)}}function l(V,Q,he){return typeof V!="string"||he.indexOf(V)===-1?Q:V}e.stringSet=l;class M extends m{constructor(Q,he,Le,We,ot=void 0){typeof ot!="undefined"&&(ot.type="string",ot.enum=We,ot.default=Le);super(Q,he,Le,ot);this._allowedValues=We}validate(Q){return l(Q,this.defaultValue,this._allowedValues)}}class r extends _{constructor(Q,he,Le,We,ot,Ge,yt=void 0){typeof yt!="undefined"&&(yt.type="string",yt.enum=ot,yt.default=We);super(Q,he,Le,yt);this._allowedValues=ot,this._convert=Ge}validate(Q){return typeof Q!="string"?this.defaultValue:this._allowedValues.indexOf(Q)===-1?this.defaultValue:this._convert(Q)}}function i(V){switch(V){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class p extends _{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[a.localize(0,null),a.localize(1,null),a.localize(2,null)],default:"auto",description:a.localize(3,null)})}validate(Q){switch(Q){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Q,he,Le){return Le===0?Q.accessibilitySupport:Le}}class d extends _{constructor(){const Q={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",Q,{"editor.comments.insertSpace":{type:"boolean",default:Q.insertSpace,description:a.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Q.ignoreEmptyLines,description:a.localize(5,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{insertSpace:c(he.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:c(he.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var s;(function(V){V[V.Hidden=0]="Hidden",V[V.Blink=1]="Blink",V[V.Smooth=2]="Smooth",V[V.Phase=3]="Phase",V[V.Expand=4]="Expand",V[V.Solid=5]="Solid"})(s=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function v(V){switch(V){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var y;(function(V){V[V.Line=1]="Line",V[V.Block=2]="Block",V[V.Underline=3]="Underline",V[V.LineThin=4]="LineThin",V[V.BlockOutline=5]="BlockOutline",V[V.UnderlineThin=6]="UnderlineThin"})(y=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function u(V){switch(V){case y.Line:return"line";case y.Block:return"block";case y.Underline:return"underline";case y.LineThin:return"line-thin";case y.BlockOutline:return"block-outline";case y.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=u;function D(V){switch(V){case"line":return y.Line;case"block":return y.Block;case"underline":return y.Underline;case"line-thin":return y.LineThin;case"block-outline":return y.BlockOutline;case"underline-thin":return y.UnderlineThin}}class A extends o{constructor(){super(127)}compute(Q,he,Le){const We=["monaco-editor"];return he.get(33)&&We.push(he.get(33)),Q.extraEditorClassName&&We.push(Q.extraEditorClassName),he.get(65)==="default"?We.push("mouse-default"):he.get(65)==="copy"&&We.push("mouse-copy"),he.get(99)&&We.push("showUnused"),he.get(125)&&We.push("showDeprecated"),We.join(" ")}}class U extends C{constructor(){super(32,"emptySelectionClipboard",!0,{description:a.localize(6,null)})}compute(Q,he,Le){return Le&&Q.emptySelectionClipboard}}class B extends _{constructor(){const Q={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(35,"find",Q,{"editor.find.cursorMoveOnType":{type:"boolean",default:Q.cursorMoveOnType,description:a.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Q.seedSearchStringFromSelection,enumDescriptions:[a.localize(8,null),a.localize(9,null),a.localize(10,null)],description:a.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Q.autoFindInSelection,enumDescriptions:[a.localize(12,null),a.localize(13,null),a.localize(14,null)],description:a.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Q.globalFindClipboard,description:a.localize(16,null),included:t.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Q.addExtraSpaceOnTop,description:a.localize(17,null)},"editor.find.loop":{type:"boolean",default:Q.loop,description:a.localize(18,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{cursorMoveOnType:c(he.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Q.seedSearchStringFromSelection=="boolean"?Q.seedSearchStringFromSelection?"always":"never":l(he.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Q.autoFindInSelection=="boolean"?Q.autoFindInSelection?"always":"never":l(he.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:c(he.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:c(he.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:c(he.loop,this.defaultValue.loop)}}}class E extends _{constructor(){super(44,"fontLigatures",E.OFF,{anyOf:[{type:"boolean",description:a.localize(19,null)},{type:"string",description:a.localize(20,null)}],description:a.localize(21,null),default:!1})}validate(Q){return typeof Q=="undefined"?this.defaultValue:typeof Q=="string"?Q==="false"?E.OFF:Q==="true"?E.ON:Q:Boolean(Q)?E.ON:E.OFF}}e.EditorFontLigatures=E,E.OFF='"liga" off, "calt" off',E.ON='"liga" on, "calt" on';class N extends o{constructor(){super(43)}compute(Q,he,Le){return Q.fontInfo}}class L extends m{constructor(){super(45,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:a.localize(22,null)})}validate(Q){let he=g.float(Q,this.defaultValue);return he===0?e.EDITOR_FONT_DEFAULTS.fontSize:g.clamp(he,6,100)}compute(Q,he,Le){return Q.fontInfo.fontSize}}class z extends _{constructor(){super(46,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:z.MINIMUM_VALUE,maximum:z.MAXIMUM_VALUE,errorMessage:a.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:z.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:a.localize(24,null)})}validate(Q){return Q==="normal"||Q==="bold"?Q:String(h.clampedInt(Q,e.EDITOR_FONT_DEFAULTS.fontWeight,z.MINIMUM_VALUE,z.MAXIMUM_VALUE))}}z.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],z.MINIMUM_VALUE=1,z.MAXIMUM_VALUE=1e3;class H extends _{constructor(){const Q={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},he={type:"string",enum:["peek","gotoAndPeek","goto"],default:Q.multiple,enumDescriptions:[a.localize(25,null),a.localize(26,null),a.localize(27,null)]},Le=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(50,"gotoLocation",Q,{"editor.gotoLocation.multiple":{deprecationMessage:a.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:a.localize(29,null),...he},"editor.gotoLocation.multipleTypeDefinitions":{description:a.localize(30,null),...he},"editor.gotoLocation.multipleDeclarations":{description:a.localize(31,null),...he},"editor.gotoLocation.multipleImplementations":{description:a.localize(32,null),...he},"editor.gotoLocation.multipleReferences":{description:a.localize(33,null),...he},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Q.alternativeDefinitionCommand,enum:Le,description:a.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Q.alternativeTypeDefinitionCommand,enum:Le,description:a.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Q.alternativeDeclarationCommand,enum:Le,description:a.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Q.alternativeImplementationCommand,enum:Le,description:a.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Q.alternativeReferenceCommand,enum:Le,description:a.localize(38,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{multiple:l(he.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:he.multipleDefinitions??l(he.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:he.multipleTypeDefinitions??l(he.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:he.multipleDeclarations??l(he.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:he.multipleImplementations??l(he.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:he.multipleReferences??l(he.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:P.string(he.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:P.string(he.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:P.string(he.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:P.string(he.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:P.string(he.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class j extends _{constructor(){const Q={enabled:!0,delay:300,sticky:!0,above:!0};super(52,"hover",Q,{"editor.hover.enabled":{type:"boolean",default:Q.enabled,description:a.localize(39,null)},"editor.hover.delay":{type:"number",default:Q.delay,description:a.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:Q.sticky,description:a.localize(41,null)},"editor.hover.above":{type:"boolean",default:Q.above,description:a.localize(42,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{enabled:c(he.enabled,this.defaultValue.enabled),delay:h.clampedInt(he.delay,this.defaultValue.delay,0,1e4),sticky:c(he.sticky,this.defaultValue.sticky),above:c(he.above,this.defaultValue.above)}}}var ue;(function(V){V[V.None=0]="None",V[V.Text=1]="Text",V[V.Blocks=2]="Blocks"})(ue=e.RenderMinimap||(e.RenderMinimap={}));class G extends o{constructor(){super(130)}compute(Q,he,Le){return G.computeLayout(he,{memory:Q.memory,outerWidth:Q.outerWidth,outerHeight:Q.outerHeight,isDominatedByLongLines:Q.isDominatedByLongLines,lineHeight:Q.fontInfo.lineHeight,viewLineCount:Q.viewLineCount,lineNumbersDigitCount:Q.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Q.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Q.fontInfo.maxDigitWidth,pixelRatio:Q.pixelRatio})}static computeContainedMinimapLineCount(Q){const he=Q.height/Q.lineHeight,Le=Q.scrollBeyondLastLine?he-1:0,We=(Q.viewLineCount+Le)/(Q.pixelRatio*Q.height),ot=Math.floor(Q.viewLineCount/We);return{typicalViewportLineCount:he,extraLinesBeyondLastLine:Le,desiredRatio:We,minimapLineCount:ot}}static _computeMinimapLayout(Q,he){const Le=Q.outerWidth,We=Q.outerHeight,ot=Q.pixelRatio;if(!Q.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(ot*We),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:We};const Ge=he.stableMinimapLayoutInput,yt=Ge&&Q.outerHeight===Ge.outerHeight&&Q.lineHeight===Ge.lineHeight&&Q.typicalHalfwidthCharacterWidth===Ge.typicalHalfwidthCharacterWidth&&Q.pixelRatio===Ge.pixelRatio&&Q.scrollBeyondLastLine===Ge.scrollBeyondLastLine&&Q.minimap.enabled===Ge.minimap.enabled&&Q.minimap.side===Ge.minimap.side&&Q.minimap.size===Ge.minimap.size&&Q.minimap.showSlider===Ge.minimap.showSlider&&Q.minimap.renderCharacters===Ge.minimap.renderCharacters&&Q.minimap.maxColumn===Ge.minimap.maxColumn&&Q.minimap.scale===Ge.minimap.scale&&Q.verticalScrollbarWidth===Ge.verticalScrollbarWidth&&Q.isViewportWrapping===Ge.isViewportWrapping,Ie=Q.lineHeight,Ce=Q.typicalHalfwidthCharacterWidth,ve=Q.scrollBeyondLastLine,oe=Q.minimap.renderCharacters;let se=ot>=2?Math.round(Q.minimap.scale*2):Q.minimap.scale;const fe=Q.minimap.maxColumn,ge=Q.minimap.size,ke=Q.minimap.side,ze=Q.verticalScrollbarWidth,Oe=Q.viewLineCount,Ve=Q.remainingWidth,it=Q.isViewportWrapping,rt=oe?2:3;let ne=Math.floor(ot*We);const pe=ne/ot;let ee=!1,W=!1,be=rt*se,De=se/ot,qe=1;if(ge==="fill"||ge==="fit"){const{typicalViewportLineCount:gt,extraLinesBeyondLastLine:_t,desiredRatio:Lt,minimapLineCount:It}=G.computeContainedMinimapLineCount({viewLineCount:Oe,scrollBeyondLastLine:ve,height:We,lineHeight:Ie,pixelRatio:ot});if(Oe/It>1)ee=!0,W=!0,se=1,be=1,De=se/ot;else{let At=!1,Et=se+1;if(ge==="fit"){const Ot=Math.ceil((Oe+_t)*be);it&&yt&&Ve<=he.stableFitRemainingWidth?(At=!0,Et=he.stableFitMaxMinimapScale):At=Ot>ne}if(ge==="fill"||At){ee=!0;const Ot=se;be=Math.min(Ie*ot,Math.max(1,Math.floor(1/Lt))),it&&yt&&Ve<=he.stableFitRemainingWidth&&(Et=he.stableFitMaxMinimapScale),se=Math.min(Et,Math.max(1,Math.floor(be/rt))),se>Ot&&(qe=Math.min(2,se/Ot)),De=se/ot/qe,ne=Math.ceil(Math.max(gt,Oe+_t)*be),it?(he.stableMinimapLayoutInput=Q,he.stableFitRemainingWidth=Ve,he.stableFitMaxMinimapScale=se):(he.stableMinimapLayoutInput=null,he.stableFitRemainingWidth=0)}}}const xe=Math.floor(fe*De),ut=Math.min(xe,Math.max(0,Math.floor((Ve-ze-2)*De/(Ce+De)))+e.MINIMAP_GUTTER_WIDTH);let vt=Math.floor(ot*ut);const St=vt/ot;vt=Math.floor(vt*qe);const bt=oe?1:2,ht=ke==="left"?0:Le-ut-ze;return{renderMinimap:bt,minimapLeft:ht,minimapWidth:ut,minimapHeightIsEditorHeight:ee,minimapIsSampling:W,minimapScale:se,minimapLineHeight:be,minimapCanvasInnerWidth:vt,minimapCanvasInnerHeight:ne,minimapCanvasOuterWidth:St,minimapCanvasOuterHeight:pe}}static computeLayout(Q,he){const Le=he.outerWidth|0,We=he.outerHeight|0,ot=he.lineHeight|0,Ge=he.lineNumbersDigitCount|0,yt=he.typicalHalfwidthCharacterWidth,Ie=he.maxDigitWidth,Ce=he.pixelRatio,ve=he.viewLineCount,oe=Q.get(122),se=oe==="inherit"?Q.get(121):oe,fe=se==="inherit"?Q.get(117):se,ge=Q.get(120),ke=Q.get(2),ze=he.isDominatedByLongLines,Oe=Q.get(49),Ve=Q.get(59).renderType!==0,it=Q.get(60),rt=Q.get(93),ne=Q.get(64),pe=Q.get(91),ee=pe.verticalScrollbarSize,W=pe.verticalHasArrows,be=pe.arrowSize,De=pe.horizontalScrollbarSize,qe=Q.get(57),xe=Q.get(37);let ut;if(typeof qe=="string"&&/^\d+(\.\d+)?ch$/.test(qe)){const $t=parseFloat(qe.substr(0,qe.length-2));ut=h.clampedInt($t*yt,0,0,1e3)}else ut=h.clampedInt(qe,0,0,1e3);xe&&(ut+=16);let vt=0;if(Ve){const $t=Math.max(Ge,it);vt=Math.round($t*Ie)}let St=0;Oe&&(St=ot);let bt=0,ht=bt+St,gt=ht+vt,_t=gt+ut;const Lt=Le-St-vt-ut;let It=!1,Pt=!1,At=-1;ke!==2&&(se==="inherit"&&ze?(It=!0,Pt=!0):fe==="on"||fe==="bounded"?Pt=!0:fe==="wordWrapColumn"&&(At=ge));const Et=G._computeMinimapLayout({outerWidth:Le,outerHeight:We,lineHeight:ot,typicalHalfwidthCharacterWidth:yt,pixelRatio:Ce,scrollBeyondLastLine:rt,minimap:ne,verticalScrollbarWidth:ee,viewLineCount:ve,remainingWidth:Lt,isViewportWrapping:Pt},he.memory||new F);Et.renderMinimap!==0&&Et.minimapLeft===0&&(bt+=Et.minimapWidth,ht+=Et.minimapWidth,gt+=Et.minimapWidth,_t+=Et.minimapWidth);const Ot=Lt-Et.minimapWidth,Nt=Math.max(1,Math.floor((Ot-ee-2)/yt)),wt=W?be:0;return Pt&&(At=Math.max(1,Nt),fe==="bounded"&&(At=Math.min(At,ge))),{width:Le,height:We,glyphMarginLeft:bt,glyphMarginWidth:St,lineNumbersLeft:ht,lineNumbersWidth:vt,decorationsLeft:gt,decorationsWidth:ut,contentLeft:_t,contentWidth:Ot,minimap:Et,viewportColumn:Nt,isWordWrapMinified:It,isViewportWrapping:Pt,wrappingColumn:At,verticalScrollbarWidth:ee,horizontalScrollbarHeight:De,overviewRuler:{top:wt,width:ee,height:We-2*wt,right:0}}}}e.EditorLayoutInfoComputer=G;class le extends _{constructor(){const Q={enabled:!0};super(56,"lightbulb",Q,{"editor.lightbulb.enabled":{type:"boolean",default:Q.enabled,description:a.localize(43,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:c(Q.enabled,this.defaultValue.enabled)}}}class ce extends _{constructor(){const Q={enabled:!0,fontSize:0,fontFamily:""};super(126,"inlayHints",Q,{"editor.inlayHints.enabled":{type:"boolean",default:Q.enabled,description:a.localize(44,null)},"editor.inlayHints.fontSize":{type:"number",default:Q.fontSize,markdownDescription:a.localize(45,null)},"editor.inlayHints.fontFamily":{type:"string",default:Q.fontFamily,markdownDescription:a.localize(46,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{enabled:c(he.enabled,this.defaultValue.enabled),fontSize:h.clampedInt(he.fontSize,this.defaultValue.fontSize,0,100),fontFamily:P.string(he.fontFamily,this.defaultValue.fontFamily)}}}class Y extends g{constructor(){super(58,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Q=>g.clamp(Q,0,150),{markdownDescription:a.localize(47,null)})}compute(Q,he,Le){return Q.fontInfo.lineHeight}}class ie extends _{constructor(){const Q={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(64,"minimap",Q,{"editor.minimap.enabled":{type:"boolean",default:Q.enabled,description:a.localize(48,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[a.localize(49,null),a.localize(50,null),a.localize(51,null)],default:Q.size,description:a.localize(52,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Q.side,description:a.localize(53,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Q.showSlider,description:a.localize(54,null)},"editor.minimap.scale":{type:"number",default:Q.scale,minimum:1,maximum:3,enum:[1,2,3],description:a.localize(55,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Q.renderCharacters,description:a.localize(56,null)},"editor.minimap.maxColumn":{type:"number",default:Q.maxColumn,description:a.localize(57,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{enabled:c(he.enabled,this.defaultValue.enabled),size:l(he.size,this.defaultValue.size,["proportional","fill","fit"]),side:l(he.side,this.defaultValue.side,["right","left"]),showSlider:l(he.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:c(he.renderCharacters,this.defaultValue.renderCharacters),scale:h.clampedInt(he.scale,1,1,3),maxColumn:h.clampedInt(he.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function we(V){return V==="ctrlCmd"?t.isMacintosh?"metaKey":"ctrlKey":"altKey"}class Me extends _{constructor(){super(74,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:a.localize(58,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:a.localize(59,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{top:h.clampedInt(he.top,0,0,1e3),bottom:h.clampedInt(he.bottom,0,0,1e3)}}}class Re extends _{constructor(){const Q={enabled:!0,cycle:!1};super(75,"parameterHints",Q,{"editor.parameterHints.enabled":{type:"boolean",default:Q.enabled,description:a.localize(60,null)},"editor.parameterHints.cycle":{type:"boolean",default:Q.cycle,description:a.localize(61,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{enabled:c(he.enabled,this.defaultValue.enabled),cycle:c(he.cycle,this.defaultValue.cycle)}}}class Be extends o{constructor(){super(128)}compute(Q,he,Le){return Q.pixelRatio}}class Qe extends _{constructor(){const Q={other:!0,comments:!1,strings:!1};super(78,"quickSuggestions",Q,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:Q.strings,description:a.localize(62,null)},comments:{type:"boolean",default:Q.comments,description:a.localize(63,null)},other:{type:"boolean",default:Q.other,description:a.localize(64,null)}}}],default:Q,description:a.localize(65,null)});this.defaultValue=Q}validate(Q){if(typeof Q=="boolean")return Q;if(Q&&typeof Q=="object"){const he=Q,Le={other:c(he.other,this.defaultValue.other),comments:c(he.comments,this.defaultValue.comments),strings:c(he.strings,this.defaultValue.strings)};return Le.other&&Le.comments&&Le.strings?!0:!Le.other&&!Le.comments&&!Le.strings?!1:Le}return this.defaultValue}}var Ke;(function(V){V[V.Off=0]="Off",V[V.On=1]="On",V[V.Relative=2]="Relative",V[V.Interval=3]="Interval",V[V.Custom=4]="Custom"})(Ke=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Xe extends _{constructor(){super(59,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[a.localize(66,null),a.localize(67,null),a.localize(68,null),a.localize(69,null)],default:"on",description:a.localize(70,null)})}validate(Q){let he=this.defaultValue.renderType,Le=this.defaultValue.renderFn;return typeof Q!="undefined"&&(typeof Q=="function"?(he=4,Le=Q):Q==="interval"?he=3:Q==="relative"?he=2:Q==="on"?he=1:he=0),{renderType:he,renderFn:Le}}}function $(V){const Q=V.get(86);return Q==="editable"?V.get(80):Q!=="on"}e.filterValidationDecorations=$;class K extends _{constructor(){const Q=[],he={type:"number",description:a.localize(71,null)};super(90,"rulers",Q,{type:"array",items:{anyOf:[he,{type:["object"],properties:{column:he,color:{type:"string",description:a.localize(72,null),format:"color-hex"}}}]},default:Q,description:a.localize(73,null)})}validate(Q){if(Array.isArray(Q)){let he=[];for(let Le of Q)if(typeof Le=="number")he.push({column:h.clampedInt(Le,0,0,1e4),color:null});else if(Le&&typeof Le=="object"){const We=Le;he.push({column:h.clampedInt(We.column,0,0,1e4),color:We.color})}return he.sort((Le,We)=>Le.column-We.column),he}return this.defaultValue}}function J(V,Q){if(typeof V!="string")return Q;switch(V){case"hidden":return 2;case"visible":return 3;default:return 1}}class ae extends _{constructor(){const Q={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(91,"scrollbar",Q,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[a.localize(74,null),a.localize(75,null),a.localize(76,null)],default:"auto",description:a.localize(77,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[a.localize(78,null),a.localize(79,null),a.localize(80,null)],default:"auto",description:a.localize(81,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Q.verticalScrollbarSize,description:a.localize(82,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Q.horizontalScrollbarSize,description:a.localize(83,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Q.scrollByPage,description:a.localize(84,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q,Le=h.clampedInt(he.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),We=h.clampedInt(he.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:h.clampedInt(he.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:J(he.vertical,this.defaultValue.vertical),horizontal:J(he.horizontal,this.defaultValue.horizontal),useShadows:c(he.useShadows,this.defaultValue.useShadows),verticalHasArrows:c(he.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:c(he.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:c(he.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:c(he.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Le,horizontalSliderSize:h.clampedInt(he.horizontalSliderSize,Le,0,1e3),verticalScrollbarSize:We,verticalSliderSize:h.clampedInt(he.verticalSliderSize,We,0,1e3),scrollByPage:c(he.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments"};class q extends _{constructor(){const Q={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,allowedCharacters:{}};super(112,"unicodeHighlight",Q,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.nonBasicASCII,description:a.localize(85,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Q.invisibleCharacters,description:a.localize(86,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Q.ambiguousCharacters,description:a.localize(87,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeComments,description:a.localize(88,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Q.allowedCharacters,description:a.localize(89,null),additionalProperties:{type:"boolean"}}})}applyUpdate(Q,he){let Le=!1;he.allowedCharacters&&(k.equals(Q.allowedCharacters,he.allowedCharacters)||(Q={...Q,allowedCharacters:he.allowedCharacters},Le=!0));const We=super.applyUpdate(Q,he);return Le?new n(We.newValue,!0):We}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{nonBasicASCII:Ne(he.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:c(he.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:c(he.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Ne(he.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateAllowedCharacters(Q.allowedCharacters,this.defaultValue.allowedCharacters)}}validateAllowedCharacters(Q,he){if(typeof Q!="object"||!Q)return he;const Le={};for(const[We,ot]of Object.entries(Q))ot===!0&&(Le[We]=!0);return Le}}class te extends _{constructor(){const Q={enabled:!0,mode:"subwordSmart"};super(54,"inlineSuggest",Q,{"editor.inlineSuggest.enabled":{type:"boolean",default:Q.enabled,description:a.localize(90,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{enabled:c(he.enabled,this.defaultValue.enabled),mode:l(he.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class me extends _{constructor(){const Q={enabled:e.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled};super(12,"bracketPairColorization",Q,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Q.enabled,description:a.localize(91,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:c(Q.enabled,this.defaultValue.enabled)}}}class Pe extends _{constructor(){const Q={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",Q,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[a.localize(92,null),a.localize(93,null),a.localize(94,null)],default:Q.bracketPairs,description:a.localize(95,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[a.localize(96,null),a.localize(97,null),a.localize(98,null)],default:Q.bracketPairsHorizontal,description:a.localize(99,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Q.highlightActiveBracketPair,description:a.localize(100,null)},"editor.guides.indentation":{type:"boolean",default:Q.indentation,description:a.localize(101,null)},"editor.guides.highlightActiveIndentation":{type:"boolean",default:Q.highlightActiveIndentation,description:a.localize(102,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{bracketPairs:Ne(he.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Ne(he.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:c(he.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:c(he.indentation,this.defaultValue.indentation),highlightActiveIndentation:c(he.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation)}}}function Ne(V,Q,he){const Le=he.indexOf(V);return Le===-1?Q:he[Le]}class He extends _{constructor(){const Q={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(105,"suggest",Q,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[a.localize(103,null),a.localize(104,null)],default:Q.insertMode,description:a.localize(105,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Q.filterGraceful,description:a.localize(106,null)},"editor.suggest.localityBonus":{type:"boolean",default:Q.localityBonus,description:a.localize(107,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Q.shareSuggestSelections,markdownDescription:a.localize(108,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Q.snippetsPreventQuickSuggestions,description:a.localize(109,null)},"editor.suggest.showIcons":{type:"boolean",default:Q.showIcons,description:a.localize(110,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Q.showStatusBar,description:a.localize(111,null)},"editor.suggest.preview":{type:"boolean",default:Q.preview,description:a.localize(112,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Q.showInlineDetails,description:a.localize(113,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:a.localize(114,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:a.localize(115,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:a.localize(116,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:a.localize(117,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:a.localize(118,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:a.localize(119,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:a.localize(120,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:a.localize(121,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:a.localize(122,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:a.localize(123,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:a.localize(124,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:a.localize(125,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:a.localize(126,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:a.localize(127,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:a.localize(128,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:a.localize(129,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:a.localize(130,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:a.localize(131,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:a.localize(132,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:a.localize(133,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:a.localize(134,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:a.localize(135,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:a.localize(136,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:a.localize(137,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:a.localize(138,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:a.localize(139,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:a.localize(140,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:a.localize(141,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:a.localize(142,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:a.localize(143,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:a.localize(144,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{insertMode:l(he.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:c(he.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:c(he.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:c(he.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:c(he.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:c(he.showIcons,this.defaultValue.showIcons),showStatusBar:c(he.showStatusBar,this.defaultValue.showStatusBar),preview:c(he.preview,this.defaultValue.preview),previewMode:l(he.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:c(he.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:c(he.showMethods,this.defaultValue.showMethods),showFunctions:c(he.showFunctions,this.defaultValue.showFunctions),showConstructors:c(he.showConstructors,this.defaultValue.showConstructors),showDeprecated:c(he.showDeprecated,this.defaultValue.showDeprecated),showFields:c(he.showFields,this.defaultValue.showFields),showVariables:c(he.showVariables,this.defaultValue.showVariables),showClasses:c(he.showClasses,this.defaultValue.showClasses),showStructs:c(he.showStructs,this.defaultValue.showStructs),showInterfaces:c(he.showInterfaces,this.defaultValue.showInterfaces),showModules:c(he.showModules,this.defaultValue.showModules),showProperties:c(he.showProperties,this.defaultValue.showProperties),showEvents:c(he.showEvents,this.defaultValue.showEvents),showOperators:c(he.showOperators,this.defaultValue.showOperators),showUnits:c(he.showUnits,this.defaultValue.showUnits),showValues:c(he.showValues,this.defaultValue.showValues),showConstants:c(he.showConstants,this.defaultValue.showConstants),showEnums:c(he.showEnums,this.defaultValue.showEnums),showEnumMembers:c(he.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:c(he.showKeywords,this.defaultValue.showKeywords),showWords:c(he.showWords,this.defaultValue.showWords),showColors:c(he.showColors,this.defaultValue.showColors),showFiles:c(he.showFiles,this.defaultValue.showFiles),showReferences:c(he.showReferences,this.defaultValue.showReferences),showFolders:c(he.showFolders,this.defaultValue.showFolders),showTypeParameters:c(he.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:c(he.showSnippets,this.defaultValue.showSnippets),showUsers:c(he.showUsers,this.defaultValue.showUsers),showIssues:c(he.showIssues,this.defaultValue.showIssues)}}}class Ye extends _{constructor(){super(101,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:a.localize(145,null),default:!0,type:"boolean"}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:c(Q.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class et extends o{constructor(){super(129)}compute(Q,he,Le){return he.get(80)?!0:Q.tabFocusMode}}var st;(function(V){V[V.None=0]="None",V[V.Same=1]="Same",V[V.Indent=2]="Indent",V[V.DeepIndent=3]="DeepIndent"})(st=e.WrappingIndent||(e.WrappingIndent={}));function Je(V){switch(V){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class nt extends o{constructor(){super(131)}compute(Q,he,Le){const We=he.get(130);return{isDominatedByLongLines:Q.isDominatedByLongLines,isWordWrapMinified:We.isWordWrapMinified,isViewportWrapping:We.isViewportWrapping,wrappingColumn:We.wrappingColumn}}}const lt="Consolas, 'Courier New', monospace",pt="Menlo, Monaco, 'Courier New', monospace",Ft="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:t.isMacintosh?pt:t.isLinux?Ft:lt,fontWeight:"normal",fontSize:t.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!1}},e.editorOptionsRegistry=[];function Fe(V){return e.editorOptionsRegistry[V.id]=V,V}var Mt;(function(V){V[V.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",V[V.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",V[V.accessibilitySupport=2]="accessibilitySupport",V[V.accessibilityPageSize=3]="accessibilityPageSize",V[V.ariaLabel=4]="ariaLabel",V[V.autoClosingBrackets=5]="autoClosingBrackets",V[V.autoClosingDelete=6]="autoClosingDelete",V[V.autoClosingOvertype=7]="autoClosingOvertype",V[V.autoClosingQuotes=8]="autoClosingQuotes",V[V.autoIndent=9]="autoIndent",V[V.automaticLayout=10]="automaticLayout",V[V.autoSurround=11]="autoSurround",V[V.bracketPairColorization=12]="bracketPairColorization",V[V.guides=13]="guides",V[V.codeLens=14]="codeLens",V[V.codeLensFontFamily=15]="codeLensFontFamily",V[V.codeLensFontSize=16]="codeLensFontSize",V[V.colorDecorators=17]="colorDecorators",V[V.columnSelection=18]="columnSelection",V[V.comments=19]="comments",V[V.contextmenu=20]="contextmenu",V[V.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",V[V.cursorBlinking=22]="cursorBlinking",V[V.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",V[V.cursorStyle=24]="cursorStyle",V[V.cursorSurroundingLines=25]="cursorSurroundingLines",V[V.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",V[V.cursorWidth=27]="cursorWidth",V[V.disableLayerHinting=28]="disableLayerHinting",V[V.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",V[V.domReadOnly=30]="domReadOnly",V[V.dragAndDrop=31]="dragAndDrop",V[V.emptySelectionClipboard=32]="emptySelectionClipboard",V[V.extraEditorClassName=33]="extraEditorClassName",V[V.fastScrollSensitivity=34]="fastScrollSensitivity",V[V.find=35]="find",V[V.fixedOverflowWidgets=36]="fixedOverflowWidgets",V[V.folding=37]="folding",V[V.foldingStrategy=38]="foldingStrategy",V[V.foldingHighlight=39]="foldingHighlight",V[V.foldingImportsByDefault=40]="foldingImportsByDefault",V[V.unfoldOnClickAfterEndOfLine=41]="unfoldOnClickAfterEndOfLine",V[V.fontFamily=42]="fontFamily",V[V.fontInfo=43]="fontInfo",V[V.fontLigatures=44]="fontLigatures",V[V.fontSize=45]="fontSize",V[V.fontWeight=46]="fontWeight",V[V.formatOnPaste=47]="formatOnPaste",V[V.formatOnType=48]="formatOnType",V[V.glyphMargin=49]="glyphMargin",V[V.gotoLocation=50]="gotoLocation",V[V.hideCursorInOverviewRuler=51]="hideCursorInOverviewRuler",V[V.hover=52]="hover",V[V.inDiffEditor=53]="inDiffEditor",V[V.inlineSuggest=54]="inlineSuggest",V[V.letterSpacing=55]="letterSpacing",V[V.lightbulb=56]="lightbulb",V[V.lineDecorationsWidth=57]="lineDecorationsWidth",V[V.lineHeight=58]="lineHeight",V[V.lineNumbers=59]="lineNumbers",V[V.lineNumbersMinChars=60]="lineNumbersMinChars",V[V.linkedEditing=61]="linkedEditing",V[V.links=62]="links",V[V.matchBrackets=63]="matchBrackets",V[V.minimap=64]="minimap",V[V.mouseStyle=65]="mouseStyle",V[V.mouseWheelScrollSensitivity=66]="mouseWheelScrollSensitivity",V[V.mouseWheelZoom=67]="mouseWheelZoom",V[V.multiCursorMergeOverlapping=68]="multiCursorMergeOverlapping",V[V.multiCursorModifier=69]="multiCursorModifier",V[V.multiCursorPaste=70]="multiCursorPaste",V[V.occurrencesHighlight=71]="occurrencesHighlight",V[V.overviewRulerBorder=72]="overviewRulerBorder",V[V.overviewRulerLanes=73]="overviewRulerLanes",V[V.padding=74]="padding",V[V.parameterHints=75]="parameterHints",V[V.peekWidgetDefaultFocus=76]="peekWidgetDefaultFocus",V[V.definitionLinkOpensInPeek=77]="definitionLinkOpensInPeek",V[V.quickSuggestions=78]="quickSuggestions",V[V.quickSuggestionsDelay=79]="quickSuggestionsDelay",V[V.readOnly=80]="readOnly",V[V.renameOnType=81]="renameOnType",V[V.renderControlCharacters=82]="renderControlCharacters",V[V.renderFinalNewline=83]="renderFinalNewline",V[V.renderLineHighlight=84]="renderLineHighlight",V[V.renderLineHighlightOnlyWhenFocus=85]="renderLineHighlightOnlyWhenFocus",V[V.renderValidationDecorations=86]="renderValidationDecorations",V[V.renderWhitespace=87]="renderWhitespace",V[V.revealHorizontalRightPadding=88]="revealHorizontalRightPadding",V[V.roundedSelection=89]="roundedSelection",V[V.rulers=90]="rulers",V[V.scrollbar=91]="scrollbar",V[V.scrollBeyondLastColumn=92]="scrollBeyondLastColumn",V[V.scrollBeyondLastLine=93]="scrollBeyondLastLine",V[V.scrollPredominantAxis=94]="scrollPredominantAxis",V[V.selectionClipboard=95]="selectionClipboard",V[V.selectionHighlight=96]="selectionHighlight",V[V.selectOnLineNumbers=97]="selectOnLineNumbers",V[V.showFoldingControls=98]="showFoldingControls",V[V.showUnused=99]="showUnused",V[V.snippetSuggestions=100]="snippetSuggestions",V[V.smartSelect=101]="smartSelect",V[V.smoothScrolling=102]="smoothScrolling",V[V.stickyTabStops=103]="stickyTabStops",V[V.stopRenderingLineAfter=104]="stopRenderingLineAfter",V[V.suggest=105]="suggest",V[V.suggestFontSize=106]="suggestFontSize",V[V.suggestLineHeight=107]="suggestLineHeight",V[V.suggestOnTriggerCharacters=108]="suggestOnTriggerCharacters",V[V.suggestSelection=109]="suggestSelection",V[V.tabCompletion=110]="tabCompletion",V[V.tabIndex=111]="tabIndex",V[V.unicodeHighlighting=112]="unicodeHighlighting",V[V.unusualLineTerminators=113]="unusualLineTerminators",V[V.useShadowDOM=114]="useShadowDOM",V[V.useTabStops=115]="useTabStops",V[V.wordSeparators=116]="wordSeparators",V[V.wordWrap=117]="wordWrap",V[V.wordWrapBreakAfterCharacters=118]="wordWrapBreakAfterCharacters",V[V.wordWrapBreakBeforeCharacters=119]="wordWrapBreakBeforeCharacters",V[V.wordWrapColumn=120]="wordWrapColumn",V[V.wordWrapOverride1=121]="wordWrapOverride1",V[V.wordWrapOverride2=122]="wordWrapOverride2",V[V.wrappingIndent=123]="wrappingIndent",V[V.wrappingStrategy=124]="wrappingStrategy",V[V.showDeprecated=125]="showDeprecated",V[V.inlayHints=126]="inlayHints",V[V.editorClassName=127]="editorClassName",V[V.pixelRatio=128]="pixelRatio",V[V.tabFocusMode=129]="tabFocusMode",V[V.layoutInfo=130]="layoutInfo",V[V.wrappingInfo=131]="wrappingInfo"})(Mt=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Fe(new C(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:a.localize(146,null)})),acceptSuggestionOnEnter:Fe(new M(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",a.localize(147,null),""],markdownDescription:a.localize(148,null)})),accessibilitySupport:Fe(new p),accessibilityPageSize:Fe(new h(3,"accessibilityPageSize",10,1,1073741824,{description:a.localize(149,null)})),ariaLabel:Fe(new P(4,"ariaLabel",a.localize(150,null))),autoClosingBrackets:Fe(new M(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",a.localize(151,null),a.localize(152,null),""],description:a.localize(153,null)})),autoClosingDelete:Fe(new M(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",a.localize(154,null),""],description:a.localize(155,null)})),autoClosingOvertype:Fe(new M(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",a.localize(156,null),""],description:a.localize(157,null)})),autoClosingQuotes:Fe(new M(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",a.localize(158,null),a.localize(159,null),""],description:a.localize(160,null)})),autoIndent:Fe(new r(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],i,{enumDescriptions:[a.localize(161,null),a.localize(162,null),a.localize(163,null),a.localize(164,null),a.localize(165,null)],description:a.localize(166,null)})),automaticLayout:Fe(new C(10,"automaticLayout",!1)),autoSurround:Fe(new M(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[a.localize(167,null),a.localize(168,null),a.localize(169,null),""],description:a.localize(170,null)})),bracketPairColorization:Fe(new me),bracketPairGuides:Fe(new Pe),stickyTabStops:Fe(new C(103,"stickyTabStops",!1,{description:a.localize(171,null)})),codeLens:Fe(new C(14,"codeLens",!0,{description:a.localize(172,null)})),codeLensFontFamily:Fe(new P(15,"codeLensFontFamily","",{description:a.localize(173,null)})),codeLensFontSize:Fe(new h(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:a.localize(174,null)})),colorDecorators:Fe(new C(17,"colorDecorators",!0,{description:a.localize(175,null)})),columnSelection:Fe(new C(18,"columnSelection",!1,{description:a.localize(176,null)})),comments:Fe(new d),contextmenu:Fe(new C(20,"contextmenu",!0)),copyWithSyntaxHighlighting:Fe(new C(21,"copyWithSyntaxHighlighting",!0,{description:a.localize(177,null)})),cursorBlinking:Fe(new r(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],v,{description:a.localize(178,null)})),cursorSmoothCaretAnimation:Fe(new C(23,"cursorSmoothCaretAnimation",!1,{description:a.localize(179,null)})),cursorStyle:Fe(new r(24,"cursorStyle",y.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],D,{description:a.localize(180,null)})),cursorSurroundingLines:Fe(new h(25,"cursorSurroundingLines",0,0,1073741824,{description:a.localize(181,null)})),cursorSurroundingLinesStyle:Fe(new M(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[a.localize(182,null),a.localize(183,null)],description:a.localize(184,null)})),cursorWidth:Fe(new h(27,"cursorWidth",0,0,1073741824,{markdownDescription:a.localize(185,null)})),disableLayerHinting:Fe(new C(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:Fe(new C(29,"disableMonospaceOptimizations",!1)),domReadOnly:Fe(new C(30,"domReadOnly",!1)),dragAndDrop:Fe(new C(31,"dragAndDrop",!0,{description:a.localize(186,null)})),emptySelectionClipboard:Fe(new U),extraEditorClassName:Fe(new P(33,"extraEditorClassName","")),fastScrollSensitivity:Fe(new g(34,"fastScrollSensitivity",5,V=>V<=0?5:V,{markdownDescription:a.localize(187,null)})),find:Fe(new B),fixedOverflowWidgets:Fe(new C(36,"fixedOverflowWidgets",!1)),folding:Fe(new C(37,"folding",!0,{description:a.localize(188,null)})),foldingStrategy:Fe(new M(38,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[a.localize(189,null),a.localize(190,null)],description:a.localize(191,null)})),foldingHighlight:Fe(new C(39,"foldingHighlight",!0,{description:a.localize(192,null)})),foldingImportsByDefault:Fe(new C(40,"foldingImportsByDefault",!1,{description:a.localize(193,null)})),unfoldOnClickAfterEndOfLine:Fe(new C(41,"unfoldOnClickAfterEndOfLine",!1,{description:a.localize(194,null)})),fontFamily:Fe(new P(42,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:a.localize(195,null)})),fontInfo:Fe(new N),fontLigatures2:Fe(new E),fontSize:Fe(new L),fontWeight:Fe(new z),formatOnPaste:Fe(new C(47,"formatOnPaste",!1,{description:a.localize(196,null)})),formatOnType:Fe(new C(48,"formatOnType",!1,{description:a.localize(197,null)})),glyphMargin:Fe(new C(49,"glyphMargin",!0,{description:a.localize(198,null)})),gotoLocation:Fe(new H),hideCursorInOverviewRuler:Fe(new C(51,"hideCursorInOverviewRuler",!1,{description:a.localize(199,null)})),hover:Fe(new j),inDiffEditor:Fe(new C(53,"inDiffEditor",!1)),letterSpacing:Fe(new g(55,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,V=>g.clamp(V,-5,20),{description:a.localize(200,null)})),lightbulb:Fe(new le),lineDecorationsWidth:Fe(new m(57,"lineDecorationsWidth",10)),lineHeight:Fe(new Y),lineNumbers:Fe(new Xe),lineNumbersMinChars:Fe(new h(60,"lineNumbersMinChars",5,1,300)),linkedEditing:Fe(new C(61,"linkedEditing",!1,{description:a.localize(201,null)})),links:Fe(new C(62,"links",!0,{description:a.localize(202,null)})),matchBrackets:Fe(new M(63,"matchBrackets","always",["always","near","never"],{description:a.localize(203,null)})),minimap:Fe(new ie),mouseStyle:Fe(new M(65,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Fe(new g(66,"mouseWheelScrollSensitivity",1,V=>V===0?1:V,{markdownDescription:a.localize(204,null)})),mouseWheelZoom:Fe(new C(67,"mouseWheelZoom",!1,{markdownDescription:a.localize(205,null)})),multiCursorMergeOverlapping:Fe(new C(68,"multiCursorMergeOverlapping",!0,{description:a.localize(206,null)})),multiCursorModifier:Fe(new r(69,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],we,{markdownEnumDescriptions:[a.localize(207,null),a.localize(208,null)],markdownDescription:a.localize(209,null)})),multiCursorPaste:Fe(new M(70,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[a.localize(210,null),a.localize(211,null)],markdownDescription:a.localize(212,null)})),occurrencesHighlight:Fe(new C(71,"occurrencesHighlight",!0,{description:a.localize(213,null)})),overviewRulerBorder:Fe(new C(72,"overviewRulerBorder",!0,{description:a.localize(214,null)})),overviewRulerLanes:Fe(new h(73,"overviewRulerLanes",3,0,3)),padding:Fe(new Me),parameterHints:Fe(new Re),peekWidgetDefaultFocus:Fe(new M(76,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[a.localize(215,null),a.localize(216,null)],description:a.localize(217,null)})),definitionLinkOpensInPeek:Fe(new C(77,"definitionLinkOpensInPeek",!1,{description:a.localize(218,null)})),quickSuggestions:Fe(new Qe),quickSuggestionsDelay:Fe(new h(79,"quickSuggestionsDelay",10,0,1073741824,{description:a.localize(219,null)})),readOnly:Fe(new C(80,"readOnly",!1)),renameOnType:Fe(new C(81,"renameOnType",!1,{description:a.localize(220,null),markdownDeprecationMessage:a.localize(221,null)})),renderControlCharacters:Fe(new C(82,"renderControlCharacters",!0,{description:a.localize(222,null),restricted:!0})),renderFinalNewline:Fe(new C(83,"renderFinalNewline",!0,{description:a.localize(223,null)})),renderLineHighlight:Fe(new M(84,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",a.localize(224,null)],description:a.localize(225,null)})),renderLineHighlightOnlyWhenFocus:Fe(new C(85,"renderLineHighlightOnlyWhenFocus",!1,{description:a.localize(226,null)})),renderValidationDecorations:Fe(new M(86,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Fe(new M(87,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",a.localize(227,null),a.localize(228,null),a.localize(229,null),""],description:a.localize(230,null)})),revealHorizontalRightPadding:Fe(new h(88,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:Fe(new C(89,"roundedSelection",!0,{description:a.localize(231,null)})),rulers:Fe(new K),scrollbar:Fe(new ae),scrollBeyondLastColumn:Fe(new h(92,"scrollBeyondLastColumn",5,0,1073741824,{description:a.localize(232,null)})),scrollBeyondLastLine:Fe(new C(93,"scrollBeyondLastLine",!0,{description:a.localize(233,null)})),scrollPredominantAxis:Fe(new C(94,"scrollPredominantAxis",!0,{description:a.localize(234,null)})),selectionClipboard:Fe(new C(95,"selectionClipboard",!0,{description:a.localize(235,null),included:t.isLinux})),selectionHighlight:Fe(new C(96,"selectionHighlight",!0,{description:a.localize(236,null)})),selectOnLineNumbers:Fe(new C(97,"selectOnLineNumbers",!0)),showFoldingControls:Fe(new M(98,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[a.localize(237,null),a.localize(238,null)],description:a.localize(239,null)})),showUnused:Fe(new C(99,"showUnused",!0,{description:a.localize(240,null)})),showDeprecated:Fe(new C(125,"showDeprecated",!0,{description:a.localize(241,null)})),inlayHints:Fe(new ce),snippetSuggestions:Fe(new M(100,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[a.localize(242,null),a.localize(243,null),a.localize(244,null),a.localize(245,null)],description:a.localize(246,null)})),smartSelect:Fe(new Ye),smoothScrolling:Fe(new C(102,"smoothScrolling",!1,{description:a.localize(247,null)})),stopRenderingLineAfter:Fe(new h(104,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Fe(new He),inlineSuggest:Fe(new te),suggestFontSize:Fe(new h(106,"suggestFontSize",0,0,1e3,{markdownDescription:a.localize(248,null)})),suggestLineHeight:Fe(new h(107,"suggestLineHeight",0,0,1e3,{markdownDescription:a.localize(249,null)})),suggestOnTriggerCharacters:Fe(new C(108,"suggestOnTriggerCharacters",!0,{description:a.localize(250,null)})),suggestSelection:Fe(new M(109,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[a.localize(251,null),a.localize(252,null),a.localize(253,null)],description:a.localize(254,null)})),tabCompletion:Fe(new M(110,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[a.localize(255,null),a.localize(256,null),a.localize(257,null)],description:a.localize(258,null)})),tabIndex:Fe(new h(111,"tabIndex",0,-1,1073741824)),unicodeHighlight:Fe(new q),unusualLineTerminators:Fe(new M(113,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[a.localize(259,null),a.localize(260,null),a.localize(261,null)],description:a.localize(262,null)})),useShadowDOM:Fe(new C(114,"useShadowDOM",!0)),useTabStops:Fe(new C(115,"useTabStops",!0,{description:a.localize(263,null)})),wordSeparators:Fe(new P(116,"wordSeparators",w.USUAL_WORD_SEPARATORS,{description:a.localize(264,null)})),wordWrap:Fe(new M(117,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[a.localize(265,null),a.localize(266,null),a.localize(267,null),a.localize(268,null)],description:a.localize(269,null)})),wordWrapBreakAfterCharacters:Fe(new P(118,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Fe(new P(119,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Fe(new h(120,"wordWrapColumn",80,1,1073741824,{markdownDescription:a.localize(270,null)})),wordWrapOverride1:Fe(new M(121,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Fe(new M(122,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Fe(new r(123,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Je,{enumDescriptions:[a.localize(271,null),a.localize(272,null),a.localize(273,null),a.localize(274,null)],description:a.localize(275,null)})),wrappingStrategy:Fe(new M(124,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[a.localize(276,null),a.localize(277,null)],description:a.localize(278,null)})),editorClassName:Fe(new A),pixelRatio:Fe(new Be),tabFocusMode:Fe(new et),layoutInfo:Fe(new G),wrappingInfo:Fe(new nt)}}),define(Ee[115],ye([18,19]),function(re,e){return re.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ee[116],ye([18,19]),function(re,e){return re.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ee[117],ye([18,19]),function(re,e){return re.create("vs/platform/files/common/files",e)}),define(Ee[118],ye([18,19]),function(re,e){return re.create("vs/platform/markers/common/markers",e)}),define(Ee[119],ye([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ee[120],ye([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ee[121],ye([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostProgress",e)}),define(Ee[122],ye([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ee[123],ye([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ee[124],ye([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ee[125],ye([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ee[126],ye([18,19]),function(re,e){return re.create("vs/workbench/common/editor",e)}),define(Ee[127],ye([18,19]),function(re,e){return re.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ee[128],ye([18,19]),function(re,e){return re.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(Ee[129],ye([18,19]),function(re,e){return re.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(Ee[130],ye([18,19]),function(re,e){return re.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ee[131],ye([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var a;(function(k){k[k.ACTIVATE=1]="ACTIVATE",k[k.RESTORE=2]="RESTORE",k[k.PRESERVE=3]="PRESERVE"})(a=e.EditorActivation||(e.EditorActivation={}));var t;(function(k){k[k.PICK=0]="PICK",k[k.DISABLED=1]="DISABLED",k[k.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(t=e.EditorResolution||(e.EditorResolution={}));var w;(function(k){k[k.API=0]="API",k[k.USER=1]="USER"})(w=e.EditorOpenContext||(e.EditorOpenContext={}));var T;(function(k){k[k.Center=0]="Center",k[k.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",k[k.NearTop=2]="NearTop",k[k.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(T=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(Ee[132],ye([0,1,116]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const t=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,w=/^-(\d{4})(\d{2})(\d{2})$/;function T(n){return n=n.trim(),n==="*"||t.test(n)}e.isValidVersionStr=T;function k(n){if(!T(n))return null;if(n=n.trim(),n==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let f=n.match(t);return f?{hasCaret:f[1]==="^",hasGreaterEquals:f[1]===">=",majorBase:f[2]==="x"?0:parseInt(f[2],10),majorMustEqual:f[2]!=="x",minorBase:f[4]==="x"?0:parseInt(f[4],10),minorMustEqual:f[4]!=="x",patchBase:f[6]==="x"?0:parseInt(f[6],10),patchMustEqual:f[6]!=="x",preRelease:f[8]||null}:null}e.parseVersion=k;function I(n){if(!n)return null;let f=n.majorBase,o=n.majorMustEqual,m=n.minorBase,c=n.minorMustEqual,C=n.patchBase,b=n.patchMustEqual;n.hasCaret&&(f===0||(c=!1),b=!1);let h=0;if(n.preRelease){const g=w.exec(n.preRelease);if(g){const[,P,l,M]=g;h=Date.UTC(Number(P),Number(l)-1,Number(M))}}return{majorBase:f,majorMustEqual:o,minorBase:m,minorMustEqual:c,patchBase:C,patchMustEqual:b,isMinimum:n.hasGreaterEquals,notBefore:h}}e.normalizeVersion=I;function S(n,f,o){let m;typeof n=="string"?m=I(k(n)):m=n;let c;f instanceof Date?c=f.getTime():typeof f=="string"&&(c=new Date(f).getTime());let C;if(typeof o=="string"?C=I(k(o)):C=o,!m||!C)return!1;let b=m.majorBase,h=m.minorBase,g=m.patchBase,P=C.majorBase,l=C.minorBase,M=C.patchBase,r=C.notBefore,i=C.majorMustEqual,p=C.minorMustEqual,d=C.patchMustEqual;return C.isMinimum?b>P?!0:b<P?!1:h>l?!0:h<l||c&&c<r?!1:g>=M:(b===1&&P===0&&(!i||!p||!d)&&(P=1,l=0,M=0,i=!0,p=!1,d=!1),b<P?!1:b>P?!i:h<l?!1:h>l?!p:g<M?!1:g>M?!d:!(c&&c<r))}e.isValidVersion=S;function R(n,f,o,m){return o.isBuiltin||typeof o.main=="undefined"?!0:_(n,f,o.engines.vscode,m)}e.isValidExtensionVersion=R;function F(n,f,o){return n==="*"||_(f,o,n)}e.isEngineValid=F;function _(n,f,o,m=[]){let c=I(k(o));if(!c)return m.push(a.localize(0,null,o)),!1;if(c.majorBase===0){if(!c.majorMustEqual||!c.minorMustEqual)return m.push(a.localize(1,null,o)),!1}else if(!c.majorMustEqual)return m.push(a.localize(2,null,o)),!1;return S(n,f,c)?!0:(m.push(a.localize(3,null,n,o)),!1)}}),define(Ee[80],ye([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class a{constructor(w,T=[],k=!1){this.ctor=w,this.staticArguments=T,this.supportsDelayedInstantiation=k}}e.SyncDescriptor=a}),define(Ee[56],ye([0,1,80]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const t=[];function w(k,I,S){I instanceof a.SyncDescriptor||(I=new a.SyncDescriptor(I,[],S)),t.push([k,I])}e.registerSingleton=w;function T(){return t}e.getSingletonServiceDescriptors=T}),define(Ee[133],ye([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class a{constructor(T){this.incoming=new Map,this.outgoing=new Map,this.data=T}}e.Node=a;class t{constructor(T){this._hashFn=T,this._nodes=new Map}roots(){const T=[];for(let k of this._nodes.values())k.outgoing.size===0&&T.push(k);return T}insertEdge(T,k){const I=this.lookupOrInsertNode(T),S=this.lookupOrInsertNode(k);I.outgoing.set(this._hashFn(k),S),S.incoming.set(this._hashFn(T),I)}removeNode(T){const k=this._hashFn(T);this._nodes.delete(k);for(let I of this._nodes.values())I.outgoing.delete(k),I.incoming.delete(k)}lookupOrInsertNode(T){const k=this._hashFn(T);let I=this._nodes.get(k);return I||(I=new a(T),this._nodes.set(k,I)),I}lookup(T){return this._nodes.get(this._hashFn(T))}isEmpty(){return this._nodes.size===0}toString(){let T=[];for(let[k,I]of this._nodes)T.push(`${k}, (incoming)[${[...I.incoming.keys()].join(", ")}], (outgoing)[${[...I.outgoing.keys()].join(",")}]`);return T.join(`
`)}findCycleSlow(){for(let[T,k]of this._nodes){const I=new Set([T]),S=this._findCycle(k,I);if(S)return S}}_findCycle(T,k){for(let[I,S]of T.outgoing){if(k.has(I))return[...k,I].join(" -> ");k.add(I);const R=this._findCycle(S,k);if(R)return R;k.delete(I)}}}e.Graph=t}),define(Ee[3],ye([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var a;(function(k){k.serviceIds=new Map,k.DI_TARGET="$di$target",k.DI_DEPENDENCIES="$di$dependencies";function I(S){return S[k.DI_DEPENDENCIES]||[]}k.getServiceDependencies=I})(a=e._util||(e._util={})),e.IInstantiationService=w("instantiationService");function t(k,I,S,R){I[a.DI_TARGET]===I?I[a.DI_DEPENDENCIES].push({id:k,index:S,optional:R}):(I[a.DI_DEPENDENCIES]=[{id:k,index:S,optional:R}],I[a.DI_TARGET]=I)}function w(k){if(a.serviceIds.has(k))return a.serviceIds.get(k);const I=function(S,R,F){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(I,S,F,!1)};return I.toString=()=>k,a.serviceIds.set(k,I),I}e.createDecorator=w;function T(k){return k}e.refineServiceDecorator=T}),define(Ee[134],ye([0,1,3]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,a.createDecorator)("modelService");function t(w){return!w.isTooLargeForSyncing()&&!w.isForSimpleWidget}e.shouldSynchronizeModel=t}),define(Ee[135],ye([0,1,4,57,6,21,75,55,134]),function(re,e,a,t,w,T,k,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function R(m){return typeof m=="string"?!1:Array.isArray(m)?m.every(R):!!m.exclusive}class F{constructor(){this._clock=0,this._entries=[],this._onDidChange=new a.Emitter}get onDidChange(){return this._onDidChange.event}register(c,C){let b={selector:c,provider:C,_score:-1,_time:this._clock++};return this._entries.push(b),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,w.toDisposable)(()=>{if(b){let h=this._entries.indexOf(b);h>=0&&(this._entries.splice(h,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),b=void 0)}})}has(c){return this.all(c).length>0}all(c){if(!c)return[];this._updateScores(c);const C=[];for(let b of this._entries)b._score>0&&C.push(b.provider);return C}ordered(c){const C=[];return this._orderedForEach(c,b=>C.push(b.provider)),C}orderedGroups(c){const C=[];let b,h;return this._orderedForEach(c,g=>{b&&h===g._score?b.push(g.provider):(h=g._score,b=[g.provider],C.push(b))}),C}_orderedForEach(c,C){if(!!c){this._updateScores(c);for(const b of this._entries)b._score>0&&C(b)}}_updateScores(c){let C={uri:c.uri.toString(),language:c.getLanguageId()};if(!(this._lastCandidate&&this._lastCandidate.language===C.language&&this._lastCandidate.uri===C.uri)){this._lastCandidate=C;for(let b of this._entries)if(b._score=(0,I.score)(b.selector,c.uri,c.getLanguageId(),(0,S.shouldSynchronizeModel)(c)),R(b.selector)&&b._score>0){for(let h of this._entries)h._score=0;b._score=1e3;break}this._entries.sort(F._compareByScoreAndTime)}}static _compareByScoreAndTime(c,C){return c._score<C._score?1:c._score>C._score?-1:c._time<C._time?1:c._time>C._time?-1:0}}e.LanguageFeatureRegistry=F;const _=new WeakMap;let n=0;function f(m){let c=_.get(m);return c===void 0&&(c=++n,_.set(m,c)),c}class o{constructor(c,C,b=Number.MAX_SAFE_INTEGER){this._registry=c,this.min=C,this.max=b,this._cache=new T.LRUCache(50,.7)}_key(c){return c.id+this._registry.all(c).reduce((C,b)=>(0,t.doHash)(f(b),C),0)}_clamp(c){return c===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(c*1.3)))}get(c){const C=this._key(c),b=this._cache.get(C);return this._clamp(b?.value)}update(c,C){const b=this._key(c);let h=this._cache.get(b);return h||(h=new k.MovingAverage,this._cache.set(b,h)),h.update(C),this.get(c)}}e.LanguageFeatureRequestDelays=o}),define(Ee[58],ye([0,1,2,59,135,108,51]),function(re,e,a,t,w,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var I;(function(u){u[u.Null=0]="Null",u[u.PlainText=1]="PlainText"})(I=e.LanguageId||(e.LanguageId={}));var S;(function(u){u[u.NotSet=-1]="NotSet",u[u.None=0]="None",u[u.Italic=1]="Italic",u[u.Bold=2]="Bold",u[u.Underline=4]="Underline"})(S=e.FontStyle||(e.FontStyle={}));var R;(function(u){u[u.None=0]="None",u[u.DefaultForeground=1]="DefaultForeground",u[u.DefaultBackground=2]="DefaultBackground"})(R=e.ColorId||(e.ColorId={}));var F;(function(u){u[u.Other=0]="Other",u[u.Comment=1]="Comment",u[u.String=2]="String",u[u.RegEx=4]="RegEx"})(F=e.StandardTokenType||(e.StandardTokenType={}));var _;(function(u){u[u.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",u[u.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",u[u.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",u[u.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",u[u.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",u[u.ITALIC_MASK=2048]="ITALIC_MASK",u[u.BOLD_MASK=4096]="BOLD_MASK",u[u.UNDERLINE_MASK=8192]="UNDERLINE_MASK",u[u.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",u[u.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",u[u.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",u[u.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",u[u.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",u[u.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",u[u.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",u[u.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",u[u.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",u[u.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(_=e.MetadataConsts||(e.MetadataConsts={}));class n{static getLanguageId(D){return(D&255)>>>0}static getTokenType(D){return(D&1792)>>>8}static getFontStyle(D){return(D&14336)>>>11}static getForeground(D){return(D&8372224)>>>14}static getBackground(D){return(D&4286578688)>>>23}static getClassNameFromMetadata(D){let A=this.getForeground(D),U="mtk"+A,B=this.getFontStyle(D);return B&1&&(U+=" mtki"),B&2&&(U+=" mtkb"),B&4&&(U+=" mtku"),U}static getInlineStyleFromMetadata(D,A){const U=this.getForeground(D),B=this.getFontStyle(D);let E=`color: ${A[U]};`;return B&1&&(E+="font-style: italic;"),B&2&&(E+="font-weight: bold;"),B&4&&(E+="text-decoration: underline;"),E}}e.TokenMetadata=n;var f;(function(u){u[u.Method=0]="Method",u[u.Function=1]="Function",u[u.Constructor=2]="Constructor",u[u.Field=3]="Field",u[u.Variable=4]="Variable",u[u.Class=5]="Class",u[u.Struct=6]="Struct",u[u.Interface=7]="Interface",u[u.Module=8]="Module",u[u.Property=9]="Property",u[u.Event=10]="Event",u[u.Operator=11]="Operator",u[u.Unit=12]="Unit",u[u.Value=13]="Value",u[u.Constant=14]="Constant",u[u.Enum=15]="Enum",u[u.EnumMember=16]="EnumMember",u[u.Keyword=17]="Keyword",u[u.Text=18]="Text",u[u.Color=19]="Color",u[u.File=20]="File",u[u.Reference=21]="Reference",u[u.Customcolor=22]="Customcolor",u[u.Folder=23]="Folder",u[u.TypeParameter=24]="TypeParameter",u[u.User=25]="User",u[u.Issue=26]="Issue",u[u.Snippet=27]="Snippet"})(f=e.CompletionItemKind||(e.CompletionItemKind={}));var o;(function(u){const D=new Map;D.set(0,k.Codicon.symbolMethod),D.set(1,k.Codicon.symbolFunction),D.set(2,k.Codicon.symbolConstructor),D.set(3,k.Codicon.symbolField),D.set(4,k.Codicon.symbolVariable),D.set(5,k.Codicon.symbolClass),D.set(6,k.Codicon.symbolStruct),D.set(7,k.Codicon.symbolInterface),D.set(8,k.Codicon.symbolModule),D.set(9,k.Codicon.symbolProperty),D.set(10,k.Codicon.symbolEvent),D.set(11,k.Codicon.symbolOperator),D.set(12,k.Codicon.symbolUnit),D.set(13,k.Codicon.symbolValue),D.set(15,k.Codicon.symbolEnum),D.set(14,k.Codicon.symbolConstant),D.set(15,k.Codicon.symbolEnum),D.set(16,k.Codicon.symbolEnumMember),D.set(17,k.Codicon.symbolKeyword),D.set(27,k.Codicon.symbolSnippet),D.set(18,k.Codicon.symbolText),D.set(19,k.Codicon.symbolColor),D.set(20,k.Codicon.symbolFile),D.set(21,k.Codicon.symbolReference),D.set(22,k.Codicon.symbolCustomColor),D.set(23,k.Codicon.symbolFolder),D.set(24,k.Codicon.symbolTypeParameter),D.set(25,k.Codicon.account),D.set(26,k.Codicon.issues);function A(E){let N=D.get(E);return N||(console.info("No codicon found for CompletionItemKind "+E),N=k.Codicon.symbolProperty),N}u.toIcon=A;const U=new Map;U.set("method",0),U.set("function",1),U.set("constructor",2),U.set("field",3),U.set("variable",4),U.set("class",5),U.set("struct",6),U.set("interface",7),U.set("module",8),U.set("property",9),U.set("event",10),U.set("operator",11),U.set("unit",12),U.set("value",13),U.set("constant",14),U.set("enum",15),U.set("enum-member",16),U.set("enumMember",16),U.set("keyword",17),U.set("snippet",27),U.set("text",18),U.set("color",19),U.set("file",20),U.set("reference",21),U.set("customcolor",22),U.set("folder",23),U.set("type-parameter",24),U.set("typeParameter",24),U.set("account",25),U.set("issue",26);function B(E,N){let L=U.get(E);return typeof L=="undefined"&&!N&&(L=9),L}u.fromString=B})(o=e.CompletionItemKinds||(e.CompletionItemKinds={}));var m;(function(u){u[u.Deprecated=1]="Deprecated"})(m=e.CompletionItemTag||(e.CompletionItemTag={}));var c;(function(u){u[u.KeepWhitespace=1]="KeepWhitespace",u[u.InsertAsSnippet=4]="InsertAsSnippet"})(c=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var C;(function(u){u[u.Invoke=0]="Invoke",u[u.TriggerCharacter=1]="TriggerCharacter",u[u.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(C=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var b;(function(u){u[u.Automatic=0]="Automatic",u[u.Explicit=1]="Explicit"})(b=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var h;(function(u){u[u.Invoke=1]="Invoke",u[u.Auto=2]="Auto"})(h=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var g;(function(u){u[u.Invoke=1]="Invoke",u[u.TriggerCharacter=2]="TriggerCharacter",u[u.ContentChange=3]="ContentChange"})(g=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var P;(function(u){u[u.Text=0]="Text",u[u.Read=1]="Read",u[u.Write=2]="Write"})(P=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function l(u){return u&&a.URI.isUri(u.uri)&&t.Range.isIRange(u.range)&&(t.Range.isIRange(u.originSelectionRange)||t.Range.isIRange(u.targetSelectionRange))}e.isLocationLink=l;var M;(function(u){u[u.File=0]="File",u[u.Module=1]="Module",u[u.Namespace=2]="Namespace",u[u.Package=3]="Package",u[u.Class=4]="Class",u[u.Method=5]="Method",u[u.Property=6]="Property",u[u.Field=7]="Field",u[u.Constructor=8]="Constructor",u[u.Enum=9]="Enum",u[u.Interface=10]="Interface",u[u.Function=11]="Function",u[u.Variable=12]="Variable",u[u.Constant=13]="Constant",u[u.String=14]="String",u[u.Number=15]="Number",u[u.Boolean=16]="Boolean",u[u.Array=17]="Array",u[u.Object=18]="Object",u[u.Key=19]="Key",u[u.Null=20]="Null",u[u.EnumMember=21]="EnumMember",u[u.Struct=22]="Struct",u[u.Event=23]="Event",u[u.Operator=24]="Operator",u[u.TypeParameter=25]="TypeParameter"})(M=e.SymbolKind||(e.SymbolKind={}));var r;(function(u){u[u.Deprecated=1]="Deprecated"})(r=e.SymbolTag||(e.SymbolTag={}));var i;(function(u){const D=new Map;D.set(0,k.Codicon.symbolFile),D.set(1,k.Codicon.symbolModule),D.set(2,k.Codicon.symbolNamespace),D.set(3,k.Codicon.symbolPackage),D.set(4,k.Codicon.symbolClass),D.set(5,k.Codicon.symbolMethod),D.set(6,k.Codicon.symbolProperty),D.set(7,k.Codicon.symbolField),D.set(8,k.Codicon.symbolConstructor),D.set(9,k.Codicon.symbolEnum),D.set(10,k.Codicon.symbolInterface),D.set(11,k.Codicon.symbolFunction),D.set(12,k.Codicon.symbolVariable),D.set(13,k.Codicon.symbolConstant),D.set(14,k.Codicon.symbolString),D.set(15,k.Codicon.symbolNumber),D.set(16,k.Codicon.symbolBoolean),D.set(17,k.Codicon.symbolArray),D.set(18,k.Codicon.symbolObject),D.set(19,k.Codicon.symbolKey),D.set(20,k.Codicon.symbolNull),D.set(21,k.Codicon.symbolEnumMember),D.set(22,k.Codicon.symbolStruct),D.set(23,k.Codicon.symbolEvent),D.set(24,k.Codicon.symbolOperator),D.set(25,k.Codicon.symbolTypeParameter);function A(U){let B=D.get(U);return B||(console.info("No codicon found for SymbolKind "+U),B=k.Codicon.symbolProperty),B}u.toIcon=A})(i=e.SymbolKinds||(e.SymbolKinds={}));class p{constructor(D){this.value=D}}e.FoldingRangeKind=p,p.Comment=new p("comment"),p.Imports=new p("imports"),p.Region=new p("region");var d;(function(u){u[u.Collapsed=0]="Collapsed",u[u.Expanded=1]="Expanded"})(d=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var s;(function(u){u[u.Editing=0]="Editing",u[u.Preview=1]="Preview"})(s=e.CommentMode||(e.CommentMode={}));var v;(function(u){u[u.Other=0]="Other",u[u.Type=1]="Type",u[u.Parameter=2]="Parameter"})(v=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new w.LanguageFeatureRegistry,e.RenameProviderRegistry=new w.LanguageFeatureRegistry,e.CompletionProviderRegistry=new w.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new w.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new w.LanguageFeatureRegistry,e.HoverProviderRegistry=new w.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new w.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new w.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new w.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new w.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new w.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new w.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new w.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new w.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new w.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new w.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new w.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new w.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new w.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new w.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new w.LanguageFeatureRegistry,e.LinkProviderRegistry=new w.LanguageFeatureRegistry,e.ColorProviderRegistry=new w.LanguageFeatureRegistry,e.SelectionRangeRegistry=new w.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new w.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new w.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new w.LanguageFeatureRegistry,e.TokenizationRegistry=new T.TokenizationRegistryImpl;var y;(function(u){u[u.None=0]="None",u[u.Option=1]="Option",u[u.Default=2]="Default",u[u.Preferred=3]="Preferred"})(y=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(Ee[81],ye([0,1,11,2,3]),function(re,e,a,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,w.createDecorator)("configurationService");function T(c){return c&&typeof c=="object"&&(!c.overrideIdentifier||typeof c.overrideIdentifier=="string")&&(!c.resource||c.resource instanceof t.URI)}e.isConfigurationOverrides=T;function k(c){return c&&typeof c=="object"&&(!c.overrideIdentifiers||a.isArray(c.overrideIdentifiers))&&!c.overrideIdentifier&&(!c.resource||c.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=k;var I;(function(c){c[c.USER=1]="USER",c[c.USER_LOCAL=2]="USER_LOCAL",c[c.USER_REMOTE=3]="USER_REMOTE",c[c.WORKSPACE=4]="WORKSPACE",c[c.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",c[c.DEFAULT=6]="DEFAULT",c[c.MEMORY=7]="MEMORY"})(I=e.ConfigurationTarget||(e.ConfigurationTarget={}));function S(c){switch(c){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=S;function R(c,C){const b=Object.create(null);for(let h in c)F(b,h,c[h],C);return b}e.toValuesTree=R;function F(c,C,b,h){const g=C.split("."),P=g.pop();let l=c;for(let M=0;M<g.length;M++){let r=g[M],i=l[r];switch(typeof i){case"undefined":i=l[r]=Object.create(null);break;case"object":break;default:h(`Ignoring ${C} as ${g.slice(0,M+1).join(".")} is ${JSON.stringify(i)}`);return}l=i}if(typeof l=="object"&&l!==null)try{l[P]=b}catch{h(`Ignoring ${C} as ${g.join(".")} is ${JSON.stringify(l)}`)}else h(`Ignoring ${C} as ${g.join(".")} is ${JSON.stringify(l)}`)}e.addToValueTree=F;function _(c,C){const b=C.split(".");n(c,b)}e.removeFromValueTree=_;function n(c,C){const b=C.shift();if(C.length===0){delete c[b];return}if(Object.keys(c).indexOf(b)!==-1){const h=c[b];typeof h=="object"&&!Array.isArray(h)&&(n(h,C),Object.keys(h).length===0&&delete c[b])}}function f(c,C,b){function h(l,M){let r=l;for(const i of M){if(typeof r!="object"||r===null)return;r=r[i]}return r}const g=C.split("."),P=h(c,g);return typeof P=="undefined"?b:P}e.getConfigurationValue=f;function o(c,C,b){Object.keys(C).forEach(h=>{h!=="__proto__"&&(h in c?a.isObject(c[h])&&a.isObject(C[h])?o(c[h],C[h],b):b&&(c[h]=C[h]):c[h]=C[h])})}e.merge=o;function m(c,C,b){const h=c.inspect(C),g=c.inspect(b);return typeof h.userValue!="undefined"||typeof h.workspaceValue!="undefined"||typeof h.workspaceFolderValue!="undefined"?h.value:typeof g.userValue!="undefined"||typeof g.workspaceValue!="undefined"||typeof g.workspaceFolderValue!="undefined"?g.value:h.defaultValue}e.getMigratedSettingValue=m}),define(Ee[44],ye([0,1,23,9,3]),function(re,e,a,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let T=a.userAgent||"";const k=new Map;k.set("false",!1),k.set("true",!0),k.set("isMac",a.isMacintosh),k.set("isLinux",a.isLinux),k.set("isWindows",a.isWindows),k.set("isWeb",a.isWeb),k.set("isMacNative",a.isMacintosh&&!a.isWeb),k.set("isEdge",T.indexOf("Edg/")>=0),k.set("isFirefox",T.indexOf("Firefox")>=0),k.set("isChrome",T.indexOf("Chrome")>=0),k.set("isSafari",T.indexOf("Safari")>=0);const I=Object.prototype.hasOwnProperty;var S;(function(B){B[B.False=0]="False",B[B.True=1]="True",B[B.Defined=2]="Defined",B[B.Not=3]="Not",B[B.Equals=4]="Equals",B[B.NotEquals=5]="NotEquals",B[B.And=6]="And",B[B.Regex=7]="Regex",B[B.NotRegex=8]="NotRegex",B[B.Or=9]="Or",B[B.In=10]="In",B[B.NotIn=11]="NotIn",B[B.Greater=12]="Greater",B[B.GreaterEquals=13]="GreaterEquals",B[B.Smaller=14]="Smaller",B[B.SmallerEquals=15]="SmallerEquals"})(S=e.ContextKeyExprType||(e.ContextKeyExprType={}));class R{static false(){return n.INSTANCE}static true(){return f.INSTANCE}static has(E){return o.create(E)}static equals(E,N){return m.create(E,N)}static notEquals(E,N){return b.create(E,N)}static regex(E,N){return i.create(E,N)}static in(E,N){return c.create(E,N)}static not(E){return h.create(E)}static and(...E){return s.create(E,null)}static or(...E){return v.create(E,null,!0)}static greater(E,N){return P.create(E,N)}static greaterEquals(E,N){return l.create(E,N)}static smaller(E,N){return M.create(E,N)}static smallerEquals(E,N){return r.create(E,N)}static deserialize(E,N=!1){if(!!E)return this._deserializeOrExpression(E,N)}static _deserializeOrExpression(E,N){let L=E.split("||");return v.create(L.map(z=>this._deserializeAndExpression(z,N)),null,!0)}static _deserializeAndExpression(E,N){let L=E.split("&&");return s.create(L.map(z=>this._deserializeOne(z,N)),null)}static _deserializeOne(E,N){if(E=E.trim(),E.indexOf("!=")>=0){let L=E.split("!=");return b.create(L[0].trim(),this._deserializeValue(L[1],N))}if(E.indexOf("==")>=0){let L=E.split("==");return m.create(L[0].trim(),this._deserializeValue(L[1],N))}if(E.indexOf("=~")>=0){let L=E.split("=~");return i.create(L[0].trim(),this._deserializeRegexValue(L[1],N))}if(E.indexOf(" in ")>=0){let L=E.split(" in ");return c.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(E)){const L=E.split(">=");return l.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(E)){const L=E.split(">");return P.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(E)){const L=E.split("<=");return r.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(E)){const L=E.split("<");return M.create(L[0].trim(),L[1].trim())}return/^\!\s*/.test(E)?h.create(E.substr(1).trim()):o.create(E)}static _deserializeValue(E,N){if(E=E.trim(),E==="true")return!0;if(E==="false")return!1;let L=/^'([^']*)'$/.exec(E);return L?L[1].trim():E}static _deserializeRegexValue(E,N){if((0,t.isFalsyOrWhitespace)(E)){if(N)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let L=E.indexOf("/"),z=E.lastIndexOf("/");if(L===z||L<0){if(N)throw new Error(`bad regexp-value '${E}', missing /-enclosure`);return console.warn(`bad regexp-value '${E}', missing /-enclosure`),null}let H=E.slice(L+1,z),j=E[z+1]==="i"?"i":"";try{return new RegExp(H,j)}catch(ue){if(N)throw new Error(`bad regexp-value '${E}', parse error: ${ue}`);return console.warn(`bad regexp-value '${E}', parse error: ${ue}`),null}}}e.ContextKeyExpr=R;function F(B,E){const N=B?B.substituteConstants():void 0,L=E?E.substituteConstants():void 0;return!N&&!L?!0:!N||!L?!1:N.equals(L)}e.expressionsAreEqualWithConstantSubstitution=F;function _(B,E){return B.cmp(E)}class n{constructor(){this.type=0}cmp(E){return this.type-E.type}equals(E){return E.type===this.type}substituteConstants(){return this}evaluate(E){return!1}serialize(){return"false"}keys(){return[]}map(E){return this}negate(){return f.INSTANCE}}e.ContextKeyFalseExpr=n,n.INSTANCE=new n;class f{constructor(){this.type=1}cmp(E){return this.type-E.type}equals(E){return E.type===this.type}substituteConstants(){return this}evaluate(E){return!0}serialize(){return"true"}keys(){return[]}map(E){return this}negate(){return n.INSTANCE}}e.ContextKeyTrueExpr=f,f.INSTANCE=new f;class o{constructor(E,N){this.key=E,this.negated=N,this.type=2}static create(E,N=null){const L=k.get(E);return typeof L=="boolean"?L?f.INSTANCE:n.INSTANCE:new o(E,N)}cmp(E){return E.type!==this.type?this.type-E.type:u(this.key,E.key)}equals(E){return E.type===this.type?this.key===E.key:!1}substituteConstants(){const E=k.get(this.key);return typeof E=="boolean"?E?f.INSTANCE:n.INSTANCE:this}evaluate(E){return!!E.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(E){return E.mapDefined(this.key)}negate(){return this.negated||(this.negated=h.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=o;class m{constructor(E,N,L){this.key=E,this.value=N,this.negated=L,this.type=4}static create(E,N,L=null){if(typeof N=="boolean")return N?o.create(E,L):h.create(E,L);const z=k.get(E);return typeof z=="boolean"?N===(z?"true":"false")?f.INSTANCE:n.INSTANCE:new m(E,N,L)}cmp(E){return E.type!==this.type?this.type-E.type:D(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}substituteConstants(){const E=k.get(this.key);if(typeof E=="boolean"){const N=E?"true":"false";return this.value===N?f.INSTANCE:n.INSTANCE}return this}evaluate(E){return E.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(E){return E.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=b.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=m;class c{constructor(E,N){this.key=E,this.valueKey=N,this.type=10,this.negated=null}static create(E,N){return new c(E,N)}cmp(E){return E.type!==this.type?this.type-E.type:D(this.key,this.valueKey,E.key,E.valueKey)}equals(E){return E.type===this.type?this.key===E.key&&this.valueKey===E.valueKey:!1}substituteConstants(){return this}evaluate(E){const N=E.getValue(this.valueKey),L=E.getValue(this.key);return Array.isArray(N)?N.indexOf(L)>=0:typeof L=="string"&&typeof N=="object"&&N!==null?I.call(N,L):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(E){return E.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=C.create(this)),this.negated}}e.ContextKeyInExpr=c;class C{constructor(E){this._actual=E,this.type=11}static create(E){return new C(E)}cmp(E){return E.type!==this.type?this.type-E.type:this._actual.cmp(E._actual)}equals(E){return E.type===this.type?this._actual.equals(E._actual):!1}substituteConstants(){return this}evaluate(E){return!this._actual.evaluate(E)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(E){return new C(this._actual.map(E))}negate(){return this._actual}}e.ContextKeyNotInExpr=C;class b{constructor(E,N,L){this.key=E,this.value=N,this.negated=L,this.type=5}static create(E,N,L=null){if(typeof N=="boolean")return N?h.create(E,L):o.create(E,L);const z=k.get(E);return typeof z=="boolean"?N===(z?"true":"false")?n.INSTANCE:f.INSTANCE:new b(E,N,L)}cmp(E){return E.type!==this.type?this.type-E.type:D(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}substituteConstants(){const E=k.get(this.key);if(typeof E=="boolean"){const N=E?"true":"false";return this.value===N?n.INSTANCE:f.INSTANCE}return this}evaluate(E){return E.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(E){return E.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=m.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=b;class h{constructor(E,N){this.key=E,this.negated=N,this.type=3}static create(E,N=null){const L=k.get(E);return typeof L=="boolean"?L?n.INSTANCE:f.INSTANCE:new h(E,N)}cmp(E){return E.type!==this.type?this.type-E.type:u(this.key,E.key)}equals(E){return E.type===this.type?this.key===E.key:!1}substituteConstants(){const E=k.get(this.key);return typeof E=="boolean"?E?n.INSTANCE:f.INSTANCE:this}evaluate(E){return!E.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(E){return E.mapNot(this.key)}negate(){return this.negated||(this.negated=o.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=h;function g(B,E){if(typeof B=="string"){const N=parseFloat(B);isNaN(N)||(B=N)}return typeof B=="string"||typeof B=="number"?E(B):n.INSTANCE}class P{constructor(E,N,L){this.key=E,this.value=N,this.negated=L,this.type=12}static create(E,N,L=null){return g(N,z=>new P(E,z,L))}cmp(E){return E.type!==this.type?this.type-E.type:D(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}substituteConstants(){return this}evaluate(E){return typeof this.value=="string"?!1:parseFloat(E.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(E){return E.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=r.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=P;class l{constructor(E,N,L){this.key=E,this.value=N,this.negated=L,this.type=13}static create(E,N,L=null){return g(N,z=>new l(E,z,L))}cmp(E){return E.type!==this.type?this.type-E.type:D(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}substituteConstants(){return this}evaluate(E){return typeof this.value=="string"?!1:parseFloat(E.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(E){return E.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=M.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=l;class M{constructor(E,N,L){this.key=E,this.value=N,this.negated=L,this.type=14}static create(E,N,L=null){return g(N,z=>new M(E,z,L))}cmp(E){return E.type!==this.type?this.type-E.type:D(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}substituteConstants(){return this}evaluate(E){return typeof this.value=="string"?!1:parseFloat(E.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(E){return E.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=l.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=M;class r{constructor(E,N,L){this.key=E,this.value=N,this.negated=L,this.type=15}static create(E,N,L=null){return g(N,z=>new r(E,z,L))}cmp(E){return E.type!==this.type?this.type-E.type:D(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}substituteConstants(){return this}evaluate(E){return typeof this.value=="string"?!1:parseFloat(E.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(E){return E.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=P.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=r;class i{constructor(E,N){this.key=E,this.regexp=N,this.type=7,this.negated=null}static create(E,N){return new i(E,N)}cmp(E){if(E.type!==this.type)return this.type-E.type;if(this.key<E.key)return-1;if(this.key>E.key)return 1;const N=this.regexp?this.regexp.source:"",L=E.regexp?E.regexp.source:"";return N<L?-1:N>L?1:0}equals(E){if(E.type===this.type){const N=this.regexp?this.regexp.source:"",L=E.regexp?E.regexp.source:"";return this.key===E.key&&N===L}return!1}substituteConstants(){return this}evaluate(E){let N=E.getValue(this.key);return this.regexp?this.regexp.test(N):!1}serialize(){const E=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${E}`}keys(){return[this.key]}map(E){return E.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=p.create(this)),this.negated}}e.ContextKeyRegexExpr=i;class p{constructor(E){this._actual=E,this.type=8}static create(E){return new p(E)}cmp(E){return E.type!==this.type?this.type-E.type:this._actual.cmp(E._actual)}equals(E){return E.type===this.type?this._actual.equals(E._actual):!1}substituteConstants(){return this}evaluate(E){return!this._actual.evaluate(E)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(E){return new p(this._actual.map(E))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=p;function d(B){let E=null;for(let N=0,L=B.length;N<L;N++){const z=B[N].substituteConstants();if(B[N]!==z&&E===null){E=[];for(let H=0;H<N;H++)E[H]=B[H]}E!==null&&(E[N]=z)}return E===null?B:E}class s{constructor(E,N){this.expr=E,this.negated=N,this.type=6}static create(E,N){return s._normalizeArr(E,N)}cmp(E){if(E.type!==this.type)return this.type-E.type;if(this.expr.length<E.expr.length)return-1;if(this.expr.length>E.expr.length)return 1;for(let N=0,L=this.expr.length;N<L;N++){const z=_(this.expr[N],E.expr[N]);if(z!==0)return z}return 0}equals(E){if(E.type===this.type){if(this.expr.length!==E.expr.length)return!1;for(let N=0,L=this.expr.length;N<L;N++)if(!this.expr[N].equals(E.expr[N]))return!1;return!0}return!1}substituteConstants(){const E=d(this.expr);return E===this.expr?this:s.create(E,this.negated)}evaluate(E){for(let N=0,L=this.expr.length;N<L;N++)if(!this.expr[N].evaluate(E))return!1;return!0}static _normalizeArr(E,N){const L=[];let z=!1;for(const H of E)if(!!H){if(H.type===1){z=!0;continue}if(H.type===0)return n.INSTANCE;if(H.type===6){L.push(...H.expr);continue}L.push(H)}if(L.length===0&&z)return f.INSTANCE;if(L.length!==0){if(L.length===1)return L[0];L.sort(_);for(let H=1;H<L.length;H++)L[H-1].equals(L[H])&&(L.splice(H,1),H--);if(L.length===1)return L[0];for(;L.length>1;){const H=L[L.length-1];if(H.type!==9)break;L.pop();const j=L.pop(),ue=L.length===0,G=v.create(H.expr.map(le=>s.create([le,j],null)),null,ue);G&&(L.push(G),L.sort(_))}return L.length===1?L[0]:new s(L,N)}}serialize(){return this.expr.map(E=>E.serialize()).join(" && ")}keys(){const E=[];for(let N of this.expr)E.push(...N.keys());return E}map(E){return new s(this.expr.map(N=>N.map(E)),null)}negate(){if(!this.negated){const E=[];for(let N of this.expr)E.push(N.negate());this.negated=v.create(E,this,!0)}return this.negated}}class v{constructor(E,N){this.expr=E,this.negated=N,this.type=9}static create(E,N,L){return v._normalizeArr(E,N,L)}cmp(E){if(E.type!==this.type)return this.type-E.type;if(this.expr.length<E.expr.length)return-1;if(this.expr.length>E.expr.length)return 1;for(let N=0,L=this.expr.length;N<L;N++){const z=_(this.expr[N],E.expr[N]);if(z!==0)return z}return 0}equals(E){if(E.type===this.type){if(this.expr.length!==E.expr.length)return!1;for(let N=0,L=this.expr.length;N<L;N++)if(!this.expr[N].equals(E.expr[N]))return!1;return!0}return!1}substituteConstants(){const E=d(this.expr);return E===this.expr?this:v.create(E,this.negated,!1)}evaluate(E){for(let N=0,L=this.expr.length;N<L;N++)if(this.expr[N].evaluate(E))return!0;return!1}static _normalizeArr(E,N,L){let z=[],H=!1;if(E){for(let j=0,ue=E.length;j<ue;j++){const G=E[j];if(!!G){if(G.type===0){H=!0;continue}if(G.type===1)return f.INSTANCE;if(G.type===9){z=z.concat(G.expr);continue}z.push(G)}}if(z.length===0&&H)return n.INSTANCE;z.sort(_)}if(z.length!==0){if(z.length===1)return z[0];for(let j=1;j<z.length;j++)z[j-1].equals(z[j])&&(z.splice(j,1),j--);if(z.length===1)return z[0];if(L){for(let j=0;j<z.length;j++)for(let ue=j+1;ue<z.length;ue++)A(z[j],z[ue])&&(z.splice(ue,1),ue--);if(z.length===1)return z[0]}return new v(z,N)}}serialize(){return this.expr.map(E=>E.serialize()).join(" || ")}keys(){const E=[];for(let N of this.expr)E.push(...N.keys());return E}map(E){return new v(this.expr.map(N=>N.map(E)),null)}negate(){if(!this.negated){let E=[];for(let N of this.expr)E.push(N.negate());for(;E.length>1;){const N=E.shift(),L=E.shift(),z=[];for(const j of U(N))for(const ue of U(L))z.push(s.create([j,ue],null));const H=E.length===0;E.unshift(v.create(z,null,H))}this.negated=E[0]}return this.negated}}class y extends o{constructor(E,N,L){super(E,null);this._defaultValue=N,typeof L=="object"?y._info.push({...L,key:E}):L!==!0&&y._info.push({key:E,description:L,type:N!=null?typeof N:void 0})}static all(){return y._info.values()}bindTo(E){return E.createKey(this.key,this._defaultValue)}getValue(E){return E.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(E){return m.create(this.key,E)}notEqualsTo(E){return b.create(this.key,E)}}e.RawContextKey=y,y._info=[],e.IContextKeyService=(0,w.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function u(B,E){return B<E?-1:B>E?1:0}function D(B,E,N,L){return B<N?-1:B>N?1:E<L?-1:E>L?1:0}function A(B,E){if(E.type===6&&B.type!==9&&B.type!==6){for(const z of E.expr)if(B.equals(z))return!0}const N=B.negate(),L=U(N).concat(U(E));L.sort(_);for(let z=0;z<L.length;z++){const j=L[z].negate();for(let ue=z+1;ue<L.length;ue++){const G=L[ue];if(j.equals(G))return!0}}return!1}e.implies=A;function U(B){return B.type===9?B.expr:[B]}}),define(Ee[136],ye([0,1,3]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,a.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,a.refineServiceDecorator)(e.IEnvironmentService)}),define(Ee[45],ye([0,1,21,17,9,11,2,117,3]),function(re,e,a,t,w,T,k,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,S.createDecorator)("fileService");function R(L){return L.create===!0}e.isFileOpenForWriteOptions=R;var F;(function(L){L[L.Unknown=0]="Unknown",L[L.File=1]="File",L[L.Directory=2]="Directory",L[L.SymbolicLink=64]="SymbolicLink"})(F=e.FileType||(e.FileType={}));var _;(function(L){L[L.Readonly=1]="Readonly"})(_=e.FilePermission||(e.FilePermission={}));var n;(function(L){L[L.FileReadWrite=2]="FileReadWrite",L[L.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",L[L.FileReadStream=16]="FileReadStream",L[L.FileFolderCopy=8]="FileFolderCopy",L[L.PathCaseSensitive=1024]="PathCaseSensitive",L[L.Readonly=2048]="Readonly",L[L.Trash=4096]="Trash",L[L.FileWriteUnlock=8192]="FileWriteUnlock"})(n=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function f(L){return!!(L.capabilities&2)}e.hasReadWriteCapability=f;function o(L){return!!(L.capabilities&8)}e.hasFileFolderCopyCapability=o;function m(L){return!!(L.capabilities&4)}e.hasOpenReadWriteCloseCapability=m;function c(L){return!!(L.capabilities&16)}e.hasFileReadStreamCapability=c;var C;(function(L){L.FileExists="EntryExists",L.FileNotFound="EntryNotFound",L.FileNotADirectory="EntryNotADirectory",L.FileIsADirectory="EntryIsADirectory",L.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",L.FileTooLarge="EntryTooLarge",L.FileWriteLocked="EntryWriteLocked",L.NoPermissions="NoPermissions",L.Unavailable="Unavailable",L.Unknown="Unknown"})(C=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class b extends Error{constructor(z,H){super(z);this.code=H}}e.FileSystemProviderError=b;function h(L,z){const H=new b(L.toString(),z);return P(H,z),H}e.createFileSystemProviderError=h;function g(L){return L||h((0,I.localize)(0,null),C.Unknown)}e.ensureFileSystemProviderError=g;function P(L,z){return L.name=z?`${z} (FileSystemError)`:"FileSystemError",L}e.markAsFileSystemProviderError=P;function l(L){if(!L)return C.Unknown;if(L instanceof b)return L.code;const z=/^(.+) \(FileSystemError\)$/.exec(L.name);if(!z)return C.Unknown;switch(z[1]){case C.FileExists:return C.FileExists;case C.FileIsADirectory:return C.FileIsADirectory;case C.FileNotADirectory:return C.FileNotADirectory;case C.FileNotFound:return C.FileNotFound;case C.FileExceedsMemoryLimit:return C.FileExceedsMemoryLimit;case C.FileTooLarge:return C.FileTooLarge;case C.FileWriteLocked:return C.FileWriteLocked;case C.NoPermissions:return C.NoPermissions;case C.Unavailable:return C.Unavailable}return C.Unknown}e.toFileSystemProviderErrorCode=l;function M(L){if(L instanceof v)return L.fileOperationResult;switch(l(L)){case C.FileNotFound:return 1;case C.FileIsADirectory:return 0;case C.FileNotADirectory:return 10;case C.FileWriteLocked:return 5;case C.NoPermissions:return 6;case C.FileExists:return 4;case C.FileExceedsMemoryLimit:return 9;case C.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=M;var r;(function(L){L[L.CREATE=0]="CREATE",L[L.DELETE=1]="DELETE",L[L.MOVE=2]="MOVE",L[L.COPY=3]="COPY"})(r=e.FileOperation||(e.FileOperation={}));class i{constructor(z,H,j){this.resource=z,this.operation=H,this.target=j}isOperation(z){return this.operation===z}}e.FileOperationEvent=i;var p;(function(L){L[L.UPDATED=0]="UPDATED",L[L.ADDED=1]="ADDED",L[L.DELETED=2]="DELETED"})(p=e.FileChangeType||(e.FileChangeType={}));class d{constructor(z,H){this.added=void 0,this.updated=void 0,this.deleted=void 0;const j=new Map;for(const ue of z){const G=j.get(ue.type);G?G.push([ue.resource,ue]):j.set(ue.type,[[ue.resource,ue]])}for(const[ue,G]of j)switch(ue){case 1:this.added=a.TernarySearchTree.forUris(()=>H),this.added.fill(G);break;case 0:this.updated=a.TernarySearchTree.forUris(()=>H),this.updated.fill(G);break;case 2:this.deleted=a.TernarySearchTree.forUris(()=>H),this.deleted.fill(G);break}}contains(z,...H){return this.doContains(z,{includeChildren:!1},...H)}affects(z,...H){return this.doContains(z,{includeChildren:!0},...H)}doContains(z,H,...j){if(!z)return!1;const ue=j.length>0;return!!((!ue||j.includes(1))&&(this.added?.get(z)||H.includeChildren&&this.added?.findSuperstr(z))||(!ue||j.includes(0))&&(this.updated?.get(z)||H.includeChildren&&this.updated?.findSuperstr(z))||(!ue||j.includes(2))&&(this.deleted?.findSubstr(z)||H.includeChildren&&this.deleted?.findSuperstr(z)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=d;function s(L,z,H){return!L||!z||L===z||z.length>L.length?!1:(z.charAt(z.length-1)!==t.sep&&(z+=t.sep),H?(0,w.startsWithIgnoreCase)(L,z):L.indexOf(z)===0)}e.isParent=s;class v extends Error{constructor(z,H,j){super(z);this.fileOperationResult=H,this.options=j}}e.FileOperationError=v;class y extends v{constructor(z,H,j){super(z,2,j);this.stat=H}}e.NotModifiedSinceFileOperationError=y;var u;(function(L){L[L.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",L[L.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",L[L.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",L[L.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",L[L.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",L[L.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",L[L.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",L[L.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",L[L.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",L[L.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",L[L.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",L[L.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(u=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var D;(function(L){L[L.FILE=0]="FILE",L[L.FOLDER=1]="FOLDER",L[L.ROOT_FOLDER=2]="ROOT_FOLDER"})(D=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function A(L){if(!(typeof L.size!="number"||typeof L.mtime!="number"))return L.mtime.toString(29)+L.size.toString(31)}e.etag=A;async function U(L,z){if(!z.hasProvider(k.URI.from({scheme:L.scheme})))return new Promise(H=>{const j=z.onDidChangeFileSystemProviderRegistrations(ue=>{ue.scheme===L.scheme&&ue.added&&(j.dispose(),H())})})}e.whenProviderRegistered=U,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class B{static formatSize(z){return(0,T.isNumber)(z)||(z=0),z<B.KB?(0,I.localize)(1,null,z.toFixed(0)):z<B.MB?(0,I.localize)(2,null,(z/B.KB).toFixed(2)):z<B.GB?(0,I.localize)(3,null,(z/B.MB).toFixed(2)):z<B.TB?(0,I.localize)(4,null,(z/B.GB).toFixed(2)):(0,I.localize)(5,null,(z/B.TB).toFixed(2))}}e.ByteSize=B,B.KB=1024,B.MB=B.KB*B.KB,B.GB=B.MB*B.KB,B.TB=B.GB*B.KB;var E;(function(L){L[L.IA32=0]="IA32",L[L.OTHER=1]="OTHER"})(E=e.Arch||(e.Arch={}));function N(L){return{maxFileSize:L===0?300*B.MB:16*B.GB,maxHeapSize:L===0?700*B.MB:2*700*B.MB}}e.getPlatformLimits=N}),define(Ee[60],ye([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class a{constructor(...w){this._entries=new Map;for(let[T,k]of w)this.set(T,k)}set(w,T){const k=this._entries.get(w);return this._entries.set(w,T),k}has(w){return this._entries.has(w)}get(w){return this._entries.get(w)}}e.ServiceCollection=a}),define(Ee[137],ye([0,1,14,15,80,133,3,60]),function(re,e,a,t,w,T,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const S=!1;class R extends Error{constructor(o){super("cyclic dependency between services");this.message=o.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${o.toString()}`}}class F{constructor(o=new I.ServiceCollection,m=!1,c){this._activeInstantiations=new Set,this._services=o,this._strict=m,this._parent=c,this._services.set(k.IInstantiationService,this)}createChild(o){return new F(o,this._strict,this)}invokeFunction(o,...m){let c=n.traceInvocation(o),C=!1;try{return o({get:h=>{if(C)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const g=this._getOrCreateServiceInstance(h,c);if(!g)throw new Error(`[invokeFunction] unknown service '${h}'`);return g}},...m)}finally{C=!0,c.stop()}}createInstance(o,...m){let c,C;return o instanceof w.SyncDescriptor?(c=n.traceCreation(o.ctor),C=this._createInstance(o.ctor,o.staticArguments.concat(m),c)):(c=n.traceCreation(o),C=this._createInstance(o,m,c)),c.stop(),C}_createInstance(o,m=[],c){let C=k._util.getServiceDependencies(o).sort((g,P)=>g.index-P.index),b=[];for(const g of C){let P=this._getOrCreateServiceInstance(g.id,c);if(!P&&this._strict&&!g.optional)throw new Error(`[createInstance] ${o.name} depends on UNKNOWN service ${g.id}.`);b.push(P)}let h=C.length>0?C[0].index:m.length;if(m.length!==h){console.warn(`[createInstance] First service dependency of ${o.name} at position ${h+1} conflicts with ${m.length} static arguments`);let g=h-m.length;g>0?m=m.concat(new Array(g)):m=m.slice(0,h)}return new o(...[...m,...b])}_setServiceInstance(o,m){if(this._services.get(o)instanceof w.SyncDescriptor)this._services.set(o,m);else if(this._parent)this._parent._setServiceInstance(o,m);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(o){let m=this._services.get(o);return!m&&this._parent?this._parent._getServiceInstanceOrDescriptor(o):m}_getOrCreateServiceInstance(o,m){let c=this._getServiceInstanceOrDescriptor(o);return c instanceof w.SyncDescriptor?this._safeCreateAndCacheServiceInstance(o,c,m.branch(o,!0)):(m.branch(o,!1),c)}_safeCreateAndCacheServiceInstance(o,m,c){if(this._activeInstantiations.has(o))throw new Error(`illegal state - RECURSIVELY instantiating service '${o}'`);this._activeInstantiations.add(o);try{return this._createAndCacheServiceInstance(o,m,c)}finally{this._activeInstantiations.delete(o)}}_createAndCacheServiceInstance(o,m,c){const C=new T.Graph(g=>g.id.toString());let b=0;const h=[{id:o,desc:m,_trace:c}];for(;h.length;){const g=h.pop();if(C.lookupOrInsertNode(g),b++>1e3)throw new R(C);for(let P of k._util.getServiceDependencies(g.desc.ctor)){let l=this._getServiceInstanceOrDescriptor(P.id);if(!l&&!P.optional&&console.warn(`[createInstance] ${o} depends on ${P.id} which is NOT registered.`),l instanceof w.SyncDescriptor){const M={id:P.id,desc:l,_trace:g._trace.branch(P.id,!0)};C.insertEdge(g,M),h.push(M)}}}for(;;){const g=C.roots();if(g.length===0){if(!C.isEmpty())throw new R(C);break}for(const{data:P}of g){if(this._getServiceInstanceOrDescriptor(P.id)instanceof w.SyncDescriptor){const M=this._createServiceInstanceWithOwner(P.id,P.desc.ctor,P.desc.staticArguments,P.desc.supportsDelayedInstantiation,P._trace);this._setServiceInstance(P.id,M)}C.removeNode(P)}}return this._getServiceInstanceOrDescriptor(o)}_createServiceInstanceWithOwner(o,m,c=[],C,b){if(this._services.get(o)instanceof w.SyncDescriptor)return this._createServiceInstance(m,c,C,b);if(this._parent)return this._parent._createServiceInstanceWithOwner(o,m,c,C,b);throw new Error(`illegalState - creating UNKNOWN service instance ${m.name}`)}_createServiceInstance(o,m=[],c,C){if(c){const b=new a.IdleValue(()=>this._createInstance(o,m,C));return new Proxy(Object.create(null),{get(h,g){if(g in h)return h[g];let P=b.value,l=P[g];return typeof l!="function"||(l=l.bind(P),h[g]=l),l},set(h,g,P){return b.value[g]=P,!0}})}else return this._createInstance(o,m,C)}}e.InstantiationService=F;var _;(function(f){f[f.Creation=0]="Creation",f[f.Invocation=1]="Invocation",f[f.Branch=2]="Branch"})(_||(_={}));class n{constructor(o,m){this.type=o,this.name=m,this._start=Date.now(),this._dep=[]}static traceInvocation(o){return S?new n(1,o.name||o.toString().substring(0,42).replace(/\n/g,"")):n._None}static traceCreation(o){return S?new n(0,o.name):n._None}branch(o,m){let c=new n(2,o.toString());return this._dep.push([o,m,c]),c}stop(){let o=Date.now()-this._start;n._totals+=o;let m=!1;function c(b,h){let g=[],P=new Array(b+1).join("	");for(const[l,M,r]of h._dep)if(M&&r){m=!0,g.push(`${P}CREATES -> ${l}`);let i=c(b+1,r);i&&g.push(i)}else g.push(`${P}uses -> ${l}`);return g.join(`
`)}let C=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${c(1,this)}`,`DONE, took ${o.toFixed(2)}ms (grand total ${n._totals.toFixed(2)}ms)`];(o>2||m)&&console.log(C.join(`
`))}}n._None=new class extends n{constructor(){super(-1,null)}stop(){}branch(){return this}},n._totals=0}),define(Ee[12],ye([0,1,43,4,6,23,3]),function(re,e,a,t,w,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,k.createDecorator)("logService"),e.ILoggerService=(0,k.createDecorator)("loggerService");function I(){return new Date().toISOString()}var S;(function(M){M[M.Trace=0]="Trace",M[M.Debug=1]="Debug",M[M.Info=2]="Info",M[M.Warning=3]="Warning",M[M.Error=4]="Error",M[M.Critical=5]="Critical",M[M.Off=6]="Off"})(S=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=S.Info;function R(M,r,i){switch(r){case S.Trace:M.trace(i);break;case S.Debug:M.debug(i);break;case S.Info:M.info(i);break;case S.Warning:M.warn(i);break;case S.Error:M.error(i);break;case S.Critical:M.critical(i);break;default:throw new Error("Invalid log level")}}e.log=R;function F(M){let r="";for(let i=0;i<M.length;i++){let p=M[i];if(typeof p=="object")try{p=JSON.stringify(p)}catch{}r+=(i>0?" ":"")+p}return r}e.format=F;class _ extends w.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new t.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(r){this.level!==r&&(this.level=r,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=_;class n extends _{constructor(r){super();this.logAlways=r}checkLogLevel(r){return this.logAlways||this.getLevel()<=r}trace(r,...i){this.checkLogLevel(S.Trace)&&this.log(S.Trace,F([r,...i]))}debug(r,...i){this.checkLogLevel(S.Debug)&&this.log(S.Debug,F([r,...i]))}info(r,...i){this.checkLogLevel(S.Info)&&this.log(S.Info,F([r,...i]))}warn(r,...i){this.checkLogLevel(S.Warning)&&this.log(S.Warning,F([r,...i]))}error(r,...i){if(this.checkLogLevel(S.Error))if(r instanceof Error){const p=Array.prototype.slice.call(arguments);p[0]=r.stack,this.log(S.Error,F(p))}else this.log(S.Error,F([r,...i]))}critical(r,...i){this.checkLogLevel(S.Critical)&&this.log(S.Critical,F([r,...i]))}flush(){}}e.AbstractMessageLogger=n;class f extends _{constructor(r=e.DEFAULT_LOG_LEVEL){super();this.setLevel(r),this.useColors=!T.isWindows}trace(r,...i){this.getLevel()<=S.Trace&&(this.useColors?console.log(`[90m[main ${I()}][0m`,r,...i):console.log(`[main ${I()}]`,r,...i))}debug(r,...i){this.getLevel()<=S.Debug&&(this.useColors?console.log(`[90m[main ${I()}][0m`,r,...i):console.log(`[main ${I()}]`,r,...i))}info(r,...i){this.getLevel()<=S.Info&&(this.useColors?console.log(`[90m[main ${I()}][0m`,r,...i):console.log(`[main ${I()}]`,r,...i))}warn(r,...i){this.getLevel()<=S.Warning&&(this.useColors?console.warn(`[93m[main ${I()}][0m`,r,...i):console.warn(`[main ${I()}]`,r,...i))}error(r,...i){this.getLevel()<=S.Error&&(this.useColors?console.error(`[91m[main ${I()}][0m`,r,...i):console.error(`[main ${I()}]`,r,...i))}critical(r,...i){this.getLevel()<=S.Critical&&(this.useColors?console.error(`[90m[main ${I()}][0m`,r,...i):console.error(`[main ${I()}]`,r,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=f;class o extends _{constructor(r=e.DEFAULT_LOG_LEVEL){super();this.setLevel(r)}trace(r,...i){this.getLevel()<=S.Trace&&console.log("%cTRACE","color: #888",r,...i)}debug(r,...i){this.getLevel()<=S.Debug&&console.log("%cDEBUG","background: #eee; color: #888",r,...i)}info(r,...i){this.getLevel()<=S.Info&&console.log("%c INFO","color: #33f",r,...i)}warn(r,...i){this.getLevel()<=S.Warning&&console.log("%c WARN","color: #993",r,...i)}error(r,...i){this.getLevel()<=S.Error&&console.log("%c  ERR","color: #f33",r,...i)}critical(r,...i){this.getLevel()<=S.Critical&&console.log("%cCRITI","background: #f33; color: white",r,...i)}dispose(){}flush(){}}e.ConsoleLogger=o;class m extends _{constructor(r,i=e.DEFAULT_LOG_LEVEL){super();this.adapter=r,this.setLevel(i)}trace(r,...i){this.getLevel()<=S.Trace&&this.adapter.log(S.Trace,[this.extractMessage(r),...i])}debug(r,...i){this.getLevel()<=S.Debug&&this.adapter.log(S.Debug,[this.extractMessage(r),...i])}info(r,...i){this.getLevel()<=S.Info&&this.adapter.log(S.Info,[this.extractMessage(r),...i])}warn(r,...i){this.getLevel()<=S.Warning&&this.adapter.log(S.Warning,[this.extractMessage(r),...i])}error(r,...i){this.getLevel()<=S.Error&&this.adapter.log(S.Error,[this.extractMessage(r),...i])}critical(r,...i){this.getLevel()<=S.Critical&&this.adapter.log(S.Critical,[this.extractMessage(r),...i])}extractMessage(r){return typeof r=="string"?r:(0,a.toErrorMessage)(r,this.getLevel()<=S.Trace)}dispose(){}flush(){}}e.AdapterLogger=m;class c extends _{constructor(r){super();this.logServices=r,r.length&&this.setLevel(r[0].getLevel())}setLevel(r){for(const i of this.logServices)i.setLevel(r);super.setLevel(r)}trace(r,...i){for(const p of this.logServices)p.trace(r,...i)}debug(r,...i){for(const p of this.logServices)p.debug(r,...i)}info(r,...i){for(const p of this.logServices)p.info(r,...i)}warn(r,...i){for(const p of this.logServices)p.warn(r,...i)}error(r,...i){for(const p of this.logServices)p.error(r,...i)}critical(r,...i){for(const p of this.logServices)p.critical(r,...i)}flush(){for(const r of this.logServices)r.flush()}dispose(){for(const r of this.logServices)r.dispose()}}e.MultiplexLogService=c;class C extends w.Disposable{constructor(r){super();this.logger=r,this._register(r)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(r){this.logger.setLevel(r)}getLevel(){return this.logger.getLevel()}trace(r,...i){this.logger.trace(r,...i)}debug(r,...i){this.logger.debug(r,...i)}info(r,...i){this.logger.info(r,...i)}warn(r,...i){this.logger.warn(r,...i)}error(r,...i){this.logger.error(r,...i)}critical(r,...i){this.logger.critical(r,...i)}flush(){this.logger.flush()}}e.LogService=C;class b extends w.Disposable{constructor(r,i){super();this.logLevel=r,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(p=>{this.logLevel=p,this.logLevelChangeableLoggers.forEach(d=>d.setLevel(p))}))}getLogger(r){return this.loggers.get(r.toString())}createLogger(r,i){let p=this.loggers.get(r.toString());return p||(p=this.doCreateLogger(r,i?.always?S.Trace:this.logLevel,i),this.loggers.set(r.toString(),p),i?.always||this.logLevelChangeableLoggers.push(p)),p}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(r=>r.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=b;class h{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(r){}getLevel(){return S.Info}trace(r,...i){}debug(r,...i){}info(r,...i){}warn(r,...i){}error(r,...i){}critical(r,...i){}dispose(){}flush(){}}e.NullLogService=h;function g(M){if(M.verbose)return S.Trace;if(typeof M.logLevel=="string"){const r=P(M.logLevel.toLowerCase());if(r!==void 0)return r}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=g;function P(M){switch(M){case"trace":return S.Trace;case"debug":return S.Debug;case"info":return S.Info;case"warn":return S.Warning;case"error":return S.Error;case"critical":return S.Critical;case"off":return S.Off}}e.parseLogLevel=P;function l(M){switch(M){case S.Trace:return"trace";case S.Debug:return"debug";case S.Info:return"info";case S.Warning:return"warn";case S.Error:return"error";case S.Critical:return"critical";case S.Off:return"off"}}e.LogLevelToString=l}),define(Ee[82],ye([0,1,34,118,3]),function(re,e,a,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var T;(function(S){S[S.Unnecessary=1]="Unnecessary",S[S.Deprecated=2]="Deprecated"})(T=e.MarkerTag||(e.MarkerTag={}));var k;(function(S){S[S.Hint=1]="Hint",S[S.Info=2]="Info",S[S.Warning=4]="Warning",S[S.Error=8]="Error"})(k=e.MarkerSeverity||(e.MarkerSeverity={})),function(S){function R(o,m){return m-o}S.compare=R;const F=Object.create(null);F[S.Error]=(0,t.localize)(0,null),F[S.Warning]=(0,t.localize)(1,null),F[S.Info]=(0,t.localize)(2,null);function _(o){return F[o]||""}S.toString=_;function n(o){switch(o){case a.default.Error:return S.Error;case a.default.Warning:return S.Warning;case a.default.Info:return S.Info;case a.default.Ignore:return S.Hint}}S.fromSeverity=n;function f(o){switch(o){case S.Error:return a.default.Error;case S.Warning:return a.default.Warning;case S.Info:return a.default.Info;case S.Hint:return a.default.Ignore}}S.toSeverity=f}(k=e.MarkerSeverity||(e.MarkerSeverity={}));var I;(function(S){const R="";function F(n){return _(n,!0)}S.makeKey=F;function _(n,f){let o=[R];return n.source?o.push(n.source.replace("\xA6","\\\xA6")):o.push(R),n.code?typeof n.code=="string"?o.push(n.code.replace("\xA6","\\\xA6")):o.push(n.code.value.replace("\xA6","\\\xA6")):o.push(R),n.severity!==void 0&&n.severity!==null?o.push(k.toString(n.severity)):o.push(R),n.message&&f?o.push(n.message.replace("\xA6","\\\xA6")):o.push(R),n.startLineNumber!==void 0&&n.startLineNumber!==null?o.push(n.startLineNumber.toString()):o.push(R),n.startColumn!==void 0&&n.startColumn!==null?o.push(n.startColumn.toString()):o.push(R),n.endLineNumber!==void 0&&n.endLineNumber!==null?o.push(n.endLineNumber.toString()):o.push(R),n.endColumn!==void 0&&n.endColumn!==null?o.push(n.endColumn.toString()):o.push(R),o.push(R),o.join("\xA6")}S.makeKeyOptionalMessage=_})(I=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,w.createDecorator)("markerService")}),define(Ee[138],ye([0,1,4,34,3]),function(re,e,a,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=t.default,e.INotificationService=(0,w.createDecorator)("notificationService");var T;(function(R){R[R.WORKSPACE=0]="WORKSPACE",R[R.GLOBAL=1]="GLOBAL"})(T=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var k;(function(R){R[R.OFF=0]="OFF",R[R.SILENT=1]="SILENT",R[R.ERROR=2]="ERROR"})(k=e.NotificationsFilter||(e.NotificationsFilter={}));class I{constructor(){this.progress=new S,this.onDidClose=a.Event.None,this.onDidChangeVisibility=a.Event.None}updateSeverity(F){}updateMessage(F){}updateActions(F){}close(){}}e.NoOpNotification=I;class S{infinite(){}done(){}total(F){}worked(F){}}e.NoOpProgress=S}),define(Ee[139],ye([0,1,6,9,2,3]),function(re,e,a,t,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,T.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return a.Disposable.None},registerValidator(){return a.Disposable.None},registerExternalUriResolver(){return a.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return a.Disposable.None},async open(){return!1},async resolveExternalUri(S){return{resolved:S,dispose(){}}}});function k(S,R){return w.URI.isUri(S)?(0,t.equalsIgnoreCase)(S.scheme,R):(0,t.startsWithIgnoreCase)(S,R+":")}e.matchesScheme=k;function I(S,...R){return R.some(F=>k(S,F))}e.matchesSomeScheme=I});var Ue=this&&this.__decorate||function(re,e,a,t){var w=arguments.length,T=w<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,a):t,k;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")T=Reflect.decorate(re,e,a,t);else for(var I=re.length-1;I>=0;I--)(k=re[I])&&(T=(w<3?k(T):w>3?k(e,a,T):k(e,a))||T);return w>3&&T&&Object.defineProperty(e,a,T),T},$e=this&&this.__param||function(re,e){return function(a,t){e(a,t,re)}};define(Ee[140],ye([0,1,14,20,6,3]),function(re,e,a,t,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,T.createDecorator)("progressService");var k;(function(F){F[F.Explorer=1]="Explorer",F[F.Scm=3]="Scm",F[F.Extensions=5]="Extensions",F[F.Window=10]="Window",F[F.Notification=15]="Notification",F[F.Dialog=20]="Dialog"})(k=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class I{constructor(_){this.callback=_}get value(){return this._value}report(_){this._value=_,this.callback(this._value)}}e.Progress=I,I.None=Object.freeze({report(){}});let S=class extends w.Disposable{constructor(_,n){super();this.deferred=new a.DeferredPromise,n.withProgress(_,f=>(this.reporter=f,this.lastStep&&f.report(this.lastStep),this.deferred.p)),this._register((0,w.toDisposable)(()=>this.deferred.complete()))}report(_){this.reporter?this.reporter.report(_):this.lastStep=_}};S=Ue([$e(1,e.IProgressService)],S),e.UnmanagedProgress=S;class R extends w.Disposable{constructor(_){super();this.progressIndicator=_,this.currentOperationId=0,this.currentOperationDisposables=this._register(new w.DisposableStore)}start(_){this.stop();const n=++this.currentOperationId,f=new t.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{n===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},_),this.currentOperationDisposables.add((0,w.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,w.toDisposable)(()=>f.cancel())),this.currentOperationDisposables.add((0,w.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:n,token:f.token,stop:()=>this.doStop(n),isCurrent:()=>this.currentOperationId===n}}stop(){this.doStop(this.currentOperationId)}doStop(_){this.currentOperationId===_&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=R,e.IEditorProgressService=(0,T.createDecorator)("editorProgressService")}),define(Ee[36],ye([0,1,41,11]),function(re,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class w{constructor(){this.data=new Map}add(k,I){a.ok(t.isString(k)),a.ok(t.isObject(I)),a.ok(!this.data.has(k),"There is already an extension with this id"),this.data.set(k,I)}knows(k){return this.data.has(k)}as(k){return this.data.get(k)||null}}e.Registry=new w}),define(Ee[141],ye([0,1,4,36]),function(re,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function w(I){return I.length>0&&I.charAt(I.length-1)==="#"?I.substring(0,I.length-1):I}class T{constructor(){this._onDidChangeSchema=new a.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(S,R){this.schemasById[w(S)]=R,this._onDidChangeSchema.fire(S)}notifySchemaChanged(S){this._onDidChangeSchema.fire(S)}getSchemaContributions(){return{schemas:this.schemasById}}}const k=new T;t.Registry.add(e.Extensions.JSONContribution,k)}),define(Ee[83],ye([0,1,16,4,11,115,141,36]),function(re,e,a,t,w,T,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var S;(function(g){g.Multiline="multilineText",g.Singleline="singlelineText"})(S=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var R;(function(g){g[g.APPLICATION=1]="APPLICATION",g[g.MACHINE=2]="MACHINE",g[g.WINDOW=3]="WINDOW",g[g.RESOURCE=4]="RESOURCE",g[g.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",g[g.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const F=I.Registry.as(k.Extensions.JSONContribution);class _{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new t.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new t.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:T.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},F.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(P,l=!0){this.registerConfigurations([P],l)}registerConfigurations(P,l=!0){const M=this.doRegisterConfigurations(P,l);F.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:M})}deregisterConfigurations(P){const l=this.doDeregisterConfigurations(P);F.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:l})}updateConfigurations({add:P,remove:l}){const M=[];M.push(...this.doDeregisterConfigurations(l)),M.push(...this.doRegisterConfigurations(P,!1)),F.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,a.distinct)(M)})}registerDefaultConfigurations(P){const l=[],M=[];for(const{overrides:r,source:i}of P)for(const p in r)if(l.push(p),e.OVERRIDE_PROPERTY_REGEX.test(p)){const d={...this.configurationDefaultsOverrides.get(p)?.value||{},...r[p]};this.configurationDefaultsOverrides.set(p,{source:i,value:d});const s={type:"object",default:d,description:T.localize(1,null,p),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:d,source:w.isString(i)?void 0:i};M.push(...o(p)),this.configurationProperties[p]=s,this.defaultLanguageConfigurationOverridesNode.properties[p]=s}else{this.configurationDefaultsOverrides.set(p,{value:r[p],source:i});const d=this.configurationProperties[p];d&&(this.updatePropertyDefaultValue(p,d),this.updateSchema(p,d))}this.registerOverrideIdentifiers(M),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:l,defaultsOverrides:!0})}deregisterDefaultConfigurations(P){const l=[];for(const{overrides:M,source:r}of P)for(const i in M){const p=this.configurationDefaultsOverrides.get(i),d=w.isString(r)?r:r?.id,s=w.isString(p?.source)?p?.source:p?.source?.id;if(d===s)if(l.push(i),this.configurationDefaultsOverrides.delete(i),e.OVERRIDE_PROPERTY_REGEX.test(i))delete this.configurationProperties[i],delete this.defaultLanguageConfigurationOverridesNode.properties[i];else{const v=this.configurationProperties[i];v&&(this.updatePropertyDefaultValue(i,v),this.updateSchema(i,v))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:l,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...P){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(P){for(const l of P)this.overrideIdentifiers.add(l);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(P,l){const M=[];return P.forEach(r=>{M.push(...this.validateAndRegisterProperties(r,l,r.extensionInfo,r.restrictedProperties)),this.configurationContributors.push(r),this.registerJSONConfiguration(r)}),M}doDeregisterConfigurations(P){const l=[],M=r=>{if(r.properties)for(const i in r.properties)l.push(i),delete this.configurationProperties[i],this.removeFromSchema(i,r.properties[i]);r.allOf&&r.allOf.forEach(i=>M(i))};for(const r of P){M(r);const i=this.configurationContributors.indexOf(r);i!==-1&&this.configurationContributors.splice(i,1)}return l}validateAndRegisterProperties(P,l=!0,M,r,i=3){i=w.isUndefinedOrNull(P.scope)?i:P.scope;let p=[],d=P.properties;if(d)for(let v in d){if(l&&b(v)){delete d[v];continue}const y=d[v];if(y.source=M,y.defaultDefaultValue=d[v].default,this.updatePropertyDefaultValue(v,y),e.OVERRIDE_PROPERTY_REGEX.test(v)?y.scope=void 0:(y.scope=w.isUndefinedOrNull(y.scope)?i:y.scope,y.restricted=w.isUndefinedOrNull(y.restricted)?!!r?.includes(v):y.restricted),d[v].hasOwnProperty("included")&&!d[v].included){this.excludedConfigurationProperties[v]=d[v],delete d[v];continue}else this.configurationProperties[v]=d[v];!d[v].deprecationMessage&&d[v].markdownDeprecationMessage&&(d[v].deprecationMessage=d[v].markdownDeprecationMessage),p.push(v)}let s=P.allOf;if(s)for(let v of s)p.push(...this.validateAndRegisterProperties(v,l,M,r,i));return p}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(P){const l=M=>{let r=M.properties;if(r)for(const p in r)this.updateSchema(p,r[p]);let i=M.allOf;i&&i.forEach(l)};l(P)}updateSchema(P,l){switch(e.allSettings.properties[P]=l,l.scope){case 1:e.applicationSettings.properties[P]=l;break;case 2:e.machineSettings.properties[P]=l;break;case 6:e.machineOverridableSettings.properties[P]=l;break;case 3:e.windowSettings.properties[P]=l;break;case 4:e.resourceSettings.properties[P]=l;break;case 5:e.resourceSettings.properties[P]=l,this.resourceLanguageSettingsSchema.properties[P]=l;break}}removeFromSchema(P,l){switch(delete e.allSettings.properties[P],l.scope){case 1:delete e.applicationSettings.properties[P];break;case 2:delete e.machineSettings.properties[P];break;case 6:delete e.machineOverridableSettings.properties[P];break;case 3:delete e.windowSettings.properties[P];break;case 4:case 5:delete e.resourceSettings.properties[P],delete this.resourceLanguageSettingsSchema.properties[P];break}}updateOverridePropertyPatternKey(){for(const P of this.overrideIdentifiers.values()){const l=`[${P}]`,M={type:"object",description:T.localize(2,null),errorMessage:T.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(l,M),e.allSettings.properties[l]=M,e.applicationSettings.properties[l]=M,e.machineSettings.properties[l]=M,e.machineOverridableSettings.properties[l]=M,e.windowSettings.properties[l]=M,e.resourceSettings.properties[l]=M}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const P={type:"object",description:T.localize(4,null),errorMessage:T.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=P,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=P,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=P,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=P,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=P,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=P,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(P,l){const M=this.configurationDefaultsOverrides.get(P);let r=M?.value,i=M?.source;w.isUndefined(r)&&(r=l.defaultDefaultValue,i=void 0),w.isUndefined(r)&&(r=c(l.type)),l.default=r,l.defaultValueSource=i}}const n="\\[([^\\]]+)\\]",f=new RegExp(n,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${n})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function o(g){const P=[];if(e.OVERRIDE_PROPERTY_REGEX.test(g)){let l=f.exec(g);for(;l?.length;){const M=l[1].trim();M&&P.push(M),l=f.exec(g)}}return(0,a.distinct)(P)}e.overrideIdentifiersFromKey=o;function m(g){return g.reduce((P,l)=>`${P}[${l}]`,"")}e.keyFromOverrideIdentifiers=m;function c(g){switch(Array.isArray(g)?g[0]:g){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=c;const C=new _;I.Registry.add(e.Extensions.Configuration,C);function b(g){return g.trim()?e.OVERRIDE_PROPERTY_REGEX.test(g)?T.localize(7,null,g):C.getConfigurationProperties()[g]!==void 0?T.localize(8,null,g):null:T.localize(6,null)}e.validateProperty=b;function h(){const g=[],P=C.getConfigurationProperties();for(const l of Object.keys(P))g.push([l,P[l].scope]);return g.push(["launch",4]),g.push(["task",4]),g}e.getScopes=h}),define(Ee[142],ye([0,1,16,4,100,6,21,26,11,2,81,83,36]),function(re,e,a,t,w,T,k,I,S,R,F,_,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class f{constructor(r={},i=[],p=[]){this._contents=r,this._keys=i,this._overrides=p,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(r){return r?(0,F.getConfigurationValue)(this.contents,r):this.contents}getOverrideValue(r,i){const p=this.getContentsForOverrideIdentifer(i);return p?r?(0,F.getConfigurationValue)(p,r):p:void 0}getKeysForOverrideIdentifier(r){const i=[];for(const p of this.overrides)p.identifiers.includes(r)&&i.push(...p.keys);return a.distinct(i)}getAllOverrideIdentifiers(){const r=[];for(const i of this.overrides)r.push(...i.identifiers);return a.distinct(r)}override(r){let i=this.overrideConfigurations.get(r);return i||(i=this.createOverrideConfigurationModel(r),this.overrideConfigurations.set(r,i)),i}merge(...r){const i=I.deepClone(this.contents),p=I.deepClone(this.overrides),d=[...this.keys];for(const s of r){this.mergeContents(i,s.contents);for(const v of s.overrides){const[y]=p.filter(u=>a.equals(u.identifiers,v.identifiers));y?(this.mergeContents(y.contents,v.contents),y.keys.push(...v.keys),y.keys=a.distinct(y.keys)):p.push(I.deepClone(v))}for(const v of s.keys)d.indexOf(v)===-1&&d.push(v)}return new f(i,d,p)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(r){const i=this.getContentsForOverrideIdentifer(r);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let p={};for(const d of a.distinct([...Object.keys(this.contents),...Object.keys(i)])){let s=this.contents[d],v=i[d];v&&(typeof s=="object"&&typeof v=="object"?(s=I.deepClone(s),this.mergeContents(s,v)):s=v),p[d]=s}return new f(p,this.keys,this.overrides)}mergeContents(r,i){for(const p of Object.keys(i)){if(p in r&&S.isObject(r[p])&&S.isObject(i[p])){this.mergeContents(r[p],i[p]);continue}r[p]=I.deepClone(i[p])}}checkAndFreeze(r){return this.isFrozen&&!Object.isFrozen(r)?I.deepFreeze(r):r}getContentsForOverrideIdentifer(r){let i=null,p=null;const d=s=>{s&&(p?this.mergeContents(p,s):p=I.deepClone(s))};for(const s of this.overrides)a.equals(s.identifiers,[r])?i=s.contents:s.identifiers.includes(r)&&d(s.contents);return d(i),p}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(r,i){this.addKey(r),(0,F.addToValueTree)(this.contents,r,i,p=>{throw new Error(p)})}removeValue(r){this.removeKey(r)&&(0,F.removeFromValueTree)(this.contents,r)}addKey(r){let i=this.keys.length;for(let p=0;p<i;p++)r.indexOf(this.keys[p])===0&&(i=p);this.keys.splice(i,1,r)}removeKey(r){let i=this.keys.indexOf(r);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=f;class o extends f{constructor(r={}){const i=n.Registry.as(_.Extensions.Configuration).getConfigurationProperties(),p=Object.keys(i),d=Object.create(null),s=[];for(const v in i){const y=r[v],u=y!==void 0?y:i[v].default;(0,F.addToValueTree)(d,v,u,D=>console.error(`Conflict in default settings: ${D}`))}for(const v of Object.keys(d))_.OVERRIDE_PROPERTY_REGEX.test(v)&&s.push({identifiers:(0,_.overrideIdentifiersFromKey)(v),keys:Object.keys(d[v]),contents:(0,F.toValuesTree)(d[v],y=>console.error(`Conflict in default settings file: ${y}`))});super(d,p,s)}}e.DefaultConfigurationModel=o;class m{constructor(r){this._name=r,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new f}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(r,i){if(!S.isUndefinedOrNull(r)){const p=this.doParseContent(r);this.parseRaw(p,i)}}reparse(r){this._raw&&this.parseRaw(this._raw,r)}parseRaw(r,i){this._raw=r;const{contents:p,keys:d,overrides:s,restricted:v}=this.doParseRaw(r,i);this._configurationModel=new f(p,d,s),this._restrictedConfigurations=v||[]}doParseContent(r){let i={},p=null,d=[],s=[],v=[];function y(D){Array.isArray(d)?d.push(D):p!==null&&(d[p]=D)}let u={onObjectBegin:()=>{let D={};y(D),s.push(d),d=D,p=null},onObjectProperty:D=>{p=D},onObjectEnd:()=>{d=s.pop()},onArrayBegin:()=>{let D=[];y(D),s.push(d),d=D,p=null},onArrayEnd:()=>{d=s.pop()},onLiteralValue:y,onError:(D,A,U)=>{v.push({error:D,offset:A,length:U})}};if(r)try{w.visit(r,u),i=d[0]||{}}catch(D){console.error(`Error while parsing settings file ${this._name}: ${D}`),this._parseErrors=[D]}return i}doParseRaw(r,i){const p=n.Registry.as(_.Extensions.Configuration).getConfigurationProperties(),d=this.filter(r,p,!0,i);r=d.raw;const s=(0,F.toValuesTree)(r,u=>console.error(`Conflict in settings file ${this._name}: ${u}`)),v=Object.keys(r),y=this.toOverrides(r,u=>console.error(`Conflict in settings file ${this._name}: ${u}`));return{contents:s,keys:v,overrides:y,restricted:d.restricted}}filter(r,i,p,d){if(!d?.scopes&&!d?.skipRestricted)return{raw:r,restricted:[]};const s={},v=[];for(let y in r)if(_.OVERRIDE_PROPERTY_REGEX.test(y)&&p){const u=this.filter(r[y],i,!1,d);s[y]=u.raw,v.push(...u.restricted)}else{const u=i[y],D=u?typeof u.scope!="undefined"?u.scope:3:void 0;u?.restricted&&v.push(y),(D===void 0||d.scopes===void 0||d.scopes.includes(D))&&(d.skipRestricted&&u?.restricted||(s[y]=r[y]))}return{raw:s,restricted:v}}toOverrides(r,i){const p=[];for(const d of Object.keys(r))if(_.OVERRIDE_PROPERTY_REGEX.test(d)){const s={};for(const v in r[d])s[v]=r[d][v];p.push({identifiers:(0,_.overrideIdentifiersFromKey)(d),keys:Object.keys(s),contents:(0,F.toValuesTree)(s,i)})}return p}}e.ConfigurationModelParser=m;class c extends T.Disposable{constructor(r,i,p,d){super();this.userSettingsResource=r,this.scopes=i,this.fileService=d,this._onDidChange=this._register(new t.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new m(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(p.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(t.Event.filter(this.fileService.onDidFilesChange,s=>s.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const r=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(r.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new f}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=c;class C{constructor(r,i,p=new f,d=new f,s=new k.ResourceMap,v=new f,y=new k.ResourceMap,u=!0){this._defaultConfiguration=r,this._localUserConfiguration=i,this._remoteUserConfiguration=p,this._workspaceConfiguration=d,this._folderConfigurations=s,this._memoryConfiguration=v,this._memoryConfigurationByResource=y,this._freeze=u,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new k.ResourceMap,this._userConfiguration=null}getValue(r,i,p){return this.getConsolidateConfigurationModel(i,p).getValue(r)}updateValue(r,i,p={}){let d;p.resource?(d=this._memoryConfigurationByResource.get(p.resource),d||(d=new f,this._memoryConfigurationByResource.set(p.resource,d))):d=this._memoryConfiguration,i===void 0?d.removeValue(r):d.setValue(r,i),p.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(r,i,p){const d=this.getConsolidateConfigurationModel(i,p),s=this.getFolderConfigurationModelForResource(i.resource,p),v=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,y=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this._defaultConfiguration.freeze().getValue(r),u=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this.userConfiguration.freeze().getValue(r),D=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this.localUserConfiguration.freeze().getValue(r),A=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this.remoteUserConfiguration.freeze().getValue(r),U=p?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this._workspaceConfiguration.freeze().getValue(r):void 0,B=s?i.overrideIdentifier?s.freeze().override(i.overrideIdentifier).getValue(r):s.freeze().getValue(r):void 0,E=i.overrideIdentifier?v.override(i.overrideIdentifier).getValue(r):v.getValue(r),N=d.getValue(r),L=a.distinct(a.flatten(d.overrides.map(z=>z.identifiers))).filter(z=>d.getOverrideValue(r,z)!==void 0);return{defaultValue:y,userValue:u,userLocalValue:D,userRemoteValue:A,workspaceValue:U,workspaceFolderValue:B,memoryValue:E,value:N,default:y!==void 0?{value:this._defaultConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,user:u!==void 0?{value:this.userConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,userLocal:D!==void 0?{value:this.localUserConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,userRemote:A!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,workspace:U!==void 0?{value:this._workspaceConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,workspaceFolder:B!==void 0?{value:s?.freeze().getValue(r),override:i.overrideIdentifier?s?.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,memory:E!==void 0?{value:v.getValue(r),override:i.overrideIdentifier?v.getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:L.length?L:void 0}}keys(r){const i=this.getFolderConfigurationModelForResource(void 0,r);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(r){this._defaultConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(r){this._localUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(r){this._remoteUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(r){this._workspaceConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(r,i){this._folderConfigurations.set(r,i),this._foldersConsolidatedConfigurations.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this._foldersConsolidatedConfigurations.delete(r)}compareAndUpdateDefaultConfiguration(r,i){const p=[];if(!i){const{added:d,updated:s,removed:v}=P(this._defaultConfiguration,r);i=[...d,...s,...v]}for(const d of i)for(const s of(0,_.overrideIdentifiersFromKey)(d)){const v=this._defaultConfiguration.getKeysForOverrideIdentifier(s),y=r.getKeysForOverrideIdentifier(s),u=[...y.filter(D=>v.indexOf(D)===-1),...v.filter(D=>y.indexOf(D)===-1),...v.filter(D=>!I.equals(this._defaultConfiguration.override(s).getValue(D),r.override(s).getValue(D)))];p.push([s,u])}return this.updateDefaultConfiguration(r),{keys:i,overrides:p}}compareAndUpdateLocalUserConfiguration(r){const{added:i,updated:p,removed:d,overrides:s}=P(this.localUserConfiguration,r),v=[...i,...p,...d];return v.length&&this.updateLocalUserConfiguration(r),{keys:v,overrides:s}}compareAndUpdateRemoteUserConfiguration(r){const{added:i,updated:p,removed:d,overrides:s}=P(this.remoteUserConfiguration,r);let v=[...i,...p,...d];return v.length&&this.updateRemoteUserConfiguration(r),{keys:v,overrides:s}}compareAndUpdateWorkspaceConfiguration(r){const{added:i,updated:p,removed:d,overrides:s}=P(this.workspaceConfiguration,r);let v=[...i,...p,...d];return v.length&&this.updateWorkspaceConfiguration(r),{keys:v,overrides:s}}compareAndUpdateFolderConfiguration(r,i){const p=this.folderConfigurations.get(r),{added:d,updated:s,removed:v,overrides:y}=P(p,i);let u=[...d,...s,...v];return(u.length||!p)&&this.updateFolderConfiguration(r,i),{keys:u,overrides:y}}compareAndDeleteFolderConfiguration(r){const i=this.folderConfigurations.get(r);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:p,updated:d,removed:s,overrides:v}=P(i,void 0);return{keys:[...p,...d,...s],overrides:v}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(r,i){let p=this.getConsolidatedConfigurationModelForResource(r,i);return r.overrideIdentifier?p.override(r.overrideIdentifier):p}getConsolidatedConfigurationModelForResource({resource:r},i){let p=this.getWorkspaceConsolidatedConfiguration();if(i&&r){const d=i.getFolder(r);d&&(p=this.getFolderConsolidatedConfiguration(d.uri)||p);const s=this._memoryConfigurationByResource.get(r);s&&(p=p.merge(s))}return p}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(r){let i=this._foldersConsolidatedConfigurations.get(r);if(!i){const p=this.getWorkspaceConsolidatedConfiguration(),d=this._folderConfigurations.get(r);d?(i=p.merge(d),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(r,i)):i=p}return i}getFolderConfigurationModelForResource(r,i){if(i&&r){const p=i.getFolder(r);if(p)return this._folderConfigurations.get(p.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((r,i)=>{const{contents:p,overrides:d,keys:s}=this._folderConfigurations.get(i);return r.push([i,{contents:p,overrides:d,keys:s}]),r},[])}}allKeys(){const r=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>r.add(i)),this.userConfiguration.freeze().keys.forEach(i=>r.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>r.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(p=>r.add(p))),[...r.values()]}allOverrideIdentifiers(){const r=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this._folderConfigurations.forEach(i=>i.freeze().getAllOverrideIdentifiers().forEach(p=>r.add(p))),[...r.values()]}getAllKeysForOverrideIdentifier(r){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(r).forEach(p=>i.add(p)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(p=>i.add(p)),this._workspaceConfiguration.getKeysForOverrideIdentifier(r).forEach(p=>i.add(p)),this._folderConfigurations.forEach(p=>p.getKeysForOverrideIdentifier(r).forEach(d=>i.add(d))),[...i.values()]}static parse(r){const i=this.parseConfigurationModel(r.defaults),p=this.parseConfigurationModel(r.user),d=this.parseConfigurationModel(r.workspace),s=r.folders.reduce((v,y)=>(v.set(R.URI.revive(y[0]),this.parseConfigurationModel(y[1])),v),new k.ResourceMap);return new C(i,p,new f,d,s,new f,new k.ResourceMap,!1)}static parseConfigurationModel(r){return new f(r.contents,r.keys,r.overrides).freeze()}}e.Configuration=C;function b(...M){if(M.length===0)return{keys:[],overrides:[]};if(M.length===1)return M[0];const r=new Set,i=new Map;for(const d of M)d.keys.forEach(s=>r.add(s)),d.overrides.forEach(([s,v])=>{const y=(0,k.getOrSet)(i,s,new Set);v.forEach(u=>y.add(u))});const p=[];return i.forEach((d,s)=>p.push([s,[...d.values()]])),{keys:[...r.values()],overrides:p}}e.mergeChanges=b;class h{constructor(r,i,p,d){this.change=r,this.previous=i,this.currentConfiguraiton=p,this.currentWorkspace=d,this._previousConfiguration=void 0;const s=new Set;r.keys.forEach(y=>s.add(y)),r.overrides.forEach(([,y])=>y.forEach(u=>s.add(u))),this.affectedKeys=[...s.values()];const v=new f;this.affectedKeys.forEach(y=>v.setValue(y,{})),this.affectedKeysTree=v.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=C.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(r,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,r)){if(i){const p=this.previousConfiguration?this.previousConfiguration.getValue(r,i,this.previous?.workspace):void 0,d=this.currentConfiguraiton.getValue(r,i,this.currentWorkspace);return!I.equals(p,d)}return!0}return!1}doesAffectedKeysTreeContains(r,i){let p=(0,F.toValuesTree)({[i]:!0},()=>{}),d;for(;typeof p=="object"&&(d=Object.keys(p)[0]);){if(r=r[d],!r)return!1;p=p[d]}return!0}}e.ConfigurationChangeEvent=h;class g extends h{constructor(r,i,p,d){super({keys:r.allKeys(),overrides:[]},void 0,r,i);this.source=p,this.sourceConfig=d}}e.AllKeysConfigurationChangeEvent=g;function P(M,r){const{added:i,removed:p,updated:d}=l(r,M),s=[],v=M?.getAllOverrideIdentifiers()||[],y=r?.getAllOverrideIdentifiers()||[];if(r){const u=y.filter(D=>!v.includes(D));for(const D of u)s.push([D,r.getKeysForOverrideIdentifier(D)])}if(M){const u=v.filter(D=>!y.includes(D));for(const D of u)s.push([D,M.getKeysForOverrideIdentifier(D)])}if(r&&M){for(const u of v)if(y.includes(u)){const D=l({contents:M.getOverrideValue(void 0,u)||{},keys:M.getKeysForOverrideIdentifier(u)},{contents:r.getOverrideValue(void 0,u)||{},keys:r.getKeysForOverrideIdentifier(u)});s.push([u,[...D.added,...D.removed,...D.updated]])}}return{added:i,removed:p,updated:d,overrides:s}}function l(M,r){const i=M?r?M.keys.filter(s=>r.keys.indexOf(s)===-1):[...M.keys]:[],p=r?M?r.keys.filter(s=>M.keys.indexOf(s)===-1):[...r.keys]:[],d=[];if(M&&r){for(const s of r.keys)if(M.keys.indexOf(s)!==-1){const v=(0,F.getConfigurationValue)(r.contents,s),y=(0,F.getConfigurationValue)(M.contents,s);I.equals(v,y)||d.push(s)}}return{added:i,removed:p,updated:d}}}),define(Ee[84],ye([0,1,3]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,a.createDecorator)("remoteAuthorityResolverService");var t;(function(T){T.Unknown="Unknown",T.NotAvailable="NotAvailable",T.TemporarilyNotAvailable="TemporarilyNotAvailable",T.NoResolverFound="NoResolverFound"})(t=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class w extends Error{constructor(k,I=t.Unknown,S){super(k);this._message=k,this._code=I,this._detail=S,this.isHandled=I===t.NotAvailable&&S===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,w.prototype)}static isTemporarilyNotAvailable(k){return k instanceof w&&k._code===t.TemporarilyNotAvailable}static isNoResolverFound(k){return k instanceof w&&k._code===t.NoResolverFound}static isHandled(k){return k instanceof w&&k.isHandled}}e.RemoteAuthorityResolverError=w}),define(Ee[61],ye([0,1,10]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function t(R){return R.scheme===a.Schemas.vscodeRemote?R.authority:void 0}e.getRemoteAuthority=t;function w(R){if(!R)return;const F=R.indexOf("+");return F<0?R:R.substr(0,F)}e.getRemoteName=w;function T(R){return R.scheme!==a.Schemas.file&&R.scheme!==a.Schemas.vscodeRemote}e.isVirtualResource=T;function k(R){if(R.folders.length)return R.folders.every(F=>T(F.uri))?R.folders[0].uri:void 0;if(R.configuration&&T(R.configuration))return R.configuration}e.getVirtualWorkspaceLocation=k;function I(R){return k(R)?.scheme}e.getVirtualWorkspaceScheme=I;function S(R){return k(R)!==void 0}e.isVirtualWorkspace=S}),define(Ee[25],ye([0,1,9,3,61]),function(re,e,a,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function T(n){if(typeof n=="object"&&n!==null&&n.supported!==!0)return n.description}e.getWorkspaceSupportTypeMessage=T;function k(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.isIExtensionIdentifier=k,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var I;(function(n){n[n.System=0]="System",n[n.User=1]="User"})(I=e.ExtensionType||(e.ExtensionType={}));class S{constructor(f){this.value=f,this._lower=f.toLowerCase()}static equals(f,o){if(typeof f=="undefined"||f===null)return typeof o=="undefined"||o===null;if(typeof o=="undefined"||o===null)return!1;if(typeof f=="string"||typeof o=="string"){let m=typeof f=="string"?f:f.value,c=typeof o=="string"?o:o.value;return a.equalsIgnoreCase(m,c)}return f._lower===o._lower}static toKey(f){return typeof f=="string"?f.toLowerCase():f._lower}}e.ExtensionIdentifier=S;function R(n){return n.contributes&&n.contributes.localizations?n.contributes.localizations.length>0:!1}e.isLanguagePackExtension=R;function F(n){return n.contributes&&n.contributes.authentication?n.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=F;function _(n,f){if(f){const o=`onResolveRemoteAuthority:${(0,w.getRemoteName)(f)}`;return n.activationEvents?.indexOf(o)!==-1}return!1}e.isResolverExtension=_,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(Ee[143],ye([0,1,9,25]),function(re,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function w(o,m){return o.uuid&&m.uuid?o.uuid===m.uuid:o.id===m.id?!0:(0,a.compareIgnoreCase)(o.id,m.id)===0}e.areSameExtensions=w;class T{constructor(m,c){this.version=c,this.id=m.id,this.uuid=m.uuid}key(){return`${this.id}-${this.version}`}equals(m){return m instanceof T?w(this,m)&&this.version===m.version:!1}}e.ExtensionIdentifierWithVersion=T;function k(o,m){return`${o}.${m}`}e.getExtensionId=k;function I(o){return o.toLocaleLowerCase()}e.adoptToGalleryExtensionId=I;function S(o,m){return I(k(o,m))}e.getGalleryExtensionId=S;function R(o,m){const c=[],C=b=>{for(const h of c)if(h.some(g=>w(m(g),m(b))))return h;return null};for(const b of o){const h=C(b);h?h.push(b):c.push([b])}return c}e.groupByExtension=R;function F(o){return{id:o.identifier.id,name:o.manifest.name,galleryId:null,publisherId:o.publisherId,publisherName:o.manifest.publisher,publisherDisplayName:o.publisherDisplayName,dependencies:o.manifest.extensionDependencies&&o.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=F;function _(o){return{id:o.identifier.id,name:o.name,galleryId:o.identifier.uuid,publisherId:o.publisherId,publisherName:o.publisher,publisherDisplayName:o.publisherDisplayName,isPreReleaseVersion:o.properties.isPreReleaseVersion,dependencies:!!(o.properties.dependencies&&o.properties.dependencies.length>0),...o.telemetryData}}e.getGalleryExtensionTelemetryData=_,e.BetterMergeId=new t.ExtensionIdentifier("pprice.better-merge");function n(o){const m=new Set;if(o.malicious)for(const c of o.malicious)m.add(c.id);return m}e.getMaliciousExtensionsSet=n;function f(o,m){const c=[],C=m.manifest.extensionDependencies?.slice(0)??[];for(;C.length;){const b=C.shift();if(b&&c.every(h=>!w(h.identifier,{id:b}))){const h=o.filter(g=>w(g.identifier,{id:b}));h.length===1&&(c.push(h[0]),C.push(...h[0].manifest.extensionDependencies?.slice(0)??[]))}}return c}e.getExtensionDependencies=f}),define(Ee[144],ye([0,1,4,23,3,12]),function(re,e,a,t,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,w.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,w.createDecorator)("sharedTunnelsService");var k;(function(o){o.Http="http",o.Https="https"})(k=e.TunnelProtocol||(e.TunnelProtocol={}));var I;(function(o){o.ConstantPrivate="constantPrivate",o.Private="private",o.Public="public"})(I=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var S;(function(o){o[o.Notify=1]="Notify",o[o.OpenBrowser=2]="OpenBrowser",o[o.OpenPreview=3]="OpenPreview",o[o.Silent=4]="Silent",o[o.Ignore=5]="Ignore",o[o.OpenBrowserOnce=6]="OpenBrowserOnce"})(S=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function R(o){if(o.scheme!=="http"&&o.scheme!=="https")return;const m=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(o.authority);if(!!m)return{address:m[1],port:+m[2]}}e.extractLocalHostUriMetaDataForPortMapping=R,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function F(o){return e.LOCALHOST_ADDRESSES.indexOf(o)>=0}e.isLocalhost=F,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function _(o){return e.ALL_INTERFACES_ADDRESSES.indexOf(o)>=0}e.isAllInterfaces=_;function n(o,m){return m?m!==1&&o<1024:!t.isWindows&&o<1024}e.isPortPrivileged=n;let f=class{constructor(m){this.logService=m,this._onTunnelOpened=new a.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new a.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new a.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(m,c){return this._tunnelProvider=m,m?(this._canElevate=c.elevation,this._privacyOptions=c.privacyOptions,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const m=[],c=Array.from(this._tunnels.values());for(let C of c){const b=Array.from(C.values());for(let h of b){const g=await h.value;g&&m.push(g)}}return m}async dispose(){for(const m of this._tunnels.values()){for(const{value:c}of m.values())await c.then(C=>C?.dispose());m.clear()}this._tunnels.clear()}openTunnel(m,c,C,b,h=!1,g=I.Private,P){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${c}:${C} on local port ${b}.`),!m)return;c||(c="localhost");const l=this.retainOrCreateTunnel(m,c,C,b,h,g,P);return l?l.then(M=>{if(!M){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(c,C);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const r=this.makeTunnel(M);return(M.tunnelRemoteHost!==c||M.tunnelRemotePort!==C)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(r),r}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),l)}makeTunnel(m){return{tunnelRemotePort:m.tunnelRemotePort,tunnelRemoteHost:m.tunnelRemoteHost,tunnelLocalPort:m.tunnelLocalPort,localAddress:m.localAddress,privacy:m.privacy,protocol:m.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${m.tunnelRemoteHost}:${m.tunnelRemotePort} `);const c=this._tunnels.get(m.tunnelRemoteHost);if(c){const C=c.get(m.tunnelRemotePort);C&&(C.refcount--,await this.tryDisposeTunnel(m.tunnelRemoteHost,m.tunnelRemotePort,C))}}}}async tryDisposeTunnel(m,c,C){if(C.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${m}:${c}.`);const b=C.value.then(async h=>{h&&(await h.dispose(!0),this._onTunnelClosed.fire({host:h.tunnelRemoteHost,port:h.tunnelRemotePort}))});return this._tunnels.has(m)&&this._tunnels.get(m).delete(c),b}}async closeTunnel(m,c){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${m}:${c} `);const C=this._tunnels.get(m);if(C&&C.has(c)){const b=C.get(c);b.refcount=0,await this.tryDisposeTunnel(m,c,b)}}addTunnelToMap(m,c,C){this._tunnels.has(m)||this._tunnels.set(m,new Map),this._tunnels.get(m).set(c,{refcount:1,value:C})}async removeEmptyTunnelFromMap(m,c){const C=this._tunnels.get(m);C&&(await C.get(c)||C.delete(c),C.size===0&&this._tunnels.delete(m))}getTunnelFromMap(m,c){let C=[m];F(m)?(C.push(...e.LOCALHOST_ADDRESSES),C.push(...e.ALL_INTERFACES_ADDRESSES)):_(m)&&C.push(...e.ALL_INTERFACES_ADDRESSES);const b=C.map(h=>this._tunnels.get(h));for(const h of b){const g=h?.get(c);if(g)return g}}canTunnel(m){return!!R(m)}createWithProvider(m,c,C,b,h,g,P){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${c}:${C} on local port ${b}.`);const M={elevationRequired:h?n(b===void 0?C:b):!1},r={remoteAddress:{host:c,port:C},localAddressPort:b,privacy:g,public:g!==I.Private,protocol:P},i=m.forwardPort(r,M);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),i&&this.addTunnelToMap(c,C,i),i}};f=Ue([$e(0,T.ILogService)],f),e.AbstractTunnelService=f}),define(Ee[145],ye([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class a{constructor(w){this._callback=w,this._terminalBufferMap=new Map}dispose(){for(const w of this._terminalBufferMap.values())w.dispose()}startBuffering(w,T,k=5){let I;return I=T(S=>{const R=typeof S=="string"?S:S.data;let F=this._terminalBufferMap.get(w);if(F){F.data.push(R);return}const _=setTimeout(()=>this.flushBuffer(w),k);F={data:[R],timeoutId:_,dispose:()=>{clearTimeout(_),this.flushBuffer(w),I.dispose()}},this._terminalBufferMap.set(w,F)}),I}stopBuffering(w){const T=this._terminalBufferMap.get(w);T&&T.dispose()}flushBuffer(w){const T=this._terminalBufferMap.get(w);T&&(this._terminalBufferMap.delete(w),this._callback(w,T.data.join("")))}}e.TerminalDataBufferer=a}),define(Ee[146],ye([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var a;(function(t){t.DARK="dark",t.LIGHT="light",t.HIGH_CONTRAST="hc"})(a=e.ColorScheme||(e.ColorScheme={}))}),define(Ee[62],ye([0,1,51,4,6,3,36,146]),function(re,e,a,t,w,T,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,T.createDecorator)("themeService");var S;(function(c){function C(b){return b&&typeof b=="object"&&typeof b.id=="string"}c.isThemeColor=C})(S=e.ThemeColor||(e.ThemeColor={}));function R(c){return{id:c}}e.themeColorFromId=R;var F;(function(c){function C(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color=="undefined"||S.isThemeColor(i.color))}c.isThemeIcon=C;const b=new RegExp(`^\\$\\((${a.CSSIcon.iconNameExpression}(?:${a.CSSIcon.iconModifierExpression})?)\\)$`);function h(i){const p=b.exec(i);if(!p)return;let[,d]=p;return{id:d}}c.fromString=h;function g(i){return{id:i}}c.fromId=g;function P(i,p){let d=i.id;const s=d.lastIndexOf("~");return s!==-1&&(d=d.substring(0,s)),p&&(d=`${d}~${p}`),{id:d}}c.modify=P;function l(i){const p=i.id.lastIndexOf("~");if(p!==-1)return i.id.substring(p+1)}c.getModifier=l;function M(i,p){return i.id===p.id&&i.color?.id===p.color?.id}c.isEqual=M;function r(i,p){return{id:i.id,color:p?R(p):void 0}}c.asThemeIcon=r,c.asClassNameArray=a.CSSIcon.asClassNameArray,c.asClassName=a.CSSIcon.asClassName,c.asCSSSelector=a.CSSIcon.asCSSSelector})(F=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=a.Codicon.file,e.FolderThemeIcon=a.Codicon.folder;function _(c){switch(c){case I.ColorScheme.DARK:return"vs-dark";case I.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=_,e.Extensions={ThemingContribution:"base.contributions.theming"};class n{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new t.Emitter}onColorThemeChange(C){return this.themingParticipants.push(C),this.onThemingParticipantAddedEmitter.fire(C),(0,w.toDisposable)(()=>{const b=this.themingParticipants.indexOf(C);this.themingParticipants.splice(b,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let f=new n;k.Registry.add(e.Extensions.ThemingContribution,f);function o(c){return f.onColorThemeChange(c)}e.registerThemingParticipant=o;class m extends w.Disposable{constructor(C){super();this.themeService=C,this.theme=C.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(b=>this.onThemeChange(b)))}onThemeChange(C){this.theme=C,this.updateStyles()}updateStyles(){}getColor(C,b){let h=this.theme.getColor(C);return h&&b&&(h=b(h,this.theme)),h?h.toString():null}}e.Themable=m}),define(Ee[46],ye([0,1,21,24,2,3]),function(re,e,a,t,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,T.createDecorator)("contextService");var k;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(k=e.WorkbenchState||(e.WorkbenchState={}));function I(n){const f=n;return!!(f&&typeof f=="object"&&typeof f.id=="string"&&Array.isArray(f.folders))}e.isWorkspace=I;function S(n){const f=n;return!!(f&&typeof f=="object"&&w.URI.isUri(f.uri)&&typeof f.name=="string"&&typeof f.toResource=="function")}e.isWorkspaceFolder=S;class R{constructor(f,o,m,c,C){this._id=f,this._transient=m,this._configuration=c,this._ignorePathCasing=C,this._foldersMap=a.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=o}update(f){this._id=f.id,this._configuration=f.configuration,this._transient=f.transient,this._ignorePathCasing=f._ignorePathCasing,this.folders=f.folders}get folders(){return this._folders}set folders(f){this._folders=f,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(f){this._configuration=f}getFolder(f){return f&&this._foldersMap.findSubstr(f.with({scheme:f.scheme,authority:f.authority,path:f.path}))||null}updateFoldersMap(){this._foldersMap=a.TernarySearchTree.forUris(this._ignorePathCasing);for(const f of this.folders)this._foldersMap.set(f.uri,f)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=R;class F{constructor(f,o){this.raw=o,this.uri=f.uri,this.index=f.index,this.name=f.name}toResource(f){return(0,t.joinPath)(this.uri,f)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=F;function _(n){return new F({uri:n,index:0,name:(0,t.basenameOrAuthority)(n)},{uri:n.toString()})}e.toWorkspaceFolder=_}),define(Ee[63],ye([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class a{constructor(w){this.id=w,this._data=new Map,this._idPool=1}add(w){const T=this._idPool++;return this._data.set(T,w),this.logDebugInfo(),T}get(w,T){return this._data.has(w)?this._data.get(w)[T]:void 0}delete(w){this._data.delete(w),this.logDebugInfo()}logDebugInfo(){!a.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=a,a.enableDebugLogging=!1}),define(Ee[30],ye([0,1,10,24,3]),function(re,e,a,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class T{constructor(){this._systemSchemes=new Set(Object.keys(a.Schemas)),this._providerInfo=new Map,this.extUri=new t.ExtUri(I=>{const S=this._providerInfo.get(I.scheme);return!(S===void 0||S&1024)})}$acceptProviderInfos(I,S){S===null?this._providerInfo.delete(I.scheme):this._providerInfo.set(I.scheme,S)}isFreeScheme(I){return!this._providerInfo.has(I)&&!this._systemSchemes.has(I)}getCapabilities(I){return this._providerInfo.get(I)}}e.ExtHostFileSystemInfo=T,e.IExtHostFileSystemInfo=(0,w.createDecorator)("IExtHostFileSystemInfo")}),define(Ee[28],ye([0,1,3]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,a.createDecorator)("IExtHostInitDataService")}),define(Ee[147],ye([0,1,14]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class t{constructor(k,I,S){this._deferredPromises=new Map,this._id=k,this._shared=I,this._storage=S,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(R=>(this._value=R,this)),this._storageListener=this._storage.onDidChangeStorage(R=>{R.shared===this._shared&&R.key===this._id&&(this._value=R.value)}),this._scheduler=new a.RunOnceScheduler(()=>{const R=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const F of R.values())F.complete()}catch(F){for(const _ of R.values())_.error(F)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,k])=>k!==void 0).map(([k])=>k)}get whenReady(){return this._init}get(k,I){let S=this._value[k];return typeof S=="undefined"&&(S=I),S}update(k,I){this._value[k]=I;let S=this._deferredPromises.get(k);if(S!==void 0)return S.p;const R=new a.DeferredPromise;return this._deferredPromises.set(k,R),this._scheduler.isScheduled()||this._scheduler.schedule(),R.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=t;class w extends t{constructor(k,I){super(k.identifier.value,!0,I);this._extension=k}setKeysForSync(k){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},k)}}e.ExtensionGlobalMemento=w}),define(Ee[148],ye([0,1,4,2,12]),function(re,e,a,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let T=class{constructor(I,S){this._logService=I,this._notebooksAndEditors=S,this._onDidChangeNotebookDocumentMetadata=new a.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new a.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(I,S,R){this._notebooksAndEditors.getNotebookDocument(t.URI.revive(I)).acceptModelChanged(S.value,R)}$acceptDirtyStateChanged(I,S){this._notebooksAndEditors.getNotebookDocument(t.URI.revive(I)).acceptDirty(S)}$acceptModelSaved(I){const S=this._notebooksAndEditors.getNotebookDocument(t.URI.revive(I));this._onDidSaveNotebookDocument.fire(S.apiNotebook)}$acceptDocumentPropertiesChanged(I,S){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",I.path,S);const R=this._notebooksAndEditors.getNotebookDocument(t.URI.revive(I));R.acceptDocumentPropertiesChanged(S),S.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:R.apiNotebook})}};T=Ue([$e(0,w.ILogService)],T),e.ExtHostNotebookDocuments=T}),define(Ee[13],ye([0,1,3]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,a.createDecorator)("IExtHostRpcService");class t{constructor(T){this.getProxy=T.getProxy.bind(T),this.set=T.set.bind(T),this.assertRegistered=T.assertRegistered.bind(T),this.drain=T.drain.bind(T)}}e.ExtHostRpcService=t});var Ze=this&&this.__classPrivateFieldSet||function(re,e,a,t,w){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!w:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?w.call(re,a):w?w.value=a:e.set(re,a),a},Te=this&&this.__classPrivateFieldGet||function(re,e,a,t){if(a==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!t:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?t:a==="a"?t.call(re):t?t.value:e.get(re)};define(Ee[149],ye([0,1,25,4]),function(re,e,a,t){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class T{constructor(I,S){w.set(this,void 0),this._onDidChange=new t.Emitter,this.onDidChange=this._onDidChange.event,this._id=a.ExtensionIdentifier.toKey(I.identifier),Ze(this,w,S,"f"),Te(this,w,"f").onDidChangePassword(R=>{R.extensionId===this._id&&this._onDidChange.fire({key:R.key})})}get(I){return Te(this,w,"f").get(this._id,I)}store(I,S){return Te(this,w,"f").store(this._id,I,S)}delete(I){return Te(this,w,"f").delete(this._id,I)}}e.ExtensionSecrets=T,w=new WeakMap}),define(Ee[85],ye([0,1,3,4]),function(re,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class w{constructor(){this._onDidChangeTelemetryEnabled=new t.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(k){this._enabled=k}$onDidChangeTelemetryEnabled(k){this._enabled=k,this._onDidChangeTelemetryEnabled.fire(k)}}e.ExtHostTelemetry=w,e.IExtHostTelemetry=(0,a.createDecorator)("IExtHostTelemetry")}),define(Ee[47],ye([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var a;(function(b){b[b.Upsert=0]="Upsert",b[b.RemoveChild=1]="RemoveChild",b[b.Invalidated=2]="Invalidated",b[b.SetProp=3]="SetProp",b[b.Bulk=4]="Bulk"})(a=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const t=new WeakMap,w=(b,h)=>{const g={controllerId:h};return t.set(b,g),g};e.createPrivateApiFor=w;const T=b=>t.get(b);e.getPrivateApiFor=T;const k=(b,h,g,P)=>{let l=g;return{enumerable:!0,configurable:!1,get(){return l},set(M){if(!P(l,M)){const r=l;l=M,b.listener?.({op:3,key:h,value:M,previous:r})}}}},I=(b,h)=>b===h,S={range:(b,h)=>b===h?!0:!b||!h?!1:b.isEqual(h),label:I,description:I,busy:I,error:I,canResolveChildren:I,tags:(b,h)=>!(b.length!==h.length||b.some(g=>!h.find(P=>g.id===P.id)))},R=Object.keys(S),F=(b,h)=>({range:k(b,"range",void 0,S.range),label:k(b,"label",h,S.label),description:k(b,"description",void 0,S.description),canResolveChildren:k(b,"canResolveChildren",!1,S.canResolveChildren),busy:k(b,"busy",!1,S.busy),error:k(b,"error",void 0,S.error),tags:k(b,"tags",[],S.tags)}),_=(b,h)=>{const g=new Map;for(const P of R)S[P](b[P],h[P])||g.set(P,h[P]);return g};e.diffTestItems=_;class n extends Error{constructor(h){super(`Attempted to insert a duplicate test item ID ${h}`)}}e.DuplicateTestItemError=n;class f extends Error{constructor(h){super(`TestItem with ID "${h}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=f;class o extends Error{constructor(h,g,P){super(`TestItem with ID "${h}" is from controller "${g}" and cannot be added as a child of an item from controller "${P}".`)}}e.MixedTestItemController=o;const m=b=>{const h=(0,e.getPrivateApiFor)(b);let g=new Map;return{get size(){return g.size},forEach(P,l){for(const M of g.values())P.call(l,M,this)},replace(P){const l=new Map,M=new Set(g.keys()),r={op:4,ops:[]};for(const i of P){if(!(i instanceof c))throw new f(i.id);const p=(0,e.getPrivateApiFor)(i).controllerId;if(p!==h.controllerId)throw new o(i.id,p,h.controllerId);if(l.has(i.id))throw new n(i.id);l.set(i.id,i),M.delete(i.id),r.ops.push({op:0,item:i})}for(const i of M.keys())r.ops.push({op:1,id:i});h.listener?.(r),g=l},add(P){if(!(P instanceof c))throw new f(P.id);g.set(P.id,P),h.listener?.({op:0,item:P})},delete(P){g.delete(P)&&h.listener?.({op:1,id:P})},get(P){return g.get(P)},toJSON(){return Array.from(g.values())},[Symbol.iterator](){return g.values()}}};class c{constructor(h,g,P,l){if(g.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(g)} symbol`);const M=(0,e.createPrivateApiFor)(this,h);Object.defineProperties(this,{id:{value:g,enumerable:!0,writable:!1},uri:{value:l,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return M.parent instanceof C?void 0:M.parent}},children:{value:m(this),enumerable:!0,writable:!1},...F(M,P)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=c;class C extends c{constructor(h,g){super(h,h,g,void 0)}}e.TestItemRootImpl=C}),define(Ee[64],ye([0,1,3,144,4,13]),function(re,e,a,t,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var k;(function(S){function R(_){return{remoteAddress:_.remoteAddress,localAddress:_.localAddress,public:!!_.public,privacy:_.privacy??(_.public?t.TunnelPrivacyId.Public:t.TunnelPrivacyId.Private),protocol:_.protocol}}S.fromApiTunnel=R;function F(_){return{remoteAddress:{host:_.tunnelRemoteHost,port:_.tunnelRemotePort},localAddress:_.localAddress,public:_.privacy!==t.TunnelPrivacyId.ConstantPrivate&&_.privacy!==t.TunnelPrivacyId.ConstantPrivate,privacy:_.privacy,protocol:_.protocol}}S.fromServiceTunnel=F})(k=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,a.createDecorator)("IExtHostTunnelService");let I=class{constructor(R){this.onDidChangeTunnels=new w.Emitter().event}async $applyCandidateFilter(R){return R}async openTunnel(R,F){}async getTunnels(){return[]}async setTunnelExtensionFunctions(R){return{dispose:()=>{}}}registerPortsAttributesProvider(R,F){return{dispose:()=>{}}}async $providePortAttributes(R,F,_,n,f){return[]}async $forwardPort(R,F){}async $closeTunnel(R){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};I=Ue([$e(0,T.IExtHostRpcService)],I),e.ExtHostTunnelService=I});var Ze=this&&this.__classPrivateFieldSet||function(re,e,a,t,w){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!w:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?w.call(re,a):w?w.value=a:e.set(re,a),a},Te=this&&this.__classPrivateFieldGet||function(re,e,a,t){if(a==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!t:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?t:a==="a"?t.call(re):t?t.value:e.get(re)};define(Ee[7],ye([0,1,16,15,76,21,78,9,11,2,35,45,84]),function(re,e,a,t,w,T,k,I,S,R,F,_,n){"use strict";var f,o,m,c,C,b,h,g,P,l,M,r,i,p,d,s,v,y,u,D;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeDataTransfer=e.TreeDataTransferItem=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function A(x){function O(){return Reflect.construct(x,arguments,this.constructor)}return Object.defineProperty(O,"name",Object.getOwnPropertyDescriptor(x,"name")),Object.setPrototypeOf(O,x),Object.setPrototypeOf(O.prototype,x.prototype),O}let U=C=class{constructor(O){f.set(this,void 0),Ze(this,f,O,"f")}static from(...O){let Z=O;return new C(function(){if(Z){for(const _e of Z)_e&&typeof _e.dispose=="function"&&_e.dispose();Z=void 0}})}dispose(){typeof Te(this,f,"f")=="function"&&(Te(this,f,"f").call(this),Ze(this,f,void 0,"f"))}};f=new WeakMap,U=C=Ue([A],U),e.Disposable=U;let B=b=class{constructor(O,Z){if(O<0)throw(0,t.illegalArgument)("line must be non-negative");if(Z<0)throw(0,t.illegalArgument)("character must be non-negative");this._line=O,this._character=Z}static Min(...O){if(O.length===0)throw new TypeError;let Z=O[0];for(let _e=1;_e<O.length;_e++){const je=O[_e];je.isBefore(Z)&&(Z=je)}return Z}static Max(...O){if(O.length===0)throw new TypeError;let Z=O[0];for(let _e=1;_e<O.length;_e++){const je=O[_e];je.isAfter(Z)&&(Z=je)}return Z}static isPosition(O){if(!O)return!1;if(O instanceof b)return!0;let{line:Z,character:_e}=O;return typeof Z=="number"&&typeof _e=="number"}get line(){return this._line}get character(){return this._character}isBefore(O){return this._line<O._line?!0:O._line<this._line?!1:this._character<O._character}isBeforeOrEqual(O){return this._line<O._line?!0:O._line<this._line?!1:this._character<=O._character}isAfter(O){return!this.isBeforeOrEqual(O)}isAfterOrEqual(O){return!this.isBefore(O)}isEqual(O){return this._line===O._line&&this._character===O._character}compareTo(O){return this._line<O._line?-1:this._line>O.line?1:this._character<O._character?-1:this._character>O._character?1:0}translate(O,Z=0){if(O===null||Z===null)throw(0,t.illegalArgument)();let _e;return typeof O=="undefined"?_e=0:typeof O=="number"?_e=O:(_e=typeof O.lineDelta=="number"?O.lineDelta:0,Z=typeof O.characterDelta=="number"?O.characterDelta:0),_e===0&&Z===0?this:new b(this.line+_e,this.character+Z)}with(O,Z=this.character){if(O===null||Z===null)throw(0,t.illegalArgument)();let _e;return typeof O=="undefined"?_e=this.line:typeof O=="number"?_e=O:(_e=typeof O.line=="number"?O.line:this.line,Z=typeof O.character=="number"?O.character:this.character),_e===this.line&&Z===this.character?this:new b(_e,Z)}toJSON(){return{line:this.line,character:this.character}}};B=b=Ue([A],B),e.Position=B;let E=h=class{constructor(O,Z,_e,je){let tt,at;if(typeof O=="number"&&typeof Z=="number"&&typeof _e=="number"&&typeof je=="number"?(tt=new B(O,Z),at=new B(_e,je)):O instanceof B&&Z instanceof B&&(tt=O,at=Z),!tt||!at)throw new Error("Invalid arguments");tt.isBefore(at)?(this._start=tt,this._end=at):(this._start=at,this._end=tt)}static isRange(O){return O instanceof h?!0:O?B.isPosition(O.start)&&B.isPosition(O.end):!1}get start(){return this._start}get end(){return this._end}contains(O){return O instanceof h?this.contains(O._start)&&this.contains(O._end):O instanceof B?!(O.isBefore(this._start)||this._end.isBefore(O)):!1}isEqual(O){return this._start.isEqual(O._start)&&this._end.isEqual(O._end)}intersection(O){const Z=B.Max(O.start,this._start),_e=B.Min(O.end,this._end);if(!Z.isAfter(_e))return new h(Z,_e)}union(O){if(this.contains(O))return this;if(O.contains(this))return O;const Z=B.Min(O.start,this._start),_e=B.Max(O.end,this.end);return new h(Z,_e)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(O,Z=this.end){if(O===null||Z===null)throw(0,t.illegalArgument)();let _e;return O?B.isPosition(O)?_e=O:(_e=O.start||this.start,Z=O.end||this.end):_e=this.start,_e.isEqual(this._start)&&Z.isEqual(this.end)?this:new h(_e,Z)}toJSON(){return[this.start,this.end]}};E=h=Ue([A],E),e.Range=E;let N=g=class extends E{constructor(O,Z,_e,je){let tt,at;if(typeof O=="number"&&typeof Z=="number"&&typeof _e=="number"&&typeof je=="number"?(tt=new B(O,Z),at=new B(_e,je)):O instanceof B&&Z instanceof B&&(tt=O,at=Z),!tt||!at)throw new Error("Invalid arguments");super(tt,at);this._anchor=tt,this._active=at}static isSelection(O){return O instanceof g?!0:O?E.isRange(O)&&B.isPosition(O.anchor)&&B.isPosition(O.active)&&typeof O.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};N=g=Ue([A],N),e.Selection=N;class L{constructor(O,Z,_e){if(typeof O!="string"||O.length===0)throw(0,t.illegalArgument)("host");if(typeof Z!="number"||Z===0||Math.round(Z)!==Z)throw(0,t.illegalArgument)("port");if(typeof _e!="undefined"&&(typeof _e!="string"||_e.length===0||!/^[0-9A-Za-z\-]+$/.test(_e)))throw(0,t.illegalArgument)("connectionToken");this.host=O,this.port=Math.round(Z),this.connectionToken=_e}}e.ResolvedAuthority=L;class z extends Error{constructor(O,Z=n.RemoteAuthorityResolverErrorCode.Unknown,_e){super(O);this._message=O,this._code=Z,this._detail=_e,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,z.prototype)}static NotAvailable(O,Z){return new z(O,n.RemoteAuthorityResolverErrorCode.NotAvailable,Z)}static TemporarilyNotAvailable(O){return new z(O,n.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=z;var H;(function(x){x[x.LF=1]="LF",x[x.CRLF=2]="CRLF"})(H=e.EndOfLine||(e.EndOfLine={}));var j;(function(x){x[x.Replace=1]="Replace",x[x.Append=2]="Append",x[x.Prepend=3]="Prepend"})(j=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let ue=P=class{constructor(O,Z){this._range=O,this._newText=Z}static isTextEdit(O){return O instanceof P?!0:O?E.isRange(O)&&typeof O.newText=="string":!1}static replace(O,Z){return new P(O,Z)}static insert(O,Z){return P.replace(new E(O,O),Z)}static delete(O){return P.replace(O,"")}static setEndOfLine(O){const Z=new P(new E(new B(0,0),new B(0,0)),"");return Z.newEol=O,Z}get range(){return this._range}set range(O){if(O&&!E.isRange(O))throw(0,t.illegalArgument)("range");this._range=O}get newText(){return this._newText||""}set newText(O){if(O&&typeof O!="string")throw(0,t.illegalArgument)("newText");this._newText=O}get newEol(){return this._newEol}set newEol(O){if(O&&typeof O!="number")throw(0,t.illegalArgument)("newEol");this._newEol=O}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};ue=P=Ue([A],ue),e.TextEdit=ue;var G;(function(x){x[x.File=1]="File",x[x.Text=2]="Text",x[x.Cell=3]="Cell",x[x.CellReplace=5]="CellReplace"})(G=e.FileEditType||(e.FileEditType={}));let le=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(O,Z,_e,je){this._edits.push({_type:1,from:O,to:Z,options:_e,metadata:je})}createFile(O,Z,_e){this._edits.push({_type:1,from:void 0,to:O,options:Z,metadata:_e})}deleteFile(O,Z,_e){this._edits.push({_type:1,from:O,to:void 0,options:Z,metadata:_e})}replaceNotebookMetadata(O,Z,_e){this._edits.push({_type:3,metadata:_e,uri:O,edit:{editType:5,metadata:Z},notebookMetadata:Z})}replaceNotebookCells(O,Z,_e,je,tt){let at,dt,kt=[],Rt;if(Ae.isNotebookRange(Z)&&Ut.isNotebookCellDataArray(_e)&&!Ut.isNotebookCellDataArray(je)?(at=Z.start,dt=Z.end,kt=_e,Rt=je):typeof Z=="number"&&typeof _e=="number"&&Ut.isNotebookCellDataArray(je)&&(at=Z,dt=_e,kt=je,Rt=tt),at===void 0||dt===void 0)throw new Error("Invalid arguments");(at!==dt||kt.length>0)&&this._edits.push({_type:5,uri:O,index:at,count:dt-at,cells:kt,metadata:Rt})}replaceNotebookCellMetadata(O,Z,_e,je){this._edits.push({_type:3,metadata:je,uri:O,edit:{editType:8,index:Z,metadata:_e}})}replace(O,Z,_e,je){this._edits.push({_type:2,uri:O,edit:new ue(Z,_e),metadata:je})}insert(O,Z,_e,je){this.replace(O,new E(Z,Z),_e,je)}delete(O,Z,_e){this.replace(O,Z,"",_e)}has(O){return this._edits.some(Z=>Z._type===2&&Z.uri.toString()===O.toString())}set(O,Z){if(Z)for(const _e of Z)_e&&this._edits.push({_type:2,uri:O,edit:_e});else{for(let _e=0;_e<this._edits.length;_e++){const je=this._edits[_e];je._type===2&&je.uri.toString()===O.toString()&&(this._edits[_e]=void 0)}(0,a.coalesceInPlace)(this._edits)}}get(O){const Z=[];for(let _e of this._edits)_e._type===2&&_e.uri.toString()===O.toString()&&Z.push(_e.edit);return Z}entries(){const O=new T.ResourceMap;for(let Z of this._edits)if(Z._type===2){let _e=O.get(Z.uri);_e||(_e=[Z.uri,[]],O.set(Z.uri,_e)),_e[1].push(Z.edit)}return[...O.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};le=Ue([A],le),e.WorkspaceEdit=le;let ce=l=class{constructor(O){this._tabstop=1,this.value=O||""}static isSnippetString(O){return O instanceof l?!0:O?typeof O.value=="string":!1}static _escape(O){return O.replace(/\$|}|\\/g,"\\$&")}appendText(O){return this.value+=l._escape(O),this}appendTabstop(O=this._tabstop++){return this.value+="$",this.value+=O,this}appendPlaceholder(O,Z=this._tabstop++){if(typeof O=="function"){const _e=new l;_e._tabstop=this._tabstop,O(_e),this._tabstop=_e._tabstop,O=_e.value}else O=l._escape(O);return this.value+="${",this.value+=Z,this.value+=":",this.value+=O,this.value+="}",this}appendChoice(O,Z=this._tabstop++){const _e=O.map(je=>je.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=Z,this.value+="|",this.value+=_e,this.value+="|}",this}appendVariable(O,Z){if(typeof Z=="function"){const _e=new l;_e._tabstop=this._tabstop,Z(_e),this._tabstop=_e._tabstop,Z=_e.value}else typeof Z=="string"&&(Z=Z.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=O,Z&&(this.value+=":",this.value+=Z),this.value+="}",this}};ce=l=Ue([A],ce),e.SnippetString=ce;var Y;(function(x){x[x.Unnecessary=1]="Unnecessary",x[x.Deprecated=2]="Deprecated"})(Y=e.DiagnosticTag||(e.DiagnosticTag={}));var ie;(function(x){x[x.Hint=3]="Hint",x[x.Information=2]="Information",x[x.Warning=1]="Warning",x[x.Error=0]="Error"})(ie=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let we=M=class{constructor(O,Z){if(this.uri=O,Z)if(Z instanceof E)this.range=Z;else if(Z instanceof B)this.range=new E(Z,Z);else throw new Error("Illegal argument")}static isLocation(O){return O instanceof M?!0:O?E.isRange(O.range)&&R.URI.isUri(O.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};we=M=Ue([A],we),e.Location=we;let Me=class{constructor(O,Z){this.location=O,this.message=Z}static is(O){return O?typeof O.message=="string"&&O.location&&E.isRange(O.location.range)&&R.URI.isUri(O.location.uri):!1}static isEqual(O,Z){return O===Z?!0:!O||!Z?!1:O.message===Z.message&&O.location.range.isEqual(Z.location.range)&&O.location.uri.toString()===Z.location.uri.toString()}};Me=Ue([A],Me),e.DiagnosticRelatedInformation=Me;let Re=class{constructor(O,Z,_e=ie.Error){if(!E.isRange(O))throw new TypeError("range must be set");if(!Z)throw new TypeError("message must be set");this.range=O,this.message=Z,this.severity=_e}toJSON(){return{severity:ie[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(O,Z){return O===Z?!0:!O||!Z?!1:O.message===Z.message&&O.severity===Z.severity&&O.code===Z.code&&O.severity===Z.severity&&O.source===Z.source&&O.range.isEqual(Z.range)&&(0,a.equals)(O.tags,Z.tags)&&(0,a.equals)(O.relatedInformation,Z.relatedInformation,Me.isEqual)}};Re=Ue([A],Re),e.Diagnostic=Re;let Be=class{constructor(O,Z){if(!O)throw new Error("Illegal argument, contents must be defined");Array.isArray(O)?this.contents=O:this.contents=[O],this.range=Z}};Be=Ue([A],Be),e.Hover=Be;var Qe;(function(x){x[x.Text=0]="Text",x[x.Read=1]="Read",x[x.Write=2]="Write"})(Qe=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Ke=class{constructor(O,Z=Qe.Text){this.range=O,this.kind=Z}toJSON(){return{range:this.range,kind:Qe[this.kind]}}};Ke=Ue([A],Ke),e.DocumentHighlight=Ke;var Xe;(function(x){x[x.File=0]="File",x[x.Module=1]="Module",x[x.Namespace=2]="Namespace",x[x.Package=3]="Package",x[x.Class=4]="Class",x[x.Method=5]="Method",x[x.Property=6]="Property",x[x.Field=7]="Field",x[x.Constructor=8]="Constructor",x[x.Enum=9]="Enum",x[x.Interface=10]="Interface",x[x.Function=11]="Function",x[x.Variable=12]="Variable",x[x.Constant=13]="Constant",x[x.String=14]="String",x[x.Number=15]="Number",x[x.Boolean=16]="Boolean",x[x.Array=17]="Array",x[x.Object=18]="Object",x[x.Key=19]="Key",x[x.Null=20]="Null",x[x.EnumMember=21]="EnumMember",x[x.Struct=22]="Struct",x[x.Event=23]="Event",x[x.Operator=24]="Operator",x[x.TypeParameter=25]="TypeParameter"})(Xe=e.SymbolKind||(e.SymbolKind={}));var $;(function(x){x[x.Deprecated=1]="Deprecated"})($=e.SymbolTag||(e.SymbolTag={}));let K=r=class{constructor(O,Z,_e,je,tt){this.name=O,this.kind=Z,this.containerName=tt,typeof _e=="string"&&(this.containerName=_e),je instanceof we?this.location=je:_e instanceof E&&(this.location=new we(je,_e)),r.validate(this)}static validate(O){if(!O.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Xe[this.kind],location:this.location,containerName:this.containerName}}};K=r=Ue([A],K),e.SymbolInformation=K;let J=i=class{constructor(O,Z,_e,je,tt){this.name=O,this.detail=Z,this.kind=_e,this.range=je,this.selectionRange=tt,this.children=[],i.validate(this)}static validate(O){if(!O.name)throw new Error("name must not be falsy");if(!O.range.contains(O.selectionRange))throw new Error("selectionRange must be contained in fullRange");O.children&&O.children.forEach(i.validate)}};J=i=Ue([A],J),e.DocumentSymbol=J;var ae;(function(x){x[x.Invoke=1]="Invoke",x[x.Automatic=2]="Automatic"})(ae=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let q=class{constructor(O,Z){this.title=O,this.kind=Z}};q=Ue([A],q),e.CodeAction=q;let te=p=class{constructor(O){this.value=O}append(O){return new p(this.value?this.value+p.sep+O:O)}intersects(O){return this.contains(O)||O.contains(this)}contains(O){return this.value===O.value||O.value.startsWith(this.value+p.sep)}};te.sep=".",te=p=Ue([A],te),e.CodeActionKind=te,te.Empty=new te(""),te.QuickFix=te.Empty.append("quickfix"),te.Refactor=te.Empty.append("refactor"),te.RefactorExtract=te.Refactor.append("extract"),te.RefactorInline=te.Refactor.append("inline"),te.RefactorRewrite=te.Refactor.append("rewrite"),te.Source=te.Empty.append("source"),te.SourceOrganizeImports=te.Source.append("organizeImports"),te.SourceFixAll=te.Source.append("fixAll");let me=class{constructor(O,Z){if(this.range=O,this.parent=Z,Z&&!Z.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};me=Ue([A],me),e.SelectionRange=me;class Pe{constructor(O,Z,_e,je,tt,at){this.kind=O,this.name=Z,this.detail=_e,this.uri=je,this.range=tt,this.selectionRange=at}}e.CallHierarchyItem=Pe;class Ne{constructor(O,Z){this.fromRanges=Z,this.from=O}}e.CallHierarchyIncomingCall=Ne;class He{constructor(O,Z){this.fromRanges=Z,this.to=O}}e.CallHierarchyOutgoingCall=He;var Ye;(function(x){x[x.Information=0]="Information",x[x.Warning=1]="Warning",x[x.Error=2]="Error"})(Ye=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let et=class{constructor(O,Z){this.range=O,this.command=Z}get isResolved(){return!!this.command}};et=Ue([A],et),e.CodeLens=et;let st=d=class{constructor(O,Z=!1){o.set(this,void 0),Ze(this,o,new w.MarkdownString(O,{supportThemeIcons:Z}),"f")}static isMarkdownString(O){return O instanceof d?!0:O&&O.appendCodeblock&&O.appendMarkdown&&O.appendText&&O.value!==void 0}get value(){return Te(this,o,"f").value}set value(O){Te(this,o,"f").value=O}get isTrusted(){return Te(this,o,"f").isTrusted}set isTrusted(O){Te(this,o,"f").isTrusted=O}get supportThemeIcons(){return Te(this,o,"f").supportThemeIcons}set supportThemeIcons(O){Te(this,o,"f").supportThemeIcons=O}get supportHtml(){return Te(this,o,"f").supportHtml}set supportHtml(O){Te(this,o,"f").supportHtml=O}appendText(O){return Te(this,o,"f").appendText(O),this}appendMarkdown(O){return Te(this,o,"f").appendMarkdown(O),this}appendCodeblock(O,Z){return Te(this,o,"f").appendCodeblock(Z??"",O),this}};o=new WeakMap,st=d=Ue([A],st),e.MarkdownString=st;let Je=class{constructor(O,Z){this.label=O,this.documentation=Z}};Je=Ue([A],Je),e.ParameterInformation=Je;let nt=class{constructor(O,Z){this.label=O,this.documentation=Z,this.parameters=[]}};nt=Ue([A],nt),e.SignatureInformation=nt;let lt=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};lt=Ue([A],lt),e.SignatureHelp=lt;var pt;(function(x){x[x.Invoke=1]="Invoke",x[x.TriggerCharacter=2]="TriggerCharacter",x[x.ContentChange=3]="ContentChange"})(pt=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Ft;(function(x){x[x.Other=0]="Other",x[x.Type=1]="Type",x[x.Parameter=2]="Parameter"})(Ft=e.InlayHintKind||(e.InlayHintKind={}));let Fe=class{constructor(O,Z,_e){this.text=O,this.position=Z,this.kind=_e}};Fe=Ue([A],Fe),e.InlayHint=Fe;var Mt;(function(x){x[x.Invoke=0]="Invoke",x[x.TriggerCharacter=1]="TriggerCharacter",x[x.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Mt=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var V;(function(x){x[x.Text=0]="Text",x[x.Method=1]="Method",x[x.Function=2]="Function",x[x.Constructor=3]="Constructor",x[x.Field=4]="Field",x[x.Variable=5]="Variable",x[x.Class=6]="Class",x[x.Interface=7]="Interface",x[x.Module=8]="Module",x[x.Property=9]="Property",x[x.Unit=10]="Unit",x[x.Value=11]="Value",x[x.Enum=12]="Enum",x[x.Keyword=13]="Keyword",x[x.Snippet=14]="Snippet",x[x.Color=15]="Color",x[x.File=16]="File",x[x.Reference=17]="Reference",x[x.Folder=18]="Folder",x[x.EnumMember=19]="EnumMember",x[x.Constant=20]="Constant",x[x.Struct=21]="Struct",x[x.Event=22]="Event",x[x.Operator=23]="Operator",x[x.TypeParameter=24]="TypeParameter",x[x.User=25]="User",x[x.Issue=26]="Issue"})(V=e.CompletionItemKind||(e.CompletionItemKind={}));var Q;(function(x){x[x.Deprecated=1]="Deprecated"})(Q=e.CompletionItemTag||(e.CompletionItemTag={}));let he=class{constructor(O,Z){this.label=O,this.kind=Z}toJSON(){return{label:this.label,kind:this.kind&&V[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};he=Ue([A],he),e.CompletionItem=he;let Le=class{constructor(O=[],Z=!1){this.items=O,this.isIncomplete=Z}};Le=Ue([A],Le),e.CompletionList=Le;let We=class{constructor(O,Z,_e){this.text=O,this.range=Z,this.command=_e}};We=Ue([A],We),e.InlineSuggestion=We;let ot=class{constructor(O){this.items=O}};ot=Ue([A],ot),e.InlineSuggestions=ot;var Ge;(function(x){x[x.Active=-1]="Active",x[x.Beside=-2]="Beside",x[x.One=1]="One",x[x.Two=2]="Two",x[x.Three=3]="Three",x[x.Four=4]="Four",x[x.Five=5]="Five",x[x.Six=6]="Six",x[x.Seven=7]="Seven",x[x.Eight=8]="Eight",x[x.Nine=9]="Nine"})(Ge=e.ViewColumn||(e.ViewColumn={}));var yt;(function(x){x[x.Left=1]="Left",x[x.Right=2]="Right"})(yt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Ie;(function(x){x[x.Off=0]="Off",x[x.On=1]="On",x[x.Relative=2]="Relative"})(Ie=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Ce;(function(x){x[x.Manual=1]="Manual",x[x.AfterDelay=2]="AfterDelay",x[x.FocusOut=3]="FocusOut"})(Ce=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var ve;(function(x){x[x.Default=0]="Default",x[x.InCenter=1]="InCenter",x[x.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",x[x.AtTop=3]="AtTop"})(ve=e.TextEditorRevealType||(e.TextEditorRevealType={}));var oe;(function(x){x[x.Keyboard=1]="Keyboard",x[x.Mouse=2]="Mouse",x[x.Command=3]="Command"})(oe=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var se;(function(x){x[x.Undo=1]="Undo",x[x.Redo=2]="Redo"})(se=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var fe;(function(x){x[x.OpenOpen=0]="OpenOpen",x[x.ClosedClosed=1]="ClosedClosed",x[x.OpenClosed=2]="OpenClosed",x[x.ClosedOpen=3]="ClosedOpen"})(fe=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(x){function O(Z){switch(Z){case"keyboard":return x.Keyboard;case"mouse":return x.Mouse;case"api":return x.Command}}x.fromValue=O}(oe=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let ge=class{constructor(O,Z){if(Z&&!R.URI.isUri(Z))throw(0,t.illegalArgument)("target");if(!E.isRange(O)||O.isEmpty)throw(0,t.illegalArgument)("range");this.range=O,this.target=Z}};ge=Ue([A],ge),e.DocumentLink=ge;let ke=class{constructor(O,Z,_e,je){this.red=O,this.green=Z,this.blue=_e,this.alpha=je}};ke=Ue([A],ke),e.Color=ke;let ze=class{constructor(O,Z){if(Z&&!(Z instanceof ke))throw(0,t.illegalArgument)("color");if(!E.isRange(O)||O.isEmpty)throw(0,t.illegalArgument)("range");this.range=O,this.color=Z}};ze=Ue([A],ze),e.ColorInformation=ze;let Oe=class{constructor(O){if(!O||typeof O!="string")throw(0,t.illegalArgument)("label");this.label=O}};Oe=Ue([A],Oe),e.ColorPresentation=Oe;var Ve;(function(x){x[x.RGB=0]="RGB",x[x.HEX=1]="HEX",x[x.HSL=2]="HSL"})(Ve=e.ColorFormat||(e.ColorFormat={}));var it;(function(x){x[x.Error=0]="Error",x[x.Warning=1]="Warning",x[x.Information=2]="Information"})(it=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class rt{constructor(O,Z,_e){if(this.startIndex=O,this.length=Z,this.tooltip=_e,typeof O!="number"||O<0)throw(0,t.illegalArgument)("startIndex");if(typeof Z!="number"||Z<1)throw(0,t.illegalArgument)("length");if(_e!==void 0&&typeof _e!="string")throw(0,t.illegalArgument)("tooltip")}}e.TerminalLink=rt;var ne;(function(x){x[x.Panel=1]="Panel",x[x.Editor=2]="Editor"})(ne=e.TerminalLocation||(e.TerminalLocation={}));class pe{constructor(O){this.options=O,typeof O!="object"&&(0,t.illegalArgument)("options")}}e.TerminalProfile=pe;var ee;(function(x){x[x.Always=1]="Always",x[x.Silent=2]="Silent",x[x.Never=3]="Never"})(ee=e.TaskRevealKind||(e.TaskRevealKind={}));var W;(function(x){x[x.Shared=1]="Shared",x[x.Dedicated=2]="Dedicated",x[x.New=3]="New"})(W=e.TaskPanelKind||(e.TaskPanelKind={}));let be=s=class{constructor(O,Z){if(this.label=Z,typeof O!="string"||typeof Z!="string")throw(0,t.illegalArgument)("name");this._id=O}static from(O){switch(O){case"clean":return s.Clean;case"build":return s.Build;case"rebuild":return s.Rebuild;case"test":return s.Test;default:return}}get id(){return this._id}};be.Clean=new s("clean","Clean"),be.Build=new s("build","Build"),be.Rebuild=new s("rebuild","Rebuild"),be.Test=new s("test","Test"),be=s=Ue([A],be),e.TaskGroup=be;function De(x){let O="";for(let Z=0;Z<x.length;Z++)O+=x[Z].replace(/,/g,",,")+",";return O}let qe=class{constructor(O,Z,_e){if(typeof O!="string")throw(0,t.illegalArgument)("process");this._args=[],this._process=O,Z!==void 0&&(Array.isArray(Z)?(this._args=Z,this._options=_e):this._options=Z)}get process(){return this._process}set process(O){if(typeof O!="string")throw(0,t.illegalArgument)("process");this._process=O}get args(){return this._args}set args(O){Array.isArray(O)||(O=[]),this._args=O}get options(){return this._options}set options(O){this._options=O}computeId(){const O=[];if(O.push("process"),this._process!==void 0&&O.push(this._process),this._args&&this._args.length>0)for(let Z of this._args)O.push(Z);return De(O)}};qe=Ue([A],qe),e.ProcessExecution=qe;let xe=class{constructor(O,Z,_e){if(this._args=[],Array.isArray(Z)){if(!O)throw(0,t.illegalArgument)("command can't be undefined or null");if(typeof O!="string"&&typeof O.value!="string")throw(0,t.illegalArgument)("command");this._command=O,this._args=Z,this._options=_e}else{if(typeof O!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=O,this._options=Z}}get commandLine(){return this._commandLine}set commandLine(O){if(typeof O!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=O}get command(){return this._command?this._command:""}set command(O){if(typeof O!="string"&&typeof O.value!="string")throw(0,t.illegalArgument)("command");this._command=O}get args(){return this._args}set args(O){this._args=O||[]}get options(){return this._options}set options(O){this._options=O}computeId(){const O=[];if(O.push("shell"),this._commandLine!==void 0&&O.push(this._commandLine),this._command!==void 0&&O.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let Z of this._args)O.push(typeof Z=="string"?Z:Z.value);return De(O)}};xe=Ue([A],xe),e.ShellExecution=xe;var ut;(function(x){x[x.Escape=1]="Escape",x[x.Strong=2]="Strong",x[x.Weak=3]="Weak"})(ut=e.ShellQuoting||(e.ShellQuoting={}));var vt;(function(x){x[x.Global=1]="Global",x[x.Workspace=2]="Workspace"})(vt=e.TaskScope||(e.TaskScope={}));class St{constructor(O){this._callback=O}computeId(){return"customExecution"+(0,F.generateUuid)()}set callback(O){this._callback=O}get callback(){return this._callback}}e.CustomExecution=St;let bt=v=class{constructor(O,Z,_e,je,tt,at){this.__deprecated=!1,this._definition=this.definition=O;let dt;typeof Z=="string"?(this._name=this.name=Z,this._source=this.source=_e,this.execution=je,dt=tt,this.__deprecated=!0):Z===vt.Global||Z===vt.Workspace?(this.target=Z,this._name=this.name=_e,this._source=this.source=je,this.execution=tt,dt=at):(this.target=Z,this._name=this.name=_e,this._source=this.source=je,this.execution=tt,dt=at),typeof dt=="string"?(this._problemMatchers=[dt],this._hasDefinedMatchers=!0):Array.isArray(dt)?(this._problemMatchers=dt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(O){this.__id=O}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof qe?this._definition={type:v.ProcessType,id:this._execution.computeId()}:this._execution instanceof xe?this._definition={type:v.ShellType,id:this._execution.computeId()}:this._execution instanceof St?this._definition={type:v.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:v.EmptyType,id:(0,F.generateUuid)()}}get definition(){return this._definition}set definition(O){if(O==null)throw(0,t.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=O}get scope(){return this._scope}set target(O){this.clear(),this._scope=O}get name(){return this._name}set name(O){if(typeof O!="string")throw(0,t.illegalArgument)("name");this.clear(),this._name=O}get execution(){return this._execution}set execution(O){O===null&&(O=void 0),this.clear(),this._execution=O;const Z=this._definition.type;(v.EmptyType===Z||v.ProcessType===Z||v.ShellType===Z||v.ExtensionCallbackType===Z)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(O){if(Array.isArray(O))this.clear(),this._problemMatchers=O,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(O){O!==!0&&O!==!1&&(O=!1),this.clear(),this._isBackground=O}get source(){return this._source}set source(O){if(typeof O!="string"||O.length===0)throw(0,t.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=O}get group(){return this._group}set group(O){O===null&&(O=void 0),this.clear(),this._group=O}get detail(){return this._detail}set detail(O){O===null&&(O=void 0),this._detail=O}get presentationOptions(){return this._presentationOptions}set presentationOptions(O){O==null&&(O=Object.create(null)),this.clear(),this._presentationOptions=O}get runOptions(){return this._runOptions}set runOptions(O){O==null&&(O=Object.create(null)),this.clear(),this._runOptions=O}};bt.ExtensionCallbackType="customExecution",bt.ProcessType="process",bt.ShellType="shell",bt.EmptyType="$empty",bt=v=Ue([A],bt),e.Task=bt;var ht;(function(x){x[x.SourceControl=1]="SourceControl",x[x.Window=10]="Window",x[x.Notification=15]="Notification"})(ht=e.ProgressLocation||(e.ProgressLocation={}));let gt=class{constructor(O,Z=_t.None){this.collapsibleState=Z,R.URI.isUri(O)?this.resourceUri=O:this.label=O}};gt=Ue([A],gt),e.TreeItem=gt;var _t;(function(x){x[x.None=0]="None",x[x.Collapsed=1]="Collapsed",x[x.Expanded=2]="Expanded"})(_t=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let Lt=class{constructor(O){this._value=O}async asString(){return JSON.stringify(this._value)}};Lt=Ue([A],Lt),e.TreeDataTransferItem=Lt;let It=class{constructor(){this._items=new Map}get(O){return this._items.get(O)}set(O,Z){this._items.set(O,Z)}forEach(O){this._items.forEach(O)}};It=Ue([A],It),e.TreeDataTransfer=It;let Pt=class{constructor(O,Z){this.id=O,this.color=Z}};Pt=Ue([A],Pt),e.ThemeIcon=Pt,Pt.File=new Pt("file"),Pt.Folder=new Pt("folder");let At=class{constructor(O){this.id=O}};At=Ue([A],At),e.ThemeColor=At;var Et;(function(x){x[x.Global=1]="Global",x[x.Workspace=2]="Workspace",x[x.WorkspaceFolder=3]="WorkspaceFolder"})(Et=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Ot=class{constructor(O,Z){if(typeof O!="string"&&(!O||!R.URI.isUri(O)&&!R.URI.isUri(O.uri)))throw(0,t.illegalArgument)("base");if(typeof Z!="string")throw(0,t.illegalArgument)("pattern");typeof O=="string"?(this.baseFolder=R.URI.file(O),this.base=O):R.URI.isUri(O)?(this.baseFolder=O,this.base=O.fsPath):(this.baseFolder=O.uri,this.base=O.uri.fsPath),this.pattern=Z}};Ot=Ue([A],Ot),e.RelativePattern=Ot;let Nt=class{constructor(O,Z,_e,je){this.enabled=typeof O=="boolean"?O:!0,typeof Z=="string"&&(this.condition=Z),typeof _e=="string"&&(this.hitCondition=_e),typeof je=="string"&&(this.logMessage=je)}get id(){return this._id||(this._id=(0,F.generateUuid)()),this._id}};Nt=Ue([A],Nt),e.Breakpoint=Nt;let wt=class extends Nt{constructor(O,Z,_e,je,tt){super(Z,_e,je,tt);if(O===null)throw(0,t.illegalArgument)("location");this.location=O}};wt=Ue([A],wt),e.SourceBreakpoint=wt;let $t=class extends Nt{constructor(O,Z,_e,je,tt){super(Z,_e,je,tt);this.functionName=O}};$t=Ue([A],$t),e.FunctionBreakpoint=$t;let jt=class extends Nt{constructor(O,Z,_e,je,tt,at,dt){super(je,tt,at,dt);if(!Z)throw(0,t.illegalArgument)("dataId");this.label=O,this.dataId=Z,this.canPersist=_e}};jt=Ue([A],jt),e.DataBreakpoint=jt;let oi=class{constructor(O,Z,_e){this.command=O,this.args=Z||[],this.options=_e}};oi=Ue([A],oi),e.DebugAdapterExecutable=oi;let si=class{constructor(O,Z){this.port=O,this.host=Z}};si=Ue([A],si),e.DebugAdapterServer=si;let Tt=class{constructor(O){this.path=O}};Tt=Ue([A],Tt),e.DebugAdapterNamedPipeServer=Tt;let Yt=class{constructor(O){this.implementation=O}};Yt=Ue([A],Yt),e.DebugAdapterInlineImplementation=Yt;let ai=class{constructor(O,Z){this.range=O,this.expression=Z}};ai=Ue([A],ai),e.EvaluatableExpression=ai;var Xt;(function(x){x[x.Automatic=0]="Automatic",x[x.Explicit=1]="Explicit"})(Xt=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Vt=class{constructor(O,Z){this.range=O,this.text=Z}};Vt=Ue([A],Vt),e.InlineValueText=Vt;let mt=class{constructor(O,Z,_e=!0){this.range=O,this.variableName=Z,this.caseSensitiveLookup=_e}};mt=Ue([A],mt),e.InlineValueVariableLookup=mt;let li=class{constructor(O,Z){this.range=O,this.expression=Z}};li=Ue([A],li),e.InlineValueEvaluatableExpression=li;let xt=class{constructor(O,Z){this.frameId=O,this.stoppedLocation=Z}};xt=Ue([A],xt),e.InlineValueContext=xt;var qt;(function(x){x[x.Changed=1]="Changed",x[x.Created=2]="Created",x[x.Deleted=3]="Deleted"})(qt=e.FileChangeType||(e.FileChangeType={}));let Jt=y=class extends Error{constructor(O,Z=_.FileSystemProviderErrorCode.Unknown,_e){super(R.URI.isUri(O)?O.toString(!0):O);this.code=_e?.name??"Unknown",(0,_.markAsFileSystemProviderError)(this,Z),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,y.prototype),typeof Error.captureStackTrace=="function"&&typeof _e=="function"&&Error.captureStackTrace(this,_e)}static FileExists(O){return new y(O,_.FileSystemProviderErrorCode.FileExists,y.FileExists)}static FileNotFound(O){return new y(O,_.FileSystemProviderErrorCode.FileNotFound,y.FileNotFound)}static FileNotADirectory(O){return new y(O,_.FileSystemProviderErrorCode.FileNotADirectory,y.FileNotADirectory)}static FileIsADirectory(O){return new y(O,_.FileSystemProviderErrorCode.FileIsADirectory,y.FileIsADirectory)}static NoPermissions(O){return new y(O,_.FileSystemProviderErrorCode.NoPermissions,y.NoPermissions)}static Unavailable(O){return new y(O,_.FileSystemProviderErrorCode.Unavailable,y.Unavailable)}};Jt=y=Ue([A],Jt),e.FileSystemError=Jt;let ci=class{constructor(O,Z,_e){this.start=O,this.end=Z,this.kind=_e}};ci=Ue([A],ci),e.FoldingRange=ci;var fi;(function(x){x[x.Comment=1]="Comment",x[x.Imports=2]="Imports",x[x.Region=3]="Region"})(fi=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Ei;(function(x){x[x.Collapsed=0]="Collapsed",x[x.Expanded=1]="Expanded"})(Ei=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var mi;(function(x){x[x.Editing=0]="Editing",x[x.Preview=1]="Preview"})(mi=e.CommentMode||(e.CommentMode={}));class Zt{constructor(O,Z=[]){this.tokenTypes=O,this.tokenModifiers=Z}}e.SemanticTokensLegend=Zt;function yi(x){return typeof x=="undefined"||(0,S.isStringArray)(x)}class Kt{constructor(O){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,O){this._hasLegend=!0;for(let Z=0,_e=O.tokenTypes.length;Z<_e;Z++)this._tokenTypeStrToInt.set(O.tokenTypes[Z],Z);for(let Z=0,_e=O.tokenModifiers.length;Z<_e;Z++)this._tokenModifierStrToInt.set(O.tokenModifiers[Z],Z)}}push(O,Z,_e,je,tt){if(typeof O=="number"&&typeof Z=="number"&&typeof _e=="number"&&typeof je=="number"&&(typeof tt=="number"||typeof tt=="undefined"))return typeof tt=="undefined"&&(tt=0),this._pushEncoded(O,Z,_e,je,tt);if(E.isRange(O)&&typeof Z=="string"&&yi(_e))return this._push(O,Z,_e);throw(0,t.illegalArgument)()}_push(O,Z,_e){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(O.start.line!==O.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(Z))throw new Error("`tokenType` is not in the provided legend");const je=O.start.line,tt=O.start.character,at=O.end.character-O.start.character,dt=this._tokenTypeStrToInt.get(Z);let kt=0;if(_e)for(const Rt of _e){if(!this._tokenModifierStrToInt.has(Rt))throw new Error("`tokenModifier` is not in the provided legend");const Bt=this._tokenModifierStrToInt.get(Rt);kt|=1<<Bt>>>0}this._pushEncoded(je,tt,at,dt,kt)}_pushEncoded(O,Z,_e,je,tt){if(this._dataIsSortedAndDeltaEncoded&&(O<this._prevLine||O===this._prevLine&&Z<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const kt=this._data.length/5|0;let Rt=0,Bt=0;for(let Ht=0;Ht<kt;Ht++){let zt=this._data[5*Ht],di=this._data[5*Ht+1];zt===0?(zt=Rt,di+=Bt):zt+=Rt,this._data[5*Ht]=zt,this._data[5*Ht+1]=di,Rt=zt,Bt=di}}let at=O,dt=Z;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(at-=this._prevLine,at===0&&(dt-=this._prevChar)),this._data[this._dataLen++]=at,this._data[this._dataLen++]=dt,this._data[this._dataLen++]=_e,this._data[this._dataLen++]=je,this._data[this._dataLen++]=tt,this._prevLine=O,this._prevChar=Z}static _sortAndDeltaEncode(O){let Z=[];const _e=O.length/5|0;for(let dt=0;dt<_e;dt++)Z[dt]=dt;Z.sort((dt,kt)=>{const Rt=O[5*dt],Bt=O[5*kt];if(Rt===Bt){const Ht=O[5*dt+1],zt=O[5*kt+1];return Ht-zt}return Rt-Bt});const je=new Uint32Array(O.length);let tt=0,at=0;for(let dt=0;dt<_e;dt++){const kt=5*Z[dt],Rt=O[kt+0],Bt=O[kt+1],Ht=O[kt+2],zt=O[kt+3],di=O[kt+4],Hi=Rt-tt,Yi=Hi===0?Bt-at:Bt,hi=5*dt;je[hi+0]=Hi,je[hi+1]=Yi,je[hi+2]=Ht,je[hi+3]=zt,je[hi+4]=di,tt=Rt,at=Bt}return je}build(O){return this._dataIsSortedAndDeltaEncoded?new Gt(new Uint32Array(this._data),O):new Gt(Kt._sortAndDeltaEncode(this._data),O)}}e.SemanticTokensBuilder=Kt;class Gt{constructor(O,Z){this.resultId=Z,this.data=O}}e.SemanticTokens=Gt;class _i{constructor(O,Z,_e){this.start=O,this.deleteCount=Z,this.data=_e}}e.SemanticTokensEdit=_i;class Ci{constructor(O,Z){this.resultId=Z,this.edits=O}}e.SemanticTokensEdits=Ci;var Qt;(function(x){x[x.Separate=0]="Separate",x[x.MergeWithParent=1]="MergeWithParent"})(Qt=e.DebugConsoleMode||(e.DebugConsoleMode={}));var Si;(function(x){x[x.Initial=1]="Initial",x[x.Dynamic=2]="Dynamic"})(Si=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let ei=class{constructor(){}};ei.Back={iconPath:new Pt("arrow-left")},ei=Ue([A],ei),e.QuickInputButtons=ei;var Di;(function(x){x[x.Default=1]="Default",x[x.Separator=2]="Separator"})(Di=e.QuickPickItemKind||(e.QuickPickItemKind={}));var ki;(function(x){x[x.UI=1]="UI",x[x.Workspace=2]="Workspace"})(ki=e.ExtensionKind||(e.ExtensionKind={}));class ui{constructor(O,Z,_e){this.badge=O,this.tooltip=Z,this.color=_e}static validate(O){if(O.badge){let Z=(0,I.nextCharLength)(O.badge,0);if(Z<O.badge.length&&(Z+=(0,I.nextCharLength)(O.badge,Z)),O.badge.length>Z)throw new Error("The 'badge'-property must be undefined or a short character")}if(!O.color&&!O.badge&&!O.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=ui;let ti=class{constructor(O){this.kind=O}};ti=Ue([A],ti),e.ColorTheme=ti;var gi;(function(x){x[x.Light=1]="Light",x[x.Dark=2]="Dark",x[x.HighContrast=3]="HighContrast"})(gi=e.ColorThemeKind||(e.ColorThemeKind={}));class Ae{constructor(O,Z){if(O<0)throw(0,t.illegalArgument)("start must be positive");if(Z<0)throw(0,t.illegalArgument)("end must be positive");O<=Z?(this._start=O,this._end=Z):(this._start=Z,this._end=O)}static isNotebookRange(O){return O instanceof Ae?!0:O?typeof O.start=="number"&&typeof O.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(O){let Z=this._start,_e=this._end;return O.start!==void 0&&(Z=O.start),O.end!==void 0&&(_e=O.end),Z===this._start&&_e===this._end?this:new Ae(Z,_e)}}e.NotebookRange=Ae;class Ut{constructor(O,Z,_e,je,tt,at,dt){this.kind=O,this.value=Z,this.languageId=_e,this.mime=je,this.outputs=tt??[],this.metadata=at,this.executionSummary=dt,Ut.validate(this)}static validate(O){if(typeof O.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof O.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof O.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(O){return Array.isArray(O)&&O.every(Z=>Ut.isNotebookCellData(Z))}static isNotebookCellData(O){return!0}}e.NotebookCellData=Ut;class pi{constructor(O){this.cells=O}}e.NotebookData=pi;class ft{constructor(O,Z){this.data=O,this.mime=Z;const _e=(0,k.normalizeMimeType)(Z,!0);if(!_e)throw new Error(`INVALID mime type: ${Z}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=_e}static isNotebookCellOutputItem(O){return O instanceof ft?!0:O?typeof O.mime=="string"&&O.data instanceof Uint8Array:!1}static error(O){const Z={name:O.name,message:O.message,stack:O.stack};return ft.json(Z,"application/vnd.code.notebook.error")}static stdout(O){return ft.text(O,"application/vnd.code.notebook.stdout")}static stderr(O){return ft.text(O,"application/vnd.code.notebook.stderr")}static bytes(O,Z="application/octet-stream"){return new ft(O,Z)}static text(O,Z=k.Mimes.text){const _e=Te(ft,m,"f",c).encode(String(O));return new ft(_e,Z)}static json(O,Z="application/json"){const _e=JSON.stringify(O,void 0,"	");return ft.text(_e,Z)}}e.NotebookCellOutputItem=ft,m=ft,c={value:new TextEncoder};class ii{constructor(O,Z,_e){this.items=ii.ensureUniqueMimeTypes(O,!0),typeof Z=="string"?(this.id=Z,this.metadata=_e):(this.id=(0,F.generateUuid)(),this.metadata=Z??_e)}static isNotebookCellOutput(O){return O instanceof ii?!0:!O||typeof O!="object"?!1:typeof O.id=="string"&&(0,S.isArray)(O.items)}static ensureUniqueMimeTypes(O,Z=!1){const _e=new Set,je=new Set;for(let tt=0;tt<O.length;tt++){const at=O[tt],dt=(0,k.normalizeMimeType)(at.mime);if(!_e.has(dt)){_e.add(dt);continue}je.add(tt),Z&&console.warn(`DUPLICATED mime type '${at.mime}' will be dropped`)}return je.size===0?O:O.filter((tt,at)=>!je.has(at))}}e.NotebookCellOutput=ii;var Ii;(function(x){x[x.Markup=1]="Markup",x[x.Code=2]="Code"})(Ii=e.NotebookCellKind||(e.NotebookCellKind={}));var vi;(function(x){x[x.Idle=1]="Idle",x[x.Pending=2]="Pending",x[x.Executing=3]="Executing"})(vi=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var bi;(function(x){x[x.Left=1]="Left",x[x.Right=2]="Right"})(bi=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Pi;(function(x){x[x.Default=0]="Default",x[x.InCenter=1]="InCenter",x[x.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",x[x.AtTop=3]="AtTop"})(Pi=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Ti{constructor(O,Z){this.text=O,this.alignment=Z}}e.NotebookCellStatusBarItem=Ti;var Ai;(function(x){x[x.Default=1]="Default",x[x.Preferred=2]="Preferred"})(Ai=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Ri{constructor(O,Z=[]){this.uri=O,this.provides=(0,a.asArray)(Z)}}e.NotebookRendererScript=Ri;let ni=class{constructor(O,Z){this.label=O,this.timestamp=Z}};ni=Ue([A],ni),e.TimelineItem=ni;var Fi;(function(x){x[x.Production=1]="Production",x[x.Development=2]="Development",x[x.Test=3]="Test"})(Fi=e.ExtensionMode||(e.ExtensionMode={}));var Mi;(function(x){x[x.Node=1]="Node",x[x.Webworker=2]="Webworker"})(Mi=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Oi;(function(x){x[x.Other=0]="Other",x[x.Comment=1]="Comment",x[x.String=2]="String",x[x.RegEx=4]="RegEx"})(Oi=e.StandardTokenType||(e.StandardTokenType={}));class Li{constructor(O,Z){this.ranges=O,this.wordPattern=Z}}e.LinkedEditingRanges=Li;class Ni{constructor(O,Z){this._port=O,this._autoForwardAction=Z}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Ni;var X;(function(x){x[x.Queued=1]="Queued",x[x.Running=2]="Running",x[x.Passed=3]="Passed",x[x.Failed=4]="Failed",x[x.Skipped=5]="Skipped",x[x.Errored=6]="Errored"})(X=e.TestResultState||(e.TestResultState={}));var de;(function(x){x[x.Run=1]="Run",x[x.Debug=2]="Debug",x[x.Coverage=3]="Coverage"})(de=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Se=class{constructor(O=void 0,Z=void 0,_e=void 0){this.include=O,this.exclude=Z,this.profile=_e}};Se=Ue([A],Se),e.TestRunRequest=Se;let ct=u=class{constructor(O){this.message=O}static diff(O,Z,_e){const je=new u(O);return je.expectedOutput=Z,je.actualOutput=_e,je}};ct=u=Ue([A],ct),e.TestMessage=ct;let Ct=class{constructor(O){this.id=O}};Ct=Ue([A],Ct),e.TestTag=Ct;let Dt=class{constructor(O,Z){this.covered=O,this.total=Z}};Dt=Ue([A],Dt),e.CoveredCount=Dt;let xi=D=class{constructor(O,Z,_e,je){this.uri=O,this.statementCoverage=Z,this.branchCoverage=_e,this.functionCoverage=je}static fromDetails(O,Z){const _e=new Dt(0,0),je=new Dt(0,0),tt=new Dt(0,0);for(const dt of Z)if("branches"in dt){_e.total+=1,_e.covered+=dt.executionCount>0?1:0;for(const kt of dt.branches)je.total+=1,je.covered+=kt.executionCount>0?1:0}else tt.total+=1,tt.covered+=dt.executionCount>0?1:0;const at=new D(O,_e,je.total>0?je:void 0,tt.total>0?tt:void 0);return at.detailedCoverage=Z,at}};xi=D=Ue([A],xi),e.FileCoverage=xi;let Ui=class{constructor(O,Z,_e=[]){this.executionCount=O,this.location=Z,this.branches=_e}};Ui=Ue([A],Ui),e.StatementCoverage=Ui;let Bi=class{constructor(O,Z){this.executionCount=O,this.location=Z}};Bi=Ue([A],Bi),e.BranchCoverage=Bi;let $i=class{constructor(O,Z){this.executionCount=O,this.location=Z}};$i=Ue([A],$i),e.FunctionCoverage=$i;var qi;(function(x){x[x.None=0]="None",x[x.Option=1]="Option",x[x.Default=2]="Default",x[x.Preferred=3]="Preferred"})(qi=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Ki;(function(x){x[x.Untrusted=0]="Untrusted",x[x.Trusted=1]="Trusted",x[x.Unspecified=2]="Unspecified"})(Ki=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Gi;(function(x){x[x.Notify=1]="Notify",x[x.OpenBrowser=2]="OpenBrowser",x[x.OpenPreview=3]="OpenPreview",x[x.Silent=4]="Silent",x[x.Ignore=5]="Ignore",x[x.OpenBrowserOnce=6]="OpenBrowserOnce"})(Gi=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class Qi{constructor(O,Z,_e,je,tt,at){this.kind=O,this.name=Z,this.detail=_e,this.uri=je,this.range=tt,this.selectionRange=at}}e.TypeHierarchyItem=Qi}),define(Ee[86],ye([0,1,41,10,9,223,114,7,16]),function(re,e,a,t,w,T,k,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const R=new Map;function F(o,m){m?R.set(o,m):R.delete(o)}e.setWordDefinitionFor=F;function _(o){return R.get(o)}e.getWordDefinitionFor=_;class n extends T.MirrorTextModel{constructor(m,c,C,b,h,g,P,l){super(c,C,b,h);this._proxy=m,this._languageId=g,this._isDirty=P,this._notebook=l,this._isDisposed=!1}dispose(){(0,a.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(m){return(0,S.equals)(this._lines,m)}get document(){if(!this._document){const m=this;this._document={get uri(){return m._uri},get fileName(){return m._uri.fsPath},get isUntitled(){return m._uri.scheme===t.Schemas.untitled},get languageId(){return m._languageId},get version(){return m._versionId},get isClosed(){return m._isDisposed},get isDirty(){return m._isDirty},get notebook(){return m._notebook},save(){return m._save()},getText(c){return c?m._getTextInRange(c):m.getText()},get eol(){return m._eol===`
`?I.EndOfLine.LF:I.EndOfLine.CRLF},get lineCount(){return m._lines.length},lineAt(c){return m._lineAt(c)},offsetAt(c){return m._offsetAt(c)},positionAt(c){return m._positionAt(c)},validateRange(c){return m._validateRange(c)},validatePosition(c){return m._validatePosition(c)},getWordRangeAtPosition(c,C){return m._getWordRangeAtPosition(c,C)}}}return Object.freeze(this._document)}_acceptLanguageId(m){(0,a.ok)(!this._isDisposed),this._languageId=m}_acceptIsDirty(m){(0,a.ok)(!this._isDisposed),this._isDirty=m}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(m){const c=this._validateRange(m);if(c.isEmpty)return"";if(c.isSingleLine)return this._lines[c.start.line].substring(c.start.character,c.end.character);const C=this._eol,b=c.start.line,h=c.end.line,g=[];g.push(this._lines[b].substring(c.start.character));for(let P=b+1;P<h;P++)g.push(this._lines[P]);return g.push(this._lines[h].substring(0,c.end.character)),g.join(C)}_lineAt(m){let c;if(m instanceof I.Position?c=m.line:typeof m=="number"&&(c=m),typeof c!="number"||c<0||c>=this._lines.length||Math.floor(c)!==c)throw new Error("Illegal value for `line`");return new f(c,this._lines[c],c===this._lines.length-1)}_offsetAt(m){return m=this._validatePosition(m),this._ensureLineStarts(),this._lineStarts.getPrefixSum(m.line-1)+m.character}_positionAt(m){m=Math.floor(m),m=Math.max(0,m),this._ensureLineStarts();const c=this._lineStarts.getIndexOf(m),C=this._lines[c.index].length;return new I.Position(c.index,Math.min(c.remainder,C))}_validateRange(m){if(!(m instanceof I.Range))throw new Error("Invalid argument");const c=this._validatePosition(m.start),C=this._validatePosition(m.end);return c===m.start&&C===m.end?m:new I.Range(c.line,c.character,C.line,C.character)}_validatePosition(m){if(!(m instanceof I.Position))throw new Error("Invalid argument");if(this._lines.length===0)return m.with(0,0);let{line:c,character:C}=m,b=!1;if(c<0)c=0,C=0,b=!0;else if(c>=this._lines.length)c=this._lines.length-1,C=this._lines[c].length,b=!0;else{const h=this._lines[c].length;C<0?(C=0,b=!0):C>h&&(C=h,b=!0)}return b?new I.Position(c,C):m}_getWordRangeAtPosition(m,c){const C=this._validatePosition(m);if(!c)c=_(this._languageId);else if((0,w.regExpLeadsToEndlessLoop)(c))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${c.source}' because it matches the empty string.`);const b=(0,k.getWordAtText)(C.character+1,(0,k.ensureValidWordDefinition)(c),this._lines[C.line],0);if(b)return new I.Range(C.line,b.startColumn-1,C.line,b.endColumn-1)}}e.ExtHostDocumentData=n;class f{constructor(m,c,C){this._line=m,this._text=c,this._isLastLine=C}get lineNumber(){return this._line}get text(){return this._text}get range(){return new I.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new I.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=f}),define(Ee[150],ye([0,1,7,4,224,6,55,21,2,35]),function(re,e,a,t,w,T,k,I,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class F{constructor(n,f,o,m){this._notebook=o,this._selector=m,this._disposables=new T.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new t.Emitter,this.onDidChange=this._onDidChange.event,this.uri=S.URI.from({scheme:"vscode-concat-doc",path:(0,R.generateUuid)()}),this._init(),this._disposables.add(f.onDidChangeDocument(C=>{const b=this._cellUris.get(C.document.uri);b!==void 0&&(this._cellLengths.setValue(b,this._cells[b].document.getText().length+1),this._cellLines.setValue(b,this._cells[b].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const c=C=>{C===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(n.onDidChangeNotebookCells(C=>c(C.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new I.ResourceMap;const n=[],f=[];for(const o of this._notebook.getCells())o.kind===a.NotebookCellKind.Code&&(!this._selector||(0,k.score)(this._selector,o.document.uri,o.document.languageId,!0))&&(this._cellUris.set(o.document.uri,this._cells.length),this._cells.push(o),n.push(o.document.getText().length+1),f.push(o.document.lineCount));this._cellLengths=new w.PrefixSumComputer(new Uint32Array(n)),this._cellLines=new w.PrefixSumComputer(new Uint32Array(f))}get version(){return this._versionId}getText(n){if(!n){let b="";for(const h of this._cells)b+=h.document.getText()+`
`;return b=b.slice(0,-1),b}if(n.isEmpty)return"";const f=this.locationAt(n.start),o=this.locationAt(n.end),m=this._cellUris.get(f.uri),c=this._cellUris.get(o.uri);if(m===void 0||c===void 0)return"";if(m===c)return this._cells[m].document.getText(new a.Range(f.range.start,o.range.end));const C=[this._cells[m].document.getText(new a.Range(f.range.start,new a.Position(this._cells[m].document.lineCount,0)))];for(let b=m+1;b<c;b++)C.push(this._cells[b].document.getText());return C.push(this._cells[c].document.getText(new a.Range(new a.Position(0,0),o.range.end))),C.join(`
`)}offsetAt(n){const f=this._cellLines.getIndexOf(n.line),o=this._cellLengths.getPrefixSum(f.index-1),m=this._cells[f.index].document.offsetAt(n.with(f.remainder));return o+m}positionAt(n){if(typeof n=="number"){const o=this._cellLengths.getIndexOf(n),m=this._cellLines.getPrefixSum(o.index-1);return this._cells[o.index].document.positionAt(o.remainder).translate(m)}const f=this._cellUris.get(n.uri);if(f!==void 0){const o=this._cellLines.getPrefixSum(f-1);return new a.Position(o+n.range.start.line,n.range.start.character)}return new a.Position(0,0)}locationAt(n){a.Range.isRange(n)||(n=new a.Range(n,n));const f=this._cellLines.getIndexOf(n.start.line);let o=f;n.isEmpty||(o=this._cellLines.getIndexOf(n.end.line));const m=new a.Position(f.remainder,n.start.character),c=new a.Position(o.remainder,n.end.character),C=new a.Range(m,c),b=this._cells[f.index];return new a.Location(b.document.uri,b.document.validateRange(C))}contains(n){return this._cellUris.has(n)}validateRange(n){const f=this.validatePosition(n.start),o=this.validatePosition(n.end);return n.with(f,o)}validatePosition(n){const f=this._cellLines.getIndexOf(n.line),o=new a.Position(f.remainder,n.character),m=this._cells[f.index].document.validatePosition(o),c=this._cellLines.getPrefixSum(f.index-1);return new a.Position(c+m.line,m.character)}}e.ExtHostNotebookConcatDocument=F}),define(Ee[151],ye([0,1,7,13,4]),function(re,e,a,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let T=class{constructor(I){this._actual=new a.ColorTheme(a.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new w.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(I){let S=I==="light"?a.ColorThemeKind.Light:I==="dark"?a.ColorThemeKind.Dark:a.ColorThemeKind.HighContrast;this._actual=new a.ColorTheme(S),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};T=Ue([$e(0,t.IExtHostRpcService)],T),e.ExtHostTheming=T}),define(Ee[65],ye([0,1,3]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,a.createDecorator)("IURITransformerService");class t{constructor(T){T?(this.transformIncoming=T.transformIncoming.bind(T),this.transformOutgoing=T.transformOutgoing.bind(T),this.transformOutgoingURI=T.transformOutgoingURI.bind(T),this.transformOutgoingScheme=T.transformOutgoingScheme.bind(T)):(this.transformIncoming=k=>k,this.transformOutgoing=k=>k,this.transformOutgoingURI=k=>k,this.transformOutgoingScheme=k=>k)}}e.URITransformerService=t}),define(Ee[152],ye([0,1,22]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class t{constructor(){this.buffers=[]}add(S){let R=this.buffers.indexOf(S);return R<0&&(R=this.buffers.length,this.buffers.push(S)),R}}function w(I,S){if(S.serializeBuffersForPostMessage){const R=new t,F=(f,o)=>{if(o instanceof ArrayBuffer){const m=R.add(o);return{$$vscode_array_buffer_reference$$:!0,index:m}}else if(ArrayBuffer.isView(o)){const m=T(o);if(m){const c=R.add(o.buffer);return{$$vscode_array_buffer_reference$$:!0,index:c,view:{type:m,byteLength:o.byteLength,byteOffset:o.byteOffset}}}}return o},_=JSON.stringify(I,F),n=R.buffers.map(f=>{const o=new Uint8Array(f);return a.VSBuffer.wrap(o)});return{message:_,buffers:n}}else return{message:JSON.stringify(I),buffers:[]}}e.serializeWebviewMessage=w;function T(I){switch(I.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function k(I,S){const R=S.map(n=>{const f=new ArrayBuffer(n.byteLength);return new Uint8Array(f).set(n.buffer),f}),F=S.length?(n,f)=>{if(typeof f=="object"&&f.$$vscode_array_buffer_reference$$){const o=f,{index:m}=o,c=R[m];if(o.view)switch(o.view.type){case 1:return new Int8Array(c,o.view.byteOffset,o.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(c,o.view.byteOffset,o.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(c,o.view.byteOffset,o.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(c,o.view.byteOffset,o.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(c,o.view.byteOffset,o.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(c,o.view.byteOffset,o.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(c,o.view.byteOffset,o.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(c,o.view.byteOffset,o.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(c,o.view.byteOffset,o.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(c,o.view.byteOffset,o.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(c,o.view.byteOffset,o.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return c}return f}:void 0;return{message:JSON.parse(I,F),arrayBuffers:R}}e.deserializeWebviewMessage=k}),define(Ee[153],ye([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var a;(function(t){function w(k){const I=new Map;return k.types.forEach((S,R)=>{I.set(S,{asString:async()=>k.items[R].asString})}),I}t.toITreeDataTransfer=w;async function T(k){const I={types:[],items:[]},S=Array.from(k.entries());for(const R of S)I.types.push(R[0]),I.items.push({asString:await R[1].asString()});return I}t.toTreeDataTransferDTO=T})(a=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(Ee[66],ye([0,1,10,2]),function(re,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function w(I,S){return I.scheme===a.Schemas.http||I.scheme===a.Schemas.https?I:(S&&S.authority&&S.isRemote&&I.scheme===a.Schemas.file&&(I=t.URI.from({scheme:a.Schemas.vscodeRemote,authority:S.authority,path:I.path})),t.URI.from({scheme:a.Schemas.https,authority:`${I.scheme}+${T(I.authority)}.${e.webviewRootResourceAuthority}`,path:I.path,fragment:I.fragment,query:I.query}))}e.asWebviewUri=w;function T(I){return I.replace(/./g,S=>{const R=S.charCodeAt(0);return R>=97&&R<=122||R>=65&&R<=90||R>=48&&R<=57?S:"-"+R.toString(16).padStart(4,"0")})}function k(I){return I.replace(/-([0-9a-f]{4})/g,(S,R)=>String.fromCharCode(parseInt(R,16)))}e.decodeAuthority=k}),define(Ee[154],ye([0,1,4,6,66]),function(re,e,a,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class T{constructor(I,S,R){this._proxy=I,this._editors=S,this._initData=R,this._handlePool=0,this._disposables=new t.DisposableStore,this._insets=new Map,this._disposables.add(S.onDidChangeVisibleTextEditors(()=>{const F=S.getVisibleTextEditors();for(const _ of this._insets.values())F.indexOf(_.editor)<0&&_.inset.dispose()}))}dispose(){this._insets.forEach(I=>I.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(I,S,R,F,_){let n;for(const h of this._editors.getVisibleTextEditors(!0))if(h.value===I){n=h;break}if(!n)throw new Error("not a visible editor");const f=this,o=this._handlePool++,m=new a.Emitter,c=new a.Emitter,C=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(h){return(0,w.asWebviewUri)(h,f._initData.remote)}get cspSource(){return w.webviewGenericCspSource}set options(h){this._options=h,f._proxy.$setOptions(o,h)}get options(){return this._options}set html(h){this._html=h,f._proxy.$setHtml(o,h)}get html(){return this._html}get onDidReceiveMessage(){return m.event}postMessage(h){return f._proxy.$postMessage(o,h)}},b=new class{constructor(){this.editor=I,this.line=S,this.height=R,this.webview=C,this.onDidDispose=c.event}dispose(){f._insets.has(o)&&(f._insets.delete(o),f._proxy.$disposeEditorInset(o),c.fire(),c.dispose(),m.dispose())}};return this._proxy.$createEditorInset(o,n.id,n.value.document.uri,S+1,R,F||{},_.identifier,_.extensionLocation),this._insets.set(o,{editor:I,inset:b,onDidReceiveMessage:m}),b}$onDidDispose(I){const S=this._insets.get(I);S&&S.inset.dispose()}$onDidReceiveMessage(I,S){const R=this._insets.get(I);R&&R.onDidReceiveMessage.fire(S)}}e.ExtHostEditorInsets=T}),define(Ee[155],ye([0,1,126,11,2,6,3,44,36,45,16,10]),function(re,e,a,t,w,T,k,I,S,R,F,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLockedContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.SideBySideEditorActiveContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanSplitInGroupContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,a.localize)(0,null),providerDisplayName:(0,a.localize)(1,null)},e.ActiveEditorDirtyContext=new I.RawContextKey("activeEditorIsDirty",!1,(0,a.localize)(2,null)),e.ActiveEditorPinnedContext=new I.RawContextKey("activeEditorIsNotPreview",!1,(0,a.localize)(3,null)),e.ActiveEditorStickyContext=new I.RawContextKey("activeEditorIsPinned",!1,(0,a.localize)(4,null)),e.ActiveEditorReadonlyContext=new I.RawContextKey("activeEditorIsReadonly",!1,(0,a.localize)(5,null)),e.ActiveEditorCanRevertContext=new I.RawContextKey("activeEditorCanRevert",!1,(0,a.localize)(6,null)),e.ActiveEditorCanSplitInGroupContext=new I.RawContextKey("activeEditorCanSplitInGroup",!0),e.ActiveEditorContext=new I.RawContextKey("activeEditor",null,{type:"string",description:(0,a.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new I.RawContextKey("activeEditorAvailableEditorIds","",(0,a.localize)(8,null)),e.TextCompareEditorVisibleContext=new I.RawContextKey("textCompareEditorVisible",!1,(0,a.localize)(9,null)),e.TextCompareEditorActiveContext=new I.RawContextKey("textCompareEditorActive",!1,(0,a.localize)(10,null)),e.SideBySideEditorActiveContext=new I.RawContextKey("sideBySideEditorActive",!1,(0,a.localize)(11,null)),e.EditorGroupEditorsCountContext=new I.RawContextKey("groupEditorsCount",0,(0,a.localize)(12,null)),e.ActiveEditorGroupEmptyContext=new I.RawContextKey("activeEditorGroupEmpty",!1,(0,a.localize)(13,null)),e.ActiveEditorGroupIndexContext=new I.RawContextKey("activeEditorGroupIndex",0,(0,a.localize)(14,null)),e.ActiveEditorGroupLastContext=new I.RawContextKey("activeEditorGroupLast",!1,(0,a.localize)(15,null)),e.ActiveEditorGroupLockedContext=new I.RawContextKey("activeEditorGroupLocked",!1,(0,a.localize)(16,null)),e.MultipleEditorGroupsContext=new I.RawContextKey("multipleEditorGroups",!1,(0,a.localize)(17,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new I.RawContextKey("editorIsOpen",!1,(0,a.localize)(18,null)),e.InEditorZenModeContext=new I.RawContextKey("inZenMode",!1,(0,a.localize)(19,null)),e.IsCenteredLayoutContext=new I.RawContextKey("isCenteredLayout",!1,(0,a.localize)(20,null)),e.SplitEditorsVertically=new I.RawContextKey("splitEditorsVertically",!1,(0,a.localize)(21,null)),e.EditorAreaVisibleContext=new I.RawContextKey("editorAreaVisible",!0,(0,a.localize)(22,null)),e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function n(E,N,L){for(const z of L.visibleEditorPanes)if(z.group.id===N&&E.matches(z.input))return z.getViewState()}e.findViewStateForEditor=n;function f(E){if(P(E))return!1;const N=E;return w.URI.isUri(N?.resource)}e.isResourceEditorInput=f;function o(E){if(P(E))return!1;const N=E;return N?.original!==void 0&&N.modified!==void 0}e.isResourceDiffEditorInput=o;function m(E){if(P(E)||o(E))return!1;const N=E;return N?.primary!==void 0&&N.secondary!==void 0}e.isResourceSideBySideEditorInput=m;function c(E){if(P(E))return!1;const N=E;return N?N.resource===void 0||N.resource.scheme===_.Schemas.untitled||N.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=c;var C;(function(E){E[E.SHORT=0]="SHORT",E[E.MEDIUM=1]="MEDIUM",E[E.LONG=2]="LONG"})(C=e.Verbosity||(e.Verbosity={}));var b;(function(E){E[E.EXPLICIT=1]="EXPLICIT",E[E.AUTO=2]="AUTO",E[E.FOCUS_CHANGE=3]="FOCUS_CHANGE",E[E.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(b=e.SaveReason||(e.SaveReason={}));var h;(function(E){E[E.None=0]="None",E[E.Readonly=2]="Readonly",E[E.Untitled=4]="Untitled",E[E.Singleton=8]="Singleton",E[E.RequiresTrust=16]="RequiresTrust",E[E.CanSplitInGroup=32]="CanSplitInGroup",E[E.ForceDescription=64]="ForceDescription"})(h=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class g extends T.Disposable{}e.AbstractEditorInput=g;function P(E){return E instanceof g}e.isEditorInput=P;function l(E){const N=E;return w.URI.isUri(N?.preferredResource)}function M(E){const N=E;return P(N?.primary)&&P(N?.secondary)}e.isSideBySideEditorInput=M;function r(E){const N=E;return P(N?.modified)&&P(N?.original)}e.isDiffEditorInput=r;function i(E){return P(E?.editor)}e.isEditorInputWithOptions=i;function p(E){const N=E;return i(E)&&N?.group!==void 0}e.isEditorInputWithOptionsAndGroup=p;function d(E){const N=E;return typeof N?.groupId=="number"&&P(N.editor)}e.isEditorIdentifier=d;var s;(function(E){E[E.UNKNOWN=0]="UNKNOWN",E[E.REPLACE=1]="REPLACE",E[E.MOVE=2]="MOVE",E[E.UNPIN=3]="UNPIN"})(s=e.EditorCloseContext||(e.EditorCloseContext={}));var v;(function(E){E[E.GROUP_ACTIVE=0]="GROUP_ACTIVE",E[E.GROUP_INDEX=1]="GROUP_INDEX",E[E.GROUP_LOCKED=2]="GROUP_LOCKED",E[E.EDITOR_OPEN=3]="EDITOR_OPEN",E[E.EDITOR_CLOSE=4]="EDITOR_CLOSE",E[E.EDITOR_MOVE=5]="EDITOR_MOVE",E[E.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",E[E.EDITOR_LABEL=7]="EDITOR_LABEL",E[E.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",E[E.EDITOR_PIN=9]="EDITOR_PIN",E[E.EDITOR_STICKY=10]="EDITOR_STICKY",E[E.EDITOR_DIRTY=11]="EDITOR_DIRTY",E[E.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(v=e.GroupChangeKind||(e.GroupChangeKind={}));var y;(function(E){E[E.PRIMARY=1]="PRIMARY",E[E.SECONDARY=2]="SECONDARY",E[E.BOTH=3]="BOTH",E[E.ANY=4]="ANY"})(y=e.SideBySideEditor||(e.SideBySideEditor={}));class u{getOriginalUri(N,L){if(!N)return;if(L?.supportSideBySide){const{primary:H,secondary:j}=this.getSideEditors(N);if(H&&j){if(L?.supportSideBySide===y.BOTH)return{primary:this.getOriginalUri(H,{filterByScheme:L.filterByScheme}),secondary:this.getOriginalUri(j,{filterByScheme:L.filterByScheme})};if(L?.supportSideBySide===y.ANY)return this.getOriginalUri(H,{filterByScheme:L.filterByScheme})??this.getOriginalUri(j,{filterByScheme:L.filterByScheme});N=L.supportSideBySide===y.PRIMARY?H:j}}if(o(N)||m(N))return;const z=l(N)?N.preferredResource:N.resource;return!z||!L||!L.filterByScheme?z:this.filterUri(z,L.filterByScheme)}getSideEditors(N){return M(N)||m(N)?{primary:N.primary,secondary:N.secondary}:r(N)||o(N)?{primary:N.modified,secondary:N.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(N,L){if(!N)return;if(L?.supportSideBySide){const{primary:H,secondary:j}=this.getSideEditors(N);if(H&&j){if(L?.supportSideBySide===y.BOTH)return{primary:this.getCanonicalUri(H,{filterByScheme:L.filterByScheme}),secondary:this.getCanonicalUri(j,{filterByScheme:L.filterByScheme})};if(L?.supportSideBySide===y.ANY)return this.getCanonicalUri(H,{filterByScheme:L.filterByScheme})??this.getCanonicalUri(j,{filterByScheme:L.filterByScheme});N=L.supportSideBySide===y.PRIMARY?H:j}}if(o(N)||m(N))return;const z=N.resource;return!z||!L||!L.filterByScheme?z:this.filterUri(z,L.filterByScheme)}filterUri(N,L){if(Array.isArray(L)){if(L.some(z=>N.scheme===z))return N}else if(L===N.scheme)return N}}e.EditorResourceAccessor=new u;var D;(function(E){E[E.LEFT=0]="LEFT",E[E.RIGHT=1]="RIGHT"})(D=e.CloseDirection||(e.CloseDirection={}));class A{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(N){const L=this.instantiationService=N.get(k.IInstantiationService);for(const[z,H]of this.editorSerializerConstructors)this.createEditorSerializer(z,H,L);this.editorSerializerConstructors.clear()}createEditorSerializer(N,L,z){const H=z.createInstance(L);this.editorSerializerInstances.set(N,H)}registerFileEditorFactory(N){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=N}getFileEditorFactory(){return(0,t.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(N,L){if(this.editorSerializerConstructors.has(N)||this.editorSerializerInstances.has(N))throw new Error(`A editor serializer with type ID '${N}' was already registered.`);return this.instantiationService?this.createEditorSerializer(N,L,this.instantiationService):this.editorSerializerConstructors.set(N,L),(0,T.toDisposable)(()=>{this.editorSerializerConstructors.delete(N),this.editorSerializerInstances.delete(N)})}getEditorSerializer(N){return this.editorSerializerInstances.get(typeof N=="string"?N:N.typeId)}}S.Registry.add(e.EditorExtensions.EditorFactory,new A);async function U(E,N){if(!E||!E.length)return[];const L=await Promise.all(E.map(async z=>{const H=w.URI.revive(z.fileUri);if(!H||!await N.canHandleResource(H))return;let ue=z.exists,G=z.type;if(typeof ue!="boolean"||typeof G!="number")try{G=(await N.resolve(H)).isDirectory?R.FileType.Directory:R.FileType.Unknown,ue=!0}catch{ue=!1}if(!ue&&z.openOnlyIfExists||G===R.FileType.Directory)return;const le={selection:ue?z.selection:void 0,pinned:!0,override:z.editorOverrideId};let ce;return ue?ce={resource:H,options:le}:ce={resource:H,options:le,forceUntitled:!0},ce}));return(0,F.coalesce)(L)}e.pathsToEditors=U;var B;(function(E){E[E.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",E[E.SEQUENTIAL=1]="SEQUENTIAL"})(B=e.EditorsOrder||(e.EditorsOrder={}))}),define(Ee[156],ye([0,1,4,14,127]),function(re,e,a,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class T{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new a.Emitter,this._onExit=new a.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(I){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=I}onEvent(I){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=I}onRequest(I){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=I}sendResponse(I){I.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${I.command}`)):this.internalSend("response",I)}sendRequest(I,S,R,F){const _={command:I};if(S&&Object.keys(S).length>0&&(_.arguments=S),this.internalSend("request",_),typeof F=="number"){const n=setTimeout(()=>{clearTimeout(n);const f=this.pendingRequests.get(_.seq);if(f){this.pendingRequests.delete(_.seq);const o={type:"response",seq:0,request_seq:_.seq,success:!1,command:I,message:(0,w.localize)(0,null,F,I)};f(o)}},F)}return R&&this.pendingRequests.set(_.seq,R),_.seq}acceptMessage(I){this.messageCallback?this.messageCallback(I):(this.queue.push(I),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(I,S){return I.type!=="event"||S.type!=="event"}async processQueue(){let I;for(;this.queue.length;){if((!I||this.needsTaskBoundaryBetween(this.queue[0],I))&&await(0,t.timeout)(0),I=this.queue.shift(),!I)return;switch(I.type){case"event":this.eventCallback&&this.eventCallback(I);break;case"request":this.requestCallback&&this.requestCallback(I);break;case"response":const S=I,R=this.pendingRequests.get(S.request_seq);R&&(this.pendingRequests.delete(S.request_seq),R(S));break}}}internalSend(I,S){S.type=I,S.seq=this.sequence++,this.sendMessage(S)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const I=new Map;this.pendingRequests.forEach((S,R)=>I.set(R,S)),await(0,t.timeout)(500),I.forEach((S,R)=>{S({type:"response",seq:0,request_seq:R,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(R)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=T}),define(Ee[157],ye([0,1,9,2,17,26,10]),function(re,e,a,t,w,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const I=/{([^}]+)}/g;function S(r,i,p){return r.replace(I,function(d,s){return i&&s.length>0&&s[0]!=="_"?d:p&&p.hasOwnProperty(s)?p[s]:d})}e.formatPII=S;function R(r){const i={};for(const p of Object.keys(r))p.startsWith("!")||(i[p]=r[p]);return i}e.filterExceptionsFromTelemetry=R;function F(r){return r.configuration.request==="attach"&&!_(r)&&(!r.parentSession||F(r.parentSession))}e.isSessionAttach=F;function _(r){let i=r.configuration.type;if(!!i)return i==="vslsShare"&&(i=r.configuration.adapterProxy.configuration.type),(0,a.equalsIgnoreCase)(i,"extensionhost")||(0,a.equalsIgnoreCase)(i,"pwa-extensionhost")?r:r.parentSession?_(r.parentSession):void 0}e.getExtensionHostDebugSession=_;function n(r){return r.type&&(r.label||r.program||r.runtime)}e.isDebuggerMainContribution=n;function f(r,i,p){let d,s=0,v=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,y=null;for(;y=v.exec(r);){let u=y.index+1,D=u+y[0].length;if(u<=i&&D>=p){d=y[0],s=u;break}}if(d){let u=/\w+/g,D=null;for(;(D=u.exec(d))&&!(D.index+1+s+D[0].length>=p););D&&(d=d.substring(0,u.lastIndex))}return d?{start:s,end:s+d.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=f;const o=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function m(r){return!!(r&&r.match(o))}e.isUri=m;function c(r){if(typeof r.path=="string"&&!(typeof r.sourceReference=="number"&&r.sourceReference>0)){if(m(r.path))return t.URI.parse(r.path);if((0,w.isAbsolute)(r.path))return t.URI.file(r.path)}return r.path}function C(r){if(typeof r.path=="object"){const i=t.URI.revive(r.path);if(i)return i.scheme===k.Schemas.file?i.fsPath:i.toString()}return r.path}function b(r,i){const p=i?c:C,d=(0,T.deepClone)(r);return g(d,(s,v)=>{s&&v&&(v.path=p(v))}),d}e.convertToDAPaths=b;function h(r,i){const p=i?c:C,d=(0,T.deepClone)(r);return g(d,(s,v)=>{!s&&v&&(v.path=p(v))}),d}e.convertToVSCPaths=h;function g(r,i){switch(r.type){case"event":const p=r;switch(p.event){case"output":i(!1,p.body.source);break;case"loadedSource":i(!1,p.body.source);break;case"breakpoint":i(!1,p.body.breakpoint.source);break;default:break}break;case"request":const d=r;switch(d.command){case"setBreakpoints":i(!0,d.arguments.source);break;case"breakpointLocations":i(!0,d.arguments.source);break;case"source":i(!0,d.arguments.source);break;case"gotoTargets":i(!0,d.arguments.source);break;case"launchVSCode":d.arguments.args.forEach(v=>i(!1,v));break;default:break}break;case"response":const s=r;if(s.success&&s.body)switch(s.command){case"stackTrace":s.body.stackFrames.forEach(v=>i(!1,v.source));break;case"loadedSources":s.body.sources.forEach(v=>i(!1,v));break;case"scopes":s.body.scopes.forEach(v=>i(!1,v.source));break;case"setFunctionBreakpoints":s.body.breakpoints.forEach(v=>i(!1,v.source));break;case"setBreakpoints":s.body.breakpoints.forEach(v=>i(!1,v.source));break;default:break}break}}function P(r){return r.filter(i=>!i.presentation?.hidden).sort((i,p)=>i.presentation?p.presentation?i.presentation.group?p.presentation.group?i.presentation.group!==p.presentation.group?i.presentation.group.localeCompare(p.presentation.group):l(i.presentation.order,p.presentation.order):-1:p.presentation.group?1:l(i.presentation.order,p.presentation.order):-1:p.presentation?1:0)}e.getVisibleAndSorted=P;function l(r,i){return typeof r!="number"?typeof i!="number"?0:1:typeof i!="number"?-1:r-i}async function M(r,i){const p=r.getValue("debug.saveBeforeStart",{overrideIdentifier:i.activeTextEditorMode});if(p!=="none"&&(await i.saveAll(),p==="allEditorsInActiveGroup")){const d=i.activeEditorPane;d&&await i.save({editor:d.input,groupId:d.group.id})}await r.reloadConfiguration()}e.saveAllBeforeDebugStart=M}),define(Ee[87],ye([0,1,29,158,78,10,17,23,44]),function(re,e,a,t,w,T,k,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var R;(function(u){u[u.Markup=1]="Markup",u[u.Code=2]="Code"})(R=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",w.Mimes.latex,w.Mimes.markdown,"image/png","image/jpeg",w.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[w.Mimes.latex,w.Mimes.markdown,"application/json",w.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var F;(function(u){u[u.Running=1]="Running",u[u.Idle=2]="Idle"})(F=e.NotebookRunState||(e.NotebookRunState={}));var _;(function(u){u[u.Pending=2]="Pending",u[u.Executing=3]="Executing"})(_=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var n;(function(u){u[u.WithHardKernelDependency=0]="WithHardKernelDependency",u[u.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",u[u.Pure=2]="Pure",u[u.Never=3]="Never"})(n=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var f;(function(u){u.Always="always",u.Never="never",u.Optional="optional"})(f=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var o;(function(u){u[u.ModelChange=1]="ModelChange",u[u.Move=2]="Move",u[u.ChangeLanguage=5]="ChangeLanguage",u[u.Initialize=6]="Initialize",u[u.ChangeCellMetadata=7]="ChangeCellMetadata",u[u.Output=8]="Output",u[u.OutputItem=9]="OutputItem",u[u.ChangeCellContent=10]="ChangeCellContent",u[u.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",u[u.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",u[u.ChangeCellMime=13]="ChangeCellMime",u[u.Unknown=100]="Unknown"})(o=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var m;(function(u){u[u.Handle=0]="Handle",u[u.Index=1]="Index"})(m=e.SelectionStateType||(e.SelectionStateType={}));var c;(function(u){u[u.Replace=1]="Replace",u[u.Output=2]="Output",u[u.Metadata=3]="Metadata",u[u.CellLanguage=4]="CellLanguage",u[u.DocumentMetadata=5]="DocumentMetadata",u[u.Move=6]="Move",u[u.OutputItems=7]="OutputItems",u[u.PartialMetadata=8]="PartialMetadata",u[u.PartialInternalMetadata=9]="PartialInternalMetadata"})(c=e.CellEditType||(e.CellEditType={}));var C;(function(u){u.scheme=T.Schemas.vscodeNotebookCell;const D=/^ch(\d{7,})/;function A(z,H){return z.with({scheme:u.scheme,fragment:`ch${H.toString().padStart(7,"0")}${z.scheme!==T.Schemas.file?z.scheme:""}`})}u.generate=A;function U(z){if(z.scheme!==u.scheme)return;const H=D.exec(z.fragment);return H?{handle:Number(H[1]),notebook:z.with({scheme:z.fragment.substr(H[0].length)||T.Schemas.file,fragment:null})}:void 0}u.parse=U;function B(z,H,j){return z.with({scheme:T.Schemas.vscodeNotebookCellOutput,fragment:`ch${H.toString().padStart(7,"0")},${j??""},${z.scheme!==T.Schemas.file?z.scheme:""}`})}u.generateCellOutputUri=B;function E(z){if(z.scheme!==T.Schemas.vscodeNotebookCellOutput)return;const H=/^ch(\d{7,})\,([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(z.fragment);if(!H)return;const j=Number(H[1]),ue=H[2]&&H[2]!==""?H[2]:void 0,G=H[3];return{handle:j,outputId:ue,notebook:z.with({scheme:G||T.Schemas.file,fragment:null})}}u.parseCellOutputUri=E;function N(z,H,j){return z.with({scheme:j,fragment:`ch${H.toString().padStart(7,"0")}${z.scheme!==T.Schemas.file?z.scheme:""}`})}u.generateCellUri=N;function L(z,H){if(z.scheme!==H)return;const j=D.exec(z.fragment);return j?{handle:Number(j[1]),notebook:z.with({scheme:z.fragment.substr(j[0].length)||T.Schemas.file,fragment:null})}:void 0}u.parseCellUri=L})(C=e.CellUri||(e.CellUri={}));const b=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[w.Mimes.latex,{alwaysSecure:!0,supportedByCore:!0}],[w.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function h(u){return b.get(u)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=h;function g(u){return b.get(u)?.supportedByCore??!1}e.mimeTypeSupportedByCore=g;function P(u){return b.get(u)?.mergeable??!1}e.mimeTypeIsMergeable=P;const l=u=>I.isWindows?u.replace(/\//g,"\\"):u;class M{constructor(D=[],A=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=A,this.order=[...new Set(D)].map(U=>({pattern:U,matches:a.parse(l(U))}))}sort(D){const A=new Map(t.Iterable.map(D,B=>[B,l(B)]));let U=[];for(const{matches:B}of this.order)for(const[E,N]of A)if(B(N)){U.push(E),A.delete(E);break}return A.size&&(U=U.concat([...A.keys()].sort((B,E)=>this.defaultOrder.indexOf(B)-this.defaultOrder.indexOf(E)))),U}prioritize(D,A){const U=this.findIndex(D);if(U===-1){this.order.unshift({pattern:D,matches:a.parse(l(D))});return}const B=new Set(A.map(N=>this.findIndex(N,U)));B.delete(-1);const E=Array.from(B).sort();this.order.splice(U+1,0,...E.map(N=>this.order[N]));for(let N=E.length-1;N>=0;N--)this.order.splice(E[N],1)}toArray(){return this.order.map(D=>D.pattern)}findIndex(D,A=this.order.length){const U=l(D);for(let B=0;B<A;B++)if(this.order[B].matches(U))return B;return-1}}e.MimeTypeDisplayOrder=M;function r(u,D,A,U=(B,E)=>B===E){const B=[];function E(z,H,j){if(H===0&&j.length===0)return;const ue=B[B.length-1];ue&&ue.start+ue.deleteCount===z?(ue.deleteCount+=H,ue.toInsert.push(...j)):B.push({start:z,deleteCount:H,toInsert:j})}let N=0,L=0;for(;;){if(N===u.length){E(N,0,D.slice(L));break}if(L===D.length){E(N,u.length-N,[]);break}const z=u[N],H=D[L];if(U(z,H)){N+=1,L+=1;continue}A(H)?(E(N,1,[]),N+=1):(E(N,0,[H]),L+=1)}return B}e.diff=r,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new S.RawContextKey("notebookEditorCursorAtBoundary","none");var i;(function(u){u.default="default",u.option="option"})(i=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function p(u){const D=u;return!!((typeof D.include=="string"||a.isRelativePattern(D.include))&&(typeof D.exclude=="string"||a.isRelativePattern(D.exclude)))}e.isDocumentExcludePattern=p;function d(u,D,A){if(Array.isArray(u.viewType)&&u.viewType.indexOf(D)>=0||u.viewType===D)return!0;if(u.filenamePattern){let U=p(u.filenamePattern)?u.filenamePattern.include:u.filenamePattern,B=p(u.filenamePattern)?u.filenamePattern.exclude:void 0;if(a.match(U,(0,k.basename)(A.fsPath).toLowerCase()))return!(B&&a.match(B,(0,k.basename)(A.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=d;class s{constructor(D){this.textModel=D}getElements(){const D=new Int32Array(this.textModel.cells.length);for(let A=0;A<this.textModel.cells.length;A++)D[A]=this.textModel.cells[A].getHashValue();return D}}e.CellSequence=s,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize"};var v;(function(u){u[u.Left=1]="Left",u[u.Right=2]="Right"})(v=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class y{static create(D){return`${y._prefix}${D}`}static parse(D){if(D.startsWith(y._prefix))return D.substr(y._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=y,y._prefix="notebook/"}),define(Ee[159],ye([0,1,3]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var t;(function(w){w[w.Output=1]="Output",w[w.OutputItems=2]="OutputItems",w[w.ExecutionState=3]="ExecutionState",w[w.Complete=4]="Complete"})(t=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,a.createDecorator)("INotebookExecutionService")}),define(Ee[160],ye([0,1,3,44]),function(re,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new t.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new t.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new t.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,a.createDecorator)(e.OUTPUT_SERVICE_ID);var w;(function(T){T[T.Append=1]="Append",T[T.Replace=2]="Replace",T[T.Clear=3]="Clear"})(w=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={}))}),define(Ee[161],ye([0,1,129,3,44]),function(re,e,a,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new w.RawContextKey("customExecutionSupported",!0,a.localize(0,null)),e.ShellExecutionSupportedContext=new w.RawContextKey("shellExecutionSupported",!1,a.localize(1,null)),e.ProcessExecutionSupportedContext=new w.RawContextKey("processExecutionSupported",!1,a.localize(2,null)),e.ITaskService=(0,t.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(Ee[162],ye([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function a(w){return[...w.entries()]}e.serializeEnvironmentVariableCollection=a;function t(w){return new Map(w)}e.deserializeEnvironmentVariableCollection=t}),define(Ee[88],ye([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.TestMessageType=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var a;(function(_){_[_.Unset=0]="Unset",_[_.Queued=1]="Queued",_[_.Running=2]="Running",_[_.Passed=3]="Passed",_[_.Failed=4]="Failed",_[_.Skipped=5]="Skipped",_[_.Errored=6]="Errored"})(a=e.TestResultState||(e.TestResultState={}));var t;(function(_){_[_.Run=2]="Run",_[_.Debug=4]="Debug",_[_.Coverage=8]="Coverage",_[_.HasNonDefaultProfile=16]="HasNonDefaultProfile",_[_.HasConfigurable=32]="HasConfigurable"})(t=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var w;(function(_){_[_.Error=0]="Error",_[_.Info=1]="Info"})(w=e.TestMessageType||(e.TestMessageType={}));var T;(function(_){_[_.NotExpandable=0]="NotExpandable",_[_.Expandable=1]="Expandable",_[_.BusyExpanding=2]="BusyExpanding",_[_.Expanded=3]="Expanded"})(T=e.TestItemExpandState||(e.TestItemExpandState={}));const k=(_,n)=>{n.expand!==void 0&&(_.expand=n.expand),n.item!==void 0&&(_.item=_.item?Object.assign(_.item,n.item):n.item)};e.applyTestItemUpdate=k;var I;(function(_){_[_.Function=0]="Function",_[_.Statement=1]="Statement"})(I=e.DetailType||(e.DetailType={}));var S;(function(_){_[_.Add=0]="Add",_[_.Update=1]="Update",_[_.Remove=2]="Remove",_[_.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",_[_.Retire=4]="Retire",_[_.AddTag=5]="AddTag",_[_.RemoveTag=6]="RemoveTag"})(S=e.TestDiffOpType||(e.TestDiffOpType={}));class R{add(n){}update(n){}remove(n,f){}complete(){}}e.IncrementalChangeCollector=R;class F{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(n){const f=this.createChangeCollector();for(const o of n)switch(o[0]){case 0:{const m=o[1];if(m.parent){if(this.items.has(m.parent)){const c=this.items.get(m.parent);c.children.add(m.item.extId);const C=this.createItem(m,c);this.items.set(m.item.extId,C),f.add(C)}}else{const c=this.createItem(m);this.roots.add(c),this.items.set(m.item.extId,c),f.add(c)}m.expand===2&&this.busyControllerCount++;break}case 1:{const m=o[1],c=this.items.get(m.extId);if(!c)break;m.expand!==void 0&&(c.expand===2&&this.busyControllerCount--,m.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(c,m),f.update(c);break}case 2:{const m=this.items.get(o[1]);if(!m)break;m.parent?this.items.get(m.parent).children.delete(m.item.extId):this.roots.delete(m);const c=[[o[1]]];for(;c.length;)for(const C of c.pop()){const b=this.items.get(C);b&&(c.push(b.children),this.items.delete(C),f.remove(b,b!==m),b.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(o[1]);break;case 3:this.updatePendingRoots(o[1]);break;case 5:this._tags.set(o[1].id,o[1]);break;case 6:this._tags.delete(o[1]);break}f.complete()}retireTest(n){}updatePendingRoots(n){this.pendingRootCount+=n}createChangeCollector(){return new R}}e.AbstractIncrementalTestCollection=F}),define(Ee[67],ye([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var a;(function(T){T.Delimiter="\0"})(a=e.TestIdPathParts||(e.TestIdPathParts={}));var t;(function(T){T[T.IsSame=0]="IsSame",T[T.Disconnected=1]="Disconnected",T[T.IsChild=2]="IsChild",T[T.IsParent=3]="IsParent"})(t=e.TestPosition||(e.TestPosition={}));class w{constructor(k,I=k.length){if(this.path=k,this.viewEnd=I,k.length===0||I<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(k,I,S=k.parent){if(k.id===I)return new w([I]);let R=[k.id];for(let F=S;F&&F.id!==I;F=F.parent)R.push(F.id);return R.push(I),new w(R.reverse())}static isRoot(k){return!k.includes("\0")}static fromString(k){return new w(k.split("\0"))}static join(k,I){return new w([...k.path,I])}static joinToString(k,I){return k.toString()+"\0"+I}static compare(k,I){return k===I?0:I.startsWith(k+"\0")?2:k.startsWith(I+"\0")?3:1}get parentId(){return this.viewEnd>1?new w(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let k=1;k<=this.viewEnd;k++)yield new w(this.path,k)}compare(k){if(typeof k=="string")return w.compare(this.toString(),k);for(let I=0;I<k.viewEnd&&I<this.viewEnd;I++)if(k.path[I]!==this.path[I])return 1;return k.viewEnd>this.viewEnd?2:k.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let k=1;k<this.viewEnd;k++)this.stringifed+="\0",this.stringifed+=this.path[k]}return this.stringifed}}e.TestId=w}),define(Ee[163],ye([0,1,17,89,11,26,23,77,130]),function(re,e,a,t,w,T,k,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class R{constructor(_,n,f){this._contributedVariables=new Map,this._context=_,this._labelService=n,f&&(this._envVariablesPromise=f.then(o=>this.prepareEnv(o)))}prepareEnv(_){if(k.isWindows){const n=Object.create(null);return Object.keys(_).forEach(f=>{n[f.toLowerCase()]=_[f]}),n}return _}resolveWithEnvironment(_,n,f){return this.recursiveResolve(this.prepareEnv(_),n?n.uri:void 0,f)}async resolveAsync(_,n){return this.recursiveResolve(await this._envVariablesPromise,_?_.uri:void 0,n)}async resolveAnyBase(_,n,f,o){const m=T.deepClone(n);return k.isWindows&&m.windows?Object.keys(m.windows).forEach(c=>m[c]=m.windows[c]):k.isMacintosh&&m.osx?Object.keys(m.osx).forEach(c=>m[c]=m.osx[c]):k.isLinux&&m.linux&&Object.keys(m.linux).forEach(c=>m[c]=m.linux[c]),delete m.windows,delete m.osx,delete m.linux,this.recursiveResolve(await this._envVariablesPromise,_?_.uri:void 0,m,f,o)}async resolveAnyAsync(_,n,f){return this.resolveAnyBase(_,n,f)}async resolveAnyMap(_,n,f){const o=new Map;return{newConfig:await this.resolveAnyBase(_,n,f,o),resolvedVariables:o}}resolveWithInteractionReplace(_,n,f,o){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(_,n,f,o){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(_,n){if(this._contributedVariables.has(_))throw new Error("Variable "+_+" is contributed twice.");this._contributedVariables.set(_,n)}recursiveResolve(_,n,f,o,m){if(w.isString(f))return this.resolveString(_,n,f,o,m);if(w.isArray(f))return f.map(c=>this.recursiveResolve(_,n,c,o,m));if(w.isObject(f)){let c=Object.create(null);return Object.keys(f).forEach(C=>{const b=this.resolveString(_,n,C,o,m);c[b]=this.recursiveResolve(_,n,f[C],o,m)}),c}return f}resolveString(_,n,f,o,m){return f.replace(R.VARIABLE_REGEXP,(C,b)=>{if(b.includes(R.VARIABLE_LHS))return C;let h=this.evaluateSingleVariable(_,C,b,n,o);return m&&m.set(b,h),h!==C&&w.isString(h)&&h.match(R.VARIABLE_REGEXP)&&(h=this.resolveString(_,n,h,o,m)),h})}fsPath(_){return this._labelService?this._labelService.getUriLabel(_,{noPrefix:!0}):_.fsPath}evaluateSingleVariable(_,n,f,o,m){let c;const C=f.split(":");C.length>1&&(f=C[0],c=C[1]);const b=()=>{const P=this._context.getFilePath();if(P)return P;throw new Error((0,S.localize)(0,null,n))},h=()=>{const P=b();if(this._context.getWorkspaceFolderPathForFile){const l=this._context.getWorkspaceFolderPathForFile();if(l)return l}throw new Error((0,S.localize)(1,null,n,a.basename(P)))},g=()=>{if(c){const P=this._context.getFolderUri(c);if(P)return P;throw new Error((0,S.localize)(2,null,n,c))}if(o)return o;throw this._context.getWorkspaceFolderCount()>1?new Error((0,S.localize)(3,null,n)):new Error((0,S.localize)(4,null,n))};switch(f){case"env":if(c){if(_){const P=_[k.isWindows?c.toLowerCase():c];if(w.isString(P))return P}return""}throw new Error((0,S.localize)(5,null,n));case"config":if(c){const P=this._context.getConfigurationValue(o,c);if(w.isUndefinedOrNull(P))throw new Error((0,S.localize)(6,null,n,c));if(w.isObject(P))throw new Error((0,S.localize)(7,null,n,c));return P}throw new Error((0,S.localize)(8,null,n));case"command":return this.resolveFromMap(n,c,m,"command");case"input":return this.resolveFromMap(n,c,m,"input");default:switch(f){case"workspaceRoot":case"workspaceFolder":return(0,I.normalizeDriveLetter)(this.fsPath(g()));case"cwd":return o||c?(0,I.normalizeDriveLetter)(this.fsPath(g())):t.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return a.basename(this.fsPath(g()));case"lineNumber":const P=this._context.getLineNumber();if(P)return P;throw new Error((0,S.localize)(9,null,n));case"selectedText":const l=this._context.getSelectedText();if(l)return l;throw new Error((0,S.localize)(10,null,n));case"file":return b();case"fileWorkspaceFolder":return h();case"relativeFile":return o||c?a.relative(this.fsPath(g()),b()):b();case"relativeFileDirname":const M=a.dirname(b());if(o||c){const d=a.relative(this.fsPath(g()),M);return d.length===0?".":d}return M;case"fileDirname":return a.dirname(b());case"fileExtname":return a.extname(b());case"fileBasename":return a.basename(b());case"fileBasenameNoExtension":const r=a.basename(b());return r.slice(0,r.length-a.extname(r).length);case"fileDirnameBasename":return a.basename(a.dirname(b()));case"execPath":const i=this._context.getExecPath();return i||n;case"execInstallFolder":const p=this._context.getAppRoot();return p||n;case"pathSeparator":return a.sep;default:try{const d=c?`${f}:${c}`:f;return this.resolveFromMap(n,d,m,void 0)}catch{return n}}}}resolveFromMap(_,n,f,o){if(n&&f){const m=o===void 0?f[n]:f[o+":"+n];if(typeof m=="string")return m;throw new Error((0,S.localize)(11,null,_))}return _}}e.AbstractVariableResolverService=R,R.VARIABLE_LHS="${",R.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(Ee[90],ye([0,1,3,155]),function(re,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,a.createDecorator)("editorGroupsService");var w;(function(o){o[o.UP=0]="UP",o[o.DOWN=1]="DOWN",o[o.LEFT=2]="LEFT",o[o.RIGHT=3]="RIGHT"})(w=e.GroupDirection||(e.GroupDirection={}));var T;(function(o){o[o.HORIZONTAL=0]="HORIZONTAL",o[o.VERTICAL=1]="VERTICAL"})(T=e.GroupOrientation||(e.GroupOrientation={}));var k;(function(o){o[o.FIRST=0]="FIRST",o[o.LAST=1]="LAST",o[o.NEXT=2]="NEXT",o[o.PREVIOUS=3]="PREVIOUS"})(k=e.GroupLocation||(e.GroupLocation={}));var I;(function(o){o[o.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",o[o.EVEN=1]="EVEN",o[o.TOGGLE=2]="TOGGLE"})(I=e.GroupsArrangement||(e.GroupsArrangement={}));var S;(function(o){o[o.COPY_EDITORS=0]="COPY_EDITORS",o[o.MOVE_EDITORS=1]="MOVE_EDITORS"})(S=e.MergeGroupMode||(e.MergeGroupMode={}));function R(o){const m=o;return(0,t.isEditorInput)(m?.editor)&&(0,t.isEditorInput)(m?.replacement)}e.isEditorReplacement=R;var F;(function(o){o[o.CREATION_TIME=0]="CREATION_TIME",o[o.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",o[o.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(F=e.GroupsOrder||(e.GroupsOrder={}));var _;(function(o){o[o.NEW_EDITOR=1]="NEW_EDITOR",o[o.MOVE_EDITOR=2]="MOVE_EDITOR",o[o.COPY_EDITOR=3]="COPY_EDITOR"})(_=e.OpenEditorContext||(e.OpenEditorContext={}));function n(o){const m=o;return!!m&&typeof m.id=="number"&&Array.isArray(m.editors)}e.isEditorGroup=n;function f(o){return o.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=f}),define(Ee[164],ye([0,1,3,90]),function(re,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,a.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function w(T){const k=T;return typeof T=="number"||(0,t.isEditorGroup)(k)}e.isPreferredGroup=w}),define(Ee[8],ye([0,1,16,22,76,225,54,26,11,2,59,58,131,82,47,87,67,164,7]),function(re,e,a,t,w,T,k,I,S,R,F,_,n,f,o,m,c,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var h;(function(ne){function pe(W){const{selectionStartLineNumber:be,selectionStartColumn:De,positionLineNumber:qe,positionColumn:xe}=W,ut=new b.Position(be-1,De-1),vt=new b.Position(qe-1,xe-1);return new b.Selection(ut,vt)}ne.to=pe;function ee(W){const{anchor:be,active:De}=W;return{selectionStartLineNumber:be.line+1,selectionStartColumn:be.character+1,positionLineNumber:De.line+1,positionColumn:De.character+1}}ne.from=ee})(h=e.Selection||(e.Selection={}));var g;(function(ne){function pe(W){if(!W)return;const{start:be,end:De}=W;return{startLineNumber:be.line+1,startColumn:be.character+1,endLineNumber:De.line+1,endColumn:De.character+1}}ne.from=pe;function ee(W){if(!W)return;const{startLineNumber:be,startColumn:De,endLineNumber:qe,endColumn:xe}=W;return new b.Range(be-1,De-1,qe-1,xe-1)}ne.to=ee})(g=e.Range||(e.Range={}));var P;(function(ne){function pe(ee){switch(ee){case 1:return b.StandardTokenType.Comment;case 0:return b.StandardTokenType.Other;case 4:return b.StandardTokenType.RegEx;case 2:return b.StandardTokenType.String}}ne.to=pe})(P=e.TokenType||(e.TokenType={}));var l;(function(ne){function pe(W){return new b.Position(W.lineNumber-1,W.column-1)}ne.to=pe;function ee(W){return{lineNumber:W.line+1,column:W.character+1}}ne.from=ee})(l=e.Position||(e.Position={}));var M;(function(ne){function pe(be,De){return(0,a.coalesce)((0,a.asArray)(be).map(qe=>ee(qe,De)))}ne.from=pe;function ee(be,De){if(typeof be=="string")return{$serialized:!0,language:be};if(be)return{$serialized:!0,language:be.language,scheme:W(be.scheme,De),pattern:typeof be.pattern=="undefined"?void 0:V.from(be.pattern),exclusive:be.exclusive}}function W(be,De){return De&&typeof be=="string"?De.transformOutgoingScheme(be):be}})(M=e.DocumentSelector||(e.DocumentSelector={}));var r;(function(ne){function pe(W){switch(W){case b.DiagnosticTag.Unnecessary:return 1;case b.DiagnosticTag.Deprecated:return 2}}ne.from=pe;function ee(W){switch(W){case 1:return b.DiagnosticTag.Unnecessary;case 2:return b.DiagnosticTag.Deprecated;default:return}}ne.to=ee})(r=e.DiagnosticTag||(e.DiagnosticTag={}));var i;(function(ne){function pe(W){let be;return W.code&&((0,S.isString)(W.code)||(0,S.isNumber)(W.code)?be=String(W.code):be={value:String(W.code.value),target:W.code.target}),{...g.from(W.range),message:W.message,source:W.source,code:be,severity:d.from(W.severity),relatedInformation:W.relatedInformation&&W.relatedInformation.map(p.from),tags:Array.isArray(W.tags)?(0,a.coalesce)(W.tags.map(r.from)):void 0}}ne.from=pe;function ee(W){const be=new b.Diagnostic(g.to(W),W.message,d.to(W.severity));return be.source=W.source,be.code=(0,S.isString)(W.code)?W.code:W.code?.value,be.relatedInformation=W.relatedInformation&&W.relatedInformation.map(p.to),be.tags=W.tags&&(0,a.coalesce)(W.tags.map(r.to)),be}ne.to=ee})(i=e.Diagnostic||(e.Diagnostic={}));var p;(function(ne){function pe(W){return{...g.from(W.location.range),message:W.message,resource:W.location.uri}}ne.from=pe;function ee(W){return new b.DiagnosticRelatedInformation(new b.Location(W.resource,g.to(W)),W.message)}ne.to=ee})(p=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var d;(function(ne){function pe(W){switch(W){case b.DiagnosticSeverity.Error:return f.MarkerSeverity.Error;case b.DiagnosticSeverity.Warning:return f.MarkerSeverity.Warning;case b.DiagnosticSeverity.Information:return f.MarkerSeverity.Info;case b.DiagnosticSeverity.Hint:return f.MarkerSeverity.Hint}return f.MarkerSeverity.Error}ne.from=pe;function ee(W){switch(W){case f.MarkerSeverity.Info:return b.DiagnosticSeverity.Information;case f.MarkerSeverity.Warning:return b.DiagnosticSeverity.Warning;case f.MarkerSeverity.Error:return b.DiagnosticSeverity.Error;case f.MarkerSeverity.Hint:return b.DiagnosticSeverity.Hint;default:return b.DiagnosticSeverity.Error}}ne.to=ee})(d=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var s;(function(ne){function pe(W){return typeof W=="number"&&W>=b.ViewColumn.One?W-1:W===b.ViewColumn.Beside?C.SIDE_GROUP:C.ACTIVE_GROUP}ne.from=pe;function ee(W){if(typeof W=="number"&&W>=0)return W+1;throw new Error("invalid 'EditorGroupColumn'")}ne.to=ee})(s=e.ViewColumn||(e.ViewColumn={}));function v(ne){return typeof ne.range!="undefined"}function y(ne){return ne.length===0?!0:!!v(ne[0])}e.isDecorationOptionsArr=y;var u;(function(ne){function pe(xe){return xe.map(ne.from)}ne.fromMany=pe;function ee(xe){return xe&&typeof xe=="object"&&typeof xe.language=="string"&&typeof xe.value=="string"}function W(xe){let ut;if(ee(xe)){const{language:ht,value:gt}=xe;ut={value:"```"+ht+`
`+gt+"\n```\n"}}else b.MarkdownString.isMarkdownString(xe)?ut={value:xe.value,isTrusted:xe.isTrusted,supportThemeIcons:xe.supportThemeIcons,supportHtml:xe.supportHtml}:typeof xe=="string"?ut={value:xe}:ut={value:""};const vt=Object.create(null);ut.uris=vt;const St=ht=>{try{let gt=R.URI.parse(ht,!0);gt=gt.with({query:be(gt.query,vt)}),vt[ht]=gt}catch{}return""},bt=new T.Renderer;return bt.link=St,bt.image=ht=>St(w.parseHrefAndDimensions(ht).href),T(ut.value,{renderer:bt}),ut}ne.from=W;function be(xe,ut){if(!xe)return xe;let vt;try{vt=(0,k.parse)(xe)}catch{}if(!vt)return xe;let St=!1;return vt=(0,I.cloneAndChange)(vt,bt=>{if(R.URI.isUri(bt)){const ht=`__uri_${Math.random().toString(16).slice(2,8)}`;return ut[ht]=bt,St=!0,ht}else return}),St?JSON.stringify(vt):xe}function De(xe){const ut=new b.MarkdownString(xe.value,xe.supportThemeIcons);return ut.isTrusted=xe.isTrusted,ut.supportHtml=xe.supportHtml,ut}ne.to=De;function qe(xe){if(!!xe)return typeof xe=="string"?xe:ne.from(xe)}ne.fromStrict=qe})(u=e.MarkdownString||(e.MarkdownString={}));function D(ne){return y(ne)?ne.map(pe=>({range:g.from(pe.range),hoverMessage:Array.isArray(pe.hoverMessage)?u.fromMany(pe.hoverMessage):pe.hoverMessage?u.from(pe.hoverMessage):void 0,renderOptions:pe.renderOptions})):ne.map(pe=>({range:g.from(pe)}))}e.fromRangeOrRangeWithMessage=D;function A(ne){return typeof ne=="undefined"?ne:typeof ne=="string"?R.URI.file(ne):ne}e.pathOrURIToURI=A;var U;(function(ne){function pe(ee){return typeof ee=="undefined"?ee:{contentText:ee.contentText,contentIconPath:ee.contentIconPath?A(ee.contentIconPath):void 0,border:ee.border,borderColor:ee.borderColor,fontStyle:ee.fontStyle,fontWeight:ee.fontWeight,textDecoration:ee.textDecoration,color:ee.color,backgroundColor:ee.backgroundColor,margin:ee.margin,width:ee.width,height:ee.height}}ne.from=pe})(U=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var B;(function(ne){function pe(ee){return typeof ee=="undefined"?ee:{backgroundColor:ee.backgroundColor,outline:ee.outline,outlineColor:ee.outlineColor,outlineStyle:ee.outlineStyle,outlineWidth:ee.outlineWidth,border:ee.border,borderColor:ee.borderColor,borderRadius:ee.borderRadius,borderSpacing:ee.borderSpacing,borderStyle:ee.borderStyle,borderWidth:ee.borderWidth,fontStyle:ee.fontStyle,fontWeight:ee.fontWeight,textDecoration:ee.textDecoration,cursor:ee.cursor,color:ee.color,opacity:ee.opacity,letterSpacing:ee.letterSpacing,gutterIconPath:ee.gutterIconPath?A(ee.gutterIconPath):void 0,gutterIconSize:ee.gutterIconSize,overviewRulerColor:ee.overviewRulerColor,before:ee.before?U.from(ee.before):void 0,after:ee.after?U.from(ee.after):void 0}}ne.from=pe})(B=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var E;(function(ne){function pe(ee){if(typeof ee=="undefined")return ee;switch(ee){case b.DecorationRangeBehavior.OpenOpen:return 0;case b.DecorationRangeBehavior.ClosedClosed:return 1;case b.DecorationRangeBehavior.OpenClosed:return 2;case b.DecorationRangeBehavior.ClosedOpen:return 3}}ne.from=pe})(E=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var N;(function(ne){function pe(ee){return{isWholeLine:ee.isWholeLine,rangeBehavior:ee.rangeBehavior?E.from(ee.rangeBehavior):void 0,overviewRulerLane:ee.overviewRulerLane,light:ee.light?B.from(ee.light):void 0,dark:ee.dark?B.from(ee.dark):void 0,backgroundColor:ee.backgroundColor,outline:ee.outline,outlineColor:ee.outlineColor,outlineStyle:ee.outlineStyle,outlineWidth:ee.outlineWidth,border:ee.border,borderColor:ee.borderColor,borderRadius:ee.borderRadius,borderSpacing:ee.borderSpacing,borderStyle:ee.borderStyle,borderWidth:ee.borderWidth,fontStyle:ee.fontStyle,fontWeight:ee.fontWeight,textDecoration:ee.textDecoration,cursor:ee.cursor,color:ee.color,opacity:ee.opacity,letterSpacing:ee.letterSpacing,gutterIconPath:ee.gutterIconPath?A(ee.gutterIconPath):void 0,gutterIconSize:ee.gutterIconSize,overviewRulerColor:ee.overviewRulerColor,before:ee.before?U.from(ee.before):void 0,after:ee.after?U.from(ee.after):void 0}}ne.from=pe})(N=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var L;(function(ne){function pe(W){return{text:W.newText,eol:W.newEol&&lt.from(W.newEol),range:g.from(W.range)}}ne.from=pe;function ee(W){const be=new b.TextEdit(g.to(W.range),W.text);return be.newEol=typeof W.eol=="undefined"?void 0:lt.to(W.eol),be}ne.to=ee})(L=e.TextEdit||(e.TextEdit={}));var z;(function(ne){function pe(W,be,De){const qe={edits:[]};if(W instanceof b.WorkspaceEdit)for(let xe of W._allEntries())if(xe._type===1)qe.edits.push({_type:1,oldUri:xe.from,newUri:xe.to,options:xe.options,metadata:xe.metadata});else if(xe._type===2){const ut=be?.getDocument(xe.uri);qe.edits.push({_type:2,resource:xe.uri,edit:L.from(xe.edit),modelVersionId:ut?.version,metadata:xe.metadata})}else xe._type===3?qe.edits.push({_type:3,metadata:xe.metadata,resource:xe.uri,edit:xe.edit,notebookMetadata:xe.notebookMetadata,notebookVersionId:De?.getNotebookDocument(xe.uri,!0)?.apiNotebook.version}):xe._type===5&&qe.edits.push({_type:3,metadata:xe.metadata,resource:xe.uri,notebookVersionId:De?.getNotebookDocument(xe.uri,!0)?.apiNotebook.version,edit:{editType:1,index:xe.index,count:xe.count,cells:xe.cells.map(Ge.from)}});return qe}ne.from=pe;function ee(W){const be=new b.WorkspaceEdit;for(const De of W.edits)De.edit?be.replace(R.URI.revive(De.resource),g.to(De.edit.range),De.edit.text):be.renameFile(R.URI.revive(De.oldUri),R.URI.revive(De.newUri),De.options);return be}ne.to=ee})(z=e.WorkspaceEdit||(e.WorkspaceEdit={}));var H;(function(ne){const pe=Object.create(null);pe[b.SymbolKind.File]=0,pe[b.SymbolKind.Module]=1,pe[b.SymbolKind.Namespace]=2,pe[b.SymbolKind.Package]=3,pe[b.SymbolKind.Class]=4,pe[b.SymbolKind.Method]=5,pe[b.SymbolKind.Property]=6,pe[b.SymbolKind.Field]=7,pe[b.SymbolKind.Constructor]=8,pe[b.SymbolKind.Enum]=9,pe[b.SymbolKind.Interface]=10,pe[b.SymbolKind.Function]=11,pe[b.SymbolKind.Variable]=12,pe[b.SymbolKind.Constant]=13,pe[b.SymbolKind.String]=14,pe[b.SymbolKind.Number]=15,pe[b.SymbolKind.Boolean]=16,pe[b.SymbolKind.Array]=17,pe[b.SymbolKind.Object]=18,pe[b.SymbolKind.Key]=19,pe[b.SymbolKind.Null]=20,pe[b.SymbolKind.EnumMember]=21,pe[b.SymbolKind.Struct]=22,pe[b.SymbolKind.Event]=23,pe[b.SymbolKind.Operator]=24,pe[b.SymbolKind.TypeParameter]=25;function ee(be){return typeof pe[be]=="number"?pe[be]:6}ne.from=ee;function W(be){for(const De in pe)if(pe[De]===be)return Number(De);return b.SymbolKind.Property}ne.to=W})(H=e.SymbolKind||(e.SymbolKind={}));var j;(function(ne){function pe(W){switch(W){case b.SymbolTag.Deprecated:return 1}}ne.from=pe;function ee(W){switch(W){case 1:return b.SymbolTag.Deprecated}}ne.to=ee})(j=e.SymbolTag||(e.SymbolTag={}));var ue;(function(ne){function pe(W){return{name:W.name,kind:H.from(W.kind),tags:W.tags&&W.tags.map(j.from),containerName:W.containerName,location:ie.from(W.location)}}ne.from=pe;function ee(W){const be=new b.SymbolInformation(W.name,H.to(W.kind),W.containerName,ie.to(W.location));return be.tags=W.tags&&W.tags.map(j.to),be}ne.to=ee})(ue=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var G;(function(ne){function pe(W){const be={name:W.name||"!!MISSING: name!!",detail:W.detail,range:g.from(W.range),selectionRange:g.from(W.selectionRange),kind:H.from(W.kind),tags:W.tags?.map(j.from)??[]};return W.children&&(be.children=W.children.map(pe)),be}ne.from=pe;function ee(W){const be=new b.DocumentSymbol(W.name,W.detail,H.to(W.kind),g.to(W.range),g.to(W.selectionRange));return(0,a.isNonEmptyArray)(W.tags)&&(be.tags=W.tags.map(j.to)),W.children&&(be.children=W.children.map(ee)),be}ne.to=ee})(G=e.DocumentSymbol||(e.DocumentSymbol={}));var le;(function(ne){function pe(W){const be=new b.CallHierarchyItem(H.to(W.kind),W.name,W.detail||"",R.URI.revive(W.uri),g.to(W.range),g.to(W.selectionRange));return be._sessionId=W._sessionId,be._itemId=W._itemId,be}ne.to=pe;function ee(W,be,De){if(be=be??W._sessionId,De=De??W._itemId,be===void 0||De===void 0)throw new Error("invalid item");return{_sessionId:be,_itemId:De,name:W.name,detail:W.detail,kind:H.from(W.kind),uri:W.uri,range:g.from(W.range),selectionRange:g.from(W.selectionRange),tags:W.tags?.map(j.from)}}ne.from=ee})(le=e.CallHierarchyItem||(e.CallHierarchyItem={}));var ce;(function(ne){function pe(ee){return new b.CallHierarchyIncomingCall(le.to(ee.from),ee.fromRanges.map(W=>g.to(W)))}ne.to=pe})(ce=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var Y;(function(ne){function pe(ee){return new b.CallHierarchyOutgoingCall(le.to(ee.to),ee.fromRanges.map(W=>g.to(W)))}ne.to=pe})(Y=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var ie;(function(ne){function pe(W){return{range:W.range&&g.from(W.range),uri:W.uri}}ne.from=pe;function ee(W){return new b.Location(R.URI.revive(W.uri),g.to(W.range))}ne.to=ee})(ie=e.location||(e.location={}));var we;(function(ne){function pe(W){const be=W,De=W;return{originSelectionRange:be.originSelectionRange?g.from(be.originSelectionRange):void 0,uri:be.targetUri?be.targetUri:De.uri,range:g.from(be.targetRange?be.targetRange:De.range),targetSelectionRange:be.targetSelectionRange?g.from(be.targetSelectionRange):void 0}}ne.from=pe;function ee(W){return{targetUri:R.URI.revive(W.uri),targetRange:g.to(W.range),targetSelectionRange:W.targetSelectionRange?g.to(W.targetSelectionRange):void 0,originSelectionRange:W.originSelectionRange?g.to(W.originSelectionRange):void 0}}ne.to=ee})(we=e.DefinitionLink||(e.DefinitionLink={}));var Me;(function(ne){function pe(W){return{range:g.from(W.range),contents:u.fromMany(W.contents)}}ne.from=pe;function ee(W){return new b.Hover(W.contents.map(u.to),g.to(W.range))}ne.to=ee})(Me=e.Hover||(e.Hover={}));var Re;(function(ne){function pe(W){return{range:g.from(W.range),expression:W.expression}}ne.from=pe;function ee(W){return new b.EvaluatableExpression(g.to(W.range),W.expression)}ne.to=ee})(Re=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Be;(function(ne){function pe(W){if(W instanceof b.InlineValueText)return{type:"text",range:g.from(W.range),text:W.text};if(W instanceof b.InlineValueVariableLookup)return{type:"variable",range:g.from(W.range),variableName:W.variableName,caseSensitiveLookup:W.caseSensitiveLookup};if(W instanceof b.InlineValueEvaluatableExpression)return{type:"expression",range:g.from(W.range),expression:W.expression};throw new Error("Unknown 'InlineValue' type")}ne.from=pe;function ee(W){switch(W.type){case"text":return{range:g.to(W.range),text:W.text};case"variable":return{range:g.to(W.range),variableName:W.variableName,caseSensitiveLookup:W.caseSensitiveLookup};case"expression":return{range:g.to(W.range),expression:W.expression}}}ne.to=ee})(Be=e.InlineValue||(e.InlineValue={}));var Qe;(function(ne){function pe(W){return{frameId:W.frameId,stoppedLocation:g.from(W.stoppedLocation)}}ne.from=pe;function ee(W){return new b.InlineValueContext(W.frameId,g.to(W.stoppedLocation))}ne.to=ee})(Qe=e.InlineValueContext||(e.InlineValueContext={}));var Ke;(function(ne){function pe(W){return{range:g.from(W.range),kind:W.kind}}ne.from=pe;function ee(W){return new b.DocumentHighlight(g.to(W.range),W.kind)}ne.to=ee})(Ke=e.DocumentHighlight||(e.DocumentHighlight={}));var Xe;(function(ne){function pe(ee){switch(ee){case 1:return b.CompletionTriggerKind.TriggerCharacter;case 2:return b.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return b.CompletionTriggerKind.Invoke}}ne.to=pe})(Xe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var $;(function(ne){function pe(ee){return{triggerKind:Xe.to(ee.triggerKind),triggerCharacter:ee.triggerCharacter}}ne.to=pe})($=e.CompletionContext||(e.CompletionContext={}));var K;(function(ne){function pe(W){switch(W){case b.CompletionItemTag.Deprecated:return 1}}ne.from=pe;function ee(W){switch(W){case 1:return b.CompletionItemTag.Deprecated}}ne.to=ee})(K=e.CompletionItemTag||(e.CompletionItemTag={}));var J;(function(ne){const pe=new Map([[b.CompletionItemKind.Method,0],[b.CompletionItemKind.Function,1],[b.CompletionItemKind.Constructor,2],[b.CompletionItemKind.Field,3],[b.CompletionItemKind.Variable,4],[b.CompletionItemKind.Class,5],[b.CompletionItemKind.Interface,7],[b.CompletionItemKind.Struct,6],[b.CompletionItemKind.Module,8],[b.CompletionItemKind.Property,9],[b.CompletionItemKind.Unit,12],[b.CompletionItemKind.Value,13],[b.CompletionItemKind.Constant,14],[b.CompletionItemKind.Enum,15],[b.CompletionItemKind.EnumMember,16],[b.CompletionItemKind.Keyword,17],[b.CompletionItemKind.Snippet,27],[b.CompletionItemKind.Text,18],[b.CompletionItemKind.Color,19],[b.CompletionItemKind.File,20],[b.CompletionItemKind.Reference,21],[b.CompletionItemKind.Folder,23],[b.CompletionItemKind.Event,10],[b.CompletionItemKind.Operator,11],[b.CompletionItemKind.TypeParameter,24],[b.CompletionItemKind.Issue,26],[b.CompletionItemKind.User,25]]);function ee(De){return pe.get(De)??9}ne.from=ee;const W=new Map([[0,b.CompletionItemKind.Method],[1,b.CompletionItemKind.Function],[2,b.CompletionItemKind.Constructor],[3,b.CompletionItemKind.Field],[4,b.CompletionItemKind.Variable],[5,b.CompletionItemKind.Class],[7,b.CompletionItemKind.Interface],[6,b.CompletionItemKind.Struct],[8,b.CompletionItemKind.Module],[9,b.CompletionItemKind.Property],[12,b.CompletionItemKind.Unit],[13,b.CompletionItemKind.Value],[14,b.CompletionItemKind.Constant],[15,b.CompletionItemKind.Enum],[16,b.CompletionItemKind.EnumMember],[17,b.CompletionItemKind.Keyword],[27,b.CompletionItemKind.Snippet],[18,b.CompletionItemKind.Text],[19,b.CompletionItemKind.Color],[20,b.CompletionItemKind.File],[21,b.CompletionItemKind.Reference],[23,b.CompletionItemKind.Folder],[10,b.CompletionItemKind.Event],[11,b.CompletionItemKind.Operator],[24,b.CompletionItemKind.TypeParameter],[25,b.CompletionItemKind.User],[26,b.CompletionItemKind.Issue]]);function be(De){return W.get(De)??b.CompletionItemKind.Property}ne.to=be})(J=e.CompletionItemKind||(e.CompletionItemKind={}));var ae;(function(ne){function pe(ee,W){const be=new b.CompletionItem(ee.label);return be.insertText=ee.insertText,be.kind=J.to(ee.kind),be.tags=ee.tags?.map(K.to),be.detail=ee.detail,be.documentation=w.isMarkdownString(ee.documentation)?u.to(ee.documentation):ee.documentation,be.sortText=ee.sortText,be.filterText=ee.filterText,be.preselect=ee.preselect,be.commitCharacters=ee.commitCharacters,F.Range.isIRange(ee.range)?be.range=g.to(ee.range):typeof ee.range=="object"&&(be.range={inserting:g.to(ee.range.insert),replacing:g.to(ee.range.replace)}),be.keepWhitespace=typeof ee.insertTextRules=="undefined"?!1:Boolean(ee.insertTextRules&1),typeof ee.insertTextRules!="undefined"&&ee.insertTextRules&4?be.insertText=new b.SnippetString(ee.insertText):(be.insertText=ee.insertText,be.textEdit=be.range instanceof b.Range?new b.TextEdit(be.range,be.insertText):void 0),ee.additionalTextEdits&&ee.additionalTextEdits.length>0&&(be.additionalTextEdits=ee.additionalTextEdits.map(De=>L.to(De))),be.command=W&&ee.command?W.fromInternal(ee.command):void 0,be}ne.to=pe})(ae=e.CompletionItem||(e.CompletionItem={}));var q;(function(ne){function pe(W){return{label:W.label,documentation:W.documentation?u.fromStrict(W.documentation):void 0}}ne.from=pe;function ee(W){return{label:W.label,documentation:w.isMarkdownString(W.documentation)?u.to(W.documentation):W.documentation}}ne.to=ee})(q=e.ParameterInformation||(e.ParameterInformation={}));var te;(function(ne){function pe(W){return{label:W.label,documentation:W.documentation?u.fromStrict(W.documentation):void 0,parameters:Array.isArray(W.parameters)?W.parameters.map(q.from):[],activeParameter:W.activeParameter}}ne.from=pe;function ee(W){return{label:W.label,documentation:w.isMarkdownString(W.documentation)?u.to(W.documentation):W.documentation,parameters:Array.isArray(W.parameters)?W.parameters.map(q.to):[],activeParameter:W.activeParameter}}ne.to=ee})(te=e.SignatureInformation||(e.SignatureInformation={}));var me;(function(ne){function pe(W){return{activeSignature:W.activeSignature,activeParameter:W.activeParameter,signatures:Array.isArray(W.signatures)?W.signatures.map(te.from):[]}}ne.from=pe;function ee(W){return{activeSignature:W.activeSignature,activeParameter:W.activeParameter,signatures:Array.isArray(W.signatures)?W.signatures.map(te.to):[]}}ne.to=ee})(me=e.SignatureHelp||(e.SignatureHelp={}));var Pe;(function(ne){function pe(W){return{text:W.text,position:l.from(W.position),kind:Ne.from(W.kind??b.InlayHintKind.Other),whitespaceBefore:W.whitespaceBefore,whitespaceAfter:W.whitespaceAfter}}ne.from=pe;function ee(W){const be=new b.InlayHint(W.text,l.to(W.position),Ne.to(W.kind));return be.whitespaceAfter=W.whitespaceAfter,be.whitespaceBefore=W.whitespaceBefore,be}ne.to=ee})(Pe=e.InlayHint||(e.InlayHint={}));var Ne;(function(ne){function pe(W){return W}ne.from=pe;function ee(W){return W}ne.to=ee})(Ne=e.InlayHintKind||(e.InlayHintKind={}));var He;(function(ne){function pe(W){return{range:g.from(W.range),url:W.target,tooltip:W.tooltip}}ne.from=pe;function ee(W){let be;if(W.url)try{be=typeof W.url=="string"?R.URI.parse(W.url,!0):R.URI.revive(W.url)}catch{}return new b.DocumentLink(g.to(W.range),be)}ne.to=ee})(He=e.DocumentLink||(e.DocumentLink={}));var Ye;(function(ne){function pe(W){const be=new b.ColorPresentation(W.label);return W.textEdit&&(be.textEdit=L.to(W.textEdit)),W.additionalTextEdits&&(be.additionalTextEdits=W.additionalTextEdits.map(De=>L.to(De))),be}ne.to=pe;function ee(W){return{label:W.label,textEdit:W.textEdit?L.from(W.textEdit):void 0,additionalTextEdits:W.additionalTextEdits?W.additionalTextEdits.map(be=>L.from(be)):void 0}}ne.from=ee})(Ye=e.ColorPresentation||(e.ColorPresentation={}));var et;(function(ne){function pe(W){return new b.Color(W[0],W[1],W[2],W[3])}ne.to=pe;function ee(W){return[W.red,W.green,W.blue,W.alpha]}ne.from=ee})(et=e.Color||(e.Color={}));var st;(function(ne){function pe(W){return{range:g.from(W.range)}}ne.from=pe;function ee(W){return new b.SelectionRange(g.to(W.range))}ne.to=ee})(st=e.SelectionRange||(e.SelectionRange={}));var Je;(function(ne){function pe(ee){switch(ee){case 2:return b.TextDocumentSaveReason.AfterDelay;case 1:return b.TextDocumentSaveReason.Manual;case 3:case 4:return b.TextDocumentSaveReason.FocusOut}}ne.to=pe})(Je=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var nt;(function(ne){function pe(W){switch(W){case b.TextEditorLineNumbersStyle.Off:return 0;case b.TextEditorLineNumbersStyle.Relative:return 2;case b.TextEditorLineNumbersStyle.On:default:return 1}}ne.from=pe;function ee(W){switch(W){case 0:return b.TextEditorLineNumbersStyle.Off;case 2:return b.TextEditorLineNumbersStyle.Relative;case 1:default:return b.TextEditorLineNumbersStyle.On}}ne.to=ee})(nt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var lt;(function(ne){function pe(W){if(W===b.EndOfLine.CRLF)return 1;if(W===b.EndOfLine.LF)return 0}ne.from=pe;function ee(W){if(W===1)return b.EndOfLine.CRLF;if(W===0)return b.EndOfLine.LF}ne.to=ee})(lt=e.EndOfLine||(e.EndOfLine={}));var pt;(function(ne){function pe(ee){if(typeof ee=="object")return ee.viewId;switch(ee){case b.ProgressLocation.SourceControl:return 3;case b.ProgressLocation.Window:return 10;case b.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ne.from=pe})(pt=e.ProgressLocation||(e.ProgressLocation={}));var Ft;(function(ne){function pe(ee){const W={start:ee.start+1,end:ee.end+1};return ee.kind&&(W.kind=Fe.from(ee.kind)),W}ne.from=pe})(Ft=e.FoldingRange||(e.FoldingRange={}));var Fe;(function(ne){function pe(ee){if(ee)switch(ee){case b.FoldingRangeKind.Comment:return _.FoldingRangeKind.Comment;case b.FoldingRangeKind.Imports:return _.FoldingRangeKind.Imports;case b.FoldingRangeKind.Region:return _.FoldingRangeKind.Region}}ne.from=pe})(Fe=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Mt;(function(ne){function pe(ee){if(ee)return{pinned:typeof ee.preview=="boolean"?!ee.preview:void 0,inactive:ee.background,preserveFocus:ee.preserveFocus,selection:typeof ee.selection=="object"?g.from(ee.selection):void 0,override:typeof ee.override=="boolean"?n.EditorResolution.DISABLED:void 0}}ne.from=pe})(Mt=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var V;(function(ne){function pe(W){return W instanceof b.RelativePattern||typeof W=="string"?W:ee(W)?new b.RelativePattern(W.base,W.pattern):W}ne.from=pe;function ee(W){const be=W;return be&&typeof be.base=="string"&&typeof be.pattern=="string"}})(V=e.GlobPattern||(e.GlobPattern={}));var Q;(function(ne){function pe(ee){if(ee){if(Array.isArray(ee))return ee.map(pe);if(typeof ee=="string")return ee;{const W=ee;return{language:W.language,scheme:W.scheme,pattern:typeof W.pattern=="undefined"?void 0:V.from(W.pattern),exclusive:W.exclusive}}}else return}ne.from=pe})(Q=e.LanguageSelector||(e.LanguageSelector={}));var he;(function(ne){function pe(W){return{start:W.start,end:W.end}}ne.from=pe;function ee(W){return new b.NotebookRange(W.start,W.end)}ne.to=ee})(he=e.NotebookRange||(e.NotebookRange={}));var Le;(function(ne){function pe(W){return{timing:typeof W.runStartTime=="number"&&typeof W.runEndTime=="number"?{startTime:W.runStartTime,endTime:W.runEndTime}:void 0,executionOrder:W.executionOrder,success:W.lastRunSuccess}}ne.to=pe;function ee(W){return{lastRunSuccess:W.success,runStartTime:W.timing?.startTime,runEndTime:W.timing?.endTime,executionOrder:W.executionOrder}}ne.from=ee})(Le=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var We;(function(ne){function pe(W){switch(W){case b.NotebookCellKind.Markup:return m.CellKind.Markup;case b.NotebookCellKind.Code:default:return m.CellKind.Code}}ne.from=pe;function ee(W){switch(W){case m.CellKind.Markup:return b.NotebookCellKind.Markup;case m.CellKind.Code:default:return b.NotebookCellKind.Code}}ne.to=ee})(We=e.NotebookCellKind||(e.NotebookCellKind={}));var ot;(function(ne){function pe(W){const be={metadata:W.metadata??Object.create(null),cells:[]};for(let De of W.cells)b.NotebookCellData.validate(De),be.cells.push(Ge.from(De));return be}ne.from=pe;function ee(W){const be=new b.NotebookData(W.cells.map(Ge.to));return(0,S.isEmptyObject)(W.metadata)||(be.metadata=W.metadata),be}ne.to=ee})(ot=e.NotebookData||(e.NotebookData={}));var Ge;(function(ne){function pe(W){return{cellKind:We.from(W.kind),language:W.languageId,mime:W.mime,source:W.value,metadata:W.metadata,internalMetadata:Le.from(W.executionSummary??{}),outputs:W.outputs?W.outputs.map(Ie.from):[]}}ne.from=pe;function ee(W){return new b.NotebookCellData(We.to(W.cellKind),W.source,W.language,W.mime,W.outputs?W.outputs.map(Ie.to):void 0,W.metadata,W.internalMetadata?Le.to(W.internalMetadata):void 0)}ne.to=ee})(Ge=e.NotebookCellData||(e.NotebookCellData={}));var yt;(function(ne){function pe(W){return{mime:W.mime,valueBytes:t.VSBuffer.wrap(W.data)}}ne.from=pe;function ee(W){return new b.NotebookCellOutputItem(W.valueBytes.buffer,W.mime)}ne.to=ee})(yt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Ie;(function(ne){function pe(W){return{outputId:W.id,items:W.items.map(yt.from),metadata:W.metadata}}ne.from=pe;function ee(W){const be=W.items.map(yt.to);return new b.NotebookCellOutput(be,W.outputId,W.metadata)}ne.to=ee})(Ie=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Ce;(function(ne){function pe(De){if(De!=null){if(De instanceof b.RelativePattern||typeof De=="string")return De;if(be(De))return new b.RelativePattern(De.base,De.pattern);if(W(De))return{include:V.from(De.include)||void 0,exclude:V.from(De.exclude)||void 0}}}ne.from=pe;function ee(De){return typeof De=="string"?De:be(De)?{base:De.base,pattern:De.pattern}:{include:De.include,exclude:De.exclude}}ne.to=ee;function W(De){const qe=De,xe=V.from(qe.include);if(!(xe&&xe instanceof b.RelativePattern||typeof xe=="string"))return!1;const ut=V.from(qe.exclude);return!!(ut&&ut instanceof b.RelativePattern||typeof ut=="string")}function be(De){const qe=De;return qe&&typeof qe.base=="string"&&typeof qe.pattern=="string"}})(Ce=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var ve;(function(ne){function pe(ee){return{backgroundColor:ee.backgroundColor,borderColor:ee.borderColor,top:ee.top?U.from(ee.top):void 0}}ne.from=pe})(ve=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var oe;(function(ne){function pe(ee,W,be){const De=typeof ee.command=="string"?{title:"",command:ee.command}:ee.command;return{alignment:ee.alignment===b.NotebookCellStatusBarAlignment.Left?1:2,command:W.toInternal(De,be),text:ee.text,tooltip:ee.tooltip,accessibilityInformation:ee.accessibilityInformation,priority:ee.priority}}ne.from=pe})(oe=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var se;(function(ne){function pe(ee){return{transientOutputs:ee?.transientOutputs??!1,transientCellMetadata:ee?.transientCellMetadata??{},transientDocumentMetadata:ee?.transientDocumentMetadata??{}}}ne.from=pe})(se=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var fe;(function(ne){function pe(W){return{uri:W.uri,provides:W.provides}}ne.from=pe;function ee(W){return new b.NotebookRendererScript(R.URI.revive(W.uri),W.provides)}ne.to=ee})(fe=e.NotebookRendererScript||(e.NotebookRendererScript={}));var ge;(function(ne){function pe(W){return{message:u.fromStrict(W.message)||"",type:0,expected:W.expectedOutput,actual:W.actualOutput,location:W.location?ie.from(W.location):void 0}}ne.from=pe;function ee(W){const be=new b.TestMessage(typeof W.message=="string"?W.message:u.to(W.message));return be.actualOutput=W.actual,be.expectedOutput=W.expected,be.location=W.location?ie.to(W.location):void 0,be}ne.to=ee})(ge=e.TestMessage||(e.TestMessage={}));var ke;(function(ne){let pe;(function(ee){ee.Delimiter="\0"})(pe||(pe={})),ne.namespace=(ee,W)=>ee+"\0"+W,ne.denamespace=ee=>{const W=ee.indexOf("\0");return{ctrlId:ee.slice(0,W),tagId:ee.slice(W+1)}}})(ke=e.TestTag||(e.TestTag={}));var ze;(function(ne){function pe(De){const qe=(0,o.getPrivateApiFor)(De).controllerId;return{extId:c.TestId.fromExtHostTestItem(De,qe).toString(),label:De.label,uri:De.uri,tags:De.tags.map(xe=>ke.namespace(qe,xe.id)),range:g.from(De.range)||null,description:De.description||null,error:De.error&&u.fromStrict(De.error)||null}}ne.from=pe;function ee(De){return{parent:void 0,error:void 0,id:c.TestId.fromString(De.extId).localId,label:De.label,uri:R.URI.revive(De.uri),tags:(De.tags||[]).map(qe=>{const{tagId:xe}=ke.denamespace(qe);return new b.TestTag(xe)}),range:g.to(De.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:De.description||void 0}}ne.toPlain=ee;function W(De){const qe=c.TestId.fromString(De.extId),xe=new o.TestItemImpl(qe.controllerId,qe.localId,De.label,R.URI.revive(De.uri));return xe.range=g.to(De.range||void 0),xe.description=De.description||void 0,xe}function be(De){let qe;for(const xe of De.tests){const ut=W(xe.item);(0,o.getPrivateApiFor)(ut).parent=qe,qe=ut}return qe}ne.toItemFromContext=be})(ze=e.TestItem||(e.TestItem={})),function(ne){function pe(W){return{id:W.id}}ne.from=pe;function ee(W){return new b.TestTag(W.id)}ne.to=ee}(ke=e.TestTag||(e.TestTag={}));var Oe;(function(ne){const pe=(W,be)=>{const De={...ze.toPlain(W.item),parent:void 0,taskStates:W.tasks.map(qe=>({state:qe.state,duration:qe.duration,messages:qe.messages.filter(xe=>xe.type===0).map(ge.to)})),children:W.children.map(qe=>be.get(qe)).filter(S.isDefined).map(qe=>pe(qe,be))};for(const qe of De.children)qe.parent=De;return De};function ee(W){const be=[],De=new Map;for(const qe of W.items)De.set(qe.item.extId,qe),W.request.targets.some(xe=>xe.controllerId===qe.controllerId&&xe.testIds.includes(qe.item.extId))&&be.push(qe);return{completedAt:W.completedAt,results:be.map(qe=>pe(qe,De))}}ne.to=ee})(Oe=e.TestResults||(e.TestResults={}));var Ve;(function(ne){function pe(De){return{covered:De.covered,total:De.covered}}function ee(De){return"line"in De?l.from(De):g.from(De)}function W(De){return"branches"in De?{count:De.executionCount,location:ee(De.location),type:1,branches:De.branches.length?De.branches.map(qe=>({count:qe.executionCount,location:qe.location&&ee(qe.location)})):void 0}:{type:0,count:De.executionCount,location:ee(De.location)}}ne.fromDetailed=W;function be(De){return{uri:De.uri,statement:pe(De.statementCoverage),branch:De.branchCoverage&&pe(De.branchCoverage),function:De.functionCoverage&&pe(De.functionCoverage),details:De.detailedCoverage?.map(W)}}ne.fromFile=be})(Ve=e.TestCoverage||(e.TestCoverage={}));var it;(function(ne){function pe(ee){switch(ee){case 1:return b.CodeActionTriggerKind.Invoke;case 2:return b.CodeActionTriggerKind.Automatic}}ne.to=pe})(it=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var rt;(function(ne){function pe(W){const be=new b.TypeHierarchyItem(H.to(W.kind),W.name,W.detail||"",R.URI.revive(W.uri),g.to(W.range),g.to(W.selectionRange));return be._sessionId=W._sessionId,be._itemId=W._itemId,be}ne.to=pe;function ee(W,be,De){if(be=be??W._sessionId,De=De??W._itemId,be===void 0||De===void 0)throw new Error("invalid item");return{_sessionId:be,_itemId:De,kind:H.from(W.kind),name:W.name,detail:W.detail??"",uri:W.uri,range:g.from(W.range),selectionRange:g.from(W.selectionRange),tags:W.tags?.map(j.from)}}ne.from=ee})(rt=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(Ee[165],ye([0,1,2,15,7,8,226]),function(re,e,a,t,w,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class I{constructor(R,F,_,n={timeout:1500,errors:3}){this._logService=R,this._documents=F,this._mainThreadBulkEdits=_,this._thresholds=n,this._callbacks=new k.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(R){return(F,_,n)=>{const o={dispose:this._callbacks.push([F,_,R])};return Array.isArray(n)&&n.push(o),o}}async $participateInSave(R,F){const _=a.URI.revive(R);let n=!1;const f=setTimeout(()=>n=!0,this._thresholds.timeout),o=[];try{for(let m of[...this._callbacks]){if(n)break;const c=this._documents.getDocument(_),C=await this._deliverEventAsyncAndBlameBadListeners(m,{document:c,reason:T.TextDocumentSaveReason.to(F)});o.push(C)}}finally{clearTimeout(f)}return o}_deliverEventAsyncAndBlameBadListeners([R,F,_],n){const f=this._badListeners.get(R);return typeof f=="number"&&f>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(_,R,F,n).then(()=>!0,o=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${_.identifier.value}' threw ERROR`),this._logService.error(o),!(o instanceof Error)||o.message!=="concurrent_edits"){const m=this._badListeners.get(R);this._badListeners.set(R,m?m+1:1),typeof m=="number"&&m>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${_.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(R,F,_,n){const f=[],o=Date.now(),{document:m,reason:c}=n,{version:C}=m,b=Object.freeze({document:m,reason:c,waitUntil(h){if(Object.isFrozen(f))throw(0,t.illegalState)("waitUntil can not be called async");f.push(Promise.resolve(h))}});try{F.apply(_,[b])}catch(h){return Promise.reject(h)}return Object.freeze(f),new Promise((h,g)=>{const P=setTimeout(()=>g(new Error("timeout")),this._thresholds.timeout);return Promise.all(f).then(l=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${R.identifier.value}' finished after ${Date.now()-o}ms`),clearTimeout(P),h(l)}).catch(l=>{clearTimeout(P),g(l)})}).then(h=>{const g={edits:[]};for(const P of h)if(Array.isArray(P)&&P.every(l=>l instanceof w.TextEdit))for(const{newText:l,newEol:M,range:r}of P)g.edits.push({_type:2,resource:m.uri,edit:{range:r&&T.Range.from(r),text:l,eol:M&&T.EndOfLine.from(M)}});if(g.edits.length!==0)return C===m.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(g):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=I}),define(Ee[166],ye([0,1,4,29,2,8,7]),function(re,e,a,t,w,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class I{constructor(F,_,n,f,o){this._onDidCreate=new a.Emitter,this._onDidChange=new a.Emitter,this._onDidDelete=new a.Emitter,this._config=0,n&&(this._config+=1),f&&(this._config+=2),o&&(this._config+=4);const m=(0,t.parse)(_),c=F(C=>{if(!n)for(let b of C.created){const h=w.URI.revive(b);m(h.fsPath)&&this._onDidCreate.fire(h)}if(!f)for(let b of C.changed){const h=w.URI.revive(b);m(h.fsPath)&&this._onDidChange.fire(h)}if(!o)for(let b of C.deleted){const h=w.URI.revive(b);m(h.fsPath)&&this._onDidDelete.fire(h)}});this._disposable=k.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,c)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class S{constructor(F,_,n){this._logService=_,this._extHostDocumentsAndEditors=n,this._onFileSystemEvent=new a.Emitter,this._onDidRenameFile=new a.Emitter,this._onDidCreateFile=new a.Emitter,this._onDidDeleteFile=new a.Emitter,this._onWillRenameFile=new a.AsyncEmitter,this._onWillCreateFile=new a.AsyncEmitter,this._onWillDeleteFile=new a.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(F,_,n,f){return new I(this._onFileSystemEvent.event,F,_,n,f)}$onFileEvent(F){this._onFileSystemEvent.fire(F)}$onDidRunFileOperation(F,_){switch(F){case 2:this._onDidRenameFile.fire(Object.freeze({files:_.map(n=>({oldUri:w.URI.revive(n.source),newUri:w.URI.revive(n.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:_.map(n=>w.URI.revive(n.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:_.map(n=>w.URI.revive(n.target))}));break;default:}}getOnWillRenameFileEvent(F){return this._createWillExecuteEvent(F,this._onWillRenameFile)}getOnWillCreateFileEvent(F){return this._createWillExecuteEvent(F,this._onWillCreateFile)}getOnWillDeleteFileEvent(F){return this._createWillExecuteEvent(F,this._onWillDeleteFile)}_createWillExecuteEvent(F,_){return(n,f,o)=>{const m=function(C){n.call(f,C)};return m.extension=F,_.event(m,void 0,o)}}async $onWillRunFileOperation(F,_,n,f){switch(F){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:_.map(o=>({oldUri:w.URI.revive(o.source),newUri:w.URI.revive(o.target)}))},n,f);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:_.map(o=>w.URI.revive(o.target))},n,f);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:_.map(o=>w.URI.revive(o.target))},n,f)}}async _fireWillEvent(F,_,n,f){const o=new Set,m=[];if(await F.fireAsync(_,f,async(C,b)=>{const h=Date.now(),g=await Promise.resolve(C);g instanceof k.WorkspaceEdit&&(m.push(g),o.add(b.extension.displayName??b.extension.identifier.value)),Date.now()-h>n&&this._logService.warn("SLOW file-participant",b.extension.identifier)}),f.isCancellationRequested||m.length===0)return;const c={edits:[]};for(let C of m){let{edits:b}=T.WorkspaceEdit.from(C,this._extHostDocumentsAndEditors);c.edits=c.edits.concat(b)}return{edit:c,extensionNames:Array.from(o)}}}e.ExtHostFileSystemEventService=S}),define(Ee[167],ye([0,1,10,26,2,8,7,87]),function(re,e,a,t,w,T,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class S{constructor(n,f,o,m){this.start=n,this.deletedCount=f,this.deletedItems=o,this.items=m}static asApiEvents(n){return n.map(f=>({start:f.start,deletedCount:f.deletedCount,deletedItems:f.deletedItems,items:f.items.map(o=>o.apiCell)}))}}class R{constructor(n,f,o){this.notebook=n,this._extHostDocument=f,this._cellData=o,this.handle=o.handle,this.uri=w.URI.revive(o.uri),this.cellKind=o.cellKind,this._outputs=o.outputs.map(T.NotebookCellOutput.to),this._internalMetadata=o.internalMetadata??{},this._metadata=Object.freeze(o.metadata??{}),this._previousResult=Object.freeze(T.NotebookCellExecutionSummary.to(o.internalMetadata??{}))}static asModelAddData(n,f){return{EOL:f.eol,lines:f.source,languageId:f.language,uri:f.uri,isDirty:!1,versionId:1,notebook:n}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const n=this,f=this._extHostDocument.getDocument(this.uri);if(!f)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return n.notebook.getCellIndex(n)},notebook:n.notebook.apiNotebook,kind:T.NotebookCellKind.to(this._cellData.cellKind),document:f.document,get mime(){return n._mime},set mime(o){n._mime=o},get outputs(){return n._outputs.slice(0)},get metadata(){return n._metadata},get executionSummary(){return n._previousResult}})}return this._apiCell}setOutputs(n){this._outputs=n.map(T.NotebookCellOutput.to)}setOutputItems(n,f,o){const m=o.map(T.NotebookCellOutputItem.to),c=this._outputs.find(C=>C.id===n);c&&(f||(c.items.length=0),c.items.push(...m))}setMetadata(n){this._metadata=Object.freeze(n)}setInternalMetadata(n){this._internalMetadata=n,this._previousResult=Object.freeze(T.NotebookCellExecutionSummary.to(n))}setMime(n){}}e.ExtHostCell=R;class F{constructor(n,f,o,m,c,C){this._proxy=n,this._textDocumentsAndEditors=f,this._textDocuments=o,this._emitter=m,this.uri=c,this.handle=F._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=C.viewType,this._metadata=Object.freeze(C.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,C.cells]],!0),this._versionId=C.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const n=this;this._notebook={get uri(){return n.uri},get version(){return n._versionId},get notebookType(){return n._notebookType},get isDirty(){return n._isDirty},get isUntitled(){return n.uri.scheme===a.Schemas.untitled},get isClosed(){return n._disposed},get metadata(){return n._metadata},get cellCount(){return n._cells.length},cellAt(f){return f=n._validateIndex(f),n._cells[f].apiCell},getCells(f){return(f?n._getCells(f):n._cells).map(m=>m.apiCell)},save(){return n._save()}}}return this._notebook}updateBackup(n){this._backup?.delete(),this._backup=n}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(n){n.metadata&&(this._metadata=Object.freeze({...this._metadata,...n.metadata}))}acceptDirty(n){this._isDirty=n}acceptModelChanged(n,f){this._versionId=n.versionId,this._isDirty=f;for(const o of n.rawEvents)o.kind===I.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(o.changes,!1):o.kind===I.NotebookCellsChangeType.Move?this._moveCell(o.index,o.newIdx):o.kind===I.NotebookCellsChangeType.Output?this._setCellOutputs(o.index,o.outputs):o.kind===I.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(o.index,o.outputId,o.append,o.outputItems):o.kind===I.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(o.index,o.language):o.kind===I.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(o.index,o.mime):o.kind===I.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(o.index,o.metadata):o.kind===I.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(o.index,o.internalMetadata)}_validateIndex(n){return n=n|0,n<0?0:n>=this._cells.length?this._cells.length-1:n}_validateRange(n){let f=n.start|0,o=n.end|0;return f<0&&(f=0),o>this._cells.length&&(o=this._cells.length),n.with({start:f,end:o})}_getCells(n){n=this._validateRange(n);const f=[];for(let o=n.start;o<n.end;o++)f.push(this._cells[o]);return f}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(n,f){if(this._disposed)return;const o=[],m=[],c=[];n.reverse().forEach(C=>{const h=C[2].map(l=>{const M=new R(this,this._textDocumentsAndEditors,l);return f||m.push(R.asModelAddData(this.apiNotebook,l)),M}),g=new S(C[0],C[1],[],h),P=this._cells.splice(C[0],C[1],...h);for(const l of P)c.push(l.uri),g.deletedItems.push(l.apiCell);o.push(g)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:m,removedDocuments:c}),f||this._emitter.emitModelChange((0,t.deepFreeze)({document:this.apiNotebook,changes:S.asApiEvents(o)}))}_moveCell(n,f){const o=this._cells.splice(n,1);this._cells.splice(f,0,...o);const m=[new S(n,1,o.map(c=>c.apiCell),[]),new S(f,0,[],o)];this._emitter.emitModelChange((0,t.deepFreeze)({document:this.apiNotebook,changes:S.asApiEvents(m)}))}_setCellOutputs(n,f){const o=this._cells[n];o.setOutputs(f),this._emitter.emitCellOutputsChange((0,t.deepFreeze)({document:this.apiNotebook,cells:[o.apiCell]}))}_setCellOutputItems(n,f,o,m){const c=this._cells[n];c.setOutputItems(f,o,m),this._emitter.emitCellOutputsChange((0,t.deepFreeze)({document:this.apiNotebook,cells:[c.apiCell]}))}_changeCellLanguage(n,f){const o=this._cells[n];o.apiCell.document.languageId!==f&&this._textDocuments.$acceptModelModeChanged(o.uri,f)}_changeCellMime(n,f){const o=this._cells[n];o.apiCell.mime=f}_changeCellMetadata(n,f){const o=this._cells[n],m=o.apiCell.metadata;o.setMetadata(f);const c=o.apiCell.metadata;(0,t.equals)(m,c)||this._emitter.emitCellMetadataChange((0,t.deepFreeze)({document:this.apiNotebook,cell:o.apiCell}))}_changeCellInternalMetadata(n,f){const o=this._cells[n],m=o.internalMetadata;if(o.setInternalMetadata(f),m.runState!==f.runState){const c=f.runState??k.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,t.deepFreeze)({document:this.apiNotebook,cell:o.apiCell,state:c}))}}getCellFromApiCell(n){return this._cells.find(f=>f.apiCell===n)}getCellFromIndex(n){return this._cells[n]}getCell(n){return this._cells.find(f=>f.handle===n)}getCellIndex(n){return this._cells.indexOf(n)}}e.ExtHostNotebookDocument=F,F._handlePool=0}),define(Ee[91],ye([0,1,7,8,15]),function(re,e,a,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class T{constructor(S){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=S}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(S){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:S})}replaceCellMetadata(S,R){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:S,metadata:R})}replaceCells(S,R,F){this._throwIfFinalized(),!(S===R&&F.length===0)&&this._collectedEdits.push({editType:1,index:S,count:R-S,cells:F.map(t.NotebookCellData.from)})}}class k{constructor(S,R,F,_,n,f){this.id=S,this._proxy=R,this.notebookData=F,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=n,this._visibleRanges=_,this._viewColumn=f}get apiEditor(){if(!this._editor){const S=this;this._editor={get document(){return S.notebookData.apiNotebook},get selections(){return S._selections},set selections(R){if(!Array.isArray(R)||!R.every(a.NotebookRange.isNotebookRange))throw(0,w.illegalArgument)("selections");S._selections=R,S._trySetSelections(R)},get visibleRanges(){return S._visibleRanges},revealRange(R,F){S._proxy.$tryRevealRange(S.id,t.NotebookRange.from(R),F??a.NotebookEditorRevealType.Default)},get viewColumn(){return S._viewColumn},edit(R){const F=new T(this.document.version);return R(F),S._applyEdit(F.finalize())},setDecorations(R,F){return S.setDecorations(R,F)}},k.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(S){this._visible=S}_acceptVisibleRanges(S){this._visibleRanges=S}_acceptSelections(S){this._selections=S}_trySetSelections(S){this._proxy.$trySetSelections(this.id,S.map(t.NotebookRange.from))}_acceptViewColumn(S){this._viewColumn=S}_applyEdit(S){if(S.cellEdits.length===0)return Promise.resolve(!0);const R=[];let F=-1;for(let _=0;_<S.cellEdits.length;_++){if(F<0){R.push(S.cellEdits[_]),F++;continue}const f=R[F],o=S.cellEdits[_];if(f.editType===1&&o.editType===1&&f.index===o.index){f.cells.push(...S.cellEdits[_].cells),f.count+=S.cellEdits[_].count;continue}R.push(S.cellEdits[_]),F++}return this._proxy.$tryApplyEdits(this.id,S.documentVersionId,R)}setDecorations(S,R){if(!(R.isEmpty&&!this._hasDecorationsForKey.has(S.key)))return R.isEmpty?this._hasDecorationsForKey.delete(S.key):this._hasDecorationsForKey.add(S.key),this._proxy.$trySetDecorations(this.id,t.NotebookRange.from(R),S.key)}}e.ExtHostNotebookEditor=k,k.apiEditorsToExtHost=new WeakMap}),define(Ee[168],ye([0,1,8,140,121,20,52,15]),function(re,e,a,t,w,T,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class S{constructor(n){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=n}async withProgress(n,f,o){const m=this._handles++,{title:c,location:C,cancellable:b}=f,h={label:(0,w.localize)(0,null,n.displayName||n.name),id:n.identifier.value};return this._proxy.$startProgress(m,{location:a.ProgressLocation.from(C),title:c,source:h,cancellable:b},n).catch(I.onUnexpectedExternalError),this._withProgress(m,o,!!b)}_withProgress(n,f,o){let m;o&&(m=new T.CancellationTokenSource,this._mapHandleToCancellationSource.set(n,m));const c=b=>{this._proxy.$progressEnd(b),this._mapHandleToCancellationSource.delete(b),m&&m.dispose()};let C;try{C=f(new F(this._proxy,n),o&&m?m.token:T.CancellationToken.None)}catch(b){throw c(n),b}return C.then(b=>c(n),b=>c(n)),C}$acceptProgressCanceled(n){const f=this._mapHandleToCancellationSource.get(n);f&&(f.cancel(),this._mapHandleToCancellationSource.delete(n))}}e.ExtHostProgress=S;function R(_,n){return _.message=n.message,typeof n.increment=="number"&&(typeof _.increment=="number"?_.increment+=n.increment:_.increment=n.increment),_}class F extends t.Progress{constructor(n,f){super(o=>this.throttledReport(o));this._proxy=n,this._handle=f}throttledReport(n){this._proxy.$progressReport(this._handle,n)}}Ue([(0,k.throttle)(100,(_,n)=>R(_,n),()=>Object.create(null))],F.prototype,"throttledReport",null)}),define(Ee[92],ye([0,1,41,15,53,8,7]),function(re,e,a,t,w,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class I{constructor(n,f,o){const m=I._Keys.nextId();n.$registerTextEditorDecorationType(f.identifier,m,T.DecorationRenderOptions.from(o)),this.value=Object.freeze({key:m,dispose(){n.$removeTextEditorDecorationType(m)}})}}e.TextEditorDecorationType=I,I._Keys=new w.IdGenerator("TextEditorDecorationType");class S{constructor(n,f){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=n,this._documentVersionId=n.version,this._undoStopBefore=f.undoStopBefore,this._undoStopAfter=f.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(n,f){this._throwIfFinalized();let o=null;if(n instanceof k.Position)o=new k.Range(n,n);else if(n instanceof k.Range)o=n;else throw new Error("Unrecognized location");this._pushEdit(o,f,!1)}insert(n,f){this._throwIfFinalized(),this._pushEdit(new k.Range(n,n),f,!0)}delete(n){this._throwIfFinalized();let f=null;if(n instanceof k.Range)f=n;else throw new Error("Unrecognized location");this._pushEdit(f,null,!0)}_pushEdit(n,f,o){const m=this._document.validateRange(n);this._collectedEdits.push({range:m,text:f,forceMoveMarkers:o})}setEndOfLine(n){if(this._throwIfFinalized(),n!==k.EndOfLine.LF&&n!==k.EndOfLine.CRLF)throw(0,t.illegalArgument)("endOfLine");this._setEndOfLine=n}}e.TextEditorEdit=S;class R{constructor(n,f,o,m){this._proxy=n,this._id=f,this._accept(o),this._logService=m;const c=this;this.value={get tabSize(){return c._tabSize},set tabSize(C){c._setTabSize(C)},get insertSpaces(){return c._insertSpaces},set insertSpaces(C){c._setInsertSpaces(C)},get cursorStyle(){return c._cursorStyle},set cursorStyle(C){c._setCursorStyle(C)},get lineNumbers(){return c._lineNumbers},set lineNumbers(C){c._setLineNumbers(C)}}}_accept(n){this._tabSize=n.tabSize,this._insertSpaces=n.insertSpaces,this._cursorStyle=n.cursorStyle,this._lineNumbers=T.TextEditorLineNumbersStyle.to(n.lineNumbers)}_validateTabSize(n){if(n==="auto")return"auto";if(typeof n=="number"){const f=Math.floor(n);return f>0?f:null}if(typeof n=="string"){const f=parseInt(n,10);return isNaN(f)?null:f>0?f:null}return null}_setTabSize(n){const f=this._validateTabSize(n);if(f!==null){if(typeof f=="number"){if(this._tabSize===f)return;this._tabSize=f}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:f}))}}_validateInsertSpaces(n){return n==="auto"?"auto":n==="false"?!1:Boolean(n)}_setInsertSpaces(n){const f=this._validateInsertSpaces(n);if(typeof f=="boolean"){if(this._insertSpaces===f)return;this._insertSpaces=f}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:f}))}_setCursorStyle(n){this._cursorStyle!==n&&(this._cursorStyle=n,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:n})))}_setLineNumbers(n){this._lineNumbers!==n&&(this._lineNumbers=n,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:T.TextEditorLineNumbersStyle.from(n)})))}assign(n){const f={};let o=!1;if(typeof n.tabSize!="undefined"){const m=this._validateTabSize(n.tabSize);m==="auto"?(o=!0,f.tabSize=m):typeof m=="number"&&this._tabSize!==m&&(this._tabSize=m,o=!0,f.tabSize=m)}if(typeof n.insertSpaces!="undefined"){const m=this._validateInsertSpaces(n.insertSpaces);m==="auto"?(o=!0,f.insertSpaces=m):this._insertSpaces!==m&&(this._insertSpaces=m,o=!0,f.insertSpaces=m)}typeof n.cursorStyle!="undefined"&&this._cursorStyle!==n.cursorStyle&&(this._cursorStyle=n.cursorStyle,o=!0,f.cursorStyle=n.cursorStyle),typeof n.lineNumbers!="undefined"&&this._lineNumbers!==n.lineNumbers&&(this._lineNumbers=n.lineNumbers,o=!0,f.lineNumbers=T.TextEditorLineNumbersStyle.from(n.lineNumbers)),o&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,f))}_warnOnError(n,f){f.catch(o=>{this._logService.warn(`ExtHostTextEditorOptions '${n}' failed:'`),this._logService.warn(o)})}}e.ExtHostTextEditorOptions=R;class F{constructor(n,f,o,m,c,C,b,h){this.id=n,this._proxy=f,this._logService=o,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=c,this._options=new R(this._proxy,this.id,C,o),this._visibleRanges=b,this._viewColumn=h;const g=this;this.value=Object.freeze({get document(){return m.getValue()},set document(P){throw(0,t.readonly)("document")},get selection(){return g._selections&&g._selections[0]},set selection(P){if(!(P instanceof k.Selection))throw(0,t.illegalArgument)("selection");g._selections=[P],g._trySetSelection()},get selections(){return g._selections},set selections(P){if(!Array.isArray(P)||P.some(l=>!(l instanceof k.Selection)))throw(0,t.illegalArgument)("selections");g._selections=P,g._trySetSelection()},get visibleRanges(){return g._visibleRanges},set visibleRanges(P){throw(0,t.readonly)("visibleRanges")},get options(){return g._options.value},set options(P){g._disposed||g._options.assign(P)},get viewColumn(){return g._viewColumn},set viewColumn(P){throw(0,t.readonly)("viewColumn")},edit(P,l={undoStopBefore:!0,undoStopAfter:!0}){if(g._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const M=new S(m.getValue(),l);return P(M),g._applyEdit(M)},insertSnippet(P,l,M={undoStopBefore:!0,undoStopAfter:!0}){if(g._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!l||Array.isArray(l)&&l.length===0)r=g._selections.map(i=>T.Range.from(i));else if(l instanceof k.Position){const{lineNumber:i,column:p}=T.Position.from(l);r=[{startLineNumber:i,startColumn:p,endLineNumber:i,endColumn:p}]}else if(l instanceof k.Range)r=[T.Range.from(l)];else{r=[];for(const i of l)if(i instanceof k.Range)r.push(T.Range.from(i));else{const{lineNumber:p,column:d}=T.Position.from(i);r.push({startLineNumber:p,startColumn:d,endLineNumber:p,endColumn:d})}}return f.$tryInsertSnippet(n,P.value,r,M)},setDecorations(P,l){const M=l.length===0;M&&!g._hasDecorationsForKey.has(P.key)||(M?g._hasDecorationsForKey.delete(P.key):g._hasDecorationsForKey.add(P.key),g._runOnProxy(()=>{if(T.isDecorationOptionsArr(l))return f.$trySetDecorations(n,P.key,T.fromRangeOrRangeWithMessage(l));{const r=new Array(4*l.length);for(let i=0,p=l.length;i<p;i++){const d=l[i];r[4*i]=d.start.line+1,r[4*i+1]=d.start.character+1,r[4*i+2]=d.end.line+1,r[4*i+3]=d.end.character+1}return f.$trySetDecorationsFast(n,P.key,r)}}))},revealRange(P,l){g._runOnProxy(()=>f.$tryRevealRange(n,T.Range.from(P),l||k.TextEditorRevealType.Default))},show(P){f.$tryShowEditor(n,T.ViewColumn.from(P))},hide(){f.$tryHideEditor(n)}})}dispose(){(0,a.ok)(!this._disposed),this._disposed=!0}_acceptOptions(n){(0,a.ok)(!this._disposed),this._options._accept(n)}_acceptVisibleRanges(n){(0,a.ok)(!this._disposed),this._visibleRanges=n}_acceptViewColumn(n){(0,a.ok)(!this._disposed),this._viewColumn=n}_acceptSelections(n){(0,a.ok)(!this._disposed),this._selections=n}async _trySetSelection(){const n=this._selections.map(T.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,n)),this.value}_applyEdit(n){const f=n.finalize();if(f.edits.length===0&&!f.setEndOfLine)return Promise.resolve(!0);const o=f.edits.map(c=>c.range);o.sort((c,C)=>c.end.line===C.end.line?c.end.character===C.end.character?c.start.line===C.start.line?c.start.character-C.start.character:c.start.line-C.start.line:c.end.character-C.end.character:c.end.line-C.end.line);for(let c=0,C=o.length-1;c<C;c++){const b=o[c].end;if(o[c+1].start.isBefore(b))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const m=f.edits.map(c=>({range:T.Range.from(c.range),text:c.text,forceMoveMarkers:c.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,f.documentVersionId,m,{setEndOfLine:typeof f.setEndOfLine=="number"?T.EndOfLine.from(f.setEndOfLine):void 0,undoStopBefore:f.undoStopBefore,undoStopAfter:f.undoStopAfter})}_runOnProxy(n){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):n().then(()=>this,f=>(f instanceof Error&&f.name==="DISPOSED"||this._logService.warn(f),null))}}e.ExtHostTextEditor=F}),define(Ee[169],ye([0,1,124,24,2,4,6,14,7,11,16,8,20,153]),function(re,e,a,t,w,T,k,I,S,R,F,_,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function o(C,b){if((0,R.isString)(C))return{label:C};if(C&&typeof C=="object"&&typeof C.label=="string"){let h;return Array.isArray(C.highlights)&&(h=C.highlights.filter(g=>g.length===2&&typeof g[0]=="number"&&typeof g[1]=="number"),h=h.length?h:void 0),{label:C.label,highlights:h}}}class m{constructor(b,h,g){this._proxy=b,this.commands=h,this.logService=g,this.treeViews=new Map;function P(l){return l&&l.$treeViewId&&l.$treeItemHandle}h.registerArgumentProcessor({processArgument:l=>P(l)?this.convertArgument(l):Array.isArray(l)&&l.length>0?l.map(M=>P(M)?this.convertArgument(M):M):l})}registerTreeDataProvider(b,h,g){const P=this.createTreeView(b,{treeDataProvider:h},g);return{dispose:()=>P.dispose()}}createTreeView(b,h,g){if(!h||!h.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const P=h.dragAndDropController?.supportedMimeTypes,l=this._proxy.$registerTreeViewDataProvider(b,{showCollapseAll:!!h.showCollapseAll,canSelectMany:!!h.canSelectMany,dragAndDropMimeTypes:P}),M=this.createExtHostTreeView(b,h,g);return{get onDidCollapseElement(){return M.onDidCollapseElement},get onDidExpandElement(){return M.onDidExpandElement},get selection(){return M.selectedElements},get onDidChangeSelection(){return M.onDidChangeSelection},get visible(){return M.visible},get onDidChangeVisibility(){return M.onDidChangeVisibility},get message(){return M.message},set message(r){M.message=r},get title(){return M.title},set title(r){M.title=r},get description(){return M.description},set description(r){M.description=r},reveal:(r,i)=>M.reveal(r,i),dispose:async()=>{await l,this.treeViews.delete(b),M.dispose()}}}$getChildren(b,h){const g=this.treeViews.get(b);return g?g.getChildren(h):Promise.reject(new Error((0,a.localize)(0,null,b)))}async $onDrop(b,h,g,P,l){const M=this.treeViews.get(b);if(!M)return Promise.reject(new Error((0,a.localize)(1,null,b)));const r=f.TreeDataTransferConverter.toITreeDataTransfer(h);if(P===b&&l){const i=await M.onWillDrop(l);i&&i.forEach((p,d)=>{p&&r.set(d,p)})}return M.onDrop(r,g)}async $hasResolve(b){const h=this.treeViews.get(b);if(!h)throw new Error((0,a.localize)(2,null,b));return h.hasResolve}$resolve(b,h,g){const P=this.treeViews.get(b);if(!P)throw new Error((0,a.localize)(3,null,b));return P.resolveTreeItem(h,g)}$setExpanded(b,h,g){const P=this.treeViews.get(b);if(!P)throw new Error((0,a.localize)(4,null,b));P.setExpanded(h,g)}$setSelection(b,h){const g=this.treeViews.get(b);if(!g)throw new Error((0,a.localize)(5,null,b));g.setSelection(h)}$setVisible(b,h){const g=this.treeViews.get(b);if(!g)throw new Error((0,a.localize)(6,null,b));g.setVisible(h)}createExtHostTreeView(b,h,g){const P=new c(b,h,this._proxy,this.commands.converter,this.logService,g);return this.treeViews.set(b,P),P}convertArgument(b){const h=this.treeViews.get(b.$treeViewId);return h?h.getExtensionElement(b.$treeItemHandle):null}}e.ExtHostTreeViews=m;class c extends k.Disposable{constructor(b,h,g,P,l,M){super();if(this.viewId=b,this.proxy=g,this.commands=P,this.logService=l,this.extension=M,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new T.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new T.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new T.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new T.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new T.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new n.CancellationTokenSource,M.contributes&&M.contributes.views)for(const p in M.contributes.views)for(const d of M.contributes.views[p])d.id===b&&(this._title=d.name);this.dataProvider=h.treeDataProvider,this.dndController=h.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(p=>this._onDidChangeData.fire({message:!1,element:p}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(p=>this._onDidChangeData.fire({message:!1,element:p})));let r,i;this._register(T.Event.debounce(this._onDidChangeData.event,(p,d)=>(p||(p={message:!1,elements:[]}),d.element!==!1&&(r||(r=new Promise(s=>i=s),this.refreshPromise=this.refreshPromise.then(()=>r)),Array.isArray(d.element)?p.elements.push(...d.element):p.elements.push(d.element)),d.message&&(p.message=!0),p),200,!0)(({message:p,elements:d})=>{d.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const s=i;return r=null,this.refresh(d).then(()=>s())})),p&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(b=>this.getExtensionElement(b)).filter(b=>!(0,R.isUndefinedOrNull)(b))}async getChildren(b){const h=b?this.getExtensionElement(b):void 0;if(b&&!h)return this.logService.error(`No tree item with id '${b}' found.`),Promise.resolve([]);let g=this.getChildrenNodes(b);return g||(g=await this.fetchChildrenNodes(h)),g?g.map(P=>P.item):void 0}getExtensionElement(b){return this.elements.get(b)}reveal(b,h){h=h||{select:!0,focus:!1};const g=(0,R.isUndefinedOrNull)(h.select)?!0:h.select,P=(0,R.isUndefinedOrNull)(h.focus)?!1:h.focus,l=(0,R.isUndefinedOrNull)(h.expand)?!1:h.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):b?this.refreshPromise.then(()=>this.resolveUnknownParentChain(b)).then(M=>this.resolveTreeNode(b,M[M.length-1]).then(r=>this.proxy.$reveal(this.viewId,{item:r.item,parentChain:M.map(i=>i.item)},{select:g,focus:P,expand:l})),M=>this.logService.error(M)):this.proxy.$reveal(this.viewId,void 0,{select:g,focus:P,expand:l})}get message(){return this._message}set message(b){this._message=b,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(b){this._title=b,this.proxy.$setTitle(this.viewId,b,this._description)}get description(){return this._description}set description(b){this._description=b,this.proxy.$setTitle(this.viewId,this._title,b)}setExpanded(b,h){const g=this.getExtensionElement(b);g&&(h?this._onDidExpandElement.fire(Object.freeze({element:g})):this._onDidCollapseElement.fire(Object.freeze({element:g})))}setSelection(b){(0,F.equals)(this._selectedHandles,b)||(this._selectedHandles=b,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(b){b!==this._visible&&(this._visible=b,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async onWillDrop(b){const h=[];for(const g of b){const P=this.getExtensionElement(g);P&&h.push(P)}if(!(!this.dndController?.onWillDrop||h.length===0))return this.dndController.onWillDrop(h)}async onDrop(b,h){const g=this.getExtensionElement(h);if(!!g)return(0,I.asPromise)(()=>this.dndController?.onDrop(b,g))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(b,h){if(!this.dataProvider.resolveTreeItem)return;const g=this.elements.get(b);if(g){const P=this.nodes.get(g);if(P){const l=await this.dataProvider.resolveTreeItem(P.extensionItem,g,h)??P.extensionItem;return P.item.tooltip=this.getTooltip(l.tooltip),P.item.command=this.getCommand(P.disposableStore,l.command),P.item}}}resolveUnknownParentChain(b){return this.resolveParent(b).then(h=>h?this.resolveUnknownParentChain(h).then(g=>this.resolveTreeNode(h,g[g.length-1]).then(P=>(g.push(P),g))):Promise.resolve([]))}resolveParent(b){const h=this.nodes.get(b);return h?Promise.resolve(h.parent?this.elements.get(h.parent.item.handle):void 0):(0,I.asPromise)(()=>this.dataProvider.getParent(b))}resolveTreeNode(b,h){const g=this.nodes.get(b);return g?Promise.resolve(g):(0,I.asPromise)(()=>this.dataProvider.getTreeItem(b)).then(P=>this.createHandle(b,P,h,!0)).then(P=>this.getChildren(h?h.item.handle:void 0).then(()=>{const l=this.getExtensionElement(P);if(l){const M=this.nodes.get(l);if(M)return Promise.resolve(M)}throw new Error(`Cannot resolve tree item for element ${P}`)}))}getChildrenNodes(b){if(b){let h;if(typeof b=="string"){const g=this.getExtensionElement(b);h=g?this.nodes.get(g):void 0}else h=b;return h&&h.children||void 0}return this.roots}async fetchChildrenNodes(b){this.clearChildren(b);const h=new n.CancellationTokenSource(this._refreshCancellationSource.token);try{const g=b?this.nodes.get(b):void 0,P=await this.dataProvider.getChildren(b);if(h.token.isCancellationRequested)return;const l=await Promise.all((0,F.coalesce)(P||[]).map(async M=>{const r=await this.dataProvider.getTreeItem(M);return r&&!h.token.isCancellationRequested?this.createAndRegisterTreeNode(M,r,g):null}));return h.token.isCancellationRequested?void 0:(0,F.coalesce)(l)}finally{h.dispose()}}refresh(b){if(b.some(g=>!g))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new n.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const g=this.getHandlesToRefresh(b);if(g.length)return this.refreshHandles(g)}return Promise.resolve(void 0)}getHandlesToRefresh(b){const h=new Set,g=b.map(l=>this.nodes.get(l));for(const l of g)if(l&&!h.has(l.item.handle)){let M=l;for(;M&&M.parent&&g.findIndex(r=>M&&M.parent&&r&&r.item.handle===M.parent.item.handle)===-1;){const r=this.elements.get(M.parent.item.handle);M=r?this.nodes.get(r):void 0}M&&!M.parent&&h.add(l.item.handle)}const P=[];return h.forEach(l=>{const M=this.elements.get(l);if(M){const r=this.nodes.get(M);r&&(!r.parent||!h.has(r.parent.item.handle))&&P.push(l)}}),P}refreshHandles(b){const h={};return Promise.all(b.map(g=>this.refreshNode(g).then(P=>{P&&(h[g]=P.item)}))).then(()=>Object.keys(h).length?this.proxy.$refresh(this.viewId,h):void 0)}refreshNode(b){const h=this.getExtensionElement(b);if(h){const g=this.nodes.get(h);if(g)return this.clearChildren(h),(0,I.asPromise)(()=>this.dataProvider.getTreeItem(h)).then(P=>{if(P){const l=this.createTreeNode(h,P,g.parent);return this.updateNodeCache(h,l,g,g.parent),g.dispose(),l}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(b,h,g){const P=this.createTreeNode(b,h,g);if(h.id&&this.elements.has(P.item.handle))throw new Error((0,a.localize)(7,null,h.id));return this.addNodeToCache(b,P),this.addNodeToParentCache(P,g),P}getTooltip(b){return S.MarkdownString.isMarkdownString(b)?_.MarkdownString.from(b):b}getCommand(b,h){return h?this.commands.toInternal(h,b):void 0}createTreeNode(b,h,g){const P=new k.DisposableStore,l=this.createHandle(b,h,g),M=this.getLightIconPath(h);return{item:{handle:l,parentHandle:g?g.item.handle:void 0,label:o(h.label,this.extension),description:h.description,resourceUri:h.resourceUri,tooltip:this.getTooltip(h.tooltip),command:this.getCommand(P,h.command),contextValue:h.contextValue,icon:M,iconDark:this.getDarkIconPath(h)||M,themeIcon:this.getThemeIcon(h),collapsibleState:(0,R.isUndefinedOrNull)(h.collapsibleState)?S.TreeItemCollapsibleState.None:h.collapsibleState,accessibilityInformation:h.accessibilityInformation},extensionItem:h,parent:g,children:void 0,disposableStore:P,dispose(){P.dispose()}}}getThemeIcon(b){return b.iconPath instanceof S.ThemeIcon?b.iconPath:void 0}createHandle(b,{id:h,label:g,resourceUri:P},l,M){if(h)return`${c.ID_HANDLE_PREFIX}/${h}`;const r=o(g,this.extension),i=l?l.item.handle:c.LABEL_HANDLE_PREFIX;let p=r?r.label:P?(0,t.basename)(P):"";p=p.indexOf("/")!==-1?p.replace("/","//"):p;const d=this.nodes.has(b)?this.nodes.get(b).item.handle:void 0,s=this.getChildrenNodes(l)||[];let v,y=0;do{if(v=`${i}/${y}:${p}`,M||!this.elements.has(v)||d===v)break;y++}while(y<=s.length);return v}getLightIconPath(b){if(b.iconPath&&!(b.iconPath instanceof S.ThemeIcon))return typeof b.iconPath=="string"||w.URI.isUri(b.iconPath)?this.getIconPath(b.iconPath):this.getIconPath(b.iconPath.light)}getDarkIconPath(b){if(b.iconPath&&!(b.iconPath instanceof S.ThemeIcon)&&b.iconPath.dark)return this.getIconPath(b.iconPath.dark)}getIconPath(b){return w.URI.isUri(b)?b:w.URI.file(b)}addNodeToCache(b,h){this.elements.set(h.item.handle,b),this.nodes.set(b,h)}updateNodeCache(b,h,g,P){this.elements.delete(h.item.handle),this.nodes.delete(b),h.item.handle!==g.item.handle&&this.elements.delete(g.item.handle),this.addNodeToCache(b,h);const l=this.getChildrenNodes(P)||[],M=l.filter(r=>r.item.handle===g.item.handle)[0];M&&l.splice(l.indexOf(M),1,h)}addNodeToParentCache(b,h){h?(h.children||(h.children=[]),h.children.push(b)):(this.roots||(this.roots=[]),this.roots.push(b))}clearChildren(b){if(b){const h=this.nodes.get(b);if(h){if(h.children)for(const g of h.children){const P=this.elements.get(g.item.handle);P&&this.clear(P)}h.children=void 0}}else this.clearAll()}clear(b){const h=this.nodes.get(b);if(h){if(h.children)for(const g of h.children){const P=this.elements.get(g.item.handle);P&&this.clear(P)}this.nodes.delete(b),this.elements.delete(h.item.handle),h.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(b=>b.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}c.LABEL_HANDLE_PREFIX="0",c.ID_HANDLE_PREFIX="1"}),define(Ee[170],ye([0,1,14,4,6,11,47,8,88,67]),function(re,e,a,t,w,T,k,I,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class F extends w.Disposable{constructor(n){super();this.controllerId=n,this.debounceSendDiff=this._register(new a.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new t.Emitter),this.root=new k.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(n){this._resolveHandler=n;for(const f of this.tree.values())this.updateExpandability(f)}collectDiff(){const n=this.diff;return this.diff=[],n}pushDiff(n){const f=this.diff[this.diff.length-1];if(f&&n[0]===1){if(f[0]===1&&f[1].extId===n[1].extId){(0,S.applyTestItemUpdate)(f[1],n[1]);return}if(f[0]===0&&f[1].item.extId===n[1].extId){(0,S.applyTestItemUpdate)(f[1],n[1]);return}}this.diff.push(n),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(n,f){const o=this.tree.get(n);if(!!o){if((o.expandLevels===void 0||f>o.expandLevels)&&(o.expandLevels=f),o.expand===1){const m=this.resolveChildren(o);return m.isOpen()?this.expandChildren(o,f-1):m.wait().then(()=>this.expandChildren(o,f-1))}else if(o.expand===3)return o.resolveBarrier?.isOpen()===!1?o.resolveBarrier.wait().then(()=>this.expandChildren(o,f-1)):this.expandChildren(o,f-1)}}dispose(){for(const n of this.tree.values())(0,k.getPrivateApiFor)(n.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(n,f){switch(f.op){case 2:this.pushDiff([4,n.fullId.toString()]);break;case 1:this.removeItem(R.TestId.joinToString(n.fullId,f.id));break;case 0:this.upsertItem(f.item,n);break;case 4:for(const b of f.ops)this.onTestItemEvent(n,b);break;case 3:const{key:o,value:m,previous:c}=f,C=n.fullId.toString();switch(o){case"canResolveChildren":this.updateExpandability(n);break;case"tags":this.diffTagRefs(m,c,C);break;case"range":this.pushDiff([1,{extId:C,item:{range:I.Range.from(m)}}]);break;case"error":this.pushDiff([1,{extId:C,item:{error:I.MarkdownString.fromStrict(m)||null}}]);break;default:this.pushDiff([1,{extId:C,item:{[o]:m??null}}]);break}break;default:(0,T.assertNever)(f)}}upsertItem(n,f){if(!(n instanceof k.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${n.id} did not`);const o=R.TestId.fromExtHostTestItem(n,this.root.id,f?.actual),m=(0,k.getPrivateApiFor)(n);m.parent&&m.parent!==f?.actual&&m.parent.children.delete(n.id);let c=this.tree.get(o.toString());if(!c){c={fullId:o,actual:n,parent:f?o.parentId:null,expandLevels:f?.expandLevels?f.expandLevels-1:void 0,expand:0},n.tags.forEach(this.incrementTagRefs,this),this.tree.set(c.fullId.toString(),c),this.setItemParent(n,f),this.pushDiff([0,{parent:c.parent&&c.parent.toString(),controllerId:this.controllerId,expand:c.expand,item:I.TestItem.from(n)}]),this.connectItemAndChildren(n,c,f);return}if(c.actual===n){this.connectItem(n,c,f);return}const C=c.actual.children,b=c.actual,h=(0,k.diffTestItems)(b,n);(0,k.getPrivateApiFor)(b).listener=void 0,c.actual=n,c.expand=0;for(const[g,P]of h)this.onTestItemEvent(c,{op:3,key:g,value:P,previous:b[g]});this.connectItemAndChildren(n,c,f);for(const g of C)n.children.get(g.id)||this.removeItem(R.TestId.joinToString(o,g.id))}diffTagRefs(n,f,o){const m=new Set(f.map(c=>c.id));for(const c of n)m.delete(c.id)||this.incrementTagRefs(c);this.pushDiff([1,{extId:o,item:{tags:n.map(c=>I.TestTag.namespace(this.controllerId,c.id))}}]),m.forEach(this.decrementTagRefs,this)}incrementTagRefs(n){const f=this.tags.get(n.id);f?f.refCount++:(this.tags.set(n.id,{refCount:1}),this.pushDiff([5,{id:I.TestTag.namespace(this.controllerId,n.id),ctrlLabel:this.root.label}]))}decrementTagRefs(n){const f=this.tags.get(n);f&&!--f.refCount&&(this.tags.delete(n),this.pushDiff([6,I.TestTag.namespace(this.controllerId,n)]))}setItemParent(n,f){(0,k.getPrivateApiFor)(n).parent=f&&f.actual!==this.root?f.actual:void 0}connectItem(n,f,o){this.setItemParent(n,o);const m=(0,k.getPrivateApiFor)(n);m.parent=o?.actual,m.listener=c=>this.onTestItemEvent(f,c),this.updateExpandability(f)}connectItemAndChildren(n,f,o){this.connectItem(n,f,o);for(const m of n.children)this.upsertItem(m,f)}updateExpandability(n){let f;this._resolveHandler?n.resolveBarrier?f=n.resolveBarrier.isOpen()?3:2:f=n.actual.canResolveChildren?1:0:f=0,f!==n.expand&&(n.expand=f,this.pushDiff([1,{extId:n.fullId.toString(),expand:f}]),f===1&&n.expandLevels!==void 0&&this.resolveChildren(n))}expandChildren(n,f){if(f<0)return;const o=[];for(const m of n.actual.children){const c=this.expand(R.TestId.joinToString(n.fullId,m.id),f);(0,a.isThenable)(c)&&o.push(c)}if(o.length)return Promise.all(o).then(()=>{})}resolveChildren(n){if(n.resolveBarrier)return n.resolveBarrier;if(!this._resolveHandler){const c=new a.Barrier;return c.open(),c}n.expand=2,this.pushExpandStateUpdate(n);const f=n.resolveBarrier=new a.Barrier,o=c=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),n.actual!==this.root&&(n.actual.error=c.stack||c.message||String(c))};let m;try{m=this._resolveHandler(n.actual===this.root?void 0:n.actual)}catch(c){o(c)}return(0,a.isThenable)(m)?m.catch(o).then(()=>{f.open(),this.updateExpandability(n)}):(f.open(),this.updateExpandability(n)),n.resolveBarrier}pushExpandStateUpdate(n){this.pushDiff([1,{extId:n.fullId.toString(),expand:n.expand}])}removeItem(n){const f=this.tree.get(n);if(!f)throw new Error("attempting to remove non-existent child");this.pushDiff([2,n]);const o=[f];for(;o.length;){const m=o.pop();if(!!m){(0,k.getPrivateApiFor)(m.actual).listener=void 0;for(const c of m.actual.tags)this.decrementTagRefs(c.id);this.tree.delete(m.fullId.toString());for(const c of m.actual.children)o.push(this.tree.get(R.TestId.joinToString(m.fullId,c.id)))}}}flushDiff(){const n=this.collectDiff();n.length&&this.diffOpEmitter.fire(n)}}e.SingleUseTestCollection=F}),define(Ee[171],ye([0,1,3,136]),function(re,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,a.refineServiceDecorator)(t.IEnvironmentService)}),define(Ee[172],ye([0,1,25,4,17]),function(re,e,a,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class T{constructor(F){this.removedDueToLooping=F}}e.DeltaExtensionsResult=T;class k{constructor(F){this._onDidChange=new t.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=F,this._initialize()}_initialize(){this._extensionDescriptions.sort(S),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const F of this._extensionDescriptions){if(this._extensionsMap.has(a.ExtensionIdentifier.toKey(F.identifier))){console.error("Extension `"+F.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(a.ExtensionIdentifier.toKey(F.identifier),F),this._extensionsArr.push(F),Array.isArray(F.activationEvents))for(let _ of F.activationEvents)_==="onUri"&&(_=`onUri:${a.ExtensionIdentifier.toKey(F.identifier)}`),this._activationMap.has(_)||this._activationMap.set(_,[]),this._activationMap.get(_).push(F)}}keepOnly(F){const _=new Set;F.forEach(n=>_.add(a.ExtensionIdentifier.toKey(n))),this._extensionDescriptions=this._extensionDescriptions.filter(n=>_.has(a.ExtensionIdentifier.toKey(n.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(F,_){F.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(F));const n=k._findLoopingExtensions(this._extensionDescriptions);if(_=_.concat(n.map(f=>f.identifier)),_.length>0){const f=new Set;_.forEach(o=>f.add(a.ExtensionIdentifier.toKey(o))),this._extensionDescriptions=this._extensionDescriptions.filter(o=>!f.has(a.ExtensionIdentifier.toKey(o.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new T(n)}static _findLoopingExtensions(F){const _=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(c){this._nodesSet.has(c)||(this._nodesSet.add(c),this._nodesArr.push(c))}addArc(c,C){this.addNode(c),this.addNode(C),this._arcs.has(c)?this._arcs.get(c).push(C):this._arcs.set(c,[C])}getArcs(c){return this._arcs.has(c)?this._arcs.get(c):[]}hasOnlyGoodArcs(c,C){const b=_.getArcs(c);for(let h=0;h<b.length;h++)if(!C.has(b[h]))return!1;return!0}getNodes(){return this._nodesArr}};let n=new Map;for(let c of F){const C=a.ExtensionIdentifier.toKey(c.identifier);if(n.set(C,c),c.extensionDependencies)for(let b of c.extensionDependencies){const h=a.ExtensionIdentifier.toKey(b);_.addArc(C,h)}}let f=new Set;_.getNodes().filter(c=>_.getArcs(c).length===0).forEach(c=>f.add(c));let o=_.getNodes().filter(c=>!f.has(c)),m;do{m=!1;for(let c=0;c<o.length;c++){const C=o[c];_.hasOnlyGoodArcs(C,f)&&(o.splice(c,1),c--,f.add(C),m=!0)}}while(m);return o.map(c=>n.get(c))}containsActivationEvent(F){return this._activationMap.has(F)}containsExtension(F){return this._extensionsMap.has(a.ExtensionIdentifier.toKey(F))}getExtensionDescriptionsForActivationEvent(F){const _=this._activationMap.get(F);return _?_.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(F){const _=this._extensionsMap.get(a.ExtensionIdentifier.toKey(F));return _||void 0}}e.ExtensionDescriptionRegistry=k;var I;(function(R){R[R.Builtin=0]="Builtin",R[R.User=1]="User",R[R.Dev=2]="Dev"})(I||(I={}));function S(R,F){const _=R.isBuiltin?0:R.isUnderDevelopment?2:1,n=F.isBuiltin?0:F.isUnderDevelopment?2:1;if(_!==n)return _-n;const f=w.posix.basename(R.extensionLocation.path),o=w.posix.basename(F.extensionLocation.path);return f<o?-1:f>o?1:0}}),define(Ee[173],ye([0,1,22]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var t;(function(I){I[I.VersionMismatch=55]="VersionMismatch",I[I.UnexpectedError=81]="UnexpectedError"})(t=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var w;(function(I){I[I.Initialized=0]="Initialized",I[I.Ready=1]="Ready",I[I.Terminate=2]="Terminate"})(w=e.MessageType||(e.MessageType={}));function T(I){const S=a.VSBuffer.alloc(1);switch(I){case 0:S.writeUInt8(1,0);break;case 1:S.writeUInt8(2,0);break;case 2:S.writeUInt8(3,0);break}return S}e.createMessageOfType=T;function k(I,S){if(I.byteLength!==1)return!1;switch(I.readUInt8(0)){case 1:return S===0;case 2:return S===1;case 3:return S===2;default:return!1}}e.isMessageOfType=k}),define(Ee[27],ye([0,1,4,2,3,25,143]),function(re,e,a,t,w,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.extensionRunningLocationToString=e.ExtensionRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new T.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:t.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,w.createDecorator)("extensionService");var I;(function(g){g[g.None=0]="None",g[g.LocalProcess=1]="LocalProcess",g[g.LocalWebWorker=2]="LocalWebWorker",g[g.Remote=3]="Remote"})(I=e.ExtensionRunningLocation||(e.ExtensionRunningLocation={}));function S(g){switch(g){case 0:return"None";case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionRunningLocationToString=S;class R{constructor(P){this.dependency=P}}e.MissingExtensionDependency=R;var F;(function(g){g[g.LocalProcess=0]="LocalProcess",g[g.LocalWebWorker=1]="LocalWebWorker",g[g.Remote=2]="Remote"})(F=e.ExtensionHostKind||(e.ExtensionHostKind={}));function _(g){switch(g){case 0:return"LocalProcess";case 1:return"LocalWebWorker";case 2:return"Remote"}}e.extensionHostKindToString=_;function n(g,P){return g.enabledApiProposals?g.enabledApiProposals.includes(P):!1}e.isProposedApiEnabled=n;function f(g,P){if(!n(g,P))throw new Error(`Extension '${g.identifier.value}' CANNOT use API proposal: ${P}.
Its package.json#enabledApiProposals-property declares: ${g.enabledApiProposals?.join(", ")??"[]"} but NOT ${P}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${g.identifier.value}`)}e.checkProposedApiEnabled=f;class o{constructor(P,l,M,r){this.codeLoadingTime=P,this.activateCallTime=l,this.activateResolvedTime=M,this.activationReason=r}}e.ActivationTimes=o;class m{constructor(P,l){this.description=P,this.value=l}}e.ExtensionPointContribution=m,e.ExtensionHostLogFileName="exthost";var c;(function(g){g[g.Normal=0]="Normal",g[g.Immediate=1]="Immediate"})(c=e.ActivationKind||(e.ActivationKind={}));function C(g){return{type:g.isBuiltin?0:1,isBuiltin:g.isBuiltin||g.isUserBuiltin,identifier:{id:(0,k.getGalleryExtensionId)(g.publisher,g.name),uuid:g.uuid},manifest:g,location:g.extensionLocation}}e.toExtension=C;function b(g,P){return{identifier:new T.ExtensionIdentifier(g.identifier.id),isBuiltin:g.type===0,isUserBuiltin:g.type===1&&g.isBuiltin,isUnderDevelopment:!!P,extensionLocation:g.location,...g.manifest,uuid:g.identifier.uuid}}e.toExtensionDescription=b;class h{constructor(){this.onDidRegisterExtensions=a.Event.None,this.onDidChangeExtensionsStatus=a.Event.None,this.onDidChangeExtensions=a.Event.None,this.onWillActivateByEvent=a.Event.None,this.onDidChangeResponsiveChange=a.Event.None}activateByEvent(P){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(P){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(P){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(P){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(P,l){return Promise.resolve()}_onWillActivateExtension(P){}_onDidActivateExtension(P,l,M,r,i){}_onDidActivateExtensionError(P,l){}_onExtensionRuntimeError(P,l){}_onExtensionHostExit(P){}}e.NullExtensionService=h}),define(Ee[174],ye([0,1,15,25,27,12]),function(re,e,a,t,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const k=Promise.resolve(void 0);class I{constructor(m,c,C,b){this.startup=m,this.codeLoadingTime=c,this.activateCallTime=C,this.activateResolvedTime=b}}e.ExtensionActivationTimes=I,I.NONE=new I(!1,-1,-1,-1);class S{constructor(m){this._startup=m,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(m,c){return m===-1||c===-1?-1:c-m}build(){return new I(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=S;class R{constructor(m,c,C,b,h,g){this.activationFailed=m,this.activationFailedError=c,this.activationTimes=C,this.module=b,this.exports=h,this.subscriptions=g}}e.ActivatedExtension=R;class F extends R{constructor(m){super(!1,null,m,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=F;class _ extends R{constructor(){super(!1,null,I.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=_;class n extends R{constructor(m){super(!0,m,I.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=n;let f=class{constructor(m,c,C,b,h){this._logService=h,this._isDisposed=!1,this._registry=m,this._resolvedExtensionsSet=new Set,c.forEach(g=>this._resolvedExtensionsSet.add(t.ExtensionIdentifier.toKey(g))),this._hostExtensionsMap=new Map,C.forEach(g=>this._hostExtensionsMap.set(t.ExtensionIdentifier.toKey(g),g)),this._host=b,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){this._isDisposed=!0}isActivated(m){const c=t.ExtensionIdentifier.toKey(m);return this._activatedExtensions.has(c)}getActivatedExtension(m){const c=t.ExtensionIdentifier.toKey(m),C=this._activatedExtensions.get(c);if(!C)throw new Error("Extension `"+m.value+"` is not known or not activated");return C}activateByEvent(m,c){if(this._alreadyActivatedEvents[m])return k;const C=this._registry.getExtensionDescriptionsForActivationEvent(m);return this._activateExtensions(C.map(b=>({id:b.identifier,reason:{startup:c,extensionId:b.identifier,activationEvent:m}}))).then(()=>{this._alreadyActivatedEvents[m]=!0})}activateById(m,c){const C=this._registry.getExtensionDescription(m);if(!C)throw new Error("Extension `"+m+"` is not known");return this._activateExtensions([{id:C.identifier,reason:c}])}_handleActivateRequest(m,c,C){if(this._hostExtensionsMap.has(t.ExtensionIdentifier.toKey(m.id))){c[t.ExtensionIdentifier.toKey(m.id)]=m;return}const b=this._registry.getExtensionDescription(m.id);if(!b){const P=new Error(`Cannot activate unknown extension '${m.id.value}'`);this._host.onExtensionActivationError(m.id,P,new w.MissingExtensionDependency(m.id.value)),this._activatedExtensions.set(t.ExtensionIdentifier.toKey(m.id),new n(P));return}const h=typeof b.extensionDependencies=="undefined"?[]:b.extensionDependencies;let g=!0;for(let P=0,l=h.length;P<l;P++){const M=h[P];if(this._resolvedExtensionsSet.has(t.ExtensionIdentifier.toKey(M)))continue;const r=this._activatedExtensions.get(t.ExtensionIdentifier.toKey(M));if(r&&!r.activationFailed)continue;if(r&&r.activationFailed){const s=b.displayName||b.identifier.value,v=this._registry.getExtensionDescription(M),y=v&&v.displayName||M,u=new Error(`Cannot activate the '${s}' extension because its dependency '${y}' failed to activate`);u.detail=r.activationFailedError,this._host.onExtensionActivationError(b.identifier,u,null),this._activatedExtensions.set(t.ExtensionIdentifier.toKey(b.identifier),new n(u));return}if(this._hostExtensionsMap.has(t.ExtensionIdentifier.toKey(M))){g=!1,c[t.ExtensionIdentifier.toKey(M)]={id:this._hostExtensionsMap.get(t.ExtensionIdentifier.toKey(M)),reason:m.reason};continue}const i=this._registry.getExtensionDescription(M);if(i){if(!i.main&&!i.browser)continue;g=!1,c[t.ExtensionIdentifier.toKey(M)]={id:i.identifier,reason:m.reason};continue}const p=b.displayName||b.identifier.value,d=new Error(`Cannot activate the '${p}' extension because it depends on unknown extension '${M}'`);this._host.onExtensionActivationError(b.identifier,d,new w.MissingExtensionDependency(M)),this._activatedExtensions.set(t.ExtensionIdentifier.toKey(b.identifier),new n(d));return}g?c[t.ExtensionIdentifier.toKey(b.identifier)]=m:C.push(m)}_activateExtensions(m){if(m.length===0||(m=m.filter(h=>!this._activatedExtensions.has(t.ExtensionIdentifier.toKey(h.id))),m.length===0))return Promise.resolve(void 0);const c=Object.create(null),C=[];for(let h=0,g=m.length;h<g;h++)this._handleActivateRequest(m[h],c,C);for(let h=0,g=C.length;h<g;h++){const P=t.ExtensionIdentifier.toKey(C[h].id);c[P]&&delete c[P]}const b=Object.keys(c).map(h=>c[h]);return C.length===0?Promise.all(b.map(h=>this._activateExtension(h.id,h.reason))).then(h=>{}):this._activateExtensions(b).then(h=>this._activateExtensions(C))}_activateExtension(m,c){const C=t.ExtensionIdentifier.toKey(m);if(this._activatedExtensions.has(C))return Promise.resolve(void 0);const b=this._activatingExtensions.get(C);if(b)return b;const h=this._host.actualActivateExtension(m,c).then(void 0,g=>{const P=new Error;return g&&g.name&&(P.name=g.name),g&&g.message?P.message=`Activating extension '${m.value}' failed: ${g.message}.`:P.message=`Activating extension '${m.value}' failed: ${g}.`,g&&g.stack&&(P.stack=g.stack),this._isDisposed&&a.isPromiseCanceledError(g)?new n(g):(this._host.onExtensionActivationError(m,P,null),this._logService.error(`Activating extension ${m.value} failed due to an error:`),this._logService.error(g),new n(g))}).then(g=>{this._activatedExtensions.set(C,g),this._activatingExtensions.delete(C)});return this._activatingExtensions.set(C,h),h}};f=Ue([$e(4,T.ILogService)],f),e.ExtensionsActivator=f}),define(Ee[175],ye([0,1,12,28,27]),function(re,e,a,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let T=class extends a.LogService{constructor(I,S){super(I.createLogger(S.logFile,{name:w.ExtensionHostLogFileName}))}};T=Ue([$e(0,a.ILoggerService),$e(1,t.IExtHostInitDataService)],T),e.ExtHostLogService=T}),define(Ee[176],ye([0,1,15]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class t{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((T,k)=>{this._actualOk=T,this._actualErr=k,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(T){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=T,this._actual&&this._actualOk(T))}resolveErr(T){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=T,this._actual?this._actualErr(T):(0,a.onUnexpectedError)(T))}then(T,k){return this._ensureActual().then(T,k)}catch(T){return this._ensureActual().then(void 0,T)}finally(T){return this._ensureActual().finally(T)}}e.LazyPromise=t}),define(Ee[37],ye([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class a{constructor(R,F){this._proxyIdentifierBrand=void 0,this.isMain=R,this.sid=F,this.nid=++a.count}}e.ProxyIdentifier=a,a.count=0;const t=[];function w(S){const R=new a(!0,S);return t[R.nid]=R,R}e.createMainContextProxyIdentifier=w;function T(S){const R=new a(!1,S);return t[R.nid]=R,R}e.createExtHostContextProxyIdentifier=T;function k(S){return t[S].sid}e.getStringIdentifierForProxy=k;class I{constructor(R){this.value=R}}e.SerializableObjectWithBuffers=I}),define(Ee[5],ye([0,1,54,2,37]),function(re,e,a,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var T;(function(h){h[h.Desktop=1]="Desktop",h[h.Web=2]="Web"})(T=e.UIKind||(e.UIKind={}));var k;(function(h){h[h.Default=0]="Default",h[h.InCenter=1]="InCenter",h[h.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",h[h.AtTop=3]="AtTop"})(k=e.TextEditorRevealType||(e.TextEditorRevealType={}));var I;(function(h){h[h.Editable=0]="Editable",h[h.SupportsHotExit=1]="SupportsHotExit"})(I=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var S;(function(h){h[h.Int8Array=1]="Int8Array",h[h.Uint8Array=2]="Uint8Array",h[h.Uint8ClampedArray=3]="Uint8ClampedArray",h[h.Int16Array=4]="Int16Array",h[h.Uint16Array=5]="Uint16Array",h[h.Int32Array=6]="Int32Array",h[h.Uint32Array=7]="Uint32Array",h[h.Float32Array=8]="Float32Array",h[h.Float64Array=9]="Float64Array",h[h.BigInt64Array=10]="BigInt64Array",h[h.BigUint64Array=11]="BigUint64Array"})(S=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var R;(function(h){h[h.Text=1]="Text",h[h.Error=2]="Error",h[h.Rich=3]="Rich"})(R=e.CellOutputKind||(e.CellOutputKind={}));var F;(function(h){h[h.Default=0]="Default",h[h.InCenter=1]="InCenter",h[h.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",h[h.AtTop=3]="AtTop"})(F=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var _;(function(h){h[h.None=0]="None",h[h.Process=1]="Process",h[h.Output=2]="Output"})(_=e.CandidatePortSource||(e.CandidatePortSource={}));var n;(function(h){h.name="$ident";function g(l,M){return Object.defineProperty(l,h.name,{value:M,enumerable:!0}),l}h.mixin=g;function P(l){return l[h.name]}h.of=P})(n=e.ObjectIdentifier||(e.ObjectIdentifier={}));class f{static mixin(g){return g._id=f._n++,g}}e.IdObject=f,f._n=0;var o;(function(h){h.label="a",h.kind="b",h.detail="c",h.documentation="d",h.sortText="e",h.filterText="f",h.preselect="g",h.insertText="h",h.insertTextRules="i",h.range="j",h.commitCharacters="k",h.additionalTextEdits="l",h.command="m",h.kindModifier="n"})(o=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var m;(function(h){h.defaultRanges="a",h.completions="b",h.isIncomplete="c",h.duration="d"})(m=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var c;(function(h){h[h.File=1]="File",h[h.Text=2]="Text",h[h.Cell=3]="Cell"})(c=e.WorkspaceEditType||(e.WorkspaceEditType={}));function C(h){if(h&&h.edits)for(const g of h.edits)typeof g.resource=="object"?g.resource=t.URI.revive(g.resource):(g.newUri=t.URI.revive(g.newUri),g.oldUri=t.URI.revive(g.oldUri)),g.metadata&&g.metadata.iconPath&&(g.metadata=(0,a.revive)(g.metadata));return h}e.reviveWorkspaceEditDto=C;var b;(function(h){h[h.Workspace=0]="Workspace",h[h.TextDocument=1]="TextDocument"})(b=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,w.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,w.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,w.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,w.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,w.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,w.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,w.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,w.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,w.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,w.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,w.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,w.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,w.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,w.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,w.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,w.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,w.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,w.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,w.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,w.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,w.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,w.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,w.createMainContextProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,w.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,w.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,w.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,w.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,w.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,w.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,w.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,w.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,w.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,w.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,w.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,w.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,w.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,w.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,w.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,w.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,w.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,w.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,w.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,w.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,w.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,w.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,w.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,w.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,w.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,w.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,w.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,w.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,w.createMainContextProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,w.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,w.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,w.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,w.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,w.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,w.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,w.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,w.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,w.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,w.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,w.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,w.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,w.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,w.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,w.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,w.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,w.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,w.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,w.createExtHostContextProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,w.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,w.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,w.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,w.createExtHostContextProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,w.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,w.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,w.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,w.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,w.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,w.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,w.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,w.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,w.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,w.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,w.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,w.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,w.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,w.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,w.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,w.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,w.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,w.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,w.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,w.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,w.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,w.createMainContextProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,w.createMainContextProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,w.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,w.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,w.createMainContextProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,w.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,w.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,w.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,w.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,w.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,w.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(Ee[68],ye([0,1,5,4,3]),function(re,e,a,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class T{constructor(I){this._onDidChangePassword=new t.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=I.getProxy(a.MainContext.MainThreadSecretState)}async $onDidChangePassword(I){this._onDidChangePassword.fire(I)}get(I,S){return this._proxy.$getPassword(I,S)}store(I,S,R){return this._proxy.$setPassword(I,S,R)}delete(I,S){return this._proxy.$deletePassword(I,S)}}e.ExtHostSecretState=T,e.IExtHostSecretState=(0,w.createDecorator)("IExtHostSecretState")}),define(Ee[69],ye([0,1,3,12,5,13]),function(re,e,a,t,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,a.createDecorator)("IExtHostApiDeprecationService");let k=class{constructor(S,R){this._extHostLogService=R,this._reportedUsages=new Set,this._telemetryShape=S.getProxy(w.MainContext.MainThreadTelemetry)}report(S,R,F){const _=this.getUsageKey(S,R);this._reportedUsages.has(_)||(this._reportedUsages.add(_),R.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${S}' is deprecated. ${F}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:R.identifier.value,apiId:S}))}getUsageKey(S,R){return`${S}-${R.identifier.value}`}};k=Ue([$e(0,T.IExtHostRpcService),$e(1,t.ILogService)],k),e.ExtHostApiDeprecationService=k,e.NullApiDeprecationService=Object.freeze(new class{report(I,S,R){}})}),define(Ee[177],ye([0,1,4,5,7,25]),function(re,e,a,t,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class k{constructor(S){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new a.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=S.getProxy(t.MainContext.MainThreadAuthentication)}$setProviders(S){return this._providers=S,Promise.resolve()}async getSession(S,R,F,_={}){const n=T.ExtensionIdentifier.toKey(S.identifier),f=this._inFlightRequests.get(n)||[],o=[...F].sort().join(" ");let m=f.find(c=>c.scopes===o);if(m)return m.result;{const c=this._getSession(S,n,R,F,_);m={scopes:o,result:c},f.push(m),this._inFlightRequests.set(n,f);try{await c}finally{const C=f.findIndex(b=>b.scopes===o);C>-1&&(f.splice(C),this._inFlightRequests.set(n,f))}return c}}async _getSession(S,R,F,_,n={}){await this._proxy.$ensureProvider(F);const f=S.displayName||S.name;return this._proxy.$getSession(F,_,R,f,n)}async removeSession(S,R){const F=this._authenticationProviders.get(S);return F?F.provider.removeSession(R):this._proxy.$removeSession(S,R)}registerAuthenticationProvider(S,R,F,_){if(this._authenticationProviders.get(S))throw new Error(`An authentication provider with id '${S}' is already registered.`);this._authenticationProviders.set(S,{label:R,provider:F,options:_??{supportsMultipleAccounts:!1}}),this._providers.find(f=>f.id===S)||this._providers.push({id:S,label:R});const n=F.onDidChangeSessions(f=>{this._proxy.$sendDidChangeSessions(S,{added:f.added??[],changed:f.changed??[],removed:f.removed??[]})});return this._proxy.$registerAuthenticationProvider(S,R,_?.supportsMultipleAccounts??!1),new w.Disposable(()=>{n.dispose(),this._authenticationProviders.delete(S);const f=this._providers.findIndex(o=>o.id===S);f>-1&&this._providers.splice(f),this._proxy.$unregisterAuthenticationProvider(S)})}$createSession(S,R){const F=this._authenticationProviders.get(S);if(F)return Promise.resolve(F.provider.createSession(R));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$removeSession(S,R){const F=this._authenticationProviders.get(S);if(F)return Promise.resolve(F.provider.removeSession(R));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$getSessions(S,R){const F=this._authenticationProviders.get(S);if(F)return Promise.resolve(F.provider.getSessions(R));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$onDidChangeAuthenticationSessions(S,R){return this._onDidChangeSessions.fire({provider:{id:S,label:R}}),Promise.resolve()}}e.ExtHostAuthentication=k}),define(Ee[178],ye([0,1,5,13,8]),function(re,e,a,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let T=class{constructor(I,S){this._extHostDocumentsAndEditors=S,this._proxy=I.getProxy(a.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(I){const S=w.WorkspaceEdit.from(I,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(S)}};T=Ue([$e(0,t.IExtHostRpcService)],T),e.ExtHostBulkEdits=T}),define(Ee[179],ye([0,1,5]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class t{constructor(T){const k=T.getProxy(a.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return k.$readText()},writeText(I){return k.$writeText(I)}})}}e.ExtHostClipboard=t}),define(Ee[38],ye([0,1,11,7,8,26,5,16,12,54,59,227,2,6,3,13,47,22,37,43]),function(re,e,a,t,w,T,k,I,S,R,F,_,n,f,o,m,c,C,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let g=class{constructor(p,d){this._commands=new Map,this._apiCommands=new Map,this._proxy=p.getProxy(k.MainContext.MainThreadCommands),this._logService=d,this.converter=new P(this,s=>{const v=this._apiCommands.get(s);return v?.result===M.Void?v:void 0},d),this._argumentProcessors=[{processArgument(s){return(0,R.revive)(s)}},{processArgument(s){return(0,T.cloneAndChange)(s,function(v){if(F.Range.isIRange(v))return w.Range.to(v);if(_.Position.isIPosition(v))return w.Position.to(v);if(F.Range.isIRange(v.range)&&n.URI.isUri(v.uri))return w.location.to(v);if(v instanceof C.VSBuffer)return v.buffer.buffer;if(!Array.isArray(v))return v})}}]}registerArgumentProcessor(p){this._argumentProcessors.push(p)}registerApiCommand(p){const d=this.registerCommand(!1,p.id,async(...s)=>{const v=p.args.map((u,D)=>{if(!u.validate(s[D]))throw new Error(`Invalid argument '${u.name}' when running '${p.id}', received: ${s[D]}`);return u.convert(s[D])}),y=await this.executeCommand(p.internalId,...v);return p.result.convert(y,s,this.converter)},void 0,{description:p.description,args:p.args,returns:p.result.description});return this._apiCommands.set(p.id,p),new t.Disposable(()=>{d.dispose(),this._apiCommands.delete(p.id)})}registerCommand(p,d,s,v,y,u){if(this._logService.trace("ExtHostCommands#registerCommand",d),!d.trim().length)throw new Error("invalid id");if(this._commands.has(d))throw new Error(`command '${d}' already exists`);return this._commands.set(d,{callback:s,thisArg:v,description:y,extension:u}),p&&this._proxy.$registerCommand(d),new t.Disposable(()=>{this._commands.delete(d)&&p&&this._proxy.$unregisterCommand(d)})}executeCommand(p,...d){return this._logService.trace("ExtHostCommands#executeCommand",p),this._doExecuteCommand(p,d,!0)}async _doExecuteCommand(p,d,s){if(this._commands.has(p))return this._executeContributedCommand(p,d,!1);{let v=!1;const y=(0,T.cloneAndChange)(d,function(u){if(u instanceof t.Position)return w.Position.from(u);if(u instanceof t.Range)return w.Range.from(u);if(u instanceof t.Location)return w.location.from(u);if(t.NotebookRange.isNotebookRange(u))return w.NotebookRange.from(u);if(u instanceof ArrayBuffer)return v=!0,C.VSBuffer.wrap(new Uint8Array(u));if(u instanceof Uint8Array)return v=!0,C.VSBuffer.wrap(u);if(!Array.isArray(u))return u});try{const u=await this._proxy.$executeCommand(p,v?new b.SerializableObjectWithBuffers(y):y,s);return(0,R.revive)(u)}catch(u){if(u instanceof Error&&u.message==="$executeCommand:retry")return this._doExecuteCommand(p,d,!1);throw u}}}async _executeContributedCommand(p,d,s){const v=this._commands.get(p);if(!v)throw new Error("Unknown command");let{callback:y,thisArg:u,description:D}=v;if(D)for(let A=0;A<D.args.length;A++)try{(0,a.validateConstraint)(d[A],D.args[A].constraint)}catch{throw new Error(`Running the contributed command: '${p}' failed. Illegal argument '${D.args[A].name}' - ${D.args[A].description}`)}try{return await y.apply(u,d)}catch(A){if(p===this.converter.delegatingCommandId){const U=this.converter.getActualCommand(...d);U&&(p=U.command)}throw this._logService.error(A,p,v.extension?.identifier),s?new class extends Error{constructor(){super((0,h.toErrorMessage)(A));this.id=p,this.source=v.extension?.displayName??v.extension?.name}}:A}}$executeContributedCommand(p,...d){return this._logService.trace("ExtHostCommands#$executeContributedCommand",p),this._commands.has(p)?(d=d.map(s=>this._argumentProcessors.reduce((v,y)=>y.processArgument(v),s)),this._executeContributedCommand(p,d,!0)):Promise.reject(new Error(`Contributed command '${p}' does not exist.`))}getCommands(p=!1){return this._logService.trace("ExtHostCommands#getCommands",p),this._proxy.$getCommands().then(d=>(p&&(d=d.filter(s=>s[0]!=="_")),d))}$getContributedCommandHandlerDescriptions(){const p=Object.create(null);for(let[d,s]of this._commands){let{description:v}=s;v&&(p[d]=v)}return Promise.resolve(p)}};g=Ue([$e(0,m.IExtHostRpcService),$e(1,S.ILogService)],g),e.ExtHostCommands=g,e.IExtHostCommands=(0,o.createDecorator)("IExtHostCommands");class P{constructor(p,d,s){this._commands=p,this._lookupApiCommand=d,this._logService=s,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(p,d){if(!p)return;const s={$ident:void 0,id:p.command,title:p.title,tooltip:p.tooltip};if(!p.command)return s;const v=this._lookupApiCommand(p.command);if(v)s.id=v.internalId,s.arguments=v.args.map((y,u)=>y.convert(p.arguments&&p.arguments[u]));else if((0,I.isNonEmptyArray)(p.arguments)){const y=++this._cachIdPool;this._cache.set(y,p),d.add((0,f.toDisposable)(()=>{this._cache.delete(y),this._logService.trace("CommandsConverter#DISPOSE",y)})),s.$ident=y,s.id=this.delegatingCommandId,s.arguments=[y],this._logService.trace("CommandsConverter#CREATE",p.command,y)}return s}fromInternal(p){const d=k.ObjectIdentifier.of(p);return typeof d=="number"?this._cache.get(d):{command:p.id,title:p.title,arguments:p.arguments}}getActualCommand(...p){return this._cache.get(p[0])}_executeConvertedCommand(...p){const d=this.getActualCommand(...p);return this._logService.trace("CommandsConverter#EXECUTE",p[0],d?d.command:"MISSING"),d?this._commands.executeCommand(d.command,...d.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=P;class l{constructor(p,d,s,v){this.name=p,this.description=d,this.validate=s,this.convert=v}optional(){return new l(this.name,`(optional) ${this.description}`,p=>p==null||this.validate(p),p=>p===void 0?void 0:p===null?null:this.convert(p))}with(p,d){return new l(p??this.name,d??this.description,this.validate,this.convert)}}e.ApiCommandArgument=l,l.Uri=new l("uri","Uri of a text document",i=>n.URI.isUri(i),i=>i),l.Position=new l("position","A position in a text document",i=>t.Position.isPosition(i),w.Position.from),l.Range=new l("range","A range in a text document",i=>t.Range.isRange(i),w.Range.from),l.Selection=new l("selection","A selection in a text document",i=>t.Selection.isSelection(i),w.Selection.from),l.Number=new l("number","",i=>typeof i=="number",i=>i),l.String=new l("string","",i=>typeof i=="string",i=>i),l.CallHierarchyItem=new l("item","A call hierarchy item",i=>i instanceof t.CallHierarchyItem,w.CallHierarchyItem.from),l.TypeHierarchyItem=new l("item","A type hierarchy item",i=>i instanceof t.TypeHierarchyItem,w.TypeHierarchyItem.from),l.TestItem=new l("testItem","A VS Code TestItem",i=>i instanceof c.TestItemImpl,w.TestItem.from);class M{constructor(p,d){this.description=p,this.convert=d}}e.ApiCommandResult=M,M.Void=new M("no result",i=>i);class r{constructor(p,d,s,v,y){this.id=p,this.internalId=d,this.description=s,this.args=v,this.result=y}}e.ApiCommand=r}),define(Ee[180],ye([0,1,8,7,58,38,16,79]),function(re,e,a,t,w,T,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const S=[new T.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",F(a.DocumentHighlight.to))),new T.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[T.ApiCommandArgument.Uri],new T.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(n,f)=>{if((0,k.isFalsyOrEmpty)(n))return;class o extends t.SymbolInformation{static to(c){const C=new o(c.name,a.SymbolKind.to(c.kind),c.containerName||"",new t.Location(f[0],a.Range.to(c.range)));return C.detail=c.detail,C.range=C.location.range,C.selectionRange=a.Range.to(c.selectionRange),C.children=c.children?c.children.map(o.to):[],C}}return n.map(o.to)})),new T.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[T.ApiCommandArgument.Uri,new T.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new T.ApiCommandResult("A promise that resolves to an array of TextEdits.",F(a.TextEdit.to))),new T.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Range,new T.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new T.ApiCommandResult("A promise that resolves to an array of TextEdits.",F(a.TextEdit.to))),new T.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position,new T.ApiCommandArgument("ch","Trigger character",n=>typeof n=="string",n=>n),new T.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new T.ApiCommandResult("A promise that resolves to an array of TextEdits.",F(a.TextEdit.to))),new T.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",_)),new T.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",_)),new T.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",_)),new T.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",_)),new T.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to an array of Location-instances.",F(a.location.to))),new T.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to an array of Hover-instances.",F(a.Hover.to))),new T.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[T.ApiCommandArgument.Uri,new T.ApiCommandArgument("position","A position in a text document",n=>Array.isArray(n)&&n.every(f=>t.Position.isPosition(f)),n=>n.map(a.Position.from))],new T.ApiCommandResult("A promise that resolves to an array of ranges.",n=>n.map(f=>{let o;for(const m of f.reverse())o=new t.SelectionRange(a.Range.to(m),o);return o}))),new T.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[T.ApiCommandArgument.String.with("query","Search string")],new T.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",n=>n.map(a.WorkspaceSymbol.to))),new T.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(a.CallHierarchyItem.to))),new T.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[T.ApiCommandArgument.CallHierarchyItem],new T.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(a.CallHierarchyIncomingCall.to))),new T.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[T.ApiCommandArgument.CallHierarchyItem],new T.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(a.CallHierarchyOutgoingCall.to))),new T.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to a range and placeholder text.",n=>{if(!!n)return{range:a.Range.to(n.range),placeholder:n.text}})),new T.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position,T.ApiCommandArgument.String.with("newName","The new symbol name")],new T.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",n=>{if(!!n){if(n.rejectReason)throw new Error(n.rejectReason);return a.WorkspaceEdit.to(n)}})),new T.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new T.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",n=>n.map(a.DocumentLink.to))),new T.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[T.ApiCommandArgument.Uri],new T.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",n=>{if(!!n)return new t.SemanticTokensLegend(n.tokenTypes,n.tokenModifiers)})),new T.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[T.ApiCommandArgument.Uri],new T.ApiCommandResult("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const f=(0,I.decodeSemanticTokensDto)(n);if(f.type==="full")return new t.SemanticTokens(f.data,void 0)})),new T.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Range.optional()],new T.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",n=>{if(!!n)return new t.SemanticTokensLegend(n.tokenTypes,n.tokenModifiers)})),new T.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Range],new T.ApiCommandResult("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const f=(0,I.decodeSemanticTokensDto)(n);if(f.type==="full")return new t.SemanticTokens(f.data,void 0)})),new T.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position,T.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),T.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new T.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(n,f,o)=>{if(!n)return new t.CompletionList([]);const m=n.suggestions.map(c=>a.CompletionItem.to(c,o));return new t.CompletionList(m,n.incomplete)})),new T.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position,T.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new T.ApiCommandResult("A promise that resolves to SignatureHelp.",n=>{if(n)return a.SignatureHelp.to(n)})),new T.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new T.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(n,f,o)=>F(m=>new t.CodeLens(a.Range.to(m.range),m.command&&o.fromInternal(m.command)))(n))),new T.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[T.ApiCommandArgument.Uri,new T.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",n=>t.Range.isRange(n),n=>t.Selection.isSelection(n)?a.Selection.from(n):a.Range.from(n)),T.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),T.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new T.ApiCommandResult("A promise that resolves to an array of Command-instances.",(n,f,o)=>F(m=>{if(m._isSynthetic){if(!m.command)throw new Error("Synthetic code actions must have a command");return o.fromInternal(m.command)}else{const c=new t.CodeAction(m.title,m.kind?new t.CodeActionKind(m.kind):void 0);return m.edit&&(c.edit=a.WorkspaceEdit.to(m.edit)),m.command&&(c.command=o.fromInternal(m.command)),c.isPreferred=m.isPreferred,c}})(n))),new T.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[T.ApiCommandArgument.Uri],new T.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",n=>n?n.map(f=>new t.ColorInformation(a.Range.to(f.range),a.Color.to(f.color))):[])),new T.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new T.ApiCommandArgument("color","The color to show and insert",n=>n instanceof t.Color,a.Color.from),new T.ApiCommandArgument("context","Context object with uri and range",n=>!0,n=>({uri:n.uri,range:a.Range.from(n.range)}))],new T.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",n=>n?n.map(a.ColorPresentation.to):[])),new T.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Range],new T.ApiCommandResult("A promise that resolves to an array of Inlay objects",n=>n.map(a.InlayHint.to))),new T.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new T.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",F(n=>({viewType:n.viewType,displayName:n.displayName,options:{transientOutputs:n.options.transientOutputs,transientCellMetadata:n.options.transientCellMetadata,transientDocumentMetadata:n.options.transientDocumentMetadata},filenamePattern:n.filenamePattern.map(f=>a.NotebookExclusiveDocumentPattern.to(f))})))),new T.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Range],new T.ApiCommandResult("A promise that resolves to an array of InlineValue objects",n=>n.map(a.InlineValue.to))),new T.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[T.ApiCommandArgument.Uri,new T.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[n,void 0]:[a.ViewColumn.from(n.viewColumn),a.TextEditorOpenOptions.from(n)])).optional(),T.ApiCommandArgument.String.with("label","").optional()],T.ApiCommandResult.Void),new T.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[T.ApiCommandArgument.Uri.with("resource","Resource to open"),T.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new T.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[n,void 0]:[a.ViewColumn.from(n.viewColumn),a.TextEditorOpenOptions.from(n)])).optional()],T.ApiCommandResult.Void),new T.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[T.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),T.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),T.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new T.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="object",n=>n&&[a.ViewColumn.from(n.viewColumn),a.TextEditorOpenOptions.from(n)]).optional()],T.ApiCommandResult.Void),new T.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(a.TypeHierarchyItem.to))),new T.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[T.ApiCommandArgument.TypeHierarchyItem],new T.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(a.TypeHierarchyItem.to))),new T.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[T.ApiCommandArgument.TypeHierarchyItem],new T.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(a.TypeHierarchyItem.to))),new T.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[T.ApiCommandArgument.TestItem],T.ApiCommandResult.Void)];class R{static register(f){S.forEach(f.registerApiCommand,f)}}e.ExtHostApiCommands=R;function F(n){return f=>{if(Array.isArray(f))return f.map(n)}}function _(n){if(!Array.isArray(n))return;const f=[];for(const o of n)w.isLocationLink(o)?f.push(a.DefinitionLink.to(o)):f.push(a.location.to(o));return f}}),define(Ee[181],ye([0,1,14,52,4,6,2,58,25,8,7,5]),function(re,e,a,t,w,T,k,I,S,R,F,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function n(f,o,m){const c=f.getProxy(_.MainContext.MainThreadComments);class C{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,o.registerArgumentProcessor({processArgument:i=>{if(i&&i.$mid===6){const p=this._commentControllers.get(i.handle);return p||i}else if(i&&i.$mid===7){const p=this._commentControllers.get(i.commentControlHandle);if(!p)return i;const d=p.getCommentThread(i.commentThreadHandle);return d||i}else if(i&&i.$mid===8){const p=this._commentControllers.get(i.thread.commentControlHandle);if(!p)return i;const d=p.getCommentThread(i.thread.commentThreadHandle);return d?{thread:d,text:i.text}:i}else if(i&&i.$mid===9){const p=this._commentControllers.get(i.thread.commentControlHandle);if(!p)return i;const d=p.getCommentThread(i.thread.commentThreadHandle);if(!d)return i;let s=i.commentUniqueId,v=d.getCommentByUniqueId(s);return v||i}else if(i&&i.$mid===10){const p=this._commentControllers.get(i.thread.commentControlHandle);if(!p)return i;const d=p.getCommentThread(i.thread.commentThreadHandle);if(!d)return i;let s=i.text,v=i.commentUniqueId,y=d.getCommentByUniqueId(v);return y?(y.body=s,y):i}return i}})}createCommentController(i,p,d){const s=C.handlePool++,v=new h(i,s,p,d);this._commentControllers.set(v.handle,v);const y=this._commentControllersByExtension.get(S.ExtensionIdentifier.toKey(i.identifier))||[];return y.push(v),this._commentControllersByExtension.set(S.ExtensionIdentifier.toKey(i.identifier),y),v.value}$createCommentThreadTemplate(i,p,d){const s=this._commentControllers.get(i);!s||s.$createCommentThreadTemplate(p,d)}async $updateCommentThreadTemplate(i,p,d){const s=this._commentControllers.get(i);!s||s.$updateCommentThreadTemplate(p,d)}$deleteCommentThread(i,p){const d=this._commentControllers.get(i);d&&d.$deleteCommentThread(p)}$provideCommentingRanges(i,p,d){const s=this._commentControllers.get(i);if(!s||!s.commentingRangeProvider)return Promise.resolve(void 0);const v=m.getDocument(k.URI.revive(p));return(0,a.asPromise)(()=>s.commentingRangeProvider.provideCommentingRanges(v,d)).then(y=>y?y.map(u=>R.Range.from(u)):void 0)}$toggleReaction(i,p,d,s,v){const y=this._commentControllers.get(i);return!y||!y.reactionHandler?Promise.resolve(void 0):(0,a.asPromise)(()=>{const u=y.getCommentThread(p);if(u){const D=u.getCommentByUniqueId(s.uniqueIdInThread);if(y!==void 0&&D&&y.reactionHandler)return y.reactionHandler(D,l(v))}return Promise.resolve(void 0)})}dispose(){}}C.handlePool=0;class b{constructor(i,p,d,s,v,y,u){this._commentControllerHandle=p,this._id=d,this._uri=s,this._range=v,this._comments=y,this.handle=b._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new w.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new T.MutableDisposable,this._acceptInputDisposables.value=new T.DisposableStore,this._id===void 0&&(this._id=`${i}.${this.handle}`),c.$createCommentThread(p,this.handle,this._id,this._uri,R.Range.from(this._range),u),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=y,this._localDisposables.push({dispose:()=>{c.$deleteCommentThread(p,this.handle)}});const D=this;this.value={get uri(){return D.uri},get range(){return D.range},set range(A){D.range=A},get comments(){return D.comments},set comments(A){D.comments=A},get collapsibleState(){return D.collapsibleState},set collapsibleState(A){D.collapsibleState=A},get canReply(){return D.canReply},set canReply(A){D.canReply=A},get contextValue(){return D.contextValue},set contextValue(A){D.contextValue=A},get label(){return D.label},set label(A){D.label=A},dispose:()=>{D.dispose()}}}set threadId(i){this._id=i}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(i){i.isEqual(this._range)||(this._range=i,this.modifications.range=i,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(i){this._canReply!==i&&(this._canReply=i,this.modifications.canReply=i,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(i){this._label=i,this.modifications.label=i,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(i){this._contextValue=i,this.modifications.contextValue=i,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(i){this._comments=i,this.modifications.comments=i,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(i){this._collapseState=i,this.modifications.collapsibleState=i,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new T.DisposableStore);const i=d=>Object.prototype.hasOwnProperty.call(this.modifications,d),p={};i("range")&&(p.range=R.Range.from(this._range)),i("label")&&(p.label=this.label),i("contextValue")&&(p.contextValue=this.contextValue??null),i("comments")&&(p.comments=this._comments.map(d=>g(this,d,this._commentsMap))),i("collapsibleState")&&(p.collapseState=M(this._collapseState)),i("canReply")&&(p.canReply=this.canReply),this.modifications={},c.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,p)}getCommentByUniqueId(i){for(let p of this._commentsMap){let d=p[0],s=p[1];if(i===s)return d}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(i=>i.dispose())}}b._handlePool=0,Ue([(0,t.debounce)(100)],b.prototype,"eventuallyUpdateCommentThread",null);class h{constructor(i,p,d,s){this._extension=i,this._handle=p,this._id=d,this._label=s,this._threads=new Map,c.$registerCommentController(this.handle,d,s);const v=this;this.value=Object.freeze({id:v.id,label:v.label,get options(){return v.options},set options(y){v.options=y},get commentingRangeProvider(){return v.commentingRangeProvider},set commentingRangeProvider(y){v.commentingRangeProvider=y},get reactionHandler(){return v.reactionHandler},set reactionHandler(y){v.reactionHandler=y},createCommentThread(y,u,D){return v.createCommentThread(y,u,D).value},dispose:()=>{v.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{c.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(i){this._commentingRangeProvider=i,c.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(i){this._reactionHandler=i,c.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!i})}get options(){return this._options}set options(i){this._options=i,c.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(i,p,d,s){if(typeof i=="string"){const v=new b(this.id,this.handle,i,p,d,s,this._extension.identifier);return this._threads.set(v.handle,v),v}else{const v=new b(this.id,this.handle,void 0,i,p,d,this._extension.identifier);return this._threads.set(v.handle,v),v}}$createCommentThreadTemplate(i,p){const d=new b(this.id,this.handle,void 0,k.URI.revive(i),R.Range.to(p),[],this._extension.identifier);return d.collapsibleState=I.CommentThreadCollapsibleState.Expanded,this._threads.set(d.handle,d),d}$updateCommentThreadTemplate(i,p){let d=this._threads.get(i);d&&(d.range=R.Range.to(p))}$deleteCommentThread(i){let p=this._threads.get(i);p&&p.dispose(),this._threads.delete(i)}getCommentThread(i){return this._threads.get(i)}dispose(){this._threads.forEach(i=>{i.dispose()}),this._localDisposables.forEach(i=>i.dispose())}}function g(r,i,p){let d=p.get(i);d||(d=++r.commentHandle,p.set(i,d));const s=i.author&&i.author.iconPath?i.author.iconPath.toString():void 0;return{mode:i.mode,contextValue:i.contextValue,uniqueIdInThread:d,body:R.MarkdownString.from(i.body),userName:i.author.name,userIconPath:s,label:i.label,commentReactions:i.reactions?i.reactions.map(v=>P(v)):void 0}}function P(r){return{label:r.label,iconPath:r.iconPath?R.pathOrURIToURI(r.iconPath):void 0,count:r.count,hasReacted:r.authorHasReacted}}function l(r){return{label:r.label||"",count:r.count||0,iconPath:r.iconPath?k.URI.revive(r.iconPath):"",authorHasReacted:r.hasReacted||!1}}function M(r){if(r!==void 0)switch(r){case F.CommentThreadCollapsibleState.Expanded:return I.CommentThreadCollapsibleState.Expanded;case F.CommentThreadCollapsibleState.Collapsed:return I.CommentThreadCollapsibleState.Collapsed}return I.CommentThreadCollapsibleState.Collapsed}return new C}e.createExtHostComments=n}),define(Ee[93],ye([0,1,2,5,7,3,13,12,16,9,17]),function(re,e,a,t,w,T,k,I,S,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let _=class wi{constructor(f,o){this._logService=o,this._provider=new Map,this._proxy=f.getProxy(t.MainContext.MainThreadDecorations)}registerFileDecorationProvider(f,o){const m=wi._handlePool++;this._provider.set(m,{provider:f,extensionId:o}),this._proxy.$registerDecorationProvider(m,o.value);const c=f.onDidChangeFileDecorations&&f.onDidChangeFileDecorations(C=>{if(!C){this._proxy.$onDidChange(m,null);return}let b=(0,S.asArray)(C);if(b.length<=wi._maxEventSize){this._proxy.$onDidChange(m,b);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",o.value,b.length);const h=b.map(l=>({uri:l,rank:(0,R.count)(l.path,"/")})),g=(0,S.groupBy)(h,(l,M)=>l.rank-M.rank||(0,R.compare)(l.uri.path,M.uri.path));let P=[];e:for(let l of g){let M;for(let r of l){let i=(0,F.dirname)(r.uri.path);if(M!==i&&(M=i,P.push(r.uri)>=wi._maxEventSize))break e}}this._proxy.$onDidChange(m,P)});return new w.Disposable(()=>{c?.dispose(),this._proxy.$unregisterDecorationProvider(m),this._provider.delete(m)})}async $provideDecorations(f,o,m){if(!this._provider.has(f))return Object.create(null);const c=Object.create(null),{provider:C,extensionId:b}=this._provider.get(f);return await Promise.all(o.map(async h=>{try{const{uri:g,id:P}=h,l=await Promise.resolve(C.provideFileDecoration(a.URI.revive(g),m));if(!l)return;try{w.FileDecoration.validate(l),c[P]=[l.propagate,l.tooltip,l.badge,l.color]}catch(M){this._logService.warn(`INVALID decoration from extension '${b.value}': ${M}`)}}catch(g){this._logService.error(g)}})),c}};_._handlePool=0,_._maxEventSize=250,_=Ue([$e(0,k.IExtHostRpcService),$e(1,I.ILogService)],_),e.ExtHostDecorations=_,e.IExtHostDecorations=(0,T.createDecorator)("IExtHostDecorations")});var Ze=this&&this.__classPrivateFieldSet||function(re,e,a,t,w){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!w:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?w.call(re,a):w?w.value=a:e.set(re,a),a},Te=this&&this.__classPrivateFieldGet||function(re,e,a,t){if(a==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!t:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?t:a==="a"?t.call(re):t?t.value:e.get(re)};define(Ee[182],ye([0,1,119,82,2,5,7,8,4,12,21,30]),function(re,e,a,t,w,T,k,I,S,R,F,_){"use strict";var n,f,o;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class m{constructor(b,h,g,P,l,M){this._name=b,this._owner=h,this._maxDiagnosticsPerFile=g,n.set(this,void 0),f.set(this,void 0),o.set(this,void 0),this._isDisposed=!1,Ze(this,o,new F.ResourceMap(r=>P.getComparisonKey(r)),"f"),Ze(this,n,l,"f"),Ze(this,f,M,"f")}dispose(){this._isDisposed||(Te(this,f,"f").fire([...Te(this,o,"f").keys()]),Te(this,n,"f")&&Te(this,n,"f").$clear(this._owner),Te(this,o,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(b,h){if(!b){this.clear();return}this._checkDisposed();let g=[];if(w.URI.isUri(b)){if(!h){this.delete(b);return}Te(this,o,"f").set(b,h.slice()),g=[b]}else if(Array.isArray(b)){g=[];let l;b=[...b].sort(m._compareIndexedTuplesByUri);for(const M of b){const[r,i]=M;if((!l||r.toString()!==l.toString())&&(l&&Te(this,o,"f").get(l).length===0&&Te(this,o,"f").delete(l),l=r,g.push(r),Te(this,o,"f").set(r,[])),i){const p=Te(this,o,"f").get(r);p&&p.push(...i)}else{const p=Te(this,o,"f").get(r);p&&(p.length=0)}}}if(Te(this,f,"f").fire(g),!Te(this,n,"f"))return;const P=[];for(let l of g){let M=[];const r=Te(this,o,"f").get(l);if(r)if(r.length>this._maxDiagnosticsPerFile){M=[];const i=[k.DiagnosticSeverity.Error,k.DiagnosticSeverity.Warning,k.DiagnosticSeverity.Information,k.DiagnosticSeverity.Hint];e:for(let p=0;p<4;p++)for(let d of r)if(d.severity===i[p]&&M.push(I.Diagnostic.from(d))===this._maxDiagnosticsPerFile)break e;M.push({severity:t.MarkerSeverity.Info,message:(0,a.localize)(0,null,r.length-this._maxDiagnosticsPerFile),startLineNumber:M[M.length-1].startLineNumber,startColumn:M[M.length-1].startColumn,endLineNumber:M[M.length-1].endLineNumber,endColumn:M[M.length-1].endColumn})}else M=r.map(i=>I.Diagnostic.from(i));P.push([l,M])}Te(this,n,"f").$changeMany(this._owner,P)}delete(b){this._checkDisposed(),Te(this,f,"f").fire([b]),Te(this,o,"f").delete(b),Te(this,n,"f")&&Te(this,n,"f").$changeMany(this._owner,[[b,void 0]])}clear(){this._checkDisposed(),Te(this,f,"f").fire([...Te(this,o,"f").keys()]),Te(this,o,"f").clear(),Te(this,n,"f")&&Te(this,n,"f").$clear(this._owner)}forEach(b,h){this._checkDisposed();for(let g of Te(this,o,"f").keys())b.apply(h,[g,this.get(g),this])}get(b){this._checkDisposed();const h=Te(this,o,"f").get(b);return Array.isArray(h)?Object.freeze(h.slice(0)):[]}has(b){return this._checkDisposed(),Array.isArray(Te(this,o,"f").get(b))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(b,h){return b[0].toString()<h[0].toString()?-1:b[0].toString()>h[0].toString()?1:0}}e.DiagnosticCollection=m,n=new WeakMap,f=new WeakMap,o=new WeakMap;let c=class ri{constructor(b,h,g){this._logService=h,this._fileSystemInfoService=g,this._collections=new Map,this._onDidChangeDiagnostics=new S.DebounceEmitter({merge:P=>P.flat(),delay:50}),this.onDidChangeDiagnostics=S.Event.map(this._onDidChangeDiagnostics.event,ri._mapper),this._proxy=b.getProxy(T.MainContext.MainThreadDiagnostics)}static _mapper(b){const h=new F.ResourceMap;for(const g of b)h.set(g,g);return{uris:Object.freeze(Array.from(h.values()))}}createDiagnosticCollection(b,h){const{_collections:g,_proxy:P,_onDidChangeDiagnostics:l,_logService:M,_fileSystemInfoService:r}=this,i=new class{$changeMany(s,v){P.$changeMany(s,v),M.trace("[DiagnosticCollection] change many (extension, owner, uris)",b.value,s,v.length===0?"CLEARING":v)}$clear(s){P.$clear(s),M.trace("[DiagnosticCollection] remove all (extension, owner)",b.value,s)}dispose(){P.dispose()}};let p;if(!h)h="_generated_diagnostic_collection_name_#"+ri._idPool++,p=h;else if(!g.has(h))p=h;else{this._logService.warn(`DiagnosticCollection with name '${h}' does already exist.`);do p=h+ri._idPool++;while(g.has(p))}return new class extends m{constructor(){super(h,p,ri._maxDiagnosticsPerFile,r.extUri,i,l);g.set(p,this)}dispose(){super.dispose(),g.delete(p)}}}getDiagnostics(b){if(b)return this._getDiagnostics(b);{const h=new Map,g=[];for(const P of this._collections.values())P.forEach((l,M)=>{let r=h.get(l.toString());typeof r=="undefined"&&(r=g.length,h.set(l.toString(),r),g.push([l,[]])),g[r][1]=g[r][1].concat(...M)});return g}}_getDiagnostics(b){let h=[];for(let g of this._collections.values())g.has(b)&&(h=h.concat(g.get(b)));return h}$acceptMarkersChange(b){if(!this._mirrorCollection){const h="_generated_mirror",g=new m(h,h,ri._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(h,g),this._mirrorCollection=g}for(const[h,g]of b)this._mirrorCollection.set(w.URI.revive(h),g.map(I.Diagnostic.to))}};c._idPool=0,c._maxDiagnosticsPerFile=1e3,c=Ue([$e(1,R.ILogService),$e(2,_.IExtHostFileSystemInfo)],c),e.ExtHostDiagnostics=c}),define(Ee[183],ye([0,1,2,5]),function(re,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class w{constructor(k){this._proxy=k.getProxy(t.MainContext.MainThreadDialogs)}showOpenDialog(k){return this._proxy.$showOpenDialog(k).then(I=>I?I.map(S=>a.URI.revive(S)):void 0)}showSaveDialog(k){return this._proxy.$showSaveDialog(k).then(I=>I?a.URI.revive(I):void 0)}}e.ExtHostDialogs=w}),define(Ee[184],ye([0,1,15,2,7,5,10,20,9]),function(re,e,a,t,w,T,k,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class R{constructor(_,n,f){this._documentsAndEditors=n,this._logService=f,this._documentContentProviders=new Map,this._proxy=_.getProxy(T.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(_,n){if(Object.keys(k.Schemas).indexOf(_)>=0)throw new Error(`scheme '${_}' already registered`);const f=R._handlePool++;this._documentContentProviders.set(f,n),this._proxy.$registerTextContentProvider(f,_);let o;return typeof n.onDidChange=="function"&&(o=n.onDidChange(m=>{if(m.scheme!==_){this._logService.warn(`Provider for scheme '${_}' is firing event for schema '${m.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(m)&&this.$provideTextDocumentContent(f,m).then(c=>{if(!c&&typeof c!="string")return;const C=this._documentsAndEditors.getDocument(m);if(!C)return;const b=(0,S.splitLines)(c);if(!C.equalLines(b))return this._proxy.$onVirtualDocumentChange(m,c)},a.onUnexpectedError)})),new w.Disposable(()=>{this._documentContentProviders.delete(f)&&this._proxy.$unregisterTextContentProvider(f),o&&(o.dispose(),o=void 0)})}$provideTextDocumentContent(_,n){const f=this._documentContentProviders.get(_);return f?Promise.resolve(f.provideTextDocumentContent(t.URI.revive(n),I.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${n.scheme}`))}}e.ExtHostDocumentContentProvider=R,R._handlePool=0}),define(Ee[185],ye([0,1,4,6,2,5,86,8,11,26,7]),function(re,e,a,t,w,T,k,I,S,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class _{constructor(f,o){this._onDidAddDocument=new a.Emitter,this._onDidRemoveDocument=new a.Emitter,this._onDidChangeDocument=new a.Emitter,this._onDidSaveDocument=new a.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new t.DisposableStore,this._documentLoader=new Map,this._proxy=f.getProxy(T.MainContext.MainThreadDocuments),this._documentsAndEditors=o,this._documentsAndEditors.onDidRemoveDocuments(m=>{for(const c of m)this._onDidRemoveDocument.fire(c.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(m=>{for(const c of m)this._onDidAddDocument.fire(c.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(f){if(!f)return;const o=this._documentsAndEditors.getDocument(f);if(o)return o}getDocument(f){const o=this.getDocumentData(f);if(!o?.document)throw new Error(`Unable to retrieve document from URI '${f}'`);return o.document}ensureDocumentData(f){const o=this._documentsAndEditors.getDocument(f);if(o)return Promise.resolve(o);let m=this._documentLoader.get(f.toString());return m||(m=this._proxy.$tryOpenDocument(f).then(c=>{this._documentLoader.delete(f.toString());const C=w.URI.revive(c);return(0,S.assertIsDefined)(this._documentsAndEditors.getDocument(C))},c=>(this._documentLoader.delete(f.toString()),Promise.reject(c))),this._documentLoader.set(f.toString(),m)),m}createDocumentData(f){return this._proxy.$tryCreateDocument(f).then(o=>w.URI.revive(o))}$acceptModelModeChanged(f,o){const m=w.URI.revive(f),c=this._documentsAndEditors.getDocument(m);if(!c)throw new Error("unknown document");this._onDidRemoveDocument.fire(c.document),c._acceptLanguageId(o),this._onDidAddDocument.fire(c.document)}$acceptModelSaved(f){const o=w.URI.revive(f),m=this._documentsAndEditors.getDocument(o);if(!m)throw new Error("unknown document");this.$acceptDirtyStateChanged(f,!1),this._onDidSaveDocument.fire(m.document)}$acceptDirtyStateChanged(f,o){const m=w.URI.revive(f),c=this._documentsAndEditors.getDocument(m);if(!c)throw new Error("unknown document");c._acceptIsDirty(o),this._onDidChangeDocument.fire({document:c.document,contentChanges:[],reason:void 0})}$acceptModelChanged(f,o,m){const c=w.URI.revive(f),C=this._documentsAndEditors.getDocument(c);if(!C)throw new Error("unknown document");C._acceptIsDirty(m),C.onEvents(o);let b;o.isUndoing?b=F.TextDocumentChangeReason.Undo:o.isRedoing&&(b=F.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,R.deepFreeze)({document:C.document,contentChanges:o.changes.map(h=>({range:I.Range.to(h.range),rangeOffset:h.rangeOffset,rangeLength:h.rangeLength,text:h.text})),reason:b}))}setWordDefinitionFor(f,o){(0,k.setWordDefinitionFor)(f,o)}}e.ExtHostDocuments=_}),define(Ee[48],ye([0,1,41,4,6,2,3,5,86,13,92,8,12,21,10,158,101]),function(re,e,a,t,w,T,k,I,S,R,F,_,n,f,o,m,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class C{constructor(g){this.value=g,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let b=class{constructor(g,P){this._extHostRpc=g,this._logService=P,this._activeEditorId=null,this._editors=new Map,this._documents=new f.ResourceMap,this._onDidAddDocuments=new t.Emitter,this._onDidRemoveDocuments=new t.Emitter,this._onDidChangeVisibleTextEditors=new t.Emitter,this._onDidChangeActiveTextEditor=new t.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(g){this.acceptDocumentsAndEditorsDelta(g)}acceptDocumentsAndEditorsDelta(g){const P=[],l=[],M=[];if(g.removedDocuments)for(const r of g.removedDocuments){const i=T.URI.revive(r),p=this._documents.get(i);p?.unref()&&(this._documents.delete(i),P.push(p.value))}if(g.addedDocuments)for(const r of g.addedDocuments){const i=T.URI.revive(r.uri);let p=this._documents.get(i);if(p&&i.scheme!==o.Schemas.vscodeNotebookCell&&i.scheme!==o.Schemas.vscodeInteractiveInput)throw new Error(`document '${i} already exists!'`);p||(p=new C(new S.ExtHostDocumentData(this._extHostRpc.getProxy(I.MainContext.MainThreadDocuments),i,r.lines,r.EOL,r.versionId,r.languageId,r.isDirty,r.notebook)),this._documents.set(i,p),l.push(p.value)),p.ref()}if(g.removedEditors)for(const r of g.removedEditors){const i=this._editors.get(r);this._editors.delete(r),i&&M.push(i)}if(g.addedEditors)for(const r of g.addedEditors){const i=T.URI.revive(r.documentUri);a.ok(this._documents.has(i),`document '${i}' does not exist`),a.ok(!this._editors.has(r.id),`editor '${r.id}' already exists!`);const p=this._documents.get(i).value,d=new F.ExtHostTextEditor(r.id,this._extHostRpc.getProxy(I.MainContext.MainThreadTextEditors),this._logService,new c.Lazy(()=>p.document),r.selections.map(_.Selection.to),r.options,r.visibleRanges.map(s=>_.Range.to(s)),typeof r.editorPosition=="number"?_.ViewColumn.to(r.editorPosition):void 0);this._editors.set(r.id,d)}g.newActiveEditor!==void 0&&(a.ok(g.newActiveEditor===null||this._editors.has(g.newActiveEditor),`active editor '${g.newActiveEditor}' does not exist`),this._activeEditorId=g.newActiveEditor),(0,w.dispose)(P),(0,w.dispose)(M),g.removedDocuments&&this._onDidRemoveDocuments.fire(P),g.addedDocuments&&this._onDidAddDocuments.fire(l),(g.removedEditors||g.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(r=>r.value)),g.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(g){return this._documents.get(g)?.value}allDocuments(){return m.Iterable.map(this._documents.values(),g=>g.value)}getEditor(g){return this._editors.get(g)}activeEditor(g){if(!this._activeEditorId)return;const P=this._editors.get(this._activeEditorId);return g?P:P?.value}allEditors(){return[...this._editors.values()]}};b=Ue([$e(0,R.IExtHostRpcService),$e(1,n.ILogService)],b),e.ExtHostDocumentsAndEditors=b,e.IExtHostDocumentsAndEditors=(0,k.createDecorator)("IExtHostDocumentsAndEditors")}),define(Ee[70],ye([0,1,8,5,2,4,3,13,14]),function(re,e,a,t,w,T,k,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,k.createDecorator)("IExtHostEditorTabs");let R=class{constructor(_){this._onDidChangeTabs=new T.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._onDidChangeActiveTab=new T.Emitter,this.onDidChangeActiveTab=this._onDidChangeActiveTab.event,this._tabs=[],this._proxy=_.getProxy(t.MainContext.MainThreadEditorTabs)}get tabs(){return this._tabs}get activeTab(){return this._activeTab}$acceptEditorTabs(_){let n=-1;this._tabs=_.map((o,m)=>(o.isActive&&(n=m),Object.freeze({label:o.label,viewColumn:a.ViewColumn.to(o.viewColumn),index:m,resource:w.URI.revive(o.resource),additionalResourcesAndViewIds:o.additionalResourcesAndViewIds.map(({resource:c,viewId:C})=>({resource:w.URI.revive(c),viewId:C})),viewId:o.editorId,isActive:o.isActive,move:async(c,C)=>{this._proxy.$moveTab(o,c,a.ViewColumn.from(C)),await(0,S.raceTimeout)(T.Event.toPromise(this._onDidChangeTabs.event),1e3)},close:async()=>{await this._proxy.$closeTab(o),await(0,S.raceTimeout)(T.Event.toPromise(this._onDidChangeTabs.event),1e3)}}))),this._tabs=this._tabs.sort((o,m)=>o.viewColumn===m.viewColumn?o.index-m.index:o.viewColumn-m.viewColumn);const f=this._activeTab;this._activeTab=n===-1?void 0:this._tabs[n],this._activeTab!==f&&this._onDidChangeActiveTab.fire(this._activeTab),this._onDidChangeTabs.fire(this._tabs)}};R=Ue([$e(0,I.IExtHostRpcService)],R),e.ExtHostEditorTabs=R}),define(Ee[186],ye([0,1,2,5,6,7,8,228,9,22,27]),function(re,e,a,t,w,T,k,I,S,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class _{constructor(){this._schemes=[]}add(o){this._stateMachine=void 0,this._schemes.push(o)}delete(o){const m=this._schemes.indexOf(o);m>=0&&(this._schemes.splice(m,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const o=this._schemes.sort(),m=[];let c,C,b=14,h=14;for(const g of o){let P=c?(0,S.commonPrefixLength)(c,g):0;for(P===0?C=1:C=h;P<g.length;P++)P+1===g.length?(b=h,h=9):h+=1,m.push([C,g.toUpperCase().charCodeAt(P),h]),m.push([C,g.toLowerCase().charCodeAt(P),h]),C=h;c=g,h=b}m.push([9,58,10]),m.push([10,47,12]),this._stateMachine=new I.StateMachine(m)}}provideDocumentLinks(o){this._initStateMachine();const m=[],c=I.LinkComputer.computeLinks({getLineContent(C){return o.lineAt(C-1).text},getLineCount(){return o.lineCount}},this._stateMachine);for(const C of c){const b=k.DocumentLink.to(C);b.target&&m.push(b)}return m}}class n{constructor(o,m){this._extHostLanguageFeatures=m,this._linkProvider=new _,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=o.getProxy(t.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(o,m,c,C={}){if(this._registeredSchemes.has(m))throw new Error(`a provider for the scheme '${m}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const b=this._handlePool++;this._linkProvider.add(m),this._registeredSchemes.add(m),this._fsProvider.set(b,c);let h=2;C.isCaseSensitive&&(h+=1024),C.isReadonly&&(h+=2048),typeof c.copy=="function"&&(h+=8),typeof c.open=="function"&&typeof c.close=="function"&&typeof c.read=="function"&&typeof c.write=="function"&&((0,F.checkProposedApiEnabled)(o,"fsChunks"),h+=4),this._proxy.$registerFileSystemProvider(b,m,h).catch(P=>{console.error(`FAILED to register filesystem provider of ${o.identifier.value}-extension for the scheme ${m}`),console.error(P)});const g=c.onDidChangeFile(P=>{const l=[];for(const M of P){let{uri:r,type:i}=M;if(r.scheme!==m)continue;let p;switch(i){case T.FileChangeType.Changed:p=0;break;case T.FileChangeType.Created:p=1;break;case T.FileChangeType.Deleted:p=2;break;default:throw new Error("Unknown FileChangeType")}l.push({resource:r,type:p})}this._proxy.$onFileSystemChange(b,l)});return(0,w.toDisposable)(()=>{g.dispose(),this._linkProvider.delete(m),this._registeredSchemes.delete(m),this._fsProvider.delete(b),this._proxy.$unregisterProvider(b)})}static _asIStat(o){const{type:m,ctime:c,mtime:C,size:b,permissions:h}=o;return{type:m,ctime:c,mtime:C,size:b,permissions:h}}$stat(o,m){return Promise.resolve(this._getFsProvider(o).stat(a.URI.revive(m))).then(c=>n._asIStat(c))}$readdir(o,m){return Promise.resolve(this._getFsProvider(o).readDirectory(a.URI.revive(m)))}$readFile(o,m){return Promise.resolve(this._getFsProvider(o).readFile(a.URI.revive(m))).then(c=>R.VSBuffer.wrap(c))}$writeFile(o,m,c,C){return Promise.resolve(this._getFsProvider(o).writeFile(a.URI.revive(m),c.buffer,C))}$delete(o,m,c){return Promise.resolve(this._getFsProvider(o).delete(a.URI.revive(m),c))}$rename(o,m,c,C){return Promise.resolve(this._getFsProvider(o).rename(a.URI.revive(m),a.URI.revive(c),C))}$copy(o,m,c,C){const b=this._getFsProvider(o);if(!b.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(b.copy(a.URI.revive(m),a.URI.revive(c),C))}$mkdir(o,m){return Promise.resolve(this._getFsProvider(o).createDirectory(a.URI.revive(m)))}$watch(o,m,c,C){const b=this._getFsProvider(o).watch(a.URI.revive(c),C);this._watches.set(m,b)}$unwatch(o,m){const c=this._watches.get(m);c&&(c.dispose(),this._watches.delete(m))}$open(o,m,c){const C=this._getFsProvider(o);if(!C.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(C.open(a.URI.revive(m),c))}$close(o,m){const c=this._getFsProvider(o);if(!c.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(c.close(m))}$read(o,m,c,C){const b=this._getFsProvider(o);if(!b.read)throw new Error('FileSystemProvider does not implement "read"');const h=R.VSBuffer.alloc(C);return Promise.resolve(b.read(m,c,h.buffer,0,C)).then(g=>h.slice(0,g))}$write(o,m,c,C){const b=this._getFsProvider(o);if(!b.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(b.write(m,c,C.buffer,0,C.byteLength))}_getFsProvider(o){const m=this._fsProvider.get(o);if(!m){const c=new Error;throw c.name="ENOPRO",c.message="no provider",c}return m}}e.ExtHostFileSystem=n}),define(Ee[49],ye([0,1,5,45,7,22,3,13,30,6]),function(re,e,a,t,w,T,k,I,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let F=class Wt{constructor(n,f){this._fileSystemProvider=new Map,this._proxy=n.getProxy(a.MainContext.MainThreadFileSystem);const o=this;this.value=Object.freeze({async stat(m){try{const c=o._fileSystemProvider.get(m.scheme);if(!c)return await o._proxy.$stat(m);await o._proxy.$ensureActivation(m.scheme);const C=await c.stat(m);return{type:C.type,ctime:C.ctime,mtime:C.mtime,size:C.size,permissions:C.permissions}}catch(c){Wt._handleError(c)}},async readDirectory(m){try{const c=o._fileSystemProvider.get(m.scheme);return c?(await o._proxy.$ensureActivation(m.scheme),(await c.readDirectory(m)).slice()):await o._proxy.$readdir(m)}catch(c){return Wt._handleError(c)}},async createDirectory(m){try{return await o._proxy.$mkdir(m)}catch(c){return Wt._handleError(c)}},async readFile(m){try{const c=o._fileSystemProvider.get(m.scheme);return c?(await o._proxy.$ensureActivation(m.scheme),(await c.readFile(m)).slice()):(await o._proxy.$readFile(m)).buffer}catch(c){return Wt._handleError(c)}},async writeFile(m,c){try{return await o._proxy.$writeFile(m,T.VSBuffer.wrap(c))}catch(C){return Wt._handleError(C)}},async delete(m,c){try{const C=o._fileSystemProvider.get(m.scheme);return C?(await o._proxy.$ensureActivation(m.scheme),await C.delete(m,{recursive:!1,...c})):await o._proxy.$delete(m,{recursive:!1,useTrash:!1,...c})}catch(C){return Wt._handleError(C)}},async rename(m,c,C){try{return await o._proxy.$rename(m,c,{overwrite:!1,...C})}catch(b){return Wt._handleError(b)}},async copy(m,c,C){try{return await o._proxy.$copy(m,c,{overwrite:!1,...C})}catch(b){return Wt._handleError(b)}},isWritableFileSystem(m){const c=f.getCapabilities(m);if(typeof c=="number")return!(c&2048)}})}static _handleError(n){if(n instanceof w.FileSystemError)throw n;if(!(n instanceof Error))throw new w.FileSystemError(String(n));if(n.name==="ENOPRO")throw w.FileSystemError.Unavailable(n.message);switch(n.name){case t.FileSystemProviderErrorCode.FileExists:throw w.FileSystemError.FileExists(n.message);case t.FileSystemProviderErrorCode.FileNotFound:throw w.FileSystemError.FileNotFound(n.message);case t.FileSystemProviderErrorCode.FileNotADirectory:throw w.FileSystemError.FileNotADirectory(n.message);case t.FileSystemProviderErrorCode.FileIsADirectory:throw w.FileSystemError.FileIsADirectory(n.message);case t.FileSystemProviderErrorCode.NoPermissions:throw w.FileSystemError.NoPermissions(n.message);case t.FileSystemProviderErrorCode.Unavailable:throw w.FileSystemError.Unavailable(n.message);default:throw new w.FileSystemError(n.message,n.name)}}addFileSystemProvider(n,f){return this._fileSystemProvider.set(n,f),(0,R.toDisposable)(()=>this._fileSystemProvider.delete(n))}};F=Ue([$e(0,I.IExtHostRpcService),$e(1,S.IExtHostFileSystemInfo)],F),e.ExtHostConsumerFileSystem=F,e.IExtHostConsumerFileSystem=(0,k.createDecorator)("IExtHostConsumerFileSystem")}),define(Ee[187],ye([0,1,2,38]),function(re,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class w{constructor(k,I,S,R){this._extHostNotebooks=I,this._textDocumentsAndEditors=S,this._commands=R;const F=new t.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new t.ApiCommandArgument("showOptions","Show Options",_=>!0,_=>_),new t.ApiCommandArgument("resource","Interactive resource Uri",_=>!0,_=>_),new t.ApiCommandArgument("controllerId","Notebook controller Id",_=>!0,_=>_),new t.ApiCommandArgument("title","Interactive editor title",_=>!0,_=>_)],new t.ApiCommandResult("Notebook and input URI",_=>{if(_.notebookEditorId!==void 0){const n=this._extHostNotebooks.getEditorById(_.notebookEditorId);return{notebookUri:a.URI.revive(_.notebookUri),inputUri:a.URI.revive(_.inputUri),notebookEditor:n.apiEditor}}return{notebookUri:a.URI.revive(_.notebookUri),inputUri:a.URI.revive(_.inputUri)}}));this._commands.registerApiCommand(F)}$willAddInteractiveDocument(k,I,S,R){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:I,lines:[""],languageId:S,uri:k,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(a.URI.revive(R))?.apiNotebook}]})}$willRemoveInteractiveDocument(k,I){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[k]})}}e.ExtHostInteractive=w}),define(Ee[188],ye([0,1,6,5]),function(re,e,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class w{constructor(k){this._handlePool=0,this._proxy=k.getProxy(t.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(k){const I=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(I,k),(0,a.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(I)})}}e.ExtHostLabelService=w}),define(Ee[189],ye([0,1,2,26,8,7,5,9,59,16,11,229,6,79,53,63,190,15,4]),function(re,e,a,t,w,T,k,I,S,R,F,_,n,f,o,m,c,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class h{constructor($,K){this._documents=$,this._provider=K}async provideDocumentSymbols($,K){const J=this._documents.getDocument($),ae=await this._provider.provideDocumentSymbols(J,K);if(!(0,R.isFalsyOrEmpty)(ae))return ae[0]instanceof T.DocumentSymbol?ae.map(w.DocumentSymbol.from):h._asDocumentSymbolTree(ae)}static _asDocumentSymbolTree($){$=$.slice(0).sort((ae,q)=>{let te=ae.location.range.start.compareTo(q.location.range.start);return te===0&&(te=q.location.range.end.compareTo(ae.location.range.end)),te});const K=[],J=[];for(const ae of $){const q={name:ae.name||"!!MISSING: name!!",kind:w.SymbolKind.from(ae.kind),tags:ae.tags?.map(w.SymbolTag.from)||[],detail:"",containerName:ae.containerName,range:w.Range.from(ae.location.range),selectionRange:w.Range.from(ae.location.range),children:[]};for(;;){if(J.length===0){J.push(q),K.push(q);break}const te=J[J.length-1];if(S.Range.containsRange(te.range,q.range)&&!S.Range.equalsRange(te.range,q.range)){te.children&&te.children.push(q),J.push(q);break}J.pop()}}return K}}class g{constructor($,K,J){this._documents=$,this._commands=K,this._provider=J,this._cache=new m.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses($,K){const J=this._documents.getDocument($),ae=await this._provider.provideCodeLenses(J,K);if(!ae||K.isCancellationRequested)return;const q=this._cache.add(ae),te=new n.DisposableStore;this._disposables.set(q,te);const me={cacheId:q,lenses:[]};for(let Pe=0;Pe<ae.length;Pe++)me.lenses.push({cacheId:[q,Pe],range:w.Range.from(ae[Pe].range),command:this._commands.toInternal(ae[Pe].command,te)});return me}async resolveCodeLens($,K){const J=$.cacheId&&this._cache.get(...$.cacheId);if(!J)return;let ae;if(typeof this._provider.resolveCodeLens!="function"||J.isResolved?ae=J:ae=await this._provider.resolveCodeLens(J,K),ae||(ae=J),K.isCancellationRequested)return;const q=$.cacheId&&this._disposables.get($.cacheId[0]);if(!!q)return $.command=this._commands.toInternal(ae.command??g._badCmd,q),$}releaseCodeLenses($){this._disposables.get($)?.dispose(),this._disposables.delete($),this._cache.delete($)}}g._badCmd={command:"missing",title:"!!MISSING: command!!"};function P(Xe){return Array.isArray(Xe)?Xe.map(w.DefinitionLink.from):Xe?[w.DefinitionLink.from(Xe)]:[]}class l{constructor($,K){this._documents=$,this._provider=K}async provideDefinition($,K,J){const ae=this._documents.getDocument($),q=w.Position.to(K),te=await this._provider.provideDefinition(ae,q,J);return P(te)}}class M{constructor($,K){this._documents=$,this._provider=K}async provideDeclaration($,K,J){const ae=this._documents.getDocument($),q=w.Position.to(K),te=await this._provider.provideDeclaration(ae,q,J);return P(te)}}class r{constructor($,K){this._documents=$,this._provider=K}async provideImplementation($,K,J){const ae=this._documents.getDocument($),q=w.Position.to(K),te=await this._provider.provideImplementation(ae,q,J);return P(te)}}class i{constructor($,K){this._documents=$,this._provider=K}async provideTypeDefinition($,K,J){const ae=this._documents.getDocument($),q=w.Position.to(K),te=await this._provider.provideTypeDefinition(ae,q,J);return P(te)}}class p{constructor($,K){this._documents=$,this._provider=K}async provideHover($,K,J){const ae=this._documents.getDocument($),q=w.Position.to(K),te=await this._provider.provideHover(ae,q,J);if(!(!te||(0,R.isFalsyOrEmpty)(te.contents)))return te.range||(te.range=ae.getWordRangeAtPosition(q)),te.range||(te.range=new T.Range(q,q)),w.Hover.from(te)}}class d{constructor($,K){this._documents=$,this._provider=K}async provideEvaluatableExpression($,K,J){const ae=this._documents.getDocument($),q=w.Position.to(K),te=await this._provider.provideEvaluatableExpression(ae,q,J);if(te)return w.EvaluatableExpression.from(te)}}class s{constructor($,K){this._documents=$,this._provider=K}async provideInlineValues($,K,J,ae){const q=this._documents.getDocument($),te=await this._provider.provideInlineValues(q,w.Range.to(K),w.InlineValueContext.to(J),ae);if(Array.isArray(te))return te.map(me=>w.InlineValue.from(me))}}class v{constructor($,K){this._documents=$,this._provider=K}async provideDocumentHighlights($,K,J){const ae=this._documents.getDocument($),q=w.Position.to(K),te=await this._provider.provideDocumentHighlights(ae,q,J);if(Array.isArray(te))return te.map(w.DocumentHighlight.from)}}class y{constructor($,K){this._documents=$,this._provider=K}async provideLinkedEditingRanges($,K,J){const ae=this._documents.getDocument($),q=w.Position.to(K),te=await this._provider.provideLinkedEditingRanges(ae,q,J);if(te&&Array.isArray(te.ranges))return{ranges:(0,R.coalesce)(te.ranges.map(w.Range.from)),wordPattern:te.wordPattern}}}class u{constructor($,K){this._documents=$,this._provider=K}async provideReferences($,K,J,ae){const q=this._documents.getDocument($),te=w.Position.to(K),me=await this._provider.provideReferences(q,te,J,ae);if(Array.isArray(me))return me.map(w.location.from)}}class D{constructor($,K,J,ae,q,te,me){this._documents=$,this._commands=K,this._diagnostics=J,this._provider=ae,this._logService=q,this._extension=te,this._apiDeprecation=me,this._cache=new m.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions($,K,J,ae){const q=this._documents.getDocument($),te=_.Selection.isISelection(K)?w.Selection.to(K):w.Range.to(K),me=[];for(const st of this._diagnostics.getDiagnostics($))if(te.intersection(st.range)&&me.push(st)>D._maxCodeActionsPerFile)break;const Pe={diagnostics:me,only:J.only?new T.CodeActionKind(J.only):void 0,triggerKind:w.CodeActionTriggerKind.to(J.trigger)},Ne=await this._provider.provideCodeActions(q,te,Pe,ae);if(!(0,R.isNonEmptyArray)(Ne)||ae.isCancellationRequested)return;const He=this._cache.add(Ne),Ye=new n.DisposableStore;this._disposables.set(He,Ye);const et=[];for(let st=0;st<Ne.length;st++){const Je=Ne[st];!Je||(D._isCommand(Je)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),et.push({_isSynthetic:!0,title:Je.title,command:this._commands.toInternal(Je,Ye)})):(Pe.only&&(Je.kind?Pe.only.contains(Je.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Pe.only.value} 'requested but returned code action is of kind '${Je.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Pe.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),et.push({cacheId:[He,st],title:Je.title,command:Je.command&&this._commands.toInternal(Je.command,Ye),diagnostics:Je.diagnostics&&Je.diagnostics.map(w.Diagnostic.from),edit:Je.edit&&w.WorkspaceEdit.from(Je.edit),kind:Je.kind&&Je.kind.value,isPreferred:Je.isPreferred,disabled:Je.disabled?.reason})))}return{cacheId:He,actions:et}}async resolveCodeAction($,K){const[J,ae]=$,q=this._cache.get(J,ae);if(!q||D._isCommand(q)||!this._provider.resolveCodeAction)return;const te=await this._provider.resolveCodeAction(q,K)??q;return te?.edit?w.WorkspaceEdit.from(te.edit):void 0}releaseCodeActions($){this._disposables.get($)?.dispose(),this._disposables.delete($),this._cache.delete($)}static _isCommand($){return typeof $.command=="string"&&typeof $.title=="string"}}D._maxCodeActionsPerFile=1e3;class A{constructor($,K){this._documents=$,this._provider=K}async provideDocumentFormattingEdits($,K,J){const ae=this._documents.getDocument($),q=await this._provider.provideDocumentFormattingEdits(ae,K,J);if(Array.isArray(q))return q.map(w.TextEdit.from)}}class U{constructor($,K){this._documents=$,this._provider=K}async provideDocumentRangeFormattingEdits($,K,J,ae){const q=this._documents.getDocument($),te=w.Range.to(K),me=await this._provider.provideDocumentRangeFormattingEdits(q,te,J,ae);if(Array.isArray(me))return me.map(w.TextEdit.from)}}class B{constructor($,K){this._documents=$,this._provider=K,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits($,K,J,ae,q){const te=this._documents.getDocument($),me=w.Position.to(K),Pe=await this._provider.provideOnTypeFormattingEdits(te,me,J,ae,q);if(Array.isArray(Pe))return Pe.map(w.TextEdit.from)}}class E{constructor($,K){this._provider=$,this._logService=K,this._symbolCache=new Map,this._resultCache=new Map}async provideWorkspaceSymbols($,K){const J=k.IdObject.mixin({symbols:[]}),ae=await this._provider.provideWorkspaceSymbols($,K);if((0,R.isNonEmptyArray)(ae))for(const q of ae){if(!q)continue;if(!q.name){this._logService.warn("INVALID SymbolInformation, lacks name",q);continue}const te=k.IdObject.mixin(w.WorkspaceSymbol.from(q));this._symbolCache.set(te._id,q),J.symbols.push(te)}return J.symbols.length>0&&this._resultCache.set(J._id,[J.symbols[0]._id,J.symbols[J.symbols.length-1]._id]),J}async resolveWorkspaceSymbol($,K){if(typeof this._provider.resolveWorkspaceSymbol!="function")return $;const J=this._symbolCache.get($._id);if(J){const ae=await this._provider.resolveWorkspaceSymbol(J,K);return ae&&(0,t.mixin)($,w.WorkspaceSymbol.from(ae),!0)}}releaseWorkspaceSymbols($){const K=this._resultCache.get($);if(K){for(let[J,ae]=K;J<=ae;J++)this._symbolCache.delete(J);this._resultCache.delete($)}}}class N{constructor($,K,J){this._documents=$,this._provider=K,this._logService=J}static supportsResolving($){return typeof $.prepareRename=="function"}async provideRenameEdits($,K,J,ae){const q=this._documents.getDocument($),te=w.Position.to(K);try{const me=await this._provider.provideRenameEdits(q,te,J,ae);return me?w.WorkspaceEdit.from(me):void 0}catch(me){const Pe=N._asMessage(me);return Pe?{rejectReason:Pe,edits:void 0}:Promise.reject(me)}}async resolveRenameLocation($,K,J){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const ae=this._documents.getDocument($),q=w.Position.to(K);try{const te=await this._provider.prepareRename(ae,q,J);let me,Pe;if(T.Range.isRange(te)?(me=te,Pe=ae.getText(te)):(0,F.isObject)(te)&&(me=te.range,Pe=te.placeholder),!me||!Pe)return;if(me.start.line>q.line||me.end.line<q.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:w.Range.from(me),text:Pe}}catch(te){const me=N._asMessage(te);return me?{rejectReason:me,range:void 0,text:void 0}:Promise.reject(te)}}static _asMessage($){return typeof $=="string"?$:$ instanceof Error&&typeof $.message=="string"?$.message:void 0}}class L{constructor($,K){this.resultId=$,this.tokens=K}}class z{constructor($,K){this._documents=$,this._provider=K,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens($,K,J){const ae=this._documents.getDocument($),q=K!==0?this._previousResults.get(K):null;let te=typeof q?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(ae,q.resultId,J):await this._provider.provideDocumentSemanticTokens(ae,J);return q&&this._previousResults.delete(K),te?(te=z._fixProvidedSemanticTokens(te),this._send(z._convertToEdits(q,te),te)):null}async releaseDocumentSemanticColoring($){this._previousResults.delete($)}static _fixProvidedSemanticTokens($){return z._isSemanticTokens($)?z._isCorrectSemanticTokens($)?$:new T.SemanticTokens(new Uint32Array($.data),$.resultId):z._isSemanticTokensEdits($)?z._isCorrectSemanticTokensEdits($)?$:new T.SemanticTokensEdits($.edits.map(K=>new T.SemanticTokensEdit(K.start,K.deleteCount,K.data?new Uint32Array(K.data):K.data)),$.resultId):$}static _isSemanticTokens($){return $&&!!$.data}static _isCorrectSemanticTokens($){return $.data instanceof Uint32Array}static _isSemanticTokensEdits($){return $&&Array.isArray($.edits)}static _isCorrectSemanticTokensEdits($){for(const K of $.edits)if(!(K.data instanceof Uint32Array))return!1;return!0}static _convertToEdits($,K){if(!z._isSemanticTokens(K)||!$||!$.tokens)return K;const J=$.tokens,ae=J.length,q=K.data,te=q.length;let me=0;const Pe=Math.min(ae,te);for(;me<Pe&&J[me]===q[me];)me++;if(me===ae&&me===te)return new T.SemanticTokensEdits([],K.resultId);let Ne=0;const He=Pe-me;for(;Ne<He&&J[ae-Ne-1]===q[te-Ne-1];)Ne++;return new T.SemanticTokensEdits([{start:me,deleteCount:ae-me-Ne,data:q.subarray(me,te-Ne)}],K.resultId)}_send($,K){if(z._isSemanticTokens($)){const J=this._nextResultId++;return this._previousResults.set(J,new L($.resultId,$.data)),(0,f.encodeSemanticTokensDto)({id:J,type:"full",data:$.data})}if(z._isSemanticTokensEdits($)){const J=this._nextResultId++;return z._isSemanticTokens(K)?this._previousResults.set(J,new L(K.resultId,K.data)):this._previousResults.set(J,new L($.resultId)),(0,f.encodeSemanticTokensDto)({id:J,type:"delta",deltas:($.edits||[]).map(ae=>({start:ae.start,deleteCount:ae.deleteCount,data:ae.data}))})}return null}}e.DocumentSemanticTokensAdapter=z;class H{constructor($,K){this._documents=$,this._provider=K}async provideDocumentRangeSemanticTokens($,K,J){const ae=this._documents.getDocument($),q=await this._provider.provideDocumentRangeSemanticTokens(ae,w.Range.to(K),J);return q?this._send(q):null}_send($){return(0,f.encodeSemanticTokensDto)({id:0,type:"full",data:$.data})}}e.DocumentRangeSemanticTokensAdapter=H;class j{constructor($,K,J,ae,q){this._documents=$,this._commands=K,this._provider=J,this._apiDeprecation=ae,this._extension=q,this._cache=new m.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving($){return typeof $.resolveCompletionItem=="function"}async provideCompletionItems($,K,J,ae){const q=this._documents.getDocument($),te=w.Position.to(K),me=q.getWordRangeAtPosition(te)||new T.Range(te,te),Pe=me.with({end:te}),Ne=new c.StopWatch(!0),He=await this._provider.provideCompletionItems(q,te,ae,w.CompletionContext.to(J));if(!He||ae.isCancellationRequested)return;const Ye=Array.isArray(He)?new T.CompletionList(He):He,et=j.supportsResolving(this._provider)?this._cache.add(Ye.items):this._cache.add([]),st=new n.DisposableStore;this._disposables.set(et,st);const Je=[],nt={x:et,b:Je,a:{replace:w.Range.from(me),insert:w.Range.from(Pe)},c:Ye.isIncomplete||void 0,d:Ne.elapsed()};for(let lt=0;lt<Ye.items.length;lt++){const pt=Ye.items[lt],Ft=this._convertCompletionItem(pt,[et,lt],Pe,me);Je.push(Ft)}return nt}async resolveCompletionItem($,K){if(typeof this._provider.resolveCompletionItem!="function")return;const J=this._cache.get(...$);if(!J)return;const ae=await this._provider.resolveCompletionItem(J,K);if(!!ae)return this._convertCompletionItem(ae,$)}releaseCompletionItems($){this._disposables.get($)?.dispose(),this._disposables.delete($),this._cache.delete($)}_convertCompletionItem($,K,J,ae){const q=this._disposables.get(K[0]);if(!q)throw Error("DisposableStore is missing...");const te={x:K,a:$.label,b:$.kind!==void 0?w.CompletionItemKind.from($.kind):void 0,n:$.tags&&$.tags.map(w.CompletionItemTag.from),c:$.detail,d:typeof $.documentation=="undefined"?void 0:w.MarkdownString.fromStrict($.documentation),e:$.sortText!==$.label?$.sortText:void 0,f:$.filterText!==$.label?$.filterText:void 0,g:$.preselect||void 0,i:$.keepWhitespace?1:0,k:$.commitCharacters,l:$.additionalTextEdits&&$.additionalTextEdits.map(w.TextEdit.from),m:this._commands.toInternal($.command,q)};$.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),te.h=$.textEdit.newText):typeof $.insertText=="string"?te.h=$.insertText:$.insertText instanceof T.SnippetString&&(te.h=$.insertText.value,te.i|=4);let me;return $.textEdit?me=$.textEdit.range:$.range&&(me=$.range),T.Range.isRange(me)?te.j=w.Range.from(me):me&&(!J?.isEqual(me.inserting)||!ae?.isEqual(me.replacing))&&(te.j={insert:w.Range.from(me.inserting),replace:w.Range.from(me.replacing)}),te}}class ue{constructor($,K,J){this._documents=$,this._provider=K,this._commands=J,this._cache=new m.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions($,K,J,ae){const q=this._documents.getDocument($),te=w.Position.to(K),me=await this._provider.provideInlineCompletionItems(q,te,{selectedCompletionInfo:J.selectedSuggestionInfo?{range:w.Range.to(J.selectedSuggestionInfo.range),text:J.selectedSuggestionInfo.text,isSnippetText:J.selectedSuggestionInfo.isSnippetText,completionKind:w.CompletionItemKind.to(J.selectedSuggestionInfo.completionKind)}:void 0,triggerKind:J.triggerKind},ae);if(!me||ae.isCancellationRequested)return;const Pe=(0,F.isArray)(me)?{items:me}:me,Ne=this._cache.add(Pe.items);let He;return{pid:Ne,items:Pe.items.map((Ye,et)=>{let st;return Ye.command&&(He||(He=new n.DisposableStore,this._disposables.set(Ne,He)),st=this._commands.toInternal(Ye.command,He)),{text:Ye.text,range:Ye.range?w.Range.from(Ye.range):void 0,command:st,idx:et}})}}disposeCompletions($){this._cache.delete($);const K=this._disposables.get($);K&&K.clear(),this._disposables.delete($)}handleDidShowCompletionItem($,K){const J=this._cache.get($,K);J&&G.get(this._provider).fireOnDidShowCompletionItem({completionItem:J})}}class G{constructor(){this._onDidShowCompletionItemEmitter=new b.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get($){let K=G.map.get($);return K||(K=new G,G.map.set($,K)),K}fireOnDidShowCompletionItem($){this._onDidShowCompletionItemEmitter.fire($)}}e.InlineCompletionController=G,G.map=new WeakMap;class le{constructor($,K){this._documents=$,this._provider=K,this._cache=new m.Cache("SignatureHelp")}async provideSignatureHelp($,K,J,ae){const q=this._documents.getDocument($),te=w.Position.to(K),me=this.reviveContext(J),Pe=await this._provider.provideSignatureHelp(q,te,ae,me);if(Pe){const Ne=this._cache.add([Pe]);return{...w.SignatureHelp.from(Pe),id:Ne}}}reviveContext($){let K;if($.activeSignatureHelp){const J=w.SignatureHelp.to($.activeSignatureHelp),ae=this._cache.get($.activeSignatureHelp.id,0);ae?(K=ae,K.activeSignature=J.activeSignature,K.activeParameter=J.activeParameter):K=J}return{...$,activeSignatureHelp:K}}releaseSignatureHelp($){this._cache.delete($)}}class ce{constructor($,K){this._documents=$,this._provider=K}async provideInlayHints($,K,J){const ae=this._documents.getDocument($),q=await this._provider.provideInlayHints(ae,w.Range.to(K),J);return q?{hints:q.map(w.InlayHint.from)}:void 0}}class Y{constructor($,K){this._documents=$,this._provider=K,this._cache=new m.Cache("DocumentLink")}async provideLinks($,K){const J=this._documents.getDocument($),ae=await this._provider.provideDocumentLinks(J,K);if(!(!Array.isArray(ae)||ae.length===0)&&!K.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:ae.filter(Y._validateLink).map(w.DocumentLink.from)};{const q=this._cache.add(ae),te={links:[],id:q};for(let me=0;me<ae.length;me++){if(!Y._validateLink(ae[me]))continue;const Pe=w.DocumentLink.from(ae[me]);Pe.cacheId=[q,me],te.links.push(Pe)}return te}}}static _validateLink($){return $.target&&$.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink($,K){if(typeof this._provider.resolveDocumentLink!="function")return;const J=this._cache.get(...$);if(!J)return;const ae=await this._provider.resolveDocumentLink(J,K);if(!(!ae||!Y._validateLink(ae)))return w.DocumentLink.from(ae)}releaseLinks($){this._cache.delete($)}}class ie{constructor($,K){this._documents=$,this._provider=K}async provideColors($,K){const J=this._documents.getDocument($),ae=await this._provider.provideDocumentColors(J,K);return Array.isArray(ae)?ae.map(te=>({color:w.Color.from(te.color),range:w.Range.from(te.range)})):[]}async provideColorPresentations($,K,J){const ae=this._documents.getDocument($),q=w.Range.to(K.range),te=w.Color.to(K.color),me=await this._provider.provideColorPresentations(te,{document:ae,range:q},J);if(!!Array.isArray(me))return me.map(w.ColorPresentation.from)}}class we{constructor($,K){this._documents=$,this._provider=K}async provideFoldingRanges($,K,J){const ae=this._documents.getDocument($),q=await this._provider.provideFoldingRanges(ae,K,J);if(!!Array.isArray(q))return q.map(w.FoldingRange.from)}}class Me{constructor($,K,J){this._documents=$,this._provider=K,this._logService=J}async provideSelectionRanges($,K,J){const ae=this._documents.getDocument($),q=K.map(w.Position.to),te=await this._provider.provideSelectionRanges(ae,q,J);if(!(0,R.isNonEmptyArray)(te))return[];if(te.length!==q.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const me=[];for(let Pe=0;Pe<q.length;Pe++){const Ne=[];me.push(Ne);let He=q[Pe],Ye=te[Pe];for(;;){if(!Ye.range.contains(He))throw new Error("INVALID selection range, must contain the previous range");if(Ne.push(w.SelectionRange.from(Ye)),!Ye.parent)break;He=Ye.range,Ye=Ye.parent}}return me}}class Re{constructor($,K){this._documents=$,this._provider=K,this._idPool=new o.IdGenerator(""),this._cache=new Map}async prepareSession($,K,J){const ae=this._documents.getDocument($),q=w.Position.to(K),te=await this._provider.prepareCallHierarchy(ae,q,J);if(!te)return;const me=this._idPool.nextId();return this._cache.set(me,new Map),Array.isArray(te)?te.map(Pe=>this._cacheAndConvertItem(me,Pe)):[this._cacheAndConvertItem(me,te)]}async provideCallsTo($,K,J){const ae=this._itemFromCache($,K);if(!ae)throw new Error("missing call hierarchy item");const q=await this._provider.provideCallHierarchyIncomingCalls(ae,J);if(!!q)return q.map(te=>({from:this._cacheAndConvertItem($,te.from),fromRanges:te.fromRanges.map(me=>w.Range.from(me))}))}async provideCallsFrom($,K,J){const ae=this._itemFromCache($,K);if(!ae)throw new Error("missing call hierarchy item");const q=await this._provider.provideCallHierarchyOutgoingCalls(ae,J);if(!!q)return q.map(te=>({to:this._cacheAndConvertItem($,te.to),fromRanges:te.fromRanges.map(me=>w.Range.from(me))}))}releaseSession($){this._cache.delete($)}_cacheAndConvertItem($,K){const J=this._cache.get($),ae=w.CallHierarchyItem.from(K,$,J.size.toString(36));return J.set(ae._itemId,K),ae}_itemFromCache($,K){return this._cache.get($)?.get(K)}}class Be{constructor($,K){this._documents=$,this._provider=K,this._idPool=new o.IdGenerator(""),this._cache=new Map}async prepareSession($,K,J){const ae=this._documents.getDocument($),q=w.Position.to(K),te=await this._provider.prepareTypeHierarchy(ae,q,J);if(!te)return;const me=this._idPool.nextId();return this._cache.set(me,new Map),Array.isArray(te)?te.map(Pe=>this._cacheAndConvertItem(me,Pe)):[this._cacheAndConvertItem(me,te)]}async provideSupertypes($,K,J){const ae=this._itemFromCache($,K);if(!ae)throw new Error("missing type hierarchy item");const q=await this._provider.provideTypeHierarchySupertypes(ae,J);if(!!q)return q.map(te=>this._cacheAndConvertItem($,te))}async provideSubtypes($,K,J){const ae=this._itemFromCache($,K);if(!ae)throw new Error("missing type hierarchy item");const q=await this._provider.provideTypeHierarchySubtypes(ae,J);if(!!q)return q.map(te=>this._cacheAndConvertItem($,te))}releaseSession($){this._cache.delete($)}_cacheAndConvertItem($,K){const J=this._cache.get($),ae=w.TypeHierarchyItem.from(K,$,J.size.toString(36));return J.set(ae._itemId,K),ae}_itemFromCache($,K){return this._cache.get($)?.get(K)}}class Qe{constructor($,K){this.adapter=$,this.extension=K}}class Ke{constructor($,K,J,ae,q,te,me){this._adapter=new Map,this._uriTransformer=K,this._proxy=$.getProxy(k.MainContext.MainThreadLanguageFeatures),this._documents=J,this._commands=ae,this._diagnostics=q,this._logService=te,this._apiDeprecation=me}_transformDocumentSelector($){return w.DocumentSelector.from($,this._uriTransformer)}_createDisposable($){return new T.Disposable(()=>{this._adapter.delete($),this._proxy.$unregister($)})}_nextHandle(){return Ke._handlePool++}_withAdapter($,K,J,ae,q=!1){const te=this._adapter.get($);if(!te)return Promise.resolve(ae);if(te.adapter instanceof K){let me;te.extension&&(me=Date.now(),this._logService.trace(`[${te.extension.identifier.value}] INVOKE provider '${K.name}'`));const Pe=J(te.adapter,te.extension),Ne=te.extension;return Ne&&Promise.resolve(Pe).then(()=>this._logService.trace(`[${Ne.identifier.value}] provider DONE after ${Date.now()-me}ms`),He=>{q&&He instanceof C.CancellationError||(this._logService.error(`[${Ne.identifier.value}] provider FAILED`),this._logService.error(He))}),Pe}return Promise.reject(new Error("no adapter found"))}_addNewAdapter($,K){const J=this._nextHandle();return this._adapter.set(J,new Qe($,K)),J}static _extLabel($){return $.displayName||$.name}registerDocumentSymbolProvider($,K,J,ae){const q=this._addNewAdapter(new h(this._documents,J),$),te=ae&&ae.label||Ke._extLabel($);return this._proxy.$registerDocumentSymbolProvider(q,this._transformDocumentSelector(K),te),this._createDisposable(q)}$provideDocumentSymbols($,K,J){return this._withAdapter($,h,ae=>ae.provideDocumentSymbols(a.URI.revive(K),J),void 0)}registerCodeLensProvider($,K,J){const ae=this._nextHandle(),q=typeof J.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(ae,new Qe(new g(this._documents,this._commands.converter,J),$)),this._proxy.$registerCodeLensSupport(ae,this._transformDocumentSelector(K),q);let te=this._createDisposable(ae);if(q!==void 0){const me=J.onDidChangeCodeLenses(Pe=>this._proxy.$emitCodeLensEvent(q));te=T.Disposable.from(te,me)}return te}$provideCodeLenses($,K,J){return this._withAdapter($,g,ae=>ae.provideCodeLenses(a.URI.revive(K),J),void 0)}$resolveCodeLens($,K,J){return this._withAdapter($,g,ae=>ae.resolveCodeLens(K,J),void 0)}$releaseCodeLenses($,K){this._withAdapter($,g,J=>Promise.resolve(J.releaseCodeLenses(K)),void 0)}registerDefinitionProvider($,K,J){const ae=this._addNewAdapter(new l(this._documents,J),$);return this._proxy.$registerDefinitionSupport(ae,this._transformDocumentSelector(K)),this._createDisposable(ae)}$provideDefinition($,K,J,ae){return this._withAdapter($,l,q=>q.provideDefinition(a.URI.revive(K),J,ae),[])}registerDeclarationProvider($,K,J){const ae=this._addNewAdapter(new M(this._documents,J),$);return this._proxy.$registerDeclarationSupport(ae,this._transformDocumentSelector(K)),this._createDisposable(ae)}$provideDeclaration($,K,J,ae){return this._withAdapter($,M,q=>q.provideDeclaration(a.URI.revive(K),J,ae),[])}registerImplementationProvider($,K,J){const ae=this._addNewAdapter(new r(this._documents,J),$);return this._proxy.$registerImplementationSupport(ae,this._transformDocumentSelector(K)),this._createDisposable(ae)}$provideImplementation($,K,J,ae){return this._withAdapter($,r,q=>q.provideImplementation(a.URI.revive(K),J,ae),[])}registerTypeDefinitionProvider($,K,J){const ae=this._addNewAdapter(new i(this._documents,J),$);return this._proxy.$registerTypeDefinitionSupport(ae,this._transformDocumentSelector(K)),this._createDisposable(ae)}$provideTypeDefinition($,K,J,ae){return this._withAdapter($,i,q=>q.provideTypeDefinition(a.URI.revive(K),J,ae),[])}registerHoverProvider($,K,J,ae){const q=this._addNewAdapter(new p(this._documents,J),$);return this._proxy.$registerHoverProvider(q,this._transformDocumentSelector(K)),this._createDisposable(q)}$provideHover($,K,J,ae){return this._withAdapter($,p,q=>q.provideHover(a.URI.revive(K),J,ae),void 0)}registerEvaluatableExpressionProvider($,K,J,ae){const q=this._addNewAdapter(new d(this._documents,J),$);return this._proxy.$registerEvaluatableExpressionProvider(q,this._transformDocumentSelector(K)),this._createDisposable(q)}$provideEvaluatableExpression($,K,J,ae){return this._withAdapter($,d,q=>q.provideEvaluatableExpression(a.URI.revive(K),J,ae),void 0)}registerInlineValuesProvider($,K,J,ae){const q=typeof J.onDidChangeInlineValues=="function"?this._nextHandle():void 0,te=this._addNewAdapter(new s(this._documents,J),$);this._proxy.$registerInlineValuesProvider(te,this._transformDocumentSelector(K),q);let me=this._createDisposable(te);if(q!==void 0){const Pe=J.onDidChangeInlineValues(Ne=>this._proxy.$emitInlineValuesEvent(q));me=T.Disposable.from(me,Pe)}return me}$provideInlineValues($,K,J,ae,q){return this._withAdapter($,s,te=>te.provideInlineValues(a.URI.revive(K),J,ae,q),void 0)}registerDocumentHighlightProvider($,K,J){const ae=this._addNewAdapter(new v(this._documents,J),$);return this._proxy.$registerDocumentHighlightProvider(ae,this._transformDocumentSelector(K)),this._createDisposable(ae)}$provideDocumentHighlights($,K,J,ae){return this._withAdapter($,v,q=>q.provideDocumentHighlights(a.URI.revive(K),J,ae),void 0)}registerLinkedEditingRangeProvider($,K,J){const ae=this._addNewAdapter(new y(this._documents,J),$);return this._proxy.$registerLinkedEditingRangeProvider(ae,this._transformDocumentSelector(K)),this._createDisposable(ae)}$provideLinkedEditingRanges($,K,J,ae){return this._withAdapter($,y,async q=>{const te=await q.provideLinkedEditingRanges(a.URI.revive(K),J,ae);if(te)return{ranges:te.ranges,wordPattern:te.wordPattern?Ke._serializeRegExp(te.wordPattern):void 0}},void 0)}registerReferenceProvider($,K,J){const ae=this._addNewAdapter(new u(this._documents,J),$);return this._proxy.$registerReferenceSupport(ae,this._transformDocumentSelector(K)),this._createDisposable(ae)}$provideReferences($,K,J,ae,q){return this._withAdapter($,u,te=>te.provideReferences(a.URI.revive(K),J,ae,q),void 0)}registerCodeActionProvider($,K,J,ae){const q=new n.DisposableStore,te=this._addNewAdapter(new D(this._documents,this._commands.converter,this._diagnostics,J,this._logService,$,this._apiDeprecation),$);return this._proxy.$registerQuickFixSupport(te,this._transformDocumentSelector(K),{providedKinds:ae?.providedCodeActionKinds?.map(me=>me.value),documentation:ae?.documentation?.map(me=>({kind:me.kind.value,command:this._commands.converter.toInternal(me.command,q)}))},Ke._extLabel($),Boolean(J.resolveCodeAction)),q.add(this._createDisposable(te)),q}$provideCodeActions($,K,J,ae,q){return this._withAdapter($,D,te=>te.provideCodeActions(a.URI.revive(K),J,ae,q),void 0)}$resolveCodeAction($,K,J){return this._withAdapter($,D,ae=>ae.resolveCodeAction(K,J),void 0)}$releaseCodeActions($,K){this._withAdapter($,D,J=>Promise.resolve(J.releaseCodeActions(K)),void 0)}registerDocumentFormattingEditProvider($,K,J){const ae=this._addNewAdapter(new A(this._documents,J),$);return this._proxy.$registerDocumentFormattingSupport(ae,this._transformDocumentSelector(K),$.identifier,$.displayName||$.name),this._createDisposable(ae)}$provideDocumentFormattingEdits($,K,J,ae){return this._withAdapter($,A,q=>q.provideDocumentFormattingEdits(a.URI.revive(K),J,ae),void 0)}registerDocumentRangeFormattingEditProvider($,K,J){const ae=this._addNewAdapter(new U(this._documents,J),$);return this._proxy.$registerRangeFormattingSupport(ae,this._transformDocumentSelector(K),$.identifier,$.displayName||$.name),this._createDisposable(ae)}$provideDocumentRangeFormattingEdits($,K,J,ae,q){return this._withAdapter($,U,te=>te.provideDocumentRangeFormattingEdits(a.URI.revive(K),J,ae,q),void 0)}registerOnTypeFormattingEditProvider($,K,J,ae){const q=this._addNewAdapter(new B(this._documents,J),$);return this._proxy.$registerOnTypeFormattingSupport(q,this._transformDocumentSelector(K),ae,$.identifier),this._createDisposable(q)}$provideOnTypeFormattingEdits($,K,J,ae,q,te){return this._withAdapter($,B,me=>me.provideOnTypeFormattingEdits(a.URI.revive(K),J,ae,q,te),void 0)}registerWorkspaceSymbolProvider($,K){const J=this._addNewAdapter(new E(K,this._logService),$);return this._proxy.$registerNavigateTypeSupport(J,typeof K.resolveWorkspaceSymbol=="function"),this._createDisposable(J)}$provideWorkspaceSymbols($,K,J){return this._withAdapter($,E,ae=>ae.provideWorkspaceSymbols(K,J),{symbols:[]})}$resolveWorkspaceSymbol($,K,J){return this._withAdapter($,E,ae=>ae.resolveWorkspaceSymbol(K,J),void 0)}$releaseWorkspaceSymbols($,K){this._withAdapter($,E,J=>J.releaseWorkspaceSymbols(K),void 0)}registerRenameProvider($,K,J){const ae=this._addNewAdapter(new N(this._documents,J,this._logService),$);return this._proxy.$registerRenameSupport(ae,this._transformDocumentSelector(K),N.supportsResolving(J)),this._createDisposable(ae)}$provideRenameEdits($,K,J,ae,q){return this._withAdapter($,N,te=>te.provideRenameEdits(a.URI.revive(K),J,ae,q),void 0)}$resolveRenameLocation($,K,J,ae){return this._withAdapter($,N,q=>q.resolveRenameLocation(a.URI.revive(K),J,ae),void 0)}registerDocumentSemanticTokensProvider($,K,J,ae){const q=this._nextHandle(),te=typeof J.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(q,new Qe(new z(this._documents,J),$)),this._proxy.$registerDocumentSemanticTokensProvider(q,this._transformDocumentSelector(K),ae,te);let me=this._createDisposable(q);if(te){const Pe=J.onDidChangeSemanticTokens(Ne=>this._proxy.$emitDocumentSemanticTokensEvent(te));me=T.Disposable.from(me,Pe)}return me}$provideDocumentSemanticTokens($,K,J,ae){return this._withAdapter($,z,q=>q.provideDocumentSemanticTokens(a.URI.revive(K),J,ae),null,!0)}$releaseDocumentSemanticTokens($,K){this._withAdapter($,z,J=>J.releaseDocumentSemanticColoring(K),void 0)}registerDocumentRangeSemanticTokensProvider($,K,J,ae){const q=this._addNewAdapter(new H(this._documents,J),$);return this._proxy.$registerDocumentRangeSemanticTokensProvider(q,this._transformDocumentSelector(K),ae),this._createDisposable(q)}$provideDocumentRangeSemanticTokens($,K,J,ae){return this._withAdapter($,H,q=>q.provideDocumentRangeSemanticTokens(a.URI.revive(K),J,ae),null,!0)}registerCompletionItemProvider($,K,J,ae){const q=this._addNewAdapter(new j(this._documents,this._commands.converter,J,this._apiDeprecation,$),$);return this._proxy.$registerSuggestSupport(q,this._transformDocumentSelector(K),ae,j.supportsResolving(J),`${$.identifier.value}(${ae.join("")})`),this._createDisposable(q)}$provideCompletionItems($,K,J,ae,q){return this._withAdapter($,j,te=>te.provideCompletionItems(a.URI.revive(K),J,ae,q),void 0)}$resolveCompletionItem($,K,J){return this._withAdapter($,j,ae=>ae.resolveCompletionItem(K,J),void 0)}$releaseCompletionItems($,K){this._withAdapter($,j,J=>J.releaseCompletionItems(K),void 0)}registerInlineCompletionsProvider($,K,J){const ae=this._addNewAdapter(new ue(this._documents,J,this._commands.converter),$);return this._proxy.$registerInlineCompletionsSupport(ae,this._transformDocumentSelector(K)),this._createDisposable(ae)}$provideInlineCompletions($,K,J,ae,q){return this._withAdapter($,ue,te=>te.provideInlineCompletions(a.URI.revive(K),J,ae,q),void 0)}$handleInlineCompletionDidShow($,K,J){this._withAdapter($,ue,async ae=>{ae.handleDidShowCompletionItem(K,J)},void 0)}$freeInlineCompletionsList($,K){this._withAdapter($,ue,async J=>{J.disposeCompletions(K)},void 0)}registerSignatureHelpProvider($,K,J,ae){const q=Array.isArray(ae)?{triggerCharacters:ae,retriggerCharacters:[]}:ae,te=this._addNewAdapter(new le(this._documents,J),$);return this._proxy.$registerSignatureHelpProvider(te,this._transformDocumentSelector(K),q),this._createDisposable(te)}$provideSignatureHelp($,K,J,ae,q){return this._withAdapter($,le,te=>te.provideSignatureHelp(a.URI.revive(K),J,ae,q),void 0)}$releaseSignatureHelp($,K){this._withAdapter($,le,J=>J.releaseSignatureHelp(K),void 0)}registerInlayHintsProvider($,K,J){const ae=typeof J.onDidChangeInlayHints=="function"?this._nextHandle():void 0,q=this._addNewAdapter(new ce(this._documents,J),$);this._proxy.$registerInlayHintsProvider(q,this._transformDocumentSelector(K),ae);let te=this._createDisposable(q);if(ae!==void 0){const me=J.onDidChangeInlayHints(Pe=>this._proxy.$emitInlayHintsEvent(ae));te=T.Disposable.from(te,me)}return te}$provideInlayHints($,K,J,ae){return this._withAdapter($,ce,q=>q.provideInlayHints(a.URI.revive(K),J,ae),void 0)}registerDocumentLinkProvider($,K,J){const ae=this._addNewAdapter(new Y(this._documents,J),$);return this._proxy.$registerDocumentLinkProvider(ae,this._transformDocumentSelector(K),typeof J.resolveDocumentLink=="function"),this._createDisposable(ae)}$provideDocumentLinks($,K,J){return this._withAdapter($,Y,ae=>ae.provideLinks(a.URI.revive(K),J),void 0)}$resolveDocumentLink($,K,J){return this._withAdapter($,Y,ae=>ae.resolveLink(K,J),void 0)}$releaseDocumentLinks($,K){this._withAdapter($,Y,J=>J.releaseLinks(K),void 0)}registerColorProvider($,K,J){const ae=this._addNewAdapter(new ie(this._documents,J),$);return this._proxy.$registerDocumentColorProvider(ae,this._transformDocumentSelector(K)),this._createDisposable(ae)}$provideDocumentColors($,K,J){return this._withAdapter($,ie,ae=>ae.provideColors(a.URI.revive(K),J),[])}$provideColorPresentations($,K,J,ae){return this._withAdapter($,ie,q=>q.provideColorPresentations(a.URI.revive(K),J,ae),void 0)}registerFoldingRangeProvider($,K,J){const ae=this._nextHandle(),q=typeof J.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(ae,new Qe(new we(this._documents,J),$)),this._proxy.$registerFoldingRangeProvider(ae,this._transformDocumentSelector(K),q);let te=this._createDisposable(ae);if(q!==void 0){const me=J.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(q));te=T.Disposable.from(te,me)}return te}$provideFoldingRanges($,K,J,ae){return this._withAdapter($,we,q=>q.provideFoldingRanges(a.URI.revive(K),J,ae),void 0)}registerSelectionRangeProvider($,K,J){const ae=this._addNewAdapter(new Me(this._documents,J,this._logService),$);return this._proxy.$registerSelectionRangeProvider(ae,this._transformDocumentSelector(K)),this._createDisposable(ae)}$provideSelectionRanges($,K,J,ae){return this._withAdapter($,Me,q=>q.provideSelectionRanges(a.URI.revive(K),J,ae),[])}registerCallHierarchyProvider($,K,J){const ae=this._addNewAdapter(new Re(this._documents,J),$);return this._proxy.$registerCallHierarchyProvider(ae,this._transformDocumentSelector(K)),this._createDisposable(ae)}$prepareCallHierarchy($,K,J,ae){return this._withAdapter($,Re,q=>Promise.resolve(q.prepareSession(a.URI.revive(K),J,ae)),void 0)}$provideCallHierarchyIncomingCalls($,K,J,ae){return this._withAdapter($,Re,q=>q.provideCallsTo(K,J,ae),void 0)}$provideCallHierarchyOutgoingCalls($,K,J,ae){return this._withAdapter($,Re,q=>q.provideCallsFrom(K,J,ae),void 0)}$releaseCallHierarchy($,K){this._withAdapter($,Re,J=>Promise.resolve(J.releaseSession(K)),void 0)}registerTypeHierarchyProvider($,K,J){const ae=this._addNewAdapter(new Be(this._documents,J),$);return this._proxy.$registerTypeHierarchyProvider(ae,this._transformDocumentSelector(K)),this._createDisposable(ae)}$prepareTypeHierarchy($,K,J,ae){return this._withAdapter($,Be,q=>Promise.resolve(q.prepareSession(a.URI.revive(K),J,ae)),void 0)}$provideTypeHierarchySupertypes($,K,J,ae){return this._withAdapter($,Be,q=>q.provideSupertypes(K,J,ae),void 0)}$provideTypeHierarchySubtypes($,K,J,ae){return this._withAdapter($,Be,q=>q.provideSubtypes(K,J,ae),void 0)}$releaseTypeHierarchy($,K){this._withAdapter($,Be,J=>Promise.resolve(J.releaseSession(K)),void 0)}static _serializeRegExp($){return{pattern:$.source,flags:(0,I.regExpFlags)($)}}static _serializeIndentationRule($){return{decreaseIndentPattern:Ke._serializeRegExp($.decreaseIndentPattern),increaseIndentPattern:Ke._serializeRegExp($.increaseIndentPattern),indentNextLinePattern:$.indentNextLinePattern?Ke._serializeRegExp($.indentNextLinePattern):void 0,unIndentedLinePattern:$.unIndentedLinePattern?Ke._serializeRegExp($.unIndentedLinePattern):void 0}}static _serializeOnEnterRule($){return{beforeText:Ke._serializeRegExp($.beforeText),afterText:$.afterText?Ke._serializeRegExp($.afterText):void 0,previousLineText:$.previousLineText?Ke._serializeRegExp($.previousLineText):void 0,action:$.action}}static _serializeOnEnterRules($){return $.map(Ke._serializeOnEnterRule)}setLanguageConfiguration($,K,J){let{wordPattern:ae}=J;if(ae&&(0,I.regExpLeadsToEndlessLoop)(ae))throw new Error(`Invalid language configuration: wordPattern '${ae}' is not allowed to match the empty string.`);ae?this._documents.setWordDefinitionFor(K,ae):this._documents.setWordDefinitionFor(K,void 0),J.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",$,"Do not use."),J.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",$,"Do not use.");const q=this._nextHandle(),te={comments:J.comments,brackets:J.brackets,wordPattern:J.wordPattern?Ke._serializeRegExp(J.wordPattern):void 0,indentationRules:J.indentationRules?Ke._serializeIndentationRule(J.indentationRules):void 0,onEnterRules:J.onEnterRules?Ke._serializeOnEnterRules(J.onEnterRules):void 0,__electricCharacterSupport:J.__electricCharacterSupport,__characterPairSupport:J.__characterPairSupport};return this._proxy.$setLanguageConfiguration(q,K,te),this._createDisposable(q)}$setWordDefinitions($){for(const K of $)this._documents.setWordDefinitionFor(K.languageId,new RegExp(K.regexSource,K.regexFlags))}}e.ExtHostLanguageFeatures=Ke,Ke._handlePool=0}),define(Ee[191],ye([0,1,5,8,7,34,14,6]),function(re,e,a,t,w,T,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class S{constructor(F,_,n,f){this._documents=_,this._commands=n,this._uriTransformer=f,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=F.getProxy(a.MainContext.MainThreadLanguages)}$acceptLanguageIds(F){this._languageIds=F}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(F,_){await this._proxy.$changeLanguage(F,_);const n=this._documents.getDocumentData(F);if(!n)throw new Error(`document '${F.toString}' NOT found`);return n.document}async tokenAtPosition(F,_){const n=F.version,f=t.Position.from(_),o=await this._proxy.$tokensAtPosition(F.uri,f),m={type:w.StandardTokenType.Other,range:F.getWordRangeAtPosition(_)??new w.Range(_.line,_.character,_.line,_.character)};if(!o)return m;const c={range:t.Range.to(o.range),type:t.TokenType.to(o.type)};return!c.range.contains(_)||n!==F.version?m:c}createLanguageStatusItem(F,_,n){const f=this._handlePool++,o=this._proxy,m=this._ids,c=`${F.identifier.value}/${_}`;if(m.has(c))throw new Error(`LanguageStatusItem with id '${_}' ALREADY exists`);m.add(c);const C={selector:n,id:_,name:F.displayName??F.name,severity:w.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let b,h=new I.DisposableStore;const g=()=>{b?.dispose(),b=(0,k.disposableTimeout)(()=>{h.clear(),this._proxy.$setLanguageStatus(f,{id:c,name:C.name??F.displayName??F.name,source:F.displayName??F.name,selector:t.DocumentSelector.from(C.selector,this._uriTransformer),label:C.text,detail:C.detail??"",severity:C.severity===w.LanguageStatusSeverity.Error?T.default.Error:C.severity===w.LanguageStatusSeverity.Warning?T.default.Warning:T.default.Info,command:C.command&&this._commands.toInternal(C.command,h),accessibilityInfo:C.accessibilityInformation,busy:C.busy})},0)},P={dispose(){h.dispose(),b?.dispose(),o.$removeLanguageStatus(f),m.delete(c)},get id(){return C.id},get name(){return C.name},set name(l){C.name=l,g()},get selector(){return C.selector},set selector(l){C.selector=l,g()},get text(){return C.text},set text(l){C.text=l,g()},get detail(){return C.detail},set detail(l){C.detail=l,g()},get severity(){return C.severity},set severity(l){C.severity=l,g()},get accessibilityInformation(){return C.accessibilityInformation},set accessibilityInformation(l){C.accessibilityInformation=l,g()},get command(){return C.command},set command(l){C.command=l,g()},get busy(){return C.busy},set busy(l){C.busy=l,g()}};return g(),P}}e.ExtHostLanguages=S}),define(Ee[192],ye([0,1,12,5,28,13,4]),function(re,e,a,t,w,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let I=class extends a.AbstractLoggerService{constructor(F,_){const n=new k.Emitter;super(_.logLevel,n.event);this._proxy=F.getProxy(t.MainContext.MainThreadLogger),this._onDidChangeLogLevel=this._register(n)}$setLevel(F){this._onDidChangeLogLevel.fire(F)}doCreateLogger(F,_,n){return new S(this._proxy,F,_,n)}};I=Ue([$e(0,T.IExtHostRpcService),$e(1,w.IExtHostInitDataService)],I),e.ExtHostLoggerService=I;class S extends a.AbstractMessageLogger{constructor(F,_,n,f){super(f?.always);this.proxy=F,this.file=_,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(n),this.proxy.$createLogger(_,f).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(F,_){const n=[[F,_]];this.isLoggerCreated?this.doLog(n):this.buffer.push(...n)}doLog(F){this.proxy.$log(this.file,F)}}}),define(Ee[193],ye([0,1,5,12,27]),function(re,e,a,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function T(I){return I&&I.title}let k=class{constructor(S,R){this._logService=R,this._proxy=S.getProxy(a.MainContext.MainThreadMessageService)}showMessage(S,R,F,_,n){const f={extension:S};let o;typeof _=="string"||T(_)?o=[_,...n]:(f.modal=_?.modal,f.useCustom=_?.useCustom,f.detail=_?.detail,o=n),f.useCustom&&(0,w.checkProposedApiEnabled)(S,"resolvers");const m=[];for(let c=0;c<o.length;c++){const C=o[c];if(typeof C=="string")m.push({title:C,handle:c,isCloseAffordance:!1});else if(typeof C=="object"){let{title:b,isCloseAffordance:h}=C;m.push({title:b,isCloseAffordance:!!h,handle:c})}else this._logService.warn("Invalid message item:",C)}return this._proxy.$showMessage(R,F,f,m).then(c=>{if(typeof c=="number")return o[c]})}};k=Ue([$e(1,t.ILogService)],k),e.ExtHostMessageService=k}),define(Ee[194],ye([0,1,22,4,57,6,21,9,11,2,63,5,8,7,37,167,91]),function(re,e,a,t,w,T,k,I,S,R,F,_,n,f,o,m,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class C{constructor(h,g,P,l,M){this._textDocumentsAndEditors=P,this._textDocuments=l,this._extensionStoragePaths=M,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new k.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new t.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new t.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new t.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new t.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new t.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new t.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new t.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new t.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new F.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=h.getProxy(_.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=h.getProxy(_.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=h.getProxy(_.MainContext.MainThreadNotebookEditors),this._commandsConverter=g.converter,g.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===12){const i=r.notebookEditor?.notebookUri,p=r.cell.handle,s=this._documents.get(i)?.getCell(p);if(s)return s.apiCell}return r}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(h=>h.apiEditor)}getEditorById(h){const g=this._editors.get(h);if(!g)throw new Error(`unknown text editor: ${h}. known editors: ${[...this._editors.keys()]} `);return g}getIdByEditor(h){for(const[g,P]of this._editors)if(P.apiEditor===h)return g}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(h,g){const P=this._documents.get(h);if(!P&&!g)throw new Error(`NO notebook document for '${h}'`);return P}_getProviderData(h){const g=this._notebookContentProviders.get(h);if(!g)throw new Error(`NO provider for '${h}'`);return g}registerNotebookContentProvider(h,g,P,l,M){if((0,I.isFalsyOrWhitespace)(g))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(g))throw new Error(`Notebook provider for '${g}' already registered`);this._notebookContentProviders.set(g,{extension:h,provider:P});let r;return P.onDidChangeNotebookContentOptions&&(r=P.onDidChangeNotebookContentOptions(()=>{const i=n.NotebookDocumentContentOptions.from(P.options);this._notebookProxy.$updateNotebookProviderOptions(g,i)})),this._notebookProxy.$registerNotebookProvider({id:h.identifier,location:h.extensionLocation},g,n.NotebookDocumentContentOptions.from(l),C._convertNotebookRegistrationData(h,M)),new f.Disposable(()=>{r?.dispose(),this._notebookContentProviders.delete(g),this._notebookProxy.$unregisterNotebookProvider(g)})}static _convertNotebookRegistrationData(h,g){if(!g)return;const P=g.filenamePattern.map(l=>n.NotebookExclusiveDocumentPattern.from(l)).filter(l=>l!==void 0);if(g.filenamePattern&&!P){console.warn(`Notebook content provider view options file name pattern is invalid ${g.filenamePattern}`);return}return{extension:h.identifier,providerDisplayName:h.displayName||h.name,displayName:g.displayName,filenamePattern:P,exclusive:g.exclusive||!1}}registerNotebookCellStatusBarItemProvider(h,g,P){const l=C._notebookStatusBarItemProviderHandlePool++,M=typeof P.onDidChangeCellStatusBarItems=="function"?C._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(l,P),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(l,M,g);let r;return M!==void 0&&(r=P.onDidChangeCellStatusBarItems(i=>this._notebookProxy.$emitCellStatusBarEvent(M))),new f.Disposable(()=>{this._notebookStatusBarItemProviders.delete(l),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(l,M),r&&r.dispose()})}async createNotebookDocument(h){const g=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:h.viewType,content:h.content&&n.NotebookData.from(h.content)});return R.URI.revive(g)}async openNotebookDocument(h){const g=this._documents.get(h);if(g)return g.apiNotebook;const P=await this._notebookDocumentsProxy.$tryOpenNotebook(h),l=this._documents.get(R.URI.revive(P));return(0,S.assertIsDefined)(l?.apiNotebook)}async showNotebookDocument(h,g){R.URI.isUri(h)&&(h=await this.openNotebookDocument(h));let P;typeof g=="object"?P={position:n.ViewColumn.from(g.viewColumn),preserveFocus:g.preserveFocus,selections:g.selections&&g.selections.map(n.NotebookRange.from),pinned:typeof g.preview=="boolean"?!g.preview:void 0}:P={preserveFocus:!1};const l=await this._notebookEditorsProxy.$tryShowNotebookDocument(h.uri,h.notebookType,P),M=l&&this._editors.get(l)?.apiEditor;if(M)return M;throw l?new Error(`Could NOT open editor for "${h.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${h.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(h,g,P,l){const M=this._notebookStatusBarItemProviders.get(h),r=R.URI.revive(g),i=this._documents.get(r);if(!i||!M)return;const p=i.getCellFromIndex(P);if(!p)return;const d=await M.provideCellStatusBarItems(p.apiCell,l);if(!d)return;const s=new T.DisposableStore,v=this._statusBarCache.add([s]),u=(Array.isArray(d)?d:[d]).map(D=>n.NotebookStatusBarItem.from(D,this._commandsConverter,s));return{cacheId:v,items:u}}$releaseNotebookCellStatusBarItems(h){this._statusBarCache.delete(h)}registerNotebookSerializer(h,g,P,l,M){if((0,I.isFalsyOrWhitespace)(g))throw new Error("viewType cannot be empty or just whitespace");const r=this._handlePool++;return this._notebookSerializer.set(r,P),this._notebookProxy.$registerNotebookSerializer(r,{id:h.identifier,location:h.extensionLocation},g,n.NotebookDocumentContentOptions.from(l),C._convertNotebookRegistrationData(h,M)),(0,T.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(r)})}async $dataToNotebook(h,g,P){const l=this._notebookSerializer.get(h);if(!l)throw new Error("NO serializer found");const M=await l.deserializeNotebook(g.buffer,P);return new o.SerializableObjectWithBuffers(n.NotebookData.from(M))}async $notebookToData(h,g,P){const l=this._notebookSerializer.get(h);if(!l)throw new Error("NO serializer found");const M=await l.serializeNotebook(n.NotebookData.to(g.value),P);return a.VSBuffer.wrap(M)}async $openNotebook(h,g,P,l,M){const{provider:r}=this._getProviderData(h),i=await r.openNotebook(R.URI.revive(g),{backupId:P,untitledDocumentData:l?.buffer},M);return new o.SerializableObjectWithBuffers({metadata:i.metadata??Object.create(null),cells:i.cells.map(n.NotebookCellData.from)})}async $saveNotebook(h,g,P){const l=this.getNotebookDocument(R.URI.revive(g)),{provider:M}=this._getProviderData(h);return await M.saveNotebook(l.apiNotebook,P),!0}async $saveNotebookAs(h,g,P,l){const M=this.getNotebookDocument(R.URI.revive(g)),{provider:r}=this._getProviderData(h);return await r.saveNotebookAs(R.URI.revive(P),M.apiNotebook,l),!0}async $backupNotebook(h,g,P){const l=this.getNotebookDocument(R.URI.revive(g)),M=this._getProviderData(h),r=this._extensionStoragePaths.workspaceValue(M.extension)??this._extensionStoragePaths.globalValue(M.extension),i=String((0,w.hash)([l.uri.toString(),this._backupIdPool++])),p=R.URI.joinPath(r,i),d=await M.provider.backupNotebook(l.apiNotebook,{destination:p},P);return l.updateBackup(d),d.id}_createExtHostEditor(h,g,P){if(this._editors.has(g))throw new Error(`editor with id ALREADY EXSIST: ${g}`);const l=new c.ExtHostNotebookEditor(g,this._notebookEditorsProxy,h,P.visibleRanges.map(n.NotebookRange.to),P.selections.map(n.NotebookRange.to),typeof P.viewColumn=="number"?n.ViewColumn.to(P.viewColumn):void 0);this._editors.set(g,l)}$acceptDocumentAndEditorsDelta(h){if(h.value.removedDocuments)for(const P of h.value.removedDocuments){const l=R.URI.revive(P),M=this._documents.get(l);M&&(M.dispose(),this._documents.delete(l),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:M.apiNotebook.getCells().map(r=>r.document.uri)}),this._onDidCloseNotebookDocument.fire(M.apiNotebook));for(const r of this._editors.values())r.notebookData.uri.toString()===l.toString()&&this._editors.delete(r.id)}if(h.value.addedDocuments){const P=[];for(const l of h.value.addedDocuments){const M=R.URI.revive(l.uri);if(this._documents.has(M))throw new Error(`adding EXISTING notebook ${M} `);const r=this,i=new m.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(p){r._onDidChangeNotebookCells.fire(p)},emitCellOutputsChange(p){r._onDidChangeCellOutputs.fire(p)},emitCellMetadataChange(p){r._onDidChangeCellMetadata.fire(p)},emitCellExecutionStateChange(p){r._onDidChangeCellExecutionState.fire(p)}},M,l);P.push(...l.cells.map(p=>m.ExtHostCell.asModelAddData(i.apiNotebook,p))),this._documents.get(M)?.dispose(),this._documents.set(M,i),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:P}),this._onDidOpenNotebookDocument.fire(i.apiNotebook)}}if(h.value.addedEditors)for(const P of h.value.addedEditors){if(this._editors.has(P.id))return;const l=R.URI.revive(P.documentUri),M=this._documents.get(l);M&&this._createExtHostEditor(M,P.id,P)}const g=[];if(h.value.removedEditors)for(const P of h.value.removedEditors){const l=this._editors.get(P);l&&(this._editors.delete(P),this._activeNotebookEditor?.id===l.id&&(this._activeNotebookEditor=void 0),g.push(l))}if(h.value.visibleEditors){this._visibleNotebookEditors=h.value.visibleEditors.map(l=>this._editors.get(l)).filter(l=>!!l);const P=new Set;this._visibleNotebookEditors.forEach(l=>P.add(l.id));for(const l of this._editors.values()){const M=P.has(l.id);l._acceptVisibility(M)}this._visibleNotebookEditors=[...this._editors.values()].map(l=>l).filter(l=>l.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}h.value.newActiveEditor===null?this._activeNotebookEditor=void 0:h.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(h.value.newActiveEditor)),h.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=C,C._notebookStatusBarItemProviderHandlePool=0}),define(Ee[195],ye([0,1,4,53,12,5,13,8]),function(re,e,a,t,w,T,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class S{constructor(_,n){const f=S._Keys.nextId();_.$registerNotebookEditorDecorationType(f,I.NotebookDecorationRenderOptions.from(n)),this.value={key:f,dispose(){_.$removeNotebookEditorDecorationType(f)}}}}S._Keys=new t.IdGenerator("NotebookEditorDecorationType");let R=class{constructor(_,n,f){this._logService=_,this._extHostRpc=n,this._notebooksAndEditors=f,this._onDidChangeNotebookEditorSelection=new a.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new a.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(_){return new S(this._extHostRpc.getProxy(T.MainContext.MainThreadNotebookEditors),_).value}$acceptEditorPropertiesChanged(_,n){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",_,n);const f=this._notebooksAndEditors.getEditorById(_);n.visibleRanges&&f._acceptVisibleRanges(n.visibleRanges.ranges.map(I.NotebookRange.to)),n.selections&&f._acceptSelections(n.selections.selections.map(I.NotebookRange.to)),n.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:f.apiEditor,visibleRanges:f.apiEditor.visibleRanges}),n.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:f.apiEditor,selections:f.apiEditor.selections}))}$acceptEditorViewColumns(_){for(const n in _)this._notebooksAndEditors.getEditorById(n)._acceptViewColumn(I.ViewColumn.to(_[n]))}};R=Ue([$e(0,w.ILogService),$e(1,k.IExtHostRpcService)],R),e.ExtHostNotebookEditors=R}),define(Ee[196],ye([0,1,16,14,20,4,6,21,2,25,12,5,38,8,7,66,159,27,37]),function(re,e,a,t,w,T,k,I,S,R,F,_,n,f,o,m,c,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let h=class{constructor(r,i,p,d,s){this._initData=i,this._extHostNotebook=p,this._commands=d,this._logService=s,this._activeExecutions=new I.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=r.getProxy(_.MainContext.MainThreadNotebookKernels);const v=new n.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new n.ApiCommandArgument("options","Select kernel options",y=>!0,y=>{if(y&&"notebookEditor"in y&&"id"in y){const u=this._extHostNotebook.getIdByEditor(y.notebookEditor);return{id:y.id,extension:y.extension,notebookEditorId:u}}else if(y&&"notebookEditor"in y){const u=this._extHostNotebook.getIdByEditor(y.notebookEditor);if(u===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${y.notebookEditor.document.uri.toString()}`);return{notebookEditorId:u}}return y})],n.ApiCommandResult.Void);this._commands.registerApiCommand(v)}createNotebookController(r,i,p,d,s,v){for(let le of this._kernelData.values())if(le.controller.id===i&&R.ExtensionIdentifier.equals(r.identifier,le.extensionId))throw new Error(`notebook controller with id '${i}' ALREADY exist`);const y=this._handlePool++,u=this;this._logService.trace(`NotebookController[${y}], CREATED by ${r.identifier.value}, ${i}`);const D=()=>console.warn(`NO execute handler from notebook controller '${N.id}' of extension: '${r.identifier}'`);let A=!1;const U=new k.DisposableStore,B=new T.Emitter,E=new T.Emitter,N={id:`${r.identifier.value}/${i}`,notebookType:p,extensionId:r.identifier,extensionLocation:r.extensionLocation,label:d||r.identifier.value,preloads:v?v.map(f.NotebookRendererScript.from):[]};let L=s??D,z;this._proxy.$addKernel(y,N).catch(le=>{console.log(le),A=!0});let H=0;const j=()=>{if(A)return;const le=++H;Promise.resolve().then(()=>{le===H&&this._proxy.$updateKernel(y,N)})},ue=new I.ResourceMap,G={get id(){return i},get notebookType(){return N.notebookType},onDidChangeSelectedNotebooks:B.event,get label(){return N.label},set label(le){N.label=le??r.displayName??r.name,j()},get detail(){return N.detail??""},set detail(le){N.detail=le,j()},get description(){return N.description??""},set description(le){N.description=le,j()},get kind(){return(0,C.checkProposedApiEnabled)(r,"notebookControllerKind"),N.kind??""},set kind(le){(0,C.checkProposedApiEnabled)(r,"notebookControllerKind"),N.kind=le,j()},get supportedLanguages(){return N.supportedLanguages},set supportedLanguages(le){N.supportedLanguages=le,j()},get supportsExecutionOrder(){return N.supportsExecutionOrder??!1},set supportsExecutionOrder(le){N.supportsExecutionOrder=le,j()},get rendererScripts(){return N.preloads?N.preloads.map(f.NotebookRendererScript.to):[]},get executeHandler(){return L},set executeHandler(le){L=le??D},get interruptHandler(){return z},set interruptHandler(le){z=le,N.supportsInterrupt=Boolean(le),j()},createNotebookCellExecution(le){if(A)throw new Error("notebook controller is DISPOSED");if(!ue.has(le.notebook.uri))throw u._logService.trace(`NotebookController[${y}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ue.keys()).map(ce=>ce.toString())),new Error(`notebook controller is NOT associated to notebook: ${le.notebook.uri.toString()}`);return u._createNotebookCellExecution(le)},dispose:()=>{A||(this._logService.trace(`NotebookController[${y}], DISPOSED`),A=!0,this._kernelData.delete(y),U.dispose(),B.dispose(),E.dispose(),this._proxy.$removeKernel(y))},updateNotebookAffinity(le,ce){u._proxy.$updateNotebookPriority(y,le.uri,ce)},onDidReceiveMessage:E.event,postMessage(le,ce){return(0,C.checkProposedApiEnabled)(r,"notebookMessaging"),u._proxy.$postMessage(y,ce&&u._extHostNotebook.getIdByEditor(ce),le)},asWebviewUri(le){return(0,C.checkProposedApiEnabled)(r,"notebookMessaging"),(0,m.asWebviewUri)(le,u._initData.remote)}};return this._kernelData.set(y,{extensionId:r.identifier,controller:G,onDidReceiveMessage:E,onDidChangeSelection:B,associatedNotebooks:ue}),G}$acceptNotebookAssociation(r,i,p){const d=this._kernelData.get(r);if(d){const s=this._extHostNotebook.getNotebookDocument(S.URI.revive(i));p?d.associatedNotebooks.set(s.uri,!0):d.associatedNotebooks.delete(s.uri),this._logService.trace(`NotebookController[${r}] ASSOCIATE notebook`,s.uri.toString(),p),d.onDidChangeSelection.fire({selected:p,notebook:s.apiNotebook})}}async $executeCells(r,i,p){const d=this._kernelData.get(r);if(!d)return;const s=this._extHostNotebook.getNotebookDocument(S.URI.revive(i)),v=[];for(let y of p){const u=s.getCell(y);u&&v.push(u.apiCell)}try{this._logService.trace(`NotebookController[${r}] EXECUTE cells`,s.uri.toString(),v.length),await d.controller.executeHandler.call(d.controller,v,s.apiNotebook,d.controller)}catch(y){this._logService.error(`NotebookController[${r}] execute cells FAILED`,y),console.error(y)}}async $cancelCells(r,i,p){const d=this._kernelData.get(r);if(!d)return;const s=this._extHostNotebook.getNotebookDocument(S.URI.revive(i));if(d.controller.interruptHandler)await d.controller.interruptHandler.call(d.controller,s.apiNotebook);else for(let v of p){const y=s.getCell(v);y&&this._activeExecutions.get(y.uri)?.cancel()}}$acceptKernelMessageFromRenderer(r,i,p){const d=this._kernelData.get(r);if(!d)return;const s=this._extHostNotebook.getEditorById(i);d.onDidReceiveMessage.fire(Object.freeze({editor:s.apiEditor,message:p}))}_createNotebookCellExecution(r){if(r.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const p=this._extHostNotebook.getNotebookDocument(r.notebook.uri).getCellFromApiCell(r);if(!p)throw new Error("invalid cell");if(this._activeExecutions.has(p.uri))throw new Error(`duplicate execution for ${p.uri}`);const d=new P(p.notebook,p,this._proxy);this._activeExecutions.set(p.uri,d);const s=d.onDidChangeState(()=>{d.state===g.Resolved&&(d.dispose(),s.dispose(),this._activeExecutions.delete(p.uri))});return d.asApiObject()}};h=Ue([$e(4,F.ILogService)],h),e.ExtHostNotebookKernels=h;var g;(function(M){M[M.Init=0]="Init",M[M.Started=1]="Started",M[M.Resolved=2]="Resolved"})(g||(g={}));class P extends k.Disposable{constructor(r,i,p){super();this._document=r,this._cell=i,this._proxy=p,this._handle=P.HANDLE++,this._onDidChangeState=new T.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=g.Init,this._tokenSource=this._register(new w.CancellationTokenSource),this._collector=new l(10,d=>this.update(d)),this._executionOrder=i.internalMetadata.executionOrder,this._proxy.$addExecution(this._handle,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(r){await this._collector.addItem(r)}async update(r){const i=Array.isArray(r)?r:[r];return this._proxy.$updateExecutions(new b.SerializableObjectWithBuffers(i))}verifyStateForOutput(){if(this._state===g.Init)throw new Error("Must call start before modifying cell output");if(this._state===g.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(r){let i=this._cell;if(r&&(i=this._document.getCellFromApiCell(r)),!i)throw new Error("INVALID cell");return i.handle}validateAndConvertOutputs(r){return r.map(i=>{const p=o.NotebookCellOutput.ensureUniqueMimeTypes(i.items,!0);return p===i.items?f.NotebookCellOutput.from(i):f.NotebookCellOutput.from({items:p,id:i.id,metadata:i.metadata})})}async updateOutputs(r,i,p){const d=this.cellIndexToHandle(i),s=this.validateAndConvertOutputs((0,a.asArray)(r));return this.updateSoon({editType:c.CellExecutionUpdateType.Output,executionHandle:this._handle,cellHandle:d,append:p,outputs:s})}async updateOutputItems(r,i,p){return r=o.NotebookCellOutput.ensureUniqueMimeTypes((0,a.asArray)(r),!0),this.updateSoon({editType:c.CellExecutionUpdateType.OutputItems,executionHandle:this._handle,items:r.map(f.NotebookCellOutputItem.from),outputId:i.id,append:p})}asApiObject(){const r=this;return Object.freeze({get token(){return r._tokenSource.token},get cell(){return r._cell.apiCell},get executionOrder(){return r._executionOrder},set executionOrder(p){r._executionOrder=p,r.update([{editType:c.CellExecutionUpdateType.ExecutionState,executionHandle:r._handle,executionOrder:r._executionOrder}])},start(p){if(r._state===g.Resolved||r._state===g.Started)throw new Error("Cannot call start again");r._state=g.Started,r._onDidChangeState.fire(),r.update({editType:c.CellExecutionUpdateType.ExecutionState,executionHandle:r._handle,runStartTime:p})},end(p,d){if(r._state===g.Resolved)throw new Error("Cannot call resolve twice");r._state=g.Resolved,r._onDidChangeState.fire(),r.updateSoon({editType:c.CellExecutionUpdateType.Complete,executionHandle:r._handle,runEndTime:d,lastRunSuccess:p}),r._collector.flush(),r._proxy.$removeExecution(r._handle)},clearOutput(p){return r.verifyStateForOutput(),r.updateOutputs([],p,!1)},appendOutput(p,d){return r.verifyStateForOutput(),r.updateOutputs(p,d,!0)},replaceOutput(p,d){return r.verifyStateForOutput(),r.updateOutputs(p,d,!1)},appendOutputItems(p,d){return r.verifyStateForOutput(),r.updateOutputItems(p,d,!0)},replaceOutputItems(p,d){return r.verifyStateForOutput(),r.updateOutputItems(p,d,!1)}})}}P.HANDLE=0;class l{constructor(r,i){this.delay=r,this.callback=i,this.batch=[],this.startedTimer=Date.now()}addItem(r){return this.batch.push(r),this.currentDeferred||(this.currentDeferred=new t.DeferredPromise,this.startedTimer=Date.now(),(0,t.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const r=this.currentDeferred;this.currentDeferred=void 0;const i=this.batch;return this.batch=[],this.callback(i).finally(()=>r.complete())}}}),define(Ee[197],ye([0,1,4,5,91,27]),function(re,e,a,t,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class k{constructor(S,R){this._extHostNotebook=R,this._rendererMessageEmitters=new Map,this.proxy=S.getProxy(t.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(S,R,F){const _=this._extHostNotebook.getEditorById(S);this._rendererMessageEmitters.get(R)?.fire({editor:_.apiEditor,message:F})}createRendererMessaging(S,R){if(!S.contributes?.notebookRenderer?.some(f=>f.id===R))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${R})`);const F=(0,T.isProposedApiEnabled)(S,"notebookEditor"),_=new WeakMap;return{onDidReceiveMessage:(f,o,m)=>{const c=F?f:C=>{const b={};_.set(b,C.editor),f({editor:b,message:C.message})};return this.getOrCreateEmitterFor(R).event(c,o,m)},postMessage:(f,o)=>{w.ExtHostNotebookEditor.apiEditorsToExtHost.has(f)&&([f,o]=[o,f]);const m=F?o:_.get(o),c=m&&w.ExtHostNotebookEditor.apiEditorsToExtHost.get(m);return this.proxy.$postMessage(c?.id,R,f)}}}getOrCreateEmitterFor(S){let R=this._rendererMessageEmitters.get(S);return R||(R=new a.Emitter({onLastListenerRemove:()=>{R?.dispose(),this._rendererMessageEmitters.delete(S)}}),this._rendererMessageEmitters.set(S,R),R)}}e.ExtHostNotebookRenderers=k}),define(Ee[94],ye([0,1,5,6,3,13,12,160,49,28,30,110,22]),function(re,e,a,t,w,T,k,I,S,R,F,_,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.ExtHostOutputChannel=void 0;class f extends t.Disposable{constructor(c,C,b,h){super();this.id=c,this.name=C,this.logger=b,this.proxy=h,this.offset=0,this.visible=!1,this._disposed=!1}get disposed(){return this._disposed}appendLine(c){this.append(c+`
`)}append(c){this.write(c),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,I.OutputChannelUpdateMode.Append))}clear(){const c=this.offset;this.logger.flush(),this.proxy.$update(this.id,I.OutputChannelUpdateMode.Clear,c)}replace(c){const C=this.offset;this.write(c),this.proxy.$update(this.id,I.OutputChannelUpdateMode.Replace,C),this.visible&&this.logger.flush()}show(c,C){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof c=="boolean"?c:C))}hide(){this.proxy.$close(this.id)}write(c){this.offset+=n.VSBuffer.fromString(c).byteLength,this.logger.info(c)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}e.ExtHostOutputChannel=f;let o=class{constructor(c,C,b,h,g){this.extHostFileSystem=b,this.extHostFileSystemInfo=h,this.loggerService=g,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=c.getProxy(a.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(C.logsLocation,`output_logging_${(0,_.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(c){this.visibleChannelId=c;for(const[C,b]of this.channels)b.visible=C===this.visibleChannelId}createOutputChannel(c,C){if(c=c.trim(),!c)throw new Error("illegal argument `name`. must not be falsy");const b=this.doCreateOutputChannel(c,C);return b.then(h=>{this.channels.set(h.id,h),h.visible=h.id===this.visibleChannelId}),this.createExtHostOutputChannel(c,b)}async doCreateOutputChannel(c,C){const b=await this.createOutputDirectory(),h=this.extHostFileSystemInfo.extUri.joinPath(b,`${this.namePool++}-${c.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),g=this.loggerService.createLogger(h,{always:!0,donotRotate:!0,donotUseFormatters:!0}),P=await this.proxy.$register(c,!1,h,C.identifier.value);return new f(P,c,g,this.proxy)}createOutputDirectory(){return this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation)),this.outputDirectoryPromise}createExtHostOutputChannel(c,C){let b=!1;const h=()=>{if(b)throw new Error("Channel has been closed")};return{get name(){return c},append(g){h(),C.then(P=>P.append(g))},appendLine(g){h(),C.then(P=>P.appendLine(g))},clear(){h(),C.then(g=>g.clear())},replace(g){h(),C.then(P=>P.replace(g))},show(g,P){h(),C.then(l=>l.show(g,P))},hide(){h(),C.then(g=>g.hide())},dispose(){b=!0,C.then(g=>g.dispose())}}}};o=Ue([$e(0,T.IExtHostRpcService),$e(1,R.IExtHostInitDataService),$e(2,S.IExtHostConsumerFileSystem),$e(3,F.IExtHostFileSystemInfo),$e(4,k.ILoggerService)],o),e.ExtHostOutputService=o,e.IExtHostOutputService=(0,w.createDecorator)("IExtHostOutputService")}),define(Ee[198],ye([0,1,14,20,4,6,5,2,7,15,16,34,62,27]),function(re,e,a,t,w,T,k,I,S,R,F,_,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function o(m,c,C){const b=m.getProxy(k.MainContext.MainThreadQuickOpen);class h{constructor(s,v){this._sessions=new Map,this._instances=0,this._workspace=s,this._commands=v}showQuickPick(s,v,y=t.CancellationToken.None){this._onDidSelectItem=void 0;const u=Promise.resolve(s),D=++this._instances,A=b.$show(D,{title:v?.title,placeHolder:v?.placeHolder,matchOnDescription:v?.matchOnDescription,matchOnDetail:v?.matchOnDetail,ignoreFocusLost:v?.ignoreFocusOut,canPickMany:v?.canPickMany},y),U={},B=A.then(()=>U);return Promise.race([B,u]).then(E=>{if(E!==U)return u.then(N=>{const L=[];for(let z=0;z<N.length;z++){const H=N[z];typeof H=="string"?L.push({label:H,handle:z}):H.kind===S.QuickPickItemKind.Separator?L.push({type:"separator",label:H.label}):L.push({label:H.label,description:H.description,detail:H.detail,picked:H.picked,alwaysShow:H.alwaysShow,handle:z})}return v&&typeof v.onDidSelectItem=="function"&&(this._onDidSelectItem=z=>{v.onDidSelectItem(N[z])}),b.$setItems(D,L),A.then(z=>{if(typeof z=="number")return N[z];if(Array.isArray(z))return z.map(H=>N[H])})})}).then(void 0,E=>{if(!(0,R.isPromiseCanceledError)(E))return b.$setError(D,E),Promise.reject(E)})}$onItemSelected(s){this._onDidSelectItem&&this._onDidSelectItem(s)}showInput(s,v=t.CancellationToken.None){return this._validateInput=s?s.validateInput:void 0,b.$input(s,typeof this._validateInput=="function",v).then(void 0,y=>{if(!(0,R.isPromiseCanceledError)(y))return Promise.reject(y)})}$validateInput(s){return this._validateInput?(0,a.asPromise)(()=>this._validateInput(s)):Promise.resolve(void 0)}async showWorkspaceFolderPick(s,v=t.CancellationToken.None){const y=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[s]);if(!y)return;const u=await this._workspace.getWorkspaceFolders2();if(!!u)return u.find(D=>D.uri.toString()===y.uri.toString())}createQuickPick(s){const v=new i(s,()=>this._sessions.delete(v._id));return this._sessions.set(v._id,v),v}createInputBox(s){const v=new p(s,()=>this._sessions.delete(v._id));return this._sessions.set(v._id,v),v}$onDidChangeValue(s,v){const y=this._sessions.get(s);y&&y._fireDidChangeValue(v)}$onDidAccept(s){const v=this._sessions.get(s);v&&v._fireDidAccept()}$onDidChangeActive(s,v){const y=this._sessions.get(s);y instanceof i&&y._fireDidChangeActive(v)}$onDidChangeSelection(s,v){const y=this._sessions.get(s);y instanceof i&&y._fireDidChangeSelection(v)}$onDidTriggerButton(s,v){const y=this._sessions.get(s);y&&y._fireDidTriggerButton(v)}$onDidTriggerItemButton(s,v,y){const u=this._sessions.get(s);u instanceof i&&u._fireDidTriggerItemButton(v,y)}$onDidHide(s){const v=this._sessions.get(s);v&&v._fireDidHide()}}class g{constructor(s,v){this._extensionId=s,this._onDidDispose=v,this._id=i._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new w.Emitter,this._onDidChangeValueEmitter=new w.Emitter,this._onDidTriggerButtonEmitter=new w.Emitter,this._onDidHideEmitter=new w.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(s){this._title=s,this.update({title:s})}get step(){return this._steps}set step(s){this._steps=s,this.update({step:s})}get totalSteps(){return this._totalSteps}set totalSteps(s){this._totalSteps=s,this.update({totalSteps:s})}get enabled(){return this._enabled}set enabled(s){this._enabled=s,this.update({enabled:s})}get busy(){return this._busy}set busy(s){this._busy=s,this.update({busy:s})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(s){this._ignoreFocusOut=s,this.update({ignoreFocusOut:s})}get value(){return this._value}set value(s){this._value=s,this.update({value:s})}get placeholder(){return this._placeholder}set placeholder(s){this._placeholder=s,this.update({placeholder:s})}get buttons(){return this._buttons}set buttons(s){this._buttons=s.slice(),this._handlesToButtons.clear(),s.forEach((v,y)=>{const u=v===S.QuickInputButtons.Back?-1:y;this._handlesToButtons.set(u,v)}),this.update({buttons:s.map((v,y)=>({...r(v),tooltip:v.tooltip,handle:v===S.QuickInputButtons.Back?-1:y}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(s){this._value=s,this._onDidChangeValueEmitter.fire(s)}_fireDidTriggerButton(s){const v=this._handlesToButtons.get(s);v&&this._onDidTriggerButtonEmitter.fire(v)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,T.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),b.$dispose(this._id))}update(s){if(!this._disposed){for(const v of Object.keys(s)){const y=s[v];this._pendingUpdate[v]=y===void 0?null:y}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){b.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}g._nextId=1;function P(d){if(d instanceof S.ThemeIcon)return{id:d.id};const s=M(d),v=l(d);return{dark:typeof s=="string"?I.URI.file(s):s,light:typeof v=="string"?I.URI.file(v):v}}function l(d){return typeof d=="object"&&"light"in d?d.light:d}function M(d){return typeof d=="object"&&"dark"in d?d.dark:d}function r(d){const s=P(d.iconPath);let v,y;return"id"in s?y=n.ThemeIcon.asClassName(s):v=s,{iconPath:v,iconClass:y}}class i extends g{constructor(s,v){super(s.identifier,v);this.extension=s,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new w.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new w.Emitter,this._onDidTriggerItemButtonEmitter=new w.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(s){s.some(y=>y.kind!==void 0)&&(0,f.checkProposedApiEnabled)(this.extension,"quickPickSeparators"),this._items=s.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),s.forEach((y,u)=>{this._handlesToItems.set(u,y),this._itemsToHandles.set(y,u)});const v=[];for(let y=0;y<s.length;y++){const u=s[y];u.kind===S.QuickPickItemKind.Separator?v.push({type:"separator",label:u.label}):v.push({handle:y,label:u.label,description:u.description,detail:u.detail,picked:u.picked,alwaysShow:u.alwaysShow,buttons:u.buttons?.map((D,A)=>({...r(D),tooltip:D.tooltip,handle:A}))})}this.update({items:v})}get canSelectMany(){return this._canSelectMany}set canSelectMany(s){this._canSelectMany=s,this.update({canSelectMany:s})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(s){this._matchOnDescription=s,this.update({matchOnDescription:s})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(s){this._matchOnDetail=s,this.update({matchOnDetail:s})}get sortByLabel(){return this._sortByLabel}set sortByLabel(s){this._sortByLabel=s,this.update({sortByLabel:s})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(s){this._keepScrollPosition=s,this.update({keepScrollPosition:s})}get activeItems(){return this._activeItems}set activeItems(s){this._activeItems=s.filter(v=>this._itemsToHandles.has(v)),this.update({activeItems:this._activeItems.map(v=>this._itemsToHandles.get(v))})}get selectedItems(){return this._selectedItems}set selectedItems(s){this._selectedItems=s.filter(v=>this._itemsToHandles.has(v)),this.update({selectedItems:this._selectedItems.map(v=>this._itemsToHandles.get(v))})}_fireDidChangeActive(s){const v=(0,F.coalesce)(s.map(y=>this._handlesToItems.get(y)));this._activeItems=v,this._onDidChangeActiveEmitter.fire(v)}_fireDidChangeSelection(s){const v=(0,F.coalesce)(s.map(y=>this._handlesToItems.get(y)));this._selectedItems=v,this._onDidChangeSelectionEmitter.fire(v)}_fireDidTriggerItemButton(s,v){const y=this._handlesToItems.get(s);if(!y||!y.buttons||!y.buttons.length)return;const u=y.buttons[v];u&&this._onDidTriggerItemButtonEmitter.fire({button:u,item:y})}}class p extends g{constructor(s,v){super(s,v);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(s){this._password=s,this.update({password:s})}get prompt(){return this._prompt}set prompt(s){this._prompt=s,this.update({prompt:s})}get validationMessage(){return this._validationMessage}set validationMessage(s){this._validationMessage=s,this.update({validationMessage:s,severity:s?_.default.Error:_.default.Ignore})}}return new h(c,C)}e.createExtHostQuickOpen=o}),define(Ee[199],ye([0,1,2,4,52,6,14,5,16,105,12,25,62,8,27]),function(re,e,a,t,w,T,k,I,S,R,F,_,n,f,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function m(d){if(d)return typeof d.iconPath=="string"?a.URI.file(d.iconPath):a.URI.isUri(d.iconPath)||n.ThemeIcon.isThemeIcon(d.iconPath)?d.iconPath:void 0}function c(d,s){if(!d.iconPath&&!s.iconPath)return 0;if(d.iconPath){if(!s.iconPath)return 1}else return-1;const v=typeof d.iconPath=="string"?d.iconPath:a.URI.isUri(d.iconPath)?d.iconPath.fsPath:d.iconPath.id,y=typeof s.iconPath=="string"?s.iconPath:a.URI.isUri(s.iconPath)?s.iconPath.fsPath:s.iconPath.id;return(0,R.comparePaths)(v,y)}function C(d,s){let v=0;if(d.strikeThrough!==s.strikeThrough)return d.strikeThrough?1:-1;if(d.faded!==s.faded)return d.faded?1:-1;if(d.tooltip!==s.tooltip)return(d.tooltip||"").localeCompare(s.tooltip||"");if(v=c(d,s),v!==0)return v;if(d.light&&s.light)v=c(d.light,s.light);else{if(d.light)return 1;if(s.light)return-1}if(v!==0)return v;if(d.dark&&s.dark)v=c(d.dark,s.dark);else{if(d.dark)return 1;if(s.dark)return-1}return v}function b(d,s){if(d.command!==s.command)return d.command<s.command?-1:1;if(d.title!==s.title)return d.title<s.title?-1:1;if(d.tooltip!==s.tooltip){if(d.tooltip!==void 0&&s.tooltip!==void 0)return d.tooltip<s.tooltip?-1:1;if(d.tooltip!==void 0)return 1;if(s.tooltip!==void 0)return-1}if(d.arguments===s.arguments)return 0;if(d.arguments)if(s.arguments){if(d.arguments.length!==s.arguments.length)return d.arguments.length-s.arguments.length}else return 1;else return-1;for(let v=0;v<d.arguments.length;v++){const y=d.arguments[v],u=s.arguments[v];if(y!==u)return y<u?-1:1}return 0}function h(d,s){let v=(0,R.comparePaths)(d.resourceUri.fsPath,s.resourceUri.fsPath,!0);if(v!==0)return v;if(d.command&&s.command)v=b(d.command,s.command);else{if(d.command)return 1;if(s.command)return-1}if(v!==0)return v;if(d.decorations&&s.decorations)v=C(d.decorations,s.decorations);else{if(d.decorations)return 1;if(s.decorations)return-1}return v}function g(d,s){for(let v=0;v<d.length;v++)if(d[v]!==s[v])return!1;return!0}function P(d,s){return d.command===s.command&&d.title===s.title&&d.tooltip===s.tooltip&&(d.arguments&&s.arguments?g(d.arguments,s.arguments):d.arguments===s.arguments)}function l(d,s){return(0,S.equals)(d,s,P)}class M{constructor(s,v,y){this._extension=s,this._proxy=v,this._sourceControlHandle=y,this._value="",this._onDidChange=new t.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(s){s=s??"",this._proxy.$setInputBoxValue(this._sourceControlHandle,s),this.updateValue(s)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(s){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,s),this._placeholder=s}get validateInput(){return(0,o.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(s){if((0,o.checkProposedApiEnabled)(this._extension,"scmValidation"),s&&typeof s!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=s,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!s)}get visible(){return this._visible}set visible(s){s=!!s,this._visible!==s&&(this._visible=s,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,s))}showValidationMessage(s,v){(0,o.checkProposedApiEnabled)(this._extension,"scmValidation"),this._proxy.$showValidationMessage(this._sourceControlHandle,s,v)}$onInputBoxValueChange(s){this.updateValue(s)}updateValue(s){this._value=s,this._onDidChange.fire(s)}}e.ExtHostSCMInputBox=M;class r{constructor(s,v,y,u,D){this._proxy=s,this._commands=v,this._sourceControlHandle=y,this._id=u,this._label=D,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new t.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=r._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(s){this._label=s,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,s)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(s){this._hideWhenEmpty=s,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(s){this._resourceStates=[...s],this._onDidUpdateResourceStates.fire()}getResourceState(s){return this._resourceStatesMap.get(s)}$executeResourceCommand(s,v){const y=this._resourceStatesCommandsMap.get(s);return y?(0,k.asPromise)(()=>this._commands.executeCommand(y.command,...y.arguments||[],v)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const s=[...this._resourceStates].sort(h),y=(0,S.sortedDiff)(this._resourceSnapshot,s,h).map(A=>{const U=A.toInsert.map(B=>{const E=this._resourceHandlePool++;this._resourceStatesMap.set(E,B);const N=B.resourceUri;let L;if(B.command)if(B.command.command==="vscode.open"||B.command.command==="vscode.diff"){const we=new T.DisposableStore;L=this._commands.converter.toInternal(B.command,we),this._resourceStatesDisposablesMap.set(E,we)}else this._resourceStatesCommandsMap.set(E,B.command);const z=m(B.decorations),H=B.decorations&&m(B.decorations.light)||z,j=B.decorations&&m(B.decorations.dark)||z,ue=[H,j],G=B.decorations&&B.decorations.tooltip||"",le=B.decorations&&!!B.decorations.strikeThrough,ce=B.decorations&&!!B.decorations.faded,Y=B.contextValue||"";return{rawResource:[E,N,ue,G,le,ce,Y,L],handle:E}});return{start:A.start,deleteCount:A.deleteCount,toInsert:U}}),u=y.map(({start:A,deleteCount:U,toInsert:B})=>[A,U,B.map(E=>E.rawResource)]),D=y.reverse();for(const{start:A,deleteCount:U,toInsert:B}of D){const E=B.map(L=>L.handle),N=this._handlesSnapshot.splice(A,U,...E);for(const L of N)this._resourceStatesMap.delete(L),this._resourceStatesCommandsMap.delete(L),this._resourceStatesDisposablesMap.get(L)?.dispose(),this._resourceStatesDisposablesMap.delete(L)}return this._resourceSnapshot=s,u}dispose(){this._disposed=!0,this._onDidDispose.fire()}}r._handlePool=0;class i{constructor(s,v,y,u,D,A){this._extension=s,this._proxy=v,this._commands=y,this._id=u,this._label=D,this._rootUri=A,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new T.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new T.MutableDisposable,this._statusBarDisposables=new T.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new t.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=i._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new M(s,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,u,D,A)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(s){this._count!==s&&(this._count=s,this._proxy.$updateSourceControl(this.handle,{count:s}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(s){this._quickDiffProvider=s,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!s})}get commitTemplate(){return this._commitTemplate}set commitTemplate(s){s!==this._commitTemplate&&(this._commitTemplate=s,this._proxy.$updateSourceControl(this.handle,{commitTemplate:s}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(s){this._acceptInputDisposables.value=new T.DisposableStore,this._acceptInputCommand=s;const v=this._commands.converter.toInternal(s,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:v})}get actionButton(){return(0,o.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(s){(0,o.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new T.DisposableStore,this._actionButton=s;const v=s!==void 0?this._commands.converter.toInternal(this._actionButton,this._actionButtonDisposables.value):void 0;this._proxy.$updateSourceControl(this.handle,{actionButton:v??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(s){if(this._statusBarCommands&&s&&l(this._statusBarCommands,s))return;this._statusBarDisposables.value=new T.DisposableStore,this._statusBarCommands=s;const v=(s||[]).map(y=>this._commands.converter.toInternal(y,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:v})}get selected(){return this._selected}createResourceGroup(s,v){const y=new r(this._proxy,this._commands,this.handle,s,v),u=t.Event.once(y.onDidDispose)(()=>this.createdResourceGroups.delete(y));return this.createdResourceGroups.set(y,u),this.eventuallyAddResourceGroups(),y}eventuallyAddResourceGroups(){const s=[],v=[];for(const[y,u]of this.createdResourceGroups){u.dispose();const D=y.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(y),this.eventuallyUpdateResourceStates()});t.Event.once(y.onDidDispose)(()=>{this.updatedResourceGroups.delete(y),D.dispose(),this._groups.delete(y.handle),this._proxy.$unregisterGroup(this.handle,y.handle)}),s.push([y.handle,y.id,y.label,y.features]);const A=y._takeResourceStateSnapshot();A.length>0&&v.push([y.handle,A]),this._groups.set(y.handle,y)}this._proxy.$registerGroups(this.handle,s,v),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const s=[];this.updatedResourceGroups.forEach(v=>{const y=v._takeResourceStateSnapshot();y.length!==0&&s.push([v.handle,y])}),s.length>0&&this._proxy.$spliceResourceStates(this.handle,s),this.updatedResourceGroups.clear()}getResourceGroup(s){return this._groups.get(s)}setSelectionState(s){this._selected=s,this._onDidChangeSelection.fire(s)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(s=>s.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}i._handlePool=0,Ue([(0,w.debounce)(100)],i.prototype,"eventuallyAddResourceGroups",null),Ue([(0,w.debounce)(100)],i.prototype,"eventuallyUpdateResourceStates",null);let p=class zi{constructor(s,v,y){this._commands=v,this.logService=y,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new t.Emitter,this._proxy=s.getProxy(I.MainContext.MainThreadSCM),this._telemetry=s.getProxy(I.MainContext.MainThreadTelemetry),v.registerArgumentProcessor({processArgument:u=>{if(u&&u.$mid===3){const D=this._sourceControls.get(u.sourceControlHandle);if(!D)return u;const A=D.getResourceGroup(u.groupHandle);return A?A.getResourceState(u.handle):u}else if(u&&u.$mid===4){const D=this._sourceControls.get(u.sourceControlHandle);return D?D.getResourceGroup(u.groupHandle):u}else if(u&&u.$mid===5){const D=this._sourceControls.get(u.handle);return D||u}return u}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(s,v,y,u){this.logService.trace("ExtHostSCM#createSourceControl",s.identifier.value,v,y,u),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:s.identifier.value});const D=zi._handlePool++,A=new i(s,this._proxy,this._commands,v,y,u);this._sourceControls.set(D,A);const U=this._sourceControlsByExtension.get(_.ExtensionIdentifier.toKey(s.identifier))||[];return U.push(A),this._sourceControlsByExtension.set(_.ExtensionIdentifier.toKey(s.identifier),U),A}getLastInputBox(s){this.logService.trace("ExtHostSCM#getLastInputBox",s.identifier.value);const v=this._sourceControlsByExtension.get(_.ExtensionIdentifier.toKey(s.identifier)),y=v&&v[v.length-1];return y&&y.inputBox}$provideOriginalResource(s,v,y){const u=a.URI.revive(v);this.logService.trace("ExtHostSCM#$provideOriginalResource",s,u.toString());const D=this._sourceControls.get(s);return!D||!D.quickDiffProvider||!D.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,k.asPromise)(()=>D.quickDiffProvider.provideOriginalResource(u,y)).then(A=>A||null)}$onInputBoxValueChange(s,v){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",s);const y=this._sourceControls.get(s);return y&&y.inputBox.$onInputBoxValueChange(v),Promise.resolve(void 0)}$executeResourceCommand(s,v,y,u){this.logService.trace("ExtHostSCM#$executeResourceCommand",s,v,y);const D=this._sourceControls.get(s);if(!D)return Promise.resolve(void 0);const A=D.getResourceGroup(v);return A?A.$executeResourceCommand(y,u):Promise.resolve(void 0)}$validateInput(s,v,y){this.logService.trace("ExtHostSCM#$validateInput",s);const u=this._sourceControls.get(s);return!u||!u.inputBox.validateInput?Promise.resolve(void 0):(0,k.asPromise)(()=>u.inputBox.validateInput(v,y)).then(D=>{if(!D)return Promise.resolve(void 0);const A=f.MarkdownString.fromStrict(D.message);return A?Promise.resolve([A,D.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(s){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",s),s!==void 0&&this._sourceControls.get(s)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=s,Promise.resolve(void 0)}};p._handlePool=0,p=Ue([$e(2,F.ILogService)],p),e.ExtHostSCM=p});var Ze=this&&this.__classPrivateFieldSet||function(re,e,a,t,w){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!w:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?w.call(re,a):w?w.value=a:e.set(re,a),a},Te=this&&this.__classPrivateFieldGet||function(re,e,a,t){if(a==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!t:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?t:a==="a"?t.call(re):t?t.value:e.get(re)};define(Ee[200],ye([0,1,7,5,122,6,8,11]),function(re,e,a,t,w,T,k,I){"use strict";var S,R;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class F{constructor(o,m,c,C,b=a.StatusBarAlignment.Left,h){S.set(this,void 0),R.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new T.DisposableStore,Ze(this,S,o,"f"),Ze(this,R,m,"f"),this._entryId=F.ID_GEN++,this._extension=c,this._id=C,this._alignment=b,this._priority=this.validatePriority(h)}validatePriority(o){if(!!(0,I.isNumber)(o))return o===Number.POSITIVE_INFINITY?Number.MAX_VALUE:o===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:o}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(o){this._text=o,this.update()}set name(o){this._name=o,this.update()}set tooltip(o){this._tooltip=o,this.update()}set color(o){this._color=o,this.update()}set backgroundColor(o){o&&!F.ALLOWED_BACKGROUND_COLORS.has(o.id)&&(o=void 0),this._backgroundColor=o,this.update()}set command(o){this._command?.fromApi!==o&&(this._internalCommandRegistration.clear(),typeof o=="string"?this._command={fromApi:o,internal:Te(this,R,"f").toInternal({title:"",command:o},this._internalCommandRegistration)}:o?this._command={fromApi:o,internal:Te(this,R,"f").toInternal(o,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(o){this._accessibilityInformation=o,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Te(this,S,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let o;this._extension?this._id?o=`${this._extension.identifier.value}.${this._id}`:o=this._extension.identifier.value:o=this._id;let m;this._name?m=this._name:m=(0,w.localize)(0,null,this._extension.displayName||this._extension.name);let c=this._color;this._backgroundColor&&(c=F.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const C=this._tooltip?k.MarkdownString.fromStrict(this._tooltip):void 0;Te(this,S,"f").$setEntry(this._entryId,o,m,this._text,C,this._command?.internal,c,this._backgroundColor,this._alignment===a.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=F,S=new WeakMap,R=new WeakMap,F.ID_GEN=0,F.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new a.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new a.ThemeColor("statusBarItem.warningForeground")]]);class _{constructor(o){this._messages=[],this._item=o.createStatusBarEntry(void 0,"status.extensionMessage",a.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,w.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(o){const m={message:o};return this._messages.unshift(m),this._update(),new a.Disposable(()=>{const c=this._messages.indexOf(m);c>=0&&(this._messages.splice(c,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class n{constructor(o,m){this._proxy=o.getProxy(t.MainContext.MainThreadStatusBar),this._commands=m,this._statusMessage=new _(this)}createStatusBarEntry(o,m,c,C){return new F(this._proxy,this._commands,o,m,c,C)}setStatusBarMessage(o,m){const c=this._statusMessage.setMessage(o);let C;return typeof m=="number"?C=setTimeout(()=>c.dispose(),m):typeof m!="undefined"&&m.then(()=>c.dispose(),()=>c.dispose()),new a.Disposable(()=>{c.dispose(),clearTimeout(C)})}}e.ExtHostStatusBar=n}),define(Ee[71],ye([0,1,5,4,3]),function(re,e,a,t,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class T{constructor(I){this._onDidChangeStorage=new t.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=I.getProxy(a.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(I,S){this._proxy.$registerExtensionStorageKeysToSync(I,S)}getValue(I,S,R){return this._proxy.$getValue(I,S).then(F=>F||R)}setValue(I,S,R){return this._proxy.$setValue(I,S,R)}$acceptValue(I,S,R){this._onDidChangeStorage.fire({shared:I,key:S,value:R})}}e.ExtHostStorage=T,e.IExtHostStorage=(0,w.createDecorator)("IExtHostStorage")}),define(Ee[72],ye([0,1,3,28,12,49,2]),function(re,e,a,t,w,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,a.createDecorator)("IExtensionStoragePaths");let I=class{constructor(R,F,_){this._logService=F,this._extHostFileSystem=_,this._workspace=R.workspace??void 0,this._environment=R.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(n=>this._value=n)}async _getWorkspaceStorageURI(R){return k.URI.joinPath(this._environment.workspaceStorageHome,R)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const R=this._workspace.id,F=await this._getWorkspaceStorageURI(R);try{return await this._extHostFileSystem.value.stat(F),this._logService.trace("[ExtHostStorage] storage dir already exists",F),F}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",F),await this._extHostFileSystem.value.createDirectory(F),await this._extHostFileSystem.value.writeFile(k.URI.joinPath(F,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:k.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),F}catch(_){this._logService.error("[ExtHostStorage]",_);return}}workspaceValue(R){if(this._value)return k.URI.joinPath(this._value,R.identifier.value)}globalValue(R){return k.URI.joinPath(this._environment.globalStorageHome,R.identifier.value.toLowerCase())}onWillDeactivateAll(){}};I=Ue([$e(0,t.IExtHostInitDataService),$e(1,w.ILogService),$e(2,T.IExtHostConsumerFileSystem)],I),e.ExtensionStoragePaths=I}),define(Ee[39],ye([0,1,4,5,3,2,13,6,7,123,15,162,20,35,145,62,11,14]),function(re,e,a,t,w,T,k,I,S,R,F,_,n,f,o,m,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,w.createDecorator)("IExtHostTerminalService");class b{constructor(d,s,v,y){this._proxy=d,this._id=s,this._creationOptions=v,this._name=y,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(D=>this._pidPromiseComplete=D);const u=this;this.value={get name(){return u._name||""},get processId(){return u._pidPromise},get creationOptions(){return u._creationOptions},get exitStatus(){return u._exitStatus},get state(){return u._state},sendText(D,A=!0){u._checkDisposed(),u._proxy.$sendText(u._id,D,A)},show(D){u._checkDisposed(),u._proxy.$show(u._id,D)},hide(){u._checkDisposed(),u._proxy.$hide(u._id)},dispose(){u._disposed||(u._disposed=!0,u._proxy.$dispose(u._id))},get dimensions(){if(!(u._cols===void 0||u._rows===void 0))return{columns:u._cols,rows:u._rows}}}}async create(d,s){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:d.name,shellPath:(0,c.withNullAsUndefined)(d.shellPath),shellArgs:(0,c.withNullAsUndefined)(d.shellArgs),cwd:(0,c.withNullAsUndefined)(d.cwd),env:(0,c.withNullAsUndefined)(d.env),icon:(0,c.withNullAsUndefined)(r(d.iconPath)),color:m.ThemeColor.isThemeColor(d.color)?d.color.id:void 0,initialText:(0,c.withNullAsUndefined)(d.message),strictEnv:(0,c.withNullAsUndefined)(d.strictEnv),hideFromUser:(0,c.withNullAsUndefined)(d.hideFromUser),isFeatureTerminal:(0,c.withNullAsUndefined)(s?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,c.withNullAsUndefined)(s?.useShellEnvironment),location:s?.location||this._serializeParentTerminal(d.location,s?.resolvedExtHostIdentifier),disablePersistence:(0,c.withNullAsUndefined)(d.disablePersistence)})}async createExtensionTerminal(d,s,v,y){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:v,color:m.ThemeColor.isThemeColor(y)?y.id:void 0,location:this._serializeParentTerminal(d,s),disablePersistence:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(d,s){return typeof d=="object"?"parentTerminal"in d&&d.parentTerminal&&s?{parentTerminal:s}:"viewColumn"in d?{viewColumn:d.viewColumn,preserveFocus:d.preserveFocus}:void 0:d}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(d){this._name=d}setExitCode(d){this._exitStatus=Object.freeze({code:d})}setDimensions(d,s){return d===this._cols&&s===this._rows||d===0||s===0?!1:(this._cols=d,this._rows=s,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(d){this._pidPromiseComplete?(this._pidPromiseComplete(d),this._pidPromiseComplete=void 0):this._pidPromise.then(s=>{s!==d&&(this._pidPromise=Promise.resolve(d))})}}e.ExtHostTerminal=b;class h{constructor(d){this._pty=d,this.id=0,this.shouldPersist=!1,this._capabilities=[],this._onProcessData=new a.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new a.Emitter,this._onDidChangeProperty=new a.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new a.Emitter,this.onProcessExit=this._onProcessExit.event}get capabilities(){return this._capabilities}get onProcessReady(){return this._onProcessReady.event}refreshProperty(d){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${d}`)}updateProperty(d,s){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${d}, value: ${s}`)}async start(){}shutdown(){this._pty.close()}input(d){this._pty.handleInput?.(d)}resize(d,s){this._pty.setDimensions?.({columns:d,rows:s})}async processBinary(d){}acknowledgeDataEvent(d){}async setUnicodeVersion(d){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(d){this._pty.onDidWrite(s=>this._onProcessData.fire(s)),this._pty.onDidClose?.((s=void 0)=>{this._onProcessExit.fire(s===void 0?void 0:s)}),this._pty.onDidOverrideDimensions?.(s=>{s&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:s.columns,rows:s.rows}})}),this._pty.onDidChangeName?.(s=>{this._onDidChangeProperty.fire({type:"title",value:s})}),this._pty.open(d||void 0),d&&this._pty.setDimensions?.(d),this._onProcessReady.fire({pid:-1,cwd:"",capabilities:this._capabilities})}}e.ExtHostPseudoterminal=h;let g=1,P=class extends I.Disposable{constructor(d,s){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new a.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new a.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new a.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new a.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new a.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=s.getProxy(t.MainContext.MainThreadTerminalService),this._bufferer=new o.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new a.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(d),this._register({dispose:()=>{for(const[v,y]of this._terminalProcesses)y.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(d=>d.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(d){return(d?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(d){return(d?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(d,s){const v=new b(this._proxy,(0,f.generateUuid)(),d,d.name),y=new h(d.pty);return v.createExtensionTerminal(d.location,this._serializeParentTerminal(d,s).resolvedExtHostIdentifier,r(d.iconPath),i(d.color)).then(u=>{const D=this._setupExtHostProcessListeners(u,y);this._terminalProcessDisposables[u]=D}),this._terminals.push(v),v.value}_serializeParentTerminal(d,s){if(s=s||{},d.location&&typeof d.location=="object"&&"parentTerminal"in d.location){const v=d.location.parentTerminal;if(v){const y=this._terminals.find(u=>u.value===v);y&&(s.resolvedExtHostIdentifier=y._id)}}else d.location&&typeof d.location!="object"?s.location=d.location:s.location&&typeof s.location=="object"&&"splitActiveTerminal"in s.location&&(s.location={splitActiveTerminal:!0});return s}attachPtyToTerminal(d,s){if(!this._getTerminalById(d))throw new Error(`Cannot resolve terminal with id ${d} for virtual process`);const y=new h(s),u=this._setupExtHostProcessListeners(d,y);this._terminalProcessDisposables[d]=u}async $acceptActiveTerminalChanged(d){const s=this._activeTerminal;if(d===null){this._activeTerminal=void 0,s!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const v=this._getTerminalById(d);v&&(this._activeTerminal=v,s!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(d,s){const v=this._getTerminalById(d);v&&this._onDidWriteTerminalData.fire({terminal:v.value,data:s})}async $acceptTerminalDimensions(d,s,v){const y=this._getTerminalById(d);y&&y.setDimensions(s,v)&&this._onDidChangeTerminalDimensions.fire({terminal:y.value,dimensions:y.value.dimensions})}async $acceptTerminalMaximumDimensions(d,s,v){this._terminalProcesses.get(d)?.resize(s,v)}async $acceptTerminalTitleChange(d,s){const v=this._getTerminalById(d);v&&(v.name=s)}async $acceptTerminalClosed(d,s){const v=this._getTerminalObjectIndexById(this._terminals,d);if(v!==null){const y=this._terminals.splice(v,1)[0];y.setExitCode(s),this._onDidCloseTerminal.fire(y.value)}}$acceptTerminalOpened(d,s,v,y){if(s){const A=this._getTerminalObjectIndexById(this._terminals,s);if(A!==null){this._terminals[A]._id=d,this._onDidOpenTerminal.fire(this.terminals[A]),this._terminals[A].isOpen=!0;return}}const u={name:y.name,shellPath:y.executable,shellArgs:y.args,cwd:typeof y.cwd=="string"?y.cwd:T.URI.revive(y.cwd),env:y.env,hideFromUser:y.hideFromUser},D=new b(this._proxy,d,u,v);this._terminals.push(D),this._onDidOpenTerminal.fire(D.value),D.isOpen=!0}async $acceptTerminalProcessId(d,s){const v=this._getTerminalById(d);v&&v._setProcessId(s)}async $startExtensionTerminal(d,s){const v=this._getTerminalById(d);if(!v)return{message:(0,R.localize)(0,null,d)};v.isOpen||await new Promise(u=>{const D=this.onDidOpenTerminal(async A=>{A===v.value&&(D.dispose(),u())})});const y=this._terminalProcesses.get(d);y?y.startSendingEvents(s):this._extensionTerminalAwaitingStart[d]={initialDimensions:s}}_setupExtHostProcessListeners(d,s){const v=new I.DisposableStore;v.add(s.onProcessReady(u=>this._proxy.$sendProcessReady(d,u.pid,u.cwd))),v.add(s.onDidChangeProperty(u=>this._proxy.$sendProcessProperty(d,u))),this._bufferer.startBuffering(d,s.onProcessData),v.add(s.onProcessExit(u=>this._onProcessExit(d,u))),this._terminalProcesses.set(d,s);const y=this._extensionTerminalAwaitingStart[d];return y&&s instanceof h&&(s.startSendingEvents(y.initialDimensions),delete this._extensionTerminalAwaitingStart[d]),v}$acceptProcessAckDataEvent(d,s){this._terminalProcesses.get(d)?.acknowledgeDataEvent(s)}$acceptProcessInput(d,s){this._terminalProcesses.get(d)?.input(s)}$acceptTerminalInteraction(d){const s=this._getTerminalById(d);s?.setInteractedWith()&&this._onDidChangeTerminalState.fire(s.value)}$acceptProcessResize(d,s,v){try{this._terminalProcesses.get(d)?.resize(s,v)}catch(y){if(y.code!=="EPIPE"&&y.code!=="ERR_IPC_CHANNEL_CLOSED")throw y}}$acceptProcessShutdown(d,s){this._terminalProcesses.get(d)?.shutdown(s)}$acceptProcessRequestInitialCwd(d){this._terminalProcesses.get(d)?.getInitialCwd().then(s=>this._proxy.$sendProcessProperty(d,{type:"initialCwd",value:s}))}$acceptProcessRequestCwd(d){this._terminalProcesses.get(d)?.getCwd().then(s=>this._proxy.$sendProcessProperty(d,{type:"cwd",value:s}))}$acceptProcessRequestLatency(d){return d}registerLinkProvider(d){return this._linkProviders.add(d),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new S.Disposable(()=>{this._linkProviders.delete(d),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(d,s,v){if(this._profileProviders.has(s))throw new Error(`Terminal profile provider "${s}" already registered`);return this._profileProviders.set(s,v),this._proxy.$registerProfileProvider(s,d.identifier.value),new S.Disposable(()=>{this._profileProviders.delete(s),this._proxy.$unregisterProfileProvider(s)})}async $createContributedProfileTerminal(d,s){const v=new n.CancellationTokenSource().token;let y=await this._profileProviders.get(d)?.provideTerminalProfile(v);if(!v.isCancellationRequested){if(y&&!("options"in y)&&(y={options:y}),!y||!("options"in y))throw new Error(`No terminal profile options provided for id "${d}"`);if("pty"in y.options){this.createExtensionTerminal(y.options,s);return}this.createTerminalFromOptions(y.options,s)}}async $provideLinks(d,s){const v=this._getTerminalById(d);if(!v)return[];this._terminalLinkCache.delete(d);const y=this._terminalLinkCancellationSource.get(d);y&&y.dispose(!0);const u=new n.CancellationTokenSource;this._terminalLinkCancellationSource.set(d,u);const D=[],A={terminal:v.value,line:s},U=[];for(const N of this._linkProviders)U.push(C.Promises.withAsyncBody(async L=>{u.token.onCancellationRequested(()=>L({provider:N,links:[]}));const z=await N.provideTerminalLinks(A,u.token)||[];u.token.isCancellationRequested||L({provider:N,links:z})}));const B=await Promise.all(U);if(u.token.isCancellationRequested)return[];const E=new Map;for(const N of B)N&&N.links.length>0&&D.push(...N.links.map(L=>{const z={id:g++,startIndex:L.startIndex,length:L.length,label:L.tooltip};return E.set(z.id,{provider:N.provider,link:L}),z}));return this._terminalLinkCache.set(d,E),D}$activateLink(d,s){const v=this._terminalLinkCache.get(d)?.get(s);!v||v.provider.handleTerminalLink(v.link)}_onProcessExit(d,s){this._bufferer.stopBuffering(d),this._terminalProcesses.delete(d),delete this._extensionTerminalAwaitingStart[d];const v=this._terminalProcessDisposables[d];v&&(v.dispose(),delete this._terminalProcessDisposables[d]),this._proxy.$sendProcessExit(d,s)}_getTerminalById(d){return this._getTerminalObjectById(this._terminals,d)}_getTerminalObjectById(d,s){const v=this._getTerminalObjectIndexById(d,s);return v!==null?d[v]:null}_getTerminalObjectIndexById(d,s){let v=null;return d.some((y,u)=>y._id===s?(v=u,!0):!1),v}getEnvironmentVariableCollection(d){let s=this._environmentVariableCollections.get(d.identifier.value);return s||(s=new l,this._setEnvironmentVariableCollection(d.identifier.value,s)),s}_syncEnvironmentVariableCollection(d,s){const v=(0,_.serializeEnvironmentVariableCollection)(s.map);this._proxy.$setEnvironmentVariableCollection(d,s.persistent,v.length===0?void 0:v)}$initEnvironmentVariableCollections(d){d.forEach(s=>{const v=s[0],y=new l(s[1]);this._setEnvironmentVariableCollection(v,y)})}$acceptDefaultProfile(d,s){this._defaultProfile=d,this._defaultAutomationProfile=s}_setEnvironmentVariableCollection(d,s){this._environmentVariableCollections.set(d,s),s.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(d,s)})}};P=Ue([$e(1,k.IExtHostRpcService)],P),e.BaseExtHostTerminalService=P;class l{constructor(d){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new a.Emitter,this.map=new Map(d)}get persistent(){return this._persistent}set persistent(d){this._persistent=d,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(d,s){this._setIfDiffers(d,{value:s,type:S.EnvironmentVariableMutatorType.Replace})}append(d,s){this._setIfDiffers(d,{value:s,type:S.EnvironmentVariableMutatorType.Append})}prepend(d,s){this._setIfDiffers(d,{value:s,type:S.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(d,s){const v=this.map.get(d);(!v||v.value!==s.value||v.type!==s.type)&&(this.map.set(d,s),this._onDidChangeCollection.fire())}get(d){return this.map.get(d)}forEach(d,s){this.map.forEach((v,y)=>d.call(s,y,v,this))}delete(d){this.map.delete(d),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=l;let M=class extends P{constructor(d){super(!1,d)}createTerminal(d,s,v){throw new F.NotSupportedError}createTerminalFromOptions(d,s){throw new F.NotSupportedError}};M=Ue([$e(0,k.IExtHostRpcService)],M),e.WorkerExtHostTerminalService=M;function r(p){if(!(!p||typeof p=="string"))return"id"in p?{id:p.id,color:p.color}:p}function i(p){return m.ThemeColor.isThemeColor(p)?p:void 0}});var Ze=this&&this.__classPrivateFieldSet||function(re,e,a,t,w){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!w:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?w.call(re,a):w?w.value=a:e.set(re,a),a},Te=this&&this.__classPrivateFieldGet||function(re,e,a,t){if(a==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!t:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?t:a==="a"?t.call(re):t?t.value:e.get(re)};define(Ee[201],ye([0,1,16,22,20,4,230,57,6,26,11,35,5,13,47,8,7,170,88,67]),function(re,e,a,t,w,T,k,I,S,R,F,_,n,f,o,m,c,C,b,h){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let P=class{constructor(A,U){this.resultsChangedEmitter=new T.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=A.getProxy(n.MainContext.MainThreadTesting),this.observer=new v(this.proxy),this.runTracker=new M(this.proxy),U.registerArgumentProcessor({processArgument:B=>B?.$mid===13?m.TestItem.toItemFromContext(B):B})}createTestController(A,U){if(this.controllers.has(A))throw new Error(`Attempt to insert a duplicate controller with ID "${A}"`);const B=new S.DisposableStore,E=B.add(new C.SingleUseTestCollection(A));E.root.label=U;const N=new Map,L=this.proxy,z={items:E.root.children,get label(){return U},set label(j){U=j,E.root.label=j,L.$updateControllerLabel(A,U)},get id(){return A},createRunProfile:(j,ue,G,le,ce)=>{let Y=(0,I.hash)(j);for(;N.has(Y);)Y++;const ie=new y(this.proxy,A,Y,j,ue,G,le,ce);return N.set(Y,ie),ie},createTestItem(j,ue,G){return new o.TestItemImpl(A,j,ue,G)},createTestRun:(j,ue,G=!0)=>this.runTracker.createTestRun(A,E,j,ue,G),set resolveHandler(j){E.resolveHandler=j},get resolveHandler(){return E.resolveHandler},dispose:()=>{B.dispose()}};z.createRunConfiguration=z.createRunProfile,L.$registerTestController(A,U),B.add((0,S.toDisposable)(()=>L.$unregisterTestController(A)));const H={controller:z,collection:E,profiles:N};return this.controllers.set(A,H),B.add((0,S.toDisposable)(()=>this.controllers.delete(A))),B.add(E.onDidGenerateDiff(j=>L.$publishDiff(A,j))),z}createTestObserver(){return this.observer.checkout()}async runTests(A,U=w.CancellationToken.None){const B=r(A);if(!B)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const E=this.controllers.get(B.controllerId);if(!E)throw new Error("Controller not found");await this.proxy.$runTests({targets:[{testIds:A.include?.map(N=>N.id)??[E.collection.root.id],profileGroup:u[B.kind],profileId:B.profileId,controllerId:B.controllerId}],exclude:A.exclude?.map(N=>N.id)},U)}$provideFileCoverage(A,U,B){return(0,a.mapFind)(this.runTracker.trackers,N=>N.id===A?N.getCoverage(U):void 0)?.provideFileCoverage(B)??Promise.resolve([])}$resolveFileCoverage(A,U,B,E){return(0,a.mapFind)(this.runTracker.trackers,L=>L.id===A?L.getCoverage(U):void 0)?.resolveFileCoverage(B,E)??Promise.resolve([])}$configureRunProfile(A,U){this.controllers.get(A)?.profiles.get(U)?.configureHandler?.()}$publishTestResults(A){this.results=Object.freeze(A.map(U=>(0,R.deepFreeze)(m.TestResults.to(U))).concat(this.results).sort((U,B)=>B.completedAt-U.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(A,U){const B=this.controllers.get(h.TestId.fromString(A).controllerId)?.collection;B&&(await B.expand(A,U<0?1/0:U),B.flushDiff())}$acceptDiff(A){this.observer.applyDiff(A)}async $runControllerTests(A,U){const B=this.controllers.get(A.controllerId);if(!B)return;const{collection:E,profiles:N}=B,L=N.get(A.profileId);if(!L)return;const z=A.testIds.map(G=>E.tree.get(G)).filter(F.isDefined),H=A.excludeExtIds.map(G=>B.collection.tree.get(G)).filter(F.isDefined).filter(G=>z.some(le=>le.fullId.compare(G.fullId)===2));if(!z.length)return;const j=new c.TestRunRequest(z.some(G=>G.actual instanceof o.TestItemRootImpl)?void 0:z.map(G=>G.actual),H.map(G=>G.actual),L),ue=this.runTracker.prepareForMainThreadTestRun(j,i.fromInternal(A,B.collection),U);try{await L.runHandler(j,U)}finally{ue.isRunning&&!U.isCancellationRequested&&await T.Event.toPromise(ue.onEnd),ue.dispose()}}$cancelExtensionTestRun(A){A===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(A)}};P=Ue([$e(0,f.IExtHostRpcService)],P),e.ExtHostTesting=P;class l extends S.Disposable{constructor(A,U,B){super();this.dto=A,this.proxy=U,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new T.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new w.CancellationTokenSource(B)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:E}of this.tasks.values())E.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(A){return this.tasks.get(A)?.coverage}createRun(A){const U=this.dto.id,B=this.dto.controllerId,E=(0,_.generateUuid)(),N=new p(this.proxy,U,E),L=ue=>(G,...le)=>{if(H){console.warn(`Setting the state of test "${G.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(G)||(this.ensureTestIsKnown(G),ue(G,...le))},z=(ue,G)=>{const le=G instanceof Array?G.map(m.TestMessage.from):[m.TestMessage.from(G)];if(ue.uri&&ue.range){const ce={range:m.Range.from(ue.range),uri:ue.uri};for(const Y of le)Y.location=Y.location||ce}this.proxy.$appendTestMessagesInRun(U,E,h.TestId.fromExtHostTestItem(ue,B).toString(),le)};let H=!1;const j={isPersisted:this.dto.isPersisted,token:this.cts.token,name:A,get coverageProvider(){return N.coverageProvider},set coverageProvider(ue){N.coverageProvider=ue},enqueued:L(ue=>{this.proxy.$updateTestStateInRun(U,E,h.TestId.fromExtHostTestItem(ue,B).toString(),1)}),skipped:L(ue=>{this.proxy.$updateTestStateInRun(U,E,h.TestId.fromExtHostTestItem(ue,B).toString(),5)}),started:L(ue=>{this.proxy.$updateTestStateInRun(U,E,h.TestId.fromExtHostTestItem(ue,B).toString(),2)}),errored:L((ue,G,le)=>{z(ue,G),this.proxy.$updateTestStateInRun(U,E,h.TestId.fromExtHostTestItem(ue,B).toString(),6,le)}),failed:L((ue,G,le)=>{z(ue,G),this.proxy.$updateTestStateInRun(U,E,h.TestId.fromExtHostTestItem(ue,B).toString(),4,le)}),passed:L((ue,G)=>{this.proxy.$updateTestStateInRun(U,E,h.TestId.fromExtHostTestItem(ue,this.dto.controllerId).toString(),3,G)}),appendOutput:(ue,G,le)=>{H||(le&&(this.dto.isIncluded(le)?this.ensureTestIsKnown(le):le=void 0),this.proxy.$appendOutputToRun(U,E,t.VSBuffer.fromString(ue),G&&m.location.from(G),le&&h.TestId.fromExtHostTestItem(le,B).toString()))},end:()=>{H||(H=!0,this.proxy.$finishedTestRunTask(U,E),this.tasks.delete(E),this.isRunning||this.dispose())}};return this.tasks.set(E,{run:j,coverage:N}),this.proxy.$startedTestRunTask(U,{id:E,name:A,running:!0}),j}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(A){if(!(A instanceof o.TestItemImpl))throw new o.InvalidTestItemError(A.id);if(this.sharedTestIds.has(h.TestId.fromExtHostTestItem(A,this.dto.controllerId).toString()))return;const U=[],B=this.dto.colllection.root;for(;;){const E=m.TestItem.from(A);if(U.unshift(E),this.sharedTestIds.has(E.extId)||(this.sharedTestIds.add(E.extId),A===B))break;A=A.parent||B}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,U)}}class M{constructor(A){this.proxy=A,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(A,U,B){return this.getTracker(A,U,B)}cancelRunById(A){for(const U of this.tracked.values())if(U.id===A){U.dispose();return}}cancelAllRuns(){for(const A of this.tracked.values())A.dispose()}createTestRun(A,U,B,E,N){const L=this.tracked.get(B);if(L)return L.createRun(E);const z=i.fromPublic(A,U,B,N),H=r(B);this.proxy.$startedExtensionTestRun({controllerId:A,profile:H&&{group:u[H.kind],id:H.profileId},exclude:B.exclude?.map(ue=>ue.id)??[],id:z.id,include:B.include?.map(ue=>ue.id)??[U.root.id],persist:N});const j=this.getTracker(B,z);return j.onEnd(()=>this.proxy.$finishedExtensionTestRun(z.id)),j.createRun(E)}getTracker(A,U,B){const E=new l(U,this.proxy,B);return this.tracked.set(A,E),E.onEnd(()=>this.tracked.delete(A)),E}}e.TestRunCoordinator=M;const r=D=>{if(!!D.profile){if(!(D.profile instanceof y))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return D.profile}};class i{constructor(A,U,B,E,N,L){this.controllerId=A,this.id=U,this.isPersisted=N,this.colllection=L,this.includePrefix=B.map(z=>z+"\0"),this.excludePrefix=E.map(z=>z+"\0")}static fromPublic(A,U,B,E){return new i(A,(0,_.generateUuid)(),B.include?.map(N=>h.TestId.fromExtHostTestItem(N,A).toString())??[A],B.exclude?.map(N=>h.TestId.fromExtHostTestItem(N,A).toString())??[],E,U)}static fromInternal(A,U){return new i(A.controllerId,A.runId,A.testIds,A.excludeExtIds,!0,U)}isIncluded(A){const U=h.TestId.fromExtHostTestItem(A,this.controllerId).toString()+"\0";for(const B of this.excludePrefix)if(U===B||U.startsWith(B))return!1;for(const B of this.includePrefix)if(U===B||U.startsWith(B))return!0;return!1}}e.TestRunDto=i;class p{constructor(A,U,B){this.proxy=A,this.runId=U,this.taskId=B}set coverageProvider(A){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!A||(this._coverageProvider=A,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(A){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(A))());try{return(await this.fileCoverage)?.map(m.TestCoverage.fromFile)??[]}catch(U){throw this.fileCoverage=void 0,U}}async resolveFileCoverage(A,U){const B=await this.fileCoverage;let E=B?.[A];return!this._coverageProvider||!B||!E?[]:(E.detailedCoverage||(E=B[A]=await this._coverageProvider.resolveFileCoverage?.(E,U)??E),E.detailedCoverage?.map(m.TestCoverage.fromDetailed)??[])}}class d extends b.IncrementalChangeCollector{constructor(A){super();this.emitter=A,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(A){this.added.add(A)}update(A){Object.assign(A.revived,m.TestItem.toPlain(A.item)),this.added.has(A)||this.updated.add(A)}remove(A){if(this.added.has(A)){this.added.delete(A);return}if(this.updated.delete(A),A.parent&&this.alreadyRemoved.has(A.parent)){this.alreadyRemoved.add(A.item.extId);return}this.removed.add(A)}getChangeEvent(){const{added:A,updated:U,removed:B}=this;return{get added(){return[...A].map(E=>E.revived)},get updated(){return[...U].map(E=>E.revived)},get removed(){return[...B].map(E=>E.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class s extends b.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new T.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(A){return this.items.get(A)}getMirroredTestDataByReference(A){return this.items.get(A.id)}createItem(A,U){return{...A,revived:m.TestItem.toPlain(A.item),depth:U?U.depth+1:0,children:new Set}}createChangeCollector(){return new d(this.changeEmitter)}}e.MirroredTestCollection=s;class v{constructor(A){this.proxy=A}checkout(){this.current||(this.current=this.createObserverData());const A=this.current;return A.observers++,{onDidChangeTest:A.tests.onDidChangeTests,get tests(){return[...A.tests.rootTests].map(U=>U.revived)},dispose:(0,k.once)(()=>{--A.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(A){return this.current?.tests.getMirroredTestDataByReference(A)}applyDiff(A){this.current?.tests.apply(A)}createObserverData(){const A=new s;return this.proxy.$subscribeToDiffs(),{observers:0,tests:A}}}class y{constructor(A,U,B,E,N,L,z=!1,H=void 0){this.controllerId=U,this.profileId=B,this._label=E,this.kind=N,this.runHandler=L,this._isDefault=z,this._tag=H,g.set(this,void 0),Ze(this,g,A,"f");const j=u[N];if(typeof j!="number")throw new Error(`Unknown TestRunProfile.group ${N}`);Te(this,g,"f").$publishTestRunProfile({profileId:B,controllerId:U,tag:H?m.TestTag.namespace(this.controllerId,H.id):null,label:E,group:j,isDefault:z,hasConfigurationHandler:!1})}get label(){return this._label}set label(A){A!==this._label&&(this._label=A,Te(this,g,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:A}))}get isDefault(){return this._isDefault}set isDefault(A){A!==this._isDefault&&(this._isDefault=A,Te(this,g,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:A}))}get tag(){return this._tag}set tag(A){A?.id!==this._tag?.id&&(this._tag=A,Te(this,g,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:A?m.TestTag.namespace(this.controllerId,A.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(A){A!==this._configureHandler&&(this._configureHandler=A,Te(this,g,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!A}))}dispose(){Te(this,g,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=y,g=new WeakMap;const u={[c.TestRunProfileKind.Coverage]:8,[c.TestRunProfileKind.Debug]:4,[c.TestRunProfileKind.Run]:2}}),define(Ee[202],ye([0,1,4,16,5,92,8,7]),function(re,e,a,t,w,T,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class S{constructor(F,_){this._extHostDocumentsAndEditors=_,this._onDidChangeTextEditorSelection=new a.Emitter,this._onDidChangeTextEditorOptions=new a.Emitter,this._onDidChangeTextEditorVisibleRanges=new a.Emitter,this._onDidChangeTextEditorViewColumn=new a.Emitter,this._onDidChangeActiveTextEditor=new a.Emitter,this._onDidChangeVisibleTextEditors=new a.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=F.getProxy(w.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(n=>this._onDidChangeVisibleTextEditors.fire(n)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(n=>this._onDidChangeActiveTextEditor.fire(n))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(F){const _=this._extHostDocumentsAndEditors.allEditors();return F?_:_.map(n=>n.value)}async showTextDocument(F,_,n){let f;typeof _=="number"?f={position:k.ViewColumn.from(_),preserveFocus:n}:typeof _=="object"?f={position:k.ViewColumn.from(_.viewColumn),preserveFocus:_.preserveFocus,selection:typeof _.selection=="object"?k.Range.from(_.selection):void 0,pinned:typeof _.preview=="boolean"?!_.preview:void 0}:f={preserveFocus:!1};const o=await this._proxy.$tryShowTextDocument(F.uri,f),m=o&&this._extHostDocumentsAndEditors.getEditor(o);if(m)return m.value;throw o?new Error(`Could NOT open editor for "${F.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${F.uri.toString()}".`)}createTextEditorDecorationType(F,_){return new T.TextEditorDecorationType(this._proxy,F,_).value}$acceptEditorPropertiesChanged(F,_){const n=this._extHostDocumentsAndEditors.getEditor(F);if(!n)throw new Error("unknown text editor");if(_.options&&n._acceptOptions(_.options),_.selections){const f=_.selections.selections.map(k.Selection.to);n._acceptSelections(f)}if(_.visibleRanges){const f=t.coalesce(_.visibleRanges.map(k.Range.to));n._acceptVisibleRanges(f)}if(_.options&&this._onDidChangeTextEditorOptions.fire({textEditor:n.value,options:{..._.options,lineNumbers:k.TextEditorLineNumbersStyle.to(_.options.lineNumbers)}}),_.selections){const f=I.TextEditorSelectionChangeKind.fromValue(_.selections.source),o=_.selections.selections.map(k.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:n.value,selections:o,kind:f})}if(_.visibleRanges){const f=t.coalesce(_.visibleRanges.map(k.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:n.value,visibleRanges:f})}}$acceptEditorPositionData(F){for(const _ in F){const n=this._extHostDocumentsAndEditors.getEditor(_);if(!n)throw new Error("Unknown text editor");const f=k.ViewColumn.to(F[_]);n.value.viewColumn!==f&&(n._acceptViewColumn(f),this._onDidChangeTextEditorViewColumn.fire({textEditor:n.value,viewColumn:f}))}}getDiffInformation(F){return Promise.resolve(this._proxy.$getDiffInformation(F))}}e.ExtHostEditors=S}),define(Ee[203],ye([0,1,2,3,5,6,7]),function(re,e,a,t,w,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,t.createDecorator)("IExtHostTimeline");class I{constructor(F,_){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=F.getProxy(w.MainContext.MainThreadTimeline),_.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===11){const f=n.uri===void 0?void 0:a.URI.revive(n.uri);return this._itemsBySourceAndUriMap.get(n.source)?.get(S(f))?.get(n.handle)}return n}})}async $getTimeline(F,_,n,f,o){return this._providers.get(F)?.provideTimeline(a.URI.revive(_),n,f,o)}registerTimelineProvider(F,_,n,f){const o=new T.DisposableStore,m=this.convertTimelineItem(_.id,f,o).bind(this);let c;_.onDidChange&&(c=_.onDidChange(b=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...b,id:_.id}),this));const C=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({..._,scheme:F,onDidChange:void 0,async provideTimeline(b,h,g,P){P?.resetCache&&(o.clear(),C.get(_.id)?.clear());const l=await _.provideTimeline(b,h,g);if(l==null)return;const M=m(b,P);return{...l,source:_.id,items:l.items.map(M)}},dispose(){for(const b of C.values())b.get(_.id)?.clear();c?.dispose(),o.dispose()}})}convertTimelineItem(F,_,n){return(f,o)=>{let m;if(o?.cacheResults){let c=this._itemsBySourceAndUriMap.get(F);c===void 0&&(c=new Map,this._itemsBySourceAndUriMap.set(F,c));const C=S(f);m=c.get(C),m===void 0&&(m=new Map,c.set(C,m))}return c=>{const{iconPath:C,...b}=c,h=`${F}|${c.id??c.timestamp}`;m?.set(h,c);let g,P,l;return c.iconPath&&(C instanceof k.ThemeIcon?l={id:C.id,color:C.color}:a.URI.isUri(C)?(g=C,P=C):{light:g,dark:P}=C),{...b,id:b.id??void 0,handle:h,source:F,command:c.command?_.toInternal(c.command,n):void 0,icon:g,iconDark:P,themeIcon:l,accessibilityInformation:c.accessibilityInformation}}}}registerTimelineProviderCore(F){if(this._providers.get(F.id))throw new Error(`Timeline Provider ${F.id} already exists.`);return this._proxy.$registerTimelineProvider({id:F.id,label:F.label,scheme:F.scheme}),this._providers.set(F.id,F),(0,T.toDisposable)(()=>{for(const n of this._itemsBySourceAndUriMap.values())n.get(F.id)?.clear();this._providers.delete(F.id),this._proxy.$unregisterTimelineProvider(F.id),F.dispose()})}}e.ExtHostTimeline=I;function S(R){return R?.toString()}}),define(Ee[204],ye([0,1,6,10,2,5]),function(re,e,a,t,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class k{constructor(S){this._openers=new Map,this._proxy=S.getProxy(T.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(S,R,F,_){if(this._openers.has(R))throw new Error(`Opener with id '${R}' already registered`);const n=_.schemes.find(f=>!k.supportedSchemes.has(f));if(n)throw new Error(`Scheme '${n}' is not supported. Only http and https are currently supported.`);return this._openers.set(R,F),this._proxy.$registerUriOpener(R,_.schemes,S,_.label),(0,a.toDisposable)(()=>{this._openers.delete(R),this._proxy.$unregisterUriOpener(R)})}async $canOpenUri(S,R,F){const _=this._openers.get(S);if(!_)throw new Error(`Unknown opener with id: ${S}`);const n=w.URI.revive(R);return _.canOpenExternalUri(n,F)}async $openUri(S,R,F){const _=this._openers.get(S);if(!_)throw new Error(`Unknown opener id: '${S}'`);return _.openExternalUri(w.URI.revive(R.resolvedUri),{sourceUri:w.URI.revive(R.sourceUri)},F)}}e.ExtHostUriOpeners=k,k.supportedSchemes=new Set([t.Schemas.http,t.Schemas.https])}),define(Ee[205],ye([0,1,5,2,6,15,25]),function(re,e,a,t,w,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class I{constructor(R){this.handles=new Set,this.handlers=new Map,this._proxy=R.getProxy(a.MainContext.MainThreadUrls)}registerUriHandler(R,F){if(this.handles.has(k.ExtensionIdentifier.toKey(R)))throw new Error(`Protocol handler already registered for extension ${R}`);const _=I.HandlePool++;return this.handles.add(k.ExtensionIdentifier.toKey(R)),this.handlers.set(_,F),this._proxy.$registerUriHandler(_,R),(0,w.toDisposable)(()=>{this.handles.delete(k.ExtensionIdentifier.toKey(R)),this.handlers.delete(_),this._proxy.$unregisterUriHandler(_)})}$handleExternalUri(R,F){const _=this.handlers.get(R);if(!_)return Promise.resolve(void 0);try{_.handleUri(t.URI.revive(F))}catch(n){(0,T.onUnexpectedError)(n)}return Promise.resolve(void 0)}async createAppUri(R){return t.URI.revive(await this._proxy.$createAppUri(R))}}e.ExtHostUrls=I,I.HandlePool=0});var Ze=this&&this.__classPrivateFieldSet||function(re,e,a,t,w){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!w:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?w.call(re,a):w?w.value=a:e.set(re,a),a},Te=this&&this.__classPrivateFieldGet||function(re,e,a,t){if(a==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!t:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?t:a==="a"?t.call(re):t?t.value:e.get(re)};define(Ee[50],ye([0,1,4,10,2,132,152,66,5]),function(re,e,a,t,w,T,k,I,S){"use strict";var R,F,_,n,f,o,m,c,C,b,h,g;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class P{constructor(v,y,u,D,A,U,B){R.set(this,void 0),F.set(this,void 0),_.set(this,void 0),n.set(this,void 0),f.set(this,void 0),o.set(this,void 0),m.set(this,""),c.set(this,void 0),C.set(this,!1),b.set(this,!1),h.set(this,!1),this._onMessageEmitter=new a.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,g.set(this,new a.Emitter),this._onDidDispose=Te(this,g,"f").event,Ze(this,R,v,"f"),Ze(this,F,y,"f"),Ze(this,c,u,"f"),Ze(this,n,D,"f"),Ze(this,f,A,"f"),Ze(this,o,U,"f"),Ze(this,h,l(U),"f"),Ze(this,_,B,"f")}dispose(){Ze(this,C,!0,"f"),Te(this,g,"f").fire(),Te(this,g,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(v){return Ze(this,b,!0,"f"),(0,I.asWebviewUri)(v,Te(this,n,"f").remote)}get cspSource(){const v=Te(this,o,"f").extensionLocation;if(v.scheme===t.Schemas.https||v.scheme===t.Schemas.http){let y=v.toString();return y.endsWith("/")||(y+="/"),y+" "+I.webviewGenericCspSource}return I.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Te(this,m,"f")}set html(v){this.assertNotDisposed(),Te(this,m,"f")!==v&&(Ze(this,m,v,"f"),!Te(this,b,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(v)&&(Ze(this,b,!0,"f"),Te(this,_,"f").report("Webview vscode-resource: uris",Te(this,o,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Te(this,F,"f").$setHtml(Te(this,R,"f"),v))}get options(){return this.assertNotDisposed(),Te(this,c,"f")}set options(v){this.assertNotDisposed(),Te(this,F,"f").$setOptions(Te(this,R,"f"),i(Te(this,o,"f"),Te(this,f,"f"),v)),Ze(this,c,v,"f")}async postMessage(v){if(Te(this,C,"f"))return!1;const y=(0,k.serializeWebviewMessage)(v,{serializeBuffersForPostMessage:Te(this,h,"f")});return Te(this,F,"f").$postMessage(Te(this,R,"f"),y.message,...y.buffers)}assertNotDisposed(){if(Te(this,C,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=P,R=new WeakMap,F=new WeakMap,_=new WeakMap,n=new WeakMap,f=new WeakMap,o=new WeakMap,m=new WeakMap,c=new WeakMap,C=new WeakMap,b=new WeakMap,h=new WeakMap,g=new WeakMap;function l(s){try{const v=(0,T.normalizeVersion)((0,T.parseVersion)(s.engines.vscode));return!!v&&v.majorBase>=1&&v.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=l;class M{constructor(v,y,u,D,A){this.initData=y,this.workspace=u,this._logService=D,this._deprecationService=A,this._webviews=new Map,this._webviewProxy=v.getProxy(S.MainContext.MainThreadWebviews)}$onMessage(v,y,u){const D=this.getWebview(v);if(D){const{message:A}=(0,k.deserializeWebviewMessage)(y,u.value);D._onMessageEmitter.fire(A)}}$onMissingCsp(v,y){this._logService.warn(`${y} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(v,y,u){const D=new P(v,this._webviewProxy,p(y),this.initData,this.workspace,u,this._deprecationService);return this._webviews.set(v,D),D._onDidDispose(()=>{this._webviews.delete(v)}),D}deleteWebview(v){this._webviews.delete(v)}getWebview(v){return this._webviews.get(v)}}e.ExtHostWebviews=M;function r(s){return{id:s.identifier,location:s.extensionLocation}}e.toExtensionData=r;function i(s,v,y){return{enableCommandUris:y.enableCommandUris,enableScripts:y.enableScripts,enableForms:y.enableForms,portMapping:y.portMapping,localResourceRoots:y.localResourceRoots||d(s,v)}}e.serializeWebviewOptions=i;function p(s){return{enableCommandUris:s.enableCommandUris,enableScripts:s.enableScripts,enableForms:s.enableForms,portMapping:s.portMapping,localResourceRoots:s.localResourceRoots?.map(v=>w.URI.from(v))}}e.reviveOptions=p;function d(s,v){return[...(v?.getWorkspaceFolders()||[]).map(y=>y.uri),s.extensionLocation]}}),define(Ee[206],ye([0,1,20,57,6,10,24,2,8,50,63,5,7]),function(re,e,a,t,w,T,k,I,S,R,F,_,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class f{constructor(l,M){this.document=l,this._storagePath=M,this._backupCounter=1,this._edits=new F.Cache("custom documents")}addEdit(l){return this._edits.add([l])}async undo(l,M){await this.getEdit(l).undo(),M||this.disposeBackup()}async redo(l,M){await this.getEdit(l).redo(),M||this.disposeBackup()}disposeEdits(l){for(const M of l)this._edits.delete(M)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const l=g(this.document.uri)+this._backupCounter++;return(0,k.joinPath)(this._storagePath,l)}updateBackup(l){this._backup?.delete(),this._backup=l}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(l){const M=this._edits.get(l,0);if(!M)throw new Error("No edit found");return M}}class o{constructor(){this._documents=new Map}get(l,M){return this._documents.get(this.key(l,M))}add(l,M,r){const i=this.key(l,M.uri);if(this._documents.has(i))throw new Error(`Document already exists for viewType:${l} resource:${M.uri}`);const p=new f(M,r);return this._documents.set(i,p),p}delete(l,M){const r=this.key(l,M.uri);this._documents.delete(r)}key(l,M){return`${l}@@@${M}`}}var m;(function(P){P[P.Text=0]="Text",P[P.Custom=1]="Custom"})(m||(m={}));class c{constructor(){this._providers=new Map}addTextProvider(l,M,r){return this.add(0,l,M,r)}addCustomProvider(l,M,r){return this.add(1,l,M,r)}get(l){return this._providers.get(l)}add(l,M,r,i){if(this._providers.has(M))throw new Error(`Provider for viewType:${M} already registered`);return this._providers.set(M,{type:l,extension:r,provider:i}),new n.Disposable(()=>this._providers.delete(M))}}class C{constructor(l,M,r,i,p){this._extHostDocuments=M,this._extensionStoragePaths=r,this._extHostWebview=i,this._extHostWebviewPanels=p,this._editorProviders=new c,this._documents=new o,this._proxy=l.getProxy(_.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(l,M,r,i){const p=new w.DisposableStore;return b(r)?(p.add(this._editorProviders.addTextProvider(M,l,r)),this._proxy.$registerTextEditorProvider((0,R.toExtensionData)(l),M,i.webviewOptions||{},{supportsMove:!!r.moveCustomTextEditor},(0,R.shouldSerializeBuffersForPostMessage)(l))):(p.add(this._editorProviders.addCustomProvider(M,l,r)),this.supportEditing(r)&&p.add(r.onDidChangeCustomDocument(d=>{const s=this.getCustomDocumentEntry(M,d.document.uri);if(h(d)){const v=s.addEdit(d);this._proxy.$onDidEdit(d.document.uri,M,v,d.label)}else this._proxy.$onContentChange(d.document.uri,M)})),this._proxy.$registerCustomEditorProvider((0,R.toExtensionData)(l),M,i.webviewOptions||{},!!i.supportsMultipleEditorsPerDocument,(0,R.shouldSerializeBuffersForPostMessage)(l))),n.Disposable.from(p,new n.Disposable(()=>{this._proxy.$unregisterEditorProvider(M)}))}async $createCustomDocument(l,M,r,i,p){const d=this._editorProviders.get(M);if(!d)throw new Error(`No provider found for '${M}'`);if(d.type!==1)throw new Error(`Invalid provide type for '${M}'`);const s=I.URI.revive(l),v=await d.provider.openCustomDocument(s,{backupId:r,untitledDocumentData:i?.buffer},p);let y;return this.supportEditing(d.provider)&&this._extensionStoragePaths&&(y=this._extensionStoragePaths.workspaceValue(d.extension)??this._extensionStoragePaths.globalValue(d.extension)),this._documents.add(M,v,y),{editable:this.supportEditing(d.provider)}}async $disposeCustomDocument(l,M){const r=this._editorProviders.get(M);if(!r)throw new Error(`No provider found for '${M}'`);if(r.type!==1)throw new Error(`Invalid provider type for '${M}'`);const i=I.URI.revive(l),{document:p}=this.getCustomDocumentEntry(M,i);this._documents.delete(M,p),p.dispose()}async $resolveWebviewEditor(l,M,r,i,p,d){const s=this._editorProviders.get(r);if(!s)throw new Error(`No provider found for '${r}'`);const v=S.ViewColumn.to(p),y=this._extHostWebview.createNewWebview(M,i.webviewOptions,s.extension),u=this._extHostWebviewPanels.createNewWebviewPanel(M,r,i.title,v,i.panelOptions,y),D=I.URI.revive(l);switch(s.type){case 1:{const{document:A}=this.getCustomDocumentEntry(r,D);return s.provider.resolveCustomEditor(A,u,d)}case 0:{const A=this._extHostDocuments.getDocument(D);return s.provider.resolveCustomTextEditor(A,u,d)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(l,M,r){this.getCustomDocumentEntry(M,l).disposeEdits(r)}async $onMoveCustomEditor(l,M,r){const i=this._editorProviders.get(r);if(!i)throw new Error(`No provider found for '${r}'`);if(!i.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${r}'`);const p=this._extHostWebviewPanels.getWebviewPanel(l);if(!p)throw new Error("No webview found");const d=I.URI.revive(M),s=this._extHostDocuments.getDocument(d);await i.provider.moveCustomTextEditor(s,p,a.CancellationToken.None)}async $undo(l,M,r,i){return this.getCustomDocumentEntry(M,l).undo(r,i)}async $redo(l,M,r,i){return this.getCustomDocumentEntry(M,l).redo(r,i)}async $revert(l,M,r){const i=this.getCustomDocumentEntry(M,l);await this.getCustomEditorProvider(M).revertCustomDocument(i.document,r),i.disposeBackup()}async $onSave(l,M,r){const i=this.getCustomDocumentEntry(M,l);await this.getCustomEditorProvider(M).saveCustomDocument(i.document,r),i.disposeBackup()}async $onSaveAs(l,M,r,i){const p=this.getCustomDocumentEntry(M,l);return this.getCustomEditorProvider(M).saveCustomDocumentAs(p.document,I.URI.revive(r),i)}async $backup(l,M,r){const i=this.getCustomDocumentEntry(M,l),d=await this.getCustomEditorProvider(M).backupCustomDocument(i.document,{destination:i.getNewBackupUri()},r);return i.updateBackup(d),d.id}getCustomDocumentEntry(l,M){const r=this._documents.get(l,I.URI.revive(M));if(!r)throw new Error("No custom document found");return r}getCustomEditorProvider(l){const r=this._editorProviders.get(l)?.provider;if(!r||!this.supportEditing(r))throw new Error("Custom document is not editable");return r}supportEditing(l){return!!l.onDidChangeCustomDocument}}e.ExtHostCustomEditors=C;function b(P){return typeof P.resolveCustomTextEditor=="function"}function h(P){return typeof P.undo=="function"&&typeof P.redo=="function"}function g(P){const l=P.scheme===T.Schemas.file||P.scheme===T.Schemas.untitled?P.fsPath:P.toString();return(0,t.hash)(l)+""}});var Ze=this&&this.__classPrivateFieldSet||function(re,e,a,t,w){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!w:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?w.call(re,a):w?w.value=a:e.set(re,a),a},Te=this&&this.__classPrivateFieldGet||function(re,e,a,t){if(a==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!t:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?t:a==="a"?t.call(re):t?t.value:e.get(re)};define(Ee[207],ye([0,1,4,6,2,35,8,50,5,7]),function(re,e,a,t,w,T,k,I,S,R){"use strict";var F,_,n,f,o,m,c,C,b,h,g,P,l;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class M extends t.Disposable{constructor(d,s,v,y,u,D,A){super();F.set(this,void 0),_.set(this,void 0),n.set(this,void 0),f.set(this,void 0),o.set(this,void 0),m.set(this,void 0),c.set(this,void 0),C.set(this,void 0),b.set(this,!0),h.set(this,!0),g.set(this,!1),P.set(this,this._register(new a.Emitter)),this.onDidDispose=Te(this,P,"f").event,l.set(this,this._register(new a.Emitter)),this.onDidChangeViewState=Te(this,l,"f").event,Ze(this,F,d,"f"),Ze(this,_,s,"f"),Ze(this,n,v,"f"),Ze(this,o,D,"f"),Ze(this,C,u,"f"),Ze(this,m,y,"f"),Ze(this,f,A,"f")}dispose(){Te(this,g,"f")||(Ze(this,g,!0,"f"),Te(this,P,"f").fire(),Te(this,_,"f").$disposeWebview(Te(this,F,"f")),Te(this,f,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Te(this,f,"f")}get viewType(){return this.assertNotDisposed(),Te(this,n,"f")}get title(){return this.assertNotDisposed(),Te(this,m,"f")}set title(d){this.assertNotDisposed(),Te(this,m,"f")!==d&&(Ze(this,m,d,"f"),Te(this,_,"f").$setTitle(Te(this,F,"f"),d))}get iconPath(){return this.assertNotDisposed(),Te(this,c,"f")}set iconPath(d){this.assertNotDisposed(),Te(this,c,"f")!==d&&(Ze(this,c,d,"f"),Te(this,_,"f").$setIconPath(Te(this,F,"f"),w.URI.isUri(d)?{light:d,dark:d}:d))}get options(){return Te(this,o,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Te(this,C,"f")=="number"&&Te(this,C,"f")<0))return Te(this,C,"f")}get active(){return this.assertNotDisposed(),Te(this,h,"f")}get visible(){return this.assertNotDisposed(),Te(this,b,"f")}_updateViewState(d){Te(this,g,"f")||(this.active!==d.active||this.visible!==d.visible||this.viewColumn!==d.viewColumn)&&(Ze(this,h,d.active,"f"),Ze(this,b,d.visible,"f"),Ze(this,C,d.viewColumn,"f"),Te(this,l,"f").fire({webviewPanel:this}))}reveal(d,s){this.assertNotDisposed(),Te(this,_,"f").$reveal(Te(this,F,"f"),{viewColumn:d?k.ViewColumn.from(d):void 0,preserveFocus:!!s})}assertNotDisposed(){if(Te(this,g,"f"))throw new Error("Webview is disposed")}}F=new WeakMap,_=new WeakMap,n=new WeakMap,f=new WeakMap,o=new WeakMap,m=new WeakMap,c=new WeakMap,C=new WeakMap,b=new WeakMap,h=new WeakMap,g=new WeakMap,P=new WeakMap,l=new WeakMap;class r{constructor(d,s,v){this.webviews=s,this.workspace=v,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=d.getProxy(S.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,T.generateUuid)()}createWebviewPanel(d,s,v,y,u={}){const D=typeof y=="object"?y.viewColumn:y,A={viewColumn:k.ViewColumn.from(D),preserveFocus:typeof y=="object"&&!!y.preserveFocus},U=(0,I.shouldSerializeBuffersForPostMessage)(d),B=r.newHandle();this._proxy.$createWebviewPanel((0,I.toExtensionData)(d),B,s,{title:v,panelOptions:i(u),webviewOptions:(0,I.serializeWebviewOptions)(d,this.workspace,u),serializeBuffersForPostMessage:U},A);const E=this.webviews.createNewWebview(B,u,d);return this.createNewWebviewPanel(B,s,v,D,u,E)}$onDidChangeWebviewPanelViewStates(d){const s=Object.keys(d);s.sort((v,y)=>{const u=d[v],D=d[y];return u.active?1:D.active?-1:+u.visible-+D.visible});for(const v of s){const y=this.getWebviewPanel(v);if(!y)continue;const u=d[v];y._updateViewState({active:u.active,visible:u.visible,viewColumn:k.ViewColumn.to(u.position)})}}async $onDidDisposeWebviewPanel(d){this.getWebviewPanel(d)?.dispose(),this._webviewPanels.delete(d),this.webviews.deleteWebview(d)}registerWebviewPanelSerializer(d,s,v){if(this._serializers.has(s))throw new Error(`Serializer for '${s}' already registered`);return this._serializers.set(s,{serializer:v,extension:d}),this._proxy.$registerSerializer(s,{serializeBuffersForPostMessage:(0,I.shouldSerializeBuffersForPostMessage)(d)}),new R.Disposable(()=>{this._serializers.delete(s),this._proxy.$unregisterSerializer(s)})}async $deserializeWebviewPanel(d,s,v,y){const u=this._serializers.get(s);if(!u)throw new Error(`No serializer found for '${s}'`);const{serializer:D,extension:A}=u,U=this.webviews.createNewWebview(d,v.webviewOptions,A),B=this.createNewWebviewPanel(d,s,v.title,y,v.panelOptions,U);await D.deserializeWebviewPanel(B,v.state)}createNewWebviewPanel(d,s,v,y,u,D){const A=new M(d,this._proxy,s,v,y,u,D);return this._webviewPanels.set(d,A),A}getWebviewPanel(d){return this._webviewPanels.get(d)}}e.ExtHostWebviewPanels=r;function i(p){return{enableFindWidget:p.enableFindWidget,retainContextWhenHidden:p.retainContextWhenHidden}}});var Ze=this&&this.__classPrivateFieldSet||function(re,e,a,t,w){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!w:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?w.call(re,a):w?w.value=a:e.set(re,a),a},Te=this&&this.__classPrivateFieldGet||function(re,e,a,t){if(a==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!t:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?t:a==="a"?t.call(re):t?t.value:e.get(re)};define(Ee[208],ye([0,1,4,6,50,5,7]),function(re,e,a,t,w,T,k){"use strict";var I,S,R,F,_,n,f,o,m,c;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class C extends t.Disposable{constructor(g,P,l,M,r,i){super();I.set(this,void 0),S.set(this,void 0),R.set(this,void 0),F.set(this,void 0),_.set(this,!1),n.set(this,void 0),f.set(this,void 0),o.set(this,void 0),m.set(this,this._register(new a.Emitter)),this.onDidChangeVisibility=Te(this,m,"f").event,c.set(this,this._register(new a.Emitter)),this.onDidDispose=Te(this,c,"f").event,Ze(this,R,l,"f"),Ze(this,f,M,"f"),Ze(this,I,g,"f"),Ze(this,S,P,"f"),Ze(this,F,r,"f"),Ze(this,n,i,"f")}dispose(){Te(this,_,"f")||(Ze(this,_,!0,"f"),Te(this,c,"f").fire(),Te(this,F,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Te(this,f,"f")}set title(g){this.assertNotDisposed(),Te(this,f,"f")!==g&&(Ze(this,f,g,"f"),Te(this,S,"f").$setWebviewViewTitle(Te(this,I,"f"),g))}get description(){return this.assertNotDisposed(),Te(this,o,"f")}set description(g){this.assertNotDisposed(),Te(this,o,"f")!==g&&(Ze(this,o,g,"f"),Te(this,S,"f").$setWebviewViewDescription(Te(this,I,"f"),g))}get visible(){return Te(this,n,"f")}get webview(){return Te(this,F,"f")}get viewType(){return Te(this,R,"f")}_setVisible(g){g===Te(this,n,"f")||Te(this,_,"f")||(Ze(this,n,g,"f"),Te(this,m,"f").fire())}show(g){this.assertNotDisposed(),Te(this,S,"f").$show(Te(this,I,"f"),!!g)}assertNotDisposed(){if(Te(this,_,"f"))throw new Error("Webview is disposed")}}I=new WeakMap,S=new WeakMap,R=new WeakMap,F=new WeakMap,_=new WeakMap,n=new WeakMap,f=new WeakMap,o=new WeakMap,m=new WeakMap,c=new WeakMap;class b{constructor(g,P){this._extHostWebview=P,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=g.getProxy(T.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(g,P,l,M){if(this._viewProviders.has(P))throw new Error(`View provider for '${P}' already registered`);return this._viewProviders.set(P,{provider:l,extension:g}),this._proxy.$registerWebviewViewProvider((0,w.toExtensionData)(g),P,{retainContextWhenHidden:M?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new k.Disposable(()=>{this._viewProviders.delete(P),this._proxy.$unregisterWebviewViewProvider(P)})}async $resolveWebviewView(g,P,l,M,r){const i=this._viewProviders.get(P);if(!i)throw new Error(`No view provider found for '${P}'`);const{provider:p,extension:d}=i,s=this._extHostWebview.createNewWebview(g,{},d),v=new C(g,this._proxy,P,l,s,!0);this._webviewViews.set(g,v),await p.resolveWebviewView(v,{state:M},r)}async $onDidChangeWebviewViewVisibility(g,P){this.getWebviewView(g)._setVisible(P)}async $disposeWebviewView(g){const P=this.getWebviewView(g);this._webviewViews.delete(g),P.dispose(),this._extHostWebview.deleteWebview(g)}getWebviewView(g){const P=this._webviewViews.get(g);if(!P)throw new Error("No webview found");return P}}e.ExtHostWebviewViews=b}),define(Ee[95],ye([0,1,4,5,2,10,9,3,13]),function(re,e,a,t,w,T,k,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let R=class Wi{constructor(_){this._onDidChangeWindowState=new a.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Wi.InitialState,this._proxy=_.getProxy(t.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(n=>this.$onDidChangeWindowFocus(n))}get state(){return this._state}$onDidChangeWindowFocus(_){_!==this._state.focused&&(this._state={...this._state,focused:_},this._onDidChangeWindowState.fire(this._state))}openUri(_,n){let f;if(typeof _=="string"){f=_;try{_=w.URI.parse(_)}catch{return Promise.reject(`Invalid uri - '${_}'`)}}return(0,k.isFalsyOrWhitespace)(_.scheme)?Promise.reject("Invalid scheme - cannot be empty"):_.scheme===T.Schemas.command?Promise.reject(`Invalid scheme '${_.scheme}'`):this._proxy.$openUri(_,f,n)}async asExternalUri(_,n){if((0,k.isFalsyOrWhitespace)(_.scheme))return Promise.reject("Invalid scheme - cannot be empty");const f=await this._proxy.$asExternalUri(_,n);return w.URI.from(f)}};R.InitialState={focused:!0},R=Ue([$e(0,S.IExtHostRpcService)],R),e.ExtHostWindow=R,e.IExtHostWindow=(0,I.createDecorator)("IExtHostWindow")}),define(Ee[209],ye([0,1,14,22,20,15,4,6,106,176,37]),function(re,e,a,t,w,T,k,I,S,R,F){"use strict";var _;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function n(u,D){try{return JSON.stringify(u,D)}catch{return"null"}}const f="$$ref$$",o={[f]:-1};class m{constructor(D,A){this.jsonString=D,this.referencedBuffers=A}}function c(u,D=null,A=!1){const U=[];return{jsonString:(A?n:JSON.stringify)(u,(E,N)=>{if(typeof N=="undefined")return o;if(typeof N=="object"){if(N instanceof t.VSBuffer){const L=U.push(N)-1;return{[f]:L}}if(D)return D(E,N)}return N}),referencedBuffers:U}}e.stringifyJsonWithBufferRefs=c;function C(u,D,A){return JSON.parse(u,(U,B)=>{if(B){const E=B[f];if(typeof E=="number")return D[E];if(A&&B.$mid===1)return A.transformIncoming(B)}return B})}e.parseJsonAndRestoreBufferRefs=C;function b(u,D){return JSON.stringify(u,D)}function h(u){return u?(D,A)=>A&&A.$mid===1?u.transformOutgoing(A):A:null}var g;(function(u){u[u.LocalSide=0]="LocalSide",u[u.OtherSide=1]="OtherSide"})(g=e.RequestInitiator||(e.RequestInitiator={}));var P;(function(u){u[u.Responsive=0]="Responsive",u[u.Unresponsive=1]="Unresponsive"})(P=e.ResponsiveState||(e.ResponsiveState={}));const l=()=>{},M=Symbol.for("rpcProtocol"),r=Symbol.for("rpcProxy");class i extends I.Disposable{constructor(D,A=null,U=null){super();this[_]=!0,this._onDidChangeResponsiveState=this._register(new k.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=D,this._logger=A,this._uriTransformer=U,this._uriReplacer=h(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let B=0,E=F.ProxyIdentifier.count;B<E;B++)this._locals[B]=null,this._proxies[B]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new a.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(B=>this._receiveOneMessage(B))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(D=>{this._pendingRPCReplies[D].resolveErr(T.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(D){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(D){this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(D){this._responsiveState!==D&&(this._responsiveState=D,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(D){return this._uriTransformer?(0,S.transformIncomingURIs)(D,this._uriTransformer):D}getProxy(D){const{nid:A,sid:U}=D;return this._proxies[A]||(this._proxies[A]=this._createProxy(A,U)),this._proxies[A]}_createProxy(D,A){let U={get:(B,E)=>(typeof E=="string"&&!B[E]&&E.charCodeAt(0)===36&&(B[E]=(...N)=>this._remoteCall(D,E,N)),E===r?A:B[E])};return new Proxy(Object.create(null),U)}set(D,A){return this._locals[D.nid]=A,A}assertRegistered(D){for(let A=0,U=D.length;A<U;A++){const B=D[A];if(!this._locals[B.nid])throw new Error(`Missing actor ${B.sid} (isMain: ${B.isMain})`)}}_receiveOneMessage(D){if(this._isDisposed)return;const A=D.byteLength,U=p.read(D,0),B=U.readUInt8(),E=U.readUInt32();switch(B){case 1:case 2:{let{rpcId:N,method:L,args:z}=s.deserializeRequestJSONArgs(U);this._uriTransformer&&(z=(0,S.transformIncomingURIs)(z,this._uriTransformer)),this._receiveRequest(A,E,N,L,z,B===2);break}case 3:case 4:{let{rpcId:N,method:L,args:z}=s.deserializeRequestMixedArgs(U);this._uriTransformer&&(z=(0,S.transformIncomingURIs)(z,this._uriTransformer)),this._receiveRequest(A,E,N,L,z,B===4);break}case 5:{this._logger&&this._logger.logIncoming(A,E,0,"ack"),this._onDidReceiveAcknowledge(E);break}case 6:{this._receiveCancel(A,E);break}case 7:{this._receiveReply(A,E,void 0);break}case 9:{let N=s.deserializeReplyOKJSON(U);this._uriTransformer&&(N=(0,S.transformIncomingURIs)(N,this._uriTransformer)),this._receiveReply(A,E,N);break}case 10:{const N=s.deserializeReplyOKJSONWithBuffers(U,this._uriTransformer);this._receiveReply(A,E,N);break}case 8:{let N=s.deserializeReplyOKVSBuffer(U);this._receiveReply(A,E,N);break}case 11:{let N=s.deserializeReplyErrError(U);this._uriTransformer&&(N=(0,S.transformIncomingURIs)(N,this._uriTransformer)),this._receiveReplyErr(A,E,N);break}case 12:{this._receiveReplyErr(A,E,void 0);break}default:console.error("received unexpected message"),console.error(D)}}_receiveRequest(D,A,U,B,E,N){this._logger&&this._logger.logIncoming(D,A,1,`receiveRequest ${(0,F.getStringIdentifierForProxy)(U)}.${B}(`,E);const L=String(A);let z,H;if(N){const ue=new w.CancellationTokenSource;E.push(ue.token),z=this._invokeHandler(U,B,E),H=()=>ue.cancel()}else z=this._invokeHandler(U,B,E),H=l;this._cancelInvokedHandlers[L]=H;const j=s.serializeAcknowledged(A);this._logger&&this._logger.logOutgoing(j.byteLength,A,1,"ack"),this._protocol.send(j),z.then(ue=>{delete this._cancelInvokedHandlers[L];const G=s.serializeReplyOK(A,ue,this._uriReplacer);this._logger&&this._logger.logOutgoing(G.byteLength,A,1,"reply:",ue),this._protocol.send(G)},ue=>{delete this._cancelInvokedHandlers[L];const G=s.serializeReplyErr(A,ue);this._logger&&this._logger.logOutgoing(G.byteLength,A,1,"replyErr:",ue),this._protocol.send(G)})}_receiveCancel(D,A){this._logger&&this._logger.logIncoming(D,A,1,"receiveCancel");const U=String(A);this._cancelInvokedHandlers[U]&&this._cancelInvokedHandlers[U]()}_receiveReply(D,A,U){this._logger&&this._logger.logIncoming(D,A,0,"receiveReply:",U);const B=String(A);if(!this._pendingRPCReplies.hasOwnProperty(B))return;const E=this._pendingRPCReplies[B];delete this._pendingRPCReplies[B],E.resolveOk(U)}_receiveReplyErr(D,A,U){this._logger&&this._logger.logIncoming(D,A,0,"receiveReplyErr:",U);const B=String(A);if(!this._pendingRPCReplies.hasOwnProperty(B))return;const E=this._pendingRPCReplies[B];delete this._pendingRPCReplies[B];let N;U&&(U.$isError?(N=new Error,N.name=U.name,N.message=U.message,N.stack=U.stack):N=U),E.resolveErr(N)}_invokeHandler(D,A,U){try{return Promise.resolve(this._doInvokeHandler(D,A,U))}catch(B){return Promise.reject(B)}}_doInvokeHandler(D,A,U){const B=this._locals[D];if(!B)throw new Error("Unknown actor "+(0,F.getStringIdentifierForProxy)(D));let E=B[A];if(typeof E!="function")throw new Error("Unknown method "+A+" on actor "+(0,F.getStringIdentifierForProxy)(D));return E.apply(B,U)}_remoteCall(D,A,U){if(this._isDisposed)return Promise.reject(T.canceled());let B=null;if(U.length>0&&w.CancellationToken.isCancellationToken(U[U.length-1])&&(B=U.pop()),B&&B.isCancellationRequested)return Promise.reject(T.canceled());const E=s.serializeRequestArguments(U,this._uriReplacer),N=++this._lastMessageId,L=String(N),z=new R.LazyPromise;B&&B.onCancellationRequested(()=>{const j=s.serializeCancel(N);this._logger&&this._logger.logOutgoing(j.byteLength,N,0,"cancel"),this._protocol.send(s.serializeCancel(N))}),this._pendingRPCReplies[L]=z,this._onWillSendRequest(N);const H=s.serializeRequest(N,D,A,E,!!B);return this._logger&&this._logger.logOutgoing(H.byteLength,N,0,`request: ${(0,F.getStringIdentifierForProxy)(D)}.${A}(`,U),this._protocol.send(H),z}}e.RPCProtocol=i,_=M,i.UNRESPONSIVE_TIME=3*1e3;class p{constructor(D,A){this._buff=D,this._offset=A}static alloc(D,A,U){let B=new p(t.VSBuffer.alloc(U+1+4),0);return B.writeUInt8(D),B.writeUInt32(A),B}static read(D,A){return new p(D,A)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(D){this._buff.writeUInt8(D,this._offset),this._offset+=1}readUInt8(){const D=this._buff.readUInt8(this._offset);return this._offset+=1,D}writeUInt32(D){this._buff.writeUInt32BE(D,this._offset),this._offset+=4}readUInt32(){const D=this._buff.readUInt32BE(this._offset);return this._offset+=4,D}static sizeShortString(D){return 1+D.byteLength}writeShortString(D){this._buff.writeUInt8(D.byteLength,this._offset),this._offset+=1,this._buff.set(D,this._offset),this._offset+=D.byteLength}readShortString(){const D=this._buff.readUInt8(this._offset);this._offset+=1;const U=this._buff.slice(this._offset,this._offset+D).toString();return this._offset+=D,U}static sizeLongString(D){return 4+D.byteLength}writeLongString(D){this._buff.writeUInt32BE(D.byteLength,this._offset),this._offset+=4,this._buff.set(D,this._offset),this._offset+=D.byteLength}readLongString(){const D=this._buff.readUInt32BE(this._offset);this._offset+=4;const U=this._buff.slice(this._offset,this._offset+D).toString();return this._offset+=D,U}writeBuffer(D){this._buff.writeUInt32BE(D.byteLength,this._offset),this._offset+=4,this._buff.set(D,this._offset),this._offset+=D.byteLength}static sizeVSBuffer(D){return 4+D.byteLength}writeVSBuffer(D){this._buff.writeUInt32BE(D.byteLength,this._offset),this._offset+=4,this._buff.set(D,this._offset),this._offset+=D.byteLength}readVSBuffer(){const D=this._buff.readUInt32BE(this._offset);this._offset+=4;const A=this._buff.slice(this._offset,this._offset+D);return this._offset+=D,A}static sizeMixedArray(D){let A=0;A+=1;for(let U=0,B=D.length;U<B;U++){const E=D[U];switch(A+=1,E.type){case 1:A+=this.sizeLongString(E.value);break;case 2:A+=this.sizeVSBuffer(E.value);break;case 3:A+=this.sizeUInt32,A+=this.sizeLongString(E.value);for(let N=0;N<E.buffers.length;++N)A+=this.sizeVSBuffer(E.buffers[N]);break;case 4:break}}return A}writeMixedArray(D){this._buff.writeUInt8(D.length,this._offset),this._offset+=1;for(let A=0,U=D.length;A<U;A++){const B=D[A];switch(B.type){case 1:this.writeUInt8(1),this.writeLongString(B.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(B.value);break;case 3:this.writeUInt8(3),this.writeUInt32(B.buffers.length),this.writeLongString(B.value);for(let E=0;E<B.buffers.length;++E)this.writeBuffer(B.buffers[E]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const D=this._buff.readUInt8(this._offset);this._offset+=1;let A=new Array(D);for(let U=0;U<D;U++)switch(this.readUInt8()){case 1:A[U]=this.readLongString();break;case 2:A[U]=this.readVSBuffer();break;case 3:const E=this.readUInt32(),N=this.readLongString(),L=[];for(let z=0;z<E;++z)L.push(this.readVSBuffer());A[U]=new F.SerializableObjectWithBuffers(C(N,L,null));break;case 4:A[U]=void 0;break}return A}}p.sizeUInt32=4;var d;(function(u){u[u.Simple=0]="Simple",u[u.Mixed=1]="Mixed"})(d||(d={}));class s{static _useMixedArgSerialization(D){for(let A=0,U=D.length;A<U;A++)if(D[A]instanceof t.VSBuffer||D[A]instanceof F.SerializableObjectWithBuffers||typeof D[A]=="undefined")return!0;return!1}static serializeRequestArguments(D,A){if(this._useMixedArgSerialization(D)){const U=[];for(let B=0,E=D.length;B<E;B++){const N=D[B];if(N instanceof t.VSBuffer)U[B]={type:2,value:N};else if(typeof N=="undefined")U[B]={type:4};else if(N instanceof F.SerializableObjectWithBuffers){const{jsonString:L,referencedBuffers:z}=c(N.value,A);U[B]={type:3,value:t.VSBuffer.fromString(L),buffers:z}}else U[B]={type:1,value:t.VSBuffer.fromString(b(N,A))}}return{type:1,args:U}}return{type:0,args:b(D,A)}}static serializeRequest(D,A,U,B,E){switch(B.type){case 0:return this._requestJSONArgs(D,A,U,B.args,E);case 1:return this._requestMixedArgs(D,A,U,B.args,E)}}static _requestJSONArgs(D,A,U,B,E){const N=t.VSBuffer.fromString(U),L=t.VSBuffer.fromString(B);let z=0;z+=p.sizeUInt8(),z+=p.sizeShortString(N),z+=p.sizeLongString(L);let H=p.alloc(E?2:1,D,z);return H.writeUInt8(A),H.writeShortString(N),H.writeLongString(L),H.buffer}static deserializeRequestJSONArgs(D){const A=D.readUInt8(),U=D.readShortString(),B=D.readLongString();return{rpcId:A,method:U,args:JSON.parse(B)}}static _requestMixedArgs(D,A,U,B,E){const N=t.VSBuffer.fromString(U);let L=0;L+=p.sizeUInt8(),L+=p.sizeShortString(N),L+=p.sizeMixedArray(B);let z=p.alloc(E?4:3,D,L);return z.writeUInt8(A),z.writeShortString(N),z.writeMixedArray(B),z.buffer}static deserializeRequestMixedArgs(D){const A=D.readUInt8(),U=D.readShortString(),B=D.readMixedArray(),E=new Array(B.length);for(let N=0,L=B.length;N<L;N++){const z=B[N];typeof z=="string"?E[N]=JSON.parse(z):E[N]=z}return{rpcId:A,method:U,args:E}}static serializeAcknowledged(D){return p.alloc(5,D,0).buffer}static serializeCancel(D){return p.alloc(6,D,0).buffer}static serializeReplyOK(D,A,U){if(typeof A=="undefined")return this._serializeReplyOKEmpty(D);if(A instanceof t.VSBuffer)return this._serializeReplyOKVSBuffer(D,A);if(A instanceof F.SerializableObjectWithBuffers){const{jsonString:B,referencedBuffers:E}=c(A.value,U,!0);return this._serializeReplyOKJSONWithBuffers(D,B,E)}else return this._serializeReplyOKJSON(D,n(A,U))}static _serializeReplyOKEmpty(D){return p.alloc(7,D,0).buffer}static _serializeReplyOKVSBuffer(D,A){let U=0;U+=p.sizeVSBuffer(A);let B=p.alloc(8,D,U);return B.writeVSBuffer(A),B.buffer}static deserializeReplyOKVSBuffer(D){return D.readVSBuffer()}static _serializeReplyOKJSON(D,A){const U=t.VSBuffer.fromString(A);let B=0;B+=p.sizeLongString(U);let E=p.alloc(9,D,B);return E.writeLongString(U),E.buffer}static _serializeReplyOKJSONWithBuffers(D,A,U){const B=t.VSBuffer.fromString(A);let E=0;E+=p.sizeUInt32,E+=p.sizeLongString(B);for(const L of U)E+=p.sizeVSBuffer(L);let N=p.alloc(10,D,E);N.writeUInt32(U.length),N.writeLongString(B);for(const L of U)N.writeBuffer(L);return N.buffer}static deserializeReplyOKJSON(D){const A=D.readLongString();return JSON.parse(A)}static deserializeReplyOKJSONWithBuffers(D,A){const U=D.readUInt32(),B=D.readLongString(),E=[];for(let N=0;N<U;++N)E.push(D.readVSBuffer());return new F.SerializableObjectWithBuffers(C(B,E,A))}static serializeReplyErr(D,A){return A?this._serializeReplyErrEror(D,A):this._serializeReplyErrEmpty(D)}static _serializeReplyErrEror(D,A){const U=t.VSBuffer.fromString(n(T.transformErrorForSerialization(A),null));let B=0;B+=p.sizeLongString(U);let E=p.alloc(11,D,B);return E.writeLongString(U),E.buffer}static deserializeReplyErrError(D){const A=D.readLongString();return JSON.parse(A)}static _serializeReplyErrEmpty(D){return p.alloc(12,D,0).buffer}}var v;(function(u){u[u.RequestJSONArgs=1]="RequestJSONArgs",u[u.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",u[u.RequestMixedArgs=3]="RequestMixedArgs",u[u.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",u[u.Acknowledged=5]="Acknowledged",u[u.Cancel=6]="Cancel",u[u.ReplyOKEmpty=7]="ReplyOKEmpty",u[u.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",u[u.ReplyOKJSON=9]="ReplyOKJSON",u[u.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",u[u.ReplyErrError=11]="ReplyErrError",u[u.ReplyErrEmpty=12]="ReplyErrEmpty"})(v||(v={}));var y;(function(u){u[u.String=1]="String",u[u.VSBuffer=2]="VSBuffer",u[u.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",u[u.Undefined=4]="Undefined"})(y||(y={}))}),define(Ee[210],ye([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const a=function(T){const k=I=>{self.removeEventListener("message",k);const S=I.data;Object.defineProperties(self,{postMessage:{value(R,F){S.postMessage(R,F)}},onmessage:{get(){return S.onmessage},set(R){S.onmessage=R}}}),S.addEventListener("message",R=>{self.dispatchEvent(new MessageEvent("message",{data:R.data}))}),S.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(T)};self.addEventListener("message",k)}.toString();class t extends EventTarget{constructor(T,k,I){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const S=`((${a})('${k}'))`,R=new Blob([S],{type:"application/javascript"}),F=URL.createObjectURL(R),_=new MessageChannel,n=F,f={type:"_newWorker",id:n,port:_.port2,url:F,options:I};T(f,[_.port2]),this.postMessage=_.port1.postMessage.bind(_.port1),this.terminate=()=>{const o={type:"_terminateWorker",id:n};_.port1.postMessage(o),URL.revokeObjectURL(F),_.port1.close(),_.port2.close()},Object.defineProperties(this,{onmessage:{get(){return _.port1.onmessage},set(o){_.port1.onmessage=o}},onmessageerror:{get(){return _.port1.onmessageerror},set(o){_.port1.onmessageerror=o}}}),_.port1.addEventListener("messageerror",o=>{const m=new MessageEvent("messageerror",{data:o.data});this.dispatchEvent(m)}),_.port1.addEventListener("message",o=>{const m=new MessageEvent("message",{data:o.data});this.dispatchEvent(m)}),_.port1.start()}}e.NestedWorker=t}),define(Ee[211],ye([0,1,3]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,a.createDecorator)("remoteAgentService")}),define(Ee[212],ye([0,1,10,17,23,2,3,61,46,171,211]),function(re,e,a,t,w,T,k,I,S,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,k.createDecorator)("pathService");let _=class Vi{constructor(f,o,m,c){this.localUserHome=f,this.remoteAgentService=o,this.environmentService=m,this.contextService=c,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||w.OS)(),this.resolveUserHome=(async()=>{const C=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=C?.userHome||f})()}get defaultUriScheme(){return Vi.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(f,o){if(f.remoteAuthority)return a.Schemas.vscodeRemote;const m=(0,I.getVirtualWorkspaceScheme)(o.getWorkspace());if(m)return m;const c=o.getWorkspace().folders[0];if(c)return c.uri.scheme;const C=o.getWorkspace().configuration;return C?C.scheme:a.Schemas.file}async userHome(f){return f?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(f=>f===1?t.win32:t.posix)}async fileURI(f){let o="";if(await this.resolveOS===1&&(f=f.replace(/\\/g,"/")),f[0]==="/"&&f[1]==="/"){const c=f.indexOf("/",2);c===-1?(o=f.substring(2),f="/"):(o=f.substring(2,c),f=f.substring(c)||"/")}return T.URI.from({scheme:a.Schemas.file,authority:o,path:f,query:"",fragment:""})}};_=Ue([$e(1,F.IRemoteAgentService),$e(2,R.IWorkbenchEnvironmentService),$e(3,S.IWorkspaceContextService)],_),e.AbstractPathService=_}),define(Ee[96],ye([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class a{constructor(k,I){this.line=k,this.character=I}isBefore(k){return!1}isBeforeOrEqual(k){return!1}isAfter(k){return!1}isAfterOrEqual(k){return!1}isEqual(k){return!1}compareTo(k){return 0}translate(k,I){return new a(0,0)}with(k){return new a(0,0)}}e.Position=a;class t{constructor(k,I,S,R){this.isEmpty=!1,this.isSingleLine=!1,this.start=new a(k,I),this.end=new a(S,R)}contains(k){return!1}isEqual(k){return!1}intersection(k){}union(k){return new t(0,0,0,0)}with(k){return new t(0,0,0,0)}}e.Range=t;var w;(function(T){T[T.Information=1]="Information",T[T.Warning=2]="Warning"})(w=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(Ee[40],ye([0,1,16,29,26,42,9,3,17,15,96,11]),function(re,e,a,t,w,T,k,I,S,R,F,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return F.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const n="\u27EA ",f=" characters skipped \u27EB",o=(n.length+f.length+5)*2;e.ISearchService=(0,I.createDecorator)("searchService");var m;(function(j){j[j.file=0]="file",j[j.text=1]="text"})(m=e.SearchProviderType||(e.SearchProviderType={}));var c;(function(j){j[j.File=1]="File",j[j.Text=2]="Text"})(c=e.QueryType||(e.QueryType={}));function C(j){return!!j.preview}e.resultIsMatch=C;function b(j){return!!j.resource}e.isFileMatch=b;function h(j){return!!j.message}e.isProgressMessage=h;var g;(function(j){j[j.Normal=0]="Normal",j[j.NewSearchStarted=1]="NewSearchStarted"})(g=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class P{constructor(ue){this.resource=ue,this.results=[]}}e.FileMatch=P;class l{constructor(ue,G,le){this.ranges=G;const ce=Array.isArray(G)?G:[G];if(le&&le.matchLines===1&&M(ce)){ue=(0,k.getNLines)(ue,le.matchLines);let Y="",ie=0,we=0;const Me=Math.floor(le.charsPerLine/5),Re=[];for(const Be of ce){const Qe=Math.max(Be.startColumn-Me,0),Ke=Be.startColumn+le.charsPerLine;if(Qe>we+Me+o){const Xe=n+(Qe-we)+f;Y+=Xe+ue.slice(Qe,Ke),ie+=Qe-(we+Xe.length)}else Y+=ue.slice(we,Ke);Re.push(new i(0,Be.startColumn-ie,Be.endColumn-ie)),we=Ke}this.preview={text:Y,matches:Array.isArray(this.ranges)?Re:Re[0]}}else{const Y=Array.isArray(G)?G[0].startLineNumber:G.startLineNumber;this.preview={text:ue,matches:(0,a.mapArrayOrNot)(G,ie=>new r(ie.startLineNumber-Y,ie.startColumn,ie.endLineNumber-Y,ie.endColumn))}}}}e.TextSearchMatch=l;function M(j){const ue=j[0].startLineNumber;for(const G of j)if(G.startLineNumber!==ue||G.endLineNumber!==ue)return!1;return!0}class r{constructor(ue,G,le,ce){this.startLineNumber=ue,this.startColumn=G,this.endLineNumber=le,this.endColumn=ce}}e.SearchRange=r;class i extends r{constructor(ue,G,le){super(ue,G,ue,le)}}e.OneLineRange=i;var p;(function(j){j.Default="default",j.FileNames="fileNames",j.Type="type",j.Modified="modified",j.CountDescending="countDescending",j.CountAscending="countAscending"})(p=e.SearchSortOrder||(e.SearchSortOrder={}));function d(j,ue=!0){const G=j&&j.files&&j.files.exclude,le=ue&&j&&j.search&&j.search.exclude;if(!G&&!le)return;if(!G||!le)return G||le;let ce=Object.create(null);return ce=w.mixin(ce,w.deepClone(G)),ce=w.mixin(ce,w.deepClone(le),!0),ce}e.getExcludes=d;function s(j,ue){return j.excludePattern&&t.match(j.excludePattern,ue)?!1:j.includePattern||j.usingSearchPaths?j.includePattern&&t.match(j.includePattern,ue)?!0:j.usingSearchPaths?!!j.folderQueries&&j.folderQueries.some(G=>{const le=G.folder.fsPath;if(T.isEqualOrParent(ue,le)){const ce=S.relative(le,ue);return!G.includePattern||!!t.match(G.includePattern,ce)}else return!1}):!1:!0}e.pathIncludedInQuery=s;var v;(function(j){j[j.unknownEncoding=1]="unknownEncoding",j[j.regexParseError=2]="regexParseError",j[j.globParseError=3]="globParseError",j[j.invalidLiteral=4]="invalidLiteral",j[j.rgProcessError=5]="rgProcessError",j[j.other=6]="other",j[j.canceled=7]="canceled"})(v=e.SearchErrorCode||(e.SearchErrorCode={}));class y extends Error{constructor(ue,G){super(ue);this.code=G}}e.SearchError=y;function u(j){const ue=j.message;if((0,R.isPromiseCanceledError)(j))return new y(ue,v.canceled);try{const G=JSON.parse(ue);return new y(G.message,G.code)}catch{return new y(ue,v.other)}}e.deserializeSearchError=u;function D(j){const ue={message:j.message,code:j.code};return new Error(JSON.stringify(ue))}e.serializeSearchError=D;function A(j){return j.type==="error"?!0:j.type==="success"}e.isSerializedSearchComplete=A;function U(j){return j.type==="success"}e.isSerializedSearchSuccess=U;function B(j){return!!j.path}e.isSerializedFileMatch=B;function E(j,ue){const G=j.searchPath?j.searchPath:j.relativePath;return(0,k.fuzzyContains)(G,ue)}e.isFilePatternMatch=E;class N{constructor(ue){this.path=ue,this.results=[]}addMatch(ue){this.results.push(ue)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=N;function L(j,ue){const G={...j||{},...ue||{}};return Object.keys(G).filter(le=>{const ce=G[le];return typeof ce=="boolean"&&ce})}e.resolvePatternsForProvider=L;class z{constructor(ue,G){this._parsedIncludeExpression=null,this._excludeExpression={...ue.excludePattern||{},...G.excludePattern||{}},this._parsedExcludeExpression=t.parse(this._excludeExpression);let le=ue.includePattern;G.includePattern&&(le?le={...le,...G.includePattern}:le=G.includePattern),le&&(this._parsedIncludeExpression=t.parse(le))}matchesExcludesSync(ue,G,le){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ue,G,le))}includedInQuerySync(ue,G,le){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ue,G,le)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(ue,G,le))}includedInQuery(ue,G,le){const ce=this._parsedExcludeExpression(ue,G,le),Y=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(ue,G,le):!0;return(0,_.isPromise)(ce)?ce.then(ie=>ie?!1:Y()):Y()}hasSiblingExcludeClauses(){return H(this._excludeExpression)}}e.QueryGlobTester=z;function H(j){for(const ue in j)if(typeof j[ue]!="boolean")return!0;return!1}}),define(Ee[31],ye([0,1,16,14,20,4,21,10,75,24,9,11,2,125,3,12,138,46,30,28,13,7,40,5]),function(re,e,a,t,w,T,k,I,S,R,F,_,n,f,o,m,c,C,b,h,g,P,l,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function r(D,A,U){return new R.ExtUri(B=>s(B,U)).isEqual(D,A)}function i(D,A,U){return r(D.uri,A.uri,U)?0:(0,F.compare)(D.uri.toString(),A.uri.toString())}function p(D,A,U){return D.index!==A.index?D.index<A.index?-1:1:r(D.uri,A.uri,U)?(0,F.compare)(D.name,A.name):(0,F.compare)(D.uri.toString(),A.uri.toString())}function d(D,A,U,B){const E=D.slice(0).sort((L,z)=>U(L,z,B)),N=A.slice(0).sort((L,z)=>U(L,z,B));return(0,a.delta)(E,N,(L,z)=>U(L,z,B))}function s(D,A){const U=A.getCapabilities(D.scheme);return!(U&&U&1024)}class v extends C.Workspace{constructor(A,U,B,E,N,L,z){super(A,B.map(H=>new C.WorkspaceFolder(H)),E,N,z);this._name=U,this._isUntitled=L,this._workspaceFolders=[],this._structure=k.TernarySearchTree.forUris(z),B.forEach(H=>{this._workspaceFolders.push(H),this._structure.set(H.uri,H)})}static toExtHostWorkspace(A,U,B,E){if(!A)return{workspace:null,added:[],removed:[]};const{id:N,name:L,folders:z,configuration:H,transient:j,isUntitled:ue}=A,G=[],le=U;U?z.forEach((we,Me)=>{const Re=n.URI.revive(we.uri),Be=v._findFolder(B||U,Re,E);Be?(Be.name=we.name,Be.index=we.index,G.push(Be)):G.push({uri:Re,name:we.name,index:Me})}):G.push(...z.map(({uri:we,name:Me,index:Re})=>({uri:n.URI.revive(we),name:Me,index:Re}))),G.sort((we,Me)=>we.index<Me.index?-1:1);const ce=new v(N,L,G,!!j,H?n.URI.revive(H):null,!!ue,we=>s(we,E)),{added:Y,removed:ie}=d(le?le.workspaceFolders:[],ce.workspaceFolders,i,E);return{workspace:ce,added:Y,removed:ie}}static _findFolder(A,U,B){for(let E=0;E<A.folders.length;E++){const N=A.workspaceFolders[E];if(r(N.uri,U,B))return N}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(A,U){return U&&this._structure.get(A)&&(A=(0,R.dirname)(A)),this._structure.findSubstr(A)}resolveWorkspaceFolder(A){return this._structure.get(A)}}let y=class{constructor(A,U,B,E){this._onDidChangeWorkspace=new T.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new T.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=E,this._extHostFileSystemInfo=B,this._requestIdProvider=new S.Counter,this._barrier=new t.Barrier,this._proxy=A.getProxy(M.MainContext.MainThreadWorkspace),this._messageService=A.getProxy(M.MainContext.MainThreadMessageService);const N=U.workspace;this._confirmedWorkspace=N?new v(N.id,N.name,[],!!N.transient,N.configuration?n.URI.revive(N.configuration):null,!!N.isUntitled,L=>s(L,B)):void 0}$initializeWorkspace(A,U){this._trusted=U,this.$acceptWorkspaceData(A),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?n.URI.from({scheme:I.Schemas.untitled,path:(0,R.basename)((0,R.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(A,U,B,...E){const N=[];if(Array.isArray(E)&&E.forEach(ue=>{n.URI.isUri(ue.uri)&&!N.some(G=>r(G.uri,ue.uri,this._extHostFileSystemInfo))&&N.push({uri:ue.uri,name:ue.name||(0,R.basenameOrAuthority)(ue.uri)})}),this._unconfirmedWorkspace||[U,B].some(ue=>typeof ue!="number"||ue<0)||B===0&&N.length===0)return!1;const L=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(U+B>L.length)return!1;const z=L.slice(0);z.splice(U,B,...N.map(ue=>({uri:ue.uri,name:ue.name||(0,R.basenameOrAuthority)(ue.uri),index:void 0})));for(let ue=0;ue<z.length;ue++){const G=z[ue];if(z.some((le,ce)=>ce!==ue&&r(G.uri,le.uri,this._extHostFileSystemInfo)))return!1}z.forEach((ue,G)=>ue.index=G);const{added:H,removed:j}=d(L,z,p,this._extHostFileSystemInfo);if(H.length===0&&j.length===0)return!1;if(this._proxy){const ue=A.displayName||A.name;this._proxy.$updateWorkspaceFolders(ue,U,B,N).then(void 0,G=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(c.Severity.Error,(0,f.localize)(0,null,ue,G.toString()),{extension:A},[])})}return this.trySetWorkspaceFolders(z),!0}getWorkspaceFolder(A,U){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(A,U)}async getWorkspaceFolder2(A,U){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(A,U)}async resolveWorkspaceFolder(A){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(A)}getPath(){if(!this._actualWorkspace)return;const{folders:A}=this._actualWorkspace;if(A.length!==0)return A[0].uri.fsPath}getRelativePath(A,U){let B,E="";if(typeof A=="string"?(B=n.URI.file(A),E=A):typeof A!="undefined"&&(B=A,E=A.fsPath),!B)return E;const N=this.getWorkspaceFolder(B,!0);if(!N)return E;typeof U=="undefined"&&this._actualWorkspace&&(U=this._actualWorkspace.folders.length>1);let L=(0,R.relativePath)(N.uri,B);return U&&N.name&&(L=`${N.name}/${L}`),L}trySetWorkspaceFolders(A){this._actualWorkspace&&(this._unconfirmedWorkspace=v.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:A,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(A){const{workspace:U,added:B,removed:E}=v.toExtHostWorkspace(A,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=U||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:B,removed:E}))}findFiles(A,U,B,E,N=w.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${E.value}, entryPoint: findFiles`);let L;if(U===null?L=!1:U&&(typeof U=="string"?L=U:L=U.pattern),N&&N.isCancellationRequested)return Promise.resolve([]);const{includePattern:z,folder:H}=u(A);return this._proxy.$startFileSearch((0,_.withUndefinedAsNull)(z),(0,_.withUndefinedAsNull)(H),(0,_.withUndefinedAsNull)(L),(0,_.withUndefinedAsNull)(B),N).then(j=>Array.isArray(j)?j.map(ue=>n.URI.revive(ue)):[])}async findTextInFiles(A,U,B,E,N=w.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${E.value}, entryPoint: findTextInFiles`);const L=this._requestIdProvider.getNext(),z=typeof U.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:U.previewOptions,{includePattern:H,folder:j}=u(U.include),ue=typeof U.exclude=="string"?U.exclude:U.exclude?U.exclude.pattern:void 0,G={ignoreSymlinks:typeof U.followSymlinks=="boolean"?!U.followSymlinks:void 0,disregardIgnoreFiles:typeof U.useIgnoreFiles=="boolean"?!U.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof U.useGlobalIgnoreFiles=="boolean"?!U.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof U.useDefaultExcludes=="boolean"?!U.useDefaultExcludes:!0,fileEncoding:U.encoding,maxResults:U.maxResults,previewOptions:z,afterContext:U.afterContext,beforeContext:U.beforeContext,includePattern:H,excludePattern:ue},le=!1;if(this._activeSearchCallbacks[L]=ce=>{if(le)return;const Y=n.URI.revive(ce.resource);ce.results.forEach(ie=>{(0,l.resultIsMatch)(ie)?B({uri:Y,preview:{text:ie.preview.text,matches:(0,a.mapArrayOrNot)(ie.preview.matches,we=>new P.Range(we.startLineNumber,we.startColumn,we.endLineNumber,we.endColumn))},ranges:(0,a.mapArrayOrNot)(ie.ranges,we=>new P.Range(we.startLineNumber,we.startColumn,we.endLineNumber,we.endColumn))}):B({uri:Y,text:ie.text,lineNumber:ie.lineNumber})})},N.isCancellationRequested)return{};try{const ce=await this._proxy.$startTextSearch(A,(0,_.withUndefinedAsNull)(j),G,L,N);return delete this._activeSearchCallbacks[L],ce||{}}catch(ce){throw delete this._activeSearchCallbacks[L],ce}}$handleTextSearchResult(A,U){this._activeSearchCallbacks[U]&&this._activeSearchCallbacks[U](A)}saveAll(A){return this._proxy.$saveAll(A)}resolveProxy(A){return this._proxy.$resolveProxy(A)}get trusted(){return this._trusted}requestWorkspaceTrust(A){return this._proxy.$requestWorkspaceTrust(A)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};y=Ue([$e(0,g.IExtHostRpcService),$e(1,h.IExtHostInitDataService),$e(2,b.IExtHostFileSystemInfo),$e(3,m.ILogService)],y),e.ExtHostWorkspace=y,e.IExtHostWorkspace=(0,o.createDecorator)("IExtHostWorkspace");function u(D){let A,U;return D&&(typeof D=="string"?A=D:(A=D.pattern,U=D.baseFolder||n.URI.file(D.base))),{includePattern:A,folder:U}}}),define(Ee[32],ye([0,1,26,4,31,5,7,142,83,11,14,3,13,12,2]),function(re,e,a,t,w,T,k,I,S,R,F,_,n,f,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function m(M,r){if(r){const i=r.split(".");let p=M;for(let d=0;p&&d<i.length;d++)p=p[i[d]];return p}}function c(M){return M instanceof o.URI}function C(M){return M&&M.uri instanceof o.URI&&M.languageId&&typeof M.languageId=="string"}function b(M){return M&&!M.uri&&M.languageId&&typeof M.languageId=="string"}function h(M){return M&&M.uri instanceof o.URI&&(!M.name||typeof M.name=="string")&&(!M.index||typeof M.index=="number")}function g(M){if(c(M))return{resource:M};if(C(M))return{resource:M.uri,overrideIdentifier:M.languageId};if(b(M))return{overrideIdentifier:M.languageId};if(h(M))return{resource:M.uri};if(M===null)return{resource:null}}let P=class{constructor(r,i,p){this._proxy=r.getProxy(T.MainContext.MainThreadConfiguration),this._extHostWorkspace=i,this._logService=p,this._barrier=new F.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(r=>this._actual)}$initializeConfiguration(r){this._actual=new l(this._proxy,this._extHostWorkspace,r,this._logService),this._barrier.open()}$acceptConfigurationChanged(r,i){this.getConfigProvider().then(p=>p.$acceptConfigurationChanged(r,i))}};P=Ue([$e(0,n.IExtHostRpcService),$e(1,w.IExtHostWorkspace),$e(2,f.ILogService)],P),e.ExtHostConfiguration=P;class l{constructor(r,i,p,d){this._onDidChangeConfiguration=new t.Emitter,this._proxy=r,this._logService=d,this._extHostWorkspace=i,this._configuration=I.Configuration.parse(p),this._configurationScopes=this._toMap(p.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(r,i){const p={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=I.Configuration.parse(r),this._configurationScopes=this._toMap(r.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(i,p))}getConfiguration(r,i,p){const d=g(i)||{},s=this._toReadonlyValue(r?m(this._configuration.getValue(void 0,d,this._extHostWorkspace.workspace),r):this._configuration.getValue(void 0,d,this._extHostWorkspace.workspace));r&&this._validateConfigurationAccess(r,d,p?.identifier);function v(u){if(u==null)return null;if(typeof u=="boolean")return u?1:4;switch(u){case k.ConfigurationTarget.Global:return 1;case k.ConfigurationTarget.Workspace:return 4;case k.ConfigurationTarget.WorkspaceFolder:return 5}}const y={has(u){return typeof m(s,u)!="undefined"},get:(u,D)=>{this._validateConfigurationAccess(r?`${r}.${u}`:u,d,p?.identifier);let A=m(s,u);if(typeof A=="undefined")A=D;else{let U;const B=(E,N)=>{let L;const z=()=>{U=U||(0,a.deepClone)(s),L=L||m(U,N)};return(0,R.isObject)(E)?new Proxy(E,{get:(H,j)=>{if(typeof j=="string"&&j.toLowerCase()==="tojson")return z(),()=>L;if(U)return L=L||m(U,N),L[j];const ue=H[j];return typeof j=="string"?B(ue,`${N}.${j}`):ue},set:(H,j,ue)=>(z(),L&&(L[j]=ue),!0),deleteProperty:(H,j)=>(z(),L&&delete L[j],!0),defineProperty:(H,j,ue)=>(z(),L&&Object.defineProperty(L,j,ue),!0)}):E};A=B(A,u)}return A},update:(u,D,A,U)=>{u=r?`${r}.${u}`:u;const B=v(A);return D!==void 0?this._proxy.$updateConfigurationOption(B,u,D,d,U):this._proxy.$removeConfigurationOption(B,u,d,U)},inspect:u=>{u=r?`${r}.${u}`:u;const D=(0,a.deepClone)(this._configuration.inspect(u,d,this._extHostWorkspace.workspace));if(D)return{key:u,defaultValue:D.default?.value,globalValue:D.user?.value,workspaceValue:D.workspace?.value,workspaceFolderValue:D.workspaceFolder?.value,defaultLanguageValue:D.default?.override,globalLanguageValue:D.user?.override,workspaceLanguageValue:D.workspace?.override,workspaceFolderLanguageValue:D.workspaceFolder?.override,languageIds:D.overrideIdentifiers}}};return typeof s=="object"&&(0,a.mixin)(y,s,!1),Object.freeze(y)}_toReadonlyValue(r){const i=p=>(0,R.isObject)(p)?new Proxy(p,{get:(d,s)=>i(d[s]),set:(d,s,v)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(s)}' of object`)},deleteProperty:(d,s)=>{throw new Error(`TypeError: Cannot delete read only property '${String(s)}' of object`)},defineProperty:(d,s)=>{throw new Error(`TypeError: Cannot define property '${String(s)}' for a readonly object`)},setPrototypeOf:d=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):p;return i(r)}_validateConfigurationAccess(r,i,p){const d=S.OVERRIDE_PROPERTY_REGEX.test(r)?4:this._configurationScopes.get(r),s=p?`[${p.value}] `:"";if(d===4){typeof i?.resource=="undefined"&&this._logService.warn(`${s}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(d===3){i?.resource&&this._logService.warn(`${s}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(r,i){const p=new I.ConfigurationChangeEvent(r,i,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(d,s)=>p.affectsConfiguration(d,g(s))})}_toMap(r){return r.reduce((i,p)=>(i.set(p[0],p[1]),i),new Map)}}e.ExtHostConfigProvider=l,e.IExtHostConfiguration=(0,_.createDecorator)("IExtHostConfiguration")});var Ze=this&&this.__classPrivateFieldSet||function(re,e,a,t,w){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!w:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?w.call(re,a):w?w.value=a:e.set(re,a),a},Te=this&&this.__classPrivateFieldGet||function(re,e,a,t){if(a==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!t:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?t:a==="a"?t.call(re):t?t.value:e.get(re)};define(Ee[97],ye([0,1,2,14,4,5,7,31,48,32,20,39,13,28,3,10,23,12,69,161,15]),function(re,e,a,t,w,T,k,I,S,R,F,_,n,f,o,m,c,C,b,h,g){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var l;(function(N){function L(H){if(H!=null)return H}N.from=L;function z(H){if(H!=null)return H}N.to=z})(l=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var M;(function(N){function L(H){if(H!=null)return H}N.from=L;function z(H){if(H!=null)return H}N.to=z})(M=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var r;(function(N){function L(H){if(H!=null)return H}N.from=L;function z(H){if(H!=null)return H}N.to=z})(r=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var i;(function(N){function L(j){if(j){const ue=j;return ue&&!!ue.process}else return!1}N.is=L;function z(j){if(j==null)return;const ue={process:j.process,args:j.args};return j.options&&(ue.options=r.from(j.options)),ue}N.from=z;function H(j){if(j!=null)return new k.ProcessExecution(j.process,j.args,j.options)}N.to=H})(i=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var p;(function(N){function L(H){if(H!=null)return H}N.from=L;function z(H){if(H!=null)return H}N.to=z})(p=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var d;(function(N){function L(j){if(j){const ue=j;return ue&&(!!ue.commandLine||!!ue.command)}else return!1}N.is=L;function z(j){if(j==null)return;const ue={};return j.commandLine!==void 0?ue.commandLine=j.commandLine:(ue.command=j.command,ue.args=j.args),j.options&&(ue.options=p.from(j.options)),ue}N.from=z;function H(j){if(!(j==null||j.command===void 0&&j.commandLine===void 0))return j.commandLine?new k.ShellExecution(j.commandLine,j.options):new k.ShellExecution(j.command,j.args?j.args:[],j.options)}N.to=H})(d=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var s;(function(N){function L(j){if(j){let ue=j;return ue&&ue.customExecution==="customExecution"}else return!1}N.is=L;function z(j){return{customExecution:"customExecution"}}N.from=z;function H(j,ue){return ue.get(j)}N.to=H})(s=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var v;(function(N){function L(z,H){let j;return z.scope!==void 0&&typeof z.scope!="number"?j=z.scope.uri:z.scope!==void 0&&typeof z.scope=="number"&&(z.scope===k.TaskScope.Workspace&&H&&H.workspaceFile?j=H.workspaceFile:j=h.USER_TASKS_GROUP_KEY),{id:z._id,workspaceFolder:j}}N.from=L})(v=e.TaskHandleDTO||(e.TaskHandleDTO={}));var y;(function(N){function L(z){if(z!=null)return{_id:z.id,isDefault:z.isDefault}}N.from=L})(y=e.TaskGroupDTO||(e.TaskGroupDTO={}));var u;(function(N){function L(j,ue){if(j==null)return[];const G=[];for(let le of j){const ce=z(le,ue);ce&&G.push(ce)}return G}N.fromMany=L;function z(j,ue){if(j==null)return;let G;j.execution instanceof k.ProcessExecution?G=i.from(j.execution):j.execution instanceof k.ShellExecution?G=d.from(j.execution):j.execution&&j.execution instanceof k.CustomExecution&&(G=s.from(j.execution));const le=l.from(j.definition);let ce;return j.scope?typeof j.scope=="number"?ce=j.scope:ce=j.scope.uri:ce=k.TaskScope.Workspace,!le||!ce?void 0:{_id:j._id,definition:le,name:j.name,source:{extensionId:ue.identifier.value,label:j.source,scope:ce},execution:G,isBackground:j.isBackground,group:y.from(j.group),presentationOptions:M.from(j.presentationOptions),problemMatchers:j.problemMatchers,hasDefinedMatchers:j.hasDefinedMatchers,runOptions:j.runOptions?j.runOptions:{reevaluateOnRerun:!0},detail:j.detail}}N.from=z;async function H(j,ue,G){if(j==null)return;let le;i.is(j.execution)?le=i.to(j.execution):d.is(j.execution)?le=d.to(j.execution):s.is(j.execution)&&(le=s.to(j._id,G));const ce=l.to(j.definition);let Y;if(j.source&&(j.source.scope!==void 0?typeof j.source.scope=="number"?Y=j.source.scope:Y=await ue.resolveWorkspaceFolder(a.URI.revive(j.source.scope)):Y=k.TaskScope.Workspace),!ce||!Y)return;const ie=new k.Task(ce,Y,j.name,j.source.label,le,j.problemMatchers);return j.isBackground!==void 0&&(ie.isBackground=j.isBackground),j.group!==void 0&&(ie.group=k.TaskGroup.from(j.group._id),ie.group&&j.group.isDefault&&(ie.group=new k.TaskGroup(ie.group.id,ie.group.label),j.group.isDefault&&(ie.group.isDefault=j.group.isDefault))),j.presentationOptions&&(ie.presentationOptions=M.to(j.presentationOptions)),j._id&&(ie._id=j._id),j.detail&&(ie.detail=j.detail),ie}N.to=H})(u=e.TaskDTO||(e.TaskDTO={}));var D;(function(N){function L(H){return H}N.from=L;function z(H){if(!!H)return Object.assign(Object.create(null),H)}N.to=z})(D=e.TaskFilterDTO||(e.TaskFilterDTO={}));class A{constructor(L,z,H){this._id=z,this._task=H,P.set(this,void 0),Ze(this,P,L,"f")}get task(){return this._task}terminate(){Te(this,P,"f").terminateTask(this)}fireDidStartProcess(L){}fireDidEndProcess(L){}}P=new WeakMap;var U;(function(N){function L(z){return{id:z._id,task:void 0}}N.from=L})(U=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let B=class{constructor(L,z,H,j,ue,G,le,ce){this._onDidExecuteTask=new w.Emitter,this._onDidTerminateTask=new w.Emitter,this._onDidTaskProcessStarted=new w.Emitter,this._onDidTaskProcessEnded=new w.Emitter,this._proxy=L.getProxy(T.MainContext.MainThreadTask),this._workspaceProvider=H,this._editorService=j,this._configurationService=ue,this._terminalService=G,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=le,this._deprecationService=ce,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(L,z,H){if(!H)return new k.Disposable(()=>{});const j=this.nextHandle();return this._handlers.set(j,{type:z,provider:H,extension:L}),this._proxy.$registerTaskProvider(j,z),new k.Disposable(()=>{this._handlers.delete(j),this._proxy.$unregisterTaskProvider(j)})}registerTaskSystem(L,z){this._proxy.$registerTaskSystem(L,z)}fetchTasks(L){return this._proxy.$fetchTasks(D.from(L)).then(async z=>{const H=[];for(let j of z){const ue=await u.to(j,this._workspaceProvider,this._providedCustomExecutions2);ue&&H.push(ue)}return H})}get taskExecutions(){const L=[];return this._taskExecutions.forEach(z=>L.push(z)),L}terminateTask(L){if(!(L instanceof A))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(L._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(L,z,H){const j=this._providedCustomExecutions2.get(L.id);j&&(this._activeCustomExecutions2.set(L.id,j),this._terminalService.attachPtyToTerminal(z,await j.callback(H))),this._lastStartedTask=L.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(L)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(L){const z=await this.getTaskExecution(L);this._taskExecutionPromises.delete(L.id),this._taskExecutions.delete(L.id),this.customExecutionComplete(L),this._onDidTerminateTask.fire({execution:z})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(L){const z=await this.getTaskExecution(L.id);this._onDidTaskProcessStarted.fire({execution:z,processId:L.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(L){const z=await this.getTaskExecution(L.id);this._onDidTaskProcessEnded.fire({execution:z,exitCode:L.exitCode})}$provideTasks(L,z){const H=this._handlers.get(L);if(!H)return Promise.reject(new Error("no handler found"));const j=[],ue=(0,t.asPromise)(()=>H.provider.provideTasks(F.CancellationToken.None)).then(G=>this.provideTasksInternal(z,j,H,G));return new Promise(G=>{ue.then(le=>{Promise.all(j).then(()=>{G(le)})})})}async $resolveTask(L,z){const H=this._handlers.get(L);if(!H)return Promise.reject(new Error("no handler found"));if(z.definition.type!==H.type)throw new Error(`Unexpected: Task of type [${z.definition.type}] cannot be resolved by provider of type [${H.type}].`);const j=await u.to(z,this._workspaceProvider,this._providedCustomExecutions2);if(!j)throw new Error("Unexpected: Task cannot be resolved.");const ue=await H.provider.resolveTask(j,F.CancellationToken.None);if(!ue)return;this.checkDeprecation(ue,H);const G=u.from(ue,H.extension);if(!G)throw new Error("Unexpected: Task cannot be resolved.");if(ue.definition!==j.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return s.is(G.execution)&&await this.addCustomExecution(G,ue,!0),await this.resolveTaskInternal(G)}nextHandle(){return this._handleCounter++}async addCustomExecution(L,z,H){const j=await this._proxy.$createTaskId(L);!H&&!this._providedCustomExecutions2.has(j)&&(this._notProvidedCustomExecutions.add(j),this._activeCustomExecutions2.set(j,z.execution)),this._providedCustomExecutions2.set(j,z.execution)}async getTaskExecution(L,z){if(typeof L=="string"){const ue=this._taskExecutionPromises.get(L);if(!ue)throw new Error("Unexpected: The specified task is missing an execution");return ue}let H=this._taskExecutionPromises.get(L.id);if(H)return H;const j=new Promise((ue,G)=>{function le(ce,Y,ie){ie?ue(new A(ce,Y.id,ie)):G("Unexpected: Task does not exist.")}z?le(this,L,z):u.to(L.task,this._workspaceProvider,this._providedCustomExecutions2).then(ce=>le(this,L,ce))});return this._taskExecutionPromises.set(L.id,j),j.then(ue=>(this._taskExecutions.set(L.id,ue),ue),ue=>Promise.reject(ue))}checkDeprecation(L,z){L._deprecated&&this._deprecationService.report("Task.constructor",z.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(L){this._activeCustomExecutions2.get(L.id)&&this._activeCustomExecutions2.delete(L.id),this._notProvidedCustomExecutions.has(L.id)&&this._lastStartedTask!==L.id&&(this._providedCustomExecutions2.delete(L.id),this._notProvidedCustomExecutions.delete(L.id));let H=this._notProvidedCustomExecutions.values(),j=H.next();for(;!j.done;)!this._activeCustomExecutions2.has(j.value)&&this._lastStartedTask!==j.value&&(this._providedCustomExecutions2.delete(j.value),this._notProvidedCustomExecutions.delete(j.value)),j=H.next()}};B=Ue([$e(0,n.IExtHostRpcService),$e(1,f.IExtHostInitDataService),$e(2,I.IExtHostWorkspace),$e(3,S.IExtHostDocumentsAndEditors),$e(4,R.IExtHostConfiguration),$e(5,_.IExtHostTerminalService),$e(6,C.ILogService),$e(7,b.IExtHostApiDeprecationService)],B),e.ExtHostTaskBase=B;let E=class extends B{constructor(L,z,H,j,ue,G,le,ce){super(L,z,H,j,ue,G,le,ce);this.registerTaskSystem(m.Schemas.vscodeRemote,{scheme:m.Schemas.vscodeRemote,authority:"",platform:c.PlatformToString(0)})}async executeTask(L,z){if(!z.execution)throw new Error("Tasks to execute must include an execution");const H=u.from(z,L);if(H===void 0)throw new Error("Task is not valid");if(s.is(H.execution))await this.addCustomExecution(H,z,!1);else throw new g.NotSupportedError;const j=await this.getTaskExecution(await this._proxy.$getTaskExecution(H),z);return this._proxy.$executeTask(H).catch(ue=>{throw new Error(ue)}),j}provideTasksInternal(L,z,H,j){const ue=[];if(j)for(let G of j){this.checkDeprecation(G,H),(!G.definition||!L[G.definition.type])&&this._logService.warn(`The task [${G.source}, ${G.name}] uses an undefined task type. The task will be ignored in the future.`);const le=u.from(G,H.extension);le&&s.is(le.execution)?(ue.push(le),z.push(this.addCustomExecution(le,G,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:ue,extension:H.extension}}async resolveTaskInternal(L){if(s.is(L.execution))return L;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(L,z){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(L,z,H){}};E=Ue([$e(0,n.IExtHostRpcService),$e(1,f.IExtHostInitDataService),$e(2,I.IExtHostWorkspace),$e(3,S.IExtHostDocumentsAndEditors),$e(4,R.IExtHostConfiguration),$e(5,_.IExtHostTerminalService),$e(6,C.ILogService),$e(7,b.IExtHostApiDeprecationService)],E),e.WorkerExtHostTask=E,e.IExtHostTask=(0,o.createDecorator)("IExtHostTask")}),define(Ee[213],ye([0,1,16,74,29,77,21,10,17,24,9,11,2,231,128,81,46,90,212,40]),function(re,e,a,t,w,T,k,I,S,R,F,_,n,f,o,m,c,C,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let g=class{constructor(v,y,u,D){this.configurationService=v,this.workspaceContextService=y,this.editorGroupsService=u,this.pathService=D}text(v,y,u={}){v=this.getContentPattern(v,u);const D=this.configurationService.getValue(),A=y&&y.some(B=>!this.configurationService.getValue({resource:B}).search.useRipgrep);return{...this.commonQuery(y?.map(c.toWorkspaceFolder),u),type:2,contentPattern:v,previewOptions:u.previewOptions,maxFileSize:u.maxFileSize,usePCRE2:D.search.usePCRE2||A||!1,beforeContext:u.beforeContext,afterContext:u.afterContext,userDisabledExcludesAndIgnoreFiles:u.disregardExcludeSettings&&u.disregardIgnoreFiles}}getContentPattern(v,y){const u=this.configurationService.getValue();v.isRegExp&&(v.pattern=v.pattern.replace(/\r?\n/g,"\\n"));const D={...v,wordSeparators:u.editor.wordSeparators};return this.isCaseSensitive(v,y)&&(D.isCaseSensitive=!0),this.isMultiline(v)&&(D.isMultiline=!0),D}file(v,y={}){return{...this.commonQuery(v,y),type:1,filePattern:y.filePattern?y.filePattern.trim():y.filePattern,exists:y.exists,sortByScore:y.sortByScore,cacheKey:y.cacheKey}}handleIncludeExclude(v,y){return v?(v=Array.isArray(v)?v.map(i):i(v),y?this.parseSearchPaths(v):{pattern:l(...Array.isArray(v)?v:[v])}):{}}commonQuery(v=[],y={}){const u=this.handleIncludeExclude(y.includePattern,y.expandPatterns),D=this.handleIncludeExclude(y.excludePattern,y.expandPatterns),A=v.length>1,U=(u.searchPaths&&u.searchPaths.length?u.searchPaths.map(N=>this.getFolderQueryForSearchPath(N,y,D)):v.map(N=>this.getFolderQueryForRoot(N,y,D,A))).filter(N=>!!N),B={_reason:y._reason,folderQueries:U,usingSearchPaths:!!(u.searchPaths&&u.searchPaths.length),extraFileResources:y.extraFileResources,excludePattern:D.pattern,includePattern:u.pattern,onlyOpenEditors:y.onlyOpenEditors,maxResults:y.maxResults};if(y.onlyOpenEditors){const L=a.coalesce(a.flatten(this.editorGroupsService.groups.map(H=>H.editors.map(j=>j.resource)))).filter(H=>(0,h.pathIncludedInQuery)(B,H.fsPath)),z=this.commonQueryFromFileList(L);return{...B,...z}}const E=y.extraFileResources&&y.extraFileResources.filter(N=>(0,h.pathIncludedInQuery)(B,N.fsPath));return B.extraFileResources=E&&E.length?E:void 0,B}commonQueryFromFileList(v){const y=[],u=new k.ResourceMap,D={};let A=!1;return v.forEach(U=>{if(U.scheme===I.Schemas.walkThrough)return;if((0,R.isAbsolutePath)(U)){const E=this.workspaceContextService.getWorkspaceFolder(U)?.uri??U.with({path:S.dirname(U.fsPath)});let N=u.get(E);N||(A=!0,N={folder:E,includePattern:{}},y.push(N),u.set(E,N));const L=S.relative(E.fsPath,U.fsPath);(0,_.assertIsDefined)(N.includePattern)[L.replace(/\\/g,"/")]=!0}else U.fsPath&&(A=!0,D[U.fsPath]=!0)}),{folderQueries:y,includePattern:D,usingSearchPaths:!0,excludePattern:A?void 0:{"**/*":!0}}}isCaseSensitive(v,y){if(y.isSmartCase){if(v.isRegExp){if(F.containsUppercaseCharacter(v.pattern,!0))return!0}else if(F.containsUppercaseCharacter(v.pattern))return!0}return!!v.isCaseSensitive}isMultiline(v){return v.isMultiline||v.isRegExp&&(0,f.isMultilineRegexSource)(v.pattern)||v.pattern.indexOf(`
`)>=0?!0:!!v.isMultiline}parseSearchPaths(v){const y=z=>S.isAbsolute(z)||/^\.\.?([\/\\]|$)/.test(z),D=(Array.isArray(v)?v:M(v)).map(z=>{const H=this.pathService.resolvedUserHome;return H?(0,T.untildify)(z,H.scheme===I.Schemas.file?H.fsPath:H.path):z}),A=t.groupBy(D,z=>y(z)?"searchPaths":"exprSegments"),U=(A.exprSegments||[]).map(z=>F.rtrim(z,"/")).map(z=>F.rtrim(z,"\\")).map(z=>(z[0]==="."&&(z="*"+z),r(z))),B={},E=this.expandSearchPathPatterns(A.searchPaths||[]);E&&E.length&&(B.searchPaths=E);const N=a.flatten(U),L=l(...N);return L&&(B.pattern=L),B}getExcludesForFolder(v,y){return y.disregardExcludeSettings?void 0:(0,h.getExcludes)(v,!y.disregardSearchExcludeSettings)}expandSearchPathPatterns(v){if(!v||!v.length)return[];const y=a.flatten(v.map(D=>{let{pathPortion:A,globPortion:U}=P(D);U&&(U=p(U));const B=this.expandOneSearchPath(A);return a.flatten(B.map(E=>this.resolveOneSearchPathPattern(E,U)))})),u=new Map;return y.forEach(D=>{const A=D.searchPath.toString(),U=u.get(A);U?D.pattern&&(U.pattern=U.pattern||{},U.pattern[D.pattern]=!0):u.set(A,{searchPath:D.searchPath,pattern:D.pattern?l(D.pattern):void 0})}),Array.from(u.values())}expandOneSearchPath(v){if(S.isAbsolute(v)){const y=this.workspaceContextService.getWorkspace().folders;return y[0]&&y[0].uri.scheme!==I.Schemas.file?[{searchPath:y[0].uri.with({path:v})}]:[{searchPath:n.URI.file(S.normalize(v))}]}if(this.workspaceContextService.getWorkbenchState()===2){const y=this.workspaceContextService.getWorkspace().folders[0].uri;if(v=i(v),v.startsWith("../")||v===".."){const D=S.posix.resolve(y.path,v);return[{searchPath:y.with({path:D})}]}const u=p(v);return[{searchPath:y,pattern:u}]}else{if(v==="./"||v===".\\")return[];{const y=v.replace(/^\.[\/\\]/,""),D=this.workspaceContextService.getWorkspace().folders.map(A=>{const U=y.match(new RegExp(`^${F.escapeRegExpCharacters(A.name)}(?:/(.*)|$)`));return U?{match:U,folder:A}:null}).filter(_.isDefined);if(D.length)return D.map(A=>{const U=A.match[1];return{searchPath:A.folder.uri,pattern:U&&p(U)}});{const A=v.match(/\.[\/\\](.+)[\/\\]?/),U=A?A[1]:v,B=o.localize(0,null,U);throw new Error(B)}}}}resolveOneSearchPathPattern(v,y){const u=v.pattern&&y?`${v.pattern}/${y}`:v.pattern||y,D=[{searchPath:v.searchPath,pattern:u}];return u&&!u.endsWith("**")&&D.push({searchPath:v.searchPath,pattern:u+"/**"}),D}getFolderQueryForSearchPath(v,y,u){const D=this.getFolderQueryForRoot((0,c.toWorkspaceFolder)(v.searchPath),y,u,!1);return D?{...D,includePattern:v.pattern}:null}getFolderQueryForRoot(v,y,u,D){let A;const U=n.URI.isUri(v)?v:v.uri;if(u.searchPaths){const z=u.searchPaths.filter(H=>(0,R.isEqual)(H.searchPath,U))[0];if(z&&!z.pattern)return null;z&&(A=z.pattern)}const B=this.configurationService.getValue({resource:U}),N={...this.getExcludesForFolder(B,y)||{},...A||{}},L=n.URI.isUri(v)?(0,R.basename)(v):v.name;return{folder:U,folderName:D?L:void 0,excludePattern:Object.keys(N).length>0?N:void 0,fileEncoding:B.files&&B.files.encoding,disregardIgnoreFiles:typeof y.disregardIgnoreFiles=="boolean"?y.disregardIgnoreFiles:!B.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof y.disregardGlobalIgnoreFiles=="boolean"?y.disregardGlobalIgnoreFiles:!B.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof y.ignoreSymlinks=="boolean"?y.ignoreSymlinks:!B.search.followSymlinks}}};g=Ue([$e(0,m.IConfigurationService),$e(1,c.IWorkspaceContextService),$e(2,C.IEditorGroupsService),$e(3,b.IPathService)],g),e.QueryBuilder=g;function P(s){const v=s.match(/[\*\{\}\(\)\[\]\?]/);if(v){const y=v.index,u=s.substr(0,y).match(/[/|\\][^/\\]*$/);if(u){let D=s.substr(0,u.index);return D.match(/[/\\]/)||(D+="/"),{pathPortion:D,globPortion:s.substr((u.index||0)+1)}}}return{pathPortion:s}}function l(...s){return s.length?s.reduce((v,y)=>(v[y]=!0,v),Object.create(null)):void 0}function M(s){return w.splitGlobAware(s,",").map(v=>v.trim()).filter(v=>!!v.length)}function r(s){return[`**/${s}/**`,`**/${s}`].map(y=>y.replace(/\*\*\/\*\*/g,"**"))}function i(s){return s.replace(/\\/g,"/")}function p(s){return i(s).replace(/^\.\//,"").replace(/\/+$/g,"")}function d(s,v){s=a.distinct(s,D=>D.toString());const y=[],u=v.getWorkspace();return s&&s.forEach(D=>{let A;if(v.getWorkbenchState()===2)A=(0,R.relativePath)(u.folders[0].uri,D),A&&A!=="."&&(A="./"+A);else{const U=v.getWorkspaceFolder(D);if(U){const B=U.name;if(u.folders.filter(N=>N.name===B).length===1){const N=(0,R.relativePath)(U.uri,D);N===""?A=`./${U.name}`:A=`./${U.name}/${N}`}else A=D.fsPath}}A&&y.push(A)}),y}e.resolveResourcesForSearchIncludes=d}),define(Ee[214],ye([0,1,24,2,20,15,3,213,40,46]),function(re,e,a,t,w,T,k,I,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const F=7e3;function _(m,c){const C=c.activationEvents;if(!C)return Promise.resolve(void 0);const b=[],h=[];for(const i of C)if(/^workspaceContains:/.test(i)){const p=i.substr("workspaceContains:".length);p.indexOf("*")>=0||p.indexOf("?")>=0||m.forceUsingSearch?h.push(p):b.push(p)}if(b.length===0&&h.length===0)return Promise.resolve(void 0);let g;const P=new Promise((i,p)=>{g=i}),l=i=>g({activationEvent:i}),M=Promise.all(b.map(i=>n(m,i,l))).then(()=>{}),r=f(m,c.identifier,h,l);return Promise.all([M,r]).then(()=>{g(void 0)}),P}e.checkActivateWorkspaceContainsExtension=_;async function n(m,c,C){for(const b of m.folders)if(await m.exists(a.joinPath(t.URI.revive(b),c))){C(`workspaceContains:${c}`);return}}async function f(m,c,C,b){if(C.length===0)return Promise.resolve(void 0);const h=new w.CancellationTokenSource,g=m.checkExists(m.folders,C,h.token),P=setTimeout(async()=>{h.cancel(),m.logService.info(`Not activating extension '${c.value}': Timed out while searching for 'workspaceContains' pattern ${C.join(",")}`)},F);let l=!1;try{l=await g}catch(M){T.isPromiseCanceledError(M)||T.onUnexpectedError(M)}h.dispose(),clearTimeout(P),l&&b(`workspaceContains:${C.join(",")}`)}function o(m,c,C,b){const h=m.get(k.IInstantiationService),g=m.get(S.ISearchService),l=h.createInstance(I.QueryBuilder).file(c.map(M=>(0,R.toWorkspaceFolder)(t.URI.revive(M))),{_reason:"checkExists",includePattern:C,exists:!0});return g.fileSearch(l,b).then(M=>!!M.limitHit,M=>T.isPromiseCanceledError(M)?!1:Promise.reject(M))}e.checkGlobFileExists=o});var Ze=this&&this.__classPrivateFieldSet||function(re,e,a,t,w){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!w:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?w.call(re,a):w?w.value=a:e.set(re,a),a},Te=this&&this.__classPrivateFieldGet||function(re,e,a,t){if(a==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!t:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?t:a==="a"?t.call(re):t?t.value:e.get(re)};define(Ee[33],ye([0,1,120,17,73,24,14,6,21,2,12,5,32,174,71,31,27,172,15,25,22,147,7,84,3,28,72,13,60,64,39,4,214,68,149,10]),function(re,e,a,t,w,T,k,I,S,R,F,_,n,f,o,m,c,C,b,h,g,P,l,M,r,i,p,d,s,v,y,u,D,A,U,B){"use strict";var E,N,L;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,r.createDecorator)("IHostUtils");let z=class ji extends I.Disposable{constructor(G,le,ce,Y,ie,we,Me,Re,Be,Qe){super();this._onDidChangeRemoteConnectionData=this._register(new u.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=le,this._extHostContext=ce,this._initData=Me,this._extHostWorkspace=Y,this._extHostConfiguration=ie,this._logService=we,this._extHostTunnelService=Be,this._extHostTerminalService=Qe,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(_.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(_.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(_.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new k.Barrier,this._readyToStartExtensionHost=new k.Barrier,this._readyToRunExtensions=new k.Barrier,this._eagerExtensionsActivated=new k.Barrier,this._registry=new C.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new o.ExtHostStorage(this._extHostContext),this._secretState=new A.ExtHostSecretState(this._extHostContext),this._storagePath=Re,this._instaService=G.createChild(new s.ServiceCollection([o.IExtHostStorage,this._storage],[A.IExtHostSecretState,this._secretState]));const Ke=new Set;this._initData.hostExtensions.forEach(Xe=>Ke.add(h.ExtensionIdentifier.toKey(Xe))),this._activator=this._register(new f.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(Xe,$,K)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(Xe,b.transformErrorForSerialization($),K)},actualActivateExtension:async(Xe,$)=>{if(Ke.has(h.ExtensionIdentifier.toKey(Xe)))return await this._mainThreadExtensionsProxy.$activateExtension(Xe,$),new f.HostExtension;const K=this._registry.getExtensionDescription(Xe);return this._activateExtension(K,$)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),w.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(G){b.onUnexpectedError(G)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let G=[];try{G=this._registry.getAllExtensionDescriptions().map(ie=>ie.identifier).filter(ie=>this.isActivated(ie)).map(ie=>this._deactivate(ie))}catch{}await Promise.all(G)}isActivated(G){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(G):!1}_activateByEvent(G,le){return this._activator.activateByEvent(G,le)}_activateById(G,le){return this._activator.activateById(G,le)}activateByIdWithErrors(G,le){return this._activateById(G,le).then(()=>{const ce=this._activator.getActivatedExtension(G);if(ce.activationFailed)return Promise.reject(ce.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(G=>this._registry)}getExtensionExports(G){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(G).exports:null}async _realPathExtensionUri(G){if(G.scheme!==B.Schemas.file)return G;const le=await this._hostUtils.realpath(G.fsPath);return R.URI.file(le)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=(async()=>{const G=S.TernarySearchTree.forUris(le=>T.extUriBiasedIgnorePathCase.ignorePathCasing(le));for(const le of this._registry.getAllExtensionDescriptions())if(this._getEntryPoint(le)){const ce=await this._realPathExtensionUri(le.extensionLocation);G.set(ce,le)}return G})()),this._extensionPathIndex}_deactivate(G){let le=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(G))return le;const ce=this._activator.getActivatedExtension(G);if(!ce)return le;try{typeof ce.module.deactivate=="function"&&(le=Promise.resolve(ce.module.deactivate()).then(void 0,Y=>(this._logService.error(Y),Promise.resolve(void 0))))}catch(Y){this._logService.error(Y)}try{(0,I.dispose)(ce.subscriptions)}catch(Y){this._logService.error(Y)}return le}async _activateExtension(G,le){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(G.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(G.identifier),this._doActivateExtension(G,le).then(ce=>{const Y=ce.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(G.identifier,Y.codeLoadingTime,Y.activateCallTime,Y.activateResolvedTime,le),this._logExtensionActivationTimes(G,le,"success",Y),ce},ce=>{throw this._logExtensionActivationTimes(G,le,"failure"),ce})}_logExtensionActivationTimes(G,le,ce,Y){const ie=H(G,le);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...ie,...Y||{},outcome:ce})}_doActivateExtension(G,le){const ce=H(G,le);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",ce);const Y=this._getEntryPoint(G);if(!Y)return Promise.resolve(new f.EmptyExtension(f.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${G.identifier.value}, startup: ${le.startup}, activationEvent: '${le.activationEvent}'${G.identifier.value!==le.extensionId.value?`, root cause: ${le.extensionId.value}`:""}`),this._logService.flush();const ie=new f.ExtensionActivationTimesBuilder(le.startup);return Promise.all([this._loadCommonJSModule(G.identifier,(0,T.joinPath)(G.extensionLocation,Y),ie),this._loadExtensionContext(G)]).then(we=>(w.mark(`code/extHost/willActivateExtension/${G.identifier.value}`),ji._callActivate(this._logService,G.identifier,we[0],we[1],ie))).then(we=>(w.mark(`code/extHost/didActivateExtension/${G.identifier.value}`),we))}_loadExtensionContext(G){const le=new P.ExtensionGlobalMemento(G,this._storage),ce=new P.ExtensionMemento(G.identifier.value,!1,this._storage),Y=new U.ExtensionSecrets(G,this._secretState),ie=G.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?l.ExtensionMode.Test:l.ExtensionMode.Development:l.ExtensionMode.Production,we=this._initData.remote.isRemote?l.ExtensionKind.Workspace:l.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${G.identifier.value}`),Promise.all([le.whenReady,ce.whenReady,this._storagePath.whenReady]).then(()=>{const Me=this;let Re;return Object.freeze({globalState:le,workspaceState:ce,secrets:Y,subscriptions:[],get extensionUri(){return G.extensionLocation},get extensionPath(){return G.extensionLocation.fsPath},asAbsolutePath(Be){return t.join(G.extensionLocation.fsPath,Be)},get storagePath(){return Me._storagePath.workspaceValue(G)?.fsPath},get globalStoragePath(){return Me._storagePath.globalValue(G).fsPath},get logPath(){return t.join(Me._initData.logsLocation.fsPath,G.identifier.value)},get logUri(){return R.URI.joinPath(Me._initData.logsLocation,G.identifier.value)},get storageUri(){return Me._storagePath.workspaceValue(G)},get globalStorageUri(){return Me._storagePath.globalValue(G)},get extensionMode(){return ie},get extension(){return Re===void 0&&(Re=new j(Me,G.identifier,G,we)),Re},get extensionRuntime(){return(0,c.checkProposedApiEnabled)(G,"extensionRuntime"),Me.extensionRuntime},get environmentVariableCollection(){return Me._extHostTerminalService.getEnvironmentVariableCollection(G)}})})}static _callActivate(G,le,ce,Y,ie){return ce=ce||{activate:void 0,deactivate:void 0},this._callActivateOptional(G,le,ce,Y,ie).then(we=>new f.ActivatedExtension(!1,null,ie.build(),ce,we,Y.subscriptions))}static _callActivateOptional(G,le,ce,Y,ie){if(typeof ce.activate=="function")try{ie.activateCallStart(),G.trace(`ExtensionService#_callActivateOptional ${le.value}`);const we=typeof global=="object"?global:self,Me=ce.activate.apply(we,[Y]);return ie.activateCallStop(),ie.activateResolveStart(),Promise.resolve(Me).then(Re=>(ie.activateResolveStop(),Re))}catch(we){return Promise.reject(we)}else return Promise.resolve(ce)}_activateOneStartupFinished(G,le){this._activateById(G.identifier,{startup:!1,extensionId:G.identifier,activationEvent:le}).then(void 0,ce=>{this._logService.error(ce)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(w.getMarks());for(const G of this._registry.getAllExtensionDescriptions())if(G.activationEvents)for(const le of G.activationEvents)le==="onStartupFinished"&&this._activateOneStartupFinished(G,le)}_handleEagerExtensions(){const G=this._activateByEvent("*",!0).then(void 0,ie=>{this._logService.error(ie)});this._register(this._extHostWorkspace.onDidChangeWorkspace(ie=>this._handleWorkspaceContainsEagerExtensions(ie.added)));const le=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],ce=this._handleWorkspaceContainsEagerExtensions(le),Y=Promise.all([G,ce]).then(()=>{});return Promise.race([Y,(0,k.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),Y}_handleWorkspaceContainsEagerExtensions(G){return G.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(le=>this._handleWorkspaceContainsEagerExtension(G,le))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(G,le){if(this.isActivated(le.identifier))return;const ce=!this._initData.remote.isRemote&&!!this._initData.remote.authority,Y={logService:this._logService,folders:G.map(we=>we.uri),forceUsingSearch:ce,exists:we=>this._hostUtils.exists(we.fsPath),checkExists:(we,Me,Re)=>this._mainThreadWorkspaceProxy.$checkExists(we,Me,Re)},ie=await(0,D.checkActivateWorkspaceContainsExtension)(Y,le);if(!!ie)return this._activateById(le.identifier,{startup:!0,extensionId:le.identifier,activationEvent:ie.activationEvent}).then(void 0,we=>this._logService.error(we))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(G){throw console.error(G),G}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:G,extensionTestsLocationURI:le}=this._initData.environment;if(!G||!le)throw new Error(a.localize(0,null));const ce=await this._loadCommonJSModule(null,le,new f.ExtensionActivationTimesBuilder(!1));if(!ce||typeof ce.run!="function")throw new Error(a.localize(1,null,le.toString()));return new Promise((Y,ie)=>{const we=(Be,Qe)=>{Be?ie(Be):Y(typeof Qe=="number"&&Qe>0?1:0)},Me=(0,T.originalFSPath)(le),Re=ce.run(Me,we);Re&&Re.then&&Re.then(()=>{Y(0)}).catch(Be=>{ie(Be.toString())})})}async $extensionTestsExit(G){this._logService.info(`Extension host terminating: test runner requested exit with code ${G}`),this._hostUtils.pid&&this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${G}`),this._logService.flush(),this._hostUtils.exit(G)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(G,le){return this._resolvers[G]=le,(0,I.toDisposable)(()=>{delete this._resolvers[G]})}async _activateAndGetResolver(G){const le=G.indexOf("+");if(le===-1)throw new Error("Not an authority that can be resolved!");const ce=G.substr(0,le);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${ce}`,!1),{authorityPrefix:ce,resolver:this._resolvers[ce]}}async $resolveAuthority(G,le){const{authorityPrefix:ce,resolver:Y}=await this._activateAndGetResolver(G);if(!Y)return{type:"error",error:{code:M.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${ce}.`,detail:void 0}};try{this._register(await this._extHostTunnelService.setTunnelExtensionFunctions(Y)),w.mark(`code/extHost/willResolveAuthority/${ce}`);const ie=await Y.resolve(G,{resolveAttempt:le});w.mark(`code/extHost/didResolveAuthorityOK/${ce}`);const we={authority:G,host:ie.host,port:ie.port,connectionToken:ie.connectionToken},Me={extensionHostEnv:ie.extensionHostEnv,isTrusted:ie.isTrusted,authenticationSession:ie.authenticationSessionForInitializingExtensions?{id:ie.authenticationSessionForInitializingExtensions.id,providerId:ie.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:we,options:Me,tunnelInformation:{environmentTunnels:ie.environmentTunnels}}}}catch(ie){if(w.mark(`code/extHost/didResolveAuthorityError/${ce}`),ie instanceof l.RemoteAuthorityResolverError)return{type:"error",error:{code:ie._code,message:ie._message,detail:ie._detail}};throw ie}}async $getCanonicalURI(G,le){const{authorityPrefix:ce,resolver:Y}=await this._activateAndGetResolver(G);if(!Y)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${ce}`);const ie=R.URI.revive(le);if(typeof Y.getCanonicalURI=="undefined")return ie;const we=await(0,k.asPromise)(()=>Y.getCanonicalURI(ie));return we||ie}$startExtensionHost(G){return this._registry.keepOnly(G),this._startExtensionHost()}$activateByEvent(G,le){return le===1?this._activateByEvent(G,!1):this._readyToRunExtensions.wait().then(ce=>this._activateByEvent(G,!1))}async $activate(G,le){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(G)?(await this._activateById(G,le),!0):!1}async $deltaExtensions(G,le){G.forEach(Y=>Y.extensionLocation=R.URI.revive(Y.extensionLocation));const ce=await this.getExtensionPathIndex();return await Promise.all(le.map(async Y=>{const ie=this._registry.getExtensionDescription(Y);ie&&ce.delete(await this._realPathExtensionUri(ie.extensionLocation))})),await Promise.all(G.map(async Y=>{const ie=await this._realPathExtensionUri(Y.extensionLocation);ce.set(ie,Y)})),this._registry.deltaExtensions(G,le),Promise.resolve(void 0)}async $test_latency(G){return G}async $test_up(G){return G.byteLength}async $test_down(G){let le=g.VSBuffer.alloc(G),ce=Math.random()%256;for(let Y=0;Y<G;Y++)le.writeUInt8(ce,Y);return le}async $updateRemoteConnectionData(G){this._remoteConnectionData=G,this._onDidChangeRemoteConnectionData.fire()}};z=Ue([$e(0,r.IInstantiationService),$e(1,e.IHostUtils),$e(2,d.IExtHostRpcService),$e(3,m.IExtHostWorkspace),$e(4,n.IExtHostConfiguration),$e(5,F.ILogService),$e(6,i.IExtHostInitDataService),$e(7,p.IExtensionStoragePaths),$e(8,v.IExtHostTunnelService),$e(9,y.IExtHostTerminalService)],z),e.AbstractExtHostExtensionService=z;function H(ue,G){return{id:ue.identifier.value,name:ue.name,extensionVersion:ue.version,publisherDisplayName:ue.publisher,activationEvents:ue.activationEvents?ue.activationEvents.join(","):null,isBuiltin:ue.isBuiltin,reason:G.activationEvent,reasonId:G.extensionId.value}}e.IExtHostExtensionService=(0,r.createDecorator)("IExtHostExtensionService");class j{constructor(G,le,ce,Y){E.set(this,void 0),N.set(this,void 0),L.set(this,void 0),Ze(this,E,G,"f"),Ze(this,N,le,"f"),Ze(this,L,ce.identifier,"f"),this.id=ce.identifier.value,this.extensionUri=ce.extensionLocation,this.extensionPath=t.normalize((0,T.originalFSPath)(ce.extensionLocation)),this.packageJSON=ce,this.extensionKind=Y}get isActive(){return Te(this,E,"f").isActivated(Te(this,L,"f"))}get exports(){if(this.packageJSON.api!=="none")return Te(this,E,"f").getExtensionExports(Te(this,L,"f"))}activate(){return Te(this,E,"f").activateByIdWithErrors(Te(this,L,"f"),{startup:!1,extensionId:Te(this,N,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=j,E=new WeakMap,N=new WeakMap,L=new WeakMap}),define(Ee[98],ye([0,1,17,2,4,14,5,7,156,31,33,48,163,32,157,13,3,11,89,70]),function(re,e,a,t,w,T,k,I,S,R,F,_,n,f,o,m,c,C,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,c.createDecorator)("IExtHostDebugService");let g=class{constructor(s,v,y,u,D,A){this._workspaceService=v,this._extensionService=y,this._editorsService=u,this._configurationService=D,this._editorTabs=A,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new w.Emitter,this._onDidTerminateDebugSession=new w.Emitter,this._onDidChangeActiveDebugSession=new w.Emitter,this._onDidReceiveDebugSessionCustomEvent=new w.Emitter,this._debugServiceProxy=s.getProxy(k.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new w.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new l(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(U=>{U.onDidChange(B=>{this.registerAllDebugTypes(U)}),this.registerAllDebugTypes(U)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(s,v){const y=s;if(typeof y.sourceReference=="number"&&y.sourceReference>0){let u=`debug:${encodeURIComponent(y.path||"")}`,D="?";return v&&(u+=`${D}session=${encodeURIComponent(v.id)}`,D="&"),u+=`${D}ref=${y.sourceReference}`,t.URI.parse(u)}else{if(y.path)return t.URI.file(y.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(s){const v=[];for(const y of s.getAllExtensionDescriptions())if(y.contributes){const u=y.contributes.debuggers;if(u&&u.length>0)for(const D of u)(0,o.isDebuggerMainContribution)(D)&&v.push(D.type)}this._debugServiceProxy.$registerDebugTypes(v)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const s=[];return this._breakpoints.forEach(v=>s.push(v)),s}addBreakpoints(s){this.startBreakpoints();const v=s.filter(D=>{const A=D.id;return this._breakpoints.has(A)?!1:(this._breakpoints.set(A,D),!0)});this.fireBreakpointChanges(v,[],[]);const y=[],u=new Map;for(const D of v)if(D instanceof I.SourceBreakpoint){let A=u.get(D.location.uri.toString());A||(A={type:"sourceMulti",uri:D.location.uri,lines:[]},u.set(D.location.uri.toString(),A),y.push(A)),A.lines.push({id:D.id,enabled:D.enabled,condition:D.condition,hitCondition:D.hitCondition,logMessage:D.logMessage,line:D.location.range.start.line,character:D.location.range.start.character})}else D instanceof I.FunctionBreakpoint&&y.push({type:"function",id:D.id,enabled:D.enabled,hitCondition:D.hitCondition,logMessage:D.logMessage,condition:D.condition,functionName:D.functionName});return this._debugServiceProxy.$registerBreakpoints(y)}removeBreakpoints(s){this.startBreakpoints();const v=s.filter(A=>this._breakpoints.delete(A.id));this.fireBreakpointChanges([],v,[]);const y=v.filter(A=>A instanceof I.SourceBreakpoint).map(A=>A.id),u=v.filter(A=>A instanceof I.FunctionBreakpoint).map(A=>A.id),D=v.filter(A=>A instanceof I.DataBreakpoint).map(A=>A.id);return this._debugServiceProxy.$unregisterBreakpoints(y,u,D)}startDebugging(s,v,y){return this._debugServiceProxy.$startDebugging(s?s.uri:void 0,v,{parentSessionID:y.parentSession?y.parentSession.id:void 0,lifecycleManagedByParent:y.lifecycleManagedByParent,repl:y.consoleMode===I.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:y.noDebug,compact:y.compact,debugUI:y.debugUI,suppressSaveBeforeStart:y.suppressSaveBeforeStart})}stopDebugging(s){return this._debugServiceProxy.$stopDebugging(s?s.id:void 0)}registerDebugConfigurationProvider(s,v,y){if(!v)return new I.Disposable(()=>{});const u=this._configProviderHandleCounter++;return this._configProviders.push({type:s,handle:u,provider:v}),this._debugServiceProxy.$registerDebugConfigurationProvider(s,y,!!v.provideDebugConfigurations,!!v.resolveDebugConfiguration,!!v.resolveDebugConfigurationWithSubstitutedVariables,u),new I.Disposable(()=>{this._configProviders=this._configProviders.filter(D=>D.provider!==v),this._debugServiceProxy.$unregisterDebugConfigurationProvider(u)})}registerDebugAdapterDescriptorFactory(s,v,y){if(!y)return new I.Disposable(()=>{});if(!this.definesDebugType(s,v))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${v}' debugger.`);if(this.getAdapterDescriptorFactoryByType(v))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const u=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:v,handle:u,factory:y}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(v,u),new I.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(D=>D.factory!==y),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(u)})}registerDebugAdapterTrackerFactory(s,v){if(!v)return new I.Disposable(()=>{});const y=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:s,handle:y,factory:v}),new I.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(u=>u.factory!==v)})}async $runInTerminal(s,v){return Promise.resolve(void 0)}async $substituteVariables(s,v){if(!this._variableResolver){const[D,A]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(D||[],this._editorsService,A)}let y;const u=await this.getFolder(s);return u&&(y={uri:u.uri,name:u.name,index:u.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(y,v)}createDebugAdapter(s,v){if(s.type==="implementation")return new i(s.implementation)}createSignService(){}async $startDASession(s,v){const y=this,u=await this.getSession(v);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(u.type),u).then(D=>{if(!D)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${u.type}' (extension might have failed to activate)`);const A=this.convertToDto(D),U=this.createDebugAdapter(A,u);if(!U)throw new Error(`Couldn't create a debug adapter for type '${u.type}'.`);const B=U;return this._debugAdapters.set(s,B),this.getDebugAdapterTrackers(u).then(E=>(E&&this._debugAdaptersTrackers.set(s,E),B.onMessage(async N=>{if(N.type==="request"&&N.command==="handshake"){const L=N,z={type:"response",seq:0,command:L.command,request_seq:L.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const H=await this._signService.sign(L.arguments.value);z.body={signature:H},B.sendResponse(z)}else throw new Error("no signer")}catch(H){z.success=!1,z.message=H.message,B.sendResponse(z)}}else E&&E.onDidSendMessage&&E.onDidSendMessage(N),N=(0,o.convertToVSCPaths)(N,!0),y._debugServiceProxy.$acceptDAMessage(s,N)}),B.onError(N=>{E&&E.onError&&E.onError(N),this._debugServiceProxy.$acceptDAError(s,N.name,N.message,N.stack)}),B.onExit(N=>{E&&E.onExit&&E.onExit((0,C.withNullAsUndefined)(N),void 0),this._debugServiceProxy.$acceptDAExit(s,(0,C.withNullAsUndefined)(N),void 0)}),E&&E.onWillStartSession&&E.onWillStartSession(),B.startSession()))})}$sendDAMessage(s,v){v=(0,o.convertToDAPaths)(v,!1);const y=this._debugAdaptersTrackers.get(s);y&&y.onWillReceiveMessage&&y.onWillReceiveMessage(v);const u=this._debugAdapters.get(s);u&&u.sendMessage(v)}$stopDASession(s){const v=this._debugAdaptersTrackers.get(s);this._debugAdaptersTrackers.delete(s),v&&v.onWillStopSession&&v.onWillStopSession();const y=this._debugAdapters.get(s);return this._debugAdapters.delete(s),y?y.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(s){const v=[],y=[],u=[];if(s.added)for(const D of s.added){const A=D.id;if(A&&!this._breakpoints.has(A)){let U;if(D.type==="function")U=new I.FunctionBreakpoint(D.functionName,D.enabled,D.condition,D.hitCondition,D.logMessage);else if(D.type==="data")U=new I.DataBreakpoint(D.label,D.dataId,D.canPersist,D.enabled,D.hitCondition,D.condition,D.logMessage);else{const B=t.URI.revive(D.uri);U=new I.SourceBreakpoint(new I.Location(B,new I.Position(D.line,D.character)),D.enabled,D.condition,D.hitCondition,D.logMessage)}U._id=A,this._breakpoints.set(A,U),v.push(U)}}if(s.removed)for(const D of s.removed){const A=this._breakpoints.get(D);A&&(this._breakpoints.delete(D),y.push(A))}if(s.changed){for(const D of s.changed)if(D.id){const A=this._breakpoints.get(D.id);if(A){if(A instanceof I.FunctionBreakpoint&&D.type==="function"){const U=A;U.enabled=D.enabled,U.condition=D.condition,U.hitCondition=D.hitCondition,U.logMessage=D.logMessage,U.functionName=D.functionName}else if(A instanceof I.SourceBreakpoint&&D.type==="source"){const U=A;U.enabled=D.enabled,U.condition=D.condition,U.hitCondition=D.hitCondition,U.logMessage=D.logMessage,U.location=new I.Location(t.URI.revive(D.uri),new I.Position(D.line,D.character))}u.push(A)}}}this.fireBreakpointChanges(v,y,u)}$provideDebugConfigurations(s,v,y){return(0,T.asPromise)(async()=>{const u=this.getConfigProviderByHandle(s);if(!u)throw new Error("no DebugConfigurationProvider found");if(!u.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const D=await this.getFolder(v);return u.provideDebugConfigurations(D,y)}).then(u=>{if(!u)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return u})}$resolveDebugConfiguration(s,v,y,u){return(0,T.asPromise)(async()=>{const D=this.getConfigProviderByHandle(s);if(!D)throw new Error("no DebugConfigurationProvider found");if(!D.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const A=await this.getFolder(v);return D.resolveDebugConfiguration(A,y,u)})}$resolveDebugConfigurationWithSubstitutedVariables(s,v,y,u){return(0,T.asPromise)(async()=>{const D=this.getConfigProviderByHandle(s);if(!D)throw new Error("no DebugConfigurationProvider found");if(!D.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const A=await this.getFolder(v);return D.resolveDebugConfigurationWithSubstitutedVariables(A,y,u)})}async $provideDebugAdapter(s,v){const y=this.getAdapterDescriptorFactoryByHandle(s);if(!y)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const u=await this.getSession(v);return this.getAdapterDescriptor(y,u).then(D=>{if(!D)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${u.type}'`);return this.convertToDto(D)})}async $acceptDebugSessionStarted(s){const v=await this.getSession(s);this._onDidStartDebugSession.fire(v)}async $acceptDebugSessionTerminated(s){const v=await this.getSession(s);v&&(this._onDidTerminateDebugSession.fire(v),this._debugSessions.delete(v.id))}async $acceptDebugSessionActiveChanged(s){this._activeDebugSession=s?await this.getSession(s):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(s,v){const y=await this.getSession(s);y&&y._acceptNameChanged(v)}async $acceptDebugSessionCustomEvent(s,v){const u={session:await this.getSession(s),event:v.event,body:v.body};this._onDidReceiveDebugSessionCustomEvent.fire(u)}convertToDto(s){if(s instanceof I.DebugAdapterExecutable)return{type:"executable",command:s.command,args:s.args,options:s.options};if(s instanceof I.DebugAdapterServer)return{type:"server",port:s.port,host:s.host};if(s instanceof I.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:s.path};if(s instanceof I.DebugAdapterInlineImplementation)return{type:"implementation",implementation:s.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(s){const v=this._adapterFactories.filter(y=>y.type===s);if(v.length>0)return v[0].factory}getAdapterDescriptorFactoryByHandle(s){const v=this._adapterFactories.filter(y=>y.handle===s);if(v.length>0)return v[0].factory}getConfigProviderByHandle(s){const v=this._configProviders.filter(y=>y.handle===s);if(v.length>0)return v[0].provider}definesDebugType(s,v){if(s.contributes){const y=s.contributes.debuggers;if(y&&y.length>0){for(const u of y)if(u.label&&u.type&&u.type===v)return!0}}return!1}getDebugAdapterTrackers(s){const y=s.configuration.type,u=this._trackerFactories.filter(D=>D.type===y||D.type==="*").map(D=>(0,T.asPromise)(()=>D.factory.createDebugAdapterTracker(s)).then(A=>A,A=>null));return Promise.race([Promise.all(u).then(D=>{const A=D.filter(U=>!!U);if(A.length>0)return new r(A)}),new Promise((D,A)=>{const U=setTimeout(()=>{clearTimeout(U),A(new Error("timeout"))},1e3)})]).catch(D=>{})}async getAdapterDescriptor(s,v){const y=v.configuration.debugServer;if(typeof y=="number")return Promise.resolve(new I.DebugAdapterServer(y));if(s){const D=await this._extensionService.getExtensionRegistry();return(0,T.asPromise)(()=>s.createDebugAdapterDescriptor(v,this.daExecutableFromPackage(v,D))).then(A=>{if(A)return A})}const u=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(v,u))}daExecutableFromPackage(s,v){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(s,v,y){(s.length>0||v.length>0||y.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:s,removed:v,changed:y}))}async getSession(s){if(s)if(typeof s=="string"){const v=this._debugSessions.get(s);if(v)return v}else{let v=this._debugSessions.get(s.id);if(!v){const y=await this.getFolder(s.folderUri),u=s.parent?this._debugSessions.get(s.parent):void 0;v=new P(this._debugServiceProxy,s.id,s.type,s.name,y,s.configuration,u),this._debugSessions.set(v.id,v),this._debugServiceProxy.$sessionCached(v.id)}return v}throw new Error("cannot find session")}getFolder(s){if(s){const v=t.URI.revive(s);return this._workspaceService.resolveWorkspaceFolder(v)}return Promise.resolve(void 0)}};g=Ue([$e(0,m.IExtHostRpcService),$e(1,R.IExtHostWorkspace),$e(2,F.IExtHostExtensionService),$e(3,_.IExtHostDocumentsAndEditors),$e(4,f.IExtHostConfiguration),$e(5,h.IExtHostEditorTabs)],g),e.ExtHostDebugServiceBase=g;class P{constructor(s,v,y,u,D,A,U){this._debugServiceProxy=s,this._id=v,this._type=y,this._name=u,this._workspaceFolder=D,this._configuration=A,this._parentSession=U}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(s){this._name=s,this._debugServiceProxy.$setDebugSessionName(this._id,s)}get parentSession(){return this._parentSession}_acceptNameChanged(s){this._name=s}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(s,v){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,s,v)}getDebugProtocolBreakpoint(s){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,s.id)}}e.ExtHostDebugSession=P;class l{constructor(s){this.value=Object.freeze({append(v){s.$appendDebugConsole(v)},appendLine(v){this.append(v+`
`)}})}}e.ExtHostDebugConsole=l;class M extends n.AbstractVariableResolverService{constructor(s,v,y,u,D){function A(){if(v){const U=v.activeEditor();if(U)return U.document.uri;const B=u.tabs.filter(E=>E.isActive);if(B.length>0){const E=B[0].resource;return E&&(E.primary||E.secondary)?E.primary??E.secondary:B[0].resource}}}super({getFolderUri:U=>{const B=s.filter(E=>E.name===U);if(B&&B.length>0)return B[0].uri},getWorkspaceFolderCount:()=>s.length,getConfigurationValue:(U,B)=>y.getConfiguration(void 0,U).get(B),getAppRoot:()=>b.cwd(),getExecPath:()=>b.env.VSCODE_EXEC_PATH,getFilePath:()=>{const U=A();if(U)return a.normalize(U.fsPath)},getWorkspaceFolderPathForFile:()=>{if(D){const U=A();if(U){const B=D.getWorkspaceFolder(U);if(B)return a.normalize(B.uri.fsPath)}}},getSelectedText:()=>{if(v){const U=v.activeEditor();if(U&&!U.selection.isEmpty)return U.document.getText(U.selection)}},getLineNumber:()=>{if(v){const U=v.activeEditor();if(U)return String(U.selection.end.line+1)}}},void 0,Promise.resolve(b.env))}}e.ExtHostVariableResolverService=M;class r{constructor(s){this.trackers=s}onWillStartSession(){this.trackers.forEach(s=>s.onWillStartSession?s.onWillStartSession():void 0)}onWillReceiveMessage(s){this.trackers.forEach(v=>v.onWillReceiveMessage?v.onWillReceiveMessage(s):void 0)}onDidSendMessage(s){this.trackers.forEach(v=>v.onDidSendMessage?v.onDidSendMessage(s):void 0)}onWillStopSession(){this.trackers.forEach(s=>s.onWillStopSession?s.onWillStopSession():void 0)}onError(s){this.trackers.forEach(v=>v.onError?v.onError(s):void 0)}onExit(s,v){this.trackers.forEach(y=>y.onExit?y.onExit(s,v):void 0)}}class i extends S.AbstractDebugAdapter{constructor(s){super();this.implementation=s,s.onDidSendMessage(v=>{this.acceptMessage(v)})}startSession(){return Promise.resolve(void 0)}sendMessage(s){this.implementation.handleMessage(s)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let p=class extends g{constructor(s,v,y,u,D,A){super(s,v,y,u,D,A)}createVariableResolver(s,v,y){return new M(s,v,y,this._editorTabs)}};p=Ue([$e(0,m.IExtHostRpcService),$e(1,R.IExtHostWorkspace),$e(2,F.IExtHostExtensionService),$e(3,_.IExtHostDocumentsAndEditors),$e(4,f.IExtHostConfiguration),$e(5,h.IExtHostEditorTabs)],p),e.WorkerExtHostDebugService=p}),define(Ee[215],ye([0,1,73,2,5,32,27,25,13,28,3,33,89,12]),function(re,e,a,t,w,T,k,I,S,R,F,_,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let o=class{constructor(h,g,P,l,M,r,i){this._apiFactory=h,this._extensionRegistry=g,this._instaService=P,this._extHostConfiguration=l,this._extHostExtensionService=M,this._initData=r,this._logService=i,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),a.mark("code/extHost/willWaitForConfig");const h=await this._extHostConfiguration.getConfigProvider();a.mark("code/extHost/didWaitForConfig");const g=await this._extHostExtensionService.getExtensionPathIndex();this.register(new m(this._apiFactory,g,this._extensionRegistry,h,this._logService)),this.register(this._instaService.createInstance(c,g)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(C,g,this._initData.environment.appUriScheme))}register(h){if(Array.isArray(h.nodeModuleName))for(let g of h.nodeModuleName)this._factories.set(g,h);else this._factories.set(h.nodeModuleName,h);typeof h.alternativeModuleName=="function"&&this._alternatives.push(g=>h.alternativeModuleName(g))}};o=Ue([$e(2,F.IInstantiationService),$e(3,T.IExtHostConfiguration),$e(4,_.IExtHostExtensionService),$e(5,R.IExtHostInitDataService),$e(6,f.ILogService)],o),e.RequireInterceptor=o;class m{constructor(h,g,P,l,M){this._apiFactory=h,this._extensionPaths=g,this._extensionRegistry=P,this._configProvider=l,this._logService=M,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(h,g){const P=this._extensionPaths.findSubstr(g);if(P){let l=this._extApiImpl.get(I.ExtensionIdentifier.toKey(P.identifier));return l||(l=this._apiFactory(P,this._extensionRegistry,this._configProvider),this._extApiImpl.set(I.ExtensionIdentifier.toKey(P.identifier),l)),l}if(!this._defaultApiImpl){let l="";this._extensionPaths.forEach((M,r)=>l+=`	${r} -> ${M.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${g}. These are the extension path mappings: 
${l}`),this._defaultApiImpl=this._apiFactory(k.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let c=class{constructor(h,g,P){this._extensionPaths=h,this.nodeModuleName="keytar",this._mainThreadTelemetry=g.getProxy(w.MainContext.MainThreadTelemetry);const{environment:l}=P,M=g.getProxy(w.MainContext.MainThreadKeytar);if(l.appRoot){let r=l.appRoot.fsPath;n.platform==="win32"&&(r=r.replace(/\\/g,"/")),r[r.length-1]==="/"&&(r=r.substr(0,r.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${r}/node_modules.asar/keytar`),this.alternativeNames.add(`${r}/node_modules/keytar`)}this._impl={getPassword:(r,i)=>M.$getPassword(r,i),setPassword:(r,i,p)=>M.$setPassword(r,i,p),deletePassword:(r,i)=>M.$deletePassword(r,i),findPassword:r=>M.$findPassword(r),findCredentials(r){return M.$findCredentials(r)}}}load(h,g){const P=this._extensionPaths.findSubstr(g);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:P?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(h){const g=h.length;if(g<=7||!this.alternativeNames)return;const P=g-7;if((h.charAt(P)==="/"||h.charAt(P)==="\\")&&h.endsWith("keytar")&&(h=h.replace(/\\/g,"/"),this.alternativeNames.has(h)))return"keytar"}};c=Ue([$e(1,S.IExtHostRpcService),$e(2,R.IExtHostInitDataService)],c);let C=class{constructor(h,g,P){this._extensionPaths=h,this._appUriScheme=g,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=P.getProxy(w.MainContext.MainThreadTelemetry);const l=P.getProxy(w.MainContext.MainThreadWindow);this._impl=(M,r)=>{const i=t.URI.parse(M);return r?this.callOriginal(M,r):i.scheme==="http"||i.scheme==="https"?l.$openUri(i,M,{allowTunneling:!0}):i.scheme==="mailto"||i.scheme===this._appUriScheme?l.$openUri(i,M,{}):this.callOriginal(M,r)}}load(h,g,P){const l=this._extensionPaths.findSubstr(g);return l&&(this._extensionId=l.identifier.value,this.sendShimmingTelemetry()),this._original=P(h),this._impl}callOriginal(h,g){return this.sendNoForwardTelemetry(),this._original(h,g)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};C=Ue([$e(2,S.IExtHostRpcService)],C)}),define(Ee[216],ye([0,1,14,15,73,6,2,5,209,12,56,60,28,137,13,65,33,39]),function(re,e,a,t,w,T,k,I,S,R,F,_,n,f,o,m,c,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class b{constructor(g,P,l,M){this._disposables=new T.DisposableStore,this._isTerminating=!1,this._hostUtils=l,this._rpcProtocol=new S.RPCProtocol(g,null,M),P=b._transform(P,this._rpcProtocol);const r=new _.ServiceCollection(...(0,F.getSingletonServiceDescriptors)());r.set(n.IExtHostInitDataService,{_serviceBrand:void 0,...P}),r.set(o.IExtHostRpcService,new o.ExtHostRpcService(this._rpcProtocol)),r.set(m.IURITransformerService,new m.URITransformerService(M)),r.set(c.IHostUtils,l);const i=new f.InstantiationService(r,!0);this._disposables.add(i.invokeFunction(v=>v.get(C.IExtHostTerminalService))),this._disposables.add(i.invokeFunction(v=>v.get(c.IExtHostExtensionService))),this._logService=i.invokeFunction(v=>v.get(R.ILogService)),w.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",P),this._extensionService=i.invokeFunction(v=>v.get(c.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const p=new WeakMap;this._extensionService.getExtensionPathIndex().then(v=>{Error.prepareStackTrace=(y,u)=>{let D="",A,U;for(const B of u)D+=`
	at ${B.toString()}`,U=B.getFileName(),!A&&U&&(A=v.findSubstr(k.URI.file(U)));return p.set(y,A),`${y.name||"Error"}: ${y.message||""}${D}`}});const d=this._rpcProtocol.getProxy(I.MainContext.MainThreadExtensionService),s=this._rpcProtocol.getProxy(I.MainContext.MainThreadErrors);t.setUnexpectedErrorHandler(v=>{const y=t.transformErrorForSerialization(v),u=p.get(v);u?d.$onExtensionRuntimeError(u.identifier,y):s.$onUnexpectedError(y)})}terminate(g){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${g}`),this._logService.flush(),this._disposables.dispose(),t.setUnexpectedErrorHandler(l=>{this._logService.error(l)}),this._rpcProtocol.dispose();const P=this._extensionService.deactivateAll();Promise.race([(0,a.timeout)(5e3),P]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code 0`):this._logService.info("Extension host exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})}static _transform(g,P){g.extensions.forEach(M=>M.extensionLocation=k.URI.revive(P.transformIncomingURIs(M.extensionLocation))),g.environment.appRoot=k.URI.revive(P.transformIncomingURIs(g.environment.appRoot));const l=g.environment.extensionDevelopmentLocationURI;return l&&(g.environment.extensionDevelopmentLocationURI=l.map(M=>k.URI.revive(P.transformIncomingURIs(M)))),g.environment.extensionTestsLocationURI=k.URI.revive(P.transformIncomingURIs(g.environment.extensionTestsLocationURI)),g.environment.globalStorageHome=k.URI.revive(P.transformIncomingURIs(g.environment.globalStorageHome)),g.environment.workspaceStorageHome=k.URI.revive(P.transformIncomingURIs(g.environment.workspaceStorageHome)),g.logsLocation=k.URI.revive(P.transformIncomingURIs(g.logsLocation)),g.logFile=k.URI.revive(P.transformIncomingURIs(g.logFile)),g.workspace=P.transformIncomingURIs(g.workspace),g}}e.ExtensionHostMain=b}),define(Ee[217],ye([0,1,17,20,43,29,24,190,40]),function(re,e,a,t,w,T,k,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class R{constructor(n,f,o){this.config=n,this.provider=f,this.sessionToken=o,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=n.filePattern,this.includePattern=n.includePattern&&T.parse(n.includePattern),this.maxResults=n.maxResults||void 0,this.exists=n.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=n.excludePattern&&T.parse(n.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(n=>n.cancel()),this.activeCancellationTokens=new Set}search(n){const f=this.config.folderQueries||[];return new Promise((o,m)=>{const c=C=>{this.resultCount++,n(C)};if(this.isCanceled)return o({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(C=>{const b=C.toString(),h=a.basename(b);this.globalExcludePattern&&this.globalExcludePattern(b,h)||this.matchFile(c,{base:C,basename:h})}),Promise.all(f.map(C=>this.searchInFolder(C,c))).then(C=>{o({limitHit:this.isLimitHit,stats:C[0]||void 0})},C=>{m(new Error((0,w.toErrorMessage)(C)))})})}async searchInFolder(n,f){const o=new t.CancellationTokenSource,m=this.getSearchOptionsForFolder(n),c=this.initDirectoryTree(),C=new S.QueryGlobTester(this.config,n),b=!C.hasSiblingExcludeClauses();let h;try{this.activeCancellationTokens.add(o),h=I.StopWatch.create();const g=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},m,o.token),P=h.elapsed(),l=I.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(g&&g.forEach(M=>{const r=a.posix.relative(n.folder.path,M.path);if(b){const i=a.basename(M.path);this.matchFile(f,{base:n.folder,relativePath:r,basename:i});return}this.addDirectoryEntries(c,n.folder,r,f)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(c,C,f),{providerTime:P,postProcessTime:l.elapsed()})}finally{o.dispose(),this.activeCancellationTokens.delete(o)}}getSearchOptionsForFolder(n){const f=(0,S.resolvePatternsForProvider)(this.config.includePattern,n.includePattern),o=(0,S.resolvePatternsForProvider)(this.config.excludePattern,n.excludePattern);return{folder:n.folder,excludes:o,includes:f,useIgnoreFiles:!n.disregardIgnoreFiles,useGlobalIgnoreFiles:!n.disregardGlobalIgnoreFiles,followSymlinks:!n.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const n={rootEntries:[],pathToEntries:Object.create(null)};return n.pathToEntries["."]=n.rootEntries,n}addDirectoryEntries({pathToEntries:n},f,o,m){if(o===this.filePattern){const C=a.basename(this.filePattern);this.matchFile(m,{base:f,relativePath:this.filePattern,basename:C})}function c(C){const b=a.basename(C),h=a.dirname(C);let g=n[h];g||(g=n[h]=[],c(h)),g.push({base:f,relativePath:C,basename:b})}c(o)}matchDirectoryTree({rootEntries:n,pathToEntries:f},o,m){const c=this,C=this.filePattern;function b(h){const g=T.hasSiblingFn(()=>h.map(P=>P.basename));for(let P=0,l=h.length;P<l;P++){const M=h[P],{relativePath:r,basename:i}=M;if(o.matchesExcludesSync(r,i,C!==i?g:void 0))continue;const p=f[r];if(p)b(p);else{if(r===C)continue;c.matchFile(m,M)}if(c.isLimitHit)break}}b(n)}matchFile(n,f){(!this.includePattern||f.relativePath&&this.includePattern(f.relativePath,f.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||n(f))}}class F{constructor(){this.sessions=new Map}fileSearch(n,f,o,m){const c=this.getSessionTokenSource(n.cacheKey),C=new R(n,f,c&&c.token);let b=0;const h=g=>{b+=g.length,o(g.map(P=>this.rawMatchToSearchItem(P)))};return this.doSearch(C,F.BATCH_SIZE,h,m).then(g=>({limitHit:g.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:b,detailStats:g.stats}}))}clearCache(n){const f=this.getSessionTokenSource(n);f&&f.cancel()}getSessionTokenSource(n){if(!!n)return this.sessions.has(n)||this.sessions.set(n,new t.CancellationTokenSource),this.sessions.get(n)}rawMatchToSearchItem(n){return n.relativePath?{resource:k.joinPath(n.base,n.relativePath)}:{resource:n.base}}doSearch(n,f,o,m){m.onCancellationRequested(()=>{n.cancel()});const c=b=>{b&&(C.push(b),f>0&&C.length>=f&&(o(C),C=[]))};let C=[];return n.search(c).then(b=>(C.length&&o(C),b),b=>(C.length&&o(C),Promise.reject(b)))}}e.FileSearchManager=F,F.BATCH_SIZE=512}),define(Ee[218],ye([0,1,16,20,43,29,10,17,24,11,2,40]),function(re,e,a,t,w,T,k,I,S,R,F,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class n{constructor(h,g,P,l){this.query=h,this.provider=g,this.fileUtils=P,this.processType=l,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(h,g){const P=this.query.folderQueries||[],l=new t.CancellationTokenSource;return g.onCancellationRequested(()=>l.cancel()),new Promise((M,r)=>{this.collector=new o(h);let i=!1;const p=(d,s)=>{if(!i&&!this.isLimitHit){const v=this.resultSize(d);c(d)&&typeof this.query.maxResults=="number"&&this.resultCount+v>this.query.maxResults&&(this.isLimitHit=!0,i=!0,l.cancel(),d=this.trimResultToSize(d,this.query.maxResults-this.resultCount));const y=this.resultSize(d);this.resultCount+=y,(y>0||!c(d))&&this.collector.add(d,s)}};Promise.all(P.map((d,s)=>this.searchInFolder(d,v=>p(v,s),l.token))).then(d=>{l.dispose(),this.collector.flush();const s=d.some(v=>!!v&&!!v.limitHit);M({limitHit:this.isLimitHit||s,messages:(0,a.flatten)(d.map(v=>v?.message?(0,R.isArray)(v.message)?v.message:[v.message]:[])),stats:{type:this.processType}})},d=>{l.dispose();const s=(0,w.toErrorMessage)(d);r(new Error(s))})})}resultSize(h){return c(h)?Array.isArray(h.ranges)?h.ranges.length:1:0}trimResultToSize(h,g){const P=Array.isArray(h.ranges)?h.ranges:[h.ranges],l=Array.isArray(h.preview.matches)?h.preview.matches:[h.preview.matches];return{ranges:P.slice(0,g),preview:{matches:l.slice(0,g),text:h.preview.text},uri:h.uri}}async searchInFolder(h,g,P){const l=new _.QueryGlobTester(this.query,h),M=[],r={report:d=>{if(!this.validateProviderResult(d))return;const s=h.folder.scheme===k.Schemas.file?T.hasSiblingPromiseFn(()=>this.fileUtils.readdir(S.dirname(d.uri))):void 0,v=S.relativePath(h.folder,d.uri);if(v){const y=l.includedInQuery(v,I.basename(v),s);(0,R.isPromise)(y)?M.push(y.then(u=>{u&&g(d)})):y&&g(d)}}},i=this.getSearchOptionsForFolder(h),p=await this.provider.provideTextSearchResults(f(this.query.contentPattern),i,r,P);return M.length&&await Promise.all(M),p}validateProviderResult(h){if(c(h)){if(Array.isArray(h.ranges)){if(!Array.isArray(h.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(h.preview.matches.length!==h.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(h.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(h){const g=(0,_.resolvePatternsForProvider)(this.query.includePattern,h.includePattern),P=(0,_.resolvePatternsForProvider)(this.query.excludePattern,h.excludePattern),l={folder:F.URI.from(h.folder),excludes:P,includes:g,useIgnoreFiles:!h.disregardIgnoreFiles,useGlobalIgnoreFiles:!h.disregardGlobalIgnoreFiles,followSymlinks:!h.ignoreSymlinks,encoding:h.fileEncoding&&this.fileUtils.toCanonicalName(h.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return l.usePCRE2=this.query.usePCRE2,l}}e.TextSearchManager=n;function f(b){return{isCaseSensitive:b.isCaseSensitive||!1,isRegExp:b.isRegExp||!1,isWordMatch:b.isWordMatch||!1,isMultiline:b.isMultiline||!1,pattern:b.pattern}}class o{constructor(h){this._onResult=h,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new C(512,g=>this.sendItems(g))}add(h,g){this._currentFileMatch&&(this._currentFolderIdx!==g||!S.isEqual(this._currentUri,h.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=g,this._currentFileMatch={resource:h.uri,results:[]}),this._currentFileMatch.results.push(m(h))}pushToCollector(){const h=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,h)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(h){this._onResult(h)}}e.TextSearchResultsCollector=o;function m(b){return c(b)?{preview:{matches:(0,a.mapArrayOrNot)(b.preview.matches,h=>({startLineNumber:h.start.line,startColumn:h.start.character,endLineNumber:h.end.line,endColumn:h.end.character})),text:b.preview.text},ranges:(0,a.mapArrayOrNot)(b.ranges,h=>({startLineNumber:h.start.line,startColumn:h.start.character,endLineNumber:h.end.line,endColumn:h.end.character}))}:{text:b.text,lineNumber:b.lineNumber}}function c(b){return!!b.preview}e.extensionResultIsMatch=c;class C{constructor(h,g){this.maxBatchSize=h,this.cb=g,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(h,g){!h||this.addItemToBatch(h,g)}addItems(h,g){!h||this.addItemsToBatch(h,g)}addItemToBatch(h,g){this.batch.push(h),this.batchSize+=g,this.onUpdate()}addItemsToBatch(h,g){this.batch=this.batch.concat(h),this.batchSize+=g,this.onUpdate()}onUpdate(){this.totalNumberCompleted<C.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},C.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=C,C.TIMEOUT=4e3,C.START_BATCH_AFTER_COUNT=50}),define(Ee[99],ye([0,1,6,5,3,217,13,65,12,2,218]),function(re,e,a,t,w,T,k,I,S,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,w.createDecorator)("IExtHostSearch");let _=class{constructor(m,c,C){this.extHostRpc=m,this._uriTransformer=c,this._logService=C,this._proxy=this.extHostRpc.getProxy(t.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new T.FileSearchManager}_transformScheme(m){return this._uriTransformer.transformOutgoingScheme(m)}registerTextSearchProvider(m,c){if(this._textSearchUsedSchemes.has(m))throw new Error(`a text search provider for the scheme '${m}' is already registered`);this._textSearchUsedSchemes.add(m);const C=this._handlePool++;return this._textSearchProvider.set(C,c),this._proxy.$registerTextSearchProvider(C,this._transformScheme(m)),(0,a.toDisposable)(()=>{this._textSearchUsedSchemes.delete(m),this._textSearchProvider.delete(C),this._proxy.$unregisterProvider(C)})}registerFileSearchProvider(m,c){if(this._fileSearchUsedSchemes.has(m))throw new Error(`a file search provider for the scheme '${m}' is already registered`);this._fileSearchUsedSchemes.add(m);const C=this._handlePool++;return this._fileSearchProvider.set(C,c),this._proxy.$registerFileSearchProvider(C,this._transformScheme(m)),(0,a.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(m),this._fileSearchProvider.delete(C),this._proxy.$unregisterProvider(C)})}$provideFileSearchResults(m,c,C,b){const h=n(C),g=this._fileSearchProvider.get(m);if(g)return this._fileSearchManager.fileSearch(h,g,P=>{this._proxy.$handleFileMatch(m,c,P.map(l=>l.resource))},b);throw new Error("unknown provider: "+m)}$clearCache(m){return this._fileSearchManager.clearCache(m),Promise.resolve(void 0)}$provideTextSearchResults(m,c,C,b){const h=this._textSearchProvider.get(m);if(!h||!h.provideTextSearchResults)throw new Error(`Unknown provider ${m}`);const g=n(C);return this.createTextSearchManager(g,h).search(l=>this._proxy.$handleTextMatch(m,c,l),b)}$enableExtensionHostSearch(){}createTextSearchManager(m,c){return new F.TextSearchManager(m,c,{readdir:C=>Promise.resolve([]),toCanonicalName:C=>C},"textSearchProvider")}};_=Ue([$e(0,k.IExtHostRpcService),$e(1,I.IURITransformerService),$e(2,S.ILogService)],_),e.ExtHostSearch=_;function n(o){return{...o,folderQueries:o.folderQueries&&o.folderQueries.map(f),extraFileResources:o.extraFileResources&&o.extraFileResources.map(m=>R.URI.revive(m))}}e.reviveQuery=n;function f(o){return{...o,folder:R.URI.revive(o.folder)}}}),define(Ee[219],ye([0,1,20,15,4,34,2,113,232,107,55,45,5,180,179,38,181,32,182,183,184,165,185,48,33,186,166,189,191,193,94,168,198,199,200,71,39,202,169,8,7,205,50,95,31,74,154,188,61,93,97,98,99,12,65,13,28,194,151,64,69,177,203,150,72,49,208,206,207,178,30,201,204,68,70,85,196,96,197,10,139,195,148,187,6,27]),function(re,e,a,t,w,T,k,I,S,R,F,_,n,f,o,m,c,C,b,h,g,P,l,M,r,i,p,d,s,v,y,u,D,A,U,B,E,N,L,z,H,j,ue,G,le,ce,Y,ie,we,Me,Re,Be,Qe,Ke,Xe,$,K,J,ae,q,te,me,Pe,Ne,He,Ye,et,st,Je,nt,lt,pt,Ft,Fe,Mt,V,Q,he,Le,We,ot,Ge,yt,Ie,Ce,ve){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function oe(se){const fe=se.get(K.IExtHostInitDataService),ge=se.get(lt.IExtHostFileSystemInfo),ke=se.get(Ye.IExtHostConsumerFileSystem),ze=se.get(r.IExtHostExtensionService),Oe=se.get(le.IExtHostWorkspace),Ve=se.get(V.IExtHostTelemetry),it=se.get(C.IExtHostConfiguration),rt=se.get(Xe.IURITransformerService),ne=se.get($.IExtHostRpcService),pe=se.get(B.IExtHostStorage),ee=se.get(He.IExtensionStoragePaths),W=se.get(Ke.ILoggerService),be=se.get(Ke.ILogService),De=se.get(q.IExtHostTunnelService),qe=se.get(te.IExtHostApiDeprecationService),xe=se.get(G.IExtHostWindow),ut=se.get(Fe.IExtHostSecretState),vt=se.get(Mt.IExtHostEditorTabs);ne.set(n.ExtHostContext.ExtHostFileSystemInfo,ge),ne.set(n.ExtHostContext.ExtHostLogLevelServiceShape,W),ne.set(n.ExtHostContext.ExtHostWorkspace,Oe),ne.set(n.ExtHostContext.ExtHostConfiguration,it),ne.set(n.ExtHostContext.ExtHostExtensionService,ze),ne.set(n.ExtHostContext.ExtHostStorage,pe),ne.set(n.ExtHostContext.ExtHostTunnelService,De),ne.set(n.ExtHostContext.ExtHostWindow,xe),ne.set(n.ExtHostContext.ExtHostSecretState,ut),ne.set(n.ExtHostContext.ExtHostTelemetry,Ve),ne.set(n.ExtHostContext.ExtHostEditorTabs,vt);const St=ne.set(n.ExtHostContext.ExtHostDecorations,se.get(Me.IExtHostDecorations)),bt=ne.set(n.ExtHostContext.ExtHostDocumentsAndEditors,se.get(M.IExtHostDocumentsAndEditors)),ht=ne.set(n.ExtHostContext.ExtHostCommands,se.get(m.IExtHostCommands)),gt=ne.set(n.ExtHostContext.ExtHostTerminalService,se.get(E.IExtHostTerminalService)),_t=ne.set(n.ExtHostContext.ExtHostDebugService,se.get(Be.IExtHostDebugService)),Lt=ne.set(n.ExtHostContext.ExtHostSearch,se.get(Qe.IExtHostSearch)),It=ne.set(n.ExtHostContext.ExtHostTask,se.get(Re.IExtHostTask)),Pt=ne.set(n.ExtHostContext.ExtHostOutputService,se.get(y.IExtHostOutputService)),At=ne.set(n.ExtHostContext.ExtHostUrls,new j.ExtHostUrls(ne)),Et=ne.set(n.ExtHostContext.ExtHostDocuments,new l.ExtHostDocuments(ne,bt)),Ot=ne.set(n.ExtHostContext.ExtHostDocumentContentProviders,new g.ExtHostDocumentContentProvider(ne,bt,be)),Nt=ne.set(n.ExtHostContext.ExtHostDocumentSaveParticipant,new P.ExtHostDocumentSaveParticipant(be,Et,ne.getProxy(n.MainContext.MainThreadBulkEdits))),wt=ne.set(n.ExtHostContext.ExtHostNotebook,new J.ExtHostNotebookController(ne,ht,bt,Et,ee)),$t=ne.set(n.ExtHostContext.ExtHostNotebookDocuments,new yt.ExtHostNotebookDocuments(be,wt)),jt=ne.set(n.ExtHostContext.ExtHostNotebookEditors,new Ge.ExtHostNotebookEditors(be,ne,wt)),oi=ne.set(n.ExtHostContext.ExtHostNotebookKernels,new Q.ExtHostNotebookKernels(ne,fe,wt,ht,be)),si=ne.set(n.ExtHostContext.ExtHostNotebookRenderers,new Le.ExtHostNotebookRenderers(ne,wt)),Tt=ne.set(n.ExtHostContext.ExtHostEditors,new N.ExtHostEditors(ne,bt)),Yt=ne.set(n.ExtHostContext.ExtHostTreeViews,new L.ExtHostTreeViews(ne.getProxy(n.MainContext.MainThreadTreeViews),ht,be)),ai=ne.set(n.ExtHostContext.ExtHostEditorInsets,new Y.ExtHostEditorInsets(ne.getProxy(n.MainContext.MainThreadEditorInsets),Tt,fe)),Xt=ne.set(n.ExtHostContext.ExtHostDiagnostics,new b.ExtHostDiagnostics(ne,be,ge)),Vt=ne.set(n.ExtHostContext.ExtHostLanguages,new s.ExtHostLanguages(ne,Et,ht.converter,rt)),mt=ne.set(n.ExtHostContext.ExtHostLanguageFeatures,new d.ExtHostLanguageFeatures(ne,rt,Et,ht,Xt,be,qe)),li=ne.set(n.ExtHostContext.ExtHostFileSystem,new i.ExtHostFileSystem(ne,mt)),xt=ne.set(n.ExtHostContext.ExtHostFileSystemEventService,new p.ExtHostFileSystemEventService(ne,be,bt)),qt=ne.set(n.ExtHostContext.ExtHostQuickOpen,(0,D.createExtHostQuickOpen)(ne,Oe,ht)),Jt=ne.set(n.ExtHostContext.ExtHostSCM,new A.ExtHostSCM(ne,ht,be)),ci=ne.set(n.ExtHostContext.ExtHostComments,(0,c.createExtHostComments)(ne,ht,Et)),fi=ne.set(n.ExtHostContext.ExtHostProgress,new u.ExtHostProgress(ne.getProxy(n.MainContext.MainThreadProgress))),Ei=ne.set(n.ExtHostContext.ExtHosLabelService,new ie.ExtHostLabelService(ne)),mi=ne.set(n.ExtHostContext.ExtHostTheming,new ae.ExtHostTheming(ne)),Zt=ne.set(n.ExtHostContext.ExtHostAuthentication,new me.ExtHostAuthentication(ne)),yi=ne.set(n.ExtHostContext.ExtHostTimeline,new Pe.ExtHostTimeline(ne,ht)),Kt=ne.set(n.ExtHostContext.ExtHostWebviews,new ue.ExtHostWebviews(ne,{remote:fe.remote},Oe,be,qe)),Gt=ne.set(n.ExtHostContext.ExtHostWebviewPanels,new Je.ExtHostWebviewPanels(ne,Kt,Oe)),_i=ne.set(n.ExtHostContext.ExtHostCustomEditors,new st.ExtHostCustomEditors(ne,Et,ee,Kt,Gt)),Ci=ne.set(n.ExtHostContext.ExtHostWebviewViews,new et.ExtHostWebviewViews(ne,Kt)),Qt=ne.set(n.ExtHostContext.ExtHostTesting,new pt.ExtHostTesting(ne,ht)),Si=ne.set(n.ExtHostContext.ExtHostUriOpeners,new Ft.ExtHostUriOpeners(ne));ne.set(n.ExtHostContext.ExtHostInteractive,new Ie.ExtHostInteractive(ne,wt,bt,ht));const ei=(0,ce.values)(n.ExtHostContext);ne.assertRegistered(ei);const Di=new nt.ExtHostBulkEdits(ne,bt),ki=new o.ExtHostClipboard(ne),ui=new v.ExtHostMessageService(ne,be),ti=new h.ExtHostDialogs(ne),gi=new U.ExtHostStatusBar(ne,ht.converter);return f.ExtHostApiCommands.register(ht),function(Ae,Ut,pi){const ft=function(){let X=!Ae.isUnderDevelopment;function de(){X||(be.info(`Extension '${Ae.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),X=!0)}return function Se(ct){if(Array.isArray(ct))ct.forEach(Se);else if(typeof ct=="string")de();else{const Ct=ct;typeof Ct.scheme=="undefined"&&de(),typeof Ct.exclusive=="boolean"&&(0,ve.checkProposedApiEnabled)(Ae,"documentFiltersExclusive")}return ct}}(),ii={getSession(X,de,Se){return Zt.getSession(Ae,X,de,Se)},async hasSession(X,de){return(0,ve.checkProposedApiEnabled)(Ae,"authSession"),!!await Zt.getSession(Ae,X,de,{silent:!0})},get onDidChangeSessions(){return Zt.onDidChangeSessions},registerAuthenticationProvider(X,de,Se,ct){return Zt.registerAuthenticationProvider(X,de,Se,ct)}},Ii={registerCommand(X,de,Se){return ht.registerCommand(!0,X,de,Se,void 0,Ae)},registerTextEditorCommand(X,de,Se){return ht.registerCommand(!0,X,(...ct)=>{const Ct=Tt.getActiveTextEditor();if(!Ct){be.warn("Cannot execute "+X+" because there is no active text editor.");return}return Ct.edit(Dt=>{de.apply(Se,[Ct,Dt,...ct])}).then(Dt=>{Dt||be.warn("Edits from command "+X+" were not applied.")},Dt=>{be.warn("An error occurred while running command "+X,Dt)})},void 0,void 0,Ae)},registerDiffInformationCommand:(X,de,Se)=>((0,ve.checkProposedApiEnabled)(Ae,"diffCommand"),ht.registerCommand(!0,X,async(...ct)=>{const Ct=bt.activeEditor(!0);if(!Ct){be.warn("Cannot execute "+X+" because there is no active text editor.");return}const Dt=await Tt.getDiffInformation(Ct.id);de.apply(Se,[Dt,...ct])},void 0,void 0,Ae)),executeCommand(X,...de){return ht.executeCommand(X,...de)},getCommands(X=!1){return ht.getCommands(X)}},vi={get machineId(){return fe.telemetryInfo.machineId},get sessionId(){return fe.telemetryInfo.sessionId},get language(){return fe.environment.appLanguage},get appName(){return fe.environment.appName},get appRoot(){return fe.environment.appRoot?.fsPath??""},get appHost(){return fe.environment.appHost},get uriScheme(){return fe.environment.appUriScheme},get clipboard(){return ki.value},get shell(){return gt.getDefaultShell(!1)},get isTelemetryEnabled(){return Ve.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return Ve.onDidChangeTelemetryEnabled},get isNewAppInstall(){const X=Date.now()-new Date(fe.telemetryInfo.firstSessionDate).getTime();return isNaN(X)?!1:X<1e3*60*60*24},openExternal(X,de){return xe.openUri(X,{allowTunneling:!!fe.remote.authority,allowContributedOpeners:de?.allowContributedOpeners})},async asExternalUri(X){if(X.scheme===fe.environment.appUriScheme)return At.createAppUri(X);try{return await xe.asExternalUri(X,{allowTunneling:!!fe.remote.authority})}catch(de){if((0,ot.matchesScheme)(X,We.Schemas.http)||(0,ot.matchesScheme)(X,We.Schemas.https))return X;throw de}},get remoteName(){return(0,we.getRemoteName)(fe.remote.authority)},get remoteAuthority(){return(0,ve.checkProposedApiEnabled)(Ae,"resolvers"),fe.remote.authority},get uiKind(){return fe.uiKind}};fe.environment.extensionTestsLocationURI||Object.freeze(vi);const bi=fe.remote.isRemote?H.ExtensionKind.Workspace:H.ExtensionKind.UI,Pi={createTestController(X,de){return Qt.createTestController(X,de)},createTestObserver(){return(0,ve.checkProposedApiEnabled)(Ae,"testObserver"),Qt.createTestObserver()},runTests(X){return(0,ve.checkProposedApiEnabled)(Ae,"testObserver"),Qt.runTests(X)},get onDidChangeTestResults(){return(0,ve.checkProposedApiEnabled)(Ae,"testObserver"),Qt.onResultsChanged},get testResults(){return(0,ve.checkProposedApiEnabled)(Ae,"testObserver"),Qt.results}},Ti={getExtension(X){const de=Ut.getExtensionDescription(X);if(de)return new r.Extension(ze,Ae.identifier,de,bi)},get all(){return Ut.getAllExtensionDescriptions().map(X=>new r.Extension(ze,Ae.identifier,X,bi))},get onDidChange(){return Ut.onDidChange}},Ai={createDiagnosticCollection(X){return Xt.createDiagnosticCollection(Ae.identifier,X)},get onDidChangeDiagnostics(){return Xt.onDidChangeDiagnostics},getDiagnostics:X=>Xt.getDiagnostics(X),getLanguages(){return Vt.getLanguages()},setTextDocumentLanguage(X,de){return Vt.changeLanguage(X.uri,de)},match(X,de){return(0,F.score)(z.LanguageSelector.from(X),de.uri,de.languageId,!0)},registerCodeActionsProvider(X,de,Se){return mt.registerCodeActionProvider(Ae,ft(X),de,Se)},registerCodeLensProvider(X,de){return mt.registerCodeLensProvider(Ae,ft(X),de)},registerDefinitionProvider(X,de){return mt.registerDefinitionProvider(Ae,ft(X),de)},registerDeclarationProvider(X,de){return mt.registerDeclarationProvider(Ae,ft(X),de)},registerImplementationProvider(X,de){return mt.registerImplementationProvider(Ae,ft(X),de)},registerTypeDefinitionProvider(X,de){return mt.registerTypeDefinitionProvider(Ae,ft(X),de)},registerHoverProvider(X,de){return mt.registerHoverProvider(Ae,ft(X),de,Ae.identifier)},registerEvaluatableExpressionProvider(X,de){return mt.registerEvaluatableExpressionProvider(Ae,ft(X),de,Ae.identifier)},registerInlineValuesProvider(X,de){return mt.registerInlineValuesProvider(Ae,ft(X),de,Ae.identifier)},registerDocumentHighlightProvider(X,de){return mt.registerDocumentHighlightProvider(Ae,ft(X),de)},registerLinkedEditingRangeProvider(X,de){return mt.registerLinkedEditingRangeProvider(Ae,ft(X),de)},registerReferenceProvider(X,de){return mt.registerReferenceProvider(Ae,ft(X),de)},registerRenameProvider(X,de){return mt.registerRenameProvider(Ae,ft(X),de)},registerDocumentSymbolProvider(X,de,Se){return mt.registerDocumentSymbolProvider(Ae,ft(X),de,Se)},registerWorkspaceSymbolProvider(X){return mt.registerWorkspaceSymbolProvider(Ae,X)},registerDocumentFormattingEditProvider(X,de){return mt.registerDocumentFormattingEditProvider(Ae,ft(X),de)},registerDocumentRangeFormattingEditProvider(X,de){return mt.registerDocumentRangeFormattingEditProvider(Ae,ft(X),de)},registerOnTypeFormattingEditProvider(X,de,Se,...ct){return mt.registerOnTypeFormattingEditProvider(Ae,ft(X),de,[Se].concat(ct))},registerDocumentSemanticTokensProvider(X,de,Se){return mt.registerDocumentSemanticTokensProvider(Ae,ft(X),de,Se)},registerDocumentRangeSemanticTokensProvider(X,de,Se){return mt.registerDocumentRangeSemanticTokensProvider(Ae,ft(X),de,Se)},registerSignatureHelpProvider(X,de,Se,...ct){return typeof Se=="object"?mt.registerSignatureHelpProvider(Ae,ft(X),de,Se):mt.registerSignatureHelpProvider(Ae,ft(X),de,typeof Se=="undefined"?[]:[Se,...ct])},registerCompletionItemProvider(X,de,...Se){return mt.registerCompletionItemProvider(Ae,ft(X),de,Se)},registerInlineCompletionItemProvider(X,de){return(0,ve.checkProposedApiEnabled)(Ae,"inlineCompletions"),mt.registerInlineCompletionsProvider(Ae,ft(X),de)},registerDocumentLinkProvider(X,de){return mt.registerDocumentLinkProvider(Ae,ft(X),de)},registerColorProvider(X,de){return mt.registerColorProvider(Ae,ft(X),de)},registerFoldingRangeProvider(X,de){return mt.registerFoldingRangeProvider(Ae,ft(X),de)},registerSelectionRangeProvider(X,de){return mt.registerSelectionRangeProvider(Ae,X,de)},registerCallHierarchyProvider(X,de){return mt.registerCallHierarchyProvider(Ae,X,de)},registerTypeHierarchyProvider(X,de){return mt.registerTypeHierarchyProvider(Ae,X,de)},setLanguageConfiguration:(X,de)=>mt.setLanguageConfiguration(Ae,X,de),getTokenInformationAtPosition(X,de){return(0,ve.checkProposedApiEnabled)(Ae,"tokenInformation"),Vt.tokenAtPosition(X,de)},registerInlayHintsProvider(X,de){return(0,ve.checkProposedApiEnabled)(Ae,"inlayHints"),mt.registerInlayHintsProvider(Ae,X,de)},createLanguageStatusItem(X,de){return(0,ve.checkProposedApiEnabled)(Ae,"languageStatus"),Vt.createLanguageStatusItem(Ae,X,de)}},Ri={get activeTextEditor(){return Tt.getActiveTextEditor()},get visibleTextEditors(){return Tt.getVisibleTextEditors()},get activeTerminal(){return gt.activeTerminal},get terminals(){return gt.terminals},async showTextDocument(X,de,Se){const ct=await(k.URI.isUri(X)?Promise.resolve(ni.openTextDocument(X)):Promise.resolve(X));return Tt.showTextDocument(ct,de,Se)},createTextEditorDecorationType(X){return Tt.createTextEditorDecorationType(Ae,X)},onDidChangeActiveTextEditor(X,de,Se){return Tt.onDidChangeActiveTextEditor(X,de,Se)},onDidChangeVisibleTextEditors(X,de,Se){return Tt.onDidChangeVisibleTextEditors(X,de,Se)},onDidChangeTextEditorSelection(X,de,Se){return Tt.onDidChangeTextEditorSelection(X,de,Se)},onDidChangeTextEditorOptions(X,de,Se){return Tt.onDidChangeTextEditorOptions(X,de,Se)},onDidChangeTextEditorVisibleRanges(X,de,Se){return Tt.onDidChangeTextEditorVisibleRanges(X,de,Se)},onDidChangeTextEditorViewColumn(X,de,Se){return Tt.onDidChangeTextEditorViewColumn(X,de,Se)},onDidCloseTerminal(X,de,Se){return gt.onDidCloseTerminal(X,de,Se)},onDidOpenTerminal(X,de,Se){return gt.onDidOpenTerminal(X,de,Se)},onDidChangeActiveTerminal(X,de,Se){return gt.onDidChangeActiveTerminal(X,de,Se)},onDidChangeTerminalDimensions(X,de,Se){return(0,ve.checkProposedApiEnabled)(Ae,"terminalDimensions"),gt.onDidChangeTerminalDimensions(X,de,Se)},onDidChangeTerminalState(X,de,Se){return gt.onDidChangeTerminalState(X,de,Se)},onDidWriteTerminalData(X,de,Se){return(0,ve.checkProposedApiEnabled)(Ae,"terminalDataWriteEvent"),gt.onDidWriteTerminalData(X,de,Se)},get state(){return xe.state},onDidChangeWindowState(X,de,Se){return xe.onDidChangeWindowState(X,de,Se)},showInformationMessage(X,...de){return ui.showMessage(Ae,T.default.Info,X,de[0],de.slice(1))},showWarningMessage(X,...de){return ui.showMessage(Ae,T.default.Warning,X,de[0],de.slice(1))},showErrorMessage(X,...de){return ui.showMessage(Ae,T.default.Error,X,de[0],de.slice(1))},showQuickPick(X,de,Se){return Array.isArray(X)&&X.some(ct=>ct.kind!==void 0)&&(0,ve.checkProposedApiEnabled)(Ae,"quickPickSeparators"),qt.showQuickPick(X,de,Se)},showWorkspaceFolderPick(X){return qt.showWorkspaceFolderPick(X)},showInputBox(X,de){return qt.showInput(X,de)},showOpenDialog(X){return ti.showOpenDialog(X)},showSaveDialog(X){return ti.showSaveDialog(X)},createStatusBarItem(X,de,Se){let ct,Ct,Dt;return typeof X=="string"?(ct=X,Ct=de,Dt=Se):(Ct=X,Dt=de),gi.createStatusBarEntry(Ae,ct,Ct,Dt)},setStatusBarMessage(X,de){return gi.setStatusBarMessage(X,de)},withScmProgress(X){return qe.report("window.withScmProgress",Ae,"Use 'withProgress' instead."),fi.withProgress(Ae,{location:H.ProgressLocation.SourceControl},(de,Se)=>X({report(ct){}}))},withProgress(X,de){return fi.withProgress(Ae,X,de)},createOutputChannel(X){return Pt.createOutputChannel(X,Ae)},createWebviewPanel(X,de,Se,ct){return Gt.createWebviewPanel(Ae,X,de,Se,ct)},createWebviewTextEditorInset(X,de,Se,ct){return(0,ve.checkProposedApiEnabled)(Ae,"editorInsets"),ai.createWebviewEditorInset(X,de,Se,ct,Ae)},createTerminal(X,de,Se){return typeof X=="object"?"pty"in X?gt.createExtensionTerminal(X):gt.createTerminalFromOptions(X):gt.createTerminal(X,de,Se)},registerTerminalLinkProvider(X){return gt.registerLinkProvider(X)},registerTerminalProfileProvider(X,de){return gt.registerProfileProvider(Ae,X,de)},registerTreeDataProvider(X,de){return Yt.registerTreeDataProvider(X,de,Ae)},createTreeView(X,de){return Yt.createTreeView(X,de,Ae)},registerWebviewPanelSerializer:(X,de)=>Gt.registerWebviewPanelSerializer(Ae,X,de),registerCustomEditorProvider:(X,de,Se={})=>_i.registerCustomEditorProvider(Ae,X,de,Se),registerFileDecorationProvider(X){return St.registerFileDecorationProvider(X,Ae.identifier)},registerUriHandler(X){return At.registerUriHandler(Ae.identifier,X)},createQuickPick(){return qt.createQuickPick(Ae)},createInputBox(){return qt.createInputBox(Ae.identifier)},get activeColorTheme(){return mi.activeColorTheme},onDidChangeActiveColorTheme(X,de,Se){return mi.onDidChangeActiveColorTheme(X,de,Se)},registerWebviewViewProvider(X,de,Se){return Ci.registerWebviewViewProvider(Ae,X,de,Se?.webviewOptions)},get activeNotebookEditor(){return(0,ve.checkProposedApiEnabled)(Ae,"notebookEditor"),wt.activeNotebookEditor},onDidChangeActiveNotebookEditor(X,de,Se){return(0,ve.checkProposedApiEnabled)(Ae,"notebookEditor"),wt.onDidChangeActiveNotebookEditor(X,de,Se)},get visibleNotebookEditors(){return(0,ve.checkProposedApiEnabled)(Ae,"notebookEditor"),wt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,ve.checkProposedApiEnabled)(Ae,"notebookEditor"),wt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(X,de,Se){return(0,ve.checkProposedApiEnabled)(Ae,"notebookEditor"),jt.onDidChangeNotebookEditorSelection(X,de,Se)},onDidChangeNotebookEditorVisibleRanges(X,de,Se){return(0,ve.checkProposedApiEnabled)(Ae,"notebookEditor"),jt.onDidChangeNotebookEditorVisibleRanges(X,de,Se)},showNotebookDocument(X,de){return(0,ve.checkProposedApiEnabled)(Ae,"notebookEditor"),wt.showNotebookDocument(X,de)},registerExternalUriOpener(X,de,Se){return(0,ve.checkProposedApiEnabled)(Ae,"externalUriOpener"),Si.registerExternalUriOpener(Ae.identifier,X,de,Se)},get tabs(){return(0,ve.checkProposedApiEnabled)(Ae,"tabs"),vt.tabs},get activeTab(){return(0,ve.checkProposedApiEnabled)(Ae,"tabs"),vt.activeTab},get onDidChangeTabs(){return(0,ve.checkProposedApiEnabled)(Ae,"tabs"),vt.onDidChangeTabs},get onDidChangeActiveTab(){return(0,ve.checkProposedApiEnabled)(Ae,"tabs"),vt.onDidChangeActiveTab},getInlineCompletionItemController(X){return(0,ve.checkProposedApiEnabled)(Ae,"inlineCompletions"),d.InlineCompletionController.get(X)}},ni={get rootPath(){return qe.report("workspace.rootPath",Ae,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),Oe.getPath()},set rootPath(X){throw t.readonly()},getWorkspaceFolder(X){return Oe.getWorkspaceFolder(X)},get workspaceFolders(){return Oe.getWorkspaceFolders()},get name(){return Oe.name},set name(X){throw t.readonly()},get workspaceFile(){return Oe.workspaceFile},set workspaceFile(X){throw t.readonly()},updateWorkspaceFolders:(X,de,...Se)=>Oe.updateWorkspaceFolders(Ae,X,de||0,...Se),onDidChangeWorkspaceFolders:function(X,de,Se){return Oe.onDidChangeWorkspace(X,de,Se)},asRelativePath:(X,de)=>Oe.getRelativePath(X,de),findFiles:(X,de,Se,ct)=>Oe.findFiles(z.GlobPattern.from(X),z.GlobPattern.from(de),Se,Ae.identifier,ct),findTextInFiles:(X,de,Se,ct)=>{(0,ve.checkProposedApiEnabled)(Ae,"findTextInFiles");let Ct,Dt;return typeof de=="object"?(Ct=de,Dt=Se):(Ct={},Dt=de,ct=Se),Oe.findTextInFiles(X,Ct||{},Dt,Ae.identifier,ct)},saveAll:X=>Oe.saveAll(X),applyEdit(X){return Di.applyWorkspaceEdit(X)},createFileSystemWatcher:(X,de,Se,ct)=>xt.createFileSystemWatcher(z.GlobPattern.from(X),de,Se,ct),get textDocuments(){return Et.getAllDocumentData().map(X=>X.document)},set textDocuments(X){throw t.readonly()},openTextDocument(X){let de;const Se=X;if(typeof X=="string")de=Promise.resolve(k.URI.file(X));else if(k.URI.isUri(X))de=Promise.resolve(X);else if(!Se||typeof Se=="object")de=Et.createDocumentData(Se);else throw new Error("illegal argument - uriOrFileNameOrOptions");return de.then(ct=>Et.ensureDocumentData(ct).then(Ct=>Ct.document))},onDidOpenTextDocument:(X,de,Se)=>Et.onDidAddDocument(X,de,Se),onDidCloseTextDocument:(X,de,Se)=>Et.onDidRemoveDocument(X,de,Se),onDidChangeTextDocument:(X,de,Se)=>Et.onDidChangeDocument(X,de,Se),onDidSaveTextDocument:(X,de,Se)=>Et.onDidSaveDocument(X,de,Se),onWillSaveTextDocument:(X,de,Se)=>Nt.getOnWillSaveTextDocumentEvent(Ae)(X,de,Se),get notebookDocuments(){return wt.notebookDocuments.map(X=>X.apiNotebook)},async openNotebookDocument(X,de){let Se;if(k.URI.isUri(X))Se=X,await wt.openNotebookDocument(X);else if(typeof X=="string")Se=k.URI.revive(await wt.createNotebookDocument({viewType:X,content:de}));else throw new Error("Invalid arguments");return wt.getNotebookDocument(Se).apiNotebook},get onDidOpenNotebookDocument(){return wt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return wt.onDidCloseNotebookDocument},registerNotebookSerializer(X,de,Se,ct){return wt.registerNotebookSerializer(Ae,X,de,Se,(0,ve.isProposedApiEnabled)(Ae,"notebookLiveShare")?ct:void 0)},registerNotebookContentProvider:(X,de,Se,ct)=>((0,ve.checkProposedApiEnabled)(Ae,"notebookContentProvider"),wt.registerNotebookContentProvider(Ae,X,de,Se,(0,ve.isProposedApiEnabled)(Ae,"notebookLiveShare")?ct:void 0)),onDidChangeConfiguration:(X,de,Se)=>pi.onDidChangeConfiguration(X,de,Se),getConfiguration(X,de){return de=arguments.length===1?void 0:de,pi.getConfiguration(X,de,Ae)},registerTextDocumentContentProvider(X,de){return Ot.registerTextDocumentContentProvider(X,de)},registerTaskProvider:(X,de)=>(qe.report("window.registerTaskProvider",Ae,"Use the corresponding function on the 'tasks' namespace instead"),It.registerTaskProvider(Ae,X,de)),registerFileSystemProvider(X,de,Se){return(0,Ce.combinedDisposable)(li.registerFileSystemProvider(Ae,X,de,Se),ke.addFileSystemProvider(X,de))},get fs(){return ke.value},registerFileSearchProvider:(X,de)=>((0,ve.checkProposedApiEnabled)(Ae,"fileSearchProvider"),Lt.registerFileSearchProvider(X,de)),registerTextSearchProvider:(X,de)=>((0,ve.checkProposedApiEnabled)(Ae,"textSearchProvider"),Lt.registerTextSearchProvider(X,de)),registerRemoteAuthorityResolver:(X,de)=>((0,ve.checkProposedApiEnabled)(Ae,"resolvers"),ze.registerRemoteAuthorityResolver(X,de)),registerResourceLabelFormatter:X=>((0,ve.checkProposedApiEnabled)(Ae,"resolvers"),Ei.$registerResourceLabelFormatter(X)),onDidCreateFiles:(X,de,Se)=>xt.onDidCreateFile(X,de,Se),onDidDeleteFiles:(X,de,Se)=>xt.onDidDeleteFile(X,de,Se),onDidRenameFiles:(X,de,Se)=>xt.onDidRenameFile(X,de,Se),onWillCreateFiles:(X,de,Se)=>xt.getOnWillCreateFileEvent(Ae)(X,de,Se),onWillDeleteFiles:(X,de,Se)=>xt.getOnWillDeleteFileEvent(Ae)(X,de,Se),onWillRenameFiles:(X,de,Se)=>xt.getOnWillRenameFileEvent(Ae)(X,de,Se),openTunnel:X=>((0,ve.checkProposedApiEnabled)(Ae,"resolvers"),De.openTunnel(Ae,X).then(de=>{if(!de)throw new Error("cannot open tunnel");return de})),get tunnels(){return(0,ve.checkProposedApiEnabled)(Ae,"resolvers"),De.getTunnels()},onDidChangeTunnels:(X,de,Se)=>((0,ve.checkProposedApiEnabled)(Ae,"resolvers"),De.onDidChangeTunnels(X,de,Se)),registerPortAttributesProvider:(X,de)=>((0,ve.checkProposedApiEnabled)(Ae,"portsAttributes"),De.registerPortsAttributesProvider(X,de)),registerTimelineProvider:(X,de)=>((0,ve.checkProposedApiEnabled)(Ae,"timeline"),yi.registerTimelineProvider(X,de,Ae.identifier,ht.converter)),get isTrusted(){return Oe.trusted},requestWorkspaceTrust:X=>((0,ve.checkProposedApiEnabled)(Ae,"workspaceTrust"),Oe.requestWorkspaceTrust(X)),onDidGrantWorkspaceTrust:(X,de,Se)=>Oe.onDidGrantWorkspaceTrust(X,de,Se)},Fi={get inputBox(){return qe.report("scm.inputBox",Ae,"Use 'SourceControl.inputBox' instead"),Jt.getLastInputBox(Ae)},createSourceControl(X,de,Se){return Jt.createSourceControl(Ae,X,de,Se)}},Mi={createCommentController(X,de){return ci.createCommentController(Ae,X,de)}},Oi={get activeDebugSession(){return _t.activeDebugSession},get activeDebugConsole(){return _t.activeDebugConsole},get breakpoints(){return _t.breakpoints},onDidStartDebugSession(X,de,Se){return _t.onDidStartDebugSession(X,de,Se)},onDidTerminateDebugSession(X,de,Se){return _t.onDidTerminateDebugSession(X,de,Se)},onDidChangeActiveDebugSession(X,de,Se){return _t.onDidChangeActiveDebugSession(X,de,Se)},onDidReceiveDebugSessionCustomEvent(X,de,Se){return _t.onDidReceiveDebugSessionCustomEvent(X,de,Se)},onDidChangeBreakpoints(X,de,Se){return _t.onDidChangeBreakpoints(X,de,Se)},registerDebugConfigurationProvider(X,de,Se){return _t.registerDebugConfigurationProvider(X,de,Se||H.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(X,de){return _t.registerDebugAdapterDescriptorFactory(Ae,X,de)},registerDebugAdapterTrackerFactory(X,de){return _t.registerDebugAdapterTrackerFactory(X,de)},startDebugging(X,de,Se){return!Se||typeof Se=="object"&&"configuration"in Se?_t.startDebugging(X,de,{parentSession:Se}):_t.startDebugging(X,de,Se||{})},stopDebugging(X){return _t.stopDebugging(X)},addBreakpoints(X){return _t.addBreakpoints(X)},removeBreakpoints(X){return _t.removeBreakpoints(X)},asDebugSourceUri(X,de){return _t.asDebugSourceUri(X,de)}},Li={registerTaskProvider:(X,de)=>It.registerTaskProvider(Ae,X,de),fetchTasks:X=>It.fetchTasks(X),executeTask:X=>It.executeTask(Ae,X),get taskExecutions(){return It.taskExecutions},onDidStartTask:(X,de,Se)=>It.onDidStartTask(X,de,Se),onDidEndTask:(X,de,Se)=>It.onDidEndTask(X,de,Se),onDidStartTaskProcess:(X,de,Se)=>It.onDidStartTaskProcess(X,de,Se),onDidEndTaskProcess:(X,de,Se)=>It.onDidEndTaskProcess(X,de,Se)},Ni={createNotebookController(X,de,Se,ct,Ct){return oi.createNotebookController(Ae,X,de,Se,ct,(0,ve.isProposedApiEnabled)(Ae,"notebookMessaging")?Ct:void 0)},registerNotebookCellStatusBarItemProvider:(X,de)=>wt.registerNotebookCellStatusBarItemProvider(Ae,X,de),get onDidSaveNotebookDocument(){return(0,ve.checkProposedApiEnabled)(Ae,"notebookEditor"),$t.onDidSaveNotebookDocument},createNotebookEditorDecorationType(X){return(0,ve.checkProposedApiEnabled)(Ae,"notebookEditorDecorationType"),jt.createNotebookEditorDecorationType(X)},createRendererMessaging(X){return si.createRendererMessaging(Ae,X)},onDidChangeNotebookDocumentMetadata(X,de,Se){return(0,ve.checkProposedApiEnabled)(Ae,"notebookEditor"),$t.onDidChangeNotebookDocumentMetadata(X,de,Se)},onDidChangeNotebookCells(X,de,Se){return(0,ve.checkProposedApiEnabled)(Ae,"notebookEditor"),wt.onDidChangeNotebookCells(X,de,Se)},onDidChangeNotebookCellExecutionState(X,de,Se){return(0,ve.checkProposedApiEnabled)(Ae,"notebookCellExecutionState"),wt.onDidChangeNotebookCellExecutionState(X,de,Se)},onDidChangeCellOutputs(X,de,Se){return(0,ve.checkProposedApiEnabled)(Ae,"notebookEditor"),wt.onDidChangeCellOutputs(X,de,Se)},onDidChangeCellMetadata(X,de,Se){return(0,ve.checkProposedApiEnabled)(Ae,"notebookEditor"),wt.onDidChangeCellMetadata(X,de,Se)},createConcatTextDocument(X,de){return(0,ve.checkProposedApiEnabled)(Ae,"notebookConcatTextDocument"),new Ne.ExtHostNotebookConcatDocument(wt,Et,X,de)}};return{version:fe.version,authentication:ii,commands:Ii,comments:Mi,debug:Oi,env:vi,extensions:Ti,languages:Ai,notebooks:Ni,scm:Fi,tasks:Li,tests:Pi,window:Ri,workspace:ni,Breakpoint:H.Breakpoint,CallHierarchyIncomingCall:H.CallHierarchyIncomingCall,CallHierarchyItem:H.CallHierarchyItem,CallHierarchyOutgoingCall:H.CallHierarchyOutgoingCall,CancellationError:t.CancellationError,CancellationTokenSource:a.CancellationTokenSource,CandidatePortSource:n.CandidatePortSource,CodeAction:H.CodeAction,CodeActionKind:H.CodeActionKind,CodeActionTriggerKind:H.CodeActionTriggerKind,CodeLens:H.CodeLens,Color:H.Color,ColorInformation:H.ColorInformation,ColorPresentation:H.ColorPresentation,ColorThemeKind:H.ColorThemeKind,CommentMode:H.CommentMode,CommentThreadCollapsibleState:H.CommentThreadCollapsibleState,CompletionItem:H.CompletionItem,CompletionItemKind:H.CompletionItemKind,CompletionItemTag:H.CompletionItemTag,CompletionList:H.CompletionList,CompletionTriggerKind:H.CompletionTriggerKind,ConfigurationTarget:H.ConfigurationTarget,CustomExecution:H.CustomExecution,DebugAdapterExecutable:H.DebugAdapterExecutable,DebugAdapterInlineImplementation:H.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:H.DebugAdapterNamedPipeServer,DebugAdapterServer:H.DebugAdapterServer,DebugConfigurationProviderTriggerKind:H.DebugConfigurationProviderTriggerKind,DebugConsoleMode:H.DebugConsoleMode,DecorationRangeBehavior:H.DecorationRangeBehavior,Diagnostic:H.Diagnostic,DiagnosticRelatedInformation:H.DiagnosticRelatedInformation,DiagnosticSeverity:H.DiagnosticSeverity,DiagnosticTag:H.DiagnosticTag,Disposable:H.Disposable,DocumentHighlight:H.DocumentHighlight,DocumentHighlightKind:H.DocumentHighlightKind,DocumentLink:H.DocumentLink,DocumentSymbol:H.DocumentSymbol,EndOfLine:H.EndOfLine,EnvironmentVariableMutatorType:H.EnvironmentVariableMutatorType,EvaluatableExpression:H.EvaluatableExpression,InlineValueText:H.InlineValueText,InlineValueVariableLookup:H.InlineValueVariableLookup,InlineValueEvaluatableExpression:H.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:H.InlineCompletionTriggerKind,EventEmitter:w.Emitter,ExtensionKind:H.ExtensionKind,ExtensionMode:H.ExtensionMode,ExternalUriOpenerPriority:H.ExternalUriOpenerPriority,FileChangeType:H.FileChangeType,FileDecoration:H.FileDecoration,FileSystemError:H.FileSystemError,FileType:_.FileType,FilePermission:_.FilePermission,FoldingRange:H.FoldingRange,FoldingRangeKind:H.FoldingRangeKind,FunctionBreakpoint:H.FunctionBreakpoint,InlineCompletionItem:H.InlineSuggestion,InlineCompletionList:H.InlineSuggestions,Hover:H.Hover,IndentAction:R.IndentAction,Location:H.Location,MarkdownString:H.MarkdownString,OverviewRulerLane:S.OverviewRulerLane,ParameterInformation:H.ParameterInformation,PortAutoForwardAction:H.PortAutoForwardAction,Position:H.Position,ProcessExecution:H.ProcessExecution,ProgressLocation:H.ProgressLocation,QuickInputButtons:H.QuickInputButtons,Range:H.Range,RelativePattern:H.RelativePattern,Selection:H.Selection,SelectionRange:H.SelectionRange,SemanticTokens:H.SemanticTokens,SemanticTokensBuilder:H.SemanticTokensBuilder,SemanticTokensEdit:H.SemanticTokensEdit,SemanticTokensEdits:H.SemanticTokensEdits,SemanticTokensLegend:H.SemanticTokensLegend,ShellExecution:H.ShellExecution,ShellQuoting:H.ShellQuoting,SignatureHelp:H.SignatureHelp,SignatureHelpTriggerKind:H.SignatureHelpTriggerKind,SignatureInformation:H.SignatureInformation,SnippetString:H.SnippetString,SourceBreakpoint:H.SourceBreakpoint,StandardTokenType:H.StandardTokenType,StatusBarAlignment:H.StatusBarAlignment,SymbolInformation:H.SymbolInformation,SymbolKind:H.SymbolKind,SymbolTag:H.SymbolTag,Task:H.Task,TaskGroup:H.TaskGroup,TaskPanelKind:H.TaskPanelKind,TaskRevealKind:H.TaskRevealKind,TaskScope:H.TaskScope,TerminalLink:H.TerminalLink,TerminalLocation:H.TerminalLocation,TerminalProfile:H.TerminalProfile,TextDocumentSaveReason:H.TextDocumentSaveReason,TextEdit:H.TextEdit,TextEditorCursorStyle:I.TextEditorCursorStyle,TextEditorLineNumbersStyle:H.TextEditorLineNumbersStyle,TextEditorRevealType:H.TextEditorRevealType,TextEditorSelectionChangeKind:H.TextEditorSelectionChangeKind,TextDocumentChangeReason:H.TextDocumentChangeReason,ThemeColor:H.ThemeColor,ThemeIcon:H.ThemeIcon,TreeItem:H.TreeItem,TreeItemCollapsibleState:H.TreeItemCollapsibleState,TypeHierarchyItem:H.TypeHierarchyItem,UIKind:n.UIKind,Uri:k.URI,ViewColumn:H.ViewColumn,WorkspaceEdit:H.WorkspaceEdit,InlayHint:H.InlayHint,InlayHintKind:H.InlayHintKind,RemoteAuthorityResolverError:H.RemoteAuthorityResolverError,ResolvedAuthority:H.ResolvedAuthority,SourceControlInputBoxValidationType:H.SourceControlInputBoxValidationType,ExtensionRuntime:H.ExtensionRuntime,TimelineItem:H.TimelineItem,NotebookRange:H.NotebookRange,NotebookCellKind:H.NotebookCellKind,NotebookCellExecutionState:H.NotebookCellExecutionState,NotebookCellData:H.NotebookCellData,NotebookData:H.NotebookData,NotebookRendererScript:H.NotebookRendererScript,NotebookCellStatusBarAlignment:H.NotebookCellStatusBarAlignment,NotebookEditorRevealType:H.NotebookEditorRevealType,NotebookCellOutput:H.NotebookCellOutput,NotebookCellOutputItem:H.NotebookCellOutputItem,NotebookCellStatusBarItem:H.NotebookCellStatusBarItem,NotebookControllerAffinity:H.NotebookControllerAffinity,PortAttributes:H.PortAttributes,LinkedEditingRanges:H.LinkedEditingRanges,TestResultState:H.TestResultState,TestRunRequest:H.TestRunRequest,TestMessage:H.TestMessage,TestTag:H.TestTag,TestRunProfileKind:H.TestRunProfileKind,TextSearchCompleteMessageType:he.TextSearchCompleteMessageType,TreeDataTransfer:H.TreeDataTransfer,TreeDataTransferItem:H.TreeDataTransferItem,CoveredCount:H.CoveredCount,FileCoverage:H.FileCoverage,StatementCoverage:H.StatementCoverage,BranchCoverage:H.BranchCoverage,FunctionCoverage:H.FunctionCoverage,WorkspaceTrustState:H.WorkspaceTrustState,LanguageStatusSeverity:H.LanguageStatusSeverity,QuickPickItemKind:H.QuickPickItemKind}}}e.createApiFactoryAndRegisterActors=oe}),define(Ee[220],ye([0,1,56,94,31,93,32,38,48,39,97,98,99,71,64,69,95,49,30,68,85,70,192,12,175]),function(re,e,a,t,w,T,k,I,S,R,F,_,n,f,o,m,c,C,b,h,g,P,l,M,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,a.registerSingleton)(M.ILoggerService,l.ExtHostLoggerService),(0,a.registerSingleton)(M.ILogService,r.ExtHostLogService),(0,a.registerSingleton)(m.IExtHostApiDeprecationService,m.ExtHostApiDeprecationService),(0,a.registerSingleton)(I.IExtHostCommands,I.ExtHostCommands),(0,a.registerSingleton)(k.IExtHostConfiguration,k.ExtHostConfiguration),(0,a.registerSingleton)(C.IExtHostConsumerFileSystem,C.ExtHostConsumerFileSystem),(0,a.registerSingleton)(_.IExtHostDebugService,_.WorkerExtHostDebugService),(0,a.registerSingleton)(T.IExtHostDecorations,T.ExtHostDecorations),(0,a.registerSingleton)(S.IExtHostDocumentsAndEditors,S.ExtHostDocumentsAndEditors),(0,a.registerSingleton)(b.IExtHostFileSystemInfo,b.ExtHostFileSystemInfo),(0,a.registerSingleton)(t.IExtHostOutputService,t.ExtHostOutputService),(0,a.registerSingleton)(n.IExtHostSearch,n.ExtHostSearch),(0,a.registerSingleton)(f.IExtHostStorage,f.ExtHostStorage),(0,a.registerSingleton)(F.IExtHostTask,F.WorkerExtHostTask),(0,a.registerSingleton)(R.IExtHostTerminalService,R.WorkerExtHostTerminalService),(0,a.registerSingleton)(o.IExtHostTunnelService,o.ExtHostTunnelService),(0,a.registerSingleton)(c.IExtHostWindow,c.ExtHostWindow),(0,a.registerSingleton)(w.IExtHostWorkspace,w.ExtHostWorkspace),(0,a.registerSingleton)(h.IExtHostSecretState,h.ExtHostSecretState),(0,a.registerSingleton)(g.IExtHostTelemetry,g.ExtHostTelemetry),(0,a.registerSingleton)(P.IExtHostEditorTabs,P.ExtHostEditorTabs)}),define(Ee[221],ye([0,1,219,33,215,7,14,5,10]),function(re,e,a,t,w,T,k,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class R extends w.RequireInterceptor{_installInterceptor(){}getModule(o,m){for(let c of this._alternatives){let C=c(o);if(C){o=C;break}}if(this._factories.has(o))return this._factories.get(o).load(o,m,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class F extends t.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=T.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const o=this._extHostContext.getProxy(I.MainContext.MainThreadConsole);n(o,this._initData.environment.isExtensionDevelopmentDebug);const m=this._instaService.invokeFunction(a.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(R,m,this._registry),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(o){return o.browser}async _loadCommonJSModule(o,m,c){m=m.with({path:_(m.path,".js")}),o&&performance.mark(`code/extHost/willFetchExtensionCode/${o.value}`);const C=await fetch(S.FileAccess.asBrowserUri(m).toString(!0));if(o&&performance.mark(`code/extHost/didFetchExtensionCode/${o.value}`),C.status!==200)throw new Error(C.statusText);const b=await C.text(),h=`${m.toString(!0)}#vscode-extension`,g=`${b}
//# sourceURL=${h}`;let P;try{P=new Function("module","exports","require",g)}catch(i){throw console.error(o?`Loading code for extension ${o.value} failed: ${i.message}`:`Loading code failed: ${i.message}`),console.error(`${m.toString(!0)}${typeof i.line=="number"?` line ${i.line}`:""}${typeof i.column=="number"?` column ${i.column}`:""}`),console.error(i),i}const l={},M={exports:l},r=i=>{const p=this._fakeModules.getModule(i,m);if(p===void 0)throw new Error(`Cannot load module '${i}'`);return p};try{return c.codeLoadingStart(),o&&performance.mark(`code/extHost/willLoadExtensionCode/${o.value}`),P(M,l,r),M.exports!==l?M.exports:l}finally{o&&performance.mark(`code/extHost/didLoadExtensionCode/${o.value}`),c.codeLoadingStop()}}async $setRemoteEnvironment(o){}async _waitForDebuggerAttachment(o=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const m=Date.now()+o;for(;Date.now()<m&&!("__jsDebugIsReady"in globalThis);)await(0,k.timeout)(10)}}e.ExtHostExtensionService=F;function _(f,o){return f.endsWith(o)?f:f+o}function n(f,o){m("info","log"),m("log","log"),m("warn","warn"),m("error","error");function m(b,h){const g=console[b];console[b]=function(){f.$logExtensionHostMessage({type:"__$console",severity:h,arguments:C(arguments)}),o&&g.apply(console,arguments)}}const c=1e5;function C(b){const h=[],g=[];if(b.length)for(let P=0;P<b.length;P++){if(typeof b[P]=="undefined")b[P]="undefined";else if(b[P]instanceof Error){const l=b[P];l.stack?b[P]=l.stack:b[P]=l.toString()}g.push(b[P])}try{const P=JSON.stringify(g,function(l,M){if(M&&typeof M=="object"){if(h.indexOf(M)!==-1)return"[Circular]";h.push(M)}return M});return P.length>c?"Output omitted for a large object that exceeds the limits":P}catch(P){return`Output omitted for an object that cannot be inspected ('${P.toString()}')`}}}}),define(Ee[222],ye([0,1,56,33,72,221]),function(re,e,a,t,w,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,a.registerSingleton)(t.IExtHostExtensionService,T.ExtHostExtensionService),(0,a.registerSingleton)(w.IExtensionStoragePaths,w.ExtensionStoragePaths)}),define(Ee[233],ye([0,1,22,4,173,216,210,17,73,10,2,220,222]),function(re,e,a,t,w,T,k,I,S,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const _=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const n=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");const f=fetch.bind(self);if(self.fetch=function(h,g){return h instanceof Request||/^file:/i.test(String(h))&&(h=R.FileAccess.asBrowserUri(F.URI.parse(String(h))).toString(!0)),f(h,g)},self.XMLHttpRequest=class extends XMLHttpRequest{open(h,g,P,l,M){return/^file:/i.test(g.toString())&&(g=R.FileAccess.asBrowserUri(F.URI.parse(g.toString())).toString(!0)),super.open(h,g,P??!0,l,M)}},self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const h=self.Worker;Worker=function(g,P){/^file:/i.test(g.toString())&&(g=R.FileAccess.asBrowserUri(F.URI.parse(g.toString())).toString(!0));const M=`(${function(d){function s(u){return typeof u=="string"||u instanceof URL?String(u).replace(/^file:\/\//i,"vscode-file://vscode-app"):u}const v=fetch.bind(self);self.fetch=function(u,D){return u instanceof Request?v(u,D):v(s(u),D)},self.XMLHttpRequest=class extends XMLHttpRequest{open(u,D,A,U,B){return super.open(u,s(D),A??!0,U,B)}};const y=importScripts.bind(self);self.importScripts=(...u)=>{y(...u.map(s))},y(d)}.toString()}('${g}'))`;P=P||{},P.name=P.name||I.basename(g.toString());const r=new Blob([M],{type:"application/javascript"}),i=URL.createObjectURL(r);return new h(i,P)}}else self.Worker=class extends k.NestedWorker{constructor(h,g){super(n,h,{name:I.basename(h.toString()),...g})}};const o=new class{constructor(){this.pid=void 0}exit(h){_()}async exists(h){return!0}async realpath(h){return h}};class m{constructor(){const g=new MessageChannel,P=new t.Emitter;let l=!1;n(g.port2,[g.port2]),g.port1.onmessage=M=>{const{data:r}=M;if(!(r instanceof ArrayBuffer)){console.warn("UNKNOWN data received",r);return}const i=a.VSBuffer.wrap(new Uint8Array(r,0,r.byteLength));if((0,w.isMessageOfType)(i,2)){l=!0,C("received terminate message from renderer");return}P.fire(i)},this.protocol={onMessage:P.event,send:M=>{if(!l){const r=M.buffer.buffer.slice(M.buffer.byteOffset,M.buffer.byteOffset+M.buffer.byteLength);g.port1.postMessage(r,[r])}}}}}function c(h){return new Promise(g=>{const P=h.onMessage(l=>{P.dispose();const M=JSON.parse(l.toString());h.send((0,w.createMessageOfType)(0)),g({protocol:h,initData:M})});h.send((0,w.createMessageOfType)(1))})}let C=h=>_();function b(){const h=new m;S.mark("code/extHost/willConnectToRenderer"),c(h.protocol).then(g=>{S.mark("code/extHost/didWaitForInitData");const P=new T.ExtensionHostMain(g.protocol,g.initData,o,null);C=l=>P.terminate(l)})}e.create=b})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/745ef8b8264e12b2a704f6b2b60a2ce2cabfcda3/core/vs/workbench/services/extensions/worker/extensionHostWorker.js.map
